#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 7480
#define LARGE_STATE_COUNT 1852
#define SYMBOL_COUNT 400
#define ALIAS_COUNT 7
#define TOKEN_COUNT 173
#define EXTERNAL_TOKEN_COUNT 9
#define FIELD_COUNT 44
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 343

enum ts_symbol_identifiers {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_type = 6,
  anon_sym_EQ = 7,
  anon_sym_as = 8,
  anon_sym_namespace = 9,
  anon_sym_LBRACE = 10,
  anon_sym_COMMA = 11,
  anon_sym_RBRACE = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_with = 16,
  anon_sym_var = 17,
  anon_sym_let = 18,
  anon_sym_const = 19,
  anon_sym_BANG = 20,
  anon_sym_else = 21,
  anon_sym_if = 22,
  anon_sym_switch = 23,
  anon_sym_for = 24,
  anon_sym_LPAREN = 25,
  anon_sym_RPAREN = 26,
  anon_sym_await = 27,
  anon_sym_in = 28,
  anon_sym_of = 29,
  anon_sym_while = 30,
  anon_sym_do = 31,
  anon_sym_try = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  sym__glimmer_template_content = 46,
  anon_sym_LTtemplate_GT = 47,
  anon_sym_LT_SLASHtemplate_GT = 48,
  aux_sym_jsx_text_token1 = 49,
  aux_sym_jsx_text_token2 = 50,
  sym_html_character_reference = 51,
  anon_sym_GT = 52,
  sym_jsx_identifier = 53,
  anon_sym_DOT = 54,
  anon_sym_LT_SLASH = 55,
  anon_sym_SLASH_GT = 56,
  anon_sym_DQUOTE = 57,
  anon_sym_SQUOTE = 58,
  sym_unescaped_double_jsx_string_fragment = 59,
  sym_unescaped_single_jsx_string_fragment = 60,
  anon_sym_class = 61,
  anon_sym_async = 62,
  anon_sym_function = 63,
  anon_sym_EQ_GT = 64,
  anon_sym_QMARK_DOT = 65,
  anon_sym_new = 66,
  anon_sym_using = 67,
  anon_sym_PLUS_EQ = 68,
  anon_sym_DASH_EQ = 69,
  anon_sym_STAR_EQ = 70,
  anon_sym_SLASH_EQ = 71,
  anon_sym_PERCENT_EQ = 72,
  anon_sym_CARET_EQ = 73,
  anon_sym_AMP_EQ = 74,
  anon_sym_PIPE_EQ = 75,
  anon_sym_GT_GT_EQ = 76,
  anon_sym_GT_GT_GT_EQ = 77,
  anon_sym_LT_LT_EQ = 78,
  anon_sym_STAR_STAR_EQ = 79,
  anon_sym_AMP_AMP_EQ = 80,
  anon_sym_PIPE_PIPE_EQ = 81,
  anon_sym_QMARK_QMARK_EQ = 82,
  anon_sym_DOT_DOT_DOT = 83,
  anon_sym_AMP_AMP = 84,
  anon_sym_PIPE_PIPE = 85,
  anon_sym_GT_GT = 86,
  anon_sym_GT_GT_GT = 87,
  anon_sym_LT_LT = 88,
  anon_sym_AMP = 89,
  anon_sym_CARET = 90,
  anon_sym_PIPE = 91,
  anon_sym_PLUS = 92,
  anon_sym_DASH = 93,
  anon_sym_SLASH = 94,
  anon_sym_PERCENT = 95,
  anon_sym_STAR_STAR = 96,
  anon_sym_LT = 97,
  anon_sym_LT_EQ = 98,
  anon_sym_EQ_EQ = 99,
  anon_sym_EQ_EQ_EQ = 100,
  anon_sym_BANG_EQ = 101,
  anon_sym_BANG_EQ_EQ = 102,
  anon_sym_GT_EQ = 103,
  anon_sym_QMARK_QMARK = 104,
  anon_sym_instanceof = 105,
  anon_sym_TILDE = 106,
  anon_sym_void = 107,
  anon_sym_delete = 108,
  anon_sym_PLUS_PLUS = 109,
  anon_sym_DASH_DASH = 110,
  sym_unescaped_double_string_fragment = 111,
  sym_unescaped_single_string_fragment = 112,
  sym_escape_sequence = 113,
  aux_sym_comment_token1 = 114,
  anon_sym_BQUOTE = 115,
  anon_sym_DOLLAR_LBRACE = 116,
  anon_sym_SLASH2 = 117,
  sym_regex_pattern = 118,
  sym_regex_flags = 119,
  sym_number = 120,
  sym_private_property_identifier = 121,
  anon_sym_target = 122,
  sym_this = 123,
  sym_super = 124,
  sym_true = 125,
  sym_false = 126,
  sym_null = 127,
  sym_undefined = 128,
  anon_sym_AT = 129,
  anon_sym_static = 130,
  anon_sym_readonly = 131,
  anon_sym_get = 132,
  anon_sym_set = 133,
  anon_sym_QMARK = 134,
  anon_sym_declare = 135,
  anon_sym_public = 136,
  anon_sym_private = 137,
  anon_sym_protected = 138,
  anon_sym_override = 139,
  anon_sym_module = 140,
  anon_sym_any = 141,
  anon_sym_number = 142,
  anon_sym_boolean = 143,
  anon_sym_string = 144,
  anon_sym_symbol = 145,
  anon_sym_object = 146,
  anon_sym_abstract = 147,
  anon_sym_satisfies = 148,
  anon_sym_require = 149,
  anon_sym_extends = 150,
  anon_sym_implements = 151,
  anon_sym_global = 152,
  anon_sym_interface = 153,
  anon_sym_enum = 154,
  anon_sym_DASH_QMARK_COLON = 155,
  anon_sym_PLUS_QMARK_COLON = 156,
  anon_sym_QMARK_COLON = 157,
  anon_sym_asserts = 158,
  anon_sym_infer = 159,
  anon_sym_is = 160,
  anon_sym_keyof = 161,
  anon_sym_unique = 162,
  anon_sym_unknown = 163,
  anon_sym_never = 164,
  anon_sym_LBRACE_PIPE = 165,
  anon_sym_PIPE_RBRACE = 166,
  sym__automatic_semicolon = 167,
  sym__template_chars = 168,
  sym__ternary_qmark = 169,
  sym_html_comment = 170,
  sym__function_signature_automatic_semicolon = 171,
  sym___error_recovery = 172,
  sym_program = 173,
  sym_export_statement = 174,
  sym_namespace_export = 175,
  sym_export_clause = 176,
  sym_export_specifier = 177,
  sym__module_export_name = 178,
  sym_declaration = 179,
  sym_import = 180,
  sym_import_statement = 181,
  sym_import_clause = 182,
  sym__from_clause = 183,
  sym_namespace_import = 184,
  sym_named_imports = 185,
  sym_import_specifier = 186,
  sym_import_attribute = 187,
  sym_statement = 188,
  sym_expression_statement = 189,
  sym_variable_declaration = 190,
  sym_lexical_declaration = 191,
  sym_variable_declarator = 192,
  sym_statement_block = 193,
  sym_else_clause = 194,
  sym_if_statement = 195,
  sym_switch_statement = 196,
  sym_for_statement = 197,
  sym_for_in_statement = 198,
  sym__for_header = 199,
  sym_while_statement = 200,
  sym_do_statement = 201,
  sym_try_statement = 202,
  sym_with_statement = 203,
  sym_break_statement = 204,
  sym_continue_statement = 205,
  sym_debugger_statement = 206,
  sym_return_statement = 207,
  sym_throw_statement = 208,
  sym_empty_statement = 209,
  sym_labeled_statement = 210,
  sym_switch_body = 211,
  sym_switch_case = 212,
  sym_switch_default = 213,
  sym_catch_clause = 214,
  sym_finally_clause = 215,
  sym_parenthesized_expression = 216,
  sym_expression = 217,
  sym_primary_expression = 218,
  sym_yield_expression = 219,
  sym_object = 220,
  sym_object_pattern = 221,
  sym_assignment_pattern = 222,
  sym_object_assignment_pattern = 223,
  sym_array = 224,
  sym_array_pattern = 225,
  sym_glimmer_template = 226,
  sym_glimmer_opening_tag = 227,
  sym_glimmer_closing_tag = 228,
  sym_jsx_element = 229,
  sym_jsx_text = 230,
  sym_jsx_expression = 231,
  sym_jsx_opening_element = 232,
  sym_nested_identifier = 233,
  sym_jsx_namespace_name = 234,
  sym_jsx_closing_element = 235,
  sym_jsx_self_closing_element = 236,
  sym_jsx_attribute = 237,
  sym__jsx_string = 238,
  sym_class = 239,
  sym_class_declaration = 240,
  sym_class_heritage = 241,
  sym_function_expression = 242,
  sym_function_declaration = 243,
  sym_generator_function = 244,
  sym_generator_function_declaration = 245,
  sym_arrow_function = 246,
  sym__call_signature = 247,
  sym__formal_parameter = 248,
  sym_optional_chain = 249,
  sym_call_expression = 250,
  sym_new_expression = 251,
  sym_await_expression = 252,
  sym_member_expression = 253,
  sym_subscript_expression = 254,
  sym_assignment_expression = 255,
  sym__augmented_assignment_lhs = 256,
  sym_augmented_assignment_expression = 257,
  sym__initializer = 258,
  sym__destructuring_pattern = 259,
  sym_spread_element = 260,
  sym_ternary_expression = 261,
  sym_binary_expression = 262,
  sym_unary_expression = 263,
  sym_update_expression = 264,
  sym_sequence_expression = 265,
  sym_string = 266,
  sym_comment = 267,
  sym_template_string = 268,
  sym_template_substitution = 269,
  sym_regex = 270,
  sym_meta_property = 271,
  sym_arguments = 272,
  sym_decorator = 273,
  sym_decorator_member_expression = 274,
  sym_decorator_call_expression = 275,
  sym_class_body = 276,
  sym_formal_parameters = 277,
  sym_class_static_block = 278,
  sym_pattern = 279,
  sym_rest_pattern = 280,
  sym_method_definition = 281,
  sym_pair = 282,
  sym_pair_pattern = 283,
  sym__property_name = 284,
  sym_computed_property_name = 285,
  sym_public_field_definition = 286,
  sym__import_identifier = 287,
  sym_non_null_expression = 288,
  sym_method_signature = 289,
  sym_abstract_method_signature = 290,
  sym_function_signature = 291,
  sym_as_expression = 292,
  sym_satisfies_expression = 293,
  sym_instantiation_expression = 294,
  sym_import_require_clause = 295,
  sym_extends_clause = 296,
  sym__extends_clause_single = 297,
  sym_implements_clause = 298,
  sym_ambient_declaration = 299,
  sym_abstract_class_declaration = 300,
  sym_module = 301,
  sym_internal_module = 302,
  sym__module = 303,
  sym_import_alias = 304,
  sym_nested_type_identifier = 305,
  sym_interface_declaration = 306,
  sym_extends_type_clause = 307,
  sym_enum_declaration = 308,
  sym_enum_body = 309,
  sym_enum_assignment = 310,
  sym_type_alias_declaration = 311,
  sym_accessibility_modifier = 312,
  sym_override_modifier = 313,
  sym_required_parameter = 314,
  sym_optional_parameter = 315,
  sym__parameter_name = 316,
  sym_omitting_type_annotation = 317,
  sym_adding_type_annotation = 318,
  sym_opting_type_annotation = 319,
  sym_type_annotation = 320,
  sym__type_query_member_expression_in_type_annotation = 321,
  sym__type_query_call_expression_in_type_annotation = 322,
  sym_asserts = 323,
  sym_asserts_annotation = 324,
  sym__type = 325,
  sym_tuple_parameter = 326,
  sym_optional_tuple_parameter = 327,
  sym_optional_type = 328,
  sym_rest_type = 329,
  sym__tuple_type_member = 330,
  sym_constructor_type = 331,
  sym__primary_type = 332,
  sym_template_type = 333,
  sym_template_literal_type = 334,
  sym_infer_type = 335,
  sym_conditional_type = 336,
  sym_generic_type = 337,
  sym_type_predicate = 338,
  sym_type_predicate_annotation = 339,
  sym__type_query_member_expression = 340,
  sym__type_query_subscript_expression = 341,
  sym__type_query_call_expression = 342,
  sym__type_query_instantiation_expression = 343,
  sym_type_query = 344,
  sym_index_type_query = 345,
  sym_lookup_type = 346,
  sym_mapped_type_clause = 347,
  sym_literal_type = 348,
  sym__number = 349,
  sym_existential_type = 350,
  sym_flow_maybe_type = 351,
  sym_parenthesized_type = 352,
  sym_predefined_type = 353,
  sym_type_arguments = 354,
  sym_object_type = 355,
  sym_call_signature = 356,
  sym_property_signature = 357,
  sym_type_parameters = 358,
  sym_type_parameter = 359,
  sym_default_type = 360,
  sym_constraint = 361,
  sym_construct_signature = 362,
  sym_index_signature = 363,
  sym_array_type = 364,
  sym_tuple_type = 365,
  sym_readonly_type = 366,
  sym_union_type = 367,
  sym_intersection_type = 368,
  sym_function_type = 369,
  aux_sym_program_repeat1 = 370,
  aux_sym_export_statement_repeat1 = 371,
  aux_sym_export_clause_repeat1 = 372,
  aux_sym_named_imports_repeat1 = 373,
  aux_sym_variable_declaration_repeat1 = 374,
  aux_sym_switch_body_repeat1 = 375,
  aux_sym_object_repeat1 = 376,
  aux_sym_object_pattern_repeat1 = 377,
  aux_sym_array_repeat1 = 378,
  aux_sym_array_pattern_repeat1 = 379,
  aux_sym_glimmer_template_repeat1 = 380,
  aux_sym_jsx_element_repeat1 = 381,
  aux_sym__jsx_string_repeat1 = 382,
  aux_sym__jsx_string_repeat2 = 383,
  aux_sym_sequence_expression_repeat1 = 384,
  aux_sym_string_repeat1 = 385,
  aux_sym_string_repeat2 = 386,
  aux_sym_template_string_repeat1 = 387,
  aux_sym_class_body_repeat1 = 388,
  aux_sym_formal_parameters_repeat1 = 389,
  aux_sym__jsx_start_opening_element_repeat1 = 390,
  aux_sym_extends_clause_repeat1 = 391,
  aux_sym_implements_clause_repeat1 = 392,
  aux_sym_extends_type_clause_repeat1 = 393,
  aux_sym_enum_body_repeat1 = 394,
  aux_sym_template_literal_type_repeat1 = 395,
  aux_sym_type_arguments_repeat1 = 396,
  aux_sym_object_type_repeat1 = 397,
  aux_sym_type_parameters_repeat1 = 398,
  aux_sym_tuple_type_repeat1 = 399,
  alias_sym_interface_body = 400,
  alias_sym_property_identifier = 401,
  alias_sym_shorthand_property_identifier = 402,
  alias_sym_shorthand_property_identifier_pattern = 403,
  alias_sym_statement_identifier = 404,
  alias_sym_this_type = 405,
  alias_sym_type_identifier = 406,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_with] = "with",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym__glimmer_template_content] = "_glimmer_template_content",
  [anon_sym_LTtemplate_GT] = "<template>",
  [anon_sym_LT_SLASHtemplate_GT] = "</template>",
  [aux_sym_jsx_text_token1] = "jsx_text_token1",
  [aux_sym_jsx_text_token2] = "jsx_text_token2",
  [sym_html_character_reference] = "html_character_reference",
  [anon_sym_GT] = ">",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_LT_SLASH] = "</",
  [anon_sym_SLASH_GT] = "/>",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym_unescaped_double_jsx_string_fragment] = "string_fragment",
  [sym_unescaped_single_jsx_string_fragment] = "string_fragment",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_using] = "using",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_escape_sequence] = "escape_sequence",
  [aux_sym_comment_token1] = "comment_token1",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_private_property_identifier] = "private_property_identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_override] = "override",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_object] = "object",
  [anon_sym_abstract] = "abstract",
  [anon_sym_satisfies] = "satisfies",
  [anon_sym_require] = "require",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_PLUS_QMARK_COLON] = "+\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_unique] = "unique symbol",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "string_fragment",
  [sym__ternary_qmark] = "\?",
  [sym_html_comment] = "html_comment",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym___error_recovery] = "__error_recovery",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_namespace_export] = "namespace_export",
  [sym_export_clause] = "export_clause",
  [sym_export_specifier] = "export_specifier",
  [sym__module_export_name] = "_module_export_name",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_import_specifier] = "import_specifier",
  [sym_import_attribute] = "import_attribute",
  [sym_statement] = "statement",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_glimmer_template] = "glimmer_template",
  [sym_glimmer_opening_tag] = "glimmer_opening_tag",
  [sym_glimmer_closing_tag] = "glimmer_closing_tag",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym__jsx_string] = "string",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function_expression] = "function_expression",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_optional_chain] = "optional_chain",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_comment] = "comment",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_formal_parameters] = "formal_parameters",
  [sym_class_static_block] = "class_static_block",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_public_field_definition] = "public_field_definition",
  [sym__import_identifier] = "_import_identifier",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_as_expression] = "as_expression",
  [sym_satisfies_expression] = "satisfies_expression",
  [sym_instantiation_expression] = "instantiation_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_extends_clause] = "extends_clause",
  [sym__extends_clause_single] = "_extends_clause_single",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_type_clause] = "extends_type_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_override_modifier] = "override_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_adding_type_annotation] = "adding_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym__type_query_member_expression_in_type_annotation] = "member_expression",
  [sym__type_query_call_expression_in_type_annotation] = "call_expression",
  [sym_asserts] = "asserts",
  [sym_asserts_annotation] = "asserts_annotation",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_template_type] = "template_type",
  [sym_template_literal_type] = "template_literal_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym__type_query_member_expression] = "member_expression",
  [sym__type_query_subscript_expression] = "subscript_expression",
  [sym__type_query_call_expression] = "call_expression",
  [sym__type_query_instantiation_expression] = "instantiation_expression",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_glimmer_template_repeat1] = "glimmer_template_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym__jsx_string_repeat1] = "_jsx_string_repeat1",
  [aux_sym__jsx_string_repeat2] = "_jsx_string_repeat2",
  [aux_sym_sequence_expression_repeat1] = "sequence_expression_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym__jsx_start_opening_element_repeat1] = "_jsx_start_opening_element_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_type_clause_repeat1] = "extends_type_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_template_literal_type_repeat1] = "template_literal_type_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [alias_sym_interface_body] = "interface_body",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_this_type] = "this_type",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym__glimmer_template_content] = sym__glimmer_template_content,
  [anon_sym_LTtemplate_GT] = anon_sym_LTtemplate_GT,
  [anon_sym_LT_SLASHtemplate_GT] = anon_sym_LT_SLASHtemplate_GT,
  [aux_sym_jsx_text_token1] = aux_sym_jsx_text_token1,
  [aux_sym_jsx_text_token2] = aux_sym_jsx_text_token2,
  [sym_html_character_reference] = sym_html_character_reference,
  [anon_sym_GT] = anon_sym_GT,
  [sym_jsx_identifier] = sym_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LT_SLASH] = anon_sym_LT_SLASH,
  [anon_sym_SLASH_GT] = anon_sym_SLASH_GT,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_unescaped_double_jsx_string_fragment] = sym__template_chars,
  [sym_unescaped_single_jsx_string_fragment] = sym__template_chars,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [sym_unescaped_double_string_fragment] = sym__template_chars,
  [sym_unescaped_single_string_fragment] = sym__template_chars,
  [sym_escape_sequence] = sym_escape_sequence,
  [aux_sym_comment_token1] = aux_sym_comment_token1,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [sym_private_property_identifier] = sym_private_property_identifier,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_satisfies] = anon_sym_satisfies,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_PLUS_QMARK_COLON] = anon_sym_PLUS_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_unique] = anon_sym_unique,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__ternary_qmark] = anon_sym_QMARK,
  [sym_html_comment] = sym_html_comment,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym___error_recovery] = sym___error_recovery,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_namespace_export] = sym_namespace_export,
  [sym_export_clause] = sym_export_clause,
  [sym_export_specifier] = sym_export_specifier,
  [sym__module_export_name] = sym__module_export_name,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_import_specifier] = sym_import_specifier,
  [sym_import_attribute] = sym_import_attribute,
  [sym_statement] = sym_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_glimmer_template] = sym_glimmer_template,
  [sym_glimmer_opening_tag] = sym_glimmer_opening_tag,
  [sym_glimmer_closing_tag] = sym_glimmer_closing_tag,
  [sym_jsx_element] = sym_jsx_element,
  [sym_jsx_text] = sym_jsx_text,
  [sym_jsx_expression] = sym_jsx_expression,
  [sym_jsx_opening_element] = sym_jsx_opening_element,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_jsx_namespace_name] = sym_jsx_namespace_name,
  [sym_jsx_closing_element] = sym_jsx_closing_element,
  [sym_jsx_self_closing_element] = sym_jsx_self_closing_element,
  [sym_jsx_attribute] = sym_jsx_attribute,
  [sym__jsx_string] = sym_string,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function_expression] = sym_function_expression,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_optional_chain] = sym_optional_chain,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_comment] = sym_comment,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_class_static_block] = sym_class_static_block,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym__import_identifier] = sym__import_identifier,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_as_expression] = sym_as_expression,
  [sym_satisfies_expression] = sym_satisfies_expression,
  [sym_instantiation_expression] = sym_instantiation_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_extends_clause] = sym_extends_clause,
  [sym__extends_clause_single] = sym__extends_clause_single,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_type_clause] = sym_extends_type_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_override_modifier] = sym_override_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_adding_type_annotation] = sym_adding_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym__type_query_member_expression_in_type_annotation] = sym_member_expression,
  [sym__type_query_call_expression_in_type_annotation] = sym_call_expression,
  [sym_asserts] = sym_asserts,
  [sym_asserts_annotation] = sym_asserts_annotation,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_template_type] = sym_template_type,
  [sym_template_literal_type] = sym_template_literal_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym__type_query_member_expression] = sym_member_expression,
  [sym__type_query_subscript_expression] = sym_subscript_expression,
  [sym__type_query_call_expression] = sym_call_expression,
  [sym__type_query_instantiation_expression] = sym_instantiation_expression,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_glimmer_template_repeat1] = aux_sym_glimmer_template_repeat1,
  [aux_sym_jsx_element_repeat1] = aux_sym_jsx_element_repeat1,
  [aux_sym__jsx_string_repeat1] = aux_sym__jsx_string_repeat1,
  [aux_sym__jsx_string_repeat2] = aux_sym__jsx_string_repeat2,
  [aux_sym_sequence_expression_repeat1] = aux_sym_sequence_expression_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym__jsx_start_opening_element_repeat1] = aux_sym__jsx_start_opening_element_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_type_clause_repeat1] = aux_sym_extends_type_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_template_literal_type_repeat1] = aux_sym_template_literal_type_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [alias_sym_interface_body] = alias_sym_interface_body,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_this_type] = alias_sym_this_type,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym__glimmer_template_content] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LTtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASHtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_jsx_text_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_text_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_html_character_reference] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_jsx_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_jsx_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_private_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_satisfies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unique] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = true,
    .named = true,
  },
  [sym__ternary_qmark] = {
    .visible = true,
    .named = false,
  },
  [sym_html_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym___error_recovery] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_export] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__module_export_name] = {
    .visible = false,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_import_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_template] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_opening_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__jsx_string] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_chain] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_class_static_block] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__import_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_satisfies_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_instantiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__extends_clause_single] = {
    .visible = false,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_override_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_adding_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression_in_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression_in_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_instantiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_glimmer_template_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__jsx_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__jsx_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__jsx_start_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_type_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_interface_body] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_close_tag = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constraint = 10,
  field_constructor = 11,
  field_content = 12,
  field_declaration = 13,
  field_decorator = 14,
  field_finalizer = 15,
  field_flags = 16,
  field_function = 17,
  field_handler = 18,
  field_increment = 19,
  field_index = 20,
  field_index_type = 21,
  field_initializer = 22,
  field_key = 23,
  field_kind = 24,
  field_label = 25,
  field_left = 26,
  field_module = 27,
  field_name = 28,
  field_object = 29,
  field_open_tag = 30,
  field_operator = 31,
  field_optional_chain = 32,
  field_parameter = 33,
  field_parameters = 34,
  field_pattern = 35,
  field_property = 36,
  field_return_type = 37,
  field_right = 38,
  field_sign = 39,
  field_source = 40,
  field_type = 41,
  field_type_arguments = 42,
  field_type_parameters = 43,
  field_value = 44,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_content] = "content",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_index_type] = "index_type",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_optional_chain] = "optional_chain",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 1},
  [12] = {.index = 12, .length = 1},
  [13] = {.index = 3, .length = 1},
  [14] = {.index = 13, .length = 2},
  [15] = {.index = 15, .length = 2},
  [16] = {.index = 17, .length = 1},
  [17] = {.index = 18, .length = 2},
  [18] = {.index = 20, .length = 2},
  [19] = {.index = 22, .length = 2},
  [20] = {.index = 24, .length = 2},
  [21] = {.index = 26, .length = 1},
  [22] = {.index = 27, .length = 2},
  [23] = {.index = 29, .length = 2},
  [24] = {.index = 31, .length = 2},
  [25] = {.index = 33, .length = 2},
  [29] = {.index = 35, .length = 1},
  [30] = {.index = 36, .length = 2},
  [31] = {.index = 38, .length = 2},
  [32] = {.index = 40, .length = 2},
  [33] = {.index = 42, .length = 1},
  [34] = {.index = 43, .length = 2},
  [35] = {.index = 45, .length = 2},
  [36] = {.index = 47, .length = 6},
  [37] = {.index = 53, .length = 1},
  [38] = {.index = 54, .length = 3},
  [39] = {.index = 57, .length = 3},
  [40] = {.index = 60, .length = 2},
  [41] = {.index = 62, .length = 2},
  [42] = {.index = 64, .length = 2},
  [43] = {.index = 66, .length = 2},
  [44] = {.index = 68, .length = 1},
  [45] = {.index = 69, .length = 2},
  [46] = {.index = 71, .length = 1},
  [47] = {.index = 72, .length = 2},
  [50] = {.index = 74, .length = 2},
  [51] = {.index = 76, .length = 1},
  [52] = {.index = 77, .length = 2},
  [53] = {.index = 79, .length = 4},
  [54] = {.index = 83, .length = 2},
  [55] = {.index = 85, .length = 2},
  [56] = {.index = 87, .length = 1},
  [57] = {.index = 87, .length = 1},
  [58] = {.index = 88, .length = 1},
  [59] = {.index = 89, .length = 2},
  [60] = {.index = 91, .length = 2},
  [61] = {.index = 87, .length = 1},
  [62] = {.index = 27, .length = 2},
  [63] = {.index = 31, .length = 2},
  [64] = {.index = 93, .length = 3},
  [65] = {.index = 69, .length = 2},
  [66] = {.index = 69, .length = 2},
  [67] = {.index = 96, .length = 2},
  [68] = {.index = 96, .length = 2},
  [69] = {.index = 98, .length = 3},
  [70] = {.index = 98, .length = 3},
  [71] = {.index = 101, .length = 3},
  [72] = {.index = 104, .length = 2},
  [73] = {.index = 106, .length = 3},
  [74] = {.index = 109, .length = 2},
  [75] = {.index = 111, .length = 4},
  [76] = {.index = 115, .length = 2},
  [77] = {.index = 117, .length = 2},
  [78] = {.index = 119, .length = 3},
  [79] = {.index = 122, .length = 2},
  [80] = {.index = 124, .length = 2},
  [81] = {.index = 126, .length = 1},
  [82] = {.index = 127, .length = 1},
  [83] = {.index = 96, .length = 2},
  [84] = {.index = 27, .length = 2},
  [85] = {.index = 128, .length = 2},
  [86] = {.index = 130, .length = 5},
  [87] = {.index = 135, .length = 1},
  [88] = {.index = 136, .length = 1},
  [89] = {.index = 137, .length = 2},
  [90] = {.index = 139, .length = 3},
  [91] = {.index = 142, .length = 2},
  [92] = {.index = 144, .length = 3},
  [93] = {.index = 147, .length = 6},
  [94] = {.index = 153, .length = 1},
  [95] = {.index = 154, .length = 1},
  [96] = {.index = 155, .length = 3},
  [97] = {.index = 158, .length = 3},
  [98] = {.index = 161, .length = 4},
  [99] = {.index = 165, .length = 2},
  [100] = {.index = 167, .length = 2},
  [101] = {.index = 169, .length = 3},
  [102] = {.index = 172, .length = 4},
  [103] = {.index = 176, .length = 1},
  [104] = {.index = 177, .length = 2},
  [105] = {.index = 179, .length = 1},
  [106] = {.index = 180, .length = 2},
  [107] = {.index = 182, .length = 3},
  [108] = {.index = 185, .length = 2},
  [109] = {.index = 187, .length = 4},
  [110] = {.index = 191, .length = 3},
  [111] = {.index = 194, .length = 2},
  [112] = {.index = 196, .length = 2},
  [113] = {.index = 198, .length = 2},
  [116] = {.index = 198, .length = 2},
  [117] = {.index = 200, .length = 2},
  [118] = {.index = 202, .length = 2},
  [119] = {.index = 204, .length = 4},
  [120] = {.index = 202, .length = 2},
  [121] = {.index = 208, .length = 4},
  [122] = {.index = 212, .length = 4},
  [123] = {.index = 216, .length = 5},
  [124] = {.index = 221, .length = 3},
  [125] = {.index = 224, .length = 2},
  [126] = {.index = 224, .length = 2},
  [127] = {.index = 226, .length = 2},
  [128] = {.index = 228, .length = 2},
  [129] = {.index = 230, .length = 2},
  [130] = {.index = 232, .length = 2},
  [131] = {.index = 234, .length = 2},
  [132] = {.index = 236, .length = 2},
  [133] = {.index = 238, .length = 3},
  [134] = {.index = 236, .length = 2},
  [135] = {.index = 232, .length = 2},
  [136] = {.index = 142, .length = 2},
  [137] = {.index = 241, .length = 1},
  [138] = {.index = 241, .length = 1},
  [139] = {.index = 180, .length = 2},
  [140] = {.index = 182, .length = 3},
  [141] = {.index = 242, .length = 4},
  [142] = {.index = 246, .length = 2},
  [143] = {.index = 248, .length = 3},
  [144] = {.index = 251, .length = 2},
  [145] = {.index = 253, .length = 3},
  [146] = {.index = 256, .length = 2},
  [147] = {.index = 258, .length = 3},
  [148] = {.index = 261, .length = 1},
  [149] = {.index = 262, .length = 2},
  [150] = {.index = 264, .length = 2},
  [151] = {.index = 266, .length = 5},
  [152] = {.index = 262, .length = 2},
  [153] = {.index = 271, .length = 1},
  [154] = {.index = 272, .length = 4},
  [155] = {.index = 276, .length = 2},
  [156] = {.index = 278, .length = 1},
  [157] = {.index = 279, .length = 2},
  [158] = {.index = 281, .length = 2},
  [159] = {.index = 283, .length = 2},
  [160] = {.index = 285, .length = 4},
  [161] = {.index = 289, .length = 2},
  [162] = {.index = 291, .length = 3},
  [163] = {.index = 294, .length = 3},
  [164] = {.index = 297, .length = 3},
  [165] = {.index = 300, .length = 4},
  [166] = {.index = 304, .length = 1},
  [167] = {.index = 305, .length = 2},
  [168] = {.index = 307, .length = 4},
  [169] = {.index = 311, .length = 4},
  [170] = {.index = 315, .length = 4},
  [171] = {.index = 319, .length = 2},
  [172] = {.index = 321, .length = 2},
  [173] = {.index = 323, .length = 4},
  [174] = {.index = 327, .length = 4},
  [175] = {.index = 331, .length = 5},
  [176] = {.index = 336, .length = 3},
  [177] = {.index = 339, .length = 3},
  [178] = {.index = 339, .length = 3},
  [179] = {.index = 342, .length = 2},
  [180] = {.index = 344, .length = 3},
  [181] = {.index = 347, .length = 2},
  [182] = {.index = 347, .length = 2},
  [183] = {.index = 297, .length = 3},
  [184] = {.index = 349, .length = 4},
  [185] = {.index = 349, .length = 4},
  [186] = {.index = 353, .length = 4},
  [187] = {.index = 353, .length = 4},
  [188] = {.index = 357, .length = 3},
  [189] = {.index = 360, .length = 3},
  [190] = {.index = 137, .length = 2},
  [191] = {.index = 363, .length = 2},
  [192] = {.index = 365, .length = 3},
  [193] = {.index = 368, .length = 4},
  [194] = {.index = 372, .length = 3},
  [195] = {.index = 375, .length = 3},
  [196] = {.index = 378, .length = 2},
  [197] = {.index = 380, .length = 3},
  [198] = {.index = 383, .length = 5},
  [199] = {.index = 378, .length = 2},
  [200] = {.index = 388, .length = 3},
  [201] = {.index = 388, .length = 3},
  [202] = {.index = 391, .length = 3},
  [203] = {.index = 394, .length = 2},
  [204] = {.index = 396, .length = 4},
  [205] = {.index = 137, .length = 2},
  [206] = {.index = 400, .length = 1},
  [207] = {.index = 401, .length = 2},
  [208] = {.index = 403, .length = 2},
  [209] = {.index = 405, .length = 2},
  [210] = {.index = 407, .length = 2},
  [211] = {.index = 409, .length = 3},
  [212] = {.index = 412, .length = 1},
  [213] = {.index = 413, .length = 3},
  [214] = {.index = 416, .length = 2},
  [215] = {.index = 418, .length = 3},
  [216] = {.index = 421, .length = 3},
  [217] = {.index = 424, .length = 3},
  [218] = {.index = 427, .length = 3},
  [219] = {.index = 430, .length = 4},
  [220] = {.index = 434, .length = 2},
  [221] = {.index = 436, .length = 2},
  [222] = {.index = 438, .length = 1},
  [223] = {.index = 439, .length = 4},
  [224] = {.index = 439, .length = 4},
  [225] = {.index = 443, .length = 2},
  [226] = {.index = 445, .length = 3},
  [227] = {.index = 448, .length = 5},
  [228] = {.index = 453, .length = 3},
  [229] = {.index = 456, .length = 2},
  [230] = {.index = 458, .length = 2},
  [231] = {.index = 460, .length = 2},
  [232] = {.index = 462, .length = 1},
  [233] = {.index = 463, .length = 4},
  [234] = {.index = 467, .length = 3},
  [235] = {.index = 470, .length = 4},
  [236] = {.index = 474, .length = 5},
  [237] = {.index = 479, .length = 1},
  [238] = {.index = 480, .length = 2},
  [239] = {.index = 482, .length = 4},
  [240] = {.index = 486, .length = 4},
  [241] = {.index = 490, .length = 2},
  [242] = {.index = 492, .length = 4},
  [243] = {.index = 496, .length = 4},
  [244] = {.index = 500, .length = 2},
  [245] = {.index = 502, .length = 2},
  [246] = {.index = 504, .length = 3},
  [247] = {.index = 507, .length = 3},
  [248] = {.index = 510, .length = 2},
  [249] = {.index = 512, .length = 2},
  [250] = {.index = 514, .length = 1},
  [251] = {.index = 515, .length = 1},
  [252] = {.index = 516, .length = 3},
  [253] = {.index = 519, .length = 3},
  [254] = {.index = 522, .length = 3},
  [255] = {.index = 525, .length = 3},
  [256] = {.index = 528, .length = 4},
  [257] = {.index = 532, .length = 2},
  [258] = {.index = 534, .length = 4},
  [259] = {.index = 538, .length = 3},
  [260] = {.index = 541, .length = 2},
  [261] = {.index = 543, .length = 2},
  [262] = {.index = 545, .length = 4},
  [263] = {.index = 549, .length = 4},
  [264] = {.index = 553, .length = 4},
  [265] = {.index = 557, .length = 3},
  [266] = {.index = 560, .length = 2},
  [268] = {.index = 562, .length = 4},
  [269] = {.index = 566, .length = 5},
  [270] = {.index = 571, .length = 5},
  [271] = {.index = 576, .length = 5},
  [272] = {.index = 581, .length = 3},
  [273] = {.index = 584, .length = 3},
  [274] = {.index = 587, .length = 3},
  [275] = {.index = 584, .length = 3},
  [276] = {.index = 590, .length = 2},
  [277] = {.index = 592, .length = 4},
  [278] = {.index = 596, .length = 4},
  [279] = {.index = 600, .length = 3},
  [280] = {.index = 603, .length = 2},
  [281] = {.index = 605, .length = 2},
  [282] = {.index = 607, .length = 3},
  [283] = {.index = 610, .length = 2},
  [284] = {.index = 612, .length = 2},
  [285] = {.index = 614, .length = 1},
  [286] = {.index = 615, .length = 3},
  [287] = {.index = 618, .length = 3},
  [288] = {.index = 621, .length = 4},
  [289] = {.index = 625, .length = 4},
  [290] = {.index = 629, .length = 3},
  [291] = {.index = 632, .length = 3},
  [292] = {.index = 635, .length = 2},
  [293] = {.index = 637, .length = 3},
  [294] = {.index = 640, .length = 2},
  [295] = {.index = 642, .length = 4},
  [296] = {.index = 646, .length = 4},
  [297] = {.index = 650, .length = 4},
  [298] = {.index = 654, .length = 3},
  [299] = {.index = 657, .length = 5},
  [300] = {.index = 662, .length = 5},
  [301] = {.index = 667, .length = 4},
  [302] = {.index = 671, .length = 4},
  [303] = {.index = 675, .length = 3},
  [304] = {.index = 678, .length = 3},
  [305] = {.index = 678, .length = 3},
  [306] = {.index = 681, .length = 2},
  [307] = {.index = 683, .length = 2},
  [308] = {.index = 685, .length = 3},
  [309] = {.index = 688, .length = 2},
  [310] = {.index = 690, .length = 2},
  [311] = {.index = 692, .length = 4},
  [312] = {.index = 696, .length = 3},
  [313] = {.index = 699, .length = 3},
  [314] = {.index = 702, .length = 4},
  [315] = {.index = 706, .length = 3},
  [316] = {.index = 709, .length = 3},
  [317] = {.index = 712, .length = 2},
  [318] = {.index = 714, .length = 4},
  [319] = {.index = 718, .length = 5},
  [320] = {.index = 723, .length = 5},
  [321] = {.index = 728, .length = 4},
  [322] = {.index = 728, .length = 4},
  [323] = {.index = 732, .length = 4},
  [324] = {.index = 736, .length = 3},
  [325] = {.index = 739, .length = 2},
  [326] = {.index = 741, .length = 2},
  [327] = {.index = 743, .length = 3},
  [328] = {.index = 746, .length = 4},
  [329] = {.index = 750, .length = 4},
  [330] = {.index = 754, .length = 3},
  [331] = {.index = 757, .length = 3},
  [332] = {.index = 760, .length = 4},
  [333] = {.index = 764, .length = 3},
  [334] = {.index = 767, .length = 3},
  [335] = {.index = 770, .length = 5},
  [336] = {.index = 775, .length = 3},
  [337] = {.index = 778, .length = 4},
  [338] = {.index = 782, .length = 4},
  [339] = {.index = 786, .length = 3},
  [340] = {.index = 789, .length = 3},
  [341] = {.index = 792, .length = 4},
  [342] = {.index = 796, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_pattern, 0},
  [9] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [11] =
    {field_body, 1},
  [12] =
    {field_constructor, 1},
  [13] =
    {field_arguments, 1},
    {field_function, 0},
  [15] =
    {field_argument, 0},
    {field_operator, 1},
  [17] =
    {field_type_arguments, 1},
  [18] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [20] =
    {field_parameters, 0},
    {field_return_type, 1},
  [22] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [24] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [26] =
    {field_declaration, 2},
  [27] =
    {field_left, 0},
    {field_right, 2},
  [29] =
    {field_body, 2},
    {field_label, 0},
  [31] =
    {field_body, 2},
    {field_parameter, 0},
  [33] =
    {field_body, 1},
    {field_name, 0},
  [35] =
    {field_source, 1},
  [36] =
    {field_body, 2},
    {field_object, 1},
  [38] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [40] =
    {field_name, 0},
    {field_type, 1},
  [42] =
    {field_kind, 0},
  [43] =
    {field_condition, 1},
    {field_consequence, 2},
  [45] =
    {field_body, 2},
    {field_value, 1},
  [47] =
    {field_body, 2},
    {field_kind, 1, .inherited = true},
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [53] =
    {field_pattern, 1},
  [54] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [57] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
  [60] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 1},
  [62] =
    {field_body, 2},
    {field_condition, 1},
  [64] =
    {field_body, 1},
    {field_handler, 2},
  [66] =
    {field_body, 1},
    {field_finalizer, 2},
  [68] =
    {field_label, 1},
  [69] =
    {field_body, 2},
    {field_name, 1},
  [71] =
    {field_value, 0},
  [72] =
    {field_type_arguments, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [74] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [76] =
    {field_body, 2},
  [77] =
    {field_body, 2},
    {field_type_parameters, 1},
  [79] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [83] =
    {field_arguments, 2},
    {field_constructor, 1},
  [85] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [87] =
    {field_name, 1},
  [88] =
    {field_attribute, 0},
  [89] =
    {field_name, 0},
    {field_value, 1},
  [91] =
    {field_constraint, 1},
    {field_name, 0},
  [93] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [96] =
    {field_object, 0},
    {field_property, 2},
  [98] =
    {field_object, 0},
    {field_optional_chain, 1},
    {field_property, 2},
  [101] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [104] =
    {field_arguments, 2},
    {field_function, 0},
  [106] =
    {field_close_tag, 2},
    {field_content, 1},
    {field_open_tag, 0},
  [109] =
    {field_close_tag, 2},
    {field_open_tag, 0},
  [111] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [115] =
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [117] =
    {field_arguments, 1, .inherited = true},
    {field_function, 1, .inherited = true},
  [119] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [122] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [124] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [126] =
    {field_source, 2, .inherited = true},
  [127] =
    {field_value, 2},
  [128] =
    {field_key, 0},
    {field_value, 2},
  [130] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [135] =
    {field_source, 2},
  [136] =
    {field_value, 1},
  [137] =
    {field_name, 0},
    {field_type, 2},
  [139] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [142] =
    {field_body, 3},
    {field_name, 2},
  [144] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [147] =
    {field_body, 3},
    {field_kind, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [153] =
    {field_type, 2},
  [154] =
    {field_pattern, 2},
  [155] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [158] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
  [161] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [165] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 2},
  [167] =
    {field_body, 1},
    {field_condition, 3},
  [169] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [172] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [176] =
    {field_decorator, 0, .inherited = true},
  [177] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
  [179] =
    {field_decorator, 1, .inherited = true},
  [180] =
    {field_body, 3},
    {field_name, 1},
  [182] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [185] =
    {field_type_arguments, 1},
    {field_value, 0},
  [187] =
    {field_type_arguments, 1, .inherited = true},
    {field_type_arguments, 2, .inherited = true},
    {field_value, 1, .inherited = true},
    {field_value, 2, .inherited = true},
  [191] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [194] =
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [196] =
    {field_function, 1, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
  [198] =
    {field_name, 0},
    {field_type_arguments, 1},
  [200] =
    {field_body, 3},
    {field_type_parameters, 1},
  [202] =
    {field_body, 3},
    {field_parameter, 1},
  [204] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [208] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [212] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [216] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [221] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [224] =
    {field_left, 1},
    {field_right, 3},
  [226] =
    {field_flags, 3},
    {field_pattern, 1},
  [228] =
    {field_name, 1},
    {field_value, 2},
  [230] =
    {field_constraint, 2},
    {field_name, 1},
  [232] =
    {field_attribute, 2, .inherited = true},
    {field_name, 1},
  [234] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [236] =
    {field_name, 1},
    {field_type_arguments, 2},
  [238] =
    {field_constraint, 1},
    {field_name, 0},
    {field_value, 2},
  [241] =
    {field_type, 1},
  [242] =
    {field_arguments, 1},
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [246] =
    {field_index, 2},
    {field_object, 0},
  [248] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [251] =
    {field_declaration, 3},
    {field_decorator, 0, .inherited = true},
  [253] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [256] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [258] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [261] =
    {field_source, 3, .inherited = true},
  [262] =
    {field_alias, 2},
    {field_name, 0},
  [264] =
    {field_name, 1},
    {field_value, 3},
  [266] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [271] =
    {field_pattern, 3},
  [272] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [276] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 3},
  [278] =
    {field_name, 2},
  [279] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [281] =
    {field_name, 1},
    {field_type, 2},
  [283] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [285] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [289] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [291] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [294] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 2},
  [297] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [300] =
    {field_type_arguments, 0, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [304] =
    {field_parameters, 1},
  [305] =
    {field_function, 0},
    {field_type_arguments, 1},
  [307] =
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_type_arguments, 1},
  [311] =
    {field_arguments, 1},
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [315] =
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
    {field_type_arguments, 1},
  [319] =
    {field_module, 0},
    {field_name, 2},
  [321] =
    {field_parameters, 0},
    {field_return_type, 2},
  [323] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [327] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [331] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [336] =
    {field_constraint, 2},
    {field_name, 1},
    {field_value, 3},
  [339] =
    {field_attribute, 3, .inherited = true},
    {field_name, 1},
    {field_type_arguments, 2},
  [342] =
    {field_body, 4},
    {field_name, 2},
  [344] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [347] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [349] =
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 2},
  [353] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_object, 0},
    {field_property, 2},
  [357] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [360] =
    {field_index, 3},
    {field_object, 0},
    {field_optional_chain, 1},
  [363] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [365] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [368] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [372] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [375] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [378] =
    {field_alias, 3},
    {field_name, 1},
  [380] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [383] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [388] =
    {field_left, 1},
    {field_operator, 2},
    {field_right, 3},
  [391] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [394] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 4},
  [396] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [400] =
    {field_type, 3},
  [401] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [403] =
    {field_name, 2},
    {field_type, 3},
  [405] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [407] =
    {field_name, 1},
    {field_type, 3},
  [409] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [412] =
    {field_name, 3},
  [413] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [416] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [418] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [421] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 3},
  [424] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [427] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 3},
  [430] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [434] =
    {field_parameters, 1},
    {field_type, 2},
  [436] =
    {field_parameters, 2},
    {field_type_parameters, 1},
  [438] =
    {field_parameters, 2},
  [439] =
    {field_index, 0, .inherited = true},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 2},
  [443] =
    {field_parameters, 1},
    {field_type, 3},
  [445] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_type_parameters, 0},
  [448] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [453] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [456] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [458] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [460] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [462] =
    {field_name, 2, .inherited = true},
  [463] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [467] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [470] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [474] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [479] =
    {field_source, 4},
  [480] =
    {field_body, 3},
    {field_value, 1},
  [482] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [486] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [490] =
    {field_body, 4},
    {field_parameter, 2},
  [492] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [496] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [500] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [502] =
    {field_name, 2},
    {field_type, 4},
  [504] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [507] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [510] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [512] =
    {field_name, 3},
    {field_type, 4},
  [514] =
    {field_type, 4},
  [515] =
    {field_name, 4},
  [516] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [519] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 4},
  [522] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [525] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 4},
  [528] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [532] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
  [534] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [538] =
    {field_parameters, 2},
    {field_type, 3},
    {field_type_parameters, 1},
  [541] =
    {field_parameters, 2},
    {field_type, 3},
  [543] =
    {field_parameters, 3},
    {field_type_parameters, 2},
  [545] =
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [549] =
    {field_index, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [553] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
  [557] =
    {field_parameters, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [560] =
    {field_parameters, 2},
    {field_type, 4},
  [562] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [566] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [571] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [576] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 4},
    {field_right, 5},
    {field_value, 3, .inherited = true},
  [581] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [584] =
    {field_index_type, 3},
    {field_name, 1},
    {field_type, 5},
  [587] =
    {field_alias, 4},
    {field_name, 0},
    {field_type, 2},
  [590] =
    {field_sign, 0},
    {field_type, 5},
  [592] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [596] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [600] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [603] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [605] =
    {field_name, 3},
    {field_type, 5},
  [607] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [610] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [612] =
    {field_name, 4},
    {field_type, 5},
  [614] =
    {field_name, 5},
  [615] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [618] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 5},
  [621] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [625] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [629] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [632] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 5},
  [635] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
  [637] =
    {field_parameters, 3},
    {field_type, 4},
    {field_type_parameters, 2},
  [640] =
    {field_index, 3},
    {field_object, 0},
  [642] =
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [646] =
    {field_index, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [650] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
  [654] =
    {field_parameters, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [657] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [662] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [667] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [671] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [675] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [678] =
    {field_index_type, 4},
    {field_name, 2},
    {field_type, 6},
  [681] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [683] =
    {field_name, 4},
    {field_type, 6},
  [685] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [688] =
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [690] =
    {field_name, 5},
    {field_type, 6},
  [692] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [696] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [699] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 6},
  [702] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [706] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [709] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 6},
  [712] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
  [714] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [718] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [723] =
    {field_body, 8},
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [728] =
    {field_index_type, 5},
    {field_name, 3},
    {field_sign, 0},
    {field_type, 7},
  [732] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [736] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [739] =
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [741] =
    {field_name, 5},
    {field_type, 7},
  [743] =
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [746] =
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [750] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [754] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [757] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 7},
  [760] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [764] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_value, 7, .inherited = true},
  [767] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 7},
  [770] =
    {field_body, 9},
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [775] =
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [778] =
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [782] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [786] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_value, 8, .inherited = true},
  [789] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 8},
  [792] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [796] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 8},
    {field_value, 9, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [13] = {
    [0] = alias_sym_type_identifier,
  },
  [22] = {
    [0] = sym_identifier,
  },
  [23] = {
    [0] = alias_sym_statement_identifier,
  },
  [24] = {
    [0] = sym_identifier,
  },
  [26] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [27] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [28] = {
    [1] = sym_identifier,
  },
  [44] = {
    [1] = alias_sym_statement_identifier,
  },
  [45] = {
    [1] = alias_sym_type_identifier,
  },
  [48] = {
    [0] = alias_sym_type_identifier,
  },
  [49] = {
    [0] = alias_sym_this_type,
  },
  [56] = {
    [1] = alias_sym_type_identifier,
  },
  [59] = {
    [0] = alias_sym_type_identifier,
  },
  [60] = {
    [0] = alias_sym_type_identifier,
  },
  [61] = {
    [1] = sym_member_expression,
  },
  [65] = {
    [1] = alias_sym_type_identifier,
    [2] = alias_sym_interface_body,
  },
  [67] = {
    [2] = alias_sym_property_identifier,
  },
  [69] = {
    [2] = alias_sym_property_identifier,
  },
  [83] = {
    [0] = sym_member_expression,
    [2] = alias_sym_property_identifier,
  },
  [84] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [106] = {
    [1] = alias_sym_type_identifier,
  },
  [107] = {
    [1] = alias_sym_type_identifier,
  },
  [113] = {
    [0] = alias_sym_type_identifier,
  },
  [114] = {
    [1] = alias_sym_type_identifier,
  },
  [115] = {
    [1] = anon_sym_unique,
  },
  [118] = {
    [1] = sym_identifier,
  },
  [125] = {
    [1] = sym_identifier,
  },
  [128] = {
    [1] = alias_sym_type_identifier,
  },
  [129] = {
    [1] = alias_sym_type_identifier,
  },
  [133] = {
    [0] = alias_sym_type_identifier,
  },
  [134] = {
    [1] = sym_member_expression,
  },
  [135] = {
    [1] = sym_member_expression,
  },
  [136] = {
    [2] = alias_sym_type_identifier,
  },
  [137] = {
    [1] = alias_sym_type_identifier,
  },
  [139] = {
    [1] = alias_sym_type_identifier,
    [3] = alias_sym_interface_body,
  },
  [140] = {
    [1] = alias_sym_type_identifier,
    [3] = alias_sym_interface_body,
  },
  [145] = {
    [2] = alias_sym_type_identifier,
  },
  [150] = {
    [1] = alias_sym_type_identifier,
  },
  [152] = {
    [0] = sym_identifier,
  },
  [164] = {
    [1] = alias_sym_type_identifier,
  },
  [171] = {
    [2] = alias_sym_type_identifier,
  },
  [176] = {
    [1] = alias_sym_type_identifier,
  },
  [178] = {
    [1] = sym_member_expression,
  },
  [179] = {
    [2] = alias_sym_type_identifier,
  },
  [180] = {
    [2] = alias_sym_type_identifier,
  },
  [181] = {
    [1] = alias_sym_type_identifier,
  },
  [183] = {
    [1] = alias_sym_type_identifier,
    [4] = alias_sym_interface_body,
  },
  [184] = {
    [2] = alias_sym_property_identifier,
  },
  [186] = {
    [2] = alias_sym_property_identifier,
  },
  [190] = {
    [0] = sym_identifier,
  },
  [192] = {
    [2] = alias_sym_type_identifier,
  },
  [193] = {
    [2] = alias_sym_type_identifier,
  },
  [195] = {
    [3] = alias_sym_type_identifier,
  },
  [197] = {
    [1] = alias_sym_type_identifier,
  },
  [199] = {
    [1] = sym_identifier,
  },
  [200] = {
    [1] = sym_identifier,
  },
  [205] = {
    [0] = alias_sym_type_identifier,
  },
  [223] = {
    [2] = alias_sym_property_identifier,
  },
  [228] = {
    [2] = alias_sym_type_identifier,
  },
  [233] = {
    [2] = alias_sym_type_identifier,
  },
  [234] = {
    [3] = alias_sym_type_identifier,
  },
  [235] = {
    [3] = alias_sym_type_identifier,
  },
  [267] = {
    [3] = alias_sym_property_identifier,
  },
  [268] = {
    [3] = alias_sym_type_identifier,
  },
  [273] = {
    [1] = sym_identifier,
  },
  [274] = {
    [0] = alias_sym_type_identifier,
  },
  [304] = {
    [2] = sym_identifier,
  },
  [321] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_nested_identifier, 2,
    sym_nested_identifier,
    sym_member_expression,
  sym_predefined_type, 2,
    sym_predefined_type,
    sym_identifier,
  sym_object_type, 2,
    sym_object_type,
    alias_sym_interface_body,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 4,
  [6] = 4,
  [7] = 4,
  [8] = 4,
  [9] = 4,
  [10] = 4,
  [11] = 4,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 14,
  [18] = 18,
  [19] = 18,
  [20] = 20,
  [21] = 18,
  [22] = 22,
  [23] = 22,
  [24] = 18,
  [25] = 18,
  [26] = 22,
  [27] = 22,
  [28] = 18,
  [29] = 18,
  [30] = 22,
  [31] = 22,
  [32] = 22,
  [33] = 18,
  [34] = 22,
  [35] = 22,
  [36] = 18,
  [37] = 18,
  [38] = 22,
  [39] = 22,
  [40] = 18,
  [41] = 18,
  [42] = 18,
  [43] = 18,
  [44] = 18,
  [45] = 22,
  [46] = 22,
  [47] = 22,
  [48] = 18,
  [49] = 18,
  [50] = 22,
  [51] = 22,
  [52] = 18,
  [53] = 18,
  [54] = 22,
  [55] = 18,
  [56] = 18,
  [57] = 22,
  [58] = 22,
  [59] = 18,
  [60] = 18,
  [61] = 22,
  [62] = 22,
  [63] = 22,
  [64] = 22,
  [65] = 22,
  [66] = 18,
  [67] = 22,
  [68] = 18,
  [69] = 18,
  [70] = 70,
  [71] = 22,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 73,
  [77] = 77,
  [78] = 78,
  [79] = 78,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 82,
  [84] = 81,
  [85] = 82,
  [86] = 78,
  [87] = 80,
  [88] = 74,
  [89] = 82,
  [90] = 81,
  [91] = 91,
  [92] = 75,
  [93] = 82,
  [94] = 94,
  [95] = 73,
  [96] = 77,
  [97] = 75,
  [98] = 91,
  [99] = 80,
  [100] = 73,
  [101] = 77,
  [102] = 91,
  [103] = 94,
  [104] = 94,
  [105] = 81,
  [106] = 74,
  [107] = 78,
  [108] = 80,
  [109] = 77,
  [110] = 73,
  [111] = 81,
  [112] = 78,
  [113] = 77,
  [114] = 94,
  [115] = 80,
  [116] = 74,
  [117] = 91,
  [118] = 94,
  [119] = 75,
  [120] = 74,
  [121] = 91,
  [122] = 75,
  [123] = 123,
  [124] = 124,
  [125] = 124,
  [126] = 124,
  [127] = 123,
  [128] = 123,
  [129] = 124,
  [130] = 124,
  [131] = 124,
  [132] = 124,
  [133] = 124,
  [134] = 124,
  [135] = 124,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 139,
  [144] = 144,
  [145] = 145,
  [146] = 145,
  [147] = 147,
  [148] = 147,
  [149] = 149,
  [150] = 147,
  [151] = 151,
  [152] = 152,
  [153] = 151,
  [154] = 154,
  [155] = 149,
  [156] = 156,
  [157] = 151,
  [158] = 154,
  [159] = 152,
  [160] = 151,
  [161] = 156,
  [162] = 151,
  [163] = 151,
  [164] = 156,
  [165] = 154,
  [166] = 154,
  [167] = 152,
  [168] = 156,
  [169] = 156,
  [170] = 154,
  [171] = 171,
  [172] = 144,
  [173] = 173,
  [174] = 174,
  [175] = 151,
  [176] = 149,
  [177] = 152,
  [178] = 151,
  [179] = 151,
  [180] = 145,
  [181] = 151,
  [182] = 152,
  [183] = 183,
  [184] = 151,
  [185] = 185,
  [186] = 151,
  [187] = 152,
  [188] = 171,
  [189] = 151,
  [190] = 151,
  [191] = 151,
  [192] = 152,
  [193] = 174,
  [194] = 151,
  [195] = 152,
  [196] = 196,
  [197] = 196,
  [198] = 198,
  [199] = 196,
  [200] = 151,
  [201] = 196,
  [202] = 196,
  [203] = 196,
  [204] = 196,
  [205] = 196,
  [206] = 196,
  [207] = 152,
  [208] = 208,
  [209] = 208,
  [210] = 208,
  [211] = 208,
  [212] = 208,
  [213] = 208,
  [214] = 208,
  [215] = 208,
  [216] = 208,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 220,
  [222] = 220,
  [223] = 220,
  [224] = 220,
  [225] = 220,
  [226] = 220,
  [227] = 220,
  [228] = 220,
  [229] = 229,
  [230] = 229,
  [231] = 231,
  [232] = 229,
  [233] = 231,
  [234] = 231,
  [235] = 231,
  [236] = 229,
  [237] = 231,
  [238] = 229,
  [239] = 231,
  [240] = 229,
  [241] = 241,
  [242] = 241,
  [243] = 241,
  [244] = 244,
  [245] = 245,
  [246] = 244,
  [247] = 247,
  [248] = 241,
  [249] = 244,
  [250] = 247,
  [251] = 241,
  [252] = 241,
  [253] = 253,
  [254] = 254,
  [255] = 241,
  [256] = 253,
  [257] = 253,
  [258] = 258,
  [259] = 254,
  [260] = 245,
  [261] = 258,
  [262] = 254,
  [263] = 241,
  [264] = 258,
  [265] = 265,
  [266] = 266,
  [267] = 265,
  [268] = 265,
  [269] = 265,
  [270] = 270,
  [271] = 265,
  [272] = 265,
  [273] = 273,
  [274] = 265,
  [275] = 241,
  [276] = 276,
  [277] = 277,
  [278] = 266,
  [279] = 276,
  [280] = 276,
  [281] = 276,
  [282] = 276,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 283,
  [288] = 266,
  [289] = 286,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 293,
  [298] = 291,
  [299] = 294,
  [300] = 295,
  [301] = 266,
  [302] = 295,
  [303] = 303,
  [304] = 266,
  [305] = 305,
  [306] = 295,
  [307] = 291,
  [308] = 293,
  [309] = 292,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 266,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 295,
  [318] = 266,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 294,
  [323] = 295,
  [324] = 324,
  [325] = 325,
  [326] = 266,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 266,
  [335] = 335,
  [336] = 266,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 295,
  [342] = 342,
  [343] = 292,
  [344] = 337,
  [345] = 345,
  [346] = 331,
  [347] = 333,
  [348] = 335,
  [349] = 349,
  [350] = 339,
  [351] = 303,
  [352] = 327,
  [353] = 311,
  [354] = 312,
  [355] = 345,
  [356] = 303,
  [357] = 324,
  [358] = 342,
  [359] = 359,
  [360] = 312,
  [361] = 310,
  [362] = 305,
  [363] = 314,
  [364] = 338,
  [365] = 345,
  [366] = 324,
  [367] = 367,
  [368] = 332,
  [369] = 359,
  [370] = 345,
  [371] = 292,
  [372] = 293,
  [373] = 291,
  [374] = 339,
  [375] = 296,
  [376] = 311,
  [377] = 345,
  [378] = 294,
  [379] = 345,
  [380] = 345,
  [381] = 310,
  [382] = 332,
  [383] = 337,
  [384] = 319,
  [385] = 321,
  [386] = 340,
  [387] = 330,
  [388] = 345,
  [389] = 342,
  [390] = 345,
  [391] = 327,
  [392] = 359,
  [393] = 328,
  [394] = 305,
  [395] = 338,
  [396] = 359,
  [397] = 315,
  [398] = 321,
  [399] = 399,
  [400] = 345,
  [401] = 340,
  [402] = 345,
  [403] = 345,
  [404] = 359,
  [405] = 331,
  [406] = 296,
  [407] = 407,
  [408] = 319,
  [409] = 320,
  [410] = 335,
  [411] = 407,
  [412] = 333,
  [413] = 315,
  [414] = 345,
  [415] = 329,
  [416] = 314,
  [417] = 328,
  [418] = 418,
  [419] = 330,
  [420] = 329,
  [421] = 345,
  [422] = 320,
  [423] = 423,
  [424] = 339,
  [425] = 329,
  [426] = 426,
  [427] = 427,
  [428] = 337,
  [429] = 315,
  [430] = 342,
  [431] = 305,
  [432] = 423,
  [433] = 433,
  [434] = 314,
  [435] = 328,
  [436] = 436,
  [437] = 330,
  [438] = 312,
  [439] = 335,
  [440] = 333,
  [441] = 324,
  [442] = 331,
  [443] = 427,
  [444] = 320,
  [445] = 423,
  [446] = 426,
  [447] = 423,
  [448] = 303,
  [449] = 340,
  [450] = 338,
  [451] = 296,
  [452] = 321,
  [453] = 319,
  [454] = 327,
  [455] = 455,
  [456] = 310,
  [457] = 457,
  [458] = 311,
  [459] = 423,
  [460] = 332,
  [461] = 461,
  [462] = 462,
  [463] = 462,
  [464] = 462,
  [465] = 462,
  [466] = 462,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 467,
  [473] = 470,
  [474] = 474,
  [475] = 470,
  [476] = 476,
  [477] = 470,
  [478] = 478,
  [479] = 479,
  [480] = 471,
  [481] = 468,
  [482] = 474,
  [483] = 468,
  [484] = 484,
  [485] = 469,
  [486] = 469,
  [487] = 474,
  [488] = 468,
  [489] = 489,
  [490] = 479,
  [491] = 476,
  [492] = 492,
  [493] = 467,
  [494] = 468,
  [495] = 495,
  [496] = 470,
  [497] = 497,
  [498] = 469,
  [499] = 470,
  [500] = 471,
  [501] = 470,
  [502] = 502,
  [503] = 471,
  [504] = 474,
  [505] = 470,
  [506] = 474,
  [507] = 479,
  [508] = 476,
  [509] = 509,
  [510] = 467,
  [511] = 476,
  [512] = 479,
  [513] = 467,
  [514] = 476,
  [515] = 479,
  [516] = 479,
  [517] = 471,
  [518] = 476,
  [519] = 467,
  [520] = 474,
  [521] = 468,
  [522] = 467,
  [523] = 469,
  [524] = 524,
  [525] = 525,
  [526] = 476,
  [527] = 479,
  [528] = 468,
  [529] = 469,
  [530] = 469,
  [531] = 469,
  [532] = 478,
  [533] = 469,
  [534] = 468,
  [535] = 484,
  [536] = 536,
  [537] = 537,
  [538] = 470,
  [539] = 539,
  [540] = 540,
  [541] = 479,
  [542] = 467,
  [543] = 476,
  [544] = 544,
  [545] = 476,
  [546] = 479,
  [547] = 467,
  [548] = 468,
  [549] = 474,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 551,
  [554] = 554,
  [555] = 555,
  [556] = 552,
  [557] = 550,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 559,
  [567] = 558,
  [568] = 568,
  [569] = 561,
  [570] = 555,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 563,
  [583] = 579,
  [584] = 577,
  [585] = 585,
  [586] = 577,
  [587] = 573,
  [588] = 579,
  [589] = 578,
  [590] = 563,
  [591] = 591,
  [592] = 575,
  [593] = 572,
  [594] = 560,
  [595] = 581,
  [596] = 596,
  [597] = 597,
  [598] = 561,
  [599] = 580,
  [600] = 558,
  [601] = 559,
  [602] = 578,
  [603] = 575,
  [604] = 585,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 560,
  [609] = 568,
  [610] = 577,
  [611] = 611,
  [612] = 612,
  [613] = 560,
  [614] = 605,
  [615] = 606,
  [616] = 563,
  [617] = 581,
  [618] = 563,
  [619] = 597,
  [620] = 561,
  [621] = 580,
  [622] = 555,
  [623] = 568,
  [624] = 564,
  [625] = 585,
  [626] = 564,
  [627] = 573,
  [628] = 605,
  [629] = 551,
  [630] = 551,
  [631] = 579,
  [632] = 579,
  [633] = 585,
  [634] = 606,
  [635] = 552,
  [636] = 563,
  [637] = 606,
  [638] = 596,
  [639] = 605,
  [640] = 564,
  [641] = 563,
  [642] = 551,
  [643] = 579,
  [644] = 564,
  [645] = 555,
  [646] = 559,
  [647] = 551,
  [648] = 558,
  [649] = 562,
  [650] = 572,
  [651] = 578,
  [652] = 565,
  [653] = 563,
  [654] = 575,
  [655] = 575,
  [656] = 578,
  [657] = 551,
  [658] = 581,
  [659] = 562,
  [660] = 607,
  [661] = 573,
  [662] = 564,
  [663] = 572,
  [664] = 579,
  [665] = 550,
  [666] = 606,
  [667] = 560,
  [668] = 573,
  [669] = 577,
  [670] = 606,
  [671] = 671,
  [672] = 605,
  [673] = 579,
  [674] = 596,
  [675] = 605,
  [676] = 581,
  [677] = 580,
  [678] = 568,
  [679] = 552,
  [680] = 550,
  [681] = 561,
  [682] = 580,
  [683] = 568,
  [684] = 552,
  [685] = 550,
  [686] = 574,
  [687] = 597,
  [688] = 585,
  [689] = 562,
  [690] = 690,
  [691] = 565,
  [692] = 560,
  [693] = 563,
  [694] = 573,
  [695] = 564,
  [696] = 574,
  [697] = 558,
  [698] = 585,
  [699] = 565,
  [700] = 559,
  [701] = 573,
  [702] = 551,
  [703] = 562,
  [704] = 550,
  [705] = 562,
  [706] = 563,
  [707] = 555,
  [708] = 561,
  [709] = 574,
  [710] = 562,
  [711] = 550,
  [712] = 612,
  [713] = 552,
  [714] = 568,
  [715] = 580,
  [716] = 560,
  [717] = 581,
  [718] = 564,
  [719] = 572,
  [720] = 577,
  [721] = 578,
  [722] = 575,
  [723] = 572,
  [724] = 597,
  [725] = 555,
  [726] = 558,
  [727] = 559,
  [728] = 559,
  [729] = 565,
  [730] = 558,
  [731] = 561,
  [732] = 561,
  [733] = 572,
  [734] = 579,
  [735] = 735,
  [736] = 555,
  [737] = 560,
  [738] = 575,
  [739] = 597,
  [740] = 563,
  [741] = 585,
  [742] = 574,
  [743] = 555,
  [744] = 606,
  [745] = 605,
  [746] = 746,
  [747] = 606,
  [748] = 605,
  [749] = 560,
  [750] = 559,
  [751] = 574,
  [752] = 574,
  [753] = 555,
  [754] = 578,
  [755] = 559,
  [756] = 558,
  [757] = 572,
  [758] = 575,
  [759] = 578,
  [760] = 565,
  [761] = 577,
  [762] = 581,
  [763] = 580,
  [764] = 568,
  [765] = 552,
  [766] = 574,
  [767] = 558,
  [768] = 572,
  [769] = 573,
  [770] = 550,
  [771] = 562,
  [772] = 577,
  [773] = 562,
  [774] = 564,
  [775] = 551,
  [776] = 561,
  [777] = 575,
  [778] = 550,
  [779] = 565,
  [780] = 552,
  [781] = 585,
  [782] = 782,
  [783] = 783,
  [784] = 596,
  [785] = 568,
  [786] = 565,
  [787] = 578,
  [788] = 581,
  [789] = 580,
  [790] = 563,
  [791] = 574,
  [792] = 565,
  [793] = 793,
  [794] = 563,
  [795] = 568,
  [796] = 571,
  [797] = 573,
  [798] = 552,
  [799] = 580,
  [800] = 581,
  [801] = 577,
  [802] = 563,
  [803] = 606,
  [804] = 605,
  [805] = 805,
  [806] = 585,
  [807] = 807,
  [808] = 807,
  [809] = 807,
  [810] = 810,
  [811] = 810,
  [812] = 810,
  [813] = 813,
  [814] = 813,
  [815] = 813,
  [816] = 816,
  [817] = 816,
  [818] = 816,
  [819] = 816,
  [820] = 816,
  [821] = 821,
  [822] = 821,
  [823] = 821,
  [824] = 824,
  [825] = 825,
  [826] = 825,
  [827] = 824,
  [828] = 825,
  [829] = 824,
  [830] = 830,
  [831] = 830,
  [832] = 830,
  [833] = 830,
  [834] = 830,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 837,
  [839] = 837,
  [840] = 836,
  [841] = 837,
  [842] = 837,
  [843] = 835,
  [844] = 836,
  [845] = 835,
  [846] = 837,
  [847] = 847,
  [848] = 848,
  [849] = 848,
  [850] = 850,
  [851] = 850,
  [852] = 852,
  [853] = 850,
  [854] = 854,
  [855] = 850,
  [856] = 852,
  [857] = 852,
  [858] = 852,
  [859] = 847,
  [860] = 852,
  [861] = 850,
  [862] = 850,
  [863] = 850,
  [864] = 864,
  [865] = 850,
  [866] = 848,
  [867] = 867,
  [868] = 868,
  [869] = 850,
  [870] = 850,
  [871] = 868,
  [872] = 850,
  [873] = 868,
  [874] = 868,
  [875] = 850,
  [876] = 868,
  [877] = 877,
  [878] = 878,
  [879] = 868,
  [880] = 850,
  [881] = 867,
  [882] = 847,
  [883] = 867,
  [884] = 850,
  [885] = 850,
  [886] = 305,
  [887] = 338,
  [888] = 850,
  [889] = 854,
  [890] = 890,
  [891] = 293,
  [892] = 890,
  [893] = 305,
  [894] = 867,
  [895] = 890,
  [896] = 896,
  [897] = 890,
  [898] = 890,
  [899] = 890,
  [900] = 850,
  [901] = 338,
  [902] = 305,
  [903] = 338,
  [904] = 331,
  [905] = 338,
  [906] = 342,
  [907] = 305,
  [908] = 890,
  [909] = 292,
  [910] = 890,
  [911] = 890,
  [912] = 291,
  [913] = 338,
  [914] = 914,
  [915] = 305,
  [916] = 342,
  [917] = 917,
  [918] = 331,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 922,
  [923] = 305,
  [924] = 924,
  [925] = 338,
  [926] = 926,
  [927] = 338,
  [928] = 292,
  [929] = 929,
  [930] = 293,
  [931] = 305,
  [932] = 338,
  [933] = 310,
  [934] = 896,
  [935] = 342,
  [936] = 342,
  [937] = 937,
  [938] = 331,
  [939] = 939,
  [940] = 940,
  [941] = 342,
  [942] = 917,
  [943] = 331,
  [944] = 305,
  [945] = 314,
  [946] = 305,
  [947] = 293,
  [948] = 292,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 896,
  [955] = 955,
  [956] = 333,
  [957] = 335,
  [958] = 338,
  [959] = 331,
  [960] = 960,
  [961] = 953,
  [962] = 293,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 966,
  [967] = 967,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 950,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 982,
  [983] = 983,
  [984] = 305,
  [985] = 985,
  [986] = 986,
  [987] = 987,
  [988] = 988,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 993,
  [994] = 994,
  [995] = 939,
  [996] = 996,
  [997] = 914,
  [998] = 929,
  [999] = 999,
  [1000] = 924,
  [1001] = 1001,
  [1002] = 338,
  [1003] = 1003,
  [1004] = 950,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 953,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 937,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 917,
  [1017] = 1017,
  [1018] = 1018,
  [1019] = 314,
  [1020] = 949,
  [1021] = 335,
  [1022] = 1022,
  [1023] = 952,
  [1024] = 333,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 310,
  [1029] = 1029,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 955,
  [1035] = 331,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 291,
  [1042] = 1042,
  [1043] = 917,
  [1044] = 919,
  [1045] = 940,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 292,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 939,
  [1057] = 305,
  [1058] = 929,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 331,
  [1062] = 305,
  [1063] = 342,
  [1064] = 1064,
  [1065] = 331,
  [1066] = 1066,
  [1067] = 342,
  [1068] = 291,
  [1069] = 1069,
  [1070] = 926,
  [1071] = 338,
  [1072] = 960,
  [1073] = 1073,
  [1074] = 331,
  [1075] = 305,
  [1076] = 1076,
  [1077] = 342,
  [1078] = 342,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 937,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1089,
  [1090] = 920,
  [1091] = 338,
  [1092] = 305,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 921,
  [1096] = 1096,
  [1097] = 338,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 331,
  [1102] = 321,
  [1103] = 949,
  [1104] = 342,
  [1105] = 310,
  [1106] = 314,
  [1107] = 926,
  [1108] = 1108,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 951,
  [1112] = 1112,
  [1113] = 914,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 924,
  [1117] = 1117,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 952,
  [1121] = 338,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 920,
  [1125] = 921,
  [1126] = 1126,
  [1127] = 331,
  [1128] = 342,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 922,
  [1132] = 922,
  [1133] = 339,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1141,
  [1142] = 940,
  [1143] = 919,
  [1144] = 1144,
  [1145] = 896,
  [1146] = 333,
  [1147] = 324,
  [1148] = 1148,
  [1149] = 310,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 960,
  [1153] = 335,
  [1154] = 1154,
  [1155] = 319,
  [1156] = 951,
  [1157] = 955,
  [1158] = 314,
  [1159] = 1006,
  [1160] = 963,
  [1161] = 291,
  [1162] = 1151,
  [1163] = 1150,
  [1164] = 1148,
  [1165] = 990,
  [1166] = 955,
  [1167] = 989,
  [1168] = 951,
  [1169] = 1059,
  [1170] = 988,
  [1171] = 926,
  [1172] = 987,
  [1173] = 960,
  [1174] = 1048,
  [1175] = 1046,
  [1176] = 1039,
  [1177] = 929,
  [1178] = 1066,
  [1179] = 1141,
  [1180] = 1064,
  [1181] = 1066,
  [1182] = 331,
  [1183] = 339,
  [1184] = 981,
  [1185] = 914,
  [1186] = 939,
  [1187] = 986,
  [1188] = 1033,
  [1189] = 987,
  [1190] = 1076,
  [1191] = 988,
  [1192] = 982,
  [1193] = 1079,
  [1194] = 989,
  [1195] = 342,
  [1196] = 981,
  [1197] = 1088,
  [1198] = 990,
  [1199] = 324,
  [1200] = 963,
  [1201] = 1140,
  [1202] = 967,
  [1203] = 1139,
  [1204] = 919,
  [1205] = 940,
  [1206] = 310,
  [1207] = 980,
  [1208] = 314,
  [1209] = 1060,
  [1210] = 314,
  [1211] = 992,
  [1212] = 979,
  [1213] = 1032,
  [1214] = 1053,
  [1215] = 1047,
  [1216] = 338,
  [1217] = 1138,
  [1218] = 321,
  [1219] = 310,
  [1220] = 319,
  [1221] = 1117,
  [1222] = 1134,
  [1223] = 310,
  [1224] = 974,
  [1225] = 1042,
  [1226] = 1136,
  [1227] = 1051,
  [1228] = 978,
  [1229] = 971,
  [1230] = 975,
  [1231] = 342,
  [1232] = 968,
  [1233] = 1135,
  [1234] = 983,
  [1235] = 993,
  [1236] = 996,
  [1237] = 980,
  [1238] = 966,
  [1239] = 331,
  [1240] = 964,
  [1241] = 999,
  [1242] = 985,
  [1243] = 331,
  [1244] = 1060,
  [1245] = 1245,
  [1246] = 1050,
  [1247] = 979,
  [1248] = 1052,
  [1249] = 1001,
  [1250] = 1005,
  [1251] = 1054,
  [1252] = 342,
  [1253] = 991,
  [1254] = 1064,
  [1255] = 992,
  [1256] = 1038,
  [1257] = 1059,
  [1258] = 1055,
  [1259] = 1115,
  [1260] = 1006,
  [1261] = 1069,
  [1262] = 1037,
  [1263] = 1036,
  [1264] = 1031,
  [1265] = 1085,
  [1266] = 977,
  [1267] = 1003,
  [1268] = 1080,
  [1269] = 1040,
  [1270] = 1032,
  [1271] = 976,
  [1272] = 1003,
  [1273] = 1053,
  [1274] = 1089,
  [1275] = 1081,
  [1276] = 305,
  [1277] = 993,
  [1278] = 1110,
  [1279] = 1081,
  [1280] = 1080,
  [1281] = 970,
  [1282] = 1112,
  [1283] = 339,
  [1284] = 1123,
  [1285] = 978,
  [1286] = 969,
  [1287] = 1126,
  [1288] = 1129,
  [1289] = 971,
  [1290] = 968,
  [1291] = 1130,
  [1292] = 1137,
  [1293] = 1108,
  [1294] = 1030,
  [1295] = 324,
  [1296] = 1144,
  [1297] = 1154,
  [1298] = 1029,
  [1299] = 1027,
  [1300] = 1025,
  [1301] = 973,
  [1302] = 1008,
  [1303] = 1082,
  [1304] = 966,
  [1305] = 1114,
  [1306] = 1026,
  [1307] = 996,
  [1308] = 924,
  [1309] = 964,
  [1310] = 1076,
  [1311] = 985,
  [1312] = 1109,
  [1313] = 1099,
  [1314] = 1050,
  [1315] = 1052,
  [1316] = 1096,
  [1317] = 983,
  [1318] = 1093,
  [1319] = 338,
  [1320] = 1087,
  [1321] = 1073,
  [1322] = 1054,
  [1323] = 1151,
  [1324] = 1150,
  [1325] = 1148,
  [1326] = 975,
  [1327] = 1100,
  [1328] = 1088,
  [1329] = 1082,
  [1330] = 937,
  [1331] = 1083,
  [1332] = 1086,
  [1333] = 1030,
  [1334] = 1029,
  [1335] = 1141,
  [1336] = 1140,
  [1337] = 1139,
  [1338] = 994,
  [1339] = 314,
  [1340] = 986,
  [1341] = 1138,
  [1342] = 1026,
  [1343] = 1118,
  [1344] = 977,
  [1345] = 976,
  [1346] = 1136,
  [1347] = 1098,
  [1348] = 1094,
  [1349] = 1117,
  [1350] = 1135,
  [1351] = 321,
  [1352] = 999,
  [1353] = 1001,
  [1354] = 1005,
  [1355] = 333,
  [1356] = 974,
  [1357] = 319,
  [1358] = 1038,
  [1359] = 994,
  [1360] = 1037,
  [1361] = 950,
  [1362] = 1055,
  [1363] = 335,
  [1364] = 1115,
  [1365] = 1069,
  [1366] = 1134,
  [1367] = 342,
  [1368] = 1085,
  [1369] = 1008,
  [1370] = 1119,
  [1371] = 1122,
  [1372] = 1036,
  [1373] = 991,
  [1374] = 920,
  [1375] = 1083,
  [1376] = 921,
  [1377] = 1086,
  [1378] = 305,
  [1379] = 1051,
  [1380] = 949,
  [1381] = 1042,
  [1382] = 1009,
  [1383] = 1010,
  [1384] = 1009,
  [1385] = 1011,
  [1386] = 952,
  [1387] = 922,
  [1388] = 1089,
  [1389] = 1122,
  [1390] = 1119,
  [1391] = 1118,
  [1392] = 1012,
  [1393] = 965,
  [1394] = 1010,
  [1395] = 1011,
  [1396] = 1014,
  [1397] = 1012,
  [1398] = 1110,
  [1399] = 1094,
  [1400] = 1015,
  [1401] = 1017,
  [1402] = 982,
  [1403] = 1022,
  [1404] = 953,
  [1405] = 1047,
  [1406] = 1098,
  [1407] = 1031,
  [1408] = 1079,
  [1409] = 970,
  [1410] = 1123,
  [1411] = 1073,
  [1412] = 1126,
  [1413] = 1129,
  [1414] = 967,
  [1415] = 1130,
  [1416] = 1137,
  [1417] = 1144,
  [1418] = 1154,
  [1419] = 1018,
  [1420] = 1087,
  [1421] = 331,
  [1422] = 1048,
  [1423] = 969,
  [1424] = 1018,
  [1425] = 973,
  [1426] = 1046,
  [1427] = 1093,
  [1428] = 1096,
  [1429] = 1099,
  [1430] = 1017,
  [1431] = 1015,
  [1432] = 1040,
  [1433] = 1014,
  [1434] = 1108,
  [1435] = 1109,
  [1436] = 1039,
  [1437] = 1112,
  [1438] = 1114,
  [1439] = 1022,
  [1440] = 1025,
  [1441] = 1033,
  [1442] = 1027,
  [1443] = 965,
  [1444] = 1100,
  [1445] = 1055,
  [1446] = 974,
  [1447] = 1052,
  [1448] = 1054,
  [1449] = 1050,
  [1450] = 319,
  [1451] = 1060,
  [1452] = 1059,
  [1453] = 964,
  [1454] = 1064,
  [1455] = 1073,
  [1456] = 996,
  [1457] = 1087,
  [1458] = 966,
  [1459] = 1066,
  [1460] = 982,
  [1461] = 969,
  [1462] = 994,
  [1463] = 968,
  [1464] = 1008,
  [1465] = 971,
  [1466] = 978,
  [1467] = 986,
  [1468] = 999,
  [1469] = 1076,
  [1470] = 1112,
  [1471] = 1048,
  [1472] = 1046,
  [1473] = 1022,
  [1474] = 324,
  [1475] = 1001,
  [1476] = 1005,
  [1477] = 977,
  [1478] = 1039,
  [1479] = 1079,
  [1480] = 1018,
  [1481] = 1017,
  [1482] = 1033,
  [1483] = 976,
  [1484] = 963,
  [1485] = 1015,
  [1486] = 1014,
  [1487] = 993,
  [1488] = 989,
  [1489] = 967,
  [1490] = 1088,
  [1491] = 1032,
  [1492] = 992,
  [1493] = 1115,
  [1494] = 1093,
  [1495] = 1069,
  [1496] = 1114,
  [1497] = 1053,
  [1498] = 1025,
  [1499] = 991,
  [1500] = 1085,
  [1501] = 1027,
  [1502] = 1154,
  [1503] = 1096,
  [1504] = 1099,
  [1505] = 1144,
  [1506] = 1037,
  [1507] = 1137,
  [1508] = 1151,
  [1509] = 1130,
  [1510] = 1150,
  [1511] = 1129,
  [1512] = 1089,
  [1513] = 988,
  [1514] = 1086,
  [1515] = 1047,
  [1516] = 1108,
  [1517] = 1083,
  [1518] = 1148,
  [1519] = 1126,
  [1520] = 321,
  [1521] = 1141,
  [1522] = 973,
  [1523] = 1123,
  [1524] = 1082,
  [1525] = 970,
  [1526] = 1134,
  [1527] = 990,
  [1528] = 981,
  [1529] = 1122,
  [1530] = 1119,
  [1531] = 1140,
  [1532] = 1012,
  [1533] = 1042,
  [1534] = 1139,
  [1535] = 1011,
  [1536] = 1051,
  [1537] = 1138,
  [1538] = 331,
  [1539] = 1136,
  [1540] = 1010,
  [1541] = 975,
  [1542] = 1036,
  [1543] = 983,
  [1544] = 985,
  [1545] = 987,
  [1546] = 1109,
  [1547] = 1118,
  [1548] = 1117,
  [1549] = 310,
  [1550] = 1009,
  [1551] = 1135,
  [1552] = 1110,
  [1553] = 1038,
  [1554] = 965,
  [1555] = 342,
  [1556] = 1245,
  [1557] = 1094,
  [1558] = 1100,
  [1559] = 1081,
  [1560] = 1006,
  [1561] = 1098,
  [1562] = 1080,
  [1563] = 339,
  [1564] = 314,
  [1565] = 1026,
  [1566] = 1031,
  [1567] = 980,
  [1568] = 979,
  [1569] = 1029,
  [1570] = 1040,
  [1571] = 1003,
  [1572] = 1030,
  [1573] = 1573,
  [1574] = 1573,
  [1575] = 1573,
  [1576] = 1573,
  [1577] = 1573,
  [1578] = 1578,
  [1579] = 1579,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 1582,
  [1583] = 1579,
  [1584] = 1584,
  [1585] = 1585,
  [1586] = 1586,
  [1587] = 1578,
  [1588] = 924,
  [1589] = 1579,
  [1590] = 1579,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1578,
  [1595] = 1595,
  [1596] = 1578,
  [1597] = 950,
  [1598] = 1578,
  [1599] = 1579,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1601,
  [1603] = 1603,
  [1604] = 1601,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1606,
  [1608] = 1608,
  [1609] = 1605,
  [1610] = 1610,
  [1611] = 1608,
  [1612] = 1605,
  [1613] = 1613,
  [1614] = 1613,
  [1615] = 1606,
  [1616] = 1608,
  [1617] = 1613,
  [1618] = 1605,
  [1619] = 1619,
  [1620] = 1605,
  [1621] = 1613,
  [1622] = 1610,
  [1623] = 1613,
  [1624] = 1606,
  [1625] = 1608,
  [1626] = 1610,
  [1627] = 1608,
  [1628] = 1610,
  [1629] = 1619,
  [1630] = 1605,
  [1631] = 1606,
  [1632] = 1613,
  [1633] = 1613,
  [1634] = 1619,
  [1635] = 1610,
  [1636] = 1619,
  [1637] = 1608,
  [1638] = 1610,
  [1639] = 1619,
  [1640] = 1605,
  [1641] = 1606,
  [1642] = 1619,
  [1643] = 1610,
  [1644] = 1608,
  [1645] = 1619,
  [1646] = 1606,
  [1647] = 1647,
  [1648] = 1648,
  [1649] = 1649,
  [1650] = 1649,
  [1651] = 1649,
  [1652] = 1649,
  [1653] = 1648,
  [1654] = 1649,
  [1655] = 1649,
  [1656] = 1649,
  [1657] = 1657,
  [1658] = 1657,
  [1659] = 1659,
  [1660] = 1657,
  [1661] = 1659,
  [1662] = 1659,
  [1663] = 1659,
  [1664] = 1657,
  [1665] = 1659,
  [1666] = 1657,
  [1667] = 1667,
  [1668] = 1667,
  [1669] = 1667,
  [1670] = 1667,
  [1671] = 1667,
  [1672] = 1667,
  [1673] = 1667,
  [1674] = 1667,
  [1675] = 1667,
  [1676] = 1667,
  [1677] = 1667,
  [1678] = 1667,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1679,
  [1682] = 1680,
  [1683] = 1679,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1679,
  [1687] = 1684,
  [1688] = 1685,
  [1689] = 1680,
  [1690] = 1690,
  [1691] = 1679,
  [1692] = 1685,
  [1693] = 1684,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1696,
  [1697] = 1697,
  [1698] = 1698,
  [1699] = 1699,
  [1700] = 1700,
  [1701] = 1701,
  [1702] = 1702,
  [1703] = 1703,
  [1704] = 1704,
  [1705] = 1703,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1699,
  [1709] = 1706,
  [1710] = 1696,
  [1711] = 1711,
  [1712] = 1707,
  [1713] = 1696,
  [1714] = 1695,
  [1715] = 1715,
  [1716] = 1696,
  [1717] = 1697,
  [1718] = 1718,
  [1719] = 1702,
  [1720] = 1720,
  [1721] = 1697,
  [1722] = 1722,
  [1723] = 1707,
  [1724] = 1694,
  [1725] = 1718,
  [1726] = 1698,
  [1727] = 1711,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1706,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1706,
  [1734] = 1701,
  [1735] = 1707,
  [1736] = 1736,
  [1737] = 1700,
  [1738] = 1698,
  [1739] = 1739,
  [1740] = 1729,
  [1741] = 1699,
  [1742] = 1742,
  [1743] = 1704,
  [1744] = 1701,
  [1745] = 1722,
  [1746] = 1731,
  [1747] = 1736,
  [1748] = 1729,
  [1749] = 1729,
  [1750] = 1728,
  [1751] = 1729,
  [1752] = 1752,
  [1753] = 1722,
  [1754] = 1718,
  [1755] = 1755,
  [1756] = 1720,
  [1757] = 1736,
  [1758] = 1703,
  [1759] = 1698,
  [1760] = 1732,
  [1761] = 1694,
  [1762] = 1703,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1694,
  [1767] = 1718,
  [1768] = 1698,
  [1769] = 1728,
  [1770] = 1731,
  [1771] = 1771,
  [1772] = 1711,
  [1773] = 1728,
  [1774] = 1722,
  [1775] = 1736,
  [1776] = 1731,
  [1777] = 1703,
  [1778] = 1720,
  [1779] = 1700,
  [1780] = 1728,
  [1781] = 1736,
  [1782] = 1699,
  [1783] = 1699,
  [1784] = 1707,
  [1785] = 1703,
  [1786] = 1700,
  [1787] = 1711,
  [1788] = 1695,
  [1789] = 1789,
  [1790] = 1695,
  [1791] = 1720,
  [1792] = 1700,
  [1793] = 1731,
  [1794] = 1722,
  [1795] = 1702,
  [1796] = 1718,
  [1797] = 1701,
  [1798] = 1701,
  [1799] = 1697,
  [1800] = 1696,
  [1801] = 1720,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1702,
  [1805] = 1805,
  [1806] = 1702,
  [1807] = 1706,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1697,
  [1811] = 1711,
  [1812] = 1695,
  [1813] = 1694,
  [1814] = 1814,
  [1815] = 1702,
  [1816] = 1701,
  [1817] = 1817,
  [1818] = 1817,
  [1819] = 1819,
  [1820] = 1820,
  [1821] = 1821,
  [1822] = 1820,
  [1823] = 1821,
  [1824] = 1824,
  [1825] = 1825,
  [1826] = 1824,
  [1827] = 1827,
  [1828] = 1824,
  [1829] = 1827,
  [1830] = 1825,
  [1831] = 1827,
  [1832] = 1825,
  [1833] = 1824,
  [1834] = 1820,
  [1835] = 1827,
  [1836] = 1820,
  [1837] = 1825,
  [1838] = 1827,
  [1839] = 1824,
  [1840] = 1820,
  [1841] = 1819,
  [1842] = 1820,
  [1843] = 1843,
  [1844] = 1844,
  [1845] = 1825,
  [1846] = 1846,
  [1847] = 1820,
  [1848] = 1846,
  [1849] = 1820,
  [1850] = 1850,
  [1851] = 1846,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 1854,
  [1855] = 1852,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1820,
  [1860] = 1817,
  [1861] = 1861,
  [1862] = 1861,
  [1863] = 1852,
  [1864] = 1864,
  [1865] = 1861,
  [1866] = 1864,
  [1867] = 1861,
  [1868] = 1868,
  [1869] = 1820,
  [1870] = 1852,
  [1871] = 1820,
  [1872] = 1820,
  [1873] = 1856,
  [1874] = 1874,
  [1875] = 1820,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1852,
  [1879] = 1879,
  [1880] = 1820,
  [1881] = 1856,
  [1882] = 1861,
  [1883] = 1883,
  [1884] = 1868,
  [1885] = 1852,
  [1886] = 1861,
  [1887] = 1820,
  [1888] = 1820,
  [1889] = 1868,
  [1890] = 1890,
  [1891] = 1843,
  [1892] = 1820,
  [1893] = 1864,
  [1894] = 1894,
  [1895] = 1864,
  [1896] = 1820,
  [1897] = 1819,
  [1898] = 1820,
  [1899] = 950,
  [1900] = 1900,
  [1901] = 1901,
  [1902] = 1864,
  [1903] = 1820,
  [1904] = 924,
  [1905] = 1864,
  [1906] = 1906,
  [1907] = 1907,
  [1908] = 1864,
  [1909] = 1909,
  [1910] = 1910,
  [1911] = 1911,
  [1912] = 1890,
  [1913] = 1909,
  [1914] = 1914,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1909,
  [1918] = 1909,
  [1919] = 1919,
  [1920] = 1820,
  [1921] = 1890,
  [1922] = 1915,
  [1923] = 1909,
  [1924] = 1901,
  [1925] = 1919,
  [1926] = 1901,
  [1927] = 1909,
  [1928] = 1864,
  [1929] = 1864,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1909,
  [1933] = 1933,
  [1934] = 1909,
  [1935] = 1935,
  [1936] = 1909,
  [1937] = 1864,
  [1938] = 1938,
  [1939] = 1939,
  [1940] = 1940,
  [1941] = 1941,
  [1942] = 1914,
  [1943] = 1901,
  [1944] = 1944,
  [1945] = 1941,
  [1946] = 1946,
  [1947] = 1947,
  [1948] = 1941,
  [1949] = 1931,
  [1950] = 1901,
  [1951] = 1941,
  [1952] = 1931,
  [1953] = 1864,
  [1954] = 1947,
  [1955] = 1108,
  [1956] = 1082,
  [1957] = 1901,
  [1958] = 1864,
  [1959] = 1940,
  [1960] = 1914,
  [1961] = 1944,
  [1962] = 1939,
  [1963] = 1941,
  [1964] = 1964,
  [1965] = 1901,
  [1966] = 1966,
  [1967] = 1901,
  [1968] = 1964,
  [1969] = 1933,
  [1970] = 1930,
  [1971] = 969,
  [1972] = 1931,
  [1973] = 1939,
  [1974] = 1947,
  [1975] = 1975,
  [1976] = 1947,
  [1977] = 1939,
  [1978] = 1978,
  [1979] = 1979,
  [1980] = 973,
  [1981] = 1864,
  [1982] = 1874,
  [1983] = 1042,
  [1984] = 1979,
  [1985] = 1964,
  [1986] = 1914,
  [1987] = 1979,
  [1988] = 1051,
  [1989] = 1939,
  [1990] = 1964,
  [1991] = 1991,
  [1992] = 1979,
  [1993] = 1933,
  [1994] = 1947,
  [1995] = 1857,
  [1996] = 1900,
  [1997] = 950,
  [1998] = 1916,
  [1999] = 924,
  [2000] = 1930,
  [2001] = 1930,
  [2002] = 1975,
  [2003] = 1879,
  [2004] = 1933,
  [2005] = 1939,
  [2006] = 1964,
  [2007] = 2007,
  [2008] = 1876,
  [2009] = 1979,
  [2010] = 1901,
  [2011] = 1853,
  [2012] = 2012,
  [2013] = 1900,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 1854,
  [2017] = 1877,
  [2018] = 1947,
  [2019] = 1931,
  [2020] = 2020,
  [2021] = 1931,
  [2022] = 1864,
  [2023] = 1947,
  [2024] = 1931,
  [2025] = 2025,
  [2026] = 1900,
  [2027] = 2027,
  [2028] = 2028,
  [2029] = 1931,
  [2030] = 2028,
  [2031] = 1938,
  [2032] = 1910,
  [2033] = 2033,
  [2034] = 1901,
  [2035] = 2028,
  [2036] = 1939,
  [2037] = 2028,
  [2038] = 1900,
  [2039] = 1947,
  [2040] = 1939,
  [2041] = 2028,
  [2042] = 2028,
  [2043] = 1931,
  [2044] = 1919,
  [2045] = 1900,
  [2046] = 1939,
  [2047] = 1939,
  [2048] = 2048,
  [2049] = 2048,
  [2050] = 2048,
  [2051] = 1930,
  [2052] = 2048,
  [2053] = 2048,
  [2054] = 2048,
  [2055] = 1931,
  [2056] = 1947,
  [2057] = 2048,
  [2058] = 1947,
  [2059] = 1939,
  [2060] = 1915,
  [2061] = 1939,
  [2062] = 1933,
  [2063] = 2063,
  [2064] = 1947,
  [2065] = 1947,
  [2066] = 2066,
  [2067] = 2067,
  [2068] = 2048,
  [2069] = 2048,
  [2070] = 2070,
  [2071] = 1947,
  [2072] = 1900,
  [2073] = 1916,
  [2074] = 1939,
  [2075] = 1939,
  [2076] = 1940,
  [2077] = 1939,
  [2078] = 1947,
  [2079] = 1939,
  [2080] = 1991,
  [2081] = 1947,
  [2082] = 2020,
  [2083] = 1947,
  [2084] = 1900,
  [2085] = 2085,
  [2086] = 2086,
  [2087] = 1900,
  [2088] = 2086,
  [2089] = 2089,
  [2090] = 2090,
  [2091] = 1939,
  [2092] = 2089,
  [2093] = 1947,
  [2094] = 2085,
  [2095] = 2095,
  [2096] = 2085,
  [2097] = 2095,
  [2098] = 2089,
  [2099] = 2085,
  [2100] = 2086,
  [2101] = 2086,
  [2102] = 2085,
  [2103] = 2095,
  [2104] = 2090,
  [2105] = 2090,
  [2106] = 2090,
  [2107] = 2089,
  [2108] = 2089,
  [2109] = 2085,
  [2110] = 2086,
  [2111] = 1938,
  [2112] = 1900,
  [2113] = 2090,
  [2114] = 2089,
  [2115] = 2086,
  [2116] = 2086,
  [2117] = 2095,
  [2118] = 2085,
  [2119] = 2090,
  [2120] = 2095,
  [2121] = 2089,
  [2122] = 2086,
  [2123] = 2095,
  [2124] = 2086,
  [2125] = 2090,
  [2126] = 2025,
  [2127] = 2095,
  [2128] = 2085,
  [2129] = 2089,
  [2130] = 2090,
  [2131] = 2095,
  [2132] = 2089,
  [2133] = 2090,
  [2134] = 2085,
  [2135] = 2095,
  [2136] = 2136,
  [2137] = 2136,
  [2138] = 2136,
  [2139] = 2136,
  [2140] = 2136,
  [2141] = 2136,
  [2142] = 2136,
  [2143] = 2136,
  [2144] = 2136,
  [2145] = 2145,
  [2146] = 2146,
  [2147] = 2145,
  [2148] = 2145,
  [2149] = 2145,
  [2150] = 2145,
  [2151] = 2145,
  [2152] = 2145,
  [2153] = 2145,
  [2154] = 2145,
  [2155] = 2155,
  [2156] = 2155,
  [2157] = 2155,
  [2158] = 2155,
  [2159] = 2155,
  [2160] = 2160,
  [2161] = 2161,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 2161,
  [2165] = 2163,
  [2166] = 2162,
  [2167] = 2161,
  [2168] = 2163,
  [2169] = 2161,
  [2170] = 2161,
  [2171] = 2162,
  [2172] = 2161,
  [2173] = 2161,
  [2174] = 2163,
  [2175] = 2162,
  [2176] = 2163,
  [2177] = 2163,
  [2178] = 2161,
  [2179] = 2161,
  [2180] = 2163,
  [2181] = 2161,
  [2182] = 2162,
  [2183] = 2163,
  [2184] = 2163,
  [2185] = 2163,
  [2186] = 2161,
  [2187] = 2161,
  [2188] = 2163,
  [2189] = 2161,
  [2190] = 2162,
  [2191] = 2163,
  [2192] = 2163,
  [2193] = 2163,
  [2194] = 2162,
  [2195] = 2161,
  [2196] = 2163,
  [2197] = 2161,
  [2198] = 2161,
  [2199] = 2163,
  [2200] = 2200,
  [2201] = 324,
  [2202] = 2202,
  [2203] = 339,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2012,
  [2212] = 2212,
  [2213] = 339,
  [2214] = 2214,
  [2215] = 2215,
  [2216] = 292,
  [2217] = 293,
  [2218] = 2218,
  [2219] = 324,
  [2220] = 2220,
  [2221] = 291,
  [2222] = 2222,
  [2223] = 2007,
  [2224] = 2015,
  [2225] = 2225,
  [2226] = 294,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2230,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2230,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2230,
  [2243] = 1031,
  [2244] = 2244,
  [2245] = 333,
  [2246] = 2246,
  [2247] = 335,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 1040,
  [2275] = 2230,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 338,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 1036,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2299,
  [2313] = 1037,
  [2314] = 1038,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2230,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2230,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 291,
  [2346] = 293,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 2353,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 292,
  [2367] = 2367,
  [2368] = 2230,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2230,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 2299,
  [2377] = 2299,
  [2378] = 2378,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2299,
  [2382] = 2382,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 305,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2311,
  [2393] = 2393,
  [2394] = 314,
  [2395] = 2395,
  [2396] = 2396,
  [2397] = 2397,
  [2398] = 2358,
  [2399] = 2399,
  [2400] = 2317,
  [2401] = 2205,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2395,
  [2407] = 2352,
  [2408] = 2316,
  [2409] = 2395,
  [2410] = 2238,
  [2411] = 2393,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2355,
  [2416] = 2416,
  [2417] = 2402,
  [2418] = 2418,
  [2419] = 314,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2350,
  [2423] = 2231,
  [2424] = 2424,
  [2425] = 2425,
  [2426] = 2426,
  [2427] = 2427,
  [2428] = 2402,
  [2429] = 2412,
  [2430] = 2430,
  [2431] = 2343,
  [2432] = 2432,
  [2433] = 2248,
  [2434] = 2393,
  [2435] = 2435,
  [2436] = 2436,
  [2437] = 2272,
  [2438] = 2438,
  [2439] = 2315,
  [2440] = 335,
  [2441] = 2441,
  [2442] = 2442,
  [2443] = 333,
  [2444] = 2444,
  [2445] = 2445,
  [2446] = 2446,
  [2447] = 2319,
  [2448] = 2416,
  [2449] = 2449,
  [2450] = 2450,
  [2451] = 2451,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2454,
  [2455] = 2455,
  [2456] = 2307,
  [2457] = 2457,
  [2458] = 2458,
  [2459] = 319,
  [2460] = 319,
  [2461] = 2367,
  [2462] = 2462,
  [2463] = 2322,
  [2464] = 2357,
  [2465] = 2465,
  [2466] = 2412,
  [2467] = 2402,
  [2468] = 2468,
  [2469] = 2469,
  [2470] = 2206,
  [2471] = 2319,
  [2472] = 2472,
  [2473] = 2473,
  [2474] = 2465,
  [2475] = 2475,
  [2476] = 2207,
  [2477] = 2477,
  [2478] = 2416,
  [2479] = 2416,
  [2480] = 2480,
  [2481] = 2481,
  [2482] = 2356,
  [2483] = 2311,
  [2484] = 2484,
  [2485] = 2358,
  [2486] = 2356,
  [2487] = 2209,
  [2488] = 2204,
  [2489] = 310,
  [2490] = 2490,
  [2491] = 2307,
  [2492] = 2352,
  [2493] = 2493,
  [2494] = 2350,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2343,
  [2499] = 2241,
  [2500] = 338,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2249,
  [2504] = 2246,
  [2505] = 2416,
  [2506] = 2355,
  [2507] = 2395,
  [2508] = 2508,
  [2509] = 2367,
  [2510] = 2393,
  [2511] = 2309,
  [2512] = 2512,
  [2513] = 2513,
  [2514] = 342,
  [2515] = 2515,
  [2516] = 2233,
  [2517] = 2517,
  [2518] = 2232,
  [2519] = 2232,
  [2520] = 2322,
  [2521] = 2521,
  [2522] = 2522,
  [2523] = 2523,
  [2524] = 2233,
  [2525] = 310,
  [2526] = 2526,
  [2527] = 2375,
  [2528] = 2328,
  [2529] = 2529,
  [2530] = 2330,
  [2531] = 2531,
  [2532] = 331,
  [2533] = 2357,
  [2534] = 2246,
  [2535] = 321,
  [2536] = 2241,
  [2537] = 2309,
  [2538] = 2248,
  [2539] = 2249,
  [2540] = 321,
  [2541] = 2541,
  [2542] = 2341,
  [2543] = 342,
  [2544] = 305,
  [2545] = 2545,
  [2546] = 2416,
  [2547] = 2547,
  [2548] = 2548,
  [2549] = 331,
  [2550] = 2550,
  [2551] = 2393,
  [2552] = 2490,
  [2553] = 2484,
  [2554] = 2554,
  [2555] = 2315,
  [2556] = 2316,
  [2557] = 2238,
  [2558] = 2558,
  [2559] = 2317,
  [2560] = 2560,
  [2561] = 2561,
  [2562] = 2341,
  [2563] = 2272,
  [2564] = 2330,
  [2565] = 2565,
  [2566] = 2566,
  [2567] = 2395,
  [2568] = 2568,
  [2569] = 2231,
  [2570] = 2570,
  [2571] = 2328,
  [2572] = 2572,
  [2573] = 2412,
  [2574] = 2375,
  [2575] = 2402,
  [2576] = 2412,
  [2577] = 2577,
  [2578] = 2379,
  [2579] = 2579,
  [2580] = 2580,
  [2581] = 2581,
  [2582] = 2484,
  [2583] = 2465,
  [2584] = 2309,
  [2585] = 2585,
  [2586] = 2241,
  [2587] = 2587,
  [2588] = 2588,
  [2589] = 2589,
  [2590] = 2222,
  [2591] = 2581,
  [2592] = 2592,
  [2593] = 2210,
  [2594] = 2212,
  [2595] = 2595,
  [2596] = 2596,
  [2597] = 2597,
  [2598] = 2225,
  [2599] = 2311,
  [2600] = 2561,
  [2601] = 2601,
  [2602] = 2007,
  [2603] = 2355,
  [2604] = 2589,
  [2605] = 2383,
  [2606] = 2561,
  [2607] = 2589,
  [2608] = 2358,
  [2609] = 2356,
  [2610] = 2589,
  [2611] = 2352,
  [2612] = 2350,
  [2613] = 2343,
  [2614] = 2248,
  [2615] = 2238,
  [2616] = 2231,
  [2617] = 2272,
  [2618] = 2310,
  [2619] = 2379,
  [2620] = 2215,
  [2621] = 2621,
  [2622] = 2581,
  [2623] = 2577,
  [2624] = 2624,
  [2625] = 2595,
  [2626] = 2601,
  [2627] = 2220,
  [2628] = 2628,
  [2629] = 2601,
  [2630] = 2630,
  [2631] = 2631,
  [2632] = 2632,
  [2633] = 2595,
  [2634] = 2581,
  [2635] = 2635,
  [2636] = 2490,
  [2637] = 2637,
  [2638] = 2589,
  [2639] = 2015,
  [2640] = 2640,
  [2641] = 2641,
  [2642] = 2012,
  [2643] = 2595,
  [2644] = 2367,
  [2645] = 2322,
  [2646] = 2595,
  [2647] = 2357,
  [2648] = 2648,
  [2649] = 2333,
  [2650] = 2632,
  [2651] = 2651,
  [2652] = 2341,
  [2653] = 2653,
  [2654] = 2581,
  [2655] = 2655,
  [2656] = 2595,
  [2657] = 2630,
  [2658] = 2330,
  [2659] = 2383,
  [2660] = 2218,
  [2661] = 2601,
  [2662] = 2214,
  [2663] = 2379,
  [2664] = 2383,
  [2665] = 2648,
  [2666] = 2328,
  [2667] = 2246,
  [2668] = 2375,
  [2669] = 2249,
  [2670] = 2641,
  [2671] = 2233,
  [2672] = 2307,
  [2673] = 2319,
  [2674] = 2317,
  [2675] = 2232,
  [2676] = 2316,
  [2677] = 2315,
  [2678] = 2678,
  [2679] = 2601,
  [2680] = 2680,
  [2681] = 2595,
  [2682] = 2572,
  [2683] = 2260,
  [2684] = 2288,
  [2685] = 2290,
  [2686] = 2291,
  [2687] = 2294,
  [2688] = 2297,
  [2689] = 2298,
  [2690] = 2301,
  [2691] = 2302,
  [2692] = 1038,
  [2693] = 2305,
  [2694] = 2308,
  [2695] = 2695,
  [2696] = 2490,
  [2697] = 2572,
  [2698] = 2585,
  [2699] = 2699,
  [2700] = 2570,
  [2701] = 2413,
  [2702] = 2332,
  [2703] = 2329,
  [2704] = 2704,
  [2705] = 2304,
  [2706] = 2292,
  [2707] = 2289,
  [2708] = 2383,
  [2709] = 2286,
  [2710] = 2378,
  [2711] = 2413,
  [2712] = 2285,
  [2713] = 2570,
  [2714] = 2307,
  [2715] = 2284,
  [2716] = 2716,
  [2717] = 2369,
  [2718] = 2365,
  [2719] = 2370,
  [2720] = 2363,
  [2721] = 2359,
  [2722] = 2351,
  [2723] = 2348,
  [2724] = 2724,
  [2725] = 2347,
  [2726] = 2374,
  [2727] = 2727,
  [2728] = 2283,
  [2729] = 2342,
  [2730] = 2340,
  [2731] = 2335,
  [2732] = 2334,
  [2733] = 1037,
  [2734] = 2282,
  [2735] = 2331,
  [2736] = 2326,
  [2737] = 2325,
  [2738] = 2324,
  [2739] = 294,
  [2740] = 2740,
  [2741] = 2740,
  [2742] = 2236,
  [2743] = 2280,
  [2744] = 2585,
  [2745] = 2745,
  [2746] = 2570,
  [2747] = 2278,
  [2748] = 2370,
  [2749] = 2277,
  [2750] = 2273,
  [2751] = 2695,
  [2752] = 2386,
  [2753] = 2338,
  [2754] = 2339,
  [2755] = 2755,
  [2756] = 2385,
  [2757] = 2757,
  [2758] = 2241,
  [2759] = 2309,
  [2760] = 2355,
  [2761] = 2367,
  [2762] = 2322,
  [2763] = 2384,
  [2764] = 2764,
  [2765] = 2357,
  [2766] = 2341,
  [2767] = 2767,
  [2768] = 2330,
  [2769] = 2268,
  [2770] = 2328,
  [2771] = 2375,
  [2772] = 2267,
  [2773] = 2319,
  [2774] = 2266,
  [2775] = 1040,
  [2776] = 2317,
  [2777] = 2265,
  [2778] = 2316,
  [2779] = 2757,
  [2780] = 2780,
  [2781] = 2264,
  [2782] = 2695,
  [2783] = 2379,
  [2784] = 2241,
  [2785] = 2309,
  [2786] = 2355,
  [2787] = 2364,
  [2788] = 2362,
  [2789] = 2367,
  [2790] = 2322,
  [2791] = 2357,
  [2792] = 2792,
  [2793] = 2248,
  [2794] = 2361,
  [2795] = 2341,
  [2796] = 2262,
  [2797] = 2330,
  [2798] = 2328,
  [2799] = 2287,
  [2800] = 2375,
  [2801] = 2307,
  [2802] = 2319,
  [2803] = 2317,
  [2804] = 2316,
  [2805] = 2805,
  [2806] = 2315,
  [2807] = 1036,
  [2808] = 2310,
  [2809] = 2315,
  [2810] = 2232,
  [2811] = 2232,
  [2812] = 2233,
  [2813] = 2327,
  [2814] = 2246,
  [2815] = 2233,
  [2816] = 2246,
  [2817] = 2249,
  [2818] = 2258,
  [2819] = 2257,
  [2820] = 2256,
  [2821] = 2343,
  [2822] = 2350,
  [2823] = 2352,
  [2824] = 2740,
  [2825] = 2249,
  [2826] = 2356,
  [2827] = 2358,
  [2828] = 2740,
  [2829] = 2255,
  [2830] = 2704,
  [2831] = 2343,
  [2832] = 2251,
  [2833] = 2350,
  [2834] = 2352,
  [2835] = 2740,
  [2836] = 2695,
  [2837] = 2311,
  [2838] = 2413,
  [2839] = 2356,
  [2840] = 2303,
  [2841] = 2271,
  [2842] = 2704,
  [2843] = 2704,
  [2844] = 2296,
  [2845] = 2295,
  [2846] = 2281,
  [2847] = 2279,
  [2848] = 2276,
  [2849] = 2270,
  [2850] = 2378,
  [2851] = 2269,
  [2852] = 2240,
  [2853] = 2237,
  [2854] = 2227,
  [2855] = 2349,
  [2856] = 2263,
  [2857] = 2261,
  [2858] = 2254,
  [2859] = 2253,
  [2860] = 2358,
  [2861] = 2311,
  [2862] = 2680,
  [2863] = 2863,
  [2864] = 2353,
  [2865] = 2252,
  [2866] = 2250,
  [2867] = 2306,
  [2868] = 2372,
  [2869] = 2382,
  [2870] = 2354,
  [2871] = 2360,
  [2872] = 2344,
  [2873] = 2337,
  [2874] = 2272,
  [2875] = 2383,
  [2876] = 2231,
  [2877] = 2572,
  [2878] = 2238,
  [2879] = 2379,
  [2880] = 2336,
  [2881] = 2235,
  [2882] = 2740,
  [2883] = 2248,
  [2884] = 2310,
  [2885] = 2244,
  [2886] = 2259,
  [2887] = 294,
  [2888] = 2229,
  [2889] = 2889,
  [2890] = 2318,
  [2891] = 2680,
  [2892] = 2321,
  [2893] = 2863,
  [2894] = 2894,
  [2895] = 2695,
  [2896] = 2896,
  [2897] = 2373,
  [2898] = 2228,
  [2899] = 2380,
  [2900] = 2272,
  [2901] = 2901,
  [2902] = 2695,
  [2903] = 2903,
  [2904] = 2704,
  [2905] = 2704,
  [2906] = 2231,
  [2907] = 2907,
  [2908] = 2383,
  [2909] = 2484,
  [2910] = 2910,
  [2911] = 2911,
  [2912] = 2238,
  [2913] = 2704,
  [2914] = 1031,
  [2915] = 2379,
  [2916] = 2465,
  [2917] = 2917,
  [2918] = 2413,
  [2919] = 2919,
  [2920] = 2920,
  [2921] = 2921,
  [2922] = 327,
  [2923] = 2923,
  [2924] = 2640,
  [2925] = 2495,
  [2926] = 2926,
  [2927] = 2927,
  [2928] = 328,
  [2929] = 296,
  [2930] = 2358,
  [2931] = 2370,
  [2932] = 2566,
  [2933] = 2565,
  [2934] = 2356,
  [2935] = 2919,
  [2936] = 337,
  [2937] = 340,
  [2938] = 2938,
  [2939] = 2939,
  [2940] = 2547,
  [2941] = 2352,
  [2942] = 2942,
  [2943] = 2350,
  [2944] = 2475,
  [2945] = 2343,
  [2946] = 2919,
  [2947] = 2926,
  [2948] = 2370,
  [2949] = 2949,
  [2950] = 2950,
  [2951] = 2919,
  [2952] = 2952,
  [2953] = 2953,
  [2954] = 2954,
  [2955] = 2955,
  [2956] = 2956,
  [2957] = 2432,
  [2958] = 2311,
  [2959] = 2959,
  [2960] = 2493,
  [2961] = 2961,
  [2962] = 2962,
  [2963] = 2963,
  [2964] = 2964,
  [2965] = 2965,
  [2966] = 2462,
  [2967] = 2473,
  [2968] = 2457,
  [2969] = 2453,
  [2970] = 2523,
  [2971] = 2952,
  [2972] = 2445,
  [2973] = 303,
  [2974] = 2926,
  [2975] = 2444,
  [2976] = 2976,
  [2977] = 2442,
  [2978] = 2441,
  [2979] = 2640,
  [2980] = 2980,
  [2981] = 2413,
  [2982] = 2568,
  [2983] = 2438,
  [2984] = 2378,
  [2985] = 2435,
  [2986] = 2426,
  [2987] = 2425,
  [2988] = 2988,
  [2989] = 2424,
  [2990] = 2990,
  [2991] = 332,
  [2992] = 2950,
  [2993] = 2911,
  [2994] = 330,
  [2995] = 2995,
  [2996] = 329,
  [2997] = 2997,
  [2998] = 2404,
  [2999] = 320,
  [3000] = 312,
  [3001] = 311,
  [3002] = 3002,
  [3003] = 2272,
  [3004] = 2231,
  [3005] = 2585,
  [3006] = 2238,
  [3007] = 2403,
  [3008] = 2397,
  [3009] = 2248,
  [3010] = 2919,
  [3011] = 2926,
  [3012] = 2640,
  [3013] = 3013,
  [3014] = 3014,
  [3015] = 2396,
  [3016] = 2391,
  [3017] = 2446,
  [3018] = 2920,
  [3019] = 3019,
  [3020] = 2911,
  [3021] = 330,
  [3022] = 2420,
  [3023] = 332,
  [3024] = 2421,
  [3025] = 2512,
  [3026] = 3002,
  [3027] = 3027,
  [3028] = 2427,
  [3029] = 2952,
  [3030] = 3030,
  [3031] = 2399,
  [3032] = 2249,
  [3033] = 2246,
  [3034] = 2233,
  [3035] = 2430,
  [3036] = 2414,
  [3037] = 2232,
  [3038] = 2561,
  [3039] = 2513,
  [3040] = 315,
  [3041] = 2585,
  [3042] = 2450,
  [3043] = 2451,
  [3044] = 2452,
  [3045] = 2454,
  [3046] = 2926,
  [3047] = 311,
  [3048] = 2919,
  [3049] = 3049,
  [3050] = 2572,
  [3051] = 2383,
  [3052] = 2315,
  [3053] = 2496,
  [3054] = 312,
  [3055] = 2316,
  [3056] = 2317,
  [3057] = 2529,
  [3058] = 2526,
  [3059] = 2522,
  [3060] = 2521,
  [3061] = 3014,
  [3062] = 2515,
  [3063] = 337,
  [3064] = 3064,
  [3065] = 2405,
  [3066] = 2319,
  [3067] = 2497,
  [3068] = 2952,
  [3069] = 2501,
  [3070] = 2307,
  [3071] = 2375,
  [3072] = 2449,
  [3073] = 2502,
  [3074] = 3074,
  [3075] = 2508,
  [3076] = 2490,
  [3077] = 2953,
  [3078] = 2952,
  [3079] = 2328,
  [3080] = 2330,
  [3081] = 3081,
  [3082] = 3082,
  [3083] = 2341,
  [3084] = 2952,
  [3085] = 2541,
  [3086] = 3086,
  [3087] = 2545,
  [3088] = 2585,
  [3089] = 2680,
  [3090] = 2248,
  [3091] = 2357,
  [3092] = 2322,
  [3093] = 2241,
  [3094] = 2436,
  [3095] = 2367,
  [3096] = 3096,
  [3097] = 2418,
  [3098] = 3098,
  [3099] = 2309,
  [3100] = 2238,
  [3101] = 2355,
  [3102] = 2388,
  [3103] = 2481,
  [3104] = 2367,
  [3105] = 2480,
  [3106] = 2322,
  [3107] = 2357,
  [3108] = 2341,
  [3109] = 2330,
  [3110] = 2328,
  [3111] = 327,
  [3112] = 2389,
  [3113] = 2375,
  [3114] = 2307,
  [3115] = 2319,
  [3116] = 2231,
  [3117] = 3117,
  [3118] = 2458,
  [3119] = 2952,
  [3120] = 2317,
  [3121] = 3086,
  [3122] = 2316,
  [3123] = 2272,
  [3124] = 2311,
  [3125] = 3125,
  [3126] = 2358,
  [3127] = 3127,
  [3128] = 2356,
  [3129] = 2315,
  [3130] = 2952,
  [3131] = 2232,
  [3132] = 2352,
  [3133] = 2233,
  [3134] = 2246,
  [3135] = 2926,
  [3136] = 3136,
  [3137] = 2952,
  [3138] = 3138,
  [3139] = 303,
  [3140] = 2560,
  [3141] = 3141,
  [3142] = 3142,
  [3143] = 2558,
  [3144] = 2355,
  [3145] = 3145,
  [3146] = 3146,
  [3147] = 3147,
  [3148] = 2554,
  [3149] = 328,
  [3150] = 3150,
  [3151] = 2350,
  [3152] = 2550,
  [3153] = 3027,
  [3154] = 3014,
  [3155] = 3027,
  [3156] = 3156,
  [3157] = 3027,
  [3158] = 3014,
  [3159] = 2249,
  [3160] = 2548,
  [3161] = 3117,
  [3162] = 315,
  [3163] = 2343,
  [3164] = 3027,
  [3165] = 3014,
  [3166] = 2379,
  [3167] = 2531,
  [3168] = 2517,
  [3169] = 2383,
  [3170] = 296,
  [3171] = 340,
  [3172] = 3172,
  [3173] = 2241,
  [3174] = 2309,
  [3175] = 2465,
  [3176] = 2484,
  [3177] = 2919,
  [3178] = 2926,
  [3179] = 3179,
  [3180] = 2572,
  [3181] = 329,
  [3182] = 320,
  [3183] = 2379,
  [3184] = 3184,
  [3185] = 2997,
  [3186] = 2383,
  [3187] = 2352,
  [3188] = 3188,
  [3189] = 2238,
  [3190] = 2585,
  [3191] = 2322,
  [3192] = 2413,
  [3193] = 2379,
  [3194] = 3194,
  [3195] = 2570,
  [3196] = 3196,
  [3197] = 3197,
  [3198] = 3198,
  [3199] = 3199,
  [3200] = 3200,
  [3201] = 3200,
  [3202] = 3202,
  [3203] = 2367,
  [3204] = 3204,
  [3205] = 2355,
  [3206] = 2465,
  [3207] = 2231,
  [3208] = 3208,
  [3209] = 2272,
  [3210] = 2309,
  [3211] = 3198,
  [3212] = 2248,
  [3213] = 2241,
  [3214] = 2357,
  [3215] = 2341,
  [3216] = 2624,
  [3217] = 2585,
  [3218] = 3218,
  [3219] = 2370,
  [3220] = 3220,
  [3221] = 2911,
  [3222] = 3200,
  [3223] = 3223,
  [3224] = 2328,
  [3225] = 3225,
  [3226] = 2378,
  [3227] = 3227,
  [3228] = 2311,
  [3229] = 2375,
  [3230] = 3230,
  [3231] = 2330,
  [3232] = 3232,
  [3233] = 3233,
  [3234] = 3200,
  [3235] = 2307,
  [3236] = 3200,
  [3237] = 2585,
  [3238] = 3196,
  [3239] = 2319,
  [3240] = 3197,
  [3241] = 2317,
  [3242] = 2358,
  [3243] = 2356,
  [3244] = 3244,
  [3245] = 2572,
  [3246] = 2350,
  [3247] = 3200,
  [3248] = 2343,
  [3249] = 3249,
  [3250] = 3250,
  [3251] = 3251,
  [3252] = 3233,
  [3253] = 3253,
  [3254] = 2249,
  [3255] = 3253,
  [3256] = 2246,
  [3257] = 3257,
  [3258] = 2233,
  [3259] = 2232,
  [3260] = 2315,
  [3261] = 2310,
  [3262] = 2570,
  [3263] = 3200,
  [3264] = 2316,
  [3265] = 3265,
  [3266] = 3266,
  [3267] = 3267,
  [3268] = 3268,
  [3269] = 3269,
  [3270] = 3270,
  [3271] = 2490,
  [3272] = 2370,
  [3273] = 2465,
  [3274] = 3274,
  [3275] = 2484,
  [3276] = 3276,
  [3277] = 3277,
  [3278] = 3278,
  [3279] = 3279,
  [3280] = 3280,
  [3281] = 3281,
  [3282] = 3282,
  [3283] = 3283,
  [3284] = 3284,
  [3285] = 2370,
  [3286] = 2640,
  [3287] = 2570,
  [3288] = 3288,
  [3289] = 3289,
  [3290] = 2572,
  [3291] = 3291,
  [3292] = 2648,
  [3293] = 3293,
  [3294] = 3294,
  [3295] = 3295,
  [3296] = 3296,
  [3297] = 3297,
  [3298] = 2585,
  [3299] = 3299,
  [3300] = 3300,
  [3301] = 2310,
  [3302] = 3302,
  [3303] = 2413,
  [3304] = 3304,
  [3305] = 2570,
  [3306] = 3306,
  [3307] = 3014,
  [3308] = 2954,
  [3309] = 3027,
  [3310] = 3014,
  [3311] = 3027,
  [3312] = 3014,
  [3313] = 3014,
  [3314] = 2220,
  [3315] = 3315,
  [3316] = 3027,
  [3317] = 3317,
  [3318] = 3318,
  [3319] = 3027,
  [3320] = 3320,
  [3321] = 3321,
  [3322] = 3322,
  [3323] = 2370,
  [3324] = 3324,
  [3325] = 3014,
  [3326] = 2490,
  [3327] = 3027,
  [3328] = 3328,
  [3329] = 3329,
  [3330] = 3014,
  [3331] = 2465,
  [3332] = 3332,
  [3333] = 2484,
  [3334] = 3027,
  [3335] = 3335,
  [3336] = 3014,
  [3337] = 3337,
  [3338] = 3266,
  [3339] = 2370,
  [3340] = 3340,
  [3341] = 3341,
  [3342] = 2911,
  [3343] = 3343,
  [3344] = 3344,
  [3345] = 3345,
  [3346] = 3346,
  [3347] = 3027,
  [3348] = 3348,
  [3349] = 3349,
  [3350] = 3349,
  [3351] = 3349,
  [3352] = 3349,
  [3353] = 3353,
  [3354] = 3349,
  [3355] = 3349,
  [3356] = 3349,
  [3357] = 3349,
  [3358] = 3349,
  [3359] = 3359,
  [3360] = 3360,
  [3361] = 3361,
  [3362] = 3362,
  [3363] = 3363,
  [3364] = 3364,
  [3365] = 3365,
  [3366] = 3366,
  [3367] = 3367,
  [3368] = 3368,
  [3369] = 3369,
  [3370] = 3370,
  [3371] = 3371,
  [3372] = 3372,
  [3373] = 3373,
  [3374] = 3374,
  [3375] = 3375,
  [3376] = 331,
  [3377] = 3377,
  [3378] = 3378,
  [3379] = 342,
  [3380] = 3380,
  [3381] = 3381,
  [3382] = 3382,
  [3383] = 3383,
  [3384] = 3384,
  [3385] = 3385,
  [3386] = 3386,
  [3387] = 3387,
  [3388] = 3388,
  [3389] = 3389,
  [3390] = 3390,
  [3391] = 3391,
  [3392] = 3268,
  [3393] = 305,
  [3394] = 3394,
  [3395] = 3269,
  [3396] = 3396,
  [3397] = 3397,
  [3398] = 3398,
  [3399] = 3399,
  [3400] = 3400,
  [3401] = 338,
  [3402] = 3402,
  [3403] = 305,
  [3404] = 3404,
  [3405] = 3405,
  [3406] = 3406,
  [3407] = 3407,
  [3408] = 3408,
  [3409] = 3409,
  [3410] = 3410,
  [3411] = 338,
  [3412] = 3412,
  [3413] = 3413,
  [3414] = 3414,
  [3415] = 3415,
  [3416] = 3416,
  [3417] = 3417,
  [3418] = 3418,
  [3419] = 3419,
  [3420] = 3420,
  [3421] = 3421,
  [3422] = 3064,
  [3423] = 342,
  [3424] = 331,
  [3425] = 3425,
  [3426] = 2990,
  [3427] = 3427,
  [3428] = 3125,
  [3429] = 3429,
  [3430] = 3430,
  [3431] = 3431,
  [3432] = 3156,
  [3433] = 3433,
  [3434] = 3196,
  [3435] = 3435,
  [3436] = 3436,
  [3437] = 3435,
  [3438] = 3249,
  [3439] = 3197,
  [3440] = 3440,
  [3441] = 3204,
  [3442] = 3257,
  [3443] = 3220,
  [3444] = 1907,
  [3445] = 3249,
  [3446] = 3446,
  [3447] = 3447,
  [3448] = 3198,
  [3449] = 3225,
  [3450] = 3198,
  [3451] = 3196,
  [3452] = 3233,
  [3453] = 3225,
  [3454] = 3230,
  [3455] = 3244,
  [3456] = 3197,
  [3457] = 3232,
  [3458] = 3447,
  [3459] = 3251,
  [3460] = 3220,
  [3461] = 3257,
  [3462] = 3233,
  [3463] = 3463,
  [3464] = 3464,
  [3465] = 3465,
  [3466] = 3466,
  [3467] = 3467,
  [3468] = 3468,
  [3469] = 3465,
  [3470] = 3464,
  [3471] = 3471,
  [3472] = 3472,
  [3473] = 3473,
  [3474] = 3464,
  [3475] = 3475,
  [3476] = 3475,
  [3477] = 3477,
  [3478] = 3472,
  [3479] = 3465,
  [3480] = 3480,
  [3481] = 3467,
  [3482] = 3471,
  [3483] = 3466,
  [3484] = 3472,
  [3485] = 3465,
  [3486] = 3472,
  [3487] = 3466,
  [3488] = 3464,
  [3489] = 1946,
  [3490] = 3475,
  [3491] = 3475,
  [3492] = 3471,
  [3493] = 3467,
  [3494] = 3494,
  [3495] = 3467,
  [3496] = 1935,
  [3497] = 3497,
  [3498] = 3466,
  [3499] = 3475,
  [3500] = 3471,
  [3501] = 3471,
  [3502] = 3467,
  [3503] = 3464,
  [3504] = 3472,
  [3505] = 3464,
  [3506] = 3472,
  [3507] = 3467,
  [3508] = 3508,
  [3509] = 3471,
  [3510] = 3475,
  [3511] = 3465,
  [3512] = 3465,
  [3513] = 3466,
  [3514] = 3466,
  [3515] = 3515,
  [3516] = 3516,
  [3517] = 3517,
  [3518] = 3518,
  [3519] = 3519,
  [3520] = 3520,
  [3521] = 3521,
  [3522] = 3522,
  [3523] = 3523,
  [3524] = 3524,
  [3525] = 3525,
  [3526] = 3526,
  [3527] = 3527,
  [3528] = 3528,
  [3529] = 3529,
  [3530] = 3530,
  [3531] = 3531,
  [3532] = 3265,
  [3533] = 3533,
  [3534] = 3534,
  [3535] = 3535,
  [3536] = 3536,
  [3537] = 3537,
  [3538] = 3538,
  [3539] = 3539,
  [3540] = 3540,
  [3541] = 3541,
  [3542] = 3536,
  [3543] = 2012,
  [3544] = 3544,
  [3545] = 2007,
  [3546] = 3546,
  [3547] = 3547,
  [3548] = 3548,
  [3549] = 3549,
  [3550] = 3550,
  [3551] = 2015,
  [3552] = 3552,
  [3553] = 3549,
  [3554] = 3554,
  [3555] = 3539,
  [3556] = 3556,
  [3557] = 2014,
  [3558] = 3558,
  [3559] = 3538,
  [3560] = 3560,
  [3561] = 3561,
  [3562] = 3562,
  [3563] = 3563,
  [3564] = 3564,
  [3565] = 3552,
  [3566] = 3566,
  [3567] = 3567,
  [3568] = 3568,
  [3569] = 3535,
  [3570] = 3570,
  [3571] = 3571,
  [3572] = 3572,
  [3573] = 3573,
  [3574] = 3574,
  [3575] = 3575,
  [3576] = 3576,
  [3577] = 3577,
  [3578] = 3548,
  [3579] = 3550,
  [3580] = 3580,
  [3581] = 3581,
  [3582] = 3582,
  [3583] = 3583,
  [3584] = 3584,
  [3585] = 3585,
  [3586] = 3586,
  [3587] = 3572,
  [3588] = 3584,
  [3589] = 3556,
  [3590] = 3590,
  [3591] = 3591,
  [3592] = 3560,
  [3593] = 3593,
  [3594] = 1966,
  [3595] = 1978,
  [3596] = 3596,
  [3597] = 2012,
  [3598] = 2204,
  [3599] = 2209,
  [3600] = 2207,
  [3601] = 2015,
  [3602] = 2007,
  [3603] = 339,
  [3604] = 324,
  [3605] = 2264,
  [3606] = 2349,
  [3607] = 2262,
  [3608] = 2206,
  [3609] = 2265,
  [3610] = 2284,
  [3611] = 2266,
  [3612] = 2267,
  [3613] = 2268,
  [3614] = 2285,
  [3615] = 2286,
  [3616] = 2287,
  [3617] = 2327,
  [3618] = 2288,
  [3619] = 2258,
  [3620] = 2257,
  [3621] = 2290,
  [3622] = 2291,
  [3623] = 2294,
  [3624] = 2297,
  [3625] = 2298,
  [3626] = 2260,
  [3627] = 2301,
  [3628] = 2302,
  [3629] = 2344,
  [3630] = 2305,
  [3631] = 2308,
  [3632] = 2360,
  [3633] = 2354,
  [3634] = 2372,
  [3635] = 2306,
  [3636] = 2240,
  [3637] = 2353,
  [3638] = 2237,
  [3639] = 2227,
  [3640] = 3640,
  [3641] = 3640,
  [3642] = 3642,
  [3643] = 3640,
  [3644] = 2210,
  [3645] = 3640,
  [3646] = 3640,
  [3647] = 3642,
  [3648] = 2207,
  [3649] = 2326,
  [3650] = 2364,
  [3651] = 2362,
  [3652] = 2292,
  [3653] = 2304,
  [3654] = 2361,
  [3655] = 2329,
  [3656] = 2250,
  [3657] = 2332,
  [3658] = 1038,
  [3659] = 2334,
  [3660] = 324,
  [3661] = 2289,
  [3662] = 2222,
  [3663] = 2347,
  [3664] = 2348,
  [3665] = 2209,
  [3666] = 2324,
  [3667] = 1036,
  [3668] = 2384,
  [3669] = 1037,
  [3670] = 2385,
  [3671] = 2386,
  [3672] = 2204,
  [3673] = 1031,
  [3674] = 339,
  [3675] = 1040,
  [3676] = 2214,
  [3677] = 2215,
  [3678] = 2225,
  [3679] = 2212,
  [3680] = 2218,
  [3681] = 2228,
  [3682] = 2308,
  [3683] = 2254,
  [3684] = 2277,
  [3685] = 2273,
  [3686] = 2207,
  [3687] = 2209,
  [3688] = 2282,
  [3689] = 2283,
  [3690] = 2303,
  [3691] = 3691,
  [3692] = 2296,
  [3693] = 2295,
  [3694] = 3694,
  [3695] = 3691,
  [3696] = 3696,
  [3697] = 3694,
  [3698] = 3698,
  [3699] = 2281,
  [3700] = 3694,
  [3701] = 2279,
  [3702] = 3702,
  [3703] = 3696,
  [3704] = 3698,
  [3705] = 2261,
  [3706] = 3691,
  [3707] = 2204,
  [3708] = 2280,
  [3709] = 3702,
  [3710] = 2269,
  [3711] = 3702,
  [3712] = 3702,
  [3713] = 2325,
  [3714] = 3702,
  [3715] = 3698,
  [3716] = 3696,
  [3717] = 2253,
  [3718] = 2331,
  [3719] = 2278,
  [3720] = 2335,
  [3721] = 3702,
  [3722] = 2252,
  [3723] = 3696,
  [3724] = 3698,
  [3725] = 2340,
  [3726] = 2342,
  [3727] = 2337,
  [3728] = 2374,
  [3729] = 2263,
  [3730] = 2351,
  [3731] = 2359,
  [3732] = 2363,
  [3733] = 3694,
  [3734] = 2365,
  [3735] = 2369,
  [3736] = 2306,
  [3737] = 2305,
  [3738] = 2302,
  [3739] = 2301,
  [3740] = 2298,
  [3741] = 2297,
  [3742] = 2294,
  [3743] = 2291,
  [3744] = 2290,
  [3745] = 2288,
  [3746] = 2287,
  [3747] = 2286,
  [3748] = 2285,
  [3749] = 2284,
  [3750] = 2244,
  [3751] = 3691,
  [3752] = 2344,
  [3753] = 2259,
  [3754] = 2360,
  [3755] = 2354,
  [3756] = 2372,
  [3757] = 2206,
  [3758] = 2318,
  [3759] = 2321,
  [3760] = 3691,
  [3761] = 3694,
  [3762] = 3698,
  [3763] = 2373,
  [3764] = 2229,
  [3765] = 2380,
  [3766] = 3696,
  [3767] = 2256,
  [3768] = 2255,
  [3769] = 2251,
  [3770] = 3702,
  [3771] = 3702,
  [3772] = 2268,
  [3773] = 2267,
  [3774] = 2266,
  [3775] = 2265,
  [3776] = 2264,
  [3777] = 2262,
  [3778] = 2260,
  [3779] = 2327,
  [3780] = 2258,
  [3781] = 2257,
  [3782] = 3702,
  [3783] = 2336,
  [3784] = 2271,
  [3785] = 2270,
  [3786] = 2276,
  [3787] = 2240,
  [3788] = 2237,
  [3789] = 2227,
  [3790] = 2349,
  [3791] = 2353,
  [3792] = 3792,
  [3793] = 3793,
  [3794] = 3794,
  [3795] = 3795,
  [3796] = 3796,
  [3797] = 3797,
  [3798] = 3798,
  [3799] = 3799,
  [3800] = 3793,
  [3801] = 3801,
  [3802] = 3802,
  [3803] = 3803,
  [3804] = 3793,
  [3805] = 3802,
  [3806] = 3806,
  [3807] = 3807,
  [3808] = 3802,
  [3809] = 3809,
  [3810] = 3810,
  [3811] = 3793,
  [3812] = 3812,
  [3813] = 3813,
  [3814] = 3814,
  [3815] = 3815,
  [3816] = 3801,
  [3817] = 3801,
  [3818] = 3818,
  [3819] = 3819,
  [3820] = 3820,
  [3821] = 2210,
  [3822] = 3802,
  [3823] = 3823,
  [3824] = 3801,
  [3825] = 3825,
  [3826] = 3826,
  [3827] = 3802,
  [3828] = 3828,
  [3829] = 3801,
  [3830] = 3830,
  [3831] = 3831,
  [3832] = 3793,
  [3833] = 3833,
  [3834] = 2258,
  [3835] = 3835,
  [3836] = 2329,
  [3837] = 3837,
  [3838] = 3838,
  [3839] = 3839,
  [3840] = 2332,
  [3841] = 2386,
  [3842] = 3842,
  [3843] = 2385,
  [3844] = 3844,
  [3845] = 2384,
  [3846] = 2015,
  [3847] = 2304,
  [3848] = 2289,
  [3849] = 3835,
  [3850] = 3850,
  [3851] = 2268,
  [3852] = 2267,
  [3853] = 2012,
  [3854] = 2266,
  [3855] = 2265,
  [3856] = 2292,
  [3857] = 3833,
  [3858] = 2264,
  [3859] = 2206,
  [3860] = 2262,
  [3861] = 3861,
  [3862] = 2260,
  [3863] = 3863,
  [3864] = 2327,
  [3865] = 3833,
  [3866] = 2348,
  [3867] = 2257,
  [3868] = 2347,
  [3869] = 2284,
  [3870] = 2344,
  [3871] = 2285,
  [3872] = 3872,
  [3873] = 2286,
  [3874] = 2334,
  [3875] = 2287,
  [3876] = 2288,
  [3877] = 2326,
  [3878] = 3850,
  [3879] = 2324,
  [3880] = 2360,
  [3881] = 2354,
  [3882] = 2222,
  [3883] = 3835,
  [3884] = 3835,
  [3885] = 2372,
  [3886] = 2306,
  [3887] = 2290,
  [3888] = 2353,
  [3889] = 2349,
  [3890] = 2227,
  [3891] = 2291,
  [3892] = 3892,
  [3893] = 3820,
  [3894] = 2294,
  [3895] = 2364,
  [3896] = 2362,
  [3897] = 2237,
  [3898] = 2361,
  [3899] = 2007,
  [3900] = 3833,
  [3901] = 2297,
  [3902] = 2308,
  [3903] = 2305,
  [3904] = 2250,
  [3905] = 2240,
  [3906] = 2302,
  [3907] = 2301,
  [3908] = 2298,
  [3909] = 3909,
  [3910] = 3910,
  [3911] = 3911,
  [3912] = 3912,
  [3913] = 3913,
  [3914] = 3914,
  [3915] = 3915,
  [3916] = 3916,
  [3917] = 3917,
  [3918] = 3918,
  [3919] = 3919,
  [3920] = 3920,
  [3921] = 3921,
  [3922] = 3922,
  [3923] = 3923,
  [3924] = 3924,
  [3925] = 2212,
  [3926] = 3921,
  [3927] = 3927,
  [3928] = 3928,
  [3929] = 3921,
  [3930] = 3915,
  [3931] = 3931,
  [3932] = 3932,
  [3933] = 3933,
  [3934] = 3934,
  [3935] = 3935,
  [3936] = 3912,
  [3937] = 3937,
  [3938] = 2218,
  [3939] = 3915,
  [3940] = 3940,
  [3941] = 3941,
  [3942] = 2210,
  [3943] = 3912,
  [3944] = 3944,
  [3945] = 3945,
  [3946] = 2215,
  [3947] = 3915,
  [3948] = 3948,
  [3949] = 3949,
  [3950] = 3950,
  [3951] = 2225,
  [3952] = 3952,
  [3953] = 3953,
  [3954] = 3912,
  [3955] = 3955,
  [3956] = 3956,
  [3957] = 2214,
  [3958] = 3958,
  [3959] = 3959,
  [3960] = 3960,
  [3961] = 3921,
  [3962] = 3912,
  [3963] = 3963,
  [3964] = 3964,
  [3965] = 3921,
  [3966] = 3966,
  [3967] = 2279,
  [3968] = 2251,
  [3969] = 2256,
  [3970] = 2337,
  [3971] = 2255,
  [3972] = 2283,
  [3973] = 2273,
  [3974] = 2336,
  [3975] = 3975,
  [3976] = 2277,
  [3977] = 1031,
  [3978] = 2278,
  [3979] = 3979,
  [3980] = 3980,
  [3981] = 2250,
  [3982] = 2280,
  [3983] = 2012,
  [3984] = 1038,
  [3985] = 2229,
  [3986] = 2282,
  [3987] = 2222,
  [3988] = 2369,
  [3989] = 2244,
  [3990] = 2365,
  [3991] = 2259,
  [3992] = 2318,
  [3993] = 2321,
  [3994] = 2270,
  [3995] = 2271,
  [3996] = 2373,
  [3997] = 2228,
  [3998] = 1040,
  [3999] = 2380,
  [4000] = 2363,
  [4001] = 2334,
  [4002] = 2348,
  [4003] = 4003,
  [4004] = 2347,
  [4005] = 2359,
  [4006] = 2252,
  [4007] = 2326,
  [4008] = 2007,
  [4009] = 2324,
  [4010] = 2351,
  [4011] = 1037,
  [4012] = 2253,
  [4013] = 2254,
  [4014] = 2261,
  [4015] = 2263,
  [4016] = 2269,
  [4017] = 1036,
  [4018] = 2374,
  [4019] = 2281,
  [4020] = 2295,
  [4021] = 2296,
  [4022] = 2276,
  [4023] = 2303,
  [4024] = 2342,
  [4025] = 2325,
  [4026] = 2331,
  [4027] = 2015,
  [4028] = 2335,
  [4029] = 2340,
  [4030] = 4030,
  [4031] = 3820,
  [4032] = 4032,
  [4033] = 2218,
  [4034] = 4034,
  [4035] = 4035,
  [4036] = 4036,
  [4037] = 4037,
  [4038] = 4032,
  [4039] = 4039,
  [4040] = 4040,
  [4041] = 4041,
  [4042] = 4037,
  [4043] = 4043,
  [4044] = 2225,
  [4045] = 4037,
  [4046] = 4034,
  [4047] = 4047,
  [4048] = 4048,
  [4049] = 4049,
  [4050] = 2212,
  [4051] = 4051,
  [4052] = 4032,
  [4053] = 2214,
  [4054] = 4034,
  [4055] = 4055,
  [4056] = 4032,
  [4057] = 4037,
  [4058] = 4058,
  [4059] = 4049,
  [4060] = 4032,
  [4061] = 4036,
  [4062] = 4032,
  [4063] = 4034,
  [4064] = 4064,
  [4065] = 4034,
  [4066] = 4034,
  [4067] = 2215,
  [4068] = 4068,
  [4069] = 2280,
  [4070] = 4070,
  [4071] = 4071,
  [4072] = 4072,
  [4073] = 4073,
  [4074] = 3921,
  [4075] = 4075,
  [4076] = 4076,
  [4077] = 4077,
  [4078] = 2276,
  [4079] = 4079,
  [4080] = 4080,
  [4081] = 4081,
  [4082] = 4082,
  [4083] = 4083,
  [4084] = 4084,
  [4085] = 4085,
  [4086] = 4086,
  [4087] = 4083,
  [4088] = 4088,
  [4089] = 4084,
  [4090] = 4090,
  [4091] = 324,
  [4092] = 4092,
  [4093] = 2303,
  [4094] = 4094,
  [4095] = 2369,
  [4096] = 4096,
  [4097] = 2365,
  [4098] = 4096,
  [4099] = 2363,
  [4100] = 2229,
  [4101] = 4101,
  [4102] = 4088,
  [4103] = 2359,
  [4104] = 4073,
  [4105] = 2351,
  [4106] = 4086,
  [4107] = 4088,
  [4108] = 4108,
  [4109] = 4109,
  [4110] = 339,
  [4111] = 4111,
  [4112] = 2374,
  [4113] = 2342,
  [4114] = 4114,
  [4115] = 2361,
  [4116] = 4073,
  [4117] = 4117,
  [4118] = 2340,
  [4119] = 4119,
  [4120] = 4096,
  [4121] = 4121,
  [4122] = 4122,
  [4123] = 4123,
  [4124] = 2335,
  [4125] = 4125,
  [4126] = 4126,
  [4127] = 4127,
  [4128] = 1038,
  [4129] = 2331,
  [4130] = 4096,
  [4131] = 4131,
  [4132] = 4088,
  [4133] = 2325,
  [4134] = 4134,
  [4135] = 1037,
  [4136] = 4073,
  [4137] = 4137,
  [4138] = 1036,
  [4139] = 4086,
  [4140] = 4035,
  [4141] = 4086,
  [4142] = 4127,
  [4143] = 4143,
  [4144] = 4144,
  [4145] = 4108,
  [4146] = 4146,
  [4147] = 4147,
  [4148] = 4111,
  [4149] = 4149,
  [4150] = 4039,
  [4151] = 4114,
  [4152] = 4070,
  [4153] = 4153,
  [4154] = 4119,
  [4155] = 4121,
  [4156] = 4144,
  [4157] = 2270,
  [4158] = 4158,
  [4159] = 4159,
  [4160] = 4160,
  [4161] = 4161,
  [4162] = 2271,
  [4163] = 4127,
  [4164] = 4164,
  [4165] = 4108,
  [4166] = 4166,
  [4167] = 4096,
  [4168] = 4168,
  [4169] = 4088,
  [4170] = 4170,
  [4171] = 4171,
  [4172] = 4172,
  [4173] = 4084,
  [4174] = 4083,
  [4175] = 4073,
  [4176] = 4176,
  [4177] = 4086,
  [4178] = 4178,
  [4179] = 4127,
  [4180] = 2362,
  [4181] = 4108,
  [4182] = 4166,
  [4183] = 4168,
  [4184] = 4171,
  [4185] = 4172,
  [4186] = 4176,
  [4187] = 1031,
  [4188] = 4178,
  [4189] = 4189,
  [4190] = 4190,
  [4191] = 4191,
  [4192] = 1040,
  [4193] = 4146,
  [4194] = 4194,
  [4195] = 4111,
  [4196] = 4196,
  [4197] = 4197,
  [4198] = 4198,
  [4199] = 2283,
  [4200] = 2282,
  [4201] = 4201,
  [4202] = 4202,
  [4203] = 4203,
  [4204] = 4153,
  [4205] = 2278,
  [4206] = 4114,
  [4207] = 4207,
  [4208] = 2277,
  [4209] = 2273,
  [4210] = 4210,
  [4211] = 4108,
  [4212] = 4123,
  [4213] = 3921,
  [4214] = 4166,
  [4215] = 4215,
  [4216] = 4216,
  [4217] = 3921,
  [4218] = 4218,
  [4219] = 4219,
  [4220] = 4220,
  [4221] = 4221,
  [4222] = 4168,
  [4223] = 4114,
  [4224] = 4224,
  [4225] = 4225,
  [4226] = 4226,
  [4227] = 4171,
  [4228] = 2296,
  [4229] = 2295,
  [4230] = 3921,
  [4231] = 2281,
  [4232] = 2279,
  [4233] = 4233,
  [4234] = 4111,
  [4235] = 2384,
  [4236] = 4236,
  [4237] = 2269,
  [4238] = 4096,
  [4239] = 4051,
  [4240] = 2263,
  [4241] = 2261,
  [4242] = 4088,
  [4243] = 2385,
  [4244] = 2254,
  [4245] = 4084,
  [4246] = 4083,
  [4247] = 2253,
  [4248] = 4073,
  [4249] = 2252,
  [4250] = 4086,
  [4251] = 4127,
  [4252] = 2386,
  [4253] = 2380,
  [4254] = 4108,
  [4255] = 4055,
  [4256] = 2332,
  [4257] = 4166,
  [4258] = 4168,
  [4259] = 4171,
  [4260] = 4172,
  [4261] = 4176,
  [4262] = 4178,
  [4263] = 2329,
  [4264] = 3921,
  [4265] = 4203,
  [4266] = 2256,
  [4267] = 2255,
  [4268] = 4111,
  [4269] = 3921,
  [4270] = 4203,
  [4271] = 2251,
  [4272] = 4114,
  [4273] = 4203,
  [4274] = 2304,
  [4275] = 2292,
  [4276] = 4114,
  [4277] = 2228,
  [4278] = 2289,
  [4279] = 2373,
  [4280] = 2364,
  [4281] = 4172,
  [4282] = 4282,
  [4283] = 4283,
  [4284] = 2321,
  [4285] = 4285,
  [4286] = 2318,
  [4287] = 4111,
  [4288] = 4288,
  [4289] = 4289,
  [4290] = 4207,
  [4291] = 3921,
  [4292] = 4101,
  [4293] = 2336,
  [4294] = 2337,
  [4295] = 4295,
  [4296] = 4296,
  [4297] = 2244,
  [4298] = 2259,
  [4299] = 4178,
  [4300] = 4176,
  [4301] = 4301,
  [4302] = 4302,
  [4303] = 4303,
  [4304] = 4304,
  [4305] = 4305,
  [4306] = 4306,
  [4307] = 4307,
  [4308] = 4308,
  [4309] = 4035,
  [4310] = 4039,
  [4311] = 4311,
  [4312] = 4312,
  [4313] = 4313,
  [4314] = 4302,
  [4315] = 4302,
  [4316] = 4316,
  [4317] = 4302,
  [4318] = 4318,
  [4319] = 4319,
  [4320] = 4320,
  [4321] = 4311,
  [4322] = 4322,
  [4323] = 4302,
  [4324] = 4320,
  [4325] = 4325,
  [4326] = 4311,
  [4327] = 4311,
  [4328] = 4311,
  [4329] = 292,
  [4330] = 293,
  [4331] = 4331,
  [4332] = 4332,
  [4333] = 4333,
  [4334] = 4311,
  [4335] = 4311,
  [4336] = 4311,
  [4337] = 4332,
  [4338] = 4331,
  [4339] = 4302,
  [4340] = 4340,
  [4341] = 4341,
  [4342] = 4342,
  [4343] = 4343,
  [4344] = 4344,
  [4345] = 4345,
  [4346] = 4346,
  [4347] = 4347,
  [4348] = 4348,
  [4349] = 4349,
  [4350] = 4350,
  [4351] = 4351,
  [4352] = 4352,
  [4353] = 4353,
  [4354] = 4354,
  [4355] = 4355,
  [4356] = 4356,
  [4357] = 4357,
  [4358] = 4358,
  [4359] = 4359,
  [4360] = 4360,
  [4361] = 4361,
  [4362] = 4362,
  [4363] = 4363,
  [4364] = 4364,
  [4365] = 4365,
  [4366] = 4366,
  [4367] = 305,
  [4368] = 4368,
  [4369] = 4369,
  [4370] = 4370,
  [4371] = 4371,
  [4372] = 4372,
  [4373] = 4373,
  [4374] = 4374,
  [4375] = 4375,
  [4376] = 4376,
  [4377] = 4377,
  [4378] = 4378,
  [4379] = 4379,
  [4380] = 4380,
  [4381] = 4381,
  [4382] = 4381,
  [4383] = 4380,
  [4384] = 4384,
  [4385] = 4372,
  [4386] = 4386,
  [4387] = 4387,
  [4388] = 4370,
  [4389] = 4288,
  [4390] = 4347,
  [4391] = 4391,
  [4392] = 4344,
  [4393] = 4393,
  [4394] = 4341,
  [4395] = 4395,
  [4396] = 4351,
  [4397] = 4215,
  [4398] = 305,
  [4399] = 4363,
  [4400] = 4400,
  [4401] = 4401,
  [4402] = 4402,
  [4403] = 4403,
  [4404] = 4404,
  [4405] = 4405,
  [4406] = 4406,
  [4407] = 4407,
  [4408] = 4197,
  [4409] = 4381,
  [4410] = 4410,
  [4411] = 4380,
  [4412] = 4372,
  [4413] = 4370,
  [4414] = 4414,
  [4415] = 4347,
  [4416] = 4416,
  [4417] = 4417,
  [4418] = 4344,
  [4419] = 335,
  [4420] = 4341,
  [4421] = 4351,
  [4422] = 4363,
  [4423] = 4423,
  [4424] = 331,
  [4425] = 4425,
  [4426] = 342,
  [4427] = 4427,
  [4428] = 4428,
  [4429] = 4429,
  [4430] = 4430,
  [4431] = 338,
  [4432] = 4432,
  [4433] = 4433,
  [4434] = 4363,
  [4435] = 4435,
  [4436] = 4436,
  [4437] = 333,
  [4438] = 4134,
  [4439] = 4439,
  [4440] = 4440,
  [4441] = 4131,
  [4442] = 4381,
  [4443] = 4443,
  [4444] = 4444,
  [4445] = 4380,
  [4446] = 4446,
  [4447] = 4447,
  [4448] = 4372,
  [4449] = 4449,
  [4450] = 4450,
  [4451] = 4370,
  [4452] = 4347,
  [4453] = 4453,
  [4454] = 4079,
  [4455] = 4455,
  [4456] = 4344,
  [4457] = 4457,
  [4458] = 4341,
  [4459] = 4351,
  [4460] = 4460,
  [4461] = 4363,
  [4462] = 4462,
  [4463] = 4463,
  [4464] = 4381,
  [4465] = 4465,
  [4466] = 4380,
  [4467] = 4372,
  [4468] = 4468,
  [4469] = 4347,
  [4470] = 4344,
  [4471] = 4341,
  [4472] = 4351,
  [4473] = 4473,
  [4474] = 4474,
  [4475] = 4363,
  [4476] = 4344,
  [4477] = 4352,
  [4478] = 3979,
  [4479] = 4479,
  [4480] = 4480,
  [4481] = 4351,
  [4482] = 4341,
  [4483] = 4483,
  [4484] = 4484,
  [4485] = 4485,
  [4486] = 4486,
  [4487] = 4487,
  [4488] = 4488,
  [4489] = 4489,
  [4490] = 4485,
  [4491] = 4491,
  [4492] = 4492,
  [4493] = 4493,
  [4494] = 4494,
  [4495] = 4495,
  [4496] = 4496,
  [4497] = 4497,
  [4498] = 4498,
  [4499] = 4499,
  [4500] = 291,
  [4501] = 4501,
  [4502] = 4502,
  [4503] = 4346,
  [4504] = 4504,
  [4505] = 4347,
  [4506] = 4348,
  [4507] = 4322,
  [4508] = 4489,
  [4509] = 4509,
  [4510] = 310,
  [4511] = 4511,
  [4512] = 333,
  [4513] = 335,
  [4514] = 4514,
  [4515] = 4515,
  [4516] = 4516,
  [4517] = 4517,
  [4518] = 4485,
  [4519] = 4519,
  [4520] = 4370,
  [4521] = 4372,
  [4522] = 4522,
  [4523] = 4523,
  [4524] = 4524,
  [4525] = 4525,
  [4526] = 4526,
  [4527] = 4527,
  [4528] = 4489,
  [4529] = 4529,
  [4530] = 4530,
  [4531] = 314,
  [4532] = 4532,
  [4533] = 4485,
  [4534] = 4534,
  [4535] = 4535,
  [4536] = 4501,
  [4537] = 4489,
  [4538] = 4489,
  [4539] = 4064,
  [4540] = 4489,
  [4541] = 4541,
  [4542] = 4542,
  [4543] = 4543,
  [4544] = 4544,
  [4545] = 4485,
  [4546] = 4546,
  [4547] = 4547,
  [4548] = 4548,
  [4549] = 4549,
  [4550] = 4550,
  [4551] = 4551,
  [4552] = 4552,
  [4553] = 4553,
  [4554] = 4554,
  [4555] = 4555,
  [4556] = 4556,
  [4557] = 4557,
  [4558] = 4558,
  [4559] = 4559,
  [4560] = 4560,
  [4561] = 4561,
  [4562] = 4379,
  [4563] = 4563,
  [4564] = 4380,
  [4565] = 4381,
  [4566] = 1907,
  [4567] = 4567,
  [4568] = 4568,
  [4569] = 4559,
  [4570] = 4395,
  [4571] = 4571,
  [4572] = 4572,
  [4573] = 4554,
  [4574] = 4574,
  [4575] = 4575,
  [4576] = 4576,
  [4577] = 4577,
  [4578] = 4578,
  [4579] = 4492,
  [4580] = 4580,
  [4581] = 338,
  [4582] = 3980,
  [4583] = 4583,
  [4584] = 4485,
  [4585] = 4549,
  [4586] = 4559,
  [4587] = 4549,
  [4588] = 4588,
  [4589] = 4559,
  [4590] = 4549,
  [4591] = 4549,
  [4592] = 4592,
  [4593] = 4593,
  [4594] = 4594,
  [4595] = 4070,
  [4596] = 4596,
  [4597] = 4597,
  [4598] = 4598,
  [4599] = 4153,
  [4600] = 4119,
  [4601] = 4121,
  [4602] = 4602,
  [4603] = 4603,
  [4604] = 4604,
  [4605] = 4605,
  [4606] = 4144,
  [4607] = 4146,
  [4608] = 4559,
  [4609] = 4549,
  [4610] = 4610,
  [4611] = 4611,
  [4612] = 4559,
  [4613] = 4613,
  [4614] = 4557,
  [4615] = 4615,
  [4616] = 4616,
  [4617] = 4615,
  [4618] = 4618,
  [4619] = 4613,
  [4620] = 4615,
  [4621] = 4621,
  [4622] = 4622,
  [4623] = 4615,
  [4624] = 867,
  [4625] = 4615,
  [4626] = 4626,
  [4627] = 4627,
  [4628] = 4628,
  [4629] = 4629,
  [4630] = 4630,
  [4631] = 4631,
  [4632] = 4632,
  [4633] = 4633,
  [4634] = 342,
  [4635] = 4635,
  [4636] = 4613,
  [4637] = 4626,
  [4638] = 4567,
  [4639] = 4627,
  [4640] = 2388,
  [4641] = 4641,
  [4642] = 4642,
  [4643] = 4516,
  [4644] = 4644,
  [4645] = 2481,
  [4646] = 4561,
  [4647] = 4647,
  [4648] = 4515,
  [4649] = 4647,
  [4650] = 4644,
  [4651] = 4651,
  [4652] = 4514,
  [4653] = 4653,
  [4654] = 4509,
  [4655] = 4635,
  [4656] = 4626,
  [4657] = 4529,
  [4658] = 4530,
  [4659] = 4659,
  [4660] = 4627,
  [4661] = 2421,
  [4662] = 4662,
  [4663] = 4616,
  [4664] = 2420,
  [4665] = 4332,
  [4666] = 4331,
  [4667] = 4532,
  [4668] = 2424,
  [4669] = 4534,
  [4670] = 4621,
  [4671] = 4622,
  [4672] = 4635,
  [4673] = 4673,
  [4674] = 4626,
  [4675] = 4675,
  [4676] = 4627,
  [4677] = 2425,
  [4678] = 4629,
  [4679] = 4630,
  [4680] = 4632,
  [4681] = 4633,
  [4682] = 4560,
  [4683] = 4055,
  [4684] = 4684,
  [4685] = 4644,
  [4686] = 4686,
  [4687] = 2435,
  [4688] = 4613,
  [4689] = 2438,
  [4690] = 4690,
  [4691] = 331,
  [4692] = 4692,
  [4693] = 4647,
  [4694] = 4694,
  [4695] = 4695,
  [4696] = 4662,
  [4697] = 4644,
  [4698] = 2441,
  [4699] = 4647,
  [4700] = 4613,
  [4701] = 4651,
  [4702] = 4702,
  [4703] = 4616,
  [4704] = 4704,
  [4705] = 4705,
  [4706] = 4488,
  [4707] = 4621,
  [4708] = 4622,
  [4709] = 4633,
  [4710] = 4580,
  [4711] = 4711,
  [4712] = 4633,
  [4713] = 4632,
  [4714] = 4322,
  [4715] = 4715,
  [4716] = 4629,
  [4717] = 2550,
  [4718] = 4630,
  [4719] = 4632,
  [4720] = 4720,
  [4721] = 2554,
  [4722] = 4632,
  [4723] = 2405,
  [4724] = 4633,
  [4725] = 4613,
  [4726] = 4726,
  [4727] = 4644,
  [4728] = 2399,
  [4729] = 4487,
  [4730] = 4647,
  [4731] = 4715,
  [4732] = 4627,
  [4733] = 4486,
  [4734] = 4734,
  [4735] = 4630,
  [4736] = 4736,
  [4737] = 4629,
  [4738] = 4621,
  [4739] = 4622,
  [4740] = 4630,
  [4741] = 4741,
  [4742] = 4632,
  [4743] = 4633,
  [4744] = 4744,
  [4745] = 4613,
  [4746] = 4635,
  [4747] = 4626,
  [4748] = 4553,
  [4749] = 4690,
  [4750] = 4622,
  [4751] = 4751,
  [4752] = 4621,
  [4753] = 2496,
  [4754] = 4621,
  [4755] = 2426,
  [4756] = 4622,
  [4757] = 4630,
  [4758] = 4758,
  [4759] = 4550,
  [4760] = 4632,
  [4761] = 4568,
  [4762] = 4762,
  [4763] = 4763,
  [4764] = 4633,
  [4765] = 4613,
  [4766] = 4766,
  [4767] = 4627,
  [4768] = 4051,
  [4769] = 4630,
  [4770] = 4632,
  [4771] = 1935,
  [4772] = 4633,
  [4773] = 4613,
  [4774] = 4774,
  [4775] = 4630,
  [4776] = 4616,
  [4777] = 4632,
  [4778] = 4633,
  [4779] = 4779,
  [4780] = 4615,
  [4781] = 4781,
  [4782] = 4766,
  [4783] = 1946,
  [4784] = 4784,
  [4785] = 4785,
  [4786] = 4786,
  [4787] = 4787,
  [4788] = 4741,
  [4789] = 4789,
  [4790] = 4790,
  [4791] = 4791,
  [4792] = 4588,
  [4793] = 4793,
  [4794] = 4794,
  [4795] = 4684,
  [4796] = 4796,
  [4797] = 4630,
  [4798] = 4455,
  [4799] = 4736,
  [4800] = 4635,
  [4801] = 4801,
  [4802] = 4802,
  [4803] = 4803,
  [4804] = 4543,
  [4805] = 4544,
  [4806] = 4806,
  [4807] = 3966,
  [4808] = 4801,
  [4809] = 2545,
  [4810] = 4692,
  [4811] = 4647,
  [4812] = 4644,
  [4813] = 4813,
  [4814] = 4629,
  [4815] = 4546,
  [4816] = 4816,
  [4817] = 4817,
  [4818] = 4659,
  [4819] = 4548,
  [4820] = 4758,
  [4821] = 4675,
  [4822] = 4653,
  [4823] = 4803,
  [4824] = 4817,
  [4825] = 4825,
  [4826] = 4816,
  [4827] = 4827,
  [4828] = 4828,
  [4829] = 4622,
  [4830] = 4621,
  [4831] = 4831,
  [4832] = 4832,
  [4833] = 4684,
  [4834] = 4834,
  [4835] = 4626,
  [4836] = 4836,
  [4837] = 4837,
  [4838] = 4684,
  [4839] = 4558,
  [4840] = 4616,
  [4841] = 4684,
  [4842] = 4802,
  [4843] = 4843,
  [4844] = 4844,
  [4845] = 4845,
  [4846] = 4846,
  [4847] = 1009,
  [4848] = 4848,
  [4849] = 4849,
  [4850] = 4850,
  [4851] = 4851,
  [4852] = 4852,
  [4853] = 4853,
  [4854] = 4854,
  [4855] = 4855,
  [4856] = 4856,
  [4857] = 4857,
  [4858] = 4858,
  [4859] = 4859,
  [4860] = 4860,
  [4861] = 4861,
  [4862] = 4862,
  [4863] = 4863,
  [4864] = 4864,
  [4865] = 4865,
  [4866] = 4866,
  [4867] = 4867,
  [4868] = 4868,
  [4869] = 4869,
  [4870] = 4870,
  [4871] = 4871,
  [4872] = 2348,
  [4873] = 4873,
  [4874] = 4874,
  [4875] = 4875,
  [4876] = 4876,
  [4877] = 4877,
  [4878] = 1094,
  [4879] = 4879,
  [4880] = 1008,
  [4881] = 4881,
  [4882] = 2347,
  [4883] = 4883,
  [4884] = 4884,
  [4885] = 4885,
  [4886] = 4886,
  [4887] = 4887,
  [4888] = 4888,
  [4889] = 4889,
  [4890] = 4890,
  [4891] = 4891,
  [4892] = 4892,
  [4893] = 1010,
  [4894] = 4894,
  [4895] = 1011,
  [4896] = 4896,
  [4897] = 4897,
  [4898] = 4898,
  [4899] = 4899,
  [4900] = 2545,
  [4901] = 4901,
  [4902] = 4902,
  [4903] = 4903,
  [4904] = 1012,
  [4905] = 4905,
  [4906] = 4906,
  [4907] = 4907,
  [4908] = 4908,
  [4909] = 4871,
  [4910] = 4910,
  [4911] = 4911,
  [4912] = 4912,
  [4913] = 4856,
  [4914] = 4861,
  [4915] = 4915,
  [4916] = 1017,
  [4917] = 4917,
  [4918] = 4844,
  [4919] = 4864,
  [4920] = 4920,
  [4921] = 4865,
  [4922] = 4869,
  [4923] = 4923,
  [4924] = 4844,
  [4925] = 4925,
  [4926] = 4926,
  [4927] = 4927,
  [4928] = 4869,
  [4929] = 4929,
  [4930] = 4873,
  [4931] = 4875,
  [4932] = 4932,
  [4933] = 4885,
  [4934] = 4876,
  [4935] = 953,
  [4936] = 4936,
  [4937] = 4937,
  [4938] = 4876,
  [4939] = 4939,
  [4940] = 4940,
  [4941] = 4941,
  [4942] = 4942,
  [4943] = 4943,
  [4944] = 4944,
  [4945] = 1086,
  [4946] = 4946,
  [4947] = 4947,
  [4948] = 4948,
  [4949] = 4949,
  [4950] = 4891,
  [4951] = 4951,
  [4952] = 1014,
  [4953] = 4953,
  [4954] = 4954,
  [4955] = 4875,
  [4956] = 1005,
  [4957] = 4957,
  [4958] = 4958,
  [4959] = 4959,
  [4960] = 4960,
  [4961] = 4961,
  [4962] = 4873,
  [4963] = 1001,
  [4964] = 999,
  [4965] = 4965,
  [4966] = 4966,
  [4967] = 2441,
  [4968] = 1015,
  [4969] = 4969,
  [4970] = 2438,
  [4971] = 4971,
  [4972] = 2426,
  [4973] = 4973,
  [4974] = 2425,
  [4975] = 4975,
  [4976] = 4976,
  [4977] = 4977,
  [4978] = 2424,
  [4979] = 4865,
  [4980] = 4864,
  [4981] = 4960,
  [4982] = 4982,
  [4983] = 996,
  [4984] = 4984,
  [4985] = 4985,
  [4986] = 4986,
  [4987] = 4563,
  [4988] = 4982,
  [4989] = 4989,
  [4990] = 993,
  [4991] = 4991,
  [4992] = 4992,
  [4993] = 992,
  [4994] = 4994,
  [4995] = 991,
  [4996] = 321,
  [4997] = 4997,
  [4998] = 4998,
  [4999] = 4999,
  [5000] = 5000,
  [5001] = 5001,
  [5002] = 5002,
  [5003] = 5003,
  [5004] = 2361,
  [5005] = 5005,
  [5006] = 4844,
  [5007] = 5007,
  [5008] = 5008,
  [5009] = 5009,
  [5010] = 5010,
  [5011] = 5011,
  [5012] = 2362,
  [5013] = 5013,
  [5014] = 4869,
  [5015] = 5015,
  [5016] = 4856,
  [5017] = 4865,
  [5018] = 5018,
  [5019] = 5019,
  [5020] = 5020,
  [5021] = 5021,
  [5022] = 4861,
  [5023] = 5023,
  [5024] = 319,
  [5025] = 5025,
  [5026] = 2364,
  [5027] = 5000,
  [5028] = 4998,
  [5029] = 4864,
  [5030] = 5030,
  [5031] = 5031,
  [5032] = 4985,
  [5033] = 4864,
  [5034] = 4865,
  [5035] = 5035,
  [5036] = 5036,
  [5037] = 5037,
  [5038] = 1083,
  [5039] = 4751,
  [5040] = 5040,
  [5041] = 4869,
  [5042] = 5042,
  [5043] = 5043,
  [5044] = 5044,
  [5045] = 4861,
  [5046] = 5046,
  [5047] = 4856,
  [5048] = 5048,
  [5049] = 1018,
  [5050] = 5050,
  [5051] = 1022,
  [5052] = 5052,
  [5053] = 5053,
  [5054] = 5054,
  [5055] = 5055,
  [5056] = 5056,
  [5057] = 4844,
  [5058] = 2550,
  [5059] = 5059,
  [5060] = 5003,
  [5061] = 5061,
  [5062] = 4850,
  [5063] = 4876,
  [5064] = 2420,
  [5065] = 5065,
  [5066] = 5066,
  [5067] = 2421,
  [5068] = 4873,
  [5069] = 4875,
  [5070] = 990,
  [5071] = 4527,
  [5072] = 4526,
  [5073] = 293,
  [5074] = 292,
  [5075] = 5075,
  [5076] = 1096,
  [5077] = 5077,
  [5078] = 5078,
  [5079] = 2435,
  [5080] = 5080,
  [5081] = 5081,
  [5082] = 5082,
  [5083] = 2554,
  [5084] = 989,
  [5085] = 4873,
  [5086] = 988,
  [5087] = 987,
  [5088] = 955,
  [5089] = 5089,
  [5090] = 5090,
  [5091] = 5091,
  [5092] = 951,
  [5093] = 4876,
  [5094] = 4873,
  [5095] = 5095,
  [5096] = 5096,
  [5097] = 5097,
  [5098] = 960,
  [5099] = 5065,
  [5100] = 5100,
  [5101] = 5101,
  [5102] = 4991,
  [5103] = 5103,
  [5104] = 5104,
  [5105] = 982,
  [5106] = 4844,
  [5107] = 4869,
  [5108] = 5020,
  [5109] = 981,
  [5110] = 5110,
  [5111] = 5035,
  [5112] = 5112,
  [5113] = 5113,
  [5114] = 4865,
  [5115] = 5115,
  [5116] = 5116,
  [5117] = 5117,
  [5118] = 5118,
  [5119] = 4864,
  [5120] = 5120,
  [5121] = 5121,
  [5122] = 5122,
  [5123] = 4861,
  [5124] = 4856,
  [5125] = 5125,
  [5126] = 5126,
  [5127] = 2496,
  [5128] = 5128,
  [5129] = 5129,
  [5130] = 5130,
  [5131] = 4875,
  [5132] = 1081,
  [5133] = 5133,
  [5134] = 1080,
  [5135] = 5135,
  [5136] = 5136,
  [5137] = 5137,
  [5138] = 5138,
  [5139] = 5007,
  [5140] = 5140,
  [5141] = 4954,
  [5142] = 5142,
  [5143] = 335,
  [5144] = 333,
  [5145] = 5145,
  [5146] = 1042,
  [5147] = 5147,
  [5148] = 5148,
  [5149] = 5149,
  [5150] = 5150,
  [5151] = 5151,
  [5152] = 5152,
  [5153] = 5153,
  [5154] = 5037,
  [5155] = 5155,
  [5156] = 5156,
  [5157] = 4954,
  [5158] = 4828,
  [5159] = 1073,
  [5160] = 1093,
  [5161] = 4861,
  [5162] = 5162,
  [5163] = 5163,
  [5164] = 5164,
  [5165] = 5165,
  [5166] = 5166,
  [5167] = 5167,
  [5168] = 5168,
  [5169] = 970,
  [5170] = 1099,
  [5171] = 1100,
  [5172] = 5172,
  [5173] = 4886,
  [5174] = 5174,
  [5175] = 1109,
  [5176] = 4871,
  [5177] = 5177,
  [5178] = 5178,
  [5179] = 5179,
  [5180] = 5180,
  [5181] = 4885,
  [5182] = 5182,
  [5183] = 5183,
  [5184] = 4711,
  [5185] = 5185,
  [5186] = 5186,
  [5187] = 4705,
  [5188] = 5188,
  [5189] = 5189,
  [5190] = 5190,
  [5191] = 5191,
  [5192] = 5192,
  [5193] = 5193,
  [5194] = 4704,
  [5195] = 4891,
  [5196] = 4871,
  [5197] = 4856,
  [5198] = 5043,
  [5199] = 5199,
  [5200] = 939,
  [5201] = 4991,
  [5202] = 5046,
  [5203] = 4885,
  [5204] = 4999,
  [5205] = 973,
  [5206] = 969,
  [5207] = 4954,
  [5208] = 5015,
  [5209] = 5209,
  [5210] = 5210,
  [5211] = 5211,
  [5212] = 949,
  [5213] = 5213,
  [5214] = 5214,
  [5215] = 952,
  [5216] = 5216,
  [5217] = 5013,
  [5218] = 5218,
  [5219] = 4891,
  [5220] = 5220,
  [5221] = 926,
  [5222] = 5222,
  [5223] = 5223,
  [5224] = 5011,
  [5225] = 5225,
  [5226] = 4960,
  [5227] = 4982,
  [5228] = 5228,
  [5229] = 5229,
  [5230] = 5230,
  [5231] = 5231,
  [5232] = 4991,
  [5233] = 5065,
  [5234] = 5234,
  [5235] = 5235,
  [5236] = 5236,
  [5237] = 5237,
  [5238] = 5238,
  [5239] = 5239,
  [5240] = 5240,
  [5241] = 1026,
  [5242] = 5242,
  [5243] = 5243,
  [5244] = 5046,
  [5245] = 4958,
  [5246] = 971,
  [5247] = 5043,
  [5248] = 968,
  [5249] = 966,
  [5250] = 2481,
  [5251] = 5251,
  [5252] = 5037,
  [5253] = 2388,
  [5254] = 5035,
  [5255] = 5255,
  [5256] = 5020,
  [5257] = 5257,
  [5258] = 5258,
  [5259] = 4982,
  [5260] = 964,
  [5261] = 4960,
  [5262] = 1060,
  [5263] = 1050,
  [5264] = 1052,
  [5265] = 5265,
  [5266] = 4960,
  [5267] = 5035,
  [5268] = 4982,
  [5269] = 914,
  [5270] = 5270,
  [5271] = 4891,
  [5272] = 1054,
  [5273] = 5273,
  [5274] = 4885,
  [5275] = 4774,
  [5276] = 5276,
  [5277] = 2289,
  [5278] = 1114,
  [5279] = 5037,
  [5280] = 2292,
  [5281] = 1025,
  [5282] = 5282,
  [5283] = 5283,
  [5284] = 5284,
  [5285] = 1029,
  [5286] = 5286,
  [5287] = 5287,
  [5288] = 5288,
  [5289] = 2384,
  [5290] = 5290,
  [5291] = 5291,
  [5292] = 2304,
  [5293] = 5020,
  [5294] = 2329,
  [5295] = 2332,
  [5296] = 1030,
  [5297] = 5297,
  [5298] = 2385,
  [5299] = 4876,
  [5300] = 2386,
  [5301] = 5035,
  [5302] = 5302,
  [5303] = 5303,
  [5304] = 1055,
  [5305] = 5305,
  [5306] = 5043,
  [5307] = 2405,
  [5308] = 2399,
  [5309] = 1144,
  [5310] = 5310,
  [5311] = 5311,
  [5312] = 5312,
  [5313] = 5037,
  [5314] = 5046,
  [5315] = 1115,
  [5316] = 5316,
  [5317] = 978,
  [5318] = 1098,
  [5319] = 5319,
  [5320] = 5065,
  [5321] = 5321,
  [5322] = 5322,
  [5323] = 5323,
  [5324] = 1085,
  [5325] = 5325,
  [5326] = 922,
  [5327] = 5172,
  [5328] = 5328,
  [5329] = 5182,
  [5330] = 1137,
  [5331] = 5331,
  [5332] = 5332,
  [5333] = 5333,
  [5334] = 5046,
  [5335] = 921,
  [5336] = 5043,
  [5337] = 920,
  [5338] = 1089,
  [5339] = 5043,
  [5340] = 5340,
  [5341] = 5341,
  [5342] = 5342,
  [5343] = 5046,
  [5344] = 5037,
  [5345] = 5035,
  [5346] = 5020,
  [5347] = 1130,
  [5348] = 5348,
  [5349] = 5349,
  [5350] = 5350,
  [5351] = 1129,
  [5352] = 5352,
  [5353] = 4982,
  [5354] = 5291,
  [5355] = 5355,
  [5356] = 5356,
  [5357] = 4960,
  [5358] = 1051,
  [5359] = 1126,
  [5360] = 5360,
  [5361] = 5361,
  [5362] = 5362,
  [5363] = 5363,
  [5364] = 1123,
  [5365] = 5365,
  [5366] = 5366,
  [5367] = 5367,
  [5368] = 5368,
  [5369] = 4891,
  [5370] = 4885,
  [5371] = 4871,
  [5372] = 4887,
  [5373] = 5373,
  [5374] = 5374,
  [5375] = 5375,
  [5376] = 5376,
  [5377] = 5377,
  [5378] = 5378,
  [5379] = 5340,
  [5380] = 4875,
  [5381] = 5209,
  [5382] = 4991,
  [5383] = 5065,
  [5384] = 5384,
  [5385] = 5050,
  [5386] = 5386,
  [5387] = 4502,
  [5388] = 5388,
  [5389] = 5389,
  [5390] = 5148,
  [5391] = 5391,
  [5392] = 5392,
  [5393] = 5393,
  [5394] = 5394,
  [5395] = 5395,
  [5396] = 5396,
  [5397] = 5397,
  [5398] = 4991,
  [5399] = 5399,
  [5400] = 5400,
  [5401] = 5401,
  [5402] = 5162,
  [5403] = 5403,
  [5404] = 5404,
  [5405] = 5405,
  [5406] = 5065,
  [5407] = 5407,
  [5408] = 5408,
  [5409] = 5409,
  [5410] = 2014,
  [5411] = 5411,
  [5412] = 5412,
  [5413] = 5413,
  [5414] = 5414,
  [5415] = 5415,
  [5416] = 5416,
  [5417] = 5417,
  [5418] = 5418,
  [5419] = 5419,
  [5420] = 5408,
  [5421] = 5421,
  [5422] = 5422,
  [5423] = 5423,
  [5424] = 5424,
  [5425] = 5425,
  [5426] = 5426,
  [5427] = 5427,
  [5428] = 5426,
  [5429] = 5429,
  [5430] = 5411,
  [5431] = 5431,
  [5432] = 5409,
  [5433] = 5433,
  [5434] = 5434,
  [5435] = 5435,
  [5436] = 5413,
  [5437] = 5412,
  [5438] = 5438,
  [5439] = 5414,
  [5440] = 919,
  [5441] = 5441,
  [5442] = 5415,
  [5443] = 5416,
  [5444] = 5444,
  [5445] = 5445,
  [5446] = 5446,
  [5447] = 5447,
  [5448] = 5412,
  [5449] = 5449,
  [5450] = 5418,
  [5451] = 5412,
  [5452] = 5425,
  [5453] = 5426,
  [5454] = 5408,
  [5455] = 5419,
  [5456] = 5456,
  [5457] = 5411,
  [5458] = 5415,
  [5459] = 5416,
  [5460] = 5418,
  [5461] = 5425,
  [5462] = 5446,
  [5463] = 5445,
  [5464] = 5429,
  [5465] = 5434,
  [5466] = 5435,
  [5467] = 5444,
  [5468] = 5438,
  [5469] = 5469,
  [5470] = 5470,
  [5471] = 5446,
  [5472] = 5445,
  [5473] = 5473,
  [5474] = 5417,
  [5475] = 5408,
  [5476] = 5419,
  [5477] = 5444,
  [5478] = 5415,
  [5479] = 5479,
  [5480] = 5438,
  [5481] = 5416,
  [5482] = 5418,
  [5483] = 5425,
  [5484] = 5434,
  [5485] = 5435,
  [5486] = 5438,
  [5487] = 5438,
  [5488] = 5488,
  [5489] = 5489,
  [5490] = 5408,
  [5491] = 5419,
  [5492] = 5418,
  [5493] = 5425,
  [5494] = 5408,
  [5495] = 5419,
  [5496] = 5496,
  [5497] = 5497,
  [5498] = 5418,
  [5499] = 5425,
  [5500] = 5417,
  [5501] = 5501,
  [5502] = 5435,
  [5503] = 5434,
  [5504] = 5433,
  [5505] = 5409,
  [5506] = 5431,
  [5507] = 5408,
  [5508] = 5508,
  [5509] = 5419,
  [5510] = 5418,
  [5511] = 5425,
  [5512] = 5435,
  [5513] = 5434,
  [5514] = 950,
  [5515] = 5433,
  [5516] = 5409,
  [5517] = 5431,
  [5518] = 5408,
  [5519] = 5419,
  [5520] = 5429,
  [5521] = 5418,
  [5522] = 5425,
  [5523] = 5408,
  [5524] = 5524,
  [5525] = 5525,
  [5526] = 5414,
  [5527] = 5418,
  [5528] = 5528,
  [5529] = 5429,
  [5530] = 5530,
  [5531] = 5425,
  [5532] = 5532,
  [5533] = 5425,
  [5534] = 5534,
  [5535] = 5418,
  [5536] = 5417,
  [5537] = 5408,
  [5538] = 5419,
  [5539] = 5418,
  [5540] = 5416,
  [5541] = 5415,
  [5542] = 5414,
  [5543] = 5425,
  [5544] = 5479,
  [5545] = 5413,
  [5546] = 5546,
  [5547] = 5411,
  [5548] = 5456,
  [5549] = 5411,
  [5550] = 5429,
  [5551] = 5551,
  [5552] = 1978,
  [5553] = 5553,
  [5554] = 5554,
  [5555] = 5555,
  [5556] = 5446,
  [5557] = 5470,
  [5558] = 5445,
  [5559] = 5425,
  [5560] = 5418,
  [5561] = 5561,
  [5562] = 896,
  [5563] = 5563,
  [5564] = 5564,
  [5565] = 5419,
  [5566] = 5449,
  [5567] = 5408,
  [5568] = 5419,
  [5569] = 5413,
  [5570] = 5419,
  [5571] = 5415,
  [5572] = 5416,
  [5573] = 5573,
  [5574] = 5426,
  [5575] = 5416,
  [5576] = 5415,
  [5577] = 5577,
  [5578] = 5414,
  [5579] = 5413,
  [5580] = 5426,
  [5581] = 5581,
  [5582] = 5582,
  [5583] = 5408,
  [5584] = 5584,
  [5585] = 5585,
  [5586] = 5418,
  [5587] = 5425,
  [5588] = 5588,
  [5589] = 5589,
  [5590] = 5412,
  [5591] = 4631,
  [5592] = 5417,
  [5593] = 5411,
  [5594] = 5554,
  [5595] = 5595,
  [5596] = 5488,
  [5597] = 5597,
  [5598] = 5598,
  [5599] = 5508,
  [5600] = 5554,
  [5601] = 5419,
  [5602] = 5446,
  [5603] = 5445,
  [5604] = 5408,
  [5605] = 5444,
  [5606] = 5584,
  [5607] = 5444,
  [5608] = 5608,
  [5609] = 4686,
  [5610] = 5438,
  [5611] = 5611,
  [5612] = 1966,
  [5613] = 924,
  [5614] = 5614,
  [5615] = 5489,
  [5616] = 291,
  [5617] = 5617,
  [5618] = 5584,
  [5619] = 5429,
  [5620] = 5554,
  [5621] = 5584,
  [5622] = 5622,
  [5623] = 5623,
  [5624] = 5438,
  [5625] = 5625,
  [5626] = 5626,
  [5627] = 5627,
  [5628] = 5431,
  [5629] = 5419,
  [5630] = 5433,
  [5631] = 5435,
  [5632] = 5434,
  [5633] = 5434,
  [5634] = 5435,
  [5635] = 5635,
  [5636] = 5433,
  [5637] = 5584,
  [5638] = 5554,
  [5639] = 5409,
  [5640] = 5431,
  [5641] = 5641,
  [5642] = 5642,
  [5643] = 5643,
  [5644] = 5644,
  [5645] = 5645,
  [5646] = 5646,
  [5647] = 5647,
  [5648] = 5648,
  [5649] = 5649,
  [5650] = 5650,
  [5651] = 5651,
  [5652] = 5652,
  [5653] = 5653,
  [5654] = 5654,
  [5655] = 5655,
  [5656] = 5656,
  [5657] = 5657,
  [5658] = 5658,
  [5659] = 5659,
  [5660] = 5660,
  [5661] = 5661,
  [5662] = 5662,
  [5663] = 5663,
  [5664] = 5664,
  [5665] = 5665,
  [5666] = 5666,
  [5667] = 5667,
  [5668] = 5668,
  [5669] = 5669,
  [5670] = 5670,
  [5671] = 5671,
  [5672] = 5672,
  [5673] = 5673,
  [5674] = 5674,
  [5675] = 5675,
  [5676] = 5676,
  [5677] = 5677,
  [5678] = 5660,
  [5679] = 5679,
  [5680] = 5680,
  [5681] = 5681,
  [5682] = 5682,
  [5683] = 5683,
  [5684] = 5684,
  [5685] = 5685,
  [5686] = 5686,
  [5687] = 5687,
  [5688] = 5688,
  [5689] = 5689,
  [5690] = 5690,
  [5691] = 5691,
  [5692] = 5692,
  [5693] = 5677,
  [5694] = 5660,
  [5695] = 5695,
  [5696] = 5641,
  [5697] = 5697,
  [5698] = 5698,
  [5699] = 5699,
  [5700] = 5700,
  [5701] = 5701,
  [5702] = 5702,
  [5703] = 5703,
  [5704] = 5704,
  [5705] = 5705,
  [5706] = 5706,
  [5707] = 5707,
  [5708] = 5708,
  [5709] = 5709,
  [5710] = 5710,
  [5711] = 5711,
  [5712] = 5712,
  [5713] = 5713,
  [5714] = 4554,
  [5715] = 5677,
  [5716] = 5660,
  [5717] = 5717,
  [5718] = 5718,
  [5719] = 5719,
  [5720] = 5720,
  [5721] = 5721,
  [5722] = 5722,
  [5723] = 5723,
  [5724] = 5724,
  [5725] = 5725,
  [5726] = 5642,
  [5727] = 5727,
  [5728] = 5728,
  [5729] = 5729,
  [5730] = 5730,
  [5731] = 5731,
  [5732] = 5732,
  [5733] = 5733,
  [5734] = 5734,
  [5735] = 5735,
  [5736] = 5736,
  [5737] = 5660,
  [5738] = 5738,
  [5739] = 5739,
  [5740] = 5740,
  [5741] = 5741,
  [5742] = 5742,
  [5743] = 5743,
  [5744] = 5744,
  [5745] = 5745,
  [5746] = 5746,
  [5747] = 5747,
  [5748] = 5677,
  [5749] = 5749,
  [5750] = 5750,
  [5751] = 5751,
  [5752] = 5752,
  [5753] = 5753,
  [5754] = 5754,
  [5755] = 5755,
  [5756] = 5756,
  [5757] = 5757,
  [5758] = 5758,
  [5759] = 5759,
  [5760] = 5760,
  [5761] = 5761,
  [5762] = 4561,
  [5763] = 5763,
  [5764] = 5764,
  [5765] = 5765,
  [5766] = 5766,
  [5767] = 5767,
  [5768] = 5768,
  [5769] = 5769,
  [5770] = 5770,
  [5771] = 5771,
  [5772] = 5772,
  [5773] = 5773,
  [5774] = 5774,
  [5775] = 5775,
  [5776] = 5776,
  [5777] = 5777,
  [5778] = 5778,
  [5779] = 5779,
  [5780] = 5780,
  [5781] = 5781,
  [5782] = 5782,
  [5783] = 5783,
  [5784] = 5784,
  [5785] = 5785,
  [5786] = 5786,
  [5787] = 5787,
  [5788] = 5788,
  [5789] = 5789,
  [5790] = 5790,
  [5791] = 5791,
  [5792] = 5792,
  [5793] = 5793,
  [5794] = 5794,
  [5795] = 5795,
  [5796] = 5796,
  [5797] = 5797,
  [5798] = 5798,
  [5799] = 5799,
  [5800] = 5800,
  [5801] = 5801,
  [5802] = 5802,
  [5803] = 5803,
  [5804] = 5804,
  [5805] = 5805,
  [5806] = 5806,
  [5807] = 5807,
  [5808] = 5808,
  [5809] = 5809,
  [5810] = 5677,
  [5811] = 5660,
  [5812] = 5812,
  [5813] = 5813,
  [5814] = 5814,
  [5815] = 5815,
  [5816] = 5763,
  [5817] = 5817,
  [5818] = 5818,
  [5819] = 5819,
  [5820] = 5820,
  [5821] = 5821,
  [5822] = 917,
  [5823] = 5823,
  [5824] = 5824,
  [5825] = 5825,
  [5826] = 5826,
  [5827] = 5827,
  [5828] = 5828,
  [5829] = 5829,
  [5830] = 5830,
  [5831] = 5831,
  [5832] = 5832,
  [5833] = 5833,
  [5834] = 5834,
  [5835] = 5835,
  [5836] = 5651,
  [5837] = 5837,
  [5838] = 5838,
  [5839] = 2361,
  [5840] = 5652,
  [5841] = 5654,
  [5842] = 2362,
  [5843] = 5843,
  [5844] = 5844,
  [5845] = 2364,
  [5846] = 5846,
  [5847] = 5792,
  [5848] = 5740,
  [5849] = 5849,
  [5850] = 5850,
  [5851] = 5851,
  [5852] = 5852,
  [5853] = 5853,
  [5854] = 5854,
  [5855] = 5855,
  [5856] = 5856,
  [5857] = 5857,
  [5858] = 2289,
  [5859] = 5642,
  [5860] = 5860,
  [5861] = 5861,
  [5862] = 5724,
  [5863] = 5863,
  [5864] = 937,
  [5865] = 5865,
  [5866] = 2292,
  [5867] = 2304,
  [5868] = 5670,
  [5869] = 5869,
  [5870] = 2329,
  [5871] = 2332,
  [5872] = 5872,
  [5873] = 2386,
  [5874] = 5874,
  [5875] = 2385,
  [5876] = 2384,
  [5877] = 5877,
  [5878] = 5878,
  [5879] = 5879,
  [5880] = 5880,
  [5881] = 5881,
  [5882] = 5882,
  [5883] = 5883,
  [5884] = 5884,
  [5885] = 5885,
  [5886] = 5886,
  [5887] = 5887,
  [5888] = 5888,
  [5889] = 5889,
  [5890] = 5666,
  [5891] = 5891,
  [5892] = 5892,
  [5893] = 5692,
  [5894] = 5894,
  [5895] = 5895,
  [5896] = 5896,
  [5897] = 5897,
  [5898] = 5642,
  [5899] = 5724,
  [5900] = 5900,
  [5901] = 4944,
  [5902] = 5902,
  [5903] = 5903,
  [5904] = 5904,
  [5905] = 5905,
  [5906] = 5906,
  [5907] = 5907,
  [5908] = 5908,
  [5909] = 5909,
  [5910] = 5910,
  [5911] = 5911,
  [5912] = 5912,
  [5913] = 5874,
  [5914] = 5914,
  [5915] = 5915,
  [5916] = 5916,
  [5917] = 5917,
  [5918] = 5654,
  [5919] = 5652,
  [5920] = 5920,
  [5921] = 5921,
  [5922] = 5884,
  [5923] = 5923,
  [5924] = 5924,
  [5925] = 5884,
  [5926] = 5926,
  [5927] = 5927,
  [5928] = 5928,
  [5929] = 5651,
  [5930] = 5930,
  [5931] = 5724,
  [5932] = 5932,
  [5933] = 5933,
  [5934] = 929,
  [5935] = 5648,
  [5936] = 914,
  [5937] = 5937,
  [5938] = 939,
  [5939] = 5939,
  [5940] = 5940,
  [5941] = 5941,
  [5942] = 5942,
  [5943] = 5943,
  [5944] = 5944,
  [5945] = 5945,
  [5946] = 5946,
  [5947] = 5824,
  [5948] = 5948,
  [5949] = 5949,
  [5950] = 5950,
  [5951] = 5951,
  [5952] = 4567,
  [5953] = 5643,
  [5954] = 5954,
  [5955] = 5955,
  [5956] = 5663,
  [5957] = 5957,
  [5958] = 5958,
  [5959] = 5648,
  [5960] = 5667,
  [5961] = 5668,
  [5962] = 5962,
  [5963] = 5963,
  [5964] = 5964,
  [5965] = 5965,
  [5966] = 5966,
  [5967] = 5967,
  [5968] = 5968,
  [5969] = 953,
  [5970] = 5970,
  [5971] = 5680,
  [5972] = 5972,
  [5973] = 5973,
  [5974] = 5974,
  [5975] = 5975,
  [5976] = 5976,
  [5977] = 5977,
  [5978] = 5978,
  [5979] = 5979,
  [5980] = 5980,
  [5981] = 5981,
  [5982] = 5982,
  [5983] = 5983,
  [5984] = 5984,
  [5985] = 5874,
  [5986] = 5695,
  [5987] = 5641,
  [5988] = 5988,
  [5989] = 5989,
  [5990] = 5990,
  [5991] = 5991,
  [5992] = 5992,
  [5993] = 5993,
  [5994] = 5994,
  [5995] = 5995,
  [5996] = 5706,
  [5997] = 5997,
  [5998] = 5998,
  [5999] = 5999,
  [6000] = 5710,
  [6001] = 6001,
  [6002] = 6002,
  [6003] = 6003,
  [6004] = 6004,
  [6005] = 6005,
  [6006] = 5884,
  [6007] = 6007,
  [6008] = 6008,
  [6009] = 6009,
  [6010] = 5720,
  [6011] = 6011,
  [6012] = 5722,
  [6013] = 5723,
  [6014] = 6014,
  [6015] = 5727,
  [6016] = 6016,
  [6017] = 5730,
  [6018] = 6018,
  [6019] = 5732,
  [6020] = 6020,
  [6021] = 6021,
  [6022] = 5642,
  [6023] = 6023,
  [6024] = 5724,
  [6025] = 6025,
  [6026] = 6026,
  [6027] = 6027,
  [6028] = 6028,
  [6029] = 6029,
  [6030] = 920,
  [6031] = 6031,
  [6032] = 6032,
  [6033] = 921,
  [6034] = 6034,
  [6035] = 949,
  [6036] = 6036,
  [6037] = 6037,
  [6038] = 6038,
  [6039] = 6039,
  [6040] = 952,
  [6041] = 922,
  [6042] = 6042,
  [6043] = 6043,
  [6044] = 5761,
  [6045] = 6045,
  [6046] = 6046,
  [6047] = 6047,
  [6048] = 6048,
  [6049] = 6049,
  [6050] = 5663,
  [6051] = 5768,
  [6052] = 6052,
  [6053] = 5770,
  [6054] = 6054,
  [6055] = 6055,
  [6056] = 6056,
  [6057] = 6057,
  [6058] = 5667,
  [6059] = 6059,
  [6060] = 5668,
  [6061] = 5669,
  [6062] = 6062,
  [6063] = 6063,
  [6064] = 6064,
  [6065] = 6065,
  [6066] = 6066,
  [6067] = 6067,
  [6068] = 6068,
  [6069] = 6069,
  [6070] = 6070,
  [6071] = 5680,
  [6072] = 6072,
  [6073] = 6073,
  [6074] = 5130,
  [6075] = 6075,
  [6076] = 6076,
  [6077] = 6077,
  [6078] = 6078,
  [6079] = 6079,
  [6080] = 6080,
  [6081] = 6081,
  [6082] = 6082,
  [6083] = 6083,
  [6084] = 6084,
  [6085] = 6085,
  [6086] = 6086,
  [6087] = 6087,
  [6088] = 6088,
  [6089] = 6089,
  [6090] = 6090,
  [6091] = 6091,
  [6092] = 6092,
  [6093] = 6093,
  [6094] = 6094,
  [6095] = 6095,
  [6096] = 6096,
  [6097] = 6097,
  [6098] = 6098,
  [6099] = 6099,
  [6100] = 5770,
  [6101] = 5768,
  [6102] = 6102,
  [6103] = 6103,
  [6104] = 6104,
  [6105] = 5651,
  [6106] = 6106,
  [6107] = 6107,
  [6108] = 6108,
  [6109] = 5652,
  [6110] = 5654,
  [6111] = 5651,
  [6112] = 6112,
  [6113] = 6113,
  [6114] = 6114,
  [6115] = 6115,
  [6116] = 6116,
  [6117] = 6117,
  [6118] = 5695,
  [6119] = 5874,
  [6120] = 5652,
  [6121] = 5654,
  [6122] = 6122,
  [6123] = 6123,
  [6124] = 6124,
  [6125] = 6125,
  [6126] = 6126,
  [6127] = 6127,
  [6128] = 5692,
  [6129] = 6129,
  [6130] = 6130,
  [6131] = 6131,
  [6132] = 6132,
  [6133] = 5755,
  [6134] = 6134,
  [6135] = 6135,
  [6136] = 6136,
  [6137] = 6137,
  [6138] = 6138,
  [6139] = 6139,
  [6140] = 4580,
  [6141] = 6141,
  [6142] = 6142,
  [6143] = 5739,
  [6144] = 5884,
  [6145] = 5740,
  [6146] = 5792,
  [6147] = 5743,
  [6148] = 6148,
  [6149] = 6149,
  [6150] = 6150,
  [6151] = 5763,
  [6152] = 6152,
  [6153] = 5773,
  [6154] = 5783,
  [6155] = 5774,
  [6156] = 5776,
  [6157] = 5396,
  [6158] = 5777,
  [6159] = 2303,
  [6160] = 5706,
  [6161] = 5761,
  [6162] = 5642,
  [6163] = 5724,
  [6164] = 6164,
  [6165] = 5710,
  [6166] = 6166,
  [6167] = 2276,
  [6168] = 6168,
  [6169] = 6169,
  [6170] = 6170,
  [6171] = 5794,
  [6172] = 6172,
  [6173] = 5759,
  [6174] = 6174,
  [6175] = 5757,
  [6176] = 6176,
  [6177] = 6177,
  [6178] = 5804,
  [6179] = 6179,
  [6180] = 6180,
  [6181] = 6181,
  [6182] = 6182,
  [6183] = 6183,
  [6184] = 5720,
  [6185] = 6185,
  [6186] = 6186,
  [6187] = 6187,
  [6188] = 5722,
  [6189] = 5723,
  [6190] = 6190,
  [6191] = 6191,
  [6192] = 5869,
  [6193] = 5727,
  [6194] = 5648,
  [6195] = 5885,
  [6196] = 5770,
  [6197] = 5730,
  [6198] = 5732,
  [6199] = 5666,
  [6200] = 6200,
  [6201] = 5753,
  [6202] = 6202,
  [6203] = 6203,
  [6204] = 5643,
  [6205] = 5648,
  [6206] = 5970,
  [6207] = 5768,
  [6208] = 5972,
  [6209] = 5663,
  [6210] = 6210,
  [6211] = 6211,
  [6212] = 6212,
  [6213] = 5667,
  [6214] = 5668,
  [6215] = 6215,
  [6216] = 6216,
  [6217] = 6217,
  [6218] = 5761,
  [6219] = 960,
  [6220] = 6220,
  [6221] = 6221,
  [6222] = 926,
  [6223] = 951,
  [6224] = 940,
  [6225] = 6225,
  [6226] = 6226,
  [6227] = 5732,
  [6228] = 6228,
  [6229] = 5730,
  [6230] = 5727,
  [6231] = 6231,
  [6232] = 6045,
  [6233] = 5723,
  [6234] = 6234,
  [6235] = 5695,
  [6236] = 5641,
  [6237] = 955,
  [6238] = 6238,
  [6239] = 5668,
  [6240] = 5667,
  [6241] = 6241,
  [6242] = 5663,
  [6243] = 6243,
  [6244] = 5667,
  [6245] = 5706,
  [6246] = 5668,
  [6247] = 5669,
  [6248] = 6248,
  [6249] = 5710,
  [6250] = 6250,
  [6251] = 6251,
  [6252] = 6252,
  [6253] = 6253,
  [6254] = 6254,
  [6255] = 6255,
  [6256] = 6256,
  [6257] = 5720,
  [6258] = 6258,
  [6259] = 5722,
  [6260] = 5723,
  [6261] = 5670,
  [6262] = 5727,
  [6263] = 5770,
  [6264] = 5730,
  [6265] = 6265,
  [6266] = 5732,
  [6267] = 5768,
  [6268] = 6268,
  [6269] = 6269,
  [6270] = 6270,
  [6271] = 6271,
  [6272] = 6272,
  [6273] = 5732,
  [6274] = 5730,
  [6275] = 6275,
  [6276] = 5680,
  [6277] = 5727,
  [6278] = 5723,
  [6279] = 6279,
  [6280] = 5722,
  [6281] = 6281,
  [6282] = 5720,
  [6283] = 6283,
  [6284] = 6284,
  [6285] = 5641,
  [6286] = 5695,
  [6287] = 5753,
  [6288] = 6288,
  [6289] = 5755,
  [6290] = 6290,
  [6291] = 5757,
  [6292] = 4588,
  [6293] = 5759,
  [6294] = 6294,
  [6295] = 5761,
  [6296] = 6296,
  [6297] = 6297,
  [6298] = 6298,
  [6299] = 5668,
  [6300] = 5667,
  [6301] = 5663,
  [6302] = 5768,
  [6303] = 6303,
  [6304] = 5770,
  [6305] = 5695,
  [6306] = 6306,
  [6307] = 6307,
  [6308] = 5641,
  [6309] = 5706,
  [6310] = 5874,
  [6311] = 5710,
  [6312] = 6312,
  [6313] = 6313,
  [6314] = 6314,
  [6315] = 5732,
  [6316] = 6316,
  [6317] = 6317,
  [6318] = 6318,
  [6319] = 6319,
  [6320] = 6320,
  [6321] = 6321,
  [6322] = 5720,
  [6323] = 5722,
  [6324] = 5723,
  [6325] = 6325,
  [6326] = 5730,
  [6327] = 6327,
  [6328] = 6328,
  [6329] = 6329,
  [6330] = 6330,
  [6331] = 6331,
  [6332] = 5727,
  [6333] = 6333,
  [6334] = 6334,
  [6335] = 968,
  [6336] = 6336,
  [6337] = 6337,
  [6338] = 6338,
  [6339] = 321,
  [6340] = 6340,
  [6341] = 6341,
  [6342] = 6342,
  [6343] = 6343,
  [6344] = 6344,
  [6345] = 6345,
  [6346] = 6346,
  [6347] = 6347,
  [6348] = 6348,
  [6349] = 6349,
  [6350] = 6350,
  [6351] = 6351,
  [6352] = 6352,
  [6353] = 1108,
  [6354] = 6354,
  [6355] = 965,
  [6356] = 6356,
  [6357] = 6357,
  [6358] = 6358,
  [6359] = 6359,
  [6360] = 1100,
  [6361] = 992,
  [6362] = 6362,
  [6363] = 6363,
  [6364] = 6364,
  [6365] = 6365,
  [6366] = 991,
  [6367] = 6367,
  [6368] = 6351,
  [6369] = 6369,
  [6370] = 6370,
  [6371] = 6371,
  [6372] = 6372,
  [6373] = 6373,
  [6374] = 6374,
  [6375] = 6375,
  [6376] = 996,
  [6377] = 6377,
  [6378] = 6378,
  [6379] = 1098,
  [6380] = 6380,
  [6381] = 6381,
  [6382] = 6382,
  [6383] = 6375,
  [6384] = 6373,
  [6385] = 1094,
  [6386] = 6386,
  [6387] = 6387,
  [6388] = 6334,
  [6389] = 6352,
  [6390] = 6356,
  [6391] = 6391,
  [6392] = 6336,
  [6393] = 6393,
  [6394] = 6394,
  [6395] = 1008,
  [6396] = 6396,
  [6397] = 6397,
  [6398] = 6398,
  [6399] = 6399,
  [6400] = 6400,
  [6401] = 6401,
  [6402] = 6402,
  [6403] = 6403,
  [6404] = 6404,
  [6405] = 6405,
  [6406] = 6406,
  [6407] = 6407,
  [6408] = 6408,
  [6409] = 6409,
  [6410] = 6406,
  [6411] = 6411,
  [6412] = 6409,
  [6413] = 6411,
  [6414] = 6406,
  [6415] = 6415,
  [6416] = 6416,
  [6417] = 6417,
  [6418] = 6411,
  [6419] = 6380,
  [6420] = 6409,
  [6421] = 6351,
  [6422] = 6377,
  [6423] = 6423,
  [6424] = 6362,
  [6425] = 6357,
  [6426] = 976,
  [6427] = 6374,
  [6428] = 6397,
  [6429] = 6429,
  [6430] = 6430,
  [6431] = 6431,
  [6432] = 6432,
  [6433] = 6433,
  [6434] = 6434,
  [6435] = 6394,
  [6436] = 6434,
  [6437] = 6386,
  [6438] = 6393,
  [6439] = 6423,
  [6440] = 6382,
  [6441] = 6433,
  [6442] = 6434,
  [6443] = 6443,
  [6444] = 6433,
  [6445] = 6432,
  [6446] = 6446,
  [6447] = 6423,
  [6448] = 6432,
  [6449] = 6356,
  [6450] = 6334,
  [6451] = 6402,
  [6452] = 6401,
  [6453] = 988,
  [6454] = 999,
  [6455] = 977,
  [6456] = 6456,
  [6457] = 1001,
  [6458] = 6372,
  [6459] = 6459,
  [6460] = 6387,
  [6461] = 6378,
  [6462] = 990,
  [6463] = 6371,
  [6464] = 6369,
  [6465] = 989,
  [6466] = 6466,
  [6467] = 1005,
  [6468] = 6357,
  [6469] = 6362,
  [6470] = 6345,
  [6471] = 1141,
  [6472] = 6472,
  [6473] = 6380,
  [6474] = 6474,
  [6475] = 6475,
  [6476] = 6351,
  [6477] = 6477,
  [6478] = 6478,
  [6479] = 6479,
  [6480] = 6354,
  [6481] = 319,
  [6482] = 6362,
  [6483] = 986,
  [6484] = 6429,
  [6485] = 6485,
  [6486] = 994,
  [6487] = 987,
  [6488] = 6488,
  [6489] = 6356,
  [6490] = 6357,
  [6491] = 1086,
  [6492] = 6492,
  [6493] = 6493,
  [6494] = 6492,
  [6495] = 6485,
  [6496] = 6488,
  [6497] = 6380,
  [6498] = 1006,
  [6499] = 6429,
  [6500] = 6349,
  [6501] = 6501,
  [6502] = 6475,
  [6503] = 3371,
  [6504] = 6382,
  [6505] = 6393,
  [6506] = 6394,
  [6507] = 6346,
  [6508] = 1134,
  [6509] = 6466,
  [6510] = 6417,
  [6511] = 1117,
  [6512] = 6409,
  [6513] = 6411,
  [6514] = 3359,
  [6515] = 6406,
  [6516] = 6456,
  [6517] = 6415,
  [6518] = 6518,
  [6519] = 6408,
  [6520] = 6520,
  [6521] = 6432,
  [6522] = 6433,
  [6523] = 6523,
  [6524] = 6524,
  [6525] = 6525,
  [6526] = 6526,
  [6527] = 1083,
  [6528] = 6434,
  [6529] = 1082,
  [6530] = 6356,
  [6531] = 6531,
  [6532] = 6334,
  [6533] = 6533,
  [6534] = 6423,
  [6535] = 6407,
  [6536] = 1088,
  [6537] = 6537,
  [6538] = 6434,
  [6539] = 982,
  [6540] = 6433,
  [6541] = 6402,
  [6542] = 6401,
  [6543] = 6417,
  [6544] = 6526,
  [6545] = 6336,
  [6546] = 6430,
  [6547] = 1079,
  [6548] = 6432,
  [6549] = 1151,
  [6550] = 6423,
  [6551] = 1081,
  [6552] = 2513,
  [6553] = 6553,
  [6554] = 6554,
  [6555] = 2517,
  [6556] = 6429,
  [6557] = 1003,
  [6558] = 6558,
  [6559] = 6559,
  [6560] = 6338,
  [6561] = 6334,
  [6562] = 6417,
  [6563] = 6526,
  [6564] = 6415,
  [6565] = 6565,
  [6566] = 6352,
  [6567] = 6408,
  [6568] = 6363,
  [6569] = 6365,
  [6570] = 1076,
  [6571] = 6571,
  [6572] = 1150,
  [6573] = 1148,
  [6574] = 6574,
  [6575] = 6415,
  [6576] = 993,
  [6577] = 6407,
  [6578] = 6578,
  [6579] = 6336,
  [6580] = 6554,
  [6581] = 6338,
  [6582] = 6582,
  [6583] = 6352,
  [6584] = 964,
  [6585] = 6346,
  [6586] = 6402,
  [6587] = 6401,
  [6588] = 981,
  [6589] = 6589,
  [6590] = 6590,
  [6591] = 6349,
  [6592] = 6387,
  [6593] = 6593,
  [6594] = 6373,
  [6595] = 6378,
  [6596] = 6375,
  [6597] = 6363,
  [6598] = 6365,
  [6599] = 6369,
  [6600] = 6600,
  [6601] = 6601,
  [6602] = 6602,
  [6603] = 6603,
  [6604] = 6604,
  [6605] = 6377,
  [6606] = 1140,
  [6607] = 1139,
  [6608] = 6387,
  [6609] = 6373,
  [6610] = 6357,
  [6611] = 6378,
  [6612] = 6604,
  [6613] = 6371,
  [6614] = 6375,
  [6615] = 973,
  [6616] = 6408,
  [6617] = 6617,
  [6618] = 6618,
  [6619] = 6619,
  [6620] = 6374,
  [6621] = 6621,
  [6622] = 1138,
  [6623] = 6372,
  [6624] = 6407,
  [6625] = 6625,
  [6626] = 1136,
  [6627] = 6377,
  [6628] = 6628,
  [6629] = 6629,
  [6630] = 6374,
  [6631] = 6369,
  [6632] = 1135,
  [6633] = 980,
  [6634] = 6367,
  [6635] = 969,
  [6636] = 6636,
  [6637] = 6362,
  [6638] = 6372,
  [6639] = 6364,
  [6640] = 979,
  [6641] = 6641,
  [6642] = 6642,
  [6643] = 6643,
  [6644] = 985,
  [6645] = 6601,
  [6646] = 6646,
  [6647] = 978,
  [6648] = 6342,
  [6649] = 6343,
  [6650] = 983,
  [6651] = 975,
  [6652] = 971,
  [6653] = 6345,
  [6654] = 6344,
  [6655] = 6372,
  [6656] = 6656,
  [6657] = 6643,
  [6658] = 6658,
  [6659] = 6659,
  [6660] = 6660,
  [6661] = 6661,
  [6662] = 2475,
  [6663] = 6374,
  [6664] = 6533,
  [6665] = 6619,
  [6666] = 6666,
  [6667] = 6617,
  [6668] = 6668,
  [6669] = 966,
  [6670] = 6351,
  [6671] = 6671,
  [6672] = 6672,
  [6673] = 6641,
  [6674] = 6367,
  [6675] = 3369,
  [6676] = 6558,
  [6677] = 3407,
  [6678] = 4751,
  [6679] = 6679,
  [6680] = 3413,
  [6681] = 3410,
  [6682] = 3368,
  [6683] = 6600,
  [6684] = 1115,
  [6685] = 1066,
  [6686] = 6590,
  [6687] = 6356,
  [6688] = 6380,
  [6689] = 6604,
  [6690] = 6690,
  [6691] = 1051,
  [6692] = 1042,
  [6693] = 6601,
  [6694] = 6377,
  [6695] = 6600,
  [6696] = 6696,
  [6697] = 3373,
  [6698] = 6698,
  [6699] = 6590,
  [6700] = 974,
  [6701] = 3388,
  [6702] = 6342,
  [6703] = 6582,
  [6704] = 6704,
  [6705] = 6582,
  [6706] = 6706,
  [6707] = 6578,
  [6708] = 1047,
  [6709] = 6578,
  [6710] = 6604,
  [6711] = 967,
  [6712] = 6712,
  [6713] = 6713,
  [6714] = 3402,
  [6715] = 6601,
  [6716] = 3399,
  [6717] = 6717,
  [6718] = 6600,
  [6719] = 6719,
  [6720] = 6590,
  [6721] = 6721,
  [6722] = 6722,
  [6723] = 6337,
  [6724] = 3398,
  [6725] = 6351,
  [6726] = 6726,
  [6727] = 6727,
  [6728] = 6728,
  [6729] = 6582,
  [6730] = 6578,
  [6731] = 1110,
  [6732] = 6493,
  [6733] = 1060,
  [6734] = 1050,
  [6735] = 1052,
  [6736] = 1054,
  [6737] = 6354,
  [6738] = 6348,
  [6739] = 6350,
  [6740] = 6740,
  [6741] = 6741,
  [6742] = 6359,
  [6743] = 6741,
  [6744] = 963,
  [6745] = 1033,
  [6746] = 6375,
  [6747] = 6373,
  [6748] = 3362,
  [6749] = 6749,
  [6750] = 6345,
  [6751] = 6751,
  [6752] = 6354,
  [6753] = 6533,
  [6754] = 6754,
  [6755] = 6354,
  [6756] = 6660,
  [6757] = 6757,
  [6758] = 6345,
  [6759] = 6759,
  [6760] = 6382,
  [6761] = 6344,
  [6762] = 6565,
  [6763] = 3394,
  [6764] = 6359,
  [6765] = 1039,
  [6766] = 1046,
  [6767] = 6751,
  [6768] = 3397,
  [6769] = 6493,
  [6770] = 6401,
  [6771] = 6350,
  [6772] = 6712,
  [6773] = 6354,
  [6774] = 6348,
  [6775] = 6775,
  [6776] = 6712,
  [6777] = 6578,
  [6778] = 6778,
  [6779] = 6582,
  [6780] = 6780,
  [6781] = 6660,
  [6782] = 6393,
  [6783] = 6394,
  [6784] = 6359,
  [6785] = 6337,
  [6786] = 6350,
  [6787] = 6787,
  [6788] = 6590,
  [6789] = 6348,
  [6790] = 6790,
  [6791] = 6791,
  [6792] = 6396,
  [6793] = 6741,
  [6794] = 6337,
  [6795] = 6795,
  [6796] = 1064,
  [6797] = 6797,
  [6798] = 6398,
  [6799] = 3361,
  [6800] = 6403,
  [6801] = 1059,
  [6802] = 6802,
  [6803] = 6717,
  [6804] = 6728,
  [6805] = 6805,
  [6806] = 1032,
  [6807] = 6679,
  [6808] = 6558,
  [6809] = 6600,
  [6810] = 6726,
  [6811] = 6811,
  [6812] = 4711,
  [6813] = 6601,
  [6814] = 6754,
  [6815] = 6604,
  [6816] = 6719,
  [6817] = 1048,
  [6818] = 6409,
  [6819] = 6741,
  [6820] = 6820,
  [6821] = 6558,
  [6822] = 6533,
  [6823] = 1053,
  [6824] = 6344,
  [6825] = 6411,
  [6826] = 6406,
  [6827] = 6345,
  [6828] = 6344,
  [6829] = 6367,
  [6830] = 6672,
  [6831] = 6416,
  [6832] = 1130,
  [6833] = 4704,
  [6834] = 4705,
  [6835] = 6371,
  [6836] = 1030,
  [6837] = 6402,
  [6838] = 1029,
  [6839] = 310,
  [6840] = 6343,
  [6841] = 1073,
  [6842] = 6397,
  [6843] = 1087,
  [6844] = 1093,
  [6845] = 1026,
  [6846] = 6386,
  [6847] = 6372,
  [6848] = 1096,
  [6849] = 1080,
  [6850] = 6374,
  [6851] = 6719,
  [6852] = 6852,
  [6853] = 6377,
  [6854] = 6443,
  [6855] = 1099,
  [6856] = 6740,
  [6857] = 6712,
  [6858] = 6858,
  [6859] = 6859,
  [6860] = 1055,
  [6861] = 3391,
  [6862] = 6862,
  [6863] = 6660,
  [6864] = 6367,
  [6865] = 6369,
  [6866] = 6371,
  [6867] = 6378,
  [6868] = 6387,
  [6869] = 6387,
  [6870] = 6401,
  [6871] = 1069,
  [6872] = 1109,
  [6873] = 6402,
  [6874] = 6874,
  [6875] = 6741,
  [6876] = 6359,
  [6877] = 314,
  [6878] = 6378,
  [6879] = 6407,
  [6880] = 1085,
  [6881] = 6408,
  [6882] = 6415,
  [6883] = 6417,
  [6884] = 6726,
  [6885] = 6885,
  [6886] = 6886,
  [6887] = 6429,
  [6888] = 6432,
  [6889] = 1089,
  [6890] = 1122,
  [6891] = 6342,
  [6892] = 6343,
  [6893] = 6433,
  [6894] = 1119,
  [6895] = 6434,
  [6896] = 6375,
  [6897] = 6373,
  [6898] = 6719,
  [6899] = 6899,
  [6900] = 6423,
  [6901] = 6350,
  [6902] = 1118,
  [6903] = 3408,
  [6904] = 6904,
  [6905] = 6533,
  [6906] = 3406,
  [6907] = 6907,
  [6908] = 6404,
  [6909] = 6518,
  [6910] = 6348,
  [6911] = 6365,
  [6912] = 6371,
  [6913] = 6363,
  [6914] = 970,
  [6915] = 6369,
  [6916] = 1123,
  [6917] = 6357,
  [6918] = 6558,
  [6919] = 1009,
  [6920] = 3404,
  [6921] = 6520,
  [6922] = 6719,
  [6923] = 6923,
  [6924] = 6362,
  [6925] = 6523,
  [6926] = 6926,
  [6927] = 6533,
  [6928] = 6726,
  [6929] = 3387,
  [6930] = 6337,
  [6931] = 6365,
  [6932] = 6741,
  [6933] = 6554,
  [6934] = 6352,
  [6935] = 6935,
  [6936] = 6936,
  [6937] = 6660,
  [6938] = 6380,
  [6939] = 6602,
  [6940] = 6382,
  [6941] = 6393,
  [6942] = 6712,
  [6943] = 6524,
  [6944] = 6338,
  [6945] = 6363,
  [6946] = 6726,
  [6947] = 6394,
  [6948] = 6343,
  [6949] = 6342,
  [6950] = 1112,
  [6951] = 6554,
  [6952] = 6336,
  [6953] = 6953,
  [6954] = 1114,
  [6955] = 1010,
  [6956] = 1126,
  [6957] = 1011,
  [6958] = 1129,
  [6959] = 6336,
  [6960] = 6409,
  [6961] = 6411,
  [6962] = 6406,
  [6963] = 6963,
  [6964] = 6338,
  [6965] = 1012,
  [6966] = 3386,
  [6967] = 6397,
  [6968] = 1137,
  [6969] = 6386,
  [6970] = 1014,
  [6971] = 6621,
  [6972] = 6972,
  [6973] = 6554,
  [6974] = 6628,
  [6975] = 6574,
  [6976] = 6642,
  [6977] = 1144,
  [6978] = 1015,
  [6979] = 6979,
  [6980] = 1017,
  [6981] = 1018,
  [6982] = 1022,
  [6983] = 6983,
  [6984] = 1154,
  [6985] = 1027,
  [6986] = 6352,
  [6987] = 6862,
  [6988] = 6988,
  [6989] = 1025,
  [6990] = 6990,
  [6991] = 6991,
  [6992] = 6992,
  [6993] = 6993,
  [6994] = 6994,
  [6995] = 6995,
  [6996] = 6996,
  [6997] = 6997,
  [6998] = 6998,
  [6999] = 6999,
  [7000] = 7000,
  [7001] = 7001,
  [7002] = 7002,
  [7003] = 7003,
  [7004] = 7004,
  [7005] = 7005,
  [7006] = 7000,
  [7007] = 7007,
  [7008] = 7008,
  [7009] = 6993,
  [7010] = 6999,
  [7011] = 7011,
  [7012] = 7001,
  [7013] = 7013,
  [7014] = 6997,
  [7015] = 6990,
  [7016] = 7016,
  [7017] = 7017,
  [7018] = 7018,
  [7019] = 7019,
  [7020] = 6991,
  [7021] = 7021,
  [7022] = 7022,
  [7023] = 7023,
  [7024] = 7024,
  [7025] = 7011,
  [7026] = 7026,
  [7027] = 7027,
  [7028] = 7028,
  [7029] = 7029,
  [7030] = 7030,
  [7031] = 7031,
  [7032] = 7031,
  [7033] = 7030,
  [7034] = 7029,
  [7035] = 7035,
  [7036] = 7036,
  [7037] = 7028,
  [7038] = 7023,
  [7039] = 7027,
  [7040] = 7040,
  [7041] = 7041,
  [7042] = 7042,
  [7043] = 7043,
  [7044] = 7017,
  [7045] = 7016,
  [7046] = 7011,
  [7047] = 7047,
  [7048] = 7048,
  [7049] = 7049,
  [7050] = 7022,
  [7051] = 7051,
  [7052] = 7052,
  [7053] = 7053,
  [7054] = 7054,
  [7055] = 7055,
  [7056] = 7056,
  [7057] = 7057,
  [7058] = 7058,
  [7059] = 7059,
  [7060] = 7004,
  [7061] = 7061,
  [7062] = 7062,
  [7063] = 7018,
  [7064] = 7064,
  [7065] = 7065,
  [7066] = 7066,
  [7067] = 7067,
  [7068] = 6996,
  [7069] = 6995,
  [7070] = 7070,
  [7071] = 6994,
  [7072] = 7072,
  [7073] = 7073,
  [7074] = 6992,
  [7075] = 7075,
  [7076] = 7035,
  [7077] = 6998,
  [7078] = 7078,
  [7079] = 7079,
  [7080] = 7080,
  [7081] = 6990,
  [7082] = 7016,
  [7083] = 7017,
  [7084] = 7084,
  [7085] = 7004,
  [7086] = 7086,
  [7087] = 7018,
  [7088] = 7022,
  [7089] = 7023,
  [7090] = 7090,
  [7091] = 7075,
  [7092] = 7092,
  [7093] = 7047,
  [7094] = 7036,
  [7095] = 7029,
  [7096] = 7030,
  [7097] = 7097,
  [7098] = 7031,
  [7099] = 6996,
  [7100] = 6995,
  [7101] = 6994,
  [7102] = 7067,
  [7103] = 7028,
  [7104] = 7104,
  [7105] = 7027,
  [7106] = 6992,
  [7107] = 7107,
  [7108] = 7108,
  [7109] = 7109,
  [7110] = 7110,
  [7111] = 7111,
  [7112] = 7011,
  [7113] = 7113,
  [7114] = 7114,
  [7115] = 7115,
  [7116] = 7022,
  [7117] = 7117,
  [7118] = 7117,
  [7119] = 7115,
  [7120] = 7120,
  [7121] = 7121,
  [7122] = 7122,
  [7123] = 7113,
  [7124] = 7124,
  [7125] = 7111,
  [7126] = 7126,
  [7127] = 7127,
  [7128] = 7018,
  [7129] = 7018,
  [7130] = 7130,
  [7131] = 7073,
  [7132] = 7110,
  [7133] = 7109,
  [7134] = 7107,
  [7135] = 7135,
  [7136] = 7075,
  [7137] = 7040,
  [7138] = 7042,
  [7139] = 7072,
  [7140] = 7036,
  [7141] = 7047,
  [7142] = 7142,
  [7143] = 7016,
  [7144] = 7017,
  [7145] = 6992,
  [7146] = 7075,
  [7147] = 7073,
  [7148] = 7023,
  [7149] = 7149,
  [7150] = 7027,
  [7151] = 7029,
  [7152] = 6992,
  [7153] = 7031,
  [7154] = 7073,
  [7155] = 7086,
  [7156] = 7080,
  [7157] = 7028,
  [7158] = 7079,
  [7159] = 7027,
  [7160] = 7075,
  [7161] = 7011,
  [7162] = 7086,
  [7163] = 6992,
  [7164] = 7022,
  [7165] = 7022,
  [7166] = 7073,
  [7167] = 7167,
  [7168] = 7168,
  [7169] = 7078,
  [7170] = 7011,
  [7171] = 7121,
  [7172] = 6995,
  [7173] = 7173,
  [7174] = 7066,
  [7175] = 7027,
  [7176] = 7028,
  [7177] = 7065,
  [7178] = 7178,
  [7179] = 7117,
  [7180] = 7028,
  [7181] = 7064,
  [7182] = 7121,
  [7183] = 7115,
  [7184] = 7113,
  [7185] = 7185,
  [7186] = 7186,
  [7187] = 7075,
  [7188] = 7111,
  [7189] = 7189,
  [7190] = 7110,
  [7191] = 6992,
  [7192] = 7053,
  [7193] = 7073,
  [7194] = 7194,
  [7195] = 7031,
  [7196] = 7196,
  [7197] = 7109,
  [7198] = 7198,
  [7199] = 7107,
  [7200] = 6994,
  [7201] = 7201,
  [7202] = 6995,
  [7203] = 6994,
  [7204] = 7030,
  [7205] = 6995,
  [7206] = 6996,
  [7207] = 6996,
  [7208] = 7061,
  [7209] = 7029,
  [7210] = 7117,
  [7211] = 7058,
  [7212] = 7072,
  [7213] = 7115,
  [7214] = 7113,
  [7215] = 7004,
  [7216] = 7216,
  [7217] = 7198,
  [7218] = 6994,
  [7219] = 7111,
  [7220] = 7173,
  [7221] = 7019,
  [7222] = 7168,
  [7223] = 7142,
  [7224] = 7110,
  [7225] = 7109,
  [7226] = 7107,
  [7227] = 7042,
  [7228] = 7072,
  [7229] = 7036,
  [7230] = 6996,
  [7231] = 7008,
  [7232] = 7047,
  [7233] = 7049,
  [7234] = 7108,
  [7235] = 7075,
  [7236] = 7031,
  [7237] = 7023,
  [7238] = 7238,
  [7239] = 7017,
  [7240] = 924,
  [7241] = 7216,
  [7242] = 7016,
  [7243] = 6990,
  [7244] = 7004,
  [7245] = 7245,
  [7246] = 7021,
  [7247] = 7036,
  [7248] = 7086,
  [7249] = 7084,
  [7250] = 7080,
  [7251] = 7079,
  [7252] = 7252,
  [7253] = 7084,
  [7254] = 7004,
  [7255] = 7073,
  [7256] = 7245,
  [7257] = 7047,
  [7258] = 7078,
  [7259] = 7035,
  [7260] = 6996,
  [7261] = 6995,
  [7262] = 7067,
  [7263] = 6994,
  [7264] = 7066,
  [7265] = 7265,
  [7266] = 7065,
  [7267] = 7024,
  [7268] = 7064,
  [7269] = 7061,
  [7270] = 7058,
  [7271] = 7080,
  [7272] = 7026,
  [7273] = 7004,
  [7274] = 7084,
  [7275] = 7238,
  [7276] = 7040,
  [7277] = 7042,
  [7278] = 7079,
  [7279] = 7042,
  [7280] = 7040,
  [7281] = 7040,
  [7282] = 7121,
  [7283] = 7030,
  [7284] = 6994,
  [7285] = 7040,
  [7286] = 7042,
  [7287] = 7042,
  [7288] = 7121,
  [7289] = 6995,
  [7290] = 7053,
  [7291] = 7049,
  [7292] = 7040,
  [7293] = 6997,
  [7294] = 7029,
  [7295] = 7040,
  [7296] = 7042,
  [7297] = 7000,
  [7298] = 6997,
  [7299] = 6996,
  [7300] = 6993,
  [7301] = 7078,
  [7302] = 7302,
  [7303] = 7303,
  [7304] = 7048,
  [7305] = 6997,
  [7306] = 7040,
  [7307] = 7307,
  [7308] = 7035,
  [7309] = 7042,
  [7310] = 6999,
  [7311] = 7041,
  [7312] = 7121,
  [7313] = 7001,
  [7314] = 950,
  [7315] = 7067,
  [7316] = 7053,
  [7317] = 7317,
  [7318] = 7075,
  [7319] = 6992,
  [7320] = 7066,
  [7321] = 6994,
  [7322] = 6995,
  [7323] = 6996,
  [7324] = 7065,
  [7325] = 7049,
  [7326] = 7064,
  [7327] = 7041,
  [7328] = 6997,
  [7329] = 7040,
  [7330] = 7042,
  [7331] = 7004,
  [7332] = 7332,
  [7333] = 7000,
  [7334] = 7023,
  [7335] = 6993,
  [7336] = 7336,
  [7337] = 7121,
  [7338] = 6999,
  [7339] = 7194,
  [7340] = 7001,
  [7341] = 7048,
  [7342] = 7061,
  [7343] = 7054,
  [7344] = 6997,
  [7345] = 7019,
  [7346] = 7189,
  [7347] = 7194,
  [7348] = 7040,
  [7349] = 7042,
  [7350] = 6991,
  [7351] = 7351,
  [7352] = 7004,
  [7353] = 7026,
  [7354] = 7021,
  [7355] = 7216,
  [7356] = 7198,
  [7357] = 7056,
  [7358] = 7024,
  [7359] = 7073,
  [7360] = 7173,
  [7361] = 7059,
  [7362] = 7168,
  [7363] = 7142,
  [7364] = 7008,
  [7365] = 7084,
  [7366] = 7108,
  [7367] = 7024,
  [7368] = 7238,
  [7369] = 7021,
  [7370] = 6992,
  [7371] = 6991,
  [7372] = 7019,
  [7373] = 7026,
  [7374] = 7072,
  [7375] = 7375,
  [7376] = 7017,
  [7377] = 7016,
  [7378] = 7073,
  [7379] = 7189,
  [7380] = 7380,
  [7381] = 7189,
  [7382] = 7194,
  [7383] = 7383,
  [7384] = 7041,
  [7385] = 7002,
  [7386] = 7386,
  [7387] = 7048,
  [7388] = 7058,
  [7389] = 7048,
  [7390] = 7216,
  [7391] = 7198,
  [7392] = 7075,
  [7393] = 6998,
  [7394] = 7173,
  [7395] = 7024,
  [7396] = 7168,
  [7397] = 7142,
  [7398] = 7008,
  [7399] = 7121,
  [7400] = 7108,
  [7401] = 7021,
  [7402] = 7238,
  [7403] = 7041,
  [7404] = 7303,
  [7405] = 6990,
  [7406] = 7049,
  [7407] = 6998,
  [7408] = 7053,
  [7409] = 7189,
  [7410] = 7194,
  [7411] = 4794,
  [7412] = 6997,
  [7413] = 7040,
  [7414] = 7042,
  [7415] = 7019,
  [7416] = 6991,
  [7417] = 7042,
  [7418] = 7216,
  [7419] = 7198,
  [7420] = 7040,
  [7421] = 7021,
  [7422] = 7173,
  [7423] = 7024,
  [7424] = 7168,
  [7425] = 7142,
  [7426] = 7008,
  [7427] = 7026,
  [7428] = 7108,
  [7429] = 7121,
  [7430] = 7238,
  [7431] = 7058,
  [7432] = 7061,
  [7433] = 7064,
  [7434] = 7189,
  [7435] = 7194,
  [7436] = 7065,
  [7437] = 7054,
  [7438] = 7066,
  [7439] = 7067,
  [7440] = 7035,
  [7441] = 7216,
  [7442] = 7198,
  [7443] = 6997,
  [7444] = 7173,
  [7445] = 7078,
  [7446] = 7168,
  [7447] = 7142,
  [7448] = 7001,
  [7449] = 7108,
  [7450] = 7238,
  [7451] = 6999,
  [7452] = 7079,
  [7453] = 7453,
  [7454] = 7336,
  [7455] = 7332,
  [7456] = 6993,
  [7457] = 7080,
  [7458] = 7056,
  [7459] = 7086,
  [7460] = 7117,
  [7461] = 7336,
  [7462] = 7332,
  [7463] = 7115,
  [7464] = 7056,
  [7465] = 7000,
  [7466] = 7336,
  [7467] = 7332,
  [7468] = 7113,
  [7469] = 7056,
  [7470] = 7111,
  [7471] = 7336,
  [7472] = 7332,
  [7473] = 7110,
  [7474] = 7056,
  [7475] = 7109,
  [7476] = 7336,
  [7477] = 7332,
  [7478] = 7107,
  [7479] = 7479,
};

static TSCharacterRange extras_character_set_1[] = {
  {'\t', '\r'}, {' ', ' '}, {0xa0, 0xa0}, {0x1680, 0x1680}, {0x2000, 0x200b}, {0x2028, 0x2029}, {0x202f, 0x202f}, {0x205f, 0x2060},
  {0x3000, 0x3000}, {0xfeff, 0xfeff},
};

static TSCharacterRange extras_character_set_2[] = {
  {'\t', '\r'}, {' ', ' '}, {0xa0, 0xa0}, {0x1680, 0x1680}, {0x2000, 0x200b}, {0x202f, 0x202f}, {0x205f, 0x2060}, {0x3000, 0x3000},
  {0xfeff, 0xfeff},
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0x7f, 0x9f}, {0xa1, 0x167f}, {0x1681, 0x1fff},
  {0x200c, 0x202e}, {0x2030, 0x205e}, {0x2061, 0x2fff}, {0x3001, 0xfefe}, {0xff00, 0x10ffff},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0x7f, 0x9f}, {0xa1, 0x167f},
  {0x1681, 0x1fff}, {0x200c, 0x202e}, {0x2030, 0x205e}, {0x2061, 0x2fff}, {0x3001, 0xfefe}, {0xff00, 0x10ffff},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 34,
        '$', 1032,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        ')', 458,
        '*', 419,
        '+', 571,
        ',', 438,
        '-', 575,
        '.', 502,
        '/', 628,
        '0', 660,
        ':', 473,
        ';', 472,
        '<', 584,
        '=', 427,
        '>', 498,
        '?', 1052,
        '@', 1046,
        '[', 480,
        '\\', 345,
        ']', 481,
        '^', 561,
        '`', 626,
        'a', 810,
        'b', 951,
        'c', 779,
        'd', 836,
        'e', 894,
        'f', 880,
        'g', 900,
        'i', 909,
        'l', 837,
        'm', 945,
        'n', 780,
        'o', 815,
        'r', 839,
        's', 785,
        't', 789,
        'u', 930,
        'v', 792,
        'w', 878,
        '{', 437,
        '|', 564,
        '}', 439,
        '~', 601,
        0x2028, 677,
        0x2029, 677,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(403);
      if (lookahead > '@') ADVANCE(1042);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(65);
      if (lookahead == ' ') ADVANCE(1);
      if (lookahead == '&') ADVANCE(60);
      if (lookahead == '/') ADVANCE(488);
      if (lookahead == '<') ADVANCE(583);
      if (lookahead == '{') ADVANCE(436);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(490);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(489);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(2);
      if (lookahead == '/') ADVANCE(483);
      if (lookahead == '<') ADVANCE(485);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(484);
      if (lookahead != 0) ADVANCE(482);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(90);
      if (lookahead == '/') ADVANCE(69);
      if (lookahead == '[') ADVANCE(140);
      if (lookahead == '\\') ADVANCE(402);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(629);
      if (lookahead != 0) ADVANCE(630);
      END_STATE();
    case 4:
      if (lookahead == ' ') ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '&' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(489);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        ' ', 5,
        '*', 491,
        '\n', 72,
        '&', 72,
        '<', 72,
        '>', 72,
        '{', 72,
        '}', 72,
      );
      if (lookahead != 0) ADVANCE(492);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        ')', 458,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 502,
        '/', 577,
        '0', 660,
        ':', 473,
        ';', 472,
        '<', 586,
        '=', 427,
        '>', 498,
        '?', 1052,
        '@', 1046,
        '[', 480,
        '\\', 352,
        ']', 481,
        '^', 561,
        '`', 626,
        'a', 923,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 920,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 946,
        '{', 436,
        '|', 563,
        '}', 439,
        '~', 601,
        0x2028, 750,
        0x2029, 750,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(6);
      if (lookahead > '#') ADVANCE(1042);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        ')', 458,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 502,
        '/', 577,
        '0', 660,
        ':', 473,
        '<', 586,
        '=', 427,
        '>', 498,
        '?', 1052,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '^', 561,
        '`', 626,
        'a', 810,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 920,
        'l', 837,
        'm', 945,
        'n', 780,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'u', 930,
        'v', 946,
        '{', 437,
        '|', 563,
        '~', 601,
        0x2028, 747,
        0x2029, 747,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(7);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 503,
        '/', 577,
        '0', 660,
        ':', 473,
        ';', 472,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 1052,
        '[', 480,
        '\\', 352,
        '^', 561,
        '`', 626,
        'a', 924,
        'b', 951,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 934,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        '|', 563,
        '}', 439,
        0x2028, 755,
        0x2029, 755,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(8);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 503,
        '/', 577,
        '0', 660,
        ':', 473,
        ';', 472,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 1052,
        '[', 480,
        '\\', 352,
        '^', 561,
        '`', 626,
        'a', 924,
        'b', 951,
        'd', 856,
        'e', 1025,
        'i', 934,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        '|', 563,
        '}', 439,
        0x2028, 756,
        0x2029, 756,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(9);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 503,
        '/', 577,
        '0', 660,
        ';', 472,
        '<', 586,
        '=', 427,
        '>', 498,
        '?', 78,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '^', 561,
        '`', 626,
        'a', 923,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 920,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 815,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 946,
        '{', 436,
        '|', 563,
        '~', 601,
        0x2028, 749,
        0x2029, 749,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(10);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 503,
        '/', 577,
        '0', 660,
        '<', 586,
        '=', 427,
        '>', 498,
        '?', 78,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '^', 561,
        '`', 626,
        'a', 923,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 910,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 946,
        '{', 436,
        '|', 563,
        '~', 601,
        0x2028, 751,
        0x2029, 751,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(11);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 578,
        '&', 559,
        '\'', 507,
        '(', 457,
        ')', 458,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 503,
        '/', 576,
        '0', 660,
        ':', 473,
        ';', 472,
        '<', 588,
        '=', 134,
        '>', 499,
        '?', 79,
        '@', 1046,
        '[', 480,
        '\\', 352,
        ']', 481,
        '^', 560,
        '`', 626,
        'a', 923,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 920,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 946,
        '{', 436,
        '|', 565,
        '}', 439,
        '~', 601,
        0x2028, 750,
        0x2029, 750,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(12);
      if (lookahead > '#') ADVANCE(1042);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 578,
        '&', 559,
        '\'', 507,
        '(', 457,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 503,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 588,
        '=', 134,
        '>', 499,
        '?', 79,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '^', 560,
        '`', 626,
        'a', 923,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 920,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 815,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 946,
        '{', 436,
        '|', 565,
        '~', 601,
        0x2028, 749,
        0x2029, 749,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(13);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 578,
        '&', 559,
        '\'', 507,
        '(', 457,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 503,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 588,
        '=', 426,
        '>', 499,
        '?', 79,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '^', 560,
        '`', 626,
        'a', 810,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 928,
        'f', 1015,
        'i', 919,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '|', 565,
        '}', 439,
        '~', 601,
        0x2028, 744,
        0x2029, 744,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(14);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 578,
        '&', 559,
        '\'', 507,
        '(', 457,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 503,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 588,
        '=', 426,
        '>', 499,
        '?', 79,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '^', 560,
        '`', 626,
        'a', 810,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 895,
        'f', 1015,
        'i', 919,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '|', 565,
        '}', 439,
        '~', 601,
        0x2028, 745,
        0x2029, 745,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(15);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 578,
        '&', 559,
        '\'', 507,
        '(', 457,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 503,
        '/', 576,
        '0', 660,
        '<', 588,
        '=', 134,
        '>', 499,
        '?', 79,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '^', 560,
        '`', 626,
        'a', 923,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 910,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 946,
        '{', 436,
        '|', 565,
        '~', 601,
        0x2028, 751,
        0x2029, 751,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(16);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        ')', 458,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 503,
        '/', 577,
        '0', 660,
        ':', 473,
        ';', 472,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 1052,
        '[', 480,
        '\\', 352,
        ']', 481,
        '^', 561,
        '`', 626,
        'a', 811,
        'b', 951,
        'c', 950,
        'i', 934,
        'n', 838,
        'o', 816,
        'r', 862,
        's', 785,
        'u', 930,
        'v', 946,
        '{', 437,
        '|', 563,
        '}', 439,
        0x2028, 753,
        0x2029, 753,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(17);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        ')', 458,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 501,
        '/', 577,
        ':', 473,
        ';', 472,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 1052,
        '[', 480,
        '\\', 352,
        ']', 481,
        '^', 561,
        '`', 626,
        'a', 985,
        'i', 934,
        's', 786,
        '{', 436,
        '|', 563,
        '}', 439,
        0x2028, 800,
        0x2029, 800,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(18);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 503,
        '/', 577,
        '0', 660,
        ';', 472,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 1052,
        '[', 480,
        '\\', 352,
        '^', 561,
        '`', 626,
        'a', 811,
        'b', 951,
        'c', 950,
        'i', 934,
        'n', 838,
        'o', 815,
        'r', 862,
        's', 785,
        'u', 930,
        'v', 946,
        '{', 437,
        '|', 563,
        0x2028, 752,
        0x2029, 752,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(19);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 503,
        '/', 577,
        '0', 660,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 1052,
        '[', 480,
        '\\', 352,
        '^', 561,
        '`', 626,
        'a', 811,
        'b', 951,
        'c', 950,
        'i', 915,
        'n', 838,
        'o', 816,
        'r', 862,
        's', 785,
        'u', 930,
        'v', 946,
        '{', 437,
        '|', 563,
        0x2028, 754,
        0x2029, 754,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(20);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 501,
        '/', 577,
        ';', 472,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 78,
        '[', 480,
        '\\', 352,
        '^', 561,
        '`', 626,
        'a', 985,
        'i', 934,
        'o', 869,
        's', 786,
        '{', 436,
        '|', 563,
        0x2028, 799,
        0x2029, 799,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(21);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 501,
        '/', 577,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 78,
        '[', 480,
        '\\', 352,
        '^', 561,
        '`', 626,
        'a', 985,
        'i', 915,
        's', 786,
        '{', 436,
        '|', 563,
        0x2028, 801,
        0x2029, 801,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(22);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '!', 454,
        '%', 579,
        '&', 558,
        '(', 457,
        ')', 458,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 501,
        '/', 577,
        ':', 473,
        ';', 472,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 1052,
        '[', 480,
        '\\', 352,
        ']', 481,
        '^', 561,
        '`', 626,
        'a', 924,
        'b', 951,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 934,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        '|', 563,
        '}', 439,
        0x2028, 783,
        0x2029, 783,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(23);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 24:
      ADVANCE_MAP(
        '!', 454,
        '%', 579,
        '&', 558,
        '(', 457,
        ')', 458,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 501,
        '/', 577,
        ':', 473,
        ';', 472,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 1052,
        '[', 480,
        ']', 481,
        '^', 561,
        '`', 626,
        'a', 317,
        'e', 358,
        'f', 306,
        'i', 262,
        'o', 213,
        's', 147,
        '{', 436,
        '|', 564,
        '}', 439,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(24);
      END_STATE();
    case 25:
      ADVANCE_MAP(
        '!', 454,
        '%', 579,
        '&', 558,
        '(', 457,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 501,
        '/', 577,
        ';', 472,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 78,
        '[', 480,
        '\\', 352,
        '^', 561,
        '`', 626,
        'a', 924,
        'b', 951,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 934,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 815,
        'r', 862,
        's', 785,
        't', 1030,
        '|', 563,
        0x2028, 782,
        0x2029, 782,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(25);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 26:
      ADVANCE_MAP(
        '!', 454,
        '%', 579,
        '&', 558,
        '(', 457,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 501,
        '/', 577,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 78,
        '[', 480,
        '\\', 352,
        '^', 561,
        '`', 626,
        'a', 924,
        'b', 951,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 915,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        '{', 436,
        '|', 563,
        0x2028, 784,
        0x2029, 784,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(26);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 27:
      ADVANCE_MAP(
        '!', 454,
        '%', 578,
        '&', 559,
        '(', 457,
        ')', 458,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 501,
        '/', 576,
        ':', 473,
        ';', 472,
        '<', 587,
        '=', 134,
        '>', 499,
        '?', 79,
        '[', 480,
        ']', 481,
        '^', 560,
        '`', 626,
        'a', 651,
        'i', 646,
        's', 631,
        '{', 437,
        '|', 565,
        '}', 439,
      );
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(28);
      END_STATE();
    case 28:
      ADVANCE_MAP(
        '!', 454,
        '%', 578,
        '&', 559,
        '(', 457,
        ')', 458,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 501,
        '/', 576,
        ':', 473,
        ';', 472,
        '<', 587,
        '=', 134,
        '>', 499,
        '?', 79,
        '[', 480,
        ']', 481,
        '^', 560,
        '`', 626,
        'a', 317,
        'i', 269,
        's', 147,
        '{', 437,
        '|', 565,
        '}', 439,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(28);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        '!', 454,
        '%', 578,
        '&', 559,
        '(', 457,
        ')', 458,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 501,
        '/', 576,
        ':', 473,
        ';', 472,
        '<', 587,
        '=', 426,
        '>', 499,
        '?', 1053,
        '[', 480,
        ']', 481,
        '^', 560,
        '`', 626,
        'a', 317,
        'e', 238,
        'i', 263,
        'o', 213,
        's', 147,
        'w', 220,
        '{', 436,
        '|', 566,
        '}', 439,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(29);
      END_STATE();
    case 30:
      ADVANCE_MAP(
        '!', 454,
        '%', 578,
        '&', 559,
        '(', 457,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 501,
        '/', 576,
        ';', 472,
        '<', 587,
        '=', 134,
        '>', 499,
        '?', 79,
        '[', 480,
        '^', 560,
        '`', 626,
        'a', 651,
        'i', 646,
        'o', 639,
        's', 631,
        '|', 565,
      );
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(31);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        '!', 454,
        '%', 578,
        '&', 559,
        '(', 457,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 501,
        '/', 576,
        ';', 472,
        '<', 587,
        '=', 134,
        '>', 499,
        '?', 79,
        '[', 480,
        '^', 560,
        '`', 626,
        'a', 317,
        'i', 269,
        'o', 213,
        's', 147,
        '|', 565,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(31);
      END_STATE();
    case 32:
      ADVANCE_MAP(
        '!', 454,
        '%', 578,
        '&', 559,
        '(', 457,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 501,
        '/', 576,
        '<', 587,
        '=', 134,
        '>', 499,
        '?', 79,
        '[', 480,
        '^', 560,
        '`', 626,
        'a', 651,
        'i', 644,
        's', 631,
        '{', 436,
        '|', 565,
      );
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(33);
      END_STATE();
    case 33:
      ADVANCE_MAP(
        '!', 454,
        '%', 578,
        '&', 559,
        '(', 457,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 501,
        '/', 576,
        '<', 587,
        '=', 134,
        '>', 499,
        '?', 79,
        '[', 480,
        '^', 560,
        '`', 626,
        'a', 317,
        'i', 262,
        's', 147,
        '{', 436,
        '|', 565,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(33);
      END_STATE();
    case 34:
      if (lookahead == '!') ADVANCE(415);
      if (lookahead == '\\') ADVANCE(351);
      if (set_contains(sym_identifier_character_set_1, 13, lookahead)) ADVANCE(1043);
      END_STATE();
    case 35:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '&', 557,
        '\'', 507,
        '(', 457,
        ')', 458,
        '*', 418,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 76,
        '/', 576,
        '0', 660,
        '<', 589,
        '?', 1050,
        '@', 1046,
        '[', 480,
        '\\', 352,
        ']', 481,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 922,
        'l', 837,
        'm', 945,
        'n', 780,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'u', 930,
        'v', 946,
        '{', 437,
        '|', 562,
        '~', 601,
        0x2028, 769,
        0x2029, 769,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(35);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 36:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '&', 557,
        '\'', 507,
        '(', 457,
        ')', 458,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 378,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '>', 497,
        '?', 1050,
        '@', 1046,
        '[', 480,
        '\\', 352,
        ']', 481,
        '`', 626,
        'a', 925,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1024,
        'f', 1015,
        'i', 922,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 946,
        '{', 436,
        '|', 567,
        '}', 439,
        '~', 601,
        0x2028, 776,
        0x2029, 776,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(36);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 37:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        ')', 458,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 502,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        ']', 481,
        '`', 626,
        'a', 925,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 922,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 946,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 775,
        0x2029, 775,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(37);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 38:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '*', 418,
        '+', 568,
        ',', 438,
        '-', 572,
        '.', 502,
        '/', 69,
        '0', 660,
        ':', 473,
        ';', 472,
        '<', 582,
        '=', 425,
        '?', 1050,
        '@', 1046,
        '[', 480,
        '\\', 352,
        'a', 813,
        'b', 951,
        'd', 856,
        'e', 1025,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        '{', 436,
        '|', 371,
        '}', 439,
        0x2028, 777,
        0x2029, 777,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(38);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || 'b' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 39:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '*', 418,
        ',', 438,
        '.', 76,
        '/', 69,
        '0', 660,
        ':', 473,
        ';', 472,
        '<', 582,
        '=', 428,
        '?', 1050,
        '[', 480,
        '\\', 352,
        'a', 926,
        'b', 951,
        'd', 856,
        'e', 1025,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        '{', 436,
        '|', 371,
        '}', 439,
        0x2028, 778,
        0x2029, 778,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(39);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || 'b' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 40:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 503,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 928,
        'f', 1015,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 763,
        0x2029, 763,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(40);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 41:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 503,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 895,
        'f', 1015,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 765,
        0x2029, 765,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(41);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 42:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 378,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 779,
        'd', 836,
        'e', 928,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 760,
        0x2029, 760,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(42);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 43:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 378,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 779,
        'd', 836,
        'e', 895,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 761,
        0x2029, 761,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(43);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 44:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 378,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 928,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 762,
        0x2029, 762,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(44);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 45:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 378,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 895,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 764,
        0x2029, 764,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(45);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 46:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 378,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 925,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 922,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        '{', 436,
        '~', 601,
        0x2028, 774,
        0x2029, 774,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(46);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 47:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 378,
        '/', 576,
        '0', 660,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 928,
        'f', 1015,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        '{', 436,
        '~', 601,
        0x2028, 768,
        0x2029, 768,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(47);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 48:
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '&', 557,
        '\'', 507,
        '(', 457,
        ')', 458,
        '*', 418,
        ',', 438,
        '.', 501,
        '/', 69,
        ':', 473,
        ';', 472,
        '<', 582,
        '=', 428,
        '>', 497,
        '?', 1050,
        '@', 1046,
        '[', 480,
        ']', 481,
        '`', 626,
        'a', 164,
        'c', 241,
        'd', 185,
        'e', 237,
        'f', 347,
        'i', 257,
        'l', 197,
        'm', 282,
        'n', 143,
        't', 362,
        'v', 150,
        'w', 221,
        '{', 436,
        '|', 567,
        '}', 439,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(48);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '!', 453,
        '&', 557,
        '(', 457,
        ')', 458,
        ',', 438,
        '.', 501,
        '/', 69,
        ':', 473,
        ';', 472,
        '<', 582,
        '=', 428,
        '>', 497,
        '?', 1051,
        '@', 1046,
        '[', 480,
        ']', 481,
        '`', 626,
        'a', 165,
        'c', 240,
        'e', 357,
        'i', 270,
        'o', 213,
        '{', 436,
        '|', 567,
        '}', 439,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(49);
      END_STATE();
    case 50:
      ADVANCE_MAP(
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '*', 418,
        '.', 501,
        '/', 69,
        ';', 472,
        '<', 582,
        '?', 77,
        '[', 480,
        '\\', 352,
        '`', 626,
        '{', 436,
        0x2028, 1036,
        0x2029, 1036,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(50);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        '"', 506,
        '&', 557,
        '\'', 507,
        '(', 457,
        '*', 418,
        '+', 568,
        ',', 438,
        '-', 572,
        '.', 76,
        '/', 69,
        '0', 660,
        '<', 582,
        '?', 1050,
        '[', 480,
        '\\', 352,
        ']', 481,
        '`', 626,
        'a', 814,
        'b', 951,
        'c', 950,
        'n', 838,
        'o', 816,
        'r', 862,
        's', 994,
        'u', 930,
        'v', 946,
        '{', 437,
        '|', 562,
        0x2028, 758,
        0x2029, 758,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(51);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 52:
      ADVANCE_MAP(
        '"', 506,
        '&', 557,
        '\'', 507,
        '(', 457,
        '*', 418,
        '+', 568,
        '-', 572,
        '.', 378,
        '/', 69,
        '0', 660,
        '<', 582,
        '>', 497,
        '?', 1050,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 814,
        'b', 951,
        'c', 950,
        'i', 922,
        'n', 838,
        'o', 816,
        'r', 862,
        's', 994,
        'u', 930,
        'v', 946,
        '{', 437,
        '|', 562,
        0x2028, 757,
        0x2029, 757,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(52);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 53:
      ADVANCE_MAP(
        '"', 506,
        '&', 557,
        '\'', 507,
        '(', 457,
        '*', 418,
        '+', 568,
        '-', 572,
        '.', 378,
        '/', 69,
        '0', 660,
        '<', 582,
        '?', 1050,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 681,
        'b', 721,
        'c', 719,
        'n', 690,
        'o', 682,
        'r', 691,
        's', 731,
        'u', 708,
        'v', 716,
        '{', 437,
        '|', 562,
        0x2028, 759,
        0x2029, 759,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(53);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (lookahead > '~') ADVANCE(1042);
      END_STATE();
    case 54:
      if (lookahead == '"') ADVANCE(506);
      if (lookahead == '&') ADVANCE(62);
      if (lookahead == '/') ADVANCE(510);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(509);
      if (lookahead != 0) ADVANCE(511);
      END_STATE();
    case 55:
      ADVANCE_MAP(
        '"', 506,
        '\'', 507,
        '(', 457,
        '*', 418,
        ',', 438,
        '.', 501,
        '/', 69,
        '<', 582,
        '?', 77,
        '\\', 352,
        '`', 626,
        't', 1030,
        '{', 436,
        '}', 439,
        0x2028, 1006,
        0x2029, 1006,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(55);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 56:
      ADVANCE_MAP(
        '"', 506,
        '\'', 507,
        '*', 418,
        ',', 438,
        '/', 69,
        '\\', 352,
        'f', 973,
        't', 1030,
        '{', 436,
        0x2028, 873,
        0x2029, 873,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(56);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 57:
      ADVANCE_MAP(
        '"', 506,
        '\'', 507,
        ',', 438,
        '/', 69,
        '\\', 352,
        'a', 985,
        't', 1030,
        '}', 439,
        0x2028, 802,
        0x2029, 802,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(57);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 58:
      if (lookahead == '"') ADVANCE(506);
      if (lookahead == '/') ADVANCE(69);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(58);
      END_STATE();
    case 59:
      if (lookahead == '"') ADVANCE(506);
      if (lookahead == '/') ADVANCE(607);
      if (lookahead == '\\') ADVANCE(354);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(58);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(610);
      if (lookahead != 0) ADVANCE(611);
      END_STATE();
    case 60:
      if (lookahead == '#') ADVANCE(374);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(133);
      END_STATE();
    case 61:
      if (lookahead == '#') ADVANCE(374);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(133);
      if (lookahead != 0) ADVANCE(517);
      END_STATE();
    case 62:
      if (lookahead == '#') ADVANCE(374);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(133);
      if (lookahead != 0) ADVANCE(511);
      END_STATE();
    case 63:
      ADVANCE_MAP(
        '&', 557,
        '(', 457,
        ')', 458,
        ',', 438,
        '.', 501,
        '/', 69,
        ':', 473,
        '<', 582,
        '=', 428,
        '>', 497,
        '?', 1050,
        '[', 480,
        ']', 481,
        '`', 626,
        'a', 317,
        'e', 238,
        'f', 306,
        'i', 271,
        'o', 213,
        'w', 220,
        '{', 436,
        '|', 562,
        '}', 439,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(63);
      END_STATE();
    case 64:
      ADVANCE_MAP(
        '&', 557,
        ',', 438,
        '.', 501,
        '/', 70,
        ':', 473,
        '<', 582,
        '=', 425,
        '>', 497,
        '[', 480,
        '\\', 352,
        'e', 740,
        '{', 436,
        '|', 562,
        0x2028, 850,
        0x2029, 850,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(64);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (lookahead > '~') ADVANCE(1042);
      END_STATE();
    case 65:
      if (lookahead == '&') ADVANCE(60);
      if (lookahead == '/') ADVANCE(488);
      if (lookahead == '<') ADVANCE(583);
      if (lookahead == '{') ADVANCE(436);
      if (lookahead == '\n' ||
          lookahead == ' ') SKIP(65);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(490);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(489);
      END_STATE();
    case 66:
      if (lookahead == '&') ADVANCE(61);
      if (lookahead == '\'') ADVANCE(507);
      if (lookahead == '/') ADVANCE(516);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(515);
      if (lookahead != 0) ADVANCE(517);
      END_STATE();
    case 67:
      if (lookahead == '\'') ADVANCE(507);
      if (lookahead == '/') ADVANCE(69);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(67);
      END_STATE();
    case 68:
      if (lookahead == '\'') ADVANCE(507);
      if (lookahead == '/') ADVANCE(612);
      if (lookahead == '\\') ADVANCE(354);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(67);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(615);
      if (lookahead != 0) ADVANCE(616);
      END_STATE();
    case 69:
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '/') ADVANCE(625);
      END_STATE();
    case 70:
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '/') ADVANCE(625);
      if (lookahead == '>') ADVANCE(505);
      END_STATE();
    case 71:
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '/') ADVANCE(622);
      if (lookahead != 0) ADVANCE(72);
      END_STATE();
    case 72:
      if (lookahead == '*') ADVANCE(71);
      if (lookahead != 0) ADVANCE(72);
      END_STATE();
    case 73:
      if (lookahead == '*') ADVANCE(518);
      if (lookahead == '#' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(72);
      if (lookahead != 0) ADVANCE(519);
      END_STATE();
    case 74:
      if (lookahead == '*') ADVANCE(512);
      if (lookahead == '#' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(72);
      if (lookahead != 0) ADVANCE(513);
      END_STATE();
    case 75:
      ADVANCE_MAP(
        '+', 137,
        ',', 438,
        '-', 138,
        '.', 501,
        '/', 69,
        ':', 473,
        '<', 582,
        '?', 94,
        'e', 358,
        '{', 437,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(75);
      END_STATE();
    case 76:
      if (lookahead == '.') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(674);
      END_STATE();
    case 77:
      if (lookahead == '.') ADVANCE(527);
      END_STATE();
    case 78:
      if (lookahead == '.') ADVANCE(527);
      if (lookahead == '?') ADVANCE(597);
      END_STATE();
    case 79:
      if (lookahead == '.') ADVANCE(527);
      if (lookahead == '?') ADVANCE(596);
      END_STATE();
    case 80:
      if (lookahead == '.') ADVANCE(546);
      END_STATE();
    case 81:
      ADVANCE_MAP(
        '.', 501,
        '/', 70,
        ':', 473,
        '<', 582,
        '=', 425,
        '>', 497,
        '\\', 352,
        '{', 436,
        0x2028, 1035,
        0x2029, 1035,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(81);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (lookahead > '~') ADVANCE(1042);
      END_STATE();
    case 82:
      if (lookahead == '/') ADVANCE(628);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(90);
      END_STATE();
    case 83:
      if (lookahead == '/') ADVANCE(69);
      if (lookahead == '<') ADVANCE(582);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(1026);
      if (lookahead == 'i') ADVANCE(916);
      if (lookahead == '{') ADVANCE(436);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(852);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(83);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 84:
      if (lookahead == '/') ADVANCE(69);
      if (lookahead == '>') ADVANCE(497);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(950);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(826);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(84);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 85:
      if (lookahead == '/') ADVANCE(69);
      if (lookahead == '[') ADVANCE(480);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(929);
      if (lookahead == '{') ADVANCE(436);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(865);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(85);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 86:
      ADVANCE_MAP(
        '/', 69,
        '\\', 352,
        'a', 926,
        'b', 951,
        'd', 856,
        'e', 1025,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        0x2028, 790,
        0x2029, 790,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(86);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || 'b' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 87:
      ADVANCE_MAP(
        '/', 69,
        '\\', 352,
        'a', 927,
        'b', 951,
        'n', 851,
        'o', 816,
        's', 994,
        'u', 930,
        'v', 946,
        0x2028, 804,
        0x2029, 804,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(87);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || 'b' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 88:
      if (lookahead == '/') ADVANCE(69);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(922);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(883);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(88);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 89:
      if (lookahead == '/') ADVANCE(69);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(867);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(980);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(89);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 90:
      if (lookahead == '/') ADVANCE(69);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(90);
      END_STATE();
    case 91:
      if (lookahead == '/') ADVANCE(70);
      if (lookahead == '>') ADVANCE(497);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(719);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(822);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(91);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (lookahead > '~') ADVANCE(1042);
      END_STATE();
    case 92:
      if (lookahead == ':') ADVANCE(1097);
      END_STATE();
    case 93:
      if (lookahead == ':') ADVANCE(1096);
      END_STATE();
    case 94:
      if (lookahead == ':') ADVANCE(1098);
      END_STATE();
    case 95:
      if (lookahead == ';') ADVANCE(496);
      END_STATE();
    case 96:
      if (lookahead == ';') ADVANCE(496);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(95);
      END_STATE();
    case 97:
      if (lookahead == ';') ADVANCE(496);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 98:
      if (lookahead == ';') ADVANCE(496);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      END_STATE();
    case 99:
      if (lookahead == ';') ADVANCE(496);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      END_STATE();
    case 100:
      if (lookahead == ';') ADVANCE(496);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(95);
      END_STATE();
    case 101:
      if (lookahead == ';') ADVANCE(496);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(100);
      END_STATE();
    case 102:
      if (lookahead == ';') ADVANCE(496);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(101);
      END_STATE();
    case 103:
      if (lookahead == ';') ADVANCE(496);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(102);
      END_STATE();
    case 104:
      if (lookahead == ';') ADVANCE(496);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(103);
      END_STATE();
    case 105:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(95);
      END_STATE();
    case 106:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(105);
      END_STATE();
    case 107:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(106);
      END_STATE();
    case 108:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(107);
      END_STATE();
    case 109:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      END_STATE();
    case 110:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 111:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(110);
      END_STATE();
    case 112:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(111);
      END_STATE();
    case 113:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(112);
      END_STATE();
    case 114:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(113);
      END_STATE();
    case 115:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(114);
      END_STATE();
    case 116:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(115);
      END_STATE();
    case 117:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(116);
      END_STATE();
    case 118:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(117);
      END_STATE();
    case 119:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(118);
      END_STATE();
    case 120:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 121:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 122:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(121);
      END_STATE();
    case 123:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 124:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(123);
      END_STATE();
    case 125:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(124);
      END_STATE();
    case 126:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 127:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 128:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 129:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(128);
      END_STATE();
    case 130:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 131:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 132:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(131);
      END_STATE();
    case 133:
      if (lookahead == ';') ADVANCE(496);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(132);
      END_STATE();
    case 134:
      if (lookahead == '=') ADVANCE(591);
      END_STATE();
    case 135:
      if (lookahead == '>') ADVANCE(486);
      END_STATE();
    case 136:
      if (lookahead == '>') ADVANCE(487);
      END_STATE();
    case 137:
      if (lookahead == '?') ADVANCE(92);
      END_STATE();
    case 138:
      if (lookahead == '?') ADVANCE(93);
      END_STATE();
    case 139:
      if (lookahead == '\\') ADVANCE(351);
      if (set_contains(sym_identifier_character_set_1, 13, lookahead)) ADVANCE(1043);
      END_STATE();
    case 140:
      if (lookahead == '\\') ADVANCE(401);
      if (lookahead == ']') ADVANCE(630);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(140);
      END_STATE();
    case 141:
      if (lookahead == 'a') ADVANCE(335);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(322);
      if (lookahead == 'l') ADVANCE(149);
      if (lookahead == 'o') ADVANCE(281);
      END_STATE();
    case 143:
      if (lookahead == 'a') ADVANCE(260);
      END_STATE();
    case 144:
      if (lookahead == 'a') ADVANCE(260);
      if (lookahead == 'e') ADVANCE(355);
      if (lookahead == 'u') ADVANCE(258);
      END_STATE();
    case 145:
      if (lookahead == 'a') ADVANCE(181);
      if (lookahead == 'q') ADVANCE(349);
      END_STATE();
    case 146:
      if (lookahead == 'a') ADVANCE(301);
      if (lookahead == 'y') ADVANCE(297);
      END_STATE();
    case 147:
      if (lookahead == 'a') ADVANCE(337);
      END_STATE();
    case 148:
      if (lookahead == 'a') ADVANCE(337);
      if (lookahead == 't') ADVANCE(307);
      if (lookahead == 'y') ADVANCE(259);
      END_STATE();
    case 149:
      if (lookahead == 'a') ADVANCE(320);
      END_STATE();
    case 150:
      if (lookahead == 'a') ADVANCE(302);
      END_STATE();
    case 151:
      if (lookahead == 'a') ADVANCE(302);
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 152:
      if (lookahead == 'a') ADVANCE(226);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(244);
      END_STATE();
    case 154:
      if (lookahead == 'a') ADVANCE(234);
      END_STATE();
    case 155:
      if (lookahead == 'a') ADVANCE(311);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(276);
      END_STATE();
    case 157:
      if (lookahead == 'a') ADVANCE(266);
      END_STATE();
    case 158:
      if (lookahead == 'a') ADVANCE(348);
      END_STATE();
    case 159:
      if (lookahead == 'a') ADVANCE(175);
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(173);
      END_STATE();
    case 161:
      if (lookahead == 'a') ADVANCE(176);
      END_STATE();
    case 162:
      if (lookahead == 'a') ADVANCE(343);
      END_STATE();
    case 163:
      if (lookahead == 'b') ADVANCE(321);
      if (lookahead == 'n') ADVANCE(359);
      if (lookahead == 's') ADVANCE(432);
      if (lookahead == 'w') ADVANCE(152);
      END_STATE();
    case 164:
      if (lookahead == 'b') ADVANCE(321);
      if (lookahead == 's') ADVANCE(432);
      END_STATE();
    case 165:
      if (lookahead == 'b') ADVANCE(321);
      if (lookahead == 's') ADVANCE(429);
      END_STATE();
    case 166:
      if (lookahead == 'b') ADVANCE(232);
      END_STATE();
    case 167:
      if (lookahead == 'b') ADVANCE(154);
      END_STATE();
    case 168:
      if (lookahead == 'b') ADVANCE(290);
      END_STATE();
    case 169:
      if (lookahead == 'b') ADVANCE(204);
      END_STATE();
    case 170:
      if (lookahead == 'c') ADVANCE(522);
      END_STATE();
    case 171:
      if (lookahead == 'c') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(331);
      END_STATE();
    case 173:
      if (lookahead == 'c') ADVANCE(334);
      END_STATE();
    case 174:
      if (lookahead == 'c') ADVANCE(205);
      END_STATE();
    case 175:
      if (lookahead == 'c') ADVANCE(195);
      END_STATE();
    case 176:
      if (lookahead == 'c') ADVANCE(196);
      END_STATE();
    case 177:
      if (lookahead == 'c') ADVANCE(245);
      if (lookahead == 'f') ADVANCE(158);
      END_STATE();
    case 178:
      if (lookahead == 'c') ADVANCE(338);
      END_STATE();
    case 179:
      if (lookahead == 'd') ADVANCE(602);
      END_STATE();
    case 180:
      if (lookahead == 'd') ADVANCE(353);
      END_STATE();
    case 181:
      if (lookahead == 'd') ADVANCE(291);
      END_STATE();
    case 182:
      if (lookahead == 'd') ADVANCE(314);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(135);
      END_STATE();
    case 185:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 186:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 187:
      if (lookahead == 'e') ADVANCE(474);
      END_STATE();
    case 188:
      if (lookahead == 'e') ADVANCE(455);
      END_STATE();
    case 189:
      if (lookahead == 'e') ADVANCE(423);
      END_STATE();
    case 190:
      if (lookahead == 'e') ADVANCE(470);
      END_STATE();
    case 191:
      if (lookahead == 'e') ADVANCE(1056);
      END_STATE();
    case 192:
      if (lookahead == 'e') ADVANCE(1101);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(1054);
      END_STATE();
    case 194:
      if (lookahead == 'e') ADVANCE(1082);
      END_STATE();
    case 195:
      if (lookahead == 'e') ADVANCE(1092);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(434);
      END_STATE();
    case 197:
      if (lookahead == 'e') ADVANCE(325);
      END_STATE();
    case 198:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 199:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 200:
      if (lookahead == 'e') ADVANCE(303);
      END_STATE();
    case 201:
      if (lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 202:
      if (lookahead == 'e') ADVANCE(304);
      END_STATE();
    case 203:
      if (lookahead == 'e') ADVANCE(315);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(305);
      END_STATE();
    case 205:
      if (lookahead == 'e') ADVANCE(287);
      END_STATE();
    case 206:
      if (lookahead == 'e') ADVANCE(332);
      END_STATE();
    case 207:
      if (lookahead == 'e') ADVANCE(280);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(261);
      END_STATE();
    case 209:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 212:
      if (lookahead == 'f') ADVANCE(598);
      END_STATE();
    case 213:
      if (lookahead == 'f') ADVANCE(467);
      END_STATE();
    case 214:
      if (lookahead == 'f') ADVANCE(228);
      END_STATE();
    case 215:
      if (lookahead == 'f') ADVANCE(159);
      END_STATE();
    case 216:
      if (lookahead == 'g') ADVANCE(1067);
      END_STATE();
    case 217:
      if (lookahead == 'g') ADVANCE(206);
      END_STATE();
    case 218:
      if (lookahead == 'h') ADVANCE(444);
      END_STATE();
    case 219:
      if (lookahead == 'h') ADVANCE(476);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(229);
      END_STATE();
    case 221:
      if (lookahead == 'h') ADVANCE(229);
      if (lookahead == 'i') ADVANCE(326);
      END_STATE();
    case 222:
      if (lookahead == 'i') ADVANCE(300);
      if (lookahead == 'k') ADVANCE(279);
      END_STATE();
    case 223:
      if (lookahead == 'i') ADVANCE(277);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == 'u') ADVANCE(272);
      END_STATE();
    case 224:
      if (lookahead == 'i') ADVANCE(179);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(318);
      END_STATE();
    case 226:
      if (lookahead == 'i') ADVANCE(327);
      END_STATE();
    case 227:
      if (lookahead == 'i') ADVANCE(273);
      END_STATE();
    case 228:
      if (lookahead == 'i') ADVANCE(203);
      END_STATE();
    case 229:
      if (lookahead == 'i') ADVANCE(248);
      END_STATE();
    case 230:
      if (lookahead == 'i') ADVANCE(292);
      END_STATE();
    case 231:
      if (lookahead == 'i') ADVANCE(312);
      END_STATE();
    case 232:
      if (lookahead == 'j') ADVANCE(209);
      END_STATE();
    case 233:
      if (lookahead == 'l') ADVANCE(141);
      END_STATE();
    case 234:
      if (lookahead == 'l') ADVANCE(1090);
      END_STATE();
    case 235:
      if (lookahead == 'l') ADVANCE(1070);
      END_STATE();
    case 236:
      if (lookahead == 'l') ADVANCE(323);
      if (lookahead == 'n') ADVANCE(346);
      if (lookahead == 'x') ADVANCE(295);
      END_STATE();
    case 237:
      if (lookahead == 'l') ADVANCE(323);
      if (lookahead == 'n') ADVANCE(346);
      if (lookahead == 'x') ADVANCE(339);
      END_STATE();
    case 238:
      if (lookahead == 'l') ADVANCE(323);
      if (lookahead == 'x') ADVANCE(339);
      END_STATE();
    case 239:
      if (lookahead == 'l') ADVANCE(360);
      END_STATE();
    case 240:
      if (lookahead == 'l') ADVANCE(149);
      END_STATE();
    case 241:
      if (lookahead == 'l') ADVANCE(149);
      if (lookahead == 'o') ADVANCE(281);
      END_STATE();
    case 242:
      if (lookahead == 'l') ADVANCE(361);
      END_STATE();
    case 243:
      if (lookahead == 'l') ADVANCE(284);
      END_STATE();
    case 244:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 245:
      if (lookahead == 'l') ADVANCE(155);
      END_STATE();
    case 246:
      if (lookahead == 'l') ADVANCE(333);
      END_STATE();
    case 247:
      if (lookahead == 'l') ADVANCE(210);
      END_STATE();
    case 248:
      if (lookahead == 'l') ADVANCE(190);
      END_STATE();
    case 249:
      if (lookahead == 'l') ADVANCE(191);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(208);
      END_STATE();
    case 251:
      if (lookahead == 'l') ADVANCE(208);
      if (lookahead == 'o') ADVANCE(310);
      END_STATE();
    case 252:
      if (lookahead == 'l') ADVANCE(162);
      END_STATE();
    case 253:
      if (lookahead == 'm') ADVANCE(293);
      END_STATE();
    case 254:
      if (lookahead == 'm') ADVANCE(1094);
      END_STATE();
    case 255:
      if (lookahead == 'm') ADVANCE(442);
      END_STATE();
    case 256:
      if (lookahead == 'm') ADVANCE(294);
      if (lookahead == 'n') ADVANCE(466);
      if (lookahead == 's') ADVANCE(1099);
      END_STATE();
    case 257:
      if (lookahead == 'm') ADVANCE(294);
      if (lookahead == 'n') ADVANCE(341);
      if (lookahead == 's') ADVANCE(1099);
      END_STATE();
    case 258:
      if (lookahead == 'm') ADVANCE(169);
      END_STATE();
    case 259:
      if (lookahead == 'm') ADVANCE(168);
      END_STATE();
    case 260:
      if (lookahead == 'm') ADVANCE(199);
      END_STATE();
    case 261:
      if (lookahead == 'm') ADVANCE(207);
      END_STATE();
    case 262:
      if (lookahead == 'm') ADVANCE(296);
      if (lookahead == 'n') ADVANCE(465);
      END_STATE();
    case 263:
      if (lookahead == 'm') ADVANCE(296);
      if (lookahead == 'n') ADVANCE(465);
      if (lookahead == 's') ADVANCE(1099);
      END_STATE();
    case 264:
      if (lookahead == 'm') ADVANCE(299);
      END_STATE();
    case 265:
      if (lookahead == 'n') ADVANCE(222);
      END_STATE();
    case 266:
      if (lookahead == 'n') ADVANCE(1064);
      END_STATE();
    case 267:
      if (lookahead == 'n') ADVANCE(1104);
      END_STATE();
    case 268:
      if (lookahead == 'n') ADVANCE(524);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(465);
      END_STATE();
    case 270:
      if (lookahead == 'n') ADVANCE(461);
      END_STATE();
    case 271:
      if (lookahead == 'n') ADVANCE(461);
      if (lookahead == 's') ADVANCE(1099);
      END_STATE();
    case 272:
      if (lookahead == 'n') ADVANCE(178);
      END_STATE();
    case 273:
      if (lookahead == 'n') ADVANCE(216);
      END_STATE();
    case 274:
      if (lookahead == 'n') ADVANCE(170);
      END_STATE();
    case 275:
      if (lookahead == 'n') ADVANCE(182);
      END_STATE();
    case 276:
      if (lookahead == 'n') ADVANCE(174);
      END_STATE();
    case 277:
      if (lookahead == 'n') ADVANCE(153);
      END_STATE();
    case 278:
      if (lookahead == 'n') ADVANCE(242);
      END_STATE();
    case 279:
      if (lookahead == 'n') ADVANCE(283);
      END_STATE();
    case 280:
      if (lookahead == 'n') ADVANCE(342);
      END_STATE();
    case 281:
      if (lookahead == 'n') ADVANCE(324);
      END_STATE();
    case 282:
      if (lookahead == 'o') ADVANCE(180);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(356);
      END_STATE();
    case 284:
      if (lookahead == 'o') ADVANCE(167);
      END_STATE();
    case 285:
      if (lookahead == 'o') ADVANCE(247);
      END_STATE();
    case 286:
      if (lookahead == 'o') ADVANCE(285);
      END_STATE();
    case 287:
      if (lookahead == 'o') ADVANCE(212);
      END_STATE();
    case 288:
      if (lookahead == 'o') ADVANCE(255);
      END_STATE();
    case 289:
      if (lookahead == 'o') ADVANCE(309);
      END_STATE();
    case 290:
      if (lookahead == 'o') ADVANCE(235);
      END_STATE();
    case 291:
      if (lookahead == 'o') ADVANCE(278);
      END_STATE();
    case 292:
      if (lookahead == 'o') ADVANCE(268);
      END_STATE();
    case 293:
      if (lookahead == 'p') ADVANCE(233);
      END_STATE();
    case 294:
      if (lookahead == 'p') ADVANCE(251);
      END_STATE();
    case 295:
      if (lookahead == 'p') ADVANCE(289);
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 296:
      if (lookahead == 'p') ADVANCE(250);
      END_STATE();
    case 297:
      if (lookahead == 'p') ADVANCE(189);
      END_STATE();
    case 298:
      if (lookahead == 'p') ADVANCE(161);
      END_STATE();
    case 299:
      if (lookahead == 'p') ADVANCE(252);
      END_STATE();
    case 300:
      if (lookahead == 'q') ADVANCE(350);
      END_STATE();
    case 301:
      if (lookahead == 'r') ADVANCE(217);
      END_STATE();
    case 302:
      if (lookahead == 'r') ADVANCE(446);
      END_STATE();
    case 303:
      if (lookahead == 'r') ADVANCE(215);
      END_STATE();
    case 304:
      if (lookahead == 'r') ADVANCE(1107);
      END_STATE();
    case 305:
      if (lookahead == 'r') ADVANCE(1061);
      END_STATE();
    case 306:
      if (lookahead == 'r') ADVANCE(288);
      END_STATE();
    case 307:
      if (lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 308:
      if (lookahead == 'r') ADVANCE(160);
      END_STATE();
    case 309:
      if (lookahead == 'r') ADVANCE(329);
      END_STATE();
    case 310:
      if (lookahead == 'r') ADVANCE(330);
      END_STATE();
    case 311:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 312:
      if (lookahead == 'r') ADVANCE(194);
      END_STATE();
    case 313:
      if (lookahead == 's') ADVANCE(520);
      END_STATE();
    case 314:
      if (lookahead == 's') ADVANCE(1084);
      END_STATE();
    case 315:
      if (lookahead == 's') ADVANCE(1079);
      END_STATE();
    case 316:
      if (lookahead == 's') ADVANCE(1087);
      END_STATE();
    case 317:
      if (lookahead == 's') ADVANCE(429);
      END_STATE();
    case 318:
      if (lookahead == 's') ADVANCE(214);
      END_STATE();
    case 319:
      if (lookahead == 's') ADVANCE(298);
      END_STATE();
    case 320:
      if (lookahead == 's') ADVANCE(313);
      END_STATE();
    case 321:
      if (lookahead == 's') ADVANCE(336);
      END_STATE();
    case 322:
      if (lookahead == 's') ADVANCE(187);
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 323:
      if (lookahead == 's') ADVANCE(188);
      END_STATE();
    case 324:
      if (lookahead == 's') ADVANCE(328);
      END_STATE();
    case 325:
      if (lookahead == 't') ADVANCE(448);
      END_STATE();
    case 326:
      if (lookahead == 't') ADVANCE(218);
      END_STATE();
    case 327:
      if (lookahead == 't') ADVANCE(459);
      END_STATE();
    case 328:
      if (lookahead == 't') ADVANCE(450);
      END_STATE();
    case 329:
      if (lookahead == 't') ADVANCE(416);
      END_STATE();
    case 330:
      if (lookahead == 't') ADVANCE(440);
      END_STATE();
    case 331:
      if (lookahead == 't') ADVANCE(1073);
      END_STATE();
    case 332:
      if (lookahead == 't') ADVANCE(1044);
      END_STATE();
    case 333:
      if (lookahead == 't') ADVANCE(421);
      END_STATE();
    case 334:
      if (lookahead == 't') ADVANCE(1076);
      END_STATE();
    case 335:
      if (lookahead == 't') ADVANCE(184);
      END_STATE();
    case 336:
      if (lookahead == 't') ADVANCE(308);
      END_STATE();
    case 337:
      if (lookahead == 't') ADVANCE(225);
      END_STATE();
    case 338:
      if (lookahead == 't') ADVANCE(230);
      END_STATE();
    case 339:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 340:
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 341:
      if (lookahead == 't') ADVANCE(200);
      END_STATE();
    case 342:
      if (lookahead == 't') ADVANCE(316);
      END_STATE();
    case 343:
      if (lookahead == 't') ADVANCE(198);
      END_STATE();
    case 344:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 345:
      if (lookahead == 'u') ADVANCE(364);
      if (lookahead == 'x') ADVANCE(391);
      if (lookahead == '\r' ||
          lookahead == '?') ADVANCE(619);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(621);
      if (lookahead != 0) ADVANCE(617);
      END_STATE();
    case 346:
      if (lookahead == 'u') ADVANCE(254);
      END_STATE();
    case 347:
      if (lookahead == 'u') ADVANCE(272);
      END_STATE();
    case 348:
      if (lookahead == 'u') ADVANCE(246);
      END_STATE();
    case 349:
      if (lookahead == 'u') ADVANCE(231);
      END_STATE();
    case 350:
      if (lookahead == 'u') ADVANCE(192);
      END_STATE();
    case 351:
      if (lookahead == 'u') ADVANCE(365);
      END_STATE();
    case 352:
      if (lookahead == 'u') ADVANCE(366);
      END_STATE();
    case 353:
      if (lookahead == 'u') ADVANCE(249);
      END_STATE();
    case 354:
      if (lookahead == 'u') ADVANCE(367);
      if (lookahead == 'x') ADVANCE(391);
      if (lookahead == '\r' ||
          lookahead == '?') ADVANCE(619);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(621);
      if (lookahead != 0) ADVANCE(617);
      END_STATE();
    case 355:
      if (lookahead == 'v') ADVANCE(202);
      if (lookahead == 'w') ADVANCE(528);
      END_STATE();
    case 356:
      if (lookahead == 'w') ADVANCE(267);
      END_STATE();
    case 357:
      if (lookahead == 'x') ADVANCE(295);
      END_STATE();
    case 358:
      if (lookahead == 'x') ADVANCE(339);
      END_STATE();
    case 359:
      if (lookahead == 'y') ADVANCE(1058);
      END_STATE();
    case 360:
      if (lookahead == 'y') ADVANCE(478);
      END_STATE();
    case 361:
      if (lookahead == 'y') ADVANCE(1047);
      END_STATE();
    case 362:
      if (lookahead == 'y') ADVANCE(297);
      END_STATE();
    case 363:
      if (lookahead == '{') ADVANCE(627);
      END_STATE();
    case 364:
      if (lookahead == '{') ADVANCE(385);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(396);
      END_STATE();
    case 365:
      if (lookahead == '{') ADVANCE(389);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(397);
      END_STATE();
    case 366:
      if (lookahead == '{') ADVANCE(390);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(398);
      END_STATE();
    case 367:
      if (lookahead == '{') ADVANCE(392);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(388);
      END_STATE();
    case 368:
      if (lookahead == '}') ADVANCE(1042);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(368);
      END_STATE();
    case 369:
      if (lookahead == '}') ADVANCE(1043);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(369);
      END_STATE();
    case 370:
      if (lookahead == '}') ADVANCE(617);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(370);
      END_STATE();
    case 371:
      if (lookahead == '}') ADVANCE(1111);
      END_STATE();
    case 372:
      if (lookahead == '}') ADVANCE(618);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(372);
      END_STATE();
    case 373:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(380);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(675);
      END_STATE();
    case 374:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(387);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      END_STATE();
    case 375:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(671);
      END_STATE();
    case 376:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(672);
      END_STATE();
    case 377:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(663);
      END_STATE();
    case 378:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(674);
      END_STATE();
    case 379:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(670);
      END_STATE();
    case 380:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(675);
      END_STATE();
    case 381:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1042);
      END_STATE();
    case 382:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1043);
      END_STATE();
    case 383:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(617);
      END_STATE();
    case 384:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(673);
      END_STATE();
    case 385:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(372);
      END_STATE();
    case 386:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(618);
      END_STATE();
    case 387:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 388:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(391);
      END_STATE();
    case 389:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(369);
      END_STATE();
    case 390:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(368);
      END_STATE();
    case 391:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(383);
      END_STATE();
    case 392:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(370);
      END_STATE();
    case 393:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(386);
      END_STATE();
    case 394:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(382);
      END_STATE();
    case 395:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(381);
      END_STATE();
    case 396:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(393);
      END_STATE();
    case 397:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(394);
      END_STATE();
    case 398:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(395);
      END_STATE();
    case 399:
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(517);
      END_STATE();
    case 400:
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          (lookahead < 'a' || 'z' < lookahead)) ADVANCE(511);
      END_STATE();
    case 401:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(140);
      END_STATE();
    case 402:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(630);
      END_STATE();
    case 403:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 34,
        '$', 1032,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        ')', 458,
        '*', 419,
        '+', 571,
        ',', 438,
        '-', 575,
        '.', 502,
        '/', 577,
        '0', 660,
        ':', 473,
        ';', 472,
        '<', 584,
        '=', 427,
        '>', 498,
        '?', 1052,
        '@', 1046,
        '[', 480,
        '\\', 352,
        ']', 481,
        '^', 561,
        '`', 626,
        'a', 810,
        'b', 951,
        'c', 779,
        'd', 836,
        'e', 894,
        'f', 880,
        'g', 900,
        'i', 909,
        'l', 837,
        'm', 945,
        'n', 780,
        'o', 815,
        'r', 839,
        's', 785,
        't', 789,
        'u', 930,
        'v', 792,
        'w', 878,
        '{', 437,
        '|', 564,
        '}', 439,
        '~', 601,
        0x2028, 677,
        0x2029, 677,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(403);
      if (lookahead > '@') ADVANCE(1042);
      END_STATE();
    case 404:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 578,
        '&', 559,
        '\'', 507,
        '(', 457,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 503,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 588,
        '=', 426,
        '>', 499,
        '?', 79,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '^', 560,
        '`', 626,
        'a', 810,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 928,
        'f', 1015,
        'i', 919,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '|', 565,
        '}', 439,
        '~', 601,
        0x2028, 746,
        0x2029, 746,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(404);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 405:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '#', 139,
        '%', 578,
        '&', 559,
        '\'', 507,
        '(', 457,
        '*', 420,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 503,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 588,
        '=', 426,
        '>', 499,
        '?', 79,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '^', 560,
        '`', 626,
        'a', 810,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 895,
        'f', 1015,
        'i', 919,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '|', 565,
        '}', 439,
        '~', 601,
        0x2028, 748,
        0x2029, 748,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(405);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 406:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '$', 363,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        ')', 458,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 503,
        '/', 577,
        '0', 660,
        ':', 473,
        ';', 472,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 1052,
        '@', 1046,
        '[', 480,
        '\\', 354,
        ']', 481,
        '^', 561,
        '`', 626,
        'a', 163,
        'b', 286,
        'c', 142,
        'd', 185,
        'e', 236,
        'f', 223,
        'g', 243,
        'i', 256,
        'l', 197,
        'm', 282,
        'n', 144,
        'o', 166,
        'r', 186,
        's', 148,
        't', 146,
        'u', 265,
        'v', 151,
        'w', 221,
        '{', 436,
        '|', 564,
        '}', 439,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(407);
      END_STATE();
    case 407:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 454,
        '"', 506,
        '$', 363,
        '%', 579,
        '&', 558,
        '\'', 507,
        '(', 457,
        ')', 458,
        '*', 419,
        '+', 570,
        ',', 438,
        '-', 574,
        '.', 503,
        '/', 577,
        '0', 660,
        ':', 473,
        ';', 472,
        '<', 585,
        '=', 427,
        '>', 498,
        '?', 1052,
        '@', 1046,
        '[', 480,
        ']', 481,
        '^', 561,
        '`', 626,
        'a', 163,
        'b', 286,
        'c', 142,
        'd', 185,
        'e', 236,
        'f', 223,
        'g', 243,
        'i', 256,
        'l', 197,
        'm', 282,
        'n', 144,
        'o', 166,
        'r', 186,
        's', 148,
        't', 146,
        'u', 265,
        'v', 151,
        'w', 221,
        '{', 436,
        '|', 564,
        '}', 439,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(407);
      END_STATE();
    case 408:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 34,
        '\'', 507,
        '(', 457,
        '*', 418,
        '+', 569,
        ',', 438,
        '-', 573,
        '.', 502,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 928,
        'f', 1015,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 767,
        0x2029, 767,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(408);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 409:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 503,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 895,
        'f', 1015,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 771,
        0x2029, 771,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(409);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 410:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 378,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 928,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 766,
        0x2029, 766,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(410);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 411:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 378,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 895,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 770,
        0x2029, 770,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(411);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 412:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 378,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 805,
        'd', 856,
        'e', 928,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 772,
        0x2029, 772,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(412);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 413:
      if (eof) ADVANCE(414);
      ADVANCE_MAP(
        '!', 453,
        '"', 506,
        '#', 139,
        '\'', 507,
        '(', 457,
        '+', 569,
        '-', 573,
        '.', 378,
        '/', 576,
        '0', 660,
        ';', 472,
        '<', 589,
        '@', 1046,
        '[', 480,
        '\\', 352,
        '`', 626,
        'a', 812,
        'b', 951,
        'c', 805,
        'd', 856,
        'e', 895,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        '{', 436,
        '}', 439,
        '~', 601,
        0x2028, 773,
        0x2029, 773,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(413);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(1042);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(415);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_export);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(581);
      if (lookahead == '=') ADVANCE(533);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(580);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_default);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(591);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(591);
      if (lookahead == '>') ADVANCE(526);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(526);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'y') ADVANCE(937);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(274);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_as);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_namespace);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(1110);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_import);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_from);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_with);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_var);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_let);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(593);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_await);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(1011);
      if (lookahead == 't') ADVANCE(855);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(1011);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(656);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(340);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(340);
      if (lookahead == 't') ADVANCE(200);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_of);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_of);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_catch);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_finally);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '/') ADVANCE(625);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(483);
      if (lookahead == '<') ADVANCE(485);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          lookahead != '\n') ADVANCE(484);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(482);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(344);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_LTtemplate_GT);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_LT_SLASHtemplate_GT);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(aux_sym_jsx_text_token1);
      if (lookahead == ' ') ADVANCE(4);
      if (lookahead == '*') ADVANCE(492);
      if (lookahead == '/') ADVANCE(493);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '&' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(489);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(aux_sym_jsx_text_token1);
      if (lookahead == ' ') ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '&' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(489);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(aux_sym_jsx_text_token1);
      if (lookahead == ' ') ADVANCE(1);
      if (lookahead == '/') ADVANCE(488);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          lookahead != '\n') ADVANCE(490);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '&' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(489);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(aux_sym_jsx_text_token1);
      ADVANCE_MAP(
        ' ', 5,
        '*', 491,
        '/', 489,
        '\n', 72,
        '&', 72,
        '<', 72,
        '>', 72,
        '{', 72,
        '}', 72,
      );
      if (lookahead != 0) ADVANCE(492);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(aux_sym_jsx_text_token1);
      ADVANCE_MAP(
        ' ', 5,
        '*', 491,
        '\n', 72,
        '&', 72,
        '<', 72,
        '>', 72,
        '{', 72,
        '}', 72,
      );
      if (lookahead != 0) ADVANCE(492);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(aux_sym_jsx_text_token1);
      if (lookahead == ' ') ADVANCE(494);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(495);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(493);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(aux_sym_jsx_text_token2);
      if (lookahead == ' ') ADVANCE(494);
      if (lookahead == '&' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(495);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(493);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(aux_sym_jsx_text_token2);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(495);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(sym_html_character_reference);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(595);
      if (lookahead == '>') ADVANCE(551);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(595);
      if (lookahead == '>') ADVANCE(552);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(500);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(674);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(674);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_LT_SLASH);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_SLASH_GT);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(sym_unescaped_double_jsx_string_fragment);
      if (lookahead == '\n') ADVANCE(511);
      if (lookahead == '&') ADVANCE(624);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(508);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(sym_unescaped_double_jsx_string_fragment);
      if (lookahead == '&') ADVANCE(62);
      if (lookahead == '/') ADVANCE(510);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(509);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(511);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(sym_unescaped_double_jsx_string_fragment);
      if (lookahead == '&') ADVANCE(400);
      if (lookahead == '*') ADVANCE(513);
      if (lookahead == '/') ADVANCE(508);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(511);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(sym_unescaped_double_jsx_string_fragment);
      if (lookahead == '&') ADVANCE(400);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(511);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(sym_unescaped_double_jsx_string_fragment);
      if (lookahead == '&') ADVANCE(74);
      if (lookahead == '*') ADVANCE(512);
      if (lookahead == '/') ADVANCE(511);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(513);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(sym_unescaped_double_jsx_string_fragment);
      if (lookahead == '&') ADVANCE(74);
      if (lookahead == '*') ADVANCE(512);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(513);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(sym_unescaped_single_jsx_string_fragment);
      if (lookahead == '\n') ADVANCE(517);
      if (lookahead == '&') ADVANCE(623);
      if (lookahead != 0 &&
          lookahead != '&' &&
          lookahead != '\'') ADVANCE(514);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(sym_unescaped_single_jsx_string_fragment);
      if (lookahead == '&') ADVANCE(61);
      if (lookahead == '/') ADVANCE(516);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(515);
      if (lookahead != 0 &&
          lookahead != '&' &&
          lookahead != '\'') ADVANCE(517);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(sym_unescaped_single_jsx_string_fragment);
      if (lookahead == '&') ADVANCE(399);
      if (lookahead == '*') ADVANCE(519);
      if (lookahead == '/') ADVANCE(514);
      if (lookahead != 0 &&
          lookahead != '&' &&
          lookahead != '\'') ADVANCE(517);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(sym_unescaped_single_jsx_string_fragment);
      if (lookahead == '&') ADVANCE(399);
      if (lookahead != 0 &&
          lookahead != '&' &&
          lookahead != '\'') ADVANCE(517);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(sym_unescaped_single_jsx_string_fragment);
      if (lookahead == '&') ADVANCE(73);
      if (lookahead == '*') ADVANCE(518);
      if (lookahead == '/') ADVANCE(517);
      if (lookahead != 0 &&
          lookahead != '&' &&
          lookahead != '\'') ADVANCE(519);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(sym_unescaped_single_jsx_string_fragment);
      if (lookahead == '&') ADVANCE(73);
      if (lookahead == '*') ADVANCE(518);
      if (lookahead != 0 &&
          lookahead != '&' &&
          lookahead != '\'') ADVANCE(519);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_class);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_async);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_new);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_new);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(543);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(544);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(539);
      if (lookahead == '>') ADVANCE(554);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(553);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(540);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(541);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(548);
      if (lookahead == '=') ADVANCE(537);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(547);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(536);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(538);
      if (lookahead == '|') ADVANCE(550);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(538);
      if (lookahead == '|') ADVANCE(550);
      if (lookahead == '}') ADVANCE(1111);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(549);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(549);
      if (lookahead == '}') ADVANCE(1111);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(1111);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(605);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(605);
      if (lookahead == '=') ADVANCE(531);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(605);
      if (lookahead == '=') ADVANCE(531);
      if (lookahead == '?') ADVANCE(92);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(606);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(606);
      if (lookahead == '=') ADVANCE(532);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(606);
      if (lookahead == '=') ADVANCE(532);
      if (lookahead == '?') ADVANCE(93);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '/') ADVANCE(625);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '/') ADVANCE(625);
      if (lookahead == '=') ADVANCE(534);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(535);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(542);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '/') ADVANCE(504);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '/') ADVANCE(504);
      if (lookahead == '<') ADVANCE(556);
      if (lookahead == '=') ADVANCE(590);
      if (lookahead == 't') ADVANCE(183);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(556);
      if (lookahead == '=') ADVANCE(590);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(556);
      if (lookahead == '=') ADVANCE(590);
      if (lookahead == 't') ADVANCE(183);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(555);
      if (lookahead == '=') ADVANCE(590);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(555);
      if (lookahead == '=') ADVANCE(590);
      if (lookahead == 't') ADVANCE(183);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == 't') ADVANCE(183);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(592);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(594);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(545);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_instanceof);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(anon_sym_instanceof);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_void);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_void);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(609);
      if (lookahead == '/') ADVANCE(611);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(611);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(608);
      if (lookahead == '/') ADVANCE(611);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(609);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(608);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(609);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '/') ADVANCE(607);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(610);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(611);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(611);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(614);
      if (lookahead == '/') ADVANCE(616);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(616);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(613);
      if (lookahead == '/') ADVANCE(616);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(614);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(613);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(614);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '/') ADVANCE(612);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(615);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(616);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(616);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n' ||
          lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(617);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(617);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(620);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '\n') ADVANCE(517);
      if (lookahead == '#' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(625);
      if (lookahead != 0) ADVANCE(514);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '\n') ADVANCE(511);
      if (lookahead == '#' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(625);
      if (lookahead != 0) ADVANCE(508);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(625);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(90);
      if (lookahead == '/') ADVANCE(69);
      if (lookahead == '[') ADVANCE(140);
      if (lookahead == '\\') ADVANCE(402);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(629);
      if (lookahead != 0) ADVANCE(630);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(140);
      if (lookahead == '\\') ADVANCE(402);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(630);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'a') ADVANCE(655);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'a') ADVANCE(647);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'c') ADVANCE(634);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'e') ADVANCE(649);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'e') ADVANCE(645);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'e') ADVANCE(653);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'e') ADVANCE(648);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'f') ADVANCE(600);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'f') ADVANCE(469);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'f') ADVANCE(642);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'i') ADVANCE(652);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'i') ADVANCE(636);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'l') ADVANCE(635);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'm') ADVANCE(650);
      if (lookahead == 'n') ADVANCE(464);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'm') ADVANCE(637);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'n') ADVANCE(464);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'n') ADVANCE(633);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'n') ADVANCE(657);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'o') ADVANCE(638);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'p') ADVANCE(643);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 's') ADVANCE(433);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 's') ADVANCE(640);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 's') ADVANCE(1081);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 's') ADVANCE(1089);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 't') ADVANCE(641);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 't') ADVANCE(632);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 't') ADVANCE(654);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_regex_flags);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_number);
      ADVANCE_MAP(
        '.', 676,
        '0', 670,
        '_', 379,
        'n', 659,
        'B', 375,
        'b', 375,
        'E', 373,
        'e', 373,
        'O', 376,
        'o', 376,
        'X', 384,
        'x', 384,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(663);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym_number);
      ADVANCE_MAP(
        '.', 676,
        '0', 664,
        '\\', 352,
        '_', 1039,
        'n', 669,
        'B', 1034,
        'b', 1034,
        'E', 1033,
        'e', 1033,
        'O', 1037,
        'o', 1037,
        'X', 1041,
        'x', 1041,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(676);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '_') ADVANCE(1038);
      if (lookahead == 'n') ADVANCE(669);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1033);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(676);
      if (lookahead == '_') ADVANCE(377);
      if (lookahead == 'n') ADVANCE(659);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(663);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '_') ADVANCE(1039);
      if (lookahead == 'n') ADVANCE(669);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(664);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '_') ADVANCE(1034);
      if (lookahead == 'n') ADVANCE(669);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '_') ADVANCE(1037);
      if (lookahead == 'n') ADVANCE(669);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(666);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '_') ADVANCE(1041);
      if (lookahead == 'n') ADVANCE(669);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(667);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '_') ADVANCE(1040);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(668);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(379);
      if (lookahead == 'n') ADVANCE(659);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(670);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(375);
      if (lookahead == 'n') ADVANCE(659);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(671);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(376);
      if (lookahead == 'n') ADVANCE(659);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(672);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(384);
      if (lookahead == 'n') ADVANCE(659);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(673);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(378);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(674);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(380);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(675);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(674);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '$', 1032,
        '0', 661,
        '\\', 352,
        'a', 810,
        'b', 951,
        'c', 779,
        'd', 836,
        'e', 894,
        'f', 880,
        'g', 900,
        'i', 909,
        'l', 837,
        'm', 945,
        'n', 780,
        'o', 815,
        'r', 839,
        's', 785,
        't', 789,
        'u', 930,
        'v', 792,
        'w', 878,
        0x2028, 677,
        0x2029, 677,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(689);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(710);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(686);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(728);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(702);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(720);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(696);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(733);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(734);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'd') ADVANCE(603);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'd') ADVANCE(729);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'd') ADVANCE(722);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(738);
      if (lookahead == 'u') ADVANCE(706);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(678);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(685);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(1102);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(679);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(724);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(725);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(713);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'g') ADVANCE(1068);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(723);
      if (lookahead == 'k') ADVANCE(714);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(687);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(709);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'j') ADVANCE(692);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(1071);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(742);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(694);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(684);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(683);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(699);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(698);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1065);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1105);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(704);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(688);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(718);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(730);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(700);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(705);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 718:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(739);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(715);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(703);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(717);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(712);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'q') ADVANCE(737);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(1108);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(1062);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(680);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(701);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 728:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(735);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 729:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(1085);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(732);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 731:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(727);
      if (lookahead == 'y') ADVANCE(707);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(451);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(1074);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 734:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(1077);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 735:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(726);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 736:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(697);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 737:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'u') ADVANCE(693);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'v') ADVANCE(695);
      if (lookahead == 'w') ADVANCE(529);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'w') ADVANCE(711);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 740:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'x') ADVANCE(736);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 741:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'y') ADVANCE(1059);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 742:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'y') ADVANCE(1048);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 810,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 928,
        'f', 1015,
        'i', 919,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 744,
        0x2029, 744,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 810,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 895,
        'f', 1015,
        'i', 919,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 745,
        0x2029, 745,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 746:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 810,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 928,
        'f', 1015,
        'i', 919,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 746,
        0x2029, 746,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 810,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 920,
        'l', 837,
        'm', 945,
        'n', 780,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'u', 930,
        'v', 946,
        0x2028, 747,
        0x2029, 747,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 748:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 810,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 895,
        'f', 1015,
        'i', 919,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 748,
        0x2029, 748,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 749:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 923,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 920,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 815,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 946,
        0x2028, 749,
        0x2029, 749,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 750:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 923,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 920,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 946,
        0x2028, 750,
        0x2029, 750,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 751:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 923,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 910,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        'v', 946,
        0x2028, 751,
        0x2029, 751,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 811,
        'b', 951,
        'c', 950,
        'i', 934,
        'n', 838,
        'o', 815,
        'r', 862,
        's', 785,
        'u', 930,
        'v', 946,
        0x2028, 752,
        0x2029, 752,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 753:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 811,
        'b', 951,
        'c', 950,
        'i', 934,
        'n', 838,
        'o', 816,
        'r', 862,
        's', 785,
        'u', 930,
        'v', 946,
        0x2028, 753,
        0x2029, 753,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 754:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 811,
        'b', 951,
        'c', 950,
        'i', 915,
        'n', 838,
        'o', 816,
        'r', 862,
        's', 785,
        'u', 930,
        'v', 946,
        0x2028, 754,
        0x2029, 754,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 755:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 924,
        'b', 951,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 934,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        0x2028, 755,
        0x2029, 755,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 756:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 924,
        'b', 951,
        'd', 856,
        'e', 1025,
        'i', 934,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        0x2028, 756,
        0x2029, 756,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 757:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 814,
        'b', 951,
        'c', 950,
        'i', 922,
        'n', 838,
        'o', 816,
        'r', 862,
        's', 994,
        'u', 930,
        'v', 946,
        0x2028, 757,
        0x2029, 757,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 814,
        'b', 951,
        'c', 950,
        'n', 838,
        'o', 816,
        'r', 862,
        's', 994,
        'u', 930,
        'v', 946,
        0x2028, 758,
        0x2029, 758,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 681,
        'b', 721,
        'c', 719,
        'n', 690,
        'o', 682,
        'r', 691,
        's', 731,
        'u', 708,
        'v', 716,
        0x2028, 759,
        0x2029, 759,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 760:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 779,
        'd', 836,
        'e', 928,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 760,
        0x2029, 760,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 779,
        'd', 836,
        'e', 895,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 761,
        0x2029, 761,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 762:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 928,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 762,
        0x2029, 762,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 763:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 928,
        'f', 1015,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 763,
        0x2029, 763,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 895,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 764,
        0x2029, 764,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 765:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 806,
        'd', 836,
        'e', 895,
        'f', 1015,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 765,
        0x2029, 765,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 766:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 928,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 766,
        0x2029, 766,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 767:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 928,
        'f', 1015,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 767,
        0x2029, 767,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 768:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 928,
        'f', 1015,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        0x2028, 768,
        0x2029, 768,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 769:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 922,
        'l', 837,
        'm', 945,
        'n', 780,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'u', 930,
        'v', 946,
        0x2028, 769,
        0x2029, 769,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 895,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 770,
        0x2029, 770,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 895,
        'f', 1015,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 771,
        0x2029, 771,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 772:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 805,
        'd', 856,
        'e', 928,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 772,
        0x2029, 772,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 812,
        'b', 951,
        'c', 805,
        'd', 856,
        'e', 895,
        'f', 881,
        'i', 921,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        'w', 878,
        0x2028, 773,
        0x2029, 773,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 774:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 925,
        'b', 951,
        'c', 897,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 922,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 792,
        0x2028, 774,
        0x2029, 774,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 925,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 922,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 946,
        0x2028, 775,
        0x2029, 775,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 925,
        'b', 951,
        'c', 898,
        'd', 856,
        'e', 1024,
        'f', 1015,
        'i', 922,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        'v', 946,
        0x2028, 776,
        0x2029, 776,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 777:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 813,
        'b', 951,
        'd', 856,
        'e', 1025,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        0x2028, 777,
        0x2029, 777,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 661,
        '\\', 352,
        'a', 926,
        'b', 951,
        'd', 856,
        'e', 1025,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        0x2028, 778,
        0x2029, 778,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 779:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(988);
      if (lookahead == 'l') ADVANCE(791);
      if (lookahead == 'o') ADVANCE(944);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(917);
      if (lookahead == 'e') ADVANCE(1020);
      if (lookahead == 'u') ADVANCE(913);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(917);
      if (lookahead == 'e') ADVANCE(1022);
      if (lookahead == 'u') ADVANCE(913);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '\\', 352,
        'a', 924,
        'b', 951,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 934,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 815,
        'r', 862,
        's', 785,
        't', 1030,
        0x2028, 782,
        0x2029, 782,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 783:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '\\', 352,
        'a', 924,
        'b', 951,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 934,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        0x2028, 783,
        0x2029, 783,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 784:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '\\', 352,
        'a', 924,
        'b', 951,
        'd', 856,
        'e', 1025,
        'f', 1015,
        'i', 915,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 785,
        't', 1030,
        0x2028, 784,
        0x2029, 784,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 785:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(1008);
      if (lookahead == 't') ADVANCE(974);
      if (lookahead == 'y') ADVANCE(914);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 786:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(1008);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 787:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(834);
      if (lookahead == 'q') ADVANCE(1017);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(834);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(968);
      if (lookahead == 'y') ADVANCE(962);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '\\', 352,
        'a', 926,
        'b', 951,
        'd', 856,
        'e', 1025,
        'l', 837,
        'm', 945,
        'n', 781,
        'o', 816,
        'r', 862,
        's', 994,
        't', 1030,
        0x2028, 790,
        0x2029, 790,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 791:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(990);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 792:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(969);
      if (lookahead == 'o') ADVANCE(882);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 793:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 794:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(902);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 795:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(1016);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(892);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(978);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 798:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(940);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 799:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(985);
      if (lookahead == 'i') ADVANCE(934);
      if (lookahead == 'o') ADVANCE(869);
      if (lookahead == 's') ADVANCE(786);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(799);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 800:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(985);
      if (lookahead == 'i') ADVANCE(934);
      if (lookahead == 's') ADVANCE(786);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(800);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 801:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(985);
      if (lookahead == 'i') ADVANCE(915);
      if (lookahead == 's') ADVANCE(786);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(801);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 802:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(985);
      if (lookahead == 't') ADVANCE(1030);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(802);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 803:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(931);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 804:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '\\', 352,
        'a', 927,
        'b', 951,
        'n', 851,
        'o', 816,
        's', 994,
        'u', 930,
        'v', 946,
        0x2028, 804,
        0x2029, 804,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 805:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(995);
      if (lookahead == 'l') ADVANCE(791);
      if (lookahead == 'o') ADVANCE(944);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 806:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(989);
      if (lookahead == 'l') ADVANCE(791);
      if (lookahead == 'o') ADVANCE(944);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 807:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(827);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 808:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(829);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 809:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'a') ADVANCE(830);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 810:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(991);
      if (lookahead == 'n') ADVANCE(1027);
      if (lookahead == 's') ADVANCE(430);
      if (lookahead == 'w') ADVANCE(793);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 811:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(991);
      if (lookahead == 'n') ADVANCE(1027);
      if (lookahead == 's') ADVANCE(431);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 812:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(991);
      if (lookahead == 'n') ADVANCE(1027);
      if (lookahead == 's') ADVANCE(1031);
      if (lookahead == 'w') ADVANCE(793);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 813:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(991);
      if (lookahead == 'n') ADVANCE(1027);
      if (lookahead == 's') ADVANCE(1031);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 814:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(991);
      if (lookahead == 'n') ADVANCE(1027);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 815:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(891);
      if (lookahead == 'f') ADVANCE(468);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 816:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(891);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 817:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(796);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 818:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(955);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 819:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'b') ADVANCE(860);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 820:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(523);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 821:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(877);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 822:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(719);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(822);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 823:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(901);
      if (lookahead == 'f') ADVANCE(795);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 824:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(901);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 825:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(1002);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 826:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(950);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(826);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 827:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(1005);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 828:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(861);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 829:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(848);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 830:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(849);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 831:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'c') ADVANCE(1012);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 832:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'd') ADVANCE(604);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 833:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'd') ADVANCE(1019);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 834:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'd') ADVANCE(956);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 835:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'd') ADVANCE(982);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 836:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(823);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 837:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(996);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 838:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(1020);
      if (lookahead == 'u') ADVANCE(913);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 839:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(787);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 840:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(475);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 841:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(456);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 842:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(424);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 843:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(471);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 844:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(1057);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 845:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(1103);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 846:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(1055);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 847:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(1083);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 848:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(1093);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 849:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(435);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 850:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(740);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(850);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 851:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(1021);
      if (lookahead == 'u') ADVANCE(913);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 852:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(1026);
      if (lookahead == 'i') ADVANCE(916);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(852);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 853:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(825);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 854:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(987);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 855:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(970);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 856:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(824);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 857:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(939);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 858:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(971);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 859:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(983);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 860:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(972);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 861:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(952);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 862:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(788);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 863:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(1003);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 864:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(943);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 865:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(929);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(865);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 866:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(918);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 867:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(966);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 868:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(803);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 869:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'f') ADVANCE(468);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 870:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'f') ADVANCE(599);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 871:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'f') ADVANCE(887);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 872:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'f') ADVANCE(808);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 873:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'f') ADVANCE(973);
      if (lookahead == 't') ADVANCE(1030);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(873);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 874:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'g') ADVANCE(1069);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 875:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'g') ADVANCE(863);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 876:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'h') ADVANCE(445);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 877:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'h') ADVANCE(477);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 878:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'h') ADVANCE(888);
      if (lookahead == 'i') ADVANCE(997);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 879:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(967);
      if (lookahead == 'k') ADVANCE(941);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 880:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(938);
      if (lookahead == 'r') ADVANCE(953);
      if (lookahead == 'u') ADVANCE(935);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 881:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(938);
      if (lookahead == 'u') ADVANCE(935);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 882:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(832);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 883:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(922);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(883);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 884:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(986);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 885:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(998);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 886:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(936);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 887:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(859);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 888:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(907);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 889:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(957);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 890:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'i') ADVANCE(979);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 891:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'j') ADVANCE(853);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 892:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(1091);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 893:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(1072);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 894:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(992);
      if (lookahead == 'n') ADVANCE(1014);
      if (lookahead == 'x') ADVANCE(960);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 895:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(992);
      if (lookahead == 'n') ADVANCE(1014);
      if (lookahead == 'x') ADVANCE(961);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 896:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(1028);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 897:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(791);
      if (lookahead == 'o') ADVANCE(944);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 898:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(791);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 899:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(1029);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 900:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(947);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 901:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(797);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 902:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(896);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 903:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(868);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 904:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(1004);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 905:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(866);
      if (lookahead == 'o') ADVANCE(977);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 906:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(866);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 907:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(843);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 908:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'l') ADVANCE(844);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 909:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(959);
      if (lookahead == 'n') ADVANCE(462);
      if (lookahead == 's') ADVANCE(1100);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 910:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(959);
      if (lookahead == 'n') ADVANCE(463);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 911:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(1095);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 912:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(443);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 913:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(819);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 914:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(818);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 915:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(964);
      if (lookahead == 'n') ADVANCE(463);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 916:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(964);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 917:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(854);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 918:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(864);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 919:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(462);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 920:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(463);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 921:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(963);
      if (lookahead == 'n') ADVANCE(1010);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 922:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'm') ADVANCE(963);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 923:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1027);
      if (lookahead == 's') ADVANCE(430);
      if (lookahead == 'w') ADVANCE(793);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 924:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1027);
      if (lookahead == 's') ADVANCE(430);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 925:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1027);
      if (lookahead == 's') ADVANCE(1031);
      if (lookahead == 'w') ADVANCE(793);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 926:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1027);
      if (lookahead == 's') ADVANCE(1031);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 927:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1027);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 928:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1014);
      if (lookahead == 'x') ADVANCE(961);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 929:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1014);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 930:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(879);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 931:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1066);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 932:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1106);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 933:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(525);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 934:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(463);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 935:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(831);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 936:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(874);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 937:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(820);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 938:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(794);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 939:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(835);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 940:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(828);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 941:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(948);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 942:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(899);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 943:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(1013);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 944:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'n') ADVANCE(993);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 945:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(833);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 946:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(882);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 947:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(817);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 948:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(1023);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 949:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(903);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 950:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(944);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 951:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(949);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 952:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(870);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 953:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(912);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 954:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(976);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 955:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(893);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 956:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(942);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 957:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(933);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 958:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'o') ADVANCE(977);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 959:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'p') ADVANCE(905);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 960:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'p') ADVANCE(954);
      if (lookahead == 't') ADVANCE(857);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 961:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'p') ADVANCE(954);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 962:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'p') ADVANCE(842);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 963:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'p') ADVANCE(958);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 964:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'p') ADVANCE(906);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 965:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'p') ADVANCE(809);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 966:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'q') ADVANCE(1017);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 967:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'q') ADVANCE(1018);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 968:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(875);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 969:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(447);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 970:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(872);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 971:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(1109);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 972:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(1063);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 973:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(953);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 974:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(886);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 975:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(807);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 976:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(1000);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 977:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(1001);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 978:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(846);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 979:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(847);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 980:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'r') ADVANCE(867);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(980);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 981:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(521);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 982:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(1086);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 983:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(1080);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 984:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(1088);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 985:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(431);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 986:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(871);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 987:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(965);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 988:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(840);
      if (lookahead == 't') ADVANCE(821);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 989:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(840);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 990:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(981);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 991:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(1007);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 992:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(841);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 993:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 's') ADVANCE(999);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 994:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(974);
      if (lookahead == 'y') ADVANCE(914);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 995:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(821);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 996:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(449);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 997:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(876);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 998:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(460);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 999:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(452);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1000:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(417);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1001:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(441);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1002:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(1075);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1003:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(1045);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1004:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(422);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1005:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(1078);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1006:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(1030);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(1006);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1007:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(975);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1008:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(884);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1009:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(857);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1010:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(855);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1011:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(798);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1012:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(889);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1013:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 't') ADVANCE(984);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1014:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'u') ADVANCE(911);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1015:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'u') ADVANCE(935);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1016:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'u') ADVANCE(904);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1017:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'u') ADVANCE(890);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1018:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'u') ADVANCE(845);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1019:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'u') ADVANCE(908);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1020:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'v') ADVANCE(858);
      if (lookahead == 'w') ADVANCE(530);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1021:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'v') ADVANCE(858);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1022:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'w') ADVANCE(530);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1023:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'w') ADVANCE(932);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1024:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'x') ADVANCE(960);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1025:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'x') ADVANCE(961);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1026:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'x') ADVANCE(1009);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1027:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'y') ADVANCE(1060);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1028:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'y') ADVANCE(479);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1029:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'y') ADVANCE(1049);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1030:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'y') ADVANCE(962);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1031:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 'y') ADVANCE(937);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1032:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '{') ADVANCE(627);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1033:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(380);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(668);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1034:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1035:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(1035);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1036:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(1036);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1042);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1037:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(666);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1038:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1039:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(664);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1040:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(668);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1041:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(667);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1042:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1043:
      ACCEPT_TOKEN(sym_private_property_identifier);
      if (lookahead == '\\') ADVANCE(351);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1043);
      END_STATE();
    case 1044:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 1045:
      ACCEPT_TOKEN(anon_sym_target);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1046:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 1047:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 1048:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1049:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1050:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 1051:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(527);
      END_STATE();
    case 1052:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(527);
      if (lookahead == '?') ADVANCE(597);
      END_STATE();
    case 1053:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(527);
      if (lookahead == '?') ADVANCE(596);
      END_STATE();
    case 1054:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 1055:
      ACCEPT_TOKEN(anon_sym_declare);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1056:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 1057:
      ACCEPT_TOKEN(anon_sym_module);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1058:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 1059:
      ACCEPT_TOKEN(anon_sym_any);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1060:
      ACCEPT_TOKEN(anon_sym_any);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1061:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 1062:
      ACCEPT_TOKEN(anon_sym_number);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1063:
      ACCEPT_TOKEN(anon_sym_number);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1064:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 1065:
      ACCEPT_TOKEN(anon_sym_boolean);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1066:
      ACCEPT_TOKEN(anon_sym_boolean);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1067:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 1068:
      ACCEPT_TOKEN(anon_sym_string);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1069:
      ACCEPT_TOKEN(anon_sym_string);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1070:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 1071:
      ACCEPT_TOKEN(anon_sym_symbol);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1072:
      ACCEPT_TOKEN(anon_sym_symbol);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1073:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 1074:
      ACCEPT_TOKEN(anon_sym_object);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1075:
      ACCEPT_TOKEN(anon_sym_object);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1076:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 1077:
      ACCEPT_TOKEN(anon_sym_abstract);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1078:
      ACCEPT_TOKEN(anon_sym_abstract);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1079:
      ACCEPT_TOKEN(anon_sym_satisfies);
      END_STATE();
    case 1080:
      ACCEPT_TOKEN(anon_sym_satisfies);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1081:
      ACCEPT_TOKEN(anon_sym_satisfies);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 1082:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 1083:
      ACCEPT_TOKEN(anon_sym_require);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1084:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 1085:
      ACCEPT_TOKEN(anon_sym_extends);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1086:
      ACCEPT_TOKEN(anon_sym_extends);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1087:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 1088:
      ACCEPT_TOKEN(anon_sym_implements);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1089:
      ACCEPT_TOKEN(anon_sym_implements);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      END_STATE();
    case 1090:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 1091:
      ACCEPT_TOKEN(anon_sym_global);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1092:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 1093:
      ACCEPT_TOKEN(anon_sym_interface);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1094:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 1095:
      ACCEPT_TOKEN(anon_sym_enum);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1096:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 1097:
      ACCEPT_TOKEN(anon_sym_PLUS_QMARK_COLON);
      END_STATE();
    case 1098:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 1099:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 1100:
      ACCEPT_TOKEN(anon_sym_is);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1101:
      ACCEPT_TOKEN(anon_sym_unique);
      END_STATE();
    case 1102:
      ACCEPT_TOKEN(anon_sym_unique);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1103:
      ACCEPT_TOKEN(anon_sym_unique);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1104:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 1105:
      ACCEPT_TOKEN(anon_sym_unknown);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1106:
      ACCEPT_TOKEN(anon_sym_unknown);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1107:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 1108:
      ACCEPT_TOKEN(anon_sym_never);
      if (lookahead == '-') ADVANCE(500);
      if (lookahead == '\\') ADVANCE(352);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1109:
      ACCEPT_TOKEN(anon_sym_never);
      if (lookahead == '\\') ADVANCE(352);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(1042);
      END_STATE();
    case 1110:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 1111:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'f', 5,
        'g', 6,
        'i', 7,
        'k', 8,
        'n', 9,
        'o', 10,
        'p', 11,
        'r', 12,
        's', 13,
        't', 14,
        'u', 15,
        'y', 16,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 's') ADVANCE(17);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(18);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(19);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(20);
      if (lookahead == 'o') ADVANCE(21);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 6:
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(25);
      if (lookahead == 'n') ADVANCE(26);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(27);
      END_STATE();
    case 9:
      if (lookahead == 'u') ADVANCE(28);
      END_STATE();
    case 10:
      if (lookahead == 'v') ADVANCE(29);
      END_STATE();
    case 11:
      if (lookahead == 'r') ADVANCE(30);
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(33);
      if (lookahead == 't') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(35);
      if (lookahead == 'w') ADVANCE(36);
      END_STATE();
    case 14:
      if (lookahead == 'h') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(38);
      if (lookahead == 'y') ADVANCE(39);
      END_STATE();
    case 15:
      if (lookahead == 'n') ADVANCE(40);
      if (lookahead == 's') ADVANCE(41);
      END_STATE();
    case 16:
      if (lookahead == 'i') ADVANCE(42);
      END_STATE();
    case 17:
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(44);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(45);
      END_STATE();
    case 20:
      if (lookahead == 'b') ADVANCE(46);
      if (lookahead == 'l') ADVANCE(47);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(48);
      END_STATE();
    case 23:
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 24:
      if (lookahead == 't') ADVANCE(50);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 26:
      if (lookahead == 'f') ADVANCE(51);
      END_STATE();
    case 27:
      if (lookahead == 'y') ADVANCE(52);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(53);
      END_STATE();
    case 29:
      if (lookahead == 'e') ADVANCE(54);
      END_STATE();
    case 30:
      if (lookahead == 'i') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(57);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(58);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(59);
      END_STATE();
    case 34:
      if (lookahead == 'a') ADVANCE(60);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(61);
      END_STATE();
    case 36:
      if (lookahead == 'i') ADVANCE(62);
      END_STATE();
    case 37:
      if (lookahead == 'i') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(65);
      if (lookahead == 'y') ADVANCE(66);
      END_STATE();
    case 39:
      if (lookahead == 'p') ADVANCE(67);
      END_STATE();
    case 40:
      if (lookahead == 'd') ADVANCE(68);
      END_STATE();
    case 41:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(72);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(73);
      END_STATE();
    case 46:
      if (lookahead == 'u') ADVANCE(74);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(75);
      END_STATE();
    case 48:
      if (lookahead == 's') ADVANCE(76);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(78);
      END_STATE();
    case 53:
      if (lookahead == 'l') ADVANCE(79);
      END_STATE();
    case 54:
      if (lookahead == 'r') ADVANCE(80);
      END_STATE();
    case 55:
      if (lookahead == 'v') ADVANCE(81);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(83);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(84);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 60:
      if (lookahead == 't') ADVANCE(85);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(86);
      END_STATE();
    case 62:
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 63:
      if (lookahead == 's') ADVANCE(88);
      END_STATE();
    case 64:
      if (lookahead == 'o') ADVANCE(89);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 70:
      if (lookahead == 'l') ADVANCE(94);
      END_STATE();
    case 71:
      if (lookahead == 'r') ADVANCE(95);
      END_STATE();
    case 72:
      if (lookahead == 'k') ADVANCE(96);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(97);
      END_STATE();
    case 74:
      if (lookahead == 'g') ADVANCE(98);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(101);
      END_STATE();
    case 78:
      if (lookahead == 'f') ADVANCE(102);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(103);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(104);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(105);
      END_STATE();
    case 83:
      if (lookahead == 'i') ADVANCE(106);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(107);
      END_STATE();
    case 85:
      if (lookahead == 'i') ADVANCE(108);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(109);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(110);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 89:
      if (lookahead == 'w') ADVANCE(111);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(112);
      END_STATE();
    case 92:
      if (lookahead == 'f') ADVANCE(113);
      END_STATE();
    case 93:
      if (lookahead == 'g') ADVANCE(114);
      END_STATE();
    case 94:
      if (lookahead == 'd') ADVANCE(115);
      END_STATE();
    case 95:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 97:
      if (lookahead == 'n') ADVANCE(117);
      END_STATE();
    case 98:
      if (lookahead == 'g') ADVANCE(118);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 103:
      if (lookahead == 'i') ADVANCE(120);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 105:
      if (lookahead == 'c') ADVANCE(122);
      END_STATE();
    case 106:
      if (lookahead == 'c') ADVANCE(123);
      END_STATE();
    case 107:
      if (lookahead == 'n') ADVANCE(124);
      END_STATE();
    case 108:
      if (lookahead == 'c') ADVANCE(125);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 110:
      if (lookahead == 'h') ADVANCE(126);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 112:
      if (lookahead == 'f') ADVANCE(127);
      END_STATE();
    case 113:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 116:
      if (lookahead == 's') ADVANCE(129);
      END_STATE();
    case 117:
      if (lookahead == 'u') ADVANCE(130);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 120:
      if (lookahead == 'd') ADVANCE(132);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(133);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(134);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 128:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 131:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 135:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 139:
      if (lookahead == 'd') ADVANCE(141);
      END_STATE();
    case 140:
      if (lookahead == 'd') ADVANCE(142);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 408, .external_lex_state = 2},
  [2] = {.lex_state = 7, .external_lex_state = 3},
  [3] = {.lex_state = 7, .external_lex_state = 3},
  [4] = {.lex_state = 408, .external_lex_state = 2},
  [5] = {.lex_state = 408, .external_lex_state = 2},
  [6] = {.lex_state = 408, .external_lex_state = 2},
  [7] = {.lex_state = 408, .external_lex_state = 2},
  [8] = {.lex_state = 408, .external_lex_state = 2},
  [9] = {.lex_state = 408, .external_lex_state = 2},
  [10] = {.lex_state = 408, .external_lex_state = 2},
  [11] = {.lex_state = 408, .external_lex_state = 2},
  [12] = {.lex_state = 40, .external_lex_state = 2},
  [13] = {.lex_state = 40, .external_lex_state = 2},
  [14] = {.lex_state = 40, .external_lex_state = 2},
  [15] = {.lex_state = 40, .external_lex_state = 2},
  [16] = {.lex_state = 40, .external_lex_state = 2},
  [17] = {.lex_state = 408, .external_lex_state = 2},
  [18] = {.lex_state = 408, .external_lex_state = 2},
  [19] = {.lex_state = 408, .external_lex_state = 2},
  [20] = {.lex_state = 408, .external_lex_state = 2},
  [21] = {.lex_state = 408, .external_lex_state = 2},
  [22] = {.lex_state = 408, .external_lex_state = 2},
  [23] = {.lex_state = 408, .external_lex_state = 2},
  [24] = {.lex_state = 408, .external_lex_state = 2},
  [25] = {.lex_state = 408, .external_lex_state = 2},
  [26] = {.lex_state = 408, .external_lex_state = 2},
  [27] = {.lex_state = 408, .external_lex_state = 2},
  [28] = {.lex_state = 408, .external_lex_state = 2},
  [29] = {.lex_state = 408, .external_lex_state = 2},
  [30] = {.lex_state = 408, .external_lex_state = 2},
  [31] = {.lex_state = 408, .external_lex_state = 2},
  [32] = {.lex_state = 408, .external_lex_state = 2},
  [33] = {.lex_state = 408, .external_lex_state = 2},
  [34] = {.lex_state = 408, .external_lex_state = 2},
  [35] = {.lex_state = 408, .external_lex_state = 2},
  [36] = {.lex_state = 408, .external_lex_state = 2},
  [37] = {.lex_state = 408, .external_lex_state = 2},
  [38] = {.lex_state = 408, .external_lex_state = 2},
  [39] = {.lex_state = 408, .external_lex_state = 2},
  [40] = {.lex_state = 408, .external_lex_state = 2},
  [41] = {.lex_state = 408, .external_lex_state = 2},
  [42] = {.lex_state = 408, .external_lex_state = 2},
  [43] = {.lex_state = 408, .external_lex_state = 2},
  [44] = {.lex_state = 408, .external_lex_state = 2},
  [45] = {.lex_state = 408, .external_lex_state = 2},
  [46] = {.lex_state = 408, .external_lex_state = 2},
  [47] = {.lex_state = 408, .external_lex_state = 2},
  [48] = {.lex_state = 408, .external_lex_state = 2},
  [49] = {.lex_state = 408, .external_lex_state = 2},
  [50] = {.lex_state = 408, .external_lex_state = 2},
  [51] = {.lex_state = 408, .external_lex_state = 2},
  [52] = {.lex_state = 408, .external_lex_state = 2},
  [53] = {.lex_state = 408, .external_lex_state = 2},
  [54] = {.lex_state = 408, .external_lex_state = 2},
  [55] = {.lex_state = 408, .external_lex_state = 2},
  [56] = {.lex_state = 408, .external_lex_state = 2},
  [57] = {.lex_state = 408, .external_lex_state = 2},
  [58] = {.lex_state = 408, .external_lex_state = 2},
  [59] = {.lex_state = 408, .external_lex_state = 2},
  [60] = {.lex_state = 408, .external_lex_state = 2},
  [61] = {.lex_state = 408, .external_lex_state = 2},
  [62] = {.lex_state = 408, .external_lex_state = 2},
  [63] = {.lex_state = 408, .external_lex_state = 2},
  [64] = {.lex_state = 408, .external_lex_state = 2},
  [65] = {.lex_state = 408, .external_lex_state = 2},
  [66] = {.lex_state = 408, .external_lex_state = 2},
  [67] = {.lex_state = 408, .external_lex_state = 2},
  [68] = {.lex_state = 408, .external_lex_state = 2},
  [69] = {.lex_state = 408, .external_lex_state = 2},
  [70] = {.lex_state = 408, .external_lex_state = 2},
  [71] = {.lex_state = 408, .external_lex_state = 2},
  [72] = {.lex_state = 408, .external_lex_state = 2},
  [73] = {.lex_state = 408, .external_lex_state = 2},
  [74] = {.lex_state = 408, .external_lex_state = 2},
  [75] = {.lex_state = 408, .external_lex_state = 2},
  [76] = {.lex_state = 408, .external_lex_state = 2},
  [77] = {.lex_state = 408, .external_lex_state = 2},
  [78] = {.lex_state = 408, .external_lex_state = 2},
  [79] = {.lex_state = 408, .external_lex_state = 2},
  [80] = {.lex_state = 408, .external_lex_state = 2},
  [81] = {.lex_state = 408, .external_lex_state = 2},
  [82] = {.lex_state = 408, .external_lex_state = 2},
  [83] = {.lex_state = 408, .external_lex_state = 2},
  [84] = {.lex_state = 408, .external_lex_state = 2},
  [85] = {.lex_state = 408, .external_lex_state = 2},
  [86] = {.lex_state = 408, .external_lex_state = 2},
  [87] = {.lex_state = 408, .external_lex_state = 2},
  [88] = {.lex_state = 408, .external_lex_state = 2},
  [89] = {.lex_state = 408, .external_lex_state = 2},
  [90] = {.lex_state = 408, .external_lex_state = 2},
  [91] = {.lex_state = 408, .external_lex_state = 2},
  [92] = {.lex_state = 408, .external_lex_state = 2},
  [93] = {.lex_state = 408, .external_lex_state = 2},
  [94] = {.lex_state = 408, .external_lex_state = 2},
  [95] = {.lex_state = 408, .external_lex_state = 2},
  [96] = {.lex_state = 408, .external_lex_state = 2},
  [97] = {.lex_state = 408, .external_lex_state = 2},
  [98] = {.lex_state = 408, .external_lex_state = 2},
  [99] = {.lex_state = 408, .external_lex_state = 2},
  [100] = {.lex_state = 408, .external_lex_state = 2},
  [101] = {.lex_state = 408, .external_lex_state = 2},
  [102] = {.lex_state = 408, .external_lex_state = 2},
  [103] = {.lex_state = 408, .external_lex_state = 2},
  [104] = {.lex_state = 408, .external_lex_state = 2},
  [105] = {.lex_state = 408, .external_lex_state = 2},
  [106] = {.lex_state = 408, .external_lex_state = 2},
  [107] = {.lex_state = 408, .external_lex_state = 2},
  [108] = {.lex_state = 408, .external_lex_state = 2},
  [109] = {.lex_state = 408, .external_lex_state = 2},
  [110] = {.lex_state = 408, .external_lex_state = 2},
  [111] = {.lex_state = 408, .external_lex_state = 2},
  [112] = {.lex_state = 408, .external_lex_state = 2},
  [113] = {.lex_state = 408, .external_lex_state = 2},
  [114] = {.lex_state = 408, .external_lex_state = 2},
  [115] = {.lex_state = 408, .external_lex_state = 2},
  [116] = {.lex_state = 408, .external_lex_state = 2},
  [117] = {.lex_state = 408, .external_lex_state = 2},
  [118] = {.lex_state = 408, .external_lex_state = 2},
  [119] = {.lex_state = 408, .external_lex_state = 2},
  [120] = {.lex_state = 408, .external_lex_state = 2},
  [121] = {.lex_state = 408, .external_lex_state = 2},
  [122] = {.lex_state = 408, .external_lex_state = 2},
  [123] = {.lex_state = 6, .external_lex_state = 4},
  [124] = {.lex_state = 35, .external_lex_state = 2},
  [125] = {.lex_state = 35, .external_lex_state = 2},
  [126] = {.lex_state = 35, .external_lex_state = 2},
  [127] = {.lex_state = 6, .external_lex_state = 4},
  [128] = {.lex_state = 6, .external_lex_state = 4},
  [129] = {.lex_state = 35, .external_lex_state = 2},
  [130] = {.lex_state = 35, .external_lex_state = 2},
  [131] = {.lex_state = 35, .external_lex_state = 2},
  [132] = {.lex_state = 35, .external_lex_state = 2},
  [133] = {.lex_state = 35, .external_lex_state = 2},
  [134] = {.lex_state = 35, .external_lex_state = 2},
  [135] = {.lex_state = 35, .external_lex_state = 2},
  [136] = {.lex_state = 6, .external_lex_state = 3},
  [137] = {.lex_state = 6, .external_lex_state = 3},
  [138] = {.lex_state = 6, .external_lex_state = 3},
  [139] = {.lex_state = 6, .external_lex_state = 3},
  [140] = {.lex_state = 6, .external_lex_state = 3},
  [141] = {.lex_state = 6, .external_lex_state = 3},
  [142] = {.lex_state = 6, .external_lex_state = 3},
  [143] = {.lex_state = 6, .external_lex_state = 3},
  [144] = {.lex_state = 6, .external_lex_state = 3},
  [145] = {.lex_state = 6, .external_lex_state = 3},
  [146] = {.lex_state = 6, .external_lex_state = 3},
  [147] = {.lex_state = 35, .external_lex_state = 2},
  [148] = {.lex_state = 35, .external_lex_state = 2},
  [149] = {.lex_state = 6, .external_lex_state = 3},
  [150] = {.lex_state = 35, .external_lex_state = 2},
  [151] = {.lex_state = 6, .external_lex_state = 3},
  [152] = {.lex_state = 6, .external_lex_state = 3},
  [153] = {.lex_state = 6, .external_lex_state = 3},
  [154] = {.lex_state = 35, .external_lex_state = 2},
  [155] = {.lex_state = 6, .external_lex_state = 3},
  [156] = {.lex_state = 6, .external_lex_state = 4},
  [157] = {.lex_state = 10, .external_lex_state = 4},
  [158] = {.lex_state = 35, .external_lex_state = 2},
  [159] = {.lex_state = 6, .external_lex_state = 4},
  [160] = {.lex_state = 10, .external_lex_state = 4},
  [161] = {.lex_state = 6, .external_lex_state = 4},
  [162] = {.lex_state = 6, .external_lex_state = 4},
  [163] = {.lex_state = 6, .external_lex_state = 4},
  [164] = {.lex_state = 6, .external_lex_state = 4},
  [165] = {.lex_state = 35, .external_lex_state = 2},
  [166] = {.lex_state = 35, .external_lex_state = 2},
  [167] = {.lex_state = 10, .external_lex_state = 4},
  [168] = {.lex_state = 6, .external_lex_state = 4},
  [169] = {.lex_state = 6, .external_lex_state = 4},
  [170] = {.lex_state = 35, .external_lex_state = 2},
  [171] = {.lex_state = 10, .external_lex_state = 4},
  [172] = {.lex_state = 6, .external_lex_state = 3},
  [173] = {.lex_state = 6, .external_lex_state = 3},
  [174] = {.lex_state = 6, .external_lex_state = 3},
  [175] = {.lex_state = 6, .external_lex_state = 4},
  [176] = {.lex_state = 6, .external_lex_state = 3},
  [177] = {.lex_state = 6, .external_lex_state = 3},
  [178] = {.lex_state = 11, .external_lex_state = 3},
  [179] = {.lex_state = 6, .external_lex_state = 3},
  [180] = {.lex_state = 6, .external_lex_state = 3},
  [181] = {.lex_state = 6, .external_lex_state = 4},
  [182] = {.lex_state = 11, .external_lex_state = 3},
  [183] = {.lex_state = 6, .external_lex_state = 3},
  [184] = {.lex_state = 11, .external_lex_state = 3},
  [185] = {.lex_state = 6, .external_lex_state = 3},
  [186] = {.lex_state = 6, .external_lex_state = 3},
  [187] = {.lex_state = 6, .external_lex_state = 4},
  [188] = {.lex_state = 10, .external_lex_state = 3},
  [189] = {.lex_state = 6, .external_lex_state = 3},
  [190] = {.lex_state = 10, .external_lex_state = 3},
  [191] = {.lex_state = 6, .external_lex_state = 3},
  [192] = {.lex_state = 10, .external_lex_state = 3},
  [193] = {.lex_state = 6, .external_lex_state = 3},
  [194] = {.lex_state = 10, .external_lex_state = 3},
  [195] = {.lex_state = 6, .external_lex_state = 3},
  [196] = {.lex_state = 6, .external_lex_state = 3},
  [197] = {.lex_state = 6, .external_lex_state = 3},
  [198] = {.lex_state = 35, .external_lex_state = 2},
  [199] = {.lex_state = 6, .external_lex_state = 3},
  [200] = {.lex_state = 6, .external_lex_state = 3},
  [201] = {.lex_state = 6, .external_lex_state = 3},
  [202] = {.lex_state = 6, .external_lex_state = 3},
  [203] = {.lex_state = 6, .external_lex_state = 3},
  [204] = {.lex_state = 6, .external_lex_state = 3},
  [205] = {.lex_state = 6, .external_lex_state = 3},
  [206] = {.lex_state = 6, .external_lex_state = 3},
  [207] = {.lex_state = 6, .external_lex_state = 3},
  [208] = {.lex_state = 35, .external_lex_state = 2},
  [209] = {.lex_state = 35, .external_lex_state = 2},
  [210] = {.lex_state = 35, .external_lex_state = 2},
  [211] = {.lex_state = 35, .external_lex_state = 2},
  [212] = {.lex_state = 35, .external_lex_state = 2},
  [213] = {.lex_state = 35, .external_lex_state = 2},
  [214] = {.lex_state = 35, .external_lex_state = 2},
  [215] = {.lex_state = 35, .external_lex_state = 2},
  [216] = {.lex_state = 35, .external_lex_state = 2},
  [217] = {.lex_state = 35, .external_lex_state = 2},
  [218] = {.lex_state = 35, .external_lex_state = 2},
  [219] = {.lex_state = 35, .external_lex_state = 2},
  [220] = {.lex_state = 12, .external_lex_state = 3},
  [221] = {.lex_state = 12, .external_lex_state = 4},
  [222] = {.lex_state = 13, .external_lex_state = 4},
  [223] = {.lex_state = 16, .external_lex_state = 3},
  [224] = {.lex_state = 12, .external_lex_state = 3},
  [225] = {.lex_state = 12, .external_lex_state = 4},
  [226] = {.lex_state = 13, .external_lex_state = 3},
  [227] = {.lex_state = 12, .external_lex_state = 3},
  [228] = {.lex_state = 12, .external_lex_state = 3},
  [229] = {.lex_state = 47, .external_lex_state = 2},
  [230] = {.lex_state = 47, .external_lex_state = 2},
  [231] = {.lex_state = 47, .external_lex_state = 2},
  [232] = {.lex_state = 47, .external_lex_state = 2},
  [233] = {.lex_state = 47, .external_lex_state = 2},
  [234] = {.lex_state = 47, .external_lex_state = 2},
  [235] = {.lex_state = 47, .external_lex_state = 2},
  [236] = {.lex_state = 47, .external_lex_state = 2},
  [237] = {.lex_state = 47, .external_lex_state = 2},
  [238] = {.lex_state = 47, .external_lex_state = 2},
  [239] = {.lex_state = 47, .external_lex_state = 2},
  [240] = {.lex_state = 47, .external_lex_state = 2},
  [241] = {.lex_state = 17, .external_lex_state = 3},
  [242] = {.lex_state = 17, .external_lex_state = 4},
  [243] = {.lex_state = 19, .external_lex_state = 4},
  [244] = {.lex_state = 17, .external_lex_state = 3},
  [245] = {.lex_state = 17, .external_lex_state = 3},
  [246] = {.lex_state = 17, .external_lex_state = 3},
  [247] = {.lex_state = 37, .external_lex_state = 2},
  [248] = {.lex_state = 17, .external_lex_state = 3},
  [249] = {.lex_state = 17, .external_lex_state = 3},
  [250] = {.lex_state = 37, .external_lex_state = 2},
  [251] = {.lex_state = 20, .external_lex_state = 3},
  [252] = {.lex_state = 17, .external_lex_state = 4},
  [253] = {.lex_state = 37, .external_lex_state = 2},
  [254] = {.lex_state = 37, .external_lex_state = 2},
  [255] = {.lex_state = 19, .external_lex_state = 3},
  [256] = {.lex_state = 37, .external_lex_state = 2},
  [257] = {.lex_state = 37, .external_lex_state = 2},
  [258] = {.lex_state = 37, .external_lex_state = 2},
  [259] = {.lex_state = 37, .external_lex_state = 2},
  [260] = {.lex_state = 17, .external_lex_state = 3},
  [261] = {.lex_state = 37, .external_lex_state = 2},
  [262] = {.lex_state = 37, .external_lex_state = 2},
  [263] = {.lex_state = 17, .external_lex_state = 3},
  [264] = {.lex_state = 37, .external_lex_state = 2},
  [265] = {.lex_state = 37, .external_lex_state = 2},
  [266] = {.lex_state = 36, .external_lex_state = 2},
  [267] = {.lex_state = 37, .external_lex_state = 2},
  [268] = {.lex_state = 37, .external_lex_state = 2},
  [269] = {.lex_state = 37, .external_lex_state = 2},
  [270] = {.lex_state = 37, .external_lex_state = 2},
  [271] = {.lex_state = 37, .external_lex_state = 2},
  [272] = {.lex_state = 37, .external_lex_state = 2},
  [273] = {.lex_state = 37, .external_lex_state = 2},
  [274] = {.lex_state = 37, .external_lex_state = 2},
  [275] = {.lex_state = 17, .external_lex_state = 3},
  [276] = {.lex_state = 46, .external_lex_state = 2},
  [277] = {.lex_state = 37, .external_lex_state = 2},
  [278] = {.lex_state = 36, .external_lex_state = 5},
  [279] = {.lex_state = 46, .external_lex_state = 2},
  [280] = {.lex_state = 46, .external_lex_state = 2},
  [281] = {.lex_state = 46, .external_lex_state = 2},
  [282] = {.lex_state = 46, .external_lex_state = 2},
  [283] = {.lex_state = 37, .external_lex_state = 2},
  [284] = {.lex_state = 37, .external_lex_state = 2},
  [285] = {.lex_state = 37, .external_lex_state = 2},
  [286] = {.lex_state = 37, .external_lex_state = 2},
  [287] = {.lex_state = 37, .external_lex_state = 2},
  [288] = {.lex_state = 36, .external_lex_state = 2},
  [289] = {.lex_state = 37, .external_lex_state = 2},
  [290] = {.lex_state = 37, .external_lex_state = 2},
  [291] = {.lex_state = 15, .external_lex_state = 4},
  [292] = {.lex_state = 15, .external_lex_state = 4},
  [293] = {.lex_state = 15, .external_lex_state = 4},
  [294] = {.lex_state = 15, .external_lex_state = 4},
  [295] = {.lex_state = 37, .external_lex_state = 2},
  [296] = {.lex_state = 15, .external_lex_state = 4},
  [297] = {.lex_state = 405, .external_lex_state = 4},
  [298] = {.lex_state = 405, .external_lex_state = 4},
  [299] = {.lex_state = 405, .external_lex_state = 4},
  [300] = {.lex_state = 37, .external_lex_state = 2},
  [301] = {.lex_state = 36, .external_lex_state = 2},
  [302] = {.lex_state = 37, .external_lex_state = 2},
  [303] = {.lex_state = 15, .external_lex_state = 4},
  [304] = {.lex_state = 36, .external_lex_state = 2},
  [305] = {.lex_state = 15, .external_lex_state = 4},
  [306] = {.lex_state = 37, .external_lex_state = 2},
  [307] = {.lex_state = 14, .external_lex_state = 4},
  [308] = {.lex_state = 14, .external_lex_state = 4},
  [309] = {.lex_state = 14, .external_lex_state = 4},
  [310] = {.lex_state = 15, .external_lex_state = 4},
  [311] = {.lex_state = 15, .external_lex_state = 4},
  [312] = {.lex_state = 15, .external_lex_state = 4},
  [313] = {.lex_state = 36, .external_lex_state = 2},
  [314] = {.lex_state = 15, .external_lex_state = 4},
  [315] = {.lex_state = 15, .external_lex_state = 4},
  [316] = {.lex_state = 37, .external_lex_state = 2},
  [317] = {.lex_state = 37, .external_lex_state = 2},
  [318] = {.lex_state = 36, .external_lex_state = 2},
  [319] = {.lex_state = 15, .external_lex_state = 4},
  [320] = {.lex_state = 15, .external_lex_state = 4},
  [321] = {.lex_state = 15, .external_lex_state = 4},
  [322] = {.lex_state = 14, .external_lex_state = 4},
  [323] = {.lex_state = 37, .external_lex_state = 2},
  [324] = {.lex_state = 15, .external_lex_state = 4},
  [325] = {.lex_state = 37, .external_lex_state = 2},
  [326] = {.lex_state = 36, .external_lex_state = 2},
  [327] = {.lex_state = 15, .external_lex_state = 4},
  [328] = {.lex_state = 15, .external_lex_state = 4},
  [329] = {.lex_state = 15, .external_lex_state = 4},
  [330] = {.lex_state = 15, .external_lex_state = 4},
  [331] = {.lex_state = 15, .external_lex_state = 4},
  [332] = {.lex_state = 15, .external_lex_state = 4},
  [333] = {.lex_state = 15, .external_lex_state = 4},
  [334] = {.lex_state = 36, .external_lex_state = 2},
  [335] = {.lex_state = 15, .external_lex_state = 4},
  [336] = {.lex_state = 36, .external_lex_state = 2},
  [337] = {.lex_state = 15, .external_lex_state = 4},
  [338] = {.lex_state = 15, .external_lex_state = 4},
  [339] = {.lex_state = 15, .external_lex_state = 4},
  [340] = {.lex_state = 15, .external_lex_state = 4},
  [341] = {.lex_state = 37, .external_lex_state = 2},
  [342] = {.lex_state = 15, .external_lex_state = 4},
  [343] = {.lex_state = 405, .external_lex_state = 4},
  [344] = {.lex_state = 14, .external_lex_state = 4},
  [345] = {.lex_state = 37, .external_lex_state = 2},
  [346] = {.lex_state = 14, .external_lex_state = 4},
  [347] = {.lex_state = 14, .external_lex_state = 4},
  [348] = {.lex_state = 14, .external_lex_state = 4},
  [349] = {.lex_state = 37, .external_lex_state = 2},
  [350] = {.lex_state = 14, .external_lex_state = 4},
  [351] = {.lex_state = 405, .external_lex_state = 4},
  [352] = {.lex_state = 405, .external_lex_state = 4},
  [353] = {.lex_state = 14, .external_lex_state = 4},
  [354] = {.lex_state = 14, .external_lex_state = 4},
  [355] = {.lex_state = 37, .external_lex_state = 2},
  [356] = {.lex_state = 14, .external_lex_state = 4},
  [357] = {.lex_state = 405, .external_lex_state = 4},
  [358] = {.lex_state = 405, .external_lex_state = 4},
  [359] = {.lex_state = 37, .external_lex_state = 2},
  [360] = {.lex_state = 405, .external_lex_state = 4},
  [361] = {.lex_state = 14, .external_lex_state = 4},
  [362] = {.lex_state = 405, .external_lex_state = 4},
  [363] = {.lex_state = 14, .external_lex_state = 4},
  [364] = {.lex_state = 405, .external_lex_state = 4},
  [365] = {.lex_state = 37, .external_lex_state = 2},
  [366] = {.lex_state = 14, .external_lex_state = 4},
  [367] = {.lex_state = 37, .external_lex_state = 2},
  [368] = {.lex_state = 14, .external_lex_state = 4},
  [369] = {.lex_state = 37, .external_lex_state = 2},
  [370] = {.lex_state = 37, .external_lex_state = 2},
  [371] = {.lex_state = 404, .external_lex_state = 4},
  [372] = {.lex_state = 404, .external_lex_state = 4},
  [373] = {.lex_state = 404, .external_lex_state = 4},
  [374] = {.lex_state = 405, .external_lex_state = 4},
  [375] = {.lex_state = 14, .external_lex_state = 4},
  [376] = {.lex_state = 405, .external_lex_state = 4},
  [377] = {.lex_state = 37, .external_lex_state = 2},
  [378] = {.lex_state = 404, .external_lex_state = 4},
  [379] = {.lex_state = 37, .external_lex_state = 2},
  [380] = {.lex_state = 37, .external_lex_state = 2},
  [381] = {.lex_state = 405, .external_lex_state = 4},
  [382] = {.lex_state = 405, .external_lex_state = 4},
  [383] = {.lex_state = 405, .external_lex_state = 4},
  [384] = {.lex_state = 405, .external_lex_state = 4},
  [385] = {.lex_state = 405, .external_lex_state = 4},
  [386] = {.lex_state = 14, .external_lex_state = 4},
  [387] = {.lex_state = 14, .external_lex_state = 4},
  [388] = {.lex_state = 37, .external_lex_state = 2},
  [389] = {.lex_state = 14, .external_lex_state = 4},
  [390] = {.lex_state = 37, .external_lex_state = 2},
  [391] = {.lex_state = 14, .external_lex_state = 4},
  [392] = {.lex_state = 37, .external_lex_state = 2},
  [393] = {.lex_state = 405, .external_lex_state = 4},
  [394] = {.lex_state = 14, .external_lex_state = 4},
  [395] = {.lex_state = 14, .external_lex_state = 4},
  [396] = {.lex_state = 37, .external_lex_state = 2},
  [397] = {.lex_state = 405, .external_lex_state = 4},
  [398] = {.lex_state = 14, .external_lex_state = 4},
  [399] = {.lex_state = 37, .external_lex_state = 2},
  [400] = {.lex_state = 37, .external_lex_state = 2},
  [401] = {.lex_state = 405, .external_lex_state = 4},
  [402] = {.lex_state = 37, .external_lex_state = 2},
  [403] = {.lex_state = 37, .external_lex_state = 2},
  [404] = {.lex_state = 37, .external_lex_state = 2},
  [405] = {.lex_state = 405, .external_lex_state = 4},
  [406] = {.lex_state = 405, .external_lex_state = 4},
  [407] = {.lex_state = 37, .external_lex_state = 2},
  [408] = {.lex_state = 14, .external_lex_state = 4},
  [409] = {.lex_state = 405, .external_lex_state = 4},
  [410] = {.lex_state = 405, .external_lex_state = 4},
  [411] = {.lex_state = 37, .external_lex_state = 2},
  [412] = {.lex_state = 405, .external_lex_state = 4},
  [413] = {.lex_state = 14, .external_lex_state = 4},
  [414] = {.lex_state = 37, .external_lex_state = 2},
  [415] = {.lex_state = 405, .external_lex_state = 4},
  [416] = {.lex_state = 405, .external_lex_state = 4},
  [417] = {.lex_state = 14, .external_lex_state = 4},
  [418] = {.lex_state = 37, .external_lex_state = 2},
  [419] = {.lex_state = 405, .external_lex_state = 4},
  [420] = {.lex_state = 14, .external_lex_state = 4},
  [421] = {.lex_state = 37, .external_lex_state = 2},
  [422] = {.lex_state = 14, .external_lex_state = 4},
  [423] = {.lex_state = 37, .external_lex_state = 5},
  [424] = {.lex_state = 404, .external_lex_state = 4},
  [425] = {.lex_state = 404, .external_lex_state = 4},
  [426] = {.lex_state = 6, .external_lex_state = 3},
  [427] = {.lex_state = 6, .external_lex_state = 3},
  [428] = {.lex_state = 404, .external_lex_state = 4},
  [429] = {.lex_state = 404, .external_lex_state = 4},
  [430] = {.lex_state = 404, .external_lex_state = 4},
  [431] = {.lex_state = 404, .external_lex_state = 4},
  [432] = {.lex_state = 37, .external_lex_state = 5},
  [433] = {.lex_state = 37, .external_lex_state = 2},
  [434] = {.lex_state = 404, .external_lex_state = 4},
  [435] = {.lex_state = 404, .external_lex_state = 4},
  [436] = {.lex_state = 37, .external_lex_state = 2},
  [437] = {.lex_state = 404, .external_lex_state = 4},
  [438] = {.lex_state = 404, .external_lex_state = 4},
  [439] = {.lex_state = 404, .external_lex_state = 4},
  [440] = {.lex_state = 404, .external_lex_state = 4},
  [441] = {.lex_state = 404, .external_lex_state = 4},
  [442] = {.lex_state = 404, .external_lex_state = 4},
  [443] = {.lex_state = 6, .external_lex_state = 3},
  [444] = {.lex_state = 404, .external_lex_state = 4},
  [445] = {.lex_state = 37, .external_lex_state = 5},
  [446] = {.lex_state = 6, .external_lex_state = 3},
  [447] = {.lex_state = 37, .external_lex_state = 5},
  [448] = {.lex_state = 404, .external_lex_state = 4},
  [449] = {.lex_state = 404, .external_lex_state = 4},
  [450] = {.lex_state = 404, .external_lex_state = 4},
  [451] = {.lex_state = 404, .external_lex_state = 4},
  [452] = {.lex_state = 404, .external_lex_state = 4},
  [453] = {.lex_state = 404, .external_lex_state = 4},
  [454] = {.lex_state = 404, .external_lex_state = 4},
  [455] = {.lex_state = 37, .external_lex_state = 2},
  [456] = {.lex_state = 404, .external_lex_state = 4},
  [457] = {.lex_state = 37, .external_lex_state = 2},
  [458] = {.lex_state = 404, .external_lex_state = 4},
  [459] = {.lex_state = 37, .external_lex_state = 5},
  [460] = {.lex_state = 404, .external_lex_state = 4},
  [461] = {.lex_state = 46, .external_lex_state = 2},
  [462] = {.lex_state = 37, .external_lex_state = 2},
  [463] = {.lex_state = 37, .external_lex_state = 2},
  [464] = {.lex_state = 37, .external_lex_state = 2},
  [465] = {.lex_state = 37, .external_lex_state = 2},
  [466] = {.lex_state = 37, .external_lex_state = 2},
  [467] = {.lex_state = 37, .external_lex_state = 2},
  [468] = {.lex_state = 37, .external_lex_state = 2},
  [469] = {.lex_state = 37, .external_lex_state = 2},
  [470] = {.lex_state = 37, .external_lex_state = 2},
  [471] = {.lex_state = 37, .external_lex_state = 2},
  [472] = {.lex_state = 37, .external_lex_state = 2},
  [473] = {.lex_state = 37, .external_lex_state = 2},
  [474] = {.lex_state = 37, .external_lex_state = 2},
  [475] = {.lex_state = 37, .external_lex_state = 2},
  [476] = {.lex_state = 37, .external_lex_state = 2},
  [477] = {.lex_state = 37, .external_lex_state = 2},
  [478] = {.lex_state = 37, .external_lex_state = 2},
  [479] = {.lex_state = 37, .external_lex_state = 2},
  [480] = {.lex_state = 37, .external_lex_state = 2},
  [481] = {.lex_state = 37, .external_lex_state = 2},
  [482] = {.lex_state = 37, .external_lex_state = 2},
  [483] = {.lex_state = 37, .external_lex_state = 2},
  [484] = {.lex_state = 37, .external_lex_state = 2},
  [485] = {.lex_state = 37, .external_lex_state = 2},
  [486] = {.lex_state = 37, .external_lex_state = 2},
  [487] = {.lex_state = 37, .external_lex_state = 2},
  [488] = {.lex_state = 37, .external_lex_state = 2},
  [489] = {.lex_state = 37, .external_lex_state = 2},
  [490] = {.lex_state = 37, .external_lex_state = 2},
  [491] = {.lex_state = 37, .external_lex_state = 2},
  [492] = {.lex_state = 37, .external_lex_state = 2},
  [493] = {.lex_state = 37, .external_lex_state = 2},
  [494] = {.lex_state = 37, .external_lex_state = 2},
  [495] = {.lex_state = 37, .external_lex_state = 2},
  [496] = {.lex_state = 37, .external_lex_state = 2},
  [497] = {.lex_state = 37, .external_lex_state = 2},
  [498] = {.lex_state = 37, .external_lex_state = 2},
  [499] = {.lex_state = 37, .external_lex_state = 2},
  [500] = {.lex_state = 37, .external_lex_state = 2},
  [501] = {.lex_state = 37, .external_lex_state = 2},
  [502] = {.lex_state = 37, .external_lex_state = 2},
  [503] = {.lex_state = 37, .external_lex_state = 2},
  [504] = {.lex_state = 37, .external_lex_state = 2},
  [505] = {.lex_state = 37, .external_lex_state = 2},
  [506] = {.lex_state = 37, .external_lex_state = 2},
  [507] = {.lex_state = 37, .external_lex_state = 2},
  [508] = {.lex_state = 37, .external_lex_state = 2},
  [509] = {.lex_state = 37, .external_lex_state = 2},
  [510] = {.lex_state = 37, .external_lex_state = 2},
  [511] = {.lex_state = 37, .external_lex_state = 2},
  [512] = {.lex_state = 37, .external_lex_state = 2},
  [513] = {.lex_state = 37, .external_lex_state = 2},
  [514] = {.lex_state = 37, .external_lex_state = 2},
  [515] = {.lex_state = 37, .external_lex_state = 2},
  [516] = {.lex_state = 37, .external_lex_state = 2},
  [517] = {.lex_state = 37, .external_lex_state = 2},
  [518] = {.lex_state = 37, .external_lex_state = 2},
  [519] = {.lex_state = 37, .external_lex_state = 2},
  [520] = {.lex_state = 37, .external_lex_state = 2},
  [521] = {.lex_state = 37, .external_lex_state = 2},
  [522] = {.lex_state = 37, .external_lex_state = 2},
  [523] = {.lex_state = 37, .external_lex_state = 2},
  [524] = {.lex_state = 37, .external_lex_state = 2},
  [525] = {.lex_state = 37, .external_lex_state = 2},
  [526] = {.lex_state = 37, .external_lex_state = 2},
  [527] = {.lex_state = 37, .external_lex_state = 2},
  [528] = {.lex_state = 37, .external_lex_state = 2},
  [529] = {.lex_state = 37, .external_lex_state = 2},
  [530] = {.lex_state = 37, .external_lex_state = 2},
  [531] = {.lex_state = 37, .external_lex_state = 2},
  [532] = {.lex_state = 37, .external_lex_state = 2},
  [533] = {.lex_state = 37, .external_lex_state = 2},
  [534] = {.lex_state = 37, .external_lex_state = 2},
  [535] = {.lex_state = 37, .external_lex_state = 2},
  [536] = {.lex_state = 37, .external_lex_state = 2},
  [537] = {.lex_state = 37, .external_lex_state = 2},
  [538] = {.lex_state = 37, .external_lex_state = 2},
  [539] = {.lex_state = 37, .external_lex_state = 2},
  [540] = {.lex_state = 37, .external_lex_state = 2},
  [541] = {.lex_state = 37, .external_lex_state = 2},
  [542] = {.lex_state = 37, .external_lex_state = 2},
  [543] = {.lex_state = 37, .external_lex_state = 2},
  [544] = {.lex_state = 37, .external_lex_state = 2},
  [545] = {.lex_state = 37, .external_lex_state = 2},
  [546] = {.lex_state = 37, .external_lex_state = 2},
  [547] = {.lex_state = 37, .external_lex_state = 2},
  [548] = {.lex_state = 37, .external_lex_state = 2},
  [549] = {.lex_state = 37, .external_lex_state = 2},
  [550] = {.lex_state = 37, .external_lex_state = 2},
  [551] = {.lex_state = 37, .external_lex_state = 2},
  [552] = {.lex_state = 37, .external_lex_state = 2},
  [553] = {.lex_state = 37, .external_lex_state = 2},
  [554] = {.lex_state = 37, .external_lex_state = 2},
  [555] = {.lex_state = 37, .external_lex_state = 2},
  [556] = {.lex_state = 37, .external_lex_state = 2},
  [557] = {.lex_state = 37, .external_lex_state = 2},
  [558] = {.lex_state = 37, .external_lex_state = 2},
  [559] = {.lex_state = 37, .external_lex_state = 2},
  [560] = {.lex_state = 37, .external_lex_state = 2},
  [561] = {.lex_state = 37, .external_lex_state = 2},
  [562] = {.lex_state = 37, .external_lex_state = 2},
  [563] = {.lex_state = 37, .external_lex_state = 2},
  [564] = {.lex_state = 37, .external_lex_state = 2},
  [565] = {.lex_state = 37, .external_lex_state = 2},
  [566] = {.lex_state = 37, .external_lex_state = 2},
  [567] = {.lex_state = 37, .external_lex_state = 2},
  [568] = {.lex_state = 37, .external_lex_state = 2},
  [569] = {.lex_state = 37, .external_lex_state = 2},
  [570] = {.lex_state = 37, .external_lex_state = 2},
  [571] = {.lex_state = 37, .external_lex_state = 2},
  [572] = {.lex_state = 37, .external_lex_state = 2},
  [573] = {.lex_state = 37, .external_lex_state = 2},
  [574] = {.lex_state = 37, .external_lex_state = 2},
  [575] = {.lex_state = 37, .external_lex_state = 2},
  [576] = {.lex_state = 37, .external_lex_state = 2},
  [577] = {.lex_state = 37, .external_lex_state = 2},
  [578] = {.lex_state = 37, .external_lex_state = 2},
  [579] = {.lex_state = 37, .external_lex_state = 2},
  [580] = {.lex_state = 37, .external_lex_state = 2},
  [581] = {.lex_state = 37, .external_lex_state = 2},
  [582] = {.lex_state = 37, .external_lex_state = 2},
  [583] = {.lex_state = 37, .external_lex_state = 2},
  [584] = {.lex_state = 37, .external_lex_state = 2},
  [585] = {.lex_state = 37, .external_lex_state = 2},
  [586] = {.lex_state = 37, .external_lex_state = 2},
  [587] = {.lex_state = 37, .external_lex_state = 2},
  [588] = {.lex_state = 37, .external_lex_state = 2},
  [589] = {.lex_state = 37, .external_lex_state = 2},
  [590] = {.lex_state = 37, .external_lex_state = 2},
  [591] = {.lex_state = 37, .external_lex_state = 2},
  [592] = {.lex_state = 37, .external_lex_state = 2},
  [593] = {.lex_state = 37, .external_lex_state = 2},
  [594] = {.lex_state = 37, .external_lex_state = 2},
  [595] = {.lex_state = 37, .external_lex_state = 2},
  [596] = {.lex_state = 37, .external_lex_state = 2},
  [597] = {.lex_state = 37, .external_lex_state = 2},
  [598] = {.lex_state = 37, .external_lex_state = 2},
  [599] = {.lex_state = 37, .external_lex_state = 2},
  [600] = {.lex_state = 37, .external_lex_state = 2},
  [601] = {.lex_state = 37, .external_lex_state = 2},
  [602] = {.lex_state = 37, .external_lex_state = 2},
  [603] = {.lex_state = 37, .external_lex_state = 2},
  [604] = {.lex_state = 37, .external_lex_state = 2},
  [605] = {.lex_state = 37, .external_lex_state = 2},
  [606] = {.lex_state = 37, .external_lex_state = 2},
  [607] = {.lex_state = 37, .external_lex_state = 2},
  [608] = {.lex_state = 37, .external_lex_state = 2},
  [609] = {.lex_state = 37, .external_lex_state = 2},
  [610] = {.lex_state = 37, .external_lex_state = 2},
  [611] = {.lex_state = 37, .external_lex_state = 2},
  [612] = {.lex_state = 37, .external_lex_state = 2},
  [613] = {.lex_state = 37, .external_lex_state = 2},
  [614] = {.lex_state = 37, .external_lex_state = 2},
  [615] = {.lex_state = 37, .external_lex_state = 2},
  [616] = {.lex_state = 37, .external_lex_state = 2},
  [617] = {.lex_state = 37, .external_lex_state = 2},
  [618] = {.lex_state = 37, .external_lex_state = 2},
  [619] = {.lex_state = 37, .external_lex_state = 2},
  [620] = {.lex_state = 37, .external_lex_state = 2},
  [621] = {.lex_state = 37, .external_lex_state = 2},
  [622] = {.lex_state = 37, .external_lex_state = 2},
  [623] = {.lex_state = 37, .external_lex_state = 2},
  [624] = {.lex_state = 37, .external_lex_state = 2},
  [625] = {.lex_state = 37, .external_lex_state = 2},
  [626] = {.lex_state = 37, .external_lex_state = 2},
  [627] = {.lex_state = 37, .external_lex_state = 2},
  [628] = {.lex_state = 37, .external_lex_state = 2},
  [629] = {.lex_state = 37, .external_lex_state = 2},
  [630] = {.lex_state = 37, .external_lex_state = 2},
  [631] = {.lex_state = 37, .external_lex_state = 2},
  [632] = {.lex_state = 37, .external_lex_state = 2},
  [633] = {.lex_state = 37, .external_lex_state = 2},
  [634] = {.lex_state = 37, .external_lex_state = 2},
  [635] = {.lex_state = 37, .external_lex_state = 2},
  [636] = {.lex_state = 37, .external_lex_state = 2},
  [637] = {.lex_state = 37, .external_lex_state = 2},
  [638] = {.lex_state = 37, .external_lex_state = 2},
  [639] = {.lex_state = 37, .external_lex_state = 2},
  [640] = {.lex_state = 37, .external_lex_state = 2},
  [641] = {.lex_state = 37, .external_lex_state = 2},
  [642] = {.lex_state = 37, .external_lex_state = 2},
  [643] = {.lex_state = 37, .external_lex_state = 2},
  [644] = {.lex_state = 37, .external_lex_state = 2},
  [645] = {.lex_state = 37, .external_lex_state = 2},
  [646] = {.lex_state = 37, .external_lex_state = 2},
  [647] = {.lex_state = 37, .external_lex_state = 2},
  [648] = {.lex_state = 37, .external_lex_state = 2},
  [649] = {.lex_state = 37, .external_lex_state = 2},
  [650] = {.lex_state = 37, .external_lex_state = 2},
  [651] = {.lex_state = 37, .external_lex_state = 2},
  [652] = {.lex_state = 37, .external_lex_state = 2},
  [653] = {.lex_state = 37, .external_lex_state = 2},
  [654] = {.lex_state = 37, .external_lex_state = 2},
  [655] = {.lex_state = 37, .external_lex_state = 2},
  [656] = {.lex_state = 37, .external_lex_state = 2},
  [657] = {.lex_state = 37, .external_lex_state = 2},
  [658] = {.lex_state = 37, .external_lex_state = 2},
  [659] = {.lex_state = 37, .external_lex_state = 2},
  [660] = {.lex_state = 37, .external_lex_state = 2},
  [661] = {.lex_state = 37, .external_lex_state = 2},
  [662] = {.lex_state = 37, .external_lex_state = 2},
  [663] = {.lex_state = 37, .external_lex_state = 2},
  [664] = {.lex_state = 37, .external_lex_state = 2},
  [665] = {.lex_state = 37, .external_lex_state = 2},
  [666] = {.lex_state = 37, .external_lex_state = 2},
  [667] = {.lex_state = 37, .external_lex_state = 2},
  [668] = {.lex_state = 37, .external_lex_state = 2},
  [669] = {.lex_state = 37, .external_lex_state = 2},
  [670] = {.lex_state = 37, .external_lex_state = 2},
  [671] = {.lex_state = 37, .external_lex_state = 2},
  [672] = {.lex_state = 37, .external_lex_state = 2},
  [673] = {.lex_state = 37, .external_lex_state = 2},
  [674] = {.lex_state = 37, .external_lex_state = 2},
  [675] = {.lex_state = 37, .external_lex_state = 2},
  [676] = {.lex_state = 37, .external_lex_state = 2},
  [677] = {.lex_state = 37, .external_lex_state = 2},
  [678] = {.lex_state = 37, .external_lex_state = 2},
  [679] = {.lex_state = 37, .external_lex_state = 2},
  [680] = {.lex_state = 37, .external_lex_state = 2},
  [681] = {.lex_state = 37, .external_lex_state = 2},
  [682] = {.lex_state = 37, .external_lex_state = 2},
  [683] = {.lex_state = 37, .external_lex_state = 2},
  [684] = {.lex_state = 37, .external_lex_state = 2},
  [685] = {.lex_state = 37, .external_lex_state = 2},
  [686] = {.lex_state = 37, .external_lex_state = 2},
  [687] = {.lex_state = 37, .external_lex_state = 2},
  [688] = {.lex_state = 37, .external_lex_state = 2},
  [689] = {.lex_state = 37, .external_lex_state = 2},
  [690] = {.lex_state = 37, .external_lex_state = 2},
  [691] = {.lex_state = 37, .external_lex_state = 2},
  [692] = {.lex_state = 37, .external_lex_state = 2},
  [693] = {.lex_state = 37, .external_lex_state = 2},
  [694] = {.lex_state = 37, .external_lex_state = 2},
  [695] = {.lex_state = 37, .external_lex_state = 2},
  [696] = {.lex_state = 37, .external_lex_state = 2},
  [697] = {.lex_state = 37, .external_lex_state = 2},
  [698] = {.lex_state = 37, .external_lex_state = 2},
  [699] = {.lex_state = 37, .external_lex_state = 2},
  [700] = {.lex_state = 37, .external_lex_state = 2},
  [701] = {.lex_state = 37, .external_lex_state = 2},
  [702] = {.lex_state = 37, .external_lex_state = 2},
  [703] = {.lex_state = 37, .external_lex_state = 2},
  [704] = {.lex_state = 37, .external_lex_state = 2},
  [705] = {.lex_state = 37, .external_lex_state = 2},
  [706] = {.lex_state = 37, .external_lex_state = 2},
  [707] = {.lex_state = 37, .external_lex_state = 2},
  [708] = {.lex_state = 37, .external_lex_state = 2},
  [709] = {.lex_state = 37, .external_lex_state = 2},
  [710] = {.lex_state = 37, .external_lex_state = 2},
  [711] = {.lex_state = 37, .external_lex_state = 2},
  [712] = {.lex_state = 37, .external_lex_state = 2},
  [713] = {.lex_state = 37, .external_lex_state = 2},
  [714] = {.lex_state = 37, .external_lex_state = 2},
  [715] = {.lex_state = 37, .external_lex_state = 2},
  [716] = {.lex_state = 37, .external_lex_state = 2},
  [717] = {.lex_state = 37, .external_lex_state = 2},
  [718] = {.lex_state = 37, .external_lex_state = 2},
  [719] = {.lex_state = 37, .external_lex_state = 2},
  [720] = {.lex_state = 37, .external_lex_state = 2},
  [721] = {.lex_state = 37, .external_lex_state = 2},
  [722] = {.lex_state = 37, .external_lex_state = 2},
  [723] = {.lex_state = 37, .external_lex_state = 2},
  [724] = {.lex_state = 37, .external_lex_state = 2},
  [725] = {.lex_state = 37, .external_lex_state = 2},
  [726] = {.lex_state = 37, .external_lex_state = 2},
  [727] = {.lex_state = 37, .external_lex_state = 2},
  [728] = {.lex_state = 37, .external_lex_state = 2},
  [729] = {.lex_state = 37, .external_lex_state = 2},
  [730] = {.lex_state = 37, .external_lex_state = 2},
  [731] = {.lex_state = 37, .external_lex_state = 2},
  [732] = {.lex_state = 37, .external_lex_state = 2},
  [733] = {.lex_state = 37, .external_lex_state = 2},
  [734] = {.lex_state = 37, .external_lex_state = 2},
  [735] = {.lex_state = 37, .external_lex_state = 2},
  [736] = {.lex_state = 37, .external_lex_state = 2},
  [737] = {.lex_state = 37, .external_lex_state = 2},
  [738] = {.lex_state = 37, .external_lex_state = 2},
  [739] = {.lex_state = 37, .external_lex_state = 2},
  [740] = {.lex_state = 37, .external_lex_state = 2},
  [741] = {.lex_state = 37, .external_lex_state = 2},
  [742] = {.lex_state = 37, .external_lex_state = 2},
  [743] = {.lex_state = 37, .external_lex_state = 2},
  [744] = {.lex_state = 37, .external_lex_state = 2},
  [745] = {.lex_state = 37, .external_lex_state = 2},
  [746] = {.lex_state = 37, .external_lex_state = 2},
  [747] = {.lex_state = 37, .external_lex_state = 2},
  [748] = {.lex_state = 37, .external_lex_state = 2},
  [749] = {.lex_state = 37, .external_lex_state = 2},
  [750] = {.lex_state = 37, .external_lex_state = 2},
  [751] = {.lex_state = 37, .external_lex_state = 2},
  [752] = {.lex_state = 37, .external_lex_state = 2},
  [753] = {.lex_state = 37, .external_lex_state = 2},
  [754] = {.lex_state = 37, .external_lex_state = 2},
  [755] = {.lex_state = 37, .external_lex_state = 2},
  [756] = {.lex_state = 37, .external_lex_state = 2},
  [757] = {.lex_state = 37, .external_lex_state = 2},
  [758] = {.lex_state = 37, .external_lex_state = 2},
  [759] = {.lex_state = 37, .external_lex_state = 2},
  [760] = {.lex_state = 37, .external_lex_state = 2},
  [761] = {.lex_state = 37, .external_lex_state = 2},
  [762] = {.lex_state = 37, .external_lex_state = 2},
  [763] = {.lex_state = 37, .external_lex_state = 2},
  [764] = {.lex_state = 37, .external_lex_state = 2},
  [765] = {.lex_state = 37, .external_lex_state = 2},
  [766] = {.lex_state = 37, .external_lex_state = 2},
  [767] = {.lex_state = 37, .external_lex_state = 2},
  [768] = {.lex_state = 37, .external_lex_state = 2},
  [769] = {.lex_state = 37, .external_lex_state = 2},
  [770] = {.lex_state = 37, .external_lex_state = 2},
  [771] = {.lex_state = 37, .external_lex_state = 2},
  [772] = {.lex_state = 37, .external_lex_state = 2},
  [773] = {.lex_state = 37, .external_lex_state = 2},
  [774] = {.lex_state = 37, .external_lex_state = 2},
  [775] = {.lex_state = 37, .external_lex_state = 2},
  [776] = {.lex_state = 37, .external_lex_state = 2},
  [777] = {.lex_state = 37, .external_lex_state = 2},
  [778] = {.lex_state = 37, .external_lex_state = 2},
  [779] = {.lex_state = 37, .external_lex_state = 2},
  [780] = {.lex_state = 37, .external_lex_state = 2},
  [781] = {.lex_state = 37, .external_lex_state = 2},
  [782] = {.lex_state = 37, .external_lex_state = 2},
  [783] = {.lex_state = 37, .external_lex_state = 2},
  [784] = {.lex_state = 37, .external_lex_state = 2},
  [785] = {.lex_state = 37, .external_lex_state = 2},
  [786] = {.lex_state = 37, .external_lex_state = 2},
  [787] = {.lex_state = 37, .external_lex_state = 2},
  [788] = {.lex_state = 37, .external_lex_state = 2},
  [789] = {.lex_state = 37, .external_lex_state = 2},
  [790] = {.lex_state = 37, .external_lex_state = 2},
  [791] = {.lex_state = 37, .external_lex_state = 2},
  [792] = {.lex_state = 37, .external_lex_state = 2},
  [793] = {.lex_state = 37, .external_lex_state = 2},
  [794] = {.lex_state = 37, .external_lex_state = 2},
  [795] = {.lex_state = 37, .external_lex_state = 2},
  [796] = {.lex_state = 37, .external_lex_state = 2},
  [797] = {.lex_state = 37, .external_lex_state = 2},
  [798] = {.lex_state = 37, .external_lex_state = 2},
  [799] = {.lex_state = 37, .external_lex_state = 2},
  [800] = {.lex_state = 37, .external_lex_state = 2},
  [801] = {.lex_state = 37, .external_lex_state = 2},
  [802] = {.lex_state = 37, .external_lex_state = 2},
  [803] = {.lex_state = 37, .external_lex_state = 2},
  [804] = {.lex_state = 37, .external_lex_state = 2},
  [805] = {.lex_state = 37, .external_lex_state = 2},
  [806] = {.lex_state = 37, .external_lex_state = 2},
  [807] = {.lex_state = 406, .external_lex_state = 4},
  [808] = {.lex_state = 406, .external_lex_state = 4},
  [809] = {.lex_state = 406, .external_lex_state = 4},
  [810] = {.lex_state = 8, .external_lex_state = 4},
  [811] = {.lex_state = 8, .external_lex_state = 4},
  [812] = {.lex_state = 8, .external_lex_state = 4},
  [813] = {.lex_state = 406, .external_lex_state = 4},
  [814] = {.lex_state = 406, .external_lex_state = 4},
  [815] = {.lex_state = 406, .external_lex_state = 4},
  [816] = {.lex_state = 406, .external_lex_state = 4},
  [817] = {.lex_state = 406, .external_lex_state = 4},
  [818] = {.lex_state = 406, .external_lex_state = 4},
  [819] = {.lex_state = 406, .external_lex_state = 4},
  [820] = {.lex_state = 406, .external_lex_state = 4},
  [821] = {.lex_state = 9, .external_lex_state = 4},
  [822] = {.lex_state = 9, .external_lex_state = 4},
  [823] = {.lex_state = 9, .external_lex_state = 4},
  [824] = {.lex_state = 9, .external_lex_state = 4},
  [825] = {.lex_state = 9, .external_lex_state = 4},
  [826] = {.lex_state = 9, .external_lex_state = 4},
  [827] = {.lex_state = 9, .external_lex_state = 4},
  [828] = {.lex_state = 9, .external_lex_state = 4},
  [829] = {.lex_state = 9, .external_lex_state = 4},
  [830] = {.lex_state = 406, .external_lex_state = 4},
  [831] = {.lex_state = 406, .external_lex_state = 4},
  [832] = {.lex_state = 406, .external_lex_state = 4},
  [833] = {.lex_state = 406, .external_lex_state = 4},
  [834] = {.lex_state = 406, .external_lex_state = 4},
  [835] = {.lex_state = 9, .external_lex_state = 4},
  [836] = {.lex_state = 9, .external_lex_state = 4},
  [837] = {.lex_state = 406, .external_lex_state = 4},
  [838] = {.lex_state = 406, .external_lex_state = 4},
  [839] = {.lex_state = 406, .external_lex_state = 4},
  [840] = {.lex_state = 9, .external_lex_state = 4},
  [841] = {.lex_state = 406, .external_lex_state = 4},
  [842] = {.lex_state = 406, .external_lex_state = 4},
  [843] = {.lex_state = 9, .external_lex_state = 4},
  [844] = {.lex_state = 9, .external_lex_state = 4},
  [845] = {.lex_state = 9, .external_lex_state = 4},
  [846] = {.lex_state = 406, .external_lex_state = 4},
  [847] = {.lex_state = 23, .external_lex_state = 3},
  [848] = {.lex_state = 23, .external_lex_state = 3},
  [849] = {.lex_state = 23, .external_lex_state = 3},
  [850] = {.lex_state = 23, .external_lex_state = 3},
  [851] = {.lex_state = 23, .external_lex_state = 3},
  [852] = {.lex_state = 23, .external_lex_state = 4},
  [853] = {.lex_state = 23, .external_lex_state = 4},
  [854] = {.lex_state = 25, .external_lex_state = 4},
  [855] = {.lex_state = 25, .external_lex_state = 4},
  [856] = {.lex_state = 23, .external_lex_state = 4},
  [857] = {.lex_state = 23, .external_lex_state = 4},
  [858] = {.lex_state = 23, .external_lex_state = 4},
  [859] = {.lex_state = 23, .external_lex_state = 3},
  [860] = {.lex_state = 23, .external_lex_state = 4},
  [861] = {.lex_state = 25, .external_lex_state = 4},
  [862] = {.lex_state = 23, .external_lex_state = 4},
  [863] = {.lex_state = 26, .external_lex_state = 3},
  [864] = {.lex_state = 23, .external_lex_state = 3},
  [865] = {.lex_state = 26, .external_lex_state = 3},
  [866] = {.lex_state = 23, .external_lex_state = 3},
  [867] = {.lex_state = 43, .external_lex_state = 2},
  [868] = {.lex_state = 23, .external_lex_state = 4},
  [869] = {.lex_state = 23, .external_lex_state = 4},
  [870] = {.lex_state = 23, .external_lex_state = 4},
  [871] = {.lex_state = 23, .external_lex_state = 4},
  [872] = {.lex_state = 23, .external_lex_state = 3},
  [873] = {.lex_state = 23, .external_lex_state = 4},
  [874] = {.lex_state = 23, .external_lex_state = 4},
  [875] = {.lex_state = 23, .external_lex_state = 3},
  [876] = {.lex_state = 23, .external_lex_state = 4},
  [877] = {.lex_state = 23, .external_lex_state = 3},
  [878] = {.lex_state = 23, .external_lex_state = 3},
  [879] = {.lex_state = 23, .external_lex_state = 4},
  [880] = {.lex_state = 23, .external_lex_state = 3},
  [881] = {.lex_state = 42, .external_lex_state = 2},
  [882] = {.lex_state = 23, .external_lex_state = 3},
  [883] = {.lex_state = 413, .external_lex_state = 2},
  [884] = {.lex_state = 25, .external_lex_state = 3},
  [885] = {.lex_state = 25, .external_lex_state = 3},
  [886] = {.lex_state = 43, .external_lex_state = 5},
  [887] = {.lex_state = 43, .external_lex_state = 5},
  [888] = {.lex_state = 23, .external_lex_state = 3},
  [889] = {.lex_state = 25, .external_lex_state = 3},
  [890] = {.lex_state = 23, .external_lex_state = 3},
  [891] = {.lex_state = 41, .external_lex_state = 2},
  [892] = {.lex_state = 23, .external_lex_state = 3},
  [893] = {.lex_state = 42, .external_lex_state = 5},
  [894] = {.lex_state = 412, .external_lex_state = 2},
  [895] = {.lex_state = 23, .external_lex_state = 3},
  [896] = {.lex_state = 45, .external_lex_state = 2},
  [897] = {.lex_state = 23, .external_lex_state = 3},
  [898] = {.lex_state = 23, .external_lex_state = 3},
  [899] = {.lex_state = 23, .external_lex_state = 3},
  [900] = {.lex_state = 23, .external_lex_state = 3},
  [901] = {.lex_state = 413, .external_lex_state = 5},
  [902] = {.lex_state = 413, .external_lex_state = 5},
  [903] = {.lex_state = 45, .external_lex_state = 5},
  [904] = {.lex_state = 43, .external_lex_state = 2},
  [905] = {.lex_state = 42, .external_lex_state = 5},
  [906] = {.lex_state = 43, .external_lex_state = 2},
  [907] = {.lex_state = 45, .external_lex_state = 5},
  [908] = {.lex_state = 23, .external_lex_state = 3},
  [909] = {.lex_state = 41, .external_lex_state = 2},
  [910] = {.lex_state = 23, .external_lex_state = 3},
  [911] = {.lex_state = 23, .external_lex_state = 3},
  [912] = {.lex_state = 41, .external_lex_state = 2},
  [913] = {.lex_state = 41, .external_lex_state = 5},
  [914] = {.lex_state = 41, .external_lex_state = 5},
  [915] = {.lex_state = 44, .external_lex_state = 5},
  [916] = {.lex_state = 42, .external_lex_state = 2},
  [917] = {.lex_state = 41, .external_lex_state = 2},
  [918] = {.lex_state = 42, .external_lex_state = 2},
  [919] = {.lex_state = 41, .external_lex_state = 5},
  [920] = {.lex_state = 41, .external_lex_state = 5},
  [921] = {.lex_state = 41, .external_lex_state = 5},
  [922] = {.lex_state = 41, .external_lex_state = 5},
  [923] = {.lex_state = 412, .external_lex_state = 5},
  [924] = {.lex_state = 41, .external_lex_state = 5},
  [925] = {.lex_state = 44, .external_lex_state = 5},
  [926] = {.lex_state = 41, .external_lex_state = 5},
  [927] = {.lex_state = 412, .external_lex_state = 5},
  [928] = {.lex_state = 409, .external_lex_state = 2},
  [929] = {.lex_state = 45, .external_lex_state = 2},
  [930] = {.lex_state = 409, .external_lex_state = 2},
  [931] = {.lex_state = 41, .external_lex_state = 5},
  [932] = {.lex_state = 41, .external_lex_state = 5},
  [933] = {.lex_state = 41, .external_lex_state = 5},
  [934] = {.lex_state = 44, .external_lex_state = 2},
  [935] = {.lex_state = 45, .external_lex_state = 2},
  [936] = {.lex_state = 413, .external_lex_state = 2},
  [937] = {.lex_state = 45, .external_lex_state = 2},
  [938] = {.lex_state = 45, .external_lex_state = 2},
  [939] = {.lex_state = 41, .external_lex_state = 5},
  [940] = {.lex_state = 45, .external_lex_state = 2},
  [941] = {.lex_state = 41, .external_lex_state = 5},
  [942] = {.lex_state = 41, .external_lex_state = 2},
  [943] = {.lex_state = 41, .external_lex_state = 5},
  [944] = {.lex_state = 411, .external_lex_state = 5},
  [945] = {.lex_state = 41, .external_lex_state = 5},
  [946] = {.lex_state = 41, .external_lex_state = 5},
  [947] = {.lex_state = 40, .external_lex_state = 2},
  [948] = {.lex_state = 40, .external_lex_state = 2},
  [949] = {.lex_state = 41, .external_lex_state = 5},
  [950] = {.lex_state = 41, .external_lex_state = 5},
  [951] = {.lex_state = 41, .external_lex_state = 5},
  [952] = {.lex_state = 41, .external_lex_state = 5},
  [953] = {.lex_state = 41, .external_lex_state = 5},
  [954] = {.lex_state = 411, .external_lex_state = 2},
  [955] = {.lex_state = 41, .external_lex_state = 5},
  [956] = {.lex_state = 41, .external_lex_state = 2},
  [957] = {.lex_state = 41, .external_lex_state = 2},
  [958] = {.lex_state = 411, .external_lex_state = 5},
  [959] = {.lex_state = 413, .external_lex_state = 2},
  [960] = {.lex_state = 41, .external_lex_state = 5},
  [961] = {.lex_state = 40, .external_lex_state = 5},
  [962] = {.lex_state = 408, .external_lex_state = 2},
  [963] = {.lex_state = 41, .external_lex_state = 2},
  [964] = {.lex_state = 41, .external_lex_state = 2},
  [965] = {.lex_state = 41, .external_lex_state = 2},
  [966] = {.lex_state = 41, .external_lex_state = 2},
  [967] = {.lex_state = 41, .external_lex_state = 2},
  [968] = {.lex_state = 41, .external_lex_state = 2},
  [969] = {.lex_state = 41, .external_lex_state = 2},
  [970] = {.lex_state = 41, .external_lex_state = 2},
  [971] = {.lex_state = 41, .external_lex_state = 2},
  [972] = {.lex_state = 409, .external_lex_state = 5},
  [973] = {.lex_state = 41, .external_lex_state = 2},
  [974] = {.lex_state = 41, .external_lex_state = 2},
  [975] = {.lex_state = 41, .external_lex_state = 2},
  [976] = {.lex_state = 41, .external_lex_state = 2},
  [977] = {.lex_state = 41, .external_lex_state = 2},
  [978] = {.lex_state = 41, .external_lex_state = 2},
  [979] = {.lex_state = 41, .external_lex_state = 2},
  [980] = {.lex_state = 41, .external_lex_state = 2},
  [981] = {.lex_state = 41, .external_lex_state = 2},
  [982] = {.lex_state = 41, .external_lex_state = 2},
  [983] = {.lex_state = 41, .external_lex_state = 2},
  [984] = {.lex_state = 410, .external_lex_state = 5},
  [985] = {.lex_state = 41, .external_lex_state = 2},
  [986] = {.lex_state = 41, .external_lex_state = 2},
  [987] = {.lex_state = 41, .external_lex_state = 2},
  [988] = {.lex_state = 41, .external_lex_state = 2},
  [989] = {.lex_state = 41, .external_lex_state = 2},
  [990] = {.lex_state = 41, .external_lex_state = 2},
  [991] = {.lex_state = 41, .external_lex_state = 2},
  [992] = {.lex_state = 41, .external_lex_state = 2},
  [993] = {.lex_state = 41, .external_lex_state = 2},
  [994] = {.lex_state = 41, .external_lex_state = 2},
  [995] = {.lex_state = 409, .external_lex_state = 5},
  [996] = {.lex_state = 41, .external_lex_state = 2},
  [997] = {.lex_state = 409, .external_lex_state = 5},
  [998] = {.lex_state = 411, .external_lex_state = 2},
  [999] = {.lex_state = 41, .external_lex_state = 2},
  [1000] = {.lex_state = 40, .external_lex_state = 5},
  [1001] = {.lex_state = 41, .external_lex_state = 2},
  [1002] = {.lex_state = 410, .external_lex_state = 5},
  [1003] = {.lex_state = 41, .external_lex_state = 2},
  [1004] = {.lex_state = 40, .external_lex_state = 5},
  [1005] = {.lex_state = 41, .external_lex_state = 2},
  [1006] = {.lex_state = 41, .external_lex_state = 2},
  [1007] = {.lex_state = 409, .external_lex_state = 5},
  [1008] = {.lex_state = 41, .external_lex_state = 2},
  [1009] = {.lex_state = 41, .external_lex_state = 2},
  [1010] = {.lex_state = 41, .external_lex_state = 2},
  [1011] = {.lex_state = 41, .external_lex_state = 2},
  [1012] = {.lex_state = 41, .external_lex_state = 2},
  [1013] = {.lex_state = 411, .external_lex_state = 2},
  [1014] = {.lex_state = 41, .external_lex_state = 2},
  [1015] = {.lex_state = 41, .external_lex_state = 2},
  [1016] = {.lex_state = 409, .external_lex_state = 2},
  [1017] = {.lex_state = 41, .external_lex_state = 2},
  [1018] = {.lex_state = 41, .external_lex_state = 2},
  [1019] = {.lex_state = 409, .external_lex_state = 5},
  [1020] = {.lex_state = 40, .external_lex_state = 5},
  [1021] = {.lex_state = 409, .external_lex_state = 2},
  [1022] = {.lex_state = 41, .external_lex_state = 2},
  [1023] = {.lex_state = 40, .external_lex_state = 5},
  [1024] = {.lex_state = 409, .external_lex_state = 2},
  [1025] = {.lex_state = 41, .external_lex_state = 2},
  [1026] = {.lex_state = 41, .external_lex_state = 2},
  [1027] = {.lex_state = 41, .external_lex_state = 2},
  [1028] = {.lex_state = 409, .external_lex_state = 5},
  [1029] = {.lex_state = 41, .external_lex_state = 2},
  [1030] = {.lex_state = 41, .external_lex_state = 2},
  [1031] = {.lex_state = 41, .external_lex_state = 2},
  [1032] = {.lex_state = 41, .external_lex_state = 2},
  [1033] = {.lex_state = 41, .external_lex_state = 2},
  [1034] = {.lex_state = 409, .external_lex_state = 5},
  [1035] = {.lex_state = 412, .external_lex_state = 2},
  [1036] = {.lex_state = 41, .external_lex_state = 2},
  [1037] = {.lex_state = 41, .external_lex_state = 2},
  [1038] = {.lex_state = 41, .external_lex_state = 2},
  [1039] = {.lex_state = 41, .external_lex_state = 2},
  [1040] = {.lex_state = 41, .external_lex_state = 2},
  [1041] = {.lex_state = 40, .external_lex_state = 2},
  [1042] = {.lex_state = 41, .external_lex_state = 2},
  [1043] = {.lex_state = 409, .external_lex_state = 2},
  [1044] = {.lex_state = 409, .external_lex_state = 5},
  [1045] = {.lex_state = 411, .external_lex_state = 2},
  [1046] = {.lex_state = 41, .external_lex_state = 2},
  [1047] = {.lex_state = 41, .external_lex_state = 2},
  [1048] = {.lex_state = 41, .external_lex_state = 2},
  [1049] = {.lex_state = 408, .external_lex_state = 2},
  [1050] = {.lex_state = 41, .external_lex_state = 2},
  [1051] = {.lex_state = 41, .external_lex_state = 2},
  [1052] = {.lex_state = 41, .external_lex_state = 2},
  [1053] = {.lex_state = 41, .external_lex_state = 2},
  [1054] = {.lex_state = 41, .external_lex_state = 2},
  [1055] = {.lex_state = 41, .external_lex_state = 2},
  [1056] = {.lex_state = 40, .external_lex_state = 5},
  [1057] = {.lex_state = 409, .external_lex_state = 5},
  [1058] = {.lex_state = 44, .external_lex_state = 2},
  [1059] = {.lex_state = 41, .external_lex_state = 2},
  [1060] = {.lex_state = 41, .external_lex_state = 2},
  [1061] = {.lex_state = 40, .external_lex_state = 5},
  [1062] = {.lex_state = 40, .external_lex_state = 5},
  [1063] = {.lex_state = 40, .external_lex_state = 5},
  [1064] = {.lex_state = 41, .external_lex_state = 2},
  [1065] = {.lex_state = 44, .external_lex_state = 2},
  [1066] = {.lex_state = 41, .external_lex_state = 2},
  [1067] = {.lex_state = 44, .external_lex_state = 2},
  [1068] = {.lex_state = 409, .external_lex_state = 2},
  [1069] = {.lex_state = 41, .external_lex_state = 2},
  [1070] = {.lex_state = 409, .external_lex_state = 5},
  [1071] = {.lex_state = 40, .external_lex_state = 5},
  [1072] = {.lex_state = 409, .external_lex_state = 5},
  [1073] = {.lex_state = 41, .external_lex_state = 2},
  [1074] = {.lex_state = 41, .external_lex_state = 2},
  [1075] = {.lex_state = 409, .external_lex_state = 5},
  [1076] = {.lex_state = 41, .external_lex_state = 2},
  [1077] = {.lex_state = 412, .external_lex_state = 2},
  [1078] = {.lex_state = 41, .external_lex_state = 2},
  [1079] = {.lex_state = 41, .external_lex_state = 2},
  [1080] = {.lex_state = 41, .external_lex_state = 2},
  [1081] = {.lex_state = 41, .external_lex_state = 2},
  [1082] = {.lex_state = 41, .external_lex_state = 2},
  [1083] = {.lex_state = 41, .external_lex_state = 2},
  [1084] = {.lex_state = 44, .external_lex_state = 2},
  [1085] = {.lex_state = 41, .external_lex_state = 2},
  [1086] = {.lex_state = 41, .external_lex_state = 2},
  [1087] = {.lex_state = 41, .external_lex_state = 2},
  [1088] = {.lex_state = 41, .external_lex_state = 2},
  [1089] = {.lex_state = 41, .external_lex_state = 2},
  [1090] = {.lex_state = 409, .external_lex_state = 5},
  [1091] = {.lex_state = 409, .external_lex_state = 5},
  [1092] = {.lex_state = 40, .external_lex_state = 5},
  [1093] = {.lex_state = 41, .external_lex_state = 2},
  [1094] = {.lex_state = 41, .external_lex_state = 2},
  [1095] = {.lex_state = 409, .external_lex_state = 5},
  [1096] = {.lex_state = 41, .external_lex_state = 2},
  [1097] = {.lex_state = 40, .external_lex_state = 5},
  [1098] = {.lex_state = 41, .external_lex_state = 2},
  [1099] = {.lex_state = 41, .external_lex_state = 2},
  [1100] = {.lex_state = 41, .external_lex_state = 2},
  [1101] = {.lex_state = 409, .external_lex_state = 5},
  [1102] = {.lex_state = 41, .external_lex_state = 2},
  [1103] = {.lex_state = 409, .external_lex_state = 5},
  [1104] = {.lex_state = 409, .external_lex_state = 5},
  [1105] = {.lex_state = 41, .external_lex_state = 2},
  [1106] = {.lex_state = 41, .external_lex_state = 2},
  [1107] = {.lex_state = 40, .external_lex_state = 5},
  [1108] = {.lex_state = 41, .external_lex_state = 2},
  [1109] = {.lex_state = 41, .external_lex_state = 2},
  [1110] = {.lex_state = 41, .external_lex_state = 2},
  [1111] = {.lex_state = 409, .external_lex_state = 5},
  [1112] = {.lex_state = 41, .external_lex_state = 2},
  [1113] = {.lex_state = 40, .external_lex_state = 5},
  [1114] = {.lex_state = 41, .external_lex_state = 2},
  [1115] = {.lex_state = 41, .external_lex_state = 2},
  [1116] = {.lex_state = 409, .external_lex_state = 5},
  [1117] = {.lex_state = 41, .external_lex_state = 2},
  [1118] = {.lex_state = 41, .external_lex_state = 2},
  [1119] = {.lex_state = 41, .external_lex_state = 2},
  [1120] = {.lex_state = 409, .external_lex_state = 5},
  [1121] = {.lex_state = 409, .external_lex_state = 5},
  [1122] = {.lex_state = 41, .external_lex_state = 2},
  [1123] = {.lex_state = 41, .external_lex_state = 2},
  [1124] = {.lex_state = 40, .external_lex_state = 5},
  [1125] = {.lex_state = 40, .external_lex_state = 5},
  [1126] = {.lex_state = 41, .external_lex_state = 2},
  [1127] = {.lex_state = 411, .external_lex_state = 2},
  [1128] = {.lex_state = 411, .external_lex_state = 2},
  [1129] = {.lex_state = 41, .external_lex_state = 2},
  [1130] = {.lex_state = 41, .external_lex_state = 2},
  [1131] = {.lex_state = 409, .external_lex_state = 5},
  [1132] = {.lex_state = 40, .external_lex_state = 5},
  [1133] = {.lex_state = 41, .external_lex_state = 2},
  [1134] = {.lex_state = 41, .external_lex_state = 2},
  [1135] = {.lex_state = 41, .external_lex_state = 2},
  [1136] = {.lex_state = 41, .external_lex_state = 2},
  [1137] = {.lex_state = 41, .external_lex_state = 2},
  [1138] = {.lex_state = 41, .external_lex_state = 2},
  [1139] = {.lex_state = 41, .external_lex_state = 2},
  [1140] = {.lex_state = 41, .external_lex_state = 2},
  [1141] = {.lex_state = 41, .external_lex_state = 2},
  [1142] = {.lex_state = 44, .external_lex_state = 2},
  [1143] = {.lex_state = 40, .external_lex_state = 5},
  [1144] = {.lex_state = 41, .external_lex_state = 2},
  [1145] = {.lex_state = 410, .external_lex_state = 2},
  [1146] = {.lex_state = 40, .external_lex_state = 2},
  [1147] = {.lex_state = 41, .external_lex_state = 2},
  [1148] = {.lex_state = 41, .external_lex_state = 2},
  [1149] = {.lex_state = 40, .external_lex_state = 5},
  [1150] = {.lex_state = 41, .external_lex_state = 2},
  [1151] = {.lex_state = 41, .external_lex_state = 2},
  [1152] = {.lex_state = 40, .external_lex_state = 5},
  [1153] = {.lex_state = 40, .external_lex_state = 2},
  [1154] = {.lex_state = 41, .external_lex_state = 2},
  [1155] = {.lex_state = 41, .external_lex_state = 2},
  [1156] = {.lex_state = 40, .external_lex_state = 5},
  [1157] = {.lex_state = 40, .external_lex_state = 5},
  [1158] = {.lex_state = 40, .external_lex_state = 5},
  [1159] = {.lex_state = 409, .external_lex_state = 2},
  [1160] = {.lex_state = 40, .external_lex_state = 2},
  [1161] = {.lex_state = 408, .external_lex_state = 2},
  [1162] = {.lex_state = 409, .external_lex_state = 2},
  [1163] = {.lex_state = 409, .external_lex_state = 2},
  [1164] = {.lex_state = 409, .external_lex_state = 2},
  [1165] = {.lex_state = 40, .external_lex_state = 2},
  [1166] = {.lex_state = 408, .external_lex_state = 5},
  [1167] = {.lex_state = 40, .external_lex_state = 2},
  [1168] = {.lex_state = 408, .external_lex_state = 5},
  [1169] = {.lex_state = 40, .external_lex_state = 2},
  [1170] = {.lex_state = 40, .external_lex_state = 2},
  [1171] = {.lex_state = 408, .external_lex_state = 5},
  [1172] = {.lex_state = 40, .external_lex_state = 2},
  [1173] = {.lex_state = 408, .external_lex_state = 5},
  [1174] = {.lex_state = 409, .external_lex_state = 2},
  [1175] = {.lex_state = 409, .external_lex_state = 2},
  [1176] = {.lex_state = 409, .external_lex_state = 2},
  [1177] = {.lex_state = 410, .external_lex_state = 2},
  [1178] = {.lex_state = 409, .external_lex_state = 2},
  [1179] = {.lex_state = 409, .external_lex_state = 2},
  [1180] = {.lex_state = 40, .external_lex_state = 2},
  [1181] = {.lex_state = 40, .external_lex_state = 2},
  [1182] = {.lex_state = 408, .external_lex_state = 5},
  [1183] = {.lex_state = 40, .external_lex_state = 2},
  [1184] = {.lex_state = 409, .external_lex_state = 2},
  [1185] = {.lex_state = 408, .external_lex_state = 5},
  [1186] = {.lex_state = 408, .external_lex_state = 5},
  [1187] = {.lex_state = 40, .external_lex_state = 2},
  [1188] = {.lex_state = 409, .external_lex_state = 2},
  [1189] = {.lex_state = 409, .external_lex_state = 2},
  [1190] = {.lex_state = 40, .external_lex_state = 2},
  [1191] = {.lex_state = 409, .external_lex_state = 2},
  [1192] = {.lex_state = 40, .external_lex_state = 2},
  [1193] = {.lex_state = 40, .external_lex_state = 2},
  [1194] = {.lex_state = 409, .external_lex_state = 2},
  [1195] = {.lex_state = 408, .external_lex_state = 5},
  [1196] = {.lex_state = 40, .external_lex_state = 2},
  [1197] = {.lex_state = 40, .external_lex_state = 2},
  [1198] = {.lex_state = 409, .external_lex_state = 2},
  [1199] = {.lex_state = 40, .external_lex_state = 2},
  [1200] = {.lex_state = 409, .external_lex_state = 2},
  [1201] = {.lex_state = 409, .external_lex_state = 2},
  [1202] = {.lex_state = 409, .external_lex_state = 2},
  [1203] = {.lex_state = 409, .external_lex_state = 2},
  [1204] = {.lex_state = 408, .external_lex_state = 5},
  [1205] = {.lex_state = 410, .external_lex_state = 2},
  [1206] = {.lex_state = 409, .external_lex_state = 2},
  [1207] = {.lex_state = 40, .external_lex_state = 2},
  [1208] = {.lex_state = 40, .external_lex_state = 2},
  [1209] = {.lex_state = 409, .external_lex_state = 2},
  [1210] = {.lex_state = 409, .external_lex_state = 2},
  [1211] = {.lex_state = 40, .external_lex_state = 2},
  [1212] = {.lex_state = 40, .external_lex_state = 2},
  [1213] = {.lex_state = 40, .external_lex_state = 2},
  [1214] = {.lex_state = 40, .external_lex_state = 2},
  [1215] = {.lex_state = 409, .external_lex_state = 2},
  [1216] = {.lex_state = 408, .external_lex_state = 5},
  [1217] = {.lex_state = 409, .external_lex_state = 2},
  [1218] = {.lex_state = 40, .external_lex_state = 2},
  [1219] = {.lex_state = 40, .external_lex_state = 2},
  [1220] = {.lex_state = 40, .external_lex_state = 2},
  [1221] = {.lex_state = 40, .external_lex_state = 2},
  [1222] = {.lex_state = 40, .external_lex_state = 2},
  [1223] = {.lex_state = 408, .external_lex_state = 5},
  [1224] = {.lex_state = 409, .external_lex_state = 2},
  [1225] = {.lex_state = 409, .external_lex_state = 2},
  [1226] = {.lex_state = 409, .external_lex_state = 2},
  [1227] = {.lex_state = 409, .external_lex_state = 2},
  [1228] = {.lex_state = 40, .external_lex_state = 2},
  [1229] = {.lex_state = 40, .external_lex_state = 2},
  [1230] = {.lex_state = 409, .external_lex_state = 2},
  [1231] = {.lex_state = 40, .external_lex_state = 2},
  [1232] = {.lex_state = 40, .external_lex_state = 2},
  [1233] = {.lex_state = 409, .external_lex_state = 2},
  [1234] = {.lex_state = 409, .external_lex_state = 2},
  [1235] = {.lex_state = 40, .external_lex_state = 2},
  [1236] = {.lex_state = 40, .external_lex_state = 2},
  [1237] = {.lex_state = 409, .external_lex_state = 2},
  [1238] = {.lex_state = 40, .external_lex_state = 2},
  [1239] = {.lex_state = 410, .external_lex_state = 2},
  [1240] = {.lex_state = 40, .external_lex_state = 2},
  [1241] = {.lex_state = 40, .external_lex_state = 2},
  [1242] = {.lex_state = 409, .external_lex_state = 2},
  [1243] = {.lex_state = 40, .external_lex_state = 2},
  [1244] = {.lex_state = 40, .external_lex_state = 2},
  [1245] = {.lex_state = 40, .external_lex_state = 2},
  [1246] = {.lex_state = 40, .external_lex_state = 2},
  [1247] = {.lex_state = 409, .external_lex_state = 2},
  [1248] = {.lex_state = 40, .external_lex_state = 2},
  [1249] = {.lex_state = 40, .external_lex_state = 2},
  [1250] = {.lex_state = 40, .external_lex_state = 2},
  [1251] = {.lex_state = 40, .external_lex_state = 2},
  [1252] = {.lex_state = 410, .external_lex_state = 2},
  [1253] = {.lex_state = 409, .external_lex_state = 2},
  [1254] = {.lex_state = 409, .external_lex_state = 2},
  [1255] = {.lex_state = 409, .external_lex_state = 2},
  [1256] = {.lex_state = 40, .external_lex_state = 2},
  [1257] = {.lex_state = 409, .external_lex_state = 2},
  [1258] = {.lex_state = 40, .external_lex_state = 2},
  [1259] = {.lex_state = 40, .external_lex_state = 2},
  [1260] = {.lex_state = 40, .external_lex_state = 2},
  [1261] = {.lex_state = 40, .external_lex_state = 2},
  [1262] = {.lex_state = 40, .external_lex_state = 2},
  [1263] = {.lex_state = 40, .external_lex_state = 2},
  [1264] = {.lex_state = 40, .external_lex_state = 2},
  [1265] = {.lex_state = 40, .external_lex_state = 2},
  [1266] = {.lex_state = 40, .external_lex_state = 2},
  [1267] = {.lex_state = 40, .external_lex_state = 2},
  [1268] = {.lex_state = 409, .external_lex_state = 2},
  [1269] = {.lex_state = 40, .external_lex_state = 2},
  [1270] = {.lex_state = 409, .external_lex_state = 2},
  [1271] = {.lex_state = 40, .external_lex_state = 2},
  [1272] = {.lex_state = 409, .external_lex_state = 2},
  [1273] = {.lex_state = 409, .external_lex_state = 2},
  [1274] = {.lex_state = 40, .external_lex_state = 2},
  [1275] = {.lex_state = 409, .external_lex_state = 2},
  [1276] = {.lex_state = 408, .external_lex_state = 5},
  [1277] = {.lex_state = 409, .external_lex_state = 2},
  [1278] = {.lex_state = 40, .external_lex_state = 2},
  [1279] = {.lex_state = 40, .external_lex_state = 2},
  [1280] = {.lex_state = 40, .external_lex_state = 2},
  [1281] = {.lex_state = 40, .external_lex_state = 2},
  [1282] = {.lex_state = 40, .external_lex_state = 2},
  [1283] = {.lex_state = 409, .external_lex_state = 2},
  [1284] = {.lex_state = 40, .external_lex_state = 2},
  [1285] = {.lex_state = 409, .external_lex_state = 2},
  [1286] = {.lex_state = 409, .external_lex_state = 2},
  [1287] = {.lex_state = 40, .external_lex_state = 2},
  [1288] = {.lex_state = 40, .external_lex_state = 2},
  [1289] = {.lex_state = 409, .external_lex_state = 2},
  [1290] = {.lex_state = 409, .external_lex_state = 2},
  [1291] = {.lex_state = 40, .external_lex_state = 2},
  [1292] = {.lex_state = 40, .external_lex_state = 2},
  [1293] = {.lex_state = 40, .external_lex_state = 2},
  [1294] = {.lex_state = 409, .external_lex_state = 2},
  [1295] = {.lex_state = 409, .external_lex_state = 2},
  [1296] = {.lex_state = 40, .external_lex_state = 2},
  [1297] = {.lex_state = 40, .external_lex_state = 2},
  [1298] = {.lex_state = 409, .external_lex_state = 2},
  [1299] = {.lex_state = 40, .external_lex_state = 2},
  [1300] = {.lex_state = 40, .external_lex_state = 2},
  [1301] = {.lex_state = 409, .external_lex_state = 2},
  [1302] = {.lex_state = 409, .external_lex_state = 2},
  [1303] = {.lex_state = 40, .external_lex_state = 2},
  [1304] = {.lex_state = 409, .external_lex_state = 2},
  [1305] = {.lex_state = 40, .external_lex_state = 2},
  [1306] = {.lex_state = 409, .external_lex_state = 2},
  [1307] = {.lex_state = 409, .external_lex_state = 2},
  [1308] = {.lex_state = 408, .external_lex_state = 5},
  [1309] = {.lex_state = 409, .external_lex_state = 2},
  [1310] = {.lex_state = 409, .external_lex_state = 2},
  [1311] = {.lex_state = 40, .external_lex_state = 2},
  [1312] = {.lex_state = 40, .external_lex_state = 2},
  [1313] = {.lex_state = 40, .external_lex_state = 2},
  [1314] = {.lex_state = 409, .external_lex_state = 2},
  [1315] = {.lex_state = 409, .external_lex_state = 2},
  [1316] = {.lex_state = 40, .external_lex_state = 2},
  [1317] = {.lex_state = 40, .external_lex_state = 2},
  [1318] = {.lex_state = 40, .external_lex_state = 2},
  [1319] = {.lex_state = 408, .external_lex_state = 5},
  [1320] = {.lex_state = 40, .external_lex_state = 2},
  [1321] = {.lex_state = 40, .external_lex_state = 2},
  [1322] = {.lex_state = 409, .external_lex_state = 2},
  [1323] = {.lex_state = 40, .external_lex_state = 2},
  [1324] = {.lex_state = 40, .external_lex_state = 2},
  [1325] = {.lex_state = 40, .external_lex_state = 2},
  [1326] = {.lex_state = 40, .external_lex_state = 2},
  [1327] = {.lex_state = 40, .external_lex_state = 2},
  [1328] = {.lex_state = 409, .external_lex_state = 2},
  [1329] = {.lex_state = 409, .external_lex_state = 2},
  [1330] = {.lex_state = 410, .external_lex_state = 2},
  [1331] = {.lex_state = 409, .external_lex_state = 2},
  [1332] = {.lex_state = 409, .external_lex_state = 2},
  [1333] = {.lex_state = 40, .external_lex_state = 2},
  [1334] = {.lex_state = 40, .external_lex_state = 2},
  [1335] = {.lex_state = 40, .external_lex_state = 2},
  [1336] = {.lex_state = 40, .external_lex_state = 2},
  [1337] = {.lex_state = 40, .external_lex_state = 2},
  [1338] = {.lex_state = 409, .external_lex_state = 2},
  [1339] = {.lex_state = 408, .external_lex_state = 5},
  [1340] = {.lex_state = 409, .external_lex_state = 2},
  [1341] = {.lex_state = 40, .external_lex_state = 2},
  [1342] = {.lex_state = 40, .external_lex_state = 2},
  [1343] = {.lex_state = 40, .external_lex_state = 2},
  [1344] = {.lex_state = 409, .external_lex_state = 2},
  [1345] = {.lex_state = 409, .external_lex_state = 2},
  [1346] = {.lex_state = 40, .external_lex_state = 2},
  [1347] = {.lex_state = 40, .external_lex_state = 2},
  [1348] = {.lex_state = 40, .external_lex_state = 2},
  [1349] = {.lex_state = 409, .external_lex_state = 2},
  [1350] = {.lex_state = 40, .external_lex_state = 2},
  [1351] = {.lex_state = 409, .external_lex_state = 2},
  [1352] = {.lex_state = 409, .external_lex_state = 2},
  [1353] = {.lex_state = 409, .external_lex_state = 2},
  [1354] = {.lex_state = 409, .external_lex_state = 2},
  [1355] = {.lex_state = 408, .external_lex_state = 2},
  [1356] = {.lex_state = 40, .external_lex_state = 2},
  [1357] = {.lex_state = 409, .external_lex_state = 2},
  [1358] = {.lex_state = 409, .external_lex_state = 2},
  [1359] = {.lex_state = 40, .external_lex_state = 2},
  [1360] = {.lex_state = 409, .external_lex_state = 2},
  [1361] = {.lex_state = 408, .external_lex_state = 5},
  [1362] = {.lex_state = 409, .external_lex_state = 2},
  [1363] = {.lex_state = 408, .external_lex_state = 2},
  [1364] = {.lex_state = 409, .external_lex_state = 2},
  [1365] = {.lex_state = 409, .external_lex_state = 2},
  [1366] = {.lex_state = 409, .external_lex_state = 2},
  [1367] = {.lex_state = 409, .external_lex_state = 2},
  [1368] = {.lex_state = 409, .external_lex_state = 2},
  [1369] = {.lex_state = 40, .external_lex_state = 2},
  [1370] = {.lex_state = 40, .external_lex_state = 2},
  [1371] = {.lex_state = 40, .external_lex_state = 2},
  [1372] = {.lex_state = 409, .external_lex_state = 2},
  [1373] = {.lex_state = 40, .external_lex_state = 2},
  [1374] = {.lex_state = 408, .external_lex_state = 5},
  [1375] = {.lex_state = 40, .external_lex_state = 2},
  [1376] = {.lex_state = 408, .external_lex_state = 5},
  [1377] = {.lex_state = 40, .external_lex_state = 2},
  [1378] = {.lex_state = 408, .external_lex_state = 5},
  [1379] = {.lex_state = 40, .external_lex_state = 2},
  [1380] = {.lex_state = 408, .external_lex_state = 5},
  [1381] = {.lex_state = 40, .external_lex_state = 2},
  [1382] = {.lex_state = 409, .external_lex_state = 2},
  [1383] = {.lex_state = 409, .external_lex_state = 2},
  [1384] = {.lex_state = 40, .external_lex_state = 2},
  [1385] = {.lex_state = 409, .external_lex_state = 2},
  [1386] = {.lex_state = 408, .external_lex_state = 5},
  [1387] = {.lex_state = 408, .external_lex_state = 5},
  [1388] = {.lex_state = 409, .external_lex_state = 2},
  [1389] = {.lex_state = 409, .external_lex_state = 2},
  [1390] = {.lex_state = 409, .external_lex_state = 2},
  [1391] = {.lex_state = 409, .external_lex_state = 2},
  [1392] = {.lex_state = 409, .external_lex_state = 2},
  [1393] = {.lex_state = 40, .external_lex_state = 2},
  [1394] = {.lex_state = 40, .external_lex_state = 2},
  [1395] = {.lex_state = 40, .external_lex_state = 2},
  [1396] = {.lex_state = 409, .external_lex_state = 2},
  [1397] = {.lex_state = 40, .external_lex_state = 2},
  [1398] = {.lex_state = 409, .external_lex_state = 2},
  [1399] = {.lex_state = 409, .external_lex_state = 2},
  [1400] = {.lex_state = 409, .external_lex_state = 2},
  [1401] = {.lex_state = 409, .external_lex_state = 2},
  [1402] = {.lex_state = 409, .external_lex_state = 2},
  [1403] = {.lex_state = 40, .external_lex_state = 2},
  [1404] = {.lex_state = 408, .external_lex_state = 5},
  [1405] = {.lex_state = 40, .external_lex_state = 2},
  [1406] = {.lex_state = 409, .external_lex_state = 2},
  [1407] = {.lex_state = 409, .external_lex_state = 2},
  [1408] = {.lex_state = 409, .external_lex_state = 2},
  [1409] = {.lex_state = 409, .external_lex_state = 2},
  [1410] = {.lex_state = 409, .external_lex_state = 2},
  [1411] = {.lex_state = 409, .external_lex_state = 2},
  [1412] = {.lex_state = 409, .external_lex_state = 2},
  [1413] = {.lex_state = 409, .external_lex_state = 2},
  [1414] = {.lex_state = 40, .external_lex_state = 2},
  [1415] = {.lex_state = 409, .external_lex_state = 2},
  [1416] = {.lex_state = 409, .external_lex_state = 2},
  [1417] = {.lex_state = 409, .external_lex_state = 2},
  [1418] = {.lex_state = 409, .external_lex_state = 2},
  [1419] = {.lex_state = 40, .external_lex_state = 2},
  [1420] = {.lex_state = 409, .external_lex_state = 2},
  [1421] = {.lex_state = 409, .external_lex_state = 2},
  [1422] = {.lex_state = 40, .external_lex_state = 2},
  [1423] = {.lex_state = 40, .external_lex_state = 2},
  [1424] = {.lex_state = 409, .external_lex_state = 2},
  [1425] = {.lex_state = 40, .external_lex_state = 2},
  [1426] = {.lex_state = 40, .external_lex_state = 2},
  [1427] = {.lex_state = 409, .external_lex_state = 2},
  [1428] = {.lex_state = 409, .external_lex_state = 2},
  [1429] = {.lex_state = 409, .external_lex_state = 2},
  [1430] = {.lex_state = 40, .external_lex_state = 2},
  [1431] = {.lex_state = 40, .external_lex_state = 2},
  [1432] = {.lex_state = 409, .external_lex_state = 2},
  [1433] = {.lex_state = 40, .external_lex_state = 2},
  [1434] = {.lex_state = 409, .external_lex_state = 2},
  [1435] = {.lex_state = 409, .external_lex_state = 2},
  [1436] = {.lex_state = 40, .external_lex_state = 2},
  [1437] = {.lex_state = 409, .external_lex_state = 2},
  [1438] = {.lex_state = 409, .external_lex_state = 2},
  [1439] = {.lex_state = 409, .external_lex_state = 2},
  [1440] = {.lex_state = 409, .external_lex_state = 2},
  [1441] = {.lex_state = 40, .external_lex_state = 2},
  [1442] = {.lex_state = 409, .external_lex_state = 2},
  [1443] = {.lex_state = 409, .external_lex_state = 2},
  [1444] = {.lex_state = 409, .external_lex_state = 2},
  [1445] = {.lex_state = 408, .external_lex_state = 2},
  [1446] = {.lex_state = 408, .external_lex_state = 2},
  [1447] = {.lex_state = 408, .external_lex_state = 2},
  [1448] = {.lex_state = 408, .external_lex_state = 2},
  [1449] = {.lex_state = 408, .external_lex_state = 2},
  [1450] = {.lex_state = 408, .external_lex_state = 2},
  [1451] = {.lex_state = 408, .external_lex_state = 2},
  [1452] = {.lex_state = 408, .external_lex_state = 2},
  [1453] = {.lex_state = 408, .external_lex_state = 2},
  [1454] = {.lex_state = 408, .external_lex_state = 2},
  [1455] = {.lex_state = 408, .external_lex_state = 2},
  [1456] = {.lex_state = 408, .external_lex_state = 2},
  [1457] = {.lex_state = 408, .external_lex_state = 2},
  [1458] = {.lex_state = 408, .external_lex_state = 2},
  [1459] = {.lex_state = 408, .external_lex_state = 2},
  [1460] = {.lex_state = 408, .external_lex_state = 2},
  [1461] = {.lex_state = 408, .external_lex_state = 2},
  [1462] = {.lex_state = 408, .external_lex_state = 2},
  [1463] = {.lex_state = 408, .external_lex_state = 2},
  [1464] = {.lex_state = 408, .external_lex_state = 2},
  [1465] = {.lex_state = 408, .external_lex_state = 2},
  [1466] = {.lex_state = 408, .external_lex_state = 2},
  [1467] = {.lex_state = 408, .external_lex_state = 2},
  [1468] = {.lex_state = 408, .external_lex_state = 2},
  [1469] = {.lex_state = 408, .external_lex_state = 2},
  [1470] = {.lex_state = 408, .external_lex_state = 2},
  [1471] = {.lex_state = 408, .external_lex_state = 2},
  [1472] = {.lex_state = 408, .external_lex_state = 2},
  [1473] = {.lex_state = 408, .external_lex_state = 2},
  [1474] = {.lex_state = 408, .external_lex_state = 2},
  [1475] = {.lex_state = 408, .external_lex_state = 2},
  [1476] = {.lex_state = 408, .external_lex_state = 2},
  [1477] = {.lex_state = 408, .external_lex_state = 2},
  [1478] = {.lex_state = 408, .external_lex_state = 2},
  [1479] = {.lex_state = 408, .external_lex_state = 2},
  [1480] = {.lex_state = 408, .external_lex_state = 2},
  [1481] = {.lex_state = 408, .external_lex_state = 2},
  [1482] = {.lex_state = 408, .external_lex_state = 2},
  [1483] = {.lex_state = 408, .external_lex_state = 2},
  [1484] = {.lex_state = 408, .external_lex_state = 2},
  [1485] = {.lex_state = 408, .external_lex_state = 2},
  [1486] = {.lex_state = 408, .external_lex_state = 2},
  [1487] = {.lex_state = 408, .external_lex_state = 2},
  [1488] = {.lex_state = 408, .external_lex_state = 2},
  [1489] = {.lex_state = 408, .external_lex_state = 2},
  [1490] = {.lex_state = 408, .external_lex_state = 2},
  [1491] = {.lex_state = 408, .external_lex_state = 2},
  [1492] = {.lex_state = 408, .external_lex_state = 2},
  [1493] = {.lex_state = 408, .external_lex_state = 2},
  [1494] = {.lex_state = 408, .external_lex_state = 2},
  [1495] = {.lex_state = 408, .external_lex_state = 2},
  [1496] = {.lex_state = 408, .external_lex_state = 2},
  [1497] = {.lex_state = 408, .external_lex_state = 2},
  [1498] = {.lex_state = 408, .external_lex_state = 2},
  [1499] = {.lex_state = 408, .external_lex_state = 2},
  [1500] = {.lex_state = 408, .external_lex_state = 2},
  [1501] = {.lex_state = 408, .external_lex_state = 2},
  [1502] = {.lex_state = 408, .external_lex_state = 2},
  [1503] = {.lex_state = 408, .external_lex_state = 2},
  [1504] = {.lex_state = 408, .external_lex_state = 2},
  [1505] = {.lex_state = 408, .external_lex_state = 2},
  [1506] = {.lex_state = 408, .external_lex_state = 2},
  [1507] = {.lex_state = 408, .external_lex_state = 2},
  [1508] = {.lex_state = 408, .external_lex_state = 2},
  [1509] = {.lex_state = 408, .external_lex_state = 2},
  [1510] = {.lex_state = 408, .external_lex_state = 2},
  [1511] = {.lex_state = 408, .external_lex_state = 2},
  [1512] = {.lex_state = 408, .external_lex_state = 2},
  [1513] = {.lex_state = 408, .external_lex_state = 2},
  [1514] = {.lex_state = 408, .external_lex_state = 2},
  [1515] = {.lex_state = 408, .external_lex_state = 2},
  [1516] = {.lex_state = 408, .external_lex_state = 2},
  [1517] = {.lex_state = 408, .external_lex_state = 2},
  [1518] = {.lex_state = 408, .external_lex_state = 2},
  [1519] = {.lex_state = 408, .external_lex_state = 2},
  [1520] = {.lex_state = 408, .external_lex_state = 2},
  [1521] = {.lex_state = 408, .external_lex_state = 2},
  [1522] = {.lex_state = 408, .external_lex_state = 2},
  [1523] = {.lex_state = 408, .external_lex_state = 2},
  [1524] = {.lex_state = 408, .external_lex_state = 2},
  [1525] = {.lex_state = 408, .external_lex_state = 2},
  [1526] = {.lex_state = 408, .external_lex_state = 2},
  [1527] = {.lex_state = 408, .external_lex_state = 2},
  [1528] = {.lex_state = 408, .external_lex_state = 2},
  [1529] = {.lex_state = 408, .external_lex_state = 2},
  [1530] = {.lex_state = 408, .external_lex_state = 2},
  [1531] = {.lex_state = 408, .external_lex_state = 2},
  [1532] = {.lex_state = 408, .external_lex_state = 2},
  [1533] = {.lex_state = 408, .external_lex_state = 2},
  [1534] = {.lex_state = 408, .external_lex_state = 2},
  [1535] = {.lex_state = 408, .external_lex_state = 2},
  [1536] = {.lex_state = 408, .external_lex_state = 2},
  [1537] = {.lex_state = 408, .external_lex_state = 2},
  [1538] = {.lex_state = 408, .external_lex_state = 2},
  [1539] = {.lex_state = 408, .external_lex_state = 2},
  [1540] = {.lex_state = 408, .external_lex_state = 2},
  [1541] = {.lex_state = 408, .external_lex_state = 2},
  [1542] = {.lex_state = 408, .external_lex_state = 2},
  [1543] = {.lex_state = 408, .external_lex_state = 2},
  [1544] = {.lex_state = 408, .external_lex_state = 2},
  [1545] = {.lex_state = 408, .external_lex_state = 2},
  [1546] = {.lex_state = 408, .external_lex_state = 2},
  [1547] = {.lex_state = 408, .external_lex_state = 2},
  [1548] = {.lex_state = 408, .external_lex_state = 2},
  [1549] = {.lex_state = 408, .external_lex_state = 2},
  [1550] = {.lex_state = 408, .external_lex_state = 2},
  [1551] = {.lex_state = 408, .external_lex_state = 2},
  [1552] = {.lex_state = 408, .external_lex_state = 2},
  [1553] = {.lex_state = 408, .external_lex_state = 2},
  [1554] = {.lex_state = 408, .external_lex_state = 2},
  [1555] = {.lex_state = 408, .external_lex_state = 2},
  [1556] = {.lex_state = 408, .external_lex_state = 2},
  [1557] = {.lex_state = 408, .external_lex_state = 2},
  [1558] = {.lex_state = 408, .external_lex_state = 2},
  [1559] = {.lex_state = 408, .external_lex_state = 2},
  [1560] = {.lex_state = 408, .external_lex_state = 2},
  [1561] = {.lex_state = 408, .external_lex_state = 2},
  [1562] = {.lex_state = 408, .external_lex_state = 2},
  [1563] = {.lex_state = 408, .external_lex_state = 2},
  [1564] = {.lex_state = 408, .external_lex_state = 2},
  [1565] = {.lex_state = 408, .external_lex_state = 2},
  [1566] = {.lex_state = 408, .external_lex_state = 2},
  [1567] = {.lex_state = 408, .external_lex_state = 2},
  [1568] = {.lex_state = 408, .external_lex_state = 2},
  [1569] = {.lex_state = 408, .external_lex_state = 2},
  [1570] = {.lex_state = 408, .external_lex_state = 2},
  [1571] = {.lex_state = 408, .external_lex_state = 2},
  [1572] = {.lex_state = 408, .external_lex_state = 2},
  [1573] = {.lex_state = 51, .external_lex_state = 2},
  [1574] = {.lex_state = 51, .external_lex_state = 2},
  [1575] = {.lex_state = 51, .external_lex_state = 2},
  [1576] = {.lex_state = 51, .external_lex_state = 2},
  [1577] = {.lex_state = 51, .external_lex_state = 2},
  [1578] = {.lex_state = 51, .external_lex_state = 2},
  [1579] = {.lex_state = 51, .external_lex_state = 2},
  [1580] = {.lex_state = 408, .external_lex_state = 2},
  [1581] = {.lex_state = 408, .external_lex_state = 2},
  [1582] = {.lex_state = 408, .external_lex_state = 2},
  [1583] = {.lex_state = 51, .external_lex_state = 2},
  [1584] = {.lex_state = 408, .external_lex_state = 2},
  [1585] = {.lex_state = 408, .external_lex_state = 2},
  [1586] = {.lex_state = 408, .external_lex_state = 2},
  [1587] = {.lex_state = 51, .external_lex_state = 2},
  [1588] = {.lex_state = 408, .external_lex_state = 2},
  [1589] = {.lex_state = 51, .external_lex_state = 2},
  [1590] = {.lex_state = 51, .external_lex_state = 2},
  [1591] = {.lex_state = 408, .external_lex_state = 2},
  [1592] = {.lex_state = 408, .external_lex_state = 2},
  [1593] = {.lex_state = 408, .external_lex_state = 2},
  [1594] = {.lex_state = 51, .external_lex_state = 2},
  [1595] = {.lex_state = 408, .external_lex_state = 2},
  [1596] = {.lex_state = 51, .external_lex_state = 2},
  [1597] = {.lex_state = 408, .external_lex_state = 2},
  [1598] = {.lex_state = 51, .external_lex_state = 2},
  [1599] = {.lex_state = 51, .external_lex_state = 2},
  [1600] = {.lex_state = 408, .external_lex_state = 2},
  [1601] = {.lex_state = 52, .external_lex_state = 2},
  [1602] = {.lex_state = 52, .external_lex_state = 2},
  [1603] = {.lex_state = 51, .external_lex_state = 2},
  [1604] = {.lex_state = 52, .external_lex_state = 2},
  [1605] = {.lex_state = 52, .external_lex_state = 2},
  [1606] = {.lex_state = 52, .external_lex_state = 2},
  [1607] = {.lex_state = 52, .external_lex_state = 2},
  [1608] = {.lex_state = 52, .external_lex_state = 2},
  [1609] = {.lex_state = 52, .external_lex_state = 2},
  [1610] = {.lex_state = 52, .external_lex_state = 2},
  [1611] = {.lex_state = 52, .external_lex_state = 2},
  [1612] = {.lex_state = 52, .external_lex_state = 2},
  [1613] = {.lex_state = 52, .external_lex_state = 2},
  [1614] = {.lex_state = 52, .external_lex_state = 2},
  [1615] = {.lex_state = 52, .external_lex_state = 2},
  [1616] = {.lex_state = 52, .external_lex_state = 2},
  [1617] = {.lex_state = 52, .external_lex_state = 2},
  [1618] = {.lex_state = 52, .external_lex_state = 2},
  [1619] = {.lex_state = 52, .external_lex_state = 2},
  [1620] = {.lex_state = 52, .external_lex_state = 2},
  [1621] = {.lex_state = 52, .external_lex_state = 2},
  [1622] = {.lex_state = 52, .external_lex_state = 2},
  [1623] = {.lex_state = 52, .external_lex_state = 2},
  [1624] = {.lex_state = 52, .external_lex_state = 2},
  [1625] = {.lex_state = 52, .external_lex_state = 2},
  [1626] = {.lex_state = 52, .external_lex_state = 2},
  [1627] = {.lex_state = 52, .external_lex_state = 2},
  [1628] = {.lex_state = 52, .external_lex_state = 2},
  [1629] = {.lex_state = 52, .external_lex_state = 2},
  [1630] = {.lex_state = 52, .external_lex_state = 2},
  [1631] = {.lex_state = 52, .external_lex_state = 2},
  [1632] = {.lex_state = 52, .external_lex_state = 2},
  [1633] = {.lex_state = 52, .external_lex_state = 2},
  [1634] = {.lex_state = 52, .external_lex_state = 2},
  [1635] = {.lex_state = 52, .external_lex_state = 2},
  [1636] = {.lex_state = 52, .external_lex_state = 2},
  [1637] = {.lex_state = 52, .external_lex_state = 2},
  [1638] = {.lex_state = 52, .external_lex_state = 2},
  [1639] = {.lex_state = 52, .external_lex_state = 2},
  [1640] = {.lex_state = 52, .external_lex_state = 2},
  [1641] = {.lex_state = 52, .external_lex_state = 2},
  [1642] = {.lex_state = 52, .external_lex_state = 2},
  [1643] = {.lex_state = 52, .external_lex_state = 2},
  [1644] = {.lex_state = 52, .external_lex_state = 2},
  [1645] = {.lex_state = 52, .external_lex_state = 2},
  [1646] = {.lex_state = 52, .external_lex_state = 2},
  [1647] = {.lex_state = 52, .external_lex_state = 2},
  [1648] = {.lex_state = 52, .external_lex_state = 2},
  [1649] = {.lex_state = 52, .external_lex_state = 2},
  [1650] = {.lex_state = 52, .external_lex_state = 2},
  [1651] = {.lex_state = 52, .external_lex_state = 2},
  [1652] = {.lex_state = 52, .external_lex_state = 2},
  [1653] = {.lex_state = 52, .external_lex_state = 2},
  [1654] = {.lex_state = 52, .external_lex_state = 2},
  [1655] = {.lex_state = 52, .external_lex_state = 2},
  [1656] = {.lex_state = 52, .external_lex_state = 2},
  [1657] = {.lex_state = 51, .external_lex_state = 2},
  [1658] = {.lex_state = 51, .external_lex_state = 2},
  [1659] = {.lex_state = 51, .external_lex_state = 2},
  [1660] = {.lex_state = 51, .external_lex_state = 2},
  [1661] = {.lex_state = 51, .external_lex_state = 2},
  [1662] = {.lex_state = 51, .external_lex_state = 2},
  [1663] = {.lex_state = 51, .external_lex_state = 2},
  [1664] = {.lex_state = 51, .external_lex_state = 2},
  [1665] = {.lex_state = 51, .external_lex_state = 2},
  [1666] = {.lex_state = 51, .external_lex_state = 2},
  [1667] = {.lex_state = 38, .external_lex_state = 2},
  [1668] = {.lex_state = 38, .external_lex_state = 2},
  [1669] = {.lex_state = 38, .external_lex_state = 2},
  [1670] = {.lex_state = 38, .external_lex_state = 2},
  [1671] = {.lex_state = 38, .external_lex_state = 2},
  [1672] = {.lex_state = 38, .external_lex_state = 2},
  [1673] = {.lex_state = 38, .external_lex_state = 2},
  [1674] = {.lex_state = 38, .external_lex_state = 2},
  [1675] = {.lex_state = 38, .external_lex_state = 2},
  [1676] = {.lex_state = 38, .external_lex_state = 2},
  [1677] = {.lex_state = 38, .external_lex_state = 2},
  [1678] = {.lex_state = 38, .external_lex_state = 2},
  [1679] = {.lex_state = 51, .external_lex_state = 2},
  [1680] = {.lex_state = 18, .external_lex_state = 4},
  [1681] = {.lex_state = 51, .external_lex_state = 2},
  [1682] = {.lex_state = 18, .external_lex_state = 4},
  [1683] = {.lex_state = 51, .external_lex_state = 2},
  [1684] = {.lex_state = 18, .external_lex_state = 4},
  [1685] = {.lex_state = 18, .external_lex_state = 4},
  [1686] = {.lex_state = 51, .external_lex_state = 2},
  [1687] = {.lex_state = 18, .external_lex_state = 4},
  [1688] = {.lex_state = 18, .external_lex_state = 4},
  [1689] = {.lex_state = 18, .external_lex_state = 4},
  [1690] = {.lex_state = 53, .external_lex_state = 2},
  [1691] = {.lex_state = 51, .external_lex_state = 2},
  [1692] = {.lex_state = 18, .external_lex_state = 4},
  [1693] = {.lex_state = 18, .external_lex_state = 4},
  [1694] = {.lex_state = 51, .external_lex_state = 2},
  [1695] = {.lex_state = 51, .external_lex_state = 2},
  [1696] = {.lex_state = 51, .external_lex_state = 2},
  [1697] = {.lex_state = 51, .external_lex_state = 2},
  [1698] = {.lex_state = 51, .external_lex_state = 2},
  [1699] = {.lex_state = 51, .external_lex_state = 2},
  [1700] = {.lex_state = 51, .external_lex_state = 2},
  [1701] = {.lex_state = 51, .external_lex_state = 2},
  [1702] = {.lex_state = 51, .external_lex_state = 2},
  [1703] = {.lex_state = 51, .external_lex_state = 2},
  [1704] = {.lex_state = 51, .external_lex_state = 2},
  [1705] = {.lex_state = 51, .external_lex_state = 2},
  [1706] = {.lex_state = 51, .external_lex_state = 2},
  [1707] = {.lex_state = 51, .external_lex_state = 2},
  [1708] = {.lex_state = 51, .external_lex_state = 2},
  [1709] = {.lex_state = 51, .external_lex_state = 2},
  [1710] = {.lex_state = 51, .external_lex_state = 2},
  [1711] = {.lex_state = 51, .external_lex_state = 2},
  [1712] = {.lex_state = 51, .external_lex_state = 2},
  [1713] = {.lex_state = 51, .external_lex_state = 2},
  [1714] = {.lex_state = 51, .external_lex_state = 2},
  [1715] = {.lex_state = 51, .external_lex_state = 2},
  [1716] = {.lex_state = 51, .external_lex_state = 2},
  [1717] = {.lex_state = 51, .external_lex_state = 2},
  [1718] = {.lex_state = 51, .external_lex_state = 2},
  [1719] = {.lex_state = 51, .external_lex_state = 2},
  [1720] = {.lex_state = 51, .external_lex_state = 2},
  [1721] = {.lex_state = 51, .external_lex_state = 2},
  [1722] = {.lex_state = 51, .external_lex_state = 2},
  [1723] = {.lex_state = 51, .external_lex_state = 2},
  [1724] = {.lex_state = 51, .external_lex_state = 2},
  [1725] = {.lex_state = 51, .external_lex_state = 2},
  [1726] = {.lex_state = 51, .external_lex_state = 2},
  [1727] = {.lex_state = 51, .external_lex_state = 2},
  [1728] = {.lex_state = 51, .external_lex_state = 2},
  [1729] = {.lex_state = 51, .external_lex_state = 2},
  [1730] = {.lex_state = 51, .external_lex_state = 2},
  [1731] = {.lex_state = 51, .external_lex_state = 2},
  [1732] = {.lex_state = 51, .external_lex_state = 2},
  [1733] = {.lex_state = 51, .external_lex_state = 2},
  [1734] = {.lex_state = 51, .external_lex_state = 2},
  [1735] = {.lex_state = 51, .external_lex_state = 2},
  [1736] = {.lex_state = 51, .external_lex_state = 2},
  [1737] = {.lex_state = 51, .external_lex_state = 2},
  [1738] = {.lex_state = 51, .external_lex_state = 2},
  [1739] = {.lex_state = 51, .external_lex_state = 2},
  [1740] = {.lex_state = 51, .external_lex_state = 2},
  [1741] = {.lex_state = 51, .external_lex_state = 2},
  [1742] = {.lex_state = 51, .external_lex_state = 2},
  [1743] = {.lex_state = 51, .external_lex_state = 2},
  [1744] = {.lex_state = 51, .external_lex_state = 2},
  [1745] = {.lex_state = 51, .external_lex_state = 2},
  [1746] = {.lex_state = 51, .external_lex_state = 2},
  [1747] = {.lex_state = 51, .external_lex_state = 2},
  [1748] = {.lex_state = 51, .external_lex_state = 2},
  [1749] = {.lex_state = 51, .external_lex_state = 2},
  [1750] = {.lex_state = 51, .external_lex_state = 2},
  [1751] = {.lex_state = 51, .external_lex_state = 2},
  [1752] = {.lex_state = 51, .external_lex_state = 2},
  [1753] = {.lex_state = 51, .external_lex_state = 2},
  [1754] = {.lex_state = 51, .external_lex_state = 2},
  [1755] = {.lex_state = 51, .external_lex_state = 2},
  [1756] = {.lex_state = 51, .external_lex_state = 2},
  [1757] = {.lex_state = 51, .external_lex_state = 2},
  [1758] = {.lex_state = 51, .external_lex_state = 2},
  [1759] = {.lex_state = 51, .external_lex_state = 2},
  [1760] = {.lex_state = 51, .external_lex_state = 2},
  [1761] = {.lex_state = 51, .external_lex_state = 2},
  [1762] = {.lex_state = 51, .external_lex_state = 2},
  [1763] = {.lex_state = 51, .external_lex_state = 2},
  [1764] = {.lex_state = 51, .external_lex_state = 2},
  [1765] = {.lex_state = 51, .external_lex_state = 2},
  [1766] = {.lex_state = 51, .external_lex_state = 2},
  [1767] = {.lex_state = 51, .external_lex_state = 2},
  [1768] = {.lex_state = 51, .external_lex_state = 2},
  [1769] = {.lex_state = 51, .external_lex_state = 2},
  [1770] = {.lex_state = 51, .external_lex_state = 2},
  [1771] = {.lex_state = 51, .external_lex_state = 2},
  [1772] = {.lex_state = 51, .external_lex_state = 2},
  [1773] = {.lex_state = 51, .external_lex_state = 2},
  [1774] = {.lex_state = 51, .external_lex_state = 2},
  [1775] = {.lex_state = 51, .external_lex_state = 2},
  [1776] = {.lex_state = 51, .external_lex_state = 2},
  [1777] = {.lex_state = 51, .external_lex_state = 2},
  [1778] = {.lex_state = 51, .external_lex_state = 2},
  [1779] = {.lex_state = 51, .external_lex_state = 2},
  [1780] = {.lex_state = 51, .external_lex_state = 2},
  [1781] = {.lex_state = 51, .external_lex_state = 2},
  [1782] = {.lex_state = 51, .external_lex_state = 2},
  [1783] = {.lex_state = 51, .external_lex_state = 2},
  [1784] = {.lex_state = 51, .external_lex_state = 2},
  [1785] = {.lex_state = 51, .external_lex_state = 2},
  [1786] = {.lex_state = 51, .external_lex_state = 2},
  [1787] = {.lex_state = 51, .external_lex_state = 2},
  [1788] = {.lex_state = 51, .external_lex_state = 2},
  [1789] = {.lex_state = 51, .external_lex_state = 2},
  [1790] = {.lex_state = 51, .external_lex_state = 2},
  [1791] = {.lex_state = 51, .external_lex_state = 2},
  [1792] = {.lex_state = 51, .external_lex_state = 2},
  [1793] = {.lex_state = 51, .external_lex_state = 2},
  [1794] = {.lex_state = 51, .external_lex_state = 2},
  [1795] = {.lex_state = 51, .external_lex_state = 2},
  [1796] = {.lex_state = 51, .external_lex_state = 2},
  [1797] = {.lex_state = 51, .external_lex_state = 2},
  [1798] = {.lex_state = 51, .external_lex_state = 2},
  [1799] = {.lex_state = 51, .external_lex_state = 2},
  [1800] = {.lex_state = 51, .external_lex_state = 2},
  [1801] = {.lex_state = 51, .external_lex_state = 2},
  [1802] = {.lex_state = 51, .external_lex_state = 2},
  [1803] = {.lex_state = 51, .external_lex_state = 2},
  [1804] = {.lex_state = 51, .external_lex_state = 2},
  [1805] = {.lex_state = 51, .external_lex_state = 2},
  [1806] = {.lex_state = 51, .external_lex_state = 2},
  [1807] = {.lex_state = 51, .external_lex_state = 2},
  [1808] = {.lex_state = 51, .external_lex_state = 2},
  [1809] = {.lex_state = 51, .external_lex_state = 2},
  [1810] = {.lex_state = 51, .external_lex_state = 2},
  [1811] = {.lex_state = 51, .external_lex_state = 2},
  [1812] = {.lex_state = 51, .external_lex_state = 2},
  [1813] = {.lex_state = 51, .external_lex_state = 2},
  [1814] = {.lex_state = 51, .external_lex_state = 2},
  [1815] = {.lex_state = 51, .external_lex_state = 2},
  [1816] = {.lex_state = 51, .external_lex_state = 2},
  [1817] = {.lex_state = 18, .external_lex_state = 3},
  [1818] = {.lex_state = 18, .external_lex_state = 3},
  [1819] = {.lex_state = 18, .external_lex_state = 3},
  [1820] = {.lex_state = 18, .external_lex_state = 3},
  [1821] = {.lex_state = 38, .external_lex_state = 2},
  [1822] = {.lex_state = 18, .external_lex_state = 3},
  [1823] = {.lex_state = 38, .external_lex_state = 2},
  [1824] = {.lex_state = 18, .external_lex_state = 4},
  [1825] = {.lex_state = 18, .external_lex_state = 4},
  [1826] = {.lex_state = 18, .external_lex_state = 4},
  [1827] = {.lex_state = 18, .external_lex_state = 4},
  [1828] = {.lex_state = 18, .external_lex_state = 4},
  [1829] = {.lex_state = 18, .external_lex_state = 4},
  [1830] = {.lex_state = 18, .external_lex_state = 4},
  [1831] = {.lex_state = 18, .external_lex_state = 4},
  [1832] = {.lex_state = 18, .external_lex_state = 4},
  [1833] = {.lex_state = 18, .external_lex_state = 4},
  [1834] = {.lex_state = 21, .external_lex_state = 4},
  [1835] = {.lex_state = 18, .external_lex_state = 4},
  [1836] = {.lex_state = 18, .external_lex_state = 4},
  [1837] = {.lex_state = 18, .external_lex_state = 4},
  [1838] = {.lex_state = 18, .external_lex_state = 4},
  [1839] = {.lex_state = 18, .external_lex_state = 4},
  [1840] = {.lex_state = 21, .external_lex_state = 4},
  [1841] = {.lex_state = 18, .external_lex_state = 3},
  [1842] = {.lex_state = 18, .external_lex_state = 4},
  [1843] = {.lex_state = 21, .external_lex_state = 4},
  [1844] = {.lex_state = 21, .external_lex_state = 4},
  [1845] = {.lex_state = 18, .external_lex_state = 4},
  [1846] = {.lex_state = 18, .external_lex_state = 4},
  [1847] = {.lex_state = 22, .external_lex_state = 3},
  [1848] = {.lex_state = 18, .external_lex_state = 4},
  [1849] = {.lex_state = 22, .external_lex_state = 3},
  [1850] = {.lex_state = 18, .external_lex_state = 3},
  [1851] = {.lex_state = 18, .external_lex_state = 4},
  [1852] = {.lex_state = 18, .external_lex_state = 4},
  [1853] = {.lex_state = 24, .external_lex_state = 3},
  [1854] = {.lex_state = 24, .external_lex_state = 3},
  [1855] = {.lex_state = 18, .external_lex_state = 4},
  [1856] = {.lex_state = 24, .external_lex_state = 4},
  [1857] = {.lex_state = 24, .external_lex_state = 3},
  [1858] = {.lex_state = 18, .external_lex_state = 3},
  [1859] = {.lex_state = 18, .external_lex_state = 4},
  [1860] = {.lex_state = 18, .external_lex_state = 3},
  [1861] = {.lex_state = 18, .external_lex_state = 4},
  [1862] = {.lex_state = 18, .external_lex_state = 4},
  [1863] = {.lex_state = 18, .external_lex_state = 4},
  [1864] = {.lex_state = 24, .external_lex_state = 3},
  [1865] = {.lex_state = 18, .external_lex_state = 4},
  [1866] = {.lex_state = 24, .external_lex_state = 4},
  [1867] = {.lex_state = 18, .external_lex_state = 4},
  [1868] = {.lex_state = 24, .external_lex_state = 4},
  [1869] = {.lex_state = 18, .external_lex_state = 4},
  [1870] = {.lex_state = 18, .external_lex_state = 4},
  [1871] = {.lex_state = 18, .external_lex_state = 4},
  [1872] = {.lex_state = 18, .external_lex_state = 3},
  [1873] = {.lex_state = 24, .external_lex_state = 4},
  [1874] = {.lex_state = 24, .external_lex_state = 3},
  [1875] = {.lex_state = 18, .external_lex_state = 4},
  [1876] = {.lex_state = 24, .external_lex_state = 3},
  [1877] = {.lex_state = 24, .external_lex_state = 3},
  [1878] = {.lex_state = 18, .external_lex_state = 4},
  [1879] = {.lex_state = 24, .external_lex_state = 3},
  [1880] = {.lex_state = 18, .external_lex_state = 4},
  [1881] = {.lex_state = 24, .external_lex_state = 4},
  [1882] = {.lex_state = 18, .external_lex_state = 4},
  [1883] = {.lex_state = 18, .external_lex_state = 3},
  [1884] = {.lex_state = 24, .external_lex_state = 4},
  [1885] = {.lex_state = 18, .external_lex_state = 4},
  [1886] = {.lex_state = 18, .external_lex_state = 4},
  [1887] = {.lex_state = 18, .external_lex_state = 3},
  [1888] = {.lex_state = 18, .external_lex_state = 4},
  [1889] = {.lex_state = 24, .external_lex_state = 4},
  [1890] = {.lex_state = 24, .external_lex_state = 4},
  [1891] = {.lex_state = 21, .external_lex_state = 3},
  [1892] = {.lex_state = 18, .external_lex_state = 3},
  [1893] = {.lex_state = 24, .external_lex_state = 4},
  [1894] = {.lex_state = 24, .external_lex_state = 3},
  [1895] = {.lex_state = 24, .external_lex_state = 3},
  [1896] = {.lex_state = 18, .external_lex_state = 3},
  [1897] = {.lex_state = 18, .external_lex_state = 3},
  [1898] = {.lex_state = 21, .external_lex_state = 3},
  [1899] = {.lex_state = 24, .external_lex_state = 3},
  [1900] = {.lex_state = 24, .external_lex_state = 3},
  [1901] = {.lex_state = 24, .external_lex_state = 3},
  [1902] = {.lex_state = 24, .external_lex_state = 4},
  [1903] = {.lex_state = 21, .external_lex_state = 3},
  [1904] = {.lex_state = 24, .external_lex_state = 3},
  [1905] = {.lex_state = 24, .external_lex_state = 3},
  [1906] = {.lex_state = 37, .external_lex_state = 2},
  [1907] = {.lex_state = 37, .external_lex_state = 2},
  [1908] = {.lex_state = 24, .external_lex_state = 3},
  [1909] = {.lex_state = 18, .external_lex_state = 3},
  [1910] = {.lex_state = 24, .external_lex_state = 3},
  [1911] = {.lex_state = 21, .external_lex_state = 3},
  [1912] = {.lex_state = 24, .external_lex_state = 3},
  [1913] = {.lex_state = 18, .external_lex_state = 3},
  [1914] = {.lex_state = 24, .external_lex_state = 4},
  [1915] = {.lex_state = 24, .external_lex_state = 3},
  [1916] = {.lex_state = 24, .external_lex_state = 3},
  [1917] = {.lex_state = 18, .external_lex_state = 3},
  [1918] = {.lex_state = 18, .external_lex_state = 3},
  [1919] = {.lex_state = 24, .external_lex_state = 3},
  [1920] = {.lex_state = 18, .external_lex_state = 3},
  [1921] = {.lex_state = 24, .external_lex_state = 3},
  [1922] = {.lex_state = 24, .external_lex_state = 3},
  [1923] = {.lex_state = 18, .external_lex_state = 3},
  [1924] = {.lex_state = 24, .external_lex_state = 4},
  [1925] = {.lex_state = 24, .external_lex_state = 3},
  [1926] = {.lex_state = 24, .external_lex_state = 4},
  [1927] = {.lex_state = 18, .external_lex_state = 3},
  [1928] = {.lex_state = 24, .external_lex_state = 4},
  [1929] = {.lex_state = 24, .external_lex_state = 3},
  [1930] = {.lex_state = 24, .external_lex_state = 3},
  [1931] = {.lex_state = 24, .external_lex_state = 3},
  [1932] = {.lex_state = 18, .external_lex_state = 3},
  [1933] = {.lex_state = 24, .external_lex_state = 3},
  [1934] = {.lex_state = 18, .external_lex_state = 3},
  [1935] = {.lex_state = 37, .external_lex_state = 2},
  [1936] = {.lex_state = 18, .external_lex_state = 3},
  [1937] = {.lex_state = 24, .external_lex_state = 3},
  [1938] = {.lex_state = 24, .external_lex_state = 3},
  [1939] = {.lex_state = 24, .external_lex_state = 3},
  [1940] = {.lex_state = 24, .external_lex_state = 3},
  [1941] = {.lex_state = 18, .external_lex_state = 4},
  [1942] = {.lex_state = 24, .external_lex_state = 3},
  [1943] = {.lex_state = 24, .external_lex_state = 4},
  [1944] = {.lex_state = 24, .external_lex_state = 3},
  [1945] = {.lex_state = 18, .external_lex_state = 4},
  [1946] = {.lex_state = 37, .external_lex_state = 2},
  [1947] = {.lex_state = 24, .external_lex_state = 3},
  [1948] = {.lex_state = 18, .external_lex_state = 4},
  [1949] = {.lex_state = 24, .external_lex_state = 4},
  [1950] = {.lex_state = 24, .external_lex_state = 3},
  [1951] = {.lex_state = 18, .external_lex_state = 4},
  [1952] = {.lex_state = 24, .external_lex_state = 4},
  [1953] = {.lex_state = 24, .external_lex_state = 3},
  [1954] = {.lex_state = 24, .external_lex_state = 3},
  [1955] = {.lex_state = 37, .external_lex_state = 2},
  [1956] = {.lex_state = 37, .external_lex_state = 2},
  [1957] = {.lex_state = 24, .external_lex_state = 3},
  [1958] = {.lex_state = 24, .external_lex_state = 3},
  [1959] = {.lex_state = 24, .external_lex_state = 3},
  [1960] = {.lex_state = 24, .external_lex_state = 3},
  [1961] = {.lex_state = 24, .external_lex_state = 3},
  [1962] = {.lex_state = 24, .external_lex_state = 3},
  [1963] = {.lex_state = 18, .external_lex_state = 4},
  [1964] = {.lex_state = 24, .external_lex_state = 4},
  [1965] = {.lex_state = 24, .external_lex_state = 3},
  [1966] = {.lex_state = 37, .external_lex_state = 2},
  [1967] = {.lex_state = 24, .external_lex_state = 3},
  [1968] = {.lex_state = 24, .external_lex_state = 4},
  [1969] = {.lex_state = 24, .external_lex_state = 3},
  [1970] = {.lex_state = 24, .external_lex_state = 3},
  [1971] = {.lex_state = 37, .external_lex_state = 2},
  [1972] = {.lex_state = 24, .external_lex_state = 3},
  [1973] = {.lex_state = 24, .external_lex_state = 4},
  [1974] = {.lex_state = 24, .external_lex_state = 4},
  [1975] = {.lex_state = 24, .external_lex_state = 3},
  [1976] = {.lex_state = 24, .external_lex_state = 4},
  [1977] = {.lex_state = 24, .external_lex_state = 4},
  [1978] = {.lex_state = 37, .external_lex_state = 2},
  [1979] = {.lex_state = 24, .external_lex_state = 4},
  [1980] = {.lex_state = 37, .external_lex_state = 2},
  [1981] = {.lex_state = 24, .external_lex_state = 3},
  [1982] = {.lex_state = 24, .external_lex_state = 4},
  [1983] = {.lex_state = 37, .external_lex_state = 2},
  [1984] = {.lex_state = 24, .external_lex_state = 4},
  [1985] = {.lex_state = 24, .external_lex_state = 4},
  [1986] = {.lex_state = 24, .external_lex_state = 3},
  [1987] = {.lex_state = 24, .external_lex_state = 4},
  [1988] = {.lex_state = 37, .external_lex_state = 2},
  [1989] = {.lex_state = 24, .external_lex_state = 4},
  [1990] = {.lex_state = 24, .external_lex_state = 4},
  [1991] = {.lex_state = 24, .external_lex_state = 4},
  [1992] = {.lex_state = 24, .external_lex_state = 4},
  [1993] = {.lex_state = 24, .external_lex_state = 4},
  [1994] = {.lex_state = 24, .external_lex_state = 4},
  [1995] = {.lex_state = 24, .external_lex_state = 4},
  [1996] = {.lex_state = 24, .external_lex_state = 4},
  [1997] = {.lex_state = 24, .external_lex_state = 4},
  [1998] = {.lex_state = 24, .external_lex_state = 3},
  [1999] = {.lex_state = 24, .external_lex_state = 4},
  [2000] = {.lex_state = 24, .external_lex_state = 4},
  [2001] = {.lex_state = 24, .external_lex_state = 4},
  [2002] = {.lex_state = 24, .external_lex_state = 3},
  [2003] = {.lex_state = 24, .external_lex_state = 4},
  [2004] = {.lex_state = 24, .external_lex_state = 4},
  [2005] = {.lex_state = 24, .external_lex_state = 4},
  [2006] = {.lex_state = 24, .external_lex_state = 4},
  [2007] = {.lex_state = 37, .external_lex_state = 2},
  [2008] = {.lex_state = 24, .external_lex_state = 4},
  [2009] = {.lex_state = 24, .external_lex_state = 4},
  [2010] = {.lex_state = 24, .external_lex_state = 3},
  [2011] = {.lex_state = 24, .external_lex_state = 4},
  [2012] = {.lex_state = 37, .external_lex_state = 2},
  [2013] = {.lex_state = 24, .external_lex_state = 3},
  [2014] = {.lex_state = 37, .external_lex_state = 2},
  [2015] = {.lex_state = 37, .external_lex_state = 2},
  [2016] = {.lex_state = 24, .external_lex_state = 4},
  [2017] = {.lex_state = 24, .external_lex_state = 4},
  [2018] = {.lex_state = 24, .external_lex_state = 4},
  [2019] = {.lex_state = 24, .external_lex_state = 4},
  [2020] = {.lex_state = 24, .external_lex_state = 4},
  [2021] = {.lex_state = 24, .external_lex_state = 3},
  [2022] = {.lex_state = 24, .external_lex_state = 3},
  [2023] = {.lex_state = 24, .external_lex_state = 3},
  [2024] = {.lex_state = 24, .external_lex_state = 3},
  [2025] = {.lex_state = 24, .external_lex_state = 4},
  [2026] = {.lex_state = 24, .external_lex_state = 4},
  [2027] = {.lex_state = 24, .external_lex_state = 3},
  [2028] = {.lex_state = 18, .external_lex_state = 4},
  [2029] = {.lex_state = 24, .external_lex_state = 3},
  [2030] = {.lex_state = 18, .external_lex_state = 4},
  [2031] = {.lex_state = 24, .external_lex_state = 3},
  [2032] = {.lex_state = 24, .external_lex_state = 3},
  [2033] = {.lex_state = 24, .external_lex_state = 3},
  [2034] = {.lex_state = 24, .external_lex_state = 3},
  [2035] = {.lex_state = 18, .external_lex_state = 4},
  [2036] = {.lex_state = 24, .external_lex_state = 3},
  [2037] = {.lex_state = 18, .external_lex_state = 4},
  [2038] = {.lex_state = 24, .external_lex_state = 4},
  [2039] = {.lex_state = 24, .external_lex_state = 3},
  [2040] = {.lex_state = 24, .external_lex_state = 3},
  [2041] = {.lex_state = 18, .external_lex_state = 4},
  [2042] = {.lex_state = 18, .external_lex_state = 4},
  [2043] = {.lex_state = 24, .external_lex_state = 3},
  [2044] = {.lex_state = 24, .external_lex_state = 3},
  [2045] = {.lex_state = 24, .external_lex_state = 3},
  [2046] = {.lex_state = 24, .external_lex_state = 3},
  [2047] = {.lex_state = 24, .external_lex_state = 4},
  [2048] = {.lex_state = 38, .external_lex_state = 2},
  [2049] = {.lex_state = 38, .external_lex_state = 2},
  [2050] = {.lex_state = 38, .external_lex_state = 2},
  [2051] = {.lex_state = 24, .external_lex_state = 4},
  [2052] = {.lex_state = 38, .external_lex_state = 2},
  [2053] = {.lex_state = 38, .external_lex_state = 2},
  [2054] = {.lex_state = 38, .external_lex_state = 2},
  [2055] = {.lex_state = 24, .external_lex_state = 3},
  [2056] = {.lex_state = 24, .external_lex_state = 4},
  [2057] = {.lex_state = 38, .external_lex_state = 2},
  [2058] = {.lex_state = 24, .external_lex_state = 3},
  [2059] = {.lex_state = 24, .external_lex_state = 4},
  [2060] = {.lex_state = 24, .external_lex_state = 3},
  [2061] = {.lex_state = 24, .external_lex_state = 3},
  [2062] = {.lex_state = 24, .external_lex_state = 4},
  [2063] = {.lex_state = 24, .external_lex_state = 3},
  [2064] = {.lex_state = 24, .external_lex_state = 3},
  [2065] = {.lex_state = 24, .external_lex_state = 4},
  [2066] = {.lex_state = 24, .external_lex_state = 3},
  [2067] = {.lex_state = 24, .external_lex_state = 3},
  [2068] = {.lex_state = 38, .external_lex_state = 2},
  [2069] = {.lex_state = 38, .external_lex_state = 2},
  [2070] = {.lex_state = 24, .external_lex_state = 3},
  [2071] = {.lex_state = 24, .external_lex_state = 3},
  [2072] = {.lex_state = 24, .external_lex_state = 3},
  [2073] = {.lex_state = 24, .external_lex_state = 3},
  [2074] = {.lex_state = 24, .external_lex_state = 3},
  [2075] = {.lex_state = 24, .external_lex_state = 3},
  [2076] = {.lex_state = 24, .external_lex_state = 3},
  [2077] = {.lex_state = 24, .external_lex_state = 3},
  [2078] = {.lex_state = 24, .external_lex_state = 3},
  [2079] = {.lex_state = 24, .external_lex_state = 3},
  [2080] = {.lex_state = 24, .external_lex_state = 3},
  [2081] = {.lex_state = 24, .external_lex_state = 3},
  [2082] = {.lex_state = 24, .external_lex_state = 3},
  [2083] = {.lex_state = 24, .external_lex_state = 3},
  [2084] = {.lex_state = 24, .external_lex_state = 4},
  [2085] = {.lex_state = 24, .external_lex_state = 3},
  [2086] = {.lex_state = 24, .external_lex_state = 3},
  [2087] = {.lex_state = 24, .external_lex_state = 3},
  [2088] = {.lex_state = 24, .external_lex_state = 3},
  [2089] = {.lex_state = 38, .external_lex_state = 2},
  [2090] = {.lex_state = 38, .external_lex_state = 2},
  [2091] = {.lex_state = 24, .external_lex_state = 3},
  [2092] = {.lex_state = 38, .external_lex_state = 2},
  [2093] = {.lex_state = 24, .external_lex_state = 3},
  [2094] = {.lex_state = 24, .external_lex_state = 3},
  [2095] = {.lex_state = 38, .external_lex_state = 2},
  [2096] = {.lex_state = 24, .external_lex_state = 3},
  [2097] = {.lex_state = 38, .external_lex_state = 2},
  [2098] = {.lex_state = 38, .external_lex_state = 2},
  [2099] = {.lex_state = 24, .external_lex_state = 3},
  [2100] = {.lex_state = 24, .external_lex_state = 3},
  [2101] = {.lex_state = 24, .external_lex_state = 3},
  [2102] = {.lex_state = 24, .external_lex_state = 3},
  [2103] = {.lex_state = 38, .external_lex_state = 2},
  [2104] = {.lex_state = 38, .external_lex_state = 2},
  [2105] = {.lex_state = 38, .external_lex_state = 2},
  [2106] = {.lex_state = 38, .external_lex_state = 2},
  [2107] = {.lex_state = 38, .external_lex_state = 2},
  [2108] = {.lex_state = 38, .external_lex_state = 2},
  [2109] = {.lex_state = 24, .external_lex_state = 3},
  [2110] = {.lex_state = 24, .external_lex_state = 3},
  [2111] = {.lex_state = 24, .external_lex_state = 3},
  [2112] = {.lex_state = 24, .external_lex_state = 3},
  [2113] = {.lex_state = 38, .external_lex_state = 2},
  [2114] = {.lex_state = 38, .external_lex_state = 2},
  [2115] = {.lex_state = 24, .external_lex_state = 3},
  [2116] = {.lex_state = 24, .external_lex_state = 3},
  [2117] = {.lex_state = 38, .external_lex_state = 2},
  [2118] = {.lex_state = 24, .external_lex_state = 3},
  [2119] = {.lex_state = 38, .external_lex_state = 2},
  [2120] = {.lex_state = 38, .external_lex_state = 2},
  [2121] = {.lex_state = 38, .external_lex_state = 2},
  [2122] = {.lex_state = 24, .external_lex_state = 3},
  [2123] = {.lex_state = 38, .external_lex_state = 2},
  [2124] = {.lex_state = 24, .external_lex_state = 3},
  [2125] = {.lex_state = 38, .external_lex_state = 2},
  [2126] = {.lex_state = 24, .external_lex_state = 3},
  [2127] = {.lex_state = 38, .external_lex_state = 2},
  [2128] = {.lex_state = 24, .external_lex_state = 3},
  [2129] = {.lex_state = 38, .external_lex_state = 2},
  [2130] = {.lex_state = 38, .external_lex_state = 2},
  [2131] = {.lex_state = 38, .external_lex_state = 2},
  [2132] = {.lex_state = 38, .external_lex_state = 2},
  [2133] = {.lex_state = 38, .external_lex_state = 2},
  [2134] = {.lex_state = 24, .external_lex_state = 3},
  [2135] = {.lex_state = 38, .external_lex_state = 2},
  [2136] = {.lex_state = 24, .external_lex_state = 3},
  [2137] = {.lex_state = 24, .external_lex_state = 3},
  [2138] = {.lex_state = 24, .external_lex_state = 3},
  [2139] = {.lex_state = 24, .external_lex_state = 3},
  [2140] = {.lex_state = 24, .external_lex_state = 3},
  [2141] = {.lex_state = 24, .external_lex_state = 3},
  [2142] = {.lex_state = 24, .external_lex_state = 3},
  [2143] = {.lex_state = 24, .external_lex_state = 3},
  [2144] = {.lex_state = 24, .external_lex_state = 3},
  [2145] = {.lex_state = 38, .external_lex_state = 2},
  [2146] = {.lex_state = 38, .external_lex_state = 2},
  [2147] = {.lex_state = 38, .external_lex_state = 2},
  [2148] = {.lex_state = 38, .external_lex_state = 2},
  [2149] = {.lex_state = 38, .external_lex_state = 2},
  [2150] = {.lex_state = 38, .external_lex_state = 2},
  [2151] = {.lex_state = 38, .external_lex_state = 2},
  [2152] = {.lex_state = 38, .external_lex_state = 2},
  [2153] = {.lex_state = 38, .external_lex_state = 2},
  [2154] = {.lex_state = 38, .external_lex_state = 2},
  [2155] = {.lex_state = 48, .external_lex_state = 5},
  [2156] = {.lex_state = 48, .external_lex_state = 5},
  [2157] = {.lex_state = 48, .external_lex_state = 5},
  [2158] = {.lex_state = 48, .external_lex_state = 5},
  [2159] = {.lex_state = 48, .external_lex_state = 5},
  [2160] = {.lex_state = 38, .external_lex_state = 2},
  [2161] = {.lex_state = 38, .external_lex_state = 2},
  [2162] = {.lex_state = 39, .external_lex_state = 2},
  [2163] = {.lex_state = 38, .external_lex_state = 2},
  [2164] = {.lex_state = 38, .external_lex_state = 2},
  [2165] = {.lex_state = 38, .external_lex_state = 2},
  [2166] = {.lex_state = 39, .external_lex_state = 2},
  [2167] = {.lex_state = 38, .external_lex_state = 2},
  [2168] = {.lex_state = 38, .external_lex_state = 2},
  [2169] = {.lex_state = 38, .external_lex_state = 2},
  [2170] = {.lex_state = 38, .external_lex_state = 2},
  [2171] = {.lex_state = 39, .external_lex_state = 2},
  [2172] = {.lex_state = 38, .external_lex_state = 2},
  [2173] = {.lex_state = 38, .external_lex_state = 2},
  [2174] = {.lex_state = 38, .external_lex_state = 2},
  [2175] = {.lex_state = 39, .external_lex_state = 2},
  [2176] = {.lex_state = 38, .external_lex_state = 2},
  [2177] = {.lex_state = 38, .external_lex_state = 2},
  [2178] = {.lex_state = 38, .external_lex_state = 2},
  [2179] = {.lex_state = 38, .external_lex_state = 2},
  [2180] = {.lex_state = 38, .external_lex_state = 2},
  [2181] = {.lex_state = 38, .external_lex_state = 2},
  [2182] = {.lex_state = 39, .external_lex_state = 2},
  [2183] = {.lex_state = 38, .external_lex_state = 2},
  [2184] = {.lex_state = 38, .external_lex_state = 2},
  [2185] = {.lex_state = 38, .external_lex_state = 2},
  [2186] = {.lex_state = 38, .external_lex_state = 2},
  [2187] = {.lex_state = 38, .external_lex_state = 2},
  [2188] = {.lex_state = 38, .external_lex_state = 2},
  [2189] = {.lex_state = 38, .external_lex_state = 2},
  [2190] = {.lex_state = 39, .external_lex_state = 2},
  [2191] = {.lex_state = 38, .external_lex_state = 2},
  [2192] = {.lex_state = 38, .external_lex_state = 2},
  [2193] = {.lex_state = 38, .external_lex_state = 2},
  [2194] = {.lex_state = 39, .external_lex_state = 2},
  [2195] = {.lex_state = 38, .external_lex_state = 2},
  [2196] = {.lex_state = 38, .external_lex_state = 2},
  [2197] = {.lex_state = 38, .external_lex_state = 2},
  [2198] = {.lex_state = 38, .external_lex_state = 2},
  [2199] = {.lex_state = 38, .external_lex_state = 2},
  [2200] = {.lex_state = 48, .external_lex_state = 5},
  [2201] = {.lex_state = 29, .external_lex_state = 4},
  [2202] = {.lex_state = 48, .external_lex_state = 5},
  [2203] = {.lex_state = 29, .external_lex_state = 4},
  [2204] = {.lex_state = 29, .external_lex_state = 3},
  [2205] = {.lex_state = 29, .external_lex_state = 3},
  [2206] = {.lex_state = 29, .external_lex_state = 3},
  [2207] = {.lex_state = 29, .external_lex_state = 3},
  [2208] = {.lex_state = 39, .external_lex_state = 2},
  [2209] = {.lex_state = 29, .external_lex_state = 3},
  [2210] = {.lex_state = 29, .external_lex_state = 3},
  [2211] = {.lex_state = 29, .external_lex_state = 3},
  [2212] = {.lex_state = 29, .external_lex_state = 3},
  [2213] = {.lex_state = 29, .external_lex_state = 3},
  [2214] = {.lex_state = 29, .external_lex_state = 3},
  [2215] = {.lex_state = 29, .external_lex_state = 3},
  [2216] = {.lex_state = 29, .external_lex_state = 4},
  [2217] = {.lex_state = 29, .external_lex_state = 4},
  [2218] = {.lex_state = 29, .external_lex_state = 3},
  [2219] = {.lex_state = 29, .external_lex_state = 3},
  [2220] = {.lex_state = 29, .external_lex_state = 3},
  [2221] = {.lex_state = 29, .external_lex_state = 4},
  [2222] = {.lex_state = 29, .external_lex_state = 3},
  [2223] = {.lex_state = 29, .external_lex_state = 3},
  [2224] = {.lex_state = 29, .external_lex_state = 3},
  [2225] = {.lex_state = 29, .external_lex_state = 3},
  [2226] = {.lex_state = 29, .external_lex_state = 4},
  [2227] = {.lex_state = 29, .external_lex_state = 3},
  [2228] = {.lex_state = 29, .external_lex_state = 3},
  [2229] = {.lex_state = 29, .external_lex_state = 3},
  [2230] = {.lex_state = 29, .external_lex_state = 3},
  [2231] = {.lex_state = 29, .external_lex_state = 3},
  [2232] = {.lex_state = 29, .external_lex_state = 3},
  [2233] = {.lex_state = 29, .external_lex_state = 3},
  [2234] = {.lex_state = 29, .external_lex_state = 3},
  [2235] = {.lex_state = 29, .external_lex_state = 3},
  [2236] = {.lex_state = 29, .external_lex_state = 3},
  [2237] = {.lex_state = 29, .external_lex_state = 3},
  [2238] = {.lex_state = 29, .external_lex_state = 3},
  [2239] = {.lex_state = 29, .external_lex_state = 3},
  [2240] = {.lex_state = 29, .external_lex_state = 3},
  [2241] = {.lex_state = 29, .external_lex_state = 3},
  [2242] = {.lex_state = 29, .external_lex_state = 3},
  [2243] = {.lex_state = 29, .external_lex_state = 3},
  [2244] = {.lex_state = 29, .external_lex_state = 3},
  [2245] = {.lex_state = 29, .external_lex_state = 4},
  [2246] = {.lex_state = 29, .external_lex_state = 3},
  [2247] = {.lex_state = 29, .external_lex_state = 4},
  [2248] = {.lex_state = 29, .external_lex_state = 3},
  [2249] = {.lex_state = 29, .external_lex_state = 3},
  [2250] = {.lex_state = 29, .external_lex_state = 3},
  [2251] = {.lex_state = 29, .external_lex_state = 3},
  [2252] = {.lex_state = 29, .external_lex_state = 3},
  [2253] = {.lex_state = 29, .external_lex_state = 3},
  [2254] = {.lex_state = 29, .external_lex_state = 3},
  [2255] = {.lex_state = 29, .external_lex_state = 3},
  [2256] = {.lex_state = 29, .external_lex_state = 3},
  [2257] = {.lex_state = 29, .external_lex_state = 3},
  [2258] = {.lex_state = 29, .external_lex_state = 3},
  [2259] = {.lex_state = 29, .external_lex_state = 3},
  [2260] = {.lex_state = 29, .external_lex_state = 3},
  [2261] = {.lex_state = 29, .external_lex_state = 3},
  [2262] = {.lex_state = 29, .external_lex_state = 3},
  [2263] = {.lex_state = 29, .external_lex_state = 3},
  [2264] = {.lex_state = 29, .external_lex_state = 3},
  [2265] = {.lex_state = 29, .external_lex_state = 3},
  [2266] = {.lex_state = 29, .external_lex_state = 3},
  [2267] = {.lex_state = 29, .external_lex_state = 3},
  [2268] = {.lex_state = 29, .external_lex_state = 3},
  [2269] = {.lex_state = 29, .external_lex_state = 3},
  [2270] = {.lex_state = 29, .external_lex_state = 3},
  [2271] = {.lex_state = 29, .external_lex_state = 3},
  [2272] = {.lex_state = 29, .external_lex_state = 3},
  [2273] = {.lex_state = 29, .external_lex_state = 3},
  [2274] = {.lex_state = 29, .external_lex_state = 3},
  [2275] = {.lex_state = 29, .external_lex_state = 3},
  [2276] = {.lex_state = 29, .external_lex_state = 3},
  [2277] = {.lex_state = 29, .external_lex_state = 3},
  [2278] = {.lex_state = 29, .external_lex_state = 3},
  [2279] = {.lex_state = 29, .external_lex_state = 3},
  [2280] = {.lex_state = 29, .external_lex_state = 3},
  [2281] = {.lex_state = 29, .external_lex_state = 3},
  [2282] = {.lex_state = 29, .external_lex_state = 3},
  [2283] = {.lex_state = 29, .external_lex_state = 3},
  [2284] = {.lex_state = 29, .external_lex_state = 3},
  [2285] = {.lex_state = 29, .external_lex_state = 3},
  [2286] = {.lex_state = 29, .external_lex_state = 3},
  [2287] = {.lex_state = 29, .external_lex_state = 3},
  [2288] = {.lex_state = 29, .external_lex_state = 3},
  [2289] = {.lex_state = 29, .external_lex_state = 3},
  [2290] = {.lex_state = 29, .external_lex_state = 3},
  [2291] = {.lex_state = 29, .external_lex_state = 3},
  [2292] = {.lex_state = 29, .external_lex_state = 3},
  [2293] = {.lex_state = 29, .external_lex_state = 4},
  [2294] = {.lex_state = 29, .external_lex_state = 3},
  [2295] = {.lex_state = 29, .external_lex_state = 3},
  [2296] = {.lex_state = 29, .external_lex_state = 3},
  [2297] = {.lex_state = 29, .external_lex_state = 3},
  [2298] = {.lex_state = 29, .external_lex_state = 3},
  [2299] = {.lex_state = 39, .external_lex_state = 5},
  [2300] = {.lex_state = 29, .external_lex_state = 3},
  [2301] = {.lex_state = 29, .external_lex_state = 3},
  [2302] = {.lex_state = 29, .external_lex_state = 3},
  [2303] = {.lex_state = 29, .external_lex_state = 3},
  [2304] = {.lex_state = 29, .external_lex_state = 3},
  [2305] = {.lex_state = 29, .external_lex_state = 3},
  [2306] = {.lex_state = 29, .external_lex_state = 3},
  [2307] = {.lex_state = 29, .external_lex_state = 3},
  [2308] = {.lex_state = 29, .external_lex_state = 3},
  [2309] = {.lex_state = 29, .external_lex_state = 3},
  [2310] = {.lex_state = 29, .external_lex_state = 3},
  [2311] = {.lex_state = 29, .external_lex_state = 3},
  [2312] = {.lex_state = 39, .external_lex_state = 5},
  [2313] = {.lex_state = 29, .external_lex_state = 3},
  [2314] = {.lex_state = 29, .external_lex_state = 3},
  [2315] = {.lex_state = 29, .external_lex_state = 3},
  [2316] = {.lex_state = 29, .external_lex_state = 3},
  [2317] = {.lex_state = 29, .external_lex_state = 3},
  [2318] = {.lex_state = 29, .external_lex_state = 3},
  [2319] = {.lex_state = 29, .external_lex_state = 3},
  [2320] = {.lex_state = 29, .external_lex_state = 3},
  [2321] = {.lex_state = 29, .external_lex_state = 3},
  [2322] = {.lex_state = 29, .external_lex_state = 3},
  [2323] = {.lex_state = 29, .external_lex_state = 3},
  [2324] = {.lex_state = 29, .external_lex_state = 3},
  [2325] = {.lex_state = 29, .external_lex_state = 3},
  [2326] = {.lex_state = 29, .external_lex_state = 3},
  [2327] = {.lex_state = 29, .external_lex_state = 3},
  [2328] = {.lex_state = 29, .external_lex_state = 3},
  [2329] = {.lex_state = 29, .external_lex_state = 3},
  [2330] = {.lex_state = 29, .external_lex_state = 3},
  [2331] = {.lex_state = 29, .external_lex_state = 3},
  [2332] = {.lex_state = 29, .external_lex_state = 3},
  [2333] = {.lex_state = 29, .external_lex_state = 3},
  [2334] = {.lex_state = 29, .external_lex_state = 3},
  [2335] = {.lex_state = 29, .external_lex_state = 3},
  [2336] = {.lex_state = 29, .external_lex_state = 3},
  [2337] = {.lex_state = 29, .external_lex_state = 3},
  [2338] = {.lex_state = 29, .external_lex_state = 3},
  [2339] = {.lex_state = 29, .external_lex_state = 3},
  [2340] = {.lex_state = 29, .external_lex_state = 3},
  [2341] = {.lex_state = 29, .external_lex_state = 3},
  [2342] = {.lex_state = 29, .external_lex_state = 3},
  [2343] = {.lex_state = 29, .external_lex_state = 3},
  [2344] = {.lex_state = 29, .external_lex_state = 3},
  [2345] = {.lex_state = 29, .external_lex_state = 3},
  [2346] = {.lex_state = 29, .external_lex_state = 3},
  [2347] = {.lex_state = 29, .external_lex_state = 3},
  [2348] = {.lex_state = 29, .external_lex_state = 3},
  [2349] = {.lex_state = 29, .external_lex_state = 3},
  [2350] = {.lex_state = 29, .external_lex_state = 3},
  [2351] = {.lex_state = 29, .external_lex_state = 3},
  [2352] = {.lex_state = 29, .external_lex_state = 3},
  [2353] = {.lex_state = 29, .external_lex_state = 3},
  [2354] = {.lex_state = 29, .external_lex_state = 3},
  [2355] = {.lex_state = 29, .external_lex_state = 3},
  [2356] = {.lex_state = 29, .external_lex_state = 3},
  [2357] = {.lex_state = 29, .external_lex_state = 3},
  [2358] = {.lex_state = 29, .external_lex_state = 3},
  [2359] = {.lex_state = 29, .external_lex_state = 3},
  [2360] = {.lex_state = 29, .external_lex_state = 3},
  [2361] = {.lex_state = 29, .external_lex_state = 3},
  [2362] = {.lex_state = 29, .external_lex_state = 3},
  [2363] = {.lex_state = 29, .external_lex_state = 3},
  [2364] = {.lex_state = 29, .external_lex_state = 3},
  [2365] = {.lex_state = 29, .external_lex_state = 3},
  [2366] = {.lex_state = 29, .external_lex_state = 3},
  [2367] = {.lex_state = 29, .external_lex_state = 3},
  [2368] = {.lex_state = 29, .external_lex_state = 3},
  [2369] = {.lex_state = 29, .external_lex_state = 3},
  [2370] = {.lex_state = 29, .external_lex_state = 3},
  [2371] = {.lex_state = 29, .external_lex_state = 3},
  [2372] = {.lex_state = 29, .external_lex_state = 3},
  [2373] = {.lex_state = 29, .external_lex_state = 3},
  [2374] = {.lex_state = 29, .external_lex_state = 3},
  [2375] = {.lex_state = 29, .external_lex_state = 3},
  [2376] = {.lex_state = 39, .external_lex_state = 5},
  [2377] = {.lex_state = 39, .external_lex_state = 5},
  [2378] = {.lex_state = 29, .external_lex_state = 3},
  [2379] = {.lex_state = 29, .external_lex_state = 3},
  [2380] = {.lex_state = 29, .external_lex_state = 3},
  [2381] = {.lex_state = 39, .external_lex_state = 5},
  [2382] = {.lex_state = 29, .external_lex_state = 3},
  [2383] = {.lex_state = 29, .external_lex_state = 3},
  [2384] = {.lex_state = 29, .external_lex_state = 3},
  [2385] = {.lex_state = 29, .external_lex_state = 3},
  [2386] = {.lex_state = 29, .external_lex_state = 3},
  [2387] = {.lex_state = 29, .external_lex_state = 4},
  [2388] = {.lex_state = 29, .external_lex_state = 3},
  [2389] = {.lex_state = 29, .external_lex_state = 3},
  [2390] = {.lex_state = 39, .external_lex_state = 5},
  [2391] = {.lex_state = 29, .external_lex_state = 3},
  [2392] = {.lex_state = 29, .external_lex_state = 4},
  [2393] = {.lex_state = 39, .external_lex_state = 5},
  [2394] = {.lex_state = 29, .external_lex_state = 4},
  [2395] = {.lex_state = 39, .external_lex_state = 5},
  [2396] = {.lex_state = 29, .external_lex_state = 3},
  [2397] = {.lex_state = 29, .external_lex_state = 3},
  [2398] = {.lex_state = 29, .external_lex_state = 4},
  [2399] = {.lex_state = 29, .external_lex_state = 3},
  [2400] = {.lex_state = 29, .external_lex_state = 4},
  [2401] = {.lex_state = 29, .external_lex_state = 4},
  [2402] = {.lex_state = 29, .external_lex_state = 4},
  [2403] = {.lex_state = 29, .external_lex_state = 3},
  [2404] = {.lex_state = 29, .external_lex_state = 3},
  [2405] = {.lex_state = 29, .external_lex_state = 3},
  [2406] = {.lex_state = 39, .external_lex_state = 5},
  [2407] = {.lex_state = 29, .external_lex_state = 4},
  [2408] = {.lex_state = 29, .external_lex_state = 4},
  [2409] = {.lex_state = 39, .external_lex_state = 5},
  [2410] = {.lex_state = 29, .external_lex_state = 4},
  [2411] = {.lex_state = 39, .external_lex_state = 5},
  [2412] = {.lex_state = 29, .external_lex_state = 4},
  [2413] = {.lex_state = 29, .external_lex_state = 3},
  [2414] = {.lex_state = 29, .external_lex_state = 3},
  [2415] = {.lex_state = 29, .external_lex_state = 4},
  [2416] = {.lex_state = 29, .external_lex_state = 4},
  [2417] = {.lex_state = 29, .external_lex_state = 4},
  [2418] = {.lex_state = 29, .external_lex_state = 3},
  [2419] = {.lex_state = 29, .external_lex_state = 3},
  [2420] = {.lex_state = 29, .external_lex_state = 3},
  [2421] = {.lex_state = 29, .external_lex_state = 3},
  [2422] = {.lex_state = 29, .external_lex_state = 4},
  [2423] = {.lex_state = 29, .external_lex_state = 4},
  [2424] = {.lex_state = 29, .external_lex_state = 3},
  [2425] = {.lex_state = 29, .external_lex_state = 3},
  [2426] = {.lex_state = 29, .external_lex_state = 3},
  [2427] = {.lex_state = 29, .external_lex_state = 3},
  [2428] = {.lex_state = 29, .external_lex_state = 4},
  [2429] = {.lex_state = 29, .external_lex_state = 4},
  [2430] = {.lex_state = 29, .external_lex_state = 3},
  [2431] = {.lex_state = 29, .external_lex_state = 4},
  [2432] = {.lex_state = 29, .external_lex_state = 3},
  [2433] = {.lex_state = 29, .external_lex_state = 4},
  [2434] = {.lex_state = 39, .external_lex_state = 5},
  [2435] = {.lex_state = 29, .external_lex_state = 3},
  [2436] = {.lex_state = 29, .external_lex_state = 3},
  [2437] = {.lex_state = 29, .external_lex_state = 4},
  [2438] = {.lex_state = 29, .external_lex_state = 3},
  [2439] = {.lex_state = 29, .external_lex_state = 4},
  [2440] = {.lex_state = 29, .external_lex_state = 3},
  [2441] = {.lex_state = 29, .external_lex_state = 3},
  [2442] = {.lex_state = 29, .external_lex_state = 3},
  [2443] = {.lex_state = 29, .external_lex_state = 3},
  [2444] = {.lex_state = 29, .external_lex_state = 3},
  [2445] = {.lex_state = 29, .external_lex_state = 3},
  [2446] = {.lex_state = 29, .external_lex_state = 3},
  [2447] = {.lex_state = 29, .external_lex_state = 4},
  [2448] = {.lex_state = 29, .external_lex_state = 4},
  [2449] = {.lex_state = 29, .external_lex_state = 3},
  [2450] = {.lex_state = 29, .external_lex_state = 3},
  [2451] = {.lex_state = 29, .external_lex_state = 3},
  [2452] = {.lex_state = 29, .external_lex_state = 3},
  [2453] = {.lex_state = 29, .external_lex_state = 3},
  [2454] = {.lex_state = 29, .external_lex_state = 3},
  [2455] = {.lex_state = 29, .external_lex_state = 4},
  [2456] = {.lex_state = 29, .external_lex_state = 4},
  [2457] = {.lex_state = 29, .external_lex_state = 3},
  [2458] = {.lex_state = 29, .external_lex_state = 3},
  [2459] = {.lex_state = 29, .external_lex_state = 4},
  [2460] = {.lex_state = 29, .external_lex_state = 3},
  [2461] = {.lex_state = 29, .external_lex_state = 4},
  [2462] = {.lex_state = 29, .external_lex_state = 3},
  [2463] = {.lex_state = 29, .external_lex_state = 4},
  [2464] = {.lex_state = 29, .external_lex_state = 4},
  [2465] = {.lex_state = 29, .external_lex_state = 3},
  [2466] = {.lex_state = 29, .external_lex_state = 4},
  [2467] = {.lex_state = 29, .external_lex_state = 4},
  [2468] = {.lex_state = 29, .external_lex_state = 4},
  [2469] = {.lex_state = 29, .external_lex_state = 4},
  [2470] = {.lex_state = 29, .external_lex_state = 4},
  [2471] = {.lex_state = 29, .external_lex_state = 4},
  [2472] = {.lex_state = 29, .external_lex_state = 4},
  [2473] = {.lex_state = 29, .external_lex_state = 3},
  [2474] = {.lex_state = 29, .external_lex_state = 3},
  [2475] = {.lex_state = 29, .external_lex_state = 3},
  [2476] = {.lex_state = 29, .external_lex_state = 4},
  [2477] = {.lex_state = 29, .external_lex_state = 4},
  [2478] = {.lex_state = 29, .external_lex_state = 4},
  [2479] = {.lex_state = 29, .external_lex_state = 4},
  [2480] = {.lex_state = 29, .external_lex_state = 3},
  [2481] = {.lex_state = 29, .external_lex_state = 3},
  [2482] = {.lex_state = 29, .external_lex_state = 4},
  [2483] = {.lex_state = 29, .external_lex_state = 4},
  [2484] = {.lex_state = 29, .external_lex_state = 3},
  [2485] = {.lex_state = 29, .external_lex_state = 4},
  [2486] = {.lex_state = 29, .external_lex_state = 4},
  [2487] = {.lex_state = 29, .external_lex_state = 4},
  [2488] = {.lex_state = 29, .external_lex_state = 4},
  [2489] = {.lex_state = 29, .external_lex_state = 3},
  [2490] = {.lex_state = 29, .external_lex_state = 3},
  [2491] = {.lex_state = 29, .external_lex_state = 4},
  [2492] = {.lex_state = 29, .external_lex_state = 4},
  [2493] = {.lex_state = 29, .external_lex_state = 3},
  [2494] = {.lex_state = 29, .external_lex_state = 4},
  [2495] = {.lex_state = 29, .external_lex_state = 3},
  [2496] = {.lex_state = 29, .external_lex_state = 3},
  [2497] = {.lex_state = 29, .external_lex_state = 3},
  [2498] = {.lex_state = 29, .external_lex_state = 4},
  [2499] = {.lex_state = 29, .external_lex_state = 4},
  [2500] = {.lex_state = 29, .external_lex_state = 4},
  [2501] = {.lex_state = 29, .external_lex_state = 3},
  [2502] = {.lex_state = 29, .external_lex_state = 3},
  [2503] = {.lex_state = 29, .external_lex_state = 4},
  [2504] = {.lex_state = 29, .external_lex_state = 4},
  [2505] = {.lex_state = 29, .external_lex_state = 4},
  [2506] = {.lex_state = 29, .external_lex_state = 4},
  [2507] = {.lex_state = 39, .external_lex_state = 5},
  [2508] = {.lex_state = 29, .external_lex_state = 3},
  [2509] = {.lex_state = 29, .external_lex_state = 4},
  [2510] = {.lex_state = 39, .external_lex_state = 5},
  [2511] = {.lex_state = 29, .external_lex_state = 4},
  [2512] = {.lex_state = 29, .external_lex_state = 3},
  [2513] = {.lex_state = 29, .external_lex_state = 3},
  [2514] = {.lex_state = 29, .external_lex_state = 3},
  [2515] = {.lex_state = 29, .external_lex_state = 3},
  [2516] = {.lex_state = 29, .external_lex_state = 4},
  [2517] = {.lex_state = 29, .external_lex_state = 3},
  [2518] = {.lex_state = 29, .external_lex_state = 4},
  [2519] = {.lex_state = 29, .external_lex_state = 4},
  [2520] = {.lex_state = 29, .external_lex_state = 4},
  [2521] = {.lex_state = 29, .external_lex_state = 3},
  [2522] = {.lex_state = 29, .external_lex_state = 3},
  [2523] = {.lex_state = 29, .external_lex_state = 3},
  [2524] = {.lex_state = 29, .external_lex_state = 4},
  [2525] = {.lex_state = 29, .external_lex_state = 4},
  [2526] = {.lex_state = 29, .external_lex_state = 3},
  [2527] = {.lex_state = 29, .external_lex_state = 4},
  [2528] = {.lex_state = 29, .external_lex_state = 4},
  [2529] = {.lex_state = 29, .external_lex_state = 3},
  [2530] = {.lex_state = 29, .external_lex_state = 4},
  [2531] = {.lex_state = 29, .external_lex_state = 3},
  [2532] = {.lex_state = 29, .external_lex_state = 3},
  [2533] = {.lex_state = 29, .external_lex_state = 4},
  [2534] = {.lex_state = 29, .external_lex_state = 4},
  [2535] = {.lex_state = 29, .external_lex_state = 4},
  [2536] = {.lex_state = 29, .external_lex_state = 4},
  [2537] = {.lex_state = 29, .external_lex_state = 4},
  [2538] = {.lex_state = 29, .external_lex_state = 4},
  [2539] = {.lex_state = 29, .external_lex_state = 4},
  [2540] = {.lex_state = 29, .external_lex_state = 3},
  [2541] = {.lex_state = 29, .external_lex_state = 3},
  [2542] = {.lex_state = 29, .external_lex_state = 4},
  [2543] = {.lex_state = 29, .external_lex_state = 4},
  [2544] = {.lex_state = 29, .external_lex_state = 4},
  [2545] = {.lex_state = 29, .external_lex_state = 3},
  [2546] = {.lex_state = 29, .external_lex_state = 4},
  [2547] = {.lex_state = 29, .external_lex_state = 3},
  [2548] = {.lex_state = 29, .external_lex_state = 3},
  [2549] = {.lex_state = 29, .external_lex_state = 4},
  [2550] = {.lex_state = 29, .external_lex_state = 3},
  [2551] = {.lex_state = 39, .external_lex_state = 5},
  [2552] = {.lex_state = 29, .external_lex_state = 3},
  [2553] = {.lex_state = 29, .external_lex_state = 3},
  [2554] = {.lex_state = 29, .external_lex_state = 3},
  [2555] = {.lex_state = 29, .external_lex_state = 4},
  [2556] = {.lex_state = 29, .external_lex_state = 4},
  [2557] = {.lex_state = 29, .external_lex_state = 4},
  [2558] = {.lex_state = 29, .external_lex_state = 3},
  [2559] = {.lex_state = 29, .external_lex_state = 4},
  [2560] = {.lex_state = 29, .external_lex_state = 3},
  [2561] = {.lex_state = 29, .external_lex_state = 4},
  [2562] = {.lex_state = 29, .external_lex_state = 4},
  [2563] = {.lex_state = 29, .external_lex_state = 4},
  [2564] = {.lex_state = 29, .external_lex_state = 4},
  [2565] = {.lex_state = 29, .external_lex_state = 3},
  [2566] = {.lex_state = 29, .external_lex_state = 3},
  [2567] = {.lex_state = 39, .external_lex_state = 5},
  [2568] = {.lex_state = 29, .external_lex_state = 3},
  [2569] = {.lex_state = 29, .external_lex_state = 4},
  [2570] = {.lex_state = 29, .external_lex_state = 3},
  [2571] = {.lex_state = 29, .external_lex_state = 4},
  [2572] = {.lex_state = 29, .external_lex_state = 3},
  [2573] = {.lex_state = 29, .external_lex_state = 4},
  [2574] = {.lex_state = 29, .external_lex_state = 4},
  [2575] = {.lex_state = 29, .external_lex_state = 4},
  [2576] = {.lex_state = 29, .external_lex_state = 4},
  [2577] = {.lex_state = 29, .external_lex_state = 3},
  [2578] = {.lex_state = 29, .external_lex_state = 4},
  [2579] = {.lex_state = 29, .external_lex_state = 3},
  [2580] = {.lex_state = 38, .external_lex_state = 5},
  [2581] = {.lex_state = 29, .external_lex_state = 4},
  [2582] = {.lex_state = 29, .external_lex_state = 3},
  [2583] = {.lex_state = 29, .external_lex_state = 3},
  [2584] = {.lex_state = 29, .external_lex_state = 3},
  [2585] = {.lex_state = 29, .external_lex_state = 3},
  [2586] = {.lex_state = 29, .external_lex_state = 3},
  [2587] = {.lex_state = 29, .external_lex_state = 3},
  [2588] = {.lex_state = 29, .external_lex_state = 3},
  [2589] = {.lex_state = 39, .external_lex_state = 5},
  [2590] = {.lex_state = 29, .external_lex_state = 4},
  [2591] = {.lex_state = 29, .external_lex_state = 4},
  [2592] = {.lex_state = 29, .external_lex_state = 3},
  [2593] = {.lex_state = 29, .external_lex_state = 4},
  [2594] = {.lex_state = 29, .external_lex_state = 4},
  [2595] = {.lex_state = 29, .external_lex_state = 3},
  [2596] = {.lex_state = 38, .external_lex_state = 5},
  [2597] = {.lex_state = 29, .external_lex_state = 3},
  [2598] = {.lex_state = 29, .external_lex_state = 4},
  [2599] = {.lex_state = 29, .external_lex_state = 3},
  [2600] = {.lex_state = 29, .external_lex_state = 4},
  [2601] = {.lex_state = 29, .external_lex_state = 3},
  [2602] = {.lex_state = 29, .external_lex_state = 4},
  [2603] = {.lex_state = 29, .external_lex_state = 3},
  [2604] = {.lex_state = 39, .external_lex_state = 5},
  [2605] = {.lex_state = 29, .external_lex_state = 4},
  [2606] = {.lex_state = 29, .external_lex_state = 3},
  [2607] = {.lex_state = 39, .external_lex_state = 5},
  [2608] = {.lex_state = 29, .external_lex_state = 3},
  [2609] = {.lex_state = 29, .external_lex_state = 3},
  [2610] = {.lex_state = 39, .external_lex_state = 5},
  [2611] = {.lex_state = 29, .external_lex_state = 3},
  [2612] = {.lex_state = 29, .external_lex_state = 3},
  [2613] = {.lex_state = 29, .external_lex_state = 3},
  [2614] = {.lex_state = 29, .external_lex_state = 3},
  [2615] = {.lex_state = 29, .external_lex_state = 3},
  [2616] = {.lex_state = 29, .external_lex_state = 3},
  [2617] = {.lex_state = 29, .external_lex_state = 3},
  [2618] = {.lex_state = 29, .external_lex_state = 3},
  [2619] = {.lex_state = 29, .external_lex_state = 4},
  [2620] = {.lex_state = 29, .external_lex_state = 4},
  [2621] = {.lex_state = 29, .external_lex_state = 3},
  [2622] = {.lex_state = 29, .external_lex_state = 4},
  [2623] = {.lex_state = 29, .external_lex_state = 3},
  [2624] = {.lex_state = 29, .external_lex_state = 3},
  [2625] = {.lex_state = 29, .external_lex_state = 3},
  [2626] = {.lex_state = 29, .external_lex_state = 3},
  [2627] = {.lex_state = 29, .external_lex_state = 4},
  [2628] = {.lex_state = 29, .external_lex_state = 3},
  [2629] = {.lex_state = 29, .external_lex_state = 3},
  [2630] = {.lex_state = 29, .external_lex_state = 3},
  [2631] = {.lex_state = 29, .external_lex_state = 3},
  [2632] = {.lex_state = 29, .external_lex_state = 3},
  [2633] = {.lex_state = 29, .external_lex_state = 3},
  [2634] = {.lex_state = 29, .external_lex_state = 4},
  [2635] = {.lex_state = 39, .external_lex_state = 5},
  [2636] = {.lex_state = 29, .external_lex_state = 3},
  [2637] = {.lex_state = 29, .external_lex_state = 3},
  [2638] = {.lex_state = 39, .external_lex_state = 5},
  [2639] = {.lex_state = 29, .external_lex_state = 4},
  [2640] = {.lex_state = 29, .external_lex_state = 3},
  [2641] = {.lex_state = 29, .external_lex_state = 3},
  [2642] = {.lex_state = 29, .external_lex_state = 4},
  [2643] = {.lex_state = 29, .external_lex_state = 3},
  [2644] = {.lex_state = 29, .external_lex_state = 3},
  [2645] = {.lex_state = 29, .external_lex_state = 3},
  [2646] = {.lex_state = 29, .external_lex_state = 3},
  [2647] = {.lex_state = 29, .external_lex_state = 3},
  [2648] = {.lex_state = 29, .external_lex_state = 3},
  [2649] = {.lex_state = 29, .external_lex_state = 4},
  [2650] = {.lex_state = 29, .external_lex_state = 3},
  [2651] = {.lex_state = 29, .external_lex_state = 3},
  [2652] = {.lex_state = 29, .external_lex_state = 3},
  [2653] = {.lex_state = 29, .external_lex_state = 3},
  [2654] = {.lex_state = 29, .external_lex_state = 4},
  [2655] = {.lex_state = 29, .external_lex_state = 3},
  [2656] = {.lex_state = 29, .external_lex_state = 3},
  [2657] = {.lex_state = 29, .external_lex_state = 3},
  [2658] = {.lex_state = 29, .external_lex_state = 3},
  [2659] = {.lex_state = 29, .external_lex_state = 4},
  [2660] = {.lex_state = 29, .external_lex_state = 4},
  [2661] = {.lex_state = 29, .external_lex_state = 3},
  [2662] = {.lex_state = 29, .external_lex_state = 4},
  [2663] = {.lex_state = 29, .external_lex_state = 3},
  [2664] = {.lex_state = 29, .external_lex_state = 3},
  [2665] = {.lex_state = 29, .external_lex_state = 3},
  [2666] = {.lex_state = 29, .external_lex_state = 3},
  [2667] = {.lex_state = 29, .external_lex_state = 3},
  [2668] = {.lex_state = 29, .external_lex_state = 3},
  [2669] = {.lex_state = 29, .external_lex_state = 3},
  [2670] = {.lex_state = 29, .external_lex_state = 3},
  [2671] = {.lex_state = 29, .external_lex_state = 3},
  [2672] = {.lex_state = 29, .external_lex_state = 3},
  [2673] = {.lex_state = 29, .external_lex_state = 3},
  [2674] = {.lex_state = 29, .external_lex_state = 3},
  [2675] = {.lex_state = 29, .external_lex_state = 3},
  [2676] = {.lex_state = 29, .external_lex_state = 3},
  [2677] = {.lex_state = 29, .external_lex_state = 3},
  [2678] = {.lex_state = 29, .external_lex_state = 3},
  [2679] = {.lex_state = 29, .external_lex_state = 3},
  [2680] = {.lex_state = 29, .external_lex_state = 4},
  [2681] = {.lex_state = 29, .external_lex_state = 3},
  [2682] = {.lex_state = 29, .external_lex_state = 4},
  [2683] = {.lex_state = 29, .external_lex_state = 4},
  [2684] = {.lex_state = 29, .external_lex_state = 4},
  [2685] = {.lex_state = 29, .external_lex_state = 4},
  [2686] = {.lex_state = 29, .external_lex_state = 4},
  [2687] = {.lex_state = 29, .external_lex_state = 4},
  [2688] = {.lex_state = 29, .external_lex_state = 4},
  [2689] = {.lex_state = 29, .external_lex_state = 4},
  [2690] = {.lex_state = 29, .external_lex_state = 4},
  [2691] = {.lex_state = 29, .external_lex_state = 4},
  [2692] = {.lex_state = 29, .external_lex_state = 4},
  [2693] = {.lex_state = 29, .external_lex_state = 4},
  [2694] = {.lex_state = 29, .external_lex_state = 4},
  [2695] = {.lex_state = 29, .external_lex_state = 4},
  [2696] = {.lex_state = 29, .external_lex_state = 4},
  [2697] = {.lex_state = 29, .external_lex_state = 4},
  [2698] = {.lex_state = 29, .external_lex_state = 4},
  [2699] = {.lex_state = 29, .external_lex_state = 3},
  [2700] = {.lex_state = 29, .external_lex_state = 3},
  [2701] = {.lex_state = 29, .external_lex_state = 4},
  [2702] = {.lex_state = 29, .external_lex_state = 4},
  [2703] = {.lex_state = 29, .external_lex_state = 4},
  [2704] = {.lex_state = 39, .external_lex_state = 2},
  [2705] = {.lex_state = 29, .external_lex_state = 4},
  [2706] = {.lex_state = 29, .external_lex_state = 4},
  [2707] = {.lex_state = 29, .external_lex_state = 4},
  [2708] = {.lex_state = 29, .external_lex_state = 3},
  [2709] = {.lex_state = 29, .external_lex_state = 4},
  [2710] = {.lex_state = 29, .external_lex_state = 4},
  [2711] = {.lex_state = 29, .external_lex_state = 3},
  [2712] = {.lex_state = 29, .external_lex_state = 4},
  [2713] = {.lex_state = 29, .external_lex_state = 4},
  [2714] = {.lex_state = 29, .external_lex_state = 3},
  [2715] = {.lex_state = 29, .external_lex_state = 4},
  [2716] = {.lex_state = 39, .external_lex_state = 5},
  [2717] = {.lex_state = 29, .external_lex_state = 4},
  [2718] = {.lex_state = 29, .external_lex_state = 4},
  [2719] = {.lex_state = 29, .external_lex_state = 3},
  [2720] = {.lex_state = 29, .external_lex_state = 4},
  [2721] = {.lex_state = 29, .external_lex_state = 4},
  [2722] = {.lex_state = 29, .external_lex_state = 4},
  [2723] = {.lex_state = 29, .external_lex_state = 4},
  [2724] = {.lex_state = 38, .external_lex_state = 5},
  [2725] = {.lex_state = 29, .external_lex_state = 4},
  [2726] = {.lex_state = 29, .external_lex_state = 4},
  [2727] = {.lex_state = 38, .external_lex_state = 5},
  [2728] = {.lex_state = 29, .external_lex_state = 4},
  [2729] = {.lex_state = 29, .external_lex_state = 4},
  [2730] = {.lex_state = 29, .external_lex_state = 4},
  [2731] = {.lex_state = 29, .external_lex_state = 4},
  [2732] = {.lex_state = 29, .external_lex_state = 4},
  [2733] = {.lex_state = 29, .external_lex_state = 4},
  [2734] = {.lex_state = 29, .external_lex_state = 4},
  [2735] = {.lex_state = 29, .external_lex_state = 4},
  [2736] = {.lex_state = 29, .external_lex_state = 4},
  [2737] = {.lex_state = 29, .external_lex_state = 4},
  [2738] = {.lex_state = 29, .external_lex_state = 4},
  [2739] = {.lex_state = 29, .external_lex_state = 4},
  [2740] = {.lex_state = 29, .external_lex_state = 4},
  [2741] = {.lex_state = 29, .external_lex_state = 4},
  [2742] = {.lex_state = 29, .external_lex_state = 4},
  [2743] = {.lex_state = 29, .external_lex_state = 4},
  [2744] = {.lex_state = 29, .external_lex_state = 4},
  [2745] = {.lex_state = 39, .external_lex_state = 5},
  [2746] = {.lex_state = 29, .external_lex_state = 4},
  [2747] = {.lex_state = 29, .external_lex_state = 4},
  [2748] = {.lex_state = 29, .external_lex_state = 4},
  [2749] = {.lex_state = 29, .external_lex_state = 4},
  [2750] = {.lex_state = 29, .external_lex_state = 4},
  [2751] = {.lex_state = 29, .external_lex_state = 4},
  [2752] = {.lex_state = 29, .external_lex_state = 4},
  [2753] = {.lex_state = 29, .external_lex_state = 4},
  [2754] = {.lex_state = 29, .external_lex_state = 4},
  [2755] = {.lex_state = 29, .external_lex_state = 3},
  [2756] = {.lex_state = 29, .external_lex_state = 4},
  [2757] = {.lex_state = 39, .external_lex_state = 2},
  [2758] = {.lex_state = 29, .external_lex_state = 3},
  [2759] = {.lex_state = 29, .external_lex_state = 3},
  [2760] = {.lex_state = 29, .external_lex_state = 3},
  [2761] = {.lex_state = 29, .external_lex_state = 3},
  [2762] = {.lex_state = 29, .external_lex_state = 3},
  [2763] = {.lex_state = 29, .external_lex_state = 4},
  [2764] = {.lex_state = 29, .external_lex_state = 3},
  [2765] = {.lex_state = 29, .external_lex_state = 3},
  [2766] = {.lex_state = 29, .external_lex_state = 3},
  [2767] = {.lex_state = 29, .external_lex_state = 3},
  [2768] = {.lex_state = 29, .external_lex_state = 3},
  [2769] = {.lex_state = 29, .external_lex_state = 4},
  [2770] = {.lex_state = 29, .external_lex_state = 3},
  [2771] = {.lex_state = 29, .external_lex_state = 3},
  [2772] = {.lex_state = 29, .external_lex_state = 4},
  [2773] = {.lex_state = 29, .external_lex_state = 3},
  [2774] = {.lex_state = 29, .external_lex_state = 4},
  [2775] = {.lex_state = 29, .external_lex_state = 4},
  [2776] = {.lex_state = 29, .external_lex_state = 3},
  [2777] = {.lex_state = 29, .external_lex_state = 4},
  [2778] = {.lex_state = 29, .external_lex_state = 3},
  [2779] = {.lex_state = 39, .external_lex_state = 2},
  [2780] = {.lex_state = 39, .external_lex_state = 5},
  [2781] = {.lex_state = 29, .external_lex_state = 4},
  [2782] = {.lex_state = 29, .external_lex_state = 4},
  [2783] = {.lex_state = 29, .external_lex_state = 3},
  [2784] = {.lex_state = 29, .external_lex_state = 4},
  [2785] = {.lex_state = 29, .external_lex_state = 4},
  [2786] = {.lex_state = 29, .external_lex_state = 4},
  [2787] = {.lex_state = 29, .external_lex_state = 4},
  [2788] = {.lex_state = 29, .external_lex_state = 4},
  [2789] = {.lex_state = 29, .external_lex_state = 4},
  [2790] = {.lex_state = 29, .external_lex_state = 4},
  [2791] = {.lex_state = 29, .external_lex_state = 4},
  [2792] = {.lex_state = 39, .external_lex_state = 5},
  [2793] = {.lex_state = 29, .external_lex_state = 4},
  [2794] = {.lex_state = 29, .external_lex_state = 4},
  [2795] = {.lex_state = 29, .external_lex_state = 4},
  [2796] = {.lex_state = 29, .external_lex_state = 4},
  [2797] = {.lex_state = 29, .external_lex_state = 4},
  [2798] = {.lex_state = 29, .external_lex_state = 4},
  [2799] = {.lex_state = 29, .external_lex_state = 4},
  [2800] = {.lex_state = 29, .external_lex_state = 4},
  [2801] = {.lex_state = 29, .external_lex_state = 4},
  [2802] = {.lex_state = 29, .external_lex_state = 4},
  [2803] = {.lex_state = 29, .external_lex_state = 4},
  [2804] = {.lex_state = 29, .external_lex_state = 4},
  [2805] = {.lex_state = 39, .external_lex_state = 5},
  [2806] = {.lex_state = 29, .external_lex_state = 4},
  [2807] = {.lex_state = 29, .external_lex_state = 4},
  [2808] = {.lex_state = 29, .external_lex_state = 4},
  [2809] = {.lex_state = 29, .external_lex_state = 3},
  [2810] = {.lex_state = 29, .external_lex_state = 4},
  [2811] = {.lex_state = 29, .external_lex_state = 3},
  [2812] = {.lex_state = 29, .external_lex_state = 4},
  [2813] = {.lex_state = 29, .external_lex_state = 4},
  [2814] = {.lex_state = 29, .external_lex_state = 4},
  [2815] = {.lex_state = 29, .external_lex_state = 3},
  [2816] = {.lex_state = 29, .external_lex_state = 3},
  [2817] = {.lex_state = 29, .external_lex_state = 4},
  [2818] = {.lex_state = 29, .external_lex_state = 4},
  [2819] = {.lex_state = 29, .external_lex_state = 4},
  [2820] = {.lex_state = 29, .external_lex_state = 4},
  [2821] = {.lex_state = 29, .external_lex_state = 4},
  [2822] = {.lex_state = 29, .external_lex_state = 4},
  [2823] = {.lex_state = 29, .external_lex_state = 4},
  [2824] = {.lex_state = 29, .external_lex_state = 4},
  [2825] = {.lex_state = 29, .external_lex_state = 3},
  [2826] = {.lex_state = 29, .external_lex_state = 4},
  [2827] = {.lex_state = 29, .external_lex_state = 4},
  [2828] = {.lex_state = 29, .external_lex_state = 4},
  [2829] = {.lex_state = 29, .external_lex_state = 4},
  [2830] = {.lex_state = 39, .external_lex_state = 2},
  [2831] = {.lex_state = 29, .external_lex_state = 3},
  [2832] = {.lex_state = 29, .external_lex_state = 4},
  [2833] = {.lex_state = 29, .external_lex_state = 3},
  [2834] = {.lex_state = 29, .external_lex_state = 3},
  [2835] = {.lex_state = 29, .external_lex_state = 4},
  [2836] = {.lex_state = 29, .external_lex_state = 4},
  [2837] = {.lex_state = 29, .external_lex_state = 4},
  [2838] = {.lex_state = 29, .external_lex_state = 4},
  [2839] = {.lex_state = 29, .external_lex_state = 3},
  [2840] = {.lex_state = 29, .external_lex_state = 4},
  [2841] = {.lex_state = 29, .external_lex_state = 4},
  [2842] = {.lex_state = 39, .external_lex_state = 2},
  [2843] = {.lex_state = 39, .external_lex_state = 2},
  [2844] = {.lex_state = 29, .external_lex_state = 4},
  [2845] = {.lex_state = 29, .external_lex_state = 4},
  [2846] = {.lex_state = 29, .external_lex_state = 4},
  [2847] = {.lex_state = 29, .external_lex_state = 4},
  [2848] = {.lex_state = 29, .external_lex_state = 4},
  [2849] = {.lex_state = 29, .external_lex_state = 4},
  [2850] = {.lex_state = 29, .external_lex_state = 4},
  [2851] = {.lex_state = 29, .external_lex_state = 4},
  [2852] = {.lex_state = 29, .external_lex_state = 4},
  [2853] = {.lex_state = 29, .external_lex_state = 4},
  [2854] = {.lex_state = 29, .external_lex_state = 4},
  [2855] = {.lex_state = 29, .external_lex_state = 4},
  [2856] = {.lex_state = 29, .external_lex_state = 4},
  [2857] = {.lex_state = 29, .external_lex_state = 4},
  [2858] = {.lex_state = 29, .external_lex_state = 4},
  [2859] = {.lex_state = 29, .external_lex_state = 4},
  [2860] = {.lex_state = 29, .external_lex_state = 3},
  [2861] = {.lex_state = 29, .external_lex_state = 3},
  [2862] = {.lex_state = 29, .external_lex_state = 3},
  [2863] = {.lex_state = 29, .external_lex_state = 3},
  [2864] = {.lex_state = 29, .external_lex_state = 4},
  [2865] = {.lex_state = 29, .external_lex_state = 4},
  [2866] = {.lex_state = 29, .external_lex_state = 4},
  [2867] = {.lex_state = 29, .external_lex_state = 4},
  [2868] = {.lex_state = 29, .external_lex_state = 4},
  [2869] = {.lex_state = 29, .external_lex_state = 4},
  [2870] = {.lex_state = 29, .external_lex_state = 4},
  [2871] = {.lex_state = 29, .external_lex_state = 4},
  [2872] = {.lex_state = 29, .external_lex_state = 4},
  [2873] = {.lex_state = 29, .external_lex_state = 4},
  [2874] = {.lex_state = 29, .external_lex_state = 3},
  [2875] = {.lex_state = 29, .external_lex_state = 3},
  [2876] = {.lex_state = 29, .external_lex_state = 3},
  [2877] = {.lex_state = 29, .external_lex_state = 3},
  [2878] = {.lex_state = 29, .external_lex_state = 3},
  [2879] = {.lex_state = 29, .external_lex_state = 3},
  [2880] = {.lex_state = 29, .external_lex_state = 4},
  [2881] = {.lex_state = 29, .external_lex_state = 4},
  [2882] = {.lex_state = 29, .external_lex_state = 4},
  [2883] = {.lex_state = 29, .external_lex_state = 3},
  [2884] = {.lex_state = 29, .external_lex_state = 4},
  [2885] = {.lex_state = 29, .external_lex_state = 4},
  [2886] = {.lex_state = 29, .external_lex_state = 4},
  [2887] = {.lex_state = 29, .external_lex_state = 4},
  [2888] = {.lex_state = 29, .external_lex_state = 4},
  [2889] = {.lex_state = 38, .external_lex_state = 5},
  [2890] = {.lex_state = 29, .external_lex_state = 4},
  [2891] = {.lex_state = 29, .external_lex_state = 3},
  [2892] = {.lex_state = 29, .external_lex_state = 4},
  [2893] = {.lex_state = 29, .external_lex_state = 3},
  [2894] = {.lex_state = 39, .external_lex_state = 5},
  [2895] = {.lex_state = 29, .external_lex_state = 4},
  [2896] = {.lex_state = 38, .external_lex_state = 5},
  [2897] = {.lex_state = 29, .external_lex_state = 4},
  [2898] = {.lex_state = 29, .external_lex_state = 4},
  [2899] = {.lex_state = 29, .external_lex_state = 4},
  [2900] = {.lex_state = 29, .external_lex_state = 4},
  [2901] = {.lex_state = 38, .external_lex_state = 5},
  [2902] = {.lex_state = 29, .external_lex_state = 4},
  [2903] = {.lex_state = 39, .external_lex_state = 5},
  [2904] = {.lex_state = 39, .external_lex_state = 2},
  [2905] = {.lex_state = 39, .external_lex_state = 2},
  [2906] = {.lex_state = 29, .external_lex_state = 4},
  [2907] = {.lex_state = 39, .external_lex_state = 5},
  [2908] = {.lex_state = 29, .external_lex_state = 3},
  [2909] = {.lex_state = 29, .external_lex_state = 4},
  [2910] = {.lex_state = 29, .external_lex_state = 4},
  [2911] = {.lex_state = 27, .external_lex_state = 3},
  [2912] = {.lex_state = 29, .external_lex_state = 4},
  [2913] = {.lex_state = 39, .external_lex_state = 2},
  [2914] = {.lex_state = 29, .external_lex_state = 4},
  [2915] = {.lex_state = 29, .external_lex_state = 3},
  [2916] = {.lex_state = 29, .external_lex_state = 4},
  [2917] = {.lex_state = 38, .external_lex_state = 5},
  [2918] = {.lex_state = 29, .external_lex_state = 3},
  [2919] = {.lex_state = 39, .external_lex_state = 2},
  [2920] = {.lex_state = 39, .external_lex_state = 5},
  [2921] = {.lex_state = 29, .external_lex_state = 3},
  [2922] = {.lex_state = 29, .external_lex_state = 4},
  [2923] = {.lex_state = 39, .external_lex_state = 5},
  [2924] = {.lex_state = 29, .external_lex_state = 4},
  [2925] = {.lex_state = 29, .external_lex_state = 4},
  [2926] = {.lex_state = 39, .external_lex_state = 2},
  [2927] = {.lex_state = 39, .external_lex_state = 5},
  [2928] = {.lex_state = 29, .external_lex_state = 4},
  [2929] = {.lex_state = 29, .external_lex_state = 4},
  [2930] = {.lex_state = 29, .external_lex_state = 3},
  [2931] = {.lex_state = 29, .external_lex_state = 4},
  [2932] = {.lex_state = 29, .external_lex_state = 4},
  [2933] = {.lex_state = 29, .external_lex_state = 4},
  [2934] = {.lex_state = 29, .external_lex_state = 3},
  [2935] = {.lex_state = 39, .external_lex_state = 2},
  [2936] = {.lex_state = 29, .external_lex_state = 4},
  [2937] = {.lex_state = 29, .external_lex_state = 4},
  [2938] = {.lex_state = 39, .external_lex_state = 5},
  [2939] = {.lex_state = 39, .external_lex_state = 5},
  [2940] = {.lex_state = 29, .external_lex_state = 4},
  [2941] = {.lex_state = 29, .external_lex_state = 3},
  [2942] = {.lex_state = 39, .external_lex_state = 2},
  [2943] = {.lex_state = 29, .external_lex_state = 3},
  [2944] = {.lex_state = 29, .external_lex_state = 4},
  [2945] = {.lex_state = 29, .external_lex_state = 3},
  [2946] = {.lex_state = 39, .external_lex_state = 2},
  [2947] = {.lex_state = 39, .external_lex_state = 2},
  [2948] = {.lex_state = 29, .external_lex_state = 4},
  [2949] = {.lex_state = 39, .external_lex_state = 5},
  [2950] = {.lex_state = 39, .external_lex_state = 5},
  [2951] = {.lex_state = 39, .external_lex_state = 2},
  [2952] = {.lex_state = 29, .external_lex_state = 3},
  [2953] = {.lex_state = 29, .external_lex_state = 3},
  [2954] = {.lex_state = 29, .external_lex_state = 4},
  [2955] = {.lex_state = 29, .external_lex_state = 3},
  [2956] = {.lex_state = 29, .external_lex_state = 3},
  [2957] = {.lex_state = 29, .external_lex_state = 4},
  [2958] = {.lex_state = 29, .external_lex_state = 3},
  [2959] = {.lex_state = 39, .external_lex_state = 5},
  [2960] = {.lex_state = 29, .external_lex_state = 4},
  [2961] = {.lex_state = 29, .external_lex_state = 3},
  [2962] = {.lex_state = 39, .external_lex_state = 5},
  [2963] = {.lex_state = 29, .external_lex_state = 3},
  [2964] = {.lex_state = 29, .external_lex_state = 3},
  [2965] = {.lex_state = 39, .external_lex_state = 5},
  [2966] = {.lex_state = 29, .external_lex_state = 4},
  [2967] = {.lex_state = 29, .external_lex_state = 4},
  [2968] = {.lex_state = 29, .external_lex_state = 4},
  [2969] = {.lex_state = 29, .external_lex_state = 4},
  [2970] = {.lex_state = 29, .external_lex_state = 3},
  [2971] = {.lex_state = 29, .external_lex_state = 3},
  [2972] = {.lex_state = 29, .external_lex_state = 4},
  [2973] = {.lex_state = 29, .external_lex_state = 4},
  [2974] = {.lex_state = 39, .external_lex_state = 2},
  [2975] = {.lex_state = 29, .external_lex_state = 4},
  [2976] = {.lex_state = 39, .external_lex_state = 5},
  [2977] = {.lex_state = 29, .external_lex_state = 4},
  [2978] = {.lex_state = 29, .external_lex_state = 4},
  [2979] = {.lex_state = 29, .external_lex_state = 3},
  [2980] = {.lex_state = 29, .external_lex_state = 3},
  [2981] = {.lex_state = 29, .external_lex_state = 3},
  [2982] = {.lex_state = 29, .external_lex_state = 4},
  [2983] = {.lex_state = 29, .external_lex_state = 4},
  [2984] = {.lex_state = 29, .external_lex_state = 3},
  [2985] = {.lex_state = 29, .external_lex_state = 4},
  [2986] = {.lex_state = 29, .external_lex_state = 4},
  [2987] = {.lex_state = 29, .external_lex_state = 4},
  [2988] = {.lex_state = 39, .external_lex_state = 5},
  [2989] = {.lex_state = 29, .external_lex_state = 4},
  [2990] = {.lex_state = 39, .external_lex_state = 5},
  [2991] = {.lex_state = 29, .external_lex_state = 4},
  [2992] = {.lex_state = 39, .external_lex_state = 5},
  [2993] = {.lex_state = 30, .external_lex_state = 4},
  [2994] = {.lex_state = 29, .external_lex_state = 4},
  [2995] = {.lex_state = 39, .external_lex_state = 2},
  [2996] = {.lex_state = 29, .external_lex_state = 4},
  [2997] = {.lex_state = 39, .external_lex_state = 5},
  [2998] = {.lex_state = 29, .external_lex_state = 4},
  [2999] = {.lex_state = 29, .external_lex_state = 4},
  [3000] = {.lex_state = 29, .external_lex_state = 4},
  [3001] = {.lex_state = 29, .external_lex_state = 4},
  [3002] = {.lex_state = 39, .external_lex_state = 5},
  [3003] = {.lex_state = 29, .external_lex_state = 3},
  [3004] = {.lex_state = 29, .external_lex_state = 3},
  [3005] = {.lex_state = 29, .external_lex_state = 4},
  [3006] = {.lex_state = 29, .external_lex_state = 3},
  [3007] = {.lex_state = 29, .external_lex_state = 4},
  [3008] = {.lex_state = 29, .external_lex_state = 4},
  [3009] = {.lex_state = 29, .external_lex_state = 3},
  [3010] = {.lex_state = 39, .external_lex_state = 2},
  [3011] = {.lex_state = 39, .external_lex_state = 2},
  [3012] = {.lex_state = 29, .external_lex_state = 4},
  [3013] = {.lex_state = 39, .external_lex_state = 5},
  [3014] = {.lex_state = 39, .external_lex_state = 5},
  [3015] = {.lex_state = 29, .external_lex_state = 4},
  [3016] = {.lex_state = 29, .external_lex_state = 4},
  [3017] = {.lex_state = 29, .external_lex_state = 4},
  [3018] = {.lex_state = 39, .external_lex_state = 5},
  [3019] = {.lex_state = 39, .external_lex_state = 5},
  [3020] = {.lex_state = 27, .external_lex_state = 4},
  [3021] = {.lex_state = 29, .external_lex_state = 4},
  [3022] = {.lex_state = 29, .external_lex_state = 4},
  [3023] = {.lex_state = 29, .external_lex_state = 4},
  [3024] = {.lex_state = 29, .external_lex_state = 4},
  [3025] = {.lex_state = 29, .external_lex_state = 4},
  [3026] = {.lex_state = 39, .external_lex_state = 5},
  [3027] = {.lex_state = 39, .external_lex_state = 5},
  [3028] = {.lex_state = 29, .external_lex_state = 4},
  [3029] = {.lex_state = 29, .external_lex_state = 3},
  [3030] = {.lex_state = 29, .external_lex_state = 4},
  [3031] = {.lex_state = 29, .external_lex_state = 4},
  [3032] = {.lex_state = 29, .external_lex_state = 3},
  [3033] = {.lex_state = 29, .external_lex_state = 3},
  [3034] = {.lex_state = 29, .external_lex_state = 3},
  [3035] = {.lex_state = 29, .external_lex_state = 4},
  [3036] = {.lex_state = 29, .external_lex_state = 4},
  [3037] = {.lex_state = 29, .external_lex_state = 3},
  [3038] = {.lex_state = 29, .external_lex_state = 3},
  [3039] = {.lex_state = 29, .external_lex_state = 4},
  [3040] = {.lex_state = 29, .external_lex_state = 4},
  [3041] = {.lex_state = 29, .external_lex_state = 3},
  [3042] = {.lex_state = 29, .external_lex_state = 4},
  [3043] = {.lex_state = 29, .external_lex_state = 4},
  [3044] = {.lex_state = 29, .external_lex_state = 4},
  [3045] = {.lex_state = 29, .external_lex_state = 4},
  [3046] = {.lex_state = 39, .external_lex_state = 2},
  [3047] = {.lex_state = 29, .external_lex_state = 4},
  [3048] = {.lex_state = 39, .external_lex_state = 2},
  [3049] = {.lex_state = 29, .external_lex_state = 3},
  [3050] = {.lex_state = 29, .external_lex_state = 3},
  [3051] = {.lex_state = 29, .external_lex_state = 4},
  [3052] = {.lex_state = 29, .external_lex_state = 3},
  [3053] = {.lex_state = 29, .external_lex_state = 4},
  [3054] = {.lex_state = 29, .external_lex_state = 4},
  [3055] = {.lex_state = 29, .external_lex_state = 3},
  [3056] = {.lex_state = 29, .external_lex_state = 3},
  [3057] = {.lex_state = 29, .external_lex_state = 4},
  [3058] = {.lex_state = 29, .external_lex_state = 4},
  [3059] = {.lex_state = 29, .external_lex_state = 4},
  [3060] = {.lex_state = 29, .external_lex_state = 4},
  [3061] = {.lex_state = 39, .external_lex_state = 5},
  [3062] = {.lex_state = 29, .external_lex_state = 4},
  [3063] = {.lex_state = 29, .external_lex_state = 4},
  [3064] = {.lex_state = 39, .external_lex_state = 5},
  [3065] = {.lex_state = 29, .external_lex_state = 4},
  [3066] = {.lex_state = 29, .external_lex_state = 3},
  [3067] = {.lex_state = 29, .external_lex_state = 4},
  [3068] = {.lex_state = 29, .external_lex_state = 3},
  [3069] = {.lex_state = 29, .external_lex_state = 4},
  [3070] = {.lex_state = 29, .external_lex_state = 3},
  [3071] = {.lex_state = 29, .external_lex_state = 3},
  [3072] = {.lex_state = 29, .external_lex_state = 4},
  [3073] = {.lex_state = 29, .external_lex_state = 4},
  [3074] = {.lex_state = 39, .external_lex_state = 5},
  [3075] = {.lex_state = 29, .external_lex_state = 4},
  [3076] = {.lex_state = 29, .external_lex_state = 4},
  [3077] = {.lex_state = 29, .external_lex_state = 3},
  [3078] = {.lex_state = 29, .external_lex_state = 3},
  [3079] = {.lex_state = 29, .external_lex_state = 3},
  [3080] = {.lex_state = 29, .external_lex_state = 3},
  [3081] = {.lex_state = 39, .external_lex_state = 5},
  [3082] = {.lex_state = 39, .external_lex_state = 5},
  [3083] = {.lex_state = 29, .external_lex_state = 3},
  [3084] = {.lex_state = 29, .external_lex_state = 3},
  [3085] = {.lex_state = 29, .external_lex_state = 4},
  [3086] = {.lex_state = 29, .external_lex_state = 3},
  [3087] = {.lex_state = 29, .external_lex_state = 4},
  [3088] = {.lex_state = 29, .external_lex_state = 3},
  [3089] = {.lex_state = 29, .external_lex_state = 3},
  [3090] = {.lex_state = 29, .external_lex_state = 3},
  [3091] = {.lex_state = 29, .external_lex_state = 3},
  [3092] = {.lex_state = 29, .external_lex_state = 3},
  [3093] = {.lex_state = 29, .external_lex_state = 3},
  [3094] = {.lex_state = 29, .external_lex_state = 4},
  [3095] = {.lex_state = 29, .external_lex_state = 3},
  [3096] = {.lex_state = 39, .external_lex_state = 5},
  [3097] = {.lex_state = 29, .external_lex_state = 4},
  [3098] = {.lex_state = 39, .external_lex_state = 5},
  [3099] = {.lex_state = 29, .external_lex_state = 3},
  [3100] = {.lex_state = 29, .external_lex_state = 3},
  [3101] = {.lex_state = 29, .external_lex_state = 3},
  [3102] = {.lex_state = 29, .external_lex_state = 4},
  [3103] = {.lex_state = 29, .external_lex_state = 4},
  [3104] = {.lex_state = 29, .external_lex_state = 3},
  [3105] = {.lex_state = 29, .external_lex_state = 4},
  [3106] = {.lex_state = 29, .external_lex_state = 3},
  [3107] = {.lex_state = 29, .external_lex_state = 3},
  [3108] = {.lex_state = 29, .external_lex_state = 3},
  [3109] = {.lex_state = 29, .external_lex_state = 3},
  [3110] = {.lex_state = 29, .external_lex_state = 3},
  [3111] = {.lex_state = 29, .external_lex_state = 4},
  [3112] = {.lex_state = 29, .external_lex_state = 4},
  [3113] = {.lex_state = 29, .external_lex_state = 3},
  [3114] = {.lex_state = 29, .external_lex_state = 3},
  [3115] = {.lex_state = 29, .external_lex_state = 3},
  [3116] = {.lex_state = 29, .external_lex_state = 3},
  [3117] = {.lex_state = 29, .external_lex_state = 3},
  [3118] = {.lex_state = 29, .external_lex_state = 4},
  [3119] = {.lex_state = 29, .external_lex_state = 3},
  [3120] = {.lex_state = 29, .external_lex_state = 3},
  [3121] = {.lex_state = 29, .external_lex_state = 3},
  [3122] = {.lex_state = 29, .external_lex_state = 3},
  [3123] = {.lex_state = 29, .external_lex_state = 3},
  [3124] = {.lex_state = 29, .external_lex_state = 3},
  [3125] = {.lex_state = 39, .external_lex_state = 5},
  [3126] = {.lex_state = 29, .external_lex_state = 3},
  [3127] = {.lex_state = 39, .external_lex_state = 5},
  [3128] = {.lex_state = 29, .external_lex_state = 3},
  [3129] = {.lex_state = 29, .external_lex_state = 3},
  [3130] = {.lex_state = 29, .external_lex_state = 3},
  [3131] = {.lex_state = 29, .external_lex_state = 3},
  [3132] = {.lex_state = 29, .external_lex_state = 3},
  [3133] = {.lex_state = 29, .external_lex_state = 3},
  [3134] = {.lex_state = 29, .external_lex_state = 3},
  [3135] = {.lex_state = 39, .external_lex_state = 2},
  [3136] = {.lex_state = 39, .external_lex_state = 5},
  [3137] = {.lex_state = 29, .external_lex_state = 3},
  [3138] = {.lex_state = 29, .external_lex_state = 3},
  [3139] = {.lex_state = 29, .external_lex_state = 4},
  [3140] = {.lex_state = 29, .external_lex_state = 4},
  [3141] = {.lex_state = 39, .external_lex_state = 5},
  [3142] = {.lex_state = 39, .external_lex_state = 5},
  [3143] = {.lex_state = 29, .external_lex_state = 4},
  [3144] = {.lex_state = 29, .external_lex_state = 3},
  [3145] = {.lex_state = 29, .external_lex_state = 3},
  [3146] = {.lex_state = 29, .external_lex_state = 3},
  [3147] = {.lex_state = 29, .external_lex_state = 3},
  [3148] = {.lex_state = 29, .external_lex_state = 4},
  [3149] = {.lex_state = 29, .external_lex_state = 4},
  [3150] = {.lex_state = 39, .external_lex_state = 5},
  [3151] = {.lex_state = 29, .external_lex_state = 3},
  [3152] = {.lex_state = 29, .external_lex_state = 4},
  [3153] = {.lex_state = 39, .external_lex_state = 5},
  [3154] = {.lex_state = 39, .external_lex_state = 5},
  [3155] = {.lex_state = 39, .external_lex_state = 5},
  [3156] = {.lex_state = 39, .external_lex_state = 5},
  [3157] = {.lex_state = 39, .external_lex_state = 5},
  [3158] = {.lex_state = 39, .external_lex_state = 5},
  [3159] = {.lex_state = 29, .external_lex_state = 3},
  [3160] = {.lex_state = 29, .external_lex_state = 4},
  [3161] = {.lex_state = 29, .external_lex_state = 3},
  [3162] = {.lex_state = 29, .external_lex_state = 4},
  [3163] = {.lex_state = 29, .external_lex_state = 3},
  [3164] = {.lex_state = 39, .external_lex_state = 5},
  [3165] = {.lex_state = 39, .external_lex_state = 5},
  [3166] = {.lex_state = 29, .external_lex_state = 3},
  [3167] = {.lex_state = 29, .external_lex_state = 4},
  [3168] = {.lex_state = 29, .external_lex_state = 4},
  [3169] = {.lex_state = 29, .external_lex_state = 3},
  [3170] = {.lex_state = 29, .external_lex_state = 4},
  [3171] = {.lex_state = 29, .external_lex_state = 4},
  [3172] = {.lex_state = 29, .external_lex_state = 4},
  [3173] = {.lex_state = 29, .external_lex_state = 3},
  [3174] = {.lex_state = 29, .external_lex_state = 3},
  [3175] = {.lex_state = 29, .external_lex_state = 4},
  [3176] = {.lex_state = 29, .external_lex_state = 4},
  [3177] = {.lex_state = 39, .external_lex_state = 2},
  [3178] = {.lex_state = 39, .external_lex_state = 2},
  [3179] = {.lex_state = 39, .external_lex_state = 5},
  [3180] = {.lex_state = 29, .external_lex_state = 3},
  [3181] = {.lex_state = 29, .external_lex_state = 4},
  [3182] = {.lex_state = 29, .external_lex_state = 4},
  [3183] = {.lex_state = 29, .external_lex_state = 4},
  [3184] = {.lex_state = 39, .external_lex_state = 5},
  [3185] = {.lex_state = 39, .external_lex_state = 5},
  [3186] = {.lex_state = 29, .external_lex_state = 3},
  [3187] = {.lex_state = 29, .external_lex_state = 3},
  [3188] = {.lex_state = 39, .external_lex_state = 5},
  [3189] = {.lex_state = 29, .external_lex_state = 3},
  [3190] = {.lex_state = 29, .external_lex_state = 3},
  [3191] = {.lex_state = 29, .external_lex_state = 3},
  [3192] = {.lex_state = 29, .external_lex_state = 4},
  [3193] = {.lex_state = 29, .external_lex_state = 3},
  [3194] = {.lex_state = 39, .external_lex_state = 5},
  [3195] = {.lex_state = 29, .external_lex_state = 4},
  [3196] = {.lex_state = 39, .external_lex_state = 5},
  [3197] = {.lex_state = 39, .external_lex_state = 5},
  [3198] = {.lex_state = 39, .external_lex_state = 5},
  [3199] = {.lex_state = 39, .external_lex_state = 5},
  [3200] = {.lex_state = 39, .external_lex_state = 2},
  [3201] = {.lex_state = 39, .external_lex_state = 2},
  [3202] = {.lex_state = 39, .external_lex_state = 5},
  [3203] = {.lex_state = 29, .external_lex_state = 3},
  [3204] = {.lex_state = 39, .external_lex_state = 5},
  [3205] = {.lex_state = 29, .external_lex_state = 3},
  [3206] = {.lex_state = 29, .external_lex_state = 3},
  [3207] = {.lex_state = 29, .external_lex_state = 3},
  [3208] = {.lex_state = 39, .external_lex_state = 2},
  [3209] = {.lex_state = 29, .external_lex_state = 3},
  [3210] = {.lex_state = 29, .external_lex_state = 3},
  [3211] = {.lex_state = 39, .external_lex_state = 5},
  [3212] = {.lex_state = 29, .external_lex_state = 3},
  [3213] = {.lex_state = 29, .external_lex_state = 3},
  [3214] = {.lex_state = 29, .external_lex_state = 3},
  [3215] = {.lex_state = 29, .external_lex_state = 3},
  [3216] = {.lex_state = 29, .external_lex_state = 3},
  [3217] = {.lex_state = 29, .external_lex_state = 3},
  [3218] = {.lex_state = 39, .external_lex_state = 2},
  [3219] = {.lex_state = 29, .external_lex_state = 3},
  [3220] = {.lex_state = 39, .external_lex_state = 5},
  [3221] = {.lex_state = 32, .external_lex_state = 3},
  [3222] = {.lex_state = 39, .external_lex_state = 2},
  [3223] = {.lex_state = 39, .external_lex_state = 5},
  [3224] = {.lex_state = 29, .external_lex_state = 3},
  [3225] = {.lex_state = 39, .external_lex_state = 5},
  [3226] = {.lex_state = 29, .external_lex_state = 3},
  [3227] = {.lex_state = 39, .external_lex_state = 5},
  [3228] = {.lex_state = 29, .external_lex_state = 3},
  [3229] = {.lex_state = 29, .external_lex_state = 3},
  [3230] = {.lex_state = 39, .external_lex_state = 5},
  [3231] = {.lex_state = 29, .external_lex_state = 3},
  [3232] = {.lex_state = 39, .external_lex_state = 5},
  [3233] = {.lex_state = 39, .external_lex_state = 5},
  [3234] = {.lex_state = 39, .external_lex_state = 2},
  [3235] = {.lex_state = 29, .external_lex_state = 3},
  [3236] = {.lex_state = 39, .external_lex_state = 2},
  [3237] = {.lex_state = 29, .external_lex_state = 3},
  [3238] = {.lex_state = 39, .external_lex_state = 5},
  [3239] = {.lex_state = 29, .external_lex_state = 3},
  [3240] = {.lex_state = 39, .external_lex_state = 5},
  [3241] = {.lex_state = 29, .external_lex_state = 3},
  [3242] = {.lex_state = 29, .external_lex_state = 3},
  [3243] = {.lex_state = 29, .external_lex_state = 3},
  [3244] = {.lex_state = 39, .external_lex_state = 5},
  [3245] = {.lex_state = 29, .external_lex_state = 4},
  [3246] = {.lex_state = 29, .external_lex_state = 3},
  [3247] = {.lex_state = 39, .external_lex_state = 2},
  [3248] = {.lex_state = 29, .external_lex_state = 3},
  [3249] = {.lex_state = 39, .external_lex_state = 5},
  [3250] = {.lex_state = 39, .external_lex_state = 2},
  [3251] = {.lex_state = 39, .external_lex_state = 5},
  [3252] = {.lex_state = 39, .external_lex_state = 5},
  [3253] = {.lex_state = 29, .external_lex_state = 3},
  [3254] = {.lex_state = 29, .external_lex_state = 3},
  [3255] = {.lex_state = 29, .external_lex_state = 3},
  [3256] = {.lex_state = 29, .external_lex_state = 3},
  [3257] = {.lex_state = 39, .external_lex_state = 5},
  [3258] = {.lex_state = 29, .external_lex_state = 3},
  [3259] = {.lex_state = 29, .external_lex_state = 3},
  [3260] = {.lex_state = 29, .external_lex_state = 3},
  [3261] = {.lex_state = 29, .external_lex_state = 4},
  [3262] = {.lex_state = 29, .external_lex_state = 3},
  [3263] = {.lex_state = 39, .external_lex_state = 2},
  [3264] = {.lex_state = 29, .external_lex_state = 3},
  [3265] = {.lex_state = 39, .external_lex_state = 5},
  [3266] = {.lex_state = 38, .external_lex_state = 5},
  [3267] = {.lex_state = 39, .external_lex_state = 2},
  [3268] = {.lex_state = 39, .external_lex_state = 5},
  [3269] = {.lex_state = 39, .external_lex_state = 5},
  [3270] = {.lex_state = 29, .external_lex_state = 3},
  [3271] = {.lex_state = 29, .external_lex_state = 3},
  [3272] = {.lex_state = 29, .external_lex_state = 3},
  [3273] = {.lex_state = 29, .external_lex_state = 3},
  [3274] = {.lex_state = 39, .external_lex_state = 2},
  [3275] = {.lex_state = 29, .external_lex_state = 3},
  [3276] = {.lex_state = 39, .external_lex_state = 5},
  [3277] = {.lex_state = 29, .external_lex_state = 3},
  [3278] = {.lex_state = 38, .external_lex_state = 5},
  [3279] = {.lex_state = 38, .external_lex_state = 2},
  [3280] = {.lex_state = 29, .external_lex_state = 3},
  [3281] = {.lex_state = 29, .external_lex_state = 3},
  [3282] = {.lex_state = 29, .external_lex_state = 3},
  [3283] = {.lex_state = 29, .external_lex_state = 3},
  [3284] = {.lex_state = 39, .external_lex_state = 5},
  [3285] = {.lex_state = 29, .external_lex_state = 4},
  [3286] = {.lex_state = 29, .external_lex_state = 4},
  [3287] = {.lex_state = 29, .external_lex_state = 3},
  [3288] = {.lex_state = 29, .external_lex_state = 3},
  [3289] = {.lex_state = 39, .external_lex_state = 5},
  [3290] = {.lex_state = 29, .external_lex_state = 3},
  [3291] = {.lex_state = 38, .external_lex_state = 5},
  [3292] = {.lex_state = 29, .external_lex_state = 3},
  [3293] = {.lex_state = 39, .external_lex_state = 2},
  [3294] = {.lex_state = 38, .external_lex_state = 5},
  [3295] = {.lex_state = 39, .external_lex_state = 2},
  [3296] = {.lex_state = 39, .external_lex_state = 5},
  [3297] = {.lex_state = 38, .external_lex_state = 5},
  [3298] = {.lex_state = 29, .external_lex_state = 3},
  [3299] = {.lex_state = 39, .external_lex_state = 2},
  [3300] = {.lex_state = 29, .external_lex_state = 3},
  [3301] = {.lex_state = 29, .external_lex_state = 3},
  [3302] = {.lex_state = 39, .external_lex_state = 5},
  [3303] = {.lex_state = 29, .external_lex_state = 3},
  [3304] = {.lex_state = 38, .external_lex_state = 5},
  [3305] = {.lex_state = 29, .external_lex_state = 3},
  [3306] = {.lex_state = 39, .external_lex_state = 5},
  [3307] = {.lex_state = 39, .external_lex_state = 2},
  [3308] = {.lex_state = 29, .external_lex_state = 3},
  [3309] = {.lex_state = 39, .external_lex_state = 2},
  [3310] = {.lex_state = 39, .external_lex_state = 2},
  [3311] = {.lex_state = 39, .external_lex_state = 2},
  [3312] = {.lex_state = 39, .external_lex_state = 2},
  [3313] = {.lex_state = 39, .external_lex_state = 2},
  [3314] = {.lex_state = 29, .external_lex_state = 3},
  [3315] = {.lex_state = 39, .external_lex_state = 5},
  [3316] = {.lex_state = 39, .external_lex_state = 2},
  [3317] = {.lex_state = 39, .external_lex_state = 5},
  [3318] = {.lex_state = 39, .external_lex_state = 5},
  [3319] = {.lex_state = 39, .external_lex_state = 2},
  [3320] = {.lex_state = 39, .external_lex_state = 2},
  [3321] = {.lex_state = 39, .external_lex_state = 5},
  [3322] = {.lex_state = 39, .external_lex_state = 2},
  [3323] = {.lex_state = 29, .external_lex_state = 3},
  [3324] = {.lex_state = 39, .external_lex_state = 2},
  [3325] = {.lex_state = 39, .external_lex_state = 2},
  [3326] = {.lex_state = 29, .external_lex_state = 3},
  [3327] = {.lex_state = 39, .external_lex_state = 2},
  [3328] = {.lex_state = 39, .external_lex_state = 5},
  [3329] = {.lex_state = 39, .external_lex_state = 5},
  [3330] = {.lex_state = 39, .external_lex_state = 2},
  [3331] = {.lex_state = 29, .external_lex_state = 3},
  [3332] = {.lex_state = 39, .external_lex_state = 5},
  [3333] = {.lex_state = 29, .external_lex_state = 3},
  [3334] = {.lex_state = 39, .external_lex_state = 2},
  [3335] = {.lex_state = 39, .external_lex_state = 2},
  [3336] = {.lex_state = 39, .external_lex_state = 2},
  [3337] = {.lex_state = 39, .external_lex_state = 5},
  [3338] = {.lex_state = 39, .external_lex_state = 5},
  [3339] = {.lex_state = 29, .external_lex_state = 3},
  [3340] = {.lex_state = 39, .external_lex_state = 5},
  [3341] = {.lex_state = 39, .external_lex_state = 5},
  [3342] = {.lex_state = 30, .external_lex_state = 3},
  [3343] = {.lex_state = 39, .external_lex_state = 5},
  [3344] = {.lex_state = 39, .external_lex_state = 5},
  [3345] = {.lex_state = 39, .external_lex_state = 5},
  [3346] = {.lex_state = 39, .external_lex_state = 5},
  [3347] = {.lex_state = 39, .external_lex_state = 2},
  [3348] = {.lex_state = 39, .external_lex_state = 5},
  [3349] = {.lex_state = 29, .external_lex_state = 3},
  [3350] = {.lex_state = 29, .external_lex_state = 3},
  [3351] = {.lex_state = 29, .external_lex_state = 3},
  [3352] = {.lex_state = 29, .external_lex_state = 3},
  [3353] = {.lex_state = 39, .external_lex_state = 2},
  [3354] = {.lex_state = 29, .external_lex_state = 3},
  [3355] = {.lex_state = 29, .external_lex_state = 3},
  [3356] = {.lex_state = 29, .external_lex_state = 3},
  [3357] = {.lex_state = 29, .external_lex_state = 3},
  [3358] = {.lex_state = 29, .external_lex_state = 3},
  [3359] = {.lex_state = 38, .external_lex_state = 5},
  [3360] = {.lex_state = 38, .external_lex_state = 5},
  [3361] = {.lex_state = 38, .external_lex_state = 5},
  [3362] = {.lex_state = 38, .external_lex_state = 5},
  [3363] = {.lex_state = 38, .external_lex_state = 5},
  [3364] = {.lex_state = 38, .external_lex_state = 5},
  [3365] = {.lex_state = 38, .external_lex_state = 5},
  [3366] = {.lex_state = 38, .external_lex_state = 5},
  [3367] = {.lex_state = 38, .external_lex_state = 5},
  [3368] = {.lex_state = 38, .external_lex_state = 5},
  [3369] = {.lex_state = 38, .external_lex_state = 5},
  [3370] = {.lex_state = 38, .external_lex_state = 5},
  [3371] = {.lex_state = 38, .external_lex_state = 5},
  [3372] = {.lex_state = 39, .external_lex_state = 2},
  [3373] = {.lex_state = 38, .external_lex_state = 5},
  [3374] = {.lex_state = 38, .external_lex_state = 5},
  [3375] = {.lex_state = 38, .external_lex_state = 5},
  [3376] = {.lex_state = 38, .external_lex_state = 5},
  [3377] = {.lex_state = 38, .external_lex_state = 5},
  [3378] = {.lex_state = 38, .external_lex_state = 5},
  [3379] = {.lex_state = 38, .external_lex_state = 5},
  [3380] = {.lex_state = 39, .external_lex_state = 2},
  [3381] = {.lex_state = 38, .external_lex_state = 5},
  [3382] = {.lex_state = 38, .external_lex_state = 5},
  [3383] = {.lex_state = 38, .external_lex_state = 5},
  [3384] = {.lex_state = 38, .external_lex_state = 5},
  [3385] = {.lex_state = 38, .external_lex_state = 5},
  [3386] = {.lex_state = 38, .external_lex_state = 5},
  [3387] = {.lex_state = 38, .external_lex_state = 5},
  [3388] = {.lex_state = 38, .external_lex_state = 5},
  [3389] = {.lex_state = 39, .external_lex_state = 2},
  [3390] = {.lex_state = 38, .external_lex_state = 5},
  [3391] = {.lex_state = 38, .external_lex_state = 5},
  [3392] = {.lex_state = 39, .external_lex_state = 2},
  [3393] = {.lex_state = 38, .external_lex_state = 5},
  [3394] = {.lex_state = 38, .external_lex_state = 5},
  [3395] = {.lex_state = 39, .external_lex_state = 2},
  [3396] = {.lex_state = 38, .external_lex_state = 5},
  [3397] = {.lex_state = 38, .external_lex_state = 5},
  [3398] = {.lex_state = 38, .external_lex_state = 5},
  [3399] = {.lex_state = 38, .external_lex_state = 5},
  [3400] = {.lex_state = 38, .external_lex_state = 5},
  [3401] = {.lex_state = 38, .external_lex_state = 5},
  [3402] = {.lex_state = 38, .external_lex_state = 5},
  [3403] = {.lex_state = 38, .external_lex_state = 5},
  [3404] = {.lex_state = 38, .external_lex_state = 5},
  [3405] = {.lex_state = 38, .external_lex_state = 5},
  [3406] = {.lex_state = 38, .external_lex_state = 5},
  [3407] = {.lex_state = 38, .external_lex_state = 5},
  [3408] = {.lex_state = 38, .external_lex_state = 5},
  [3409] = {.lex_state = 38, .external_lex_state = 5},
  [3410] = {.lex_state = 38, .external_lex_state = 5},
  [3411] = {.lex_state = 38, .external_lex_state = 5},
  [3412] = {.lex_state = 38, .external_lex_state = 5},
  [3413] = {.lex_state = 38, .external_lex_state = 5},
  [3414] = {.lex_state = 38, .external_lex_state = 5},
  [3415] = {.lex_state = 38, .external_lex_state = 5},
  [3416] = {.lex_state = 39, .external_lex_state = 2},
  [3417] = {.lex_state = 39, .external_lex_state = 2},
  [3418] = {.lex_state = 38, .external_lex_state = 2},
  [3419] = {.lex_state = 38, .external_lex_state = 2},
  [3420] = {.lex_state = 38, .external_lex_state = 2},
  [3421] = {.lex_state = 39, .external_lex_state = 2},
  [3422] = {.lex_state = 39, .external_lex_state = 2},
  [3423] = {.lex_state = 38, .external_lex_state = 2},
  [3424] = {.lex_state = 38, .external_lex_state = 2},
  [3425] = {.lex_state = 38, .external_lex_state = 2},
  [3426] = {.lex_state = 39, .external_lex_state = 2},
  [3427] = {.lex_state = 39, .external_lex_state = 2},
  [3428] = {.lex_state = 39, .external_lex_state = 2},
  [3429] = {.lex_state = 38, .external_lex_state = 2},
  [3430] = {.lex_state = 39, .external_lex_state = 2},
  [3431] = {.lex_state = 38, .external_lex_state = 2},
  [3432] = {.lex_state = 39, .external_lex_state = 2},
  [3433] = {.lex_state = 39, .external_lex_state = 2},
  [3434] = {.lex_state = 39, .external_lex_state = 2},
  [3435] = {.lex_state = 39, .external_lex_state = 2},
  [3436] = {.lex_state = 38, .external_lex_state = 2},
  [3437] = {.lex_state = 39, .external_lex_state = 2},
  [3438] = {.lex_state = 39, .external_lex_state = 2},
  [3439] = {.lex_state = 39, .external_lex_state = 2},
  [3440] = {.lex_state = 39, .external_lex_state = 2},
  [3441] = {.lex_state = 39, .external_lex_state = 2},
  [3442] = {.lex_state = 39, .external_lex_state = 2},
  [3443] = {.lex_state = 39, .external_lex_state = 2},
  [3444] = {.lex_state = 38, .external_lex_state = 2},
  [3445] = {.lex_state = 39, .external_lex_state = 2},
  [3446] = {.lex_state = 39, .external_lex_state = 2},
  [3447] = {.lex_state = 39, .external_lex_state = 2},
  [3448] = {.lex_state = 39, .external_lex_state = 2},
  [3449] = {.lex_state = 39, .external_lex_state = 2},
  [3450] = {.lex_state = 39, .external_lex_state = 2},
  [3451] = {.lex_state = 39, .external_lex_state = 2},
  [3452] = {.lex_state = 39, .external_lex_state = 2},
  [3453] = {.lex_state = 39, .external_lex_state = 2},
  [3454] = {.lex_state = 39, .external_lex_state = 2},
  [3455] = {.lex_state = 39, .external_lex_state = 2},
  [3456] = {.lex_state = 39, .external_lex_state = 2},
  [3457] = {.lex_state = 39, .external_lex_state = 2},
  [3458] = {.lex_state = 39, .external_lex_state = 2},
  [3459] = {.lex_state = 39, .external_lex_state = 2},
  [3460] = {.lex_state = 39, .external_lex_state = 2},
  [3461] = {.lex_state = 39, .external_lex_state = 2},
  [3462] = {.lex_state = 39, .external_lex_state = 2},
  [3463] = {.lex_state = 38, .external_lex_state = 2},
  [3464] = {.lex_state = 39, .external_lex_state = 2},
  [3465] = {.lex_state = 39, .external_lex_state = 2},
  [3466] = {.lex_state = 39, .external_lex_state = 2},
  [3467] = {.lex_state = 39, .external_lex_state = 2},
  [3468] = {.lex_state = 39, .external_lex_state = 2},
  [3469] = {.lex_state = 39, .external_lex_state = 2},
  [3470] = {.lex_state = 39, .external_lex_state = 2},
  [3471] = {.lex_state = 39, .external_lex_state = 2},
  [3472] = {.lex_state = 406, .external_lex_state = 2},
  [3473] = {.lex_state = 39, .external_lex_state = 2},
  [3474] = {.lex_state = 39, .external_lex_state = 2},
  [3475] = {.lex_state = 406, .external_lex_state = 2},
  [3476] = {.lex_state = 406, .external_lex_state = 2},
  [3477] = {.lex_state = 39, .external_lex_state = 2},
  [3478] = {.lex_state = 406, .external_lex_state = 2},
  [3479] = {.lex_state = 39, .external_lex_state = 2},
  [3480] = {.lex_state = 38, .external_lex_state = 2},
  [3481] = {.lex_state = 39, .external_lex_state = 2},
  [3482] = {.lex_state = 39, .external_lex_state = 2},
  [3483] = {.lex_state = 39, .external_lex_state = 2},
  [3484] = {.lex_state = 406, .external_lex_state = 2},
  [3485] = {.lex_state = 39, .external_lex_state = 2},
  [3486] = {.lex_state = 406, .external_lex_state = 2},
  [3487] = {.lex_state = 39, .external_lex_state = 2},
  [3488] = {.lex_state = 39, .external_lex_state = 2},
  [3489] = {.lex_state = 38, .external_lex_state = 2},
  [3490] = {.lex_state = 406, .external_lex_state = 2},
  [3491] = {.lex_state = 406, .external_lex_state = 2},
  [3492] = {.lex_state = 39, .external_lex_state = 2},
  [3493] = {.lex_state = 39, .external_lex_state = 2},
  [3494] = {.lex_state = 38, .external_lex_state = 2},
  [3495] = {.lex_state = 39, .external_lex_state = 2},
  [3496] = {.lex_state = 38, .external_lex_state = 2},
  [3497] = {.lex_state = 39, .external_lex_state = 2},
  [3498] = {.lex_state = 39, .external_lex_state = 2},
  [3499] = {.lex_state = 406, .external_lex_state = 2},
  [3500] = {.lex_state = 39, .external_lex_state = 2},
  [3501] = {.lex_state = 39, .external_lex_state = 2},
  [3502] = {.lex_state = 39, .external_lex_state = 2},
  [3503] = {.lex_state = 39, .external_lex_state = 2},
  [3504] = {.lex_state = 406, .external_lex_state = 2},
  [3505] = {.lex_state = 39, .external_lex_state = 2},
  [3506] = {.lex_state = 406, .external_lex_state = 2},
  [3507] = {.lex_state = 39, .external_lex_state = 2},
  [3508] = {.lex_state = 39, .external_lex_state = 2},
  [3509] = {.lex_state = 39, .external_lex_state = 2},
  [3510] = {.lex_state = 406, .external_lex_state = 2},
  [3511] = {.lex_state = 39, .external_lex_state = 2},
  [3512] = {.lex_state = 39, .external_lex_state = 2},
  [3513] = {.lex_state = 39, .external_lex_state = 2},
  [3514] = {.lex_state = 39, .external_lex_state = 2},
  [3515] = {.lex_state = 39, .external_lex_state = 2},
  [3516] = {.lex_state = 39, .external_lex_state = 2},
  [3517] = {.lex_state = 39, .external_lex_state = 2},
  [3518] = {.lex_state = 39, .external_lex_state = 2},
  [3519] = {.lex_state = 39, .external_lex_state = 2},
  [3520] = {.lex_state = 39, .external_lex_state = 2},
  [3521] = {.lex_state = 39, .external_lex_state = 2},
  [3522] = {.lex_state = 39, .external_lex_state = 2},
  [3523] = {.lex_state = 39, .external_lex_state = 2},
  [3524] = {.lex_state = 39, .external_lex_state = 2},
  [3525] = {.lex_state = 39, .external_lex_state = 2},
  [3526] = {.lex_state = 39, .external_lex_state = 2},
  [3527] = {.lex_state = 39, .external_lex_state = 2},
  [3528] = {.lex_state = 39, .external_lex_state = 2},
  [3529] = {.lex_state = 39, .external_lex_state = 2},
  [3530] = {.lex_state = 39, .external_lex_state = 2},
  [3531] = {.lex_state = 39, .external_lex_state = 2},
  [3532] = {.lex_state = 39, .external_lex_state = 2},
  [3533] = {.lex_state = 39, .external_lex_state = 2},
  [3534] = {.lex_state = 39, .external_lex_state = 2},
  [3535] = {.lex_state = 39, .external_lex_state = 2},
  [3536] = {.lex_state = 39, .external_lex_state = 2},
  [3537] = {.lex_state = 39, .external_lex_state = 2},
  [3538] = {.lex_state = 39, .external_lex_state = 2},
  [3539] = {.lex_state = 39, .external_lex_state = 2},
  [3540] = {.lex_state = 39, .external_lex_state = 2},
  [3541] = {.lex_state = 39, .external_lex_state = 2},
  [3542] = {.lex_state = 39, .external_lex_state = 2},
  [3543] = {.lex_state = 38, .external_lex_state = 2},
  [3544] = {.lex_state = 39, .external_lex_state = 2},
  [3545] = {.lex_state = 38, .external_lex_state = 2},
  [3546] = {.lex_state = 39, .external_lex_state = 2},
  [3547] = {.lex_state = 39, .external_lex_state = 2},
  [3548] = {.lex_state = 39, .external_lex_state = 2},
  [3549] = {.lex_state = 39, .external_lex_state = 2},
  [3550] = {.lex_state = 39, .external_lex_state = 2},
  [3551] = {.lex_state = 38, .external_lex_state = 2},
  [3552] = {.lex_state = 39, .external_lex_state = 2},
  [3553] = {.lex_state = 39, .external_lex_state = 2},
  [3554] = {.lex_state = 39, .external_lex_state = 2},
  [3555] = {.lex_state = 39, .external_lex_state = 2},
  [3556] = {.lex_state = 39, .external_lex_state = 2},
  [3557] = {.lex_state = 38, .external_lex_state = 2},
  [3558] = {.lex_state = 39, .external_lex_state = 2},
  [3559] = {.lex_state = 39, .external_lex_state = 2},
  [3560] = {.lex_state = 39, .external_lex_state = 2},
  [3561] = {.lex_state = 39, .external_lex_state = 2},
  [3562] = {.lex_state = 39, .external_lex_state = 2},
  [3563] = {.lex_state = 39, .external_lex_state = 2},
  [3564] = {.lex_state = 39, .external_lex_state = 2},
  [3565] = {.lex_state = 39, .external_lex_state = 2},
  [3566] = {.lex_state = 39, .external_lex_state = 2},
  [3567] = {.lex_state = 39, .external_lex_state = 2},
  [3568] = {.lex_state = 39, .external_lex_state = 2},
  [3569] = {.lex_state = 39, .external_lex_state = 2},
  [3570] = {.lex_state = 39, .external_lex_state = 2},
  [3571] = {.lex_state = 39, .external_lex_state = 2},
  [3572] = {.lex_state = 39, .external_lex_state = 2},
  [3573] = {.lex_state = 39, .external_lex_state = 2},
  [3574] = {.lex_state = 39, .external_lex_state = 2},
  [3575] = {.lex_state = 39, .external_lex_state = 2},
  [3576] = {.lex_state = 39, .external_lex_state = 2},
  [3577] = {.lex_state = 39, .external_lex_state = 2},
  [3578] = {.lex_state = 39, .external_lex_state = 2},
  [3579] = {.lex_state = 39, .external_lex_state = 2},
  [3580] = {.lex_state = 39, .external_lex_state = 2},
  [3581] = {.lex_state = 39, .external_lex_state = 2},
  [3582] = {.lex_state = 39, .external_lex_state = 2},
  [3583] = {.lex_state = 39, .external_lex_state = 2},
  [3584] = {.lex_state = 39, .external_lex_state = 2},
  [3585] = {.lex_state = 39, .external_lex_state = 2},
  [3586] = {.lex_state = 39, .external_lex_state = 2},
  [3587] = {.lex_state = 39, .external_lex_state = 2},
  [3588] = {.lex_state = 39, .external_lex_state = 2},
  [3589] = {.lex_state = 39, .external_lex_state = 2},
  [3590] = {.lex_state = 39, .external_lex_state = 2},
  [3591] = {.lex_state = 39, .external_lex_state = 2},
  [3592] = {.lex_state = 39, .external_lex_state = 2},
  [3593] = {.lex_state = 39, .external_lex_state = 2},
  [3594] = {.lex_state = 38, .external_lex_state = 2},
  [3595] = {.lex_state = 38, .external_lex_state = 2},
  [3596] = {.lex_state = 86, .external_lex_state = 2},
  [3597] = {.lex_state = 49, .external_lex_state = 2},
  [3598] = {.lex_state = 49, .external_lex_state = 2},
  [3599] = {.lex_state = 49, .external_lex_state = 2},
  [3600] = {.lex_state = 49, .external_lex_state = 2},
  [3601] = {.lex_state = 49, .external_lex_state = 2},
  [3602] = {.lex_state = 49, .external_lex_state = 2},
  [3603] = {.lex_state = 63, .external_lex_state = 2},
  [3604] = {.lex_state = 63, .external_lex_state = 2},
  [3605] = {.lex_state = 49, .external_lex_state = 2},
  [3606] = {.lex_state = 49, .external_lex_state = 2},
  [3607] = {.lex_state = 49, .external_lex_state = 2},
  [3608] = {.lex_state = 63, .external_lex_state = 2},
  [3609] = {.lex_state = 49, .external_lex_state = 2},
  [3610] = {.lex_state = 49, .external_lex_state = 2},
  [3611] = {.lex_state = 49, .external_lex_state = 2},
  [3612] = {.lex_state = 49, .external_lex_state = 2},
  [3613] = {.lex_state = 49, .external_lex_state = 2},
  [3614] = {.lex_state = 49, .external_lex_state = 2},
  [3615] = {.lex_state = 49, .external_lex_state = 2},
  [3616] = {.lex_state = 49, .external_lex_state = 2},
  [3617] = {.lex_state = 49, .external_lex_state = 2},
  [3618] = {.lex_state = 49, .external_lex_state = 2},
  [3619] = {.lex_state = 49, .external_lex_state = 2},
  [3620] = {.lex_state = 49, .external_lex_state = 2},
  [3621] = {.lex_state = 49, .external_lex_state = 2},
  [3622] = {.lex_state = 49, .external_lex_state = 2},
  [3623] = {.lex_state = 49, .external_lex_state = 2},
  [3624] = {.lex_state = 49, .external_lex_state = 2},
  [3625] = {.lex_state = 49, .external_lex_state = 2},
  [3626] = {.lex_state = 49, .external_lex_state = 2},
  [3627] = {.lex_state = 49, .external_lex_state = 2},
  [3628] = {.lex_state = 49, .external_lex_state = 2},
  [3629] = {.lex_state = 49, .external_lex_state = 2},
  [3630] = {.lex_state = 49, .external_lex_state = 2},
  [3631] = {.lex_state = 49, .external_lex_state = 2},
  [3632] = {.lex_state = 49, .external_lex_state = 2},
  [3633] = {.lex_state = 49, .external_lex_state = 2},
  [3634] = {.lex_state = 49, .external_lex_state = 2},
  [3635] = {.lex_state = 49, .external_lex_state = 2},
  [3636] = {.lex_state = 49, .external_lex_state = 2},
  [3637] = {.lex_state = 49, .external_lex_state = 2},
  [3638] = {.lex_state = 49, .external_lex_state = 2},
  [3639] = {.lex_state = 49, .external_lex_state = 2},
  [3640] = {.lex_state = 55, .external_lex_state = 2},
  [3641] = {.lex_state = 55, .external_lex_state = 2},
  [3642] = {.lex_state = 64, .external_lex_state = 2},
  [3643] = {.lex_state = 55, .external_lex_state = 2},
  [3644] = {.lex_state = 63, .external_lex_state = 2},
  [3645] = {.lex_state = 55, .external_lex_state = 2},
  [3646] = {.lex_state = 55, .external_lex_state = 2},
  [3647] = {.lex_state = 64, .external_lex_state = 2},
  [3648] = {.lex_state = 49, .external_lex_state = 5},
  [3649] = {.lex_state = 49, .external_lex_state = 2},
  [3650] = {.lex_state = 63, .external_lex_state = 2},
  [3651] = {.lex_state = 63, .external_lex_state = 2},
  [3652] = {.lex_state = 63, .external_lex_state = 2},
  [3653] = {.lex_state = 63, .external_lex_state = 2},
  [3654] = {.lex_state = 63, .external_lex_state = 2},
  [3655] = {.lex_state = 63, .external_lex_state = 2},
  [3656] = {.lex_state = 49, .external_lex_state = 2},
  [3657] = {.lex_state = 63, .external_lex_state = 2},
  [3658] = {.lex_state = 63, .external_lex_state = 2},
  [3659] = {.lex_state = 49, .external_lex_state = 2},
  [3660] = {.lex_state = 48, .external_lex_state = 5},
  [3661] = {.lex_state = 63, .external_lex_state = 2},
  [3662] = {.lex_state = 63, .external_lex_state = 2},
  [3663] = {.lex_state = 63, .external_lex_state = 2},
  [3664] = {.lex_state = 63, .external_lex_state = 2},
  [3665] = {.lex_state = 49, .external_lex_state = 5},
  [3666] = {.lex_state = 49, .external_lex_state = 2},
  [3667] = {.lex_state = 63, .external_lex_state = 2},
  [3668] = {.lex_state = 63, .external_lex_state = 2},
  [3669] = {.lex_state = 63, .external_lex_state = 2},
  [3670] = {.lex_state = 63, .external_lex_state = 2},
  [3671] = {.lex_state = 63, .external_lex_state = 2},
  [3672] = {.lex_state = 49, .external_lex_state = 5},
  [3673] = {.lex_state = 63, .external_lex_state = 2},
  [3674] = {.lex_state = 48, .external_lex_state = 5},
  [3675] = {.lex_state = 63, .external_lex_state = 2},
  [3676] = {.lex_state = 63, .external_lex_state = 2},
  [3677] = {.lex_state = 63, .external_lex_state = 2},
  [3678] = {.lex_state = 63, .external_lex_state = 2},
  [3679] = {.lex_state = 63, .external_lex_state = 2},
  [3680] = {.lex_state = 63, .external_lex_state = 2},
  [3681] = {.lex_state = 63, .external_lex_state = 2},
  [3682] = {.lex_state = 49, .external_lex_state = 5},
  [3683] = {.lex_state = 63, .external_lex_state = 2},
  [3684] = {.lex_state = 63, .external_lex_state = 2},
  [3685] = {.lex_state = 63, .external_lex_state = 2},
  [3686] = {.lex_state = 49, .external_lex_state = 6},
  [3687] = {.lex_state = 49, .external_lex_state = 6},
  [3688] = {.lex_state = 63, .external_lex_state = 2},
  [3689] = {.lex_state = 63, .external_lex_state = 2},
  [3690] = {.lex_state = 63, .external_lex_state = 2},
  [3691] = {.lex_state = 406, .external_lex_state = 2},
  [3692] = {.lex_state = 63, .external_lex_state = 2},
  [3693] = {.lex_state = 63, .external_lex_state = 2},
  [3694] = {.lex_state = 406, .external_lex_state = 2},
  [3695] = {.lex_state = 406, .external_lex_state = 2},
  [3696] = {.lex_state = 406, .external_lex_state = 2},
  [3697] = {.lex_state = 406, .external_lex_state = 2},
  [3698] = {.lex_state = 406, .external_lex_state = 2},
  [3699] = {.lex_state = 63, .external_lex_state = 2},
  [3700] = {.lex_state = 406, .external_lex_state = 2},
  [3701] = {.lex_state = 63, .external_lex_state = 2},
  [3702] = {.lex_state = 406, .external_lex_state = 2},
  [3703] = {.lex_state = 406, .external_lex_state = 2},
  [3704] = {.lex_state = 406, .external_lex_state = 2},
  [3705] = {.lex_state = 63, .external_lex_state = 2},
  [3706] = {.lex_state = 406, .external_lex_state = 2},
  [3707] = {.lex_state = 49, .external_lex_state = 6},
  [3708] = {.lex_state = 63, .external_lex_state = 2},
  [3709] = {.lex_state = 406, .external_lex_state = 2},
  [3710] = {.lex_state = 63, .external_lex_state = 2},
  [3711] = {.lex_state = 406, .external_lex_state = 2},
  [3712] = {.lex_state = 406, .external_lex_state = 2},
  [3713] = {.lex_state = 63, .external_lex_state = 2},
  [3714] = {.lex_state = 406, .external_lex_state = 2},
  [3715] = {.lex_state = 406, .external_lex_state = 2},
  [3716] = {.lex_state = 406, .external_lex_state = 2},
  [3717] = {.lex_state = 63, .external_lex_state = 2},
  [3718] = {.lex_state = 63, .external_lex_state = 2},
  [3719] = {.lex_state = 63, .external_lex_state = 2},
  [3720] = {.lex_state = 63, .external_lex_state = 2},
  [3721] = {.lex_state = 406, .external_lex_state = 2},
  [3722] = {.lex_state = 63, .external_lex_state = 2},
  [3723] = {.lex_state = 406, .external_lex_state = 2},
  [3724] = {.lex_state = 406, .external_lex_state = 2},
  [3725] = {.lex_state = 63, .external_lex_state = 2},
  [3726] = {.lex_state = 63, .external_lex_state = 2},
  [3727] = {.lex_state = 63, .external_lex_state = 2},
  [3728] = {.lex_state = 63, .external_lex_state = 2},
  [3729] = {.lex_state = 63, .external_lex_state = 2},
  [3730] = {.lex_state = 63, .external_lex_state = 2},
  [3731] = {.lex_state = 63, .external_lex_state = 2},
  [3732] = {.lex_state = 63, .external_lex_state = 2},
  [3733] = {.lex_state = 406, .external_lex_state = 2},
  [3734] = {.lex_state = 63, .external_lex_state = 2},
  [3735] = {.lex_state = 63, .external_lex_state = 2},
  [3736] = {.lex_state = 49, .external_lex_state = 5},
  [3737] = {.lex_state = 49, .external_lex_state = 5},
  [3738] = {.lex_state = 49, .external_lex_state = 5},
  [3739] = {.lex_state = 49, .external_lex_state = 5},
  [3740] = {.lex_state = 49, .external_lex_state = 5},
  [3741] = {.lex_state = 49, .external_lex_state = 5},
  [3742] = {.lex_state = 49, .external_lex_state = 5},
  [3743] = {.lex_state = 49, .external_lex_state = 5},
  [3744] = {.lex_state = 49, .external_lex_state = 5},
  [3745] = {.lex_state = 49, .external_lex_state = 5},
  [3746] = {.lex_state = 49, .external_lex_state = 5},
  [3747] = {.lex_state = 49, .external_lex_state = 5},
  [3748] = {.lex_state = 49, .external_lex_state = 5},
  [3749] = {.lex_state = 49, .external_lex_state = 5},
  [3750] = {.lex_state = 63, .external_lex_state = 2},
  [3751] = {.lex_state = 406, .external_lex_state = 2},
  [3752] = {.lex_state = 49, .external_lex_state = 5},
  [3753] = {.lex_state = 63, .external_lex_state = 2},
  [3754] = {.lex_state = 49, .external_lex_state = 5},
  [3755] = {.lex_state = 49, .external_lex_state = 5},
  [3756] = {.lex_state = 49, .external_lex_state = 5},
  [3757] = {.lex_state = 48, .external_lex_state = 5},
  [3758] = {.lex_state = 63, .external_lex_state = 2},
  [3759] = {.lex_state = 63, .external_lex_state = 2},
  [3760] = {.lex_state = 406, .external_lex_state = 2},
  [3761] = {.lex_state = 406, .external_lex_state = 2},
  [3762] = {.lex_state = 406, .external_lex_state = 2},
  [3763] = {.lex_state = 63, .external_lex_state = 2},
  [3764] = {.lex_state = 63, .external_lex_state = 2},
  [3765] = {.lex_state = 63, .external_lex_state = 2},
  [3766] = {.lex_state = 406, .external_lex_state = 2},
  [3767] = {.lex_state = 63, .external_lex_state = 2},
  [3768] = {.lex_state = 63, .external_lex_state = 2},
  [3769] = {.lex_state = 63, .external_lex_state = 2},
  [3770] = {.lex_state = 406, .external_lex_state = 2},
  [3771] = {.lex_state = 406, .external_lex_state = 2},
  [3772] = {.lex_state = 49, .external_lex_state = 5},
  [3773] = {.lex_state = 49, .external_lex_state = 5},
  [3774] = {.lex_state = 49, .external_lex_state = 5},
  [3775] = {.lex_state = 49, .external_lex_state = 5},
  [3776] = {.lex_state = 49, .external_lex_state = 5},
  [3777] = {.lex_state = 49, .external_lex_state = 5},
  [3778] = {.lex_state = 49, .external_lex_state = 5},
  [3779] = {.lex_state = 49, .external_lex_state = 5},
  [3780] = {.lex_state = 49, .external_lex_state = 5},
  [3781] = {.lex_state = 49, .external_lex_state = 5},
  [3782] = {.lex_state = 406, .external_lex_state = 2},
  [3783] = {.lex_state = 63, .external_lex_state = 2},
  [3784] = {.lex_state = 63, .external_lex_state = 2},
  [3785] = {.lex_state = 63, .external_lex_state = 2},
  [3786] = {.lex_state = 63, .external_lex_state = 2},
  [3787] = {.lex_state = 49, .external_lex_state = 5},
  [3788] = {.lex_state = 49, .external_lex_state = 5},
  [3789] = {.lex_state = 49, .external_lex_state = 5},
  [3790] = {.lex_state = 49, .external_lex_state = 5},
  [3791] = {.lex_state = 49, .external_lex_state = 5},
  [3792] = {.lex_state = 48, .external_lex_state = 5},
  [3793] = {.lex_state = 56, .external_lex_state = 2},
  [3794] = {.lex_state = 48, .external_lex_state = 5},
  [3795] = {.lex_state = 48, .external_lex_state = 5},
  [3796] = {.lex_state = 48, .external_lex_state = 5},
  [3797] = {.lex_state = 48, .external_lex_state = 5},
  [3798] = {.lex_state = 48, .external_lex_state = 5},
  [3799] = {.lex_state = 48, .external_lex_state = 5},
  [3800] = {.lex_state = 56, .external_lex_state = 2},
  [3801] = {.lex_state = 87, .external_lex_state = 2},
  [3802] = {.lex_state = 48, .external_lex_state = 5},
  [3803] = {.lex_state = 48, .external_lex_state = 5},
  [3804] = {.lex_state = 56, .external_lex_state = 2},
  [3805] = {.lex_state = 48, .external_lex_state = 5},
  [3806] = {.lex_state = 48, .external_lex_state = 5},
  [3807] = {.lex_state = 48, .external_lex_state = 5},
  [3808] = {.lex_state = 48, .external_lex_state = 5},
  [3809] = {.lex_state = 48, .external_lex_state = 5},
  [3810] = {.lex_state = 48, .external_lex_state = 5},
  [3811] = {.lex_state = 56, .external_lex_state = 2},
  [3812] = {.lex_state = 48, .external_lex_state = 5},
  [3813] = {.lex_state = 48, .external_lex_state = 5},
  [3814] = {.lex_state = 48, .external_lex_state = 5},
  [3815] = {.lex_state = 48, .external_lex_state = 5},
  [3816] = {.lex_state = 87, .external_lex_state = 2},
  [3817] = {.lex_state = 87, .external_lex_state = 2},
  [3818] = {.lex_state = 48, .external_lex_state = 5},
  [3819] = {.lex_state = 48, .external_lex_state = 5},
  [3820] = {.lex_state = 48, .external_lex_state = 2},
  [3821] = {.lex_state = 48, .external_lex_state = 5},
  [3822] = {.lex_state = 48, .external_lex_state = 5},
  [3823] = {.lex_state = 48, .external_lex_state = 5},
  [3824] = {.lex_state = 87, .external_lex_state = 2},
  [3825] = {.lex_state = 48, .external_lex_state = 5},
  [3826] = {.lex_state = 48, .external_lex_state = 5},
  [3827] = {.lex_state = 48, .external_lex_state = 5},
  [3828] = {.lex_state = 48, .external_lex_state = 5},
  [3829] = {.lex_state = 87, .external_lex_state = 2},
  [3830] = {.lex_state = 64, .external_lex_state = 2},
  [3831] = {.lex_state = 48, .external_lex_state = 5},
  [3832] = {.lex_state = 56, .external_lex_state = 2},
  [3833] = {.lex_state = 65, .external_lex_state = 2},
  [3834] = {.lex_state = 49, .external_lex_state = 6},
  [3835] = {.lex_state = 65, .external_lex_state = 2},
  [3836] = {.lex_state = 48, .external_lex_state = 5},
  [3837] = {.lex_state = 48, .external_lex_state = 5},
  [3838] = {.lex_state = 48, .external_lex_state = 5},
  [3839] = {.lex_state = 48, .external_lex_state = 5},
  [3840] = {.lex_state = 48, .external_lex_state = 5},
  [3841] = {.lex_state = 48, .external_lex_state = 5},
  [3842] = {.lex_state = 48, .external_lex_state = 5},
  [3843] = {.lex_state = 48, .external_lex_state = 5},
  [3844] = {.lex_state = 48, .external_lex_state = 5},
  [3845] = {.lex_state = 48, .external_lex_state = 5},
  [3846] = {.lex_state = 49, .external_lex_state = 5},
  [3847] = {.lex_state = 48, .external_lex_state = 5},
  [3848] = {.lex_state = 48, .external_lex_state = 5},
  [3849] = {.lex_state = 65, .external_lex_state = 2},
  [3850] = {.lex_state = 81, .external_lex_state = 2},
  [3851] = {.lex_state = 49, .external_lex_state = 6},
  [3852] = {.lex_state = 49, .external_lex_state = 6},
  [3853] = {.lex_state = 49, .external_lex_state = 5},
  [3854] = {.lex_state = 49, .external_lex_state = 6},
  [3855] = {.lex_state = 49, .external_lex_state = 6},
  [3856] = {.lex_state = 48, .external_lex_state = 5},
  [3857] = {.lex_state = 65, .external_lex_state = 2},
  [3858] = {.lex_state = 49, .external_lex_state = 6},
  [3859] = {.lex_state = 48, .external_lex_state = 6},
  [3860] = {.lex_state = 49, .external_lex_state = 6},
  [3861] = {.lex_state = 48, .external_lex_state = 5},
  [3862] = {.lex_state = 49, .external_lex_state = 6},
  [3863] = {.lex_state = 48, .external_lex_state = 5},
  [3864] = {.lex_state = 49, .external_lex_state = 6},
  [3865] = {.lex_state = 65, .external_lex_state = 2},
  [3866] = {.lex_state = 48, .external_lex_state = 5},
  [3867] = {.lex_state = 49, .external_lex_state = 6},
  [3868] = {.lex_state = 48, .external_lex_state = 5},
  [3869] = {.lex_state = 49, .external_lex_state = 6},
  [3870] = {.lex_state = 49, .external_lex_state = 6},
  [3871] = {.lex_state = 49, .external_lex_state = 6},
  [3872] = {.lex_state = 48, .external_lex_state = 5},
  [3873] = {.lex_state = 49, .external_lex_state = 6},
  [3874] = {.lex_state = 49, .external_lex_state = 5},
  [3875] = {.lex_state = 49, .external_lex_state = 6},
  [3876] = {.lex_state = 49, .external_lex_state = 6},
  [3877] = {.lex_state = 49, .external_lex_state = 5},
  [3878] = {.lex_state = 81, .external_lex_state = 2},
  [3879] = {.lex_state = 49, .external_lex_state = 5},
  [3880] = {.lex_state = 49, .external_lex_state = 6},
  [3881] = {.lex_state = 49, .external_lex_state = 6},
  [3882] = {.lex_state = 48, .external_lex_state = 5},
  [3883] = {.lex_state = 65, .external_lex_state = 2},
  [3884] = {.lex_state = 65, .external_lex_state = 2},
  [3885] = {.lex_state = 49, .external_lex_state = 6},
  [3886] = {.lex_state = 49, .external_lex_state = 6},
  [3887] = {.lex_state = 49, .external_lex_state = 6},
  [3888] = {.lex_state = 49, .external_lex_state = 6},
  [3889] = {.lex_state = 49, .external_lex_state = 6},
  [3890] = {.lex_state = 49, .external_lex_state = 6},
  [3891] = {.lex_state = 49, .external_lex_state = 6},
  [3892] = {.lex_state = 48, .external_lex_state = 5},
  [3893] = {.lex_state = 48, .external_lex_state = 5},
  [3894] = {.lex_state = 49, .external_lex_state = 6},
  [3895] = {.lex_state = 48, .external_lex_state = 5},
  [3896] = {.lex_state = 48, .external_lex_state = 5},
  [3897] = {.lex_state = 49, .external_lex_state = 6},
  [3898] = {.lex_state = 48, .external_lex_state = 5},
  [3899] = {.lex_state = 49, .external_lex_state = 5},
  [3900] = {.lex_state = 65, .external_lex_state = 2},
  [3901] = {.lex_state = 49, .external_lex_state = 6},
  [3902] = {.lex_state = 49, .external_lex_state = 6},
  [3903] = {.lex_state = 49, .external_lex_state = 6},
  [3904] = {.lex_state = 49, .external_lex_state = 5},
  [3905] = {.lex_state = 49, .external_lex_state = 6},
  [3906] = {.lex_state = 49, .external_lex_state = 6},
  [3907] = {.lex_state = 49, .external_lex_state = 6},
  [3908] = {.lex_state = 49, .external_lex_state = 6},
  [3909] = {.lex_state = 48, .external_lex_state = 5},
  [3910] = {.lex_state = 48, .external_lex_state = 5},
  [3911] = {.lex_state = 48, .external_lex_state = 5},
  [3912] = {.lex_state = 55, .external_lex_state = 2},
  [3913] = {.lex_state = 48, .external_lex_state = 5},
  [3914] = {.lex_state = 48, .external_lex_state = 5},
  [3915] = {.lex_state = 81, .external_lex_state = 2},
  [3916] = {.lex_state = 48, .external_lex_state = 5},
  [3917] = {.lex_state = 48, .external_lex_state = 5},
  [3918] = {.lex_state = 48, .external_lex_state = 5},
  [3919] = {.lex_state = 48, .external_lex_state = 5},
  [3920] = {.lex_state = 48, .external_lex_state = 5},
  [3921] = {.lex_state = 48, .external_lex_state = 5},
  [3922] = {.lex_state = 48, .external_lex_state = 5},
  [3923] = {.lex_state = 48, .external_lex_state = 5},
  [3924] = {.lex_state = 65, .external_lex_state = 2},
  [3925] = {.lex_state = 48, .external_lex_state = 5},
  [3926] = {.lex_state = 48, .external_lex_state = 5},
  [3927] = {.lex_state = 48, .external_lex_state = 5},
  [3928] = {.lex_state = 48, .external_lex_state = 5},
  [3929] = {.lex_state = 48, .external_lex_state = 5},
  [3930] = {.lex_state = 81, .external_lex_state = 2},
  [3931] = {.lex_state = 48, .external_lex_state = 5},
  [3932] = {.lex_state = 48, .external_lex_state = 5},
  [3933] = {.lex_state = 48, .external_lex_state = 5},
  [3934] = {.lex_state = 48, .external_lex_state = 5},
  [3935] = {.lex_state = 48, .external_lex_state = 5},
  [3936] = {.lex_state = 55, .external_lex_state = 2},
  [3937] = {.lex_state = 48, .external_lex_state = 5},
  [3938] = {.lex_state = 48, .external_lex_state = 5},
  [3939] = {.lex_state = 81, .external_lex_state = 2},
  [3940] = {.lex_state = 48, .external_lex_state = 5},
  [3941] = {.lex_state = 48, .external_lex_state = 5},
  [3942] = {.lex_state = 48, .external_lex_state = 6},
  [3943] = {.lex_state = 55, .external_lex_state = 2},
  [3944] = {.lex_state = 48, .external_lex_state = 5},
  [3945] = {.lex_state = 48, .external_lex_state = 5},
  [3946] = {.lex_state = 48, .external_lex_state = 5},
  [3947] = {.lex_state = 81, .external_lex_state = 2},
  [3948] = {.lex_state = 48, .external_lex_state = 5},
  [3949] = {.lex_state = 48, .external_lex_state = 5},
  [3950] = {.lex_state = 48, .external_lex_state = 5},
  [3951] = {.lex_state = 48, .external_lex_state = 5},
  [3952] = {.lex_state = 48, .external_lex_state = 5},
  [3953] = {.lex_state = 48, .external_lex_state = 5},
  [3954] = {.lex_state = 55, .external_lex_state = 2},
  [3955] = {.lex_state = 48, .external_lex_state = 5},
  [3956] = {.lex_state = 48, .external_lex_state = 5},
  [3957] = {.lex_state = 48, .external_lex_state = 5},
  [3958] = {.lex_state = 48, .external_lex_state = 5},
  [3959] = {.lex_state = 48, .external_lex_state = 5},
  [3960] = {.lex_state = 48, .external_lex_state = 5},
  [3961] = {.lex_state = 48, .external_lex_state = 5},
  [3962] = {.lex_state = 55, .external_lex_state = 2},
  [3963] = {.lex_state = 48, .external_lex_state = 2},
  [3964] = {.lex_state = 48, .external_lex_state = 5},
  [3965] = {.lex_state = 48, .external_lex_state = 5},
  [3966] = {.lex_state = 48, .external_lex_state = 5},
  [3967] = {.lex_state = 48, .external_lex_state = 5},
  [3968] = {.lex_state = 48, .external_lex_state = 5},
  [3969] = {.lex_state = 48, .external_lex_state = 5},
  [3970] = {.lex_state = 48, .external_lex_state = 5},
  [3971] = {.lex_state = 48, .external_lex_state = 5},
  [3972] = {.lex_state = 48, .external_lex_state = 5},
  [3973] = {.lex_state = 48, .external_lex_state = 5},
  [3974] = {.lex_state = 48, .external_lex_state = 5},
  [3975] = {.lex_state = 48, .external_lex_state = 5},
  [3976] = {.lex_state = 48, .external_lex_state = 5},
  [3977] = {.lex_state = 48, .external_lex_state = 5},
  [3978] = {.lex_state = 48, .external_lex_state = 5},
  [3979] = {.lex_state = 48, .external_lex_state = 5},
  [3980] = {.lex_state = 48, .external_lex_state = 5},
  [3981] = {.lex_state = 49, .external_lex_state = 6},
  [3982] = {.lex_state = 48, .external_lex_state = 5},
  [3983] = {.lex_state = 49, .external_lex_state = 6},
  [3984] = {.lex_state = 48, .external_lex_state = 5},
  [3985] = {.lex_state = 48, .external_lex_state = 5},
  [3986] = {.lex_state = 48, .external_lex_state = 5},
  [3987] = {.lex_state = 48, .external_lex_state = 6},
  [3988] = {.lex_state = 48, .external_lex_state = 5},
  [3989] = {.lex_state = 48, .external_lex_state = 5},
  [3990] = {.lex_state = 48, .external_lex_state = 5},
  [3991] = {.lex_state = 48, .external_lex_state = 5},
  [3992] = {.lex_state = 48, .external_lex_state = 5},
  [3993] = {.lex_state = 48, .external_lex_state = 5},
  [3994] = {.lex_state = 48, .external_lex_state = 5},
  [3995] = {.lex_state = 48, .external_lex_state = 5},
  [3996] = {.lex_state = 48, .external_lex_state = 5},
  [3997] = {.lex_state = 48, .external_lex_state = 5},
  [3998] = {.lex_state = 48, .external_lex_state = 5},
  [3999] = {.lex_state = 48, .external_lex_state = 5},
  [4000] = {.lex_state = 48, .external_lex_state = 5},
  [4001] = {.lex_state = 49, .external_lex_state = 6},
  [4002] = {.lex_state = 48, .external_lex_state = 6},
  [4003] = {.lex_state = 55, .external_lex_state = 2},
  [4004] = {.lex_state = 48, .external_lex_state = 6},
  [4005] = {.lex_state = 48, .external_lex_state = 5},
  [4006] = {.lex_state = 48, .external_lex_state = 5},
  [4007] = {.lex_state = 49, .external_lex_state = 6},
  [4008] = {.lex_state = 49, .external_lex_state = 6},
  [4009] = {.lex_state = 49, .external_lex_state = 6},
  [4010] = {.lex_state = 48, .external_lex_state = 5},
  [4011] = {.lex_state = 48, .external_lex_state = 5},
  [4012] = {.lex_state = 48, .external_lex_state = 5},
  [4013] = {.lex_state = 48, .external_lex_state = 5},
  [4014] = {.lex_state = 48, .external_lex_state = 5},
  [4015] = {.lex_state = 48, .external_lex_state = 5},
  [4016] = {.lex_state = 48, .external_lex_state = 5},
  [4017] = {.lex_state = 48, .external_lex_state = 5},
  [4018] = {.lex_state = 48, .external_lex_state = 5},
  [4019] = {.lex_state = 48, .external_lex_state = 5},
  [4020] = {.lex_state = 48, .external_lex_state = 5},
  [4021] = {.lex_state = 48, .external_lex_state = 5},
  [4022] = {.lex_state = 48, .external_lex_state = 5},
  [4023] = {.lex_state = 48, .external_lex_state = 5},
  [4024] = {.lex_state = 48, .external_lex_state = 5},
  [4025] = {.lex_state = 48, .external_lex_state = 5},
  [4026] = {.lex_state = 48, .external_lex_state = 5},
  [4027] = {.lex_state = 49, .external_lex_state = 6},
  [4028] = {.lex_state = 48, .external_lex_state = 5},
  [4029] = {.lex_state = 48, .external_lex_state = 5},
  [4030] = {.lex_state = 55, .external_lex_state = 2},
  [4031] = {.lex_state = 48, .external_lex_state = 2},
  [4032] = {.lex_state = 83, .external_lex_state = 2},
  [4033] = {.lex_state = 48, .external_lex_state = 6},
  [4034] = {.lex_state = 83, .external_lex_state = 2},
  [4035] = {.lex_state = 48, .external_lex_state = 5},
  [4036] = {.lex_state = 83, .external_lex_state = 2},
  [4037] = {.lex_state = 81, .external_lex_state = 2},
  [4038] = {.lex_state = 83, .external_lex_state = 2},
  [4039] = {.lex_state = 406, .external_lex_state = 5},
  [4040] = {.lex_state = 83, .external_lex_state = 2},
  [4041] = {.lex_state = 55, .external_lex_state = 2},
  [4042] = {.lex_state = 81, .external_lex_state = 2},
  [4043] = {.lex_state = 49, .external_lex_state = 5},
  [4044] = {.lex_state = 48, .external_lex_state = 6},
  [4045] = {.lex_state = 81, .external_lex_state = 2},
  [4046] = {.lex_state = 83, .external_lex_state = 2},
  [4047] = {.lex_state = 55, .external_lex_state = 2},
  [4048] = {.lex_state = 49, .external_lex_state = 5},
  [4049] = {.lex_state = 83, .external_lex_state = 2},
  [4050] = {.lex_state = 48, .external_lex_state = 6},
  [4051] = {.lex_state = 406, .external_lex_state = 5},
  [4052] = {.lex_state = 83, .external_lex_state = 2},
  [4053] = {.lex_state = 48, .external_lex_state = 6},
  [4054] = {.lex_state = 83, .external_lex_state = 2},
  [4055] = {.lex_state = 406, .external_lex_state = 5},
  [4056] = {.lex_state = 83, .external_lex_state = 2},
  [4057] = {.lex_state = 81, .external_lex_state = 2},
  [4058] = {.lex_state = 57, .external_lex_state = 2},
  [4059] = {.lex_state = 83, .external_lex_state = 2},
  [4060] = {.lex_state = 83, .external_lex_state = 2},
  [4061] = {.lex_state = 83, .external_lex_state = 2},
  [4062] = {.lex_state = 83, .external_lex_state = 2},
  [4063] = {.lex_state = 83, .external_lex_state = 2},
  [4064] = {.lex_state = 48, .external_lex_state = 5},
  [4065] = {.lex_state = 83, .external_lex_state = 2},
  [4066] = {.lex_state = 83, .external_lex_state = 2},
  [4067] = {.lex_state = 48, .external_lex_state = 6},
  [4068] = {.lex_state = 48, .external_lex_state = 5},
  [4069] = {.lex_state = 48, .external_lex_state = 6},
  [4070] = {.lex_state = 406, .external_lex_state = 5},
  [4071] = {.lex_state = 49, .external_lex_state = 5},
  [4072] = {.lex_state = 49, .external_lex_state = 5},
  [4073] = {.lex_state = 48, .external_lex_state = 2},
  [4074] = {.lex_state = 48, .external_lex_state = 2},
  [4075] = {.lex_state = 48, .external_lex_state = 2},
  [4076] = {.lex_state = 48, .external_lex_state = 5},
  [4077] = {.lex_state = 48, .external_lex_state = 5},
  [4078] = {.lex_state = 48, .external_lex_state = 6},
  [4079] = {.lex_state = 63, .external_lex_state = 2},
  [4080] = {.lex_state = 48, .external_lex_state = 2},
  [4081] = {.lex_state = 48, .external_lex_state = 2},
  [4082] = {.lex_state = 81, .external_lex_state = 2},
  [4083] = {.lex_state = 81, .external_lex_state = 2},
  [4084] = {.lex_state = 81, .external_lex_state = 2},
  [4085] = {.lex_state = 48, .external_lex_state = 5},
  [4086] = {.lex_state = 48, .external_lex_state = 2},
  [4087] = {.lex_state = 81, .external_lex_state = 2},
  [4088] = {.lex_state = 49, .external_lex_state = 2},
  [4089] = {.lex_state = 81, .external_lex_state = 2},
  [4090] = {.lex_state = 55, .external_lex_state = 2},
  [4091] = {.lex_state = 48, .external_lex_state = 6},
  [4092] = {.lex_state = 48, .external_lex_state = 5},
  [4093] = {.lex_state = 48, .external_lex_state = 6},
  [4094] = {.lex_state = 48, .external_lex_state = 5},
  [4095] = {.lex_state = 48, .external_lex_state = 6},
  [4096] = {.lex_state = 48, .external_lex_state = 2},
  [4097] = {.lex_state = 48, .external_lex_state = 6},
  [4098] = {.lex_state = 48, .external_lex_state = 2},
  [4099] = {.lex_state = 48, .external_lex_state = 6},
  [4100] = {.lex_state = 48, .external_lex_state = 6},
  [4101] = {.lex_state = 48, .external_lex_state = 2},
  [4102] = {.lex_state = 49, .external_lex_state = 2},
  [4103] = {.lex_state = 48, .external_lex_state = 6},
  [4104] = {.lex_state = 48, .external_lex_state = 2},
  [4105] = {.lex_state = 48, .external_lex_state = 6},
  [4106] = {.lex_state = 48, .external_lex_state = 2},
  [4107] = {.lex_state = 49, .external_lex_state = 2},
  [4108] = {.lex_state = 48, .external_lex_state = 2},
  [4109] = {.lex_state = 48, .external_lex_state = 5},
  [4110] = {.lex_state = 48, .external_lex_state = 6},
  [4111] = {.lex_state = 48, .external_lex_state = 2},
  [4112] = {.lex_state = 48, .external_lex_state = 6},
  [4113] = {.lex_state = 48, .external_lex_state = 6},
  [4114] = {.lex_state = 48, .external_lex_state = 2},
  [4115] = {.lex_state = 48, .external_lex_state = 6},
  [4116] = {.lex_state = 48, .external_lex_state = 2},
  [4117] = {.lex_state = 48, .external_lex_state = 5},
  [4118] = {.lex_state = 48, .external_lex_state = 6},
  [4119] = {.lex_state = 406, .external_lex_state = 5},
  [4120] = {.lex_state = 48, .external_lex_state = 2},
  [4121] = {.lex_state = 406, .external_lex_state = 5},
  [4122] = {.lex_state = 48, .external_lex_state = 5},
  [4123] = {.lex_state = 48, .external_lex_state = 2},
  [4124] = {.lex_state = 48, .external_lex_state = 6},
  [4125] = {.lex_state = 48, .external_lex_state = 5},
  [4126] = {.lex_state = 48, .external_lex_state = 5},
  [4127] = {.lex_state = 49, .external_lex_state = 2},
  [4128] = {.lex_state = 48, .external_lex_state = 6},
  [4129] = {.lex_state = 48, .external_lex_state = 6},
  [4130] = {.lex_state = 48, .external_lex_state = 2},
  [4131] = {.lex_state = 63, .external_lex_state = 2},
  [4132] = {.lex_state = 49, .external_lex_state = 2},
  [4133] = {.lex_state = 48, .external_lex_state = 6},
  [4134] = {.lex_state = 63, .external_lex_state = 2},
  [4135] = {.lex_state = 48, .external_lex_state = 6},
  [4136] = {.lex_state = 48, .external_lex_state = 2},
  [4137] = {.lex_state = 55, .external_lex_state = 2},
  [4138] = {.lex_state = 48, .external_lex_state = 6},
  [4139] = {.lex_state = 48, .external_lex_state = 2},
  [4140] = {.lex_state = 48, .external_lex_state = 2},
  [4141] = {.lex_state = 48, .external_lex_state = 2},
  [4142] = {.lex_state = 49, .external_lex_state = 2},
  [4143] = {.lex_state = 48, .external_lex_state = 5},
  [4144] = {.lex_state = 406, .external_lex_state = 5},
  [4145] = {.lex_state = 48, .external_lex_state = 2},
  [4146] = {.lex_state = 406, .external_lex_state = 5},
  [4147] = {.lex_state = 48, .external_lex_state = 5},
  [4148] = {.lex_state = 48, .external_lex_state = 2},
  [4149] = {.lex_state = 48, .external_lex_state = 5},
  [4150] = {.lex_state = 406, .external_lex_state = 2},
  [4151] = {.lex_state = 48, .external_lex_state = 2},
  [4152] = {.lex_state = 48, .external_lex_state = 2},
  [4153] = {.lex_state = 48, .external_lex_state = 2},
  [4154] = {.lex_state = 48, .external_lex_state = 2},
  [4155] = {.lex_state = 48, .external_lex_state = 2},
  [4156] = {.lex_state = 48, .external_lex_state = 2},
  [4157] = {.lex_state = 48, .external_lex_state = 6},
  [4158] = {.lex_state = 48, .external_lex_state = 5},
  [4159] = {.lex_state = 48, .external_lex_state = 5},
  [4160] = {.lex_state = 48, .external_lex_state = 5},
  [4161] = {.lex_state = 48, .external_lex_state = 5},
  [4162] = {.lex_state = 48, .external_lex_state = 6},
  [4163] = {.lex_state = 49, .external_lex_state = 2},
  [4164] = {.lex_state = 48, .external_lex_state = 5},
  [4165] = {.lex_state = 48, .external_lex_state = 2},
  [4166] = {.lex_state = 81, .external_lex_state = 2},
  [4167] = {.lex_state = 48, .external_lex_state = 2},
  [4168] = {.lex_state = 81, .external_lex_state = 2},
  [4169] = {.lex_state = 49, .external_lex_state = 2},
  [4170] = {.lex_state = 48, .external_lex_state = 5},
  [4171] = {.lex_state = 81, .external_lex_state = 2},
  [4172] = {.lex_state = 81, .external_lex_state = 2},
  [4173] = {.lex_state = 81, .external_lex_state = 2},
  [4174] = {.lex_state = 81, .external_lex_state = 2},
  [4175] = {.lex_state = 48, .external_lex_state = 2},
  [4176] = {.lex_state = 81, .external_lex_state = 2},
  [4177] = {.lex_state = 48, .external_lex_state = 2},
  [4178] = {.lex_state = 81, .external_lex_state = 2},
  [4179] = {.lex_state = 49, .external_lex_state = 2},
  [4180] = {.lex_state = 48, .external_lex_state = 6},
  [4181] = {.lex_state = 48, .external_lex_state = 2},
  [4182] = {.lex_state = 81, .external_lex_state = 2},
  [4183] = {.lex_state = 81, .external_lex_state = 2},
  [4184] = {.lex_state = 81, .external_lex_state = 2},
  [4185] = {.lex_state = 81, .external_lex_state = 2},
  [4186] = {.lex_state = 81, .external_lex_state = 2},
  [4187] = {.lex_state = 48, .external_lex_state = 6},
  [4188] = {.lex_state = 81, .external_lex_state = 2},
  [4189] = {.lex_state = 48, .external_lex_state = 5},
  [4190] = {.lex_state = 48, .external_lex_state = 5},
  [4191] = {.lex_state = 48, .external_lex_state = 5},
  [4192] = {.lex_state = 48, .external_lex_state = 6},
  [4193] = {.lex_state = 48, .external_lex_state = 2},
  [4194] = {.lex_state = 48, .external_lex_state = 5},
  [4195] = {.lex_state = 48, .external_lex_state = 2},
  [4196] = {.lex_state = 55, .external_lex_state = 2},
  [4197] = {.lex_state = 63, .external_lex_state = 2},
  [4198] = {.lex_state = 48, .external_lex_state = 5},
  [4199] = {.lex_state = 48, .external_lex_state = 6},
  [4200] = {.lex_state = 48, .external_lex_state = 6},
  [4201] = {.lex_state = 48, .external_lex_state = 5},
  [4202] = {.lex_state = 48, .external_lex_state = 5},
  [4203] = {.lex_state = 81, .external_lex_state = 2},
  [4204] = {.lex_state = 406, .external_lex_state = 5},
  [4205] = {.lex_state = 48, .external_lex_state = 6},
  [4206] = {.lex_state = 48, .external_lex_state = 2},
  [4207] = {.lex_state = 49, .external_lex_state = 2},
  [4208] = {.lex_state = 48, .external_lex_state = 6},
  [4209] = {.lex_state = 48, .external_lex_state = 6},
  [4210] = {.lex_state = 48, .external_lex_state = 5},
  [4211] = {.lex_state = 48, .external_lex_state = 2},
  [4212] = {.lex_state = 48, .external_lex_state = 2},
  [4213] = {.lex_state = 48, .external_lex_state = 2},
  [4214] = {.lex_state = 81, .external_lex_state = 2},
  [4215] = {.lex_state = 63, .external_lex_state = 2},
  [4216] = {.lex_state = 48, .external_lex_state = 5},
  [4217] = {.lex_state = 48, .external_lex_state = 2},
  [4218] = {.lex_state = 48, .external_lex_state = 5},
  [4219] = {.lex_state = 48, .external_lex_state = 5},
  [4220] = {.lex_state = 48, .external_lex_state = 5},
  [4221] = {.lex_state = 48, .external_lex_state = 5},
  [4222] = {.lex_state = 81, .external_lex_state = 2},
  [4223] = {.lex_state = 48, .external_lex_state = 2},
  [4224] = {.lex_state = 48, .external_lex_state = 5},
  [4225] = {.lex_state = 48, .external_lex_state = 5},
  [4226] = {.lex_state = 48, .external_lex_state = 5},
  [4227] = {.lex_state = 81, .external_lex_state = 2},
  [4228] = {.lex_state = 48, .external_lex_state = 6},
  [4229] = {.lex_state = 48, .external_lex_state = 6},
  [4230] = {.lex_state = 48, .external_lex_state = 2},
  [4231] = {.lex_state = 48, .external_lex_state = 6},
  [4232] = {.lex_state = 48, .external_lex_state = 6},
  [4233] = {.lex_state = 48, .external_lex_state = 5},
  [4234] = {.lex_state = 48, .external_lex_state = 2},
  [4235] = {.lex_state = 48, .external_lex_state = 6},
  [4236] = {.lex_state = 48, .external_lex_state = 5},
  [4237] = {.lex_state = 48, .external_lex_state = 6},
  [4238] = {.lex_state = 48, .external_lex_state = 2},
  [4239] = {.lex_state = 406, .external_lex_state = 6},
  [4240] = {.lex_state = 48, .external_lex_state = 6},
  [4241] = {.lex_state = 48, .external_lex_state = 6},
  [4242] = {.lex_state = 49, .external_lex_state = 2},
  [4243] = {.lex_state = 48, .external_lex_state = 6},
  [4244] = {.lex_state = 48, .external_lex_state = 6},
  [4245] = {.lex_state = 81, .external_lex_state = 2},
  [4246] = {.lex_state = 81, .external_lex_state = 2},
  [4247] = {.lex_state = 48, .external_lex_state = 6},
  [4248] = {.lex_state = 48, .external_lex_state = 2},
  [4249] = {.lex_state = 48, .external_lex_state = 6},
  [4250] = {.lex_state = 48, .external_lex_state = 2},
  [4251] = {.lex_state = 49, .external_lex_state = 2},
  [4252] = {.lex_state = 48, .external_lex_state = 6},
  [4253] = {.lex_state = 48, .external_lex_state = 6},
  [4254] = {.lex_state = 48, .external_lex_state = 2},
  [4255] = {.lex_state = 406, .external_lex_state = 6},
  [4256] = {.lex_state = 48, .external_lex_state = 6},
  [4257] = {.lex_state = 81, .external_lex_state = 2},
  [4258] = {.lex_state = 81, .external_lex_state = 2},
  [4259] = {.lex_state = 81, .external_lex_state = 2},
  [4260] = {.lex_state = 81, .external_lex_state = 2},
  [4261] = {.lex_state = 81, .external_lex_state = 2},
  [4262] = {.lex_state = 81, .external_lex_state = 2},
  [4263] = {.lex_state = 48, .external_lex_state = 6},
  [4264] = {.lex_state = 48, .external_lex_state = 2},
  [4265] = {.lex_state = 81, .external_lex_state = 2},
  [4266] = {.lex_state = 48, .external_lex_state = 6},
  [4267] = {.lex_state = 48, .external_lex_state = 6},
  [4268] = {.lex_state = 48, .external_lex_state = 2},
  [4269] = {.lex_state = 48, .external_lex_state = 2},
  [4270] = {.lex_state = 81, .external_lex_state = 2},
  [4271] = {.lex_state = 48, .external_lex_state = 6},
  [4272] = {.lex_state = 48, .external_lex_state = 2},
  [4273] = {.lex_state = 81, .external_lex_state = 2},
  [4274] = {.lex_state = 48, .external_lex_state = 6},
  [4275] = {.lex_state = 48, .external_lex_state = 6},
  [4276] = {.lex_state = 48, .external_lex_state = 2},
  [4277] = {.lex_state = 48, .external_lex_state = 6},
  [4278] = {.lex_state = 48, .external_lex_state = 6},
  [4279] = {.lex_state = 48, .external_lex_state = 6},
  [4280] = {.lex_state = 48, .external_lex_state = 6},
  [4281] = {.lex_state = 81, .external_lex_state = 2},
  [4282] = {.lex_state = 48, .external_lex_state = 5},
  [4283] = {.lex_state = 48, .external_lex_state = 5},
  [4284] = {.lex_state = 48, .external_lex_state = 6},
  [4285] = {.lex_state = 48, .external_lex_state = 5},
  [4286] = {.lex_state = 48, .external_lex_state = 6},
  [4287] = {.lex_state = 48, .external_lex_state = 2},
  [4288] = {.lex_state = 63, .external_lex_state = 2},
  [4289] = {.lex_state = 48, .external_lex_state = 5},
  [4290] = {.lex_state = 49, .external_lex_state = 2},
  [4291] = {.lex_state = 48, .external_lex_state = 2},
  [4292] = {.lex_state = 48, .external_lex_state = 2},
  [4293] = {.lex_state = 48, .external_lex_state = 6},
  [4294] = {.lex_state = 48, .external_lex_state = 6},
  [4295] = {.lex_state = 48, .external_lex_state = 5},
  [4296] = {.lex_state = 48, .external_lex_state = 5},
  [4297] = {.lex_state = 48, .external_lex_state = 6},
  [4298] = {.lex_state = 48, .external_lex_state = 6},
  [4299] = {.lex_state = 81, .external_lex_state = 2},
  [4300] = {.lex_state = 81, .external_lex_state = 2},
  [4301] = {.lex_state = 75, .external_lex_state = 2},
  [4302] = {.lex_state = 85, .external_lex_state = 2},
  [4303] = {.lex_state = 48, .external_lex_state = 5},
  [4304] = {.lex_state = 48, .external_lex_state = 5},
  [4305] = {.lex_state = 48, .external_lex_state = 5},
  [4306] = {.lex_state = 75, .external_lex_state = 2},
  [4307] = {.lex_state = 75, .external_lex_state = 2},
  [4308] = {.lex_state = 48, .external_lex_state = 5},
  [4309] = {.lex_state = 48, .external_lex_state = 6},
  [4310] = {.lex_state = 406, .external_lex_state = 6},
  [4311] = {.lex_state = 406, .external_lex_state = 7},
  [4312] = {.lex_state = 75, .external_lex_state = 2},
  [4313] = {.lex_state = 75, .external_lex_state = 2},
  [4314] = {.lex_state = 85, .external_lex_state = 2},
  [4315] = {.lex_state = 85, .external_lex_state = 2},
  [4316] = {.lex_state = 75, .external_lex_state = 2},
  [4317] = {.lex_state = 85, .external_lex_state = 2},
  [4318] = {.lex_state = 75, .external_lex_state = 2},
  [4319] = {.lex_state = 75, .external_lex_state = 2},
  [4320] = {.lex_state = 91, .external_lex_state = 2},
  [4321] = {.lex_state = 406, .external_lex_state = 7},
  [4322] = {.lex_state = 406, .external_lex_state = 5},
  [4323] = {.lex_state = 85, .external_lex_state = 2},
  [4324] = {.lex_state = 91, .external_lex_state = 2},
  [4325] = {.lex_state = 55, .external_lex_state = 2},
  [4326] = {.lex_state = 406, .external_lex_state = 7},
  [4327] = {.lex_state = 406, .external_lex_state = 7},
  [4328] = {.lex_state = 406, .external_lex_state = 7},
  [4329] = {.lex_state = 406, .external_lex_state = 5},
  [4330] = {.lex_state = 406, .external_lex_state = 5},
  [4331] = {.lex_state = 406, .external_lex_state = 5},
  [4332] = {.lex_state = 406, .external_lex_state = 5},
  [4333] = {.lex_state = 75, .external_lex_state = 2},
  [4334] = {.lex_state = 406, .external_lex_state = 7},
  [4335] = {.lex_state = 406, .external_lex_state = 7},
  [4336] = {.lex_state = 406, .external_lex_state = 7},
  [4337] = {.lex_state = 48, .external_lex_state = 2},
  [4338] = {.lex_state = 48, .external_lex_state = 2},
  [4339] = {.lex_state = 85, .external_lex_state = 2},
  [4340] = {.lex_state = 406, .external_lex_state = 5},
  [4341] = {.lex_state = 406, .external_lex_state = 2},
  [4342] = {.lex_state = 406, .external_lex_state = 5},
  [4343] = {.lex_state = 406, .external_lex_state = 5},
  [4344] = {.lex_state = 406, .external_lex_state = 2},
  [4345] = {.lex_state = 406, .external_lex_state = 5},
  [4346] = {.lex_state = 406, .external_lex_state = 2},
  [4347] = {.lex_state = 406, .external_lex_state = 2},
  [4348] = {.lex_state = 406, .external_lex_state = 2},
  [4349] = {.lex_state = 406, .external_lex_state = 5},
  [4350] = {.lex_state = 406, .external_lex_state = 5},
  [4351] = {.lex_state = 406, .external_lex_state = 2},
  [4352] = {.lex_state = 406, .external_lex_state = 2},
  [4353] = {.lex_state = 406, .external_lex_state = 5},
  [4354] = {.lex_state = 406, .external_lex_state = 5},
  [4355] = {.lex_state = 406, .external_lex_state = 5},
  [4356] = {.lex_state = 406, .external_lex_state = 5},
  [4357] = {.lex_state = 406, .external_lex_state = 5},
  [4358] = {.lex_state = 406, .external_lex_state = 5},
  [4359] = {.lex_state = 406, .external_lex_state = 5},
  [4360] = {.lex_state = 406, .external_lex_state = 5},
  [4361] = {.lex_state = 406, .external_lex_state = 5},
  [4362] = {.lex_state = 406, .external_lex_state = 5},
  [4363] = {.lex_state = 406, .external_lex_state = 2},
  [4364] = {.lex_state = 406, .external_lex_state = 5},
  [4365] = {.lex_state = 406, .external_lex_state = 5},
  [4366] = {.lex_state = 406, .external_lex_state = 5},
  [4367] = {.lex_state = 406, .external_lex_state = 5},
  [4368] = {.lex_state = 406, .external_lex_state = 5},
  [4369] = {.lex_state = 406, .external_lex_state = 5},
  [4370] = {.lex_state = 88, .external_lex_state = 2},
  [4371] = {.lex_state = 406, .external_lex_state = 5},
  [4372] = {.lex_state = 406, .external_lex_state = 2},
  [4373] = {.lex_state = 406, .external_lex_state = 5},
  [4374] = {.lex_state = 406, .external_lex_state = 5},
  [4375] = {.lex_state = 406, .external_lex_state = 5},
  [4376] = {.lex_state = 406, .external_lex_state = 5},
  [4377] = {.lex_state = 406, .external_lex_state = 5},
  [4378] = {.lex_state = 406, .external_lex_state = 5},
  [4379] = {.lex_state = 50, .external_lex_state = 2},
  [4380] = {.lex_state = 75, .external_lex_state = 2},
  [4381] = {.lex_state = 50, .external_lex_state = 2},
  [4382] = {.lex_state = 50, .external_lex_state = 2},
  [4383] = {.lex_state = 75, .external_lex_state = 2},
  [4384] = {.lex_state = 406, .external_lex_state = 5},
  [4385] = {.lex_state = 406, .external_lex_state = 2},
  [4386] = {.lex_state = 406, .external_lex_state = 5},
  [4387] = {.lex_state = 406, .external_lex_state = 5},
  [4388] = {.lex_state = 88, .external_lex_state = 2},
  [4389] = {.lex_state = 49, .external_lex_state = 5},
  [4390] = {.lex_state = 406, .external_lex_state = 2},
  [4391] = {.lex_state = 406, .external_lex_state = 5},
  [4392] = {.lex_state = 406, .external_lex_state = 2},
  [4393] = {.lex_state = 406, .external_lex_state = 5},
  [4394] = {.lex_state = 406, .external_lex_state = 2},
  [4395] = {.lex_state = 406, .external_lex_state = 2},
  [4396] = {.lex_state = 406, .external_lex_state = 2},
  [4397] = {.lex_state = 49, .external_lex_state = 5},
  [4398] = {.lex_state = 406, .external_lex_state = 5},
  [4399] = {.lex_state = 406, .external_lex_state = 2},
  [4400] = {.lex_state = 406, .external_lex_state = 5},
  [4401] = {.lex_state = 406, .external_lex_state = 5},
  [4402] = {.lex_state = 406, .external_lex_state = 5},
  [4403] = {.lex_state = 48, .external_lex_state = 2},
  [4404] = {.lex_state = 406, .external_lex_state = 5},
  [4405] = {.lex_state = 406, .external_lex_state = 5},
  [4406] = {.lex_state = 406, .external_lex_state = 5},
  [4407] = {.lex_state = 406, .external_lex_state = 5},
  [4408] = {.lex_state = 49, .external_lex_state = 5},
  [4409] = {.lex_state = 50, .external_lex_state = 2},
  [4410] = {.lex_state = 406, .external_lex_state = 5},
  [4411] = {.lex_state = 75, .external_lex_state = 2},
  [4412] = {.lex_state = 406, .external_lex_state = 2},
  [4413] = {.lex_state = 88, .external_lex_state = 2},
  [4414] = {.lex_state = 406, .external_lex_state = 5},
  [4415] = {.lex_state = 406, .external_lex_state = 2},
  [4416] = {.lex_state = 406, .external_lex_state = 5},
  [4417] = {.lex_state = 406, .external_lex_state = 5},
  [4418] = {.lex_state = 406, .external_lex_state = 2},
  [4419] = {.lex_state = 81, .external_lex_state = 2},
  [4420] = {.lex_state = 406, .external_lex_state = 2},
  [4421] = {.lex_state = 406, .external_lex_state = 2},
  [4422] = {.lex_state = 406, .external_lex_state = 2},
  [4423] = {.lex_state = 406, .external_lex_state = 5},
  [4424] = {.lex_state = 406, .external_lex_state = 5},
  [4425] = {.lex_state = 406, .external_lex_state = 5},
  [4426] = {.lex_state = 406, .external_lex_state = 5},
  [4427] = {.lex_state = 406, .external_lex_state = 5},
  [4428] = {.lex_state = 406, .external_lex_state = 5},
  [4429] = {.lex_state = 406, .external_lex_state = 5},
  [4430] = {.lex_state = 406, .external_lex_state = 5},
  [4431] = {.lex_state = 406, .external_lex_state = 5},
  [4432] = {.lex_state = 406, .external_lex_state = 5},
  [4433] = {.lex_state = 406, .external_lex_state = 5},
  [4434] = {.lex_state = 406, .external_lex_state = 2},
  [4435] = {.lex_state = 406, .external_lex_state = 5},
  [4436] = {.lex_state = 406, .external_lex_state = 5},
  [4437] = {.lex_state = 81, .external_lex_state = 2},
  [4438] = {.lex_state = 49, .external_lex_state = 5},
  [4439] = {.lex_state = 406, .external_lex_state = 5},
  [4440] = {.lex_state = 406, .external_lex_state = 5},
  [4441] = {.lex_state = 49, .external_lex_state = 5},
  [4442] = {.lex_state = 50, .external_lex_state = 2},
  [4443] = {.lex_state = 406, .external_lex_state = 5},
  [4444] = {.lex_state = 406, .external_lex_state = 5},
  [4445] = {.lex_state = 75, .external_lex_state = 2},
  [4446] = {.lex_state = 406, .external_lex_state = 5},
  [4447] = {.lex_state = 406, .external_lex_state = 5},
  [4448] = {.lex_state = 406, .external_lex_state = 2},
  [4449] = {.lex_state = 406, .external_lex_state = 5},
  [4450] = {.lex_state = 406, .external_lex_state = 5},
  [4451] = {.lex_state = 88, .external_lex_state = 2},
  [4452] = {.lex_state = 406, .external_lex_state = 2},
  [4453] = {.lex_state = 406, .external_lex_state = 5},
  [4454] = {.lex_state = 49, .external_lex_state = 5},
  [4455] = {.lex_state = 406, .external_lex_state = 5},
  [4456] = {.lex_state = 406, .external_lex_state = 2},
  [4457] = {.lex_state = 406, .external_lex_state = 5},
  [4458] = {.lex_state = 406, .external_lex_state = 2},
  [4459] = {.lex_state = 406, .external_lex_state = 2},
  [4460] = {.lex_state = 406, .external_lex_state = 5},
  [4461] = {.lex_state = 406, .external_lex_state = 2},
  [4462] = {.lex_state = 406, .external_lex_state = 5},
  [4463] = {.lex_state = 406, .external_lex_state = 5},
  [4464] = {.lex_state = 50, .external_lex_state = 2},
  [4465] = {.lex_state = 406, .external_lex_state = 5},
  [4466] = {.lex_state = 75, .external_lex_state = 2},
  [4467] = {.lex_state = 406, .external_lex_state = 2},
  [4468] = {.lex_state = 406, .external_lex_state = 2},
  [4469] = {.lex_state = 406, .external_lex_state = 2},
  [4470] = {.lex_state = 406, .external_lex_state = 2},
  [4471] = {.lex_state = 406, .external_lex_state = 2},
  [4472] = {.lex_state = 406, .external_lex_state = 2},
  [4473] = {.lex_state = 406, .external_lex_state = 5},
  [4474] = {.lex_state = 406, .external_lex_state = 5},
  [4475] = {.lex_state = 406, .external_lex_state = 2},
  [4476] = {.lex_state = 406, .external_lex_state = 2},
  [4477] = {.lex_state = 406, .external_lex_state = 2},
  [4478] = {.lex_state = 48, .external_lex_state = 2},
  [4479] = {.lex_state = 406, .external_lex_state = 5},
  [4480] = {.lex_state = 406, .external_lex_state = 5},
  [4481] = {.lex_state = 406, .external_lex_state = 2},
  [4482] = {.lex_state = 406, .external_lex_state = 2},
  [4483] = {.lex_state = 406, .external_lex_state = 5},
  [4484] = {.lex_state = 75, .external_lex_state = 2},
  [4485] = {.lex_state = 50, .external_lex_state = 2},
  [4486] = {.lex_state = 406, .external_lex_state = 5},
  [4487] = {.lex_state = 406, .external_lex_state = 5},
  [4488] = {.lex_state = 406, .external_lex_state = 5},
  [4489] = {.lex_state = 50, .external_lex_state = 2},
  [4490] = {.lex_state = 50, .external_lex_state = 2},
  [4491] = {.lex_state = 406, .external_lex_state = 5},
  [4492] = {.lex_state = 50, .external_lex_state = 2},
  [4493] = {.lex_state = 406, .external_lex_state = 5},
  [4494] = {.lex_state = 406, .external_lex_state = 5},
  [4495] = {.lex_state = 406, .external_lex_state = 5},
  [4496] = {.lex_state = 406, .external_lex_state = 5},
  [4497] = {.lex_state = 406, .external_lex_state = 5},
  [4498] = {.lex_state = 406, .external_lex_state = 5},
  [4499] = {.lex_state = 406, .external_lex_state = 2},
  [4500] = {.lex_state = 406, .external_lex_state = 5},
  [4501] = {.lex_state = 50, .external_lex_state = 2},
  [4502] = {.lex_state = 49, .external_lex_state = 5},
  [4503] = {.lex_state = 406, .external_lex_state = 2},
  [4504] = {.lex_state = 48, .external_lex_state = 2},
  [4505] = {.lex_state = 406, .external_lex_state = 2},
  [4506] = {.lex_state = 406, .external_lex_state = 2},
  [4507] = {.lex_state = 406, .external_lex_state = 2},
  [4508] = {.lex_state = 50, .external_lex_state = 2},
  [4509] = {.lex_state = 406, .external_lex_state = 5},
  [4510] = {.lex_state = 406, .external_lex_state = 5},
  [4511] = {.lex_state = 406, .external_lex_state = 5},
  [4512] = {.lex_state = 406, .external_lex_state = 5},
  [4513] = {.lex_state = 406, .external_lex_state = 5},
  [4514] = {.lex_state = 406, .external_lex_state = 5},
  [4515] = {.lex_state = 406, .external_lex_state = 5},
  [4516] = {.lex_state = 406, .external_lex_state = 5},
  [4517] = {.lex_state = 81, .external_lex_state = 2},
  [4518] = {.lex_state = 50, .external_lex_state = 2},
  [4519] = {.lex_state = 48, .external_lex_state = 2},
  [4520] = {.lex_state = 88, .external_lex_state = 2},
  [4521] = {.lex_state = 406, .external_lex_state = 2},
  [4522] = {.lex_state = 48, .external_lex_state = 2},
  [4523] = {.lex_state = 50, .external_lex_state = 2},
  [4524] = {.lex_state = 50, .external_lex_state = 2},
  [4525] = {.lex_state = 50, .external_lex_state = 2},
  [4526] = {.lex_state = 49, .external_lex_state = 5},
  [4527] = {.lex_state = 49, .external_lex_state = 5},
  [4528] = {.lex_state = 50, .external_lex_state = 2},
  [4529] = {.lex_state = 406, .external_lex_state = 5},
  [4530] = {.lex_state = 406, .external_lex_state = 5},
  [4531] = {.lex_state = 406, .external_lex_state = 5},
  [4532] = {.lex_state = 406, .external_lex_state = 5},
  [4533] = {.lex_state = 50, .external_lex_state = 2},
  [4534] = {.lex_state = 406, .external_lex_state = 5},
  [4535] = {.lex_state = 55, .external_lex_state = 2},
  [4536] = {.lex_state = 50, .external_lex_state = 2},
  [4537] = {.lex_state = 50, .external_lex_state = 2},
  [4538] = {.lex_state = 50, .external_lex_state = 2},
  [4539] = {.lex_state = 48, .external_lex_state = 2},
  [4540] = {.lex_state = 50, .external_lex_state = 2},
  [4541] = {.lex_state = 406, .external_lex_state = 5},
  [4542] = {.lex_state = 406, .external_lex_state = 5},
  [4543] = {.lex_state = 406, .external_lex_state = 5},
  [4544] = {.lex_state = 406, .external_lex_state = 5},
  [4545] = {.lex_state = 50, .external_lex_state = 2},
  [4546] = {.lex_state = 406, .external_lex_state = 5},
  [4547] = {.lex_state = 406, .external_lex_state = 5},
  [4548] = {.lex_state = 406, .external_lex_state = 5},
  [4549] = {.lex_state = 50, .external_lex_state = 2},
  [4550] = {.lex_state = 406, .external_lex_state = 5},
  [4551] = {.lex_state = 406, .external_lex_state = 5},
  [4552] = {.lex_state = 406, .external_lex_state = 5},
  [4553] = {.lex_state = 406, .external_lex_state = 5},
  [4554] = {.lex_state = 48, .external_lex_state = 2},
  [4555] = {.lex_state = 406, .external_lex_state = 5},
  [4556] = {.lex_state = 406, .external_lex_state = 5},
  [4557] = {.lex_state = 406, .external_lex_state = 5},
  [4558] = {.lex_state = 406, .external_lex_state = 5},
  [4559] = {.lex_state = 50, .external_lex_state = 2},
  [4560] = {.lex_state = 406, .external_lex_state = 5},
  [4561] = {.lex_state = 406, .external_lex_state = 5},
  [4562] = {.lex_state = 50, .external_lex_state = 2},
  [4563] = {.lex_state = 48, .external_lex_state = 2},
  [4564] = {.lex_state = 75, .external_lex_state = 2},
  [4565] = {.lex_state = 50, .external_lex_state = 2},
  [4566] = {.lex_state = 406, .external_lex_state = 2},
  [4567] = {.lex_state = 406, .external_lex_state = 5},
  [4568] = {.lex_state = 406, .external_lex_state = 5},
  [4569] = {.lex_state = 50, .external_lex_state = 2},
  [4570] = {.lex_state = 406, .external_lex_state = 2},
  [4571] = {.lex_state = 48, .external_lex_state = 2},
  [4572] = {.lex_state = 48, .external_lex_state = 2},
  [4573] = {.lex_state = 48, .external_lex_state = 2},
  [4574] = {.lex_state = 406, .external_lex_state = 5},
  [4575] = {.lex_state = 406, .external_lex_state = 5},
  [4576] = {.lex_state = 406, .external_lex_state = 5},
  [4577] = {.lex_state = 406, .external_lex_state = 5},
  [4578] = {.lex_state = 406, .external_lex_state = 5},
  [4579] = {.lex_state = 50, .external_lex_state = 2},
  [4580] = {.lex_state = 406, .external_lex_state = 5},
  [4581] = {.lex_state = 406, .external_lex_state = 5},
  [4582] = {.lex_state = 48, .external_lex_state = 2},
  [4583] = {.lex_state = 48, .external_lex_state = 2},
  [4584] = {.lex_state = 50, .external_lex_state = 2},
  [4585] = {.lex_state = 50, .external_lex_state = 2},
  [4586] = {.lex_state = 50, .external_lex_state = 2},
  [4587] = {.lex_state = 50, .external_lex_state = 2},
  [4588] = {.lex_state = 406, .external_lex_state = 5},
  [4589] = {.lex_state = 50, .external_lex_state = 2},
  [4590] = {.lex_state = 50, .external_lex_state = 2},
  [4591] = {.lex_state = 50, .external_lex_state = 2},
  [4592] = {.lex_state = 406, .external_lex_state = 5},
  [4593] = {.lex_state = 406, .external_lex_state = 5},
  [4594] = {.lex_state = 406, .external_lex_state = 5},
  [4595] = {.lex_state = 406, .external_lex_state = 6},
  [4596] = {.lex_state = 406, .external_lex_state = 5},
  [4597] = {.lex_state = 406, .external_lex_state = 5},
  [4598] = {.lex_state = 406, .external_lex_state = 5},
  [4599] = {.lex_state = 406, .external_lex_state = 6},
  [4600] = {.lex_state = 406, .external_lex_state = 6},
  [4601] = {.lex_state = 406, .external_lex_state = 6},
  [4602] = {.lex_state = 406, .external_lex_state = 5},
  [4603] = {.lex_state = 406, .external_lex_state = 5},
  [4604] = {.lex_state = 406, .external_lex_state = 5},
  [4605] = {.lex_state = 406, .external_lex_state = 5},
  [4606] = {.lex_state = 406, .external_lex_state = 6},
  [4607] = {.lex_state = 406, .external_lex_state = 6},
  [4608] = {.lex_state = 50, .external_lex_state = 2},
  [4609] = {.lex_state = 50, .external_lex_state = 2},
  [4610] = {.lex_state = 406, .external_lex_state = 5},
  [4611] = {.lex_state = 406, .external_lex_state = 5},
  [4612] = {.lex_state = 50, .external_lex_state = 2},
  [4613] = {.lex_state = 406, .external_lex_state = 5},
  [4614] = {.lex_state = 406, .external_lex_state = 6},
  [4615] = {.lex_state = 50, .external_lex_state = 2},
  [4616] = {.lex_state = 406, .external_lex_state = 2},
  [4617] = {.lex_state = 50, .external_lex_state = 2},
  [4618] = {.lex_state = 48, .external_lex_state = 2},
  [4619] = {.lex_state = 406, .external_lex_state = 5},
  [4620] = {.lex_state = 50, .external_lex_state = 2},
  [4621] = {.lex_state = 48, .external_lex_state = 2},
  [4622] = {.lex_state = 48, .external_lex_state = 2},
  [4623] = {.lex_state = 50, .external_lex_state = 2},
  [4624] = {.lex_state = 406, .external_lex_state = 2},
  [4625] = {.lex_state = 50, .external_lex_state = 2},
  [4626] = {.lex_state = 50, .external_lex_state = 2},
  [4627] = {.lex_state = 50, .external_lex_state = 2},
  [4628] = {.lex_state = 406, .external_lex_state = 5},
  [4629] = {.lex_state = 406, .external_lex_state = 2},
  [4630] = {.lex_state = 406, .external_lex_state = 5},
  [4631] = {.lex_state = 406, .external_lex_state = 2},
  [4632] = {.lex_state = 406, .external_lex_state = 5},
  [4633] = {.lex_state = 406, .external_lex_state = 5},
  [4634] = {.lex_state = 406, .external_lex_state = 2},
  [4635] = {.lex_state = 50, .external_lex_state = 2},
  [4636] = {.lex_state = 406, .external_lex_state = 5},
  [4637] = {.lex_state = 50, .external_lex_state = 2},
  [4638] = {.lex_state = 406, .external_lex_state = 6},
  [4639] = {.lex_state = 50, .external_lex_state = 2},
  [4640] = {.lex_state = 65, .external_lex_state = 2},
  [4641] = {.lex_state = 48, .external_lex_state = 2},
  [4642] = {.lex_state = 75, .external_lex_state = 2},
  [4643] = {.lex_state = 406, .external_lex_state = 6},
  [4644] = {.lex_state = 50, .external_lex_state = 2},
  [4645] = {.lex_state = 65, .external_lex_state = 2},
  [4646] = {.lex_state = 406, .external_lex_state = 6},
  [4647] = {.lex_state = 50, .external_lex_state = 2},
  [4648] = {.lex_state = 406, .external_lex_state = 6},
  [4649] = {.lex_state = 50, .external_lex_state = 2},
  [4650] = {.lex_state = 50, .external_lex_state = 2},
  [4651] = {.lex_state = 48, .external_lex_state = 2},
  [4652] = {.lex_state = 406, .external_lex_state = 6},
  [4653] = {.lex_state = 48, .external_lex_state = 2},
  [4654] = {.lex_state = 406, .external_lex_state = 6},
  [4655] = {.lex_state = 50, .external_lex_state = 2},
  [4656] = {.lex_state = 50, .external_lex_state = 2},
  [4657] = {.lex_state = 406, .external_lex_state = 6},
  [4658] = {.lex_state = 406, .external_lex_state = 6},
  [4659] = {.lex_state = 406, .external_lex_state = 7},
  [4660] = {.lex_state = 50, .external_lex_state = 2},
  [4661] = {.lex_state = 65, .external_lex_state = 2},
  [4662] = {.lex_state = 48, .external_lex_state = 2},
  [4663] = {.lex_state = 406, .external_lex_state = 2},
  [4664] = {.lex_state = 65, .external_lex_state = 2},
  [4665] = {.lex_state = 406, .external_lex_state = 6},
  [4666] = {.lex_state = 406, .external_lex_state = 6},
  [4667] = {.lex_state = 406, .external_lex_state = 6},
  [4668] = {.lex_state = 65, .external_lex_state = 2},
  [4669] = {.lex_state = 406, .external_lex_state = 6},
  [4670] = {.lex_state = 48, .external_lex_state = 2},
  [4671] = {.lex_state = 48, .external_lex_state = 2},
  [4672] = {.lex_state = 50, .external_lex_state = 2},
  [4673] = {.lex_state = 48, .external_lex_state = 2},
  [4674] = {.lex_state = 50, .external_lex_state = 2},
  [4675] = {.lex_state = 48, .external_lex_state = 2},
  [4676] = {.lex_state = 50, .external_lex_state = 2},
  [4677] = {.lex_state = 65, .external_lex_state = 2},
  [4678] = {.lex_state = 406, .external_lex_state = 2},
  [4679] = {.lex_state = 406, .external_lex_state = 5},
  [4680] = {.lex_state = 406, .external_lex_state = 5},
  [4681] = {.lex_state = 406, .external_lex_state = 5},
  [4682] = {.lex_state = 406, .external_lex_state = 6},
  [4683] = {.lex_state = 406, .external_lex_state = 2},
  [4684] = {.lex_state = 406, .external_lex_state = 2},
  [4685] = {.lex_state = 50, .external_lex_state = 2},
  [4686] = {.lex_state = 406, .external_lex_state = 2},
  [4687] = {.lex_state = 65, .external_lex_state = 2},
  [4688] = {.lex_state = 406, .external_lex_state = 5},
  [4689] = {.lex_state = 65, .external_lex_state = 2},
  [4690] = {.lex_state = 48, .external_lex_state = 2},
  [4691] = {.lex_state = 406, .external_lex_state = 2},
  [4692] = {.lex_state = 48, .external_lex_state = 2},
  [4693] = {.lex_state = 50, .external_lex_state = 2},
  [4694] = {.lex_state = 65, .external_lex_state = 2},
  [4695] = {.lex_state = 65, .external_lex_state = 2},
  [4696] = {.lex_state = 48, .external_lex_state = 2},
  [4697] = {.lex_state = 50, .external_lex_state = 2},
  [4698] = {.lex_state = 65, .external_lex_state = 2},
  [4699] = {.lex_state = 50, .external_lex_state = 2},
  [4700] = {.lex_state = 406, .external_lex_state = 5},
  [4701] = {.lex_state = 48, .external_lex_state = 2},
  [4702] = {.lex_state = 48, .external_lex_state = 2},
  [4703] = {.lex_state = 406, .external_lex_state = 2},
  [4704] = {.lex_state = 406, .external_lex_state = 5},
  [4705] = {.lex_state = 406, .external_lex_state = 5},
  [4706] = {.lex_state = 406, .external_lex_state = 6},
  [4707] = {.lex_state = 48, .external_lex_state = 2},
  [4708] = {.lex_state = 48, .external_lex_state = 2},
  [4709] = {.lex_state = 406, .external_lex_state = 5},
  [4710] = {.lex_state = 406, .external_lex_state = 6},
  [4711] = {.lex_state = 406, .external_lex_state = 5},
  [4712] = {.lex_state = 406, .external_lex_state = 5},
  [4713] = {.lex_state = 406, .external_lex_state = 5},
  [4714] = {.lex_state = 406, .external_lex_state = 6},
  [4715] = {.lex_state = 48, .external_lex_state = 2},
  [4716] = {.lex_state = 406, .external_lex_state = 2},
  [4717] = {.lex_state = 65, .external_lex_state = 2},
  [4718] = {.lex_state = 406, .external_lex_state = 5},
  [4719] = {.lex_state = 406, .external_lex_state = 5},
  [4720] = {.lex_state = 48, .external_lex_state = 2},
  [4721] = {.lex_state = 65, .external_lex_state = 2},
  [4722] = {.lex_state = 406, .external_lex_state = 5},
  [4723] = {.lex_state = 65, .external_lex_state = 2},
  [4724] = {.lex_state = 406, .external_lex_state = 5},
  [4725] = {.lex_state = 406, .external_lex_state = 5},
  [4726] = {.lex_state = 48, .external_lex_state = 2},
  [4727] = {.lex_state = 50, .external_lex_state = 2},
  [4728] = {.lex_state = 65, .external_lex_state = 2},
  [4729] = {.lex_state = 406, .external_lex_state = 6},
  [4730] = {.lex_state = 50, .external_lex_state = 2},
  [4731] = {.lex_state = 48, .external_lex_state = 2},
  [4732] = {.lex_state = 50, .external_lex_state = 2},
  [4733] = {.lex_state = 406, .external_lex_state = 6},
  [4734] = {.lex_state = 65, .external_lex_state = 2},
  [4735] = {.lex_state = 406, .external_lex_state = 5},
  [4736] = {.lex_state = 48, .external_lex_state = 2},
  [4737] = {.lex_state = 406, .external_lex_state = 2},
  [4738] = {.lex_state = 48, .external_lex_state = 2},
  [4739] = {.lex_state = 48, .external_lex_state = 2},
  [4740] = {.lex_state = 406, .external_lex_state = 5},
  [4741] = {.lex_state = 406, .external_lex_state = 7},
  [4742] = {.lex_state = 406, .external_lex_state = 5},
  [4743] = {.lex_state = 406, .external_lex_state = 5},
  [4744] = {.lex_state = 406, .external_lex_state = 2},
  [4745] = {.lex_state = 406, .external_lex_state = 5},
  [4746] = {.lex_state = 50, .external_lex_state = 2},
  [4747] = {.lex_state = 50, .external_lex_state = 2},
  [4748] = {.lex_state = 406, .external_lex_state = 6},
  [4749] = {.lex_state = 48, .external_lex_state = 2},
  [4750] = {.lex_state = 48, .external_lex_state = 2},
  [4751] = {.lex_state = 406, .external_lex_state = 5},
  [4752] = {.lex_state = 48, .external_lex_state = 2},
  [4753] = {.lex_state = 65, .external_lex_state = 2},
  [4754] = {.lex_state = 48, .external_lex_state = 2},
  [4755] = {.lex_state = 65, .external_lex_state = 2},
  [4756] = {.lex_state = 48, .external_lex_state = 2},
  [4757] = {.lex_state = 406, .external_lex_state = 5},
  [4758] = {.lex_state = 48, .external_lex_state = 2},
  [4759] = {.lex_state = 406, .external_lex_state = 6},
  [4760] = {.lex_state = 406, .external_lex_state = 5},
  [4761] = {.lex_state = 406, .external_lex_state = 6},
  [4762] = {.lex_state = 65, .external_lex_state = 2},
  [4763] = {.lex_state = 65, .external_lex_state = 2},
  [4764] = {.lex_state = 406, .external_lex_state = 5},
  [4765] = {.lex_state = 406, .external_lex_state = 5},
  [4766] = {.lex_state = 81, .external_lex_state = 2},
  [4767] = {.lex_state = 50, .external_lex_state = 2},
  [4768] = {.lex_state = 406, .external_lex_state = 2},
  [4769] = {.lex_state = 406, .external_lex_state = 5},
  [4770] = {.lex_state = 406, .external_lex_state = 5},
  [4771] = {.lex_state = 406, .external_lex_state = 2},
  [4772] = {.lex_state = 406, .external_lex_state = 5},
  [4773] = {.lex_state = 406, .external_lex_state = 5},
  [4774] = {.lex_state = 65, .external_lex_state = 2},
  [4775] = {.lex_state = 406, .external_lex_state = 5},
  [4776] = {.lex_state = 406, .external_lex_state = 2},
  [4777] = {.lex_state = 406, .external_lex_state = 5},
  [4778] = {.lex_state = 406, .external_lex_state = 5},
  [4779] = {.lex_state = 48, .external_lex_state = 2},
  [4780] = {.lex_state = 50, .external_lex_state = 2},
  [4781] = {.lex_state = 75, .external_lex_state = 2},
  [4782] = {.lex_state = 81, .external_lex_state = 2},
  [4783] = {.lex_state = 406, .external_lex_state = 2},
  [4784] = {.lex_state = 48, .external_lex_state = 2},
  [4785] = {.lex_state = 65, .external_lex_state = 2},
  [4786] = {.lex_state = 65, .external_lex_state = 2},
  [4787] = {.lex_state = 65, .external_lex_state = 2},
  [4788] = {.lex_state = 406, .external_lex_state = 7},
  [4789] = {.lex_state = 65, .external_lex_state = 2},
  [4790] = {.lex_state = 65, .external_lex_state = 2},
  [4791] = {.lex_state = 48, .external_lex_state = 2},
  [4792] = {.lex_state = 406, .external_lex_state = 6},
  [4793] = {.lex_state = 65, .external_lex_state = 2},
  [4794] = {.lex_state = 81, .external_lex_state = 2},
  [4795] = {.lex_state = 406, .external_lex_state = 2},
  [4796] = {.lex_state = 48, .external_lex_state = 2},
  [4797] = {.lex_state = 406, .external_lex_state = 5},
  [4798] = {.lex_state = 406, .external_lex_state = 6},
  [4799] = {.lex_state = 48, .external_lex_state = 2},
  [4800] = {.lex_state = 50, .external_lex_state = 2},
  [4801] = {.lex_state = 48, .external_lex_state = 2},
  [4802] = {.lex_state = 50, .external_lex_state = 2},
  [4803] = {.lex_state = 48, .external_lex_state = 2},
  [4804] = {.lex_state = 406, .external_lex_state = 6},
  [4805] = {.lex_state = 406, .external_lex_state = 6},
  [4806] = {.lex_state = 50, .external_lex_state = 2},
  [4807] = {.lex_state = 48, .external_lex_state = 2},
  [4808] = {.lex_state = 48, .external_lex_state = 2},
  [4809] = {.lex_state = 65, .external_lex_state = 2},
  [4810] = {.lex_state = 48, .external_lex_state = 2},
  [4811] = {.lex_state = 50, .external_lex_state = 2},
  [4812] = {.lex_state = 50, .external_lex_state = 2},
  [4813] = {.lex_state = 50, .external_lex_state = 2},
  [4814] = {.lex_state = 406, .external_lex_state = 2},
  [4815] = {.lex_state = 406, .external_lex_state = 6},
  [4816] = {.lex_state = 48, .external_lex_state = 2},
  [4817] = {.lex_state = 50, .external_lex_state = 2},
  [4818] = {.lex_state = 406, .external_lex_state = 7},
  [4819] = {.lex_state = 406, .external_lex_state = 6},
  [4820] = {.lex_state = 48, .external_lex_state = 2},
  [4821] = {.lex_state = 48, .external_lex_state = 2},
  [4822] = {.lex_state = 48, .external_lex_state = 2},
  [4823] = {.lex_state = 48, .external_lex_state = 2},
  [4824] = {.lex_state = 50, .external_lex_state = 2},
  [4825] = {.lex_state = 48, .external_lex_state = 2},
  [4826] = {.lex_state = 48, .external_lex_state = 2},
  [4827] = {.lex_state = 406, .external_lex_state = 7},
  [4828] = {.lex_state = 65, .external_lex_state = 2},
  [4829] = {.lex_state = 48, .external_lex_state = 2},
  [4830] = {.lex_state = 48, .external_lex_state = 2},
  [4831] = {.lex_state = 65, .external_lex_state = 2},
  [4832] = {.lex_state = 81, .external_lex_state = 2},
  [4833] = {.lex_state = 406, .external_lex_state = 2},
  [4834] = {.lex_state = 65, .external_lex_state = 2},
  [4835] = {.lex_state = 50, .external_lex_state = 2},
  [4836] = {.lex_state = 48, .external_lex_state = 2},
  [4837] = {.lex_state = 406, .external_lex_state = 2},
  [4838] = {.lex_state = 406, .external_lex_state = 2},
  [4839] = {.lex_state = 406, .external_lex_state = 6},
  [4840] = {.lex_state = 406, .external_lex_state = 2},
  [4841] = {.lex_state = 406, .external_lex_state = 2},
  [4842] = {.lex_state = 50, .external_lex_state = 2},
  [4843] = {.lex_state = 48, .external_lex_state = 2},
  [4844] = {.lex_state = 48, .external_lex_state = 2},
  [4845] = {.lex_state = 406, .external_lex_state = 5},
  [4846] = {.lex_state = 406, .external_lex_state = 5},
  [4847] = {.lex_state = 406, .external_lex_state = 5},
  [4848] = {.lex_state = 48, .external_lex_state = 2},
  [4849] = {.lex_state = 406, .external_lex_state = 5},
  [4850] = {.lex_state = 48, .external_lex_state = 2},
  [4851] = {.lex_state = 406, .external_lex_state = 5},
  [4852] = {.lex_state = 406, .external_lex_state = 5},
  [4853] = {.lex_state = 406, .external_lex_state = 5},
  [4854] = {.lex_state = 48, .external_lex_state = 2},
  [4855] = {.lex_state = 406, .external_lex_state = 5},
  [4856] = {.lex_state = 48, .external_lex_state = 2},
  [4857] = {.lex_state = 406, .external_lex_state = 5},
  [4858] = {.lex_state = 406, .external_lex_state = 5},
  [4859] = {.lex_state = 406, .external_lex_state = 5},
  [4860] = {.lex_state = 406, .external_lex_state = 5},
  [4861] = {.lex_state = 48, .external_lex_state = 2},
  [4862] = {.lex_state = 406, .external_lex_state = 5},
  [4863] = {.lex_state = 406, .external_lex_state = 5},
  [4864] = {.lex_state = 48, .external_lex_state = 2},
  [4865] = {.lex_state = 48, .external_lex_state = 2},
  [4866] = {.lex_state = 406, .external_lex_state = 5},
  [4867] = {.lex_state = 406, .external_lex_state = 5},
  [4868] = {.lex_state = 406, .external_lex_state = 5},
  [4869] = {.lex_state = 48, .external_lex_state = 2},
  [4870] = {.lex_state = 406, .external_lex_state = 5},
  [4871] = {.lex_state = 406, .external_lex_state = 8},
  [4872] = {.lex_state = 75, .external_lex_state = 2},
  [4873] = {.lex_state = 48, .external_lex_state = 2},
  [4874] = {.lex_state = 406, .external_lex_state = 5},
  [4875] = {.lex_state = 406, .external_lex_state = 2},
  [4876] = {.lex_state = 48, .external_lex_state = 2},
  [4877] = {.lex_state = 406, .external_lex_state = 5},
  [4878] = {.lex_state = 406, .external_lex_state = 5},
  [4879] = {.lex_state = 406, .external_lex_state = 5},
  [4880] = {.lex_state = 406, .external_lex_state = 5},
  [4881] = {.lex_state = 406, .external_lex_state = 5},
  [4882] = {.lex_state = 75, .external_lex_state = 2},
  [4883] = {.lex_state = 406, .external_lex_state = 5},
  [4884] = {.lex_state = 406, .external_lex_state = 5},
  [4885] = {.lex_state = 406, .external_lex_state = 6},
  [4886] = {.lex_state = 406, .external_lex_state = 2},
  [4887] = {.lex_state = 48, .external_lex_state = 2},
  [4888] = {.lex_state = 406, .external_lex_state = 5},
  [4889] = {.lex_state = 406, .external_lex_state = 5},
  [4890] = {.lex_state = 406, .external_lex_state = 5},
  [4891] = {.lex_state = 75, .external_lex_state = 2},
  [4892] = {.lex_state = 406, .external_lex_state = 5},
  [4893] = {.lex_state = 406, .external_lex_state = 5},
  [4894] = {.lex_state = 406, .external_lex_state = 5},
  [4895] = {.lex_state = 406, .external_lex_state = 5},
  [4896] = {.lex_state = 48, .external_lex_state = 2},
  [4897] = {.lex_state = 406, .external_lex_state = 5},
  [4898] = {.lex_state = 406, .external_lex_state = 5},
  [4899] = {.lex_state = 48, .external_lex_state = 2},
  [4900] = {.lex_state = 81, .external_lex_state = 2},
  [4901] = {.lex_state = 406, .external_lex_state = 5},
  [4902] = {.lex_state = 406, .external_lex_state = 5},
  [4903] = {.lex_state = 406, .external_lex_state = 5},
  [4904] = {.lex_state = 406, .external_lex_state = 5},
  [4905] = {.lex_state = 406, .external_lex_state = 5},
  [4906] = {.lex_state = 406, .external_lex_state = 5},
  [4907] = {.lex_state = 48, .external_lex_state = 2},
  [4908] = {.lex_state = 406, .external_lex_state = 5},
  [4909] = {.lex_state = 406, .external_lex_state = 8},
  [4910] = {.lex_state = 406, .external_lex_state = 5},
  [4911] = {.lex_state = 406, .external_lex_state = 5},
  [4912] = {.lex_state = 406, .external_lex_state = 5},
  [4913] = {.lex_state = 48, .external_lex_state = 2},
  [4914] = {.lex_state = 48, .external_lex_state = 2},
  [4915] = {.lex_state = 406, .external_lex_state = 5},
  [4916] = {.lex_state = 406, .external_lex_state = 5},
  [4917] = {.lex_state = 406, .external_lex_state = 5},
  [4918] = {.lex_state = 48, .external_lex_state = 2},
  [4919] = {.lex_state = 48, .external_lex_state = 2},
  [4920] = {.lex_state = 406, .external_lex_state = 5},
  [4921] = {.lex_state = 48, .external_lex_state = 2},
  [4922] = {.lex_state = 48, .external_lex_state = 2},
  [4923] = {.lex_state = 406, .external_lex_state = 5},
  [4924] = {.lex_state = 48, .external_lex_state = 2},
  [4925] = {.lex_state = 406, .external_lex_state = 5},
  [4926] = {.lex_state = 406, .external_lex_state = 5},
  [4927] = {.lex_state = 406, .external_lex_state = 5},
  [4928] = {.lex_state = 48, .external_lex_state = 2},
  [4929] = {.lex_state = 406, .external_lex_state = 5},
  [4930] = {.lex_state = 48, .external_lex_state = 2},
  [4931] = {.lex_state = 406, .external_lex_state = 2},
  [4932] = {.lex_state = 406, .external_lex_state = 5},
  [4933] = {.lex_state = 406, .external_lex_state = 6},
  [4934] = {.lex_state = 48, .external_lex_state = 2},
  [4935] = {.lex_state = 406, .external_lex_state = 5},
  [4936] = {.lex_state = 406, .external_lex_state = 5},
  [4937] = {.lex_state = 81, .external_lex_state = 2},
  [4938] = {.lex_state = 48, .external_lex_state = 2},
  [4939] = {.lex_state = 406, .external_lex_state = 5},
  [4940] = {.lex_state = 406, .external_lex_state = 5},
  [4941] = {.lex_state = 48, .external_lex_state = 2},
  [4942] = {.lex_state = 406, .external_lex_state = 5},
  [4943] = {.lex_state = 406, .external_lex_state = 5},
  [4944] = {.lex_state = 406, .external_lex_state = 2},
  [4945] = {.lex_state = 406, .external_lex_state = 5},
  [4946] = {.lex_state = 406, .external_lex_state = 5},
  [4947] = {.lex_state = 406, .external_lex_state = 5},
  [4948] = {.lex_state = 406, .external_lex_state = 5},
  [4949] = {.lex_state = 406, .external_lex_state = 5},
  [4950] = {.lex_state = 75, .external_lex_state = 2},
  [4951] = {.lex_state = 406, .external_lex_state = 5},
  [4952] = {.lex_state = 406, .external_lex_state = 5},
  [4953] = {.lex_state = 406, .external_lex_state = 5},
  [4954] = {.lex_state = 81, .external_lex_state = 2},
  [4955] = {.lex_state = 406, .external_lex_state = 2},
  [4956] = {.lex_state = 406, .external_lex_state = 5},
  [4957] = {.lex_state = 406, .external_lex_state = 5},
  [4958] = {.lex_state = 406, .external_lex_state = 2},
  [4959] = {.lex_state = 406, .external_lex_state = 5},
  [4960] = {.lex_state = 406, .external_lex_state = 6},
  [4961] = {.lex_state = 406, .external_lex_state = 5},
  [4962] = {.lex_state = 48, .external_lex_state = 2},
  [4963] = {.lex_state = 406, .external_lex_state = 5},
  [4964] = {.lex_state = 406, .external_lex_state = 5},
  [4965] = {.lex_state = 406, .external_lex_state = 5},
  [4966] = {.lex_state = 406, .external_lex_state = 5},
  [4967] = {.lex_state = 81, .external_lex_state = 2},
  [4968] = {.lex_state = 406, .external_lex_state = 5},
  [4969] = {.lex_state = 406, .external_lex_state = 5},
  [4970] = {.lex_state = 81, .external_lex_state = 2},
  [4971] = {.lex_state = 406, .external_lex_state = 5},
  [4972] = {.lex_state = 81, .external_lex_state = 2},
  [4973] = {.lex_state = 406, .external_lex_state = 5},
  [4974] = {.lex_state = 81, .external_lex_state = 2},
  [4975] = {.lex_state = 406, .external_lex_state = 5},
  [4976] = {.lex_state = 50, .external_lex_state = 2},
  [4977] = {.lex_state = 406, .external_lex_state = 5},
  [4978] = {.lex_state = 81, .external_lex_state = 2},
  [4979] = {.lex_state = 48, .external_lex_state = 2},
  [4980] = {.lex_state = 48, .external_lex_state = 2},
  [4981] = {.lex_state = 406, .external_lex_state = 6},
  [4982] = {.lex_state = 48, .external_lex_state = 5},
  [4983] = {.lex_state = 406, .external_lex_state = 5},
  [4984] = {.lex_state = 406, .external_lex_state = 5},
  [4985] = {.lex_state = 48, .external_lex_state = 2},
  [4986] = {.lex_state = 406, .external_lex_state = 5},
  [4987] = {.lex_state = 406, .external_lex_state = 2},
  [4988] = {.lex_state = 48, .external_lex_state = 5},
  [4989] = {.lex_state = 406, .external_lex_state = 5},
  [4990] = {.lex_state = 406, .external_lex_state = 5},
  [4991] = {.lex_state = 406, .external_lex_state = 2},
  [4992] = {.lex_state = 406, .external_lex_state = 5},
  [4993] = {.lex_state = 406, .external_lex_state = 5},
  [4994] = {.lex_state = 406, .external_lex_state = 5},
  [4995] = {.lex_state = 406, .external_lex_state = 5},
  [4996] = {.lex_state = 406, .external_lex_state = 5},
  [4997] = {.lex_state = 406, .external_lex_state = 5},
  [4998] = {.lex_state = 48, .external_lex_state = 2},
  [4999] = {.lex_state = 48, .external_lex_state = 2},
  [5000] = {.lex_state = 48, .external_lex_state = 2},
  [5001] = {.lex_state = 406, .external_lex_state = 5},
  [5002] = {.lex_state = 406, .external_lex_state = 5},
  [5003] = {.lex_state = 48, .external_lex_state = 2},
  [5004] = {.lex_state = 81, .external_lex_state = 2},
  [5005] = {.lex_state = 406, .external_lex_state = 5},
  [5006] = {.lex_state = 48, .external_lex_state = 2},
  [5007] = {.lex_state = 48, .external_lex_state = 2},
  [5008] = {.lex_state = 406, .external_lex_state = 5},
  [5009] = {.lex_state = 48, .external_lex_state = 2},
  [5010] = {.lex_state = 406, .external_lex_state = 5},
  [5011] = {.lex_state = 48, .external_lex_state = 2},
  [5012] = {.lex_state = 81, .external_lex_state = 2},
  [5013] = {.lex_state = 48, .external_lex_state = 2},
  [5014] = {.lex_state = 48, .external_lex_state = 2},
  [5015] = {.lex_state = 48, .external_lex_state = 2},
  [5016] = {.lex_state = 48, .external_lex_state = 2},
  [5017] = {.lex_state = 48, .external_lex_state = 2},
  [5018] = {.lex_state = 406, .external_lex_state = 5},
  [5019] = {.lex_state = 406, .external_lex_state = 5},
  [5020] = {.lex_state = 406, .external_lex_state = 8},
  [5021] = {.lex_state = 406, .external_lex_state = 5},
  [5022] = {.lex_state = 48, .external_lex_state = 2},
  [5023] = {.lex_state = 406, .external_lex_state = 5},
  [5024] = {.lex_state = 406, .external_lex_state = 5},
  [5025] = {.lex_state = 406, .external_lex_state = 5},
  [5026] = {.lex_state = 81, .external_lex_state = 2},
  [5027] = {.lex_state = 48, .external_lex_state = 2},
  [5028] = {.lex_state = 48, .external_lex_state = 2},
  [5029] = {.lex_state = 48, .external_lex_state = 2},
  [5030] = {.lex_state = 406, .external_lex_state = 5},
  [5031] = {.lex_state = 406, .external_lex_state = 5},
  [5032] = {.lex_state = 48, .external_lex_state = 2},
  [5033] = {.lex_state = 48, .external_lex_state = 2},
  [5034] = {.lex_state = 48, .external_lex_state = 2},
  [5035] = {.lex_state = 406, .external_lex_state = 6},
  [5036] = {.lex_state = 406, .external_lex_state = 5},
  [5037] = {.lex_state = 406, .external_lex_state = 2},
  [5038] = {.lex_state = 406, .external_lex_state = 5},
  [5039] = {.lex_state = 406, .external_lex_state = 6},
  [5040] = {.lex_state = 406, .external_lex_state = 5},
  [5041] = {.lex_state = 48, .external_lex_state = 2},
  [5042] = {.lex_state = 406, .external_lex_state = 5},
  [5043] = {.lex_state = 406, .external_lex_state = 6},
  [5044] = {.lex_state = 406, .external_lex_state = 5},
  [5045] = {.lex_state = 48, .external_lex_state = 2},
  [5046] = {.lex_state = 48, .external_lex_state = 5},
  [5047] = {.lex_state = 48, .external_lex_state = 2},
  [5048] = {.lex_state = 406, .external_lex_state = 5},
  [5049] = {.lex_state = 406, .external_lex_state = 5},
  [5050] = {.lex_state = 48, .external_lex_state = 2},
  [5051] = {.lex_state = 406, .external_lex_state = 5},
  [5052] = {.lex_state = 406, .external_lex_state = 5},
  [5053] = {.lex_state = 406, .external_lex_state = 5},
  [5054] = {.lex_state = 406, .external_lex_state = 5},
  [5055] = {.lex_state = 406, .external_lex_state = 5},
  [5056] = {.lex_state = 406, .external_lex_state = 5},
  [5057] = {.lex_state = 48, .external_lex_state = 2},
  [5058] = {.lex_state = 81, .external_lex_state = 2},
  [5059] = {.lex_state = 406, .external_lex_state = 5},
  [5060] = {.lex_state = 48, .external_lex_state = 2},
  [5061] = {.lex_state = 48, .external_lex_state = 2},
  [5062] = {.lex_state = 48, .external_lex_state = 2},
  [5063] = {.lex_state = 48, .external_lex_state = 2},
  [5064] = {.lex_state = 81, .external_lex_state = 2},
  [5065] = {.lex_state = 48, .external_lex_state = 5},
  [5066] = {.lex_state = 406, .external_lex_state = 5},
  [5067] = {.lex_state = 81, .external_lex_state = 2},
  [5068] = {.lex_state = 48, .external_lex_state = 2},
  [5069] = {.lex_state = 406, .external_lex_state = 2},
  [5070] = {.lex_state = 406, .external_lex_state = 5},
  [5071] = {.lex_state = 49, .external_lex_state = 2},
  [5072] = {.lex_state = 49, .external_lex_state = 2},
  [5073] = {.lex_state = 406, .external_lex_state = 2},
  [5074] = {.lex_state = 406, .external_lex_state = 2},
  [5075] = {.lex_state = 81, .external_lex_state = 2},
  [5076] = {.lex_state = 406, .external_lex_state = 5},
  [5077] = {.lex_state = 406, .external_lex_state = 5},
  [5078] = {.lex_state = 406, .external_lex_state = 5},
  [5079] = {.lex_state = 81, .external_lex_state = 2},
  [5080] = {.lex_state = 48, .external_lex_state = 2},
  [5081] = {.lex_state = 48, .external_lex_state = 2},
  [5082] = {.lex_state = 48, .external_lex_state = 2},
  [5083] = {.lex_state = 81, .external_lex_state = 2},
  [5084] = {.lex_state = 406, .external_lex_state = 5},
  [5085] = {.lex_state = 48, .external_lex_state = 2},
  [5086] = {.lex_state = 406, .external_lex_state = 5},
  [5087] = {.lex_state = 406, .external_lex_state = 5},
  [5088] = {.lex_state = 406, .external_lex_state = 5},
  [5089] = {.lex_state = 406, .external_lex_state = 5},
  [5090] = {.lex_state = 406, .external_lex_state = 5},
  [5091] = {.lex_state = 406, .external_lex_state = 5},
  [5092] = {.lex_state = 406, .external_lex_state = 5},
  [5093] = {.lex_state = 48, .external_lex_state = 2},
  [5094] = {.lex_state = 48, .external_lex_state = 2},
  [5095] = {.lex_state = 406, .external_lex_state = 5},
  [5096] = {.lex_state = 81, .external_lex_state = 2},
  [5097] = {.lex_state = 48, .external_lex_state = 2},
  [5098] = {.lex_state = 406, .external_lex_state = 5},
  [5099] = {.lex_state = 48, .external_lex_state = 5},
  [5100] = {.lex_state = 406, .external_lex_state = 5},
  [5101] = {.lex_state = 75, .external_lex_state = 2},
  [5102] = {.lex_state = 406, .external_lex_state = 2},
  [5103] = {.lex_state = 406, .external_lex_state = 5},
  [5104] = {.lex_state = 406, .external_lex_state = 5},
  [5105] = {.lex_state = 406, .external_lex_state = 5},
  [5106] = {.lex_state = 48, .external_lex_state = 2},
  [5107] = {.lex_state = 48, .external_lex_state = 2},
  [5108] = {.lex_state = 406, .external_lex_state = 8},
  [5109] = {.lex_state = 406, .external_lex_state = 5},
  [5110] = {.lex_state = 406, .external_lex_state = 5},
  [5111] = {.lex_state = 406, .external_lex_state = 6},
  [5112] = {.lex_state = 406, .external_lex_state = 5},
  [5113] = {.lex_state = 406, .external_lex_state = 5},
  [5114] = {.lex_state = 48, .external_lex_state = 2},
  [5115] = {.lex_state = 406, .external_lex_state = 5},
  [5116] = {.lex_state = 406, .external_lex_state = 5},
  [5117] = {.lex_state = 406, .external_lex_state = 5},
  [5118] = {.lex_state = 406, .external_lex_state = 5},
  [5119] = {.lex_state = 48, .external_lex_state = 2},
  [5120] = {.lex_state = 406, .external_lex_state = 5},
  [5121] = {.lex_state = 406, .external_lex_state = 5},
  [5122] = {.lex_state = 48, .external_lex_state = 2},
  [5123] = {.lex_state = 48, .external_lex_state = 2},
  [5124] = {.lex_state = 48, .external_lex_state = 2},
  [5125] = {.lex_state = 406, .external_lex_state = 5},
  [5126] = {.lex_state = 406, .external_lex_state = 5},
  [5127] = {.lex_state = 81, .external_lex_state = 2},
  [5128] = {.lex_state = 50, .external_lex_state = 2},
  [5129] = {.lex_state = 406, .external_lex_state = 5},
  [5130] = {.lex_state = 406, .external_lex_state = 2},
  [5131] = {.lex_state = 406, .external_lex_state = 2},
  [5132] = {.lex_state = 406, .external_lex_state = 5},
  [5133] = {.lex_state = 406, .external_lex_state = 5},
  [5134] = {.lex_state = 406, .external_lex_state = 5},
  [5135] = {.lex_state = 406, .external_lex_state = 5},
  [5136] = {.lex_state = 406, .external_lex_state = 5},
  [5137] = {.lex_state = 48, .external_lex_state = 2},
  [5138] = {.lex_state = 406, .external_lex_state = 5},
  [5139] = {.lex_state = 48, .external_lex_state = 2},
  [5140] = {.lex_state = 406, .external_lex_state = 5},
  [5141] = {.lex_state = 81, .external_lex_state = 2},
  [5142] = {.lex_state = 48, .external_lex_state = 2},
  [5143] = {.lex_state = 48, .external_lex_state = 2},
  [5144] = {.lex_state = 48, .external_lex_state = 2},
  [5145] = {.lex_state = 406, .external_lex_state = 5},
  [5146] = {.lex_state = 406, .external_lex_state = 5},
  [5147] = {.lex_state = 406, .external_lex_state = 5},
  [5148] = {.lex_state = 48, .external_lex_state = 2},
  [5149] = {.lex_state = 406, .external_lex_state = 5},
  [5150] = {.lex_state = 406, .external_lex_state = 5},
  [5151] = {.lex_state = 49, .external_lex_state = 2},
  [5152] = {.lex_state = 406, .external_lex_state = 5},
  [5153] = {.lex_state = 406, .external_lex_state = 5},
  [5154] = {.lex_state = 406, .external_lex_state = 2},
  [5155] = {.lex_state = 406, .external_lex_state = 5},
  [5156] = {.lex_state = 48, .external_lex_state = 2},
  [5157] = {.lex_state = 81, .external_lex_state = 2},
  [5158] = {.lex_state = 81, .external_lex_state = 2},
  [5159] = {.lex_state = 406, .external_lex_state = 5},
  [5160] = {.lex_state = 406, .external_lex_state = 5},
  [5161] = {.lex_state = 48, .external_lex_state = 2},
  [5162] = {.lex_state = 48, .external_lex_state = 2},
  [5163] = {.lex_state = 406, .external_lex_state = 5},
  [5164] = {.lex_state = 406, .external_lex_state = 5},
  [5165] = {.lex_state = 406, .external_lex_state = 5},
  [5166] = {.lex_state = 406, .external_lex_state = 5},
  [5167] = {.lex_state = 406, .external_lex_state = 2},
  [5168] = {.lex_state = 406, .external_lex_state = 5},
  [5169] = {.lex_state = 406, .external_lex_state = 5},
  [5170] = {.lex_state = 406, .external_lex_state = 5},
  [5171] = {.lex_state = 406, .external_lex_state = 5},
  [5172] = {.lex_state = 406, .external_lex_state = 2},
  [5173] = {.lex_state = 406, .external_lex_state = 2},
  [5174] = {.lex_state = 406, .external_lex_state = 5},
  [5175] = {.lex_state = 406, .external_lex_state = 5},
  [5176] = {.lex_state = 406, .external_lex_state = 8},
  [5177] = {.lex_state = 406, .external_lex_state = 5},
  [5178] = {.lex_state = 406, .external_lex_state = 5},
  [5179] = {.lex_state = 406, .external_lex_state = 5},
  [5180] = {.lex_state = 406, .external_lex_state = 5},
  [5181] = {.lex_state = 406, .external_lex_state = 6},
  [5182] = {.lex_state = 406, .external_lex_state = 2},
  [5183] = {.lex_state = 406, .external_lex_state = 5},
  [5184] = {.lex_state = 406, .external_lex_state = 6},
  [5185] = {.lex_state = 406, .external_lex_state = 5},
  [5186] = {.lex_state = 406, .external_lex_state = 5},
  [5187] = {.lex_state = 406, .external_lex_state = 6},
  [5188] = {.lex_state = 406, .external_lex_state = 5},
  [5189] = {.lex_state = 406, .external_lex_state = 5},
  [5190] = {.lex_state = 406, .external_lex_state = 5},
  [5191] = {.lex_state = 50, .external_lex_state = 2},
  [5192] = {.lex_state = 50, .external_lex_state = 2},
  [5193] = {.lex_state = 406, .external_lex_state = 5},
  [5194] = {.lex_state = 406, .external_lex_state = 6},
  [5195] = {.lex_state = 75, .external_lex_state = 2},
  [5196] = {.lex_state = 406, .external_lex_state = 8},
  [5197] = {.lex_state = 48, .external_lex_state = 2},
  [5198] = {.lex_state = 406, .external_lex_state = 6},
  [5199] = {.lex_state = 48, .external_lex_state = 2},
  [5200] = {.lex_state = 406, .external_lex_state = 5},
  [5201] = {.lex_state = 406, .external_lex_state = 2},
  [5202] = {.lex_state = 48, .external_lex_state = 5},
  [5203] = {.lex_state = 406, .external_lex_state = 6},
  [5204] = {.lex_state = 48, .external_lex_state = 2},
  [5205] = {.lex_state = 406, .external_lex_state = 5},
  [5206] = {.lex_state = 406, .external_lex_state = 5},
  [5207] = {.lex_state = 81, .external_lex_state = 2},
  [5208] = {.lex_state = 48, .external_lex_state = 2},
  [5209] = {.lex_state = 48, .external_lex_state = 2},
  [5210] = {.lex_state = 406, .external_lex_state = 5},
  [5211] = {.lex_state = 406, .external_lex_state = 5},
  [5212] = {.lex_state = 406, .external_lex_state = 5},
  [5213] = {.lex_state = 406, .external_lex_state = 5},
  [5214] = {.lex_state = 406, .external_lex_state = 5},
  [5215] = {.lex_state = 406, .external_lex_state = 5},
  [5216] = {.lex_state = 406, .external_lex_state = 5},
  [5217] = {.lex_state = 48, .external_lex_state = 2},
  [5218] = {.lex_state = 406, .external_lex_state = 5},
  [5219] = {.lex_state = 75, .external_lex_state = 2},
  [5220] = {.lex_state = 406, .external_lex_state = 5},
  [5221] = {.lex_state = 406, .external_lex_state = 5},
  [5222] = {.lex_state = 406, .external_lex_state = 5},
  [5223] = {.lex_state = 406, .external_lex_state = 5},
  [5224] = {.lex_state = 48, .external_lex_state = 2},
  [5225] = {.lex_state = 406, .external_lex_state = 5},
  [5226] = {.lex_state = 406, .external_lex_state = 6},
  [5227] = {.lex_state = 48, .external_lex_state = 5},
  [5228] = {.lex_state = 406, .external_lex_state = 5},
  [5229] = {.lex_state = 406, .external_lex_state = 5},
  [5230] = {.lex_state = 406, .external_lex_state = 5},
  [5231] = {.lex_state = 406, .external_lex_state = 5},
  [5232] = {.lex_state = 406, .external_lex_state = 2},
  [5233] = {.lex_state = 48, .external_lex_state = 5},
  [5234] = {.lex_state = 406, .external_lex_state = 5},
  [5235] = {.lex_state = 406, .external_lex_state = 5},
  [5236] = {.lex_state = 406, .external_lex_state = 5},
  [5237] = {.lex_state = 406, .external_lex_state = 5},
  [5238] = {.lex_state = 406, .external_lex_state = 5},
  [5239] = {.lex_state = 49, .external_lex_state = 5},
  [5240] = {.lex_state = 406, .external_lex_state = 5},
  [5241] = {.lex_state = 406, .external_lex_state = 5},
  [5242] = {.lex_state = 406, .external_lex_state = 5},
  [5243] = {.lex_state = 406, .external_lex_state = 5},
  [5244] = {.lex_state = 48, .external_lex_state = 5},
  [5245] = {.lex_state = 406, .external_lex_state = 2},
  [5246] = {.lex_state = 406, .external_lex_state = 5},
  [5247] = {.lex_state = 406, .external_lex_state = 6},
  [5248] = {.lex_state = 406, .external_lex_state = 5},
  [5249] = {.lex_state = 406, .external_lex_state = 5},
  [5250] = {.lex_state = 81, .external_lex_state = 2},
  [5251] = {.lex_state = 406, .external_lex_state = 5},
  [5252] = {.lex_state = 406, .external_lex_state = 2},
  [5253] = {.lex_state = 81, .external_lex_state = 2},
  [5254] = {.lex_state = 406, .external_lex_state = 6},
  [5255] = {.lex_state = 406, .external_lex_state = 5},
  [5256] = {.lex_state = 406, .external_lex_state = 8},
  [5257] = {.lex_state = 406, .external_lex_state = 5},
  [5258] = {.lex_state = 406, .external_lex_state = 5},
  [5259] = {.lex_state = 48, .external_lex_state = 5},
  [5260] = {.lex_state = 406, .external_lex_state = 5},
  [5261] = {.lex_state = 406, .external_lex_state = 6},
  [5262] = {.lex_state = 406, .external_lex_state = 5},
  [5263] = {.lex_state = 406, .external_lex_state = 5},
  [5264] = {.lex_state = 406, .external_lex_state = 5},
  [5265] = {.lex_state = 48, .external_lex_state = 2},
  [5266] = {.lex_state = 406, .external_lex_state = 6},
  [5267] = {.lex_state = 406, .external_lex_state = 6},
  [5268] = {.lex_state = 48, .external_lex_state = 5},
  [5269] = {.lex_state = 406, .external_lex_state = 5},
  [5270] = {.lex_state = 406, .external_lex_state = 5},
  [5271] = {.lex_state = 75, .external_lex_state = 2},
  [5272] = {.lex_state = 406, .external_lex_state = 5},
  [5273] = {.lex_state = 406, .external_lex_state = 5},
  [5274] = {.lex_state = 406, .external_lex_state = 6},
  [5275] = {.lex_state = 81, .external_lex_state = 2},
  [5276] = {.lex_state = 406, .external_lex_state = 5},
  [5277] = {.lex_state = 81, .external_lex_state = 2},
  [5278] = {.lex_state = 406, .external_lex_state = 5},
  [5279] = {.lex_state = 406, .external_lex_state = 2},
  [5280] = {.lex_state = 81, .external_lex_state = 2},
  [5281] = {.lex_state = 406, .external_lex_state = 5},
  [5282] = {.lex_state = 406, .external_lex_state = 5},
  [5283] = {.lex_state = 48, .external_lex_state = 2},
  [5284] = {.lex_state = 406, .external_lex_state = 5},
  [5285] = {.lex_state = 406, .external_lex_state = 5},
  [5286] = {.lex_state = 48, .external_lex_state = 2},
  [5287] = {.lex_state = 406, .external_lex_state = 5},
  [5288] = {.lex_state = 406, .external_lex_state = 5},
  [5289] = {.lex_state = 81, .external_lex_state = 2},
  [5290] = {.lex_state = 48, .external_lex_state = 2},
  [5291] = {.lex_state = 48, .external_lex_state = 2},
  [5292] = {.lex_state = 81, .external_lex_state = 2},
  [5293] = {.lex_state = 406, .external_lex_state = 8},
  [5294] = {.lex_state = 81, .external_lex_state = 2},
  [5295] = {.lex_state = 81, .external_lex_state = 2},
  [5296] = {.lex_state = 406, .external_lex_state = 5},
  [5297] = {.lex_state = 406, .external_lex_state = 5},
  [5298] = {.lex_state = 81, .external_lex_state = 2},
  [5299] = {.lex_state = 48, .external_lex_state = 2},
  [5300] = {.lex_state = 81, .external_lex_state = 2},
  [5301] = {.lex_state = 406, .external_lex_state = 6},
  [5302] = {.lex_state = 406, .external_lex_state = 5},
  [5303] = {.lex_state = 406, .external_lex_state = 5},
  [5304] = {.lex_state = 406, .external_lex_state = 5},
  [5305] = {.lex_state = 406, .external_lex_state = 5},
  [5306] = {.lex_state = 406, .external_lex_state = 6},
  [5307] = {.lex_state = 81, .external_lex_state = 2},
  [5308] = {.lex_state = 81, .external_lex_state = 2},
  [5309] = {.lex_state = 406, .external_lex_state = 5},
  [5310] = {.lex_state = 406, .external_lex_state = 5},
  [5311] = {.lex_state = 49, .external_lex_state = 5},
  [5312] = {.lex_state = 406, .external_lex_state = 5},
  [5313] = {.lex_state = 406, .external_lex_state = 2},
  [5314] = {.lex_state = 48, .external_lex_state = 5},
  [5315] = {.lex_state = 406, .external_lex_state = 5},
  [5316] = {.lex_state = 406, .external_lex_state = 5},
  [5317] = {.lex_state = 406, .external_lex_state = 5},
  [5318] = {.lex_state = 406, .external_lex_state = 5},
  [5319] = {.lex_state = 406, .external_lex_state = 5},
  [5320] = {.lex_state = 48, .external_lex_state = 5},
  [5321] = {.lex_state = 406, .external_lex_state = 5},
  [5322] = {.lex_state = 406, .external_lex_state = 5},
  [5323] = {.lex_state = 406, .external_lex_state = 5},
  [5324] = {.lex_state = 406, .external_lex_state = 5},
  [5325] = {.lex_state = 406, .external_lex_state = 5},
  [5326] = {.lex_state = 406, .external_lex_state = 5},
  [5327] = {.lex_state = 406, .external_lex_state = 2},
  [5328] = {.lex_state = 406, .external_lex_state = 5},
  [5329] = {.lex_state = 406, .external_lex_state = 2},
  [5330] = {.lex_state = 406, .external_lex_state = 5},
  [5331] = {.lex_state = 406, .external_lex_state = 5},
  [5332] = {.lex_state = 406, .external_lex_state = 5},
  [5333] = {.lex_state = 406, .external_lex_state = 5},
  [5334] = {.lex_state = 48, .external_lex_state = 5},
  [5335] = {.lex_state = 406, .external_lex_state = 5},
  [5336] = {.lex_state = 406, .external_lex_state = 6},
  [5337] = {.lex_state = 406, .external_lex_state = 5},
  [5338] = {.lex_state = 406, .external_lex_state = 5},
  [5339] = {.lex_state = 406, .external_lex_state = 6},
  [5340] = {.lex_state = 406, .external_lex_state = 2},
  [5341] = {.lex_state = 406, .external_lex_state = 5},
  [5342] = {.lex_state = 406, .external_lex_state = 5},
  [5343] = {.lex_state = 48, .external_lex_state = 5},
  [5344] = {.lex_state = 406, .external_lex_state = 2},
  [5345] = {.lex_state = 406, .external_lex_state = 6},
  [5346] = {.lex_state = 406, .external_lex_state = 8},
  [5347] = {.lex_state = 406, .external_lex_state = 5},
  [5348] = {.lex_state = 406, .external_lex_state = 5},
  [5349] = {.lex_state = 48, .external_lex_state = 2},
  [5350] = {.lex_state = 406, .external_lex_state = 5},
  [5351] = {.lex_state = 406, .external_lex_state = 5},
  [5352] = {.lex_state = 406, .external_lex_state = 5},
  [5353] = {.lex_state = 48, .external_lex_state = 5},
  [5354] = {.lex_state = 48, .external_lex_state = 2},
  [5355] = {.lex_state = 406, .external_lex_state = 5},
  [5356] = {.lex_state = 406, .external_lex_state = 5},
  [5357] = {.lex_state = 406, .external_lex_state = 6},
  [5358] = {.lex_state = 406, .external_lex_state = 5},
  [5359] = {.lex_state = 406, .external_lex_state = 5},
  [5360] = {.lex_state = 406, .external_lex_state = 5},
  [5361] = {.lex_state = 406, .external_lex_state = 5},
  [5362] = {.lex_state = 406, .external_lex_state = 5},
  [5363] = {.lex_state = 406, .external_lex_state = 5},
  [5364] = {.lex_state = 406, .external_lex_state = 5},
  [5365] = {.lex_state = 406, .external_lex_state = 5},
  [5366] = {.lex_state = 406, .external_lex_state = 5},
  [5367] = {.lex_state = 406, .external_lex_state = 5},
  [5368] = {.lex_state = 406, .external_lex_state = 5},
  [5369] = {.lex_state = 75, .external_lex_state = 2},
  [5370] = {.lex_state = 406, .external_lex_state = 6},
  [5371] = {.lex_state = 406, .external_lex_state = 8},
  [5372] = {.lex_state = 48, .external_lex_state = 2},
  [5373] = {.lex_state = 406, .external_lex_state = 5},
  [5374] = {.lex_state = 406, .external_lex_state = 5},
  [5375] = {.lex_state = 406, .external_lex_state = 5},
  [5376] = {.lex_state = 406, .external_lex_state = 5},
  [5377] = {.lex_state = 48, .external_lex_state = 2},
  [5378] = {.lex_state = 406, .external_lex_state = 5},
  [5379] = {.lex_state = 406, .external_lex_state = 2},
  [5380] = {.lex_state = 406, .external_lex_state = 2},
  [5381] = {.lex_state = 48, .external_lex_state = 2},
  [5382] = {.lex_state = 406, .external_lex_state = 2},
  [5383] = {.lex_state = 48, .external_lex_state = 5},
  [5384] = {.lex_state = 406, .external_lex_state = 5},
  [5385] = {.lex_state = 48, .external_lex_state = 2},
  [5386] = {.lex_state = 48, .external_lex_state = 2},
  [5387] = {.lex_state = 49, .external_lex_state = 2},
  [5388] = {.lex_state = 48, .external_lex_state = 2},
  [5389] = {.lex_state = 48, .external_lex_state = 2},
  [5390] = {.lex_state = 48, .external_lex_state = 2},
  [5391] = {.lex_state = 49, .external_lex_state = 2},
  [5392] = {.lex_state = 406, .external_lex_state = 5},
  [5393] = {.lex_state = 406, .external_lex_state = 5},
  [5394] = {.lex_state = 406, .external_lex_state = 8},
  [5395] = {.lex_state = 48, .external_lex_state = 2},
  [5396] = {.lex_state = 406, .external_lex_state = 2},
  [5397] = {.lex_state = 48, .external_lex_state = 2},
  [5398] = {.lex_state = 406, .external_lex_state = 2},
  [5399] = {.lex_state = 406, .external_lex_state = 5},
  [5400] = {.lex_state = 406, .external_lex_state = 5},
  [5401] = {.lex_state = 63, .external_lex_state = 2},
  [5402] = {.lex_state = 48, .external_lex_state = 2},
  [5403] = {.lex_state = 81, .external_lex_state = 2},
  [5404] = {.lex_state = 406, .external_lex_state = 5},
  [5405] = {.lex_state = 81, .external_lex_state = 2},
  [5406] = {.lex_state = 48, .external_lex_state = 5},
  [5407] = {.lex_state = 406, .external_lex_state = 5},
  [5408] = {.lex_state = 59, .external_lex_state = 9},
  [5409] = {.lex_state = 406, .external_lex_state = 5},
  [5410] = {.lex_state = 406, .external_lex_state = 2},
  [5411] = {.lex_state = 406, .external_lex_state = 5},
  [5412] = {.lex_state = 48, .external_lex_state = 2},
  [5413] = {.lex_state = 406, .external_lex_state = 5},
  [5414] = {.lex_state = 406, .external_lex_state = 5},
  [5415] = {.lex_state = 406, .external_lex_state = 5},
  [5416] = {.lex_state = 406, .external_lex_state = 5},
  [5417] = {.lex_state = 48, .external_lex_state = 2},
  [5418] = {.lex_state = 59, .external_lex_state = 9},
  [5419] = {.lex_state = 68, .external_lex_state = 9},
  [5420] = {.lex_state = 59, .external_lex_state = 9},
  [5421] = {.lex_state = 50, .external_lex_state = 2},
  [5422] = {.lex_state = 27, .external_lex_state = 2},
  [5423] = {.lex_state = 27, .external_lex_state = 2},
  [5424] = {.lex_state = 27, .external_lex_state = 2},
  [5425] = {.lex_state = 68, .external_lex_state = 9},
  [5426] = {.lex_state = 48, .external_lex_state = 2},
  [5427] = {.lex_state = 48, .external_lex_state = 2},
  [5428] = {.lex_state = 48, .external_lex_state = 2},
  [5429] = {.lex_state = 406, .external_lex_state = 5},
  [5430] = {.lex_state = 406, .external_lex_state = 5},
  [5431] = {.lex_state = 406, .external_lex_state = 5},
  [5432] = {.lex_state = 406, .external_lex_state = 5},
  [5433] = {.lex_state = 406, .external_lex_state = 5},
  [5434] = {.lex_state = 406, .external_lex_state = 5},
  [5435] = {.lex_state = 406, .external_lex_state = 5},
  [5436] = {.lex_state = 406, .external_lex_state = 5},
  [5437] = {.lex_state = 48, .external_lex_state = 2},
  [5438] = {.lex_state = 48, .external_lex_state = 2},
  [5439] = {.lex_state = 406, .external_lex_state = 5},
  [5440] = {.lex_state = 406, .external_lex_state = 5},
  [5441] = {.lex_state = 48, .external_lex_state = 2},
  [5442] = {.lex_state = 406, .external_lex_state = 5},
  [5443] = {.lex_state = 406, .external_lex_state = 5},
  [5444] = {.lex_state = 406, .external_lex_state = 5},
  [5445] = {.lex_state = 48, .external_lex_state = 2},
  [5446] = {.lex_state = 48, .external_lex_state = 2},
  [5447] = {.lex_state = 406, .external_lex_state = 2},
  [5448] = {.lex_state = 48, .external_lex_state = 2},
  [5449] = {.lex_state = 406, .external_lex_state = 2},
  [5450] = {.lex_state = 59, .external_lex_state = 9},
  [5451] = {.lex_state = 48, .external_lex_state = 2},
  [5452] = {.lex_state = 68, .external_lex_state = 9},
  [5453] = {.lex_state = 48, .external_lex_state = 2},
  [5454] = {.lex_state = 59, .external_lex_state = 9},
  [5455] = {.lex_state = 68, .external_lex_state = 9},
  [5456] = {.lex_state = 84, .external_lex_state = 2},
  [5457] = {.lex_state = 406, .external_lex_state = 5},
  [5458] = {.lex_state = 406, .external_lex_state = 5},
  [5459] = {.lex_state = 406, .external_lex_state = 5},
  [5460] = {.lex_state = 59, .external_lex_state = 9},
  [5461] = {.lex_state = 68, .external_lex_state = 9},
  [5462] = {.lex_state = 48, .external_lex_state = 2},
  [5463] = {.lex_state = 48, .external_lex_state = 2},
  [5464] = {.lex_state = 406, .external_lex_state = 5},
  [5465] = {.lex_state = 406, .external_lex_state = 5},
  [5466] = {.lex_state = 406, .external_lex_state = 5},
  [5467] = {.lex_state = 406, .external_lex_state = 5},
  [5468] = {.lex_state = 48, .external_lex_state = 2},
  [5469] = {.lex_state = 406, .external_lex_state = 7},
  [5470] = {.lex_state = 406, .external_lex_state = 2},
  [5471] = {.lex_state = 48, .external_lex_state = 2},
  [5472] = {.lex_state = 48, .external_lex_state = 2},
  [5473] = {.lex_state = 49, .external_lex_state = 2},
  [5474] = {.lex_state = 48, .external_lex_state = 2},
  [5475] = {.lex_state = 59, .external_lex_state = 9},
  [5476] = {.lex_state = 68, .external_lex_state = 9},
  [5477] = {.lex_state = 406, .external_lex_state = 5},
  [5478] = {.lex_state = 406, .external_lex_state = 5},
  [5479] = {.lex_state = 406, .external_lex_state = 2},
  [5480] = {.lex_state = 48, .external_lex_state = 2},
  [5481] = {.lex_state = 406, .external_lex_state = 5},
  [5482] = {.lex_state = 59, .external_lex_state = 9},
  [5483] = {.lex_state = 68, .external_lex_state = 9},
  [5484] = {.lex_state = 406, .external_lex_state = 5},
  [5485] = {.lex_state = 406, .external_lex_state = 5},
  [5486] = {.lex_state = 48, .external_lex_state = 2},
  [5487] = {.lex_state = 48, .external_lex_state = 2},
  [5488] = {.lex_state = 2, .external_lex_state = 2},
  [5489] = {.lex_state = 84, .external_lex_state = 2},
  [5490] = {.lex_state = 59, .external_lex_state = 9},
  [5491] = {.lex_state = 68, .external_lex_state = 9},
  [5492] = {.lex_state = 59, .external_lex_state = 9},
  [5493] = {.lex_state = 68, .external_lex_state = 9},
  [5494] = {.lex_state = 59, .external_lex_state = 9},
  [5495] = {.lex_state = 68, .external_lex_state = 9},
  [5496] = {.lex_state = 48, .external_lex_state = 2},
  [5497] = {.lex_state = 48, .external_lex_state = 2},
  [5498] = {.lex_state = 59, .external_lex_state = 9},
  [5499] = {.lex_state = 68, .external_lex_state = 9},
  [5500] = {.lex_state = 48, .external_lex_state = 2},
  [5501] = {.lex_state = 406, .external_lex_state = 7},
  [5502] = {.lex_state = 406, .external_lex_state = 5},
  [5503] = {.lex_state = 406, .external_lex_state = 5},
  [5504] = {.lex_state = 406, .external_lex_state = 5},
  [5505] = {.lex_state = 406, .external_lex_state = 5},
  [5506] = {.lex_state = 406, .external_lex_state = 5},
  [5507] = {.lex_state = 59, .external_lex_state = 9},
  [5508] = {.lex_state = 2, .external_lex_state = 2},
  [5509] = {.lex_state = 68, .external_lex_state = 9},
  [5510] = {.lex_state = 59, .external_lex_state = 9},
  [5511] = {.lex_state = 68, .external_lex_state = 9},
  [5512] = {.lex_state = 406, .external_lex_state = 5},
  [5513] = {.lex_state = 406, .external_lex_state = 5},
  [5514] = {.lex_state = 406, .external_lex_state = 5},
  [5515] = {.lex_state = 406, .external_lex_state = 5},
  [5516] = {.lex_state = 406, .external_lex_state = 5},
  [5517] = {.lex_state = 406, .external_lex_state = 5},
  [5518] = {.lex_state = 59, .external_lex_state = 9},
  [5519] = {.lex_state = 68, .external_lex_state = 9},
  [5520] = {.lex_state = 406, .external_lex_state = 5},
  [5521] = {.lex_state = 59, .external_lex_state = 9},
  [5522] = {.lex_state = 68, .external_lex_state = 9},
  [5523] = {.lex_state = 59, .external_lex_state = 9},
  [5524] = {.lex_state = 66, .external_lex_state = 2},
  [5525] = {.lex_state = 54, .external_lex_state = 2},
  [5526] = {.lex_state = 406, .external_lex_state = 5},
  [5527] = {.lex_state = 59, .external_lex_state = 9},
  [5528] = {.lex_state = 48, .external_lex_state = 2},
  [5529] = {.lex_state = 406, .external_lex_state = 5},
  [5530] = {.lex_state = 48, .external_lex_state = 2},
  [5531] = {.lex_state = 68, .external_lex_state = 9},
  [5532] = {.lex_state = 27, .external_lex_state = 2},
  [5533] = {.lex_state = 68, .external_lex_state = 9},
  [5534] = {.lex_state = 27, .external_lex_state = 2},
  [5535] = {.lex_state = 59, .external_lex_state = 9},
  [5536] = {.lex_state = 48, .external_lex_state = 2},
  [5537] = {.lex_state = 59, .external_lex_state = 9},
  [5538] = {.lex_state = 68, .external_lex_state = 9},
  [5539] = {.lex_state = 59, .external_lex_state = 9},
  [5540] = {.lex_state = 406, .external_lex_state = 5},
  [5541] = {.lex_state = 406, .external_lex_state = 5},
  [5542] = {.lex_state = 406, .external_lex_state = 5},
  [5543] = {.lex_state = 68, .external_lex_state = 9},
  [5544] = {.lex_state = 406, .external_lex_state = 2},
  [5545] = {.lex_state = 406, .external_lex_state = 5},
  [5546] = {.lex_state = 406, .external_lex_state = 7},
  [5547] = {.lex_state = 406, .external_lex_state = 5},
  [5548] = {.lex_state = 84, .external_lex_state = 2},
  [5549] = {.lex_state = 406, .external_lex_state = 5},
  [5550] = {.lex_state = 406, .external_lex_state = 5},
  [5551] = {.lex_state = 24, .external_lex_state = 2},
  [5552] = {.lex_state = 406, .external_lex_state = 2},
  [5553] = {.lex_state = 48, .external_lex_state = 2},
  [5554] = {.lex_state = 48, .external_lex_state = 2},
  [5555] = {.lex_state = 406, .external_lex_state = 2},
  [5556] = {.lex_state = 48, .external_lex_state = 2},
  [5557] = {.lex_state = 406, .external_lex_state = 2},
  [5558] = {.lex_state = 48, .external_lex_state = 2},
  [5559] = {.lex_state = 68, .external_lex_state = 9},
  [5560] = {.lex_state = 59, .external_lex_state = 9},
  [5561] = {.lex_state = 66, .external_lex_state = 2},
  [5562] = {.lex_state = 406, .external_lex_state = 2},
  [5563] = {.lex_state = 406, .external_lex_state = 2},
  [5564] = {.lex_state = 54, .external_lex_state = 2},
  [5565] = {.lex_state = 68, .external_lex_state = 9},
  [5566] = {.lex_state = 406, .external_lex_state = 2},
  [5567] = {.lex_state = 59, .external_lex_state = 9},
  [5568] = {.lex_state = 68, .external_lex_state = 9},
  [5569] = {.lex_state = 406, .external_lex_state = 5},
  [5570] = {.lex_state = 68, .external_lex_state = 9},
  [5571] = {.lex_state = 406, .external_lex_state = 5},
  [5572] = {.lex_state = 406, .external_lex_state = 5},
  [5573] = {.lex_state = 406, .external_lex_state = 2},
  [5574] = {.lex_state = 48, .external_lex_state = 2},
  [5575] = {.lex_state = 406, .external_lex_state = 5},
  [5576] = {.lex_state = 406, .external_lex_state = 5},
  [5577] = {.lex_state = 54, .external_lex_state = 2},
  [5578] = {.lex_state = 406, .external_lex_state = 5},
  [5579] = {.lex_state = 406, .external_lex_state = 5},
  [5580] = {.lex_state = 48, .external_lex_state = 2},
  [5581] = {.lex_state = 66, .external_lex_state = 2},
  [5582] = {.lex_state = 406, .external_lex_state = 2},
  [5583] = {.lex_state = 59, .external_lex_state = 9},
  [5584] = {.lex_state = 48, .external_lex_state = 2},
  [5585] = {.lex_state = 48, .external_lex_state = 2},
  [5586] = {.lex_state = 59, .external_lex_state = 9},
  [5587] = {.lex_state = 68, .external_lex_state = 9},
  [5588] = {.lex_state = 48, .external_lex_state = 2},
  [5589] = {.lex_state = 48, .external_lex_state = 2},
  [5590] = {.lex_state = 48, .external_lex_state = 2},
  [5591] = {.lex_state = 406, .external_lex_state = 5},
  [5592] = {.lex_state = 48, .external_lex_state = 2},
  [5593] = {.lex_state = 406, .external_lex_state = 5},
  [5594] = {.lex_state = 48, .external_lex_state = 2},
  [5595] = {.lex_state = 48, .external_lex_state = 2},
  [5596] = {.lex_state = 2, .external_lex_state = 2},
  [5597] = {.lex_state = 48, .external_lex_state = 2},
  [5598] = {.lex_state = 406, .external_lex_state = 5},
  [5599] = {.lex_state = 2, .external_lex_state = 2},
  [5600] = {.lex_state = 48, .external_lex_state = 2},
  [5601] = {.lex_state = 68, .external_lex_state = 9},
  [5602] = {.lex_state = 48, .external_lex_state = 2},
  [5603] = {.lex_state = 48, .external_lex_state = 2},
  [5604] = {.lex_state = 59, .external_lex_state = 9},
  [5605] = {.lex_state = 406, .external_lex_state = 5},
  [5606] = {.lex_state = 48, .external_lex_state = 2},
  [5607] = {.lex_state = 406, .external_lex_state = 5},
  [5608] = {.lex_state = 406, .external_lex_state = 2},
  [5609] = {.lex_state = 406, .external_lex_state = 5},
  [5610] = {.lex_state = 48, .external_lex_state = 2},
  [5611] = {.lex_state = 50, .external_lex_state = 2},
  [5612] = {.lex_state = 406, .external_lex_state = 2},
  [5613] = {.lex_state = 406, .external_lex_state = 5},
  [5614] = {.lex_state = 68, .external_lex_state = 9},
  [5615] = {.lex_state = 84, .external_lex_state = 2},
  [5616] = {.lex_state = 406, .external_lex_state = 2},
  [5617] = {.lex_state = 48, .external_lex_state = 2},
  [5618] = {.lex_state = 48, .external_lex_state = 2},
  [5619] = {.lex_state = 406, .external_lex_state = 5},
  [5620] = {.lex_state = 48, .external_lex_state = 2},
  [5621] = {.lex_state = 48, .external_lex_state = 2},
  [5622] = {.lex_state = 406, .external_lex_state = 2},
  [5623] = {.lex_state = 406, .external_lex_state = 6},
  [5624] = {.lex_state = 48, .external_lex_state = 2},
  [5625] = {.lex_state = 59, .external_lex_state = 9},
  [5626] = {.lex_state = 406, .external_lex_state = 2},
  [5627] = {.lex_state = 406, .external_lex_state = 2},
  [5628] = {.lex_state = 406, .external_lex_state = 5},
  [5629] = {.lex_state = 68, .external_lex_state = 9},
  [5630] = {.lex_state = 406, .external_lex_state = 5},
  [5631] = {.lex_state = 406, .external_lex_state = 5},
  [5632] = {.lex_state = 406, .external_lex_state = 5},
  [5633] = {.lex_state = 406, .external_lex_state = 5},
  [5634] = {.lex_state = 406, .external_lex_state = 5},
  [5635] = {.lex_state = 48, .external_lex_state = 2},
  [5636] = {.lex_state = 406, .external_lex_state = 5},
  [5637] = {.lex_state = 48, .external_lex_state = 2},
  [5638] = {.lex_state = 48, .external_lex_state = 2},
  [5639] = {.lex_state = 406, .external_lex_state = 5},
  [5640] = {.lex_state = 406, .external_lex_state = 5},
  [5641] = {.lex_state = 406, .external_lex_state = 5},
  [5642] = {.lex_state = 50, .external_lex_state = 2},
  [5643] = {.lex_state = 406, .external_lex_state = 2},
  [5644] = {.lex_state = 406, .external_lex_state = 5},
  [5645] = {.lex_state = 406, .external_lex_state = 5},
  [5646] = {.lex_state = 406, .external_lex_state = 5},
  [5647] = {.lex_state = 406, .external_lex_state = 5},
  [5648] = {.lex_state = 406, .external_lex_state = 2},
  [5649] = {.lex_state = 406, .external_lex_state = 5},
  [5650] = {.lex_state = 406, .external_lex_state = 5},
  [5651] = {.lex_state = 406, .external_lex_state = 2},
  [5652] = {.lex_state = 50, .external_lex_state = 5},
  [5653] = {.lex_state = 406, .external_lex_state = 5},
  [5654] = {.lex_state = 50, .external_lex_state = 5},
  [5655] = {.lex_state = 406, .external_lex_state = 5},
  [5656] = {.lex_state = 406, .external_lex_state = 5},
  [5657] = {.lex_state = 406, .external_lex_state = 5},
  [5658] = {.lex_state = 406, .external_lex_state = 5},
  [5659] = {.lex_state = 406, .external_lex_state = 5},
  [5660] = {.lex_state = 48, .external_lex_state = 2},
  [5661] = {.lex_state = 406, .external_lex_state = 5},
  [5662] = {.lex_state = 406, .external_lex_state = 5},
  [5663] = {.lex_state = 27, .external_lex_state = 2},
  [5664] = {.lex_state = 406, .external_lex_state = 5},
  [5665] = {.lex_state = 406, .external_lex_state = 5},
  [5666] = {.lex_state = 406, .external_lex_state = 2},
  [5667] = {.lex_state = 406, .external_lex_state = 2},
  [5668] = {.lex_state = 406, .external_lex_state = 2},
  [5669] = {.lex_state = 406, .external_lex_state = 2},
  [5670] = {.lex_state = 406, .external_lex_state = 2},
  [5671] = {.lex_state = 406, .external_lex_state = 5},
  [5672] = {.lex_state = 406, .external_lex_state = 5},
  [5673] = {.lex_state = 406, .external_lex_state = 5},
  [5674] = {.lex_state = 406, .external_lex_state = 5},
  [5675] = {.lex_state = 406, .external_lex_state = 5},
  [5676] = {.lex_state = 406, .external_lex_state = 5},
  [5677] = {.lex_state = 406, .external_lex_state = 2},
  [5678] = {.lex_state = 48, .external_lex_state = 2},
  [5679] = {.lex_state = 406, .external_lex_state = 5},
  [5680] = {.lex_state = 48, .external_lex_state = 2},
  [5681] = {.lex_state = 406, .external_lex_state = 5},
  [5682] = {.lex_state = 406, .external_lex_state = 5},
  [5683] = {.lex_state = 406, .external_lex_state = 5},
  [5684] = {.lex_state = 406, .external_lex_state = 5},
  [5685] = {.lex_state = 406, .external_lex_state = 5},
  [5686] = {.lex_state = 406, .external_lex_state = 5},
  [5687] = {.lex_state = 406, .external_lex_state = 5},
  [5688] = {.lex_state = 406, .external_lex_state = 5},
  [5689] = {.lex_state = 406, .external_lex_state = 5},
  [5690] = {.lex_state = 406, .external_lex_state = 5},
  [5691] = {.lex_state = 406, .external_lex_state = 5},
  [5692] = {.lex_state = 50, .external_lex_state = 2},
  [5693] = {.lex_state = 406, .external_lex_state = 2},
  [5694] = {.lex_state = 48, .external_lex_state = 2},
  [5695] = {.lex_state = 406, .external_lex_state = 5},
  [5696] = {.lex_state = 406, .external_lex_state = 5},
  [5697] = {.lex_state = 406, .external_lex_state = 5},
  [5698] = {.lex_state = 406, .external_lex_state = 5},
  [5699] = {.lex_state = 406, .external_lex_state = 5},
  [5700] = {.lex_state = 406, .external_lex_state = 5},
  [5701] = {.lex_state = 406, .external_lex_state = 5},
  [5702] = {.lex_state = 406, .external_lex_state = 5},
  [5703] = {.lex_state = 406, .external_lex_state = 5},
  [5704] = {.lex_state = 406, .external_lex_state = 5},
  [5705] = {.lex_state = 406, .external_lex_state = 5},
  [5706] = {.lex_state = 406, .external_lex_state = 2},
  [5707] = {.lex_state = 406, .external_lex_state = 5},
  [5708] = {.lex_state = 406, .external_lex_state = 5},
  [5709] = {.lex_state = 406, .external_lex_state = 5},
  [5710] = {.lex_state = 48, .external_lex_state = 2},
  [5711] = {.lex_state = 406, .external_lex_state = 5},
  [5712] = {.lex_state = 406, .external_lex_state = 5},
  [5713] = {.lex_state = 406, .external_lex_state = 5},
  [5714] = {.lex_state = 406, .external_lex_state = 2},
  [5715] = {.lex_state = 406, .external_lex_state = 2},
  [5716] = {.lex_state = 48, .external_lex_state = 2},
  [5717] = {.lex_state = 406, .external_lex_state = 5},
  [5718] = {.lex_state = 406, .external_lex_state = 5},
  [5719] = {.lex_state = 406, .external_lex_state = 5},
  [5720] = {.lex_state = 27, .external_lex_state = 2},
  [5721] = {.lex_state = 406, .external_lex_state = 5},
  [5722] = {.lex_state = 406, .external_lex_state = 2},
  [5723] = {.lex_state = 406, .external_lex_state = 2},
  [5724] = {.lex_state = 24, .external_lex_state = 2},
  [5725] = {.lex_state = 406, .external_lex_state = 5},
  [5726] = {.lex_state = 50, .external_lex_state = 2},
  [5727] = {.lex_state = 48, .external_lex_state = 2},
  [5728] = {.lex_state = 406, .external_lex_state = 5},
  [5729] = {.lex_state = 406, .external_lex_state = 5},
  [5730] = {.lex_state = 48, .external_lex_state = 2},
  [5731] = {.lex_state = 406, .external_lex_state = 5},
  [5732] = {.lex_state = 48, .external_lex_state = 2},
  [5733] = {.lex_state = 406, .external_lex_state = 5},
  [5734] = {.lex_state = 406, .external_lex_state = 5},
  [5735] = {.lex_state = 406, .external_lex_state = 5},
  [5736] = {.lex_state = 406, .external_lex_state = 5},
  [5737] = {.lex_state = 48, .external_lex_state = 2},
  [5738] = {.lex_state = 406, .external_lex_state = 5},
  [5739] = {.lex_state = 406, .external_lex_state = 2},
  [5740] = {.lex_state = 406, .external_lex_state = 2},
  [5741] = {.lex_state = 406, .external_lex_state = 5},
  [5742] = {.lex_state = 406, .external_lex_state = 5},
  [5743] = {.lex_state = 406, .external_lex_state = 2},
  [5744] = {.lex_state = 406, .external_lex_state = 5},
  [5745] = {.lex_state = 406, .external_lex_state = 5},
  [5746] = {.lex_state = 406, .external_lex_state = 5},
  [5747] = {.lex_state = 406, .external_lex_state = 5},
  [5748] = {.lex_state = 406, .external_lex_state = 2},
  [5749] = {.lex_state = 406, .external_lex_state = 5},
  [5750] = {.lex_state = 406, .external_lex_state = 5},
  [5751] = {.lex_state = 406, .external_lex_state = 5},
  [5752] = {.lex_state = 406, .external_lex_state = 5},
  [5753] = {.lex_state = 50, .external_lex_state = 2},
  [5754] = {.lex_state = 406, .external_lex_state = 5},
  [5755] = {.lex_state = 50, .external_lex_state = 2},
  [5756] = {.lex_state = 406, .external_lex_state = 5},
  [5757] = {.lex_state = 50, .external_lex_state = 2},
  [5758] = {.lex_state = 406, .external_lex_state = 5},
  [5759] = {.lex_state = 50, .external_lex_state = 2},
  [5760] = {.lex_state = 406, .external_lex_state = 5},
  [5761] = {.lex_state = 406, .external_lex_state = 2},
  [5762] = {.lex_state = 406, .external_lex_state = 2},
  [5763] = {.lex_state = 406, .external_lex_state = 2},
  [5764] = {.lex_state = 406, .external_lex_state = 5},
  [5765] = {.lex_state = 406, .external_lex_state = 5},
  [5766] = {.lex_state = 406, .external_lex_state = 5},
  [5767] = {.lex_state = 406, .external_lex_state = 5},
  [5768] = {.lex_state = 406, .external_lex_state = 2},
  [5769] = {.lex_state = 406, .external_lex_state = 5},
  [5770] = {.lex_state = 406, .external_lex_state = 2},
  [5771] = {.lex_state = 406, .external_lex_state = 5},
  [5772] = {.lex_state = 406, .external_lex_state = 5},
  [5773] = {.lex_state = 406, .external_lex_state = 2},
  [5774] = {.lex_state = 406, .external_lex_state = 2},
  [5775] = {.lex_state = 406, .external_lex_state = 5},
  [5776] = {.lex_state = 406, .external_lex_state = 2},
  [5777] = {.lex_state = 406, .external_lex_state = 2},
  [5778] = {.lex_state = 59, .external_lex_state = 9},
  [5779] = {.lex_state = 406, .external_lex_state = 5},
  [5780] = {.lex_state = 406, .external_lex_state = 5},
  [5781] = {.lex_state = 68, .external_lex_state = 9},
  [5782] = {.lex_state = 406, .external_lex_state = 5},
  [5783] = {.lex_state = 84, .external_lex_state = 2},
  [5784] = {.lex_state = 406, .external_lex_state = 5},
  [5785] = {.lex_state = 406, .external_lex_state = 2},
  [5786] = {.lex_state = 406, .external_lex_state = 5},
  [5787] = {.lex_state = 406, .external_lex_state = 5},
  [5788] = {.lex_state = 406, .external_lex_state = 5},
  [5789] = {.lex_state = 406, .external_lex_state = 5},
  [5790] = {.lex_state = 406, .external_lex_state = 5},
  [5791] = {.lex_state = 406, .external_lex_state = 5},
  [5792] = {.lex_state = 406, .external_lex_state = 2},
  [5793] = {.lex_state = 406, .external_lex_state = 5},
  [5794] = {.lex_state = 48, .external_lex_state = 2},
  [5795] = {.lex_state = 406, .external_lex_state = 5},
  [5796] = {.lex_state = 406, .external_lex_state = 5},
  [5797] = {.lex_state = 406, .external_lex_state = 5},
  [5798] = {.lex_state = 406, .external_lex_state = 5},
  [5799] = {.lex_state = 406, .external_lex_state = 5},
  [5800] = {.lex_state = 406, .external_lex_state = 5},
  [5801] = {.lex_state = 406, .external_lex_state = 5},
  [5802] = {.lex_state = 50, .external_lex_state = 2},
  [5803] = {.lex_state = 406, .external_lex_state = 5},
  [5804] = {.lex_state = 50, .external_lex_state = 2},
  [5805] = {.lex_state = 406, .external_lex_state = 5},
  [5806] = {.lex_state = 406, .external_lex_state = 5},
  [5807] = {.lex_state = 406, .external_lex_state = 5},
  [5808] = {.lex_state = 406, .external_lex_state = 5},
  [5809] = {.lex_state = 406, .external_lex_state = 5},
  [5810] = {.lex_state = 406, .external_lex_state = 2},
  [5811] = {.lex_state = 48, .external_lex_state = 2},
  [5812] = {.lex_state = 406, .external_lex_state = 5},
  [5813] = {.lex_state = 406, .external_lex_state = 5},
  [5814] = {.lex_state = 406, .external_lex_state = 5},
  [5815] = {.lex_state = 406, .external_lex_state = 5},
  [5816] = {.lex_state = 406, .external_lex_state = 2},
  [5817] = {.lex_state = 406, .external_lex_state = 5},
  [5818] = {.lex_state = 406, .external_lex_state = 2},
  [5819] = {.lex_state = 406, .external_lex_state = 2},
  [5820] = {.lex_state = 406, .external_lex_state = 5},
  [5821] = {.lex_state = 406, .external_lex_state = 5},
  [5822] = {.lex_state = 406, .external_lex_state = 2},
  [5823] = {.lex_state = 406, .external_lex_state = 5},
  [5824] = {.lex_state = 49, .external_lex_state = 2},
  [5825] = {.lex_state = 406, .external_lex_state = 5},
  [5826] = {.lex_state = 406, .external_lex_state = 5},
  [5827] = {.lex_state = 406, .external_lex_state = 5},
  [5828] = {.lex_state = 406, .external_lex_state = 5},
  [5829] = {.lex_state = 406, .external_lex_state = 2},
  [5830] = {.lex_state = 406, .external_lex_state = 5},
  [5831] = {.lex_state = 406, .external_lex_state = 5},
  [5832] = {.lex_state = 24, .external_lex_state = 2},
  [5833] = {.lex_state = 406, .external_lex_state = 5},
  [5834] = {.lex_state = 406, .external_lex_state = 5},
  [5835] = {.lex_state = 406, .external_lex_state = 8},
  [5836] = {.lex_state = 406, .external_lex_state = 2},
  [5837] = {.lex_state = 406, .external_lex_state = 5},
  [5838] = {.lex_state = 406, .external_lex_state = 5},
  [5839] = {.lex_state = 27, .external_lex_state = 2},
  [5840] = {.lex_state = 50, .external_lex_state = 5},
  [5841] = {.lex_state = 50, .external_lex_state = 5},
  [5842] = {.lex_state = 27, .external_lex_state = 2},
  [5843] = {.lex_state = 406, .external_lex_state = 5},
  [5844] = {.lex_state = 406, .external_lex_state = 5},
  [5845] = {.lex_state = 27, .external_lex_state = 2},
  [5846] = {.lex_state = 54, .external_lex_state = 2},
  [5847] = {.lex_state = 406, .external_lex_state = 2},
  [5848] = {.lex_state = 406, .external_lex_state = 2},
  [5849] = {.lex_state = 406, .external_lex_state = 5},
  [5850] = {.lex_state = 406, .external_lex_state = 5},
  [5851] = {.lex_state = 406, .external_lex_state = 5},
  [5852] = {.lex_state = 406, .external_lex_state = 5},
  [5853] = {.lex_state = 406, .external_lex_state = 5},
  [5854] = {.lex_state = 66, .external_lex_state = 2},
  [5855] = {.lex_state = 406, .external_lex_state = 5},
  [5856] = {.lex_state = 406, .external_lex_state = 5},
  [5857] = {.lex_state = 27, .external_lex_state = 2},
  [5858] = {.lex_state = 27, .external_lex_state = 2},
  [5859] = {.lex_state = 50, .external_lex_state = 2},
  [5860] = {.lex_state = 406, .external_lex_state = 5},
  [5861] = {.lex_state = 406, .external_lex_state = 5},
  [5862] = {.lex_state = 24, .external_lex_state = 2},
  [5863] = {.lex_state = 406, .external_lex_state = 2},
  [5864] = {.lex_state = 406, .external_lex_state = 2},
  [5865] = {.lex_state = 406, .external_lex_state = 5},
  [5866] = {.lex_state = 27, .external_lex_state = 2},
  [5867] = {.lex_state = 27, .external_lex_state = 2},
  [5868] = {.lex_state = 406, .external_lex_state = 2},
  [5869] = {.lex_state = 406, .external_lex_state = 2},
  [5870] = {.lex_state = 27, .external_lex_state = 2},
  [5871] = {.lex_state = 27, .external_lex_state = 2},
  [5872] = {.lex_state = 406, .external_lex_state = 5},
  [5873] = {.lex_state = 27, .external_lex_state = 2},
  [5874] = {.lex_state = 406, .external_lex_state = 2},
  [5875] = {.lex_state = 27, .external_lex_state = 2},
  [5876] = {.lex_state = 27, .external_lex_state = 2},
  [5877] = {.lex_state = 406, .external_lex_state = 5},
  [5878] = {.lex_state = 406, .external_lex_state = 5},
  [5879] = {.lex_state = 406, .external_lex_state = 5},
  [5880] = {.lex_state = 406, .external_lex_state = 5},
  [5881] = {.lex_state = 406, .external_lex_state = 5},
  [5882] = {.lex_state = 406, .external_lex_state = 5},
  [5883] = {.lex_state = 406, .external_lex_state = 5},
  [5884] = {.lex_state = 89, .external_lex_state = 2},
  [5885] = {.lex_state = 406, .external_lex_state = 2},
  [5886] = {.lex_state = 406, .external_lex_state = 5},
  [5887] = {.lex_state = 406, .external_lex_state = 5},
  [5888] = {.lex_state = 406, .external_lex_state = 5},
  [5889] = {.lex_state = 406, .external_lex_state = 5},
  [5890] = {.lex_state = 406, .external_lex_state = 2},
  [5891] = {.lex_state = 406, .external_lex_state = 5},
  [5892] = {.lex_state = 406, .external_lex_state = 5},
  [5893] = {.lex_state = 50, .external_lex_state = 2},
  [5894] = {.lex_state = 406, .external_lex_state = 5},
  [5895] = {.lex_state = 406, .external_lex_state = 2},
  [5896] = {.lex_state = 406, .external_lex_state = 5},
  [5897] = {.lex_state = 406, .external_lex_state = 2},
  [5898] = {.lex_state = 50, .external_lex_state = 2},
  [5899] = {.lex_state = 24, .external_lex_state = 2},
  [5900] = {.lex_state = 406, .external_lex_state = 5},
  [5901] = {.lex_state = 75, .external_lex_state = 2},
  [5902] = {.lex_state = 406, .external_lex_state = 5},
  [5903] = {.lex_state = 406, .external_lex_state = 5},
  [5904] = {.lex_state = 406, .external_lex_state = 5},
  [5905] = {.lex_state = 406, .external_lex_state = 5},
  [5906] = {.lex_state = 406, .external_lex_state = 2},
  [5907] = {.lex_state = 406, .external_lex_state = 2},
  [5908] = {.lex_state = 406, .external_lex_state = 5},
  [5909] = {.lex_state = 406, .external_lex_state = 5},
  [5910] = {.lex_state = 406, .external_lex_state = 5},
  [5911] = {.lex_state = 406, .external_lex_state = 5},
  [5912] = {.lex_state = 406, .external_lex_state = 5},
  [5913] = {.lex_state = 406, .external_lex_state = 2},
  [5914] = {.lex_state = 406, .external_lex_state = 5},
  [5915] = {.lex_state = 406, .external_lex_state = 5},
  [5916] = {.lex_state = 406, .external_lex_state = 5},
  [5917] = {.lex_state = 406, .external_lex_state = 5},
  [5918] = {.lex_state = 50, .external_lex_state = 5},
  [5919] = {.lex_state = 50, .external_lex_state = 5},
  [5920] = {.lex_state = 406, .external_lex_state = 5},
  [5921] = {.lex_state = 24, .external_lex_state = 2},
  [5922] = {.lex_state = 89, .external_lex_state = 2},
  [5923] = {.lex_state = 406, .external_lex_state = 2},
  [5924] = {.lex_state = 406, .external_lex_state = 5},
  [5925] = {.lex_state = 89, .external_lex_state = 2},
  [5926] = {.lex_state = 406, .external_lex_state = 5},
  [5927] = {.lex_state = 406, .external_lex_state = 5},
  [5928] = {.lex_state = 406, .external_lex_state = 5},
  [5929] = {.lex_state = 406, .external_lex_state = 2},
  [5930] = {.lex_state = 406, .external_lex_state = 5},
  [5931] = {.lex_state = 24, .external_lex_state = 2},
  [5932] = {.lex_state = 406, .external_lex_state = 5},
  [5933] = {.lex_state = 406, .external_lex_state = 5},
  [5934] = {.lex_state = 406, .external_lex_state = 2},
  [5935] = {.lex_state = 406, .external_lex_state = 2},
  [5936] = {.lex_state = 406, .external_lex_state = 5},
  [5937] = {.lex_state = 406, .external_lex_state = 5},
  [5938] = {.lex_state = 406, .external_lex_state = 5},
  [5939] = {.lex_state = 406, .external_lex_state = 5},
  [5940] = {.lex_state = 406, .external_lex_state = 5},
  [5941] = {.lex_state = 406, .external_lex_state = 5},
  [5942] = {.lex_state = 406, .external_lex_state = 5},
  [5943] = {.lex_state = 406, .external_lex_state = 5},
  [5944] = {.lex_state = 406, .external_lex_state = 5},
  [5945] = {.lex_state = 406, .external_lex_state = 5},
  [5946] = {.lex_state = 406, .external_lex_state = 5},
  [5947] = {.lex_state = 49, .external_lex_state = 2},
  [5948] = {.lex_state = 406, .external_lex_state = 5},
  [5949] = {.lex_state = 406, .external_lex_state = 5},
  [5950] = {.lex_state = 406, .external_lex_state = 5},
  [5951] = {.lex_state = 406, .external_lex_state = 5},
  [5952] = {.lex_state = 406, .external_lex_state = 2},
  [5953] = {.lex_state = 406, .external_lex_state = 2},
  [5954] = {.lex_state = 406, .external_lex_state = 5},
  [5955] = {.lex_state = 406, .external_lex_state = 5},
  [5956] = {.lex_state = 27, .external_lex_state = 2},
  [5957] = {.lex_state = 406, .external_lex_state = 5},
  [5958] = {.lex_state = 406, .external_lex_state = 5},
  [5959] = {.lex_state = 406, .external_lex_state = 2},
  [5960] = {.lex_state = 406, .external_lex_state = 2},
  [5961] = {.lex_state = 406, .external_lex_state = 2},
  [5962] = {.lex_state = 406, .external_lex_state = 5},
  [5963] = {.lex_state = 406, .external_lex_state = 5},
  [5964] = {.lex_state = 406, .external_lex_state = 5},
  [5965] = {.lex_state = 406, .external_lex_state = 5},
  [5966] = {.lex_state = 406, .external_lex_state = 2},
  [5967] = {.lex_state = 406, .external_lex_state = 5},
  [5968] = {.lex_state = 406, .external_lex_state = 2},
  [5969] = {.lex_state = 406, .external_lex_state = 5},
  [5970] = {.lex_state = 406, .external_lex_state = 2},
  [5971] = {.lex_state = 48, .external_lex_state = 2},
  [5972] = {.lex_state = 406, .external_lex_state = 2},
  [5973] = {.lex_state = 406, .external_lex_state = 5},
  [5974] = {.lex_state = 406, .external_lex_state = 2},
  [5975] = {.lex_state = 406, .external_lex_state = 5},
  [5976] = {.lex_state = 406, .external_lex_state = 5},
  [5977] = {.lex_state = 406, .external_lex_state = 5},
  [5978] = {.lex_state = 406, .external_lex_state = 5},
  [5979] = {.lex_state = 406, .external_lex_state = 5},
  [5980] = {.lex_state = 406, .external_lex_state = 5},
  [5981] = {.lex_state = 406, .external_lex_state = 5},
  [5982] = {.lex_state = 406, .external_lex_state = 5},
  [5983] = {.lex_state = 406, .external_lex_state = 5},
  [5984] = {.lex_state = 406, .external_lex_state = 5},
  [5985] = {.lex_state = 406, .external_lex_state = 2},
  [5986] = {.lex_state = 406, .external_lex_state = 5},
  [5987] = {.lex_state = 406, .external_lex_state = 5},
  [5988] = {.lex_state = 406, .external_lex_state = 5},
  [5989] = {.lex_state = 406, .external_lex_state = 5},
  [5990] = {.lex_state = 406, .external_lex_state = 5},
  [5991] = {.lex_state = 406, .external_lex_state = 5},
  [5992] = {.lex_state = 406, .external_lex_state = 5},
  [5993] = {.lex_state = 406, .external_lex_state = 5},
  [5994] = {.lex_state = 406, .external_lex_state = 5},
  [5995] = {.lex_state = 406, .external_lex_state = 5},
  [5996] = {.lex_state = 406, .external_lex_state = 2},
  [5997] = {.lex_state = 406, .external_lex_state = 5},
  [5998] = {.lex_state = 406, .external_lex_state = 5},
  [5999] = {.lex_state = 406, .external_lex_state = 5},
  [6000] = {.lex_state = 48, .external_lex_state = 2},
  [6001] = {.lex_state = 406, .external_lex_state = 5},
  [6002] = {.lex_state = 406, .external_lex_state = 5},
  [6003] = {.lex_state = 406, .external_lex_state = 5},
  [6004] = {.lex_state = 406, .external_lex_state = 5},
  [6005] = {.lex_state = 406, .external_lex_state = 5},
  [6006] = {.lex_state = 89, .external_lex_state = 2},
  [6007] = {.lex_state = 406, .external_lex_state = 5},
  [6008] = {.lex_state = 406, .external_lex_state = 5},
  [6009] = {.lex_state = 406, .external_lex_state = 5},
  [6010] = {.lex_state = 27, .external_lex_state = 2},
  [6011] = {.lex_state = 406, .external_lex_state = 5},
  [6012] = {.lex_state = 406, .external_lex_state = 2},
  [6013] = {.lex_state = 406, .external_lex_state = 2},
  [6014] = {.lex_state = 406, .external_lex_state = 5},
  [6015] = {.lex_state = 48, .external_lex_state = 2},
  [6016] = {.lex_state = 406, .external_lex_state = 5},
  [6017] = {.lex_state = 48, .external_lex_state = 2},
  [6018] = {.lex_state = 406, .external_lex_state = 5},
  [6019] = {.lex_state = 48, .external_lex_state = 2},
  [6020] = {.lex_state = 406, .external_lex_state = 5},
  [6021] = {.lex_state = 406, .external_lex_state = 5},
  [6022] = {.lex_state = 50, .external_lex_state = 2},
  [6023] = {.lex_state = 406, .external_lex_state = 5},
  [6024] = {.lex_state = 24, .external_lex_state = 2},
  [6025] = {.lex_state = 406, .external_lex_state = 5},
  [6026] = {.lex_state = 406, .external_lex_state = 5},
  [6027] = {.lex_state = 406, .external_lex_state = 5},
  [6028] = {.lex_state = 406, .external_lex_state = 5},
  [6029] = {.lex_state = 406, .external_lex_state = 5},
  [6030] = {.lex_state = 406, .external_lex_state = 5},
  [6031] = {.lex_state = 406, .external_lex_state = 5},
  [6032] = {.lex_state = 406, .external_lex_state = 5},
  [6033] = {.lex_state = 406, .external_lex_state = 5},
  [6034] = {.lex_state = 406, .external_lex_state = 5},
  [6035] = {.lex_state = 406, .external_lex_state = 5},
  [6036] = {.lex_state = 406, .external_lex_state = 5},
  [6037] = {.lex_state = 406, .external_lex_state = 5},
  [6038] = {.lex_state = 406, .external_lex_state = 5},
  [6039] = {.lex_state = 406, .external_lex_state = 5},
  [6040] = {.lex_state = 406, .external_lex_state = 5},
  [6041] = {.lex_state = 406, .external_lex_state = 5},
  [6042] = {.lex_state = 406, .external_lex_state = 5},
  [6043] = {.lex_state = 406, .external_lex_state = 5},
  [6044] = {.lex_state = 406, .external_lex_state = 2},
  [6045] = {.lex_state = 48, .external_lex_state = 2},
  [6046] = {.lex_state = 406, .external_lex_state = 5},
  [6047] = {.lex_state = 406, .external_lex_state = 5},
  [6048] = {.lex_state = 406, .external_lex_state = 5},
  [6049] = {.lex_state = 406, .external_lex_state = 5},
  [6050] = {.lex_state = 27, .external_lex_state = 2},
  [6051] = {.lex_state = 406, .external_lex_state = 2},
  [6052] = {.lex_state = 406, .external_lex_state = 5},
  [6053] = {.lex_state = 406, .external_lex_state = 2},
  [6054] = {.lex_state = 406, .external_lex_state = 5},
  [6055] = {.lex_state = 406, .external_lex_state = 5},
  [6056] = {.lex_state = 406, .external_lex_state = 5},
  [6057] = {.lex_state = 406, .external_lex_state = 5},
  [6058] = {.lex_state = 406, .external_lex_state = 2},
  [6059] = {.lex_state = 406, .external_lex_state = 5},
  [6060] = {.lex_state = 406, .external_lex_state = 2},
  [6061] = {.lex_state = 406, .external_lex_state = 2},
  [6062] = {.lex_state = 406, .external_lex_state = 5},
  [6063] = {.lex_state = 406, .external_lex_state = 5},
  [6064] = {.lex_state = 406, .external_lex_state = 5},
  [6065] = {.lex_state = 406, .external_lex_state = 5},
  [6066] = {.lex_state = 406, .external_lex_state = 5},
  [6067] = {.lex_state = 406, .external_lex_state = 5},
  [6068] = {.lex_state = 406, .external_lex_state = 5},
  [6069] = {.lex_state = 2, .external_lex_state = 2},
  [6070] = {.lex_state = 406, .external_lex_state = 5},
  [6071] = {.lex_state = 48, .external_lex_state = 2},
  [6072] = {.lex_state = 406, .external_lex_state = 5},
  [6073] = {.lex_state = 406, .external_lex_state = 5},
  [6074] = {.lex_state = 75, .external_lex_state = 2},
  [6075] = {.lex_state = 406, .external_lex_state = 5},
  [6076] = {.lex_state = 406, .external_lex_state = 5},
  [6077] = {.lex_state = 406, .external_lex_state = 5},
  [6078] = {.lex_state = 406, .external_lex_state = 5},
  [6079] = {.lex_state = 48, .external_lex_state = 2},
  [6080] = {.lex_state = 406, .external_lex_state = 5},
  [6081] = {.lex_state = 24, .external_lex_state = 2},
  [6082] = {.lex_state = 406, .external_lex_state = 5},
  [6083] = {.lex_state = 406, .external_lex_state = 5},
  [6084] = {.lex_state = 406, .external_lex_state = 2},
  [6085] = {.lex_state = 406, .external_lex_state = 5},
  [6086] = {.lex_state = 406, .external_lex_state = 5},
  [6087] = {.lex_state = 406, .external_lex_state = 5},
  [6088] = {.lex_state = 406, .external_lex_state = 5},
  [6089] = {.lex_state = 406, .external_lex_state = 5},
  [6090] = {.lex_state = 406, .external_lex_state = 5},
  [6091] = {.lex_state = 406, .external_lex_state = 5},
  [6092] = {.lex_state = 406, .external_lex_state = 5},
  [6093] = {.lex_state = 406, .external_lex_state = 5},
  [6094] = {.lex_state = 406, .external_lex_state = 5},
  [6095] = {.lex_state = 406, .external_lex_state = 5},
  [6096] = {.lex_state = 48, .external_lex_state = 2},
  [6097] = {.lex_state = 406, .external_lex_state = 5},
  [6098] = {.lex_state = 406, .external_lex_state = 2},
  [6099] = {.lex_state = 406, .external_lex_state = 5},
  [6100] = {.lex_state = 406, .external_lex_state = 2},
  [6101] = {.lex_state = 406, .external_lex_state = 2},
  [6102] = {.lex_state = 406, .external_lex_state = 5},
  [6103] = {.lex_state = 406, .external_lex_state = 5},
  [6104] = {.lex_state = 406, .external_lex_state = 5},
  [6105] = {.lex_state = 406, .external_lex_state = 2},
  [6106] = {.lex_state = 406, .external_lex_state = 5},
  [6107] = {.lex_state = 406, .external_lex_state = 5},
  [6108] = {.lex_state = 406, .external_lex_state = 5},
  [6109] = {.lex_state = 50, .external_lex_state = 5},
  [6110] = {.lex_state = 50, .external_lex_state = 5},
  [6111] = {.lex_state = 406, .external_lex_state = 2},
  [6112] = {.lex_state = 24, .external_lex_state = 2},
  [6113] = {.lex_state = 55, .external_lex_state = 2},
  [6114] = {.lex_state = 406, .external_lex_state = 5},
  [6115] = {.lex_state = 55, .external_lex_state = 2},
  [6116] = {.lex_state = 406, .external_lex_state = 2},
  [6117] = {.lex_state = 84, .external_lex_state = 2},
  [6118] = {.lex_state = 406, .external_lex_state = 5},
  [6119] = {.lex_state = 406, .external_lex_state = 2},
  [6120] = {.lex_state = 50, .external_lex_state = 5},
  [6121] = {.lex_state = 50, .external_lex_state = 5},
  [6122] = {.lex_state = 406, .external_lex_state = 5},
  [6123] = {.lex_state = 406, .external_lex_state = 5},
  [6124] = {.lex_state = 406, .external_lex_state = 5},
  [6125] = {.lex_state = 406, .external_lex_state = 5},
  [6126] = {.lex_state = 406, .external_lex_state = 5},
  [6127] = {.lex_state = 406, .external_lex_state = 5},
  [6128] = {.lex_state = 50, .external_lex_state = 2},
  [6129] = {.lex_state = 406, .external_lex_state = 5},
  [6130] = {.lex_state = 406, .external_lex_state = 5},
  [6131] = {.lex_state = 406, .external_lex_state = 5},
  [6132] = {.lex_state = 406, .external_lex_state = 5},
  [6133] = {.lex_state = 50, .external_lex_state = 2},
  [6134] = {.lex_state = 406, .external_lex_state = 5},
  [6135] = {.lex_state = 406, .external_lex_state = 5},
  [6136] = {.lex_state = 406, .external_lex_state = 5},
  [6137] = {.lex_state = 406, .external_lex_state = 2},
  [6138] = {.lex_state = 406, .external_lex_state = 5},
  [6139] = {.lex_state = 406, .external_lex_state = 5},
  [6140] = {.lex_state = 406, .external_lex_state = 2},
  [6141] = {.lex_state = 406, .external_lex_state = 2},
  [6142] = {.lex_state = 406, .external_lex_state = 2},
  [6143] = {.lex_state = 406, .external_lex_state = 2},
  [6144] = {.lex_state = 89, .external_lex_state = 2},
  [6145] = {.lex_state = 406, .external_lex_state = 2},
  [6146] = {.lex_state = 406, .external_lex_state = 2},
  [6147] = {.lex_state = 406, .external_lex_state = 2},
  [6148] = {.lex_state = 406, .external_lex_state = 5},
  [6149] = {.lex_state = 406, .external_lex_state = 5},
  [6150] = {.lex_state = 406, .external_lex_state = 5},
  [6151] = {.lex_state = 406, .external_lex_state = 2},
  [6152] = {.lex_state = 406, .external_lex_state = 5},
  [6153] = {.lex_state = 406, .external_lex_state = 2},
  [6154] = {.lex_state = 84, .external_lex_state = 2},
  [6155] = {.lex_state = 406, .external_lex_state = 2},
  [6156] = {.lex_state = 406, .external_lex_state = 2},
  [6157] = {.lex_state = 75, .external_lex_state = 2},
  [6158] = {.lex_state = 406, .external_lex_state = 2},
  [6159] = {.lex_state = 27, .external_lex_state = 2},
  [6160] = {.lex_state = 406, .external_lex_state = 2},
  [6161] = {.lex_state = 406, .external_lex_state = 2},
  [6162] = {.lex_state = 50, .external_lex_state = 2},
  [6163] = {.lex_state = 24, .external_lex_state = 2},
  [6164] = {.lex_state = 406, .external_lex_state = 8},
  [6165] = {.lex_state = 48, .external_lex_state = 2},
  [6166] = {.lex_state = 406, .external_lex_state = 2},
  [6167] = {.lex_state = 27, .external_lex_state = 2},
  [6168] = {.lex_state = 406, .external_lex_state = 5},
  [6169] = {.lex_state = 406, .external_lex_state = 5},
  [6170] = {.lex_state = 406, .external_lex_state = 5},
  [6171] = {.lex_state = 48, .external_lex_state = 2},
  [6172] = {.lex_state = 406, .external_lex_state = 5},
  [6173] = {.lex_state = 50, .external_lex_state = 2},
  [6174] = {.lex_state = 406, .external_lex_state = 5},
  [6175] = {.lex_state = 50, .external_lex_state = 2},
  [6176] = {.lex_state = 406, .external_lex_state = 5},
  [6177] = {.lex_state = 48, .external_lex_state = 2},
  [6178] = {.lex_state = 50, .external_lex_state = 2},
  [6179] = {.lex_state = 406, .external_lex_state = 5},
  [6180] = {.lex_state = 406, .external_lex_state = 5},
  [6181] = {.lex_state = 406, .external_lex_state = 5},
  [6182] = {.lex_state = 406, .external_lex_state = 5},
  [6183] = {.lex_state = 406, .external_lex_state = 5},
  [6184] = {.lex_state = 27, .external_lex_state = 2},
  [6185] = {.lex_state = 406, .external_lex_state = 5},
  [6186] = {.lex_state = 406, .external_lex_state = 5},
  [6187] = {.lex_state = 406, .external_lex_state = 5},
  [6188] = {.lex_state = 406, .external_lex_state = 2},
  [6189] = {.lex_state = 406, .external_lex_state = 2},
  [6190] = {.lex_state = 406, .external_lex_state = 5},
  [6191] = {.lex_state = 406, .external_lex_state = 5},
  [6192] = {.lex_state = 406, .external_lex_state = 2},
  [6193] = {.lex_state = 48, .external_lex_state = 2},
  [6194] = {.lex_state = 406, .external_lex_state = 2},
  [6195] = {.lex_state = 406, .external_lex_state = 2},
  [6196] = {.lex_state = 406, .external_lex_state = 2},
  [6197] = {.lex_state = 48, .external_lex_state = 2},
  [6198] = {.lex_state = 48, .external_lex_state = 2},
  [6199] = {.lex_state = 406, .external_lex_state = 2},
  [6200] = {.lex_state = 406, .external_lex_state = 5},
  [6201] = {.lex_state = 50, .external_lex_state = 2},
  [6202] = {.lex_state = 406, .external_lex_state = 5},
  [6203] = {.lex_state = 406, .external_lex_state = 5},
  [6204] = {.lex_state = 406, .external_lex_state = 2},
  [6205] = {.lex_state = 406, .external_lex_state = 2},
  [6206] = {.lex_state = 406, .external_lex_state = 2},
  [6207] = {.lex_state = 406, .external_lex_state = 2},
  [6208] = {.lex_state = 406, .external_lex_state = 2},
  [6209] = {.lex_state = 27, .external_lex_state = 2},
  [6210] = {.lex_state = 406, .external_lex_state = 5},
  [6211] = {.lex_state = 406, .external_lex_state = 5},
  [6212] = {.lex_state = 406, .external_lex_state = 5},
  [6213] = {.lex_state = 406, .external_lex_state = 2},
  [6214] = {.lex_state = 406, .external_lex_state = 2},
  [6215] = {.lex_state = 406, .external_lex_state = 5},
  [6216] = {.lex_state = 406, .external_lex_state = 5},
  [6217] = {.lex_state = 406, .external_lex_state = 5},
  [6218] = {.lex_state = 406, .external_lex_state = 2},
  [6219] = {.lex_state = 406, .external_lex_state = 5},
  [6220] = {.lex_state = 406, .external_lex_state = 5},
  [6221] = {.lex_state = 406, .external_lex_state = 2},
  [6222] = {.lex_state = 406, .external_lex_state = 5},
  [6223] = {.lex_state = 406, .external_lex_state = 5},
  [6224] = {.lex_state = 406, .external_lex_state = 2},
  [6225] = {.lex_state = 406, .external_lex_state = 5},
  [6226] = {.lex_state = 406, .external_lex_state = 5},
  [6227] = {.lex_state = 48, .external_lex_state = 2},
  [6228] = {.lex_state = 406, .external_lex_state = 5},
  [6229] = {.lex_state = 48, .external_lex_state = 2},
  [6230] = {.lex_state = 48, .external_lex_state = 2},
  [6231] = {.lex_state = 406, .external_lex_state = 5},
  [6232] = {.lex_state = 48, .external_lex_state = 2},
  [6233] = {.lex_state = 406, .external_lex_state = 2},
  [6234] = {.lex_state = 406, .external_lex_state = 5},
  [6235] = {.lex_state = 406, .external_lex_state = 5},
  [6236] = {.lex_state = 406, .external_lex_state = 5},
  [6237] = {.lex_state = 406, .external_lex_state = 5},
  [6238] = {.lex_state = 406, .external_lex_state = 5},
  [6239] = {.lex_state = 406, .external_lex_state = 2},
  [6240] = {.lex_state = 406, .external_lex_state = 2},
  [6241] = {.lex_state = 406, .external_lex_state = 5},
  [6242] = {.lex_state = 27, .external_lex_state = 2},
  [6243] = {.lex_state = 406, .external_lex_state = 5},
  [6244] = {.lex_state = 406, .external_lex_state = 2},
  [6245] = {.lex_state = 406, .external_lex_state = 2},
  [6246] = {.lex_state = 406, .external_lex_state = 2},
  [6247] = {.lex_state = 406, .external_lex_state = 2},
  [6248] = {.lex_state = 55, .external_lex_state = 2},
  [6249] = {.lex_state = 48, .external_lex_state = 2},
  [6250] = {.lex_state = 406, .external_lex_state = 5},
  [6251] = {.lex_state = 406, .external_lex_state = 5},
  [6252] = {.lex_state = 406, .external_lex_state = 5},
  [6253] = {.lex_state = 55, .external_lex_state = 2},
  [6254] = {.lex_state = 406, .external_lex_state = 2},
  [6255] = {.lex_state = 406, .external_lex_state = 2},
  [6256] = {.lex_state = 406, .external_lex_state = 5},
  [6257] = {.lex_state = 27, .external_lex_state = 2},
  [6258] = {.lex_state = 406, .external_lex_state = 5},
  [6259] = {.lex_state = 406, .external_lex_state = 2},
  [6260] = {.lex_state = 406, .external_lex_state = 2},
  [6261] = {.lex_state = 406, .external_lex_state = 2},
  [6262] = {.lex_state = 48, .external_lex_state = 2},
  [6263] = {.lex_state = 406, .external_lex_state = 2},
  [6264] = {.lex_state = 48, .external_lex_state = 2},
  [6265] = {.lex_state = 406, .external_lex_state = 5},
  [6266] = {.lex_state = 48, .external_lex_state = 2},
  [6267] = {.lex_state = 406, .external_lex_state = 2},
  [6268] = {.lex_state = 406, .external_lex_state = 5},
  [6269] = {.lex_state = 406, .external_lex_state = 5},
  [6270] = {.lex_state = 406, .external_lex_state = 5},
  [6271] = {.lex_state = 406, .external_lex_state = 5},
  [6272] = {.lex_state = 406, .external_lex_state = 5},
  [6273] = {.lex_state = 48, .external_lex_state = 2},
  [6274] = {.lex_state = 48, .external_lex_state = 2},
  [6275] = {.lex_state = 406, .external_lex_state = 5},
  [6276] = {.lex_state = 48, .external_lex_state = 2},
  [6277] = {.lex_state = 48, .external_lex_state = 2},
  [6278] = {.lex_state = 406, .external_lex_state = 2},
  [6279] = {.lex_state = 406, .external_lex_state = 5},
  [6280] = {.lex_state = 406, .external_lex_state = 2},
  [6281] = {.lex_state = 406, .external_lex_state = 2},
  [6282] = {.lex_state = 27, .external_lex_state = 2},
  [6283] = {.lex_state = 406, .external_lex_state = 5},
  [6284] = {.lex_state = 406, .external_lex_state = 5},
  [6285] = {.lex_state = 406, .external_lex_state = 5},
  [6286] = {.lex_state = 406, .external_lex_state = 5},
  [6287] = {.lex_state = 50, .external_lex_state = 2},
  [6288] = {.lex_state = 406, .external_lex_state = 5},
  [6289] = {.lex_state = 50, .external_lex_state = 2},
  [6290] = {.lex_state = 406, .external_lex_state = 5},
  [6291] = {.lex_state = 50, .external_lex_state = 2},
  [6292] = {.lex_state = 406, .external_lex_state = 2},
  [6293] = {.lex_state = 50, .external_lex_state = 2},
  [6294] = {.lex_state = 406, .external_lex_state = 5},
  [6295] = {.lex_state = 406, .external_lex_state = 2},
  [6296] = {.lex_state = 406, .external_lex_state = 5},
  [6297] = {.lex_state = 406, .external_lex_state = 5},
  [6298] = {.lex_state = 406, .external_lex_state = 5},
  [6299] = {.lex_state = 406, .external_lex_state = 2},
  [6300] = {.lex_state = 406, .external_lex_state = 2},
  [6301] = {.lex_state = 27, .external_lex_state = 2},
  [6302] = {.lex_state = 406, .external_lex_state = 2},
  [6303] = {.lex_state = 406, .external_lex_state = 5},
  [6304] = {.lex_state = 406, .external_lex_state = 2},
  [6305] = {.lex_state = 406, .external_lex_state = 5},
  [6306] = {.lex_state = 406, .external_lex_state = 5},
  [6307] = {.lex_state = 406, .external_lex_state = 5},
  [6308] = {.lex_state = 406, .external_lex_state = 5},
  [6309] = {.lex_state = 406, .external_lex_state = 2},
  [6310] = {.lex_state = 406, .external_lex_state = 2},
  [6311] = {.lex_state = 48, .external_lex_state = 2},
  [6312] = {.lex_state = 406, .external_lex_state = 5},
  [6313] = {.lex_state = 406, .external_lex_state = 5},
  [6314] = {.lex_state = 406, .external_lex_state = 5},
  [6315] = {.lex_state = 48, .external_lex_state = 2},
  [6316] = {.lex_state = 406, .external_lex_state = 5},
  [6317] = {.lex_state = 406, .external_lex_state = 5},
  [6318] = {.lex_state = 406, .external_lex_state = 5},
  [6319] = {.lex_state = 406, .external_lex_state = 5},
  [6320] = {.lex_state = 406, .external_lex_state = 5},
  [6321] = {.lex_state = 406, .external_lex_state = 5},
  [6322] = {.lex_state = 27, .external_lex_state = 2},
  [6323] = {.lex_state = 406, .external_lex_state = 2},
  [6324] = {.lex_state = 406, .external_lex_state = 2},
  [6325] = {.lex_state = 406, .external_lex_state = 5},
  [6326] = {.lex_state = 48, .external_lex_state = 2},
  [6327] = {.lex_state = 406, .external_lex_state = 5},
  [6328] = {.lex_state = 406, .external_lex_state = 5},
  [6329] = {.lex_state = 406, .external_lex_state = 5},
  [6330] = {.lex_state = 406, .external_lex_state = 5},
  [6331] = {.lex_state = 406, .external_lex_state = 5},
  [6332] = {.lex_state = 48, .external_lex_state = 2},
  [6333] = {.lex_state = 406, .external_lex_state = 5},
  [6334] = {.lex_state = 50, .external_lex_state = 2},
  [6335] = {.lex_state = 406, .external_lex_state = 2},
  [6336] = {.lex_state = 406, .external_lex_state = 2},
  [6337] = {.lex_state = 406, .external_lex_state = 2},
  [6338] = {.lex_state = 406, .external_lex_state = 2},
  [6339] = {.lex_state = 406, .external_lex_state = 2},
  [6340] = {.lex_state = 406, .external_lex_state = 2},
  [6341] = {.lex_state = 406, .external_lex_state = 2},
  [6342] = {.lex_state = 406, .external_lex_state = 2},
  [6343] = {.lex_state = 406, .external_lex_state = 2},
  [6344] = {.lex_state = 406, .external_lex_state = 2},
  [6345] = {.lex_state = 406, .external_lex_state = 2},
  [6346] = {.lex_state = 50, .external_lex_state = 2},
  [6347] = {.lex_state = 406, .external_lex_state = 2},
  [6348] = {.lex_state = 406, .external_lex_state = 2},
  [6349] = {.lex_state = 50, .external_lex_state = 2},
  [6350] = {.lex_state = 406, .external_lex_state = 2},
  [6351] = {.lex_state = 50, .external_lex_state = 2},
  [6352] = {.lex_state = 406, .external_lex_state = 2},
  [6353] = {.lex_state = 406, .external_lex_state = 2},
  [6354] = {.lex_state = 406, .external_lex_state = 5},
  [6355] = {.lex_state = 406, .external_lex_state = 2},
  [6356] = {.lex_state = 50, .external_lex_state = 2},
  [6357] = {.lex_state = 406, .external_lex_state = 2},
  [6358] = {.lex_state = 406, .external_lex_state = 2},
  [6359] = {.lex_state = 406, .external_lex_state = 5},
  [6360] = {.lex_state = 406, .external_lex_state = 2},
  [6361] = {.lex_state = 406, .external_lex_state = 2},
  [6362] = {.lex_state = 406, .external_lex_state = 2},
  [6363] = {.lex_state = 406, .external_lex_state = 5},
  [6364] = {.lex_state = 406, .external_lex_state = 2},
  [6365] = {.lex_state = 406, .external_lex_state = 5},
  [6366] = {.lex_state = 406, .external_lex_state = 2},
  [6367] = {.lex_state = 406, .external_lex_state = 2},
  [6368] = {.lex_state = 50, .external_lex_state = 2},
  [6369] = {.lex_state = 406, .external_lex_state = 2},
  [6370] = {.lex_state = 2, .external_lex_state = 2},
  [6371] = {.lex_state = 406, .external_lex_state = 2},
  [6372] = {.lex_state = 406, .external_lex_state = 2},
  [6373] = {.lex_state = 406, .external_lex_state = 5},
  [6374] = {.lex_state = 406, .external_lex_state = 2},
  [6375] = {.lex_state = 406, .external_lex_state = 5},
  [6376] = {.lex_state = 406, .external_lex_state = 2},
  [6377] = {.lex_state = 406, .external_lex_state = 5},
  [6378] = {.lex_state = 406, .external_lex_state = 2},
  [6379] = {.lex_state = 406, .external_lex_state = 2},
  [6380] = {.lex_state = 406, .external_lex_state = 2},
  [6381] = {.lex_state = 406, .external_lex_state = 2},
  [6382] = {.lex_state = 406, .external_lex_state = 5},
  [6383] = {.lex_state = 406, .external_lex_state = 5},
  [6384] = {.lex_state = 406, .external_lex_state = 5},
  [6385] = {.lex_state = 406, .external_lex_state = 2},
  [6386] = {.lex_state = 48, .external_lex_state = 2},
  [6387] = {.lex_state = 406, .external_lex_state = 2},
  [6388] = {.lex_state = 50, .external_lex_state = 2},
  [6389] = {.lex_state = 406, .external_lex_state = 2},
  [6390] = {.lex_state = 50, .external_lex_state = 2},
  [6391] = {.lex_state = 406, .external_lex_state = 2},
  [6392] = {.lex_state = 406, .external_lex_state = 2},
  [6393] = {.lex_state = 406, .external_lex_state = 5},
  [6394] = {.lex_state = 406, .external_lex_state = 5},
  [6395] = {.lex_state = 406, .external_lex_state = 2},
  [6396] = {.lex_state = 406, .external_lex_state = 2},
  [6397] = {.lex_state = 48, .external_lex_state = 2},
  [6398] = {.lex_state = 406, .external_lex_state = 2},
  [6399] = {.lex_state = 406, .external_lex_state = 2},
  [6400] = {.lex_state = 406, .external_lex_state = 2},
  [6401] = {.lex_state = 406, .external_lex_state = 2},
  [6402] = {.lex_state = 406, .external_lex_state = 2},
  [6403] = {.lex_state = 406, .external_lex_state = 2},
  [6404] = {.lex_state = 406, .external_lex_state = 2},
  [6405] = {.lex_state = 406, .external_lex_state = 2},
  [6406] = {.lex_state = 406, .external_lex_state = 5},
  [6407] = {.lex_state = 50, .external_lex_state = 2},
  [6408] = {.lex_state = 50, .external_lex_state = 2},
  [6409] = {.lex_state = 406, .external_lex_state = 2},
  [6410] = {.lex_state = 406, .external_lex_state = 5},
  [6411] = {.lex_state = 406, .external_lex_state = 5},
  [6412] = {.lex_state = 406, .external_lex_state = 2},
  [6413] = {.lex_state = 406, .external_lex_state = 5},
  [6414] = {.lex_state = 406, .external_lex_state = 5},
  [6415] = {.lex_state = 50, .external_lex_state = 2},
  [6416] = {.lex_state = 406, .external_lex_state = 2},
  [6417] = {.lex_state = 50, .external_lex_state = 2},
  [6418] = {.lex_state = 406, .external_lex_state = 5},
  [6419] = {.lex_state = 406, .external_lex_state = 2},
  [6420] = {.lex_state = 406, .external_lex_state = 2},
  [6421] = {.lex_state = 50, .external_lex_state = 2},
  [6422] = {.lex_state = 406, .external_lex_state = 5},
  [6423] = {.lex_state = 406, .external_lex_state = 2},
  [6424] = {.lex_state = 406, .external_lex_state = 2},
  [6425] = {.lex_state = 406, .external_lex_state = 2},
  [6426] = {.lex_state = 406, .external_lex_state = 2},
  [6427] = {.lex_state = 406, .external_lex_state = 2},
  [6428] = {.lex_state = 48, .external_lex_state = 2},
  [6429] = {.lex_state = 406, .external_lex_state = 5},
  [6430] = {.lex_state = 406, .external_lex_state = 2},
  [6431] = {.lex_state = 49, .external_lex_state = 2},
  [6432] = {.lex_state = 406, .external_lex_state = 2},
  [6433] = {.lex_state = 406, .external_lex_state = 2},
  [6434] = {.lex_state = 406, .external_lex_state = 2},
  [6435] = {.lex_state = 406, .external_lex_state = 5},
  [6436] = {.lex_state = 406, .external_lex_state = 2},
  [6437] = {.lex_state = 48, .external_lex_state = 2},
  [6438] = {.lex_state = 406, .external_lex_state = 5},
  [6439] = {.lex_state = 406, .external_lex_state = 2},
  [6440] = {.lex_state = 406, .external_lex_state = 5},
  [6441] = {.lex_state = 406, .external_lex_state = 2},
  [6442] = {.lex_state = 406, .external_lex_state = 2},
  [6443] = {.lex_state = 406, .external_lex_state = 2},
  [6444] = {.lex_state = 406, .external_lex_state = 2},
  [6445] = {.lex_state = 406, .external_lex_state = 2},
  [6446] = {.lex_state = 406, .external_lex_state = 2},
  [6447] = {.lex_state = 406, .external_lex_state = 2},
  [6448] = {.lex_state = 406, .external_lex_state = 2},
  [6449] = {.lex_state = 50, .external_lex_state = 2},
  [6450] = {.lex_state = 50, .external_lex_state = 2},
  [6451] = {.lex_state = 406, .external_lex_state = 2},
  [6452] = {.lex_state = 406, .external_lex_state = 2},
  [6453] = {.lex_state = 406, .external_lex_state = 2},
  [6454] = {.lex_state = 406, .external_lex_state = 2},
  [6455] = {.lex_state = 406, .external_lex_state = 2},
  [6456] = {.lex_state = 406, .external_lex_state = 2},
  [6457] = {.lex_state = 406, .external_lex_state = 2},
  [6458] = {.lex_state = 406, .external_lex_state = 2},
  [6459] = {.lex_state = 406, .external_lex_state = 5},
  [6460] = {.lex_state = 406, .external_lex_state = 2},
  [6461] = {.lex_state = 406, .external_lex_state = 2},
  [6462] = {.lex_state = 406, .external_lex_state = 2},
  [6463] = {.lex_state = 406, .external_lex_state = 2},
  [6464] = {.lex_state = 406, .external_lex_state = 2},
  [6465] = {.lex_state = 406, .external_lex_state = 2},
  [6466] = {.lex_state = 406, .external_lex_state = 2},
  [6467] = {.lex_state = 406, .external_lex_state = 2},
  [6468] = {.lex_state = 406, .external_lex_state = 2},
  [6469] = {.lex_state = 406, .external_lex_state = 2},
  [6470] = {.lex_state = 406, .external_lex_state = 2},
  [6471] = {.lex_state = 406, .external_lex_state = 2},
  [6472] = {.lex_state = 406, .external_lex_state = 2},
  [6473] = {.lex_state = 406, .external_lex_state = 2},
  [6474] = {.lex_state = 406, .external_lex_state = 2},
  [6475] = {.lex_state = 406, .external_lex_state = 2},
  [6476] = {.lex_state = 50, .external_lex_state = 2},
  [6477] = {.lex_state = 406, .external_lex_state = 2},
  [6478] = {.lex_state = 406, .external_lex_state = 2},
  [6479] = {.lex_state = 406, .external_lex_state = 2},
  [6480] = {.lex_state = 406, .external_lex_state = 5},
  [6481] = {.lex_state = 406, .external_lex_state = 2},
  [6482] = {.lex_state = 406, .external_lex_state = 2},
  [6483] = {.lex_state = 406, .external_lex_state = 2},
  [6484] = {.lex_state = 406, .external_lex_state = 5},
  [6485] = {.lex_state = 406, .external_lex_state = 2},
  [6486] = {.lex_state = 406, .external_lex_state = 2},
  [6487] = {.lex_state = 406, .external_lex_state = 2},
  [6488] = {.lex_state = 406, .external_lex_state = 2},
  [6489] = {.lex_state = 50, .external_lex_state = 2},
  [6490] = {.lex_state = 406, .external_lex_state = 2},
  [6491] = {.lex_state = 406, .external_lex_state = 2},
  [6492] = {.lex_state = 406, .external_lex_state = 2},
  [6493] = {.lex_state = 406, .external_lex_state = 2},
  [6494] = {.lex_state = 406, .external_lex_state = 2},
  [6495] = {.lex_state = 406, .external_lex_state = 2},
  [6496] = {.lex_state = 406, .external_lex_state = 2},
  [6497] = {.lex_state = 406, .external_lex_state = 2},
  [6498] = {.lex_state = 406, .external_lex_state = 2},
  [6499] = {.lex_state = 406, .external_lex_state = 5},
  [6500] = {.lex_state = 50, .external_lex_state = 2},
  [6501] = {.lex_state = 406, .external_lex_state = 2},
  [6502] = {.lex_state = 406, .external_lex_state = 2},
  [6503] = {.lex_state = 406, .external_lex_state = 2},
  [6504] = {.lex_state = 406, .external_lex_state = 5},
  [6505] = {.lex_state = 406, .external_lex_state = 5},
  [6506] = {.lex_state = 406, .external_lex_state = 5},
  [6507] = {.lex_state = 50, .external_lex_state = 2},
  [6508] = {.lex_state = 406, .external_lex_state = 2},
  [6509] = {.lex_state = 406, .external_lex_state = 2},
  [6510] = {.lex_state = 50, .external_lex_state = 2},
  [6511] = {.lex_state = 406, .external_lex_state = 2},
  [6512] = {.lex_state = 406, .external_lex_state = 2},
  [6513] = {.lex_state = 406, .external_lex_state = 5},
  [6514] = {.lex_state = 406, .external_lex_state = 2},
  [6515] = {.lex_state = 406, .external_lex_state = 5},
  [6516] = {.lex_state = 406, .external_lex_state = 2},
  [6517] = {.lex_state = 50, .external_lex_state = 2},
  [6518] = {.lex_state = 81, .external_lex_state = 2},
  [6519] = {.lex_state = 50, .external_lex_state = 2},
  [6520] = {.lex_state = 406, .external_lex_state = 2},
  [6521] = {.lex_state = 406, .external_lex_state = 2},
  [6522] = {.lex_state = 406, .external_lex_state = 2},
  [6523] = {.lex_state = 406, .external_lex_state = 2},
  [6524] = {.lex_state = 406, .external_lex_state = 2},
  [6525] = {.lex_state = 406, .external_lex_state = 2},
  [6526] = {.lex_state = 50, .external_lex_state = 2},
  [6527] = {.lex_state = 406, .external_lex_state = 2},
  [6528] = {.lex_state = 406, .external_lex_state = 2},
  [6529] = {.lex_state = 406, .external_lex_state = 2},
  [6530] = {.lex_state = 50, .external_lex_state = 2},
  [6531] = {.lex_state = 406, .external_lex_state = 2},
  [6532] = {.lex_state = 50, .external_lex_state = 2},
  [6533] = {.lex_state = 406, .external_lex_state = 2},
  [6534] = {.lex_state = 406, .external_lex_state = 2},
  [6535] = {.lex_state = 50, .external_lex_state = 2},
  [6536] = {.lex_state = 406, .external_lex_state = 2},
  [6537] = {.lex_state = 406, .external_lex_state = 2},
  [6538] = {.lex_state = 406, .external_lex_state = 2},
  [6539] = {.lex_state = 406, .external_lex_state = 2},
  [6540] = {.lex_state = 406, .external_lex_state = 2},
  [6541] = {.lex_state = 406, .external_lex_state = 2},
  [6542] = {.lex_state = 406, .external_lex_state = 2},
  [6543] = {.lex_state = 50, .external_lex_state = 2},
  [6544] = {.lex_state = 50, .external_lex_state = 2},
  [6545] = {.lex_state = 406, .external_lex_state = 2},
  [6546] = {.lex_state = 406, .external_lex_state = 2},
  [6547] = {.lex_state = 406, .external_lex_state = 2},
  [6548] = {.lex_state = 406, .external_lex_state = 2},
  [6549] = {.lex_state = 406, .external_lex_state = 2},
  [6550] = {.lex_state = 406, .external_lex_state = 2},
  [6551] = {.lex_state = 406, .external_lex_state = 2},
  [6552] = {.lex_state = 406, .external_lex_state = 5},
  [6553] = {.lex_state = 406, .external_lex_state = 2},
  [6554] = {.lex_state = 406, .external_lex_state = 2},
  [6555] = {.lex_state = 406, .external_lex_state = 5},
  [6556] = {.lex_state = 406, .external_lex_state = 5},
  [6557] = {.lex_state = 406, .external_lex_state = 2},
  [6558] = {.lex_state = 406, .external_lex_state = 2},
  [6559] = {.lex_state = 406, .external_lex_state = 2},
  [6560] = {.lex_state = 406, .external_lex_state = 2},
  [6561] = {.lex_state = 50, .external_lex_state = 2},
  [6562] = {.lex_state = 50, .external_lex_state = 2},
  [6563] = {.lex_state = 50, .external_lex_state = 2},
  [6564] = {.lex_state = 50, .external_lex_state = 2},
  [6565] = {.lex_state = 406, .external_lex_state = 2},
  [6566] = {.lex_state = 406, .external_lex_state = 2},
  [6567] = {.lex_state = 50, .external_lex_state = 2},
  [6568] = {.lex_state = 406, .external_lex_state = 5},
  [6569] = {.lex_state = 406, .external_lex_state = 5},
  [6570] = {.lex_state = 406, .external_lex_state = 2},
  [6571] = {.lex_state = 406, .external_lex_state = 2},
  [6572] = {.lex_state = 406, .external_lex_state = 2},
  [6573] = {.lex_state = 406, .external_lex_state = 2},
  [6574] = {.lex_state = 406, .external_lex_state = 2},
  [6575] = {.lex_state = 50, .external_lex_state = 2},
  [6576] = {.lex_state = 406, .external_lex_state = 2},
  [6577] = {.lex_state = 50, .external_lex_state = 2},
  [6578] = {.lex_state = 406, .external_lex_state = 2},
  [6579] = {.lex_state = 406, .external_lex_state = 2},
  [6580] = {.lex_state = 406, .external_lex_state = 2},
  [6581] = {.lex_state = 406, .external_lex_state = 2},
  [6582] = {.lex_state = 406, .external_lex_state = 2},
  [6583] = {.lex_state = 406, .external_lex_state = 2},
  [6584] = {.lex_state = 406, .external_lex_state = 2},
  [6585] = {.lex_state = 50, .external_lex_state = 2},
  [6586] = {.lex_state = 406, .external_lex_state = 2},
  [6587] = {.lex_state = 406, .external_lex_state = 2},
  [6588] = {.lex_state = 406, .external_lex_state = 2},
  [6589] = {.lex_state = 406, .external_lex_state = 2},
  [6590] = {.lex_state = 406, .external_lex_state = 5},
  [6591] = {.lex_state = 50, .external_lex_state = 2},
  [6592] = {.lex_state = 406, .external_lex_state = 2},
  [6593] = {.lex_state = 406, .external_lex_state = 2},
  [6594] = {.lex_state = 406, .external_lex_state = 5},
  [6595] = {.lex_state = 406, .external_lex_state = 2},
  [6596] = {.lex_state = 406, .external_lex_state = 5},
  [6597] = {.lex_state = 406, .external_lex_state = 5},
  [6598] = {.lex_state = 406, .external_lex_state = 5},
  [6599] = {.lex_state = 406, .external_lex_state = 2},
  [6600] = {.lex_state = 406, .external_lex_state = 5},
  [6601] = {.lex_state = 406, .external_lex_state = 5},
  [6602] = {.lex_state = 406, .external_lex_state = 2},
  [6603] = {.lex_state = 406, .external_lex_state = 2},
  [6604] = {.lex_state = 406, .external_lex_state = 5},
  [6605] = {.lex_state = 406, .external_lex_state = 5},
  [6606] = {.lex_state = 406, .external_lex_state = 2},
  [6607] = {.lex_state = 406, .external_lex_state = 2},
  [6608] = {.lex_state = 406, .external_lex_state = 2},
  [6609] = {.lex_state = 406, .external_lex_state = 5},
  [6610] = {.lex_state = 406, .external_lex_state = 2},
  [6611] = {.lex_state = 406, .external_lex_state = 2},
  [6612] = {.lex_state = 406, .external_lex_state = 5},
  [6613] = {.lex_state = 406, .external_lex_state = 2},
  [6614] = {.lex_state = 406, .external_lex_state = 5},
  [6615] = {.lex_state = 406, .external_lex_state = 2},
  [6616] = {.lex_state = 50, .external_lex_state = 2},
  [6617] = {.lex_state = 50, .external_lex_state = 2},
  [6618] = {.lex_state = 48, .external_lex_state = 2},
  [6619] = {.lex_state = 50, .external_lex_state = 2},
  [6620] = {.lex_state = 406, .external_lex_state = 2},
  [6621] = {.lex_state = 406, .external_lex_state = 2},
  [6622] = {.lex_state = 406, .external_lex_state = 2},
  [6623] = {.lex_state = 406, .external_lex_state = 2},
  [6624] = {.lex_state = 50, .external_lex_state = 2},
  [6625] = {.lex_state = 48, .external_lex_state = 2},
  [6626] = {.lex_state = 406, .external_lex_state = 2},
  [6627] = {.lex_state = 406, .external_lex_state = 5},
  [6628] = {.lex_state = 406, .external_lex_state = 2},
  [6629] = {.lex_state = 406, .external_lex_state = 2},
  [6630] = {.lex_state = 406, .external_lex_state = 2},
  [6631] = {.lex_state = 406, .external_lex_state = 2},
  [6632] = {.lex_state = 406, .external_lex_state = 2},
  [6633] = {.lex_state = 406, .external_lex_state = 2},
  [6634] = {.lex_state = 406, .external_lex_state = 2},
  [6635] = {.lex_state = 406, .external_lex_state = 2},
  [6636] = {.lex_state = 48, .external_lex_state = 2},
  [6637] = {.lex_state = 406, .external_lex_state = 2},
  [6638] = {.lex_state = 406, .external_lex_state = 2},
  [6639] = {.lex_state = 406, .external_lex_state = 2},
  [6640] = {.lex_state = 406, .external_lex_state = 2},
  [6641] = {.lex_state = 406, .external_lex_state = 2},
  [6642] = {.lex_state = 406, .external_lex_state = 2},
  [6643] = {.lex_state = 406, .external_lex_state = 2},
  [6644] = {.lex_state = 406, .external_lex_state = 2},
  [6645] = {.lex_state = 406, .external_lex_state = 5},
  [6646] = {.lex_state = 406, .external_lex_state = 2},
  [6647] = {.lex_state = 406, .external_lex_state = 2},
  [6648] = {.lex_state = 406, .external_lex_state = 2},
  [6649] = {.lex_state = 406, .external_lex_state = 2},
  [6650] = {.lex_state = 406, .external_lex_state = 2},
  [6651] = {.lex_state = 406, .external_lex_state = 2},
  [6652] = {.lex_state = 406, .external_lex_state = 2},
  [6653] = {.lex_state = 406, .external_lex_state = 2},
  [6654] = {.lex_state = 406, .external_lex_state = 2},
  [6655] = {.lex_state = 406, .external_lex_state = 2},
  [6656] = {.lex_state = 406, .external_lex_state = 2},
  [6657] = {.lex_state = 406, .external_lex_state = 2},
  [6658] = {.lex_state = 406, .external_lex_state = 2},
  [6659] = {.lex_state = 406, .external_lex_state = 2},
  [6660] = {.lex_state = 406, .external_lex_state = 2},
  [6661] = {.lex_state = 406, .external_lex_state = 2},
  [6662] = {.lex_state = 406, .external_lex_state = 5},
  [6663] = {.lex_state = 406, .external_lex_state = 2},
  [6664] = {.lex_state = 406, .external_lex_state = 2},
  [6665] = {.lex_state = 50, .external_lex_state = 2},
  [6666] = {.lex_state = 406, .external_lex_state = 2},
  [6667] = {.lex_state = 50, .external_lex_state = 2},
  [6668] = {.lex_state = 406, .external_lex_state = 2},
  [6669] = {.lex_state = 406, .external_lex_state = 2},
  [6670] = {.lex_state = 50, .external_lex_state = 2},
  [6671] = {.lex_state = 2, .external_lex_state = 2},
  [6672] = {.lex_state = 406, .external_lex_state = 2},
  [6673] = {.lex_state = 406, .external_lex_state = 2},
  [6674] = {.lex_state = 406, .external_lex_state = 2},
  [6675] = {.lex_state = 406, .external_lex_state = 2},
  [6676] = {.lex_state = 406, .external_lex_state = 2},
  [6677] = {.lex_state = 406, .external_lex_state = 2},
  [6678] = {.lex_state = 406, .external_lex_state = 2},
  [6679] = {.lex_state = 406, .external_lex_state = 2},
  [6680] = {.lex_state = 406, .external_lex_state = 2},
  [6681] = {.lex_state = 406, .external_lex_state = 2},
  [6682] = {.lex_state = 406, .external_lex_state = 2},
  [6683] = {.lex_state = 406, .external_lex_state = 5},
  [6684] = {.lex_state = 406, .external_lex_state = 2},
  [6685] = {.lex_state = 406, .external_lex_state = 2},
  [6686] = {.lex_state = 406, .external_lex_state = 5},
  [6687] = {.lex_state = 50, .external_lex_state = 2},
  [6688] = {.lex_state = 406, .external_lex_state = 2},
  [6689] = {.lex_state = 406, .external_lex_state = 5},
  [6690] = {.lex_state = 406, .external_lex_state = 2},
  [6691] = {.lex_state = 406, .external_lex_state = 2},
  [6692] = {.lex_state = 406, .external_lex_state = 2},
  [6693] = {.lex_state = 406, .external_lex_state = 5},
  [6694] = {.lex_state = 406, .external_lex_state = 5},
  [6695] = {.lex_state = 406, .external_lex_state = 5},
  [6696] = {.lex_state = 406, .external_lex_state = 2},
  [6697] = {.lex_state = 406, .external_lex_state = 2},
  [6698] = {.lex_state = 406, .external_lex_state = 2},
  [6699] = {.lex_state = 406, .external_lex_state = 5},
  [6700] = {.lex_state = 406, .external_lex_state = 2},
  [6701] = {.lex_state = 406, .external_lex_state = 2},
  [6702] = {.lex_state = 406, .external_lex_state = 2},
  [6703] = {.lex_state = 406, .external_lex_state = 2},
  [6704] = {.lex_state = 406, .external_lex_state = 2},
  [6705] = {.lex_state = 406, .external_lex_state = 2},
  [6706] = {.lex_state = 406, .external_lex_state = 2},
  [6707] = {.lex_state = 406, .external_lex_state = 2},
  [6708] = {.lex_state = 406, .external_lex_state = 2},
  [6709] = {.lex_state = 406, .external_lex_state = 2},
  [6710] = {.lex_state = 406, .external_lex_state = 5},
  [6711] = {.lex_state = 406, .external_lex_state = 2},
  [6712] = {.lex_state = 406, .external_lex_state = 2},
  [6713] = {.lex_state = 406, .external_lex_state = 2},
  [6714] = {.lex_state = 406, .external_lex_state = 2},
  [6715] = {.lex_state = 406, .external_lex_state = 5},
  [6716] = {.lex_state = 406, .external_lex_state = 2},
  [6717] = {.lex_state = 406, .external_lex_state = 2},
  [6718] = {.lex_state = 406, .external_lex_state = 5},
  [6719] = {.lex_state = 406, .external_lex_state = 2},
  [6720] = {.lex_state = 406, .external_lex_state = 5},
  [6721] = {.lex_state = 406, .external_lex_state = 2},
  [6722] = {.lex_state = 406, .external_lex_state = 2},
  [6723] = {.lex_state = 406, .external_lex_state = 2},
  [6724] = {.lex_state = 406, .external_lex_state = 2},
  [6725] = {.lex_state = 50, .external_lex_state = 2},
  [6726] = {.lex_state = 406, .external_lex_state = 2},
  [6727] = {.lex_state = 406, .external_lex_state = 2},
  [6728] = {.lex_state = 406, .external_lex_state = 2},
  [6729] = {.lex_state = 406, .external_lex_state = 2},
  [6730] = {.lex_state = 406, .external_lex_state = 2},
  [6731] = {.lex_state = 406, .external_lex_state = 2},
  [6732] = {.lex_state = 406, .external_lex_state = 2},
  [6733] = {.lex_state = 406, .external_lex_state = 2},
  [6734] = {.lex_state = 406, .external_lex_state = 2},
  [6735] = {.lex_state = 406, .external_lex_state = 2},
  [6736] = {.lex_state = 406, .external_lex_state = 2},
  [6737] = {.lex_state = 406, .external_lex_state = 5},
  [6738] = {.lex_state = 406, .external_lex_state = 2},
  [6739] = {.lex_state = 406, .external_lex_state = 2},
  [6740] = {.lex_state = 406, .external_lex_state = 2},
  [6741] = {.lex_state = 50, .external_lex_state = 2},
  [6742] = {.lex_state = 406, .external_lex_state = 5},
  [6743] = {.lex_state = 50, .external_lex_state = 2},
  [6744] = {.lex_state = 406, .external_lex_state = 2},
  [6745] = {.lex_state = 406, .external_lex_state = 2},
  [6746] = {.lex_state = 406, .external_lex_state = 5},
  [6747] = {.lex_state = 406, .external_lex_state = 5},
  [6748] = {.lex_state = 406, .external_lex_state = 2},
  [6749] = {.lex_state = 48, .external_lex_state = 2},
  [6750] = {.lex_state = 406, .external_lex_state = 2},
  [6751] = {.lex_state = 406, .external_lex_state = 2},
  [6752] = {.lex_state = 406, .external_lex_state = 5},
  [6753] = {.lex_state = 406, .external_lex_state = 2},
  [6754] = {.lex_state = 406, .external_lex_state = 2},
  [6755] = {.lex_state = 406, .external_lex_state = 5},
  [6756] = {.lex_state = 406, .external_lex_state = 2},
  [6757] = {.lex_state = 406, .external_lex_state = 2},
  [6758] = {.lex_state = 406, .external_lex_state = 2},
  [6759] = {.lex_state = 406, .external_lex_state = 5},
  [6760] = {.lex_state = 406, .external_lex_state = 5},
  [6761] = {.lex_state = 406, .external_lex_state = 2},
  [6762] = {.lex_state = 406, .external_lex_state = 2},
  [6763] = {.lex_state = 406, .external_lex_state = 2},
  [6764] = {.lex_state = 406, .external_lex_state = 5},
  [6765] = {.lex_state = 406, .external_lex_state = 2},
  [6766] = {.lex_state = 406, .external_lex_state = 2},
  [6767] = {.lex_state = 406, .external_lex_state = 2},
  [6768] = {.lex_state = 406, .external_lex_state = 2},
  [6769] = {.lex_state = 406, .external_lex_state = 2},
  [6770] = {.lex_state = 406, .external_lex_state = 2},
  [6771] = {.lex_state = 406, .external_lex_state = 2},
  [6772] = {.lex_state = 406, .external_lex_state = 2},
  [6773] = {.lex_state = 406, .external_lex_state = 5},
  [6774] = {.lex_state = 406, .external_lex_state = 2},
  [6775] = {.lex_state = 406, .external_lex_state = 2},
  [6776] = {.lex_state = 406, .external_lex_state = 2},
  [6777] = {.lex_state = 406, .external_lex_state = 2},
  [6778] = {.lex_state = 406, .external_lex_state = 2},
  [6779] = {.lex_state = 406, .external_lex_state = 2},
  [6780] = {.lex_state = 406, .external_lex_state = 2},
  [6781] = {.lex_state = 406, .external_lex_state = 2},
  [6782] = {.lex_state = 406, .external_lex_state = 5},
  [6783] = {.lex_state = 406, .external_lex_state = 5},
  [6784] = {.lex_state = 406, .external_lex_state = 5},
  [6785] = {.lex_state = 406, .external_lex_state = 2},
  [6786] = {.lex_state = 406, .external_lex_state = 2},
  [6787] = {.lex_state = 49, .external_lex_state = 2},
  [6788] = {.lex_state = 406, .external_lex_state = 5},
  [6789] = {.lex_state = 406, .external_lex_state = 2},
  [6790] = {.lex_state = 406, .external_lex_state = 2},
  [6791] = {.lex_state = 406, .external_lex_state = 2},
  [6792] = {.lex_state = 406, .external_lex_state = 2},
  [6793] = {.lex_state = 50, .external_lex_state = 2},
  [6794] = {.lex_state = 406, .external_lex_state = 2},
  [6795] = {.lex_state = 406, .external_lex_state = 2},
  [6796] = {.lex_state = 406, .external_lex_state = 2},
  [6797] = {.lex_state = 406, .external_lex_state = 2},
  [6798] = {.lex_state = 406, .external_lex_state = 2},
  [6799] = {.lex_state = 406, .external_lex_state = 2},
  [6800] = {.lex_state = 406, .external_lex_state = 2},
  [6801] = {.lex_state = 406, .external_lex_state = 2},
  [6802] = {.lex_state = 406, .external_lex_state = 2},
  [6803] = {.lex_state = 406, .external_lex_state = 2},
  [6804] = {.lex_state = 406, .external_lex_state = 2},
  [6805] = {.lex_state = 406, .external_lex_state = 2},
  [6806] = {.lex_state = 406, .external_lex_state = 2},
  [6807] = {.lex_state = 406, .external_lex_state = 2},
  [6808] = {.lex_state = 406, .external_lex_state = 2},
  [6809] = {.lex_state = 406, .external_lex_state = 5},
  [6810] = {.lex_state = 406, .external_lex_state = 2},
  [6811] = {.lex_state = 406, .external_lex_state = 2},
  [6812] = {.lex_state = 406, .external_lex_state = 2},
  [6813] = {.lex_state = 406, .external_lex_state = 5},
  [6814] = {.lex_state = 406, .external_lex_state = 2},
  [6815] = {.lex_state = 406, .external_lex_state = 5},
  [6816] = {.lex_state = 406, .external_lex_state = 2},
  [6817] = {.lex_state = 406, .external_lex_state = 2},
  [6818] = {.lex_state = 406, .external_lex_state = 2},
  [6819] = {.lex_state = 50, .external_lex_state = 2},
  [6820] = {.lex_state = 406, .external_lex_state = 2},
  [6821] = {.lex_state = 406, .external_lex_state = 2},
  [6822] = {.lex_state = 406, .external_lex_state = 2},
  [6823] = {.lex_state = 406, .external_lex_state = 2},
  [6824] = {.lex_state = 406, .external_lex_state = 2},
  [6825] = {.lex_state = 406, .external_lex_state = 5},
  [6826] = {.lex_state = 406, .external_lex_state = 5},
  [6827] = {.lex_state = 406, .external_lex_state = 2},
  [6828] = {.lex_state = 406, .external_lex_state = 2},
  [6829] = {.lex_state = 406, .external_lex_state = 2},
  [6830] = {.lex_state = 406, .external_lex_state = 2},
  [6831] = {.lex_state = 406, .external_lex_state = 2},
  [6832] = {.lex_state = 406, .external_lex_state = 2},
  [6833] = {.lex_state = 406, .external_lex_state = 2},
  [6834] = {.lex_state = 406, .external_lex_state = 2},
  [6835] = {.lex_state = 406, .external_lex_state = 2},
  [6836] = {.lex_state = 406, .external_lex_state = 2},
  [6837] = {.lex_state = 406, .external_lex_state = 2},
  [6838] = {.lex_state = 406, .external_lex_state = 2},
  [6839] = {.lex_state = 406, .external_lex_state = 2},
  [6840] = {.lex_state = 406, .external_lex_state = 2},
  [6841] = {.lex_state = 406, .external_lex_state = 2},
  [6842] = {.lex_state = 48, .external_lex_state = 2},
  [6843] = {.lex_state = 406, .external_lex_state = 2},
  [6844] = {.lex_state = 406, .external_lex_state = 2},
  [6845] = {.lex_state = 406, .external_lex_state = 2},
  [6846] = {.lex_state = 48, .external_lex_state = 2},
  [6847] = {.lex_state = 406, .external_lex_state = 2},
  [6848] = {.lex_state = 406, .external_lex_state = 2},
  [6849] = {.lex_state = 406, .external_lex_state = 2},
  [6850] = {.lex_state = 406, .external_lex_state = 2},
  [6851] = {.lex_state = 406, .external_lex_state = 2},
  [6852] = {.lex_state = 406, .external_lex_state = 2},
  [6853] = {.lex_state = 406, .external_lex_state = 5},
  [6854] = {.lex_state = 406, .external_lex_state = 2},
  [6855] = {.lex_state = 406, .external_lex_state = 2},
  [6856] = {.lex_state = 406, .external_lex_state = 2},
  [6857] = {.lex_state = 406, .external_lex_state = 2},
  [6858] = {.lex_state = 49, .external_lex_state = 2},
  [6859] = {.lex_state = 406, .external_lex_state = 2},
  [6860] = {.lex_state = 406, .external_lex_state = 2},
  [6861] = {.lex_state = 406, .external_lex_state = 2},
  [6862] = {.lex_state = 406, .external_lex_state = 2},
  [6863] = {.lex_state = 406, .external_lex_state = 2},
  [6864] = {.lex_state = 406, .external_lex_state = 2},
  [6865] = {.lex_state = 406, .external_lex_state = 2},
  [6866] = {.lex_state = 406, .external_lex_state = 2},
  [6867] = {.lex_state = 406, .external_lex_state = 2},
  [6868] = {.lex_state = 406, .external_lex_state = 2},
  [6869] = {.lex_state = 406, .external_lex_state = 2},
  [6870] = {.lex_state = 406, .external_lex_state = 2},
  [6871] = {.lex_state = 406, .external_lex_state = 2},
  [6872] = {.lex_state = 406, .external_lex_state = 2},
  [6873] = {.lex_state = 406, .external_lex_state = 2},
  [6874] = {.lex_state = 406, .external_lex_state = 5},
  [6875] = {.lex_state = 50, .external_lex_state = 2},
  [6876] = {.lex_state = 406, .external_lex_state = 5},
  [6877] = {.lex_state = 406, .external_lex_state = 2},
  [6878] = {.lex_state = 406, .external_lex_state = 2},
  [6879] = {.lex_state = 50, .external_lex_state = 2},
  [6880] = {.lex_state = 406, .external_lex_state = 2},
  [6881] = {.lex_state = 50, .external_lex_state = 2},
  [6882] = {.lex_state = 50, .external_lex_state = 2},
  [6883] = {.lex_state = 50, .external_lex_state = 2},
  [6884] = {.lex_state = 406, .external_lex_state = 2},
  [6885] = {.lex_state = 406, .external_lex_state = 2},
  [6886] = {.lex_state = 48, .external_lex_state = 2},
  [6887] = {.lex_state = 406, .external_lex_state = 5},
  [6888] = {.lex_state = 406, .external_lex_state = 2},
  [6889] = {.lex_state = 406, .external_lex_state = 2},
  [6890] = {.lex_state = 406, .external_lex_state = 2},
  [6891] = {.lex_state = 406, .external_lex_state = 2},
  [6892] = {.lex_state = 406, .external_lex_state = 2},
  [6893] = {.lex_state = 406, .external_lex_state = 2},
  [6894] = {.lex_state = 406, .external_lex_state = 2},
  [6895] = {.lex_state = 406, .external_lex_state = 2},
  [6896] = {.lex_state = 406, .external_lex_state = 5},
  [6897] = {.lex_state = 406, .external_lex_state = 5},
  [6898] = {.lex_state = 406, .external_lex_state = 2},
  [6899] = {.lex_state = 406, .external_lex_state = 2},
  [6900] = {.lex_state = 406, .external_lex_state = 2},
  [6901] = {.lex_state = 406, .external_lex_state = 2},
  [6902] = {.lex_state = 406, .external_lex_state = 2},
  [6903] = {.lex_state = 406, .external_lex_state = 2},
  [6904] = {.lex_state = 406, .external_lex_state = 2},
  [6905] = {.lex_state = 406, .external_lex_state = 2},
  [6906] = {.lex_state = 406, .external_lex_state = 2},
  [6907] = {.lex_state = 406, .external_lex_state = 2},
  [6908] = {.lex_state = 406, .external_lex_state = 2},
  [6909] = {.lex_state = 81, .external_lex_state = 2},
  [6910] = {.lex_state = 406, .external_lex_state = 2},
  [6911] = {.lex_state = 406, .external_lex_state = 5},
  [6912] = {.lex_state = 406, .external_lex_state = 2},
  [6913] = {.lex_state = 406, .external_lex_state = 5},
  [6914] = {.lex_state = 406, .external_lex_state = 2},
  [6915] = {.lex_state = 406, .external_lex_state = 2},
  [6916] = {.lex_state = 406, .external_lex_state = 2},
  [6917] = {.lex_state = 406, .external_lex_state = 2},
  [6918] = {.lex_state = 406, .external_lex_state = 2},
  [6919] = {.lex_state = 406, .external_lex_state = 2},
  [6920] = {.lex_state = 406, .external_lex_state = 2},
  [6921] = {.lex_state = 406, .external_lex_state = 2},
  [6922] = {.lex_state = 406, .external_lex_state = 2},
  [6923] = {.lex_state = 406, .external_lex_state = 2},
  [6924] = {.lex_state = 406, .external_lex_state = 2},
  [6925] = {.lex_state = 406, .external_lex_state = 2},
  [6926] = {.lex_state = 406, .external_lex_state = 2},
  [6927] = {.lex_state = 406, .external_lex_state = 2},
  [6928] = {.lex_state = 406, .external_lex_state = 2},
  [6929] = {.lex_state = 406, .external_lex_state = 2},
  [6930] = {.lex_state = 406, .external_lex_state = 2},
  [6931] = {.lex_state = 406, .external_lex_state = 5},
  [6932] = {.lex_state = 50, .external_lex_state = 2},
  [6933] = {.lex_state = 406, .external_lex_state = 2},
  [6934] = {.lex_state = 406, .external_lex_state = 2},
  [6935] = {.lex_state = 406, .external_lex_state = 2},
  [6936] = {.lex_state = 406, .external_lex_state = 2},
  [6937] = {.lex_state = 406, .external_lex_state = 2},
  [6938] = {.lex_state = 406, .external_lex_state = 2},
  [6939] = {.lex_state = 406, .external_lex_state = 2},
  [6940] = {.lex_state = 406, .external_lex_state = 5},
  [6941] = {.lex_state = 406, .external_lex_state = 5},
  [6942] = {.lex_state = 406, .external_lex_state = 2},
  [6943] = {.lex_state = 406, .external_lex_state = 2},
  [6944] = {.lex_state = 406, .external_lex_state = 2},
  [6945] = {.lex_state = 406, .external_lex_state = 5},
  [6946] = {.lex_state = 406, .external_lex_state = 2},
  [6947] = {.lex_state = 406, .external_lex_state = 5},
  [6948] = {.lex_state = 406, .external_lex_state = 2},
  [6949] = {.lex_state = 406, .external_lex_state = 2},
  [6950] = {.lex_state = 406, .external_lex_state = 2},
  [6951] = {.lex_state = 406, .external_lex_state = 2},
  [6952] = {.lex_state = 406, .external_lex_state = 2},
  [6953] = {.lex_state = 406, .external_lex_state = 2},
  [6954] = {.lex_state = 406, .external_lex_state = 2},
  [6955] = {.lex_state = 406, .external_lex_state = 2},
  [6956] = {.lex_state = 406, .external_lex_state = 2},
  [6957] = {.lex_state = 406, .external_lex_state = 2},
  [6958] = {.lex_state = 406, .external_lex_state = 2},
  [6959] = {.lex_state = 406, .external_lex_state = 2},
  [6960] = {.lex_state = 406, .external_lex_state = 2},
  [6961] = {.lex_state = 406, .external_lex_state = 5},
  [6962] = {.lex_state = 406, .external_lex_state = 5},
  [6963] = {.lex_state = 406, .external_lex_state = 2},
  [6964] = {.lex_state = 406, .external_lex_state = 2},
  [6965] = {.lex_state = 406, .external_lex_state = 2},
  [6966] = {.lex_state = 406, .external_lex_state = 2},
  [6967] = {.lex_state = 48, .external_lex_state = 2},
  [6968] = {.lex_state = 406, .external_lex_state = 2},
  [6969] = {.lex_state = 48, .external_lex_state = 2},
  [6970] = {.lex_state = 406, .external_lex_state = 2},
  [6971] = {.lex_state = 406, .external_lex_state = 2},
  [6972] = {.lex_state = 406, .external_lex_state = 2},
  [6973] = {.lex_state = 406, .external_lex_state = 2},
  [6974] = {.lex_state = 406, .external_lex_state = 2},
  [6975] = {.lex_state = 406, .external_lex_state = 2},
  [6976] = {.lex_state = 406, .external_lex_state = 2},
  [6977] = {.lex_state = 406, .external_lex_state = 2},
  [6978] = {.lex_state = 406, .external_lex_state = 2},
  [6979] = {.lex_state = 406, .external_lex_state = 2},
  [6980] = {.lex_state = 406, .external_lex_state = 2},
  [6981] = {.lex_state = 406, .external_lex_state = 2},
  [6982] = {.lex_state = 406, .external_lex_state = 2},
  [6983] = {.lex_state = 406, .external_lex_state = 2},
  [6984] = {.lex_state = 406, .external_lex_state = 2},
  [6985] = {.lex_state = 406, .external_lex_state = 2},
  [6986] = {.lex_state = 406, .external_lex_state = 2},
  [6987] = {.lex_state = 406, .external_lex_state = 2},
  [6988] = {.lex_state = 406, .external_lex_state = 2},
  [6989] = {.lex_state = 406, .external_lex_state = 2},
  [6990] = {.lex_state = 3, .external_lex_state = 10},
  [6991] = {.lex_state = 406, .external_lex_state = 2},
  [6992] = {.lex_state = 406, .external_lex_state = 2},
  [6993] = {.lex_state = 50, .external_lex_state = 2},
  [6994] = {.lex_state = 406, .external_lex_state = 2},
  [6995] = {.lex_state = 406, .external_lex_state = 2},
  [6996] = {.lex_state = 406, .external_lex_state = 2},
  [6997] = {.lex_state = 406, .external_lex_state = 2},
  [6998] = {.lex_state = 48, .external_lex_state = 2},
  [6999] = {.lex_state = 406, .external_lex_state = 2},
  [7000] = {.lex_state = 406, .external_lex_state = 2},
  [7001] = {.lex_state = 406, .external_lex_state = 2},
  [7002] = {.lex_state = 406, .external_lex_state = 2},
  [7003] = {.lex_state = 406, .external_lex_state = 2},
  [7004] = {.lex_state = 406, .external_lex_state = 2},
  [7005] = {.lex_state = 406, .external_lex_state = 2},
  [7006] = {.lex_state = 406, .external_lex_state = 2},
  [7007] = {.lex_state = 406, .external_lex_state = 2},
  [7008] = {.lex_state = 406, .external_lex_state = 2},
  [7009] = {.lex_state = 50, .external_lex_state = 2},
  [7010] = {.lex_state = 406, .external_lex_state = 2},
  [7011] = {.lex_state = 406, .external_lex_state = 2},
  [7012] = {.lex_state = 406, .external_lex_state = 2},
  [7013] = {.lex_state = 406, .external_lex_state = 2},
  [7014] = {.lex_state = 406, .external_lex_state = 2},
  [7015] = {.lex_state = 3, .external_lex_state = 10},
  [7016] = {.lex_state = 50, .external_lex_state = 2},
  [7017] = {.lex_state = 50, .external_lex_state = 2},
  [7018] = {.lex_state = 406, .external_lex_state = 2},
  [7019] = {.lex_state = 406, .external_lex_state = 2},
  [7020] = {.lex_state = 406, .external_lex_state = 2},
  [7021] = {.lex_state = 50, .external_lex_state = 2},
  [7022] = {.lex_state = 50, .external_lex_state = 2},
  [7023] = {.lex_state = 50, .external_lex_state = 2},
  [7024] = {.lex_state = 50, .external_lex_state = 2},
  [7025] = {.lex_state = 406, .external_lex_state = 2},
  [7026] = {.lex_state = 406, .external_lex_state = 2},
  [7027] = {.lex_state = 50, .external_lex_state = 2},
  [7028] = {.lex_state = 50, .external_lex_state = 2},
  [7029] = {.lex_state = 50, .external_lex_state = 2},
  [7030] = {.lex_state = 406, .external_lex_state = 2},
  [7031] = {.lex_state = 50, .external_lex_state = 2},
  [7032] = {.lex_state = 50, .external_lex_state = 2},
  [7033] = {.lex_state = 406, .external_lex_state = 2},
  [7034] = {.lex_state = 50, .external_lex_state = 2},
  [7035] = {.lex_state = 406, .external_lex_state = 2},
  [7036] = {.lex_state = 406, .external_lex_state = 2},
  [7037] = {.lex_state = 50, .external_lex_state = 2},
  [7038] = {.lex_state = 50, .external_lex_state = 2},
  [7039] = {.lex_state = 50, .external_lex_state = 2},
  [7040] = {.lex_state = 50, .external_lex_state = 2},
  [7041] = {.lex_state = 406, .external_lex_state = 2},
  [7042] = {.lex_state = 50, .external_lex_state = 2},
  [7043] = {.lex_state = 24, .external_lex_state = 2},
  [7044] = {.lex_state = 50, .external_lex_state = 2},
  [7045] = {.lex_state = 50, .external_lex_state = 2},
  [7046] = {.lex_state = 406, .external_lex_state = 2},
  [7047] = {.lex_state = 406, .external_lex_state = 2},
  [7048] = {.lex_state = 406, .external_lex_state = 2},
  [7049] = {.lex_state = 406, .external_lex_state = 2},
  [7050] = {.lex_state = 50, .external_lex_state = 2},
  [7051] = {.lex_state = 406, .external_lex_state = 2},
  [7052] = {.lex_state = 406, .external_lex_state = 2},
  [7053] = {.lex_state = 406, .external_lex_state = 2},
  [7054] = {.lex_state = 50, .external_lex_state = 2},
  [7055] = {.lex_state = 406, .external_lex_state = 2},
  [7056] = {.lex_state = 50, .external_lex_state = 2},
  [7057] = {.lex_state = 406, .external_lex_state = 2},
  [7058] = {.lex_state = 406, .external_lex_state = 2},
  [7059] = {.lex_state = 406, .external_lex_state = 2},
  [7060] = {.lex_state = 406, .external_lex_state = 2},
  [7061] = {.lex_state = 406, .external_lex_state = 2},
  [7062] = {.lex_state = 406, .external_lex_state = 2},
  [7063] = {.lex_state = 406, .external_lex_state = 2},
  [7064] = {.lex_state = 406, .external_lex_state = 2},
  [7065] = {.lex_state = 406, .external_lex_state = 2},
  [7066] = {.lex_state = 406, .external_lex_state = 2},
  [7067] = {.lex_state = 406, .external_lex_state = 2},
  [7068] = {.lex_state = 406, .external_lex_state = 2},
  [7069] = {.lex_state = 406, .external_lex_state = 2},
  [7070] = {.lex_state = 50, .external_lex_state = 2},
  [7071] = {.lex_state = 406, .external_lex_state = 2},
  [7072] = {.lex_state = 406, .external_lex_state = 2},
  [7073] = {.lex_state = 406, .external_lex_state = 2},
  [7074] = {.lex_state = 406, .external_lex_state = 2},
  [7075] = {.lex_state = 49, .external_lex_state = 2},
  [7076] = {.lex_state = 406, .external_lex_state = 2},
  [7077] = {.lex_state = 48, .external_lex_state = 2},
  [7078] = {.lex_state = 406, .external_lex_state = 2},
  [7079] = {.lex_state = 406, .external_lex_state = 2},
  [7080] = {.lex_state = 406, .external_lex_state = 2},
  [7081] = {.lex_state = 3, .external_lex_state = 10},
  [7082] = {.lex_state = 50, .external_lex_state = 2},
  [7083] = {.lex_state = 50, .external_lex_state = 2},
  [7084] = {.lex_state = 82, .external_lex_state = 2},
  [7085] = {.lex_state = 406, .external_lex_state = 2},
  [7086] = {.lex_state = 406, .external_lex_state = 2},
  [7087] = {.lex_state = 406, .external_lex_state = 2},
  [7088] = {.lex_state = 50, .external_lex_state = 2},
  [7089] = {.lex_state = 50, .external_lex_state = 2},
  [7090] = {.lex_state = 406, .external_lex_state = 2},
  [7091] = {.lex_state = 49, .external_lex_state = 2},
  [7092] = {.lex_state = 406, .external_lex_state = 2},
  [7093] = {.lex_state = 406, .external_lex_state = 2},
  [7094] = {.lex_state = 406, .external_lex_state = 2},
  [7095] = {.lex_state = 50, .external_lex_state = 2},
  [7096] = {.lex_state = 406, .external_lex_state = 2},
  [7097] = {.lex_state = 406, .external_lex_state = 2},
  [7098] = {.lex_state = 50, .external_lex_state = 2},
  [7099] = {.lex_state = 406, .external_lex_state = 2},
  [7100] = {.lex_state = 406, .external_lex_state = 2},
  [7101] = {.lex_state = 406, .external_lex_state = 2},
  [7102] = {.lex_state = 406, .external_lex_state = 2},
  [7103] = {.lex_state = 50, .external_lex_state = 2},
  [7104] = {.lex_state = 406, .external_lex_state = 2},
  [7105] = {.lex_state = 50, .external_lex_state = 2},
  [7106] = {.lex_state = 406, .external_lex_state = 2},
  [7107] = {.lex_state = 406, .external_lex_state = 2},
  [7108] = {.lex_state = 50, .external_lex_state = 2},
  [7109] = {.lex_state = 406, .external_lex_state = 2},
  [7110] = {.lex_state = 406, .external_lex_state = 2},
  [7111] = {.lex_state = 406, .external_lex_state = 2},
  [7112] = {.lex_state = 406, .external_lex_state = 2},
  [7113] = {.lex_state = 406, .external_lex_state = 2},
  [7114] = {.lex_state = 406, .external_lex_state = 2},
  [7115] = {.lex_state = 406, .external_lex_state = 2},
  [7116] = {.lex_state = 50, .external_lex_state = 2},
  [7117] = {.lex_state = 406, .external_lex_state = 2},
  [7118] = {.lex_state = 406, .external_lex_state = 2},
  [7119] = {.lex_state = 406, .external_lex_state = 2},
  [7120] = {.lex_state = 406, .external_lex_state = 2},
  [7121] = {.lex_state = 406, .external_lex_state = 2},
  [7122] = {.lex_state = 406, .external_lex_state = 2},
  [7123] = {.lex_state = 406, .external_lex_state = 2},
  [7124] = {.lex_state = 406, .external_lex_state = 2},
  [7125] = {.lex_state = 406, .external_lex_state = 2},
  [7126] = {.lex_state = 24, .external_lex_state = 2},
  [7127] = {.lex_state = 406, .external_lex_state = 2},
  [7128] = {.lex_state = 406, .external_lex_state = 2},
  [7129] = {.lex_state = 406, .external_lex_state = 2},
  [7130] = {.lex_state = 406, .external_lex_state = 2},
  [7131] = {.lex_state = 406, .external_lex_state = 2},
  [7132] = {.lex_state = 406, .external_lex_state = 2},
  [7133] = {.lex_state = 406, .external_lex_state = 2},
  [7134] = {.lex_state = 406, .external_lex_state = 2},
  [7135] = {.lex_state = 406, .external_lex_state = 2},
  [7136] = {.lex_state = 49, .external_lex_state = 2},
  [7137] = {.lex_state = 50, .external_lex_state = 2},
  [7138] = {.lex_state = 50, .external_lex_state = 2},
  [7139] = {.lex_state = 406, .external_lex_state = 2},
  [7140] = {.lex_state = 406, .external_lex_state = 2},
  [7141] = {.lex_state = 406, .external_lex_state = 2},
  [7142] = {.lex_state = 406, .external_lex_state = 2},
  [7143] = {.lex_state = 50, .external_lex_state = 2},
  [7144] = {.lex_state = 50, .external_lex_state = 2},
  [7145] = {.lex_state = 406, .external_lex_state = 2},
  [7146] = {.lex_state = 49, .external_lex_state = 2},
  [7147] = {.lex_state = 406, .external_lex_state = 2},
  [7148] = {.lex_state = 50, .external_lex_state = 2},
  [7149] = {.lex_state = 406, .external_lex_state = 2},
  [7150] = {.lex_state = 50, .external_lex_state = 2},
  [7151] = {.lex_state = 50, .external_lex_state = 2},
  [7152] = {.lex_state = 406, .external_lex_state = 2},
  [7153] = {.lex_state = 50, .external_lex_state = 2},
  [7154] = {.lex_state = 406, .external_lex_state = 2},
  [7155] = {.lex_state = 406, .external_lex_state = 2},
  [7156] = {.lex_state = 406, .external_lex_state = 2},
  [7157] = {.lex_state = 50, .external_lex_state = 2},
  [7158] = {.lex_state = 406, .external_lex_state = 2},
  [7159] = {.lex_state = 50, .external_lex_state = 2},
  [7160] = {.lex_state = 49, .external_lex_state = 2},
  [7161] = {.lex_state = 406, .external_lex_state = 2},
  [7162] = {.lex_state = 406, .external_lex_state = 2},
  [7163] = {.lex_state = 406, .external_lex_state = 2},
  [7164] = {.lex_state = 50, .external_lex_state = 2},
  [7165] = {.lex_state = 50, .external_lex_state = 2},
  [7166] = {.lex_state = 406, .external_lex_state = 2},
  [7167] = {.lex_state = 406, .external_lex_state = 2},
  [7168] = {.lex_state = 50, .external_lex_state = 2},
  [7169] = {.lex_state = 406, .external_lex_state = 2},
  [7170] = {.lex_state = 406, .external_lex_state = 2},
  [7171] = {.lex_state = 406, .external_lex_state = 2},
  [7172] = {.lex_state = 406, .external_lex_state = 2},
  [7173] = {.lex_state = 406, .external_lex_state = 2},
  [7174] = {.lex_state = 406, .external_lex_state = 2},
  [7175] = {.lex_state = 50, .external_lex_state = 2},
  [7176] = {.lex_state = 50, .external_lex_state = 2},
  [7177] = {.lex_state = 406, .external_lex_state = 2},
  [7178] = {.lex_state = 406, .external_lex_state = 2},
  [7179] = {.lex_state = 406, .external_lex_state = 2},
  [7180] = {.lex_state = 50, .external_lex_state = 2},
  [7181] = {.lex_state = 406, .external_lex_state = 2},
  [7182] = {.lex_state = 406, .external_lex_state = 2},
  [7183] = {.lex_state = 406, .external_lex_state = 2},
  [7184] = {.lex_state = 406, .external_lex_state = 2},
  [7185] = {.lex_state = 406, .external_lex_state = 2},
  [7186] = {.lex_state = 406, .external_lex_state = 2},
  [7187] = {.lex_state = 49, .external_lex_state = 2},
  [7188] = {.lex_state = 406, .external_lex_state = 2},
  [7189] = {.lex_state = 406, .external_lex_state = 2},
  [7190] = {.lex_state = 406, .external_lex_state = 2},
  [7191] = {.lex_state = 406, .external_lex_state = 2},
  [7192] = {.lex_state = 406, .external_lex_state = 2},
  [7193] = {.lex_state = 406, .external_lex_state = 2},
  [7194] = {.lex_state = 406, .external_lex_state = 2},
  [7195] = {.lex_state = 50, .external_lex_state = 2},
  [7196] = {.lex_state = 406, .external_lex_state = 2},
  [7197] = {.lex_state = 406, .external_lex_state = 2},
  [7198] = {.lex_state = 406, .external_lex_state = 2},
  [7199] = {.lex_state = 406, .external_lex_state = 2},
  [7200] = {.lex_state = 406, .external_lex_state = 2},
  [7201] = {.lex_state = 406, .external_lex_state = 2},
  [7202] = {.lex_state = 406, .external_lex_state = 2},
  [7203] = {.lex_state = 406, .external_lex_state = 2},
  [7204] = {.lex_state = 406, .external_lex_state = 2},
  [7205] = {.lex_state = 406, .external_lex_state = 2},
  [7206] = {.lex_state = 406, .external_lex_state = 2},
  [7207] = {.lex_state = 406, .external_lex_state = 2},
  [7208] = {.lex_state = 406, .external_lex_state = 2},
  [7209] = {.lex_state = 50, .external_lex_state = 2},
  [7210] = {.lex_state = 406, .external_lex_state = 2},
  [7211] = {.lex_state = 406, .external_lex_state = 2},
  [7212] = {.lex_state = 406, .external_lex_state = 2},
  [7213] = {.lex_state = 406, .external_lex_state = 2},
  [7214] = {.lex_state = 406, .external_lex_state = 2},
  [7215] = {.lex_state = 406, .external_lex_state = 2},
  [7216] = {.lex_state = 50, .external_lex_state = 2},
  [7217] = {.lex_state = 406, .external_lex_state = 2},
  [7218] = {.lex_state = 406, .external_lex_state = 2},
  [7219] = {.lex_state = 406, .external_lex_state = 2},
  [7220] = {.lex_state = 406, .external_lex_state = 2},
  [7221] = {.lex_state = 406, .external_lex_state = 2},
  [7222] = {.lex_state = 50, .external_lex_state = 2},
  [7223] = {.lex_state = 406, .external_lex_state = 2},
  [7224] = {.lex_state = 406, .external_lex_state = 2},
  [7225] = {.lex_state = 406, .external_lex_state = 2},
  [7226] = {.lex_state = 406, .external_lex_state = 2},
  [7227] = {.lex_state = 50, .external_lex_state = 2},
  [7228] = {.lex_state = 406, .external_lex_state = 2},
  [7229] = {.lex_state = 406, .external_lex_state = 2},
  [7230] = {.lex_state = 406, .external_lex_state = 2},
  [7231] = {.lex_state = 406, .external_lex_state = 2},
  [7232] = {.lex_state = 406, .external_lex_state = 2},
  [7233] = {.lex_state = 406, .external_lex_state = 2},
  [7234] = {.lex_state = 50, .external_lex_state = 2},
  [7235] = {.lex_state = 49, .external_lex_state = 2},
  [7236] = {.lex_state = 50, .external_lex_state = 2},
  [7237] = {.lex_state = 50, .external_lex_state = 2},
  [7238] = {.lex_state = 406, .external_lex_state = 2},
  [7239] = {.lex_state = 50, .external_lex_state = 2},
  [7240] = {.lex_state = 406, .external_lex_state = 2},
  [7241] = {.lex_state = 50, .external_lex_state = 2},
  [7242] = {.lex_state = 50, .external_lex_state = 2},
  [7243] = {.lex_state = 3, .external_lex_state = 10},
  [7244] = {.lex_state = 406, .external_lex_state = 2},
  [7245] = {.lex_state = 406, .external_lex_state = 2},
  [7246] = {.lex_state = 50, .external_lex_state = 2},
  [7247] = {.lex_state = 406, .external_lex_state = 2},
  [7248] = {.lex_state = 406, .external_lex_state = 2},
  [7249] = {.lex_state = 82, .external_lex_state = 2},
  [7250] = {.lex_state = 406, .external_lex_state = 2},
  [7251] = {.lex_state = 406, .external_lex_state = 2},
  [7252] = {.lex_state = 50, .external_lex_state = 2},
  [7253] = {.lex_state = 82, .external_lex_state = 2},
  [7254] = {.lex_state = 406, .external_lex_state = 2},
  [7255] = {.lex_state = 406, .external_lex_state = 2},
  [7256] = {.lex_state = 406, .external_lex_state = 2},
  [7257] = {.lex_state = 406, .external_lex_state = 2},
  [7258] = {.lex_state = 406, .external_lex_state = 2},
  [7259] = {.lex_state = 406, .external_lex_state = 2},
  [7260] = {.lex_state = 406, .external_lex_state = 2},
  [7261] = {.lex_state = 406, .external_lex_state = 2},
  [7262] = {.lex_state = 406, .external_lex_state = 2},
  [7263] = {.lex_state = 406, .external_lex_state = 2},
  [7264] = {.lex_state = 406, .external_lex_state = 2},
  [7265] = {.lex_state = 406, .external_lex_state = 2},
  [7266] = {.lex_state = 406, .external_lex_state = 2},
  [7267] = {.lex_state = 50, .external_lex_state = 2},
  [7268] = {.lex_state = 406, .external_lex_state = 2},
  [7269] = {.lex_state = 406, .external_lex_state = 2},
  [7270] = {.lex_state = 406, .external_lex_state = 2},
  [7271] = {.lex_state = 406, .external_lex_state = 2},
  [7272] = {.lex_state = 406, .external_lex_state = 2},
  [7273] = {.lex_state = 406, .external_lex_state = 2},
  [7274] = {.lex_state = 82, .external_lex_state = 2},
  [7275] = {.lex_state = 406, .external_lex_state = 2},
  [7276] = {.lex_state = 50, .external_lex_state = 2},
  [7277] = {.lex_state = 50, .external_lex_state = 2},
  [7278] = {.lex_state = 406, .external_lex_state = 2},
  [7279] = {.lex_state = 50, .external_lex_state = 2},
  [7280] = {.lex_state = 50, .external_lex_state = 2},
  [7281] = {.lex_state = 50, .external_lex_state = 2},
  [7282] = {.lex_state = 406, .external_lex_state = 2},
  [7283] = {.lex_state = 406, .external_lex_state = 2},
  [7284] = {.lex_state = 406, .external_lex_state = 2},
  [7285] = {.lex_state = 50, .external_lex_state = 2},
  [7286] = {.lex_state = 50, .external_lex_state = 2},
  [7287] = {.lex_state = 50, .external_lex_state = 2},
  [7288] = {.lex_state = 406, .external_lex_state = 2},
  [7289] = {.lex_state = 406, .external_lex_state = 2},
  [7290] = {.lex_state = 406, .external_lex_state = 2},
  [7291] = {.lex_state = 406, .external_lex_state = 2},
  [7292] = {.lex_state = 50, .external_lex_state = 2},
  [7293] = {.lex_state = 406, .external_lex_state = 2},
  [7294] = {.lex_state = 50, .external_lex_state = 2},
  [7295] = {.lex_state = 50, .external_lex_state = 2},
  [7296] = {.lex_state = 50, .external_lex_state = 2},
  [7297] = {.lex_state = 406, .external_lex_state = 2},
  [7298] = {.lex_state = 406, .external_lex_state = 2},
  [7299] = {.lex_state = 406, .external_lex_state = 2},
  [7300] = {.lex_state = 50, .external_lex_state = 2},
  [7301] = {.lex_state = 406, .external_lex_state = 2},
  [7302] = {.lex_state = 406, .external_lex_state = 2},
  [7303] = {.lex_state = 406, .external_lex_state = 2},
  [7304] = {.lex_state = 406, .external_lex_state = 2},
  [7305] = {.lex_state = 406, .external_lex_state = 2},
  [7306] = {.lex_state = 50, .external_lex_state = 2},
  [7307] = {.lex_state = 24, .external_lex_state = 2},
  [7308] = {.lex_state = 406, .external_lex_state = 2},
  [7309] = {.lex_state = 50, .external_lex_state = 2},
  [7310] = {.lex_state = 406, .external_lex_state = 2},
  [7311] = {.lex_state = 406, .external_lex_state = 2},
  [7312] = {.lex_state = 406, .external_lex_state = 2},
  [7313] = {.lex_state = 406, .external_lex_state = 2},
  [7314] = {.lex_state = 406, .external_lex_state = 2},
  [7315] = {.lex_state = 406, .external_lex_state = 2},
  [7316] = {.lex_state = 406, .external_lex_state = 2},
  [7317] = {.lex_state = 406, .external_lex_state = 2},
  [7318] = {.lex_state = 49, .external_lex_state = 2},
  [7319] = {.lex_state = 406, .external_lex_state = 2},
  [7320] = {.lex_state = 406, .external_lex_state = 2},
  [7321] = {.lex_state = 406, .external_lex_state = 2},
  [7322] = {.lex_state = 406, .external_lex_state = 2},
  [7323] = {.lex_state = 406, .external_lex_state = 2},
  [7324] = {.lex_state = 406, .external_lex_state = 2},
  [7325] = {.lex_state = 406, .external_lex_state = 2},
  [7326] = {.lex_state = 406, .external_lex_state = 2},
  [7327] = {.lex_state = 406, .external_lex_state = 2},
  [7328] = {.lex_state = 406, .external_lex_state = 2},
  [7329] = {.lex_state = 50, .external_lex_state = 2},
  [7330] = {.lex_state = 50, .external_lex_state = 2},
  [7331] = {.lex_state = 406, .external_lex_state = 2},
  [7332] = {.lex_state = 406, .external_lex_state = 2},
  [7333] = {.lex_state = 406, .external_lex_state = 2},
  [7334] = {.lex_state = 50, .external_lex_state = 2},
  [7335] = {.lex_state = 50, .external_lex_state = 2},
  [7336] = {.lex_state = 50, .external_lex_state = 2},
  [7337] = {.lex_state = 406, .external_lex_state = 2},
  [7338] = {.lex_state = 406, .external_lex_state = 2},
  [7339] = {.lex_state = 406, .external_lex_state = 2},
  [7340] = {.lex_state = 406, .external_lex_state = 2},
  [7341] = {.lex_state = 406, .external_lex_state = 2},
  [7342] = {.lex_state = 406, .external_lex_state = 2},
  [7343] = {.lex_state = 50, .external_lex_state = 2},
  [7344] = {.lex_state = 406, .external_lex_state = 2},
  [7345] = {.lex_state = 406, .external_lex_state = 2},
  [7346] = {.lex_state = 406, .external_lex_state = 2},
  [7347] = {.lex_state = 406, .external_lex_state = 2},
  [7348] = {.lex_state = 50, .external_lex_state = 2},
  [7349] = {.lex_state = 50, .external_lex_state = 2},
  [7350] = {.lex_state = 406, .external_lex_state = 2},
  [7351] = {.lex_state = 406, .external_lex_state = 2},
  [7352] = {.lex_state = 406, .external_lex_state = 2},
  [7353] = {.lex_state = 406, .external_lex_state = 2},
  [7354] = {.lex_state = 50, .external_lex_state = 2},
  [7355] = {.lex_state = 50, .external_lex_state = 2},
  [7356] = {.lex_state = 406, .external_lex_state = 2},
  [7357] = {.lex_state = 50, .external_lex_state = 2},
  [7358] = {.lex_state = 50, .external_lex_state = 2},
  [7359] = {.lex_state = 406, .external_lex_state = 2},
  [7360] = {.lex_state = 406, .external_lex_state = 2},
  [7361] = {.lex_state = 406, .external_lex_state = 2},
  [7362] = {.lex_state = 50, .external_lex_state = 2},
  [7363] = {.lex_state = 406, .external_lex_state = 2},
  [7364] = {.lex_state = 406, .external_lex_state = 2},
  [7365] = {.lex_state = 82, .external_lex_state = 2},
  [7366] = {.lex_state = 50, .external_lex_state = 2},
  [7367] = {.lex_state = 50, .external_lex_state = 2},
  [7368] = {.lex_state = 406, .external_lex_state = 2},
  [7369] = {.lex_state = 50, .external_lex_state = 2},
  [7370] = {.lex_state = 406, .external_lex_state = 2},
  [7371] = {.lex_state = 406, .external_lex_state = 2},
  [7372] = {.lex_state = 406, .external_lex_state = 2},
  [7373] = {.lex_state = 406, .external_lex_state = 2},
  [7374] = {.lex_state = 406, .external_lex_state = 2},
  [7375] = {.lex_state = 406, .external_lex_state = 2},
  [7376] = {.lex_state = 50, .external_lex_state = 2},
  [7377] = {.lex_state = 50, .external_lex_state = 2},
  [7378] = {.lex_state = 406, .external_lex_state = 2},
  [7379] = {.lex_state = 406, .external_lex_state = 2},
  [7380] = {.lex_state = 406, .external_lex_state = 2},
  [7381] = {.lex_state = 406, .external_lex_state = 2},
  [7382] = {.lex_state = 406, .external_lex_state = 2},
  [7383] = {.lex_state = 406, .external_lex_state = 2},
  [7384] = {.lex_state = 406, .external_lex_state = 2},
  [7385] = {.lex_state = 406, .external_lex_state = 2},
  [7386] = {.lex_state = 406, .external_lex_state = 2},
  [7387] = {.lex_state = 406, .external_lex_state = 2},
  [7388] = {.lex_state = 406, .external_lex_state = 2},
  [7389] = {.lex_state = 406, .external_lex_state = 2},
  [7390] = {.lex_state = 50, .external_lex_state = 2},
  [7391] = {.lex_state = 406, .external_lex_state = 2},
  [7392] = {.lex_state = 49, .external_lex_state = 2},
  [7393] = {.lex_state = 48, .external_lex_state = 2},
  [7394] = {.lex_state = 406, .external_lex_state = 2},
  [7395] = {.lex_state = 50, .external_lex_state = 2},
  [7396] = {.lex_state = 50, .external_lex_state = 2},
  [7397] = {.lex_state = 406, .external_lex_state = 2},
  [7398] = {.lex_state = 406, .external_lex_state = 2},
  [7399] = {.lex_state = 406, .external_lex_state = 2},
  [7400] = {.lex_state = 50, .external_lex_state = 2},
  [7401] = {.lex_state = 50, .external_lex_state = 2},
  [7402] = {.lex_state = 406, .external_lex_state = 2},
  [7403] = {.lex_state = 406, .external_lex_state = 2},
  [7404] = {.lex_state = 406, .external_lex_state = 2},
  [7405] = {.lex_state = 3, .external_lex_state = 10},
  [7406] = {.lex_state = 406, .external_lex_state = 2},
  [7407] = {.lex_state = 48, .external_lex_state = 2},
  [7408] = {.lex_state = 406, .external_lex_state = 2},
  [7409] = {.lex_state = 406, .external_lex_state = 2},
  [7410] = {.lex_state = 406, .external_lex_state = 2},
  [7411] = {.lex_state = 48, .external_lex_state = 2},
  [7412] = {.lex_state = 406, .external_lex_state = 2},
  [7413] = {.lex_state = 50, .external_lex_state = 2},
  [7414] = {.lex_state = 50, .external_lex_state = 2},
  [7415] = {.lex_state = 406, .external_lex_state = 2},
  [7416] = {.lex_state = 406, .external_lex_state = 2},
  [7417] = {.lex_state = 50, .external_lex_state = 2},
  [7418] = {.lex_state = 50, .external_lex_state = 2},
  [7419] = {.lex_state = 406, .external_lex_state = 2},
  [7420] = {.lex_state = 50, .external_lex_state = 2},
  [7421] = {.lex_state = 50, .external_lex_state = 2},
  [7422] = {.lex_state = 406, .external_lex_state = 2},
  [7423] = {.lex_state = 50, .external_lex_state = 2},
  [7424] = {.lex_state = 50, .external_lex_state = 2},
  [7425] = {.lex_state = 406, .external_lex_state = 2},
  [7426] = {.lex_state = 406, .external_lex_state = 2},
  [7427] = {.lex_state = 406, .external_lex_state = 2},
  [7428] = {.lex_state = 50, .external_lex_state = 2},
  [7429] = {.lex_state = 406, .external_lex_state = 2},
  [7430] = {.lex_state = 406, .external_lex_state = 2},
  [7431] = {.lex_state = 406, .external_lex_state = 2},
  [7432] = {.lex_state = 406, .external_lex_state = 2},
  [7433] = {.lex_state = 406, .external_lex_state = 2},
  [7434] = {.lex_state = 406, .external_lex_state = 2},
  [7435] = {.lex_state = 406, .external_lex_state = 2},
  [7436] = {.lex_state = 406, .external_lex_state = 2},
  [7437] = {.lex_state = 50, .external_lex_state = 2},
  [7438] = {.lex_state = 406, .external_lex_state = 2},
  [7439] = {.lex_state = 406, .external_lex_state = 2},
  [7440] = {.lex_state = 406, .external_lex_state = 2},
  [7441] = {.lex_state = 50, .external_lex_state = 2},
  [7442] = {.lex_state = 406, .external_lex_state = 2},
  [7443] = {.lex_state = 406, .external_lex_state = 2},
  [7444] = {.lex_state = 406, .external_lex_state = 2},
  [7445] = {.lex_state = 406, .external_lex_state = 2},
  [7446] = {.lex_state = 50, .external_lex_state = 2},
  [7447] = {.lex_state = 406, .external_lex_state = 2},
  [7448] = {.lex_state = 406, .external_lex_state = 2},
  [7449] = {.lex_state = 50, .external_lex_state = 2},
  [7450] = {.lex_state = 406, .external_lex_state = 2},
  [7451] = {.lex_state = 406, .external_lex_state = 2},
  [7452] = {.lex_state = 406, .external_lex_state = 2},
  [7453] = {.lex_state = 406, .external_lex_state = 2},
  [7454] = {.lex_state = 50, .external_lex_state = 2},
  [7455] = {.lex_state = 406, .external_lex_state = 2},
  [7456] = {.lex_state = 50, .external_lex_state = 2},
  [7457] = {.lex_state = 406, .external_lex_state = 2},
  [7458] = {.lex_state = 50, .external_lex_state = 2},
  [7459] = {.lex_state = 406, .external_lex_state = 2},
  [7460] = {.lex_state = 406, .external_lex_state = 2},
  [7461] = {.lex_state = 50, .external_lex_state = 2},
  [7462] = {.lex_state = 406, .external_lex_state = 2},
  [7463] = {.lex_state = 406, .external_lex_state = 2},
  [7464] = {.lex_state = 50, .external_lex_state = 2},
  [7465] = {.lex_state = 406, .external_lex_state = 2},
  [7466] = {.lex_state = 50, .external_lex_state = 2},
  [7467] = {.lex_state = 406, .external_lex_state = 2},
  [7468] = {.lex_state = 406, .external_lex_state = 2},
  [7469] = {.lex_state = 50, .external_lex_state = 2},
  [7470] = {.lex_state = 406, .external_lex_state = 2},
  [7471] = {.lex_state = 50, .external_lex_state = 2},
  [7472] = {.lex_state = 406, .external_lex_state = 2},
  [7473] = {.lex_state = 406, .external_lex_state = 2},
  [7474] = {.lex_state = 50, .external_lex_state = 2},
  [7475] = {.lex_state = 406, .external_lex_state = 2},
  [7476] = {.lex_state = 50, .external_lex_state = 2},
  [7477] = {.lex_state = 406, .external_lex_state = 2},
  [7478] = {.lex_state = 406, .external_lex_state = 2},
  [7479] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LTtemplate_GT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LT_SLASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_private_property_identifier] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_satisfies] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_PLUS_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_unique] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__ternary_qmark] = ACTIONS(1),
    [sym_html_comment] = ACTIONS(5),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
    [sym___error_recovery] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(7375),
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(1),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [sym_hash_bang_line] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [2] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(2),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(4896),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(169),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(176),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(178),
    [anon_sym_DASH_DASH] = ACTIONS(178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(187),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(191),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(193),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(197),
    [anon_sym_number] = ACTIONS(197),
    [anon_sym_boolean] = ACTIONS(197),
    [anon_sym_string] = ACTIONS(197),
    [anon_sym_symbol] = ACTIONS(197),
    [anon_sym_object] = ACTIONS(197),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [3] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(3),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(4896),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(216),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(216),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(169),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(176),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(178),
    [anon_sym_DASH_DASH] = ACTIONS(178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(187),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(191),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(193),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(197),
    [anon_sym_number] = ACTIONS(197),
    [anon_sym_boolean] = ACTIONS(197),
    [anon_sym_string] = ACTIONS(197),
    [anon_sym_symbol] = ACTIONS(197),
    [anon_sym_object] = ACTIONS(197),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [4] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7317),
    [sym_spread_element] = STATE(5740),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(3030),
    [sym_comment] = STATE(4),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(5740),
    [sym_pair] = STATE(5740),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(4583),
    [sym_computed_property_name] = STATE(4582),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_accessibility_modifier] = STATE(3468),
    [sym_override_modifier] = STATE(3530),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [aux_sym_object_repeat1] = STATE(5792),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(221),
    [anon_sym_export] = ACTIONS(223),
    [anon_sym_STAR] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(233),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(237),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(239),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(241),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(245),
    [sym_private_property_identifier] = ACTIONS(247),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_readonly] = ACTIONS(251),
    [anon_sym_get] = ACTIONS(253),
    [anon_sym_set] = ACTIONS(253),
    [anon_sym_declare] = ACTIONS(255),
    [anon_sym_public] = ACTIONS(257),
    [anon_sym_private] = ACTIONS(257),
    [anon_sym_protected] = ACTIONS(257),
    [anon_sym_override] = ACTIONS(259),
    [anon_sym_module] = ACTIONS(261),
    [anon_sym_any] = ACTIONS(263),
    [anon_sym_number] = ACTIONS(263),
    [anon_sym_boolean] = ACTIONS(263),
    [anon_sym_string] = ACTIONS(263),
    [anon_sym_symbol] = ACTIONS(263),
    [anon_sym_object] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [5] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7317),
    [sym_spread_element] = STATE(5740),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(3030),
    [sym_comment] = STATE(5),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(5740),
    [sym_pair] = STATE(5740),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(4583),
    [sym_computed_property_name] = STATE(4582),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_accessibility_modifier] = STATE(3468),
    [sym_override_modifier] = STATE(3530),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(40),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [aux_sym_object_repeat1] = STATE(5792),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(221),
    [anon_sym_export] = ACTIONS(223),
    [anon_sym_STAR] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(265),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(237),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(239),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(241),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(245),
    [sym_private_property_identifier] = ACTIONS(247),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_readonly] = ACTIONS(251),
    [anon_sym_get] = ACTIONS(253),
    [anon_sym_set] = ACTIONS(253),
    [anon_sym_declare] = ACTIONS(255),
    [anon_sym_public] = ACTIONS(257),
    [anon_sym_private] = ACTIONS(257),
    [anon_sym_protected] = ACTIONS(257),
    [anon_sym_override] = ACTIONS(259),
    [anon_sym_module] = ACTIONS(261),
    [anon_sym_any] = ACTIONS(263),
    [anon_sym_number] = ACTIONS(263),
    [anon_sym_boolean] = ACTIONS(263),
    [anon_sym_string] = ACTIONS(263),
    [anon_sym_symbol] = ACTIONS(263),
    [anon_sym_object] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [6] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7317),
    [sym_spread_element] = STATE(5740),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(3030),
    [sym_comment] = STATE(6),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(5740),
    [sym_pair] = STATE(5740),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(4583),
    [sym_computed_property_name] = STATE(4582),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_accessibility_modifier] = STATE(3468),
    [sym_override_modifier] = STATE(3530),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(33),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [aux_sym_object_repeat1] = STATE(5792),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(221),
    [anon_sym_export] = ACTIONS(223),
    [anon_sym_STAR] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(237),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(239),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(241),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(245),
    [sym_private_property_identifier] = ACTIONS(247),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_readonly] = ACTIONS(251),
    [anon_sym_get] = ACTIONS(253),
    [anon_sym_set] = ACTIONS(253),
    [anon_sym_declare] = ACTIONS(255),
    [anon_sym_public] = ACTIONS(257),
    [anon_sym_private] = ACTIONS(257),
    [anon_sym_protected] = ACTIONS(257),
    [anon_sym_override] = ACTIONS(259),
    [anon_sym_module] = ACTIONS(261),
    [anon_sym_any] = ACTIONS(263),
    [anon_sym_number] = ACTIONS(263),
    [anon_sym_boolean] = ACTIONS(263),
    [anon_sym_string] = ACTIONS(263),
    [anon_sym_symbol] = ACTIONS(263),
    [anon_sym_object] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [7] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7317),
    [sym_spread_element] = STATE(5740),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(3030),
    [sym_comment] = STATE(7),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(5740),
    [sym_pair] = STATE(5740),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(4583),
    [sym_computed_property_name] = STATE(4582),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_accessibility_modifier] = STATE(3468),
    [sym_override_modifier] = STATE(3530),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [aux_sym_object_repeat1] = STATE(5792),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(221),
    [anon_sym_export] = ACTIONS(223),
    [anon_sym_STAR] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(237),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(239),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(241),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(245),
    [sym_private_property_identifier] = ACTIONS(247),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_readonly] = ACTIONS(251),
    [anon_sym_get] = ACTIONS(253),
    [anon_sym_set] = ACTIONS(253),
    [anon_sym_declare] = ACTIONS(255),
    [anon_sym_public] = ACTIONS(257),
    [anon_sym_private] = ACTIONS(257),
    [anon_sym_protected] = ACTIONS(257),
    [anon_sym_override] = ACTIONS(259),
    [anon_sym_module] = ACTIONS(261),
    [anon_sym_any] = ACTIONS(263),
    [anon_sym_number] = ACTIONS(263),
    [anon_sym_boolean] = ACTIONS(263),
    [anon_sym_string] = ACTIONS(263),
    [anon_sym_symbol] = ACTIONS(263),
    [anon_sym_object] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [8] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7317),
    [sym_spread_element] = STATE(5740),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(3030),
    [sym_comment] = STATE(8),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(5740),
    [sym_pair] = STATE(5740),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(4583),
    [sym_computed_property_name] = STATE(4582),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_accessibility_modifier] = STATE(3468),
    [sym_override_modifier] = STATE(3530),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(36),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [aux_sym_object_repeat1] = STATE(5792),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(221),
    [anon_sym_export] = ACTIONS(223),
    [anon_sym_STAR] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(271),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(237),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(239),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(241),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(245),
    [sym_private_property_identifier] = ACTIONS(247),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_readonly] = ACTIONS(251),
    [anon_sym_get] = ACTIONS(253),
    [anon_sym_set] = ACTIONS(253),
    [anon_sym_declare] = ACTIONS(255),
    [anon_sym_public] = ACTIONS(257),
    [anon_sym_private] = ACTIONS(257),
    [anon_sym_protected] = ACTIONS(257),
    [anon_sym_override] = ACTIONS(259),
    [anon_sym_module] = ACTIONS(261),
    [anon_sym_any] = ACTIONS(263),
    [anon_sym_number] = ACTIONS(263),
    [anon_sym_boolean] = ACTIONS(263),
    [anon_sym_string] = ACTIONS(263),
    [anon_sym_symbol] = ACTIONS(263),
    [anon_sym_object] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [9] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7317),
    [sym_spread_element] = STATE(5740),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(3030),
    [sym_comment] = STATE(9),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(5740),
    [sym_pair] = STATE(5740),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(4583),
    [sym_computed_property_name] = STATE(4582),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_accessibility_modifier] = STATE(3468),
    [sym_override_modifier] = STATE(3530),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(66),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [aux_sym_object_repeat1] = STATE(5792),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(221),
    [anon_sym_export] = ACTIONS(223),
    [anon_sym_STAR] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(273),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(237),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(239),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(241),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(245),
    [sym_private_property_identifier] = ACTIONS(247),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_readonly] = ACTIONS(251),
    [anon_sym_get] = ACTIONS(253),
    [anon_sym_set] = ACTIONS(253),
    [anon_sym_declare] = ACTIONS(255),
    [anon_sym_public] = ACTIONS(257),
    [anon_sym_private] = ACTIONS(257),
    [anon_sym_protected] = ACTIONS(257),
    [anon_sym_override] = ACTIONS(259),
    [anon_sym_module] = ACTIONS(261),
    [anon_sym_any] = ACTIONS(263),
    [anon_sym_number] = ACTIONS(263),
    [anon_sym_boolean] = ACTIONS(263),
    [anon_sym_string] = ACTIONS(263),
    [anon_sym_symbol] = ACTIONS(263),
    [anon_sym_object] = ACTIONS(263),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [10] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7317),
    [sym_spread_element] = STATE(6145),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(3030),
    [sym_comment] = STATE(10),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(4583),
    [sym_computed_property_name] = STATE(4582),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_accessibility_modifier] = STATE(3468),
    [sym_override_modifier] = STATE(3530),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(42),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_STAR] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(279),
    [anon_sym_namespace] = ACTIONS(281),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(285),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(237),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(287),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(289),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(245),
    [sym_private_property_identifier] = ACTIONS(247),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(293),
    [anon_sym_get] = ACTIONS(295),
    [anon_sym_set] = ACTIONS(295),
    [anon_sym_declare] = ACTIONS(297),
    [anon_sym_public] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_override] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(303),
    [anon_sym_any] = ACTIONS(305),
    [anon_sym_number] = ACTIONS(305),
    [anon_sym_boolean] = ACTIONS(305),
    [anon_sym_string] = ACTIONS(305),
    [anon_sym_symbol] = ACTIONS(305),
    [anon_sym_object] = ACTIONS(305),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [11] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7317),
    [sym_spread_element] = STATE(6145),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(3030),
    [sym_comment] = STATE(11),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(4583),
    [sym_computed_property_name] = STATE(4582),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_accessibility_modifier] = STATE(3468),
    [sym_override_modifier] = STATE(3530),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(42),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(307),
    [anon_sym_export] = ACTIONS(309),
    [anon_sym_STAR] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(311),
    [anon_sym_namespace] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(315),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(237),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(319),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(245),
    [sym_private_property_identifier] = ACTIONS(247),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(321),
    [anon_sym_readonly] = ACTIONS(323),
    [anon_sym_get] = ACTIONS(325),
    [anon_sym_set] = ACTIONS(325),
    [anon_sym_declare] = ACTIONS(327),
    [anon_sym_public] = ACTIONS(329),
    [anon_sym_private] = ACTIONS(329),
    [anon_sym_protected] = ACTIONS(329),
    [anon_sym_override] = ACTIONS(331),
    [anon_sym_module] = ACTIONS(333),
    [anon_sym_any] = ACTIONS(335),
    [anon_sym_number] = ACTIONS(335),
    [anon_sym_boolean] = ACTIONS(335),
    [anon_sym_string] = ACTIONS(335),
    [anon_sym_symbol] = ACTIONS(335),
    [anon_sym_object] = ACTIONS(335),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [12] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1245),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(12),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_default] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_RBRACE] = ACTIONS(341),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_case] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [13] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1245),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(13),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_default] = ACTIONS(403),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [14] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1245),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(14),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_export] = ACTIONS(408),
    [anon_sym_default] = ACTIONS(411),
    [anon_sym_type] = ACTIONS(413),
    [anon_sym_namespace] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(422),
    [anon_sym_import] = ACTIONS(425),
    [anon_sym_with] = ACTIONS(428),
    [anon_sym_var] = ACTIONS(431),
    [anon_sym_let] = ACTIONS(434),
    [anon_sym_const] = ACTIONS(437),
    [anon_sym_BANG] = ACTIONS(422),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_switch] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(446),
    [anon_sym_LPAREN] = ACTIONS(449),
    [anon_sym_await] = ACTIONS(452),
    [anon_sym_while] = ACTIONS(455),
    [anon_sym_do] = ACTIONS(458),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_continue] = ACTIONS(467),
    [anon_sym_debugger] = ACTIONS(470),
    [anon_sym_return] = ACTIONS(473),
    [anon_sym_throw] = ACTIONS(476),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_case] = ACTIONS(411),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LTtemplate_GT] = ACTIONS(488),
    [anon_sym_DQUOTE] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(494),
    [anon_sym_class] = ACTIONS(497),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(503),
    [anon_sym_new] = ACTIONS(506),
    [anon_sym_using] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(422),
    [anon_sym_DASH] = ACTIONS(422),
    [anon_sym_SLASH] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_TILDE] = ACTIONS(422),
    [anon_sym_void] = ACTIONS(422),
    [anon_sym_delete] = ACTIONS(422),
    [anon_sym_PLUS_PLUS] = ACTIONS(518),
    [anon_sym_DASH_DASH] = ACTIONS(518),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_number] = ACTIONS(524),
    [sym_private_property_identifier] = ACTIONS(527),
    [sym_this] = ACTIONS(524),
    [sym_super] = ACTIONS(524),
    [sym_true] = ACTIONS(524),
    [sym_false] = ACTIONS(524),
    [sym_null] = ACTIONS(524),
    [sym_undefined] = ACTIONS(530),
    [anon_sym_AT] = ACTIONS(533),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_readonly] = ACTIONS(536),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(539),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_override] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(542),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [anon_sym_object] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(545),
    [anon_sym_interface] = ACTIONS(548),
    [anon_sym_enum] = ACTIONS(551),
    [sym_html_comment] = ACTIONS(5),
  },
  [15] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1245),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(15),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_default] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_case] = ACTIONS(554),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [16] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1245),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(16),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_default] = ACTIONS(556),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_RBRACE] = ACTIONS(556),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_case] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [17] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(17),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [ts_builtin_sym_end] = ACTIONS(558),
    [sym_identifier] = ACTIONS(560),
    [anon_sym_export] = ACTIONS(563),
    [anon_sym_type] = ACTIONS(566),
    [anon_sym_namespace] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(422),
    [anon_sym_import] = ACTIONS(575),
    [anon_sym_with] = ACTIONS(578),
    [anon_sym_var] = ACTIONS(581),
    [anon_sym_let] = ACTIONS(584),
    [anon_sym_const] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(422),
    [anon_sym_if] = ACTIONS(590),
    [anon_sym_switch] = ACTIONS(593),
    [anon_sym_for] = ACTIONS(596),
    [anon_sym_LPAREN] = ACTIONS(449),
    [anon_sym_await] = ACTIONS(452),
    [anon_sym_while] = ACTIONS(599),
    [anon_sym_do] = ACTIONS(602),
    [anon_sym_try] = ACTIONS(605),
    [anon_sym_break] = ACTIONS(608),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_debugger] = ACTIONS(614),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_throw] = ACTIONS(620),
    [anon_sym_SEMI] = ACTIONS(623),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LTtemplate_GT] = ACTIONS(488),
    [anon_sym_DQUOTE] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(494),
    [anon_sym_class] = ACTIONS(626),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(632),
    [anon_sym_new] = ACTIONS(635),
    [anon_sym_using] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(422),
    [anon_sym_DASH] = ACTIONS(422),
    [anon_sym_SLASH] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_TILDE] = ACTIONS(422),
    [anon_sym_void] = ACTIONS(422),
    [anon_sym_delete] = ACTIONS(422),
    [anon_sym_PLUS_PLUS] = ACTIONS(518),
    [anon_sym_DASH_DASH] = ACTIONS(518),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_number] = ACTIONS(524),
    [sym_private_property_identifier] = ACTIONS(527),
    [sym_this] = ACTIONS(524),
    [sym_super] = ACTIONS(524),
    [sym_true] = ACTIONS(524),
    [sym_false] = ACTIONS(524),
    [sym_null] = ACTIONS(524),
    [sym_undefined] = ACTIONS(530),
    [anon_sym_AT] = ACTIONS(533),
    [anon_sym_static] = ACTIONS(638),
    [anon_sym_readonly] = ACTIONS(638),
    [anon_sym_get] = ACTIONS(638),
    [anon_sym_set] = ACTIONS(638),
    [anon_sym_declare] = ACTIONS(641),
    [anon_sym_public] = ACTIONS(638),
    [anon_sym_private] = ACTIONS(638),
    [anon_sym_protected] = ACTIONS(638),
    [anon_sym_override] = ACTIONS(638),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(638),
    [anon_sym_number] = ACTIONS(638),
    [anon_sym_boolean] = ACTIONS(638),
    [anon_sym_string] = ACTIONS(638),
    [anon_sym_symbol] = ACTIONS(638),
    [anon_sym_object] = ACTIONS(638),
    [anon_sym_abstract] = ACTIONS(647),
    [anon_sym_interface] = ACTIONS(650),
    [anon_sym_enum] = ACTIONS(653),
    [sym_html_comment] = ACTIONS(5),
  },
  [18] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(18),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [19] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(19),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(658),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [20] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(20),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [ts_builtin_sym_end] = ACTIONS(660),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [21] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(21),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(662),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [22] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(22),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [23] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(23),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(52),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [24] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(24),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [25] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(25),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(670),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [26] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(26),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [27] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(27),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [28] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(28),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(676),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [29] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(29),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [30] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(30),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(680),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [31] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(31),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(682),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [32] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(32),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [33] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(33),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(686),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [34] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(34),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(37),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(688),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [35] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(35),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(60),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(690),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [36] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(36),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(692),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [37] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(37),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [38] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(38),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(41),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(696),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [39] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(39),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(49),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [40] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(40),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [41] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(41),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(702),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [42] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(42),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [43] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(43),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(706),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [44] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(44),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(708),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [45] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(45),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(44),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(710),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [46] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(46),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(712),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [47] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(47),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(48),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [48] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(48),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(716),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [49] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(49),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(718),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [50] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(50),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(42),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(720),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [51] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(51),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(59),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [52] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(52),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [53] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(53),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(726),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [54] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(54),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(53),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(728),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [55] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(55),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(730),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [56] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(56),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(732),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [57] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(57),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(68),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(734),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [58] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(58),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(66),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [59] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(59),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [60] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(60),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [61] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(61),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(33),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(742),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [62] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(62),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(36),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(744),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [63] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(63),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(56),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(746),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [64] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(64),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(748),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [65] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(65),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(43),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(750),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [66] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(66),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [67] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(67),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(40),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [68] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(68),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [69] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(69),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(758),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [70] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(70),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [ts_builtin_sym_end] = ACTIONS(760),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [71] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(71),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(69),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(762),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [72] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1556),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(72),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_program_repeat1] = STATE(70),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [ts_builtin_sym_end] = ACTIONS(660),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [73] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1537),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(73),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [74] = {
    [sym_export_statement] = STATE(1443),
    [sym_declaration] = STATE(1443),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1443),
    [sym_statement] = STATE(1437),
    [sym_expression_statement] = STATE(1443),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_statement_block] = STATE(1443),
    [sym_if_statement] = STATE(1443),
    [sym_switch_statement] = STATE(1443),
    [sym_for_statement] = STATE(1443),
    [sym_for_in_statement] = STATE(1443),
    [sym_while_statement] = STATE(1443),
    [sym_do_statement] = STATE(1443),
    [sym_try_statement] = STATE(1443),
    [sym_with_statement] = STATE(1443),
    [sym_break_statement] = STATE(1443),
    [sym_continue_statement] = STATE(1443),
    [sym_debugger_statement] = STATE(1443),
    [sym_return_statement] = STATE(1443),
    [sym_throw_statement] = STATE(1443),
    [sym_empty_statement] = STATE(1443),
    [sym_labeled_statement] = STATE(1443),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6773),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(74),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4833),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_export] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(792),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_debugger] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(810),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_readonly] = ACTIONS(816),
    [anon_sym_get] = ACTIONS(816),
    [anon_sym_set] = ACTIONS(816),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_override] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(820),
    [anon_sym_any] = ACTIONS(816),
    [anon_sym_number] = ACTIONS(816),
    [anon_sym_boolean] = ACTIONS(816),
    [anon_sym_string] = ACTIONS(816),
    [anon_sym_symbol] = ACTIONS(816),
    [anon_sym_object] = ACTIONS(816),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [75] = {
    [sym_export_statement] = STATE(965),
    [sym_declaration] = STATE(965),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(965),
    [sym_statement] = STATE(967),
    [sym_expression_statement] = STATE(965),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_statement_block] = STATE(965),
    [sym_if_statement] = STATE(965),
    [sym_switch_statement] = STATE(965),
    [sym_for_statement] = STATE(965),
    [sym_for_in_statement] = STATE(965),
    [sym_while_statement] = STATE(965),
    [sym_do_statement] = STATE(965),
    [sym_try_statement] = STATE(965),
    [sym_with_statement] = STATE(965),
    [sym_break_statement] = STATE(965),
    [sym_continue_statement] = STATE(965),
    [sym_debugger_statement] = STATE(965),
    [sym_return_statement] = STATE(965),
    [sym_throw_statement] = STATE(965),
    [sym_empty_statement] = STATE(965),
    [sym_labeled_statement] = STATE(965),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6354),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(75),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4838),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_export] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_switch] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(862),
    [anon_sym_debugger] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(880),
    [anon_sym_set] = ACTIONS(880),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(880),
    [anon_sym_private] = ACTIONS(880),
    [anon_sym_protected] = ACTIONS(880),
    [anon_sym_override] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(884),
    [anon_sym_any] = ACTIONS(880),
    [anon_sym_number] = ACTIONS(880),
    [anon_sym_boolean] = ACTIONS(880),
    [anon_sym_string] = ACTIONS(880),
    [anon_sym_symbol] = ACTIONS(880),
    [anon_sym_object] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [76] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1341),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(76),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [77] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(6902),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(77),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [78] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1515),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(78),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [79] = {
    [sym_export_statement] = STATE(965),
    [sym_declaration] = STATE(965),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(965),
    [sym_statement] = STATE(1047),
    [sym_expression_statement] = STATE(965),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_statement_block] = STATE(965),
    [sym_if_statement] = STATE(965),
    [sym_switch_statement] = STATE(965),
    [sym_for_statement] = STATE(965),
    [sym_for_in_statement] = STATE(965),
    [sym_while_statement] = STATE(965),
    [sym_do_statement] = STATE(965),
    [sym_try_statement] = STATE(965),
    [sym_with_statement] = STATE(965),
    [sym_break_statement] = STATE(965),
    [sym_continue_statement] = STATE(965),
    [sym_debugger_statement] = STATE(965),
    [sym_return_statement] = STATE(965),
    [sym_throw_statement] = STATE(965),
    [sym_empty_statement] = STATE(965),
    [sym_labeled_statement] = STATE(965),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6354),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(79),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4838),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_export] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_switch] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(862),
    [anon_sym_debugger] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(880),
    [anon_sym_set] = ACTIONS(880),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(880),
    [anon_sym_private] = ACTIONS(880),
    [anon_sym_protected] = ACTIONS(880),
    [anon_sym_override] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(884),
    [anon_sym_any] = ACTIONS(880),
    [anon_sym_number] = ACTIONS(880),
    [anon_sym_boolean] = ACTIONS(880),
    [anon_sym_string] = ACTIONS(880),
    [anon_sym_symbol] = ACTIONS(880),
    [anon_sym_object] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [80] = {
    [sym_export_statement] = STATE(1443),
    [sym_declaration] = STATE(1443),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1443),
    [sym_statement] = STATE(1043),
    [sym_expression_statement] = STATE(1443),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_statement_block] = STATE(1443),
    [sym_if_statement] = STATE(1443),
    [sym_switch_statement] = STATE(1443),
    [sym_for_statement] = STATE(1443),
    [sym_for_in_statement] = STATE(1443),
    [sym_while_statement] = STATE(1443),
    [sym_do_statement] = STATE(1443),
    [sym_try_statement] = STATE(1443),
    [sym_with_statement] = STATE(1443),
    [sym_break_statement] = STATE(1443),
    [sym_continue_statement] = STATE(1443),
    [sym_debugger_statement] = STATE(1443),
    [sym_return_statement] = STATE(1443),
    [sym_throw_statement] = STATE(1443),
    [sym_empty_statement] = STATE(1443),
    [sym_labeled_statement] = STATE(1443),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6773),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(80),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4833),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_export] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(792),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_debugger] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(810),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_readonly] = ACTIONS(816),
    [anon_sym_get] = ACTIONS(816),
    [anon_sym_set] = ACTIONS(816),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_override] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(820),
    [anon_sym_any] = ACTIONS(816),
    [anon_sym_number] = ACTIONS(816),
    [anon_sym_boolean] = ACTIONS(816),
    [anon_sym_string] = ACTIONS(816),
    [anon_sym_symbol] = ACTIONS(816),
    [anon_sym_object] = ACTIONS(816),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [81] = {
    [sym_export_statement] = STATE(965),
    [sym_declaration] = STATE(965),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(965),
    [sym_statement] = STATE(975),
    [sym_expression_statement] = STATE(965),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_statement_block] = STATE(965),
    [sym_if_statement] = STATE(965),
    [sym_switch_statement] = STATE(965),
    [sym_for_statement] = STATE(965),
    [sym_for_in_statement] = STATE(965),
    [sym_while_statement] = STATE(965),
    [sym_do_statement] = STATE(965),
    [sym_try_statement] = STATE(965),
    [sym_with_statement] = STATE(965),
    [sym_break_statement] = STATE(965),
    [sym_continue_statement] = STATE(965),
    [sym_debugger_statement] = STATE(965),
    [sym_return_statement] = STATE(965),
    [sym_throw_statement] = STATE(965),
    [sym_empty_statement] = STATE(965),
    [sym_labeled_statement] = STATE(965),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6354),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(81),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4838),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_export] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_switch] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(862),
    [anon_sym_debugger] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(880),
    [anon_sym_set] = ACTIONS(880),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(880),
    [anon_sym_private] = ACTIONS(880),
    [anon_sym_protected] = ACTIONS(880),
    [anon_sym_override] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(884),
    [anon_sym_any] = ACTIONS(880),
    [anon_sym_number] = ACTIONS(880),
    [anon_sym_boolean] = ACTIONS(880),
    [anon_sym_string] = ACTIONS(880),
    [anon_sym_symbol] = ACTIONS(880),
    [anon_sym_object] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [82] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1267),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(82),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [83] = {
    [sym_export_statement] = STATE(965),
    [sym_declaration] = STATE(965),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(965),
    [sym_statement] = STATE(1003),
    [sym_expression_statement] = STATE(965),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_statement_block] = STATE(965),
    [sym_if_statement] = STATE(965),
    [sym_switch_statement] = STATE(965),
    [sym_for_statement] = STATE(965),
    [sym_for_in_statement] = STATE(965),
    [sym_while_statement] = STATE(965),
    [sym_do_statement] = STATE(965),
    [sym_try_statement] = STATE(965),
    [sym_with_statement] = STATE(965),
    [sym_break_statement] = STATE(965),
    [sym_continue_statement] = STATE(965),
    [sym_debugger_statement] = STATE(965),
    [sym_return_statement] = STATE(965),
    [sym_throw_statement] = STATE(965),
    [sym_empty_statement] = STATE(965),
    [sym_labeled_statement] = STATE(965),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6354),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(83),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4838),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_export] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_switch] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(862),
    [anon_sym_debugger] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(880),
    [anon_sym_set] = ACTIONS(880),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(880),
    [anon_sym_private] = ACTIONS(880),
    [anon_sym_protected] = ACTIONS(880),
    [anon_sym_override] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(884),
    [anon_sym_any] = ACTIONS(880),
    [anon_sym_number] = ACTIONS(880),
    [anon_sym_boolean] = ACTIONS(880),
    [anon_sym_string] = ACTIONS(880),
    [anon_sym_symbol] = ACTIONS(880),
    [anon_sym_object] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [84] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(6651),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(84),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [85] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1571),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(85),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [86] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(6708),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(86),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [87] = {
    [sym_export_statement] = STATE(1443),
    [sym_declaration] = STATE(1443),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1443),
    [sym_statement] = STATE(1016),
    [sym_expression_statement] = STATE(1443),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_statement_block] = STATE(1443),
    [sym_if_statement] = STATE(1443),
    [sym_switch_statement] = STATE(1443),
    [sym_for_statement] = STATE(1443),
    [sym_for_in_statement] = STATE(1443),
    [sym_while_statement] = STATE(1443),
    [sym_do_statement] = STATE(1443),
    [sym_try_statement] = STATE(1443),
    [sym_with_statement] = STATE(1443),
    [sym_break_statement] = STATE(1443),
    [sym_continue_statement] = STATE(1443),
    [sym_debugger_statement] = STATE(1443),
    [sym_return_statement] = STATE(1443),
    [sym_throw_statement] = STATE(1443),
    [sym_empty_statement] = STATE(1443),
    [sym_labeled_statement] = STATE(1443),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6773),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(87),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4833),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_export] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(792),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_debugger] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(810),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_readonly] = ACTIONS(816),
    [anon_sym_get] = ACTIONS(816),
    [anon_sym_set] = ACTIONS(816),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_override] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(820),
    [anon_sym_any] = ACTIONS(816),
    [anon_sym_number] = ACTIONS(816),
    [anon_sym_boolean] = ACTIONS(816),
    [anon_sym_string] = ACTIONS(816),
    [anon_sym_symbol] = ACTIONS(816),
    [anon_sym_object] = ACTIONS(816),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [88] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1282),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(88),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [89] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(6557),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(89),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [90] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1541),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(90),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [91] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1197),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(91),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [92] = {
    [sym_export_statement] = STATE(1443),
    [sym_declaration] = STATE(1443),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1443),
    [sym_statement] = STATE(1202),
    [sym_expression_statement] = STATE(1443),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_statement_block] = STATE(1443),
    [sym_if_statement] = STATE(1443),
    [sym_switch_statement] = STATE(1443),
    [sym_for_statement] = STATE(1443),
    [sym_for_in_statement] = STATE(1443),
    [sym_while_statement] = STATE(1443),
    [sym_do_statement] = STATE(1443),
    [sym_try_statement] = STATE(1443),
    [sym_with_statement] = STATE(1443),
    [sym_break_statement] = STATE(1443),
    [sym_continue_statement] = STATE(1443),
    [sym_debugger_statement] = STATE(1443),
    [sym_return_statement] = STATE(1443),
    [sym_throw_statement] = STATE(1443),
    [sym_empty_statement] = STATE(1443),
    [sym_labeled_statement] = STATE(1443),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6773),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(92),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4833),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_export] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(792),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_debugger] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(810),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_readonly] = ACTIONS(816),
    [anon_sym_get] = ACTIONS(816),
    [anon_sym_set] = ACTIONS(816),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_override] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(820),
    [anon_sym_any] = ACTIONS(816),
    [anon_sym_number] = ACTIONS(816),
    [anon_sym_boolean] = ACTIONS(816),
    [anon_sym_string] = ACTIONS(816),
    [anon_sym_symbol] = ACTIONS(816),
    [anon_sym_object] = ACTIONS(816),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [93] = {
    [sym_export_statement] = STATE(1443),
    [sym_declaration] = STATE(1443),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1443),
    [sym_statement] = STATE(1272),
    [sym_expression_statement] = STATE(1443),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_statement_block] = STATE(1443),
    [sym_if_statement] = STATE(1443),
    [sym_switch_statement] = STATE(1443),
    [sym_for_statement] = STATE(1443),
    [sym_for_in_statement] = STATE(1443),
    [sym_while_statement] = STATE(1443),
    [sym_do_statement] = STATE(1443),
    [sym_try_statement] = STATE(1443),
    [sym_with_statement] = STATE(1443),
    [sym_break_statement] = STATE(1443),
    [sym_continue_statement] = STATE(1443),
    [sym_debugger_statement] = STATE(1443),
    [sym_return_statement] = STATE(1443),
    [sym_throw_statement] = STATE(1443),
    [sym_empty_statement] = STATE(1443),
    [sym_labeled_statement] = STATE(1443),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6773),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(93),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4833),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_export] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(792),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_debugger] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(810),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_readonly] = ACTIONS(816),
    [anon_sym_get] = ACTIONS(816),
    [anon_sym_set] = ACTIONS(816),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_override] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(820),
    [anon_sym_any] = ACTIONS(816),
    [anon_sym_number] = ACTIONS(816),
    [anon_sym_boolean] = ACTIONS(816),
    [anon_sym_string] = ACTIONS(816),
    [anon_sym_symbol] = ACTIONS(816),
    [anon_sym_object] = ACTIONS(816),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [94] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(7283),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(94),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [95] = {
    [sym_export_statement] = STATE(1443),
    [sym_declaration] = STATE(1443),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1443),
    [sym_statement] = STATE(1217),
    [sym_expression_statement] = STATE(1443),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_statement_block] = STATE(1443),
    [sym_if_statement] = STATE(1443),
    [sym_switch_statement] = STATE(1443),
    [sym_for_statement] = STATE(1443),
    [sym_for_in_statement] = STATE(1443),
    [sym_while_statement] = STATE(1443),
    [sym_do_statement] = STATE(1443),
    [sym_try_statement] = STATE(1443),
    [sym_with_statement] = STATE(1443),
    [sym_break_statement] = STATE(1443),
    [sym_continue_statement] = STATE(1443),
    [sym_debugger_statement] = STATE(1443),
    [sym_return_statement] = STATE(1443),
    [sym_throw_statement] = STATE(1443),
    [sym_empty_statement] = STATE(1443),
    [sym_labeled_statement] = STATE(1443),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6773),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(95),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4833),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_export] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(792),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_debugger] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(810),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_readonly] = ACTIONS(816),
    [anon_sym_get] = ACTIONS(816),
    [anon_sym_set] = ACTIONS(816),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_override] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(820),
    [anon_sym_any] = ACTIONS(816),
    [anon_sym_number] = ACTIONS(816),
    [anon_sym_boolean] = ACTIONS(816),
    [anon_sym_string] = ACTIONS(816),
    [anon_sym_symbol] = ACTIONS(816),
    [anon_sym_object] = ACTIONS(816),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [96] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1547),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(96),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [97] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1489),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(97),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [98] = {
    [sym_export_statement] = STATE(965),
    [sym_declaration] = STATE(965),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(965),
    [sym_statement] = STATE(1088),
    [sym_expression_statement] = STATE(965),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_statement_block] = STATE(965),
    [sym_if_statement] = STATE(965),
    [sym_switch_statement] = STATE(965),
    [sym_for_statement] = STATE(965),
    [sym_for_in_statement] = STATE(965),
    [sym_while_statement] = STATE(965),
    [sym_do_statement] = STATE(965),
    [sym_try_statement] = STATE(965),
    [sym_with_statement] = STATE(965),
    [sym_break_statement] = STATE(965),
    [sym_continue_statement] = STATE(965),
    [sym_debugger_statement] = STATE(965),
    [sym_return_statement] = STATE(965),
    [sym_throw_statement] = STATE(965),
    [sym_empty_statement] = STATE(965),
    [sym_labeled_statement] = STATE(965),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6354),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(98),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4838),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_export] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_switch] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(862),
    [anon_sym_debugger] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(880),
    [anon_sym_set] = ACTIONS(880),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(880),
    [anon_sym_private] = ACTIONS(880),
    [anon_sym_protected] = ACTIONS(880),
    [anon_sym_override] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(884),
    [anon_sym_any] = ACTIONS(880),
    [anon_sym_number] = ACTIONS(880),
    [anon_sym_boolean] = ACTIONS(880),
    [anon_sym_string] = ACTIONS(880),
    [anon_sym_symbol] = ACTIONS(880),
    [anon_sym_object] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [99] = {
    [sym_export_statement] = STATE(965),
    [sym_declaration] = STATE(965),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(965),
    [sym_statement] = STATE(917),
    [sym_expression_statement] = STATE(965),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_statement_block] = STATE(965),
    [sym_if_statement] = STATE(965),
    [sym_switch_statement] = STATE(965),
    [sym_for_statement] = STATE(965),
    [sym_for_in_statement] = STATE(965),
    [sym_while_statement] = STATE(965),
    [sym_do_statement] = STATE(965),
    [sym_try_statement] = STATE(965),
    [sym_with_statement] = STATE(965),
    [sym_break_statement] = STATE(965),
    [sym_continue_statement] = STATE(965),
    [sym_debugger_statement] = STATE(965),
    [sym_return_statement] = STATE(965),
    [sym_throw_statement] = STATE(965),
    [sym_empty_statement] = STATE(965),
    [sym_labeled_statement] = STATE(965),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6354),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(99),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4838),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_export] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_switch] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(862),
    [anon_sym_debugger] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(880),
    [anon_sym_set] = ACTIONS(880),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(880),
    [anon_sym_private] = ACTIONS(880),
    [anon_sym_protected] = ACTIONS(880),
    [anon_sym_override] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(884),
    [anon_sym_any] = ACTIONS(880),
    [anon_sym_number] = ACTIONS(880),
    [anon_sym_boolean] = ACTIONS(880),
    [anon_sym_string] = ACTIONS(880),
    [anon_sym_symbol] = ACTIONS(880),
    [anon_sym_object] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [100] = {
    [sym_export_statement] = STATE(965),
    [sym_declaration] = STATE(965),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(965),
    [sym_statement] = STATE(1138),
    [sym_expression_statement] = STATE(965),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_statement_block] = STATE(965),
    [sym_if_statement] = STATE(965),
    [sym_switch_statement] = STATE(965),
    [sym_for_statement] = STATE(965),
    [sym_for_in_statement] = STATE(965),
    [sym_while_statement] = STATE(965),
    [sym_do_statement] = STATE(965),
    [sym_try_statement] = STATE(965),
    [sym_with_statement] = STATE(965),
    [sym_break_statement] = STATE(965),
    [sym_continue_statement] = STATE(965),
    [sym_debugger_statement] = STATE(965),
    [sym_return_statement] = STATE(965),
    [sym_throw_statement] = STATE(965),
    [sym_empty_statement] = STATE(965),
    [sym_labeled_statement] = STATE(965),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6354),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(100),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4838),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_export] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_switch] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(862),
    [anon_sym_debugger] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(880),
    [anon_sym_set] = ACTIONS(880),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(880),
    [anon_sym_private] = ACTIONS(880),
    [anon_sym_protected] = ACTIONS(880),
    [anon_sym_override] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(884),
    [anon_sym_any] = ACTIONS(880),
    [anon_sym_number] = ACTIONS(880),
    [anon_sym_boolean] = ACTIONS(880),
    [anon_sym_string] = ACTIONS(880),
    [anon_sym_symbol] = ACTIONS(880),
    [anon_sym_object] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [101] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1343),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(101),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [102] = {
    [sym_export_statement] = STATE(1443),
    [sym_declaration] = STATE(1443),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1443),
    [sym_statement] = STATE(1328),
    [sym_expression_statement] = STATE(1443),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_statement_block] = STATE(1443),
    [sym_if_statement] = STATE(1443),
    [sym_switch_statement] = STATE(1443),
    [sym_for_statement] = STATE(1443),
    [sym_for_in_statement] = STATE(1443),
    [sym_while_statement] = STATE(1443),
    [sym_do_statement] = STATE(1443),
    [sym_try_statement] = STATE(1443),
    [sym_with_statement] = STATE(1443),
    [sym_break_statement] = STATE(1443),
    [sym_continue_statement] = STATE(1443),
    [sym_debugger_statement] = STATE(1443),
    [sym_return_statement] = STATE(1443),
    [sym_throw_statement] = STATE(1443),
    [sym_empty_statement] = STATE(1443),
    [sym_labeled_statement] = STATE(1443),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6773),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(102),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4833),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_export] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(792),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_debugger] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(810),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_readonly] = ACTIONS(816),
    [anon_sym_get] = ACTIONS(816),
    [anon_sym_set] = ACTIONS(816),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_override] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(820),
    [anon_sym_any] = ACTIONS(816),
    [anon_sym_number] = ACTIONS(816),
    [anon_sym_boolean] = ACTIONS(816),
    [anon_sym_string] = ACTIONS(816),
    [anon_sym_symbol] = ACTIONS(816),
    [anon_sym_object] = ACTIONS(816),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [103] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(7096),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(103),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [104] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(7204),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(104),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [105] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1326),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(105),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [106] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(6950),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(106),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [107] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1405),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(107),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [108] = {
    [sym_export_statement] = STATE(965),
    [sym_declaration] = STATE(965),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(965),
    [sym_statement] = STATE(942),
    [sym_expression_statement] = STATE(965),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_statement_block] = STATE(965),
    [sym_if_statement] = STATE(965),
    [sym_switch_statement] = STATE(965),
    [sym_for_statement] = STATE(965),
    [sym_for_in_statement] = STATE(965),
    [sym_while_statement] = STATE(965),
    [sym_do_statement] = STATE(965),
    [sym_try_statement] = STATE(965),
    [sym_with_statement] = STATE(965),
    [sym_break_statement] = STATE(965),
    [sym_continue_statement] = STATE(965),
    [sym_debugger_statement] = STATE(965),
    [sym_return_statement] = STATE(965),
    [sym_throw_statement] = STATE(965),
    [sym_empty_statement] = STATE(965),
    [sym_labeled_statement] = STATE(965),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6354),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(108),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4838),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_export] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_switch] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(862),
    [anon_sym_debugger] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(880),
    [anon_sym_set] = ACTIONS(880),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(880),
    [anon_sym_private] = ACTIONS(880),
    [anon_sym_protected] = ACTIONS(880),
    [anon_sym_override] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(884),
    [anon_sym_any] = ACTIONS(880),
    [anon_sym_number] = ACTIONS(880),
    [anon_sym_boolean] = ACTIONS(880),
    [anon_sym_string] = ACTIONS(880),
    [anon_sym_symbol] = ACTIONS(880),
    [anon_sym_object] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [109] = {
    [sym_export_statement] = STATE(1443),
    [sym_declaration] = STATE(1443),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1443),
    [sym_statement] = STATE(1391),
    [sym_expression_statement] = STATE(1443),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_statement_block] = STATE(1443),
    [sym_if_statement] = STATE(1443),
    [sym_switch_statement] = STATE(1443),
    [sym_for_statement] = STATE(1443),
    [sym_for_in_statement] = STATE(1443),
    [sym_while_statement] = STATE(1443),
    [sym_do_statement] = STATE(1443),
    [sym_try_statement] = STATE(1443),
    [sym_with_statement] = STATE(1443),
    [sym_break_statement] = STATE(1443),
    [sym_continue_statement] = STATE(1443),
    [sym_debugger_statement] = STATE(1443),
    [sym_return_statement] = STATE(1443),
    [sym_throw_statement] = STATE(1443),
    [sym_empty_statement] = STATE(1443),
    [sym_labeled_statement] = STATE(1443),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6773),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(109),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4833),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_export] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(792),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_debugger] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(810),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_readonly] = ACTIONS(816),
    [anon_sym_get] = ACTIONS(816),
    [anon_sym_set] = ACTIONS(816),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_override] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(820),
    [anon_sym_any] = ACTIONS(816),
    [anon_sym_number] = ACTIONS(816),
    [anon_sym_boolean] = ACTIONS(816),
    [anon_sym_string] = ACTIONS(816),
    [anon_sym_symbol] = ACTIONS(816),
    [anon_sym_object] = ACTIONS(816),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [110] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(6622),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(110),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [111] = {
    [sym_export_statement] = STATE(1443),
    [sym_declaration] = STATE(1443),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1443),
    [sym_statement] = STATE(1230),
    [sym_expression_statement] = STATE(1443),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_statement_block] = STATE(1443),
    [sym_if_statement] = STATE(1443),
    [sym_switch_statement] = STATE(1443),
    [sym_for_statement] = STATE(1443),
    [sym_for_in_statement] = STATE(1443),
    [sym_while_statement] = STATE(1443),
    [sym_do_statement] = STATE(1443),
    [sym_try_statement] = STATE(1443),
    [sym_with_statement] = STATE(1443),
    [sym_break_statement] = STATE(1443),
    [sym_continue_statement] = STATE(1443),
    [sym_debugger_statement] = STATE(1443),
    [sym_return_statement] = STATE(1443),
    [sym_throw_statement] = STATE(1443),
    [sym_empty_statement] = STATE(1443),
    [sym_labeled_statement] = STATE(1443),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6773),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(111),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4833),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_export] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(792),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_debugger] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(810),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_readonly] = ACTIONS(816),
    [anon_sym_get] = ACTIONS(816),
    [anon_sym_set] = ACTIONS(816),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_override] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(820),
    [anon_sym_any] = ACTIONS(816),
    [anon_sym_number] = ACTIONS(816),
    [anon_sym_boolean] = ACTIONS(816),
    [anon_sym_string] = ACTIONS(816),
    [anon_sym_symbol] = ACTIONS(816),
    [anon_sym_object] = ACTIONS(816),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [112] = {
    [sym_export_statement] = STATE(1443),
    [sym_declaration] = STATE(1443),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1443),
    [sym_statement] = STATE(1215),
    [sym_expression_statement] = STATE(1443),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_statement_block] = STATE(1443),
    [sym_if_statement] = STATE(1443),
    [sym_switch_statement] = STATE(1443),
    [sym_for_statement] = STATE(1443),
    [sym_for_in_statement] = STATE(1443),
    [sym_while_statement] = STATE(1443),
    [sym_do_statement] = STATE(1443),
    [sym_try_statement] = STATE(1443),
    [sym_with_statement] = STATE(1443),
    [sym_break_statement] = STATE(1443),
    [sym_continue_statement] = STATE(1443),
    [sym_debugger_statement] = STATE(1443),
    [sym_return_statement] = STATE(1443),
    [sym_throw_statement] = STATE(1443),
    [sym_empty_statement] = STATE(1443),
    [sym_labeled_statement] = STATE(1443),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6773),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(112),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4833),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_export] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(792),
    [anon_sym_try] = ACTIONS(794),
    [anon_sym_break] = ACTIONS(796),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_debugger] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_throw] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(810),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_readonly] = ACTIONS(816),
    [anon_sym_get] = ACTIONS(816),
    [anon_sym_set] = ACTIONS(816),
    [anon_sym_declare] = ACTIONS(818),
    [anon_sym_public] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_override] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(820),
    [anon_sym_any] = ACTIONS(816),
    [anon_sym_number] = ACTIONS(816),
    [anon_sym_boolean] = ACTIONS(816),
    [anon_sym_string] = ACTIONS(816),
    [anon_sym_symbol] = ACTIONS(816),
    [anon_sym_object] = ACTIONS(816),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [113] = {
    [sym_export_statement] = STATE(965),
    [sym_declaration] = STATE(965),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(965),
    [sym_statement] = STATE(1118),
    [sym_expression_statement] = STATE(965),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_statement_block] = STATE(965),
    [sym_if_statement] = STATE(965),
    [sym_switch_statement] = STATE(965),
    [sym_for_statement] = STATE(965),
    [sym_for_in_statement] = STATE(965),
    [sym_while_statement] = STATE(965),
    [sym_do_statement] = STATE(965),
    [sym_try_statement] = STATE(965),
    [sym_with_statement] = STATE(965),
    [sym_break_statement] = STATE(965),
    [sym_continue_statement] = STATE(965),
    [sym_debugger_statement] = STATE(965),
    [sym_return_statement] = STATE(965),
    [sym_throw_statement] = STATE(965),
    [sym_empty_statement] = STATE(965),
    [sym_labeled_statement] = STATE(965),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6354),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(113),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4838),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_export] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_switch] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(862),
    [anon_sym_debugger] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(880),
    [anon_sym_set] = ACTIONS(880),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(880),
    [anon_sym_private] = ACTIONS(880),
    [anon_sym_protected] = ACTIONS(880),
    [anon_sym_override] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(884),
    [anon_sym_any] = ACTIONS(880),
    [anon_sym_number] = ACTIONS(880),
    [anon_sym_boolean] = ACTIONS(880),
    [anon_sym_string] = ACTIONS(880),
    [anon_sym_symbol] = ACTIONS(880),
    [anon_sym_object] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [114] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(7030),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(114),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [115] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(5822),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(115),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [116] = {
    [sym_export_statement] = STATE(965),
    [sym_declaration] = STATE(965),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(965),
    [sym_statement] = STATE(1112),
    [sym_expression_statement] = STATE(965),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_statement_block] = STATE(965),
    [sym_if_statement] = STATE(965),
    [sym_switch_statement] = STATE(965),
    [sym_for_statement] = STATE(965),
    [sym_for_in_statement] = STATE(965),
    [sym_while_statement] = STATE(965),
    [sym_do_statement] = STATE(965),
    [sym_try_statement] = STATE(965),
    [sym_with_statement] = STATE(965),
    [sym_break_statement] = STATE(965),
    [sym_continue_statement] = STATE(965),
    [sym_debugger_statement] = STATE(965),
    [sym_return_statement] = STATE(965),
    [sym_throw_statement] = STATE(965),
    [sym_empty_statement] = STATE(965),
    [sym_labeled_statement] = STATE(965),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6354),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(116),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4838),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_export] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_switch] = ACTIONS(850),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(856),
    [anon_sym_try] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(862),
    [anon_sym_debugger] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_throw] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(870),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(874),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(880),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_get] = ACTIONS(880),
    [anon_sym_set] = ACTIONS(880),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(880),
    [anon_sym_private] = ACTIONS(880),
    [anon_sym_protected] = ACTIONS(880),
    [anon_sym_override] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(884),
    [anon_sym_any] = ACTIONS(880),
    [anon_sym_number] = ACTIONS(880),
    [anon_sym_boolean] = ACTIONS(880),
    [anon_sym_string] = ACTIONS(880),
    [anon_sym_symbol] = ACTIONS(880),
    [anon_sym_object] = ACTIONS(880),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [117] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1490),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(117),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [118] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(7033),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(118),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [119] = {
    [sym_export_statement] = STATE(1393),
    [sym_declaration] = STATE(1393),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1393),
    [sym_statement] = STATE(1414),
    [sym_expression_statement] = STATE(1393),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_statement_block] = STATE(1393),
    [sym_if_statement] = STATE(1393),
    [sym_switch_statement] = STATE(1393),
    [sym_for_statement] = STATE(1393),
    [sym_for_in_statement] = STATE(1393),
    [sym_while_statement] = STATE(1393),
    [sym_do_statement] = STATE(1393),
    [sym_try_statement] = STATE(1393),
    [sym_with_statement] = STATE(1393),
    [sym_break_statement] = STATE(1393),
    [sym_continue_statement] = STATE(1393),
    [sym_debugger_statement] = STATE(1393),
    [sym_return_statement] = STATE(1393),
    [sym_throw_statement] = STATE(1393),
    [sym_empty_statement] = STATE(1393),
    [sym_labeled_statement] = STATE(1393),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2416),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6752),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(119),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4841),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_export] = ACTIONS(339),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_namespace] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_with] = ACTIONS(351),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_debugger] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(385),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(389),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_get] = ACTIONS(391),
    [anon_sym_set] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(393),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_override] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_any] = ACTIONS(391),
    [anon_sym_number] = ACTIONS(391),
    [anon_sym_boolean] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_symbol] = ACTIONS(391),
    [anon_sym_object] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [120] = {
    [sym_export_statement] = STATE(1554),
    [sym_declaration] = STATE(1554),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(1554),
    [sym_statement] = STATE(1470),
    [sym_expression_statement] = STATE(1554),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_statement_block] = STATE(1554),
    [sym_if_statement] = STATE(1554),
    [sym_switch_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_for_in_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_do_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_with_statement] = STATE(1554),
    [sym_break_statement] = STATE(1554),
    [sym_continue_statement] = STATE(1554),
    [sym_debugger_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_throw_statement] = STATE(1554),
    [sym_empty_statement] = STATE(1554),
    [sym_labeled_statement] = STATE(1554),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6480),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(120),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4684),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [121] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(6536),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(121),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [122] = {
    [sym_export_statement] = STATE(6355),
    [sym_declaration] = STATE(6355),
    [sym_import] = STATE(4290),
    [sym_import_statement] = STATE(6355),
    [sym_statement] = STATE(6711),
    [sym_expression_statement] = STATE(6355),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_statement_block] = STATE(6355),
    [sym_if_statement] = STATE(6355),
    [sym_switch_statement] = STATE(6355),
    [sym_for_statement] = STATE(6355),
    [sym_for_in_statement] = STATE(6355),
    [sym_while_statement] = STATE(6355),
    [sym_do_statement] = STATE(6355),
    [sym_try_statement] = STATE(6355),
    [sym_with_statement] = STATE(6355),
    [sym_break_statement] = STATE(6355),
    [sym_continue_statement] = STATE(6355),
    [sym_debugger_statement] = STATE(6355),
    [sym_return_statement] = STATE(6355),
    [sym_throw_statement] = STATE(6355),
    [sym_empty_statement] = STATE(6355),
    [sym_labeled_statement] = STATE(6355),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6737),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(122),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4795),
    [sym_identifier] = ACTIONS(892),
    [anon_sym_export] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(896),
    [anon_sym_namespace] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_debugger] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(948),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_object] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [123] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(123),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_readonly] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_override] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_any] = ACTIONS(958),
    [anon_sym_number] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [anon_sym_object] = ACTIONS(958),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [124] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2670),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(5774),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(124),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(5167),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6160),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(5776),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_RBRACK] = ACTIONS(1009),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1033),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1035),
    [anon_sym_number] = ACTIONS(1035),
    [anon_sym_boolean] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [anon_sym_symbol] = ACTIONS(1035),
    [anon_sym_object] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [125] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(125),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(5167),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6160),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_RBRACK] = ACTIONS(1037),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1033),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1035),
    [anon_sym_number] = ACTIONS(1035),
    [anon_sym_boolean] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [anon_sym_symbol] = ACTIONS(1035),
    [anon_sym_object] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [126] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(126),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(5167),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6160),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_RBRACK] = ACTIONS(1039),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1033),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1035),
    [anon_sym_number] = ACTIONS(1035),
    [anon_sym_boolean] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [anon_sym_symbol] = ACTIONS(1035),
    [anon_sym_object] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [127] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(127),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_readonly] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_override] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_any] = ACTIONS(958),
    [anon_sym_number] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [anon_sym_object] = ACTIONS(958),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [128] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(128),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_readonly] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_override] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_any] = ACTIONS(958),
    [anon_sym_number] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [anon_sym_object] = ACTIONS(958),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [129] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(129),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(5167),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(5706),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_RBRACK] = ACTIONS(1047),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1033),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1035),
    [anon_sym_number] = ACTIONS(1035),
    [anon_sym_boolean] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [anon_sym_symbol] = ACTIONS(1035),
    [anon_sym_object] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [130] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2670),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(5774),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(130),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(5167),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6160),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(5776),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_RBRACK] = ACTIONS(1049),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1033),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1035),
    [anon_sym_number] = ACTIONS(1035),
    [anon_sym_boolean] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [anon_sym_symbol] = ACTIONS(1035),
    [anon_sym_object] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [131] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(131),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(5167),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6160),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_RBRACK] = ACTIONS(1051),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1033),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1035),
    [anon_sym_number] = ACTIONS(1035),
    [anon_sym_boolean] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [anon_sym_symbol] = ACTIONS(1035),
    [anon_sym_object] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [132] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(132),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(5167),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6160),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_RBRACK] = ACTIONS(1053),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1033),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1035),
    [anon_sym_number] = ACTIONS(1035),
    [anon_sym_boolean] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [anon_sym_symbol] = ACTIONS(1035),
    [anon_sym_object] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [133] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(133),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(5167),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6160),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_RBRACK] = ACTIONS(1055),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1033),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1035),
    [anon_sym_number] = ACTIONS(1035),
    [anon_sym_boolean] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [anon_sym_symbol] = ACTIONS(1035),
    [anon_sym_object] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [134] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(134),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(5167),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6160),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_RBRACK] = ACTIONS(1057),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1033),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1035),
    [anon_sym_number] = ACTIONS(1035),
    [anon_sym_boolean] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [anon_sym_symbol] = ACTIONS(1035),
    [anon_sym_object] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [135] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(135),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(5167),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6160),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_RBRACK] = ACTIONS(1059),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1033),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1035),
    [anon_sym_number] = ACTIONS(1035),
    [anon_sym_boolean] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [anon_sym_symbol] = ACTIONS(1035),
    [anon_sym_object] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [136] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(136),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5156),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_SLASH] = ACTIONS(169),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(178),
    [anon_sym_DASH_DASH] = ACTIONS(178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1079),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [137] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(137),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5080),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_SLASH] = ACTIONS(169),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(178),
    [anon_sym_DASH_DASH] = ACTIONS(178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1083),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [138] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(138),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5290),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_SLASH] = ACTIONS(169),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(178),
    [anon_sym_DASH_DASH] = ACTIONS(178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1085),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [139] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(139),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(4896),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(216),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(216),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_SLASH] = ACTIONS(169),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(178),
    [anon_sym_DASH_DASH] = ACTIONS(178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1087),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [140] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(140),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5283),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_SLASH] = ACTIONS(169),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(178),
    [anon_sym_DASH_DASH] = ACTIONS(178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1089),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [141] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(141),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5265),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_SLASH] = ACTIONS(169),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(178),
    [anon_sym_DASH_DASH] = ACTIONS(178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1091),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [142] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(142),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5061),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_SLASH] = ACTIONS(169),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(178),
    [anon_sym_DASH_DASH] = ACTIONS(178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1093),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [143] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(143),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(4896),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(132),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_DASH] = ACTIONS(132),
    [anon_sym_SLASH] = ACTIONS(169),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(178),
    [anon_sym_DASH_DASH] = ACTIONS(178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1087),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [144] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(144),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1105),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(1105),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [145] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(145),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1121),
    [anon_sym_export] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1123),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_RBRACE] = ACTIONS(216),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(216),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(216),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1131),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1133),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1123),
    [anon_sym_get] = ACTIONS(1123),
    [anon_sym_set] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(1123),
    [anon_sym_public] = ACTIONS(1123),
    [anon_sym_private] = ACTIONS(1123),
    [anon_sym_protected] = ACTIONS(1123),
    [anon_sym_override] = ACTIONS(1123),
    [anon_sym_module] = ACTIONS(1123),
    [anon_sym_any] = ACTIONS(1123),
    [anon_sym_number] = ACTIONS(1123),
    [anon_sym_boolean] = ACTIONS(1123),
    [anon_sym_string] = ACTIONS(1123),
    [anon_sym_symbol] = ACTIONS(1123),
    [anon_sym_object] = ACTIONS(1123),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [146] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(146),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [147] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2368),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym__formal_parameter] = STATE(5763),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7288),
    [sym_string] = STATE(3050),
    [sym_comment] = STATE(147),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym__type] = STATE(5556),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1139),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1143),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1147),
    [sym_number] = ACTIONS(1149),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [sym_null] = ACTIONS(1149),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1157),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(1159),
    [anon_sym_private] = ACTIONS(1159),
    [anon_sym_protected] = ACTIONS(1159),
    [anon_sym_override] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1163),
    [anon_sym_number] = ACTIONS(1163),
    [anon_sym_boolean] = ACTIONS(1163),
    [anon_sym_string] = ACTIONS(1163),
    [anon_sym_symbol] = ACTIONS(1163),
    [anon_sym_object] = ACTIONS(1163),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [148] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2323),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym__formal_parameter] = STATE(5763),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7121),
    [sym_string] = STATE(3050),
    [sym_comment] = STATE(148),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym__type] = STATE(5602),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1139),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1143),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1147),
    [sym_number] = ACTIONS(1149),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [sym_null] = ACTIONS(1149),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1157),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(1159),
    [anon_sym_private] = ACTIONS(1159),
    [anon_sym_protected] = ACTIONS(1159),
    [anon_sym_override] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1163),
    [anon_sym_number] = ACTIONS(1163),
    [anon_sym_boolean] = ACTIONS(1163),
    [anon_sym_string] = ACTIONS(1163),
    [anon_sym_symbol] = ACTIONS(1163),
    [anon_sym_object] = ACTIONS(1163),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [149] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(149),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1121),
    [anon_sym_export] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1123),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(216),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(216),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1131),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1133),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1123),
    [anon_sym_get] = ACTIONS(1123),
    [anon_sym_set] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(1123),
    [anon_sym_public] = ACTIONS(1123),
    [anon_sym_private] = ACTIONS(1123),
    [anon_sym_protected] = ACTIONS(1123),
    [anon_sym_override] = ACTIONS(1123),
    [anon_sym_module] = ACTIONS(1123),
    [anon_sym_any] = ACTIONS(1123),
    [anon_sym_number] = ACTIONS(1123),
    [anon_sym_boolean] = ACTIONS(1123),
    [anon_sym_string] = ACTIONS(1123),
    [anon_sym_symbol] = ACTIONS(1123),
    [anon_sym_object] = ACTIONS(1123),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [150] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2323),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym__formal_parameter] = STATE(5763),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7121),
    [sym_string] = STATE(3050),
    [sym_comment] = STATE(150),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym__type] = STATE(5556),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1139),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1143),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1147),
    [sym_number] = ACTIONS(1149),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [sym_null] = ACTIONS(1149),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1157),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(1159),
    [anon_sym_private] = ACTIONS(1159),
    [anon_sym_protected] = ACTIONS(1159),
    [anon_sym_override] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1163),
    [anon_sym_number] = ACTIONS(1163),
    [anon_sym_boolean] = ACTIONS(1163),
    [anon_sym_string] = ACTIONS(1163),
    [anon_sym_symbol] = ACTIONS(1163),
    [anon_sym_object] = ACTIONS(1163),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [151] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(151),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [152] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(152),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1121),
    [anon_sym_export] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1123),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1131),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1133),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1123),
    [anon_sym_get] = ACTIONS(1123),
    [anon_sym_set] = ACTIONS(1123),
    [anon_sym_declare] = ACTIONS(1123),
    [anon_sym_public] = ACTIONS(1123),
    [anon_sym_private] = ACTIONS(1123),
    [anon_sym_protected] = ACTIONS(1123),
    [anon_sym_override] = ACTIONS(1123),
    [anon_sym_module] = ACTIONS(1123),
    [anon_sym_any] = ACTIONS(1123),
    [anon_sym_number] = ACTIONS(1123),
    [anon_sym_boolean] = ACTIONS(1123),
    [anon_sym_string] = ACTIONS(1123),
    [anon_sym_symbol] = ACTIONS(1123),
    [anon_sym_object] = ACTIONS(1123),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [153] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(153),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1121),
    [anon_sym_export] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1123),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1131),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1133),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1123),
    [anon_sym_get] = ACTIONS(1123),
    [anon_sym_set] = ACTIONS(1123),
    [anon_sym_declare] = ACTIONS(1123),
    [anon_sym_public] = ACTIONS(1123),
    [anon_sym_private] = ACTIONS(1123),
    [anon_sym_protected] = ACTIONS(1123),
    [anon_sym_override] = ACTIONS(1123),
    [anon_sym_module] = ACTIONS(1123),
    [anon_sym_any] = ACTIONS(1123),
    [anon_sym_number] = ACTIONS(1123),
    [anon_sym_boolean] = ACTIONS(1123),
    [anon_sym_string] = ACTIONS(1123),
    [anon_sym_symbol] = ACTIONS(1123),
    [anon_sym_object] = ACTIONS(1123),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [154] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(5763),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(154),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym__type] = STATE(5446),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(176),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1167),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(191),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1169),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(197),
    [anon_sym_number] = ACTIONS(197),
    [anon_sym_boolean] = ACTIONS(197),
    [anon_sym_string] = ACTIONS(197),
    [anon_sym_symbol] = ACTIONS(197),
    [anon_sym_object] = ACTIONS(197),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [155] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(155),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [156] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(156),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1177),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_readonly] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_override] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_any] = ACTIONS(958),
    [anon_sym_number] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [anon_sym_object] = ACTIONS(958),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [157] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(157),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1179),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [158] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(5763),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(158),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym__type] = STATE(5462),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(176),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1167),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(191),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1169),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(197),
    [anon_sym_number] = ACTIONS(197),
    [anon_sym_boolean] = ACTIONS(197),
    [anon_sym_string] = ACTIONS(197),
    [anon_sym_symbol] = ACTIONS(197),
    [anon_sym_object] = ACTIONS(197),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [159] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(159),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_readonly] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_override] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_any] = ACTIONS(958),
    [anon_sym_number] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [anon_sym_object] = ACTIONS(958),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [160] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(160),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_export] = ACTIONS(1183),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1183),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1189),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(1179),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1191),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1183),
    [anon_sym_get] = ACTIONS(1183),
    [anon_sym_set] = ACTIONS(1183),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(1183),
    [anon_sym_private] = ACTIONS(1183),
    [anon_sym_protected] = ACTIONS(1183),
    [anon_sym_override] = ACTIONS(1183),
    [anon_sym_module] = ACTIONS(1183),
    [anon_sym_any] = ACTIONS(1183),
    [anon_sym_number] = ACTIONS(1183),
    [anon_sym_boolean] = ACTIONS(1183),
    [anon_sym_string] = ACTIONS(1183),
    [anon_sym_symbol] = ACTIONS(1183),
    [anon_sym_object] = ACTIONS(1183),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [161] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(161),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1195),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_readonly] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_override] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_any] = ACTIONS(958),
    [anon_sym_number] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [anon_sym_object] = ACTIONS(958),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [162] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(162),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_readonly] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_override] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_any] = ACTIONS(958),
    [anon_sym_number] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [anon_sym_object] = ACTIONS(958),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [163] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(163),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [164] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(164),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_readonly] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_override] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_any] = ACTIONS(958),
    [anon_sym_number] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [anon_sym_object] = ACTIONS(958),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [165] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(5763),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(165),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym__type] = STATE(5556),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(176),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1167),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(191),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1169),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(197),
    [anon_sym_number] = ACTIONS(197),
    [anon_sym_boolean] = ACTIONS(197),
    [anon_sym_string] = ACTIONS(197),
    [anon_sym_symbol] = ACTIONS(197),
    [anon_sym_object] = ACTIONS(197),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [166] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(5763),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(166),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym__type] = STATE(5602),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(176),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1167),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(191),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1169),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(197),
    [anon_sym_number] = ACTIONS(197),
    [anon_sym_boolean] = ACTIONS(197),
    [anon_sym_string] = ACTIONS(197),
    [anon_sym_symbol] = ACTIONS(197),
    [anon_sym_object] = ACTIONS(197),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [167] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(167),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_export] = ACTIONS(1183),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1183),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1189),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(1179),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1191),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1183),
    [anon_sym_get] = ACTIONS(1183),
    [anon_sym_set] = ACTIONS(1183),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(1183),
    [anon_sym_private] = ACTIONS(1183),
    [anon_sym_protected] = ACTIONS(1183),
    [anon_sym_override] = ACTIONS(1183),
    [anon_sym_module] = ACTIONS(1183),
    [anon_sym_any] = ACTIONS(1183),
    [anon_sym_number] = ACTIONS(1183),
    [anon_sym_boolean] = ACTIONS(1183),
    [anon_sym_string] = ACTIONS(1183),
    [anon_sym_symbol] = ACTIONS(1183),
    [anon_sym_object] = ACTIONS(1183),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [168] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(168),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_readonly] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_override] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_any] = ACTIONS(958),
    [anon_sym_number] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [anon_sym_object] = ACTIONS(958),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [169] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(169),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_readonly] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_override] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_any] = ACTIONS(958),
    [anon_sym_number] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [anon_sym_object] = ACTIONS(958),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [170] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(5763),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(170),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4958),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym__type] = STATE(5471),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(126),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(176),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1167),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(191),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1169),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(197),
    [anon_sym_number] = ACTIONS(197),
    [anon_sym_boolean] = ACTIONS(197),
    [anon_sym_string] = ACTIONS(197),
    [anon_sym_symbol] = ACTIONS(197),
    [anon_sym_object] = ACTIONS(197),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [171] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(171),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_export] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_of] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(981),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_readonly] = ACTIONS(958),
    [anon_sym_get] = ACTIONS(958),
    [anon_sym_set] = ACTIONS(958),
    [anon_sym_declare] = ACTIONS(958),
    [anon_sym_public] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym_protected] = ACTIONS(958),
    [anon_sym_override] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(958),
    [anon_sym_any] = ACTIONS(958),
    [anon_sym_number] = ACTIONS(958),
    [anon_sym_boolean] = ACTIONS(958),
    [anon_sym_string] = ACTIONS(958),
    [anon_sym_symbol] = ACTIONS(958),
    [anon_sym_object] = ACTIONS(958),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [172] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(172),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1121),
    [anon_sym_export] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1123),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(1208),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(1208),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1131),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1133),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1123),
    [anon_sym_get] = ACTIONS(1123),
    [anon_sym_set] = ACTIONS(1123),
    [anon_sym_declare] = ACTIONS(1123),
    [anon_sym_public] = ACTIONS(1123),
    [anon_sym_private] = ACTIONS(1123),
    [anon_sym_protected] = ACTIONS(1123),
    [anon_sym_override] = ACTIONS(1123),
    [anon_sym_module] = ACTIONS(1123),
    [anon_sym_any] = ACTIONS(1123),
    [anon_sym_number] = ACTIONS(1123),
    [anon_sym_boolean] = ACTIONS(1123),
    [anon_sym_string] = ACTIONS(1123),
    [anon_sym_symbol] = ACTIONS(1123),
    [anon_sym_object] = ACTIONS(1123),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [173] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(173),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1213),
    [anon_sym_EQ] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1222),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1226),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_readonly] = ACTIONS(1213),
    [anon_sym_get] = ACTIONS(1213),
    [anon_sym_set] = ACTIONS(1213),
    [anon_sym_declare] = ACTIONS(1213),
    [anon_sym_public] = ACTIONS(1213),
    [anon_sym_private] = ACTIONS(1213),
    [anon_sym_protected] = ACTIONS(1213),
    [anon_sym_override] = ACTIONS(1213),
    [anon_sym_module] = ACTIONS(1213),
    [anon_sym_any] = ACTIONS(1213),
    [anon_sym_number] = ACTIONS(1213),
    [anon_sym_boolean] = ACTIONS(1213),
    [anon_sym_string] = ACTIONS(1213),
    [anon_sym_symbol] = ACTIONS(1213),
    [anon_sym_object] = ACTIONS(1213),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [174] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(174),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1121),
    [anon_sym_export] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1123),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1208),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(1208),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1131),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1133),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1123),
    [anon_sym_get] = ACTIONS(1123),
    [anon_sym_set] = ACTIONS(1123),
    [anon_sym_declare] = ACTIONS(1123),
    [anon_sym_public] = ACTIONS(1123),
    [anon_sym_private] = ACTIONS(1123),
    [anon_sym_protected] = ACTIONS(1123),
    [anon_sym_override] = ACTIONS(1123),
    [anon_sym_module] = ACTIONS(1123),
    [anon_sym_any] = ACTIONS(1123),
    [anon_sym_number] = ACTIONS(1123),
    [anon_sym_boolean] = ACTIONS(1123),
    [anon_sym_string] = ACTIONS(1123),
    [anon_sym_symbol] = ACTIONS(1123),
    [anon_sym_object] = ACTIONS(1123),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [175] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(175),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1228),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1234),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1230),
    [anon_sym_readonly] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_override] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_object] = ACTIONS(1230),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [176] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(176),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5327),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6762),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1121),
    [anon_sym_export] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1123),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_RBRACE] = ACTIONS(216),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1131),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1133),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(1123),
    [anon_sym_get] = ACTIONS(1123),
    [anon_sym_set] = ACTIONS(1123),
    [anon_sym_declare] = ACTIONS(1123),
    [anon_sym_public] = ACTIONS(1123),
    [anon_sym_private] = ACTIONS(1123),
    [anon_sym_protected] = ACTIONS(1123),
    [anon_sym_override] = ACTIONS(1123),
    [anon_sym_module] = ACTIONS(1123),
    [anon_sym_any] = ACTIONS(1123),
    [anon_sym_number] = ACTIONS(1123),
    [anon_sym_boolean] = ACTIONS(1123),
    [anon_sym_string] = ACTIONS(1123),
    [anon_sym_symbol] = ACTIONS(1123),
    [anon_sym_object] = ACTIONS(1123),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [177] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(177),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_export] = ACTIONS(1244),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1244),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1244),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1250),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1252),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1254),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1244),
    [anon_sym_readonly] = ACTIONS(1244),
    [anon_sym_get] = ACTIONS(1244),
    [anon_sym_set] = ACTIONS(1244),
    [anon_sym_declare] = ACTIONS(1244),
    [anon_sym_public] = ACTIONS(1244),
    [anon_sym_private] = ACTIONS(1244),
    [anon_sym_protected] = ACTIONS(1244),
    [anon_sym_override] = ACTIONS(1244),
    [anon_sym_module] = ACTIONS(1244),
    [anon_sym_any] = ACTIONS(1244),
    [anon_sym_number] = ACTIONS(1244),
    [anon_sym_boolean] = ACTIONS(1244),
    [anon_sym_string] = ACTIONS(1244),
    [anon_sym_symbol] = ACTIONS(1244),
    [anon_sym_object] = ACTIONS(1244),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [178] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(178),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1264),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1266),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1258),
    [anon_sym_readonly] = ACTIONS(1258),
    [anon_sym_get] = ACTIONS(1258),
    [anon_sym_set] = ACTIONS(1258),
    [anon_sym_declare] = ACTIONS(1258),
    [anon_sym_public] = ACTIONS(1258),
    [anon_sym_private] = ACTIONS(1258),
    [anon_sym_protected] = ACTIONS(1258),
    [anon_sym_override] = ACTIONS(1258),
    [anon_sym_module] = ACTIONS(1258),
    [anon_sym_any] = ACTIONS(1258),
    [anon_sym_number] = ACTIONS(1258),
    [anon_sym_boolean] = ACTIONS(1258),
    [anon_sym_string] = ACTIONS(1258),
    [anon_sym_symbol] = ACTIONS(1258),
    [anon_sym_object] = ACTIONS(1258),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [179] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(179),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1252),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [180] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(180),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1213),
    [anon_sym_EQ] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1222),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1226),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_readonly] = ACTIONS(1213),
    [anon_sym_get] = ACTIONS(1213),
    [anon_sym_set] = ACTIONS(1213),
    [anon_sym_declare] = ACTIONS(1213),
    [anon_sym_public] = ACTIONS(1213),
    [anon_sym_private] = ACTIONS(1213),
    [anon_sym_protected] = ACTIONS(1213),
    [anon_sym_override] = ACTIONS(1213),
    [anon_sym_module] = ACTIONS(1213),
    [anon_sym_any] = ACTIONS(1213),
    [anon_sym_number] = ACTIONS(1213),
    [anon_sym_boolean] = ACTIONS(1213),
    [anon_sym_string] = ACTIONS(1213),
    [anon_sym_symbol] = ACTIONS(1213),
    [anon_sym_object] = ACTIONS(1213),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [181] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(181),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [182] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(182),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1264),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1266),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1258),
    [anon_sym_readonly] = ACTIONS(1258),
    [anon_sym_get] = ACTIONS(1258),
    [anon_sym_set] = ACTIONS(1258),
    [anon_sym_declare] = ACTIONS(1258),
    [anon_sym_public] = ACTIONS(1258),
    [anon_sym_private] = ACTIONS(1258),
    [anon_sym_protected] = ACTIONS(1258),
    [anon_sym_override] = ACTIONS(1258),
    [anon_sym_module] = ACTIONS(1258),
    [anon_sym_any] = ACTIONS(1258),
    [anon_sym_number] = ACTIONS(1258),
    [anon_sym_boolean] = ACTIONS(1258),
    [anon_sym_string] = ACTIONS(1258),
    [anon_sym_symbol] = ACTIONS(1258),
    [anon_sym_object] = ACTIONS(1258),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [183] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(183),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1213),
    [anon_sym_EQ] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1222),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1226),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_readonly] = ACTIONS(1213),
    [anon_sym_get] = ACTIONS(1213),
    [anon_sym_set] = ACTIONS(1213),
    [anon_sym_declare] = ACTIONS(1213),
    [anon_sym_public] = ACTIONS(1213),
    [anon_sym_private] = ACTIONS(1213),
    [anon_sym_protected] = ACTIONS(1213),
    [anon_sym_override] = ACTIONS(1213),
    [anon_sym_module] = ACTIONS(1213),
    [anon_sym_any] = ACTIONS(1213),
    [anon_sym_number] = ACTIONS(1213),
    [anon_sym_boolean] = ACTIONS(1213),
    [anon_sym_string] = ACTIONS(1213),
    [anon_sym_symbol] = ACTIONS(1213),
    [anon_sym_object] = ACTIONS(1213),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [184] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(184),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1266),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [185] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(185),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1213),
    [anon_sym_EQ] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1222),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1226),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_readonly] = ACTIONS(1213),
    [anon_sym_get] = ACTIONS(1213),
    [anon_sym_set] = ACTIONS(1213),
    [anon_sym_declare] = ACTIONS(1213),
    [anon_sym_public] = ACTIONS(1213),
    [anon_sym_private] = ACTIONS(1213),
    [anon_sym_protected] = ACTIONS(1213),
    [anon_sym_override] = ACTIONS(1213),
    [anon_sym_module] = ACTIONS(1213),
    [anon_sym_any] = ACTIONS(1213),
    [anon_sym_number] = ACTIONS(1213),
    [anon_sym_boolean] = ACTIONS(1213),
    [anon_sym_string] = ACTIONS(1213),
    [anon_sym_symbol] = ACTIONS(1213),
    [anon_sym_object] = ACTIONS(1213),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [186] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(186),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_export] = ACTIONS(1244),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1244),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1244),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1250),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1252),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1254),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1244),
    [anon_sym_readonly] = ACTIONS(1244),
    [anon_sym_get] = ACTIONS(1244),
    [anon_sym_set] = ACTIONS(1244),
    [anon_sym_declare] = ACTIONS(1244),
    [anon_sym_public] = ACTIONS(1244),
    [anon_sym_private] = ACTIONS(1244),
    [anon_sym_protected] = ACTIONS(1244),
    [anon_sym_override] = ACTIONS(1244),
    [anon_sym_module] = ACTIONS(1244),
    [anon_sym_any] = ACTIONS(1244),
    [anon_sym_number] = ACTIONS(1244),
    [anon_sym_boolean] = ACTIONS(1244),
    [anon_sym_string] = ACTIONS(1244),
    [anon_sym_symbol] = ACTIONS(1244),
    [anon_sym_object] = ACTIONS(1244),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [187] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(1996),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2401),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1996),
    [sym_subscript_expression] = STATE(1996),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(187),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1996),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1228),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1234),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1230),
    [anon_sym_readonly] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_override] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_object] = ACTIONS(1230),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [188] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(188),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_of] = ACTIONS(1206),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [189] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(189),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [190] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(190),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1278),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1278),
    [anon_sym_EQ] = ACTIONS(1280),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1284),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1286),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1288),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1278),
    [anon_sym_readonly] = ACTIONS(1278),
    [anon_sym_get] = ACTIONS(1278),
    [anon_sym_set] = ACTIONS(1278),
    [anon_sym_declare] = ACTIONS(1278),
    [anon_sym_public] = ACTIONS(1278),
    [anon_sym_private] = ACTIONS(1278),
    [anon_sym_protected] = ACTIONS(1278),
    [anon_sym_override] = ACTIONS(1278),
    [anon_sym_module] = ACTIONS(1278),
    [anon_sym_any] = ACTIONS(1278),
    [anon_sym_number] = ACTIONS(1278),
    [anon_sym_boolean] = ACTIONS(1278),
    [anon_sym_string] = ACTIONS(1278),
    [anon_sym_symbol] = ACTIONS(1278),
    [anon_sym_object] = ACTIONS(1278),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [191] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(191),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1213),
    [anon_sym_EQ] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1222),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1226),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_readonly] = ACTIONS(1213),
    [anon_sym_get] = ACTIONS(1213),
    [anon_sym_set] = ACTIONS(1213),
    [anon_sym_declare] = ACTIONS(1213),
    [anon_sym_public] = ACTIONS(1213),
    [anon_sym_private] = ACTIONS(1213),
    [anon_sym_protected] = ACTIONS(1213),
    [anon_sym_override] = ACTIONS(1213),
    [anon_sym_module] = ACTIONS(1213),
    [anon_sym_any] = ACTIONS(1213),
    [anon_sym_number] = ACTIONS(1213),
    [anon_sym_boolean] = ACTIONS(1213),
    [anon_sym_string] = ACTIONS(1213),
    [anon_sym_symbol] = ACTIONS(1213),
    [anon_sym_object] = ACTIONS(1213),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [192] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(192),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1278),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1278),
    [anon_sym_EQ] = ACTIONS(1280),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1284),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1286),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1288),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1278),
    [anon_sym_readonly] = ACTIONS(1278),
    [anon_sym_get] = ACTIONS(1278),
    [anon_sym_set] = ACTIONS(1278),
    [anon_sym_declare] = ACTIONS(1278),
    [anon_sym_public] = ACTIONS(1278),
    [anon_sym_private] = ACTIONS(1278),
    [anon_sym_protected] = ACTIONS(1278),
    [anon_sym_override] = ACTIONS(1278),
    [anon_sym_module] = ACTIONS(1278),
    [anon_sym_any] = ACTIONS(1278),
    [anon_sym_number] = ACTIONS(1278),
    [anon_sym_boolean] = ACTIONS(1278),
    [anon_sym_string] = ACTIONS(1278),
    [anon_sym_symbol] = ACTIONS(1278),
    [anon_sym_object] = ACTIONS(1278),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [193] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(193),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [194] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(194),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1286),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [195] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(195),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1213),
    [anon_sym_EQ] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1222),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1226),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_readonly] = ACTIONS(1213),
    [anon_sym_get] = ACTIONS(1213),
    [anon_sym_set] = ACTIONS(1213),
    [anon_sym_declare] = ACTIONS(1213),
    [anon_sym_public] = ACTIONS(1213),
    [anon_sym_private] = ACTIONS(1213),
    [anon_sym_protected] = ACTIONS(1213),
    [anon_sym_override] = ACTIONS(1213),
    [anon_sym_module] = ACTIONS(1213),
    [anon_sym_any] = ACTIONS(1213),
    [anon_sym_number] = ACTIONS(1213),
    [anon_sym_boolean] = ACTIONS(1213),
    [anon_sym_string] = ACTIONS(1213),
    [anon_sym_symbol] = ACTIONS(1213),
    [anon_sym_object] = ACTIONS(1213),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [196] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(196),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [197] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(197),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1294),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [198] = {
    [sym_import] = STATE(4142),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2764),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(6802),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7025),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2697),
    [sym_comment] = STATE(198),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5245),
    [sym_pattern] = STATE(6098),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4039),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4322),
    [sym__type] = STATE(4035),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6740),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1296),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_typeof] = ACTIONS(1302),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1310),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1318),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1320),
    [sym_number] = ACTIONS(1322),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1324),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1322),
    [sym_false] = ACTIONS(1322),
    [sym_null] = ACTIONS(1322),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1328),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(1332),
    [anon_sym_number] = ACTIONS(1332),
    [anon_sym_boolean] = ACTIONS(1332),
    [anon_sym_string] = ACTIONS(1332),
    [anon_sym_symbol] = ACTIONS(1332),
    [anon_sym_object] = ACTIONS(1332),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [199] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(199),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1346),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [200] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(200),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [201] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(201),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [202] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(202),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [203] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(203),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [204] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(204),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1354),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [205] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(205),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1356),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [206] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(206),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [207] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2205),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(207),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(5172),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6565),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [208] = {
    [sym_import] = STATE(4127),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2647),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2572),
    [sym_comment] = STATE(208),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4621),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5624),
    [sym__type] = STATE(4622),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_typeof] = ACTIONS(1368),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1380),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1386),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [sym_number] = ACTIONS(1392),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(1396),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1392),
    [sym_false] = ACTIONS(1392),
    [sym_null] = ACTIONS(1392),
    [sym_undefined] = ACTIONS(1398),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1402),
    [anon_sym_number] = ACTIONS(1402),
    [anon_sym_boolean] = ACTIONS(1402),
    [anon_sym_string] = ACTIONS(1402),
    [anon_sym_symbol] = ACTIONS(1402),
    [anon_sym_object] = ACTIONS(1402),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [209] = {
    [sym_import] = STATE(4163),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2533),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2682),
    [sym_comment] = STATE(209),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4752),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5480),
    [sym__type] = STATE(4750),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1410),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(1414),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1416),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1420),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1426),
    [sym_number] = ACTIONS(1428),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(1430),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1432),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1434),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1436),
    [anon_sym_number] = ACTIONS(1436),
    [anon_sym_boolean] = ACTIONS(1436),
    [anon_sym_string] = ACTIONS(1436),
    [anon_sym_symbol] = ACTIONS(1436),
    [anon_sym_object] = ACTIONS(1436),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [210] = {
    [sym_import] = STATE(4251),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3214),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2877),
    [sym_comment] = STATE(210),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4621),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5624),
    [sym__type] = STATE(4622),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1438),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_typeof] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1444),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1446),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(176),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1450),
    [sym_number] = ACTIONS(1452),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1454),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_null] = ACTIONS(1452),
    [sym_undefined] = ACTIONS(1456),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1458),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1460),
    [anon_sym_number] = ACTIONS(1460),
    [anon_sym_boolean] = ACTIONS(1460),
    [anon_sym_string] = ACTIONS(1460),
    [anon_sym_symbol] = ACTIONS(1460),
    [anon_sym_object] = ACTIONS(1460),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [211] = {
    [sym_import] = STATE(4163),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2464),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2682),
    [sym_comment] = STATE(211),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4752),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5480),
    [sym__type] = STATE(4750),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1410),
    [anon_sym_typeof] = ACTIONS(1468),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1414),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1416),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1478),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1484),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1426),
    [sym_number] = ACTIONS(1428),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(1430),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1490),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1492),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1494),
    [anon_sym_number] = ACTIONS(1494),
    [anon_sym_boolean] = ACTIONS(1494),
    [anon_sym_string] = ACTIONS(1494),
    [anon_sym_symbol] = ACTIONS(1494),
    [anon_sym_object] = ACTIONS(1494),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [212] = {
    [sym_import] = STATE(4251),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3107),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2877),
    [sym_comment] = STATE(212),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4621),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5624),
    [sym__type] = STATE(4622),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1496),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(1504),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1444),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1520),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1450),
    [sym_number] = ACTIONS(1452),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(1454),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_null] = ACTIONS(1452),
    [sym_undefined] = ACTIONS(1526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1528),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1530),
    [anon_sym_number] = ACTIONS(1530),
    [anon_sym_boolean] = ACTIONS(1530),
    [anon_sym_string] = ACTIONS(1530),
    [anon_sym_symbol] = ACTIONS(1530),
    [anon_sym_object] = ACTIONS(1530),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [213] = {
    [sym_import] = STATE(4251),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3091),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2877),
    [sym_comment] = STATE(213),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4621),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5624),
    [sym__type] = STATE(4622),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_typeof] = ACTIONS(1538),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1444),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1548),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1552),
    [anon_sym_DASH] = ACTIONS(1552),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1554),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1450),
    [sym_number] = ACTIONS(1452),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(1454),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_null] = ACTIONS(1452),
    [sym_undefined] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1562),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1564),
    [anon_sym_number] = ACTIONS(1564),
    [anon_sym_boolean] = ACTIONS(1564),
    [anon_sym_string] = ACTIONS(1564),
    [anon_sym_symbol] = ACTIONS(1564),
    [anon_sym_object] = ACTIONS(1564),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [214] = {
    [sym_import] = STATE(4251),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2765),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2877),
    [sym_comment] = STATE(214),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4621),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5624),
    [sym__type] = STATE(4622),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(1572),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1444),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1582),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1586),
    [anon_sym_DASH] = ACTIONS(1586),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1588),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1450),
    [sym_number] = ACTIONS(1452),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(1454),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_null] = ACTIONS(1452),
    [sym_undefined] = ACTIONS(1594),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1596),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1598),
    [anon_sym_number] = ACTIONS(1598),
    [anon_sym_boolean] = ACTIONS(1598),
    [anon_sym_string] = ACTIONS(1598),
    [anon_sym_symbol] = ACTIONS(1598),
    [anon_sym_object] = ACTIONS(1598),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [215] = {
    [sym_import] = STATE(4179),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2791),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(3245),
    [sym_comment] = STATE(215),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4752),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5480),
    [sym__type] = STATE(4750),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1414),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1616),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1620),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1626),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1630),
    [sym_number] = ACTIONS(1632),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(1636),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(1632),
    [sym_false] = ACTIONS(1632),
    [sym_null] = ACTIONS(1632),
    [sym_undefined] = ACTIONS(1638),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1640),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1642),
    [anon_sym_number] = ACTIONS(1642),
    [anon_sym_boolean] = ACTIONS(1642),
    [anon_sym_string] = ACTIONS(1642),
    [anon_sym_symbol] = ACTIONS(1642),
    [anon_sym_object] = ACTIONS(1642),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [216] = {
    [sym_import] = STATE(4127),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2357),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2572),
    [sym_comment] = STATE(216),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4621),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5624),
    [sym__type] = STATE(4622),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1644),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_typeof] = ACTIONS(1650),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1654),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1656),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [sym_number] = ACTIONS(1392),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1396),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1392),
    [sym_false] = ACTIONS(1392),
    [sym_null] = ACTIONS(1392),
    [sym_undefined] = ACTIONS(1658),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1660),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1662),
    [anon_sym_number] = ACTIONS(1662),
    [anon_sym_boolean] = ACTIONS(1662),
    [anon_sym_string] = ACTIONS(1662),
    [anon_sym_symbol] = ACTIONS(1662),
    [anon_sym_object] = ACTIONS(1662),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [217] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2631),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7051),
    [sym_string] = STATE(3050),
    [sym_comment] = STATE(217),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(6165),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(5388),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(5427),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1664),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1666),
    [anon_sym_typeof] = ACTIONS(1139),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1668),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1654),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1147),
    [sym_number] = ACTIONS(1149),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1670),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [sym_null] = ACTIONS(1149),
    [sym_undefined] = ACTIONS(1672),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1660),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1674),
    [anon_sym_number] = ACTIONS(1674),
    [anon_sym_boolean] = ACTIONS(1674),
    [anon_sym_string] = ACTIONS(1674),
    [anon_sym_symbol] = ACTIONS(1674),
    [anon_sym_object] = ACTIONS(1674),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [218] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2111),
    [sym_subscript_expression] = STATE(2111),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4563),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3290),
    [sym_comment] = STATE(218),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(2111),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5386),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1676),
    [anon_sym_export] = ACTIONS(1678),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1678),
    [anon_sym_namespace] = ACTIONS(1680),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_typeof] = ACTIONS(1684),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1678),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1686),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1690),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1692),
    [anon_sym_DASH] = ACTIONS(1692),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(176),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [sym_number] = ACTIONS(1696),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1698),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(1696),
    [sym_false] = ACTIONS(1696),
    [sym_null] = ACTIONS(1696),
    [sym_undefined] = ACTIONS(1700),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1678),
    [anon_sym_readonly] = ACTIONS(1702),
    [anon_sym_get] = ACTIONS(1678),
    [anon_sym_set] = ACTIONS(1678),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1678),
    [anon_sym_public] = ACTIONS(1678),
    [anon_sym_private] = ACTIONS(1678),
    [anon_sym_protected] = ACTIONS(1678),
    [anon_sym_override] = ACTIONS(1678),
    [anon_sym_module] = ACTIONS(1678),
    [anon_sym_any] = ACTIONS(1704),
    [anon_sym_number] = ACTIONS(1704),
    [anon_sym_boolean] = ACTIONS(1704),
    [anon_sym_string] = ACTIONS(1704),
    [anon_sym_symbol] = ACTIONS(1704),
    [anon_sym_object] = ACTIONS(1704),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [219] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2523),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_nested_identifier] = STATE(7011),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2031),
    [sym_subscript_expression] = STATE(2031),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4987),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(3180),
    [sym_comment] = STATE(219),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4958),
    [sym_non_null_expression] = STATE(2031),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5386),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6856),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1706),
    [anon_sym_export] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1708),
    [anon_sym_namespace] = ACTIONS(1710),
    [anon_sym_LBRACE] = ACTIONS(1712),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1708),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1714),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1716),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1023),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(181),
    [sym_number] = ACTIONS(183),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1708),
    [anon_sym_readonly] = ACTIONS(1720),
    [anon_sym_get] = ACTIONS(1708),
    [anon_sym_set] = ACTIONS(1708),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_public] = ACTIONS(1708),
    [anon_sym_private] = ACTIONS(1708),
    [anon_sym_protected] = ACTIONS(1708),
    [anon_sym_override] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1708),
    [anon_sym_any] = ACTIONS(1722),
    [anon_sym_number] = ACTIONS(1722),
    [anon_sym_boolean] = ACTIONS(1722),
    [anon_sym_string] = ACTIONS(1722),
    [anon_sym_symbol] = ACTIONS(1722),
    [anon_sym_object] = ACTIONS(1722),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [220] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2238),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(220),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(1726),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1728),
    [anon_sym_RBRACE] = ACTIONS(1728),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1728),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_in] = ACTIONS(1728),
    [anon_sym_COLON] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(1728),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_QMARK_DOT] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1728),
    [anon_sym_PIPE_PIPE] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1728),
    [anon_sym_GT_GT_GT] = ACTIONS(1728),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(1728),
    [anon_sym_STAR_STAR] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1728),
    [anon_sym_GT_EQ] = ACTIONS(1728),
    [anon_sym_QMARK_QMARK] = ACTIONS(1728),
    [anon_sym_instanceof] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [anon_sym_satisfies] = ACTIONS(1728),
    [sym__ternary_qmark] = ACTIONS(1734),
    [sym_html_comment] = ACTIONS(5),
  },
  [221] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2410),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(221),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1738),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(1728),
    [anon_sym_RBRACE] = ACTIONS(1728),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_AMP_AMP] = ACTIONS(1728),
    [anon_sym_PIPE_PIPE] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1728),
    [anon_sym_GT_GT_GT] = ACTIONS(1728),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(1728),
    [anon_sym_STAR_STAR] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1728),
    [anon_sym_GT_EQ] = ACTIONS(1728),
    [anon_sym_QMARK_QMARK] = ACTIONS(1728),
    [anon_sym_instanceof] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [anon_sym_satisfies] = ACTIONS(1728),
    [sym__automatic_semicolon] = ACTIONS(1734),
    [sym__ternary_qmark] = ACTIONS(1734),
    [sym_html_comment] = ACTIONS(5),
  },
  [222] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2557),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(222),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(1744),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(1728),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_in] = ACTIONS(1728),
    [anon_sym_of] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_AMP_AMP] = ACTIONS(1728),
    [anon_sym_PIPE_PIPE] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1728),
    [anon_sym_GT_GT_GT] = ACTIONS(1728),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1728),
    [anon_sym_STAR_STAR] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1728),
    [anon_sym_GT_EQ] = ACTIONS(1728),
    [anon_sym_QMARK_QMARK] = ACTIONS(1728),
    [anon_sym_instanceof] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [anon_sym_satisfies] = ACTIONS(1728),
    [sym__automatic_semicolon] = ACTIONS(1734),
    [sym__ternary_qmark] = ACTIONS(1734),
    [sym_html_comment] = ACTIONS(5),
  },
  [223] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2615),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(223),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1752),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1728),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_in] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_QMARK_DOT] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1728),
    [anon_sym_PIPE_PIPE] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1728),
    [anon_sym_GT_GT_GT] = ACTIONS(1728),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_PERCENT] = ACTIONS(1728),
    [anon_sym_STAR_STAR] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1728),
    [anon_sym_GT_EQ] = ACTIONS(1728),
    [anon_sym_QMARK_QMARK] = ACTIONS(1728),
    [anon_sym_instanceof] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [anon_sym_satisfies] = ACTIONS(1728),
    [anon_sym_implements] = ACTIONS(1728),
    [sym__ternary_qmark] = ACTIONS(1734),
    [sym_html_comment] = ACTIONS(5),
  },
  [224] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2878),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(224),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_STAR] = ACTIONS(1760),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_RBRACE] = ACTIONS(1728),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_in] = ACTIONS(1728),
    [anon_sym_COLON] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_QMARK_DOT] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_AMP_AMP] = ACTIONS(1728),
    [anon_sym_PIPE_PIPE] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1728),
    [anon_sym_GT_GT_GT] = ACTIONS(1728),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(1728),
    [anon_sym_STAR_STAR] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1728),
    [anon_sym_GT_EQ] = ACTIONS(1728),
    [anon_sym_QMARK_QMARK] = ACTIONS(1728),
    [anon_sym_instanceof] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [anon_sym_satisfies] = ACTIONS(1728),
    [sym__ternary_qmark] = ACTIONS(1734),
    [sym_html_comment] = ACTIONS(5),
  },
  [225] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2912),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(225),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_STAR] = ACTIONS(1768),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_in] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_AMP_AMP] = ACTIONS(1728),
    [anon_sym_PIPE_PIPE] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1728),
    [anon_sym_GT_GT_GT] = ACTIONS(1728),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(1728),
    [anon_sym_STAR_STAR] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1728),
    [anon_sym_GT_EQ] = ACTIONS(1728),
    [anon_sym_QMARK_QMARK] = ACTIONS(1728),
    [anon_sym_instanceof] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_satisfies] = ACTIONS(1728),
    [sym__automatic_semicolon] = ACTIONS(1734),
    [sym__ternary_qmark] = ACTIONS(1734),
    [sym_html_comment] = ACTIONS(5),
  },
  [226] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3006),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(226),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_STAR] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_in] = ACTIONS(1728),
    [anon_sym_of] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_QMARK_DOT] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_AMP_AMP] = ACTIONS(1728),
    [anon_sym_PIPE_PIPE] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1728),
    [anon_sym_GT_GT_GT] = ACTIONS(1728),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1728),
    [anon_sym_STAR_STAR] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1728),
    [anon_sym_GT_EQ] = ACTIONS(1728),
    [anon_sym_QMARK_QMARK] = ACTIONS(1728),
    [anon_sym_instanceof] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [anon_sym_satisfies] = ACTIONS(1728),
    [sym__ternary_qmark] = ACTIONS(1734),
    [sym_html_comment] = ACTIONS(5),
  },
  [227] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3100),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(227),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_STAR] = ACTIONS(1784),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_in] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(1728),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_QMARK_DOT] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_AMP_AMP] = ACTIONS(1728),
    [anon_sym_PIPE_PIPE] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1728),
    [anon_sym_GT_GT_GT] = ACTIONS(1728),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(1728),
    [anon_sym_STAR_STAR] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1728),
    [anon_sym_GT_EQ] = ACTIONS(1728),
    [anon_sym_QMARK_QMARK] = ACTIONS(1728),
    [anon_sym_instanceof] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [anon_sym_satisfies] = ACTIONS(1728),
    [sym__ternary_qmark] = ACTIONS(1734),
    [sym_html_comment] = ACTIONS(5),
  },
  [228] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3189),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(228),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(1790),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(1728),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_QMARK_DOT] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(1728),
    [anon_sym_PIPE_PIPE] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1728),
    [anon_sym_GT_GT_GT] = ACTIONS(1728),
    [anon_sym_LT_LT] = ACTIONS(1728),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(1728),
    [anon_sym_STAR_STAR] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_LT_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1728),
    [anon_sym_GT_EQ] = ACTIONS(1728),
    [anon_sym_QMARK_QMARK] = ACTIONS(1728),
    [anon_sym_instanceof] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_satisfies] = ACTIONS(1728),
    [sym__ternary_qmark] = ACTIONS(1734),
    [sym_html_comment] = ACTIONS(5),
  },
  [229] = {
    [sym_declaration] = STATE(1198),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2882),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(229),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4931),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_namespace] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1796),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(1798),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1802),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1804),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [230] = {
    [sym_declaration] = STATE(1165),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2740),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(230),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4955),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1806),
    [anon_sym_namespace] = ACTIONS(1808),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(1812),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(1814),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1816),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1818),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [231] = {
    [sym_declaration] = STATE(1275),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2895),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1444),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(231),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(1444),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(397),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4931),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_namespace] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1796),
    [anon_sym_var] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(1798),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(808),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1802),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1804),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(822),
    [anon_sym_interface] = ACTIONS(824),
    [anon_sym_enum] = ACTIONS(826),
    [sym_html_comment] = ACTIONS(5),
  },
  [232] = {
    [sym_declaration] = STATE(1527),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2835),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(232),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5131),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1820),
    [anon_sym_namespace] = ACTIONS(1822),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1824),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(1826),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(1828),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1830),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1832),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [233] = {
    [sym_declaration] = STATE(5132),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(5171),
    [sym_lexical_declaration] = STATE(5171),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2836),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(5171),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(5171),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(5171),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(233),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(5171),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(5171),
    [sym_abstract_class_declaration] = STATE(5171),
    [sym_module] = STATE(5171),
    [sym_internal_module] = STATE(3040),
    [sym_import_alias] = STATE(5171),
    [sym_interface_declaration] = STATE(5171),
    [sym_enum_declaration] = STATE(5171),
    [sym_type_alias_declaration] = STATE(5171),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4875),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1834),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(1844),
    [anon_sym_async] = ACTIONS(1846),
    [anon_sym_function] = ACTIONS(1848),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1850),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1852),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(1854),
    [anon_sym_interface] = ACTIONS(1856),
    [anon_sym_enum] = ACTIONS(1858),
    [sym_html_comment] = ACTIONS(5),
  },
  [234] = {
    [sym_declaration] = STATE(1081),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2695),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(234),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5380),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1860),
    [anon_sym_namespace] = ACTIONS(1862),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1864),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(1866),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1870),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1872),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [235] = {
    [sym_declaration] = STATE(6551),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2782),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(235),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5069),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1874),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1876),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(1878),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(1880),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1882),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1884),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [236] = {
    [sym_declaration] = STATE(6462),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2828),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(6360),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(236),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(6360),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(3162),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5069),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1874),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1876),
    [anon_sym_var] = ACTIONS(906),
    [anon_sym_let] = ACTIONS(1878),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(936),
    [anon_sym_async] = ACTIONS(1880),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1882),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1884),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(954),
    [sym_html_comment] = ACTIONS(5),
  },
  [237] = {
    [sym_declaration] = STATE(1559),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2902),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1558),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(237),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(1558),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(429),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5131),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1820),
    [anon_sym_namespace] = ACTIONS(1822),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1824),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(1826),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(1828),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1830),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1832),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [238] = {
    [sym_declaration] = STATE(5070),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(5171),
    [sym_lexical_declaration] = STATE(5171),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2824),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(5171),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(5171),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(5171),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(238),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(5171),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(5171),
    [sym_abstract_class_declaration] = STATE(5171),
    [sym_module] = STATE(5171),
    [sym_internal_module] = STATE(3040),
    [sym_import_alias] = STATE(5171),
    [sym_interface_declaration] = STATE(5171),
    [sym_enum_declaration] = STATE(5171),
    [sym_type_alias_declaration] = STATE(5171),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4875),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1834),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(1844),
    [anon_sym_async] = ACTIONS(1846),
    [anon_sym_function] = ACTIONS(1848),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1850),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1852),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(1854),
    [anon_sym_interface] = ACTIONS(1856),
    [anon_sym_enum] = ACTIONS(1858),
    [sym_html_comment] = ACTIONS(5),
  },
  [239] = {
    [sym_declaration] = STATE(1279),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2751),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1327),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(239),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(1327),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(413),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(4955),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1806),
    [anon_sym_namespace] = ACTIONS(1808),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1810),
    [anon_sym_var] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(1812),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(383),
    [anon_sym_async] = ACTIONS(1814),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1816),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1818),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(401),
    [sym_html_comment] = ACTIONS(5),
  },
  [240] = {
    [sym_declaration] = STATE(990),
    [sym_import] = STATE(4290),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2741),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_class_declaration] = STATE(1100),
    [sym_function_expression] = STATE(2940),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function] = STATE(2940),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(240),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_function_signature] = STATE(1100),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(315),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5380),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1860),
    [anon_sym_namespace] = ACTIONS(1862),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(1864),
    [anon_sym_var] = ACTIONS(842),
    [anon_sym_let] = ACTIONS(1866),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(876),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1870),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1872),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(888),
    [anon_sym_enum] = ACTIONS(890),
    [sym_html_comment] = ACTIONS(5),
  },
  [241] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(241),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [242] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(242),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [243] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(243),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(1179),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [244] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(244),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [245] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(245),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(1208),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [246] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(246),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(3967),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_RBRACE] = ACTIONS(216),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(1342),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [247] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2368),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym__formal_parameter] = STATE(5763),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7288),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(247),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1940),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(1159),
    [anon_sym_private] = ACTIONS(1159),
    [anon_sym_protected] = ACTIONS(1159),
    [anon_sym_override] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [248] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(248),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(1252),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [249] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(249),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [250] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2323),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym__formal_parameter] = STATE(5763),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7121),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(250),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(1940),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(1159),
    [anon_sym_private] = ACTIONS(1159),
    [anon_sym_protected] = ACTIONS(1159),
    [anon_sym_override] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [251] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(251),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(1266),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [252] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(252),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [253] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(5816),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(253),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1946),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [254] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(6727),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(254),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1954),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [255] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(255),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1280),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(1286),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [256] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(5763),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(256),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [257] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(6151),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(257),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1956),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [258] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(6727),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(258),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1958),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [259] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(6727),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(259),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1960),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [260] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(260),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [261] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(6727),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(261),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [262] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(6727),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(262),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1964),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [263] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(263),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [264] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(6727),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(264),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1966),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [265] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(265),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1970),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [266] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(266),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_RBRACE] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1972),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_RBRACK] = ACTIONS(1972),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_QMARK] = ACTIONS(1972),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [anon_sym_extends] = ACTIONS(1972),
    [sym_html_comment] = ACTIONS(5),
  },
  [267] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(267),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1974),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [268] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(268),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1976),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [269] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2670),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(5774),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(269),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(5776),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1978),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [270] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym__formal_parameter] = STATE(6727),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(270),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5349),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(399),
    [sym_override_modifier] = STATE(433),
    [sym_required_parameter] = STATE(6589),
    [sym_optional_parameter] = STATE(6589),
    [sym__parameter_name] = STATE(4571),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(316),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [271] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(271),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1980),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [272] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2670),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(5774),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(272),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(5776),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1982),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [273] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2579),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(5774),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(273),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(5776),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1978),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [274] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2641),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(6155),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(274),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6156),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1968),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [275] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(275),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(207),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [276] = {
    [sym_import] = STATE(4290),
    [sym_expression_statement] = STATE(369),
    [sym_variable_declaration] = STATE(369),
    [sym_lexical_declaration] = STATE(369),
    [sym_empty_statement] = STATE(369),
    [sym_parenthesized_expression] = STATE(2025),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2025),
    [sym_subscript_expression] = STATE(2025),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(5947),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6755),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(276),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2025),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1986),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_type] = ACTIONS(1988),
    [anon_sym_namespace] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1992),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_var] = ACTIONS(1994),
    [anon_sym_let] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1998),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2002),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(2004),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(2006),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(2008),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_get] = ACTIONS(1988),
    [anon_sym_set] = ACTIONS(1988),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_public] = ACTIONS(1988),
    [anon_sym_private] = ACTIONS(1988),
    [anon_sym_protected] = ACTIONS(1988),
    [anon_sym_override] = ACTIONS(1988),
    [anon_sym_module] = ACTIONS(1988),
    [anon_sym_any] = ACTIONS(1988),
    [anon_sym_number] = ACTIONS(1988),
    [anon_sym_boolean] = ACTIONS(1988),
    [anon_sym_string] = ACTIONS(1988),
    [anon_sym_symbol] = ACTIONS(1988),
    [anon_sym_object] = ACTIONS(1988),
    [sym_html_comment] = ACTIONS(5),
  },
  [277] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3077),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2076),
    [sym_subscript_expression] = STATE(2076),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(5714),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(277),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(2076),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_mapped_type_clause] = STATE(7185),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(2010),
    [anon_sym_export] = ACTIONS(2012),
    [anon_sym_type] = ACTIONS(2012),
    [anon_sym_namespace] = ACTIONS(2014),
    [anon_sym_LBRACE] = ACTIONS(2016),
    [anon_sym_COMMA] = ACTIONS(2018),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2012),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(2022),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2024),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2026),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2028),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_readonly] = ACTIONS(2012),
    [anon_sym_get] = ACTIONS(2012),
    [anon_sym_set] = ACTIONS(2012),
    [anon_sym_declare] = ACTIONS(2012),
    [anon_sym_public] = ACTIONS(2012),
    [anon_sym_private] = ACTIONS(2012),
    [anon_sym_protected] = ACTIONS(2012),
    [anon_sym_override] = ACTIONS(2012),
    [anon_sym_module] = ACTIONS(2012),
    [anon_sym_any] = ACTIONS(2012),
    [anon_sym_number] = ACTIONS(2012),
    [anon_sym_boolean] = ACTIONS(2012),
    [anon_sym_string] = ACTIONS(2012),
    [anon_sym_symbol] = ACTIONS(2012),
    [anon_sym_object] = ACTIONS(2012),
    [sym_html_comment] = ACTIONS(5),
  },
  [278] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(278),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_RBRACE] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_SEMI] = ACTIONS(1972),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [anon_sym_extends] = ACTIONS(1972),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1972),
    [sym__automatic_semicolon] = ACTIONS(2030),
    [sym_html_comment] = ACTIONS(5),
  },
  [279] = {
    [sym_import] = STATE(4290),
    [sym_expression_statement] = STATE(359),
    [sym_variable_declaration] = STATE(359),
    [sym_lexical_declaration] = STATE(359),
    [sym_empty_statement] = STATE(359),
    [sym_parenthesized_expression] = STATE(2025),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2025),
    [sym_subscript_expression] = STATE(2025),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(5947),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6755),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(279),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2025),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1986),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_type] = ACTIONS(1988),
    [anon_sym_namespace] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1992),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_var] = ACTIONS(1994),
    [anon_sym_let] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1998),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2002),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(2004),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(2006),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(2008),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_get] = ACTIONS(1988),
    [anon_sym_set] = ACTIONS(1988),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_public] = ACTIONS(1988),
    [anon_sym_private] = ACTIONS(1988),
    [anon_sym_protected] = ACTIONS(1988),
    [anon_sym_override] = ACTIONS(1988),
    [anon_sym_module] = ACTIONS(1988),
    [anon_sym_any] = ACTIONS(1988),
    [anon_sym_number] = ACTIONS(1988),
    [anon_sym_boolean] = ACTIONS(1988),
    [anon_sym_string] = ACTIONS(1988),
    [anon_sym_symbol] = ACTIONS(1988),
    [anon_sym_object] = ACTIONS(1988),
    [sym_html_comment] = ACTIONS(5),
  },
  [280] = {
    [sym_import] = STATE(4290),
    [sym_expression_statement] = STATE(404),
    [sym_variable_declaration] = STATE(404),
    [sym_lexical_declaration] = STATE(404),
    [sym_empty_statement] = STATE(404),
    [sym_parenthesized_expression] = STATE(2025),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2025),
    [sym_subscript_expression] = STATE(2025),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(5947),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6755),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(280),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2025),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1986),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_type] = ACTIONS(1988),
    [anon_sym_namespace] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1992),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_var] = ACTIONS(1994),
    [anon_sym_let] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1998),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2002),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(2004),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(2006),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(2008),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_get] = ACTIONS(1988),
    [anon_sym_set] = ACTIONS(1988),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_public] = ACTIONS(1988),
    [anon_sym_private] = ACTIONS(1988),
    [anon_sym_protected] = ACTIONS(1988),
    [anon_sym_override] = ACTIONS(1988),
    [anon_sym_module] = ACTIONS(1988),
    [anon_sym_any] = ACTIONS(1988),
    [anon_sym_number] = ACTIONS(1988),
    [anon_sym_boolean] = ACTIONS(1988),
    [anon_sym_string] = ACTIONS(1988),
    [anon_sym_symbol] = ACTIONS(1988),
    [anon_sym_object] = ACTIONS(1988),
    [sym_html_comment] = ACTIONS(5),
  },
  [281] = {
    [sym_import] = STATE(4290),
    [sym_expression_statement] = STATE(396),
    [sym_variable_declaration] = STATE(396),
    [sym_lexical_declaration] = STATE(396),
    [sym_empty_statement] = STATE(396),
    [sym_parenthesized_expression] = STATE(2025),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2025),
    [sym_subscript_expression] = STATE(2025),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(5947),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6755),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(281),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2025),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1986),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_type] = ACTIONS(1988),
    [anon_sym_namespace] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1992),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_var] = ACTIONS(1994),
    [anon_sym_let] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1998),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2002),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(2004),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(2006),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(2008),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_get] = ACTIONS(1988),
    [anon_sym_set] = ACTIONS(1988),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_public] = ACTIONS(1988),
    [anon_sym_private] = ACTIONS(1988),
    [anon_sym_protected] = ACTIONS(1988),
    [anon_sym_override] = ACTIONS(1988),
    [anon_sym_module] = ACTIONS(1988),
    [anon_sym_any] = ACTIONS(1988),
    [anon_sym_number] = ACTIONS(1988),
    [anon_sym_boolean] = ACTIONS(1988),
    [anon_sym_string] = ACTIONS(1988),
    [anon_sym_symbol] = ACTIONS(1988),
    [anon_sym_object] = ACTIONS(1988),
    [sym_html_comment] = ACTIONS(5),
  },
  [282] = {
    [sym_import] = STATE(4290),
    [sym_expression_statement] = STATE(392),
    [sym_variable_declaration] = STATE(392),
    [sym_lexical_declaration] = STATE(392),
    [sym_empty_statement] = STATE(392),
    [sym_parenthesized_expression] = STATE(2025),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2025),
    [sym_subscript_expression] = STATE(2025),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(5947),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6755),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(282),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2025),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1986),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_type] = ACTIONS(1988),
    [anon_sym_namespace] = ACTIONS(1990),
    [anon_sym_LBRACE] = ACTIONS(1992),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_var] = ACTIONS(1994),
    [anon_sym_let] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1998),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2002),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(2004),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(2006),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(2008),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_get] = ACTIONS(1988),
    [anon_sym_set] = ACTIONS(1988),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_public] = ACTIONS(1988),
    [anon_sym_private] = ACTIONS(1988),
    [anon_sym_protected] = ACTIONS(1988),
    [anon_sym_override] = ACTIONS(1988),
    [anon_sym_module] = ACTIONS(1988),
    [anon_sym_any] = ACTIONS(1988),
    [anon_sym_number] = ACTIONS(1988),
    [anon_sym_boolean] = ACTIONS(1988),
    [anon_sym_string] = ACTIONS(1988),
    [anon_sym_symbol] = ACTIONS(1988),
    [anon_sym_object] = ACTIONS(1988),
    [sym_html_comment] = ACTIONS(5),
  },
  [283] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(283),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(2018),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_RBRACK] = ACTIONS(2022),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [284] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2637),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(6972),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(5966),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(284),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5968),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(2032),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(2032),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [285] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(2953),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(5773),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2076),
    [sym_subscript_expression] = STATE(2076),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(5714),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(285),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5449),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(2076),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_pattern_repeat1] = STATE(5777),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_export] = ACTIONS(2037),
    [anon_sym_type] = ACTIONS(2037),
    [anon_sym_namespace] = ACTIONS(2039),
    [anon_sym_LBRACE] = ACTIONS(2016),
    [anon_sym_COMMA] = ACTIONS(2018),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_RBRACK] = ACTIONS(2022),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2041),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2043),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2028),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2037),
    [anon_sym_readonly] = ACTIONS(2037),
    [anon_sym_get] = ACTIONS(2037),
    [anon_sym_set] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2037),
    [anon_sym_public] = ACTIONS(2037),
    [anon_sym_private] = ACTIONS(2037),
    [anon_sym_protected] = ACTIONS(2037),
    [anon_sym_override] = ACTIONS(2037),
    [anon_sym_module] = ACTIONS(2037),
    [anon_sym_any] = ACTIONS(2037),
    [anon_sym_number] = ACTIONS(2037),
    [anon_sym_boolean] = ACTIONS(2037),
    [anon_sym_string] = ACTIONS(2037),
    [anon_sym_symbol] = ACTIONS(2037),
    [anon_sym_object] = ACTIONS(2037),
    [sym_html_comment] = ACTIONS(5),
  },
  [286] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2637),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(6972),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(5966),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(286),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5968),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(2032),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(2045),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [287] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(6153),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(287),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5566),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_pattern_repeat1] = STATE(6158),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(2018),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [288] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3209),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(288),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1972),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_RBRACK] = ACTIONS(1972),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [anon_sym_extends] = ACTIONS(1972),
    [sym_html_comment] = ACTIONS(5),
  },
  [289] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2637),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(6972),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_spread_element] = STATE(5966),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(289),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5968),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(2032),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [290] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(6972),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(290),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5968),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_RBRACK] = ACTIONS(2055),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [291] = {
    [sym_statement_block] = STATE(321),
    [sym_comment] = STATE(291),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2059),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [292] = {
    [sym_statement_block] = STATE(321),
    [sym_comment] = STATE(292),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2059),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2063),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [293] = {
    [sym_statement_block] = STATE(321),
    [sym_comment] = STATE(293),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2059),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [294] = {
    [sym_comment] = STATE(294),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2069),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_EQ] = ACTIONS(2071),
    [anon_sym_as] = ACTIONS(2069),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_COMMA] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(2069),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(2069),
    [anon_sym_DOT] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_QMARK_DOT] = ACTIONS(2069),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2069),
    [anon_sym_PIPE_PIPE] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2069),
    [anon_sym_GT_GT_GT] = ACTIONS(2069),
    [anon_sym_LT_LT] = ACTIONS(2069),
    [anon_sym_AMP] = ACTIONS(2069),
    [anon_sym_CARET] = ACTIONS(2069),
    [anon_sym_PIPE] = ACTIONS(2069),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_PERCENT] = ACTIONS(2069),
    [anon_sym_STAR_STAR] = ACTIONS(2069),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_LT_EQ] = ACTIONS(2069),
    [anon_sym_EQ_EQ] = ACTIONS(2069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2069),
    [anon_sym_GT_EQ] = ACTIONS(2069),
    [anon_sym_QMARK_QMARK] = ACTIONS(2069),
    [anon_sym_instanceof] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_satisfies] = ACTIONS(2069),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2073),
    [sym__ternary_qmark] = ACTIONS(2075),
    [sym_html_comment] = ACTIONS(5),
  },
  [295] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2595),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_spread_element] = STATE(5667),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(295),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(5668),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(2077),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2079),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [296] = {
    [sym_comment] = STATE(296),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_default] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_as] = ACTIONS(2085),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2085),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_else] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_in] = ACTIONS(2085),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_case] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_LTtemplate_GT] = ACTIONS(2083),
    [anon_sym_GT] = ACTIONS(2085),
    [anon_sym_DOT] = ACTIONS(2085),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2083),
    [anon_sym_QMARK_DOT] = ACTIONS(2085),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_using] = ACTIONS(2083),
    [anon_sym_AMP_AMP] = ACTIONS(2085),
    [anon_sym_PIPE_PIPE] = ACTIONS(2085),
    [anon_sym_GT_GT] = ACTIONS(2085),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2085),
    [anon_sym_CARET] = ACTIONS(2085),
    [anon_sym_PIPE] = ACTIONS(2085),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_STAR_STAR] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_EQ_EQ] = ACTIONS(2085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG_EQ] = ACTIONS(2085),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_QMARK_QMARK] = ACTIONS(2085),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2083),
    [sym_number] = ACTIONS(2083),
    [sym_private_property_identifier] = ACTIONS(2083),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2083),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_readonly] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_override] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_object] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_satisfies] = ACTIONS(2085),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [sym__automatic_semicolon] = ACTIONS(2087),
    [sym__ternary_qmark] = ACTIONS(2089),
    [sym_html_comment] = ACTIONS(5),
  },
  [297] = {
    [sym_statement_block] = STATE(385),
    [sym_comment] = STATE(297),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2091),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [298] = {
    [sym_statement_block] = STATE(385),
    [sym_comment] = STATE(298),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2091),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [299] = {
    [sym_comment] = STATE(299),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2069),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_EQ] = ACTIONS(2071),
    [anon_sym_as] = ACTIONS(2069),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_COMMA] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(2069),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(2069),
    [anon_sym_DOT] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_QMARK_DOT] = ACTIONS(2069),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2069),
    [anon_sym_PIPE_PIPE] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2069),
    [anon_sym_GT_GT_GT] = ACTIONS(2069),
    [anon_sym_LT_LT] = ACTIONS(2069),
    [anon_sym_AMP] = ACTIONS(2069),
    [anon_sym_CARET] = ACTIONS(2069),
    [anon_sym_PIPE] = ACTIONS(2069),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_PERCENT] = ACTIONS(2069),
    [anon_sym_STAR_STAR] = ACTIONS(2069),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_LT_EQ] = ACTIONS(2069),
    [anon_sym_EQ_EQ] = ACTIONS(2069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2069),
    [anon_sym_GT_EQ] = ACTIONS(2069),
    [anon_sym_QMARK_QMARK] = ACTIONS(2069),
    [anon_sym_instanceof] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_satisfies] = ACTIONS(2069),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2097),
    [sym__ternary_qmark] = ACTIONS(2075),
    [sym_html_comment] = ACTIONS(5),
  },
  [300] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2656),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_spread_element] = STATE(6213),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(300),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6214),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(2077),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2099),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [301] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3123),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(301),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [anon_sym_extends] = ACTIONS(1972),
    [sym_html_comment] = ACTIONS(5),
  },
  [302] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2646),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_spread_element] = STATE(6240),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(302),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6239),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(2077),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2101),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [303] = {
    [sym_comment] = STATE(303),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_export] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2105),
    [anon_sym_default] = ACTIONS(2103),
    [anon_sym_type] = ACTIONS(2103),
    [anon_sym_as] = ACTIONS(2105),
    [anon_sym_namespace] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_typeof] = ACTIONS(2103),
    [anon_sym_import] = ACTIONS(2103),
    [anon_sym_with] = ACTIONS(2103),
    [anon_sym_var] = ACTIONS(2103),
    [anon_sym_let] = ACTIONS(2103),
    [anon_sym_const] = ACTIONS(2103),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_else] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_switch] = ACTIONS(2103),
    [anon_sym_for] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_await] = ACTIONS(2103),
    [anon_sym_in] = ACTIONS(2105),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_try] = ACTIONS(2103),
    [anon_sym_break] = ACTIONS(2103),
    [anon_sym_continue] = ACTIONS(2103),
    [anon_sym_debugger] = ACTIONS(2103),
    [anon_sym_return] = ACTIONS(2103),
    [anon_sym_throw] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_case] = ACTIONS(2103),
    [anon_sym_yield] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LTtemplate_GT] = ACTIONS(2103),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2103),
    [anon_sym_SQUOTE] = ACTIONS(2103),
    [anon_sym_class] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(2103),
    [anon_sym_QMARK_DOT] = ACTIONS(2105),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_using] = ACTIONS(2103),
    [anon_sym_AMP_AMP] = ACTIONS(2105),
    [anon_sym_PIPE_PIPE] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2105),
    [anon_sym_GT_GT_GT] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_PERCENT] = ACTIONS(2105),
    [anon_sym_STAR_STAR] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(2105),
    [anon_sym_QMARK_QMARK] = ACTIONS(2105),
    [anon_sym_instanceof] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2103),
    [anon_sym_void] = ACTIONS(2103),
    [anon_sym_delete] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2103),
    [sym_number] = ACTIONS(2103),
    [sym_private_property_identifier] = ACTIONS(2103),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_undefined] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2103),
    [anon_sym_static] = ACTIONS(2103),
    [anon_sym_readonly] = ACTIONS(2103),
    [anon_sym_get] = ACTIONS(2103),
    [anon_sym_set] = ACTIONS(2103),
    [anon_sym_declare] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2103),
    [anon_sym_private] = ACTIONS(2103),
    [anon_sym_protected] = ACTIONS(2103),
    [anon_sym_override] = ACTIONS(2103),
    [anon_sym_module] = ACTIONS(2103),
    [anon_sym_any] = ACTIONS(2103),
    [anon_sym_number] = ACTIONS(2103),
    [anon_sym_boolean] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_symbol] = ACTIONS(2103),
    [anon_sym_object] = ACTIONS(2103),
    [anon_sym_abstract] = ACTIONS(2103),
    [anon_sym_satisfies] = ACTIONS(2105),
    [anon_sym_interface] = ACTIONS(2103),
    [anon_sym_enum] = ACTIONS(2103),
    [sym__automatic_semicolon] = ACTIONS(2107),
    [sym__ternary_qmark] = ACTIONS(2109),
    [sym_html_comment] = ACTIONS(5),
  },
  [304] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2437),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(304),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [anon_sym_extends] = ACTIONS(1972),
    [sym_html_comment] = ACTIONS(5),
  },
  [305] = {
    [sym_comment] = STATE(305),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_as] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2111),
    [anon_sym_DOT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_QMARK_DOT] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_AMP_AMP] = ACTIONS(2111),
    [anon_sym_PIPE_PIPE] = ACTIONS(2111),
    [anon_sym_GT_GT] = ACTIONS(2111),
    [anon_sym_GT_GT_GT] = ACTIONS(2111),
    [anon_sym_LT_LT] = ACTIONS(2111),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_CARET] = ACTIONS(2111),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_PERCENT] = ACTIONS(2111),
    [anon_sym_STAR_STAR] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_QMARK_QMARK] = ACTIONS(2111),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_satisfies] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2113),
    [sym__ternary_qmark] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [306] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2633),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_spread_element] = STATE(6244),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(306),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6246),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(2077),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [307] = {
    [sym_statement_block] = STATE(398),
    [sym_comment] = STATE(307),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [308] = {
    [sym_statement_block] = STATE(398),
    [sym_comment] = STATE(308),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [309] = {
    [sym_statement_block] = STATE(398),
    [sym_comment] = STATE(309),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [310] = {
    [sym_comment] = STATE(310),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_as] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_COMMA] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_in] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_GT] = ACTIONS(2125),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_QMARK_DOT] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_GT] = ACTIONS(2125),
    [anon_sym_GT_GT_GT] = ACTIONS(2125),
    [anon_sym_LT_LT] = ACTIONS(2125),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2125),
    [anon_sym_PIPE] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_PERCENT] = ACTIONS(2125),
    [anon_sym_STAR_STAR] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2125),
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_QMARK_QMARK] = ACTIONS(2125),
    [anon_sym_instanceof] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_satisfies] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym__automatic_semicolon] = ACTIONS(2127),
    [sym__ternary_qmark] = ACTIONS(2127),
    [sym_html_comment] = ACTIONS(5),
  },
  [311] = {
    [sym_comment] = STATE(311),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2131),
    [anon_sym_default] = ACTIONS(2129),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_as] = ACTIONS(2131),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_else] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2129),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_in] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_case] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2129),
    [anon_sym_LTtemplate_GT] = ACTIONS(2129),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_DOT] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_QMARK_DOT] = ACTIONS(2131),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_using] = ACTIONS(2129),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_GT_GT] = ACTIONS(2131),
    [anon_sym_GT_GT_GT] = ACTIONS(2131),
    [anon_sym_LT_LT] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_LT_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2131),
    [anon_sym_GT_EQ] = ACTIONS(2131),
    [anon_sym_QMARK_QMARK] = ACTIONS(2131),
    [anon_sym_instanceof] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_number] = ACTIONS(2129),
    [sym_private_property_identifier] = ACTIONS(2129),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_object] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_satisfies] = ACTIONS(2131),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
    [sym__automatic_semicolon] = ACTIONS(2133),
    [sym__ternary_qmark] = ACTIONS(2135),
    [sym_html_comment] = ACTIONS(5),
  },
  [312] = {
    [sym_comment] = STATE(312),
    [sym_identifier] = ACTIONS(2137),
    [anon_sym_export] = ACTIONS(2137),
    [anon_sym_STAR] = ACTIONS(2139),
    [anon_sym_default] = ACTIONS(2137),
    [anon_sym_type] = ACTIONS(2137),
    [anon_sym_as] = ACTIONS(2139),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_COMMA] = ACTIONS(2139),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_typeof] = ACTIONS(2137),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_with] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2137),
    [anon_sym_let] = ACTIONS(2137),
    [anon_sym_const] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2137),
    [anon_sym_else] = ACTIONS(2137),
    [anon_sym_if] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2137),
    [anon_sym_for] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2137),
    [anon_sym_await] = ACTIONS(2137),
    [anon_sym_in] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2137),
    [anon_sym_do] = ACTIONS(2137),
    [anon_sym_try] = ACTIONS(2137),
    [anon_sym_break] = ACTIONS(2137),
    [anon_sym_continue] = ACTIONS(2137),
    [anon_sym_debugger] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2137),
    [anon_sym_throw] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym_case] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_LTtemplate_GT] = ACTIONS(2137),
    [anon_sym_GT] = ACTIONS(2139),
    [anon_sym_DOT] = ACTIONS(2139),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_SQUOTE] = ACTIONS(2137),
    [anon_sym_class] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(2137),
    [anon_sym_QMARK_DOT] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2137),
    [anon_sym_using] = ACTIONS(2137),
    [anon_sym_AMP_AMP] = ACTIONS(2139),
    [anon_sym_PIPE_PIPE] = ACTIONS(2139),
    [anon_sym_GT_GT] = ACTIONS(2139),
    [anon_sym_GT_GT_GT] = ACTIONS(2139),
    [anon_sym_LT_LT] = ACTIONS(2139),
    [anon_sym_AMP] = ACTIONS(2139),
    [anon_sym_CARET] = ACTIONS(2139),
    [anon_sym_PIPE] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(2137),
    [anon_sym_PERCENT] = ACTIONS(2139),
    [anon_sym_STAR_STAR] = ACTIONS(2139),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_LT_EQ] = ACTIONS(2139),
    [anon_sym_EQ_EQ] = ACTIONS(2139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2139),
    [anon_sym_BANG_EQ] = ACTIONS(2139),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2139),
    [anon_sym_GT_EQ] = ACTIONS(2139),
    [anon_sym_QMARK_QMARK] = ACTIONS(2139),
    [anon_sym_instanceof] = ACTIONS(2139),
    [anon_sym_TILDE] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2137),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [sym_number] = ACTIONS(2137),
    [sym_private_property_identifier] = ACTIONS(2137),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(2137),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(2137),
    [anon_sym_static] = ACTIONS(2137),
    [anon_sym_readonly] = ACTIONS(2137),
    [anon_sym_get] = ACTIONS(2137),
    [anon_sym_set] = ACTIONS(2137),
    [anon_sym_declare] = ACTIONS(2137),
    [anon_sym_public] = ACTIONS(2137),
    [anon_sym_private] = ACTIONS(2137),
    [anon_sym_protected] = ACTIONS(2137),
    [anon_sym_override] = ACTIONS(2137),
    [anon_sym_module] = ACTIONS(2137),
    [anon_sym_any] = ACTIONS(2137),
    [anon_sym_number] = ACTIONS(2137),
    [anon_sym_boolean] = ACTIONS(2137),
    [anon_sym_string] = ACTIONS(2137),
    [anon_sym_symbol] = ACTIONS(2137),
    [anon_sym_object] = ACTIONS(2137),
    [anon_sym_abstract] = ACTIONS(2137),
    [anon_sym_satisfies] = ACTIONS(2139),
    [anon_sym_interface] = ACTIONS(2137),
    [anon_sym_enum] = ACTIONS(2137),
    [sym__automatic_semicolon] = ACTIONS(2141),
    [sym__ternary_qmark] = ACTIONS(2143),
    [sym_html_comment] = ACTIONS(5),
  },
  [313] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3003),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(313),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [anon_sym_extends] = ACTIONS(1972),
    [sym_html_comment] = ACTIONS(5),
  },
  [314] = {
    [sym_comment] = STATE(314),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_as] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_DOT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_QMARK_DOT] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(2145),
    [anon_sym_GT_GT_GT] = ACTIONS(2145),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_STAR_STAR] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_QMARK_QMARK] = ACTIONS(2145),
    [anon_sym_instanceof] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_satisfies] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym__automatic_semicolon] = ACTIONS(2147),
    [sym__ternary_qmark] = ACTIONS(2147),
    [sym_html_comment] = ACTIONS(5),
  },
  [315] = {
    [sym_comment] = STATE(315),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_default] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_as] = ACTIONS(2151),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_else] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_in] = ACTIONS(2151),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_case] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_GT] = ACTIONS(2151),
    [anon_sym_DOT] = ACTIONS(2151),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_QMARK_DOT] = ACTIONS(2151),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2151),
    [anon_sym_GT_GT_GT] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_STAR_STAR] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_EQ] = ACTIONS(2151),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2151),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_QMARK_QMARK] = ACTIONS(2151),
    [anon_sym_instanceof] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_satisfies] = ACTIONS(2151),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym__automatic_semicolon] = ACTIONS(2153),
    [sym__ternary_qmark] = ACTIONS(2153),
    [sym_html_comment] = ACTIONS(5),
  },
  [316] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(316),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(2014),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(4899),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_accessibility_modifier] = STATE(367),
    [sym_override_modifier] = STATE(457),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(1906),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(2155),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(2157),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1155),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2159),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1171),
    [anon_sym_private] = ACTIONS(1171),
    [anon_sym_protected] = ACTIONS(1171),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [317] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2643),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_spread_element] = STATE(6058),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(317),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6060),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(2077),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2161),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [318] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2900),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(318),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [anon_sym_extends] = ACTIONS(1972),
    [sym_html_comment] = ACTIONS(5),
  },
  [319] = {
    [sym_comment] = STATE(319),
    [sym_identifier] = ACTIONS(2163),
    [anon_sym_export] = ACTIONS(2163),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_default] = ACTIONS(2163),
    [anon_sym_type] = ACTIONS(2163),
    [anon_sym_as] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2163),
    [anon_sym_COMMA] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2163),
    [anon_sym_import] = ACTIONS(2163),
    [anon_sym_with] = ACTIONS(2163),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2163),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_debugger] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_case] = ACTIONS(2163),
    [anon_sym_yield] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_LTtemplate_GT] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2163),
    [anon_sym_DOT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2163),
    [anon_sym_SQUOTE] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_async] = ACTIONS(2163),
    [anon_sym_function] = ACTIONS(2163),
    [anon_sym_QMARK_DOT] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_GT_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2163),
    [anon_sym_PIPE] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_SLASH] = ACTIONS(2163),
    [anon_sym_PERCENT] = ACTIONS(2163),
    [anon_sym_STAR_STAR] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_LT_EQ] = ACTIONS(2163),
    [anon_sym_EQ_EQ] = ACTIONS(2163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2163),
    [anon_sym_BANG_EQ] = ACTIONS(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2163),
    [anon_sym_GT_EQ] = ACTIONS(2163),
    [anon_sym_QMARK_QMARK] = ACTIONS(2163),
    [anon_sym_instanceof] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [anon_sym_void] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_PLUS_PLUS] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2163),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2163),
    [sym_number] = ACTIONS(2163),
    [sym_private_property_identifier] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(2163),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_readonly] = ACTIONS(2163),
    [anon_sym_get] = ACTIONS(2163),
    [anon_sym_set] = ACTIONS(2163),
    [anon_sym_declare] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_override] = ACTIONS(2163),
    [anon_sym_module] = ACTIONS(2163),
    [anon_sym_any] = ACTIONS(2163),
    [anon_sym_number] = ACTIONS(2163),
    [anon_sym_boolean] = ACTIONS(2163),
    [anon_sym_string] = ACTIONS(2163),
    [anon_sym_symbol] = ACTIONS(2163),
    [anon_sym_object] = ACTIONS(2163),
    [anon_sym_abstract] = ACTIONS(2163),
    [anon_sym_satisfies] = ACTIONS(2163),
    [anon_sym_interface] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [sym__automatic_semicolon] = ACTIONS(2165),
    [sym__ternary_qmark] = ACTIONS(2165),
    [sym_html_comment] = ACTIONS(5),
  },
  [320] = {
    [sym_comment] = STATE(320),
    [sym_identifier] = ACTIONS(2167),
    [anon_sym_export] = ACTIONS(2167),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2167),
    [anon_sym_type] = ACTIONS(2167),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2167),
    [anon_sym_with] = ACTIONS(2167),
    [anon_sym_var] = ACTIONS(2167),
    [anon_sym_let] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_debugger] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_case] = ACTIONS(2167),
    [anon_sym_yield] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LTtemplate_GT] = ACTIONS(2167),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_async] = ACTIONS(2167),
    [anon_sym_function] = ACTIONS(2167),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_STAR_STAR] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2167),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_QMARK_QMARK] = ACTIONS(2169),
    [anon_sym_instanceof] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_void] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [sym_number] = ACTIONS(2167),
    [sym_private_property_identifier] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [sym_super] = ACTIONS(2167),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_undefined] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_readonly] = ACTIONS(2167),
    [anon_sym_get] = ACTIONS(2167),
    [anon_sym_set] = ACTIONS(2167),
    [anon_sym_declare] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_override] = ACTIONS(2167),
    [anon_sym_module] = ACTIONS(2167),
    [anon_sym_any] = ACTIONS(2167),
    [anon_sym_number] = ACTIONS(2167),
    [anon_sym_boolean] = ACTIONS(2167),
    [anon_sym_string] = ACTIONS(2167),
    [anon_sym_symbol] = ACTIONS(2167),
    [anon_sym_object] = ACTIONS(2167),
    [anon_sym_abstract] = ACTIONS(2167),
    [anon_sym_satisfies] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [sym__automatic_semicolon] = ACTIONS(2171),
    [sym__ternary_qmark] = ACTIONS(2173),
    [sym_html_comment] = ACTIONS(5),
  },
  [321] = {
    [sym_comment] = STATE(321),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_default] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_namespace] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2175),
    [anon_sym_import] = ACTIONS(2175),
    [anon_sym_with] = ACTIONS(2175),
    [anon_sym_var] = ACTIONS(2175),
    [anon_sym_let] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_else] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_switch] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_await] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_do] = ACTIONS(2175),
    [anon_sym_try] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_debugger] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_case] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [anon_sym_LTtemplate_GT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_class] = ACTIONS(2175),
    [anon_sym_async] = ACTIONS(2175),
    [anon_sym_function] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_new] = ACTIONS(2175),
    [anon_sym_using] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_STAR_STAR] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_QMARK_QMARK] = ACTIONS(2175),
    [anon_sym_instanceof] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_void] = ACTIONS(2175),
    [anon_sym_delete] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_number] = ACTIONS(2175),
    [sym_private_property_identifier] = ACTIONS(2175),
    [sym_this] = ACTIONS(2175),
    [sym_super] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2175),
    [anon_sym_static] = ACTIONS(2175),
    [anon_sym_readonly] = ACTIONS(2175),
    [anon_sym_get] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(2175),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_public] = ACTIONS(2175),
    [anon_sym_private] = ACTIONS(2175),
    [anon_sym_protected] = ACTIONS(2175),
    [anon_sym_override] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2175),
    [anon_sym_any] = ACTIONS(2175),
    [anon_sym_number] = ACTIONS(2175),
    [anon_sym_boolean] = ACTIONS(2175),
    [anon_sym_string] = ACTIONS(2175),
    [anon_sym_symbol] = ACTIONS(2175),
    [anon_sym_object] = ACTIONS(2175),
    [anon_sym_abstract] = ACTIONS(2175),
    [anon_sym_satisfies] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [sym__automatic_semicolon] = ACTIONS(2177),
    [sym__ternary_qmark] = ACTIONS(2177),
    [sym_html_comment] = ACTIONS(5),
  },
  [322] = {
    [sym_comment] = STATE(322),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2069),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_EQ] = ACTIONS(2071),
    [anon_sym_as] = ACTIONS(2069),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_COMMA] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(2069),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(2069),
    [anon_sym_DOT] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_QMARK_DOT] = ACTIONS(2069),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2069),
    [anon_sym_PIPE_PIPE] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2069),
    [anon_sym_GT_GT_GT] = ACTIONS(2069),
    [anon_sym_LT_LT] = ACTIONS(2069),
    [anon_sym_AMP] = ACTIONS(2069),
    [anon_sym_CARET] = ACTIONS(2069),
    [anon_sym_PIPE] = ACTIONS(2069),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_PERCENT] = ACTIONS(2069),
    [anon_sym_STAR_STAR] = ACTIONS(2069),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_LT_EQ] = ACTIONS(2069),
    [anon_sym_EQ_EQ] = ACTIONS(2069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2069),
    [anon_sym_GT_EQ] = ACTIONS(2069),
    [anon_sym_QMARK_QMARK] = ACTIONS(2069),
    [anon_sym_instanceof] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_satisfies] = ACTIONS(2069),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2179),
    [sym__ternary_qmark] = ACTIONS(2075),
    [sym_html_comment] = ACTIONS(5),
  },
  [323] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2625),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_spread_element] = STATE(5960),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(323),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(5961),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(2077),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [324] = {
    [sym_comment] = STATE(324),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_export] = ACTIONS(2183),
    [anon_sym_STAR] = ACTIONS(2183),
    [anon_sym_default] = ACTIONS(2183),
    [anon_sym_type] = ACTIONS(2183),
    [anon_sym_as] = ACTIONS(2183),
    [anon_sym_namespace] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_typeof] = ACTIONS(2183),
    [anon_sym_import] = ACTIONS(2183),
    [anon_sym_with] = ACTIONS(2183),
    [anon_sym_var] = ACTIONS(2183),
    [anon_sym_let] = ACTIONS(2183),
    [anon_sym_const] = ACTIONS(2183),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_else] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2183),
    [anon_sym_for] = ACTIONS(2183),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2183),
    [anon_sym_in] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(2183),
    [anon_sym_do] = ACTIONS(2183),
    [anon_sym_try] = ACTIONS(2183),
    [anon_sym_break] = ACTIONS(2183),
    [anon_sym_continue] = ACTIONS(2183),
    [anon_sym_debugger] = ACTIONS(2183),
    [anon_sym_return] = ACTIONS(2183),
    [anon_sym_throw] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_case] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2183),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [anon_sym_class] = ACTIONS(2183),
    [anon_sym_async] = ACTIONS(2183),
    [anon_sym_function] = ACTIONS(2183),
    [anon_sym_QMARK_DOT] = ACTIONS(2183),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_using] = ACTIONS(2183),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE_PIPE] = ACTIONS(2183),
    [anon_sym_GT_GT] = ACTIONS(2183),
    [anon_sym_GT_GT_GT] = ACTIONS(2183),
    [anon_sym_LT_LT] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_PERCENT] = ACTIONS(2183),
    [anon_sym_STAR_STAR] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2183),
    [anon_sym_QMARK_QMARK] = ACTIONS(2183),
    [anon_sym_instanceof] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2183),
    [anon_sym_delete] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2183),
    [sym_private_property_identifier] = ACTIONS(2183),
    [sym_this] = ACTIONS(2183),
    [sym_super] = ACTIONS(2183),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_undefined] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2183),
    [anon_sym_readonly] = ACTIONS(2183),
    [anon_sym_get] = ACTIONS(2183),
    [anon_sym_set] = ACTIONS(2183),
    [anon_sym_declare] = ACTIONS(2183),
    [anon_sym_public] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2183),
    [anon_sym_protected] = ACTIONS(2183),
    [anon_sym_override] = ACTIONS(2183),
    [anon_sym_module] = ACTIONS(2183),
    [anon_sym_any] = ACTIONS(2183),
    [anon_sym_number] = ACTIONS(2183),
    [anon_sym_boolean] = ACTIONS(2183),
    [anon_sym_string] = ACTIONS(2183),
    [anon_sym_symbol] = ACTIONS(2183),
    [anon_sym_object] = ACTIONS(2183),
    [anon_sym_abstract] = ACTIONS(2183),
    [anon_sym_satisfies] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2183),
    [anon_sym_enum] = ACTIONS(2183),
    [sym__automatic_semicolon] = ACTIONS(2185),
    [sym__ternary_qmark] = ACTIONS(2185),
    [sym_html_comment] = ACTIONS(5),
  },
  [325] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2637),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_spread_element] = STATE(5966),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(325),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(2187),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [326] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2563),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(326),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [anon_sym_extends] = ACTIONS(1972),
    [sym_html_comment] = ACTIONS(5),
  },
  [327] = {
    [sym_comment] = STATE(327),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_export] = ACTIONS(2189),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_default] = ACTIONS(2189),
    [anon_sym_type] = ACTIONS(2189),
    [anon_sym_as] = ACTIONS(2191),
    [anon_sym_namespace] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_import] = ACTIONS(2189),
    [anon_sym_with] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_else] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2189),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_in] = ACTIONS(2191),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_debugger] = ACTIONS(2189),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_case] = ACTIONS(2189),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2189),
    [anon_sym_LTtemplate_GT] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2191),
    [anon_sym_DOT] = ACTIONS(2191),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_class] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_function] = ACTIONS(2189),
    [anon_sym_QMARK_DOT] = ACTIONS(2191),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_using] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2191),
    [anon_sym_GT_GT] = ACTIONS(2191),
    [anon_sym_GT_GT_GT] = ACTIONS(2191),
    [anon_sym_LT_LT] = ACTIONS(2191),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2191),
    [anon_sym_PIPE] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_PERCENT] = ACTIONS(2191),
    [anon_sym_STAR_STAR] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_LT_EQ] = ACTIONS(2191),
    [anon_sym_EQ_EQ] = ACTIONS(2191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2191),
    [anon_sym_BANG_EQ] = ACTIONS(2191),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2191),
    [anon_sym_GT_EQ] = ACTIONS(2191),
    [anon_sym_QMARK_QMARK] = ACTIONS(2191),
    [anon_sym_instanceof] = ACTIONS(2191),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_void] = ACTIONS(2189),
    [anon_sym_delete] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2189),
    [sym_number] = ACTIONS(2189),
    [sym_private_property_identifier] = ACTIONS(2189),
    [sym_this] = ACTIONS(2189),
    [sym_super] = ACTIONS(2189),
    [sym_true] = ACTIONS(2189),
    [sym_false] = ACTIONS(2189),
    [sym_null] = ACTIONS(2189),
    [sym_undefined] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_declare] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_module] = ACTIONS(2189),
    [anon_sym_any] = ACTIONS(2189),
    [anon_sym_number] = ACTIONS(2189),
    [anon_sym_boolean] = ACTIONS(2189),
    [anon_sym_string] = ACTIONS(2189),
    [anon_sym_symbol] = ACTIONS(2189),
    [anon_sym_object] = ACTIONS(2189),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_satisfies] = ACTIONS(2191),
    [anon_sym_interface] = ACTIONS(2189),
    [anon_sym_enum] = ACTIONS(2189),
    [sym__automatic_semicolon] = ACTIONS(2193),
    [sym__ternary_qmark] = ACTIONS(2195),
    [sym_html_comment] = ACTIONS(5),
  },
  [328] = {
    [sym_comment] = STATE(328),
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_export] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2199),
    [anon_sym_default] = ACTIONS(2197),
    [anon_sym_type] = ACTIONS(2197),
    [anon_sym_as] = ACTIONS(2199),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_import] = ACTIONS(2197),
    [anon_sym_with] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_debugger] = ACTIONS(2197),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_case] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_LTtemplate_GT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_DOT] = ACTIONS(2199),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_function] = ACTIONS(2197),
    [anon_sym_QMARK_DOT] = ACTIONS(2199),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_AMP_AMP] = ACTIONS(2199),
    [anon_sym_PIPE_PIPE] = ACTIONS(2199),
    [anon_sym_GT_GT] = ACTIONS(2199),
    [anon_sym_GT_GT_GT] = ACTIONS(2199),
    [anon_sym_LT_LT] = ACTIONS(2199),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_PIPE] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2199),
    [anon_sym_STAR_STAR] = ACTIONS(2199),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_EQ_EQ] = ACTIONS(2199),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2199),
    [anon_sym_BANG_EQ] = ACTIONS(2199),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2199),
    [anon_sym_QMARK_QMARK] = ACTIONS(2199),
    [anon_sym_instanceof] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2197),
    [sym_number] = ACTIONS(2197),
    [sym_private_property_identifier] = ACTIONS(2197),
    [sym_this] = ACTIONS(2197),
    [sym_super] = ACTIONS(2197),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [sym_null] = ACTIONS(2197),
    [sym_undefined] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_declare] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_module] = ACTIONS(2197),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_boolean] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_object] = ACTIONS(2197),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_satisfies] = ACTIONS(2199),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [sym__automatic_semicolon] = ACTIONS(2201),
    [sym__ternary_qmark] = ACTIONS(2203),
    [sym_html_comment] = ACTIONS(5),
  },
  [329] = {
    [sym_comment] = STATE(329),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2207),
    [anon_sym_default] = ACTIONS(2205),
    [anon_sym_type] = ACTIONS(2205),
    [anon_sym_as] = ACTIONS(2207),
    [anon_sym_namespace] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_COMMA] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_typeof] = ACTIONS(2205),
    [anon_sym_import] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2205),
    [anon_sym_var] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_else] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_await] = ACTIONS(2205),
    [anon_sym_in] = ACTIONS(2207),
    [anon_sym_while] = ACTIONS(2205),
    [anon_sym_do] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2205),
    [anon_sym_break] = ACTIONS(2205),
    [anon_sym_continue] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2205),
    [anon_sym_return] = ACTIONS(2205),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_case] = ACTIONS(2205),
    [anon_sym_yield] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_LTtemplate_GT] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_DOT] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_class] = ACTIONS(2205),
    [anon_sym_async] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2205),
    [anon_sym_QMARK_DOT] = ACTIONS(2207),
    [anon_sym_new] = ACTIONS(2205),
    [anon_sym_using] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(2207),
    [anon_sym_GT_GT_GT] = ACTIONS(2207),
    [anon_sym_LT_LT] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
    [anon_sym_CARET] = ACTIONS(2207),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2207),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_EQ] = ACTIONS(2207),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2207),
    [anon_sym_GT_EQ] = ACTIONS(2207),
    [anon_sym_QMARK_QMARK] = ACTIONS(2207),
    [anon_sym_instanceof] = ACTIONS(2207),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_void] = ACTIONS(2205),
    [anon_sym_delete] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_number] = ACTIONS(2205),
    [sym_private_property_identifier] = ACTIONS(2205),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(2205),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [anon_sym_static] = ACTIONS(2205),
    [anon_sym_readonly] = ACTIONS(2205),
    [anon_sym_get] = ACTIONS(2205),
    [anon_sym_set] = ACTIONS(2205),
    [anon_sym_declare] = ACTIONS(2205),
    [anon_sym_public] = ACTIONS(2205),
    [anon_sym_private] = ACTIONS(2205),
    [anon_sym_protected] = ACTIONS(2205),
    [anon_sym_override] = ACTIONS(2205),
    [anon_sym_module] = ACTIONS(2205),
    [anon_sym_any] = ACTIONS(2205),
    [anon_sym_number] = ACTIONS(2205),
    [anon_sym_boolean] = ACTIONS(2205),
    [anon_sym_string] = ACTIONS(2205),
    [anon_sym_symbol] = ACTIONS(2205),
    [anon_sym_object] = ACTIONS(2205),
    [anon_sym_abstract] = ACTIONS(2205),
    [anon_sym_satisfies] = ACTIONS(2207),
    [anon_sym_interface] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2205),
    [sym__automatic_semicolon] = ACTIONS(2209),
    [sym__ternary_qmark] = ACTIONS(2211),
    [sym_html_comment] = ACTIONS(5),
  },
  [330] = {
    [sym_comment] = STATE(330),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_export] = ACTIONS(2213),
    [anon_sym_STAR] = ACTIONS(2215),
    [anon_sym_default] = ACTIONS(2213),
    [anon_sym_type] = ACTIONS(2213),
    [anon_sym_as] = ACTIONS(2215),
    [anon_sym_namespace] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_COMMA] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_typeof] = ACTIONS(2213),
    [anon_sym_import] = ACTIONS(2213),
    [anon_sym_with] = ACTIONS(2213),
    [anon_sym_var] = ACTIONS(2213),
    [anon_sym_let] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_else] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_for] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_await] = ACTIONS(2213),
    [anon_sym_in] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_do] = ACTIONS(2213),
    [anon_sym_try] = ACTIONS(2213),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_debugger] = ACTIONS(2213),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_throw] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_case] = ACTIONS(2213),
    [anon_sym_yield] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2213),
    [anon_sym_LTtemplate_GT] = ACTIONS(2213),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_DOT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_class] = ACTIONS(2213),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2213),
    [anon_sym_QMARK_DOT] = ACTIONS(2215),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_using] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_GT_GT_GT] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_PERCENT] = ACTIONS(2215),
    [anon_sym_STAR_STAR] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_LT_EQ] = ACTIONS(2215),
    [anon_sym_EQ_EQ] = ACTIONS(2215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2215),
    [anon_sym_BANG_EQ] = ACTIONS(2215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2215),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_QMARK_QMARK] = ACTIONS(2215),
    [anon_sym_instanceof] = ACTIONS(2215),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_void] = ACTIONS(2213),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_number] = ACTIONS(2213),
    [sym_private_property_identifier] = ACTIONS(2213),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(2213),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2213),
    [anon_sym_static] = ACTIONS(2213),
    [anon_sym_readonly] = ACTIONS(2213),
    [anon_sym_get] = ACTIONS(2213),
    [anon_sym_set] = ACTIONS(2213),
    [anon_sym_declare] = ACTIONS(2213),
    [anon_sym_public] = ACTIONS(2213),
    [anon_sym_private] = ACTIONS(2213),
    [anon_sym_protected] = ACTIONS(2213),
    [anon_sym_override] = ACTIONS(2213),
    [anon_sym_module] = ACTIONS(2213),
    [anon_sym_any] = ACTIONS(2213),
    [anon_sym_number] = ACTIONS(2213),
    [anon_sym_boolean] = ACTIONS(2213),
    [anon_sym_string] = ACTIONS(2213),
    [anon_sym_symbol] = ACTIONS(2213),
    [anon_sym_object] = ACTIONS(2213),
    [anon_sym_abstract] = ACTIONS(2213),
    [anon_sym_satisfies] = ACTIONS(2215),
    [anon_sym_interface] = ACTIONS(2213),
    [anon_sym_enum] = ACTIONS(2213),
    [sym__automatic_semicolon] = ACTIONS(2217),
    [sym__ternary_qmark] = ACTIONS(2219),
    [sym_html_comment] = ACTIONS(5),
  },
  [331] = {
    [sym_comment] = STATE(331),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_as] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_in] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_QMARK_DOT] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_PIPE_PIPE] = ACTIONS(2221),
    [anon_sym_GT_GT] = ACTIONS(2221),
    [anon_sym_GT_GT_GT] = ACTIONS(2221),
    [anon_sym_LT_LT] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_PERCENT] = ACTIONS(2221),
    [anon_sym_STAR_STAR] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2221),
    [anon_sym_QMARK_QMARK] = ACTIONS(2221),
    [anon_sym_instanceof] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_satisfies] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [sym__ternary_qmark] = ACTIONS(2223),
    [sym_html_comment] = ACTIONS(5),
  },
  [332] = {
    [sym_comment] = STATE(332),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(2227),
    [anon_sym_default] = ACTIONS(2225),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_as] = ACTIONS(2227),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2225),
    [anon_sym_COMMA] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_else] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_in] = ACTIONS(2227),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_case] = ACTIONS(2225),
    [anon_sym_yield] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2225),
    [anon_sym_LTtemplate_GT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2227),
    [anon_sym_DOT] = ACTIONS(2227),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_SQUOTE] = ACTIONS(2225),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_function] = ACTIONS(2225),
    [anon_sym_QMARK_DOT] = ACTIONS(2227),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_using] = ACTIONS(2225),
    [anon_sym_AMP_AMP] = ACTIONS(2227),
    [anon_sym_PIPE_PIPE] = ACTIONS(2227),
    [anon_sym_GT_GT] = ACTIONS(2227),
    [anon_sym_GT_GT_GT] = ACTIONS(2227),
    [anon_sym_LT_LT] = ACTIONS(2227),
    [anon_sym_AMP] = ACTIONS(2227),
    [anon_sym_CARET] = ACTIONS(2227),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2227),
    [anon_sym_STAR_STAR] = ACTIONS(2227),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_LT_EQ] = ACTIONS(2227),
    [anon_sym_EQ_EQ] = ACTIONS(2227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2227),
    [anon_sym_BANG_EQ] = ACTIONS(2227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2227),
    [anon_sym_GT_EQ] = ACTIONS(2227),
    [anon_sym_QMARK_QMARK] = ACTIONS(2227),
    [anon_sym_instanceof] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2225),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(2225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [sym_number] = ACTIONS(2225),
    [sym_private_property_identifier] = ACTIONS(2225),
    [sym_this] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [sym_false] = ACTIONS(2225),
    [sym_null] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2225),
    [anon_sym_static] = ACTIONS(2225),
    [anon_sym_readonly] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_override] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_object] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_satisfies] = ACTIONS(2227),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
    [sym__automatic_semicolon] = ACTIONS(2229),
    [sym__ternary_qmark] = ACTIONS(2231),
    [sym_html_comment] = ACTIONS(5),
  },
  [333] = {
    [sym_comment] = STATE(333),
    [sym_identifier] = ACTIONS(2233),
    [anon_sym_export] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_default] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(2233),
    [anon_sym_as] = ACTIONS(2233),
    [anon_sym_namespace] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_COMMA] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [anon_sym_typeof] = ACTIONS(2233),
    [anon_sym_import] = ACTIONS(2233),
    [anon_sym_with] = ACTIONS(2233),
    [anon_sym_var] = ACTIONS(2233),
    [anon_sym_let] = ACTIONS(2233),
    [anon_sym_const] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_else] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_for] = ACTIONS(2233),
    [anon_sym_LPAREN] = ACTIONS(2233),
    [anon_sym_await] = ACTIONS(2233),
    [anon_sym_in] = ACTIONS(2233),
    [anon_sym_while] = ACTIONS(2233),
    [anon_sym_do] = ACTIONS(2233),
    [anon_sym_try] = ACTIONS(2233),
    [anon_sym_break] = ACTIONS(2233),
    [anon_sym_continue] = ACTIONS(2233),
    [anon_sym_debugger] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2233),
    [anon_sym_throw] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym_case] = ACTIONS(2233),
    [anon_sym_yield] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2233),
    [anon_sym_LTtemplate_GT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_class] = ACTIONS(2233),
    [anon_sym_async] = ACTIONS(2233),
    [anon_sym_function] = ACTIONS(2233),
    [anon_sym_QMARK_DOT] = ACTIONS(2233),
    [anon_sym_new] = ACTIONS(2233),
    [anon_sym_using] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_GT_GT_GT] = ACTIONS(2233),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2233),
    [anon_sym_BANG_EQ] = ACTIONS(2233),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2233),
    [anon_sym_QMARK_QMARK] = ACTIONS(2233),
    [anon_sym_instanceof] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_void] = ACTIONS(2233),
    [anon_sym_delete] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2233),
    [sym_number] = ACTIONS(2233),
    [sym_private_property_identifier] = ACTIONS(2233),
    [sym_this] = ACTIONS(2233),
    [sym_super] = ACTIONS(2233),
    [sym_true] = ACTIONS(2233),
    [sym_false] = ACTIONS(2233),
    [sym_null] = ACTIONS(2233),
    [sym_undefined] = ACTIONS(2233),
    [anon_sym_AT] = ACTIONS(2233),
    [anon_sym_static] = ACTIONS(2233),
    [anon_sym_readonly] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2233),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_declare] = ACTIONS(2233),
    [anon_sym_public] = ACTIONS(2233),
    [anon_sym_private] = ACTIONS(2233),
    [anon_sym_protected] = ACTIONS(2233),
    [anon_sym_override] = ACTIONS(2233),
    [anon_sym_module] = ACTIONS(2233),
    [anon_sym_any] = ACTIONS(2233),
    [anon_sym_number] = ACTIONS(2233),
    [anon_sym_boolean] = ACTIONS(2233),
    [anon_sym_string] = ACTIONS(2233),
    [anon_sym_symbol] = ACTIONS(2233),
    [anon_sym_object] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2233),
    [anon_sym_satisfies] = ACTIONS(2233),
    [anon_sym_interface] = ACTIONS(2233),
    [anon_sym_enum] = ACTIONS(2233),
    [sym__automatic_semicolon] = ACTIONS(2235),
    [sym__ternary_qmark] = ACTIONS(2235),
    [sym_html_comment] = ACTIONS(5),
  },
  [334] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2617),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(334),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [anon_sym_extends] = ACTIONS(1972),
    [sym_html_comment] = ACTIONS(5),
  },
  [335] = {
    [sym_comment] = STATE(335),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_export] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_default] = ACTIONS(2237),
    [anon_sym_type] = ACTIONS(2237),
    [anon_sym_as] = ACTIONS(2237),
    [anon_sym_namespace] = ACTIONS(2237),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_COMMA] = ACTIONS(2237),
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_typeof] = ACTIONS(2237),
    [anon_sym_import] = ACTIONS(2237),
    [anon_sym_with] = ACTIONS(2237),
    [anon_sym_var] = ACTIONS(2237),
    [anon_sym_let] = ACTIONS(2237),
    [anon_sym_const] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_else] = ACTIONS(2237),
    [anon_sym_if] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_for] = ACTIONS(2237),
    [anon_sym_LPAREN] = ACTIONS(2237),
    [anon_sym_await] = ACTIONS(2237),
    [anon_sym_in] = ACTIONS(2237),
    [anon_sym_while] = ACTIONS(2237),
    [anon_sym_do] = ACTIONS(2237),
    [anon_sym_try] = ACTIONS(2237),
    [anon_sym_break] = ACTIONS(2237),
    [anon_sym_continue] = ACTIONS(2237),
    [anon_sym_debugger] = ACTIONS(2237),
    [anon_sym_return] = ACTIONS(2237),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2237),
    [anon_sym_case] = ACTIONS(2237),
    [anon_sym_yield] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2237),
    [anon_sym_LTtemplate_GT] = ACTIONS(2237),
    [anon_sym_GT] = ACTIONS(2237),
    [anon_sym_DOT] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_class] = ACTIONS(2237),
    [anon_sym_async] = ACTIONS(2237),
    [anon_sym_function] = ACTIONS(2237),
    [anon_sym_QMARK_DOT] = ACTIONS(2237),
    [anon_sym_new] = ACTIONS(2237),
    [anon_sym_using] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_PIPE_PIPE] = ACTIONS(2237),
    [anon_sym_GT_GT] = ACTIONS(2237),
    [anon_sym_GT_GT_GT] = ACTIONS(2237),
    [anon_sym_LT_LT] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_PIPE] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_SLASH] = ACTIONS(2237),
    [anon_sym_PERCENT] = ACTIONS(2237),
    [anon_sym_STAR_STAR] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2237),
    [anon_sym_LT_EQ] = ACTIONS(2237),
    [anon_sym_EQ_EQ] = ACTIONS(2237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2237),
    [anon_sym_BANG_EQ] = ACTIONS(2237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2237),
    [anon_sym_GT_EQ] = ACTIONS(2237),
    [anon_sym_QMARK_QMARK] = ACTIONS(2237),
    [anon_sym_instanceof] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_void] = ACTIONS(2237),
    [anon_sym_delete] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2237),
    [sym_number] = ACTIONS(2237),
    [sym_private_property_identifier] = ACTIONS(2237),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2237),
    [anon_sym_static] = ACTIONS(2237),
    [anon_sym_readonly] = ACTIONS(2237),
    [anon_sym_get] = ACTIONS(2237),
    [anon_sym_set] = ACTIONS(2237),
    [anon_sym_declare] = ACTIONS(2237),
    [anon_sym_public] = ACTIONS(2237),
    [anon_sym_private] = ACTIONS(2237),
    [anon_sym_protected] = ACTIONS(2237),
    [anon_sym_override] = ACTIONS(2237),
    [anon_sym_module] = ACTIONS(2237),
    [anon_sym_any] = ACTIONS(2237),
    [anon_sym_number] = ACTIONS(2237),
    [anon_sym_boolean] = ACTIONS(2237),
    [anon_sym_string] = ACTIONS(2237),
    [anon_sym_symbol] = ACTIONS(2237),
    [anon_sym_object] = ACTIONS(2237),
    [anon_sym_abstract] = ACTIONS(2237),
    [anon_sym_satisfies] = ACTIONS(2237),
    [anon_sym_interface] = ACTIONS(2237),
    [anon_sym_enum] = ACTIONS(2237),
    [sym__automatic_semicolon] = ACTIONS(2239),
    [sym__ternary_qmark] = ACTIONS(2239),
    [sym_html_comment] = ACTIONS(5),
  },
  [336] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2874),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(336),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [anon_sym_extends] = ACTIONS(1972),
    [sym_html_comment] = ACTIONS(5),
  },
  [337] = {
    [sym_comment] = STATE(337),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_export] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2241),
    [anon_sym_type] = ACTIONS(2241),
    [anon_sym_as] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_typeof] = ACTIONS(2241),
    [anon_sym_import] = ACTIONS(2241),
    [anon_sym_with] = ACTIONS(2241),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_const] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_else] = ACTIONS(2241),
    [anon_sym_if] = ACTIONS(2241),
    [anon_sym_switch] = ACTIONS(2241),
    [anon_sym_for] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_await] = ACTIONS(2241),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2241),
    [anon_sym_do] = ACTIONS(2241),
    [anon_sym_try] = ACTIONS(2241),
    [anon_sym_break] = ACTIONS(2241),
    [anon_sym_continue] = ACTIONS(2241),
    [anon_sym_debugger] = ACTIONS(2241),
    [anon_sym_return] = ACTIONS(2241),
    [anon_sym_throw] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_case] = ACTIONS(2241),
    [anon_sym_yield] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_LTtemplate_GT] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2243),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_class] = ACTIONS(2241),
    [anon_sym_async] = ACTIONS(2241),
    [anon_sym_function] = ACTIONS(2241),
    [anon_sym_QMARK_DOT] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2241),
    [anon_sym_using] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_GT_GT] = ACTIONS(2243),
    [anon_sym_GT_GT_GT] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2243),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_CARET] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [anon_sym_PERCENT] = ACTIONS(2243),
    [anon_sym_STAR_STAR] = ACTIONS(2243),
    [anon_sym_LT] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2243),
    [anon_sym_GT_EQ] = ACTIONS(2243),
    [anon_sym_QMARK_QMARK] = ACTIONS(2243),
    [anon_sym_instanceof] = ACTIONS(2243),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_void] = ACTIONS(2241),
    [anon_sym_delete] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2241),
    [sym_number] = ACTIONS(2241),
    [sym_private_property_identifier] = ACTIONS(2241),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(2241),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(2241),
    [anon_sym_static] = ACTIONS(2241),
    [anon_sym_readonly] = ACTIONS(2241),
    [anon_sym_get] = ACTIONS(2241),
    [anon_sym_set] = ACTIONS(2241),
    [anon_sym_declare] = ACTIONS(2241),
    [anon_sym_public] = ACTIONS(2241),
    [anon_sym_private] = ACTIONS(2241),
    [anon_sym_protected] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_module] = ACTIONS(2241),
    [anon_sym_any] = ACTIONS(2241),
    [anon_sym_number] = ACTIONS(2241),
    [anon_sym_boolean] = ACTIONS(2241),
    [anon_sym_string] = ACTIONS(2241),
    [anon_sym_symbol] = ACTIONS(2241),
    [anon_sym_object] = ACTIONS(2241),
    [anon_sym_abstract] = ACTIONS(2241),
    [anon_sym_satisfies] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2241),
    [anon_sym_enum] = ACTIONS(2241),
    [sym__automatic_semicolon] = ACTIONS(2245),
    [sym__ternary_qmark] = ACTIONS(2247),
    [sym_html_comment] = ACTIONS(5),
  },
  [338] = {
    [sym_comment] = STATE(338),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_COMMA] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(2067),
    [anon_sym_DOT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_QMARK_DOT] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2067),
    [anon_sym_PIPE_PIPE] = ACTIONS(2067),
    [anon_sym_GT_GT] = ACTIONS(2067),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_AMP] = ACTIONS(2067),
    [anon_sym_CARET] = ACTIONS(2067),
    [anon_sym_PIPE] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_STAR_STAR] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_LT_EQ] = ACTIONS(2067),
    [anon_sym_EQ_EQ] = ACTIONS(2067),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2067),
    [anon_sym_GT_EQ] = ACTIONS(2067),
    [anon_sym_QMARK_QMARK] = ACTIONS(2067),
    [anon_sym_instanceof] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_satisfies] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2249),
    [sym__ternary_qmark] = ACTIONS(2095),
    [sym_html_comment] = ACTIONS(5),
  },
  [339] = {
    [sym_comment] = STATE(339),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2251),
    [anon_sym_in] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_LTtemplate_GT] = ACTIONS(2251),
    [anon_sym_GT] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_function] = ACTIONS(2251),
    [anon_sym_QMARK_DOT] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_AMP_AMP] = ACTIONS(2251),
    [anon_sym_PIPE_PIPE] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_GT_GT_GT] = ACTIONS(2251),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [anon_sym_PERCENT] = ACTIONS(2251),
    [anon_sym_STAR_STAR] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_LT_EQ] = ACTIONS(2251),
    [anon_sym_EQ_EQ] = ACTIONS(2251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2251),
    [anon_sym_BANG_EQ] = ACTIONS(2251),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2251),
    [anon_sym_GT_EQ] = ACTIONS(2251),
    [anon_sym_QMARK_QMARK] = ACTIONS(2251),
    [anon_sym_instanceof] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2251),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_number] = ACTIONS(2251),
    [sym_private_property_identifier] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [sym_null] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_readonly] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_override] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_object] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_satisfies] = ACTIONS(2251),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [sym__automatic_semicolon] = ACTIONS(2253),
    [sym__ternary_qmark] = ACTIONS(2253),
    [sym_html_comment] = ACTIONS(5),
  },
  [340] = {
    [sym_comment] = STATE(340),
    [sym_identifier] = ACTIONS(2255),
    [anon_sym_export] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_default] = ACTIONS(2255),
    [anon_sym_type] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2255),
    [anon_sym_COMMA] = ACTIONS(2257),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_typeof] = ACTIONS(2255),
    [anon_sym_import] = ACTIONS(2255),
    [anon_sym_with] = ACTIONS(2255),
    [anon_sym_var] = ACTIONS(2255),
    [anon_sym_let] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_else] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_await] = ACTIONS(2255),
    [anon_sym_in] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_debugger] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2255),
    [anon_sym_case] = ACTIONS(2255),
    [anon_sym_yield] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_LTtemplate_GT] = ACTIONS(2255),
    [anon_sym_GT] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(2255),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_async] = ACTIONS(2255),
    [anon_sym_function] = ACTIONS(2255),
    [anon_sym_QMARK_DOT] = ACTIONS(2257),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_PIPE_PIPE] = ACTIONS(2257),
    [anon_sym_GT_GT] = ACTIONS(2257),
    [anon_sym_GT_GT_GT] = ACTIONS(2257),
    [anon_sym_LT_LT] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(2257),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2257),
    [anon_sym_STAR_STAR] = ACTIONS(2257),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2257),
    [anon_sym_EQ_EQ] = ACTIONS(2257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2257),
    [anon_sym_BANG_EQ] = ACTIONS(2257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2257),
    [anon_sym_GT_EQ] = ACTIONS(2257),
    [anon_sym_QMARK_QMARK] = ACTIONS(2257),
    [anon_sym_instanceof] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2255),
    [anon_sym_void] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [sym_number] = ACTIONS(2255),
    [sym_private_property_identifier] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [sym_super] = ACTIONS(2255),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [sym_null] = ACTIONS(2255),
    [sym_undefined] = ACTIONS(2255),
    [anon_sym_AT] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_readonly] = ACTIONS(2255),
    [anon_sym_get] = ACTIONS(2255),
    [anon_sym_set] = ACTIONS(2255),
    [anon_sym_declare] = ACTIONS(2255),
    [anon_sym_public] = ACTIONS(2255),
    [anon_sym_private] = ACTIONS(2255),
    [anon_sym_protected] = ACTIONS(2255),
    [anon_sym_override] = ACTIONS(2255),
    [anon_sym_module] = ACTIONS(2255),
    [anon_sym_any] = ACTIONS(2255),
    [anon_sym_number] = ACTIONS(2255),
    [anon_sym_boolean] = ACTIONS(2255),
    [anon_sym_string] = ACTIONS(2255),
    [anon_sym_symbol] = ACTIONS(2255),
    [anon_sym_object] = ACTIONS(2255),
    [anon_sym_abstract] = ACTIONS(2255),
    [anon_sym_satisfies] = ACTIONS(2257),
    [anon_sym_interface] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [sym__automatic_semicolon] = ACTIONS(2259),
    [sym__ternary_qmark] = ACTIONS(2261),
    [sym_html_comment] = ACTIONS(5),
  },
  [341] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2681),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_spread_element] = STATE(6300),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(341),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [aux_sym_array_repeat1] = STATE(6299),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(2077),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2263),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [342] = {
    [sym_comment] = STATE(342),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_as] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2111),
    [anon_sym_DOT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_QMARK_DOT] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_AMP_AMP] = ACTIONS(2111),
    [anon_sym_PIPE_PIPE] = ACTIONS(2111),
    [anon_sym_GT_GT] = ACTIONS(2111),
    [anon_sym_GT_GT_GT] = ACTIONS(2111),
    [anon_sym_LT_LT] = ACTIONS(2111),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_CARET] = ACTIONS(2111),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_PERCENT] = ACTIONS(2111),
    [anon_sym_STAR_STAR] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_QMARK_QMARK] = ACTIONS(2111),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_satisfies] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2115),
    [sym__ternary_qmark] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [343] = {
    [sym_statement_block] = STATE(385),
    [sym_comment] = STATE(343),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2091),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [344] = {
    [sym_comment] = STATE(344),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_export] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2241),
    [anon_sym_type] = ACTIONS(2241),
    [anon_sym_as] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_typeof] = ACTIONS(2241),
    [anon_sym_import] = ACTIONS(2241),
    [anon_sym_with] = ACTIONS(2241),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_const] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_if] = ACTIONS(2241),
    [anon_sym_switch] = ACTIONS(2241),
    [anon_sym_for] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_await] = ACTIONS(2241),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2241),
    [anon_sym_do] = ACTIONS(2241),
    [anon_sym_try] = ACTIONS(2241),
    [anon_sym_break] = ACTIONS(2241),
    [anon_sym_continue] = ACTIONS(2241),
    [anon_sym_debugger] = ACTIONS(2241),
    [anon_sym_return] = ACTIONS(2241),
    [anon_sym_throw] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_case] = ACTIONS(2241),
    [anon_sym_yield] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_LTtemplate_GT] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2243),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_class] = ACTIONS(2241),
    [anon_sym_async] = ACTIONS(2241),
    [anon_sym_function] = ACTIONS(2241),
    [anon_sym_QMARK_DOT] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2241),
    [anon_sym_using] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_GT_GT] = ACTIONS(2243),
    [anon_sym_GT_GT_GT] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2243),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_CARET] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [anon_sym_PERCENT] = ACTIONS(2243),
    [anon_sym_STAR_STAR] = ACTIONS(2243),
    [anon_sym_LT] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2243),
    [anon_sym_GT_EQ] = ACTIONS(2243),
    [anon_sym_QMARK_QMARK] = ACTIONS(2243),
    [anon_sym_instanceof] = ACTIONS(2243),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_void] = ACTIONS(2241),
    [anon_sym_delete] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2241),
    [sym_number] = ACTIONS(2241),
    [sym_private_property_identifier] = ACTIONS(2241),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(2241),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(2241),
    [anon_sym_static] = ACTIONS(2241),
    [anon_sym_readonly] = ACTIONS(2241),
    [anon_sym_get] = ACTIONS(2241),
    [anon_sym_set] = ACTIONS(2241),
    [anon_sym_declare] = ACTIONS(2241),
    [anon_sym_public] = ACTIONS(2241),
    [anon_sym_private] = ACTIONS(2241),
    [anon_sym_protected] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_module] = ACTIONS(2241),
    [anon_sym_any] = ACTIONS(2241),
    [anon_sym_number] = ACTIONS(2241),
    [anon_sym_boolean] = ACTIONS(2241),
    [anon_sym_string] = ACTIONS(2241),
    [anon_sym_symbol] = ACTIONS(2241),
    [anon_sym_object] = ACTIONS(2241),
    [anon_sym_abstract] = ACTIONS(2241),
    [anon_sym_satisfies] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2241),
    [anon_sym_enum] = ACTIONS(2241),
    [sym__automatic_semicolon] = ACTIONS(2267),
    [sym__ternary_qmark] = ACTIONS(2247),
    [sym_html_comment] = ACTIONS(5),
  },
  [345] = {
    [sym_import] = STATE(4242),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3209),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(345),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [346] = {
    [sym_comment] = STATE(346),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_as] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_in] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_QMARK_DOT] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_PIPE_PIPE] = ACTIONS(2221),
    [anon_sym_GT_GT] = ACTIONS(2221),
    [anon_sym_GT_GT_GT] = ACTIONS(2221),
    [anon_sym_LT_LT] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_PERCENT] = ACTIONS(2221),
    [anon_sym_STAR_STAR] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2221),
    [anon_sym_QMARK_QMARK] = ACTIONS(2221),
    [anon_sym_instanceof] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_satisfies] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [sym__ternary_qmark] = ACTIONS(2223),
    [sym_html_comment] = ACTIONS(5),
  },
  [347] = {
    [sym_comment] = STATE(347),
    [sym_identifier] = ACTIONS(2233),
    [anon_sym_export] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_default] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(2233),
    [anon_sym_as] = ACTIONS(2233),
    [anon_sym_namespace] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_COMMA] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [anon_sym_typeof] = ACTIONS(2233),
    [anon_sym_import] = ACTIONS(2233),
    [anon_sym_with] = ACTIONS(2233),
    [anon_sym_var] = ACTIONS(2233),
    [anon_sym_let] = ACTIONS(2233),
    [anon_sym_const] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_for] = ACTIONS(2233),
    [anon_sym_LPAREN] = ACTIONS(2233),
    [anon_sym_await] = ACTIONS(2233),
    [anon_sym_in] = ACTIONS(2233),
    [anon_sym_while] = ACTIONS(2233),
    [anon_sym_do] = ACTIONS(2233),
    [anon_sym_try] = ACTIONS(2233),
    [anon_sym_break] = ACTIONS(2233),
    [anon_sym_continue] = ACTIONS(2233),
    [anon_sym_debugger] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2233),
    [anon_sym_throw] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym_case] = ACTIONS(2233),
    [anon_sym_yield] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2233),
    [anon_sym_LTtemplate_GT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_class] = ACTIONS(2233),
    [anon_sym_async] = ACTIONS(2233),
    [anon_sym_function] = ACTIONS(2233),
    [anon_sym_QMARK_DOT] = ACTIONS(2233),
    [anon_sym_new] = ACTIONS(2233),
    [anon_sym_using] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_GT_GT_GT] = ACTIONS(2233),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2233),
    [anon_sym_BANG_EQ] = ACTIONS(2233),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2233),
    [anon_sym_QMARK_QMARK] = ACTIONS(2233),
    [anon_sym_instanceof] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_void] = ACTIONS(2233),
    [anon_sym_delete] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2233),
    [sym_number] = ACTIONS(2233),
    [sym_private_property_identifier] = ACTIONS(2233),
    [sym_this] = ACTIONS(2233),
    [sym_super] = ACTIONS(2233),
    [sym_true] = ACTIONS(2233),
    [sym_false] = ACTIONS(2233),
    [sym_null] = ACTIONS(2233),
    [sym_undefined] = ACTIONS(2233),
    [anon_sym_AT] = ACTIONS(2233),
    [anon_sym_static] = ACTIONS(2233),
    [anon_sym_readonly] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2233),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_declare] = ACTIONS(2233),
    [anon_sym_public] = ACTIONS(2233),
    [anon_sym_private] = ACTIONS(2233),
    [anon_sym_protected] = ACTIONS(2233),
    [anon_sym_override] = ACTIONS(2233),
    [anon_sym_module] = ACTIONS(2233),
    [anon_sym_any] = ACTIONS(2233),
    [anon_sym_number] = ACTIONS(2233),
    [anon_sym_boolean] = ACTIONS(2233),
    [anon_sym_string] = ACTIONS(2233),
    [anon_sym_symbol] = ACTIONS(2233),
    [anon_sym_object] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2233),
    [anon_sym_satisfies] = ACTIONS(2233),
    [anon_sym_interface] = ACTIONS(2233),
    [anon_sym_enum] = ACTIONS(2233),
    [sym__automatic_semicolon] = ACTIONS(2235),
    [sym__ternary_qmark] = ACTIONS(2235),
    [sym_html_comment] = ACTIONS(5),
  },
  [348] = {
    [sym_comment] = STATE(348),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_export] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_default] = ACTIONS(2237),
    [anon_sym_type] = ACTIONS(2237),
    [anon_sym_as] = ACTIONS(2237),
    [anon_sym_namespace] = ACTIONS(2237),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_COMMA] = ACTIONS(2237),
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_typeof] = ACTIONS(2237),
    [anon_sym_import] = ACTIONS(2237),
    [anon_sym_with] = ACTIONS(2237),
    [anon_sym_var] = ACTIONS(2237),
    [anon_sym_let] = ACTIONS(2237),
    [anon_sym_const] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_if] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_for] = ACTIONS(2237),
    [anon_sym_LPAREN] = ACTIONS(2237),
    [anon_sym_await] = ACTIONS(2237),
    [anon_sym_in] = ACTIONS(2237),
    [anon_sym_while] = ACTIONS(2237),
    [anon_sym_do] = ACTIONS(2237),
    [anon_sym_try] = ACTIONS(2237),
    [anon_sym_break] = ACTIONS(2237),
    [anon_sym_continue] = ACTIONS(2237),
    [anon_sym_debugger] = ACTIONS(2237),
    [anon_sym_return] = ACTIONS(2237),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2237),
    [anon_sym_case] = ACTIONS(2237),
    [anon_sym_yield] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2237),
    [anon_sym_LTtemplate_GT] = ACTIONS(2237),
    [anon_sym_GT] = ACTIONS(2237),
    [anon_sym_DOT] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_class] = ACTIONS(2237),
    [anon_sym_async] = ACTIONS(2237),
    [anon_sym_function] = ACTIONS(2237),
    [anon_sym_QMARK_DOT] = ACTIONS(2237),
    [anon_sym_new] = ACTIONS(2237),
    [anon_sym_using] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_PIPE_PIPE] = ACTIONS(2237),
    [anon_sym_GT_GT] = ACTIONS(2237),
    [anon_sym_GT_GT_GT] = ACTIONS(2237),
    [anon_sym_LT_LT] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_PIPE] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_SLASH] = ACTIONS(2237),
    [anon_sym_PERCENT] = ACTIONS(2237),
    [anon_sym_STAR_STAR] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2237),
    [anon_sym_LT_EQ] = ACTIONS(2237),
    [anon_sym_EQ_EQ] = ACTIONS(2237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2237),
    [anon_sym_BANG_EQ] = ACTIONS(2237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2237),
    [anon_sym_GT_EQ] = ACTIONS(2237),
    [anon_sym_QMARK_QMARK] = ACTIONS(2237),
    [anon_sym_instanceof] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_void] = ACTIONS(2237),
    [anon_sym_delete] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2237),
    [sym_number] = ACTIONS(2237),
    [sym_private_property_identifier] = ACTIONS(2237),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2237),
    [anon_sym_static] = ACTIONS(2237),
    [anon_sym_readonly] = ACTIONS(2237),
    [anon_sym_get] = ACTIONS(2237),
    [anon_sym_set] = ACTIONS(2237),
    [anon_sym_declare] = ACTIONS(2237),
    [anon_sym_public] = ACTIONS(2237),
    [anon_sym_private] = ACTIONS(2237),
    [anon_sym_protected] = ACTIONS(2237),
    [anon_sym_override] = ACTIONS(2237),
    [anon_sym_module] = ACTIONS(2237),
    [anon_sym_any] = ACTIONS(2237),
    [anon_sym_number] = ACTIONS(2237),
    [anon_sym_boolean] = ACTIONS(2237),
    [anon_sym_string] = ACTIONS(2237),
    [anon_sym_symbol] = ACTIONS(2237),
    [anon_sym_object] = ACTIONS(2237),
    [anon_sym_abstract] = ACTIONS(2237),
    [anon_sym_satisfies] = ACTIONS(2237),
    [anon_sym_interface] = ACTIONS(2237),
    [anon_sym_enum] = ACTIONS(2237),
    [sym__automatic_semicolon] = ACTIONS(2239),
    [sym__ternary_qmark] = ACTIONS(2239),
    [sym_html_comment] = ACTIONS(5),
  },
  [349] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(6802),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(349),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(6098),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [350] = {
    [sym_comment] = STATE(350),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2251),
    [anon_sym_in] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_LTtemplate_GT] = ACTIONS(2251),
    [anon_sym_GT] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_function] = ACTIONS(2251),
    [anon_sym_QMARK_DOT] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_AMP_AMP] = ACTIONS(2251),
    [anon_sym_PIPE_PIPE] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_GT_GT_GT] = ACTIONS(2251),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [anon_sym_PERCENT] = ACTIONS(2251),
    [anon_sym_STAR_STAR] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_LT_EQ] = ACTIONS(2251),
    [anon_sym_EQ_EQ] = ACTIONS(2251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2251),
    [anon_sym_BANG_EQ] = ACTIONS(2251),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2251),
    [anon_sym_GT_EQ] = ACTIONS(2251),
    [anon_sym_QMARK_QMARK] = ACTIONS(2251),
    [anon_sym_instanceof] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2251),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_number] = ACTIONS(2251),
    [sym_private_property_identifier] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [sym_null] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_readonly] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_override] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_object] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_satisfies] = ACTIONS(2251),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [sym__automatic_semicolon] = ACTIONS(2253),
    [sym__ternary_qmark] = ACTIONS(2253),
    [sym_html_comment] = ACTIONS(5),
  },
  [351] = {
    [sym_comment] = STATE(351),
    [ts_builtin_sym_end] = ACTIONS(2271),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_export] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2105),
    [anon_sym_type] = ACTIONS(2103),
    [anon_sym_as] = ACTIONS(2105),
    [anon_sym_namespace] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_typeof] = ACTIONS(2103),
    [anon_sym_import] = ACTIONS(2103),
    [anon_sym_with] = ACTIONS(2103),
    [anon_sym_var] = ACTIONS(2103),
    [anon_sym_let] = ACTIONS(2103),
    [anon_sym_const] = ACTIONS(2103),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_else] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_switch] = ACTIONS(2103),
    [anon_sym_for] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_await] = ACTIONS(2103),
    [anon_sym_in] = ACTIONS(2105),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_try] = ACTIONS(2103),
    [anon_sym_break] = ACTIONS(2103),
    [anon_sym_continue] = ACTIONS(2103),
    [anon_sym_debugger] = ACTIONS(2103),
    [anon_sym_return] = ACTIONS(2103),
    [anon_sym_throw] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_yield] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LTtemplate_GT] = ACTIONS(2103),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2103),
    [anon_sym_SQUOTE] = ACTIONS(2103),
    [anon_sym_class] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(2103),
    [anon_sym_QMARK_DOT] = ACTIONS(2105),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_using] = ACTIONS(2103),
    [anon_sym_AMP_AMP] = ACTIONS(2105),
    [anon_sym_PIPE_PIPE] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2105),
    [anon_sym_GT_GT_GT] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_PERCENT] = ACTIONS(2105),
    [anon_sym_STAR_STAR] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(2105),
    [anon_sym_QMARK_QMARK] = ACTIONS(2105),
    [anon_sym_instanceof] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2103),
    [anon_sym_void] = ACTIONS(2103),
    [anon_sym_delete] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2103),
    [sym_number] = ACTIONS(2103),
    [sym_private_property_identifier] = ACTIONS(2103),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_undefined] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2103),
    [anon_sym_static] = ACTIONS(2103),
    [anon_sym_readonly] = ACTIONS(2103),
    [anon_sym_get] = ACTIONS(2103),
    [anon_sym_set] = ACTIONS(2103),
    [anon_sym_declare] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2103),
    [anon_sym_private] = ACTIONS(2103),
    [anon_sym_protected] = ACTIONS(2103),
    [anon_sym_override] = ACTIONS(2103),
    [anon_sym_module] = ACTIONS(2103),
    [anon_sym_any] = ACTIONS(2103),
    [anon_sym_number] = ACTIONS(2103),
    [anon_sym_boolean] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_symbol] = ACTIONS(2103),
    [anon_sym_object] = ACTIONS(2103),
    [anon_sym_abstract] = ACTIONS(2103),
    [anon_sym_satisfies] = ACTIONS(2105),
    [anon_sym_interface] = ACTIONS(2103),
    [anon_sym_enum] = ACTIONS(2103),
    [sym__automatic_semicolon] = ACTIONS(2273),
    [sym__ternary_qmark] = ACTIONS(2109),
    [sym_html_comment] = ACTIONS(5),
  },
  [352] = {
    [sym_comment] = STATE(352),
    [ts_builtin_sym_end] = ACTIONS(2275),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_export] = ACTIONS(2189),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_type] = ACTIONS(2189),
    [anon_sym_as] = ACTIONS(2191),
    [anon_sym_namespace] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_import] = ACTIONS(2189),
    [anon_sym_with] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_else] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2189),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_in] = ACTIONS(2191),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_debugger] = ACTIONS(2189),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2189),
    [anon_sym_LTtemplate_GT] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2191),
    [anon_sym_DOT] = ACTIONS(2191),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_class] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_function] = ACTIONS(2189),
    [anon_sym_QMARK_DOT] = ACTIONS(2191),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_using] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2191),
    [anon_sym_GT_GT] = ACTIONS(2191),
    [anon_sym_GT_GT_GT] = ACTIONS(2191),
    [anon_sym_LT_LT] = ACTIONS(2191),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2191),
    [anon_sym_PIPE] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_PERCENT] = ACTIONS(2191),
    [anon_sym_STAR_STAR] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_LT_EQ] = ACTIONS(2191),
    [anon_sym_EQ_EQ] = ACTIONS(2191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2191),
    [anon_sym_BANG_EQ] = ACTIONS(2191),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2191),
    [anon_sym_GT_EQ] = ACTIONS(2191),
    [anon_sym_QMARK_QMARK] = ACTIONS(2191),
    [anon_sym_instanceof] = ACTIONS(2191),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_void] = ACTIONS(2189),
    [anon_sym_delete] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2189),
    [sym_number] = ACTIONS(2189),
    [sym_private_property_identifier] = ACTIONS(2189),
    [sym_this] = ACTIONS(2189),
    [sym_super] = ACTIONS(2189),
    [sym_true] = ACTIONS(2189),
    [sym_false] = ACTIONS(2189),
    [sym_null] = ACTIONS(2189),
    [sym_undefined] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_declare] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_module] = ACTIONS(2189),
    [anon_sym_any] = ACTIONS(2189),
    [anon_sym_number] = ACTIONS(2189),
    [anon_sym_boolean] = ACTIONS(2189),
    [anon_sym_string] = ACTIONS(2189),
    [anon_sym_symbol] = ACTIONS(2189),
    [anon_sym_object] = ACTIONS(2189),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_satisfies] = ACTIONS(2191),
    [anon_sym_interface] = ACTIONS(2189),
    [anon_sym_enum] = ACTIONS(2189),
    [sym__automatic_semicolon] = ACTIONS(2277),
    [sym__ternary_qmark] = ACTIONS(2195),
    [sym_html_comment] = ACTIONS(5),
  },
  [353] = {
    [sym_comment] = STATE(353),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2131),
    [anon_sym_default] = ACTIONS(2129),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_as] = ACTIONS(2131),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2129),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_in] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_case] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2129),
    [anon_sym_LTtemplate_GT] = ACTIONS(2129),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_DOT] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_QMARK_DOT] = ACTIONS(2131),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_using] = ACTIONS(2129),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_GT_GT] = ACTIONS(2131),
    [anon_sym_GT_GT_GT] = ACTIONS(2131),
    [anon_sym_LT_LT] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_LT_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2131),
    [anon_sym_GT_EQ] = ACTIONS(2131),
    [anon_sym_QMARK_QMARK] = ACTIONS(2131),
    [anon_sym_instanceof] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_number] = ACTIONS(2129),
    [sym_private_property_identifier] = ACTIONS(2129),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_object] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_satisfies] = ACTIONS(2131),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
    [sym__automatic_semicolon] = ACTIONS(2279),
    [sym__ternary_qmark] = ACTIONS(2135),
    [sym_html_comment] = ACTIONS(5),
  },
  [354] = {
    [sym_comment] = STATE(354),
    [sym_identifier] = ACTIONS(2137),
    [anon_sym_export] = ACTIONS(2137),
    [anon_sym_STAR] = ACTIONS(2139),
    [anon_sym_default] = ACTIONS(2137),
    [anon_sym_type] = ACTIONS(2137),
    [anon_sym_as] = ACTIONS(2139),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_COMMA] = ACTIONS(2139),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_typeof] = ACTIONS(2137),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_with] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2137),
    [anon_sym_let] = ACTIONS(2137),
    [anon_sym_const] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2137),
    [anon_sym_if] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2137),
    [anon_sym_for] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2137),
    [anon_sym_await] = ACTIONS(2137),
    [anon_sym_in] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2137),
    [anon_sym_do] = ACTIONS(2137),
    [anon_sym_try] = ACTIONS(2137),
    [anon_sym_break] = ACTIONS(2137),
    [anon_sym_continue] = ACTIONS(2137),
    [anon_sym_debugger] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2137),
    [anon_sym_throw] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym_case] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_LTtemplate_GT] = ACTIONS(2137),
    [anon_sym_GT] = ACTIONS(2139),
    [anon_sym_DOT] = ACTIONS(2139),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_SQUOTE] = ACTIONS(2137),
    [anon_sym_class] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(2137),
    [anon_sym_QMARK_DOT] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2137),
    [anon_sym_using] = ACTIONS(2137),
    [anon_sym_AMP_AMP] = ACTIONS(2139),
    [anon_sym_PIPE_PIPE] = ACTIONS(2139),
    [anon_sym_GT_GT] = ACTIONS(2139),
    [anon_sym_GT_GT_GT] = ACTIONS(2139),
    [anon_sym_LT_LT] = ACTIONS(2139),
    [anon_sym_AMP] = ACTIONS(2139),
    [anon_sym_CARET] = ACTIONS(2139),
    [anon_sym_PIPE] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(2137),
    [anon_sym_PERCENT] = ACTIONS(2139),
    [anon_sym_STAR_STAR] = ACTIONS(2139),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_LT_EQ] = ACTIONS(2139),
    [anon_sym_EQ_EQ] = ACTIONS(2139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2139),
    [anon_sym_BANG_EQ] = ACTIONS(2139),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2139),
    [anon_sym_GT_EQ] = ACTIONS(2139),
    [anon_sym_QMARK_QMARK] = ACTIONS(2139),
    [anon_sym_instanceof] = ACTIONS(2139),
    [anon_sym_TILDE] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2137),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [sym_number] = ACTIONS(2137),
    [sym_private_property_identifier] = ACTIONS(2137),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(2137),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(2137),
    [anon_sym_static] = ACTIONS(2137),
    [anon_sym_readonly] = ACTIONS(2137),
    [anon_sym_get] = ACTIONS(2137),
    [anon_sym_set] = ACTIONS(2137),
    [anon_sym_declare] = ACTIONS(2137),
    [anon_sym_public] = ACTIONS(2137),
    [anon_sym_private] = ACTIONS(2137),
    [anon_sym_protected] = ACTIONS(2137),
    [anon_sym_override] = ACTIONS(2137),
    [anon_sym_module] = ACTIONS(2137),
    [anon_sym_any] = ACTIONS(2137),
    [anon_sym_number] = ACTIONS(2137),
    [anon_sym_boolean] = ACTIONS(2137),
    [anon_sym_string] = ACTIONS(2137),
    [anon_sym_symbol] = ACTIONS(2137),
    [anon_sym_object] = ACTIONS(2137),
    [anon_sym_abstract] = ACTIONS(2137),
    [anon_sym_satisfies] = ACTIONS(2139),
    [anon_sym_interface] = ACTIONS(2137),
    [anon_sym_enum] = ACTIONS(2137),
    [sym__automatic_semicolon] = ACTIONS(2281),
    [sym__ternary_qmark] = ACTIONS(2143),
    [sym_html_comment] = ACTIONS(5),
  },
  [355] = {
    [sym_import] = STATE(4107),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(355),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2283),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [356] = {
    [sym_comment] = STATE(356),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_export] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2105),
    [anon_sym_default] = ACTIONS(2103),
    [anon_sym_type] = ACTIONS(2103),
    [anon_sym_as] = ACTIONS(2105),
    [anon_sym_namespace] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_typeof] = ACTIONS(2103),
    [anon_sym_import] = ACTIONS(2103),
    [anon_sym_with] = ACTIONS(2103),
    [anon_sym_var] = ACTIONS(2103),
    [anon_sym_let] = ACTIONS(2103),
    [anon_sym_const] = ACTIONS(2103),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_switch] = ACTIONS(2103),
    [anon_sym_for] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_await] = ACTIONS(2103),
    [anon_sym_in] = ACTIONS(2105),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_try] = ACTIONS(2103),
    [anon_sym_break] = ACTIONS(2103),
    [anon_sym_continue] = ACTIONS(2103),
    [anon_sym_debugger] = ACTIONS(2103),
    [anon_sym_return] = ACTIONS(2103),
    [anon_sym_throw] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_case] = ACTIONS(2103),
    [anon_sym_yield] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LTtemplate_GT] = ACTIONS(2103),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2103),
    [anon_sym_SQUOTE] = ACTIONS(2103),
    [anon_sym_class] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(2103),
    [anon_sym_QMARK_DOT] = ACTIONS(2105),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_using] = ACTIONS(2103),
    [anon_sym_AMP_AMP] = ACTIONS(2105),
    [anon_sym_PIPE_PIPE] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2105),
    [anon_sym_GT_GT_GT] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_PERCENT] = ACTIONS(2105),
    [anon_sym_STAR_STAR] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(2105),
    [anon_sym_QMARK_QMARK] = ACTIONS(2105),
    [anon_sym_instanceof] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2103),
    [anon_sym_void] = ACTIONS(2103),
    [anon_sym_delete] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2103),
    [sym_number] = ACTIONS(2103),
    [sym_private_property_identifier] = ACTIONS(2103),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_undefined] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2103),
    [anon_sym_static] = ACTIONS(2103),
    [anon_sym_readonly] = ACTIONS(2103),
    [anon_sym_get] = ACTIONS(2103),
    [anon_sym_set] = ACTIONS(2103),
    [anon_sym_declare] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2103),
    [anon_sym_private] = ACTIONS(2103),
    [anon_sym_protected] = ACTIONS(2103),
    [anon_sym_override] = ACTIONS(2103),
    [anon_sym_module] = ACTIONS(2103),
    [anon_sym_any] = ACTIONS(2103),
    [anon_sym_number] = ACTIONS(2103),
    [anon_sym_boolean] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_symbol] = ACTIONS(2103),
    [anon_sym_object] = ACTIONS(2103),
    [anon_sym_abstract] = ACTIONS(2103),
    [anon_sym_satisfies] = ACTIONS(2105),
    [anon_sym_interface] = ACTIONS(2103),
    [anon_sym_enum] = ACTIONS(2103),
    [sym__automatic_semicolon] = ACTIONS(2285),
    [sym__ternary_qmark] = ACTIONS(2109),
    [sym_html_comment] = ACTIONS(5),
  },
  [357] = {
    [sym_comment] = STATE(357),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_export] = ACTIONS(2183),
    [anon_sym_STAR] = ACTIONS(2183),
    [anon_sym_type] = ACTIONS(2183),
    [anon_sym_as] = ACTIONS(2183),
    [anon_sym_namespace] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_typeof] = ACTIONS(2183),
    [anon_sym_import] = ACTIONS(2183),
    [anon_sym_with] = ACTIONS(2183),
    [anon_sym_var] = ACTIONS(2183),
    [anon_sym_let] = ACTIONS(2183),
    [anon_sym_const] = ACTIONS(2183),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_else] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2183),
    [anon_sym_for] = ACTIONS(2183),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2183),
    [anon_sym_in] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(2183),
    [anon_sym_do] = ACTIONS(2183),
    [anon_sym_try] = ACTIONS(2183),
    [anon_sym_break] = ACTIONS(2183),
    [anon_sym_continue] = ACTIONS(2183),
    [anon_sym_debugger] = ACTIONS(2183),
    [anon_sym_return] = ACTIONS(2183),
    [anon_sym_throw] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2183),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [anon_sym_class] = ACTIONS(2183),
    [anon_sym_async] = ACTIONS(2183),
    [anon_sym_function] = ACTIONS(2183),
    [anon_sym_QMARK_DOT] = ACTIONS(2183),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_using] = ACTIONS(2183),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE_PIPE] = ACTIONS(2183),
    [anon_sym_GT_GT] = ACTIONS(2183),
    [anon_sym_GT_GT_GT] = ACTIONS(2183),
    [anon_sym_LT_LT] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_PERCENT] = ACTIONS(2183),
    [anon_sym_STAR_STAR] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2183),
    [anon_sym_QMARK_QMARK] = ACTIONS(2183),
    [anon_sym_instanceof] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2183),
    [anon_sym_delete] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2183),
    [sym_private_property_identifier] = ACTIONS(2183),
    [sym_this] = ACTIONS(2183),
    [sym_super] = ACTIONS(2183),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_undefined] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2183),
    [anon_sym_readonly] = ACTIONS(2183),
    [anon_sym_get] = ACTIONS(2183),
    [anon_sym_set] = ACTIONS(2183),
    [anon_sym_declare] = ACTIONS(2183),
    [anon_sym_public] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2183),
    [anon_sym_protected] = ACTIONS(2183),
    [anon_sym_override] = ACTIONS(2183),
    [anon_sym_module] = ACTIONS(2183),
    [anon_sym_any] = ACTIONS(2183),
    [anon_sym_number] = ACTIONS(2183),
    [anon_sym_boolean] = ACTIONS(2183),
    [anon_sym_string] = ACTIONS(2183),
    [anon_sym_symbol] = ACTIONS(2183),
    [anon_sym_object] = ACTIONS(2183),
    [anon_sym_abstract] = ACTIONS(2183),
    [anon_sym_satisfies] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2183),
    [anon_sym_enum] = ACTIONS(2183),
    [sym__automatic_semicolon] = ACTIONS(2185),
    [sym__ternary_qmark] = ACTIONS(2185),
    [sym_html_comment] = ACTIONS(5),
  },
  [358] = {
    [sym_comment] = STATE(358),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_as] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2111),
    [anon_sym_DOT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_QMARK_DOT] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_AMP_AMP] = ACTIONS(2111),
    [anon_sym_PIPE_PIPE] = ACTIONS(2111),
    [anon_sym_GT_GT] = ACTIONS(2111),
    [anon_sym_GT_GT_GT] = ACTIONS(2111),
    [anon_sym_LT_LT] = ACTIONS(2111),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_CARET] = ACTIONS(2111),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_PERCENT] = ACTIONS(2111),
    [anon_sym_STAR_STAR] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_QMARK_QMARK] = ACTIONS(2111),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_satisfies] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2115),
    [sym__ternary_qmark] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [359] = {
    [sym_import] = STATE(4290),
    [sym_expression_statement] = STATE(464),
    [sym_empty_statement] = STATE(464),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6755),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(359),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [360] = {
    [sym_comment] = STATE(360),
    [ts_builtin_sym_end] = ACTIONS(2287),
    [sym_identifier] = ACTIONS(2137),
    [anon_sym_export] = ACTIONS(2137),
    [anon_sym_STAR] = ACTIONS(2139),
    [anon_sym_type] = ACTIONS(2137),
    [anon_sym_as] = ACTIONS(2139),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_COMMA] = ACTIONS(2139),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_typeof] = ACTIONS(2137),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_with] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2137),
    [anon_sym_let] = ACTIONS(2137),
    [anon_sym_const] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2137),
    [anon_sym_else] = ACTIONS(2137),
    [anon_sym_if] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2137),
    [anon_sym_for] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2137),
    [anon_sym_await] = ACTIONS(2137),
    [anon_sym_in] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2137),
    [anon_sym_do] = ACTIONS(2137),
    [anon_sym_try] = ACTIONS(2137),
    [anon_sym_break] = ACTIONS(2137),
    [anon_sym_continue] = ACTIONS(2137),
    [anon_sym_debugger] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2137),
    [anon_sym_throw] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_LTtemplate_GT] = ACTIONS(2137),
    [anon_sym_GT] = ACTIONS(2139),
    [anon_sym_DOT] = ACTIONS(2139),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_SQUOTE] = ACTIONS(2137),
    [anon_sym_class] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(2137),
    [anon_sym_QMARK_DOT] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2137),
    [anon_sym_using] = ACTIONS(2137),
    [anon_sym_AMP_AMP] = ACTIONS(2139),
    [anon_sym_PIPE_PIPE] = ACTIONS(2139),
    [anon_sym_GT_GT] = ACTIONS(2139),
    [anon_sym_GT_GT_GT] = ACTIONS(2139),
    [anon_sym_LT_LT] = ACTIONS(2139),
    [anon_sym_AMP] = ACTIONS(2139),
    [anon_sym_CARET] = ACTIONS(2139),
    [anon_sym_PIPE] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(2137),
    [anon_sym_PERCENT] = ACTIONS(2139),
    [anon_sym_STAR_STAR] = ACTIONS(2139),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_LT_EQ] = ACTIONS(2139),
    [anon_sym_EQ_EQ] = ACTIONS(2139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2139),
    [anon_sym_BANG_EQ] = ACTIONS(2139),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2139),
    [anon_sym_GT_EQ] = ACTIONS(2139),
    [anon_sym_QMARK_QMARK] = ACTIONS(2139),
    [anon_sym_instanceof] = ACTIONS(2139),
    [anon_sym_TILDE] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2137),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [sym_number] = ACTIONS(2137),
    [sym_private_property_identifier] = ACTIONS(2137),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(2137),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(2137),
    [anon_sym_static] = ACTIONS(2137),
    [anon_sym_readonly] = ACTIONS(2137),
    [anon_sym_get] = ACTIONS(2137),
    [anon_sym_set] = ACTIONS(2137),
    [anon_sym_declare] = ACTIONS(2137),
    [anon_sym_public] = ACTIONS(2137),
    [anon_sym_private] = ACTIONS(2137),
    [anon_sym_protected] = ACTIONS(2137),
    [anon_sym_override] = ACTIONS(2137),
    [anon_sym_module] = ACTIONS(2137),
    [anon_sym_any] = ACTIONS(2137),
    [anon_sym_number] = ACTIONS(2137),
    [anon_sym_boolean] = ACTIONS(2137),
    [anon_sym_string] = ACTIONS(2137),
    [anon_sym_symbol] = ACTIONS(2137),
    [anon_sym_object] = ACTIONS(2137),
    [anon_sym_abstract] = ACTIONS(2137),
    [anon_sym_satisfies] = ACTIONS(2139),
    [anon_sym_interface] = ACTIONS(2137),
    [anon_sym_enum] = ACTIONS(2137),
    [sym__automatic_semicolon] = ACTIONS(2289),
    [sym__ternary_qmark] = ACTIONS(2143),
    [sym_html_comment] = ACTIONS(5),
  },
  [361] = {
    [sym_comment] = STATE(361),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_as] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_COMMA] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_in] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_GT] = ACTIONS(2125),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_QMARK_DOT] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_GT] = ACTIONS(2125),
    [anon_sym_GT_GT_GT] = ACTIONS(2125),
    [anon_sym_LT_LT] = ACTIONS(2125),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2125),
    [anon_sym_PIPE] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_PERCENT] = ACTIONS(2125),
    [anon_sym_STAR_STAR] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2125),
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_QMARK_QMARK] = ACTIONS(2125),
    [anon_sym_instanceof] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_satisfies] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym__automatic_semicolon] = ACTIONS(2127),
    [sym__ternary_qmark] = ACTIONS(2127),
    [sym_html_comment] = ACTIONS(5),
  },
  [362] = {
    [sym_comment] = STATE(362),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_as] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2111),
    [anon_sym_DOT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_QMARK_DOT] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_AMP_AMP] = ACTIONS(2111),
    [anon_sym_PIPE_PIPE] = ACTIONS(2111),
    [anon_sym_GT_GT] = ACTIONS(2111),
    [anon_sym_GT_GT_GT] = ACTIONS(2111),
    [anon_sym_LT_LT] = ACTIONS(2111),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_CARET] = ACTIONS(2111),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_PERCENT] = ACTIONS(2111),
    [anon_sym_STAR_STAR] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_QMARK_QMARK] = ACTIONS(2111),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_satisfies] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2291),
    [sym__ternary_qmark] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [363] = {
    [sym_comment] = STATE(363),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_as] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_DOT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_QMARK_DOT] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(2145),
    [anon_sym_GT_GT_GT] = ACTIONS(2145),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_STAR_STAR] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_QMARK_QMARK] = ACTIONS(2145),
    [anon_sym_instanceof] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_satisfies] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym__automatic_semicolon] = ACTIONS(2147),
    [sym__ternary_qmark] = ACTIONS(2147),
    [sym_html_comment] = ACTIONS(5),
  },
  [364] = {
    [sym_comment] = STATE(364),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_COMMA] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(2067),
    [anon_sym_DOT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_QMARK_DOT] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2067),
    [anon_sym_PIPE_PIPE] = ACTIONS(2067),
    [anon_sym_GT_GT] = ACTIONS(2067),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_AMP] = ACTIONS(2067),
    [anon_sym_CARET] = ACTIONS(2067),
    [anon_sym_PIPE] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_STAR_STAR] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_LT_EQ] = ACTIONS(2067),
    [anon_sym_EQ_EQ] = ACTIONS(2067),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2067),
    [anon_sym_GT_EQ] = ACTIONS(2067),
    [anon_sym_QMARK_QMARK] = ACTIONS(2067),
    [anon_sym_instanceof] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_satisfies] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2293),
    [sym__ternary_qmark] = ACTIONS(2095),
    [sym_html_comment] = ACTIONS(5),
  },
  [365] = {
    [sym_import] = STATE(4242),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3003),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(365),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2295),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [366] = {
    [sym_comment] = STATE(366),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_export] = ACTIONS(2183),
    [anon_sym_STAR] = ACTIONS(2183),
    [anon_sym_default] = ACTIONS(2183),
    [anon_sym_type] = ACTIONS(2183),
    [anon_sym_as] = ACTIONS(2183),
    [anon_sym_namespace] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_typeof] = ACTIONS(2183),
    [anon_sym_import] = ACTIONS(2183),
    [anon_sym_with] = ACTIONS(2183),
    [anon_sym_var] = ACTIONS(2183),
    [anon_sym_let] = ACTIONS(2183),
    [anon_sym_const] = ACTIONS(2183),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2183),
    [anon_sym_for] = ACTIONS(2183),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2183),
    [anon_sym_in] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(2183),
    [anon_sym_do] = ACTIONS(2183),
    [anon_sym_try] = ACTIONS(2183),
    [anon_sym_break] = ACTIONS(2183),
    [anon_sym_continue] = ACTIONS(2183),
    [anon_sym_debugger] = ACTIONS(2183),
    [anon_sym_return] = ACTIONS(2183),
    [anon_sym_throw] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_case] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2183),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [anon_sym_class] = ACTIONS(2183),
    [anon_sym_async] = ACTIONS(2183),
    [anon_sym_function] = ACTIONS(2183),
    [anon_sym_QMARK_DOT] = ACTIONS(2183),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_using] = ACTIONS(2183),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE_PIPE] = ACTIONS(2183),
    [anon_sym_GT_GT] = ACTIONS(2183),
    [anon_sym_GT_GT_GT] = ACTIONS(2183),
    [anon_sym_LT_LT] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_PERCENT] = ACTIONS(2183),
    [anon_sym_STAR_STAR] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2183),
    [anon_sym_QMARK_QMARK] = ACTIONS(2183),
    [anon_sym_instanceof] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2183),
    [anon_sym_delete] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2183),
    [sym_private_property_identifier] = ACTIONS(2183),
    [sym_this] = ACTIONS(2183),
    [sym_super] = ACTIONS(2183),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_undefined] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2183),
    [anon_sym_readonly] = ACTIONS(2183),
    [anon_sym_get] = ACTIONS(2183),
    [anon_sym_set] = ACTIONS(2183),
    [anon_sym_declare] = ACTIONS(2183),
    [anon_sym_public] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2183),
    [anon_sym_protected] = ACTIONS(2183),
    [anon_sym_override] = ACTIONS(2183),
    [anon_sym_module] = ACTIONS(2183),
    [anon_sym_any] = ACTIONS(2183),
    [anon_sym_number] = ACTIONS(2183),
    [anon_sym_boolean] = ACTIONS(2183),
    [anon_sym_string] = ACTIONS(2183),
    [anon_sym_symbol] = ACTIONS(2183),
    [anon_sym_object] = ACTIONS(2183),
    [anon_sym_abstract] = ACTIONS(2183),
    [anon_sym_satisfies] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2183),
    [anon_sym_enum] = ACTIONS(2183),
    [sym__automatic_semicolon] = ACTIONS(2185),
    [sym__ternary_qmark] = ACTIONS(2185),
    [sym_html_comment] = ACTIONS(5),
  },
  [367] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(367),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5081),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_override_modifier] = STATE(436),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(2297),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2299),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [368] = {
    [sym_comment] = STATE(368),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(2227),
    [anon_sym_default] = ACTIONS(2225),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_as] = ACTIONS(2227),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2225),
    [anon_sym_COMMA] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_in] = ACTIONS(2227),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_case] = ACTIONS(2225),
    [anon_sym_yield] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2225),
    [anon_sym_LTtemplate_GT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2227),
    [anon_sym_DOT] = ACTIONS(2227),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_SQUOTE] = ACTIONS(2225),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_function] = ACTIONS(2225),
    [anon_sym_QMARK_DOT] = ACTIONS(2227),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_using] = ACTIONS(2225),
    [anon_sym_AMP_AMP] = ACTIONS(2227),
    [anon_sym_PIPE_PIPE] = ACTIONS(2227),
    [anon_sym_GT_GT] = ACTIONS(2227),
    [anon_sym_GT_GT_GT] = ACTIONS(2227),
    [anon_sym_LT_LT] = ACTIONS(2227),
    [anon_sym_AMP] = ACTIONS(2227),
    [anon_sym_CARET] = ACTIONS(2227),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2227),
    [anon_sym_STAR_STAR] = ACTIONS(2227),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_LT_EQ] = ACTIONS(2227),
    [anon_sym_EQ_EQ] = ACTIONS(2227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2227),
    [anon_sym_BANG_EQ] = ACTIONS(2227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2227),
    [anon_sym_GT_EQ] = ACTIONS(2227),
    [anon_sym_QMARK_QMARK] = ACTIONS(2227),
    [anon_sym_instanceof] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2225),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(2225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [sym_number] = ACTIONS(2225),
    [sym_private_property_identifier] = ACTIONS(2225),
    [sym_this] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [sym_false] = ACTIONS(2225),
    [sym_null] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2225),
    [anon_sym_static] = ACTIONS(2225),
    [anon_sym_readonly] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_override] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_object] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_satisfies] = ACTIONS(2227),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
    [sym__automatic_semicolon] = ACTIONS(2301),
    [sym__ternary_qmark] = ACTIONS(2231),
    [sym_html_comment] = ACTIONS(5),
  },
  [369] = {
    [sym_import] = STATE(4290),
    [sym_expression_statement] = STATE(465),
    [sym_empty_statement] = STATE(465),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6755),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(369),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [370] = {
    [sym_import] = STATE(4242),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2874),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(370),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2303),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [371] = {
    [sym_statement_block] = STATE(452),
    [sym_comment] = STATE(371),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [372] = {
    [sym_statement_block] = STATE(452),
    [sym_comment] = STATE(372),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2309),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [373] = {
    [sym_statement_block] = STATE(452),
    [sym_comment] = STATE(373),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_as] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_in] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_QMARK_DOT] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_AMP_AMP] = ACTIONS(2057),
    [anon_sym_PIPE_PIPE] = ACTIONS(2057),
    [anon_sym_GT_GT] = ACTIONS(2057),
    [anon_sym_GT_GT_GT] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_STAR_STAR] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_LT_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2057),
    [anon_sym_GT_EQ] = ACTIONS(2057),
    [anon_sym_QMARK_QMARK] = ACTIONS(2057),
    [anon_sym_instanceof] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_satisfies] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym__automatic_semicolon] = ACTIONS(2061),
    [sym__ternary_qmark] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [374] = {
    [sym_comment] = STATE(374),
    [ts_builtin_sym_end] = ACTIONS(2253),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2251),
    [anon_sym_in] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_LTtemplate_GT] = ACTIONS(2251),
    [anon_sym_GT] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_function] = ACTIONS(2251),
    [anon_sym_QMARK_DOT] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_AMP_AMP] = ACTIONS(2251),
    [anon_sym_PIPE_PIPE] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_GT_GT_GT] = ACTIONS(2251),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [anon_sym_PERCENT] = ACTIONS(2251),
    [anon_sym_STAR_STAR] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_LT_EQ] = ACTIONS(2251),
    [anon_sym_EQ_EQ] = ACTIONS(2251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2251),
    [anon_sym_BANG_EQ] = ACTIONS(2251),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2251),
    [anon_sym_GT_EQ] = ACTIONS(2251),
    [anon_sym_QMARK_QMARK] = ACTIONS(2251),
    [anon_sym_instanceof] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2251),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_number] = ACTIONS(2251),
    [sym_private_property_identifier] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [sym_null] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_readonly] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_override] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_object] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_satisfies] = ACTIONS(2251),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [sym__automatic_semicolon] = ACTIONS(2253),
    [sym__ternary_qmark] = ACTIONS(2253),
    [sym_html_comment] = ACTIONS(5),
  },
  [375] = {
    [sym_comment] = STATE(375),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_default] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_as] = ACTIONS(2085),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2085),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_in] = ACTIONS(2085),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_case] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_LTtemplate_GT] = ACTIONS(2083),
    [anon_sym_GT] = ACTIONS(2085),
    [anon_sym_DOT] = ACTIONS(2085),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2083),
    [anon_sym_QMARK_DOT] = ACTIONS(2085),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_using] = ACTIONS(2083),
    [anon_sym_AMP_AMP] = ACTIONS(2085),
    [anon_sym_PIPE_PIPE] = ACTIONS(2085),
    [anon_sym_GT_GT] = ACTIONS(2085),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2085),
    [anon_sym_CARET] = ACTIONS(2085),
    [anon_sym_PIPE] = ACTIONS(2085),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_STAR_STAR] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_EQ_EQ] = ACTIONS(2085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG_EQ] = ACTIONS(2085),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_QMARK_QMARK] = ACTIONS(2085),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2083),
    [sym_number] = ACTIONS(2083),
    [sym_private_property_identifier] = ACTIONS(2083),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2083),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_readonly] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_override] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_object] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_satisfies] = ACTIONS(2085),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [sym__automatic_semicolon] = ACTIONS(2311),
    [sym__ternary_qmark] = ACTIONS(2089),
    [sym_html_comment] = ACTIONS(5),
  },
  [376] = {
    [sym_comment] = STATE(376),
    [ts_builtin_sym_end] = ACTIONS(2313),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2131),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_as] = ACTIONS(2131),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_else] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2129),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_in] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2129),
    [anon_sym_LTtemplate_GT] = ACTIONS(2129),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_DOT] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_QMARK_DOT] = ACTIONS(2131),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_using] = ACTIONS(2129),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_GT_GT] = ACTIONS(2131),
    [anon_sym_GT_GT_GT] = ACTIONS(2131),
    [anon_sym_LT_LT] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_LT_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2131),
    [anon_sym_GT_EQ] = ACTIONS(2131),
    [anon_sym_QMARK_QMARK] = ACTIONS(2131),
    [anon_sym_instanceof] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_number] = ACTIONS(2129),
    [sym_private_property_identifier] = ACTIONS(2129),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_object] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_satisfies] = ACTIONS(2131),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
    [sym__automatic_semicolon] = ACTIONS(2315),
    [sym__ternary_qmark] = ACTIONS(2135),
    [sym_html_comment] = ACTIONS(5),
  },
  [377] = {
    [sym_import] = STATE(4242),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3209),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(377),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [378] = {
    [sym_comment] = STATE(378),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2069),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_EQ] = ACTIONS(2071),
    [anon_sym_as] = ACTIONS(2069),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_COMMA] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(2069),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(2069),
    [anon_sym_DOT] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_QMARK_DOT] = ACTIONS(2069),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2069),
    [anon_sym_PIPE_PIPE] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2069),
    [anon_sym_GT_GT_GT] = ACTIONS(2069),
    [anon_sym_LT_LT] = ACTIONS(2069),
    [anon_sym_AMP] = ACTIONS(2069),
    [anon_sym_CARET] = ACTIONS(2069),
    [anon_sym_PIPE] = ACTIONS(2069),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_PERCENT] = ACTIONS(2069),
    [anon_sym_STAR_STAR] = ACTIONS(2069),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_LT_EQ] = ACTIONS(2069),
    [anon_sym_EQ_EQ] = ACTIONS(2069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2069),
    [anon_sym_GT_EQ] = ACTIONS(2069),
    [anon_sym_QMARK_QMARK] = ACTIONS(2069),
    [anon_sym_instanceof] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_satisfies] = ACTIONS(2069),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2319),
    [sym__ternary_qmark] = ACTIONS(2075),
    [sym_html_comment] = ACTIONS(5),
  },
  [379] = {
    [sym_import] = STATE(4107),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2617),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(379),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [380] = {
    [sym_import] = STATE(4242),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3209),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(380),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2323),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [381] = {
    [sym_comment] = STATE(381),
    [ts_builtin_sym_end] = ACTIONS(2127),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_as] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_COMMA] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_in] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_GT] = ACTIONS(2125),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_QMARK_DOT] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_GT] = ACTIONS(2125),
    [anon_sym_GT_GT_GT] = ACTIONS(2125),
    [anon_sym_LT_LT] = ACTIONS(2125),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2125),
    [anon_sym_PIPE] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_PERCENT] = ACTIONS(2125),
    [anon_sym_STAR_STAR] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2125),
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_QMARK_QMARK] = ACTIONS(2125),
    [anon_sym_instanceof] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_satisfies] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym__automatic_semicolon] = ACTIONS(2127),
    [sym__ternary_qmark] = ACTIONS(2127),
    [sym_html_comment] = ACTIONS(5),
  },
  [382] = {
    [sym_comment] = STATE(382),
    [ts_builtin_sym_end] = ACTIONS(2325),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(2227),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_as] = ACTIONS(2227),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2225),
    [anon_sym_COMMA] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_else] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_in] = ACTIONS(2227),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_yield] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2225),
    [anon_sym_LTtemplate_GT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2227),
    [anon_sym_DOT] = ACTIONS(2227),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_SQUOTE] = ACTIONS(2225),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_function] = ACTIONS(2225),
    [anon_sym_QMARK_DOT] = ACTIONS(2227),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_using] = ACTIONS(2225),
    [anon_sym_AMP_AMP] = ACTIONS(2227),
    [anon_sym_PIPE_PIPE] = ACTIONS(2227),
    [anon_sym_GT_GT] = ACTIONS(2227),
    [anon_sym_GT_GT_GT] = ACTIONS(2227),
    [anon_sym_LT_LT] = ACTIONS(2227),
    [anon_sym_AMP] = ACTIONS(2227),
    [anon_sym_CARET] = ACTIONS(2227),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2227),
    [anon_sym_STAR_STAR] = ACTIONS(2227),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_LT_EQ] = ACTIONS(2227),
    [anon_sym_EQ_EQ] = ACTIONS(2227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2227),
    [anon_sym_BANG_EQ] = ACTIONS(2227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2227),
    [anon_sym_GT_EQ] = ACTIONS(2227),
    [anon_sym_QMARK_QMARK] = ACTIONS(2227),
    [anon_sym_instanceof] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2225),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(2225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [sym_number] = ACTIONS(2225),
    [sym_private_property_identifier] = ACTIONS(2225),
    [sym_this] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [sym_false] = ACTIONS(2225),
    [sym_null] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2225),
    [anon_sym_static] = ACTIONS(2225),
    [anon_sym_readonly] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_override] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_object] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_satisfies] = ACTIONS(2227),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
    [sym__automatic_semicolon] = ACTIONS(2327),
    [sym__ternary_qmark] = ACTIONS(2231),
    [sym_html_comment] = ACTIONS(5),
  },
  [383] = {
    [sym_comment] = STATE(383),
    [ts_builtin_sym_end] = ACTIONS(2329),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_export] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2243),
    [anon_sym_type] = ACTIONS(2241),
    [anon_sym_as] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_typeof] = ACTIONS(2241),
    [anon_sym_import] = ACTIONS(2241),
    [anon_sym_with] = ACTIONS(2241),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_const] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_else] = ACTIONS(2241),
    [anon_sym_if] = ACTIONS(2241),
    [anon_sym_switch] = ACTIONS(2241),
    [anon_sym_for] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_await] = ACTIONS(2241),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2241),
    [anon_sym_do] = ACTIONS(2241),
    [anon_sym_try] = ACTIONS(2241),
    [anon_sym_break] = ACTIONS(2241),
    [anon_sym_continue] = ACTIONS(2241),
    [anon_sym_debugger] = ACTIONS(2241),
    [anon_sym_return] = ACTIONS(2241),
    [anon_sym_throw] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_yield] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_LTtemplate_GT] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2243),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_class] = ACTIONS(2241),
    [anon_sym_async] = ACTIONS(2241),
    [anon_sym_function] = ACTIONS(2241),
    [anon_sym_QMARK_DOT] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2241),
    [anon_sym_using] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_GT_GT] = ACTIONS(2243),
    [anon_sym_GT_GT_GT] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2243),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_CARET] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [anon_sym_PERCENT] = ACTIONS(2243),
    [anon_sym_STAR_STAR] = ACTIONS(2243),
    [anon_sym_LT] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2243),
    [anon_sym_GT_EQ] = ACTIONS(2243),
    [anon_sym_QMARK_QMARK] = ACTIONS(2243),
    [anon_sym_instanceof] = ACTIONS(2243),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_void] = ACTIONS(2241),
    [anon_sym_delete] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2241),
    [sym_number] = ACTIONS(2241),
    [sym_private_property_identifier] = ACTIONS(2241),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(2241),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(2241),
    [anon_sym_static] = ACTIONS(2241),
    [anon_sym_readonly] = ACTIONS(2241),
    [anon_sym_get] = ACTIONS(2241),
    [anon_sym_set] = ACTIONS(2241),
    [anon_sym_declare] = ACTIONS(2241),
    [anon_sym_public] = ACTIONS(2241),
    [anon_sym_private] = ACTIONS(2241),
    [anon_sym_protected] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_module] = ACTIONS(2241),
    [anon_sym_any] = ACTIONS(2241),
    [anon_sym_number] = ACTIONS(2241),
    [anon_sym_boolean] = ACTIONS(2241),
    [anon_sym_string] = ACTIONS(2241),
    [anon_sym_symbol] = ACTIONS(2241),
    [anon_sym_object] = ACTIONS(2241),
    [anon_sym_abstract] = ACTIONS(2241),
    [anon_sym_satisfies] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2241),
    [anon_sym_enum] = ACTIONS(2241),
    [sym__automatic_semicolon] = ACTIONS(2331),
    [sym__ternary_qmark] = ACTIONS(2247),
    [sym_html_comment] = ACTIONS(5),
  },
  [384] = {
    [sym_comment] = STATE(384),
    [ts_builtin_sym_end] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2163),
    [anon_sym_export] = ACTIONS(2163),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_type] = ACTIONS(2163),
    [anon_sym_as] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2163),
    [anon_sym_COMMA] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2163),
    [anon_sym_import] = ACTIONS(2163),
    [anon_sym_with] = ACTIONS(2163),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2163),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_debugger] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_yield] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_LTtemplate_GT] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2163),
    [anon_sym_DOT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2163),
    [anon_sym_SQUOTE] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_async] = ACTIONS(2163),
    [anon_sym_function] = ACTIONS(2163),
    [anon_sym_QMARK_DOT] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_GT_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2163),
    [anon_sym_PIPE] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_SLASH] = ACTIONS(2163),
    [anon_sym_PERCENT] = ACTIONS(2163),
    [anon_sym_STAR_STAR] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_LT_EQ] = ACTIONS(2163),
    [anon_sym_EQ_EQ] = ACTIONS(2163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2163),
    [anon_sym_BANG_EQ] = ACTIONS(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2163),
    [anon_sym_GT_EQ] = ACTIONS(2163),
    [anon_sym_QMARK_QMARK] = ACTIONS(2163),
    [anon_sym_instanceof] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [anon_sym_void] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_PLUS_PLUS] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2163),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2163),
    [sym_number] = ACTIONS(2163),
    [sym_private_property_identifier] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(2163),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_readonly] = ACTIONS(2163),
    [anon_sym_get] = ACTIONS(2163),
    [anon_sym_set] = ACTIONS(2163),
    [anon_sym_declare] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_override] = ACTIONS(2163),
    [anon_sym_module] = ACTIONS(2163),
    [anon_sym_any] = ACTIONS(2163),
    [anon_sym_number] = ACTIONS(2163),
    [anon_sym_boolean] = ACTIONS(2163),
    [anon_sym_string] = ACTIONS(2163),
    [anon_sym_symbol] = ACTIONS(2163),
    [anon_sym_object] = ACTIONS(2163),
    [anon_sym_abstract] = ACTIONS(2163),
    [anon_sym_satisfies] = ACTIONS(2163),
    [anon_sym_interface] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [sym__automatic_semicolon] = ACTIONS(2165),
    [sym__ternary_qmark] = ACTIONS(2165),
    [sym_html_comment] = ACTIONS(5),
  },
  [385] = {
    [sym_comment] = STATE(385),
    [ts_builtin_sym_end] = ACTIONS(2177),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_namespace] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2175),
    [anon_sym_import] = ACTIONS(2175),
    [anon_sym_with] = ACTIONS(2175),
    [anon_sym_var] = ACTIONS(2175),
    [anon_sym_let] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_else] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_switch] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_await] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_do] = ACTIONS(2175),
    [anon_sym_try] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_debugger] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [anon_sym_LTtemplate_GT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_class] = ACTIONS(2175),
    [anon_sym_async] = ACTIONS(2175),
    [anon_sym_function] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_new] = ACTIONS(2175),
    [anon_sym_using] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_STAR_STAR] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_QMARK_QMARK] = ACTIONS(2175),
    [anon_sym_instanceof] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_void] = ACTIONS(2175),
    [anon_sym_delete] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_number] = ACTIONS(2175),
    [sym_private_property_identifier] = ACTIONS(2175),
    [sym_this] = ACTIONS(2175),
    [sym_super] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2175),
    [anon_sym_static] = ACTIONS(2175),
    [anon_sym_readonly] = ACTIONS(2175),
    [anon_sym_get] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(2175),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_public] = ACTIONS(2175),
    [anon_sym_private] = ACTIONS(2175),
    [anon_sym_protected] = ACTIONS(2175),
    [anon_sym_override] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2175),
    [anon_sym_any] = ACTIONS(2175),
    [anon_sym_number] = ACTIONS(2175),
    [anon_sym_boolean] = ACTIONS(2175),
    [anon_sym_string] = ACTIONS(2175),
    [anon_sym_symbol] = ACTIONS(2175),
    [anon_sym_object] = ACTIONS(2175),
    [anon_sym_abstract] = ACTIONS(2175),
    [anon_sym_satisfies] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [sym__automatic_semicolon] = ACTIONS(2177),
    [sym__ternary_qmark] = ACTIONS(2177),
    [sym_html_comment] = ACTIONS(5),
  },
  [386] = {
    [sym_comment] = STATE(386),
    [sym_identifier] = ACTIONS(2255),
    [anon_sym_export] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_default] = ACTIONS(2255),
    [anon_sym_type] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2255),
    [anon_sym_COMMA] = ACTIONS(2257),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_typeof] = ACTIONS(2255),
    [anon_sym_import] = ACTIONS(2255),
    [anon_sym_with] = ACTIONS(2255),
    [anon_sym_var] = ACTIONS(2255),
    [anon_sym_let] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_await] = ACTIONS(2255),
    [anon_sym_in] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_debugger] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2255),
    [anon_sym_case] = ACTIONS(2255),
    [anon_sym_yield] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_LTtemplate_GT] = ACTIONS(2255),
    [anon_sym_GT] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(2255),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_async] = ACTIONS(2255),
    [anon_sym_function] = ACTIONS(2255),
    [anon_sym_QMARK_DOT] = ACTIONS(2257),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_PIPE_PIPE] = ACTIONS(2257),
    [anon_sym_GT_GT] = ACTIONS(2257),
    [anon_sym_GT_GT_GT] = ACTIONS(2257),
    [anon_sym_LT_LT] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(2257),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2257),
    [anon_sym_STAR_STAR] = ACTIONS(2257),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2257),
    [anon_sym_EQ_EQ] = ACTIONS(2257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2257),
    [anon_sym_BANG_EQ] = ACTIONS(2257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2257),
    [anon_sym_GT_EQ] = ACTIONS(2257),
    [anon_sym_QMARK_QMARK] = ACTIONS(2257),
    [anon_sym_instanceof] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2255),
    [anon_sym_void] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [sym_number] = ACTIONS(2255),
    [sym_private_property_identifier] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [sym_super] = ACTIONS(2255),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [sym_null] = ACTIONS(2255),
    [sym_undefined] = ACTIONS(2255),
    [anon_sym_AT] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_readonly] = ACTIONS(2255),
    [anon_sym_get] = ACTIONS(2255),
    [anon_sym_set] = ACTIONS(2255),
    [anon_sym_declare] = ACTIONS(2255),
    [anon_sym_public] = ACTIONS(2255),
    [anon_sym_private] = ACTIONS(2255),
    [anon_sym_protected] = ACTIONS(2255),
    [anon_sym_override] = ACTIONS(2255),
    [anon_sym_module] = ACTIONS(2255),
    [anon_sym_any] = ACTIONS(2255),
    [anon_sym_number] = ACTIONS(2255),
    [anon_sym_boolean] = ACTIONS(2255),
    [anon_sym_string] = ACTIONS(2255),
    [anon_sym_symbol] = ACTIONS(2255),
    [anon_sym_object] = ACTIONS(2255),
    [anon_sym_abstract] = ACTIONS(2255),
    [anon_sym_satisfies] = ACTIONS(2257),
    [anon_sym_interface] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [sym__automatic_semicolon] = ACTIONS(2333),
    [sym__ternary_qmark] = ACTIONS(2261),
    [sym_html_comment] = ACTIONS(5),
  },
  [387] = {
    [sym_comment] = STATE(387),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_export] = ACTIONS(2213),
    [anon_sym_STAR] = ACTIONS(2215),
    [anon_sym_default] = ACTIONS(2213),
    [anon_sym_type] = ACTIONS(2213),
    [anon_sym_as] = ACTIONS(2215),
    [anon_sym_namespace] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_COMMA] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_typeof] = ACTIONS(2213),
    [anon_sym_import] = ACTIONS(2213),
    [anon_sym_with] = ACTIONS(2213),
    [anon_sym_var] = ACTIONS(2213),
    [anon_sym_let] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_for] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_await] = ACTIONS(2213),
    [anon_sym_in] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_do] = ACTIONS(2213),
    [anon_sym_try] = ACTIONS(2213),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_debugger] = ACTIONS(2213),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_throw] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_case] = ACTIONS(2213),
    [anon_sym_yield] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2213),
    [anon_sym_LTtemplate_GT] = ACTIONS(2213),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_DOT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_class] = ACTIONS(2213),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2213),
    [anon_sym_QMARK_DOT] = ACTIONS(2215),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_using] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_GT_GT_GT] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_PERCENT] = ACTIONS(2215),
    [anon_sym_STAR_STAR] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_LT_EQ] = ACTIONS(2215),
    [anon_sym_EQ_EQ] = ACTIONS(2215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2215),
    [anon_sym_BANG_EQ] = ACTIONS(2215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2215),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_QMARK_QMARK] = ACTIONS(2215),
    [anon_sym_instanceof] = ACTIONS(2215),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_void] = ACTIONS(2213),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_number] = ACTIONS(2213),
    [sym_private_property_identifier] = ACTIONS(2213),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(2213),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2213),
    [anon_sym_static] = ACTIONS(2213),
    [anon_sym_readonly] = ACTIONS(2213),
    [anon_sym_get] = ACTIONS(2213),
    [anon_sym_set] = ACTIONS(2213),
    [anon_sym_declare] = ACTIONS(2213),
    [anon_sym_public] = ACTIONS(2213),
    [anon_sym_private] = ACTIONS(2213),
    [anon_sym_protected] = ACTIONS(2213),
    [anon_sym_override] = ACTIONS(2213),
    [anon_sym_module] = ACTIONS(2213),
    [anon_sym_any] = ACTIONS(2213),
    [anon_sym_number] = ACTIONS(2213),
    [anon_sym_boolean] = ACTIONS(2213),
    [anon_sym_string] = ACTIONS(2213),
    [anon_sym_symbol] = ACTIONS(2213),
    [anon_sym_object] = ACTIONS(2213),
    [anon_sym_abstract] = ACTIONS(2213),
    [anon_sym_satisfies] = ACTIONS(2215),
    [anon_sym_interface] = ACTIONS(2213),
    [anon_sym_enum] = ACTIONS(2213),
    [sym__automatic_semicolon] = ACTIONS(2335),
    [sym__ternary_qmark] = ACTIONS(2219),
    [sym_html_comment] = ACTIONS(5),
  },
  [388] = {
    [sym_import] = STATE(4088),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2437),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(388),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(2337),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [389] = {
    [sym_comment] = STATE(389),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_as] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2111),
    [anon_sym_DOT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_QMARK_DOT] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_AMP_AMP] = ACTIONS(2111),
    [anon_sym_PIPE_PIPE] = ACTIONS(2111),
    [anon_sym_GT_GT] = ACTIONS(2111),
    [anon_sym_GT_GT_GT] = ACTIONS(2111),
    [anon_sym_LT_LT] = ACTIONS(2111),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_CARET] = ACTIONS(2111),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_PERCENT] = ACTIONS(2111),
    [anon_sym_STAR_STAR] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_QMARK_QMARK] = ACTIONS(2111),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_satisfies] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2115),
    [sym__ternary_qmark] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [390] = {
    [sym_import] = STATE(4102),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(390),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym__type_query_member_expression] = STATE(3665),
    [sym__type_query_subscript_expression] = STATE(3648),
    [sym__type_query_call_expression] = STATE(3904),
    [sym__type_query_instantiation_expression] = STATE(4006),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2339),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [391] = {
    [sym_comment] = STATE(391),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_export] = ACTIONS(2189),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_default] = ACTIONS(2189),
    [anon_sym_type] = ACTIONS(2189),
    [anon_sym_as] = ACTIONS(2191),
    [anon_sym_namespace] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_import] = ACTIONS(2189),
    [anon_sym_with] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2189),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_in] = ACTIONS(2191),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_debugger] = ACTIONS(2189),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_case] = ACTIONS(2189),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2189),
    [anon_sym_LTtemplate_GT] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2191),
    [anon_sym_DOT] = ACTIONS(2191),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_class] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_function] = ACTIONS(2189),
    [anon_sym_QMARK_DOT] = ACTIONS(2191),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_using] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2191),
    [anon_sym_GT_GT] = ACTIONS(2191),
    [anon_sym_GT_GT_GT] = ACTIONS(2191),
    [anon_sym_LT_LT] = ACTIONS(2191),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2191),
    [anon_sym_PIPE] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_PERCENT] = ACTIONS(2191),
    [anon_sym_STAR_STAR] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_LT_EQ] = ACTIONS(2191),
    [anon_sym_EQ_EQ] = ACTIONS(2191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2191),
    [anon_sym_BANG_EQ] = ACTIONS(2191),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2191),
    [anon_sym_GT_EQ] = ACTIONS(2191),
    [anon_sym_QMARK_QMARK] = ACTIONS(2191),
    [anon_sym_instanceof] = ACTIONS(2191),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_void] = ACTIONS(2189),
    [anon_sym_delete] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2189),
    [sym_number] = ACTIONS(2189),
    [sym_private_property_identifier] = ACTIONS(2189),
    [sym_this] = ACTIONS(2189),
    [sym_super] = ACTIONS(2189),
    [sym_true] = ACTIONS(2189),
    [sym_false] = ACTIONS(2189),
    [sym_null] = ACTIONS(2189),
    [sym_undefined] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_declare] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_module] = ACTIONS(2189),
    [anon_sym_any] = ACTIONS(2189),
    [anon_sym_number] = ACTIONS(2189),
    [anon_sym_boolean] = ACTIONS(2189),
    [anon_sym_string] = ACTIONS(2189),
    [anon_sym_symbol] = ACTIONS(2189),
    [anon_sym_object] = ACTIONS(2189),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_satisfies] = ACTIONS(2191),
    [anon_sym_interface] = ACTIONS(2189),
    [anon_sym_enum] = ACTIONS(2189),
    [sym__automatic_semicolon] = ACTIONS(2341),
    [sym__ternary_qmark] = ACTIONS(2195),
    [sym_html_comment] = ACTIONS(5),
  },
  [392] = {
    [sym_import] = STATE(4290),
    [sym_expression_statement] = STATE(466),
    [sym_empty_statement] = STATE(466),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6755),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(392),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [393] = {
    [sym_comment] = STATE(393),
    [ts_builtin_sym_end] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_export] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2199),
    [anon_sym_type] = ACTIONS(2197),
    [anon_sym_as] = ACTIONS(2199),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_import] = ACTIONS(2197),
    [anon_sym_with] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_debugger] = ACTIONS(2197),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_LTtemplate_GT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_DOT] = ACTIONS(2199),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_function] = ACTIONS(2197),
    [anon_sym_QMARK_DOT] = ACTIONS(2199),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_AMP_AMP] = ACTIONS(2199),
    [anon_sym_PIPE_PIPE] = ACTIONS(2199),
    [anon_sym_GT_GT] = ACTIONS(2199),
    [anon_sym_GT_GT_GT] = ACTIONS(2199),
    [anon_sym_LT_LT] = ACTIONS(2199),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_PIPE] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2199),
    [anon_sym_STAR_STAR] = ACTIONS(2199),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_EQ_EQ] = ACTIONS(2199),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2199),
    [anon_sym_BANG_EQ] = ACTIONS(2199),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2199),
    [anon_sym_QMARK_QMARK] = ACTIONS(2199),
    [anon_sym_instanceof] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2197),
    [sym_number] = ACTIONS(2197),
    [sym_private_property_identifier] = ACTIONS(2197),
    [sym_this] = ACTIONS(2197),
    [sym_super] = ACTIONS(2197),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [sym_null] = ACTIONS(2197),
    [sym_undefined] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_declare] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_module] = ACTIONS(2197),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_boolean] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_object] = ACTIONS(2197),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_satisfies] = ACTIONS(2199),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [sym__automatic_semicolon] = ACTIONS(2345),
    [sym__ternary_qmark] = ACTIONS(2203),
    [sym_html_comment] = ACTIONS(5),
  },
  [394] = {
    [sym_comment] = STATE(394),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_as] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2111),
    [anon_sym_DOT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_QMARK_DOT] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_AMP_AMP] = ACTIONS(2111),
    [anon_sym_PIPE_PIPE] = ACTIONS(2111),
    [anon_sym_GT_GT] = ACTIONS(2111),
    [anon_sym_GT_GT_GT] = ACTIONS(2111),
    [anon_sym_LT_LT] = ACTIONS(2111),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_CARET] = ACTIONS(2111),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_PERCENT] = ACTIONS(2111),
    [anon_sym_STAR_STAR] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_QMARK_QMARK] = ACTIONS(2111),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_satisfies] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2347),
    [sym__ternary_qmark] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [395] = {
    [sym_comment] = STATE(395),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_COMMA] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(2067),
    [anon_sym_DOT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_QMARK_DOT] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2067),
    [anon_sym_PIPE_PIPE] = ACTIONS(2067),
    [anon_sym_GT_GT] = ACTIONS(2067),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_AMP] = ACTIONS(2067),
    [anon_sym_CARET] = ACTIONS(2067),
    [anon_sym_PIPE] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_STAR_STAR] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_LT_EQ] = ACTIONS(2067),
    [anon_sym_EQ_EQ] = ACTIONS(2067),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2067),
    [anon_sym_GT_EQ] = ACTIONS(2067),
    [anon_sym_QMARK_QMARK] = ACTIONS(2067),
    [anon_sym_instanceof] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_satisfies] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2349),
    [sym__ternary_qmark] = ACTIONS(2095),
    [sym_html_comment] = ACTIONS(5),
  },
  [396] = {
    [sym_import] = STATE(4290),
    [sym_expression_statement] = STATE(462),
    [sym_empty_statement] = STATE(462),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6755),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(396),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [397] = {
    [sym_comment] = STATE(397),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_as] = ACTIONS(2151),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_else] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_in] = ACTIONS(2151),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_GT] = ACTIONS(2151),
    [anon_sym_DOT] = ACTIONS(2151),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_QMARK_DOT] = ACTIONS(2151),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2151),
    [anon_sym_GT_GT_GT] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_STAR_STAR] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_EQ] = ACTIONS(2151),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2151),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_QMARK_QMARK] = ACTIONS(2151),
    [anon_sym_instanceof] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_satisfies] = ACTIONS(2151),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym__automatic_semicolon] = ACTIONS(2153),
    [sym__ternary_qmark] = ACTIONS(2153),
    [sym_html_comment] = ACTIONS(5),
  },
  [398] = {
    [sym_comment] = STATE(398),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_default] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_namespace] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2175),
    [anon_sym_import] = ACTIONS(2175),
    [anon_sym_with] = ACTIONS(2175),
    [anon_sym_var] = ACTIONS(2175),
    [anon_sym_let] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_switch] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_await] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_do] = ACTIONS(2175),
    [anon_sym_try] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_debugger] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_case] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [anon_sym_LTtemplate_GT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_class] = ACTIONS(2175),
    [anon_sym_async] = ACTIONS(2175),
    [anon_sym_function] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_new] = ACTIONS(2175),
    [anon_sym_using] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_STAR_STAR] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_QMARK_QMARK] = ACTIONS(2175),
    [anon_sym_instanceof] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_void] = ACTIONS(2175),
    [anon_sym_delete] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_number] = ACTIONS(2175),
    [sym_private_property_identifier] = ACTIONS(2175),
    [sym_this] = ACTIONS(2175),
    [sym_super] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2175),
    [anon_sym_static] = ACTIONS(2175),
    [anon_sym_readonly] = ACTIONS(2175),
    [anon_sym_get] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(2175),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_public] = ACTIONS(2175),
    [anon_sym_private] = ACTIONS(2175),
    [anon_sym_protected] = ACTIONS(2175),
    [anon_sym_override] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2175),
    [anon_sym_any] = ACTIONS(2175),
    [anon_sym_number] = ACTIONS(2175),
    [anon_sym_boolean] = ACTIONS(2175),
    [anon_sym_string] = ACTIONS(2175),
    [anon_sym_symbol] = ACTIONS(2175),
    [anon_sym_object] = ACTIONS(2175),
    [anon_sym_abstract] = ACTIONS(2175),
    [anon_sym_satisfies] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [sym__automatic_semicolon] = ACTIONS(2177),
    [sym__ternary_qmark] = ACTIONS(2177),
    [sym_html_comment] = ACTIONS(5),
  },
  [399] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(399),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(4896),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_override_modifier] = STATE(455),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1087),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2353),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [400] = {
    [sym_import] = STATE(4107),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(400),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2355),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [401] = {
    [sym_comment] = STATE(401),
    [ts_builtin_sym_end] = ACTIONS(2357),
    [sym_identifier] = ACTIONS(2255),
    [anon_sym_export] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_type] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2255),
    [anon_sym_COMMA] = ACTIONS(2257),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_typeof] = ACTIONS(2255),
    [anon_sym_import] = ACTIONS(2255),
    [anon_sym_with] = ACTIONS(2255),
    [anon_sym_var] = ACTIONS(2255),
    [anon_sym_let] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_else] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_await] = ACTIONS(2255),
    [anon_sym_in] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_debugger] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2255),
    [anon_sym_yield] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_LTtemplate_GT] = ACTIONS(2255),
    [anon_sym_GT] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(2255),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_async] = ACTIONS(2255),
    [anon_sym_function] = ACTIONS(2255),
    [anon_sym_QMARK_DOT] = ACTIONS(2257),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_PIPE_PIPE] = ACTIONS(2257),
    [anon_sym_GT_GT] = ACTIONS(2257),
    [anon_sym_GT_GT_GT] = ACTIONS(2257),
    [anon_sym_LT_LT] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(2257),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2257),
    [anon_sym_STAR_STAR] = ACTIONS(2257),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2257),
    [anon_sym_EQ_EQ] = ACTIONS(2257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2257),
    [anon_sym_BANG_EQ] = ACTIONS(2257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2257),
    [anon_sym_GT_EQ] = ACTIONS(2257),
    [anon_sym_QMARK_QMARK] = ACTIONS(2257),
    [anon_sym_instanceof] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2255),
    [anon_sym_void] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [sym_number] = ACTIONS(2255),
    [sym_private_property_identifier] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [sym_super] = ACTIONS(2255),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [sym_null] = ACTIONS(2255),
    [sym_undefined] = ACTIONS(2255),
    [anon_sym_AT] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_readonly] = ACTIONS(2255),
    [anon_sym_get] = ACTIONS(2255),
    [anon_sym_set] = ACTIONS(2255),
    [anon_sym_declare] = ACTIONS(2255),
    [anon_sym_public] = ACTIONS(2255),
    [anon_sym_private] = ACTIONS(2255),
    [anon_sym_protected] = ACTIONS(2255),
    [anon_sym_override] = ACTIONS(2255),
    [anon_sym_module] = ACTIONS(2255),
    [anon_sym_any] = ACTIONS(2255),
    [anon_sym_number] = ACTIONS(2255),
    [anon_sym_boolean] = ACTIONS(2255),
    [anon_sym_string] = ACTIONS(2255),
    [anon_sym_symbol] = ACTIONS(2255),
    [anon_sym_object] = ACTIONS(2255),
    [anon_sym_abstract] = ACTIONS(2255),
    [anon_sym_satisfies] = ACTIONS(2257),
    [anon_sym_interface] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [sym__automatic_semicolon] = ACTIONS(2359),
    [sym__ternary_qmark] = ACTIONS(2261),
    [sym_html_comment] = ACTIONS(5),
  },
  [402] = {
    [sym_import] = STATE(4132),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3123),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(402),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2361),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [403] = {
    [sym_import] = STATE(4107),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(403),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2363),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [404] = {
    [sym_import] = STATE(4290),
    [sym_expression_statement] = STATE(463),
    [sym_empty_statement] = STATE(463),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6755),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(404),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [405] = {
    [sym_comment] = STATE(405),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_as] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_in] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_QMARK_DOT] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_PIPE_PIPE] = ACTIONS(2221),
    [anon_sym_GT_GT] = ACTIONS(2221),
    [anon_sym_GT_GT_GT] = ACTIONS(2221),
    [anon_sym_LT_LT] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_PERCENT] = ACTIONS(2221),
    [anon_sym_STAR_STAR] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2221),
    [anon_sym_QMARK_QMARK] = ACTIONS(2221),
    [anon_sym_instanceof] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_satisfies] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [sym__ternary_qmark] = ACTIONS(2223),
    [sym_html_comment] = ACTIONS(5),
  },
  [406] = {
    [sym_comment] = STATE(406),
    [ts_builtin_sym_end] = ACTIONS(2365),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_as] = ACTIONS(2085),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2085),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_else] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_in] = ACTIONS(2085),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_LTtemplate_GT] = ACTIONS(2083),
    [anon_sym_GT] = ACTIONS(2085),
    [anon_sym_DOT] = ACTIONS(2085),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2083),
    [anon_sym_QMARK_DOT] = ACTIONS(2085),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_using] = ACTIONS(2083),
    [anon_sym_AMP_AMP] = ACTIONS(2085),
    [anon_sym_PIPE_PIPE] = ACTIONS(2085),
    [anon_sym_GT_GT] = ACTIONS(2085),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2085),
    [anon_sym_CARET] = ACTIONS(2085),
    [anon_sym_PIPE] = ACTIONS(2085),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_STAR_STAR] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_EQ_EQ] = ACTIONS(2085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG_EQ] = ACTIONS(2085),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_QMARK_QMARK] = ACTIONS(2085),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2083),
    [sym_number] = ACTIONS(2083),
    [sym_private_property_identifier] = ACTIONS(2083),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2083),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_readonly] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_override] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_object] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_satisfies] = ACTIONS(2085),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [sym__automatic_semicolon] = ACTIONS(2367),
    [sym__ternary_qmark] = ACTIONS(2089),
    [sym_html_comment] = ACTIONS(5),
  },
  [407] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2630),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_spread_element] = STATE(7385),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7385),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(407),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_RBRACE] = ACTIONS(2369),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [408] = {
    [sym_comment] = STATE(408),
    [sym_identifier] = ACTIONS(2163),
    [anon_sym_export] = ACTIONS(2163),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_default] = ACTIONS(2163),
    [anon_sym_type] = ACTIONS(2163),
    [anon_sym_as] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2163),
    [anon_sym_COMMA] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2163),
    [anon_sym_import] = ACTIONS(2163),
    [anon_sym_with] = ACTIONS(2163),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2163),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_debugger] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_case] = ACTIONS(2163),
    [anon_sym_yield] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_LTtemplate_GT] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2163),
    [anon_sym_DOT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2163),
    [anon_sym_SQUOTE] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_async] = ACTIONS(2163),
    [anon_sym_function] = ACTIONS(2163),
    [anon_sym_QMARK_DOT] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_GT_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2163),
    [anon_sym_PIPE] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_SLASH] = ACTIONS(2163),
    [anon_sym_PERCENT] = ACTIONS(2163),
    [anon_sym_STAR_STAR] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_LT_EQ] = ACTIONS(2163),
    [anon_sym_EQ_EQ] = ACTIONS(2163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2163),
    [anon_sym_BANG_EQ] = ACTIONS(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2163),
    [anon_sym_GT_EQ] = ACTIONS(2163),
    [anon_sym_QMARK_QMARK] = ACTIONS(2163),
    [anon_sym_instanceof] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [anon_sym_void] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_PLUS_PLUS] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2163),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2163),
    [sym_number] = ACTIONS(2163),
    [sym_private_property_identifier] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(2163),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_readonly] = ACTIONS(2163),
    [anon_sym_get] = ACTIONS(2163),
    [anon_sym_set] = ACTIONS(2163),
    [anon_sym_declare] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_override] = ACTIONS(2163),
    [anon_sym_module] = ACTIONS(2163),
    [anon_sym_any] = ACTIONS(2163),
    [anon_sym_number] = ACTIONS(2163),
    [anon_sym_boolean] = ACTIONS(2163),
    [anon_sym_string] = ACTIONS(2163),
    [anon_sym_symbol] = ACTIONS(2163),
    [anon_sym_object] = ACTIONS(2163),
    [anon_sym_abstract] = ACTIONS(2163),
    [anon_sym_satisfies] = ACTIONS(2163),
    [anon_sym_interface] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [sym__automatic_semicolon] = ACTIONS(2165),
    [sym__ternary_qmark] = ACTIONS(2165),
    [sym_html_comment] = ACTIONS(5),
  },
  [409] = {
    [sym_comment] = STATE(409),
    [ts_builtin_sym_end] = ACTIONS(2373),
    [sym_identifier] = ACTIONS(2167),
    [anon_sym_export] = ACTIONS(2167),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_type] = ACTIONS(2167),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2167),
    [anon_sym_with] = ACTIONS(2167),
    [anon_sym_var] = ACTIONS(2167),
    [anon_sym_let] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_debugger] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_yield] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LTtemplate_GT] = ACTIONS(2167),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_async] = ACTIONS(2167),
    [anon_sym_function] = ACTIONS(2167),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_STAR_STAR] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2167),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_QMARK_QMARK] = ACTIONS(2169),
    [anon_sym_instanceof] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_void] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [sym_number] = ACTIONS(2167),
    [sym_private_property_identifier] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [sym_super] = ACTIONS(2167),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_undefined] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_readonly] = ACTIONS(2167),
    [anon_sym_get] = ACTIONS(2167),
    [anon_sym_set] = ACTIONS(2167),
    [anon_sym_declare] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_override] = ACTIONS(2167),
    [anon_sym_module] = ACTIONS(2167),
    [anon_sym_any] = ACTIONS(2167),
    [anon_sym_number] = ACTIONS(2167),
    [anon_sym_boolean] = ACTIONS(2167),
    [anon_sym_string] = ACTIONS(2167),
    [anon_sym_symbol] = ACTIONS(2167),
    [anon_sym_object] = ACTIONS(2167),
    [anon_sym_abstract] = ACTIONS(2167),
    [anon_sym_satisfies] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [sym__automatic_semicolon] = ACTIONS(2375),
    [sym__ternary_qmark] = ACTIONS(2173),
    [sym_html_comment] = ACTIONS(5),
  },
  [410] = {
    [sym_comment] = STATE(410),
    [ts_builtin_sym_end] = ACTIONS(2239),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_export] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_type] = ACTIONS(2237),
    [anon_sym_as] = ACTIONS(2237),
    [anon_sym_namespace] = ACTIONS(2237),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_COMMA] = ACTIONS(2237),
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_typeof] = ACTIONS(2237),
    [anon_sym_import] = ACTIONS(2237),
    [anon_sym_with] = ACTIONS(2237),
    [anon_sym_var] = ACTIONS(2237),
    [anon_sym_let] = ACTIONS(2237),
    [anon_sym_const] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_else] = ACTIONS(2237),
    [anon_sym_if] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_for] = ACTIONS(2237),
    [anon_sym_LPAREN] = ACTIONS(2237),
    [anon_sym_await] = ACTIONS(2237),
    [anon_sym_in] = ACTIONS(2237),
    [anon_sym_while] = ACTIONS(2237),
    [anon_sym_do] = ACTIONS(2237),
    [anon_sym_try] = ACTIONS(2237),
    [anon_sym_break] = ACTIONS(2237),
    [anon_sym_continue] = ACTIONS(2237),
    [anon_sym_debugger] = ACTIONS(2237),
    [anon_sym_return] = ACTIONS(2237),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2237),
    [anon_sym_yield] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2237),
    [anon_sym_LTtemplate_GT] = ACTIONS(2237),
    [anon_sym_GT] = ACTIONS(2237),
    [anon_sym_DOT] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_class] = ACTIONS(2237),
    [anon_sym_async] = ACTIONS(2237),
    [anon_sym_function] = ACTIONS(2237),
    [anon_sym_QMARK_DOT] = ACTIONS(2237),
    [anon_sym_new] = ACTIONS(2237),
    [anon_sym_using] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_PIPE_PIPE] = ACTIONS(2237),
    [anon_sym_GT_GT] = ACTIONS(2237),
    [anon_sym_GT_GT_GT] = ACTIONS(2237),
    [anon_sym_LT_LT] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_PIPE] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_SLASH] = ACTIONS(2237),
    [anon_sym_PERCENT] = ACTIONS(2237),
    [anon_sym_STAR_STAR] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2237),
    [anon_sym_LT_EQ] = ACTIONS(2237),
    [anon_sym_EQ_EQ] = ACTIONS(2237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2237),
    [anon_sym_BANG_EQ] = ACTIONS(2237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2237),
    [anon_sym_GT_EQ] = ACTIONS(2237),
    [anon_sym_QMARK_QMARK] = ACTIONS(2237),
    [anon_sym_instanceof] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_void] = ACTIONS(2237),
    [anon_sym_delete] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2237),
    [sym_number] = ACTIONS(2237),
    [sym_private_property_identifier] = ACTIONS(2237),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2237),
    [anon_sym_static] = ACTIONS(2237),
    [anon_sym_readonly] = ACTIONS(2237),
    [anon_sym_get] = ACTIONS(2237),
    [anon_sym_set] = ACTIONS(2237),
    [anon_sym_declare] = ACTIONS(2237),
    [anon_sym_public] = ACTIONS(2237),
    [anon_sym_private] = ACTIONS(2237),
    [anon_sym_protected] = ACTIONS(2237),
    [anon_sym_override] = ACTIONS(2237),
    [anon_sym_module] = ACTIONS(2237),
    [anon_sym_any] = ACTIONS(2237),
    [anon_sym_number] = ACTIONS(2237),
    [anon_sym_boolean] = ACTIONS(2237),
    [anon_sym_string] = ACTIONS(2237),
    [anon_sym_symbol] = ACTIONS(2237),
    [anon_sym_object] = ACTIONS(2237),
    [anon_sym_abstract] = ACTIONS(2237),
    [anon_sym_satisfies] = ACTIONS(2237),
    [anon_sym_interface] = ACTIONS(2237),
    [anon_sym_enum] = ACTIONS(2237),
    [sym__automatic_semicolon] = ACTIONS(2239),
    [sym__ternary_qmark] = ACTIONS(2239),
    [sym_html_comment] = ACTIONS(5),
  },
  [411] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2657),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_spread_element] = STATE(7002),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7002),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(411),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_RBRACE] = ACTIONS(2377),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [412] = {
    [sym_comment] = STATE(412),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [sym_identifier] = ACTIONS(2233),
    [anon_sym_export] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(2233),
    [anon_sym_as] = ACTIONS(2233),
    [anon_sym_namespace] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_COMMA] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [anon_sym_typeof] = ACTIONS(2233),
    [anon_sym_import] = ACTIONS(2233),
    [anon_sym_with] = ACTIONS(2233),
    [anon_sym_var] = ACTIONS(2233),
    [anon_sym_let] = ACTIONS(2233),
    [anon_sym_const] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_else] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_for] = ACTIONS(2233),
    [anon_sym_LPAREN] = ACTIONS(2233),
    [anon_sym_await] = ACTIONS(2233),
    [anon_sym_in] = ACTIONS(2233),
    [anon_sym_while] = ACTIONS(2233),
    [anon_sym_do] = ACTIONS(2233),
    [anon_sym_try] = ACTIONS(2233),
    [anon_sym_break] = ACTIONS(2233),
    [anon_sym_continue] = ACTIONS(2233),
    [anon_sym_debugger] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2233),
    [anon_sym_throw] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym_yield] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2233),
    [anon_sym_LTtemplate_GT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_class] = ACTIONS(2233),
    [anon_sym_async] = ACTIONS(2233),
    [anon_sym_function] = ACTIONS(2233),
    [anon_sym_QMARK_DOT] = ACTIONS(2233),
    [anon_sym_new] = ACTIONS(2233),
    [anon_sym_using] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_GT_GT_GT] = ACTIONS(2233),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2233),
    [anon_sym_BANG_EQ] = ACTIONS(2233),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2233),
    [anon_sym_QMARK_QMARK] = ACTIONS(2233),
    [anon_sym_instanceof] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_void] = ACTIONS(2233),
    [anon_sym_delete] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2233),
    [sym_number] = ACTIONS(2233),
    [sym_private_property_identifier] = ACTIONS(2233),
    [sym_this] = ACTIONS(2233),
    [sym_super] = ACTIONS(2233),
    [sym_true] = ACTIONS(2233),
    [sym_false] = ACTIONS(2233),
    [sym_null] = ACTIONS(2233),
    [sym_undefined] = ACTIONS(2233),
    [anon_sym_AT] = ACTIONS(2233),
    [anon_sym_static] = ACTIONS(2233),
    [anon_sym_readonly] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2233),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_declare] = ACTIONS(2233),
    [anon_sym_public] = ACTIONS(2233),
    [anon_sym_private] = ACTIONS(2233),
    [anon_sym_protected] = ACTIONS(2233),
    [anon_sym_override] = ACTIONS(2233),
    [anon_sym_module] = ACTIONS(2233),
    [anon_sym_any] = ACTIONS(2233),
    [anon_sym_number] = ACTIONS(2233),
    [anon_sym_boolean] = ACTIONS(2233),
    [anon_sym_string] = ACTIONS(2233),
    [anon_sym_symbol] = ACTIONS(2233),
    [anon_sym_object] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2233),
    [anon_sym_satisfies] = ACTIONS(2233),
    [anon_sym_interface] = ACTIONS(2233),
    [anon_sym_enum] = ACTIONS(2233),
    [sym__automatic_semicolon] = ACTIONS(2235),
    [sym__ternary_qmark] = ACTIONS(2235),
    [sym_html_comment] = ACTIONS(5),
  },
  [413] = {
    [sym_comment] = STATE(413),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_default] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_as] = ACTIONS(2151),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_in] = ACTIONS(2151),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_case] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_GT] = ACTIONS(2151),
    [anon_sym_DOT] = ACTIONS(2151),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_QMARK_DOT] = ACTIONS(2151),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2151),
    [anon_sym_GT_GT_GT] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_STAR_STAR] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_EQ] = ACTIONS(2151),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2151),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_QMARK_QMARK] = ACTIONS(2151),
    [anon_sym_instanceof] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_satisfies] = ACTIONS(2151),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym__automatic_semicolon] = ACTIONS(2153),
    [sym__ternary_qmark] = ACTIONS(2153),
    [sym_html_comment] = ACTIONS(5),
  },
  [414] = {
    [sym_import] = STATE(4169),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2900),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(414),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(2379),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [415] = {
    [sym_comment] = STATE(415),
    [ts_builtin_sym_end] = ACTIONS(2381),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2207),
    [anon_sym_type] = ACTIONS(2205),
    [anon_sym_as] = ACTIONS(2207),
    [anon_sym_namespace] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_COMMA] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_typeof] = ACTIONS(2205),
    [anon_sym_import] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2205),
    [anon_sym_var] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_else] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_await] = ACTIONS(2205),
    [anon_sym_in] = ACTIONS(2207),
    [anon_sym_while] = ACTIONS(2205),
    [anon_sym_do] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2205),
    [anon_sym_break] = ACTIONS(2205),
    [anon_sym_continue] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2205),
    [anon_sym_return] = ACTIONS(2205),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_yield] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_LTtemplate_GT] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_DOT] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_class] = ACTIONS(2205),
    [anon_sym_async] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2205),
    [anon_sym_QMARK_DOT] = ACTIONS(2207),
    [anon_sym_new] = ACTIONS(2205),
    [anon_sym_using] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(2207),
    [anon_sym_GT_GT_GT] = ACTIONS(2207),
    [anon_sym_LT_LT] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
    [anon_sym_CARET] = ACTIONS(2207),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2207),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_EQ] = ACTIONS(2207),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2207),
    [anon_sym_GT_EQ] = ACTIONS(2207),
    [anon_sym_QMARK_QMARK] = ACTIONS(2207),
    [anon_sym_instanceof] = ACTIONS(2207),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_void] = ACTIONS(2205),
    [anon_sym_delete] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_number] = ACTIONS(2205),
    [sym_private_property_identifier] = ACTIONS(2205),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(2205),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [anon_sym_static] = ACTIONS(2205),
    [anon_sym_readonly] = ACTIONS(2205),
    [anon_sym_get] = ACTIONS(2205),
    [anon_sym_set] = ACTIONS(2205),
    [anon_sym_declare] = ACTIONS(2205),
    [anon_sym_public] = ACTIONS(2205),
    [anon_sym_private] = ACTIONS(2205),
    [anon_sym_protected] = ACTIONS(2205),
    [anon_sym_override] = ACTIONS(2205),
    [anon_sym_module] = ACTIONS(2205),
    [anon_sym_any] = ACTIONS(2205),
    [anon_sym_number] = ACTIONS(2205),
    [anon_sym_boolean] = ACTIONS(2205),
    [anon_sym_string] = ACTIONS(2205),
    [anon_sym_symbol] = ACTIONS(2205),
    [anon_sym_object] = ACTIONS(2205),
    [anon_sym_abstract] = ACTIONS(2205),
    [anon_sym_satisfies] = ACTIONS(2207),
    [anon_sym_interface] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2205),
    [sym__automatic_semicolon] = ACTIONS(2383),
    [sym__ternary_qmark] = ACTIONS(2211),
    [sym_html_comment] = ACTIONS(5),
  },
  [416] = {
    [sym_comment] = STATE(416),
    [ts_builtin_sym_end] = ACTIONS(2147),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_as] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_DOT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_QMARK_DOT] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(2145),
    [anon_sym_GT_GT_GT] = ACTIONS(2145),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_STAR_STAR] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_QMARK_QMARK] = ACTIONS(2145),
    [anon_sym_instanceof] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_satisfies] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym__automatic_semicolon] = ACTIONS(2147),
    [sym__ternary_qmark] = ACTIONS(2147),
    [sym_html_comment] = ACTIONS(5),
  },
  [417] = {
    [sym_comment] = STATE(417),
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_export] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2199),
    [anon_sym_default] = ACTIONS(2197),
    [anon_sym_type] = ACTIONS(2197),
    [anon_sym_as] = ACTIONS(2199),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_import] = ACTIONS(2197),
    [anon_sym_with] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_debugger] = ACTIONS(2197),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_case] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_LTtemplate_GT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_DOT] = ACTIONS(2199),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_function] = ACTIONS(2197),
    [anon_sym_QMARK_DOT] = ACTIONS(2199),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_AMP_AMP] = ACTIONS(2199),
    [anon_sym_PIPE_PIPE] = ACTIONS(2199),
    [anon_sym_GT_GT] = ACTIONS(2199),
    [anon_sym_GT_GT_GT] = ACTIONS(2199),
    [anon_sym_LT_LT] = ACTIONS(2199),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_PIPE] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2199),
    [anon_sym_STAR_STAR] = ACTIONS(2199),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_EQ_EQ] = ACTIONS(2199),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2199),
    [anon_sym_BANG_EQ] = ACTIONS(2199),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2199),
    [anon_sym_QMARK_QMARK] = ACTIONS(2199),
    [anon_sym_instanceof] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2197),
    [sym_number] = ACTIONS(2197),
    [sym_private_property_identifier] = ACTIONS(2197),
    [sym_this] = ACTIONS(2197),
    [sym_super] = ACTIONS(2197),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [sym_null] = ACTIONS(2197),
    [sym_undefined] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_declare] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_module] = ACTIONS(2197),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_boolean] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_object] = ACTIONS(2197),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_satisfies] = ACTIONS(2199),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [sym__automatic_semicolon] = ACTIONS(2385),
    [sym__ternary_qmark] = ACTIONS(2203),
    [sym_html_comment] = ACTIONS(5),
  },
  [418] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2764),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_assignment_pattern] = STATE(6802),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4573),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(418),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(6098),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [sym_html_comment] = ACTIONS(5),
  },
  [419] = {
    [sym_comment] = STATE(419),
    [ts_builtin_sym_end] = ACTIONS(2387),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_export] = ACTIONS(2213),
    [anon_sym_STAR] = ACTIONS(2215),
    [anon_sym_type] = ACTIONS(2213),
    [anon_sym_as] = ACTIONS(2215),
    [anon_sym_namespace] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_COMMA] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_typeof] = ACTIONS(2213),
    [anon_sym_import] = ACTIONS(2213),
    [anon_sym_with] = ACTIONS(2213),
    [anon_sym_var] = ACTIONS(2213),
    [anon_sym_let] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_else] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_for] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_await] = ACTIONS(2213),
    [anon_sym_in] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_do] = ACTIONS(2213),
    [anon_sym_try] = ACTIONS(2213),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_debugger] = ACTIONS(2213),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_throw] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_yield] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2213),
    [anon_sym_LTtemplate_GT] = ACTIONS(2213),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_DOT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_class] = ACTIONS(2213),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2213),
    [anon_sym_QMARK_DOT] = ACTIONS(2215),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_using] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_GT_GT_GT] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_PERCENT] = ACTIONS(2215),
    [anon_sym_STAR_STAR] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_LT_EQ] = ACTIONS(2215),
    [anon_sym_EQ_EQ] = ACTIONS(2215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2215),
    [anon_sym_BANG_EQ] = ACTIONS(2215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2215),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_QMARK_QMARK] = ACTIONS(2215),
    [anon_sym_instanceof] = ACTIONS(2215),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_void] = ACTIONS(2213),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_number] = ACTIONS(2213),
    [sym_private_property_identifier] = ACTIONS(2213),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(2213),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2213),
    [anon_sym_static] = ACTIONS(2213),
    [anon_sym_readonly] = ACTIONS(2213),
    [anon_sym_get] = ACTIONS(2213),
    [anon_sym_set] = ACTIONS(2213),
    [anon_sym_declare] = ACTIONS(2213),
    [anon_sym_public] = ACTIONS(2213),
    [anon_sym_private] = ACTIONS(2213),
    [anon_sym_protected] = ACTIONS(2213),
    [anon_sym_override] = ACTIONS(2213),
    [anon_sym_module] = ACTIONS(2213),
    [anon_sym_any] = ACTIONS(2213),
    [anon_sym_number] = ACTIONS(2213),
    [anon_sym_boolean] = ACTIONS(2213),
    [anon_sym_string] = ACTIONS(2213),
    [anon_sym_symbol] = ACTIONS(2213),
    [anon_sym_object] = ACTIONS(2213),
    [anon_sym_abstract] = ACTIONS(2213),
    [anon_sym_satisfies] = ACTIONS(2215),
    [anon_sym_interface] = ACTIONS(2213),
    [anon_sym_enum] = ACTIONS(2213),
    [sym__automatic_semicolon] = ACTIONS(2389),
    [sym__ternary_qmark] = ACTIONS(2219),
    [sym_html_comment] = ACTIONS(5),
  },
  [420] = {
    [sym_comment] = STATE(420),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2207),
    [anon_sym_default] = ACTIONS(2205),
    [anon_sym_type] = ACTIONS(2205),
    [anon_sym_as] = ACTIONS(2207),
    [anon_sym_namespace] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_COMMA] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_typeof] = ACTIONS(2205),
    [anon_sym_import] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2205),
    [anon_sym_var] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_await] = ACTIONS(2205),
    [anon_sym_in] = ACTIONS(2207),
    [anon_sym_while] = ACTIONS(2205),
    [anon_sym_do] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2205),
    [anon_sym_break] = ACTIONS(2205),
    [anon_sym_continue] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2205),
    [anon_sym_return] = ACTIONS(2205),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_case] = ACTIONS(2205),
    [anon_sym_yield] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_LTtemplate_GT] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_DOT] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_class] = ACTIONS(2205),
    [anon_sym_async] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2205),
    [anon_sym_QMARK_DOT] = ACTIONS(2207),
    [anon_sym_new] = ACTIONS(2205),
    [anon_sym_using] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(2207),
    [anon_sym_GT_GT_GT] = ACTIONS(2207),
    [anon_sym_LT_LT] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
    [anon_sym_CARET] = ACTIONS(2207),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2207),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_EQ] = ACTIONS(2207),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2207),
    [anon_sym_GT_EQ] = ACTIONS(2207),
    [anon_sym_QMARK_QMARK] = ACTIONS(2207),
    [anon_sym_instanceof] = ACTIONS(2207),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_void] = ACTIONS(2205),
    [anon_sym_delete] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_number] = ACTIONS(2205),
    [sym_private_property_identifier] = ACTIONS(2205),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(2205),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [anon_sym_static] = ACTIONS(2205),
    [anon_sym_readonly] = ACTIONS(2205),
    [anon_sym_get] = ACTIONS(2205),
    [anon_sym_set] = ACTIONS(2205),
    [anon_sym_declare] = ACTIONS(2205),
    [anon_sym_public] = ACTIONS(2205),
    [anon_sym_private] = ACTIONS(2205),
    [anon_sym_protected] = ACTIONS(2205),
    [anon_sym_override] = ACTIONS(2205),
    [anon_sym_module] = ACTIONS(2205),
    [anon_sym_any] = ACTIONS(2205),
    [anon_sym_number] = ACTIONS(2205),
    [anon_sym_boolean] = ACTIONS(2205),
    [anon_sym_string] = ACTIONS(2205),
    [anon_sym_symbol] = ACTIONS(2205),
    [anon_sym_object] = ACTIONS(2205),
    [anon_sym_abstract] = ACTIONS(2205),
    [anon_sym_satisfies] = ACTIONS(2207),
    [anon_sym_interface] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2205),
    [sym__automatic_semicolon] = ACTIONS(2391),
    [sym__ternary_qmark] = ACTIONS(2211),
    [sym_html_comment] = ACTIONS(5),
  },
  [421] = {
    [sym_import] = STATE(4088),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2563),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(421),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym__type_query_member_expression] = STATE(3599),
    [sym__type_query_subscript_expression] = STATE(3600),
    [sym__type_query_call_expression] = STATE(3656),
    [sym__type_query_instantiation_expression] = STATE(3722),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(2393),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [422] = {
    [sym_comment] = STATE(422),
    [sym_identifier] = ACTIONS(2167),
    [anon_sym_export] = ACTIONS(2167),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2167),
    [anon_sym_type] = ACTIONS(2167),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2167),
    [anon_sym_with] = ACTIONS(2167),
    [anon_sym_var] = ACTIONS(2167),
    [anon_sym_let] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_debugger] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_case] = ACTIONS(2167),
    [anon_sym_yield] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LTtemplate_GT] = ACTIONS(2167),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_async] = ACTIONS(2167),
    [anon_sym_function] = ACTIONS(2167),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_STAR_STAR] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2167),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_QMARK_QMARK] = ACTIONS(2169),
    [anon_sym_instanceof] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_void] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [sym_number] = ACTIONS(2167),
    [sym_private_property_identifier] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [sym_super] = ACTIONS(2167),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_undefined] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_readonly] = ACTIONS(2167),
    [anon_sym_get] = ACTIONS(2167),
    [anon_sym_set] = ACTIONS(2167),
    [anon_sym_declare] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_override] = ACTIONS(2167),
    [anon_sym_module] = ACTIONS(2167),
    [anon_sym_any] = ACTIONS(2167),
    [anon_sym_number] = ACTIONS(2167),
    [anon_sym_boolean] = ACTIONS(2167),
    [anon_sym_string] = ACTIONS(2167),
    [anon_sym_symbol] = ACTIONS(2167),
    [anon_sym_object] = ACTIONS(2167),
    [anon_sym_abstract] = ACTIONS(2167),
    [anon_sym_satisfies] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [sym__automatic_semicolon] = ACTIONS(2395),
    [sym__ternary_qmark] = ACTIONS(2173),
    [sym_html_comment] = ACTIONS(5),
  },
  [423] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2417),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6601),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(423),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2397),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym__automatic_semicolon] = ACTIONS(2399),
    [sym_html_comment] = ACTIONS(5),
  },
  [424] = {
    [sym_comment] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(2253),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_as] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2251),
    [anon_sym_in] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_LTtemplate_GT] = ACTIONS(2251),
    [anon_sym_GT] = ACTIONS(2251),
    [anon_sym_DOT] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_function] = ACTIONS(2251),
    [anon_sym_QMARK_DOT] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_AMP_AMP] = ACTIONS(2251),
    [anon_sym_PIPE_PIPE] = ACTIONS(2251),
    [anon_sym_GT_GT] = ACTIONS(2251),
    [anon_sym_GT_GT_GT] = ACTIONS(2251),
    [anon_sym_LT_LT] = ACTIONS(2251),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PIPE] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [anon_sym_PERCENT] = ACTIONS(2251),
    [anon_sym_STAR_STAR] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_LT_EQ] = ACTIONS(2251),
    [anon_sym_EQ_EQ] = ACTIONS(2251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2251),
    [anon_sym_BANG_EQ] = ACTIONS(2251),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2251),
    [anon_sym_GT_EQ] = ACTIONS(2251),
    [anon_sym_QMARK_QMARK] = ACTIONS(2251),
    [anon_sym_instanceof] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2251),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_number] = ACTIONS(2251),
    [sym_private_property_identifier] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [sym_null] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_readonly] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_override] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_object] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_satisfies] = ACTIONS(2251),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [sym__automatic_semicolon] = ACTIONS(2253),
    [sym__ternary_qmark] = ACTIONS(2253),
    [sym_html_comment] = ACTIONS(5),
  },
  [425] = {
    [sym_comment] = STATE(425),
    [ts_builtin_sym_end] = ACTIONS(2381),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2207),
    [anon_sym_type] = ACTIONS(2205),
    [anon_sym_as] = ACTIONS(2207),
    [anon_sym_namespace] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_COMMA] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_typeof] = ACTIONS(2205),
    [anon_sym_import] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2205),
    [anon_sym_var] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_await] = ACTIONS(2205),
    [anon_sym_in] = ACTIONS(2207),
    [anon_sym_while] = ACTIONS(2205),
    [anon_sym_do] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2205),
    [anon_sym_break] = ACTIONS(2205),
    [anon_sym_continue] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2205),
    [anon_sym_return] = ACTIONS(2205),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_yield] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_LTtemplate_GT] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_DOT] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_class] = ACTIONS(2205),
    [anon_sym_async] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2205),
    [anon_sym_QMARK_DOT] = ACTIONS(2207),
    [anon_sym_new] = ACTIONS(2205),
    [anon_sym_using] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(2207),
    [anon_sym_GT_GT_GT] = ACTIONS(2207),
    [anon_sym_LT_LT] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
    [anon_sym_CARET] = ACTIONS(2207),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2207),
    [anon_sym_STAR_STAR] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_EQ] = ACTIONS(2207),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2207),
    [anon_sym_GT_EQ] = ACTIONS(2207),
    [anon_sym_QMARK_QMARK] = ACTIONS(2207),
    [anon_sym_instanceof] = ACTIONS(2207),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_void] = ACTIONS(2205),
    [anon_sym_delete] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_number] = ACTIONS(2205),
    [sym_private_property_identifier] = ACTIONS(2205),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(2205),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [anon_sym_static] = ACTIONS(2205),
    [anon_sym_readonly] = ACTIONS(2205),
    [anon_sym_get] = ACTIONS(2205),
    [anon_sym_set] = ACTIONS(2205),
    [anon_sym_declare] = ACTIONS(2205),
    [anon_sym_public] = ACTIONS(2205),
    [anon_sym_private] = ACTIONS(2205),
    [anon_sym_protected] = ACTIONS(2205),
    [anon_sym_override] = ACTIONS(2205),
    [anon_sym_module] = ACTIONS(2205),
    [anon_sym_any] = ACTIONS(2205),
    [anon_sym_number] = ACTIONS(2205),
    [anon_sym_boolean] = ACTIONS(2205),
    [anon_sym_string] = ACTIONS(2205),
    [anon_sym_symbol] = ACTIONS(2205),
    [anon_sym_object] = ACTIONS(2205),
    [anon_sym_abstract] = ACTIONS(2205),
    [anon_sym_satisfies] = ACTIONS(2207),
    [anon_sym_interface] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2205),
    [sym__automatic_semicolon] = ACTIONS(2401),
    [sym__ternary_qmark] = ACTIONS(2211),
    [sym_html_comment] = ACTIONS(5),
  },
  [426] = {
    [sym_comment] = STATE(426),
    [sym_identifier] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2403),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_typeof] = ACTIONS(2403),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_let] = ACTIONS(2403),
    [anon_sym_BANG] = ACTIONS(2403),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_RPAREN] = ACTIONS(216),
    [anon_sym_await] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(216),
    [anon_sym_yield] = ACTIONS(2403),
    [anon_sym_LBRACK] = ACTIONS(2403),
    [anon_sym_LTtemplate_GT] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [anon_sym_SQUOTE] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(2403),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2403),
    [anon_sym_using] = ACTIONS(2403),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(2403),
    [anon_sym_DASH] = ACTIONS(2403),
    [anon_sym_SLASH] = ACTIONS(2403),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2403),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(2403),
    [anon_sym_void] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2403),
    [anon_sym_PLUS_PLUS] = ACTIONS(2403),
    [anon_sym_DASH_DASH] = ACTIONS(2403),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [sym_number] = ACTIONS(2403),
    [sym_private_property_identifier] = ACTIONS(2403),
    [sym_this] = ACTIONS(2403),
    [sym_super] = ACTIONS(2403),
    [sym_true] = ACTIONS(2403),
    [sym_false] = ACTIONS(2403),
    [sym_null] = ACTIONS(2403),
    [sym_undefined] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2403),
    [anon_sym_static] = ACTIONS(2403),
    [anon_sym_readonly] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_override] = ACTIONS(2403),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_object] = ACTIONS(2403),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [427] = {
    [sym_comment] = STATE(427),
    [sym_identifier] = ACTIONS(2405),
    [anon_sym_export] = ACTIONS(2405),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2405),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_import] = ACTIONS(2405),
    [anon_sym_let] = ACTIONS(2405),
    [anon_sym_BANG] = ACTIONS(2405),
    [anon_sym_LPAREN] = ACTIONS(2405),
    [anon_sym_RPAREN] = ACTIONS(216),
    [anon_sym_await] = ACTIONS(2405),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(216),
    [anon_sym_yield] = ACTIONS(2405),
    [anon_sym_LBRACK] = ACTIONS(2405),
    [anon_sym_LTtemplate_GT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(2405),
    [anon_sym_class] = ACTIONS(2405),
    [anon_sym_async] = ACTIONS(2405),
    [anon_sym_function] = ACTIONS(2405),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2405),
    [anon_sym_using] = ACTIONS(2405),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(2405),
    [anon_sym_DASH] = ACTIONS(2405),
    [anon_sym_SLASH] = ACTIONS(2405),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(2405),
    [anon_sym_void] = ACTIONS(2405),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_PLUS_PLUS] = ACTIONS(2405),
    [anon_sym_DASH_DASH] = ACTIONS(2405),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [sym_number] = ACTIONS(2405),
    [sym_private_property_identifier] = ACTIONS(2405),
    [sym_this] = ACTIONS(2405),
    [sym_super] = ACTIONS(2405),
    [sym_true] = ACTIONS(2405),
    [sym_false] = ACTIONS(2405),
    [sym_null] = ACTIONS(2405),
    [sym_undefined] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(2405),
    [anon_sym_static] = ACTIONS(2405),
    [anon_sym_readonly] = ACTIONS(2405),
    [anon_sym_get] = ACTIONS(2405),
    [anon_sym_set] = ACTIONS(2405),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(2405),
    [anon_sym_public] = ACTIONS(2405),
    [anon_sym_private] = ACTIONS(2405),
    [anon_sym_protected] = ACTIONS(2405),
    [anon_sym_override] = ACTIONS(2405),
    [anon_sym_module] = ACTIONS(2405),
    [anon_sym_any] = ACTIONS(2405),
    [anon_sym_number] = ACTIONS(2405),
    [anon_sym_boolean] = ACTIONS(2405),
    [anon_sym_string] = ACTIONS(2405),
    [anon_sym_symbol] = ACTIONS(2405),
    [anon_sym_object] = ACTIONS(2405),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [428] = {
    [sym_comment] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(2329),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_export] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2243),
    [anon_sym_type] = ACTIONS(2241),
    [anon_sym_as] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_typeof] = ACTIONS(2241),
    [anon_sym_import] = ACTIONS(2241),
    [anon_sym_with] = ACTIONS(2241),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_const] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_if] = ACTIONS(2241),
    [anon_sym_switch] = ACTIONS(2241),
    [anon_sym_for] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_await] = ACTIONS(2241),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2241),
    [anon_sym_do] = ACTIONS(2241),
    [anon_sym_try] = ACTIONS(2241),
    [anon_sym_break] = ACTIONS(2241),
    [anon_sym_continue] = ACTIONS(2241),
    [anon_sym_debugger] = ACTIONS(2241),
    [anon_sym_return] = ACTIONS(2241),
    [anon_sym_throw] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_yield] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_LTtemplate_GT] = ACTIONS(2241),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2243),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_class] = ACTIONS(2241),
    [anon_sym_async] = ACTIONS(2241),
    [anon_sym_function] = ACTIONS(2241),
    [anon_sym_QMARK_DOT] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2241),
    [anon_sym_using] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_GT_GT] = ACTIONS(2243),
    [anon_sym_GT_GT_GT] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2243),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_CARET] = ACTIONS(2243),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [anon_sym_PERCENT] = ACTIONS(2243),
    [anon_sym_STAR_STAR] = ACTIONS(2243),
    [anon_sym_LT] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2243),
    [anon_sym_GT_EQ] = ACTIONS(2243),
    [anon_sym_QMARK_QMARK] = ACTIONS(2243),
    [anon_sym_instanceof] = ACTIONS(2243),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_void] = ACTIONS(2241),
    [anon_sym_delete] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2241),
    [sym_number] = ACTIONS(2241),
    [sym_private_property_identifier] = ACTIONS(2241),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(2241),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(2241),
    [anon_sym_static] = ACTIONS(2241),
    [anon_sym_readonly] = ACTIONS(2241),
    [anon_sym_get] = ACTIONS(2241),
    [anon_sym_set] = ACTIONS(2241),
    [anon_sym_declare] = ACTIONS(2241),
    [anon_sym_public] = ACTIONS(2241),
    [anon_sym_private] = ACTIONS(2241),
    [anon_sym_protected] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_module] = ACTIONS(2241),
    [anon_sym_any] = ACTIONS(2241),
    [anon_sym_number] = ACTIONS(2241),
    [anon_sym_boolean] = ACTIONS(2241),
    [anon_sym_string] = ACTIONS(2241),
    [anon_sym_symbol] = ACTIONS(2241),
    [anon_sym_object] = ACTIONS(2241),
    [anon_sym_abstract] = ACTIONS(2241),
    [anon_sym_satisfies] = ACTIONS(2243),
    [anon_sym_interface] = ACTIONS(2241),
    [anon_sym_enum] = ACTIONS(2241),
    [sym__automatic_semicolon] = ACTIONS(2407),
    [sym__ternary_qmark] = ACTIONS(2247),
    [sym_html_comment] = ACTIONS(5),
  },
  [429] = {
    [sym_comment] = STATE(429),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_STAR] = ACTIONS(2151),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_as] = ACTIONS(2151),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_in] = ACTIONS(2151),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_GT] = ACTIONS(2151),
    [anon_sym_DOT] = ACTIONS(2151),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_QMARK_DOT] = ACTIONS(2151),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_AMP_AMP] = ACTIONS(2151),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2151),
    [anon_sym_GT_GT_GT] = ACTIONS(2151),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_CARET] = ACTIONS(2151),
    [anon_sym_PIPE] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_PERCENT] = ACTIONS(2151),
    [anon_sym_STAR_STAR] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_LT_EQ] = ACTIONS(2151),
    [anon_sym_EQ_EQ] = ACTIONS(2151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ] = ACTIONS(2151),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2151),
    [anon_sym_GT_EQ] = ACTIONS(2151),
    [anon_sym_QMARK_QMARK] = ACTIONS(2151),
    [anon_sym_instanceof] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_satisfies] = ACTIONS(2151),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym__automatic_semicolon] = ACTIONS(2153),
    [sym__ternary_qmark] = ACTIONS(2153),
    [sym_html_comment] = ACTIONS(5),
  },
  [430] = {
    [sym_comment] = STATE(430),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_as] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2111),
    [anon_sym_DOT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_QMARK_DOT] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_AMP_AMP] = ACTIONS(2111),
    [anon_sym_PIPE_PIPE] = ACTIONS(2111),
    [anon_sym_GT_GT] = ACTIONS(2111),
    [anon_sym_GT_GT_GT] = ACTIONS(2111),
    [anon_sym_LT_LT] = ACTIONS(2111),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_CARET] = ACTIONS(2111),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_PERCENT] = ACTIONS(2111),
    [anon_sym_STAR_STAR] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_QMARK_QMARK] = ACTIONS(2111),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_satisfies] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2115),
    [sym__ternary_qmark] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [431] = {
    [sym_comment] = STATE(431),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_as] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_in] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2111),
    [anon_sym_DOT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_QMARK_DOT] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_AMP_AMP] = ACTIONS(2111),
    [anon_sym_PIPE_PIPE] = ACTIONS(2111),
    [anon_sym_GT_GT] = ACTIONS(2111),
    [anon_sym_GT_GT_GT] = ACTIONS(2111),
    [anon_sym_LT_LT] = ACTIONS(2111),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_CARET] = ACTIONS(2111),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_PERCENT] = ACTIONS(2111),
    [anon_sym_STAR_STAR] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2111),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [anon_sym_QMARK_QMARK] = ACTIONS(2111),
    [anon_sym_instanceof] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_satisfies] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2409),
    [sym__ternary_qmark] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [432] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2402),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6645),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(432),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym__automatic_semicolon] = ACTIONS(2413),
    [sym_html_comment] = ACTIONS(5),
  },
  [433] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(433),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(4896),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1087),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2353),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [434] = {
    [sym_comment] = STATE(434),
    [ts_builtin_sym_end] = ACTIONS(2147),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_as] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_COMMA] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_DOT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_QMARK_DOT] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(2145),
    [anon_sym_GT_GT_GT] = ACTIONS(2145),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_STAR_STAR] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_QMARK_QMARK] = ACTIONS(2145),
    [anon_sym_instanceof] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_satisfies] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym__automatic_semicolon] = ACTIONS(2147),
    [sym__ternary_qmark] = ACTIONS(2147),
    [sym_html_comment] = ACTIONS(5),
  },
  [435] = {
    [sym_comment] = STATE(435),
    [ts_builtin_sym_end] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_export] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2199),
    [anon_sym_type] = ACTIONS(2197),
    [anon_sym_as] = ACTIONS(2199),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_import] = ACTIONS(2197),
    [anon_sym_with] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_debugger] = ACTIONS(2197),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_LTtemplate_GT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_DOT] = ACTIONS(2199),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_function] = ACTIONS(2197),
    [anon_sym_QMARK_DOT] = ACTIONS(2199),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_AMP_AMP] = ACTIONS(2199),
    [anon_sym_PIPE_PIPE] = ACTIONS(2199),
    [anon_sym_GT_GT] = ACTIONS(2199),
    [anon_sym_GT_GT_GT] = ACTIONS(2199),
    [anon_sym_LT_LT] = ACTIONS(2199),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_PIPE] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2199),
    [anon_sym_STAR_STAR] = ACTIONS(2199),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_EQ_EQ] = ACTIONS(2199),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2199),
    [anon_sym_BANG_EQ] = ACTIONS(2199),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2199),
    [anon_sym_QMARK_QMARK] = ACTIONS(2199),
    [anon_sym_instanceof] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2197),
    [sym_number] = ACTIONS(2197),
    [sym_private_property_identifier] = ACTIONS(2197),
    [sym_this] = ACTIONS(2197),
    [sym_super] = ACTIONS(2197),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [sym_null] = ACTIONS(2197),
    [sym_undefined] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_declare] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_module] = ACTIONS(2197),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_boolean] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_object] = ACTIONS(2197),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_satisfies] = ACTIONS(2199),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [sym__automatic_semicolon] = ACTIONS(2415),
    [sym__ternary_qmark] = ACTIONS(2203),
    [sym_html_comment] = ACTIONS(5),
  },
  [436] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(436),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5286),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(2417),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2419),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [437] = {
    [sym_comment] = STATE(437),
    [ts_builtin_sym_end] = ACTIONS(2387),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_export] = ACTIONS(2213),
    [anon_sym_STAR] = ACTIONS(2215),
    [anon_sym_type] = ACTIONS(2213),
    [anon_sym_as] = ACTIONS(2215),
    [anon_sym_namespace] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_COMMA] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_typeof] = ACTIONS(2213),
    [anon_sym_import] = ACTIONS(2213),
    [anon_sym_with] = ACTIONS(2213),
    [anon_sym_var] = ACTIONS(2213),
    [anon_sym_let] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_for] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_await] = ACTIONS(2213),
    [anon_sym_in] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_do] = ACTIONS(2213),
    [anon_sym_try] = ACTIONS(2213),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_debugger] = ACTIONS(2213),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_throw] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_yield] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2213),
    [anon_sym_LTtemplate_GT] = ACTIONS(2213),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_DOT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_class] = ACTIONS(2213),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2213),
    [anon_sym_QMARK_DOT] = ACTIONS(2215),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_using] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_GT_GT_GT] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_PERCENT] = ACTIONS(2215),
    [anon_sym_STAR_STAR] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_LT_EQ] = ACTIONS(2215),
    [anon_sym_EQ_EQ] = ACTIONS(2215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2215),
    [anon_sym_BANG_EQ] = ACTIONS(2215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2215),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_QMARK_QMARK] = ACTIONS(2215),
    [anon_sym_instanceof] = ACTIONS(2215),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_void] = ACTIONS(2213),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_number] = ACTIONS(2213),
    [sym_private_property_identifier] = ACTIONS(2213),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(2213),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2213),
    [anon_sym_static] = ACTIONS(2213),
    [anon_sym_readonly] = ACTIONS(2213),
    [anon_sym_get] = ACTIONS(2213),
    [anon_sym_set] = ACTIONS(2213),
    [anon_sym_declare] = ACTIONS(2213),
    [anon_sym_public] = ACTIONS(2213),
    [anon_sym_private] = ACTIONS(2213),
    [anon_sym_protected] = ACTIONS(2213),
    [anon_sym_override] = ACTIONS(2213),
    [anon_sym_module] = ACTIONS(2213),
    [anon_sym_any] = ACTIONS(2213),
    [anon_sym_number] = ACTIONS(2213),
    [anon_sym_boolean] = ACTIONS(2213),
    [anon_sym_string] = ACTIONS(2213),
    [anon_sym_symbol] = ACTIONS(2213),
    [anon_sym_object] = ACTIONS(2213),
    [anon_sym_abstract] = ACTIONS(2213),
    [anon_sym_satisfies] = ACTIONS(2215),
    [anon_sym_interface] = ACTIONS(2213),
    [anon_sym_enum] = ACTIONS(2213),
    [sym__automatic_semicolon] = ACTIONS(2421),
    [sym__ternary_qmark] = ACTIONS(2219),
    [sym_html_comment] = ACTIONS(5),
  },
  [438] = {
    [sym_comment] = STATE(438),
    [ts_builtin_sym_end] = ACTIONS(2287),
    [sym_identifier] = ACTIONS(2137),
    [anon_sym_export] = ACTIONS(2137),
    [anon_sym_STAR] = ACTIONS(2139),
    [anon_sym_type] = ACTIONS(2137),
    [anon_sym_as] = ACTIONS(2139),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_COMMA] = ACTIONS(2139),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_typeof] = ACTIONS(2137),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_with] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2137),
    [anon_sym_let] = ACTIONS(2137),
    [anon_sym_const] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2137),
    [anon_sym_if] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2137),
    [anon_sym_for] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2137),
    [anon_sym_await] = ACTIONS(2137),
    [anon_sym_in] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2137),
    [anon_sym_do] = ACTIONS(2137),
    [anon_sym_try] = ACTIONS(2137),
    [anon_sym_break] = ACTIONS(2137),
    [anon_sym_continue] = ACTIONS(2137),
    [anon_sym_debugger] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2137),
    [anon_sym_throw] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_LTtemplate_GT] = ACTIONS(2137),
    [anon_sym_GT] = ACTIONS(2139),
    [anon_sym_DOT] = ACTIONS(2139),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_SQUOTE] = ACTIONS(2137),
    [anon_sym_class] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(2137),
    [anon_sym_QMARK_DOT] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2137),
    [anon_sym_using] = ACTIONS(2137),
    [anon_sym_AMP_AMP] = ACTIONS(2139),
    [anon_sym_PIPE_PIPE] = ACTIONS(2139),
    [anon_sym_GT_GT] = ACTIONS(2139),
    [anon_sym_GT_GT_GT] = ACTIONS(2139),
    [anon_sym_LT_LT] = ACTIONS(2139),
    [anon_sym_AMP] = ACTIONS(2139),
    [anon_sym_CARET] = ACTIONS(2139),
    [anon_sym_PIPE] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(2137),
    [anon_sym_PERCENT] = ACTIONS(2139),
    [anon_sym_STAR_STAR] = ACTIONS(2139),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_LT_EQ] = ACTIONS(2139),
    [anon_sym_EQ_EQ] = ACTIONS(2139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2139),
    [anon_sym_BANG_EQ] = ACTIONS(2139),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2139),
    [anon_sym_GT_EQ] = ACTIONS(2139),
    [anon_sym_QMARK_QMARK] = ACTIONS(2139),
    [anon_sym_instanceof] = ACTIONS(2139),
    [anon_sym_TILDE] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2137),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [sym_number] = ACTIONS(2137),
    [sym_private_property_identifier] = ACTIONS(2137),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(2137),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(2137),
    [anon_sym_static] = ACTIONS(2137),
    [anon_sym_readonly] = ACTIONS(2137),
    [anon_sym_get] = ACTIONS(2137),
    [anon_sym_set] = ACTIONS(2137),
    [anon_sym_declare] = ACTIONS(2137),
    [anon_sym_public] = ACTIONS(2137),
    [anon_sym_private] = ACTIONS(2137),
    [anon_sym_protected] = ACTIONS(2137),
    [anon_sym_override] = ACTIONS(2137),
    [anon_sym_module] = ACTIONS(2137),
    [anon_sym_any] = ACTIONS(2137),
    [anon_sym_number] = ACTIONS(2137),
    [anon_sym_boolean] = ACTIONS(2137),
    [anon_sym_string] = ACTIONS(2137),
    [anon_sym_symbol] = ACTIONS(2137),
    [anon_sym_object] = ACTIONS(2137),
    [anon_sym_abstract] = ACTIONS(2137),
    [anon_sym_satisfies] = ACTIONS(2139),
    [anon_sym_interface] = ACTIONS(2137),
    [anon_sym_enum] = ACTIONS(2137),
    [sym__automatic_semicolon] = ACTIONS(2423),
    [sym__ternary_qmark] = ACTIONS(2143),
    [sym_html_comment] = ACTIONS(5),
  },
  [439] = {
    [sym_comment] = STATE(439),
    [ts_builtin_sym_end] = ACTIONS(2239),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_export] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_type] = ACTIONS(2237),
    [anon_sym_as] = ACTIONS(2237),
    [anon_sym_namespace] = ACTIONS(2237),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_COMMA] = ACTIONS(2237),
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_typeof] = ACTIONS(2237),
    [anon_sym_import] = ACTIONS(2237),
    [anon_sym_with] = ACTIONS(2237),
    [anon_sym_var] = ACTIONS(2237),
    [anon_sym_let] = ACTIONS(2237),
    [anon_sym_const] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_if] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_for] = ACTIONS(2237),
    [anon_sym_LPAREN] = ACTIONS(2237),
    [anon_sym_await] = ACTIONS(2237),
    [anon_sym_in] = ACTIONS(2237),
    [anon_sym_while] = ACTIONS(2237),
    [anon_sym_do] = ACTIONS(2237),
    [anon_sym_try] = ACTIONS(2237),
    [anon_sym_break] = ACTIONS(2237),
    [anon_sym_continue] = ACTIONS(2237),
    [anon_sym_debugger] = ACTIONS(2237),
    [anon_sym_return] = ACTIONS(2237),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2237),
    [anon_sym_yield] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2237),
    [anon_sym_LTtemplate_GT] = ACTIONS(2237),
    [anon_sym_GT] = ACTIONS(2237),
    [anon_sym_DOT] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_class] = ACTIONS(2237),
    [anon_sym_async] = ACTIONS(2237),
    [anon_sym_function] = ACTIONS(2237),
    [anon_sym_QMARK_DOT] = ACTIONS(2237),
    [anon_sym_new] = ACTIONS(2237),
    [anon_sym_using] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_PIPE_PIPE] = ACTIONS(2237),
    [anon_sym_GT_GT] = ACTIONS(2237),
    [anon_sym_GT_GT_GT] = ACTIONS(2237),
    [anon_sym_LT_LT] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2237),
    [anon_sym_CARET] = ACTIONS(2237),
    [anon_sym_PIPE] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_SLASH] = ACTIONS(2237),
    [anon_sym_PERCENT] = ACTIONS(2237),
    [anon_sym_STAR_STAR] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2237),
    [anon_sym_LT_EQ] = ACTIONS(2237),
    [anon_sym_EQ_EQ] = ACTIONS(2237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2237),
    [anon_sym_BANG_EQ] = ACTIONS(2237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2237),
    [anon_sym_GT_EQ] = ACTIONS(2237),
    [anon_sym_QMARK_QMARK] = ACTIONS(2237),
    [anon_sym_instanceof] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_void] = ACTIONS(2237),
    [anon_sym_delete] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2237),
    [sym_number] = ACTIONS(2237),
    [sym_private_property_identifier] = ACTIONS(2237),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2237),
    [anon_sym_static] = ACTIONS(2237),
    [anon_sym_readonly] = ACTIONS(2237),
    [anon_sym_get] = ACTIONS(2237),
    [anon_sym_set] = ACTIONS(2237),
    [anon_sym_declare] = ACTIONS(2237),
    [anon_sym_public] = ACTIONS(2237),
    [anon_sym_private] = ACTIONS(2237),
    [anon_sym_protected] = ACTIONS(2237),
    [anon_sym_override] = ACTIONS(2237),
    [anon_sym_module] = ACTIONS(2237),
    [anon_sym_any] = ACTIONS(2237),
    [anon_sym_number] = ACTIONS(2237),
    [anon_sym_boolean] = ACTIONS(2237),
    [anon_sym_string] = ACTIONS(2237),
    [anon_sym_symbol] = ACTIONS(2237),
    [anon_sym_object] = ACTIONS(2237),
    [anon_sym_abstract] = ACTIONS(2237),
    [anon_sym_satisfies] = ACTIONS(2237),
    [anon_sym_interface] = ACTIONS(2237),
    [anon_sym_enum] = ACTIONS(2237),
    [sym__automatic_semicolon] = ACTIONS(2239),
    [sym__ternary_qmark] = ACTIONS(2239),
    [sym_html_comment] = ACTIONS(5),
  },
  [440] = {
    [sym_comment] = STATE(440),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [sym_identifier] = ACTIONS(2233),
    [anon_sym_export] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(2233),
    [anon_sym_as] = ACTIONS(2233),
    [anon_sym_namespace] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_COMMA] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [anon_sym_typeof] = ACTIONS(2233),
    [anon_sym_import] = ACTIONS(2233),
    [anon_sym_with] = ACTIONS(2233),
    [anon_sym_var] = ACTIONS(2233),
    [anon_sym_let] = ACTIONS(2233),
    [anon_sym_const] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_for] = ACTIONS(2233),
    [anon_sym_LPAREN] = ACTIONS(2233),
    [anon_sym_await] = ACTIONS(2233),
    [anon_sym_in] = ACTIONS(2233),
    [anon_sym_while] = ACTIONS(2233),
    [anon_sym_do] = ACTIONS(2233),
    [anon_sym_try] = ACTIONS(2233),
    [anon_sym_break] = ACTIONS(2233),
    [anon_sym_continue] = ACTIONS(2233),
    [anon_sym_debugger] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2233),
    [anon_sym_throw] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym_yield] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2233),
    [anon_sym_LTtemplate_GT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_class] = ACTIONS(2233),
    [anon_sym_async] = ACTIONS(2233),
    [anon_sym_function] = ACTIONS(2233),
    [anon_sym_QMARK_DOT] = ACTIONS(2233),
    [anon_sym_new] = ACTIONS(2233),
    [anon_sym_using] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_PIPE_PIPE] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_GT_GT_GT] = ACTIONS(2233),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_STAR_STAR] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2233),
    [anon_sym_BANG_EQ] = ACTIONS(2233),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2233),
    [anon_sym_QMARK_QMARK] = ACTIONS(2233),
    [anon_sym_instanceof] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_void] = ACTIONS(2233),
    [anon_sym_delete] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2233),
    [sym_number] = ACTIONS(2233),
    [sym_private_property_identifier] = ACTIONS(2233),
    [sym_this] = ACTIONS(2233),
    [sym_super] = ACTIONS(2233),
    [sym_true] = ACTIONS(2233),
    [sym_false] = ACTIONS(2233),
    [sym_null] = ACTIONS(2233),
    [sym_undefined] = ACTIONS(2233),
    [anon_sym_AT] = ACTIONS(2233),
    [anon_sym_static] = ACTIONS(2233),
    [anon_sym_readonly] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2233),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_declare] = ACTIONS(2233),
    [anon_sym_public] = ACTIONS(2233),
    [anon_sym_private] = ACTIONS(2233),
    [anon_sym_protected] = ACTIONS(2233),
    [anon_sym_override] = ACTIONS(2233),
    [anon_sym_module] = ACTIONS(2233),
    [anon_sym_any] = ACTIONS(2233),
    [anon_sym_number] = ACTIONS(2233),
    [anon_sym_boolean] = ACTIONS(2233),
    [anon_sym_string] = ACTIONS(2233),
    [anon_sym_symbol] = ACTIONS(2233),
    [anon_sym_object] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2233),
    [anon_sym_satisfies] = ACTIONS(2233),
    [anon_sym_interface] = ACTIONS(2233),
    [anon_sym_enum] = ACTIONS(2233),
    [sym__automatic_semicolon] = ACTIONS(2235),
    [sym__ternary_qmark] = ACTIONS(2235),
    [sym_html_comment] = ACTIONS(5),
  },
  [441] = {
    [sym_comment] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_export] = ACTIONS(2183),
    [anon_sym_STAR] = ACTIONS(2183),
    [anon_sym_type] = ACTIONS(2183),
    [anon_sym_as] = ACTIONS(2183),
    [anon_sym_namespace] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_typeof] = ACTIONS(2183),
    [anon_sym_import] = ACTIONS(2183),
    [anon_sym_with] = ACTIONS(2183),
    [anon_sym_var] = ACTIONS(2183),
    [anon_sym_let] = ACTIONS(2183),
    [anon_sym_const] = ACTIONS(2183),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2183),
    [anon_sym_for] = ACTIONS(2183),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2183),
    [anon_sym_in] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(2183),
    [anon_sym_do] = ACTIONS(2183),
    [anon_sym_try] = ACTIONS(2183),
    [anon_sym_break] = ACTIONS(2183),
    [anon_sym_continue] = ACTIONS(2183),
    [anon_sym_debugger] = ACTIONS(2183),
    [anon_sym_return] = ACTIONS(2183),
    [anon_sym_throw] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2183),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_GT] = ACTIONS(2183),
    [anon_sym_DOT] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [anon_sym_class] = ACTIONS(2183),
    [anon_sym_async] = ACTIONS(2183),
    [anon_sym_function] = ACTIONS(2183),
    [anon_sym_QMARK_DOT] = ACTIONS(2183),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_using] = ACTIONS(2183),
    [anon_sym_AMP_AMP] = ACTIONS(2183),
    [anon_sym_PIPE_PIPE] = ACTIONS(2183),
    [anon_sym_GT_GT] = ACTIONS(2183),
    [anon_sym_GT_GT_GT] = ACTIONS(2183),
    [anon_sym_LT_LT] = ACTIONS(2183),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_CARET] = ACTIONS(2183),
    [anon_sym_PIPE] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_PERCENT] = ACTIONS(2183),
    [anon_sym_STAR_STAR] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_LT_EQ] = ACTIONS(2183),
    [anon_sym_EQ_EQ] = ACTIONS(2183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ] = ACTIONS(2183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2183),
    [anon_sym_GT_EQ] = ACTIONS(2183),
    [anon_sym_QMARK_QMARK] = ACTIONS(2183),
    [anon_sym_instanceof] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2183),
    [anon_sym_delete] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2183),
    [sym_private_property_identifier] = ACTIONS(2183),
    [sym_this] = ACTIONS(2183),
    [sym_super] = ACTIONS(2183),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_undefined] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2183),
    [anon_sym_readonly] = ACTIONS(2183),
    [anon_sym_get] = ACTIONS(2183),
    [anon_sym_set] = ACTIONS(2183),
    [anon_sym_declare] = ACTIONS(2183),
    [anon_sym_public] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2183),
    [anon_sym_protected] = ACTIONS(2183),
    [anon_sym_override] = ACTIONS(2183),
    [anon_sym_module] = ACTIONS(2183),
    [anon_sym_any] = ACTIONS(2183),
    [anon_sym_number] = ACTIONS(2183),
    [anon_sym_boolean] = ACTIONS(2183),
    [anon_sym_string] = ACTIONS(2183),
    [anon_sym_symbol] = ACTIONS(2183),
    [anon_sym_object] = ACTIONS(2183),
    [anon_sym_abstract] = ACTIONS(2183),
    [anon_sym_satisfies] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2183),
    [anon_sym_enum] = ACTIONS(2183),
    [sym__automatic_semicolon] = ACTIONS(2185),
    [sym__ternary_qmark] = ACTIONS(2185),
    [sym_html_comment] = ACTIONS(5),
  },
  [442] = {
    [sym_comment] = STATE(442),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_as] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_in] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_QMARK_DOT] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_PIPE_PIPE] = ACTIONS(2221),
    [anon_sym_GT_GT] = ACTIONS(2221),
    [anon_sym_GT_GT_GT] = ACTIONS(2221),
    [anon_sym_LT_LT] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_PERCENT] = ACTIONS(2221),
    [anon_sym_STAR_STAR] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2221),
    [anon_sym_QMARK_QMARK] = ACTIONS(2221),
    [anon_sym_instanceof] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_satisfies] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [sym__ternary_qmark] = ACTIONS(2223),
    [sym_html_comment] = ACTIONS(5),
  },
  [443] = {
    [sym_comment] = STATE(443),
    [sym_identifier] = ACTIONS(2405),
    [anon_sym_export] = ACTIONS(2405),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2405),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(2405),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_import] = ACTIONS(2405),
    [anon_sym_let] = ACTIONS(2405),
    [anon_sym_BANG] = ACTIONS(2405),
    [anon_sym_LPAREN] = ACTIONS(2405),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(2405),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(2405),
    [anon_sym_LBRACK] = ACTIONS(2405),
    [anon_sym_LTtemplate_GT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(2405),
    [anon_sym_class] = ACTIONS(2405),
    [anon_sym_async] = ACTIONS(2405),
    [anon_sym_function] = ACTIONS(2405),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2405),
    [anon_sym_using] = ACTIONS(2405),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(2405),
    [anon_sym_DASH] = ACTIONS(2405),
    [anon_sym_SLASH] = ACTIONS(2405),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(2405),
    [anon_sym_void] = ACTIONS(2405),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_PLUS_PLUS] = ACTIONS(2405),
    [anon_sym_DASH_DASH] = ACTIONS(2405),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [sym_number] = ACTIONS(2405),
    [sym_private_property_identifier] = ACTIONS(2405),
    [sym_this] = ACTIONS(2405),
    [sym_super] = ACTIONS(2405),
    [sym_true] = ACTIONS(2405),
    [sym_false] = ACTIONS(2405),
    [sym_null] = ACTIONS(2405),
    [sym_undefined] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(2405),
    [anon_sym_static] = ACTIONS(2405),
    [anon_sym_readonly] = ACTIONS(2405),
    [anon_sym_get] = ACTIONS(2405),
    [anon_sym_set] = ACTIONS(2405),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(2405),
    [anon_sym_public] = ACTIONS(2405),
    [anon_sym_private] = ACTIONS(2405),
    [anon_sym_protected] = ACTIONS(2405),
    [anon_sym_override] = ACTIONS(2405),
    [anon_sym_module] = ACTIONS(2405),
    [anon_sym_any] = ACTIONS(2405),
    [anon_sym_number] = ACTIONS(2405),
    [anon_sym_boolean] = ACTIONS(2405),
    [anon_sym_string] = ACTIONS(2405),
    [anon_sym_symbol] = ACTIONS(2405),
    [anon_sym_object] = ACTIONS(2405),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [444] = {
    [sym_comment] = STATE(444),
    [ts_builtin_sym_end] = ACTIONS(2373),
    [sym_identifier] = ACTIONS(2167),
    [anon_sym_export] = ACTIONS(2167),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_type] = ACTIONS(2167),
    [anon_sym_as] = ACTIONS(2169),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2167),
    [anon_sym_with] = ACTIONS(2167),
    [anon_sym_var] = ACTIONS(2167),
    [anon_sym_let] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_debugger] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_yield] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LTtemplate_GT] = ACTIONS(2167),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_async] = ACTIONS(2167),
    [anon_sym_function] = ACTIONS(2167),
    [anon_sym_QMARK_DOT] = ACTIONS(2169),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_STAR_STAR] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2167),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_QMARK_QMARK] = ACTIONS(2169),
    [anon_sym_instanceof] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_void] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [sym_number] = ACTIONS(2167),
    [sym_private_property_identifier] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [sym_super] = ACTIONS(2167),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_undefined] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_readonly] = ACTIONS(2167),
    [anon_sym_get] = ACTIONS(2167),
    [anon_sym_set] = ACTIONS(2167),
    [anon_sym_declare] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_override] = ACTIONS(2167),
    [anon_sym_module] = ACTIONS(2167),
    [anon_sym_any] = ACTIONS(2167),
    [anon_sym_number] = ACTIONS(2167),
    [anon_sym_boolean] = ACTIONS(2167),
    [anon_sym_string] = ACTIONS(2167),
    [anon_sym_symbol] = ACTIONS(2167),
    [anon_sym_object] = ACTIONS(2167),
    [anon_sym_abstract] = ACTIONS(2167),
    [anon_sym_satisfies] = ACTIONS(2169),
    [anon_sym_interface] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [sym__automatic_semicolon] = ACTIONS(2425),
    [sym__ternary_qmark] = ACTIONS(2173),
    [sym_html_comment] = ACTIONS(5),
  },
  [445] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2428),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6715),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(445),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym__automatic_semicolon] = ACTIONS(2429),
    [sym_html_comment] = ACTIONS(5),
  },
  [446] = {
    [sym_comment] = STATE(446),
    [sym_identifier] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2403),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(2403),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_let] = ACTIONS(2403),
    [anon_sym_BANG] = ACTIONS(2403),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(2403),
    [anon_sym_LBRACK] = ACTIONS(2403),
    [anon_sym_LTtemplate_GT] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [anon_sym_SQUOTE] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(2403),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2403),
    [anon_sym_using] = ACTIONS(2403),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(2403),
    [anon_sym_DASH] = ACTIONS(2403),
    [anon_sym_SLASH] = ACTIONS(2403),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2403),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(2403),
    [anon_sym_void] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2403),
    [anon_sym_PLUS_PLUS] = ACTIONS(2403),
    [anon_sym_DASH_DASH] = ACTIONS(2403),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [sym_number] = ACTIONS(2403),
    [sym_private_property_identifier] = ACTIONS(2403),
    [sym_this] = ACTIONS(2403),
    [sym_super] = ACTIONS(2403),
    [sym_true] = ACTIONS(2403),
    [sym_false] = ACTIONS(2403),
    [sym_null] = ACTIONS(2403),
    [sym_undefined] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2403),
    [anon_sym_static] = ACTIONS(2403),
    [anon_sym_readonly] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_override] = ACTIONS(2403),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_object] = ACTIONS(2403),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [447] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2575),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6693),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(447),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym__automatic_semicolon] = ACTIONS(2433),
    [sym_html_comment] = ACTIONS(5),
  },
  [448] = {
    [sym_comment] = STATE(448),
    [ts_builtin_sym_end] = ACTIONS(2271),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_export] = ACTIONS(2103),
    [anon_sym_STAR] = ACTIONS(2105),
    [anon_sym_type] = ACTIONS(2103),
    [anon_sym_as] = ACTIONS(2105),
    [anon_sym_namespace] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_typeof] = ACTIONS(2103),
    [anon_sym_import] = ACTIONS(2103),
    [anon_sym_with] = ACTIONS(2103),
    [anon_sym_var] = ACTIONS(2103),
    [anon_sym_let] = ACTIONS(2103),
    [anon_sym_const] = ACTIONS(2103),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_switch] = ACTIONS(2103),
    [anon_sym_for] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_await] = ACTIONS(2103),
    [anon_sym_in] = ACTIONS(2105),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_try] = ACTIONS(2103),
    [anon_sym_break] = ACTIONS(2103),
    [anon_sym_continue] = ACTIONS(2103),
    [anon_sym_debugger] = ACTIONS(2103),
    [anon_sym_return] = ACTIONS(2103),
    [anon_sym_throw] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_yield] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LTtemplate_GT] = ACTIONS(2103),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2103),
    [anon_sym_SQUOTE] = ACTIONS(2103),
    [anon_sym_class] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(2103),
    [anon_sym_QMARK_DOT] = ACTIONS(2105),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_using] = ACTIONS(2103),
    [anon_sym_AMP_AMP] = ACTIONS(2105),
    [anon_sym_PIPE_PIPE] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2105),
    [anon_sym_GT_GT_GT] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2105),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(2105),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_PERCENT] = ACTIONS(2105),
    [anon_sym_STAR_STAR] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(2105),
    [anon_sym_QMARK_QMARK] = ACTIONS(2105),
    [anon_sym_instanceof] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2103),
    [anon_sym_void] = ACTIONS(2103),
    [anon_sym_delete] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2103),
    [sym_number] = ACTIONS(2103),
    [sym_private_property_identifier] = ACTIONS(2103),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_undefined] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2103),
    [anon_sym_static] = ACTIONS(2103),
    [anon_sym_readonly] = ACTIONS(2103),
    [anon_sym_get] = ACTIONS(2103),
    [anon_sym_set] = ACTIONS(2103),
    [anon_sym_declare] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2103),
    [anon_sym_private] = ACTIONS(2103),
    [anon_sym_protected] = ACTIONS(2103),
    [anon_sym_override] = ACTIONS(2103),
    [anon_sym_module] = ACTIONS(2103),
    [anon_sym_any] = ACTIONS(2103),
    [anon_sym_number] = ACTIONS(2103),
    [anon_sym_boolean] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_symbol] = ACTIONS(2103),
    [anon_sym_object] = ACTIONS(2103),
    [anon_sym_abstract] = ACTIONS(2103),
    [anon_sym_satisfies] = ACTIONS(2105),
    [anon_sym_interface] = ACTIONS(2103),
    [anon_sym_enum] = ACTIONS(2103),
    [sym__automatic_semicolon] = ACTIONS(2435),
    [sym__ternary_qmark] = ACTIONS(2109),
    [sym_html_comment] = ACTIONS(5),
  },
  [449] = {
    [sym_comment] = STATE(449),
    [ts_builtin_sym_end] = ACTIONS(2357),
    [sym_identifier] = ACTIONS(2255),
    [anon_sym_export] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_type] = ACTIONS(2255),
    [anon_sym_as] = ACTIONS(2257),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2255),
    [anon_sym_COMMA] = ACTIONS(2257),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_typeof] = ACTIONS(2255),
    [anon_sym_import] = ACTIONS(2255),
    [anon_sym_with] = ACTIONS(2255),
    [anon_sym_var] = ACTIONS(2255),
    [anon_sym_let] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_await] = ACTIONS(2255),
    [anon_sym_in] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_debugger] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2255),
    [anon_sym_yield] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_LTtemplate_GT] = ACTIONS(2255),
    [anon_sym_GT] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(2255),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_async] = ACTIONS(2255),
    [anon_sym_function] = ACTIONS(2255),
    [anon_sym_QMARK_DOT] = ACTIONS(2257),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_PIPE_PIPE] = ACTIONS(2257),
    [anon_sym_GT_GT] = ACTIONS(2257),
    [anon_sym_GT_GT_GT] = ACTIONS(2257),
    [anon_sym_LT_LT] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(2257),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_PERCENT] = ACTIONS(2257),
    [anon_sym_STAR_STAR] = ACTIONS(2257),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_LT_EQ] = ACTIONS(2257),
    [anon_sym_EQ_EQ] = ACTIONS(2257),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2257),
    [anon_sym_BANG_EQ] = ACTIONS(2257),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2257),
    [anon_sym_GT_EQ] = ACTIONS(2257),
    [anon_sym_QMARK_QMARK] = ACTIONS(2257),
    [anon_sym_instanceof] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2255),
    [anon_sym_void] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [sym_number] = ACTIONS(2255),
    [sym_private_property_identifier] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [sym_super] = ACTIONS(2255),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [sym_null] = ACTIONS(2255),
    [sym_undefined] = ACTIONS(2255),
    [anon_sym_AT] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_readonly] = ACTIONS(2255),
    [anon_sym_get] = ACTIONS(2255),
    [anon_sym_set] = ACTIONS(2255),
    [anon_sym_declare] = ACTIONS(2255),
    [anon_sym_public] = ACTIONS(2255),
    [anon_sym_private] = ACTIONS(2255),
    [anon_sym_protected] = ACTIONS(2255),
    [anon_sym_override] = ACTIONS(2255),
    [anon_sym_module] = ACTIONS(2255),
    [anon_sym_any] = ACTIONS(2255),
    [anon_sym_number] = ACTIONS(2255),
    [anon_sym_boolean] = ACTIONS(2255),
    [anon_sym_string] = ACTIONS(2255),
    [anon_sym_symbol] = ACTIONS(2255),
    [anon_sym_object] = ACTIONS(2255),
    [anon_sym_abstract] = ACTIONS(2255),
    [anon_sym_satisfies] = ACTIONS(2257),
    [anon_sym_interface] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [sym__automatic_semicolon] = ACTIONS(2437),
    [sym__ternary_qmark] = ACTIONS(2261),
    [sym_html_comment] = ACTIONS(5),
  },
  [450] = {
    [sym_comment] = STATE(450),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_COMMA] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_GT] = ACTIONS(2067),
    [anon_sym_DOT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_QMARK_DOT] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2067),
    [anon_sym_PIPE_PIPE] = ACTIONS(2067),
    [anon_sym_GT_GT] = ACTIONS(2067),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_AMP] = ACTIONS(2067),
    [anon_sym_CARET] = ACTIONS(2067),
    [anon_sym_PIPE] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_STAR_STAR] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_LT_EQ] = ACTIONS(2067),
    [anon_sym_EQ_EQ] = ACTIONS(2067),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ] = ACTIONS(2067),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2067),
    [anon_sym_GT_EQ] = ACTIONS(2067),
    [anon_sym_QMARK_QMARK] = ACTIONS(2067),
    [anon_sym_instanceof] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_satisfies] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2439),
    [sym__ternary_qmark] = ACTIONS(2095),
    [sym_html_comment] = ACTIONS(5),
  },
  [451] = {
    [sym_comment] = STATE(451),
    [ts_builtin_sym_end] = ACTIONS(2365),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_as] = ACTIONS(2085),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2085),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_in] = ACTIONS(2085),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_LTtemplate_GT] = ACTIONS(2083),
    [anon_sym_GT] = ACTIONS(2085),
    [anon_sym_DOT] = ACTIONS(2085),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2083),
    [anon_sym_QMARK_DOT] = ACTIONS(2085),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_using] = ACTIONS(2083),
    [anon_sym_AMP_AMP] = ACTIONS(2085),
    [anon_sym_PIPE_PIPE] = ACTIONS(2085),
    [anon_sym_GT_GT] = ACTIONS(2085),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2085),
    [anon_sym_CARET] = ACTIONS(2085),
    [anon_sym_PIPE] = ACTIONS(2085),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_STAR_STAR] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_LT_EQ] = ACTIONS(2085),
    [anon_sym_EQ_EQ] = ACTIONS(2085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2085),
    [anon_sym_BANG_EQ] = ACTIONS(2085),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2085),
    [anon_sym_GT_EQ] = ACTIONS(2085),
    [anon_sym_QMARK_QMARK] = ACTIONS(2085),
    [anon_sym_instanceof] = ACTIONS(2085),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2083),
    [sym_number] = ACTIONS(2083),
    [sym_private_property_identifier] = ACTIONS(2083),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2083),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_readonly] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_override] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_object] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_satisfies] = ACTIONS(2085),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [sym__automatic_semicolon] = ACTIONS(2441),
    [sym__ternary_qmark] = ACTIONS(2089),
    [sym_html_comment] = ACTIONS(5),
  },
  [452] = {
    [sym_comment] = STATE(452),
    [ts_builtin_sym_end] = ACTIONS(2177),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_as] = ACTIONS(2175),
    [anon_sym_namespace] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2175),
    [anon_sym_import] = ACTIONS(2175),
    [anon_sym_with] = ACTIONS(2175),
    [anon_sym_var] = ACTIONS(2175),
    [anon_sym_let] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_switch] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_await] = ACTIONS(2175),
    [anon_sym_in] = ACTIONS(2175),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_do] = ACTIONS(2175),
    [anon_sym_try] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_debugger] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [anon_sym_LTtemplate_GT] = ACTIONS(2175),
    [anon_sym_GT] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_class] = ACTIONS(2175),
    [anon_sym_async] = ACTIONS(2175),
    [anon_sym_function] = ACTIONS(2175),
    [anon_sym_QMARK_DOT] = ACTIONS(2175),
    [anon_sym_new] = ACTIONS(2175),
    [anon_sym_using] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2175),
    [anon_sym_PIPE_PIPE] = ACTIONS(2175),
    [anon_sym_GT_GT] = ACTIONS(2175),
    [anon_sym_GT_GT_GT] = ACTIONS(2175),
    [anon_sym_LT_LT] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2175),
    [anon_sym_PIPE] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2175),
    [anon_sym_STAR_STAR] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_LT_EQ] = ACTIONS(2175),
    [anon_sym_EQ_EQ] = ACTIONS(2175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ] = ACTIONS(2175),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2175),
    [anon_sym_GT_EQ] = ACTIONS(2175),
    [anon_sym_QMARK_QMARK] = ACTIONS(2175),
    [anon_sym_instanceof] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_void] = ACTIONS(2175),
    [anon_sym_delete] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_number] = ACTIONS(2175),
    [sym_private_property_identifier] = ACTIONS(2175),
    [sym_this] = ACTIONS(2175),
    [sym_super] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2175),
    [anon_sym_static] = ACTIONS(2175),
    [anon_sym_readonly] = ACTIONS(2175),
    [anon_sym_get] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(2175),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_public] = ACTIONS(2175),
    [anon_sym_private] = ACTIONS(2175),
    [anon_sym_protected] = ACTIONS(2175),
    [anon_sym_override] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2175),
    [anon_sym_any] = ACTIONS(2175),
    [anon_sym_number] = ACTIONS(2175),
    [anon_sym_boolean] = ACTIONS(2175),
    [anon_sym_string] = ACTIONS(2175),
    [anon_sym_symbol] = ACTIONS(2175),
    [anon_sym_object] = ACTIONS(2175),
    [anon_sym_abstract] = ACTIONS(2175),
    [anon_sym_satisfies] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [sym__automatic_semicolon] = ACTIONS(2177),
    [sym__ternary_qmark] = ACTIONS(2177),
    [sym_html_comment] = ACTIONS(5),
  },
  [453] = {
    [sym_comment] = STATE(453),
    [ts_builtin_sym_end] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2163),
    [anon_sym_export] = ACTIONS(2163),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_type] = ACTIONS(2163),
    [anon_sym_as] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2163),
    [anon_sym_COMMA] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2163),
    [anon_sym_import] = ACTIONS(2163),
    [anon_sym_with] = ACTIONS(2163),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2163),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_debugger] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_yield] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_LTtemplate_GT] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2163),
    [anon_sym_DOT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2163),
    [anon_sym_SQUOTE] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_async] = ACTIONS(2163),
    [anon_sym_function] = ACTIONS(2163),
    [anon_sym_QMARK_DOT] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_GT_GT_GT] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2163),
    [anon_sym_CARET] = ACTIONS(2163),
    [anon_sym_PIPE] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_SLASH] = ACTIONS(2163),
    [anon_sym_PERCENT] = ACTIONS(2163),
    [anon_sym_STAR_STAR] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_LT_EQ] = ACTIONS(2163),
    [anon_sym_EQ_EQ] = ACTIONS(2163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2163),
    [anon_sym_BANG_EQ] = ACTIONS(2163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2163),
    [anon_sym_GT_EQ] = ACTIONS(2163),
    [anon_sym_QMARK_QMARK] = ACTIONS(2163),
    [anon_sym_instanceof] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [anon_sym_void] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_PLUS_PLUS] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2163),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2163),
    [sym_number] = ACTIONS(2163),
    [sym_private_property_identifier] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(2163),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_readonly] = ACTIONS(2163),
    [anon_sym_get] = ACTIONS(2163),
    [anon_sym_set] = ACTIONS(2163),
    [anon_sym_declare] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_override] = ACTIONS(2163),
    [anon_sym_module] = ACTIONS(2163),
    [anon_sym_any] = ACTIONS(2163),
    [anon_sym_number] = ACTIONS(2163),
    [anon_sym_boolean] = ACTIONS(2163),
    [anon_sym_string] = ACTIONS(2163),
    [anon_sym_symbol] = ACTIONS(2163),
    [anon_sym_object] = ACTIONS(2163),
    [anon_sym_abstract] = ACTIONS(2163),
    [anon_sym_satisfies] = ACTIONS(2163),
    [anon_sym_interface] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [sym__automatic_semicolon] = ACTIONS(2165),
    [sym__ternary_qmark] = ACTIONS(2165),
    [sym_html_comment] = ACTIONS(5),
  },
  [454] = {
    [sym_comment] = STATE(454),
    [ts_builtin_sym_end] = ACTIONS(2275),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_export] = ACTIONS(2189),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_type] = ACTIONS(2189),
    [anon_sym_as] = ACTIONS(2191),
    [anon_sym_namespace] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_import] = ACTIONS(2189),
    [anon_sym_with] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2189),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_in] = ACTIONS(2191),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_debugger] = ACTIONS(2189),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2189),
    [anon_sym_LTtemplate_GT] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2191),
    [anon_sym_DOT] = ACTIONS(2191),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_class] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_function] = ACTIONS(2189),
    [anon_sym_QMARK_DOT] = ACTIONS(2191),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_using] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2191),
    [anon_sym_PIPE_PIPE] = ACTIONS(2191),
    [anon_sym_GT_GT] = ACTIONS(2191),
    [anon_sym_GT_GT_GT] = ACTIONS(2191),
    [anon_sym_LT_LT] = ACTIONS(2191),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2191),
    [anon_sym_PIPE] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_PERCENT] = ACTIONS(2191),
    [anon_sym_STAR_STAR] = ACTIONS(2191),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_LT_EQ] = ACTIONS(2191),
    [anon_sym_EQ_EQ] = ACTIONS(2191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2191),
    [anon_sym_BANG_EQ] = ACTIONS(2191),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2191),
    [anon_sym_GT_EQ] = ACTIONS(2191),
    [anon_sym_QMARK_QMARK] = ACTIONS(2191),
    [anon_sym_instanceof] = ACTIONS(2191),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_void] = ACTIONS(2189),
    [anon_sym_delete] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2189),
    [sym_number] = ACTIONS(2189),
    [sym_private_property_identifier] = ACTIONS(2189),
    [sym_this] = ACTIONS(2189),
    [sym_super] = ACTIONS(2189),
    [sym_true] = ACTIONS(2189),
    [sym_false] = ACTIONS(2189),
    [sym_null] = ACTIONS(2189),
    [sym_undefined] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_declare] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_module] = ACTIONS(2189),
    [anon_sym_any] = ACTIONS(2189),
    [anon_sym_number] = ACTIONS(2189),
    [anon_sym_boolean] = ACTIONS(2189),
    [anon_sym_string] = ACTIONS(2189),
    [anon_sym_symbol] = ACTIONS(2189),
    [anon_sym_object] = ACTIONS(2189),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_satisfies] = ACTIONS(2191),
    [anon_sym_interface] = ACTIONS(2189),
    [anon_sym_enum] = ACTIONS(2189),
    [sym__automatic_semicolon] = ACTIONS(2443),
    [sym__ternary_qmark] = ACTIONS(2195),
    [sym_html_comment] = ACTIONS(5),
  },
  [455] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(455),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5061),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(1093),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2445),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [456] = {
    [sym_comment] = STATE(456),
    [ts_builtin_sym_end] = ACTIONS(2127),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_as] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_COMMA] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_in] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_GT] = ACTIONS(2125),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_QMARK_DOT] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_GT] = ACTIONS(2125),
    [anon_sym_GT_GT_GT] = ACTIONS(2125),
    [anon_sym_LT_LT] = ACTIONS(2125),
    [anon_sym_AMP] = ACTIONS(2125),
    [anon_sym_CARET] = ACTIONS(2125),
    [anon_sym_PIPE] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_PERCENT] = ACTIONS(2125),
    [anon_sym_STAR_STAR] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2125),
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_QMARK_QMARK] = ACTIONS(2125),
    [anon_sym_instanceof] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_satisfies] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym__automatic_semicolon] = ACTIONS(2127),
    [sym__ternary_qmark] = ACTIONS(2127),
    [sym_html_comment] = ACTIONS(5),
  },
  [457] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1940),
    [sym_subscript_expression] = STATE(1940),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4554),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(457),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_pattern] = STATE(5082),
    [sym_rest_pattern] = STATE(4572),
    [sym_non_null_expression] = STATE(1940),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1071),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(161),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(2447),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2449),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [458] = {
    [sym_comment] = STATE(458),
    [ts_builtin_sym_end] = ACTIONS(2313),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2131),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_as] = ACTIONS(2131),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2129),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_in] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2129),
    [anon_sym_LTtemplate_GT] = ACTIONS(2129),
    [anon_sym_GT] = ACTIONS(2131),
    [anon_sym_DOT] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_QMARK_DOT] = ACTIONS(2131),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_using] = ACTIONS(2129),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_GT_GT] = ACTIONS(2131),
    [anon_sym_GT_GT_GT] = ACTIONS(2131),
    [anon_sym_LT_LT] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2131),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_PERCENT] = ACTIONS(2131),
    [anon_sym_STAR_STAR] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_LT_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2131),
    [anon_sym_GT_EQ] = ACTIONS(2131),
    [anon_sym_QMARK_QMARK] = ACTIONS(2131),
    [anon_sym_instanceof] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_number] = ACTIONS(2129),
    [sym_private_property_identifier] = ACTIONS(2129),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_object] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_satisfies] = ACTIONS(2131),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
    [sym__automatic_semicolon] = ACTIONS(2451),
    [sym__ternary_qmark] = ACTIONS(2135),
    [sym_html_comment] = ACTIONS(5),
  },
  [459] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2467),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6813),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(459),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2453),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym__automatic_semicolon] = ACTIONS(2455),
    [sym_html_comment] = ACTIONS(5),
  },
  [460] = {
    [sym_comment] = STATE(460),
    [ts_builtin_sym_end] = ACTIONS(2325),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(2227),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_as] = ACTIONS(2227),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2225),
    [anon_sym_COMMA] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_in] = ACTIONS(2227),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_yield] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2225),
    [anon_sym_LTtemplate_GT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2227),
    [anon_sym_DOT] = ACTIONS(2227),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_SQUOTE] = ACTIONS(2225),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_function] = ACTIONS(2225),
    [anon_sym_QMARK_DOT] = ACTIONS(2227),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_using] = ACTIONS(2225),
    [anon_sym_AMP_AMP] = ACTIONS(2227),
    [anon_sym_PIPE_PIPE] = ACTIONS(2227),
    [anon_sym_GT_GT] = ACTIONS(2227),
    [anon_sym_GT_GT_GT] = ACTIONS(2227),
    [anon_sym_LT_LT] = ACTIONS(2227),
    [anon_sym_AMP] = ACTIONS(2227),
    [anon_sym_CARET] = ACTIONS(2227),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2227),
    [anon_sym_STAR_STAR] = ACTIONS(2227),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_LT_EQ] = ACTIONS(2227),
    [anon_sym_EQ_EQ] = ACTIONS(2227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2227),
    [anon_sym_BANG_EQ] = ACTIONS(2227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2227),
    [anon_sym_GT_EQ] = ACTIONS(2227),
    [anon_sym_QMARK_QMARK] = ACTIONS(2227),
    [anon_sym_instanceof] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2225),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(2225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [sym_number] = ACTIONS(2225),
    [sym_private_property_identifier] = ACTIONS(2225),
    [sym_this] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [sym_false] = ACTIONS(2225),
    [sym_null] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2225),
    [anon_sym_static] = ACTIONS(2225),
    [anon_sym_readonly] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_override] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_object] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_satisfies] = ACTIONS(2227),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
    [sym__automatic_semicolon] = ACTIONS(2457),
    [sym__ternary_qmark] = ACTIONS(2231),
    [sym_html_comment] = ACTIONS(5),
  },
  [461] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2126),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2126),
    [sym_subscript_expression] = STATE(2126),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(5824),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(461),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2126),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2459),
    [anon_sym_export] = ACTIONS(2461),
    [anon_sym_type] = ACTIONS(2461),
    [anon_sym_namespace] = ACTIONS(2463),
    [anon_sym_LBRACE] = ACTIONS(2465),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_var] = ACTIONS(2467),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2475),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2461),
    [anon_sym_readonly] = ACTIONS(2461),
    [anon_sym_get] = ACTIONS(2461),
    [anon_sym_set] = ACTIONS(2461),
    [anon_sym_declare] = ACTIONS(2461),
    [anon_sym_public] = ACTIONS(2461),
    [anon_sym_private] = ACTIONS(2461),
    [anon_sym_protected] = ACTIONS(2461),
    [anon_sym_override] = ACTIONS(2461),
    [anon_sym_module] = ACTIONS(2461),
    [anon_sym_any] = ACTIONS(2461),
    [anon_sym_number] = ACTIONS(2461),
    [anon_sym_boolean] = ACTIONS(2461),
    [anon_sym_string] = ACTIONS(2461),
    [anon_sym_symbol] = ACTIONS(2461),
    [anon_sym_object] = ACTIONS(2461),
    [sym_html_comment] = ACTIONS(5),
  },
  [462] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2679),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7387),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(462),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2481),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [463] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2661),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7389),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(463),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2483),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [464] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2601),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7304),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(464),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [465] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2626),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7341),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(465),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2487),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [466] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7048),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(466),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(2489),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [467] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2473),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(2945),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(467),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [468] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2548),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3134),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(468),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [469] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2436),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2322),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(469),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [470] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2586),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(470),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [471] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2466),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6815),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(471),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [472] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2473),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3163),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(472),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [473] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(2925),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2536),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(473),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [474] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2234),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7182),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(474),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [475] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2241),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(475),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [476] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2453),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3151),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(476),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [477] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(2925),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2499),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(477),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [478] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2623),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7303),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(478),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [479] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2446),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3132),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(479),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [480] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2429),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6710),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(480),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [481] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(3160),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2534),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(481),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [482] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2275),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7429),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(482),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [483] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2548),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3033),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(483),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [484] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2650),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7059),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(484),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [485] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2436),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3106),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(485),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [486] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2436),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3092),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(486),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [487] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2239),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7282),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(487),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [488] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2548),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2246),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(488),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [489] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2587),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7057),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(489),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [490] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2446),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3187),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(490),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [491] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2453),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3246),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(491),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [492] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2588),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7104),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(492),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [493] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2473),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3248),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(493),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [494] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2548),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3256),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(494),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [495] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2655),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7097),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(495),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [496] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3093),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(496),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [497] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2628),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7092),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(497),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [498] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2436),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3191),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(498),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [499] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3173),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(499),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [500] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2576),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6689),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(500),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [501] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(2925),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2784),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(501),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [502] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2592),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(502),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym__extends_clause_single] = STATE(5622),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [503] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2412),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6604),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(503),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [504] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2320),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7399),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(504),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [505] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3213),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(505),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [506] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2230),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7337),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(506),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [507] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2446),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2611),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(507),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [508] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2453),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2612),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(508),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [509] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2621),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7196),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(509),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [510] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2473),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2613),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(510),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [511] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2453),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(2943),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(511),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [512] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2446),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(2941),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(512),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [513] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2473),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2343),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(513),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [514] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2453),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2350),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(514),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [515] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2446),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2352),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(515),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [516] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2446),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2834),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(516),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [517] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2573),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_sequence_expression] = STATE(6612),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(517),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [518] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2453),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2833),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(518),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [519] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2473),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2831),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(519),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [520] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2242),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7312),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(520),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [521] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2548),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2816),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(521),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [522] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(2967),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2498),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(522),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [523] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2436),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2645),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(523),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [524] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2592),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(524),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym__extends_clause_single] = STATE(6281),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [525] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3077),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(525),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_mapped_type_clause] = STATE(7185),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2497),
    [anon_sym_export] = ACTIONS(2499),
    [anon_sym_type] = ACTIONS(2499),
    [anon_sym_namespace] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2503),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2505),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2499),
    [anon_sym_readonly] = ACTIONS(2499),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2499),
    [anon_sym_public] = ACTIONS(2499),
    [anon_sym_private] = ACTIONS(2499),
    [anon_sym_protected] = ACTIONS(2499),
    [anon_sym_override] = ACTIONS(2499),
    [anon_sym_module] = ACTIONS(2499),
    [anon_sym_any] = ACTIONS(2499),
    [anon_sym_number] = ACTIONS(2499),
    [anon_sym_boolean] = ACTIONS(2499),
    [anon_sym_string] = ACTIONS(2499),
    [anon_sym_symbol] = ACTIONS(2499),
    [anon_sym_object] = ACTIONS(2499),
    [sym_html_comment] = ACTIONS(5),
  },
  [526] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(2969),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2494),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(526),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [527] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(3017),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2492),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(527),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [528] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2548),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2667),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(528),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [529] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(3094),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2790),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(529),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [530] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(3094),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2463),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(530),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [531] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2436),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2762),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(531),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [532] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2577),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7404),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(532),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [533] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(3094),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2520),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(533),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [534] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(3160),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2504),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(534),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [535] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2632),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7361),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(535),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [536] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3077),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(536),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_mapped_type_clause] = STATE(7453),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_export] = ACTIONS(2509),
    [anon_sym_type] = ACTIONS(2509),
    [anon_sym_namespace] = ACTIONS(2511),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2509),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2513),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2515),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2509),
    [anon_sym_readonly] = ACTIONS(2509),
    [anon_sym_get] = ACTIONS(2509),
    [anon_sym_set] = ACTIONS(2509),
    [anon_sym_declare] = ACTIONS(2509),
    [anon_sym_public] = ACTIONS(2509),
    [anon_sym_private] = ACTIONS(2509),
    [anon_sym_protected] = ACTIONS(2509),
    [anon_sym_override] = ACTIONS(2509),
    [anon_sym_module] = ACTIONS(2509),
    [anon_sym_any] = ACTIONS(2509),
    [anon_sym_number] = ACTIONS(2509),
    [anon_sym_boolean] = ACTIONS(2509),
    [anon_sym_string] = ACTIONS(2509),
    [anon_sym_symbol] = ACTIONS(2509),
    [anon_sym_object] = ACTIONS(2509),
    [sym_html_comment] = ACTIONS(5),
  },
  [537] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2651),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7380),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(537),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [538] = {
    [sym_import] = STATE(4207),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2758),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(538),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [539] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2653),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7383),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(539),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [540] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2678),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7386),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(540),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [541] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(3017),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2823),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(541),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [542] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(2967),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2431),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(542),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [543] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(2969),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2822),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(543),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [544] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2631),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7051),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(544),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [545] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(2969),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2422),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(545),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [546] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(3017),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2407),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(546),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [547] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(2967),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2821),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(547),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [548] = {
    [sym_import] = STATE(4290),
    [sym_statement_block] = STATE(3160),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2814),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(548),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [549] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2371),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_sequence_expression] = STATE(7171),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(549),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [550] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2562),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(550),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [551] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3209),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(551),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [552] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2564),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(552),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [553] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2437),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(553),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [554] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2764),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(554),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [555] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2825),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(555),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [556] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2768),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(556),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [557] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2766),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(557),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [558] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2810),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(558),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [559] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2815),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(559),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [560] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(3078),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(560),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [561] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2136),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2136),
    [sym_subscript_expression] = STATE(2136),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7215),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(561),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2136),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2517),
    [anon_sym_export] = ACTIONS(2519),
    [anon_sym_type] = ACTIONS(2519),
    [anon_sym_namespace] = ACTIONS(2521),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2523),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2525),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2527),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2519),
    [anon_sym_readonly] = ACTIONS(2519),
    [anon_sym_get] = ACTIONS(2519),
    [anon_sym_set] = ACTIONS(2519),
    [anon_sym_declare] = ACTIONS(2519),
    [anon_sym_public] = ACTIONS(2519),
    [anon_sym_private] = ACTIONS(2519),
    [anon_sym_protected] = ACTIONS(2519),
    [anon_sym_override] = ACTIONS(2519),
    [anon_sym_module] = ACTIONS(2519),
    [anon_sym_any] = ACTIONS(2519),
    [anon_sym_number] = ACTIONS(2519),
    [anon_sym_boolean] = ACTIONS(2519),
    [anon_sym_string] = ACTIONS(2519),
    [anon_sym_symbol] = ACTIONS(2519),
    [anon_sym_object] = ACTIONS(2519),
    [sym_html_comment] = ACTIONS(5),
  },
  [562] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2765),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(562),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [563] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(563),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(2529),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [564] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2423),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(564),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [565] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2761),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(565),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [566] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2812),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(566),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [567] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2811),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(567),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [568] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2571),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(568),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [569] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2140),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2140),
    [sym_subscript_expression] = STATE(2140),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7254),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(569),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2140),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_export] = ACTIONS(2533),
    [anon_sym_type] = ACTIONS(2533),
    [anon_sym_namespace] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2533),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2537),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2539),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2541),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2533),
    [anon_sym_readonly] = ACTIONS(2533),
    [anon_sym_get] = ACTIONS(2533),
    [anon_sym_set] = ACTIONS(2533),
    [anon_sym_declare] = ACTIONS(2533),
    [anon_sym_public] = ACTIONS(2533),
    [anon_sym_private] = ACTIONS(2533),
    [anon_sym_protected] = ACTIONS(2533),
    [anon_sym_override] = ACTIONS(2533),
    [anon_sym_module] = ACTIONS(2533),
    [anon_sym_any] = ACTIONS(2533),
    [anon_sym_number] = ACTIONS(2533),
    [anon_sym_boolean] = ACTIONS(2533),
    [anon_sym_string] = ACTIONS(2533),
    [anon_sym_symbol] = ACTIONS(2533),
    [anon_sym_object] = ACTIONS(2533),
    [sym_html_comment] = ACTIONS(5),
  },
  [570] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2817),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(570),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [571] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3077),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(571),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [572] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2809),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(572),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [573] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2433),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(573),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [574] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2760),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(574),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [575] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2778),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(575),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [576] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2597),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(576),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [577] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2802),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(577),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [578] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2776),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(578),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [579] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2599),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(579),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [580] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2574),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(580),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [581] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2456),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(581),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [582] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3209),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(582),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(2543),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [583] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2392),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(583),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [584] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2447),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(584),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [585] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2759),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(585),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [586] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2773),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(586),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [587] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3090),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(587),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [588] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2483),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(588),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [589] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2559),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(589),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [590] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2563),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(590),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2545),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [591] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2910),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(591),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [592] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2556),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(592),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [593] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2555),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(593),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [594] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(3029),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(594),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [595] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2714),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(595),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [596] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3038),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(596),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [597] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2581),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(597),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [598] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2139),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2139),
    [sym_subscript_expression] = STATE(2139),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7331),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(598),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2139),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2547),
    [anon_sym_export] = ACTIONS(2549),
    [anon_sym_type] = ACTIONS(2549),
    [anon_sym_namespace] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2549),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2553),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2555),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2557),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2549),
    [anon_sym_readonly] = ACTIONS(2549),
    [anon_sym_get] = ACTIONS(2549),
    [anon_sym_set] = ACTIONS(2549),
    [anon_sym_declare] = ACTIONS(2549),
    [anon_sym_public] = ACTIONS(2549),
    [anon_sym_private] = ACTIONS(2549),
    [anon_sym_protected] = ACTIONS(2549),
    [anon_sym_override] = ACTIONS(2549),
    [anon_sym_module] = ACTIONS(2549),
    [anon_sym_any] = ACTIONS(2549),
    [anon_sym_number] = ACTIONS(2549),
    [anon_sym_boolean] = ACTIONS(2549),
    [anon_sym_string] = ACTIONS(2549),
    [anon_sym_symbol] = ACTIONS(2549),
    [anon_sym_object] = ACTIONS(2549),
    [sym_html_comment] = ACTIONS(5),
  },
  [599] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2771),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(599),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [600] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2519),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(600),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [601] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2516),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(601),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [602] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2803),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(602),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [603] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2804),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(603),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [604] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2511),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(604),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [605] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2826),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(605),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [606] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2827),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(606),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [607] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2970),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(607),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [608] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(3130),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(608),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [609] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2770),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(609),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [610] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3066),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(610),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [611] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2523),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2031),
    [sym_subscript_expression] = STATE(2031),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4987),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(611),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2031),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2559),
    [anon_sym_export] = ACTIONS(1708),
    [anon_sym_type] = ACTIONS(1708),
    [anon_sym_namespace] = ACTIONS(1710),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1708),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1714),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2561),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1708),
    [anon_sym_readonly] = ACTIONS(1708),
    [anon_sym_get] = ACTIONS(1708),
    [anon_sym_set] = ACTIONS(1708),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_public] = ACTIONS(1708),
    [anon_sym_private] = ACTIONS(1708),
    [anon_sym_protected] = ACTIONS(1708),
    [anon_sym_override] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1708),
    [anon_sym_any] = ACTIONS(1708),
    [anon_sym_number] = ACTIONS(1708),
    [anon_sym_boolean] = ACTIONS(1708),
    [anon_sym_string] = ACTIONS(1708),
    [anon_sym_symbol] = ACTIONS(1708),
    [anon_sym_object] = ACTIONS(1708),
    [sym_html_comment] = ACTIONS(5),
  },
  [612] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2649),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(612),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [613] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(3119),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(613),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [614] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2482),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(614),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [615] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2398),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(615),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [616] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2900),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(616),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2545),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [617] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2801),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(617),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [618] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(618),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(2565),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [619] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2591),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(619),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [620] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(620),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2144),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_export] = ACTIONS(2569),
    [anon_sym_type] = ACTIONS(2569),
    [anon_sym_namespace] = ACTIONS(2571),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2569),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2575),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2577),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2569),
    [anon_sym_readonly] = ACTIONS(2569),
    [anon_sym_get] = ACTIONS(2569),
    [anon_sym_set] = ACTIONS(2569),
    [anon_sym_declare] = ACTIONS(2569),
    [anon_sym_public] = ACTIONS(2569),
    [anon_sym_private] = ACTIONS(2569),
    [anon_sym_protected] = ACTIONS(2569),
    [anon_sym_override] = ACTIONS(2569),
    [anon_sym_module] = ACTIONS(2569),
    [anon_sym_any] = ACTIONS(2569),
    [anon_sym_number] = ACTIONS(2569),
    [anon_sym_boolean] = ACTIONS(2569),
    [anon_sym_string] = ACTIONS(2569),
    [anon_sym_symbol] = ACTIONS(2569),
    [anon_sym_object] = ACTIONS(2569),
    [sym_html_comment] = ACTIONS(5),
  },
  [621] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2800),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(621),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [622] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2503),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(622),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [623] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2798),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(623),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [624] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3004),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(624),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [625] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2309),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(625),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [626] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3116),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(626),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [627] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2614),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(627),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [628] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2839),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(628),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [629] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3123),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(629),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [630] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3003),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(630),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [631] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3124),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(631),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [632] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(2958),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(632),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [633] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2537),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(633),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [634] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2860),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(634),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [635] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2797),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(635),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [636] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3123),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(636),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(2565),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [637] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3126),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(637),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [638] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2561),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(638),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [639] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3128),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(639),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [640] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2616),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(640),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [641] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2874),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(641),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(2565),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [642] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(642),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [643] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2861),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(643),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [644] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2231),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(644),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [645] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3159),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(645),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [646] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3133),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(646),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [647] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2617),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(647),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [648] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3131),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(648),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [649] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2533),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(649),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [650] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3129),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(650),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [651] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3056),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(651),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [652] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2509),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(652),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [653] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(653),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(2543),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [654] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3122),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(654),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [655] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3055),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(655),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [656] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3120),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(656),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [657] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2874),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(657),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [658] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3070),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(658),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [659] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2464),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(659),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [660] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2523),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(660),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [661] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2883),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(661),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [662] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2876),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(662),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [663] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3052),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(663),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [664] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2837),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(664),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [665] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2795),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(665),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [666] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2358),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(666),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [667] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(3084),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(667),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [668] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2793),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(668),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [669] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3115),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(669),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [670] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2485),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(670),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [671] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2455),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(671),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [672] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2356),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(672),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [673] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2311),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(673),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [674] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(674),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [675] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2486),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(675),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [676] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3114),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(676),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [677] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3113),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(677),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [678] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3110),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(678),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [679] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3109),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(679),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [680] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3108),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(680),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [681] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2141),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2141),
    [sym_subscript_expression] = STATE(2141),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7352),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(681),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2141),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2579),
    [anon_sym_export] = ACTIONS(2581),
    [anon_sym_type] = ACTIONS(2581),
    [anon_sym_namespace] = ACTIONS(2583),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2581),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2585),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2587),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2581),
    [anon_sym_readonly] = ACTIONS(2581),
    [anon_sym_get] = ACTIONS(2581),
    [anon_sym_set] = ACTIONS(2581),
    [anon_sym_declare] = ACTIONS(2581),
    [anon_sym_public] = ACTIONS(2581),
    [anon_sym_private] = ACTIONS(2581),
    [anon_sym_protected] = ACTIONS(2581),
    [anon_sym_override] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2581),
    [anon_sym_any] = ACTIONS(2581),
    [anon_sym_number] = ACTIONS(2581),
    [anon_sym_boolean] = ACTIONS(2581),
    [anon_sym_string] = ACTIONS(2581),
    [anon_sym_symbol] = ACTIONS(2581),
    [anon_sym_object] = ACTIONS(2581),
    [sym_html_comment] = ACTIONS(5),
  },
  [682] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3071),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(682),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [683] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3079),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(683),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [684] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3080),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(684),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [685] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3083),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(685),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [686] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2355),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(686),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [687] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2622),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(687),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [688] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2584),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(688),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [689] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2791),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(689),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [690] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1938),
    [sym_subscript_expression] = STATE(1938),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(4563),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(690),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1938),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2591),
    [anon_sym_export] = ACTIONS(2593),
    [anon_sym_type] = ACTIONS(2593),
    [anon_sym_namespace] = ACTIONS(2595),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1948),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2597),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2599),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2601),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2593),
    [anon_sym_readonly] = ACTIONS(2593),
    [anon_sym_get] = ACTIONS(2593),
    [anon_sym_set] = ACTIONS(2593),
    [anon_sym_declare] = ACTIONS(2593),
    [anon_sym_public] = ACTIONS(2593),
    [anon_sym_private] = ACTIONS(2593),
    [anon_sym_protected] = ACTIONS(2593),
    [anon_sym_override] = ACTIONS(2593),
    [anon_sym_module] = ACTIONS(2593),
    [anon_sym_any] = ACTIONS(2593),
    [anon_sym_number] = ACTIONS(2593),
    [anon_sym_boolean] = ACTIONS(2593),
    [anon_sym_string] = ACTIONS(2593),
    [anon_sym_symbol] = ACTIONS(2593),
    [anon_sym_object] = ACTIONS(2593),
    [sym_html_comment] = ACTIONS(5),
  },
  [691] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3104),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(691),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [692] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2971),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(692),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [693] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2437),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(693),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2545),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [694] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2538),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(694),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [695] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2906),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(695),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [696] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3101),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(696),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [697] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3037),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(697),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [698] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3099),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(698),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [699] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2367),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(699),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [700] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3034),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(700),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [701] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2248),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(701),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [702] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2900),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(702),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [703] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2357),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(703),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [704] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2542),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(704),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [705] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(3107),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(705),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [706] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3003),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(706),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(2565),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [707] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2539),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(707),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [708] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2137),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2137),
    [sym_subscript_expression] = STATE(2137),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7004),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(708),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2137),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2603),
    [anon_sym_export] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(2605),
    [anon_sym_namespace] = ACTIONS(2607),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2609),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2613),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2605),
    [anon_sym_readonly] = ACTIONS(2605),
    [anon_sym_get] = ACTIONS(2605),
    [anon_sym_set] = ACTIONS(2605),
    [anon_sym_declare] = ACTIONS(2605),
    [anon_sym_public] = ACTIONS(2605),
    [anon_sym_private] = ACTIONS(2605),
    [anon_sym_protected] = ACTIONS(2605),
    [anon_sym_override] = ACTIONS(2605),
    [anon_sym_module] = ACTIONS(2605),
    [anon_sym_any] = ACTIONS(2605),
    [anon_sym_number] = ACTIONS(2605),
    [anon_sym_boolean] = ACTIONS(2605),
    [anon_sym_string] = ACTIONS(2605),
    [anon_sym_symbol] = ACTIONS(2605),
    [anon_sym_object] = ACTIONS(2605),
    [sym_html_comment] = ACTIONS(5),
  },
  [709] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2415),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(709),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [710] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3091),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(710),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [711] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2341),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(711),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [712] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2333),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(712),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [713] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2330),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(713),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [714] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2328),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(714),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [715] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2375),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(715),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [716] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(3137),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(716),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [717] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2307),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(717),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [718] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3207),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(718),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [719] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2806),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(719),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [720] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2319),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(720),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [721] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2317),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(721),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [722] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2316),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(722),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [723] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2315),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(723),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [724] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2654),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(724),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [725] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3032),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(725),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [726] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2232),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(726),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [727] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(727),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [728] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2524),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(728),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [729] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3095),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(729),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [730] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2518),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(730),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [731] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2138),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2138),
    [sym_subscript_expression] = STATE(2138),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7244),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(731),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2138),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2615),
    [anon_sym_export] = ACTIONS(2617),
    [anon_sym_type] = ACTIONS(2617),
    [anon_sym_namespace] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2617),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2621),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2623),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2625),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2617),
    [anon_sym_readonly] = ACTIONS(2617),
    [anon_sym_get] = ACTIONS(2617),
    [anon_sym_set] = ACTIONS(2617),
    [anon_sym_declare] = ACTIONS(2617),
    [anon_sym_public] = ACTIONS(2617),
    [anon_sym_private] = ACTIONS(2617),
    [anon_sym_protected] = ACTIONS(2617),
    [anon_sym_override] = ACTIONS(2617),
    [anon_sym_module] = ACTIONS(2617),
    [anon_sym_any] = ACTIONS(2617),
    [anon_sym_number] = ACTIONS(2617),
    [anon_sym_boolean] = ACTIONS(2617),
    [anon_sym_string] = ACTIONS(2617),
    [anon_sym_symbol] = ACTIONS(2617),
    [anon_sym_object] = ACTIONS(2617),
    [sym_html_comment] = ACTIONS(5),
  },
  [732] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2143),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2143),
    [sym_subscript_expression] = STATE(2143),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7273),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(732),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2143),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_export] = ACTIONS(2629),
    [anon_sym_type] = ACTIONS(2629),
    [anon_sym_namespace] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2629),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2633),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2637),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2629),
    [anon_sym_readonly] = ACTIONS(2629),
    [anon_sym_get] = ACTIONS(2629),
    [anon_sym_set] = ACTIONS(2629),
    [anon_sym_declare] = ACTIONS(2629),
    [anon_sym_public] = ACTIONS(2629),
    [anon_sym_private] = ACTIONS(2629),
    [anon_sym_protected] = ACTIONS(2629),
    [anon_sym_override] = ACTIONS(2629),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_any] = ACTIONS(2629),
    [anon_sym_number] = ACTIONS(2629),
    [anon_sym_boolean] = ACTIONS(2629),
    [anon_sym_string] = ACTIONS(2629),
    [anon_sym_symbol] = ACTIONS(2629),
    [anon_sym_object] = ACTIONS(2629),
    [sym_html_comment] = ACTIONS(5),
  },
  [733] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2439),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(733),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [734] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3228),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(734),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [735] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2468),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(735),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [736] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2249),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(736),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [737] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(2952),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(737),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [738] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2408),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(738),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [739] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2634),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(739),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [740] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3209),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(740),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(2565),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [741] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2785),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(741),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [742] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3144),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(742),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [743] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2669),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(743),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [744] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3242),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(744),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [745] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3243),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(745),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [746] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2469),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(746),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [747] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(2930),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(747),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [748] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(2934),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(748),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [749] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2072),
    [sym_expression] = STATE(3068),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(6992),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2072),
    [sym_subscript_expression] = STATE(2072),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7255),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(749),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2072),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1762),
    [anon_sym_using] = ACTIONS(1584),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1592),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_readonly] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_override] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_object] = ACTIONS(1568),
    [sym_html_comment] = ACTIONS(5),
  },
  [750] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2671),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(750),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [751] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2603),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(751),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [752] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2786),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(752),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [753] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3254),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(753),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [754] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2400),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(754),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [755] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3258),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(755),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [756] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3259),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(756),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [757] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3260),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(757),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [758] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3264),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(758),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [759] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3241),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(759),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [760] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2644),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(760),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [761] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3239),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(761),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [762] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3235),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(762),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [763] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3229),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(763),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [764] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3224),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(764),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [765] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3231),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(765),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [766] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2506),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(766),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [767] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2675),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(767),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [768] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2677),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(768),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [769] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3212),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(769),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [770] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3215),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(770),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [771] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3214),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(771),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [772] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2471),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(772),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [773] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2647),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(773),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [774] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2569),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(774),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [775] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2563),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(775),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [776] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2142),
    [sym_expression] = STATE(3253),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2142),
    [sym_subscript_expression] = STATE(2142),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7085),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(776),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2142),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_export] = ACTIONS(2641),
    [anon_sym_type] = ACTIONS(2641),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(2645),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(2647),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(2649),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2641),
    [anon_sym_readonly] = ACTIONS(2641),
    [anon_sym_get] = ACTIONS(2641),
    [anon_sym_set] = ACTIONS(2641),
    [anon_sym_declare] = ACTIONS(2641),
    [anon_sym_public] = ACTIONS(2641),
    [anon_sym_private] = ACTIONS(2641),
    [anon_sym_protected] = ACTIONS(2641),
    [anon_sym_override] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(2641),
    [anon_sym_any] = ACTIONS(2641),
    [anon_sym_number] = ACTIONS(2641),
    [anon_sym_boolean] = ACTIONS(2641),
    [anon_sym_string] = ACTIONS(2641),
    [anon_sym_symbol] = ACTIONS(2641),
    [anon_sym_object] = ACTIONS(2641),
    [sym_html_comment] = ACTIONS(5),
  },
  [777] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2676),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(777),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [778] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2652),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(778),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [779] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3203),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(779),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [780] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2658),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(780),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [781] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3174),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(781),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [782] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2699),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(782),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [783] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2767),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(783),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [784] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2606),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(784),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [785] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2666),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(785),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [786] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_expression] = STATE(2789),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7191),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7193),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(786),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2084),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1602),
    [anon_sym_type] = ACTIONS(1602),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1610),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1602),
    [anon_sym_BANG] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1612),
    [anon_sym_yield] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_using] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1610),
    [anon_sym_void] = ACTIONS(1610),
    [anon_sym_delete] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1628),
    [anon_sym_DASH_DASH] = ACTIONS(1628),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1634),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1602),
    [anon_sym_readonly] = ACTIONS(1602),
    [anon_sym_get] = ACTIONS(1602),
    [anon_sym_set] = ACTIONS(1602),
    [anon_sym_declare] = ACTIONS(1602),
    [anon_sym_public] = ACTIONS(1602),
    [anon_sym_private] = ACTIONS(1602),
    [anon_sym_protected] = ACTIONS(1602),
    [anon_sym_override] = ACTIONS(1602),
    [anon_sym_module] = ACTIONS(1602),
    [anon_sym_any] = ACTIONS(1602),
    [anon_sym_number] = ACTIONS(1602),
    [anon_sym_boolean] = ACTIONS(1602),
    [anon_sym_string] = ACTIONS(1602),
    [anon_sym_symbol] = ACTIONS(1602),
    [anon_sym_object] = ACTIONS(1602),
    [sym_html_comment] = ACTIONS(5),
  },
  [787] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2674),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(787),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [788] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2491),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(788),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [789] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(789),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [790] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2013),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7163),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2013),
    [sym_subscript_expression] = STATE(2013),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3771),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(790),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2013),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1652),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1730),
    [anon_sym_using] = ACTIONS(1015),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(2651),
    [sym_private_property_identifier] = ACTIONS(1027),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_override] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [sym_html_comment] = ACTIONS(5),
  },
  [791] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3205),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(791),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [792] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2461),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(792),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [793] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2472),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(793),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [794] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2617),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(794),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(2565),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [795] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2528),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(795),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [796] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_expression] = STATE(2953),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7319),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3721),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7378),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(796),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2087),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1782),
    [anon_sym_export] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_namespace] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1524),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_readonly] = ACTIONS(1498),
    [anon_sym_get] = ACTIONS(1498),
    [anon_sym_set] = ACTIONS(1498),
    [anon_sym_declare] = ACTIONS(1498),
    [anon_sym_public] = ACTIONS(1498),
    [anon_sym_private] = ACTIONS(1498),
    [anon_sym_protected] = ACTIONS(1498),
    [anon_sym_override] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [anon_sym_any] = ACTIONS(1498),
    [anon_sym_number] = ACTIONS(1498),
    [anon_sym_boolean] = ACTIONS(1498),
    [anon_sym_string] = ACTIONS(1498),
    [anon_sym_symbol] = ACTIONS(1498),
    [anon_sym_object] = ACTIONS(1498),
    [sym_html_comment] = ACTIONS(5),
  },
  [797] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2112),
    [sym_expression] = STATE(3009),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7145),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2112),
    [sym_subscript_expression] = STATE(2112),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3782),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7154),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(797),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2112),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1774),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_using] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1558),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_readonly] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_override] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [anon_sym_object] = ACTIONS(1534),
    [sym_html_comment] = ACTIONS(5),
  },
  [798] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2038),
    [sym_expression] = STATE(2530),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7152),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7147),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(798),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1746),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1488),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_declare] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [sym_html_comment] = ACTIONS(5),
  },
  [799] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2668),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(799),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [800] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2672),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(800),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [801] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2673),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(801),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [802] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3209),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(802),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(2651),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [803] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2608),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(803),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [804] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(2045),
    [sym_expression] = STATE(2609),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7106),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2045),
    [sym_subscript_expression] = STATE(2045),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3702),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7131),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(804),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2045),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1362),
    [anon_sym_type] = ACTIONS(1362),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1372),
    [anon_sym_yield] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1754),
    [anon_sym_using] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1370),
    [anon_sym_delete] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(1394),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(1362),
    [anon_sym_set] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1362),
    [anon_sym_public] = ACTIONS(1362),
    [anon_sym_private] = ACTIONS(1362),
    [anon_sym_protected] = ACTIONS(1362),
    [anon_sym_override] = ACTIONS(1362),
    [anon_sym_module] = ACTIONS(1362),
    [anon_sym_any] = ACTIONS(1362),
    [anon_sym_number] = ACTIONS(1362),
    [anon_sym_boolean] = ACTIONS(1362),
    [anon_sym_string] = ACTIONS(1362),
    [anon_sym_symbol] = ACTIONS(1362),
    [anon_sym_object] = ACTIONS(1362),
    [sym_html_comment] = ACTIONS(5),
  },
  [805] = {
    [sym_import] = STATE(4290),
    [sym_parenthesized_expression] = STATE(2026),
    [sym_expression] = STATE(2477),
    [sym_primary_expression] = STATE(2881),
    [sym_yield_expression] = STATE(2982),
    [sym_object] = STATE(2940),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2940),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2982),
    [sym_glimmer_opening_tag] = STATE(5508),
    [sym_jsx_element] = STATE(2982),
    [sym_jsx_opening_element] = STATE(3884),
    [sym_jsx_self_closing_element] = STATE(2982),
    [sym_class] = STATE(2940),
    [sym_function_expression] = STATE(2940),
    [sym_generator_function] = STATE(2940),
    [sym_arrow_function] = STATE(2940),
    [sym__call_signature] = STATE(7370),
    [sym_call_expression] = STATE(2940),
    [sym_new_expression] = STATE(2982),
    [sym_await_expression] = STATE(2982),
    [sym_member_expression] = STATE(2026),
    [sym_subscript_expression] = STATE(2026),
    [sym_assignment_expression] = STATE(2982),
    [sym__augmented_assignment_lhs] = STATE(3712),
    [sym_augmented_assignment_expression] = STATE(2982),
    [sym__destructuring_pattern] = STATE(7359),
    [sym_ternary_expression] = STATE(2982),
    [sym_binary_expression] = STATE(2982),
    [sym_unary_expression] = STATE(2982),
    [sym_update_expression] = STATE(2982),
    [sym_string] = STATE(2940),
    [sym_comment] = STATE(805),
    [sym_template_string] = STATE(2940),
    [sym_regex] = STATE(2940),
    [sym_meta_property] = STATE(2940),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(2026),
    [sym_as_expression] = STATE(2982),
    [sym_satisfies_expression] = STATE(2982),
    [sym_instantiation_expression] = STATE(2982),
    [sym_internal_module] = STATE(2982),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5470),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(977),
    [anon_sym_new] = ACTIONS(1740),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_readonly] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_override] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_object] = ACTIONS(1406),
    [sym_html_comment] = ACTIONS(5),
  },
  [806] = {
    [sym_import] = STATE(4207),
    [sym_parenthesized_expression] = STATE(1900),
    [sym_expression] = STATE(3210),
    [sym_primary_expression] = STATE(2235),
    [sym_yield_expression] = STATE(2568),
    [sym_object] = STATE(2547),
    [sym_object_pattern] = STATE(4288),
    [sym_array] = STATE(2547),
    [sym_array_pattern] = STATE(4288),
    [sym_glimmer_template] = STATE(2568),
    [sym_glimmer_opening_tag] = STATE(5599),
    [sym_jsx_element] = STATE(2568),
    [sym_jsx_opening_element] = STATE(3849),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2547),
    [sym_function_expression] = STATE(2547),
    [sym_generator_function] = STATE(2547),
    [sym_arrow_function] = STATE(2547),
    [sym__call_signature] = STATE(7074),
    [sym_call_expression] = STATE(2547),
    [sym_new_expression] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(1900),
    [sym_subscript_expression] = STATE(1900),
    [sym_assignment_expression] = STATE(2568),
    [sym__augmented_assignment_lhs] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym__destructuring_pattern] = STATE(7166),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_string] = STATE(2547),
    [sym_comment] = STATE(806),
    [sym_template_string] = STATE(2547),
    [sym_regex] = STATE(2547),
    [sym_meta_property] = STATE(2547),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4683),
    [sym_non_null_expression] = STATE(1900),
    [sym_as_expression] = STATE(2568),
    [sym_satisfies_expression] = STATE(2568),
    [sym_instantiation_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_export_statement_repeat1] = STATE(5557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(174),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(174),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_class] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_using] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_DASH] = ACTIONS(174),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(172),
    [anon_sym_TILDE] = ACTIONS(174),
    [anon_sym_void] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(174),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(189),
    [sym_private_property_identifier] = ACTIONS(185),
    [sym_this] = ACTIONS(189),
    [sym_super] = ACTIONS(189),
    [sym_true] = ACTIONS(189),
    [sym_false] = ACTIONS(189),
    [sym_null] = ACTIONS(189),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_readonly] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_override] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_object] = ACTIONS(1097),
    [sym_html_comment] = ACTIONS(5),
  },
  [807] = {
    [sym_namespace_export] = STATE(6533),
    [sym_export_clause] = STATE(5430),
    [sym_declaration] = STATE(1561),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_class_declaration] = STATE(1558),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_comment] = STATE(807),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1558),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(1557),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [aux_sym_export_statement_repeat1] = STATE(5398),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2655),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_EQ] = ACTIONS(2659),
    [anon_sym_as] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2663),
    [anon_sym_LBRACE] = ACTIONS(2665),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_import] = ACTIONS(2669),
    [anon_sym_var] = ACTIONS(2671),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2680),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2687),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2700),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2708),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [808] = {
    [sym_namespace_export] = STATE(6533),
    [sym_export_clause] = STATE(5430),
    [sym_declaration] = STATE(1561),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_class_declaration] = STATE(1558),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_comment] = STATE(808),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1558),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(1557),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [aux_sym_export_statement_repeat1] = STATE(5398),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2655),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_EQ] = ACTIONS(2659),
    [anon_sym_as] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2663),
    [anon_sym_LBRACE] = ACTIONS(2665),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_import] = ACTIONS(2669),
    [anon_sym_var] = ACTIONS(2671),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2680),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2687),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2700),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2708),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [809] = {
    [sym_namespace_export] = STATE(6533),
    [sym_export_clause] = STATE(5430),
    [sym_declaration] = STATE(1561),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_class_declaration] = STATE(1558),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_comment] = STATE(809),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1558),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(1557),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [aux_sym_export_statement_repeat1] = STATE(5398),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2655),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_EQ] = ACTIONS(2659),
    [anon_sym_as] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2663),
    [anon_sym_LBRACE] = ACTIONS(2665),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_RBRACE] = ACTIONS(2712),
    [anon_sym_import] = ACTIONS(2669),
    [anon_sym_var] = ACTIONS(2671),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2680),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2687),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2700),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2708),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [810] = {
    [sym__call_signature] = STATE(7260),
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(810),
    [sym_formal_parameters] = STATE(4683),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2716),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2716),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2721),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2716),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2730),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2716),
    [anon_sym_readonly] = ACTIONS(2716),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2716),
    [anon_sym_public] = ACTIONS(2716),
    [anon_sym_private] = ACTIONS(2716),
    [anon_sym_protected] = ACTIONS(2716),
    [anon_sym_override] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_any] = ACTIONS(2716),
    [anon_sym_number] = ACTIONS(2716),
    [anon_sym_boolean] = ACTIONS(2716),
    [anon_sym_string] = ACTIONS(2716),
    [anon_sym_symbol] = ACTIONS(2716),
    [anon_sym_object] = ACTIONS(2716),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [811] = {
    [sym__call_signature] = STATE(7260),
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(811),
    [sym_formal_parameters] = STATE(4683),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2716),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2716),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2721),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2716),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2730),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2716),
    [anon_sym_readonly] = ACTIONS(2716),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2716),
    [anon_sym_public] = ACTIONS(2716),
    [anon_sym_private] = ACTIONS(2716),
    [anon_sym_protected] = ACTIONS(2716),
    [anon_sym_override] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_any] = ACTIONS(2716),
    [anon_sym_number] = ACTIONS(2716),
    [anon_sym_boolean] = ACTIONS(2716),
    [anon_sym_string] = ACTIONS(2716),
    [anon_sym_symbol] = ACTIONS(2716),
    [anon_sym_object] = ACTIONS(2716),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [812] = {
    [sym__call_signature] = STATE(7260),
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(812),
    [sym_formal_parameters] = STATE(4683),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [sym_type_parameters] = STATE(6493),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2716),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2716),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2721),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2716),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2730),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2716),
    [anon_sym_readonly] = ACTIONS(2716),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2716),
    [anon_sym_public] = ACTIONS(2716),
    [anon_sym_private] = ACTIONS(2716),
    [anon_sym_protected] = ACTIONS(2716),
    [anon_sym_override] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_any] = ACTIONS(2716),
    [anon_sym_number] = ACTIONS(2716),
    [anon_sym_boolean] = ACTIONS(2716),
    [anon_sym_string] = ACTIONS(2716),
    [anon_sym_symbol] = ACTIONS(2716),
    [anon_sym_object] = ACTIONS(2716),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [813] = {
    [sym_declaration] = STATE(1514),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_class_declaration] = STATE(1558),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_comment] = STATE(813),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1558),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(1557),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [aux_sym_export_statement_repeat1] = STATE(5398),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2738),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2663),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_import] = ACTIONS(2669),
    [anon_sym_var] = ACTIONS(2671),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2680),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2687),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2700),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2708),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [814] = {
    [sym_declaration] = STATE(1514),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_class_declaration] = STATE(1558),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_comment] = STATE(814),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1558),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(1557),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [aux_sym_export_statement_repeat1] = STATE(5398),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2738),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2663),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_import] = ACTIONS(2669),
    [anon_sym_var] = ACTIONS(2671),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2680),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2687),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2700),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2708),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [815] = {
    [sym_declaration] = STATE(1514),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_class_declaration] = STATE(1558),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_comment] = STATE(815),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1558),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(1557),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [aux_sym_export_statement_repeat1] = STATE(5398),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2738),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2663),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_RBRACE] = ACTIONS(2712),
    [anon_sym_import] = ACTIONS(2669),
    [anon_sym_var] = ACTIONS(2671),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2680),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2687),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2700),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2708),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [816] = {
    [sym_namespace_export] = STATE(6533),
    [sym_export_clause] = STATE(5430),
    [sym_declaration] = STATE(1561),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_class_declaration] = STATE(1558),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_comment] = STATE(816),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1558),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(1557),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [aux_sym_export_statement_repeat1] = STATE(5398),
    [anon_sym_STAR] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2655),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_EQ] = ACTIONS(2744),
    [anon_sym_as] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2663),
    [anon_sym_LBRACE] = ACTIONS(2665),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2669),
    [anon_sym_var] = ACTIONS(2671),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2746),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2687),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2700),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2708),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [817] = {
    [sym_namespace_export] = STATE(6822),
    [sym_export_clause] = STATE(5411),
    [sym_declaration] = STATE(1347),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_class_declaration] = STATE(1327),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_comment] = STATE(817),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1327),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(1348),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [aux_sym_export_statement_repeat1] = STATE(5102),
    [anon_sym_STAR] = ACTIONS(2748),
    [anon_sym_default] = ACTIONS(2750),
    [anon_sym_type] = ACTIONS(2752),
    [anon_sym_EQ] = ACTIONS(2754),
    [anon_sym_as] = ACTIONS(2756),
    [anon_sym_namespace] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2665),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2760),
    [anon_sym_var] = ACTIONS(2762),
    [anon_sym_let] = ACTIONS(2764),
    [anon_sym_const] = ACTIONS(2766),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2770),
    [anon_sym_async] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2774),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2776),
    [anon_sym_module] = ACTIONS(2778),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_interface] = ACTIONS(2782),
    [anon_sym_enum] = ACTIONS(2784),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [818] = {
    [sym_namespace_export] = STATE(6664),
    [sym_export_clause] = STATE(5593),
    [sym_declaration] = STATE(6379),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_class_declaration] = STATE(6360),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_comment] = STATE(818),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(6360),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(6385),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [aux_sym_export_statement_repeat1] = STATE(5201),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_default] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2790),
    [anon_sym_EQ] = ACTIONS(2792),
    [anon_sym_as] = ACTIONS(2794),
    [anon_sym_namespace] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2665),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2798),
    [anon_sym_var] = ACTIONS(2800),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_const] = ACTIONS(2804),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2806),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2808),
    [anon_sym_async] = ACTIONS(2810),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2814),
    [anon_sym_module] = ACTIONS(2816),
    [anon_sym_abstract] = ACTIONS(2818),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_enum] = ACTIONS(2822),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [819] = {
    [sym_namespace_export] = STATE(6753),
    [sym_export_clause] = STATE(5457),
    [sym_declaration] = STATE(1098),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_class_declaration] = STATE(1100),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_comment] = STATE(819),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1100),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(1094),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [aux_sym_export_statement_repeat1] = STATE(4991),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_default] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2828),
    [anon_sym_EQ] = ACTIONS(2830),
    [anon_sym_as] = ACTIONS(2832),
    [anon_sym_namespace] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(2665),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2836),
    [anon_sym_var] = ACTIONS(2838),
    [anon_sym_let] = ACTIONS(2840),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_async] = ACTIONS(2848),
    [anon_sym_function] = ACTIONS(2850),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2852),
    [anon_sym_module] = ACTIONS(2854),
    [anon_sym_abstract] = ACTIONS(2856),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_interface] = ACTIONS(2858),
    [anon_sym_enum] = ACTIONS(2860),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [820] = {
    [sym_namespace_export] = STATE(6905),
    [sym_export_clause] = STATE(5547),
    [sym_declaration] = STATE(1406),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_class_declaration] = STATE(1444),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_comment] = STATE(820),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1444),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(1399),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [aux_sym_export_statement_repeat1] = STATE(5232),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_default] = ACTIONS(2864),
    [anon_sym_type] = ACTIONS(2866),
    [anon_sym_EQ] = ACTIONS(2868),
    [anon_sym_as] = ACTIONS(2870),
    [anon_sym_namespace] = ACTIONS(2872),
    [anon_sym_LBRACE] = ACTIONS(2665),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2874),
    [anon_sym_var] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_const] = ACTIONS(2880),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2882),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2884),
    [anon_sym_async] = ACTIONS(2886),
    [anon_sym_function] = ACTIONS(2888),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2890),
    [anon_sym_module] = ACTIONS(2892),
    [anon_sym_abstract] = ACTIONS(2894),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_interface] = ACTIONS(2896),
    [anon_sym_enum] = ACTIONS(2898),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [821] = {
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(821),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [sym_override_modifier] = STATE(3531),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2902),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2904),
    [anon_sym_get] = ACTIONS(2906),
    [anon_sym_set] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_override] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_object] = ACTIONS(2900),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [822] = {
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(822),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [sym_override_modifier] = STATE(3531),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2902),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2904),
    [anon_sym_get] = ACTIONS(2906),
    [anon_sym_set] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_override] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_object] = ACTIONS(2900),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [823] = {
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(823),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [sym_override_modifier] = STATE(3531),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2902),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2904),
    [anon_sym_get] = ACTIONS(2906),
    [anon_sym_set] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_override] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_object] = ACTIONS(2900),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [824] = {
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(824),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2902),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2906),
    [anon_sym_set] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_override] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_object] = ACTIONS(2900),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [825] = {
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(825),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2900),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2900),
    [anon_sym_set] = ACTIONS(2900),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_override] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_object] = ACTIONS(2900),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [826] = {
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(826),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2900),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2900),
    [anon_sym_set] = ACTIONS(2900),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_override] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_object] = ACTIONS(2900),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [827] = {
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(827),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2902),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2906),
    [anon_sym_set] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_override] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_object] = ACTIONS(2900),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [828] = {
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(828),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2900),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2900),
    [anon_sym_set] = ACTIONS(2900),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_override] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_object] = ACTIONS(2900),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [829] = {
    [sym_string] = STATE(4582),
    [sym_comment] = STATE(829),
    [sym__property_name] = STATE(4808),
    [sym_computed_property_name] = STATE(4582),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(2902),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2734),
    [sym_private_property_identifier] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2906),
    [anon_sym_set] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_override] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_object] = ACTIONS(2900),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [830] = {
    [sym_declaration] = STATE(1332),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_class_declaration] = STATE(1444),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_comment] = STATE(830),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1444),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(1399),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [aux_sym_export_statement_repeat1] = STATE(5232),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2872),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2874),
    [anon_sym_var] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_const] = ACTIONS(2880),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2882),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2884),
    [anon_sym_async] = ACTIONS(2886),
    [anon_sym_function] = ACTIONS(2888),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2890),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2894),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2914),
    [anon_sym_interface] = ACTIONS(2896),
    [anon_sym_enum] = ACTIONS(2898),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [831] = {
    [sym_declaration] = STATE(1086),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_class_declaration] = STATE(1100),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_comment] = STATE(831),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1100),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(1094),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [aux_sym_export_statement_repeat1] = STATE(4991),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2916),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2834),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2836),
    [anon_sym_var] = ACTIONS(2838),
    [anon_sym_let] = ACTIONS(2840),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_async] = ACTIONS(2848),
    [anon_sym_function] = ACTIONS(2850),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2852),
    [anon_sym_module] = ACTIONS(2918),
    [anon_sym_abstract] = ACTIONS(2856),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2920),
    [anon_sym_interface] = ACTIONS(2858),
    [anon_sym_enum] = ACTIONS(2860),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [832] = {
    [sym_declaration] = STATE(1377),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_class_declaration] = STATE(1327),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_comment] = STATE(832),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1327),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(1348),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [aux_sym_export_statement_repeat1] = STATE(5102),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2758),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2760),
    [anon_sym_var] = ACTIONS(2762),
    [anon_sym_let] = ACTIONS(2764),
    [anon_sym_const] = ACTIONS(2766),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2770),
    [anon_sym_async] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2774),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2776),
    [anon_sym_module] = ACTIONS(2924),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2926),
    [anon_sym_interface] = ACTIONS(2782),
    [anon_sym_enum] = ACTIONS(2784),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [833] = {
    [sym_declaration] = STATE(6491),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_class_declaration] = STATE(6360),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_comment] = STATE(833),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(6360),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(6385),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [aux_sym_export_statement_repeat1] = STATE(5201),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2928),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2796),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2798),
    [anon_sym_var] = ACTIONS(2800),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_const] = ACTIONS(2804),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2806),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2808),
    [anon_sym_async] = ACTIONS(2810),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2814),
    [anon_sym_module] = ACTIONS(2930),
    [anon_sym_abstract] = ACTIONS(2818),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2932),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_enum] = ACTIONS(2822),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [834] = {
    [sym_declaration] = STATE(1514),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_class_declaration] = STATE(1558),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_comment] = STATE(834),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1558),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(1557),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [aux_sym_export_statement_repeat1] = STATE(5398),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2738),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2663),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2669),
    [anon_sym_var] = ACTIONS(2671),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_COLON] = ACTIONS(2746),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2687),
    [anon_sym_EQ_GT] = ACTIONS(2689),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2700),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2708),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [835] = {
    [sym_comment] = STATE(835),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2405),
    [anon_sym_export] = ACTIONS(2405),
    [anon_sym_STAR] = ACTIONS(2405),
    [anon_sym_type] = ACTIONS(2405),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2405),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_let] = ACTIONS(2405),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(2405),
    [anon_sym_async] = ACTIONS(2405),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2405),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2405),
    [sym_private_property_identifier] = ACTIONS(2405),
    [anon_sym_static] = ACTIONS(2405),
    [anon_sym_readonly] = ACTIONS(2405),
    [anon_sym_get] = ACTIONS(2405),
    [anon_sym_set] = ACTIONS(2405),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2405),
    [anon_sym_public] = ACTIONS(2405),
    [anon_sym_private] = ACTIONS(2405),
    [anon_sym_protected] = ACTIONS(2405),
    [anon_sym_override] = ACTIONS(2405),
    [anon_sym_module] = ACTIONS(2405),
    [anon_sym_any] = ACTIONS(2405),
    [anon_sym_number] = ACTIONS(2405),
    [anon_sym_boolean] = ACTIONS(2405),
    [anon_sym_string] = ACTIONS(2405),
    [anon_sym_symbol] = ACTIONS(2405),
    [anon_sym_object] = ACTIONS(2405),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [836] = {
    [sym_comment] = STATE(836),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_STAR] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2403),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_let] = ACTIONS(2403),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [anon_sym_SQUOTE] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2403),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2403),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2403),
    [sym_private_property_identifier] = ACTIONS(2403),
    [anon_sym_static] = ACTIONS(2403),
    [anon_sym_readonly] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_override] = ACTIONS(2403),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_object] = ACTIONS(2403),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [837] = {
    [sym_declaration] = STATE(1377),
    [sym_variable_declaration] = STATE(1327),
    [sym_lexical_declaration] = STATE(1327),
    [sym_class_declaration] = STATE(1327),
    [sym_function_declaration] = STATE(1327),
    [sym_generator_function_declaration] = STATE(1327),
    [sym_comment] = STATE(837),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1327),
    [sym_ambient_declaration] = STATE(1327),
    [sym_abstract_class_declaration] = STATE(1327),
    [sym_module] = STATE(1327),
    [sym_internal_module] = STATE(1348),
    [sym_import_alias] = STATE(1327),
    [sym_interface_declaration] = STATE(1327),
    [sym_enum_declaration] = STATE(1327),
    [sym_type_alias_declaration] = STATE(1327),
    [aux_sym_export_statement_repeat1] = STATE(5102),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2758),
    [anon_sym_import] = ACTIONS(2760),
    [anon_sym_var] = ACTIONS(2762),
    [anon_sym_let] = ACTIONS(2764),
    [anon_sym_const] = ACTIONS(2766),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2770),
    [anon_sym_async] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2774),
    [anon_sym_EQ_GT] = ACTIONS(2934),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2776),
    [anon_sym_module] = ACTIONS(2924),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2926),
    [anon_sym_interface] = ACTIONS(2782),
    [anon_sym_enum] = ACTIONS(2784),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [838] = {
    [sym_declaration] = STATE(4945),
    [sym_variable_declaration] = STATE(5171),
    [sym_lexical_declaration] = STATE(5171),
    [sym_class_declaration] = STATE(5171),
    [sym_function_declaration] = STATE(5171),
    [sym_generator_function_declaration] = STATE(5171),
    [sym_comment] = STATE(838),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(5171),
    [sym_ambient_declaration] = STATE(5171),
    [sym_abstract_class_declaration] = STATE(5171),
    [sym_module] = STATE(5171),
    [sym_internal_module] = STATE(4878),
    [sym_import_alias] = STATE(5171),
    [sym_interface_declaration] = STATE(5171),
    [sym_enum_declaration] = STATE(5171),
    [sym_type_alias_declaration] = STATE(5171),
    [aux_sym_export_statement_repeat1] = STATE(5382),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2936),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2938),
    [anon_sym_import] = ACTIONS(2940),
    [anon_sym_var] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2944),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_async] = ACTIONS(2950),
    [anon_sym_function] = ACTIONS(2952),
    [anon_sym_EQ_GT] = ACTIONS(2934),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2954),
    [anon_sym_module] = ACTIONS(2956),
    [anon_sym_abstract] = ACTIONS(2958),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2960),
    [anon_sym_interface] = ACTIONS(2962),
    [anon_sym_enum] = ACTIONS(2964),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [839] = {
    [sym_declaration] = STATE(1514),
    [sym_variable_declaration] = STATE(1558),
    [sym_lexical_declaration] = STATE(1558),
    [sym_class_declaration] = STATE(1558),
    [sym_function_declaration] = STATE(1558),
    [sym_generator_function_declaration] = STATE(1558),
    [sym_comment] = STATE(839),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1558),
    [sym_ambient_declaration] = STATE(1558),
    [sym_abstract_class_declaration] = STATE(1558),
    [sym_module] = STATE(1558),
    [sym_internal_module] = STATE(1557),
    [sym_import_alias] = STATE(1558),
    [sym_interface_declaration] = STATE(1558),
    [sym_enum_declaration] = STATE(1558),
    [sym_type_alias_declaration] = STATE(1558),
    [aux_sym_export_statement_repeat1] = STATE(5398),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2738),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2663),
    [anon_sym_import] = ACTIONS(2669),
    [anon_sym_var] = ACTIONS(2671),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2687),
    [anon_sym_EQ_GT] = ACTIONS(2934),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2700),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2708),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [840] = {
    [sym_comment] = STATE(840),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_STAR] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2403),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_let] = ACTIONS(2403),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [anon_sym_SQUOTE] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2403),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2403),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2403),
    [sym_private_property_identifier] = ACTIONS(2403),
    [anon_sym_static] = ACTIONS(2403),
    [anon_sym_readonly] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_override] = ACTIONS(2403),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_object] = ACTIONS(2403),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [841] = {
    [sym_declaration] = STATE(6491),
    [sym_variable_declaration] = STATE(6360),
    [sym_lexical_declaration] = STATE(6360),
    [sym_class_declaration] = STATE(6360),
    [sym_function_declaration] = STATE(6360),
    [sym_generator_function_declaration] = STATE(6360),
    [sym_comment] = STATE(841),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(6360),
    [sym_ambient_declaration] = STATE(6360),
    [sym_abstract_class_declaration] = STATE(6360),
    [sym_module] = STATE(6360),
    [sym_internal_module] = STATE(6385),
    [sym_import_alias] = STATE(6360),
    [sym_interface_declaration] = STATE(6360),
    [sym_enum_declaration] = STATE(6360),
    [sym_type_alias_declaration] = STATE(6360),
    [aux_sym_export_statement_repeat1] = STATE(5201),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2928),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2796),
    [anon_sym_import] = ACTIONS(2798),
    [anon_sym_var] = ACTIONS(2800),
    [anon_sym_let] = ACTIONS(2802),
    [anon_sym_const] = ACTIONS(2804),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2808),
    [anon_sym_async] = ACTIONS(2810),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_EQ_GT] = ACTIONS(2934),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2814),
    [anon_sym_module] = ACTIONS(2930),
    [anon_sym_abstract] = ACTIONS(2818),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2932),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_enum] = ACTIONS(2822),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [842] = {
    [sym_declaration] = STATE(1086),
    [sym_variable_declaration] = STATE(1100),
    [sym_lexical_declaration] = STATE(1100),
    [sym_class_declaration] = STATE(1100),
    [sym_function_declaration] = STATE(1100),
    [sym_generator_function_declaration] = STATE(1100),
    [sym_comment] = STATE(842),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1100),
    [sym_ambient_declaration] = STATE(1100),
    [sym_abstract_class_declaration] = STATE(1100),
    [sym_module] = STATE(1100),
    [sym_internal_module] = STATE(1094),
    [sym_import_alias] = STATE(1100),
    [sym_interface_declaration] = STATE(1100),
    [sym_enum_declaration] = STATE(1100),
    [sym_type_alias_declaration] = STATE(1100),
    [aux_sym_export_statement_repeat1] = STATE(4991),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2916),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2834),
    [anon_sym_import] = ACTIONS(2836),
    [anon_sym_var] = ACTIONS(2838),
    [anon_sym_let] = ACTIONS(2840),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_async] = ACTIONS(2848),
    [anon_sym_function] = ACTIONS(2850),
    [anon_sym_EQ_GT] = ACTIONS(2934),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2852),
    [anon_sym_module] = ACTIONS(2918),
    [anon_sym_abstract] = ACTIONS(2856),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2920),
    [anon_sym_interface] = ACTIONS(2858),
    [anon_sym_enum] = ACTIONS(2860),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [843] = {
    [sym_comment] = STATE(843),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2405),
    [anon_sym_export] = ACTIONS(2405),
    [anon_sym_STAR] = ACTIONS(2405),
    [anon_sym_type] = ACTIONS(2405),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2405),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_let] = ACTIONS(2405),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(2405),
    [anon_sym_async] = ACTIONS(2405),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2405),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2405),
    [sym_private_property_identifier] = ACTIONS(2405),
    [anon_sym_static] = ACTIONS(2405),
    [anon_sym_readonly] = ACTIONS(2405),
    [anon_sym_get] = ACTIONS(2405),
    [anon_sym_set] = ACTIONS(2405),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2405),
    [anon_sym_public] = ACTIONS(2405),
    [anon_sym_private] = ACTIONS(2405),
    [anon_sym_protected] = ACTIONS(2405),
    [anon_sym_override] = ACTIONS(2405),
    [anon_sym_module] = ACTIONS(2405),
    [anon_sym_any] = ACTIONS(2405),
    [anon_sym_number] = ACTIONS(2405),
    [anon_sym_boolean] = ACTIONS(2405),
    [anon_sym_string] = ACTIONS(2405),
    [anon_sym_symbol] = ACTIONS(2405),
    [anon_sym_object] = ACTIONS(2405),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [844] = {
    [sym_comment] = STATE(844),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_STAR] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2403),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_let] = ACTIONS(2403),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [anon_sym_SQUOTE] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2403),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2403),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2403),
    [sym_private_property_identifier] = ACTIONS(2403),
    [anon_sym_static] = ACTIONS(2403),
    [anon_sym_readonly] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_override] = ACTIONS(2403),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_object] = ACTIONS(2403),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [845] = {
    [sym_comment] = STATE(845),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(2405),
    [anon_sym_export] = ACTIONS(2405),
    [anon_sym_STAR] = ACTIONS(2405),
    [anon_sym_type] = ACTIONS(2405),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2405),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_let] = ACTIONS(2405),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(2405),
    [anon_sym_async] = ACTIONS(2405),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2405),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2405),
    [sym_private_property_identifier] = ACTIONS(2405),
    [anon_sym_static] = ACTIONS(2405),
    [anon_sym_readonly] = ACTIONS(2405),
    [anon_sym_get] = ACTIONS(2405),
    [anon_sym_set] = ACTIONS(2405),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(2405),
    [anon_sym_public] = ACTIONS(2405),
    [anon_sym_private] = ACTIONS(2405),
    [anon_sym_protected] = ACTIONS(2405),
    [anon_sym_override] = ACTIONS(2405),
    [anon_sym_module] = ACTIONS(2405),
    [anon_sym_any] = ACTIONS(2405),
    [anon_sym_number] = ACTIONS(2405),
    [anon_sym_boolean] = ACTIONS(2405),
    [anon_sym_string] = ACTIONS(2405),
    [anon_sym_symbol] = ACTIONS(2405),
    [anon_sym_object] = ACTIONS(2405),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [846] = {
    [sym_declaration] = STATE(1332),
    [sym_variable_declaration] = STATE(1444),
    [sym_lexical_declaration] = STATE(1444),
    [sym_class_declaration] = STATE(1444),
    [sym_function_declaration] = STATE(1444),
    [sym_generator_function_declaration] = STATE(1444),
    [sym_comment] = STATE(846),
    [sym_decorator] = STATE(5410),
    [sym_function_signature] = STATE(1444),
    [sym_ambient_declaration] = STATE(1444),
    [sym_abstract_class_declaration] = STATE(1444),
    [sym_module] = STATE(1444),
    [sym_internal_module] = STATE(1399),
    [sym_import_alias] = STATE(1444),
    [sym_interface_declaration] = STATE(1444),
    [sym_enum_declaration] = STATE(1444),
    [sym_type_alias_declaration] = STATE(1444),
    [aux_sym_export_statement_repeat1] = STATE(5232),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2872),
    [anon_sym_import] = ACTIONS(2874),
    [anon_sym_var] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_const] = ACTIONS(2880),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_class] = ACTIONS(2884),
    [anon_sym_async] = ACTIONS(2886),
    [anon_sym_function] = ACTIONS(2888),
    [anon_sym_EQ_GT] = ACTIONS(2934),
    [anon_sym_QMARK_DOT] = ACTIONS(211),
    [anon_sym_PLUS_EQ] = ACTIONS(2691),
    [anon_sym_DASH_EQ] = ACTIONS(2691),
    [anon_sym_STAR_EQ] = ACTIONS(2691),
    [anon_sym_SLASH_EQ] = ACTIONS(2691),
    [anon_sym_PERCENT_EQ] = ACTIONS(2691),
    [anon_sym_CARET_EQ] = ACTIONS(2691),
    [anon_sym_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2691),
    [anon_sym_LT_LT_EQ] = ACTIONS(2691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(211),
    [anon_sym_PLUS_PLUS] = ACTIONS(211),
    [anon_sym_DASH_DASH] = ACTIONS(211),
    [aux_sym_comment_token1] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2890),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2894),
    [anon_sym_satisfies] = ACTIONS(211),
    [anon_sym_global] = ACTIONS(2914),
    [anon_sym_interface] = ACTIONS(2896),
    [anon_sym_enum] = ACTIONS(2898),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [847] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(847),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_COMMA] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_QMARK] = ACTIONS(1105),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [848] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(848),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [849] = {
    [sym__call_signature] = STATE(7230),
    [sym_comment] = STATE(849),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_export] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2980),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_RBRACE] = ACTIONS(216),
    [anon_sym_let] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_RPAREN] = ACTIONS(216),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2980),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_readonly] = ACTIONS(2980),
    [anon_sym_get] = ACTIONS(2980),
    [anon_sym_set] = ACTIONS(2980),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_declare] = ACTIONS(2980),
    [anon_sym_public] = ACTIONS(2980),
    [anon_sym_private] = ACTIONS(2980),
    [anon_sym_protected] = ACTIONS(2980),
    [anon_sym_override] = ACTIONS(2980),
    [anon_sym_module] = ACTIONS(2980),
    [anon_sym_any] = ACTIONS(2980),
    [anon_sym_number] = ACTIONS(2980),
    [anon_sym_boolean] = ACTIONS(2980),
    [anon_sym_string] = ACTIONS(2980),
    [anon_sym_symbol] = ACTIONS(2980),
    [anon_sym_object] = ACTIONS(2980),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [850] = {
    [sym__call_signature] = STATE(7230),
    [sym_comment] = STATE(850),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_export] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2980),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2980),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_readonly] = ACTIONS(2980),
    [anon_sym_get] = ACTIONS(2980),
    [anon_sym_set] = ACTIONS(2980),
    [anon_sym_declare] = ACTIONS(2980),
    [anon_sym_public] = ACTIONS(2980),
    [anon_sym_private] = ACTIONS(2980),
    [anon_sym_protected] = ACTIONS(2980),
    [anon_sym_override] = ACTIONS(2980),
    [anon_sym_module] = ACTIONS(2980),
    [anon_sym_any] = ACTIONS(2980),
    [anon_sym_number] = ACTIONS(2980),
    [anon_sym_boolean] = ACTIONS(2980),
    [anon_sym_string] = ACTIONS(2980),
    [anon_sym_symbol] = ACTIONS(2980),
    [anon_sym_object] = ACTIONS(2980),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [851] = {
    [sym__call_signature] = STATE(7230),
    [sym_comment] = STATE(851),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_export] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2980),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2980),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_readonly] = ACTIONS(2980),
    [anon_sym_get] = ACTIONS(2980),
    [anon_sym_set] = ACTIONS(2980),
    [anon_sym_declare] = ACTIONS(2980),
    [anon_sym_public] = ACTIONS(2980),
    [anon_sym_private] = ACTIONS(2980),
    [anon_sym_protected] = ACTIONS(2980),
    [anon_sym_override] = ACTIONS(2980),
    [anon_sym_module] = ACTIONS(2980),
    [anon_sym_any] = ACTIONS(2980),
    [anon_sym_number] = ACTIONS(2980),
    [anon_sym_boolean] = ACTIONS(2980),
    [anon_sym_string] = ACTIONS(2980),
    [anon_sym_symbol] = ACTIONS(2980),
    [anon_sym_object] = ACTIONS(2980),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [852] = {
    [sym__call_signature] = STATE(7260),
    [sym_comment] = STATE(852),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_export] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2984),
    [anon_sym_function] = ACTIONS(2986),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2984),
    [anon_sym_readonly] = ACTIONS(2984),
    [anon_sym_get] = ACTIONS(2984),
    [anon_sym_set] = ACTIONS(2984),
    [anon_sym_declare] = ACTIONS(2984),
    [anon_sym_public] = ACTIONS(2984),
    [anon_sym_private] = ACTIONS(2984),
    [anon_sym_protected] = ACTIONS(2984),
    [anon_sym_override] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_any] = ACTIONS(2984),
    [anon_sym_number] = ACTIONS(2984),
    [anon_sym_boolean] = ACTIONS(2984),
    [anon_sym_string] = ACTIONS(2984),
    [anon_sym_symbol] = ACTIONS(2984),
    [anon_sym_object] = ACTIONS(2984),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [853] = {
    [sym__call_signature] = STATE(7260),
    [sym_comment] = STATE(853),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_export] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2984),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2984),
    [anon_sym_readonly] = ACTIONS(2984),
    [anon_sym_get] = ACTIONS(2984),
    [anon_sym_set] = ACTIONS(2984),
    [anon_sym_declare] = ACTIONS(2984),
    [anon_sym_public] = ACTIONS(2984),
    [anon_sym_private] = ACTIONS(2984),
    [anon_sym_protected] = ACTIONS(2984),
    [anon_sym_override] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_any] = ACTIONS(2984),
    [anon_sym_number] = ACTIONS(2984),
    [anon_sym_boolean] = ACTIONS(2984),
    [anon_sym_string] = ACTIONS(2984),
    [anon_sym_symbol] = ACTIONS(2984),
    [anon_sym_object] = ACTIONS(2984),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [854] = {
    [sym__call_signature] = STATE(7260),
    [sym_comment] = STATE(854),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_export] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_of] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2984),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2984),
    [anon_sym_readonly] = ACTIONS(2984),
    [anon_sym_get] = ACTIONS(2984),
    [anon_sym_set] = ACTIONS(2984),
    [anon_sym_declare] = ACTIONS(2984),
    [anon_sym_public] = ACTIONS(2984),
    [anon_sym_private] = ACTIONS(2984),
    [anon_sym_protected] = ACTIONS(2984),
    [anon_sym_override] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_any] = ACTIONS(2984),
    [anon_sym_number] = ACTIONS(2984),
    [anon_sym_boolean] = ACTIONS(2984),
    [anon_sym_string] = ACTIONS(2984),
    [anon_sym_symbol] = ACTIONS(2984),
    [anon_sym_object] = ACTIONS(2984),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [855] = {
    [sym__call_signature] = STATE(7099),
    [sym_comment] = STATE(855),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2990),
    [anon_sym_export] = ACTIONS(2992),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2992),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_EQ_GT] = ACTIONS(1179),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2992),
    [anon_sym_readonly] = ACTIONS(2992),
    [anon_sym_get] = ACTIONS(2992),
    [anon_sym_set] = ACTIONS(2992),
    [anon_sym_declare] = ACTIONS(2992),
    [anon_sym_public] = ACTIONS(2992),
    [anon_sym_private] = ACTIONS(2992),
    [anon_sym_protected] = ACTIONS(2992),
    [anon_sym_override] = ACTIONS(2992),
    [anon_sym_module] = ACTIONS(2992),
    [anon_sym_any] = ACTIONS(2992),
    [anon_sym_number] = ACTIONS(2992),
    [anon_sym_boolean] = ACTIONS(2992),
    [anon_sym_string] = ACTIONS(2992),
    [anon_sym_symbol] = ACTIONS(2992),
    [anon_sym_object] = ACTIONS(2992),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [856] = {
    [sym__call_signature] = STATE(7260),
    [sym_comment] = STATE(856),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_export] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2984),
    [anon_sym_function] = ACTIONS(2994),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2984),
    [anon_sym_readonly] = ACTIONS(2984),
    [anon_sym_get] = ACTIONS(2984),
    [anon_sym_set] = ACTIONS(2984),
    [anon_sym_declare] = ACTIONS(2984),
    [anon_sym_public] = ACTIONS(2984),
    [anon_sym_private] = ACTIONS(2984),
    [anon_sym_protected] = ACTIONS(2984),
    [anon_sym_override] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_any] = ACTIONS(2984),
    [anon_sym_number] = ACTIONS(2984),
    [anon_sym_boolean] = ACTIONS(2984),
    [anon_sym_string] = ACTIONS(2984),
    [anon_sym_symbol] = ACTIONS(2984),
    [anon_sym_object] = ACTIONS(2984),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [857] = {
    [sym__call_signature] = STATE(7260),
    [sym_comment] = STATE(857),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_export] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2984),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2984),
    [anon_sym_readonly] = ACTIONS(2984),
    [anon_sym_get] = ACTIONS(2984),
    [anon_sym_set] = ACTIONS(2984),
    [anon_sym_declare] = ACTIONS(2984),
    [anon_sym_public] = ACTIONS(2984),
    [anon_sym_private] = ACTIONS(2984),
    [anon_sym_protected] = ACTIONS(2984),
    [anon_sym_override] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_any] = ACTIONS(2984),
    [anon_sym_number] = ACTIONS(2984),
    [anon_sym_boolean] = ACTIONS(2984),
    [anon_sym_string] = ACTIONS(2984),
    [anon_sym_symbol] = ACTIONS(2984),
    [anon_sym_object] = ACTIONS(2984),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [858] = {
    [sym__call_signature] = STATE(7260),
    [sym_comment] = STATE(858),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_export] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2984),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2984),
    [anon_sym_readonly] = ACTIONS(2984),
    [anon_sym_get] = ACTIONS(2984),
    [anon_sym_set] = ACTIONS(2984),
    [anon_sym_declare] = ACTIONS(2984),
    [anon_sym_public] = ACTIONS(2984),
    [anon_sym_private] = ACTIONS(2984),
    [anon_sym_protected] = ACTIONS(2984),
    [anon_sym_override] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_any] = ACTIONS(2984),
    [anon_sym_number] = ACTIONS(2984),
    [anon_sym_boolean] = ACTIONS(2984),
    [anon_sym_string] = ACTIONS(2984),
    [anon_sym_symbol] = ACTIONS(2984),
    [anon_sym_object] = ACTIONS(2984),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [859] = {
    [sym__call_signature] = STATE(7230),
    [sym_comment] = STATE(859),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_export] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2980),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(1208),
    [anon_sym_let] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2980),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_readonly] = ACTIONS(2980),
    [anon_sym_get] = ACTIONS(2980),
    [anon_sym_set] = ACTIONS(2980),
    [anon_sym_declare] = ACTIONS(2980),
    [anon_sym_public] = ACTIONS(2980),
    [anon_sym_private] = ACTIONS(2980),
    [anon_sym_protected] = ACTIONS(2980),
    [anon_sym_override] = ACTIONS(2980),
    [anon_sym_module] = ACTIONS(2980),
    [anon_sym_any] = ACTIONS(2980),
    [anon_sym_number] = ACTIONS(2980),
    [anon_sym_boolean] = ACTIONS(2980),
    [anon_sym_string] = ACTIONS(2980),
    [anon_sym_symbol] = ACTIONS(2980),
    [anon_sym_object] = ACTIONS(2980),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [860] = {
    [sym__call_signature] = STATE(7260),
    [sym_comment] = STATE(860),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_export] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2984),
    [anon_sym_function] = ACTIONS(2998),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2984),
    [anon_sym_readonly] = ACTIONS(2984),
    [anon_sym_get] = ACTIONS(2984),
    [anon_sym_set] = ACTIONS(2984),
    [anon_sym_declare] = ACTIONS(2984),
    [anon_sym_public] = ACTIONS(2984),
    [anon_sym_private] = ACTIONS(2984),
    [anon_sym_protected] = ACTIONS(2984),
    [anon_sym_override] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_any] = ACTIONS(2984),
    [anon_sym_number] = ACTIONS(2984),
    [anon_sym_boolean] = ACTIONS(2984),
    [anon_sym_string] = ACTIONS(2984),
    [anon_sym_symbol] = ACTIONS(2984),
    [anon_sym_object] = ACTIONS(2984),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [861] = {
    [sym__call_signature] = STATE(7099),
    [sym_comment] = STATE(861),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2990),
    [anon_sym_export] = ACTIONS(2992),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2992),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_EQ_GT] = ACTIONS(1179),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2992),
    [anon_sym_readonly] = ACTIONS(2992),
    [anon_sym_get] = ACTIONS(2992),
    [anon_sym_set] = ACTIONS(2992),
    [anon_sym_declare] = ACTIONS(2992),
    [anon_sym_public] = ACTIONS(2992),
    [anon_sym_private] = ACTIONS(2992),
    [anon_sym_protected] = ACTIONS(2992),
    [anon_sym_override] = ACTIONS(2992),
    [anon_sym_module] = ACTIONS(2992),
    [anon_sym_any] = ACTIONS(2992),
    [anon_sym_number] = ACTIONS(2992),
    [anon_sym_boolean] = ACTIONS(2992),
    [anon_sym_string] = ACTIONS(2992),
    [anon_sym_symbol] = ACTIONS(2992),
    [anon_sym_object] = ACTIONS(2992),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [862] = {
    [sym__call_signature] = STATE(7260),
    [sym_comment] = STATE(862),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_export] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2984),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2984),
    [anon_sym_readonly] = ACTIONS(2984),
    [anon_sym_get] = ACTIONS(2984),
    [anon_sym_set] = ACTIONS(2984),
    [anon_sym_declare] = ACTIONS(2984),
    [anon_sym_public] = ACTIONS(2984),
    [anon_sym_private] = ACTIONS(2984),
    [anon_sym_protected] = ACTIONS(2984),
    [anon_sym_override] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_any] = ACTIONS(2984),
    [anon_sym_number] = ACTIONS(2984),
    [anon_sym_boolean] = ACTIONS(2984),
    [anon_sym_string] = ACTIONS(2984),
    [anon_sym_symbol] = ACTIONS(2984),
    [anon_sym_object] = ACTIONS(2984),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [863] = {
    [sym__call_signature] = STATE(7299),
    [sym_comment] = STATE(863),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3002),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3002),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1266),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_readonly] = ACTIONS(3002),
    [anon_sym_get] = ACTIONS(3002),
    [anon_sym_set] = ACTIONS(3002),
    [anon_sym_declare] = ACTIONS(3002),
    [anon_sym_public] = ACTIONS(3002),
    [anon_sym_private] = ACTIONS(3002),
    [anon_sym_protected] = ACTIONS(3002),
    [anon_sym_override] = ACTIONS(3002),
    [anon_sym_module] = ACTIONS(3002),
    [anon_sym_any] = ACTIONS(3002),
    [anon_sym_number] = ACTIONS(3002),
    [anon_sym_boolean] = ACTIONS(3002),
    [anon_sym_string] = ACTIONS(3002),
    [anon_sym_symbol] = ACTIONS(3002),
    [anon_sym_object] = ACTIONS(3002),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [864] = {
    [sym__call_signature] = STATE(7323),
    [sym_comment] = STATE(864),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3004),
    [anon_sym_export] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3006),
    [anon_sym_EQ] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3006),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3006),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3006),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3006),
    [anon_sym_readonly] = ACTIONS(3006),
    [anon_sym_get] = ACTIONS(3006),
    [anon_sym_set] = ACTIONS(3006),
    [anon_sym_declare] = ACTIONS(3006),
    [anon_sym_public] = ACTIONS(3006),
    [anon_sym_private] = ACTIONS(3006),
    [anon_sym_protected] = ACTIONS(3006),
    [anon_sym_override] = ACTIONS(3006),
    [anon_sym_module] = ACTIONS(3006),
    [anon_sym_any] = ACTIONS(3006),
    [anon_sym_number] = ACTIONS(3006),
    [anon_sym_boolean] = ACTIONS(3006),
    [anon_sym_string] = ACTIONS(3006),
    [anon_sym_symbol] = ACTIONS(3006),
    [anon_sym_object] = ACTIONS(3006),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [865] = {
    [sym__call_signature] = STATE(7299),
    [sym_comment] = STATE(865),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3002),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3002),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3002),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1266),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_readonly] = ACTIONS(3002),
    [anon_sym_get] = ACTIONS(3002),
    [anon_sym_set] = ACTIONS(3002),
    [anon_sym_declare] = ACTIONS(3002),
    [anon_sym_public] = ACTIONS(3002),
    [anon_sym_private] = ACTIONS(3002),
    [anon_sym_protected] = ACTIONS(3002),
    [anon_sym_override] = ACTIONS(3002),
    [anon_sym_module] = ACTIONS(3002),
    [anon_sym_any] = ACTIONS(3002),
    [anon_sym_number] = ACTIONS(3002),
    [anon_sym_boolean] = ACTIONS(3002),
    [anon_sym_string] = ACTIONS(3002),
    [anon_sym_symbol] = ACTIONS(3002),
    [anon_sym_object] = ACTIONS(3002),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [866] = {
    [sym__call_signature] = STATE(7323),
    [sym_comment] = STATE(866),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3004),
    [anon_sym_export] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3006),
    [anon_sym_EQ] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3006),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3006),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3006),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3006),
    [anon_sym_readonly] = ACTIONS(3006),
    [anon_sym_get] = ACTIONS(3006),
    [anon_sym_set] = ACTIONS(3006),
    [anon_sym_declare] = ACTIONS(3006),
    [anon_sym_public] = ACTIONS(3006),
    [anon_sym_private] = ACTIONS(3006),
    [anon_sym_protected] = ACTIONS(3006),
    [anon_sym_override] = ACTIONS(3006),
    [anon_sym_module] = ACTIONS(3006),
    [anon_sym_any] = ACTIONS(3006),
    [anon_sym_number] = ACTIONS(3006),
    [anon_sym_boolean] = ACTIONS(3006),
    [anon_sym_string] = ACTIONS(3006),
    [anon_sym_symbol] = ACTIONS(3006),
    [anon_sym_object] = ACTIONS(3006),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [867] = {
    [sym_catch_clause] = STATE(896),
    [sym_finally_clause] = STATE(963),
    [sym_comment] = STATE(867),
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_export] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_type] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3008),
    [anon_sym_typeof] = ACTIONS(3008),
    [anon_sym_import] = ACTIONS(3008),
    [anon_sym_with] = ACTIONS(3008),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_BANG] = ACTIONS(3008),
    [anon_sym_else] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_LPAREN] = ACTIONS(3008),
    [anon_sym_await] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_debugger] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_catch] = ACTIONS(3010),
    [anon_sym_finally] = ACTIONS(3012),
    [anon_sym_yield] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_LTtemplate_GT] = ACTIONS(3008),
    [anon_sym_DQUOTE] = ACTIONS(3008),
    [anon_sym_SQUOTE] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_async] = ACTIONS(3008),
    [anon_sym_function] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_SLASH] = ACTIONS(3008),
    [anon_sym_LT] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3008),
    [anon_sym_void] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3008),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3008),
    [sym_number] = ACTIONS(3008),
    [sym_private_property_identifier] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
    [sym_super] = ACTIONS(3008),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [sym_null] = ACTIONS(3008),
    [sym_undefined] = ACTIONS(3008),
    [anon_sym_AT] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_readonly] = ACTIONS(3008),
    [anon_sym_get] = ACTIONS(3008),
    [anon_sym_set] = ACTIONS(3008),
    [anon_sym_declare] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_override] = ACTIONS(3008),
    [anon_sym_module] = ACTIONS(3008),
    [anon_sym_any] = ACTIONS(3008),
    [anon_sym_number] = ACTIONS(3008),
    [anon_sym_boolean] = ACTIONS(3008),
    [anon_sym_string] = ACTIONS(3008),
    [anon_sym_symbol] = ACTIONS(3008),
    [anon_sym_object] = ACTIONS(3008),
    [anon_sym_abstract] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [sym_html_comment] = ACTIONS(5),
  },
  [868] = {
    [sym__call_signature] = STATE(7206),
    [sym_comment] = STATE(868),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(2986),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_readonly] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_override] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_object] = ACTIONS(3016),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [869] = {
    [sym__call_signature] = STATE(7206),
    [sym_comment] = STATE(869),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_readonly] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_override] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_object] = ACTIONS(3016),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [870] = {
    [sym__call_signature] = STATE(7206),
    [sym_comment] = STATE(870),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_readonly] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_override] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_object] = ACTIONS(3016),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [871] = {
    [sym__call_signature] = STATE(7206),
    [sym_comment] = STATE(871),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_readonly] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_override] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_object] = ACTIONS(3016),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [872] = {
    [sym__call_signature] = STATE(6996),
    [sym_comment] = STATE(872),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3018),
    [anon_sym_export] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3020),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3020),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1252),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_readonly] = ACTIONS(3020),
    [anon_sym_get] = ACTIONS(3020),
    [anon_sym_set] = ACTIONS(3020),
    [anon_sym_declare] = ACTIONS(3020),
    [anon_sym_public] = ACTIONS(3020),
    [anon_sym_private] = ACTIONS(3020),
    [anon_sym_protected] = ACTIONS(3020),
    [anon_sym_override] = ACTIONS(3020),
    [anon_sym_module] = ACTIONS(3020),
    [anon_sym_any] = ACTIONS(3020),
    [anon_sym_number] = ACTIONS(3020),
    [anon_sym_boolean] = ACTIONS(3020),
    [anon_sym_string] = ACTIONS(3020),
    [anon_sym_symbol] = ACTIONS(3020),
    [anon_sym_object] = ACTIONS(3020),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [873] = {
    [sym__call_signature] = STATE(7206),
    [sym_comment] = STATE(873),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_readonly] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_override] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_object] = ACTIONS(3016),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [874] = {
    [sym__call_signature] = STATE(7206),
    [sym_comment] = STATE(874),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(2994),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_readonly] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_override] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_object] = ACTIONS(3016),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [875] = {
    [sym__call_signature] = STATE(6996),
    [sym_comment] = STATE(875),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3018),
    [anon_sym_export] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3020),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3020),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1252),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_readonly] = ACTIONS(3020),
    [anon_sym_get] = ACTIONS(3020),
    [anon_sym_set] = ACTIONS(3020),
    [anon_sym_declare] = ACTIONS(3020),
    [anon_sym_public] = ACTIONS(3020),
    [anon_sym_private] = ACTIONS(3020),
    [anon_sym_protected] = ACTIONS(3020),
    [anon_sym_override] = ACTIONS(3020),
    [anon_sym_module] = ACTIONS(3020),
    [anon_sym_any] = ACTIONS(3020),
    [anon_sym_number] = ACTIONS(3020),
    [anon_sym_boolean] = ACTIONS(3020),
    [anon_sym_string] = ACTIONS(3020),
    [anon_sym_symbol] = ACTIONS(3020),
    [anon_sym_object] = ACTIONS(3020),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [876] = {
    [sym__call_signature] = STATE(7206),
    [sym_comment] = STATE(876),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(2998),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_readonly] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_override] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_object] = ACTIONS(3016),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [877] = {
    [sym__call_signature] = STATE(7323),
    [sym_comment] = STATE(877),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3004),
    [anon_sym_export] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3006),
    [anon_sym_EQ] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3006),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3006),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3006),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3006),
    [anon_sym_readonly] = ACTIONS(3006),
    [anon_sym_get] = ACTIONS(3006),
    [anon_sym_set] = ACTIONS(3006),
    [anon_sym_declare] = ACTIONS(3006),
    [anon_sym_public] = ACTIONS(3006),
    [anon_sym_private] = ACTIONS(3006),
    [anon_sym_protected] = ACTIONS(3006),
    [anon_sym_override] = ACTIONS(3006),
    [anon_sym_module] = ACTIONS(3006),
    [anon_sym_any] = ACTIONS(3006),
    [anon_sym_number] = ACTIONS(3006),
    [anon_sym_boolean] = ACTIONS(3006),
    [anon_sym_string] = ACTIONS(3006),
    [anon_sym_symbol] = ACTIONS(3006),
    [anon_sym_object] = ACTIONS(3006),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [878] = {
    [sym__call_signature] = STATE(7323),
    [sym_comment] = STATE(878),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3004),
    [anon_sym_export] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3006),
    [anon_sym_EQ] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3006),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3006),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3006),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3006),
    [anon_sym_readonly] = ACTIONS(3006),
    [anon_sym_get] = ACTIONS(3006),
    [anon_sym_set] = ACTIONS(3006),
    [anon_sym_declare] = ACTIONS(3006),
    [anon_sym_public] = ACTIONS(3006),
    [anon_sym_private] = ACTIONS(3006),
    [anon_sym_protected] = ACTIONS(3006),
    [anon_sym_override] = ACTIONS(3006),
    [anon_sym_module] = ACTIONS(3006),
    [anon_sym_any] = ACTIONS(3006),
    [anon_sym_number] = ACTIONS(3006),
    [anon_sym_boolean] = ACTIONS(3006),
    [anon_sym_string] = ACTIONS(3006),
    [anon_sym_symbol] = ACTIONS(3006),
    [anon_sym_object] = ACTIONS(3006),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [879] = {
    [sym__call_signature] = STATE(7206),
    [sym_comment] = STATE(879),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_EQ] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(3022),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_readonly] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_override] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_object] = ACTIONS(3016),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [880] = {
    [sym__call_signature] = STATE(7323),
    [sym_comment] = STATE(880),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3004),
    [anon_sym_export] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3006),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3006),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3006),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3006),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3006),
    [anon_sym_readonly] = ACTIONS(3006),
    [anon_sym_get] = ACTIONS(3006),
    [anon_sym_set] = ACTIONS(3006),
    [anon_sym_declare] = ACTIONS(3006),
    [anon_sym_public] = ACTIONS(3006),
    [anon_sym_private] = ACTIONS(3006),
    [anon_sym_protected] = ACTIONS(3006),
    [anon_sym_override] = ACTIONS(3006),
    [anon_sym_module] = ACTIONS(3006),
    [anon_sym_any] = ACTIONS(3006),
    [anon_sym_number] = ACTIONS(3006),
    [anon_sym_boolean] = ACTIONS(3006),
    [anon_sym_string] = ACTIONS(3006),
    [anon_sym_symbol] = ACTIONS(3006),
    [anon_sym_object] = ACTIONS(3006),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [881] = {
    [sym_catch_clause] = STATE(934),
    [sym_finally_clause] = STATE(1160),
    [sym_comment] = STATE(881),
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_export] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_type] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3008),
    [anon_sym_typeof] = ACTIONS(3008),
    [anon_sym_import] = ACTIONS(3008),
    [anon_sym_with] = ACTIONS(3008),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_BANG] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_LPAREN] = ACTIONS(3008),
    [anon_sym_await] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_debugger] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_catch] = ACTIONS(3024),
    [anon_sym_finally] = ACTIONS(3026),
    [anon_sym_yield] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_LTtemplate_GT] = ACTIONS(3008),
    [anon_sym_DQUOTE] = ACTIONS(3008),
    [anon_sym_SQUOTE] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_async] = ACTIONS(3008),
    [anon_sym_function] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_SLASH] = ACTIONS(3008),
    [anon_sym_LT] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3008),
    [anon_sym_void] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3008),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3008),
    [sym_number] = ACTIONS(3008),
    [sym_private_property_identifier] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
    [sym_super] = ACTIONS(3008),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [sym_null] = ACTIONS(3008),
    [sym_undefined] = ACTIONS(3008),
    [anon_sym_AT] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_readonly] = ACTIONS(3008),
    [anon_sym_get] = ACTIONS(3008),
    [anon_sym_set] = ACTIONS(3008),
    [anon_sym_declare] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_override] = ACTIONS(3008),
    [anon_sym_module] = ACTIONS(3008),
    [anon_sym_any] = ACTIONS(3008),
    [anon_sym_number] = ACTIONS(3008),
    [anon_sym_boolean] = ACTIONS(3008),
    [anon_sym_string] = ACTIONS(3008),
    [anon_sym_symbol] = ACTIONS(3008),
    [anon_sym_object] = ACTIONS(3008),
    [anon_sym_abstract] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [sym_html_comment] = ACTIONS(5),
  },
  [882] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(882),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [883] = {
    [sym_catch_clause] = STATE(954),
    [sym_finally_clause] = STATE(1200),
    [sym_comment] = STATE(883),
    [ts_builtin_sym_end] = ACTIONS(3028),
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_export] = ACTIONS(3008),
    [anon_sym_type] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3008),
    [anon_sym_typeof] = ACTIONS(3008),
    [anon_sym_import] = ACTIONS(3008),
    [anon_sym_with] = ACTIONS(3008),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_BANG] = ACTIONS(3008),
    [anon_sym_else] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_LPAREN] = ACTIONS(3008),
    [anon_sym_await] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_debugger] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym_catch] = ACTIONS(3030),
    [anon_sym_finally] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_LTtemplate_GT] = ACTIONS(3008),
    [anon_sym_DQUOTE] = ACTIONS(3008),
    [anon_sym_SQUOTE] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_async] = ACTIONS(3008),
    [anon_sym_function] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_SLASH] = ACTIONS(3008),
    [anon_sym_LT] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3008),
    [anon_sym_void] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3008),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3008),
    [sym_number] = ACTIONS(3008),
    [sym_private_property_identifier] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
    [sym_super] = ACTIONS(3008),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [sym_null] = ACTIONS(3008),
    [sym_undefined] = ACTIONS(3008),
    [anon_sym_AT] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_readonly] = ACTIONS(3008),
    [anon_sym_get] = ACTIONS(3008),
    [anon_sym_set] = ACTIONS(3008),
    [anon_sym_declare] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_override] = ACTIONS(3008),
    [anon_sym_module] = ACTIONS(3008),
    [anon_sym_any] = ACTIONS(3008),
    [anon_sym_number] = ACTIONS(3008),
    [anon_sym_boolean] = ACTIONS(3008),
    [anon_sym_string] = ACTIONS(3008),
    [anon_sym_symbol] = ACTIONS(3008),
    [anon_sym_object] = ACTIONS(3008),
    [anon_sym_abstract] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [sym_html_comment] = ACTIONS(5),
  },
  [884] = {
    [sym__call_signature] = STATE(7207),
    [sym_comment] = STATE(884),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3034),
    [anon_sym_export] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3036),
    [anon_sym_EQ] = ACTIONS(1280),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3036),
    [anon_sym_let] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3036),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1286),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_readonly] = ACTIONS(3036),
    [anon_sym_get] = ACTIONS(3036),
    [anon_sym_set] = ACTIONS(3036),
    [anon_sym_declare] = ACTIONS(3036),
    [anon_sym_public] = ACTIONS(3036),
    [anon_sym_private] = ACTIONS(3036),
    [anon_sym_protected] = ACTIONS(3036),
    [anon_sym_override] = ACTIONS(3036),
    [anon_sym_module] = ACTIONS(3036),
    [anon_sym_any] = ACTIONS(3036),
    [anon_sym_number] = ACTIONS(3036),
    [anon_sym_boolean] = ACTIONS(3036),
    [anon_sym_string] = ACTIONS(3036),
    [anon_sym_symbol] = ACTIONS(3036),
    [anon_sym_object] = ACTIONS(3036),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [885] = {
    [sym__call_signature] = STATE(7207),
    [sym_comment] = STATE(885),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3034),
    [anon_sym_export] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3036),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3036),
    [anon_sym_let] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3036),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1286),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_readonly] = ACTIONS(3036),
    [anon_sym_get] = ACTIONS(3036),
    [anon_sym_set] = ACTIONS(3036),
    [anon_sym_declare] = ACTIONS(3036),
    [anon_sym_public] = ACTIONS(3036),
    [anon_sym_private] = ACTIONS(3036),
    [anon_sym_protected] = ACTIONS(3036),
    [anon_sym_override] = ACTIONS(3036),
    [anon_sym_module] = ACTIONS(3036),
    [anon_sym_any] = ACTIONS(3036),
    [anon_sym_number] = ACTIONS(3036),
    [anon_sym_boolean] = ACTIONS(3036),
    [anon_sym_string] = ACTIONS(3036),
    [anon_sym_symbol] = ACTIONS(3036),
    [anon_sym_object] = ACTIONS(3036),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [886] = {
    [sym_comment] = STATE(886),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_catch] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3038),
    [sym_html_comment] = ACTIONS(5),
  },
  [887] = {
    [sym_comment] = STATE(887),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_catch] = ACTIONS(2067),
    [anon_sym_finally] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3040),
    [sym_html_comment] = ACTIONS(5),
  },
  [888] = {
    [sym__call_signature] = STATE(7323),
    [sym_comment] = STATE(888),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(3004),
    [anon_sym_export] = ACTIONS(3006),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3006),
    [anon_sym_EQ] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3006),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3006),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3006),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3006),
    [anon_sym_readonly] = ACTIONS(3006),
    [anon_sym_get] = ACTIONS(3006),
    [anon_sym_set] = ACTIONS(3006),
    [anon_sym_declare] = ACTIONS(3006),
    [anon_sym_public] = ACTIONS(3006),
    [anon_sym_private] = ACTIONS(3006),
    [anon_sym_protected] = ACTIONS(3006),
    [anon_sym_override] = ACTIONS(3006),
    [anon_sym_module] = ACTIONS(3006),
    [anon_sym_any] = ACTIONS(3006),
    [anon_sym_number] = ACTIONS(3006),
    [anon_sym_boolean] = ACTIONS(3006),
    [anon_sym_string] = ACTIONS(3006),
    [anon_sym_symbol] = ACTIONS(3006),
    [anon_sym_object] = ACTIONS(3006),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [889] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(889),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_of] = ACTIONS(1206),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [890] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(890),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [891] = {
    [sym_statement_block] = STATE(1102),
    [sym_comment] = STATE(891),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [892] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(892),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1346),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [893] = {
    [sym_comment] = STATE(893),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_catch] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3046),
    [sym_html_comment] = ACTIONS(5),
  },
  [894] = {
    [sym_catch_clause] = STATE(1145),
    [sym_finally_clause] = STATE(1484),
    [sym_comment] = STATE(894),
    [ts_builtin_sym_end] = ACTIONS(3028),
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_export] = ACTIONS(3008),
    [anon_sym_type] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3008),
    [anon_sym_typeof] = ACTIONS(3008),
    [anon_sym_import] = ACTIONS(3008),
    [anon_sym_with] = ACTIONS(3008),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_BANG] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_LPAREN] = ACTIONS(3008),
    [anon_sym_await] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_debugger] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym_catch] = ACTIONS(3048),
    [anon_sym_finally] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_LTtemplate_GT] = ACTIONS(3008),
    [anon_sym_DQUOTE] = ACTIONS(3008),
    [anon_sym_SQUOTE] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_async] = ACTIONS(3008),
    [anon_sym_function] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_SLASH] = ACTIONS(3008),
    [anon_sym_LT] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3008),
    [anon_sym_void] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3008),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3008),
    [sym_number] = ACTIONS(3008),
    [sym_private_property_identifier] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
    [sym_super] = ACTIONS(3008),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [sym_null] = ACTIONS(3008),
    [sym_undefined] = ACTIONS(3008),
    [anon_sym_AT] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_readonly] = ACTIONS(3008),
    [anon_sym_get] = ACTIONS(3008),
    [anon_sym_set] = ACTIONS(3008),
    [anon_sym_declare] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_override] = ACTIONS(3008),
    [anon_sym_module] = ACTIONS(3008),
    [anon_sym_any] = ACTIONS(3008),
    [anon_sym_number] = ACTIONS(3008),
    [anon_sym_boolean] = ACTIONS(3008),
    [anon_sym_string] = ACTIONS(3008),
    [anon_sym_symbol] = ACTIONS(3008),
    [anon_sym_object] = ACTIONS(3008),
    [anon_sym_abstract] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [sym_html_comment] = ACTIONS(5),
  },
  [895] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(895),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [896] = {
    [sym_finally_clause] = STATE(1134),
    [sym_comment] = STATE(896),
    [sym_identifier] = ACTIONS(3052),
    [anon_sym_export] = ACTIONS(3052),
    [anon_sym_default] = ACTIONS(3052),
    [anon_sym_type] = ACTIONS(3052),
    [anon_sym_namespace] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_typeof] = ACTIONS(3052),
    [anon_sym_import] = ACTIONS(3052),
    [anon_sym_with] = ACTIONS(3052),
    [anon_sym_var] = ACTIONS(3052),
    [anon_sym_let] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_else] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [anon_sym_await] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_debugger] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_throw] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3052),
    [anon_sym_finally] = ACTIONS(3012),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_LTtemplate_GT] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_async] = ACTIONS(3052),
    [anon_sym_function] = ACTIONS(3052),
    [anon_sym_new] = ACTIONS(3052),
    [anon_sym_using] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_void] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3052),
    [sym_number] = ACTIONS(3052),
    [sym_private_property_identifier] = ACTIONS(3052),
    [sym_this] = ACTIONS(3052),
    [sym_super] = ACTIONS(3052),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [sym_null] = ACTIONS(3052),
    [sym_undefined] = ACTIONS(3052),
    [anon_sym_AT] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_readonly] = ACTIONS(3052),
    [anon_sym_get] = ACTIONS(3052),
    [anon_sym_set] = ACTIONS(3052),
    [anon_sym_declare] = ACTIONS(3052),
    [anon_sym_public] = ACTIONS(3052),
    [anon_sym_private] = ACTIONS(3052),
    [anon_sym_protected] = ACTIONS(3052),
    [anon_sym_override] = ACTIONS(3052),
    [anon_sym_module] = ACTIONS(3052),
    [anon_sym_any] = ACTIONS(3052),
    [anon_sym_number] = ACTIONS(3052),
    [anon_sym_boolean] = ACTIONS(3052),
    [anon_sym_string] = ACTIONS(3052),
    [anon_sym_symbol] = ACTIONS(3052),
    [anon_sym_object] = ACTIONS(3052),
    [anon_sym_abstract] = ACTIONS(3052),
    [anon_sym_interface] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [sym_html_comment] = ACTIONS(5),
  },
  [897] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(897),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1294),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [898] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(898),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [899] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(899),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1356),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [900] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(900),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [901] = {
    [sym_comment] = STATE(901),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_catch] = ACTIONS(2067),
    [anon_sym_finally] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3054),
    [sym_html_comment] = ACTIONS(5),
  },
  [902] = {
    [sym_comment] = STATE(902),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_catch] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3056),
    [sym_html_comment] = ACTIONS(5),
  },
  [903] = {
    [sym_comment] = STATE(903),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_finally] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3058),
    [sym_html_comment] = ACTIONS(5),
  },
  [904] = {
    [sym_comment] = STATE(904),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_catch] = ACTIONS(2221),
    [anon_sym_finally] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [905] = {
    [sym_comment] = STATE(905),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_catch] = ACTIONS(2067),
    [anon_sym_finally] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3060),
    [sym_html_comment] = ACTIONS(5),
  },
  [906] = {
    [sym_comment] = STATE(906),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_catch] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [907] = {
    [sym_comment] = STATE(907),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3062),
    [sym_html_comment] = ACTIONS(5),
  },
  [908] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(908),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1354),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [909] = {
    [sym_statement_block] = STATE(1102),
    [sym_comment] = STATE(909),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(3064),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [910] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(910),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [911] = {
    [sym__call_signature] = STATE(7068),
    [sym_comment] = STATE(911),
    [sym_formal_parameters] = STATE(4683),
    [sym_type_parameters] = STATE(6493),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_let] = ACTIONS(2968),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_readonly] = ACTIONS(2968),
    [anon_sym_get] = ACTIONS(2968),
    [anon_sym_set] = ACTIONS(2968),
    [anon_sym_declare] = ACTIONS(2968),
    [anon_sym_public] = ACTIONS(2968),
    [anon_sym_private] = ACTIONS(2968),
    [anon_sym_protected] = ACTIONS(2968),
    [anon_sym_override] = ACTIONS(2968),
    [anon_sym_module] = ACTIONS(2968),
    [anon_sym_any] = ACTIONS(2968),
    [anon_sym_number] = ACTIONS(2968),
    [anon_sym_boolean] = ACTIONS(2968),
    [anon_sym_string] = ACTIONS(2968),
    [anon_sym_symbol] = ACTIONS(2968),
    [anon_sym_object] = ACTIONS(2968),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [912] = {
    [sym_statement_block] = STATE(1102),
    [sym_comment] = STATE(912),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [913] = {
    [sym_comment] = STATE(913),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3066),
    [sym_html_comment] = ACTIONS(5),
  },
  [914] = {
    [sym_comment] = STATE(914),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_default] = ACTIONS(2129),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_else] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2129),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_case] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2129),
    [anon_sym_LTtemplate_GT] = ACTIONS(2129),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_using] = ACTIONS(2129),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_number] = ACTIONS(2129),
    [sym_private_property_identifier] = ACTIONS(2129),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_object] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
    [sym__automatic_semicolon] = ACTIONS(2133),
    [sym_html_comment] = ACTIONS(5),
  },
  [915] = {
    [sym_comment] = STATE(915),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3068),
    [sym_html_comment] = ACTIONS(5),
  },
  [916] = {
    [sym_comment] = STATE(916),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_catch] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [917] = {
    [sym_else_clause] = STATE(1190),
    [sym_comment] = STATE(917),
    [sym_identifier] = ACTIONS(3070),
    [anon_sym_export] = ACTIONS(3070),
    [anon_sym_default] = ACTIONS(3070),
    [anon_sym_type] = ACTIONS(3070),
    [anon_sym_namespace] = ACTIONS(3070),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_typeof] = ACTIONS(3070),
    [anon_sym_import] = ACTIONS(3070),
    [anon_sym_with] = ACTIONS(3070),
    [anon_sym_var] = ACTIONS(3070),
    [anon_sym_let] = ACTIONS(3070),
    [anon_sym_const] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_else] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3070),
    [anon_sym_switch] = ACTIONS(3070),
    [anon_sym_for] = ACTIONS(3070),
    [anon_sym_LPAREN] = ACTIONS(3070),
    [anon_sym_await] = ACTIONS(3070),
    [anon_sym_while] = ACTIONS(3070),
    [anon_sym_do] = ACTIONS(3070),
    [anon_sym_try] = ACTIONS(3070),
    [anon_sym_break] = ACTIONS(3070),
    [anon_sym_continue] = ACTIONS(3070),
    [anon_sym_debugger] = ACTIONS(3070),
    [anon_sym_return] = ACTIONS(3070),
    [anon_sym_throw] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym_case] = ACTIONS(3070),
    [anon_sym_yield] = ACTIONS(3070),
    [anon_sym_LBRACK] = ACTIONS(3070),
    [anon_sym_LTtemplate_GT] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_class] = ACTIONS(3070),
    [anon_sym_async] = ACTIONS(3070),
    [anon_sym_function] = ACTIONS(3070),
    [anon_sym_new] = ACTIONS(3070),
    [anon_sym_using] = ACTIONS(3070),
    [anon_sym_PLUS] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3070),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_LT] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_void] = ACTIONS(3070),
    [anon_sym_delete] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3070),
    [sym_number] = ACTIONS(3070),
    [sym_private_property_identifier] = ACTIONS(3070),
    [sym_this] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_true] = ACTIONS(3070),
    [sym_false] = ACTIONS(3070),
    [sym_null] = ACTIONS(3070),
    [sym_undefined] = ACTIONS(3070),
    [anon_sym_AT] = ACTIONS(3070),
    [anon_sym_static] = ACTIONS(3070),
    [anon_sym_readonly] = ACTIONS(3070),
    [anon_sym_get] = ACTIONS(3070),
    [anon_sym_set] = ACTIONS(3070),
    [anon_sym_declare] = ACTIONS(3070),
    [anon_sym_public] = ACTIONS(3070),
    [anon_sym_private] = ACTIONS(3070),
    [anon_sym_protected] = ACTIONS(3070),
    [anon_sym_override] = ACTIONS(3070),
    [anon_sym_module] = ACTIONS(3070),
    [anon_sym_any] = ACTIONS(3070),
    [anon_sym_number] = ACTIONS(3070),
    [anon_sym_boolean] = ACTIONS(3070),
    [anon_sym_string] = ACTIONS(3070),
    [anon_sym_symbol] = ACTIONS(3070),
    [anon_sym_object] = ACTIONS(3070),
    [anon_sym_abstract] = ACTIONS(3070),
    [anon_sym_interface] = ACTIONS(3070),
    [anon_sym_enum] = ACTIONS(3070),
    [sym_html_comment] = ACTIONS(5),
  },
  [918] = {
    [sym_comment] = STATE(918),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_catch] = ACTIONS(2221),
    [anon_sym_finally] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [919] = {
    [sym_comment] = STATE(919),
    [sym_identifier] = ACTIONS(3074),
    [anon_sym_export] = ACTIONS(3074),
    [anon_sym_default] = ACTIONS(3074),
    [anon_sym_type] = ACTIONS(3074),
    [anon_sym_namespace] = ACTIONS(3074),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_typeof] = ACTIONS(3074),
    [anon_sym_import] = ACTIONS(3074),
    [anon_sym_with] = ACTIONS(3074),
    [anon_sym_var] = ACTIONS(3074),
    [anon_sym_let] = ACTIONS(3074),
    [anon_sym_const] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_else] = ACTIONS(3074),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_switch] = ACTIONS(3074),
    [anon_sym_for] = ACTIONS(3074),
    [anon_sym_LPAREN] = ACTIONS(3074),
    [anon_sym_await] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_try] = ACTIONS(3074),
    [anon_sym_break] = ACTIONS(3074),
    [anon_sym_continue] = ACTIONS(3074),
    [anon_sym_debugger] = ACTIONS(3074),
    [anon_sym_return] = ACTIONS(3074),
    [anon_sym_throw] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3076),
    [anon_sym_case] = ACTIONS(3074),
    [anon_sym_yield] = ACTIONS(3074),
    [anon_sym_LBRACK] = ACTIONS(3074),
    [anon_sym_LTtemplate_GT] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_class] = ACTIONS(3074),
    [anon_sym_async] = ACTIONS(3074),
    [anon_sym_function] = ACTIONS(3074),
    [anon_sym_new] = ACTIONS(3074),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3074),
    [anon_sym_SLASH] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_void] = ACTIONS(3074),
    [anon_sym_delete] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3074),
    [sym_number] = ACTIONS(3074),
    [sym_private_property_identifier] = ACTIONS(3074),
    [sym_this] = ACTIONS(3074),
    [sym_super] = ACTIONS(3074),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [sym_null] = ACTIONS(3074),
    [sym_undefined] = ACTIONS(3074),
    [anon_sym_AT] = ACTIONS(3074),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_readonly] = ACTIONS(3074),
    [anon_sym_get] = ACTIONS(3074),
    [anon_sym_set] = ACTIONS(3074),
    [anon_sym_declare] = ACTIONS(3074),
    [anon_sym_public] = ACTIONS(3074),
    [anon_sym_private] = ACTIONS(3074),
    [anon_sym_protected] = ACTIONS(3074),
    [anon_sym_override] = ACTIONS(3074),
    [anon_sym_module] = ACTIONS(3074),
    [anon_sym_any] = ACTIONS(3074),
    [anon_sym_number] = ACTIONS(3074),
    [anon_sym_boolean] = ACTIONS(3074),
    [anon_sym_string] = ACTIONS(3074),
    [anon_sym_symbol] = ACTIONS(3074),
    [anon_sym_object] = ACTIONS(3074),
    [anon_sym_abstract] = ACTIONS(3074),
    [anon_sym_interface] = ACTIONS(3074),
    [anon_sym_enum] = ACTIONS(3074),
    [sym__automatic_semicolon] = ACTIONS(3078),
    [sym_html_comment] = ACTIONS(5),
  },
  [920] = {
    [sym_comment] = STATE(920),
    [sym_identifier] = ACTIONS(2167),
    [anon_sym_export] = ACTIONS(2167),
    [anon_sym_default] = ACTIONS(2167),
    [anon_sym_type] = ACTIONS(2167),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2167),
    [anon_sym_with] = ACTIONS(2167),
    [anon_sym_var] = ACTIONS(2167),
    [anon_sym_let] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_debugger] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_case] = ACTIONS(2167),
    [anon_sym_yield] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LTtemplate_GT] = ACTIONS(2167),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_async] = ACTIONS(2167),
    [anon_sym_function] = ACTIONS(2167),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_LT] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_void] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [sym_number] = ACTIONS(2167),
    [sym_private_property_identifier] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [sym_super] = ACTIONS(2167),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_undefined] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_readonly] = ACTIONS(2167),
    [anon_sym_get] = ACTIONS(2167),
    [anon_sym_set] = ACTIONS(2167),
    [anon_sym_declare] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_override] = ACTIONS(2167),
    [anon_sym_module] = ACTIONS(2167),
    [anon_sym_any] = ACTIONS(2167),
    [anon_sym_number] = ACTIONS(2167),
    [anon_sym_boolean] = ACTIONS(2167),
    [anon_sym_string] = ACTIONS(2167),
    [anon_sym_symbol] = ACTIONS(2167),
    [anon_sym_object] = ACTIONS(2167),
    [anon_sym_abstract] = ACTIONS(2167),
    [anon_sym_interface] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [sym__automatic_semicolon] = ACTIONS(2171),
    [sym_html_comment] = ACTIONS(5),
  },
  [921] = {
    [sym_comment] = STATE(921),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2205),
    [anon_sym_default] = ACTIONS(2205),
    [anon_sym_type] = ACTIONS(2205),
    [anon_sym_namespace] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_typeof] = ACTIONS(2205),
    [anon_sym_import] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2205),
    [anon_sym_var] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_else] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_await] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(2205),
    [anon_sym_do] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2205),
    [anon_sym_break] = ACTIONS(2205),
    [anon_sym_continue] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2205),
    [anon_sym_return] = ACTIONS(2205),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_case] = ACTIONS(2205),
    [anon_sym_yield] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_LTtemplate_GT] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_class] = ACTIONS(2205),
    [anon_sym_async] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2205),
    [anon_sym_new] = ACTIONS(2205),
    [anon_sym_using] = ACTIONS(2205),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_void] = ACTIONS(2205),
    [anon_sym_delete] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_number] = ACTIONS(2205),
    [sym_private_property_identifier] = ACTIONS(2205),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(2205),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [anon_sym_static] = ACTIONS(2205),
    [anon_sym_readonly] = ACTIONS(2205),
    [anon_sym_get] = ACTIONS(2205),
    [anon_sym_set] = ACTIONS(2205),
    [anon_sym_declare] = ACTIONS(2205),
    [anon_sym_public] = ACTIONS(2205),
    [anon_sym_private] = ACTIONS(2205),
    [anon_sym_protected] = ACTIONS(2205),
    [anon_sym_override] = ACTIONS(2205),
    [anon_sym_module] = ACTIONS(2205),
    [anon_sym_any] = ACTIONS(2205),
    [anon_sym_number] = ACTIONS(2205),
    [anon_sym_boolean] = ACTIONS(2205),
    [anon_sym_string] = ACTIONS(2205),
    [anon_sym_symbol] = ACTIONS(2205),
    [anon_sym_object] = ACTIONS(2205),
    [anon_sym_abstract] = ACTIONS(2205),
    [anon_sym_interface] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2205),
    [sym__automatic_semicolon] = ACTIONS(2209),
    [sym_html_comment] = ACTIONS(5),
  },
  [922] = {
    [sym_comment] = STATE(922),
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_export] = ACTIONS(2197),
    [anon_sym_default] = ACTIONS(2197),
    [anon_sym_type] = ACTIONS(2197),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_RBRACE] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_import] = ACTIONS(2197),
    [anon_sym_with] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_debugger] = ACTIONS(2197),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_case] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_LTtemplate_GT] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_function] = ACTIONS(2197),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2197),
    [sym_number] = ACTIONS(2197),
    [sym_private_property_identifier] = ACTIONS(2197),
    [sym_this] = ACTIONS(2197),
    [sym_super] = ACTIONS(2197),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [sym_null] = ACTIONS(2197),
    [sym_undefined] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_declare] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_module] = ACTIONS(2197),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_boolean] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_object] = ACTIONS(2197),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [sym__automatic_semicolon] = ACTIONS(2201),
    [sym_html_comment] = ACTIONS(5),
  },
  [923] = {
    [sym_comment] = STATE(923),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_catch] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3080),
    [sym_html_comment] = ACTIONS(5),
  },
  [924] = {
    [sym_comment] = STATE(924),
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_export] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_type] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3082),
    [anon_sym_RBRACE] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3082),
    [anon_sym_import] = ACTIONS(3082),
    [anon_sym_with] = ACTIONS(3082),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_BANG] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3082),
    [anon_sym_await] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_debugger] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_yield] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_LTtemplate_GT] = ACTIONS(3082),
    [anon_sym_DQUOTE] = ACTIONS(3082),
    [anon_sym_SQUOTE] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_async] = ACTIONS(3082),
    [anon_sym_function] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_TILDE] = ACTIONS(3082),
    [anon_sym_void] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3082),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3082),
    [sym_number] = ACTIONS(3082),
    [sym_private_property_identifier] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
    [sym_super] = ACTIONS(3082),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [sym_null] = ACTIONS(3082),
    [sym_undefined] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_readonly] = ACTIONS(3082),
    [anon_sym_get] = ACTIONS(3082),
    [anon_sym_set] = ACTIONS(3082),
    [anon_sym_declare] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_override] = ACTIONS(3082),
    [anon_sym_module] = ACTIONS(3082),
    [anon_sym_any] = ACTIONS(3082),
    [anon_sym_number] = ACTIONS(3082),
    [anon_sym_boolean] = ACTIONS(3082),
    [anon_sym_string] = ACTIONS(3082),
    [anon_sym_symbol] = ACTIONS(3082),
    [anon_sym_object] = ACTIONS(3082),
    [anon_sym_abstract] = ACTIONS(3082),
    [anon_sym_interface] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [sym__automatic_semicolon] = ACTIONS(3084),
    [sym_html_comment] = ACTIONS(5),
  },
  [925] = {
    [sym_comment] = STATE(925),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_finally] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3086),
    [sym_html_comment] = ACTIONS(5),
  },
  [926] = {
    [sym_comment] = STATE(926),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_export] = ACTIONS(2241),
    [anon_sym_default] = ACTIONS(2241),
    [anon_sym_type] = ACTIONS(2241),
    [anon_sym_namespace] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_typeof] = ACTIONS(2241),
    [anon_sym_import] = ACTIONS(2241),
    [anon_sym_with] = ACTIONS(2241),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_const] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_else] = ACTIONS(2241),
    [anon_sym_if] = ACTIONS(2241),
    [anon_sym_switch] = ACTIONS(2241),
    [anon_sym_for] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_await] = ACTIONS(2241),
    [anon_sym_while] = ACTIONS(2241),
    [anon_sym_do] = ACTIONS(2241),
    [anon_sym_try] = ACTIONS(2241),
    [anon_sym_break] = ACTIONS(2241),
    [anon_sym_continue] = ACTIONS(2241),
    [anon_sym_debugger] = ACTIONS(2241),
    [anon_sym_return] = ACTIONS(2241),
    [anon_sym_throw] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_case] = ACTIONS(2241),
    [anon_sym_yield] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_LTtemplate_GT] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_class] = ACTIONS(2241),
    [anon_sym_async] = ACTIONS(2241),
    [anon_sym_function] = ACTIONS(2241),
    [anon_sym_new] = ACTIONS(2241),
    [anon_sym_using] = ACTIONS(2241),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_void] = ACTIONS(2241),
    [anon_sym_delete] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2241),
    [sym_number] = ACTIONS(2241),
    [sym_private_property_identifier] = ACTIONS(2241),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(2241),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(2241),
    [anon_sym_static] = ACTIONS(2241),
    [anon_sym_readonly] = ACTIONS(2241),
    [anon_sym_get] = ACTIONS(2241),
    [anon_sym_set] = ACTIONS(2241),
    [anon_sym_declare] = ACTIONS(2241),
    [anon_sym_public] = ACTIONS(2241),
    [anon_sym_private] = ACTIONS(2241),
    [anon_sym_protected] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_module] = ACTIONS(2241),
    [anon_sym_any] = ACTIONS(2241),
    [anon_sym_number] = ACTIONS(2241),
    [anon_sym_boolean] = ACTIONS(2241),
    [anon_sym_string] = ACTIONS(2241),
    [anon_sym_symbol] = ACTIONS(2241),
    [anon_sym_object] = ACTIONS(2241),
    [anon_sym_abstract] = ACTIONS(2241),
    [anon_sym_interface] = ACTIONS(2241),
    [anon_sym_enum] = ACTIONS(2241),
    [sym__automatic_semicolon] = ACTIONS(2245),
    [sym_html_comment] = ACTIONS(5),
  },
  [927] = {
    [sym_comment] = STATE(927),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_catch] = ACTIONS(2067),
    [anon_sym_finally] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3088),
    [sym_html_comment] = ACTIONS(5),
  },
  [928] = {
    [sym_statement_block] = STATE(1351),
    [sym_comment] = STATE(928),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3090),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [929] = {
    [sym_comment] = STATE(929),
    [sym_identifier] = ACTIONS(3094),
    [anon_sym_export] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_type] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3094),
    [anon_sym_typeof] = ACTIONS(3094),
    [anon_sym_import] = ACTIONS(3094),
    [anon_sym_with] = ACTIONS(3094),
    [anon_sym_var] = ACTIONS(3094),
    [anon_sym_let] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_else] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3094),
    [anon_sym_await] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_debugger] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_finally] = ACTIONS(3094),
    [anon_sym_yield] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_LTtemplate_GT] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_async] = ACTIONS(3094),
    [anon_sym_function] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_void] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3094),
    [sym_number] = ACTIONS(3094),
    [sym_private_property_identifier] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
    [sym_super] = ACTIONS(3094),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_undefined] = ACTIONS(3094),
    [anon_sym_AT] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_readonly] = ACTIONS(3094),
    [anon_sym_get] = ACTIONS(3094),
    [anon_sym_set] = ACTIONS(3094),
    [anon_sym_declare] = ACTIONS(3094),
    [anon_sym_public] = ACTIONS(3094),
    [anon_sym_private] = ACTIONS(3094),
    [anon_sym_protected] = ACTIONS(3094),
    [anon_sym_override] = ACTIONS(3094),
    [anon_sym_module] = ACTIONS(3094),
    [anon_sym_any] = ACTIONS(3094),
    [anon_sym_number] = ACTIONS(3094),
    [anon_sym_boolean] = ACTIONS(3094),
    [anon_sym_string] = ACTIONS(3094),
    [anon_sym_symbol] = ACTIONS(3094),
    [anon_sym_object] = ACTIONS(3094),
    [anon_sym_abstract] = ACTIONS(3094),
    [anon_sym_interface] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [sym_html_comment] = ACTIONS(5),
  },
  [930] = {
    [sym_statement_block] = STATE(1351),
    [sym_comment] = STATE(930),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3090),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [931] = {
    [sym_comment] = STATE(931),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3098),
    [sym_html_comment] = ACTIONS(5),
  },
  [932] = {
    [sym_comment] = STATE(932),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2073),
    [sym_html_comment] = ACTIONS(5),
  },
  [933] = {
    [sym_comment] = STATE(933),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym__automatic_semicolon] = ACTIONS(2127),
    [sym_html_comment] = ACTIONS(5),
  },
  [934] = {
    [sym_finally_clause] = STATE(1222),
    [sym_comment] = STATE(934),
    [sym_identifier] = ACTIONS(3052),
    [anon_sym_export] = ACTIONS(3052),
    [anon_sym_default] = ACTIONS(3052),
    [anon_sym_type] = ACTIONS(3052),
    [anon_sym_namespace] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_typeof] = ACTIONS(3052),
    [anon_sym_import] = ACTIONS(3052),
    [anon_sym_with] = ACTIONS(3052),
    [anon_sym_var] = ACTIONS(3052),
    [anon_sym_let] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [anon_sym_await] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_debugger] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_throw] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3052),
    [anon_sym_finally] = ACTIONS(3026),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_LTtemplate_GT] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_async] = ACTIONS(3052),
    [anon_sym_function] = ACTIONS(3052),
    [anon_sym_new] = ACTIONS(3052),
    [anon_sym_using] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_void] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3052),
    [sym_number] = ACTIONS(3052),
    [sym_private_property_identifier] = ACTIONS(3052),
    [sym_this] = ACTIONS(3052),
    [sym_super] = ACTIONS(3052),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [sym_null] = ACTIONS(3052),
    [sym_undefined] = ACTIONS(3052),
    [anon_sym_AT] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_readonly] = ACTIONS(3052),
    [anon_sym_get] = ACTIONS(3052),
    [anon_sym_set] = ACTIONS(3052),
    [anon_sym_declare] = ACTIONS(3052),
    [anon_sym_public] = ACTIONS(3052),
    [anon_sym_private] = ACTIONS(3052),
    [anon_sym_protected] = ACTIONS(3052),
    [anon_sym_override] = ACTIONS(3052),
    [anon_sym_module] = ACTIONS(3052),
    [anon_sym_any] = ACTIONS(3052),
    [anon_sym_number] = ACTIONS(3052),
    [anon_sym_boolean] = ACTIONS(3052),
    [anon_sym_string] = ACTIONS(3052),
    [anon_sym_symbol] = ACTIONS(3052),
    [anon_sym_object] = ACTIONS(3052),
    [anon_sym_abstract] = ACTIONS(3052),
    [anon_sym_interface] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [sym_html_comment] = ACTIONS(5),
  },
  [935] = {
    [sym_comment] = STATE(935),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [936] = {
    [sym_comment] = STATE(936),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_catch] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [937] = {
    [sym_comment] = STATE(937),
    [sym_identifier] = ACTIONS(3100),
    [anon_sym_export] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_type] = ACTIONS(3100),
    [anon_sym_namespace] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_RBRACE] = ACTIONS(3100),
    [anon_sym_typeof] = ACTIONS(3100),
    [anon_sym_import] = ACTIONS(3100),
    [anon_sym_with] = ACTIONS(3100),
    [anon_sym_var] = ACTIONS(3100),
    [anon_sym_let] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3100),
    [anon_sym_else] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3100),
    [anon_sym_await] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_try] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_debugger] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_throw] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_finally] = ACTIONS(3100),
    [anon_sym_yield] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3100),
    [anon_sym_LTtemplate_GT] = ACTIONS(3100),
    [anon_sym_DQUOTE] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_async] = ACTIONS(3100),
    [anon_sym_function] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_using] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_SLASH] = ACTIONS(3100),
    [anon_sym_LT] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_void] = ACTIONS(3100),
    [anon_sym_delete] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3100),
    [sym_number] = ACTIONS(3100),
    [sym_private_property_identifier] = ACTIONS(3100),
    [sym_this] = ACTIONS(3100),
    [sym_super] = ACTIONS(3100),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_null] = ACTIONS(3100),
    [sym_undefined] = ACTIONS(3100),
    [anon_sym_AT] = ACTIONS(3100),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_readonly] = ACTIONS(3100),
    [anon_sym_get] = ACTIONS(3100),
    [anon_sym_set] = ACTIONS(3100),
    [anon_sym_declare] = ACTIONS(3100),
    [anon_sym_public] = ACTIONS(3100),
    [anon_sym_private] = ACTIONS(3100),
    [anon_sym_protected] = ACTIONS(3100),
    [anon_sym_override] = ACTIONS(3100),
    [anon_sym_module] = ACTIONS(3100),
    [anon_sym_any] = ACTIONS(3100),
    [anon_sym_number] = ACTIONS(3100),
    [anon_sym_boolean] = ACTIONS(3100),
    [anon_sym_string] = ACTIONS(3100),
    [anon_sym_symbol] = ACTIONS(3100),
    [anon_sym_object] = ACTIONS(3100),
    [anon_sym_abstract] = ACTIONS(3100),
    [anon_sym_interface] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [sym_html_comment] = ACTIONS(5),
  },
  [938] = {
    [sym_comment] = STATE(938),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_finally] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [939] = {
    [sym_comment] = STATE(939),
    [sym_identifier] = ACTIONS(2137),
    [anon_sym_export] = ACTIONS(2137),
    [anon_sym_default] = ACTIONS(2137),
    [anon_sym_type] = ACTIONS(2137),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_typeof] = ACTIONS(2137),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_with] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2137),
    [anon_sym_let] = ACTIONS(2137),
    [anon_sym_const] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2137),
    [anon_sym_else] = ACTIONS(2137),
    [anon_sym_if] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2137),
    [anon_sym_for] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2137),
    [anon_sym_await] = ACTIONS(2137),
    [anon_sym_while] = ACTIONS(2137),
    [anon_sym_do] = ACTIONS(2137),
    [anon_sym_try] = ACTIONS(2137),
    [anon_sym_break] = ACTIONS(2137),
    [anon_sym_continue] = ACTIONS(2137),
    [anon_sym_debugger] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2137),
    [anon_sym_throw] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym_case] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_LTtemplate_GT] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_SQUOTE] = ACTIONS(2137),
    [anon_sym_class] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(2137),
    [anon_sym_new] = ACTIONS(2137),
    [anon_sym_using] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(2137),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_TILDE] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2137),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [sym_number] = ACTIONS(2137),
    [sym_private_property_identifier] = ACTIONS(2137),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(2137),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(2137),
    [anon_sym_static] = ACTIONS(2137),
    [anon_sym_readonly] = ACTIONS(2137),
    [anon_sym_get] = ACTIONS(2137),
    [anon_sym_set] = ACTIONS(2137),
    [anon_sym_declare] = ACTIONS(2137),
    [anon_sym_public] = ACTIONS(2137),
    [anon_sym_private] = ACTIONS(2137),
    [anon_sym_protected] = ACTIONS(2137),
    [anon_sym_override] = ACTIONS(2137),
    [anon_sym_module] = ACTIONS(2137),
    [anon_sym_any] = ACTIONS(2137),
    [anon_sym_number] = ACTIONS(2137),
    [anon_sym_boolean] = ACTIONS(2137),
    [anon_sym_string] = ACTIONS(2137),
    [anon_sym_symbol] = ACTIONS(2137),
    [anon_sym_object] = ACTIONS(2137),
    [anon_sym_abstract] = ACTIONS(2137),
    [anon_sym_interface] = ACTIONS(2137),
    [anon_sym_enum] = ACTIONS(2137),
    [sym__automatic_semicolon] = ACTIONS(2141),
    [sym_html_comment] = ACTIONS(5),
  },
  [940] = {
    [sym_comment] = STATE(940),
    [sym_identifier] = ACTIONS(3102),
    [anon_sym_export] = ACTIONS(3102),
    [anon_sym_default] = ACTIONS(3102),
    [anon_sym_type] = ACTIONS(3102),
    [anon_sym_namespace] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_typeof] = ACTIONS(3102),
    [anon_sym_import] = ACTIONS(3102),
    [anon_sym_with] = ACTIONS(3102),
    [anon_sym_var] = ACTIONS(3102),
    [anon_sym_let] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_await] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_debugger] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_case] = ACTIONS(3102),
    [anon_sym_finally] = ACTIONS(3102),
    [anon_sym_yield] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_LTtemplate_GT] = ACTIONS(3102),
    [anon_sym_DQUOTE] = ACTIONS(3102),
    [anon_sym_SQUOTE] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_async] = ACTIONS(3102),
    [anon_sym_function] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_using] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_SLASH] = ACTIONS(3102),
    [anon_sym_LT] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_void] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3102),
    [sym_number] = ACTIONS(3102),
    [sym_private_property_identifier] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
    [sym_super] = ACTIONS(3102),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [sym_null] = ACTIONS(3102),
    [sym_undefined] = ACTIONS(3102),
    [anon_sym_AT] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_readonly] = ACTIONS(3102),
    [anon_sym_get] = ACTIONS(3102),
    [anon_sym_set] = ACTIONS(3102),
    [anon_sym_declare] = ACTIONS(3102),
    [anon_sym_public] = ACTIONS(3102),
    [anon_sym_private] = ACTIONS(3102),
    [anon_sym_protected] = ACTIONS(3102),
    [anon_sym_override] = ACTIONS(3102),
    [anon_sym_module] = ACTIONS(3102),
    [anon_sym_any] = ACTIONS(3102),
    [anon_sym_number] = ACTIONS(3102),
    [anon_sym_boolean] = ACTIONS(3102),
    [anon_sym_string] = ACTIONS(3102),
    [anon_sym_symbol] = ACTIONS(3102),
    [anon_sym_object] = ACTIONS(3102),
    [anon_sym_abstract] = ACTIONS(3102),
    [anon_sym_interface] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [sym_html_comment] = ACTIONS(5),
  },
  [941] = {
    [sym_comment] = STATE(941),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [942] = {
    [sym_else_clause] = STATE(1076),
    [sym_comment] = STATE(942),
    [sym_identifier] = ACTIONS(3070),
    [anon_sym_export] = ACTIONS(3070),
    [anon_sym_default] = ACTIONS(3070),
    [anon_sym_type] = ACTIONS(3070),
    [anon_sym_namespace] = ACTIONS(3070),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_typeof] = ACTIONS(3070),
    [anon_sym_import] = ACTIONS(3070),
    [anon_sym_with] = ACTIONS(3070),
    [anon_sym_var] = ACTIONS(3070),
    [anon_sym_let] = ACTIONS(3070),
    [anon_sym_const] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_else] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3070),
    [anon_sym_switch] = ACTIONS(3070),
    [anon_sym_for] = ACTIONS(3070),
    [anon_sym_LPAREN] = ACTIONS(3070),
    [anon_sym_await] = ACTIONS(3070),
    [anon_sym_while] = ACTIONS(3070),
    [anon_sym_do] = ACTIONS(3070),
    [anon_sym_try] = ACTIONS(3070),
    [anon_sym_break] = ACTIONS(3070),
    [anon_sym_continue] = ACTIONS(3070),
    [anon_sym_debugger] = ACTIONS(3070),
    [anon_sym_return] = ACTIONS(3070),
    [anon_sym_throw] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym_case] = ACTIONS(3070),
    [anon_sym_yield] = ACTIONS(3070),
    [anon_sym_LBRACK] = ACTIONS(3070),
    [anon_sym_LTtemplate_GT] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_class] = ACTIONS(3070),
    [anon_sym_async] = ACTIONS(3070),
    [anon_sym_function] = ACTIONS(3070),
    [anon_sym_new] = ACTIONS(3070),
    [anon_sym_using] = ACTIONS(3070),
    [anon_sym_PLUS] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3070),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_LT] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_void] = ACTIONS(3070),
    [anon_sym_delete] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3070),
    [sym_number] = ACTIONS(3070),
    [sym_private_property_identifier] = ACTIONS(3070),
    [sym_this] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_true] = ACTIONS(3070),
    [sym_false] = ACTIONS(3070),
    [sym_null] = ACTIONS(3070),
    [sym_undefined] = ACTIONS(3070),
    [anon_sym_AT] = ACTIONS(3070),
    [anon_sym_static] = ACTIONS(3070),
    [anon_sym_readonly] = ACTIONS(3070),
    [anon_sym_get] = ACTIONS(3070),
    [anon_sym_set] = ACTIONS(3070),
    [anon_sym_declare] = ACTIONS(3070),
    [anon_sym_public] = ACTIONS(3070),
    [anon_sym_private] = ACTIONS(3070),
    [anon_sym_protected] = ACTIONS(3070),
    [anon_sym_override] = ACTIONS(3070),
    [anon_sym_module] = ACTIONS(3070),
    [anon_sym_any] = ACTIONS(3070),
    [anon_sym_number] = ACTIONS(3070),
    [anon_sym_boolean] = ACTIONS(3070),
    [anon_sym_string] = ACTIONS(3070),
    [anon_sym_symbol] = ACTIONS(3070),
    [anon_sym_object] = ACTIONS(3070),
    [anon_sym_abstract] = ACTIONS(3070),
    [anon_sym_interface] = ACTIONS(3070),
    [anon_sym_enum] = ACTIONS(3070),
    [sym_html_comment] = ACTIONS(5),
  },
  [943] = {
    [sym_comment] = STATE(943),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [sym_html_comment] = ACTIONS(5),
  },
  [944] = {
    [sym_comment] = STATE(944),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3106),
    [sym_html_comment] = ACTIONS(5),
  },
  [945] = {
    [sym_comment] = STATE(945),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym__automatic_semicolon] = ACTIONS(2147),
    [sym_html_comment] = ACTIONS(5),
  },
  [946] = {
    [sym_comment] = STATE(946),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3108),
    [sym_html_comment] = ACTIONS(5),
  },
  [947] = {
    [sym_statement_block] = STATE(1218),
    [sym_comment] = STATE(947),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(3112),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [948] = {
    [sym_statement_block] = STATE(1218),
    [sym_comment] = STATE(948),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(3114),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [949] = {
    [sym_comment] = STATE(949),
    [sym_identifier] = ACTIONS(2255),
    [anon_sym_export] = ACTIONS(2255),
    [anon_sym_default] = ACTIONS(2255),
    [anon_sym_type] = ACTIONS(2255),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2255),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_typeof] = ACTIONS(2255),
    [anon_sym_import] = ACTIONS(2255),
    [anon_sym_with] = ACTIONS(2255),
    [anon_sym_var] = ACTIONS(2255),
    [anon_sym_let] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_else] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_await] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_debugger] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2255),
    [anon_sym_case] = ACTIONS(2255),
    [anon_sym_yield] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_LTtemplate_GT] = ACTIONS(2255),
    [anon_sym_DQUOTE] = ACTIONS(2255),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_async] = ACTIONS(2255),
    [anon_sym_function] = ACTIONS(2255),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_TILDE] = ACTIONS(2255),
    [anon_sym_void] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [sym_number] = ACTIONS(2255),
    [sym_private_property_identifier] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [sym_super] = ACTIONS(2255),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [sym_null] = ACTIONS(2255),
    [sym_undefined] = ACTIONS(2255),
    [anon_sym_AT] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_readonly] = ACTIONS(2255),
    [anon_sym_get] = ACTIONS(2255),
    [anon_sym_set] = ACTIONS(2255),
    [anon_sym_declare] = ACTIONS(2255),
    [anon_sym_public] = ACTIONS(2255),
    [anon_sym_private] = ACTIONS(2255),
    [anon_sym_protected] = ACTIONS(2255),
    [anon_sym_override] = ACTIONS(2255),
    [anon_sym_module] = ACTIONS(2255),
    [anon_sym_any] = ACTIONS(2255),
    [anon_sym_number] = ACTIONS(2255),
    [anon_sym_boolean] = ACTIONS(2255),
    [anon_sym_string] = ACTIONS(2255),
    [anon_sym_symbol] = ACTIONS(2255),
    [anon_sym_object] = ACTIONS(2255),
    [anon_sym_abstract] = ACTIONS(2255),
    [anon_sym_interface] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [sym__automatic_semicolon] = ACTIONS(2259),
    [sym_html_comment] = ACTIONS(5),
  },
  [950] = {
    [sym_comment] = STATE(950),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_export] = ACTIONS(3116),
    [anon_sym_default] = ACTIONS(3116),
    [anon_sym_type] = ACTIONS(3116),
    [anon_sym_namespace] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_typeof] = ACTIONS(3116),
    [anon_sym_import] = ACTIONS(3116),
    [anon_sym_with] = ACTIONS(3116),
    [anon_sym_var] = ACTIONS(3116),
    [anon_sym_let] = ACTIONS(3116),
    [anon_sym_const] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3116),
    [anon_sym_else] = ACTIONS(3116),
    [anon_sym_if] = ACTIONS(3116),
    [anon_sym_switch] = ACTIONS(3116),
    [anon_sym_for] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3116),
    [anon_sym_await] = ACTIONS(3116),
    [anon_sym_while] = ACTIONS(3116),
    [anon_sym_do] = ACTIONS(3116),
    [anon_sym_try] = ACTIONS(3116),
    [anon_sym_break] = ACTIONS(3116),
    [anon_sym_continue] = ACTIONS(3116),
    [anon_sym_debugger] = ACTIONS(3116),
    [anon_sym_return] = ACTIONS(3116),
    [anon_sym_throw] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym_case] = ACTIONS(3116),
    [anon_sym_yield] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [anon_sym_LTtemplate_GT] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [anon_sym_SQUOTE] = ACTIONS(3116),
    [anon_sym_class] = ACTIONS(3116),
    [anon_sym_async] = ACTIONS(3116),
    [anon_sym_function] = ACTIONS(3116),
    [anon_sym_new] = ACTIONS(3116),
    [anon_sym_using] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3116),
    [anon_sym_SLASH] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3116),
    [anon_sym_TILDE] = ACTIONS(3116),
    [anon_sym_void] = ACTIONS(3116),
    [anon_sym_delete] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [sym_number] = ACTIONS(3116),
    [sym_private_property_identifier] = ACTIONS(3116),
    [sym_this] = ACTIONS(3116),
    [sym_super] = ACTIONS(3116),
    [sym_true] = ACTIONS(3116),
    [sym_false] = ACTIONS(3116),
    [sym_null] = ACTIONS(3116),
    [sym_undefined] = ACTIONS(3116),
    [anon_sym_AT] = ACTIONS(3116),
    [anon_sym_static] = ACTIONS(3116),
    [anon_sym_readonly] = ACTIONS(3116),
    [anon_sym_get] = ACTIONS(3116),
    [anon_sym_set] = ACTIONS(3116),
    [anon_sym_declare] = ACTIONS(3116),
    [anon_sym_public] = ACTIONS(3116),
    [anon_sym_private] = ACTIONS(3116),
    [anon_sym_protected] = ACTIONS(3116),
    [anon_sym_override] = ACTIONS(3116),
    [anon_sym_module] = ACTIONS(3116),
    [anon_sym_any] = ACTIONS(3116),
    [anon_sym_number] = ACTIONS(3116),
    [anon_sym_boolean] = ACTIONS(3116),
    [anon_sym_string] = ACTIONS(3116),
    [anon_sym_symbol] = ACTIONS(3116),
    [anon_sym_object] = ACTIONS(3116),
    [anon_sym_abstract] = ACTIONS(3116),
    [anon_sym_interface] = ACTIONS(3116),
    [anon_sym_enum] = ACTIONS(3116),
    [sym__automatic_semicolon] = ACTIONS(3118),
    [sym_html_comment] = ACTIONS(5),
  },
  [951] = {
    [sym_comment] = STATE(951),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_default] = ACTIONS(2225),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2225),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_else] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_case] = ACTIONS(2225),
    [anon_sym_yield] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2225),
    [anon_sym_LTtemplate_GT] = ACTIONS(2225),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_SQUOTE] = ACTIONS(2225),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_function] = ACTIONS(2225),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_using] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_TILDE] = ACTIONS(2225),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(2225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [sym_number] = ACTIONS(2225),
    [sym_private_property_identifier] = ACTIONS(2225),
    [sym_this] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [sym_false] = ACTIONS(2225),
    [sym_null] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2225),
    [anon_sym_static] = ACTIONS(2225),
    [anon_sym_readonly] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_override] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_object] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
    [sym__automatic_semicolon] = ACTIONS(2229),
    [sym_html_comment] = ACTIONS(5),
  },
  [952] = {
    [sym_comment] = STATE(952),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_default] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_else] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_case] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_LTtemplate_GT] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2083),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_using] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2083),
    [sym_number] = ACTIONS(2083),
    [sym_private_property_identifier] = ACTIONS(2083),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2083),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_readonly] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_override] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_object] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [sym__automatic_semicolon] = ACTIONS(2087),
    [sym_html_comment] = ACTIONS(5),
  },
  [953] = {
    [sym_comment] = STATE(953),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_export] = ACTIONS(2103),
    [anon_sym_default] = ACTIONS(2103),
    [anon_sym_type] = ACTIONS(2103),
    [anon_sym_namespace] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_typeof] = ACTIONS(2103),
    [anon_sym_import] = ACTIONS(2103),
    [anon_sym_with] = ACTIONS(2103),
    [anon_sym_var] = ACTIONS(2103),
    [anon_sym_let] = ACTIONS(2103),
    [anon_sym_const] = ACTIONS(2103),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_else] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_switch] = ACTIONS(2103),
    [anon_sym_for] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_await] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_try] = ACTIONS(2103),
    [anon_sym_break] = ACTIONS(2103),
    [anon_sym_continue] = ACTIONS(2103),
    [anon_sym_debugger] = ACTIONS(2103),
    [anon_sym_return] = ACTIONS(2103),
    [anon_sym_throw] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_case] = ACTIONS(2103),
    [anon_sym_yield] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LTtemplate_GT] = ACTIONS(2103),
    [anon_sym_DQUOTE] = ACTIONS(2103),
    [anon_sym_SQUOTE] = ACTIONS(2103),
    [anon_sym_class] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(2103),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_using] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [anon_sym_void] = ACTIONS(2103),
    [anon_sym_delete] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2103),
    [sym_number] = ACTIONS(2103),
    [sym_private_property_identifier] = ACTIONS(2103),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_undefined] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2103),
    [anon_sym_static] = ACTIONS(2103),
    [anon_sym_readonly] = ACTIONS(2103),
    [anon_sym_get] = ACTIONS(2103),
    [anon_sym_set] = ACTIONS(2103),
    [anon_sym_declare] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2103),
    [anon_sym_private] = ACTIONS(2103),
    [anon_sym_protected] = ACTIONS(2103),
    [anon_sym_override] = ACTIONS(2103),
    [anon_sym_module] = ACTIONS(2103),
    [anon_sym_any] = ACTIONS(2103),
    [anon_sym_number] = ACTIONS(2103),
    [anon_sym_boolean] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_symbol] = ACTIONS(2103),
    [anon_sym_object] = ACTIONS(2103),
    [anon_sym_abstract] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2103),
    [anon_sym_enum] = ACTIONS(2103),
    [sym__automatic_semicolon] = ACTIONS(2107),
    [sym_html_comment] = ACTIONS(5),
  },
  [954] = {
    [sym_finally_clause] = STATE(1366),
    [sym_comment] = STATE(954),
    [ts_builtin_sym_end] = ACTIONS(3120),
    [sym_identifier] = ACTIONS(3052),
    [anon_sym_export] = ACTIONS(3052),
    [anon_sym_type] = ACTIONS(3052),
    [anon_sym_namespace] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_typeof] = ACTIONS(3052),
    [anon_sym_import] = ACTIONS(3052),
    [anon_sym_with] = ACTIONS(3052),
    [anon_sym_var] = ACTIONS(3052),
    [anon_sym_let] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_else] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [anon_sym_await] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_debugger] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_throw] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_finally] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_LTtemplate_GT] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_async] = ACTIONS(3052),
    [anon_sym_function] = ACTIONS(3052),
    [anon_sym_new] = ACTIONS(3052),
    [anon_sym_using] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_void] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3052),
    [sym_number] = ACTIONS(3052),
    [sym_private_property_identifier] = ACTIONS(3052),
    [sym_this] = ACTIONS(3052),
    [sym_super] = ACTIONS(3052),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [sym_null] = ACTIONS(3052),
    [sym_undefined] = ACTIONS(3052),
    [anon_sym_AT] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_readonly] = ACTIONS(3052),
    [anon_sym_get] = ACTIONS(3052),
    [anon_sym_set] = ACTIONS(3052),
    [anon_sym_declare] = ACTIONS(3052),
    [anon_sym_public] = ACTIONS(3052),
    [anon_sym_private] = ACTIONS(3052),
    [anon_sym_protected] = ACTIONS(3052),
    [anon_sym_override] = ACTIONS(3052),
    [anon_sym_module] = ACTIONS(3052),
    [anon_sym_any] = ACTIONS(3052),
    [anon_sym_number] = ACTIONS(3052),
    [anon_sym_boolean] = ACTIONS(3052),
    [anon_sym_string] = ACTIONS(3052),
    [anon_sym_symbol] = ACTIONS(3052),
    [anon_sym_object] = ACTIONS(3052),
    [anon_sym_abstract] = ACTIONS(3052),
    [anon_sym_interface] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [sym_html_comment] = ACTIONS(5),
  },
  [955] = {
    [sym_comment] = STATE(955),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_export] = ACTIONS(2213),
    [anon_sym_default] = ACTIONS(2213),
    [anon_sym_type] = ACTIONS(2213),
    [anon_sym_namespace] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_typeof] = ACTIONS(2213),
    [anon_sym_import] = ACTIONS(2213),
    [anon_sym_with] = ACTIONS(2213),
    [anon_sym_var] = ACTIONS(2213),
    [anon_sym_let] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_else] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_for] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_await] = ACTIONS(2213),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_do] = ACTIONS(2213),
    [anon_sym_try] = ACTIONS(2213),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_debugger] = ACTIONS(2213),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_throw] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_case] = ACTIONS(2213),
    [anon_sym_yield] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2213),
    [anon_sym_LTtemplate_GT] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_class] = ACTIONS(2213),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2213),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_using] = ACTIONS(2213),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_void] = ACTIONS(2213),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_number] = ACTIONS(2213),
    [sym_private_property_identifier] = ACTIONS(2213),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(2213),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2213),
    [anon_sym_static] = ACTIONS(2213),
    [anon_sym_readonly] = ACTIONS(2213),
    [anon_sym_get] = ACTIONS(2213),
    [anon_sym_set] = ACTIONS(2213),
    [anon_sym_declare] = ACTIONS(2213),
    [anon_sym_public] = ACTIONS(2213),
    [anon_sym_private] = ACTIONS(2213),
    [anon_sym_protected] = ACTIONS(2213),
    [anon_sym_override] = ACTIONS(2213),
    [anon_sym_module] = ACTIONS(2213),
    [anon_sym_any] = ACTIONS(2213),
    [anon_sym_number] = ACTIONS(2213),
    [anon_sym_boolean] = ACTIONS(2213),
    [anon_sym_string] = ACTIONS(2213),
    [anon_sym_symbol] = ACTIONS(2213),
    [anon_sym_object] = ACTIONS(2213),
    [anon_sym_abstract] = ACTIONS(2213),
    [anon_sym_interface] = ACTIONS(2213),
    [anon_sym_enum] = ACTIONS(2213),
    [sym__automatic_semicolon] = ACTIONS(2217),
    [sym_html_comment] = ACTIONS(5),
  },
  [956] = {
    [sym_comment] = STATE(956),
    [sym_identifier] = ACTIONS(2233),
    [anon_sym_export] = ACTIONS(2233),
    [anon_sym_default] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(2233),
    [anon_sym_namespace] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [anon_sym_typeof] = ACTIONS(2233),
    [anon_sym_import] = ACTIONS(2233),
    [anon_sym_with] = ACTIONS(2233),
    [anon_sym_var] = ACTIONS(2233),
    [anon_sym_let] = ACTIONS(2233),
    [anon_sym_const] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_else] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_for] = ACTIONS(2233),
    [anon_sym_LPAREN] = ACTIONS(2233),
    [anon_sym_await] = ACTIONS(2233),
    [anon_sym_while] = ACTIONS(2233),
    [anon_sym_do] = ACTIONS(2233),
    [anon_sym_try] = ACTIONS(2233),
    [anon_sym_break] = ACTIONS(2233),
    [anon_sym_continue] = ACTIONS(2233),
    [anon_sym_debugger] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2233),
    [anon_sym_throw] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym_case] = ACTIONS(2233),
    [anon_sym_yield] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2233),
    [anon_sym_LTtemplate_GT] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_class] = ACTIONS(2233),
    [anon_sym_async] = ACTIONS(2233),
    [anon_sym_function] = ACTIONS(2233),
    [anon_sym_new] = ACTIONS(2233),
    [anon_sym_using] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_void] = ACTIONS(2233),
    [anon_sym_delete] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2233),
    [sym_number] = ACTIONS(2233),
    [sym_private_property_identifier] = ACTIONS(2233),
    [sym_this] = ACTIONS(2233),
    [sym_super] = ACTIONS(2233),
    [sym_true] = ACTIONS(2233),
    [sym_false] = ACTIONS(2233),
    [sym_null] = ACTIONS(2233),
    [sym_undefined] = ACTIONS(2233),
    [anon_sym_AT] = ACTIONS(2233),
    [anon_sym_static] = ACTIONS(2233),
    [anon_sym_readonly] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2233),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_declare] = ACTIONS(2233),
    [anon_sym_public] = ACTIONS(2233),
    [anon_sym_private] = ACTIONS(2233),
    [anon_sym_protected] = ACTIONS(2233),
    [anon_sym_override] = ACTIONS(2233),
    [anon_sym_module] = ACTIONS(2233),
    [anon_sym_any] = ACTIONS(2233),
    [anon_sym_number] = ACTIONS(2233),
    [anon_sym_boolean] = ACTIONS(2233),
    [anon_sym_string] = ACTIONS(2233),
    [anon_sym_symbol] = ACTIONS(2233),
    [anon_sym_object] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2233),
    [anon_sym_interface] = ACTIONS(2233),
    [anon_sym_enum] = ACTIONS(2233),
    [sym_html_comment] = ACTIONS(5),
  },
  [957] = {
    [sym_comment] = STATE(957),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_export] = ACTIONS(2237),
    [anon_sym_default] = ACTIONS(2237),
    [anon_sym_type] = ACTIONS(2237),
    [anon_sym_namespace] = ACTIONS(2237),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_typeof] = ACTIONS(2237),
    [anon_sym_import] = ACTIONS(2237),
    [anon_sym_with] = ACTIONS(2237),
    [anon_sym_var] = ACTIONS(2237),
    [anon_sym_let] = ACTIONS(2237),
    [anon_sym_const] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_else] = ACTIONS(2237),
    [anon_sym_if] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_for] = ACTIONS(2237),
    [anon_sym_LPAREN] = ACTIONS(2237),
    [anon_sym_await] = ACTIONS(2237),
    [anon_sym_while] = ACTIONS(2237),
    [anon_sym_do] = ACTIONS(2237),
    [anon_sym_try] = ACTIONS(2237),
    [anon_sym_break] = ACTIONS(2237),
    [anon_sym_continue] = ACTIONS(2237),
    [anon_sym_debugger] = ACTIONS(2237),
    [anon_sym_return] = ACTIONS(2237),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2237),
    [anon_sym_case] = ACTIONS(2237),
    [anon_sym_yield] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2237),
    [anon_sym_LTtemplate_GT] = ACTIONS(2237),
    [anon_sym_DOT] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_class] = ACTIONS(2237),
    [anon_sym_async] = ACTIONS(2237),
    [anon_sym_function] = ACTIONS(2237),
    [anon_sym_new] = ACTIONS(2237),
    [anon_sym_using] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_SLASH] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_void] = ACTIONS(2237),
    [anon_sym_delete] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2237),
    [sym_number] = ACTIONS(2237),
    [sym_private_property_identifier] = ACTIONS(2237),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2237),
    [anon_sym_static] = ACTIONS(2237),
    [anon_sym_readonly] = ACTIONS(2237),
    [anon_sym_get] = ACTIONS(2237),
    [anon_sym_set] = ACTIONS(2237),
    [anon_sym_declare] = ACTIONS(2237),
    [anon_sym_public] = ACTIONS(2237),
    [anon_sym_private] = ACTIONS(2237),
    [anon_sym_protected] = ACTIONS(2237),
    [anon_sym_override] = ACTIONS(2237),
    [anon_sym_module] = ACTIONS(2237),
    [anon_sym_any] = ACTIONS(2237),
    [anon_sym_number] = ACTIONS(2237),
    [anon_sym_boolean] = ACTIONS(2237),
    [anon_sym_string] = ACTIONS(2237),
    [anon_sym_symbol] = ACTIONS(2237),
    [anon_sym_object] = ACTIONS(2237),
    [anon_sym_abstract] = ACTIONS(2237),
    [anon_sym_interface] = ACTIONS(2237),
    [anon_sym_enum] = ACTIONS(2237),
    [sym_html_comment] = ACTIONS(5),
  },
  [958] = {
    [sym_comment] = STATE(958),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_finally] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3122),
    [sym_html_comment] = ACTIONS(5),
  },
  [959] = {
    [sym_comment] = STATE(959),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_catch] = ACTIONS(2221),
    [anon_sym_finally] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [960] = {
    [sym_comment] = STATE(960),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_export] = ACTIONS(2189),
    [anon_sym_default] = ACTIONS(2189),
    [anon_sym_type] = ACTIONS(2189),
    [anon_sym_namespace] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_import] = ACTIONS(2189),
    [anon_sym_with] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_else] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2189),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_debugger] = ACTIONS(2189),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_case] = ACTIONS(2189),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2189),
    [anon_sym_LTtemplate_GT] = ACTIONS(2189),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_class] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_function] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_using] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_void] = ACTIONS(2189),
    [anon_sym_delete] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2189),
    [sym_number] = ACTIONS(2189),
    [sym_private_property_identifier] = ACTIONS(2189),
    [sym_this] = ACTIONS(2189),
    [sym_super] = ACTIONS(2189),
    [sym_true] = ACTIONS(2189),
    [sym_false] = ACTIONS(2189),
    [sym_null] = ACTIONS(2189),
    [sym_undefined] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_declare] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_module] = ACTIONS(2189),
    [anon_sym_any] = ACTIONS(2189),
    [anon_sym_number] = ACTIONS(2189),
    [anon_sym_boolean] = ACTIONS(2189),
    [anon_sym_string] = ACTIONS(2189),
    [anon_sym_symbol] = ACTIONS(2189),
    [anon_sym_object] = ACTIONS(2189),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_interface] = ACTIONS(2189),
    [anon_sym_enum] = ACTIONS(2189),
    [sym__automatic_semicolon] = ACTIONS(2193),
    [sym_html_comment] = ACTIONS(5),
  },
  [961] = {
    [sym_comment] = STATE(961),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_export] = ACTIONS(2103),
    [anon_sym_default] = ACTIONS(2103),
    [anon_sym_type] = ACTIONS(2103),
    [anon_sym_namespace] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_typeof] = ACTIONS(2103),
    [anon_sym_import] = ACTIONS(2103),
    [anon_sym_with] = ACTIONS(2103),
    [anon_sym_var] = ACTIONS(2103),
    [anon_sym_let] = ACTIONS(2103),
    [anon_sym_const] = ACTIONS(2103),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_switch] = ACTIONS(2103),
    [anon_sym_for] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_await] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_try] = ACTIONS(2103),
    [anon_sym_break] = ACTIONS(2103),
    [anon_sym_continue] = ACTIONS(2103),
    [anon_sym_debugger] = ACTIONS(2103),
    [anon_sym_return] = ACTIONS(2103),
    [anon_sym_throw] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_case] = ACTIONS(2103),
    [anon_sym_yield] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LTtemplate_GT] = ACTIONS(2103),
    [anon_sym_DQUOTE] = ACTIONS(2103),
    [anon_sym_SQUOTE] = ACTIONS(2103),
    [anon_sym_class] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(2103),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_using] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [anon_sym_void] = ACTIONS(2103),
    [anon_sym_delete] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2103),
    [sym_number] = ACTIONS(2103),
    [sym_private_property_identifier] = ACTIONS(2103),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_undefined] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2103),
    [anon_sym_static] = ACTIONS(2103),
    [anon_sym_readonly] = ACTIONS(2103),
    [anon_sym_get] = ACTIONS(2103),
    [anon_sym_set] = ACTIONS(2103),
    [anon_sym_declare] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2103),
    [anon_sym_private] = ACTIONS(2103),
    [anon_sym_protected] = ACTIONS(2103),
    [anon_sym_override] = ACTIONS(2103),
    [anon_sym_module] = ACTIONS(2103),
    [anon_sym_any] = ACTIONS(2103),
    [anon_sym_number] = ACTIONS(2103),
    [anon_sym_boolean] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_symbol] = ACTIONS(2103),
    [anon_sym_object] = ACTIONS(2103),
    [anon_sym_abstract] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2103),
    [anon_sym_enum] = ACTIONS(2103),
    [sym__automatic_semicolon] = ACTIONS(2285),
    [sym_html_comment] = ACTIONS(5),
  },
  [962] = {
    [sym_statement_block] = STATE(1520),
    [sym_comment] = STATE(962),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3124),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(3126),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [963] = {
    [sym_comment] = STATE(963),
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_export] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_type] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_RBRACE] = ACTIONS(3128),
    [anon_sym_typeof] = ACTIONS(3128),
    [anon_sym_import] = ACTIONS(3128),
    [anon_sym_with] = ACTIONS(3128),
    [anon_sym_var] = ACTIONS(3128),
    [anon_sym_let] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_else] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(3128),
    [anon_sym_await] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_debugger] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_LTtemplate_GT] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_async] = ACTIONS(3128),
    [anon_sym_function] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_SLASH] = ACTIONS(3128),
    [anon_sym_LT] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_void] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3128),
    [sym_number] = ACTIONS(3128),
    [sym_private_property_identifier] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
    [sym_super] = ACTIONS(3128),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [sym_null] = ACTIONS(3128),
    [sym_undefined] = ACTIONS(3128),
    [anon_sym_AT] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_readonly] = ACTIONS(3128),
    [anon_sym_get] = ACTIONS(3128),
    [anon_sym_set] = ACTIONS(3128),
    [anon_sym_declare] = ACTIONS(3128),
    [anon_sym_public] = ACTIONS(3128),
    [anon_sym_private] = ACTIONS(3128),
    [anon_sym_protected] = ACTIONS(3128),
    [anon_sym_override] = ACTIONS(3128),
    [anon_sym_module] = ACTIONS(3128),
    [anon_sym_any] = ACTIONS(3128),
    [anon_sym_number] = ACTIONS(3128),
    [anon_sym_boolean] = ACTIONS(3128),
    [anon_sym_string] = ACTIONS(3128),
    [anon_sym_symbol] = ACTIONS(3128),
    [anon_sym_object] = ACTIONS(3128),
    [anon_sym_abstract] = ACTIONS(3128),
    [anon_sym_interface] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [sym_html_comment] = ACTIONS(5),
  },
  [964] = {
    [sym_comment] = STATE(964),
    [sym_identifier] = ACTIONS(3130),
    [anon_sym_export] = ACTIONS(3130),
    [anon_sym_default] = ACTIONS(3130),
    [anon_sym_type] = ACTIONS(3130),
    [anon_sym_namespace] = ACTIONS(3130),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_typeof] = ACTIONS(3130),
    [anon_sym_import] = ACTIONS(3130),
    [anon_sym_with] = ACTIONS(3130),
    [anon_sym_var] = ACTIONS(3130),
    [anon_sym_let] = ACTIONS(3130),
    [anon_sym_const] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_else] = ACTIONS(3130),
    [anon_sym_if] = ACTIONS(3130),
    [anon_sym_switch] = ACTIONS(3130),
    [anon_sym_for] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [anon_sym_await] = ACTIONS(3130),
    [anon_sym_while] = ACTIONS(3130),
    [anon_sym_do] = ACTIONS(3130),
    [anon_sym_try] = ACTIONS(3130),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_continue] = ACTIONS(3130),
    [anon_sym_debugger] = ACTIONS(3130),
    [anon_sym_return] = ACTIONS(3130),
    [anon_sym_throw] = ACTIONS(3130),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_case] = ACTIONS(3130),
    [anon_sym_yield] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [anon_sym_LTtemplate_GT] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_class] = ACTIONS(3130),
    [anon_sym_async] = ACTIONS(3130),
    [anon_sym_function] = ACTIONS(3130),
    [anon_sym_new] = ACTIONS(3130),
    [anon_sym_using] = ACTIONS(3130),
    [anon_sym_PLUS] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3130),
    [anon_sym_SLASH] = ACTIONS(3130),
    [anon_sym_LT] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_void] = ACTIONS(3130),
    [anon_sym_delete] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3130),
    [sym_number] = ACTIONS(3130),
    [sym_private_property_identifier] = ACTIONS(3130),
    [sym_this] = ACTIONS(3130),
    [sym_super] = ACTIONS(3130),
    [sym_true] = ACTIONS(3130),
    [sym_false] = ACTIONS(3130),
    [sym_null] = ACTIONS(3130),
    [sym_undefined] = ACTIONS(3130),
    [anon_sym_AT] = ACTIONS(3130),
    [anon_sym_static] = ACTIONS(3130),
    [anon_sym_readonly] = ACTIONS(3130),
    [anon_sym_get] = ACTIONS(3130),
    [anon_sym_set] = ACTIONS(3130),
    [anon_sym_declare] = ACTIONS(3130),
    [anon_sym_public] = ACTIONS(3130),
    [anon_sym_private] = ACTIONS(3130),
    [anon_sym_protected] = ACTIONS(3130),
    [anon_sym_override] = ACTIONS(3130),
    [anon_sym_module] = ACTIONS(3130),
    [anon_sym_any] = ACTIONS(3130),
    [anon_sym_number] = ACTIONS(3130),
    [anon_sym_boolean] = ACTIONS(3130),
    [anon_sym_string] = ACTIONS(3130),
    [anon_sym_symbol] = ACTIONS(3130),
    [anon_sym_object] = ACTIONS(3130),
    [anon_sym_abstract] = ACTIONS(3130),
    [anon_sym_interface] = ACTIONS(3130),
    [anon_sym_enum] = ACTIONS(3130),
    [sym_html_comment] = ACTIONS(5),
  },
  [965] = {
    [sym_comment] = STATE(965),
    [sym_identifier] = ACTIONS(3132),
    [anon_sym_export] = ACTIONS(3132),
    [anon_sym_default] = ACTIONS(3132),
    [anon_sym_type] = ACTIONS(3132),
    [anon_sym_namespace] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_typeof] = ACTIONS(3132),
    [anon_sym_import] = ACTIONS(3132),
    [anon_sym_with] = ACTIONS(3132),
    [anon_sym_var] = ACTIONS(3132),
    [anon_sym_let] = ACTIONS(3132),
    [anon_sym_const] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_else] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_switch] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [anon_sym_await] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_do] = ACTIONS(3132),
    [anon_sym_try] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_continue] = ACTIONS(3132),
    [anon_sym_debugger] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_throw] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_case] = ACTIONS(3132),
    [anon_sym_yield] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_LTtemplate_GT] = ACTIONS(3132),
    [anon_sym_DQUOTE] = ACTIONS(3132),
    [anon_sym_SQUOTE] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_async] = ACTIONS(3132),
    [anon_sym_function] = ACTIONS(3132),
    [anon_sym_new] = ACTIONS(3132),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3132),
    [anon_sym_DASH] = ACTIONS(3132),
    [anon_sym_SLASH] = ACTIONS(3132),
    [anon_sym_LT] = ACTIONS(3132),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_void] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3132),
    [sym_number] = ACTIONS(3132),
    [sym_private_property_identifier] = ACTIONS(3132),
    [sym_this] = ACTIONS(3132),
    [sym_super] = ACTIONS(3132),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [sym_null] = ACTIONS(3132),
    [sym_undefined] = ACTIONS(3132),
    [anon_sym_AT] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_readonly] = ACTIONS(3132),
    [anon_sym_get] = ACTIONS(3132),
    [anon_sym_set] = ACTIONS(3132),
    [anon_sym_declare] = ACTIONS(3132),
    [anon_sym_public] = ACTIONS(3132),
    [anon_sym_private] = ACTIONS(3132),
    [anon_sym_protected] = ACTIONS(3132),
    [anon_sym_override] = ACTIONS(3132),
    [anon_sym_module] = ACTIONS(3132),
    [anon_sym_any] = ACTIONS(3132),
    [anon_sym_number] = ACTIONS(3132),
    [anon_sym_boolean] = ACTIONS(3132),
    [anon_sym_string] = ACTIONS(3132),
    [anon_sym_symbol] = ACTIONS(3132),
    [anon_sym_object] = ACTIONS(3132),
    [anon_sym_abstract] = ACTIONS(3132),
    [anon_sym_interface] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3132),
    [sym_html_comment] = ACTIONS(5),
  },
  [966] = {
    [sym_comment] = STATE(966),
    [sym_identifier] = ACTIONS(3134),
    [anon_sym_export] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_type] = ACTIONS(3134),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [anon_sym_typeof] = ACTIONS(3134),
    [anon_sym_import] = ACTIONS(3134),
    [anon_sym_with] = ACTIONS(3134),
    [anon_sym_var] = ACTIONS(3134),
    [anon_sym_let] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3134),
    [anon_sym_await] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_debugger] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_yield] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_LTtemplate_GT] = ACTIONS(3134),
    [anon_sym_DQUOTE] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_async] = ACTIONS(3134),
    [anon_sym_function] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_SLASH] = ACTIONS(3134),
    [anon_sym_LT] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_void] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_PLUS_PLUS] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3134),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3134),
    [sym_number] = ACTIONS(3134),
    [sym_private_property_identifier] = ACTIONS(3134),
    [sym_this] = ACTIONS(3134),
    [sym_super] = ACTIONS(3134),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [sym_null] = ACTIONS(3134),
    [sym_undefined] = ACTIONS(3134),
    [anon_sym_AT] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_readonly] = ACTIONS(3134),
    [anon_sym_get] = ACTIONS(3134),
    [anon_sym_set] = ACTIONS(3134),
    [anon_sym_declare] = ACTIONS(3134),
    [anon_sym_public] = ACTIONS(3134),
    [anon_sym_private] = ACTIONS(3134),
    [anon_sym_protected] = ACTIONS(3134),
    [anon_sym_override] = ACTIONS(3134),
    [anon_sym_module] = ACTIONS(3134),
    [anon_sym_any] = ACTIONS(3134),
    [anon_sym_number] = ACTIONS(3134),
    [anon_sym_boolean] = ACTIONS(3134),
    [anon_sym_string] = ACTIONS(3134),
    [anon_sym_symbol] = ACTIONS(3134),
    [anon_sym_object] = ACTIONS(3134),
    [anon_sym_abstract] = ACTIONS(3134),
    [anon_sym_interface] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [sym_html_comment] = ACTIONS(5),
  },
  [967] = {
    [sym_comment] = STATE(967),
    [sym_identifier] = ACTIONS(3136),
    [anon_sym_export] = ACTIONS(3136),
    [anon_sym_default] = ACTIONS(3136),
    [anon_sym_type] = ACTIONS(3136),
    [anon_sym_namespace] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_RBRACE] = ACTIONS(3136),
    [anon_sym_typeof] = ACTIONS(3136),
    [anon_sym_import] = ACTIONS(3136),
    [anon_sym_with] = ACTIONS(3136),
    [anon_sym_var] = ACTIONS(3136),
    [anon_sym_let] = ACTIONS(3136),
    [anon_sym_const] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_else] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_switch] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_LPAREN] = ACTIONS(3136),
    [anon_sym_await] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_do] = ACTIONS(3136),
    [anon_sym_try] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_continue] = ACTIONS(3136),
    [anon_sym_debugger] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_throw] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym_case] = ACTIONS(3136),
    [anon_sym_yield] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3136),
    [anon_sym_LTtemplate_GT] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(3136),
    [anon_sym_SQUOTE] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_async] = ACTIONS(3136),
    [anon_sym_function] = ACTIONS(3136),
    [anon_sym_new] = ACTIONS(3136),
    [anon_sym_using] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3136),
    [anon_sym_SLASH] = ACTIONS(3136),
    [anon_sym_LT] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_void] = ACTIONS(3136),
    [anon_sym_delete] = ACTIONS(3136),
    [anon_sym_PLUS_PLUS] = ACTIONS(3136),
    [anon_sym_DASH_DASH] = ACTIONS(3136),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3136),
    [sym_number] = ACTIONS(3136),
    [sym_private_property_identifier] = ACTIONS(3136),
    [sym_this] = ACTIONS(3136),
    [sym_super] = ACTIONS(3136),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [sym_null] = ACTIONS(3136),
    [sym_undefined] = ACTIONS(3136),
    [anon_sym_AT] = ACTIONS(3136),
    [anon_sym_static] = ACTIONS(3136),
    [anon_sym_readonly] = ACTIONS(3136),
    [anon_sym_get] = ACTIONS(3136),
    [anon_sym_set] = ACTIONS(3136),
    [anon_sym_declare] = ACTIONS(3136),
    [anon_sym_public] = ACTIONS(3136),
    [anon_sym_private] = ACTIONS(3136),
    [anon_sym_protected] = ACTIONS(3136),
    [anon_sym_override] = ACTIONS(3136),
    [anon_sym_module] = ACTIONS(3136),
    [anon_sym_any] = ACTIONS(3136),
    [anon_sym_number] = ACTIONS(3136),
    [anon_sym_boolean] = ACTIONS(3136),
    [anon_sym_string] = ACTIONS(3136),
    [anon_sym_symbol] = ACTIONS(3136),
    [anon_sym_object] = ACTIONS(3136),
    [anon_sym_abstract] = ACTIONS(3136),
    [anon_sym_interface] = ACTIONS(3136),
    [anon_sym_enum] = ACTIONS(3136),
    [sym_html_comment] = ACTIONS(5),
  },
  [968] = {
    [sym_comment] = STATE(968),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [969] = {
    [sym_comment] = STATE(969),
    [sym_identifier] = ACTIONS(3140),
    [anon_sym_export] = ACTIONS(3140),
    [anon_sym_default] = ACTIONS(3140),
    [anon_sym_type] = ACTIONS(3140),
    [anon_sym_namespace] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_RBRACE] = ACTIONS(3140),
    [anon_sym_typeof] = ACTIONS(3140),
    [anon_sym_import] = ACTIONS(3140),
    [anon_sym_with] = ACTIONS(3140),
    [anon_sym_var] = ACTIONS(3140),
    [anon_sym_let] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_else] = ACTIONS(3140),
    [anon_sym_if] = ACTIONS(3140),
    [anon_sym_switch] = ACTIONS(3140),
    [anon_sym_for] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3140),
    [anon_sym_await] = ACTIONS(3140),
    [anon_sym_while] = ACTIONS(3140),
    [anon_sym_do] = ACTIONS(3140),
    [anon_sym_try] = ACTIONS(3140),
    [anon_sym_break] = ACTIONS(3140),
    [anon_sym_continue] = ACTIONS(3140),
    [anon_sym_debugger] = ACTIONS(3140),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_throw] = ACTIONS(3140),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym_case] = ACTIONS(3140),
    [anon_sym_yield] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(3140),
    [anon_sym_LTtemplate_GT] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3140),
    [anon_sym_async] = ACTIONS(3140),
    [anon_sym_function] = ACTIONS(3140),
    [anon_sym_new] = ACTIONS(3140),
    [anon_sym_using] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3140),
    [anon_sym_SLASH] = ACTIONS(3140),
    [anon_sym_LT] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_void] = ACTIONS(3140),
    [anon_sym_delete] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3140),
    [sym_number] = ACTIONS(3140),
    [sym_private_property_identifier] = ACTIONS(3140),
    [sym_this] = ACTIONS(3140),
    [sym_super] = ACTIONS(3140),
    [sym_true] = ACTIONS(3140),
    [sym_false] = ACTIONS(3140),
    [sym_null] = ACTIONS(3140),
    [sym_undefined] = ACTIONS(3140),
    [anon_sym_AT] = ACTIONS(3140),
    [anon_sym_static] = ACTIONS(3140),
    [anon_sym_readonly] = ACTIONS(3140),
    [anon_sym_get] = ACTIONS(3140),
    [anon_sym_set] = ACTIONS(3140),
    [anon_sym_declare] = ACTIONS(3140),
    [anon_sym_public] = ACTIONS(3140),
    [anon_sym_private] = ACTIONS(3140),
    [anon_sym_protected] = ACTIONS(3140),
    [anon_sym_override] = ACTIONS(3140),
    [anon_sym_module] = ACTIONS(3140),
    [anon_sym_any] = ACTIONS(3140),
    [anon_sym_number] = ACTIONS(3140),
    [anon_sym_boolean] = ACTIONS(3140),
    [anon_sym_string] = ACTIONS(3140),
    [anon_sym_symbol] = ACTIONS(3140),
    [anon_sym_object] = ACTIONS(3140),
    [anon_sym_abstract] = ACTIONS(3140),
    [anon_sym_interface] = ACTIONS(3140),
    [anon_sym_enum] = ACTIONS(3140),
    [sym_html_comment] = ACTIONS(5),
  },
  [970] = {
    [sym_comment] = STATE(970),
    [sym_identifier] = ACTIONS(3142),
    [anon_sym_export] = ACTIONS(3142),
    [anon_sym_default] = ACTIONS(3142),
    [anon_sym_type] = ACTIONS(3142),
    [anon_sym_namespace] = ACTIONS(3142),
    [anon_sym_LBRACE] = ACTIONS(3142),
    [anon_sym_RBRACE] = ACTIONS(3142),
    [anon_sym_typeof] = ACTIONS(3142),
    [anon_sym_import] = ACTIONS(3142),
    [anon_sym_with] = ACTIONS(3142),
    [anon_sym_var] = ACTIONS(3142),
    [anon_sym_let] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_BANG] = ACTIONS(3142),
    [anon_sym_else] = ACTIONS(3142),
    [anon_sym_if] = ACTIONS(3142),
    [anon_sym_switch] = ACTIONS(3142),
    [anon_sym_for] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(3142),
    [anon_sym_await] = ACTIONS(3142),
    [anon_sym_while] = ACTIONS(3142),
    [anon_sym_do] = ACTIONS(3142),
    [anon_sym_try] = ACTIONS(3142),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3142),
    [anon_sym_debugger] = ACTIONS(3142),
    [anon_sym_return] = ACTIONS(3142),
    [anon_sym_throw] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3142),
    [anon_sym_case] = ACTIONS(3142),
    [anon_sym_yield] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_LTtemplate_GT] = ACTIONS(3142),
    [anon_sym_DQUOTE] = ACTIONS(3142),
    [anon_sym_SQUOTE] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_async] = ACTIONS(3142),
    [anon_sym_function] = ACTIONS(3142),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_using] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_SLASH] = ACTIONS(3142),
    [anon_sym_LT] = ACTIONS(3142),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_void] = ACTIONS(3142),
    [anon_sym_delete] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3142),
    [sym_number] = ACTIONS(3142),
    [sym_private_property_identifier] = ACTIONS(3142),
    [sym_this] = ACTIONS(3142),
    [sym_super] = ACTIONS(3142),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [sym_null] = ACTIONS(3142),
    [sym_undefined] = ACTIONS(3142),
    [anon_sym_AT] = ACTIONS(3142),
    [anon_sym_static] = ACTIONS(3142),
    [anon_sym_readonly] = ACTIONS(3142),
    [anon_sym_get] = ACTIONS(3142),
    [anon_sym_set] = ACTIONS(3142),
    [anon_sym_declare] = ACTIONS(3142),
    [anon_sym_public] = ACTIONS(3142),
    [anon_sym_private] = ACTIONS(3142),
    [anon_sym_protected] = ACTIONS(3142),
    [anon_sym_override] = ACTIONS(3142),
    [anon_sym_module] = ACTIONS(3142),
    [anon_sym_any] = ACTIONS(3142),
    [anon_sym_number] = ACTIONS(3142),
    [anon_sym_boolean] = ACTIONS(3142),
    [anon_sym_string] = ACTIONS(3142),
    [anon_sym_symbol] = ACTIONS(3142),
    [anon_sym_object] = ACTIONS(3142),
    [anon_sym_abstract] = ACTIONS(3142),
    [anon_sym_interface] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [sym_html_comment] = ACTIONS(5),
  },
  [971] = {
    [sym_comment] = STATE(971),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [972] = {
    [sym_comment] = STATE(972),
    [ts_builtin_sym_end] = ACTIONS(3118),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_export] = ACTIONS(3116),
    [anon_sym_type] = ACTIONS(3116),
    [anon_sym_namespace] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_typeof] = ACTIONS(3116),
    [anon_sym_import] = ACTIONS(3116),
    [anon_sym_with] = ACTIONS(3116),
    [anon_sym_var] = ACTIONS(3116),
    [anon_sym_let] = ACTIONS(3116),
    [anon_sym_const] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3116),
    [anon_sym_else] = ACTIONS(3116),
    [anon_sym_if] = ACTIONS(3116),
    [anon_sym_switch] = ACTIONS(3116),
    [anon_sym_for] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3116),
    [anon_sym_await] = ACTIONS(3116),
    [anon_sym_while] = ACTIONS(3116),
    [anon_sym_do] = ACTIONS(3116),
    [anon_sym_try] = ACTIONS(3116),
    [anon_sym_break] = ACTIONS(3116),
    [anon_sym_continue] = ACTIONS(3116),
    [anon_sym_debugger] = ACTIONS(3116),
    [anon_sym_return] = ACTIONS(3116),
    [anon_sym_throw] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym_yield] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [anon_sym_LTtemplate_GT] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [anon_sym_SQUOTE] = ACTIONS(3116),
    [anon_sym_class] = ACTIONS(3116),
    [anon_sym_async] = ACTIONS(3116),
    [anon_sym_function] = ACTIONS(3116),
    [anon_sym_new] = ACTIONS(3116),
    [anon_sym_using] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3116),
    [anon_sym_SLASH] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3116),
    [anon_sym_TILDE] = ACTIONS(3116),
    [anon_sym_void] = ACTIONS(3116),
    [anon_sym_delete] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [sym_number] = ACTIONS(3116),
    [sym_private_property_identifier] = ACTIONS(3116),
    [sym_this] = ACTIONS(3116),
    [sym_super] = ACTIONS(3116),
    [sym_true] = ACTIONS(3116),
    [sym_false] = ACTIONS(3116),
    [sym_null] = ACTIONS(3116),
    [sym_undefined] = ACTIONS(3116),
    [anon_sym_AT] = ACTIONS(3116),
    [anon_sym_static] = ACTIONS(3116),
    [anon_sym_readonly] = ACTIONS(3116),
    [anon_sym_get] = ACTIONS(3116),
    [anon_sym_set] = ACTIONS(3116),
    [anon_sym_declare] = ACTIONS(3116),
    [anon_sym_public] = ACTIONS(3116),
    [anon_sym_private] = ACTIONS(3116),
    [anon_sym_protected] = ACTIONS(3116),
    [anon_sym_override] = ACTIONS(3116),
    [anon_sym_module] = ACTIONS(3116),
    [anon_sym_any] = ACTIONS(3116),
    [anon_sym_number] = ACTIONS(3116),
    [anon_sym_boolean] = ACTIONS(3116),
    [anon_sym_string] = ACTIONS(3116),
    [anon_sym_symbol] = ACTIONS(3116),
    [anon_sym_object] = ACTIONS(3116),
    [anon_sym_abstract] = ACTIONS(3116),
    [anon_sym_interface] = ACTIONS(3116),
    [anon_sym_enum] = ACTIONS(3116),
    [sym__automatic_semicolon] = ACTIONS(3118),
    [sym_html_comment] = ACTIONS(5),
  },
  [973] = {
    [sym_comment] = STATE(973),
    [sym_identifier] = ACTIONS(3144),
    [anon_sym_export] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_type] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_RBRACE] = ACTIONS(3144),
    [anon_sym_typeof] = ACTIONS(3144),
    [anon_sym_import] = ACTIONS(3144),
    [anon_sym_with] = ACTIONS(3144),
    [anon_sym_var] = ACTIONS(3144),
    [anon_sym_let] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3144),
    [anon_sym_await] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_debugger] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_yield] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_LTtemplate_GT] = ACTIONS(3144),
    [anon_sym_DQUOTE] = ACTIONS(3144),
    [anon_sym_SQUOTE] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_async] = ACTIONS(3144),
    [anon_sym_function] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_SLASH] = ACTIONS(3144),
    [anon_sym_LT] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_void] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3144),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3144),
    [sym_number] = ACTIONS(3144),
    [sym_private_property_identifier] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
    [sym_super] = ACTIONS(3144),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [sym_null] = ACTIONS(3144),
    [sym_undefined] = ACTIONS(3144),
    [anon_sym_AT] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_readonly] = ACTIONS(3144),
    [anon_sym_get] = ACTIONS(3144),
    [anon_sym_set] = ACTIONS(3144),
    [anon_sym_declare] = ACTIONS(3144),
    [anon_sym_public] = ACTIONS(3144),
    [anon_sym_private] = ACTIONS(3144),
    [anon_sym_protected] = ACTIONS(3144),
    [anon_sym_override] = ACTIONS(3144),
    [anon_sym_module] = ACTIONS(3144),
    [anon_sym_any] = ACTIONS(3144),
    [anon_sym_number] = ACTIONS(3144),
    [anon_sym_boolean] = ACTIONS(3144),
    [anon_sym_string] = ACTIONS(3144),
    [anon_sym_symbol] = ACTIONS(3144),
    [anon_sym_object] = ACTIONS(3144),
    [anon_sym_abstract] = ACTIONS(3144),
    [anon_sym_interface] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [sym_html_comment] = ACTIONS(5),
  },
  [974] = {
    [sym_comment] = STATE(974),
    [sym_identifier] = ACTIONS(3146),
    [anon_sym_export] = ACTIONS(3146),
    [anon_sym_default] = ACTIONS(3146),
    [anon_sym_type] = ACTIONS(3146),
    [anon_sym_namespace] = ACTIONS(3146),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_typeof] = ACTIONS(3146),
    [anon_sym_import] = ACTIONS(3146),
    [anon_sym_with] = ACTIONS(3146),
    [anon_sym_var] = ACTIONS(3146),
    [anon_sym_let] = ACTIONS(3146),
    [anon_sym_const] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_else] = ACTIONS(3146),
    [anon_sym_if] = ACTIONS(3146),
    [anon_sym_switch] = ACTIONS(3146),
    [anon_sym_for] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_await] = ACTIONS(3146),
    [anon_sym_while] = ACTIONS(3146),
    [anon_sym_do] = ACTIONS(3146),
    [anon_sym_try] = ACTIONS(3146),
    [anon_sym_break] = ACTIONS(3146),
    [anon_sym_continue] = ACTIONS(3146),
    [anon_sym_debugger] = ACTIONS(3146),
    [anon_sym_return] = ACTIONS(3146),
    [anon_sym_throw] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_case] = ACTIONS(3146),
    [anon_sym_yield] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_LTtemplate_GT] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(3146),
    [anon_sym_async] = ACTIONS(3146),
    [anon_sym_function] = ACTIONS(3146),
    [anon_sym_new] = ACTIONS(3146),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3146),
    [anon_sym_SLASH] = ACTIONS(3146),
    [anon_sym_LT] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_void] = ACTIONS(3146),
    [anon_sym_delete] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3146),
    [sym_number] = ACTIONS(3146),
    [sym_private_property_identifier] = ACTIONS(3146),
    [sym_this] = ACTIONS(3146),
    [sym_super] = ACTIONS(3146),
    [sym_true] = ACTIONS(3146),
    [sym_false] = ACTIONS(3146),
    [sym_null] = ACTIONS(3146),
    [sym_undefined] = ACTIONS(3146),
    [anon_sym_AT] = ACTIONS(3146),
    [anon_sym_static] = ACTIONS(3146),
    [anon_sym_readonly] = ACTIONS(3146),
    [anon_sym_get] = ACTIONS(3146),
    [anon_sym_set] = ACTIONS(3146),
    [anon_sym_declare] = ACTIONS(3146),
    [anon_sym_public] = ACTIONS(3146),
    [anon_sym_private] = ACTIONS(3146),
    [anon_sym_protected] = ACTIONS(3146),
    [anon_sym_override] = ACTIONS(3146),
    [anon_sym_module] = ACTIONS(3146),
    [anon_sym_any] = ACTIONS(3146),
    [anon_sym_number] = ACTIONS(3146),
    [anon_sym_boolean] = ACTIONS(3146),
    [anon_sym_string] = ACTIONS(3146),
    [anon_sym_symbol] = ACTIONS(3146),
    [anon_sym_object] = ACTIONS(3146),
    [anon_sym_abstract] = ACTIONS(3146),
    [anon_sym_interface] = ACTIONS(3146),
    [anon_sym_enum] = ACTIONS(3146),
    [sym_html_comment] = ACTIONS(5),
  },
  [975] = {
    [sym_comment] = STATE(975),
    [sym_identifier] = ACTIONS(3148),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_default] = ACTIONS(3148),
    [anon_sym_type] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_typeof] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3148),
    [anon_sym_with] = ACTIONS(3148),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_await] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_debugger] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_yield] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_LTtemplate_GT] = ACTIONS(3148),
    [anon_sym_DQUOTE] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_async] = ACTIONS(3148),
    [anon_sym_function] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_SLASH] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_void] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3148),
    [sym_number] = ACTIONS(3148),
    [sym_private_property_identifier] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
    [sym_super] = ACTIONS(3148),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [sym_null] = ACTIONS(3148),
    [sym_undefined] = ACTIONS(3148),
    [anon_sym_AT] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_readonly] = ACTIONS(3148),
    [anon_sym_get] = ACTIONS(3148),
    [anon_sym_set] = ACTIONS(3148),
    [anon_sym_declare] = ACTIONS(3148),
    [anon_sym_public] = ACTIONS(3148),
    [anon_sym_private] = ACTIONS(3148),
    [anon_sym_protected] = ACTIONS(3148),
    [anon_sym_override] = ACTIONS(3148),
    [anon_sym_module] = ACTIONS(3148),
    [anon_sym_any] = ACTIONS(3148),
    [anon_sym_number] = ACTIONS(3148),
    [anon_sym_boolean] = ACTIONS(3148),
    [anon_sym_string] = ACTIONS(3148),
    [anon_sym_symbol] = ACTIONS(3148),
    [anon_sym_object] = ACTIONS(3148),
    [anon_sym_abstract] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [sym_html_comment] = ACTIONS(5),
  },
  [976] = {
    [sym_comment] = STATE(976),
    [sym_identifier] = ACTIONS(3150),
    [anon_sym_export] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_type] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_typeof] = ACTIONS(3150),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_with] = ACTIONS(3150),
    [anon_sym_var] = ACTIONS(3150),
    [anon_sym_let] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_LPAREN] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_debugger] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_yield] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_LTtemplate_GT] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_async] = ACTIONS(3150),
    [anon_sym_function] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3150),
    [anon_sym_LT] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_void] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3150),
    [sym_number] = ACTIONS(3150),
    [sym_private_property_identifier] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
    [sym_super] = ACTIONS(3150),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [sym_null] = ACTIONS(3150),
    [sym_undefined] = ACTIONS(3150),
    [anon_sym_AT] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_readonly] = ACTIONS(3150),
    [anon_sym_get] = ACTIONS(3150),
    [anon_sym_set] = ACTIONS(3150),
    [anon_sym_declare] = ACTIONS(3150),
    [anon_sym_public] = ACTIONS(3150),
    [anon_sym_private] = ACTIONS(3150),
    [anon_sym_protected] = ACTIONS(3150),
    [anon_sym_override] = ACTIONS(3150),
    [anon_sym_module] = ACTIONS(3150),
    [anon_sym_any] = ACTIONS(3150),
    [anon_sym_number] = ACTIONS(3150),
    [anon_sym_boolean] = ACTIONS(3150),
    [anon_sym_string] = ACTIONS(3150),
    [anon_sym_symbol] = ACTIONS(3150),
    [anon_sym_object] = ACTIONS(3150),
    [anon_sym_abstract] = ACTIONS(3150),
    [anon_sym_interface] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [sym_html_comment] = ACTIONS(5),
  },
  [977] = {
    [sym_comment] = STATE(977),
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_export] = ACTIONS(3152),
    [anon_sym_default] = ACTIONS(3152),
    [anon_sym_type] = ACTIONS(3152),
    [anon_sym_namespace] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3152),
    [anon_sym_typeof] = ACTIONS(3152),
    [anon_sym_import] = ACTIONS(3152),
    [anon_sym_with] = ACTIONS(3152),
    [anon_sym_var] = ACTIONS(3152),
    [anon_sym_let] = ACTIONS(3152),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_else] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_switch] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3152),
    [anon_sym_await] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_do] = ACTIONS(3152),
    [anon_sym_try] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_continue] = ACTIONS(3152),
    [anon_sym_debugger] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_throw] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_yield] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_LTtemplate_GT] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_async] = ACTIONS(3152),
    [anon_sym_function] = ACTIONS(3152),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_using] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_LT] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_void] = ACTIONS(3152),
    [anon_sym_delete] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3152),
    [sym_number] = ACTIONS(3152),
    [sym_private_property_identifier] = ACTIONS(3152),
    [sym_this] = ACTIONS(3152),
    [sym_super] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_null] = ACTIONS(3152),
    [sym_undefined] = ACTIONS(3152),
    [anon_sym_AT] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_readonly] = ACTIONS(3152),
    [anon_sym_get] = ACTIONS(3152),
    [anon_sym_set] = ACTIONS(3152),
    [anon_sym_declare] = ACTIONS(3152),
    [anon_sym_public] = ACTIONS(3152),
    [anon_sym_private] = ACTIONS(3152),
    [anon_sym_protected] = ACTIONS(3152),
    [anon_sym_override] = ACTIONS(3152),
    [anon_sym_module] = ACTIONS(3152),
    [anon_sym_any] = ACTIONS(3152),
    [anon_sym_number] = ACTIONS(3152),
    [anon_sym_boolean] = ACTIONS(3152),
    [anon_sym_string] = ACTIONS(3152),
    [anon_sym_symbol] = ACTIONS(3152),
    [anon_sym_object] = ACTIONS(3152),
    [anon_sym_abstract] = ACTIONS(3152),
    [anon_sym_interface] = ACTIONS(3152),
    [anon_sym_enum] = ACTIONS(3152),
    [sym_html_comment] = ACTIONS(5),
  },
  [978] = {
    [sym_comment] = STATE(978),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [979] = {
    [sym_comment] = STATE(979),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_export] = ACTIONS(3154),
    [anon_sym_default] = ACTIONS(3154),
    [anon_sym_type] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_typeof] = ACTIONS(3154),
    [anon_sym_import] = ACTIONS(3154),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_var] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_await] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_debugger] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_case] = ACTIONS(3154),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LTtemplate_GT] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_async] = ACTIONS(3154),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_SLASH] = ACTIONS(3154),
    [anon_sym_LT] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_void] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3154),
    [sym_number] = ACTIONS(3154),
    [sym_private_property_identifier] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
    [sym_super] = ACTIONS(3154),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [sym_null] = ACTIONS(3154),
    [sym_undefined] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_readonly] = ACTIONS(3154),
    [anon_sym_get] = ACTIONS(3154),
    [anon_sym_set] = ACTIONS(3154),
    [anon_sym_declare] = ACTIONS(3154),
    [anon_sym_public] = ACTIONS(3154),
    [anon_sym_private] = ACTIONS(3154),
    [anon_sym_protected] = ACTIONS(3154),
    [anon_sym_override] = ACTIONS(3154),
    [anon_sym_module] = ACTIONS(3154),
    [anon_sym_any] = ACTIONS(3154),
    [anon_sym_number] = ACTIONS(3154),
    [anon_sym_boolean] = ACTIONS(3154),
    [anon_sym_string] = ACTIONS(3154),
    [anon_sym_symbol] = ACTIONS(3154),
    [anon_sym_object] = ACTIONS(3154),
    [anon_sym_abstract] = ACTIONS(3154),
    [anon_sym_interface] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [sym_html_comment] = ACTIONS(5),
  },
  [980] = {
    [sym_comment] = STATE(980),
    [sym_identifier] = ACTIONS(3156),
    [anon_sym_export] = ACTIONS(3156),
    [anon_sym_default] = ACTIONS(3156),
    [anon_sym_type] = ACTIONS(3156),
    [anon_sym_namespace] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_typeof] = ACTIONS(3156),
    [anon_sym_import] = ACTIONS(3156),
    [anon_sym_with] = ACTIONS(3156),
    [anon_sym_var] = ACTIONS(3156),
    [anon_sym_let] = ACTIONS(3156),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_else] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_switch] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3156),
    [anon_sym_await] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_do] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_debugger] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_throw] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym_case] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_LTtemplate_GT] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_async] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_using] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_SLASH] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_void] = ACTIONS(3156),
    [anon_sym_delete] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [sym_number] = ACTIONS(3156),
    [sym_private_property_identifier] = ACTIONS(3156),
    [sym_this] = ACTIONS(3156),
    [sym_super] = ACTIONS(3156),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [sym_null] = ACTIONS(3156),
    [sym_undefined] = ACTIONS(3156),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_readonly] = ACTIONS(3156),
    [anon_sym_get] = ACTIONS(3156),
    [anon_sym_set] = ACTIONS(3156),
    [anon_sym_declare] = ACTIONS(3156),
    [anon_sym_public] = ACTIONS(3156),
    [anon_sym_private] = ACTIONS(3156),
    [anon_sym_protected] = ACTIONS(3156),
    [anon_sym_override] = ACTIONS(3156),
    [anon_sym_module] = ACTIONS(3156),
    [anon_sym_any] = ACTIONS(3156),
    [anon_sym_number] = ACTIONS(3156),
    [anon_sym_boolean] = ACTIONS(3156),
    [anon_sym_string] = ACTIONS(3156),
    [anon_sym_symbol] = ACTIONS(3156),
    [anon_sym_object] = ACTIONS(3156),
    [anon_sym_abstract] = ACTIONS(3156),
    [anon_sym_interface] = ACTIONS(3156),
    [anon_sym_enum] = ACTIONS(3156),
    [sym_html_comment] = ACTIONS(5),
  },
  [981] = {
    [sym_comment] = STATE(981),
    [sym_identifier] = ACTIONS(3158),
    [anon_sym_export] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_type] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_typeof] = ACTIONS(3158),
    [anon_sym_import] = ACTIONS(3158),
    [anon_sym_with] = ACTIONS(3158),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_LPAREN] = ACTIONS(3158),
    [anon_sym_await] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_debugger] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_yield] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_LTtemplate_GT] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_async] = ACTIONS(3158),
    [anon_sym_function] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_SLASH] = ACTIONS(3158),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [anon_sym_void] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3158),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3158),
    [sym_number] = ACTIONS(3158),
    [sym_private_property_identifier] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
    [sym_super] = ACTIONS(3158),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [sym_null] = ACTIONS(3158),
    [sym_undefined] = ACTIONS(3158),
    [anon_sym_AT] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_readonly] = ACTIONS(3158),
    [anon_sym_get] = ACTIONS(3158),
    [anon_sym_set] = ACTIONS(3158),
    [anon_sym_declare] = ACTIONS(3158),
    [anon_sym_public] = ACTIONS(3158),
    [anon_sym_private] = ACTIONS(3158),
    [anon_sym_protected] = ACTIONS(3158),
    [anon_sym_override] = ACTIONS(3158),
    [anon_sym_module] = ACTIONS(3158),
    [anon_sym_any] = ACTIONS(3158),
    [anon_sym_number] = ACTIONS(3158),
    [anon_sym_boolean] = ACTIONS(3158),
    [anon_sym_string] = ACTIONS(3158),
    [anon_sym_symbol] = ACTIONS(3158),
    [anon_sym_object] = ACTIONS(3158),
    [anon_sym_abstract] = ACTIONS(3158),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [sym_html_comment] = ACTIONS(5),
  },
  [982] = {
    [sym_comment] = STATE(982),
    [sym_identifier] = ACTIONS(3160),
    [anon_sym_export] = ACTIONS(3160),
    [anon_sym_default] = ACTIONS(3160),
    [anon_sym_type] = ACTIONS(3160),
    [anon_sym_namespace] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_typeof] = ACTIONS(3160),
    [anon_sym_import] = ACTIONS(3160),
    [anon_sym_with] = ACTIONS(3160),
    [anon_sym_var] = ACTIONS(3160),
    [anon_sym_let] = ACTIONS(3160),
    [anon_sym_const] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_else] = ACTIONS(3160),
    [anon_sym_if] = ACTIONS(3160),
    [anon_sym_switch] = ACTIONS(3160),
    [anon_sym_for] = ACTIONS(3160),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_await] = ACTIONS(3160),
    [anon_sym_while] = ACTIONS(3160),
    [anon_sym_do] = ACTIONS(3160),
    [anon_sym_try] = ACTIONS(3160),
    [anon_sym_break] = ACTIONS(3160),
    [anon_sym_continue] = ACTIONS(3160),
    [anon_sym_debugger] = ACTIONS(3160),
    [anon_sym_return] = ACTIONS(3160),
    [anon_sym_throw] = ACTIONS(3160),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym_case] = ACTIONS(3160),
    [anon_sym_yield] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_LTtemplate_GT] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_class] = ACTIONS(3160),
    [anon_sym_async] = ACTIONS(3160),
    [anon_sym_function] = ACTIONS(3160),
    [anon_sym_new] = ACTIONS(3160),
    [anon_sym_using] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3160),
    [anon_sym_SLASH] = ACTIONS(3160),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_void] = ACTIONS(3160),
    [anon_sym_delete] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3160),
    [sym_number] = ACTIONS(3160),
    [sym_private_property_identifier] = ACTIONS(3160),
    [sym_this] = ACTIONS(3160),
    [sym_super] = ACTIONS(3160),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [sym_null] = ACTIONS(3160),
    [sym_undefined] = ACTIONS(3160),
    [anon_sym_AT] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_readonly] = ACTIONS(3160),
    [anon_sym_get] = ACTIONS(3160),
    [anon_sym_set] = ACTIONS(3160),
    [anon_sym_declare] = ACTIONS(3160),
    [anon_sym_public] = ACTIONS(3160),
    [anon_sym_private] = ACTIONS(3160),
    [anon_sym_protected] = ACTIONS(3160),
    [anon_sym_override] = ACTIONS(3160),
    [anon_sym_module] = ACTIONS(3160),
    [anon_sym_any] = ACTIONS(3160),
    [anon_sym_number] = ACTIONS(3160),
    [anon_sym_boolean] = ACTIONS(3160),
    [anon_sym_string] = ACTIONS(3160),
    [anon_sym_symbol] = ACTIONS(3160),
    [anon_sym_object] = ACTIONS(3160),
    [anon_sym_abstract] = ACTIONS(3160),
    [anon_sym_interface] = ACTIONS(3160),
    [anon_sym_enum] = ACTIONS(3160),
    [sym_html_comment] = ACTIONS(5),
  },
  [983] = {
    [sym_comment] = STATE(983),
    [sym_identifier] = ACTIONS(3162),
    [anon_sym_export] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_type] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_RBRACE] = ACTIONS(3162),
    [anon_sym_typeof] = ACTIONS(3162),
    [anon_sym_import] = ACTIONS(3162),
    [anon_sym_with] = ACTIONS(3162),
    [anon_sym_var] = ACTIONS(3162),
    [anon_sym_let] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_LPAREN] = ACTIONS(3162),
    [anon_sym_await] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_debugger] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_yield] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_LTtemplate_GT] = ACTIONS(3162),
    [anon_sym_DQUOTE] = ACTIONS(3162),
    [anon_sym_SQUOTE] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_async] = ACTIONS(3162),
    [anon_sym_function] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_SLASH] = ACTIONS(3162),
    [anon_sym_LT] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_void] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3162),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3162),
    [sym_number] = ACTIONS(3162),
    [sym_private_property_identifier] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
    [sym_super] = ACTIONS(3162),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [sym_null] = ACTIONS(3162),
    [sym_undefined] = ACTIONS(3162),
    [anon_sym_AT] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_readonly] = ACTIONS(3162),
    [anon_sym_get] = ACTIONS(3162),
    [anon_sym_set] = ACTIONS(3162),
    [anon_sym_declare] = ACTIONS(3162),
    [anon_sym_public] = ACTIONS(3162),
    [anon_sym_private] = ACTIONS(3162),
    [anon_sym_protected] = ACTIONS(3162),
    [anon_sym_override] = ACTIONS(3162),
    [anon_sym_module] = ACTIONS(3162),
    [anon_sym_any] = ACTIONS(3162),
    [anon_sym_number] = ACTIONS(3162),
    [anon_sym_boolean] = ACTIONS(3162),
    [anon_sym_string] = ACTIONS(3162),
    [anon_sym_symbol] = ACTIONS(3162),
    [anon_sym_object] = ACTIONS(3162),
    [anon_sym_abstract] = ACTIONS(3162),
    [anon_sym_interface] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [sym_html_comment] = ACTIONS(5),
  },
  [984] = {
    [sym_comment] = STATE(984),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3164),
    [sym_html_comment] = ACTIONS(5),
  },
  [985] = {
    [sym_comment] = STATE(985),
    [sym_identifier] = ACTIONS(3166),
    [anon_sym_export] = ACTIONS(3166),
    [anon_sym_default] = ACTIONS(3166),
    [anon_sym_type] = ACTIONS(3166),
    [anon_sym_namespace] = ACTIONS(3166),
    [anon_sym_LBRACE] = ACTIONS(3166),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [anon_sym_typeof] = ACTIONS(3166),
    [anon_sym_import] = ACTIONS(3166),
    [anon_sym_with] = ACTIONS(3166),
    [anon_sym_var] = ACTIONS(3166),
    [anon_sym_let] = ACTIONS(3166),
    [anon_sym_const] = ACTIONS(3166),
    [anon_sym_BANG] = ACTIONS(3166),
    [anon_sym_else] = ACTIONS(3166),
    [anon_sym_if] = ACTIONS(3166),
    [anon_sym_switch] = ACTIONS(3166),
    [anon_sym_for] = ACTIONS(3166),
    [anon_sym_LPAREN] = ACTIONS(3166),
    [anon_sym_await] = ACTIONS(3166),
    [anon_sym_while] = ACTIONS(3166),
    [anon_sym_do] = ACTIONS(3166),
    [anon_sym_try] = ACTIONS(3166),
    [anon_sym_break] = ACTIONS(3166),
    [anon_sym_continue] = ACTIONS(3166),
    [anon_sym_debugger] = ACTIONS(3166),
    [anon_sym_return] = ACTIONS(3166),
    [anon_sym_throw] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym_case] = ACTIONS(3166),
    [anon_sym_yield] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [anon_sym_LTtemplate_GT] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [anon_sym_SQUOTE] = ACTIONS(3166),
    [anon_sym_class] = ACTIONS(3166),
    [anon_sym_async] = ACTIONS(3166),
    [anon_sym_function] = ACTIONS(3166),
    [anon_sym_new] = ACTIONS(3166),
    [anon_sym_using] = ACTIONS(3166),
    [anon_sym_PLUS] = ACTIONS(3166),
    [anon_sym_DASH] = ACTIONS(3166),
    [anon_sym_SLASH] = ACTIONS(3166),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_void] = ACTIONS(3166),
    [anon_sym_delete] = ACTIONS(3166),
    [anon_sym_PLUS_PLUS] = ACTIONS(3166),
    [anon_sym_DASH_DASH] = ACTIONS(3166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3166),
    [sym_number] = ACTIONS(3166),
    [sym_private_property_identifier] = ACTIONS(3166),
    [sym_this] = ACTIONS(3166),
    [sym_super] = ACTIONS(3166),
    [sym_true] = ACTIONS(3166),
    [sym_false] = ACTIONS(3166),
    [sym_null] = ACTIONS(3166),
    [sym_undefined] = ACTIONS(3166),
    [anon_sym_AT] = ACTIONS(3166),
    [anon_sym_static] = ACTIONS(3166),
    [anon_sym_readonly] = ACTIONS(3166),
    [anon_sym_get] = ACTIONS(3166),
    [anon_sym_set] = ACTIONS(3166),
    [anon_sym_declare] = ACTIONS(3166),
    [anon_sym_public] = ACTIONS(3166),
    [anon_sym_private] = ACTIONS(3166),
    [anon_sym_protected] = ACTIONS(3166),
    [anon_sym_override] = ACTIONS(3166),
    [anon_sym_module] = ACTIONS(3166),
    [anon_sym_any] = ACTIONS(3166),
    [anon_sym_number] = ACTIONS(3166),
    [anon_sym_boolean] = ACTIONS(3166),
    [anon_sym_string] = ACTIONS(3166),
    [anon_sym_symbol] = ACTIONS(3166),
    [anon_sym_object] = ACTIONS(3166),
    [anon_sym_abstract] = ACTIONS(3166),
    [anon_sym_interface] = ACTIONS(3166),
    [anon_sym_enum] = ACTIONS(3166),
    [sym_html_comment] = ACTIONS(5),
  },
  [986] = {
    [sym_comment] = STATE(986),
    [sym_identifier] = ACTIONS(3168),
    [anon_sym_export] = ACTIONS(3168),
    [anon_sym_default] = ACTIONS(3168),
    [anon_sym_type] = ACTIONS(3168),
    [anon_sym_namespace] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_typeof] = ACTIONS(3168),
    [anon_sym_import] = ACTIONS(3168),
    [anon_sym_with] = ACTIONS(3168),
    [anon_sym_var] = ACTIONS(3168),
    [anon_sym_let] = ACTIONS(3168),
    [anon_sym_const] = ACTIONS(3168),
    [anon_sym_BANG] = ACTIONS(3168),
    [anon_sym_else] = ACTIONS(3168),
    [anon_sym_if] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3168),
    [anon_sym_LPAREN] = ACTIONS(3168),
    [anon_sym_await] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3168),
    [anon_sym_do] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3168),
    [anon_sym_break] = ACTIONS(3168),
    [anon_sym_continue] = ACTIONS(3168),
    [anon_sym_debugger] = ACTIONS(3168),
    [anon_sym_return] = ACTIONS(3168),
    [anon_sym_throw] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_case] = ACTIONS(3168),
    [anon_sym_yield] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_LTtemplate_GT] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_class] = ACTIONS(3168),
    [anon_sym_async] = ACTIONS(3168),
    [anon_sym_function] = ACTIONS(3168),
    [anon_sym_new] = ACTIONS(3168),
    [anon_sym_using] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3168),
    [anon_sym_SLASH] = ACTIONS(3168),
    [anon_sym_LT] = ACTIONS(3168),
    [anon_sym_TILDE] = ACTIONS(3168),
    [anon_sym_void] = ACTIONS(3168),
    [anon_sym_delete] = ACTIONS(3168),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3168),
    [sym_number] = ACTIONS(3168),
    [sym_private_property_identifier] = ACTIONS(3168),
    [sym_this] = ACTIONS(3168),
    [sym_super] = ACTIONS(3168),
    [sym_true] = ACTIONS(3168),
    [sym_false] = ACTIONS(3168),
    [sym_null] = ACTIONS(3168),
    [sym_undefined] = ACTIONS(3168),
    [anon_sym_AT] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3168),
    [anon_sym_readonly] = ACTIONS(3168),
    [anon_sym_get] = ACTIONS(3168),
    [anon_sym_set] = ACTIONS(3168),
    [anon_sym_declare] = ACTIONS(3168),
    [anon_sym_public] = ACTIONS(3168),
    [anon_sym_private] = ACTIONS(3168),
    [anon_sym_protected] = ACTIONS(3168),
    [anon_sym_override] = ACTIONS(3168),
    [anon_sym_module] = ACTIONS(3168),
    [anon_sym_any] = ACTIONS(3168),
    [anon_sym_number] = ACTIONS(3168),
    [anon_sym_boolean] = ACTIONS(3168),
    [anon_sym_string] = ACTIONS(3168),
    [anon_sym_symbol] = ACTIONS(3168),
    [anon_sym_object] = ACTIONS(3168),
    [anon_sym_abstract] = ACTIONS(3168),
    [anon_sym_interface] = ACTIONS(3168),
    [anon_sym_enum] = ACTIONS(3168),
    [sym_html_comment] = ACTIONS(5),
  },
  [987] = {
    [sym_comment] = STATE(987),
    [sym_identifier] = ACTIONS(3170),
    [anon_sym_export] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_type] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_typeof] = ACTIONS(3170),
    [anon_sym_import] = ACTIONS(3170),
    [anon_sym_with] = ACTIONS(3170),
    [anon_sym_var] = ACTIONS(3170),
    [anon_sym_let] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_else] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_await] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_debugger] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_yield] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_LTtemplate_GT] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_async] = ACTIONS(3170),
    [anon_sym_function] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_void] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [sym_number] = ACTIONS(3170),
    [sym_private_property_identifier] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
    [sym_super] = ACTIONS(3170),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [sym_null] = ACTIONS(3170),
    [sym_undefined] = ACTIONS(3170),
    [anon_sym_AT] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_readonly] = ACTIONS(3170),
    [anon_sym_get] = ACTIONS(3170),
    [anon_sym_set] = ACTIONS(3170),
    [anon_sym_declare] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_override] = ACTIONS(3170),
    [anon_sym_module] = ACTIONS(3170),
    [anon_sym_any] = ACTIONS(3170),
    [anon_sym_number] = ACTIONS(3170),
    [anon_sym_boolean] = ACTIONS(3170),
    [anon_sym_string] = ACTIONS(3170),
    [anon_sym_symbol] = ACTIONS(3170),
    [anon_sym_object] = ACTIONS(3170),
    [anon_sym_abstract] = ACTIONS(3170),
    [anon_sym_interface] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [sym_html_comment] = ACTIONS(5),
  },
  [988] = {
    [sym_comment] = STATE(988),
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_export] = ACTIONS(3172),
    [anon_sym_default] = ACTIONS(3172),
    [anon_sym_type] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_typeof] = ACTIONS(3172),
    [anon_sym_import] = ACTIONS(3172),
    [anon_sym_with] = ACTIONS(3172),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_else] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_LPAREN] = ACTIONS(3172),
    [anon_sym_await] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_debugger] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_case] = ACTIONS(3172),
    [anon_sym_yield] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_LTtemplate_GT] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_async] = ACTIONS(3172),
    [anon_sym_function] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_SLASH] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_void] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3172),
    [sym_number] = ACTIONS(3172),
    [sym_private_property_identifier] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
    [sym_super] = ACTIONS(3172),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [sym_null] = ACTIONS(3172),
    [sym_undefined] = ACTIONS(3172),
    [anon_sym_AT] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_readonly] = ACTIONS(3172),
    [anon_sym_get] = ACTIONS(3172),
    [anon_sym_set] = ACTIONS(3172),
    [anon_sym_declare] = ACTIONS(3172),
    [anon_sym_public] = ACTIONS(3172),
    [anon_sym_private] = ACTIONS(3172),
    [anon_sym_protected] = ACTIONS(3172),
    [anon_sym_override] = ACTIONS(3172),
    [anon_sym_module] = ACTIONS(3172),
    [anon_sym_any] = ACTIONS(3172),
    [anon_sym_number] = ACTIONS(3172),
    [anon_sym_boolean] = ACTIONS(3172),
    [anon_sym_string] = ACTIONS(3172),
    [anon_sym_symbol] = ACTIONS(3172),
    [anon_sym_object] = ACTIONS(3172),
    [anon_sym_abstract] = ACTIONS(3172),
    [anon_sym_interface] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [sym_html_comment] = ACTIONS(5),
  },
  [989] = {
    [sym_comment] = STATE(989),
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_export] = ACTIONS(3172),
    [anon_sym_default] = ACTIONS(3172),
    [anon_sym_type] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_typeof] = ACTIONS(3172),
    [anon_sym_import] = ACTIONS(3172),
    [anon_sym_with] = ACTIONS(3172),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_else] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_LPAREN] = ACTIONS(3172),
    [anon_sym_await] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_debugger] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_case] = ACTIONS(3172),
    [anon_sym_yield] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_LTtemplate_GT] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_async] = ACTIONS(3172),
    [anon_sym_function] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_SLASH] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_void] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3172),
    [sym_number] = ACTIONS(3172),
    [sym_private_property_identifier] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
    [sym_super] = ACTIONS(3172),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [sym_null] = ACTIONS(3172),
    [sym_undefined] = ACTIONS(3172),
    [anon_sym_AT] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_readonly] = ACTIONS(3172),
    [anon_sym_get] = ACTIONS(3172),
    [anon_sym_set] = ACTIONS(3172),
    [anon_sym_declare] = ACTIONS(3172),
    [anon_sym_public] = ACTIONS(3172),
    [anon_sym_private] = ACTIONS(3172),
    [anon_sym_protected] = ACTIONS(3172),
    [anon_sym_override] = ACTIONS(3172),
    [anon_sym_module] = ACTIONS(3172),
    [anon_sym_any] = ACTIONS(3172),
    [anon_sym_number] = ACTIONS(3172),
    [anon_sym_boolean] = ACTIONS(3172),
    [anon_sym_string] = ACTIONS(3172),
    [anon_sym_symbol] = ACTIONS(3172),
    [anon_sym_object] = ACTIONS(3172),
    [anon_sym_abstract] = ACTIONS(3172),
    [anon_sym_interface] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [sym_html_comment] = ACTIONS(5),
  },
  [990] = {
    [sym_comment] = STATE(990),
    [sym_identifier] = ACTIONS(3174),
    [anon_sym_export] = ACTIONS(3174),
    [anon_sym_default] = ACTIONS(3174),
    [anon_sym_type] = ACTIONS(3174),
    [anon_sym_namespace] = ACTIONS(3174),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(3174),
    [anon_sym_typeof] = ACTIONS(3174),
    [anon_sym_import] = ACTIONS(3174),
    [anon_sym_with] = ACTIONS(3174),
    [anon_sym_var] = ACTIONS(3174),
    [anon_sym_let] = ACTIONS(3174),
    [anon_sym_const] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_else] = ACTIONS(3174),
    [anon_sym_if] = ACTIONS(3174),
    [anon_sym_switch] = ACTIONS(3174),
    [anon_sym_for] = ACTIONS(3174),
    [anon_sym_LPAREN] = ACTIONS(3174),
    [anon_sym_await] = ACTIONS(3174),
    [anon_sym_while] = ACTIONS(3174),
    [anon_sym_do] = ACTIONS(3174),
    [anon_sym_try] = ACTIONS(3174),
    [anon_sym_break] = ACTIONS(3174),
    [anon_sym_continue] = ACTIONS(3174),
    [anon_sym_debugger] = ACTIONS(3174),
    [anon_sym_return] = ACTIONS(3174),
    [anon_sym_throw] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym_case] = ACTIONS(3174),
    [anon_sym_yield] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(3174),
    [anon_sym_LTtemplate_GT] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_class] = ACTIONS(3174),
    [anon_sym_async] = ACTIONS(3174),
    [anon_sym_function] = ACTIONS(3174),
    [anon_sym_new] = ACTIONS(3174),
    [anon_sym_using] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_SLASH] = ACTIONS(3174),
    [anon_sym_LT] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_void] = ACTIONS(3174),
    [anon_sym_delete] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3174),
    [sym_number] = ACTIONS(3174),
    [sym_private_property_identifier] = ACTIONS(3174),
    [sym_this] = ACTIONS(3174),
    [sym_super] = ACTIONS(3174),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [sym_null] = ACTIONS(3174),
    [sym_undefined] = ACTIONS(3174),
    [anon_sym_AT] = ACTIONS(3174),
    [anon_sym_static] = ACTIONS(3174),
    [anon_sym_readonly] = ACTIONS(3174),
    [anon_sym_get] = ACTIONS(3174),
    [anon_sym_set] = ACTIONS(3174),
    [anon_sym_declare] = ACTIONS(3174),
    [anon_sym_public] = ACTIONS(3174),
    [anon_sym_private] = ACTIONS(3174),
    [anon_sym_protected] = ACTIONS(3174),
    [anon_sym_override] = ACTIONS(3174),
    [anon_sym_module] = ACTIONS(3174),
    [anon_sym_any] = ACTIONS(3174),
    [anon_sym_number] = ACTIONS(3174),
    [anon_sym_boolean] = ACTIONS(3174),
    [anon_sym_string] = ACTIONS(3174),
    [anon_sym_symbol] = ACTIONS(3174),
    [anon_sym_object] = ACTIONS(3174),
    [anon_sym_abstract] = ACTIONS(3174),
    [anon_sym_interface] = ACTIONS(3174),
    [anon_sym_enum] = ACTIONS(3174),
    [sym_html_comment] = ACTIONS(5),
  },
  [991] = {
    [sym_comment] = STATE(991),
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_export] = ACTIONS(3176),
    [anon_sym_default] = ACTIONS(3176),
    [anon_sym_type] = ACTIONS(3176),
    [anon_sym_namespace] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3176),
    [anon_sym_RBRACE] = ACTIONS(3176),
    [anon_sym_typeof] = ACTIONS(3176),
    [anon_sym_import] = ACTIONS(3176),
    [anon_sym_with] = ACTIONS(3176),
    [anon_sym_var] = ACTIONS(3176),
    [anon_sym_let] = ACTIONS(3176),
    [anon_sym_const] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_else] = ACTIONS(3176),
    [anon_sym_if] = ACTIONS(3176),
    [anon_sym_switch] = ACTIONS(3176),
    [anon_sym_for] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(3176),
    [anon_sym_await] = ACTIONS(3176),
    [anon_sym_while] = ACTIONS(3176),
    [anon_sym_do] = ACTIONS(3176),
    [anon_sym_try] = ACTIONS(3176),
    [anon_sym_break] = ACTIONS(3176),
    [anon_sym_continue] = ACTIONS(3176),
    [anon_sym_debugger] = ACTIONS(3176),
    [anon_sym_return] = ACTIONS(3176),
    [anon_sym_throw] = ACTIONS(3176),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym_case] = ACTIONS(3176),
    [anon_sym_yield] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_LTtemplate_GT] = ACTIONS(3176),
    [anon_sym_DQUOTE] = ACTIONS(3176),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym_class] = ACTIONS(3176),
    [anon_sym_async] = ACTIONS(3176),
    [anon_sym_function] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3176),
    [anon_sym_using] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_SLASH] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3176),
    [anon_sym_TILDE] = ACTIONS(3176),
    [anon_sym_void] = ACTIONS(3176),
    [anon_sym_delete] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3176),
    [sym_number] = ACTIONS(3176),
    [sym_private_property_identifier] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_super] = ACTIONS(3176),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [sym_null] = ACTIONS(3176),
    [sym_undefined] = ACTIONS(3176),
    [anon_sym_AT] = ACTIONS(3176),
    [anon_sym_static] = ACTIONS(3176),
    [anon_sym_readonly] = ACTIONS(3176),
    [anon_sym_get] = ACTIONS(3176),
    [anon_sym_set] = ACTIONS(3176),
    [anon_sym_declare] = ACTIONS(3176),
    [anon_sym_public] = ACTIONS(3176),
    [anon_sym_private] = ACTIONS(3176),
    [anon_sym_protected] = ACTIONS(3176),
    [anon_sym_override] = ACTIONS(3176),
    [anon_sym_module] = ACTIONS(3176),
    [anon_sym_any] = ACTIONS(3176),
    [anon_sym_number] = ACTIONS(3176),
    [anon_sym_boolean] = ACTIONS(3176),
    [anon_sym_string] = ACTIONS(3176),
    [anon_sym_symbol] = ACTIONS(3176),
    [anon_sym_object] = ACTIONS(3176),
    [anon_sym_abstract] = ACTIONS(3176),
    [anon_sym_interface] = ACTIONS(3176),
    [anon_sym_enum] = ACTIONS(3176),
    [sym_html_comment] = ACTIONS(5),
  },
  [992] = {
    [sym_comment] = STATE(992),
    [sym_identifier] = ACTIONS(3178),
    [anon_sym_export] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_type] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_RBRACE] = ACTIONS(3178),
    [anon_sym_typeof] = ACTIONS(3178),
    [anon_sym_import] = ACTIONS(3178),
    [anon_sym_with] = ACTIONS(3178),
    [anon_sym_var] = ACTIONS(3178),
    [anon_sym_let] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_BANG] = ACTIONS(3178),
    [anon_sym_else] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_LPAREN] = ACTIONS(3178),
    [anon_sym_await] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_debugger] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_yield] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_LTtemplate_GT] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_SQUOTE] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_async] = ACTIONS(3178),
    [anon_sym_function] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_SLASH] = ACTIONS(3178),
    [anon_sym_LT] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3178),
    [anon_sym_void] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_PLUS_PLUS] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [sym_number] = ACTIONS(3178),
    [sym_private_property_identifier] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
    [sym_super] = ACTIONS(3178),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [sym_null] = ACTIONS(3178),
    [sym_undefined] = ACTIONS(3178),
    [anon_sym_AT] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_readonly] = ACTIONS(3178),
    [anon_sym_get] = ACTIONS(3178),
    [anon_sym_set] = ACTIONS(3178),
    [anon_sym_declare] = ACTIONS(3178),
    [anon_sym_public] = ACTIONS(3178),
    [anon_sym_private] = ACTIONS(3178),
    [anon_sym_protected] = ACTIONS(3178),
    [anon_sym_override] = ACTIONS(3178),
    [anon_sym_module] = ACTIONS(3178),
    [anon_sym_any] = ACTIONS(3178),
    [anon_sym_number] = ACTIONS(3178),
    [anon_sym_boolean] = ACTIONS(3178),
    [anon_sym_string] = ACTIONS(3178),
    [anon_sym_symbol] = ACTIONS(3178),
    [anon_sym_object] = ACTIONS(3178),
    [anon_sym_abstract] = ACTIONS(3178),
    [anon_sym_interface] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [sym_html_comment] = ACTIONS(5),
  },
  [993] = {
    [sym_comment] = STATE(993),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_export] = ACTIONS(3180),
    [anon_sym_default] = ACTIONS(3180),
    [anon_sym_type] = ACTIONS(3180),
    [anon_sym_namespace] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_RBRACE] = ACTIONS(3180),
    [anon_sym_typeof] = ACTIONS(3180),
    [anon_sym_import] = ACTIONS(3180),
    [anon_sym_with] = ACTIONS(3180),
    [anon_sym_var] = ACTIONS(3180),
    [anon_sym_let] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_else] = ACTIONS(3180),
    [anon_sym_if] = ACTIONS(3180),
    [anon_sym_switch] = ACTIONS(3180),
    [anon_sym_for] = ACTIONS(3180),
    [anon_sym_LPAREN] = ACTIONS(3180),
    [anon_sym_await] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3180),
    [anon_sym_do] = ACTIONS(3180),
    [anon_sym_try] = ACTIONS(3180),
    [anon_sym_break] = ACTIONS(3180),
    [anon_sym_continue] = ACTIONS(3180),
    [anon_sym_debugger] = ACTIONS(3180),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_throw] = ACTIONS(3180),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym_case] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3180),
    [anon_sym_LBRACK] = ACTIONS(3180),
    [anon_sym_LTtemplate_GT] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_class] = ACTIONS(3180),
    [anon_sym_async] = ACTIONS(3180),
    [anon_sym_function] = ACTIONS(3180),
    [anon_sym_new] = ACTIONS(3180),
    [anon_sym_using] = ACTIONS(3180),
    [anon_sym_PLUS] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3180),
    [anon_sym_SLASH] = ACTIONS(3180),
    [anon_sym_LT] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_void] = ACTIONS(3180),
    [anon_sym_delete] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3180),
    [sym_number] = ACTIONS(3180),
    [sym_private_property_identifier] = ACTIONS(3180),
    [sym_this] = ACTIONS(3180),
    [sym_super] = ACTIONS(3180),
    [sym_true] = ACTIONS(3180),
    [sym_false] = ACTIONS(3180),
    [sym_null] = ACTIONS(3180),
    [sym_undefined] = ACTIONS(3180),
    [anon_sym_AT] = ACTIONS(3180),
    [anon_sym_static] = ACTIONS(3180),
    [anon_sym_readonly] = ACTIONS(3180),
    [anon_sym_get] = ACTIONS(3180),
    [anon_sym_set] = ACTIONS(3180),
    [anon_sym_declare] = ACTIONS(3180),
    [anon_sym_public] = ACTIONS(3180),
    [anon_sym_private] = ACTIONS(3180),
    [anon_sym_protected] = ACTIONS(3180),
    [anon_sym_override] = ACTIONS(3180),
    [anon_sym_module] = ACTIONS(3180),
    [anon_sym_any] = ACTIONS(3180),
    [anon_sym_number] = ACTIONS(3180),
    [anon_sym_boolean] = ACTIONS(3180),
    [anon_sym_string] = ACTIONS(3180),
    [anon_sym_symbol] = ACTIONS(3180),
    [anon_sym_object] = ACTIONS(3180),
    [anon_sym_abstract] = ACTIONS(3180),
    [anon_sym_interface] = ACTIONS(3180),
    [anon_sym_enum] = ACTIONS(3180),
    [sym_html_comment] = ACTIONS(5),
  },
  [994] = {
    [sym_comment] = STATE(994),
    [sym_identifier] = ACTIONS(3182),
    [anon_sym_export] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_type] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_typeof] = ACTIONS(3182),
    [anon_sym_import] = ACTIONS(3182),
    [anon_sym_with] = ACTIONS(3182),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_await] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_debugger] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_LTtemplate_GT] = ACTIONS(3182),
    [anon_sym_DQUOTE] = ACTIONS(3182),
    [anon_sym_SQUOTE] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_async] = ACTIONS(3182),
    [anon_sym_function] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_SLASH] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_void] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3182),
    [sym_number] = ACTIONS(3182),
    [sym_private_property_identifier] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [sym_super] = ACTIONS(3182),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [sym_null] = ACTIONS(3182),
    [sym_undefined] = ACTIONS(3182),
    [anon_sym_AT] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_readonly] = ACTIONS(3182),
    [anon_sym_get] = ACTIONS(3182),
    [anon_sym_set] = ACTIONS(3182),
    [anon_sym_declare] = ACTIONS(3182),
    [anon_sym_public] = ACTIONS(3182),
    [anon_sym_private] = ACTIONS(3182),
    [anon_sym_protected] = ACTIONS(3182),
    [anon_sym_override] = ACTIONS(3182),
    [anon_sym_module] = ACTIONS(3182),
    [anon_sym_any] = ACTIONS(3182),
    [anon_sym_number] = ACTIONS(3182),
    [anon_sym_boolean] = ACTIONS(3182),
    [anon_sym_string] = ACTIONS(3182),
    [anon_sym_symbol] = ACTIONS(3182),
    [anon_sym_object] = ACTIONS(3182),
    [anon_sym_abstract] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [sym_html_comment] = ACTIONS(5),
  },
  [995] = {
    [sym_comment] = STATE(995),
    [ts_builtin_sym_end] = ACTIONS(2287),
    [sym_identifier] = ACTIONS(2137),
    [anon_sym_export] = ACTIONS(2137),
    [anon_sym_type] = ACTIONS(2137),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_typeof] = ACTIONS(2137),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_with] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2137),
    [anon_sym_let] = ACTIONS(2137),
    [anon_sym_const] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2137),
    [anon_sym_else] = ACTIONS(2137),
    [anon_sym_if] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2137),
    [anon_sym_for] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2137),
    [anon_sym_await] = ACTIONS(2137),
    [anon_sym_while] = ACTIONS(2137),
    [anon_sym_do] = ACTIONS(2137),
    [anon_sym_try] = ACTIONS(2137),
    [anon_sym_break] = ACTIONS(2137),
    [anon_sym_continue] = ACTIONS(2137),
    [anon_sym_debugger] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2137),
    [anon_sym_throw] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_LTtemplate_GT] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_SQUOTE] = ACTIONS(2137),
    [anon_sym_class] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(2137),
    [anon_sym_new] = ACTIONS(2137),
    [anon_sym_using] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(2137),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_TILDE] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2137),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [sym_number] = ACTIONS(2137),
    [sym_private_property_identifier] = ACTIONS(2137),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(2137),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(2137),
    [anon_sym_static] = ACTIONS(2137),
    [anon_sym_readonly] = ACTIONS(2137),
    [anon_sym_get] = ACTIONS(2137),
    [anon_sym_set] = ACTIONS(2137),
    [anon_sym_declare] = ACTIONS(2137),
    [anon_sym_public] = ACTIONS(2137),
    [anon_sym_private] = ACTIONS(2137),
    [anon_sym_protected] = ACTIONS(2137),
    [anon_sym_override] = ACTIONS(2137),
    [anon_sym_module] = ACTIONS(2137),
    [anon_sym_any] = ACTIONS(2137),
    [anon_sym_number] = ACTIONS(2137),
    [anon_sym_boolean] = ACTIONS(2137),
    [anon_sym_string] = ACTIONS(2137),
    [anon_sym_symbol] = ACTIONS(2137),
    [anon_sym_object] = ACTIONS(2137),
    [anon_sym_abstract] = ACTIONS(2137),
    [anon_sym_interface] = ACTIONS(2137),
    [anon_sym_enum] = ACTIONS(2137),
    [sym__automatic_semicolon] = ACTIONS(2289),
    [sym_html_comment] = ACTIONS(5),
  },
  [996] = {
    [sym_comment] = STATE(996),
    [sym_identifier] = ACTIONS(3184),
    [anon_sym_export] = ACTIONS(3184),
    [anon_sym_default] = ACTIONS(3184),
    [anon_sym_type] = ACTIONS(3184),
    [anon_sym_namespace] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_typeof] = ACTIONS(3184),
    [anon_sym_import] = ACTIONS(3184),
    [anon_sym_with] = ACTIONS(3184),
    [anon_sym_var] = ACTIONS(3184),
    [anon_sym_let] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_else] = ACTIONS(3184),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3184),
    [anon_sym_await] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_try] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_debugger] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_throw] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_case] = ACTIONS(3184),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3184),
    [anon_sym_LTtemplate_GT] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_class] = ACTIONS(3184),
    [anon_sym_async] = ACTIONS(3184),
    [anon_sym_function] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_using] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_SLASH] = ACTIONS(3184),
    [anon_sym_LT] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_void] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3184),
    [sym_number] = ACTIONS(3184),
    [sym_private_property_identifier] = ACTIONS(3184),
    [sym_this] = ACTIONS(3184),
    [sym_super] = ACTIONS(3184),
    [sym_true] = ACTIONS(3184),
    [sym_false] = ACTIONS(3184),
    [sym_null] = ACTIONS(3184),
    [sym_undefined] = ACTIONS(3184),
    [anon_sym_AT] = ACTIONS(3184),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_readonly] = ACTIONS(3184),
    [anon_sym_get] = ACTIONS(3184),
    [anon_sym_set] = ACTIONS(3184),
    [anon_sym_declare] = ACTIONS(3184),
    [anon_sym_public] = ACTIONS(3184),
    [anon_sym_private] = ACTIONS(3184),
    [anon_sym_protected] = ACTIONS(3184),
    [anon_sym_override] = ACTIONS(3184),
    [anon_sym_module] = ACTIONS(3184),
    [anon_sym_any] = ACTIONS(3184),
    [anon_sym_number] = ACTIONS(3184),
    [anon_sym_boolean] = ACTIONS(3184),
    [anon_sym_string] = ACTIONS(3184),
    [anon_sym_symbol] = ACTIONS(3184),
    [anon_sym_object] = ACTIONS(3184),
    [anon_sym_abstract] = ACTIONS(3184),
    [anon_sym_interface] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [sym_html_comment] = ACTIONS(5),
  },
  [997] = {
    [sym_comment] = STATE(997),
    [ts_builtin_sym_end] = ACTIONS(2313),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_else] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2129),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2129),
    [anon_sym_LTtemplate_GT] = ACTIONS(2129),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_using] = ACTIONS(2129),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_number] = ACTIONS(2129),
    [sym_private_property_identifier] = ACTIONS(2129),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_object] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
    [sym__automatic_semicolon] = ACTIONS(2315),
    [sym_html_comment] = ACTIONS(5),
  },
  [998] = {
    [sym_comment] = STATE(998),
    [ts_builtin_sym_end] = ACTIONS(3186),
    [sym_identifier] = ACTIONS(3094),
    [anon_sym_export] = ACTIONS(3094),
    [anon_sym_type] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3094),
    [anon_sym_typeof] = ACTIONS(3094),
    [anon_sym_import] = ACTIONS(3094),
    [anon_sym_with] = ACTIONS(3094),
    [anon_sym_var] = ACTIONS(3094),
    [anon_sym_let] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_else] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3094),
    [anon_sym_await] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_debugger] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym_finally] = ACTIONS(3094),
    [anon_sym_yield] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_LTtemplate_GT] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_async] = ACTIONS(3094),
    [anon_sym_function] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_void] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3094),
    [sym_number] = ACTIONS(3094),
    [sym_private_property_identifier] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
    [sym_super] = ACTIONS(3094),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_undefined] = ACTIONS(3094),
    [anon_sym_AT] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_readonly] = ACTIONS(3094),
    [anon_sym_get] = ACTIONS(3094),
    [anon_sym_set] = ACTIONS(3094),
    [anon_sym_declare] = ACTIONS(3094),
    [anon_sym_public] = ACTIONS(3094),
    [anon_sym_private] = ACTIONS(3094),
    [anon_sym_protected] = ACTIONS(3094),
    [anon_sym_override] = ACTIONS(3094),
    [anon_sym_module] = ACTIONS(3094),
    [anon_sym_any] = ACTIONS(3094),
    [anon_sym_number] = ACTIONS(3094),
    [anon_sym_boolean] = ACTIONS(3094),
    [anon_sym_string] = ACTIONS(3094),
    [anon_sym_symbol] = ACTIONS(3094),
    [anon_sym_object] = ACTIONS(3094),
    [anon_sym_abstract] = ACTIONS(3094),
    [anon_sym_interface] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [sym_html_comment] = ACTIONS(5),
  },
  [999] = {
    [sym_comment] = STATE(999),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_default] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_else] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_case] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1000] = {
    [sym_comment] = STATE(1000),
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_export] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_type] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3082),
    [anon_sym_RBRACE] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3082),
    [anon_sym_import] = ACTIONS(3082),
    [anon_sym_with] = ACTIONS(3082),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_BANG] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3082),
    [anon_sym_await] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_debugger] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_yield] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_LTtemplate_GT] = ACTIONS(3082),
    [anon_sym_DQUOTE] = ACTIONS(3082),
    [anon_sym_SQUOTE] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_async] = ACTIONS(3082),
    [anon_sym_function] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_TILDE] = ACTIONS(3082),
    [anon_sym_void] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3082),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3082),
    [sym_number] = ACTIONS(3082),
    [sym_private_property_identifier] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
    [sym_super] = ACTIONS(3082),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [sym_null] = ACTIONS(3082),
    [sym_undefined] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_readonly] = ACTIONS(3082),
    [anon_sym_get] = ACTIONS(3082),
    [anon_sym_set] = ACTIONS(3082),
    [anon_sym_declare] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_override] = ACTIONS(3082),
    [anon_sym_module] = ACTIONS(3082),
    [anon_sym_any] = ACTIONS(3082),
    [anon_sym_number] = ACTIONS(3082),
    [anon_sym_boolean] = ACTIONS(3082),
    [anon_sym_string] = ACTIONS(3082),
    [anon_sym_symbol] = ACTIONS(3082),
    [anon_sym_object] = ACTIONS(3082),
    [anon_sym_abstract] = ACTIONS(3082),
    [anon_sym_interface] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [sym__automatic_semicolon] = ACTIONS(3084),
    [sym_html_comment] = ACTIONS(5),
  },
  [1001] = {
    [sym_comment] = STATE(1001),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_default] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_else] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_case] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1002] = {
    [sym_comment] = STATE(1002),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_finally] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3190),
    [sym_html_comment] = ACTIONS(5),
  },
  [1003] = {
    [sym_comment] = STATE(1003),
    [sym_identifier] = ACTIONS(3192),
    [anon_sym_export] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_type] = ACTIONS(3192),
    [anon_sym_namespace] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3192),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_typeof] = ACTIONS(3192),
    [anon_sym_import] = ACTIONS(3192),
    [anon_sym_with] = ACTIONS(3192),
    [anon_sym_var] = ACTIONS(3192),
    [anon_sym_let] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3192),
    [anon_sym_else] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_await] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_debugger] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_throw] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_yield] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_LTtemplate_GT] = ACTIONS(3192),
    [anon_sym_DQUOTE] = ACTIONS(3192),
    [anon_sym_SQUOTE] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_async] = ACTIONS(3192),
    [anon_sym_function] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_SLASH] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3192),
    [anon_sym_void] = ACTIONS(3192),
    [anon_sym_delete] = ACTIONS(3192),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [sym_number] = ACTIONS(3192),
    [sym_private_property_identifier] = ACTIONS(3192),
    [sym_this] = ACTIONS(3192),
    [sym_super] = ACTIONS(3192),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [sym_null] = ACTIONS(3192),
    [sym_undefined] = ACTIONS(3192),
    [anon_sym_AT] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_readonly] = ACTIONS(3192),
    [anon_sym_get] = ACTIONS(3192),
    [anon_sym_set] = ACTIONS(3192),
    [anon_sym_declare] = ACTIONS(3192),
    [anon_sym_public] = ACTIONS(3192),
    [anon_sym_private] = ACTIONS(3192),
    [anon_sym_protected] = ACTIONS(3192),
    [anon_sym_override] = ACTIONS(3192),
    [anon_sym_module] = ACTIONS(3192),
    [anon_sym_any] = ACTIONS(3192),
    [anon_sym_number] = ACTIONS(3192),
    [anon_sym_boolean] = ACTIONS(3192),
    [anon_sym_string] = ACTIONS(3192),
    [anon_sym_symbol] = ACTIONS(3192),
    [anon_sym_object] = ACTIONS(3192),
    [anon_sym_abstract] = ACTIONS(3192),
    [anon_sym_interface] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [sym_html_comment] = ACTIONS(5),
  },
  [1004] = {
    [sym_comment] = STATE(1004),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_export] = ACTIONS(3116),
    [anon_sym_default] = ACTIONS(3116),
    [anon_sym_type] = ACTIONS(3116),
    [anon_sym_namespace] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_typeof] = ACTIONS(3116),
    [anon_sym_import] = ACTIONS(3116),
    [anon_sym_with] = ACTIONS(3116),
    [anon_sym_var] = ACTIONS(3116),
    [anon_sym_let] = ACTIONS(3116),
    [anon_sym_const] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3116),
    [anon_sym_if] = ACTIONS(3116),
    [anon_sym_switch] = ACTIONS(3116),
    [anon_sym_for] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3116),
    [anon_sym_await] = ACTIONS(3116),
    [anon_sym_while] = ACTIONS(3116),
    [anon_sym_do] = ACTIONS(3116),
    [anon_sym_try] = ACTIONS(3116),
    [anon_sym_break] = ACTIONS(3116),
    [anon_sym_continue] = ACTIONS(3116),
    [anon_sym_debugger] = ACTIONS(3116),
    [anon_sym_return] = ACTIONS(3116),
    [anon_sym_throw] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym_case] = ACTIONS(3116),
    [anon_sym_yield] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [anon_sym_LTtemplate_GT] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [anon_sym_SQUOTE] = ACTIONS(3116),
    [anon_sym_class] = ACTIONS(3116),
    [anon_sym_async] = ACTIONS(3116),
    [anon_sym_function] = ACTIONS(3116),
    [anon_sym_new] = ACTIONS(3116),
    [anon_sym_using] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3116),
    [anon_sym_SLASH] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3116),
    [anon_sym_TILDE] = ACTIONS(3116),
    [anon_sym_void] = ACTIONS(3116),
    [anon_sym_delete] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [sym_number] = ACTIONS(3116),
    [sym_private_property_identifier] = ACTIONS(3116),
    [sym_this] = ACTIONS(3116),
    [sym_super] = ACTIONS(3116),
    [sym_true] = ACTIONS(3116),
    [sym_false] = ACTIONS(3116),
    [sym_null] = ACTIONS(3116),
    [sym_undefined] = ACTIONS(3116),
    [anon_sym_AT] = ACTIONS(3116),
    [anon_sym_static] = ACTIONS(3116),
    [anon_sym_readonly] = ACTIONS(3116),
    [anon_sym_get] = ACTIONS(3116),
    [anon_sym_set] = ACTIONS(3116),
    [anon_sym_declare] = ACTIONS(3116),
    [anon_sym_public] = ACTIONS(3116),
    [anon_sym_private] = ACTIONS(3116),
    [anon_sym_protected] = ACTIONS(3116),
    [anon_sym_override] = ACTIONS(3116),
    [anon_sym_module] = ACTIONS(3116),
    [anon_sym_any] = ACTIONS(3116),
    [anon_sym_number] = ACTIONS(3116),
    [anon_sym_boolean] = ACTIONS(3116),
    [anon_sym_string] = ACTIONS(3116),
    [anon_sym_symbol] = ACTIONS(3116),
    [anon_sym_object] = ACTIONS(3116),
    [anon_sym_abstract] = ACTIONS(3116),
    [anon_sym_interface] = ACTIONS(3116),
    [anon_sym_enum] = ACTIONS(3116),
    [sym__automatic_semicolon] = ACTIONS(3118),
    [sym_html_comment] = ACTIONS(5),
  },
  [1005] = {
    [sym_comment] = STATE(1005),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_default] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_else] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_case] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1006] = {
    [sym_comment] = STATE(1006),
    [sym_identifier] = ACTIONS(3194),
    [anon_sym_export] = ACTIONS(3194),
    [anon_sym_default] = ACTIONS(3194),
    [anon_sym_type] = ACTIONS(3194),
    [anon_sym_namespace] = ACTIONS(3194),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3194),
    [anon_sym_typeof] = ACTIONS(3194),
    [anon_sym_import] = ACTIONS(3194),
    [anon_sym_with] = ACTIONS(3194),
    [anon_sym_var] = ACTIONS(3194),
    [anon_sym_let] = ACTIONS(3194),
    [anon_sym_const] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_else] = ACTIONS(3194),
    [anon_sym_if] = ACTIONS(3194),
    [anon_sym_switch] = ACTIONS(3194),
    [anon_sym_for] = ACTIONS(3194),
    [anon_sym_LPAREN] = ACTIONS(3194),
    [anon_sym_await] = ACTIONS(3194),
    [anon_sym_while] = ACTIONS(3194),
    [anon_sym_do] = ACTIONS(3194),
    [anon_sym_try] = ACTIONS(3194),
    [anon_sym_break] = ACTIONS(3194),
    [anon_sym_continue] = ACTIONS(3194),
    [anon_sym_debugger] = ACTIONS(3194),
    [anon_sym_return] = ACTIONS(3194),
    [anon_sym_throw] = ACTIONS(3194),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym_case] = ACTIONS(3194),
    [anon_sym_yield] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_LTtemplate_GT] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3194),
    [anon_sym_SQUOTE] = ACTIONS(3194),
    [anon_sym_class] = ACTIONS(3194),
    [anon_sym_async] = ACTIONS(3194),
    [anon_sym_function] = ACTIONS(3194),
    [anon_sym_new] = ACTIONS(3194),
    [anon_sym_using] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3194),
    [anon_sym_SLASH] = ACTIONS(3194),
    [anon_sym_LT] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_void] = ACTIONS(3194),
    [anon_sym_delete] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_number] = ACTIONS(3194),
    [sym_private_property_identifier] = ACTIONS(3194),
    [sym_this] = ACTIONS(3194),
    [sym_super] = ACTIONS(3194),
    [sym_true] = ACTIONS(3194),
    [sym_false] = ACTIONS(3194),
    [sym_null] = ACTIONS(3194),
    [sym_undefined] = ACTIONS(3194),
    [anon_sym_AT] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3194),
    [anon_sym_readonly] = ACTIONS(3194),
    [anon_sym_get] = ACTIONS(3194),
    [anon_sym_set] = ACTIONS(3194),
    [anon_sym_declare] = ACTIONS(3194),
    [anon_sym_public] = ACTIONS(3194),
    [anon_sym_private] = ACTIONS(3194),
    [anon_sym_protected] = ACTIONS(3194),
    [anon_sym_override] = ACTIONS(3194),
    [anon_sym_module] = ACTIONS(3194),
    [anon_sym_any] = ACTIONS(3194),
    [anon_sym_number] = ACTIONS(3194),
    [anon_sym_boolean] = ACTIONS(3194),
    [anon_sym_string] = ACTIONS(3194),
    [anon_sym_symbol] = ACTIONS(3194),
    [anon_sym_object] = ACTIONS(3194),
    [anon_sym_abstract] = ACTIONS(3194),
    [anon_sym_interface] = ACTIONS(3194),
    [anon_sym_enum] = ACTIONS(3194),
    [sym_html_comment] = ACTIONS(5),
  },
  [1007] = {
    [sym_comment] = STATE(1007),
    [ts_builtin_sym_end] = ACTIONS(2271),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_export] = ACTIONS(2103),
    [anon_sym_type] = ACTIONS(2103),
    [anon_sym_namespace] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_typeof] = ACTIONS(2103),
    [anon_sym_import] = ACTIONS(2103),
    [anon_sym_with] = ACTIONS(2103),
    [anon_sym_var] = ACTIONS(2103),
    [anon_sym_let] = ACTIONS(2103),
    [anon_sym_const] = ACTIONS(2103),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_else] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_switch] = ACTIONS(2103),
    [anon_sym_for] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_await] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_try] = ACTIONS(2103),
    [anon_sym_break] = ACTIONS(2103),
    [anon_sym_continue] = ACTIONS(2103),
    [anon_sym_debugger] = ACTIONS(2103),
    [anon_sym_return] = ACTIONS(2103),
    [anon_sym_throw] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_yield] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LTtemplate_GT] = ACTIONS(2103),
    [anon_sym_DQUOTE] = ACTIONS(2103),
    [anon_sym_SQUOTE] = ACTIONS(2103),
    [anon_sym_class] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(2103),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_using] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [anon_sym_void] = ACTIONS(2103),
    [anon_sym_delete] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2103),
    [sym_number] = ACTIONS(2103),
    [sym_private_property_identifier] = ACTIONS(2103),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_undefined] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2103),
    [anon_sym_static] = ACTIONS(2103),
    [anon_sym_readonly] = ACTIONS(2103),
    [anon_sym_get] = ACTIONS(2103),
    [anon_sym_set] = ACTIONS(2103),
    [anon_sym_declare] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2103),
    [anon_sym_private] = ACTIONS(2103),
    [anon_sym_protected] = ACTIONS(2103),
    [anon_sym_override] = ACTIONS(2103),
    [anon_sym_module] = ACTIONS(2103),
    [anon_sym_any] = ACTIONS(2103),
    [anon_sym_number] = ACTIONS(2103),
    [anon_sym_boolean] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_symbol] = ACTIONS(2103),
    [anon_sym_object] = ACTIONS(2103),
    [anon_sym_abstract] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2103),
    [anon_sym_enum] = ACTIONS(2103),
    [sym__automatic_semicolon] = ACTIONS(2273),
    [sym_html_comment] = ACTIONS(5),
  },
  [1008] = {
    [sym_comment] = STATE(1008),
    [sym_identifier] = ACTIONS(3196),
    [anon_sym_export] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_type] = ACTIONS(3196),
    [anon_sym_namespace] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3196),
    [anon_sym_RBRACE] = ACTIONS(3196),
    [anon_sym_typeof] = ACTIONS(3196),
    [anon_sym_import] = ACTIONS(3196),
    [anon_sym_with] = ACTIONS(3196),
    [anon_sym_var] = ACTIONS(3196),
    [anon_sym_let] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3196),
    [anon_sym_await] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_debugger] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_throw] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_LTtemplate_GT] = ACTIONS(3196),
    [anon_sym_DQUOTE] = ACTIONS(3196),
    [anon_sym_SQUOTE] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_async] = ACTIONS(3196),
    [anon_sym_function] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_using] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_SLASH] = ACTIONS(3196),
    [anon_sym_LT] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [anon_sym_void] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_PLUS_PLUS] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3196),
    [sym_number] = ACTIONS(3196),
    [sym_private_property_identifier] = ACTIONS(3196),
    [sym_this] = ACTIONS(3196),
    [sym_super] = ACTIONS(3196),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [sym_null] = ACTIONS(3196),
    [sym_undefined] = ACTIONS(3196),
    [anon_sym_AT] = ACTIONS(3196),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_readonly] = ACTIONS(3196),
    [anon_sym_get] = ACTIONS(3196),
    [anon_sym_set] = ACTIONS(3196),
    [anon_sym_declare] = ACTIONS(3196),
    [anon_sym_public] = ACTIONS(3196),
    [anon_sym_private] = ACTIONS(3196),
    [anon_sym_protected] = ACTIONS(3196),
    [anon_sym_override] = ACTIONS(3196),
    [anon_sym_module] = ACTIONS(3196),
    [anon_sym_any] = ACTIONS(3196),
    [anon_sym_number] = ACTIONS(3196),
    [anon_sym_boolean] = ACTIONS(3196),
    [anon_sym_string] = ACTIONS(3196),
    [anon_sym_symbol] = ACTIONS(3196),
    [anon_sym_object] = ACTIONS(3196),
    [anon_sym_abstract] = ACTIONS(3196),
    [anon_sym_interface] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [sym_html_comment] = ACTIONS(5),
  },
  [1009] = {
    [sym_comment] = STATE(1009),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1010] = {
    [sym_comment] = STATE(1010),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1011] = {
    [sym_comment] = STATE(1011),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1012] = {
    [sym_comment] = STATE(1012),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1013] = {
    [sym_comment] = STATE(1013),
    [ts_builtin_sym_end] = ACTIONS(3200),
    [sym_identifier] = ACTIONS(3100),
    [anon_sym_export] = ACTIONS(3100),
    [anon_sym_type] = ACTIONS(3100),
    [anon_sym_namespace] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_RBRACE] = ACTIONS(3100),
    [anon_sym_typeof] = ACTIONS(3100),
    [anon_sym_import] = ACTIONS(3100),
    [anon_sym_with] = ACTIONS(3100),
    [anon_sym_var] = ACTIONS(3100),
    [anon_sym_let] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3100),
    [anon_sym_else] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3100),
    [anon_sym_await] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_try] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_debugger] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_throw] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym_finally] = ACTIONS(3100),
    [anon_sym_yield] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3100),
    [anon_sym_LTtemplate_GT] = ACTIONS(3100),
    [anon_sym_DQUOTE] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_async] = ACTIONS(3100),
    [anon_sym_function] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_using] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_SLASH] = ACTIONS(3100),
    [anon_sym_LT] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_void] = ACTIONS(3100),
    [anon_sym_delete] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3100),
    [sym_number] = ACTIONS(3100),
    [sym_private_property_identifier] = ACTIONS(3100),
    [sym_this] = ACTIONS(3100),
    [sym_super] = ACTIONS(3100),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_null] = ACTIONS(3100),
    [sym_undefined] = ACTIONS(3100),
    [anon_sym_AT] = ACTIONS(3100),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_readonly] = ACTIONS(3100),
    [anon_sym_get] = ACTIONS(3100),
    [anon_sym_set] = ACTIONS(3100),
    [anon_sym_declare] = ACTIONS(3100),
    [anon_sym_public] = ACTIONS(3100),
    [anon_sym_private] = ACTIONS(3100),
    [anon_sym_protected] = ACTIONS(3100),
    [anon_sym_override] = ACTIONS(3100),
    [anon_sym_module] = ACTIONS(3100),
    [anon_sym_any] = ACTIONS(3100),
    [anon_sym_number] = ACTIONS(3100),
    [anon_sym_boolean] = ACTIONS(3100),
    [anon_sym_string] = ACTIONS(3100),
    [anon_sym_symbol] = ACTIONS(3100),
    [anon_sym_object] = ACTIONS(3100),
    [anon_sym_abstract] = ACTIONS(3100),
    [anon_sym_interface] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [sym_html_comment] = ACTIONS(5),
  },
  [1014] = {
    [sym_comment] = STATE(1014),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_export] = ACTIONS(3202),
    [anon_sym_default] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_namespace] = ACTIONS(3202),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_RBRACE] = ACTIONS(3202),
    [anon_sym_typeof] = ACTIONS(3202),
    [anon_sym_import] = ACTIONS(3202),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_var] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_const] = ACTIONS(3202),
    [anon_sym_BANG] = ACTIONS(3202),
    [anon_sym_else] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_switch] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_await] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_break] = ACTIONS(3202),
    [anon_sym_continue] = ACTIONS(3202),
    [anon_sym_debugger] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_throw] = ACTIONS(3202),
    [anon_sym_SEMI] = ACTIONS(3202),
    [anon_sym_case] = ACTIONS(3202),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LTtemplate_GT] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_class] = ACTIONS(3202),
    [anon_sym_async] = ACTIONS(3202),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_using] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(3202),
    [anon_sym_LT] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3202),
    [anon_sym_void] = ACTIONS(3202),
    [anon_sym_delete] = ACTIONS(3202),
    [anon_sym_PLUS_PLUS] = ACTIONS(3202),
    [anon_sym_DASH_DASH] = ACTIONS(3202),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3202),
    [sym_number] = ACTIONS(3202),
    [sym_private_property_identifier] = ACTIONS(3202),
    [sym_this] = ACTIONS(3202),
    [sym_super] = ACTIONS(3202),
    [sym_true] = ACTIONS(3202),
    [sym_false] = ACTIONS(3202),
    [sym_null] = ACTIONS(3202),
    [sym_undefined] = ACTIONS(3202),
    [anon_sym_AT] = ACTIONS(3202),
    [anon_sym_static] = ACTIONS(3202),
    [anon_sym_readonly] = ACTIONS(3202),
    [anon_sym_get] = ACTIONS(3202),
    [anon_sym_set] = ACTIONS(3202),
    [anon_sym_declare] = ACTIONS(3202),
    [anon_sym_public] = ACTIONS(3202),
    [anon_sym_private] = ACTIONS(3202),
    [anon_sym_protected] = ACTIONS(3202),
    [anon_sym_override] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_any] = ACTIONS(3202),
    [anon_sym_number] = ACTIONS(3202),
    [anon_sym_boolean] = ACTIONS(3202),
    [anon_sym_string] = ACTIONS(3202),
    [anon_sym_symbol] = ACTIONS(3202),
    [anon_sym_object] = ACTIONS(3202),
    [anon_sym_abstract] = ACTIONS(3202),
    [anon_sym_interface] = ACTIONS(3202),
    [anon_sym_enum] = ACTIONS(3202),
    [sym_html_comment] = ACTIONS(5),
  },
  [1015] = {
    [sym_comment] = STATE(1015),
    [sym_identifier] = ACTIONS(3204),
    [anon_sym_export] = ACTIONS(3204),
    [anon_sym_default] = ACTIONS(3204),
    [anon_sym_type] = ACTIONS(3204),
    [anon_sym_namespace] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_typeof] = ACTIONS(3204),
    [anon_sym_import] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3204),
    [anon_sym_var] = ACTIONS(3204),
    [anon_sym_let] = ACTIONS(3204),
    [anon_sym_const] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_switch] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3204),
    [anon_sym_await] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3204),
    [anon_sym_break] = ACTIONS(3204),
    [anon_sym_continue] = ACTIONS(3204),
    [anon_sym_debugger] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3204),
    [anon_sym_throw] = ACTIONS(3204),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_case] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_LTtemplate_GT] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [anon_sym_SQUOTE] = ACTIONS(3204),
    [anon_sym_class] = ACTIONS(3204),
    [anon_sym_async] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3204),
    [anon_sym_using] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3204),
    [anon_sym_DASH] = ACTIONS(3204),
    [anon_sym_SLASH] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [anon_sym_void] = ACTIONS(3204),
    [anon_sym_delete] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3204),
    [anon_sym_DASH_DASH] = ACTIONS(3204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3204),
    [sym_number] = ACTIONS(3204),
    [sym_private_property_identifier] = ACTIONS(3204),
    [sym_this] = ACTIONS(3204),
    [sym_super] = ACTIONS(3204),
    [sym_true] = ACTIONS(3204),
    [sym_false] = ACTIONS(3204),
    [sym_null] = ACTIONS(3204),
    [sym_undefined] = ACTIONS(3204),
    [anon_sym_AT] = ACTIONS(3204),
    [anon_sym_static] = ACTIONS(3204),
    [anon_sym_readonly] = ACTIONS(3204),
    [anon_sym_get] = ACTIONS(3204),
    [anon_sym_set] = ACTIONS(3204),
    [anon_sym_declare] = ACTIONS(3204),
    [anon_sym_public] = ACTIONS(3204),
    [anon_sym_private] = ACTIONS(3204),
    [anon_sym_protected] = ACTIONS(3204),
    [anon_sym_override] = ACTIONS(3204),
    [anon_sym_module] = ACTIONS(3204),
    [anon_sym_any] = ACTIONS(3204),
    [anon_sym_number] = ACTIONS(3204),
    [anon_sym_boolean] = ACTIONS(3204),
    [anon_sym_string] = ACTIONS(3204),
    [anon_sym_symbol] = ACTIONS(3204),
    [anon_sym_object] = ACTIONS(3204),
    [anon_sym_abstract] = ACTIONS(3204),
    [anon_sym_interface] = ACTIONS(3204),
    [anon_sym_enum] = ACTIONS(3204),
    [sym_html_comment] = ACTIONS(5),
  },
  [1016] = {
    [sym_else_clause] = STATE(1310),
    [sym_comment] = STATE(1016),
    [ts_builtin_sym_end] = ACTIONS(3206),
    [sym_identifier] = ACTIONS(3070),
    [anon_sym_export] = ACTIONS(3070),
    [anon_sym_type] = ACTIONS(3070),
    [anon_sym_namespace] = ACTIONS(3070),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_typeof] = ACTIONS(3070),
    [anon_sym_import] = ACTIONS(3070),
    [anon_sym_with] = ACTIONS(3070),
    [anon_sym_var] = ACTIONS(3070),
    [anon_sym_let] = ACTIONS(3070),
    [anon_sym_const] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_else] = ACTIONS(3208),
    [anon_sym_if] = ACTIONS(3070),
    [anon_sym_switch] = ACTIONS(3070),
    [anon_sym_for] = ACTIONS(3070),
    [anon_sym_LPAREN] = ACTIONS(3070),
    [anon_sym_await] = ACTIONS(3070),
    [anon_sym_while] = ACTIONS(3070),
    [anon_sym_do] = ACTIONS(3070),
    [anon_sym_try] = ACTIONS(3070),
    [anon_sym_break] = ACTIONS(3070),
    [anon_sym_continue] = ACTIONS(3070),
    [anon_sym_debugger] = ACTIONS(3070),
    [anon_sym_return] = ACTIONS(3070),
    [anon_sym_throw] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym_yield] = ACTIONS(3070),
    [anon_sym_LBRACK] = ACTIONS(3070),
    [anon_sym_LTtemplate_GT] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_class] = ACTIONS(3070),
    [anon_sym_async] = ACTIONS(3070),
    [anon_sym_function] = ACTIONS(3070),
    [anon_sym_new] = ACTIONS(3070),
    [anon_sym_using] = ACTIONS(3070),
    [anon_sym_PLUS] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3070),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_LT] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_void] = ACTIONS(3070),
    [anon_sym_delete] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3070),
    [sym_number] = ACTIONS(3070),
    [sym_private_property_identifier] = ACTIONS(3070),
    [sym_this] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_true] = ACTIONS(3070),
    [sym_false] = ACTIONS(3070),
    [sym_null] = ACTIONS(3070),
    [sym_undefined] = ACTIONS(3070),
    [anon_sym_AT] = ACTIONS(3070),
    [anon_sym_static] = ACTIONS(3070),
    [anon_sym_readonly] = ACTIONS(3070),
    [anon_sym_get] = ACTIONS(3070),
    [anon_sym_set] = ACTIONS(3070),
    [anon_sym_declare] = ACTIONS(3070),
    [anon_sym_public] = ACTIONS(3070),
    [anon_sym_private] = ACTIONS(3070),
    [anon_sym_protected] = ACTIONS(3070),
    [anon_sym_override] = ACTIONS(3070),
    [anon_sym_module] = ACTIONS(3070),
    [anon_sym_any] = ACTIONS(3070),
    [anon_sym_number] = ACTIONS(3070),
    [anon_sym_boolean] = ACTIONS(3070),
    [anon_sym_string] = ACTIONS(3070),
    [anon_sym_symbol] = ACTIONS(3070),
    [anon_sym_object] = ACTIONS(3070),
    [anon_sym_abstract] = ACTIONS(3070),
    [anon_sym_interface] = ACTIONS(3070),
    [anon_sym_enum] = ACTIONS(3070),
    [sym_html_comment] = ACTIONS(5),
  },
  [1017] = {
    [sym_comment] = STATE(1017),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1018] = {
    [sym_comment] = STATE(1018),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1019] = {
    [sym_comment] = STATE(1019),
    [ts_builtin_sym_end] = ACTIONS(2147),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym__automatic_semicolon] = ACTIONS(2147),
    [sym_html_comment] = ACTIONS(5),
  },
  [1020] = {
    [sym_comment] = STATE(1020),
    [sym_identifier] = ACTIONS(2255),
    [anon_sym_export] = ACTIONS(2255),
    [anon_sym_default] = ACTIONS(2255),
    [anon_sym_type] = ACTIONS(2255),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2255),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_typeof] = ACTIONS(2255),
    [anon_sym_import] = ACTIONS(2255),
    [anon_sym_with] = ACTIONS(2255),
    [anon_sym_var] = ACTIONS(2255),
    [anon_sym_let] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_await] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_debugger] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2255),
    [anon_sym_case] = ACTIONS(2255),
    [anon_sym_yield] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_LTtemplate_GT] = ACTIONS(2255),
    [anon_sym_DQUOTE] = ACTIONS(2255),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_async] = ACTIONS(2255),
    [anon_sym_function] = ACTIONS(2255),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_TILDE] = ACTIONS(2255),
    [anon_sym_void] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [sym_number] = ACTIONS(2255),
    [sym_private_property_identifier] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [sym_super] = ACTIONS(2255),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [sym_null] = ACTIONS(2255),
    [sym_undefined] = ACTIONS(2255),
    [anon_sym_AT] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_readonly] = ACTIONS(2255),
    [anon_sym_get] = ACTIONS(2255),
    [anon_sym_set] = ACTIONS(2255),
    [anon_sym_declare] = ACTIONS(2255),
    [anon_sym_public] = ACTIONS(2255),
    [anon_sym_private] = ACTIONS(2255),
    [anon_sym_protected] = ACTIONS(2255),
    [anon_sym_override] = ACTIONS(2255),
    [anon_sym_module] = ACTIONS(2255),
    [anon_sym_any] = ACTIONS(2255),
    [anon_sym_number] = ACTIONS(2255),
    [anon_sym_boolean] = ACTIONS(2255),
    [anon_sym_string] = ACTIONS(2255),
    [anon_sym_symbol] = ACTIONS(2255),
    [anon_sym_object] = ACTIONS(2255),
    [anon_sym_abstract] = ACTIONS(2255),
    [anon_sym_interface] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [sym__automatic_semicolon] = ACTIONS(2333),
    [sym_html_comment] = ACTIONS(5),
  },
  [1021] = {
    [sym_comment] = STATE(1021),
    [ts_builtin_sym_end] = ACTIONS(2239),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_export] = ACTIONS(2237),
    [anon_sym_type] = ACTIONS(2237),
    [anon_sym_namespace] = ACTIONS(2237),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_typeof] = ACTIONS(2237),
    [anon_sym_import] = ACTIONS(2237),
    [anon_sym_with] = ACTIONS(2237),
    [anon_sym_var] = ACTIONS(2237),
    [anon_sym_let] = ACTIONS(2237),
    [anon_sym_const] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_else] = ACTIONS(2237),
    [anon_sym_if] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_for] = ACTIONS(2237),
    [anon_sym_LPAREN] = ACTIONS(2237),
    [anon_sym_await] = ACTIONS(2237),
    [anon_sym_while] = ACTIONS(2237),
    [anon_sym_do] = ACTIONS(2237),
    [anon_sym_try] = ACTIONS(2237),
    [anon_sym_break] = ACTIONS(2237),
    [anon_sym_continue] = ACTIONS(2237),
    [anon_sym_debugger] = ACTIONS(2237),
    [anon_sym_return] = ACTIONS(2237),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2237),
    [anon_sym_yield] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2237),
    [anon_sym_LTtemplate_GT] = ACTIONS(2237),
    [anon_sym_DOT] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_class] = ACTIONS(2237),
    [anon_sym_async] = ACTIONS(2237),
    [anon_sym_function] = ACTIONS(2237),
    [anon_sym_new] = ACTIONS(2237),
    [anon_sym_using] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_SLASH] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_void] = ACTIONS(2237),
    [anon_sym_delete] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2237),
    [sym_number] = ACTIONS(2237),
    [sym_private_property_identifier] = ACTIONS(2237),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2237),
    [anon_sym_static] = ACTIONS(2237),
    [anon_sym_readonly] = ACTIONS(2237),
    [anon_sym_get] = ACTIONS(2237),
    [anon_sym_set] = ACTIONS(2237),
    [anon_sym_declare] = ACTIONS(2237),
    [anon_sym_public] = ACTIONS(2237),
    [anon_sym_private] = ACTIONS(2237),
    [anon_sym_protected] = ACTIONS(2237),
    [anon_sym_override] = ACTIONS(2237),
    [anon_sym_module] = ACTIONS(2237),
    [anon_sym_any] = ACTIONS(2237),
    [anon_sym_number] = ACTIONS(2237),
    [anon_sym_boolean] = ACTIONS(2237),
    [anon_sym_string] = ACTIONS(2237),
    [anon_sym_symbol] = ACTIONS(2237),
    [anon_sym_object] = ACTIONS(2237),
    [anon_sym_abstract] = ACTIONS(2237),
    [anon_sym_interface] = ACTIONS(2237),
    [anon_sym_enum] = ACTIONS(2237),
    [sym_html_comment] = ACTIONS(5),
  },
  [1022] = {
    [sym_comment] = STATE(1022),
    [sym_identifier] = ACTIONS(3210),
    [anon_sym_export] = ACTIONS(3210),
    [anon_sym_default] = ACTIONS(3210),
    [anon_sym_type] = ACTIONS(3210),
    [anon_sym_namespace] = ACTIONS(3210),
    [anon_sym_LBRACE] = ACTIONS(3210),
    [anon_sym_RBRACE] = ACTIONS(3210),
    [anon_sym_typeof] = ACTIONS(3210),
    [anon_sym_import] = ACTIONS(3210),
    [anon_sym_with] = ACTIONS(3210),
    [anon_sym_var] = ACTIONS(3210),
    [anon_sym_let] = ACTIONS(3210),
    [anon_sym_const] = ACTIONS(3210),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_else] = ACTIONS(3210),
    [anon_sym_if] = ACTIONS(3210),
    [anon_sym_switch] = ACTIONS(3210),
    [anon_sym_for] = ACTIONS(3210),
    [anon_sym_LPAREN] = ACTIONS(3210),
    [anon_sym_await] = ACTIONS(3210),
    [anon_sym_while] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3210),
    [anon_sym_try] = ACTIONS(3210),
    [anon_sym_break] = ACTIONS(3210),
    [anon_sym_continue] = ACTIONS(3210),
    [anon_sym_debugger] = ACTIONS(3210),
    [anon_sym_return] = ACTIONS(3210),
    [anon_sym_throw] = ACTIONS(3210),
    [anon_sym_SEMI] = ACTIONS(3210),
    [anon_sym_case] = ACTIONS(3210),
    [anon_sym_yield] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_LTtemplate_GT] = ACTIONS(3210),
    [anon_sym_DQUOTE] = ACTIONS(3210),
    [anon_sym_SQUOTE] = ACTIONS(3210),
    [anon_sym_class] = ACTIONS(3210),
    [anon_sym_async] = ACTIONS(3210),
    [anon_sym_function] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3210),
    [anon_sym_using] = ACTIONS(3210),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_SLASH] = ACTIONS(3210),
    [anon_sym_LT] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3210),
    [anon_sym_void] = ACTIONS(3210),
    [anon_sym_delete] = ACTIONS(3210),
    [anon_sym_PLUS_PLUS] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3210),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3210),
    [sym_number] = ACTIONS(3210),
    [sym_private_property_identifier] = ACTIONS(3210),
    [sym_this] = ACTIONS(3210),
    [sym_super] = ACTIONS(3210),
    [sym_true] = ACTIONS(3210),
    [sym_false] = ACTIONS(3210),
    [sym_null] = ACTIONS(3210),
    [sym_undefined] = ACTIONS(3210),
    [anon_sym_AT] = ACTIONS(3210),
    [anon_sym_static] = ACTIONS(3210),
    [anon_sym_readonly] = ACTIONS(3210),
    [anon_sym_get] = ACTIONS(3210),
    [anon_sym_set] = ACTIONS(3210),
    [anon_sym_declare] = ACTIONS(3210),
    [anon_sym_public] = ACTIONS(3210),
    [anon_sym_private] = ACTIONS(3210),
    [anon_sym_protected] = ACTIONS(3210),
    [anon_sym_override] = ACTIONS(3210),
    [anon_sym_module] = ACTIONS(3210),
    [anon_sym_any] = ACTIONS(3210),
    [anon_sym_number] = ACTIONS(3210),
    [anon_sym_boolean] = ACTIONS(3210),
    [anon_sym_string] = ACTIONS(3210),
    [anon_sym_symbol] = ACTIONS(3210),
    [anon_sym_object] = ACTIONS(3210),
    [anon_sym_abstract] = ACTIONS(3210),
    [anon_sym_interface] = ACTIONS(3210),
    [anon_sym_enum] = ACTIONS(3210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1023] = {
    [sym_comment] = STATE(1023),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_default] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_case] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_LTtemplate_GT] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2083),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_using] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2083),
    [sym_number] = ACTIONS(2083),
    [sym_private_property_identifier] = ACTIONS(2083),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2083),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_readonly] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_override] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_object] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [sym__automatic_semicolon] = ACTIONS(2311),
    [sym_html_comment] = ACTIONS(5),
  },
  [1024] = {
    [sym_comment] = STATE(1024),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [sym_identifier] = ACTIONS(2233),
    [anon_sym_export] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(2233),
    [anon_sym_namespace] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [anon_sym_typeof] = ACTIONS(2233),
    [anon_sym_import] = ACTIONS(2233),
    [anon_sym_with] = ACTIONS(2233),
    [anon_sym_var] = ACTIONS(2233),
    [anon_sym_let] = ACTIONS(2233),
    [anon_sym_const] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_else] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_for] = ACTIONS(2233),
    [anon_sym_LPAREN] = ACTIONS(2233),
    [anon_sym_await] = ACTIONS(2233),
    [anon_sym_while] = ACTIONS(2233),
    [anon_sym_do] = ACTIONS(2233),
    [anon_sym_try] = ACTIONS(2233),
    [anon_sym_break] = ACTIONS(2233),
    [anon_sym_continue] = ACTIONS(2233),
    [anon_sym_debugger] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2233),
    [anon_sym_throw] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym_yield] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2233),
    [anon_sym_LTtemplate_GT] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_class] = ACTIONS(2233),
    [anon_sym_async] = ACTIONS(2233),
    [anon_sym_function] = ACTIONS(2233),
    [anon_sym_new] = ACTIONS(2233),
    [anon_sym_using] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_void] = ACTIONS(2233),
    [anon_sym_delete] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2233),
    [sym_number] = ACTIONS(2233),
    [sym_private_property_identifier] = ACTIONS(2233),
    [sym_this] = ACTIONS(2233),
    [sym_super] = ACTIONS(2233),
    [sym_true] = ACTIONS(2233),
    [sym_false] = ACTIONS(2233),
    [sym_null] = ACTIONS(2233),
    [sym_undefined] = ACTIONS(2233),
    [anon_sym_AT] = ACTIONS(2233),
    [anon_sym_static] = ACTIONS(2233),
    [anon_sym_readonly] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2233),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_declare] = ACTIONS(2233),
    [anon_sym_public] = ACTIONS(2233),
    [anon_sym_private] = ACTIONS(2233),
    [anon_sym_protected] = ACTIONS(2233),
    [anon_sym_override] = ACTIONS(2233),
    [anon_sym_module] = ACTIONS(2233),
    [anon_sym_any] = ACTIONS(2233),
    [anon_sym_number] = ACTIONS(2233),
    [anon_sym_boolean] = ACTIONS(2233),
    [anon_sym_string] = ACTIONS(2233),
    [anon_sym_symbol] = ACTIONS(2233),
    [anon_sym_object] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2233),
    [anon_sym_interface] = ACTIONS(2233),
    [anon_sym_enum] = ACTIONS(2233),
    [sym_html_comment] = ACTIONS(5),
  },
  [1025] = {
    [sym_comment] = STATE(1025),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_export] = ACTIONS(3212),
    [anon_sym_default] = ACTIONS(3212),
    [anon_sym_type] = ACTIONS(3212),
    [anon_sym_namespace] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_RBRACE] = ACTIONS(3212),
    [anon_sym_typeof] = ACTIONS(3212),
    [anon_sym_import] = ACTIONS(3212),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_var] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_const] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_else] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_switch] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_await] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_break] = ACTIONS(3212),
    [anon_sym_continue] = ACTIONS(3212),
    [anon_sym_debugger] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_throw] = ACTIONS(3212),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym_case] = ACTIONS(3212),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LTtemplate_GT] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_class] = ACTIONS(3212),
    [anon_sym_async] = ACTIONS(3212),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_using] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_LT] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_void] = ACTIONS(3212),
    [anon_sym_delete] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3212),
    [sym_number] = ACTIONS(3212),
    [sym_private_property_identifier] = ACTIONS(3212),
    [sym_this] = ACTIONS(3212),
    [sym_super] = ACTIONS(3212),
    [sym_true] = ACTIONS(3212),
    [sym_false] = ACTIONS(3212),
    [sym_null] = ACTIONS(3212),
    [sym_undefined] = ACTIONS(3212),
    [anon_sym_AT] = ACTIONS(3212),
    [anon_sym_static] = ACTIONS(3212),
    [anon_sym_readonly] = ACTIONS(3212),
    [anon_sym_get] = ACTIONS(3212),
    [anon_sym_set] = ACTIONS(3212),
    [anon_sym_declare] = ACTIONS(3212),
    [anon_sym_public] = ACTIONS(3212),
    [anon_sym_private] = ACTIONS(3212),
    [anon_sym_protected] = ACTIONS(3212),
    [anon_sym_override] = ACTIONS(3212),
    [anon_sym_module] = ACTIONS(3212),
    [anon_sym_any] = ACTIONS(3212),
    [anon_sym_number] = ACTIONS(3212),
    [anon_sym_boolean] = ACTIONS(3212),
    [anon_sym_string] = ACTIONS(3212),
    [anon_sym_symbol] = ACTIONS(3212),
    [anon_sym_object] = ACTIONS(3212),
    [anon_sym_abstract] = ACTIONS(3212),
    [anon_sym_interface] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3212),
    [sym_html_comment] = ACTIONS(5),
  },
  [1026] = {
    [sym_comment] = STATE(1026),
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_export] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3214),
    [anon_sym_type] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3214),
    [anon_sym_RBRACE] = ACTIONS(3214),
    [anon_sym_typeof] = ACTIONS(3214),
    [anon_sym_import] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3214),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_BANG] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3214),
    [anon_sym_await] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_debugger] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3214),
    [anon_sym_case] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_LTtemplate_GT] = ACTIONS(3214),
    [anon_sym_DQUOTE] = ACTIONS(3214),
    [anon_sym_SQUOTE] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_SLASH] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3214),
    [anon_sym_void] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_PLUS_PLUS] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3214),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3214),
    [sym_number] = ACTIONS(3214),
    [sym_private_property_identifier] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [sym_super] = ACTIONS(3214),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [sym_null] = ACTIONS(3214),
    [sym_undefined] = ACTIONS(3214),
    [anon_sym_AT] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_readonly] = ACTIONS(3214),
    [anon_sym_get] = ACTIONS(3214),
    [anon_sym_set] = ACTIONS(3214),
    [anon_sym_declare] = ACTIONS(3214),
    [anon_sym_public] = ACTIONS(3214),
    [anon_sym_private] = ACTIONS(3214),
    [anon_sym_protected] = ACTIONS(3214),
    [anon_sym_override] = ACTIONS(3214),
    [anon_sym_module] = ACTIONS(3214),
    [anon_sym_any] = ACTIONS(3214),
    [anon_sym_number] = ACTIONS(3214),
    [anon_sym_boolean] = ACTIONS(3214),
    [anon_sym_string] = ACTIONS(3214),
    [anon_sym_symbol] = ACTIONS(3214),
    [anon_sym_object] = ACTIONS(3214),
    [anon_sym_abstract] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [sym_html_comment] = ACTIONS(5),
  },
  [1027] = {
    [sym_comment] = STATE(1027),
    [sym_identifier] = ACTIONS(3216),
    [anon_sym_export] = ACTIONS(3216),
    [anon_sym_default] = ACTIONS(3216),
    [anon_sym_type] = ACTIONS(3216),
    [anon_sym_namespace] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_typeof] = ACTIONS(3216),
    [anon_sym_import] = ACTIONS(3216),
    [anon_sym_with] = ACTIONS(3216),
    [anon_sym_var] = ACTIONS(3216),
    [anon_sym_let] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_else] = ACTIONS(3216),
    [anon_sym_if] = ACTIONS(3216),
    [anon_sym_switch] = ACTIONS(3216),
    [anon_sym_for] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [anon_sym_await] = ACTIONS(3216),
    [anon_sym_while] = ACTIONS(3216),
    [anon_sym_do] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(3216),
    [anon_sym_break] = ACTIONS(3216),
    [anon_sym_continue] = ACTIONS(3216),
    [anon_sym_debugger] = ACTIONS(3216),
    [anon_sym_return] = ACTIONS(3216),
    [anon_sym_throw] = ACTIONS(3216),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym_case] = ACTIONS(3216),
    [anon_sym_yield] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [anon_sym_LTtemplate_GT] = ACTIONS(3216),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_async] = ACTIONS(3216),
    [anon_sym_function] = ACTIONS(3216),
    [anon_sym_new] = ACTIONS(3216),
    [anon_sym_using] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_SLASH] = ACTIONS(3216),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_void] = ACTIONS(3216),
    [anon_sym_delete] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3216),
    [sym_number] = ACTIONS(3216),
    [sym_private_property_identifier] = ACTIONS(3216),
    [sym_this] = ACTIONS(3216),
    [sym_super] = ACTIONS(3216),
    [sym_true] = ACTIONS(3216),
    [sym_false] = ACTIONS(3216),
    [sym_null] = ACTIONS(3216),
    [sym_undefined] = ACTIONS(3216),
    [anon_sym_AT] = ACTIONS(3216),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_readonly] = ACTIONS(3216),
    [anon_sym_get] = ACTIONS(3216),
    [anon_sym_set] = ACTIONS(3216),
    [anon_sym_declare] = ACTIONS(3216),
    [anon_sym_public] = ACTIONS(3216),
    [anon_sym_private] = ACTIONS(3216),
    [anon_sym_protected] = ACTIONS(3216),
    [anon_sym_override] = ACTIONS(3216),
    [anon_sym_module] = ACTIONS(3216),
    [anon_sym_any] = ACTIONS(3216),
    [anon_sym_number] = ACTIONS(3216),
    [anon_sym_boolean] = ACTIONS(3216),
    [anon_sym_string] = ACTIONS(3216),
    [anon_sym_symbol] = ACTIONS(3216),
    [anon_sym_object] = ACTIONS(3216),
    [anon_sym_abstract] = ACTIONS(3216),
    [anon_sym_interface] = ACTIONS(3216),
    [anon_sym_enum] = ACTIONS(3216),
    [sym_html_comment] = ACTIONS(5),
  },
  [1028] = {
    [sym_comment] = STATE(1028),
    [ts_builtin_sym_end] = ACTIONS(2127),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym__automatic_semicolon] = ACTIONS(2127),
    [sym_html_comment] = ACTIONS(5),
  },
  [1029] = {
    [sym_comment] = STATE(1029),
    [sym_identifier] = ACTIONS(3218),
    [anon_sym_export] = ACTIONS(3218),
    [anon_sym_default] = ACTIONS(3218),
    [anon_sym_type] = ACTIONS(3218),
    [anon_sym_namespace] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_RBRACE] = ACTIONS(3218),
    [anon_sym_typeof] = ACTIONS(3218),
    [anon_sym_import] = ACTIONS(3218),
    [anon_sym_with] = ACTIONS(3218),
    [anon_sym_var] = ACTIONS(3218),
    [anon_sym_let] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3218),
    [anon_sym_BANG] = ACTIONS(3218),
    [anon_sym_else] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_switch] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_LPAREN] = ACTIONS(3218),
    [anon_sym_await] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_debugger] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_throw] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_case] = ACTIONS(3218),
    [anon_sym_yield] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_LTtemplate_GT] = ACTIONS(3218),
    [anon_sym_DQUOTE] = ACTIONS(3218),
    [anon_sym_SQUOTE] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_async] = ACTIONS(3218),
    [anon_sym_function] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_using] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_SLASH] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3218),
    [anon_sym_TILDE] = ACTIONS(3218),
    [anon_sym_void] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3218),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3218),
    [sym_number] = ACTIONS(3218),
    [sym_private_property_identifier] = ACTIONS(3218),
    [sym_this] = ACTIONS(3218),
    [sym_super] = ACTIONS(3218),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [sym_null] = ACTIONS(3218),
    [sym_undefined] = ACTIONS(3218),
    [anon_sym_AT] = ACTIONS(3218),
    [anon_sym_static] = ACTIONS(3218),
    [anon_sym_readonly] = ACTIONS(3218),
    [anon_sym_get] = ACTIONS(3218),
    [anon_sym_set] = ACTIONS(3218),
    [anon_sym_declare] = ACTIONS(3218),
    [anon_sym_public] = ACTIONS(3218),
    [anon_sym_private] = ACTIONS(3218),
    [anon_sym_protected] = ACTIONS(3218),
    [anon_sym_override] = ACTIONS(3218),
    [anon_sym_module] = ACTIONS(3218),
    [anon_sym_any] = ACTIONS(3218),
    [anon_sym_number] = ACTIONS(3218),
    [anon_sym_boolean] = ACTIONS(3218),
    [anon_sym_string] = ACTIONS(3218),
    [anon_sym_symbol] = ACTIONS(3218),
    [anon_sym_object] = ACTIONS(3218),
    [anon_sym_abstract] = ACTIONS(3218),
    [anon_sym_interface] = ACTIONS(3218),
    [anon_sym_enum] = ACTIONS(3218),
    [sym_html_comment] = ACTIONS(5),
  },
  [1030] = {
    [sym_comment] = STATE(1030),
    [sym_identifier] = ACTIONS(3220),
    [anon_sym_export] = ACTIONS(3220),
    [anon_sym_default] = ACTIONS(3220),
    [anon_sym_type] = ACTIONS(3220),
    [anon_sym_namespace] = ACTIONS(3220),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_RBRACE] = ACTIONS(3220),
    [anon_sym_typeof] = ACTIONS(3220),
    [anon_sym_import] = ACTIONS(3220),
    [anon_sym_with] = ACTIONS(3220),
    [anon_sym_var] = ACTIONS(3220),
    [anon_sym_let] = ACTIONS(3220),
    [anon_sym_const] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_else] = ACTIONS(3220),
    [anon_sym_if] = ACTIONS(3220),
    [anon_sym_switch] = ACTIONS(3220),
    [anon_sym_for] = ACTIONS(3220),
    [anon_sym_LPAREN] = ACTIONS(3220),
    [anon_sym_await] = ACTIONS(3220),
    [anon_sym_while] = ACTIONS(3220),
    [anon_sym_do] = ACTIONS(3220),
    [anon_sym_try] = ACTIONS(3220),
    [anon_sym_break] = ACTIONS(3220),
    [anon_sym_continue] = ACTIONS(3220),
    [anon_sym_debugger] = ACTIONS(3220),
    [anon_sym_return] = ACTIONS(3220),
    [anon_sym_throw] = ACTIONS(3220),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym_case] = ACTIONS(3220),
    [anon_sym_yield] = ACTIONS(3220),
    [anon_sym_LBRACK] = ACTIONS(3220),
    [anon_sym_LTtemplate_GT] = ACTIONS(3220),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [anon_sym_class] = ACTIONS(3220),
    [anon_sym_async] = ACTIONS(3220),
    [anon_sym_function] = ACTIONS(3220),
    [anon_sym_new] = ACTIONS(3220),
    [anon_sym_using] = ACTIONS(3220),
    [anon_sym_PLUS] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3220),
    [anon_sym_SLASH] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_void] = ACTIONS(3220),
    [anon_sym_delete] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3220),
    [sym_number] = ACTIONS(3220),
    [sym_private_property_identifier] = ACTIONS(3220),
    [sym_this] = ACTIONS(3220),
    [sym_super] = ACTIONS(3220),
    [sym_true] = ACTIONS(3220),
    [sym_false] = ACTIONS(3220),
    [sym_null] = ACTIONS(3220),
    [sym_undefined] = ACTIONS(3220),
    [anon_sym_AT] = ACTIONS(3220),
    [anon_sym_static] = ACTIONS(3220),
    [anon_sym_readonly] = ACTIONS(3220),
    [anon_sym_get] = ACTIONS(3220),
    [anon_sym_set] = ACTIONS(3220),
    [anon_sym_declare] = ACTIONS(3220),
    [anon_sym_public] = ACTIONS(3220),
    [anon_sym_private] = ACTIONS(3220),
    [anon_sym_protected] = ACTIONS(3220),
    [anon_sym_override] = ACTIONS(3220),
    [anon_sym_module] = ACTIONS(3220),
    [anon_sym_any] = ACTIONS(3220),
    [anon_sym_number] = ACTIONS(3220),
    [anon_sym_boolean] = ACTIONS(3220),
    [anon_sym_string] = ACTIONS(3220),
    [anon_sym_symbol] = ACTIONS(3220),
    [anon_sym_object] = ACTIONS(3220),
    [anon_sym_abstract] = ACTIONS(3220),
    [anon_sym_interface] = ACTIONS(3220),
    [anon_sym_enum] = ACTIONS(3220),
    [sym_html_comment] = ACTIONS(5),
  },
  [1031] = {
    [sym_comment] = STATE(1031),
    [sym_identifier] = ACTIONS(3222),
    [anon_sym_export] = ACTIONS(3222),
    [anon_sym_default] = ACTIONS(3222),
    [anon_sym_type] = ACTIONS(3222),
    [anon_sym_namespace] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3222),
    [anon_sym_RBRACE] = ACTIONS(3222),
    [anon_sym_typeof] = ACTIONS(3222),
    [anon_sym_import] = ACTIONS(3222),
    [anon_sym_with] = ACTIONS(3222),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_BANG] = ACTIONS(3222),
    [anon_sym_else] = ACTIONS(3222),
    [anon_sym_if] = ACTIONS(3222),
    [anon_sym_switch] = ACTIONS(3222),
    [anon_sym_for] = ACTIONS(3222),
    [anon_sym_LPAREN] = ACTIONS(3222),
    [anon_sym_await] = ACTIONS(3222),
    [anon_sym_while] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3222),
    [anon_sym_break] = ACTIONS(3222),
    [anon_sym_continue] = ACTIONS(3222),
    [anon_sym_debugger] = ACTIONS(3222),
    [anon_sym_return] = ACTIONS(3222),
    [anon_sym_throw] = ACTIONS(3222),
    [anon_sym_SEMI] = ACTIONS(3222),
    [anon_sym_case] = ACTIONS(3222),
    [anon_sym_yield] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_LTtemplate_GT] = ACTIONS(3222),
    [anon_sym_DQUOTE] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_async] = ACTIONS(3222),
    [anon_sym_function] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_using] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_SLASH] = ACTIONS(3222),
    [anon_sym_LT] = ACTIONS(3222),
    [anon_sym_TILDE] = ACTIONS(3222),
    [anon_sym_void] = ACTIONS(3222),
    [anon_sym_delete] = ACTIONS(3222),
    [anon_sym_PLUS_PLUS] = ACTIONS(3222),
    [anon_sym_DASH_DASH] = ACTIONS(3222),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3222),
    [sym_number] = ACTIONS(3222),
    [sym_private_property_identifier] = ACTIONS(3222),
    [sym_this] = ACTIONS(3222),
    [sym_super] = ACTIONS(3222),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [sym_null] = ACTIONS(3222),
    [sym_undefined] = ACTIONS(3222),
    [anon_sym_AT] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_readonly] = ACTIONS(3222),
    [anon_sym_get] = ACTIONS(3222),
    [anon_sym_set] = ACTIONS(3222),
    [anon_sym_declare] = ACTIONS(3222),
    [anon_sym_public] = ACTIONS(3222),
    [anon_sym_private] = ACTIONS(3222),
    [anon_sym_protected] = ACTIONS(3222),
    [anon_sym_override] = ACTIONS(3222),
    [anon_sym_module] = ACTIONS(3222),
    [anon_sym_any] = ACTIONS(3222),
    [anon_sym_number] = ACTIONS(3222),
    [anon_sym_boolean] = ACTIONS(3222),
    [anon_sym_string] = ACTIONS(3222),
    [anon_sym_symbol] = ACTIONS(3222),
    [anon_sym_object] = ACTIONS(3222),
    [anon_sym_abstract] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [sym_html_comment] = ACTIONS(5),
  },
  [1032] = {
    [sym_comment] = STATE(1032),
    [sym_identifier] = ACTIONS(3224),
    [anon_sym_export] = ACTIONS(3224),
    [anon_sym_default] = ACTIONS(3224),
    [anon_sym_type] = ACTIONS(3224),
    [anon_sym_namespace] = ACTIONS(3224),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_typeof] = ACTIONS(3224),
    [anon_sym_import] = ACTIONS(3224),
    [anon_sym_with] = ACTIONS(3224),
    [anon_sym_var] = ACTIONS(3224),
    [anon_sym_let] = ACTIONS(3224),
    [anon_sym_const] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_else] = ACTIONS(3224),
    [anon_sym_if] = ACTIONS(3224),
    [anon_sym_switch] = ACTIONS(3224),
    [anon_sym_for] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [anon_sym_await] = ACTIONS(3224),
    [anon_sym_while] = ACTIONS(3224),
    [anon_sym_do] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(3224),
    [anon_sym_break] = ACTIONS(3224),
    [anon_sym_continue] = ACTIONS(3224),
    [anon_sym_debugger] = ACTIONS(3224),
    [anon_sym_return] = ACTIONS(3224),
    [anon_sym_throw] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_case] = ACTIONS(3224),
    [anon_sym_yield] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_LTtemplate_GT] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_class] = ACTIONS(3224),
    [anon_sym_async] = ACTIONS(3224),
    [anon_sym_function] = ACTIONS(3224),
    [anon_sym_new] = ACTIONS(3224),
    [anon_sym_using] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3224),
    [anon_sym_SLASH] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_void] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3224),
    [sym_number] = ACTIONS(3224),
    [sym_private_property_identifier] = ACTIONS(3224),
    [sym_this] = ACTIONS(3224),
    [sym_super] = ACTIONS(3224),
    [sym_true] = ACTIONS(3224),
    [sym_false] = ACTIONS(3224),
    [sym_null] = ACTIONS(3224),
    [sym_undefined] = ACTIONS(3224),
    [anon_sym_AT] = ACTIONS(3224),
    [anon_sym_static] = ACTIONS(3224),
    [anon_sym_readonly] = ACTIONS(3224),
    [anon_sym_get] = ACTIONS(3224),
    [anon_sym_set] = ACTIONS(3224),
    [anon_sym_declare] = ACTIONS(3224),
    [anon_sym_public] = ACTIONS(3224),
    [anon_sym_private] = ACTIONS(3224),
    [anon_sym_protected] = ACTIONS(3224),
    [anon_sym_override] = ACTIONS(3224),
    [anon_sym_module] = ACTIONS(3224),
    [anon_sym_any] = ACTIONS(3224),
    [anon_sym_number] = ACTIONS(3224),
    [anon_sym_boolean] = ACTIONS(3224),
    [anon_sym_string] = ACTIONS(3224),
    [anon_sym_symbol] = ACTIONS(3224),
    [anon_sym_object] = ACTIONS(3224),
    [anon_sym_abstract] = ACTIONS(3224),
    [anon_sym_interface] = ACTIONS(3224),
    [anon_sym_enum] = ACTIONS(3224),
    [sym_html_comment] = ACTIONS(5),
  },
  [1033] = {
    [sym_comment] = STATE(1033),
    [sym_identifier] = ACTIONS(3226),
    [anon_sym_export] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_type] = ACTIONS(3226),
    [anon_sym_namespace] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [anon_sym_RBRACE] = ACTIONS(3226),
    [anon_sym_typeof] = ACTIONS(3226),
    [anon_sym_import] = ACTIONS(3226),
    [anon_sym_with] = ACTIONS(3226),
    [anon_sym_var] = ACTIONS(3226),
    [anon_sym_let] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_BANG] = ACTIONS(3226),
    [anon_sym_else] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3226),
    [anon_sym_await] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_try] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_debugger] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_throw] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_yield] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [anon_sym_LTtemplate_GT] = ACTIONS(3226),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_SQUOTE] = ACTIONS(3226),
    [anon_sym_class] = ACTIONS(3226),
    [anon_sym_async] = ACTIONS(3226),
    [anon_sym_function] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_using] = ACTIONS(3226),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_SLASH] = ACTIONS(3226),
    [anon_sym_LT] = ACTIONS(3226),
    [anon_sym_TILDE] = ACTIONS(3226),
    [anon_sym_void] = ACTIONS(3226),
    [anon_sym_delete] = ACTIONS(3226),
    [anon_sym_PLUS_PLUS] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3226),
    [sym_number] = ACTIONS(3226),
    [sym_private_property_identifier] = ACTIONS(3226),
    [sym_this] = ACTIONS(3226),
    [sym_super] = ACTIONS(3226),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [sym_null] = ACTIONS(3226),
    [sym_undefined] = ACTIONS(3226),
    [anon_sym_AT] = ACTIONS(3226),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_readonly] = ACTIONS(3226),
    [anon_sym_get] = ACTIONS(3226),
    [anon_sym_set] = ACTIONS(3226),
    [anon_sym_declare] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3226),
    [anon_sym_private] = ACTIONS(3226),
    [anon_sym_protected] = ACTIONS(3226),
    [anon_sym_override] = ACTIONS(3226),
    [anon_sym_module] = ACTIONS(3226),
    [anon_sym_any] = ACTIONS(3226),
    [anon_sym_number] = ACTIONS(3226),
    [anon_sym_boolean] = ACTIONS(3226),
    [anon_sym_string] = ACTIONS(3226),
    [anon_sym_symbol] = ACTIONS(3226),
    [anon_sym_object] = ACTIONS(3226),
    [anon_sym_abstract] = ACTIONS(3226),
    [anon_sym_interface] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [sym_html_comment] = ACTIONS(5),
  },
  [1034] = {
    [sym_comment] = STATE(1034),
    [ts_builtin_sym_end] = ACTIONS(2387),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_export] = ACTIONS(2213),
    [anon_sym_type] = ACTIONS(2213),
    [anon_sym_namespace] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_typeof] = ACTIONS(2213),
    [anon_sym_import] = ACTIONS(2213),
    [anon_sym_with] = ACTIONS(2213),
    [anon_sym_var] = ACTIONS(2213),
    [anon_sym_let] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_else] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_for] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_await] = ACTIONS(2213),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_do] = ACTIONS(2213),
    [anon_sym_try] = ACTIONS(2213),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_debugger] = ACTIONS(2213),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_throw] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_yield] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2213),
    [anon_sym_LTtemplate_GT] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_class] = ACTIONS(2213),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2213),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_using] = ACTIONS(2213),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_void] = ACTIONS(2213),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_number] = ACTIONS(2213),
    [sym_private_property_identifier] = ACTIONS(2213),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(2213),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2213),
    [anon_sym_static] = ACTIONS(2213),
    [anon_sym_readonly] = ACTIONS(2213),
    [anon_sym_get] = ACTIONS(2213),
    [anon_sym_set] = ACTIONS(2213),
    [anon_sym_declare] = ACTIONS(2213),
    [anon_sym_public] = ACTIONS(2213),
    [anon_sym_private] = ACTIONS(2213),
    [anon_sym_protected] = ACTIONS(2213),
    [anon_sym_override] = ACTIONS(2213),
    [anon_sym_module] = ACTIONS(2213),
    [anon_sym_any] = ACTIONS(2213),
    [anon_sym_number] = ACTIONS(2213),
    [anon_sym_boolean] = ACTIONS(2213),
    [anon_sym_string] = ACTIONS(2213),
    [anon_sym_symbol] = ACTIONS(2213),
    [anon_sym_object] = ACTIONS(2213),
    [anon_sym_abstract] = ACTIONS(2213),
    [anon_sym_interface] = ACTIONS(2213),
    [anon_sym_enum] = ACTIONS(2213),
    [sym__automatic_semicolon] = ACTIONS(2389),
    [sym_html_comment] = ACTIONS(5),
  },
  [1035] = {
    [sym_comment] = STATE(1035),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_catch] = ACTIONS(2221),
    [anon_sym_finally] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1036] = {
    [sym_comment] = STATE(1036),
    [sym_identifier] = ACTIONS(3228),
    [anon_sym_export] = ACTIONS(3228),
    [anon_sym_default] = ACTIONS(3228),
    [anon_sym_type] = ACTIONS(3228),
    [anon_sym_namespace] = ACTIONS(3228),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_typeof] = ACTIONS(3228),
    [anon_sym_import] = ACTIONS(3228),
    [anon_sym_with] = ACTIONS(3228),
    [anon_sym_var] = ACTIONS(3228),
    [anon_sym_let] = ACTIONS(3228),
    [anon_sym_const] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_else] = ACTIONS(3228),
    [anon_sym_if] = ACTIONS(3228),
    [anon_sym_switch] = ACTIONS(3228),
    [anon_sym_for] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3228),
    [anon_sym_await] = ACTIONS(3228),
    [anon_sym_while] = ACTIONS(3228),
    [anon_sym_do] = ACTIONS(3228),
    [anon_sym_try] = ACTIONS(3228),
    [anon_sym_break] = ACTIONS(3228),
    [anon_sym_continue] = ACTIONS(3228),
    [anon_sym_debugger] = ACTIONS(3228),
    [anon_sym_return] = ACTIONS(3228),
    [anon_sym_throw] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_case] = ACTIONS(3228),
    [anon_sym_yield] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_LTtemplate_GT] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3228),
    [anon_sym_SQUOTE] = ACTIONS(3228),
    [anon_sym_class] = ACTIONS(3228),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_function] = ACTIONS(3228),
    [anon_sym_new] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3228),
    [anon_sym_SLASH] = ACTIONS(3228),
    [anon_sym_LT] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3228),
    [anon_sym_void] = ACTIONS(3228),
    [anon_sym_delete] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3228),
    [sym_number] = ACTIONS(3228),
    [sym_private_property_identifier] = ACTIONS(3228),
    [sym_this] = ACTIONS(3228),
    [sym_super] = ACTIONS(3228),
    [sym_true] = ACTIONS(3228),
    [sym_false] = ACTIONS(3228),
    [sym_null] = ACTIONS(3228),
    [sym_undefined] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(3228),
    [anon_sym_readonly] = ACTIONS(3228),
    [anon_sym_get] = ACTIONS(3228),
    [anon_sym_set] = ACTIONS(3228),
    [anon_sym_declare] = ACTIONS(3228),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_override] = ACTIONS(3228),
    [anon_sym_module] = ACTIONS(3228),
    [anon_sym_any] = ACTIONS(3228),
    [anon_sym_number] = ACTIONS(3228),
    [anon_sym_boolean] = ACTIONS(3228),
    [anon_sym_string] = ACTIONS(3228),
    [anon_sym_symbol] = ACTIONS(3228),
    [anon_sym_object] = ACTIONS(3228),
    [anon_sym_abstract] = ACTIONS(3228),
    [anon_sym_interface] = ACTIONS(3228),
    [anon_sym_enum] = ACTIONS(3228),
    [sym_html_comment] = ACTIONS(5),
  },
  [1037] = {
    [sym_comment] = STATE(1037),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_export] = ACTIONS(3230),
    [anon_sym_default] = ACTIONS(3230),
    [anon_sym_type] = ACTIONS(3230),
    [anon_sym_namespace] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_RBRACE] = ACTIONS(3230),
    [anon_sym_typeof] = ACTIONS(3230),
    [anon_sym_import] = ACTIONS(3230),
    [anon_sym_with] = ACTIONS(3230),
    [anon_sym_var] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_BANG] = ACTIONS(3230),
    [anon_sym_else] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_switch] = ACTIONS(3230),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_await] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_break] = ACTIONS(3230),
    [anon_sym_continue] = ACTIONS(3230),
    [anon_sym_debugger] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_throw] = ACTIONS(3230),
    [anon_sym_SEMI] = ACTIONS(3230),
    [anon_sym_case] = ACTIONS(3230),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LTtemplate_GT] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_SQUOTE] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3230),
    [anon_sym_async] = ACTIONS(3230),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_SLASH] = ACTIONS(3230),
    [anon_sym_LT] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3230),
    [anon_sym_void] = ACTIONS(3230),
    [anon_sym_delete] = ACTIONS(3230),
    [anon_sym_PLUS_PLUS] = ACTIONS(3230),
    [anon_sym_DASH_DASH] = ACTIONS(3230),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3230),
    [sym_number] = ACTIONS(3230),
    [sym_private_property_identifier] = ACTIONS(3230),
    [sym_this] = ACTIONS(3230),
    [sym_super] = ACTIONS(3230),
    [sym_true] = ACTIONS(3230),
    [sym_false] = ACTIONS(3230),
    [sym_null] = ACTIONS(3230),
    [sym_undefined] = ACTIONS(3230),
    [anon_sym_AT] = ACTIONS(3230),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_readonly] = ACTIONS(3230),
    [anon_sym_get] = ACTIONS(3230),
    [anon_sym_set] = ACTIONS(3230),
    [anon_sym_declare] = ACTIONS(3230),
    [anon_sym_public] = ACTIONS(3230),
    [anon_sym_private] = ACTIONS(3230),
    [anon_sym_protected] = ACTIONS(3230),
    [anon_sym_override] = ACTIONS(3230),
    [anon_sym_module] = ACTIONS(3230),
    [anon_sym_any] = ACTIONS(3230),
    [anon_sym_number] = ACTIONS(3230),
    [anon_sym_boolean] = ACTIONS(3230),
    [anon_sym_string] = ACTIONS(3230),
    [anon_sym_symbol] = ACTIONS(3230),
    [anon_sym_object] = ACTIONS(3230),
    [anon_sym_abstract] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3230),
    [anon_sym_enum] = ACTIONS(3230),
    [sym_html_comment] = ACTIONS(5),
  },
  [1038] = {
    [sym_comment] = STATE(1038),
    [sym_identifier] = ACTIONS(3232),
    [anon_sym_export] = ACTIONS(3232),
    [anon_sym_default] = ACTIONS(3232),
    [anon_sym_type] = ACTIONS(3232),
    [anon_sym_namespace] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [anon_sym_typeof] = ACTIONS(3232),
    [anon_sym_import] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3232),
    [anon_sym_var] = ACTIONS(3232),
    [anon_sym_let] = ACTIONS(3232),
    [anon_sym_const] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_else] = ACTIONS(3232),
    [anon_sym_if] = ACTIONS(3232),
    [anon_sym_switch] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3232),
    [anon_sym_await] = ACTIONS(3232),
    [anon_sym_while] = ACTIONS(3232),
    [anon_sym_do] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3232),
    [anon_sym_break] = ACTIONS(3232),
    [anon_sym_continue] = ACTIONS(3232),
    [anon_sym_debugger] = ACTIONS(3232),
    [anon_sym_return] = ACTIONS(3232),
    [anon_sym_throw] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym_case] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3232),
    [anon_sym_LBRACK] = ACTIONS(3232),
    [anon_sym_LTtemplate_GT] = ACTIONS(3232),
    [anon_sym_DQUOTE] = ACTIONS(3232),
    [anon_sym_SQUOTE] = ACTIONS(3232),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_async] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3232),
    [anon_sym_using] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3232),
    [anon_sym_SLASH] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_void] = ACTIONS(3232),
    [anon_sym_delete] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3232),
    [sym_number] = ACTIONS(3232),
    [sym_private_property_identifier] = ACTIONS(3232),
    [sym_this] = ACTIONS(3232),
    [sym_super] = ACTIONS(3232),
    [sym_true] = ACTIONS(3232),
    [sym_false] = ACTIONS(3232),
    [sym_null] = ACTIONS(3232),
    [sym_undefined] = ACTIONS(3232),
    [anon_sym_AT] = ACTIONS(3232),
    [anon_sym_static] = ACTIONS(3232),
    [anon_sym_readonly] = ACTIONS(3232),
    [anon_sym_get] = ACTIONS(3232),
    [anon_sym_set] = ACTIONS(3232),
    [anon_sym_declare] = ACTIONS(3232),
    [anon_sym_public] = ACTIONS(3232),
    [anon_sym_private] = ACTIONS(3232),
    [anon_sym_protected] = ACTIONS(3232),
    [anon_sym_override] = ACTIONS(3232),
    [anon_sym_module] = ACTIONS(3232),
    [anon_sym_any] = ACTIONS(3232),
    [anon_sym_number] = ACTIONS(3232),
    [anon_sym_boolean] = ACTIONS(3232),
    [anon_sym_string] = ACTIONS(3232),
    [anon_sym_symbol] = ACTIONS(3232),
    [anon_sym_object] = ACTIONS(3232),
    [anon_sym_abstract] = ACTIONS(3232),
    [anon_sym_interface] = ACTIONS(3232),
    [anon_sym_enum] = ACTIONS(3232),
    [sym_html_comment] = ACTIONS(5),
  },
  [1039] = {
    [sym_comment] = STATE(1039),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_export] = ACTIONS(3234),
    [anon_sym_default] = ACTIONS(3234),
    [anon_sym_type] = ACTIONS(3234),
    [anon_sym_namespace] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(3234),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_typeof] = ACTIONS(3234),
    [anon_sym_import] = ACTIONS(3234),
    [anon_sym_with] = ACTIONS(3234),
    [anon_sym_var] = ACTIONS(3234),
    [anon_sym_let] = ACTIONS(3234),
    [anon_sym_const] = ACTIONS(3234),
    [anon_sym_BANG] = ACTIONS(3234),
    [anon_sym_else] = ACTIONS(3234),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_for] = ACTIONS(3234),
    [anon_sym_LPAREN] = ACTIONS(3234),
    [anon_sym_await] = ACTIONS(3234),
    [anon_sym_while] = ACTIONS(3234),
    [anon_sym_do] = ACTIONS(3234),
    [anon_sym_try] = ACTIONS(3234),
    [anon_sym_break] = ACTIONS(3234),
    [anon_sym_continue] = ACTIONS(3234),
    [anon_sym_debugger] = ACTIONS(3234),
    [anon_sym_return] = ACTIONS(3234),
    [anon_sym_throw] = ACTIONS(3234),
    [anon_sym_SEMI] = ACTIONS(3234),
    [anon_sym_case] = ACTIONS(3234),
    [anon_sym_yield] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_LTtemplate_GT] = ACTIONS(3234),
    [anon_sym_DQUOTE] = ACTIONS(3234),
    [anon_sym_SQUOTE] = ACTIONS(3234),
    [anon_sym_class] = ACTIONS(3234),
    [anon_sym_async] = ACTIONS(3234),
    [anon_sym_function] = ACTIONS(3234),
    [anon_sym_new] = ACTIONS(3234),
    [anon_sym_using] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3234),
    [anon_sym_DASH] = ACTIONS(3234),
    [anon_sym_SLASH] = ACTIONS(3234),
    [anon_sym_LT] = ACTIONS(3234),
    [anon_sym_TILDE] = ACTIONS(3234),
    [anon_sym_void] = ACTIONS(3234),
    [anon_sym_delete] = ACTIONS(3234),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3234),
    [sym_number] = ACTIONS(3234),
    [sym_private_property_identifier] = ACTIONS(3234),
    [sym_this] = ACTIONS(3234),
    [sym_super] = ACTIONS(3234),
    [sym_true] = ACTIONS(3234),
    [sym_false] = ACTIONS(3234),
    [sym_null] = ACTIONS(3234),
    [sym_undefined] = ACTIONS(3234),
    [anon_sym_AT] = ACTIONS(3234),
    [anon_sym_static] = ACTIONS(3234),
    [anon_sym_readonly] = ACTIONS(3234),
    [anon_sym_get] = ACTIONS(3234),
    [anon_sym_set] = ACTIONS(3234),
    [anon_sym_declare] = ACTIONS(3234),
    [anon_sym_public] = ACTIONS(3234),
    [anon_sym_private] = ACTIONS(3234),
    [anon_sym_protected] = ACTIONS(3234),
    [anon_sym_override] = ACTIONS(3234),
    [anon_sym_module] = ACTIONS(3234),
    [anon_sym_any] = ACTIONS(3234),
    [anon_sym_number] = ACTIONS(3234),
    [anon_sym_boolean] = ACTIONS(3234),
    [anon_sym_string] = ACTIONS(3234),
    [anon_sym_symbol] = ACTIONS(3234),
    [anon_sym_object] = ACTIONS(3234),
    [anon_sym_abstract] = ACTIONS(3234),
    [anon_sym_interface] = ACTIONS(3234),
    [anon_sym_enum] = ACTIONS(3234),
    [sym_html_comment] = ACTIONS(5),
  },
  [1040] = {
    [sym_comment] = STATE(1040),
    [sym_identifier] = ACTIONS(3236),
    [anon_sym_export] = ACTIONS(3236),
    [anon_sym_default] = ACTIONS(3236),
    [anon_sym_type] = ACTIONS(3236),
    [anon_sym_namespace] = ACTIONS(3236),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_RBRACE] = ACTIONS(3236),
    [anon_sym_typeof] = ACTIONS(3236),
    [anon_sym_import] = ACTIONS(3236),
    [anon_sym_with] = ACTIONS(3236),
    [anon_sym_var] = ACTIONS(3236),
    [anon_sym_let] = ACTIONS(3236),
    [anon_sym_const] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_else] = ACTIONS(3236),
    [anon_sym_if] = ACTIONS(3236),
    [anon_sym_switch] = ACTIONS(3236),
    [anon_sym_for] = ACTIONS(3236),
    [anon_sym_LPAREN] = ACTIONS(3236),
    [anon_sym_await] = ACTIONS(3236),
    [anon_sym_while] = ACTIONS(3236),
    [anon_sym_do] = ACTIONS(3236),
    [anon_sym_try] = ACTIONS(3236),
    [anon_sym_break] = ACTIONS(3236),
    [anon_sym_continue] = ACTIONS(3236),
    [anon_sym_debugger] = ACTIONS(3236),
    [anon_sym_return] = ACTIONS(3236),
    [anon_sym_throw] = ACTIONS(3236),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym_case] = ACTIONS(3236),
    [anon_sym_yield] = ACTIONS(3236),
    [anon_sym_LBRACK] = ACTIONS(3236),
    [anon_sym_LTtemplate_GT] = ACTIONS(3236),
    [anon_sym_DQUOTE] = ACTIONS(3236),
    [anon_sym_SQUOTE] = ACTIONS(3236),
    [anon_sym_class] = ACTIONS(3236),
    [anon_sym_async] = ACTIONS(3236),
    [anon_sym_function] = ACTIONS(3236),
    [anon_sym_new] = ACTIONS(3236),
    [anon_sym_using] = ACTIONS(3236),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3236),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_void] = ACTIONS(3236),
    [anon_sym_delete] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3236),
    [anon_sym_DASH_DASH] = ACTIONS(3236),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3236),
    [sym_number] = ACTIONS(3236),
    [sym_private_property_identifier] = ACTIONS(3236),
    [sym_this] = ACTIONS(3236),
    [sym_super] = ACTIONS(3236),
    [sym_true] = ACTIONS(3236),
    [sym_false] = ACTIONS(3236),
    [sym_null] = ACTIONS(3236),
    [sym_undefined] = ACTIONS(3236),
    [anon_sym_AT] = ACTIONS(3236),
    [anon_sym_static] = ACTIONS(3236),
    [anon_sym_readonly] = ACTIONS(3236),
    [anon_sym_get] = ACTIONS(3236),
    [anon_sym_set] = ACTIONS(3236),
    [anon_sym_declare] = ACTIONS(3236),
    [anon_sym_public] = ACTIONS(3236),
    [anon_sym_private] = ACTIONS(3236),
    [anon_sym_protected] = ACTIONS(3236),
    [anon_sym_override] = ACTIONS(3236),
    [anon_sym_module] = ACTIONS(3236),
    [anon_sym_any] = ACTIONS(3236),
    [anon_sym_number] = ACTIONS(3236),
    [anon_sym_boolean] = ACTIONS(3236),
    [anon_sym_string] = ACTIONS(3236),
    [anon_sym_symbol] = ACTIONS(3236),
    [anon_sym_object] = ACTIONS(3236),
    [anon_sym_abstract] = ACTIONS(3236),
    [anon_sym_interface] = ACTIONS(3236),
    [anon_sym_enum] = ACTIONS(3236),
    [sym_html_comment] = ACTIONS(5),
  },
  [1041] = {
    [sym_statement_block] = STATE(1218),
    [sym_comment] = STATE(1041),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_default] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3110),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [1042] = {
    [sym_comment] = STATE(1042),
    [sym_identifier] = ACTIONS(3238),
    [anon_sym_export] = ACTIONS(3238),
    [anon_sym_default] = ACTIONS(3238),
    [anon_sym_type] = ACTIONS(3238),
    [anon_sym_namespace] = ACTIONS(3238),
    [anon_sym_LBRACE] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_typeof] = ACTIONS(3238),
    [anon_sym_import] = ACTIONS(3238),
    [anon_sym_with] = ACTIONS(3238),
    [anon_sym_var] = ACTIONS(3238),
    [anon_sym_let] = ACTIONS(3238),
    [anon_sym_const] = ACTIONS(3238),
    [anon_sym_BANG] = ACTIONS(3238),
    [anon_sym_else] = ACTIONS(3238),
    [anon_sym_if] = ACTIONS(3238),
    [anon_sym_switch] = ACTIONS(3238),
    [anon_sym_for] = ACTIONS(3238),
    [anon_sym_LPAREN] = ACTIONS(3238),
    [anon_sym_await] = ACTIONS(3238),
    [anon_sym_while] = ACTIONS(3238),
    [anon_sym_do] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(3238),
    [anon_sym_break] = ACTIONS(3238),
    [anon_sym_continue] = ACTIONS(3238),
    [anon_sym_debugger] = ACTIONS(3238),
    [anon_sym_return] = ACTIONS(3238),
    [anon_sym_throw] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym_case] = ACTIONS(3238),
    [anon_sym_yield] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_LTtemplate_GT] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [anon_sym_class] = ACTIONS(3238),
    [anon_sym_async] = ACTIONS(3238),
    [anon_sym_function] = ACTIONS(3238),
    [anon_sym_new] = ACTIONS(3238),
    [anon_sym_using] = ACTIONS(3238),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3238),
    [anon_sym_TILDE] = ACTIONS(3238),
    [anon_sym_void] = ACTIONS(3238),
    [anon_sym_delete] = ACTIONS(3238),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [sym_number] = ACTIONS(3238),
    [sym_private_property_identifier] = ACTIONS(3238),
    [sym_this] = ACTIONS(3238),
    [sym_super] = ACTIONS(3238),
    [sym_true] = ACTIONS(3238),
    [sym_false] = ACTIONS(3238),
    [sym_null] = ACTIONS(3238),
    [sym_undefined] = ACTIONS(3238),
    [anon_sym_AT] = ACTIONS(3238),
    [anon_sym_static] = ACTIONS(3238),
    [anon_sym_readonly] = ACTIONS(3238),
    [anon_sym_get] = ACTIONS(3238),
    [anon_sym_set] = ACTIONS(3238),
    [anon_sym_declare] = ACTIONS(3238),
    [anon_sym_public] = ACTIONS(3238),
    [anon_sym_private] = ACTIONS(3238),
    [anon_sym_protected] = ACTIONS(3238),
    [anon_sym_override] = ACTIONS(3238),
    [anon_sym_module] = ACTIONS(3238),
    [anon_sym_any] = ACTIONS(3238),
    [anon_sym_number] = ACTIONS(3238),
    [anon_sym_boolean] = ACTIONS(3238),
    [anon_sym_string] = ACTIONS(3238),
    [anon_sym_symbol] = ACTIONS(3238),
    [anon_sym_object] = ACTIONS(3238),
    [anon_sym_abstract] = ACTIONS(3238),
    [anon_sym_interface] = ACTIONS(3238),
    [anon_sym_enum] = ACTIONS(3238),
    [sym_html_comment] = ACTIONS(5),
  },
  [1043] = {
    [sym_else_clause] = STATE(1469),
    [sym_comment] = STATE(1043),
    [ts_builtin_sym_end] = ACTIONS(3206),
    [sym_identifier] = ACTIONS(3070),
    [anon_sym_export] = ACTIONS(3070),
    [anon_sym_type] = ACTIONS(3070),
    [anon_sym_namespace] = ACTIONS(3070),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_typeof] = ACTIONS(3070),
    [anon_sym_import] = ACTIONS(3070),
    [anon_sym_with] = ACTIONS(3070),
    [anon_sym_var] = ACTIONS(3070),
    [anon_sym_let] = ACTIONS(3070),
    [anon_sym_const] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_else] = ACTIONS(3240),
    [anon_sym_if] = ACTIONS(3070),
    [anon_sym_switch] = ACTIONS(3070),
    [anon_sym_for] = ACTIONS(3070),
    [anon_sym_LPAREN] = ACTIONS(3070),
    [anon_sym_await] = ACTIONS(3070),
    [anon_sym_while] = ACTIONS(3070),
    [anon_sym_do] = ACTIONS(3070),
    [anon_sym_try] = ACTIONS(3070),
    [anon_sym_break] = ACTIONS(3070),
    [anon_sym_continue] = ACTIONS(3070),
    [anon_sym_debugger] = ACTIONS(3070),
    [anon_sym_return] = ACTIONS(3070),
    [anon_sym_throw] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym_yield] = ACTIONS(3070),
    [anon_sym_LBRACK] = ACTIONS(3070),
    [anon_sym_LTtemplate_GT] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_class] = ACTIONS(3070),
    [anon_sym_async] = ACTIONS(3070),
    [anon_sym_function] = ACTIONS(3070),
    [anon_sym_new] = ACTIONS(3070),
    [anon_sym_using] = ACTIONS(3070),
    [anon_sym_PLUS] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3070),
    [anon_sym_SLASH] = ACTIONS(3070),
    [anon_sym_LT] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_void] = ACTIONS(3070),
    [anon_sym_delete] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3070),
    [sym_number] = ACTIONS(3070),
    [sym_private_property_identifier] = ACTIONS(3070),
    [sym_this] = ACTIONS(3070),
    [sym_super] = ACTIONS(3070),
    [sym_true] = ACTIONS(3070),
    [sym_false] = ACTIONS(3070),
    [sym_null] = ACTIONS(3070),
    [sym_undefined] = ACTIONS(3070),
    [anon_sym_AT] = ACTIONS(3070),
    [anon_sym_static] = ACTIONS(3070),
    [anon_sym_readonly] = ACTIONS(3070),
    [anon_sym_get] = ACTIONS(3070),
    [anon_sym_set] = ACTIONS(3070),
    [anon_sym_declare] = ACTIONS(3070),
    [anon_sym_public] = ACTIONS(3070),
    [anon_sym_private] = ACTIONS(3070),
    [anon_sym_protected] = ACTIONS(3070),
    [anon_sym_override] = ACTIONS(3070),
    [anon_sym_module] = ACTIONS(3070),
    [anon_sym_any] = ACTIONS(3070),
    [anon_sym_number] = ACTIONS(3070),
    [anon_sym_boolean] = ACTIONS(3070),
    [anon_sym_string] = ACTIONS(3070),
    [anon_sym_symbol] = ACTIONS(3070),
    [anon_sym_object] = ACTIONS(3070),
    [anon_sym_abstract] = ACTIONS(3070),
    [anon_sym_interface] = ACTIONS(3070),
    [anon_sym_enum] = ACTIONS(3070),
    [sym_html_comment] = ACTIONS(5),
  },
  [1044] = {
    [sym_comment] = STATE(1044),
    [ts_builtin_sym_end] = ACTIONS(3242),
    [sym_identifier] = ACTIONS(3074),
    [anon_sym_export] = ACTIONS(3074),
    [anon_sym_type] = ACTIONS(3074),
    [anon_sym_namespace] = ACTIONS(3074),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_typeof] = ACTIONS(3074),
    [anon_sym_import] = ACTIONS(3074),
    [anon_sym_with] = ACTIONS(3074),
    [anon_sym_var] = ACTIONS(3074),
    [anon_sym_let] = ACTIONS(3074),
    [anon_sym_const] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_else] = ACTIONS(3074),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_switch] = ACTIONS(3074),
    [anon_sym_for] = ACTIONS(3074),
    [anon_sym_LPAREN] = ACTIONS(3074),
    [anon_sym_await] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_try] = ACTIONS(3074),
    [anon_sym_break] = ACTIONS(3074),
    [anon_sym_continue] = ACTIONS(3074),
    [anon_sym_debugger] = ACTIONS(3074),
    [anon_sym_return] = ACTIONS(3074),
    [anon_sym_throw] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym_yield] = ACTIONS(3074),
    [anon_sym_LBRACK] = ACTIONS(3074),
    [anon_sym_LTtemplate_GT] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_class] = ACTIONS(3074),
    [anon_sym_async] = ACTIONS(3074),
    [anon_sym_function] = ACTIONS(3074),
    [anon_sym_new] = ACTIONS(3074),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3074),
    [anon_sym_SLASH] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_void] = ACTIONS(3074),
    [anon_sym_delete] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3074),
    [sym_number] = ACTIONS(3074),
    [sym_private_property_identifier] = ACTIONS(3074),
    [sym_this] = ACTIONS(3074),
    [sym_super] = ACTIONS(3074),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [sym_null] = ACTIONS(3074),
    [sym_undefined] = ACTIONS(3074),
    [anon_sym_AT] = ACTIONS(3074),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_readonly] = ACTIONS(3074),
    [anon_sym_get] = ACTIONS(3074),
    [anon_sym_set] = ACTIONS(3074),
    [anon_sym_declare] = ACTIONS(3074),
    [anon_sym_public] = ACTIONS(3074),
    [anon_sym_private] = ACTIONS(3074),
    [anon_sym_protected] = ACTIONS(3074),
    [anon_sym_override] = ACTIONS(3074),
    [anon_sym_module] = ACTIONS(3074),
    [anon_sym_any] = ACTIONS(3074),
    [anon_sym_number] = ACTIONS(3074),
    [anon_sym_boolean] = ACTIONS(3074),
    [anon_sym_string] = ACTIONS(3074),
    [anon_sym_symbol] = ACTIONS(3074),
    [anon_sym_object] = ACTIONS(3074),
    [anon_sym_abstract] = ACTIONS(3074),
    [anon_sym_interface] = ACTIONS(3074),
    [anon_sym_enum] = ACTIONS(3074),
    [sym__automatic_semicolon] = ACTIONS(3246),
    [sym_html_comment] = ACTIONS(5),
  },
  [1045] = {
    [sym_comment] = STATE(1045),
    [ts_builtin_sym_end] = ACTIONS(3248),
    [sym_identifier] = ACTIONS(3102),
    [anon_sym_export] = ACTIONS(3102),
    [anon_sym_type] = ACTIONS(3102),
    [anon_sym_namespace] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_typeof] = ACTIONS(3102),
    [anon_sym_import] = ACTIONS(3102),
    [anon_sym_with] = ACTIONS(3102),
    [anon_sym_var] = ACTIONS(3102),
    [anon_sym_let] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_await] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_debugger] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_finally] = ACTIONS(3102),
    [anon_sym_yield] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_LTtemplate_GT] = ACTIONS(3102),
    [anon_sym_DQUOTE] = ACTIONS(3102),
    [anon_sym_SQUOTE] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_async] = ACTIONS(3102),
    [anon_sym_function] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_using] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_SLASH] = ACTIONS(3102),
    [anon_sym_LT] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_void] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3102),
    [sym_number] = ACTIONS(3102),
    [sym_private_property_identifier] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
    [sym_super] = ACTIONS(3102),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [sym_null] = ACTIONS(3102),
    [sym_undefined] = ACTIONS(3102),
    [anon_sym_AT] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_readonly] = ACTIONS(3102),
    [anon_sym_get] = ACTIONS(3102),
    [anon_sym_set] = ACTIONS(3102),
    [anon_sym_declare] = ACTIONS(3102),
    [anon_sym_public] = ACTIONS(3102),
    [anon_sym_private] = ACTIONS(3102),
    [anon_sym_protected] = ACTIONS(3102),
    [anon_sym_override] = ACTIONS(3102),
    [anon_sym_module] = ACTIONS(3102),
    [anon_sym_any] = ACTIONS(3102),
    [anon_sym_number] = ACTIONS(3102),
    [anon_sym_boolean] = ACTIONS(3102),
    [anon_sym_string] = ACTIONS(3102),
    [anon_sym_symbol] = ACTIONS(3102),
    [anon_sym_object] = ACTIONS(3102),
    [anon_sym_abstract] = ACTIONS(3102),
    [anon_sym_interface] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [sym_html_comment] = ACTIONS(5),
  },
  [1046] = {
    [sym_comment] = STATE(1046),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_export] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_type] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_typeof] = ACTIONS(3250),
    [anon_sym_import] = ACTIONS(3250),
    [anon_sym_with] = ACTIONS(3250),
    [anon_sym_var] = ACTIONS(3250),
    [anon_sym_let] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_else] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym_await] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_debugger] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_yield] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_LTtemplate_GT] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_async] = ACTIONS(3250),
    [anon_sym_function] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3250),
    [anon_sym_LT] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_void] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3250),
    [sym_number] = ACTIONS(3250),
    [sym_private_property_identifier] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
    [sym_super] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_null] = ACTIONS(3250),
    [sym_undefined] = ACTIONS(3250),
    [anon_sym_AT] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_readonly] = ACTIONS(3250),
    [anon_sym_get] = ACTIONS(3250),
    [anon_sym_set] = ACTIONS(3250),
    [anon_sym_declare] = ACTIONS(3250),
    [anon_sym_public] = ACTIONS(3250),
    [anon_sym_private] = ACTIONS(3250),
    [anon_sym_protected] = ACTIONS(3250),
    [anon_sym_override] = ACTIONS(3250),
    [anon_sym_module] = ACTIONS(3250),
    [anon_sym_any] = ACTIONS(3250),
    [anon_sym_number] = ACTIONS(3250),
    [anon_sym_boolean] = ACTIONS(3250),
    [anon_sym_string] = ACTIONS(3250),
    [anon_sym_symbol] = ACTIONS(3250),
    [anon_sym_object] = ACTIONS(3250),
    [anon_sym_abstract] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [sym_html_comment] = ACTIONS(5),
  },
  [1047] = {
    [sym_comment] = STATE(1047),
    [sym_identifier] = ACTIONS(3252),
    [anon_sym_export] = ACTIONS(3252),
    [anon_sym_default] = ACTIONS(3252),
    [anon_sym_type] = ACTIONS(3252),
    [anon_sym_namespace] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_typeof] = ACTIONS(3252),
    [anon_sym_import] = ACTIONS(3252),
    [anon_sym_with] = ACTIONS(3252),
    [anon_sym_var] = ACTIONS(3252),
    [anon_sym_let] = ACTIONS(3252),
    [anon_sym_const] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_else] = ACTIONS(3252),
    [anon_sym_if] = ACTIONS(3252),
    [anon_sym_switch] = ACTIONS(3252),
    [anon_sym_for] = ACTIONS(3252),
    [anon_sym_LPAREN] = ACTIONS(3252),
    [anon_sym_await] = ACTIONS(3252),
    [anon_sym_while] = ACTIONS(3252),
    [anon_sym_do] = ACTIONS(3252),
    [anon_sym_try] = ACTIONS(3252),
    [anon_sym_break] = ACTIONS(3252),
    [anon_sym_continue] = ACTIONS(3252),
    [anon_sym_debugger] = ACTIONS(3252),
    [anon_sym_return] = ACTIONS(3252),
    [anon_sym_throw] = ACTIONS(3252),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym_case] = ACTIONS(3252),
    [anon_sym_yield] = ACTIONS(3252),
    [anon_sym_LBRACK] = ACTIONS(3252),
    [anon_sym_LTtemplate_GT] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_class] = ACTIONS(3252),
    [anon_sym_async] = ACTIONS(3252),
    [anon_sym_function] = ACTIONS(3252),
    [anon_sym_new] = ACTIONS(3252),
    [anon_sym_using] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3252),
    [anon_sym_SLASH] = ACTIONS(3252),
    [anon_sym_LT] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_void] = ACTIONS(3252),
    [anon_sym_delete] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3252),
    [sym_number] = ACTIONS(3252),
    [sym_private_property_identifier] = ACTIONS(3252),
    [sym_this] = ACTIONS(3252),
    [sym_super] = ACTIONS(3252),
    [sym_true] = ACTIONS(3252),
    [sym_false] = ACTIONS(3252),
    [sym_null] = ACTIONS(3252),
    [sym_undefined] = ACTIONS(3252),
    [anon_sym_AT] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3252),
    [anon_sym_readonly] = ACTIONS(3252),
    [anon_sym_get] = ACTIONS(3252),
    [anon_sym_set] = ACTIONS(3252),
    [anon_sym_declare] = ACTIONS(3252),
    [anon_sym_public] = ACTIONS(3252),
    [anon_sym_private] = ACTIONS(3252),
    [anon_sym_protected] = ACTIONS(3252),
    [anon_sym_override] = ACTIONS(3252),
    [anon_sym_module] = ACTIONS(3252),
    [anon_sym_any] = ACTIONS(3252),
    [anon_sym_number] = ACTIONS(3252),
    [anon_sym_boolean] = ACTIONS(3252),
    [anon_sym_string] = ACTIONS(3252),
    [anon_sym_symbol] = ACTIONS(3252),
    [anon_sym_object] = ACTIONS(3252),
    [anon_sym_abstract] = ACTIONS(3252),
    [anon_sym_interface] = ACTIONS(3252),
    [anon_sym_enum] = ACTIONS(3252),
    [sym_html_comment] = ACTIONS(5),
  },
  [1048] = {
    [sym_comment] = STATE(1048),
    [sym_identifier] = ACTIONS(3254),
    [anon_sym_export] = ACTIONS(3254),
    [anon_sym_default] = ACTIONS(3254),
    [anon_sym_type] = ACTIONS(3254),
    [anon_sym_namespace] = ACTIONS(3254),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_RBRACE] = ACTIONS(3254),
    [anon_sym_typeof] = ACTIONS(3254),
    [anon_sym_import] = ACTIONS(3254),
    [anon_sym_with] = ACTIONS(3254),
    [anon_sym_var] = ACTIONS(3254),
    [anon_sym_let] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_BANG] = ACTIONS(3254),
    [anon_sym_else] = ACTIONS(3254),
    [anon_sym_if] = ACTIONS(3254),
    [anon_sym_switch] = ACTIONS(3254),
    [anon_sym_for] = ACTIONS(3254),
    [anon_sym_LPAREN] = ACTIONS(3254),
    [anon_sym_await] = ACTIONS(3254),
    [anon_sym_while] = ACTIONS(3254),
    [anon_sym_do] = ACTIONS(3254),
    [anon_sym_try] = ACTIONS(3254),
    [anon_sym_break] = ACTIONS(3254),
    [anon_sym_continue] = ACTIONS(3254),
    [anon_sym_debugger] = ACTIONS(3254),
    [anon_sym_return] = ACTIONS(3254),
    [anon_sym_throw] = ACTIONS(3254),
    [anon_sym_SEMI] = ACTIONS(3254),
    [anon_sym_case] = ACTIONS(3254),
    [anon_sym_yield] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_LTtemplate_GT] = ACTIONS(3254),
    [anon_sym_DQUOTE] = ACTIONS(3254),
    [anon_sym_SQUOTE] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_async] = ACTIONS(3254),
    [anon_sym_function] = ACTIONS(3254),
    [anon_sym_new] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_PLUS] = ACTIONS(3254),
    [anon_sym_DASH] = ACTIONS(3254),
    [anon_sym_SLASH] = ACTIONS(3254),
    [anon_sym_LT] = ACTIONS(3254),
    [anon_sym_TILDE] = ACTIONS(3254),
    [anon_sym_void] = ACTIONS(3254),
    [anon_sym_delete] = ACTIONS(3254),
    [anon_sym_PLUS_PLUS] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3254),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3254),
    [sym_number] = ACTIONS(3254),
    [sym_private_property_identifier] = ACTIONS(3254),
    [sym_this] = ACTIONS(3254),
    [sym_super] = ACTIONS(3254),
    [sym_true] = ACTIONS(3254),
    [sym_false] = ACTIONS(3254),
    [sym_null] = ACTIONS(3254),
    [sym_undefined] = ACTIONS(3254),
    [anon_sym_AT] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_readonly] = ACTIONS(3254),
    [anon_sym_get] = ACTIONS(3254),
    [anon_sym_set] = ACTIONS(3254),
    [anon_sym_declare] = ACTIONS(3254),
    [anon_sym_public] = ACTIONS(3254),
    [anon_sym_private] = ACTIONS(3254),
    [anon_sym_protected] = ACTIONS(3254),
    [anon_sym_override] = ACTIONS(3254),
    [anon_sym_module] = ACTIONS(3254),
    [anon_sym_any] = ACTIONS(3254),
    [anon_sym_number] = ACTIONS(3254),
    [anon_sym_boolean] = ACTIONS(3254),
    [anon_sym_string] = ACTIONS(3254),
    [anon_sym_symbol] = ACTIONS(3254),
    [anon_sym_object] = ACTIONS(3254),
    [anon_sym_abstract] = ACTIONS(3254),
    [anon_sym_interface] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [sym_html_comment] = ACTIONS(5),
  },
  [1049] = {
    [sym_statement_block] = STATE(1520),
    [sym_comment] = STATE(1049),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3124),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(3256),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [1050] = {
    [sym_comment] = STATE(1050),
    [sym_identifier] = ACTIONS(3258),
    [anon_sym_export] = ACTIONS(3258),
    [anon_sym_default] = ACTIONS(3258),
    [anon_sym_type] = ACTIONS(3258),
    [anon_sym_namespace] = ACTIONS(3258),
    [anon_sym_LBRACE] = ACTIONS(3258),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_typeof] = ACTIONS(3258),
    [anon_sym_import] = ACTIONS(3258),
    [anon_sym_with] = ACTIONS(3258),
    [anon_sym_var] = ACTIONS(3258),
    [anon_sym_let] = ACTIONS(3258),
    [anon_sym_const] = ACTIONS(3258),
    [anon_sym_BANG] = ACTIONS(3258),
    [anon_sym_else] = ACTIONS(3258),
    [anon_sym_if] = ACTIONS(3258),
    [anon_sym_switch] = ACTIONS(3258),
    [anon_sym_for] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [anon_sym_await] = ACTIONS(3258),
    [anon_sym_while] = ACTIONS(3258),
    [anon_sym_do] = ACTIONS(3258),
    [anon_sym_try] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3258),
    [anon_sym_continue] = ACTIONS(3258),
    [anon_sym_debugger] = ACTIONS(3258),
    [anon_sym_return] = ACTIONS(3258),
    [anon_sym_throw] = ACTIONS(3258),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_case] = ACTIONS(3258),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_LTtemplate_GT] = ACTIONS(3258),
    [anon_sym_DQUOTE] = ACTIONS(3258),
    [anon_sym_SQUOTE] = ACTIONS(3258),
    [anon_sym_class] = ACTIONS(3258),
    [anon_sym_async] = ACTIONS(3258),
    [anon_sym_function] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3258),
    [anon_sym_using] = ACTIONS(3258),
    [anon_sym_PLUS] = ACTIONS(3258),
    [anon_sym_DASH] = ACTIONS(3258),
    [anon_sym_SLASH] = ACTIONS(3258),
    [anon_sym_LT] = ACTIONS(3258),
    [anon_sym_TILDE] = ACTIONS(3258),
    [anon_sym_void] = ACTIONS(3258),
    [anon_sym_delete] = ACTIONS(3258),
    [anon_sym_PLUS_PLUS] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3258),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [sym_number] = ACTIONS(3258),
    [sym_private_property_identifier] = ACTIONS(3258),
    [sym_this] = ACTIONS(3258),
    [sym_super] = ACTIONS(3258),
    [sym_true] = ACTIONS(3258),
    [sym_false] = ACTIONS(3258),
    [sym_null] = ACTIONS(3258),
    [sym_undefined] = ACTIONS(3258),
    [anon_sym_AT] = ACTIONS(3258),
    [anon_sym_static] = ACTIONS(3258),
    [anon_sym_readonly] = ACTIONS(3258),
    [anon_sym_get] = ACTIONS(3258),
    [anon_sym_set] = ACTIONS(3258),
    [anon_sym_declare] = ACTIONS(3258),
    [anon_sym_public] = ACTIONS(3258),
    [anon_sym_private] = ACTIONS(3258),
    [anon_sym_protected] = ACTIONS(3258),
    [anon_sym_override] = ACTIONS(3258),
    [anon_sym_module] = ACTIONS(3258),
    [anon_sym_any] = ACTIONS(3258),
    [anon_sym_number] = ACTIONS(3258),
    [anon_sym_boolean] = ACTIONS(3258),
    [anon_sym_string] = ACTIONS(3258),
    [anon_sym_symbol] = ACTIONS(3258),
    [anon_sym_object] = ACTIONS(3258),
    [anon_sym_abstract] = ACTIONS(3258),
    [anon_sym_interface] = ACTIONS(3258),
    [anon_sym_enum] = ACTIONS(3258),
    [sym_html_comment] = ACTIONS(5),
  },
  [1051] = {
    [sym_comment] = STATE(1051),
    [sym_identifier] = ACTIONS(3260),
    [anon_sym_export] = ACTIONS(3260),
    [anon_sym_default] = ACTIONS(3260),
    [anon_sym_type] = ACTIONS(3260),
    [anon_sym_namespace] = ACTIONS(3260),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_RBRACE] = ACTIONS(3260),
    [anon_sym_typeof] = ACTIONS(3260),
    [anon_sym_import] = ACTIONS(3260),
    [anon_sym_with] = ACTIONS(3260),
    [anon_sym_var] = ACTIONS(3260),
    [anon_sym_let] = ACTIONS(3260),
    [anon_sym_const] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_else] = ACTIONS(3260),
    [anon_sym_if] = ACTIONS(3260),
    [anon_sym_switch] = ACTIONS(3260),
    [anon_sym_for] = ACTIONS(3260),
    [anon_sym_LPAREN] = ACTIONS(3260),
    [anon_sym_await] = ACTIONS(3260),
    [anon_sym_while] = ACTIONS(3260),
    [anon_sym_do] = ACTIONS(3260),
    [anon_sym_try] = ACTIONS(3260),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_continue] = ACTIONS(3260),
    [anon_sym_debugger] = ACTIONS(3260),
    [anon_sym_return] = ACTIONS(3260),
    [anon_sym_throw] = ACTIONS(3260),
    [anon_sym_SEMI] = ACTIONS(3260),
    [anon_sym_case] = ACTIONS(3260),
    [anon_sym_yield] = ACTIONS(3260),
    [anon_sym_LBRACK] = ACTIONS(3260),
    [anon_sym_LTtemplate_GT] = ACTIONS(3260),
    [anon_sym_DQUOTE] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3260),
    [anon_sym_class] = ACTIONS(3260),
    [anon_sym_async] = ACTIONS(3260),
    [anon_sym_function] = ACTIONS(3260),
    [anon_sym_new] = ACTIONS(3260),
    [anon_sym_using] = ACTIONS(3260),
    [anon_sym_PLUS] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3260),
    [anon_sym_SLASH] = ACTIONS(3260),
    [anon_sym_LT] = ACTIONS(3260),
    [anon_sym_TILDE] = ACTIONS(3260),
    [anon_sym_void] = ACTIONS(3260),
    [anon_sym_delete] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3260),
    [anon_sym_DASH_DASH] = ACTIONS(3260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3260),
    [sym_number] = ACTIONS(3260),
    [sym_private_property_identifier] = ACTIONS(3260),
    [sym_this] = ACTIONS(3260),
    [sym_super] = ACTIONS(3260),
    [sym_true] = ACTIONS(3260),
    [sym_false] = ACTIONS(3260),
    [sym_null] = ACTIONS(3260),
    [sym_undefined] = ACTIONS(3260),
    [anon_sym_AT] = ACTIONS(3260),
    [anon_sym_static] = ACTIONS(3260),
    [anon_sym_readonly] = ACTIONS(3260),
    [anon_sym_get] = ACTIONS(3260),
    [anon_sym_set] = ACTIONS(3260),
    [anon_sym_declare] = ACTIONS(3260),
    [anon_sym_public] = ACTIONS(3260),
    [anon_sym_private] = ACTIONS(3260),
    [anon_sym_protected] = ACTIONS(3260),
    [anon_sym_override] = ACTIONS(3260),
    [anon_sym_module] = ACTIONS(3260),
    [anon_sym_any] = ACTIONS(3260),
    [anon_sym_number] = ACTIONS(3260),
    [anon_sym_boolean] = ACTIONS(3260),
    [anon_sym_string] = ACTIONS(3260),
    [anon_sym_symbol] = ACTIONS(3260),
    [anon_sym_object] = ACTIONS(3260),
    [anon_sym_abstract] = ACTIONS(3260),
    [anon_sym_interface] = ACTIONS(3260),
    [anon_sym_enum] = ACTIONS(3260),
    [sym_html_comment] = ACTIONS(5),
  },
  [1052] = {
    [sym_comment] = STATE(1052),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_export] = ACTIONS(3262),
    [anon_sym_default] = ACTIONS(3262),
    [anon_sym_type] = ACTIONS(3262),
    [anon_sym_namespace] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_typeof] = ACTIONS(3262),
    [anon_sym_import] = ACTIONS(3262),
    [anon_sym_with] = ACTIONS(3262),
    [anon_sym_var] = ACTIONS(3262),
    [anon_sym_let] = ACTIONS(3262),
    [anon_sym_const] = ACTIONS(3262),
    [anon_sym_BANG] = ACTIONS(3262),
    [anon_sym_else] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_await] = ACTIONS(3262),
    [anon_sym_while] = ACTIONS(3262),
    [anon_sym_do] = ACTIONS(3262),
    [anon_sym_try] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_debugger] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_throw] = ACTIONS(3262),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_case] = ACTIONS(3262),
    [anon_sym_yield] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_LTtemplate_GT] = ACTIONS(3262),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [anon_sym_class] = ACTIONS(3262),
    [anon_sym_async] = ACTIONS(3262),
    [anon_sym_function] = ACTIONS(3262),
    [anon_sym_new] = ACTIONS(3262),
    [anon_sym_using] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_SLASH] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3262),
    [anon_sym_TILDE] = ACTIONS(3262),
    [anon_sym_void] = ACTIONS(3262),
    [anon_sym_delete] = ACTIONS(3262),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3262),
    [sym_number] = ACTIONS(3262),
    [sym_private_property_identifier] = ACTIONS(3262),
    [sym_this] = ACTIONS(3262),
    [sym_super] = ACTIONS(3262),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_null] = ACTIONS(3262),
    [sym_undefined] = ACTIONS(3262),
    [anon_sym_AT] = ACTIONS(3262),
    [anon_sym_static] = ACTIONS(3262),
    [anon_sym_readonly] = ACTIONS(3262),
    [anon_sym_get] = ACTIONS(3262),
    [anon_sym_set] = ACTIONS(3262),
    [anon_sym_declare] = ACTIONS(3262),
    [anon_sym_public] = ACTIONS(3262),
    [anon_sym_private] = ACTIONS(3262),
    [anon_sym_protected] = ACTIONS(3262),
    [anon_sym_override] = ACTIONS(3262),
    [anon_sym_module] = ACTIONS(3262),
    [anon_sym_any] = ACTIONS(3262),
    [anon_sym_number] = ACTIONS(3262),
    [anon_sym_boolean] = ACTIONS(3262),
    [anon_sym_string] = ACTIONS(3262),
    [anon_sym_symbol] = ACTIONS(3262),
    [anon_sym_object] = ACTIONS(3262),
    [anon_sym_abstract] = ACTIONS(3262),
    [anon_sym_interface] = ACTIONS(3262),
    [anon_sym_enum] = ACTIONS(3262),
    [sym_html_comment] = ACTIONS(5),
  },
  [1053] = {
    [sym_comment] = STATE(1053),
    [sym_identifier] = ACTIONS(3264),
    [anon_sym_export] = ACTIONS(3264),
    [anon_sym_default] = ACTIONS(3264),
    [anon_sym_type] = ACTIONS(3264),
    [anon_sym_namespace] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_RBRACE] = ACTIONS(3264),
    [anon_sym_typeof] = ACTIONS(3264),
    [anon_sym_import] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3264),
    [anon_sym_var] = ACTIONS(3264),
    [anon_sym_let] = ACTIONS(3264),
    [anon_sym_const] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_else] = ACTIONS(3264),
    [anon_sym_if] = ACTIONS(3264),
    [anon_sym_switch] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3264),
    [anon_sym_await] = ACTIONS(3264),
    [anon_sym_while] = ACTIONS(3264),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_try] = ACTIONS(3264),
    [anon_sym_break] = ACTIONS(3264),
    [anon_sym_continue] = ACTIONS(3264),
    [anon_sym_debugger] = ACTIONS(3264),
    [anon_sym_return] = ACTIONS(3264),
    [anon_sym_throw] = ACTIONS(3264),
    [anon_sym_SEMI] = ACTIONS(3264),
    [anon_sym_case] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3264),
    [anon_sym_LBRACK] = ACTIONS(3264),
    [anon_sym_LTtemplate_GT] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(3264),
    [anon_sym_SQUOTE] = ACTIONS(3264),
    [anon_sym_class] = ACTIONS(3264),
    [anon_sym_async] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3264),
    [anon_sym_using] = ACTIONS(3264),
    [anon_sym_PLUS] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3264),
    [anon_sym_SLASH] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_TILDE] = ACTIONS(3264),
    [anon_sym_void] = ACTIONS(3264),
    [anon_sym_delete] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3264),
    [anon_sym_DASH_DASH] = ACTIONS(3264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3264),
    [sym_number] = ACTIONS(3264),
    [sym_private_property_identifier] = ACTIONS(3264),
    [sym_this] = ACTIONS(3264),
    [sym_super] = ACTIONS(3264),
    [sym_true] = ACTIONS(3264),
    [sym_false] = ACTIONS(3264),
    [sym_null] = ACTIONS(3264),
    [sym_undefined] = ACTIONS(3264),
    [anon_sym_AT] = ACTIONS(3264),
    [anon_sym_static] = ACTIONS(3264),
    [anon_sym_readonly] = ACTIONS(3264),
    [anon_sym_get] = ACTIONS(3264),
    [anon_sym_set] = ACTIONS(3264),
    [anon_sym_declare] = ACTIONS(3264),
    [anon_sym_public] = ACTIONS(3264),
    [anon_sym_private] = ACTIONS(3264),
    [anon_sym_protected] = ACTIONS(3264),
    [anon_sym_override] = ACTIONS(3264),
    [anon_sym_module] = ACTIONS(3264),
    [anon_sym_any] = ACTIONS(3264),
    [anon_sym_number] = ACTIONS(3264),
    [anon_sym_boolean] = ACTIONS(3264),
    [anon_sym_string] = ACTIONS(3264),
    [anon_sym_symbol] = ACTIONS(3264),
    [anon_sym_object] = ACTIONS(3264),
    [anon_sym_abstract] = ACTIONS(3264),
    [anon_sym_interface] = ACTIONS(3264),
    [anon_sym_enum] = ACTIONS(3264),
    [sym_html_comment] = ACTIONS(5),
  },
  [1054] = {
    [sym_comment] = STATE(1054),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_export] = ACTIONS(3266),
    [anon_sym_default] = ACTIONS(3266),
    [anon_sym_type] = ACTIONS(3266),
    [anon_sym_namespace] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_typeof] = ACTIONS(3266),
    [anon_sym_import] = ACTIONS(3266),
    [anon_sym_with] = ACTIONS(3266),
    [anon_sym_var] = ACTIONS(3266),
    [anon_sym_let] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_else] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_await] = ACTIONS(3266),
    [anon_sym_while] = ACTIONS(3266),
    [anon_sym_do] = ACTIONS(3266),
    [anon_sym_try] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_debugger] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_throw] = ACTIONS(3266),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_case] = ACTIONS(3266),
    [anon_sym_yield] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_LTtemplate_GT] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_class] = ACTIONS(3266),
    [anon_sym_async] = ACTIONS(3266),
    [anon_sym_function] = ACTIONS(3266),
    [anon_sym_new] = ACTIONS(3266),
    [anon_sym_using] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_SLASH] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_void] = ACTIONS(3266),
    [anon_sym_delete] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3266),
    [sym_number] = ACTIONS(3266),
    [sym_private_property_identifier] = ACTIONS(3266),
    [sym_this] = ACTIONS(3266),
    [sym_super] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_null] = ACTIONS(3266),
    [sym_undefined] = ACTIONS(3266),
    [anon_sym_AT] = ACTIONS(3266),
    [anon_sym_static] = ACTIONS(3266),
    [anon_sym_readonly] = ACTIONS(3266),
    [anon_sym_get] = ACTIONS(3266),
    [anon_sym_set] = ACTIONS(3266),
    [anon_sym_declare] = ACTIONS(3266),
    [anon_sym_public] = ACTIONS(3266),
    [anon_sym_private] = ACTIONS(3266),
    [anon_sym_protected] = ACTIONS(3266),
    [anon_sym_override] = ACTIONS(3266),
    [anon_sym_module] = ACTIONS(3266),
    [anon_sym_any] = ACTIONS(3266),
    [anon_sym_number] = ACTIONS(3266),
    [anon_sym_boolean] = ACTIONS(3266),
    [anon_sym_string] = ACTIONS(3266),
    [anon_sym_symbol] = ACTIONS(3266),
    [anon_sym_object] = ACTIONS(3266),
    [anon_sym_abstract] = ACTIONS(3266),
    [anon_sym_interface] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [sym_html_comment] = ACTIONS(5),
  },
  [1055] = {
    [sym_comment] = STATE(1055),
    [sym_identifier] = ACTIONS(3268),
    [anon_sym_export] = ACTIONS(3268),
    [anon_sym_default] = ACTIONS(3268),
    [anon_sym_type] = ACTIONS(3268),
    [anon_sym_namespace] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3268),
    [anon_sym_typeof] = ACTIONS(3268),
    [anon_sym_import] = ACTIONS(3268),
    [anon_sym_with] = ACTIONS(3268),
    [anon_sym_var] = ACTIONS(3268),
    [anon_sym_let] = ACTIONS(3268),
    [anon_sym_const] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_else] = ACTIONS(3268),
    [anon_sym_if] = ACTIONS(3268),
    [anon_sym_switch] = ACTIONS(3268),
    [anon_sym_for] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3268),
    [anon_sym_await] = ACTIONS(3268),
    [anon_sym_while] = ACTIONS(3268),
    [anon_sym_do] = ACTIONS(3268),
    [anon_sym_try] = ACTIONS(3268),
    [anon_sym_break] = ACTIONS(3268),
    [anon_sym_continue] = ACTIONS(3268),
    [anon_sym_debugger] = ACTIONS(3268),
    [anon_sym_return] = ACTIONS(3268),
    [anon_sym_throw] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_case] = ACTIONS(3268),
    [anon_sym_yield] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_LTtemplate_GT] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_class] = ACTIONS(3268),
    [anon_sym_async] = ACTIONS(3268),
    [anon_sym_function] = ACTIONS(3268),
    [anon_sym_new] = ACTIONS(3268),
    [anon_sym_using] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_void] = ACTIONS(3268),
    [anon_sym_delete] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3268),
    [sym_number] = ACTIONS(3268),
    [sym_private_property_identifier] = ACTIONS(3268),
    [sym_this] = ACTIONS(3268),
    [sym_super] = ACTIONS(3268),
    [sym_true] = ACTIONS(3268),
    [sym_false] = ACTIONS(3268),
    [sym_null] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_AT] = ACTIONS(3268),
    [anon_sym_static] = ACTIONS(3268),
    [anon_sym_readonly] = ACTIONS(3268),
    [anon_sym_get] = ACTIONS(3268),
    [anon_sym_set] = ACTIONS(3268),
    [anon_sym_declare] = ACTIONS(3268),
    [anon_sym_public] = ACTIONS(3268),
    [anon_sym_private] = ACTIONS(3268),
    [anon_sym_protected] = ACTIONS(3268),
    [anon_sym_override] = ACTIONS(3268),
    [anon_sym_module] = ACTIONS(3268),
    [anon_sym_any] = ACTIONS(3268),
    [anon_sym_number] = ACTIONS(3268),
    [anon_sym_boolean] = ACTIONS(3268),
    [anon_sym_string] = ACTIONS(3268),
    [anon_sym_symbol] = ACTIONS(3268),
    [anon_sym_object] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(3268),
    [anon_sym_interface] = ACTIONS(3268),
    [anon_sym_enum] = ACTIONS(3268),
    [sym_html_comment] = ACTIONS(5),
  },
  [1056] = {
    [sym_comment] = STATE(1056),
    [sym_identifier] = ACTIONS(2137),
    [anon_sym_export] = ACTIONS(2137),
    [anon_sym_default] = ACTIONS(2137),
    [anon_sym_type] = ACTIONS(2137),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_typeof] = ACTIONS(2137),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_with] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2137),
    [anon_sym_let] = ACTIONS(2137),
    [anon_sym_const] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2137),
    [anon_sym_if] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2137),
    [anon_sym_for] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2137),
    [anon_sym_await] = ACTIONS(2137),
    [anon_sym_while] = ACTIONS(2137),
    [anon_sym_do] = ACTIONS(2137),
    [anon_sym_try] = ACTIONS(2137),
    [anon_sym_break] = ACTIONS(2137),
    [anon_sym_continue] = ACTIONS(2137),
    [anon_sym_debugger] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2137),
    [anon_sym_throw] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym_case] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_LTtemplate_GT] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_SQUOTE] = ACTIONS(2137),
    [anon_sym_class] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(2137),
    [anon_sym_new] = ACTIONS(2137),
    [anon_sym_using] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(2137),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_TILDE] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2137),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [sym_number] = ACTIONS(2137),
    [sym_private_property_identifier] = ACTIONS(2137),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(2137),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(2137),
    [anon_sym_static] = ACTIONS(2137),
    [anon_sym_readonly] = ACTIONS(2137),
    [anon_sym_get] = ACTIONS(2137),
    [anon_sym_set] = ACTIONS(2137),
    [anon_sym_declare] = ACTIONS(2137),
    [anon_sym_public] = ACTIONS(2137),
    [anon_sym_private] = ACTIONS(2137),
    [anon_sym_protected] = ACTIONS(2137),
    [anon_sym_override] = ACTIONS(2137),
    [anon_sym_module] = ACTIONS(2137),
    [anon_sym_any] = ACTIONS(2137),
    [anon_sym_number] = ACTIONS(2137),
    [anon_sym_boolean] = ACTIONS(2137),
    [anon_sym_string] = ACTIONS(2137),
    [anon_sym_symbol] = ACTIONS(2137),
    [anon_sym_object] = ACTIONS(2137),
    [anon_sym_abstract] = ACTIONS(2137),
    [anon_sym_interface] = ACTIONS(2137),
    [anon_sym_enum] = ACTIONS(2137),
    [sym__automatic_semicolon] = ACTIONS(2281),
    [sym_html_comment] = ACTIONS(5),
  },
  [1057] = {
    [sym_comment] = STATE(1057),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3270),
    [sym_html_comment] = ACTIONS(5),
  },
  [1058] = {
    [sym_comment] = STATE(1058),
    [sym_identifier] = ACTIONS(3094),
    [anon_sym_export] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_type] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3094),
    [anon_sym_typeof] = ACTIONS(3094),
    [anon_sym_import] = ACTIONS(3094),
    [anon_sym_with] = ACTIONS(3094),
    [anon_sym_var] = ACTIONS(3094),
    [anon_sym_let] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3094),
    [anon_sym_await] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_debugger] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_finally] = ACTIONS(3094),
    [anon_sym_yield] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_LTtemplate_GT] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_async] = ACTIONS(3094),
    [anon_sym_function] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_void] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3094),
    [sym_number] = ACTIONS(3094),
    [sym_private_property_identifier] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
    [sym_super] = ACTIONS(3094),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_undefined] = ACTIONS(3094),
    [anon_sym_AT] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_readonly] = ACTIONS(3094),
    [anon_sym_get] = ACTIONS(3094),
    [anon_sym_set] = ACTIONS(3094),
    [anon_sym_declare] = ACTIONS(3094),
    [anon_sym_public] = ACTIONS(3094),
    [anon_sym_private] = ACTIONS(3094),
    [anon_sym_protected] = ACTIONS(3094),
    [anon_sym_override] = ACTIONS(3094),
    [anon_sym_module] = ACTIONS(3094),
    [anon_sym_any] = ACTIONS(3094),
    [anon_sym_number] = ACTIONS(3094),
    [anon_sym_boolean] = ACTIONS(3094),
    [anon_sym_string] = ACTIONS(3094),
    [anon_sym_symbol] = ACTIONS(3094),
    [anon_sym_object] = ACTIONS(3094),
    [anon_sym_abstract] = ACTIONS(3094),
    [anon_sym_interface] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [sym_html_comment] = ACTIONS(5),
  },
  [1059] = {
    [sym_comment] = STATE(1059),
    [sym_identifier] = ACTIONS(3272),
    [anon_sym_export] = ACTIONS(3272),
    [anon_sym_default] = ACTIONS(3272),
    [anon_sym_type] = ACTIONS(3272),
    [anon_sym_namespace] = ACTIONS(3272),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_typeof] = ACTIONS(3272),
    [anon_sym_import] = ACTIONS(3272),
    [anon_sym_with] = ACTIONS(3272),
    [anon_sym_var] = ACTIONS(3272),
    [anon_sym_let] = ACTIONS(3272),
    [anon_sym_const] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_else] = ACTIONS(3272),
    [anon_sym_if] = ACTIONS(3272),
    [anon_sym_switch] = ACTIONS(3272),
    [anon_sym_for] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3272),
    [anon_sym_await] = ACTIONS(3272),
    [anon_sym_while] = ACTIONS(3272),
    [anon_sym_do] = ACTIONS(3272),
    [anon_sym_try] = ACTIONS(3272),
    [anon_sym_break] = ACTIONS(3272),
    [anon_sym_continue] = ACTIONS(3272),
    [anon_sym_debugger] = ACTIONS(3272),
    [anon_sym_return] = ACTIONS(3272),
    [anon_sym_throw] = ACTIONS(3272),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym_case] = ACTIONS(3272),
    [anon_sym_yield] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_LTtemplate_GT] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_class] = ACTIONS(3272),
    [anon_sym_async] = ACTIONS(3272),
    [anon_sym_function] = ACTIONS(3272),
    [anon_sym_new] = ACTIONS(3272),
    [anon_sym_using] = ACTIONS(3272),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_SLASH] = ACTIONS(3272),
    [anon_sym_LT] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_void] = ACTIONS(3272),
    [anon_sym_delete] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3272),
    [sym_number] = ACTIONS(3272),
    [sym_private_property_identifier] = ACTIONS(3272),
    [sym_this] = ACTIONS(3272),
    [sym_super] = ACTIONS(3272),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_undefined] = ACTIONS(3272),
    [anon_sym_AT] = ACTIONS(3272),
    [anon_sym_static] = ACTIONS(3272),
    [anon_sym_readonly] = ACTIONS(3272),
    [anon_sym_get] = ACTIONS(3272),
    [anon_sym_set] = ACTIONS(3272),
    [anon_sym_declare] = ACTIONS(3272),
    [anon_sym_public] = ACTIONS(3272),
    [anon_sym_private] = ACTIONS(3272),
    [anon_sym_protected] = ACTIONS(3272),
    [anon_sym_override] = ACTIONS(3272),
    [anon_sym_module] = ACTIONS(3272),
    [anon_sym_any] = ACTIONS(3272),
    [anon_sym_number] = ACTIONS(3272),
    [anon_sym_boolean] = ACTIONS(3272),
    [anon_sym_string] = ACTIONS(3272),
    [anon_sym_symbol] = ACTIONS(3272),
    [anon_sym_object] = ACTIONS(3272),
    [anon_sym_abstract] = ACTIONS(3272),
    [anon_sym_interface] = ACTIONS(3272),
    [anon_sym_enum] = ACTIONS(3272),
    [sym_html_comment] = ACTIONS(5),
  },
  [1060] = {
    [sym_comment] = STATE(1060),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_export] = ACTIONS(3274),
    [anon_sym_default] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_namespace] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_typeof] = ACTIONS(3274),
    [anon_sym_import] = ACTIONS(3274),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_var] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_const] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_else] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_switch] = ACTIONS(3274),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_await] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_break] = ACTIONS(3274),
    [anon_sym_continue] = ACTIONS(3274),
    [anon_sym_debugger] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_throw] = ACTIONS(3274),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_case] = ACTIONS(3274),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LTtemplate_GT] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_SQUOTE] = ACTIONS(3274),
    [anon_sym_class] = ACTIONS(3274),
    [anon_sym_async] = ACTIONS(3274),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_using] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_SLASH] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_void] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3274),
    [sym_number] = ACTIONS(3274),
    [sym_private_property_identifier] = ACTIONS(3274),
    [sym_this] = ACTIONS(3274),
    [sym_super] = ACTIONS(3274),
    [sym_true] = ACTIONS(3274),
    [sym_false] = ACTIONS(3274),
    [sym_null] = ACTIONS(3274),
    [sym_undefined] = ACTIONS(3274),
    [anon_sym_AT] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3274),
    [anon_sym_readonly] = ACTIONS(3274),
    [anon_sym_get] = ACTIONS(3274),
    [anon_sym_set] = ACTIONS(3274),
    [anon_sym_declare] = ACTIONS(3274),
    [anon_sym_public] = ACTIONS(3274),
    [anon_sym_private] = ACTIONS(3274),
    [anon_sym_protected] = ACTIONS(3274),
    [anon_sym_override] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_any] = ACTIONS(3274),
    [anon_sym_number] = ACTIONS(3274),
    [anon_sym_boolean] = ACTIONS(3274),
    [anon_sym_string] = ACTIONS(3274),
    [anon_sym_symbol] = ACTIONS(3274),
    [anon_sym_object] = ACTIONS(3274),
    [anon_sym_abstract] = ACTIONS(3274),
    [anon_sym_interface] = ACTIONS(3274),
    [anon_sym_enum] = ACTIONS(3274),
    [sym_html_comment] = ACTIONS(5),
  },
  [1061] = {
    [sym_comment] = STATE(1061),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [sym_html_comment] = ACTIONS(5),
  },
  [1062] = {
    [sym_comment] = STATE(1062),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3276),
    [sym_html_comment] = ACTIONS(5),
  },
  [1063] = {
    [sym_comment] = STATE(1063),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [1064] = {
    [sym_comment] = STATE(1064),
    [sym_identifier] = ACTIONS(3272),
    [anon_sym_export] = ACTIONS(3272),
    [anon_sym_default] = ACTIONS(3272),
    [anon_sym_type] = ACTIONS(3272),
    [anon_sym_namespace] = ACTIONS(3272),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_typeof] = ACTIONS(3272),
    [anon_sym_import] = ACTIONS(3272),
    [anon_sym_with] = ACTIONS(3272),
    [anon_sym_var] = ACTIONS(3272),
    [anon_sym_let] = ACTIONS(3272),
    [anon_sym_const] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_else] = ACTIONS(3272),
    [anon_sym_if] = ACTIONS(3272),
    [anon_sym_switch] = ACTIONS(3272),
    [anon_sym_for] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3272),
    [anon_sym_await] = ACTIONS(3272),
    [anon_sym_while] = ACTIONS(3272),
    [anon_sym_do] = ACTIONS(3272),
    [anon_sym_try] = ACTIONS(3272),
    [anon_sym_break] = ACTIONS(3272),
    [anon_sym_continue] = ACTIONS(3272),
    [anon_sym_debugger] = ACTIONS(3272),
    [anon_sym_return] = ACTIONS(3272),
    [anon_sym_throw] = ACTIONS(3272),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym_case] = ACTIONS(3272),
    [anon_sym_yield] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_LTtemplate_GT] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_class] = ACTIONS(3272),
    [anon_sym_async] = ACTIONS(3272),
    [anon_sym_function] = ACTIONS(3272),
    [anon_sym_new] = ACTIONS(3272),
    [anon_sym_using] = ACTIONS(3272),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_SLASH] = ACTIONS(3272),
    [anon_sym_LT] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_void] = ACTIONS(3272),
    [anon_sym_delete] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3272),
    [sym_number] = ACTIONS(3272),
    [sym_private_property_identifier] = ACTIONS(3272),
    [sym_this] = ACTIONS(3272),
    [sym_super] = ACTIONS(3272),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_undefined] = ACTIONS(3272),
    [anon_sym_AT] = ACTIONS(3272),
    [anon_sym_static] = ACTIONS(3272),
    [anon_sym_readonly] = ACTIONS(3272),
    [anon_sym_get] = ACTIONS(3272),
    [anon_sym_set] = ACTIONS(3272),
    [anon_sym_declare] = ACTIONS(3272),
    [anon_sym_public] = ACTIONS(3272),
    [anon_sym_private] = ACTIONS(3272),
    [anon_sym_protected] = ACTIONS(3272),
    [anon_sym_override] = ACTIONS(3272),
    [anon_sym_module] = ACTIONS(3272),
    [anon_sym_any] = ACTIONS(3272),
    [anon_sym_number] = ACTIONS(3272),
    [anon_sym_boolean] = ACTIONS(3272),
    [anon_sym_string] = ACTIONS(3272),
    [anon_sym_symbol] = ACTIONS(3272),
    [anon_sym_object] = ACTIONS(3272),
    [anon_sym_abstract] = ACTIONS(3272),
    [anon_sym_interface] = ACTIONS(3272),
    [anon_sym_enum] = ACTIONS(3272),
    [sym_html_comment] = ACTIONS(5),
  },
  [1065] = {
    [sym_comment] = STATE(1065),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_finally] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1066] = {
    [sym_comment] = STATE(1066),
    [sym_identifier] = ACTIONS(3278),
    [anon_sym_export] = ACTIONS(3278),
    [anon_sym_default] = ACTIONS(3278),
    [anon_sym_type] = ACTIONS(3278),
    [anon_sym_namespace] = ACTIONS(3278),
    [anon_sym_LBRACE] = ACTIONS(3278),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_typeof] = ACTIONS(3278),
    [anon_sym_import] = ACTIONS(3278),
    [anon_sym_with] = ACTIONS(3278),
    [anon_sym_var] = ACTIONS(3278),
    [anon_sym_let] = ACTIONS(3278),
    [anon_sym_const] = ACTIONS(3278),
    [anon_sym_BANG] = ACTIONS(3278),
    [anon_sym_else] = ACTIONS(3278),
    [anon_sym_if] = ACTIONS(3278),
    [anon_sym_switch] = ACTIONS(3278),
    [anon_sym_for] = ACTIONS(3278),
    [anon_sym_LPAREN] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3278),
    [anon_sym_while] = ACTIONS(3278),
    [anon_sym_do] = ACTIONS(3278),
    [anon_sym_try] = ACTIONS(3278),
    [anon_sym_break] = ACTIONS(3278),
    [anon_sym_continue] = ACTIONS(3278),
    [anon_sym_debugger] = ACTIONS(3278),
    [anon_sym_return] = ACTIONS(3278),
    [anon_sym_throw] = ACTIONS(3278),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym_case] = ACTIONS(3278),
    [anon_sym_yield] = ACTIONS(3278),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_LTtemplate_GT] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_class] = ACTIONS(3278),
    [anon_sym_async] = ACTIONS(3278),
    [anon_sym_function] = ACTIONS(3278),
    [anon_sym_new] = ACTIONS(3278),
    [anon_sym_using] = ACTIONS(3278),
    [anon_sym_PLUS] = ACTIONS(3278),
    [anon_sym_DASH] = ACTIONS(3278),
    [anon_sym_SLASH] = ACTIONS(3278),
    [anon_sym_LT] = ACTIONS(3278),
    [anon_sym_TILDE] = ACTIONS(3278),
    [anon_sym_void] = ACTIONS(3278),
    [anon_sym_delete] = ACTIONS(3278),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3278),
    [sym_number] = ACTIONS(3278),
    [sym_private_property_identifier] = ACTIONS(3278),
    [sym_this] = ACTIONS(3278),
    [sym_super] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_null] = ACTIONS(3278),
    [sym_undefined] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3278),
    [anon_sym_static] = ACTIONS(3278),
    [anon_sym_readonly] = ACTIONS(3278),
    [anon_sym_get] = ACTIONS(3278),
    [anon_sym_set] = ACTIONS(3278),
    [anon_sym_declare] = ACTIONS(3278),
    [anon_sym_public] = ACTIONS(3278),
    [anon_sym_private] = ACTIONS(3278),
    [anon_sym_protected] = ACTIONS(3278),
    [anon_sym_override] = ACTIONS(3278),
    [anon_sym_module] = ACTIONS(3278),
    [anon_sym_any] = ACTIONS(3278),
    [anon_sym_number] = ACTIONS(3278),
    [anon_sym_boolean] = ACTIONS(3278),
    [anon_sym_string] = ACTIONS(3278),
    [anon_sym_symbol] = ACTIONS(3278),
    [anon_sym_object] = ACTIONS(3278),
    [anon_sym_abstract] = ACTIONS(3278),
    [anon_sym_interface] = ACTIONS(3278),
    [anon_sym_enum] = ACTIONS(3278),
    [sym_html_comment] = ACTIONS(5),
  },
  [1067] = {
    [sym_comment] = STATE(1067),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1068] = {
    [sym_statement_block] = STATE(1351),
    [sym_comment] = STATE(1068),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3090),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [1069] = {
    [sym_comment] = STATE(1069),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_export] = ACTIONS(3280),
    [anon_sym_default] = ACTIONS(3280),
    [anon_sym_type] = ACTIONS(3280),
    [anon_sym_namespace] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_RBRACE] = ACTIONS(3280),
    [anon_sym_typeof] = ACTIONS(3280),
    [anon_sym_import] = ACTIONS(3280),
    [anon_sym_with] = ACTIONS(3280),
    [anon_sym_var] = ACTIONS(3280),
    [anon_sym_let] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_BANG] = ACTIONS(3280),
    [anon_sym_else] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_switch] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_LPAREN] = ACTIONS(3280),
    [anon_sym_await] = ACTIONS(3280),
    [anon_sym_while] = ACTIONS(3280),
    [anon_sym_do] = ACTIONS(3280),
    [anon_sym_try] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_debugger] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_throw] = ACTIONS(3280),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_case] = ACTIONS(3280),
    [anon_sym_yield] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_LTtemplate_GT] = ACTIONS(3280),
    [anon_sym_DQUOTE] = ACTIONS(3280),
    [anon_sym_SQUOTE] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_async] = ACTIONS(3280),
    [anon_sym_function] = ACTIONS(3280),
    [anon_sym_new] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_SLASH] = ACTIONS(3280),
    [anon_sym_LT] = ACTIONS(3280),
    [anon_sym_TILDE] = ACTIONS(3280),
    [anon_sym_void] = ACTIONS(3280),
    [anon_sym_delete] = ACTIONS(3280),
    [anon_sym_PLUS_PLUS] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3280),
    [sym_number] = ACTIONS(3280),
    [sym_private_property_identifier] = ACTIONS(3280),
    [sym_this] = ACTIONS(3280),
    [sym_super] = ACTIONS(3280),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_null] = ACTIONS(3280),
    [sym_undefined] = ACTIONS(3280),
    [anon_sym_AT] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_readonly] = ACTIONS(3280),
    [anon_sym_get] = ACTIONS(3280),
    [anon_sym_set] = ACTIONS(3280),
    [anon_sym_declare] = ACTIONS(3280),
    [anon_sym_public] = ACTIONS(3280),
    [anon_sym_private] = ACTIONS(3280),
    [anon_sym_protected] = ACTIONS(3280),
    [anon_sym_override] = ACTIONS(3280),
    [anon_sym_module] = ACTIONS(3280),
    [anon_sym_any] = ACTIONS(3280),
    [anon_sym_number] = ACTIONS(3280),
    [anon_sym_boolean] = ACTIONS(3280),
    [anon_sym_string] = ACTIONS(3280),
    [anon_sym_symbol] = ACTIONS(3280),
    [anon_sym_object] = ACTIONS(3280),
    [anon_sym_abstract] = ACTIONS(3280),
    [anon_sym_interface] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [sym_html_comment] = ACTIONS(5),
  },
  [1070] = {
    [sym_comment] = STATE(1070),
    [ts_builtin_sym_end] = ACTIONS(2329),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_export] = ACTIONS(2241),
    [anon_sym_type] = ACTIONS(2241),
    [anon_sym_namespace] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_typeof] = ACTIONS(2241),
    [anon_sym_import] = ACTIONS(2241),
    [anon_sym_with] = ACTIONS(2241),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_const] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_else] = ACTIONS(2241),
    [anon_sym_if] = ACTIONS(2241),
    [anon_sym_switch] = ACTIONS(2241),
    [anon_sym_for] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_await] = ACTIONS(2241),
    [anon_sym_while] = ACTIONS(2241),
    [anon_sym_do] = ACTIONS(2241),
    [anon_sym_try] = ACTIONS(2241),
    [anon_sym_break] = ACTIONS(2241),
    [anon_sym_continue] = ACTIONS(2241),
    [anon_sym_debugger] = ACTIONS(2241),
    [anon_sym_return] = ACTIONS(2241),
    [anon_sym_throw] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_yield] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_LTtemplate_GT] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_class] = ACTIONS(2241),
    [anon_sym_async] = ACTIONS(2241),
    [anon_sym_function] = ACTIONS(2241),
    [anon_sym_new] = ACTIONS(2241),
    [anon_sym_using] = ACTIONS(2241),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_void] = ACTIONS(2241),
    [anon_sym_delete] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2241),
    [sym_number] = ACTIONS(2241),
    [sym_private_property_identifier] = ACTIONS(2241),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(2241),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(2241),
    [anon_sym_static] = ACTIONS(2241),
    [anon_sym_readonly] = ACTIONS(2241),
    [anon_sym_get] = ACTIONS(2241),
    [anon_sym_set] = ACTIONS(2241),
    [anon_sym_declare] = ACTIONS(2241),
    [anon_sym_public] = ACTIONS(2241),
    [anon_sym_private] = ACTIONS(2241),
    [anon_sym_protected] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_module] = ACTIONS(2241),
    [anon_sym_any] = ACTIONS(2241),
    [anon_sym_number] = ACTIONS(2241),
    [anon_sym_boolean] = ACTIONS(2241),
    [anon_sym_string] = ACTIONS(2241),
    [anon_sym_symbol] = ACTIONS(2241),
    [anon_sym_object] = ACTIONS(2241),
    [anon_sym_abstract] = ACTIONS(2241),
    [anon_sym_interface] = ACTIONS(2241),
    [anon_sym_enum] = ACTIONS(2241),
    [sym__automatic_semicolon] = ACTIONS(2331),
    [sym_html_comment] = ACTIONS(5),
  },
  [1071] = {
    [sym_comment] = STATE(1071),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3282),
    [sym_html_comment] = ACTIONS(5),
  },
  [1072] = {
    [sym_comment] = STATE(1072),
    [ts_builtin_sym_end] = ACTIONS(2275),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_export] = ACTIONS(2189),
    [anon_sym_type] = ACTIONS(2189),
    [anon_sym_namespace] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_import] = ACTIONS(2189),
    [anon_sym_with] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_else] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2189),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_debugger] = ACTIONS(2189),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2189),
    [anon_sym_LTtemplate_GT] = ACTIONS(2189),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_class] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_function] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_using] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_void] = ACTIONS(2189),
    [anon_sym_delete] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2189),
    [sym_number] = ACTIONS(2189),
    [sym_private_property_identifier] = ACTIONS(2189),
    [sym_this] = ACTIONS(2189),
    [sym_super] = ACTIONS(2189),
    [sym_true] = ACTIONS(2189),
    [sym_false] = ACTIONS(2189),
    [sym_null] = ACTIONS(2189),
    [sym_undefined] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_declare] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_module] = ACTIONS(2189),
    [anon_sym_any] = ACTIONS(2189),
    [anon_sym_number] = ACTIONS(2189),
    [anon_sym_boolean] = ACTIONS(2189),
    [anon_sym_string] = ACTIONS(2189),
    [anon_sym_symbol] = ACTIONS(2189),
    [anon_sym_object] = ACTIONS(2189),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_interface] = ACTIONS(2189),
    [anon_sym_enum] = ACTIONS(2189),
    [sym__automatic_semicolon] = ACTIONS(2277),
    [sym_html_comment] = ACTIONS(5),
  },
  [1073] = {
    [sym_comment] = STATE(1073),
    [sym_identifier] = ACTIONS(3284),
    [anon_sym_export] = ACTIONS(3284),
    [anon_sym_default] = ACTIONS(3284),
    [anon_sym_type] = ACTIONS(3284),
    [anon_sym_namespace] = ACTIONS(3284),
    [anon_sym_LBRACE] = ACTIONS(3284),
    [anon_sym_RBRACE] = ACTIONS(3284),
    [anon_sym_typeof] = ACTIONS(3284),
    [anon_sym_import] = ACTIONS(3284),
    [anon_sym_with] = ACTIONS(3284),
    [anon_sym_var] = ACTIONS(3284),
    [anon_sym_let] = ACTIONS(3284),
    [anon_sym_const] = ACTIONS(3284),
    [anon_sym_BANG] = ACTIONS(3284),
    [anon_sym_else] = ACTIONS(3284),
    [anon_sym_if] = ACTIONS(3284),
    [anon_sym_switch] = ACTIONS(3284),
    [anon_sym_for] = ACTIONS(3284),
    [anon_sym_LPAREN] = ACTIONS(3284),
    [anon_sym_await] = ACTIONS(3284),
    [anon_sym_while] = ACTIONS(3284),
    [anon_sym_do] = ACTIONS(3284),
    [anon_sym_try] = ACTIONS(3284),
    [anon_sym_break] = ACTIONS(3284),
    [anon_sym_continue] = ACTIONS(3284),
    [anon_sym_debugger] = ACTIONS(3284),
    [anon_sym_return] = ACTIONS(3284),
    [anon_sym_throw] = ACTIONS(3284),
    [anon_sym_SEMI] = ACTIONS(3284),
    [anon_sym_case] = ACTIONS(3284),
    [anon_sym_yield] = ACTIONS(3284),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [anon_sym_LTtemplate_GT] = ACTIONS(3284),
    [anon_sym_DQUOTE] = ACTIONS(3284),
    [anon_sym_SQUOTE] = ACTIONS(3284),
    [anon_sym_class] = ACTIONS(3284),
    [anon_sym_async] = ACTIONS(3284),
    [anon_sym_function] = ACTIONS(3284),
    [anon_sym_new] = ACTIONS(3284),
    [anon_sym_using] = ACTIONS(3284),
    [anon_sym_PLUS] = ACTIONS(3284),
    [anon_sym_DASH] = ACTIONS(3284),
    [anon_sym_SLASH] = ACTIONS(3284),
    [anon_sym_LT] = ACTIONS(3284),
    [anon_sym_TILDE] = ACTIONS(3284),
    [anon_sym_void] = ACTIONS(3284),
    [anon_sym_delete] = ACTIONS(3284),
    [anon_sym_PLUS_PLUS] = ACTIONS(3284),
    [anon_sym_DASH_DASH] = ACTIONS(3284),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3284),
    [sym_number] = ACTIONS(3284),
    [sym_private_property_identifier] = ACTIONS(3284),
    [sym_this] = ACTIONS(3284),
    [sym_super] = ACTIONS(3284),
    [sym_true] = ACTIONS(3284),
    [sym_false] = ACTIONS(3284),
    [sym_null] = ACTIONS(3284),
    [sym_undefined] = ACTIONS(3284),
    [anon_sym_AT] = ACTIONS(3284),
    [anon_sym_static] = ACTIONS(3284),
    [anon_sym_readonly] = ACTIONS(3284),
    [anon_sym_get] = ACTIONS(3284),
    [anon_sym_set] = ACTIONS(3284),
    [anon_sym_declare] = ACTIONS(3284),
    [anon_sym_public] = ACTIONS(3284),
    [anon_sym_private] = ACTIONS(3284),
    [anon_sym_protected] = ACTIONS(3284),
    [anon_sym_override] = ACTIONS(3284),
    [anon_sym_module] = ACTIONS(3284),
    [anon_sym_any] = ACTIONS(3284),
    [anon_sym_number] = ACTIONS(3284),
    [anon_sym_boolean] = ACTIONS(3284),
    [anon_sym_string] = ACTIONS(3284),
    [anon_sym_symbol] = ACTIONS(3284),
    [anon_sym_object] = ACTIONS(3284),
    [anon_sym_abstract] = ACTIONS(3284),
    [anon_sym_interface] = ACTIONS(3284),
    [anon_sym_enum] = ACTIONS(3284),
    [sym_html_comment] = ACTIONS(5),
  },
  [1074] = {
    [sym_comment] = STATE(1074),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1075] = {
    [sym_comment] = STATE(1075),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3286),
    [sym_html_comment] = ACTIONS(5),
  },
  [1076] = {
    [sym_comment] = STATE(1076),
    [sym_identifier] = ACTIONS(3288),
    [anon_sym_export] = ACTIONS(3288),
    [anon_sym_default] = ACTIONS(3288),
    [anon_sym_type] = ACTIONS(3288),
    [anon_sym_namespace] = ACTIONS(3288),
    [anon_sym_LBRACE] = ACTIONS(3288),
    [anon_sym_RBRACE] = ACTIONS(3288),
    [anon_sym_typeof] = ACTIONS(3288),
    [anon_sym_import] = ACTIONS(3288),
    [anon_sym_with] = ACTIONS(3288),
    [anon_sym_var] = ACTIONS(3288),
    [anon_sym_let] = ACTIONS(3288),
    [anon_sym_const] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3288),
    [anon_sym_else] = ACTIONS(3288),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_switch] = ACTIONS(3288),
    [anon_sym_for] = ACTIONS(3288),
    [anon_sym_LPAREN] = ACTIONS(3288),
    [anon_sym_await] = ACTIONS(3288),
    [anon_sym_while] = ACTIONS(3288),
    [anon_sym_do] = ACTIONS(3288),
    [anon_sym_try] = ACTIONS(3288),
    [anon_sym_break] = ACTIONS(3288),
    [anon_sym_continue] = ACTIONS(3288),
    [anon_sym_debugger] = ACTIONS(3288),
    [anon_sym_return] = ACTIONS(3288),
    [anon_sym_throw] = ACTIONS(3288),
    [anon_sym_SEMI] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3288),
    [anon_sym_yield] = ACTIONS(3288),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_LTtemplate_GT] = ACTIONS(3288),
    [anon_sym_DQUOTE] = ACTIONS(3288),
    [anon_sym_SQUOTE] = ACTIONS(3288),
    [anon_sym_class] = ACTIONS(3288),
    [anon_sym_async] = ACTIONS(3288),
    [anon_sym_function] = ACTIONS(3288),
    [anon_sym_new] = ACTIONS(3288),
    [anon_sym_using] = ACTIONS(3288),
    [anon_sym_PLUS] = ACTIONS(3288),
    [anon_sym_DASH] = ACTIONS(3288),
    [anon_sym_SLASH] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3288),
    [anon_sym_TILDE] = ACTIONS(3288),
    [anon_sym_void] = ACTIONS(3288),
    [anon_sym_delete] = ACTIONS(3288),
    [anon_sym_PLUS_PLUS] = ACTIONS(3288),
    [anon_sym_DASH_DASH] = ACTIONS(3288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3288),
    [sym_number] = ACTIONS(3288),
    [sym_private_property_identifier] = ACTIONS(3288),
    [sym_this] = ACTIONS(3288),
    [sym_super] = ACTIONS(3288),
    [sym_true] = ACTIONS(3288),
    [sym_false] = ACTIONS(3288),
    [sym_null] = ACTIONS(3288),
    [sym_undefined] = ACTIONS(3288),
    [anon_sym_AT] = ACTIONS(3288),
    [anon_sym_static] = ACTIONS(3288),
    [anon_sym_readonly] = ACTIONS(3288),
    [anon_sym_get] = ACTIONS(3288),
    [anon_sym_set] = ACTIONS(3288),
    [anon_sym_declare] = ACTIONS(3288),
    [anon_sym_public] = ACTIONS(3288),
    [anon_sym_private] = ACTIONS(3288),
    [anon_sym_protected] = ACTIONS(3288),
    [anon_sym_override] = ACTIONS(3288),
    [anon_sym_module] = ACTIONS(3288),
    [anon_sym_any] = ACTIONS(3288),
    [anon_sym_number] = ACTIONS(3288),
    [anon_sym_boolean] = ACTIONS(3288),
    [anon_sym_string] = ACTIONS(3288),
    [anon_sym_symbol] = ACTIONS(3288),
    [anon_sym_object] = ACTIONS(3288),
    [anon_sym_abstract] = ACTIONS(3288),
    [anon_sym_interface] = ACTIONS(3288),
    [anon_sym_enum] = ACTIONS(3288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1077] = {
    [sym_comment] = STATE(1077),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_catch] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1078] = {
    [sym_comment] = STATE(1078),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1079] = {
    [sym_comment] = STATE(1079),
    [sym_identifier] = ACTIONS(3290),
    [anon_sym_export] = ACTIONS(3290),
    [anon_sym_default] = ACTIONS(3290),
    [anon_sym_type] = ACTIONS(3290),
    [anon_sym_namespace] = ACTIONS(3290),
    [anon_sym_LBRACE] = ACTIONS(3290),
    [anon_sym_RBRACE] = ACTIONS(3290),
    [anon_sym_typeof] = ACTIONS(3290),
    [anon_sym_import] = ACTIONS(3290),
    [anon_sym_with] = ACTIONS(3290),
    [anon_sym_var] = ACTIONS(3290),
    [anon_sym_let] = ACTIONS(3290),
    [anon_sym_const] = ACTIONS(3290),
    [anon_sym_BANG] = ACTIONS(3290),
    [anon_sym_else] = ACTIONS(3290),
    [anon_sym_if] = ACTIONS(3290),
    [anon_sym_switch] = ACTIONS(3290),
    [anon_sym_for] = ACTIONS(3290),
    [anon_sym_LPAREN] = ACTIONS(3290),
    [anon_sym_await] = ACTIONS(3290),
    [anon_sym_while] = ACTIONS(3290),
    [anon_sym_do] = ACTIONS(3290),
    [anon_sym_try] = ACTIONS(3290),
    [anon_sym_break] = ACTIONS(3290),
    [anon_sym_continue] = ACTIONS(3290),
    [anon_sym_debugger] = ACTIONS(3290),
    [anon_sym_return] = ACTIONS(3290),
    [anon_sym_throw] = ACTIONS(3290),
    [anon_sym_SEMI] = ACTIONS(3290),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_yield] = ACTIONS(3290),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_LTtemplate_GT] = ACTIONS(3290),
    [anon_sym_DQUOTE] = ACTIONS(3290),
    [anon_sym_SQUOTE] = ACTIONS(3290),
    [anon_sym_class] = ACTIONS(3290),
    [anon_sym_async] = ACTIONS(3290),
    [anon_sym_function] = ACTIONS(3290),
    [anon_sym_new] = ACTIONS(3290),
    [anon_sym_using] = ACTIONS(3290),
    [anon_sym_PLUS] = ACTIONS(3290),
    [anon_sym_DASH] = ACTIONS(3290),
    [anon_sym_SLASH] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3290),
    [anon_sym_TILDE] = ACTIONS(3290),
    [anon_sym_void] = ACTIONS(3290),
    [anon_sym_delete] = ACTIONS(3290),
    [anon_sym_PLUS_PLUS] = ACTIONS(3290),
    [anon_sym_DASH_DASH] = ACTIONS(3290),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3290),
    [sym_number] = ACTIONS(3290),
    [sym_private_property_identifier] = ACTIONS(3290),
    [sym_this] = ACTIONS(3290),
    [sym_super] = ACTIONS(3290),
    [sym_true] = ACTIONS(3290),
    [sym_false] = ACTIONS(3290),
    [sym_null] = ACTIONS(3290),
    [sym_undefined] = ACTIONS(3290),
    [anon_sym_AT] = ACTIONS(3290),
    [anon_sym_static] = ACTIONS(3290),
    [anon_sym_readonly] = ACTIONS(3290),
    [anon_sym_get] = ACTIONS(3290),
    [anon_sym_set] = ACTIONS(3290),
    [anon_sym_declare] = ACTIONS(3290),
    [anon_sym_public] = ACTIONS(3290),
    [anon_sym_private] = ACTIONS(3290),
    [anon_sym_protected] = ACTIONS(3290),
    [anon_sym_override] = ACTIONS(3290),
    [anon_sym_module] = ACTIONS(3290),
    [anon_sym_any] = ACTIONS(3290),
    [anon_sym_number] = ACTIONS(3290),
    [anon_sym_boolean] = ACTIONS(3290),
    [anon_sym_string] = ACTIONS(3290),
    [anon_sym_symbol] = ACTIONS(3290),
    [anon_sym_object] = ACTIONS(3290),
    [anon_sym_abstract] = ACTIONS(3290),
    [anon_sym_interface] = ACTIONS(3290),
    [anon_sym_enum] = ACTIONS(3290),
    [sym_html_comment] = ACTIONS(5),
  },
  [1080] = {
    [sym_comment] = STATE(1080),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_export] = ACTIONS(3292),
    [anon_sym_default] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_namespace] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_RBRACE] = ACTIONS(3292),
    [anon_sym_typeof] = ACTIONS(3292),
    [anon_sym_import] = ACTIONS(3292),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_var] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_const] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_else] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_switch] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_await] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_break] = ACTIONS(3292),
    [anon_sym_continue] = ACTIONS(3292),
    [anon_sym_debugger] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_throw] = ACTIONS(3292),
    [anon_sym_SEMI] = ACTIONS(3292),
    [anon_sym_case] = ACTIONS(3292),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LTtemplate_GT] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [anon_sym_class] = ACTIONS(3292),
    [anon_sym_async] = ACTIONS(3292),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_using] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3292),
    [anon_sym_void] = ACTIONS(3292),
    [anon_sym_delete] = ACTIONS(3292),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3292),
    [sym_number] = ACTIONS(3292),
    [sym_private_property_identifier] = ACTIONS(3292),
    [sym_this] = ACTIONS(3292),
    [sym_super] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_null] = ACTIONS(3292),
    [sym_undefined] = ACTIONS(3292),
    [anon_sym_AT] = ACTIONS(3292),
    [anon_sym_static] = ACTIONS(3292),
    [anon_sym_readonly] = ACTIONS(3292),
    [anon_sym_get] = ACTIONS(3292),
    [anon_sym_set] = ACTIONS(3292),
    [anon_sym_declare] = ACTIONS(3292),
    [anon_sym_public] = ACTIONS(3292),
    [anon_sym_private] = ACTIONS(3292),
    [anon_sym_protected] = ACTIONS(3292),
    [anon_sym_override] = ACTIONS(3292),
    [anon_sym_module] = ACTIONS(3292),
    [anon_sym_any] = ACTIONS(3292),
    [anon_sym_number] = ACTIONS(3292),
    [anon_sym_boolean] = ACTIONS(3292),
    [anon_sym_string] = ACTIONS(3292),
    [anon_sym_symbol] = ACTIONS(3292),
    [anon_sym_object] = ACTIONS(3292),
    [anon_sym_abstract] = ACTIONS(3292),
    [anon_sym_interface] = ACTIONS(3292),
    [anon_sym_enum] = ACTIONS(3292),
    [sym_html_comment] = ACTIONS(5),
  },
  [1081] = {
    [sym_comment] = STATE(1081),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_export] = ACTIONS(3294),
    [anon_sym_default] = ACTIONS(3294),
    [anon_sym_type] = ACTIONS(3294),
    [anon_sym_namespace] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3294),
    [anon_sym_RBRACE] = ACTIONS(3294),
    [anon_sym_typeof] = ACTIONS(3294),
    [anon_sym_import] = ACTIONS(3294),
    [anon_sym_with] = ACTIONS(3294),
    [anon_sym_var] = ACTIONS(3294),
    [anon_sym_let] = ACTIONS(3294),
    [anon_sym_const] = ACTIONS(3294),
    [anon_sym_BANG] = ACTIONS(3294),
    [anon_sym_else] = ACTIONS(3294),
    [anon_sym_if] = ACTIONS(3294),
    [anon_sym_switch] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3294),
    [anon_sym_await] = ACTIONS(3294),
    [anon_sym_while] = ACTIONS(3294),
    [anon_sym_do] = ACTIONS(3294),
    [anon_sym_try] = ACTIONS(3294),
    [anon_sym_break] = ACTIONS(3294),
    [anon_sym_continue] = ACTIONS(3294),
    [anon_sym_debugger] = ACTIONS(3294),
    [anon_sym_return] = ACTIONS(3294),
    [anon_sym_throw] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(3294),
    [anon_sym_case] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3294),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_LTtemplate_GT] = ACTIONS(3294),
    [anon_sym_DQUOTE] = ACTIONS(3294),
    [anon_sym_SQUOTE] = ACTIONS(3294),
    [anon_sym_class] = ACTIONS(3294),
    [anon_sym_async] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3294),
    [anon_sym_using] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(3294),
    [anon_sym_delete] = ACTIONS(3294),
    [anon_sym_PLUS_PLUS] = ACTIONS(3294),
    [anon_sym_DASH_DASH] = ACTIONS(3294),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3294),
    [sym_number] = ACTIONS(3294),
    [sym_private_property_identifier] = ACTIONS(3294),
    [sym_this] = ACTIONS(3294),
    [sym_super] = ACTIONS(3294),
    [sym_true] = ACTIONS(3294),
    [sym_false] = ACTIONS(3294),
    [sym_null] = ACTIONS(3294),
    [sym_undefined] = ACTIONS(3294),
    [anon_sym_AT] = ACTIONS(3294),
    [anon_sym_static] = ACTIONS(3294),
    [anon_sym_readonly] = ACTIONS(3294),
    [anon_sym_get] = ACTIONS(3294),
    [anon_sym_set] = ACTIONS(3294),
    [anon_sym_declare] = ACTIONS(3294),
    [anon_sym_public] = ACTIONS(3294),
    [anon_sym_private] = ACTIONS(3294),
    [anon_sym_protected] = ACTIONS(3294),
    [anon_sym_override] = ACTIONS(3294),
    [anon_sym_module] = ACTIONS(3294),
    [anon_sym_any] = ACTIONS(3294),
    [anon_sym_number] = ACTIONS(3294),
    [anon_sym_boolean] = ACTIONS(3294),
    [anon_sym_string] = ACTIONS(3294),
    [anon_sym_symbol] = ACTIONS(3294),
    [anon_sym_object] = ACTIONS(3294),
    [anon_sym_abstract] = ACTIONS(3294),
    [anon_sym_interface] = ACTIONS(3294),
    [anon_sym_enum] = ACTIONS(3294),
    [sym_html_comment] = ACTIONS(5),
  },
  [1082] = {
    [sym_comment] = STATE(1082),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_export] = ACTIONS(3296),
    [anon_sym_default] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_namespace] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(3296),
    [anon_sym_import] = ACTIONS(3296),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_var] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_const] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_else] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_switch] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_await] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_debugger] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_throw] = ACTIONS(3296),
    [anon_sym_SEMI] = ACTIONS(3296),
    [anon_sym_case] = ACTIONS(3296),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LTtemplate_GT] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [anon_sym_class] = ACTIONS(3296),
    [anon_sym_async] = ACTIONS(3296),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_using] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_SLASH] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3296),
    [anon_sym_void] = ACTIONS(3296),
    [anon_sym_delete] = ACTIONS(3296),
    [anon_sym_PLUS_PLUS] = ACTIONS(3296),
    [anon_sym_DASH_DASH] = ACTIONS(3296),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3296),
    [sym_number] = ACTIONS(3296),
    [sym_private_property_identifier] = ACTIONS(3296),
    [sym_this] = ACTIONS(3296),
    [sym_super] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_null] = ACTIONS(3296),
    [sym_undefined] = ACTIONS(3296),
    [anon_sym_AT] = ACTIONS(3296),
    [anon_sym_static] = ACTIONS(3296),
    [anon_sym_readonly] = ACTIONS(3296),
    [anon_sym_get] = ACTIONS(3296),
    [anon_sym_set] = ACTIONS(3296),
    [anon_sym_declare] = ACTIONS(3296),
    [anon_sym_public] = ACTIONS(3296),
    [anon_sym_private] = ACTIONS(3296),
    [anon_sym_protected] = ACTIONS(3296),
    [anon_sym_override] = ACTIONS(3296),
    [anon_sym_module] = ACTIONS(3296),
    [anon_sym_any] = ACTIONS(3296),
    [anon_sym_number] = ACTIONS(3296),
    [anon_sym_boolean] = ACTIONS(3296),
    [anon_sym_string] = ACTIONS(3296),
    [anon_sym_symbol] = ACTIONS(3296),
    [anon_sym_object] = ACTIONS(3296),
    [anon_sym_abstract] = ACTIONS(3296),
    [anon_sym_interface] = ACTIONS(3296),
    [anon_sym_enum] = ACTIONS(3296),
    [sym_html_comment] = ACTIONS(5),
  },
  [1083] = {
    [sym_comment] = STATE(1083),
    [sym_identifier] = ACTIONS(3298),
    [anon_sym_export] = ACTIONS(3298),
    [anon_sym_default] = ACTIONS(3298),
    [anon_sym_type] = ACTIONS(3298),
    [anon_sym_namespace] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3298),
    [anon_sym_RBRACE] = ACTIONS(3298),
    [anon_sym_typeof] = ACTIONS(3298),
    [anon_sym_import] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3298),
    [anon_sym_var] = ACTIONS(3298),
    [anon_sym_let] = ACTIONS(3298),
    [anon_sym_const] = ACTIONS(3298),
    [anon_sym_BANG] = ACTIONS(3298),
    [anon_sym_else] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(3298),
    [anon_sym_switch] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3298),
    [anon_sym_await] = ACTIONS(3298),
    [anon_sym_while] = ACTIONS(3298),
    [anon_sym_do] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3298),
    [anon_sym_break] = ACTIONS(3298),
    [anon_sym_continue] = ACTIONS(3298),
    [anon_sym_debugger] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3298),
    [anon_sym_throw] = ACTIONS(3298),
    [anon_sym_SEMI] = ACTIONS(3298),
    [anon_sym_case] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3298),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LTtemplate_GT] = ACTIONS(3298),
    [anon_sym_DQUOTE] = ACTIONS(3298),
    [anon_sym_SQUOTE] = ACTIONS(3298),
    [anon_sym_class] = ACTIONS(3298),
    [anon_sym_async] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3298),
    [anon_sym_using] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3298),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_SLASH] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3298),
    [anon_sym_void] = ACTIONS(3298),
    [anon_sym_delete] = ACTIONS(3298),
    [anon_sym_PLUS_PLUS] = ACTIONS(3298),
    [anon_sym_DASH_DASH] = ACTIONS(3298),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3298),
    [sym_number] = ACTIONS(3298),
    [sym_private_property_identifier] = ACTIONS(3298),
    [sym_this] = ACTIONS(3298),
    [sym_super] = ACTIONS(3298),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [sym_null] = ACTIONS(3298),
    [sym_undefined] = ACTIONS(3298),
    [anon_sym_AT] = ACTIONS(3298),
    [anon_sym_static] = ACTIONS(3298),
    [anon_sym_readonly] = ACTIONS(3298),
    [anon_sym_get] = ACTIONS(3298),
    [anon_sym_set] = ACTIONS(3298),
    [anon_sym_declare] = ACTIONS(3298),
    [anon_sym_public] = ACTIONS(3298),
    [anon_sym_private] = ACTIONS(3298),
    [anon_sym_protected] = ACTIONS(3298),
    [anon_sym_override] = ACTIONS(3298),
    [anon_sym_module] = ACTIONS(3298),
    [anon_sym_any] = ACTIONS(3298),
    [anon_sym_number] = ACTIONS(3298),
    [anon_sym_boolean] = ACTIONS(3298),
    [anon_sym_string] = ACTIONS(3298),
    [anon_sym_symbol] = ACTIONS(3298),
    [anon_sym_object] = ACTIONS(3298),
    [anon_sym_abstract] = ACTIONS(3298),
    [anon_sym_interface] = ACTIONS(3298),
    [anon_sym_enum] = ACTIONS(3298),
    [sym_html_comment] = ACTIONS(5),
  },
  [1084] = {
    [sym_comment] = STATE(1084),
    [sym_identifier] = ACTIONS(3100),
    [anon_sym_export] = ACTIONS(3100),
    [anon_sym_default] = ACTIONS(3100),
    [anon_sym_type] = ACTIONS(3100),
    [anon_sym_namespace] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_RBRACE] = ACTIONS(3100),
    [anon_sym_typeof] = ACTIONS(3100),
    [anon_sym_import] = ACTIONS(3100),
    [anon_sym_with] = ACTIONS(3100),
    [anon_sym_var] = ACTIONS(3100),
    [anon_sym_let] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3100),
    [anon_sym_await] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_try] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_debugger] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_throw] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym_case] = ACTIONS(3100),
    [anon_sym_finally] = ACTIONS(3100),
    [anon_sym_yield] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3100),
    [anon_sym_LTtemplate_GT] = ACTIONS(3100),
    [anon_sym_DQUOTE] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_async] = ACTIONS(3100),
    [anon_sym_function] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_using] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_SLASH] = ACTIONS(3100),
    [anon_sym_LT] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_void] = ACTIONS(3100),
    [anon_sym_delete] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3100),
    [sym_number] = ACTIONS(3100),
    [sym_private_property_identifier] = ACTIONS(3100),
    [sym_this] = ACTIONS(3100),
    [sym_super] = ACTIONS(3100),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_null] = ACTIONS(3100),
    [sym_undefined] = ACTIONS(3100),
    [anon_sym_AT] = ACTIONS(3100),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_readonly] = ACTIONS(3100),
    [anon_sym_get] = ACTIONS(3100),
    [anon_sym_set] = ACTIONS(3100),
    [anon_sym_declare] = ACTIONS(3100),
    [anon_sym_public] = ACTIONS(3100),
    [anon_sym_private] = ACTIONS(3100),
    [anon_sym_protected] = ACTIONS(3100),
    [anon_sym_override] = ACTIONS(3100),
    [anon_sym_module] = ACTIONS(3100),
    [anon_sym_any] = ACTIONS(3100),
    [anon_sym_number] = ACTIONS(3100),
    [anon_sym_boolean] = ACTIONS(3100),
    [anon_sym_string] = ACTIONS(3100),
    [anon_sym_symbol] = ACTIONS(3100),
    [anon_sym_object] = ACTIONS(3100),
    [anon_sym_abstract] = ACTIONS(3100),
    [anon_sym_interface] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [sym_html_comment] = ACTIONS(5),
  },
  [1085] = {
    [sym_comment] = STATE(1085),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_export] = ACTIONS(3300),
    [anon_sym_default] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_namespace] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_typeof] = ACTIONS(3300),
    [anon_sym_import] = ACTIONS(3300),
    [anon_sym_with] = ACTIONS(3300),
    [anon_sym_var] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_const] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_else] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_switch] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_await] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_debugger] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_throw] = ACTIONS(3300),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym_case] = ACTIONS(3300),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LTtemplate_GT] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_class] = ACTIONS(3300),
    [anon_sym_async] = ACTIONS(3300),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_using] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_SLASH] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_void] = ACTIONS(3300),
    [anon_sym_delete] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3300),
    [sym_number] = ACTIONS(3300),
    [sym_private_property_identifier] = ACTIONS(3300),
    [sym_this] = ACTIONS(3300),
    [sym_super] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_null] = ACTIONS(3300),
    [sym_undefined] = ACTIONS(3300),
    [anon_sym_AT] = ACTIONS(3300),
    [anon_sym_static] = ACTIONS(3300),
    [anon_sym_readonly] = ACTIONS(3300),
    [anon_sym_get] = ACTIONS(3300),
    [anon_sym_set] = ACTIONS(3300),
    [anon_sym_declare] = ACTIONS(3300),
    [anon_sym_public] = ACTIONS(3300),
    [anon_sym_private] = ACTIONS(3300),
    [anon_sym_protected] = ACTIONS(3300),
    [anon_sym_override] = ACTIONS(3300),
    [anon_sym_module] = ACTIONS(3300),
    [anon_sym_any] = ACTIONS(3300),
    [anon_sym_number] = ACTIONS(3300),
    [anon_sym_boolean] = ACTIONS(3300),
    [anon_sym_string] = ACTIONS(3300),
    [anon_sym_symbol] = ACTIONS(3300),
    [anon_sym_object] = ACTIONS(3300),
    [anon_sym_abstract] = ACTIONS(3300),
    [anon_sym_interface] = ACTIONS(3300),
    [anon_sym_enum] = ACTIONS(3300),
    [sym_html_comment] = ACTIONS(5),
  },
  [1086] = {
    [sym_comment] = STATE(1086),
    [sym_identifier] = ACTIONS(3302),
    [anon_sym_export] = ACTIONS(3302),
    [anon_sym_default] = ACTIONS(3302),
    [anon_sym_type] = ACTIONS(3302),
    [anon_sym_namespace] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3302),
    [anon_sym_RBRACE] = ACTIONS(3302),
    [anon_sym_typeof] = ACTIONS(3302),
    [anon_sym_import] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3302),
    [anon_sym_var] = ACTIONS(3302),
    [anon_sym_let] = ACTIONS(3302),
    [anon_sym_const] = ACTIONS(3302),
    [anon_sym_BANG] = ACTIONS(3302),
    [anon_sym_else] = ACTIONS(3302),
    [anon_sym_if] = ACTIONS(3302),
    [anon_sym_switch] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3302),
    [anon_sym_await] = ACTIONS(3302),
    [anon_sym_while] = ACTIONS(3302),
    [anon_sym_do] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3302),
    [anon_sym_break] = ACTIONS(3302),
    [anon_sym_continue] = ACTIONS(3302),
    [anon_sym_debugger] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3302),
    [anon_sym_throw] = ACTIONS(3302),
    [anon_sym_SEMI] = ACTIONS(3302),
    [anon_sym_case] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_LTtemplate_GT] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(3302),
    [anon_sym_SQUOTE] = ACTIONS(3302),
    [anon_sym_class] = ACTIONS(3302),
    [anon_sym_async] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3302),
    [anon_sym_using] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_TILDE] = ACTIONS(3302),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_delete] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3302),
    [sym_number] = ACTIONS(3302),
    [sym_private_property_identifier] = ACTIONS(3302),
    [sym_this] = ACTIONS(3302),
    [sym_super] = ACTIONS(3302),
    [sym_true] = ACTIONS(3302),
    [sym_false] = ACTIONS(3302),
    [sym_null] = ACTIONS(3302),
    [sym_undefined] = ACTIONS(3302),
    [anon_sym_AT] = ACTIONS(3302),
    [anon_sym_static] = ACTIONS(3302),
    [anon_sym_readonly] = ACTIONS(3302),
    [anon_sym_get] = ACTIONS(3302),
    [anon_sym_set] = ACTIONS(3302),
    [anon_sym_declare] = ACTIONS(3302),
    [anon_sym_public] = ACTIONS(3302),
    [anon_sym_private] = ACTIONS(3302),
    [anon_sym_protected] = ACTIONS(3302),
    [anon_sym_override] = ACTIONS(3302),
    [anon_sym_module] = ACTIONS(3302),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_object] = ACTIONS(3302),
    [anon_sym_abstract] = ACTIONS(3302),
    [anon_sym_interface] = ACTIONS(3302),
    [anon_sym_enum] = ACTIONS(3302),
    [sym_html_comment] = ACTIONS(5),
  },
  [1087] = {
    [sym_comment] = STATE(1087),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_export] = ACTIONS(3304),
    [anon_sym_default] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_namespace] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_RBRACE] = ACTIONS(3304),
    [anon_sym_typeof] = ACTIONS(3304),
    [anon_sym_import] = ACTIONS(3304),
    [anon_sym_with] = ACTIONS(3304),
    [anon_sym_var] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_const] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_else] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_switch] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_await] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_debugger] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_throw] = ACTIONS(3304),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym_case] = ACTIONS(3304),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LTtemplate_GT] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_class] = ACTIONS(3304),
    [anon_sym_async] = ACTIONS(3304),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_using] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_void] = ACTIONS(3304),
    [anon_sym_delete] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3304),
    [sym_number] = ACTIONS(3304),
    [sym_private_property_identifier] = ACTIONS(3304),
    [sym_this] = ACTIONS(3304),
    [sym_super] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_null] = ACTIONS(3304),
    [sym_undefined] = ACTIONS(3304),
    [anon_sym_AT] = ACTIONS(3304),
    [anon_sym_static] = ACTIONS(3304),
    [anon_sym_readonly] = ACTIONS(3304),
    [anon_sym_get] = ACTIONS(3304),
    [anon_sym_set] = ACTIONS(3304),
    [anon_sym_declare] = ACTIONS(3304),
    [anon_sym_public] = ACTIONS(3304),
    [anon_sym_private] = ACTIONS(3304),
    [anon_sym_protected] = ACTIONS(3304),
    [anon_sym_override] = ACTIONS(3304),
    [anon_sym_module] = ACTIONS(3304),
    [anon_sym_any] = ACTIONS(3304),
    [anon_sym_number] = ACTIONS(3304),
    [anon_sym_boolean] = ACTIONS(3304),
    [anon_sym_string] = ACTIONS(3304),
    [anon_sym_symbol] = ACTIONS(3304),
    [anon_sym_object] = ACTIONS(3304),
    [anon_sym_abstract] = ACTIONS(3304),
    [anon_sym_interface] = ACTIONS(3304),
    [anon_sym_enum] = ACTIONS(3304),
    [sym_html_comment] = ACTIONS(5),
  },
  [1088] = {
    [sym_comment] = STATE(1088),
    [sym_identifier] = ACTIONS(3306),
    [anon_sym_export] = ACTIONS(3306),
    [anon_sym_default] = ACTIONS(3306),
    [anon_sym_type] = ACTIONS(3306),
    [anon_sym_namespace] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3306),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_typeof] = ACTIONS(3306),
    [anon_sym_import] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3306),
    [anon_sym_var] = ACTIONS(3306),
    [anon_sym_let] = ACTIONS(3306),
    [anon_sym_const] = ACTIONS(3306),
    [anon_sym_BANG] = ACTIONS(3306),
    [anon_sym_else] = ACTIONS(3306),
    [anon_sym_if] = ACTIONS(3306),
    [anon_sym_switch] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3306),
    [anon_sym_await] = ACTIONS(3306),
    [anon_sym_while] = ACTIONS(3306),
    [anon_sym_do] = ACTIONS(3306),
    [anon_sym_try] = ACTIONS(3306),
    [anon_sym_break] = ACTIONS(3306),
    [anon_sym_continue] = ACTIONS(3306),
    [anon_sym_debugger] = ACTIONS(3306),
    [anon_sym_return] = ACTIONS(3306),
    [anon_sym_throw] = ACTIONS(3306),
    [anon_sym_SEMI] = ACTIONS(3306),
    [anon_sym_case] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3306),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_LTtemplate_GT] = ACTIONS(3306),
    [anon_sym_DQUOTE] = ACTIONS(3306),
    [anon_sym_SQUOTE] = ACTIONS(3306),
    [anon_sym_class] = ACTIONS(3306),
    [anon_sym_async] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3306),
    [anon_sym_using] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_DASH] = ACTIONS(3306),
    [anon_sym_SLASH] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [anon_sym_void] = ACTIONS(3306),
    [anon_sym_delete] = ACTIONS(3306),
    [anon_sym_PLUS_PLUS] = ACTIONS(3306),
    [anon_sym_DASH_DASH] = ACTIONS(3306),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3306),
    [sym_number] = ACTIONS(3306),
    [sym_private_property_identifier] = ACTIONS(3306),
    [sym_this] = ACTIONS(3306),
    [sym_super] = ACTIONS(3306),
    [sym_true] = ACTIONS(3306),
    [sym_false] = ACTIONS(3306),
    [sym_null] = ACTIONS(3306),
    [sym_undefined] = ACTIONS(3306),
    [anon_sym_AT] = ACTIONS(3306),
    [anon_sym_static] = ACTIONS(3306),
    [anon_sym_readonly] = ACTIONS(3306),
    [anon_sym_get] = ACTIONS(3306),
    [anon_sym_set] = ACTIONS(3306),
    [anon_sym_declare] = ACTIONS(3306),
    [anon_sym_public] = ACTIONS(3306),
    [anon_sym_private] = ACTIONS(3306),
    [anon_sym_protected] = ACTIONS(3306),
    [anon_sym_override] = ACTIONS(3306),
    [anon_sym_module] = ACTIONS(3306),
    [anon_sym_any] = ACTIONS(3306),
    [anon_sym_number] = ACTIONS(3306),
    [anon_sym_boolean] = ACTIONS(3306),
    [anon_sym_string] = ACTIONS(3306),
    [anon_sym_symbol] = ACTIONS(3306),
    [anon_sym_object] = ACTIONS(3306),
    [anon_sym_abstract] = ACTIONS(3306),
    [anon_sym_interface] = ACTIONS(3306),
    [anon_sym_enum] = ACTIONS(3306),
    [sym_html_comment] = ACTIONS(5),
  },
  [1089] = {
    [sym_comment] = STATE(1089),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_export] = ACTIONS(3308),
    [anon_sym_default] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_namespace] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_RBRACE] = ACTIONS(3308),
    [anon_sym_typeof] = ACTIONS(3308),
    [anon_sym_import] = ACTIONS(3308),
    [anon_sym_with] = ACTIONS(3308),
    [anon_sym_var] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_else] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_switch] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_await] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_debugger] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_throw] = ACTIONS(3308),
    [anon_sym_SEMI] = ACTIONS(3308),
    [anon_sym_case] = ACTIONS(3308),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LTtemplate_GT] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_class] = ACTIONS(3308),
    [anon_sym_async] = ACTIONS(3308),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_using] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_void] = ACTIONS(3308),
    [anon_sym_delete] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3308),
    [sym_number] = ACTIONS(3308),
    [sym_private_property_identifier] = ACTIONS(3308),
    [sym_this] = ACTIONS(3308),
    [sym_super] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_null] = ACTIONS(3308),
    [sym_undefined] = ACTIONS(3308),
    [anon_sym_AT] = ACTIONS(3308),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_readonly] = ACTIONS(3308),
    [anon_sym_get] = ACTIONS(3308),
    [anon_sym_set] = ACTIONS(3308),
    [anon_sym_declare] = ACTIONS(3308),
    [anon_sym_public] = ACTIONS(3308),
    [anon_sym_private] = ACTIONS(3308),
    [anon_sym_protected] = ACTIONS(3308),
    [anon_sym_override] = ACTIONS(3308),
    [anon_sym_module] = ACTIONS(3308),
    [anon_sym_any] = ACTIONS(3308),
    [anon_sym_number] = ACTIONS(3308),
    [anon_sym_boolean] = ACTIONS(3308),
    [anon_sym_string] = ACTIONS(3308),
    [anon_sym_symbol] = ACTIONS(3308),
    [anon_sym_object] = ACTIONS(3308),
    [anon_sym_abstract] = ACTIONS(3308),
    [anon_sym_interface] = ACTIONS(3308),
    [anon_sym_enum] = ACTIONS(3308),
    [sym_html_comment] = ACTIONS(5),
  },
  [1090] = {
    [sym_comment] = STATE(1090),
    [ts_builtin_sym_end] = ACTIONS(2373),
    [sym_identifier] = ACTIONS(2167),
    [anon_sym_export] = ACTIONS(2167),
    [anon_sym_type] = ACTIONS(2167),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2167),
    [anon_sym_with] = ACTIONS(2167),
    [anon_sym_var] = ACTIONS(2167),
    [anon_sym_let] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_debugger] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_yield] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LTtemplate_GT] = ACTIONS(2167),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_async] = ACTIONS(2167),
    [anon_sym_function] = ACTIONS(2167),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_LT] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_void] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [sym_number] = ACTIONS(2167),
    [sym_private_property_identifier] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [sym_super] = ACTIONS(2167),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_undefined] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_readonly] = ACTIONS(2167),
    [anon_sym_get] = ACTIONS(2167),
    [anon_sym_set] = ACTIONS(2167),
    [anon_sym_declare] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_override] = ACTIONS(2167),
    [anon_sym_module] = ACTIONS(2167),
    [anon_sym_any] = ACTIONS(2167),
    [anon_sym_number] = ACTIONS(2167),
    [anon_sym_boolean] = ACTIONS(2167),
    [anon_sym_string] = ACTIONS(2167),
    [anon_sym_symbol] = ACTIONS(2167),
    [anon_sym_object] = ACTIONS(2167),
    [anon_sym_abstract] = ACTIONS(2167),
    [anon_sym_interface] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [sym__automatic_semicolon] = ACTIONS(2375),
    [sym_html_comment] = ACTIONS(5),
  },
  [1091] = {
    [sym_comment] = STATE(1091),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2097),
    [sym_html_comment] = ACTIONS(5),
  },
  [1092] = {
    [sym_comment] = STATE(1092),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3310),
    [sym_html_comment] = ACTIONS(5),
  },
  [1093] = {
    [sym_comment] = STATE(1093),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_export] = ACTIONS(3312),
    [anon_sym_default] = ACTIONS(3312),
    [anon_sym_type] = ACTIONS(3312),
    [anon_sym_namespace] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_typeof] = ACTIONS(3312),
    [anon_sym_import] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3312),
    [anon_sym_var] = ACTIONS(3312),
    [anon_sym_let] = ACTIONS(3312),
    [anon_sym_const] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_else] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_switch] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym_await] = ACTIONS(3312),
    [anon_sym_while] = ACTIONS(3312),
    [anon_sym_do] = ACTIONS(3312),
    [anon_sym_try] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_debugger] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_throw] = ACTIONS(3312),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym_case] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3312),
    [anon_sym_LTtemplate_GT] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_class] = ACTIONS(3312),
    [anon_sym_async] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3312),
    [anon_sym_using] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_void] = ACTIONS(3312),
    [anon_sym_delete] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3312),
    [sym_number] = ACTIONS(3312),
    [sym_private_property_identifier] = ACTIONS(3312),
    [sym_this] = ACTIONS(3312),
    [sym_super] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_null] = ACTIONS(3312),
    [sym_undefined] = ACTIONS(3312),
    [anon_sym_AT] = ACTIONS(3312),
    [anon_sym_static] = ACTIONS(3312),
    [anon_sym_readonly] = ACTIONS(3312),
    [anon_sym_get] = ACTIONS(3312),
    [anon_sym_set] = ACTIONS(3312),
    [anon_sym_declare] = ACTIONS(3312),
    [anon_sym_public] = ACTIONS(3312),
    [anon_sym_private] = ACTIONS(3312),
    [anon_sym_protected] = ACTIONS(3312),
    [anon_sym_override] = ACTIONS(3312),
    [anon_sym_module] = ACTIONS(3312),
    [anon_sym_any] = ACTIONS(3312),
    [anon_sym_number] = ACTIONS(3312),
    [anon_sym_boolean] = ACTIONS(3312),
    [anon_sym_string] = ACTIONS(3312),
    [anon_sym_symbol] = ACTIONS(3312),
    [anon_sym_object] = ACTIONS(3312),
    [anon_sym_abstract] = ACTIONS(3312),
    [anon_sym_interface] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(3312),
    [sym_html_comment] = ACTIONS(5),
  },
  [1094] = {
    [sym_comment] = STATE(1094),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_default] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_else] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_case] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym_html_comment] = ACTIONS(5),
  },
  [1095] = {
    [sym_comment] = STATE(1095),
    [ts_builtin_sym_end] = ACTIONS(2381),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2205),
    [anon_sym_type] = ACTIONS(2205),
    [anon_sym_namespace] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_typeof] = ACTIONS(2205),
    [anon_sym_import] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2205),
    [anon_sym_var] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_else] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_await] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(2205),
    [anon_sym_do] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2205),
    [anon_sym_break] = ACTIONS(2205),
    [anon_sym_continue] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2205),
    [anon_sym_return] = ACTIONS(2205),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_yield] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_LTtemplate_GT] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_class] = ACTIONS(2205),
    [anon_sym_async] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2205),
    [anon_sym_new] = ACTIONS(2205),
    [anon_sym_using] = ACTIONS(2205),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_void] = ACTIONS(2205),
    [anon_sym_delete] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_number] = ACTIONS(2205),
    [sym_private_property_identifier] = ACTIONS(2205),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(2205),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [anon_sym_static] = ACTIONS(2205),
    [anon_sym_readonly] = ACTIONS(2205),
    [anon_sym_get] = ACTIONS(2205),
    [anon_sym_set] = ACTIONS(2205),
    [anon_sym_declare] = ACTIONS(2205),
    [anon_sym_public] = ACTIONS(2205),
    [anon_sym_private] = ACTIONS(2205),
    [anon_sym_protected] = ACTIONS(2205),
    [anon_sym_override] = ACTIONS(2205),
    [anon_sym_module] = ACTIONS(2205),
    [anon_sym_any] = ACTIONS(2205),
    [anon_sym_number] = ACTIONS(2205),
    [anon_sym_boolean] = ACTIONS(2205),
    [anon_sym_string] = ACTIONS(2205),
    [anon_sym_symbol] = ACTIONS(2205),
    [anon_sym_object] = ACTIONS(2205),
    [anon_sym_abstract] = ACTIONS(2205),
    [anon_sym_interface] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2205),
    [sym__automatic_semicolon] = ACTIONS(2383),
    [sym_html_comment] = ACTIONS(5),
  },
  [1096] = {
    [sym_comment] = STATE(1096),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_export] = ACTIONS(3314),
    [anon_sym_default] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_RBRACE] = ACTIONS(3314),
    [anon_sym_typeof] = ACTIONS(3314),
    [anon_sym_import] = ACTIONS(3314),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_var] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_BANG] = ACTIONS(3314),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_await] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_debugger] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3314),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LTtemplate_GT] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_SQUOTE] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_async] = ACTIONS(3314),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_SLASH] = ACTIONS(3314),
    [anon_sym_LT] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3314),
    [anon_sym_void] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_PLUS_PLUS] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3314),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3314),
    [sym_number] = ACTIONS(3314),
    [sym_private_property_identifier] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_undefined] = ACTIONS(3314),
    [anon_sym_AT] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_readonly] = ACTIONS(3314),
    [anon_sym_get] = ACTIONS(3314),
    [anon_sym_set] = ACTIONS(3314),
    [anon_sym_declare] = ACTIONS(3314),
    [anon_sym_public] = ACTIONS(3314),
    [anon_sym_private] = ACTIONS(3314),
    [anon_sym_protected] = ACTIONS(3314),
    [anon_sym_override] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_any] = ACTIONS(3314),
    [anon_sym_number] = ACTIONS(3314),
    [anon_sym_boolean] = ACTIONS(3314),
    [anon_sym_string] = ACTIONS(3314),
    [anon_sym_symbol] = ACTIONS(3314),
    [anon_sym_object] = ACTIONS(3314),
    [anon_sym_abstract] = ACTIONS(3314),
    [anon_sym_interface] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [sym_html_comment] = ACTIONS(5),
  },
  [1097] = {
    [sym_comment] = STATE(1097),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2179),
    [sym_html_comment] = ACTIONS(5),
  },
  [1098] = {
    [sym_comment] = STATE(1098),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_export] = ACTIONS(3316),
    [anon_sym_default] = ACTIONS(3316),
    [anon_sym_type] = ACTIONS(3316),
    [anon_sym_namespace] = ACTIONS(3316),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_typeof] = ACTIONS(3316),
    [anon_sym_import] = ACTIONS(3316),
    [anon_sym_with] = ACTIONS(3316),
    [anon_sym_var] = ACTIONS(3316),
    [anon_sym_let] = ACTIONS(3316),
    [anon_sym_const] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_else] = ACTIONS(3316),
    [anon_sym_if] = ACTIONS(3316),
    [anon_sym_switch] = ACTIONS(3316),
    [anon_sym_for] = ACTIONS(3316),
    [anon_sym_LPAREN] = ACTIONS(3316),
    [anon_sym_await] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(3316),
    [anon_sym_do] = ACTIONS(3316),
    [anon_sym_try] = ACTIONS(3316),
    [anon_sym_break] = ACTIONS(3316),
    [anon_sym_continue] = ACTIONS(3316),
    [anon_sym_debugger] = ACTIONS(3316),
    [anon_sym_return] = ACTIONS(3316),
    [anon_sym_throw] = ACTIONS(3316),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym_case] = ACTIONS(3316),
    [anon_sym_yield] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_LTtemplate_GT] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_class] = ACTIONS(3316),
    [anon_sym_async] = ACTIONS(3316),
    [anon_sym_function] = ACTIONS(3316),
    [anon_sym_new] = ACTIONS(3316),
    [anon_sym_using] = ACTIONS(3316),
    [anon_sym_PLUS] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3316),
    [anon_sym_SLASH] = ACTIONS(3316),
    [anon_sym_LT] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_void] = ACTIONS(3316),
    [anon_sym_delete] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3316),
    [sym_number] = ACTIONS(3316),
    [sym_private_property_identifier] = ACTIONS(3316),
    [sym_this] = ACTIONS(3316),
    [sym_super] = ACTIONS(3316),
    [sym_true] = ACTIONS(3316),
    [sym_false] = ACTIONS(3316),
    [sym_null] = ACTIONS(3316),
    [sym_undefined] = ACTIONS(3316),
    [anon_sym_AT] = ACTIONS(3316),
    [anon_sym_static] = ACTIONS(3316),
    [anon_sym_readonly] = ACTIONS(3316),
    [anon_sym_get] = ACTIONS(3316),
    [anon_sym_set] = ACTIONS(3316),
    [anon_sym_declare] = ACTIONS(3316),
    [anon_sym_public] = ACTIONS(3316),
    [anon_sym_private] = ACTIONS(3316),
    [anon_sym_protected] = ACTIONS(3316),
    [anon_sym_override] = ACTIONS(3316),
    [anon_sym_module] = ACTIONS(3316),
    [anon_sym_any] = ACTIONS(3316),
    [anon_sym_number] = ACTIONS(3316),
    [anon_sym_boolean] = ACTIONS(3316),
    [anon_sym_string] = ACTIONS(3316),
    [anon_sym_symbol] = ACTIONS(3316),
    [anon_sym_object] = ACTIONS(3316),
    [anon_sym_abstract] = ACTIONS(3316),
    [anon_sym_interface] = ACTIONS(3316),
    [anon_sym_enum] = ACTIONS(3316),
    [sym_html_comment] = ACTIONS(5),
  },
  [1099] = {
    [sym_comment] = STATE(1099),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_export] = ACTIONS(3318),
    [anon_sym_default] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_namespace] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_RBRACE] = ACTIONS(3318),
    [anon_sym_typeof] = ACTIONS(3318),
    [anon_sym_import] = ACTIONS(3318),
    [anon_sym_with] = ACTIONS(3318),
    [anon_sym_var] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_else] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_switch] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_await] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_debugger] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_throw] = ACTIONS(3318),
    [anon_sym_SEMI] = ACTIONS(3318),
    [anon_sym_case] = ACTIONS(3318),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LTtemplate_GT] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_SQUOTE] = ACTIONS(3318),
    [anon_sym_class] = ACTIONS(3318),
    [anon_sym_async] = ACTIONS(3318),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_using] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3318),
    [anon_sym_void] = ACTIONS(3318),
    [anon_sym_delete] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3318),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3318),
    [sym_number] = ACTIONS(3318),
    [sym_private_property_identifier] = ACTIONS(3318),
    [sym_this] = ACTIONS(3318),
    [sym_super] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_null] = ACTIONS(3318),
    [sym_undefined] = ACTIONS(3318),
    [anon_sym_AT] = ACTIONS(3318),
    [anon_sym_static] = ACTIONS(3318),
    [anon_sym_readonly] = ACTIONS(3318),
    [anon_sym_get] = ACTIONS(3318),
    [anon_sym_set] = ACTIONS(3318),
    [anon_sym_declare] = ACTIONS(3318),
    [anon_sym_public] = ACTIONS(3318),
    [anon_sym_private] = ACTIONS(3318),
    [anon_sym_protected] = ACTIONS(3318),
    [anon_sym_override] = ACTIONS(3318),
    [anon_sym_module] = ACTIONS(3318),
    [anon_sym_any] = ACTIONS(3318),
    [anon_sym_number] = ACTIONS(3318),
    [anon_sym_boolean] = ACTIONS(3318),
    [anon_sym_string] = ACTIONS(3318),
    [anon_sym_symbol] = ACTIONS(3318),
    [anon_sym_object] = ACTIONS(3318),
    [anon_sym_abstract] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [sym_html_comment] = ACTIONS(5),
  },
  [1100] = {
    [sym_comment] = STATE(1100),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_default] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_else] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_case] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym_html_comment] = ACTIONS(5),
  },
  [1101] = {
    [sym_comment] = STATE(1101),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [sym_html_comment] = ACTIONS(5),
  },
  [1102] = {
    [sym_comment] = STATE(1102),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(2175),
    [anon_sym_default] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_namespace] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2175),
    [anon_sym_import] = ACTIONS(2175),
    [anon_sym_with] = ACTIONS(2175),
    [anon_sym_var] = ACTIONS(2175),
    [anon_sym_let] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_else] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_switch] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_await] = ACTIONS(2175),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_do] = ACTIONS(2175),
    [anon_sym_try] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_debugger] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_case] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [anon_sym_LTtemplate_GT] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_class] = ACTIONS(2175),
    [anon_sym_async] = ACTIONS(2175),
    [anon_sym_function] = ACTIONS(2175),
    [anon_sym_new] = ACTIONS(2175),
    [anon_sym_using] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_void] = ACTIONS(2175),
    [anon_sym_delete] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_number] = ACTIONS(2175),
    [sym_private_property_identifier] = ACTIONS(2175),
    [sym_this] = ACTIONS(2175),
    [sym_super] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2175),
    [anon_sym_static] = ACTIONS(2175),
    [anon_sym_readonly] = ACTIONS(2175),
    [anon_sym_get] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(2175),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_public] = ACTIONS(2175),
    [anon_sym_private] = ACTIONS(2175),
    [anon_sym_protected] = ACTIONS(2175),
    [anon_sym_override] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2175),
    [anon_sym_any] = ACTIONS(2175),
    [anon_sym_number] = ACTIONS(2175),
    [anon_sym_boolean] = ACTIONS(2175),
    [anon_sym_string] = ACTIONS(2175),
    [anon_sym_symbol] = ACTIONS(2175),
    [anon_sym_object] = ACTIONS(2175),
    [anon_sym_abstract] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [sym_html_comment] = ACTIONS(5),
  },
  [1103] = {
    [sym_comment] = STATE(1103),
    [ts_builtin_sym_end] = ACTIONS(2357),
    [sym_identifier] = ACTIONS(2255),
    [anon_sym_export] = ACTIONS(2255),
    [anon_sym_type] = ACTIONS(2255),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2255),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_typeof] = ACTIONS(2255),
    [anon_sym_import] = ACTIONS(2255),
    [anon_sym_with] = ACTIONS(2255),
    [anon_sym_var] = ACTIONS(2255),
    [anon_sym_let] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_else] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_await] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_debugger] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2255),
    [anon_sym_yield] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_LTtemplate_GT] = ACTIONS(2255),
    [anon_sym_DQUOTE] = ACTIONS(2255),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_async] = ACTIONS(2255),
    [anon_sym_function] = ACTIONS(2255),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_TILDE] = ACTIONS(2255),
    [anon_sym_void] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [sym_number] = ACTIONS(2255),
    [sym_private_property_identifier] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [sym_super] = ACTIONS(2255),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [sym_null] = ACTIONS(2255),
    [sym_undefined] = ACTIONS(2255),
    [anon_sym_AT] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_readonly] = ACTIONS(2255),
    [anon_sym_get] = ACTIONS(2255),
    [anon_sym_set] = ACTIONS(2255),
    [anon_sym_declare] = ACTIONS(2255),
    [anon_sym_public] = ACTIONS(2255),
    [anon_sym_private] = ACTIONS(2255),
    [anon_sym_protected] = ACTIONS(2255),
    [anon_sym_override] = ACTIONS(2255),
    [anon_sym_module] = ACTIONS(2255),
    [anon_sym_any] = ACTIONS(2255),
    [anon_sym_number] = ACTIONS(2255),
    [anon_sym_boolean] = ACTIONS(2255),
    [anon_sym_string] = ACTIONS(2255),
    [anon_sym_symbol] = ACTIONS(2255),
    [anon_sym_object] = ACTIONS(2255),
    [anon_sym_abstract] = ACTIONS(2255),
    [anon_sym_interface] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [sym__automatic_semicolon] = ACTIONS(2359),
    [sym_html_comment] = ACTIONS(5),
  },
  [1104] = {
    [sym_comment] = STATE(1104),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [1105] = {
    [sym_comment] = STATE(1105),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym_html_comment] = ACTIONS(5),
  },
  [1106] = {
    [sym_comment] = STATE(1106),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym_html_comment] = ACTIONS(5),
  },
  [1107] = {
    [sym_comment] = STATE(1107),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_export] = ACTIONS(2241),
    [anon_sym_default] = ACTIONS(2241),
    [anon_sym_type] = ACTIONS(2241),
    [anon_sym_namespace] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_typeof] = ACTIONS(2241),
    [anon_sym_import] = ACTIONS(2241),
    [anon_sym_with] = ACTIONS(2241),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_const] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_if] = ACTIONS(2241),
    [anon_sym_switch] = ACTIONS(2241),
    [anon_sym_for] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_await] = ACTIONS(2241),
    [anon_sym_while] = ACTIONS(2241),
    [anon_sym_do] = ACTIONS(2241),
    [anon_sym_try] = ACTIONS(2241),
    [anon_sym_break] = ACTIONS(2241),
    [anon_sym_continue] = ACTIONS(2241),
    [anon_sym_debugger] = ACTIONS(2241),
    [anon_sym_return] = ACTIONS(2241),
    [anon_sym_throw] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_case] = ACTIONS(2241),
    [anon_sym_yield] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_LTtemplate_GT] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_class] = ACTIONS(2241),
    [anon_sym_async] = ACTIONS(2241),
    [anon_sym_function] = ACTIONS(2241),
    [anon_sym_new] = ACTIONS(2241),
    [anon_sym_using] = ACTIONS(2241),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_void] = ACTIONS(2241),
    [anon_sym_delete] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2241),
    [sym_number] = ACTIONS(2241),
    [sym_private_property_identifier] = ACTIONS(2241),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(2241),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(2241),
    [anon_sym_static] = ACTIONS(2241),
    [anon_sym_readonly] = ACTIONS(2241),
    [anon_sym_get] = ACTIONS(2241),
    [anon_sym_set] = ACTIONS(2241),
    [anon_sym_declare] = ACTIONS(2241),
    [anon_sym_public] = ACTIONS(2241),
    [anon_sym_private] = ACTIONS(2241),
    [anon_sym_protected] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_module] = ACTIONS(2241),
    [anon_sym_any] = ACTIONS(2241),
    [anon_sym_number] = ACTIONS(2241),
    [anon_sym_boolean] = ACTIONS(2241),
    [anon_sym_string] = ACTIONS(2241),
    [anon_sym_symbol] = ACTIONS(2241),
    [anon_sym_object] = ACTIONS(2241),
    [anon_sym_abstract] = ACTIONS(2241),
    [anon_sym_interface] = ACTIONS(2241),
    [anon_sym_enum] = ACTIONS(2241),
    [sym__automatic_semicolon] = ACTIONS(2267),
    [sym_html_comment] = ACTIONS(5),
  },
  [1108] = {
    [sym_comment] = STATE(1108),
    [sym_identifier] = ACTIONS(3320),
    [anon_sym_export] = ACTIONS(3320),
    [anon_sym_default] = ACTIONS(3320),
    [anon_sym_type] = ACTIONS(3320),
    [anon_sym_namespace] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3320),
    [anon_sym_RBRACE] = ACTIONS(3320),
    [anon_sym_typeof] = ACTIONS(3320),
    [anon_sym_import] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3320),
    [anon_sym_var] = ACTIONS(3320),
    [anon_sym_let] = ACTIONS(3320),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_BANG] = ACTIONS(3320),
    [anon_sym_else] = ACTIONS(3320),
    [anon_sym_if] = ACTIONS(3320),
    [anon_sym_switch] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3320),
    [anon_sym_await] = ACTIONS(3320),
    [anon_sym_while] = ACTIONS(3320),
    [anon_sym_do] = ACTIONS(3320),
    [anon_sym_try] = ACTIONS(3320),
    [anon_sym_break] = ACTIONS(3320),
    [anon_sym_continue] = ACTIONS(3320),
    [anon_sym_debugger] = ACTIONS(3320),
    [anon_sym_return] = ACTIONS(3320),
    [anon_sym_throw] = ACTIONS(3320),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym_case] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3320),
    [anon_sym_LBRACK] = ACTIONS(3320),
    [anon_sym_LTtemplate_GT] = ACTIONS(3320),
    [anon_sym_DQUOTE] = ACTIONS(3320),
    [anon_sym_SQUOTE] = ACTIONS(3320),
    [anon_sym_class] = ACTIONS(3320),
    [anon_sym_async] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3320),
    [anon_sym_using] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3320),
    [anon_sym_DASH] = ACTIONS(3320),
    [anon_sym_SLASH] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [anon_sym_void] = ACTIONS(3320),
    [anon_sym_delete] = ACTIONS(3320),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3320),
    [sym_number] = ACTIONS(3320),
    [sym_private_property_identifier] = ACTIONS(3320),
    [sym_this] = ACTIONS(3320),
    [sym_super] = ACTIONS(3320),
    [sym_true] = ACTIONS(3320),
    [sym_false] = ACTIONS(3320),
    [sym_null] = ACTIONS(3320),
    [sym_undefined] = ACTIONS(3320),
    [anon_sym_AT] = ACTIONS(3320),
    [anon_sym_static] = ACTIONS(3320),
    [anon_sym_readonly] = ACTIONS(3320),
    [anon_sym_get] = ACTIONS(3320),
    [anon_sym_set] = ACTIONS(3320),
    [anon_sym_declare] = ACTIONS(3320),
    [anon_sym_public] = ACTIONS(3320),
    [anon_sym_private] = ACTIONS(3320),
    [anon_sym_protected] = ACTIONS(3320),
    [anon_sym_override] = ACTIONS(3320),
    [anon_sym_module] = ACTIONS(3320),
    [anon_sym_any] = ACTIONS(3320),
    [anon_sym_number] = ACTIONS(3320),
    [anon_sym_boolean] = ACTIONS(3320),
    [anon_sym_string] = ACTIONS(3320),
    [anon_sym_symbol] = ACTIONS(3320),
    [anon_sym_object] = ACTIONS(3320),
    [anon_sym_abstract] = ACTIONS(3320),
    [anon_sym_interface] = ACTIONS(3320),
    [anon_sym_enum] = ACTIONS(3320),
    [sym_html_comment] = ACTIONS(5),
  },
  [1109] = {
    [sym_comment] = STATE(1109),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_export] = ACTIONS(3322),
    [anon_sym_default] = ACTIONS(3322),
    [anon_sym_type] = ACTIONS(3322),
    [anon_sym_namespace] = ACTIONS(3322),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_RBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3322),
    [anon_sym_import] = ACTIONS(3322),
    [anon_sym_with] = ACTIONS(3322),
    [anon_sym_var] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_BANG] = ACTIONS(3322),
    [anon_sym_else] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_switch] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_await] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(3322),
    [anon_sym_continue] = ACTIONS(3322),
    [anon_sym_debugger] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_throw] = ACTIONS(3322),
    [anon_sym_SEMI] = ACTIONS(3322),
    [anon_sym_case] = ACTIONS(3322),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LTtemplate_GT] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_SQUOTE] = ACTIONS(3322),
    [anon_sym_class] = ACTIONS(3322),
    [anon_sym_async] = ACTIONS(3322),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_using] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_SLASH] = ACTIONS(3322),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3322),
    [anon_sym_void] = ACTIONS(3322),
    [anon_sym_delete] = ACTIONS(3322),
    [anon_sym_PLUS_PLUS] = ACTIONS(3322),
    [anon_sym_DASH_DASH] = ACTIONS(3322),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3322),
    [sym_number] = ACTIONS(3322),
    [sym_private_property_identifier] = ACTIONS(3322),
    [sym_this] = ACTIONS(3322),
    [sym_super] = ACTIONS(3322),
    [sym_true] = ACTIONS(3322),
    [sym_false] = ACTIONS(3322),
    [sym_null] = ACTIONS(3322),
    [sym_undefined] = ACTIONS(3322),
    [anon_sym_AT] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3322),
    [anon_sym_readonly] = ACTIONS(3322),
    [anon_sym_get] = ACTIONS(3322),
    [anon_sym_set] = ACTIONS(3322),
    [anon_sym_declare] = ACTIONS(3322),
    [anon_sym_public] = ACTIONS(3322),
    [anon_sym_private] = ACTIONS(3322),
    [anon_sym_protected] = ACTIONS(3322),
    [anon_sym_override] = ACTIONS(3322),
    [anon_sym_module] = ACTIONS(3322),
    [anon_sym_any] = ACTIONS(3322),
    [anon_sym_number] = ACTIONS(3322),
    [anon_sym_boolean] = ACTIONS(3322),
    [anon_sym_string] = ACTIONS(3322),
    [anon_sym_symbol] = ACTIONS(3322),
    [anon_sym_object] = ACTIONS(3322),
    [anon_sym_abstract] = ACTIONS(3322),
    [anon_sym_interface] = ACTIONS(3322),
    [anon_sym_enum] = ACTIONS(3322),
    [sym_html_comment] = ACTIONS(5),
  },
  [1110] = {
    [sym_comment] = STATE(1110),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_export] = ACTIONS(3324),
    [anon_sym_default] = ACTIONS(3324),
    [anon_sym_type] = ACTIONS(3324),
    [anon_sym_namespace] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_import] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3324),
    [anon_sym_var] = ACTIONS(3324),
    [anon_sym_let] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_else] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_switch] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym_await] = ACTIONS(3324),
    [anon_sym_while] = ACTIONS(3324),
    [anon_sym_do] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_debugger] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_throw] = ACTIONS(3324),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym_case] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_LTtemplate_GT] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_async] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_SLASH] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_void] = ACTIONS(3324),
    [anon_sym_delete] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3324),
    [sym_number] = ACTIONS(3324),
    [sym_private_property_identifier] = ACTIONS(3324),
    [sym_this] = ACTIONS(3324),
    [sym_super] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_null] = ACTIONS(3324),
    [sym_undefined] = ACTIONS(3324),
    [anon_sym_AT] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_readonly] = ACTIONS(3324),
    [anon_sym_get] = ACTIONS(3324),
    [anon_sym_set] = ACTIONS(3324),
    [anon_sym_declare] = ACTIONS(3324),
    [anon_sym_public] = ACTIONS(3324),
    [anon_sym_private] = ACTIONS(3324),
    [anon_sym_protected] = ACTIONS(3324),
    [anon_sym_override] = ACTIONS(3324),
    [anon_sym_module] = ACTIONS(3324),
    [anon_sym_any] = ACTIONS(3324),
    [anon_sym_number] = ACTIONS(3324),
    [anon_sym_boolean] = ACTIONS(3324),
    [anon_sym_string] = ACTIONS(3324),
    [anon_sym_symbol] = ACTIONS(3324),
    [anon_sym_object] = ACTIONS(3324),
    [anon_sym_abstract] = ACTIONS(3324),
    [anon_sym_interface] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [sym_html_comment] = ACTIONS(5),
  },
  [1111] = {
    [sym_comment] = STATE(1111),
    [ts_builtin_sym_end] = ACTIONS(2325),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2225),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_else] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_yield] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2225),
    [anon_sym_LTtemplate_GT] = ACTIONS(2225),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_SQUOTE] = ACTIONS(2225),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_function] = ACTIONS(2225),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_using] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_TILDE] = ACTIONS(2225),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(2225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [sym_number] = ACTIONS(2225),
    [sym_private_property_identifier] = ACTIONS(2225),
    [sym_this] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [sym_false] = ACTIONS(2225),
    [sym_null] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2225),
    [anon_sym_static] = ACTIONS(2225),
    [anon_sym_readonly] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_override] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_object] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
    [sym__automatic_semicolon] = ACTIONS(2327),
    [sym_html_comment] = ACTIONS(5),
  },
  [1112] = {
    [sym_comment] = STATE(1112),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_export] = ACTIONS(3326),
    [anon_sym_default] = ACTIONS(3326),
    [anon_sym_type] = ACTIONS(3326),
    [anon_sym_namespace] = ACTIONS(3326),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_RBRACE] = ACTIONS(3326),
    [anon_sym_typeof] = ACTIONS(3326),
    [anon_sym_import] = ACTIONS(3326),
    [anon_sym_with] = ACTIONS(3326),
    [anon_sym_var] = ACTIONS(3326),
    [anon_sym_let] = ACTIONS(3326),
    [anon_sym_const] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_else] = ACTIONS(3326),
    [anon_sym_if] = ACTIONS(3326),
    [anon_sym_switch] = ACTIONS(3326),
    [anon_sym_for] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_await] = ACTIONS(3326),
    [anon_sym_while] = ACTIONS(3326),
    [anon_sym_do] = ACTIONS(3326),
    [anon_sym_try] = ACTIONS(3326),
    [anon_sym_break] = ACTIONS(3326),
    [anon_sym_continue] = ACTIONS(3326),
    [anon_sym_debugger] = ACTIONS(3326),
    [anon_sym_return] = ACTIONS(3326),
    [anon_sym_throw] = ACTIONS(3326),
    [anon_sym_SEMI] = ACTIONS(3326),
    [anon_sym_case] = ACTIONS(3326),
    [anon_sym_yield] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_LTtemplate_GT] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_class] = ACTIONS(3326),
    [anon_sym_async] = ACTIONS(3326),
    [anon_sym_function] = ACTIONS(3326),
    [anon_sym_new] = ACTIONS(3326),
    [anon_sym_using] = ACTIONS(3326),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3326),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_void] = ACTIONS(3326),
    [anon_sym_delete] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3326),
    [sym_number] = ACTIONS(3326),
    [sym_private_property_identifier] = ACTIONS(3326),
    [sym_this] = ACTIONS(3326),
    [sym_super] = ACTIONS(3326),
    [sym_true] = ACTIONS(3326),
    [sym_false] = ACTIONS(3326),
    [sym_null] = ACTIONS(3326),
    [sym_undefined] = ACTIONS(3326),
    [anon_sym_AT] = ACTIONS(3326),
    [anon_sym_static] = ACTIONS(3326),
    [anon_sym_readonly] = ACTIONS(3326),
    [anon_sym_get] = ACTIONS(3326),
    [anon_sym_set] = ACTIONS(3326),
    [anon_sym_declare] = ACTIONS(3326),
    [anon_sym_public] = ACTIONS(3326),
    [anon_sym_private] = ACTIONS(3326),
    [anon_sym_protected] = ACTIONS(3326),
    [anon_sym_override] = ACTIONS(3326),
    [anon_sym_module] = ACTIONS(3326),
    [anon_sym_any] = ACTIONS(3326),
    [anon_sym_number] = ACTIONS(3326),
    [anon_sym_boolean] = ACTIONS(3326),
    [anon_sym_string] = ACTIONS(3326),
    [anon_sym_symbol] = ACTIONS(3326),
    [anon_sym_object] = ACTIONS(3326),
    [anon_sym_abstract] = ACTIONS(3326),
    [anon_sym_interface] = ACTIONS(3326),
    [anon_sym_enum] = ACTIONS(3326),
    [sym_html_comment] = ACTIONS(5),
  },
  [1113] = {
    [sym_comment] = STATE(1113),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_default] = ACTIONS(2129),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2129),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_case] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2129),
    [anon_sym_LTtemplate_GT] = ACTIONS(2129),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_using] = ACTIONS(2129),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_number] = ACTIONS(2129),
    [sym_private_property_identifier] = ACTIONS(2129),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_object] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
    [sym__automatic_semicolon] = ACTIONS(2279),
    [sym_html_comment] = ACTIONS(5),
  },
  [1114] = {
    [sym_comment] = STATE(1114),
    [sym_identifier] = ACTIONS(3328),
    [anon_sym_export] = ACTIONS(3328),
    [anon_sym_default] = ACTIONS(3328),
    [anon_sym_type] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_typeof] = ACTIONS(3328),
    [anon_sym_import] = ACTIONS(3328),
    [anon_sym_with] = ACTIONS(3328),
    [anon_sym_var] = ACTIONS(3328),
    [anon_sym_let] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_BANG] = ACTIONS(3328),
    [anon_sym_else] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_await] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_debugger] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_throw] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_case] = ACTIONS(3328),
    [anon_sym_yield] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LTtemplate_GT] = ACTIONS(3328),
    [anon_sym_DQUOTE] = ACTIONS(3328),
    [anon_sym_SQUOTE] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_async] = ACTIONS(3328),
    [anon_sym_function] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_SLASH] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3328),
    [anon_sym_TILDE] = ACTIONS(3328),
    [anon_sym_void] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3328),
    [sym_number] = ACTIONS(3328),
    [sym_private_property_identifier] = ACTIONS(3328),
    [sym_this] = ACTIONS(3328),
    [sym_super] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_null] = ACTIONS(3328),
    [sym_undefined] = ACTIONS(3328),
    [anon_sym_AT] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_readonly] = ACTIONS(3328),
    [anon_sym_get] = ACTIONS(3328),
    [anon_sym_set] = ACTIONS(3328),
    [anon_sym_declare] = ACTIONS(3328),
    [anon_sym_public] = ACTIONS(3328),
    [anon_sym_private] = ACTIONS(3328),
    [anon_sym_protected] = ACTIONS(3328),
    [anon_sym_override] = ACTIONS(3328),
    [anon_sym_module] = ACTIONS(3328),
    [anon_sym_any] = ACTIONS(3328),
    [anon_sym_number] = ACTIONS(3328),
    [anon_sym_boolean] = ACTIONS(3328),
    [anon_sym_string] = ACTIONS(3328),
    [anon_sym_symbol] = ACTIONS(3328),
    [anon_sym_object] = ACTIONS(3328),
    [anon_sym_abstract] = ACTIONS(3328),
    [anon_sym_interface] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [sym_html_comment] = ACTIONS(5),
  },
  [1115] = {
    [sym_comment] = STATE(1115),
    [sym_identifier] = ACTIONS(3268),
    [anon_sym_export] = ACTIONS(3268),
    [anon_sym_default] = ACTIONS(3268),
    [anon_sym_type] = ACTIONS(3268),
    [anon_sym_namespace] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3268),
    [anon_sym_typeof] = ACTIONS(3268),
    [anon_sym_import] = ACTIONS(3268),
    [anon_sym_with] = ACTIONS(3268),
    [anon_sym_var] = ACTIONS(3268),
    [anon_sym_let] = ACTIONS(3268),
    [anon_sym_const] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_else] = ACTIONS(3268),
    [anon_sym_if] = ACTIONS(3268),
    [anon_sym_switch] = ACTIONS(3268),
    [anon_sym_for] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3268),
    [anon_sym_await] = ACTIONS(3268),
    [anon_sym_while] = ACTIONS(3268),
    [anon_sym_do] = ACTIONS(3268),
    [anon_sym_try] = ACTIONS(3268),
    [anon_sym_break] = ACTIONS(3268),
    [anon_sym_continue] = ACTIONS(3268),
    [anon_sym_debugger] = ACTIONS(3268),
    [anon_sym_return] = ACTIONS(3268),
    [anon_sym_throw] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_case] = ACTIONS(3268),
    [anon_sym_yield] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_LTtemplate_GT] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_class] = ACTIONS(3268),
    [anon_sym_async] = ACTIONS(3268),
    [anon_sym_function] = ACTIONS(3268),
    [anon_sym_new] = ACTIONS(3268),
    [anon_sym_using] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_void] = ACTIONS(3268),
    [anon_sym_delete] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3268),
    [sym_number] = ACTIONS(3268),
    [sym_private_property_identifier] = ACTIONS(3268),
    [sym_this] = ACTIONS(3268),
    [sym_super] = ACTIONS(3268),
    [sym_true] = ACTIONS(3268),
    [sym_false] = ACTIONS(3268),
    [sym_null] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_AT] = ACTIONS(3268),
    [anon_sym_static] = ACTIONS(3268),
    [anon_sym_readonly] = ACTIONS(3268),
    [anon_sym_get] = ACTIONS(3268),
    [anon_sym_set] = ACTIONS(3268),
    [anon_sym_declare] = ACTIONS(3268),
    [anon_sym_public] = ACTIONS(3268),
    [anon_sym_private] = ACTIONS(3268),
    [anon_sym_protected] = ACTIONS(3268),
    [anon_sym_override] = ACTIONS(3268),
    [anon_sym_module] = ACTIONS(3268),
    [anon_sym_any] = ACTIONS(3268),
    [anon_sym_number] = ACTIONS(3268),
    [anon_sym_boolean] = ACTIONS(3268),
    [anon_sym_string] = ACTIONS(3268),
    [anon_sym_symbol] = ACTIONS(3268),
    [anon_sym_object] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(3268),
    [anon_sym_interface] = ACTIONS(3268),
    [anon_sym_enum] = ACTIONS(3268),
    [sym_html_comment] = ACTIONS(5),
  },
  [1116] = {
    [sym_comment] = STATE(1116),
    [ts_builtin_sym_end] = ACTIONS(3084),
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_export] = ACTIONS(3082),
    [anon_sym_type] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3082),
    [anon_sym_RBRACE] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3082),
    [anon_sym_import] = ACTIONS(3082),
    [anon_sym_with] = ACTIONS(3082),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_BANG] = ACTIONS(3082),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3082),
    [anon_sym_await] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_debugger] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3082),
    [anon_sym_yield] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_LTtemplate_GT] = ACTIONS(3082),
    [anon_sym_DQUOTE] = ACTIONS(3082),
    [anon_sym_SQUOTE] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_async] = ACTIONS(3082),
    [anon_sym_function] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_TILDE] = ACTIONS(3082),
    [anon_sym_void] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3082),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3082),
    [sym_number] = ACTIONS(3082),
    [sym_private_property_identifier] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
    [sym_super] = ACTIONS(3082),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [sym_null] = ACTIONS(3082),
    [sym_undefined] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_readonly] = ACTIONS(3082),
    [anon_sym_get] = ACTIONS(3082),
    [anon_sym_set] = ACTIONS(3082),
    [anon_sym_declare] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_override] = ACTIONS(3082),
    [anon_sym_module] = ACTIONS(3082),
    [anon_sym_any] = ACTIONS(3082),
    [anon_sym_number] = ACTIONS(3082),
    [anon_sym_boolean] = ACTIONS(3082),
    [anon_sym_string] = ACTIONS(3082),
    [anon_sym_symbol] = ACTIONS(3082),
    [anon_sym_object] = ACTIONS(3082),
    [anon_sym_abstract] = ACTIONS(3082),
    [anon_sym_interface] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [sym__automatic_semicolon] = ACTIONS(3084),
    [sym_html_comment] = ACTIONS(5),
  },
  [1117] = {
    [sym_comment] = STATE(1117),
    [sym_identifier] = ACTIONS(3330),
    [anon_sym_export] = ACTIONS(3330),
    [anon_sym_default] = ACTIONS(3330),
    [anon_sym_type] = ACTIONS(3330),
    [anon_sym_namespace] = ACTIONS(3330),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_RBRACE] = ACTIONS(3330),
    [anon_sym_typeof] = ACTIONS(3330),
    [anon_sym_import] = ACTIONS(3330),
    [anon_sym_with] = ACTIONS(3330),
    [anon_sym_var] = ACTIONS(3330),
    [anon_sym_let] = ACTIONS(3330),
    [anon_sym_const] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_else] = ACTIONS(3330),
    [anon_sym_if] = ACTIONS(3330),
    [anon_sym_switch] = ACTIONS(3330),
    [anon_sym_for] = ACTIONS(3330),
    [anon_sym_LPAREN] = ACTIONS(3330),
    [anon_sym_await] = ACTIONS(3330),
    [anon_sym_while] = ACTIONS(3330),
    [anon_sym_do] = ACTIONS(3330),
    [anon_sym_try] = ACTIONS(3330),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_continue] = ACTIONS(3330),
    [anon_sym_debugger] = ACTIONS(3330),
    [anon_sym_return] = ACTIONS(3330),
    [anon_sym_throw] = ACTIONS(3330),
    [anon_sym_SEMI] = ACTIONS(3330),
    [anon_sym_case] = ACTIONS(3330),
    [anon_sym_yield] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_LTtemplate_GT] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_class] = ACTIONS(3330),
    [anon_sym_async] = ACTIONS(3330),
    [anon_sym_function] = ACTIONS(3330),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_using] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_SLASH] = ACTIONS(3330),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_void] = ACTIONS(3330),
    [anon_sym_delete] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3330),
    [sym_number] = ACTIONS(3330),
    [sym_private_property_identifier] = ACTIONS(3330),
    [sym_this] = ACTIONS(3330),
    [sym_super] = ACTIONS(3330),
    [sym_true] = ACTIONS(3330),
    [sym_false] = ACTIONS(3330),
    [sym_null] = ACTIONS(3330),
    [sym_undefined] = ACTIONS(3330),
    [anon_sym_AT] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3330),
    [anon_sym_readonly] = ACTIONS(3330),
    [anon_sym_get] = ACTIONS(3330),
    [anon_sym_set] = ACTIONS(3330),
    [anon_sym_declare] = ACTIONS(3330),
    [anon_sym_public] = ACTIONS(3330),
    [anon_sym_private] = ACTIONS(3330),
    [anon_sym_protected] = ACTIONS(3330),
    [anon_sym_override] = ACTIONS(3330),
    [anon_sym_module] = ACTIONS(3330),
    [anon_sym_any] = ACTIONS(3330),
    [anon_sym_number] = ACTIONS(3330),
    [anon_sym_boolean] = ACTIONS(3330),
    [anon_sym_string] = ACTIONS(3330),
    [anon_sym_symbol] = ACTIONS(3330),
    [anon_sym_object] = ACTIONS(3330),
    [anon_sym_abstract] = ACTIONS(3330),
    [anon_sym_interface] = ACTIONS(3330),
    [anon_sym_enum] = ACTIONS(3330),
    [sym_html_comment] = ACTIONS(5),
  },
  [1118] = {
    [sym_comment] = STATE(1118),
    [sym_identifier] = ACTIONS(3332),
    [anon_sym_export] = ACTIONS(3332),
    [anon_sym_default] = ACTIONS(3332),
    [anon_sym_type] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_typeof] = ACTIONS(3332),
    [anon_sym_import] = ACTIONS(3332),
    [anon_sym_with] = ACTIONS(3332),
    [anon_sym_var] = ACTIONS(3332),
    [anon_sym_let] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_else] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_await] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_debugger] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_throw] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_case] = ACTIONS(3332),
    [anon_sym_yield] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_LTtemplate_GT] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_async] = ACTIONS(3332),
    [anon_sym_function] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_SLASH] = ACTIONS(3332),
    [anon_sym_LT] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_void] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3332),
    [sym_number] = ACTIONS(3332),
    [sym_private_property_identifier] = ACTIONS(3332),
    [sym_this] = ACTIONS(3332),
    [sym_super] = ACTIONS(3332),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_null] = ACTIONS(3332),
    [sym_undefined] = ACTIONS(3332),
    [anon_sym_AT] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_readonly] = ACTIONS(3332),
    [anon_sym_get] = ACTIONS(3332),
    [anon_sym_set] = ACTIONS(3332),
    [anon_sym_declare] = ACTIONS(3332),
    [anon_sym_public] = ACTIONS(3332),
    [anon_sym_private] = ACTIONS(3332),
    [anon_sym_protected] = ACTIONS(3332),
    [anon_sym_override] = ACTIONS(3332),
    [anon_sym_module] = ACTIONS(3332),
    [anon_sym_any] = ACTIONS(3332),
    [anon_sym_number] = ACTIONS(3332),
    [anon_sym_boolean] = ACTIONS(3332),
    [anon_sym_string] = ACTIONS(3332),
    [anon_sym_symbol] = ACTIONS(3332),
    [anon_sym_object] = ACTIONS(3332),
    [anon_sym_abstract] = ACTIONS(3332),
    [anon_sym_interface] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [sym_html_comment] = ACTIONS(5),
  },
  [1119] = {
    [sym_comment] = STATE(1119),
    [sym_identifier] = ACTIONS(3334),
    [anon_sym_export] = ACTIONS(3334),
    [anon_sym_default] = ACTIONS(3334),
    [anon_sym_type] = ACTIONS(3334),
    [anon_sym_namespace] = ACTIONS(3334),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_typeof] = ACTIONS(3334),
    [anon_sym_import] = ACTIONS(3334),
    [anon_sym_with] = ACTIONS(3334),
    [anon_sym_var] = ACTIONS(3334),
    [anon_sym_let] = ACTIONS(3334),
    [anon_sym_const] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_else] = ACTIONS(3334),
    [anon_sym_if] = ACTIONS(3334),
    [anon_sym_switch] = ACTIONS(3334),
    [anon_sym_for] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3334),
    [anon_sym_await] = ACTIONS(3334),
    [anon_sym_while] = ACTIONS(3334),
    [anon_sym_do] = ACTIONS(3334),
    [anon_sym_try] = ACTIONS(3334),
    [anon_sym_break] = ACTIONS(3334),
    [anon_sym_continue] = ACTIONS(3334),
    [anon_sym_debugger] = ACTIONS(3334),
    [anon_sym_return] = ACTIONS(3334),
    [anon_sym_throw] = ACTIONS(3334),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym_case] = ACTIONS(3334),
    [anon_sym_yield] = ACTIONS(3334),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LTtemplate_GT] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_class] = ACTIONS(3334),
    [anon_sym_async] = ACTIONS(3334),
    [anon_sym_function] = ACTIONS(3334),
    [anon_sym_new] = ACTIONS(3334),
    [anon_sym_using] = ACTIONS(3334),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3334),
    [anon_sym_SLASH] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_void] = ACTIONS(3334),
    [anon_sym_delete] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3334),
    [sym_number] = ACTIONS(3334),
    [sym_private_property_identifier] = ACTIONS(3334),
    [sym_this] = ACTIONS(3334),
    [sym_super] = ACTIONS(3334),
    [sym_true] = ACTIONS(3334),
    [sym_false] = ACTIONS(3334),
    [sym_null] = ACTIONS(3334),
    [sym_undefined] = ACTIONS(3334),
    [anon_sym_AT] = ACTIONS(3334),
    [anon_sym_static] = ACTIONS(3334),
    [anon_sym_readonly] = ACTIONS(3334),
    [anon_sym_get] = ACTIONS(3334),
    [anon_sym_set] = ACTIONS(3334),
    [anon_sym_declare] = ACTIONS(3334),
    [anon_sym_public] = ACTIONS(3334),
    [anon_sym_private] = ACTIONS(3334),
    [anon_sym_protected] = ACTIONS(3334),
    [anon_sym_override] = ACTIONS(3334),
    [anon_sym_module] = ACTIONS(3334),
    [anon_sym_any] = ACTIONS(3334),
    [anon_sym_number] = ACTIONS(3334),
    [anon_sym_boolean] = ACTIONS(3334),
    [anon_sym_string] = ACTIONS(3334),
    [anon_sym_symbol] = ACTIONS(3334),
    [anon_sym_object] = ACTIONS(3334),
    [anon_sym_abstract] = ACTIONS(3334),
    [anon_sym_interface] = ACTIONS(3334),
    [anon_sym_enum] = ACTIONS(3334),
    [sym_html_comment] = ACTIONS(5),
  },
  [1120] = {
    [sym_comment] = STATE(1120),
    [ts_builtin_sym_end] = ACTIONS(2365),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_else] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_LTtemplate_GT] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2083),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_using] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2083),
    [sym_number] = ACTIONS(2083),
    [sym_private_property_identifier] = ACTIONS(2083),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2083),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_readonly] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_override] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_object] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [sym__automatic_semicolon] = ACTIONS(2367),
    [sym_html_comment] = ACTIONS(5),
  },
  [1121] = {
    [sym_comment] = STATE(1121),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3336),
    [sym_html_comment] = ACTIONS(5),
  },
  [1122] = {
    [sym_comment] = STATE(1122),
    [sym_identifier] = ACTIONS(3334),
    [anon_sym_export] = ACTIONS(3334),
    [anon_sym_default] = ACTIONS(3334),
    [anon_sym_type] = ACTIONS(3334),
    [anon_sym_namespace] = ACTIONS(3334),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_typeof] = ACTIONS(3334),
    [anon_sym_import] = ACTIONS(3334),
    [anon_sym_with] = ACTIONS(3334),
    [anon_sym_var] = ACTIONS(3334),
    [anon_sym_let] = ACTIONS(3334),
    [anon_sym_const] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_else] = ACTIONS(3334),
    [anon_sym_if] = ACTIONS(3334),
    [anon_sym_switch] = ACTIONS(3334),
    [anon_sym_for] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3334),
    [anon_sym_await] = ACTIONS(3334),
    [anon_sym_while] = ACTIONS(3334),
    [anon_sym_do] = ACTIONS(3334),
    [anon_sym_try] = ACTIONS(3334),
    [anon_sym_break] = ACTIONS(3334),
    [anon_sym_continue] = ACTIONS(3334),
    [anon_sym_debugger] = ACTIONS(3334),
    [anon_sym_return] = ACTIONS(3334),
    [anon_sym_throw] = ACTIONS(3334),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym_case] = ACTIONS(3334),
    [anon_sym_yield] = ACTIONS(3334),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LTtemplate_GT] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_class] = ACTIONS(3334),
    [anon_sym_async] = ACTIONS(3334),
    [anon_sym_function] = ACTIONS(3334),
    [anon_sym_new] = ACTIONS(3334),
    [anon_sym_using] = ACTIONS(3334),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3334),
    [anon_sym_SLASH] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_void] = ACTIONS(3334),
    [anon_sym_delete] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3334),
    [sym_number] = ACTIONS(3334),
    [sym_private_property_identifier] = ACTIONS(3334),
    [sym_this] = ACTIONS(3334),
    [sym_super] = ACTIONS(3334),
    [sym_true] = ACTIONS(3334),
    [sym_false] = ACTIONS(3334),
    [sym_null] = ACTIONS(3334),
    [sym_undefined] = ACTIONS(3334),
    [anon_sym_AT] = ACTIONS(3334),
    [anon_sym_static] = ACTIONS(3334),
    [anon_sym_readonly] = ACTIONS(3334),
    [anon_sym_get] = ACTIONS(3334),
    [anon_sym_set] = ACTIONS(3334),
    [anon_sym_declare] = ACTIONS(3334),
    [anon_sym_public] = ACTIONS(3334),
    [anon_sym_private] = ACTIONS(3334),
    [anon_sym_protected] = ACTIONS(3334),
    [anon_sym_override] = ACTIONS(3334),
    [anon_sym_module] = ACTIONS(3334),
    [anon_sym_any] = ACTIONS(3334),
    [anon_sym_number] = ACTIONS(3334),
    [anon_sym_boolean] = ACTIONS(3334),
    [anon_sym_string] = ACTIONS(3334),
    [anon_sym_symbol] = ACTIONS(3334),
    [anon_sym_object] = ACTIONS(3334),
    [anon_sym_abstract] = ACTIONS(3334),
    [anon_sym_interface] = ACTIONS(3334),
    [anon_sym_enum] = ACTIONS(3334),
    [sym_html_comment] = ACTIONS(5),
  },
  [1123] = {
    [sym_comment] = STATE(1123),
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_export] = ACTIONS(3338),
    [anon_sym_default] = ACTIONS(3338),
    [anon_sym_type] = ACTIONS(3338),
    [anon_sym_namespace] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_typeof] = ACTIONS(3338),
    [anon_sym_import] = ACTIONS(3338),
    [anon_sym_with] = ACTIONS(3338),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_else] = ACTIONS(3338),
    [anon_sym_if] = ACTIONS(3338),
    [anon_sym_switch] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3338),
    [anon_sym_await] = ACTIONS(3338),
    [anon_sym_while] = ACTIONS(3338),
    [anon_sym_do] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3338),
    [anon_sym_break] = ACTIONS(3338),
    [anon_sym_continue] = ACTIONS(3338),
    [anon_sym_debugger] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3338),
    [anon_sym_throw] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym_case] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_LTtemplate_GT] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_class] = ACTIONS(3338),
    [anon_sym_async] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3338),
    [anon_sym_using] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3338),
    [anon_sym_delete] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3338),
    [sym_number] = ACTIONS(3338),
    [sym_private_property_identifier] = ACTIONS(3338),
    [sym_this] = ACTIONS(3338),
    [sym_super] = ACTIONS(3338),
    [sym_true] = ACTIONS(3338),
    [sym_false] = ACTIONS(3338),
    [sym_null] = ACTIONS(3338),
    [sym_undefined] = ACTIONS(3338),
    [anon_sym_AT] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_readonly] = ACTIONS(3338),
    [anon_sym_get] = ACTIONS(3338),
    [anon_sym_set] = ACTIONS(3338),
    [anon_sym_declare] = ACTIONS(3338),
    [anon_sym_public] = ACTIONS(3338),
    [anon_sym_private] = ACTIONS(3338),
    [anon_sym_protected] = ACTIONS(3338),
    [anon_sym_override] = ACTIONS(3338),
    [anon_sym_module] = ACTIONS(3338),
    [anon_sym_any] = ACTIONS(3338),
    [anon_sym_number] = ACTIONS(3338),
    [anon_sym_boolean] = ACTIONS(3338),
    [anon_sym_string] = ACTIONS(3338),
    [anon_sym_symbol] = ACTIONS(3338),
    [anon_sym_object] = ACTIONS(3338),
    [anon_sym_abstract] = ACTIONS(3338),
    [anon_sym_interface] = ACTIONS(3338),
    [anon_sym_enum] = ACTIONS(3338),
    [sym_html_comment] = ACTIONS(5),
  },
  [1124] = {
    [sym_comment] = STATE(1124),
    [sym_identifier] = ACTIONS(2167),
    [anon_sym_export] = ACTIONS(2167),
    [anon_sym_default] = ACTIONS(2167),
    [anon_sym_type] = ACTIONS(2167),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2167),
    [anon_sym_with] = ACTIONS(2167),
    [anon_sym_var] = ACTIONS(2167),
    [anon_sym_let] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_debugger] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_case] = ACTIONS(2167),
    [anon_sym_yield] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LTtemplate_GT] = ACTIONS(2167),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_async] = ACTIONS(2167),
    [anon_sym_function] = ACTIONS(2167),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_LT] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_void] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [sym_number] = ACTIONS(2167),
    [sym_private_property_identifier] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [sym_super] = ACTIONS(2167),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_undefined] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_readonly] = ACTIONS(2167),
    [anon_sym_get] = ACTIONS(2167),
    [anon_sym_set] = ACTIONS(2167),
    [anon_sym_declare] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_override] = ACTIONS(2167),
    [anon_sym_module] = ACTIONS(2167),
    [anon_sym_any] = ACTIONS(2167),
    [anon_sym_number] = ACTIONS(2167),
    [anon_sym_boolean] = ACTIONS(2167),
    [anon_sym_string] = ACTIONS(2167),
    [anon_sym_symbol] = ACTIONS(2167),
    [anon_sym_object] = ACTIONS(2167),
    [anon_sym_abstract] = ACTIONS(2167),
    [anon_sym_interface] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [sym__automatic_semicolon] = ACTIONS(2395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1125] = {
    [sym_comment] = STATE(1125),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2205),
    [anon_sym_default] = ACTIONS(2205),
    [anon_sym_type] = ACTIONS(2205),
    [anon_sym_namespace] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_typeof] = ACTIONS(2205),
    [anon_sym_import] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2205),
    [anon_sym_var] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_await] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(2205),
    [anon_sym_do] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2205),
    [anon_sym_break] = ACTIONS(2205),
    [anon_sym_continue] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2205),
    [anon_sym_return] = ACTIONS(2205),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_case] = ACTIONS(2205),
    [anon_sym_yield] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_LTtemplate_GT] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_class] = ACTIONS(2205),
    [anon_sym_async] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2205),
    [anon_sym_new] = ACTIONS(2205),
    [anon_sym_using] = ACTIONS(2205),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_void] = ACTIONS(2205),
    [anon_sym_delete] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_number] = ACTIONS(2205),
    [sym_private_property_identifier] = ACTIONS(2205),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(2205),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [anon_sym_static] = ACTIONS(2205),
    [anon_sym_readonly] = ACTIONS(2205),
    [anon_sym_get] = ACTIONS(2205),
    [anon_sym_set] = ACTIONS(2205),
    [anon_sym_declare] = ACTIONS(2205),
    [anon_sym_public] = ACTIONS(2205),
    [anon_sym_private] = ACTIONS(2205),
    [anon_sym_protected] = ACTIONS(2205),
    [anon_sym_override] = ACTIONS(2205),
    [anon_sym_module] = ACTIONS(2205),
    [anon_sym_any] = ACTIONS(2205),
    [anon_sym_number] = ACTIONS(2205),
    [anon_sym_boolean] = ACTIONS(2205),
    [anon_sym_string] = ACTIONS(2205),
    [anon_sym_symbol] = ACTIONS(2205),
    [anon_sym_object] = ACTIONS(2205),
    [anon_sym_abstract] = ACTIONS(2205),
    [anon_sym_interface] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2205),
    [sym__automatic_semicolon] = ACTIONS(2391),
    [sym_html_comment] = ACTIONS(5),
  },
  [1126] = {
    [sym_comment] = STATE(1126),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_export] = ACTIONS(3340),
    [anon_sym_default] = ACTIONS(3340),
    [anon_sym_type] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3340),
    [anon_sym_typeof] = ACTIONS(3340),
    [anon_sym_import] = ACTIONS(3340),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_var] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_BANG] = ACTIONS(3340),
    [anon_sym_else] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_await] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_debugger] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_throw] = ACTIONS(3340),
    [anon_sym_SEMI] = ACTIONS(3340),
    [anon_sym_case] = ACTIONS(3340),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LTtemplate_GT] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_SQUOTE] = ACTIONS(3340),
    [anon_sym_class] = ACTIONS(3340),
    [anon_sym_async] = ACTIONS(3340),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_SLASH] = ACTIONS(3340),
    [anon_sym_LT] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3340),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_delete] = ACTIONS(3340),
    [anon_sym_PLUS_PLUS] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3340),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3340),
    [sym_number] = ACTIONS(3340),
    [sym_private_property_identifier] = ACTIONS(3340),
    [sym_this] = ACTIONS(3340),
    [sym_super] = ACTIONS(3340),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [sym_null] = ACTIONS(3340),
    [sym_undefined] = ACTIONS(3340),
    [anon_sym_AT] = ACTIONS(3340),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_readonly] = ACTIONS(3340),
    [anon_sym_get] = ACTIONS(3340),
    [anon_sym_set] = ACTIONS(3340),
    [anon_sym_declare] = ACTIONS(3340),
    [anon_sym_public] = ACTIONS(3340),
    [anon_sym_private] = ACTIONS(3340),
    [anon_sym_protected] = ACTIONS(3340),
    [anon_sym_override] = ACTIONS(3340),
    [anon_sym_module] = ACTIONS(3340),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_object] = ACTIONS(3340),
    [anon_sym_abstract] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [sym_html_comment] = ACTIONS(5),
  },
  [1127] = {
    [sym_comment] = STATE(1127),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_finally] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1128] = {
    [sym_comment] = STATE(1128),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1129] = {
    [sym_comment] = STATE(1129),
    [sym_identifier] = ACTIONS(3342),
    [anon_sym_export] = ACTIONS(3342),
    [anon_sym_default] = ACTIONS(3342),
    [anon_sym_type] = ACTIONS(3342),
    [anon_sym_namespace] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_typeof] = ACTIONS(3342),
    [anon_sym_import] = ACTIONS(3342),
    [anon_sym_with] = ACTIONS(3342),
    [anon_sym_var] = ACTIONS(3342),
    [anon_sym_let] = ACTIONS(3342),
    [anon_sym_const] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_else] = ACTIONS(3342),
    [anon_sym_if] = ACTIONS(3342),
    [anon_sym_switch] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3342),
    [anon_sym_await] = ACTIONS(3342),
    [anon_sym_while] = ACTIONS(3342),
    [anon_sym_do] = ACTIONS(3342),
    [anon_sym_try] = ACTIONS(3342),
    [anon_sym_break] = ACTIONS(3342),
    [anon_sym_continue] = ACTIONS(3342),
    [anon_sym_debugger] = ACTIONS(3342),
    [anon_sym_return] = ACTIONS(3342),
    [anon_sym_throw] = ACTIONS(3342),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym_case] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3342),
    [anon_sym_LBRACK] = ACTIONS(3342),
    [anon_sym_LTtemplate_GT] = ACTIONS(3342),
    [anon_sym_DQUOTE] = ACTIONS(3342),
    [anon_sym_SQUOTE] = ACTIONS(3342),
    [anon_sym_class] = ACTIONS(3342),
    [anon_sym_async] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3342),
    [anon_sym_using] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_SLASH] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_void] = ACTIONS(3342),
    [anon_sym_delete] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3342),
    [sym_number] = ACTIONS(3342),
    [sym_private_property_identifier] = ACTIONS(3342),
    [sym_this] = ACTIONS(3342),
    [sym_super] = ACTIONS(3342),
    [sym_true] = ACTIONS(3342),
    [sym_false] = ACTIONS(3342),
    [sym_null] = ACTIONS(3342),
    [sym_undefined] = ACTIONS(3342),
    [anon_sym_AT] = ACTIONS(3342),
    [anon_sym_static] = ACTIONS(3342),
    [anon_sym_readonly] = ACTIONS(3342),
    [anon_sym_get] = ACTIONS(3342),
    [anon_sym_set] = ACTIONS(3342),
    [anon_sym_declare] = ACTIONS(3342),
    [anon_sym_public] = ACTIONS(3342),
    [anon_sym_private] = ACTIONS(3342),
    [anon_sym_protected] = ACTIONS(3342),
    [anon_sym_override] = ACTIONS(3342),
    [anon_sym_module] = ACTIONS(3342),
    [anon_sym_any] = ACTIONS(3342),
    [anon_sym_number] = ACTIONS(3342),
    [anon_sym_boolean] = ACTIONS(3342),
    [anon_sym_string] = ACTIONS(3342),
    [anon_sym_symbol] = ACTIONS(3342),
    [anon_sym_object] = ACTIONS(3342),
    [anon_sym_abstract] = ACTIONS(3342),
    [anon_sym_interface] = ACTIONS(3342),
    [anon_sym_enum] = ACTIONS(3342),
    [sym_html_comment] = ACTIONS(5),
  },
  [1130] = {
    [sym_comment] = STATE(1130),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_export] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_type] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_RBRACE] = ACTIONS(3344),
    [anon_sym_typeof] = ACTIONS(3344),
    [anon_sym_import] = ACTIONS(3344),
    [anon_sym_with] = ACTIONS(3344),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_await] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_debugger] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LTtemplate_GT] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_SQUOTE] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_async] = ACTIONS(3344),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_SLASH] = ACTIONS(3344),
    [anon_sym_LT] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_void] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_PLUS_PLUS] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3344),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3344),
    [sym_number] = ACTIONS(3344),
    [sym_private_property_identifier] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [sym_super] = ACTIONS(3344),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [sym_null] = ACTIONS(3344),
    [sym_undefined] = ACTIONS(3344),
    [anon_sym_AT] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_readonly] = ACTIONS(3344),
    [anon_sym_get] = ACTIONS(3344),
    [anon_sym_set] = ACTIONS(3344),
    [anon_sym_declare] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_override] = ACTIONS(3344),
    [anon_sym_module] = ACTIONS(3344),
    [anon_sym_any] = ACTIONS(3344),
    [anon_sym_number] = ACTIONS(3344),
    [anon_sym_boolean] = ACTIONS(3344),
    [anon_sym_string] = ACTIONS(3344),
    [anon_sym_symbol] = ACTIONS(3344),
    [anon_sym_object] = ACTIONS(3344),
    [anon_sym_abstract] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1131] = {
    [sym_comment] = STATE(1131),
    [ts_builtin_sym_end] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_export] = ACTIONS(2197),
    [anon_sym_type] = ACTIONS(2197),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_RBRACE] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_import] = ACTIONS(2197),
    [anon_sym_with] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_debugger] = ACTIONS(2197),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_LTtemplate_GT] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_function] = ACTIONS(2197),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2197),
    [sym_number] = ACTIONS(2197),
    [sym_private_property_identifier] = ACTIONS(2197),
    [sym_this] = ACTIONS(2197),
    [sym_super] = ACTIONS(2197),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [sym_null] = ACTIONS(2197),
    [sym_undefined] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_declare] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_module] = ACTIONS(2197),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_boolean] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_object] = ACTIONS(2197),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [sym__automatic_semicolon] = ACTIONS(2345),
    [sym_html_comment] = ACTIONS(5),
  },
  [1132] = {
    [sym_comment] = STATE(1132),
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_export] = ACTIONS(2197),
    [anon_sym_default] = ACTIONS(2197),
    [anon_sym_type] = ACTIONS(2197),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_RBRACE] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_import] = ACTIONS(2197),
    [anon_sym_with] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_debugger] = ACTIONS(2197),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_case] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_LTtemplate_GT] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_function] = ACTIONS(2197),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2197),
    [sym_number] = ACTIONS(2197),
    [sym_private_property_identifier] = ACTIONS(2197),
    [sym_this] = ACTIONS(2197),
    [sym_super] = ACTIONS(2197),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [sym_null] = ACTIONS(2197),
    [sym_undefined] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_declare] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_module] = ACTIONS(2197),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_boolean] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_object] = ACTIONS(2197),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [sym__automatic_semicolon] = ACTIONS(2385),
    [sym_html_comment] = ACTIONS(5),
  },
  [1133] = {
    [sym_comment] = STATE(1133),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_LTtemplate_GT] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_function] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2251),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_number] = ACTIONS(2251),
    [sym_private_property_identifier] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [sym_null] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_readonly] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_override] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_object] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [sym_html_comment] = ACTIONS(5),
  },
  [1134] = {
    [sym_comment] = STATE(1134),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_export] = ACTIONS(3346),
    [anon_sym_default] = ACTIONS(3346),
    [anon_sym_type] = ACTIONS(3346),
    [anon_sym_namespace] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_typeof] = ACTIONS(3346),
    [anon_sym_import] = ACTIONS(3346),
    [anon_sym_with] = ACTIONS(3346),
    [anon_sym_var] = ACTIONS(3346),
    [anon_sym_let] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_else] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_switch] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_await] = ACTIONS(3346),
    [anon_sym_while] = ACTIONS(3346),
    [anon_sym_do] = ACTIONS(3346),
    [anon_sym_try] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_debugger] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_throw] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_case] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_LTtemplate_GT] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_async] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_SLASH] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_void] = ACTIONS(3346),
    [anon_sym_delete] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3346),
    [sym_number] = ACTIONS(3346),
    [sym_private_property_identifier] = ACTIONS(3346),
    [sym_this] = ACTIONS(3346),
    [sym_super] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_null] = ACTIONS(3346),
    [sym_undefined] = ACTIONS(3346),
    [anon_sym_AT] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_readonly] = ACTIONS(3346),
    [anon_sym_get] = ACTIONS(3346),
    [anon_sym_set] = ACTIONS(3346),
    [anon_sym_declare] = ACTIONS(3346),
    [anon_sym_public] = ACTIONS(3346),
    [anon_sym_private] = ACTIONS(3346),
    [anon_sym_protected] = ACTIONS(3346),
    [anon_sym_override] = ACTIONS(3346),
    [anon_sym_module] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3346),
    [anon_sym_number] = ACTIONS(3346),
    [anon_sym_boolean] = ACTIONS(3346),
    [anon_sym_string] = ACTIONS(3346),
    [anon_sym_symbol] = ACTIONS(3346),
    [anon_sym_object] = ACTIONS(3346),
    [anon_sym_abstract] = ACTIONS(3346),
    [anon_sym_interface] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [sym_html_comment] = ACTIONS(5),
  },
  [1135] = {
    [sym_comment] = STATE(1135),
    [sym_identifier] = ACTIONS(3348),
    [anon_sym_export] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_type] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_RBRACE] = ACTIONS(3348),
    [anon_sym_typeof] = ACTIONS(3348),
    [anon_sym_import] = ACTIONS(3348),
    [anon_sym_with] = ACTIONS(3348),
    [anon_sym_var] = ACTIONS(3348),
    [anon_sym_let] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_BANG] = ACTIONS(3348),
    [anon_sym_else] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_LPAREN] = ACTIONS(3348),
    [anon_sym_await] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_debugger] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_throw] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_yield] = ACTIONS(3348),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_LTtemplate_GT] = ACTIONS(3348),
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [anon_sym_SQUOTE] = ACTIONS(3348),
    [anon_sym_class] = ACTIONS(3348),
    [anon_sym_async] = ACTIONS(3348),
    [anon_sym_function] = ACTIONS(3348),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3348),
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_void] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [sym_number] = ACTIONS(3348),
    [sym_private_property_identifier] = ACTIONS(3348),
    [sym_this] = ACTIONS(3348),
    [sym_super] = ACTIONS(3348),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_undefined] = ACTIONS(3348),
    [anon_sym_AT] = ACTIONS(3348),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_readonly] = ACTIONS(3348),
    [anon_sym_get] = ACTIONS(3348),
    [anon_sym_set] = ACTIONS(3348),
    [anon_sym_declare] = ACTIONS(3348),
    [anon_sym_public] = ACTIONS(3348),
    [anon_sym_private] = ACTIONS(3348),
    [anon_sym_protected] = ACTIONS(3348),
    [anon_sym_override] = ACTIONS(3348),
    [anon_sym_module] = ACTIONS(3348),
    [anon_sym_any] = ACTIONS(3348),
    [anon_sym_number] = ACTIONS(3348),
    [anon_sym_boolean] = ACTIONS(3348),
    [anon_sym_string] = ACTIONS(3348),
    [anon_sym_symbol] = ACTIONS(3348),
    [anon_sym_object] = ACTIONS(3348),
    [anon_sym_abstract] = ACTIONS(3348),
    [anon_sym_interface] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [sym_html_comment] = ACTIONS(5),
  },
  [1136] = {
    [sym_comment] = STATE(1136),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_export] = ACTIONS(3350),
    [anon_sym_default] = ACTIONS(3350),
    [anon_sym_type] = ACTIONS(3350),
    [anon_sym_namespace] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3350),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_typeof] = ACTIONS(3350),
    [anon_sym_import] = ACTIONS(3350),
    [anon_sym_with] = ACTIONS(3350),
    [anon_sym_var] = ACTIONS(3350),
    [anon_sym_let] = ACTIONS(3350),
    [anon_sym_const] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_else] = ACTIONS(3350),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_switch] = ACTIONS(3350),
    [anon_sym_for] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym_await] = ACTIONS(3350),
    [anon_sym_while] = ACTIONS(3350),
    [anon_sym_do] = ACTIONS(3350),
    [anon_sym_try] = ACTIONS(3350),
    [anon_sym_break] = ACTIONS(3350),
    [anon_sym_continue] = ACTIONS(3350),
    [anon_sym_debugger] = ACTIONS(3350),
    [anon_sym_return] = ACTIONS(3350),
    [anon_sym_throw] = ACTIONS(3350),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym_case] = ACTIONS(3350),
    [anon_sym_yield] = ACTIONS(3350),
    [anon_sym_LBRACK] = ACTIONS(3350),
    [anon_sym_LTtemplate_GT] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_class] = ACTIONS(3350),
    [anon_sym_async] = ACTIONS(3350),
    [anon_sym_function] = ACTIONS(3350),
    [anon_sym_new] = ACTIONS(3350),
    [anon_sym_using] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_void] = ACTIONS(3350),
    [anon_sym_delete] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [sym_number] = ACTIONS(3350),
    [sym_private_property_identifier] = ACTIONS(3350),
    [sym_this] = ACTIONS(3350),
    [sym_super] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_null] = ACTIONS(3350),
    [sym_undefined] = ACTIONS(3350),
    [anon_sym_AT] = ACTIONS(3350),
    [anon_sym_static] = ACTIONS(3350),
    [anon_sym_readonly] = ACTIONS(3350),
    [anon_sym_get] = ACTIONS(3350),
    [anon_sym_set] = ACTIONS(3350),
    [anon_sym_declare] = ACTIONS(3350),
    [anon_sym_public] = ACTIONS(3350),
    [anon_sym_private] = ACTIONS(3350),
    [anon_sym_protected] = ACTIONS(3350),
    [anon_sym_override] = ACTIONS(3350),
    [anon_sym_module] = ACTIONS(3350),
    [anon_sym_any] = ACTIONS(3350),
    [anon_sym_number] = ACTIONS(3350),
    [anon_sym_boolean] = ACTIONS(3350),
    [anon_sym_string] = ACTIONS(3350),
    [anon_sym_symbol] = ACTIONS(3350),
    [anon_sym_object] = ACTIONS(3350),
    [anon_sym_abstract] = ACTIONS(3350),
    [anon_sym_interface] = ACTIONS(3350),
    [anon_sym_enum] = ACTIONS(3350),
    [sym_html_comment] = ACTIONS(5),
  },
  [1137] = {
    [sym_comment] = STATE(1137),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_export] = ACTIONS(3352),
    [anon_sym_default] = ACTIONS(3352),
    [anon_sym_type] = ACTIONS(3352),
    [anon_sym_namespace] = ACTIONS(3352),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_RBRACE] = ACTIONS(3352),
    [anon_sym_typeof] = ACTIONS(3352),
    [anon_sym_import] = ACTIONS(3352),
    [anon_sym_with] = ACTIONS(3352),
    [anon_sym_var] = ACTIONS(3352),
    [anon_sym_let] = ACTIONS(3352),
    [anon_sym_const] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_else] = ACTIONS(3352),
    [anon_sym_if] = ACTIONS(3352),
    [anon_sym_switch] = ACTIONS(3352),
    [anon_sym_for] = ACTIONS(3352),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [anon_sym_await] = ACTIONS(3352),
    [anon_sym_while] = ACTIONS(3352),
    [anon_sym_do] = ACTIONS(3352),
    [anon_sym_try] = ACTIONS(3352),
    [anon_sym_break] = ACTIONS(3352),
    [anon_sym_continue] = ACTIONS(3352),
    [anon_sym_debugger] = ACTIONS(3352),
    [anon_sym_return] = ACTIONS(3352),
    [anon_sym_throw] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_case] = ACTIONS(3352),
    [anon_sym_yield] = ACTIONS(3352),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_LTtemplate_GT] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [anon_sym_SQUOTE] = ACTIONS(3352),
    [anon_sym_class] = ACTIONS(3352),
    [anon_sym_async] = ACTIONS(3352),
    [anon_sym_function] = ACTIONS(3352),
    [anon_sym_new] = ACTIONS(3352),
    [anon_sym_using] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_SLASH] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_void] = ACTIONS(3352),
    [anon_sym_delete] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [sym_number] = ACTIONS(3352),
    [sym_private_property_identifier] = ACTIONS(3352),
    [sym_this] = ACTIONS(3352),
    [sym_super] = ACTIONS(3352),
    [sym_true] = ACTIONS(3352),
    [sym_false] = ACTIONS(3352),
    [sym_null] = ACTIONS(3352),
    [sym_undefined] = ACTIONS(3352),
    [anon_sym_AT] = ACTIONS(3352),
    [anon_sym_static] = ACTIONS(3352),
    [anon_sym_readonly] = ACTIONS(3352),
    [anon_sym_get] = ACTIONS(3352),
    [anon_sym_set] = ACTIONS(3352),
    [anon_sym_declare] = ACTIONS(3352),
    [anon_sym_public] = ACTIONS(3352),
    [anon_sym_private] = ACTIONS(3352),
    [anon_sym_protected] = ACTIONS(3352),
    [anon_sym_override] = ACTIONS(3352),
    [anon_sym_module] = ACTIONS(3352),
    [anon_sym_any] = ACTIONS(3352),
    [anon_sym_number] = ACTIONS(3352),
    [anon_sym_boolean] = ACTIONS(3352),
    [anon_sym_string] = ACTIONS(3352),
    [anon_sym_symbol] = ACTIONS(3352),
    [anon_sym_object] = ACTIONS(3352),
    [anon_sym_abstract] = ACTIONS(3352),
    [anon_sym_interface] = ACTIONS(3352),
    [anon_sym_enum] = ACTIONS(3352),
    [sym_html_comment] = ACTIONS(5),
  },
  [1138] = {
    [sym_comment] = STATE(1138),
    [sym_identifier] = ACTIONS(3354),
    [anon_sym_export] = ACTIONS(3354),
    [anon_sym_default] = ACTIONS(3354),
    [anon_sym_type] = ACTIONS(3354),
    [anon_sym_namespace] = ACTIONS(3354),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_RBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3354),
    [anon_sym_import] = ACTIONS(3354),
    [anon_sym_with] = ACTIONS(3354),
    [anon_sym_var] = ACTIONS(3354),
    [anon_sym_let] = ACTIONS(3354),
    [anon_sym_const] = ACTIONS(3354),
    [anon_sym_BANG] = ACTIONS(3354),
    [anon_sym_else] = ACTIONS(3354),
    [anon_sym_if] = ACTIONS(3354),
    [anon_sym_switch] = ACTIONS(3354),
    [anon_sym_for] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3354),
    [anon_sym_await] = ACTIONS(3354),
    [anon_sym_while] = ACTIONS(3354),
    [anon_sym_do] = ACTIONS(3354),
    [anon_sym_try] = ACTIONS(3354),
    [anon_sym_break] = ACTIONS(3354),
    [anon_sym_continue] = ACTIONS(3354),
    [anon_sym_debugger] = ACTIONS(3354),
    [anon_sym_return] = ACTIONS(3354),
    [anon_sym_throw] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(3354),
    [anon_sym_case] = ACTIONS(3354),
    [anon_sym_yield] = ACTIONS(3354),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_LTtemplate_GT] = ACTIONS(3354),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_class] = ACTIONS(3354),
    [anon_sym_async] = ACTIONS(3354),
    [anon_sym_function] = ACTIONS(3354),
    [anon_sym_new] = ACTIONS(3354),
    [anon_sym_using] = ACTIONS(3354),
    [anon_sym_PLUS] = ACTIONS(3354),
    [anon_sym_DASH] = ACTIONS(3354),
    [anon_sym_SLASH] = ACTIONS(3354),
    [anon_sym_LT] = ACTIONS(3354),
    [anon_sym_TILDE] = ACTIONS(3354),
    [anon_sym_void] = ACTIONS(3354),
    [anon_sym_delete] = ACTIONS(3354),
    [anon_sym_PLUS_PLUS] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3354),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3354),
    [sym_number] = ACTIONS(3354),
    [sym_private_property_identifier] = ACTIONS(3354),
    [sym_this] = ACTIONS(3354),
    [sym_super] = ACTIONS(3354),
    [sym_true] = ACTIONS(3354),
    [sym_false] = ACTIONS(3354),
    [sym_null] = ACTIONS(3354),
    [sym_undefined] = ACTIONS(3354),
    [anon_sym_AT] = ACTIONS(3354),
    [anon_sym_static] = ACTIONS(3354),
    [anon_sym_readonly] = ACTIONS(3354),
    [anon_sym_get] = ACTIONS(3354),
    [anon_sym_set] = ACTIONS(3354),
    [anon_sym_declare] = ACTIONS(3354),
    [anon_sym_public] = ACTIONS(3354),
    [anon_sym_private] = ACTIONS(3354),
    [anon_sym_protected] = ACTIONS(3354),
    [anon_sym_override] = ACTIONS(3354),
    [anon_sym_module] = ACTIONS(3354),
    [anon_sym_any] = ACTIONS(3354),
    [anon_sym_number] = ACTIONS(3354),
    [anon_sym_boolean] = ACTIONS(3354),
    [anon_sym_string] = ACTIONS(3354),
    [anon_sym_symbol] = ACTIONS(3354),
    [anon_sym_object] = ACTIONS(3354),
    [anon_sym_abstract] = ACTIONS(3354),
    [anon_sym_interface] = ACTIONS(3354),
    [anon_sym_enum] = ACTIONS(3354),
    [sym_html_comment] = ACTIONS(5),
  },
  [1139] = {
    [sym_comment] = STATE(1139),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_default] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_else] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym_case] = ACTIONS(3356),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LTtemplate_GT] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_using] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [sym_number] = ACTIONS(3356),
    [sym_private_property_identifier] = ACTIONS(3356),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3356),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_object] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [sym_html_comment] = ACTIONS(5),
  },
  [1140] = {
    [sym_comment] = STATE(1140),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_default] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_else] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym_case] = ACTIONS(3356),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LTtemplate_GT] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_using] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [sym_number] = ACTIONS(3356),
    [sym_private_property_identifier] = ACTIONS(3356),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3356),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_object] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [sym_html_comment] = ACTIONS(5),
  },
  [1141] = {
    [sym_comment] = STATE(1141),
    [sym_identifier] = ACTIONS(3358),
    [anon_sym_export] = ACTIONS(3358),
    [anon_sym_default] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3358),
    [anon_sym_namespace] = ACTIONS(3358),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_RBRACE] = ACTIONS(3358),
    [anon_sym_typeof] = ACTIONS(3358),
    [anon_sym_import] = ACTIONS(3358),
    [anon_sym_with] = ACTIONS(3358),
    [anon_sym_var] = ACTIONS(3358),
    [anon_sym_let] = ACTIONS(3358),
    [anon_sym_const] = ACTIONS(3358),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_else] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3358),
    [anon_sym_switch] = ACTIONS(3358),
    [anon_sym_for] = ACTIONS(3358),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3358),
    [anon_sym_while] = ACTIONS(3358),
    [anon_sym_do] = ACTIONS(3358),
    [anon_sym_try] = ACTIONS(3358),
    [anon_sym_break] = ACTIONS(3358),
    [anon_sym_continue] = ACTIONS(3358),
    [anon_sym_debugger] = ACTIONS(3358),
    [anon_sym_return] = ACTIONS(3358),
    [anon_sym_throw] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_case] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3358),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [anon_sym_class] = ACTIONS(3358),
    [anon_sym_async] = ACTIONS(3358),
    [anon_sym_function] = ACTIONS(3358),
    [anon_sym_new] = ACTIONS(3358),
    [anon_sym_using] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3358),
    [anon_sym_DASH] = ACTIONS(3358),
    [anon_sym_SLASH] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3358),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_private_property_identifier] = ACTIONS(3358),
    [sym_this] = ACTIONS(3358),
    [sym_super] = ACTIONS(3358),
    [sym_true] = ACTIONS(3358),
    [sym_false] = ACTIONS(3358),
    [sym_null] = ACTIONS(3358),
    [sym_undefined] = ACTIONS(3358),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3358),
    [anon_sym_readonly] = ACTIONS(3358),
    [anon_sym_get] = ACTIONS(3358),
    [anon_sym_set] = ACTIONS(3358),
    [anon_sym_declare] = ACTIONS(3358),
    [anon_sym_public] = ACTIONS(3358),
    [anon_sym_private] = ACTIONS(3358),
    [anon_sym_protected] = ACTIONS(3358),
    [anon_sym_override] = ACTIONS(3358),
    [anon_sym_module] = ACTIONS(3358),
    [anon_sym_any] = ACTIONS(3358),
    [anon_sym_number] = ACTIONS(3358),
    [anon_sym_boolean] = ACTIONS(3358),
    [anon_sym_string] = ACTIONS(3358),
    [anon_sym_symbol] = ACTIONS(3358),
    [anon_sym_object] = ACTIONS(3358),
    [anon_sym_abstract] = ACTIONS(3358),
    [anon_sym_interface] = ACTIONS(3358),
    [anon_sym_enum] = ACTIONS(3358),
    [sym_html_comment] = ACTIONS(5),
  },
  [1142] = {
    [sym_comment] = STATE(1142),
    [sym_identifier] = ACTIONS(3102),
    [anon_sym_export] = ACTIONS(3102),
    [anon_sym_default] = ACTIONS(3102),
    [anon_sym_type] = ACTIONS(3102),
    [anon_sym_namespace] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_typeof] = ACTIONS(3102),
    [anon_sym_import] = ACTIONS(3102),
    [anon_sym_with] = ACTIONS(3102),
    [anon_sym_var] = ACTIONS(3102),
    [anon_sym_let] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_await] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_debugger] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_case] = ACTIONS(3102),
    [anon_sym_finally] = ACTIONS(3102),
    [anon_sym_yield] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_LTtemplate_GT] = ACTIONS(3102),
    [anon_sym_DQUOTE] = ACTIONS(3102),
    [anon_sym_SQUOTE] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_async] = ACTIONS(3102),
    [anon_sym_function] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_using] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_SLASH] = ACTIONS(3102),
    [anon_sym_LT] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_void] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3102),
    [sym_number] = ACTIONS(3102),
    [sym_private_property_identifier] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
    [sym_super] = ACTIONS(3102),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [sym_null] = ACTIONS(3102),
    [sym_undefined] = ACTIONS(3102),
    [anon_sym_AT] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_readonly] = ACTIONS(3102),
    [anon_sym_get] = ACTIONS(3102),
    [anon_sym_set] = ACTIONS(3102),
    [anon_sym_declare] = ACTIONS(3102),
    [anon_sym_public] = ACTIONS(3102),
    [anon_sym_private] = ACTIONS(3102),
    [anon_sym_protected] = ACTIONS(3102),
    [anon_sym_override] = ACTIONS(3102),
    [anon_sym_module] = ACTIONS(3102),
    [anon_sym_any] = ACTIONS(3102),
    [anon_sym_number] = ACTIONS(3102),
    [anon_sym_boolean] = ACTIONS(3102),
    [anon_sym_string] = ACTIONS(3102),
    [anon_sym_symbol] = ACTIONS(3102),
    [anon_sym_object] = ACTIONS(3102),
    [anon_sym_abstract] = ACTIONS(3102),
    [anon_sym_interface] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [sym_html_comment] = ACTIONS(5),
  },
  [1143] = {
    [sym_comment] = STATE(1143),
    [sym_identifier] = ACTIONS(3074),
    [anon_sym_export] = ACTIONS(3074),
    [anon_sym_default] = ACTIONS(3074),
    [anon_sym_type] = ACTIONS(3074),
    [anon_sym_namespace] = ACTIONS(3074),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_typeof] = ACTIONS(3074),
    [anon_sym_import] = ACTIONS(3074),
    [anon_sym_with] = ACTIONS(3074),
    [anon_sym_var] = ACTIONS(3074),
    [anon_sym_let] = ACTIONS(3074),
    [anon_sym_const] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_switch] = ACTIONS(3074),
    [anon_sym_for] = ACTIONS(3074),
    [anon_sym_LPAREN] = ACTIONS(3074),
    [anon_sym_await] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_try] = ACTIONS(3074),
    [anon_sym_break] = ACTIONS(3074),
    [anon_sym_continue] = ACTIONS(3074),
    [anon_sym_debugger] = ACTIONS(3074),
    [anon_sym_return] = ACTIONS(3074),
    [anon_sym_throw] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3360),
    [anon_sym_case] = ACTIONS(3074),
    [anon_sym_yield] = ACTIONS(3074),
    [anon_sym_LBRACK] = ACTIONS(3074),
    [anon_sym_LTtemplate_GT] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_class] = ACTIONS(3074),
    [anon_sym_async] = ACTIONS(3074),
    [anon_sym_function] = ACTIONS(3074),
    [anon_sym_new] = ACTIONS(3074),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3074),
    [anon_sym_SLASH] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_void] = ACTIONS(3074),
    [anon_sym_delete] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3074),
    [sym_number] = ACTIONS(3074),
    [sym_private_property_identifier] = ACTIONS(3074),
    [sym_this] = ACTIONS(3074),
    [sym_super] = ACTIONS(3074),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [sym_null] = ACTIONS(3074),
    [sym_undefined] = ACTIONS(3074),
    [anon_sym_AT] = ACTIONS(3074),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_readonly] = ACTIONS(3074),
    [anon_sym_get] = ACTIONS(3074),
    [anon_sym_set] = ACTIONS(3074),
    [anon_sym_declare] = ACTIONS(3074),
    [anon_sym_public] = ACTIONS(3074),
    [anon_sym_private] = ACTIONS(3074),
    [anon_sym_protected] = ACTIONS(3074),
    [anon_sym_override] = ACTIONS(3074),
    [anon_sym_module] = ACTIONS(3074),
    [anon_sym_any] = ACTIONS(3074),
    [anon_sym_number] = ACTIONS(3074),
    [anon_sym_boolean] = ACTIONS(3074),
    [anon_sym_string] = ACTIONS(3074),
    [anon_sym_symbol] = ACTIONS(3074),
    [anon_sym_object] = ACTIONS(3074),
    [anon_sym_abstract] = ACTIONS(3074),
    [anon_sym_interface] = ACTIONS(3074),
    [anon_sym_enum] = ACTIONS(3074),
    [sym__automatic_semicolon] = ACTIONS(3362),
    [sym_html_comment] = ACTIONS(5),
  },
  [1144] = {
    [sym_comment] = STATE(1144),
    [sym_identifier] = ACTIONS(3364),
    [anon_sym_export] = ACTIONS(3364),
    [anon_sym_default] = ACTIONS(3364),
    [anon_sym_type] = ACTIONS(3364),
    [anon_sym_namespace] = ACTIONS(3364),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_RBRACE] = ACTIONS(3364),
    [anon_sym_typeof] = ACTIONS(3364),
    [anon_sym_import] = ACTIONS(3364),
    [anon_sym_with] = ACTIONS(3364),
    [anon_sym_var] = ACTIONS(3364),
    [anon_sym_let] = ACTIONS(3364),
    [anon_sym_const] = ACTIONS(3364),
    [anon_sym_BANG] = ACTIONS(3364),
    [anon_sym_else] = ACTIONS(3364),
    [anon_sym_if] = ACTIONS(3364),
    [anon_sym_switch] = ACTIONS(3364),
    [anon_sym_for] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(3364),
    [anon_sym_await] = ACTIONS(3364),
    [anon_sym_while] = ACTIONS(3364),
    [anon_sym_do] = ACTIONS(3364),
    [anon_sym_try] = ACTIONS(3364),
    [anon_sym_break] = ACTIONS(3364),
    [anon_sym_continue] = ACTIONS(3364),
    [anon_sym_debugger] = ACTIONS(3364),
    [anon_sym_return] = ACTIONS(3364),
    [anon_sym_throw] = ACTIONS(3364),
    [anon_sym_SEMI] = ACTIONS(3364),
    [anon_sym_case] = ACTIONS(3364),
    [anon_sym_yield] = ACTIONS(3364),
    [anon_sym_LBRACK] = ACTIONS(3364),
    [anon_sym_LTtemplate_GT] = ACTIONS(3364),
    [anon_sym_DQUOTE] = ACTIONS(3364),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym_class] = ACTIONS(3364),
    [anon_sym_async] = ACTIONS(3364),
    [anon_sym_function] = ACTIONS(3364),
    [anon_sym_new] = ACTIONS(3364),
    [anon_sym_using] = ACTIONS(3364),
    [anon_sym_PLUS] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3364),
    [anon_sym_SLASH] = ACTIONS(3364),
    [anon_sym_LT] = ACTIONS(3364),
    [anon_sym_TILDE] = ACTIONS(3364),
    [anon_sym_void] = ACTIONS(3364),
    [anon_sym_delete] = ACTIONS(3364),
    [anon_sym_PLUS_PLUS] = ACTIONS(3364),
    [anon_sym_DASH_DASH] = ACTIONS(3364),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3364),
    [sym_number] = ACTIONS(3364),
    [sym_private_property_identifier] = ACTIONS(3364),
    [sym_this] = ACTIONS(3364),
    [sym_super] = ACTIONS(3364),
    [sym_true] = ACTIONS(3364),
    [sym_false] = ACTIONS(3364),
    [sym_null] = ACTIONS(3364),
    [sym_undefined] = ACTIONS(3364),
    [anon_sym_AT] = ACTIONS(3364),
    [anon_sym_static] = ACTIONS(3364),
    [anon_sym_readonly] = ACTIONS(3364),
    [anon_sym_get] = ACTIONS(3364),
    [anon_sym_set] = ACTIONS(3364),
    [anon_sym_declare] = ACTIONS(3364),
    [anon_sym_public] = ACTIONS(3364),
    [anon_sym_private] = ACTIONS(3364),
    [anon_sym_protected] = ACTIONS(3364),
    [anon_sym_override] = ACTIONS(3364),
    [anon_sym_module] = ACTIONS(3364),
    [anon_sym_any] = ACTIONS(3364),
    [anon_sym_number] = ACTIONS(3364),
    [anon_sym_boolean] = ACTIONS(3364),
    [anon_sym_string] = ACTIONS(3364),
    [anon_sym_symbol] = ACTIONS(3364),
    [anon_sym_object] = ACTIONS(3364),
    [anon_sym_abstract] = ACTIONS(3364),
    [anon_sym_interface] = ACTIONS(3364),
    [anon_sym_enum] = ACTIONS(3364),
    [sym_html_comment] = ACTIONS(5),
  },
  [1145] = {
    [sym_finally_clause] = STATE(1526),
    [sym_comment] = STATE(1145),
    [ts_builtin_sym_end] = ACTIONS(3120),
    [sym_identifier] = ACTIONS(3052),
    [anon_sym_export] = ACTIONS(3052),
    [anon_sym_type] = ACTIONS(3052),
    [anon_sym_namespace] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_typeof] = ACTIONS(3052),
    [anon_sym_import] = ACTIONS(3052),
    [anon_sym_with] = ACTIONS(3052),
    [anon_sym_var] = ACTIONS(3052),
    [anon_sym_let] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [anon_sym_await] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_debugger] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_throw] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_finally] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_LTtemplate_GT] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_async] = ACTIONS(3052),
    [anon_sym_function] = ACTIONS(3052),
    [anon_sym_new] = ACTIONS(3052),
    [anon_sym_using] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_SLASH] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_void] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3052),
    [sym_number] = ACTIONS(3052),
    [sym_private_property_identifier] = ACTIONS(3052),
    [sym_this] = ACTIONS(3052),
    [sym_super] = ACTIONS(3052),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [sym_null] = ACTIONS(3052),
    [sym_undefined] = ACTIONS(3052),
    [anon_sym_AT] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_readonly] = ACTIONS(3052),
    [anon_sym_get] = ACTIONS(3052),
    [anon_sym_set] = ACTIONS(3052),
    [anon_sym_declare] = ACTIONS(3052),
    [anon_sym_public] = ACTIONS(3052),
    [anon_sym_private] = ACTIONS(3052),
    [anon_sym_protected] = ACTIONS(3052),
    [anon_sym_override] = ACTIONS(3052),
    [anon_sym_module] = ACTIONS(3052),
    [anon_sym_any] = ACTIONS(3052),
    [anon_sym_number] = ACTIONS(3052),
    [anon_sym_boolean] = ACTIONS(3052),
    [anon_sym_string] = ACTIONS(3052),
    [anon_sym_symbol] = ACTIONS(3052),
    [anon_sym_object] = ACTIONS(3052),
    [anon_sym_abstract] = ACTIONS(3052),
    [anon_sym_interface] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [sym_html_comment] = ACTIONS(5),
  },
  [1146] = {
    [sym_comment] = STATE(1146),
    [sym_identifier] = ACTIONS(2233),
    [anon_sym_export] = ACTIONS(2233),
    [anon_sym_default] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(2233),
    [anon_sym_namespace] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [anon_sym_typeof] = ACTIONS(2233),
    [anon_sym_import] = ACTIONS(2233),
    [anon_sym_with] = ACTIONS(2233),
    [anon_sym_var] = ACTIONS(2233),
    [anon_sym_let] = ACTIONS(2233),
    [anon_sym_const] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_for] = ACTIONS(2233),
    [anon_sym_LPAREN] = ACTIONS(2233),
    [anon_sym_await] = ACTIONS(2233),
    [anon_sym_while] = ACTIONS(2233),
    [anon_sym_do] = ACTIONS(2233),
    [anon_sym_try] = ACTIONS(2233),
    [anon_sym_break] = ACTIONS(2233),
    [anon_sym_continue] = ACTIONS(2233),
    [anon_sym_debugger] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2233),
    [anon_sym_throw] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym_case] = ACTIONS(2233),
    [anon_sym_yield] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2233),
    [anon_sym_LTtemplate_GT] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_class] = ACTIONS(2233),
    [anon_sym_async] = ACTIONS(2233),
    [anon_sym_function] = ACTIONS(2233),
    [anon_sym_new] = ACTIONS(2233),
    [anon_sym_using] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_void] = ACTIONS(2233),
    [anon_sym_delete] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2233),
    [sym_number] = ACTIONS(2233),
    [sym_private_property_identifier] = ACTIONS(2233),
    [sym_this] = ACTIONS(2233),
    [sym_super] = ACTIONS(2233),
    [sym_true] = ACTIONS(2233),
    [sym_false] = ACTIONS(2233),
    [sym_null] = ACTIONS(2233),
    [sym_undefined] = ACTIONS(2233),
    [anon_sym_AT] = ACTIONS(2233),
    [anon_sym_static] = ACTIONS(2233),
    [anon_sym_readonly] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2233),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_declare] = ACTIONS(2233),
    [anon_sym_public] = ACTIONS(2233),
    [anon_sym_private] = ACTIONS(2233),
    [anon_sym_protected] = ACTIONS(2233),
    [anon_sym_override] = ACTIONS(2233),
    [anon_sym_module] = ACTIONS(2233),
    [anon_sym_any] = ACTIONS(2233),
    [anon_sym_number] = ACTIONS(2233),
    [anon_sym_boolean] = ACTIONS(2233),
    [anon_sym_string] = ACTIONS(2233),
    [anon_sym_symbol] = ACTIONS(2233),
    [anon_sym_object] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2233),
    [anon_sym_interface] = ACTIONS(2233),
    [anon_sym_enum] = ACTIONS(2233),
    [sym_html_comment] = ACTIONS(5),
  },
  [1147] = {
    [sym_comment] = STATE(1147),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_export] = ACTIONS(2183),
    [anon_sym_default] = ACTIONS(2183),
    [anon_sym_type] = ACTIONS(2183),
    [anon_sym_namespace] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_typeof] = ACTIONS(2183),
    [anon_sym_import] = ACTIONS(2183),
    [anon_sym_with] = ACTIONS(2183),
    [anon_sym_var] = ACTIONS(2183),
    [anon_sym_let] = ACTIONS(2183),
    [anon_sym_const] = ACTIONS(2183),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_else] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2183),
    [anon_sym_for] = ACTIONS(2183),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(2183),
    [anon_sym_do] = ACTIONS(2183),
    [anon_sym_try] = ACTIONS(2183),
    [anon_sym_break] = ACTIONS(2183),
    [anon_sym_continue] = ACTIONS(2183),
    [anon_sym_debugger] = ACTIONS(2183),
    [anon_sym_return] = ACTIONS(2183),
    [anon_sym_throw] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_case] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2183),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [anon_sym_class] = ACTIONS(2183),
    [anon_sym_async] = ACTIONS(2183),
    [anon_sym_function] = ACTIONS(2183),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_using] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2183),
    [anon_sym_delete] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2183),
    [sym_private_property_identifier] = ACTIONS(2183),
    [sym_this] = ACTIONS(2183),
    [sym_super] = ACTIONS(2183),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_undefined] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2183),
    [anon_sym_readonly] = ACTIONS(2183),
    [anon_sym_get] = ACTIONS(2183),
    [anon_sym_set] = ACTIONS(2183),
    [anon_sym_declare] = ACTIONS(2183),
    [anon_sym_public] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2183),
    [anon_sym_protected] = ACTIONS(2183),
    [anon_sym_override] = ACTIONS(2183),
    [anon_sym_module] = ACTIONS(2183),
    [anon_sym_any] = ACTIONS(2183),
    [anon_sym_number] = ACTIONS(2183),
    [anon_sym_boolean] = ACTIONS(2183),
    [anon_sym_string] = ACTIONS(2183),
    [anon_sym_symbol] = ACTIONS(2183),
    [anon_sym_object] = ACTIONS(2183),
    [anon_sym_abstract] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2183),
    [anon_sym_enum] = ACTIONS(2183),
    [sym_html_comment] = ACTIONS(5),
  },
  [1148] = {
    [sym_comment] = STATE(1148),
    [sym_identifier] = ACTIONS(3366),
    [anon_sym_export] = ACTIONS(3366),
    [anon_sym_default] = ACTIONS(3366),
    [anon_sym_type] = ACTIONS(3366),
    [anon_sym_namespace] = ACTIONS(3366),
    [anon_sym_LBRACE] = ACTIONS(3366),
    [anon_sym_RBRACE] = ACTIONS(3366),
    [anon_sym_typeof] = ACTIONS(3366),
    [anon_sym_import] = ACTIONS(3366),
    [anon_sym_with] = ACTIONS(3366),
    [anon_sym_var] = ACTIONS(3366),
    [anon_sym_let] = ACTIONS(3366),
    [anon_sym_const] = ACTIONS(3366),
    [anon_sym_BANG] = ACTIONS(3366),
    [anon_sym_else] = ACTIONS(3366),
    [anon_sym_if] = ACTIONS(3366),
    [anon_sym_switch] = ACTIONS(3366),
    [anon_sym_for] = ACTIONS(3366),
    [anon_sym_LPAREN] = ACTIONS(3366),
    [anon_sym_await] = ACTIONS(3366),
    [anon_sym_while] = ACTIONS(3366),
    [anon_sym_do] = ACTIONS(3366),
    [anon_sym_try] = ACTIONS(3366),
    [anon_sym_break] = ACTIONS(3366),
    [anon_sym_continue] = ACTIONS(3366),
    [anon_sym_debugger] = ACTIONS(3366),
    [anon_sym_return] = ACTIONS(3366),
    [anon_sym_throw] = ACTIONS(3366),
    [anon_sym_SEMI] = ACTIONS(3366),
    [anon_sym_case] = ACTIONS(3366),
    [anon_sym_yield] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(3366),
    [anon_sym_LTtemplate_GT] = ACTIONS(3366),
    [anon_sym_DQUOTE] = ACTIONS(3366),
    [anon_sym_SQUOTE] = ACTIONS(3366),
    [anon_sym_class] = ACTIONS(3366),
    [anon_sym_async] = ACTIONS(3366),
    [anon_sym_function] = ACTIONS(3366),
    [anon_sym_new] = ACTIONS(3366),
    [anon_sym_using] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_SLASH] = ACTIONS(3366),
    [anon_sym_LT] = ACTIONS(3366),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_void] = ACTIONS(3366),
    [anon_sym_delete] = ACTIONS(3366),
    [anon_sym_PLUS_PLUS] = ACTIONS(3366),
    [anon_sym_DASH_DASH] = ACTIONS(3366),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3366),
    [sym_number] = ACTIONS(3366),
    [sym_private_property_identifier] = ACTIONS(3366),
    [sym_this] = ACTIONS(3366),
    [sym_super] = ACTIONS(3366),
    [sym_true] = ACTIONS(3366),
    [sym_false] = ACTIONS(3366),
    [sym_null] = ACTIONS(3366),
    [sym_undefined] = ACTIONS(3366),
    [anon_sym_AT] = ACTIONS(3366),
    [anon_sym_static] = ACTIONS(3366),
    [anon_sym_readonly] = ACTIONS(3366),
    [anon_sym_get] = ACTIONS(3366),
    [anon_sym_set] = ACTIONS(3366),
    [anon_sym_declare] = ACTIONS(3366),
    [anon_sym_public] = ACTIONS(3366),
    [anon_sym_private] = ACTIONS(3366),
    [anon_sym_protected] = ACTIONS(3366),
    [anon_sym_override] = ACTIONS(3366),
    [anon_sym_module] = ACTIONS(3366),
    [anon_sym_any] = ACTIONS(3366),
    [anon_sym_number] = ACTIONS(3366),
    [anon_sym_boolean] = ACTIONS(3366),
    [anon_sym_string] = ACTIONS(3366),
    [anon_sym_symbol] = ACTIONS(3366),
    [anon_sym_object] = ACTIONS(3366),
    [anon_sym_abstract] = ACTIONS(3366),
    [anon_sym_interface] = ACTIONS(3366),
    [anon_sym_enum] = ACTIONS(3366),
    [sym_html_comment] = ACTIONS(5),
  },
  [1149] = {
    [sym_comment] = STATE(1149),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym__automatic_semicolon] = ACTIONS(2127),
    [sym_html_comment] = ACTIONS(5),
  },
  [1150] = {
    [sym_comment] = STATE(1150),
    [sym_identifier] = ACTIONS(3368),
    [anon_sym_export] = ACTIONS(3368),
    [anon_sym_default] = ACTIONS(3368),
    [anon_sym_type] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3368),
    [anon_sym_RBRACE] = ACTIONS(3368),
    [anon_sym_typeof] = ACTIONS(3368),
    [anon_sym_import] = ACTIONS(3368),
    [anon_sym_with] = ACTIONS(3368),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_else] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_LPAREN] = ACTIONS(3368),
    [anon_sym_await] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_debugger] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3368),
    [anon_sym_case] = ACTIONS(3368),
    [anon_sym_yield] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_LTtemplate_GT] = ACTIONS(3368),
    [anon_sym_DQUOTE] = ACTIONS(3368),
    [anon_sym_SQUOTE] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_async] = ACTIONS(3368),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_TILDE] = ACTIONS(3368),
    [anon_sym_void] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3368),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3368),
    [sym_number] = ACTIONS(3368),
    [sym_private_property_identifier] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [sym_super] = ACTIONS(3368),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [sym_null] = ACTIONS(3368),
    [sym_undefined] = ACTIONS(3368),
    [anon_sym_AT] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_readonly] = ACTIONS(3368),
    [anon_sym_get] = ACTIONS(3368),
    [anon_sym_set] = ACTIONS(3368),
    [anon_sym_declare] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_override] = ACTIONS(3368),
    [anon_sym_module] = ACTIONS(3368),
    [anon_sym_any] = ACTIONS(3368),
    [anon_sym_number] = ACTIONS(3368),
    [anon_sym_boolean] = ACTIONS(3368),
    [anon_sym_string] = ACTIONS(3368),
    [anon_sym_symbol] = ACTIONS(3368),
    [anon_sym_object] = ACTIONS(3368),
    [anon_sym_abstract] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [sym_html_comment] = ACTIONS(5),
  },
  [1151] = {
    [sym_comment] = STATE(1151),
    [sym_identifier] = ACTIONS(3368),
    [anon_sym_export] = ACTIONS(3368),
    [anon_sym_default] = ACTIONS(3368),
    [anon_sym_type] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3368),
    [anon_sym_RBRACE] = ACTIONS(3368),
    [anon_sym_typeof] = ACTIONS(3368),
    [anon_sym_import] = ACTIONS(3368),
    [anon_sym_with] = ACTIONS(3368),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_else] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_LPAREN] = ACTIONS(3368),
    [anon_sym_await] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_debugger] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3368),
    [anon_sym_case] = ACTIONS(3368),
    [anon_sym_yield] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_LTtemplate_GT] = ACTIONS(3368),
    [anon_sym_DQUOTE] = ACTIONS(3368),
    [anon_sym_SQUOTE] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_async] = ACTIONS(3368),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_TILDE] = ACTIONS(3368),
    [anon_sym_void] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3368),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3368),
    [sym_number] = ACTIONS(3368),
    [sym_private_property_identifier] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [sym_super] = ACTIONS(3368),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [sym_null] = ACTIONS(3368),
    [sym_undefined] = ACTIONS(3368),
    [anon_sym_AT] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_readonly] = ACTIONS(3368),
    [anon_sym_get] = ACTIONS(3368),
    [anon_sym_set] = ACTIONS(3368),
    [anon_sym_declare] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_override] = ACTIONS(3368),
    [anon_sym_module] = ACTIONS(3368),
    [anon_sym_any] = ACTIONS(3368),
    [anon_sym_number] = ACTIONS(3368),
    [anon_sym_boolean] = ACTIONS(3368),
    [anon_sym_string] = ACTIONS(3368),
    [anon_sym_symbol] = ACTIONS(3368),
    [anon_sym_object] = ACTIONS(3368),
    [anon_sym_abstract] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [sym_html_comment] = ACTIONS(5),
  },
  [1152] = {
    [sym_comment] = STATE(1152),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_export] = ACTIONS(2189),
    [anon_sym_default] = ACTIONS(2189),
    [anon_sym_type] = ACTIONS(2189),
    [anon_sym_namespace] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_import] = ACTIONS(2189),
    [anon_sym_with] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2189),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_debugger] = ACTIONS(2189),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_case] = ACTIONS(2189),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2189),
    [anon_sym_LTtemplate_GT] = ACTIONS(2189),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_class] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_function] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_using] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_void] = ACTIONS(2189),
    [anon_sym_delete] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2189),
    [sym_number] = ACTIONS(2189),
    [sym_private_property_identifier] = ACTIONS(2189),
    [sym_this] = ACTIONS(2189),
    [sym_super] = ACTIONS(2189),
    [sym_true] = ACTIONS(2189),
    [sym_false] = ACTIONS(2189),
    [sym_null] = ACTIONS(2189),
    [sym_undefined] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_declare] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_module] = ACTIONS(2189),
    [anon_sym_any] = ACTIONS(2189),
    [anon_sym_number] = ACTIONS(2189),
    [anon_sym_boolean] = ACTIONS(2189),
    [anon_sym_string] = ACTIONS(2189),
    [anon_sym_symbol] = ACTIONS(2189),
    [anon_sym_object] = ACTIONS(2189),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_interface] = ACTIONS(2189),
    [anon_sym_enum] = ACTIONS(2189),
    [sym__automatic_semicolon] = ACTIONS(2341),
    [sym_html_comment] = ACTIONS(5),
  },
  [1153] = {
    [sym_comment] = STATE(1153),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_export] = ACTIONS(2237),
    [anon_sym_default] = ACTIONS(2237),
    [anon_sym_type] = ACTIONS(2237),
    [anon_sym_namespace] = ACTIONS(2237),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_typeof] = ACTIONS(2237),
    [anon_sym_import] = ACTIONS(2237),
    [anon_sym_with] = ACTIONS(2237),
    [anon_sym_var] = ACTIONS(2237),
    [anon_sym_let] = ACTIONS(2237),
    [anon_sym_const] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_if] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_for] = ACTIONS(2237),
    [anon_sym_LPAREN] = ACTIONS(2237),
    [anon_sym_await] = ACTIONS(2237),
    [anon_sym_while] = ACTIONS(2237),
    [anon_sym_do] = ACTIONS(2237),
    [anon_sym_try] = ACTIONS(2237),
    [anon_sym_break] = ACTIONS(2237),
    [anon_sym_continue] = ACTIONS(2237),
    [anon_sym_debugger] = ACTIONS(2237),
    [anon_sym_return] = ACTIONS(2237),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2237),
    [anon_sym_case] = ACTIONS(2237),
    [anon_sym_yield] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2237),
    [anon_sym_LTtemplate_GT] = ACTIONS(2237),
    [anon_sym_DOT] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_class] = ACTIONS(2237),
    [anon_sym_async] = ACTIONS(2237),
    [anon_sym_function] = ACTIONS(2237),
    [anon_sym_new] = ACTIONS(2237),
    [anon_sym_using] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_SLASH] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_void] = ACTIONS(2237),
    [anon_sym_delete] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2237),
    [sym_number] = ACTIONS(2237),
    [sym_private_property_identifier] = ACTIONS(2237),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2237),
    [anon_sym_static] = ACTIONS(2237),
    [anon_sym_readonly] = ACTIONS(2237),
    [anon_sym_get] = ACTIONS(2237),
    [anon_sym_set] = ACTIONS(2237),
    [anon_sym_declare] = ACTIONS(2237),
    [anon_sym_public] = ACTIONS(2237),
    [anon_sym_private] = ACTIONS(2237),
    [anon_sym_protected] = ACTIONS(2237),
    [anon_sym_override] = ACTIONS(2237),
    [anon_sym_module] = ACTIONS(2237),
    [anon_sym_any] = ACTIONS(2237),
    [anon_sym_number] = ACTIONS(2237),
    [anon_sym_boolean] = ACTIONS(2237),
    [anon_sym_string] = ACTIONS(2237),
    [anon_sym_symbol] = ACTIONS(2237),
    [anon_sym_object] = ACTIONS(2237),
    [anon_sym_abstract] = ACTIONS(2237),
    [anon_sym_interface] = ACTIONS(2237),
    [anon_sym_enum] = ACTIONS(2237),
    [sym_html_comment] = ACTIONS(5),
  },
  [1154] = {
    [sym_comment] = STATE(1154),
    [sym_identifier] = ACTIONS(3370),
    [anon_sym_export] = ACTIONS(3370),
    [anon_sym_default] = ACTIONS(3370),
    [anon_sym_type] = ACTIONS(3370),
    [anon_sym_namespace] = ACTIONS(3370),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_typeof] = ACTIONS(3370),
    [anon_sym_import] = ACTIONS(3370),
    [anon_sym_with] = ACTIONS(3370),
    [anon_sym_var] = ACTIONS(3370),
    [anon_sym_let] = ACTIONS(3370),
    [anon_sym_const] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_else] = ACTIONS(3370),
    [anon_sym_if] = ACTIONS(3370),
    [anon_sym_switch] = ACTIONS(3370),
    [anon_sym_for] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_await] = ACTIONS(3370),
    [anon_sym_while] = ACTIONS(3370),
    [anon_sym_do] = ACTIONS(3370),
    [anon_sym_try] = ACTIONS(3370),
    [anon_sym_break] = ACTIONS(3370),
    [anon_sym_continue] = ACTIONS(3370),
    [anon_sym_debugger] = ACTIONS(3370),
    [anon_sym_return] = ACTIONS(3370),
    [anon_sym_throw] = ACTIONS(3370),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym_case] = ACTIONS(3370),
    [anon_sym_yield] = ACTIONS(3370),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_LTtemplate_GT] = ACTIONS(3370),
    [anon_sym_DQUOTE] = ACTIONS(3370),
    [anon_sym_SQUOTE] = ACTIONS(3370),
    [anon_sym_class] = ACTIONS(3370),
    [anon_sym_async] = ACTIONS(3370),
    [anon_sym_function] = ACTIONS(3370),
    [anon_sym_new] = ACTIONS(3370),
    [anon_sym_using] = ACTIONS(3370),
    [anon_sym_PLUS] = ACTIONS(3370),
    [anon_sym_DASH] = ACTIONS(3370),
    [anon_sym_SLASH] = ACTIONS(3370),
    [anon_sym_LT] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_void] = ACTIONS(3370),
    [anon_sym_delete] = ACTIONS(3370),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3370),
    [sym_number] = ACTIONS(3370),
    [sym_private_property_identifier] = ACTIONS(3370),
    [sym_this] = ACTIONS(3370),
    [sym_super] = ACTIONS(3370),
    [sym_true] = ACTIONS(3370),
    [sym_false] = ACTIONS(3370),
    [sym_null] = ACTIONS(3370),
    [sym_undefined] = ACTIONS(3370),
    [anon_sym_AT] = ACTIONS(3370),
    [anon_sym_static] = ACTIONS(3370),
    [anon_sym_readonly] = ACTIONS(3370),
    [anon_sym_get] = ACTIONS(3370),
    [anon_sym_set] = ACTIONS(3370),
    [anon_sym_declare] = ACTIONS(3370),
    [anon_sym_public] = ACTIONS(3370),
    [anon_sym_private] = ACTIONS(3370),
    [anon_sym_protected] = ACTIONS(3370),
    [anon_sym_override] = ACTIONS(3370),
    [anon_sym_module] = ACTIONS(3370),
    [anon_sym_any] = ACTIONS(3370),
    [anon_sym_number] = ACTIONS(3370),
    [anon_sym_boolean] = ACTIONS(3370),
    [anon_sym_string] = ACTIONS(3370),
    [anon_sym_symbol] = ACTIONS(3370),
    [anon_sym_object] = ACTIONS(3370),
    [anon_sym_abstract] = ACTIONS(3370),
    [anon_sym_interface] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3370),
    [sym_html_comment] = ACTIONS(5),
  },
  [1155] = {
    [sym_comment] = STATE(1155),
    [sym_identifier] = ACTIONS(2163),
    [anon_sym_export] = ACTIONS(2163),
    [anon_sym_default] = ACTIONS(2163),
    [anon_sym_type] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2163),
    [anon_sym_import] = ACTIONS(2163),
    [anon_sym_with] = ACTIONS(2163),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2163),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_debugger] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_case] = ACTIONS(2163),
    [anon_sym_yield] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_LTtemplate_GT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2163),
    [anon_sym_SQUOTE] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_async] = ACTIONS(2163),
    [anon_sym_function] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_SLASH] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [anon_sym_void] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_PLUS_PLUS] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2163),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2163),
    [sym_number] = ACTIONS(2163),
    [sym_private_property_identifier] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(2163),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_readonly] = ACTIONS(2163),
    [anon_sym_get] = ACTIONS(2163),
    [anon_sym_set] = ACTIONS(2163),
    [anon_sym_declare] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_override] = ACTIONS(2163),
    [anon_sym_module] = ACTIONS(2163),
    [anon_sym_any] = ACTIONS(2163),
    [anon_sym_number] = ACTIONS(2163),
    [anon_sym_boolean] = ACTIONS(2163),
    [anon_sym_string] = ACTIONS(2163),
    [anon_sym_symbol] = ACTIONS(2163),
    [anon_sym_object] = ACTIONS(2163),
    [anon_sym_abstract] = ACTIONS(2163),
    [anon_sym_interface] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [sym_html_comment] = ACTIONS(5),
  },
  [1156] = {
    [sym_comment] = STATE(1156),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_default] = ACTIONS(2225),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2225),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_case] = ACTIONS(2225),
    [anon_sym_yield] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2225),
    [anon_sym_LTtemplate_GT] = ACTIONS(2225),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_SQUOTE] = ACTIONS(2225),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_function] = ACTIONS(2225),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_using] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_TILDE] = ACTIONS(2225),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(2225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [sym_number] = ACTIONS(2225),
    [sym_private_property_identifier] = ACTIONS(2225),
    [sym_this] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [sym_false] = ACTIONS(2225),
    [sym_null] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2225),
    [anon_sym_static] = ACTIONS(2225),
    [anon_sym_readonly] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_override] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_object] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
    [sym__automatic_semicolon] = ACTIONS(2301),
    [sym_html_comment] = ACTIONS(5),
  },
  [1157] = {
    [sym_comment] = STATE(1157),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_export] = ACTIONS(2213),
    [anon_sym_default] = ACTIONS(2213),
    [anon_sym_type] = ACTIONS(2213),
    [anon_sym_namespace] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_typeof] = ACTIONS(2213),
    [anon_sym_import] = ACTIONS(2213),
    [anon_sym_with] = ACTIONS(2213),
    [anon_sym_var] = ACTIONS(2213),
    [anon_sym_let] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_for] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_await] = ACTIONS(2213),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_do] = ACTIONS(2213),
    [anon_sym_try] = ACTIONS(2213),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_debugger] = ACTIONS(2213),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_throw] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_case] = ACTIONS(2213),
    [anon_sym_yield] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2213),
    [anon_sym_LTtemplate_GT] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_class] = ACTIONS(2213),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2213),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_using] = ACTIONS(2213),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_void] = ACTIONS(2213),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_number] = ACTIONS(2213),
    [sym_private_property_identifier] = ACTIONS(2213),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(2213),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2213),
    [anon_sym_static] = ACTIONS(2213),
    [anon_sym_readonly] = ACTIONS(2213),
    [anon_sym_get] = ACTIONS(2213),
    [anon_sym_set] = ACTIONS(2213),
    [anon_sym_declare] = ACTIONS(2213),
    [anon_sym_public] = ACTIONS(2213),
    [anon_sym_private] = ACTIONS(2213),
    [anon_sym_protected] = ACTIONS(2213),
    [anon_sym_override] = ACTIONS(2213),
    [anon_sym_module] = ACTIONS(2213),
    [anon_sym_any] = ACTIONS(2213),
    [anon_sym_number] = ACTIONS(2213),
    [anon_sym_boolean] = ACTIONS(2213),
    [anon_sym_string] = ACTIONS(2213),
    [anon_sym_symbol] = ACTIONS(2213),
    [anon_sym_object] = ACTIONS(2213),
    [anon_sym_abstract] = ACTIONS(2213),
    [anon_sym_interface] = ACTIONS(2213),
    [anon_sym_enum] = ACTIONS(2213),
    [sym__automatic_semicolon] = ACTIONS(2335),
    [sym_html_comment] = ACTIONS(5),
  },
  [1158] = {
    [sym_comment] = STATE(1158),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym__automatic_semicolon] = ACTIONS(2147),
    [sym_html_comment] = ACTIONS(5),
  },
  [1159] = {
    [sym_comment] = STATE(1159),
    [ts_builtin_sym_end] = ACTIONS(3372),
    [sym_identifier] = ACTIONS(3194),
    [anon_sym_export] = ACTIONS(3194),
    [anon_sym_type] = ACTIONS(3194),
    [anon_sym_namespace] = ACTIONS(3194),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3194),
    [anon_sym_typeof] = ACTIONS(3194),
    [anon_sym_import] = ACTIONS(3194),
    [anon_sym_with] = ACTIONS(3194),
    [anon_sym_var] = ACTIONS(3194),
    [anon_sym_let] = ACTIONS(3194),
    [anon_sym_const] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_else] = ACTIONS(3194),
    [anon_sym_if] = ACTIONS(3194),
    [anon_sym_switch] = ACTIONS(3194),
    [anon_sym_for] = ACTIONS(3194),
    [anon_sym_LPAREN] = ACTIONS(3194),
    [anon_sym_await] = ACTIONS(3194),
    [anon_sym_while] = ACTIONS(3194),
    [anon_sym_do] = ACTIONS(3194),
    [anon_sym_try] = ACTIONS(3194),
    [anon_sym_break] = ACTIONS(3194),
    [anon_sym_continue] = ACTIONS(3194),
    [anon_sym_debugger] = ACTIONS(3194),
    [anon_sym_return] = ACTIONS(3194),
    [anon_sym_throw] = ACTIONS(3194),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym_yield] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_LTtemplate_GT] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3194),
    [anon_sym_SQUOTE] = ACTIONS(3194),
    [anon_sym_class] = ACTIONS(3194),
    [anon_sym_async] = ACTIONS(3194),
    [anon_sym_function] = ACTIONS(3194),
    [anon_sym_new] = ACTIONS(3194),
    [anon_sym_using] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3194),
    [anon_sym_SLASH] = ACTIONS(3194),
    [anon_sym_LT] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_void] = ACTIONS(3194),
    [anon_sym_delete] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_number] = ACTIONS(3194),
    [sym_private_property_identifier] = ACTIONS(3194),
    [sym_this] = ACTIONS(3194),
    [sym_super] = ACTIONS(3194),
    [sym_true] = ACTIONS(3194),
    [sym_false] = ACTIONS(3194),
    [sym_null] = ACTIONS(3194),
    [sym_undefined] = ACTIONS(3194),
    [anon_sym_AT] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3194),
    [anon_sym_readonly] = ACTIONS(3194),
    [anon_sym_get] = ACTIONS(3194),
    [anon_sym_set] = ACTIONS(3194),
    [anon_sym_declare] = ACTIONS(3194),
    [anon_sym_public] = ACTIONS(3194),
    [anon_sym_private] = ACTIONS(3194),
    [anon_sym_protected] = ACTIONS(3194),
    [anon_sym_override] = ACTIONS(3194),
    [anon_sym_module] = ACTIONS(3194),
    [anon_sym_any] = ACTIONS(3194),
    [anon_sym_number] = ACTIONS(3194),
    [anon_sym_boolean] = ACTIONS(3194),
    [anon_sym_string] = ACTIONS(3194),
    [anon_sym_symbol] = ACTIONS(3194),
    [anon_sym_object] = ACTIONS(3194),
    [anon_sym_abstract] = ACTIONS(3194),
    [anon_sym_interface] = ACTIONS(3194),
    [anon_sym_enum] = ACTIONS(3194),
    [sym_html_comment] = ACTIONS(5),
  },
  [1160] = {
    [sym_comment] = STATE(1160),
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_export] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_type] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_RBRACE] = ACTIONS(3128),
    [anon_sym_typeof] = ACTIONS(3128),
    [anon_sym_import] = ACTIONS(3128),
    [anon_sym_with] = ACTIONS(3128),
    [anon_sym_var] = ACTIONS(3128),
    [anon_sym_let] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(3128),
    [anon_sym_await] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_debugger] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_LTtemplate_GT] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_async] = ACTIONS(3128),
    [anon_sym_function] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_SLASH] = ACTIONS(3128),
    [anon_sym_LT] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_void] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3128),
    [sym_number] = ACTIONS(3128),
    [sym_private_property_identifier] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
    [sym_super] = ACTIONS(3128),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [sym_null] = ACTIONS(3128),
    [sym_undefined] = ACTIONS(3128),
    [anon_sym_AT] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_readonly] = ACTIONS(3128),
    [anon_sym_get] = ACTIONS(3128),
    [anon_sym_set] = ACTIONS(3128),
    [anon_sym_declare] = ACTIONS(3128),
    [anon_sym_public] = ACTIONS(3128),
    [anon_sym_private] = ACTIONS(3128),
    [anon_sym_protected] = ACTIONS(3128),
    [anon_sym_override] = ACTIONS(3128),
    [anon_sym_module] = ACTIONS(3128),
    [anon_sym_any] = ACTIONS(3128),
    [anon_sym_number] = ACTIONS(3128),
    [anon_sym_boolean] = ACTIONS(3128),
    [anon_sym_string] = ACTIONS(3128),
    [anon_sym_symbol] = ACTIONS(3128),
    [anon_sym_object] = ACTIONS(3128),
    [anon_sym_abstract] = ACTIONS(3128),
    [anon_sym_interface] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [sym_html_comment] = ACTIONS(5),
  },
  [1161] = {
    [sym_statement_block] = STATE(1520),
    [sym_comment] = STATE(1161),
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2057),
    [anon_sym_export] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2057),
    [anon_sym_namespace] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(3124),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_typeof] = ACTIONS(2057),
    [anon_sym_import] = ACTIONS(2057),
    [anon_sym_with] = ACTIONS(2057),
    [anon_sym_var] = ACTIONS(2057),
    [anon_sym_let] = ACTIONS(2057),
    [anon_sym_const] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_if] = ACTIONS(2057),
    [anon_sym_switch] = ACTIONS(2057),
    [anon_sym_for] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2057),
    [anon_sym_while] = ACTIONS(2057),
    [anon_sym_do] = ACTIONS(2057),
    [anon_sym_try] = ACTIONS(2057),
    [anon_sym_break] = ACTIONS(2057),
    [anon_sym_continue] = ACTIONS(2057),
    [anon_sym_debugger] = ACTIONS(2057),
    [anon_sym_return] = ACTIONS(2057),
    [anon_sym_throw] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_class] = ACTIONS(2057),
    [anon_sym_async] = ACTIONS(2057),
    [anon_sym_function] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(2057),
    [anon_sym_using] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2057),
    [anon_sym_delete] = ACTIONS(2057),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_private_property_identifier] = ACTIONS(2057),
    [sym_this] = ACTIONS(2057),
    [sym_super] = ACTIONS(2057),
    [sym_true] = ACTIONS(2057),
    [sym_false] = ACTIONS(2057),
    [sym_null] = ACTIONS(2057),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2057),
    [anon_sym_readonly] = ACTIONS(2057),
    [anon_sym_get] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(2057),
    [anon_sym_declare] = ACTIONS(2057),
    [anon_sym_public] = ACTIONS(2057),
    [anon_sym_private] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(2057),
    [anon_sym_override] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(2057),
    [anon_sym_number] = ACTIONS(2057),
    [anon_sym_boolean] = ACTIONS(2057),
    [anon_sym_string] = ACTIONS(2057),
    [anon_sym_symbol] = ACTIONS(2057),
    [anon_sym_object] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_interface] = ACTIONS(2057),
    [anon_sym_enum] = ACTIONS(2057),
    [sym_html_comment] = ACTIONS(5),
  },
  [1162] = {
    [sym_comment] = STATE(1162),
    [ts_builtin_sym_end] = ACTIONS(3374),
    [sym_identifier] = ACTIONS(3368),
    [anon_sym_export] = ACTIONS(3368),
    [anon_sym_type] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3368),
    [anon_sym_RBRACE] = ACTIONS(3368),
    [anon_sym_typeof] = ACTIONS(3368),
    [anon_sym_import] = ACTIONS(3368),
    [anon_sym_with] = ACTIONS(3368),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_else] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_LPAREN] = ACTIONS(3368),
    [anon_sym_await] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_debugger] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3368),
    [anon_sym_yield] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_LTtemplate_GT] = ACTIONS(3368),
    [anon_sym_DQUOTE] = ACTIONS(3368),
    [anon_sym_SQUOTE] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_async] = ACTIONS(3368),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_TILDE] = ACTIONS(3368),
    [anon_sym_void] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3368),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3368),
    [sym_number] = ACTIONS(3368),
    [sym_private_property_identifier] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [sym_super] = ACTIONS(3368),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [sym_null] = ACTIONS(3368),
    [sym_undefined] = ACTIONS(3368),
    [anon_sym_AT] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_readonly] = ACTIONS(3368),
    [anon_sym_get] = ACTIONS(3368),
    [anon_sym_set] = ACTIONS(3368),
    [anon_sym_declare] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_override] = ACTIONS(3368),
    [anon_sym_module] = ACTIONS(3368),
    [anon_sym_any] = ACTIONS(3368),
    [anon_sym_number] = ACTIONS(3368),
    [anon_sym_boolean] = ACTIONS(3368),
    [anon_sym_string] = ACTIONS(3368),
    [anon_sym_symbol] = ACTIONS(3368),
    [anon_sym_object] = ACTIONS(3368),
    [anon_sym_abstract] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [sym_html_comment] = ACTIONS(5),
  },
  [1163] = {
    [sym_comment] = STATE(1163),
    [ts_builtin_sym_end] = ACTIONS(3374),
    [sym_identifier] = ACTIONS(3368),
    [anon_sym_export] = ACTIONS(3368),
    [anon_sym_type] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3368),
    [anon_sym_RBRACE] = ACTIONS(3368),
    [anon_sym_typeof] = ACTIONS(3368),
    [anon_sym_import] = ACTIONS(3368),
    [anon_sym_with] = ACTIONS(3368),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_else] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_LPAREN] = ACTIONS(3368),
    [anon_sym_await] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_debugger] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3368),
    [anon_sym_yield] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_LTtemplate_GT] = ACTIONS(3368),
    [anon_sym_DQUOTE] = ACTIONS(3368),
    [anon_sym_SQUOTE] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_async] = ACTIONS(3368),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_TILDE] = ACTIONS(3368),
    [anon_sym_void] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3368),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3368),
    [sym_number] = ACTIONS(3368),
    [sym_private_property_identifier] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [sym_super] = ACTIONS(3368),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [sym_null] = ACTIONS(3368),
    [sym_undefined] = ACTIONS(3368),
    [anon_sym_AT] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_readonly] = ACTIONS(3368),
    [anon_sym_get] = ACTIONS(3368),
    [anon_sym_set] = ACTIONS(3368),
    [anon_sym_declare] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_override] = ACTIONS(3368),
    [anon_sym_module] = ACTIONS(3368),
    [anon_sym_any] = ACTIONS(3368),
    [anon_sym_number] = ACTIONS(3368),
    [anon_sym_boolean] = ACTIONS(3368),
    [anon_sym_string] = ACTIONS(3368),
    [anon_sym_symbol] = ACTIONS(3368),
    [anon_sym_object] = ACTIONS(3368),
    [anon_sym_abstract] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [sym_html_comment] = ACTIONS(5),
  },
  [1164] = {
    [sym_comment] = STATE(1164),
    [ts_builtin_sym_end] = ACTIONS(3376),
    [sym_identifier] = ACTIONS(3366),
    [anon_sym_export] = ACTIONS(3366),
    [anon_sym_type] = ACTIONS(3366),
    [anon_sym_namespace] = ACTIONS(3366),
    [anon_sym_LBRACE] = ACTIONS(3366),
    [anon_sym_RBRACE] = ACTIONS(3366),
    [anon_sym_typeof] = ACTIONS(3366),
    [anon_sym_import] = ACTIONS(3366),
    [anon_sym_with] = ACTIONS(3366),
    [anon_sym_var] = ACTIONS(3366),
    [anon_sym_let] = ACTIONS(3366),
    [anon_sym_const] = ACTIONS(3366),
    [anon_sym_BANG] = ACTIONS(3366),
    [anon_sym_else] = ACTIONS(3366),
    [anon_sym_if] = ACTIONS(3366),
    [anon_sym_switch] = ACTIONS(3366),
    [anon_sym_for] = ACTIONS(3366),
    [anon_sym_LPAREN] = ACTIONS(3366),
    [anon_sym_await] = ACTIONS(3366),
    [anon_sym_while] = ACTIONS(3366),
    [anon_sym_do] = ACTIONS(3366),
    [anon_sym_try] = ACTIONS(3366),
    [anon_sym_break] = ACTIONS(3366),
    [anon_sym_continue] = ACTIONS(3366),
    [anon_sym_debugger] = ACTIONS(3366),
    [anon_sym_return] = ACTIONS(3366),
    [anon_sym_throw] = ACTIONS(3366),
    [anon_sym_SEMI] = ACTIONS(3366),
    [anon_sym_yield] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(3366),
    [anon_sym_LTtemplate_GT] = ACTIONS(3366),
    [anon_sym_DQUOTE] = ACTIONS(3366),
    [anon_sym_SQUOTE] = ACTIONS(3366),
    [anon_sym_class] = ACTIONS(3366),
    [anon_sym_async] = ACTIONS(3366),
    [anon_sym_function] = ACTIONS(3366),
    [anon_sym_new] = ACTIONS(3366),
    [anon_sym_using] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_SLASH] = ACTIONS(3366),
    [anon_sym_LT] = ACTIONS(3366),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_void] = ACTIONS(3366),
    [anon_sym_delete] = ACTIONS(3366),
    [anon_sym_PLUS_PLUS] = ACTIONS(3366),
    [anon_sym_DASH_DASH] = ACTIONS(3366),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3366),
    [sym_number] = ACTIONS(3366),
    [sym_private_property_identifier] = ACTIONS(3366),
    [sym_this] = ACTIONS(3366),
    [sym_super] = ACTIONS(3366),
    [sym_true] = ACTIONS(3366),
    [sym_false] = ACTIONS(3366),
    [sym_null] = ACTIONS(3366),
    [sym_undefined] = ACTIONS(3366),
    [anon_sym_AT] = ACTIONS(3366),
    [anon_sym_static] = ACTIONS(3366),
    [anon_sym_readonly] = ACTIONS(3366),
    [anon_sym_get] = ACTIONS(3366),
    [anon_sym_set] = ACTIONS(3366),
    [anon_sym_declare] = ACTIONS(3366),
    [anon_sym_public] = ACTIONS(3366),
    [anon_sym_private] = ACTIONS(3366),
    [anon_sym_protected] = ACTIONS(3366),
    [anon_sym_override] = ACTIONS(3366),
    [anon_sym_module] = ACTIONS(3366),
    [anon_sym_any] = ACTIONS(3366),
    [anon_sym_number] = ACTIONS(3366),
    [anon_sym_boolean] = ACTIONS(3366),
    [anon_sym_string] = ACTIONS(3366),
    [anon_sym_symbol] = ACTIONS(3366),
    [anon_sym_object] = ACTIONS(3366),
    [anon_sym_abstract] = ACTIONS(3366),
    [anon_sym_interface] = ACTIONS(3366),
    [anon_sym_enum] = ACTIONS(3366),
    [sym_html_comment] = ACTIONS(5),
  },
  [1165] = {
    [sym_comment] = STATE(1165),
    [sym_identifier] = ACTIONS(3174),
    [anon_sym_export] = ACTIONS(3174),
    [anon_sym_default] = ACTIONS(3174),
    [anon_sym_type] = ACTIONS(3174),
    [anon_sym_namespace] = ACTIONS(3174),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(3174),
    [anon_sym_typeof] = ACTIONS(3174),
    [anon_sym_import] = ACTIONS(3174),
    [anon_sym_with] = ACTIONS(3174),
    [anon_sym_var] = ACTIONS(3174),
    [anon_sym_let] = ACTIONS(3174),
    [anon_sym_const] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_if] = ACTIONS(3174),
    [anon_sym_switch] = ACTIONS(3174),
    [anon_sym_for] = ACTIONS(3174),
    [anon_sym_LPAREN] = ACTIONS(3174),
    [anon_sym_await] = ACTIONS(3174),
    [anon_sym_while] = ACTIONS(3174),
    [anon_sym_do] = ACTIONS(3174),
    [anon_sym_try] = ACTIONS(3174),
    [anon_sym_break] = ACTIONS(3174),
    [anon_sym_continue] = ACTIONS(3174),
    [anon_sym_debugger] = ACTIONS(3174),
    [anon_sym_return] = ACTIONS(3174),
    [anon_sym_throw] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym_case] = ACTIONS(3174),
    [anon_sym_yield] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(3174),
    [anon_sym_LTtemplate_GT] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_class] = ACTIONS(3174),
    [anon_sym_async] = ACTIONS(3174),
    [anon_sym_function] = ACTIONS(3174),
    [anon_sym_new] = ACTIONS(3174),
    [anon_sym_using] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_SLASH] = ACTIONS(3174),
    [anon_sym_LT] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_void] = ACTIONS(3174),
    [anon_sym_delete] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3174),
    [sym_number] = ACTIONS(3174),
    [sym_private_property_identifier] = ACTIONS(3174),
    [sym_this] = ACTIONS(3174),
    [sym_super] = ACTIONS(3174),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [sym_null] = ACTIONS(3174),
    [sym_undefined] = ACTIONS(3174),
    [anon_sym_AT] = ACTIONS(3174),
    [anon_sym_static] = ACTIONS(3174),
    [anon_sym_readonly] = ACTIONS(3174),
    [anon_sym_get] = ACTIONS(3174),
    [anon_sym_set] = ACTIONS(3174),
    [anon_sym_declare] = ACTIONS(3174),
    [anon_sym_public] = ACTIONS(3174),
    [anon_sym_private] = ACTIONS(3174),
    [anon_sym_protected] = ACTIONS(3174),
    [anon_sym_override] = ACTIONS(3174),
    [anon_sym_module] = ACTIONS(3174),
    [anon_sym_any] = ACTIONS(3174),
    [anon_sym_number] = ACTIONS(3174),
    [anon_sym_boolean] = ACTIONS(3174),
    [anon_sym_string] = ACTIONS(3174),
    [anon_sym_symbol] = ACTIONS(3174),
    [anon_sym_object] = ACTIONS(3174),
    [anon_sym_abstract] = ACTIONS(3174),
    [anon_sym_interface] = ACTIONS(3174),
    [anon_sym_enum] = ACTIONS(3174),
    [sym_html_comment] = ACTIONS(5),
  },
  [1166] = {
    [sym_comment] = STATE(1166),
    [ts_builtin_sym_end] = ACTIONS(2387),
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_export] = ACTIONS(2213),
    [anon_sym_type] = ACTIONS(2213),
    [anon_sym_namespace] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_typeof] = ACTIONS(2213),
    [anon_sym_import] = ACTIONS(2213),
    [anon_sym_with] = ACTIONS(2213),
    [anon_sym_var] = ACTIONS(2213),
    [anon_sym_let] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_if] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_for] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [anon_sym_await] = ACTIONS(2213),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_do] = ACTIONS(2213),
    [anon_sym_try] = ACTIONS(2213),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_debugger] = ACTIONS(2213),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_throw] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym_yield] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2213),
    [anon_sym_LTtemplate_GT] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_class] = ACTIONS(2213),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2213),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_using] = ACTIONS(2213),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_void] = ACTIONS(2213),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2213),
    [sym_number] = ACTIONS(2213),
    [sym_private_property_identifier] = ACTIONS(2213),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(2213),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2213),
    [anon_sym_static] = ACTIONS(2213),
    [anon_sym_readonly] = ACTIONS(2213),
    [anon_sym_get] = ACTIONS(2213),
    [anon_sym_set] = ACTIONS(2213),
    [anon_sym_declare] = ACTIONS(2213),
    [anon_sym_public] = ACTIONS(2213),
    [anon_sym_private] = ACTIONS(2213),
    [anon_sym_protected] = ACTIONS(2213),
    [anon_sym_override] = ACTIONS(2213),
    [anon_sym_module] = ACTIONS(2213),
    [anon_sym_any] = ACTIONS(2213),
    [anon_sym_number] = ACTIONS(2213),
    [anon_sym_boolean] = ACTIONS(2213),
    [anon_sym_string] = ACTIONS(2213),
    [anon_sym_symbol] = ACTIONS(2213),
    [anon_sym_object] = ACTIONS(2213),
    [anon_sym_abstract] = ACTIONS(2213),
    [anon_sym_interface] = ACTIONS(2213),
    [anon_sym_enum] = ACTIONS(2213),
    [sym__automatic_semicolon] = ACTIONS(2421),
    [sym_html_comment] = ACTIONS(5),
  },
  [1167] = {
    [sym_comment] = STATE(1167),
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_export] = ACTIONS(3172),
    [anon_sym_default] = ACTIONS(3172),
    [anon_sym_type] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_typeof] = ACTIONS(3172),
    [anon_sym_import] = ACTIONS(3172),
    [anon_sym_with] = ACTIONS(3172),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_LPAREN] = ACTIONS(3172),
    [anon_sym_await] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_debugger] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_case] = ACTIONS(3172),
    [anon_sym_yield] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_LTtemplate_GT] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_async] = ACTIONS(3172),
    [anon_sym_function] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_SLASH] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_void] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3172),
    [sym_number] = ACTIONS(3172),
    [sym_private_property_identifier] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
    [sym_super] = ACTIONS(3172),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [sym_null] = ACTIONS(3172),
    [sym_undefined] = ACTIONS(3172),
    [anon_sym_AT] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_readonly] = ACTIONS(3172),
    [anon_sym_get] = ACTIONS(3172),
    [anon_sym_set] = ACTIONS(3172),
    [anon_sym_declare] = ACTIONS(3172),
    [anon_sym_public] = ACTIONS(3172),
    [anon_sym_private] = ACTIONS(3172),
    [anon_sym_protected] = ACTIONS(3172),
    [anon_sym_override] = ACTIONS(3172),
    [anon_sym_module] = ACTIONS(3172),
    [anon_sym_any] = ACTIONS(3172),
    [anon_sym_number] = ACTIONS(3172),
    [anon_sym_boolean] = ACTIONS(3172),
    [anon_sym_string] = ACTIONS(3172),
    [anon_sym_symbol] = ACTIONS(3172),
    [anon_sym_object] = ACTIONS(3172),
    [anon_sym_abstract] = ACTIONS(3172),
    [anon_sym_interface] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [sym_html_comment] = ACTIONS(5),
  },
  [1168] = {
    [sym_comment] = STATE(1168),
    [ts_builtin_sym_end] = ACTIONS(2325),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2225),
    [anon_sym_RBRACE] = ACTIONS(2225),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2225),
    [anon_sym_yield] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2225),
    [anon_sym_LTtemplate_GT] = ACTIONS(2225),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_SQUOTE] = ACTIONS(2225),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_function] = ACTIONS(2225),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_using] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_TILDE] = ACTIONS(2225),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(2225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2225),
    [sym_number] = ACTIONS(2225),
    [sym_private_property_identifier] = ACTIONS(2225),
    [sym_this] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [sym_false] = ACTIONS(2225),
    [sym_null] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2225),
    [anon_sym_static] = ACTIONS(2225),
    [anon_sym_readonly] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_override] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_object] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
    [sym__automatic_semicolon] = ACTIONS(2457),
    [sym_html_comment] = ACTIONS(5),
  },
  [1169] = {
    [sym_comment] = STATE(1169),
    [sym_identifier] = ACTIONS(3272),
    [anon_sym_export] = ACTIONS(3272),
    [anon_sym_default] = ACTIONS(3272),
    [anon_sym_type] = ACTIONS(3272),
    [anon_sym_namespace] = ACTIONS(3272),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_typeof] = ACTIONS(3272),
    [anon_sym_import] = ACTIONS(3272),
    [anon_sym_with] = ACTIONS(3272),
    [anon_sym_var] = ACTIONS(3272),
    [anon_sym_let] = ACTIONS(3272),
    [anon_sym_const] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_if] = ACTIONS(3272),
    [anon_sym_switch] = ACTIONS(3272),
    [anon_sym_for] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3272),
    [anon_sym_await] = ACTIONS(3272),
    [anon_sym_while] = ACTIONS(3272),
    [anon_sym_do] = ACTIONS(3272),
    [anon_sym_try] = ACTIONS(3272),
    [anon_sym_break] = ACTIONS(3272),
    [anon_sym_continue] = ACTIONS(3272),
    [anon_sym_debugger] = ACTIONS(3272),
    [anon_sym_return] = ACTIONS(3272),
    [anon_sym_throw] = ACTIONS(3272),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym_case] = ACTIONS(3272),
    [anon_sym_yield] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_LTtemplate_GT] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_class] = ACTIONS(3272),
    [anon_sym_async] = ACTIONS(3272),
    [anon_sym_function] = ACTIONS(3272),
    [anon_sym_new] = ACTIONS(3272),
    [anon_sym_using] = ACTIONS(3272),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_SLASH] = ACTIONS(3272),
    [anon_sym_LT] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_void] = ACTIONS(3272),
    [anon_sym_delete] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3272),
    [sym_number] = ACTIONS(3272),
    [sym_private_property_identifier] = ACTIONS(3272),
    [sym_this] = ACTIONS(3272),
    [sym_super] = ACTIONS(3272),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_undefined] = ACTIONS(3272),
    [anon_sym_AT] = ACTIONS(3272),
    [anon_sym_static] = ACTIONS(3272),
    [anon_sym_readonly] = ACTIONS(3272),
    [anon_sym_get] = ACTIONS(3272),
    [anon_sym_set] = ACTIONS(3272),
    [anon_sym_declare] = ACTIONS(3272),
    [anon_sym_public] = ACTIONS(3272),
    [anon_sym_private] = ACTIONS(3272),
    [anon_sym_protected] = ACTIONS(3272),
    [anon_sym_override] = ACTIONS(3272),
    [anon_sym_module] = ACTIONS(3272),
    [anon_sym_any] = ACTIONS(3272),
    [anon_sym_number] = ACTIONS(3272),
    [anon_sym_boolean] = ACTIONS(3272),
    [anon_sym_string] = ACTIONS(3272),
    [anon_sym_symbol] = ACTIONS(3272),
    [anon_sym_object] = ACTIONS(3272),
    [anon_sym_abstract] = ACTIONS(3272),
    [anon_sym_interface] = ACTIONS(3272),
    [anon_sym_enum] = ACTIONS(3272),
    [sym_html_comment] = ACTIONS(5),
  },
  [1170] = {
    [sym_comment] = STATE(1170),
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_export] = ACTIONS(3172),
    [anon_sym_default] = ACTIONS(3172),
    [anon_sym_type] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_typeof] = ACTIONS(3172),
    [anon_sym_import] = ACTIONS(3172),
    [anon_sym_with] = ACTIONS(3172),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_LPAREN] = ACTIONS(3172),
    [anon_sym_await] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_debugger] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_case] = ACTIONS(3172),
    [anon_sym_yield] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_LTtemplate_GT] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_async] = ACTIONS(3172),
    [anon_sym_function] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_SLASH] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_void] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3172),
    [sym_number] = ACTIONS(3172),
    [sym_private_property_identifier] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
    [sym_super] = ACTIONS(3172),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [sym_null] = ACTIONS(3172),
    [sym_undefined] = ACTIONS(3172),
    [anon_sym_AT] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_readonly] = ACTIONS(3172),
    [anon_sym_get] = ACTIONS(3172),
    [anon_sym_set] = ACTIONS(3172),
    [anon_sym_declare] = ACTIONS(3172),
    [anon_sym_public] = ACTIONS(3172),
    [anon_sym_private] = ACTIONS(3172),
    [anon_sym_protected] = ACTIONS(3172),
    [anon_sym_override] = ACTIONS(3172),
    [anon_sym_module] = ACTIONS(3172),
    [anon_sym_any] = ACTIONS(3172),
    [anon_sym_number] = ACTIONS(3172),
    [anon_sym_boolean] = ACTIONS(3172),
    [anon_sym_string] = ACTIONS(3172),
    [anon_sym_symbol] = ACTIONS(3172),
    [anon_sym_object] = ACTIONS(3172),
    [anon_sym_abstract] = ACTIONS(3172),
    [anon_sym_interface] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [sym_html_comment] = ACTIONS(5),
  },
  [1171] = {
    [sym_comment] = STATE(1171),
    [ts_builtin_sym_end] = ACTIONS(2329),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_export] = ACTIONS(2241),
    [anon_sym_type] = ACTIONS(2241),
    [anon_sym_namespace] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_typeof] = ACTIONS(2241),
    [anon_sym_import] = ACTIONS(2241),
    [anon_sym_with] = ACTIONS(2241),
    [anon_sym_var] = ACTIONS(2241),
    [anon_sym_let] = ACTIONS(2241),
    [anon_sym_const] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_if] = ACTIONS(2241),
    [anon_sym_switch] = ACTIONS(2241),
    [anon_sym_for] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_await] = ACTIONS(2241),
    [anon_sym_while] = ACTIONS(2241),
    [anon_sym_do] = ACTIONS(2241),
    [anon_sym_try] = ACTIONS(2241),
    [anon_sym_break] = ACTIONS(2241),
    [anon_sym_continue] = ACTIONS(2241),
    [anon_sym_debugger] = ACTIONS(2241),
    [anon_sym_return] = ACTIONS(2241),
    [anon_sym_throw] = ACTIONS(2241),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_yield] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_LTtemplate_GT] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_class] = ACTIONS(2241),
    [anon_sym_async] = ACTIONS(2241),
    [anon_sym_function] = ACTIONS(2241),
    [anon_sym_new] = ACTIONS(2241),
    [anon_sym_using] = ACTIONS(2241),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_SLASH] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_void] = ACTIONS(2241),
    [anon_sym_delete] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2241),
    [sym_number] = ACTIONS(2241),
    [sym_private_property_identifier] = ACTIONS(2241),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(2241),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(2241),
    [anon_sym_static] = ACTIONS(2241),
    [anon_sym_readonly] = ACTIONS(2241),
    [anon_sym_get] = ACTIONS(2241),
    [anon_sym_set] = ACTIONS(2241),
    [anon_sym_declare] = ACTIONS(2241),
    [anon_sym_public] = ACTIONS(2241),
    [anon_sym_private] = ACTIONS(2241),
    [anon_sym_protected] = ACTIONS(2241),
    [anon_sym_override] = ACTIONS(2241),
    [anon_sym_module] = ACTIONS(2241),
    [anon_sym_any] = ACTIONS(2241),
    [anon_sym_number] = ACTIONS(2241),
    [anon_sym_boolean] = ACTIONS(2241),
    [anon_sym_string] = ACTIONS(2241),
    [anon_sym_symbol] = ACTIONS(2241),
    [anon_sym_object] = ACTIONS(2241),
    [anon_sym_abstract] = ACTIONS(2241),
    [anon_sym_interface] = ACTIONS(2241),
    [anon_sym_enum] = ACTIONS(2241),
    [sym__automatic_semicolon] = ACTIONS(2407),
    [sym_html_comment] = ACTIONS(5),
  },
  [1172] = {
    [sym_comment] = STATE(1172),
    [sym_identifier] = ACTIONS(3170),
    [anon_sym_export] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_type] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_typeof] = ACTIONS(3170),
    [anon_sym_import] = ACTIONS(3170),
    [anon_sym_with] = ACTIONS(3170),
    [anon_sym_var] = ACTIONS(3170),
    [anon_sym_let] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_await] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_debugger] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_yield] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_LTtemplate_GT] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_async] = ACTIONS(3170),
    [anon_sym_function] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_void] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [sym_number] = ACTIONS(3170),
    [sym_private_property_identifier] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
    [sym_super] = ACTIONS(3170),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [sym_null] = ACTIONS(3170),
    [sym_undefined] = ACTIONS(3170),
    [anon_sym_AT] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_readonly] = ACTIONS(3170),
    [anon_sym_get] = ACTIONS(3170),
    [anon_sym_set] = ACTIONS(3170),
    [anon_sym_declare] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_override] = ACTIONS(3170),
    [anon_sym_module] = ACTIONS(3170),
    [anon_sym_any] = ACTIONS(3170),
    [anon_sym_number] = ACTIONS(3170),
    [anon_sym_boolean] = ACTIONS(3170),
    [anon_sym_string] = ACTIONS(3170),
    [anon_sym_symbol] = ACTIONS(3170),
    [anon_sym_object] = ACTIONS(3170),
    [anon_sym_abstract] = ACTIONS(3170),
    [anon_sym_interface] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [sym_html_comment] = ACTIONS(5),
  },
  [1173] = {
    [sym_comment] = STATE(1173),
    [ts_builtin_sym_end] = ACTIONS(2275),
    [sym_identifier] = ACTIONS(2189),
    [anon_sym_export] = ACTIONS(2189),
    [anon_sym_type] = ACTIONS(2189),
    [anon_sym_namespace] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_import] = ACTIONS(2189),
    [anon_sym_with] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2189),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_debugger] = ACTIONS(2189),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2189),
    [anon_sym_LTtemplate_GT] = ACTIONS(2189),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_class] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_function] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_using] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_void] = ACTIONS(2189),
    [anon_sym_delete] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2189),
    [sym_number] = ACTIONS(2189),
    [sym_private_property_identifier] = ACTIONS(2189),
    [sym_this] = ACTIONS(2189),
    [sym_super] = ACTIONS(2189),
    [sym_true] = ACTIONS(2189),
    [sym_false] = ACTIONS(2189),
    [sym_null] = ACTIONS(2189),
    [sym_undefined] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_declare] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_module] = ACTIONS(2189),
    [anon_sym_any] = ACTIONS(2189),
    [anon_sym_number] = ACTIONS(2189),
    [anon_sym_boolean] = ACTIONS(2189),
    [anon_sym_string] = ACTIONS(2189),
    [anon_sym_symbol] = ACTIONS(2189),
    [anon_sym_object] = ACTIONS(2189),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_interface] = ACTIONS(2189),
    [anon_sym_enum] = ACTIONS(2189),
    [sym__automatic_semicolon] = ACTIONS(2443),
    [sym_html_comment] = ACTIONS(5),
  },
  [1174] = {
    [sym_comment] = STATE(1174),
    [ts_builtin_sym_end] = ACTIONS(3378),
    [sym_identifier] = ACTIONS(3254),
    [anon_sym_export] = ACTIONS(3254),
    [anon_sym_type] = ACTIONS(3254),
    [anon_sym_namespace] = ACTIONS(3254),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_RBRACE] = ACTIONS(3254),
    [anon_sym_typeof] = ACTIONS(3254),
    [anon_sym_import] = ACTIONS(3254),
    [anon_sym_with] = ACTIONS(3254),
    [anon_sym_var] = ACTIONS(3254),
    [anon_sym_let] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_BANG] = ACTIONS(3254),
    [anon_sym_else] = ACTIONS(3254),
    [anon_sym_if] = ACTIONS(3254),
    [anon_sym_switch] = ACTIONS(3254),
    [anon_sym_for] = ACTIONS(3254),
    [anon_sym_LPAREN] = ACTIONS(3254),
    [anon_sym_await] = ACTIONS(3254),
    [anon_sym_while] = ACTIONS(3254),
    [anon_sym_do] = ACTIONS(3254),
    [anon_sym_try] = ACTIONS(3254),
    [anon_sym_break] = ACTIONS(3254),
    [anon_sym_continue] = ACTIONS(3254),
    [anon_sym_debugger] = ACTIONS(3254),
    [anon_sym_return] = ACTIONS(3254),
    [anon_sym_throw] = ACTIONS(3254),
    [anon_sym_SEMI] = ACTIONS(3254),
    [anon_sym_yield] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_LTtemplate_GT] = ACTIONS(3254),
    [anon_sym_DQUOTE] = ACTIONS(3254),
    [anon_sym_SQUOTE] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_async] = ACTIONS(3254),
    [anon_sym_function] = ACTIONS(3254),
    [anon_sym_new] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_PLUS] = ACTIONS(3254),
    [anon_sym_DASH] = ACTIONS(3254),
    [anon_sym_SLASH] = ACTIONS(3254),
    [anon_sym_LT] = ACTIONS(3254),
    [anon_sym_TILDE] = ACTIONS(3254),
    [anon_sym_void] = ACTIONS(3254),
    [anon_sym_delete] = ACTIONS(3254),
    [anon_sym_PLUS_PLUS] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3254),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3254),
    [sym_number] = ACTIONS(3254),
    [sym_private_property_identifier] = ACTIONS(3254),
    [sym_this] = ACTIONS(3254),
    [sym_super] = ACTIONS(3254),
    [sym_true] = ACTIONS(3254),
    [sym_false] = ACTIONS(3254),
    [sym_null] = ACTIONS(3254),
    [sym_undefined] = ACTIONS(3254),
    [anon_sym_AT] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_readonly] = ACTIONS(3254),
    [anon_sym_get] = ACTIONS(3254),
    [anon_sym_set] = ACTIONS(3254),
    [anon_sym_declare] = ACTIONS(3254),
    [anon_sym_public] = ACTIONS(3254),
    [anon_sym_private] = ACTIONS(3254),
    [anon_sym_protected] = ACTIONS(3254),
    [anon_sym_override] = ACTIONS(3254),
    [anon_sym_module] = ACTIONS(3254),
    [anon_sym_any] = ACTIONS(3254),
    [anon_sym_number] = ACTIONS(3254),
    [anon_sym_boolean] = ACTIONS(3254),
    [anon_sym_string] = ACTIONS(3254),
    [anon_sym_symbol] = ACTIONS(3254),
    [anon_sym_object] = ACTIONS(3254),
    [anon_sym_abstract] = ACTIONS(3254),
    [anon_sym_interface] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [sym_html_comment] = ACTIONS(5),
  },
  [1175] = {
    [sym_comment] = STATE(1175),
    [ts_builtin_sym_end] = ACTIONS(3380),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_export] = ACTIONS(3250),
    [anon_sym_type] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_typeof] = ACTIONS(3250),
    [anon_sym_import] = ACTIONS(3250),
    [anon_sym_with] = ACTIONS(3250),
    [anon_sym_var] = ACTIONS(3250),
    [anon_sym_let] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_else] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym_await] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_debugger] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3250),
    [anon_sym_yield] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_LTtemplate_GT] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_async] = ACTIONS(3250),
    [anon_sym_function] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3250),
    [anon_sym_LT] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_void] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3250),
    [sym_number] = ACTIONS(3250),
    [sym_private_property_identifier] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
    [sym_super] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_null] = ACTIONS(3250),
    [sym_undefined] = ACTIONS(3250),
    [anon_sym_AT] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_readonly] = ACTIONS(3250),
    [anon_sym_get] = ACTIONS(3250),
    [anon_sym_set] = ACTIONS(3250),
    [anon_sym_declare] = ACTIONS(3250),
    [anon_sym_public] = ACTIONS(3250),
    [anon_sym_private] = ACTIONS(3250),
    [anon_sym_protected] = ACTIONS(3250),
    [anon_sym_override] = ACTIONS(3250),
    [anon_sym_module] = ACTIONS(3250),
    [anon_sym_any] = ACTIONS(3250),
    [anon_sym_number] = ACTIONS(3250),
    [anon_sym_boolean] = ACTIONS(3250),
    [anon_sym_string] = ACTIONS(3250),
    [anon_sym_symbol] = ACTIONS(3250),
    [anon_sym_object] = ACTIONS(3250),
    [anon_sym_abstract] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [sym_html_comment] = ACTIONS(5),
  },
  [1176] = {
    [sym_comment] = STATE(1176),
    [ts_builtin_sym_end] = ACTIONS(3382),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_export] = ACTIONS(3234),
    [anon_sym_type] = ACTIONS(3234),
    [anon_sym_namespace] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(3234),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_typeof] = ACTIONS(3234),
    [anon_sym_import] = ACTIONS(3234),
    [anon_sym_with] = ACTIONS(3234),
    [anon_sym_var] = ACTIONS(3234),
    [anon_sym_let] = ACTIONS(3234),
    [anon_sym_const] = ACTIONS(3234),
    [anon_sym_BANG] = ACTIONS(3234),
    [anon_sym_else] = ACTIONS(3234),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_for] = ACTIONS(3234),
    [anon_sym_LPAREN] = ACTIONS(3234),
    [anon_sym_await] = ACTIONS(3234),
    [anon_sym_while] = ACTIONS(3234),
    [anon_sym_do] = ACTIONS(3234),
    [anon_sym_try] = ACTIONS(3234),
    [anon_sym_break] = ACTIONS(3234),
    [anon_sym_continue] = ACTIONS(3234),
    [anon_sym_debugger] = ACTIONS(3234),
    [anon_sym_return] = ACTIONS(3234),
    [anon_sym_throw] = ACTIONS(3234),
    [anon_sym_SEMI] = ACTIONS(3234),
    [anon_sym_yield] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_LTtemplate_GT] = ACTIONS(3234),
    [anon_sym_DQUOTE] = ACTIONS(3234),
    [anon_sym_SQUOTE] = ACTIONS(3234),
    [anon_sym_class] = ACTIONS(3234),
    [anon_sym_async] = ACTIONS(3234),
    [anon_sym_function] = ACTIONS(3234),
    [anon_sym_new] = ACTIONS(3234),
    [anon_sym_using] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3234),
    [anon_sym_DASH] = ACTIONS(3234),
    [anon_sym_SLASH] = ACTIONS(3234),
    [anon_sym_LT] = ACTIONS(3234),
    [anon_sym_TILDE] = ACTIONS(3234),
    [anon_sym_void] = ACTIONS(3234),
    [anon_sym_delete] = ACTIONS(3234),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3234),
    [sym_number] = ACTIONS(3234),
    [sym_private_property_identifier] = ACTIONS(3234),
    [sym_this] = ACTIONS(3234),
    [sym_super] = ACTIONS(3234),
    [sym_true] = ACTIONS(3234),
    [sym_false] = ACTIONS(3234),
    [sym_null] = ACTIONS(3234),
    [sym_undefined] = ACTIONS(3234),
    [anon_sym_AT] = ACTIONS(3234),
    [anon_sym_static] = ACTIONS(3234),
    [anon_sym_readonly] = ACTIONS(3234),
    [anon_sym_get] = ACTIONS(3234),
    [anon_sym_set] = ACTIONS(3234),
    [anon_sym_declare] = ACTIONS(3234),
    [anon_sym_public] = ACTIONS(3234),
    [anon_sym_private] = ACTIONS(3234),
    [anon_sym_protected] = ACTIONS(3234),
    [anon_sym_override] = ACTIONS(3234),
    [anon_sym_module] = ACTIONS(3234),
    [anon_sym_any] = ACTIONS(3234),
    [anon_sym_number] = ACTIONS(3234),
    [anon_sym_boolean] = ACTIONS(3234),
    [anon_sym_string] = ACTIONS(3234),
    [anon_sym_symbol] = ACTIONS(3234),
    [anon_sym_object] = ACTIONS(3234),
    [anon_sym_abstract] = ACTIONS(3234),
    [anon_sym_interface] = ACTIONS(3234),
    [anon_sym_enum] = ACTIONS(3234),
    [sym_html_comment] = ACTIONS(5),
  },
  [1177] = {
    [sym_comment] = STATE(1177),
    [ts_builtin_sym_end] = ACTIONS(3186),
    [sym_identifier] = ACTIONS(3094),
    [anon_sym_export] = ACTIONS(3094),
    [anon_sym_type] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3094),
    [anon_sym_typeof] = ACTIONS(3094),
    [anon_sym_import] = ACTIONS(3094),
    [anon_sym_with] = ACTIONS(3094),
    [anon_sym_var] = ACTIONS(3094),
    [anon_sym_let] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3094),
    [anon_sym_await] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_debugger] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3094),
    [anon_sym_finally] = ACTIONS(3094),
    [anon_sym_yield] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_LTtemplate_GT] = ACTIONS(3094),
    [anon_sym_DQUOTE] = ACTIONS(3094),
    [anon_sym_SQUOTE] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_async] = ACTIONS(3094),
    [anon_sym_function] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_TILDE] = ACTIONS(3094),
    [anon_sym_void] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3094),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3094),
    [sym_number] = ACTIONS(3094),
    [sym_private_property_identifier] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
    [sym_super] = ACTIONS(3094),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_undefined] = ACTIONS(3094),
    [anon_sym_AT] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_readonly] = ACTIONS(3094),
    [anon_sym_get] = ACTIONS(3094),
    [anon_sym_set] = ACTIONS(3094),
    [anon_sym_declare] = ACTIONS(3094),
    [anon_sym_public] = ACTIONS(3094),
    [anon_sym_private] = ACTIONS(3094),
    [anon_sym_protected] = ACTIONS(3094),
    [anon_sym_override] = ACTIONS(3094),
    [anon_sym_module] = ACTIONS(3094),
    [anon_sym_any] = ACTIONS(3094),
    [anon_sym_number] = ACTIONS(3094),
    [anon_sym_boolean] = ACTIONS(3094),
    [anon_sym_string] = ACTIONS(3094),
    [anon_sym_symbol] = ACTIONS(3094),
    [anon_sym_object] = ACTIONS(3094),
    [anon_sym_abstract] = ACTIONS(3094),
    [anon_sym_interface] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [sym_html_comment] = ACTIONS(5),
  },
  [1178] = {
    [sym_comment] = STATE(1178),
    [ts_builtin_sym_end] = ACTIONS(3384),
    [sym_identifier] = ACTIONS(3278),
    [anon_sym_export] = ACTIONS(3278),
    [anon_sym_type] = ACTIONS(3278),
    [anon_sym_namespace] = ACTIONS(3278),
    [anon_sym_LBRACE] = ACTIONS(3278),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_typeof] = ACTIONS(3278),
    [anon_sym_import] = ACTIONS(3278),
    [anon_sym_with] = ACTIONS(3278),
    [anon_sym_var] = ACTIONS(3278),
    [anon_sym_let] = ACTIONS(3278),
    [anon_sym_const] = ACTIONS(3278),
    [anon_sym_BANG] = ACTIONS(3278),
    [anon_sym_else] = ACTIONS(3278),
    [anon_sym_if] = ACTIONS(3278),
    [anon_sym_switch] = ACTIONS(3278),
    [anon_sym_for] = ACTIONS(3278),
    [anon_sym_LPAREN] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3278),
    [anon_sym_while] = ACTIONS(3278),
    [anon_sym_do] = ACTIONS(3278),
    [anon_sym_try] = ACTIONS(3278),
    [anon_sym_break] = ACTIONS(3278),
    [anon_sym_continue] = ACTIONS(3278),
    [anon_sym_debugger] = ACTIONS(3278),
    [anon_sym_return] = ACTIONS(3278),
    [anon_sym_throw] = ACTIONS(3278),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym_yield] = ACTIONS(3278),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_LTtemplate_GT] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_class] = ACTIONS(3278),
    [anon_sym_async] = ACTIONS(3278),
    [anon_sym_function] = ACTIONS(3278),
    [anon_sym_new] = ACTIONS(3278),
    [anon_sym_using] = ACTIONS(3278),
    [anon_sym_PLUS] = ACTIONS(3278),
    [anon_sym_DASH] = ACTIONS(3278),
    [anon_sym_SLASH] = ACTIONS(3278),
    [anon_sym_LT] = ACTIONS(3278),
    [anon_sym_TILDE] = ACTIONS(3278),
    [anon_sym_void] = ACTIONS(3278),
    [anon_sym_delete] = ACTIONS(3278),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3278),
    [sym_number] = ACTIONS(3278),
    [sym_private_property_identifier] = ACTIONS(3278),
    [sym_this] = ACTIONS(3278),
    [sym_super] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_null] = ACTIONS(3278),
    [sym_undefined] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3278),
    [anon_sym_static] = ACTIONS(3278),
    [anon_sym_readonly] = ACTIONS(3278),
    [anon_sym_get] = ACTIONS(3278),
    [anon_sym_set] = ACTIONS(3278),
    [anon_sym_declare] = ACTIONS(3278),
    [anon_sym_public] = ACTIONS(3278),
    [anon_sym_private] = ACTIONS(3278),
    [anon_sym_protected] = ACTIONS(3278),
    [anon_sym_override] = ACTIONS(3278),
    [anon_sym_module] = ACTIONS(3278),
    [anon_sym_any] = ACTIONS(3278),
    [anon_sym_number] = ACTIONS(3278),
    [anon_sym_boolean] = ACTIONS(3278),
    [anon_sym_string] = ACTIONS(3278),
    [anon_sym_symbol] = ACTIONS(3278),
    [anon_sym_object] = ACTIONS(3278),
    [anon_sym_abstract] = ACTIONS(3278),
    [anon_sym_interface] = ACTIONS(3278),
    [anon_sym_enum] = ACTIONS(3278),
    [sym_html_comment] = ACTIONS(5),
  },
  [1179] = {
    [sym_comment] = STATE(1179),
    [ts_builtin_sym_end] = ACTIONS(3386),
    [sym_identifier] = ACTIONS(3358),
    [anon_sym_export] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3358),
    [anon_sym_namespace] = ACTIONS(3358),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_RBRACE] = ACTIONS(3358),
    [anon_sym_typeof] = ACTIONS(3358),
    [anon_sym_import] = ACTIONS(3358),
    [anon_sym_with] = ACTIONS(3358),
    [anon_sym_var] = ACTIONS(3358),
    [anon_sym_let] = ACTIONS(3358),
    [anon_sym_const] = ACTIONS(3358),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_else] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3358),
    [anon_sym_switch] = ACTIONS(3358),
    [anon_sym_for] = ACTIONS(3358),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3358),
    [anon_sym_while] = ACTIONS(3358),
    [anon_sym_do] = ACTIONS(3358),
    [anon_sym_try] = ACTIONS(3358),
    [anon_sym_break] = ACTIONS(3358),
    [anon_sym_continue] = ACTIONS(3358),
    [anon_sym_debugger] = ACTIONS(3358),
    [anon_sym_return] = ACTIONS(3358),
    [anon_sym_throw] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3358),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [anon_sym_class] = ACTIONS(3358),
    [anon_sym_async] = ACTIONS(3358),
    [anon_sym_function] = ACTIONS(3358),
    [anon_sym_new] = ACTIONS(3358),
    [anon_sym_using] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3358),
    [anon_sym_DASH] = ACTIONS(3358),
    [anon_sym_SLASH] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3358),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_private_property_identifier] = ACTIONS(3358),
    [sym_this] = ACTIONS(3358),
    [sym_super] = ACTIONS(3358),
    [sym_true] = ACTIONS(3358),
    [sym_false] = ACTIONS(3358),
    [sym_null] = ACTIONS(3358),
    [sym_undefined] = ACTIONS(3358),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3358),
    [anon_sym_readonly] = ACTIONS(3358),
    [anon_sym_get] = ACTIONS(3358),
    [anon_sym_set] = ACTIONS(3358),
    [anon_sym_declare] = ACTIONS(3358),
    [anon_sym_public] = ACTIONS(3358),
    [anon_sym_private] = ACTIONS(3358),
    [anon_sym_protected] = ACTIONS(3358),
    [anon_sym_override] = ACTIONS(3358),
    [anon_sym_module] = ACTIONS(3358),
    [anon_sym_any] = ACTIONS(3358),
    [anon_sym_number] = ACTIONS(3358),
    [anon_sym_boolean] = ACTIONS(3358),
    [anon_sym_string] = ACTIONS(3358),
    [anon_sym_symbol] = ACTIONS(3358),
    [anon_sym_object] = ACTIONS(3358),
    [anon_sym_abstract] = ACTIONS(3358),
    [anon_sym_interface] = ACTIONS(3358),
    [anon_sym_enum] = ACTIONS(3358),
    [sym_html_comment] = ACTIONS(5),
  },
  [1180] = {
    [sym_comment] = STATE(1180),
    [sym_identifier] = ACTIONS(3272),
    [anon_sym_export] = ACTIONS(3272),
    [anon_sym_default] = ACTIONS(3272),
    [anon_sym_type] = ACTIONS(3272),
    [anon_sym_namespace] = ACTIONS(3272),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_typeof] = ACTIONS(3272),
    [anon_sym_import] = ACTIONS(3272),
    [anon_sym_with] = ACTIONS(3272),
    [anon_sym_var] = ACTIONS(3272),
    [anon_sym_let] = ACTIONS(3272),
    [anon_sym_const] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_if] = ACTIONS(3272),
    [anon_sym_switch] = ACTIONS(3272),
    [anon_sym_for] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3272),
    [anon_sym_await] = ACTIONS(3272),
    [anon_sym_while] = ACTIONS(3272),
    [anon_sym_do] = ACTIONS(3272),
    [anon_sym_try] = ACTIONS(3272),
    [anon_sym_break] = ACTIONS(3272),
    [anon_sym_continue] = ACTIONS(3272),
    [anon_sym_debugger] = ACTIONS(3272),
    [anon_sym_return] = ACTIONS(3272),
    [anon_sym_throw] = ACTIONS(3272),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym_case] = ACTIONS(3272),
    [anon_sym_yield] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_LTtemplate_GT] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_class] = ACTIONS(3272),
    [anon_sym_async] = ACTIONS(3272),
    [anon_sym_function] = ACTIONS(3272),
    [anon_sym_new] = ACTIONS(3272),
    [anon_sym_using] = ACTIONS(3272),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_SLASH] = ACTIONS(3272),
    [anon_sym_LT] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_void] = ACTIONS(3272),
    [anon_sym_delete] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3272),
    [sym_number] = ACTIONS(3272),
    [sym_private_property_identifier] = ACTIONS(3272),
    [sym_this] = ACTIONS(3272),
    [sym_super] = ACTIONS(3272),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_undefined] = ACTIONS(3272),
    [anon_sym_AT] = ACTIONS(3272),
    [anon_sym_static] = ACTIONS(3272),
    [anon_sym_readonly] = ACTIONS(3272),
    [anon_sym_get] = ACTIONS(3272),
    [anon_sym_set] = ACTIONS(3272),
    [anon_sym_declare] = ACTIONS(3272),
    [anon_sym_public] = ACTIONS(3272),
    [anon_sym_private] = ACTIONS(3272),
    [anon_sym_protected] = ACTIONS(3272),
    [anon_sym_override] = ACTIONS(3272),
    [anon_sym_module] = ACTIONS(3272),
    [anon_sym_any] = ACTIONS(3272),
    [anon_sym_number] = ACTIONS(3272),
    [anon_sym_boolean] = ACTIONS(3272),
    [anon_sym_string] = ACTIONS(3272),
    [anon_sym_symbol] = ACTIONS(3272),
    [anon_sym_object] = ACTIONS(3272),
    [anon_sym_abstract] = ACTIONS(3272),
    [anon_sym_interface] = ACTIONS(3272),
    [anon_sym_enum] = ACTIONS(3272),
    [sym_html_comment] = ACTIONS(5),
  },
  [1181] = {
    [sym_comment] = STATE(1181),
    [sym_identifier] = ACTIONS(3278),
    [anon_sym_export] = ACTIONS(3278),
    [anon_sym_default] = ACTIONS(3278),
    [anon_sym_type] = ACTIONS(3278),
    [anon_sym_namespace] = ACTIONS(3278),
    [anon_sym_LBRACE] = ACTIONS(3278),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_typeof] = ACTIONS(3278),
    [anon_sym_import] = ACTIONS(3278),
    [anon_sym_with] = ACTIONS(3278),
    [anon_sym_var] = ACTIONS(3278),
    [anon_sym_let] = ACTIONS(3278),
    [anon_sym_const] = ACTIONS(3278),
    [anon_sym_BANG] = ACTIONS(3278),
    [anon_sym_if] = ACTIONS(3278),
    [anon_sym_switch] = ACTIONS(3278),
    [anon_sym_for] = ACTIONS(3278),
    [anon_sym_LPAREN] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3278),
    [anon_sym_while] = ACTIONS(3278),
    [anon_sym_do] = ACTIONS(3278),
    [anon_sym_try] = ACTIONS(3278),
    [anon_sym_break] = ACTIONS(3278),
    [anon_sym_continue] = ACTIONS(3278),
    [anon_sym_debugger] = ACTIONS(3278),
    [anon_sym_return] = ACTIONS(3278),
    [anon_sym_throw] = ACTIONS(3278),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym_case] = ACTIONS(3278),
    [anon_sym_yield] = ACTIONS(3278),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_LTtemplate_GT] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_class] = ACTIONS(3278),
    [anon_sym_async] = ACTIONS(3278),
    [anon_sym_function] = ACTIONS(3278),
    [anon_sym_new] = ACTIONS(3278),
    [anon_sym_using] = ACTIONS(3278),
    [anon_sym_PLUS] = ACTIONS(3278),
    [anon_sym_DASH] = ACTIONS(3278),
    [anon_sym_SLASH] = ACTIONS(3278),
    [anon_sym_LT] = ACTIONS(3278),
    [anon_sym_TILDE] = ACTIONS(3278),
    [anon_sym_void] = ACTIONS(3278),
    [anon_sym_delete] = ACTIONS(3278),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3278),
    [sym_number] = ACTIONS(3278),
    [sym_private_property_identifier] = ACTIONS(3278),
    [sym_this] = ACTIONS(3278),
    [sym_super] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_null] = ACTIONS(3278),
    [sym_undefined] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3278),
    [anon_sym_static] = ACTIONS(3278),
    [anon_sym_readonly] = ACTIONS(3278),
    [anon_sym_get] = ACTIONS(3278),
    [anon_sym_set] = ACTIONS(3278),
    [anon_sym_declare] = ACTIONS(3278),
    [anon_sym_public] = ACTIONS(3278),
    [anon_sym_private] = ACTIONS(3278),
    [anon_sym_protected] = ACTIONS(3278),
    [anon_sym_override] = ACTIONS(3278),
    [anon_sym_module] = ACTIONS(3278),
    [anon_sym_any] = ACTIONS(3278),
    [anon_sym_number] = ACTIONS(3278),
    [anon_sym_boolean] = ACTIONS(3278),
    [anon_sym_string] = ACTIONS(3278),
    [anon_sym_symbol] = ACTIONS(3278),
    [anon_sym_object] = ACTIONS(3278),
    [anon_sym_abstract] = ACTIONS(3278),
    [anon_sym_interface] = ACTIONS(3278),
    [anon_sym_enum] = ACTIONS(3278),
    [sym_html_comment] = ACTIONS(5),
  },
  [1182] = {
    [sym_comment] = STATE(1182),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [sym_html_comment] = ACTIONS(5),
  },
  [1183] = {
    [sym_comment] = STATE(1183),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_LTtemplate_GT] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_function] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2251),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_number] = ACTIONS(2251),
    [sym_private_property_identifier] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [sym_null] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_readonly] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_override] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_object] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [sym_html_comment] = ACTIONS(5),
  },
  [1184] = {
    [sym_comment] = STATE(1184),
    [ts_builtin_sym_end] = ACTIONS(3388),
    [sym_identifier] = ACTIONS(3158),
    [anon_sym_export] = ACTIONS(3158),
    [anon_sym_type] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_typeof] = ACTIONS(3158),
    [anon_sym_import] = ACTIONS(3158),
    [anon_sym_with] = ACTIONS(3158),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_LPAREN] = ACTIONS(3158),
    [anon_sym_await] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_debugger] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_yield] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_LTtemplate_GT] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_async] = ACTIONS(3158),
    [anon_sym_function] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_SLASH] = ACTIONS(3158),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [anon_sym_void] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3158),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3158),
    [sym_number] = ACTIONS(3158),
    [sym_private_property_identifier] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
    [sym_super] = ACTIONS(3158),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [sym_null] = ACTIONS(3158),
    [sym_undefined] = ACTIONS(3158),
    [anon_sym_AT] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_readonly] = ACTIONS(3158),
    [anon_sym_get] = ACTIONS(3158),
    [anon_sym_set] = ACTIONS(3158),
    [anon_sym_declare] = ACTIONS(3158),
    [anon_sym_public] = ACTIONS(3158),
    [anon_sym_private] = ACTIONS(3158),
    [anon_sym_protected] = ACTIONS(3158),
    [anon_sym_override] = ACTIONS(3158),
    [anon_sym_module] = ACTIONS(3158),
    [anon_sym_any] = ACTIONS(3158),
    [anon_sym_number] = ACTIONS(3158),
    [anon_sym_boolean] = ACTIONS(3158),
    [anon_sym_string] = ACTIONS(3158),
    [anon_sym_symbol] = ACTIONS(3158),
    [anon_sym_object] = ACTIONS(3158),
    [anon_sym_abstract] = ACTIONS(3158),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [sym_html_comment] = ACTIONS(5),
  },
  [1185] = {
    [sym_comment] = STATE(1185),
    [ts_builtin_sym_end] = ACTIONS(2313),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_export] = ACTIONS(2129),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_namespace] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_typeof] = ACTIONS(2129),
    [anon_sym_import] = ACTIONS(2129),
    [anon_sym_with] = ACTIONS(2129),
    [anon_sym_var] = ACTIONS(2129),
    [anon_sym_let] = ACTIONS(2129),
    [anon_sym_const] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_if] = ACTIONS(2129),
    [anon_sym_switch] = ACTIONS(2129),
    [anon_sym_for] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(2129),
    [anon_sym_await] = ACTIONS(2129),
    [anon_sym_while] = ACTIONS(2129),
    [anon_sym_do] = ACTIONS(2129),
    [anon_sym_try] = ACTIONS(2129),
    [anon_sym_break] = ACTIONS(2129),
    [anon_sym_continue] = ACTIONS(2129),
    [anon_sym_debugger] = ACTIONS(2129),
    [anon_sym_return] = ACTIONS(2129),
    [anon_sym_throw] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_yield] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(2129),
    [anon_sym_LTtemplate_GT] = ACTIONS(2129),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [anon_sym_class] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(2129),
    [anon_sym_function] = ACTIONS(2129),
    [anon_sym_new] = ACTIONS(2129),
    [anon_sym_using] = ACTIONS(2129),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2129),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_void] = ACTIONS(2129),
    [anon_sym_delete] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_number] = ACTIONS(2129),
    [sym_private_property_identifier] = ACTIONS(2129),
    [sym_this] = ACTIONS(2129),
    [sym_super] = ACTIONS(2129),
    [sym_true] = ACTIONS(2129),
    [sym_false] = ACTIONS(2129),
    [sym_null] = ACTIONS(2129),
    [sym_undefined] = ACTIONS(2129),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_static] = ACTIONS(2129),
    [anon_sym_readonly] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2129),
    [anon_sym_set] = ACTIONS(2129),
    [anon_sym_declare] = ACTIONS(2129),
    [anon_sym_public] = ACTIONS(2129),
    [anon_sym_private] = ACTIONS(2129),
    [anon_sym_protected] = ACTIONS(2129),
    [anon_sym_override] = ACTIONS(2129),
    [anon_sym_module] = ACTIONS(2129),
    [anon_sym_any] = ACTIONS(2129),
    [anon_sym_number] = ACTIONS(2129),
    [anon_sym_boolean] = ACTIONS(2129),
    [anon_sym_string] = ACTIONS(2129),
    [anon_sym_symbol] = ACTIONS(2129),
    [anon_sym_object] = ACTIONS(2129),
    [anon_sym_abstract] = ACTIONS(2129),
    [anon_sym_interface] = ACTIONS(2129),
    [anon_sym_enum] = ACTIONS(2129),
    [sym__automatic_semicolon] = ACTIONS(2451),
    [sym_html_comment] = ACTIONS(5),
  },
  [1186] = {
    [sym_comment] = STATE(1186),
    [ts_builtin_sym_end] = ACTIONS(2287),
    [sym_identifier] = ACTIONS(2137),
    [anon_sym_export] = ACTIONS(2137),
    [anon_sym_type] = ACTIONS(2137),
    [anon_sym_namespace] = ACTIONS(2137),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_typeof] = ACTIONS(2137),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_with] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2137),
    [anon_sym_let] = ACTIONS(2137),
    [anon_sym_const] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2137),
    [anon_sym_if] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2137),
    [anon_sym_for] = ACTIONS(2137),
    [anon_sym_LPAREN] = ACTIONS(2137),
    [anon_sym_await] = ACTIONS(2137),
    [anon_sym_while] = ACTIONS(2137),
    [anon_sym_do] = ACTIONS(2137),
    [anon_sym_try] = ACTIONS(2137),
    [anon_sym_break] = ACTIONS(2137),
    [anon_sym_continue] = ACTIONS(2137),
    [anon_sym_debugger] = ACTIONS(2137),
    [anon_sym_return] = ACTIONS(2137),
    [anon_sym_throw] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym_yield] = ACTIONS(2137),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_LTtemplate_GT] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_SQUOTE] = ACTIONS(2137),
    [anon_sym_class] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(2137),
    [anon_sym_function] = ACTIONS(2137),
    [anon_sym_new] = ACTIONS(2137),
    [anon_sym_using] = ACTIONS(2137),
    [anon_sym_PLUS] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(2137),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_TILDE] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2137),
    [anon_sym_delete] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2137),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [sym_number] = ACTIONS(2137),
    [sym_private_property_identifier] = ACTIONS(2137),
    [sym_this] = ACTIONS(2137),
    [sym_super] = ACTIONS(2137),
    [sym_true] = ACTIONS(2137),
    [sym_false] = ACTIONS(2137),
    [sym_null] = ACTIONS(2137),
    [sym_undefined] = ACTIONS(2137),
    [anon_sym_AT] = ACTIONS(2137),
    [anon_sym_static] = ACTIONS(2137),
    [anon_sym_readonly] = ACTIONS(2137),
    [anon_sym_get] = ACTIONS(2137),
    [anon_sym_set] = ACTIONS(2137),
    [anon_sym_declare] = ACTIONS(2137),
    [anon_sym_public] = ACTIONS(2137),
    [anon_sym_private] = ACTIONS(2137),
    [anon_sym_protected] = ACTIONS(2137),
    [anon_sym_override] = ACTIONS(2137),
    [anon_sym_module] = ACTIONS(2137),
    [anon_sym_any] = ACTIONS(2137),
    [anon_sym_number] = ACTIONS(2137),
    [anon_sym_boolean] = ACTIONS(2137),
    [anon_sym_string] = ACTIONS(2137),
    [anon_sym_symbol] = ACTIONS(2137),
    [anon_sym_object] = ACTIONS(2137),
    [anon_sym_abstract] = ACTIONS(2137),
    [anon_sym_interface] = ACTIONS(2137),
    [anon_sym_enum] = ACTIONS(2137),
    [sym__automatic_semicolon] = ACTIONS(2423),
    [sym_html_comment] = ACTIONS(5),
  },
  [1187] = {
    [sym_comment] = STATE(1187),
    [sym_identifier] = ACTIONS(3168),
    [anon_sym_export] = ACTIONS(3168),
    [anon_sym_default] = ACTIONS(3168),
    [anon_sym_type] = ACTIONS(3168),
    [anon_sym_namespace] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_typeof] = ACTIONS(3168),
    [anon_sym_import] = ACTIONS(3168),
    [anon_sym_with] = ACTIONS(3168),
    [anon_sym_var] = ACTIONS(3168),
    [anon_sym_let] = ACTIONS(3168),
    [anon_sym_const] = ACTIONS(3168),
    [anon_sym_BANG] = ACTIONS(3168),
    [anon_sym_if] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3168),
    [anon_sym_LPAREN] = ACTIONS(3168),
    [anon_sym_await] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3168),
    [anon_sym_do] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3168),
    [anon_sym_break] = ACTIONS(3168),
    [anon_sym_continue] = ACTIONS(3168),
    [anon_sym_debugger] = ACTIONS(3168),
    [anon_sym_return] = ACTIONS(3168),
    [anon_sym_throw] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_case] = ACTIONS(3168),
    [anon_sym_yield] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_LTtemplate_GT] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_class] = ACTIONS(3168),
    [anon_sym_async] = ACTIONS(3168),
    [anon_sym_function] = ACTIONS(3168),
    [anon_sym_new] = ACTIONS(3168),
    [anon_sym_using] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3168),
    [anon_sym_SLASH] = ACTIONS(3168),
    [anon_sym_LT] = ACTIONS(3168),
    [anon_sym_TILDE] = ACTIONS(3168),
    [anon_sym_void] = ACTIONS(3168),
    [anon_sym_delete] = ACTIONS(3168),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3168),
    [sym_number] = ACTIONS(3168),
    [sym_private_property_identifier] = ACTIONS(3168),
    [sym_this] = ACTIONS(3168),
    [sym_super] = ACTIONS(3168),
    [sym_true] = ACTIONS(3168),
    [sym_false] = ACTIONS(3168),
    [sym_null] = ACTIONS(3168),
    [sym_undefined] = ACTIONS(3168),
    [anon_sym_AT] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3168),
    [anon_sym_readonly] = ACTIONS(3168),
    [anon_sym_get] = ACTIONS(3168),
    [anon_sym_set] = ACTIONS(3168),
    [anon_sym_declare] = ACTIONS(3168),
    [anon_sym_public] = ACTIONS(3168),
    [anon_sym_private] = ACTIONS(3168),
    [anon_sym_protected] = ACTIONS(3168),
    [anon_sym_override] = ACTIONS(3168),
    [anon_sym_module] = ACTIONS(3168),
    [anon_sym_any] = ACTIONS(3168),
    [anon_sym_number] = ACTIONS(3168),
    [anon_sym_boolean] = ACTIONS(3168),
    [anon_sym_string] = ACTIONS(3168),
    [anon_sym_symbol] = ACTIONS(3168),
    [anon_sym_object] = ACTIONS(3168),
    [anon_sym_abstract] = ACTIONS(3168),
    [anon_sym_interface] = ACTIONS(3168),
    [anon_sym_enum] = ACTIONS(3168),
    [sym_html_comment] = ACTIONS(5),
  },
  [1188] = {
    [sym_comment] = STATE(1188),
    [ts_builtin_sym_end] = ACTIONS(3390),
    [sym_identifier] = ACTIONS(3226),
    [anon_sym_export] = ACTIONS(3226),
    [anon_sym_type] = ACTIONS(3226),
    [anon_sym_namespace] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [anon_sym_RBRACE] = ACTIONS(3226),
    [anon_sym_typeof] = ACTIONS(3226),
    [anon_sym_import] = ACTIONS(3226),
    [anon_sym_with] = ACTIONS(3226),
    [anon_sym_var] = ACTIONS(3226),
    [anon_sym_let] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_BANG] = ACTIONS(3226),
    [anon_sym_else] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3226),
    [anon_sym_await] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_try] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_debugger] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_throw] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym_yield] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [anon_sym_LTtemplate_GT] = ACTIONS(3226),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_SQUOTE] = ACTIONS(3226),
    [anon_sym_class] = ACTIONS(3226),
    [anon_sym_async] = ACTIONS(3226),
    [anon_sym_function] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_using] = ACTIONS(3226),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_SLASH] = ACTIONS(3226),
    [anon_sym_LT] = ACTIONS(3226),
    [anon_sym_TILDE] = ACTIONS(3226),
    [anon_sym_void] = ACTIONS(3226),
    [anon_sym_delete] = ACTIONS(3226),
    [anon_sym_PLUS_PLUS] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3226),
    [sym_number] = ACTIONS(3226),
    [sym_private_property_identifier] = ACTIONS(3226),
    [sym_this] = ACTIONS(3226),
    [sym_super] = ACTIONS(3226),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [sym_null] = ACTIONS(3226),
    [sym_undefined] = ACTIONS(3226),
    [anon_sym_AT] = ACTIONS(3226),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_readonly] = ACTIONS(3226),
    [anon_sym_get] = ACTIONS(3226),
    [anon_sym_set] = ACTIONS(3226),
    [anon_sym_declare] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3226),
    [anon_sym_private] = ACTIONS(3226),
    [anon_sym_protected] = ACTIONS(3226),
    [anon_sym_override] = ACTIONS(3226),
    [anon_sym_module] = ACTIONS(3226),
    [anon_sym_any] = ACTIONS(3226),
    [anon_sym_number] = ACTIONS(3226),
    [anon_sym_boolean] = ACTIONS(3226),
    [anon_sym_string] = ACTIONS(3226),
    [anon_sym_symbol] = ACTIONS(3226),
    [anon_sym_object] = ACTIONS(3226),
    [anon_sym_abstract] = ACTIONS(3226),
    [anon_sym_interface] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [sym_html_comment] = ACTIONS(5),
  },
  [1189] = {
    [sym_comment] = STATE(1189),
    [ts_builtin_sym_end] = ACTIONS(3392),
    [sym_identifier] = ACTIONS(3170),
    [anon_sym_export] = ACTIONS(3170),
    [anon_sym_type] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_typeof] = ACTIONS(3170),
    [anon_sym_import] = ACTIONS(3170),
    [anon_sym_with] = ACTIONS(3170),
    [anon_sym_var] = ACTIONS(3170),
    [anon_sym_let] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_else] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_await] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_debugger] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_yield] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_LTtemplate_GT] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_async] = ACTIONS(3170),
    [anon_sym_function] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_void] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [sym_number] = ACTIONS(3170),
    [sym_private_property_identifier] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
    [sym_super] = ACTIONS(3170),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [sym_null] = ACTIONS(3170),
    [sym_undefined] = ACTIONS(3170),
    [anon_sym_AT] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_readonly] = ACTIONS(3170),
    [anon_sym_get] = ACTIONS(3170),
    [anon_sym_set] = ACTIONS(3170),
    [anon_sym_declare] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_override] = ACTIONS(3170),
    [anon_sym_module] = ACTIONS(3170),
    [anon_sym_any] = ACTIONS(3170),
    [anon_sym_number] = ACTIONS(3170),
    [anon_sym_boolean] = ACTIONS(3170),
    [anon_sym_string] = ACTIONS(3170),
    [anon_sym_symbol] = ACTIONS(3170),
    [anon_sym_object] = ACTIONS(3170),
    [anon_sym_abstract] = ACTIONS(3170),
    [anon_sym_interface] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [sym_html_comment] = ACTIONS(5),
  },
  [1190] = {
    [sym_comment] = STATE(1190),
    [sym_identifier] = ACTIONS(3288),
    [anon_sym_export] = ACTIONS(3288),
    [anon_sym_default] = ACTIONS(3288),
    [anon_sym_type] = ACTIONS(3288),
    [anon_sym_namespace] = ACTIONS(3288),
    [anon_sym_LBRACE] = ACTIONS(3288),
    [anon_sym_RBRACE] = ACTIONS(3288),
    [anon_sym_typeof] = ACTIONS(3288),
    [anon_sym_import] = ACTIONS(3288),
    [anon_sym_with] = ACTIONS(3288),
    [anon_sym_var] = ACTIONS(3288),
    [anon_sym_let] = ACTIONS(3288),
    [anon_sym_const] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3288),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_switch] = ACTIONS(3288),
    [anon_sym_for] = ACTIONS(3288),
    [anon_sym_LPAREN] = ACTIONS(3288),
    [anon_sym_await] = ACTIONS(3288),
    [anon_sym_while] = ACTIONS(3288),
    [anon_sym_do] = ACTIONS(3288),
    [anon_sym_try] = ACTIONS(3288),
    [anon_sym_break] = ACTIONS(3288),
    [anon_sym_continue] = ACTIONS(3288),
    [anon_sym_debugger] = ACTIONS(3288),
    [anon_sym_return] = ACTIONS(3288),
    [anon_sym_throw] = ACTIONS(3288),
    [anon_sym_SEMI] = ACTIONS(3288),
    [anon_sym_case] = ACTIONS(3288),
    [anon_sym_yield] = ACTIONS(3288),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_LTtemplate_GT] = ACTIONS(3288),
    [anon_sym_DQUOTE] = ACTIONS(3288),
    [anon_sym_SQUOTE] = ACTIONS(3288),
    [anon_sym_class] = ACTIONS(3288),
    [anon_sym_async] = ACTIONS(3288),
    [anon_sym_function] = ACTIONS(3288),
    [anon_sym_new] = ACTIONS(3288),
    [anon_sym_using] = ACTIONS(3288),
    [anon_sym_PLUS] = ACTIONS(3288),
    [anon_sym_DASH] = ACTIONS(3288),
    [anon_sym_SLASH] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3288),
    [anon_sym_TILDE] = ACTIONS(3288),
    [anon_sym_void] = ACTIONS(3288),
    [anon_sym_delete] = ACTIONS(3288),
    [anon_sym_PLUS_PLUS] = ACTIONS(3288),
    [anon_sym_DASH_DASH] = ACTIONS(3288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3288),
    [sym_number] = ACTIONS(3288),
    [sym_private_property_identifier] = ACTIONS(3288),
    [sym_this] = ACTIONS(3288),
    [sym_super] = ACTIONS(3288),
    [sym_true] = ACTIONS(3288),
    [sym_false] = ACTIONS(3288),
    [sym_null] = ACTIONS(3288),
    [sym_undefined] = ACTIONS(3288),
    [anon_sym_AT] = ACTIONS(3288),
    [anon_sym_static] = ACTIONS(3288),
    [anon_sym_readonly] = ACTIONS(3288),
    [anon_sym_get] = ACTIONS(3288),
    [anon_sym_set] = ACTIONS(3288),
    [anon_sym_declare] = ACTIONS(3288),
    [anon_sym_public] = ACTIONS(3288),
    [anon_sym_private] = ACTIONS(3288),
    [anon_sym_protected] = ACTIONS(3288),
    [anon_sym_override] = ACTIONS(3288),
    [anon_sym_module] = ACTIONS(3288),
    [anon_sym_any] = ACTIONS(3288),
    [anon_sym_number] = ACTIONS(3288),
    [anon_sym_boolean] = ACTIONS(3288),
    [anon_sym_string] = ACTIONS(3288),
    [anon_sym_symbol] = ACTIONS(3288),
    [anon_sym_object] = ACTIONS(3288),
    [anon_sym_abstract] = ACTIONS(3288),
    [anon_sym_interface] = ACTIONS(3288),
    [anon_sym_enum] = ACTIONS(3288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1191] = {
    [sym_comment] = STATE(1191),
    [ts_builtin_sym_end] = ACTIONS(3394),
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_export] = ACTIONS(3172),
    [anon_sym_type] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_typeof] = ACTIONS(3172),
    [anon_sym_import] = ACTIONS(3172),
    [anon_sym_with] = ACTIONS(3172),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_else] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_LPAREN] = ACTIONS(3172),
    [anon_sym_await] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_debugger] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_yield] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_LTtemplate_GT] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_async] = ACTIONS(3172),
    [anon_sym_function] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_SLASH] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_void] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3172),
    [sym_number] = ACTIONS(3172),
    [sym_private_property_identifier] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
    [sym_super] = ACTIONS(3172),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [sym_null] = ACTIONS(3172),
    [sym_undefined] = ACTIONS(3172),
    [anon_sym_AT] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_readonly] = ACTIONS(3172),
    [anon_sym_get] = ACTIONS(3172),
    [anon_sym_set] = ACTIONS(3172),
    [anon_sym_declare] = ACTIONS(3172),
    [anon_sym_public] = ACTIONS(3172),
    [anon_sym_private] = ACTIONS(3172),
    [anon_sym_protected] = ACTIONS(3172),
    [anon_sym_override] = ACTIONS(3172),
    [anon_sym_module] = ACTIONS(3172),
    [anon_sym_any] = ACTIONS(3172),
    [anon_sym_number] = ACTIONS(3172),
    [anon_sym_boolean] = ACTIONS(3172),
    [anon_sym_string] = ACTIONS(3172),
    [anon_sym_symbol] = ACTIONS(3172),
    [anon_sym_object] = ACTIONS(3172),
    [anon_sym_abstract] = ACTIONS(3172),
    [anon_sym_interface] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [sym_html_comment] = ACTIONS(5),
  },
  [1192] = {
    [sym_comment] = STATE(1192),
    [sym_identifier] = ACTIONS(3160),
    [anon_sym_export] = ACTIONS(3160),
    [anon_sym_default] = ACTIONS(3160),
    [anon_sym_type] = ACTIONS(3160),
    [anon_sym_namespace] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_typeof] = ACTIONS(3160),
    [anon_sym_import] = ACTIONS(3160),
    [anon_sym_with] = ACTIONS(3160),
    [anon_sym_var] = ACTIONS(3160),
    [anon_sym_let] = ACTIONS(3160),
    [anon_sym_const] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_if] = ACTIONS(3160),
    [anon_sym_switch] = ACTIONS(3160),
    [anon_sym_for] = ACTIONS(3160),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_await] = ACTIONS(3160),
    [anon_sym_while] = ACTIONS(3160),
    [anon_sym_do] = ACTIONS(3160),
    [anon_sym_try] = ACTIONS(3160),
    [anon_sym_break] = ACTIONS(3160),
    [anon_sym_continue] = ACTIONS(3160),
    [anon_sym_debugger] = ACTIONS(3160),
    [anon_sym_return] = ACTIONS(3160),
    [anon_sym_throw] = ACTIONS(3160),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym_case] = ACTIONS(3160),
    [anon_sym_yield] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_LTtemplate_GT] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_class] = ACTIONS(3160),
    [anon_sym_async] = ACTIONS(3160),
    [anon_sym_function] = ACTIONS(3160),
    [anon_sym_new] = ACTIONS(3160),
    [anon_sym_using] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3160),
    [anon_sym_SLASH] = ACTIONS(3160),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_void] = ACTIONS(3160),
    [anon_sym_delete] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3160),
    [sym_number] = ACTIONS(3160),
    [sym_private_property_identifier] = ACTIONS(3160),
    [sym_this] = ACTIONS(3160),
    [sym_super] = ACTIONS(3160),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [sym_null] = ACTIONS(3160),
    [sym_undefined] = ACTIONS(3160),
    [anon_sym_AT] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_readonly] = ACTIONS(3160),
    [anon_sym_get] = ACTIONS(3160),
    [anon_sym_set] = ACTIONS(3160),
    [anon_sym_declare] = ACTIONS(3160),
    [anon_sym_public] = ACTIONS(3160),
    [anon_sym_private] = ACTIONS(3160),
    [anon_sym_protected] = ACTIONS(3160),
    [anon_sym_override] = ACTIONS(3160),
    [anon_sym_module] = ACTIONS(3160),
    [anon_sym_any] = ACTIONS(3160),
    [anon_sym_number] = ACTIONS(3160),
    [anon_sym_boolean] = ACTIONS(3160),
    [anon_sym_string] = ACTIONS(3160),
    [anon_sym_symbol] = ACTIONS(3160),
    [anon_sym_object] = ACTIONS(3160),
    [anon_sym_abstract] = ACTIONS(3160),
    [anon_sym_interface] = ACTIONS(3160),
    [anon_sym_enum] = ACTIONS(3160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1193] = {
    [sym_comment] = STATE(1193),
    [sym_identifier] = ACTIONS(3290),
    [anon_sym_export] = ACTIONS(3290),
    [anon_sym_default] = ACTIONS(3290),
    [anon_sym_type] = ACTIONS(3290),
    [anon_sym_namespace] = ACTIONS(3290),
    [anon_sym_LBRACE] = ACTIONS(3290),
    [anon_sym_RBRACE] = ACTIONS(3290),
    [anon_sym_typeof] = ACTIONS(3290),
    [anon_sym_import] = ACTIONS(3290),
    [anon_sym_with] = ACTIONS(3290),
    [anon_sym_var] = ACTIONS(3290),
    [anon_sym_let] = ACTIONS(3290),
    [anon_sym_const] = ACTIONS(3290),
    [anon_sym_BANG] = ACTIONS(3290),
    [anon_sym_if] = ACTIONS(3290),
    [anon_sym_switch] = ACTIONS(3290),
    [anon_sym_for] = ACTIONS(3290),
    [anon_sym_LPAREN] = ACTIONS(3290),
    [anon_sym_await] = ACTIONS(3290),
    [anon_sym_while] = ACTIONS(3290),
    [anon_sym_do] = ACTIONS(3290),
    [anon_sym_try] = ACTIONS(3290),
    [anon_sym_break] = ACTIONS(3290),
    [anon_sym_continue] = ACTIONS(3290),
    [anon_sym_debugger] = ACTIONS(3290),
    [anon_sym_return] = ACTIONS(3290),
    [anon_sym_throw] = ACTIONS(3290),
    [anon_sym_SEMI] = ACTIONS(3290),
    [anon_sym_case] = ACTIONS(3290),
    [anon_sym_yield] = ACTIONS(3290),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_LTtemplate_GT] = ACTIONS(3290),
    [anon_sym_DQUOTE] = ACTIONS(3290),
    [anon_sym_SQUOTE] = ACTIONS(3290),
    [anon_sym_class] = ACTIONS(3290),
    [anon_sym_async] = ACTIONS(3290),
    [anon_sym_function] = ACTIONS(3290),
    [anon_sym_new] = ACTIONS(3290),
    [anon_sym_using] = ACTIONS(3290),
    [anon_sym_PLUS] = ACTIONS(3290),
    [anon_sym_DASH] = ACTIONS(3290),
    [anon_sym_SLASH] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3290),
    [anon_sym_TILDE] = ACTIONS(3290),
    [anon_sym_void] = ACTIONS(3290),
    [anon_sym_delete] = ACTIONS(3290),
    [anon_sym_PLUS_PLUS] = ACTIONS(3290),
    [anon_sym_DASH_DASH] = ACTIONS(3290),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3290),
    [sym_number] = ACTIONS(3290),
    [sym_private_property_identifier] = ACTIONS(3290),
    [sym_this] = ACTIONS(3290),
    [sym_super] = ACTIONS(3290),
    [sym_true] = ACTIONS(3290),
    [sym_false] = ACTIONS(3290),
    [sym_null] = ACTIONS(3290),
    [sym_undefined] = ACTIONS(3290),
    [anon_sym_AT] = ACTIONS(3290),
    [anon_sym_static] = ACTIONS(3290),
    [anon_sym_readonly] = ACTIONS(3290),
    [anon_sym_get] = ACTIONS(3290),
    [anon_sym_set] = ACTIONS(3290),
    [anon_sym_declare] = ACTIONS(3290),
    [anon_sym_public] = ACTIONS(3290),
    [anon_sym_private] = ACTIONS(3290),
    [anon_sym_protected] = ACTIONS(3290),
    [anon_sym_override] = ACTIONS(3290),
    [anon_sym_module] = ACTIONS(3290),
    [anon_sym_any] = ACTIONS(3290),
    [anon_sym_number] = ACTIONS(3290),
    [anon_sym_boolean] = ACTIONS(3290),
    [anon_sym_string] = ACTIONS(3290),
    [anon_sym_symbol] = ACTIONS(3290),
    [anon_sym_object] = ACTIONS(3290),
    [anon_sym_abstract] = ACTIONS(3290),
    [anon_sym_interface] = ACTIONS(3290),
    [anon_sym_enum] = ACTIONS(3290),
    [sym_html_comment] = ACTIONS(5),
  },
  [1194] = {
    [sym_comment] = STATE(1194),
    [ts_builtin_sym_end] = ACTIONS(3394),
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_export] = ACTIONS(3172),
    [anon_sym_type] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_typeof] = ACTIONS(3172),
    [anon_sym_import] = ACTIONS(3172),
    [anon_sym_with] = ACTIONS(3172),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_else] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_LPAREN] = ACTIONS(3172),
    [anon_sym_await] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_debugger] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_yield] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_LTtemplate_GT] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_async] = ACTIONS(3172),
    [anon_sym_function] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_SLASH] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_void] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3172),
    [sym_number] = ACTIONS(3172),
    [sym_private_property_identifier] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
    [sym_super] = ACTIONS(3172),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [sym_null] = ACTIONS(3172),
    [sym_undefined] = ACTIONS(3172),
    [anon_sym_AT] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_readonly] = ACTIONS(3172),
    [anon_sym_get] = ACTIONS(3172),
    [anon_sym_set] = ACTIONS(3172),
    [anon_sym_declare] = ACTIONS(3172),
    [anon_sym_public] = ACTIONS(3172),
    [anon_sym_private] = ACTIONS(3172),
    [anon_sym_protected] = ACTIONS(3172),
    [anon_sym_override] = ACTIONS(3172),
    [anon_sym_module] = ACTIONS(3172),
    [anon_sym_any] = ACTIONS(3172),
    [anon_sym_number] = ACTIONS(3172),
    [anon_sym_boolean] = ACTIONS(3172),
    [anon_sym_string] = ACTIONS(3172),
    [anon_sym_symbol] = ACTIONS(3172),
    [anon_sym_object] = ACTIONS(3172),
    [anon_sym_abstract] = ACTIONS(3172),
    [anon_sym_interface] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [sym_html_comment] = ACTIONS(5),
  },
  [1195] = {
    [sym_comment] = STATE(1195),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(2115),
    [sym_html_comment] = ACTIONS(5),
  },
  [1196] = {
    [sym_comment] = STATE(1196),
    [sym_identifier] = ACTIONS(3158),
    [anon_sym_export] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_type] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_typeof] = ACTIONS(3158),
    [anon_sym_import] = ACTIONS(3158),
    [anon_sym_with] = ACTIONS(3158),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_LPAREN] = ACTIONS(3158),
    [anon_sym_await] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_debugger] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_yield] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_LTtemplate_GT] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_async] = ACTIONS(3158),
    [anon_sym_function] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_SLASH] = ACTIONS(3158),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [anon_sym_void] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3158),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3158),
    [sym_number] = ACTIONS(3158),
    [sym_private_property_identifier] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
    [sym_super] = ACTIONS(3158),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [sym_null] = ACTIONS(3158),
    [sym_undefined] = ACTIONS(3158),
    [anon_sym_AT] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_readonly] = ACTIONS(3158),
    [anon_sym_get] = ACTIONS(3158),
    [anon_sym_set] = ACTIONS(3158),
    [anon_sym_declare] = ACTIONS(3158),
    [anon_sym_public] = ACTIONS(3158),
    [anon_sym_private] = ACTIONS(3158),
    [anon_sym_protected] = ACTIONS(3158),
    [anon_sym_override] = ACTIONS(3158),
    [anon_sym_module] = ACTIONS(3158),
    [anon_sym_any] = ACTIONS(3158),
    [anon_sym_number] = ACTIONS(3158),
    [anon_sym_boolean] = ACTIONS(3158),
    [anon_sym_string] = ACTIONS(3158),
    [anon_sym_symbol] = ACTIONS(3158),
    [anon_sym_object] = ACTIONS(3158),
    [anon_sym_abstract] = ACTIONS(3158),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [sym_html_comment] = ACTIONS(5),
  },
  [1197] = {
    [sym_comment] = STATE(1197),
    [sym_identifier] = ACTIONS(3306),
    [anon_sym_export] = ACTIONS(3306),
    [anon_sym_default] = ACTIONS(3306),
    [anon_sym_type] = ACTIONS(3306),
    [anon_sym_namespace] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3306),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_typeof] = ACTIONS(3306),
    [anon_sym_import] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3306),
    [anon_sym_var] = ACTIONS(3306),
    [anon_sym_let] = ACTIONS(3306),
    [anon_sym_const] = ACTIONS(3306),
    [anon_sym_BANG] = ACTIONS(3306),
    [anon_sym_if] = ACTIONS(3306),
    [anon_sym_switch] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3306),
    [anon_sym_await] = ACTIONS(3306),
    [anon_sym_while] = ACTIONS(3306),
    [anon_sym_do] = ACTIONS(3306),
    [anon_sym_try] = ACTIONS(3306),
    [anon_sym_break] = ACTIONS(3306),
    [anon_sym_continue] = ACTIONS(3306),
    [anon_sym_debugger] = ACTIONS(3306),
    [anon_sym_return] = ACTIONS(3306),
    [anon_sym_throw] = ACTIONS(3306),
    [anon_sym_SEMI] = ACTIONS(3306),
    [anon_sym_case] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3306),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_LTtemplate_GT] = ACTIONS(3306),
    [anon_sym_DQUOTE] = ACTIONS(3306),
    [anon_sym_SQUOTE] = ACTIONS(3306),
    [anon_sym_class] = ACTIONS(3306),
    [anon_sym_async] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3306),
    [anon_sym_using] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_DASH] = ACTIONS(3306),
    [anon_sym_SLASH] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [anon_sym_void] = ACTIONS(3306),
    [anon_sym_delete] = ACTIONS(3306),
    [anon_sym_PLUS_PLUS] = ACTIONS(3306),
    [anon_sym_DASH_DASH] = ACTIONS(3306),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3306),
    [sym_number] = ACTIONS(3306),
    [sym_private_property_identifier] = ACTIONS(3306),
    [sym_this] = ACTIONS(3306),
    [sym_super] = ACTIONS(3306),
    [sym_true] = ACTIONS(3306),
    [sym_false] = ACTIONS(3306),
    [sym_null] = ACTIONS(3306),
    [sym_undefined] = ACTIONS(3306),
    [anon_sym_AT] = ACTIONS(3306),
    [anon_sym_static] = ACTIONS(3306),
    [anon_sym_readonly] = ACTIONS(3306),
    [anon_sym_get] = ACTIONS(3306),
    [anon_sym_set] = ACTIONS(3306),
    [anon_sym_declare] = ACTIONS(3306),
    [anon_sym_public] = ACTIONS(3306),
    [anon_sym_private] = ACTIONS(3306),
    [anon_sym_protected] = ACTIONS(3306),
    [anon_sym_override] = ACTIONS(3306),
    [anon_sym_module] = ACTIONS(3306),
    [anon_sym_any] = ACTIONS(3306),
    [anon_sym_number] = ACTIONS(3306),
    [anon_sym_boolean] = ACTIONS(3306),
    [anon_sym_string] = ACTIONS(3306),
    [anon_sym_symbol] = ACTIONS(3306),
    [anon_sym_object] = ACTIONS(3306),
    [anon_sym_abstract] = ACTIONS(3306),
    [anon_sym_interface] = ACTIONS(3306),
    [anon_sym_enum] = ACTIONS(3306),
    [sym_html_comment] = ACTIONS(5),
  },
  [1198] = {
    [sym_comment] = STATE(1198),
    [ts_builtin_sym_end] = ACTIONS(3396),
    [sym_identifier] = ACTIONS(3174),
    [anon_sym_export] = ACTIONS(3174),
    [anon_sym_type] = ACTIONS(3174),
    [anon_sym_namespace] = ACTIONS(3174),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(3174),
    [anon_sym_typeof] = ACTIONS(3174),
    [anon_sym_import] = ACTIONS(3174),
    [anon_sym_with] = ACTIONS(3174),
    [anon_sym_var] = ACTIONS(3174),
    [anon_sym_let] = ACTIONS(3174),
    [anon_sym_const] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_else] = ACTIONS(3174),
    [anon_sym_if] = ACTIONS(3174),
    [anon_sym_switch] = ACTIONS(3174),
    [anon_sym_for] = ACTIONS(3174),
    [anon_sym_LPAREN] = ACTIONS(3174),
    [anon_sym_await] = ACTIONS(3174),
    [anon_sym_while] = ACTIONS(3174),
    [anon_sym_do] = ACTIONS(3174),
    [anon_sym_try] = ACTIONS(3174),
    [anon_sym_break] = ACTIONS(3174),
    [anon_sym_continue] = ACTIONS(3174),
    [anon_sym_debugger] = ACTIONS(3174),
    [anon_sym_return] = ACTIONS(3174),
    [anon_sym_throw] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym_yield] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(3174),
    [anon_sym_LTtemplate_GT] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_class] = ACTIONS(3174),
    [anon_sym_async] = ACTIONS(3174),
    [anon_sym_function] = ACTIONS(3174),
    [anon_sym_new] = ACTIONS(3174),
    [anon_sym_using] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_SLASH] = ACTIONS(3174),
    [anon_sym_LT] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_void] = ACTIONS(3174),
    [anon_sym_delete] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3174),
    [sym_number] = ACTIONS(3174),
    [sym_private_property_identifier] = ACTIONS(3174),
    [sym_this] = ACTIONS(3174),
    [sym_super] = ACTIONS(3174),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [sym_null] = ACTIONS(3174),
    [sym_undefined] = ACTIONS(3174),
    [anon_sym_AT] = ACTIONS(3174),
    [anon_sym_static] = ACTIONS(3174),
    [anon_sym_readonly] = ACTIONS(3174),
    [anon_sym_get] = ACTIONS(3174),
    [anon_sym_set] = ACTIONS(3174),
    [anon_sym_declare] = ACTIONS(3174),
    [anon_sym_public] = ACTIONS(3174),
    [anon_sym_private] = ACTIONS(3174),
    [anon_sym_protected] = ACTIONS(3174),
    [anon_sym_override] = ACTIONS(3174),
    [anon_sym_module] = ACTIONS(3174),
    [anon_sym_any] = ACTIONS(3174),
    [anon_sym_number] = ACTIONS(3174),
    [anon_sym_boolean] = ACTIONS(3174),
    [anon_sym_string] = ACTIONS(3174),
    [anon_sym_symbol] = ACTIONS(3174),
    [anon_sym_object] = ACTIONS(3174),
    [anon_sym_abstract] = ACTIONS(3174),
    [anon_sym_interface] = ACTIONS(3174),
    [anon_sym_enum] = ACTIONS(3174),
    [sym_html_comment] = ACTIONS(5),
  },
  [1199] = {
    [sym_comment] = STATE(1199),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_export] = ACTIONS(2183),
    [anon_sym_default] = ACTIONS(2183),
    [anon_sym_type] = ACTIONS(2183),
    [anon_sym_namespace] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_typeof] = ACTIONS(2183),
    [anon_sym_import] = ACTIONS(2183),
    [anon_sym_with] = ACTIONS(2183),
    [anon_sym_var] = ACTIONS(2183),
    [anon_sym_let] = ACTIONS(2183),
    [anon_sym_const] = ACTIONS(2183),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2183),
    [anon_sym_for] = ACTIONS(2183),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(2183),
    [anon_sym_do] = ACTIONS(2183),
    [anon_sym_try] = ACTIONS(2183),
    [anon_sym_break] = ACTIONS(2183),
    [anon_sym_continue] = ACTIONS(2183),
    [anon_sym_debugger] = ACTIONS(2183),
    [anon_sym_return] = ACTIONS(2183),
    [anon_sym_throw] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_case] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2183),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [anon_sym_class] = ACTIONS(2183),
    [anon_sym_async] = ACTIONS(2183),
    [anon_sym_function] = ACTIONS(2183),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_using] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2183),
    [anon_sym_delete] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2183),
    [sym_private_property_identifier] = ACTIONS(2183),
    [sym_this] = ACTIONS(2183),
    [sym_super] = ACTIONS(2183),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_undefined] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2183),
    [anon_sym_readonly] = ACTIONS(2183),
    [anon_sym_get] = ACTIONS(2183),
    [anon_sym_set] = ACTIONS(2183),
    [anon_sym_declare] = ACTIONS(2183),
    [anon_sym_public] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2183),
    [anon_sym_protected] = ACTIONS(2183),
    [anon_sym_override] = ACTIONS(2183),
    [anon_sym_module] = ACTIONS(2183),
    [anon_sym_any] = ACTIONS(2183),
    [anon_sym_number] = ACTIONS(2183),
    [anon_sym_boolean] = ACTIONS(2183),
    [anon_sym_string] = ACTIONS(2183),
    [anon_sym_symbol] = ACTIONS(2183),
    [anon_sym_object] = ACTIONS(2183),
    [anon_sym_abstract] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2183),
    [anon_sym_enum] = ACTIONS(2183),
    [sym_html_comment] = ACTIONS(5),
  },
  [1200] = {
    [sym_comment] = STATE(1200),
    [ts_builtin_sym_end] = ACTIONS(3398),
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_export] = ACTIONS(3128),
    [anon_sym_type] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_RBRACE] = ACTIONS(3128),
    [anon_sym_typeof] = ACTIONS(3128),
    [anon_sym_import] = ACTIONS(3128),
    [anon_sym_with] = ACTIONS(3128),
    [anon_sym_var] = ACTIONS(3128),
    [anon_sym_let] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_else] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(3128),
    [anon_sym_await] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_debugger] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3128),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_LTtemplate_GT] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_async] = ACTIONS(3128),
    [anon_sym_function] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_SLASH] = ACTIONS(3128),
    [anon_sym_LT] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_void] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3128),
    [sym_number] = ACTIONS(3128),
    [sym_private_property_identifier] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
    [sym_super] = ACTIONS(3128),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [sym_null] = ACTIONS(3128),
    [sym_undefined] = ACTIONS(3128),
    [anon_sym_AT] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_readonly] = ACTIONS(3128),
    [anon_sym_get] = ACTIONS(3128),
    [anon_sym_set] = ACTIONS(3128),
    [anon_sym_declare] = ACTIONS(3128),
    [anon_sym_public] = ACTIONS(3128),
    [anon_sym_private] = ACTIONS(3128),
    [anon_sym_protected] = ACTIONS(3128),
    [anon_sym_override] = ACTIONS(3128),
    [anon_sym_module] = ACTIONS(3128),
    [anon_sym_any] = ACTIONS(3128),
    [anon_sym_number] = ACTIONS(3128),
    [anon_sym_boolean] = ACTIONS(3128),
    [anon_sym_string] = ACTIONS(3128),
    [anon_sym_symbol] = ACTIONS(3128),
    [anon_sym_object] = ACTIONS(3128),
    [anon_sym_abstract] = ACTIONS(3128),
    [anon_sym_interface] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [sym_html_comment] = ACTIONS(5),
  },
  [1201] = {
    [sym_comment] = STATE(1201),
    [ts_builtin_sym_end] = ACTIONS(3400),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_else] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LTtemplate_GT] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_using] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [sym_number] = ACTIONS(3356),
    [sym_private_property_identifier] = ACTIONS(3356),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3356),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_object] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [sym_html_comment] = ACTIONS(5),
  },
  [1202] = {
    [sym_comment] = STATE(1202),
    [ts_builtin_sym_end] = ACTIONS(3402),
    [sym_identifier] = ACTIONS(3136),
    [anon_sym_export] = ACTIONS(3136),
    [anon_sym_type] = ACTIONS(3136),
    [anon_sym_namespace] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_RBRACE] = ACTIONS(3136),
    [anon_sym_typeof] = ACTIONS(3136),
    [anon_sym_import] = ACTIONS(3136),
    [anon_sym_with] = ACTIONS(3136),
    [anon_sym_var] = ACTIONS(3136),
    [anon_sym_let] = ACTIONS(3136),
    [anon_sym_const] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_else] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_switch] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_LPAREN] = ACTIONS(3136),
    [anon_sym_await] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_do] = ACTIONS(3136),
    [anon_sym_try] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_continue] = ACTIONS(3136),
    [anon_sym_debugger] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_throw] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym_yield] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3136),
    [anon_sym_LTtemplate_GT] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(3136),
    [anon_sym_SQUOTE] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_async] = ACTIONS(3136),
    [anon_sym_function] = ACTIONS(3136),
    [anon_sym_new] = ACTIONS(3136),
    [anon_sym_using] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3136),
    [anon_sym_SLASH] = ACTIONS(3136),
    [anon_sym_LT] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_void] = ACTIONS(3136),
    [anon_sym_delete] = ACTIONS(3136),
    [anon_sym_PLUS_PLUS] = ACTIONS(3136),
    [anon_sym_DASH_DASH] = ACTIONS(3136),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3136),
    [sym_number] = ACTIONS(3136),
    [sym_private_property_identifier] = ACTIONS(3136),
    [sym_this] = ACTIONS(3136),
    [sym_super] = ACTIONS(3136),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [sym_null] = ACTIONS(3136),
    [sym_undefined] = ACTIONS(3136),
    [anon_sym_AT] = ACTIONS(3136),
    [anon_sym_static] = ACTIONS(3136),
    [anon_sym_readonly] = ACTIONS(3136),
    [anon_sym_get] = ACTIONS(3136),
    [anon_sym_set] = ACTIONS(3136),
    [anon_sym_declare] = ACTIONS(3136),
    [anon_sym_public] = ACTIONS(3136),
    [anon_sym_private] = ACTIONS(3136),
    [anon_sym_protected] = ACTIONS(3136),
    [anon_sym_override] = ACTIONS(3136),
    [anon_sym_module] = ACTIONS(3136),
    [anon_sym_any] = ACTIONS(3136),
    [anon_sym_number] = ACTIONS(3136),
    [anon_sym_boolean] = ACTIONS(3136),
    [anon_sym_string] = ACTIONS(3136),
    [anon_sym_symbol] = ACTIONS(3136),
    [anon_sym_object] = ACTIONS(3136),
    [anon_sym_abstract] = ACTIONS(3136),
    [anon_sym_interface] = ACTIONS(3136),
    [anon_sym_enum] = ACTIONS(3136),
    [sym_html_comment] = ACTIONS(5),
  },
  [1203] = {
    [sym_comment] = STATE(1203),
    [ts_builtin_sym_end] = ACTIONS(3400),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_else] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LTtemplate_GT] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_using] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [sym_number] = ACTIONS(3356),
    [sym_private_property_identifier] = ACTIONS(3356),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3356),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_object] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [sym_html_comment] = ACTIONS(5),
  },
  [1204] = {
    [sym_comment] = STATE(1204),
    [ts_builtin_sym_end] = ACTIONS(3242),
    [sym_identifier] = ACTIONS(3074),
    [anon_sym_export] = ACTIONS(3074),
    [anon_sym_type] = ACTIONS(3074),
    [anon_sym_namespace] = ACTIONS(3074),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_typeof] = ACTIONS(3074),
    [anon_sym_import] = ACTIONS(3074),
    [anon_sym_with] = ACTIONS(3074),
    [anon_sym_var] = ACTIONS(3074),
    [anon_sym_let] = ACTIONS(3074),
    [anon_sym_const] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_if] = ACTIONS(3074),
    [anon_sym_switch] = ACTIONS(3074),
    [anon_sym_for] = ACTIONS(3074),
    [anon_sym_LPAREN] = ACTIONS(3074),
    [anon_sym_await] = ACTIONS(3074),
    [anon_sym_while] = ACTIONS(3074),
    [anon_sym_do] = ACTIONS(3074),
    [anon_sym_try] = ACTIONS(3074),
    [anon_sym_break] = ACTIONS(3074),
    [anon_sym_continue] = ACTIONS(3074),
    [anon_sym_debugger] = ACTIONS(3074),
    [anon_sym_return] = ACTIONS(3074),
    [anon_sym_throw] = ACTIONS(3074),
    [anon_sym_SEMI] = ACTIONS(3404),
    [anon_sym_yield] = ACTIONS(3074),
    [anon_sym_LBRACK] = ACTIONS(3074),
    [anon_sym_LTtemplate_GT] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_class] = ACTIONS(3074),
    [anon_sym_async] = ACTIONS(3074),
    [anon_sym_function] = ACTIONS(3074),
    [anon_sym_new] = ACTIONS(3074),
    [anon_sym_using] = ACTIONS(3074),
    [anon_sym_PLUS] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3074),
    [anon_sym_SLASH] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_void] = ACTIONS(3074),
    [anon_sym_delete] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3074),
    [sym_number] = ACTIONS(3074),
    [sym_private_property_identifier] = ACTIONS(3074),
    [sym_this] = ACTIONS(3074),
    [sym_super] = ACTIONS(3074),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [sym_null] = ACTIONS(3074),
    [sym_undefined] = ACTIONS(3074),
    [anon_sym_AT] = ACTIONS(3074),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_readonly] = ACTIONS(3074),
    [anon_sym_get] = ACTIONS(3074),
    [anon_sym_set] = ACTIONS(3074),
    [anon_sym_declare] = ACTIONS(3074),
    [anon_sym_public] = ACTIONS(3074),
    [anon_sym_private] = ACTIONS(3074),
    [anon_sym_protected] = ACTIONS(3074),
    [anon_sym_override] = ACTIONS(3074),
    [anon_sym_module] = ACTIONS(3074),
    [anon_sym_any] = ACTIONS(3074),
    [anon_sym_number] = ACTIONS(3074),
    [anon_sym_boolean] = ACTIONS(3074),
    [anon_sym_string] = ACTIONS(3074),
    [anon_sym_symbol] = ACTIONS(3074),
    [anon_sym_object] = ACTIONS(3074),
    [anon_sym_abstract] = ACTIONS(3074),
    [anon_sym_interface] = ACTIONS(3074),
    [anon_sym_enum] = ACTIONS(3074),
    [sym__automatic_semicolon] = ACTIONS(3406),
    [sym_html_comment] = ACTIONS(5),
  },
  [1205] = {
    [sym_comment] = STATE(1205),
    [ts_builtin_sym_end] = ACTIONS(3248),
    [sym_identifier] = ACTIONS(3102),
    [anon_sym_export] = ACTIONS(3102),
    [anon_sym_type] = ACTIONS(3102),
    [anon_sym_namespace] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_typeof] = ACTIONS(3102),
    [anon_sym_import] = ACTIONS(3102),
    [anon_sym_with] = ACTIONS(3102),
    [anon_sym_var] = ACTIONS(3102),
    [anon_sym_let] = ACTIONS(3102),
    [anon_sym_const] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3102),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_await] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3102),
    [anon_sym_break] = ACTIONS(3102),
    [anon_sym_continue] = ACTIONS(3102),
    [anon_sym_debugger] = ACTIONS(3102),
    [anon_sym_return] = ACTIONS(3102),
    [anon_sym_throw] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_finally] = ACTIONS(3102),
    [anon_sym_yield] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_LTtemplate_GT] = ACTIONS(3102),
    [anon_sym_DQUOTE] = ACTIONS(3102),
    [anon_sym_SQUOTE] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(3102),
    [anon_sym_async] = ACTIONS(3102),
    [anon_sym_function] = ACTIONS(3102),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_using] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_SLASH] = ACTIONS(3102),
    [anon_sym_LT] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_void] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3102),
    [sym_number] = ACTIONS(3102),
    [sym_private_property_identifier] = ACTIONS(3102),
    [sym_this] = ACTIONS(3102),
    [sym_super] = ACTIONS(3102),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [sym_null] = ACTIONS(3102),
    [sym_undefined] = ACTIONS(3102),
    [anon_sym_AT] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_readonly] = ACTIONS(3102),
    [anon_sym_get] = ACTIONS(3102),
    [anon_sym_set] = ACTIONS(3102),
    [anon_sym_declare] = ACTIONS(3102),
    [anon_sym_public] = ACTIONS(3102),
    [anon_sym_private] = ACTIONS(3102),
    [anon_sym_protected] = ACTIONS(3102),
    [anon_sym_override] = ACTIONS(3102),
    [anon_sym_module] = ACTIONS(3102),
    [anon_sym_any] = ACTIONS(3102),
    [anon_sym_number] = ACTIONS(3102),
    [anon_sym_boolean] = ACTIONS(3102),
    [anon_sym_string] = ACTIONS(3102),
    [anon_sym_symbol] = ACTIONS(3102),
    [anon_sym_object] = ACTIONS(3102),
    [anon_sym_abstract] = ACTIONS(3102),
    [anon_sym_interface] = ACTIONS(3102),
    [anon_sym_enum] = ACTIONS(3102),
    [sym_html_comment] = ACTIONS(5),
  },
  [1206] = {
    [sym_comment] = STATE(1206),
    [ts_builtin_sym_end] = ACTIONS(2127),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_else] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym_html_comment] = ACTIONS(5),
  },
  [1207] = {
    [sym_comment] = STATE(1207),
    [sym_identifier] = ACTIONS(3156),
    [anon_sym_export] = ACTIONS(3156),
    [anon_sym_default] = ACTIONS(3156),
    [anon_sym_type] = ACTIONS(3156),
    [anon_sym_namespace] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_typeof] = ACTIONS(3156),
    [anon_sym_import] = ACTIONS(3156),
    [anon_sym_with] = ACTIONS(3156),
    [anon_sym_var] = ACTIONS(3156),
    [anon_sym_let] = ACTIONS(3156),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_switch] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3156),
    [anon_sym_await] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_do] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_debugger] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_throw] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym_case] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_LTtemplate_GT] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_async] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_using] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_SLASH] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_void] = ACTIONS(3156),
    [anon_sym_delete] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [sym_number] = ACTIONS(3156),
    [sym_private_property_identifier] = ACTIONS(3156),
    [sym_this] = ACTIONS(3156),
    [sym_super] = ACTIONS(3156),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [sym_null] = ACTIONS(3156),
    [sym_undefined] = ACTIONS(3156),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_readonly] = ACTIONS(3156),
    [anon_sym_get] = ACTIONS(3156),
    [anon_sym_set] = ACTIONS(3156),
    [anon_sym_declare] = ACTIONS(3156),
    [anon_sym_public] = ACTIONS(3156),
    [anon_sym_private] = ACTIONS(3156),
    [anon_sym_protected] = ACTIONS(3156),
    [anon_sym_override] = ACTIONS(3156),
    [anon_sym_module] = ACTIONS(3156),
    [anon_sym_any] = ACTIONS(3156),
    [anon_sym_number] = ACTIONS(3156),
    [anon_sym_boolean] = ACTIONS(3156),
    [anon_sym_string] = ACTIONS(3156),
    [anon_sym_symbol] = ACTIONS(3156),
    [anon_sym_object] = ACTIONS(3156),
    [anon_sym_abstract] = ACTIONS(3156),
    [anon_sym_interface] = ACTIONS(3156),
    [anon_sym_enum] = ACTIONS(3156),
    [sym_html_comment] = ACTIONS(5),
  },
  [1208] = {
    [sym_comment] = STATE(1208),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym_html_comment] = ACTIONS(5),
  },
  [1209] = {
    [sym_comment] = STATE(1209),
    [ts_builtin_sym_end] = ACTIONS(3408),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_export] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_namespace] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_typeof] = ACTIONS(3274),
    [anon_sym_import] = ACTIONS(3274),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_var] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_const] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_else] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_switch] = ACTIONS(3274),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_await] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_break] = ACTIONS(3274),
    [anon_sym_continue] = ACTIONS(3274),
    [anon_sym_debugger] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_throw] = ACTIONS(3274),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LTtemplate_GT] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_SQUOTE] = ACTIONS(3274),
    [anon_sym_class] = ACTIONS(3274),
    [anon_sym_async] = ACTIONS(3274),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_using] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_SLASH] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_void] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3274),
    [sym_number] = ACTIONS(3274),
    [sym_private_property_identifier] = ACTIONS(3274),
    [sym_this] = ACTIONS(3274),
    [sym_super] = ACTIONS(3274),
    [sym_true] = ACTIONS(3274),
    [sym_false] = ACTIONS(3274),
    [sym_null] = ACTIONS(3274),
    [sym_undefined] = ACTIONS(3274),
    [anon_sym_AT] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3274),
    [anon_sym_readonly] = ACTIONS(3274),
    [anon_sym_get] = ACTIONS(3274),
    [anon_sym_set] = ACTIONS(3274),
    [anon_sym_declare] = ACTIONS(3274),
    [anon_sym_public] = ACTIONS(3274),
    [anon_sym_private] = ACTIONS(3274),
    [anon_sym_protected] = ACTIONS(3274),
    [anon_sym_override] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_any] = ACTIONS(3274),
    [anon_sym_number] = ACTIONS(3274),
    [anon_sym_boolean] = ACTIONS(3274),
    [anon_sym_string] = ACTIONS(3274),
    [anon_sym_symbol] = ACTIONS(3274),
    [anon_sym_object] = ACTIONS(3274),
    [anon_sym_abstract] = ACTIONS(3274),
    [anon_sym_interface] = ACTIONS(3274),
    [anon_sym_enum] = ACTIONS(3274),
    [sym_html_comment] = ACTIONS(5),
  },
  [1210] = {
    [sym_comment] = STATE(1210),
    [ts_builtin_sym_end] = ACTIONS(2147),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym_html_comment] = ACTIONS(5),
  },
  [1211] = {
    [sym_comment] = STATE(1211),
    [sym_identifier] = ACTIONS(3178),
    [anon_sym_export] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_type] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_RBRACE] = ACTIONS(3178),
    [anon_sym_typeof] = ACTIONS(3178),
    [anon_sym_import] = ACTIONS(3178),
    [anon_sym_with] = ACTIONS(3178),
    [anon_sym_var] = ACTIONS(3178),
    [anon_sym_let] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_BANG] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_LPAREN] = ACTIONS(3178),
    [anon_sym_await] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_debugger] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_yield] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_LTtemplate_GT] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_SQUOTE] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_async] = ACTIONS(3178),
    [anon_sym_function] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_SLASH] = ACTIONS(3178),
    [anon_sym_LT] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3178),
    [anon_sym_void] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_PLUS_PLUS] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [sym_number] = ACTIONS(3178),
    [sym_private_property_identifier] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
    [sym_super] = ACTIONS(3178),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [sym_null] = ACTIONS(3178),
    [sym_undefined] = ACTIONS(3178),
    [anon_sym_AT] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_readonly] = ACTIONS(3178),
    [anon_sym_get] = ACTIONS(3178),
    [anon_sym_set] = ACTIONS(3178),
    [anon_sym_declare] = ACTIONS(3178),
    [anon_sym_public] = ACTIONS(3178),
    [anon_sym_private] = ACTIONS(3178),
    [anon_sym_protected] = ACTIONS(3178),
    [anon_sym_override] = ACTIONS(3178),
    [anon_sym_module] = ACTIONS(3178),
    [anon_sym_any] = ACTIONS(3178),
    [anon_sym_number] = ACTIONS(3178),
    [anon_sym_boolean] = ACTIONS(3178),
    [anon_sym_string] = ACTIONS(3178),
    [anon_sym_symbol] = ACTIONS(3178),
    [anon_sym_object] = ACTIONS(3178),
    [anon_sym_abstract] = ACTIONS(3178),
    [anon_sym_interface] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [sym_html_comment] = ACTIONS(5),
  },
  [1212] = {
    [sym_comment] = STATE(1212),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_export] = ACTIONS(3154),
    [anon_sym_default] = ACTIONS(3154),
    [anon_sym_type] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_typeof] = ACTIONS(3154),
    [anon_sym_import] = ACTIONS(3154),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_var] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_await] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_debugger] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_case] = ACTIONS(3154),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LTtemplate_GT] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_async] = ACTIONS(3154),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_SLASH] = ACTIONS(3154),
    [anon_sym_LT] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_void] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3154),
    [sym_number] = ACTIONS(3154),
    [sym_private_property_identifier] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
    [sym_super] = ACTIONS(3154),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [sym_null] = ACTIONS(3154),
    [sym_undefined] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_readonly] = ACTIONS(3154),
    [anon_sym_get] = ACTIONS(3154),
    [anon_sym_set] = ACTIONS(3154),
    [anon_sym_declare] = ACTIONS(3154),
    [anon_sym_public] = ACTIONS(3154),
    [anon_sym_private] = ACTIONS(3154),
    [anon_sym_protected] = ACTIONS(3154),
    [anon_sym_override] = ACTIONS(3154),
    [anon_sym_module] = ACTIONS(3154),
    [anon_sym_any] = ACTIONS(3154),
    [anon_sym_number] = ACTIONS(3154),
    [anon_sym_boolean] = ACTIONS(3154),
    [anon_sym_string] = ACTIONS(3154),
    [anon_sym_symbol] = ACTIONS(3154),
    [anon_sym_object] = ACTIONS(3154),
    [anon_sym_abstract] = ACTIONS(3154),
    [anon_sym_interface] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [sym_html_comment] = ACTIONS(5),
  },
  [1213] = {
    [sym_comment] = STATE(1213),
    [sym_identifier] = ACTIONS(3224),
    [anon_sym_export] = ACTIONS(3224),
    [anon_sym_default] = ACTIONS(3224),
    [anon_sym_type] = ACTIONS(3224),
    [anon_sym_namespace] = ACTIONS(3224),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_typeof] = ACTIONS(3224),
    [anon_sym_import] = ACTIONS(3224),
    [anon_sym_with] = ACTIONS(3224),
    [anon_sym_var] = ACTIONS(3224),
    [anon_sym_let] = ACTIONS(3224),
    [anon_sym_const] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_if] = ACTIONS(3224),
    [anon_sym_switch] = ACTIONS(3224),
    [anon_sym_for] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [anon_sym_await] = ACTIONS(3224),
    [anon_sym_while] = ACTIONS(3224),
    [anon_sym_do] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(3224),
    [anon_sym_break] = ACTIONS(3224),
    [anon_sym_continue] = ACTIONS(3224),
    [anon_sym_debugger] = ACTIONS(3224),
    [anon_sym_return] = ACTIONS(3224),
    [anon_sym_throw] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_case] = ACTIONS(3224),
    [anon_sym_yield] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_LTtemplate_GT] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_class] = ACTIONS(3224),
    [anon_sym_async] = ACTIONS(3224),
    [anon_sym_function] = ACTIONS(3224),
    [anon_sym_new] = ACTIONS(3224),
    [anon_sym_using] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3224),
    [anon_sym_SLASH] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_void] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3224),
    [sym_number] = ACTIONS(3224),
    [sym_private_property_identifier] = ACTIONS(3224),
    [sym_this] = ACTIONS(3224),
    [sym_super] = ACTIONS(3224),
    [sym_true] = ACTIONS(3224),
    [sym_false] = ACTIONS(3224),
    [sym_null] = ACTIONS(3224),
    [sym_undefined] = ACTIONS(3224),
    [anon_sym_AT] = ACTIONS(3224),
    [anon_sym_static] = ACTIONS(3224),
    [anon_sym_readonly] = ACTIONS(3224),
    [anon_sym_get] = ACTIONS(3224),
    [anon_sym_set] = ACTIONS(3224),
    [anon_sym_declare] = ACTIONS(3224),
    [anon_sym_public] = ACTIONS(3224),
    [anon_sym_private] = ACTIONS(3224),
    [anon_sym_protected] = ACTIONS(3224),
    [anon_sym_override] = ACTIONS(3224),
    [anon_sym_module] = ACTIONS(3224),
    [anon_sym_any] = ACTIONS(3224),
    [anon_sym_number] = ACTIONS(3224),
    [anon_sym_boolean] = ACTIONS(3224),
    [anon_sym_string] = ACTIONS(3224),
    [anon_sym_symbol] = ACTIONS(3224),
    [anon_sym_object] = ACTIONS(3224),
    [anon_sym_abstract] = ACTIONS(3224),
    [anon_sym_interface] = ACTIONS(3224),
    [anon_sym_enum] = ACTIONS(3224),
    [sym_html_comment] = ACTIONS(5),
  },
  [1214] = {
    [sym_comment] = STATE(1214),
    [sym_identifier] = ACTIONS(3264),
    [anon_sym_export] = ACTIONS(3264),
    [anon_sym_default] = ACTIONS(3264),
    [anon_sym_type] = ACTIONS(3264),
    [anon_sym_namespace] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_RBRACE] = ACTIONS(3264),
    [anon_sym_typeof] = ACTIONS(3264),
    [anon_sym_import] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3264),
    [anon_sym_var] = ACTIONS(3264),
    [anon_sym_let] = ACTIONS(3264),
    [anon_sym_const] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_if] = ACTIONS(3264),
    [anon_sym_switch] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3264),
    [anon_sym_await] = ACTIONS(3264),
    [anon_sym_while] = ACTIONS(3264),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_try] = ACTIONS(3264),
    [anon_sym_break] = ACTIONS(3264),
    [anon_sym_continue] = ACTIONS(3264),
    [anon_sym_debugger] = ACTIONS(3264),
    [anon_sym_return] = ACTIONS(3264),
    [anon_sym_throw] = ACTIONS(3264),
    [anon_sym_SEMI] = ACTIONS(3264),
    [anon_sym_case] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3264),
    [anon_sym_LBRACK] = ACTIONS(3264),
    [anon_sym_LTtemplate_GT] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(3264),
    [anon_sym_SQUOTE] = ACTIONS(3264),
    [anon_sym_class] = ACTIONS(3264),
    [anon_sym_async] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3264),
    [anon_sym_using] = ACTIONS(3264),
    [anon_sym_PLUS] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3264),
    [anon_sym_SLASH] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_TILDE] = ACTIONS(3264),
    [anon_sym_void] = ACTIONS(3264),
    [anon_sym_delete] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3264),
    [anon_sym_DASH_DASH] = ACTIONS(3264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3264),
    [sym_number] = ACTIONS(3264),
    [sym_private_property_identifier] = ACTIONS(3264),
    [sym_this] = ACTIONS(3264),
    [sym_super] = ACTIONS(3264),
    [sym_true] = ACTIONS(3264),
    [sym_false] = ACTIONS(3264),
    [sym_null] = ACTIONS(3264),
    [sym_undefined] = ACTIONS(3264),
    [anon_sym_AT] = ACTIONS(3264),
    [anon_sym_static] = ACTIONS(3264),
    [anon_sym_readonly] = ACTIONS(3264),
    [anon_sym_get] = ACTIONS(3264),
    [anon_sym_set] = ACTIONS(3264),
    [anon_sym_declare] = ACTIONS(3264),
    [anon_sym_public] = ACTIONS(3264),
    [anon_sym_private] = ACTIONS(3264),
    [anon_sym_protected] = ACTIONS(3264),
    [anon_sym_override] = ACTIONS(3264),
    [anon_sym_module] = ACTIONS(3264),
    [anon_sym_any] = ACTIONS(3264),
    [anon_sym_number] = ACTIONS(3264),
    [anon_sym_boolean] = ACTIONS(3264),
    [anon_sym_string] = ACTIONS(3264),
    [anon_sym_symbol] = ACTIONS(3264),
    [anon_sym_object] = ACTIONS(3264),
    [anon_sym_abstract] = ACTIONS(3264),
    [anon_sym_interface] = ACTIONS(3264),
    [anon_sym_enum] = ACTIONS(3264),
    [sym_html_comment] = ACTIONS(5),
  },
  [1215] = {
    [sym_comment] = STATE(1215),
    [ts_builtin_sym_end] = ACTIONS(3410),
    [sym_identifier] = ACTIONS(3252),
    [anon_sym_export] = ACTIONS(3252),
    [anon_sym_type] = ACTIONS(3252),
    [anon_sym_namespace] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_typeof] = ACTIONS(3252),
    [anon_sym_import] = ACTIONS(3252),
    [anon_sym_with] = ACTIONS(3252),
    [anon_sym_var] = ACTIONS(3252),
    [anon_sym_let] = ACTIONS(3252),
    [anon_sym_const] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_else] = ACTIONS(3252),
    [anon_sym_if] = ACTIONS(3252),
    [anon_sym_switch] = ACTIONS(3252),
    [anon_sym_for] = ACTIONS(3252),
    [anon_sym_LPAREN] = ACTIONS(3252),
    [anon_sym_await] = ACTIONS(3252),
    [anon_sym_while] = ACTIONS(3252),
    [anon_sym_do] = ACTIONS(3252),
    [anon_sym_try] = ACTIONS(3252),
    [anon_sym_break] = ACTIONS(3252),
    [anon_sym_continue] = ACTIONS(3252),
    [anon_sym_debugger] = ACTIONS(3252),
    [anon_sym_return] = ACTIONS(3252),
    [anon_sym_throw] = ACTIONS(3252),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym_yield] = ACTIONS(3252),
    [anon_sym_LBRACK] = ACTIONS(3252),
    [anon_sym_LTtemplate_GT] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_class] = ACTIONS(3252),
    [anon_sym_async] = ACTIONS(3252),
    [anon_sym_function] = ACTIONS(3252),
    [anon_sym_new] = ACTIONS(3252),
    [anon_sym_using] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3252),
    [anon_sym_SLASH] = ACTIONS(3252),
    [anon_sym_LT] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_void] = ACTIONS(3252),
    [anon_sym_delete] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3252),
    [sym_number] = ACTIONS(3252),
    [sym_private_property_identifier] = ACTIONS(3252),
    [sym_this] = ACTIONS(3252),
    [sym_super] = ACTIONS(3252),
    [sym_true] = ACTIONS(3252),
    [sym_false] = ACTIONS(3252),
    [sym_null] = ACTIONS(3252),
    [sym_undefined] = ACTIONS(3252),
    [anon_sym_AT] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3252),
    [anon_sym_readonly] = ACTIONS(3252),
    [anon_sym_get] = ACTIONS(3252),
    [anon_sym_set] = ACTIONS(3252),
    [anon_sym_declare] = ACTIONS(3252),
    [anon_sym_public] = ACTIONS(3252),
    [anon_sym_private] = ACTIONS(3252),
    [anon_sym_protected] = ACTIONS(3252),
    [anon_sym_override] = ACTIONS(3252),
    [anon_sym_module] = ACTIONS(3252),
    [anon_sym_any] = ACTIONS(3252),
    [anon_sym_number] = ACTIONS(3252),
    [anon_sym_boolean] = ACTIONS(3252),
    [anon_sym_string] = ACTIONS(3252),
    [anon_sym_symbol] = ACTIONS(3252),
    [anon_sym_object] = ACTIONS(3252),
    [anon_sym_abstract] = ACTIONS(3252),
    [anon_sym_interface] = ACTIONS(3252),
    [anon_sym_enum] = ACTIONS(3252),
    [sym_html_comment] = ACTIONS(5),
  },
  [1216] = {
    [sym_comment] = STATE(1216),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(3412),
    [sym_html_comment] = ACTIONS(5),
  },
  [1217] = {
    [sym_comment] = STATE(1217),
    [ts_builtin_sym_end] = ACTIONS(3414),
    [sym_identifier] = ACTIONS(3354),
    [anon_sym_export] = ACTIONS(3354),
    [anon_sym_type] = ACTIONS(3354),
    [anon_sym_namespace] = ACTIONS(3354),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_RBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3354),
    [anon_sym_import] = ACTIONS(3354),
    [anon_sym_with] = ACTIONS(3354),
    [anon_sym_var] = ACTIONS(3354),
    [anon_sym_let] = ACTIONS(3354),
    [anon_sym_const] = ACTIONS(3354),
    [anon_sym_BANG] = ACTIONS(3354),
    [anon_sym_else] = ACTIONS(3354),
    [anon_sym_if] = ACTIONS(3354),
    [anon_sym_switch] = ACTIONS(3354),
    [anon_sym_for] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3354),
    [anon_sym_await] = ACTIONS(3354),
    [anon_sym_while] = ACTIONS(3354),
    [anon_sym_do] = ACTIONS(3354),
    [anon_sym_try] = ACTIONS(3354),
    [anon_sym_break] = ACTIONS(3354),
    [anon_sym_continue] = ACTIONS(3354),
    [anon_sym_debugger] = ACTIONS(3354),
    [anon_sym_return] = ACTIONS(3354),
    [anon_sym_throw] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(3354),
    [anon_sym_yield] = ACTIONS(3354),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_LTtemplate_GT] = ACTIONS(3354),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_class] = ACTIONS(3354),
    [anon_sym_async] = ACTIONS(3354),
    [anon_sym_function] = ACTIONS(3354),
    [anon_sym_new] = ACTIONS(3354),
    [anon_sym_using] = ACTIONS(3354),
    [anon_sym_PLUS] = ACTIONS(3354),
    [anon_sym_DASH] = ACTIONS(3354),
    [anon_sym_SLASH] = ACTIONS(3354),
    [anon_sym_LT] = ACTIONS(3354),
    [anon_sym_TILDE] = ACTIONS(3354),
    [anon_sym_void] = ACTIONS(3354),
    [anon_sym_delete] = ACTIONS(3354),
    [anon_sym_PLUS_PLUS] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3354),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3354),
    [sym_number] = ACTIONS(3354),
    [sym_private_property_identifier] = ACTIONS(3354),
    [sym_this] = ACTIONS(3354),
    [sym_super] = ACTIONS(3354),
    [sym_true] = ACTIONS(3354),
    [sym_false] = ACTIONS(3354),
    [sym_null] = ACTIONS(3354),
    [sym_undefined] = ACTIONS(3354),
    [anon_sym_AT] = ACTIONS(3354),
    [anon_sym_static] = ACTIONS(3354),
    [anon_sym_readonly] = ACTIONS(3354),
    [anon_sym_get] = ACTIONS(3354),
    [anon_sym_set] = ACTIONS(3354),
    [anon_sym_declare] = ACTIONS(3354),
    [anon_sym_public] = ACTIONS(3354),
    [anon_sym_private] = ACTIONS(3354),
    [anon_sym_protected] = ACTIONS(3354),
    [anon_sym_override] = ACTIONS(3354),
    [anon_sym_module] = ACTIONS(3354),
    [anon_sym_any] = ACTIONS(3354),
    [anon_sym_number] = ACTIONS(3354),
    [anon_sym_boolean] = ACTIONS(3354),
    [anon_sym_string] = ACTIONS(3354),
    [anon_sym_symbol] = ACTIONS(3354),
    [anon_sym_object] = ACTIONS(3354),
    [anon_sym_abstract] = ACTIONS(3354),
    [anon_sym_interface] = ACTIONS(3354),
    [anon_sym_enum] = ACTIONS(3354),
    [sym_html_comment] = ACTIONS(5),
  },
  [1218] = {
    [sym_comment] = STATE(1218),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(2175),
    [anon_sym_default] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_namespace] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2175),
    [anon_sym_import] = ACTIONS(2175),
    [anon_sym_with] = ACTIONS(2175),
    [anon_sym_var] = ACTIONS(2175),
    [anon_sym_let] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_switch] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_await] = ACTIONS(2175),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_do] = ACTIONS(2175),
    [anon_sym_try] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_debugger] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_case] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [anon_sym_LTtemplate_GT] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_class] = ACTIONS(2175),
    [anon_sym_async] = ACTIONS(2175),
    [anon_sym_function] = ACTIONS(2175),
    [anon_sym_new] = ACTIONS(2175),
    [anon_sym_using] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_void] = ACTIONS(2175),
    [anon_sym_delete] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_number] = ACTIONS(2175),
    [sym_private_property_identifier] = ACTIONS(2175),
    [sym_this] = ACTIONS(2175),
    [sym_super] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2175),
    [anon_sym_static] = ACTIONS(2175),
    [anon_sym_readonly] = ACTIONS(2175),
    [anon_sym_get] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(2175),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_public] = ACTIONS(2175),
    [anon_sym_private] = ACTIONS(2175),
    [anon_sym_protected] = ACTIONS(2175),
    [anon_sym_override] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2175),
    [anon_sym_any] = ACTIONS(2175),
    [anon_sym_number] = ACTIONS(2175),
    [anon_sym_boolean] = ACTIONS(2175),
    [anon_sym_string] = ACTIONS(2175),
    [anon_sym_symbol] = ACTIONS(2175),
    [anon_sym_object] = ACTIONS(2175),
    [anon_sym_abstract] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [sym_html_comment] = ACTIONS(5),
  },
  [1219] = {
    [sym_comment] = STATE(1219),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_case] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym_html_comment] = ACTIONS(5),
  },
  [1220] = {
    [sym_comment] = STATE(1220),
    [sym_identifier] = ACTIONS(2163),
    [anon_sym_export] = ACTIONS(2163),
    [anon_sym_default] = ACTIONS(2163),
    [anon_sym_type] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2163),
    [anon_sym_import] = ACTIONS(2163),
    [anon_sym_with] = ACTIONS(2163),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2163),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_debugger] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_case] = ACTIONS(2163),
    [anon_sym_yield] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_LTtemplate_GT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2163),
    [anon_sym_SQUOTE] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_async] = ACTIONS(2163),
    [anon_sym_function] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_SLASH] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [anon_sym_void] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_PLUS_PLUS] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2163),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2163),
    [sym_number] = ACTIONS(2163),
    [sym_private_property_identifier] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(2163),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_readonly] = ACTIONS(2163),
    [anon_sym_get] = ACTIONS(2163),
    [anon_sym_set] = ACTIONS(2163),
    [anon_sym_declare] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_override] = ACTIONS(2163),
    [anon_sym_module] = ACTIONS(2163),
    [anon_sym_any] = ACTIONS(2163),
    [anon_sym_number] = ACTIONS(2163),
    [anon_sym_boolean] = ACTIONS(2163),
    [anon_sym_string] = ACTIONS(2163),
    [anon_sym_symbol] = ACTIONS(2163),
    [anon_sym_object] = ACTIONS(2163),
    [anon_sym_abstract] = ACTIONS(2163),
    [anon_sym_interface] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [sym_html_comment] = ACTIONS(5),
  },
  [1221] = {
    [sym_comment] = STATE(1221),
    [sym_identifier] = ACTIONS(3330),
    [anon_sym_export] = ACTIONS(3330),
    [anon_sym_default] = ACTIONS(3330),
    [anon_sym_type] = ACTIONS(3330),
    [anon_sym_namespace] = ACTIONS(3330),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_RBRACE] = ACTIONS(3330),
    [anon_sym_typeof] = ACTIONS(3330),
    [anon_sym_import] = ACTIONS(3330),
    [anon_sym_with] = ACTIONS(3330),
    [anon_sym_var] = ACTIONS(3330),
    [anon_sym_let] = ACTIONS(3330),
    [anon_sym_const] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_if] = ACTIONS(3330),
    [anon_sym_switch] = ACTIONS(3330),
    [anon_sym_for] = ACTIONS(3330),
    [anon_sym_LPAREN] = ACTIONS(3330),
    [anon_sym_await] = ACTIONS(3330),
    [anon_sym_while] = ACTIONS(3330),
    [anon_sym_do] = ACTIONS(3330),
    [anon_sym_try] = ACTIONS(3330),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_continue] = ACTIONS(3330),
    [anon_sym_debugger] = ACTIONS(3330),
    [anon_sym_return] = ACTIONS(3330),
    [anon_sym_throw] = ACTIONS(3330),
    [anon_sym_SEMI] = ACTIONS(3330),
    [anon_sym_case] = ACTIONS(3330),
    [anon_sym_yield] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_LTtemplate_GT] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_class] = ACTIONS(3330),
    [anon_sym_async] = ACTIONS(3330),
    [anon_sym_function] = ACTIONS(3330),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_using] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_SLASH] = ACTIONS(3330),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_void] = ACTIONS(3330),
    [anon_sym_delete] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3330),
    [sym_number] = ACTIONS(3330),
    [sym_private_property_identifier] = ACTIONS(3330),
    [sym_this] = ACTIONS(3330),
    [sym_super] = ACTIONS(3330),
    [sym_true] = ACTIONS(3330),
    [sym_false] = ACTIONS(3330),
    [sym_null] = ACTIONS(3330),
    [sym_undefined] = ACTIONS(3330),
    [anon_sym_AT] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3330),
    [anon_sym_readonly] = ACTIONS(3330),
    [anon_sym_get] = ACTIONS(3330),
    [anon_sym_set] = ACTIONS(3330),
    [anon_sym_declare] = ACTIONS(3330),
    [anon_sym_public] = ACTIONS(3330),
    [anon_sym_private] = ACTIONS(3330),
    [anon_sym_protected] = ACTIONS(3330),
    [anon_sym_override] = ACTIONS(3330),
    [anon_sym_module] = ACTIONS(3330),
    [anon_sym_any] = ACTIONS(3330),
    [anon_sym_number] = ACTIONS(3330),
    [anon_sym_boolean] = ACTIONS(3330),
    [anon_sym_string] = ACTIONS(3330),
    [anon_sym_symbol] = ACTIONS(3330),
    [anon_sym_object] = ACTIONS(3330),
    [anon_sym_abstract] = ACTIONS(3330),
    [anon_sym_interface] = ACTIONS(3330),
    [anon_sym_enum] = ACTIONS(3330),
    [sym_html_comment] = ACTIONS(5),
  },
  [1222] = {
    [sym_comment] = STATE(1222),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_export] = ACTIONS(3346),
    [anon_sym_default] = ACTIONS(3346),
    [anon_sym_type] = ACTIONS(3346),
    [anon_sym_namespace] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_typeof] = ACTIONS(3346),
    [anon_sym_import] = ACTIONS(3346),
    [anon_sym_with] = ACTIONS(3346),
    [anon_sym_var] = ACTIONS(3346),
    [anon_sym_let] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_switch] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_await] = ACTIONS(3346),
    [anon_sym_while] = ACTIONS(3346),
    [anon_sym_do] = ACTIONS(3346),
    [anon_sym_try] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_debugger] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_throw] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_case] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_LTtemplate_GT] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_async] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_SLASH] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_void] = ACTIONS(3346),
    [anon_sym_delete] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3346),
    [sym_number] = ACTIONS(3346),
    [sym_private_property_identifier] = ACTIONS(3346),
    [sym_this] = ACTIONS(3346),
    [sym_super] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_null] = ACTIONS(3346),
    [sym_undefined] = ACTIONS(3346),
    [anon_sym_AT] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_readonly] = ACTIONS(3346),
    [anon_sym_get] = ACTIONS(3346),
    [anon_sym_set] = ACTIONS(3346),
    [anon_sym_declare] = ACTIONS(3346),
    [anon_sym_public] = ACTIONS(3346),
    [anon_sym_private] = ACTIONS(3346),
    [anon_sym_protected] = ACTIONS(3346),
    [anon_sym_override] = ACTIONS(3346),
    [anon_sym_module] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3346),
    [anon_sym_number] = ACTIONS(3346),
    [anon_sym_boolean] = ACTIONS(3346),
    [anon_sym_string] = ACTIONS(3346),
    [anon_sym_symbol] = ACTIONS(3346),
    [anon_sym_object] = ACTIONS(3346),
    [anon_sym_abstract] = ACTIONS(3346),
    [anon_sym_interface] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [sym_html_comment] = ACTIONS(5),
  },
  [1223] = {
    [sym_comment] = STATE(1223),
    [ts_builtin_sym_end] = ACTIONS(2127),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym__automatic_semicolon] = ACTIONS(2127),
    [sym_html_comment] = ACTIONS(5),
  },
  [1224] = {
    [sym_comment] = STATE(1224),
    [ts_builtin_sym_end] = ACTIONS(3416),
    [sym_identifier] = ACTIONS(3146),
    [anon_sym_export] = ACTIONS(3146),
    [anon_sym_type] = ACTIONS(3146),
    [anon_sym_namespace] = ACTIONS(3146),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_typeof] = ACTIONS(3146),
    [anon_sym_import] = ACTIONS(3146),
    [anon_sym_with] = ACTIONS(3146),
    [anon_sym_var] = ACTIONS(3146),
    [anon_sym_let] = ACTIONS(3146),
    [anon_sym_const] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_else] = ACTIONS(3146),
    [anon_sym_if] = ACTIONS(3146),
    [anon_sym_switch] = ACTIONS(3146),
    [anon_sym_for] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_await] = ACTIONS(3146),
    [anon_sym_while] = ACTIONS(3146),
    [anon_sym_do] = ACTIONS(3146),
    [anon_sym_try] = ACTIONS(3146),
    [anon_sym_break] = ACTIONS(3146),
    [anon_sym_continue] = ACTIONS(3146),
    [anon_sym_debugger] = ACTIONS(3146),
    [anon_sym_return] = ACTIONS(3146),
    [anon_sym_throw] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_yield] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_LTtemplate_GT] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(3146),
    [anon_sym_async] = ACTIONS(3146),
    [anon_sym_function] = ACTIONS(3146),
    [anon_sym_new] = ACTIONS(3146),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3146),
    [anon_sym_SLASH] = ACTIONS(3146),
    [anon_sym_LT] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_void] = ACTIONS(3146),
    [anon_sym_delete] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3146),
    [sym_number] = ACTIONS(3146),
    [sym_private_property_identifier] = ACTIONS(3146),
    [sym_this] = ACTIONS(3146),
    [sym_super] = ACTIONS(3146),
    [sym_true] = ACTIONS(3146),
    [sym_false] = ACTIONS(3146),
    [sym_null] = ACTIONS(3146),
    [sym_undefined] = ACTIONS(3146),
    [anon_sym_AT] = ACTIONS(3146),
    [anon_sym_static] = ACTIONS(3146),
    [anon_sym_readonly] = ACTIONS(3146),
    [anon_sym_get] = ACTIONS(3146),
    [anon_sym_set] = ACTIONS(3146),
    [anon_sym_declare] = ACTIONS(3146),
    [anon_sym_public] = ACTIONS(3146),
    [anon_sym_private] = ACTIONS(3146),
    [anon_sym_protected] = ACTIONS(3146),
    [anon_sym_override] = ACTIONS(3146),
    [anon_sym_module] = ACTIONS(3146),
    [anon_sym_any] = ACTIONS(3146),
    [anon_sym_number] = ACTIONS(3146),
    [anon_sym_boolean] = ACTIONS(3146),
    [anon_sym_string] = ACTIONS(3146),
    [anon_sym_symbol] = ACTIONS(3146),
    [anon_sym_object] = ACTIONS(3146),
    [anon_sym_abstract] = ACTIONS(3146),
    [anon_sym_interface] = ACTIONS(3146),
    [anon_sym_enum] = ACTIONS(3146),
    [sym_html_comment] = ACTIONS(5),
  },
  [1225] = {
    [sym_comment] = STATE(1225),
    [ts_builtin_sym_end] = ACTIONS(3418),
    [sym_identifier] = ACTIONS(3238),
    [anon_sym_export] = ACTIONS(3238),
    [anon_sym_type] = ACTIONS(3238),
    [anon_sym_namespace] = ACTIONS(3238),
    [anon_sym_LBRACE] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_typeof] = ACTIONS(3238),
    [anon_sym_import] = ACTIONS(3238),
    [anon_sym_with] = ACTIONS(3238),
    [anon_sym_var] = ACTIONS(3238),
    [anon_sym_let] = ACTIONS(3238),
    [anon_sym_const] = ACTIONS(3238),
    [anon_sym_BANG] = ACTIONS(3238),
    [anon_sym_else] = ACTIONS(3238),
    [anon_sym_if] = ACTIONS(3238),
    [anon_sym_switch] = ACTIONS(3238),
    [anon_sym_for] = ACTIONS(3238),
    [anon_sym_LPAREN] = ACTIONS(3238),
    [anon_sym_await] = ACTIONS(3238),
    [anon_sym_while] = ACTIONS(3238),
    [anon_sym_do] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(3238),
    [anon_sym_break] = ACTIONS(3238),
    [anon_sym_continue] = ACTIONS(3238),
    [anon_sym_debugger] = ACTIONS(3238),
    [anon_sym_return] = ACTIONS(3238),
    [anon_sym_throw] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym_yield] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_LTtemplate_GT] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [anon_sym_class] = ACTIONS(3238),
    [anon_sym_async] = ACTIONS(3238),
    [anon_sym_function] = ACTIONS(3238),
    [anon_sym_new] = ACTIONS(3238),
    [anon_sym_using] = ACTIONS(3238),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3238),
    [anon_sym_TILDE] = ACTIONS(3238),
    [anon_sym_void] = ACTIONS(3238),
    [anon_sym_delete] = ACTIONS(3238),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [sym_number] = ACTIONS(3238),
    [sym_private_property_identifier] = ACTIONS(3238),
    [sym_this] = ACTIONS(3238),
    [sym_super] = ACTIONS(3238),
    [sym_true] = ACTIONS(3238),
    [sym_false] = ACTIONS(3238),
    [sym_null] = ACTIONS(3238),
    [sym_undefined] = ACTIONS(3238),
    [anon_sym_AT] = ACTIONS(3238),
    [anon_sym_static] = ACTIONS(3238),
    [anon_sym_readonly] = ACTIONS(3238),
    [anon_sym_get] = ACTIONS(3238),
    [anon_sym_set] = ACTIONS(3238),
    [anon_sym_declare] = ACTIONS(3238),
    [anon_sym_public] = ACTIONS(3238),
    [anon_sym_private] = ACTIONS(3238),
    [anon_sym_protected] = ACTIONS(3238),
    [anon_sym_override] = ACTIONS(3238),
    [anon_sym_module] = ACTIONS(3238),
    [anon_sym_any] = ACTIONS(3238),
    [anon_sym_number] = ACTIONS(3238),
    [anon_sym_boolean] = ACTIONS(3238),
    [anon_sym_string] = ACTIONS(3238),
    [anon_sym_symbol] = ACTIONS(3238),
    [anon_sym_object] = ACTIONS(3238),
    [anon_sym_abstract] = ACTIONS(3238),
    [anon_sym_interface] = ACTIONS(3238),
    [anon_sym_enum] = ACTIONS(3238),
    [sym_html_comment] = ACTIONS(5),
  },
  [1226] = {
    [sym_comment] = STATE(1226),
    [ts_builtin_sym_end] = ACTIONS(3420),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_export] = ACTIONS(3350),
    [anon_sym_type] = ACTIONS(3350),
    [anon_sym_namespace] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3350),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_typeof] = ACTIONS(3350),
    [anon_sym_import] = ACTIONS(3350),
    [anon_sym_with] = ACTIONS(3350),
    [anon_sym_var] = ACTIONS(3350),
    [anon_sym_let] = ACTIONS(3350),
    [anon_sym_const] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_else] = ACTIONS(3350),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_switch] = ACTIONS(3350),
    [anon_sym_for] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym_await] = ACTIONS(3350),
    [anon_sym_while] = ACTIONS(3350),
    [anon_sym_do] = ACTIONS(3350),
    [anon_sym_try] = ACTIONS(3350),
    [anon_sym_break] = ACTIONS(3350),
    [anon_sym_continue] = ACTIONS(3350),
    [anon_sym_debugger] = ACTIONS(3350),
    [anon_sym_return] = ACTIONS(3350),
    [anon_sym_throw] = ACTIONS(3350),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym_yield] = ACTIONS(3350),
    [anon_sym_LBRACK] = ACTIONS(3350),
    [anon_sym_LTtemplate_GT] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_class] = ACTIONS(3350),
    [anon_sym_async] = ACTIONS(3350),
    [anon_sym_function] = ACTIONS(3350),
    [anon_sym_new] = ACTIONS(3350),
    [anon_sym_using] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_void] = ACTIONS(3350),
    [anon_sym_delete] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [sym_number] = ACTIONS(3350),
    [sym_private_property_identifier] = ACTIONS(3350),
    [sym_this] = ACTIONS(3350),
    [sym_super] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_null] = ACTIONS(3350),
    [sym_undefined] = ACTIONS(3350),
    [anon_sym_AT] = ACTIONS(3350),
    [anon_sym_static] = ACTIONS(3350),
    [anon_sym_readonly] = ACTIONS(3350),
    [anon_sym_get] = ACTIONS(3350),
    [anon_sym_set] = ACTIONS(3350),
    [anon_sym_declare] = ACTIONS(3350),
    [anon_sym_public] = ACTIONS(3350),
    [anon_sym_private] = ACTIONS(3350),
    [anon_sym_protected] = ACTIONS(3350),
    [anon_sym_override] = ACTIONS(3350),
    [anon_sym_module] = ACTIONS(3350),
    [anon_sym_any] = ACTIONS(3350),
    [anon_sym_number] = ACTIONS(3350),
    [anon_sym_boolean] = ACTIONS(3350),
    [anon_sym_string] = ACTIONS(3350),
    [anon_sym_symbol] = ACTIONS(3350),
    [anon_sym_object] = ACTIONS(3350),
    [anon_sym_abstract] = ACTIONS(3350),
    [anon_sym_interface] = ACTIONS(3350),
    [anon_sym_enum] = ACTIONS(3350),
    [sym_html_comment] = ACTIONS(5),
  },
  [1227] = {
    [sym_comment] = STATE(1227),
    [ts_builtin_sym_end] = ACTIONS(3422),
    [sym_identifier] = ACTIONS(3260),
    [anon_sym_export] = ACTIONS(3260),
    [anon_sym_type] = ACTIONS(3260),
    [anon_sym_namespace] = ACTIONS(3260),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_RBRACE] = ACTIONS(3260),
    [anon_sym_typeof] = ACTIONS(3260),
    [anon_sym_import] = ACTIONS(3260),
    [anon_sym_with] = ACTIONS(3260),
    [anon_sym_var] = ACTIONS(3260),
    [anon_sym_let] = ACTIONS(3260),
    [anon_sym_const] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_else] = ACTIONS(3260),
    [anon_sym_if] = ACTIONS(3260),
    [anon_sym_switch] = ACTIONS(3260),
    [anon_sym_for] = ACTIONS(3260),
    [anon_sym_LPAREN] = ACTIONS(3260),
    [anon_sym_await] = ACTIONS(3260),
    [anon_sym_while] = ACTIONS(3260),
    [anon_sym_do] = ACTIONS(3260),
    [anon_sym_try] = ACTIONS(3260),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_continue] = ACTIONS(3260),
    [anon_sym_debugger] = ACTIONS(3260),
    [anon_sym_return] = ACTIONS(3260),
    [anon_sym_throw] = ACTIONS(3260),
    [anon_sym_SEMI] = ACTIONS(3260),
    [anon_sym_yield] = ACTIONS(3260),
    [anon_sym_LBRACK] = ACTIONS(3260),
    [anon_sym_LTtemplate_GT] = ACTIONS(3260),
    [anon_sym_DQUOTE] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3260),
    [anon_sym_class] = ACTIONS(3260),
    [anon_sym_async] = ACTIONS(3260),
    [anon_sym_function] = ACTIONS(3260),
    [anon_sym_new] = ACTIONS(3260),
    [anon_sym_using] = ACTIONS(3260),
    [anon_sym_PLUS] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3260),
    [anon_sym_SLASH] = ACTIONS(3260),
    [anon_sym_LT] = ACTIONS(3260),
    [anon_sym_TILDE] = ACTIONS(3260),
    [anon_sym_void] = ACTIONS(3260),
    [anon_sym_delete] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3260),
    [anon_sym_DASH_DASH] = ACTIONS(3260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3260),
    [sym_number] = ACTIONS(3260),
    [sym_private_property_identifier] = ACTIONS(3260),
    [sym_this] = ACTIONS(3260),
    [sym_super] = ACTIONS(3260),
    [sym_true] = ACTIONS(3260),
    [sym_false] = ACTIONS(3260),
    [sym_null] = ACTIONS(3260),
    [sym_undefined] = ACTIONS(3260),
    [anon_sym_AT] = ACTIONS(3260),
    [anon_sym_static] = ACTIONS(3260),
    [anon_sym_readonly] = ACTIONS(3260),
    [anon_sym_get] = ACTIONS(3260),
    [anon_sym_set] = ACTIONS(3260),
    [anon_sym_declare] = ACTIONS(3260),
    [anon_sym_public] = ACTIONS(3260),
    [anon_sym_private] = ACTIONS(3260),
    [anon_sym_protected] = ACTIONS(3260),
    [anon_sym_override] = ACTIONS(3260),
    [anon_sym_module] = ACTIONS(3260),
    [anon_sym_any] = ACTIONS(3260),
    [anon_sym_number] = ACTIONS(3260),
    [anon_sym_boolean] = ACTIONS(3260),
    [anon_sym_string] = ACTIONS(3260),
    [anon_sym_symbol] = ACTIONS(3260),
    [anon_sym_object] = ACTIONS(3260),
    [anon_sym_abstract] = ACTIONS(3260),
    [anon_sym_interface] = ACTIONS(3260),
    [anon_sym_enum] = ACTIONS(3260),
    [sym_html_comment] = ACTIONS(5),
  },
  [1228] = {
    [sym_comment] = STATE(1228),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [1229] = {
    [sym_comment] = STATE(1229),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [1230] = {
    [sym_comment] = STATE(1230),
    [ts_builtin_sym_end] = ACTIONS(3424),
    [sym_identifier] = ACTIONS(3148),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_type] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_typeof] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3148),
    [anon_sym_with] = ACTIONS(3148),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_await] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_debugger] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_yield] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_LTtemplate_GT] = ACTIONS(3148),
    [anon_sym_DQUOTE] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_async] = ACTIONS(3148),
    [anon_sym_function] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_SLASH] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_void] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3148),
    [sym_number] = ACTIONS(3148),
    [sym_private_property_identifier] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
    [sym_super] = ACTIONS(3148),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [sym_null] = ACTIONS(3148),
    [sym_undefined] = ACTIONS(3148),
    [anon_sym_AT] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_readonly] = ACTIONS(3148),
    [anon_sym_get] = ACTIONS(3148),
    [anon_sym_set] = ACTIONS(3148),
    [anon_sym_declare] = ACTIONS(3148),
    [anon_sym_public] = ACTIONS(3148),
    [anon_sym_private] = ACTIONS(3148),
    [anon_sym_protected] = ACTIONS(3148),
    [anon_sym_override] = ACTIONS(3148),
    [anon_sym_module] = ACTIONS(3148),
    [anon_sym_any] = ACTIONS(3148),
    [anon_sym_number] = ACTIONS(3148),
    [anon_sym_boolean] = ACTIONS(3148),
    [anon_sym_string] = ACTIONS(3148),
    [anon_sym_symbol] = ACTIONS(3148),
    [anon_sym_object] = ACTIONS(3148),
    [anon_sym_abstract] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [sym_html_comment] = ACTIONS(5),
  },
  [1231] = {
    [sym_comment] = STATE(1231),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1232] = {
    [sym_comment] = STATE(1232),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [1233] = {
    [sym_comment] = STATE(1233),
    [ts_builtin_sym_end] = ACTIONS(3426),
    [sym_identifier] = ACTIONS(3348),
    [anon_sym_export] = ACTIONS(3348),
    [anon_sym_type] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_RBRACE] = ACTIONS(3348),
    [anon_sym_typeof] = ACTIONS(3348),
    [anon_sym_import] = ACTIONS(3348),
    [anon_sym_with] = ACTIONS(3348),
    [anon_sym_var] = ACTIONS(3348),
    [anon_sym_let] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_BANG] = ACTIONS(3348),
    [anon_sym_else] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_LPAREN] = ACTIONS(3348),
    [anon_sym_await] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_debugger] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_throw] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3348),
    [anon_sym_yield] = ACTIONS(3348),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_LTtemplate_GT] = ACTIONS(3348),
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [anon_sym_SQUOTE] = ACTIONS(3348),
    [anon_sym_class] = ACTIONS(3348),
    [anon_sym_async] = ACTIONS(3348),
    [anon_sym_function] = ACTIONS(3348),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3348),
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_void] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [sym_number] = ACTIONS(3348),
    [sym_private_property_identifier] = ACTIONS(3348),
    [sym_this] = ACTIONS(3348),
    [sym_super] = ACTIONS(3348),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_undefined] = ACTIONS(3348),
    [anon_sym_AT] = ACTIONS(3348),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_readonly] = ACTIONS(3348),
    [anon_sym_get] = ACTIONS(3348),
    [anon_sym_set] = ACTIONS(3348),
    [anon_sym_declare] = ACTIONS(3348),
    [anon_sym_public] = ACTIONS(3348),
    [anon_sym_private] = ACTIONS(3348),
    [anon_sym_protected] = ACTIONS(3348),
    [anon_sym_override] = ACTIONS(3348),
    [anon_sym_module] = ACTIONS(3348),
    [anon_sym_any] = ACTIONS(3348),
    [anon_sym_number] = ACTIONS(3348),
    [anon_sym_boolean] = ACTIONS(3348),
    [anon_sym_string] = ACTIONS(3348),
    [anon_sym_symbol] = ACTIONS(3348),
    [anon_sym_object] = ACTIONS(3348),
    [anon_sym_abstract] = ACTIONS(3348),
    [anon_sym_interface] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [sym_html_comment] = ACTIONS(5),
  },
  [1234] = {
    [sym_comment] = STATE(1234),
    [ts_builtin_sym_end] = ACTIONS(3428),
    [sym_identifier] = ACTIONS(3162),
    [anon_sym_export] = ACTIONS(3162),
    [anon_sym_type] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_RBRACE] = ACTIONS(3162),
    [anon_sym_typeof] = ACTIONS(3162),
    [anon_sym_import] = ACTIONS(3162),
    [anon_sym_with] = ACTIONS(3162),
    [anon_sym_var] = ACTIONS(3162),
    [anon_sym_let] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_LPAREN] = ACTIONS(3162),
    [anon_sym_await] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_debugger] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym_yield] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_LTtemplate_GT] = ACTIONS(3162),
    [anon_sym_DQUOTE] = ACTIONS(3162),
    [anon_sym_SQUOTE] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_async] = ACTIONS(3162),
    [anon_sym_function] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_SLASH] = ACTIONS(3162),
    [anon_sym_LT] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_void] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3162),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3162),
    [sym_number] = ACTIONS(3162),
    [sym_private_property_identifier] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
    [sym_super] = ACTIONS(3162),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [sym_null] = ACTIONS(3162),
    [sym_undefined] = ACTIONS(3162),
    [anon_sym_AT] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_readonly] = ACTIONS(3162),
    [anon_sym_get] = ACTIONS(3162),
    [anon_sym_set] = ACTIONS(3162),
    [anon_sym_declare] = ACTIONS(3162),
    [anon_sym_public] = ACTIONS(3162),
    [anon_sym_private] = ACTIONS(3162),
    [anon_sym_protected] = ACTIONS(3162),
    [anon_sym_override] = ACTIONS(3162),
    [anon_sym_module] = ACTIONS(3162),
    [anon_sym_any] = ACTIONS(3162),
    [anon_sym_number] = ACTIONS(3162),
    [anon_sym_boolean] = ACTIONS(3162),
    [anon_sym_string] = ACTIONS(3162),
    [anon_sym_symbol] = ACTIONS(3162),
    [anon_sym_object] = ACTIONS(3162),
    [anon_sym_abstract] = ACTIONS(3162),
    [anon_sym_interface] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [sym_html_comment] = ACTIONS(5),
  },
  [1235] = {
    [sym_comment] = STATE(1235),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_export] = ACTIONS(3180),
    [anon_sym_default] = ACTIONS(3180),
    [anon_sym_type] = ACTIONS(3180),
    [anon_sym_namespace] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_RBRACE] = ACTIONS(3180),
    [anon_sym_typeof] = ACTIONS(3180),
    [anon_sym_import] = ACTIONS(3180),
    [anon_sym_with] = ACTIONS(3180),
    [anon_sym_var] = ACTIONS(3180),
    [anon_sym_let] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_if] = ACTIONS(3180),
    [anon_sym_switch] = ACTIONS(3180),
    [anon_sym_for] = ACTIONS(3180),
    [anon_sym_LPAREN] = ACTIONS(3180),
    [anon_sym_await] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3180),
    [anon_sym_do] = ACTIONS(3180),
    [anon_sym_try] = ACTIONS(3180),
    [anon_sym_break] = ACTIONS(3180),
    [anon_sym_continue] = ACTIONS(3180),
    [anon_sym_debugger] = ACTIONS(3180),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_throw] = ACTIONS(3180),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym_case] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3180),
    [anon_sym_LBRACK] = ACTIONS(3180),
    [anon_sym_LTtemplate_GT] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_class] = ACTIONS(3180),
    [anon_sym_async] = ACTIONS(3180),
    [anon_sym_function] = ACTIONS(3180),
    [anon_sym_new] = ACTIONS(3180),
    [anon_sym_using] = ACTIONS(3180),
    [anon_sym_PLUS] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3180),
    [anon_sym_SLASH] = ACTIONS(3180),
    [anon_sym_LT] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_void] = ACTIONS(3180),
    [anon_sym_delete] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3180),
    [sym_number] = ACTIONS(3180),
    [sym_private_property_identifier] = ACTIONS(3180),
    [sym_this] = ACTIONS(3180),
    [sym_super] = ACTIONS(3180),
    [sym_true] = ACTIONS(3180),
    [sym_false] = ACTIONS(3180),
    [sym_null] = ACTIONS(3180),
    [sym_undefined] = ACTIONS(3180),
    [anon_sym_AT] = ACTIONS(3180),
    [anon_sym_static] = ACTIONS(3180),
    [anon_sym_readonly] = ACTIONS(3180),
    [anon_sym_get] = ACTIONS(3180),
    [anon_sym_set] = ACTIONS(3180),
    [anon_sym_declare] = ACTIONS(3180),
    [anon_sym_public] = ACTIONS(3180),
    [anon_sym_private] = ACTIONS(3180),
    [anon_sym_protected] = ACTIONS(3180),
    [anon_sym_override] = ACTIONS(3180),
    [anon_sym_module] = ACTIONS(3180),
    [anon_sym_any] = ACTIONS(3180),
    [anon_sym_number] = ACTIONS(3180),
    [anon_sym_boolean] = ACTIONS(3180),
    [anon_sym_string] = ACTIONS(3180),
    [anon_sym_symbol] = ACTIONS(3180),
    [anon_sym_object] = ACTIONS(3180),
    [anon_sym_abstract] = ACTIONS(3180),
    [anon_sym_interface] = ACTIONS(3180),
    [anon_sym_enum] = ACTIONS(3180),
    [sym_html_comment] = ACTIONS(5),
  },
  [1236] = {
    [sym_comment] = STATE(1236),
    [sym_identifier] = ACTIONS(3184),
    [anon_sym_export] = ACTIONS(3184),
    [anon_sym_default] = ACTIONS(3184),
    [anon_sym_type] = ACTIONS(3184),
    [anon_sym_namespace] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_typeof] = ACTIONS(3184),
    [anon_sym_import] = ACTIONS(3184),
    [anon_sym_with] = ACTIONS(3184),
    [anon_sym_var] = ACTIONS(3184),
    [anon_sym_let] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3184),
    [anon_sym_await] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_try] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_debugger] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_throw] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_case] = ACTIONS(3184),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3184),
    [anon_sym_LTtemplate_GT] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_class] = ACTIONS(3184),
    [anon_sym_async] = ACTIONS(3184),
    [anon_sym_function] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_using] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_SLASH] = ACTIONS(3184),
    [anon_sym_LT] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_void] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3184),
    [sym_number] = ACTIONS(3184),
    [sym_private_property_identifier] = ACTIONS(3184),
    [sym_this] = ACTIONS(3184),
    [sym_super] = ACTIONS(3184),
    [sym_true] = ACTIONS(3184),
    [sym_false] = ACTIONS(3184),
    [sym_null] = ACTIONS(3184),
    [sym_undefined] = ACTIONS(3184),
    [anon_sym_AT] = ACTIONS(3184),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_readonly] = ACTIONS(3184),
    [anon_sym_get] = ACTIONS(3184),
    [anon_sym_set] = ACTIONS(3184),
    [anon_sym_declare] = ACTIONS(3184),
    [anon_sym_public] = ACTIONS(3184),
    [anon_sym_private] = ACTIONS(3184),
    [anon_sym_protected] = ACTIONS(3184),
    [anon_sym_override] = ACTIONS(3184),
    [anon_sym_module] = ACTIONS(3184),
    [anon_sym_any] = ACTIONS(3184),
    [anon_sym_number] = ACTIONS(3184),
    [anon_sym_boolean] = ACTIONS(3184),
    [anon_sym_string] = ACTIONS(3184),
    [anon_sym_symbol] = ACTIONS(3184),
    [anon_sym_object] = ACTIONS(3184),
    [anon_sym_abstract] = ACTIONS(3184),
    [anon_sym_interface] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [sym_html_comment] = ACTIONS(5),
  },
  [1237] = {
    [sym_comment] = STATE(1237),
    [ts_builtin_sym_end] = ACTIONS(3430),
    [sym_identifier] = ACTIONS(3156),
    [anon_sym_export] = ACTIONS(3156),
    [anon_sym_type] = ACTIONS(3156),
    [anon_sym_namespace] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_typeof] = ACTIONS(3156),
    [anon_sym_import] = ACTIONS(3156),
    [anon_sym_with] = ACTIONS(3156),
    [anon_sym_var] = ACTIONS(3156),
    [anon_sym_let] = ACTIONS(3156),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_else] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_switch] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3156),
    [anon_sym_await] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_do] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_debugger] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_throw] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_LTtemplate_GT] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_async] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_using] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_SLASH] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_void] = ACTIONS(3156),
    [anon_sym_delete] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [sym_number] = ACTIONS(3156),
    [sym_private_property_identifier] = ACTIONS(3156),
    [sym_this] = ACTIONS(3156),
    [sym_super] = ACTIONS(3156),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [sym_null] = ACTIONS(3156),
    [sym_undefined] = ACTIONS(3156),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_readonly] = ACTIONS(3156),
    [anon_sym_get] = ACTIONS(3156),
    [anon_sym_set] = ACTIONS(3156),
    [anon_sym_declare] = ACTIONS(3156),
    [anon_sym_public] = ACTIONS(3156),
    [anon_sym_private] = ACTIONS(3156),
    [anon_sym_protected] = ACTIONS(3156),
    [anon_sym_override] = ACTIONS(3156),
    [anon_sym_module] = ACTIONS(3156),
    [anon_sym_any] = ACTIONS(3156),
    [anon_sym_number] = ACTIONS(3156),
    [anon_sym_boolean] = ACTIONS(3156),
    [anon_sym_string] = ACTIONS(3156),
    [anon_sym_symbol] = ACTIONS(3156),
    [anon_sym_object] = ACTIONS(3156),
    [anon_sym_abstract] = ACTIONS(3156),
    [anon_sym_interface] = ACTIONS(3156),
    [anon_sym_enum] = ACTIONS(3156),
    [sym_html_comment] = ACTIONS(5),
  },
  [1238] = {
    [sym_comment] = STATE(1238),
    [sym_identifier] = ACTIONS(3134),
    [anon_sym_export] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_type] = ACTIONS(3134),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [anon_sym_typeof] = ACTIONS(3134),
    [anon_sym_import] = ACTIONS(3134),
    [anon_sym_with] = ACTIONS(3134),
    [anon_sym_var] = ACTIONS(3134),
    [anon_sym_let] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3134),
    [anon_sym_await] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_debugger] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_yield] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_LTtemplate_GT] = ACTIONS(3134),
    [anon_sym_DQUOTE] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_async] = ACTIONS(3134),
    [anon_sym_function] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_SLASH] = ACTIONS(3134),
    [anon_sym_LT] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_void] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_PLUS_PLUS] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3134),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3134),
    [sym_number] = ACTIONS(3134),
    [sym_private_property_identifier] = ACTIONS(3134),
    [sym_this] = ACTIONS(3134),
    [sym_super] = ACTIONS(3134),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [sym_null] = ACTIONS(3134),
    [sym_undefined] = ACTIONS(3134),
    [anon_sym_AT] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_readonly] = ACTIONS(3134),
    [anon_sym_get] = ACTIONS(3134),
    [anon_sym_set] = ACTIONS(3134),
    [anon_sym_declare] = ACTIONS(3134),
    [anon_sym_public] = ACTIONS(3134),
    [anon_sym_private] = ACTIONS(3134),
    [anon_sym_protected] = ACTIONS(3134),
    [anon_sym_override] = ACTIONS(3134),
    [anon_sym_module] = ACTIONS(3134),
    [anon_sym_any] = ACTIONS(3134),
    [anon_sym_number] = ACTIONS(3134),
    [anon_sym_boolean] = ACTIONS(3134),
    [anon_sym_string] = ACTIONS(3134),
    [anon_sym_symbol] = ACTIONS(3134),
    [anon_sym_object] = ACTIONS(3134),
    [anon_sym_abstract] = ACTIONS(3134),
    [anon_sym_interface] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [sym_html_comment] = ACTIONS(5),
  },
  [1239] = {
    [sym_comment] = STATE(1239),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_finally] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1240] = {
    [sym_comment] = STATE(1240),
    [sym_identifier] = ACTIONS(3130),
    [anon_sym_export] = ACTIONS(3130),
    [anon_sym_default] = ACTIONS(3130),
    [anon_sym_type] = ACTIONS(3130),
    [anon_sym_namespace] = ACTIONS(3130),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_typeof] = ACTIONS(3130),
    [anon_sym_import] = ACTIONS(3130),
    [anon_sym_with] = ACTIONS(3130),
    [anon_sym_var] = ACTIONS(3130),
    [anon_sym_let] = ACTIONS(3130),
    [anon_sym_const] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_if] = ACTIONS(3130),
    [anon_sym_switch] = ACTIONS(3130),
    [anon_sym_for] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [anon_sym_await] = ACTIONS(3130),
    [anon_sym_while] = ACTIONS(3130),
    [anon_sym_do] = ACTIONS(3130),
    [anon_sym_try] = ACTIONS(3130),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_continue] = ACTIONS(3130),
    [anon_sym_debugger] = ACTIONS(3130),
    [anon_sym_return] = ACTIONS(3130),
    [anon_sym_throw] = ACTIONS(3130),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_case] = ACTIONS(3130),
    [anon_sym_yield] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [anon_sym_LTtemplate_GT] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_class] = ACTIONS(3130),
    [anon_sym_async] = ACTIONS(3130),
    [anon_sym_function] = ACTIONS(3130),
    [anon_sym_new] = ACTIONS(3130),
    [anon_sym_using] = ACTIONS(3130),
    [anon_sym_PLUS] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3130),
    [anon_sym_SLASH] = ACTIONS(3130),
    [anon_sym_LT] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_void] = ACTIONS(3130),
    [anon_sym_delete] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3130),
    [sym_number] = ACTIONS(3130),
    [sym_private_property_identifier] = ACTIONS(3130),
    [sym_this] = ACTIONS(3130),
    [sym_super] = ACTIONS(3130),
    [sym_true] = ACTIONS(3130),
    [sym_false] = ACTIONS(3130),
    [sym_null] = ACTIONS(3130),
    [sym_undefined] = ACTIONS(3130),
    [anon_sym_AT] = ACTIONS(3130),
    [anon_sym_static] = ACTIONS(3130),
    [anon_sym_readonly] = ACTIONS(3130),
    [anon_sym_get] = ACTIONS(3130),
    [anon_sym_set] = ACTIONS(3130),
    [anon_sym_declare] = ACTIONS(3130),
    [anon_sym_public] = ACTIONS(3130),
    [anon_sym_private] = ACTIONS(3130),
    [anon_sym_protected] = ACTIONS(3130),
    [anon_sym_override] = ACTIONS(3130),
    [anon_sym_module] = ACTIONS(3130),
    [anon_sym_any] = ACTIONS(3130),
    [anon_sym_number] = ACTIONS(3130),
    [anon_sym_boolean] = ACTIONS(3130),
    [anon_sym_string] = ACTIONS(3130),
    [anon_sym_symbol] = ACTIONS(3130),
    [anon_sym_object] = ACTIONS(3130),
    [anon_sym_abstract] = ACTIONS(3130),
    [anon_sym_interface] = ACTIONS(3130),
    [anon_sym_enum] = ACTIONS(3130),
    [sym_html_comment] = ACTIONS(5),
  },
  [1241] = {
    [sym_comment] = STATE(1241),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_default] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_case] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1242] = {
    [sym_comment] = STATE(1242),
    [ts_builtin_sym_end] = ACTIONS(3432),
    [sym_identifier] = ACTIONS(3166),
    [anon_sym_export] = ACTIONS(3166),
    [anon_sym_type] = ACTIONS(3166),
    [anon_sym_namespace] = ACTIONS(3166),
    [anon_sym_LBRACE] = ACTIONS(3166),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [anon_sym_typeof] = ACTIONS(3166),
    [anon_sym_import] = ACTIONS(3166),
    [anon_sym_with] = ACTIONS(3166),
    [anon_sym_var] = ACTIONS(3166),
    [anon_sym_let] = ACTIONS(3166),
    [anon_sym_const] = ACTIONS(3166),
    [anon_sym_BANG] = ACTIONS(3166),
    [anon_sym_else] = ACTIONS(3166),
    [anon_sym_if] = ACTIONS(3166),
    [anon_sym_switch] = ACTIONS(3166),
    [anon_sym_for] = ACTIONS(3166),
    [anon_sym_LPAREN] = ACTIONS(3166),
    [anon_sym_await] = ACTIONS(3166),
    [anon_sym_while] = ACTIONS(3166),
    [anon_sym_do] = ACTIONS(3166),
    [anon_sym_try] = ACTIONS(3166),
    [anon_sym_break] = ACTIONS(3166),
    [anon_sym_continue] = ACTIONS(3166),
    [anon_sym_debugger] = ACTIONS(3166),
    [anon_sym_return] = ACTIONS(3166),
    [anon_sym_throw] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym_yield] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [anon_sym_LTtemplate_GT] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [anon_sym_SQUOTE] = ACTIONS(3166),
    [anon_sym_class] = ACTIONS(3166),
    [anon_sym_async] = ACTIONS(3166),
    [anon_sym_function] = ACTIONS(3166),
    [anon_sym_new] = ACTIONS(3166),
    [anon_sym_using] = ACTIONS(3166),
    [anon_sym_PLUS] = ACTIONS(3166),
    [anon_sym_DASH] = ACTIONS(3166),
    [anon_sym_SLASH] = ACTIONS(3166),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_void] = ACTIONS(3166),
    [anon_sym_delete] = ACTIONS(3166),
    [anon_sym_PLUS_PLUS] = ACTIONS(3166),
    [anon_sym_DASH_DASH] = ACTIONS(3166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3166),
    [sym_number] = ACTIONS(3166),
    [sym_private_property_identifier] = ACTIONS(3166),
    [sym_this] = ACTIONS(3166),
    [sym_super] = ACTIONS(3166),
    [sym_true] = ACTIONS(3166),
    [sym_false] = ACTIONS(3166),
    [sym_null] = ACTIONS(3166),
    [sym_undefined] = ACTIONS(3166),
    [anon_sym_AT] = ACTIONS(3166),
    [anon_sym_static] = ACTIONS(3166),
    [anon_sym_readonly] = ACTIONS(3166),
    [anon_sym_get] = ACTIONS(3166),
    [anon_sym_set] = ACTIONS(3166),
    [anon_sym_declare] = ACTIONS(3166),
    [anon_sym_public] = ACTIONS(3166),
    [anon_sym_private] = ACTIONS(3166),
    [anon_sym_protected] = ACTIONS(3166),
    [anon_sym_override] = ACTIONS(3166),
    [anon_sym_module] = ACTIONS(3166),
    [anon_sym_any] = ACTIONS(3166),
    [anon_sym_number] = ACTIONS(3166),
    [anon_sym_boolean] = ACTIONS(3166),
    [anon_sym_string] = ACTIONS(3166),
    [anon_sym_symbol] = ACTIONS(3166),
    [anon_sym_object] = ACTIONS(3166),
    [anon_sym_abstract] = ACTIONS(3166),
    [anon_sym_interface] = ACTIONS(3166),
    [anon_sym_enum] = ACTIONS(3166),
    [sym_html_comment] = ACTIONS(5),
  },
  [1243] = {
    [sym_comment] = STATE(1243),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1244] = {
    [sym_comment] = STATE(1244),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_export] = ACTIONS(3274),
    [anon_sym_default] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_namespace] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_typeof] = ACTIONS(3274),
    [anon_sym_import] = ACTIONS(3274),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_var] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_const] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_switch] = ACTIONS(3274),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_await] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_break] = ACTIONS(3274),
    [anon_sym_continue] = ACTIONS(3274),
    [anon_sym_debugger] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_throw] = ACTIONS(3274),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_case] = ACTIONS(3274),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LTtemplate_GT] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_SQUOTE] = ACTIONS(3274),
    [anon_sym_class] = ACTIONS(3274),
    [anon_sym_async] = ACTIONS(3274),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_using] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_SLASH] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_void] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3274),
    [sym_number] = ACTIONS(3274),
    [sym_private_property_identifier] = ACTIONS(3274),
    [sym_this] = ACTIONS(3274),
    [sym_super] = ACTIONS(3274),
    [sym_true] = ACTIONS(3274),
    [sym_false] = ACTIONS(3274),
    [sym_null] = ACTIONS(3274),
    [sym_undefined] = ACTIONS(3274),
    [anon_sym_AT] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3274),
    [anon_sym_readonly] = ACTIONS(3274),
    [anon_sym_get] = ACTIONS(3274),
    [anon_sym_set] = ACTIONS(3274),
    [anon_sym_declare] = ACTIONS(3274),
    [anon_sym_public] = ACTIONS(3274),
    [anon_sym_private] = ACTIONS(3274),
    [anon_sym_protected] = ACTIONS(3274),
    [anon_sym_override] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_any] = ACTIONS(3274),
    [anon_sym_number] = ACTIONS(3274),
    [anon_sym_boolean] = ACTIONS(3274),
    [anon_sym_string] = ACTIONS(3274),
    [anon_sym_symbol] = ACTIONS(3274),
    [anon_sym_object] = ACTIONS(3274),
    [anon_sym_abstract] = ACTIONS(3274),
    [anon_sym_interface] = ACTIONS(3274),
    [anon_sym_enum] = ACTIONS(3274),
    [sym_html_comment] = ACTIONS(5),
  },
  [1245] = {
    [sym_comment] = STATE(1245),
    [sym_identifier] = ACTIONS(3434),
    [anon_sym_export] = ACTIONS(3434),
    [anon_sym_default] = ACTIONS(3434),
    [anon_sym_type] = ACTIONS(3434),
    [anon_sym_namespace] = ACTIONS(3434),
    [anon_sym_LBRACE] = ACTIONS(3434),
    [anon_sym_RBRACE] = ACTIONS(3434),
    [anon_sym_typeof] = ACTIONS(3434),
    [anon_sym_import] = ACTIONS(3434),
    [anon_sym_with] = ACTIONS(3434),
    [anon_sym_var] = ACTIONS(3434),
    [anon_sym_let] = ACTIONS(3434),
    [anon_sym_const] = ACTIONS(3434),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_if] = ACTIONS(3434),
    [anon_sym_switch] = ACTIONS(3434),
    [anon_sym_for] = ACTIONS(3434),
    [anon_sym_LPAREN] = ACTIONS(3434),
    [anon_sym_await] = ACTIONS(3434),
    [anon_sym_while] = ACTIONS(3434),
    [anon_sym_do] = ACTIONS(3434),
    [anon_sym_try] = ACTIONS(3434),
    [anon_sym_break] = ACTIONS(3434),
    [anon_sym_continue] = ACTIONS(3434),
    [anon_sym_debugger] = ACTIONS(3434),
    [anon_sym_return] = ACTIONS(3434),
    [anon_sym_throw] = ACTIONS(3434),
    [anon_sym_SEMI] = ACTIONS(3434),
    [anon_sym_case] = ACTIONS(3434),
    [anon_sym_yield] = ACTIONS(3434),
    [anon_sym_LBRACK] = ACTIONS(3434),
    [anon_sym_LTtemplate_GT] = ACTIONS(3434),
    [anon_sym_DQUOTE] = ACTIONS(3434),
    [anon_sym_SQUOTE] = ACTIONS(3434),
    [anon_sym_class] = ACTIONS(3434),
    [anon_sym_async] = ACTIONS(3434),
    [anon_sym_function] = ACTIONS(3434),
    [anon_sym_new] = ACTIONS(3434),
    [anon_sym_using] = ACTIONS(3434),
    [anon_sym_PLUS] = ACTIONS(3434),
    [anon_sym_DASH] = ACTIONS(3434),
    [anon_sym_SLASH] = ACTIONS(3434),
    [anon_sym_LT] = ACTIONS(3434),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_void] = ACTIONS(3434),
    [anon_sym_delete] = ACTIONS(3434),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3434),
    [sym_number] = ACTIONS(3434),
    [sym_private_property_identifier] = ACTIONS(3434),
    [sym_this] = ACTIONS(3434),
    [sym_super] = ACTIONS(3434),
    [sym_true] = ACTIONS(3434),
    [sym_false] = ACTIONS(3434),
    [sym_null] = ACTIONS(3434),
    [sym_undefined] = ACTIONS(3434),
    [anon_sym_AT] = ACTIONS(3434),
    [anon_sym_static] = ACTIONS(3434),
    [anon_sym_readonly] = ACTIONS(3434),
    [anon_sym_get] = ACTIONS(3434),
    [anon_sym_set] = ACTIONS(3434),
    [anon_sym_declare] = ACTIONS(3434),
    [anon_sym_public] = ACTIONS(3434),
    [anon_sym_private] = ACTIONS(3434),
    [anon_sym_protected] = ACTIONS(3434),
    [anon_sym_override] = ACTIONS(3434),
    [anon_sym_module] = ACTIONS(3434),
    [anon_sym_any] = ACTIONS(3434),
    [anon_sym_number] = ACTIONS(3434),
    [anon_sym_boolean] = ACTIONS(3434),
    [anon_sym_string] = ACTIONS(3434),
    [anon_sym_symbol] = ACTIONS(3434),
    [anon_sym_object] = ACTIONS(3434),
    [anon_sym_abstract] = ACTIONS(3434),
    [anon_sym_interface] = ACTIONS(3434),
    [anon_sym_enum] = ACTIONS(3434),
    [sym_html_comment] = ACTIONS(5),
  },
  [1246] = {
    [sym_comment] = STATE(1246),
    [sym_identifier] = ACTIONS(3258),
    [anon_sym_export] = ACTIONS(3258),
    [anon_sym_default] = ACTIONS(3258),
    [anon_sym_type] = ACTIONS(3258),
    [anon_sym_namespace] = ACTIONS(3258),
    [anon_sym_LBRACE] = ACTIONS(3258),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_typeof] = ACTIONS(3258),
    [anon_sym_import] = ACTIONS(3258),
    [anon_sym_with] = ACTIONS(3258),
    [anon_sym_var] = ACTIONS(3258),
    [anon_sym_let] = ACTIONS(3258),
    [anon_sym_const] = ACTIONS(3258),
    [anon_sym_BANG] = ACTIONS(3258),
    [anon_sym_if] = ACTIONS(3258),
    [anon_sym_switch] = ACTIONS(3258),
    [anon_sym_for] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [anon_sym_await] = ACTIONS(3258),
    [anon_sym_while] = ACTIONS(3258),
    [anon_sym_do] = ACTIONS(3258),
    [anon_sym_try] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3258),
    [anon_sym_continue] = ACTIONS(3258),
    [anon_sym_debugger] = ACTIONS(3258),
    [anon_sym_return] = ACTIONS(3258),
    [anon_sym_throw] = ACTIONS(3258),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_case] = ACTIONS(3258),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_LTtemplate_GT] = ACTIONS(3258),
    [anon_sym_DQUOTE] = ACTIONS(3258),
    [anon_sym_SQUOTE] = ACTIONS(3258),
    [anon_sym_class] = ACTIONS(3258),
    [anon_sym_async] = ACTIONS(3258),
    [anon_sym_function] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3258),
    [anon_sym_using] = ACTIONS(3258),
    [anon_sym_PLUS] = ACTIONS(3258),
    [anon_sym_DASH] = ACTIONS(3258),
    [anon_sym_SLASH] = ACTIONS(3258),
    [anon_sym_LT] = ACTIONS(3258),
    [anon_sym_TILDE] = ACTIONS(3258),
    [anon_sym_void] = ACTIONS(3258),
    [anon_sym_delete] = ACTIONS(3258),
    [anon_sym_PLUS_PLUS] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3258),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [sym_number] = ACTIONS(3258),
    [sym_private_property_identifier] = ACTIONS(3258),
    [sym_this] = ACTIONS(3258),
    [sym_super] = ACTIONS(3258),
    [sym_true] = ACTIONS(3258),
    [sym_false] = ACTIONS(3258),
    [sym_null] = ACTIONS(3258),
    [sym_undefined] = ACTIONS(3258),
    [anon_sym_AT] = ACTIONS(3258),
    [anon_sym_static] = ACTIONS(3258),
    [anon_sym_readonly] = ACTIONS(3258),
    [anon_sym_get] = ACTIONS(3258),
    [anon_sym_set] = ACTIONS(3258),
    [anon_sym_declare] = ACTIONS(3258),
    [anon_sym_public] = ACTIONS(3258),
    [anon_sym_private] = ACTIONS(3258),
    [anon_sym_protected] = ACTIONS(3258),
    [anon_sym_override] = ACTIONS(3258),
    [anon_sym_module] = ACTIONS(3258),
    [anon_sym_any] = ACTIONS(3258),
    [anon_sym_number] = ACTIONS(3258),
    [anon_sym_boolean] = ACTIONS(3258),
    [anon_sym_string] = ACTIONS(3258),
    [anon_sym_symbol] = ACTIONS(3258),
    [anon_sym_object] = ACTIONS(3258),
    [anon_sym_abstract] = ACTIONS(3258),
    [anon_sym_interface] = ACTIONS(3258),
    [anon_sym_enum] = ACTIONS(3258),
    [sym_html_comment] = ACTIONS(5),
  },
  [1247] = {
    [sym_comment] = STATE(1247),
    [ts_builtin_sym_end] = ACTIONS(3436),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_export] = ACTIONS(3154),
    [anon_sym_type] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_typeof] = ACTIONS(3154),
    [anon_sym_import] = ACTIONS(3154),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_var] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_else] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_await] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_debugger] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LTtemplate_GT] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_async] = ACTIONS(3154),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_SLASH] = ACTIONS(3154),
    [anon_sym_LT] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_void] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3154),
    [sym_number] = ACTIONS(3154),
    [sym_private_property_identifier] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
    [sym_super] = ACTIONS(3154),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [sym_null] = ACTIONS(3154),
    [sym_undefined] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_readonly] = ACTIONS(3154),
    [anon_sym_get] = ACTIONS(3154),
    [anon_sym_set] = ACTIONS(3154),
    [anon_sym_declare] = ACTIONS(3154),
    [anon_sym_public] = ACTIONS(3154),
    [anon_sym_private] = ACTIONS(3154),
    [anon_sym_protected] = ACTIONS(3154),
    [anon_sym_override] = ACTIONS(3154),
    [anon_sym_module] = ACTIONS(3154),
    [anon_sym_any] = ACTIONS(3154),
    [anon_sym_number] = ACTIONS(3154),
    [anon_sym_boolean] = ACTIONS(3154),
    [anon_sym_string] = ACTIONS(3154),
    [anon_sym_symbol] = ACTIONS(3154),
    [anon_sym_object] = ACTIONS(3154),
    [anon_sym_abstract] = ACTIONS(3154),
    [anon_sym_interface] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [sym_html_comment] = ACTIONS(5),
  },
  [1248] = {
    [sym_comment] = STATE(1248),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_export] = ACTIONS(3262),
    [anon_sym_default] = ACTIONS(3262),
    [anon_sym_type] = ACTIONS(3262),
    [anon_sym_namespace] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_typeof] = ACTIONS(3262),
    [anon_sym_import] = ACTIONS(3262),
    [anon_sym_with] = ACTIONS(3262),
    [anon_sym_var] = ACTIONS(3262),
    [anon_sym_let] = ACTIONS(3262),
    [anon_sym_const] = ACTIONS(3262),
    [anon_sym_BANG] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_await] = ACTIONS(3262),
    [anon_sym_while] = ACTIONS(3262),
    [anon_sym_do] = ACTIONS(3262),
    [anon_sym_try] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_debugger] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_throw] = ACTIONS(3262),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_case] = ACTIONS(3262),
    [anon_sym_yield] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_LTtemplate_GT] = ACTIONS(3262),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [anon_sym_class] = ACTIONS(3262),
    [anon_sym_async] = ACTIONS(3262),
    [anon_sym_function] = ACTIONS(3262),
    [anon_sym_new] = ACTIONS(3262),
    [anon_sym_using] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_SLASH] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3262),
    [anon_sym_TILDE] = ACTIONS(3262),
    [anon_sym_void] = ACTIONS(3262),
    [anon_sym_delete] = ACTIONS(3262),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3262),
    [sym_number] = ACTIONS(3262),
    [sym_private_property_identifier] = ACTIONS(3262),
    [sym_this] = ACTIONS(3262),
    [sym_super] = ACTIONS(3262),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_null] = ACTIONS(3262),
    [sym_undefined] = ACTIONS(3262),
    [anon_sym_AT] = ACTIONS(3262),
    [anon_sym_static] = ACTIONS(3262),
    [anon_sym_readonly] = ACTIONS(3262),
    [anon_sym_get] = ACTIONS(3262),
    [anon_sym_set] = ACTIONS(3262),
    [anon_sym_declare] = ACTIONS(3262),
    [anon_sym_public] = ACTIONS(3262),
    [anon_sym_private] = ACTIONS(3262),
    [anon_sym_protected] = ACTIONS(3262),
    [anon_sym_override] = ACTIONS(3262),
    [anon_sym_module] = ACTIONS(3262),
    [anon_sym_any] = ACTIONS(3262),
    [anon_sym_number] = ACTIONS(3262),
    [anon_sym_boolean] = ACTIONS(3262),
    [anon_sym_string] = ACTIONS(3262),
    [anon_sym_symbol] = ACTIONS(3262),
    [anon_sym_object] = ACTIONS(3262),
    [anon_sym_abstract] = ACTIONS(3262),
    [anon_sym_interface] = ACTIONS(3262),
    [anon_sym_enum] = ACTIONS(3262),
    [sym_html_comment] = ACTIONS(5),
  },
  [1249] = {
    [sym_comment] = STATE(1249),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_default] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_case] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1250] = {
    [sym_comment] = STATE(1250),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_default] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_case] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1251] = {
    [sym_comment] = STATE(1251),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_export] = ACTIONS(3266),
    [anon_sym_default] = ACTIONS(3266),
    [anon_sym_type] = ACTIONS(3266),
    [anon_sym_namespace] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_typeof] = ACTIONS(3266),
    [anon_sym_import] = ACTIONS(3266),
    [anon_sym_with] = ACTIONS(3266),
    [anon_sym_var] = ACTIONS(3266),
    [anon_sym_let] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_await] = ACTIONS(3266),
    [anon_sym_while] = ACTIONS(3266),
    [anon_sym_do] = ACTIONS(3266),
    [anon_sym_try] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_debugger] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_throw] = ACTIONS(3266),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_case] = ACTIONS(3266),
    [anon_sym_yield] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_LTtemplate_GT] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_class] = ACTIONS(3266),
    [anon_sym_async] = ACTIONS(3266),
    [anon_sym_function] = ACTIONS(3266),
    [anon_sym_new] = ACTIONS(3266),
    [anon_sym_using] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_SLASH] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_void] = ACTIONS(3266),
    [anon_sym_delete] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3266),
    [sym_number] = ACTIONS(3266),
    [sym_private_property_identifier] = ACTIONS(3266),
    [sym_this] = ACTIONS(3266),
    [sym_super] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_null] = ACTIONS(3266),
    [sym_undefined] = ACTIONS(3266),
    [anon_sym_AT] = ACTIONS(3266),
    [anon_sym_static] = ACTIONS(3266),
    [anon_sym_readonly] = ACTIONS(3266),
    [anon_sym_get] = ACTIONS(3266),
    [anon_sym_set] = ACTIONS(3266),
    [anon_sym_declare] = ACTIONS(3266),
    [anon_sym_public] = ACTIONS(3266),
    [anon_sym_private] = ACTIONS(3266),
    [anon_sym_protected] = ACTIONS(3266),
    [anon_sym_override] = ACTIONS(3266),
    [anon_sym_module] = ACTIONS(3266),
    [anon_sym_any] = ACTIONS(3266),
    [anon_sym_number] = ACTIONS(3266),
    [anon_sym_boolean] = ACTIONS(3266),
    [anon_sym_string] = ACTIONS(3266),
    [anon_sym_symbol] = ACTIONS(3266),
    [anon_sym_object] = ACTIONS(3266),
    [anon_sym_abstract] = ACTIONS(3266),
    [anon_sym_interface] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [sym_html_comment] = ACTIONS(5),
  },
  [1252] = {
    [sym_comment] = STATE(1252),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_finally] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1253] = {
    [sym_comment] = STATE(1253),
    [ts_builtin_sym_end] = ACTIONS(3438),
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_export] = ACTIONS(3176),
    [anon_sym_type] = ACTIONS(3176),
    [anon_sym_namespace] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3176),
    [anon_sym_RBRACE] = ACTIONS(3176),
    [anon_sym_typeof] = ACTIONS(3176),
    [anon_sym_import] = ACTIONS(3176),
    [anon_sym_with] = ACTIONS(3176),
    [anon_sym_var] = ACTIONS(3176),
    [anon_sym_let] = ACTIONS(3176),
    [anon_sym_const] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_else] = ACTIONS(3176),
    [anon_sym_if] = ACTIONS(3176),
    [anon_sym_switch] = ACTIONS(3176),
    [anon_sym_for] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(3176),
    [anon_sym_await] = ACTIONS(3176),
    [anon_sym_while] = ACTIONS(3176),
    [anon_sym_do] = ACTIONS(3176),
    [anon_sym_try] = ACTIONS(3176),
    [anon_sym_break] = ACTIONS(3176),
    [anon_sym_continue] = ACTIONS(3176),
    [anon_sym_debugger] = ACTIONS(3176),
    [anon_sym_return] = ACTIONS(3176),
    [anon_sym_throw] = ACTIONS(3176),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym_yield] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_LTtemplate_GT] = ACTIONS(3176),
    [anon_sym_DQUOTE] = ACTIONS(3176),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym_class] = ACTIONS(3176),
    [anon_sym_async] = ACTIONS(3176),
    [anon_sym_function] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3176),
    [anon_sym_using] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_SLASH] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3176),
    [anon_sym_TILDE] = ACTIONS(3176),
    [anon_sym_void] = ACTIONS(3176),
    [anon_sym_delete] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3176),
    [sym_number] = ACTIONS(3176),
    [sym_private_property_identifier] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_super] = ACTIONS(3176),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [sym_null] = ACTIONS(3176),
    [sym_undefined] = ACTIONS(3176),
    [anon_sym_AT] = ACTIONS(3176),
    [anon_sym_static] = ACTIONS(3176),
    [anon_sym_readonly] = ACTIONS(3176),
    [anon_sym_get] = ACTIONS(3176),
    [anon_sym_set] = ACTIONS(3176),
    [anon_sym_declare] = ACTIONS(3176),
    [anon_sym_public] = ACTIONS(3176),
    [anon_sym_private] = ACTIONS(3176),
    [anon_sym_protected] = ACTIONS(3176),
    [anon_sym_override] = ACTIONS(3176),
    [anon_sym_module] = ACTIONS(3176),
    [anon_sym_any] = ACTIONS(3176),
    [anon_sym_number] = ACTIONS(3176),
    [anon_sym_boolean] = ACTIONS(3176),
    [anon_sym_string] = ACTIONS(3176),
    [anon_sym_symbol] = ACTIONS(3176),
    [anon_sym_object] = ACTIONS(3176),
    [anon_sym_abstract] = ACTIONS(3176),
    [anon_sym_interface] = ACTIONS(3176),
    [anon_sym_enum] = ACTIONS(3176),
    [sym_html_comment] = ACTIONS(5),
  },
  [1254] = {
    [sym_comment] = STATE(1254),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [sym_identifier] = ACTIONS(3272),
    [anon_sym_export] = ACTIONS(3272),
    [anon_sym_type] = ACTIONS(3272),
    [anon_sym_namespace] = ACTIONS(3272),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_typeof] = ACTIONS(3272),
    [anon_sym_import] = ACTIONS(3272),
    [anon_sym_with] = ACTIONS(3272),
    [anon_sym_var] = ACTIONS(3272),
    [anon_sym_let] = ACTIONS(3272),
    [anon_sym_const] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_else] = ACTIONS(3272),
    [anon_sym_if] = ACTIONS(3272),
    [anon_sym_switch] = ACTIONS(3272),
    [anon_sym_for] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3272),
    [anon_sym_await] = ACTIONS(3272),
    [anon_sym_while] = ACTIONS(3272),
    [anon_sym_do] = ACTIONS(3272),
    [anon_sym_try] = ACTIONS(3272),
    [anon_sym_break] = ACTIONS(3272),
    [anon_sym_continue] = ACTIONS(3272),
    [anon_sym_debugger] = ACTIONS(3272),
    [anon_sym_return] = ACTIONS(3272),
    [anon_sym_throw] = ACTIONS(3272),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym_yield] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_LTtemplate_GT] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_class] = ACTIONS(3272),
    [anon_sym_async] = ACTIONS(3272),
    [anon_sym_function] = ACTIONS(3272),
    [anon_sym_new] = ACTIONS(3272),
    [anon_sym_using] = ACTIONS(3272),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_SLASH] = ACTIONS(3272),
    [anon_sym_LT] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_void] = ACTIONS(3272),
    [anon_sym_delete] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3272),
    [sym_number] = ACTIONS(3272),
    [sym_private_property_identifier] = ACTIONS(3272),
    [sym_this] = ACTIONS(3272),
    [sym_super] = ACTIONS(3272),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_undefined] = ACTIONS(3272),
    [anon_sym_AT] = ACTIONS(3272),
    [anon_sym_static] = ACTIONS(3272),
    [anon_sym_readonly] = ACTIONS(3272),
    [anon_sym_get] = ACTIONS(3272),
    [anon_sym_set] = ACTIONS(3272),
    [anon_sym_declare] = ACTIONS(3272),
    [anon_sym_public] = ACTIONS(3272),
    [anon_sym_private] = ACTIONS(3272),
    [anon_sym_protected] = ACTIONS(3272),
    [anon_sym_override] = ACTIONS(3272),
    [anon_sym_module] = ACTIONS(3272),
    [anon_sym_any] = ACTIONS(3272),
    [anon_sym_number] = ACTIONS(3272),
    [anon_sym_boolean] = ACTIONS(3272),
    [anon_sym_string] = ACTIONS(3272),
    [anon_sym_symbol] = ACTIONS(3272),
    [anon_sym_object] = ACTIONS(3272),
    [anon_sym_abstract] = ACTIONS(3272),
    [anon_sym_interface] = ACTIONS(3272),
    [anon_sym_enum] = ACTIONS(3272),
    [sym_html_comment] = ACTIONS(5),
  },
  [1255] = {
    [sym_comment] = STATE(1255),
    [ts_builtin_sym_end] = ACTIONS(3442),
    [sym_identifier] = ACTIONS(3178),
    [anon_sym_export] = ACTIONS(3178),
    [anon_sym_type] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_RBRACE] = ACTIONS(3178),
    [anon_sym_typeof] = ACTIONS(3178),
    [anon_sym_import] = ACTIONS(3178),
    [anon_sym_with] = ACTIONS(3178),
    [anon_sym_var] = ACTIONS(3178),
    [anon_sym_let] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_BANG] = ACTIONS(3178),
    [anon_sym_else] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_LPAREN] = ACTIONS(3178),
    [anon_sym_await] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_debugger] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_yield] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_LTtemplate_GT] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_SQUOTE] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_async] = ACTIONS(3178),
    [anon_sym_function] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_SLASH] = ACTIONS(3178),
    [anon_sym_LT] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3178),
    [anon_sym_void] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_PLUS_PLUS] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [sym_number] = ACTIONS(3178),
    [sym_private_property_identifier] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
    [sym_super] = ACTIONS(3178),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [sym_null] = ACTIONS(3178),
    [sym_undefined] = ACTIONS(3178),
    [anon_sym_AT] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_readonly] = ACTIONS(3178),
    [anon_sym_get] = ACTIONS(3178),
    [anon_sym_set] = ACTIONS(3178),
    [anon_sym_declare] = ACTIONS(3178),
    [anon_sym_public] = ACTIONS(3178),
    [anon_sym_private] = ACTIONS(3178),
    [anon_sym_protected] = ACTIONS(3178),
    [anon_sym_override] = ACTIONS(3178),
    [anon_sym_module] = ACTIONS(3178),
    [anon_sym_any] = ACTIONS(3178),
    [anon_sym_number] = ACTIONS(3178),
    [anon_sym_boolean] = ACTIONS(3178),
    [anon_sym_string] = ACTIONS(3178),
    [anon_sym_symbol] = ACTIONS(3178),
    [anon_sym_object] = ACTIONS(3178),
    [anon_sym_abstract] = ACTIONS(3178),
    [anon_sym_interface] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [sym_html_comment] = ACTIONS(5),
  },
  [1256] = {
    [sym_comment] = STATE(1256),
    [sym_identifier] = ACTIONS(3232),
    [anon_sym_export] = ACTIONS(3232),
    [anon_sym_default] = ACTIONS(3232),
    [anon_sym_type] = ACTIONS(3232),
    [anon_sym_namespace] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [anon_sym_typeof] = ACTIONS(3232),
    [anon_sym_import] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3232),
    [anon_sym_var] = ACTIONS(3232),
    [anon_sym_let] = ACTIONS(3232),
    [anon_sym_const] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_if] = ACTIONS(3232),
    [anon_sym_switch] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3232),
    [anon_sym_await] = ACTIONS(3232),
    [anon_sym_while] = ACTIONS(3232),
    [anon_sym_do] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3232),
    [anon_sym_break] = ACTIONS(3232),
    [anon_sym_continue] = ACTIONS(3232),
    [anon_sym_debugger] = ACTIONS(3232),
    [anon_sym_return] = ACTIONS(3232),
    [anon_sym_throw] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym_case] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3232),
    [anon_sym_LBRACK] = ACTIONS(3232),
    [anon_sym_LTtemplate_GT] = ACTIONS(3232),
    [anon_sym_DQUOTE] = ACTIONS(3232),
    [anon_sym_SQUOTE] = ACTIONS(3232),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_async] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3232),
    [anon_sym_using] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3232),
    [anon_sym_SLASH] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_void] = ACTIONS(3232),
    [anon_sym_delete] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3232),
    [sym_number] = ACTIONS(3232),
    [sym_private_property_identifier] = ACTIONS(3232),
    [sym_this] = ACTIONS(3232),
    [sym_super] = ACTIONS(3232),
    [sym_true] = ACTIONS(3232),
    [sym_false] = ACTIONS(3232),
    [sym_null] = ACTIONS(3232),
    [sym_undefined] = ACTIONS(3232),
    [anon_sym_AT] = ACTIONS(3232),
    [anon_sym_static] = ACTIONS(3232),
    [anon_sym_readonly] = ACTIONS(3232),
    [anon_sym_get] = ACTIONS(3232),
    [anon_sym_set] = ACTIONS(3232),
    [anon_sym_declare] = ACTIONS(3232),
    [anon_sym_public] = ACTIONS(3232),
    [anon_sym_private] = ACTIONS(3232),
    [anon_sym_protected] = ACTIONS(3232),
    [anon_sym_override] = ACTIONS(3232),
    [anon_sym_module] = ACTIONS(3232),
    [anon_sym_any] = ACTIONS(3232),
    [anon_sym_number] = ACTIONS(3232),
    [anon_sym_boolean] = ACTIONS(3232),
    [anon_sym_string] = ACTIONS(3232),
    [anon_sym_symbol] = ACTIONS(3232),
    [anon_sym_object] = ACTIONS(3232),
    [anon_sym_abstract] = ACTIONS(3232),
    [anon_sym_interface] = ACTIONS(3232),
    [anon_sym_enum] = ACTIONS(3232),
    [sym_html_comment] = ACTIONS(5),
  },
  [1257] = {
    [sym_comment] = STATE(1257),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [sym_identifier] = ACTIONS(3272),
    [anon_sym_export] = ACTIONS(3272),
    [anon_sym_type] = ACTIONS(3272),
    [anon_sym_namespace] = ACTIONS(3272),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_typeof] = ACTIONS(3272),
    [anon_sym_import] = ACTIONS(3272),
    [anon_sym_with] = ACTIONS(3272),
    [anon_sym_var] = ACTIONS(3272),
    [anon_sym_let] = ACTIONS(3272),
    [anon_sym_const] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_else] = ACTIONS(3272),
    [anon_sym_if] = ACTIONS(3272),
    [anon_sym_switch] = ACTIONS(3272),
    [anon_sym_for] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3272),
    [anon_sym_await] = ACTIONS(3272),
    [anon_sym_while] = ACTIONS(3272),
    [anon_sym_do] = ACTIONS(3272),
    [anon_sym_try] = ACTIONS(3272),
    [anon_sym_break] = ACTIONS(3272),
    [anon_sym_continue] = ACTIONS(3272),
    [anon_sym_debugger] = ACTIONS(3272),
    [anon_sym_return] = ACTIONS(3272),
    [anon_sym_throw] = ACTIONS(3272),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym_yield] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_LTtemplate_GT] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_class] = ACTIONS(3272),
    [anon_sym_async] = ACTIONS(3272),
    [anon_sym_function] = ACTIONS(3272),
    [anon_sym_new] = ACTIONS(3272),
    [anon_sym_using] = ACTIONS(3272),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_SLASH] = ACTIONS(3272),
    [anon_sym_LT] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_void] = ACTIONS(3272),
    [anon_sym_delete] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3272),
    [sym_number] = ACTIONS(3272),
    [sym_private_property_identifier] = ACTIONS(3272),
    [sym_this] = ACTIONS(3272),
    [sym_super] = ACTIONS(3272),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_undefined] = ACTIONS(3272),
    [anon_sym_AT] = ACTIONS(3272),
    [anon_sym_static] = ACTIONS(3272),
    [anon_sym_readonly] = ACTIONS(3272),
    [anon_sym_get] = ACTIONS(3272),
    [anon_sym_set] = ACTIONS(3272),
    [anon_sym_declare] = ACTIONS(3272),
    [anon_sym_public] = ACTIONS(3272),
    [anon_sym_private] = ACTIONS(3272),
    [anon_sym_protected] = ACTIONS(3272),
    [anon_sym_override] = ACTIONS(3272),
    [anon_sym_module] = ACTIONS(3272),
    [anon_sym_any] = ACTIONS(3272),
    [anon_sym_number] = ACTIONS(3272),
    [anon_sym_boolean] = ACTIONS(3272),
    [anon_sym_string] = ACTIONS(3272),
    [anon_sym_symbol] = ACTIONS(3272),
    [anon_sym_object] = ACTIONS(3272),
    [anon_sym_abstract] = ACTIONS(3272),
    [anon_sym_interface] = ACTIONS(3272),
    [anon_sym_enum] = ACTIONS(3272),
    [sym_html_comment] = ACTIONS(5),
  },
  [1258] = {
    [sym_comment] = STATE(1258),
    [sym_identifier] = ACTIONS(3268),
    [anon_sym_export] = ACTIONS(3268),
    [anon_sym_default] = ACTIONS(3268),
    [anon_sym_type] = ACTIONS(3268),
    [anon_sym_namespace] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3268),
    [anon_sym_typeof] = ACTIONS(3268),
    [anon_sym_import] = ACTIONS(3268),
    [anon_sym_with] = ACTIONS(3268),
    [anon_sym_var] = ACTIONS(3268),
    [anon_sym_let] = ACTIONS(3268),
    [anon_sym_const] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_if] = ACTIONS(3268),
    [anon_sym_switch] = ACTIONS(3268),
    [anon_sym_for] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3268),
    [anon_sym_await] = ACTIONS(3268),
    [anon_sym_while] = ACTIONS(3268),
    [anon_sym_do] = ACTIONS(3268),
    [anon_sym_try] = ACTIONS(3268),
    [anon_sym_break] = ACTIONS(3268),
    [anon_sym_continue] = ACTIONS(3268),
    [anon_sym_debugger] = ACTIONS(3268),
    [anon_sym_return] = ACTIONS(3268),
    [anon_sym_throw] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_case] = ACTIONS(3268),
    [anon_sym_yield] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_LTtemplate_GT] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_class] = ACTIONS(3268),
    [anon_sym_async] = ACTIONS(3268),
    [anon_sym_function] = ACTIONS(3268),
    [anon_sym_new] = ACTIONS(3268),
    [anon_sym_using] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_void] = ACTIONS(3268),
    [anon_sym_delete] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3268),
    [sym_number] = ACTIONS(3268),
    [sym_private_property_identifier] = ACTIONS(3268),
    [sym_this] = ACTIONS(3268),
    [sym_super] = ACTIONS(3268),
    [sym_true] = ACTIONS(3268),
    [sym_false] = ACTIONS(3268),
    [sym_null] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_AT] = ACTIONS(3268),
    [anon_sym_static] = ACTIONS(3268),
    [anon_sym_readonly] = ACTIONS(3268),
    [anon_sym_get] = ACTIONS(3268),
    [anon_sym_set] = ACTIONS(3268),
    [anon_sym_declare] = ACTIONS(3268),
    [anon_sym_public] = ACTIONS(3268),
    [anon_sym_private] = ACTIONS(3268),
    [anon_sym_protected] = ACTIONS(3268),
    [anon_sym_override] = ACTIONS(3268),
    [anon_sym_module] = ACTIONS(3268),
    [anon_sym_any] = ACTIONS(3268),
    [anon_sym_number] = ACTIONS(3268),
    [anon_sym_boolean] = ACTIONS(3268),
    [anon_sym_string] = ACTIONS(3268),
    [anon_sym_symbol] = ACTIONS(3268),
    [anon_sym_object] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(3268),
    [anon_sym_interface] = ACTIONS(3268),
    [anon_sym_enum] = ACTIONS(3268),
    [sym_html_comment] = ACTIONS(5),
  },
  [1259] = {
    [sym_comment] = STATE(1259),
    [sym_identifier] = ACTIONS(3268),
    [anon_sym_export] = ACTIONS(3268),
    [anon_sym_default] = ACTIONS(3268),
    [anon_sym_type] = ACTIONS(3268),
    [anon_sym_namespace] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3268),
    [anon_sym_typeof] = ACTIONS(3268),
    [anon_sym_import] = ACTIONS(3268),
    [anon_sym_with] = ACTIONS(3268),
    [anon_sym_var] = ACTIONS(3268),
    [anon_sym_let] = ACTIONS(3268),
    [anon_sym_const] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_if] = ACTIONS(3268),
    [anon_sym_switch] = ACTIONS(3268),
    [anon_sym_for] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3268),
    [anon_sym_await] = ACTIONS(3268),
    [anon_sym_while] = ACTIONS(3268),
    [anon_sym_do] = ACTIONS(3268),
    [anon_sym_try] = ACTIONS(3268),
    [anon_sym_break] = ACTIONS(3268),
    [anon_sym_continue] = ACTIONS(3268),
    [anon_sym_debugger] = ACTIONS(3268),
    [anon_sym_return] = ACTIONS(3268),
    [anon_sym_throw] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_case] = ACTIONS(3268),
    [anon_sym_yield] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_LTtemplate_GT] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_class] = ACTIONS(3268),
    [anon_sym_async] = ACTIONS(3268),
    [anon_sym_function] = ACTIONS(3268),
    [anon_sym_new] = ACTIONS(3268),
    [anon_sym_using] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_void] = ACTIONS(3268),
    [anon_sym_delete] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3268),
    [sym_number] = ACTIONS(3268),
    [sym_private_property_identifier] = ACTIONS(3268),
    [sym_this] = ACTIONS(3268),
    [sym_super] = ACTIONS(3268),
    [sym_true] = ACTIONS(3268),
    [sym_false] = ACTIONS(3268),
    [sym_null] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_AT] = ACTIONS(3268),
    [anon_sym_static] = ACTIONS(3268),
    [anon_sym_readonly] = ACTIONS(3268),
    [anon_sym_get] = ACTIONS(3268),
    [anon_sym_set] = ACTIONS(3268),
    [anon_sym_declare] = ACTIONS(3268),
    [anon_sym_public] = ACTIONS(3268),
    [anon_sym_private] = ACTIONS(3268),
    [anon_sym_protected] = ACTIONS(3268),
    [anon_sym_override] = ACTIONS(3268),
    [anon_sym_module] = ACTIONS(3268),
    [anon_sym_any] = ACTIONS(3268),
    [anon_sym_number] = ACTIONS(3268),
    [anon_sym_boolean] = ACTIONS(3268),
    [anon_sym_string] = ACTIONS(3268),
    [anon_sym_symbol] = ACTIONS(3268),
    [anon_sym_object] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(3268),
    [anon_sym_interface] = ACTIONS(3268),
    [anon_sym_enum] = ACTIONS(3268),
    [sym_html_comment] = ACTIONS(5),
  },
  [1260] = {
    [sym_comment] = STATE(1260),
    [sym_identifier] = ACTIONS(3194),
    [anon_sym_export] = ACTIONS(3194),
    [anon_sym_default] = ACTIONS(3194),
    [anon_sym_type] = ACTIONS(3194),
    [anon_sym_namespace] = ACTIONS(3194),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3194),
    [anon_sym_typeof] = ACTIONS(3194),
    [anon_sym_import] = ACTIONS(3194),
    [anon_sym_with] = ACTIONS(3194),
    [anon_sym_var] = ACTIONS(3194),
    [anon_sym_let] = ACTIONS(3194),
    [anon_sym_const] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_if] = ACTIONS(3194),
    [anon_sym_switch] = ACTIONS(3194),
    [anon_sym_for] = ACTIONS(3194),
    [anon_sym_LPAREN] = ACTIONS(3194),
    [anon_sym_await] = ACTIONS(3194),
    [anon_sym_while] = ACTIONS(3194),
    [anon_sym_do] = ACTIONS(3194),
    [anon_sym_try] = ACTIONS(3194),
    [anon_sym_break] = ACTIONS(3194),
    [anon_sym_continue] = ACTIONS(3194),
    [anon_sym_debugger] = ACTIONS(3194),
    [anon_sym_return] = ACTIONS(3194),
    [anon_sym_throw] = ACTIONS(3194),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym_case] = ACTIONS(3194),
    [anon_sym_yield] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_LTtemplate_GT] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3194),
    [anon_sym_SQUOTE] = ACTIONS(3194),
    [anon_sym_class] = ACTIONS(3194),
    [anon_sym_async] = ACTIONS(3194),
    [anon_sym_function] = ACTIONS(3194),
    [anon_sym_new] = ACTIONS(3194),
    [anon_sym_using] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3194),
    [anon_sym_SLASH] = ACTIONS(3194),
    [anon_sym_LT] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_void] = ACTIONS(3194),
    [anon_sym_delete] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_number] = ACTIONS(3194),
    [sym_private_property_identifier] = ACTIONS(3194),
    [sym_this] = ACTIONS(3194),
    [sym_super] = ACTIONS(3194),
    [sym_true] = ACTIONS(3194),
    [sym_false] = ACTIONS(3194),
    [sym_null] = ACTIONS(3194),
    [sym_undefined] = ACTIONS(3194),
    [anon_sym_AT] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3194),
    [anon_sym_readonly] = ACTIONS(3194),
    [anon_sym_get] = ACTIONS(3194),
    [anon_sym_set] = ACTIONS(3194),
    [anon_sym_declare] = ACTIONS(3194),
    [anon_sym_public] = ACTIONS(3194),
    [anon_sym_private] = ACTIONS(3194),
    [anon_sym_protected] = ACTIONS(3194),
    [anon_sym_override] = ACTIONS(3194),
    [anon_sym_module] = ACTIONS(3194),
    [anon_sym_any] = ACTIONS(3194),
    [anon_sym_number] = ACTIONS(3194),
    [anon_sym_boolean] = ACTIONS(3194),
    [anon_sym_string] = ACTIONS(3194),
    [anon_sym_symbol] = ACTIONS(3194),
    [anon_sym_object] = ACTIONS(3194),
    [anon_sym_abstract] = ACTIONS(3194),
    [anon_sym_interface] = ACTIONS(3194),
    [anon_sym_enum] = ACTIONS(3194),
    [sym_html_comment] = ACTIONS(5),
  },
  [1261] = {
    [sym_comment] = STATE(1261),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_export] = ACTIONS(3280),
    [anon_sym_default] = ACTIONS(3280),
    [anon_sym_type] = ACTIONS(3280),
    [anon_sym_namespace] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_RBRACE] = ACTIONS(3280),
    [anon_sym_typeof] = ACTIONS(3280),
    [anon_sym_import] = ACTIONS(3280),
    [anon_sym_with] = ACTIONS(3280),
    [anon_sym_var] = ACTIONS(3280),
    [anon_sym_let] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_BANG] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_switch] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_LPAREN] = ACTIONS(3280),
    [anon_sym_await] = ACTIONS(3280),
    [anon_sym_while] = ACTIONS(3280),
    [anon_sym_do] = ACTIONS(3280),
    [anon_sym_try] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_debugger] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_throw] = ACTIONS(3280),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_case] = ACTIONS(3280),
    [anon_sym_yield] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_LTtemplate_GT] = ACTIONS(3280),
    [anon_sym_DQUOTE] = ACTIONS(3280),
    [anon_sym_SQUOTE] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_async] = ACTIONS(3280),
    [anon_sym_function] = ACTIONS(3280),
    [anon_sym_new] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_SLASH] = ACTIONS(3280),
    [anon_sym_LT] = ACTIONS(3280),
    [anon_sym_TILDE] = ACTIONS(3280),
    [anon_sym_void] = ACTIONS(3280),
    [anon_sym_delete] = ACTIONS(3280),
    [anon_sym_PLUS_PLUS] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3280),
    [sym_number] = ACTIONS(3280),
    [sym_private_property_identifier] = ACTIONS(3280),
    [sym_this] = ACTIONS(3280),
    [sym_super] = ACTIONS(3280),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_null] = ACTIONS(3280),
    [sym_undefined] = ACTIONS(3280),
    [anon_sym_AT] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_readonly] = ACTIONS(3280),
    [anon_sym_get] = ACTIONS(3280),
    [anon_sym_set] = ACTIONS(3280),
    [anon_sym_declare] = ACTIONS(3280),
    [anon_sym_public] = ACTIONS(3280),
    [anon_sym_private] = ACTIONS(3280),
    [anon_sym_protected] = ACTIONS(3280),
    [anon_sym_override] = ACTIONS(3280),
    [anon_sym_module] = ACTIONS(3280),
    [anon_sym_any] = ACTIONS(3280),
    [anon_sym_number] = ACTIONS(3280),
    [anon_sym_boolean] = ACTIONS(3280),
    [anon_sym_string] = ACTIONS(3280),
    [anon_sym_symbol] = ACTIONS(3280),
    [anon_sym_object] = ACTIONS(3280),
    [anon_sym_abstract] = ACTIONS(3280),
    [anon_sym_interface] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [sym_html_comment] = ACTIONS(5),
  },
  [1262] = {
    [sym_comment] = STATE(1262),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_export] = ACTIONS(3230),
    [anon_sym_default] = ACTIONS(3230),
    [anon_sym_type] = ACTIONS(3230),
    [anon_sym_namespace] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_RBRACE] = ACTIONS(3230),
    [anon_sym_typeof] = ACTIONS(3230),
    [anon_sym_import] = ACTIONS(3230),
    [anon_sym_with] = ACTIONS(3230),
    [anon_sym_var] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_BANG] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_switch] = ACTIONS(3230),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_await] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_break] = ACTIONS(3230),
    [anon_sym_continue] = ACTIONS(3230),
    [anon_sym_debugger] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_throw] = ACTIONS(3230),
    [anon_sym_SEMI] = ACTIONS(3230),
    [anon_sym_case] = ACTIONS(3230),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LTtemplate_GT] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_SQUOTE] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3230),
    [anon_sym_async] = ACTIONS(3230),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_SLASH] = ACTIONS(3230),
    [anon_sym_LT] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3230),
    [anon_sym_void] = ACTIONS(3230),
    [anon_sym_delete] = ACTIONS(3230),
    [anon_sym_PLUS_PLUS] = ACTIONS(3230),
    [anon_sym_DASH_DASH] = ACTIONS(3230),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3230),
    [sym_number] = ACTIONS(3230),
    [sym_private_property_identifier] = ACTIONS(3230),
    [sym_this] = ACTIONS(3230),
    [sym_super] = ACTIONS(3230),
    [sym_true] = ACTIONS(3230),
    [sym_false] = ACTIONS(3230),
    [sym_null] = ACTIONS(3230),
    [sym_undefined] = ACTIONS(3230),
    [anon_sym_AT] = ACTIONS(3230),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_readonly] = ACTIONS(3230),
    [anon_sym_get] = ACTIONS(3230),
    [anon_sym_set] = ACTIONS(3230),
    [anon_sym_declare] = ACTIONS(3230),
    [anon_sym_public] = ACTIONS(3230),
    [anon_sym_private] = ACTIONS(3230),
    [anon_sym_protected] = ACTIONS(3230),
    [anon_sym_override] = ACTIONS(3230),
    [anon_sym_module] = ACTIONS(3230),
    [anon_sym_any] = ACTIONS(3230),
    [anon_sym_number] = ACTIONS(3230),
    [anon_sym_boolean] = ACTIONS(3230),
    [anon_sym_string] = ACTIONS(3230),
    [anon_sym_symbol] = ACTIONS(3230),
    [anon_sym_object] = ACTIONS(3230),
    [anon_sym_abstract] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3230),
    [anon_sym_enum] = ACTIONS(3230),
    [sym_html_comment] = ACTIONS(5),
  },
  [1263] = {
    [sym_comment] = STATE(1263),
    [sym_identifier] = ACTIONS(3228),
    [anon_sym_export] = ACTIONS(3228),
    [anon_sym_default] = ACTIONS(3228),
    [anon_sym_type] = ACTIONS(3228),
    [anon_sym_namespace] = ACTIONS(3228),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_typeof] = ACTIONS(3228),
    [anon_sym_import] = ACTIONS(3228),
    [anon_sym_with] = ACTIONS(3228),
    [anon_sym_var] = ACTIONS(3228),
    [anon_sym_let] = ACTIONS(3228),
    [anon_sym_const] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_if] = ACTIONS(3228),
    [anon_sym_switch] = ACTIONS(3228),
    [anon_sym_for] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3228),
    [anon_sym_await] = ACTIONS(3228),
    [anon_sym_while] = ACTIONS(3228),
    [anon_sym_do] = ACTIONS(3228),
    [anon_sym_try] = ACTIONS(3228),
    [anon_sym_break] = ACTIONS(3228),
    [anon_sym_continue] = ACTIONS(3228),
    [anon_sym_debugger] = ACTIONS(3228),
    [anon_sym_return] = ACTIONS(3228),
    [anon_sym_throw] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_case] = ACTIONS(3228),
    [anon_sym_yield] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_LTtemplate_GT] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3228),
    [anon_sym_SQUOTE] = ACTIONS(3228),
    [anon_sym_class] = ACTIONS(3228),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_function] = ACTIONS(3228),
    [anon_sym_new] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3228),
    [anon_sym_SLASH] = ACTIONS(3228),
    [anon_sym_LT] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3228),
    [anon_sym_void] = ACTIONS(3228),
    [anon_sym_delete] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3228),
    [sym_number] = ACTIONS(3228),
    [sym_private_property_identifier] = ACTIONS(3228),
    [sym_this] = ACTIONS(3228),
    [sym_super] = ACTIONS(3228),
    [sym_true] = ACTIONS(3228),
    [sym_false] = ACTIONS(3228),
    [sym_null] = ACTIONS(3228),
    [sym_undefined] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(3228),
    [anon_sym_readonly] = ACTIONS(3228),
    [anon_sym_get] = ACTIONS(3228),
    [anon_sym_set] = ACTIONS(3228),
    [anon_sym_declare] = ACTIONS(3228),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_override] = ACTIONS(3228),
    [anon_sym_module] = ACTIONS(3228),
    [anon_sym_any] = ACTIONS(3228),
    [anon_sym_number] = ACTIONS(3228),
    [anon_sym_boolean] = ACTIONS(3228),
    [anon_sym_string] = ACTIONS(3228),
    [anon_sym_symbol] = ACTIONS(3228),
    [anon_sym_object] = ACTIONS(3228),
    [anon_sym_abstract] = ACTIONS(3228),
    [anon_sym_interface] = ACTIONS(3228),
    [anon_sym_enum] = ACTIONS(3228),
    [sym_html_comment] = ACTIONS(5),
  },
  [1264] = {
    [sym_comment] = STATE(1264),
    [sym_identifier] = ACTIONS(3222),
    [anon_sym_export] = ACTIONS(3222),
    [anon_sym_default] = ACTIONS(3222),
    [anon_sym_type] = ACTIONS(3222),
    [anon_sym_namespace] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3222),
    [anon_sym_RBRACE] = ACTIONS(3222),
    [anon_sym_typeof] = ACTIONS(3222),
    [anon_sym_import] = ACTIONS(3222),
    [anon_sym_with] = ACTIONS(3222),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_BANG] = ACTIONS(3222),
    [anon_sym_if] = ACTIONS(3222),
    [anon_sym_switch] = ACTIONS(3222),
    [anon_sym_for] = ACTIONS(3222),
    [anon_sym_LPAREN] = ACTIONS(3222),
    [anon_sym_await] = ACTIONS(3222),
    [anon_sym_while] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3222),
    [anon_sym_break] = ACTIONS(3222),
    [anon_sym_continue] = ACTIONS(3222),
    [anon_sym_debugger] = ACTIONS(3222),
    [anon_sym_return] = ACTIONS(3222),
    [anon_sym_throw] = ACTIONS(3222),
    [anon_sym_SEMI] = ACTIONS(3222),
    [anon_sym_case] = ACTIONS(3222),
    [anon_sym_yield] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_LTtemplate_GT] = ACTIONS(3222),
    [anon_sym_DQUOTE] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_async] = ACTIONS(3222),
    [anon_sym_function] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_using] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_SLASH] = ACTIONS(3222),
    [anon_sym_LT] = ACTIONS(3222),
    [anon_sym_TILDE] = ACTIONS(3222),
    [anon_sym_void] = ACTIONS(3222),
    [anon_sym_delete] = ACTIONS(3222),
    [anon_sym_PLUS_PLUS] = ACTIONS(3222),
    [anon_sym_DASH_DASH] = ACTIONS(3222),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3222),
    [sym_number] = ACTIONS(3222),
    [sym_private_property_identifier] = ACTIONS(3222),
    [sym_this] = ACTIONS(3222),
    [sym_super] = ACTIONS(3222),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [sym_null] = ACTIONS(3222),
    [sym_undefined] = ACTIONS(3222),
    [anon_sym_AT] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_readonly] = ACTIONS(3222),
    [anon_sym_get] = ACTIONS(3222),
    [anon_sym_set] = ACTIONS(3222),
    [anon_sym_declare] = ACTIONS(3222),
    [anon_sym_public] = ACTIONS(3222),
    [anon_sym_private] = ACTIONS(3222),
    [anon_sym_protected] = ACTIONS(3222),
    [anon_sym_override] = ACTIONS(3222),
    [anon_sym_module] = ACTIONS(3222),
    [anon_sym_any] = ACTIONS(3222),
    [anon_sym_number] = ACTIONS(3222),
    [anon_sym_boolean] = ACTIONS(3222),
    [anon_sym_string] = ACTIONS(3222),
    [anon_sym_symbol] = ACTIONS(3222),
    [anon_sym_object] = ACTIONS(3222),
    [anon_sym_abstract] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [sym_html_comment] = ACTIONS(5),
  },
  [1265] = {
    [sym_comment] = STATE(1265),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_export] = ACTIONS(3300),
    [anon_sym_default] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_namespace] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_typeof] = ACTIONS(3300),
    [anon_sym_import] = ACTIONS(3300),
    [anon_sym_with] = ACTIONS(3300),
    [anon_sym_var] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_const] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_switch] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_await] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_debugger] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_throw] = ACTIONS(3300),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym_case] = ACTIONS(3300),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LTtemplate_GT] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_class] = ACTIONS(3300),
    [anon_sym_async] = ACTIONS(3300),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_using] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_SLASH] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_void] = ACTIONS(3300),
    [anon_sym_delete] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3300),
    [sym_number] = ACTIONS(3300),
    [sym_private_property_identifier] = ACTIONS(3300),
    [sym_this] = ACTIONS(3300),
    [sym_super] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_null] = ACTIONS(3300),
    [sym_undefined] = ACTIONS(3300),
    [anon_sym_AT] = ACTIONS(3300),
    [anon_sym_static] = ACTIONS(3300),
    [anon_sym_readonly] = ACTIONS(3300),
    [anon_sym_get] = ACTIONS(3300),
    [anon_sym_set] = ACTIONS(3300),
    [anon_sym_declare] = ACTIONS(3300),
    [anon_sym_public] = ACTIONS(3300),
    [anon_sym_private] = ACTIONS(3300),
    [anon_sym_protected] = ACTIONS(3300),
    [anon_sym_override] = ACTIONS(3300),
    [anon_sym_module] = ACTIONS(3300),
    [anon_sym_any] = ACTIONS(3300),
    [anon_sym_number] = ACTIONS(3300),
    [anon_sym_boolean] = ACTIONS(3300),
    [anon_sym_string] = ACTIONS(3300),
    [anon_sym_symbol] = ACTIONS(3300),
    [anon_sym_object] = ACTIONS(3300),
    [anon_sym_abstract] = ACTIONS(3300),
    [anon_sym_interface] = ACTIONS(3300),
    [anon_sym_enum] = ACTIONS(3300),
    [sym_html_comment] = ACTIONS(5),
  },
  [1266] = {
    [sym_comment] = STATE(1266),
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_export] = ACTIONS(3152),
    [anon_sym_default] = ACTIONS(3152),
    [anon_sym_type] = ACTIONS(3152),
    [anon_sym_namespace] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3152),
    [anon_sym_typeof] = ACTIONS(3152),
    [anon_sym_import] = ACTIONS(3152),
    [anon_sym_with] = ACTIONS(3152),
    [anon_sym_var] = ACTIONS(3152),
    [anon_sym_let] = ACTIONS(3152),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_switch] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3152),
    [anon_sym_await] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_do] = ACTIONS(3152),
    [anon_sym_try] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_continue] = ACTIONS(3152),
    [anon_sym_debugger] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_throw] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_yield] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_LTtemplate_GT] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_async] = ACTIONS(3152),
    [anon_sym_function] = ACTIONS(3152),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_using] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_LT] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_void] = ACTIONS(3152),
    [anon_sym_delete] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3152),
    [sym_number] = ACTIONS(3152),
    [sym_private_property_identifier] = ACTIONS(3152),
    [sym_this] = ACTIONS(3152),
    [sym_super] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_null] = ACTIONS(3152),
    [sym_undefined] = ACTIONS(3152),
    [anon_sym_AT] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_readonly] = ACTIONS(3152),
    [anon_sym_get] = ACTIONS(3152),
    [anon_sym_set] = ACTIONS(3152),
    [anon_sym_declare] = ACTIONS(3152),
    [anon_sym_public] = ACTIONS(3152),
    [anon_sym_private] = ACTIONS(3152),
    [anon_sym_protected] = ACTIONS(3152),
    [anon_sym_override] = ACTIONS(3152),
    [anon_sym_module] = ACTIONS(3152),
    [anon_sym_any] = ACTIONS(3152),
    [anon_sym_number] = ACTIONS(3152),
    [anon_sym_boolean] = ACTIONS(3152),
    [anon_sym_string] = ACTIONS(3152),
    [anon_sym_symbol] = ACTIONS(3152),
    [anon_sym_object] = ACTIONS(3152),
    [anon_sym_abstract] = ACTIONS(3152),
    [anon_sym_interface] = ACTIONS(3152),
    [anon_sym_enum] = ACTIONS(3152),
    [sym_html_comment] = ACTIONS(5),
  },
  [1267] = {
    [sym_comment] = STATE(1267),
    [sym_identifier] = ACTIONS(3192),
    [anon_sym_export] = ACTIONS(3192),
    [anon_sym_default] = ACTIONS(3192),
    [anon_sym_type] = ACTIONS(3192),
    [anon_sym_namespace] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3192),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_typeof] = ACTIONS(3192),
    [anon_sym_import] = ACTIONS(3192),
    [anon_sym_with] = ACTIONS(3192),
    [anon_sym_var] = ACTIONS(3192),
    [anon_sym_let] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_await] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_debugger] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_throw] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym_case] = ACTIONS(3192),
    [anon_sym_yield] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_LTtemplate_GT] = ACTIONS(3192),
    [anon_sym_DQUOTE] = ACTIONS(3192),
    [anon_sym_SQUOTE] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_async] = ACTIONS(3192),
    [anon_sym_function] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_SLASH] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3192),
    [anon_sym_void] = ACTIONS(3192),
    [anon_sym_delete] = ACTIONS(3192),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [sym_number] = ACTIONS(3192),
    [sym_private_property_identifier] = ACTIONS(3192),
    [sym_this] = ACTIONS(3192),
    [sym_super] = ACTIONS(3192),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [sym_null] = ACTIONS(3192),
    [sym_undefined] = ACTIONS(3192),
    [anon_sym_AT] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_readonly] = ACTIONS(3192),
    [anon_sym_get] = ACTIONS(3192),
    [anon_sym_set] = ACTIONS(3192),
    [anon_sym_declare] = ACTIONS(3192),
    [anon_sym_public] = ACTIONS(3192),
    [anon_sym_private] = ACTIONS(3192),
    [anon_sym_protected] = ACTIONS(3192),
    [anon_sym_override] = ACTIONS(3192),
    [anon_sym_module] = ACTIONS(3192),
    [anon_sym_any] = ACTIONS(3192),
    [anon_sym_number] = ACTIONS(3192),
    [anon_sym_boolean] = ACTIONS(3192),
    [anon_sym_string] = ACTIONS(3192),
    [anon_sym_symbol] = ACTIONS(3192),
    [anon_sym_object] = ACTIONS(3192),
    [anon_sym_abstract] = ACTIONS(3192),
    [anon_sym_interface] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [sym_html_comment] = ACTIONS(5),
  },
  [1268] = {
    [sym_comment] = STATE(1268),
    [ts_builtin_sym_end] = ACTIONS(3444),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_export] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_namespace] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_RBRACE] = ACTIONS(3292),
    [anon_sym_typeof] = ACTIONS(3292),
    [anon_sym_import] = ACTIONS(3292),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_var] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_const] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_else] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_switch] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_await] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_break] = ACTIONS(3292),
    [anon_sym_continue] = ACTIONS(3292),
    [anon_sym_debugger] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_throw] = ACTIONS(3292),
    [anon_sym_SEMI] = ACTIONS(3292),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LTtemplate_GT] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [anon_sym_class] = ACTIONS(3292),
    [anon_sym_async] = ACTIONS(3292),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_using] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3292),
    [anon_sym_void] = ACTIONS(3292),
    [anon_sym_delete] = ACTIONS(3292),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3292),
    [sym_number] = ACTIONS(3292),
    [sym_private_property_identifier] = ACTIONS(3292),
    [sym_this] = ACTIONS(3292),
    [sym_super] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_null] = ACTIONS(3292),
    [sym_undefined] = ACTIONS(3292),
    [anon_sym_AT] = ACTIONS(3292),
    [anon_sym_static] = ACTIONS(3292),
    [anon_sym_readonly] = ACTIONS(3292),
    [anon_sym_get] = ACTIONS(3292),
    [anon_sym_set] = ACTIONS(3292),
    [anon_sym_declare] = ACTIONS(3292),
    [anon_sym_public] = ACTIONS(3292),
    [anon_sym_private] = ACTIONS(3292),
    [anon_sym_protected] = ACTIONS(3292),
    [anon_sym_override] = ACTIONS(3292),
    [anon_sym_module] = ACTIONS(3292),
    [anon_sym_any] = ACTIONS(3292),
    [anon_sym_number] = ACTIONS(3292),
    [anon_sym_boolean] = ACTIONS(3292),
    [anon_sym_string] = ACTIONS(3292),
    [anon_sym_symbol] = ACTIONS(3292),
    [anon_sym_object] = ACTIONS(3292),
    [anon_sym_abstract] = ACTIONS(3292),
    [anon_sym_interface] = ACTIONS(3292),
    [anon_sym_enum] = ACTIONS(3292),
    [sym_html_comment] = ACTIONS(5),
  },
  [1269] = {
    [sym_comment] = STATE(1269),
    [sym_identifier] = ACTIONS(3236),
    [anon_sym_export] = ACTIONS(3236),
    [anon_sym_default] = ACTIONS(3236),
    [anon_sym_type] = ACTIONS(3236),
    [anon_sym_namespace] = ACTIONS(3236),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_RBRACE] = ACTIONS(3236),
    [anon_sym_typeof] = ACTIONS(3236),
    [anon_sym_import] = ACTIONS(3236),
    [anon_sym_with] = ACTIONS(3236),
    [anon_sym_var] = ACTIONS(3236),
    [anon_sym_let] = ACTIONS(3236),
    [anon_sym_const] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_if] = ACTIONS(3236),
    [anon_sym_switch] = ACTIONS(3236),
    [anon_sym_for] = ACTIONS(3236),
    [anon_sym_LPAREN] = ACTIONS(3236),
    [anon_sym_await] = ACTIONS(3236),
    [anon_sym_while] = ACTIONS(3236),
    [anon_sym_do] = ACTIONS(3236),
    [anon_sym_try] = ACTIONS(3236),
    [anon_sym_break] = ACTIONS(3236),
    [anon_sym_continue] = ACTIONS(3236),
    [anon_sym_debugger] = ACTIONS(3236),
    [anon_sym_return] = ACTIONS(3236),
    [anon_sym_throw] = ACTIONS(3236),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym_case] = ACTIONS(3236),
    [anon_sym_yield] = ACTIONS(3236),
    [anon_sym_LBRACK] = ACTIONS(3236),
    [anon_sym_LTtemplate_GT] = ACTIONS(3236),
    [anon_sym_DQUOTE] = ACTIONS(3236),
    [anon_sym_SQUOTE] = ACTIONS(3236),
    [anon_sym_class] = ACTIONS(3236),
    [anon_sym_async] = ACTIONS(3236),
    [anon_sym_function] = ACTIONS(3236),
    [anon_sym_new] = ACTIONS(3236),
    [anon_sym_using] = ACTIONS(3236),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3236),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_void] = ACTIONS(3236),
    [anon_sym_delete] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3236),
    [anon_sym_DASH_DASH] = ACTIONS(3236),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3236),
    [sym_number] = ACTIONS(3236),
    [sym_private_property_identifier] = ACTIONS(3236),
    [sym_this] = ACTIONS(3236),
    [sym_super] = ACTIONS(3236),
    [sym_true] = ACTIONS(3236),
    [sym_false] = ACTIONS(3236),
    [sym_null] = ACTIONS(3236),
    [sym_undefined] = ACTIONS(3236),
    [anon_sym_AT] = ACTIONS(3236),
    [anon_sym_static] = ACTIONS(3236),
    [anon_sym_readonly] = ACTIONS(3236),
    [anon_sym_get] = ACTIONS(3236),
    [anon_sym_set] = ACTIONS(3236),
    [anon_sym_declare] = ACTIONS(3236),
    [anon_sym_public] = ACTIONS(3236),
    [anon_sym_private] = ACTIONS(3236),
    [anon_sym_protected] = ACTIONS(3236),
    [anon_sym_override] = ACTIONS(3236),
    [anon_sym_module] = ACTIONS(3236),
    [anon_sym_any] = ACTIONS(3236),
    [anon_sym_number] = ACTIONS(3236),
    [anon_sym_boolean] = ACTIONS(3236),
    [anon_sym_string] = ACTIONS(3236),
    [anon_sym_symbol] = ACTIONS(3236),
    [anon_sym_object] = ACTIONS(3236),
    [anon_sym_abstract] = ACTIONS(3236),
    [anon_sym_interface] = ACTIONS(3236),
    [anon_sym_enum] = ACTIONS(3236),
    [sym_html_comment] = ACTIONS(5),
  },
  [1270] = {
    [sym_comment] = STATE(1270),
    [ts_builtin_sym_end] = ACTIONS(3446),
    [sym_identifier] = ACTIONS(3224),
    [anon_sym_export] = ACTIONS(3224),
    [anon_sym_type] = ACTIONS(3224),
    [anon_sym_namespace] = ACTIONS(3224),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_typeof] = ACTIONS(3224),
    [anon_sym_import] = ACTIONS(3224),
    [anon_sym_with] = ACTIONS(3224),
    [anon_sym_var] = ACTIONS(3224),
    [anon_sym_let] = ACTIONS(3224),
    [anon_sym_const] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_else] = ACTIONS(3224),
    [anon_sym_if] = ACTIONS(3224),
    [anon_sym_switch] = ACTIONS(3224),
    [anon_sym_for] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [anon_sym_await] = ACTIONS(3224),
    [anon_sym_while] = ACTIONS(3224),
    [anon_sym_do] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(3224),
    [anon_sym_break] = ACTIONS(3224),
    [anon_sym_continue] = ACTIONS(3224),
    [anon_sym_debugger] = ACTIONS(3224),
    [anon_sym_return] = ACTIONS(3224),
    [anon_sym_throw] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_yield] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_LTtemplate_GT] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_class] = ACTIONS(3224),
    [anon_sym_async] = ACTIONS(3224),
    [anon_sym_function] = ACTIONS(3224),
    [anon_sym_new] = ACTIONS(3224),
    [anon_sym_using] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3224),
    [anon_sym_SLASH] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_void] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3224),
    [sym_number] = ACTIONS(3224),
    [sym_private_property_identifier] = ACTIONS(3224),
    [sym_this] = ACTIONS(3224),
    [sym_super] = ACTIONS(3224),
    [sym_true] = ACTIONS(3224),
    [sym_false] = ACTIONS(3224),
    [sym_null] = ACTIONS(3224),
    [sym_undefined] = ACTIONS(3224),
    [anon_sym_AT] = ACTIONS(3224),
    [anon_sym_static] = ACTIONS(3224),
    [anon_sym_readonly] = ACTIONS(3224),
    [anon_sym_get] = ACTIONS(3224),
    [anon_sym_set] = ACTIONS(3224),
    [anon_sym_declare] = ACTIONS(3224),
    [anon_sym_public] = ACTIONS(3224),
    [anon_sym_private] = ACTIONS(3224),
    [anon_sym_protected] = ACTIONS(3224),
    [anon_sym_override] = ACTIONS(3224),
    [anon_sym_module] = ACTIONS(3224),
    [anon_sym_any] = ACTIONS(3224),
    [anon_sym_number] = ACTIONS(3224),
    [anon_sym_boolean] = ACTIONS(3224),
    [anon_sym_string] = ACTIONS(3224),
    [anon_sym_symbol] = ACTIONS(3224),
    [anon_sym_object] = ACTIONS(3224),
    [anon_sym_abstract] = ACTIONS(3224),
    [anon_sym_interface] = ACTIONS(3224),
    [anon_sym_enum] = ACTIONS(3224),
    [sym_html_comment] = ACTIONS(5),
  },
  [1271] = {
    [sym_comment] = STATE(1271),
    [sym_identifier] = ACTIONS(3150),
    [anon_sym_export] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_type] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_typeof] = ACTIONS(3150),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_with] = ACTIONS(3150),
    [anon_sym_var] = ACTIONS(3150),
    [anon_sym_let] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_LPAREN] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_debugger] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_yield] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_LTtemplate_GT] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_async] = ACTIONS(3150),
    [anon_sym_function] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3150),
    [anon_sym_LT] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_void] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3150),
    [sym_number] = ACTIONS(3150),
    [sym_private_property_identifier] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
    [sym_super] = ACTIONS(3150),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [sym_null] = ACTIONS(3150),
    [sym_undefined] = ACTIONS(3150),
    [anon_sym_AT] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_readonly] = ACTIONS(3150),
    [anon_sym_get] = ACTIONS(3150),
    [anon_sym_set] = ACTIONS(3150),
    [anon_sym_declare] = ACTIONS(3150),
    [anon_sym_public] = ACTIONS(3150),
    [anon_sym_private] = ACTIONS(3150),
    [anon_sym_protected] = ACTIONS(3150),
    [anon_sym_override] = ACTIONS(3150),
    [anon_sym_module] = ACTIONS(3150),
    [anon_sym_any] = ACTIONS(3150),
    [anon_sym_number] = ACTIONS(3150),
    [anon_sym_boolean] = ACTIONS(3150),
    [anon_sym_string] = ACTIONS(3150),
    [anon_sym_symbol] = ACTIONS(3150),
    [anon_sym_object] = ACTIONS(3150),
    [anon_sym_abstract] = ACTIONS(3150),
    [anon_sym_interface] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [sym_html_comment] = ACTIONS(5),
  },
  [1272] = {
    [sym_comment] = STATE(1272),
    [ts_builtin_sym_end] = ACTIONS(3448),
    [sym_identifier] = ACTIONS(3192),
    [anon_sym_export] = ACTIONS(3192),
    [anon_sym_type] = ACTIONS(3192),
    [anon_sym_namespace] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3192),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_typeof] = ACTIONS(3192),
    [anon_sym_import] = ACTIONS(3192),
    [anon_sym_with] = ACTIONS(3192),
    [anon_sym_var] = ACTIONS(3192),
    [anon_sym_let] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3192),
    [anon_sym_else] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_await] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_debugger] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_throw] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym_yield] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_LTtemplate_GT] = ACTIONS(3192),
    [anon_sym_DQUOTE] = ACTIONS(3192),
    [anon_sym_SQUOTE] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_async] = ACTIONS(3192),
    [anon_sym_function] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_SLASH] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3192),
    [anon_sym_void] = ACTIONS(3192),
    [anon_sym_delete] = ACTIONS(3192),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [sym_number] = ACTIONS(3192),
    [sym_private_property_identifier] = ACTIONS(3192),
    [sym_this] = ACTIONS(3192),
    [sym_super] = ACTIONS(3192),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [sym_null] = ACTIONS(3192),
    [sym_undefined] = ACTIONS(3192),
    [anon_sym_AT] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_readonly] = ACTIONS(3192),
    [anon_sym_get] = ACTIONS(3192),
    [anon_sym_set] = ACTIONS(3192),
    [anon_sym_declare] = ACTIONS(3192),
    [anon_sym_public] = ACTIONS(3192),
    [anon_sym_private] = ACTIONS(3192),
    [anon_sym_protected] = ACTIONS(3192),
    [anon_sym_override] = ACTIONS(3192),
    [anon_sym_module] = ACTIONS(3192),
    [anon_sym_any] = ACTIONS(3192),
    [anon_sym_number] = ACTIONS(3192),
    [anon_sym_boolean] = ACTIONS(3192),
    [anon_sym_string] = ACTIONS(3192),
    [anon_sym_symbol] = ACTIONS(3192),
    [anon_sym_object] = ACTIONS(3192),
    [anon_sym_abstract] = ACTIONS(3192),
    [anon_sym_interface] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [sym_html_comment] = ACTIONS(5),
  },
  [1273] = {
    [sym_comment] = STATE(1273),
    [ts_builtin_sym_end] = ACTIONS(3450),
    [sym_identifier] = ACTIONS(3264),
    [anon_sym_export] = ACTIONS(3264),
    [anon_sym_type] = ACTIONS(3264),
    [anon_sym_namespace] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_RBRACE] = ACTIONS(3264),
    [anon_sym_typeof] = ACTIONS(3264),
    [anon_sym_import] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3264),
    [anon_sym_var] = ACTIONS(3264),
    [anon_sym_let] = ACTIONS(3264),
    [anon_sym_const] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_else] = ACTIONS(3264),
    [anon_sym_if] = ACTIONS(3264),
    [anon_sym_switch] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3264),
    [anon_sym_await] = ACTIONS(3264),
    [anon_sym_while] = ACTIONS(3264),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_try] = ACTIONS(3264),
    [anon_sym_break] = ACTIONS(3264),
    [anon_sym_continue] = ACTIONS(3264),
    [anon_sym_debugger] = ACTIONS(3264),
    [anon_sym_return] = ACTIONS(3264),
    [anon_sym_throw] = ACTIONS(3264),
    [anon_sym_SEMI] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3264),
    [anon_sym_LBRACK] = ACTIONS(3264),
    [anon_sym_LTtemplate_GT] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(3264),
    [anon_sym_SQUOTE] = ACTIONS(3264),
    [anon_sym_class] = ACTIONS(3264),
    [anon_sym_async] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3264),
    [anon_sym_using] = ACTIONS(3264),
    [anon_sym_PLUS] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3264),
    [anon_sym_SLASH] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_TILDE] = ACTIONS(3264),
    [anon_sym_void] = ACTIONS(3264),
    [anon_sym_delete] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3264),
    [anon_sym_DASH_DASH] = ACTIONS(3264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3264),
    [sym_number] = ACTIONS(3264),
    [sym_private_property_identifier] = ACTIONS(3264),
    [sym_this] = ACTIONS(3264),
    [sym_super] = ACTIONS(3264),
    [sym_true] = ACTIONS(3264),
    [sym_false] = ACTIONS(3264),
    [sym_null] = ACTIONS(3264),
    [sym_undefined] = ACTIONS(3264),
    [anon_sym_AT] = ACTIONS(3264),
    [anon_sym_static] = ACTIONS(3264),
    [anon_sym_readonly] = ACTIONS(3264),
    [anon_sym_get] = ACTIONS(3264),
    [anon_sym_set] = ACTIONS(3264),
    [anon_sym_declare] = ACTIONS(3264),
    [anon_sym_public] = ACTIONS(3264),
    [anon_sym_private] = ACTIONS(3264),
    [anon_sym_protected] = ACTIONS(3264),
    [anon_sym_override] = ACTIONS(3264),
    [anon_sym_module] = ACTIONS(3264),
    [anon_sym_any] = ACTIONS(3264),
    [anon_sym_number] = ACTIONS(3264),
    [anon_sym_boolean] = ACTIONS(3264),
    [anon_sym_string] = ACTIONS(3264),
    [anon_sym_symbol] = ACTIONS(3264),
    [anon_sym_object] = ACTIONS(3264),
    [anon_sym_abstract] = ACTIONS(3264),
    [anon_sym_interface] = ACTIONS(3264),
    [anon_sym_enum] = ACTIONS(3264),
    [sym_html_comment] = ACTIONS(5),
  },
  [1274] = {
    [sym_comment] = STATE(1274),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_export] = ACTIONS(3308),
    [anon_sym_default] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_namespace] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_RBRACE] = ACTIONS(3308),
    [anon_sym_typeof] = ACTIONS(3308),
    [anon_sym_import] = ACTIONS(3308),
    [anon_sym_with] = ACTIONS(3308),
    [anon_sym_var] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_switch] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_await] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_debugger] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_throw] = ACTIONS(3308),
    [anon_sym_SEMI] = ACTIONS(3308),
    [anon_sym_case] = ACTIONS(3308),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LTtemplate_GT] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_class] = ACTIONS(3308),
    [anon_sym_async] = ACTIONS(3308),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_using] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_void] = ACTIONS(3308),
    [anon_sym_delete] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3308),
    [sym_number] = ACTIONS(3308),
    [sym_private_property_identifier] = ACTIONS(3308),
    [sym_this] = ACTIONS(3308),
    [sym_super] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_null] = ACTIONS(3308),
    [sym_undefined] = ACTIONS(3308),
    [anon_sym_AT] = ACTIONS(3308),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_readonly] = ACTIONS(3308),
    [anon_sym_get] = ACTIONS(3308),
    [anon_sym_set] = ACTIONS(3308),
    [anon_sym_declare] = ACTIONS(3308),
    [anon_sym_public] = ACTIONS(3308),
    [anon_sym_private] = ACTIONS(3308),
    [anon_sym_protected] = ACTIONS(3308),
    [anon_sym_override] = ACTIONS(3308),
    [anon_sym_module] = ACTIONS(3308),
    [anon_sym_any] = ACTIONS(3308),
    [anon_sym_number] = ACTIONS(3308),
    [anon_sym_boolean] = ACTIONS(3308),
    [anon_sym_string] = ACTIONS(3308),
    [anon_sym_symbol] = ACTIONS(3308),
    [anon_sym_object] = ACTIONS(3308),
    [anon_sym_abstract] = ACTIONS(3308),
    [anon_sym_interface] = ACTIONS(3308),
    [anon_sym_enum] = ACTIONS(3308),
    [sym_html_comment] = ACTIONS(5),
  },
  [1275] = {
    [sym_comment] = STATE(1275),
    [ts_builtin_sym_end] = ACTIONS(3452),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_export] = ACTIONS(3294),
    [anon_sym_type] = ACTIONS(3294),
    [anon_sym_namespace] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3294),
    [anon_sym_RBRACE] = ACTIONS(3294),
    [anon_sym_typeof] = ACTIONS(3294),
    [anon_sym_import] = ACTIONS(3294),
    [anon_sym_with] = ACTIONS(3294),
    [anon_sym_var] = ACTIONS(3294),
    [anon_sym_let] = ACTIONS(3294),
    [anon_sym_const] = ACTIONS(3294),
    [anon_sym_BANG] = ACTIONS(3294),
    [anon_sym_else] = ACTIONS(3294),
    [anon_sym_if] = ACTIONS(3294),
    [anon_sym_switch] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3294),
    [anon_sym_await] = ACTIONS(3294),
    [anon_sym_while] = ACTIONS(3294),
    [anon_sym_do] = ACTIONS(3294),
    [anon_sym_try] = ACTIONS(3294),
    [anon_sym_break] = ACTIONS(3294),
    [anon_sym_continue] = ACTIONS(3294),
    [anon_sym_debugger] = ACTIONS(3294),
    [anon_sym_return] = ACTIONS(3294),
    [anon_sym_throw] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3294),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_LTtemplate_GT] = ACTIONS(3294),
    [anon_sym_DQUOTE] = ACTIONS(3294),
    [anon_sym_SQUOTE] = ACTIONS(3294),
    [anon_sym_class] = ACTIONS(3294),
    [anon_sym_async] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3294),
    [anon_sym_using] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(3294),
    [anon_sym_delete] = ACTIONS(3294),
    [anon_sym_PLUS_PLUS] = ACTIONS(3294),
    [anon_sym_DASH_DASH] = ACTIONS(3294),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3294),
    [sym_number] = ACTIONS(3294),
    [sym_private_property_identifier] = ACTIONS(3294),
    [sym_this] = ACTIONS(3294),
    [sym_super] = ACTIONS(3294),
    [sym_true] = ACTIONS(3294),
    [sym_false] = ACTIONS(3294),
    [sym_null] = ACTIONS(3294),
    [sym_undefined] = ACTIONS(3294),
    [anon_sym_AT] = ACTIONS(3294),
    [anon_sym_static] = ACTIONS(3294),
    [anon_sym_readonly] = ACTIONS(3294),
    [anon_sym_get] = ACTIONS(3294),
    [anon_sym_set] = ACTIONS(3294),
    [anon_sym_declare] = ACTIONS(3294),
    [anon_sym_public] = ACTIONS(3294),
    [anon_sym_private] = ACTIONS(3294),
    [anon_sym_protected] = ACTIONS(3294),
    [anon_sym_override] = ACTIONS(3294),
    [anon_sym_module] = ACTIONS(3294),
    [anon_sym_any] = ACTIONS(3294),
    [anon_sym_number] = ACTIONS(3294),
    [anon_sym_boolean] = ACTIONS(3294),
    [anon_sym_string] = ACTIONS(3294),
    [anon_sym_symbol] = ACTIONS(3294),
    [anon_sym_object] = ACTIONS(3294),
    [anon_sym_abstract] = ACTIONS(3294),
    [anon_sym_interface] = ACTIONS(3294),
    [anon_sym_enum] = ACTIONS(3294),
    [sym_html_comment] = ACTIONS(5),
  },
  [1276] = {
    [sym_comment] = STATE(1276),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3454),
    [sym_html_comment] = ACTIONS(5),
  },
  [1277] = {
    [sym_comment] = STATE(1277),
    [ts_builtin_sym_end] = ACTIONS(3456),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_export] = ACTIONS(3180),
    [anon_sym_type] = ACTIONS(3180),
    [anon_sym_namespace] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_RBRACE] = ACTIONS(3180),
    [anon_sym_typeof] = ACTIONS(3180),
    [anon_sym_import] = ACTIONS(3180),
    [anon_sym_with] = ACTIONS(3180),
    [anon_sym_var] = ACTIONS(3180),
    [anon_sym_let] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_else] = ACTIONS(3180),
    [anon_sym_if] = ACTIONS(3180),
    [anon_sym_switch] = ACTIONS(3180),
    [anon_sym_for] = ACTIONS(3180),
    [anon_sym_LPAREN] = ACTIONS(3180),
    [anon_sym_await] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3180),
    [anon_sym_do] = ACTIONS(3180),
    [anon_sym_try] = ACTIONS(3180),
    [anon_sym_break] = ACTIONS(3180),
    [anon_sym_continue] = ACTIONS(3180),
    [anon_sym_debugger] = ACTIONS(3180),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_throw] = ACTIONS(3180),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3180),
    [anon_sym_LBRACK] = ACTIONS(3180),
    [anon_sym_LTtemplate_GT] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_class] = ACTIONS(3180),
    [anon_sym_async] = ACTIONS(3180),
    [anon_sym_function] = ACTIONS(3180),
    [anon_sym_new] = ACTIONS(3180),
    [anon_sym_using] = ACTIONS(3180),
    [anon_sym_PLUS] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3180),
    [anon_sym_SLASH] = ACTIONS(3180),
    [anon_sym_LT] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_void] = ACTIONS(3180),
    [anon_sym_delete] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3180),
    [sym_number] = ACTIONS(3180),
    [sym_private_property_identifier] = ACTIONS(3180),
    [sym_this] = ACTIONS(3180),
    [sym_super] = ACTIONS(3180),
    [sym_true] = ACTIONS(3180),
    [sym_false] = ACTIONS(3180),
    [sym_null] = ACTIONS(3180),
    [sym_undefined] = ACTIONS(3180),
    [anon_sym_AT] = ACTIONS(3180),
    [anon_sym_static] = ACTIONS(3180),
    [anon_sym_readonly] = ACTIONS(3180),
    [anon_sym_get] = ACTIONS(3180),
    [anon_sym_set] = ACTIONS(3180),
    [anon_sym_declare] = ACTIONS(3180),
    [anon_sym_public] = ACTIONS(3180),
    [anon_sym_private] = ACTIONS(3180),
    [anon_sym_protected] = ACTIONS(3180),
    [anon_sym_override] = ACTIONS(3180),
    [anon_sym_module] = ACTIONS(3180),
    [anon_sym_any] = ACTIONS(3180),
    [anon_sym_number] = ACTIONS(3180),
    [anon_sym_boolean] = ACTIONS(3180),
    [anon_sym_string] = ACTIONS(3180),
    [anon_sym_symbol] = ACTIONS(3180),
    [anon_sym_object] = ACTIONS(3180),
    [anon_sym_abstract] = ACTIONS(3180),
    [anon_sym_interface] = ACTIONS(3180),
    [anon_sym_enum] = ACTIONS(3180),
    [sym_html_comment] = ACTIONS(5),
  },
  [1278] = {
    [sym_comment] = STATE(1278),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_export] = ACTIONS(3324),
    [anon_sym_default] = ACTIONS(3324),
    [anon_sym_type] = ACTIONS(3324),
    [anon_sym_namespace] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_import] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3324),
    [anon_sym_var] = ACTIONS(3324),
    [anon_sym_let] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_switch] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym_await] = ACTIONS(3324),
    [anon_sym_while] = ACTIONS(3324),
    [anon_sym_do] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_debugger] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_throw] = ACTIONS(3324),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym_case] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_LTtemplate_GT] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_async] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_SLASH] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_void] = ACTIONS(3324),
    [anon_sym_delete] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3324),
    [sym_number] = ACTIONS(3324),
    [sym_private_property_identifier] = ACTIONS(3324),
    [sym_this] = ACTIONS(3324),
    [sym_super] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_null] = ACTIONS(3324),
    [sym_undefined] = ACTIONS(3324),
    [anon_sym_AT] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_readonly] = ACTIONS(3324),
    [anon_sym_get] = ACTIONS(3324),
    [anon_sym_set] = ACTIONS(3324),
    [anon_sym_declare] = ACTIONS(3324),
    [anon_sym_public] = ACTIONS(3324),
    [anon_sym_private] = ACTIONS(3324),
    [anon_sym_protected] = ACTIONS(3324),
    [anon_sym_override] = ACTIONS(3324),
    [anon_sym_module] = ACTIONS(3324),
    [anon_sym_any] = ACTIONS(3324),
    [anon_sym_number] = ACTIONS(3324),
    [anon_sym_boolean] = ACTIONS(3324),
    [anon_sym_string] = ACTIONS(3324),
    [anon_sym_symbol] = ACTIONS(3324),
    [anon_sym_object] = ACTIONS(3324),
    [anon_sym_abstract] = ACTIONS(3324),
    [anon_sym_interface] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [sym_html_comment] = ACTIONS(5),
  },
  [1279] = {
    [sym_comment] = STATE(1279),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_export] = ACTIONS(3294),
    [anon_sym_default] = ACTIONS(3294),
    [anon_sym_type] = ACTIONS(3294),
    [anon_sym_namespace] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3294),
    [anon_sym_RBRACE] = ACTIONS(3294),
    [anon_sym_typeof] = ACTIONS(3294),
    [anon_sym_import] = ACTIONS(3294),
    [anon_sym_with] = ACTIONS(3294),
    [anon_sym_var] = ACTIONS(3294),
    [anon_sym_let] = ACTIONS(3294),
    [anon_sym_const] = ACTIONS(3294),
    [anon_sym_BANG] = ACTIONS(3294),
    [anon_sym_if] = ACTIONS(3294),
    [anon_sym_switch] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3294),
    [anon_sym_await] = ACTIONS(3294),
    [anon_sym_while] = ACTIONS(3294),
    [anon_sym_do] = ACTIONS(3294),
    [anon_sym_try] = ACTIONS(3294),
    [anon_sym_break] = ACTIONS(3294),
    [anon_sym_continue] = ACTIONS(3294),
    [anon_sym_debugger] = ACTIONS(3294),
    [anon_sym_return] = ACTIONS(3294),
    [anon_sym_throw] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(3294),
    [anon_sym_case] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3294),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_LTtemplate_GT] = ACTIONS(3294),
    [anon_sym_DQUOTE] = ACTIONS(3294),
    [anon_sym_SQUOTE] = ACTIONS(3294),
    [anon_sym_class] = ACTIONS(3294),
    [anon_sym_async] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3294),
    [anon_sym_using] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(3294),
    [anon_sym_delete] = ACTIONS(3294),
    [anon_sym_PLUS_PLUS] = ACTIONS(3294),
    [anon_sym_DASH_DASH] = ACTIONS(3294),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3294),
    [sym_number] = ACTIONS(3294),
    [sym_private_property_identifier] = ACTIONS(3294),
    [sym_this] = ACTIONS(3294),
    [sym_super] = ACTIONS(3294),
    [sym_true] = ACTIONS(3294),
    [sym_false] = ACTIONS(3294),
    [sym_null] = ACTIONS(3294),
    [sym_undefined] = ACTIONS(3294),
    [anon_sym_AT] = ACTIONS(3294),
    [anon_sym_static] = ACTIONS(3294),
    [anon_sym_readonly] = ACTIONS(3294),
    [anon_sym_get] = ACTIONS(3294),
    [anon_sym_set] = ACTIONS(3294),
    [anon_sym_declare] = ACTIONS(3294),
    [anon_sym_public] = ACTIONS(3294),
    [anon_sym_private] = ACTIONS(3294),
    [anon_sym_protected] = ACTIONS(3294),
    [anon_sym_override] = ACTIONS(3294),
    [anon_sym_module] = ACTIONS(3294),
    [anon_sym_any] = ACTIONS(3294),
    [anon_sym_number] = ACTIONS(3294),
    [anon_sym_boolean] = ACTIONS(3294),
    [anon_sym_string] = ACTIONS(3294),
    [anon_sym_symbol] = ACTIONS(3294),
    [anon_sym_object] = ACTIONS(3294),
    [anon_sym_abstract] = ACTIONS(3294),
    [anon_sym_interface] = ACTIONS(3294),
    [anon_sym_enum] = ACTIONS(3294),
    [sym_html_comment] = ACTIONS(5),
  },
  [1280] = {
    [sym_comment] = STATE(1280),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_export] = ACTIONS(3292),
    [anon_sym_default] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_namespace] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_RBRACE] = ACTIONS(3292),
    [anon_sym_typeof] = ACTIONS(3292),
    [anon_sym_import] = ACTIONS(3292),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_var] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_const] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_switch] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_await] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_break] = ACTIONS(3292),
    [anon_sym_continue] = ACTIONS(3292),
    [anon_sym_debugger] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_throw] = ACTIONS(3292),
    [anon_sym_SEMI] = ACTIONS(3292),
    [anon_sym_case] = ACTIONS(3292),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LTtemplate_GT] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [anon_sym_class] = ACTIONS(3292),
    [anon_sym_async] = ACTIONS(3292),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_using] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3292),
    [anon_sym_void] = ACTIONS(3292),
    [anon_sym_delete] = ACTIONS(3292),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3292),
    [sym_number] = ACTIONS(3292),
    [sym_private_property_identifier] = ACTIONS(3292),
    [sym_this] = ACTIONS(3292),
    [sym_super] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_null] = ACTIONS(3292),
    [sym_undefined] = ACTIONS(3292),
    [anon_sym_AT] = ACTIONS(3292),
    [anon_sym_static] = ACTIONS(3292),
    [anon_sym_readonly] = ACTIONS(3292),
    [anon_sym_get] = ACTIONS(3292),
    [anon_sym_set] = ACTIONS(3292),
    [anon_sym_declare] = ACTIONS(3292),
    [anon_sym_public] = ACTIONS(3292),
    [anon_sym_private] = ACTIONS(3292),
    [anon_sym_protected] = ACTIONS(3292),
    [anon_sym_override] = ACTIONS(3292),
    [anon_sym_module] = ACTIONS(3292),
    [anon_sym_any] = ACTIONS(3292),
    [anon_sym_number] = ACTIONS(3292),
    [anon_sym_boolean] = ACTIONS(3292),
    [anon_sym_string] = ACTIONS(3292),
    [anon_sym_symbol] = ACTIONS(3292),
    [anon_sym_object] = ACTIONS(3292),
    [anon_sym_abstract] = ACTIONS(3292),
    [anon_sym_interface] = ACTIONS(3292),
    [anon_sym_enum] = ACTIONS(3292),
    [sym_html_comment] = ACTIONS(5),
  },
  [1281] = {
    [sym_comment] = STATE(1281),
    [sym_identifier] = ACTIONS(3142),
    [anon_sym_export] = ACTIONS(3142),
    [anon_sym_default] = ACTIONS(3142),
    [anon_sym_type] = ACTIONS(3142),
    [anon_sym_namespace] = ACTIONS(3142),
    [anon_sym_LBRACE] = ACTIONS(3142),
    [anon_sym_RBRACE] = ACTIONS(3142),
    [anon_sym_typeof] = ACTIONS(3142),
    [anon_sym_import] = ACTIONS(3142),
    [anon_sym_with] = ACTIONS(3142),
    [anon_sym_var] = ACTIONS(3142),
    [anon_sym_let] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_BANG] = ACTIONS(3142),
    [anon_sym_if] = ACTIONS(3142),
    [anon_sym_switch] = ACTIONS(3142),
    [anon_sym_for] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(3142),
    [anon_sym_await] = ACTIONS(3142),
    [anon_sym_while] = ACTIONS(3142),
    [anon_sym_do] = ACTIONS(3142),
    [anon_sym_try] = ACTIONS(3142),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3142),
    [anon_sym_debugger] = ACTIONS(3142),
    [anon_sym_return] = ACTIONS(3142),
    [anon_sym_throw] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3142),
    [anon_sym_case] = ACTIONS(3142),
    [anon_sym_yield] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_LTtemplate_GT] = ACTIONS(3142),
    [anon_sym_DQUOTE] = ACTIONS(3142),
    [anon_sym_SQUOTE] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_async] = ACTIONS(3142),
    [anon_sym_function] = ACTIONS(3142),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_using] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_SLASH] = ACTIONS(3142),
    [anon_sym_LT] = ACTIONS(3142),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_void] = ACTIONS(3142),
    [anon_sym_delete] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3142),
    [sym_number] = ACTIONS(3142),
    [sym_private_property_identifier] = ACTIONS(3142),
    [sym_this] = ACTIONS(3142),
    [sym_super] = ACTIONS(3142),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [sym_null] = ACTIONS(3142),
    [sym_undefined] = ACTIONS(3142),
    [anon_sym_AT] = ACTIONS(3142),
    [anon_sym_static] = ACTIONS(3142),
    [anon_sym_readonly] = ACTIONS(3142),
    [anon_sym_get] = ACTIONS(3142),
    [anon_sym_set] = ACTIONS(3142),
    [anon_sym_declare] = ACTIONS(3142),
    [anon_sym_public] = ACTIONS(3142),
    [anon_sym_private] = ACTIONS(3142),
    [anon_sym_protected] = ACTIONS(3142),
    [anon_sym_override] = ACTIONS(3142),
    [anon_sym_module] = ACTIONS(3142),
    [anon_sym_any] = ACTIONS(3142),
    [anon_sym_number] = ACTIONS(3142),
    [anon_sym_boolean] = ACTIONS(3142),
    [anon_sym_string] = ACTIONS(3142),
    [anon_sym_symbol] = ACTIONS(3142),
    [anon_sym_object] = ACTIONS(3142),
    [anon_sym_abstract] = ACTIONS(3142),
    [anon_sym_interface] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [sym_html_comment] = ACTIONS(5),
  },
  [1282] = {
    [sym_comment] = STATE(1282),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_export] = ACTIONS(3326),
    [anon_sym_default] = ACTIONS(3326),
    [anon_sym_type] = ACTIONS(3326),
    [anon_sym_namespace] = ACTIONS(3326),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_RBRACE] = ACTIONS(3326),
    [anon_sym_typeof] = ACTIONS(3326),
    [anon_sym_import] = ACTIONS(3326),
    [anon_sym_with] = ACTIONS(3326),
    [anon_sym_var] = ACTIONS(3326),
    [anon_sym_let] = ACTIONS(3326),
    [anon_sym_const] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_if] = ACTIONS(3326),
    [anon_sym_switch] = ACTIONS(3326),
    [anon_sym_for] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_await] = ACTIONS(3326),
    [anon_sym_while] = ACTIONS(3326),
    [anon_sym_do] = ACTIONS(3326),
    [anon_sym_try] = ACTIONS(3326),
    [anon_sym_break] = ACTIONS(3326),
    [anon_sym_continue] = ACTIONS(3326),
    [anon_sym_debugger] = ACTIONS(3326),
    [anon_sym_return] = ACTIONS(3326),
    [anon_sym_throw] = ACTIONS(3326),
    [anon_sym_SEMI] = ACTIONS(3326),
    [anon_sym_case] = ACTIONS(3326),
    [anon_sym_yield] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_LTtemplate_GT] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_class] = ACTIONS(3326),
    [anon_sym_async] = ACTIONS(3326),
    [anon_sym_function] = ACTIONS(3326),
    [anon_sym_new] = ACTIONS(3326),
    [anon_sym_using] = ACTIONS(3326),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3326),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_void] = ACTIONS(3326),
    [anon_sym_delete] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3326),
    [sym_number] = ACTIONS(3326),
    [sym_private_property_identifier] = ACTIONS(3326),
    [sym_this] = ACTIONS(3326),
    [sym_super] = ACTIONS(3326),
    [sym_true] = ACTIONS(3326),
    [sym_false] = ACTIONS(3326),
    [sym_null] = ACTIONS(3326),
    [sym_undefined] = ACTIONS(3326),
    [anon_sym_AT] = ACTIONS(3326),
    [anon_sym_static] = ACTIONS(3326),
    [anon_sym_readonly] = ACTIONS(3326),
    [anon_sym_get] = ACTIONS(3326),
    [anon_sym_set] = ACTIONS(3326),
    [anon_sym_declare] = ACTIONS(3326),
    [anon_sym_public] = ACTIONS(3326),
    [anon_sym_private] = ACTIONS(3326),
    [anon_sym_protected] = ACTIONS(3326),
    [anon_sym_override] = ACTIONS(3326),
    [anon_sym_module] = ACTIONS(3326),
    [anon_sym_any] = ACTIONS(3326),
    [anon_sym_number] = ACTIONS(3326),
    [anon_sym_boolean] = ACTIONS(3326),
    [anon_sym_string] = ACTIONS(3326),
    [anon_sym_symbol] = ACTIONS(3326),
    [anon_sym_object] = ACTIONS(3326),
    [anon_sym_abstract] = ACTIONS(3326),
    [anon_sym_interface] = ACTIONS(3326),
    [anon_sym_enum] = ACTIONS(3326),
    [sym_html_comment] = ACTIONS(5),
  },
  [1283] = {
    [sym_comment] = STATE(1283),
    [ts_builtin_sym_end] = ACTIONS(2253),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_else] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_LTtemplate_GT] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_function] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2251),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_number] = ACTIONS(2251),
    [sym_private_property_identifier] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [sym_null] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_readonly] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_override] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_object] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [sym_html_comment] = ACTIONS(5),
  },
  [1284] = {
    [sym_comment] = STATE(1284),
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_export] = ACTIONS(3338),
    [anon_sym_default] = ACTIONS(3338),
    [anon_sym_type] = ACTIONS(3338),
    [anon_sym_namespace] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_typeof] = ACTIONS(3338),
    [anon_sym_import] = ACTIONS(3338),
    [anon_sym_with] = ACTIONS(3338),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_if] = ACTIONS(3338),
    [anon_sym_switch] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3338),
    [anon_sym_await] = ACTIONS(3338),
    [anon_sym_while] = ACTIONS(3338),
    [anon_sym_do] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3338),
    [anon_sym_break] = ACTIONS(3338),
    [anon_sym_continue] = ACTIONS(3338),
    [anon_sym_debugger] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3338),
    [anon_sym_throw] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym_case] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_LTtemplate_GT] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_class] = ACTIONS(3338),
    [anon_sym_async] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3338),
    [anon_sym_using] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3338),
    [anon_sym_delete] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3338),
    [sym_number] = ACTIONS(3338),
    [sym_private_property_identifier] = ACTIONS(3338),
    [sym_this] = ACTIONS(3338),
    [sym_super] = ACTIONS(3338),
    [sym_true] = ACTIONS(3338),
    [sym_false] = ACTIONS(3338),
    [sym_null] = ACTIONS(3338),
    [sym_undefined] = ACTIONS(3338),
    [anon_sym_AT] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_readonly] = ACTIONS(3338),
    [anon_sym_get] = ACTIONS(3338),
    [anon_sym_set] = ACTIONS(3338),
    [anon_sym_declare] = ACTIONS(3338),
    [anon_sym_public] = ACTIONS(3338),
    [anon_sym_private] = ACTIONS(3338),
    [anon_sym_protected] = ACTIONS(3338),
    [anon_sym_override] = ACTIONS(3338),
    [anon_sym_module] = ACTIONS(3338),
    [anon_sym_any] = ACTIONS(3338),
    [anon_sym_number] = ACTIONS(3338),
    [anon_sym_boolean] = ACTIONS(3338),
    [anon_sym_string] = ACTIONS(3338),
    [anon_sym_symbol] = ACTIONS(3338),
    [anon_sym_object] = ACTIONS(3338),
    [anon_sym_abstract] = ACTIONS(3338),
    [anon_sym_interface] = ACTIONS(3338),
    [anon_sym_enum] = ACTIONS(3338),
    [sym_html_comment] = ACTIONS(5),
  },
  [1285] = {
    [sym_comment] = STATE(1285),
    [ts_builtin_sym_end] = ACTIONS(3458),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [1286] = {
    [sym_comment] = STATE(1286),
    [ts_builtin_sym_end] = ACTIONS(3460),
    [sym_identifier] = ACTIONS(3140),
    [anon_sym_export] = ACTIONS(3140),
    [anon_sym_type] = ACTIONS(3140),
    [anon_sym_namespace] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_RBRACE] = ACTIONS(3140),
    [anon_sym_typeof] = ACTIONS(3140),
    [anon_sym_import] = ACTIONS(3140),
    [anon_sym_with] = ACTIONS(3140),
    [anon_sym_var] = ACTIONS(3140),
    [anon_sym_let] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_else] = ACTIONS(3140),
    [anon_sym_if] = ACTIONS(3140),
    [anon_sym_switch] = ACTIONS(3140),
    [anon_sym_for] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3140),
    [anon_sym_await] = ACTIONS(3140),
    [anon_sym_while] = ACTIONS(3140),
    [anon_sym_do] = ACTIONS(3140),
    [anon_sym_try] = ACTIONS(3140),
    [anon_sym_break] = ACTIONS(3140),
    [anon_sym_continue] = ACTIONS(3140),
    [anon_sym_debugger] = ACTIONS(3140),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_throw] = ACTIONS(3140),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym_yield] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(3140),
    [anon_sym_LTtemplate_GT] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3140),
    [anon_sym_async] = ACTIONS(3140),
    [anon_sym_function] = ACTIONS(3140),
    [anon_sym_new] = ACTIONS(3140),
    [anon_sym_using] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3140),
    [anon_sym_SLASH] = ACTIONS(3140),
    [anon_sym_LT] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_void] = ACTIONS(3140),
    [anon_sym_delete] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3140),
    [sym_number] = ACTIONS(3140),
    [sym_private_property_identifier] = ACTIONS(3140),
    [sym_this] = ACTIONS(3140),
    [sym_super] = ACTIONS(3140),
    [sym_true] = ACTIONS(3140),
    [sym_false] = ACTIONS(3140),
    [sym_null] = ACTIONS(3140),
    [sym_undefined] = ACTIONS(3140),
    [anon_sym_AT] = ACTIONS(3140),
    [anon_sym_static] = ACTIONS(3140),
    [anon_sym_readonly] = ACTIONS(3140),
    [anon_sym_get] = ACTIONS(3140),
    [anon_sym_set] = ACTIONS(3140),
    [anon_sym_declare] = ACTIONS(3140),
    [anon_sym_public] = ACTIONS(3140),
    [anon_sym_private] = ACTIONS(3140),
    [anon_sym_protected] = ACTIONS(3140),
    [anon_sym_override] = ACTIONS(3140),
    [anon_sym_module] = ACTIONS(3140),
    [anon_sym_any] = ACTIONS(3140),
    [anon_sym_number] = ACTIONS(3140),
    [anon_sym_boolean] = ACTIONS(3140),
    [anon_sym_string] = ACTIONS(3140),
    [anon_sym_symbol] = ACTIONS(3140),
    [anon_sym_object] = ACTIONS(3140),
    [anon_sym_abstract] = ACTIONS(3140),
    [anon_sym_interface] = ACTIONS(3140),
    [anon_sym_enum] = ACTIONS(3140),
    [sym_html_comment] = ACTIONS(5),
  },
  [1287] = {
    [sym_comment] = STATE(1287),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_export] = ACTIONS(3340),
    [anon_sym_default] = ACTIONS(3340),
    [anon_sym_type] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3340),
    [anon_sym_typeof] = ACTIONS(3340),
    [anon_sym_import] = ACTIONS(3340),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_var] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_BANG] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_await] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_debugger] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_throw] = ACTIONS(3340),
    [anon_sym_SEMI] = ACTIONS(3340),
    [anon_sym_case] = ACTIONS(3340),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LTtemplate_GT] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_SQUOTE] = ACTIONS(3340),
    [anon_sym_class] = ACTIONS(3340),
    [anon_sym_async] = ACTIONS(3340),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_SLASH] = ACTIONS(3340),
    [anon_sym_LT] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3340),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_delete] = ACTIONS(3340),
    [anon_sym_PLUS_PLUS] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3340),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3340),
    [sym_number] = ACTIONS(3340),
    [sym_private_property_identifier] = ACTIONS(3340),
    [sym_this] = ACTIONS(3340),
    [sym_super] = ACTIONS(3340),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [sym_null] = ACTIONS(3340),
    [sym_undefined] = ACTIONS(3340),
    [anon_sym_AT] = ACTIONS(3340),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_readonly] = ACTIONS(3340),
    [anon_sym_get] = ACTIONS(3340),
    [anon_sym_set] = ACTIONS(3340),
    [anon_sym_declare] = ACTIONS(3340),
    [anon_sym_public] = ACTIONS(3340),
    [anon_sym_private] = ACTIONS(3340),
    [anon_sym_protected] = ACTIONS(3340),
    [anon_sym_override] = ACTIONS(3340),
    [anon_sym_module] = ACTIONS(3340),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_object] = ACTIONS(3340),
    [anon_sym_abstract] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [sym_html_comment] = ACTIONS(5),
  },
  [1288] = {
    [sym_comment] = STATE(1288),
    [sym_identifier] = ACTIONS(3342),
    [anon_sym_export] = ACTIONS(3342),
    [anon_sym_default] = ACTIONS(3342),
    [anon_sym_type] = ACTIONS(3342),
    [anon_sym_namespace] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_typeof] = ACTIONS(3342),
    [anon_sym_import] = ACTIONS(3342),
    [anon_sym_with] = ACTIONS(3342),
    [anon_sym_var] = ACTIONS(3342),
    [anon_sym_let] = ACTIONS(3342),
    [anon_sym_const] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_if] = ACTIONS(3342),
    [anon_sym_switch] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3342),
    [anon_sym_await] = ACTIONS(3342),
    [anon_sym_while] = ACTIONS(3342),
    [anon_sym_do] = ACTIONS(3342),
    [anon_sym_try] = ACTIONS(3342),
    [anon_sym_break] = ACTIONS(3342),
    [anon_sym_continue] = ACTIONS(3342),
    [anon_sym_debugger] = ACTIONS(3342),
    [anon_sym_return] = ACTIONS(3342),
    [anon_sym_throw] = ACTIONS(3342),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym_case] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3342),
    [anon_sym_LBRACK] = ACTIONS(3342),
    [anon_sym_LTtemplate_GT] = ACTIONS(3342),
    [anon_sym_DQUOTE] = ACTIONS(3342),
    [anon_sym_SQUOTE] = ACTIONS(3342),
    [anon_sym_class] = ACTIONS(3342),
    [anon_sym_async] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3342),
    [anon_sym_using] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_SLASH] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_void] = ACTIONS(3342),
    [anon_sym_delete] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3342),
    [sym_number] = ACTIONS(3342),
    [sym_private_property_identifier] = ACTIONS(3342),
    [sym_this] = ACTIONS(3342),
    [sym_super] = ACTIONS(3342),
    [sym_true] = ACTIONS(3342),
    [sym_false] = ACTIONS(3342),
    [sym_null] = ACTIONS(3342),
    [sym_undefined] = ACTIONS(3342),
    [anon_sym_AT] = ACTIONS(3342),
    [anon_sym_static] = ACTIONS(3342),
    [anon_sym_readonly] = ACTIONS(3342),
    [anon_sym_get] = ACTIONS(3342),
    [anon_sym_set] = ACTIONS(3342),
    [anon_sym_declare] = ACTIONS(3342),
    [anon_sym_public] = ACTIONS(3342),
    [anon_sym_private] = ACTIONS(3342),
    [anon_sym_protected] = ACTIONS(3342),
    [anon_sym_override] = ACTIONS(3342),
    [anon_sym_module] = ACTIONS(3342),
    [anon_sym_any] = ACTIONS(3342),
    [anon_sym_number] = ACTIONS(3342),
    [anon_sym_boolean] = ACTIONS(3342),
    [anon_sym_string] = ACTIONS(3342),
    [anon_sym_symbol] = ACTIONS(3342),
    [anon_sym_object] = ACTIONS(3342),
    [anon_sym_abstract] = ACTIONS(3342),
    [anon_sym_interface] = ACTIONS(3342),
    [anon_sym_enum] = ACTIONS(3342),
    [sym_html_comment] = ACTIONS(5),
  },
  [1289] = {
    [sym_comment] = STATE(1289),
    [ts_builtin_sym_end] = ACTIONS(3458),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [1290] = {
    [sym_comment] = STATE(1290),
    [ts_builtin_sym_end] = ACTIONS(3458),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_else] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [1291] = {
    [sym_comment] = STATE(1291),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_export] = ACTIONS(3344),
    [anon_sym_default] = ACTIONS(3344),
    [anon_sym_type] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_RBRACE] = ACTIONS(3344),
    [anon_sym_typeof] = ACTIONS(3344),
    [anon_sym_import] = ACTIONS(3344),
    [anon_sym_with] = ACTIONS(3344),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_await] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_debugger] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3344),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LTtemplate_GT] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_SQUOTE] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_async] = ACTIONS(3344),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_SLASH] = ACTIONS(3344),
    [anon_sym_LT] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_void] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_PLUS_PLUS] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3344),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3344),
    [sym_number] = ACTIONS(3344),
    [sym_private_property_identifier] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [sym_super] = ACTIONS(3344),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [sym_null] = ACTIONS(3344),
    [sym_undefined] = ACTIONS(3344),
    [anon_sym_AT] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_readonly] = ACTIONS(3344),
    [anon_sym_get] = ACTIONS(3344),
    [anon_sym_set] = ACTIONS(3344),
    [anon_sym_declare] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_override] = ACTIONS(3344),
    [anon_sym_module] = ACTIONS(3344),
    [anon_sym_any] = ACTIONS(3344),
    [anon_sym_number] = ACTIONS(3344),
    [anon_sym_boolean] = ACTIONS(3344),
    [anon_sym_string] = ACTIONS(3344),
    [anon_sym_symbol] = ACTIONS(3344),
    [anon_sym_object] = ACTIONS(3344),
    [anon_sym_abstract] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1292] = {
    [sym_comment] = STATE(1292),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_export] = ACTIONS(3352),
    [anon_sym_default] = ACTIONS(3352),
    [anon_sym_type] = ACTIONS(3352),
    [anon_sym_namespace] = ACTIONS(3352),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_RBRACE] = ACTIONS(3352),
    [anon_sym_typeof] = ACTIONS(3352),
    [anon_sym_import] = ACTIONS(3352),
    [anon_sym_with] = ACTIONS(3352),
    [anon_sym_var] = ACTIONS(3352),
    [anon_sym_let] = ACTIONS(3352),
    [anon_sym_const] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_if] = ACTIONS(3352),
    [anon_sym_switch] = ACTIONS(3352),
    [anon_sym_for] = ACTIONS(3352),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [anon_sym_await] = ACTIONS(3352),
    [anon_sym_while] = ACTIONS(3352),
    [anon_sym_do] = ACTIONS(3352),
    [anon_sym_try] = ACTIONS(3352),
    [anon_sym_break] = ACTIONS(3352),
    [anon_sym_continue] = ACTIONS(3352),
    [anon_sym_debugger] = ACTIONS(3352),
    [anon_sym_return] = ACTIONS(3352),
    [anon_sym_throw] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_case] = ACTIONS(3352),
    [anon_sym_yield] = ACTIONS(3352),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_LTtemplate_GT] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [anon_sym_SQUOTE] = ACTIONS(3352),
    [anon_sym_class] = ACTIONS(3352),
    [anon_sym_async] = ACTIONS(3352),
    [anon_sym_function] = ACTIONS(3352),
    [anon_sym_new] = ACTIONS(3352),
    [anon_sym_using] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_SLASH] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_void] = ACTIONS(3352),
    [anon_sym_delete] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [sym_number] = ACTIONS(3352),
    [sym_private_property_identifier] = ACTIONS(3352),
    [sym_this] = ACTIONS(3352),
    [sym_super] = ACTIONS(3352),
    [sym_true] = ACTIONS(3352),
    [sym_false] = ACTIONS(3352),
    [sym_null] = ACTIONS(3352),
    [sym_undefined] = ACTIONS(3352),
    [anon_sym_AT] = ACTIONS(3352),
    [anon_sym_static] = ACTIONS(3352),
    [anon_sym_readonly] = ACTIONS(3352),
    [anon_sym_get] = ACTIONS(3352),
    [anon_sym_set] = ACTIONS(3352),
    [anon_sym_declare] = ACTIONS(3352),
    [anon_sym_public] = ACTIONS(3352),
    [anon_sym_private] = ACTIONS(3352),
    [anon_sym_protected] = ACTIONS(3352),
    [anon_sym_override] = ACTIONS(3352),
    [anon_sym_module] = ACTIONS(3352),
    [anon_sym_any] = ACTIONS(3352),
    [anon_sym_number] = ACTIONS(3352),
    [anon_sym_boolean] = ACTIONS(3352),
    [anon_sym_string] = ACTIONS(3352),
    [anon_sym_symbol] = ACTIONS(3352),
    [anon_sym_object] = ACTIONS(3352),
    [anon_sym_abstract] = ACTIONS(3352),
    [anon_sym_interface] = ACTIONS(3352),
    [anon_sym_enum] = ACTIONS(3352),
    [sym_html_comment] = ACTIONS(5),
  },
  [1293] = {
    [sym_comment] = STATE(1293),
    [sym_identifier] = ACTIONS(3320),
    [anon_sym_export] = ACTIONS(3320),
    [anon_sym_default] = ACTIONS(3320),
    [anon_sym_type] = ACTIONS(3320),
    [anon_sym_namespace] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3320),
    [anon_sym_RBRACE] = ACTIONS(3320),
    [anon_sym_typeof] = ACTIONS(3320),
    [anon_sym_import] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3320),
    [anon_sym_var] = ACTIONS(3320),
    [anon_sym_let] = ACTIONS(3320),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_BANG] = ACTIONS(3320),
    [anon_sym_if] = ACTIONS(3320),
    [anon_sym_switch] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3320),
    [anon_sym_await] = ACTIONS(3320),
    [anon_sym_while] = ACTIONS(3320),
    [anon_sym_do] = ACTIONS(3320),
    [anon_sym_try] = ACTIONS(3320),
    [anon_sym_break] = ACTIONS(3320),
    [anon_sym_continue] = ACTIONS(3320),
    [anon_sym_debugger] = ACTIONS(3320),
    [anon_sym_return] = ACTIONS(3320),
    [anon_sym_throw] = ACTIONS(3320),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym_case] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3320),
    [anon_sym_LBRACK] = ACTIONS(3320),
    [anon_sym_LTtemplate_GT] = ACTIONS(3320),
    [anon_sym_DQUOTE] = ACTIONS(3320),
    [anon_sym_SQUOTE] = ACTIONS(3320),
    [anon_sym_class] = ACTIONS(3320),
    [anon_sym_async] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3320),
    [anon_sym_using] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3320),
    [anon_sym_DASH] = ACTIONS(3320),
    [anon_sym_SLASH] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [anon_sym_void] = ACTIONS(3320),
    [anon_sym_delete] = ACTIONS(3320),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3320),
    [sym_number] = ACTIONS(3320),
    [sym_private_property_identifier] = ACTIONS(3320),
    [sym_this] = ACTIONS(3320),
    [sym_super] = ACTIONS(3320),
    [sym_true] = ACTIONS(3320),
    [sym_false] = ACTIONS(3320),
    [sym_null] = ACTIONS(3320),
    [sym_undefined] = ACTIONS(3320),
    [anon_sym_AT] = ACTIONS(3320),
    [anon_sym_static] = ACTIONS(3320),
    [anon_sym_readonly] = ACTIONS(3320),
    [anon_sym_get] = ACTIONS(3320),
    [anon_sym_set] = ACTIONS(3320),
    [anon_sym_declare] = ACTIONS(3320),
    [anon_sym_public] = ACTIONS(3320),
    [anon_sym_private] = ACTIONS(3320),
    [anon_sym_protected] = ACTIONS(3320),
    [anon_sym_override] = ACTIONS(3320),
    [anon_sym_module] = ACTIONS(3320),
    [anon_sym_any] = ACTIONS(3320),
    [anon_sym_number] = ACTIONS(3320),
    [anon_sym_boolean] = ACTIONS(3320),
    [anon_sym_string] = ACTIONS(3320),
    [anon_sym_symbol] = ACTIONS(3320),
    [anon_sym_object] = ACTIONS(3320),
    [anon_sym_abstract] = ACTIONS(3320),
    [anon_sym_interface] = ACTIONS(3320),
    [anon_sym_enum] = ACTIONS(3320),
    [sym_html_comment] = ACTIONS(5),
  },
  [1294] = {
    [sym_comment] = STATE(1294),
    [ts_builtin_sym_end] = ACTIONS(3462),
    [sym_identifier] = ACTIONS(3220),
    [anon_sym_export] = ACTIONS(3220),
    [anon_sym_type] = ACTIONS(3220),
    [anon_sym_namespace] = ACTIONS(3220),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_RBRACE] = ACTIONS(3220),
    [anon_sym_typeof] = ACTIONS(3220),
    [anon_sym_import] = ACTIONS(3220),
    [anon_sym_with] = ACTIONS(3220),
    [anon_sym_var] = ACTIONS(3220),
    [anon_sym_let] = ACTIONS(3220),
    [anon_sym_const] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_else] = ACTIONS(3220),
    [anon_sym_if] = ACTIONS(3220),
    [anon_sym_switch] = ACTIONS(3220),
    [anon_sym_for] = ACTIONS(3220),
    [anon_sym_LPAREN] = ACTIONS(3220),
    [anon_sym_await] = ACTIONS(3220),
    [anon_sym_while] = ACTIONS(3220),
    [anon_sym_do] = ACTIONS(3220),
    [anon_sym_try] = ACTIONS(3220),
    [anon_sym_break] = ACTIONS(3220),
    [anon_sym_continue] = ACTIONS(3220),
    [anon_sym_debugger] = ACTIONS(3220),
    [anon_sym_return] = ACTIONS(3220),
    [anon_sym_throw] = ACTIONS(3220),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym_yield] = ACTIONS(3220),
    [anon_sym_LBRACK] = ACTIONS(3220),
    [anon_sym_LTtemplate_GT] = ACTIONS(3220),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [anon_sym_class] = ACTIONS(3220),
    [anon_sym_async] = ACTIONS(3220),
    [anon_sym_function] = ACTIONS(3220),
    [anon_sym_new] = ACTIONS(3220),
    [anon_sym_using] = ACTIONS(3220),
    [anon_sym_PLUS] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3220),
    [anon_sym_SLASH] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_void] = ACTIONS(3220),
    [anon_sym_delete] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3220),
    [sym_number] = ACTIONS(3220),
    [sym_private_property_identifier] = ACTIONS(3220),
    [sym_this] = ACTIONS(3220),
    [sym_super] = ACTIONS(3220),
    [sym_true] = ACTIONS(3220),
    [sym_false] = ACTIONS(3220),
    [sym_null] = ACTIONS(3220),
    [sym_undefined] = ACTIONS(3220),
    [anon_sym_AT] = ACTIONS(3220),
    [anon_sym_static] = ACTIONS(3220),
    [anon_sym_readonly] = ACTIONS(3220),
    [anon_sym_get] = ACTIONS(3220),
    [anon_sym_set] = ACTIONS(3220),
    [anon_sym_declare] = ACTIONS(3220),
    [anon_sym_public] = ACTIONS(3220),
    [anon_sym_private] = ACTIONS(3220),
    [anon_sym_protected] = ACTIONS(3220),
    [anon_sym_override] = ACTIONS(3220),
    [anon_sym_module] = ACTIONS(3220),
    [anon_sym_any] = ACTIONS(3220),
    [anon_sym_number] = ACTIONS(3220),
    [anon_sym_boolean] = ACTIONS(3220),
    [anon_sym_string] = ACTIONS(3220),
    [anon_sym_symbol] = ACTIONS(3220),
    [anon_sym_object] = ACTIONS(3220),
    [anon_sym_abstract] = ACTIONS(3220),
    [anon_sym_interface] = ACTIONS(3220),
    [anon_sym_enum] = ACTIONS(3220),
    [sym_html_comment] = ACTIONS(5),
  },
  [1295] = {
    [sym_comment] = STATE(1295),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_export] = ACTIONS(2183),
    [anon_sym_type] = ACTIONS(2183),
    [anon_sym_namespace] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_typeof] = ACTIONS(2183),
    [anon_sym_import] = ACTIONS(2183),
    [anon_sym_with] = ACTIONS(2183),
    [anon_sym_var] = ACTIONS(2183),
    [anon_sym_let] = ACTIONS(2183),
    [anon_sym_const] = ACTIONS(2183),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_else] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2183),
    [anon_sym_for] = ACTIONS(2183),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(2183),
    [anon_sym_do] = ACTIONS(2183),
    [anon_sym_try] = ACTIONS(2183),
    [anon_sym_break] = ACTIONS(2183),
    [anon_sym_continue] = ACTIONS(2183),
    [anon_sym_debugger] = ACTIONS(2183),
    [anon_sym_return] = ACTIONS(2183),
    [anon_sym_throw] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2183),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [anon_sym_class] = ACTIONS(2183),
    [anon_sym_async] = ACTIONS(2183),
    [anon_sym_function] = ACTIONS(2183),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_using] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2183),
    [anon_sym_delete] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2183),
    [sym_private_property_identifier] = ACTIONS(2183),
    [sym_this] = ACTIONS(2183),
    [sym_super] = ACTIONS(2183),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_undefined] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2183),
    [anon_sym_readonly] = ACTIONS(2183),
    [anon_sym_get] = ACTIONS(2183),
    [anon_sym_set] = ACTIONS(2183),
    [anon_sym_declare] = ACTIONS(2183),
    [anon_sym_public] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2183),
    [anon_sym_protected] = ACTIONS(2183),
    [anon_sym_override] = ACTIONS(2183),
    [anon_sym_module] = ACTIONS(2183),
    [anon_sym_any] = ACTIONS(2183),
    [anon_sym_number] = ACTIONS(2183),
    [anon_sym_boolean] = ACTIONS(2183),
    [anon_sym_string] = ACTIONS(2183),
    [anon_sym_symbol] = ACTIONS(2183),
    [anon_sym_object] = ACTIONS(2183),
    [anon_sym_abstract] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2183),
    [anon_sym_enum] = ACTIONS(2183),
    [sym_html_comment] = ACTIONS(5),
  },
  [1296] = {
    [sym_comment] = STATE(1296),
    [sym_identifier] = ACTIONS(3364),
    [anon_sym_export] = ACTIONS(3364),
    [anon_sym_default] = ACTIONS(3364),
    [anon_sym_type] = ACTIONS(3364),
    [anon_sym_namespace] = ACTIONS(3364),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_RBRACE] = ACTIONS(3364),
    [anon_sym_typeof] = ACTIONS(3364),
    [anon_sym_import] = ACTIONS(3364),
    [anon_sym_with] = ACTIONS(3364),
    [anon_sym_var] = ACTIONS(3364),
    [anon_sym_let] = ACTIONS(3364),
    [anon_sym_const] = ACTIONS(3364),
    [anon_sym_BANG] = ACTIONS(3364),
    [anon_sym_if] = ACTIONS(3364),
    [anon_sym_switch] = ACTIONS(3364),
    [anon_sym_for] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(3364),
    [anon_sym_await] = ACTIONS(3364),
    [anon_sym_while] = ACTIONS(3364),
    [anon_sym_do] = ACTIONS(3364),
    [anon_sym_try] = ACTIONS(3364),
    [anon_sym_break] = ACTIONS(3364),
    [anon_sym_continue] = ACTIONS(3364),
    [anon_sym_debugger] = ACTIONS(3364),
    [anon_sym_return] = ACTIONS(3364),
    [anon_sym_throw] = ACTIONS(3364),
    [anon_sym_SEMI] = ACTIONS(3364),
    [anon_sym_case] = ACTIONS(3364),
    [anon_sym_yield] = ACTIONS(3364),
    [anon_sym_LBRACK] = ACTIONS(3364),
    [anon_sym_LTtemplate_GT] = ACTIONS(3364),
    [anon_sym_DQUOTE] = ACTIONS(3364),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym_class] = ACTIONS(3364),
    [anon_sym_async] = ACTIONS(3364),
    [anon_sym_function] = ACTIONS(3364),
    [anon_sym_new] = ACTIONS(3364),
    [anon_sym_using] = ACTIONS(3364),
    [anon_sym_PLUS] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3364),
    [anon_sym_SLASH] = ACTIONS(3364),
    [anon_sym_LT] = ACTIONS(3364),
    [anon_sym_TILDE] = ACTIONS(3364),
    [anon_sym_void] = ACTIONS(3364),
    [anon_sym_delete] = ACTIONS(3364),
    [anon_sym_PLUS_PLUS] = ACTIONS(3364),
    [anon_sym_DASH_DASH] = ACTIONS(3364),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3364),
    [sym_number] = ACTIONS(3364),
    [sym_private_property_identifier] = ACTIONS(3364),
    [sym_this] = ACTIONS(3364),
    [sym_super] = ACTIONS(3364),
    [sym_true] = ACTIONS(3364),
    [sym_false] = ACTIONS(3364),
    [sym_null] = ACTIONS(3364),
    [sym_undefined] = ACTIONS(3364),
    [anon_sym_AT] = ACTIONS(3364),
    [anon_sym_static] = ACTIONS(3364),
    [anon_sym_readonly] = ACTIONS(3364),
    [anon_sym_get] = ACTIONS(3364),
    [anon_sym_set] = ACTIONS(3364),
    [anon_sym_declare] = ACTIONS(3364),
    [anon_sym_public] = ACTIONS(3364),
    [anon_sym_private] = ACTIONS(3364),
    [anon_sym_protected] = ACTIONS(3364),
    [anon_sym_override] = ACTIONS(3364),
    [anon_sym_module] = ACTIONS(3364),
    [anon_sym_any] = ACTIONS(3364),
    [anon_sym_number] = ACTIONS(3364),
    [anon_sym_boolean] = ACTIONS(3364),
    [anon_sym_string] = ACTIONS(3364),
    [anon_sym_symbol] = ACTIONS(3364),
    [anon_sym_object] = ACTIONS(3364),
    [anon_sym_abstract] = ACTIONS(3364),
    [anon_sym_interface] = ACTIONS(3364),
    [anon_sym_enum] = ACTIONS(3364),
    [sym_html_comment] = ACTIONS(5),
  },
  [1297] = {
    [sym_comment] = STATE(1297),
    [sym_identifier] = ACTIONS(3370),
    [anon_sym_export] = ACTIONS(3370),
    [anon_sym_default] = ACTIONS(3370),
    [anon_sym_type] = ACTIONS(3370),
    [anon_sym_namespace] = ACTIONS(3370),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_typeof] = ACTIONS(3370),
    [anon_sym_import] = ACTIONS(3370),
    [anon_sym_with] = ACTIONS(3370),
    [anon_sym_var] = ACTIONS(3370),
    [anon_sym_let] = ACTIONS(3370),
    [anon_sym_const] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_if] = ACTIONS(3370),
    [anon_sym_switch] = ACTIONS(3370),
    [anon_sym_for] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_await] = ACTIONS(3370),
    [anon_sym_while] = ACTIONS(3370),
    [anon_sym_do] = ACTIONS(3370),
    [anon_sym_try] = ACTIONS(3370),
    [anon_sym_break] = ACTIONS(3370),
    [anon_sym_continue] = ACTIONS(3370),
    [anon_sym_debugger] = ACTIONS(3370),
    [anon_sym_return] = ACTIONS(3370),
    [anon_sym_throw] = ACTIONS(3370),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym_case] = ACTIONS(3370),
    [anon_sym_yield] = ACTIONS(3370),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_LTtemplate_GT] = ACTIONS(3370),
    [anon_sym_DQUOTE] = ACTIONS(3370),
    [anon_sym_SQUOTE] = ACTIONS(3370),
    [anon_sym_class] = ACTIONS(3370),
    [anon_sym_async] = ACTIONS(3370),
    [anon_sym_function] = ACTIONS(3370),
    [anon_sym_new] = ACTIONS(3370),
    [anon_sym_using] = ACTIONS(3370),
    [anon_sym_PLUS] = ACTIONS(3370),
    [anon_sym_DASH] = ACTIONS(3370),
    [anon_sym_SLASH] = ACTIONS(3370),
    [anon_sym_LT] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_void] = ACTIONS(3370),
    [anon_sym_delete] = ACTIONS(3370),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3370),
    [sym_number] = ACTIONS(3370),
    [sym_private_property_identifier] = ACTIONS(3370),
    [sym_this] = ACTIONS(3370),
    [sym_super] = ACTIONS(3370),
    [sym_true] = ACTIONS(3370),
    [sym_false] = ACTIONS(3370),
    [sym_null] = ACTIONS(3370),
    [sym_undefined] = ACTIONS(3370),
    [anon_sym_AT] = ACTIONS(3370),
    [anon_sym_static] = ACTIONS(3370),
    [anon_sym_readonly] = ACTIONS(3370),
    [anon_sym_get] = ACTIONS(3370),
    [anon_sym_set] = ACTIONS(3370),
    [anon_sym_declare] = ACTIONS(3370),
    [anon_sym_public] = ACTIONS(3370),
    [anon_sym_private] = ACTIONS(3370),
    [anon_sym_protected] = ACTIONS(3370),
    [anon_sym_override] = ACTIONS(3370),
    [anon_sym_module] = ACTIONS(3370),
    [anon_sym_any] = ACTIONS(3370),
    [anon_sym_number] = ACTIONS(3370),
    [anon_sym_boolean] = ACTIONS(3370),
    [anon_sym_string] = ACTIONS(3370),
    [anon_sym_symbol] = ACTIONS(3370),
    [anon_sym_object] = ACTIONS(3370),
    [anon_sym_abstract] = ACTIONS(3370),
    [anon_sym_interface] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3370),
    [sym_html_comment] = ACTIONS(5),
  },
  [1298] = {
    [sym_comment] = STATE(1298),
    [ts_builtin_sym_end] = ACTIONS(3464),
    [sym_identifier] = ACTIONS(3218),
    [anon_sym_export] = ACTIONS(3218),
    [anon_sym_type] = ACTIONS(3218),
    [anon_sym_namespace] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_RBRACE] = ACTIONS(3218),
    [anon_sym_typeof] = ACTIONS(3218),
    [anon_sym_import] = ACTIONS(3218),
    [anon_sym_with] = ACTIONS(3218),
    [anon_sym_var] = ACTIONS(3218),
    [anon_sym_let] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3218),
    [anon_sym_BANG] = ACTIONS(3218),
    [anon_sym_else] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_switch] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_LPAREN] = ACTIONS(3218),
    [anon_sym_await] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_debugger] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_throw] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_yield] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_LTtemplate_GT] = ACTIONS(3218),
    [anon_sym_DQUOTE] = ACTIONS(3218),
    [anon_sym_SQUOTE] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_async] = ACTIONS(3218),
    [anon_sym_function] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_using] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_SLASH] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3218),
    [anon_sym_TILDE] = ACTIONS(3218),
    [anon_sym_void] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3218),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3218),
    [sym_number] = ACTIONS(3218),
    [sym_private_property_identifier] = ACTIONS(3218),
    [sym_this] = ACTIONS(3218),
    [sym_super] = ACTIONS(3218),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [sym_null] = ACTIONS(3218),
    [sym_undefined] = ACTIONS(3218),
    [anon_sym_AT] = ACTIONS(3218),
    [anon_sym_static] = ACTIONS(3218),
    [anon_sym_readonly] = ACTIONS(3218),
    [anon_sym_get] = ACTIONS(3218),
    [anon_sym_set] = ACTIONS(3218),
    [anon_sym_declare] = ACTIONS(3218),
    [anon_sym_public] = ACTIONS(3218),
    [anon_sym_private] = ACTIONS(3218),
    [anon_sym_protected] = ACTIONS(3218),
    [anon_sym_override] = ACTIONS(3218),
    [anon_sym_module] = ACTIONS(3218),
    [anon_sym_any] = ACTIONS(3218),
    [anon_sym_number] = ACTIONS(3218),
    [anon_sym_boolean] = ACTIONS(3218),
    [anon_sym_string] = ACTIONS(3218),
    [anon_sym_symbol] = ACTIONS(3218),
    [anon_sym_object] = ACTIONS(3218),
    [anon_sym_abstract] = ACTIONS(3218),
    [anon_sym_interface] = ACTIONS(3218),
    [anon_sym_enum] = ACTIONS(3218),
    [sym_html_comment] = ACTIONS(5),
  },
  [1299] = {
    [sym_comment] = STATE(1299),
    [sym_identifier] = ACTIONS(3216),
    [anon_sym_export] = ACTIONS(3216),
    [anon_sym_default] = ACTIONS(3216),
    [anon_sym_type] = ACTIONS(3216),
    [anon_sym_namespace] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_typeof] = ACTIONS(3216),
    [anon_sym_import] = ACTIONS(3216),
    [anon_sym_with] = ACTIONS(3216),
    [anon_sym_var] = ACTIONS(3216),
    [anon_sym_let] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_if] = ACTIONS(3216),
    [anon_sym_switch] = ACTIONS(3216),
    [anon_sym_for] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [anon_sym_await] = ACTIONS(3216),
    [anon_sym_while] = ACTIONS(3216),
    [anon_sym_do] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(3216),
    [anon_sym_break] = ACTIONS(3216),
    [anon_sym_continue] = ACTIONS(3216),
    [anon_sym_debugger] = ACTIONS(3216),
    [anon_sym_return] = ACTIONS(3216),
    [anon_sym_throw] = ACTIONS(3216),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym_case] = ACTIONS(3216),
    [anon_sym_yield] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [anon_sym_LTtemplate_GT] = ACTIONS(3216),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_async] = ACTIONS(3216),
    [anon_sym_function] = ACTIONS(3216),
    [anon_sym_new] = ACTIONS(3216),
    [anon_sym_using] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_SLASH] = ACTIONS(3216),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_void] = ACTIONS(3216),
    [anon_sym_delete] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3216),
    [sym_number] = ACTIONS(3216),
    [sym_private_property_identifier] = ACTIONS(3216),
    [sym_this] = ACTIONS(3216),
    [sym_super] = ACTIONS(3216),
    [sym_true] = ACTIONS(3216),
    [sym_false] = ACTIONS(3216),
    [sym_null] = ACTIONS(3216),
    [sym_undefined] = ACTIONS(3216),
    [anon_sym_AT] = ACTIONS(3216),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_readonly] = ACTIONS(3216),
    [anon_sym_get] = ACTIONS(3216),
    [anon_sym_set] = ACTIONS(3216),
    [anon_sym_declare] = ACTIONS(3216),
    [anon_sym_public] = ACTIONS(3216),
    [anon_sym_private] = ACTIONS(3216),
    [anon_sym_protected] = ACTIONS(3216),
    [anon_sym_override] = ACTIONS(3216),
    [anon_sym_module] = ACTIONS(3216),
    [anon_sym_any] = ACTIONS(3216),
    [anon_sym_number] = ACTIONS(3216),
    [anon_sym_boolean] = ACTIONS(3216),
    [anon_sym_string] = ACTIONS(3216),
    [anon_sym_symbol] = ACTIONS(3216),
    [anon_sym_object] = ACTIONS(3216),
    [anon_sym_abstract] = ACTIONS(3216),
    [anon_sym_interface] = ACTIONS(3216),
    [anon_sym_enum] = ACTIONS(3216),
    [sym_html_comment] = ACTIONS(5),
  },
  [1300] = {
    [sym_comment] = STATE(1300),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_export] = ACTIONS(3212),
    [anon_sym_default] = ACTIONS(3212),
    [anon_sym_type] = ACTIONS(3212),
    [anon_sym_namespace] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_RBRACE] = ACTIONS(3212),
    [anon_sym_typeof] = ACTIONS(3212),
    [anon_sym_import] = ACTIONS(3212),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_var] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_const] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_switch] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_await] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_break] = ACTIONS(3212),
    [anon_sym_continue] = ACTIONS(3212),
    [anon_sym_debugger] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_throw] = ACTIONS(3212),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym_case] = ACTIONS(3212),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LTtemplate_GT] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_class] = ACTIONS(3212),
    [anon_sym_async] = ACTIONS(3212),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_using] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_LT] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_void] = ACTIONS(3212),
    [anon_sym_delete] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3212),
    [sym_number] = ACTIONS(3212),
    [sym_private_property_identifier] = ACTIONS(3212),
    [sym_this] = ACTIONS(3212),
    [sym_super] = ACTIONS(3212),
    [sym_true] = ACTIONS(3212),
    [sym_false] = ACTIONS(3212),
    [sym_null] = ACTIONS(3212),
    [sym_undefined] = ACTIONS(3212),
    [anon_sym_AT] = ACTIONS(3212),
    [anon_sym_static] = ACTIONS(3212),
    [anon_sym_readonly] = ACTIONS(3212),
    [anon_sym_get] = ACTIONS(3212),
    [anon_sym_set] = ACTIONS(3212),
    [anon_sym_declare] = ACTIONS(3212),
    [anon_sym_public] = ACTIONS(3212),
    [anon_sym_private] = ACTIONS(3212),
    [anon_sym_protected] = ACTIONS(3212),
    [anon_sym_override] = ACTIONS(3212),
    [anon_sym_module] = ACTIONS(3212),
    [anon_sym_any] = ACTIONS(3212),
    [anon_sym_number] = ACTIONS(3212),
    [anon_sym_boolean] = ACTIONS(3212),
    [anon_sym_string] = ACTIONS(3212),
    [anon_sym_symbol] = ACTIONS(3212),
    [anon_sym_object] = ACTIONS(3212),
    [anon_sym_abstract] = ACTIONS(3212),
    [anon_sym_interface] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3212),
    [sym_html_comment] = ACTIONS(5),
  },
  [1301] = {
    [sym_comment] = STATE(1301),
    [ts_builtin_sym_end] = ACTIONS(3466),
    [sym_identifier] = ACTIONS(3144),
    [anon_sym_export] = ACTIONS(3144),
    [anon_sym_type] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_RBRACE] = ACTIONS(3144),
    [anon_sym_typeof] = ACTIONS(3144),
    [anon_sym_import] = ACTIONS(3144),
    [anon_sym_with] = ACTIONS(3144),
    [anon_sym_var] = ACTIONS(3144),
    [anon_sym_let] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3144),
    [anon_sym_await] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_debugger] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym_yield] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_LTtemplate_GT] = ACTIONS(3144),
    [anon_sym_DQUOTE] = ACTIONS(3144),
    [anon_sym_SQUOTE] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_async] = ACTIONS(3144),
    [anon_sym_function] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_SLASH] = ACTIONS(3144),
    [anon_sym_LT] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_void] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3144),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3144),
    [sym_number] = ACTIONS(3144),
    [sym_private_property_identifier] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
    [sym_super] = ACTIONS(3144),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [sym_null] = ACTIONS(3144),
    [sym_undefined] = ACTIONS(3144),
    [anon_sym_AT] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_readonly] = ACTIONS(3144),
    [anon_sym_get] = ACTIONS(3144),
    [anon_sym_set] = ACTIONS(3144),
    [anon_sym_declare] = ACTIONS(3144),
    [anon_sym_public] = ACTIONS(3144),
    [anon_sym_private] = ACTIONS(3144),
    [anon_sym_protected] = ACTIONS(3144),
    [anon_sym_override] = ACTIONS(3144),
    [anon_sym_module] = ACTIONS(3144),
    [anon_sym_any] = ACTIONS(3144),
    [anon_sym_number] = ACTIONS(3144),
    [anon_sym_boolean] = ACTIONS(3144),
    [anon_sym_string] = ACTIONS(3144),
    [anon_sym_symbol] = ACTIONS(3144),
    [anon_sym_object] = ACTIONS(3144),
    [anon_sym_abstract] = ACTIONS(3144),
    [anon_sym_interface] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [sym_html_comment] = ACTIONS(5),
  },
  [1302] = {
    [sym_comment] = STATE(1302),
    [ts_builtin_sym_end] = ACTIONS(3468),
    [sym_identifier] = ACTIONS(3196),
    [anon_sym_export] = ACTIONS(3196),
    [anon_sym_type] = ACTIONS(3196),
    [anon_sym_namespace] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3196),
    [anon_sym_RBRACE] = ACTIONS(3196),
    [anon_sym_typeof] = ACTIONS(3196),
    [anon_sym_import] = ACTIONS(3196),
    [anon_sym_with] = ACTIONS(3196),
    [anon_sym_var] = ACTIONS(3196),
    [anon_sym_let] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3196),
    [anon_sym_await] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_debugger] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_throw] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_LTtemplate_GT] = ACTIONS(3196),
    [anon_sym_DQUOTE] = ACTIONS(3196),
    [anon_sym_SQUOTE] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_async] = ACTIONS(3196),
    [anon_sym_function] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_using] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_SLASH] = ACTIONS(3196),
    [anon_sym_LT] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [anon_sym_void] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_PLUS_PLUS] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3196),
    [sym_number] = ACTIONS(3196),
    [sym_private_property_identifier] = ACTIONS(3196),
    [sym_this] = ACTIONS(3196),
    [sym_super] = ACTIONS(3196),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [sym_null] = ACTIONS(3196),
    [sym_undefined] = ACTIONS(3196),
    [anon_sym_AT] = ACTIONS(3196),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_readonly] = ACTIONS(3196),
    [anon_sym_get] = ACTIONS(3196),
    [anon_sym_set] = ACTIONS(3196),
    [anon_sym_declare] = ACTIONS(3196),
    [anon_sym_public] = ACTIONS(3196),
    [anon_sym_private] = ACTIONS(3196),
    [anon_sym_protected] = ACTIONS(3196),
    [anon_sym_override] = ACTIONS(3196),
    [anon_sym_module] = ACTIONS(3196),
    [anon_sym_any] = ACTIONS(3196),
    [anon_sym_number] = ACTIONS(3196),
    [anon_sym_boolean] = ACTIONS(3196),
    [anon_sym_string] = ACTIONS(3196),
    [anon_sym_symbol] = ACTIONS(3196),
    [anon_sym_object] = ACTIONS(3196),
    [anon_sym_abstract] = ACTIONS(3196),
    [anon_sym_interface] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [sym_html_comment] = ACTIONS(5),
  },
  [1303] = {
    [sym_comment] = STATE(1303),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_export] = ACTIONS(3296),
    [anon_sym_default] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_namespace] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(3296),
    [anon_sym_import] = ACTIONS(3296),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_var] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_const] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_switch] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_await] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_debugger] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_throw] = ACTIONS(3296),
    [anon_sym_SEMI] = ACTIONS(3296),
    [anon_sym_case] = ACTIONS(3296),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LTtemplate_GT] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [anon_sym_class] = ACTIONS(3296),
    [anon_sym_async] = ACTIONS(3296),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_using] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_SLASH] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3296),
    [anon_sym_void] = ACTIONS(3296),
    [anon_sym_delete] = ACTIONS(3296),
    [anon_sym_PLUS_PLUS] = ACTIONS(3296),
    [anon_sym_DASH_DASH] = ACTIONS(3296),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3296),
    [sym_number] = ACTIONS(3296),
    [sym_private_property_identifier] = ACTIONS(3296),
    [sym_this] = ACTIONS(3296),
    [sym_super] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_null] = ACTIONS(3296),
    [sym_undefined] = ACTIONS(3296),
    [anon_sym_AT] = ACTIONS(3296),
    [anon_sym_static] = ACTIONS(3296),
    [anon_sym_readonly] = ACTIONS(3296),
    [anon_sym_get] = ACTIONS(3296),
    [anon_sym_set] = ACTIONS(3296),
    [anon_sym_declare] = ACTIONS(3296),
    [anon_sym_public] = ACTIONS(3296),
    [anon_sym_private] = ACTIONS(3296),
    [anon_sym_protected] = ACTIONS(3296),
    [anon_sym_override] = ACTIONS(3296),
    [anon_sym_module] = ACTIONS(3296),
    [anon_sym_any] = ACTIONS(3296),
    [anon_sym_number] = ACTIONS(3296),
    [anon_sym_boolean] = ACTIONS(3296),
    [anon_sym_string] = ACTIONS(3296),
    [anon_sym_symbol] = ACTIONS(3296),
    [anon_sym_object] = ACTIONS(3296),
    [anon_sym_abstract] = ACTIONS(3296),
    [anon_sym_interface] = ACTIONS(3296),
    [anon_sym_enum] = ACTIONS(3296),
    [sym_html_comment] = ACTIONS(5),
  },
  [1304] = {
    [sym_comment] = STATE(1304),
    [ts_builtin_sym_end] = ACTIONS(3470),
    [sym_identifier] = ACTIONS(3134),
    [anon_sym_export] = ACTIONS(3134),
    [anon_sym_type] = ACTIONS(3134),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [anon_sym_typeof] = ACTIONS(3134),
    [anon_sym_import] = ACTIONS(3134),
    [anon_sym_with] = ACTIONS(3134),
    [anon_sym_var] = ACTIONS(3134),
    [anon_sym_let] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3134),
    [anon_sym_await] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_debugger] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym_yield] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_LTtemplate_GT] = ACTIONS(3134),
    [anon_sym_DQUOTE] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_async] = ACTIONS(3134),
    [anon_sym_function] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_SLASH] = ACTIONS(3134),
    [anon_sym_LT] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_void] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_PLUS_PLUS] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3134),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3134),
    [sym_number] = ACTIONS(3134),
    [sym_private_property_identifier] = ACTIONS(3134),
    [sym_this] = ACTIONS(3134),
    [sym_super] = ACTIONS(3134),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [sym_null] = ACTIONS(3134),
    [sym_undefined] = ACTIONS(3134),
    [anon_sym_AT] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_readonly] = ACTIONS(3134),
    [anon_sym_get] = ACTIONS(3134),
    [anon_sym_set] = ACTIONS(3134),
    [anon_sym_declare] = ACTIONS(3134),
    [anon_sym_public] = ACTIONS(3134),
    [anon_sym_private] = ACTIONS(3134),
    [anon_sym_protected] = ACTIONS(3134),
    [anon_sym_override] = ACTIONS(3134),
    [anon_sym_module] = ACTIONS(3134),
    [anon_sym_any] = ACTIONS(3134),
    [anon_sym_number] = ACTIONS(3134),
    [anon_sym_boolean] = ACTIONS(3134),
    [anon_sym_string] = ACTIONS(3134),
    [anon_sym_symbol] = ACTIONS(3134),
    [anon_sym_object] = ACTIONS(3134),
    [anon_sym_abstract] = ACTIONS(3134),
    [anon_sym_interface] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [sym_html_comment] = ACTIONS(5),
  },
  [1305] = {
    [sym_comment] = STATE(1305),
    [sym_identifier] = ACTIONS(3328),
    [anon_sym_export] = ACTIONS(3328),
    [anon_sym_default] = ACTIONS(3328),
    [anon_sym_type] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_typeof] = ACTIONS(3328),
    [anon_sym_import] = ACTIONS(3328),
    [anon_sym_with] = ACTIONS(3328),
    [anon_sym_var] = ACTIONS(3328),
    [anon_sym_let] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_BANG] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_await] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_debugger] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_throw] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_case] = ACTIONS(3328),
    [anon_sym_yield] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LTtemplate_GT] = ACTIONS(3328),
    [anon_sym_DQUOTE] = ACTIONS(3328),
    [anon_sym_SQUOTE] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_async] = ACTIONS(3328),
    [anon_sym_function] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_SLASH] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3328),
    [anon_sym_TILDE] = ACTIONS(3328),
    [anon_sym_void] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3328),
    [sym_number] = ACTIONS(3328),
    [sym_private_property_identifier] = ACTIONS(3328),
    [sym_this] = ACTIONS(3328),
    [sym_super] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_null] = ACTIONS(3328),
    [sym_undefined] = ACTIONS(3328),
    [anon_sym_AT] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_readonly] = ACTIONS(3328),
    [anon_sym_get] = ACTIONS(3328),
    [anon_sym_set] = ACTIONS(3328),
    [anon_sym_declare] = ACTIONS(3328),
    [anon_sym_public] = ACTIONS(3328),
    [anon_sym_private] = ACTIONS(3328),
    [anon_sym_protected] = ACTIONS(3328),
    [anon_sym_override] = ACTIONS(3328),
    [anon_sym_module] = ACTIONS(3328),
    [anon_sym_any] = ACTIONS(3328),
    [anon_sym_number] = ACTIONS(3328),
    [anon_sym_boolean] = ACTIONS(3328),
    [anon_sym_string] = ACTIONS(3328),
    [anon_sym_symbol] = ACTIONS(3328),
    [anon_sym_object] = ACTIONS(3328),
    [anon_sym_abstract] = ACTIONS(3328),
    [anon_sym_interface] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [sym_html_comment] = ACTIONS(5),
  },
  [1306] = {
    [sym_comment] = STATE(1306),
    [ts_builtin_sym_end] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_export] = ACTIONS(3214),
    [anon_sym_type] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3214),
    [anon_sym_RBRACE] = ACTIONS(3214),
    [anon_sym_typeof] = ACTIONS(3214),
    [anon_sym_import] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3214),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_BANG] = ACTIONS(3214),
    [anon_sym_else] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3214),
    [anon_sym_await] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_debugger] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_LTtemplate_GT] = ACTIONS(3214),
    [anon_sym_DQUOTE] = ACTIONS(3214),
    [anon_sym_SQUOTE] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_SLASH] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3214),
    [anon_sym_void] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_PLUS_PLUS] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3214),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3214),
    [sym_number] = ACTIONS(3214),
    [sym_private_property_identifier] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [sym_super] = ACTIONS(3214),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [sym_null] = ACTIONS(3214),
    [sym_undefined] = ACTIONS(3214),
    [anon_sym_AT] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_readonly] = ACTIONS(3214),
    [anon_sym_get] = ACTIONS(3214),
    [anon_sym_set] = ACTIONS(3214),
    [anon_sym_declare] = ACTIONS(3214),
    [anon_sym_public] = ACTIONS(3214),
    [anon_sym_private] = ACTIONS(3214),
    [anon_sym_protected] = ACTIONS(3214),
    [anon_sym_override] = ACTIONS(3214),
    [anon_sym_module] = ACTIONS(3214),
    [anon_sym_any] = ACTIONS(3214),
    [anon_sym_number] = ACTIONS(3214),
    [anon_sym_boolean] = ACTIONS(3214),
    [anon_sym_string] = ACTIONS(3214),
    [anon_sym_symbol] = ACTIONS(3214),
    [anon_sym_object] = ACTIONS(3214),
    [anon_sym_abstract] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [sym_html_comment] = ACTIONS(5),
  },
  [1307] = {
    [sym_comment] = STATE(1307),
    [ts_builtin_sym_end] = ACTIONS(3474),
    [sym_identifier] = ACTIONS(3184),
    [anon_sym_export] = ACTIONS(3184),
    [anon_sym_type] = ACTIONS(3184),
    [anon_sym_namespace] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_typeof] = ACTIONS(3184),
    [anon_sym_import] = ACTIONS(3184),
    [anon_sym_with] = ACTIONS(3184),
    [anon_sym_var] = ACTIONS(3184),
    [anon_sym_let] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_else] = ACTIONS(3184),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3184),
    [anon_sym_await] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_try] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_debugger] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_throw] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3184),
    [anon_sym_LTtemplate_GT] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_class] = ACTIONS(3184),
    [anon_sym_async] = ACTIONS(3184),
    [anon_sym_function] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_using] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_SLASH] = ACTIONS(3184),
    [anon_sym_LT] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_void] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3184),
    [sym_number] = ACTIONS(3184),
    [sym_private_property_identifier] = ACTIONS(3184),
    [sym_this] = ACTIONS(3184),
    [sym_super] = ACTIONS(3184),
    [sym_true] = ACTIONS(3184),
    [sym_false] = ACTIONS(3184),
    [sym_null] = ACTIONS(3184),
    [sym_undefined] = ACTIONS(3184),
    [anon_sym_AT] = ACTIONS(3184),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_readonly] = ACTIONS(3184),
    [anon_sym_get] = ACTIONS(3184),
    [anon_sym_set] = ACTIONS(3184),
    [anon_sym_declare] = ACTIONS(3184),
    [anon_sym_public] = ACTIONS(3184),
    [anon_sym_private] = ACTIONS(3184),
    [anon_sym_protected] = ACTIONS(3184),
    [anon_sym_override] = ACTIONS(3184),
    [anon_sym_module] = ACTIONS(3184),
    [anon_sym_any] = ACTIONS(3184),
    [anon_sym_number] = ACTIONS(3184),
    [anon_sym_boolean] = ACTIONS(3184),
    [anon_sym_string] = ACTIONS(3184),
    [anon_sym_symbol] = ACTIONS(3184),
    [anon_sym_object] = ACTIONS(3184),
    [anon_sym_abstract] = ACTIONS(3184),
    [anon_sym_interface] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [sym_html_comment] = ACTIONS(5),
  },
  [1308] = {
    [sym_comment] = STATE(1308),
    [ts_builtin_sym_end] = ACTIONS(3084),
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_export] = ACTIONS(3082),
    [anon_sym_type] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3082),
    [anon_sym_RBRACE] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3082),
    [anon_sym_import] = ACTIONS(3082),
    [anon_sym_with] = ACTIONS(3082),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_BANG] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3082),
    [anon_sym_await] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_debugger] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3082),
    [anon_sym_yield] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_LTtemplate_GT] = ACTIONS(3082),
    [anon_sym_DQUOTE] = ACTIONS(3082),
    [anon_sym_SQUOTE] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_async] = ACTIONS(3082),
    [anon_sym_function] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_TILDE] = ACTIONS(3082),
    [anon_sym_void] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3082),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3082),
    [sym_number] = ACTIONS(3082),
    [sym_private_property_identifier] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
    [sym_super] = ACTIONS(3082),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [sym_null] = ACTIONS(3082),
    [sym_undefined] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_readonly] = ACTIONS(3082),
    [anon_sym_get] = ACTIONS(3082),
    [anon_sym_set] = ACTIONS(3082),
    [anon_sym_declare] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_override] = ACTIONS(3082),
    [anon_sym_module] = ACTIONS(3082),
    [anon_sym_any] = ACTIONS(3082),
    [anon_sym_number] = ACTIONS(3082),
    [anon_sym_boolean] = ACTIONS(3082),
    [anon_sym_string] = ACTIONS(3082),
    [anon_sym_symbol] = ACTIONS(3082),
    [anon_sym_object] = ACTIONS(3082),
    [anon_sym_abstract] = ACTIONS(3082),
    [anon_sym_interface] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [sym__automatic_semicolon] = ACTIONS(3084),
    [sym_html_comment] = ACTIONS(5),
  },
  [1309] = {
    [sym_comment] = STATE(1309),
    [ts_builtin_sym_end] = ACTIONS(3476),
    [sym_identifier] = ACTIONS(3130),
    [anon_sym_export] = ACTIONS(3130),
    [anon_sym_type] = ACTIONS(3130),
    [anon_sym_namespace] = ACTIONS(3130),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_typeof] = ACTIONS(3130),
    [anon_sym_import] = ACTIONS(3130),
    [anon_sym_with] = ACTIONS(3130),
    [anon_sym_var] = ACTIONS(3130),
    [anon_sym_let] = ACTIONS(3130),
    [anon_sym_const] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_else] = ACTIONS(3130),
    [anon_sym_if] = ACTIONS(3130),
    [anon_sym_switch] = ACTIONS(3130),
    [anon_sym_for] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [anon_sym_await] = ACTIONS(3130),
    [anon_sym_while] = ACTIONS(3130),
    [anon_sym_do] = ACTIONS(3130),
    [anon_sym_try] = ACTIONS(3130),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_continue] = ACTIONS(3130),
    [anon_sym_debugger] = ACTIONS(3130),
    [anon_sym_return] = ACTIONS(3130),
    [anon_sym_throw] = ACTIONS(3130),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_yield] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [anon_sym_LTtemplate_GT] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_class] = ACTIONS(3130),
    [anon_sym_async] = ACTIONS(3130),
    [anon_sym_function] = ACTIONS(3130),
    [anon_sym_new] = ACTIONS(3130),
    [anon_sym_using] = ACTIONS(3130),
    [anon_sym_PLUS] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3130),
    [anon_sym_SLASH] = ACTIONS(3130),
    [anon_sym_LT] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_void] = ACTIONS(3130),
    [anon_sym_delete] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3130),
    [sym_number] = ACTIONS(3130),
    [sym_private_property_identifier] = ACTIONS(3130),
    [sym_this] = ACTIONS(3130),
    [sym_super] = ACTIONS(3130),
    [sym_true] = ACTIONS(3130),
    [sym_false] = ACTIONS(3130),
    [sym_null] = ACTIONS(3130),
    [sym_undefined] = ACTIONS(3130),
    [anon_sym_AT] = ACTIONS(3130),
    [anon_sym_static] = ACTIONS(3130),
    [anon_sym_readonly] = ACTIONS(3130),
    [anon_sym_get] = ACTIONS(3130),
    [anon_sym_set] = ACTIONS(3130),
    [anon_sym_declare] = ACTIONS(3130),
    [anon_sym_public] = ACTIONS(3130),
    [anon_sym_private] = ACTIONS(3130),
    [anon_sym_protected] = ACTIONS(3130),
    [anon_sym_override] = ACTIONS(3130),
    [anon_sym_module] = ACTIONS(3130),
    [anon_sym_any] = ACTIONS(3130),
    [anon_sym_number] = ACTIONS(3130),
    [anon_sym_boolean] = ACTIONS(3130),
    [anon_sym_string] = ACTIONS(3130),
    [anon_sym_symbol] = ACTIONS(3130),
    [anon_sym_object] = ACTIONS(3130),
    [anon_sym_abstract] = ACTIONS(3130),
    [anon_sym_interface] = ACTIONS(3130),
    [anon_sym_enum] = ACTIONS(3130),
    [sym_html_comment] = ACTIONS(5),
  },
  [1310] = {
    [sym_comment] = STATE(1310),
    [ts_builtin_sym_end] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3288),
    [anon_sym_export] = ACTIONS(3288),
    [anon_sym_type] = ACTIONS(3288),
    [anon_sym_namespace] = ACTIONS(3288),
    [anon_sym_LBRACE] = ACTIONS(3288),
    [anon_sym_RBRACE] = ACTIONS(3288),
    [anon_sym_typeof] = ACTIONS(3288),
    [anon_sym_import] = ACTIONS(3288),
    [anon_sym_with] = ACTIONS(3288),
    [anon_sym_var] = ACTIONS(3288),
    [anon_sym_let] = ACTIONS(3288),
    [anon_sym_const] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3288),
    [anon_sym_else] = ACTIONS(3288),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_switch] = ACTIONS(3288),
    [anon_sym_for] = ACTIONS(3288),
    [anon_sym_LPAREN] = ACTIONS(3288),
    [anon_sym_await] = ACTIONS(3288),
    [anon_sym_while] = ACTIONS(3288),
    [anon_sym_do] = ACTIONS(3288),
    [anon_sym_try] = ACTIONS(3288),
    [anon_sym_break] = ACTIONS(3288),
    [anon_sym_continue] = ACTIONS(3288),
    [anon_sym_debugger] = ACTIONS(3288),
    [anon_sym_return] = ACTIONS(3288),
    [anon_sym_throw] = ACTIONS(3288),
    [anon_sym_SEMI] = ACTIONS(3288),
    [anon_sym_yield] = ACTIONS(3288),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_LTtemplate_GT] = ACTIONS(3288),
    [anon_sym_DQUOTE] = ACTIONS(3288),
    [anon_sym_SQUOTE] = ACTIONS(3288),
    [anon_sym_class] = ACTIONS(3288),
    [anon_sym_async] = ACTIONS(3288),
    [anon_sym_function] = ACTIONS(3288),
    [anon_sym_new] = ACTIONS(3288),
    [anon_sym_using] = ACTIONS(3288),
    [anon_sym_PLUS] = ACTIONS(3288),
    [anon_sym_DASH] = ACTIONS(3288),
    [anon_sym_SLASH] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3288),
    [anon_sym_TILDE] = ACTIONS(3288),
    [anon_sym_void] = ACTIONS(3288),
    [anon_sym_delete] = ACTIONS(3288),
    [anon_sym_PLUS_PLUS] = ACTIONS(3288),
    [anon_sym_DASH_DASH] = ACTIONS(3288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3288),
    [sym_number] = ACTIONS(3288),
    [sym_private_property_identifier] = ACTIONS(3288),
    [sym_this] = ACTIONS(3288),
    [sym_super] = ACTIONS(3288),
    [sym_true] = ACTIONS(3288),
    [sym_false] = ACTIONS(3288),
    [sym_null] = ACTIONS(3288),
    [sym_undefined] = ACTIONS(3288),
    [anon_sym_AT] = ACTIONS(3288),
    [anon_sym_static] = ACTIONS(3288),
    [anon_sym_readonly] = ACTIONS(3288),
    [anon_sym_get] = ACTIONS(3288),
    [anon_sym_set] = ACTIONS(3288),
    [anon_sym_declare] = ACTIONS(3288),
    [anon_sym_public] = ACTIONS(3288),
    [anon_sym_private] = ACTIONS(3288),
    [anon_sym_protected] = ACTIONS(3288),
    [anon_sym_override] = ACTIONS(3288),
    [anon_sym_module] = ACTIONS(3288),
    [anon_sym_any] = ACTIONS(3288),
    [anon_sym_number] = ACTIONS(3288),
    [anon_sym_boolean] = ACTIONS(3288),
    [anon_sym_string] = ACTIONS(3288),
    [anon_sym_symbol] = ACTIONS(3288),
    [anon_sym_object] = ACTIONS(3288),
    [anon_sym_abstract] = ACTIONS(3288),
    [anon_sym_interface] = ACTIONS(3288),
    [anon_sym_enum] = ACTIONS(3288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1311] = {
    [sym_comment] = STATE(1311),
    [sym_identifier] = ACTIONS(3166),
    [anon_sym_export] = ACTIONS(3166),
    [anon_sym_default] = ACTIONS(3166),
    [anon_sym_type] = ACTIONS(3166),
    [anon_sym_namespace] = ACTIONS(3166),
    [anon_sym_LBRACE] = ACTIONS(3166),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [anon_sym_typeof] = ACTIONS(3166),
    [anon_sym_import] = ACTIONS(3166),
    [anon_sym_with] = ACTIONS(3166),
    [anon_sym_var] = ACTIONS(3166),
    [anon_sym_let] = ACTIONS(3166),
    [anon_sym_const] = ACTIONS(3166),
    [anon_sym_BANG] = ACTIONS(3166),
    [anon_sym_if] = ACTIONS(3166),
    [anon_sym_switch] = ACTIONS(3166),
    [anon_sym_for] = ACTIONS(3166),
    [anon_sym_LPAREN] = ACTIONS(3166),
    [anon_sym_await] = ACTIONS(3166),
    [anon_sym_while] = ACTIONS(3166),
    [anon_sym_do] = ACTIONS(3166),
    [anon_sym_try] = ACTIONS(3166),
    [anon_sym_break] = ACTIONS(3166),
    [anon_sym_continue] = ACTIONS(3166),
    [anon_sym_debugger] = ACTIONS(3166),
    [anon_sym_return] = ACTIONS(3166),
    [anon_sym_throw] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym_case] = ACTIONS(3166),
    [anon_sym_yield] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [anon_sym_LTtemplate_GT] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [anon_sym_SQUOTE] = ACTIONS(3166),
    [anon_sym_class] = ACTIONS(3166),
    [anon_sym_async] = ACTIONS(3166),
    [anon_sym_function] = ACTIONS(3166),
    [anon_sym_new] = ACTIONS(3166),
    [anon_sym_using] = ACTIONS(3166),
    [anon_sym_PLUS] = ACTIONS(3166),
    [anon_sym_DASH] = ACTIONS(3166),
    [anon_sym_SLASH] = ACTIONS(3166),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_void] = ACTIONS(3166),
    [anon_sym_delete] = ACTIONS(3166),
    [anon_sym_PLUS_PLUS] = ACTIONS(3166),
    [anon_sym_DASH_DASH] = ACTIONS(3166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3166),
    [sym_number] = ACTIONS(3166),
    [sym_private_property_identifier] = ACTIONS(3166),
    [sym_this] = ACTIONS(3166),
    [sym_super] = ACTIONS(3166),
    [sym_true] = ACTIONS(3166),
    [sym_false] = ACTIONS(3166),
    [sym_null] = ACTIONS(3166),
    [sym_undefined] = ACTIONS(3166),
    [anon_sym_AT] = ACTIONS(3166),
    [anon_sym_static] = ACTIONS(3166),
    [anon_sym_readonly] = ACTIONS(3166),
    [anon_sym_get] = ACTIONS(3166),
    [anon_sym_set] = ACTIONS(3166),
    [anon_sym_declare] = ACTIONS(3166),
    [anon_sym_public] = ACTIONS(3166),
    [anon_sym_private] = ACTIONS(3166),
    [anon_sym_protected] = ACTIONS(3166),
    [anon_sym_override] = ACTIONS(3166),
    [anon_sym_module] = ACTIONS(3166),
    [anon_sym_any] = ACTIONS(3166),
    [anon_sym_number] = ACTIONS(3166),
    [anon_sym_boolean] = ACTIONS(3166),
    [anon_sym_string] = ACTIONS(3166),
    [anon_sym_symbol] = ACTIONS(3166),
    [anon_sym_object] = ACTIONS(3166),
    [anon_sym_abstract] = ACTIONS(3166),
    [anon_sym_interface] = ACTIONS(3166),
    [anon_sym_enum] = ACTIONS(3166),
    [sym_html_comment] = ACTIONS(5),
  },
  [1312] = {
    [sym_comment] = STATE(1312),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_export] = ACTIONS(3322),
    [anon_sym_default] = ACTIONS(3322),
    [anon_sym_type] = ACTIONS(3322),
    [anon_sym_namespace] = ACTIONS(3322),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_RBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3322),
    [anon_sym_import] = ACTIONS(3322),
    [anon_sym_with] = ACTIONS(3322),
    [anon_sym_var] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_BANG] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_switch] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_await] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(3322),
    [anon_sym_continue] = ACTIONS(3322),
    [anon_sym_debugger] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_throw] = ACTIONS(3322),
    [anon_sym_SEMI] = ACTIONS(3322),
    [anon_sym_case] = ACTIONS(3322),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LTtemplate_GT] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_SQUOTE] = ACTIONS(3322),
    [anon_sym_class] = ACTIONS(3322),
    [anon_sym_async] = ACTIONS(3322),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_using] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_SLASH] = ACTIONS(3322),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3322),
    [anon_sym_void] = ACTIONS(3322),
    [anon_sym_delete] = ACTIONS(3322),
    [anon_sym_PLUS_PLUS] = ACTIONS(3322),
    [anon_sym_DASH_DASH] = ACTIONS(3322),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3322),
    [sym_number] = ACTIONS(3322),
    [sym_private_property_identifier] = ACTIONS(3322),
    [sym_this] = ACTIONS(3322),
    [sym_super] = ACTIONS(3322),
    [sym_true] = ACTIONS(3322),
    [sym_false] = ACTIONS(3322),
    [sym_null] = ACTIONS(3322),
    [sym_undefined] = ACTIONS(3322),
    [anon_sym_AT] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3322),
    [anon_sym_readonly] = ACTIONS(3322),
    [anon_sym_get] = ACTIONS(3322),
    [anon_sym_set] = ACTIONS(3322),
    [anon_sym_declare] = ACTIONS(3322),
    [anon_sym_public] = ACTIONS(3322),
    [anon_sym_private] = ACTIONS(3322),
    [anon_sym_protected] = ACTIONS(3322),
    [anon_sym_override] = ACTIONS(3322),
    [anon_sym_module] = ACTIONS(3322),
    [anon_sym_any] = ACTIONS(3322),
    [anon_sym_number] = ACTIONS(3322),
    [anon_sym_boolean] = ACTIONS(3322),
    [anon_sym_string] = ACTIONS(3322),
    [anon_sym_symbol] = ACTIONS(3322),
    [anon_sym_object] = ACTIONS(3322),
    [anon_sym_abstract] = ACTIONS(3322),
    [anon_sym_interface] = ACTIONS(3322),
    [anon_sym_enum] = ACTIONS(3322),
    [sym_html_comment] = ACTIONS(5),
  },
  [1313] = {
    [sym_comment] = STATE(1313),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_export] = ACTIONS(3318),
    [anon_sym_default] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_namespace] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_RBRACE] = ACTIONS(3318),
    [anon_sym_typeof] = ACTIONS(3318),
    [anon_sym_import] = ACTIONS(3318),
    [anon_sym_with] = ACTIONS(3318),
    [anon_sym_var] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_switch] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_await] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_debugger] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_throw] = ACTIONS(3318),
    [anon_sym_SEMI] = ACTIONS(3318),
    [anon_sym_case] = ACTIONS(3318),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LTtemplate_GT] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_SQUOTE] = ACTIONS(3318),
    [anon_sym_class] = ACTIONS(3318),
    [anon_sym_async] = ACTIONS(3318),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_using] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3318),
    [anon_sym_void] = ACTIONS(3318),
    [anon_sym_delete] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3318),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3318),
    [sym_number] = ACTIONS(3318),
    [sym_private_property_identifier] = ACTIONS(3318),
    [sym_this] = ACTIONS(3318),
    [sym_super] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_null] = ACTIONS(3318),
    [sym_undefined] = ACTIONS(3318),
    [anon_sym_AT] = ACTIONS(3318),
    [anon_sym_static] = ACTIONS(3318),
    [anon_sym_readonly] = ACTIONS(3318),
    [anon_sym_get] = ACTIONS(3318),
    [anon_sym_set] = ACTIONS(3318),
    [anon_sym_declare] = ACTIONS(3318),
    [anon_sym_public] = ACTIONS(3318),
    [anon_sym_private] = ACTIONS(3318),
    [anon_sym_protected] = ACTIONS(3318),
    [anon_sym_override] = ACTIONS(3318),
    [anon_sym_module] = ACTIONS(3318),
    [anon_sym_any] = ACTIONS(3318),
    [anon_sym_number] = ACTIONS(3318),
    [anon_sym_boolean] = ACTIONS(3318),
    [anon_sym_string] = ACTIONS(3318),
    [anon_sym_symbol] = ACTIONS(3318),
    [anon_sym_object] = ACTIONS(3318),
    [anon_sym_abstract] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [sym_html_comment] = ACTIONS(5),
  },
  [1314] = {
    [sym_comment] = STATE(1314),
    [ts_builtin_sym_end] = ACTIONS(3480),
    [sym_identifier] = ACTIONS(3258),
    [anon_sym_export] = ACTIONS(3258),
    [anon_sym_type] = ACTIONS(3258),
    [anon_sym_namespace] = ACTIONS(3258),
    [anon_sym_LBRACE] = ACTIONS(3258),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_typeof] = ACTIONS(3258),
    [anon_sym_import] = ACTIONS(3258),
    [anon_sym_with] = ACTIONS(3258),
    [anon_sym_var] = ACTIONS(3258),
    [anon_sym_let] = ACTIONS(3258),
    [anon_sym_const] = ACTIONS(3258),
    [anon_sym_BANG] = ACTIONS(3258),
    [anon_sym_else] = ACTIONS(3258),
    [anon_sym_if] = ACTIONS(3258),
    [anon_sym_switch] = ACTIONS(3258),
    [anon_sym_for] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [anon_sym_await] = ACTIONS(3258),
    [anon_sym_while] = ACTIONS(3258),
    [anon_sym_do] = ACTIONS(3258),
    [anon_sym_try] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3258),
    [anon_sym_continue] = ACTIONS(3258),
    [anon_sym_debugger] = ACTIONS(3258),
    [anon_sym_return] = ACTIONS(3258),
    [anon_sym_throw] = ACTIONS(3258),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_LTtemplate_GT] = ACTIONS(3258),
    [anon_sym_DQUOTE] = ACTIONS(3258),
    [anon_sym_SQUOTE] = ACTIONS(3258),
    [anon_sym_class] = ACTIONS(3258),
    [anon_sym_async] = ACTIONS(3258),
    [anon_sym_function] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3258),
    [anon_sym_using] = ACTIONS(3258),
    [anon_sym_PLUS] = ACTIONS(3258),
    [anon_sym_DASH] = ACTIONS(3258),
    [anon_sym_SLASH] = ACTIONS(3258),
    [anon_sym_LT] = ACTIONS(3258),
    [anon_sym_TILDE] = ACTIONS(3258),
    [anon_sym_void] = ACTIONS(3258),
    [anon_sym_delete] = ACTIONS(3258),
    [anon_sym_PLUS_PLUS] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3258),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [sym_number] = ACTIONS(3258),
    [sym_private_property_identifier] = ACTIONS(3258),
    [sym_this] = ACTIONS(3258),
    [sym_super] = ACTIONS(3258),
    [sym_true] = ACTIONS(3258),
    [sym_false] = ACTIONS(3258),
    [sym_null] = ACTIONS(3258),
    [sym_undefined] = ACTIONS(3258),
    [anon_sym_AT] = ACTIONS(3258),
    [anon_sym_static] = ACTIONS(3258),
    [anon_sym_readonly] = ACTIONS(3258),
    [anon_sym_get] = ACTIONS(3258),
    [anon_sym_set] = ACTIONS(3258),
    [anon_sym_declare] = ACTIONS(3258),
    [anon_sym_public] = ACTIONS(3258),
    [anon_sym_private] = ACTIONS(3258),
    [anon_sym_protected] = ACTIONS(3258),
    [anon_sym_override] = ACTIONS(3258),
    [anon_sym_module] = ACTIONS(3258),
    [anon_sym_any] = ACTIONS(3258),
    [anon_sym_number] = ACTIONS(3258),
    [anon_sym_boolean] = ACTIONS(3258),
    [anon_sym_string] = ACTIONS(3258),
    [anon_sym_symbol] = ACTIONS(3258),
    [anon_sym_object] = ACTIONS(3258),
    [anon_sym_abstract] = ACTIONS(3258),
    [anon_sym_interface] = ACTIONS(3258),
    [anon_sym_enum] = ACTIONS(3258),
    [sym_html_comment] = ACTIONS(5),
  },
  [1315] = {
    [sym_comment] = STATE(1315),
    [ts_builtin_sym_end] = ACTIONS(3482),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_export] = ACTIONS(3262),
    [anon_sym_type] = ACTIONS(3262),
    [anon_sym_namespace] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_typeof] = ACTIONS(3262),
    [anon_sym_import] = ACTIONS(3262),
    [anon_sym_with] = ACTIONS(3262),
    [anon_sym_var] = ACTIONS(3262),
    [anon_sym_let] = ACTIONS(3262),
    [anon_sym_const] = ACTIONS(3262),
    [anon_sym_BANG] = ACTIONS(3262),
    [anon_sym_else] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_await] = ACTIONS(3262),
    [anon_sym_while] = ACTIONS(3262),
    [anon_sym_do] = ACTIONS(3262),
    [anon_sym_try] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_debugger] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_throw] = ACTIONS(3262),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_yield] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_LTtemplate_GT] = ACTIONS(3262),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [anon_sym_class] = ACTIONS(3262),
    [anon_sym_async] = ACTIONS(3262),
    [anon_sym_function] = ACTIONS(3262),
    [anon_sym_new] = ACTIONS(3262),
    [anon_sym_using] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_SLASH] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3262),
    [anon_sym_TILDE] = ACTIONS(3262),
    [anon_sym_void] = ACTIONS(3262),
    [anon_sym_delete] = ACTIONS(3262),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3262),
    [sym_number] = ACTIONS(3262),
    [sym_private_property_identifier] = ACTIONS(3262),
    [sym_this] = ACTIONS(3262),
    [sym_super] = ACTIONS(3262),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_null] = ACTIONS(3262),
    [sym_undefined] = ACTIONS(3262),
    [anon_sym_AT] = ACTIONS(3262),
    [anon_sym_static] = ACTIONS(3262),
    [anon_sym_readonly] = ACTIONS(3262),
    [anon_sym_get] = ACTIONS(3262),
    [anon_sym_set] = ACTIONS(3262),
    [anon_sym_declare] = ACTIONS(3262),
    [anon_sym_public] = ACTIONS(3262),
    [anon_sym_private] = ACTIONS(3262),
    [anon_sym_protected] = ACTIONS(3262),
    [anon_sym_override] = ACTIONS(3262),
    [anon_sym_module] = ACTIONS(3262),
    [anon_sym_any] = ACTIONS(3262),
    [anon_sym_number] = ACTIONS(3262),
    [anon_sym_boolean] = ACTIONS(3262),
    [anon_sym_string] = ACTIONS(3262),
    [anon_sym_symbol] = ACTIONS(3262),
    [anon_sym_object] = ACTIONS(3262),
    [anon_sym_abstract] = ACTIONS(3262),
    [anon_sym_interface] = ACTIONS(3262),
    [anon_sym_enum] = ACTIONS(3262),
    [sym_html_comment] = ACTIONS(5),
  },
  [1316] = {
    [sym_comment] = STATE(1316),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_export] = ACTIONS(3314),
    [anon_sym_default] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_RBRACE] = ACTIONS(3314),
    [anon_sym_typeof] = ACTIONS(3314),
    [anon_sym_import] = ACTIONS(3314),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_var] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_BANG] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_await] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_debugger] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3314),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LTtemplate_GT] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_SQUOTE] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_async] = ACTIONS(3314),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_SLASH] = ACTIONS(3314),
    [anon_sym_LT] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3314),
    [anon_sym_void] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_PLUS_PLUS] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3314),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3314),
    [sym_number] = ACTIONS(3314),
    [sym_private_property_identifier] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_undefined] = ACTIONS(3314),
    [anon_sym_AT] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_readonly] = ACTIONS(3314),
    [anon_sym_get] = ACTIONS(3314),
    [anon_sym_set] = ACTIONS(3314),
    [anon_sym_declare] = ACTIONS(3314),
    [anon_sym_public] = ACTIONS(3314),
    [anon_sym_private] = ACTIONS(3314),
    [anon_sym_protected] = ACTIONS(3314),
    [anon_sym_override] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_any] = ACTIONS(3314),
    [anon_sym_number] = ACTIONS(3314),
    [anon_sym_boolean] = ACTIONS(3314),
    [anon_sym_string] = ACTIONS(3314),
    [anon_sym_symbol] = ACTIONS(3314),
    [anon_sym_object] = ACTIONS(3314),
    [anon_sym_abstract] = ACTIONS(3314),
    [anon_sym_interface] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [sym_html_comment] = ACTIONS(5),
  },
  [1317] = {
    [sym_comment] = STATE(1317),
    [sym_identifier] = ACTIONS(3162),
    [anon_sym_export] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_type] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_RBRACE] = ACTIONS(3162),
    [anon_sym_typeof] = ACTIONS(3162),
    [anon_sym_import] = ACTIONS(3162),
    [anon_sym_with] = ACTIONS(3162),
    [anon_sym_var] = ACTIONS(3162),
    [anon_sym_let] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_LPAREN] = ACTIONS(3162),
    [anon_sym_await] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_debugger] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_yield] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_LTtemplate_GT] = ACTIONS(3162),
    [anon_sym_DQUOTE] = ACTIONS(3162),
    [anon_sym_SQUOTE] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_async] = ACTIONS(3162),
    [anon_sym_function] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_SLASH] = ACTIONS(3162),
    [anon_sym_LT] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_void] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3162),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3162),
    [sym_number] = ACTIONS(3162),
    [sym_private_property_identifier] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
    [sym_super] = ACTIONS(3162),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [sym_null] = ACTIONS(3162),
    [sym_undefined] = ACTIONS(3162),
    [anon_sym_AT] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_readonly] = ACTIONS(3162),
    [anon_sym_get] = ACTIONS(3162),
    [anon_sym_set] = ACTIONS(3162),
    [anon_sym_declare] = ACTIONS(3162),
    [anon_sym_public] = ACTIONS(3162),
    [anon_sym_private] = ACTIONS(3162),
    [anon_sym_protected] = ACTIONS(3162),
    [anon_sym_override] = ACTIONS(3162),
    [anon_sym_module] = ACTIONS(3162),
    [anon_sym_any] = ACTIONS(3162),
    [anon_sym_number] = ACTIONS(3162),
    [anon_sym_boolean] = ACTIONS(3162),
    [anon_sym_string] = ACTIONS(3162),
    [anon_sym_symbol] = ACTIONS(3162),
    [anon_sym_object] = ACTIONS(3162),
    [anon_sym_abstract] = ACTIONS(3162),
    [anon_sym_interface] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [sym_html_comment] = ACTIONS(5),
  },
  [1318] = {
    [sym_comment] = STATE(1318),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_export] = ACTIONS(3312),
    [anon_sym_default] = ACTIONS(3312),
    [anon_sym_type] = ACTIONS(3312),
    [anon_sym_namespace] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_typeof] = ACTIONS(3312),
    [anon_sym_import] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3312),
    [anon_sym_var] = ACTIONS(3312),
    [anon_sym_let] = ACTIONS(3312),
    [anon_sym_const] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_switch] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym_await] = ACTIONS(3312),
    [anon_sym_while] = ACTIONS(3312),
    [anon_sym_do] = ACTIONS(3312),
    [anon_sym_try] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_debugger] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_throw] = ACTIONS(3312),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym_case] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3312),
    [anon_sym_LTtemplate_GT] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_class] = ACTIONS(3312),
    [anon_sym_async] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3312),
    [anon_sym_using] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_void] = ACTIONS(3312),
    [anon_sym_delete] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3312),
    [sym_number] = ACTIONS(3312),
    [sym_private_property_identifier] = ACTIONS(3312),
    [sym_this] = ACTIONS(3312),
    [sym_super] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_null] = ACTIONS(3312),
    [sym_undefined] = ACTIONS(3312),
    [anon_sym_AT] = ACTIONS(3312),
    [anon_sym_static] = ACTIONS(3312),
    [anon_sym_readonly] = ACTIONS(3312),
    [anon_sym_get] = ACTIONS(3312),
    [anon_sym_set] = ACTIONS(3312),
    [anon_sym_declare] = ACTIONS(3312),
    [anon_sym_public] = ACTIONS(3312),
    [anon_sym_private] = ACTIONS(3312),
    [anon_sym_protected] = ACTIONS(3312),
    [anon_sym_override] = ACTIONS(3312),
    [anon_sym_module] = ACTIONS(3312),
    [anon_sym_any] = ACTIONS(3312),
    [anon_sym_number] = ACTIONS(3312),
    [anon_sym_boolean] = ACTIONS(3312),
    [anon_sym_string] = ACTIONS(3312),
    [anon_sym_symbol] = ACTIONS(3312),
    [anon_sym_object] = ACTIONS(3312),
    [anon_sym_abstract] = ACTIONS(3312),
    [anon_sym_interface] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(3312),
    [sym_html_comment] = ACTIONS(5),
  },
  [1319] = {
    [sym_comment] = STATE(1319),
    [ts_builtin_sym_end] = ACTIONS(2095),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2067),
    [anon_sym_RBRACE] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2067),
    [anon_sym_LTtemplate_GT] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_using] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2067),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2067),
    [anon_sym_DASH_DASH] = ACTIONS(2067),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_number] = ACTIONS(2067),
    [sym_private_property_identifier] = ACTIONS(2067),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2067),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym__automatic_semicolon] = ACTIONS(2319),
    [sym_html_comment] = ACTIONS(5),
  },
  [1320] = {
    [sym_comment] = STATE(1320),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_export] = ACTIONS(3304),
    [anon_sym_default] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_namespace] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_RBRACE] = ACTIONS(3304),
    [anon_sym_typeof] = ACTIONS(3304),
    [anon_sym_import] = ACTIONS(3304),
    [anon_sym_with] = ACTIONS(3304),
    [anon_sym_var] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_const] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_switch] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_await] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_debugger] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_throw] = ACTIONS(3304),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym_case] = ACTIONS(3304),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LTtemplate_GT] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_class] = ACTIONS(3304),
    [anon_sym_async] = ACTIONS(3304),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_using] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_void] = ACTIONS(3304),
    [anon_sym_delete] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3304),
    [sym_number] = ACTIONS(3304),
    [sym_private_property_identifier] = ACTIONS(3304),
    [sym_this] = ACTIONS(3304),
    [sym_super] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_null] = ACTIONS(3304),
    [sym_undefined] = ACTIONS(3304),
    [anon_sym_AT] = ACTIONS(3304),
    [anon_sym_static] = ACTIONS(3304),
    [anon_sym_readonly] = ACTIONS(3304),
    [anon_sym_get] = ACTIONS(3304),
    [anon_sym_set] = ACTIONS(3304),
    [anon_sym_declare] = ACTIONS(3304),
    [anon_sym_public] = ACTIONS(3304),
    [anon_sym_private] = ACTIONS(3304),
    [anon_sym_protected] = ACTIONS(3304),
    [anon_sym_override] = ACTIONS(3304),
    [anon_sym_module] = ACTIONS(3304),
    [anon_sym_any] = ACTIONS(3304),
    [anon_sym_number] = ACTIONS(3304),
    [anon_sym_boolean] = ACTIONS(3304),
    [anon_sym_string] = ACTIONS(3304),
    [anon_sym_symbol] = ACTIONS(3304),
    [anon_sym_object] = ACTIONS(3304),
    [anon_sym_abstract] = ACTIONS(3304),
    [anon_sym_interface] = ACTIONS(3304),
    [anon_sym_enum] = ACTIONS(3304),
    [sym_html_comment] = ACTIONS(5),
  },
  [1321] = {
    [sym_comment] = STATE(1321),
    [sym_identifier] = ACTIONS(3284),
    [anon_sym_export] = ACTIONS(3284),
    [anon_sym_default] = ACTIONS(3284),
    [anon_sym_type] = ACTIONS(3284),
    [anon_sym_namespace] = ACTIONS(3284),
    [anon_sym_LBRACE] = ACTIONS(3284),
    [anon_sym_RBRACE] = ACTIONS(3284),
    [anon_sym_typeof] = ACTIONS(3284),
    [anon_sym_import] = ACTIONS(3284),
    [anon_sym_with] = ACTIONS(3284),
    [anon_sym_var] = ACTIONS(3284),
    [anon_sym_let] = ACTIONS(3284),
    [anon_sym_const] = ACTIONS(3284),
    [anon_sym_BANG] = ACTIONS(3284),
    [anon_sym_if] = ACTIONS(3284),
    [anon_sym_switch] = ACTIONS(3284),
    [anon_sym_for] = ACTIONS(3284),
    [anon_sym_LPAREN] = ACTIONS(3284),
    [anon_sym_await] = ACTIONS(3284),
    [anon_sym_while] = ACTIONS(3284),
    [anon_sym_do] = ACTIONS(3284),
    [anon_sym_try] = ACTIONS(3284),
    [anon_sym_break] = ACTIONS(3284),
    [anon_sym_continue] = ACTIONS(3284),
    [anon_sym_debugger] = ACTIONS(3284),
    [anon_sym_return] = ACTIONS(3284),
    [anon_sym_throw] = ACTIONS(3284),
    [anon_sym_SEMI] = ACTIONS(3284),
    [anon_sym_case] = ACTIONS(3284),
    [anon_sym_yield] = ACTIONS(3284),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [anon_sym_LTtemplate_GT] = ACTIONS(3284),
    [anon_sym_DQUOTE] = ACTIONS(3284),
    [anon_sym_SQUOTE] = ACTIONS(3284),
    [anon_sym_class] = ACTIONS(3284),
    [anon_sym_async] = ACTIONS(3284),
    [anon_sym_function] = ACTIONS(3284),
    [anon_sym_new] = ACTIONS(3284),
    [anon_sym_using] = ACTIONS(3284),
    [anon_sym_PLUS] = ACTIONS(3284),
    [anon_sym_DASH] = ACTIONS(3284),
    [anon_sym_SLASH] = ACTIONS(3284),
    [anon_sym_LT] = ACTIONS(3284),
    [anon_sym_TILDE] = ACTIONS(3284),
    [anon_sym_void] = ACTIONS(3284),
    [anon_sym_delete] = ACTIONS(3284),
    [anon_sym_PLUS_PLUS] = ACTIONS(3284),
    [anon_sym_DASH_DASH] = ACTIONS(3284),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3284),
    [sym_number] = ACTIONS(3284),
    [sym_private_property_identifier] = ACTIONS(3284),
    [sym_this] = ACTIONS(3284),
    [sym_super] = ACTIONS(3284),
    [sym_true] = ACTIONS(3284),
    [sym_false] = ACTIONS(3284),
    [sym_null] = ACTIONS(3284),
    [sym_undefined] = ACTIONS(3284),
    [anon_sym_AT] = ACTIONS(3284),
    [anon_sym_static] = ACTIONS(3284),
    [anon_sym_readonly] = ACTIONS(3284),
    [anon_sym_get] = ACTIONS(3284),
    [anon_sym_set] = ACTIONS(3284),
    [anon_sym_declare] = ACTIONS(3284),
    [anon_sym_public] = ACTIONS(3284),
    [anon_sym_private] = ACTIONS(3284),
    [anon_sym_protected] = ACTIONS(3284),
    [anon_sym_override] = ACTIONS(3284),
    [anon_sym_module] = ACTIONS(3284),
    [anon_sym_any] = ACTIONS(3284),
    [anon_sym_number] = ACTIONS(3284),
    [anon_sym_boolean] = ACTIONS(3284),
    [anon_sym_string] = ACTIONS(3284),
    [anon_sym_symbol] = ACTIONS(3284),
    [anon_sym_object] = ACTIONS(3284),
    [anon_sym_abstract] = ACTIONS(3284),
    [anon_sym_interface] = ACTIONS(3284),
    [anon_sym_enum] = ACTIONS(3284),
    [sym_html_comment] = ACTIONS(5),
  },
  [1322] = {
    [sym_comment] = STATE(1322),
    [ts_builtin_sym_end] = ACTIONS(3484),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_export] = ACTIONS(3266),
    [anon_sym_type] = ACTIONS(3266),
    [anon_sym_namespace] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_typeof] = ACTIONS(3266),
    [anon_sym_import] = ACTIONS(3266),
    [anon_sym_with] = ACTIONS(3266),
    [anon_sym_var] = ACTIONS(3266),
    [anon_sym_let] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_else] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_await] = ACTIONS(3266),
    [anon_sym_while] = ACTIONS(3266),
    [anon_sym_do] = ACTIONS(3266),
    [anon_sym_try] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_debugger] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_throw] = ACTIONS(3266),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_yield] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_LTtemplate_GT] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_class] = ACTIONS(3266),
    [anon_sym_async] = ACTIONS(3266),
    [anon_sym_function] = ACTIONS(3266),
    [anon_sym_new] = ACTIONS(3266),
    [anon_sym_using] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_SLASH] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_void] = ACTIONS(3266),
    [anon_sym_delete] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3266),
    [sym_number] = ACTIONS(3266),
    [sym_private_property_identifier] = ACTIONS(3266),
    [sym_this] = ACTIONS(3266),
    [sym_super] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_null] = ACTIONS(3266),
    [sym_undefined] = ACTIONS(3266),
    [anon_sym_AT] = ACTIONS(3266),
    [anon_sym_static] = ACTIONS(3266),
    [anon_sym_readonly] = ACTIONS(3266),
    [anon_sym_get] = ACTIONS(3266),
    [anon_sym_set] = ACTIONS(3266),
    [anon_sym_declare] = ACTIONS(3266),
    [anon_sym_public] = ACTIONS(3266),
    [anon_sym_private] = ACTIONS(3266),
    [anon_sym_protected] = ACTIONS(3266),
    [anon_sym_override] = ACTIONS(3266),
    [anon_sym_module] = ACTIONS(3266),
    [anon_sym_any] = ACTIONS(3266),
    [anon_sym_number] = ACTIONS(3266),
    [anon_sym_boolean] = ACTIONS(3266),
    [anon_sym_string] = ACTIONS(3266),
    [anon_sym_symbol] = ACTIONS(3266),
    [anon_sym_object] = ACTIONS(3266),
    [anon_sym_abstract] = ACTIONS(3266),
    [anon_sym_interface] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [sym_html_comment] = ACTIONS(5),
  },
  [1323] = {
    [sym_comment] = STATE(1323),
    [sym_identifier] = ACTIONS(3368),
    [anon_sym_export] = ACTIONS(3368),
    [anon_sym_default] = ACTIONS(3368),
    [anon_sym_type] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3368),
    [anon_sym_RBRACE] = ACTIONS(3368),
    [anon_sym_typeof] = ACTIONS(3368),
    [anon_sym_import] = ACTIONS(3368),
    [anon_sym_with] = ACTIONS(3368),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_LPAREN] = ACTIONS(3368),
    [anon_sym_await] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_debugger] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3368),
    [anon_sym_case] = ACTIONS(3368),
    [anon_sym_yield] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_LTtemplate_GT] = ACTIONS(3368),
    [anon_sym_DQUOTE] = ACTIONS(3368),
    [anon_sym_SQUOTE] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_async] = ACTIONS(3368),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_TILDE] = ACTIONS(3368),
    [anon_sym_void] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3368),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3368),
    [sym_number] = ACTIONS(3368),
    [sym_private_property_identifier] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [sym_super] = ACTIONS(3368),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [sym_null] = ACTIONS(3368),
    [sym_undefined] = ACTIONS(3368),
    [anon_sym_AT] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_readonly] = ACTIONS(3368),
    [anon_sym_get] = ACTIONS(3368),
    [anon_sym_set] = ACTIONS(3368),
    [anon_sym_declare] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_override] = ACTIONS(3368),
    [anon_sym_module] = ACTIONS(3368),
    [anon_sym_any] = ACTIONS(3368),
    [anon_sym_number] = ACTIONS(3368),
    [anon_sym_boolean] = ACTIONS(3368),
    [anon_sym_string] = ACTIONS(3368),
    [anon_sym_symbol] = ACTIONS(3368),
    [anon_sym_object] = ACTIONS(3368),
    [anon_sym_abstract] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [sym_html_comment] = ACTIONS(5),
  },
  [1324] = {
    [sym_comment] = STATE(1324),
    [sym_identifier] = ACTIONS(3368),
    [anon_sym_export] = ACTIONS(3368),
    [anon_sym_default] = ACTIONS(3368),
    [anon_sym_type] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3368),
    [anon_sym_RBRACE] = ACTIONS(3368),
    [anon_sym_typeof] = ACTIONS(3368),
    [anon_sym_import] = ACTIONS(3368),
    [anon_sym_with] = ACTIONS(3368),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_LPAREN] = ACTIONS(3368),
    [anon_sym_await] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_debugger] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3368),
    [anon_sym_case] = ACTIONS(3368),
    [anon_sym_yield] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_LTtemplate_GT] = ACTIONS(3368),
    [anon_sym_DQUOTE] = ACTIONS(3368),
    [anon_sym_SQUOTE] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_async] = ACTIONS(3368),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_TILDE] = ACTIONS(3368),
    [anon_sym_void] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3368),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3368),
    [sym_number] = ACTIONS(3368),
    [sym_private_property_identifier] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [sym_super] = ACTIONS(3368),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [sym_null] = ACTIONS(3368),
    [sym_undefined] = ACTIONS(3368),
    [anon_sym_AT] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_readonly] = ACTIONS(3368),
    [anon_sym_get] = ACTIONS(3368),
    [anon_sym_set] = ACTIONS(3368),
    [anon_sym_declare] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_override] = ACTIONS(3368),
    [anon_sym_module] = ACTIONS(3368),
    [anon_sym_any] = ACTIONS(3368),
    [anon_sym_number] = ACTIONS(3368),
    [anon_sym_boolean] = ACTIONS(3368),
    [anon_sym_string] = ACTIONS(3368),
    [anon_sym_symbol] = ACTIONS(3368),
    [anon_sym_object] = ACTIONS(3368),
    [anon_sym_abstract] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [sym_html_comment] = ACTIONS(5),
  },
  [1325] = {
    [sym_comment] = STATE(1325),
    [sym_identifier] = ACTIONS(3366),
    [anon_sym_export] = ACTIONS(3366),
    [anon_sym_default] = ACTIONS(3366),
    [anon_sym_type] = ACTIONS(3366),
    [anon_sym_namespace] = ACTIONS(3366),
    [anon_sym_LBRACE] = ACTIONS(3366),
    [anon_sym_RBRACE] = ACTIONS(3366),
    [anon_sym_typeof] = ACTIONS(3366),
    [anon_sym_import] = ACTIONS(3366),
    [anon_sym_with] = ACTIONS(3366),
    [anon_sym_var] = ACTIONS(3366),
    [anon_sym_let] = ACTIONS(3366),
    [anon_sym_const] = ACTIONS(3366),
    [anon_sym_BANG] = ACTIONS(3366),
    [anon_sym_if] = ACTIONS(3366),
    [anon_sym_switch] = ACTIONS(3366),
    [anon_sym_for] = ACTIONS(3366),
    [anon_sym_LPAREN] = ACTIONS(3366),
    [anon_sym_await] = ACTIONS(3366),
    [anon_sym_while] = ACTIONS(3366),
    [anon_sym_do] = ACTIONS(3366),
    [anon_sym_try] = ACTIONS(3366),
    [anon_sym_break] = ACTIONS(3366),
    [anon_sym_continue] = ACTIONS(3366),
    [anon_sym_debugger] = ACTIONS(3366),
    [anon_sym_return] = ACTIONS(3366),
    [anon_sym_throw] = ACTIONS(3366),
    [anon_sym_SEMI] = ACTIONS(3366),
    [anon_sym_case] = ACTIONS(3366),
    [anon_sym_yield] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(3366),
    [anon_sym_LTtemplate_GT] = ACTIONS(3366),
    [anon_sym_DQUOTE] = ACTIONS(3366),
    [anon_sym_SQUOTE] = ACTIONS(3366),
    [anon_sym_class] = ACTIONS(3366),
    [anon_sym_async] = ACTIONS(3366),
    [anon_sym_function] = ACTIONS(3366),
    [anon_sym_new] = ACTIONS(3366),
    [anon_sym_using] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_SLASH] = ACTIONS(3366),
    [anon_sym_LT] = ACTIONS(3366),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_void] = ACTIONS(3366),
    [anon_sym_delete] = ACTIONS(3366),
    [anon_sym_PLUS_PLUS] = ACTIONS(3366),
    [anon_sym_DASH_DASH] = ACTIONS(3366),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3366),
    [sym_number] = ACTIONS(3366),
    [sym_private_property_identifier] = ACTIONS(3366),
    [sym_this] = ACTIONS(3366),
    [sym_super] = ACTIONS(3366),
    [sym_true] = ACTIONS(3366),
    [sym_false] = ACTIONS(3366),
    [sym_null] = ACTIONS(3366),
    [sym_undefined] = ACTIONS(3366),
    [anon_sym_AT] = ACTIONS(3366),
    [anon_sym_static] = ACTIONS(3366),
    [anon_sym_readonly] = ACTIONS(3366),
    [anon_sym_get] = ACTIONS(3366),
    [anon_sym_set] = ACTIONS(3366),
    [anon_sym_declare] = ACTIONS(3366),
    [anon_sym_public] = ACTIONS(3366),
    [anon_sym_private] = ACTIONS(3366),
    [anon_sym_protected] = ACTIONS(3366),
    [anon_sym_override] = ACTIONS(3366),
    [anon_sym_module] = ACTIONS(3366),
    [anon_sym_any] = ACTIONS(3366),
    [anon_sym_number] = ACTIONS(3366),
    [anon_sym_boolean] = ACTIONS(3366),
    [anon_sym_string] = ACTIONS(3366),
    [anon_sym_symbol] = ACTIONS(3366),
    [anon_sym_object] = ACTIONS(3366),
    [anon_sym_abstract] = ACTIONS(3366),
    [anon_sym_interface] = ACTIONS(3366),
    [anon_sym_enum] = ACTIONS(3366),
    [sym_html_comment] = ACTIONS(5),
  },
  [1326] = {
    [sym_comment] = STATE(1326),
    [sym_identifier] = ACTIONS(3148),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_default] = ACTIONS(3148),
    [anon_sym_type] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_typeof] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3148),
    [anon_sym_with] = ACTIONS(3148),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_await] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_debugger] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_yield] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_LTtemplate_GT] = ACTIONS(3148),
    [anon_sym_DQUOTE] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_async] = ACTIONS(3148),
    [anon_sym_function] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_SLASH] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_void] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3148),
    [sym_number] = ACTIONS(3148),
    [sym_private_property_identifier] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
    [sym_super] = ACTIONS(3148),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [sym_null] = ACTIONS(3148),
    [sym_undefined] = ACTIONS(3148),
    [anon_sym_AT] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_readonly] = ACTIONS(3148),
    [anon_sym_get] = ACTIONS(3148),
    [anon_sym_set] = ACTIONS(3148),
    [anon_sym_declare] = ACTIONS(3148),
    [anon_sym_public] = ACTIONS(3148),
    [anon_sym_private] = ACTIONS(3148),
    [anon_sym_protected] = ACTIONS(3148),
    [anon_sym_override] = ACTIONS(3148),
    [anon_sym_module] = ACTIONS(3148),
    [anon_sym_any] = ACTIONS(3148),
    [anon_sym_number] = ACTIONS(3148),
    [anon_sym_boolean] = ACTIONS(3148),
    [anon_sym_string] = ACTIONS(3148),
    [anon_sym_symbol] = ACTIONS(3148),
    [anon_sym_object] = ACTIONS(3148),
    [anon_sym_abstract] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [sym_html_comment] = ACTIONS(5),
  },
  [1327] = {
    [sym_comment] = STATE(1327),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_default] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_case] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym_html_comment] = ACTIONS(5),
  },
  [1328] = {
    [sym_comment] = STATE(1328),
    [ts_builtin_sym_end] = ACTIONS(3486),
    [sym_identifier] = ACTIONS(3306),
    [anon_sym_export] = ACTIONS(3306),
    [anon_sym_type] = ACTIONS(3306),
    [anon_sym_namespace] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3306),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_typeof] = ACTIONS(3306),
    [anon_sym_import] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3306),
    [anon_sym_var] = ACTIONS(3306),
    [anon_sym_let] = ACTIONS(3306),
    [anon_sym_const] = ACTIONS(3306),
    [anon_sym_BANG] = ACTIONS(3306),
    [anon_sym_else] = ACTIONS(3306),
    [anon_sym_if] = ACTIONS(3306),
    [anon_sym_switch] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3306),
    [anon_sym_await] = ACTIONS(3306),
    [anon_sym_while] = ACTIONS(3306),
    [anon_sym_do] = ACTIONS(3306),
    [anon_sym_try] = ACTIONS(3306),
    [anon_sym_break] = ACTIONS(3306),
    [anon_sym_continue] = ACTIONS(3306),
    [anon_sym_debugger] = ACTIONS(3306),
    [anon_sym_return] = ACTIONS(3306),
    [anon_sym_throw] = ACTIONS(3306),
    [anon_sym_SEMI] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3306),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_LTtemplate_GT] = ACTIONS(3306),
    [anon_sym_DQUOTE] = ACTIONS(3306),
    [anon_sym_SQUOTE] = ACTIONS(3306),
    [anon_sym_class] = ACTIONS(3306),
    [anon_sym_async] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3306),
    [anon_sym_using] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_DASH] = ACTIONS(3306),
    [anon_sym_SLASH] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [anon_sym_void] = ACTIONS(3306),
    [anon_sym_delete] = ACTIONS(3306),
    [anon_sym_PLUS_PLUS] = ACTIONS(3306),
    [anon_sym_DASH_DASH] = ACTIONS(3306),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3306),
    [sym_number] = ACTIONS(3306),
    [sym_private_property_identifier] = ACTIONS(3306),
    [sym_this] = ACTIONS(3306),
    [sym_super] = ACTIONS(3306),
    [sym_true] = ACTIONS(3306),
    [sym_false] = ACTIONS(3306),
    [sym_null] = ACTIONS(3306),
    [sym_undefined] = ACTIONS(3306),
    [anon_sym_AT] = ACTIONS(3306),
    [anon_sym_static] = ACTIONS(3306),
    [anon_sym_readonly] = ACTIONS(3306),
    [anon_sym_get] = ACTIONS(3306),
    [anon_sym_set] = ACTIONS(3306),
    [anon_sym_declare] = ACTIONS(3306),
    [anon_sym_public] = ACTIONS(3306),
    [anon_sym_private] = ACTIONS(3306),
    [anon_sym_protected] = ACTIONS(3306),
    [anon_sym_override] = ACTIONS(3306),
    [anon_sym_module] = ACTIONS(3306),
    [anon_sym_any] = ACTIONS(3306),
    [anon_sym_number] = ACTIONS(3306),
    [anon_sym_boolean] = ACTIONS(3306),
    [anon_sym_string] = ACTIONS(3306),
    [anon_sym_symbol] = ACTIONS(3306),
    [anon_sym_object] = ACTIONS(3306),
    [anon_sym_abstract] = ACTIONS(3306),
    [anon_sym_interface] = ACTIONS(3306),
    [anon_sym_enum] = ACTIONS(3306),
    [sym_html_comment] = ACTIONS(5),
  },
  [1329] = {
    [sym_comment] = STATE(1329),
    [ts_builtin_sym_end] = ACTIONS(3488),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_export] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_namespace] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(3296),
    [anon_sym_import] = ACTIONS(3296),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_var] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_const] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_else] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_switch] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_await] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_debugger] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_throw] = ACTIONS(3296),
    [anon_sym_SEMI] = ACTIONS(3296),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LTtemplate_GT] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [anon_sym_class] = ACTIONS(3296),
    [anon_sym_async] = ACTIONS(3296),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_using] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_SLASH] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3296),
    [anon_sym_void] = ACTIONS(3296),
    [anon_sym_delete] = ACTIONS(3296),
    [anon_sym_PLUS_PLUS] = ACTIONS(3296),
    [anon_sym_DASH_DASH] = ACTIONS(3296),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3296),
    [sym_number] = ACTIONS(3296),
    [sym_private_property_identifier] = ACTIONS(3296),
    [sym_this] = ACTIONS(3296),
    [sym_super] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_null] = ACTIONS(3296),
    [sym_undefined] = ACTIONS(3296),
    [anon_sym_AT] = ACTIONS(3296),
    [anon_sym_static] = ACTIONS(3296),
    [anon_sym_readonly] = ACTIONS(3296),
    [anon_sym_get] = ACTIONS(3296),
    [anon_sym_set] = ACTIONS(3296),
    [anon_sym_declare] = ACTIONS(3296),
    [anon_sym_public] = ACTIONS(3296),
    [anon_sym_private] = ACTIONS(3296),
    [anon_sym_protected] = ACTIONS(3296),
    [anon_sym_override] = ACTIONS(3296),
    [anon_sym_module] = ACTIONS(3296),
    [anon_sym_any] = ACTIONS(3296),
    [anon_sym_number] = ACTIONS(3296),
    [anon_sym_boolean] = ACTIONS(3296),
    [anon_sym_string] = ACTIONS(3296),
    [anon_sym_symbol] = ACTIONS(3296),
    [anon_sym_object] = ACTIONS(3296),
    [anon_sym_abstract] = ACTIONS(3296),
    [anon_sym_interface] = ACTIONS(3296),
    [anon_sym_enum] = ACTIONS(3296),
    [sym_html_comment] = ACTIONS(5),
  },
  [1330] = {
    [sym_comment] = STATE(1330),
    [ts_builtin_sym_end] = ACTIONS(3200),
    [sym_identifier] = ACTIONS(3100),
    [anon_sym_export] = ACTIONS(3100),
    [anon_sym_type] = ACTIONS(3100),
    [anon_sym_namespace] = ACTIONS(3100),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_RBRACE] = ACTIONS(3100),
    [anon_sym_typeof] = ACTIONS(3100),
    [anon_sym_import] = ACTIONS(3100),
    [anon_sym_with] = ACTIONS(3100),
    [anon_sym_var] = ACTIONS(3100),
    [anon_sym_let] = ACTIONS(3100),
    [anon_sym_const] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3100),
    [anon_sym_if] = ACTIONS(3100),
    [anon_sym_switch] = ACTIONS(3100),
    [anon_sym_for] = ACTIONS(3100),
    [anon_sym_LPAREN] = ACTIONS(3100),
    [anon_sym_await] = ACTIONS(3100),
    [anon_sym_while] = ACTIONS(3100),
    [anon_sym_do] = ACTIONS(3100),
    [anon_sym_try] = ACTIONS(3100),
    [anon_sym_break] = ACTIONS(3100),
    [anon_sym_continue] = ACTIONS(3100),
    [anon_sym_debugger] = ACTIONS(3100),
    [anon_sym_return] = ACTIONS(3100),
    [anon_sym_throw] = ACTIONS(3100),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym_finally] = ACTIONS(3100),
    [anon_sym_yield] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3100),
    [anon_sym_LTtemplate_GT] = ACTIONS(3100),
    [anon_sym_DQUOTE] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(3100),
    [anon_sym_class] = ACTIONS(3100),
    [anon_sym_async] = ACTIONS(3100),
    [anon_sym_function] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3100),
    [anon_sym_using] = ACTIONS(3100),
    [anon_sym_PLUS] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [anon_sym_SLASH] = ACTIONS(3100),
    [anon_sym_LT] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_void] = ACTIONS(3100),
    [anon_sym_delete] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3100),
    [sym_number] = ACTIONS(3100),
    [sym_private_property_identifier] = ACTIONS(3100),
    [sym_this] = ACTIONS(3100),
    [sym_super] = ACTIONS(3100),
    [sym_true] = ACTIONS(3100),
    [sym_false] = ACTIONS(3100),
    [sym_null] = ACTIONS(3100),
    [sym_undefined] = ACTIONS(3100),
    [anon_sym_AT] = ACTIONS(3100),
    [anon_sym_static] = ACTIONS(3100),
    [anon_sym_readonly] = ACTIONS(3100),
    [anon_sym_get] = ACTIONS(3100),
    [anon_sym_set] = ACTIONS(3100),
    [anon_sym_declare] = ACTIONS(3100),
    [anon_sym_public] = ACTIONS(3100),
    [anon_sym_private] = ACTIONS(3100),
    [anon_sym_protected] = ACTIONS(3100),
    [anon_sym_override] = ACTIONS(3100),
    [anon_sym_module] = ACTIONS(3100),
    [anon_sym_any] = ACTIONS(3100),
    [anon_sym_number] = ACTIONS(3100),
    [anon_sym_boolean] = ACTIONS(3100),
    [anon_sym_string] = ACTIONS(3100),
    [anon_sym_symbol] = ACTIONS(3100),
    [anon_sym_object] = ACTIONS(3100),
    [anon_sym_abstract] = ACTIONS(3100),
    [anon_sym_interface] = ACTIONS(3100),
    [anon_sym_enum] = ACTIONS(3100),
    [sym_html_comment] = ACTIONS(5),
  },
  [1331] = {
    [sym_comment] = STATE(1331),
    [ts_builtin_sym_end] = ACTIONS(3490),
    [sym_identifier] = ACTIONS(3298),
    [anon_sym_export] = ACTIONS(3298),
    [anon_sym_type] = ACTIONS(3298),
    [anon_sym_namespace] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3298),
    [anon_sym_RBRACE] = ACTIONS(3298),
    [anon_sym_typeof] = ACTIONS(3298),
    [anon_sym_import] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3298),
    [anon_sym_var] = ACTIONS(3298),
    [anon_sym_let] = ACTIONS(3298),
    [anon_sym_const] = ACTIONS(3298),
    [anon_sym_BANG] = ACTIONS(3298),
    [anon_sym_else] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(3298),
    [anon_sym_switch] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3298),
    [anon_sym_await] = ACTIONS(3298),
    [anon_sym_while] = ACTIONS(3298),
    [anon_sym_do] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3298),
    [anon_sym_break] = ACTIONS(3298),
    [anon_sym_continue] = ACTIONS(3298),
    [anon_sym_debugger] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3298),
    [anon_sym_throw] = ACTIONS(3298),
    [anon_sym_SEMI] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3298),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LTtemplate_GT] = ACTIONS(3298),
    [anon_sym_DQUOTE] = ACTIONS(3298),
    [anon_sym_SQUOTE] = ACTIONS(3298),
    [anon_sym_class] = ACTIONS(3298),
    [anon_sym_async] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3298),
    [anon_sym_using] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3298),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_SLASH] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3298),
    [anon_sym_void] = ACTIONS(3298),
    [anon_sym_delete] = ACTIONS(3298),
    [anon_sym_PLUS_PLUS] = ACTIONS(3298),
    [anon_sym_DASH_DASH] = ACTIONS(3298),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3298),
    [sym_number] = ACTIONS(3298),
    [sym_private_property_identifier] = ACTIONS(3298),
    [sym_this] = ACTIONS(3298),
    [sym_super] = ACTIONS(3298),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [sym_null] = ACTIONS(3298),
    [sym_undefined] = ACTIONS(3298),
    [anon_sym_AT] = ACTIONS(3298),
    [anon_sym_static] = ACTIONS(3298),
    [anon_sym_readonly] = ACTIONS(3298),
    [anon_sym_get] = ACTIONS(3298),
    [anon_sym_set] = ACTIONS(3298),
    [anon_sym_declare] = ACTIONS(3298),
    [anon_sym_public] = ACTIONS(3298),
    [anon_sym_private] = ACTIONS(3298),
    [anon_sym_protected] = ACTIONS(3298),
    [anon_sym_override] = ACTIONS(3298),
    [anon_sym_module] = ACTIONS(3298),
    [anon_sym_any] = ACTIONS(3298),
    [anon_sym_number] = ACTIONS(3298),
    [anon_sym_boolean] = ACTIONS(3298),
    [anon_sym_string] = ACTIONS(3298),
    [anon_sym_symbol] = ACTIONS(3298),
    [anon_sym_object] = ACTIONS(3298),
    [anon_sym_abstract] = ACTIONS(3298),
    [anon_sym_interface] = ACTIONS(3298),
    [anon_sym_enum] = ACTIONS(3298),
    [sym_html_comment] = ACTIONS(5),
  },
  [1332] = {
    [sym_comment] = STATE(1332),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3302),
    [anon_sym_export] = ACTIONS(3302),
    [anon_sym_type] = ACTIONS(3302),
    [anon_sym_namespace] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3302),
    [anon_sym_RBRACE] = ACTIONS(3302),
    [anon_sym_typeof] = ACTIONS(3302),
    [anon_sym_import] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3302),
    [anon_sym_var] = ACTIONS(3302),
    [anon_sym_let] = ACTIONS(3302),
    [anon_sym_const] = ACTIONS(3302),
    [anon_sym_BANG] = ACTIONS(3302),
    [anon_sym_else] = ACTIONS(3302),
    [anon_sym_if] = ACTIONS(3302),
    [anon_sym_switch] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3302),
    [anon_sym_await] = ACTIONS(3302),
    [anon_sym_while] = ACTIONS(3302),
    [anon_sym_do] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3302),
    [anon_sym_break] = ACTIONS(3302),
    [anon_sym_continue] = ACTIONS(3302),
    [anon_sym_debugger] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3302),
    [anon_sym_throw] = ACTIONS(3302),
    [anon_sym_SEMI] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_LTtemplate_GT] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(3302),
    [anon_sym_SQUOTE] = ACTIONS(3302),
    [anon_sym_class] = ACTIONS(3302),
    [anon_sym_async] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3302),
    [anon_sym_using] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_TILDE] = ACTIONS(3302),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_delete] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3302),
    [sym_number] = ACTIONS(3302),
    [sym_private_property_identifier] = ACTIONS(3302),
    [sym_this] = ACTIONS(3302),
    [sym_super] = ACTIONS(3302),
    [sym_true] = ACTIONS(3302),
    [sym_false] = ACTIONS(3302),
    [sym_null] = ACTIONS(3302),
    [sym_undefined] = ACTIONS(3302),
    [anon_sym_AT] = ACTIONS(3302),
    [anon_sym_static] = ACTIONS(3302),
    [anon_sym_readonly] = ACTIONS(3302),
    [anon_sym_get] = ACTIONS(3302),
    [anon_sym_set] = ACTIONS(3302),
    [anon_sym_declare] = ACTIONS(3302),
    [anon_sym_public] = ACTIONS(3302),
    [anon_sym_private] = ACTIONS(3302),
    [anon_sym_protected] = ACTIONS(3302),
    [anon_sym_override] = ACTIONS(3302),
    [anon_sym_module] = ACTIONS(3302),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_object] = ACTIONS(3302),
    [anon_sym_abstract] = ACTIONS(3302),
    [anon_sym_interface] = ACTIONS(3302),
    [anon_sym_enum] = ACTIONS(3302),
    [sym_html_comment] = ACTIONS(5),
  },
  [1333] = {
    [sym_comment] = STATE(1333),
    [sym_identifier] = ACTIONS(3220),
    [anon_sym_export] = ACTIONS(3220),
    [anon_sym_default] = ACTIONS(3220),
    [anon_sym_type] = ACTIONS(3220),
    [anon_sym_namespace] = ACTIONS(3220),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_RBRACE] = ACTIONS(3220),
    [anon_sym_typeof] = ACTIONS(3220),
    [anon_sym_import] = ACTIONS(3220),
    [anon_sym_with] = ACTIONS(3220),
    [anon_sym_var] = ACTIONS(3220),
    [anon_sym_let] = ACTIONS(3220),
    [anon_sym_const] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_if] = ACTIONS(3220),
    [anon_sym_switch] = ACTIONS(3220),
    [anon_sym_for] = ACTIONS(3220),
    [anon_sym_LPAREN] = ACTIONS(3220),
    [anon_sym_await] = ACTIONS(3220),
    [anon_sym_while] = ACTIONS(3220),
    [anon_sym_do] = ACTIONS(3220),
    [anon_sym_try] = ACTIONS(3220),
    [anon_sym_break] = ACTIONS(3220),
    [anon_sym_continue] = ACTIONS(3220),
    [anon_sym_debugger] = ACTIONS(3220),
    [anon_sym_return] = ACTIONS(3220),
    [anon_sym_throw] = ACTIONS(3220),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym_case] = ACTIONS(3220),
    [anon_sym_yield] = ACTIONS(3220),
    [anon_sym_LBRACK] = ACTIONS(3220),
    [anon_sym_LTtemplate_GT] = ACTIONS(3220),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [anon_sym_class] = ACTIONS(3220),
    [anon_sym_async] = ACTIONS(3220),
    [anon_sym_function] = ACTIONS(3220),
    [anon_sym_new] = ACTIONS(3220),
    [anon_sym_using] = ACTIONS(3220),
    [anon_sym_PLUS] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3220),
    [anon_sym_SLASH] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_void] = ACTIONS(3220),
    [anon_sym_delete] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3220),
    [sym_number] = ACTIONS(3220),
    [sym_private_property_identifier] = ACTIONS(3220),
    [sym_this] = ACTIONS(3220),
    [sym_super] = ACTIONS(3220),
    [sym_true] = ACTIONS(3220),
    [sym_false] = ACTIONS(3220),
    [sym_null] = ACTIONS(3220),
    [sym_undefined] = ACTIONS(3220),
    [anon_sym_AT] = ACTIONS(3220),
    [anon_sym_static] = ACTIONS(3220),
    [anon_sym_readonly] = ACTIONS(3220),
    [anon_sym_get] = ACTIONS(3220),
    [anon_sym_set] = ACTIONS(3220),
    [anon_sym_declare] = ACTIONS(3220),
    [anon_sym_public] = ACTIONS(3220),
    [anon_sym_private] = ACTIONS(3220),
    [anon_sym_protected] = ACTIONS(3220),
    [anon_sym_override] = ACTIONS(3220),
    [anon_sym_module] = ACTIONS(3220),
    [anon_sym_any] = ACTIONS(3220),
    [anon_sym_number] = ACTIONS(3220),
    [anon_sym_boolean] = ACTIONS(3220),
    [anon_sym_string] = ACTIONS(3220),
    [anon_sym_symbol] = ACTIONS(3220),
    [anon_sym_object] = ACTIONS(3220),
    [anon_sym_abstract] = ACTIONS(3220),
    [anon_sym_interface] = ACTIONS(3220),
    [anon_sym_enum] = ACTIONS(3220),
    [sym_html_comment] = ACTIONS(5),
  },
  [1334] = {
    [sym_comment] = STATE(1334),
    [sym_identifier] = ACTIONS(3218),
    [anon_sym_export] = ACTIONS(3218),
    [anon_sym_default] = ACTIONS(3218),
    [anon_sym_type] = ACTIONS(3218),
    [anon_sym_namespace] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_RBRACE] = ACTIONS(3218),
    [anon_sym_typeof] = ACTIONS(3218),
    [anon_sym_import] = ACTIONS(3218),
    [anon_sym_with] = ACTIONS(3218),
    [anon_sym_var] = ACTIONS(3218),
    [anon_sym_let] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3218),
    [anon_sym_BANG] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_switch] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_LPAREN] = ACTIONS(3218),
    [anon_sym_await] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_debugger] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_throw] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_case] = ACTIONS(3218),
    [anon_sym_yield] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_LTtemplate_GT] = ACTIONS(3218),
    [anon_sym_DQUOTE] = ACTIONS(3218),
    [anon_sym_SQUOTE] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_async] = ACTIONS(3218),
    [anon_sym_function] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_using] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_SLASH] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3218),
    [anon_sym_TILDE] = ACTIONS(3218),
    [anon_sym_void] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3218),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3218),
    [sym_number] = ACTIONS(3218),
    [sym_private_property_identifier] = ACTIONS(3218),
    [sym_this] = ACTIONS(3218),
    [sym_super] = ACTIONS(3218),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [sym_null] = ACTIONS(3218),
    [sym_undefined] = ACTIONS(3218),
    [anon_sym_AT] = ACTIONS(3218),
    [anon_sym_static] = ACTIONS(3218),
    [anon_sym_readonly] = ACTIONS(3218),
    [anon_sym_get] = ACTIONS(3218),
    [anon_sym_set] = ACTIONS(3218),
    [anon_sym_declare] = ACTIONS(3218),
    [anon_sym_public] = ACTIONS(3218),
    [anon_sym_private] = ACTIONS(3218),
    [anon_sym_protected] = ACTIONS(3218),
    [anon_sym_override] = ACTIONS(3218),
    [anon_sym_module] = ACTIONS(3218),
    [anon_sym_any] = ACTIONS(3218),
    [anon_sym_number] = ACTIONS(3218),
    [anon_sym_boolean] = ACTIONS(3218),
    [anon_sym_string] = ACTIONS(3218),
    [anon_sym_symbol] = ACTIONS(3218),
    [anon_sym_object] = ACTIONS(3218),
    [anon_sym_abstract] = ACTIONS(3218),
    [anon_sym_interface] = ACTIONS(3218),
    [anon_sym_enum] = ACTIONS(3218),
    [sym_html_comment] = ACTIONS(5),
  },
  [1335] = {
    [sym_comment] = STATE(1335),
    [sym_identifier] = ACTIONS(3358),
    [anon_sym_export] = ACTIONS(3358),
    [anon_sym_default] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3358),
    [anon_sym_namespace] = ACTIONS(3358),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_RBRACE] = ACTIONS(3358),
    [anon_sym_typeof] = ACTIONS(3358),
    [anon_sym_import] = ACTIONS(3358),
    [anon_sym_with] = ACTIONS(3358),
    [anon_sym_var] = ACTIONS(3358),
    [anon_sym_let] = ACTIONS(3358),
    [anon_sym_const] = ACTIONS(3358),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3358),
    [anon_sym_switch] = ACTIONS(3358),
    [anon_sym_for] = ACTIONS(3358),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3358),
    [anon_sym_while] = ACTIONS(3358),
    [anon_sym_do] = ACTIONS(3358),
    [anon_sym_try] = ACTIONS(3358),
    [anon_sym_break] = ACTIONS(3358),
    [anon_sym_continue] = ACTIONS(3358),
    [anon_sym_debugger] = ACTIONS(3358),
    [anon_sym_return] = ACTIONS(3358),
    [anon_sym_throw] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_case] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3358),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [anon_sym_class] = ACTIONS(3358),
    [anon_sym_async] = ACTIONS(3358),
    [anon_sym_function] = ACTIONS(3358),
    [anon_sym_new] = ACTIONS(3358),
    [anon_sym_using] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3358),
    [anon_sym_DASH] = ACTIONS(3358),
    [anon_sym_SLASH] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3358),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_private_property_identifier] = ACTIONS(3358),
    [sym_this] = ACTIONS(3358),
    [sym_super] = ACTIONS(3358),
    [sym_true] = ACTIONS(3358),
    [sym_false] = ACTIONS(3358),
    [sym_null] = ACTIONS(3358),
    [sym_undefined] = ACTIONS(3358),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3358),
    [anon_sym_readonly] = ACTIONS(3358),
    [anon_sym_get] = ACTIONS(3358),
    [anon_sym_set] = ACTIONS(3358),
    [anon_sym_declare] = ACTIONS(3358),
    [anon_sym_public] = ACTIONS(3358),
    [anon_sym_private] = ACTIONS(3358),
    [anon_sym_protected] = ACTIONS(3358),
    [anon_sym_override] = ACTIONS(3358),
    [anon_sym_module] = ACTIONS(3358),
    [anon_sym_any] = ACTIONS(3358),
    [anon_sym_number] = ACTIONS(3358),
    [anon_sym_boolean] = ACTIONS(3358),
    [anon_sym_string] = ACTIONS(3358),
    [anon_sym_symbol] = ACTIONS(3358),
    [anon_sym_object] = ACTIONS(3358),
    [anon_sym_abstract] = ACTIONS(3358),
    [anon_sym_interface] = ACTIONS(3358),
    [anon_sym_enum] = ACTIONS(3358),
    [sym_html_comment] = ACTIONS(5),
  },
  [1336] = {
    [sym_comment] = STATE(1336),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_default] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym_case] = ACTIONS(3356),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LTtemplate_GT] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_using] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [sym_number] = ACTIONS(3356),
    [sym_private_property_identifier] = ACTIONS(3356),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3356),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_object] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [sym_html_comment] = ACTIONS(5),
  },
  [1337] = {
    [sym_comment] = STATE(1337),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_default] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym_case] = ACTIONS(3356),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LTtemplate_GT] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_using] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [sym_number] = ACTIONS(3356),
    [sym_private_property_identifier] = ACTIONS(3356),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3356),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_object] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [sym_html_comment] = ACTIONS(5),
  },
  [1338] = {
    [sym_comment] = STATE(1338),
    [ts_builtin_sym_end] = ACTIONS(3494),
    [sym_identifier] = ACTIONS(3182),
    [anon_sym_export] = ACTIONS(3182),
    [anon_sym_type] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_typeof] = ACTIONS(3182),
    [anon_sym_import] = ACTIONS(3182),
    [anon_sym_with] = ACTIONS(3182),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_await] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_debugger] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_LTtemplate_GT] = ACTIONS(3182),
    [anon_sym_DQUOTE] = ACTIONS(3182),
    [anon_sym_SQUOTE] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_async] = ACTIONS(3182),
    [anon_sym_function] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_SLASH] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_void] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3182),
    [sym_number] = ACTIONS(3182),
    [sym_private_property_identifier] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [sym_super] = ACTIONS(3182),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [sym_null] = ACTIONS(3182),
    [sym_undefined] = ACTIONS(3182),
    [anon_sym_AT] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_readonly] = ACTIONS(3182),
    [anon_sym_get] = ACTIONS(3182),
    [anon_sym_set] = ACTIONS(3182),
    [anon_sym_declare] = ACTIONS(3182),
    [anon_sym_public] = ACTIONS(3182),
    [anon_sym_private] = ACTIONS(3182),
    [anon_sym_protected] = ACTIONS(3182),
    [anon_sym_override] = ACTIONS(3182),
    [anon_sym_module] = ACTIONS(3182),
    [anon_sym_any] = ACTIONS(3182),
    [anon_sym_number] = ACTIONS(3182),
    [anon_sym_boolean] = ACTIONS(3182),
    [anon_sym_string] = ACTIONS(3182),
    [anon_sym_symbol] = ACTIONS(3182),
    [anon_sym_object] = ACTIONS(3182),
    [anon_sym_abstract] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [sym_html_comment] = ACTIONS(5),
  },
  [1339] = {
    [sym_comment] = STATE(1339),
    [ts_builtin_sym_end] = ACTIONS(2147),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym__automatic_semicolon] = ACTIONS(2147),
    [sym_html_comment] = ACTIONS(5),
  },
  [1340] = {
    [sym_comment] = STATE(1340),
    [ts_builtin_sym_end] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3168),
    [anon_sym_export] = ACTIONS(3168),
    [anon_sym_type] = ACTIONS(3168),
    [anon_sym_namespace] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_typeof] = ACTIONS(3168),
    [anon_sym_import] = ACTIONS(3168),
    [anon_sym_with] = ACTIONS(3168),
    [anon_sym_var] = ACTIONS(3168),
    [anon_sym_let] = ACTIONS(3168),
    [anon_sym_const] = ACTIONS(3168),
    [anon_sym_BANG] = ACTIONS(3168),
    [anon_sym_else] = ACTIONS(3168),
    [anon_sym_if] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3168),
    [anon_sym_LPAREN] = ACTIONS(3168),
    [anon_sym_await] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3168),
    [anon_sym_do] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3168),
    [anon_sym_break] = ACTIONS(3168),
    [anon_sym_continue] = ACTIONS(3168),
    [anon_sym_debugger] = ACTIONS(3168),
    [anon_sym_return] = ACTIONS(3168),
    [anon_sym_throw] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_yield] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_LTtemplate_GT] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_class] = ACTIONS(3168),
    [anon_sym_async] = ACTIONS(3168),
    [anon_sym_function] = ACTIONS(3168),
    [anon_sym_new] = ACTIONS(3168),
    [anon_sym_using] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3168),
    [anon_sym_SLASH] = ACTIONS(3168),
    [anon_sym_LT] = ACTIONS(3168),
    [anon_sym_TILDE] = ACTIONS(3168),
    [anon_sym_void] = ACTIONS(3168),
    [anon_sym_delete] = ACTIONS(3168),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3168),
    [sym_number] = ACTIONS(3168),
    [sym_private_property_identifier] = ACTIONS(3168),
    [sym_this] = ACTIONS(3168),
    [sym_super] = ACTIONS(3168),
    [sym_true] = ACTIONS(3168),
    [sym_false] = ACTIONS(3168),
    [sym_null] = ACTIONS(3168),
    [sym_undefined] = ACTIONS(3168),
    [anon_sym_AT] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3168),
    [anon_sym_readonly] = ACTIONS(3168),
    [anon_sym_get] = ACTIONS(3168),
    [anon_sym_set] = ACTIONS(3168),
    [anon_sym_declare] = ACTIONS(3168),
    [anon_sym_public] = ACTIONS(3168),
    [anon_sym_private] = ACTIONS(3168),
    [anon_sym_protected] = ACTIONS(3168),
    [anon_sym_override] = ACTIONS(3168),
    [anon_sym_module] = ACTIONS(3168),
    [anon_sym_any] = ACTIONS(3168),
    [anon_sym_number] = ACTIONS(3168),
    [anon_sym_boolean] = ACTIONS(3168),
    [anon_sym_string] = ACTIONS(3168),
    [anon_sym_symbol] = ACTIONS(3168),
    [anon_sym_object] = ACTIONS(3168),
    [anon_sym_abstract] = ACTIONS(3168),
    [anon_sym_interface] = ACTIONS(3168),
    [anon_sym_enum] = ACTIONS(3168),
    [sym_html_comment] = ACTIONS(5),
  },
  [1341] = {
    [sym_comment] = STATE(1341),
    [sym_identifier] = ACTIONS(3354),
    [anon_sym_export] = ACTIONS(3354),
    [anon_sym_default] = ACTIONS(3354),
    [anon_sym_type] = ACTIONS(3354),
    [anon_sym_namespace] = ACTIONS(3354),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_RBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3354),
    [anon_sym_import] = ACTIONS(3354),
    [anon_sym_with] = ACTIONS(3354),
    [anon_sym_var] = ACTIONS(3354),
    [anon_sym_let] = ACTIONS(3354),
    [anon_sym_const] = ACTIONS(3354),
    [anon_sym_BANG] = ACTIONS(3354),
    [anon_sym_if] = ACTIONS(3354),
    [anon_sym_switch] = ACTIONS(3354),
    [anon_sym_for] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3354),
    [anon_sym_await] = ACTIONS(3354),
    [anon_sym_while] = ACTIONS(3354),
    [anon_sym_do] = ACTIONS(3354),
    [anon_sym_try] = ACTIONS(3354),
    [anon_sym_break] = ACTIONS(3354),
    [anon_sym_continue] = ACTIONS(3354),
    [anon_sym_debugger] = ACTIONS(3354),
    [anon_sym_return] = ACTIONS(3354),
    [anon_sym_throw] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(3354),
    [anon_sym_case] = ACTIONS(3354),
    [anon_sym_yield] = ACTIONS(3354),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_LTtemplate_GT] = ACTIONS(3354),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_class] = ACTIONS(3354),
    [anon_sym_async] = ACTIONS(3354),
    [anon_sym_function] = ACTIONS(3354),
    [anon_sym_new] = ACTIONS(3354),
    [anon_sym_using] = ACTIONS(3354),
    [anon_sym_PLUS] = ACTIONS(3354),
    [anon_sym_DASH] = ACTIONS(3354),
    [anon_sym_SLASH] = ACTIONS(3354),
    [anon_sym_LT] = ACTIONS(3354),
    [anon_sym_TILDE] = ACTIONS(3354),
    [anon_sym_void] = ACTIONS(3354),
    [anon_sym_delete] = ACTIONS(3354),
    [anon_sym_PLUS_PLUS] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3354),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3354),
    [sym_number] = ACTIONS(3354),
    [sym_private_property_identifier] = ACTIONS(3354),
    [sym_this] = ACTIONS(3354),
    [sym_super] = ACTIONS(3354),
    [sym_true] = ACTIONS(3354),
    [sym_false] = ACTIONS(3354),
    [sym_null] = ACTIONS(3354),
    [sym_undefined] = ACTIONS(3354),
    [anon_sym_AT] = ACTIONS(3354),
    [anon_sym_static] = ACTIONS(3354),
    [anon_sym_readonly] = ACTIONS(3354),
    [anon_sym_get] = ACTIONS(3354),
    [anon_sym_set] = ACTIONS(3354),
    [anon_sym_declare] = ACTIONS(3354),
    [anon_sym_public] = ACTIONS(3354),
    [anon_sym_private] = ACTIONS(3354),
    [anon_sym_protected] = ACTIONS(3354),
    [anon_sym_override] = ACTIONS(3354),
    [anon_sym_module] = ACTIONS(3354),
    [anon_sym_any] = ACTIONS(3354),
    [anon_sym_number] = ACTIONS(3354),
    [anon_sym_boolean] = ACTIONS(3354),
    [anon_sym_string] = ACTIONS(3354),
    [anon_sym_symbol] = ACTIONS(3354),
    [anon_sym_object] = ACTIONS(3354),
    [anon_sym_abstract] = ACTIONS(3354),
    [anon_sym_interface] = ACTIONS(3354),
    [anon_sym_enum] = ACTIONS(3354),
    [sym_html_comment] = ACTIONS(5),
  },
  [1342] = {
    [sym_comment] = STATE(1342),
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_export] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3214),
    [anon_sym_type] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3214),
    [anon_sym_RBRACE] = ACTIONS(3214),
    [anon_sym_typeof] = ACTIONS(3214),
    [anon_sym_import] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3214),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_BANG] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3214),
    [anon_sym_await] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_debugger] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3214),
    [anon_sym_case] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_LTtemplate_GT] = ACTIONS(3214),
    [anon_sym_DQUOTE] = ACTIONS(3214),
    [anon_sym_SQUOTE] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_SLASH] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3214),
    [anon_sym_void] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_PLUS_PLUS] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3214),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3214),
    [sym_number] = ACTIONS(3214),
    [sym_private_property_identifier] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [sym_super] = ACTIONS(3214),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [sym_null] = ACTIONS(3214),
    [sym_undefined] = ACTIONS(3214),
    [anon_sym_AT] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_readonly] = ACTIONS(3214),
    [anon_sym_get] = ACTIONS(3214),
    [anon_sym_set] = ACTIONS(3214),
    [anon_sym_declare] = ACTIONS(3214),
    [anon_sym_public] = ACTIONS(3214),
    [anon_sym_private] = ACTIONS(3214),
    [anon_sym_protected] = ACTIONS(3214),
    [anon_sym_override] = ACTIONS(3214),
    [anon_sym_module] = ACTIONS(3214),
    [anon_sym_any] = ACTIONS(3214),
    [anon_sym_number] = ACTIONS(3214),
    [anon_sym_boolean] = ACTIONS(3214),
    [anon_sym_string] = ACTIONS(3214),
    [anon_sym_symbol] = ACTIONS(3214),
    [anon_sym_object] = ACTIONS(3214),
    [anon_sym_abstract] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [sym_html_comment] = ACTIONS(5),
  },
  [1343] = {
    [sym_comment] = STATE(1343),
    [sym_identifier] = ACTIONS(3332),
    [anon_sym_export] = ACTIONS(3332),
    [anon_sym_default] = ACTIONS(3332),
    [anon_sym_type] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_typeof] = ACTIONS(3332),
    [anon_sym_import] = ACTIONS(3332),
    [anon_sym_with] = ACTIONS(3332),
    [anon_sym_var] = ACTIONS(3332),
    [anon_sym_let] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_await] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_debugger] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_throw] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_case] = ACTIONS(3332),
    [anon_sym_yield] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_LTtemplate_GT] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_async] = ACTIONS(3332),
    [anon_sym_function] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_SLASH] = ACTIONS(3332),
    [anon_sym_LT] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_void] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3332),
    [sym_number] = ACTIONS(3332),
    [sym_private_property_identifier] = ACTIONS(3332),
    [sym_this] = ACTIONS(3332),
    [sym_super] = ACTIONS(3332),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_null] = ACTIONS(3332),
    [sym_undefined] = ACTIONS(3332),
    [anon_sym_AT] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_readonly] = ACTIONS(3332),
    [anon_sym_get] = ACTIONS(3332),
    [anon_sym_set] = ACTIONS(3332),
    [anon_sym_declare] = ACTIONS(3332),
    [anon_sym_public] = ACTIONS(3332),
    [anon_sym_private] = ACTIONS(3332),
    [anon_sym_protected] = ACTIONS(3332),
    [anon_sym_override] = ACTIONS(3332),
    [anon_sym_module] = ACTIONS(3332),
    [anon_sym_any] = ACTIONS(3332),
    [anon_sym_number] = ACTIONS(3332),
    [anon_sym_boolean] = ACTIONS(3332),
    [anon_sym_string] = ACTIONS(3332),
    [anon_sym_symbol] = ACTIONS(3332),
    [anon_sym_object] = ACTIONS(3332),
    [anon_sym_abstract] = ACTIONS(3332),
    [anon_sym_interface] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [sym_html_comment] = ACTIONS(5),
  },
  [1344] = {
    [sym_comment] = STATE(1344),
    [ts_builtin_sym_end] = ACTIONS(3498),
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_export] = ACTIONS(3152),
    [anon_sym_type] = ACTIONS(3152),
    [anon_sym_namespace] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3152),
    [anon_sym_typeof] = ACTIONS(3152),
    [anon_sym_import] = ACTIONS(3152),
    [anon_sym_with] = ACTIONS(3152),
    [anon_sym_var] = ACTIONS(3152),
    [anon_sym_let] = ACTIONS(3152),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_else] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_switch] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3152),
    [anon_sym_await] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_do] = ACTIONS(3152),
    [anon_sym_try] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_continue] = ACTIONS(3152),
    [anon_sym_debugger] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_throw] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym_yield] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_LTtemplate_GT] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_async] = ACTIONS(3152),
    [anon_sym_function] = ACTIONS(3152),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_using] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_LT] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_void] = ACTIONS(3152),
    [anon_sym_delete] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3152),
    [sym_number] = ACTIONS(3152),
    [sym_private_property_identifier] = ACTIONS(3152),
    [sym_this] = ACTIONS(3152),
    [sym_super] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_null] = ACTIONS(3152),
    [sym_undefined] = ACTIONS(3152),
    [anon_sym_AT] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_readonly] = ACTIONS(3152),
    [anon_sym_get] = ACTIONS(3152),
    [anon_sym_set] = ACTIONS(3152),
    [anon_sym_declare] = ACTIONS(3152),
    [anon_sym_public] = ACTIONS(3152),
    [anon_sym_private] = ACTIONS(3152),
    [anon_sym_protected] = ACTIONS(3152),
    [anon_sym_override] = ACTIONS(3152),
    [anon_sym_module] = ACTIONS(3152),
    [anon_sym_any] = ACTIONS(3152),
    [anon_sym_number] = ACTIONS(3152),
    [anon_sym_boolean] = ACTIONS(3152),
    [anon_sym_string] = ACTIONS(3152),
    [anon_sym_symbol] = ACTIONS(3152),
    [anon_sym_object] = ACTIONS(3152),
    [anon_sym_abstract] = ACTIONS(3152),
    [anon_sym_interface] = ACTIONS(3152),
    [anon_sym_enum] = ACTIONS(3152),
    [sym_html_comment] = ACTIONS(5),
  },
  [1345] = {
    [sym_comment] = STATE(1345),
    [ts_builtin_sym_end] = ACTIONS(3500),
    [sym_identifier] = ACTIONS(3150),
    [anon_sym_export] = ACTIONS(3150),
    [anon_sym_type] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_typeof] = ACTIONS(3150),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_with] = ACTIONS(3150),
    [anon_sym_var] = ACTIONS(3150),
    [anon_sym_let] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_LPAREN] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_debugger] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym_yield] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_LTtemplate_GT] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_async] = ACTIONS(3150),
    [anon_sym_function] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3150),
    [anon_sym_LT] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_void] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3150),
    [sym_number] = ACTIONS(3150),
    [sym_private_property_identifier] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
    [sym_super] = ACTIONS(3150),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [sym_null] = ACTIONS(3150),
    [sym_undefined] = ACTIONS(3150),
    [anon_sym_AT] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_readonly] = ACTIONS(3150),
    [anon_sym_get] = ACTIONS(3150),
    [anon_sym_set] = ACTIONS(3150),
    [anon_sym_declare] = ACTIONS(3150),
    [anon_sym_public] = ACTIONS(3150),
    [anon_sym_private] = ACTIONS(3150),
    [anon_sym_protected] = ACTIONS(3150),
    [anon_sym_override] = ACTIONS(3150),
    [anon_sym_module] = ACTIONS(3150),
    [anon_sym_any] = ACTIONS(3150),
    [anon_sym_number] = ACTIONS(3150),
    [anon_sym_boolean] = ACTIONS(3150),
    [anon_sym_string] = ACTIONS(3150),
    [anon_sym_symbol] = ACTIONS(3150),
    [anon_sym_object] = ACTIONS(3150),
    [anon_sym_abstract] = ACTIONS(3150),
    [anon_sym_interface] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [sym_html_comment] = ACTIONS(5),
  },
  [1346] = {
    [sym_comment] = STATE(1346),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_export] = ACTIONS(3350),
    [anon_sym_default] = ACTIONS(3350),
    [anon_sym_type] = ACTIONS(3350),
    [anon_sym_namespace] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3350),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_typeof] = ACTIONS(3350),
    [anon_sym_import] = ACTIONS(3350),
    [anon_sym_with] = ACTIONS(3350),
    [anon_sym_var] = ACTIONS(3350),
    [anon_sym_let] = ACTIONS(3350),
    [anon_sym_const] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_switch] = ACTIONS(3350),
    [anon_sym_for] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym_await] = ACTIONS(3350),
    [anon_sym_while] = ACTIONS(3350),
    [anon_sym_do] = ACTIONS(3350),
    [anon_sym_try] = ACTIONS(3350),
    [anon_sym_break] = ACTIONS(3350),
    [anon_sym_continue] = ACTIONS(3350),
    [anon_sym_debugger] = ACTIONS(3350),
    [anon_sym_return] = ACTIONS(3350),
    [anon_sym_throw] = ACTIONS(3350),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym_case] = ACTIONS(3350),
    [anon_sym_yield] = ACTIONS(3350),
    [anon_sym_LBRACK] = ACTIONS(3350),
    [anon_sym_LTtemplate_GT] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_class] = ACTIONS(3350),
    [anon_sym_async] = ACTIONS(3350),
    [anon_sym_function] = ACTIONS(3350),
    [anon_sym_new] = ACTIONS(3350),
    [anon_sym_using] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_void] = ACTIONS(3350),
    [anon_sym_delete] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [sym_number] = ACTIONS(3350),
    [sym_private_property_identifier] = ACTIONS(3350),
    [sym_this] = ACTIONS(3350),
    [sym_super] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_null] = ACTIONS(3350),
    [sym_undefined] = ACTIONS(3350),
    [anon_sym_AT] = ACTIONS(3350),
    [anon_sym_static] = ACTIONS(3350),
    [anon_sym_readonly] = ACTIONS(3350),
    [anon_sym_get] = ACTIONS(3350),
    [anon_sym_set] = ACTIONS(3350),
    [anon_sym_declare] = ACTIONS(3350),
    [anon_sym_public] = ACTIONS(3350),
    [anon_sym_private] = ACTIONS(3350),
    [anon_sym_protected] = ACTIONS(3350),
    [anon_sym_override] = ACTIONS(3350),
    [anon_sym_module] = ACTIONS(3350),
    [anon_sym_any] = ACTIONS(3350),
    [anon_sym_number] = ACTIONS(3350),
    [anon_sym_boolean] = ACTIONS(3350),
    [anon_sym_string] = ACTIONS(3350),
    [anon_sym_symbol] = ACTIONS(3350),
    [anon_sym_object] = ACTIONS(3350),
    [anon_sym_abstract] = ACTIONS(3350),
    [anon_sym_interface] = ACTIONS(3350),
    [anon_sym_enum] = ACTIONS(3350),
    [sym_html_comment] = ACTIONS(5),
  },
  [1347] = {
    [sym_comment] = STATE(1347),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_export] = ACTIONS(3316),
    [anon_sym_default] = ACTIONS(3316),
    [anon_sym_type] = ACTIONS(3316),
    [anon_sym_namespace] = ACTIONS(3316),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_typeof] = ACTIONS(3316),
    [anon_sym_import] = ACTIONS(3316),
    [anon_sym_with] = ACTIONS(3316),
    [anon_sym_var] = ACTIONS(3316),
    [anon_sym_let] = ACTIONS(3316),
    [anon_sym_const] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_if] = ACTIONS(3316),
    [anon_sym_switch] = ACTIONS(3316),
    [anon_sym_for] = ACTIONS(3316),
    [anon_sym_LPAREN] = ACTIONS(3316),
    [anon_sym_await] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(3316),
    [anon_sym_do] = ACTIONS(3316),
    [anon_sym_try] = ACTIONS(3316),
    [anon_sym_break] = ACTIONS(3316),
    [anon_sym_continue] = ACTIONS(3316),
    [anon_sym_debugger] = ACTIONS(3316),
    [anon_sym_return] = ACTIONS(3316),
    [anon_sym_throw] = ACTIONS(3316),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym_case] = ACTIONS(3316),
    [anon_sym_yield] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_LTtemplate_GT] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_class] = ACTIONS(3316),
    [anon_sym_async] = ACTIONS(3316),
    [anon_sym_function] = ACTIONS(3316),
    [anon_sym_new] = ACTIONS(3316),
    [anon_sym_using] = ACTIONS(3316),
    [anon_sym_PLUS] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3316),
    [anon_sym_SLASH] = ACTIONS(3316),
    [anon_sym_LT] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_void] = ACTIONS(3316),
    [anon_sym_delete] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3316),
    [sym_number] = ACTIONS(3316),
    [sym_private_property_identifier] = ACTIONS(3316),
    [sym_this] = ACTIONS(3316),
    [sym_super] = ACTIONS(3316),
    [sym_true] = ACTIONS(3316),
    [sym_false] = ACTIONS(3316),
    [sym_null] = ACTIONS(3316),
    [sym_undefined] = ACTIONS(3316),
    [anon_sym_AT] = ACTIONS(3316),
    [anon_sym_static] = ACTIONS(3316),
    [anon_sym_readonly] = ACTIONS(3316),
    [anon_sym_get] = ACTIONS(3316),
    [anon_sym_set] = ACTIONS(3316),
    [anon_sym_declare] = ACTIONS(3316),
    [anon_sym_public] = ACTIONS(3316),
    [anon_sym_private] = ACTIONS(3316),
    [anon_sym_protected] = ACTIONS(3316),
    [anon_sym_override] = ACTIONS(3316),
    [anon_sym_module] = ACTIONS(3316),
    [anon_sym_any] = ACTIONS(3316),
    [anon_sym_number] = ACTIONS(3316),
    [anon_sym_boolean] = ACTIONS(3316),
    [anon_sym_string] = ACTIONS(3316),
    [anon_sym_symbol] = ACTIONS(3316),
    [anon_sym_object] = ACTIONS(3316),
    [anon_sym_abstract] = ACTIONS(3316),
    [anon_sym_interface] = ACTIONS(3316),
    [anon_sym_enum] = ACTIONS(3316),
    [sym_html_comment] = ACTIONS(5),
  },
  [1348] = {
    [sym_comment] = STATE(1348),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_default] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_case] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym_html_comment] = ACTIONS(5),
  },
  [1349] = {
    [sym_comment] = STATE(1349),
    [ts_builtin_sym_end] = ACTIONS(3502),
    [sym_identifier] = ACTIONS(3330),
    [anon_sym_export] = ACTIONS(3330),
    [anon_sym_type] = ACTIONS(3330),
    [anon_sym_namespace] = ACTIONS(3330),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_RBRACE] = ACTIONS(3330),
    [anon_sym_typeof] = ACTIONS(3330),
    [anon_sym_import] = ACTIONS(3330),
    [anon_sym_with] = ACTIONS(3330),
    [anon_sym_var] = ACTIONS(3330),
    [anon_sym_let] = ACTIONS(3330),
    [anon_sym_const] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_else] = ACTIONS(3330),
    [anon_sym_if] = ACTIONS(3330),
    [anon_sym_switch] = ACTIONS(3330),
    [anon_sym_for] = ACTIONS(3330),
    [anon_sym_LPAREN] = ACTIONS(3330),
    [anon_sym_await] = ACTIONS(3330),
    [anon_sym_while] = ACTIONS(3330),
    [anon_sym_do] = ACTIONS(3330),
    [anon_sym_try] = ACTIONS(3330),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_continue] = ACTIONS(3330),
    [anon_sym_debugger] = ACTIONS(3330),
    [anon_sym_return] = ACTIONS(3330),
    [anon_sym_throw] = ACTIONS(3330),
    [anon_sym_SEMI] = ACTIONS(3330),
    [anon_sym_yield] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_LTtemplate_GT] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_class] = ACTIONS(3330),
    [anon_sym_async] = ACTIONS(3330),
    [anon_sym_function] = ACTIONS(3330),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_using] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_SLASH] = ACTIONS(3330),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_void] = ACTIONS(3330),
    [anon_sym_delete] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3330),
    [sym_number] = ACTIONS(3330),
    [sym_private_property_identifier] = ACTIONS(3330),
    [sym_this] = ACTIONS(3330),
    [sym_super] = ACTIONS(3330),
    [sym_true] = ACTIONS(3330),
    [sym_false] = ACTIONS(3330),
    [sym_null] = ACTIONS(3330),
    [sym_undefined] = ACTIONS(3330),
    [anon_sym_AT] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3330),
    [anon_sym_readonly] = ACTIONS(3330),
    [anon_sym_get] = ACTIONS(3330),
    [anon_sym_set] = ACTIONS(3330),
    [anon_sym_declare] = ACTIONS(3330),
    [anon_sym_public] = ACTIONS(3330),
    [anon_sym_private] = ACTIONS(3330),
    [anon_sym_protected] = ACTIONS(3330),
    [anon_sym_override] = ACTIONS(3330),
    [anon_sym_module] = ACTIONS(3330),
    [anon_sym_any] = ACTIONS(3330),
    [anon_sym_number] = ACTIONS(3330),
    [anon_sym_boolean] = ACTIONS(3330),
    [anon_sym_string] = ACTIONS(3330),
    [anon_sym_symbol] = ACTIONS(3330),
    [anon_sym_object] = ACTIONS(3330),
    [anon_sym_abstract] = ACTIONS(3330),
    [anon_sym_interface] = ACTIONS(3330),
    [anon_sym_enum] = ACTIONS(3330),
    [sym_html_comment] = ACTIONS(5),
  },
  [1350] = {
    [sym_comment] = STATE(1350),
    [sym_identifier] = ACTIONS(3348),
    [anon_sym_export] = ACTIONS(3348),
    [anon_sym_default] = ACTIONS(3348),
    [anon_sym_type] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_RBRACE] = ACTIONS(3348),
    [anon_sym_typeof] = ACTIONS(3348),
    [anon_sym_import] = ACTIONS(3348),
    [anon_sym_with] = ACTIONS(3348),
    [anon_sym_var] = ACTIONS(3348),
    [anon_sym_let] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_BANG] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_LPAREN] = ACTIONS(3348),
    [anon_sym_await] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_debugger] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_throw] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3348),
    [anon_sym_case] = ACTIONS(3348),
    [anon_sym_yield] = ACTIONS(3348),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_LTtemplate_GT] = ACTIONS(3348),
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [anon_sym_SQUOTE] = ACTIONS(3348),
    [anon_sym_class] = ACTIONS(3348),
    [anon_sym_async] = ACTIONS(3348),
    [anon_sym_function] = ACTIONS(3348),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3348),
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_void] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [sym_number] = ACTIONS(3348),
    [sym_private_property_identifier] = ACTIONS(3348),
    [sym_this] = ACTIONS(3348),
    [sym_super] = ACTIONS(3348),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_undefined] = ACTIONS(3348),
    [anon_sym_AT] = ACTIONS(3348),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_readonly] = ACTIONS(3348),
    [anon_sym_get] = ACTIONS(3348),
    [anon_sym_set] = ACTIONS(3348),
    [anon_sym_declare] = ACTIONS(3348),
    [anon_sym_public] = ACTIONS(3348),
    [anon_sym_private] = ACTIONS(3348),
    [anon_sym_protected] = ACTIONS(3348),
    [anon_sym_override] = ACTIONS(3348),
    [anon_sym_module] = ACTIONS(3348),
    [anon_sym_any] = ACTIONS(3348),
    [anon_sym_number] = ACTIONS(3348),
    [anon_sym_boolean] = ACTIONS(3348),
    [anon_sym_string] = ACTIONS(3348),
    [anon_sym_symbol] = ACTIONS(3348),
    [anon_sym_object] = ACTIONS(3348),
    [anon_sym_abstract] = ACTIONS(3348),
    [anon_sym_interface] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [sym_html_comment] = ACTIONS(5),
  },
  [1351] = {
    [sym_comment] = STATE(1351),
    [ts_builtin_sym_end] = ACTIONS(2177),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_namespace] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2175),
    [anon_sym_import] = ACTIONS(2175),
    [anon_sym_with] = ACTIONS(2175),
    [anon_sym_var] = ACTIONS(2175),
    [anon_sym_let] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_else] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_switch] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_await] = ACTIONS(2175),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_do] = ACTIONS(2175),
    [anon_sym_try] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_debugger] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [anon_sym_LTtemplate_GT] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_class] = ACTIONS(2175),
    [anon_sym_async] = ACTIONS(2175),
    [anon_sym_function] = ACTIONS(2175),
    [anon_sym_new] = ACTIONS(2175),
    [anon_sym_using] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_void] = ACTIONS(2175),
    [anon_sym_delete] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_number] = ACTIONS(2175),
    [sym_private_property_identifier] = ACTIONS(2175),
    [sym_this] = ACTIONS(2175),
    [sym_super] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2175),
    [anon_sym_static] = ACTIONS(2175),
    [anon_sym_readonly] = ACTIONS(2175),
    [anon_sym_get] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(2175),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_public] = ACTIONS(2175),
    [anon_sym_private] = ACTIONS(2175),
    [anon_sym_protected] = ACTIONS(2175),
    [anon_sym_override] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2175),
    [anon_sym_any] = ACTIONS(2175),
    [anon_sym_number] = ACTIONS(2175),
    [anon_sym_boolean] = ACTIONS(2175),
    [anon_sym_string] = ACTIONS(2175),
    [anon_sym_symbol] = ACTIONS(2175),
    [anon_sym_object] = ACTIONS(2175),
    [anon_sym_abstract] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [sym_html_comment] = ACTIONS(5),
  },
  [1352] = {
    [sym_comment] = STATE(1352),
    [ts_builtin_sym_end] = ACTIONS(3504),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_else] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1353] = {
    [sym_comment] = STATE(1353),
    [ts_builtin_sym_end] = ACTIONS(3504),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_else] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1354] = {
    [sym_comment] = STATE(1354),
    [ts_builtin_sym_end] = ACTIONS(3504),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_else] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1355] = {
    [sym_comment] = STATE(1355),
    [ts_builtin_sym_end] = ACTIONS(2235),
    [sym_identifier] = ACTIONS(2233),
    [anon_sym_export] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(2233),
    [anon_sym_namespace] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [anon_sym_typeof] = ACTIONS(2233),
    [anon_sym_import] = ACTIONS(2233),
    [anon_sym_with] = ACTIONS(2233),
    [anon_sym_var] = ACTIONS(2233),
    [anon_sym_let] = ACTIONS(2233),
    [anon_sym_const] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_if] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_for] = ACTIONS(2233),
    [anon_sym_LPAREN] = ACTIONS(2233),
    [anon_sym_await] = ACTIONS(2233),
    [anon_sym_while] = ACTIONS(2233),
    [anon_sym_do] = ACTIONS(2233),
    [anon_sym_try] = ACTIONS(2233),
    [anon_sym_break] = ACTIONS(2233),
    [anon_sym_continue] = ACTIONS(2233),
    [anon_sym_debugger] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2233),
    [anon_sym_throw] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym_yield] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2233),
    [anon_sym_LTtemplate_GT] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_class] = ACTIONS(2233),
    [anon_sym_async] = ACTIONS(2233),
    [anon_sym_function] = ACTIONS(2233),
    [anon_sym_new] = ACTIONS(2233),
    [anon_sym_using] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_void] = ACTIONS(2233),
    [anon_sym_delete] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2233),
    [sym_number] = ACTIONS(2233),
    [sym_private_property_identifier] = ACTIONS(2233),
    [sym_this] = ACTIONS(2233),
    [sym_super] = ACTIONS(2233),
    [sym_true] = ACTIONS(2233),
    [sym_false] = ACTIONS(2233),
    [sym_null] = ACTIONS(2233),
    [sym_undefined] = ACTIONS(2233),
    [anon_sym_AT] = ACTIONS(2233),
    [anon_sym_static] = ACTIONS(2233),
    [anon_sym_readonly] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2233),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_declare] = ACTIONS(2233),
    [anon_sym_public] = ACTIONS(2233),
    [anon_sym_private] = ACTIONS(2233),
    [anon_sym_protected] = ACTIONS(2233),
    [anon_sym_override] = ACTIONS(2233),
    [anon_sym_module] = ACTIONS(2233),
    [anon_sym_any] = ACTIONS(2233),
    [anon_sym_number] = ACTIONS(2233),
    [anon_sym_boolean] = ACTIONS(2233),
    [anon_sym_string] = ACTIONS(2233),
    [anon_sym_symbol] = ACTIONS(2233),
    [anon_sym_object] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2233),
    [anon_sym_interface] = ACTIONS(2233),
    [anon_sym_enum] = ACTIONS(2233),
    [sym_html_comment] = ACTIONS(5),
  },
  [1356] = {
    [sym_comment] = STATE(1356),
    [sym_identifier] = ACTIONS(3146),
    [anon_sym_export] = ACTIONS(3146),
    [anon_sym_default] = ACTIONS(3146),
    [anon_sym_type] = ACTIONS(3146),
    [anon_sym_namespace] = ACTIONS(3146),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_typeof] = ACTIONS(3146),
    [anon_sym_import] = ACTIONS(3146),
    [anon_sym_with] = ACTIONS(3146),
    [anon_sym_var] = ACTIONS(3146),
    [anon_sym_let] = ACTIONS(3146),
    [anon_sym_const] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_if] = ACTIONS(3146),
    [anon_sym_switch] = ACTIONS(3146),
    [anon_sym_for] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_await] = ACTIONS(3146),
    [anon_sym_while] = ACTIONS(3146),
    [anon_sym_do] = ACTIONS(3146),
    [anon_sym_try] = ACTIONS(3146),
    [anon_sym_break] = ACTIONS(3146),
    [anon_sym_continue] = ACTIONS(3146),
    [anon_sym_debugger] = ACTIONS(3146),
    [anon_sym_return] = ACTIONS(3146),
    [anon_sym_throw] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_case] = ACTIONS(3146),
    [anon_sym_yield] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_LTtemplate_GT] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(3146),
    [anon_sym_async] = ACTIONS(3146),
    [anon_sym_function] = ACTIONS(3146),
    [anon_sym_new] = ACTIONS(3146),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3146),
    [anon_sym_SLASH] = ACTIONS(3146),
    [anon_sym_LT] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_void] = ACTIONS(3146),
    [anon_sym_delete] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3146),
    [sym_number] = ACTIONS(3146),
    [sym_private_property_identifier] = ACTIONS(3146),
    [sym_this] = ACTIONS(3146),
    [sym_super] = ACTIONS(3146),
    [sym_true] = ACTIONS(3146),
    [sym_false] = ACTIONS(3146),
    [sym_null] = ACTIONS(3146),
    [sym_undefined] = ACTIONS(3146),
    [anon_sym_AT] = ACTIONS(3146),
    [anon_sym_static] = ACTIONS(3146),
    [anon_sym_readonly] = ACTIONS(3146),
    [anon_sym_get] = ACTIONS(3146),
    [anon_sym_set] = ACTIONS(3146),
    [anon_sym_declare] = ACTIONS(3146),
    [anon_sym_public] = ACTIONS(3146),
    [anon_sym_private] = ACTIONS(3146),
    [anon_sym_protected] = ACTIONS(3146),
    [anon_sym_override] = ACTIONS(3146),
    [anon_sym_module] = ACTIONS(3146),
    [anon_sym_any] = ACTIONS(3146),
    [anon_sym_number] = ACTIONS(3146),
    [anon_sym_boolean] = ACTIONS(3146),
    [anon_sym_string] = ACTIONS(3146),
    [anon_sym_symbol] = ACTIONS(3146),
    [anon_sym_object] = ACTIONS(3146),
    [anon_sym_abstract] = ACTIONS(3146),
    [anon_sym_interface] = ACTIONS(3146),
    [anon_sym_enum] = ACTIONS(3146),
    [sym_html_comment] = ACTIONS(5),
  },
  [1357] = {
    [sym_comment] = STATE(1357),
    [ts_builtin_sym_end] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2163),
    [anon_sym_export] = ACTIONS(2163),
    [anon_sym_type] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2163),
    [anon_sym_import] = ACTIONS(2163),
    [anon_sym_with] = ACTIONS(2163),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2163),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_debugger] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_yield] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_LTtemplate_GT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2163),
    [anon_sym_SQUOTE] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_async] = ACTIONS(2163),
    [anon_sym_function] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_SLASH] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [anon_sym_void] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_PLUS_PLUS] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2163),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2163),
    [sym_number] = ACTIONS(2163),
    [sym_private_property_identifier] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(2163),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_readonly] = ACTIONS(2163),
    [anon_sym_get] = ACTIONS(2163),
    [anon_sym_set] = ACTIONS(2163),
    [anon_sym_declare] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_override] = ACTIONS(2163),
    [anon_sym_module] = ACTIONS(2163),
    [anon_sym_any] = ACTIONS(2163),
    [anon_sym_number] = ACTIONS(2163),
    [anon_sym_boolean] = ACTIONS(2163),
    [anon_sym_string] = ACTIONS(2163),
    [anon_sym_symbol] = ACTIONS(2163),
    [anon_sym_object] = ACTIONS(2163),
    [anon_sym_abstract] = ACTIONS(2163),
    [anon_sym_interface] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [sym_html_comment] = ACTIONS(5),
  },
  [1358] = {
    [sym_comment] = STATE(1358),
    [ts_builtin_sym_end] = ACTIONS(3506),
    [sym_identifier] = ACTIONS(3232),
    [anon_sym_export] = ACTIONS(3232),
    [anon_sym_type] = ACTIONS(3232),
    [anon_sym_namespace] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [anon_sym_typeof] = ACTIONS(3232),
    [anon_sym_import] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3232),
    [anon_sym_var] = ACTIONS(3232),
    [anon_sym_let] = ACTIONS(3232),
    [anon_sym_const] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_else] = ACTIONS(3232),
    [anon_sym_if] = ACTIONS(3232),
    [anon_sym_switch] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3232),
    [anon_sym_await] = ACTIONS(3232),
    [anon_sym_while] = ACTIONS(3232),
    [anon_sym_do] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3232),
    [anon_sym_break] = ACTIONS(3232),
    [anon_sym_continue] = ACTIONS(3232),
    [anon_sym_debugger] = ACTIONS(3232),
    [anon_sym_return] = ACTIONS(3232),
    [anon_sym_throw] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3232),
    [anon_sym_LBRACK] = ACTIONS(3232),
    [anon_sym_LTtemplate_GT] = ACTIONS(3232),
    [anon_sym_DQUOTE] = ACTIONS(3232),
    [anon_sym_SQUOTE] = ACTIONS(3232),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_async] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3232),
    [anon_sym_using] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3232),
    [anon_sym_SLASH] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_void] = ACTIONS(3232),
    [anon_sym_delete] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3232),
    [sym_number] = ACTIONS(3232),
    [sym_private_property_identifier] = ACTIONS(3232),
    [sym_this] = ACTIONS(3232),
    [sym_super] = ACTIONS(3232),
    [sym_true] = ACTIONS(3232),
    [sym_false] = ACTIONS(3232),
    [sym_null] = ACTIONS(3232),
    [sym_undefined] = ACTIONS(3232),
    [anon_sym_AT] = ACTIONS(3232),
    [anon_sym_static] = ACTIONS(3232),
    [anon_sym_readonly] = ACTIONS(3232),
    [anon_sym_get] = ACTIONS(3232),
    [anon_sym_set] = ACTIONS(3232),
    [anon_sym_declare] = ACTIONS(3232),
    [anon_sym_public] = ACTIONS(3232),
    [anon_sym_private] = ACTIONS(3232),
    [anon_sym_protected] = ACTIONS(3232),
    [anon_sym_override] = ACTIONS(3232),
    [anon_sym_module] = ACTIONS(3232),
    [anon_sym_any] = ACTIONS(3232),
    [anon_sym_number] = ACTIONS(3232),
    [anon_sym_boolean] = ACTIONS(3232),
    [anon_sym_string] = ACTIONS(3232),
    [anon_sym_symbol] = ACTIONS(3232),
    [anon_sym_object] = ACTIONS(3232),
    [anon_sym_abstract] = ACTIONS(3232),
    [anon_sym_interface] = ACTIONS(3232),
    [anon_sym_enum] = ACTIONS(3232),
    [sym_html_comment] = ACTIONS(5),
  },
  [1359] = {
    [sym_comment] = STATE(1359),
    [sym_identifier] = ACTIONS(3182),
    [anon_sym_export] = ACTIONS(3182),
    [anon_sym_default] = ACTIONS(3182),
    [anon_sym_type] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_typeof] = ACTIONS(3182),
    [anon_sym_import] = ACTIONS(3182),
    [anon_sym_with] = ACTIONS(3182),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_await] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_debugger] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_LTtemplate_GT] = ACTIONS(3182),
    [anon_sym_DQUOTE] = ACTIONS(3182),
    [anon_sym_SQUOTE] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_async] = ACTIONS(3182),
    [anon_sym_function] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_SLASH] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_void] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3182),
    [sym_number] = ACTIONS(3182),
    [sym_private_property_identifier] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [sym_super] = ACTIONS(3182),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [sym_null] = ACTIONS(3182),
    [sym_undefined] = ACTIONS(3182),
    [anon_sym_AT] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_readonly] = ACTIONS(3182),
    [anon_sym_get] = ACTIONS(3182),
    [anon_sym_set] = ACTIONS(3182),
    [anon_sym_declare] = ACTIONS(3182),
    [anon_sym_public] = ACTIONS(3182),
    [anon_sym_private] = ACTIONS(3182),
    [anon_sym_protected] = ACTIONS(3182),
    [anon_sym_override] = ACTIONS(3182),
    [anon_sym_module] = ACTIONS(3182),
    [anon_sym_any] = ACTIONS(3182),
    [anon_sym_number] = ACTIONS(3182),
    [anon_sym_boolean] = ACTIONS(3182),
    [anon_sym_string] = ACTIONS(3182),
    [anon_sym_symbol] = ACTIONS(3182),
    [anon_sym_object] = ACTIONS(3182),
    [anon_sym_abstract] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [sym_html_comment] = ACTIONS(5),
  },
  [1360] = {
    [sym_comment] = STATE(1360),
    [ts_builtin_sym_end] = ACTIONS(3508),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_export] = ACTIONS(3230),
    [anon_sym_type] = ACTIONS(3230),
    [anon_sym_namespace] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_RBRACE] = ACTIONS(3230),
    [anon_sym_typeof] = ACTIONS(3230),
    [anon_sym_import] = ACTIONS(3230),
    [anon_sym_with] = ACTIONS(3230),
    [anon_sym_var] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_BANG] = ACTIONS(3230),
    [anon_sym_else] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_switch] = ACTIONS(3230),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_await] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_break] = ACTIONS(3230),
    [anon_sym_continue] = ACTIONS(3230),
    [anon_sym_debugger] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_throw] = ACTIONS(3230),
    [anon_sym_SEMI] = ACTIONS(3230),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LTtemplate_GT] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_SQUOTE] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3230),
    [anon_sym_async] = ACTIONS(3230),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_SLASH] = ACTIONS(3230),
    [anon_sym_LT] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3230),
    [anon_sym_void] = ACTIONS(3230),
    [anon_sym_delete] = ACTIONS(3230),
    [anon_sym_PLUS_PLUS] = ACTIONS(3230),
    [anon_sym_DASH_DASH] = ACTIONS(3230),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3230),
    [sym_number] = ACTIONS(3230),
    [sym_private_property_identifier] = ACTIONS(3230),
    [sym_this] = ACTIONS(3230),
    [sym_super] = ACTIONS(3230),
    [sym_true] = ACTIONS(3230),
    [sym_false] = ACTIONS(3230),
    [sym_null] = ACTIONS(3230),
    [sym_undefined] = ACTIONS(3230),
    [anon_sym_AT] = ACTIONS(3230),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_readonly] = ACTIONS(3230),
    [anon_sym_get] = ACTIONS(3230),
    [anon_sym_set] = ACTIONS(3230),
    [anon_sym_declare] = ACTIONS(3230),
    [anon_sym_public] = ACTIONS(3230),
    [anon_sym_private] = ACTIONS(3230),
    [anon_sym_protected] = ACTIONS(3230),
    [anon_sym_override] = ACTIONS(3230),
    [anon_sym_module] = ACTIONS(3230),
    [anon_sym_any] = ACTIONS(3230),
    [anon_sym_number] = ACTIONS(3230),
    [anon_sym_boolean] = ACTIONS(3230),
    [anon_sym_string] = ACTIONS(3230),
    [anon_sym_symbol] = ACTIONS(3230),
    [anon_sym_object] = ACTIONS(3230),
    [anon_sym_abstract] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3230),
    [anon_sym_enum] = ACTIONS(3230),
    [sym_html_comment] = ACTIONS(5),
  },
  [1361] = {
    [sym_comment] = STATE(1361),
    [ts_builtin_sym_end] = ACTIONS(3118),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_export] = ACTIONS(3116),
    [anon_sym_type] = ACTIONS(3116),
    [anon_sym_namespace] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_typeof] = ACTIONS(3116),
    [anon_sym_import] = ACTIONS(3116),
    [anon_sym_with] = ACTIONS(3116),
    [anon_sym_var] = ACTIONS(3116),
    [anon_sym_let] = ACTIONS(3116),
    [anon_sym_const] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3116),
    [anon_sym_if] = ACTIONS(3116),
    [anon_sym_switch] = ACTIONS(3116),
    [anon_sym_for] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3116),
    [anon_sym_await] = ACTIONS(3116),
    [anon_sym_while] = ACTIONS(3116),
    [anon_sym_do] = ACTIONS(3116),
    [anon_sym_try] = ACTIONS(3116),
    [anon_sym_break] = ACTIONS(3116),
    [anon_sym_continue] = ACTIONS(3116),
    [anon_sym_debugger] = ACTIONS(3116),
    [anon_sym_return] = ACTIONS(3116),
    [anon_sym_throw] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym_yield] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [anon_sym_LTtemplate_GT] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [anon_sym_SQUOTE] = ACTIONS(3116),
    [anon_sym_class] = ACTIONS(3116),
    [anon_sym_async] = ACTIONS(3116),
    [anon_sym_function] = ACTIONS(3116),
    [anon_sym_new] = ACTIONS(3116),
    [anon_sym_using] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3116),
    [anon_sym_SLASH] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3116),
    [anon_sym_TILDE] = ACTIONS(3116),
    [anon_sym_void] = ACTIONS(3116),
    [anon_sym_delete] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [sym_number] = ACTIONS(3116),
    [sym_private_property_identifier] = ACTIONS(3116),
    [sym_this] = ACTIONS(3116),
    [sym_super] = ACTIONS(3116),
    [sym_true] = ACTIONS(3116),
    [sym_false] = ACTIONS(3116),
    [sym_null] = ACTIONS(3116),
    [sym_undefined] = ACTIONS(3116),
    [anon_sym_AT] = ACTIONS(3116),
    [anon_sym_static] = ACTIONS(3116),
    [anon_sym_readonly] = ACTIONS(3116),
    [anon_sym_get] = ACTIONS(3116),
    [anon_sym_set] = ACTIONS(3116),
    [anon_sym_declare] = ACTIONS(3116),
    [anon_sym_public] = ACTIONS(3116),
    [anon_sym_private] = ACTIONS(3116),
    [anon_sym_protected] = ACTIONS(3116),
    [anon_sym_override] = ACTIONS(3116),
    [anon_sym_module] = ACTIONS(3116),
    [anon_sym_any] = ACTIONS(3116),
    [anon_sym_number] = ACTIONS(3116),
    [anon_sym_boolean] = ACTIONS(3116),
    [anon_sym_string] = ACTIONS(3116),
    [anon_sym_symbol] = ACTIONS(3116),
    [anon_sym_object] = ACTIONS(3116),
    [anon_sym_abstract] = ACTIONS(3116),
    [anon_sym_interface] = ACTIONS(3116),
    [anon_sym_enum] = ACTIONS(3116),
    [sym__automatic_semicolon] = ACTIONS(3118),
    [sym_html_comment] = ACTIONS(5),
  },
  [1362] = {
    [sym_comment] = STATE(1362),
    [ts_builtin_sym_end] = ACTIONS(3510),
    [sym_identifier] = ACTIONS(3268),
    [anon_sym_export] = ACTIONS(3268),
    [anon_sym_type] = ACTIONS(3268),
    [anon_sym_namespace] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3268),
    [anon_sym_typeof] = ACTIONS(3268),
    [anon_sym_import] = ACTIONS(3268),
    [anon_sym_with] = ACTIONS(3268),
    [anon_sym_var] = ACTIONS(3268),
    [anon_sym_let] = ACTIONS(3268),
    [anon_sym_const] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_else] = ACTIONS(3268),
    [anon_sym_if] = ACTIONS(3268),
    [anon_sym_switch] = ACTIONS(3268),
    [anon_sym_for] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3268),
    [anon_sym_await] = ACTIONS(3268),
    [anon_sym_while] = ACTIONS(3268),
    [anon_sym_do] = ACTIONS(3268),
    [anon_sym_try] = ACTIONS(3268),
    [anon_sym_break] = ACTIONS(3268),
    [anon_sym_continue] = ACTIONS(3268),
    [anon_sym_debugger] = ACTIONS(3268),
    [anon_sym_return] = ACTIONS(3268),
    [anon_sym_throw] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_yield] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_LTtemplate_GT] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_class] = ACTIONS(3268),
    [anon_sym_async] = ACTIONS(3268),
    [anon_sym_function] = ACTIONS(3268),
    [anon_sym_new] = ACTIONS(3268),
    [anon_sym_using] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_void] = ACTIONS(3268),
    [anon_sym_delete] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3268),
    [sym_number] = ACTIONS(3268),
    [sym_private_property_identifier] = ACTIONS(3268),
    [sym_this] = ACTIONS(3268),
    [sym_super] = ACTIONS(3268),
    [sym_true] = ACTIONS(3268),
    [sym_false] = ACTIONS(3268),
    [sym_null] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_AT] = ACTIONS(3268),
    [anon_sym_static] = ACTIONS(3268),
    [anon_sym_readonly] = ACTIONS(3268),
    [anon_sym_get] = ACTIONS(3268),
    [anon_sym_set] = ACTIONS(3268),
    [anon_sym_declare] = ACTIONS(3268),
    [anon_sym_public] = ACTIONS(3268),
    [anon_sym_private] = ACTIONS(3268),
    [anon_sym_protected] = ACTIONS(3268),
    [anon_sym_override] = ACTIONS(3268),
    [anon_sym_module] = ACTIONS(3268),
    [anon_sym_any] = ACTIONS(3268),
    [anon_sym_number] = ACTIONS(3268),
    [anon_sym_boolean] = ACTIONS(3268),
    [anon_sym_string] = ACTIONS(3268),
    [anon_sym_symbol] = ACTIONS(3268),
    [anon_sym_object] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(3268),
    [anon_sym_interface] = ACTIONS(3268),
    [anon_sym_enum] = ACTIONS(3268),
    [sym_html_comment] = ACTIONS(5),
  },
  [1363] = {
    [sym_comment] = STATE(1363),
    [ts_builtin_sym_end] = ACTIONS(2239),
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_export] = ACTIONS(2237),
    [anon_sym_type] = ACTIONS(2237),
    [anon_sym_namespace] = ACTIONS(2237),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_typeof] = ACTIONS(2237),
    [anon_sym_import] = ACTIONS(2237),
    [anon_sym_with] = ACTIONS(2237),
    [anon_sym_var] = ACTIONS(2237),
    [anon_sym_let] = ACTIONS(2237),
    [anon_sym_const] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_if] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_for] = ACTIONS(2237),
    [anon_sym_LPAREN] = ACTIONS(2237),
    [anon_sym_await] = ACTIONS(2237),
    [anon_sym_while] = ACTIONS(2237),
    [anon_sym_do] = ACTIONS(2237),
    [anon_sym_try] = ACTIONS(2237),
    [anon_sym_break] = ACTIONS(2237),
    [anon_sym_continue] = ACTIONS(2237),
    [anon_sym_debugger] = ACTIONS(2237),
    [anon_sym_return] = ACTIONS(2237),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2237),
    [anon_sym_yield] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2237),
    [anon_sym_LTtemplate_GT] = ACTIONS(2237),
    [anon_sym_DOT] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_class] = ACTIONS(2237),
    [anon_sym_async] = ACTIONS(2237),
    [anon_sym_function] = ACTIONS(2237),
    [anon_sym_new] = ACTIONS(2237),
    [anon_sym_using] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_SLASH] = ACTIONS(2237),
    [anon_sym_LT] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_void] = ACTIONS(2237),
    [anon_sym_delete] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2237),
    [sym_number] = ACTIONS(2237),
    [sym_private_property_identifier] = ACTIONS(2237),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2237),
    [anon_sym_static] = ACTIONS(2237),
    [anon_sym_readonly] = ACTIONS(2237),
    [anon_sym_get] = ACTIONS(2237),
    [anon_sym_set] = ACTIONS(2237),
    [anon_sym_declare] = ACTIONS(2237),
    [anon_sym_public] = ACTIONS(2237),
    [anon_sym_private] = ACTIONS(2237),
    [anon_sym_protected] = ACTIONS(2237),
    [anon_sym_override] = ACTIONS(2237),
    [anon_sym_module] = ACTIONS(2237),
    [anon_sym_any] = ACTIONS(2237),
    [anon_sym_number] = ACTIONS(2237),
    [anon_sym_boolean] = ACTIONS(2237),
    [anon_sym_string] = ACTIONS(2237),
    [anon_sym_symbol] = ACTIONS(2237),
    [anon_sym_object] = ACTIONS(2237),
    [anon_sym_abstract] = ACTIONS(2237),
    [anon_sym_interface] = ACTIONS(2237),
    [anon_sym_enum] = ACTIONS(2237),
    [sym_html_comment] = ACTIONS(5),
  },
  [1364] = {
    [sym_comment] = STATE(1364),
    [ts_builtin_sym_end] = ACTIONS(3510),
    [sym_identifier] = ACTIONS(3268),
    [anon_sym_export] = ACTIONS(3268),
    [anon_sym_type] = ACTIONS(3268),
    [anon_sym_namespace] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3268),
    [anon_sym_typeof] = ACTIONS(3268),
    [anon_sym_import] = ACTIONS(3268),
    [anon_sym_with] = ACTIONS(3268),
    [anon_sym_var] = ACTIONS(3268),
    [anon_sym_let] = ACTIONS(3268),
    [anon_sym_const] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_else] = ACTIONS(3268),
    [anon_sym_if] = ACTIONS(3268),
    [anon_sym_switch] = ACTIONS(3268),
    [anon_sym_for] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3268),
    [anon_sym_await] = ACTIONS(3268),
    [anon_sym_while] = ACTIONS(3268),
    [anon_sym_do] = ACTIONS(3268),
    [anon_sym_try] = ACTIONS(3268),
    [anon_sym_break] = ACTIONS(3268),
    [anon_sym_continue] = ACTIONS(3268),
    [anon_sym_debugger] = ACTIONS(3268),
    [anon_sym_return] = ACTIONS(3268),
    [anon_sym_throw] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_yield] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_LTtemplate_GT] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_class] = ACTIONS(3268),
    [anon_sym_async] = ACTIONS(3268),
    [anon_sym_function] = ACTIONS(3268),
    [anon_sym_new] = ACTIONS(3268),
    [anon_sym_using] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_void] = ACTIONS(3268),
    [anon_sym_delete] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3268),
    [sym_number] = ACTIONS(3268),
    [sym_private_property_identifier] = ACTIONS(3268),
    [sym_this] = ACTIONS(3268),
    [sym_super] = ACTIONS(3268),
    [sym_true] = ACTIONS(3268),
    [sym_false] = ACTIONS(3268),
    [sym_null] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_AT] = ACTIONS(3268),
    [anon_sym_static] = ACTIONS(3268),
    [anon_sym_readonly] = ACTIONS(3268),
    [anon_sym_get] = ACTIONS(3268),
    [anon_sym_set] = ACTIONS(3268),
    [anon_sym_declare] = ACTIONS(3268),
    [anon_sym_public] = ACTIONS(3268),
    [anon_sym_private] = ACTIONS(3268),
    [anon_sym_protected] = ACTIONS(3268),
    [anon_sym_override] = ACTIONS(3268),
    [anon_sym_module] = ACTIONS(3268),
    [anon_sym_any] = ACTIONS(3268),
    [anon_sym_number] = ACTIONS(3268),
    [anon_sym_boolean] = ACTIONS(3268),
    [anon_sym_string] = ACTIONS(3268),
    [anon_sym_symbol] = ACTIONS(3268),
    [anon_sym_object] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(3268),
    [anon_sym_interface] = ACTIONS(3268),
    [anon_sym_enum] = ACTIONS(3268),
    [sym_html_comment] = ACTIONS(5),
  },
  [1365] = {
    [sym_comment] = STATE(1365),
    [ts_builtin_sym_end] = ACTIONS(3512),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_export] = ACTIONS(3280),
    [anon_sym_type] = ACTIONS(3280),
    [anon_sym_namespace] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_RBRACE] = ACTIONS(3280),
    [anon_sym_typeof] = ACTIONS(3280),
    [anon_sym_import] = ACTIONS(3280),
    [anon_sym_with] = ACTIONS(3280),
    [anon_sym_var] = ACTIONS(3280),
    [anon_sym_let] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_BANG] = ACTIONS(3280),
    [anon_sym_else] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_switch] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_LPAREN] = ACTIONS(3280),
    [anon_sym_await] = ACTIONS(3280),
    [anon_sym_while] = ACTIONS(3280),
    [anon_sym_do] = ACTIONS(3280),
    [anon_sym_try] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_debugger] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_throw] = ACTIONS(3280),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_yield] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_LTtemplate_GT] = ACTIONS(3280),
    [anon_sym_DQUOTE] = ACTIONS(3280),
    [anon_sym_SQUOTE] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_async] = ACTIONS(3280),
    [anon_sym_function] = ACTIONS(3280),
    [anon_sym_new] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_SLASH] = ACTIONS(3280),
    [anon_sym_LT] = ACTIONS(3280),
    [anon_sym_TILDE] = ACTIONS(3280),
    [anon_sym_void] = ACTIONS(3280),
    [anon_sym_delete] = ACTIONS(3280),
    [anon_sym_PLUS_PLUS] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3280),
    [sym_number] = ACTIONS(3280),
    [sym_private_property_identifier] = ACTIONS(3280),
    [sym_this] = ACTIONS(3280),
    [sym_super] = ACTIONS(3280),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_null] = ACTIONS(3280),
    [sym_undefined] = ACTIONS(3280),
    [anon_sym_AT] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_readonly] = ACTIONS(3280),
    [anon_sym_get] = ACTIONS(3280),
    [anon_sym_set] = ACTIONS(3280),
    [anon_sym_declare] = ACTIONS(3280),
    [anon_sym_public] = ACTIONS(3280),
    [anon_sym_private] = ACTIONS(3280),
    [anon_sym_protected] = ACTIONS(3280),
    [anon_sym_override] = ACTIONS(3280),
    [anon_sym_module] = ACTIONS(3280),
    [anon_sym_any] = ACTIONS(3280),
    [anon_sym_number] = ACTIONS(3280),
    [anon_sym_boolean] = ACTIONS(3280),
    [anon_sym_string] = ACTIONS(3280),
    [anon_sym_symbol] = ACTIONS(3280),
    [anon_sym_object] = ACTIONS(3280),
    [anon_sym_abstract] = ACTIONS(3280),
    [anon_sym_interface] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [sym_html_comment] = ACTIONS(5),
  },
  [1366] = {
    [sym_comment] = STATE(1366),
    [ts_builtin_sym_end] = ACTIONS(3514),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_export] = ACTIONS(3346),
    [anon_sym_type] = ACTIONS(3346),
    [anon_sym_namespace] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_typeof] = ACTIONS(3346),
    [anon_sym_import] = ACTIONS(3346),
    [anon_sym_with] = ACTIONS(3346),
    [anon_sym_var] = ACTIONS(3346),
    [anon_sym_let] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_else] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_switch] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_await] = ACTIONS(3346),
    [anon_sym_while] = ACTIONS(3346),
    [anon_sym_do] = ACTIONS(3346),
    [anon_sym_try] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_debugger] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_throw] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_LTtemplate_GT] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_async] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_SLASH] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_void] = ACTIONS(3346),
    [anon_sym_delete] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3346),
    [sym_number] = ACTIONS(3346),
    [sym_private_property_identifier] = ACTIONS(3346),
    [sym_this] = ACTIONS(3346),
    [sym_super] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_null] = ACTIONS(3346),
    [sym_undefined] = ACTIONS(3346),
    [anon_sym_AT] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_readonly] = ACTIONS(3346),
    [anon_sym_get] = ACTIONS(3346),
    [anon_sym_set] = ACTIONS(3346),
    [anon_sym_declare] = ACTIONS(3346),
    [anon_sym_public] = ACTIONS(3346),
    [anon_sym_private] = ACTIONS(3346),
    [anon_sym_protected] = ACTIONS(3346),
    [anon_sym_override] = ACTIONS(3346),
    [anon_sym_module] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3346),
    [anon_sym_number] = ACTIONS(3346),
    [anon_sym_boolean] = ACTIONS(3346),
    [anon_sym_string] = ACTIONS(3346),
    [anon_sym_symbol] = ACTIONS(3346),
    [anon_sym_object] = ACTIONS(3346),
    [anon_sym_abstract] = ACTIONS(3346),
    [anon_sym_interface] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [sym_html_comment] = ACTIONS(5),
  },
  [1367] = {
    [sym_comment] = STATE(1367),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1368] = {
    [sym_comment] = STATE(1368),
    [ts_builtin_sym_end] = ACTIONS(3516),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_export] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_namespace] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_typeof] = ACTIONS(3300),
    [anon_sym_import] = ACTIONS(3300),
    [anon_sym_with] = ACTIONS(3300),
    [anon_sym_var] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_const] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_else] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_switch] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_await] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_debugger] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_throw] = ACTIONS(3300),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LTtemplate_GT] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_class] = ACTIONS(3300),
    [anon_sym_async] = ACTIONS(3300),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_using] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_SLASH] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_void] = ACTIONS(3300),
    [anon_sym_delete] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3300),
    [sym_number] = ACTIONS(3300),
    [sym_private_property_identifier] = ACTIONS(3300),
    [sym_this] = ACTIONS(3300),
    [sym_super] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_null] = ACTIONS(3300),
    [sym_undefined] = ACTIONS(3300),
    [anon_sym_AT] = ACTIONS(3300),
    [anon_sym_static] = ACTIONS(3300),
    [anon_sym_readonly] = ACTIONS(3300),
    [anon_sym_get] = ACTIONS(3300),
    [anon_sym_set] = ACTIONS(3300),
    [anon_sym_declare] = ACTIONS(3300),
    [anon_sym_public] = ACTIONS(3300),
    [anon_sym_private] = ACTIONS(3300),
    [anon_sym_protected] = ACTIONS(3300),
    [anon_sym_override] = ACTIONS(3300),
    [anon_sym_module] = ACTIONS(3300),
    [anon_sym_any] = ACTIONS(3300),
    [anon_sym_number] = ACTIONS(3300),
    [anon_sym_boolean] = ACTIONS(3300),
    [anon_sym_string] = ACTIONS(3300),
    [anon_sym_symbol] = ACTIONS(3300),
    [anon_sym_object] = ACTIONS(3300),
    [anon_sym_abstract] = ACTIONS(3300),
    [anon_sym_interface] = ACTIONS(3300),
    [anon_sym_enum] = ACTIONS(3300),
    [sym_html_comment] = ACTIONS(5),
  },
  [1369] = {
    [sym_comment] = STATE(1369),
    [sym_identifier] = ACTIONS(3196),
    [anon_sym_export] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_type] = ACTIONS(3196),
    [anon_sym_namespace] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3196),
    [anon_sym_RBRACE] = ACTIONS(3196),
    [anon_sym_typeof] = ACTIONS(3196),
    [anon_sym_import] = ACTIONS(3196),
    [anon_sym_with] = ACTIONS(3196),
    [anon_sym_var] = ACTIONS(3196),
    [anon_sym_let] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3196),
    [anon_sym_await] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_debugger] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_throw] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3196),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_LTtemplate_GT] = ACTIONS(3196),
    [anon_sym_DQUOTE] = ACTIONS(3196),
    [anon_sym_SQUOTE] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_async] = ACTIONS(3196),
    [anon_sym_function] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_using] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_SLASH] = ACTIONS(3196),
    [anon_sym_LT] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [anon_sym_void] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_PLUS_PLUS] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3196),
    [sym_number] = ACTIONS(3196),
    [sym_private_property_identifier] = ACTIONS(3196),
    [sym_this] = ACTIONS(3196),
    [sym_super] = ACTIONS(3196),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [sym_null] = ACTIONS(3196),
    [sym_undefined] = ACTIONS(3196),
    [anon_sym_AT] = ACTIONS(3196),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_readonly] = ACTIONS(3196),
    [anon_sym_get] = ACTIONS(3196),
    [anon_sym_set] = ACTIONS(3196),
    [anon_sym_declare] = ACTIONS(3196),
    [anon_sym_public] = ACTIONS(3196),
    [anon_sym_private] = ACTIONS(3196),
    [anon_sym_protected] = ACTIONS(3196),
    [anon_sym_override] = ACTIONS(3196),
    [anon_sym_module] = ACTIONS(3196),
    [anon_sym_any] = ACTIONS(3196),
    [anon_sym_number] = ACTIONS(3196),
    [anon_sym_boolean] = ACTIONS(3196),
    [anon_sym_string] = ACTIONS(3196),
    [anon_sym_symbol] = ACTIONS(3196),
    [anon_sym_object] = ACTIONS(3196),
    [anon_sym_abstract] = ACTIONS(3196),
    [anon_sym_interface] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [sym_html_comment] = ACTIONS(5),
  },
  [1370] = {
    [sym_comment] = STATE(1370),
    [sym_identifier] = ACTIONS(3334),
    [anon_sym_export] = ACTIONS(3334),
    [anon_sym_default] = ACTIONS(3334),
    [anon_sym_type] = ACTIONS(3334),
    [anon_sym_namespace] = ACTIONS(3334),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_typeof] = ACTIONS(3334),
    [anon_sym_import] = ACTIONS(3334),
    [anon_sym_with] = ACTIONS(3334),
    [anon_sym_var] = ACTIONS(3334),
    [anon_sym_let] = ACTIONS(3334),
    [anon_sym_const] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_if] = ACTIONS(3334),
    [anon_sym_switch] = ACTIONS(3334),
    [anon_sym_for] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3334),
    [anon_sym_await] = ACTIONS(3334),
    [anon_sym_while] = ACTIONS(3334),
    [anon_sym_do] = ACTIONS(3334),
    [anon_sym_try] = ACTIONS(3334),
    [anon_sym_break] = ACTIONS(3334),
    [anon_sym_continue] = ACTIONS(3334),
    [anon_sym_debugger] = ACTIONS(3334),
    [anon_sym_return] = ACTIONS(3334),
    [anon_sym_throw] = ACTIONS(3334),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym_case] = ACTIONS(3334),
    [anon_sym_yield] = ACTIONS(3334),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LTtemplate_GT] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_class] = ACTIONS(3334),
    [anon_sym_async] = ACTIONS(3334),
    [anon_sym_function] = ACTIONS(3334),
    [anon_sym_new] = ACTIONS(3334),
    [anon_sym_using] = ACTIONS(3334),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3334),
    [anon_sym_SLASH] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_void] = ACTIONS(3334),
    [anon_sym_delete] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3334),
    [sym_number] = ACTIONS(3334),
    [sym_private_property_identifier] = ACTIONS(3334),
    [sym_this] = ACTIONS(3334),
    [sym_super] = ACTIONS(3334),
    [sym_true] = ACTIONS(3334),
    [sym_false] = ACTIONS(3334),
    [sym_null] = ACTIONS(3334),
    [sym_undefined] = ACTIONS(3334),
    [anon_sym_AT] = ACTIONS(3334),
    [anon_sym_static] = ACTIONS(3334),
    [anon_sym_readonly] = ACTIONS(3334),
    [anon_sym_get] = ACTIONS(3334),
    [anon_sym_set] = ACTIONS(3334),
    [anon_sym_declare] = ACTIONS(3334),
    [anon_sym_public] = ACTIONS(3334),
    [anon_sym_private] = ACTIONS(3334),
    [anon_sym_protected] = ACTIONS(3334),
    [anon_sym_override] = ACTIONS(3334),
    [anon_sym_module] = ACTIONS(3334),
    [anon_sym_any] = ACTIONS(3334),
    [anon_sym_number] = ACTIONS(3334),
    [anon_sym_boolean] = ACTIONS(3334),
    [anon_sym_string] = ACTIONS(3334),
    [anon_sym_symbol] = ACTIONS(3334),
    [anon_sym_object] = ACTIONS(3334),
    [anon_sym_abstract] = ACTIONS(3334),
    [anon_sym_interface] = ACTIONS(3334),
    [anon_sym_enum] = ACTIONS(3334),
    [sym_html_comment] = ACTIONS(5),
  },
  [1371] = {
    [sym_comment] = STATE(1371),
    [sym_identifier] = ACTIONS(3334),
    [anon_sym_export] = ACTIONS(3334),
    [anon_sym_default] = ACTIONS(3334),
    [anon_sym_type] = ACTIONS(3334),
    [anon_sym_namespace] = ACTIONS(3334),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_typeof] = ACTIONS(3334),
    [anon_sym_import] = ACTIONS(3334),
    [anon_sym_with] = ACTIONS(3334),
    [anon_sym_var] = ACTIONS(3334),
    [anon_sym_let] = ACTIONS(3334),
    [anon_sym_const] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_if] = ACTIONS(3334),
    [anon_sym_switch] = ACTIONS(3334),
    [anon_sym_for] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3334),
    [anon_sym_await] = ACTIONS(3334),
    [anon_sym_while] = ACTIONS(3334),
    [anon_sym_do] = ACTIONS(3334),
    [anon_sym_try] = ACTIONS(3334),
    [anon_sym_break] = ACTIONS(3334),
    [anon_sym_continue] = ACTIONS(3334),
    [anon_sym_debugger] = ACTIONS(3334),
    [anon_sym_return] = ACTIONS(3334),
    [anon_sym_throw] = ACTIONS(3334),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym_case] = ACTIONS(3334),
    [anon_sym_yield] = ACTIONS(3334),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LTtemplate_GT] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_class] = ACTIONS(3334),
    [anon_sym_async] = ACTIONS(3334),
    [anon_sym_function] = ACTIONS(3334),
    [anon_sym_new] = ACTIONS(3334),
    [anon_sym_using] = ACTIONS(3334),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3334),
    [anon_sym_SLASH] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_void] = ACTIONS(3334),
    [anon_sym_delete] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3334),
    [sym_number] = ACTIONS(3334),
    [sym_private_property_identifier] = ACTIONS(3334),
    [sym_this] = ACTIONS(3334),
    [sym_super] = ACTIONS(3334),
    [sym_true] = ACTIONS(3334),
    [sym_false] = ACTIONS(3334),
    [sym_null] = ACTIONS(3334),
    [sym_undefined] = ACTIONS(3334),
    [anon_sym_AT] = ACTIONS(3334),
    [anon_sym_static] = ACTIONS(3334),
    [anon_sym_readonly] = ACTIONS(3334),
    [anon_sym_get] = ACTIONS(3334),
    [anon_sym_set] = ACTIONS(3334),
    [anon_sym_declare] = ACTIONS(3334),
    [anon_sym_public] = ACTIONS(3334),
    [anon_sym_private] = ACTIONS(3334),
    [anon_sym_protected] = ACTIONS(3334),
    [anon_sym_override] = ACTIONS(3334),
    [anon_sym_module] = ACTIONS(3334),
    [anon_sym_any] = ACTIONS(3334),
    [anon_sym_number] = ACTIONS(3334),
    [anon_sym_boolean] = ACTIONS(3334),
    [anon_sym_string] = ACTIONS(3334),
    [anon_sym_symbol] = ACTIONS(3334),
    [anon_sym_object] = ACTIONS(3334),
    [anon_sym_abstract] = ACTIONS(3334),
    [anon_sym_interface] = ACTIONS(3334),
    [anon_sym_enum] = ACTIONS(3334),
    [sym_html_comment] = ACTIONS(5),
  },
  [1372] = {
    [sym_comment] = STATE(1372),
    [ts_builtin_sym_end] = ACTIONS(3518),
    [sym_identifier] = ACTIONS(3228),
    [anon_sym_export] = ACTIONS(3228),
    [anon_sym_type] = ACTIONS(3228),
    [anon_sym_namespace] = ACTIONS(3228),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_typeof] = ACTIONS(3228),
    [anon_sym_import] = ACTIONS(3228),
    [anon_sym_with] = ACTIONS(3228),
    [anon_sym_var] = ACTIONS(3228),
    [anon_sym_let] = ACTIONS(3228),
    [anon_sym_const] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_else] = ACTIONS(3228),
    [anon_sym_if] = ACTIONS(3228),
    [anon_sym_switch] = ACTIONS(3228),
    [anon_sym_for] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3228),
    [anon_sym_await] = ACTIONS(3228),
    [anon_sym_while] = ACTIONS(3228),
    [anon_sym_do] = ACTIONS(3228),
    [anon_sym_try] = ACTIONS(3228),
    [anon_sym_break] = ACTIONS(3228),
    [anon_sym_continue] = ACTIONS(3228),
    [anon_sym_debugger] = ACTIONS(3228),
    [anon_sym_return] = ACTIONS(3228),
    [anon_sym_throw] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_yield] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_LTtemplate_GT] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3228),
    [anon_sym_SQUOTE] = ACTIONS(3228),
    [anon_sym_class] = ACTIONS(3228),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_function] = ACTIONS(3228),
    [anon_sym_new] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3228),
    [anon_sym_SLASH] = ACTIONS(3228),
    [anon_sym_LT] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3228),
    [anon_sym_void] = ACTIONS(3228),
    [anon_sym_delete] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3228),
    [sym_number] = ACTIONS(3228),
    [sym_private_property_identifier] = ACTIONS(3228),
    [sym_this] = ACTIONS(3228),
    [sym_super] = ACTIONS(3228),
    [sym_true] = ACTIONS(3228),
    [sym_false] = ACTIONS(3228),
    [sym_null] = ACTIONS(3228),
    [sym_undefined] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(3228),
    [anon_sym_readonly] = ACTIONS(3228),
    [anon_sym_get] = ACTIONS(3228),
    [anon_sym_set] = ACTIONS(3228),
    [anon_sym_declare] = ACTIONS(3228),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_override] = ACTIONS(3228),
    [anon_sym_module] = ACTIONS(3228),
    [anon_sym_any] = ACTIONS(3228),
    [anon_sym_number] = ACTIONS(3228),
    [anon_sym_boolean] = ACTIONS(3228),
    [anon_sym_string] = ACTIONS(3228),
    [anon_sym_symbol] = ACTIONS(3228),
    [anon_sym_object] = ACTIONS(3228),
    [anon_sym_abstract] = ACTIONS(3228),
    [anon_sym_interface] = ACTIONS(3228),
    [anon_sym_enum] = ACTIONS(3228),
    [sym_html_comment] = ACTIONS(5),
  },
  [1373] = {
    [sym_comment] = STATE(1373),
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_export] = ACTIONS(3176),
    [anon_sym_default] = ACTIONS(3176),
    [anon_sym_type] = ACTIONS(3176),
    [anon_sym_namespace] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3176),
    [anon_sym_RBRACE] = ACTIONS(3176),
    [anon_sym_typeof] = ACTIONS(3176),
    [anon_sym_import] = ACTIONS(3176),
    [anon_sym_with] = ACTIONS(3176),
    [anon_sym_var] = ACTIONS(3176),
    [anon_sym_let] = ACTIONS(3176),
    [anon_sym_const] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_if] = ACTIONS(3176),
    [anon_sym_switch] = ACTIONS(3176),
    [anon_sym_for] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(3176),
    [anon_sym_await] = ACTIONS(3176),
    [anon_sym_while] = ACTIONS(3176),
    [anon_sym_do] = ACTIONS(3176),
    [anon_sym_try] = ACTIONS(3176),
    [anon_sym_break] = ACTIONS(3176),
    [anon_sym_continue] = ACTIONS(3176),
    [anon_sym_debugger] = ACTIONS(3176),
    [anon_sym_return] = ACTIONS(3176),
    [anon_sym_throw] = ACTIONS(3176),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym_case] = ACTIONS(3176),
    [anon_sym_yield] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_LTtemplate_GT] = ACTIONS(3176),
    [anon_sym_DQUOTE] = ACTIONS(3176),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym_class] = ACTIONS(3176),
    [anon_sym_async] = ACTIONS(3176),
    [anon_sym_function] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3176),
    [anon_sym_using] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_SLASH] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3176),
    [anon_sym_TILDE] = ACTIONS(3176),
    [anon_sym_void] = ACTIONS(3176),
    [anon_sym_delete] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3176),
    [sym_number] = ACTIONS(3176),
    [sym_private_property_identifier] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_super] = ACTIONS(3176),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [sym_null] = ACTIONS(3176),
    [sym_undefined] = ACTIONS(3176),
    [anon_sym_AT] = ACTIONS(3176),
    [anon_sym_static] = ACTIONS(3176),
    [anon_sym_readonly] = ACTIONS(3176),
    [anon_sym_get] = ACTIONS(3176),
    [anon_sym_set] = ACTIONS(3176),
    [anon_sym_declare] = ACTIONS(3176),
    [anon_sym_public] = ACTIONS(3176),
    [anon_sym_private] = ACTIONS(3176),
    [anon_sym_protected] = ACTIONS(3176),
    [anon_sym_override] = ACTIONS(3176),
    [anon_sym_module] = ACTIONS(3176),
    [anon_sym_any] = ACTIONS(3176),
    [anon_sym_number] = ACTIONS(3176),
    [anon_sym_boolean] = ACTIONS(3176),
    [anon_sym_string] = ACTIONS(3176),
    [anon_sym_symbol] = ACTIONS(3176),
    [anon_sym_object] = ACTIONS(3176),
    [anon_sym_abstract] = ACTIONS(3176),
    [anon_sym_interface] = ACTIONS(3176),
    [anon_sym_enum] = ACTIONS(3176),
    [sym_html_comment] = ACTIONS(5),
  },
  [1374] = {
    [sym_comment] = STATE(1374),
    [ts_builtin_sym_end] = ACTIONS(2373),
    [sym_identifier] = ACTIONS(2167),
    [anon_sym_export] = ACTIONS(2167),
    [anon_sym_type] = ACTIONS(2167),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2167),
    [anon_sym_with] = ACTIONS(2167),
    [anon_sym_var] = ACTIONS(2167),
    [anon_sym_let] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_BANG] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_debugger] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_yield] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LTtemplate_GT] = ACTIONS(2167),
    [anon_sym_DQUOTE] = ACTIONS(2167),
    [anon_sym_SQUOTE] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_async] = ACTIONS(2167),
    [anon_sym_function] = ACTIONS(2167),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_LT] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2167),
    [anon_sym_void] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [sym_number] = ACTIONS(2167),
    [sym_private_property_identifier] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [sym_super] = ACTIONS(2167),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_undefined] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_readonly] = ACTIONS(2167),
    [anon_sym_get] = ACTIONS(2167),
    [anon_sym_set] = ACTIONS(2167),
    [anon_sym_declare] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_override] = ACTIONS(2167),
    [anon_sym_module] = ACTIONS(2167),
    [anon_sym_any] = ACTIONS(2167),
    [anon_sym_number] = ACTIONS(2167),
    [anon_sym_boolean] = ACTIONS(2167),
    [anon_sym_string] = ACTIONS(2167),
    [anon_sym_symbol] = ACTIONS(2167),
    [anon_sym_object] = ACTIONS(2167),
    [anon_sym_abstract] = ACTIONS(2167),
    [anon_sym_interface] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [sym__automatic_semicolon] = ACTIONS(2425),
    [sym_html_comment] = ACTIONS(5),
  },
  [1375] = {
    [sym_comment] = STATE(1375),
    [sym_identifier] = ACTIONS(3298),
    [anon_sym_export] = ACTIONS(3298),
    [anon_sym_default] = ACTIONS(3298),
    [anon_sym_type] = ACTIONS(3298),
    [anon_sym_namespace] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3298),
    [anon_sym_RBRACE] = ACTIONS(3298),
    [anon_sym_typeof] = ACTIONS(3298),
    [anon_sym_import] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3298),
    [anon_sym_var] = ACTIONS(3298),
    [anon_sym_let] = ACTIONS(3298),
    [anon_sym_const] = ACTIONS(3298),
    [anon_sym_BANG] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(3298),
    [anon_sym_switch] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3298),
    [anon_sym_await] = ACTIONS(3298),
    [anon_sym_while] = ACTIONS(3298),
    [anon_sym_do] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3298),
    [anon_sym_break] = ACTIONS(3298),
    [anon_sym_continue] = ACTIONS(3298),
    [anon_sym_debugger] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3298),
    [anon_sym_throw] = ACTIONS(3298),
    [anon_sym_SEMI] = ACTIONS(3298),
    [anon_sym_case] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3298),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LTtemplate_GT] = ACTIONS(3298),
    [anon_sym_DQUOTE] = ACTIONS(3298),
    [anon_sym_SQUOTE] = ACTIONS(3298),
    [anon_sym_class] = ACTIONS(3298),
    [anon_sym_async] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3298),
    [anon_sym_using] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3298),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_SLASH] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3298),
    [anon_sym_void] = ACTIONS(3298),
    [anon_sym_delete] = ACTIONS(3298),
    [anon_sym_PLUS_PLUS] = ACTIONS(3298),
    [anon_sym_DASH_DASH] = ACTIONS(3298),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3298),
    [sym_number] = ACTIONS(3298),
    [sym_private_property_identifier] = ACTIONS(3298),
    [sym_this] = ACTIONS(3298),
    [sym_super] = ACTIONS(3298),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [sym_null] = ACTIONS(3298),
    [sym_undefined] = ACTIONS(3298),
    [anon_sym_AT] = ACTIONS(3298),
    [anon_sym_static] = ACTIONS(3298),
    [anon_sym_readonly] = ACTIONS(3298),
    [anon_sym_get] = ACTIONS(3298),
    [anon_sym_set] = ACTIONS(3298),
    [anon_sym_declare] = ACTIONS(3298),
    [anon_sym_public] = ACTIONS(3298),
    [anon_sym_private] = ACTIONS(3298),
    [anon_sym_protected] = ACTIONS(3298),
    [anon_sym_override] = ACTIONS(3298),
    [anon_sym_module] = ACTIONS(3298),
    [anon_sym_any] = ACTIONS(3298),
    [anon_sym_number] = ACTIONS(3298),
    [anon_sym_boolean] = ACTIONS(3298),
    [anon_sym_string] = ACTIONS(3298),
    [anon_sym_symbol] = ACTIONS(3298),
    [anon_sym_object] = ACTIONS(3298),
    [anon_sym_abstract] = ACTIONS(3298),
    [anon_sym_interface] = ACTIONS(3298),
    [anon_sym_enum] = ACTIONS(3298),
    [sym_html_comment] = ACTIONS(5),
  },
  [1376] = {
    [sym_comment] = STATE(1376),
    [ts_builtin_sym_end] = ACTIONS(2381),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2205),
    [anon_sym_type] = ACTIONS(2205),
    [anon_sym_namespace] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_typeof] = ACTIONS(2205),
    [anon_sym_import] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2205),
    [anon_sym_var] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_await] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(2205),
    [anon_sym_do] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2205),
    [anon_sym_break] = ACTIONS(2205),
    [anon_sym_continue] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2205),
    [anon_sym_return] = ACTIONS(2205),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_yield] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_LTtemplate_GT] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_class] = ACTIONS(2205),
    [anon_sym_async] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2205),
    [anon_sym_new] = ACTIONS(2205),
    [anon_sym_using] = ACTIONS(2205),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_void] = ACTIONS(2205),
    [anon_sym_delete] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_number] = ACTIONS(2205),
    [sym_private_property_identifier] = ACTIONS(2205),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(2205),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2205),
    [anon_sym_static] = ACTIONS(2205),
    [anon_sym_readonly] = ACTIONS(2205),
    [anon_sym_get] = ACTIONS(2205),
    [anon_sym_set] = ACTIONS(2205),
    [anon_sym_declare] = ACTIONS(2205),
    [anon_sym_public] = ACTIONS(2205),
    [anon_sym_private] = ACTIONS(2205),
    [anon_sym_protected] = ACTIONS(2205),
    [anon_sym_override] = ACTIONS(2205),
    [anon_sym_module] = ACTIONS(2205),
    [anon_sym_any] = ACTIONS(2205),
    [anon_sym_number] = ACTIONS(2205),
    [anon_sym_boolean] = ACTIONS(2205),
    [anon_sym_string] = ACTIONS(2205),
    [anon_sym_symbol] = ACTIONS(2205),
    [anon_sym_object] = ACTIONS(2205),
    [anon_sym_abstract] = ACTIONS(2205),
    [anon_sym_interface] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2205),
    [sym__automatic_semicolon] = ACTIONS(2401),
    [sym_html_comment] = ACTIONS(5),
  },
  [1377] = {
    [sym_comment] = STATE(1377),
    [sym_identifier] = ACTIONS(3302),
    [anon_sym_export] = ACTIONS(3302),
    [anon_sym_default] = ACTIONS(3302),
    [anon_sym_type] = ACTIONS(3302),
    [anon_sym_namespace] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3302),
    [anon_sym_RBRACE] = ACTIONS(3302),
    [anon_sym_typeof] = ACTIONS(3302),
    [anon_sym_import] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3302),
    [anon_sym_var] = ACTIONS(3302),
    [anon_sym_let] = ACTIONS(3302),
    [anon_sym_const] = ACTIONS(3302),
    [anon_sym_BANG] = ACTIONS(3302),
    [anon_sym_if] = ACTIONS(3302),
    [anon_sym_switch] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3302),
    [anon_sym_await] = ACTIONS(3302),
    [anon_sym_while] = ACTIONS(3302),
    [anon_sym_do] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3302),
    [anon_sym_break] = ACTIONS(3302),
    [anon_sym_continue] = ACTIONS(3302),
    [anon_sym_debugger] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3302),
    [anon_sym_throw] = ACTIONS(3302),
    [anon_sym_SEMI] = ACTIONS(3302),
    [anon_sym_case] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_LTtemplate_GT] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(3302),
    [anon_sym_SQUOTE] = ACTIONS(3302),
    [anon_sym_class] = ACTIONS(3302),
    [anon_sym_async] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3302),
    [anon_sym_using] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_TILDE] = ACTIONS(3302),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_delete] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3302),
    [sym_number] = ACTIONS(3302),
    [sym_private_property_identifier] = ACTIONS(3302),
    [sym_this] = ACTIONS(3302),
    [sym_super] = ACTIONS(3302),
    [sym_true] = ACTIONS(3302),
    [sym_false] = ACTIONS(3302),
    [sym_null] = ACTIONS(3302),
    [sym_undefined] = ACTIONS(3302),
    [anon_sym_AT] = ACTIONS(3302),
    [anon_sym_static] = ACTIONS(3302),
    [anon_sym_readonly] = ACTIONS(3302),
    [anon_sym_get] = ACTIONS(3302),
    [anon_sym_set] = ACTIONS(3302),
    [anon_sym_declare] = ACTIONS(3302),
    [anon_sym_public] = ACTIONS(3302),
    [anon_sym_private] = ACTIONS(3302),
    [anon_sym_protected] = ACTIONS(3302),
    [anon_sym_override] = ACTIONS(3302),
    [anon_sym_module] = ACTIONS(3302),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_object] = ACTIONS(3302),
    [anon_sym_abstract] = ACTIONS(3302),
    [anon_sym_interface] = ACTIONS(3302),
    [anon_sym_enum] = ACTIONS(3302),
    [sym_html_comment] = ACTIONS(5),
  },
  [1378] = {
    [sym_comment] = STATE(1378),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym__automatic_semicolon] = ACTIONS(3520),
    [sym_html_comment] = ACTIONS(5),
  },
  [1379] = {
    [sym_comment] = STATE(1379),
    [sym_identifier] = ACTIONS(3260),
    [anon_sym_export] = ACTIONS(3260),
    [anon_sym_default] = ACTIONS(3260),
    [anon_sym_type] = ACTIONS(3260),
    [anon_sym_namespace] = ACTIONS(3260),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_RBRACE] = ACTIONS(3260),
    [anon_sym_typeof] = ACTIONS(3260),
    [anon_sym_import] = ACTIONS(3260),
    [anon_sym_with] = ACTIONS(3260),
    [anon_sym_var] = ACTIONS(3260),
    [anon_sym_let] = ACTIONS(3260),
    [anon_sym_const] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_if] = ACTIONS(3260),
    [anon_sym_switch] = ACTIONS(3260),
    [anon_sym_for] = ACTIONS(3260),
    [anon_sym_LPAREN] = ACTIONS(3260),
    [anon_sym_await] = ACTIONS(3260),
    [anon_sym_while] = ACTIONS(3260),
    [anon_sym_do] = ACTIONS(3260),
    [anon_sym_try] = ACTIONS(3260),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_continue] = ACTIONS(3260),
    [anon_sym_debugger] = ACTIONS(3260),
    [anon_sym_return] = ACTIONS(3260),
    [anon_sym_throw] = ACTIONS(3260),
    [anon_sym_SEMI] = ACTIONS(3260),
    [anon_sym_case] = ACTIONS(3260),
    [anon_sym_yield] = ACTIONS(3260),
    [anon_sym_LBRACK] = ACTIONS(3260),
    [anon_sym_LTtemplate_GT] = ACTIONS(3260),
    [anon_sym_DQUOTE] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3260),
    [anon_sym_class] = ACTIONS(3260),
    [anon_sym_async] = ACTIONS(3260),
    [anon_sym_function] = ACTIONS(3260),
    [anon_sym_new] = ACTIONS(3260),
    [anon_sym_using] = ACTIONS(3260),
    [anon_sym_PLUS] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3260),
    [anon_sym_SLASH] = ACTIONS(3260),
    [anon_sym_LT] = ACTIONS(3260),
    [anon_sym_TILDE] = ACTIONS(3260),
    [anon_sym_void] = ACTIONS(3260),
    [anon_sym_delete] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3260),
    [anon_sym_DASH_DASH] = ACTIONS(3260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3260),
    [sym_number] = ACTIONS(3260),
    [sym_private_property_identifier] = ACTIONS(3260),
    [sym_this] = ACTIONS(3260),
    [sym_super] = ACTIONS(3260),
    [sym_true] = ACTIONS(3260),
    [sym_false] = ACTIONS(3260),
    [sym_null] = ACTIONS(3260),
    [sym_undefined] = ACTIONS(3260),
    [anon_sym_AT] = ACTIONS(3260),
    [anon_sym_static] = ACTIONS(3260),
    [anon_sym_readonly] = ACTIONS(3260),
    [anon_sym_get] = ACTIONS(3260),
    [anon_sym_set] = ACTIONS(3260),
    [anon_sym_declare] = ACTIONS(3260),
    [anon_sym_public] = ACTIONS(3260),
    [anon_sym_private] = ACTIONS(3260),
    [anon_sym_protected] = ACTIONS(3260),
    [anon_sym_override] = ACTIONS(3260),
    [anon_sym_module] = ACTIONS(3260),
    [anon_sym_any] = ACTIONS(3260),
    [anon_sym_number] = ACTIONS(3260),
    [anon_sym_boolean] = ACTIONS(3260),
    [anon_sym_string] = ACTIONS(3260),
    [anon_sym_symbol] = ACTIONS(3260),
    [anon_sym_object] = ACTIONS(3260),
    [anon_sym_abstract] = ACTIONS(3260),
    [anon_sym_interface] = ACTIONS(3260),
    [anon_sym_enum] = ACTIONS(3260),
    [sym_html_comment] = ACTIONS(5),
  },
  [1380] = {
    [sym_comment] = STATE(1380),
    [ts_builtin_sym_end] = ACTIONS(2357),
    [sym_identifier] = ACTIONS(2255),
    [anon_sym_export] = ACTIONS(2255),
    [anon_sym_type] = ACTIONS(2255),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2255),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_typeof] = ACTIONS(2255),
    [anon_sym_import] = ACTIONS(2255),
    [anon_sym_with] = ACTIONS(2255),
    [anon_sym_var] = ACTIONS(2255),
    [anon_sym_let] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_BANG] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_await] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_debugger] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2255),
    [anon_sym_yield] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_LTtemplate_GT] = ACTIONS(2255),
    [anon_sym_DQUOTE] = ACTIONS(2255),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_async] = ACTIONS(2255),
    [anon_sym_function] = ACTIONS(2255),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_SLASH] = ACTIONS(2255),
    [anon_sym_LT] = ACTIONS(2255),
    [anon_sym_TILDE] = ACTIONS(2255),
    [anon_sym_void] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_PLUS_PLUS] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2255),
    [sym_number] = ACTIONS(2255),
    [sym_private_property_identifier] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [sym_super] = ACTIONS(2255),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [sym_null] = ACTIONS(2255),
    [sym_undefined] = ACTIONS(2255),
    [anon_sym_AT] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_readonly] = ACTIONS(2255),
    [anon_sym_get] = ACTIONS(2255),
    [anon_sym_set] = ACTIONS(2255),
    [anon_sym_declare] = ACTIONS(2255),
    [anon_sym_public] = ACTIONS(2255),
    [anon_sym_private] = ACTIONS(2255),
    [anon_sym_protected] = ACTIONS(2255),
    [anon_sym_override] = ACTIONS(2255),
    [anon_sym_module] = ACTIONS(2255),
    [anon_sym_any] = ACTIONS(2255),
    [anon_sym_number] = ACTIONS(2255),
    [anon_sym_boolean] = ACTIONS(2255),
    [anon_sym_string] = ACTIONS(2255),
    [anon_sym_symbol] = ACTIONS(2255),
    [anon_sym_object] = ACTIONS(2255),
    [anon_sym_abstract] = ACTIONS(2255),
    [anon_sym_interface] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [sym__automatic_semicolon] = ACTIONS(2437),
    [sym_html_comment] = ACTIONS(5),
  },
  [1381] = {
    [sym_comment] = STATE(1381),
    [sym_identifier] = ACTIONS(3238),
    [anon_sym_export] = ACTIONS(3238),
    [anon_sym_default] = ACTIONS(3238),
    [anon_sym_type] = ACTIONS(3238),
    [anon_sym_namespace] = ACTIONS(3238),
    [anon_sym_LBRACE] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_typeof] = ACTIONS(3238),
    [anon_sym_import] = ACTIONS(3238),
    [anon_sym_with] = ACTIONS(3238),
    [anon_sym_var] = ACTIONS(3238),
    [anon_sym_let] = ACTIONS(3238),
    [anon_sym_const] = ACTIONS(3238),
    [anon_sym_BANG] = ACTIONS(3238),
    [anon_sym_if] = ACTIONS(3238),
    [anon_sym_switch] = ACTIONS(3238),
    [anon_sym_for] = ACTIONS(3238),
    [anon_sym_LPAREN] = ACTIONS(3238),
    [anon_sym_await] = ACTIONS(3238),
    [anon_sym_while] = ACTIONS(3238),
    [anon_sym_do] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(3238),
    [anon_sym_break] = ACTIONS(3238),
    [anon_sym_continue] = ACTIONS(3238),
    [anon_sym_debugger] = ACTIONS(3238),
    [anon_sym_return] = ACTIONS(3238),
    [anon_sym_throw] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym_case] = ACTIONS(3238),
    [anon_sym_yield] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_LTtemplate_GT] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [anon_sym_class] = ACTIONS(3238),
    [anon_sym_async] = ACTIONS(3238),
    [anon_sym_function] = ACTIONS(3238),
    [anon_sym_new] = ACTIONS(3238),
    [anon_sym_using] = ACTIONS(3238),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3238),
    [anon_sym_TILDE] = ACTIONS(3238),
    [anon_sym_void] = ACTIONS(3238),
    [anon_sym_delete] = ACTIONS(3238),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [sym_number] = ACTIONS(3238),
    [sym_private_property_identifier] = ACTIONS(3238),
    [sym_this] = ACTIONS(3238),
    [sym_super] = ACTIONS(3238),
    [sym_true] = ACTIONS(3238),
    [sym_false] = ACTIONS(3238),
    [sym_null] = ACTIONS(3238),
    [sym_undefined] = ACTIONS(3238),
    [anon_sym_AT] = ACTIONS(3238),
    [anon_sym_static] = ACTIONS(3238),
    [anon_sym_readonly] = ACTIONS(3238),
    [anon_sym_get] = ACTIONS(3238),
    [anon_sym_set] = ACTIONS(3238),
    [anon_sym_declare] = ACTIONS(3238),
    [anon_sym_public] = ACTIONS(3238),
    [anon_sym_private] = ACTIONS(3238),
    [anon_sym_protected] = ACTIONS(3238),
    [anon_sym_override] = ACTIONS(3238),
    [anon_sym_module] = ACTIONS(3238),
    [anon_sym_any] = ACTIONS(3238),
    [anon_sym_number] = ACTIONS(3238),
    [anon_sym_boolean] = ACTIONS(3238),
    [anon_sym_string] = ACTIONS(3238),
    [anon_sym_symbol] = ACTIONS(3238),
    [anon_sym_object] = ACTIONS(3238),
    [anon_sym_abstract] = ACTIONS(3238),
    [anon_sym_interface] = ACTIONS(3238),
    [anon_sym_enum] = ACTIONS(3238),
    [sym_html_comment] = ACTIONS(5),
  },
  [1382] = {
    [sym_comment] = STATE(1382),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1383] = {
    [sym_comment] = STATE(1383),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1384] = {
    [sym_comment] = STATE(1384),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1385] = {
    [sym_comment] = STATE(1385),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1386] = {
    [sym_comment] = STATE(1386),
    [ts_builtin_sym_end] = ACTIONS(2365),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2083),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_LTtemplate_GT] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2083),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2083),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_using] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2083),
    [sym_number] = ACTIONS(2083),
    [sym_private_property_identifier] = ACTIONS(2083),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2083),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_readonly] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_override] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_object] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [sym__automatic_semicolon] = ACTIONS(2441),
    [sym_html_comment] = ACTIONS(5),
  },
  [1387] = {
    [sym_comment] = STATE(1387),
    [ts_builtin_sym_end] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_export] = ACTIONS(2197),
    [anon_sym_type] = ACTIONS(2197),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_RBRACE] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_import] = ACTIONS(2197),
    [anon_sym_with] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_debugger] = ACTIONS(2197),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_LTtemplate_GT] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_function] = ACTIONS(2197),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_void] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2197),
    [sym_number] = ACTIONS(2197),
    [sym_private_property_identifier] = ACTIONS(2197),
    [sym_this] = ACTIONS(2197),
    [sym_super] = ACTIONS(2197),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [sym_null] = ACTIONS(2197),
    [sym_undefined] = ACTIONS(2197),
    [anon_sym_AT] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_declare] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_module] = ACTIONS(2197),
    [anon_sym_any] = ACTIONS(2197),
    [anon_sym_number] = ACTIONS(2197),
    [anon_sym_boolean] = ACTIONS(2197),
    [anon_sym_string] = ACTIONS(2197),
    [anon_sym_symbol] = ACTIONS(2197),
    [anon_sym_object] = ACTIONS(2197),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [sym__automatic_semicolon] = ACTIONS(2415),
    [sym_html_comment] = ACTIONS(5),
  },
  [1388] = {
    [sym_comment] = STATE(1388),
    [ts_builtin_sym_end] = ACTIONS(3524),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_export] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_namespace] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_RBRACE] = ACTIONS(3308),
    [anon_sym_typeof] = ACTIONS(3308),
    [anon_sym_import] = ACTIONS(3308),
    [anon_sym_with] = ACTIONS(3308),
    [anon_sym_var] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_else] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_switch] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_await] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_debugger] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_throw] = ACTIONS(3308),
    [anon_sym_SEMI] = ACTIONS(3308),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LTtemplate_GT] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_class] = ACTIONS(3308),
    [anon_sym_async] = ACTIONS(3308),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_using] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_void] = ACTIONS(3308),
    [anon_sym_delete] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3308),
    [sym_number] = ACTIONS(3308),
    [sym_private_property_identifier] = ACTIONS(3308),
    [sym_this] = ACTIONS(3308),
    [sym_super] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_null] = ACTIONS(3308),
    [sym_undefined] = ACTIONS(3308),
    [anon_sym_AT] = ACTIONS(3308),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_readonly] = ACTIONS(3308),
    [anon_sym_get] = ACTIONS(3308),
    [anon_sym_set] = ACTIONS(3308),
    [anon_sym_declare] = ACTIONS(3308),
    [anon_sym_public] = ACTIONS(3308),
    [anon_sym_private] = ACTIONS(3308),
    [anon_sym_protected] = ACTIONS(3308),
    [anon_sym_override] = ACTIONS(3308),
    [anon_sym_module] = ACTIONS(3308),
    [anon_sym_any] = ACTIONS(3308),
    [anon_sym_number] = ACTIONS(3308),
    [anon_sym_boolean] = ACTIONS(3308),
    [anon_sym_string] = ACTIONS(3308),
    [anon_sym_symbol] = ACTIONS(3308),
    [anon_sym_object] = ACTIONS(3308),
    [anon_sym_abstract] = ACTIONS(3308),
    [anon_sym_interface] = ACTIONS(3308),
    [anon_sym_enum] = ACTIONS(3308),
    [sym_html_comment] = ACTIONS(5),
  },
  [1389] = {
    [sym_comment] = STATE(1389),
    [ts_builtin_sym_end] = ACTIONS(3526),
    [sym_identifier] = ACTIONS(3334),
    [anon_sym_export] = ACTIONS(3334),
    [anon_sym_type] = ACTIONS(3334),
    [anon_sym_namespace] = ACTIONS(3334),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_typeof] = ACTIONS(3334),
    [anon_sym_import] = ACTIONS(3334),
    [anon_sym_with] = ACTIONS(3334),
    [anon_sym_var] = ACTIONS(3334),
    [anon_sym_let] = ACTIONS(3334),
    [anon_sym_const] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_else] = ACTIONS(3334),
    [anon_sym_if] = ACTIONS(3334),
    [anon_sym_switch] = ACTIONS(3334),
    [anon_sym_for] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3334),
    [anon_sym_await] = ACTIONS(3334),
    [anon_sym_while] = ACTIONS(3334),
    [anon_sym_do] = ACTIONS(3334),
    [anon_sym_try] = ACTIONS(3334),
    [anon_sym_break] = ACTIONS(3334),
    [anon_sym_continue] = ACTIONS(3334),
    [anon_sym_debugger] = ACTIONS(3334),
    [anon_sym_return] = ACTIONS(3334),
    [anon_sym_throw] = ACTIONS(3334),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym_yield] = ACTIONS(3334),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LTtemplate_GT] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_class] = ACTIONS(3334),
    [anon_sym_async] = ACTIONS(3334),
    [anon_sym_function] = ACTIONS(3334),
    [anon_sym_new] = ACTIONS(3334),
    [anon_sym_using] = ACTIONS(3334),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3334),
    [anon_sym_SLASH] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_void] = ACTIONS(3334),
    [anon_sym_delete] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3334),
    [sym_number] = ACTIONS(3334),
    [sym_private_property_identifier] = ACTIONS(3334),
    [sym_this] = ACTIONS(3334),
    [sym_super] = ACTIONS(3334),
    [sym_true] = ACTIONS(3334),
    [sym_false] = ACTIONS(3334),
    [sym_null] = ACTIONS(3334),
    [sym_undefined] = ACTIONS(3334),
    [anon_sym_AT] = ACTIONS(3334),
    [anon_sym_static] = ACTIONS(3334),
    [anon_sym_readonly] = ACTIONS(3334),
    [anon_sym_get] = ACTIONS(3334),
    [anon_sym_set] = ACTIONS(3334),
    [anon_sym_declare] = ACTIONS(3334),
    [anon_sym_public] = ACTIONS(3334),
    [anon_sym_private] = ACTIONS(3334),
    [anon_sym_protected] = ACTIONS(3334),
    [anon_sym_override] = ACTIONS(3334),
    [anon_sym_module] = ACTIONS(3334),
    [anon_sym_any] = ACTIONS(3334),
    [anon_sym_number] = ACTIONS(3334),
    [anon_sym_boolean] = ACTIONS(3334),
    [anon_sym_string] = ACTIONS(3334),
    [anon_sym_symbol] = ACTIONS(3334),
    [anon_sym_object] = ACTIONS(3334),
    [anon_sym_abstract] = ACTIONS(3334),
    [anon_sym_interface] = ACTIONS(3334),
    [anon_sym_enum] = ACTIONS(3334),
    [sym_html_comment] = ACTIONS(5),
  },
  [1390] = {
    [sym_comment] = STATE(1390),
    [ts_builtin_sym_end] = ACTIONS(3526),
    [sym_identifier] = ACTIONS(3334),
    [anon_sym_export] = ACTIONS(3334),
    [anon_sym_type] = ACTIONS(3334),
    [anon_sym_namespace] = ACTIONS(3334),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_typeof] = ACTIONS(3334),
    [anon_sym_import] = ACTIONS(3334),
    [anon_sym_with] = ACTIONS(3334),
    [anon_sym_var] = ACTIONS(3334),
    [anon_sym_let] = ACTIONS(3334),
    [anon_sym_const] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_else] = ACTIONS(3334),
    [anon_sym_if] = ACTIONS(3334),
    [anon_sym_switch] = ACTIONS(3334),
    [anon_sym_for] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3334),
    [anon_sym_await] = ACTIONS(3334),
    [anon_sym_while] = ACTIONS(3334),
    [anon_sym_do] = ACTIONS(3334),
    [anon_sym_try] = ACTIONS(3334),
    [anon_sym_break] = ACTIONS(3334),
    [anon_sym_continue] = ACTIONS(3334),
    [anon_sym_debugger] = ACTIONS(3334),
    [anon_sym_return] = ACTIONS(3334),
    [anon_sym_throw] = ACTIONS(3334),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym_yield] = ACTIONS(3334),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LTtemplate_GT] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_class] = ACTIONS(3334),
    [anon_sym_async] = ACTIONS(3334),
    [anon_sym_function] = ACTIONS(3334),
    [anon_sym_new] = ACTIONS(3334),
    [anon_sym_using] = ACTIONS(3334),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3334),
    [anon_sym_SLASH] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_void] = ACTIONS(3334),
    [anon_sym_delete] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3334),
    [sym_number] = ACTIONS(3334),
    [sym_private_property_identifier] = ACTIONS(3334),
    [sym_this] = ACTIONS(3334),
    [sym_super] = ACTIONS(3334),
    [sym_true] = ACTIONS(3334),
    [sym_false] = ACTIONS(3334),
    [sym_null] = ACTIONS(3334),
    [sym_undefined] = ACTIONS(3334),
    [anon_sym_AT] = ACTIONS(3334),
    [anon_sym_static] = ACTIONS(3334),
    [anon_sym_readonly] = ACTIONS(3334),
    [anon_sym_get] = ACTIONS(3334),
    [anon_sym_set] = ACTIONS(3334),
    [anon_sym_declare] = ACTIONS(3334),
    [anon_sym_public] = ACTIONS(3334),
    [anon_sym_private] = ACTIONS(3334),
    [anon_sym_protected] = ACTIONS(3334),
    [anon_sym_override] = ACTIONS(3334),
    [anon_sym_module] = ACTIONS(3334),
    [anon_sym_any] = ACTIONS(3334),
    [anon_sym_number] = ACTIONS(3334),
    [anon_sym_boolean] = ACTIONS(3334),
    [anon_sym_string] = ACTIONS(3334),
    [anon_sym_symbol] = ACTIONS(3334),
    [anon_sym_object] = ACTIONS(3334),
    [anon_sym_abstract] = ACTIONS(3334),
    [anon_sym_interface] = ACTIONS(3334),
    [anon_sym_enum] = ACTIONS(3334),
    [sym_html_comment] = ACTIONS(5),
  },
  [1391] = {
    [sym_comment] = STATE(1391),
    [ts_builtin_sym_end] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3332),
    [anon_sym_export] = ACTIONS(3332),
    [anon_sym_type] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_typeof] = ACTIONS(3332),
    [anon_sym_import] = ACTIONS(3332),
    [anon_sym_with] = ACTIONS(3332),
    [anon_sym_var] = ACTIONS(3332),
    [anon_sym_let] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_else] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_await] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_debugger] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_throw] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_yield] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_LTtemplate_GT] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_async] = ACTIONS(3332),
    [anon_sym_function] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_SLASH] = ACTIONS(3332),
    [anon_sym_LT] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_void] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3332),
    [sym_number] = ACTIONS(3332),
    [sym_private_property_identifier] = ACTIONS(3332),
    [sym_this] = ACTIONS(3332),
    [sym_super] = ACTIONS(3332),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_null] = ACTIONS(3332),
    [sym_undefined] = ACTIONS(3332),
    [anon_sym_AT] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_readonly] = ACTIONS(3332),
    [anon_sym_get] = ACTIONS(3332),
    [anon_sym_set] = ACTIONS(3332),
    [anon_sym_declare] = ACTIONS(3332),
    [anon_sym_public] = ACTIONS(3332),
    [anon_sym_private] = ACTIONS(3332),
    [anon_sym_protected] = ACTIONS(3332),
    [anon_sym_override] = ACTIONS(3332),
    [anon_sym_module] = ACTIONS(3332),
    [anon_sym_any] = ACTIONS(3332),
    [anon_sym_number] = ACTIONS(3332),
    [anon_sym_boolean] = ACTIONS(3332),
    [anon_sym_string] = ACTIONS(3332),
    [anon_sym_symbol] = ACTIONS(3332),
    [anon_sym_object] = ACTIONS(3332),
    [anon_sym_abstract] = ACTIONS(3332),
    [anon_sym_interface] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [sym_html_comment] = ACTIONS(5),
  },
  [1392] = {
    [sym_comment] = STATE(1392),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1393] = {
    [sym_comment] = STATE(1393),
    [sym_identifier] = ACTIONS(3132),
    [anon_sym_export] = ACTIONS(3132),
    [anon_sym_default] = ACTIONS(3132),
    [anon_sym_type] = ACTIONS(3132),
    [anon_sym_namespace] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_typeof] = ACTIONS(3132),
    [anon_sym_import] = ACTIONS(3132),
    [anon_sym_with] = ACTIONS(3132),
    [anon_sym_var] = ACTIONS(3132),
    [anon_sym_let] = ACTIONS(3132),
    [anon_sym_const] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_switch] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [anon_sym_await] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_do] = ACTIONS(3132),
    [anon_sym_try] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_continue] = ACTIONS(3132),
    [anon_sym_debugger] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_throw] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_case] = ACTIONS(3132),
    [anon_sym_yield] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_LTtemplate_GT] = ACTIONS(3132),
    [anon_sym_DQUOTE] = ACTIONS(3132),
    [anon_sym_SQUOTE] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_async] = ACTIONS(3132),
    [anon_sym_function] = ACTIONS(3132),
    [anon_sym_new] = ACTIONS(3132),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3132),
    [anon_sym_DASH] = ACTIONS(3132),
    [anon_sym_SLASH] = ACTIONS(3132),
    [anon_sym_LT] = ACTIONS(3132),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_void] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3132),
    [sym_number] = ACTIONS(3132),
    [sym_private_property_identifier] = ACTIONS(3132),
    [sym_this] = ACTIONS(3132),
    [sym_super] = ACTIONS(3132),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [sym_null] = ACTIONS(3132),
    [sym_undefined] = ACTIONS(3132),
    [anon_sym_AT] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_readonly] = ACTIONS(3132),
    [anon_sym_get] = ACTIONS(3132),
    [anon_sym_set] = ACTIONS(3132),
    [anon_sym_declare] = ACTIONS(3132),
    [anon_sym_public] = ACTIONS(3132),
    [anon_sym_private] = ACTIONS(3132),
    [anon_sym_protected] = ACTIONS(3132),
    [anon_sym_override] = ACTIONS(3132),
    [anon_sym_module] = ACTIONS(3132),
    [anon_sym_any] = ACTIONS(3132),
    [anon_sym_number] = ACTIONS(3132),
    [anon_sym_boolean] = ACTIONS(3132),
    [anon_sym_string] = ACTIONS(3132),
    [anon_sym_symbol] = ACTIONS(3132),
    [anon_sym_object] = ACTIONS(3132),
    [anon_sym_abstract] = ACTIONS(3132),
    [anon_sym_interface] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1394] = {
    [sym_comment] = STATE(1394),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1395] = {
    [sym_comment] = STATE(1395),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1396] = {
    [sym_comment] = STATE(1396),
    [ts_builtin_sym_end] = ACTIONS(3530),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_export] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_namespace] = ACTIONS(3202),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_RBRACE] = ACTIONS(3202),
    [anon_sym_typeof] = ACTIONS(3202),
    [anon_sym_import] = ACTIONS(3202),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_var] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_const] = ACTIONS(3202),
    [anon_sym_BANG] = ACTIONS(3202),
    [anon_sym_else] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_switch] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_await] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_break] = ACTIONS(3202),
    [anon_sym_continue] = ACTIONS(3202),
    [anon_sym_debugger] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_throw] = ACTIONS(3202),
    [anon_sym_SEMI] = ACTIONS(3202),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LTtemplate_GT] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_class] = ACTIONS(3202),
    [anon_sym_async] = ACTIONS(3202),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_using] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(3202),
    [anon_sym_LT] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3202),
    [anon_sym_void] = ACTIONS(3202),
    [anon_sym_delete] = ACTIONS(3202),
    [anon_sym_PLUS_PLUS] = ACTIONS(3202),
    [anon_sym_DASH_DASH] = ACTIONS(3202),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3202),
    [sym_number] = ACTIONS(3202),
    [sym_private_property_identifier] = ACTIONS(3202),
    [sym_this] = ACTIONS(3202),
    [sym_super] = ACTIONS(3202),
    [sym_true] = ACTIONS(3202),
    [sym_false] = ACTIONS(3202),
    [sym_null] = ACTIONS(3202),
    [sym_undefined] = ACTIONS(3202),
    [anon_sym_AT] = ACTIONS(3202),
    [anon_sym_static] = ACTIONS(3202),
    [anon_sym_readonly] = ACTIONS(3202),
    [anon_sym_get] = ACTIONS(3202),
    [anon_sym_set] = ACTIONS(3202),
    [anon_sym_declare] = ACTIONS(3202),
    [anon_sym_public] = ACTIONS(3202),
    [anon_sym_private] = ACTIONS(3202),
    [anon_sym_protected] = ACTIONS(3202),
    [anon_sym_override] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_any] = ACTIONS(3202),
    [anon_sym_number] = ACTIONS(3202),
    [anon_sym_boolean] = ACTIONS(3202),
    [anon_sym_string] = ACTIONS(3202),
    [anon_sym_symbol] = ACTIONS(3202),
    [anon_sym_object] = ACTIONS(3202),
    [anon_sym_abstract] = ACTIONS(3202),
    [anon_sym_interface] = ACTIONS(3202),
    [anon_sym_enum] = ACTIONS(3202),
    [sym_html_comment] = ACTIONS(5),
  },
  [1397] = {
    [sym_comment] = STATE(1397),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1398] = {
    [sym_comment] = STATE(1398),
    [ts_builtin_sym_end] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_export] = ACTIONS(3324),
    [anon_sym_type] = ACTIONS(3324),
    [anon_sym_namespace] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_import] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3324),
    [anon_sym_var] = ACTIONS(3324),
    [anon_sym_let] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_else] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_switch] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym_await] = ACTIONS(3324),
    [anon_sym_while] = ACTIONS(3324),
    [anon_sym_do] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_debugger] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_throw] = ACTIONS(3324),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_LTtemplate_GT] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_async] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_SLASH] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_void] = ACTIONS(3324),
    [anon_sym_delete] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3324),
    [sym_number] = ACTIONS(3324),
    [sym_private_property_identifier] = ACTIONS(3324),
    [sym_this] = ACTIONS(3324),
    [sym_super] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_null] = ACTIONS(3324),
    [sym_undefined] = ACTIONS(3324),
    [anon_sym_AT] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_readonly] = ACTIONS(3324),
    [anon_sym_get] = ACTIONS(3324),
    [anon_sym_set] = ACTIONS(3324),
    [anon_sym_declare] = ACTIONS(3324),
    [anon_sym_public] = ACTIONS(3324),
    [anon_sym_private] = ACTIONS(3324),
    [anon_sym_protected] = ACTIONS(3324),
    [anon_sym_override] = ACTIONS(3324),
    [anon_sym_module] = ACTIONS(3324),
    [anon_sym_any] = ACTIONS(3324),
    [anon_sym_number] = ACTIONS(3324),
    [anon_sym_boolean] = ACTIONS(3324),
    [anon_sym_string] = ACTIONS(3324),
    [anon_sym_symbol] = ACTIONS(3324),
    [anon_sym_object] = ACTIONS(3324),
    [anon_sym_abstract] = ACTIONS(3324),
    [anon_sym_interface] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [sym_html_comment] = ACTIONS(5),
  },
  [1399] = {
    [sym_comment] = STATE(1399),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_else] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym_html_comment] = ACTIONS(5),
  },
  [1400] = {
    [sym_comment] = STATE(1400),
    [ts_builtin_sym_end] = ACTIONS(3534),
    [sym_identifier] = ACTIONS(3204),
    [anon_sym_export] = ACTIONS(3204),
    [anon_sym_type] = ACTIONS(3204),
    [anon_sym_namespace] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_typeof] = ACTIONS(3204),
    [anon_sym_import] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3204),
    [anon_sym_var] = ACTIONS(3204),
    [anon_sym_let] = ACTIONS(3204),
    [anon_sym_const] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_switch] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3204),
    [anon_sym_await] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3204),
    [anon_sym_break] = ACTIONS(3204),
    [anon_sym_continue] = ACTIONS(3204),
    [anon_sym_debugger] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3204),
    [anon_sym_throw] = ACTIONS(3204),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_LTtemplate_GT] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [anon_sym_SQUOTE] = ACTIONS(3204),
    [anon_sym_class] = ACTIONS(3204),
    [anon_sym_async] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3204),
    [anon_sym_using] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3204),
    [anon_sym_DASH] = ACTIONS(3204),
    [anon_sym_SLASH] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [anon_sym_void] = ACTIONS(3204),
    [anon_sym_delete] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3204),
    [anon_sym_DASH_DASH] = ACTIONS(3204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3204),
    [sym_number] = ACTIONS(3204),
    [sym_private_property_identifier] = ACTIONS(3204),
    [sym_this] = ACTIONS(3204),
    [sym_super] = ACTIONS(3204),
    [sym_true] = ACTIONS(3204),
    [sym_false] = ACTIONS(3204),
    [sym_null] = ACTIONS(3204),
    [sym_undefined] = ACTIONS(3204),
    [anon_sym_AT] = ACTIONS(3204),
    [anon_sym_static] = ACTIONS(3204),
    [anon_sym_readonly] = ACTIONS(3204),
    [anon_sym_get] = ACTIONS(3204),
    [anon_sym_set] = ACTIONS(3204),
    [anon_sym_declare] = ACTIONS(3204),
    [anon_sym_public] = ACTIONS(3204),
    [anon_sym_private] = ACTIONS(3204),
    [anon_sym_protected] = ACTIONS(3204),
    [anon_sym_override] = ACTIONS(3204),
    [anon_sym_module] = ACTIONS(3204),
    [anon_sym_any] = ACTIONS(3204),
    [anon_sym_number] = ACTIONS(3204),
    [anon_sym_boolean] = ACTIONS(3204),
    [anon_sym_string] = ACTIONS(3204),
    [anon_sym_symbol] = ACTIONS(3204),
    [anon_sym_object] = ACTIONS(3204),
    [anon_sym_abstract] = ACTIONS(3204),
    [anon_sym_interface] = ACTIONS(3204),
    [anon_sym_enum] = ACTIONS(3204),
    [sym_html_comment] = ACTIONS(5),
  },
  [1401] = {
    [sym_comment] = STATE(1401),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1402] = {
    [sym_comment] = STATE(1402),
    [ts_builtin_sym_end] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3160),
    [anon_sym_export] = ACTIONS(3160),
    [anon_sym_type] = ACTIONS(3160),
    [anon_sym_namespace] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_typeof] = ACTIONS(3160),
    [anon_sym_import] = ACTIONS(3160),
    [anon_sym_with] = ACTIONS(3160),
    [anon_sym_var] = ACTIONS(3160),
    [anon_sym_let] = ACTIONS(3160),
    [anon_sym_const] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_else] = ACTIONS(3160),
    [anon_sym_if] = ACTIONS(3160),
    [anon_sym_switch] = ACTIONS(3160),
    [anon_sym_for] = ACTIONS(3160),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_await] = ACTIONS(3160),
    [anon_sym_while] = ACTIONS(3160),
    [anon_sym_do] = ACTIONS(3160),
    [anon_sym_try] = ACTIONS(3160),
    [anon_sym_break] = ACTIONS(3160),
    [anon_sym_continue] = ACTIONS(3160),
    [anon_sym_debugger] = ACTIONS(3160),
    [anon_sym_return] = ACTIONS(3160),
    [anon_sym_throw] = ACTIONS(3160),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym_yield] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_LTtemplate_GT] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_class] = ACTIONS(3160),
    [anon_sym_async] = ACTIONS(3160),
    [anon_sym_function] = ACTIONS(3160),
    [anon_sym_new] = ACTIONS(3160),
    [anon_sym_using] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3160),
    [anon_sym_SLASH] = ACTIONS(3160),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_void] = ACTIONS(3160),
    [anon_sym_delete] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3160),
    [sym_number] = ACTIONS(3160),
    [sym_private_property_identifier] = ACTIONS(3160),
    [sym_this] = ACTIONS(3160),
    [sym_super] = ACTIONS(3160),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [sym_null] = ACTIONS(3160),
    [sym_undefined] = ACTIONS(3160),
    [anon_sym_AT] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_readonly] = ACTIONS(3160),
    [anon_sym_get] = ACTIONS(3160),
    [anon_sym_set] = ACTIONS(3160),
    [anon_sym_declare] = ACTIONS(3160),
    [anon_sym_public] = ACTIONS(3160),
    [anon_sym_private] = ACTIONS(3160),
    [anon_sym_protected] = ACTIONS(3160),
    [anon_sym_override] = ACTIONS(3160),
    [anon_sym_module] = ACTIONS(3160),
    [anon_sym_any] = ACTIONS(3160),
    [anon_sym_number] = ACTIONS(3160),
    [anon_sym_boolean] = ACTIONS(3160),
    [anon_sym_string] = ACTIONS(3160),
    [anon_sym_symbol] = ACTIONS(3160),
    [anon_sym_object] = ACTIONS(3160),
    [anon_sym_abstract] = ACTIONS(3160),
    [anon_sym_interface] = ACTIONS(3160),
    [anon_sym_enum] = ACTIONS(3160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1403] = {
    [sym_comment] = STATE(1403),
    [sym_identifier] = ACTIONS(3210),
    [anon_sym_export] = ACTIONS(3210),
    [anon_sym_default] = ACTIONS(3210),
    [anon_sym_type] = ACTIONS(3210),
    [anon_sym_namespace] = ACTIONS(3210),
    [anon_sym_LBRACE] = ACTIONS(3210),
    [anon_sym_RBRACE] = ACTIONS(3210),
    [anon_sym_typeof] = ACTIONS(3210),
    [anon_sym_import] = ACTIONS(3210),
    [anon_sym_with] = ACTIONS(3210),
    [anon_sym_var] = ACTIONS(3210),
    [anon_sym_let] = ACTIONS(3210),
    [anon_sym_const] = ACTIONS(3210),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_if] = ACTIONS(3210),
    [anon_sym_switch] = ACTIONS(3210),
    [anon_sym_for] = ACTIONS(3210),
    [anon_sym_LPAREN] = ACTIONS(3210),
    [anon_sym_await] = ACTIONS(3210),
    [anon_sym_while] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3210),
    [anon_sym_try] = ACTIONS(3210),
    [anon_sym_break] = ACTIONS(3210),
    [anon_sym_continue] = ACTIONS(3210),
    [anon_sym_debugger] = ACTIONS(3210),
    [anon_sym_return] = ACTIONS(3210),
    [anon_sym_throw] = ACTIONS(3210),
    [anon_sym_SEMI] = ACTIONS(3210),
    [anon_sym_case] = ACTIONS(3210),
    [anon_sym_yield] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_LTtemplate_GT] = ACTIONS(3210),
    [anon_sym_DQUOTE] = ACTIONS(3210),
    [anon_sym_SQUOTE] = ACTIONS(3210),
    [anon_sym_class] = ACTIONS(3210),
    [anon_sym_async] = ACTIONS(3210),
    [anon_sym_function] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3210),
    [anon_sym_using] = ACTIONS(3210),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_SLASH] = ACTIONS(3210),
    [anon_sym_LT] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3210),
    [anon_sym_void] = ACTIONS(3210),
    [anon_sym_delete] = ACTIONS(3210),
    [anon_sym_PLUS_PLUS] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3210),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3210),
    [sym_number] = ACTIONS(3210),
    [sym_private_property_identifier] = ACTIONS(3210),
    [sym_this] = ACTIONS(3210),
    [sym_super] = ACTIONS(3210),
    [sym_true] = ACTIONS(3210),
    [sym_false] = ACTIONS(3210),
    [sym_null] = ACTIONS(3210),
    [sym_undefined] = ACTIONS(3210),
    [anon_sym_AT] = ACTIONS(3210),
    [anon_sym_static] = ACTIONS(3210),
    [anon_sym_readonly] = ACTIONS(3210),
    [anon_sym_get] = ACTIONS(3210),
    [anon_sym_set] = ACTIONS(3210),
    [anon_sym_declare] = ACTIONS(3210),
    [anon_sym_public] = ACTIONS(3210),
    [anon_sym_private] = ACTIONS(3210),
    [anon_sym_protected] = ACTIONS(3210),
    [anon_sym_override] = ACTIONS(3210),
    [anon_sym_module] = ACTIONS(3210),
    [anon_sym_any] = ACTIONS(3210),
    [anon_sym_number] = ACTIONS(3210),
    [anon_sym_boolean] = ACTIONS(3210),
    [anon_sym_string] = ACTIONS(3210),
    [anon_sym_symbol] = ACTIONS(3210),
    [anon_sym_object] = ACTIONS(3210),
    [anon_sym_abstract] = ACTIONS(3210),
    [anon_sym_interface] = ACTIONS(3210),
    [anon_sym_enum] = ACTIONS(3210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1404] = {
    [sym_comment] = STATE(1404),
    [ts_builtin_sym_end] = ACTIONS(2271),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_export] = ACTIONS(2103),
    [anon_sym_type] = ACTIONS(2103),
    [anon_sym_namespace] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_typeof] = ACTIONS(2103),
    [anon_sym_import] = ACTIONS(2103),
    [anon_sym_with] = ACTIONS(2103),
    [anon_sym_var] = ACTIONS(2103),
    [anon_sym_let] = ACTIONS(2103),
    [anon_sym_const] = ACTIONS(2103),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_switch] = ACTIONS(2103),
    [anon_sym_for] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2103),
    [anon_sym_await] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_try] = ACTIONS(2103),
    [anon_sym_break] = ACTIONS(2103),
    [anon_sym_continue] = ACTIONS(2103),
    [anon_sym_debugger] = ACTIONS(2103),
    [anon_sym_return] = ACTIONS(2103),
    [anon_sym_throw] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2103),
    [anon_sym_yield] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2103),
    [anon_sym_LTtemplate_GT] = ACTIONS(2103),
    [anon_sym_DQUOTE] = ACTIONS(2103),
    [anon_sym_SQUOTE] = ACTIONS(2103),
    [anon_sym_class] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(2103),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_using] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [anon_sym_void] = ACTIONS(2103),
    [anon_sym_delete] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2103),
    [anon_sym_DASH_DASH] = ACTIONS(2103),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2103),
    [sym_number] = ACTIONS(2103),
    [sym_private_property_identifier] = ACTIONS(2103),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_undefined] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2103),
    [anon_sym_static] = ACTIONS(2103),
    [anon_sym_readonly] = ACTIONS(2103),
    [anon_sym_get] = ACTIONS(2103),
    [anon_sym_set] = ACTIONS(2103),
    [anon_sym_declare] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2103),
    [anon_sym_private] = ACTIONS(2103),
    [anon_sym_protected] = ACTIONS(2103),
    [anon_sym_override] = ACTIONS(2103),
    [anon_sym_module] = ACTIONS(2103),
    [anon_sym_any] = ACTIONS(2103),
    [anon_sym_number] = ACTIONS(2103),
    [anon_sym_boolean] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_symbol] = ACTIONS(2103),
    [anon_sym_object] = ACTIONS(2103),
    [anon_sym_abstract] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2103),
    [anon_sym_enum] = ACTIONS(2103),
    [sym__automatic_semicolon] = ACTIONS(2435),
    [sym_html_comment] = ACTIONS(5),
  },
  [1405] = {
    [sym_comment] = STATE(1405),
    [sym_identifier] = ACTIONS(3252),
    [anon_sym_export] = ACTIONS(3252),
    [anon_sym_default] = ACTIONS(3252),
    [anon_sym_type] = ACTIONS(3252),
    [anon_sym_namespace] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_typeof] = ACTIONS(3252),
    [anon_sym_import] = ACTIONS(3252),
    [anon_sym_with] = ACTIONS(3252),
    [anon_sym_var] = ACTIONS(3252),
    [anon_sym_let] = ACTIONS(3252),
    [anon_sym_const] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_if] = ACTIONS(3252),
    [anon_sym_switch] = ACTIONS(3252),
    [anon_sym_for] = ACTIONS(3252),
    [anon_sym_LPAREN] = ACTIONS(3252),
    [anon_sym_await] = ACTIONS(3252),
    [anon_sym_while] = ACTIONS(3252),
    [anon_sym_do] = ACTIONS(3252),
    [anon_sym_try] = ACTIONS(3252),
    [anon_sym_break] = ACTIONS(3252),
    [anon_sym_continue] = ACTIONS(3252),
    [anon_sym_debugger] = ACTIONS(3252),
    [anon_sym_return] = ACTIONS(3252),
    [anon_sym_throw] = ACTIONS(3252),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym_case] = ACTIONS(3252),
    [anon_sym_yield] = ACTIONS(3252),
    [anon_sym_LBRACK] = ACTIONS(3252),
    [anon_sym_LTtemplate_GT] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_class] = ACTIONS(3252),
    [anon_sym_async] = ACTIONS(3252),
    [anon_sym_function] = ACTIONS(3252),
    [anon_sym_new] = ACTIONS(3252),
    [anon_sym_using] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3252),
    [anon_sym_SLASH] = ACTIONS(3252),
    [anon_sym_LT] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_void] = ACTIONS(3252),
    [anon_sym_delete] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3252),
    [sym_number] = ACTIONS(3252),
    [sym_private_property_identifier] = ACTIONS(3252),
    [sym_this] = ACTIONS(3252),
    [sym_super] = ACTIONS(3252),
    [sym_true] = ACTIONS(3252),
    [sym_false] = ACTIONS(3252),
    [sym_null] = ACTIONS(3252),
    [sym_undefined] = ACTIONS(3252),
    [anon_sym_AT] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3252),
    [anon_sym_readonly] = ACTIONS(3252),
    [anon_sym_get] = ACTIONS(3252),
    [anon_sym_set] = ACTIONS(3252),
    [anon_sym_declare] = ACTIONS(3252),
    [anon_sym_public] = ACTIONS(3252),
    [anon_sym_private] = ACTIONS(3252),
    [anon_sym_protected] = ACTIONS(3252),
    [anon_sym_override] = ACTIONS(3252),
    [anon_sym_module] = ACTIONS(3252),
    [anon_sym_any] = ACTIONS(3252),
    [anon_sym_number] = ACTIONS(3252),
    [anon_sym_boolean] = ACTIONS(3252),
    [anon_sym_string] = ACTIONS(3252),
    [anon_sym_symbol] = ACTIONS(3252),
    [anon_sym_object] = ACTIONS(3252),
    [anon_sym_abstract] = ACTIONS(3252),
    [anon_sym_interface] = ACTIONS(3252),
    [anon_sym_enum] = ACTIONS(3252),
    [sym_html_comment] = ACTIONS(5),
  },
  [1406] = {
    [sym_comment] = STATE(1406),
    [ts_builtin_sym_end] = ACTIONS(3538),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_export] = ACTIONS(3316),
    [anon_sym_type] = ACTIONS(3316),
    [anon_sym_namespace] = ACTIONS(3316),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_typeof] = ACTIONS(3316),
    [anon_sym_import] = ACTIONS(3316),
    [anon_sym_with] = ACTIONS(3316),
    [anon_sym_var] = ACTIONS(3316),
    [anon_sym_let] = ACTIONS(3316),
    [anon_sym_const] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_else] = ACTIONS(3316),
    [anon_sym_if] = ACTIONS(3316),
    [anon_sym_switch] = ACTIONS(3316),
    [anon_sym_for] = ACTIONS(3316),
    [anon_sym_LPAREN] = ACTIONS(3316),
    [anon_sym_await] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(3316),
    [anon_sym_do] = ACTIONS(3316),
    [anon_sym_try] = ACTIONS(3316),
    [anon_sym_break] = ACTIONS(3316),
    [anon_sym_continue] = ACTIONS(3316),
    [anon_sym_debugger] = ACTIONS(3316),
    [anon_sym_return] = ACTIONS(3316),
    [anon_sym_throw] = ACTIONS(3316),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym_yield] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_LTtemplate_GT] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_class] = ACTIONS(3316),
    [anon_sym_async] = ACTIONS(3316),
    [anon_sym_function] = ACTIONS(3316),
    [anon_sym_new] = ACTIONS(3316),
    [anon_sym_using] = ACTIONS(3316),
    [anon_sym_PLUS] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3316),
    [anon_sym_SLASH] = ACTIONS(3316),
    [anon_sym_LT] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_void] = ACTIONS(3316),
    [anon_sym_delete] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3316),
    [sym_number] = ACTIONS(3316),
    [sym_private_property_identifier] = ACTIONS(3316),
    [sym_this] = ACTIONS(3316),
    [sym_super] = ACTIONS(3316),
    [sym_true] = ACTIONS(3316),
    [sym_false] = ACTIONS(3316),
    [sym_null] = ACTIONS(3316),
    [sym_undefined] = ACTIONS(3316),
    [anon_sym_AT] = ACTIONS(3316),
    [anon_sym_static] = ACTIONS(3316),
    [anon_sym_readonly] = ACTIONS(3316),
    [anon_sym_get] = ACTIONS(3316),
    [anon_sym_set] = ACTIONS(3316),
    [anon_sym_declare] = ACTIONS(3316),
    [anon_sym_public] = ACTIONS(3316),
    [anon_sym_private] = ACTIONS(3316),
    [anon_sym_protected] = ACTIONS(3316),
    [anon_sym_override] = ACTIONS(3316),
    [anon_sym_module] = ACTIONS(3316),
    [anon_sym_any] = ACTIONS(3316),
    [anon_sym_number] = ACTIONS(3316),
    [anon_sym_boolean] = ACTIONS(3316),
    [anon_sym_string] = ACTIONS(3316),
    [anon_sym_symbol] = ACTIONS(3316),
    [anon_sym_object] = ACTIONS(3316),
    [anon_sym_abstract] = ACTIONS(3316),
    [anon_sym_interface] = ACTIONS(3316),
    [anon_sym_enum] = ACTIONS(3316),
    [sym_html_comment] = ACTIONS(5),
  },
  [1407] = {
    [sym_comment] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(3540),
    [sym_identifier] = ACTIONS(3222),
    [anon_sym_export] = ACTIONS(3222),
    [anon_sym_type] = ACTIONS(3222),
    [anon_sym_namespace] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3222),
    [anon_sym_RBRACE] = ACTIONS(3222),
    [anon_sym_typeof] = ACTIONS(3222),
    [anon_sym_import] = ACTIONS(3222),
    [anon_sym_with] = ACTIONS(3222),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_BANG] = ACTIONS(3222),
    [anon_sym_else] = ACTIONS(3222),
    [anon_sym_if] = ACTIONS(3222),
    [anon_sym_switch] = ACTIONS(3222),
    [anon_sym_for] = ACTIONS(3222),
    [anon_sym_LPAREN] = ACTIONS(3222),
    [anon_sym_await] = ACTIONS(3222),
    [anon_sym_while] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3222),
    [anon_sym_break] = ACTIONS(3222),
    [anon_sym_continue] = ACTIONS(3222),
    [anon_sym_debugger] = ACTIONS(3222),
    [anon_sym_return] = ACTIONS(3222),
    [anon_sym_throw] = ACTIONS(3222),
    [anon_sym_SEMI] = ACTIONS(3222),
    [anon_sym_yield] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_LTtemplate_GT] = ACTIONS(3222),
    [anon_sym_DQUOTE] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_async] = ACTIONS(3222),
    [anon_sym_function] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_using] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_SLASH] = ACTIONS(3222),
    [anon_sym_LT] = ACTIONS(3222),
    [anon_sym_TILDE] = ACTIONS(3222),
    [anon_sym_void] = ACTIONS(3222),
    [anon_sym_delete] = ACTIONS(3222),
    [anon_sym_PLUS_PLUS] = ACTIONS(3222),
    [anon_sym_DASH_DASH] = ACTIONS(3222),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3222),
    [sym_number] = ACTIONS(3222),
    [sym_private_property_identifier] = ACTIONS(3222),
    [sym_this] = ACTIONS(3222),
    [sym_super] = ACTIONS(3222),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [sym_null] = ACTIONS(3222),
    [sym_undefined] = ACTIONS(3222),
    [anon_sym_AT] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_readonly] = ACTIONS(3222),
    [anon_sym_get] = ACTIONS(3222),
    [anon_sym_set] = ACTIONS(3222),
    [anon_sym_declare] = ACTIONS(3222),
    [anon_sym_public] = ACTIONS(3222),
    [anon_sym_private] = ACTIONS(3222),
    [anon_sym_protected] = ACTIONS(3222),
    [anon_sym_override] = ACTIONS(3222),
    [anon_sym_module] = ACTIONS(3222),
    [anon_sym_any] = ACTIONS(3222),
    [anon_sym_number] = ACTIONS(3222),
    [anon_sym_boolean] = ACTIONS(3222),
    [anon_sym_string] = ACTIONS(3222),
    [anon_sym_symbol] = ACTIONS(3222),
    [anon_sym_object] = ACTIONS(3222),
    [anon_sym_abstract] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [sym_html_comment] = ACTIONS(5),
  },
  [1408] = {
    [sym_comment] = STATE(1408),
    [ts_builtin_sym_end] = ACTIONS(3542),
    [sym_identifier] = ACTIONS(3290),
    [anon_sym_export] = ACTIONS(3290),
    [anon_sym_type] = ACTIONS(3290),
    [anon_sym_namespace] = ACTIONS(3290),
    [anon_sym_LBRACE] = ACTIONS(3290),
    [anon_sym_RBRACE] = ACTIONS(3290),
    [anon_sym_typeof] = ACTIONS(3290),
    [anon_sym_import] = ACTIONS(3290),
    [anon_sym_with] = ACTIONS(3290),
    [anon_sym_var] = ACTIONS(3290),
    [anon_sym_let] = ACTIONS(3290),
    [anon_sym_const] = ACTIONS(3290),
    [anon_sym_BANG] = ACTIONS(3290),
    [anon_sym_else] = ACTIONS(3290),
    [anon_sym_if] = ACTIONS(3290),
    [anon_sym_switch] = ACTIONS(3290),
    [anon_sym_for] = ACTIONS(3290),
    [anon_sym_LPAREN] = ACTIONS(3290),
    [anon_sym_await] = ACTIONS(3290),
    [anon_sym_while] = ACTIONS(3290),
    [anon_sym_do] = ACTIONS(3290),
    [anon_sym_try] = ACTIONS(3290),
    [anon_sym_break] = ACTIONS(3290),
    [anon_sym_continue] = ACTIONS(3290),
    [anon_sym_debugger] = ACTIONS(3290),
    [anon_sym_return] = ACTIONS(3290),
    [anon_sym_throw] = ACTIONS(3290),
    [anon_sym_SEMI] = ACTIONS(3290),
    [anon_sym_yield] = ACTIONS(3290),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_LTtemplate_GT] = ACTIONS(3290),
    [anon_sym_DQUOTE] = ACTIONS(3290),
    [anon_sym_SQUOTE] = ACTIONS(3290),
    [anon_sym_class] = ACTIONS(3290),
    [anon_sym_async] = ACTIONS(3290),
    [anon_sym_function] = ACTIONS(3290),
    [anon_sym_new] = ACTIONS(3290),
    [anon_sym_using] = ACTIONS(3290),
    [anon_sym_PLUS] = ACTIONS(3290),
    [anon_sym_DASH] = ACTIONS(3290),
    [anon_sym_SLASH] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3290),
    [anon_sym_TILDE] = ACTIONS(3290),
    [anon_sym_void] = ACTIONS(3290),
    [anon_sym_delete] = ACTIONS(3290),
    [anon_sym_PLUS_PLUS] = ACTIONS(3290),
    [anon_sym_DASH_DASH] = ACTIONS(3290),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3290),
    [sym_number] = ACTIONS(3290),
    [sym_private_property_identifier] = ACTIONS(3290),
    [sym_this] = ACTIONS(3290),
    [sym_super] = ACTIONS(3290),
    [sym_true] = ACTIONS(3290),
    [sym_false] = ACTIONS(3290),
    [sym_null] = ACTIONS(3290),
    [sym_undefined] = ACTIONS(3290),
    [anon_sym_AT] = ACTIONS(3290),
    [anon_sym_static] = ACTIONS(3290),
    [anon_sym_readonly] = ACTIONS(3290),
    [anon_sym_get] = ACTIONS(3290),
    [anon_sym_set] = ACTIONS(3290),
    [anon_sym_declare] = ACTIONS(3290),
    [anon_sym_public] = ACTIONS(3290),
    [anon_sym_private] = ACTIONS(3290),
    [anon_sym_protected] = ACTIONS(3290),
    [anon_sym_override] = ACTIONS(3290),
    [anon_sym_module] = ACTIONS(3290),
    [anon_sym_any] = ACTIONS(3290),
    [anon_sym_number] = ACTIONS(3290),
    [anon_sym_boolean] = ACTIONS(3290),
    [anon_sym_string] = ACTIONS(3290),
    [anon_sym_symbol] = ACTIONS(3290),
    [anon_sym_object] = ACTIONS(3290),
    [anon_sym_abstract] = ACTIONS(3290),
    [anon_sym_interface] = ACTIONS(3290),
    [anon_sym_enum] = ACTIONS(3290),
    [sym_html_comment] = ACTIONS(5),
  },
  [1409] = {
    [sym_comment] = STATE(1409),
    [ts_builtin_sym_end] = ACTIONS(3544),
    [sym_identifier] = ACTIONS(3142),
    [anon_sym_export] = ACTIONS(3142),
    [anon_sym_type] = ACTIONS(3142),
    [anon_sym_namespace] = ACTIONS(3142),
    [anon_sym_LBRACE] = ACTIONS(3142),
    [anon_sym_RBRACE] = ACTIONS(3142),
    [anon_sym_typeof] = ACTIONS(3142),
    [anon_sym_import] = ACTIONS(3142),
    [anon_sym_with] = ACTIONS(3142),
    [anon_sym_var] = ACTIONS(3142),
    [anon_sym_let] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_BANG] = ACTIONS(3142),
    [anon_sym_else] = ACTIONS(3142),
    [anon_sym_if] = ACTIONS(3142),
    [anon_sym_switch] = ACTIONS(3142),
    [anon_sym_for] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(3142),
    [anon_sym_await] = ACTIONS(3142),
    [anon_sym_while] = ACTIONS(3142),
    [anon_sym_do] = ACTIONS(3142),
    [anon_sym_try] = ACTIONS(3142),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3142),
    [anon_sym_debugger] = ACTIONS(3142),
    [anon_sym_return] = ACTIONS(3142),
    [anon_sym_throw] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3142),
    [anon_sym_yield] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_LTtemplate_GT] = ACTIONS(3142),
    [anon_sym_DQUOTE] = ACTIONS(3142),
    [anon_sym_SQUOTE] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_async] = ACTIONS(3142),
    [anon_sym_function] = ACTIONS(3142),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_using] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_SLASH] = ACTIONS(3142),
    [anon_sym_LT] = ACTIONS(3142),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_void] = ACTIONS(3142),
    [anon_sym_delete] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3142),
    [sym_number] = ACTIONS(3142),
    [sym_private_property_identifier] = ACTIONS(3142),
    [sym_this] = ACTIONS(3142),
    [sym_super] = ACTIONS(3142),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [sym_null] = ACTIONS(3142),
    [sym_undefined] = ACTIONS(3142),
    [anon_sym_AT] = ACTIONS(3142),
    [anon_sym_static] = ACTIONS(3142),
    [anon_sym_readonly] = ACTIONS(3142),
    [anon_sym_get] = ACTIONS(3142),
    [anon_sym_set] = ACTIONS(3142),
    [anon_sym_declare] = ACTIONS(3142),
    [anon_sym_public] = ACTIONS(3142),
    [anon_sym_private] = ACTIONS(3142),
    [anon_sym_protected] = ACTIONS(3142),
    [anon_sym_override] = ACTIONS(3142),
    [anon_sym_module] = ACTIONS(3142),
    [anon_sym_any] = ACTIONS(3142),
    [anon_sym_number] = ACTIONS(3142),
    [anon_sym_boolean] = ACTIONS(3142),
    [anon_sym_string] = ACTIONS(3142),
    [anon_sym_symbol] = ACTIONS(3142),
    [anon_sym_object] = ACTIONS(3142),
    [anon_sym_abstract] = ACTIONS(3142),
    [anon_sym_interface] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [sym_html_comment] = ACTIONS(5),
  },
  [1410] = {
    [sym_comment] = STATE(1410),
    [ts_builtin_sym_end] = ACTIONS(3546),
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_export] = ACTIONS(3338),
    [anon_sym_type] = ACTIONS(3338),
    [anon_sym_namespace] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_typeof] = ACTIONS(3338),
    [anon_sym_import] = ACTIONS(3338),
    [anon_sym_with] = ACTIONS(3338),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_else] = ACTIONS(3338),
    [anon_sym_if] = ACTIONS(3338),
    [anon_sym_switch] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3338),
    [anon_sym_await] = ACTIONS(3338),
    [anon_sym_while] = ACTIONS(3338),
    [anon_sym_do] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3338),
    [anon_sym_break] = ACTIONS(3338),
    [anon_sym_continue] = ACTIONS(3338),
    [anon_sym_debugger] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3338),
    [anon_sym_throw] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_LTtemplate_GT] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_class] = ACTIONS(3338),
    [anon_sym_async] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3338),
    [anon_sym_using] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3338),
    [anon_sym_delete] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3338),
    [sym_number] = ACTIONS(3338),
    [sym_private_property_identifier] = ACTIONS(3338),
    [sym_this] = ACTIONS(3338),
    [sym_super] = ACTIONS(3338),
    [sym_true] = ACTIONS(3338),
    [sym_false] = ACTIONS(3338),
    [sym_null] = ACTIONS(3338),
    [sym_undefined] = ACTIONS(3338),
    [anon_sym_AT] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_readonly] = ACTIONS(3338),
    [anon_sym_get] = ACTIONS(3338),
    [anon_sym_set] = ACTIONS(3338),
    [anon_sym_declare] = ACTIONS(3338),
    [anon_sym_public] = ACTIONS(3338),
    [anon_sym_private] = ACTIONS(3338),
    [anon_sym_protected] = ACTIONS(3338),
    [anon_sym_override] = ACTIONS(3338),
    [anon_sym_module] = ACTIONS(3338),
    [anon_sym_any] = ACTIONS(3338),
    [anon_sym_number] = ACTIONS(3338),
    [anon_sym_boolean] = ACTIONS(3338),
    [anon_sym_string] = ACTIONS(3338),
    [anon_sym_symbol] = ACTIONS(3338),
    [anon_sym_object] = ACTIONS(3338),
    [anon_sym_abstract] = ACTIONS(3338),
    [anon_sym_interface] = ACTIONS(3338),
    [anon_sym_enum] = ACTIONS(3338),
    [sym_html_comment] = ACTIONS(5),
  },
  [1411] = {
    [sym_comment] = STATE(1411),
    [ts_builtin_sym_end] = ACTIONS(3548),
    [sym_identifier] = ACTIONS(3284),
    [anon_sym_export] = ACTIONS(3284),
    [anon_sym_type] = ACTIONS(3284),
    [anon_sym_namespace] = ACTIONS(3284),
    [anon_sym_LBRACE] = ACTIONS(3284),
    [anon_sym_RBRACE] = ACTIONS(3284),
    [anon_sym_typeof] = ACTIONS(3284),
    [anon_sym_import] = ACTIONS(3284),
    [anon_sym_with] = ACTIONS(3284),
    [anon_sym_var] = ACTIONS(3284),
    [anon_sym_let] = ACTIONS(3284),
    [anon_sym_const] = ACTIONS(3284),
    [anon_sym_BANG] = ACTIONS(3284),
    [anon_sym_else] = ACTIONS(3284),
    [anon_sym_if] = ACTIONS(3284),
    [anon_sym_switch] = ACTIONS(3284),
    [anon_sym_for] = ACTIONS(3284),
    [anon_sym_LPAREN] = ACTIONS(3284),
    [anon_sym_await] = ACTIONS(3284),
    [anon_sym_while] = ACTIONS(3284),
    [anon_sym_do] = ACTIONS(3284),
    [anon_sym_try] = ACTIONS(3284),
    [anon_sym_break] = ACTIONS(3284),
    [anon_sym_continue] = ACTIONS(3284),
    [anon_sym_debugger] = ACTIONS(3284),
    [anon_sym_return] = ACTIONS(3284),
    [anon_sym_throw] = ACTIONS(3284),
    [anon_sym_SEMI] = ACTIONS(3284),
    [anon_sym_yield] = ACTIONS(3284),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [anon_sym_LTtemplate_GT] = ACTIONS(3284),
    [anon_sym_DQUOTE] = ACTIONS(3284),
    [anon_sym_SQUOTE] = ACTIONS(3284),
    [anon_sym_class] = ACTIONS(3284),
    [anon_sym_async] = ACTIONS(3284),
    [anon_sym_function] = ACTIONS(3284),
    [anon_sym_new] = ACTIONS(3284),
    [anon_sym_using] = ACTIONS(3284),
    [anon_sym_PLUS] = ACTIONS(3284),
    [anon_sym_DASH] = ACTIONS(3284),
    [anon_sym_SLASH] = ACTIONS(3284),
    [anon_sym_LT] = ACTIONS(3284),
    [anon_sym_TILDE] = ACTIONS(3284),
    [anon_sym_void] = ACTIONS(3284),
    [anon_sym_delete] = ACTIONS(3284),
    [anon_sym_PLUS_PLUS] = ACTIONS(3284),
    [anon_sym_DASH_DASH] = ACTIONS(3284),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3284),
    [sym_number] = ACTIONS(3284),
    [sym_private_property_identifier] = ACTIONS(3284),
    [sym_this] = ACTIONS(3284),
    [sym_super] = ACTIONS(3284),
    [sym_true] = ACTIONS(3284),
    [sym_false] = ACTIONS(3284),
    [sym_null] = ACTIONS(3284),
    [sym_undefined] = ACTIONS(3284),
    [anon_sym_AT] = ACTIONS(3284),
    [anon_sym_static] = ACTIONS(3284),
    [anon_sym_readonly] = ACTIONS(3284),
    [anon_sym_get] = ACTIONS(3284),
    [anon_sym_set] = ACTIONS(3284),
    [anon_sym_declare] = ACTIONS(3284),
    [anon_sym_public] = ACTIONS(3284),
    [anon_sym_private] = ACTIONS(3284),
    [anon_sym_protected] = ACTIONS(3284),
    [anon_sym_override] = ACTIONS(3284),
    [anon_sym_module] = ACTIONS(3284),
    [anon_sym_any] = ACTIONS(3284),
    [anon_sym_number] = ACTIONS(3284),
    [anon_sym_boolean] = ACTIONS(3284),
    [anon_sym_string] = ACTIONS(3284),
    [anon_sym_symbol] = ACTIONS(3284),
    [anon_sym_object] = ACTIONS(3284),
    [anon_sym_abstract] = ACTIONS(3284),
    [anon_sym_interface] = ACTIONS(3284),
    [anon_sym_enum] = ACTIONS(3284),
    [sym_html_comment] = ACTIONS(5),
  },
  [1412] = {
    [sym_comment] = STATE(1412),
    [ts_builtin_sym_end] = ACTIONS(3550),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_export] = ACTIONS(3340),
    [anon_sym_type] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3340),
    [anon_sym_typeof] = ACTIONS(3340),
    [anon_sym_import] = ACTIONS(3340),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_var] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_BANG] = ACTIONS(3340),
    [anon_sym_else] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_await] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_debugger] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_throw] = ACTIONS(3340),
    [anon_sym_SEMI] = ACTIONS(3340),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LTtemplate_GT] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_SQUOTE] = ACTIONS(3340),
    [anon_sym_class] = ACTIONS(3340),
    [anon_sym_async] = ACTIONS(3340),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_SLASH] = ACTIONS(3340),
    [anon_sym_LT] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3340),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_delete] = ACTIONS(3340),
    [anon_sym_PLUS_PLUS] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3340),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3340),
    [sym_number] = ACTIONS(3340),
    [sym_private_property_identifier] = ACTIONS(3340),
    [sym_this] = ACTIONS(3340),
    [sym_super] = ACTIONS(3340),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [sym_null] = ACTIONS(3340),
    [sym_undefined] = ACTIONS(3340),
    [anon_sym_AT] = ACTIONS(3340),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_readonly] = ACTIONS(3340),
    [anon_sym_get] = ACTIONS(3340),
    [anon_sym_set] = ACTIONS(3340),
    [anon_sym_declare] = ACTIONS(3340),
    [anon_sym_public] = ACTIONS(3340),
    [anon_sym_private] = ACTIONS(3340),
    [anon_sym_protected] = ACTIONS(3340),
    [anon_sym_override] = ACTIONS(3340),
    [anon_sym_module] = ACTIONS(3340),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_object] = ACTIONS(3340),
    [anon_sym_abstract] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [sym_html_comment] = ACTIONS(5),
  },
  [1413] = {
    [sym_comment] = STATE(1413),
    [ts_builtin_sym_end] = ACTIONS(3552),
    [sym_identifier] = ACTIONS(3342),
    [anon_sym_export] = ACTIONS(3342),
    [anon_sym_type] = ACTIONS(3342),
    [anon_sym_namespace] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_typeof] = ACTIONS(3342),
    [anon_sym_import] = ACTIONS(3342),
    [anon_sym_with] = ACTIONS(3342),
    [anon_sym_var] = ACTIONS(3342),
    [anon_sym_let] = ACTIONS(3342),
    [anon_sym_const] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_else] = ACTIONS(3342),
    [anon_sym_if] = ACTIONS(3342),
    [anon_sym_switch] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3342),
    [anon_sym_await] = ACTIONS(3342),
    [anon_sym_while] = ACTIONS(3342),
    [anon_sym_do] = ACTIONS(3342),
    [anon_sym_try] = ACTIONS(3342),
    [anon_sym_break] = ACTIONS(3342),
    [anon_sym_continue] = ACTIONS(3342),
    [anon_sym_debugger] = ACTIONS(3342),
    [anon_sym_return] = ACTIONS(3342),
    [anon_sym_throw] = ACTIONS(3342),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3342),
    [anon_sym_LBRACK] = ACTIONS(3342),
    [anon_sym_LTtemplate_GT] = ACTIONS(3342),
    [anon_sym_DQUOTE] = ACTIONS(3342),
    [anon_sym_SQUOTE] = ACTIONS(3342),
    [anon_sym_class] = ACTIONS(3342),
    [anon_sym_async] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3342),
    [anon_sym_using] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_SLASH] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_void] = ACTIONS(3342),
    [anon_sym_delete] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3342),
    [sym_number] = ACTIONS(3342),
    [sym_private_property_identifier] = ACTIONS(3342),
    [sym_this] = ACTIONS(3342),
    [sym_super] = ACTIONS(3342),
    [sym_true] = ACTIONS(3342),
    [sym_false] = ACTIONS(3342),
    [sym_null] = ACTIONS(3342),
    [sym_undefined] = ACTIONS(3342),
    [anon_sym_AT] = ACTIONS(3342),
    [anon_sym_static] = ACTIONS(3342),
    [anon_sym_readonly] = ACTIONS(3342),
    [anon_sym_get] = ACTIONS(3342),
    [anon_sym_set] = ACTIONS(3342),
    [anon_sym_declare] = ACTIONS(3342),
    [anon_sym_public] = ACTIONS(3342),
    [anon_sym_private] = ACTIONS(3342),
    [anon_sym_protected] = ACTIONS(3342),
    [anon_sym_override] = ACTIONS(3342),
    [anon_sym_module] = ACTIONS(3342),
    [anon_sym_any] = ACTIONS(3342),
    [anon_sym_number] = ACTIONS(3342),
    [anon_sym_boolean] = ACTIONS(3342),
    [anon_sym_string] = ACTIONS(3342),
    [anon_sym_symbol] = ACTIONS(3342),
    [anon_sym_object] = ACTIONS(3342),
    [anon_sym_abstract] = ACTIONS(3342),
    [anon_sym_interface] = ACTIONS(3342),
    [anon_sym_enum] = ACTIONS(3342),
    [sym_html_comment] = ACTIONS(5),
  },
  [1414] = {
    [sym_comment] = STATE(1414),
    [sym_identifier] = ACTIONS(3136),
    [anon_sym_export] = ACTIONS(3136),
    [anon_sym_default] = ACTIONS(3136),
    [anon_sym_type] = ACTIONS(3136),
    [anon_sym_namespace] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_RBRACE] = ACTIONS(3136),
    [anon_sym_typeof] = ACTIONS(3136),
    [anon_sym_import] = ACTIONS(3136),
    [anon_sym_with] = ACTIONS(3136),
    [anon_sym_var] = ACTIONS(3136),
    [anon_sym_let] = ACTIONS(3136),
    [anon_sym_const] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_switch] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_LPAREN] = ACTIONS(3136),
    [anon_sym_await] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_do] = ACTIONS(3136),
    [anon_sym_try] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_continue] = ACTIONS(3136),
    [anon_sym_debugger] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_throw] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym_case] = ACTIONS(3136),
    [anon_sym_yield] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3136),
    [anon_sym_LTtemplate_GT] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(3136),
    [anon_sym_SQUOTE] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_async] = ACTIONS(3136),
    [anon_sym_function] = ACTIONS(3136),
    [anon_sym_new] = ACTIONS(3136),
    [anon_sym_using] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3136),
    [anon_sym_SLASH] = ACTIONS(3136),
    [anon_sym_LT] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_void] = ACTIONS(3136),
    [anon_sym_delete] = ACTIONS(3136),
    [anon_sym_PLUS_PLUS] = ACTIONS(3136),
    [anon_sym_DASH_DASH] = ACTIONS(3136),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3136),
    [sym_number] = ACTIONS(3136),
    [sym_private_property_identifier] = ACTIONS(3136),
    [sym_this] = ACTIONS(3136),
    [sym_super] = ACTIONS(3136),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [sym_null] = ACTIONS(3136),
    [sym_undefined] = ACTIONS(3136),
    [anon_sym_AT] = ACTIONS(3136),
    [anon_sym_static] = ACTIONS(3136),
    [anon_sym_readonly] = ACTIONS(3136),
    [anon_sym_get] = ACTIONS(3136),
    [anon_sym_set] = ACTIONS(3136),
    [anon_sym_declare] = ACTIONS(3136),
    [anon_sym_public] = ACTIONS(3136),
    [anon_sym_private] = ACTIONS(3136),
    [anon_sym_protected] = ACTIONS(3136),
    [anon_sym_override] = ACTIONS(3136),
    [anon_sym_module] = ACTIONS(3136),
    [anon_sym_any] = ACTIONS(3136),
    [anon_sym_number] = ACTIONS(3136),
    [anon_sym_boolean] = ACTIONS(3136),
    [anon_sym_string] = ACTIONS(3136),
    [anon_sym_symbol] = ACTIONS(3136),
    [anon_sym_object] = ACTIONS(3136),
    [anon_sym_abstract] = ACTIONS(3136),
    [anon_sym_interface] = ACTIONS(3136),
    [anon_sym_enum] = ACTIONS(3136),
    [sym_html_comment] = ACTIONS(5),
  },
  [1415] = {
    [sym_comment] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(3554),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_export] = ACTIONS(3344),
    [anon_sym_type] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_RBRACE] = ACTIONS(3344),
    [anon_sym_typeof] = ACTIONS(3344),
    [anon_sym_import] = ACTIONS(3344),
    [anon_sym_with] = ACTIONS(3344),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_await] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_debugger] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3344),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LTtemplate_GT] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_SQUOTE] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_async] = ACTIONS(3344),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_SLASH] = ACTIONS(3344),
    [anon_sym_LT] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_void] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_PLUS_PLUS] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3344),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3344),
    [sym_number] = ACTIONS(3344),
    [sym_private_property_identifier] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [sym_super] = ACTIONS(3344),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [sym_null] = ACTIONS(3344),
    [sym_undefined] = ACTIONS(3344),
    [anon_sym_AT] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_readonly] = ACTIONS(3344),
    [anon_sym_get] = ACTIONS(3344),
    [anon_sym_set] = ACTIONS(3344),
    [anon_sym_declare] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_override] = ACTIONS(3344),
    [anon_sym_module] = ACTIONS(3344),
    [anon_sym_any] = ACTIONS(3344),
    [anon_sym_number] = ACTIONS(3344),
    [anon_sym_boolean] = ACTIONS(3344),
    [anon_sym_string] = ACTIONS(3344),
    [anon_sym_symbol] = ACTIONS(3344),
    [anon_sym_object] = ACTIONS(3344),
    [anon_sym_abstract] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1416] = {
    [sym_comment] = STATE(1416),
    [ts_builtin_sym_end] = ACTIONS(3556),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_export] = ACTIONS(3352),
    [anon_sym_type] = ACTIONS(3352),
    [anon_sym_namespace] = ACTIONS(3352),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_RBRACE] = ACTIONS(3352),
    [anon_sym_typeof] = ACTIONS(3352),
    [anon_sym_import] = ACTIONS(3352),
    [anon_sym_with] = ACTIONS(3352),
    [anon_sym_var] = ACTIONS(3352),
    [anon_sym_let] = ACTIONS(3352),
    [anon_sym_const] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_else] = ACTIONS(3352),
    [anon_sym_if] = ACTIONS(3352),
    [anon_sym_switch] = ACTIONS(3352),
    [anon_sym_for] = ACTIONS(3352),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [anon_sym_await] = ACTIONS(3352),
    [anon_sym_while] = ACTIONS(3352),
    [anon_sym_do] = ACTIONS(3352),
    [anon_sym_try] = ACTIONS(3352),
    [anon_sym_break] = ACTIONS(3352),
    [anon_sym_continue] = ACTIONS(3352),
    [anon_sym_debugger] = ACTIONS(3352),
    [anon_sym_return] = ACTIONS(3352),
    [anon_sym_throw] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_yield] = ACTIONS(3352),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_LTtemplate_GT] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [anon_sym_SQUOTE] = ACTIONS(3352),
    [anon_sym_class] = ACTIONS(3352),
    [anon_sym_async] = ACTIONS(3352),
    [anon_sym_function] = ACTIONS(3352),
    [anon_sym_new] = ACTIONS(3352),
    [anon_sym_using] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_SLASH] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_void] = ACTIONS(3352),
    [anon_sym_delete] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [sym_number] = ACTIONS(3352),
    [sym_private_property_identifier] = ACTIONS(3352),
    [sym_this] = ACTIONS(3352),
    [sym_super] = ACTIONS(3352),
    [sym_true] = ACTIONS(3352),
    [sym_false] = ACTIONS(3352),
    [sym_null] = ACTIONS(3352),
    [sym_undefined] = ACTIONS(3352),
    [anon_sym_AT] = ACTIONS(3352),
    [anon_sym_static] = ACTIONS(3352),
    [anon_sym_readonly] = ACTIONS(3352),
    [anon_sym_get] = ACTIONS(3352),
    [anon_sym_set] = ACTIONS(3352),
    [anon_sym_declare] = ACTIONS(3352),
    [anon_sym_public] = ACTIONS(3352),
    [anon_sym_private] = ACTIONS(3352),
    [anon_sym_protected] = ACTIONS(3352),
    [anon_sym_override] = ACTIONS(3352),
    [anon_sym_module] = ACTIONS(3352),
    [anon_sym_any] = ACTIONS(3352),
    [anon_sym_number] = ACTIONS(3352),
    [anon_sym_boolean] = ACTIONS(3352),
    [anon_sym_string] = ACTIONS(3352),
    [anon_sym_symbol] = ACTIONS(3352),
    [anon_sym_object] = ACTIONS(3352),
    [anon_sym_abstract] = ACTIONS(3352),
    [anon_sym_interface] = ACTIONS(3352),
    [anon_sym_enum] = ACTIONS(3352),
    [sym_html_comment] = ACTIONS(5),
  },
  [1417] = {
    [sym_comment] = STATE(1417),
    [ts_builtin_sym_end] = ACTIONS(3558),
    [sym_identifier] = ACTIONS(3364),
    [anon_sym_export] = ACTIONS(3364),
    [anon_sym_type] = ACTIONS(3364),
    [anon_sym_namespace] = ACTIONS(3364),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_RBRACE] = ACTIONS(3364),
    [anon_sym_typeof] = ACTIONS(3364),
    [anon_sym_import] = ACTIONS(3364),
    [anon_sym_with] = ACTIONS(3364),
    [anon_sym_var] = ACTIONS(3364),
    [anon_sym_let] = ACTIONS(3364),
    [anon_sym_const] = ACTIONS(3364),
    [anon_sym_BANG] = ACTIONS(3364),
    [anon_sym_else] = ACTIONS(3364),
    [anon_sym_if] = ACTIONS(3364),
    [anon_sym_switch] = ACTIONS(3364),
    [anon_sym_for] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(3364),
    [anon_sym_await] = ACTIONS(3364),
    [anon_sym_while] = ACTIONS(3364),
    [anon_sym_do] = ACTIONS(3364),
    [anon_sym_try] = ACTIONS(3364),
    [anon_sym_break] = ACTIONS(3364),
    [anon_sym_continue] = ACTIONS(3364),
    [anon_sym_debugger] = ACTIONS(3364),
    [anon_sym_return] = ACTIONS(3364),
    [anon_sym_throw] = ACTIONS(3364),
    [anon_sym_SEMI] = ACTIONS(3364),
    [anon_sym_yield] = ACTIONS(3364),
    [anon_sym_LBRACK] = ACTIONS(3364),
    [anon_sym_LTtemplate_GT] = ACTIONS(3364),
    [anon_sym_DQUOTE] = ACTIONS(3364),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym_class] = ACTIONS(3364),
    [anon_sym_async] = ACTIONS(3364),
    [anon_sym_function] = ACTIONS(3364),
    [anon_sym_new] = ACTIONS(3364),
    [anon_sym_using] = ACTIONS(3364),
    [anon_sym_PLUS] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3364),
    [anon_sym_SLASH] = ACTIONS(3364),
    [anon_sym_LT] = ACTIONS(3364),
    [anon_sym_TILDE] = ACTIONS(3364),
    [anon_sym_void] = ACTIONS(3364),
    [anon_sym_delete] = ACTIONS(3364),
    [anon_sym_PLUS_PLUS] = ACTIONS(3364),
    [anon_sym_DASH_DASH] = ACTIONS(3364),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3364),
    [sym_number] = ACTIONS(3364),
    [sym_private_property_identifier] = ACTIONS(3364),
    [sym_this] = ACTIONS(3364),
    [sym_super] = ACTIONS(3364),
    [sym_true] = ACTIONS(3364),
    [sym_false] = ACTIONS(3364),
    [sym_null] = ACTIONS(3364),
    [sym_undefined] = ACTIONS(3364),
    [anon_sym_AT] = ACTIONS(3364),
    [anon_sym_static] = ACTIONS(3364),
    [anon_sym_readonly] = ACTIONS(3364),
    [anon_sym_get] = ACTIONS(3364),
    [anon_sym_set] = ACTIONS(3364),
    [anon_sym_declare] = ACTIONS(3364),
    [anon_sym_public] = ACTIONS(3364),
    [anon_sym_private] = ACTIONS(3364),
    [anon_sym_protected] = ACTIONS(3364),
    [anon_sym_override] = ACTIONS(3364),
    [anon_sym_module] = ACTIONS(3364),
    [anon_sym_any] = ACTIONS(3364),
    [anon_sym_number] = ACTIONS(3364),
    [anon_sym_boolean] = ACTIONS(3364),
    [anon_sym_string] = ACTIONS(3364),
    [anon_sym_symbol] = ACTIONS(3364),
    [anon_sym_object] = ACTIONS(3364),
    [anon_sym_abstract] = ACTIONS(3364),
    [anon_sym_interface] = ACTIONS(3364),
    [anon_sym_enum] = ACTIONS(3364),
    [sym_html_comment] = ACTIONS(5),
  },
  [1418] = {
    [sym_comment] = STATE(1418),
    [ts_builtin_sym_end] = ACTIONS(3560),
    [sym_identifier] = ACTIONS(3370),
    [anon_sym_export] = ACTIONS(3370),
    [anon_sym_type] = ACTIONS(3370),
    [anon_sym_namespace] = ACTIONS(3370),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_typeof] = ACTIONS(3370),
    [anon_sym_import] = ACTIONS(3370),
    [anon_sym_with] = ACTIONS(3370),
    [anon_sym_var] = ACTIONS(3370),
    [anon_sym_let] = ACTIONS(3370),
    [anon_sym_const] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_else] = ACTIONS(3370),
    [anon_sym_if] = ACTIONS(3370),
    [anon_sym_switch] = ACTIONS(3370),
    [anon_sym_for] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_await] = ACTIONS(3370),
    [anon_sym_while] = ACTIONS(3370),
    [anon_sym_do] = ACTIONS(3370),
    [anon_sym_try] = ACTIONS(3370),
    [anon_sym_break] = ACTIONS(3370),
    [anon_sym_continue] = ACTIONS(3370),
    [anon_sym_debugger] = ACTIONS(3370),
    [anon_sym_return] = ACTIONS(3370),
    [anon_sym_throw] = ACTIONS(3370),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym_yield] = ACTIONS(3370),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_LTtemplate_GT] = ACTIONS(3370),
    [anon_sym_DQUOTE] = ACTIONS(3370),
    [anon_sym_SQUOTE] = ACTIONS(3370),
    [anon_sym_class] = ACTIONS(3370),
    [anon_sym_async] = ACTIONS(3370),
    [anon_sym_function] = ACTIONS(3370),
    [anon_sym_new] = ACTIONS(3370),
    [anon_sym_using] = ACTIONS(3370),
    [anon_sym_PLUS] = ACTIONS(3370),
    [anon_sym_DASH] = ACTIONS(3370),
    [anon_sym_SLASH] = ACTIONS(3370),
    [anon_sym_LT] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_void] = ACTIONS(3370),
    [anon_sym_delete] = ACTIONS(3370),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3370),
    [sym_number] = ACTIONS(3370),
    [sym_private_property_identifier] = ACTIONS(3370),
    [sym_this] = ACTIONS(3370),
    [sym_super] = ACTIONS(3370),
    [sym_true] = ACTIONS(3370),
    [sym_false] = ACTIONS(3370),
    [sym_null] = ACTIONS(3370),
    [sym_undefined] = ACTIONS(3370),
    [anon_sym_AT] = ACTIONS(3370),
    [anon_sym_static] = ACTIONS(3370),
    [anon_sym_readonly] = ACTIONS(3370),
    [anon_sym_get] = ACTIONS(3370),
    [anon_sym_set] = ACTIONS(3370),
    [anon_sym_declare] = ACTIONS(3370),
    [anon_sym_public] = ACTIONS(3370),
    [anon_sym_private] = ACTIONS(3370),
    [anon_sym_protected] = ACTIONS(3370),
    [anon_sym_override] = ACTIONS(3370),
    [anon_sym_module] = ACTIONS(3370),
    [anon_sym_any] = ACTIONS(3370),
    [anon_sym_number] = ACTIONS(3370),
    [anon_sym_boolean] = ACTIONS(3370),
    [anon_sym_string] = ACTIONS(3370),
    [anon_sym_symbol] = ACTIONS(3370),
    [anon_sym_object] = ACTIONS(3370),
    [anon_sym_abstract] = ACTIONS(3370),
    [anon_sym_interface] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3370),
    [sym_html_comment] = ACTIONS(5),
  },
  [1419] = {
    [sym_comment] = STATE(1419),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1420] = {
    [sym_comment] = STATE(1420),
    [ts_builtin_sym_end] = ACTIONS(3562),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_export] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_namespace] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_RBRACE] = ACTIONS(3304),
    [anon_sym_typeof] = ACTIONS(3304),
    [anon_sym_import] = ACTIONS(3304),
    [anon_sym_with] = ACTIONS(3304),
    [anon_sym_var] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_const] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_else] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_switch] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_await] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_debugger] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_throw] = ACTIONS(3304),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LTtemplate_GT] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_class] = ACTIONS(3304),
    [anon_sym_async] = ACTIONS(3304),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_using] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_void] = ACTIONS(3304),
    [anon_sym_delete] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3304),
    [sym_number] = ACTIONS(3304),
    [sym_private_property_identifier] = ACTIONS(3304),
    [sym_this] = ACTIONS(3304),
    [sym_super] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_null] = ACTIONS(3304),
    [sym_undefined] = ACTIONS(3304),
    [anon_sym_AT] = ACTIONS(3304),
    [anon_sym_static] = ACTIONS(3304),
    [anon_sym_readonly] = ACTIONS(3304),
    [anon_sym_get] = ACTIONS(3304),
    [anon_sym_set] = ACTIONS(3304),
    [anon_sym_declare] = ACTIONS(3304),
    [anon_sym_public] = ACTIONS(3304),
    [anon_sym_private] = ACTIONS(3304),
    [anon_sym_protected] = ACTIONS(3304),
    [anon_sym_override] = ACTIONS(3304),
    [anon_sym_module] = ACTIONS(3304),
    [anon_sym_any] = ACTIONS(3304),
    [anon_sym_number] = ACTIONS(3304),
    [anon_sym_boolean] = ACTIONS(3304),
    [anon_sym_string] = ACTIONS(3304),
    [anon_sym_symbol] = ACTIONS(3304),
    [anon_sym_object] = ACTIONS(3304),
    [anon_sym_abstract] = ACTIONS(3304),
    [anon_sym_interface] = ACTIONS(3304),
    [anon_sym_enum] = ACTIONS(3304),
    [sym_html_comment] = ACTIONS(5),
  },
  [1421] = {
    [sym_comment] = STATE(1421),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_else] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1422] = {
    [sym_comment] = STATE(1422),
    [sym_identifier] = ACTIONS(3254),
    [anon_sym_export] = ACTIONS(3254),
    [anon_sym_default] = ACTIONS(3254),
    [anon_sym_type] = ACTIONS(3254),
    [anon_sym_namespace] = ACTIONS(3254),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_RBRACE] = ACTIONS(3254),
    [anon_sym_typeof] = ACTIONS(3254),
    [anon_sym_import] = ACTIONS(3254),
    [anon_sym_with] = ACTIONS(3254),
    [anon_sym_var] = ACTIONS(3254),
    [anon_sym_let] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_BANG] = ACTIONS(3254),
    [anon_sym_if] = ACTIONS(3254),
    [anon_sym_switch] = ACTIONS(3254),
    [anon_sym_for] = ACTIONS(3254),
    [anon_sym_LPAREN] = ACTIONS(3254),
    [anon_sym_await] = ACTIONS(3254),
    [anon_sym_while] = ACTIONS(3254),
    [anon_sym_do] = ACTIONS(3254),
    [anon_sym_try] = ACTIONS(3254),
    [anon_sym_break] = ACTIONS(3254),
    [anon_sym_continue] = ACTIONS(3254),
    [anon_sym_debugger] = ACTIONS(3254),
    [anon_sym_return] = ACTIONS(3254),
    [anon_sym_throw] = ACTIONS(3254),
    [anon_sym_SEMI] = ACTIONS(3254),
    [anon_sym_case] = ACTIONS(3254),
    [anon_sym_yield] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_LTtemplate_GT] = ACTIONS(3254),
    [anon_sym_DQUOTE] = ACTIONS(3254),
    [anon_sym_SQUOTE] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_async] = ACTIONS(3254),
    [anon_sym_function] = ACTIONS(3254),
    [anon_sym_new] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_PLUS] = ACTIONS(3254),
    [anon_sym_DASH] = ACTIONS(3254),
    [anon_sym_SLASH] = ACTIONS(3254),
    [anon_sym_LT] = ACTIONS(3254),
    [anon_sym_TILDE] = ACTIONS(3254),
    [anon_sym_void] = ACTIONS(3254),
    [anon_sym_delete] = ACTIONS(3254),
    [anon_sym_PLUS_PLUS] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3254),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3254),
    [sym_number] = ACTIONS(3254),
    [sym_private_property_identifier] = ACTIONS(3254),
    [sym_this] = ACTIONS(3254),
    [sym_super] = ACTIONS(3254),
    [sym_true] = ACTIONS(3254),
    [sym_false] = ACTIONS(3254),
    [sym_null] = ACTIONS(3254),
    [sym_undefined] = ACTIONS(3254),
    [anon_sym_AT] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_readonly] = ACTIONS(3254),
    [anon_sym_get] = ACTIONS(3254),
    [anon_sym_set] = ACTIONS(3254),
    [anon_sym_declare] = ACTIONS(3254),
    [anon_sym_public] = ACTIONS(3254),
    [anon_sym_private] = ACTIONS(3254),
    [anon_sym_protected] = ACTIONS(3254),
    [anon_sym_override] = ACTIONS(3254),
    [anon_sym_module] = ACTIONS(3254),
    [anon_sym_any] = ACTIONS(3254),
    [anon_sym_number] = ACTIONS(3254),
    [anon_sym_boolean] = ACTIONS(3254),
    [anon_sym_string] = ACTIONS(3254),
    [anon_sym_symbol] = ACTIONS(3254),
    [anon_sym_object] = ACTIONS(3254),
    [anon_sym_abstract] = ACTIONS(3254),
    [anon_sym_interface] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [sym_html_comment] = ACTIONS(5),
  },
  [1423] = {
    [sym_comment] = STATE(1423),
    [sym_identifier] = ACTIONS(3140),
    [anon_sym_export] = ACTIONS(3140),
    [anon_sym_default] = ACTIONS(3140),
    [anon_sym_type] = ACTIONS(3140),
    [anon_sym_namespace] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_RBRACE] = ACTIONS(3140),
    [anon_sym_typeof] = ACTIONS(3140),
    [anon_sym_import] = ACTIONS(3140),
    [anon_sym_with] = ACTIONS(3140),
    [anon_sym_var] = ACTIONS(3140),
    [anon_sym_let] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_if] = ACTIONS(3140),
    [anon_sym_switch] = ACTIONS(3140),
    [anon_sym_for] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3140),
    [anon_sym_await] = ACTIONS(3140),
    [anon_sym_while] = ACTIONS(3140),
    [anon_sym_do] = ACTIONS(3140),
    [anon_sym_try] = ACTIONS(3140),
    [anon_sym_break] = ACTIONS(3140),
    [anon_sym_continue] = ACTIONS(3140),
    [anon_sym_debugger] = ACTIONS(3140),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_throw] = ACTIONS(3140),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym_case] = ACTIONS(3140),
    [anon_sym_yield] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(3140),
    [anon_sym_LTtemplate_GT] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3140),
    [anon_sym_async] = ACTIONS(3140),
    [anon_sym_function] = ACTIONS(3140),
    [anon_sym_new] = ACTIONS(3140),
    [anon_sym_using] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3140),
    [anon_sym_SLASH] = ACTIONS(3140),
    [anon_sym_LT] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_void] = ACTIONS(3140),
    [anon_sym_delete] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3140),
    [sym_number] = ACTIONS(3140),
    [sym_private_property_identifier] = ACTIONS(3140),
    [sym_this] = ACTIONS(3140),
    [sym_super] = ACTIONS(3140),
    [sym_true] = ACTIONS(3140),
    [sym_false] = ACTIONS(3140),
    [sym_null] = ACTIONS(3140),
    [sym_undefined] = ACTIONS(3140),
    [anon_sym_AT] = ACTIONS(3140),
    [anon_sym_static] = ACTIONS(3140),
    [anon_sym_readonly] = ACTIONS(3140),
    [anon_sym_get] = ACTIONS(3140),
    [anon_sym_set] = ACTIONS(3140),
    [anon_sym_declare] = ACTIONS(3140),
    [anon_sym_public] = ACTIONS(3140),
    [anon_sym_private] = ACTIONS(3140),
    [anon_sym_protected] = ACTIONS(3140),
    [anon_sym_override] = ACTIONS(3140),
    [anon_sym_module] = ACTIONS(3140),
    [anon_sym_any] = ACTIONS(3140),
    [anon_sym_number] = ACTIONS(3140),
    [anon_sym_boolean] = ACTIONS(3140),
    [anon_sym_string] = ACTIONS(3140),
    [anon_sym_symbol] = ACTIONS(3140),
    [anon_sym_object] = ACTIONS(3140),
    [anon_sym_abstract] = ACTIONS(3140),
    [anon_sym_interface] = ACTIONS(3140),
    [anon_sym_enum] = ACTIONS(3140),
    [sym_html_comment] = ACTIONS(5),
  },
  [1424] = {
    [sym_comment] = STATE(1424),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1425] = {
    [sym_comment] = STATE(1425),
    [sym_identifier] = ACTIONS(3144),
    [anon_sym_export] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_type] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_RBRACE] = ACTIONS(3144),
    [anon_sym_typeof] = ACTIONS(3144),
    [anon_sym_import] = ACTIONS(3144),
    [anon_sym_with] = ACTIONS(3144),
    [anon_sym_var] = ACTIONS(3144),
    [anon_sym_let] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3144),
    [anon_sym_await] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_debugger] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_yield] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_LTtemplate_GT] = ACTIONS(3144),
    [anon_sym_DQUOTE] = ACTIONS(3144),
    [anon_sym_SQUOTE] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_async] = ACTIONS(3144),
    [anon_sym_function] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_SLASH] = ACTIONS(3144),
    [anon_sym_LT] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_void] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3144),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3144),
    [sym_number] = ACTIONS(3144),
    [sym_private_property_identifier] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
    [sym_super] = ACTIONS(3144),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [sym_null] = ACTIONS(3144),
    [sym_undefined] = ACTIONS(3144),
    [anon_sym_AT] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_readonly] = ACTIONS(3144),
    [anon_sym_get] = ACTIONS(3144),
    [anon_sym_set] = ACTIONS(3144),
    [anon_sym_declare] = ACTIONS(3144),
    [anon_sym_public] = ACTIONS(3144),
    [anon_sym_private] = ACTIONS(3144),
    [anon_sym_protected] = ACTIONS(3144),
    [anon_sym_override] = ACTIONS(3144),
    [anon_sym_module] = ACTIONS(3144),
    [anon_sym_any] = ACTIONS(3144),
    [anon_sym_number] = ACTIONS(3144),
    [anon_sym_boolean] = ACTIONS(3144),
    [anon_sym_string] = ACTIONS(3144),
    [anon_sym_symbol] = ACTIONS(3144),
    [anon_sym_object] = ACTIONS(3144),
    [anon_sym_abstract] = ACTIONS(3144),
    [anon_sym_interface] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [sym_html_comment] = ACTIONS(5),
  },
  [1426] = {
    [sym_comment] = STATE(1426),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_export] = ACTIONS(3250),
    [anon_sym_default] = ACTIONS(3250),
    [anon_sym_type] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_typeof] = ACTIONS(3250),
    [anon_sym_import] = ACTIONS(3250),
    [anon_sym_with] = ACTIONS(3250),
    [anon_sym_var] = ACTIONS(3250),
    [anon_sym_let] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym_await] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_debugger] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3250),
    [anon_sym_case] = ACTIONS(3250),
    [anon_sym_yield] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_LTtemplate_GT] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_async] = ACTIONS(3250),
    [anon_sym_function] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3250),
    [anon_sym_LT] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_void] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3250),
    [sym_number] = ACTIONS(3250),
    [sym_private_property_identifier] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
    [sym_super] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_null] = ACTIONS(3250),
    [sym_undefined] = ACTIONS(3250),
    [anon_sym_AT] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_readonly] = ACTIONS(3250),
    [anon_sym_get] = ACTIONS(3250),
    [anon_sym_set] = ACTIONS(3250),
    [anon_sym_declare] = ACTIONS(3250),
    [anon_sym_public] = ACTIONS(3250),
    [anon_sym_private] = ACTIONS(3250),
    [anon_sym_protected] = ACTIONS(3250),
    [anon_sym_override] = ACTIONS(3250),
    [anon_sym_module] = ACTIONS(3250),
    [anon_sym_any] = ACTIONS(3250),
    [anon_sym_number] = ACTIONS(3250),
    [anon_sym_boolean] = ACTIONS(3250),
    [anon_sym_string] = ACTIONS(3250),
    [anon_sym_symbol] = ACTIONS(3250),
    [anon_sym_object] = ACTIONS(3250),
    [anon_sym_abstract] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [sym_html_comment] = ACTIONS(5),
  },
  [1427] = {
    [sym_comment] = STATE(1427),
    [ts_builtin_sym_end] = ACTIONS(3564),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_export] = ACTIONS(3312),
    [anon_sym_type] = ACTIONS(3312),
    [anon_sym_namespace] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_typeof] = ACTIONS(3312),
    [anon_sym_import] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3312),
    [anon_sym_var] = ACTIONS(3312),
    [anon_sym_let] = ACTIONS(3312),
    [anon_sym_const] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_else] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_switch] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym_await] = ACTIONS(3312),
    [anon_sym_while] = ACTIONS(3312),
    [anon_sym_do] = ACTIONS(3312),
    [anon_sym_try] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_debugger] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_throw] = ACTIONS(3312),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3312),
    [anon_sym_LTtemplate_GT] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_class] = ACTIONS(3312),
    [anon_sym_async] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3312),
    [anon_sym_using] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_void] = ACTIONS(3312),
    [anon_sym_delete] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3312),
    [sym_number] = ACTIONS(3312),
    [sym_private_property_identifier] = ACTIONS(3312),
    [sym_this] = ACTIONS(3312),
    [sym_super] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_null] = ACTIONS(3312),
    [sym_undefined] = ACTIONS(3312),
    [anon_sym_AT] = ACTIONS(3312),
    [anon_sym_static] = ACTIONS(3312),
    [anon_sym_readonly] = ACTIONS(3312),
    [anon_sym_get] = ACTIONS(3312),
    [anon_sym_set] = ACTIONS(3312),
    [anon_sym_declare] = ACTIONS(3312),
    [anon_sym_public] = ACTIONS(3312),
    [anon_sym_private] = ACTIONS(3312),
    [anon_sym_protected] = ACTIONS(3312),
    [anon_sym_override] = ACTIONS(3312),
    [anon_sym_module] = ACTIONS(3312),
    [anon_sym_any] = ACTIONS(3312),
    [anon_sym_number] = ACTIONS(3312),
    [anon_sym_boolean] = ACTIONS(3312),
    [anon_sym_string] = ACTIONS(3312),
    [anon_sym_symbol] = ACTIONS(3312),
    [anon_sym_object] = ACTIONS(3312),
    [anon_sym_abstract] = ACTIONS(3312),
    [anon_sym_interface] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(3312),
    [sym_html_comment] = ACTIONS(5),
  },
  [1428] = {
    [sym_comment] = STATE(1428),
    [ts_builtin_sym_end] = ACTIONS(3566),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_export] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_RBRACE] = ACTIONS(3314),
    [anon_sym_typeof] = ACTIONS(3314),
    [anon_sym_import] = ACTIONS(3314),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_var] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_BANG] = ACTIONS(3314),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_await] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_debugger] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3314),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LTtemplate_GT] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_SQUOTE] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_async] = ACTIONS(3314),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_SLASH] = ACTIONS(3314),
    [anon_sym_LT] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3314),
    [anon_sym_void] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_PLUS_PLUS] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3314),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3314),
    [sym_number] = ACTIONS(3314),
    [sym_private_property_identifier] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_undefined] = ACTIONS(3314),
    [anon_sym_AT] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_readonly] = ACTIONS(3314),
    [anon_sym_get] = ACTIONS(3314),
    [anon_sym_set] = ACTIONS(3314),
    [anon_sym_declare] = ACTIONS(3314),
    [anon_sym_public] = ACTIONS(3314),
    [anon_sym_private] = ACTIONS(3314),
    [anon_sym_protected] = ACTIONS(3314),
    [anon_sym_override] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_any] = ACTIONS(3314),
    [anon_sym_number] = ACTIONS(3314),
    [anon_sym_boolean] = ACTIONS(3314),
    [anon_sym_string] = ACTIONS(3314),
    [anon_sym_symbol] = ACTIONS(3314),
    [anon_sym_object] = ACTIONS(3314),
    [anon_sym_abstract] = ACTIONS(3314),
    [anon_sym_interface] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [sym_html_comment] = ACTIONS(5),
  },
  [1429] = {
    [sym_comment] = STATE(1429),
    [ts_builtin_sym_end] = ACTIONS(3568),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_export] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_namespace] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_RBRACE] = ACTIONS(3318),
    [anon_sym_typeof] = ACTIONS(3318),
    [anon_sym_import] = ACTIONS(3318),
    [anon_sym_with] = ACTIONS(3318),
    [anon_sym_var] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_else] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_switch] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_await] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_debugger] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_throw] = ACTIONS(3318),
    [anon_sym_SEMI] = ACTIONS(3318),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LTtemplate_GT] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_SQUOTE] = ACTIONS(3318),
    [anon_sym_class] = ACTIONS(3318),
    [anon_sym_async] = ACTIONS(3318),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_using] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3318),
    [anon_sym_void] = ACTIONS(3318),
    [anon_sym_delete] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3318),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3318),
    [sym_number] = ACTIONS(3318),
    [sym_private_property_identifier] = ACTIONS(3318),
    [sym_this] = ACTIONS(3318),
    [sym_super] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_null] = ACTIONS(3318),
    [sym_undefined] = ACTIONS(3318),
    [anon_sym_AT] = ACTIONS(3318),
    [anon_sym_static] = ACTIONS(3318),
    [anon_sym_readonly] = ACTIONS(3318),
    [anon_sym_get] = ACTIONS(3318),
    [anon_sym_set] = ACTIONS(3318),
    [anon_sym_declare] = ACTIONS(3318),
    [anon_sym_public] = ACTIONS(3318),
    [anon_sym_private] = ACTIONS(3318),
    [anon_sym_protected] = ACTIONS(3318),
    [anon_sym_override] = ACTIONS(3318),
    [anon_sym_module] = ACTIONS(3318),
    [anon_sym_any] = ACTIONS(3318),
    [anon_sym_number] = ACTIONS(3318),
    [anon_sym_boolean] = ACTIONS(3318),
    [anon_sym_string] = ACTIONS(3318),
    [anon_sym_symbol] = ACTIONS(3318),
    [anon_sym_object] = ACTIONS(3318),
    [anon_sym_abstract] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [sym_html_comment] = ACTIONS(5),
  },
  [1430] = {
    [sym_comment] = STATE(1430),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_default] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1431] = {
    [sym_comment] = STATE(1431),
    [sym_identifier] = ACTIONS(3204),
    [anon_sym_export] = ACTIONS(3204),
    [anon_sym_default] = ACTIONS(3204),
    [anon_sym_type] = ACTIONS(3204),
    [anon_sym_namespace] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_typeof] = ACTIONS(3204),
    [anon_sym_import] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3204),
    [anon_sym_var] = ACTIONS(3204),
    [anon_sym_let] = ACTIONS(3204),
    [anon_sym_const] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_switch] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3204),
    [anon_sym_await] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3204),
    [anon_sym_break] = ACTIONS(3204),
    [anon_sym_continue] = ACTIONS(3204),
    [anon_sym_debugger] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3204),
    [anon_sym_throw] = ACTIONS(3204),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_case] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_LTtemplate_GT] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [anon_sym_SQUOTE] = ACTIONS(3204),
    [anon_sym_class] = ACTIONS(3204),
    [anon_sym_async] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3204),
    [anon_sym_using] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3204),
    [anon_sym_DASH] = ACTIONS(3204),
    [anon_sym_SLASH] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [anon_sym_void] = ACTIONS(3204),
    [anon_sym_delete] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3204),
    [anon_sym_DASH_DASH] = ACTIONS(3204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3204),
    [sym_number] = ACTIONS(3204),
    [sym_private_property_identifier] = ACTIONS(3204),
    [sym_this] = ACTIONS(3204),
    [sym_super] = ACTIONS(3204),
    [sym_true] = ACTIONS(3204),
    [sym_false] = ACTIONS(3204),
    [sym_null] = ACTIONS(3204),
    [sym_undefined] = ACTIONS(3204),
    [anon_sym_AT] = ACTIONS(3204),
    [anon_sym_static] = ACTIONS(3204),
    [anon_sym_readonly] = ACTIONS(3204),
    [anon_sym_get] = ACTIONS(3204),
    [anon_sym_set] = ACTIONS(3204),
    [anon_sym_declare] = ACTIONS(3204),
    [anon_sym_public] = ACTIONS(3204),
    [anon_sym_private] = ACTIONS(3204),
    [anon_sym_protected] = ACTIONS(3204),
    [anon_sym_override] = ACTIONS(3204),
    [anon_sym_module] = ACTIONS(3204),
    [anon_sym_any] = ACTIONS(3204),
    [anon_sym_number] = ACTIONS(3204),
    [anon_sym_boolean] = ACTIONS(3204),
    [anon_sym_string] = ACTIONS(3204),
    [anon_sym_symbol] = ACTIONS(3204),
    [anon_sym_object] = ACTIONS(3204),
    [anon_sym_abstract] = ACTIONS(3204),
    [anon_sym_interface] = ACTIONS(3204),
    [anon_sym_enum] = ACTIONS(3204),
    [sym_html_comment] = ACTIONS(5),
  },
  [1432] = {
    [sym_comment] = STATE(1432),
    [ts_builtin_sym_end] = ACTIONS(3570),
    [sym_identifier] = ACTIONS(3236),
    [anon_sym_export] = ACTIONS(3236),
    [anon_sym_type] = ACTIONS(3236),
    [anon_sym_namespace] = ACTIONS(3236),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_RBRACE] = ACTIONS(3236),
    [anon_sym_typeof] = ACTIONS(3236),
    [anon_sym_import] = ACTIONS(3236),
    [anon_sym_with] = ACTIONS(3236),
    [anon_sym_var] = ACTIONS(3236),
    [anon_sym_let] = ACTIONS(3236),
    [anon_sym_const] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_else] = ACTIONS(3236),
    [anon_sym_if] = ACTIONS(3236),
    [anon_sym_switch] = ACTIONS(3236),
    [anon_sym_for] = ACTIONS(3236),
    [anon_sym_LPAREN] = ACTIONS(3236),
    [anon_sym_await] = ACTIONS(3236),
    [anon_sym_while] = ACTIONS(3236),
    [anon_sym_do] = ACTIONS(3236),
    [anon_sym_try] = ACTIONS(3236),
    [anon_sym_break] = ACTIONS(3236),
    [anon_sym_continue] = ACTIONS(3236),
    [anon_sym_debugger] = ACTIONS(3236),
    [anon_sym_return] = ACTIONS(3236),
    [anon_sym_throw] = ACTIONS(3236),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym_yield] = ACTIONS(3236),
    [anon_sym_LBRACK] = ACTIONS(3236),
    [anon_sym_LTtemplate_GT] = ACTIONS(3236),
    [anon_sym_DQUOTE] = ACTIONS(3236),
    [anon_sym_SQUOTE] = ACTIONS(3236),
    [anon_sym_class] = ACTIONS(3236),
    [anon_sym_async] = ACTIONS(3236),
    [anon_sym_function] = ACTIONS(3236),
    [anon_sym_new] = ACTIONS(3236),
    [anon_sym_using] = ACTIONS(3236),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3236),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_void] = ACTIONS(3236),
    [anon_sym_delete] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3236),
    [anon_sym_DASH_DASH] = ACTIONS(3236),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3236),
    [sym_number] = ACTIONS(3236),
    [sym_private_property_identifier] = ACTIONS(3236),
    [sym_this] = ACTIONS(3236),
    [sym_super] = ACTIONS(3236),
    [sym_true] = ACTIONS(3236),
    [sym_false] = ACTIONS(3236),
    [sym_null] = ACTIONS(3236),
    [sym_undefined] = ACTIONS(3236),
    [anon_sym_AT] = ACTIONS(3236),
    [anon_sym_static] = ACTIONS(3236),
    [anon_sym_readonly] = ACTIONS(3236),
    [anon_sym_get] = ACTIONS(3236),
    [anon_sym_set] = ACTIONS(3236),
    [anon_sym_declare] = ACTIONS(3236),
    [anon_sym_public] = ACTIONS(3236),
    [anon_sym_private] = ACTIONS(3236),
    [anon_sym_protected] = ACTIONS(3236),
    [anon_sym_override] = ACTIONS(3236),
    [anon_sym_module] = ACTIONS(3236),
    [anon_sym_any] = ACTIONS(3236),
    [anon_sym_number] = ACTIONS(3236),
    [anon_sym_boolean] = ACTIONS(3236),
    [anon_sym_string] = ACTIONS(3236),
    [anon_sym_symbol] = ACTIONS(3236),
    [anon_sym_object] = ACTIONS(3236),
    [anon_sym_abstract] = ACTIONS(3236),
    [anon_sym_interface] = ACTIONS(3236),
    [anon_sym_enum] = ACTIONS(3236),
    [sym_html_comment] = ACTIONS(5),
  },
  [1433] = {
    [sym_comment] = STATE(1433),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_export] = ACTIONS(3202),
    [anon_sym_default] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_namespace] = ACTIONS(3202),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_RBRACE] = ACTIONS(3202),
    [anon_sym_typeof] = ACTIONS(3202),
    [anon_sym_import] = ACTIONS(3202),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_var] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_const] = ACTIONS(3202),
    [anon_sym_BANG] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_switch] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_await] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_break] = ACTIONS(3202),
    [anon_sym_continue] = ACTIONS(3202),
    [anon_sym_debugger] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_throw] = ACTIONS(3202),
    [anon_sym_SEMI] = ACTIONS(3202),
    [anon_sym_case] = ACTIONS(3202),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LTtemplate_GT] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_class] = ACTIONS(3202),
    [anon_sym_async] = ACTIONS(3202),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_using] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(3202),
    [anon_sym_LT] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3202),
    [anon_sym_void] = ACTIONS(3202),
    [anon_sym_delete] = ACTIONS(3202),
    [anon_sym_PLUS_PLUS] = ACTIONS(3202),
    [anon_sym_DASH_DASH] = ACTIONS(3202),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3202),
    [sym_number] = ACTIONS(3202),
    [sym_private_property_identifier] = ACTIONS(3202),
    [sym_this] = ACTIONS(3202),
    [sym_super] = ACTIONS(3202),
    [sym_true] = ACTIONS(3202),
    [sym_false] = ACTIONS(3202),
    [sym_null] = ACTIONS(3202),
    [sym_undefined] = ACTIONS(3202),
    [anon_sym_AT] = ACTIONS(3202),
    [anon_sym_static] = ACTIONS(3202),
    [anon_sym_readonly] = ACTIONS(3202),
    [anon_sym_get] = ACTIONS(3202),
    [anon_sym_set] = ACTIONS(3202),
    [anon_sym_declare] = ACTIONS(3202),
    [anon_sym_public] = ACTIONS(3202),
    [anon_sym_private] = ACTIONS(3202),
    [anon_sym_protected] = ACTIONS(3202),
    [anon_sym_override] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_any] = ACTIONS(3202),
    [anon_sym_number] = ACTIONS(3202),
    [anon_sym_boolean] = ACTIONS(3202),
    [anon_sym_string] = ACTIONS(3202),
    [anon_sym_symbol] = ACTIONS(3202),
    [anon_sym_object] = ACTIONS(3202),
    [anon_sym_abstract] = ACTIONS(3202),
    [anon_sym_interface] = ACTIONS(3202),
    [anon_sym_enum] = ACTIONS(3202),
    [sym_html_comment] = ACTIONS(5),
  },
  [1434] = {
    [sym_comment] = STATE(1434),
    [ts_builtin_sym_end] = ACTIONS(3572),
    [sym_identifier] = ACTIONS(3320),
    [anon_sym_export] = ACTIONS(3320),
    [anon_sym_type] = ACTIONS(3320),
    [anon_sym_namespace] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3320),
    [anon_sym_RBRACE] = ACTIONS(3320),
    [anon_sym_typeof] = ACTIONS(3320),
    [anon_sym_import] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3320),
    [anon_sym_var] = ACTIONS(3320),
    [anon_sym_let] = ACTIONS(3320),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_BANG] = ACTIONS(3320),
    [anon_sym_else] = ACTIONS(3320),
    [anon_sym_if] = ACTIONS(3320),
    [anon_sym_switch] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3320),
    [anon_sym_await] = ACTIONS(3320),
    [anon_sym_while] = ACTIONS(3320),
    [anon_sym_do] = ACTIONS(3320),
    [anon_sym_try] = ACTIONS(3320),
    [anon_sym_break] = ACTIONS(3320),
    [anon_sym_continue] = ACTIONS(3320),
    [anon_sym_debugger] = ACTIONS(3320),
    [anon_sym_return] = ACTIONS(3320),
    [anon_sym_throw] = ACTIONS(3320),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3320),
    [anon_sym_LBRACK] = ACTIONS(3320),
    [anon_sym_LTtemplate_GT] = ACTIONS(3320),
    [anon_sym_DQUOTE] = ACTIONS(3320),
    [anon_sym_SQUOTE] = ACTIONS(3320),
    [anon_sym_class] = ACTIONS(3320),
    [anon_sym_async] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3320),
    [anon_sym_using] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3320),
    [anon_sym_DASH] = ACTIONS(3320),
    [anon_sym_SLASH] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [anon_sym_void] = ACTIONS(3320),
    [anon_sym_delete] = ACTIONS(3320),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3320),
    [sym_number] = ACTIONS(3320),
    [sym_private_property_identifier] = ACTIONS(3320),
    [sym_this] = ACTIONS(3320),
    [sym_super] = ACTIONS(3320),
    [sym_true] = ACTIONS(3320),
    [sym_false] = ACTIONS(3320),
    [sym_null] = ACTIONS(3320),
    [sym_undefined] = ACTIONS(3320),
    [anon_sym_AT] = ACTIONS(3320),
    [anon_sym_static] = ACTIONS(3320),
    [anon_sym_readonly] = ACTIONS(3320),
    [anon_sym_get] = ACTIONS(3320),
    [anon_sym_set] = ACTIONS(3320),
    [anon_sym_declare] = ACTIONS(3320),
    [anon_sym_public] = ACTIONS(3320),
    [anon_sym_private] = ACTIONS(3320),
    [anon_sym_protected] = ACTIONS(3320),
    [anon_sym_override] = ACTIONS(3320),
    [anon_sym_module] = ACTIONS(3320),
    [anon_sym_any] = ACTIONS(3320),
    [anon_sym_number] = ACTIONS(3320),
    [anon_sym_boolean] = ACTIONS(3320),
    [anon_sym_string] = ACTIONS(3320),
    [anon_sym_symbol] = ACTIONS(3320),
    [anon_sym_object] = ACTIONS(3320),
    [anon_sym_abstract] = ACTIONS(3320),
    [anon_sym_interface] = ACTIONS(3320),
    [anon_sym_enum] = ACTIONS(3320),
    [sym_html_comment] = ACTIONS(5),
  },
  [1435] = {
    [sym_comment] = STATE(1435),
    [ts_builtin_sym_end] = ACTIONS(3574),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_export] = ACTIONS(3322),
    [anon_sym_type] = ACTIONS(3322),
    [anon_sym_namespace] = ACTIONS(3322),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_RBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3322),
    [anon_sym_import] = ACTIONS(3322),
    [anon_sym_with] = ACTIONS(3322),
    [anon_sym_var] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_BANG] = ACTIONS(3322),
    [anon_sym_else] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_switch] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_await] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(3322),
    [anon_sym_continue] = ACTIONS(3322),
    [anon_sym_debugger] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_throw] = ACTIONS(3322),
    [anon_sym_SEMI] = ACTIONS(3322),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LTtemplate_GT] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_SQUOTE] = ACTIONS(3322),
    [anon_sym_class] = ACTIONS(3322),
    [anon_sym_async] = ACTIONS(3322),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_using] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_SLASH] = ACTIONS(3322),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3322),
    [anon_sym_void] = ACTIONS(3322),
    [anon_sym_delete] = ACTIONS(3322),
    [anon_sym_PLUS_PLUS] = ACTIONS(3322),
    [anon_sym_DASH_DASH] = ACTIONS(3322),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3322),
    [sym_number] = ACTIONS(3322),
    [sym_private_property_identifier] = ACTIONS(3322),
    [sym_this] = ACTIONS(3322),
    [sym_super] = ACTIONS(3322),
    [sym_true] = ACTIONS(3322),
    [sym_false] = ACTIONS(3322),
    [sym_null] = ACTIONS(3322),
    [sym_undefined] = ACTIONS(3322),
    [anon_sym_AT] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3322),
    [anon_sym_readonly] = ACTIONS(3322),
    [anon_sym_get] = ACTIONS(3322),
    [anon_sym_set] = ACTIONS(3322),
    [anon_sym_declare] = ACTIONS(3322),
    [anon_sym_public] = ACTIONS(3322),
    [anon_sym_private] = ACTIONS(3322),
    [anon_sym_protected] = ACTIONS(3322),
    [anon_sym_override] = ACTIONS(3322),
    [anon_sym_module] = ACTIONS(3322),
    [anon_sym_any] = ACTIONS(3322),
    [anon_sym_number] = ACTIONS(3322),
    [anon_sym_boolean] = ACTIONS(3322),
    [anon_sym_string] = ACTIONS(3322),
    [anon_sym_symbol] = ACTIONS(3322),
    [anon_sym_object] = ACTIONS(3322),
    [anon_sym_abstract] = ACTIONS(3322),
    [anon_sym_interface] = ACTIONS(3322),
    [anon_sym_enum] = ACTIONS(3322),
    [sym_html_comment] = ACTIONS(5),
  },
  [1436] = {
    [sym_comment] = STATE(1436),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_export] = ACTIONS(3234),
    [anon_sym_default] = ACTIONS(3234),
    [anon_sym_type] = ACTIONS(3234),
    [anon_sym_namespace] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(3234),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_typeof] = ACTIONS(3234),
    [anon_sym_import] = ACTIONS(3234),
    [anon_sym_with] = ACTIONS(3234),
    [anon_sym_var] = ACTIONS(3234),
    [anon_sym_let] = ACTIONS(3234),
    [anon_sym_const] = ACTIONS(3234),
    [anon_sym_BANG] = ACTIONS(3234),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_for] = ACTIONS(3234),
    [anon_sym_LPAREN] = ACTIONS(3234),
    [anon_sym_await] = ACTIONS(3234),
    [anon_sym_while] = ACTIONS(3234),
    [anon_sym_do] = ACTIONS(3234),
    [anon_sym_try] = ACTIONS(3234),
    [anon_sym_break] = ACTIONS(3234),
    [anon_sym_continue] = ACTIONS(3234),
    [anon_sym_debugger] = ACTIONS(3234),
    [anon_sym_return] = ACTIONS(3234),
    [anon_sym_throw] = ACTIONS(3234),
    [anon_sym_SEMI] = ACTIONS(3234),
    [anon_sym_case] = ACTIONS(3234),
    [anon_sym_yield] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_LTtemplate_GT] = ACTIONS(3234),
    [anon_sym_DQUOTE] = ACTIONS(3234),
    [anon_sym_SQUOTE] = ACTIONS(3234),
    [anon_sym_class] = ACTIONS(3234),
    [anon_sym_async] = ACTIONS(3234),
    [anon_sym_function] = ACTIONS(3234),
    [anon_sym_new] = ACTIONS(3234),
    [anon_sym_using] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3234),
    [anon_sym_DASH] = ACTIONS(3234),
    [anon_sym_SLASH] = ACTIONS(3234),
    [anon_sym_LT] = ACTIONS(3234),
    [anon_sym_TILDE] = ACTIONS(3234),
    [anon_sym_void] = ACTIONS(3234),
    [anon_sym_delete] = ACTIONS(3234),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3234),
    [sym_number] = ACTIONS(3234),
    [sym_private_property_identifier] = ACTIONS(3234),
    [sym_this] = ACTIONS(3234),
    [sym_super] = ACTIONS(3234),
    [sym_true] = ACTIONS(3234),
    [sym_false] = ACTIONS(3234),
    [sym_null] = ACTIONS(3234),
    [sym_undefined] = ACTIONS(3234),
    [anon_sym_AT] = ACTIONS(3234),
    [anon_sym_static] = ACTIONS(3234),
    [anon_sym_readonly] = ACTIONS(3234),
    [anon_sym_get] = ACTIONS(3234),
    [anon_sym_set] = ACTIONS(3234),
    [anon_sym_declare] = ACTIONS(3234),
    [anon_sym_public] = ACTIONS(3234),
    [anon_sym_private] = ACTIONS(3234),
    [anon_sym_protected] = ACTIONS(3234),
    [anon_sym_override] = ACTIONS(3234),
    [anon_sym_module] = ACTIONS(3234),
    [anon_sym_any] = ACTIONS(3234),
    [anon_sym_number] = ACTIONS(3234),
    [anon_sym_boolean] = ACTIONS(3234),
    [anon_sym_string] = ACTIONS(3234),
    [anon_sym_symbol] = ACTIONS(3234),
    [anon_sym_object] = ACTIONS(3234),
    [anon_sym_abstract] = ACTIONS(3234),
    [anon_sym_interface] = ACTIONS(3234),
    [anon_sym_enum] = ACTIONS(3234),
    [sym_html_comment] = ACTIONS(5),
  },
  [1437] = {
    [sym_comment] = STATE(1437),
    [ts_builtin_sym_end] = ACTIONS(3576),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_export] = ACTIONS(3326),
    [anon_sym_type] = ACTIONS(3326),
    [anon_sym_namespace] = ACTIONS(3326),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_RBRACE] = ACTIONS(3326),
    [anon_sym_typeof] = ACTIONS(3326),
    [anon_sym_import] = ACTIONS(3326),
    [anon_sym_with] = ACTIONS(3326),
    [anon_sym_var] = ACTIONS(3326),
    [anon_sym_let] = ACTIONS(3326),
    [anon_sym_const] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_else] = ACTIONS(3326),
    [anon_sym_if] = ACTIONS(3326),
    [anon_sym_switch] = ACTIONS(3326),
    [anon_sym_for] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_await] = ACTIONS(3326),
    [anon_sym_while] = ACTIONS(3326),
    [anon_sym_do] = ACTIONS(3326),
    [anon_sym_try] = ACTIONS(3326),
    [anon_sym_break] = ACTIONS(3326),
    [anon_sym_continue] = ACTIONS(3326),
    [anon_sym_debugger] = ACTIONS(3326),
    [anon_sym_return] = ACTIONS(3326),
    [anon_sym_throw] = ACTIONS(3326),
    [anon_sym_SEMI] = ACTIONS(3326),
    [anon_sym_yield] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_LTtemplate_GT] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_class] = ACTIONS(3326),
    [anon_sym_async] = ACTIONS(3326),
    [anon_sym_function] = ACTIONS(3326),
    [anon_sym_new] = ACTIONS(3326),
    [anon_sym_using] = ACTIONS(3326),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3326),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_void] = ACTIONS(3326),
    [anon_sym_delete] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3326),
    [sym_number] = ACTIONS(3326),
    [sym_private_property_identifier] = ACTIONS(3326),
    [sym_this] = ACTIONS(3326),
    [sym_super] = ACTIONS(3326),
    [sym_true] = ACTIONS(3326),
    [sym_false] = ACTIONS(3326),
    [sym_null] = ACTIONS(3326),
    [sym_undefined] = ACTIONS(3326),
    [anon_sym_AT] = ACTIONS(3326),
    [anon_sym_static] = ACTIONS(3326),
    [anon_sym_readonly] = ACTIONS(3326),
    [anon_sym_get] = ACTIONS(3326),
    [anon_sym_set] = ACTIONS(3326),
    [anon_sym_declare] = ACTIONS(3326),
    [anon_sym_public] = ACTIONS(3326),
    [anon_sym_private] = ACTIONS(3326),
    [anon_sym_protected] = ACTIONS(3326),
    [anon_sym_override] = ACTIONS(3326),
    [anon_sym_module] = ACTIONS(3326),
    [anon_sym_any] = ACTIONS(3326),
    [anon_sym_number] = ACTIONS(3326),
    [anon_sym_boolean] = ACTIONS(3326),
    [anon_sym_string] = ACTIONS(3326),
    [anon_sym_symbol] = ACTIONS(3326),
    [anon_sym_object] = ACTIONS(3326),
    [anon_sym_abstract] = ACTIONS(3326),
    [anon_sym_interface] = ACTIONS(3326),
    [anon_sym_enum] = ACTIONS(3326),
    [sym_html_comment] = ACTIONS(5),
  },
  [1438] = {
    [sym_comment] = STATE(1438),
    [ts_builtin_sym_end] = ACTIONS(3578),
    [sym_identifier] = ACTIONS(3328),
    [anon_sym_export] = ACTIONS(3328),
    [anon_sym_type] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_typeof] = ACTIONS(3328),
    [anon_sym_import] = ACTIONS(3328),
    [anon_sym_with] = ACTIONS(3328),
    [anon_sym_var] = ACTIONS(3328),
    [anon_sym_let] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_BANG] = ACTIONS(3328),
    [anon_sym_else] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_await] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_debugger] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_throw] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_yield] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LTtemplate_GT] = ACTIONS(3328),
    [anon_sym_DQUOTE] = ACTIONS(3328),
    [anon_sym_SQUOTE] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_async] = ACTIONS(3328),
    [anon_sym_function] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_SLASH] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3328),
    [anon_sym_TILDE] = ACTIONS(3328),
    [anon_sym_void] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3328),
    [sym_number] = ACTIONS(3328),
    [sym_private_property_identifier] = ACTIONS(3328),
    [sym_this] = ACTIONS(3328),
    [sym_super] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_null] = ACTIONS(3328),
    [sym_undefined] = ACTIONS(3328),
    [anon_sym_AT] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_readonly] = ACTIONS(3328),
    [anon_sym_get] = ACTIONS(3328),
    [anon_sym_set] = ACTIONS(3328),
    [anon_sym_declare] = ACTIONS(3328),
    [anon_sym_public] = ACTIONS(3328),
    [anon_sym_private] = ACTIONS(3328),
    [anon_sym_protected] = ACTIONS(3328),
    [anon_sym_override] = ACTIONS(3328),
    [anon_sym_module] = ACTIONS(3328),
    [anon_sym_any] = ACTIONS(3328),
    [anon_sym_number] = ACTIONS(3328),
    [anon_sym_boolean] = ACTIONS(3328),
    [anon_sym_string] = ACTIONS(3328),
    [anon_sym_symbol] = ACTIONS(3328),
    [anon_sym_object] = ACTIONS(3328),
    [anon_sym_abstract] = ACTIONS(3328),
    [anon_sym_interface] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [sym_html_comment] = ACTIONS(5),
  },
  [1439] = {
    [sym_comment] = STATE(1439),
    [ts_builtin_sym_end] = ACTIONS(3580),
    [sym_identifier] = ACTIONS(3210),
    [anon_sym_export] = ACTIONS(3210),
    [anon_sym_type] = ACTIONS(3210),
    [anon_sym_namespace] = ACTIONS(3210),
    [anon_sym_LBRACE] = ACTIONS(3210),
    [anon_sym_RBRACE] = ACTIONS(3210),
    [anon_sym_typeof] = ACTIONS(3210),
    [anon_sym_import] = ACTIONS(3210),
    [anon_sym_with] = ACTIONS(3210),
    [anon_sym_var] = ACTIONS(3210),
    [anon_sym_let] = ACTIONS(3210),
    [anon_sym_const] = ACTIONS(3210),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_else] = ACTIONS(3210),
    [anon_sym_if] = ACTIONS(3210),
    [anon_sym_switch] = ACTIONS(3210),
    [anon_sym_for] = ACTIONS(3210),
    [anon_sym_LPAREN] = ACTIONS(3210),
    [anon_sym_await] = ACTIONS(3210),
    [anon_sym_while] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3210),
    [anon_sym_try] = ACTIONS(3210),
    [anon_sym_break] = ACTIONS(3210),
    [anon_sym_continue] = ACTIONS(3210),
    [anon_sym_debugger] = ACTIONS(3210),
    [anon_sym_return] = ACTIONS(3210),
    [anon_sym_throw] = ACTIONS(3210),
    [anon_sym_SEMI] = ACTIONS(3210),
    [anon_sym_yield] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_LTtemplate_GT] = ACTIONS(3210),
    [anon_sym_DQUOTE] = ACTIONS(3210),
    [anon_sym_SQUOTE] = ACTIONS(3210),
    [anon_sym_class] = ACTIONS(3210),
    [anon_sym_async] = ACTIONS(3210),
    [anon_sym_function] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3210),
    [anon_sym_using] = ACTIONS(3210),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_SLASH] = ACTIONS(3210),
    [anon_sym_LT] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3210),
    [anon_sym_void] = ACTIONS(3210),
    [anon_sym_delete] = ACTIONS(3210),
    [anon_sym_PLUS_PLUS] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3210),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3210),
    [sym_number] = ACTIONS(3210),
    [sym_private_property_identifier] = ACTIONS(3210),
    [sym_this] = ACTIONS(3210),
    [sym_super] = ACTIONS(3210),
    [sym_true] = ACTIONS(3210),
    [sym_false] = ACTIONS(3210),
    [sym_null] = ACTIONS(3210),
    [sym_undefined] = ACTIONS(3210),
    [anon_sym_AT] = ACTIONS(3210),
    [anon_sym_static] = ACTIONS(3210),
    [anon_sym_readonly] = ACTIONS(3210),
    [anon_sym_get] = ACTIONS(3210),
    [anon_sym_set] = ACTIONS(3210),
    [anon_sym_declare] = ACTIONS(3210),
    [anon_sym_public] = ACTIONS(3210),
    [anon_sym_private] = ACTIONS(3210),
    [anon_sym_protected] = ACTIONS(3210),
    [anon_sym_override] = ACTIONS(3210),
    [anon_sym_module] = ACTIONS(3210),
    [anon_sym_any] = ACTIONS(3210),
    [anon_sym_number] = ACTIONS(3210),
    [anon_sym_boolean] = ACTIONS(3210),
    [anon_sym_string] = ACTIONS(3210),
    [anon_sym_symbol] = ACTIONS(3210),
    [anon_sym_object] = ACTIONS(3210),
    [anon_sym_abstract] = ACTIONS(3210),
    [anon_sym_interface] = ACTIONS(3210),
    [anon_sym_enum] = ACTIONS(3210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1440] = {
    [sym_comment] = STATE(1440),
    [ts_builtin_sym_end] = ACTIONS(3582),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_export] = ACTIONS(3212),
    [anon_sym_type] = ACTIONS(3212),
    [anon_sym_namespace] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_RBRACE] = ACTIONS(3212),
    [anon_sym_typeof] = ACTIONS(3212),
    [anon_sym_import] = ACTIONS(3212),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_var] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_const] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_else] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_switch] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_await] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_break] = ACTIONS(3212),
    [anon_sym_continue] = ACTIONS(3212),
    [anon_sym_debugger] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_throw] = ACTIONS(3212),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LTtemplate_GT] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_class] = ACTIONS(3212),
    [anon_sym_async] = ACTIONS(3212),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_using] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_LT] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_void] = ACTIONS(3212),
    [anon_sym_delete] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3212),
    [sym_number] = ACTIONS(3212),
    [sym_private_property_identifier] = ACTIONS(3212),
    [sym_this] = ACTIONS(3212),
    [sym_super] = ACTIONS(3212),
    [sym_true] = ACTIONS(3212),
    [sym_false] = ACTIONS(3212),
    [sym_null] = ACTIONS(3212),
    [sym_undefined] = ACTIONS(3212),
    [anon_sym_AT] = ACTIONS(3212),
    [anon_sym_static] = ACTIONS(3212),
    [anon_sym_readonly] = ACTIONS(3212),
    [anon_sym_get] = ACTIONS(3212),
    [anon_sym_set] = ACTIONS(3212),
    [anon_sym_declare] = ACTIONS(3212),
    [anon_sym_public] = ACTIONS(3212),
    [anon_sym_private] = ACTIONS(3212),
    [anon_sym_protected] = ACTIONS(3212),
    [anon_sym_override] = ACTIONS(3212),
    [anon_sym_module] = ACTIONS(3212),
    [anon_sym_any] = ACTIONS(3212),
    [anon_sym_number] = ACTIONS(3212),
    [anon_sym_boolean] = ACTIONS(3212),
    [anon_sym_string] = ACTIONS(3212),
    [anon_sym_symbol] = ACTIONS(3212),
    [anon_sym_object] = ACTIONS(3212),
    [anon_sym_abstract] = ACTIONS(3212),
    [anon_sym_interface] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3212),
    [sym_html_comment] = ACTIONS(5),
  },
  [1441] = {
    [sym_comment] = STATE(1441),
    [sym_identifier] = ACTIONS(3226),
    [anon_sym_export] = ACTIONS(3226),
    [anon_sym_default] = ACTIONS(3226),
    [anon_sym_type] = ACTIONS(3226),
    [anon_sym_namespace] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [anon_sym_RBRACE] = ACTIONS(3226),
    [anon_sym_typeof] = ACTIONS(3226),
    [anon_sym_import] = ACTIONS(3226),
    [anon_sym_with] = ACTIONS(3226),
    [anon_sym_var] = ACTIONS(3226),
    [anon_sym_let] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_BANG] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3226),
    [anon_sym_await] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_try] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_debugger] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_throw] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3226),
    [anon_sym_yield] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [anon_sym_LTtemplate_GT] = ACTIONS(3226),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_SQUOTE] = ACTIONS(3226),
    [anon_sym_class] = ACTIONS(3226),
    [anon_sym_async] = ACTIONS(3226),
    [anon_sym_function] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_using] = ACTIONS(3226),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_SLASH] = ACTIONS(3226),
    [anon_sym_LT] = ACTIONS(3226),
    [anon_sym_TILDE] = ACTIONS(3226),
    [anon_sym_void] = ACTIONS(3226),
    [anon_sym_delete] = ACTIONS(3226),
    [anon_sym_PLUS_PLUS] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3226),
    [sym_number] = ACTIONS(3226),
    [sym_private_property_identifier] = ACTIONS(3226),
    [sym_this] = ACTIONS(3226),
    [sym_super] = ACTIONS(3226),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [sym_null] = ACTIONS(3226),
    [sym_undefined] = ACTIONS(3226),
    [anon_sym_AT] = ACTIONS(3226),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_readonly] = ACTIONS(3226),
    [anon_sym_get] = ACTIONS(3226),
    [anon_sym_set] = ACTIONS(3226),
    [anon_sym_declare] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3226),
    [anon_sym_private] = ACTIONS(3226),
    [anon_sym_protected] = ACTIONS(3226),
    [anon_sym_override] = ACTIONS(3226),
    [anon_sym_module] = ACTIONS(3226),
    [anon_sym_any] = ACTIONS(3226),
    [anon_sym_number] = ACTIONS(3226),
    [anon_sym_boolean] = ACTIONS(3226),
    [anon_sym_string] = ACTIONS(3226),
    [anon_sym_symbol] = ACTIONS(3226),
    [anon_sym_object] = ACTIONS(3226),
    [anon_sym_abstract] = ACTIONS(3226),
    [anon_sym_interface] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [sym_html_comment] = ACTIONS(5),
  },
  [1442] = {
    [sym_comment] = STATE(1442),
    [ts_builtin_sym_end] = ACTIONS(3584),
    [sym_identifier] = ACTIONS(3216),
    [anon_sym_export] = ACTIONS(3216),
    [anon_sym_type] = ACTIONS(3216),
    [anon_sym_namespace] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_typeof] = ACTIONS(3216),
    [anon_sym_import] = ACTIONS(3216),
    [anon_sym_with] = ACTIONS(3216),
    [anon_sym_var] = ACTIONS(3216),
    [anon_sym_let] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_else] = ACTIONS(3216),
    [anon_sym_if] = ACTIONS(3216),
    [anon_sym_switch] = ACTIONS(3216),
    [anon_sym_for] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [anon_sym_await] = ACTIONS(3216),
    [anon_sym_while] = ACTIONS(3216),
    [anon_sym_do] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(3216),
    [anon_sym_break] = ACTIONS(3216),
    [anon_sym_continue] = ACTIONS(3216),
    [anon_sym_debugger] = ACTIONS(3216),
    [anon_sym_return] = ACTIONS(3216),
    [anon_sym_throw] = ACTIONS(3216),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym_yield] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [anon_sym_LTtemplate_GT] = ACTIONS(3216),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_async] = ACTIONS(3216),
    [anon_sym_function] = ACTIONS(3216),
    [anon_sym_new] = ACTIONS(3216),
    [anon_sym_using] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_SLASH] = ACTIONS(3216),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_void] = ACTIONS(3216),
    [anon_sym_delete] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3216),
    [sym_number] = ACTIONS(3216),
    [sym_private_property_identifier] = ACTIONS(3216),
    [sym_this] = ACTIONS(3216),
    [sym_super] = ACTIONS(3216),
    [sym_true] = ACTIONS(3216),
    [sym_false] = ACTIONS(3216),
    [sym_null] = ACTIONS(3216),
    [sym_undefined] = ACTIONS(3216),
    [anon_sym_AT] = ACTIONS(3216),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_readonly] = ACTIONS(3216),
    [anon_sym_get] = ACTIONS(3216),
    [anon_sym_set] = ACTIONS(3216),
    [anon_sym_declare] = ACTIONS(3216),
    [anon_sym_public] = ACTIONS(3216),
    [anon_sym_private] = ACTIONS(3216),
    [anon_sym_protected] = ACTIONS(3216),
    [anon_sym_override] = ACTIONS(3216),
    [anon_sym_module] = ACTIONS(3216),
    [anon_sym_any] = ACTIONS(3216),
    [anon_sym_number] = ACTIONS(3216),
    [anon_sym_boolean] = ACTIONS(3216),
    [anon_sym_string] = ACTIONS(3216),
    [anon_sym_symbol] = ACTIONS(3216),
    [anon_sym_object] = ACTIONS(3216),
    [anon_sym_abstract] = ACTIONS(3216),
    [anon_sym_interface] = ACTIONS(3216),
    [anon_sym_enum] = ACTIONS(3216),
    [sym_html_comment] = ACTIONS(5),
  },
  [1443] = {
    [sym_comment] = STATE(1443),
    [ts_builtin_sym_end] = ACTIONS(3586),
    [sym_identifier] = ACTIONS(3132),
    [anon_sym_export] = ACTIONS(3132),
    [anon_sym_type] = ACTIONS(3132),
    [anon_sym_namespace] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_typeof] = ACTIONS(3132),
    [anon_sym_import] = ACTIONS(3132),
    [anon_sym_with] = ACTIONS(3132),
    [anon_sym_var] = ACTIONS(3132),
    [anon_sym_let] = ACTIONS(3132),
    [anon_sym_const] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_else] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_switch] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [anon_sym_await] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_do] = ACTIONS(3132),
    [anon_sym_try] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_continue] = ACTIONS(3132),
    [anon_sym_debugger] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_throw] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_yield] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_LTtemplate_GT] = ACTIONS(3132),
    [anon_sym_DQUOTE] = ACTIONS(3132),
    [anon_sym_SQUOTE] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_async] = ACTIONS(3132),
    [anon_sym_function] = ACTIONS(3132),
    [anon_sym_new] = ACTIONS(3132),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3132),
    [anon_sym_DASH] = ACTIONS(3132),
    [anon_sym_SLASH] = ACTIONS(3132),
    [anon_sym_LT] = ACTIONS(3132),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_void] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3132),
    [sym_number] = ACTIONS(3132),
    [sym_private_property_identifier] = ACTIONS(3132),
    [sym_this] = ACTIONS(3132),
    [sym_super] = ACTIONS(3132),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [sym_null] = ACTIONS(3132),
    [sym_undefined] = ACTIONS(3132),
    [anon_sym_AT] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_readonly] = ACTIONS(3132),
    [anon_sym_get] = ACTIONS(3132),
    [anon_sym_set] = ACTIONS(3132),
    [anon_sym_declare] = ACTIONS(3132),
    [anon_sym_public] = ACTIONS(3132),
    [anon_sym_private] = ACTIONS(3132),
    [anon_sym_protected] = ACTIONS(3132),
    [anon_sym_override] = ACTIONS(3132),
    [anon_sym_module] = ACTIONS(3132),
    [anon_sym_any] = ACTIONS(3132),
    [anon_sym_number] = ACTIONS(3132),
    [anon_sym_boolean] = ACTIONS(3132),
    [anon_sym_string] = ACTIONS(3132),
    [anon_sym_symbol] = ACTIONS(3132),
    [anon_sym_object] = ACTIONS(3132),
    [anon_sym_abstract] = ACTIONS(3132),
    [anon_sym_interface] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1444] = {
    [sym_comment] = STATE(1444),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_else] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym_html_comment] = ACTIONS(5),
  },
  [1445] = {
    [sym_comment] = STATE(1445),
    [ts_builtin_sym_end] = ACTIONS(3510),
    [sym_identifier] = ACTIONS(3268),
    [anon_sym_export] = ACTIONS(3268),
    [anon_sym_type] = ACTIONS(3268),
    [anon_sym_namespace] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3268),
    [anon_sym_typeof] = ACTIONS(3268),
    [anon_sym_import] = ACTIONS(3268),
    [anon_sym_with] = ACTIONS(3268),
    [anon_sym_var] = ACTIONS(3268),
    [anon_sym_let] = ACTIONS(3268),
    [anon_sym_const] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_if] = ACTIONS(3268),
    [anon_sym_switch] = ACTIONS(3268),
    [anon_sym_for] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3268),
    [anon_sym_await] = ACTIONS(3268),
    [anon_sym_while] = ACTIONS(3268),
    [anon_sym_do] = ACTIONS(3268),
    [anon_sym_try] = ACTIONS(3268),
    [anon_sym_break] = ACTIONS(3268),
    [anon_sym_continue] = ACTIONS(3268),
    [anon_sym_debugger] = ACTIONS(3268),
    [anon_sym_return] = ACTIONS(3268),
    [anon_sym_throw] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_yield] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_LTtemplate_GT] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_class] = ACTIONS(3268),
    [anon_sym_async] = ACTIONS(3268),
    [anon_sym_function] = ACTIONS(3268),
    [anon_sym_new] = ACTIONS(3268),
    [anon_sym_using] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_void] = ACTIONS(3268),
    [anon_sym_delete] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3268),
    [sym_number] = ACTIONS(3268),
    [sym_private_property_identifier] = ACTIONS(3268),
    [sym_this] = ACTIONS(3268),
    [sym_super] = ACTIONS(3268),
    [sym_true] = ACTIONS(3268),
    [sym_false] = ACTIONS(3268),
    [sym_null] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_AT] = ACTIONS(3268),
    [anon_sym_static] = ACTIONS(3268),
    [anon_sym_readonly] = ACTIONS(3268),
    [anon_sym_get] = ACTIONS(3268),
    [anon_sym_set] = ACTIONS(3268),
    [anon_sym_declare] = ACTIONS(3268),
    [anon_sym_public] = ACTIONS(3268),
    [anon_sym_private] = ACTIONS(3268),
    [anon_sym_protected] = ACTIONS(3268),
    [anon_sym_override] = ACTIONS(3268),
    [anon_sym_module] = ACTIONS(3268),
    [anon_sym_any] = ACTIONS(3268),
    [anon_sym_number] = ACTIONS(3268),
    [anon_sym_boolean] = ACTIONS(3268),
    [anon_sym_string] = ACTIONS(3268),
    [anon_sym_symbol] = ACTIONS(3268),
    [anon_sym_object] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(3268),
    [anon_sym_interface] = ACTIONS(3268),
    [anon_sym_enum] = ACTIONS(3268),
    [sym_html_comment] = ACTIONS(5),
  },
  [1446] = {
    [sym_comment] = STATE(1446),
    [ts_builtin_sym_end] = ACTIONS(3416),
    [sym_identifier] = ACTIONS(3146),
    [anon_sym_export] = ACTIONS(3146),
    [anon_sym_type] = ACTIONS(3146),
    [anon_sym_namespace] = ACTIONS(3146),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_typeof] = ACTIONS(3146),
    [anon_sym_import] = ACTIONS(3146),
    [anon_sym_with] = ACTIONS(3146),
    [anon_sym_var] = ACTIONS(3146),
    [anon_sym_let] = ACTIONS(3146),
    [anon_sym_const] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_if] = ACTIONS(3146),
    [anon_sym_switch] = ACTIONS(3146),
    [anon_sym_for] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [anon_sym_await] = ACTIONS(3146),
    [anon_sym_while] = ACTIONS(3146),
    [anon_sym_do] = ACTIONS(3146),
    [anon_sym_try] = ACTIONS(3146),
    [anon_sym_break] = ACTIONS(3146),
    [anon_sym_continue] = ACTIONS(3146),
    [anon_sym_debugger] = ACTIONS(3146),
    [anon_sym_return] = ACTIONS(3146),
    [anon_sym_throw] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_yield] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_LTtemplate_GT] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(3146),
    [anon_sym_async] = ACTIONS(3146),
    [anon_sym_function] = ACTIONS(3146),
    [anon_sym_new] = ACTIONS(3146),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3146),
    [anon_sym_SLASH] = ACTIONS(3146),
    [anon_sym_LT] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_void] = ACTIONS(3146),
    [anon_sym_delete] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3146),
    [sym_number] = ACTIONS(3146),
    [sym_private_property_identifier] = ACTIONS(3146),
    [sym_this] = ACTIONS(3146),
    [sym_super] = ACTIONS(3146),
    [sym_true] = ACTIONS(3146),
    [sym_false] = ACTIONS(3146),
    [sym_null] = ACTIONS(3146),
    [sym_undefined] = ACTIONS(3146),
    [anon_sym_AT] = ACTIONS(3146),
    [anon_sym_static] = ACTIONS(3146),
    [anon_sym_readonly] = ACTIONS(3146),
    [anon_sym_get] = ACTIONS(3146),
    [anon_sym_set] = ACTIONS(3146),
    [anon_sym_declare] = ACTIONS(3146),
    [anon_sym_public] = ACTIONS(3146),
    [anon_sym_private] = ACTIONS(3146),
    [anon_sym_protected] = ACTIONS(3146),
    [anon_sym_override] = ACTIONS(3146),
    [anon_sym_module] = ACTIONS(3146),
    [anon_sym_any] = ACTIONS(3146),
    [anon_sym_number] = ACTIONS(3146),
    [anon_sym_boolean] = ACTIONS(3146),
    [anon_sym_string] = ACTIONS(3146),
    [anon_sym_symbol] = ACTIONS(3146),
    [anon_sym_object] = ACTIONS(3146),
    [anon_sym_abstract] = ACTIONS(3146),
    [anon_sym_interface] = ACTIONS(3146),
    [anon_sym_enum] = ACTIONS(3146),
    [sym_html_comment] = ACTIONS(5),
  },
  [1447] = {
    [sym_comment] = STATE(1447),
    [ts_builtin_sym_end] = ACTIONS(3482),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_export] = ACTIONS(3262),
    [anon_sym_type] = ACTIONS(3262),
    [anon_sym_namespace] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_typeof] = ACTIONS(3262),
    [anon_sym_import] = ACTIONS(3262),
    [anon_sym_with] = ACTIONS(3262),
    [anon_sym_var] = ACTIONS(3262),
    [anon_sym_let] = ACTIONS(3262),
    [anon_sym_const] = ACTIONS(3262),
    [anon_sym_BANG] = ACTIONS(3262),
    [anon_sym_if] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_await] = ACTIONS(3262),
    [anon_sym_while] = ACTIONS(3262),
    [anon_sym_do] = ACTIONS(3262),
    [anon_sym_try] = ACTIONS(3262),
    [anon_sym_break] = ACTIONS(3262),
    [anon_sym_continue] = ACTIONS(3262),
    [anon_sym_debugger] = ACTIONS(3262),
    [anon_sym_return] = ACTIONS(3262),
    [anon_sym_throw] = ACTIONS(3262),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_yield] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_LTtemplate_GT] = ACTIONS(3262),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [anon_sym_class] = ACTIONS(3262),
    [anon_sym_async] = ACTIONS(3262),
    [anon_sym_function] = ACTIONS(3262),
    [anon_sym_new] = ACTIONS(3262),
    [anon_sym_using] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3262),
    [anon_sym_SLASH] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3262),
    [anon_sym_TILDE] = ACTIONS(3262),
    [anon_sym_void] = ACTIONS(3262),
    [anon_sym_delete] = ACTIONS(3262),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3262),
    [sym_number] = ACTIONS(3262),
    [sym_private_property_identifier] = ACTIONS(3262),
    [sym_this] = ACTIONS(3262),
    [sym_super] = ACTIONS(3262),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_null] = ACTIONS(3262),
    [sym_undefined] = ACTIONS(3262),
    [anon_sym_AT] = ACTIONS(3262),
    [anon_sym_static] = ACTIONS(3262),
    [anon_sym_readonly] = ACTIONS(3262),
    [anon_sym_get] = ACTIONS(3262),
    [anon_sym_set] = ACTIONS(3262),
    [anon_sym_declare] = ACTIONS(3262),
    [anon_sym_public] = ACTIONS(3262),
    [anon_sym_private] = ACTIONS(3262),
    [anon_sym_protected] = ACTIONS(3262),
    [anon_sym_override] = ACTIONS(3262),
    [anon_sym_module] = ACTIONS(3262),
    [anon_sym_any] = ACTIONS(3262),
    [anon_sym_number] = ACTIONS(3262),
    [anon_sym_boolean] = ACTIONS(3262),
    [anon_sym_string] = ACTIONS(3262),
    [anon_sym_symbol] = ACTIONS(3262),
    [anon_sym_object] = ACTIONS(3262),
    [anon_sym_abstract] = ACTIONS(3262),
    [anon_sym_interface] = ACTIONS(3262),
    [anon_sym_enum] = ACTIONS(3262),
    [sym_html_comment] = ACTIONS(5),
  },
  [1448] = {
    [sym_comment] = STATE(1448),
    [ts_builtin_sym_end] = ACTIONS(3484),
    [sym_identifier] = ACTIONS(3266),
    [anon_sym_export] = ACTIONS(3266),
    [anon_sym_type] = ACTIONS(3266),
    [anon_sym_namespace] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_typeof] = ACTIONS(3266),
    [anon_sym_import] = ACTIONS(3266),
    [anon_sym_with] = ACTIONS(3266),
    [anon_sym_var] = ACTIONS(3266),
    [anon_sym_let] = ACTIONS(3266),
    [anon_sym_const] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_if] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_await] = ACTIONS(3266),
    [anon_sym_while] = ACTIONS(3266),
    [anon_sym_do] = ACTIONS(3266),
    [anon_sym_try] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3266),
    [anon_sym_continue] = ACTIONS(3266),
    [anon_sym_debugger] = ACTIONS(3266),
    [anon_sym_return] = ACTIONS(3266),
    [anon_sym_throw] = ACTIONS(3266),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_yield] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_LTtemplate_GT] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_class] = ACTIONS(3266),
    [anon_sym_async] = ACTIONS(3266),
    [anon_sym_function] = ACTIONS(3266),
    [anon_sym_new] = ACTIONS(3266),
    [anon_sym_using] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3266),
    [anon_sym_SLASH] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3266),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_void] = ACTIONS(3266),
    [anon_sym_delete] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3266),
    [sym_number] = ACTIONS(3266),
    [sym_private_property_identifier] = ACTIONS(3266),
    [sym_this] = ACTIONS(3266),
    [sym_super] = ACTIONS(3266),
    [sym_true] = ACTIONS(3266),
    [sym_false] = ACTIONS(3266),
    [sym_null] = ACTIONS(3266),
    [sym_undefined] = ACTIONS(3266),
    [anon_sym_AT] = ACTIONS(3266),
    [anon_sym_static] = ACTIONS(3266),
    [anon_sym_readonly] = ACTIONS(3266),
    [anon_sym_get] = ACTIONS(3266),
    [anon_sym_set] = ACTIONS(3266),
    [anon_sym_declare] = ACTIONS(3266),
    [anon_sym_public] = ACTIONS(3266),
    [anon_sym_private] = ACTIONS(3266),
    [anon_sym_protected] = ACTIONS(3266),
    [anon_sym_override] = ACTIONS(3266),
    [anon_sym_module] = ACTIONS(3266),
    [anon_sym_any] = ACTIONS(3266),
    [anon_sym_number] = ACTIONS(3266),
    [anon_sym_boolean] = ACTIONS(3266),
    [anon_sym_string] = ACTIONS(3266),
    [anon_sym_symbol] = ACTIONS(3266),
    [anon_sym_object] = ACTIONS(3266),
    [anon_sym_abstract] = ACTIONS(3266),
    [anon_sym_interface] = ACTIONS(3266),
    [anon_sym_enum] = ACTIONS(3266),
    [sym_html_comment] = ACTIONS(5),
  },
  [1449] = {
    [sym_comment] = STATE(1449),
    [ts_builtin_sym_end] = ACTIONS(3480),
    [sym_identifier] = ACTIONS(3258),
    [anon_sym_export] = ACTIONS(3258),
    [anon_sym_type] = ACTIONS(3258),
    [anon_sym_namespace] = ACTIONS(3258),
    [anon_sym_LBRACE] = ACTIONS(3258),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_typeof] = ACTIONS(3258),
    [anon_sym_import] = ACTIONS(3258),
    [anon_sym_with] = ACTIONS(3258),
    [anon_sym_var] = ACTIONS(3258),
    [anon_sym_let] = ACTIONS(3258),
    [anon_sym_const] = ACTIONS(3258),
    [anon_sym_BANG] = ACTIONS(3258),
    [anon_sym_if] = ACTIONS(3258),
    [anon_sym_switch] = ACTIONS(3258),
    [anon_sym_for] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [anon_sym_await] = ACTIONS(3258),
    [anon_sym_while] = ACTIONS(3258),
    [anon_sym_do] = ACTIONS(3258),
    [anon_sym_try] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3258),
    [anon_sym_continue] = ACTIONS(3258),
    [anon_sym_debugger] = ACTIONS(3258),
    [anon_sym_return] = ACTIONS(3258),
    [anon_sym_throw] = ACTIONS(3258),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_LTtemplate_GT] = ACTIONS(3258),
    [anon_sym_DQUOTE] = ACTIONS(3258),
    [anon_sym_SQUOTE] = ACTIONS(3258),
    [anon_sym_class] = ACTIONS(3258),
    [anon_sym_async] = ACTIONS(3258),
    [anon_sym_function] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3258),
    [anon_sym_using] = ACTIONS(3258),
    [anon_sym_PLUS] = ACTIONS(3258),
    [anon_sym_DASH] = ACTIONS(3258),
    [anon_sym_SLASH] = ACTIONS(3258),
    [anon_sym_LT] = ACTIONS(3258),
    [anon_sym_TILDE] = ACTIONS(3258),
    [anon_sym_void] = ACTIONS(3258),
    [anon_sym_delete] = ACTIONS(3258),
    [anon_sym_PLUS_PLUS] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3258),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [sym_number] = ACTIONS(3258),
    [sym_private_property_identifier] = ACTIONS(3258),
    [sym_this] = ACTIONS(3258),
    [sym_super] = ACTIONS(3258),
    [sym_true] = ACTIONS(3258),
    [sym_false] = ACTIONS(3258),
    [sym_null] = ACTIONS(3258),
    [sym_undefined] = ACTIONS(3258),
    [anon_sym_AT] = ACTIONS(3258),
    [anon_sym_static] = ACTIONS(3258),
    [anon_sym_readonly] = ACTIONS(3258),
    [anon_sym_get] = ACTIONS(3258),
    [anon_sym_set] = ACTIONS(3258),
    [anon_sym_declare] = ACTIONS(3258),
    [anon_sym_public] = ACTIONS(3258),
    [anon_sym_private] = ACTIONS(3258),
    [anon_sym_protected] = ACTIONS(3258),
    [anon_sym_override] = ACTIONS(3258),
    [anon_sym_module] = ACTIONS(3258),
    [anon_sym_any] = ACTIONS(3258),
    [anon_sym_number] = ACTIONS(3258),
    [anon_sym_boolean] = ACTIONS(3258),
    [anon_sym_string] = ACTIONS(3258),
    [anon_sym_symbol] = ACTIONS(3258),
    [anon_sym_object] = ACTIONS(3258),
    [anon_sym_abstract] = ACTIONS(3258),
    [anon_sym_interface] = ACTIONS(3258),
    [anon_sym_enum] = ACTIONS(3258),
    [sym_html_comment] = ACTIONS(5),
  },
  [1450] = {
    [sym_comment] = STATE(1450),
    [ts_builtin_sym_end] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2163),
    [anon_sym_export] = ACTIONS(2163),
    [anon_sym_type] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2163),
    [anon_sym_import] = ACTIONS(2163),
    [anon_sym_with] = ACTIONS(2163),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2163),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_debugger] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_yield] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_LTtemplate_GT] = ACTIONS(2163),
    [anon_sym_DQUOTE] = ACTIONS(2163),
    [anon_sym_SQUOTE] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_async] = ACTIONS(2163),
    [anon_sym_function] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_SLASH] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [anon_sym_void] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_PLUS_PLUS] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2163),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2163),
    [sym_number] = ACTIONS(2163),
    [sym_private_property_identifier] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(2163),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_readonly] = ACTIONS(2163),
    [anon_sym_get] = ACTIONS(2163),
    [anon_sym_set] = ACTIONS(2163),
    [anon_sym_declare] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_override] = ACTIONS(2163),
    [anon_sym_module] = ACTIONS(2163),
    [anon_sym_any] = ACTIONS(2163),
    [anon_sym_number] = ACTIONS(2163),
    [anon_sym_boolean] = ACTIONS(2163),
    [anon_sym_string] = ACTIONS(2163),
    [anon_sym_symbol] = ACTIONS(2163),
    [anon_sym_object] = ACTIONS(2163),
    [anon_sym_abstract] = ACTIONS(2163),
    [anon_sym_interface] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [sym_html_comment] = ACTIONS(5),
  },
  [1451] = {
    [sym_comment] = STATE(1451),
    [ts_builtin_sym_end] = ACTIONS(3408),
    [sym_identifier] = ACTIONS(3274),
    [anon_sym_export] = ACTIONS(3274),
    [anon_sym_type] = ACTIONS(3274),
    [anon_sym_namespace] = ACTIONS(3274),
    [anon_sym_LBRACE] = ACTIONS(3274),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_typeof] = ACTIONS(3274),
    [anon_sym_import] = ACTIONS(3274),
    [anon_sym_with] = ACTIONS(3274),
    [anon_sym_var] = ACTIONS(3274),
    [anon_sym_let] = ACTIONS(3274),
    [anon_sym_const] = ACTIONS(3274),
    [anon_sym_BANG] = ACTIONS(3274),
    [anon_sym_if] = ACTIONS(3274),
    [anon_sym_switch] = ACTIONS(3274),
    [anon_sym_for] = ACTIONS(3274),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_await] = ACTIONS(3274),
    [anon_sym_while] = ACTIONS(3274),
    [anon_sym_do] = ACTIONS(3274),
    [anon_sym_try] = ACTIONS(3274),
    [anon_sym_break] = ACTIONS(3274),
    [anon_sym_continue] = ACTIONS(3274),
    [anon_sym_debugger] = ACTIONS(3274),
    [anon_sym_return] = ACTIONS(3274),
    [anon_sym_throw] = ACTIONS(3274),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_yield] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LTtemplate_GT] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_SQUOTE] = ACTIONS(3274),
    [anon_sym_class] = ACTIONS(3274),
    [anon_sym_async] = ACTIONS(3274),
    [anon_sym_function] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3274),
    [anon_sym_using] = ACTIONS(3274),
    [anon_sym_PLUS] = ACTIONS(3274),
    [anon_sym_DASH] = ACTIONS(3274),
    [anon_sym_SLASH] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3274),
    [anon_sym_TILDE] = ACTIONS(3274),
    [anon_sym_void] = ACTIONS(3274),
    [anon_sym_delete] = ACTIONS(3274),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3274),
    [sym_number] = ACTIONS(3274),
    [sym_private_property_identifier] = ACTIONS(3274),
    [sym_this] = ACTIONS(3274),
    [sym_super] = ACTIONS(3274),
    [sym_true] = ACTIONS(3274),
    [sym_false] = ACTIONS(3274),
    [sym_null] = ACTIONS(3274),
    [sym_undefined] = ACTIONS(3274),
    [anon_sym_AT] = ACTIONS(3274),
    [anon_sym_static] = ACTIONS(3274),
    [anon_sym_readonly] = ACTIONS(3274),
    [anon_sym_get] = ACTIONS(3274),
    [anon_sym_set] = ACTIONS(3274),
    [anon_sym_declare] = ACTIONS(3274),
    [anon_sym_public] = ACTIONS(3274),
    [anon_sym_private] = ACTIONS(3274),
    [anon_sym_protected] = ACTIONS(3274),
    [anon_sym_override] = ACTIONS(3274),
    [anon_sym_module] = ACTIONS(3274),
    [anon_sym_any] = ACTIONS(3274),
    [anon_sym_number] = ACTIONS(3274),
    [anon_sym_boolean] = ACTIONS(3274),
    [anon_sym_string] = ACTIONS(3274),
    [anon_sym_symbol] = ACTIONS(3274),
    [anon_sym_object] = ACTIONS(3274),
    [anon_sym_abstract] = ACTIONS(3274),
    [anon_sym_interface] = ACTIONS(3274),
    [anon_sym_enum] = ACTIONS(3274),
    [sym_html_comment] = ACTIONS(5),
  },
  [1452] = {
    [sym_comment] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [sym_identifier] = ACTIONS(3272),
    [anon_sym_export] = ACTIONS(3272),
    [anon_sym_type] = ACTIONS(3272),
    [anon_sym_namespace] = ACTIONS(3272),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_typeof] = ACTIONS(3272),
    [anon_sym_import] = ACTIONS(3272),
    [anon_sym_with] = ACTIONS(3272),
    [anon_sym_var] = ACTIONS(3272),
    [anon_sym_let] = ACTIONS(3272),
    [anon_sym_const] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_if] = ACTIONS(3272),
    [anon_sym_switch] = ACTIONS(3272),
    [anon_sym_for] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3272),
    [anon_sym_await] = ACTIONS(3272),
    [anon_sym_while] = ACTIONS(3272),
    [anon_sym_do] = ACTIONS(3272),
    [anon_sym_try] = ACTIONS(3272),
    [anon_sym_break] = ACTIONS(3272),
    [anon_sym_continue] = ACTIONS(3272),
    [anon_sym_debugger] = ACTIONS(3272),
    [anon_sym_return] = ACTIONS(3272),
    [anon_sym_throw] = ACTIONS(3272),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym_yield] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_LTtemplate_GT] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_class] = ACTIONS(3272),
    [anon_sym_async] = ACTIONS(3272),
    [anon_sym_function] = ACTIONS(3272),
    [anon_sym_new] = ACTIONS(3272),
    [anon_sym_using] = ACTIONS(3272),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_SLASH] = ACTIONS(3272),
    [anon_sym_LT] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_void] = ACTIONS(3272),
    [anon_sym_delete] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3272),
    [sym_number] = ACTIONS(3272),
    [sym_private_property_identifier] = ACTIONS(3272),
    [sym_this] = ACTIONS(3272),
    [sym_super] = ACTIONS(3272),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_undefined] = ACTIONS(3272),
    [anon_sym_AT] = ACTIONS(3272),
    [anon_sym_static] = ACTIONS(3272),
    [anon_sym_readonly] = ACTIONS(3272),
    [anon_sym_get] = ACTIONS(3272),
    [anon_sym_set] = ACTIONS(3272),
    [anon_sym_declare] = ACTIONS(3272),
    [anon_sym_public] = ACTIONS(3272),
    [anon_sym_private] = ACTIONS(3272),
    [anon_sym_protected] = ACTIONS(3272),
    [anon_sym_override] = ACTIONS(3272),
    [anon_sym_module] = ACTIONS(3272),
    [anon_sym_any] = ACTIONS(3272),
    [anon_sym_number] = ACTIONS(3272),
    [anon_sym_boolean] = ACTIONS(3272),
    [anon_sym_string] = ACTIONS(3272),
    [anon_sym_symbol] = ACTIONS(3272),
    [anon_sym_object] = ACTIONS(3272),
    [anon_sym_abstract] = ACTIONS(3272),
    [anon_sym_interface] = ACTIONS(3272),
    [anon_sym_enum] = ACTIONS(3272),
    [sym_html_comment] = ACTIONS(5),
  },
  [1453] = {
    [sym_comment] = STATE(1453),
    [ts_builtin_sym_end] = ACTIONS(3476),
    [sym_identifier] = ACTIONS(3130),
    [anon_sym_export] = ACTIONS(3130),
    [anon_sym_type] = ACTIONS(3130),
    [anon_sym_namespace] = ACTIONS(3130),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_typeof] = ACTIONS(3130),
    [anon_sym_import] = ACTIONS(3130),
    [anon_sym_with] = ACTIONS(3130),
    [anon_sym_var] = ACTIONS(3130),
    [anon_sym_let] = ACTIONS(3130),
    [anon_sym_const] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_if] = ACTIONS(3130),
    [anon_sym_switch] = ACTIONS(3130),
    [anon_sym_for] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [anon_sym_await] = ACTIONS(3130),
    [anon_sym_while] = ACTIONS(3130),
    [anon_sym_do] = ACTIONS(3130),
    [anon_sym_try] = ACTIONS(3130),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_continue] = ACTIONS(3130),
    [anon_sym_debugger] = ACTIONS(3130),
    [anon_sym_return] = ACTIONS(3130),
    [anon_sym_throw] = ACTIONS(3130),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_yield] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [anon_sym_LTtemplate_GT] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_class] = ACTIONS(3130),
    [anon_sym_async] = ACTIONS(3130),
    [anon_sym_function] = ACTIONS(3130),
    [anon_sym_new] = ACTIONS(3130),
    [anon_sym_using] = ACTIONS(3130),
    [anon_sym_PLUS] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3130),
    [anon_sym_SLASH] = ACTIONS(3130),
    [anon_sym_LT] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_void] = ACTIONS(3130),
    [anon_sym_delete] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3130),
    [sym_number] = ACTIONS(3130),
    [sym_private_property_identifier] = ACTIONS(3130),
    [sym_this] = ACTIONS(3130),
    [sym_super] = ACTIONS(3130),
    [sym_true] = ACTIONS(3130),
    [sym_false] = ACTIONS(3130),
    [sym_null] = ACTIONS(3130),
    [sym_undefined] = ACTIONS(3130),
    [anon_sym_AT] = ACTIONS(3130),
    [anon_sym_static] = ACTIONS(3130),
    [anon_sym_readonly] = ACTIONS(3130),
    [anon_sym_get] = ACTIONS(3130),
    [anon_sym_set] = ACTIONS(3130),
    [anon_sym_declare] = ACTIONS(3130),
    [anon_sym_public] = ACTIONS(3130),
    [anon_sym_private] = ACTIONS(3130),
    [anon_sym_protected] = ACTIONS(3130),
    [anon_sym_override] = ACTIONS(3130),
    [anon_sym_module] = ACTIONS(3130),
    [anon_sym_any] = ACTIONS(3130),
    [anon_sym_number] = ACTIONS(3130),
    [anon_sym_boolean] = ACTIONS(3130),
    [anon_sym_string] = ACTIONS(3130),
    [anon_sym_symbol] = ACTIONS(3130),
    [anon_sym_object] = ACTIONS(3130),
    [anon_sym_abstract] = ACTIONS(3130),
    [anon_sym_interface] = ACTIONS(3130),
    [anon_sym_enum] = ACTIONS(3130),
    [sym_html_comment] = ACTIONS(5),
  },
  [1454] = {
    [sym_comment] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [sym_identifier] = ACTIONS(3272),
    [anon_sym_export] = ACTIONS(3272),
    [anon_sym_type] = ACTIONS(3272),
    [anon_sym_namespace] = ACTIONS(3272),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_typeof] = ACTIONS(3272),
    [anon_sym_import] = ACTIONS(3272),
    [anon_sym_with] = ACTIONS(3272),
    [anon_sym_var] = ACTIONS(3272),
    [anon_sym_let] = ACTIONS(3272),
    [anon_sym_const] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_if] = ACTIONS(3272),
    [anon_sym_switch] = ACTIONS(3272),
    [anon_sym_for] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3272),
    [anon_sym_await] = ACTIONS(3272),
    [anon_sym_while] = ACTIONS(3272),
    [anon_sym_do] = ACTIONS(3272),
    [anon_sym_try] = ACTIONS(3272),
    [anon_sym_break] = ACTIONS(3272),
    [anon_sym_continue] = ACTIONS(3272),
    [anon_sym_debugger] = ACTIONS(3272),
    [anon_sym_return] = ACTIONS(3272),
    [anon_sym_throw] = ACTIONS(3272),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym_yield] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3272),
    [anon_sym_LTtemplate_GT] = ACTIONS(3272),
    [anon_sym_DQUOTE] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(3272),
    [anon_sym_class] = ACTIONS(3272),
    [anon_sym_async] = ACTIONS(3272),
    [anon_sym_function] = ACTIONS(3272),
    [anon_sym_new] = ACTIONS(3272),
    [anon_sym_using] = ACTIONS(3272),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_SLASH] = ACTIONS(3272),
    [anon_sym_LT] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [anon_sym_void] = ACTIONS(3272),
    [anon_sym_delete] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3272),
    [anon_sym_DASH_DASH] = ACTIONS(3272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3272),
    [sym_number] = ACTIONS(3272),
    [sym_private_property_identifier] = ACTIONS(3272),
    [sym_this] = ACTIONS(3272),
    [sym_super] = ACTIONS(3272),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_undefined] = ACTIONS(3272),
    [anon_sym_AT] = ACTIONS(3272),
    [anon_sym_static] = ACTIONS(3272),
    [anon_sym_readonly] = ACTIONS(3272),
    [anon_sym_get] = ACTIONS(3272),
    [anon_sym_set] = ACTIONS(3272),
    [anon_sym_declare] = ACTIONS(3272),
    [anon_sym_public] = ACTIONS(3272),
    [anon_sym_private] = ACTIONS(3272),
    [anon_sym_protected] = ACTIONS(3272),
    [anon_sym_override] = ACTIONS(3272),
    [anon_sym_module] = ACTIONS(3272),
    [anon_sym_any] = ACTIONS(3272),
    [anon_sym_number] = ACTIONS(3272),
    [anon_sym_boolean] = ACTIONS(3272),
    [anon_sym_string] = ACTIONS(3272),
    [anon_sym_symbol] = ACTIONS(3272),
    [anon_sym_object] = ACTIONS(3272),
    [anon_sym_abstract] = ACTIONS(3272),
    [anon_sym_interface] = ACTIONS(3272),
    [anon_sym_enum] = ACTIONS(3272),
    [sym_html_comment] = ACTIONS(5),
  },
  [1455] = {
    [sym_comment] = STATE(1455),
    [ts_builtin_sym_end] = ACTIONS(3548),
    [sym_identifier] = ACTIONS(3284),
    [anon_sym_export] = ACTIONS(3284),
    [anon_sym_type] = ACTIONS(3284),
    [anon_sym_namespace] = ACTIONS(3284),
    [anon_sym_LBRACE] = ACTIONS(3284),
    [anon_sym_RBRACE] = ACTIONS(3284),
    [anon_sym_typeof] = ACTIONS(3284),
    [anon_sym_import] = ACTIONS(3284),
    [anon_sym_with] = ACTIONS(3284),
    [anon_sym_var] = ACTIONS(3284),
    [anon_sym_let] = ACTIONS(3284),
    [anon_sym_const] = ACTIONS(3284),
    [anon_sym_BANG] = ACTIONS(3284),
    [anon_sym_if] = ACTIONS(3284),
    [anon_sym_switch] = ACTIONS(3284),
    [anon_sym_for] = ACTIONS(3284),
    [anon_sym_LPAREN] = ACTIONS(3284),
    [anon_sym_await] = ACTIONS(3284),
    [anon_sym_while] = ACTIONS(3284),
    [anon_sym_do] = ACTIONS(3284),
    [anon_sym_try] = ACTIONS(3284),
    [anon_sym_break] = ACTIONS(3284),
    [anon_sym_continue] = ACTIONS(3284),
    [anon_sym_debugger] = ACTIONS(3284),
    [anon_sym_return] = ACTIONS(3284),
    [anon_sym_throw] = ACTIONS(3284),
    [anon_sym_SEMI] = ACTIONS(3284),
    [anon_sym_yield] = ACTIONS(3284),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [anon_sym_LTtemplate_GT] = ACTIONS(3284),
    [anon_sym_DQUOTE] = ACTIONS(3284),
    [anon_sym_SQUOTE] = ACTIONS(3284),
    [anon_sym_class] = ACTIONS(3284),
    [anon_sym_async] = ACTIONS(3284),
    [anon_sym_function] = ACTIONS(3284),
    [anon_sym_new] = ACTIONS(3284),
    [anon_sym_using] = ACTIONS(3284),
    [anon_sym_PLUS] = ACTIONS(3284),
    [anon_sym_DASH] = ACTIONS(3284),
    [anon_sym_SLASH] = ACTIONS(3284),
    [anon_sym_LT] = ACTIONS(3284),
    [anon_sym_TILDE] = ACTIONS(3284),
    [anon_sym_void] = ACTIONS(3284),
    [anon_sym_delete] = ACTIONS(3284),
    [anon_sym_PLUS_PLUS] = ACTIONS(3284),
    [anon_sym_DASH_DASH] = ACTIONS(3284),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3284),
    [sym_number] = ACTIONS(3284),
    [sym_private_property_identifier] = ACTIONS(3284),
    [sym_this] = ACTIONS(3284),
    [sym_super] = ACTIONS(3284),
    [sym_true] = ACTIONS(3284),
    [sym_false] = ACTIONS(3284),
    [sym_null] = ACTIONS(3284),
    [sym_undefined] = ACTIONS(3284),
    [anon_sym_AT] = ACTIONS(3284),
    [anon_sym_static] = ACTIONS(3284),
    [anon_sym_readonly] = ACTIONS(3284),
    [anon_sym_get] = ACTIONS(3284),
    [anon_sym_set] = ACTIONS(3284),
    [anon_sym_declare] = ACTIONS(3284),
    [anon_sym_public] = ACTIONS(3284),
    [anon_sym_private] = ACTIONS(3284),
    [anon_sym_protected] = ACTIONS(3284),
    [anon_sym_override] = ACTIONS(3284),
    [anon_sym_module] = ACTIONS(3284),
    [anon_sym_any] = ACTIONS(3284),
    [anon_sym_number] = ACTIONS(3284),
    [anon_sym_boolean] = ACTIONS(3284),
    [anon_sym_string] = ACTIONS(3284),
    [anon_sym_symbol] = ACTIONS(3284),
    [anon_sym_object] = ACTIONS(3284),
    [anon_sym_abstract] = ACTIONS(3284),
    [anon_sym_interface] = ACTIONS(3284),
    [anon_sym_enum] = ACTIONS(3284),
    [sym_html_comment] = ACTIONS(5),
  },
  [1456] = {
    [sym_comment] = STATE(1456),
    [ts_builtin_sym_end] = ACTIONS(3474),
    [sym_identifier] = ACTIONS(3184),
    [anon_sym_export] = ACTIONS(3184),
    [anon_sym_type] = ACTIONS(3184),
    [anon_sym_namespace] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_typeof] = ACTIONS(3184),
    [anon_sym_import] = ACTIONS(3184),
    [anon_sym_with] = ACTIONS(3184),
    [anon_sym_var] = ACTIONS(3184),
    [anon_sym_let] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3184),
    [anon_sym_await] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_try] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_debugger] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_throw] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3184),
    [anon_sym_LTtemplate_GT] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [anon_sym_class] = ACTIONS(3184),
    [anon_sym_async] = ACTIONS(3184),
    [anon_sym_function] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_using] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_SLASH] = ACTIONS(3184),
    [anon_sym_LT] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3184),
    [anon_sym_void] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3184),
    [sym_number] = ACTIONS(3184),
    [sym_private_property_identifier] = ACTIONS(3184),
    [sym_this] = ACTIONS(3184),
    [sym_super] = ACTIONS(3184),
    [sym_true] = ACTIONS(3184),
    [sym_false] = ACTIONS(3184),
    [sym_null] = ACTIONS(3184),
    [sym_undefined] = ACTIONS(3184),
    [anon_sym_AT] = ACTIONS(3184),
    [anon_sym_static] = ACTIONS(3184),
    [anon_sym_readonly] = ACTIONS(3184),
    [anon_sym_get] = ACTIONS(3184),
    [anon_sym_set] = ACTIONS(3184),
    [anon_sym_declare] = ACTIONS(3184),
    [anon_sym_public] = ACTIONS(3184),
    [anon_sym_private] = ACTIONS(3184),
    [anon_sym_protected] = ACTIONS(3184),
    [anon_sym_override] = ACTIONS(3184),
    [anon_sym_module] = ACTIONS(3184),
    [anon_sym_any] = ACTIONS(3184),
    [anon_sym_number] = ACTIONS(3184),
    [anon_sym_boolean] = ACTIONS(3184),
    [anon_sym_string] = ACTIONS(3184),
    [anon_sym_symbol] = ACTIONS(3184),
    [anon_sym_object] = ACTIONS(3184),
    [anon_sym_abstract] = ACTIONS(3184),
    [anon_sym_interface] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [sym_html_comment] = ACTIONS(5),
  },
  [1457] = {
    [sym_comment] = STATE(1457),
    [ts_builtin_sym_end] = ACTIONS(3562),
    [sym_identifier] = ACTIONS(3304),
    [anon_sym_export] = ACTIONS(3304),
    [anon_sym_type] = ACTIONS(3304),
    [anon_sym_namespace] = ACTIONS(3304),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_RBRACE] = ACTIONS(3304),
    [anon_sym_typeof] = ACTIONS(3304),
    [anon_sym_import] = ACTIONS(3304),
    [anon_sym_with] = ACTIONS(3304),
    [anon_sym_var] = ACTIONS(3304),
    [anon_sym_let] = ACTIONS(3304),
    [anon_sym_const] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_if] = ACTIONS(3304),
    [anon_sym_switch] = ACTIONS(3304),
    [anon_sym_for] = ACTIONS(3304),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_await] = ACTIONS(3304),
    [anon_sym_while] = ACTIONS(3304),
    [anon_sym_do] = ACTIONS(3304),
    [anon_sym_try] = ACTIONS(3304),
    [anon_sym_break] = ACTIONS(3304),
    [anon_sym_continue] = ACTIONS(3304),
    [anon_sym_debugger] = ACTIONS(3304),
    [anon_sym_return] = ACTIONS(3304),
    [anon_sym_throw] = ACTIONS(3304),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym_yield] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LTtemplate_GT] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [anon_sym_class] = ACTIONS(3304),
    [anon_sym_async] = ACTIONS(3304),
    [anon_sym_function] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3304),
    [anon_sym_using] = ACTIONS(3304),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3304),
    [anon_sym_void] = ACTIONS(3304),
    [anon_sym_delete] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3304),
    [sym_number] = ACTIONS(3304),
    [sym_private_property_identifier] = ACTIONS(3304),
    [sym_this] = ACTIONS(3304),
    [sym_super] = ACTIONS(3304),
    [sym_true] = ACTIONS(3304),
    [sym_false] = ACTIONS(3304),
    [sym_null] = ACTIONS(3304),
    [sym_undefined] = ACTIONS(3304),
    [anon_sym_AT] = ACTIONS(3304),
    [anon_sym_static] = ACTIONS(3304),
    [anon_sym_readonly] = ACTIONS(3304),
    [anon_sym_get] = ACTIONS(3304),
    [anon_sym_set] = ACTIONS(3304),
    [anon_sym_declare] = ACTIONS(3304),
    [anon_sym_public] = ACTIONS(3304),
    [anon_sym_private] = ACTIONS(3304),
    [anon_sym_protected] = ACTIONS(3304),
    [anon_sym_override] = ACTIONS(3304),
    [anon_sym_module] = ACTIONS(3304),
    [anon_sym_any] = ACTIONS(3304),
    [anon_sym_number] = ACTIONS(3304),
    [anon_sym_boolean] = ACTIONS(3304),
    [anon_sym_string] = ACTIONS(3304),
    [anon_sym_symbol] = ACTIONS(3304),
    [anon_sym_object] = ACTIONS(3304),
    [anon_sym_abstract] = ACTIONS(3304),
    [anon_sym_interface] = ACTIONS(3304),
    [anon_sym_enum] = ACTIONS(3304),
    [sym_html_comment] = ACTIONS(5),
  },
  [1458] = {
    [sym_comment] = STATE(1458),
    [ts_builtin_sym_end] = ACTIONS(3470),
    [sym_identifier] = ACTIONS(3134),
    [anon_sym_export] = ACTIONS(3134),
    [anon_sym_type] = ACTIONS(3134),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [anon_sym_typeof] = ACTIONS(3134),
    [anon_sym_import] = ACTIONS(3134),
    [anon_sym_with] = ACTIONS(3134),
    [anon_sym_var] = ACTIONS(3134),
    [anon_sym_let] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3134),
    [anon_sym_await] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_debugger] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym_yield] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3134),
    [anon_sym_LTtemplate_GT] = ACTIONS(3134),
    [anon_sym_DQUOTE] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_async] = ACTIONS(3134),
    [anon_sym_function] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_using] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_SLASH] = ACTIONS(3134),
    [anon_sym_LT] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_void] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_PLUS_PLUS] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3134),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3134),
    [sym_number] = ACTIONS(3134),
    [sym_private_property_identifier] = ACTIONS(3134),
    [sym_this] = ACTIONS(3134),
    [sym_super] = ACTIONS(3134),
    [sym_true] = ACTIONS(3134),
    [sym_false] = ACTIONS(3134),
    [sym_null] = ACTIONS(3134),
    [sym_undefined] = ACTIONS(3134),
    [anon_sym_AT] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_readonly] = ACTIONS(3134),
    [anon_sym_get] = ACTIONS(3134),
    [anon_sym_set] = ACTIONS(3134),
    [anon_sym_declare] = ACTIONS(3134),
    [anon_sym_public] = ACTIONS(3134),
    [anon_sym_private] = ACTIONS(3134),
    [anon_sym_protected] = ACTIONS(3134),
    [anon_sym_override] = ACTIONS(3134),
    [anon_sym_module] = ACTIONS(3134),
    [anon_sym_any] = ACTIONS(3134),
    [anon_sym_number] = ACTIONS(3134),
    [anon_sym_boolean] = ACTIONS(3134),
    [anon_sym_string] = ACTIONS(3134),
    [anon_sym_symbol] = ACTIONS(3134),
    [anon_sym_object] = ACTIONS(3134),
    [anon_sym_abstract] = ACTIONS(3134),
    [anon_sym_interface] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [sym_html_comment] = ACTIONS(5),
  },
  [1459] = {
    [sym_comment] = STATE(1459),
    [ts_builtin_sym_end] = ACTIONS(3384),
    [sym_identifier] = ACTIONS(3278),
    [anon_sym_export] = ACTIONS(3278),
    [anon_sym_type] = ACTIONS(3278),
    [anon_sym_namespace] = ACTIONS(3278),
    [anon_sym_LBRACE] = ACTIONS(3278),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_typeof] = ACTIONS(3278),
    [anon_sym_import] = ACTIONS(3278),
    [anon_sym_with] = ACTIONS(3278),
    [anon_sym_var] = ACTIONS(3278),
    [anon_sym_let] = ACTIONS(3278),
    [anon_sym_const] = ACTIONS(3278),
    [anon_sym_BANG] = ACTIONS(3278),
    [anon_sym_if] = ACTIONS(3278),
    [anon_sym_switch] = ACTIONS(3278),
    [anon_sym_for] = ACTIONS(3278),
    [anon_sym_LPAREN] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3278),
    [anon_sym_while] = ACTIONS(3278),
    [anon_sym_do] = ACTIONS(3278),
    [anon_sym_try] = ACTIONS(3278),
    [anon_sym_break] = ACTIONS(3278),
    [anon_sym_continue] = ACTIONS(3278),
    [anon_sym_debugger] = ACTIONS(3278),
    [anon_sym_return] = ACTIONS(3278),
    [anon_sym_throw] = ACTIONS(3278),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym_yield] = ACTIONS(3278),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_LTtemplate_GT] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_class] = ACTIONS(3278),
    [anon_sym_async] = ACTIONS(3278),
    [anon_sym_function] = ACTIONS(3278),
    [anon_sym_new] = ACTIONS(3278),
    [anon_sym_using] = ACTIONS(3278),
    [anon_sym_PLUS] = ACTIONS(3278),
    [anon_sym_DASH] = ACTIONS(3278),
    [anon_sym_SLASH] = ACTIONS(3278),
    [anon_sym_LT] = ACTIONS(3278),
    [anon_sym_TILDE] = ACTIONS(3278),
    [anon_sym_void] = ACTIONS(3278),
    [anon_sym_delete] = ACTIONS(3278),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3278),
    [sym_number] = ACTIONS(3278),
    [sym_private_property_identifier] = ACTIONS(3278),
    [sym_this] = ACTIONS(3278),
    [sym_super] = ACTIONS(3278),
    [sym_true] = ACTIONS(3278),
    [sym_false] = ACTIONS(3278),
    [sym_null] = ACTIONS(3278),
    [sym_undefined] = ACTIONS(3278),
    [anon_sym_AT] = ACTIONS(3278),
    [anon_sym_static] = ACTIONS(3278),
    [anon_sym_readonly] = ACTIONS(3278),
    [anon_sym_get] = ACTIONS(3278),
    [anon_sym_set] = ACTIONS(3278),
    [anon_sym_declare] = ACTIONS(3278),
    [anon_sym_public] = ACTIONS(3278),
    [anon_sym_private] = ACTIONS(3278),
    [anon_sym_protected] = ACTIONS(3278),
    [anon_sym_override] = ACTIONS(3278),
    [anon_sym_module] = ACTIONS(3278),
    [anon_sym_any] = ACTIONS(3278),
    [anon_sym_number] = ACTIONS(3278),
    [anon_sym_boolean] = ACTIONS(3278),
    [anon_sym_string] = ACTIONS(3278),
    [anon_sym_symbol] = ACTIONS(3278),
    [anon_sym_object] = ACTIONS(3278),
    [anon_sym_abstract] = ACTIONS(3278),
    [anon_sym_interface] = ACTIONS(3278),
    [anon_sym_enum] = ACTIONS(3278),
    [sym_html_comment] = ACTIONS(5),
  },
  [1460] = {
    [sym_comment] = STATE(1460),
    [ts_builtin_sym_end] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3160),
    [anon_sym_export] = ACTIONS(3160),
    [anon_sym_type] = ACTIONS(3160),
    [anon_sym_namespace] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_typeof] = ACTIONS(3160),
    [anon_sym_import] = ACTIONS(3160),
    [anon_sym_with] = ACTIONS(3160),
    [anon_sym_var] = ACTIONS(3160),
    [anon_sym_let] = ACTIONS(3160),
    [anon_sym_const] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_if] = ACTIONS(3160),
    [anon_sym_switch] = ACTIONS(3160),
    [anon_sym_for] = ACTIONS(3160),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_await] = ACTIONS(3160),
    [anon_sym_while] = ACTIONS(3160),
    [anon_sym_do] = ACTIONS(3160),
    [anon_sym_try] = ACTIONS(3160),
    [anon_sym_break] = ACTIONS(3160),
    [anon_sym_continue] = ACTIONS(3160),
    [anon_sym_debugger] = ACTIONS(3160),
    [anon_sym_return] = ACTIONS(3160),
    [anon_sym_throw] = ACTIONS(3160),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym_yield] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_LTtemplate_GT] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_class] = ACTIONS(3160),
    [anon_sym_async] = ACTIONS(3160),
    [anon_sym_function] = ACTIONS(3160),
    [anon_sym_new] = ACTIONS(3160),
    [anon_sym_using] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3160),
    [anon_sym_SLASH] = ACTIONS(3160),
    [anon_sym_LT] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_void] = ACTIONS(3160),
    [anon_sym_delete] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3160),
    [sym_number] = ACTIONS(3160),
    [sym_private_property_identifier] = ACTIONS(3160),
    [sym_this] = ACTIONS(3160),
    [sym_super] = ACTIONS(3160),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [sym_null] = ACTIONS(3160),
    [sym_undefined] = ACTIONS(3160),
    [anon_sym_AT] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_readonly] = ACTIONS(3160),
    [anon_sym_get] = ACTIONS(3160),
    [anon_sym_set] = ACTIONS(3160),
    [anon_sym_declare] = ACTIONS(3160),
    [anon_sym_public] = ACTIONS(3160),
    [anon_sym_private] = ACTIONS(3160),
    [anon_sym_protected] = ACTIONS(3160),
    [anon_sym_override] = ACTIONS(3160),
    [anon_sym_module] = ACTIONS(3160),
    [anon_sym_any] = ACTIONS(3160),
    [anon_sym_number] = ACTIONS(3160),
    [anon_sym_boolean] = ACTIONS(3160),
    [anon_sym_string] = ACTIONS(3160),
    [anon_sym_symbol] = ACTIONS(3160),
    [anon_sym_object] = ACTIONS(3160),
    [anon_sym_abstract] = ACTIONS(3160),
    [anon_sym_interface] = ACTIONS(3160),
    [anon_sym_enum] = ACTIONS(3160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1461] = {
    [sym_comment] = STATE(1461),
    [ts_builtin_sym_end] = ACTIONS(3460),
    [sym_identifier] = ACTIONS(3140),
    [anon_sym_export] = ACTIONS(3140),
    [anon_sym_type] = ACTIONS(3140),
    [anon_sym_namespace] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_RBRACE] = ACTIONS(3140),
    [anon_sym_typeof] = ACTIONS(3140),
    [anon_sym_import] = ACTIONS(3140),
    [anon_sym_with] = ACTIONS(3140),
    [anon_sym_var] = ACTIONS(3140),
    [anon_sym_let] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_if] = ACTIONS(3140),
    [anon_sym_switch] = ACTIONS(3140),
    [anon_sym_for] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3140),
    [anon_sym_await] = ACTIONS(3140),
    [anon_sym_while] = ACTIONS(3140),
    [anon_sym_do] = ACTIONS(3140),
    [anon_sym_try] = ACTIONS(3140),
    [anon_sym_break] = ACTIONS(3140),
    [anon_sym_continue] = ACTIONS(3140),
    [anon_sym_debugger] = ACTIONS(3140),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_throw] = ACTIONS(3140),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym_yield] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(3140),
    [anon_sym_LTtemplate_GT] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3140),
    [anon_sym_async] = ACTIONS(3140),
    [anon_sym_function] = ACTIONS(3140),
    [anon_sym_new] = ACTIONS(3140),
    [anon_sym_using] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3140),
    [anon_sym_SLASH] = ACTIONS(3140),
    [anon_sym_LT] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_void] = ACTIONS(3140),
    [anon_sym_delete] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3140),
    [sym_number] = ACTIONS(3140),
    [sym_private_property_identifier] = ACTIONS(3140),
    [sym_this] = ACTIONS(3140),
    [sym_super] = ACTIONS(3140),
    [sym_true] = ACTIONS(3140),
    [sym_false] = ACTIONS(3140),
    [sym_null] = ACTIONS(3140),
    [sym_undefined] = ACTIONS(3140),
    [anon_sym_AT] = ACTIONS(3140),
    [anon_sym_static] = ACTIONS(3140),
    [anon_sym_readonly] = ACTIONS(3140),
    [anon_sym_get] = ACTIONS(3140),
    [anon_sym_set] = ACTIONS(3140),
    [anon_sym_declare] = ACTIONS(3140),
    [anon_sym_public] = ACTIONS(3140),
    [anon_sym_private] = ACTIONS(3140),
    [anon_sym_protected] = ACTIONS(3140),
    [anon_sym_override] = ACTIONS(3140),
    [anon_sym_module] = ACTIONS(3140),
    [anon_sym_any] = ACTIONS(3140),
    [anon_sym_number] = ACTIONS(3140),
    [anon_sym_boolean] = ACTIONS(3140),
    [anon_sym_string] = ACTIONS(3140),
    [anon_sym_symbol] = ACTIONS(3140),
    [anon_sym_object] = ACTIONS(3140),
    [anon_sym_abstract] = ACTIONS(3140),
    [anon_sym_interface] = ACTIONS(3140),
    [anon_sym_enum] = ACTIONS(3140),
    [sym_html_comment] = ACTIONS(5),
  },
  [1462] = {
    [sym_comment] = STATE(1462),
    [ts_builtin_sym_end] = ACTIONS(3494),
    [sym_identifier] = ACTIONS(3182),
    [anon_sym_export] = ACTIONS(3182),
    [anon_sym_type] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_typeof] = ACTIONS(3182),
    [anon_sym_import] = ACTIONS(3182),
    [anon_sym_with] = ACTIONS(3182),
    [anon_sym_var] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3182),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3182),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_await] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_do] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3182),
    [anon_sym_continue] = ACTIONS(3182),
    [anon_sym_debugger] = ACTIONS(3182),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_throw] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_LTtemplate_GT] = ACTIONS(3182),
    [anon_sym_DQUOTE] = ACTIONS(3182),
    [anon_sym_SQUOTE] = ACTIONS(3182),
    [anon_sym_class] = ACTIONS(3182),
    [anon_sym_async] = ACTIONS(3182),
    [anon_sym_function] = ACTIONS(3182),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_using] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_SLASH] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(3182),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_void] = ACTIONS(3182),
    [anon_sym_delete] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3182),
    [sym_number] = ACTIONS(3182),
    [sym_private_property_identifier] = ACTIONS(3182),
    [sym_this] = ACTIONS(3182),
    [sym_super] = ACTIONS(3182),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [sym_null] = ACTIONS(3182),
    [sym_undefined] = ACTIONS(3182),
    [anon_sym_AT] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_readonly] = ACTIONS(3182),
    [anon_sym_get] = ACTIONS(3182),
    [anon_sym_set] = ACTIONS(3182),
    [anon_sym_declare] = ACTIONS(3182),
    [anon_sym_public] = ACTIONS(3182),
    [anon_sym_private] = ACTIONS(3182),
    [anon_sym_protected] = ACTIONS(3182),
    [anon_sym_override] = ACTIONS(3182),
    [anon_sym_module] = ACTIONS(3182),
    [anon_sym_any] = ACTIONS(3182),
    [anon_sym_number] = ACTIONS(3182),
    [anon_sym_boolean] = ACTIONS(3182),
    [anon_sym_string] = ACTIONS(3182),
    [anon_sym_symbol] = ACTIONS(3182),
    [anon_sym_object] = ACTIONS(3182),
    [anon_sym_abstract] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3182),
    [anon_sym_enum] = ACTIONS(3182),
    [sym_html_comment] = ACTIONS(5),
  },
  [1463] = {
    [sym_comment] = STATE(1463),
    [ts_builtin_sym_end] = ACTIONS(3458),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [1464] = {
    [sym_comment] = STATE(1464),
    [ts_builtin_sym_end] = ACTIONS(3468),
    [sym_identifier] = ACTIONS(3196),
    [anon_sym_export] = ACTIONS(3196),
    [anon_sym_type] = ACTIONS(3196),
    [anon_sym_namespace] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3196),
    [anon_sym_RBRACE] = ACTIONS(3196),
    [anon_sym_typeof] = ACTIONS(3196),
    [anon_sym_import] = ACTIONS(3196),
    [anon_sym_with] = ACTIONS(3196),
    [anon_sym_var] = ACTIONS(3196),
    [anon_sym_let] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3196),
    [anon_sym_await] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_debugger] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_throw] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_LTtemplate_GT] = ACTIONS(3196),
    [anon_sym_DQUOTE] = ACTIONS(3196),
    [anon_sym_SQUOTE] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_async] = ACTIONS(3196),
    [anon_sym_function] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [anon_sym_using] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_SLASH] = ACTIONS(3196),
    [anon_sym_LT] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [anon_sym_void] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_PLUS_PLUS] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3196),
    [sym_number] = ACTIONS(3196),
    [sym_private_property_identifier] = ACTIONS(3196),
    [sym_this] = ACTIONS(3196),
    [sym_super] = ACTIONS(3196),
    [sym_true] = ACTIONS(3196),
    [sym_false] = ACTIONS(3196),
    [sym_null] = ACTIONS(3196),
    [sym_undefined] = ACTIONS(3196),
    [anon_sym_AT] = ACTIONS(3196),
    [anon_sym_static] = ACTIONS(3196),
    [anon_sym_readonly] = ACTIONS(3196),
    [anon_sym_get] = ACTIONS(3196),
    [anon_sym_set] = ACTIONS(3196),
    [anon_sym_declare] = ACTIONS(3196),
    [anon_sym_public] = ACTIONS(3196),
    [anon_sym_private] = ACTIONS(3196),
    [anon_sym_protected] = ACTIONS(3196),
    [anon_sym_override] = ACTIONS(3196),
    [anon_sym_module] = ACTIONS(3196),
    [anon_sym_any] = ACTIONS(3196),
    [anon_sym_number] = ACTIONS(3196),
    [anon_sym_boolean] = ACTIONS(3196),
    [anon_sym_string] = ACTIONS(3196),
    [anon_sym_symbol] = ACTIONS(3196),
    [anon_sym_object] = ACTIONS(3196),
    [anon_sym_abstract] = ACTIONS(3196),
    [anon_sym_interface] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [sym_html_comment] = ACTIONS(5),
  },
  [1465] = {
    [sym_comment] = STATE(1465),
    [ts_builtin_sym_end] = ACTIONS(3458),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [1466] = {
    [sym_comment] = STATE(1466),
    [ts_builtin_sym_end] = ACTIONS(3458),
    [sym_identifier] = ACTIONS(3138),
    [anon_sym_export] = ACTIONS(3138),
    [anon_sym_type] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_typeof] = ACTIONS(3138),
    [anon_sym_import] = ACTIONS(3138),
    [anon_sym_with] = ACTIONS(3138),
    [anon_sym_var] = ACTIONS(3138),
    [anon_sym_let] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_LPAREN] = ACTIONS(3138),
    [anon_sym_await] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_debugger] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_LTtemplate_GT] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_async] = ACTIONS(3138),
    [anon_sym_function] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_SLASH] = ACTIONS(3138),
    [anon_sym_LT] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_void] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3138),
    [sym_number] = ACTIONS(3138),
    [sym_private_property_identifier] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
    [sym_super] = ACTIONS(3138),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [sym_null] = ACTIONS(3138),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_AT] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_readonly] = ACTIONS(3138),
    [anon_sym_get] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(3138),
    [anon_sym_declare] = ACTIONS(3138),
    [anon_sym_public] = ACTIONS(3138),
    [anon_sym_private] = ACTIONS(3138),
    [anon_sym_protected] = ACTIONS(3138),
    [anon_sym_override] = ACTIONS(3138),
    [anon_sym_module] = ACTIONS(3138),
    [anon_sym_any] = ACTIONS(3138),
    [anon_sym_number] = ACTIONS(3138),
    [anon_sym_boolean] = ACTIONS(3138),
    [anon_sym_string] = ACTIONS(3138),
    [anon_sym_symbol] = ACTIONS(3138),
    [anon_sym_object] = ACTIONS(3138),
    [anon_sym_abstract] = ACTIONS(3138),
    [anon_sym_interface] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [sym_html_comment] = ACTIONS(5),
  },
  [1467] = {
    [sym_comment] = STATE(1467),
    [ts_builtin_sym_end] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3168),
    [anon_sym_export] = ACTIONS(3168),
    [anon_sym_type] = ACTIONS(3168),
    [anon_sym_namespace] = ACTIONS(3168),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_typeof] = ACTIONS(3168),
    [anon_sym_import] = ACTIONS(3168),
    [anon_sym_with] = ACTIONS(3168),
    [anon_sym_var] = ACTIONS(3168),
    [anon_sym_let] = ACTIONS(3168),
    [anon_sym_const] = ACTIONS(3168),
    [anon_sym_BANG] = ACTIONS(3168),
    [anon_sym_if] = ACTIONS(3168),
    [anon_sym_switch] = ACTIONS(3168),
    [anon_sym_for] = ACTIONS(3168),
    [anon_sym_LPAREN] = ACTIONS(3168),
    [anon_sym_await] = ACTIONS(3168),
    [anon_sym_while] = ACTIONS(3168),
    [anon_sym_do] = ACTIONS(3168),
    [anon_sym_try] = ACTIONS(3168),
    [anon_sym_break] = ACTIONS(3168),
    [anon_sym_continue] = ACTIONS(3168),
    [anon_sym_debugger] = ACTIONS(3168),
    [anon_sym_return] = ACTIONS(3168),
    [anon_sym_throw] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_yield] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_LTtemplate_GT] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_class] = ACTIONS(3168),
    [anon_sym_async] = ACTIONS(3168),
    [anon_sym_function] = ACTIONS(3168),
    [anon_sym_new] = ACTIONS(3168),
    [anon_sym_using] = ACTIONS(3168),
    [anon_sym_PLUS] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3168),
    [anon_sym_SLASH] = ACTIONS(3168),
    [anon_sym_LT] = ACTIONS(3168),
    [anon_sym_TILDE] = ACTIONS(3168),
    [anon_sym_void] = ACTIONS(3168),
    [anon_sym_delete] = ACTIONS(3168),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3168),
    [sym_number] = ACTIONS(3168),
    [sym_private_property_identifier] = ACTIONS(3168),
    [sym_this] = ACTIONS(3168),
    [sym_super] = ACTIONS(3168),
    [sym_true] = ACTIONS(3168),
    [sym_false] = ACTIONS(3168),
    [sym_null] = ACTIONS(3168),
    [sym_undefined] = ACTIONS(3168),
    [anon_sym_AT] = ACTIONS(3168),
    [anon_sym_static] = ACTIONS(3168),
    [anon_sym_readonly] = ACTIONS(3168),
    [anon_sym_get] = ACTIONS(3168),
    [anon_sym_set] = ACTIONS(3168),
    [anon_sym_declare] = ACTIONS(3168),
    [anon_sym_public] = ACTIONS(3168),
    [anon_sym_private] = ACTIONS(3168),
    [anon_sym_protected] = ACTIONS(3168),
    [anon_sym_override] = ACTIONS(3168),
    [anon_sym_module] = ACTIONS(3168),
    [anon_sym_any] = ACTIONS(3168),
    [anon_sym_number] = ACTIONS(3168),
    [anon_sym_boolean] = ACTIONS(3168),
    [anon_sym_string] = ACTIONS(3168),
    [anon_sym_symbol] = ACTIONS(3168),
    [anon_sym_object] = ACTIONS(3168),
    [anon_sym_abstract] = ACTIONS(3168),
    [anon_sym_interface] = ACTIONS(3168),
    [anon_sym_enum] = ACTIONS(3168),
    [sym_html_comment] = ACTIONS(5),
  },
  [1468] = {
    [sym_comment] = STATE(1468),
    [ts_builtin_sym_end] = ACTIONS(3504),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1469] = {
    [sym_comment] = STATE(1469),
    [ts_builtin_sym_end] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3288),
    [anon_sym_export] = ACTIONS(3288),
    [anon_sym_type] = ACTIONS(3288),
    [anon_sym_namespace] = ACTIONS(3288),
    [anon_sym_LBRACE] = ACTIONS(3288),
    [anon_sym_RBRACE] = ACTIONS(3288),
    [anon_sym_typeof] = ACTIONS(3288),
    [anon_sym_import] = ACTIONS(3288),
    [anon_sym_with] = ACTIONS(3288),
    [anon_sym_var] = ACTIONS(3288),
    [anon_sym_let] = ACTIONS(3288),
    [anon_sym_const] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3288),
    [anon_sym_if] = ACTIONS(3288),
    [anon_sym_switch] = ACTIONS(3288),
    [anon_sym_for] = ACTIONS(3288),
    [anon_sym_LPAREN] = ACTIONS(3288),
    [anon_sym_await] = ACTIONS(3288),
    [anon_sym_while] = ACTIONS(3288),
    [anon_sym_do] = ACTIONS(3288),
    [anon_sym_try] = ACTIONS(3288),
    [anon_sym_break] = ACTIONS(3288),
    [anon_sym_continue] = ACTIONS(3288),
    [anon_sym_debugger] = ACTIONS(3288),
    [anon_sym_return] = ACTIONS(3288),
    [anon_sym_throw] = ACTIONS(3288),
    [anon_sym_SEMI] = ACTIONS(3288),
    [anon_sym_yield] = ACTIONS(3288),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_LTtemplate_GT] = ACTIONS(3288),
    [anon_sym_DQUOTE] = ACTIONS(3288),
    [anon_sym_SQUOTE] = ACTIONS(3288),
    [anon_sym_class] = ACTIONS(3288),
    [anon_sym_async] = ACTIONS(3288),
    [anon_sym_function] = ACTIONS(3288),
    [anon_sym_new] = ACTIONS(3288),
    [anon_sym_using] = ACTIONS(3288),
    [anon_sym_PLUS] = ACTIONS(3288),
    [anon_sym_DASH] = ACTIONS(3288),
    [anon_sym_SLASH] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3288),
    [anon_sym_TILDE] = ACTIONS(3288),
    [anon_sym_void] = ACTIONS(3288),
    [anon_sym_delete] = ACTIONS(3288),
    [anon_sym_PLUS_PLUS] = ACTIONS(3288),
    [anon_sym_DASH_DASH] = ACTIONS(3288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3288),
    [sym_number] = ACTIONS(3288),
    [sym_private_property_identifier] = ACTIONS(3288),
    [sym_this] = ACTIONS(3288),
    [sym_super] = ACTIONS(3288),
    [sym_true] = ACTIONS(3288),
    [sym_false] = ACTIONS(3288),
    [sym_null] = ACTIONS(3288),
    [sym_undefined] = ACTIONS(3288),
    [anon_sym_AT] = ACTIONS(3288),
    [anon_sym_static] = ACTIONS(3288),
    [anon_sym_readonly] = ACTIONS(3288),
    [anon_sym_get] = ACTIONS(3288),
    [anon_sym_set] = ACTIONS(3288),
    [anon_sym_declare] = ACTIONS(3288),
    [anon_sym_public] = ACTIONS(3288),
    [anon_sym_private] = ACTIONS(3288),
    [anon_sym_protected] = ACTIONS(3288),
    [anon_sym_override] = ACTIONS(3288),
    [anon_sym_module] = ACTIONS(3288),
    [anon_sym_any] = ACTIONS(3288),
    [anon_sym_number] = ACTIONS(3288),
    [anon_sym_boolean] = ACTIONS(3288),
    [anon_sym_string] = ACTIONS(3288),
    [anon_sym_symbol] = ACTIONS(3288),
    [anon_sym_object] = ACTIONS(3288),
    [anon_sym_abstract] = ACTIONS(3288),
    [anon_sym_interface] = ACTIONS(3288),
    [anon_sym_enum] = ACTIONS(3288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1470] = {
    [sym_comment] = STATE(1470),
    [ts_builtin_sym_end] = ACTIONS(3576),
    [sym_identifier] = ACTIONS(3326),
    [anon_sym_export] = ACTIONS(3326),
    [anon_sym_type] = ACTIONS(3326),
    [anon_sym_namespace] = ACTIONS(3326),
    [anon_sym_LBRACE] = ACTIONS(3326),
    [anon_sym_RBRACE] = ACTIONS(3326),
    [anon_sym_typeof] = ACTIONS(3326),
    [anon_sym_import] = ACTIONS(3326),
    [anon_sym_with] = ACTIONS(3326),
    [anon_sym_var] = ACTIONS(3326),
    [anon_sym_let] = ACTIONS(3326),
    [anon_sym_const] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_if] = ACTIONS(3326),
    [anon_sym_switch] = ACTIONS(3326),
    [anon_sym_for] = ACTIONS(3326),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_await] = ACTIONS(3326),
    [anon_sym_while] = ACTIONS(3326),
    [anon_sym_do] = ACTIONS(3326),
    [anon_sym_try] = ACTIONS(3326),
    [anon_sym_break] = ACTIONS(3326),
    [anon_sym_continue] = ACTIONS(3326),
    [anon_sym_debugger] = ACTIONS(3326),
    [anon_sym_return] = ACTIONS(3326),
    [anon_sym_throw] = ACTIONS(3326),
    [anon_sym_SEMI] = ACTIONS(3326),
    [anon_sym_yield] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3326),
    [anon_sym_LTtemplate_GT] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(3326),
    [anon_sym_SQUOTE] = ACTIONS(3326),
    [anon_sym_class] = ACTIONS(3326),
    [anon_sym_async] = ACTIONS(3326),
    [anon_sym_function] = ACTIONS(3326),
    [anon_sym_new] = ACTIONS(3326),
    [anon_sym_using] = ACTIONS(3326),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3326),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_TILDE] = ACTIONS(3326),
    [anon_sym_void] = ACTIONS(3326),
    [anon_sym_delete] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3326),
    [anon_sym_DASH_DASH] = ACTIONS(3326),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3326),
    [sym_number] = ACTIONS(3326),
    [sym_private_property_identifier] = ACTIONS(3326),
    [sym_this] = ACTIONS(3326),
    [sym_super] = ACTIONS(3326),
    [sym_true] = ACTIONS(3326),
    [sym_false] = ACTIONS(3326),
    [sym_null] = ACTIONS(3326),
    [sym_undefined] = ACTIONS(3326),
    [anon_sym_AT] = ACTIONS(3326),
    [anon_sym_static] = ACTIONS(3326),
    [anon_sym_readonly] = ACTIONS(3326),
    [anon_sym_get] = ACTIONS(3326),
    [anon_sym_set] = ACTIONS(3326),
    [anon_sym_declare] = ACTIONS(3326),
    [anon_sym_public] = ACTIONS(3326),
    [anon_sym_private] = ACTIONS(3326),
    [anon_sym_protected] = ACTIONS(3326),
    [anon_sym_override] = ACTIONS(3326),
    [anon_sym_module] = ACTIONS(3326),
    [anon_sym_any] = ACTIONS(3326),
    [anon_sym_number] = ACTIONS(3326),
    [anon_sym_boolean] = ACTIONS(3326),
    [anon_sym_string] = ACTIONS(3326),
    [anon_sym_symbol] = ACTIONS(3326),
    [anon_sym_object] = ACTIONS(3326),
    [anon_sym_abstract] = ACTIONS(3326),
    [anon_sym_interface] = ACTIONS(3326),
    [anon_sym_enum] = ACTIONS(3326),
    [sym_html_comment] = ACTIONS(5),
  },
  [1471] = {
    [sym_comment] = STATE(1471),
    [ts_builtin_sym_end] = ACTIONS(3378),
    [sym_identifier] = ACTIONS(3254),
    [anon_sym_export] = ACTIONS(3254),
    [anon_sym_type] = ACTIONS(3254),
    [anon_sym_namespace] = ACTIONS(3254),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_RBRACE] = ACTIONS(3254),
    [anon_sym_typeof] = ACTIONS(3254),
    [anon_sym_import] = ACTIONS(3254),
    [anon_sym_with] = ACTIONS(3254),
    [anon_sym_var] = ACTIONS(3254),
    [anon_sym_let] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3254),
    [anon_sym_BANG] = ACTIONS(3254),
    [anon_sym_if] = ACTIONS(3254),
    [anon_sym_switch] = ACTIONS(3254),
    [anon_sym_for] = ACTIONS(3254),
    [anon_sym_LPAREN] = ACTIONS(3254),
    [anon_sym_await] = ACTIONS(3254),
    [anon_sym_while] = ACTIONS(3254),
    [anon_sym_do] = ACTIONS(3254),
    [anon_sym_try] = ACTIONS(3254),
    [anon_sym_break] = ACTIONS(3254),
    [anon_sym_continue] = ACTIONS(3254),
    [anon_sym_debugger] = ACTIONS(3254),
    [anon_sym_return] = ACTIONS(3254),
    [anon_sym_throw] = ACTIONS(3254),
    [anon_sym_SEMI] = ACTIONS(3254),
    [anon_sym_yield] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_LTtemplate_GT] = ACTIONS(3254),
    [anon_sym_DQUOTE] = ACTIONS(3254),
    [anon_sym_SQUOTE] = ACTIONS(3254),
    [anon_sym_class] = ACTIONS(3254),
    [anon_sym_async] = ACTIONS(3254),
    [anon_sym_function] = ACTIONS(3254),
    [anon_sym_new] = ACTIONS(3254),
    [anon_sym_using] = ACTIONS(3254),
    [anon_sym_PLUS] = ACTIONS(3254),
    [anon_sym_DASH] = ACTIONS(3254),
    [anon_sym_SLASH] = ACTIONS(3254),
    [anon_sym_LT] = ACTIONS(3254),
    [anon_sym_TILDE] = ACTIONS(3254),
    [anon_sym_void] = ACTIONS(3254),
    [anon_sym_delete] = ACTIONS(3254),
    [anon_sym_PLUS_PLUS] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3254),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3254),
    [sym_number] = ACTIONS(3254),
    [sym_private_property_identifier] = ACTIONS(3254),
    [sym_this] = ACTIONS(3254),
    [sym_super] = ACTIONS(3254),
    [sym_true] = ACTIONS(3254),
    [sym_false] = ACTIONS(3254),
    [sym_null] = ACTIONS(3254),
    [sym_undefined] = ACTIONS(3254),
    [anon_sym_AT] = ACTIONS(3254),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_readonly] = ACTIONS(3254),
    [anon_sym_get] = ACTIONS(3254),
    [anon_sym_set] = ACTIONS(3254),
    [anon_sym_declare] = ACTIONS(3254),
    [anon_sym_public] = ACTIONS(3254),
    [anon_sym_private] = ACTIONS(3254),
    [anon_sym_protected] = ACTIONS(3254),
    [anon_sym_override] = ACTIONS(3254),
    [anon_sym_module] = ACTIONS(3254),
    [anon_sym_any] = ACTIONS(3254),
    [anon_sym_number] = ACTIONS(3254),
    [anon_sym_boolean] = ACTIONS(3254),
    [anon_sym_string] = ACTIONS(3254),
    [anon_sym_symbol] = ACTIONS(3254),
    [anon_sym_object] = ACTIONS(3254),
    [anon_sym_abstract] = ACTIONS(3254),
    [anon_sym_interface] = ACTIONS(3254),
    [anon_sym_enum] = ACTIONS(3254),
    [sym_html_comment] = ACTIONS(5),
  },
  [1472] = {
    [sym_comment] = STATE(1472),
    [ts_builtin_sym_end] = ACTIONS(3380),
    [sym_identifier] = ACTIONS(3250),
    [anon_sym_export] = ACTIONS(3250),
    [anon_sym_type] = ACTIONS(3250),
    [anon_sym_namespace] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3250),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_typeof] = ACTIONS(3250),
    [anon_sym_import] = ACTIONS(3250),
    [anon_sym_with] = ACTIONS(3250),
    [anon_sym_var] = ACTIONS(3250),
    [anon_sym_let] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(3250),
    [anon_sym_BANG] = ACTIONS(3250),
    [anon_sym_if] = ACTIONS(3250),
    [anon_sym_switch] = ACTIONS(3250),
    [anon_sym_for] = ACTIONS(3250),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym_await] = ACTIONS(3250),
    [anon_sym_while] = ACTIONS(3250),
    [anon_sym_do] = ACTIONS(3250),
    [anon_sym_try] = ACTIONS(3250),
    [anon_sym_break] = ACTIONS(3250),
    [anon_sym_continue] = ACTIONS(3250),
    [anon_sym_debugger] = ACTIONS(3250),
    [anon_sym_return] = ACTIONS(3250),
    [anon_sym_throw] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(3250),
    [anon_sym_yield] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_LTtemplate_GT] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [anon_sym_class] = ACTIONS(3250),
    [anon_sym_async] = ACTIONS(3250),
    [anon_sym_function] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3250),
    [anon_sym_using] = ACTIONS(3250),
    [anon_sym_PLUS] = ACTIONS(3250),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_SLASH] = ACTIONS(3250),
    [anon_sym_LT] = ACTIONS(3250),
    [anon_sym_TILDE] = ACTIONS(3250),
    [anon_sym_void] = ACTIONS(3250),
    [anon_sym_delete] = ACTIONS(3250),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3250),
    [sym_number] = ACTIONS(3250),
    [sym_private_property_identifier] = ACTIONS(3250),
    [sym_this] = ACTIONS(3250),
    [sym_super] = ACTIONS(3250),
    [sym_true] = ACTIONS(3250),
    [sym_false] = ACTIONS(3250),
    [sym_null] = ACTIONS(3250),
    [sym_undefined] = ACTIONS(3250),
    [anon_sym_AT] = ACTIONS(3250),
    [anon_sym_static] = ACTIONS(3250),
    [anon_sym_readonly] = ACTIONS(3250),
    [anon_sym_get] = ACTIONS(3250),
    [anon_sym_set] = ACTIONS(3250),
    [anon_sym_declare] = ACTIONS(3250),
    [anon_sym_public] = ACTIONS(3250),
    [anon_sym_private] = ACTIONS(3250),
    [anon_sym_protected] = ACTIONS(3250),
    [anon_sym_override] = ACTIONS(3250),
    [anon_sym_module] = ACTIONS(3250),
    [anon_sym_any] = ACTIONS(3250),
    [anon_sym_number] = ACTIONS(3250),
    [anon_sym_boolean] = ACTIONS(3250),
    [anon_sym_string] = ACTIONS(3250),
    [anon_sym_symbol] = ACTIONS(3250),
    [anon_sym_object] = ACTIONS(3250),
    [anon_sym_abstract] = ACTIONS(3250),
    [anon_sym_interface] = ACTIONS(3250),
    [anon_sym_enum] = ACTIONS(3250),
    [sym_html_comment] = ACTIONS(5),
  },
  [1473] = {
    [sym_comment] = STATE(1473),
    [ts_builtin_sym_end] = ACTIONS(3580),
    [sym_identifier] = ACTIONS(3210),
    [anon_sym_export] = ACTIONS(3210),
    [anon_sym_type] = ACTIONS(3210),
    [anon_sym_namespace] = ACTIONS(3210),
    [anon_sym_LBRACE] = ACTIONS(3210),
    [anon_sym_RBRACE] = ACTIONS(3210),
    [anon_sym_typeof] = ACTIONS(3210),
    [anon_sym_import] = ACTIONS(3210),
    [anon_sym_with] = ACTIONS(3210),
    [anon_sym_var] = ACTIONS(3210),
    [anon_sym_let] = ACTIONS(3210),
    [anon_sym_const] = ACTIONS(3210),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_if] = ACTIONS(3210),
    [anon_sym_switch] = ACTIONS(3210),
    [anon_sym_for] = ACTIONS(3210),
    [anon_sym_LPAREN] = ACTIONS(3210),
    [anon_sym_await] = ACTIONS(3210),
    [anon_sym_while] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3210),
    [anon_sym_try] = ACTIONS(3210),
    [anon_sym_break] = ACTIONS(3210),
    [anon_sym_continue] = ACTIONS(3210),
    [anon_sym_debugger] = ACTIONS(3210),
    [anon_sym_return] = ACTIONS(3210),
    [anon_sym_throw] = ACTIONS(3210),
    [anon_sym_SEMI] = ACTIONS(3210),
    [anon_sym_yield] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(3210),
    [anon_sym_LTtemplate_GT] = ACTIONS(3210),
    [anon_sym_DQUOTE] = ACTIONS(3210),
    [anon_sym_SQUOTE] = ACTIONS(3210),
    [anon_sym_class] = ACTIONS(3210),
    [anon_sym_async] = ACTIONS(3210),
    [anon_sym_function] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3210),
    [anon_sym_using] = ACTIONS(3210),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_SLASH] = ACTIONS(3210),
    [anon_sym_LT] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3210),
    [anon_sym_void] = ACTIONS(3210),
    [anon_sym_delete] = ACTIONS(3210),
    [anon_sym_PLUS_PLUS] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3210),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3210),
    [sym_number] = ACTIONS(3210),
    [sym_private_property_identifier] = ACTIONS(3210),
    [sym_this] = ACTIONS(3210),
    [sym_super] = ACTIONS(3210),
    [sym_true] = ACTIONS(3210),
    [sym_false] = ACTIONS(3210),
    [sym_null] = ACTIONS(3210),
    [sym_undefined] = ACTIONS(3210),
    [anon_sym_AT] = ACTIONS(3210),
    [anon_sym_static] = ACTIONS(3210),
    [anon_sym_readonly] = ACTIONS(3210),
    [anon_sym_get] = ACTIONS(3210),
    [anon_sym_set] = ACTIONS(3210),
    [anon_sym_declare] = ACTIONS(3210),
    [anon_sym_public] = ACTIONS(3210),
    [anon_sym_private] = ACTIONS(3210),
    [anon_sym_protected] = ACTIONS(3210),
    [anon_sym_override] = ACTIONS(3210),
    [anon_sym_module] = ACTIONS(3210),
    [anon_sym_any] = ACTIONS(3210),
    [anon_sym_number] = ACTIONS(3210),
    [anon_sym_boolean] = ACTIONS(3210),
    [anon_sym_string] = ACTIONS(3210),
    [anon_sym_symbol] = ACTIONS(3210),
    [anon_sym_object] = ACTIONS(3210),
    [anon_sym_abstract] = ACTIONS(3210),
    [anon_sym_interface] = ACTIONS(3210),
    [anon_sym_enum] = ACTIONS(3210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1474] = {
    [sym_comment] = STATE(1474),
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_export] = ACTIONS(2183),
    [anon_sym_type] = ACTIONS(2183),
    [anon_sym_namespace] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_typeof] = ACTIONS(2183),
    [anon_sym_import] = ACTIONS(2183),
    [anon_sym_with] = ACTIONS(2183),
    [anon_sym_var] = ACTIONS(2183),
    [anon_sym_let] = ACTIONS(2183),
    [anon_sym_const] = ACTIONS(2183),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2183),
    [anon_sym_for] = ACTIONS(2183),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(2183),
    [anon_sym_do] = ACTIONS(2183),
    [anon_sym_try] = ACTIONS(2183),
    [anon_sym_break] = ACTIONS(2183),
    [anon_sym_continue] = ACTIONS(2183),
    [anon_sym_debugger] = ACTIONS(2183),
    [anon_sym_return] = ACTIONS(2183),
    [anon_sym_throw] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2183),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [anon_sym_class] = ACTIONS(2183),
    [anon_sym_async] = ACTIONS(2183),
    [anon_sym_function] = ACTIONS(2183),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_using] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2183),
    [anon_sym_delete] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2183),
    [sym_private_property_identifier] = ACTIONS(2183),
    [sym_this] = ACTIONS(2183),
    [sym_super] = ACTIONS(2183),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_undefined] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2183),
    [anon_sym_readonly] = ACTIONS(2183),
    [anon_sym_get] = ACTIONS(2183),
    [anon_sym_set] = ACTIONS(2183),
    [anon_sym_declare] = ACTIONS(2183),
    [anon_sym_public] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2183),
    [anon_sym_protected] = ACTIONS(2183),
    [anon_sym_override] = ACTIONS(2183),
    [anon_sym_module] = ACTIONS(2183),
    [anon_sym_any] = ACTIONS(2183),
    [anon_sym_number] = ACTIONS(2183),
    [anon_sym_boolean] = ACTIONS(2183),
    [anon_sym_string] = ACTIONS(2183),
    [anon_sym_symbol] = ACTIONS(2183),
    [anon_sym_object] = ACTIONS(2183),
    [anon_sym_abstract] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2183),
    [anon_sym_enum] = ACTIONS(2183),
    [sym_html_comment] = ACTIONS(5),
  },
  [1475] = {
    [sym_comment] = STATE(1475),
    [ts_builtin_sym_end] = ACTIONS(3504),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1476] = {
    [sym_comment] = STATE(1476),
    [ts_builtin_sym_end] = ACTIONS(3504),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_export] = ACTIONS(3188),
    [anon_sym_type] = ACTIONS(3188),
    [anon_sym_namespace] = ACTIONS(3188),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3188),
    [anon_sym_import] = ACTIONS(3188),
    [anon_sym_with] = ACTIONS(3188),
    [anon_sym_var] = ACTIONS(3188),
    [anon_sym_let] = ACTIONS(3188),
    [anon_sym_const] = ACTIONS(3188),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_if] = ACTIONS(3188),
    [anon_sym_switch] = ACTIONS(3188),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_await] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3188),
    [anon_sym_do] = ACTIONS(3188),
    [anon_sym_try] = ACTIONS(3188),
    [anon_sym_break] = ACTIONS(3188),
    [anon_sym_continue] = ACTIONS(3188),
    [anon_sym_debugger] = ACTIONS(3188),
    [anon_sym_return] = ACTIONS(3188),
    [anon_sym_throw] = ACTIONS(3188),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_yield] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LTtemplate_GT] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [anon_sym_class] = ACTIONS(3188),
    [anon_sym_async] = ACTIONS(3188),
    [anon_sym_function] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3188),
    [anon_sym_using] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3188),
    [anon_sym_void] = ACTIONS(3188),
    [anon_sym_delete] = ACTIONS(3188),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_private_property_identifier] = ACTIONS(3188),
    [sym_this] = ACTIONS(3188),
    [sym_super] = ACTIONS(3188),
    [sym_true] = ACTIONS(3188),
    [sym_false] = ACTIONS(3188),
    [sym_null] = ACTIONS(3188),
    [sym_undefined] = ACTIONS(3188),
    [anon_sym_AT] = ACTIONS(3188),
    [anon_sym_static] = ACTIONS(3188),
    [anon_sym_readonly] = ACTIONS(3188),
    [anon_sym_get] = ACTIONS(3188),
    [anon_sym_set] = ACTIONS(3188),
    [anon_sym_declare] = ACTIONS(3188),
    [anon_sym_public] = ACTIONS(3188),
    [anon_sym_private] = ACTIONS(3188),
    [anon_sym_protected] = ACTIONS(3188),
    [anon_sym_override] = ACTIONS(3188),
    [anon_sym_module] = ACTIONS(3188),
    [anon_sym_any] = ACTIONS(3188),
    [anon_sym_number] = ACTIONS(3188),
    [anon_sym_boolean] = ACTIONS(3188),
    [anon_sym_string] = ACTIONS(3188),
    [anon_sym_symbol] = ACTIONS(3188),
    [anon_sym_object] = ACTIONS(3188),
    [anon_sym_abstract] = ACTIONS(3188),
    [anon_sym_interface] = ACTIONS(3188),
    [anon_sym_enum] = ACTIONS(3188),
    [sym_html_comment] = ACTIONS(5),
  },
  [1477] = {
    [sym_comment] = STATE(1477),
    [ts_builtin_sym_end] = ACTIONS(3498),
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_export] = ACTIONS(3152),
    [anon_sym_type] = ACTIONS(3152),
    [anon_sym_namespace] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3152),
    [anon_sym_typeof] = ACTIONS(3152),
    [anon_sym_import] = ACTIONS(3152),
    [anon_sym_with] = ACTIONS(3152),
    [anon_sym_var] = ACTIONS(3152),
    [anon_sym_let] = ACTIONS(3152),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_switch] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3152),
    [anon_sym_await] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_do] = ACTIONS(3152),
    [anon_sym_try] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_continue] = ACTIONS(3152),
    [anon_sym_debugger] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_throw] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym_yield] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_LTtemplate_GT] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_async] = ACTIONS(3152),
    [anon_sym_function] = ACTIONS(3152),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_using] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_LT] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_void] = ACTIONS(3152),
    [anon_sym_delete] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3152),
    [sym_number] = ACTIONS(3152),
    [sym_private_property_identifier] = ACTIONS(3152),
    [sym_this] = ACTIONS(3152),
    [sym_super] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_null] = ACTIONS(3152),
    [sym_undefined] = ACTIONS(3152),
    [anon_sym_AT] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_readonly] = ACTIONS(3152),
    [anon_sym_get] = ACTIONS(3152),
    [anon_sym_set] = ACTIONS(3152),
    [anon_sym_declare] = ACTIONS(3152),
    [anon_sym_public] = ACTIONS(3152),
    [anon_sym_private] = ACTIONS(3152),
    [anon_sym_protected] = ACTIONS(3152),
    [anon_sym_override] = ACTIONS(3152),
    [anon_sym_module] = ACTIONS(3152),
    [anon_sym_any] = ACTIONS(3152),
    [anon_sym_number] = ACTIONS(3152),
    [anon_sym_boolean] = ACTIONS(3152),
    [anon_sym_string] = ACTIONS(3152),
    [anon_sym_symbol] = ACTIONS(3152),
    [anon_sym_object] = ACTIONS(3152),
    [anon_sym_abstract] = ACTIONS(3152),
    [anon_sym_interface] = ACTIONS(3152),
    [anon_sym_enum] = ACTIONS(3152),
    [sym_html_comment] = ACTIONS(5),
  },
  [1478] = {
    [sym_comment] = STATE(1478),
    [ts_builtin_sym_end] = ACTIONS(3382),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_export] = ACTIONS(3234),
    [anon_sym_type] = ACTIONS(3234),
    [anon_sym_namespace] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(3234),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_typeof] = ACTIONS(3234),
    [anon_sym_import] = ACTIONS(3234),
    [anon_sym_with] = ACTIONS(3234),
    [anon_sym_var] = ACTIONS(3234),
    [anon_sym_let] = ACTIONS(3234),
    [anon_sym_const] = ACTIONS(3234),
    [anon_sym_BANG] = ACTIONS(3234),
    [anon_sym_if] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_for] = ACTIONS(3234),
    [anon_sym_LPAREN] = ACTIONS(3234),
    [anon_sym_await] = ACTIONS(3234),
    [anon_sym_while] = ACTIONS(3234),
    [anon_sym_do] = ACTIONS(3234),
    [anon_sym_try] = ACTIONS(3234),
    [anon_sym_break] = ACTIONS(3234),
    [anon_sym_continue] = ACTIONS(3234),
    [anon_sym_debugger] = ACTIONS(3234),
    [anon_sym_return] = ACTIONS(3234),
    [anon_sym_throw] = ACTIONS(3234),
    [anon_sym_SEMI] = ACTIONS(3234),
    [anon_sym_yield] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_LTtemplate_GT] = ACTIONS(3234),
    [anon_sym_DQUOTE] = ACTIONS(3234),
    [anon_sym_SQUOTE] = ACTIONS(3234),
    [anon_sym_class] = ACTIONS(3234),
    [anon_sym_async] = ACTIONS(3234),
    [anon_sym_function] = ACTIONS(3234),
    [anon_sym_new] = ACTIONS(3234),
    [anon_sym_using] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3234),
    [anon_sym_DASH] = ACTIONS(3234),
    [anon_sym_SLASH] = ACTIONS(3234),
    [anon_sym_LT] = ACTIONS(3234),
    [anon_sym_TILDE] = ACTIONS(3234),
    [anon_sym_void] = ACTIONS(3234),
    [anon_sym_delete] = ACTIONS(3234),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3234),
    [sym_number] = ACTIONS(3234),
    [sym_private_property_identifier] = ACTIONS(3234),
    [sym_this] = ACTIONS(3234),
    [sym_super] = ACTIONS(3234),
    [sym_true] = ACTIONS(3234),
    [sym_false] = ACTIONS(3234),
    [sym_null] = ACTIONS(3234),
    [sym_undefined] = ACTIONS(3234),
    [anon_sym_AT] = ACTIONS(3234),
    [anon_sym_static] = ACTIONS(3234),
    [anon_sym_readonly] = ACTIONS(3234),
    [anon_sym_get] = ACTIONS(3234),
    [anon_sym_set] = ACTIONS(3234),
    [anon_sym_declare] = ACTIONS(3234),
    [anon_sym_public] = ACTIONS(3234),
    [anon_sym_private] = ACTIONS(3234),
    [anon_sym_protected] = ACTIONS(3234),
    [anon_sym_override] = ACTIONS(3234),
    [anon_sym_module] = ACTIONS(3234),
    [anon_sym_any] = ACTIONS(3234),
    [anon_sym_number] = ACTIONS(3234),
    [anon_sym_boolean] = ACTIONS(3234),
    [anon_sym_string] = ACTIONS(3234),
    [anon_sym_symbol] = ACTIONS(3234),
    [anon_sym_object] = ACTIONS(3234),
    [anon_sym_abstract] = ACTIONS(3234),
    [anon_sym_interface] = ACTIONS(3234),
    [anon_sym_enum] = ACTIONS(3234),
    [sym_html_comment] = ACTIONS(5),
  },
  [1479] = {
    [sym_comment] = STATE(1479),
    [ts_builtin_sym_end] = ACTIONS(3542),
    [sym_identifier] = ACTIONS(3290),
    [anon_sym_export] = ACTIONS(3290),
    [anon_sym_type] = ACTIONS(3290),
    [anon_sym_namespace] = ACTIONS(3290),
    [anon_sym_LBRACE] = ACTIONS(3290),
    [anon_sym_RBRACE] = ACTIONS(3290),
    [anon_sym_typeof] = ACTIONS(3290),
    [anon_sym_import] = ACTIONS(3290),
    [anon_sym_with] = ACTIONS(3290),
    [anon_sym_var] = ACTIONS(3290),
    [anon_sym_let] = ACTIONS(3290),
    [anon_sym_const] = ACTIONS(3290),
    [anon_sym_BANG] = ACTIONS(3290),
    [anon_sym_if] = ACTIONS(3290),
    [anon_sym_switch] = ACTIONS(3290),
    [anon_sym_for] = ACTIONS(3290),
    [anon_sym_LPAREN] = ACTIONS(3290),
    [anon_sym_await] = ACTIONS(3290),
    [anon_sym_while] = ACTIONS(3290),
    [anon_sym_do] = ACTIONS(3290),
    [anon_sym_try] = ACTIONS(3290),
    [anon_sym_break] = ACTIONS(3290),
    [anon_sym_continue] = ACTIONS(3290),
    [anon_sym_debugger] = ACTIONS(3290),
    [anon_sym_return] = ACTIONS(3290),
    [anon_sym_throw] = ACTIONS(3290),
    [anon_sym_SEMI] = ACTIONS(3290),
    [anon_sym_yield] = ACTIONS(3290),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_LTtemplate_GT] = ACTIONS(3290),
    [anon_sym_DQUOTE] = ACTIONS(3290),
    [anon_sym_SQUOTE] = ACTIONS(3290),
    [anon_sym_class] = ACTIONS(3290),
    [anon_sym_async] = ACTIONS(3290),
    [anon_sym_function] = ACTIONS(3290),
    [anon_sym_new] = ACTIONS(3290),
    [anon_sym_using] = ACTIONS(3290),
    [anon_sym_PLUS] = ACTIONS(3290),
    [anon_sym_DASH] = ACTIONS(3290),
    [anon_sym_SLASH] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3290),
    [anon_sym_TILDE] = ACTIONS(3290),
    [anon_sym_void] = ACTIONS(3290),
    [anon_sym_delete] = ACTIONS(3290),
    [anon_sym_PLUS_PLUS] = ACTIONS(3290),
    [anon_sym_DASH_DASH] = ACTIONS(3290),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3290),
    [sym_number] = ACTIONS(3290),
    [sym_private_property_identifier] = ACTIONS(3290),
    [sym_this] = ACTIONS(3290),
    [sym_super] = ACTIONS(3290),
    [sym_true] = ACTIONS(3290),
    [sym_false] = ACTIONS(3290),
    [sym_null] = ACTIONS(3290),
    [sym_undefined] = ACTIONS(3290),
    [anon_sym_AT] = ACTIONS(3290),
    [anon_sym_static] = ACTIONS(3290),
    [anon_sym_readonly] = ACTIONS(3290),
    [anon_sym_get] = ACTIONS(3290),
    [anon_sym_set] = ACTIONS(3290),
    [anon_sym_declare] = ACTIONS(3290),
    [anon_sym_public] = ACTIONS(3290),
    [anon_sym_private] = ACTIONS(3290),
    [anon_sym_protected] = ACTIONS(3290),
    [anon_sym_override] = ACTIONS(3290),
    [anon_sym_module] = ACTIONS(3290),
    [anon_sym_any] = ACTIONS(3290),
    [anon_sym_number] = ACTIONS(3290),
    [anon_sym_boolean] = ACTIONS(3290),
    [anon_sym_string] = ACTIONS(3290),
    [anon_sym_symbol] = ACTIONS(3290),
    [anon_sym_object] = ACTIONS(3290),
    [anon_sym_abstract] = ACTIONS(3290),
    [anon_sym_interface] = ACTIONS(3290),
    [anon_sym_enum] = ACTIONS(3290),
    [sym_html_comment] = ACTIONS(5),
  },
  [1480] = {
    [sym_comment] = STATE(1480),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1481] = {
    [sym_comment] = STATE(1481),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1482] = {
    [sym_comment] = STATE(1482),
    [ts_builtin_sym_end] = ACTIONS(3390),
    [sym_identifier] = ACTIONS(3226),
    [anon_sym_export] = ACTIONS(3226),
    [anon_sym_type] = ACTIONS(3226),
    [anon_sym_namespace] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [anon_sym_RBRACE] = ACTIONS(3226),
    [anon_sym_typeof] = ACTIONS(3226),
    [anon_sym_import] = ACTIONS(3226),
    [anon_sym_with] = ACTIONS(3226),
    [anon_sym_var] = ACTIONS(3226),
    [anon_sym_let] = ACTIONS(3226),
    [anon_sym_const] = ACTIONS(3226),
    [anon_sym_BANG] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3226),
    [anon_sym_await] = ACTIONS(3226),
    [anon_sym_while] = ACTIONS(3226),
    [anon_sym_do] = ACTIONS(3226),
    [anon_sym_try] = ACTIONS(3226),
    [anon_sym_break] = ACTIONS(3226),
    [anon_sym_continue] = ACTIONS(3226),
    [anon_sym_debugger] = ACTIONS(3226),
    [anon_sym_return] = ACTIONS(3226),
    [anon_sym_throw] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym_yield] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [anon_sym_LTtemplate_GT] = ACTIONS(3226),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_SQUOTE] = ACTIONS(3226),
    [anon_sym_class] = ACTIONS(3226),
    [anon_sym_async] = ACTIONS(3226),
    [anon_sym_function] = ACTIONS(3226),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_using] = ACTIONS(3226),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_SLASH] = ACTIONS(3226),
    [anon_sym_LT] = ACTIONS(3226),
    [anon_sym_TILDE] = ACTIONS(3226),
    [anon_sym_void] = ACTIONS(3226),
    [anon_sym_delete] = ACTIONS(3226),
    [anon_sym_PLUS_PLUS] = ACTIONS(3226),
    [anon_sym_DASH_DASH] = ACTIONS(3226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3226),
    [sym_number] = ACTIONS(3226),
    [sym_private_property_identifier] = ACTIONS(3226),
    [sym_this] = ACTIONS(3226),
    [sym_super] = ACTIONS(3226),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [sym_null] = ACTIONS(3226),
    [sym_undefined] = ACTIONS(3226),
    [anon_sym_AT] = ACTIONS(3226),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_readonly] = ACTIONS(3226),
    [anon_sym_get] = ACTIONS(3226),
    [anon_sym_set] = ACTIONS(3226),
    [anon_sym_declare] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3226),
    [anon_sym_private] = ACTIONS(3226),
    [anon_sym_protected] = ACTIONS(3226),
    [anon_sym_override] = ACTIONS(3226),
    [anon_sym_module] = ACTIONS(3226),
    [anon_sym_any] = ACTIONS(3226),
    [anon_sym_number] = ACTIONS(3226),
    [anon_sym_boolean] = ACTIONS(3226),
    [anon_sym_string] = ACTIONS(3226),
    [anon_sym_symbol] = ACTIONS(3226),
    [anon_sym_object] = ACTIONS(3226),
    [anon_sym_abstract] = ACTIONS(3226),
    [anon_sym_interface] = ACTIONS(3226),
    [anon_sym_enum] = ACTIONS(3226),
    [sym_html_comment] = ACTIONS(5),
  },
  [1483] = {
    [sym_comment] = STATE(1483),
    [ts_builtin_sym_end] = ACTIONS(3500),
    [sym_identifier] = ACTIONS(3150),
    [anon_sym_export] = ACTIONS(3150),
    [anon_sym_type] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_typeof] = ACTIONS(3150),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_with] = ACTIONS(3150),
    [anon_sym_var] = ACTIONS(3150),
    [anon_sym_let] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_LPAREN] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_debugger] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym_yield] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_LTtemplate_GT] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_async] = ACTIONS(3150),
    [anon_sym_function] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3150),
    [anon_sym_LT] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_void] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3150),
    [sym_number] = ACTIONS(3150),
    [sym_private_property_identifier] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
    [sym_super] = ACTIONS(3150),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [sym_null] = ACTIONS(3150),
    [sym_undefined] = ACTIONS(3150),
    [anon_sym_AT] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_readonly] = ACTIONS(3150),
    [anon_sym_get] = ACTIONS(3150),
    [anon_sym_set] = ACTIONS(3150),
    [anon_sym_declare] = ACTIONS(3150),
    [anon_sym_public] = ACTIONS(3150),
    [anon_sym_private] = ACTIONS(3150),
    [anon_sym_protected] = ACTIONS(3150),
    [anon_sym_override] = ACTIONS(3150),
    [anon_sym_module] = ACTIONS(3150),
    [anon_sym_any] = ACTIONS(3150),
    [anon_sym_number] = ACTIONS(3150),
    [anon_sym_boolean] = ACTIONS(3150),
    [anon_sym_string] = ACTIONS(3150),
    [anon_sym_symbol] = ACTIONS(3150),
    [anon_sym_object] = ACTIONS(3150),
    [anon_sym_abstract] = ACTIONS(3150),
    [anon_sym_interface] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [sym_html_comment] = ACTIONS(5),
  },
  [1484] = {
    [sym_comment] = STATE(1484),
    [ts_builtin_sym_end] = ACTIONS(3398),
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_export] = ACTIONS(3128),
    [anon_sym_type] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_RBRACE] = ACTIONS(3128),
    [anon_sym_typeof] = ACTIONS(3128),
    [anon_sym_import] = ACTIONS(3128),
    [anon_sym_with] = ACTIONS(3128),
    [anon_sym_var] = ACTIONS(3128),
    [anon_sym_let] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(3128),
    [anon_sym_await] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_debugger] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3128),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_LTtemplate_GT] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_async] = ACTIONS(3128),
    [anon_sym_function] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_SLASH] = ACTIONS(3128),
    [anon_sym_LT] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_void] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3128),
    [sym_number] = ACTIONS(3128),
    [sym_private_property_identifier] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
    [sym_super] = ACTIONS(3128),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [sym_null] = ACTIONS(3128),
    [sym_undefined] = ACTIONS(3128),
    [anon_sym_AT] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_readonly] = ACTIONS(3128),
    [anon_sym_get] = ACTIONS(3128),
    [anon_sym_set] = ACTIONS(3128),
    [anon_sym_declare] = ACTIONS(3128),
    [anon_sym_public] = ACTIONS(3128),
    [anon_sym_private] = ACTIONS(3128),
    [anon_sym_protected] = ACTIONS(3128),
    [anon_sym_override] = ACTIONS(3128),
    [anon_sym_module] = ACTIONS(3128),
    [anon_sym_any] = ACTIONS(3128),
    [anon_sym_number] = ACTIONS(3128),
    [anon_sym_boolean] = ACTIONS(3128),
    [anon_sym_string] = ACTIONS(3128),
    [anon_sym_symbol] = ACTIONS(3128),
    [anon_sym_object] = ACTIONS(3128),
    [anon_sym_abstract] = ACTIONS(3128),
    [anon_sym_interface] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [sym_html_comment] = ACTIONS(5),
  },
  [1485] = {
    [sym_comment] = STATE(1485),
    [ts_builtin_sym_end] = ACTIONS(3534),
    [sym_identifier] = ACTIONS(3204),
    [anon_sym_export] = ACTIONS(3204),
    [anon_sym_type] = ACTIONS(3204),
    [anon_sym_namespace] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_typeof] = ACTIONS(3204),
    [anon_sym_import] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3204),
    [anon_sym_var] = ACTIONS(3204),
    [anon_sym_let] = ACTIONS(3204),
    [anon_sym_const] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_switch] = ACTIONS(3204),
    [anon_sym_for] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3204),
    [anon_sym_await] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_try] = ACTIONS(3204),
    [anon_sym_break] = ACTIONS(3204),
    [anon_sym_continue] = ACTIONS(3204),
    [anon_sym_debugger] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3204),
    [anon_sym_throw] = ACTIONS(3204),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_LTtemplate_GT] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [anon_sym_SQUOTE] = ACTIONS(3204),
    [anon_sym_class] = ACTIONS(3204),
    [anon_sym_async] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3204),
    [anon_sym_using] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3204),
    [anon_sym_DASH] = ACTIONS(3204),
    [anon_sym_SLASH] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3204),
    [anon_sym_void] = ACTIONS(3204),
    [anon_sym_delete] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3204),
    [anon_sym_DASH_DASH] = ACTIONS(3204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3204),
    [sym_number] = ACTIONS(3204),
    [sym_private_property_identifier] = ACTIONS(3204),
    [sym_this] = ACTIONS(3204),
    [sym_super] = ACTIONS(3204),
    [sym_true] = ACTIONS(3204),
    [sym_false] = ACTIONS(3204),
    [sym_null] = ACTIONS(3204),
    [sym_undefined] = ACTIONS(3204),
    [anon_sym_AT] = ACTIONS(3204),
    [anon_sym_static] = ACTIONS(3204),
    [anon_sym_readonly] = ACTIONS(3204),
    [anon_sym_get] = ACTIONS(3204),
    [anon_sym_set] = ACTIONS(3204),
    [anon_sym_declare] = ACTIONS(3204),
    [anon_sym_public] = ACTIONS(3204),
    [anon_sym_private] = ACTIONS(3204),
    [anon_sym_protected] = ACTIONS(3204),
    [anon_sym_override] = ACTIONS(3204),
    [anon_sym_module] = ACTIONS(3204),
    [anon_sym_any] = ACTIONS(3204),
    [anon_sym_number] = ACTIONS(3204),
    [anon_sym_boolean] = ACTIONS(3204),
    [anon_sym_string] = ACTIONS(3204),
    [anon_sym_symbol] = ACTIONS(3204),
    [anon_sym_object] = ACTIONS(3204),
    [anon_sym_abstract] = ACTIONS(3204),
    [anon_sym_interface] = ACTIONS(3204),
    [anon_sym_enum] = ACTIONS(3204),
    [sym_html_comment] = ACTIONS(5),
  },
  [1486] = {
    [sym_comment] = STATE(1486),
    [ts_builtin_sym_end] = ACTIONS(3530),
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_export] = ACTIONS(3202),
    [anon_sym_type] = ACTIONS(3202),
    [anon_sym_namespace] = ACTIONS(3202),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_RBRACE] = ACTIONS(3202),
    [anon_sym_typeof] = ACTIONS(3202),
    [anon_sym_import] = ACTIONS(3202),
    [anon_sym_with] = ACTIONS(3202),
    [anon_sym_var] = ACTIONS(3202),
    [anon_sym_let] = ACTIONS(3202),
    [anon_sym_const] = ACTIONS(3202),
    [anon_sym_BANG] = ACTIONS(3202),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_switch] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_await] = ACTIONS(3202),
    [anon_sym_while] = ACTIONS(3202),
    [anon_sym_do] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3202),
    [anon_sym_break] = ACTIONS(3202),
    [anon_sym_continue] = ACTIONS(3202),
    [anon_sym_debugger] = ACTIONS(3202),
    [anon_sym_return] = ACTIONS(3202),
    [anon_sym_throw] = ACTIONS(3202),
    [anon_sym_SEMI] = ACTIONS(3202),
    [anon_sym_yield] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LTtemplate_GT] = ACTIONS(3202),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_class] = ACTIONS(3202),
    [anon_sym_async] = ACTIONS(3202),
    [anon_sym_function] = ACTIONS(3202),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_using] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(3202),
    [anon_sym_LT] = ACTIONS(3202),
    [anon_sym_TILDE] = ACTIONS(3202),
    [anon_sym_void] = ACTIONS(3202),
    [anon_sym_delete] = ACTIONS(3202),
    [anon_sym_PLUS_PLUS] = ACTIONS(3202),
    [anon_sym_DASH_DASH] = ACTIONS(3202),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3202),
    [sym_number] = ACTIONS(3202),
    [sym_private_property_identifier] = ACTIONS(3202),
    [sym_this] = ACTIONS(3202),
    [sym_super] = ACTIONS(3202),
    [sym_true] = ACTIONS(3202),
    [sym_false] = ACTIONS(3202),
    [sym_null] = ACTIONS(3202),
    [sym_undefined] = ACTIONS(3202),
    [anon_sym_AT] = ACTIONS(3202),
    [anon_sym_static] = ACTIONS(3202),
    [anon_sym_readonly] = ACTIONS(3202),
    [anon_sym_get] = ACTIONS(3202),
    [anon_sym_set] = ACTIONS(3202),
    [anon_sym_declare] = ACTIONS(3202),
    [anon_sym_public] = ACTIONS(3202),
    [anon_sym_private] = ACTIONS(3202),
    [anon_sym_protected] = ACTIONS(3202),
    [anon_sym_override] = ACTIONS(3202),
    [anon_sym_module] = ACTIONS(3202),
    [anon_sym_any] = ACTIONS(3202),
    [anon_sym_number] = ACTIONS(3202),
    [anon_sym_boolean] = ACTIONS(3202),
    [anon_sym_string] = ACTIONS(3202),
    [anon_sym_symbol] = ACTIONS(3202),
    [anon_sym_object] = ACTIONS(3202),
    [anon_sym_abstract] = ACTIONS(3202),
    [anon_sym_interface] = ACTIONS(3202),
    [anon_sym_enum] = ACTIONS(3202),
    [sym_html_comment] = ACTIONS(5),
  },
  [1487] = {
    [sym_comment] = STATE(1487),
    [ts_builtin_sym_end] = ACTIONS(3456),
    [sym_identifier] = ACTIONS(3180),
    [anon_sym_export] = ACTIONS(3180),
    [anon_sym_type] = ACTIONS(3180),
    [anon_sym_namespace] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_RBRACE] = ACTIONS(3180),
    [anon_sym_typeof] = ACTIONS(3180),
    [anon_sym_import] = ACTIONS(3180),
    [anon_sym_with] = ACTIONS(3180),
    [anon_sym_var] = ACTIONS(3180),
    [anon_sym_let] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_if] = ACTIONS(3180),
    [anon_sym_switch] = ACTIONS(3180),
    [anon_sym_for] = ACTIONS(3180),
    [anon_sym_LPAREN] = ACTIONS(3180),
    [anon_sym_await] = ACTIONS(3180),
    [anon_sym_while] = ACTIONS(3180),
    [anon_sym_do] = ACTIONS(3180),
    [anon_sym_try] = ACTIONS(3180),
    [anon_sym_break] = ACTIONS(3180),
    [anon_sym_continue] = ACTIONS(3180),
    [anon_sym_debugger] = ACTIONS(3180),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_throw] = ACTIONS(3180),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym_yield] = ACTIONS(3180),
    [anon_sym_LBRACK] = ACTIONS(3180),
    [anon_sym_LTtemplate_GT] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_class] = ACTIONS(3180),
    [anon_sym_async] = ACTIONS(3180),
    [anon_sym_function] = ACTIONS(3180),
    [anon_sym_new] = ACTIONS(3180),
    [anon_sym_using] = ACTIONS(3180),
    [anon_sym_PLUS] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3180),
    [anon_sym_SLASH] = ACTIONS(3180),
    [anon_sym_LT] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_void] = ACTIONS(3180),
    [anon_sym_delete] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3180),
    [sym_number] = ACTIONS(3180),
    [sym_private_property_identifier] = ACTIONS(3180),
    [sym_this] = ACTIONS(3180),
    [sym_super] = ACTIONS(3180),
    [sym_true] = ACTIONS(3180),
    [sym_false] = ACTIONS(3180),
    [sym_null] = ACTIONS(3180),
    [sym_undefined] = ACTIONS(3180),
    [anon_sym_AT] = ACTIONS(3180),
    [anon_sym_static] = ACTIONS(3180),
    [anon_sym_readonly] = ACTIONS(3180),
    [anon_sym_get] = ACTIONS(3180),
    [anon_sym_set] = ACTIONS(3180),
    [anon_sym_declare] = ACTIONS(3180),
    [anon_sym_public] = ACTIONS(3180),
    [anon_sym_private] = ACTIONS(3180),
    [anon_sym_protected] = ACTIONS(3180),
    [anon_sym_override] = ACTIONS(3180),
    [anon_sym_module] = ACTIONS(3180),
    [anon_sym_any] = ACTIONS(3180),
    [anon_sym_number] = ACTIONS(3180),
    [anon_sym_boolean] = ACTIONS(3180),
    [anon_sym_string] = ACTIONS(3180),
    [anon_sym_symbol] = ACTIONS(3180),
    [anon_sym_object] = ACTIONS(3180),
    [anon_sym_abstract] = ACTIONS(3180),
    [anon_sym_interface] = ACTIONS(3180),
    [anon_sym_enum] = ACTIONS(3180),
    [sym_html_comment] = ACTIONS(5),
  },
  [1488] = {
    [sym_comment] = STATE(1488),
    [ts_builtin_sym_end] = ACTIONS(3394),
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_export] = ACTIONS(3172),
    [anon_sym_type] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_typeof] = ACTIONS(3172),
    [anon_sym_import] = ACTIONS(3172),
    [anon_sym_with] = ACTIONS(3172),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_LPAREN] = ACTIONS(3172),
    [anon_sym_await] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_debugger] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_yield] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_LTtemplate_GT] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_async] = ACTIONS(3172),
    [anon_sym_function] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_SLASH] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_void] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3172),
    [sym_number] = ACTIONS(3172),
    [sym_private_property_identifier] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
    [sym_super] = ACTIONS(3172),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [sym_null] = ACTIONS(3172),
    [sym_undefined] = ACTIONS(3172),
    [anon_sym_AT] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_readonly] = ACTIONS(3172),
    [anon_sym_get] = ACTIONS(3172),
    [anon_sym_set] = ACTIONS(3172),
    [anon_sym_declare] = ACTIONS(3172),
    [anon_sym_public] = ACTIONS(3172),
    [anon_sym_private] = ACTIONS(3172),
    [anon_sym_protected] = ACTIONS(3172),
    [anon_sym_override] = ACTIONS(3172),
    [anon_sym_module] = ACTIONS(3172),
    [anon_sym_any] = ACTIONS(3172),
    [anon_sym_number] = ACTIONS(3172),
    [anon_sym_boolean] = ACTIONS(3172),
    [anon_sym_string] = ACTIONS(3172),
    [anon_sym_symbol] = ACTIONS(3172),
    [anon_sym_object] = ACTIONS(3172),
    [anon_sym_abstract] = ACTIONS(3172),
    [anon_sym_interface] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [sym_html_comment] = ACTIONS(5),
  },
  [1489] = {
    [sym_comment] = STATE(1489),
    [ts_builtin_sym_end] = ACTIONS(3402),
    [sym_identifier] = ACTIONS(3136),
    [anon_sym_export] = ACTIONS(3136),
    [anon_sym_type] = ACTIONS(3136),
    [anon_sym_namespace] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_RBRACE] = ACTIONS(3136),
    [anon_sym_typeof] = ACTIONS(3136),
    [anon_sym_import] = ACTIONS(3136),
    [anon_sym_with] = ACTIONS(3136),
    [anon_sym_var] = ACTIONS(3136),
    [anon_sym_let] = ACTIONS(3136),
    [anon_sym_const] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_switch] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_LPAREN] = ACTIONS(3136),
    [anon_sym_await] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_do] = ACTIONS(3136),
    [anon_sym_try] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_continue] = ACTIONS(3136),
    [anon_sym_debugger] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_throw] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym_yield] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3136),
    [anon_sym_LTtemplate_GT] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(3136),
    [anon_sym_SQUOTE] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_async] = ACTIONS(3136),
    [anon_sym_function] = ACTIONS(3136),
    [anon_sym_new] = ACTIONS(3136),
    [anon_sym_using] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3136),
    [anon_sym_SLASH] = ACTIONS(3136),
    [anon_sym_LT] = ACTIONS(3136),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_void] = ACTIONS(3136),
    [anon_sym_delete] = ACTIONS(3136),
    [anon_sym_PLUS_PLUS] = ACTIONS(3136),
    [anon_sym_DASH_DASH] = ACTIONS(3136),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3136),
    [sym_number] = ACTIONS(3136),
    [sym_private_property_identifier] = ACTIONS(3136),
    [sym_this] = ACTIONS(3136),
    [sym_super] = ACTIONS(3136),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [sym_null] = ACTIONS(3136),
    [sym_undefined] = ACTIONS(3136),
    [anon_sym_AT] = ACTIONS(3136),
    [anon_sym_static] = ACTIONS(3136),
    [anon_sym_readonly] = ACTIONS(3136),
    [anon_sym_get] = ACTIONS(3136),
    [anon_sym_set] = ACTIONS(3136),
    [anon_sym_declare] = ACTIONS(3136),
    [anon_sym_public] = ACTIONS(3136),
    [anon_sym_private] = ACTIONS(3136),
    [anon_sym_protected] = ACTIONS(3136),
    [anon_sym_override] = ACTIONS(3136),
    [anon_sym_module] = ACTIONS(3136),
    [anon_sym_any] = ACTIONS(3136),
    [anon_sym_number] = ACTIONS(3136),
    [anon_sym_boolean] = ACTIONS(3136),
    [anon_sym_string] = ACTIONS(3136),
    [anon_sym_symbol] = ACTIONS(3136),
    [anon_sym_object] = ACTIONS(3136),
    [anon_sym_abstract] = ACTIONS(3136),
    [anon_sym_interface] = ACTIONS(3136),
    [anon_sym_enum] = ACTIONS(3136),
    [sym_html_comment] = ACTIONS(5),
  },
  [1490] = {
    [sym_comment] = STATE(1490),
    [ts_builtin_sym_end] = ACTIONS(3486),
    [sym_identifier] = ACTIONS(3306),
    [anon_sym_export] = ACTIONS(3306),
    [anon_sym_type] = ACTIONS(3306),
    [anon_sym_namespace] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3306),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_typeof] = ACTIONS(3306),
    [anon_sym_import] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3306),
    [anon_sym_var] = ACTIONS(3306),
    [anon_sym_let] = ACTIONS(3306),
    [anon_sym_const] = ACTIONS(3306),
    [anon_sym_BANG] = ACTIONS(3306),
    [anon_sym_if] = ACTIONS(3306),
    [anon_sym_switch] = ACTIONS(3306),
    [anon_sym_for] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3306),
    [anon_sym_await] = ACTIONS(3306),
    [anon_sym_while] = ACTIONS(3306),
    [anon_sym_do] = ACTIONS(3306),
    [anon_sym_try] = ACTIONS(3306),
    [anon_sym_break] = ACTIONS(3306),
    [anon_sym_continue] = ACTIONS(3306),
    [anon_sym_debugger] = ACTIONS(3306),
    [anon_sym_return] = ACTIONS(3306),
    [anon_sym_throw] = ACTIONS(3306),
    [anon_sym_SEMI] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3306),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_LTtemplate_GT] = ACTIONS(3306),
    [anon_sym_DQUOTE] = ACTIONS(3306),
    [anon_sym_SQUOTE] = ACTIONS(3306),
    [anon_sym_class] = ACTIONS(3306),
    [anon_sym_async] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3306),
    [anon_sym_using] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_DASH] = ACTIONS(3306),
    [anon_sym_SLASH] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3306),
    [anon_sym_void] = ACTIONS(3306),
    [anon_sym_delete] = ACTIONS(3306),
    [anon_sym_PLUS_PLUS] = ACTIONS(3306),
    [anon_sym_DASH_DASH] = ACTIONS(3306),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3306),
    [sym_number] = ACTIONS(3306),
    [sym_private_property_identifier] = ACTIONS(3306),
    [sym_this] = ACTIONS(3306),
    [sym_super] = ACTIONS(3306),
    [sym_true] = ACTIONS(3306),
    [sym_false] = ACTIONS(3306),
    [sym_null] = ACTIONS(3306),
    [sym_undefined] = ACTIONS(3306),
    [anon_sym_AT] = ACTIONS(3306),
    [anon_sym_static] = ACTIONS(3306),
    [anon_sym_readonly] = ACTIONS(3306),
    [anon_sym_get] = ACTIONS(3306),
    [anon_sym_set] = ACTIONS(3306),
    [anon_sym_declare] = ACTIONS(3306),
    [anon_sym_public] = ACTIONS(3306),
    [anon_sym_private] = ACTIONS(3306),
    [anon_sym_protected] = ACTIONS(3306),
    [anon_sym_override] = ACTIONS(3306),
    [anon_sym_module] = ACTIONS(3306),
    [anon_sym_any] = ACTIONS(3306),
    [anon_sym_number] = ACTIONS(3306),
    [anon_sym_boolean] = ACTIONS(3306),
    [anon_sym_string] = ACTIONS(3306),
    [anon_sym_symbol] = ACTIONS(3306),
    [anon_sym_object] = ACTIONS(3306),
    [anon_sym_abstract] = ACTIONS(3306),
    [anon_sym_interface] = ACTIONS(3306),
    [anon_sym_enum] = ACTIONS(3306),
    [sym_html_comment] = ACTIONS(5),
  },
  [1491] = {
    [sym_comment] = STATE(1491),
    [ts_builtin_sym_end] = ACTIONS(3446),
    [sym_identifier] = ACTIONS(3224),
    [anon_sym_export] = ACTIONS(3224),
    [anon_sym_type] = ACTIONS(3224),
    [anon_sym_namespace] = ACTIONS(3224),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_typeof] = ACTIONS(3224),
    [anon_sym_import] = ACTIONS(3224),
    [anon_sym_with] = ACTIONS(3224),
    [anon_sym_var] = ACTIONS(3224),
    [anon_sym_let] = ACTIONS(3224),
    [anon_sym_const] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_if] = ACTIONS(3224),
    [anon_sym_switch] = ACTIONS(3224),
    [anon_sym_for] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [anon_sym_await] = ACTIONS(3224),
    [anon_sym_while] = ACTIONS(3224),
    [anon_sym_do] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(3224),
    [anon_sym_break] = ACTIONS(3224),
    [anon_sym_continue] = ACTIONS(3224),
    [anon_sym_debugger] = ACTIONS(3224),
    [anon_sym_return] = ACTIONS(3224),
    [anon_sym_throw] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_yield] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_LTtemplate_GT] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [anon_sym_class] = ACTIONS(3224),
    [anon_sym_async] = ACTIONS(3224),
    [anon_sym_function] = ACTIONS(3224),
    [anon_sym_new] = ACTIONS(3224),
    [anon_sym_using] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3224),
    [anon_sym_DASH] = ACTIONS(3224),
    [anon_sym_SLASH] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_void] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3224),
    [sym_number] = ACTIONS(3224),
    [sym_private_property_identifier] = ACTIONS(3224),
    [sym_this] = ACTIONS(3224),
    [sym_super] = ACTIONS(3224),
    [sym_true] = ACTIONS(3224),
    [sym_false] = ACTIONS(3224),
    [sym_null] = ACTIONS(3224),
    [sym_undefined] = ACTIONS(3224),
    [anon_sym_AT] = ACTIONS(3224),
    [anon_sym_static] = ACTIONS(3224),
    [anon_sym_readonly] = ACTIONS(3224),
    [anon_sym_get] = ACTIONS(3224),
    [anon_sym_set] = ACTIONS(3224),
    [anon_sym_declare] = ACTIONS(3224),
    [anon_sym_public] = ACTIONS(3224),
    [anon_sym_private] = ACTIONS(3224),
    [anon_sym_protected] = ACTIONS(3224),
    [anon_sym_override] = ACTIONS(3224),
    [anon_sym_module] = ACTIONS(3224),
    [anon_sym_any] = ACTIONS(3224),
    [anon_sym_number] = ACTIONS(3224),
    [anon_sym_boolean] = ACTIONS(3224),
    [anon_sym_string] = ACTIONS(3224),
    [anon_sym_symbol] = ACTIONS(3224),
    [anon_sym_object] = ACTIONS(3224),
    [anon_sym_abstract] = ACTIONS(3224),
    [anon_sym_interface] = ACTIONS(3224),
    [anon_sym_enum] = ACTIONS(3224),
    [sym_html_comment] = ACTIONS(5),
  },
  [1492] = {
    [sym_comment] = STATE(1492),
    [ts_builtin_sym_end] = ACTIONS(3442),
    [sym_identifier] = ACTIONS(3178),
    [anon_sym_export] = ACTIONS(3178),
    [anon_sym_type] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_RBRACE] = ACTIONS(3178),
    [anon_sym_typeof] = ACTIONS(3178),
    [anon_sym_import] = ACTIONS(3178),
    [anon_sym_with] = ACTIONS(3178),
    [anon_sym_var] = ACTIONS(3178),
    [anon_sym_let] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_BANG] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_LPAREN] = ACTIONS(3178),
    [anon_sym_await] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_debugger] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_yield] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_LTtemplate_GT] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_SQUOTE] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_async] = ACTIONS(3178),
    [anon_sym_function] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_SLASH] = ACTIONS(3178),
    [anon_sym_LT] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3178),
    [anon_sym_void] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_PLUS_PLUS] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [sym_number] = ACTIONS(3178),
    [sym_private_property_identifier] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
    [sym_super] = ACTIONS(3178),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [sym_null] = ACTIONS(3178),
    [sym_undefined] = ACTIONS(3178),
    [anon_sym_AT] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_readonly] = ACTIONS(3178),
    [anon_sym_get] = ACTIONS(3178),
    [anon_sym_set] = ACTIONS(3178),
    [anon_sym_declare] = ACTIONS(3178),
    [anon_sym_public] = ACTIONS(3178),
    [anon_sym_private] = ACTIONS(3178),
    [anon_sym_protected] = ACTIONS(3178),
    [anon_sym_override] = ACTIONS(3178),
    [anon_sym_module] = ACTIONS(3178),
    [anon_sym_any] = ACTIONS(3178),
    [anon_sym_number] = ACTIONS(3178),
    [anon_sym_boolean] = ACTIONS(3178),
    [anon_sym_string] = ACTIONS(3178),
    [anon_sym_symbol] = ACTIONS(3178),
    [anon_sym_object] = ACTIONS(3178),
    [anon_sym_abstract] = ACTIONS(3178),
    [anon_sym_interface] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [sym_html_comment] = ACTIONS(5),
  },
  [1493] = {
    [sym_comment] = STATE(1493),
    [ts_builtin_sym_end] = ACTIONS(3510),
    [sym_identifier] = ACTIONS(3268),
    [anon_sym_export] = ACTIONS(3268),
    [anon_sym_type] = ACTIONS(3268),
    [anon_sym_namespace] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3268),
    [anon_sym_typeof] = ACTIONS(3268),
    [anon_sym_import] = ACTIONS(3268),
    [anon_sym_with] = ACTIONS(3268),
    [anon_sym_var] = ACTIONS(3268),
    [anon_sym_let] = ACTIONS(3268),
    [anon_sym_const] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_if] = ACTIONS(3268),
    [anon_sym_switch] = ACTIONS(3268),
    [anon_sym_for] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3268),
    [anon_sym_await] = ACTIONS(3268),
    [anon_sym_while] = ACTIONS(3268),
    [anon_sym_do] = ACTIONS(3268),
    [anon_sym_try] = ACTIONS(3268),
    [anon_sym_break] = ACTIONS(3268),
    [anon_sym_continue] = ACTIONS(3268),
    [anon_sym_debugger] = ACTIONS(3268),
    [anon_sym_return] = ACTIONS(3268),
    [anon_sym_throw] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_yield] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3268),
    [anon_sym_LTtemplate_GT] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3268),
    [anon_sym_class] = ACTIONS(3268),
    [anon_sym_async] = ACTIONS(3268),
    [anon_sym_function] = ACTIONS(3268),
    [anon_sym_new] = ACTIONS(3268),
    [anon_sym_using] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3268),
    [anon_sym_void] = ACTIONS(3268),
    [anon_sym_delete] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3268),
    [sym_number] = ACTIONS(3268),
    [sym_private_property_identifier] = ACTIONS(3268),
    [sym_this] = ACTIONS(3268),
    [sym_super] = ACTIONS(3268),
    [sym_true] = ACTIONS(3268),
    [sym_false] = ACTIONS(3268),
    [sym_null] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_AT] = ACTIONS(3268),
    [anon_sym_static] = ACTIONS(3268),
    [anon_sym_readonly] = ACTIONS(3268),
    [anon_sym_get] = ACTIONS(3268),
    [anon_sym_set] = ACTIONS(3268),
    [anon_sym_declare] = ACTIONS(3268),
    [anon_sym_public] = ACTIONS(3268),
    [anon_sym_private] = ACTIONS(3268),
    [anon_sym_protected] = ACTIONS(3268),
    [anon_sym_override] = ACTIONS(3268),
    [anon_sym_module] = ACTIONS(3268),
    [anon_sym_any] = ACTIONS(3268),
    [anon_sym_number] = ACTIONS(3268),
    [anon_sym_boolean] = ACTIONS(3268),
    [anon_sym_string] = ACTIONS(3268),
    [anon_sym_symbol] = ACTIONS(3268),
    [anon_sym_object] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(3268),
    [anon_sym_interface] = ACTIONS(3268),
    [anon_sym_enum] = ACTIONS(3268),
    [sym_html_comment] = ACTIONS(5),
  },
  [1494] = {
    [sym_comment] = STATE(1494),
    [ts_builtin_sym_end] = ACTIONS(3564),
    [sym_identifier] = ACTIONS(3312),
    [anon_sym_export] = ACTIONS(3312),
    [anon_sym_type] = ACTIONS(3312),
    [anon_sym_namespace] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3312),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_typeof] = ACTIONS(3312),
    [anon_sym_import] = ACTIONS(3312),
    [anon_sym_with] = ACTIONS(3312),
    [anon_sym_var] = ACTIONS(3312),
    [anon_sym_let] = ACTIONS(3312),
    [anon_sym_const] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_if] = ACTIONS(3312),
    [anon_sym_switch] = ACTIONS(3312),
    [anon_sym_for] = ACTIONS(3312),
    [anon_sym_LPAREN] = ACTIONS(3312),
    [anon_sym_await] = ACTIONS(3312),
    [anon_sym_while] = ACTIONS(3312),
    [anon_sym_do] = ACTIONS(3312),
    [anon_sym_try] = ACTIONS(3312),
    [anon_sym_break] = ACTIONS(3312),
    [anon_sym_continue] = ACTIONS(3312),
    [anon_sym_debugger] = ACTIONS(3312),
    [anon_sym_return] = ACTIONS(3312),
    [anon_sym_throw] = ACTIONS(3312),
    [anon_sym_SEMI] = ACTIONS(3312),
    [anon_sym_yield] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3312),
    [anon_sym_LTtemplate_GT] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3312),
    [anon_sym_SQUOTE] = ACTIONS(3312),
    [anon_sym_class] = ACTIONS(3312),
    [anon_sym_async] = ACTIONS(3312),
    [anon_sym_function] = ACTIONS(3312),
    [anon_sym_new] = ACTIONS(3312),
    [anon_sym_using] = ACTIONS(3312),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_TILDE] = ACTIONS(3312),
    [anon_sym_void] = ACTIONS(3312),
    [anon_sym_delete] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3312),
    [anon_sym_DASH_DASH] = ACTIONS(3312),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3312),
    [sym_number] = ACTIONS(3312),
    [sym_private_property_identifier] = ACTIONS(3312),
    [sym_this] = ACTIONS(3312),
    [sym_super] = ACTIONS(3312),
    [sym_true] = ACTIONS(3312),
    [sym_false] = ACTIONS(3312),
    [sym_null] = ACTIONS(3312),
    [sym_undefined] = ACTIONS(3312),
    [anon_sym_AT] = ACTIONS(3312),
    [anon_sym_static] = ACTIONS(3312),
    [anon_sym_readonly] = ACTIONS(3312),
    [anon_sym_get] = ACTIONS(3312),
    [anon_sym_set] = ACTIONS(3312),
    [anon_sym_declare] = ACTIONS(3312),
    [anon_sym_public] = ACTIONS(3312),
    [anon_sym_private] = ACTIONS(3312),
    [anon_sym_protected] = ACTIONS(3312),
    [anon_sym_override] = ACTIONS(3312),
    [anon_sym_module] = ACTIONS(3312),
    [anon_sym_any] = ACTIONS(3312),
    [anon_sym_number] = ACTIONS(3312),
    [anon_sym_boolean] = ACTIONS(3312),
    [anon_sym_string] = ACTIONS(3312),
    [anon_sym_symbol] = ACTIONS(3312),
    [anon_sym_object] = ACTIONS(3312),
    [anon_sym_abstract] = ACTIONS(3312),
    [anon_sym_interface] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(3312),
    [sym_html_comment] = ACTIONS(5),
  },
  [1495] = {
    [sym_comment] = STATE(1495),
    [ts_builtin_sym_end] = ACTIONS(3512),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_export] = ACTIONS(3280),
    [anon_sym_type] = ACTIONS(3280),
    [anon_sym_namespace] = ACTIONS(3280),
    [anon_sym_LBRACE] = ACTIONS(3280),
    [anon_sym_RBRACE] = ACTIONS(3280),
    [anon_sym_typeof] = ACTIONS(3280),
    [anon_sym_import] = ACTIONS(3280),
    [anon_sym_with] = ACTIONS(3280),
    [anon_sym_var] = ACTIONS(3280),
    [anon_sym_let] = ACTIONS(3280),
    [anon_sym_const] = ACTIONS(3280),
    [anon_sym_BANG] = ACTIONS(3280),
    [anon_sym_if] = ACTIONS(3280),
    [anon_sym_switch] = ACTIONS(3280),
    [anon_sym_for] = ACTIONS(3280),
    [anon_sym_LPAREN] = ACTIONS(3280),
    [anon_sym_await] = ACTIONS(3280),
    [anon_sym_while] = ACTIONS(3280),
    [anon_sym_do] = ACTIONS(3280),
    [anon_sym_try] = ACTIONS(3280),
    [anon_sym_break] = ACTIONS(3280),
    [anon_sym_continue] = ACTIONS(3280),
    [anon_sym_debugger] = ACTIONS(3280),
    [anon_sym_return] = ACTIONS(3280),
    [anon_sym_throw] = ACTIONS(3280),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_yield] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_LTtemplate_GT] = ACTIONS(3280),
    [anon_sym_DQUOTE] = ACTIONS(3280),
    [anon_sym_SQUOTE] = ACTIONS(3280),
    [anon_sym_class] = ACTIONS(3280),
    [anon_sym_async] = ACTIONS(3280),
    [anon_sym_function] = ACTIONS(3280),
    [anon_sym_new] = ACTIONS(3280),
    [anon_sym_using] = ACTIONS(3280),
    [anon_sym_PLUS] = ACTIONS(3280),
    [anon_sym_DASH] = ACTIONS(3280),
    [anon_sym_SLASH] = ACTIONS(3280),
    [anon_sym_LT] = ACTIONS(3280),
    [anon_sym_TILDE] = ACTIONS(3280),
    [anon_sym_void] = ACTIONS(3280),
    [anon_sym_delete] = ACTIONS(3280),
    [anon_sym_PLUS_PLUS] = ACTIONS(3280),
    [anon_sym_DASH_DASH] = ACTIONS(3280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3280),
    [sym_number] = ACTIONS(3280),
    [sym_private_property_identifier] = ACTIONS(3280),
    [sym_this] = ACTIONS(3280),
    [sym_super] = ACTIONS(3280),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_null] = ACTIONS(3280),
    [sym_undefined] = ACTIONS(3280),
    [anon_sym_AT] = ACTIONS(3280),
    [anon_sym_static] = ACTIONS(3280),
    [anon_sym_readonly] = ACTIONS(3280),
    [anon_sym_get] = ACTIONS(3280),
    [anon_sym_set] = ACTIONS(3280),
    [anon_sym_declare] = ACTIONS(3280),
    [anon_sym_public] = ACTIONS(3280),
    [anon_sym_private] = ACTIONS(3280),
    [anon_sym_protected] = ACTIONS(3280),
    [anon_sym_override] = ACTIONS(3280),
    [anon_sym_module] = ACTIONS(3280),
    [anon_sym_any] = ACTIONS(3280),
    [anon_sym_number] = ACTIONS(3280),
    [anon_sym_boolean] = ACTIONS(3280),
    [anon_sym_string] = ACTIONS(3280),
    [anon_sym_symbol] = ACTIONS(3280),
    [anon_sym_object] = ACTIONS(3280),
    [anon_sym_abstract] = ACTIONS(3280),
    [anon_sym_interface] = ACTIONS(3280),
    [anon_sym_enum] = ACTIONS(3280),
    [sym_html_comment] = ACTIONS(5),
  },
  [1496] = {
    [sym_comment] = STATE(1496),
    [ts_builtin_sym_end] = ACTIONS(3578),
    [sym_identifier] = ACTIONS(3328),
    [anon_sym_export] = ACTIONS(3328),
    [anon_sym_type] = ACTIONS(3328),
    [anon_sym_namespace] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_typeof] = ACTIONS(3328),
    [anon_sym_import] = ACTIONS(3328),
    [anon_sym_with] = ACTIONS(3328),
    [anon_sym_var] = ACTIONS(3328),
    [anon_sym_let] = ACTIONS(3328),
    [anon_sym_const] = ACTIONS(3328),
    [anon_sym_BANG] = ACTIONS(3328),
    [anon_sym_if] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_for] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_await] = ACTIONS(3328),
    [anon_sym_while] = ACTIONS(3328),
    [anon_sym_do] = ACTIONS(3328),
    [anon_sym_try] = ACTIONS(3328),
    [anon_sym_break] = ACTIONS(3328),
    [anon_sym_continue] = ACTIONS(3328),
    [anon_sym_debugger] = ACTIONS(3328),
    [anon_sym_return] = ACTIONS(3328),
    [anon_sym_throw] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_yield] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LTtemplate_GT] = ACTIONS(3328),
    [anon_sym_DQUOTE] = ACTIONS(3328),
    [anon_sym_SQUOTE] = ACTIONS(3328),
    [anon_sym_class] = ACTIONS(3328),
    [anon_sym_async] = ACTIONS(3328),
    [anon_sym_function] = ACTIONS(3328),
    [anon_sym_new] = ACTIONS(3328),
    [anon_sym_using] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3328),
    [anon_sym_DASH] = ACTIONS(3328),
    [anon_sym_SLASH] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3328),
    [anon_sym_TILDE] = ACTIONS(3328),
    [anon_sym_void] = ACTIONS(3328),
    [anon_sym_delete] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3328),
    [sym_number] = ACTIONS(3328),
    [sym_private_property_identifier] = ACTIONS(3328),
    [sym_this] = ACTIONS(3328),
    [sym_super] = ACTIONS(3328),
    [sym_true] = ACTIONS(3328),
    [sym_false] = ACTIONS(3328),
    [sym_null] = ACTIONS(3328),
    [sym_undefined] = ACTIONS(3328),
    [anon_sym_AT] = ACTIONS(3328),
    [anon_sym_static] = ACTIONS(3328),
    [anon_sym_readonly] = ACTIONS(3328),
    [anon_sym_get] = ACTIONS(3328),
    [anon_sym_set] = ACTIONS(3328),
    [anon_sym_declare] = ACTIONS(3328),
    [anon_sym_public] = ACTIONS(3328),
    [anon_sym_private] = ACTIONS(3328),
    [anon_sym_protected] = ACTIONS(3328),
    [anon_sym_override] = ACTIONS(3328),
    [anon_sym_module] = ACTIONS(3328),
    [anon_sym_any] = ACTIONS(3328),
    [anon_sym_number] = ACTIONS(3328),
    [anon_sym_boolean] = ACTIONS(3328),
    [anon_sym_string] = ACTIONS(3328),
    [anon_sym_symbol] = ACTIONS(3328),
    [anon_sym_object] = ACTIONS(3328),
    [anon_sym_abstract] = ACTIONS(3328),
    [anon_sym_interface] = ACTIONS(3328),
    [anon_sym_enum] = ACTIONS(3328),
    [sym_html_comment] = ACTIONS(5),
  },
  [1497] = {
    [sym_comment] = STATE(1497),
    [ts_builtin_sym_end] = ACTIONS(3450),
    [sym_identifier] = ACTIONS(3264),
    [anon_sym_export] = ACTIONS(3264),
    [anon_sym_type] = ACTIONS(3264),
    [anon_sym_namespace] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_RBRACE] = ACTIONS(3264),
    [anon_sym_typeof] = ACTIONS(3264),
    [anon_sym_import] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3264),
    [anon_sym_var] = ACTIONS(3264),
    [anon_sym_let] = ACTIONS(3264),
    [anon_sym_const] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_if] = ACTIONS(3264),
    [anon_sym_switch] = ACTIONS(3264),
    [anon_sym_for] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3264),
    [anon_sym_await] = ACTIONS(3264),
    [anon_sym_while] = ACTIONS(3264),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_try] = ACTIONS(3264),
    [anon_sym_break] = ACTIONS(3264),
    [anon_sym_continue] = ACTIONS(3264),
    [anon_sym_debugger] = ACTIONS(3264),
    [anon_sym_return] = ACTIONS(3264),
    [anon_sym_throw] = ACTIONS(3264),
    [anon_sym_SEMI] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3264),
    [anon_sym_LBRACK] = ACTIONS(3264),
    [anon_sym_LTtemplate_GT] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(3264),
    [anon_sym_SQUOTE] = ACTIONS(3264),
    [anon_sym_class] = ACTIONS(3264),
    [anon_sym_async] = ACTIONS(3264),
    [anon_sym_function] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3264),
    [anon_sym_using] = ACTIONS(3264),
    [anon_sym_PLUS] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3264),
    [anon_sym_SLASH] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_TILDE] = ACTIONS(3264),
    [anon_sym_void] = ACTIONS(3264),
    [anon_sym_delete] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3264),
    [anon_sym_DASH_DASH] = ACTIONS(3264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3264),
    [sym_number] = ACTIONS(3264),
    [sym_private_property_identifier] = ACTIONS(3264),
    [sym_this] = ACTIONS(3264),
    [sym_super] = ACTIONS(3264),
    [sym_true] = ACTIONS(3264),
    [sym_false] = ACTIONS(3264),
    [sym_null] = ACTIONS(3264),
    [sym_undefined] = ACTIONS(3264),
    [anon_sym_AT] = ACTIONS(3264),
    [anon_sym_static] = ACTIONS(3264),
    [anon_sym_readonly] = ACTIONS(3264),
    [anon_sym_get] = ACTIONS(3264),
    [anon_sym_set] = ACTIONS(3264),
    [anon_sym_declare] = ACTIONS(3264),
    [anon_sym_public] = ACTIONS(3264),
    [anon_sym_private] = ACTIONS(3264),
    [anon_sym_protected] = ACTIONS(3264),
    [anon_sym_override] = ACTIONS(3264),
    [anon_sym_module] = ACTIONS(3264),
    [anon_sym_any] = ACTIONS(3264),
    [anon_sym_number] = ACTIONS(3264),
    [anon_sym_boolean] = ACTIONS(3264),
    [anon_sym_string] = ACTIONS(3264),
    [anon_sym_symbol] = ACTIONS(3264),
    [anon_sym_object] = ACTIONS(3264),
    [anon_sym_abstract] = ACTIONS(3264),
    [anon_sym_interface] = ACTIONS(3264),
    [anon_sym_enum] = ACTIONS(3264),
    [sym_html_comment] = ACTIONS(5),
  },
  [1498] = {
    [sym_comment] = STATE(1498),
    [ts_builtin_sym_end] = ACTIONS(3582),
    [sym_identifier] = ACTIONS(3212),
    [anon_sym_export] = ACTIONS(3212),
    [anon_sym_type] = ACTIONS(3212),
    [anon_sym_namespace] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_RBRACE] = ACTIONS(3212),
    [anon_sym_typeof] = ACTIONS(3212),
    [anon_sym_import] = ACTIONS(3212),
    [anon_sym_with] = ACTIONS(3212),
    [anon_sym_var] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_const] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3212),
    [anon_sym_switch] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3212),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_await] = ACTIONS(3212),
    [anon_sym_while] = ACTIONS(3212),
    [anon_sym_do] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3212),
    [anon_sym_break] = ACTIONS(3212),
    [anon_sym_continue] = ACTIONS(3212),
    [anon_sym_debugger] = ACTIONS(3212),
    [anon_sym_return] = ACTIONS(3212),
    [anon_sym_throw] = ACTIONS(3212),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LTtemplate_GT] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_class] = ACTIONS(3212),
    [anon_sym_async] = ACTIONS(3212),
    [anon_sym_function] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_using] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_LT] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_void] = ACTIONS(3212),
    [anon_sym_delete] = ACTIONS(3212),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3212),
    [sym_number] = ACTIONS(3212),
    [sym_private_property_identifier] = ACTIONS(3212),
    [sym_this] = ACTIONS(3212),
    [sym_super] = ACTIONS(3212),
    [sym_true] = ACTIONS(3212),
    [sym_false] = ACTIONS(3212),
    [sym_null] = ACTIONS(3212),
    [sym_undefined] = ACTIONS(3212),
    [anon_sym_AT] = ACTIONS(3212),
    [anon_sym_static] = ACTIONS(3212),
    [anon_sym_readonly] = ACTIONS(3212),
    [anon_sym_get] = ACTIONS(3212),
    [anon_sym_set] = ACTIONS(3212),
    [anon_sym_declare] = ACTIONS(3212),
    [anon_sym_public] = ACTIONS(3212),
    [anon_sym_private] = ACTIONS(3212),
    [anon_sym_protected] = ACTIONS(3212),
    [anon_sym_override] = ACTIONS(3212),
    [anon_sym_module] = ACTIONS(3212),
    [anon_sym_any] = ACTIONS(3212),
    [anon_sym_number] = ACTIONS(3212),
    [anon_sym_boolean] = ACTIONS(3212),
    [anon_sym_string] = ACTIONS(3212),
    [anon_sym_symbol] = ACTIONS(3212),
    [anon_sym_object] = ACTIONS(3212),
    [anon_sym_abstract] = ACTIONS(3212),
    [anon_sym_interface] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3212),
    [sym_html_comment] = ACTIONS(5),
  },
  [1499] = {
    [sym_comment] = STATE(1499),
    [ts_builtin_sym_end] = ACTIONS(3438),
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_export] = ACTIONS(3176),
    [anon_sym_type] = ACTIONS(3176),
    [anon_sym_namespace] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3176),
    [anon_sym_RBRACE] = ACTIONS(3176),
    [anon_sym_typeof] = ACTIONS(3176),
    [anon_sym_import] = ACTIONS(3176),
    [anon_sym_with] = ACTIONS(3176),
    [anon_sym_var] = ACTIONS(3176),
    [anon_sym_let] = ACTIONS(3176),
    [anon_sym_const] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_if] = ACTIONS(3176),
    [anon_sym_switch] = ACTIONS(3176),
    [anon_sym_for] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(3176),
    [anon_sym_await] = ACTIONS(3176),
    [anon_sym_while] = ACTIONS(3176),
    [anon_sym_do] = ACTIONS(3176),
    [anon_sym_try] = ACTIONS(3176),
    [anon_sym_break] = ACTIONS(3176),
    [anon_sym_continue] = ACTIONS(3176),
    [anon_sym_debugger] = ACTIONS(3176),
    [anon_sym_return] = ACTIONS(3176),
    [anon_sym_throw] = ACTIONS(3176),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym_yield] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_LTtemplate_GT] = ACTIONS(3176),
    [anon_sym_DQUOTE] = ACTIONS(3176),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym_class] = ACTIONS(3176),
    [anon_sym_async] = ACTIONS(3176),
    [anon_sym_function] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3176),
    [anon_sym_using] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_SLASH] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3176),
    [anon_sym_TILDE] = ACTIONS(3176),
    [anon_sym_void] = ACTIONS(3176),
    [anon_sym_delete] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3176),
    [sym_number] = ACTIONS(3176),
    [sym_private_property_identifier] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_super] = ACTIONS(3176),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [sym_null] = ACTIONS(3176),
    [sym_undefined] = ACTIONS(3176),
    [anon_sym_AT] = ACTIONS(3176),
    [anon_sym_static] = ACTIONS(3176),
    [anon_sym_readonly] = ACTIONS(3176),
    [anon_sym_get] = ACTIONS(3176),
    [anon_sym_set] = ACTIONS(3176),
    [anon_sym_declare] = ACTIONS(3176),
    [anon_sym_public] = ACTIONS(3176),
    [anon_sym_private] = ACTIONS(3176),
    [anon_sym_protected] = ACTIONS(3176),
    [anon_sym_override] = ACTIONS(3176),
    [anon_sym_module] = ACTIONS(3176),
    [anon_sym_any] = ACTIONS(3176),
    [anon_sym_number] = ACTIONS(3176),
    [anon_sym_boolean] = ACTIONS(3176),
    [anon_sym_string] = ACTIONS(3176),
    [anon_sym_symbol] = ACTIONS(3176),
    [anon_sym_object] = ACTIONS(3176),
    [anon_sym_abstract] = ACTIONS(3176),
    [anon_sym_interface] = ACTIONS(3176),
    [anon_sym_enum] = ACTIONS(3176),
    [sym_html_comment] = ACTIONS(5),
  },
  [1500] = {
    [sym_comment] = STATE(1500),
    [ts_builtin_sym_end] = ACTIONS(3516),
    [sym_identifier] = ACTIONS(3300),
    [anon_sym_export] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3300),
    [anon_sym_namespace] = ACTIONS(3300),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_typeof] = ACTIONS(3300),
    [anon_sym_import] = ACTIONS(3300),
    [anon_sym_with] = ACTIONS(3300),
    [anon_sym_var] = ACTIONS(3300),
    [anon_sym_let] = ACTIONS(3300),
    [anon_sym_const] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_if] = ACTIONS(3300),
    [anon_sym_switch] = ACTIONS(3300),
    [anon_sym_for] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_await] = ACTIONS(3300),
    [anon_sym_while] = ACTIONS(3300),
    [anon_sym_do] = ACTIONS(3300),
    [anon_sym_try] = ACTIONS(3300),
    [anon_sym_break] = ACTIONS(3300),
    [anon_sym_continue] = ACTIONS(3300),
    [anon_sym_debugger] = ACTIONS(3300),
    [anon_sym_return] = ACTIONS(3300),
    [anon_sym_throw] = ACTIONS(3300),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym_yield] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LTtemplate_GT] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [anon_sym_class] = ACTIONS(3300),
    [anon_sym_async] = ACTIONS(3300),
    [anon_sym_function] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3300),
    [anon_sym_using] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3300),
    [anon_sym_SLASH] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_void] = ACTIONS(3300),
    [anon_sym_delete] = ACTIONS(3300),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3300),
    [sym_number] = ACTIONS(3300),
    [sym_private_property_identifier] = ACTIONS(3300),
    [sym_this] = ACTIONS(3300),
    [sym_super] = ACTIONS(3300),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_null] = ACTIONS(3300),
    [sym_undefined] = ACTIONS(3300),
    [anon_sym_AT] = ACTIONS(3300),
    [anon_sym_static] = ACTIONS(3300),
    [anon_sym_readonly] = ACTIONS(3300),
    [anon_sym_get] = ACTIONS(3300),
    [anon_sym_set] = ACTIONS(3300),
    [anon_sym_declare] = ACTIONS(3300),
    [anon_sym_public] = ACTIONS(3300),
    [anon_sym_private] = ACTIONS(3300),
    [anon_sym_protected] = ACTIONS(3300),
    [anon_sym_override] = ACTIONS(3300),
    [anon_sym_module] = ACTIONS(3300),
    [anon_sym_any] = ACTIONS(3300),
    [anon_sym_number] = ACTIONS(3300),
    [anon_sym_boolean] = ACTIONS(3300),
    [anon_sym_string] = ACTIONS(3300),
    [anon_sym_symbol] = ACTIONS(3300),
    [anon_sym_object] = ACTIONS(3300),
    [anon_sym_abstract] = ACTIONS(3300),
    [anon_sym_interface] = ACTIONS(3300),
    [anon_sym_enum] = ACTIONS(3300),
    [sym_html_comment] = ACTIONS(5),
  },
  [1501] = {
    [sym_comment] = STATE(1501),
    [ts_builtin_sym_end] = ACTIONS(3584),
    [sym_identifier] = ACTIONS(3216),
    [anon_sym_export] = ACTIONS(3216),
    [anon_sym_type] = ACTIONS(3216),
    [anon_sym_namespace] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_typeof] = ACTIONS(3216),
    [anon_sym_import] = ACTIONS(3216),
    [anon_sym_with] = ACTIONS(3216),
    [anon_sym_var] = ACTIONS(3216),
    [anon_sym_let] = ACTIONS(3216),
    [anon_sym_const] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_if] = ACTIONS(3216),
    [anon_sym_switch] = ACTIONS(3216),
    [anon_sym_for] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [anon_sym_await] = ACTIONS(3216),
    [anon_sym_while] = ACTIONS(3216),
    [anon_sym_do] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(3216),
    [anon_sym_break] = ACTIONS(3216),
    [anon_sym_continue] = ACTIONS(3216),
    [anon_sym_debugger] = ACTIONS(3216),
    [anon_sym_return] = ACTIONS(3216),
    [anon_sym_throw] = ACTIONS(3216),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym_yield] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [anon_sym_LTtemplate_GT] = ACTIONS(3216),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_async] = ACTIONS(3216),
    [anon_sym_function] = ACTIONS(3216),
    [anon_sym_new] = ACTIONS(3216),
    [anon_sym_using] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_SLASH] = ACTIONS(3216),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_void] = ACTIONS(3216),
    [anon_sym_delete] = ACTIONS(3216),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3216),
    [sym_number] = ACTIONS(3216),
    [sym_private_property_identifier] = ACTIONS(3216),
    [sym_this] = ACTIONS(3216),
    [sym_super] = ACTIONS(3216),
    [sym_true] = ACTIONS(3216),
    [sym_false] = ACTIONS(3216),
    [sym_null] = ACTIONS(3216),
    [sym_undefined] = ACTIONS(3216),
    [anon_sym_AT] = ACTIONS(3216),
    [anon_sym_static] = ACTIONS(3216),
    [anon_sym_readonly] = ACTIONS(3216),
    [anon_sym_get] = ACTIONS(3216),
    [anon_sym_set] = ACTIONS(3216),
    [anon_sym_declare] = ACTIONS(3216),
    [anon_sym_public] = ACTIONS(3216),
    [anon_sym_private] = ACTIONS(3216),
    [anon_sym_protected] = ACTIONS(3216),
    [anon_sym_override] = ACTIONS(3216),
    [anon_sym_module] = ACTIONS(3216),
    [anon_sym_any] = ACTIONS(3216),
    [anon_sym_number] = ACTIONS(3216),
    [anon_sym_boolean] = ACTIONS(3216),
    [anon_sym_string] = ACTIONS(3216),
    [anon_sym_symbol] = ACTIONS(3216),
    [anon_sym_object] = ACTIONS(3216),
    [anon_sym_abstract] = ACTIONS(3216),
    [anon_sym_interface] = ACTIONS(3216),
    [anon_sym_enum] = ACTIONS(3216),
    [sym_html_comment] = ACTIONS(5),
  },
  [1502] = {
    [sym_comment] = STATE(1502),
    [ts_builtin_sym_end] = ACTIONS(3560),
    [sym_identifier] = ACTIONS(3370),
    [anon_sym_export] = ACTIONS(3370),
    [anon_sym_type] = ACTIONS(3370),
    [anon_sym_namespace] = ACTIONS(3370),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_typeof] = ACTIONS(3370),
    [anon_sym_import] = ACTIONS(3370),
    [anon_sym_with] = ACTIONS(3370),
    [anon_sym_var] = ACTIONS(3370),
    [anon_sym_let] = ACTIONS(3370),
    [anon_sym_const] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3370),
    [anon_sym_if] = ACTIONS(3370),
    [anon_sym_switch] = ACTIONS(3370),
    [anon_sym_for] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_await] = ACTIONS(3370),
    [anon_sym_while] = ACTIONS(3370),
    [anon_sym_do] = ACTIONS(3370),
    [anon_sym_try] = ACTIONS(3370),
    [anon_sym_break] = ACTIONS(3370),
    [anon_sym_continue] = ACTIONS(3370),
    [anon_sym_debugger] = ACTIONS(3370),
    [anon_sym_return] = ACTIONS(3370),
    [anon_sym_throw] = ACTIONS(3370),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym_yield] = ACTIONS(3370),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_LTtemplate_GT] = ACTIONS(3370),
    [anon_sym_DQUOTE] = ACTIONS(3370),
    [anon_sym_SQUOTE] = ACTIONS(3370),
    [anon_sym_class] = ACTIONS(3370),
    [anon_sym_async] = ACTIONS(3370),
    [anon_sym_function] = ACTIONS(3370),
    [anon_sym_new] = ACTIONS(3370),
    [anon_sym_using] = ACTIONS(3370),
    [anon_sym_PLUS] = ACTIONS(3370),
    [anon_sym_DASH] = ACTIONS(3370),
    [anon_sym_SLASH] = ACTIONS(3370),
    [anon_sym_LT] = ACTIONS(3370),
    [anon_sym_TILDE] = ACTIONS(3370),
    [anon_sym_void] = ACTIONS(3370),
    [anon_sym_delete] = ACTIONS(3370),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3370),
    [sym_number] = ACTIONS(3370),
    [sym_private_property_identifier] = ACTIONS(3370),
    [sym_this] = ACTIONS(3370),
    [sym_super] = ACTIONS(3370),
    [sym_true] = ACTIONS(3370),
    [sym_false] = ACTIONS(3370),
    [sym_null] = ACTIONS(3370),
    [sym_undefined] = ACTIONS(3370),
    [anon_sym_AT] = ACTIONS(3370),
    [anon_sym_static] = ACTIONS(3370),
    [anon_sym_readonly] = ACTIONS(3370),
    [anon_sym_get] = ACTIONS(3370),
    [anon_sym_set] = ACTIONS(3370),
    [anon_sym_declare] = ACTIONS(3370),
    [anon_sym_public] = ACTIONS(3370),
    [anon_sym_private] = ACTIONS(3370),
    [anon_sym_protected] = ACTIONS(3370),
    [anon_sym_override] = ACTIONS(3370),
    [anon_sym_module] = ACTIONS(3370),
    [anon_sym_any] = ACTIONS(3370),
    [anon_sym_number] = ACTIONS(3370),
    [anon_sym_boolean] = ACTIONS(3370),
    [anon_sym_string] = ACTIONS(3370),
    [anon_sym_symbol] = ACTIONS(3370),
    [anon_sym_object] = ACTIONS(3370),
    [anon_sym_abstract] = ACTIONS(3370),
    [anon_sym_interface] = ACTIONS(3370),
    [anon_sym_enum] = ACTIONS(3370),
    [sym_html_comment] = ACTIONS(5),
  },
  [1503] = {
    [sym_comment] = STATE(1503),
    [ts_builtin_sym_end] = ACTIONS(3566),
    [sym_identifier] = ACTIONS(3314),
    [anon_sym_export] = ACTIONS(3314),
    [anon_sym_type] = ACTIONS(3314),
    [anon_sym_namespace] = ACTIONS(3314),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_RBRACE] = ACTIONS(3314),
    [anon_sym_typeof] = ACTIONS(3314),
    [anon_sym_import] = ACTIONS(3314),
    [anon_sym_with] = ACTIONS(3314),
    [anon_sym_var] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3314),
    [anon_sym_const] = ACTIONS(3314),
    [anon_sym_BANG] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_await] = ACTIONS(3314),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_do] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3314),
    [anon_sym_break] = ACTIONS(3314),
    [anon_sym_continue] = ACTIONS(3314),
    [anon_sym_debugger] = ACTIONS(3314),
    [anon_sym_return] = ACTIONS(3314),
    [anon_sym_throw] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3314),
    [anon_sym_yield] = ACTIONS(3314),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [anon_sym_LTtemplate_GT] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_SQUOTE] = ACTIONS(3314),
    [anon_sym_class] = ACTIONS(3314),
    [anon_sym_async] = ACTIONS(3314),
    [anon_sym_function] = ACTIONS(3314),
    [anon_sym_new] = ACTIONS(3314),
    [anon_sym_using] = ACTIONS(3314),
    [anon_sym_PLUS] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_SLASH] = ACTIONS(3314),
    [anon_sym_LT] = ACTIONS(3314),
    [anon_sym_TILDE] = ACTIONS(3314),
    [anon_sym_void] = ACTIONS(3314),
    [anon_sym_delete] = ACTIONS(3314),
    [anon_sym_PLUS_PLUS] = ACTIONS(3314),
    [anon_sym_DASH_DASH] = ACTIONS(3314),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3314),
    [sym_number] = ACTIONS(3314),
    [sym_private_property_identifier] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_undefined] = ACTIONS(3314),
    [anon_sym_AT] = ACTIONS(3314),
    [anon_sym_static] = ACTIONS(3314),
    [anon_sym_readonly] = ACTIONS(3314),
    [anon_sym_get] = ACTIONS(3314),
    [anon_sym_set] = ACTIONS(3314),
    [anon_sym_declare] = ACTIONS(3314),
    [anon_sym_public] = ACTIONS(3314),
    [anon_sym_private] = ACTIONS(3314),
    [anon_sym_protected] = ACTIONS(3314),
    [anon_sym_override] = ACTIONS(3314),
    [anon_sym_module] = ACTIONS(3314),
    [anon_sym_any] = ACTIONS(3314),
    [anon_sym_number] = ACTIONS(3314),
    [anon_sym_boolean] = ACTIONS(3314),
    [anon_sym_string] = ACTIONS(3314),
    [anon_sym_symbol] = ACTIONS(3314),
    [anon_sym_object] = ACTIONS(3314),
    [anon_sym_abstract] = ACTIONS(3314),
    [anon_sym_interface] = ACTIONS(3314),
    [anon_sym_enum] = ACTIONS(3314),
    [sym_html_comment] = ACTIONS(5),
  },
  [1504] = {
    [sym_comment] = STATE(1504),
    [ts_builtin_sym_end] = ACTIONS(3568),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_export] = ACTIONS(3318),
    [anon_sym_type] = ACTIONS(3318),
    [anon_sym_namespace] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_RBRACE] = ACTIONS(3318),
    [anon_sym_typeof] = ACTIONS(3318),
    [anon_sym_import] = ACTIONS(3318),
    [anon_sym_with] = ACTIONS(3318),
    [anon_sym_var] = ACTIONS(3318),
    [anon_sym_let] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_if] = ACTIONS(3318),
    [anon_sym_switch] = ACTIONS(3318),
    [anon_sym_for] = ACTIONS(3318),
    [anon_sym_LPAREN] = ACTIONS(3318),
    [anon_sym_await] = ACTIONS(3318),
    [anon_sym_while] = ACTIONS(3318),
    [anon_sym_do] = ACTIONS(3318),
    [anon_sym_try] = ACTIONS(3318),
    [anon_sym_break] = ACTIONS(3318),
    [anon_sym_continue] = ACTIONS(3318),
    [anon_sym_debugger] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_throw] = ACTIONS(3318),
    [anon_sym_SEMI] = ACTIONS(3318),
    [anon_sym_yield] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3318),
    [anon_sym_LTtemplate_GT] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3318),
    [anon_sym_SQUOTE] = ACTIONS(3318),
    [anon_sym_class] = ACTIONS(3318),
    [anon_sym_async] = ACTIONS(3318),
    [anon_sym_function] = ACTIONS(3318),
    [anon_sym_new] = ACTIONS(3318),
    [anon_sym_using] = ACTIONS(3318),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_TILDE] = ACTIONS(3318),
    [anon_sym_void] = ACTIONS(3318),
    [anon_sym_delete] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3318),
    [anon_sym_DASH_DASH] = ACTIONS(3318),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3318),
    [sym_number] = ACTIONS(3318),
    [sym_private_property_identifier] = ACTIONS(3318),
    [sym_this] = ACTIONS(3318),
    [sym_super] = ACTIONS(3318),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_null] = ACTIONS(3318),
    [sym_undefined] = ACTIONS(3318),
    [anon_sym_AT] = ACTIONS(3318),
    [anon_sym_static] = ACTIONS(3318),
    [anon_sym_readonly] = ACTIONS(3318),
    [anon_sym_get] = ACTIONS(3318),
    [anon_sym_set] = ACTIONS(3318),
    [anon_sym_declare] = ACTIONS(3318),
    [anon_sym_public] = ACTIONS(3318),
    [anon_sym_private] = ACTIONS(3318),
    [anon_sym_protected] = ACTIONS(3318),
    [anon_sym_override] = ACTIONS(3318),
    [anon_sym_module] = ACTIONS(3318),
    [anon_sym_any] = ACTIONS(3318),
    [anon_sym_number] = ACTIONS(3318),
    [anon_sym_boolean] = ACTIONS(3318),
    [anon_sym_string] = ACTIONS(3318),
    [anon_sym_symbol] = ACTIONS(3318),
    [anon_sym_object] = ACTIONS(3318),
    [anon_sym_abstract] = ACTIONS(3318),
    [anon_sym_interface] = ACTIONS(3318),
    [anon_sym_enum] = ACTIONS(3318),
    [sym_html_comment] = ACTIONS(5),
  },
  [1505] = {
    [sym_comment] = STATE(1505),
    [ts_builtin_sym_end] = ACTIONS(3558),
    [sym_identifier] = ACTIONS(3364),
    [anon_sym_export] = ACTIONS(3364),
    [anon_sym_type] = ACTIONS(3364),
    [anon_sym_namespace] = ACTIONS(3364),
    [anon_sym_LBRACE] = ACTIONS(3364),
    [anon_sym_RBRACE] = ACTIONS(3364),
    [anon_sym_typeof] = ACTIONS(3364),
    [anon_sym_import] = ACTIONS(3364),
    [anon_sym_with] = ACTIONS(3364),
    [anon_sym_var] = ACTIONS(3364),
    [anon_sym_let] = ACTIONS(3364),
    [anon_sym_const] = ACTIONS(3364),
    [anon_sym_BANG] = ACTIONS(3364),
    [anon_sym_if] = ACTIONS(3364),
    [anon_sym_switch] = ACTIONS(3364),
    [anon_sym_for] = ACTIONS(3364),
    [anon_sym_LPAREN] = ACTIONS(3364),
    [anon_sym_await] = ACTIONS(3364),
    [anon_sym_while] = ACTIONS(3364),
    [anon_sym_do] = ACTIONS(3364),
    [anon_sym_try] = ACTIONS(3364),
    [anon_sym_break] = ACTIONS(3364),
    [anon_sym_continue] = ACTIONS(3364),
    [anon_sym_debugger] = ACTIONS(3364),
    [anon_sym_return] = ACTIONS(3364),
    [anon_sym_throw] = ACTIONS(3364),
    [anon_sym_SEMI] = ACTIONS(3364),
    [anon_sym_yield] = ACTIONS(3364),
    [anon_sym_LBRACK] = ACTIONS(3364),
    [anon_sym_LTtemplate_GT] = ACTIONS(3364),
    [anon_sym_DQUOTE] = ACTIONS(3364),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym_class] = ACTIONS(3364),
    [anon_sym_async] = ACTIONS(3364),
    [anon_sym_function] = ACTIONS(3364),
    [anon_sym_new] = ACTIONS(3364),
    [anon_sym_using] = ACTIONS(3364),
    [anon_sym_PLUS] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3364),
    [anon_sym_SLASH] = ACTIONS(3364),
    [anon_sym_LT] = ACTIONS(3364),
    [anon_sym_TILDE] = ACTIONS(3364),
    [anon_sym_void] = ACTIONS(3364),
    [anon_sym_delete] = ACTIONS(3364),
    [anon_sym_PLUS_PLUS] = ACTIONS(3364),
    [anon_sym_DASH_DASH] = ACTIONS(3364),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3364),
    [sym_number] = ACTIONS(3364),
    [sym_private_property_identifier] = ACTIONS(3364),
    [sym_this] = ACTIONS(3364),
    [sym_super] = ACTIONS(3364),
    [sym_true] = ACTIONS(3364),
    [sym_false] = ACTIONS(3364),
    [sym_null] = ACTIONS(3364),
    [sym_undefined] = ACTIONS(3364),
    [anon_sym_AT] = ACTIONS(3364),
    [anon_sym_static] = ACTIONS(3364),
    [anon_sym_readonly] = ACTIONS(3364),
    [anon_sym_get] = ACTIONS(3364),
    [anon_sym_set] = ACTIONS(3364),
    [anon_sym_declare] = ACTIONS(3364),
    [anon_sym_public] = ACTIONS(3364),
    [anon_sym_private] = ACTIONS(3364),
    [anon_sym_protected] = ACTIONS(3364),
    [anon_sym_override] = ACTIONS(3364),
    [anon_sym_module] = ACTIONS(3364),
    [anon_sym_any] = ACTIONS(3364),
    [anon_sym_number] = ACTIONS(3364),
    [anon_sym_boolean] = ACTIONS(3364),
    [anon_sym_string] = ACTIONS(3364),
    [anon_sym_symbol] = ACTIONS(3364),
    [anon_sym_object] = ACTIONS(3364),
    [anon_sym_abstract] = ACTIONS(3364),
    [anon_sym_interface] = ACTIONS(3364),
    [anon_sym_enum] = ACTIONS(3364),
    [sym_html_comment] = ACTIONS(5),
  },
  [1506] = {
    [sym_comment] = STATE(1506),
    [ts_builtin_sym_end] = ACTIONS(3508),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_export] = ACTIONS(3230),
    [anon_sym_type] = ACTIONS(3230),
    [anon_sym_namespace] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_RBRACE] = ACTIONS(3230),
    [anon_sym_typeof] = ACTIONS(3230),
    [anon_sym_import] = ACTIONS(3230),
    [anon_sym_with] = ACTIONS(3230),
    [anon_sym_var] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_const] = ACTIONS(3230),
    [anon_sym_BANG] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_switch] = ACTIONS(3230),
    [anon_sym_for] = ACTIONS(3230),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [anon_sym_await] = ACTIONS(3230),
    [anon_sym_while] = ACTIONS(3230),
    [anon_sym_do] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3230),
    [anon_sym_break] = ACTIONS(3230),
    [anon_sym_continue] = ACTIONS(3230),
    [anon_sym_debugger] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(3230),
    [anon_sym_throw] = ACTIONS(3230),
    [anon_sym_SEMI] = ACTIONS(3230),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LTtemplate_GT] = ACTIONS(3230),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_SQUOTE] = ACTIONS(3230),
    [anon_sym_class] = ACTIONS(3230),
    [anon_sym_async] = ACTIONS(3230),
    [anon_sym_function] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_SLASH] = ACTIONS(3230),
    [anon_sym_LT] = ACTIONS(3230),
    [anon_sym_TILDE] = ACTIONS(3230),
    [anon_sym_void] = ACTIONS(3230),
    [anon_sym_delete] = ACTIONS(3230),
    [anon_sym_PLUS_PLUS] = ACTIONS(3230),
    [anon_sym_DASH_DASH] = ACTIONS(3230),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3230),
    [sym_number] = ACTIONS(3230),
    [sym_private_property_identifier] = ACTIONS(3230),
    [sym_this] = ACTIONS(3230),
    [sym_super] = ACTIONS(3230),
    [sym_true] = ACTIONS(3230),
    [sym_false] = ACTIONS(3230),
    [sym_null] = ACTIONS(3230),
    [sym_undefined] = ACTIONS(3230),
    [anon_sym_AT] = ACTIONS(3230),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_readonly] = ACTIONS(3230),
    [anon_sym_get] = ACTIONS(3230),
    [anon_sym_set] = ACTIONS(3230),
    [anon_sym_declare] = ACTIONS(3230),
    [anon_sym_public] = ACTIONS(3230),
    [anon_sym_private] = ACTIONS(3230),
    [anon_sym_protected] = ACTIONS(3230),
    [anon_sym_override] = ACTIONS(3230),
    [anon_sym_module] = ACTIONS(3230),
    [anon_sym_any] = ACTIONS(3230),
    [anon_sym_number] = ACTIONS(3230),
    [anon_sym_boolean] = ACTIONS(3230),
    [anon_sym_string] = ACTIONS(3230),
    [anon_sym_symbol] = ACTIONS(3230),
    [anon_sym_object] = ACTIONS(3230),
    [anon_sym_abstract] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3230),
    [anon_sym_enum] = ACTIONS(3230),
    [sym_html_comment] = ACTIONS(5),
  },
  [1507] = {
    [sym_comment] = STATE(1507),
    [ts_builtin_sym_end] = ACTIONS(3556),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_export] = ACTIONS(3352),
    [anon_sym_type] = ACTIONS(3352),
    [anon_sym_namespace] = ACTIONS(3352),
    [anon_sym_LBRACE] = ACTIONS(3352),
    [anon_sym_RBRACE] = ACTIONS(3352),
    [anon_sym_typeof] = ACTIONS(3352),
    [anon_sym_import] = ACTIONS(3352),
    [anon_sym_with] = ACTIONS(3352),
    [anon_sym_var] = ACTIONS(3352),
    [anon_sym_let] = ACTIONS(3352),
    [anon_sym_const] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_if] = ACTIONS(3352),
    [anon_sym_switch] = ACTIONS(3352),
    [anon_sym_for] = ACTIONS(3352),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [anon_sym_await] = ACTIONS(3352),
    [anon_sym_while] = ACTIONS(3352),
    [anon_sym_do] = ACTIONS(3352),
    [anon_sym_try] = ACTIONS(3352),
    [anon_sym_break] = ACTIONS(3352),
    [anon_sym_continue] = ACTIONS(3352),
    [anon_sym_debugger] = ACTIONS(3352),
    [anon_sym_return] = ACTIONS(3352),
    [anon_sym_throw] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_yield] = ACTIONS(3352),
    [anon_sym_LBRACK] = ACTIONS(3352),
    [anon_sym_LTtemplate_GT] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [anon_sym_SQUOTE] = ACTIONS(3352),
    [anon_sym_class] = ACTIONS(3352),
    [anon_sym_async] = ACTIONS(3352),
    [anon_sym_function] = ACTIONS(3352),
    [anon_sym_new] = ACTIONS(3352),
    [anon_sym_using] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_SLASH] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_TILDE] = ACTIONS(3352),
    [anon_sym_void] = ACTIONS(3352),
    [anon_sym_delete] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3352),
    [anon_sym_DASH_DASH] = ACTIONS(3352),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [sym_number] = ACTIONS(3352),
    [sym_private_property_identifier] = ACTIONS(3352),
    [sym_this] = ACTIONS(3352),
    [sym_super] = ACTIONS(3352),
    [sym_true] = ACTIONS(3352),
    [sym_false] = ACTIONS(3352),
    [sym_null] = ACTIONS(3352),
    [sym_undefined] = ACTIONS(3352),
    [anon_sym_AT] = ACTIONS(3352),
    [anon_sym_static] = ACTIONS(3352),
    [anon_sym_readonly] = ACTIONS(3352),
    [anon_sym_get] = ACTIONS(3352),
    [anon_sym_set] = ACTIONS(3352),
    [anon_sym_declare] = ACTIONS(3352),
    [anon_sym_public] = ACTIONS(3352),
    [anon_sym_private] = ACTIONS(3352),
    [anon_sym_protected] = ACTIONS(3352),
    [anon_sym_override] = ACTIONS(3352),
    [anon_sym_module] = ACTIONS(3352),
    [anon_sym_any] = ACTIONS(3352),
    [anon_sym_number] = ACTIONS(3352),
    [anon_sym_boolean] = ACTIONS(3352),
    [anon_sym_string] = ACTIONS(3352),
    [anon_sym_symbol] = ACTIONS(3352),
    [anon_sym_object] = ACTIONS(3352),
    [anon_sym_abstract] = ACTIONS(3352),
    [anon_sym_interface] = ACTIONS(3352),
    [anon_sym_enum] = ACTIONS(3352),
    [sym_html_comment] = ACTIONS(5),
  },
  [1508] = {
    [sym_comment] = STATE(1508),
    [ts_builtin_sym_end] = ACTIONS(3374),
    [sym_identifier] = ACTIONS(3368),
    [anon_sym_export] = ACTIONS(3368),
    [anon_sym_type] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3368),
    [anon_sym_RBRACE] = ACTIONS(3368),
    [anon_sym_typeof] = ACTIONS(3368),
    [anon_sym_import] = ACTIONS(3368),
    [anon_sym_with] = ACTIONS(3368),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_LPAREN] = ACTIONS(3368),
    [anon_sym_await] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_debugger] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3368),
    [anon_sym_yield] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_LTtemplate_GT] = ACTIONS(3368),
    [anon_sym_DQUOTE] = ACTIONS(3368),
    [anon_sym_SQUOTE] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_async] = ACTIONS(3368),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_TILDE] = ACTIONS(3368),
    [anon_sym_void] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3368),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3368),
    [sym_number] = ACTIONS(3368),
    [sym_private_property_identifier] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [sym_super] = ACTIONS(3368),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [sym_null] = ACTIONS(3368),
    [sym_undefined] = ACTIONS(3368),
    [anon_sym_AT] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_readonly] = ACTIONS(3368),
    [anon_sym_get] = ACTIONS(3368),
    [anon_sym_set] = ACTIONS(3368),
    [anon_sym_declare] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_override] = ACTIONS(3368),
    [anon_sym_module] = ACTIONS(3368),
    [anon_sym_any] = ACTIONS(3368),
    [anon_sym_number] = ACTIONS(3368),
    [anon_sym_boolean] = ACTIONS(3368),
    [anon_sym_string] = ACTIONS(3368),
    [anon_sym_symbol] = ACTIONS(3368),
    [anon_sym_object] = ACTIONS(3368),
    [anon_sym_abstract] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [sym_html_comment] = ACTIONS(5),
  },
  [1509] = {
    [sym_comment] = STATE(1509),
    [ts_builtin_sym_end] = ACTIONS(3554),
    [sym_identifier] = ACTIONS(3344),
    [anon_sym_export] = ACTIONS(3344),
    [anon_sym_type] = ACTIONS(3344),
    [anon_sym_namespace] = ACTIONS(3344),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_RBRACE] = ACTIONS(3344),
    [anon_sym_typeof] = ACTIONS(3344),
    [anon_sym_import] = ACTIONS(3344),
    [anon_sym_with] = ACTIONS(3344),
    [anon_sym_var] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3344),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3344),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_await] = ACTIONS(3344),
    [anon_sym_while] = ACTIONS(3344),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3344),
    [anon_sym_break] = ACTIONS(3344),
    [anon_sym_continue] = ACTIONS(3344),
    [anon_sym_debugger] = ACTIONS(3344),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_throw] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3344),
    [anon_sym_yield] = ACTIONS(3344),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [anon_sym_LTtemplate_GT] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_SQUOTE] = ACTIONS(3344),
    [anon_sym_class] = ACTIONS(3344),
    [anon_sym_async] = ACTIONS(3344),
    [anon_sym_function] = ACTIONS(3344),
    [anon_sym_new] = ACTIONS(3344),
    [anon_sym_using] = ACTIONS(3344),
    [anon_sym_PLUS] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3344),
    [anon_sym_SLASH] = ACTIONS(3344),
    [anon_sym_LT] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_void] = ACTIONS(3344),
    [anon_sym_delete] = ACTIONS(3344),
    [anon_sym_PLUS_PLUS] = ACTIONS(3344),
    [anon_sym_DASH_DASH] = ACTIONS(3344),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3344),
    [sym_number] = ACTIONS(3344),
    [sym_private_property_identifier] = ACTIONS(3344),
    [sym_this] = ACTIONS(3344),
    [sym_super] = ACTIONS(3344),
    [sym_true] = ACTIONS(3344),
    [sym_false] = ACTIONS(3344),
    [sym_null] = ACTIONS(3344),
    [sym_undefined] = ACTIONS(3344),
    [anon_sym_AT] = ACTIONS(3344),
    [anon_sym_static] = ACTIONS(3344),
    [anon_sym_readonly] = ACTIONS(3344),
    [anon_sym_get] = ACTIONS(3344),
    [anon_sym_set] = ACTIONS(3344),
    [anon_sym_declare] = ACTIONS(3344),
    [anon_sym_public] = ACTIONS(3344),
    [anon_sym_private] = ACTIONS(3344),
    [anon_sym_protected] = ACTIONS(3344),
    [anon_sym_override] = ACTIONS(3344),
    [anon_sym_module] = ACTIONS(3344),
    [anon_sym_any] = ACTIONS(3344),
    [anon_sym_number] = ACTIONS(3344),
    [anon_sym_boolean] = ACTIONS(3344),
    [anon_sym_string] = ACTIONS(3344),
    [anon_sym_symbol] = ACTIONS(3344),
    [anon_sym_object] = ACTIONS(3344),
    [anon_sym_abstract] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3344),
    [anon_sym_enum] = ACTIONS(3344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1510] = {
    [sym_comment] = STATE(1510),
    [ts_builtin_sym_end] = ACTIONS(3374),
    [sym_identifier] = ACTIONS(3368),
    [anon_sym_export] = ACTIONS(3368),
    [anon_sym_type] = ACTIONS(3368),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3368),
    [anon_sym_RBRACE] = ACTIONS(3368),
    [anon_sym_typeof] = ACTIONS(3368),
    [anon_sym_import] = ACTIONS(3368),
    [anon_sym_with] = ACTIONS(3368),
    [anon_sym_var] = ACTIONS(3368),
    [anon_sym_let] = ACTIONS(3368),
    [anon_sym_const] = ACTIONS(3368),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_if] = ACTIONS(3368),
    [anon_sym_switch] = ACTIONS(3368),
    [anon_sym_for] = ACTIONS(3368),
    [anon_sym_LPAREN] = ACTIONS(3368),
    [anon_sym_await] = ACTIONS(3368),
    [anon_sym_while] = ACTIONS(3368),
    [anon_sym_do] = ACTIONS(3368),
    [anon_sym_try] = ACTIONS(3368),
    [anon_sym_break] = ACTIONS(3368),
    [anon_sym_continue] = ACTIONS(3368),
    [anon_sym_debugger] = ACTIONS(3368),
    [anon_sym_return] = ACTIONS(3368),
    [anon_sym_throw] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3368),
    [anon_sym_yield] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3368),
    [anon_sym_LTtemplate_GT] = ACTIONS(3368),
    [anon_sym_DQUOTE] = ACTIONS(3368),
    [anon_sym_SQUOTE] = ACTIONS(3368),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_async] = ACTIONS(3368),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(3368),
    [anon_sym_using] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_TILDE] = ACTIONS(3368),
    [anon_sym_void] = ACTIONS(3368),
    [anon_sym_delete] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3368),
    [anon_sym_DASH_DASH] = ACTIONS(3368),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3368),
    [sym_number] = ACTIONS(3368),
    [sym_private_property_identifier] = ACTIONS(3368),
    [sym_this] = ACTIONS(3368),
    [sym_super] = ACTIONS(3368),
    [sym_true] = ACTIONS(3368),
    [sym_false] = ACTIONS(3368),
    [sym_null] = ACTIONS(3368),
    [sym_undefined] = ACTIONS(3368),
    [anon_sym_AT] = ACTIONS(3368),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_readonly] = ACTIONS(3368),
    [anon_sym_get] = ACTIONS(3368),
    [anon_sym_set] = ACTIONS(3368),
    [anon_sym_declare] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_override] = ACTIONS(3368),
    [anon_sym_module] = ACTIONS(3368),
    [anon_sym_any] = ACTIONS(3368),
    [anon_sym_number] = ACTIONS(3368),
    [anon_sym_boolean] = ACTIONS(3368),
    [anon_sym_string] = ACTIONS(3368),
    [anon_sym_symbol] = ACTIONS(3368),
    [anon_sym_object] = ACTIONS(3368),
    [anon_sym_abstract] = ACTIONS(3368),
    [anon_sym_interface] = ACTIONS(3368),
    [anon_sym_enum] = ACTIONS(3368),
    [sym_html_comment] = ACTIONS(5),
  },
  [1511] = {
    [sym_comment] = STATE(1511),
    [ts_builtin_sym_end] = ACTIONS(3552),
    [sym_identifier] = ACTIONS(3342),
    [anon_sym_export] = ACTIONS(3342),
    [anon_sym_type] = ACTIONS(3342),
    [anon_sym_namespace] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3342),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_typeof] = ACTIONS(3342),
    [anon_sym_import] = ACTIONS(3342),
    [anon_sym_with] = ACTIONS(3342),
    [anon_sym_var] = ACTIONS(3342),
    [anon_sym_let] = ACTIONS(3342),
    [anon_sym_const] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_if] = ACTIONS(3342),
    [anon_sym_switch] = ACTIONS(3342),
    [anon_sym_for] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3342),
    [anon_sym_await] = ACTIONS(3342),
    [anon_sym_while] = ACTIONS(3342),
    [anon_sym_do] = ACTIONS(3342),
    [anon_sym_try] = ACTIONS(3342),
    [anon_sym_break] = ACTIONS(3342),
    [anon_sym_continue] = ACTIONS(3342),
    [anon_sym_debugger] = ACTIONS(3342),
    [anon_sym_return] = ACTIONS(3342),
    [anon_sym_throw] = ACTIONS(3342),
    [anon_sym_SEMI] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3342),
    [anon_sym_LBRACK] = ACTIONS(3342),
    [anon_sym_LTtemplate_GT] = ACTIONS(3342),
    [anon_sym_DQUOTE] = ACTIONS(3342),
    [anon_sym_SQUOTE] = ACTIONS(3342),
    [anon_sym_class] = ACTIONS(3342),
    [anon_sym_async] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3342),
    [anon_sym_using] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_SLASH] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3342),
    [anon_sym_void] = ACTIONS(3342),
    [anon_sym_delete] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(3342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3342),
    [sym_number] = ACTIONS(3342),
    [sym_private_property_identifier] = ACTIONS(3342),
    [sym_this] = ACTIONS(3342),
    [sym_super] = ACTIONS(3342),
    [sym_true] = ACTIONS(3342),
    [sym_false] = ACTIONS(3342),
    [sym_null] = ACTIONS(3342),
    [sym_undefined] = ACTIONS(3342),
    [anon_sym_AT] = ACTIONS(3342),
    [anon_sym_static] = ACTIONS(3342),
    [anon_sym_readonly] = ACTIONS(3342),
    [anon_sym_get] = ACTIONS(3342),
    [anon_sym_set] = ACTIONS(3342),
    [anon_sym_declare] = ACTIONS(3342),
    [anon_sym_public] = ACTIONS(3342),
    [anon_sym_private] = ACTIONS(3342),
    [anon_sym_protected] = ACTIONS(3342),
    [anon_sym_override] = ACTIONS(3342),
    [anon_sym_module] = ACTIONS(3342),
    [anon_sym_any] = ACTIONS(3342),
    [anon_sym_number] = ACTIONS(3342),
    [anon_sym_boolean] = ACTIONS(3342),
    [anon_sym_string] = ACTIONS(3342),
    [anon_sym_symbol] = ACTIONS(3342),
    [anon_sym_object] = ACTIONS(3342),
    [anon_sym_abstract] = ACTIONS(3342),
    [anon_sym_interface] = ACTIONS(3342),
    [anon_sym_enum] = ACTIONS(3342),
    [sym_html_comment] = ACTIONS(5),
  },
  [1512] = {
    [sym_comment] = STATE(1512),
    [ts_builtin_sym_end] = ACTIONS(3524),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_export] = ACTIONS(3308),
    [anon_sym_type] = ACTIONS(3308),
    [anon_sym_namespace] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_RBRACE] = ACTIONS(3308),
    [anon_sym_typeof] = ACTIONS(3308),
    [anon_sym_import] = ACTIONS(3308),
    [anon_sym_with] = ACTIONS(3308),
    [anon_sym_var] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3308),
    [anon_sym_switch] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3308),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_await] = ACTIONS(3308),
    [anon_sym_while] = ACTIONS(3308),
    [anon_sym_do] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3308),
    [anon_sym_break] = ACTIONS(3308),
    [anon_sym_continue] = ACTIONS(3308),
    [anon_sym_debugger] = ACTIONS(3308),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_throw] = ACTIONS(3308),
    [anon_sym_SEMI] = ACTIONS(3308),
    [anon_sym_yield] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [anon_sym_LTtemplate_GT] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_class] = ACTIONS(3308),
    [anon_sym_async] = ACTIONS(3308),
    [anon_sym_function] = ACTIONS(3308),
    [anon_sym_new] = ACTIONS(3308),
    [anon_sym_using] = ACTIONS(3308),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_void] = ACTIONS(3308),
    [anon_sym_delete] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3308),
    [sym_number] = ACTIONS(3308),
    [sym_private_property_identifier] = ACTIONS(3308),
    [sym_this] = ACTIONS(3308),
    [sym_super] = ACTIONS(3308),
    [sym_true] = ACTIONS(3308),
    [sym_false] = ACTIONS(3308),
    [sym_null] = ACTIONS(3308),
    [sym_undefined] = ACTIONS(3308),
    [anon_sym_AT] = ACTIONS(3308),
    [anon_sym_static] = ACTIONS(3308),
    [anon_sym_readonly] = ACTIONS(3308),
    [anon_sym_get] = ACTIONS(3308),
    [anon_sym_set] = ACTIONS(3308),
    [anon_sym_declare] = ACTIONS(3308),
    [anon_sym_public] = ACTIONS(3308),
    [anon_sym_private] = ACTIONS(3308),
    [anon_sym_protected] = ACTIONS(3308),
    [anon_sym_override] = ACTIONS(3308),
    [anon_sym_module] = ACTIONS(3308),
    [anon_sym_any] = ACTIONS(3308),
    [anon_sym_number] = ACTIONS(3308),
    [anon_sym_boolean] = ACTIONS(3308),
    [anon_sym_string] = ACTIONS(3308),
    [anon_sym_symbol] = ACTIONS(3308),
    [anon_sym_object] = ACTIONS(3308),
    [anon_sym_abstract] = ACTIONS(3308),
    [anon_sym_interface] = ACTIONS(3308),
    [anon_sym_enum] = ACTIONS(3308),
    [sym_html_comment] = ACTIONS(5),
  },
  [1513] = {
    [sym_comment] = STATE(1513),
    [ts_builtin_sym_end] = ACTIONS(3394),
    [sym_identifier] = ACTIONS(3172),
    [anon_sym_export] = ACTIONS(3172),
    [anon_sym_type] = ACTIONS(3172),
    [anon_sym_namespace] = ACTIONS(3172),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_typeof] = ACTIONS(3172),
    [anon_sym_import] = ACTIONS(3172),
    [anon_sym_with] = ACTIONS(3172),
    [anon_sym_var] = ACTIONS(3172),
    [anon_sym_let] = ACTIONS(3172),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_if] = ACTIONS(3172),
    [anon_sym_switch] = ACTIONS(3172),
    [anon_sym_for] = ACTIONS(3172),
    [anon_sym_LPAREN] = ACTIONS(3172),
    [anon_sym_await] = ACTIONS(3172),
    [anon_sym_while] = ACTIONS(3172),
    [anon_sym_do] = ACTIONS(3172),
    [anon_sym_try] = ACTIONS(3172),
    [anon_sym_break] = ACTIONS(3172),
    [anon_sym_continue] = ACTIONS(3172),
    [anon_sym_debugger] = ACTIONS(3172),
    [anon_sym_return] = ACTIONS(3172),
    [anon_sym_throw] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_yield] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_LTtemplate_GT] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_class] = ACTIONS(3172),
    [anon_sym_async] = ACTIONS(3172),
    [anon_sym_function] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3172),
    [anon_sym_using] = ACTIONS(3172),
    [anon_sym_PLUS] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3172),
    [anon_sym_SLASH] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_void] = ACTIONS(3172),
    [anon_sym_delete] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3172),
    [sym_number] = ACTIONS(3172),
    [sym_private_property_identifier] = ACTIONS(3172),
    [sym_this] = ACTIONS(3172),
    [sym_super] = ACTIONS(3172),
    [sym_true] = ACTIONS(3172),
    [sym_false] = ACTIONS(3172),
    [sym_null] = ACTIONS(3172),
    [sym_undefined] = ACTIONS(3172),
    [anon_sym_AT] = ACTIONS(3172),
    [anon_sym_static] = ACTIONS(3172),
    [anon_sym_readonly] = ACTIONS(3172),
    [anon_sym_get] = ACTIONS(3172),
    [anon_sym_set] = ACTIONS(3172),
    [anon_sym_declare] = ACTIONS(3172),
    [anon_sym_public] = ACTIONS(3172),
    [anon_sym_private] = ACTIONS(3172),
    [anon_sym_protected] = ACTIONS(3172),
    [anon_sym_override] = ACTIONS(3172),
    [anon_sym_module] = ACTIONS(3172),
    [anon_sym_any] = ACTIONS(3172),
    [anon_sym_number] = ACTIONS(3172),
    [anon_sym_boolean] = ACTIONS(3172),
    [anon_sym_string] = ACTIONS(3172),
    [anon_sym_symbol] = ACTIONS(3172),
    [anon_sym_object] = ACTIONS(3172),
    [anon_sym_abstract] = ACTIONS(3172),
    [anon_sym_interface] = ACTIONS(3172),
    [anon_sym_enum] = ACTIONS(3172),
    [sym_html_comment] = ACTIONS(5),
  },
  [1514] = {
    [sym_comment] = STATE(1514),
    [ts_builtin_sym_end] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3302),
    [anon_sym_export] = ACTIONS(3302),
    [anon_sym_type] = ACTIONS(3302),
    [anon_sym_namespace] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3302),
    [anon_sym_RBRACE] = ACTIONS(3302),
    [anon_sym_typeof] = ACTIONS(3302),
    [anon_sym_import] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3302),
    [anon_sym_var] = ACTIONS(3302),
    [anon_sym_let] = ACTIONS(3302),
    [anon_sym_const] = ACTIONS(3302),
    [anon_sym_BANG] = ACTIONS(3302),
    [anon_sym_if] = ACTIONS(3302),
    [anon_sym_switch] = ACTIONS(3302),
    [anon_sym_for] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3302),
    [anon_sym_await] = ACTIONS(3302),
    [anon_sym_while] = ACTIONS(3302),
    [anon_sym_do] = ACTIONS(3302),
    [anon_sym_try] = ACTIONS(3302),
    [anon_sym_break] = ACTIONS(3302),
    [anon_sym_continue] = ACTIONS(3302),
    [anon_sym_debugger] = ACTIONS(3302),
    [anon_sym_return] = ACTIONS(3302),
    [anon_sym_throw] = ACTIONS(3302),
    [anon_sym_SEMI] = ACTIONS(3302),
    [anon_sym_yield] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_LTtemplate_GT] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(3302),
    [anon_sym_SQUOTE] = ACTIONS(3302),
    [anon_sym_class] = ACTIONS(3302),
    [anon_sym_async] = ACTIONS(3302),
    [anon_sym_function] = ACTIONS(3302),
    [anon_sym_new] = ACTIONS(3302),
    [anon_sym_using] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_TILDE] = ACTIONS(3302),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_delete] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3302),
    [sym_number] = ACTIONS(3302),
    [sym_private_property_identifier] = ACTIONS(3302),
    [sym_this] = ACTIONS(3302),
    [sym_super] = ACTIONS(3302),
    [sym_true] = ACTIONS(3302),
    [sym_false] = ACTIONS(3302),
    [sym_null] = ACTIONS(3302),
    [sym_undefined] = ACTIONS(3302),
    [anon_sym_AT] = ACTIONS(3302),
    [anon_sym_static] = ACTIONS(3302),
    [anon_sym_readonly] = ACTIONS(3302),
    [anon_sym_get] = ACTIONS(3302),
    [anon_sym_set] = ACTIONS(3302),
    [anon_sym_declare] = ACTIONS(3302),
    [anon_sym_public] = ACTIONS(3302),
    [anon_sym_private] = ACTIONS(3302),
    [anon_sym_protected] = ACTIONS(3302),
    [anon_sym_override] = ACTIONS(3302),
    [anon_sym_module] = ACTIONS(3302),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_object] = ACTIONS(3302),
    [anon_sym_abstract] = ACTIONS(3302),
    [anon_sym_interface] = ACTIONS(3302),
    [anon_sym_enum] = ACTIONS(3302),
    [sym_html_comment] = ACTIONS(5),
  },
  [1515] = {
    [sym_comment] = STATE(1515),
    [ts_builtin_sym_end] = ACTIONS(3410),
    [sym_identifier] = ACTIONS(3252),
    [anon_sym_export] = ACTIONS(3252),
    [anon_sym_type] = ACTIONS(3252),
    [anon_sym_namespace] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_typeof] = ACTIONS(3252),
    [anon_sym_import] = ACTIONS(3252),
    [anon_sym_with] = ACTIONS(3252),
    [anon_sym_var] = ACTIONS(3252),
    [anon_sym_let] = ACTIONS(3252),
    [anon_sym_const] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_if] = ACTIONS(3252),
    [anon_sym_switch] = ACTIONS(3252),
    [anon_sym_for] = ACTIONS(3252),
    [anon_sym_LPAREN] = ACTIONS(3252),
    [anon_sym_await] = ACTIONS(3252),
    [anon_sym_while] = ACTIONS(3252),
    [anon_sym_do] = ACTIONS(3252),
    [anon_sym_try] = ACTIONS(3252),
    [anon_sym_break] = ACTIONS(3252),
    [anon_sym_continue] = ACTIONS(3252),
    [anon_sym_debugger] = ACTIONS(3252),
    [anon_sym_return] = ACTIONS(3252),
    [anon_sym_throw] = ACTIONS(3252),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym_yield] = ACTIONS(3252),
    [anon_sym_LBRACK] = ACTIONS(3252),
    [anon_sym_LTtemplate_GT] = ACTIONS(3252),
    [anon_sym_DQUOTE] = ACTIONS(3252),
    [anon_sym_SQUOTE] = ACTIONS(3252),
    [anon_sym_class] = ACTIONS(3252),
    [anon_sym_async] = ACTIONS(3252),
    [anon_sym_function] = ACTIONS(3252),
    [anon_sym_new] = ACTIONS(3252),
    [anon_sym_using] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3252),
    [anon_sym_SLASH] = ACTIONS(3252),
    [anon_sym_LT] = ACTIONS(3252),
    [anon_sym_TILDE] = ACTIONS(3252),
    [anon_sym_void] = ACTIONS(3252),
    [anon_sym_delete] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3252),
    [anon_sym_DASH_DASH] = ACTIONS(3252),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3252),
    [sym_number] = ACTIONS(3252),
    [sym_private_property_identifier] = ACTIONS(3252),
    [sym_this] = ACTIONS(3252),
    [sym_super] = ACTIONS(3252),
    [sym_true] = ACTIONS(3252),
    [sym_false] = ACTIONS(3252),
    [sym_null] = ACTIONS(3252),
    [sym_undefined] = ACTIONS(3252),
    [anon_sym_AT] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3252),
    [anon_sym_readonly] = ACTIONS(3252),
    [anon_sym_get] = ACTIONS(3252),
    [anon_sym_set] = ACTIONS(3252),
    [anon_sym_declare] = ACTIONS(3252),
    [anon_sym_public] = ACTIONS(3252),
    [anon_sym_private] = ACTIONS(3252),
    [anon_sym_protected] = ACTIONS(3252),
    [anon_sym_override] = ACTIONS(3252),
    [anon_sym_module] = ACTIONS(3252),
    [anon_sym_any] = ACTIONS(3252),
    [anon_sym_number] = ACTIONS(3252),
    [anon_sym_boolean] = ACTIONS(3252),
    [anon_sym_string] = ACTIONS(3252),
    [anon_sym_symbol] = ACTIONS(3252),
    [anon_sym_object] = ACTIONS(3252),
    [anon_sym_abstract] = ACTIONS(3252),
    [anon_sym_interface] = ACTIONS(3252),
    [anon_sym_enum] = ACTIONS(3252),
    [sym_html_comment] = ACTIONS(5),
  },
  [1516] = {
    [sym_comment] = STATE(1516),
    [ts_builtin_sym_end] = ACTIONS(3572),
    [sym_identifier] = ACTIONS(3320),
    [anon_sym_export] = ACTIONS(3320),
    [anon_sym_type] = ACTIONS(3320),
    [anon_sym_namespace] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3320),
    [anon_sym_RBRACE] = ACTIONS(3320),
    [anon_sym_typeof] = ACTIONS(3320),
    [anon_sym_import] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3320),
    [anon_sym_var] = ACTIONS(3320),
    [anon_sym_let] = ACTIONS(3320),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_BANG] = ACTIONS(3320),
    [anon_sym_if] = ACTIONS(3320),
    [anon_sym_switch] = ACTIONS(3320),
    [anon_sym_for] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3320),
    [anon_sym_await] = ACTIONS(3320),
    [anon_sym_while] = ACTIONS(3320),
    [anon_sym_do] = ACTIONS(3320),
    [anon_sym_try] = ACTIONS(3320),
    [anon_sym_break] = ACTIONS(3320),
    [anon_sym_continue] = ACTIONS(3320),
    [anon_sym_debugger] = ACTIONS(3320),
    [anon_sym_return] = ACTIONS(3320),
    [anon_sym_throw] = ACTIONS(3320),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym_yield] = ACTIONS(3320),
    [anon_sym_LBRACK] = ACTIONS(3320),
    [anon_sym_LTtemplate_GT] = ACTIONS(3320),
    [anon_sym_DQUOTE] = ACTIONS(3320),
    [anon_sym_SQUOTE] = ACTIONS(3320),
    [anon_sym_class] = ACTIONS(3320),
    [anon_sym_async] = ACTIONS(3320),
    [anon_sym_function] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(3320),
    [anon_sym_using] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3320),
    [anon_sym_DASH] = ACTIONS(3320),
    [anon_sym_SLASH] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3320),
    [anon_sym_TILDE] = ACTIONS(3320),
    [anon_sym_void] = ACTIONS(3320),
    [anon_sym_delete] = ACTIONS(3320),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3320),
    [sym_number] = ACTIONS(3320),
    [sym_private_property_identifier] = ACTIONS(3320),
    [sym_this] = ACTIONS(3320),
    [sym_super] = ACTIONS(3320),
    [sym_true] = ACTIONS(3320),
    [sym_false] = ACTIONS(3320),
    [sym_null] = ACTIONS(3320),
    [sym_undefined] = ACTIONS(3320),
    [anon_sym_AT] = ACTIONS(3320),
    [anon_sym_static] = ACTIONS(3320),
    [anon_sym_readonly] = ACTIONS(3320),
    [anon_sym_get] = ACTIONS(3320),
    [anon_sym_set] = ACTIONS(3320),
    [anon_sym_declare] = ACTIONS(3320),
    [anon_sym_public] = ACTIONS(3320),
    [anon_sym_private] = ACTIONS(3320),
    [anon_sym_protected] = ACTIONS(3320),
    [anon_sym_override] = ACTIONS(3320),
    [anon_sym_module] = ACTIONS(3320),
    [anon_sym_any] = ACTIONS(3320),
    [anon_sym_number] = ACTIONS(3320),
    [anon_sym_boolean] = ACTIONS(3320),
    [anon_sym_string] = ACTIONS(3320),
    [anon_sym_symbol] = ACTIONS(3320),
    [anon_sym_object] = ACTIONS(3320),
    [anon_sym_abstract] = ACTIONS(3320),
    [anon_sym_interface] = ACTIONS(3320),
    [anon_sym_enum] = ACTIONS(3320),
    [sym_html_comment] = ACTIONS(5),
  },
  [1517] = {
    [sym_comment] = STATE(1517),
    [ts_builtin_sym_end] = ACTIONS(3490),
    [sym_identifier] = ACTIONS(3298),
    [anon_sym_export] = ACTIONS(3298),
    [anon_sym_type] = ACTIONS(3298),
    [anon_sym_namespace] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3298),
    [anon_sym_RBRACE] = ACTIONS(3298),
    [anon_sym_typeof] = ACTIONS(3298),
    [anon_sym_import] = ACTIONS(3298),
    [anon_sym_with] = ACTIONS(3298),
    [anon_sym_var] = ACTIONS(3298),
    [anon_sym_let] = ACTIONS(3298),
    [anon_sym_const] = ACTIONS(3298),
    [anon_sym_BANG] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(3298),
    [anon_sym_switch] = ACTIONS(3298),
    [anon_sym_for] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3298),
    [anon_sym_await] = ACTIONS(3298),
    [anon_sym_while] = ACTIONS(3298),
    [anon_sym_do] = ACTIONS(3298),
    [anon_sym_try] = ACTIONS(3298),
    [anon_sym_break] = ACTIONS(3298),
    [anon_sym_continue] = ACTIONS(3298),
    [anon_sym_debugger] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(3298),
    [anon_sym_throw] = ACTIONS(3298),
    [anon_sym_SEMI] = ACTIONS(3298),
    [anon_sym_yield] = ACTIONS(3298),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LTtemplate_GT] = ACTIONS(3298),
    [anon_sym_DQUOTE] = ACTIONS(3298),
    [anon_sym_SQUOTE] = ACTIONS(3298),
    [anon_sym_class] = ACTIONS(3298),
    [anon_sym_async] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3298),
    [anon_sym_new] = ACTIONS(3298),
    [anon_sym_using] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3298),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_SLASH] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3298),
    [anon_sym_void] = ACTIONS(3298),
    [anon_sym_delete] = ACTIONS(3298),
    [anon_sym_PLUS_PLUS] = ACTIONS(3298),
    [anon_sym_DASH_DASH] = ACTIONS(3298),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3298),
    [sym_number] = ACTIONS(3298),
    [sym_private_property_identifier] = ACTIONS(3298),
    [sym_this] = ACTIONS(3298),
    [sym_super] = ACTIONS(3298),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [sym_null] = ACTIONS(3298),
    [sym_undefined] = ACTIONS(3298),
    [anon_sym_AT] = ACTIONS(3298),
    [anon_sym_static] = ACTIONS(3298),
    [anon_sym_readonly] = ACTIONS(3298),
    [anon_sym_get] = ACTIONS(3298),
    [anon_sym_set] = ACTIONS(3298),
    [anon_sym_declare] = ACTIONS(3298),
    [anon_sym_public] = ACTIONS(3298),
    [anon_sym_private] = ACTIONS(3298),
    [anon_sym_protected] = ACTIONS(3298),
    [anon_sym_override] = ACTIONS(3298),
    [anon_sym_module] = ACTIONS(3298),
    [anon_sym_any] = ACTIONS(3298),
    [anon_sym_number] = ACTIONS(3298),
    [anon_sym_boolean] = ACTIONS(3298),
    [anon_sym_string] = ACTIONS(3298),
    [anon_sym_symbol] = ACTIONS(3298),
    [anon_sym_object] = ACTIONS(3298),
    [anon_sym_abstract] = ACTIONS(3298),
    [anon_sym_interface] = ACTIONS(3298),
    [anon_sym_enum] = ACTIONS(3298),
    [sym_html_comment] = ACTIONS(5),
  },
  [1518] = {
    [sym_comment] = STATE(1518),
    [ts_builtin_sym_end] = ACTIONS(3376),
    [sym_identifier] = ACTIONS(3366),
    [anon_sym_export] = ACTIONS(3366),
    [anon_sym_type] = ACTIONS(3366),
    [anon_sym_namespace] = ACTIONS(3366),
    [anon_sym_LBRACE] = ACTIONS(3366),
    [anon_sym_RBRACE] = ACTIONS(3366),
    [anon_sym_typeof] = ACTIONS(3366),
    [anon_sym_import] = ACTIONS(3366),
    [anon_sym_with] = ACTIONS(3366),
    [anon_sym_var] = ACTIONS(3366),
    [anon_sym_let] = ACTIONS(3366),
    [anon_sym_const] = ACTIONS(3366),
    [anon_sym_BANG] = ACTIONS(3366),
    [anon_sym_if] = ACTIONS(3366),
    [anon_sym_switch] = ACTIONS(3366),
    [anon_sym_for] = ACTIONS(3366),
    [anon_sym_LPAREN] = ACTIONS(3366),
    [anon_sym_await] = ACTIONS(3366),
    [anon_sym_while] = ACTIONS(3366),
    [anon_sym_do] = ACTIONS(3366),
    [anon_sym_try] = ACTIONS(3366),
    [anon_sym_break] = ACTIONS(3366),
    [anon_sym_continue] = ACTIONS(3366),
    [anon_sym_debugger] = ACTIONS(3366),
    [anon_sym_return] = ACTIONS(3366),
    [anon_sym_throw] = ACTIONS(3366),
    [anon_sym_SEMI] = ACTIONS(3366),
    [anon_sym_yield] = ACTIONS(3366),
    [anon_sym_LBRACK] = ACTIONS(3366),
    [anon_sym_LTtemplate_GT] = ACTIONS(3366),
    [anon_sym_DQUOTE] = ACTIONS(3366),
    [anon_sym_SQUOTE] = ACTIONS(3366),
    [anon_sym_class] = ACTIONS(3366),
    [anon_sym_async] = ACTIONS(3366),
    [anon_sym_function] = ACTIONS(3366),
    [anon_sym_new] = ACTIONS(3366),
    [anon_sym_using] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [anon_sym_SLASH] = ACTIONS(3366),
    [anon_sym_LT] = ACTIONS(3366),
    [anon_sym_TILDE] = ACTIONS(3366),
    [anon_sym_void] = ACTIONS(3366),
    [anon_sym_delete] = ACTIONS(3366),
    [anon_sym_PLUS_PLUS] = ACTIONS(3366),
    [anon_sym_DASH_DASH] = ACTIONS(3366),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3366),
    [sym_number] = ACTIONS(3366),
    [sym_private_property_identifier] = ACTIONS(3366),
    [sym_this] = ACTIONS(3366),
    [sym_super] = ACTIONS(3366),
    [sym_true] = ACTIONS(3366),
    [sym_false] = ACTIONS(3366),
    [sym_null] = ACTIONS(3366),
    [sym_undefined] = ACTIONS(3366),
    [anon_sym_AT] = ACTIONS(3366),
    [anon_sym_static] = ACTIONS(3366),
    [anon_sym_readonly] = ACTIONS(3366),
    [anon_sym_get] = ACTIONS(3366),
    [anon_sym_set] = ACTIONS(3366),
    [anon_sym_declare] = ACTIONS(3366),
    [anon_sym_public] = ACTIONS(3366),
    [anon_sym_private] = ACTIONS(3366),
    [anon_sym_protected] = ACTIONS(3366),
    [anon_sym_override] = ACTIONS(3366),
    [anon_sym_module] = ACTIONS(3366),
    [anon_sym_any] = ACTIONS(3366),
    [anon_sym_number] = ACTIONS(3366),
    [anon_sym_boolean] = ACTIONS(3366),
    [anon_sym_string] = ACTIONS(3366),
    [anon_sym_symbol] = ACTIONS(3366),
    [anon_sym_object] = ACTIONS(3366),
    [anon_sym_abstract] = ACTIONS(3366),
    [anon_sym_interface] = ACTIONS(3366),
    [anon_sym_enum] = ACTIONS(3366),
    [sym_html_comment] = ACTIONS(5),
  },
  [1519] = {
    [sym_comment] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(3550),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_export] = ACTIONS(3340),
    [anon_sym_type] = ACTIONS(3340),
    [anon_sym_namespace] = ACTIONS(3340),
    [anon_sym_LBRACE] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3340),
    [anon_sym_typeof] = ACTIONS(3340),
    [anon_sym_import] = ACTIONS(3340),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_var] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_const] = ACTIONS(3340),
    [anon_sym_BANG] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3340),
    [anon_sym_for] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3340),
    [anon_sym_await] = ACTIONS(3340),
    [anon_sym_while] = ACTIONS(3340),
    [anon_sym_do] = ACTIONS(3340),
    [anon_sym_try] = ACTIONS(3340),
    [anon_sym_break] = ACTIONS(3340),
    [anon_sym_continue] = ACTIONS(3340),
    [anon_sym_debugger] = ACTIONS(3340),
    [anon_sym_return] = ACTIONS(3340),
    [anon_sym_throw] = ACTIONS(3340),
    [anon_sym_SEMI] = ACTIONS(3340),
    [anon_sym_yield] = ACTIONS(3340),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_LTtemplate_GT] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(3340),
    [anon_sym_SQUOTE] = ACTIONS(3340),
    [anon_sym_class] = ACTIONS(3340),
    [anon_sym_async] = ACTIONS(3340),
    [anon_sym_function] = ACTIONS(3340),
    [anon_sym_new] = ACTIONS(3340),
    [anon_sym_using] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3340),
    [anon_sym_DASH] = ACTIONS(3340),
    [anon_sym_SLASH] = ACTIONS(3340),
    [anon_sym_LT] = ACTIONS(3340),
    [anon_sym_TILDE] = ACTIONS(3340),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_delete] = ACTIONS(3340),
    [anon_sym_PLUS_PLUS] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3340),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3340),
    [sym_number] = ACTIONS(3340),
    [sym_private_property_identifier] = ACTIONS(3340),
    [sym_this] = ACTIONS(3340),
    [sym_super] = ACTIONS(3340),
    [sym_true] = ACTIONS(3340),
    [sym_false] = ACTIONS(3340),
    [sym_null] = ACTIONS(3340),
    [sym_undefined] = ACTIONS(3340),
    [anon_sym_AT] = ACTIONS(3340),
    [anon_sym_static] = ACTIONS(3340),
    [anon_sym_readonly] = ACTIONS(3340),
    [anon_sym_get] = ACTIONS(3340),
    [anon_sym_set] = ACTIONS(3340),
    [anon_sym_declare] = ACTIONS(3340),
    [anon_sym_public] = ACTIONS(3340),
    [anon_sym_private] = ACTIONS(3340),
    [anon_sym_protected] = ACTIONS(3340),
    [anon_sym_override] = ACTIONS(3340),
    [anon_sym_module] = ACTIONS(3340),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_object] = ACTIONS(3340),
    [anon_sym_abstract] = ACTIONS(3340),
    [anon_sym_interface] = ACTIONS(3340),
    [anon_sym_enum] = ACTIONS(3340),
    [sym_html_comment] = ACTIONS(5),
  },
  [1520] = {
    [sym_comment] = STATE(1520),
    [ts_builtin_sym_end] = ACTIONS(2177),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(2175),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_namespace] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2175),
    [anon_sym_import] = ACTIONS(2175),
    [anon_sym_with] = ACTIONS(2175),
    [anon_sym_var] = ACTIONS(2175),
    [anon_sym_let] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_switch] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_await] = ACTIONS(2175),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_do] = ACTIONS(2175),
    [anon_sym_try] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_debugger] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [anon_sym_LTtemplate_GT] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2175),
    [anon_sym_class] = ACTIONS(2175),
    [anon_sym_async] = ACTIONS(2175),
    [anon_sym_function] = ACTIONS(2175),
    [anon_sym_new] = ACTIONS(2175),
    [anon_sym_using] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_LT] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_void] = ACTIONS(2175),
    [anon_sym_delete] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [sym_number] = ACTIONS(2175),
    [sym_private_property_identifier] = ACTIONS(2175),
    [sym_this] = ACTIONS(2175),
    [sym_super] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2175),
    [anon_sym_static] = ACTIONS(2175),
    [anon_sym_readonly] = ACTIONS(2175),
    [anon_sym_get] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(2175),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_public] = ACTIONS(2175),
    [anon_sym_private] = ACTIONS(2175),
    [anon_sym_protected] = ACTIONS(2175),
    [anon_sym_override] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2175),
    [anon_sym_any] = ACTIONS(2175),
    [anon_sym_number] = ACTIONS(2175),
    [anon_sym_boolean] = ACTIONS(2175),
    [anon_sym_string] = ACTIONS(2175),
    [anon_sym_symbol] = ACTIONS(2175),
    [anon_sym_object] = ACTIONS(2175),
    [anon_sym_abstract] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [sym_html_comment] = ACTIONS(5),
  },
  [1521] = {
    [sym_comment] = STATE(1521),
    [ts_builtin_sym_end] = ACTIONS(3386),
    [sym_identifier] = ACTIONS(3358),
    [anon_sym_export] = ACTIONS(3358),
    [anon_sym_type] = ACTIONS(3358),
    [anon_sym_namespace] = ACTIONS(3358),
    [anon_sym_LBRACE] = ACTIONS(3358),
    [anon_sym_RBRACE] = ACTIONS(3358),
    [anon_sym_typeof] = ACTIONS(3358),
    [anon_sym_import] = ACTIONS(3358),
    [anon_sym_with] = ACTIONS(3358),
    [anon_sym_var] = ACTIONS(3358),
    [anon_sym_let] = ACTIONS(3358),
    [anon_sym_const] = ACTIONS(3358),
    [anon_sym_BANG] = ACTIONS(3358),
    [anon_sym_if] = ACTIONS(3358),
    [anon_sym_switch] = ACTIONS(3358),
    [anon_sym_for] = ACTIONS(3358),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_await] = ACTIONS(3358),
    [anon_sym_while] = ACTIONS(3358),
    [anon_sym_do] = ACTIONS(3358),
    [anon_sym_try] = ACTIONS(3358),
    [anon_sym_break] = ACTIONS(3358),
    [anon_sym_continue] = ACTIONS(3358),
    [anon_sym_debugger] = ACTIONS(3358),
    [anon_sym_return] = ACTIONS(3358),
    [anon_sym_throw] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_yield] = ACTIONS(3358),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_LTtemplate_GT] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(3358),
    [anon_sym_class] = ACTIONS(3358),
    [anon_sym_async] = ACTIONS(3358),
    [anon_sym_function] = ACTIONS(3358),
    [anon_sym_new] = ACTIONS(3358),
    [anon_sym_using] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3358),
    [anon_sym_DASH] = ACTIONS(3358),
    [anon_sym_SLASH] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_TILDE] = ACTIONS(3358),
    [anon_sym_void] = ACTIONS(3358),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_number] = ACTIONS(3358),
    [sym_private_property_identifier] = ACTIONS(3358),
    [sym_this] = ACTIONS(3358),
    [sym_super] = ACTIONS(3358),
    [sym_true] = ACTIONS(3358),
    [sym_false] = ACTIONS(3358),
    [sym_null] = ACTIONS(3358),
    [sym_undefined] = ACTIONS(3358),
    [anon_sym_AT] = ACTIONS(3358),
    [anon_sym_static] = ACTIONS(3358),
    [anon_sym_readonly] = ACTIONS(3358),
    [anon_sym_get] = ACTIONS(3358),
    [anon_sym_set] = ACTIONS(3358),
    [anon_sym_declare] = ACTIONS(3358),
    [anon_sym_public] = ACTIONS(3358),
    [anon_sym_private] = ACTIONS(3358),
    [anon_sym_protected] = ACTIONS(3358),
    [anon_sym_override] = ACTIONS(3358),
    [anon_sym_module] = ACTIONS(3358),
    [anon_sym_any] = ACTIONS(3358),
    [anon_sym_number] = ACTIONS(3358),
    [anon_sym_boolean] = ACTIONS(3358),
    [anon_sym_string] = ACTIONS(3358),
    [anon_sym_symbol] = ACTIONS(3358),
    [anon_sym_object] = ACTIONS(3358),
    [anon_sym_abstract] = ACTIONS(3358),
    [anon_sym_interface] = ACTIONS(3358),
    [anon_sym_enum] = ACTIONS(3358),
    [sym_html_comment] = ACTIONS(5),
  },
  [1522] = {
    [sym_comment] = STATE(1522),
    [ts_builtin_sym_end] = ACTIONS(3466),
    [sym_identifier] = ACTIONS(3144),
    [anon_sym_export] = ACTIONS(3144),
    [anon_sym_type] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_RBRACE] = ACTIONS(3144),
    [anon_sym_typeof] = ACTIONS(3144),
    [anon_sym_import] = ACTIONS(3144),
    [anon_sym_with] = ACTIONS(3144),
    [anon_sym_var] = ACTIONS(3144),
    [anon_sym_let] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3144),
    [anon_sym_await] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_debugger] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym_yield] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_LTtemplate_GT] = ACTIONS(3144),
    [anon_sym_DQUOTE] = ACTIONS(3144),
    [anon_sym_SQUOTE] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_async] = ACTIONS(3144),
    [anon_sym_function] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_SLASH] = ACTIONS(3144),
    [anon_sym_LT] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_void] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3144),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3144),
    [sym_number] = ACTIONS(3144),
    [sym_private_property_identifier] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
    [sym_super] = ACTIONS(3144),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [sym_null] = ACTIONS(3144),
    [sym_undefined] = ACTIONS(3144),
    [anon_sym_AT] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_readonly] = ACTIONS(3144),
    [anon_sym_get] = ACTIONS(3144),
    [anon_sym_set] = ACTIONS(3144),
    [anon_sym_declare] = ACTIONS(3144),
    [anon_sym_public] = ACTIONS(3144),
    [anon_sym_private] = ACTIONS(3144),
    [anon_sym_protected] = ACTIONS(3144),
    [anon_sym_override] = ACTIONS(3144),
    [anon_sym_module] = ACTIONS(3144),
    [anon_sym_any] = ACTIONS(3144),
    [anon_sym_number] = ACTIONS(3144),
    [anon_sym_boolean] = ACTIONS(3144),
    [anon_sym_string] = ACTIONS(3144),
    [anon_sym_symbol] = ACTIONS(3144),
    [anon_sym_object] = ACTIONS(3144),
    [anon_sym_abstract] = ACTIONS(3144),
    [anon_sym_interface] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [sym_html_comment] = ACTIONS(5),
  },
  [1523] = {
    [sym_comment] = STATE(1523),
    [ts_builtin_sym_end] = ACTIONS(3546),
    [sym_identifier] = ACTIONS(3338),
    [anon_sym_export] = ACTIONS(3338),
    [anon_sym_type] = ACTIONS(3338),
    [anon_sym_namespace] = ACTIONS(3338),
    [anon_sym_LBRACE] = ACTIONS(3338),
    [anon_sym_RBRACE] = ACTIONS(3338),
    [anon_sym_typeof] = ACTIONS(3338),
    [anon_sym_import] = ACTIONS(3338),
    [anon_sym_with] = ACTIONS(3338),
    [anon_sym_var] = ACTIONS(3338),
    [anon_sym_let] = ACTIONS(3338),
    [anon_sym_const] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_if] = ACTIONS(3338),
    [anon_sym_switch] = ACTIONS(3338),
    [anon_sym_for] = ACTIONS(3338),
    [anon_sym_LPAREN] = ACTIONS(3338),
    [anon_sym_await] = ACTIONS(3338),
    [anon_sym_while] = ACTIONS(3338),
    [anon_sym_do] = ACTIONS(3338),
    [anon_sym_try] = ACTIONS(3338),
    [anon_sym_break] = ACTIONS(3338),
    [anon_sym_continue] = ACTIONS(3338),
    [anon_sym_debugger] = ACTIONS(3338),
    [anon_sym_return] = ACTIONS(3338),
    [anon_sym_throw] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym_yield] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3338),
    [anon_sym_LTtemplate_GT] = ACTIONS(3338),
    [anon_sym_DQUOTE] = ACTIONS(3338),
    [anon_sym_SQUOTE] = ACTIONS(3338),
    [anon_sym_class] = ACTIONS(3338),
    [anon_sym_async] = ACTIONS(3338),
    [anon_sym_function] = ACTIONS(3338),
    [anon_sym_new] = ACTIONS(3338),
    [anon_sym_using] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_TILDE] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3338),
    [anon_sym_delete] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3338),
    [anon_sym_DASH_DASH] = ACTIONS(3338),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3338),
    [sym_number] = ACTIONS(3338),
    [sym_private_property_identifier] = ACTIONS(3338),
    [sym_this] = ACTIONS(3338),
    [sym_super] = ACTIONS(3338),
    [sym_true] = ACTIONS(3338),
    [sym_false] = ACTIONS(3338),
    [sym_null] = ACTIONS(3338),
    [sym_undefined] = ACTIONS(3338),
    [anon_sym_AT] = ACTIONS(3338),
    [anon_sym_static] = ACTIONS(3338),
    [anon_sym_readonly] = ACTIONS(3338),
    [anon_sym_get] = ACTIONS(3338),
    [anon_sym_set] = ACTIONS(3338),
    [anon_sym_declare] = ACTIONS(3338),
    [anon_sym_public] = ACTIONS(3338),
    [anon_sym_private] = ACTIONS(3338),
    [anon_sym_protected] = ACTIONS(3338),
    [anon_sym_override] = ACTIONS(3338),
    [anon_sym_module] = ACTIONS(3338),
    [anon_sym_any] = ACTIONS(3338),
    [anon_sym_number] = ACTIONS(3338),
    [anon_sym_boolean] = ACTIONS(3338),
    [anon_sym_string] = ACTIONS(3338),
    [anon_sym_symbol] = ACTIONS(3338),
    [anon_sym_object] = ACTIONS(3338),
    [anon_sym_abstract] = ACTIONS(3338),
    [anon_sym_interface] = ACTIONS(3338),
    [anon_sym_enum] = ACTIONS(3338),
    [sym_html_comment] = ACTIONS(5),
  },
  [1524] = {
    [sym_comment] = STATE(1524),
    [ts_builtin_sym_end] = ACTIONS(3488),
    [sym_identifier] = ACTIONS(3296),
    [anon_sym_export] = ACTIONS(3296),
    [anon_sym_type] = ACTIONS(3296),
    [anon_sym_namespace] = ACTIONS(3296),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(3296),
    [anon_sym_import] = ACTIONS(3296),
    [anon_sym_with] = ACTIONS(3296),
    [anon_sym_var] = ACTIONS(3296),
    [anon_sym_let] = ACTIONS(3296),
    [anon_sym_const] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(3296),
    [anon_sym_if] = ACTIONS(3296),
    [anon_sym_switch] = ACTIONS(3296),
    [anon_sym_for] = ACTIONS(3296),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_await] = ACTIONS(3296),
    [anon_sym_while] = ACTIONS(3296),
    [anon_sym_do] = ACTIONS(3296),
    [anon_sym_try] = ACTIONS(3296),
    [anon_sym_break] = ACTIONS(3296),
    [anon_sym_continue] = ACTIONS(3296),
    [anon_sym_debugger] = ACTIONS(3296),
    [anon_sym_return] = ACTIONS(3296),
    [anon_sym_throw] = ACTIONS(3296),
    [anon_sym_SEMI] = ACTIONS(3296),
    [anon_sym_yield] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LTtemplate_GT] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [anon_sym_class] = ACTIONS(3296),
    [anon_sym_async] = ACTIONS(3296),
    [anon_sym_function] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3296),
    [anon_sym_using] = ACTIONS(3296),
    [anon_sym_PLUS] = ACTIONS(3296),
    [anon_sym_DASH] = ACTIONS(3296),
    [anon_sym_SLASH] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_TILDE] = ACTIONS(3296),
    [anon_sym_void] = ACTIONS(3296),
    [anon_sym_delete] = ACTIONS(3296),
    [anon_sym_PLUS_PLUS] = ACTIONS(3296),
    [anon_sym_DASH_DASH] = ACTIONS(3296),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3296),
    [sym_number] = ACTIONS(3296),
    [sym_private_property_identifier] = ACTIONS(3296),
    [sym_this] = ACTIONS(3296),
    [sym_super] = ACTIONS(3296),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_null] = ACTIONS(3296),
    [sym_undefined] = ACTIONS(3296),
    [anon_sym_AT] = ACTIONS(3296),
    [anon_sym_static] = ACTIONS(3296),
    [anon_sym_readonly] = ACTIONS(3296),
    [anon_sym_get] = ACTIONS(3296),
    [anon_sym_set] = ACTIONS(3296),
    [anon_sym_declare] = ACTIONS(3296),
    [anon_sym_public] = ACTIONS(3296),
    [anon_sym_private] = ACTIONS(3296),
    [anon_sym_protected] = ACTIONS(3296),
    [anon_sym_override] = ACTIONS(3296),
    [anon_sym_module] = ACTIONS(3296),
    [anon_sym_any] = ACTIONS(3296),
    [anon_sym_number] = ACTIONS(3296),
    [anon_sym_boolean] = ACTIONS(3296),
    [anon_sym_string] = ACTIONS(3296),
    [anon_sym_symbol] = ACTIONS(3296),
    [anon_sym_object] = ACTIONS(3296),
    [anon_sym_abstract] = ACTIONS(3296),
    [anon_sym_interface] = ACTIONS(3296),
    [anon_sym_enum] = ACTIONS(3296),
    [sym_html_comment] = ACTIONS(5),
  },
  [1525] = {
    [sym_comment] = STATE(1525),
    [ts_builtin_sym_end] = ACTIONS(3544),
    [sym_identifier] = ACTIONS(3142),
    [anon_sym_export] = ACTIONS(3142),
    [anon_sym_type] = ACTIONS(3142),
    [anon_sym_namespace] = ACTIONS(3142),
    [anon_sym_LBRACE] = ACTIONS(3142),
    [anon_sym_RBRACE] = ACTIONS(3142),
    [anon_sym_typeof] = ACTIONS(3142),
    [anon_sym_import] = ACTIONS(3142),
    [anon_sym_with] = ACTIONS(3142),
    [anon_sym_var] = ACTIONS(3142),
    [anon_sym_let] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_BANG] = ACTIONS(3142),
    [anon_sym_if] = ACTIONS(3142),
    [anon_sym_switch] = ACTIONS(3142),
    [anon_sym_for] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(3142),
    [anon_sym_await] = ACTIONS(3142),
    [anon_sym_while] = ACTIONS(3142),
    [anon_sym_do] = ACTIONS(3142),
    [anon_sym_try] = ACTIONS(3142),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3142),
    [anon_sym_debugger] = ACTIONS(3142),
    [anon_sym_return] = ACTIONS(3142),
    [anon_sym_throw] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3142),
    [anon_sym_yield] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_LTtemplate_GT] = ACTIONS(3142),
    [anon_sym_DQUOTE] = ACTIONS(3142),
    [anon_sym_SQUOTE] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_async] = ACTIONS(3142),
    [anon_sym_function] = ACTIONS(3142),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_using] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_SLASH] = ACTIONS(3142),
    [anon_sym_LT] = ACTIONS(3142),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_void] = ACTIONS(3142),
    [anon_sym_delete] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3142),
    [sym_number] = ACTIONS(3142),
    [sym_private_property_identifier] = ACTIONS(3142),
    [sym_this] = ACTIONS(3142),
    [sym_super] = ACTIONS(3142),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [sym_null] = ACTIONS(3142),
    [sym_undefined] = ACTIONS(3142),
    [anon_sym_AT] = ACTIONS(3142),
    [anon_sym_static] = ACTIONS(3142),
    [anon_sym_readonly] = ACTIONS(3142),
    [anon_sym_get] = ACTIONS(3142),
    [anon_sym_set] = ACTIONS(3142),
    [anon_sym_declare] = ACTIONS(3142),
    [anon_sym_public] = ACTIONS(3142),
    [anon_sym_private] = ACTIONS(3142),
    [anon_sym_protected] = ACTIONS(3142),
    [anon_sym_override] = ACTIONS(3142),
    [anon_sym_module] = ACTIONS(3142),
    [anon_sym_any] = ACTIONS(3142),
    [anon_sym_number] = ACTIONS(3142),
    [anon_sym_boolean] = ACTIONS(3142),
    [anon_sym_string] = ACTIONS(3142),
    [anon_sym_symbol] = ACTIONS(3142),
    [anon_sym_object] = ACTIONS(3142),
    [anon_sym_abstract] = ACTIONS(3142),
    [anon_sym_interface] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [sym_html_comment] = ACTIONS(5),
  },
  [1526] = {
    [sym_comment] = STATE(1526),
    [ts_builtin_sym_end] = ACTIONS(3514),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_export] = ACTIONS(3346),
    [anon_sym_type] = ACTIONS(3346),
    [anon_sym_namespace] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_typeof] = ACTIONS(3346),
    [anon_sym_import] = ACTIONS(3346),
    [anon_sym_with] = ACTIONS(3346),
    [anon_sym_var] = ACTIONS(3346),
    [anon_sym_let] = ACTIONS(3346),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3346),
    [anon_sym_if] = ACTIONS(3346),
    [anon_sym_switch] = ACTIONS(3346),
    [anon_sym_for] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_await] = ACTIONS(3346),
    [anon_sym_while] = ACTIONS(3346),
    [anon_sym_do] = ACTIONS(3346),
    [anon_sym_try] = ACTIONS(3346),
    [anon_sym_break] = ACTIONS(3346),
    [anon_sym_continue] = ACTIONS(3346),
    [anon_sym_debugger] = ACTIONS(3346),
    [anon_sym_return] = ACTIONS(3346),
    [anon_sym_throw] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_yield] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_LTtemplate_GT] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(3346),
    [anon_sym_SQUOTE] = ACTIONS(3346),
    [anon_sym_class] = ACTIONS(3346),
    [anon_sym_async] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(3346),
    [anon_sym_new] = ACTIONS(3346),
    [anon_sym_using] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3346),
    [anon_sym_DASH] = ACTIONS(3346),
    [anon_sym_SLASH] = ACTIONS(3346),
    [anon_sym_LT] = ACTIONS(3346),
    [anon_sym_TILDE] = ACTIONS(3346),
    [anon_sym_void] = ACTIONS(3346),
    [anon_sym_delete] = ACTIONS(3346),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3346),
    [sym_number] = ACTIONS(3346),
    [sym_private_property_identifier] = ACTIONS(3346),
    [sym_this] = ACTIONS(3346),
    [sym_super] = ACTIONS(3346),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [sym_null] = ACTIONS(3346),
    [sym_undefined] = ACTIONS(3346),
    [anon_sym_AT] = ACTIONS(3346),
    [anon_sym_static] = ACTIONS(3346),
    [anon_sym_readonly] = ACTIONS(3346),
    [anon_sym_get] = ACTIONS(3346),
    [anon_sym_set] = ACTIONS(3346),
    [anon_sym_declare] = ACTIONS(3346),
    [anon_sym_public] = ACTIONS(3346),
    [anon_sym_private] = ACTIONS(3346),
    [anon_sym_protected] = ACTIONS(3346),
    [anon_sym_override] = ACTIONS(3346),
    [anon_sym_module] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3346),
    [anon_sym_number] = ACTIONS(3346),
    [anon_sym_boolean] = ACTIONS(3346),
    [anon_sym_string] = ACTIONS(3346),
    [anon_sym_symbol] = ACTIONS(3346),
    [anon_sym_object] = ACTIONS(3346),
    [anon_sym_abstract] = ACTIONS(3346),
    [anon_sym_interface] = ACTIONS(3346),
    [anon_sym_enum] = ACTIONS(3346),
    [sym_html_comment] = ACTIONS(5),
  },
  [1527] = {
    [sym_comment] = STATE(1527),
    [ts_builtin_sym_end] = ACTIONS(3396),
    [sym_identifier] = ACTIONS(3174),
    [anon_sym_export] = ACTIONS(3174),
    [anon_sym_type] = ACTIONS(3174),
    [anon_sym_namespace] = ACTIONS(3174),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(3174),
    [anon_sym_typeof] = ACTIONS(3174),
    [anon_sym_import] = ACTIONS(3174),
    [anon_sym_with] = ACTIONS(3174),
    [anon_sym_var] = ACTIONS(3174),
    [anon_sym_let] = ACTIONS(3174),
    [anon_sym_const] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_if] = ACTIONS(3174),
    [anon_sym_switch] = ACTIONS(3174),
    [anon_sym_for] = ACTIONS(3174),
    [anon_sym_LPAREN] = ACTIONS(3174),
    [anon_sym_await] = ACTIONS(3174),
    [anon_sym_while] = ACTIONS(3174),
    [anon_sym_do] = ACTIONS(3174),
    [anon_sym_try] = ACTIONS(3174),
    [anon_sym_break] = ACTIONS(3174),
    [anon_sym_continue] = ACTIONS(3174),
    [anon_sym_debugger] = ACTIONS(3174),
    [anon_sym_return] = ACTIONS(3174),
    [anon_sym_throw] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym_yield] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(3174),
    [anon_sym_LTtemplate_GT] = ACTIONS(3174),
    [anon_sym_DQUOTE] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(3174),
    [anon_sym_class] = ACTIONS(3174),
    [anon_sym_async] = ACTIONS(3174),
    [anon_sym_function] = ACTIONS(3174),
    [anon_sym_new] = ACTIONS(3174),
    [anon_sym_using] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_SLASH] = ACTIONS(3174),
    [anon_sym_LT] = ACTIONS(3174),
    [anon_sym_TILDE] = ACTIONS(3174),
    [anon_sym_void] = ACTIONS(3174),
    [anon_sym_delete] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3174),
    [anon_sym_DASH_DASH] = ACTIONS(3174),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3174),
    [sym_number] = ACTIONS(3174),
    [sym_private_property_identifier] = ACTIONS(3174),
    [sym_this] = ACTIONS(3174),
    [sym_super] = ACTIONS(3174),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [sym_null] = ACTIONS(3174),
    [sym_undefined] = ACTIONS(3174),
    [anon_sym_AT] = ACTIONS(3174),
    [anon_sym_static] = ACTIONS(3174),
    [anon_sym_readonly] = ACTIONS(3174),
    [anon_sym_get] = ACTIONS(3174),
    [anon_sym_set] = ACTIONS(3174),
    [anon_sym_declare] = ACTIONS(3174),
    [anon_sym_public] = ACTIONS(3174),
    [anon_sym_private] = ACTIONS(3174),
    [anon_sym_protected] = ACTIONS(3174),
    [anon_sym_override] = ACTIONS(3174),
    [anon_sym_module] = ACTIONS(3174),
    [anon_sym_any] = ACTIONS(3174),
    [anon_sym_number] = ACTIONS(3174),
    [anon_sym_boolean] = ACTIONS(3174),
    [anon_sym_string] = ACTIONS(3174),
    [anon_sym_symbol] = ACTIONS(3174),
    [anon_sym_object] = ACTIONS(3174),
    [anon_sym_abstract] = ACTIONS(3174),
    [anon_sym_interface] = ACTIONS(3174),
    [anon_sym_enum] = ACTIONS(3174),
    [sym_html_comment] = ACTIONS(5),
  },
  [1528] = {
    [sym_comment] = STATE(1528),
    [ts_builtin_sym_end] = ACTIONS(3388),
    [sym_identifier] = ACTIONS(3158),
    [anon_sym_export] = ACTIONS(3158),
    [anon_sym_type] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_typeof] = ACTIONS(3158),
    [anon_sym_import] = ACTIONS(3158),
    [anon_sym_with] = ACTIONS(3158),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_LPAREN] = ACTIONS(3158),
    [anon_sym_await] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_debugger] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_yield] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_LTtemplate_GT] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_async] = ACTIONS(3158),
    [anon_sym_function] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_SLASH] = ACTIONS(3158),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [anon_sym_void] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3158),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3158),
    [sym_number] = ACTIONS(3158),
    [sym_private_property_identifier] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
    [sym_super] = ACTIONS(3158),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [sym_null] = ACTIONS(3158),
    [sym_undefined] = ACTIONS(3158),
    [anon_sym_AT] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_readonly] = ACTIONS(3158),
    [anon_sym_get] = ACTIONS(3158),
    [anon_sym_set] = ACTIONS(3158),
    [anon_sym_declare] = ACTIONS(3158),
    [anon_sym_public] = ACTIONS(3158),
    [anon_sym_private] = ACTIONS(3158),
    [anon_sym_protected] = ACTIONS(3158),
    [anon_sym_override] = ACTIONS(3158),
    [anon_sym_module] = ACTIONS(3158),
    [anon_sym_any] = ACTIONS(3158),
    [anon_sym_number] = ACTIONS(3158),
    [anon_sym_boolean] = ACTIONS(3158),
    [anon_sym_string] = ACTIONS(3158),
    [anon_sym_symbol] = ACTIONS(3158),
    [anon_sym_object] = ACTIONS(3158),
    [anon_sym_abstract] = ACTIONS(3158),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [sym_html_comment] = ACTIONS(5),
  },
  [1529] = {
    [sym_comment] = STATE(1529),
    [ts_builtin_sym_end] = ACTIONS(3526),
    [sym_identifier] = ACTIONS(3334),
    [anon_sym_export] = ACTIONS(3334),
    [anon_sym_type] = ACTIONS(3334),
    [anon_sym_namespace] = ACTIONS(3334),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_typeof] = ACTIONS(3334),
    [anon_sym_import] = ACTIONS(3334),
    [anon_sym_with] = ACTIONS(3334),
    [anon_sym_var] = ACTIONS(3334),
    [anon_sym_let] = ACTIONS(3334),
    [anon_sym_const] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_if] = ACTIONS(3334),
    [anon_sym_switch] = ACTIONS(3334),
    [anon_sym_for] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3334),
    [anon_sym_await] = ACTIONS(3334),
    [anon_sym_while] = ACTIONS(3334),
    [anon_sym_do] = ACTIONS(3334),
    [anon_sym_try] = ACTIONS(3334),
    [anon_sym_break] = ACTIONS(3334),
    [anon_sym_continue] = ACTIONS(3334),
    [anon_sym_debugger] = ACTIONS(3334),
    [anon_sym_return] = ACTIONS(3334),
    [anon_sym_throw] = ACTIONS(3334),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym_yield] = ACTIONS(3334),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LTtemplate_GT] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_class] = ACTIONS(3334),
    [anon_sym_async] = ACTIONS(3334),
    [anon_sym_function] = ACTIONS(3334),
    [anon_sym_new] = ACTIONS(3334),
    [anon_sym_using] = ACTIONS(3334),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3334),
    [anon_sym_SLASH] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_void] = ACTIONS(3334),
    [anon_sym_delete] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3334),
    [sym_number] = ACTIONS(3334),
    [sym_private_property_identifier] = ACTIONS(3334),
    [sym_this] = ACTIONS(3334),
    [sym_super] = ACTIONS(3334),
    [sym_true] = ACTIONS(3334),
    [sym_false] = ACTIONS(3334),
    [sym_null] = ACTIONS(3334),
    [sym_undefined] = ACTIONS(3334),
    [anon_sym_AT] = ACTIONS(3334),
    [anon_sym_static] = ACTIONS(3334),
    [anon_sym_readonly] = ACTIONS(3334),
    [anon_sym_get] = ACTIONS(3334),
    [anon_sym_set] = ACTIONS(3334),
    [anon_sym_declare] = ACTIONS(3334),
    [anon_sym_public] = ACTIONS(3334),
    [anon_sym_private] = ACTIONS(3334),
    [anon_sym_protected] = ACTIONS(3334),
    [anon_sym_override] = ACTIONS(3334),
    [anon_sym_module] = ACTIONS(3334),
    [anon_sym_any] = ACTIONS(3334),
    [anon_sym_number] = ACTIONS(3334),
    [anon_sym_boolean] = ACTIONS(3334),
    [anon_sym_string] = ACTIONS(3334),
    [anon_sym_symbol] = ACTIONS(3334),
    [anon_sym_object] = ACTIONS(3334),
    [anon_sym_abstract] = ACTIONS(3334),
    [anon_sym_interface] = ACTIONS(3334),
    [anon_sym_enum] = ACTIONS(3334),
    [sym_html_comment] = ACTIONS(5),
  },
  [1530] = {
    [sym_comment] = STATE(1530),
    [ts_builtin_sym_end] = ACTIONS(3526),
    [sym_identifier] = ACTIONS(3334),
    [anon_sym_export] = ACTIONS(3334),
    [anon_sym_type] = ACTIONS(3334),
    [anon_sym_namespace] = ACTIONS(3334),
    [anon_sym_LBRACE] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_typeof] = ACTIONS(3334),
    [anon_sym_import] = ACTIONS(3334),
    [anon_sym_with] = ACTIONS(3334),
    [anon_sym_var] = ACTIONS(3334),
    [anon_sym_let] = ACTIONS(3334),
    [anon_sym_const] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_if] = ACTIONS(3334),
    [anon_sym_switch] = ACTIONS(3334),
    [anon_sym_for] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3334),
    [anon_sym_await] = ACTIONS(3334),
    [anon_sym_while] = ACTIONS(3334),
    [anon_sym_do] = ACTIONS(3334),
    [anon_sym_try] = ACTIONS(3334),
    [anon_sym_break] = ACTIONS(3334),
    [anon_sym_continue] = ACTIONS(3334),
    [anon_sym_debugger] = ACTIONS(3334),
    [anon_sym_return] = ACTIONS(3334),
    [anon_sym_throw] = ACTIONS(3334),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym_yield] = ACTIONS(3334),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LTtemplate_GT] = ACTIONS(3334),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [anon_sym_SQUOTE] = ACTIONS(3334),
    [anon_sym_class] = ACTIONS(3334),
    [anon_sym_async] = ACTIONS(3334),
    [anon_sym_function] = ACTIONS(3334),
    [anon_sym_new] = ACTIONS(3334),
    [anon_sym_using] = ACTIONS(3334),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3334),
    [anon_sym_SLASH] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3334),
    [anon_sym_TILDE] = ACTIONS(3334),
    [anon_sym_void] = ACTIONS(3334),
    [anon_sym_delete] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3334),
    [anon_sym_DASH_DASH] = ACTIONS(3334),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3334),
    [sym_number] = ACTIONS(3334),
    [sym_private_property_identifier] = ACTIONS(3334),
    [sym_this] = ACTIONS(3334),
    [sym_super] = ACTIONS(3334),
    [sym_true] = ACTIONS(3334),
    [sym_false] = ACTIONS(3334),
    [sym_null] = ACTIONS(3334),
    [sym_undefined] = ACTIONS(3334),
    [anon_sym_AT] = ACTIONS(3334),
    [anon_sym_static] = ACTIONS(3334),
    [anon_sym_readonly] = ACTIONS(3334),
    [anon_sym_get] = ACTIONS(3334),
    [anon_sym_set] = ACTIONS(3334),
    [anon_sym_declare] = ACTIONS(3334),
    [anon_sym_public] = ACTIONS(3334),
    [anon_sym_private] = ACTIONS(3334),
    [anon_sym_protected] = ACTIONS(3334),
    [anon_sym_override] = ACTIONS(3334),
    [anon_sym_module] = ACTIONS(3334),
    [anon_sym_any] = ACTIONS(3334),
    [anon_sym_number] = ACTIONS(3334),
    [anon_sym_boolean] = ACTIONS(3334),
    [anon_sym_string] = ACTIONS(3334),
    [anon_sym_symbol] = ACTIONS(3334),
    [anon_sym_object] = ACTIONS(3334),
    [anon_sym_abstract] = ACTIONS(3334),
    [anon_sym_interface] = ACTIONS(3334),
    [anon_sym_enum] = ACTIONS(3334),
    [sym_html_comment] = ACTIONS(5),
  },
  [1531] = {
    [sym_comment] = STATE(1531),
    [ts_builtin_sym_end] = ACTIONS(3400),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LTtemplate_GT] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_using] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [sym_number] = ACTIONS(3356),
    [sym_private_property_identifier] = ACTIONS(3356),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3356),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_object] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [sym_html_comment] = ACTIONS(5),
  },
  [1532] = {
    [sym_comment] = STATE(1532),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1533] = {
    [sym_comment] = STATE(1533),
    [ts_builtin_sym_end] = ACTIONS(3418),
    [sym_identifier] = ACTIONS(3238),
    [anon_sym_export] = ACTIONS(3238),
    [anon_sym_type] = ACTIONS(3238),
    [anon_sym_namespace] = ACTIONS(3238),
    [anon_sym_LBRACE] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_typeof] = ACTIONS(3238),
    [anon_sym_import] = ACTIONS(3238),
    [anon_sym_with] = ACTIONS(3238),
    [anon_sym_var] = ACTIONS(3238),
    [anon_sym_let] = ACTIONS(3238),
    [anon_sym_const] = ACTIONS(3238),
    [anon_sym_BANG] = ACTIONS(3238),
    [anon_sym_if] = ACTIONS(3238),
    [anon_sym_switch] = ACTIONS(3238),
    [anon_sym_for] = ACTIONS(3238),
    [anon_sym_LPAREN] = ACTIONS(3238),
    [anon_sym_await] = ACTIONS(3238),
    [anon_sym_while] = ACTIONS(3238),
    [anon_sym_do] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(3238),
    [anon_sym_break] = ACTIONS(3238),
    [anon_sym_continue] = ACTIONS(3238),
    [anon_sym_debugger] = ACTIONS(3238),
    [anon_sym_return] = ACTIONS(3238),
    [anon_sym_throw] = ACTIONS(3238),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym_yield] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_LTtemplate_GT] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [anon_sym_class] = ACTIONS(3238),
    [anon_sym_async] = ACTIONS(3238),
    [anon_sym_function] = ACTIONS(3238),
    [anon_sym_new] = ACTIONS(3238),
    [anon_sym_using] = ACTIONS(3238),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3238),
    [anon_sym_TILDE] = ACTIONS(3238),
    [anon_sym_void] = ACTIONS(3238),
    [anon_sym_delete] = ACTIONS(3238),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [sym_number] = ACTIONS(3238),
    [sym_private_property_identifier] = ACTIONS(3238),
    [sym_this] = ACTIONS(3238),
    [sym_super] = ACTIONS(3238),
    [sym_true] = ACTIONS(3238),
    [sym_false] = ACTIONS(3238),
    [sym_null] = ACTIONS(3238),
    [sym_undefined] = ACTIONS(3238),
    [anon_sym_AT] = ACTIONS(3238),
    [anon_sym_static] = ACTIONS(3238),
    [anon_sym_readonly] = ACTIONS(3238),
    [anon_sym_get] = ACTIONS(3238),
    [anon_sym_set] = ACTIONS(3238),
    [anon_sym_declare] = ACTIONS(3238),
    [anon_sym_public] = ACTIONS(3238),
    [anon_sym_private] = ACTIONS(3238),
    [anon_sym_protected] = ACTIONS(3238),
    [anon_sym_override] = ACTIONS(3238),
    [anon_sym_module] = ACTIONS(3238),
    [anon_sym_any] = ACTIONS(3238),
    [anon_sym_number] = ACTIONS(3238),
    [anon_sym_boolean] = ACTIONS(3238),
    [anon_sym_string] = ACTIONS(3238),
    [anon_sym_symbol] = ACTIONS(3238),
    [anon_sym_object] = ACTIONS(3238),
    [anon_sym_abstract] = ACTIONS(3238),
    [anon_sym_interface] = ACTIONS(3238),
    [anon_sym_enum] = ACTIONS(3238),
    [sym_html_comment] = ACTIONS(5),
  },
  [1534] = {
    [sym_comment] = STATE(1534),
    [ts_builtin_sym_end] = ACTIONS(3400),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_export] = ACTIONS(3356),
    [anon_sym_type] = ACTIONS(3356),
    [anon_sym_namespace] = ACTIONS(3356),
    [anon_sym_LBRACE] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_typeof] = ACTIONS(3356),
    [anon_sym_import] = ACTIONS(3356),
    [anon_sym_with] = ACTIONS(3356),
    [anon_sym_var] = ACTIONS(3356),
    [anon_sym_let] = ACTIONS(3356),
    [anon_sym_const] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_if] = ACTIONS(3356),
    [anon_sym_switch] = ACTIONS(3356),
    [anon_sym_for] = ACTIONS(3356),
    [anon_sym_LPAREN] = ACTIONS(3356),
    [anon_sym_await] = ACTIONS(3356),
    [anon_sym_while] = ACTIONS(3356),
    [anon_sym_do] = ACTIONS(3356),
    [anon_sym_try] = ACTIONS(3356),
    [anon_sym_break] = ACTIONS(3356),
    [anon_sym_continue] = ACTIONS(3356),
    [anon_sym_debugger] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(3356),
    [anon_sym_throw] = ACTIONS(3356),
    [anon_sym_SEMI] = ACTIONS(3356),
    [anon_sym_yield] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LTtemplate_GT] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [anon_sym_SQUOTE] = ACTIONS(3356),
    [anon_sym_class] = ACTIONS(3356),
    [anon_sym_async] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(3356),
    [anon_sym_new] = ACTIONS(3356),
    [anon_sym_using] = ACTIONS(3356),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_TILDE] = ACTIONS(3356),
    [anon_sym_void] = ACTIONS(3356),
    [anon_sym_delete] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3356),
    [anon_sym_DASH_DASH] = ACTIONS(3356),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [sym_number] = ACTIONS(3356),
    [sym_private_property_identifier] = ACTIONS(3356),
    [sym_this] = ACTIONS(3356),
    [sym_super] = ACTIONS(3356),
    [sym_true] = ACTIONS(3356),
    [sym_false] = ACTIONS(3356),
    [sym_null] = ACTIONS(3356),
    [sym_undefined] = ACTIONS(3356),
    [anon_sym_AT] = ACTIONS(3356),
    [anon_sym_static] = ACTIONS(3356),
    [anon_sym_readonly] = ACTIONS(3356),
    [anon_sym_get] = ACTIONS(3356),
    [anon_sym_set] = ACTIONS(3356),
    [anon_sym_declare] = ACTIONS(3356),
    [anon_sym_public] = ACTIONS(3356),
    [anon_sym_private] = ACTIONS(3356),
    [anon_sym_protected] = ACTIONS(3356),
    [anon_sym_override] = ACTIONS(3356),
    [anon_sym_module] = ACTIONS(3356),
    [anon_sym_any] = ACTIONS(3356),
    [anon_sym_number] = ACTIONS(3356),
    [anon_sym_boolean] = ACTIONS(3356),
    [anon_sym_string] = ACTIONS(3356),
    [anon_sym_symbol] = ACTIONS(3356),
    [anon_sym_object] = ACTIONS(3356),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_interface] = ACTIONS(3356),
    [anon_sym_enum] = ACTIONS(3356),
    [sym_html_comment] = ACTIONS(5),
  },
  [1535] = {
    [sym_comment] = STATE(1535),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1536] = {
    [sym_comment] = STATE(1536),
    [ts_builtin_sym_end] = ACTIONS(3422),
    [sym_identifier] = ACTIONS(3260),
    [anon_sym_export] = ACTIONS(3260),
    [anon_sym_type] = ACTIONS(3260),
    [anon_sym_namespace] = ACTIONS(3260),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_RBRACE] = ACTIONS(3260),
    [anon_sym_typeof] = ACTIONS(3260),
    [anon_sym_import] = ACTIONS(3260),
    [anon_sym_with] = ACTIONS(3260),
    [anon_sym_var] = ACTIONS(3260),
    [anon_sym_let] = ACTIONS(3260),
    [anon_sym_const] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_if] = ACTIONS(3260),
    [anon_sym_switch] = ACTIONS(3260),
    [anon_sym_for] = ACTIONS(3260),
    [anon_sym_LPAREN] = ACTIONS(3260),
    [anon_sym_await] = ACTIONS(3260),
    [anon_sym_while] = ACTIONS(3260),
    [anon_sym_do] = ACTIONS(3260),
    [anon_sym_try] = ACTIONS(3260),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_continue] = ACTIONS(3260),
    [anon_sym_debugger] = ACTIONS(3260),
    [anon_sym_return] = ACTIONS(3260),
    [anon_sym_throw] = ACTIONS(3260),
    [anon_sym_SEMI] = ACTIONS(3260),
    [anon_sym_yield] = ACTIONS(3260),
    [anon_sym_LBRACK] = ACTIONS(3260),
    [anon_sym_LTtemplate_GT] = ACTIONS(3260),
    [anon_sym_DQUOTE] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3260),
    [anon_sym_class] = ACTIONS(3260),
    [anon_sym_async] = ACTIONS(3260),
    [anon_sym_function] = ACTIONS(3260),
    [anon_sym_new] = ACTIONS(3260),
    [anon_sym_using] = ACTIONS(3260),
    [anon_sym_PLUS] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3260),
    [anon_sym_SLASH] = ACTIONS(3260),
    [anon_sym_LT] = ACTIONS(3260),
    [anon_sym_TILDE] = ACTIONS(3260),
    [anon_sym_void] = ACTIONS(3260),
    [anon_sym_delete] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3260),
    [anon_sym_DASH_DASH] = ACTIONS(3260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3260),
    [sym_number] = ACTIONS(3260),
    [sym_private_property_identifier] = ACTIONS(3260),
    [sym_this] = ACTIONS(3260),
    [sym_super] = ACTIONS(3260),
    [sym_true] = ACTIONS(3260),
    [sym_false] = ACTIONS(3260),
    [sym_null] = ACTIONS(3260),
    [sym_undefined] = ACTIONS(3260),
    [anon_sym_AT] = ACTIONS(3260),
    [anon_sym_static] = ACTIONS(3260),
    [anon_sym_readonly] = ACTIONS(3260),
    [anon_sym_get] = ACTIONS(3260),
    [anon_sym_set] = ACTIONS(3260),
    [anon_sym_declare] = ACTIONS(3260),
    [anon_sym_public] = ACTIONS(3260),
    [anon_sym_private] = ACTIONS(3260),
    [anon_sym_protected] = ACTIONS(3260),
    [anon_sym_override] = ACTIONS(3260),
    [anon_sym_module] = ACTIONS(3260),
    [anon_sym_any] = ACTIONS(3260),
    [anon_sym_number] = ACTIONS(3260),
    [anon_sym_boolean] = ACTIONS(3260),
    [anon_sym_string] = ACTIONS(3260),
    [anon_sym_symbol] = ACTIONS(3260),
    [anon_sym_object] = ACTIONS(3260),
    [anon_sym_abstract] = ACTIONS(3260),
    [anon_sym_interface] = ACTIONS(3260),
    [anon_sym_enum] = ACTIONS(3260),
    [sym_html_comment] = ACTIONS(5),
  },
  [1537] = {
    [sym_comment] = STATE(1537),
    [ts_builtin_sym_end] = ACTIONS(3414),
    [sym_identifier] = ACTIONS(3354),
    [anon_sym_export] = ACTIONS(3354),
    [anon_sym_type] = ACTIONS(3354),
    [anon_sym_namespace] = ACTIONS(3354),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_RBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3354),
    [anon_sym_import] = ACTIONS(3354),
    [anon_sym_with] = ACTIONS(3354),
    [anon_sym_var] = ACTIONS(3354),
    [anon_sym_let] = ACTIONS(3354),
    [anon_sym_const] = ACTIONS(3354),
    [anon_sym_BANG] = ACTIONS(3354),
    [anon_sym_if] = ACTIONS(3354),
    [anon_sym_switch] = ACTIONS(3354),
    [anon_sym_for] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3354),
    [anon_sym_await] = ACTIONS(3354),
    [anon_sym_while] = ACTIONS(3354),
    [anon_sym_do] = ACTIONS(3354),
    [anon_sym_try] = ACTIONS(3354),
    [anon_sym_break] = ACTIONS(3354),
    [anon_sym_continue] = ACTIONS(3354),
    [anon_sym_debugger] = ACTIONS(3354),
    [anon_sym_return] = ACTIONS(3354),
    [anon_sym_throw] = ACTIONS(3354),
    [anon_sym_SEMI] = ACTIONS(3354),
    [anon_sym_yield] = ACTIONS(3354),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_LTtemplate_GT] = ACTIONS(3354),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_class] = ACTIONS(3354),
    [anon_sym_async] = ACTIONS(3354),
    [anon_sym_function] = ACTIONS(3354),
    [anon_sym_new] = ACTIONS(3354),
    [anon_sym_using] = ACTIONS(3354),
    [anon_sym_PLUS] = ACTIONS(3354),
    [anon_sym_DASH] = ACTIONS(3354),
    [anon_sym_SLASH] = ACTIONS(3354),
    [anon_sym_LT] = ACTIONS(3354),
    [anon_sym_TILDE] = ACTIONS(3354),
    [anon_sym_void] = ACTIONS(3354),
    [anon_sym_delete] = ACTIONS(3354),
    [anon_sym_PLUS_PLUS] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3354),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3354),
    [sym_number] = ACTIONS(3354),
    [sym_private_property_identifier] = ACTIONS(3354),
    [sym_this] = ACTIONS(3354),
    [sym_super] = ACTIONS(3354),
    [sym_true] = ACTIONS(3354),
    [sym_false] = ACTIONS(3354),
    [sym_null] = ACTIONS(3354),
    [sym_undefined] = ACTIONS(3354),
    [anon_sym_AT] = ACTIONS(3354),
    [anon_sym_static] = ACTIONS(3354),
    [anon_sym_readonly] = ACTIONS(3354),
    [anon_sym_get] = ACTIONS(3354),
    [anon_sym_set] = ACTIONS(3354),
    [anon_sym_declare] = ACTIONS(3354),
    [anon_sym_public] = ACTIONS(3354),
    [anon_sym_private] = ACTIONS(3354),
    [anon_sym_protected] = ACTIONS(3354),
    [anon_sym_override] = ACTIONS(3354),
    [anon_sym_module] = ACTIONS(3354),
    [anon_sym_any] = ACTIONS(3354),
    [anon_sym_number] = ACTIONS(3354),
    [anon_sym_boolean] = ACTIONS(3354),
    [anon_sym_string] = ACTIONS(3354),
    [anon_sym_symbol] = ACTIONS(3354),
    [anon_sym_object] = ACTIONS(3354),
    [anon_sym_abstract] = ACTIONS(3354),
    [anon_sym_interface] = ACTIONS(3354),
    [anon_sym_enum] = ACTIONS(3354),
    [sym_html_comment] = ACTIONS(5),
  },
  [1538] = {
    [sym_comment] = STATE(1538),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2221),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2221),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_LTtemplate_GT] = ACTIONS(2221),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2221),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2221),
    [sym_number] = ACTIONS(2221),
    [sym_private_property_identifier] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_readonly] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_override] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_object] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1539] = {
    [sym_comment] = STATE(1539),
    [ts_builtin_sym_end] = ACTIONS(3420),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_export] = ACTIONS(3350),
    [anon_sym_type] = ACTIONS(3350),
    [anon_sym_namespace] = ACTIONS(3350),
    [anon_sym_LBRACE] = ACTIONS(3350),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_typeof] = ACTIONS(3350),
    [anon_sym_import] = ACTIONS(3350),
    [anon_sym_with] = ACTIONS(3350),
    [anon_sym_var] = ACTIONS(3350),
    [anon_sym_let] = ACTIONS(3350),
    [anon_sym_const] = ACTIONS(3350),
    [anon_sym_BANG] = ACTIONS(3350),
    [anon_sym_if] = ACTIONS(3350),
    [anon_sym_switch] = ACTIONS(3350),
    [anon_sym_for] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym_await] = ACTIONS(3350),
    [anon_sym_while] = ACTIONS(3350),
    [anon_sym_do] = ACTIONS(3350),
    [anon_sym_try] = ACTIONS(3350),
    [anon_sym_break] = ACTIONS(3350),
    [anon_sym_continue] = ACTIONS(3350),
    [anon_sym_debugger] = ACTIONS(3350),
    [anon_sym_return] = ACTIONS(3350),
    [anon_sym_throw] = ACTIONS(3350),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym_yield] = ACTIONS(3350),
    [anon_sym_LBRACK] = ACTIONS(3350),
    [anon_sym_LTtemplate_GT] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [anon_sym_SQUOTE] = ACTIONS(3350),
    [anon_sym_class] = ACTIONS(3350),
    [anon_sym_async] = ACTIONS(3350),
    [anon_sym_function] = ACTIONS(3350),
    [anon_sym_new] = ACTIONS(3350),
    [anon_sym_using] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3350),
    [anon_sym_DASH] = ACTIONS(3350),
    [anon_sym_SLASH] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(3350),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_void] = ACTIONS(3350),
    [anon_sym_delete] = ACTIONS(3350),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [sym_number] = ACTIONS(3350),
    [sym_private_property_identifier] = ACTIONS(3350),
    [sym_this] = ACTIONS(3350),
    [sym_super] = ACTIONS(3350),
    [sym_true] = ACTIONS(3350),
    [sym_false] = ACTIONS(3350),
    [sym_null] = ACTIONS(3350),
    [sym_undefined] = ACTIONS(3350),
    [anon_sym_AT] = ACTIONS(3350),
    [anon_sym_static] = ACTIONS(3350),
    [anon_sym_readonly] = ACTIONS(3350),
    [anon_sym_get] = ACTIONS(3350),
    [anon_sym_set] = ACTIONS(3350),
    [anon_sym_declare] = ACTIONS(3350),
    [anon_sym_public] = ACTIONS(3350),
    [anon_sym_private] = ACTIONS(3350),
    [anon_sym_protected] = ACTIONS(3350),
    [anon_sym_override] = ACTIONS(3350),
    [anon_sym_module] = ACTIONS(3350),
    [anon_sym_any] = ACTIONS(3350),
    [anon_sym_number] = ACTIONS(3350),
    [anon_sym_boolean] = ACTIONS(3350),
    [anon_sym_string] = ACTIONS(3350),
    [anon_sym_symbol] = ACTIONS(3350),
    [anon_sym_object] = ACTIONS(3350),
    [anon_sym_abstract] = ACTIONS(3350),
    [anon_sym_interface] = ACTIONS(3350),
    [anon_sym_enum] = ACTIONS(3350),
    [sym_html_comment] = ACTIONS(5),
  },
  [1540] = {
    [sym_comment] = STATE(1540),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1541] = {
    [sym_comment] = STATE(1541),
    [ts_builtin_sym_end] = ACTIONS(3424),
    [sym_identifier] = ACTIONS(3148),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_type] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_typeof] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3148),
    [anon_sym_with] = ACTIONS(3148),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_await] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_debugger] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_yield] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_LTtemplate_GT] = ACTIONS(3148),
    [anon_sym_DQUOTE] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_async] = ACTIONS(3148),
    [anon_sym_function] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_SLASH] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_void] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3148),
    [sym_number] = ACTIONS(3148),
    [sym_private_property_identifier] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
    [sym_super] = ACTIONS(3148),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [sym_null] = ACTIONS(3148),
    [sym_undefined] = ACTIONS(3148),
    [anon_sym_AT] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_readonly] = ACTIONS(3148),
    [anon_sym_get] = ACTIONS(3148),
    [anon_sym_set] = ACTIONS(3148),
    [anon_sym_declare] = ACTIONS(3148),
    [anon_sym_public] = ACTIONS(3148),
    [anon_sym_private] = ACTIONS(3148),
    [anon_sym_protected] = ACTIONS(3148),
    [anon_sym_override] = ACTIONS(3148),
    [anon_sym_module] = ACTIONS(3148),
    [anon_sym_any] = ACTIONS(3148),
    [anon_sym_number] = ACTIONS(3148),
    [anon_sym_boolean] = ACTIONS(3148),
    [anon_sym_string] = ACTIONS(3148),
    [anon_sym_symbol] = ACTIONS(3148),
    [anon_sym_object] = ACTIONS(3148),
    [anon_sym_abstract] = ACTIONS(3148),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [sym_html_comment] = ACTIONS(5),
  },
  [1542] = {
    [sym_comment] = STATE(1542),
    [ts_builtin_sym_end] = ACTIONS(3518),
    [sym_identifier] = ACTIONS(3228),
    [anon_sym_export] = ACTIONS(3228),
    [anon_sym_type] = ACTIONS(3228),
    [anon_sym_namespace] = ACTIONS(3228),
    [anon_sym_LBRACE] = ACTIONS(3228),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_typeof] = ACTIONS(3228),
    [anon_sym_import] = ACTIONS(3228),
    [anon_sym_with] = ACTIONS(3228),
    [anon_sym_var] = ACTIONS(3228),
    [anon_sym_let] = ACTIONS(3228),
    [anon_sym_const] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3228),
    [anon_sym_if] = ACTIONS(3228),
    [anon_sym_switch] = ACTIONS(3228),
    [anon_sym_for] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3228),
    [anon_sym_await] = ACTIONS(3228),
    [anon_sym_while] = ACTIONS(3228),
    [anon_sym_do] = ACTIONS(3228),
    [anon_sym_try] = ACTIONS(3228),
    [anon_sym_break] = ACTIONS(3228),
    [anon_sym_continue] = ACTIONS(3228),
    [anon_sym_debugger] = ACTIONS(3228),
    [anon_sym_return] = ACTIONS(3228),
    [anon_sym_throw] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_yield] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3228),
    [anon_sym_LTtemplate_GT] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3228),
    [anon_sym_SQUOTE] = ACTIONS(3228),
    [anon_sym_class] = ACTIONS(3228),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_function] = ACTIONS(3228),
    [anon_sym_new] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3228),
    [anon_sym_DASH] = ACTIONS(3228),
    [anon_sym_SLASH] = ACTIONS(3228),
    [anon_sym_LT] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3228),
    [anon_sym_void] = ACTIONS(3228),
    [anon_sym_delete] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3228),
    [sym_number] = ACTIONS(3228),
    [sym_private_property_identifier] = ACTIONS(3228),
    [sym_this] = ACTIONS(3228),
    [sym_super] = ACTIONS(3228),
    [sym_true] = ACTIONS(3228),
    [sym_false] = ACTIONS(3228),
    [sym_null] = ACTIONS(3228),
    [sym_undefined] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3228),
    [anon_sym_static] = ACTIONS(3228),
    [anon_sym_readonly] = ACTIONS(3228),
    [anon_sym_get] = ACTIONS(3228),
    [anon_sym_set] = ACTIONS(3228),
    [anon_sym_declare] = ACTIONS(3228),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_override] = ACTIONS(3228),
    [anon_sym_module] = ACTIONS(3228),
    [anon_sym_any] = ACTIONS(3228),
    [anon_sym_number] = ACTIONS(3228),
    [anon_sym_boolean] = ACTIONS(3228),
    [anon_sym_string] = ACTIONS(3228),
    [anon_sym_symbol] = ACTIONS(3228),
    [anon_sym_object] = ACTIONS(3228),
    [anon_sym_abstract] = ACTIONS(3228),
    [anon_sym_interface] = ACTIONS(3228),
    [anon_sym_enum] = ACTIONS(3228),
    [sym_html_comment] = ACTIONS(5),
  },
  [1543] = {
    [sym_comment] = STATE(1543),
    [ts_builtin_sym_end] = ACTIONS(3428),
    [sym_identifier] = ACTIONS(3162),
    [anon_sym_export] = ACTIONS(3162),
    [anon_sym_type] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_RBRACE] = ACTIONS(3162),
    [anon_sym_typeof] = ACTIONS(3162),
    [anon_sym_import] = ACTIONS(3162),
    [anon_sym_with] = ACTIONS(3162),
    [anon_sym_var] = ACTIONS(3162),
    [anon_sym_let] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_LPAREN] = ACTIONS(3162),
    [anon_sym_await] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_debugger] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym_yield] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_LTtemplate_GT] = ACTIONS(3162),
    [anon_sym_DQUOTE] = ACTIONS(3162),
    [anon_sym_SQUOTE] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_async] = ACTIONS(3162),
    [anon_sym_function] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_SLASH] = ACTIONS(3162),
    [anon_sym_LT] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_void] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3162),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3162),
    [sym_number] = ACTIONS(3162),
    [sym_private_property_identifier] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
    [sym_super] = ACTIONS(3162),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [sym_null] = ACTIONS(3162),
    [sym_undefined] = ACTIONS(3162),
    [anon_sym_AT] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_readonly] = ACTIONS(3162),
    [anon_sym_get] = ACTIONS(3162),
    [anon_sym_set] = ACTIONS(3162),
    [anon_sym_declare] = ACTIONS(3162),
    [anon_sym_public] = ACTIONS(3162),
    [anon_sym_private] = ACTIONS(3162),
    [anon_sym_protected] = ACTIONS(3162),
    [anon_sym_override] = ACTIONS(3162),
    [anon_sym_module] = ACTIONS(3162),
    [anon_sym_any] = ACTIONS(3162),
    [anon_sym_number] = ACTIONS(3162),
    [anon_sym_boolean] = ACTIONS(3162),
    [anon_sym_string] = ACTIONS(3162),
    [anon_sym_symbol] = ACTIONS(3162),
    [anon_sym_object] = ACTIONS(3162),
    [anon_sym_abstract] = ACTIONS(3162),
    [anon_sym_interface] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [sym_html_comment] = ACTIONS(5),
  },
  [1544] = {
    [sym_comment] = STATE(1544),
    [ts_builtin_sym_end] = ACTIONS(3432),
    [sym_identifier] = ACTIONS(3166),
    [anon_sym_export] = ACTIONS(3166),
    [anon_sym_type] = ACTIONS(3166),
    [anon_sym_namespace] = ACTIONS(3166),
    [anon_sym_LBRACE] = ACTIONS(3166),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [anon_sym_typeof] = ACTIONS(3166),
    [anon_sym_import] = ACTIONS(3166),
    [anon_sym_with] = ACTIONS(3166),
    [anon_sym_var] = ACTIONS(3166),
    [anon_sym_let] = ACTIONS(3166),
    [anon_sym_const] = ACTIONS(3166),
    [anon_sym_BANG] = ACTIONS(3166),
    [anon_sym_if] = ACTIONS(3166),
    [anon_sym_switch] = ACTIONS(3166),
    [anon_sym_for] = ACTIONS(3166),
    [anon_sym_LPAREN] = ACTIONS(3166),
    [anon_sym_await] = ACTIONS(3166),
    [anon_sym_while] = ACTIONS(3166),
    [anon_sym_do] = ACTIONS(3166),
    [anon_sym_try] = ACTIONS(3166),
    [anon_sym_break] = ACTIONS(3166),
    [anon_sym_continue] = ACTIONS(3166),
    [anon_sym_debugger] = ACTIONS(3166),
    [anon_sym_return] = ACTIONS(3166),
    [anon_sym_throw] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym_yield] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [anon_sym_LTtemplate_GT] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [anon_sym_SQUOTE] = ACTIONS(3166),
    [anon_sym_class] = ACTIONS(3166),
    [anon_sym_async] = ACTIONS(3166),
    [anon_sym_function] = ACTIONS(3166),
    [anon_sym_new] = ACTIONS(3166),
    [anon_sym_using] = ACTIONS(3166),
    [anon_sym_PLUS] = ACTIONS(3166),
    [anon_sym_DASH] = ACTIONS(3166),
    [anon_sym_SLASH] = ACTIONS(3166),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_void] = ACTIONS(3166),
    [anon_sym_delete] = ACTIONS(3166),
    [anon_sym_PLUS_PLUS] = ACTIONS(3166),
    [anon_sym_DASH_DASH] = ACTIONS(3166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3166),
    [sym_number] = ACTIONS(3166),
    [sym_private_property_identifier] = ACTIONS(3166),
    [sym_this] = ACTIONS(3166),
    [sym_super] = ACTIONS(3166),
    [sym_true] = ACTIONS(3166),
    [sym_false] = ACTIONS(3166),
    [sym_null] = ACTIONS(3166),
    [sym_undefined] = ACTIONS(3166),
    [anon_sym_AT] = ACTIONS(3166),
    [anon_sym_static] = ACTIONS(3166),
    [anon_sym_readonly] = ACTIONS(3166),
    [anon_sym_get] = ACTIONS(3166),
    [anon_sym_set] = ACTIONS(3166),
    [anon_sym_declare] = ACTIONS(3166),
    [anon_sym_public] = ACTIONS(3166),
    [anon_sym_private] = ACTIONS(3166),
    [anon_sym_protected] = ACTIONS(3166),
    [anon_sym_override] = ACTIONS(3166),
    [anon_sym_module] = ACTIONS(3166),
    [anon_sym_any] = ACTIONS(3166),
    [anon_sym_number] = ACTIONS(3166),
    [anon_sym_boolean] = ACTIONS(3166),
    [anon_sym_string] = ACTIONS(3166),
    [anon_sym_symbol] = ACTIONS(3166),
    [anon_sym_object] = ACTIONS(3166),
    [anon_sym_abstract] = ACTIONS(3166),
    [anon_sym_interface] = ACTIONS(3166),
    [anon_sym_enum] = ACTIONS(3166),
    [sym_html_comment] = ACTIONS(5),
  },
  [1545] = {
    [sym_comment] = STATE(1545),
    [ts_builtin_sym_end] = ACTIONS(3392),
    [sym_identifier] = ACTIONS(3170),
    [anon_sym_export] = ACTIONS(3170),
    [anon_sym_type] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_typeof] = ACTIONS(3170),
    [anon_sym_import] = ACTIONS(3170),
    [anon_sym_with] = ACTIONS(3170),
    [anon_sym_var] = ACTIONS(3170),
    [anon_sym_let] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_await] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_debugger] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_yield] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_LTtemplate_GT] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_async] = ACTIONS(3170),
    [anon_sym_function] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3170),
    [anon_sym_TILDE] = ACTIONS(3170),
    [anon_sym_void] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [sym_number] = ACTIONS(3170),
    [sym_private_property_identifier] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
    [sym_super] = ACTIONS(3170),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [sym_null] = ACTIONS(3170),
    [sym_undefined] = ACTIONS(3170),
    [anon_sym_AT] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_readonly] = ACTIONS(3170),
    [anon_sym_get] = ACTIONS(3170),
    [anon_sym_set] = ACTIONS(3170),
    [anon_sym_declare] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_override] = ACTIONS(3170),
    [anon_sym_module] = ACTIONS(3170),
    [anon_sym_any] = ACTIONS(3170),
    [anon_sym_number] = ACTIONS(3170),
    [anon_sym_boolean] = ACTIONS(3170),
    [anon_sym_string] = ACTIONS(3170),
    [anon_sym_symbol] = ACTIONS(3170),
    [anon_sym_object] = ACTIONS(3170),
    [anon_sym_abstract] = ACTIONS(3170),
    [anon_sym_interface] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [sym_html_comment] = ACTIONS(5),
  },
  [1546] = {
    [sym_comment] = STATE(1546),
    [ts_builtin_sym_end] = ACTIONS(3574),
    [sym_identifier] = ACTIONS(3322),
    [anon_sym_export] = ACTIONS(3322),
    [anon_sym_type] = ACTIONS(3322),
    [anon_sym_namespace] = ACTIONS(3322),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_RBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3322),
    [anon_sym_import] = ACTIONS(3322),
    [anon_sym_with] = ACTIONS(3322),
    [anon_sym_var] = ACTIONS(3322),
    [anon_sym_let] = ACTIONS(3322),
    [anon_sym_const] = ACTIONS(3322),
    [anon_sym_BANG] = ACTIONS(3322),
    [anon_sym_if] = ACTIONS(3322),
    [anon_sym_switch] = ACTIONS(3322),
    [anon_sym_for] = ACTIONS(3322),
    [anon_sym_LPAREN] = ACTIONS(3322),
    [anon_sym_await] = ACTIONS(3322),
    [anon_sym_while] = ACTIONS(3322),
    [anon_sym_do] = ACTIONS(3322),
    [anon_sym_try] = ACTIONS(3322),
    [anon_sym_break] = ACTIONS(3322),
    [anon_sym_continue] = ACTIONS(3322),
    [anon_sym_debugger] = ACTIONS(3322),
    [anon_sym_return] = ACTIONS(3322),
    [anon_sym_throw] = ACTIONS(3322),
    [anon_sym_SEMI] = ACTIONS(3322),
    [anon_sym_yield] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3322),
    [anon_sym_LTtemplate_GT] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(3322),
    [anon_sym_SQUOTE] = ACTIONS(3322),
    [anon_sym_class] = ACTIONS(3322),
    [anon_sym_async] = ACTIONS(3322),
    [anon_sym_function] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(3322),
    [anon_sym_using] = ACTIONS(3322),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_SLASH] = ACTIONS(3322),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_TILDE] = ACTIONS(3322),
    [anon_sym_void] = ACTIONS(3322),
    [anon_sym_delete] = ACTIONS(3322),
    [anon_sym_PLUS_PLUS] = ACTIONS(3322),
    [anon_sym_DASH_DASH] = ACTIONS(3322),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3322),
    [sym_number] = ACTIONS(3322),
    [sym_private_property_identifier] = ACTIONS(3322),
    [sym_this] = ACTIONS(3322),
    [sym_super] = ACTIONS(3322),
    [sym_true] = ACTIONS(3322),
    [sym_false] = ACTIONS(3322),
    [sym_null] = ACTIONS(3322),
    [sym_undefined] = ACTIONS(3322),
    [anon_sym_AT] = ACTIONS(3322),
    [anon_sym_static] = ACTIONS(3322),
    [anon_sym_readonly] = ACTIONS(3322),
    [anon_sym_get] = ACTIONS(3322),
    [anon_sym_set] = ACTIONS(3322),
    [anon_sym_declare] = ACTIONS(3322),
    [anon_sym_public] = ACTIONS(3322),
    [anon_sym_private] = ACTIONS(3322),
    [anon_sym_protected] = ACTIONS(3322),
    [anon_sym_override] = ACTIONS(3322),
    [anon_sym_module] = ACTIONS(3322),
    [anon_sym_any] = ACTIONS(3322),
    [anon_sym_number] = ACTIONS(3322),
    [anon_sym_boolean] = ACTIONS(3322),
    [anon_sym_string] = ACTIONS(3322),
    [anon_sym_symbol] = ACTIONS(3322),
    [anon_sym_object] = ACTIONS(3322),
    [anon_sym_abstract] = ACTIONS(3322),
    [anon_sym_interface] = ACTIONS(3322),
    [anon_sym_enum] = ACTIONS(3322),
    [sym_html_comment] = ACTIONS(5),
  },
  [1547] = {
    [sym_comment] = STATE(1547),
    [ts_builtin_sym_end] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3332),
    [anon_sym_export] = ACTIONS(3332),
    [anon_sym_type] = ACTIONS(3332),
    [anon_sym_namespace] = ACTIONS(3332),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_typeof] = ACTIONS(3332),
    [anon_sym_import] = ACTIONS(3332),
    [anon_sym_with] = ACTIONS(3332),
    [anon_sym_var] = ACTIONS(3332),
    [anon_sym_let] = ACTIONS(3332),
    [anon_sym_const] = ACTIONS(3332),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3332),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_await] = ACTIONS(3332),
    [anon_sym_while] = ACTIONS(3332),
    [anon_sym_do] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3332),
    [anon_sym_break] = ACTIONS(3332),
    [anon_sym_continue] = ACTIONS(3332),
    [anon_sym_debugger] = ACTIONS(3332),
    [anon_sym_return] = ACTIONS(3332),
    [anon_sym_throw] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_yield] = ACTIONS(3332),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_LTtemplate_GT] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_class] = ACTIONS(3332),
    [anon_sym_async] = ACTIONS(3332),
    [anon_sym_function] = ACTIONS(3332),
    [anon_sym_new] = ACTIONS(3332),
    [anon_sym_using] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3332),
    [anon_sym_SLASH] = ACTIONS(3332),
    [anon_sym_LT] = ACTIONS(3332),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_void] = ACTIONS(3332),
    [anon_sym_delete] = ACTIONS(3332),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3332),
    [sym_number] = ACTIONS(3332),
    [sym_private_property_identifier] = ACTIONS(3332),
    [sym_this] = ACTIONS(3332),
    [sym_super] = ACTIONS(3332),
    [sym_true] = ACTIONS(3332),
    [sym_false] = ACTIONS(3332),
    [sym_null] = ACTIONS(3332),
    [sym_undefined] = ACTIONS(3332),
    [anon_sym_AT] = ACTIONS(3332),
    [anon_sym_static] = ACTIONS(3332),
    [anon_sym_readonly] = ACTIONS(3332),
    [anon_sym_get] = ACTIONS(3332),
    [anon_sym_set] = ACTIONS(3332),
    [anon_sym_declare] = ACTIONS(3332),
    [anon_sym_public] = ACTIONS(3332),
    [anon_sym_private] = ACTIONS(3332),
    [anon_sym_protected] = ACTIONS(3332),
    [anon_sym_override] = ACTIONS(3332),
    [anon_sym_module] = ACTIONS(3332),
    [anon_sym_any] = ACTIONS(3332),
    [anon_sym_number] = ACTIONS(3332),
    [anon_sym_boolean] = ACTIONS(3332),
    [anon_sym_string] = ACTIONS(3332),
    [anon_sym_symbol] = ACTIONS(3332),
    [anon_sym_object] = ACTIONS(3332),
    [anon_sym_abstract] = ACTIONS(3332),
    [anon_sym_interface] = ACTIONS(3332),
    [anon_sym_enum] = ACTIONS(3332),
    [sym_html_comment] = ACTIONS(5),
  },
  [1548] = {
    [sym_comment] = STATE(1548),
    [ts_builtin_sym_end] = ACTIONS(3502),
    [sym_identifier] = ACTIONS(3330),
    [anon_sym_export] = ACTIONS(3330),
    [anon_sym_type] = ACTIONS(3330),
    [anon_sym_namespace] = ACTIONS(3330),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_RBRACE] = ACTIONS(3330),
    [anon_sym_typeof] = ACTIONS(3330),
    [anon_sym_import] = ACTIONS(3330),
    [anon_sym_with] = ACTIONS(3330),
    [anon_sym_var] = ACTIONS(3330),
    [anon_sym_let] = ACTIONS(3330),
    [anon_sym_const] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_if] = ACTIONS(3330),
    [anon_sym_switch] = ACTIONS(3330),
    [anon_sym_for] = ACTIONS(3330),
    [anon_sym_LPAREN] = ACTIONS(3330),
    [anon_sym_await] = ACTIONS(3330),
    [anon_sym_while] = ACTIONS(3330),
    [anon_sym_do] = ACTIONS(3330),
    [anon_sym_try] = ACTIONS(3330),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_continue] = ACTIONS(3330),
    [anon_sym_debugger] = ACTIONS(3330),
    [anon_sym_return] = ACTIONS(3330),
    [anon_sym_throw] = ACTIONS(3330),
    [anon_sym_SEMI] = ACTIONS(3330),
    [anon_sym_yield] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3330),
    [anon_sym_LTtemplate_GT] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3330),
    [anon_sym_class] = ACTIONS(3330),
    [anon_sym_async] = ACTIONS(3330),
    [anon_sym_function] = ACTIONS(3330),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_using] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_SLASH] = ACTIONS(3330),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3330),
    [anon_sym_void] = ACTIONS(3330),
    [anon_sym_delete] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3330),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3330),
    [sym_number] = ACTIONS(3330),
    [sym_private_property_identifier] = ACTIONS(3330),
    [sym_this] = ACTIONS(3330),
    [sym_super] = ACTIONS(3330),
    [sym_true] = ACTIONS(3330),
    [sym_false] = ACTIONS(3330),
    [sym_null] = ACTIONS(3330),
    [sym_undefined] = ACTIONS(3330),
    [anon_sym_AT] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3330),
    [anon_sym_readonly] = ACTIONS(3330),
    [anon_sym_get] = ACTIONS(3330),
    [anon_sym_set] = ACTIONS(3330),
    [anon_sym_declare] = ACTIONS(3330),
    [anon_sym_public] = ACTIONS(3330),
    [anon_sym_private] = ACTIONS(3330),
    [anon_sym_protected] = ACTIONS(3330),
    [anon_sym_override] = ACTIONS(3330),
    [anon_sym_module] = ACTIONS(3330),
    [anon_sym_any] = ACTIONS(3330),
    [anon_sym_number] = ACTIONS(3330),
    [anon_sym_boolean] = ACTIONS(3330),
    [anon_sym_string] = ACTIONS(3330),
    [anon_sym_symbol] = ACTIONS(3330),
    [anon_sym_object] = ACTIONS(3330),
    [anon_sym_abstract] = ACTIONS(3330),
    [anon_sym_interface] = ACTIONS(3330),
    [anon_sym_enum] = ACTIONS(3330),
    [sym_html_comment] = ACTIONS(5),
  },
  [1549] = {
    [sym_comment] = STATE(1549),
    [ts_builtin_sym_end] = ACTIONS(2127),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_typeof] = ACTIONS(2125),
    [anon_sym_import] = ACTIONS(2125),
    [anon_sym_with] = ACTIONS(2125),
    [anon_sym_var] = ACTIONS(2125),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_const] = ACTIONS(2125),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2125),
    [anon_sym_switch] = ACTIONS(2125),
    [anon_sym_for] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2125),
    [anon_sym_while] = ACTIONS(2125),
    [anon_sym_do] = ACTIONS(2125),
    [anon_sym_try] = ACTIONS(2125),
    [anon_sym_break] = ACTIONS(2125),
    [anon_sym_continue] = ACTIONS(2125),
    [anon_sym_debugger] = ACTIONS(2125),
    [anon_sym_return] = ACTIONS(2125),
    [anon_sym_throw] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LTtemplate_GT] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_class] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_function] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_using] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_delete] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_private_property_identifier] = ACTIONS(2125),
    [sym_this] = ACTIONS(2125),
    [sym_super] = ACTIONS(2125),
    [sym_true] = ACTIONS(2125),
    [sym_false] = ACTIONS(2125),
    [sym_null] = ACTIONS(2125),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_readonly] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_override] = ACTIONS(2125),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_interface] = ACTIONS(2125),
    [anon_sym_enum] = ACTIONS(2125),
    [sym_html_comment] = ACTIONS(5),
  },
  [1550] = {
    [sym_comment] = STATE(1550),
    [ts_builtin_sym_end] = ACTIONS(3522),
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3198),
    [anon_sym_var] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3198),
    [anon_sym_const] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_while] = ACTIONS(3198),
    [anon_sym_do] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3198),
    [anon_sym_continue] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3198),
    [anon_sym_return] = ACTIONS(3198),
    [anon_sym_throw] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [anon_sym_LTtemplate_GT] = ACTIONS(3198),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_using] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [sym_private_property_identifier] = ACTIONS(3198),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3198),
    [anon_sym_enum] = ACTIONS(3198),
    [sym_html_comment] = ACTIONS(5),
  },
  [1551] = {
    [sym_comment] = STATE(1551),
    [ts_builtin_sym_end] = ACTIONS(3426),
    [sym_identifier] = ACTIONS(3348),
    [anon_sym_export] = ACTIONS(3348),
    [anon_sym_type] = ACTIONS(3348),
    [anon_sym_namespace] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(3348),
    [anon_sym_RBRACE] = ACTIONS(3348),
    [anon_sym_typeof] = ACTIONS(3348),
    [anon_sym_import] = ACTIONS(3348),
    [anon_sym_with] = ACTIONS(3348),
    [anon_sym_var] = ACTIONS(3348),
    [anon_sym_let] = ACTIONS(3348),
    [anon_sym_const] = ACTIONS(3348),
    [anon_sym_BANG] = ACTIONS(3348),
    [anon_sym_if] = ACTIONS(3348),
    [anon_sym_switch] = ACTIONS(3348),
    [anon_sym_for] = ACTIONS(3348),
    [anon_sym_LPAREN] = ACTIONS(3348),
    [anon_sym_await] = ACTIONS(3348),
    [anon_sym_while] = ACTIONS(3348),
    [anon_sym_do] = ACTIONS(3348),
    [anon_sym_try] = ACTIONS(3348),
    [anon_sym_break] = ACTIONS(3348),
    [anon_sym_continue] = ACTIONS(3348),
    [anon_sym_debugger] = ACTIONS(3348),
    [anon_sym_return] = ACTIONS(3348),
    [anon_sym_throw] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3348),
    [anon_sym_yield] = ACTIONS(3348),
    [anon_sym_LBRACK] = ACTIONS(3348),
    [anon_sym_LTtemplate_GT] = ACTIONS(3348),
    [anon_sym_DQUOTE] = ACTIONS(3348),
    [anon_sym_SQUOTE] = ACTIONS(3348),
    [anon_sym_class] = ACTIONS(3348),
    [anon_sym_async] = ACTIONS(3348),
    [anon_sym_function] = ACTIONS(3348),
    [anon_sym_new] = ACTIONS(3348),
    [anon_sym_using] = ACTIONS(3348),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3348),
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_TILDE] = ACTIONS(3348),
    [anon_sym_void] = ACTIONS(3348),
    [anon_sym_delete] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3348),
    [anon_sym_DASH_DASH] = ACTIONS(3348),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [sym_number] = ACTIONS(3348),
    [sym_private_property_identifier] = ACTIONS(3348),
    [sym_this] = ACTIONS(3348),
    [sym_super] = ACTIONS(3348),
    [sym_true] = ACTIONS(3348),
    [sym_false] = ACTIONS(3348),
    [sym_null] = ACTIONS(3348),
    [sym_undefined] = ACTIONS(3348),
    [anon_sym_AT] = ACTIONS(3348),
    [anon_sym_static] = ACTIONS(3348),
    [anon_sym_readonly] = ACTIONS(3348),
    [anon_sym_get] = ACTIONS(3348),
    [anon_sym_set] = ACTIONS(3348),
    [anon_sym_declare] = ACTIONS(3348),
    [anon_sym_public] = ACTIONS(3348),
    [anon_sym_private] = ACTIONS(3348),
    [anon_sym_protected] = ACTIONS(3348),
    [anon_sym_override] = ACTIONS(3348),
    [anon_sym_module] = ACTIONS(3348),
    [anon_sym_any] = ACTIONS(3348),
    [anon_sym_number] = ACTIONS(3348),
    [anon_sym_boolean] = ACTIONS(3348),
    [anon_sym_string] = ACTIONS(3348),
    [anon_sym_symbol] = ACTIONS(3348),
    [anon_sym_object] = ACTIONS(3348),
    [anon_sym_abstract] = ACTIONS(3348),
    [anon_sym_interface] = ACTIONS(3348),
    [anon_sym_enum] = ACTIONS(3348),
    [sym_html_comment] = ACTIONS(5),
  },
  [1552] = {
    [sym_comment] = STATE(1552),
    [ts_builtin_sym_end] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3324),
    [anon_sym_export] = ACTIONS(3324),
    [anon_sym_type] = ACTIONS(3324),
    [anon_sym_namespace] = ACTIONS(3324),
    [anon_sym_LBRACE] = ACTIONS(3324),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_import] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3324),
    [anon_sym_var] = ACTIONS(3324),
    [anon_sym_let] = ACTIONS(3324),
    [anon_sym_const] = ACTIONS(3324),
    [anon_sym_BANG] = ACTIONS(3324),
    [anon_sym_if] = ACTIONS(3324),
    [anon_sym_switch] = ACTIONS(3324),
    [anon_sym_for] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym_await] = ACTIONS(3324),
    [anon_sym_while] = ACTIONS(3324),
    [anon_sym_do] = ACTIONS(3324),
    [anon_sym_try] = ACTIONS(3324),
    [anon_sym_break] = ACTIONS(3324),
    [anon_sym_continue] = ACTIONS(3324),
    [anon_sym_debugger] = ACTIONS(3324),
    [anon_sym_return] = ACTIONS(3324),
    [anon_sym_throw] = ACTIONS(3324),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym_yield] = ACTIONS(3324),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_LTtemplate_GT] = ACTIONS(3324),
    [anon_sym_DQUOTE] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(3324),
    [anon_sym_class] = ACTIONS(3324),
    [anon_sym_async] = ACTIONS(3324),
    [anon_sym_function] = ACTIONS(3324),
    [anon_sym_new] = ACTIONS(3324),
    [anon_sym_using] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3324),
    [anon_sym_DASH] = ACTIONS(3324),
    [anon_sym_SLASH] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(3324),
    [anon_sym_TILDE] = ACTIONS(3324),
    [anon_sym_void] = ACTIONS(3324),
    [anon_sym_delete] = ACTIONS(3324),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3324),
    [sym_number] = ACTIONS(3324),
    [sym_private_property_identifier] = ACTIONS(3324),
    [sym_this] = ACTIONS(3324),
    [sym_super] = ACTIONS(3324),
    [sym_true] = ACTIONS(3324),
    [sym_false] = ACTIONS(3324),
    [sym_null] = ACTIONS(3324),
    [sym_undefined] = ACTIONS(3324),
    [anon_sym_AT] = ACTIONS(3324),
    [anon_sym_static] = ACTIONS(3324),
    [anon_sym_readonly] = ACTIONS(3324),
    [anon_sym_get] = ACTIONS(3324),
    [anon_sym_set] = ACTIONS(3324),
    [anon_sym_declare] = ACTIONS(3324),
    [anon_sym_public] = ACTIONS(3324),
    [anon_sym_private] = ACTIONS(3324),
    [anon_sym_protected] = ACTIONS(3324),
    [anon_sym_override] = ACTIONS(3324),
    [anon_sym_module] = ACTIONS(3324),
    [anon_sym_any] = ACTIONS(3324),
    [anon_sym_number] = ACTIONS(3324),
    [anon_sym_boolean] = ACTIONS(3324),
    [anon_sym_string] = ACTIONS(3324),
    [anon_sym_symbol] = ACTIONS(3324),
    [anon_sym_object] = ACTIONS(3324),
    [anon_sym_abstract] = ACTIONS(3324),
    [anon_sym_interface] = ACTIONS(3324),
    [anon_sym_enum] = ACTIONS(3324),
    [sym_html_comment] = ACTIONS(5),
  },
  [1553] = {
    [sym_comment] = STATE(1553),
    [ts_builtin_sym_end] = ACTIONS(3506),
    [sym_identifier] = ACTIONS(3232),
    [anon_sym_export] = ACTIONS(3232),
    [anon_sym_type] = ACTIONS(3232),
    [anon_sym_namespace] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [anon_sym_typeof] = ACTIONS(3232),
    [anon_sym_import] = ACTIONS(3232),
    [anon_sym_with] = ACTIONS(3232),
    [anon_sym_var] = ACTIONS(3232),
    [anon_sym_let] = ACTIONS(3232),
    [anon_sym_const] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_if] = ACTIONS(3232),
    [anon_sym_switch] = ACTIONS(3232),
    [anon_sym_for] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3232),
    [anon_sym_await] = ACTIONS(3232),
    [anon_sym_while] = ACTIONS(3232),
    [anon_sym_do] = ACTIONS(3232),
    [anon_sym_try] = ACTIONS(3232),
    [anon_sym_break] = ACTIONS(3232),
    [anon_sym_continue] = ACTIONS(3232),
    [anon_sym_debugger] = ACTIONS(3232),
    [anon_sym_return] = ACTIONS(3232),
    [anon_sym_throw] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(3232),
    [anon_sym_LBRACK] = ACTIONS(3232),
    [anon_sym_LTtemplate_GT] = ACTIONS(3232),
    [anon_sym_DQUOTE] = ACTIONS(3232),
    [anon_sym_SQUOTE] = ACTIONS(3232),
    [anon_sym_class] = ACTIONS(3232),
    [anon_sym_async] = ACTIONS(3232),
    [anon_sym_function] = ACTIONS(3232),
    [anon_sym_new] = ACTIONS(3232),
    [anon_sym_using] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3232),
    [anon_sym_SLASH] = ACTIONS(3232),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_void] = ACTIONS(3232),
    [anon_sym_delete] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3232),
    [sym_number] = ACTIONS(3232),
    [sym_private_property_identifier] = ACTIONS(3232),
    [sym_this] = ACTIONS(3232),
    [sym_super] = ACTIONS(3232),
    [sym_true] = ACTIONS(3232),
    [sym_false] = ACTIONS(3232),
    [sym_null] = ACTIONS(3232),
    [sym_undefined] = ACTIONS(3232),
    [anon_sym_AT] = ACTIONS(3232),
    [anon_sym_static] = ACTIONS(3232),
    [anon_sym_readonly] = ACTIONS(3232),
    [anon_sym_get] = ACTIONS(3232),
    [anon_sym_set] = ACTIONS(3232),
    [anon_sym_declare] = ACTIONS(3232),
    [anon_sym_public] = ACTIONS(3232),
    [anon_sym_private] = ACTIONS(3232),
    [anon_sym_protected] = ACTIONS(3232),
    [anon_sym_override] = ACTIONS(3232),
    [anon_sym_module] = ACTIONS(3232),
    [anon_sym_any] = ACTIONS(3232),
    [anon_sym_number] = ACTIONS(3232),
    [anon_sym_boolean] = ACTIONS(3232),
    [anon_sym_string] = ACTIONS(3232),
    [anon_sym_symbol] = ACTIONS(3232),
    [anon_sym_object] = ACTIONS(3232),
    [anon_sym_abstract] = ACTIONS(3232),
    [anon_sym_interface] = ACTIONS(3232),
    [anon_sym_enum] = ACTIONS(3232),
    [sym_html_comment] = ACTIONS(5),
  },
  [1554] = {
    [sym_comment] = STATE(1554),
    [ts_builtin_sym_end] = ACTIONS(3586),
    [sym_identifier] = ACTIONS(3132),
    [anon_sym_export] = ACTIONS(3132),
    [anon_sym_type] = ACTIONS(3132),
    [anon_sym_namespace] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_typeof] = ACTIONS(3132),
    [anon_sym_import] = ACTIONS(3132),
    [anon_sym_with] = ACTIONS(3132),
    [anon_sym_var] = ACTIONS(3132),
    [anon_sym_let] = ACTIONS(3132),
    [anon_sym_const] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_switch] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [anon_sym_await] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_do] = ACTIONS(3132),
    [anon_sym_try] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_continue] = ACTIONS(3132),
    [anon_sym_debugger] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_throw] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_yield] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_LTtemplate_GT] = ACTIONS(3132),
    [anon_sym_DQUOTE] = ACTIONS(3132),
    [anon_sym_SQUOTE] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_async] = ACTIONS(3132),
    [anon_sym_function] = ACTIONS(3132),
    [anon_sym_new] = ACTIONS(3132),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3132),
    [anon_sym_DASH] = ACTIONS(3132),
    [anon_sym_SLASH] = ACTIONS(3132),
    [anon_sym_LT] = ACTIONS(3132),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_void] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3132),
    [sym_number] = ACTIONS(3132),
    [sym_private_property_identifier] = ACTIONS(3132),
    [sym_this] = ACTIONS(3132),
    [sym_super] = ACTIONS(3132),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [sym_null] = ACTIONS(3132),
    [sym_undefined] = ACTIONS(3132),
    [anon_sym_AT] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_readonly] = ACTIONS(3132),
    [anon_sym_get] = ACTIONS(3132),
    [anon_sym_set] = ACTIONS(3132),
    [anon_sym_declare] = ACTIONS(3132),
    [anon_sym_public] = ACTIONS(3132),
    [anon_sym_private] = ACTIONS(3132),
    [anon_sym_protected] = ACTIONS(3132),
    [anon_sym_override] = ACTIONS(3132),
    [anon_sym_module] = ACTIONS(3132),
    [anon_sym_any] = ACTIONS(3132),
    [anon_sym_number] = ACTIONS(3132),
    [anon_sym_boolean] = ACTIONS(3132),
    [anon_sym_string] = ACTIONS(3132),
    [anon_sym_symbol] = ACTIONS(3132),
    [anon_sym_object] = ACTIONS(3132),
    [anon_sym_abstract] = ACTIONS(3132),
    [anon_sym_interface] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1555] = {
    [sym_comment] = STATE(1555),
    [ts_builtin_sym_end] = ACTIONS(2115),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_using] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_private_property_identifier] = ACTIONS(2111),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1556] = {
    [sym_comment] = STATE(1556),
    [ts_builtin_sym_end] = ACTIONS(3588),
    [sym_identifier] = ACTIONS(3434),
    [anon_sym_export] = ACTIONS(3434),
    [anon_sym_type] = ACTIONS(3434),
    [anon_sym_namespace] = ACTIONS(3434),
    [anon_sym_LBRACE] = ACTIONS(3434),
    [anon_sym_RBRACE] = ACTIONS(3434),
    [anon_sym_typeof] = ACTIONS(3434),
    [anon_sym_import] = ACTIONS(3434),
    [anon_sym_with] = ACTIONS(3434),
    [anon_sym_var] = ACTIONS(3434),
    [anon_sym_let] = ACTIONS(3434),
    [anon_sym_const] = ACTIONS(3434),
    [anon_sym_BANG] = ACTIONS(3434),
    [anon_sym_if] = ACTIONS(3434),
    [anon_sym_switch] = ACTIONS(3434),
    [anon_sym_for] = ACTIONS(3434),
    [anon_sym_LPAREN] = ACTIONS(3434),
    [anon_sym_await] = ACTIONS(3434),
    [anon_sym_while] = ACTIONS(3434),
    [anon_sym_do] = ACTIONS(3434),
    [anon_sym_try] = ACTIONS(3434),
    [anon_sym_break] = ACTIONS(3434),
    [anon_sym_continue] = ACTIONS(3434),
    [anon_sym_debugger] = ACTIONS(3434),
    [anon_sym_return] = ACTIONS(3434),
    [anon_sym_throw] = ACTIONS(3434),
    [anon_sym_SEMI] = ACTIONS(3434),
    [anon_sym_yield] = ACTIONS(3434),
    [anon_sym_LBRACK] = ACTIONS(3434),
    [anon_sym_LTtemplate_GT] = ACTIONS(3434),
    [anon_sym_DQUOTE] = ACTIONS(3434),
    [anon_sym_SQUOTE] = ACTIONS(3434),
    [anon_sym_class] = ACTIONS(3434),
    [anon_sym_async] = ACTIONS(3434),
    [anon_sym_function] = ACTIONS(3434),
    [anon_sym_new] = ACTIONS(3434),
    [anon_sym_using] = ACTIONS(3434),
    [anon_sym_PLUS] = ACTIONS(3434),
    [anon_sym_DASH] = ACTIONS(3434),
    [anon_sym_SLASH] = ACTIONS(3434),
    [anon_sym_LT] = ACTIONS(3434),
    [anon_sym_TILDE] = ACTIONS(3434),
    [anon_sym_void] = ACTIONS(3434),
    [anon_sym_delete] = ACTIONS(3434),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3434),
    [sym_number] = ACTIONS(3434),
    [sym_private_property_identifier] = ACTIONS(3434),
    [sym_this] = ACTIONS(3434),
    [sym_super] = ACTIONS(3434),
    [sym_true] = ACTIONS(3434),
    [sym_false] = ACTIONS(3434),
    [sym_null] = ACTIONS(3434),
    [sym_undefined] = ACTIONS(3434),
    [anon_sym_AT] = ACTIONS(3434),
    [anon_sym_static] = ACTIONS(3434),
    [anon_sym_readonly] = ACTIONS(3434),
    [anon_sym_get] = ACTIONS(3434),
    [anon_sym_set] = ACTIONS(3434),
    [anon_sym_declare] = ACTIONS(3434),
    [anon_sym_public] = ACTIONS(3434),
    [anon_sym_private] = ACTIONS(3434),
    [anon_sym_protected] = ACTIONS(3434),
    [anon_sym_override] = ACTIONS(3434),
    [anon_sym_module] = ACTIONS(3434),
    [anon_sym_any] = ACTIONS(3434),
    [anon_sym_number] = ACTIONS(3434),
    [anon_sym_boolean] = ACTIONS(3434),
    [anon_sym_string] = ACTIONS(3434),
    [anon_sym_symbol] = ACTIONS(3434),
    [anon_sym_object] = ACTIONS(3434),
    [anon_sym_abstract] = ACTIONS(3434),
    [anon_sym_interface] = ACTIONS(3434),
    [anon_sym_enum] = ACTIONS(3434),
    [sym_html_comment] = ACTIONS(5),
  },
  [1557] = {
    [sym_comment] = STATE(1557),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym_html_comment] = ACTIONS(5),
  },
  [1558] = {
    [sym_comment] = STATE(1558),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [sym_identifier] = ACTIONS(2149),
    [anon_sym_export] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2149),
    [anon_sym_namespace] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2149),
    [anon_sym_import] = ACTIONS(2149),
    [anon_sym_with] = ACTIONS(2149),
    [anon_sym_var] = ACTIONS(2149),
    [anon_sym_let] = ACTIONS(2149),
    [anon_sym_const] = ACTIONS(2149),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_for] = ACTIONS(2149),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2149),
    [anon_sym_while] = ACTIONS(2149),
    [anon_sym_do] = ACTIONS(2149),
    [anon_sym_try] = ACTIONS(2149),
    [anon_sym_break] = ACTIONS(2149),
    [anon_sym_continue] = ACTIONS(2149),
    [anon_sym_debugger] = ACTIONS(2149),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_throw] = ACTIONS(2149),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2149),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LTtemplate_GT] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [anon_sym_class] = ACTIONS(2149),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2149),
    [anon_sym_new] = ACTIONS(2149),
    [anon_sym_using] = ACTIONS(2149),
    [anon_sym_PLUS] = ACTIONS(2149),
    [anon_sym_DASH] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2149),
    [anon_sym_delete] = ACTIONS(2149),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_private_property_identifier] = ACTIONS(2149),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(2149),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2149),
    [anon_sym_readonly] = ACTIONS(2149),
    [anon_sym_get] = ACTIONS(2149),
    [anon_sym_set] = ACTIONS(2149),
    [anon_sym_declare] = ACTIONS(2149),
    [anon_sym_public] = ACTIONS(2149),
    [anon_sym_private] = ACTIONS(2149),
    [anon_sym_protected] = ACTIONS(2149),
    [anon_sym_override] = ACTIONS(2149),
    [anon_sym_module] = ACTIONS(2149),
    [anon_sym_any] = ACTIONS(2149),
    [anon_sym_number] = ACTIONS(2149),
    [anon_sym_boolean] = ACTIONS(2149),
    [anon_sym_string] = ACTIONS(2149),
    [anon_sym_symbol] = ACTIONS(2149),
    [anon_sym_object] = ACTIONS(2149),
    [anon_sym_abstract] = ACTIONS(2149),
    [anon_sym_interface] = ACTIONS(2149),
    [anon_sym_enum] = ACTIONS(2149),
    [sym_html_comment] = ACTIONS(5),
  },
  [1559] = {
    [sym_comment] = STATE(1559),
    [ts_builtin_sym_end] = ACTIONS(3452),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_export] = ACTIONS(3294),
    [anon_sym_type] = ACTIONS(3294),
    [anon_sym_namespace] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3294),
    [anon_sym_RBRACE] = ACTIONS(3294),
    [anon_sym_typeof] = ACTIONS(3294),
    [anon_sym_import] = ACTIONS(3294),
    [anon_sym_with] = ACTIONS(3294),
    [anon_sym_var] = ACTIONS(3294),
    [anon_sym_let] = ACTIONS(3294),
    [anon_sym_const] = ACTIONS(3294),
    [anon_sym_BANG] = ACTIONS(3294),
    [anon_sym_if] = ACTIONS(3294),
    [anon_sym_switch] = ACTIONS(3294),
    [anon_sym_for] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3294),
    [anon_sym_await] = ACTIONS(3294),
    [anon_sym_while] = ACTIONS(3294),
    [anon_sym_do] = ACTIONS(3294),
    [anon_sym_try] = ACTIONS(3294),
    [anon_sym_break] = ACTIONS(3294),
    [anon_sym_continue] = ACTIONS(3294),
    [anon_sym_debugger] = ACTIONS(3294),
    [anon_sym_return] = ACTIONS(3294),
    [anon_sym_throw] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(3294),
    [anon_sym_yield] = ACTIONS(3294),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_LTtemplate_GT] = ACTIONS(3294),
    [anon_sym_DQUOTE] = ACTIONS(3294),
    [anon_sym_SQUOTE] = ACTIONS(3294),
    [anon_sym_class] = ACTIONS(3294),
    [anon_sym_async] = ACTIONS(3294),
    [anon_sym_function] = ACTIONS(3294),
    [anon_sym_new] = ACTIONS(3294),
    [anon_sym_using] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_TILDE] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(3294),
    [anon_sym_delete] = ACTIONS(3294),
    [anon_sym_PLUS_PLUS] = ACTIONS(3294),
    [anon_sym_DASH_DASH] = ACTIONS(3294),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3294),
    [sym_number] = ACTIONS(3294),
    [sym_private_property_identifier] = ACTIONS(3294),
    [sym_this] = ACTIONS(3294),
    [sym_super] = ACTIONS(3294),
    [sym_true] = ACTIONS(3294),
    [sym_false] = ACTIONS(3294),
    [sym_null] = ACTIONS(3294),
    [sym_undefined] = ACTIONS(3294),
    [anon_sym_AT] = ACTIONS(3294),
    [anon_sym_static] = ACTIONS(3294),
    [anon_sym_readonly] = ACTIONS(3294),
    [anon_sym_get] = ACTIONS(3294),
    [anon_sym_set] = ACTIONS(3294),
    [anon_sym_declare] = ACTIONS(3294),
    [anon_sym_public] = ACTIONS(3294),
    [anon_sym_private] = ACTIONS(3294),
    [anon_sym_protected] = ACTIONS(3294),
    [anon_sym_override] = ACTIONS(3294),
    [anon_sym_module] = ACTIONS(3294),
    [anon_sym_any] = ACTIONS(3294),
    [anon_sym_number] = ACTIONS(3294),
    [anon_sym_boolean] = ACTIONS(3294),
    [anon_sym_string] = ACTIONS(3294),
    [anon_sym_symbol] = ACTIONS(3294),
    [anon_sym_object] = ACTIONS(3294),
    [anon_sym_abstract] = ACTIONS(3294),
    [anon_sym_interface] = ACTIONS(3294),
    [anon_sym_enum] = ACTIONS(3294),
    [sym_html_comment] = ACTIONS(5),
  },
  [1560] = {
    [sym_comment] = STATE(1560),
    [ts_builtin_sym_end] = ACTIONS(3372),
    [sym_identifier] = ACTIONS(3194),
    [anon_sym_export] = ACTIONS(3194),
    [anon_sym_type] = ACTIONS(3194),
    [anon_sym_namespace] = ACTIONS(3194),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3194),
    [anon_sym_typeof] = ACTIONS(3194),
    [anon_sym_import] = ACTIONS(3194),
    [anon_sym_with] = ACTIONS(3194),
    [anon_sym_var] = ACTIONS(3194),
    [anon_sym_let] = ACTIONS(3194),
    [anon_sym_const] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_if] = ACTIONS(3194),
    [anon_sym_switch] = ACTIONS(3194),
    [anon_sym_for] = ACTIONS(3194),
    [anon_sym_LPAREN] = ACTIONS(3194),
    [anon_sym_await] = ACTIONS(3194),
    [anon_sym_while] = ACTIONS(3194),
    [anon_sym_do] = ACTIONS(3194),
    [anon_sym_try] = ACTIONS(3194),
    [anon_sym_break] = ACTIONS(3194),
    [anon_sym_continue] = ACTIONS(3194),
    [anon_sym_debugger] = ACTIONS(3194),
    [anon_sym_return] = ACTIONS(3194),
    [anon_sym_throw] = ACTIONS(3194),
    [anon_sym_SEMI] = ACTIONS(3194),
    [anon_sym_yield] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3194),
    [anon_sym_LTtemplate_GT] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3194),
    [anon_sym_SQUOTE] = ACTIONS(3194),
    [anon_sym_class] = ACTIONS(3194),
    [anon_sym_async] = ACTIONS(3194),
    [anon_sym_function] = ACTIONS(3194),
    [anon_sym_new] = ACTIONS(3194),
    [anon_sym_using] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3194),
    [anon_sym_SLASH] = ACTIONS(3194),
    [anon_sym_LT] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_void] = ACTIONS(3194),
    [anon_sym_delete] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3194),
    [anon_sym_DASH_DASH] = ACTIONS(3194),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3194),
    [sym_number] = ACTIONS(3194),
    [sym_private_property_identifier] = ACTIONS(3194),
    [sym_this] = ACTIONS(3194),
    [sym_super] = ACTIONS(3194),
    [sym_true] = ACTIONS(3194),
    [sym_false] = ACTIONS(3194),
    [sym_null] = ACTIONS(3194),
    [sym_undefined] = ACTIONS(3194),
    [anon_sym_AT] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3194),
    [anon_sym_readonly] = ACTIONS(3194),
    [anon_sym_get] = ACTIONS(3194),
    [anon_sym_set] = ACTIONS(3194),
    [anon_sym_declare] = ACTIONS(3194),
    [anon_sym_public] = ACTIONS(3194),
    [anon_sym_private] = ACTIONS(3194),
    [anon_sym_protected] = ACTIONS(3194),
    [anon_sym_override] = ACTIONS(3194),
    [anon_sym_module] = ACTIONS(3194),
    [anon_sym_any] = ACTIONS(3194),
    [anon_sym_number] = ACTIONS(3194),
    [anon_sym_boolean] = ACTIONS(3194),
    [anon_sym_string] = ACTIONS(3194),
    [anon_sym_symbol] = ACTIONS(3194),
    [anon_sym_object] = ACTIONS(3194),
    [anon_sym_abstract] = ACTIONS(3194),
    [anon_sym_interface] = ACTIONS(3194),
    [anon_sym_enum] = ACTIONS(3194),
    [sym_html_comment] = ACTIONS(5),
  },
  [1561] = {
    [sym_comment] = STATE(1561),
    [ts_builtin_sym_end] = ACTIONS(3538),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_export] = ACTIONS(3316),
    [anon_sym_type] = ACTIONS(3316),
    [anon_sym_namespace] = ACTIONS(3316),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_typeof] = ACTIONS(3316),
    [anon_sym_import] = ACTIONS(3316),
    [anon_sym_with] = ACTIONS(3316),
    [anon_sym_var] = ACTIONS(3316),
    [anon_sym_let] = ACTIONS(3316),
    [anon_sym_const] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_if] = ACTIONS(3316),
    [anon_sym_switch] = ACTIONS(3316),
    [anon_sym_for] = ACTIONS(3316),
    [anon_sym_LPAREN] = ACTIONS(3316),
    [anon_sym_await] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(3316),
    [anon_sym_do] = ACTIONS(3316),
    [anon_sym_try] = ACTIONS(3316),
    [anon_sym_break] = ACTIONS(3316),
    [anon_sym_continue] = ACTIONS(3316),
    [anon_sym_debugger] = ACTIONS(3316),
    [anon_sym_return] = ACTIONS(3316),
    [anon_sym_throw] = ACTIONS(3316),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym_yield] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_LTtemplate_GT] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3316),
    [anon_sym_class] = ACTIONS(3316),
    [anon_sym_async] = ACTIONS(3316),
    [anon_sym_function] = ACTIONS(3316),
    [anon_sym_new] = ACTIONS(3316),
    [anon_sym_using] = ACTIONS(3316),
    [anon_sym_PLUS] = ACTIONS(3316),
    [anon_sym_DASH] = ACTIONS(3316),
    [anon_sym_SLASH] = ACTIONS(3316),
    [anon_sym_LT] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3316),
    [anon_sym_void] = ACTIONS(3316),
    [anon_sym_delete] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3316),
    [sym_number] = ACTIONS(3316),
    [sym_private_property_identifier] = ACTIONS(3316),
    [sym_this] = ACTIONS(3316),
    [sym_super] = ACTIONS(3316),
    [sym_true] = ACTIONS(3316),
    [sym_false] = ACTIONS(3316),
    [sym_null] = ACTIONS(3316),
    [sym_undefined] = ACTIONS(3316),
    [anon_sym_AT] = ACTIONS(3316),
    [anon_sym_static] = ACTIONS(3316),
    [anon_sym_readonly] = ACTIONS(3316),
    [anon_sym_get] = ACTIONS(3316),
    [anon_sym_set] = ACTIONS(3316),
    [anon_sym_declare] = ACTIONS(3316),
    [anon_sym_public] = ACTIONS(3316),
    [anon_sym_private] = ACTIONS(3316),
    [anon_sym_protected] = ACTIONS(3316),
    [anon_sym_override] = ACTIONS(3316),
    [anon_sym_module] = ACTIONS(3316),
    [anon_sym_any] = ACTIONS(3316),
    [anon_sym_number] = ACTIONS(3316),
    [anon_sym_boolean] = ACTIONS(3316),
    [anon_sym_string] = ACTIONS(3316),
    [anon_sym_symbol] = ACTIONS(3316),
    [anon_sym_object] = ACTIONS(3316),
    [anon_sym_abstract] = ACTIONS(3316),
    [anon_sym_interface] = ACTIONS(3316),
    [anon_sym_enum] = ACTIONS(3316),
    [sym_html_comment] = ACTIONS(5),
  },
  [1562] = {
    [sym_comment] = STATE(1562),
    [ts_builtin_sym_end] = ACTIONS(3444),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_export] = ACTIONS(3292),
    [anon_sym_type] = ACTIONS(3292),
    [anon_sym_namespace] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(3292),
    [anon_sym_RBRACE] = ACTIONS(3292),
    [anon_sym_typeof] = ACTIONS(3292),
    [anon_sym_import] = ACTIONS(3292),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_var] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_const] = ACTIONS(3292),
    [anon_sym_BANG] = ACTIONS(3292),
    [anon_sym_if] = ACTIONS(3292),
    [anon_sym_switch] = ACTIONS(3292),
    [anon_sym_for] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_await] = ACTIONS(3292),
    [anon_sym_while] = ACTIONS(3292),
    [anon_sym_do] = ACTIONS(3292),
    [anon_sym_try] = ACTIONS(3292),
    [anon_sym_break] = ACTIONS(3292),
    [anon_sym_continue] = ACTIONS(3292),
    [anon_sym_debugger] = ACTIONS(3292),
    [anon_sym_return] = ACTIONS(3292),
    [anon_sym_throw] = ACTIONS(3292),
    [anon_sym_SEMI] = ACTIONS(3292),
    [anon_sym_yield] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LTtemplate_GT] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [anon_sym_class] = ACTIONS(3292),
    [anon_sym_async] = ACTIONS(3292),
    [anon_sym_function] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3292),
    [anon_sym_using] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3292),
    [anon_sym_DASH] = ACTIONS(3292),
    [anon_sym_SLASH] = ACTIONS(3292),
    [anon_sym_LT] = ACTIONS(3292),
    [anon_sym_TILDE] = ACTIONS(3292),
    [anon_sym_void] = ACTIONS(3292),
    [anon_sym_delete] = ACTIONS(3292),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3292),
    [sym_number] = ACTIONS(3292),
    [sym_private_property_identifier] = ACTIONS(3292),
    [sym_this] = ACTIONS(3292),
    [sym_super] = ACTIONS(3292),
    [sym_true] = ACTIONS(3292),
    [sym_false] = ACTIONS(3292),
    [sym_null] = ACTIONS(3292),
    [sym_undefined] = ACTIONS(3292),
    [anon_sym_AT] = ACTIONS(3292),
    [anon_sym_static] = ACTIONS(3292),
    [anon_sym_readonly] = ACTIONS(3292),
    [anon_sym_get] = ACTIONS(3292),
    [anon_sym_set] = ACTIONS(3292),
    [anon_sym_declare] = ACTIONS(3292),
    [anon_sym_public] = ACTIONS(3292),
    [anon_sym_private] = ACTIONS(3292),
    [anon_sym_protected] = ACTIONS(3292),
    [anon_sym_override] = ACTIONS(3292),
    [anon_sym_module] = ACTIONS(3292),
    [anon_sym_any] = ACTIONS(3292),
    [anon_sym_number] = ACTIONS(3292),
    [anon_sym_boolean] = ACTIONS(3292),
    [anon_sym_string] = ACTIONS(3292),
    [anon_sym_symbol] = ACTIONS(3292),
    [anon_sym_object] = ACTIONS(3292),
    [anon_sym_abstract] = ACTIONS(3292),
    [anon_sym_interface] = ACTIONS(3292),
    [anon_sym_enum] = ACTIONS(3292),
    [sym_html_comment] = ACTIONS(5),
  },
  [1563] = {
    [sym_comment] = STATE(1563),
    [ts_builtin_sym_end] = ACTIONS(2253),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_export] = ACTIONS(2251),
    [anon_sym_type] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_typeof] = ACTIONS(2251),
    [anon_sym_import] = ACTIONS(2251),
    [anon_sym_with] = ACTIONS(2251),
    [anon_sym_var] = ACTIONS(2251),
    [anon_sym_let] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_BANG] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(2251),
    [anon_sym_await] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_debugger] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2251),
    [anon_sym_yield] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_LTtemplate_GT] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(2251),
    [anon_sym_SQUOTE] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_async] = ACTIONS(2251),
    [anon_sym_function] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_SLASH] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2251),
    [anon_sym_TILDE] = ACTIONS(2251),
    [anon_sym_void] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_PLUS_PLUS] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2251),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_number] = ACTIONS(2251),
    [sym_private_property_identifier] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [sym_super] = ACTIONS(2251),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [sym_null] = ACTIONS(2251),
    [sym_undefined] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_readonly] = ACTIONS(2251),
    [anon_sym_get] = ACTIONS(2251),
    [anon_sym_set] = ACTIONS(2251),
    [anon_sym_declare] = ACTIONS(2251),
    [anon_sym_public] = ACTIONS(2251),
    [anon_sym_private] = ACTIONS(2251),
    [anon_sym_protected] = ACTIONS(2251),
    [anon_sym_override] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2251),
    [anon_sym_any] = ACTIONS(2251),
    [anon_sym_number] = ACTIONS(2251),
    [anon_sym_boolean] = ACTIONS(2251),
    [anon_sym_string] = ACTIONS(2251),
    [anon_sym_symbol] = ACTIONS(2251),
    [anon_sym_object] = ACTIONS(2251),
    [anon_sym_abstract] = ACTIONS(2251),
    [anon_sym_interface] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [sym_html_comment] = ACTIONS(5),
  },
  [1564] = {
    [sym_comment] = STATE(1564),
    [ts_builtin_sym_end] = ACTIONS(2147),
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LTtemplate_GT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_private_property_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_readonly] = ACTIONS(2145),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
    [anon_sym_declare] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_override] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_any] = ACTIONS(2145),
    [anon_sym_number] = ACTIONS(2145),
    [anon_sym_boolean] = ACTIONS(2145),
    [anon_sym_string] = ACTIONS(2145),
    [anon_sym_symbol] = ACTIONS(2145),
    [anon_sym_object] = ACTIONS(2145),
    [anon_sym_abstract] = ACTIONS(2145),
    [anon_sym_interface] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [sym_html_comment] = ACTIONS(5),
  },
  [1565] = {
    [sym_comment] = STATE(1565),
    [ts_builtin_sym_end] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_export] = ACTIONS(3214),
    [anon_sym_type] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3214),
    [anon_sym_RBRACE] = ACTIONS(3214),
    [anon_sym_typeof] = ACTIONS(3214),
    [anon_sym_import] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3214),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [anon_sym_BANG] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3214),
    [anon_sym_await] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_debugger] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_LTtemplate_GT] = ACTIONS(3214),
    [anon_sym_DQUOTE] = ACTIONS(3214),
    [anon_sym_SQUOTE] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_using] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_SLASH] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3214),
    [anon_sym_void] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_PLUS_PLUS] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3214),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3214),
    [sym_number] = ACTIONS(3214),
    [sym_private_property_identifier] = ACTIONS(3214),
    [sym_this] = ACTIONS(3214),
    [sym_super] = ACTIONS(3214),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [sym_null] = ACTIONS(3214),
    [sym_undefined] = ACTIONS(3214),
    [anon_sym_AT] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_readonly] = ACTIONS(3214),
    [anon_sym_get] = ACTIONS(3214),
    [anon_sym_set] = ACTIONS(3214),
    [anon_sym_declare] = ACTIONS(3214),
    [anon_sym_public] = ACTIONS(3214),
    [anon_sym_private] = ACTIONS(3214),
    [anon_sym_protected] = ACTIONS(3214),
    [anon_sym_override] = ACTIONS(3214),
    [anon_sym_module] = ACTIONS(3214),
    [anon_sym_any] = ACTIONS(3214),
    [anon_sym_number] = ACTIONS(3214),
    [anon_sym_boolean] = ACTIONS(3214),
    [anon_sym_string] = ACTIONS(3214),
    [anon_sym_symbol] = ACTIONS(3214),
    [anon_sym_object] = ACTIONS(3214),
    [anon_sym_abstract] = ACTIONS(3214),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [sym_html_comment] = ACTIONS(5),
  },
  [1566] = {
    [sym_comment] = STATE(1566),
    [ts_builtin_sym_end] = ACTIONS(3540),
    [sym_identifier] = ACTIONS(3222),
    [anon_sym_export] = ACTIONS(3222),
    [anon_sym_type] = ACTIONS(3222),
    [anon_sym_namespace] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3222),
    [anon_sym_RBRACE] = ACTIONS(3222),
    [anon_sym_typeof] = ACTIONS(3222),
    [anon_sym_import] = ACTIONS(3222),
    [anon_sym_with] = ACTIONS(3222),
    [anon_sym_var] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_const] = ACTIONS(3222),
    [anon_sym_BANG] = ACTIONS(3222),
    [anon_sym_if] = ACTIONS(3222),
    [anon_sym_switch] = ACTIONS(3222),
    [anon_sym_for] = ACTIONS(3222),
    [anon_sym_LPAREN] = ACTIONS(3222),
    [anon_sym_await] = ACTIONS(3222),
    [anon_sym_while] = ACTIONS(3222),
    [anon_sym_do] = ACTIONS(3222),
    [anon_sym_try] = ACTIONS(3222),
    [anon_sym_break] = ACTIONS(3222),
    [anon_sym_continue] = ACTIONS(3222),
    [anon_sym_debugger] = ACTIONS(3222),
    [anon_sym_return] = ACTIONS(3222),
    [anon_sym_throw] = ACTIONS(3222),
    [anon_sym_SEMI] = ACTIONS(3222),
    [anon_sym_yield] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3222),
    [anon_sym_LTtemplate_GT] = ACTIONS(3222),
    [anon_sym_DQUOTE] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3222),
    [anon_sym_class] = ACTIONS(3222),
    [anon_sym_async] = ACTIONS(3222),
    [anon_sym_function] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_using] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_SLASH] = ACTIONS(3222),
    [anon_sym_LT] = ACTIONS(3222),
    [anon_sym_TILDE] = ACTIONS(3222),
    [anon_sym_void] = ACTIONS(3222),
    [anon_sym_delete] = ACTIONS(3222),
    [anon_sym_PLUS_PLUS] = ACTIONS(3222),
    [anon_sym_DASH_DASH] = ACTIONS(3222),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3222),
    [sym_number] = ACTIONS(3222),
    [sym_private_property_identifier] = ACTIONS(3222),
    [sym_this] = ACTIONS(3222),
    [sym_super] = ACTIONS(3222),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [sym_null] = ACTIONS(3222),
    [sym_undefined] = ACTIONS(3222),
    [anon_sym_AT] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_readonly] = ACTIONS(3222),
    [anon_sym_get] = ACTIONS(3222),
    [anon_sym_set] = ACTIONS(3222),
    [anon_sym_declare] = ACTIONS(3222),
    [anon_sym_public] = ACTIONS(3222),
    [anon_sym_private] = ACTIONS(3222),
    [anon_sym_protected] = ACTIONS(3222),
    [anon_sym_override] = ACTIONS(3222),
    [anon_sym_module] = ACTIONS(3222),
    [anon_sym_any] = ACTIONS(3222),
    [anon_sym_number] = ACTIONS(3222),
    [anon_sym_boolean] = ACTIONS(3222),
    [anon_sym_string] = ACTIONS(3222),
    [anon_sym_symbol] = ACTIONS(3222),
    [anon_sym_object] = ACTIONS(3222),
    [anon_sym_abstract] = ACTIONS(3222),
    [anon_sym_interface] = ACTIONS(3222),
    [anon_sym_enum] = ACTIONS(3222),
    [sym_html_comment] = ACTIONS(5),
  },
  [1567] = {
    [sym_comment] = STATE(1567),
    [ts_builtin_sym_end] = ACTIONS(3430),
    [sym_identifier] = ACTIONS(3156),
    [anon_sym_export] = ACTIONS(3156),
    [anon_sym_type] = ACTIONS(3156),
    [anon_sym_namespace] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_typeof] = ACTIONS(3156),
    [anon_sym_import] = ACTIONS(3156),
    [anon_sym_with] = ACTIONS(3156),
    [anon_sym_var] = ACTIONS(3156),
    [anon_sym_let] = ACTIONS(3156),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_switch] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3156),
    [anon_sym_await] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_do] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_debugger] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_throw] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_LTtemplate_GT] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_async] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_using] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_SLASH] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_void] = ACTIONS(3156),
    [anon_sym_delete] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [sym_number] = ACTIONS(3156),
    [sym_private_property_identifier] = ACTIONS(3156),
    [sym_this] = ACTIONS(3156),
    [sym_super] = ACTIONS(3156),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [sym_null] = ACTIONS(3156),
    [sym_undefined] = ACTIONS(3156),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_readonly] = ACTIONS(3156),
    [anon_sym_get] = ACTIONS(3156),
    [anon_sym_set] = ACTIONS(3156),
    [anon_sym_declare] = ACTIONS(3156),
    [anon_sym_public] = ACTIONS(3156),
    [anon_sym_private] = ACTIONS(3156),
    [anon_sym_protected] = ACTIONS(3156),
    [anon_sym_override] = ACTIONS(3156),
    [anon_sym_module] = ACTIONS(3156),
    [anon_sym_any] = ACTIONS(3156),
    [anon_sym_number] = ACTIONS(3156),
    [anon_sym_boolean] = ACTIONS(3156),
    [anon_sym_string] = ACTIONS(3156),
    [anon_sym_symbol] = ACTIONS(3156),
    [anon_sym_object] = ACTIONS(3156),
    [anon_sym_abstract] = ACTIONS(3156),
    [anon_sym_interface] = ACTIONS(3156),
    [anon_sym_enum] = ACTIONS(3156),
    [sym_html_comment] = ACTIONS(5),
  },
  [1568] = {
    [sym_comment] = STATE(1568),
    [ts_builtin_sym_end] = ACTIONS(3436),
    [sym_identifier] = ACTIONS(3154),
    [anon_sym_export] = ACTIONS(3154),
    [anon_sym_type] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_typeof] = ACTIONS(3154),
    [anon_sym_import] = ACTIONS(3154),
    [anon_sym_with] = ACTIONS(3154),
    [anon_sym_var] = ACTIONS(3154),
    [anon_sym_let] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_await] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_debugger] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_yield] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LTtemplate_GT] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_async] = ACTIONS(3154),
    [anon_sym_function] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_SLASH] = ACTIONS(3154),
    [anon_sym_LT] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_void] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3154),
    [sym_number] = ACTIONS(3154),
    [sym_private_property_identifier] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
    [sym_super] = ACTIONS(3154),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [sym_null] = ACTIONS(3154),
    [sym_undefined] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_readonly] = ACTIONS(3154),
    [anon_sym_get] = ACTIONS(3154),
    [anon_sym_set] = ACTIONS(3154),
    [anon_sym_declare] = ACTIONS(3154),
    [anon_sym_public] = ACTIONS(3154),
    [anon_sym_private] = ACTIONS(3154),
    [anon_sym_protected] = ACTIONS(3154),
    [anon_sym_override] = ACTIONS(3154),
    [anon_sym_module] = ACTIONS(3154),
    [anon_sym_any] = ACTIONS(3154),
    [anon_sym_number] = ACTIONS(3154),
    [anon_sym_boolean] = ACTIONS(3154),
    [anon_sym_string] = ACTIONS(3154),
    [anon_sym_symbol] = ACTIONS(3154),
    [anon_sym_object] = ACTIONS(3154),
    [anon_sym_abstract] = ACTIONS(3154),
    [anon_sym_interface] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [sym_html_comment] = ACTIONS(5),
  },
  [1569] = {
    [sym_comment] = STATE(1569),
    [ts_builtin_sym_end] = ACTIONS(3464),
    [sym_identifier] = ACTIONS(3218),
    [anon_sym_export] = ACTIONS(3218),
    [anon_sym_type] = ACTIONS(3218),
    [anon_sym_namespace] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_RBRACE] = ACTIONS(3218),
    [anon_sym_typeof] = ACTIONS(3218),
    [anon_sym_import] = ACTIONS(3218),
    [anon_sym_with] = ACTIONS(3218),
    [anon_sym_var] = ACTIONS(3218),
    [anon_sym_let] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3218),
    [anon_sym_BANG] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_switch] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_LPAREN] = ACTIONS(3218),
    [anon_sym_await] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_debugger] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_throw] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3218),
    [anon_sym_yield] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3218),
    [anon_sym_LTtemplate_GT] = ACTIONS(3218),
    [anon_sym_DQUOTE] = ACTIONS(3218),
    [anon_sym_SQUOTE] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_async] = ACTIONS(3218),
    [anon_sym_function] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_using] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_SLASH] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3218),
    [anon_sym_TILDE] = ACTIONS(3218),
    [anon_sym_void] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3218),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3218),
    [sym_number] = ACTIONS(3218),
    [sym_private_property_identifier] = ACTIONS(3218),
    [sym_this] = ACTIONS(3218),
    [sym_super] = ACTIONS(3218),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [sym_null] = ACTIONS(3218),
    [sym_undefined] = ACTIONS(3218),
    [anon_sym_AT] = ACTIONS(3218),
    [anon_sym_static] = ACTIONS(3218),
    [anon_sym_readonly] = ACTIONS(3218),
    [anon_sym_get] = ACTIONS(3218),
    [anon_sym_set] = ACTIONS(3218),
    [anon_sym_declare] = ACTIONS(3218),
    [anon_sym_public] = ACTIONS(3218),
    [anon_sym_private] = ACTIONS(3218),
    [anon_sym_protected] = ACTIONS(3218),
    [anon_sym_override] = ACTIONS(3218),
    [anon_sym_module] = ACTIONS(3218),
    [anon_sym_any] = ACTIONS(3218),
    [anon_sym_number] = ACTIONS(3218),
    [anon_sym_boolean] = ACTIONS(3218),
    [anon_sym_string] = ACTIONS(3218),
    [anon_sym_symbol] = ACTIONS(3218),
    [anon_sym_object] = ACTIONS(3218),
    [anon_sym_abstract] = ACTIONS(3218),
    [anon_sym_interface] = ACTIONS(3218),
    [anon_sym_enum] = ACTIONS(3218),
    [sym_html_comment] = ACTIONS(5),
  },
  [1570] = {
    [sym_comment] = STATE(1570),
    [ts_builtin_sym_end] = ACTIONS(3570),
    [sym_identifier] = ACTIONS(3236),
    [anon_sym_export] = ACTIONS(3236),
    [anon_sym_type] = ACTIONS(3236),
    [anon_sym_namespace] = ACTIONS(3236),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_RBRACE] = ACTIONS(3236),
    [anon_sym_typeof] = ACTIONS(3236),
    [anon_sym_import] = ACTIONS(3236),
    [anon_sym_with] = ACTIONS(3236),
    [anon_sym_var] = ACTIONS(3236),
    [anon_sym_let] = ACTIONS(3236),
    [anon_sym_const] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_if] = ACTIONS(3236),
    [anon_sym_switch] = ACTIONS(3236),
    [anon_sym_for] = ACTIONS(3236),
    [anon_sym_LPAREN] = ACTIONS(3236),
    [anon_sym_await] = ACTIONS(3236),
    [anon_sym_while] = ACTIONS(3236),
    [anon_sym_do] = ACTIONS(3236),
    [anon_sym_try] = ACTIONS(3236),
    [anon_sym_break] = ACTIONS(3236),
    [anon_sym_continue] = ACTIONS(3236),
    [anon_sym_debugger] = ACTIONS(3236),
    [anon_sym_return] = ACTIONS(3236),
    [anon_sym_throw] = ACTIONS(3236),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym_yield] = ACTIONS(3236),
    [anon_sym_LBRACK] = ACTIONS(3236),
    [anon_sym_LTtemplate_GT] = ACTIONS(3236),
    [anon_sym_DQUOTE] = ACTIONS(3236),
    [anon_sym_SQUOTE] = ACTIONS(3236),
    [anon_sym_class] = ACTIONS(3236),
    [anon_sym_async] = ACTIONS(3236),
    [anon_sym_function] = ACTIONS(3236),
    [anon_sym_new] = ACTIONS(3236),
    [anon_sym_using] = ACTIONS(3236),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3236),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_void] = ACTIONS(3236),
    [anon_sym_delete] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3236),
    [anon_sym_DASH_DASH] = ACTIONS(3236),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3236),
    [sym_number] = ACTIONS(3236),
    [sym_private_property_identifier] = ACTIONS(3236),
    [sym_this] = ACTIONS(3236),
    [sym_super] = ACTIONS(3236),
    [sym_true] = ACTIONS(3236),
    [sym_false] = ACTIONS(3236),
    [sym_null] = ACTIONS(3236),
    [sym_undefined] = ACTIONS(3236),
    [anon_sym_AT] = ACTIONS(3236),
    [anon_sym_static] = ACTIONS(3236),
    [anon_sym_readonly] = ACTIONS(3236),
    [anon_sym_get] = ACTIONS(3236),
    [anon_sym_set] = ACTIONS(3236),
    [anon_sym_declare] = ACTIONS(3236),
    [anon_sym_public] = ACTIONS(3236),
    [anon_sym_private] = ACTIONS(3236),
    [anon_sym_protected] = ACTIONS(3236),
    [anon_sym_override] = ACTIONS(3236),
    [anon_sym_module] = ACTIONS(3236),
    [anon_sym_any] = ACTIONS(3236),
    [anon_sym_number] = ACTIONS(3236),
    [anon_sym_boolean] = ACTIONS(3236),
    [anon_sym_string] = ACTIONS(3236),
    [anon_sym_symbol] = ACTIONS(3236),
    [anon_sym_object] = ACTIONS(3236),
    [anon_sym_abstract] = ACTIONS(3236),
    [anon_sym_interface] = ACTIONS(3236),
    [anon_sym_enum] = ACTIONS(3236),
    [sym_html_comment] = ACTIONS(5),
  },
  [1571] = {
    [sym_comment] = STATE(1571),
    [ts_builtin_sym_end] = ACTIONS(3448),
    [sym_identifier] = ACTIONS(3192),
    [anon_sym_export] = ACTIONS(3192),
    [anon_sym_type] = ACTIONS(3192),
    [anon_sym_namespace] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3192),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_typeof] = ACTIONS(3192),
    [anon_sym_import] = ACTIONS(3192),
    [anon_sym_with] = ACTIONS(3192),
    [anon_sym_var] = ACTIONS(3192),
    [anon_sym_let] = ACTIONS(3192),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3192),
    [anon_sym_if] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_await] = ACTIONS(3192),
    [anon_sym_while] = ACTIONS(3192),
    [anon_sym_do] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3192),
    [anon_sym_continue] = ACTIONS(3192),
    [anon_sym_debugger] = ACTIONS(3192),
    [anon_sym_return] = ACTIONS(3192),
    [anon_sym_throw] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym_yield] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_LTtemplate_GT] = ACTIONS(3192),
    [anon_sym_DQUOTE] = ACTIONS(3192),
    [anon_sym_SQUOTE] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_async] = ACTIONS(3192),
    [anon_sym_function] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3192),
    [anon_sym_using] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3192),
    [anon_sym_SLASH] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3192),
    [anon_sym_void] = ACTIONS(3192),
    [anon_sym_delete] = ACTIONS(3192),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [sym_number] = ACTIONS(3192),
    [sym_private_property_identifier] = ACTIONS(3192),
    [sym_this] = ACTIONS(3192),
    [sym_super] = ACTIONS(3192),
    [sym_true] = ACTIONS(3192),
    [sym_false] = ACTIONS(3192),
    [sym_null] = ACTIONS(3192),
    [sym_undefined] = ACTIONS(3192),
    [anon_sym_AT] = ACTIONS(3192),
    [anon_sym_static] = ACTIONS(3192),
    [anon_sym_readonly] = ACTIONS(3192),
    [anon_sym_get] = ACTIONS(3192),
    [anon_sym_set] = ACTIONS(3192),
    [anon_sym_declare] = ACTIONS(3192),
    [anon_sym_public] = ACTIONS(3192),
    [anon_sym_private] = ACTIONS(3192),
    [anon_sym_protected] = ACTIONS(3192),
    [anon_sym_override] = ACTIONS(3192),
    [anon_sym_module] = ACTIONS(3192),
    [anon_sym_any] = ACTIONS(3192),
    [anon_sym_number] = ACTIONS(3192),
    [anon_sym_boolean] = ACTIONS(3192),
    [anon_sym_string] = ACTIONS(3192),
    [anon_sym_symbol] = ACTIONS(3192),
    [anon_sym_object] = ACTIONS(3192),
    [anon_sym_abstract] = ACTIONS(3192),
    [anon_sym_interface] = ACTIONS(3192),
    [anon_sym_enum] = ACTIONS(3192),
    [sym_html_comment] = ACTIONS(5),
  },
  [1572] = {
    [sym_comment] = STATE(1572),
    [ts_builtin_sym_end] = ACTIONS(3462),
    [sym_identifier] = ACTIONS(3220),
    [anon_sym_export] = ACTIONS(3220),
    [anon_sym_type] = ACTIONS(3220),
    [anon_sym_namespace] = ACTIONS(3220),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_RBRACE] = ACTIONS(3220),
    [anon_sym_typeof] = ACTIONS(3220),
    [anon_sym_import] = ACTIONS(3220),
    [anon_sym_with] = ACTIONS(3220),
    [anon_sym_var] = ACTIONS(3220),
    [anon_sym_let] = ACTIONS(3220),
    [anon_sym_const] = ACTIONS(3220),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_if] = ACTIONS(3220),
    [anon_sym_switch] = ACTIONS(3220),
    [anon_sym_for] = ACTIONS(3220),
    [anon_sym_LPAREN] = ACTIONS(3220),
    [anon_sym_await] = ACTIONS(3220),
    [anon_sym_while] = ACTIONS(3220),
    [anon_sym_do] = ACTIONS(3220),
    [anon_sym_try] = ACTIONS(3220),
    [anon_sym_break] = ACTIONS(3220),
    [anon_sym_continue] = ACTIONS(3220),
    [anon_sym_debugger] = ACTIONS(3220),
    [anon_sym_return] = ACTIONS(3220),
    [anon_sym_throw] = ACTIONS(3220),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym_yield] = ACTIONS(3220),
    [anon_sym_LBRACK] = ACTIONS(3220),
    [anon_sym_LTtemplate_GT] = ACTIONS(3220),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [anon_sym_class] = ACTIONS(3220),
    [anon_sym_async] = ACTIONS(3220),
    [anon_sym_function] = ACTIONS(3220),
    [anon_sym_new] = ACTIONS(3220),
    [anon_sym_using] = ACTIONS(3220),
    [anon_sym_PLUS] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3220),
    [anon_sym_SLASH] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(3220),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_void] = ACTIONS(3220),
    [anon_sym_delete] = ACTIONS(3220),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3220),
    [sym_number] = ACTIONS(3220),
    [sym_private_property_identifier] = ACTIONS(3220),
    [sym_this] = ACTIONS(3220),
    [sym_super] = ACTIONS(3220),
    [sym_true] = ACTIONS(3220),
    [sym_false] = ACTIONS(3220),
    [sym_null] = ACTIONS(3220),
    [sym_undefined] = ACTIONS(3220),
    [anon_sym_AT] = ACTIONS(3220),
    [anon_sym_static] = ACTIONS(3220),
    [anon_sym_readonly] = ACTIONS(3220),
    [anon_sym_get] = ACTIONS(3220),
    [anon_sym_set] = ACTIONS(3220),
    [anon_sym_declare] = ACTIONS(3220),
    [anon_sym_public] = ACTIONS(3220),
    [anon_sym_private] = ACTIONS(3220),
    [anon_sym_protected] = ACTIONS(3220),
    [anon_sym_override] = ACTIONS(3220),
    [anon_sym_module] = ACTIONS(3220),
    [anon_sym_any] = ACTIONS(3220),
    [anon_sym_number] = ACTIONS(3220),
    [anon_sym_boolean] = ACTIONS(3220),
    [anon_sym_string] = ACTIONS(3220),
    [anon_sym_symbol] = ACTIONS(3220),
    [anon_sym_object] = ACTIONS(3220),
    [anon_sym_abstract] = ACTIONS(3220),
    [anon_sym_interface] = ACTIONS(3220),
    [anon_sym_enum] = ACTIONS(3220),
    [sym_html_comment] = ACTIONS(5),
  },
  [1573] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1573),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6245),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(3592),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1574] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1574),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6309),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(3598),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3600),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1575] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1575),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(5996),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3604),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1576] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1576),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(5706),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(3606),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3608),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1577] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1577),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6160),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(3610),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3612),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1578] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1578),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6690),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3614),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1579] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1579),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6690),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1580] = {
    [sym_comment] = STATE(1580),
    [sym_identifier] = ACTIONS(3618),
    [anon_sym_export] = ACTIONS(3618),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_namespace] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3618),
    [anon_sym_typeof] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3618),
    [anon_sym_var] = ACTIONS(3618),
    [anon_sym_let] = ACTIONS(3618),
    [anon_sym_const] = ACTIONS(3618),
    [anon_sym_BANG] = ACTIONS(3618),
    [anon_sym_if] = ACTIONS(3618),
    [anon_sym_switch] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3618),
    [anon_sym_await] = ACTIONS(3618),
    [anon_sym_while] = ACTIONS(3618),
    [anon_sym_do] = ACTIONS(3618),
    [anon_sym_try] = ACTIONS(3618),
    [anon_sym_break] = ACTIONS(3618),
    [anon_sym_continue] = ACTIONS(3618),
    [anon_sym_debugger] = ACTIONS(3618),
    [anon_sym_return] = ACTIONS(3618),
    [anon_sym_throw] = ACTIONS(3618),
    [anon_sym_SEMI] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3618),
    [anon_sym_LBRACK] = ACTIONS(3618),
    [anon_sym_LTtemplate_GT] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3618),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_class] = ACTIONS(3618),
    [anon_sym_async] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3618),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_PLUS] = ACTIONS(3618),
    [anon_sym_DASH] = ACTIONS(3618),
    [anon_sym_SLASH] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_TILDE] = ACTIONS(3618),
    [anon_sym_void] = ACTIONS(3618),
    [anon_sym_delete] = ACTIONS(3618),
    [anon_sym_PLUS_PLUS] = ACTIONS(3618),
    [anon_sym_DASH_DASH] = ACTIONS(3618),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3618),
    [sym_number] = ACTIONS(3618),
    [sym_private_property_identifier] = ACTIONS(3618),
    [sym_this] = ACTIONS(3618),
    [sym_super] = ACTIONS(3618),
    [sym_true] = ACTIONS(3618),
    [sym_false] = ACTIONS(3618),
    [sym_null] = ACTIONS(3618),
    [sym_undefined] = ACTIONS(3618),
    [anon_sym_AT] = ACTIONS(3618),
    [anon_sym_static] = ACTIONS(3618),
    [anon_sym_readonly] = ACTIONS(3618),
    [anon_sym_get] = ACTIONS(3618),
    [anon_sym_set] = ACTIONS(3618),
    [anon_sym_declare] = ACTIONS(3618),
    [anon_sym_public] = ACTIONS(3618),
    [anon_sym_private] = ACTIONS(3618),
    [anon_sym_protected] = ACTIONS(3618),
    [anon_sym_override] = ACTIONS(3618),
    [anon_sym_module] = ACTIONS(3618),
    [anon_sym_any] = ACTIONS(3618),
    [anon_sym_number] = ACTIONS(3618),
    [anon_sym_boolean] = ACTIONS(3618),
    [anon_sym_string] = ACTIONS(3618),
    [anon_sym_symbol] = ACTIONS(3618),
    [anon_sym_object] = ACTIONS(3618),
    [anon_sym_abstract] = ACTIONS(3618),
    [anon_sym_interface] = ACTIONS(3618),
    [anon_sym_enum] = ACTIONS(3618),
    [sym_html_comment] = ACTIONS(5),
  },
  [1581] = {
    [sym_comment] = STATE(1581),
    [sym_identifier] = ACTIONS(3618),
    [anon_sym_export] = ACTIONS(3618),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_namespace] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3618),
    [anon_sym_typeof] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3618),
    [anon_sym_var] = ACTIONS(3618),
    [anon_sym_let] = ACTIONS(3618),
    [anon_sym_const] = ACTIONS(3618),
    [anon_sym_BANG] = ACTIONS(3618),
    [anon_sym_if] = ACTIONS(3618),
    [anon_sym_switch] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3618),
    [anon_sym_await] = ACTIONS(3618),
    [anon_sym_while] = ACTIONS(3618),
    [anon_sym_do] = ACTIONS(3618),
    [anon_sym_try] = ACTIONS(3618),
    [anon_sym_break] = ACTIONS(3618),
    [anon_sym_continue] = ACTIONS(3618),
    [anon_sym_debugger] = ACTIONS(3618),
    [anon_sym_return] = ACTIONS(3618),
    [anon_sym_throw] = ACTIONS(3618),
    [anon_sym_SEMI] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3618),
    [anon_sym_LBRACK] = ACTIONS(3618),
    [anon_sym_LTtemplate_GT] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3618),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_class] = ACTIONS(3618),
    [anon_sym_async] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3618),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_PLUS] = ACTIONS(3618),
    [anon_sym_DASH] = ACTIONS(3618),
    [anon_sym_SLASH] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_TILDE] = ACTIONS(3618),
    [anon_sym_void] = ACTIONS(3618),
    [anon_sym_delete] = ACTIONS(3618),
    [anon_sym_PLUS_PLUS] = ACTIONS(3618),
    [anon_sym_DASH_DASH] = ACTIONS(3618),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3618),
    [sym_number] = ACTIONS(3618),
    [sym_private_property_identifier] = ACTIONS(3618),
    [sym_this] = ACTIONS(3618),
    [sym_super] = ACTIONS(3618),
    [sym_true] = ACTIONS(3618),
    [sym_false] = ACTIONS(3618),
    [sym_null] = ACTIONS(3618),
    [sym_undefined] = ACTIONS(3618),
    [anon_sym_AT] = ACTIONS(3618),
    [anon_sym_static] = ACTIONS(3618),
    [anon_sym_readonly] = ACTIONS(3618),
    [anon_sym_get] = ACTIONS(3618),
    [anon_sym_set] = ACTIONS(3618),
    [anon_sym_declare] = ACTIONS(3618),
    [anon_sym_public] = ACTIONS(3618),
    [anon_sym_private] = ACTIONS(3618),
    [anon_sym_protected] = ACTIONS(3618),
    [anon_sym_override] = ACTIONS(3618),
    [anon_sym_module] = ACTIONS(3618),
    [anon_sym_any] = ACTIONS(3618),
    [anon_sym_number] = ACTIONS(3618),
    [anon_sym_boolean] = ACTIONS(3618),
    [anon_sym_string] = ACTIONS(3618),
    [anon_sym_symbol] = ACTIONS(3618),
    [anon_sym_object] = ACTIONS(3618),
    [anon_sym_abstract] = ACTIONS(3618),
    [anon_sym_interface] = ACTIONS(3618),
    [anon_sym_enum] = ACTIONS(3618),
    [sym_html_comment] = ACTIONS(5),
  },
  [1582] = {
    [sym_comment] = STATE(1582),
    [sym_identifier] = ACTIONS(3618),
    [anon_sym_export] = ACTIONS(3618),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_namespace] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3618),
    [anon_sym_typeof] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3618),
    [anon_sym_var] = ACTIONS(3618),
    [anon_sym_let] = ACTIONS(3618),
    [anon_sym_const] = ACTIONS(3618),
    [anon_sym_BANG] = ACTIONS(3618),
    [anon_sym_if] = ACTIONS(3618),
    [anon_sym_switch] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3618),
    [anon_sym_await] = ACTIONS(3618),
    [anon_sym_while] = ACTIONS(3618),
    [anon_sym_do] = ACTIONS(3618),
    [anon_sym_try] = ACTIONS(3618),
    [anon_sym_break] = ACTIONS(3618),
    [anon_sym_continue] = ACTIONS(3618),
    [anon_sym_debugger] = ACTIONS(3618),
    [anon_sym_return] = ACTIONS(3618),
    [anon_sym_throw] = ACTIONS(3618),
    [anon_sym_SEMI] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3618),
    [anon_sym_LBRACK] = ACTIONS(3618),
    [anon_sym_LTtemplate_GT] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3618),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_class] = ACTIONS(3618),
    [anon_sym_async] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3618),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_PLUS] = ACTIONS(3618),
    [anon_sym_DASH] = ACTIONS(3618),
    [anon_sym_SLASH] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_TILDE] = ACTIONS(3618),
    [anon_sym_void] = ACTIONS(3618),
    [anon_sym_delete] = ACTIONS(3618),
    [anon_sym_PLUS_PLUS] = ACTIONS(3618),
    [anon_sym_DASH_DASH] = ACTIONS(3618),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3618),
    [sym_number] = ACTIONS(3618),
    [sym_private_property_identifier] = ACTIONS(3618),
    [sym_this] = ACTIONS(3618),
    [sym_super] = ACTIONS(3618),
    [sym_true] = ACTIONS(3618),
    [sym_false] = ACTIONS(3618),
    [sym_null] = ACTIONS(3618),
    [sym_undefined] = ACTIONS(3618),
    [anon_sym_AT] = ACTIONS(3618),
    [anon_sym_static] = ACTIONS(3618),
    [anon_sym_readonly] = ACTIONS(3618),
    [anon_sym_get] = ACTIONS(3618),
    [anon_sym_set] = ACTIONS(3618),
    [anon_sym_declare] = ACTIONS(3618),
    [anon_sym_public] = ACTIONS(3618),
    [anon_sym_private] = ACTIONS(3618),
    [anon_sym_protected] = ACTIONS(3618),
    [anon_sym_override] = ACTIONS(3618),
    [anon_sym_module] = ACTIONS(3618),
    [anon_sym_any] = ACTIONS(3618),
    [anon_sym_number] = ACTIONS(3618),
    [anon_sym_boolean] = ACTIONS(3618),
    [anon_sym_string] = ACTIONS(3618),
    [anon_sym_symbol] = ACTIONS(3618),
    [anon_sym_object] = ACTIONS(3618),
    [anon_sym_abstract] = ACTIONS(3618),
    [anon_sym_interface] = ACTIONS(3618),
    [anon_sym_enum] = ACTIONS(3618),
    [sym_html_comment] = ACTIONS(5),
  },
  [1583] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1583),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6690),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1584] = {
    [sym_comment] = STATE(1584),
    [sym_identifier] = ACTIONS(3618),
    [anon_sym_export] = ACTIONS(3618),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_namespace] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3618),
    [anon_sym_typeof] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3618),
    [anon_sym_var] = ACTIONS(3618),
    [anon_sym_let] = ACTIONS(3618),
    [anon_sym_const] = ACTIONS(3618),
    [anon_sym_BANG] = ACTIONS(3618),
    [anon_sym_if] = ACTIONS(3618),
    [anon_sym_switch] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3618),
    [anon_sym_await] = ACTIONS(3618),
    [anon_sym_while] = ACTIONS(3618),
    [anon_sym_do] = ACTIONS(3618),
    [anon_sym_try] = ACTIONS(3618),
    [anon_sym_break] = ACTIONS(3618),
    [anon_sym_continue] = ACTIONS(3618),
    [anon_sym_debugger] = ACTIONS(3618),
    [anon_sym_return] = ACTIONS(3618),
    [anon_sym_throw] = ACTIONS(3618),
    [anon_sym_SEMI] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3618),
    [anon_sym_LBRACK] = ACTIONS(3618),
    [anon_sym_LTtemplate_GT] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3618),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_class] = ACTIONS(3618),
    [anon_sym_async] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3618),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_PLUS] = ACTIONS(3618),
    [anon_sym_DASH] = ACTIONS(3618),
    [anon_sym_SLASH] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_TILDE] = ACTIONS(3618),
    [anon_sym_void] = ACTIONS(3618),
    [anon_sym_delete] = ACTIONS(3618),
    [anon_sym_PLUS_PLUS] = ACTIONS(3618),
    [anon_sym_DASH_DASH] = ACTIONS(3618),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3618),
    [sym_number] = ACTIONS(3618),
    [sym_private_property_identifier] = ACTIONS(3618),
    [sym_this] = ACTIONS(3618),
    [sym_super] = ACTIONS(3618),
    [sym_true] = ACTIONS(3618),
    [sym_false] = ACTIONS(3618),
    [sym_null] = ACTIONS(3618),
    [sym_undefined] = ACTIONS(3618),
    [anon_sym_AT] = ACTIONS(3618),
    [anon_sym_static] = ACTIONS(3618),
    [anon_sym_readonly] = ACTIONS(3618),
    [anon_sym_get] = ACTIONS(3618),
    [anon_sym_set] = ACTIONS(3618),
    [anon_sym_declare] = ACTIONS(3618),
    [anon_sym_public] = ACTIONS(3618),
    [anon_sym_private] = ACTIONS(3618),
    [anon_sym_protected] = ACTIONS(3618),
    [anon_sym_override] = ACTIONS(3618),
    [anon_sym_module] = ACTIONS(3618),
    [anon_sym_any] = ACTIONS(3618),
    [anon_sym_number] = ACTIONS(3618),
    [anon_sym_boolean] = ACTIONS(3618),
    [anon_sym_string] = ACTIONS(3618),
    [anon_sym_symbol] = ACTIONS(3618),
    [anon_sym_object] = ACTIONS(3618),
    [anon_sym_abstract] = ACTIONS(3618),
    [anon_sym_interface] = ACTIONS(3618),
    [anon_sym_enum] = ACTIONS(3618),
    [sym_html_comment] = ACTIONS(5),
  },
  [1585] = {
    [sym_comment] = STATE(1585),
    [sym_identifier] = ACTIONS(3618),
    [anon_sym_export] = ACTIONS(3618),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_namespace] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3618),
    [anon_sym_typeof] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3618),
    [anon_sym_var] = ACTIONS(3618),
    [anon_sym_let] = ACTIONS(3618),
    [anon_sym_const] = ACTIONS(3618),
    [anon_sym_BANG] = ACTIONS(3618),
    [anon_sym_if] = ACTIONS(3618),
    [anon_sym_switch] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3618),
    [anon_sym_await] = ACTIONS(3618),
    [anon_sym_while] = ACTIONS(3618),
    [anon_sym_do] = ACTIONS(3618),
    [anon_sym_try] = ACTIONS(3618),
    [anon_sym_break] = ACTIONS(3618),
    [anon_sym_continue] = ACTIONS(3618),
    [anon_sym_debugger] = ACTIONS(3618),
    [anon_sym_return] = ACTIONS(3618),
    [anon_sym_throw] = ACTIONS(3618),
    [anon_sym_SEMI] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3618),
    [anon_sym_LBRACK] = ACTIONS(3618),
    [anon_sym_LTtemplate_GT] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3618),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_class] = ACTIONS(3618),
    [anon_sym_async] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3618),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_PLUS] = ACTIONS(3618),
    [anon_sym_DASH] = ACTIONS(3618),
    [anon_sym_SLASH] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_TILDE] = ACTIONS(3618),
    [anon_sym_void] = ACTIONS(3618),
    [anon_sym_delete] = ACTIONS(3618),
    [anon_sym_PLUS_PLUS] = ACTIONS(3618),
    [anon_sym_DASH_DASH] = ACTIONS(3618),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3618),
    [sym_number] = ACTIONS(3618),
    [sym_private_property_identifier] = ACTIONS(3618),
    [sym_this] = ACTIONS(3618),
    [sym_super] = ACTIONS(3618),
    [sym_true] = ACTIONS(3618),
    [sym_false] = ACTIONS(3618),
    [sym_null] = ACTIONS(3618),
    [sym_undefined] = ACTIONS(3618),
    [anon_sym_AT] = ACTIONS(3618),
    [anon_sym_static] = ACTIONS(3618),
    [anon_sym_readonly] = ACTIONS(3618),
    [anon_sym_get] = ACTIONS(3618),
    [anon_sym_set] = ACTIONS(3618),
    [anon_sym_declare] = ACTIONS(3618),
    [anon_sym_public] = ACTIONS(3618),
    [anon_sym_private] = ACTIONS(3618),
    [anon_sym_protected] = ACTIONS(3618),
    [anon_sym_override] = ACTIONS(3618),
    [anon_sym_module] = ACTIONS(3618),
    [anon_sym_any] = ACTIONS(3618),
    [anon_sym_number] = ACTIONS(3618),
    [anon_sym_boolean] = ACTIONS(3618),
    [anon_sym_string] = ACTIONS(3618),
    [anon_sym_symbol] = ACTIONS(3618),
    [anon_sym_object] = ACTIONS(3618),
    [anon_sym_abstract] = ACTIONS(3618),
    [anon_sym_interface] = ACTIONS(3618),
    [anon_sym_enum] = ACTIONS(3618),
    [sym_html_comment] = ACTIONS(5),
  },
  [1586] = {
    [sym_comment] = STATE(1586),
    [sym_identifier] = ACTIONS(3622),
    [anon_sym_export] = ACTIONS(3622),
    [anon_sym_type] = ACTIONS(3622),
    [anon_sym_namespace] = ACTIONS(3622),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_typeof] = ACTIONS(3622),
    [anon_sym_import] = ACTIONS(3622),
    [anon_sym_with] = ACTIONS(3622),
    [anon_sym_var] = ACTIONS(3622),
    [anon_sym_let] = ACTIONS(3622),
    [anon_sym_const] = ACTIONS(3622),
    [anon_sym_BANG] = ACTIONS(3622),
    [anon_sym_if] = ACTIONS(3622),
    [anon_sym_switch] = ACTIONS(3622),
    [anon_sym_for] = ACTIONS(3622),
    [anon_sym_LPAREN] = ACTIONS(3622),
    [anon_sym_await] = ACTIONS(3622),
    [anon_sym_while] = ACTIONS(3622),
    [anon_sym_do] = ACTIONS(3622),
    [anon_sym_try] = ACTIONS(3622),
    [anon_sym_break] = ACTIONS(3622),
    [anon_sym_continue] = ACTIONS(3622),
    [anon_sym_debugger] = ACTIONS(3622),
    [anon_sym_return] = ACTIONS(3622),
    [anon_sym_throw] = ACTIONS(3622),
    [anon_sym_SEMI] = ACTIONS(3622),
    [anon_sym_yield] = ACTIONS(3622),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LTtemplate_GT] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(3622),
    [anon_sym_SQUOTE] = ACTIONS(3622),
    [anon_sym_class] = ACTIONS(3622),
    [anon_sym_async] = ACTIONS(3622),
    [anon_sym_function] = ACTIONS(3622),
    [anon_sym_new] = ACTIONS(3622),
    [anon_sym_using] = ACTIONS(3622),
    [anon_sym_PLUS] = ACTIONS(3622),
    [anon_sym_DASH] = ACTIONS(3622),
    [anon_sym_SLASH] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3622),
    [anon_sym_TILDE] = ACTIONS(3622),
    [anon_sym_void] = ACTIONS(3622),
    [anon_sym_delete] = ACTIONS(3622),
    [anon_sym_PLUS_PLUS] = ACTIONS(3622),
    [anon_sym_DASH_DASH] = ACTIONS(3622),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3622),
    [sym_number] = ACTIONS(3622),
    [sym_private_property_identifier] = ACTIONS(3622),
    [sym_this] = ACTIONS(3622),
    [sym_super] = ACTIONS(3622),
    [sym_true] = ACTIONS(3622),
    [sym_false] = ACTIONS(3622),
    [sym_null] = ACTIONS(3622),
    [sym_undefined] = ACTIONS(3622),
    [anon_sym_AT] = ACTIONS(3622),
    [anon_sym_static] = ACTIONS(3622),
    [anon_sym_readonly] = ACTIONS(3622),
    [anon_sym_get] = ACTIONS(3622),
    [anon_sym_set] = ACTIONS(3622),
    [anon_sym_declare] = ACTIONS(3622),
    [anon_sym_public] = ACTIONS(3622),
    [anon_sym_private] = ACTIONS(3622),
    [anon_sym_protected] = ACTIONS(3622),
    [anon_sym_override] = ACTIONS(3622),
    [anon_sym_module] = ACTIONS(3622),
    [anon_sym_any] = ACTIONS(3622),
    [anon_sym_number] = ACTIONS(3622),
    [anon_sym_boolean] = ACTIONS(3622),
    [anon_sym_string] = ACTIONS(3622),
    [anon_sym_symbol] = ACTIONS(3622),
    [anon_sym_object] = ACTIONS(3622),
    [anon_sym_abstract] = ACTIONS(3622),
    [anon_sym_interface] = ACTIONS(3622),
    [anon_sym_enum] = ACTIONS(3622),
    [sym_html_comment] = ACTIONS(5),
  },
  [1587] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1587),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6690),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1588] = {
    [sym_comment] = STATE(1588),
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_export] = ACTIONS(3082),
    [anon_sym_type] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3082),
    [anon_sym_import] = ACTIONS(3082),
    [anon_sym_with] = ACTIONS(3082),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_BANG] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3082),
    [anon_sym_await] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_debugger] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3082),
    [anon_sym_yield] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_LTtemplate_GT] = ACTIONS(3082),
    [anon_sym_DQUOTE] = ACTIONS(3082),
    [anon_sym_SQUOTE] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_async] = ACTIONS(3082),
    [anon_sym_function] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_TILDE] = ACTIONS(3082),
    [anon_sym_void] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3082),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3082),
    [sym_number] = ACTIONS(3082),
    [sym_private_property_identifier] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
    [sym_super] = ACTIONS(3082),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [sym_null] = ACTIONS(3082),
    [sym_undefined] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_readonly] = ACTIONS(3082),
    [anon_sym_get] = ACTIONS(3082),
    [anon_sym_set] = ACTIONS(3082),
    [anon_sym_declare] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_override] = ACTIONS(3082),
    [anon_sym_module] = ACTIONS(3082),
    [anon_sym_any] = ACTIONS(3082),
    [anon_sym_number] = ACTIONS(3082),
    [anon_sym_boolean] = ACTIONS(3082),
    [anon_sym_string] = ACTIONS(3082),
    [anon_sym_symbol] = ACTIONS(3082),
    [anon_sym_object] = ACTIONS(3082),
    [anon_sym_abstract] = ACTIONS(3082),
    [anon_sym_interface] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [sym_html_comment] = ACTIONS(5),
  },
  [1589] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1589),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6690),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3626),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1590] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1590),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6690),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3628),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1591] = {
    [sym_comment] = STATE(1591),
    [sym_identifier] = ACTIONS(3618),
    [anon_sym_export] = ACTIONS(3618),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_namespace] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3618),
    [anon_sym_typeof] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3618),
    [anon_sym_var] = ACTIONS(3618),
    [anon_sym_let] = ACTIONS(3618),
    [anon_sym_const] = ACTIONS(3618),
    [anon_sym_BANG] = ACTIONS(3618),
    [anon_sym_if] = ACTIONS(3618),
    [anon_sym_switch] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3618),
    [anon_sym_await] = ACTIONS(3618),
    [anon_sym_while] = ACTIONS(3618),
    [anon_sym_do] = ACTIONS(3618),
    [anon_sym_try] = ACTIONS(3618),
    [anon_sym_break] = ACTIONS(3618),
    [anon_sym_continue] = ACTIONS(3618),
    [anon_sym_debugger] = ACTIONS(3618),
    [anon_sym_return] = ACTIONS(3618),
    [anon_sym_throw] = ACTIONS(3618),
    [anon_sym_SEMI] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3618),
    [anon_sym_LBRACK] = ACTIONS(3618),
    [anon_sym_LTtemplate_GT] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3618),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_class] = ACTIONS(3618),
    [anon_sym_async] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3618),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_PLUS] = ACTIONS(3618),
    [anon_sym_DASH] = ACTIONS(3618),
    [anon_sym_SLASH] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_TILDE] = ACTIONS(3618),
    [anon_sym_void] = ACTIONS(3618),
    [anon_sym_delete] = ACTIONS(3618),
    [anon_sym_PLUS_PLUS] = ACTIONS(3618),
    [anon_sym_DASH_DASH] = ACTIONS(3618),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3618),
    [sym_number] = ACTIONS(3618),
    [sym_private_property_identifier] = ACTIONS(3618),
    [sym_this] = ACTIONS(3618),
    [sym_super] = ACTIONS(3618),
    [sym_true] = ACTIONS(3618),
    [sym_false] = ACTIONS(3618),
    [sym_null] = ACTIONS(3618),
    [sym_undefined] = ACTIONS(3618),
    [anon_sym_AT] = ACTIONS(3618),
    [anon_sym_static] = ACTIONS(3618),
    [anon_sym_readonly] = ACTIONS(3618),
    [anon_sym_get] = ACTIONS(3618),
    [anon_sym_set] = ACTIONS(3618),
    [anon_sym_declare] = ACTIONS(3618),
    [anon_sym_public] = ACTIONS(3618),
    [anon_sym_private] = ACTIONS(3618),
    [anon_sym_protected] = ACTIONS(3618),
    [anon_sym_override] = ACTIONS(3618),
    [anon_sym_module] = ACTIONS(3618),
    [anon_sym_any] = ACTIONS(3618),
    [anon_sym_number] = ACTIONS(3618),
    [anon_sym_boolean] = ACTIONS(3618),
    [anon_sym_string] = ACTIONS(3618),
    [anon_sym_symbol] = ACTIONS(3618),
    [anon_sym_object] = ACTIONS(3618),
    [anon_sym_abstract] = ACTIONS(3618),
    [anon_sym_interface] = ACTIONS(3618),
    [anon_sym_enum] = ACTIONS(3618),
    [sym_html_comment] = ACTIONS(5),
  },
  [1592] = {
    [sym_comment] = STATE(1592),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_export] = ACTIONS(3630),
    [anon_sym_type] = ACTIONS(3630),
    [anon_sym_namespace] = ACTIONS(3630),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_typeof] = ACTIONS(3630),
    [anon_sym_import] = ACTIONS(3630),
    [anon_sym_with] = ACTIONS(3630),
    [anon_sym_var] = ACTIONS(3630),
    [anon_sym_let] = ACTIONS(3630),
    [anon_sym_const] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_if] = ACTIONS(3630),
    [anon_sym_switch] = ACTIONS(3630),
    [anon_sym_for] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_await] = ACTIONS(3630),
    [anon_sym_while] = ACTIONS(3630),
    [anon_sym_do] = ACTIONS(3630),
    [anon_sym_try] = ACTIONS(3630),
    [anon_sym_break] = ACTIONS(3630),
    [anon_sym_continue] = ACTIONS(3630),
    [anon_sym_debugger] = ACTIONS(3630),
    [anon_sym_return] = ACTIONS(3630),
    [anon_sym_throw] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(3630),
    [anon_sym_yield] = ACTIONS(3630),
    [anon_sym_LBRACK] = ACTIONS(3630),
    [anon_sym_LTtemplate_GT] = ACTIONS(3630),
    [anon_sym_DQUOTE] = ACTIONS(3630),
    [anon_sym_SQUOTE] = ACTIONS(3630),
    [anon_sym_class] = ACTIONS(3630),
    [anon_sym_async] = ACTIONS(3630),
    [anon_sym_function] = ACTIONS(3630),
    [anon_sym_new] = ACTIONS(3630),
    [anon_sym_using] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3630),
    [anon_sym_SLASH] = ACTIONS(3630),
    [anon_sym_LT] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [anon_sym_void] = ACTIONS(3630),
    [anon_sym_delete] = ACTIONS(3630),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3630),
    [sym_number] = ACTIONS(3630),
    [sym_private_property_identifier] = ACTIONS(3630),
    [sym_this] = ACTIONS(3630),
    [sym_super] = ACTIONS(3630),
    [sym_true] = ACTIONS(3630),
    [sym_false] = ACTIONS(3630),
    [sym_null] = ACTIONS(3630),
    [sym_undefined] = ACTIONS(3630),
    [anon_sym_AT] = ACTIONS(3630),
    [anon_sym_static] = ACTIONS(3630),
    [anon_sym_readonly] = ACTIONS(3630),
    [anon_sym_get] = ACTIONS(3630),
    [anon_sym_set] = ACTIONS(3630),
    [anon_sym_declare] = ACTIONS(3630),
    [anon_sym_public] = ACTIONS(3630),
    [anon_sym_private] = ACTIONS(3630),
    [anon_sym_protected] = ACTIONS(3630),
    [anon_sym_override] = ACTIONS(3630),
    [anon_sym_module] = ACTIONS(3630),
    [anon_sym_any] = ACTIONS(3630),
    [anon_sym_number] = ACTIONS(3630),
    [anon_sym_boolean] = ACTIONS(3630),
    [anon_sym_string] = ACTIONS(3630),
    [anon_sym_symbol] = ACTIONS(3630),
    [anon_sym_object] = ACTIONS(3630),
    [anon_sym_abstract] = ACTIONS(3630),
    [anon_sym_interface] = ACTIONS(3630),
    [anon_sym_enum] = ACTIONS(3630),
    [sym_html_comment] = ACTIONS(5),
  },
  [1593] = {
    [sym_comment] = STATE(1593),
    [sym_identifier] = ACTIONS(3632),
    [anon_sym_export] = ACTIONS(3632),
    [anon_sym_type] = ACTIONS(3632),
    [anon_sym_namespace] = ACTIONS(3632),
    [anon_sym_LBRACE] = ACTIONS(3632),
    [anon_sym_typeof] = ACTIONS(3632),
    [anon_sym_import] = ACTIONS(3632),
    [anon_sym_with] = ACTIONS(3632),
    [anon_sym_var] = ACTIONS(3632),
    [anon_sym_let] = ACTIONS(3632),
    [anon_sym_const] = ACTIONS(3632),
    [anon_sym_BANG] = ACTIONS(3632),
    [anon_sym_if] = ACTIONS(3632),
    [anon_sym_switch] = ACTIONS(3632),
    [anon_sym_for] = ACTIONS(3632),
    [anon_sym_LPAREN] = ACTIONS(3632),
    [anon_sym_await] = ACTIONS(3632),
    [anon_sym_while] = ACTIONS(3632),
    [anon_sym_do] = ACTIONS(3632),
    [anon_sym_try] = ACTIONS(3632),
    [anon_sym_break] = ACTIONS(3632),
    [anon_sym_continue] = ACTIONS(3632),
    [anon_sym_debugger] = ACTIONS(3632),
    [anon_sym_return] = ACTIONS(3632),
    [anon_sym_throw] = ACTIONS(3632),
    [anon_sym_SEMI] = ACTIONS(3632),
    [anon_sym_yield] = ACTIONS(3632),
    [anon_sym_LBRACK] = ACTIONS(3632),
    [anon_sym_LTtemplate_GT] = ACTIONS(3632),
    [anon_sym_DQUOTE] = ACTIONS(3632),
    [anon_sym_SQUOTE] = ACTIONS(3632),
    [anon_sym_class] = ACTIONS(3632),
    [anon_sym_async] = ACTIONS(3632),
    [anon_sym_function] = ACTIONS(3632),
    [anon_sym_new] = ACTIONS(3632),
    [anon_sym_using] = ACTIONS(3632),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_SLASH] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3632),
    [anon_sym_TILDE] = ACTIONS(3632),
    [anon_sym_void] = ACTIONS(3632),
    [anon_sym_delete] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3632),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3632),
    [sym_number] = ACTIONS(3632),
    [sym_private_property_identifier] = ACTIONS(3632),
    [sym_this] = ACTIONS(3632),
    [sym_super] = ACTIONS(3632),
    [sym_true] = ACTIONS(3632),
    [sym_false] = ACTIONS(3632),
    [sym_null] = ACTIONS(3632),
    [sym_undefined] = ACTIONS(3632),
    [anon_sym_AT] = ACTIONS(3632),
    [anon_sym_static] = ACTIONS(3632),
    [anon_sym_readonly] = ACTIONS(3632),
    [anon_sym_get] = ACTIONS(3632),
    [anon_sym_set] = ACTIONS(3632),
    [anon_sym_declare] = ACTIONS(3632),
    [anon_sym_public] = ACTIONS(3632),
    [anon_sym_private] = ACTIONS(3632),
    [anon_sym_protected] = ACTIONS(3632),
    [anon_sym_override] = ACTIONS(3632),
    [anon_sym_module] = ACTIONS(3632),
    [anon_sym_any] = ACTIONS(3632),
    [anon_sym_number] = ACTIONS(3632),
    [anon_sym_boolean] = ACTIONS(3632),
    [anon_sym_string] = ACTIONS(3632),
    [anon_sym_symbol] = ACTIONS(3632),
    [anon_sym_object] = ACTIONS(3632),
    [anon_sym_abstract] = ACTIONS(3632),
    [anon_sym_interface] = ACTIONS(3632),
    [anon_sym_enum] = ACTIONS(3632),
    [sym_html_comment] = ACTIONS(5),
  },
  [1594] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1594),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6690),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3634),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1595] = {
    [sym_comment] = STATE(1595),
    [sym_identifier] = ACTIONS(3618),
    [anon_sym_export] = ACTIONS(3618),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_namespace] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3618),
    [anon_sym_typeof] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3618),
    [anon_sym_var] = ACTIONS(3618),
    [anon_sym_let] = ACTIONS(3618),
    [anon_sym_const] = ACTIONS(3618),
    [anon_sym_BANG] = ACTIONS(3618),
    [anon_sym_if] = ACTIONS(3618),
    [anon_sym_switch] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3618),
    [anon_sym_await] = ACTIONS(3618),
    [anon_sym_while] = ACTIONS(3618),
    [anon_sym_do] = ACTIONS(3618),
    [anon_sym_try] = ACTIONS(3618),
    [anon_sym_break] = ACTIONS(3618),
    [anon_sym_continue] = ACTIONS(3618),
    [anon_sym_debugger] = ACTIONS(3618),
    [anon_sym_return] = ACTIONS(3618),
    [anon_sym_throw] = ACTIONS(3618),
    [anon_sym_SEMI] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3618),
    [anon_sym_LBRACK] = ACTIONS(3618),
    [anon_sym_LTtemplate_GT] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3618),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_class] = ACTIONS(3618),
    [anon_sym_async] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3618),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_PLUS] = ACTIONS(3618),
    [anon_sym_DASH] = ACTIONS(3618),
    [anon_sym_SLASH] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_TILDE] = ACTIONS(3618),
    [anon_sym_void] = ACTIONS(3618),
    [anon_sym_delete] = ACTIONS(3618),
    [anon_sym_PLUS_PLUS] = ACTIONS(3618),
    [anon_sym_DASH_DASH] = ACTIONS(3618),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3618),
    [sym_number] = ACTIONS(3618),
    [sym_private_property_identifier] = ACTIONS(3618),
    [sym_this] = ACTIONS(3618),
    [sym_super] = ACTIONS(3618),
    [sym_true] = ACTIONS(3618),
    [sym_false] = ACTIONS(3618),
    [sym_null] = ACTIONS(3618),
    [sym_undefined] = ACTIONS(3618),
    [anon_sym_AT] = ACTIONS(3618),
    [anon_sym_static] = ACTIONS(3618),
    [anon_sym_readonly] = ACTIONS(3618),
    [anon_sym_get] = ACTIONS(3618),
    [anon_sym_set] = ACTIONS(3618),
    [anon_sym_declare] = ACTIONS(3618),
    [anon_sym_public] = ACTIONS(3618),
    [anon_sym_private] = ACTIONS(3618),
    [anon_sym_protected] = ACTIONS(3618),
    [anon_sym_override] = ACTIONS(3618),
    [anon_sym_module] = ACTIONS(3618),
    [anon_sym_any] = ACTIONS(3618),
    [anon_sym_number] = ACTIONS(3618),
    [anon_sym_boolean] = ACTIONS(3618),
    [anon_sym_string] = ACTIONS(3618),
    [anon_sym_symbol] = ACTIONS(3618),
    [anon_sym_object] = ACTIONS(3618),
    [anon_sym_abstract] = ACTIONS(3618),
    [anon_sym_interface] = ACTIONS(3618),
    [anon_sym_enum] = ACTIONS(3618),
    [sym_html_comment] = ACTIONS(5),
  },
  [1596] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1596),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6690),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3636),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1597] = {
    [sym_comment] = STATE(1597),
    [sym_identifier] = ACTIONS(3116),
    [anon_sym_export] = ACTIONS(3116),
    [anon_sym_type] = ACTIONS(3116),
    [anon_sym_namespace] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_typeof] = ACTIONS(3116),
    [anon_sym_import] = ACTIONS(3116),
    [anon_sym_with] = ACTIONS(3116),
    [anon_sym_var] = ACTIONS(3116),
    [anon_sym_let] = ACTIONS(3116),
    [anon_sym_const] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3116),
    [anon_sym_if] = ACTIONS(3116),
    [anon_sym_switch] = ACTIONS(3116),
    [anon_sym_for] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3116),
    [anon_sym_await] = ACTIONS(3116),
    [anon_sym_while] = ACTIONS(3116),
    [anon_sym_do] = ACTIONS(3116),
    [anon_sym_try] = ACTIONS(3116),
    [anon_sym_break] = ACTIONS(3116),
    [anon_sym_continue] = ACTIONS(3116),
    [anon_sym_debugger] = ACTIONS(3116),
    [anon_sym_return] = ACTIONS(3116),
    [anon_sym_throw] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym_yield] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [anon_sym_LTtemplate_GT] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [anon_sym_SQUOTE] = ACTIONS(3116),
    [anon_sym_class] = ACTIONS(3116),
    [anon_sym_async] = ACTIONS(3116),
    [anon_sym_function] = ACTIONS(3116),
    [anon_sym_new] = ACTIONS(3116),
    [anon_sym_using] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3116),
    [anon_sym_SLASH] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3116),
    [anon_sym_TILDE] = ACTIONS(3116),
    [anon_sym_void] = ACTIONS(3116),
    [anon_sym_delete] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [sym_number] = ACTIONS(3116),
    [sym_private_property_identifier] = ACTIONS(3116),
    [sym_this] = ACTIONS(3116),
    [sym_super] = ACTIONS(3116),
    [sym_true] = ACTIONS(3116),
    [sym_false] = ACTIONS(3116),
    [sym_null] = ACTIONS(3116),
    [sym_undefined] = ACTIONS(3116),
    [anon_sym_AT] = ACTIONS(3116),
    [anon_sym_static] = ACTIONS(3116),
    [anon_sym_readonly] = ACTIONS(3116),
    [anon_sym_get] = ACTIONS(3116),
    [anon_sym_set] = ACTIONS(3116),
    [anon_sym_declare] = ACTIONS(3116),
    [anon_sym_public] = ACTIONS(3116),
    [anon_sym_private] = ACTIONS(3116),
    [anon_sym_protected] = ACTIONS(3116),
    [anon_sym_override] = ACTIONS(3116),
    [anon_sym_module] = ACTIONS(3116),
    [anon_sym_any] = ACTIONS(3116),
    [anon_sym_number] = ACTIONS(3116),
    [anon_sym_boolean] = ACTIONS(3116),
    [anon_sym_string] = ACTIONS(3116),
    [anon_sym_symbol] = ACTIONS(3116),
    [anon_sym_object] = ACTIONS(3116),
    [anon_sym_abstract] = ACTIONS(3116),
    [anon_sym_interface] = ACTIONS(3116),
    [anon_sym_enum] = ACTIONS(3116),
    [sym_html_comment] = ACTIONS(5),
  },
  [1598] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1598),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6690),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3638),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1599] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1599),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6690),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(3640),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1600] = {
    [sym_comment] = STATE(1600),
    [sym_identifier] = ACTIONS(3618),
    [anon_sym_export] = ACTIONS(3618),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_namespace] = ACTIONS(3618),
    [anon_sym_LBRACE] = ACTIONS(3618),
    [anon_sym_typeof] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3618),
    [anon_sym_with] = ACTIONS(3618),
    [anon_sym_var] = ACTIONS(3618),
    [anon_sym_let] = ACTIONS(3618),
    [anon_sym_const] = ACTIONS(3618),
    [anon_sym_BANG] = ACTIONS(3618),
    [anon_sym_if] = ACTIONS(3618),
    [anon_sym_switch] = ACTIONS(3618),
    [anon_sym_for] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3618),
    [anon_sym_await] = ACTIONS(3618),
    [anon_sym_while] = ACTIONS(3618),
    [anon_sym_do] = ACTIONS(3618),
    [anon_sym_try] = ACTIONS(3618),
    [anon_sym_break] = ACTIONS(3618),
    [anon_sym_continue] = ACTIONS(3618),
    [anon_sym_debugger] = ACTIONS(3618),
    [anon_sym_return] = ACTIONS(3618),
    [anon_sym_throw] = ACTIONS(3618),
    [anon_sym_SEMI] = ACTIONS(3618),
    [anon_sym_yield] = ACTIONS(3618),
    [anon_sym_LBRACK] = ACTIONS(3618),
    [anon_sym_LTtemplate_GT] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3618),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_class] = ACTIONS(3618),
    [anon_sym_async] = ACTIONS(3618),
    [anon_sym_function] = ACTIONS(3618),
    [anon_sym_new] = ACTIONS(3618),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_PLUS] = ACTIONS(3618),
    [anon_sym_DASH] = ACTIONS(3618),
    [anon_sym_SLASH] = ACTIONS(3618),
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_TILDE] = ACTIONS(3618),
    [anon_sym_void] = ACTIONS(3618),
    [anon_sym_delete] = ACTIONS(3618),
    [anon_sym_PLUS_PLUS] = ACTIONS(3618),
    [anon_sym_DASH_DASH] = ACTIONS(3618),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3618),
    [sym_number] = ACTIONS(3618),
    [sym_private_property_identifier] = ACTIONS(3618),
    [sym_this] = ACTIONS(3618),
    [sym_super] = ACTIONS(3618),
    [sym_true] = ACTIONS(3618),
    [sym_false] = ACTIONS(3618),
    [sym_null] = ACTIONS(3618),
    [sym_undefined] = ACTIONS(3618),
    [anon_sym_AT] = ACTIONS(3618),
    [anon_sym_static] = ACTIONS(3618),
    [anon_sym_readonly] = ACTIONS(3618),
    [anon_sym_get] = ACTIONS(3618),
    [anon_sym_set] = ACTIONS(3618),
    [anon_sym_declare] = ACTIONS(3618),
    [anon_sym_public] = ACTIONS(3618),
    [anon_sym_private] = ACTIONS(3618),
    [anon_sym_protected] = ACTIONS(3618),
    [anon_sym_override] = ACTIONS(3618),
    [anon_sym_module] = ACTIONS(3618),
    [anon_sym_any] = ACTIONS(3618),
    [anon_sym_number] = ACTIONS(3618),
    [anon_sym_boolean] = ACTIONS(3618),
    [anon_sym_string] = ACTIONS(3618),
    [anon_sym_symbol] = ACTIONS(3618),
    [anon_sym_object] = ACTIONS(3618),
    [anon_sym_abstract] = ACTIONS(3618),
    [anon_sym_interface] = ACTIONS(3618),
    [anon_sym_enum] = ACTIONS(3618),
    [sym_html_comment] = ACTIONS(5),
  },
  [1601] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1601),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4150),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4507),
    [sym_asserts] = STATE(6812),
    [sym__type] = STATE(4140),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_predicate] = STATE(6834),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3680),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(3644),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_asserts] = ACTIONS(3646),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1602] = {
    [sym_import] = STATE(5669),
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1602),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4310),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4714),
    [sym_asserts] = STATE(5184),
    [sym__type] = STATE(4309),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_predicate] = STATE(5187),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4033),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(3680),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_asserts] = ACTIONS(3688),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1603] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1603),
    [sym_formal_parameters] = STATE(7012),
    [sym_rest_pattern] = STATE(6668),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4796),
    [sym_tuple_parameter] = STATE(6666),
    [sym_optional_tuple_parameter] = STATE(6666),
    [sym_optional_type] = STATE(6666),
    [sym_rest_type] = STATE(6666),
    [sym__tuple_type_member] = STATE(6690),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3590),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3596),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1604] = {
    [sym_import] = STATE(6247),
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1604),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4039),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4322),
    [sym_asserts] = STATE(4711),
    [sym__type] = STATE(4035),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_predicate] = STATE(4705),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3938),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(3698),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_asserts] = ACTIONS(3700),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1605] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1605),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3702),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1606] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1606),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1607] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1607),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1608] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1608),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3708),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1609] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1609),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3710),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1610] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1610),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1611] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1611),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1612] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1612),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3716),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1613] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1613),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1614] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1614),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3720),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1615] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1615),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3722),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1616] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1616),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3724),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1617] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1617),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3726),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1618] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1618),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1619] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1619),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1620] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1620),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1621] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1621),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1622] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1622),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3736),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1623] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1623),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1624] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1624),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3740),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1625] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1625),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1626] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1626),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3744),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1627] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1627),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1628] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1628),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3748),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1629] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1629),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3750),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1630] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1630),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3752),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1631] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1631),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3754),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1632] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1632),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1633] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1633),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3758),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1634] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1634),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3760),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1635] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1635),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1636] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1636),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3764),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1637] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1637),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1638] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1638),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3768),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1639] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1639),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3770),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1640] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1640),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3772),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1641] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1641),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1642] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1642),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1643] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1643),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3778),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1644] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1644),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3780),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1645] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1645),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3782),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1646] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1646),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(3784),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1647] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1647),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5395),
    [sym__type_query_call_expression_in_type_annotation] = STATE(6096),
    [sym__type] = STATE(5389),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1648] = {
    [sym_import] = STATE(6247),
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1648),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4039),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4322),
    [sym__type] = STATE(4035),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1649] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1649),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4670),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5486),
    [sym__type] = STATE(4671),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1650] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1650),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4830),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5610),
    [sym__type] = STATE(4829),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1651] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1651),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4754),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5487),
    [sym__type] = STATE(4756),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1652] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1652),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4621),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5624),
    [sym__type] = STATE(4622),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1653] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1653),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4150),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4507),
    [sym__type] = STATE(4140),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1654] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1654),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4752),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5480),
    [sym__type] = STATE(4750),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1655] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1655),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4707),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5438),
    [sym__type] = STATE(4708),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1656] = {
    [sym_import] = STATE(6061),
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1656),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4738),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5468),
    [sym__type] = STATE(4739),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(128),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1657] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1657),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym_asserts] = STATE(4208),
    [sym__type] = STATE(4209),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_predicate] = STATE(4208),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4033),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(3680),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_asserts] = ACTIONS(3688),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1658] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1658),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym_asserts] = STATE(3684),
    [sym__type] = STATE(3685),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_predicate] = STATE(3684),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3680),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(3644),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_asserts] = ACTIONS(3646),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1659] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1659),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym_asserts] = STATE(3730),
    [sym__type] = STATE(3731),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_predicate] = STATE(3730),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3680),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(3644),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_asserts] = ACTIONS(3646),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1660] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1660),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym_asserts] = STATE(2277),
    [sym__type] = STATE(2273),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_predicate] = STATE(2277),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2218),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_asserts] = ACTIONS(3822),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1661] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1661),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym_asserts] = STATE(4105),
    [sym__type] = STATE(4103),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_predicate] = STATE(4105),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4033),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(3680),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_asserts] = ACTIONS(3688),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1662] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1662),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym_asserts] = STATE(2351),
    [sym__type] = STATE(2359),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_predicate] = STATE(2351),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2218),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(3786),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(3814),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_asserts] = ACTIONS(3822),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1663] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1663),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym_asserts] = STATE(2722),
    [sym__type] = STATE(2721),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_predicate] = STATE(2722),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2660),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(3830),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(3858),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_asserts] = ACTIONS(3866),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1664] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1664),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym_asserts] = STATE(3976),
    [sym__type] = STATE(3973),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_predicate] = STATE(3976),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3938),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(3698),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_asserts] = ACTIONS(3700),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1665] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1665),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym_asserts] = STATE(4010),
    [sym__type] = STATE(4005),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_predicate] = STATE(4010),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3938),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(3698),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_asserts] = ACTIONS(3700),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1666] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1666),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym_asserts] = STATE(2749),
    [sym__type] = STATE(2750),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_predicate] = STATE(2749),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2660),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(3830),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(3858),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_asserts] = ACTIONS(3866),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1667] = {
    [sym_export_statement] = STATE(4797),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(5740),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1667),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(5740),
    [sym_pair] = STATE(5740),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4797),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4797),
    [sym_property_signature] = STATE(4797),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4797),
    [sym_index_signature] = STATE(4797),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(5792),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3874),
    [anon_sym_export] = ACTIONS(3876),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3874),
    [anon_sym_namespace] = ACTIONS(3874),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3892),
    [anon_sym_new] = ACTIONS(3894),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_readonly] = ACTIONS(3902),
    [anon_sym_get] = ACTIONS(3904),
    [anon_sym_set] = ACTIONS(3904),
    [anon_sym_declare] = ACTIONS(3874),
    [anon_sym_public] = ACTIONS(3906),
    [anon_sym_private] = ACTIONS(3906),
    [anon_sym_protected] = ACTIONS(3906),
    [anon_sym_override] = ACTIONS(3908),
    [anon_sym_module] = ACTIONS(3874),
    [anon_sym_any] = ACTIONS(3874),
    [anon_sym_number] = ACTIONS(3874),
    [anon_sym_boolean] = ACTIONS(3874),
    [anon_sym_string] = ACTIONS(3874),
    [anon_sym_symbol] = ACTIONS(3874),
    [anon_sym_object] = ACTIONS(3874),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3912),
    [sym_html_comment] = ACTIONS(5),
  },
  [1668] = {
    [sym_export_statement] = STATE(4797),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6145),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1668),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4797),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4797),
    [sym_property_signature] = STATE(4797),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4797),
    [sym_index_signature] = STATE(4797),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_export] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3914),
    [anon_sym_namespace] = ACTIONS(3914),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3918),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(3922),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3924),
    [anon_sym_readonly] = ACTIONS(3926),
    [anon_sym_get] = ACTIONS(3928),
    [anon_sym_set] = ACTIONS(3928),
    [anon_sym_declare] = ACTIONS(3914),
    [anon_sym_public] = ACTIONS(3930),
    [anon_sym_private] = ACTIONS(3930),
    [anon_sym_protected] = ACTIONS(3930),
    [anon_sym_override] = ACTIONS(3932),
    [anon_sym_module] = ACTIONS(3914),
    [anon_sym_any] = ACTIONS(3914),
    [anon_sym_number] = ACTIONS(3914),
    [anon_sym_boolean] = ACTIONS(3914),
    [anon_sym_string] = ACTIONS(3914),
    [anon_sym_symbol] = ACTIONS(3914),
    [anon_sym_object] = ACTIONS(3914),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3912),
    [sym_html_comment] = ACTIONS(5),
  },
  [1669] = {
    [sym_export_statement] = STATE(4797),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6145),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1669),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4797),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4797),
    [sym_property_signature] = STATE(4797),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4797),
    [sym_index_signature] = STATE(4797),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3934),
    [anon_sym_export] = ACTIONS(3936),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3934),
    [anon_sym_namespace] = ACTIONS(3934),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3938),
    [anon_sym_let] = ACTIONS(3934),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3944),
    [anon_sym_readonly] = ACTIONS(3946),
    [anon_sym_get] = ACTIONS(3948),
    [anon_sym_set] = ACTIONS(3948),
    [anon_sym_declare] = ACTIONS(3934),
    [anon_sym_public] = ACTIONS(3950),
    [anon_sym_private] = ACTIONS(3950),
    [anon_sym_protected] = ACTIONS(3950),
    [anon_sym_override] = ACTIONS(3952),
    [anon_sym_module] = ACTIONS(3934),
    [anon_sym_any] = ACTIONS(3934),
    [anon_sym_number] = ACTIONS(3934),
    [anon_sym_boolean] = ACTIONS(3934),
    [anon_sym_string] = ACTIONS(3934),
    [anon_sym_symbol] = ACTIONS(3934),
    [anon_sym_object] = ACTIONS(3934),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3912),
    [sym_html_comment] = ACTIONS(5),
  },
  [1670] = {
    [sym_export_statement] = STATE(4797),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6145),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1670),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4797),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4797),
    [sym_property_signature] = STATE(4797),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4797),
    [sym_index_signature] = STATE(4797),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_export] = ACTIONS(3956),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3954),
    [anon_sym_namespace] = ACTIONS(3954),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3958),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3964),
    [anon_sym_readonly] = ACTIONS(3966),
    [anon_sym_get] = ACTIONS(3968),
    [anon_sym_set] = ACTIONS(3968),
    [anon_sym_declare] = ACTIONS(3954),
    [anon_sym_public] = ACTIONS(3970),
    [anon_sym_private] = ACTIONS(3970),
    [anon_sym_protected] = ACTIONS(3970),
    [anon_sym_override] = ACTIONS(3972),
    [anon_sym_module] = ACTIONS(3954),
    [anon_sym_any] = ACTIONS(3954),
    [anon_sym_number] = ACTIONS(3954),
    [anon_sym_boolean] = ACTIONS(3954),
    [anon_sym_string] = ACTIONS(3954),
    [anon_sym_symbol] = ACTIONS(3954),
    [anon_sym_object] = ACTIONS(3954),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3912),
    [sym_html_comment] = ACTIONS(5),
  },
  [1671] = {
    [sym_export_statement] = STATE(4797),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6145),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1671),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4797),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4797),
    [sym_property_signature] = STATE(4797),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4797),
    [sym_index_signature] = STATE(4797),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3934),
    [anon_sym_export] = ACTIONS(3936),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3934),
    [anon_sym_namespace] = ACTIONS(3934),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3974),
    [anon_sym_let] = ACTIONS(3934),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3944),
    [anon_sym_readonly] = ACTIONS(3946),
    [anon_sym_get] = ACTIONS(3948),
    [anon_sym_set] = ACTIONS(3948),
    [anon_sym_declare] = ACTIONS(3934),
    [anon_sym_public] = ACTIONS(3950),
    [anon_sym_private] = ACTIONS(3950),
    [anon_sym_protected] = ACTIONS(3950),
    [anon_sym_override] = ACTIONS(3952),
    [anon_sym_module] = ACTIONS(3934),
    [anon_sym_any] = ACTIONS(3934),
    [anon_sym_number] = ACTIONS(3934),
    [anon_sym_boolean] = ACTIONS(3934),
    [anon_sym_string] = ACTIONS(3934),
    [anon_sym_symbol] = ACTIONS(3934),
    [anon_sym_object] = ACTIONS(3934),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3912),
    [sym_html_comment] = ACTIONS(5),
  },
  [1672] = {
    [sym_export_statement] = STATE(4797),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6145),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1672),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4797),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4797),
    [sym_property_signature] = STATE(4797),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4797),
    [sym_index_signature] = STATE(4797),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_export] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3914),
    [anon_sym_namespace] = ACTIONS(3914),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(3922),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3924),
    [anon_sym_readonly] = ACTIONS(3926),
    [anon_sym_get] = ACTIONS(3928),
    [anon_sym_set] = ACTIONS(3928),
    [anon_sym_declare] = ACTIONS(3914),
    [anon_sym_public] = ACTIONS(3930),
    [anon_sym_private] = ACTIONS(3930),
    [anon_sym_protected] = ACTIONS(3930),
    [anon_sym_override] = ACTIONS(3932),
    [anon_sym_module] = ACTIONS(3914),
    [anon_sym_any] = ACTIONS(3914),
    [anon_sym_number] = ACTIONS(3914),
    [anon_sym_boolean] = ACTIONS(3914),
    [anon_sym_string] = ACTIONS(3914),
    [anon_sym_symbol] = ACTIONS(3914),
    [anon_sym_object] = ACTIONS(3914),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3912),
    [sym_html_comment] = ACTIONS(5),
  },
  [1673] = {
    [sym_export_statement] = STATE(4797),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6145),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1673),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4797),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4797),
    [sym_property_signature] = STATE(4797),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4797),
    [sym_index_signature] = STATE(4797),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3954),
    [anon_sym_export] = ACTIONS(3956),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3954),
    [anon_sym_namespace] = ACTIONS(3954),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3978),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3964),
    [anon_sym_readonly] = ACTIONS(3966),
    [anon_sym_get] = ACTIONS(3968),
    [anon_sym_set] = ACTIONS(3968),
    [anon_sym_declare] = ACTIONS(3954),
    [anon_sym_public] = ACTIONS(3970),
    [anon_sym_private] = ACTIONS(3970),
    [anon_sym_protected] = ACTIONS(3970),
    [anon_sym_override] = ACTIONS(3972),
    [anon_sym_module] = ACTIONS(3954),
    [anon_sym_any] = ACTIONS(3954),
    [anon_sym_number] = ACTIONS(3954),
    [anon_sym_boolean] = ACTIONS(3954),
    [anon_sym_string] = ACTIONS(3954),
    [anon_sym_symbol] = ACTIONS(3954),
    [anon_sym_object] = ACTIONS(3954),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3912),
    [sym_html_comment] = ACTIONS(5),
  },
  [1674] = {
    [sym_export_statement] = STATE(4797),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6145),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1674),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4797),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4797),
    [sym_property_signature] = STATE(4797),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4797),
    [sym_index_signature] = STATE(4797),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3934),
    [anon_sym_export] = ACTIONS(3936),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3934),
    [anon_sym_namespace] = ACTIONS(3934),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3976),
    [anon_sym_let] = ACTIONS(3934),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3944),
    [anon_sym_readonly] = ACTIONS(3946),
    [anon_sym_get] = ACTIONS(3948),
    [anon_sym_set] = ACTIONS(3948),
    [anon_sym_declare] = ACTIONS(3934),
    [anon_sym_public] = ACTIONS(3950),
    [anon_sym_private] = ACTIONS(3950),
    [anon_sym_protected] = ACTIONS(3950),
    [anon_sym_override] = ACTIONS(3952),
    [anon_sym_module] = ACTIONS(3934),
    [anon_sym_any] = ACTIONS(3934),
    [anon_sym_number] = ACTIONS(3934),
    [anon_sym_boolean] = ACTIONS(3934),
    [anon_sym_string] = ACTIONS(3934),
    [anon_sym_symbol] = ACTIONS(3934),
    [anon_sym_object] = ACTIONS(3934),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3912),
    [sym_html_comment] = ACTIONS(5),
  },
  [1675] = {
    [sym_export_statement] = STATE(4797),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(5740),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1675),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(5740),
    [sym_pair] = STATE(5740),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4797),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4797),
    [sym_property_signature] = STATE(4797),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4797),
    [sym_index_signature] = STATE(4797),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(5792),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3874),
    [anon_sym_export] = ACTIONS(3876),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3874),
    [anon_sym_namespace] = ACTIONS(3874),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3980),
    [anon_sym_let] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3892),
    [anon_sym_new] = ACTIONS(3894),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_readonly] = ACTIONS(3902),
    [anon_sym_get] = ACTIONS(3904),
    [anon_sym_set] = ACTIONS(3904),
    [anon_sym_declare] = ACTIONS(3874),
    [anon_sym_public] = ACTIONS(3906),
    [anon_sym_private] = ACTIONS(3906),
    [anon_sym_protected] = ACTIONS(3906),
    [anon_sym_override] = ACTIONS(3908),
    [anon_sym_module] = ACTIONS(3874),
    [anon_sym_any] = ACTIONS(3874),
    [anon_sym_number] = ACTIONS(3874),
    [anon_sym_boolean] = ACTIONS(3874),
    [anon_sym_string] = ACTIONS(3874),
    [anon_sym_symbol] = ACTIONS(3874),
    [anon_sym_object] = ACTIONS(3874),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3912),
    [sym_html_comment] = ACTIONS(5),
  },
  [1676] = {
    [sym_export_statement] = STATE(4797),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6145),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1676),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4797),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4797),
    [sym_property_signature] = STATE(4797),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4797),
    [sym_index_signature] = STATE(4797),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3982),
    [anon_sym_export] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3982),
    [anon_sym_namespace] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3986),
    [anon_sym_let] = ACTIONS(3982),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3988),
    [anon_sym_new] = ACTIONS(3990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_readonly] = ACTIONS(3994),
    [anon_sym_get] = ACTIONS(3996),
    [anon_sym_set] = ACTIONS(3996),
    [anon_sym_declare] = ACTIONS(3982),
    [anon_sym_public] = ACTIONS(3998),
    [anon_sym_private] = ACTIONS(3998),
    [anon_sym_protected] = ACTIONS(3998),
    [anon_sym_override] = ACTIONS(4000),
    [anon_sym_module] = ACTIONS(3982),
    [anon_sym_any] = ACTIONS(3982),
    [anon_sym_number] = ACTIONS(3982),
    [anon_sym_boolean] = ACTIONS(3982),
    [anon_sym_string] = ACTIONS(3982),
    [anon_sym_symbol] = ACTIONS(3982),
    [anon_sym_object] = ACTIONS(3982),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3912),
    [sym_html_comment] = ACTIONS(5),
  },
  [1677] = {
    [sym_export_statement] = STATE(4797),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6145),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1677),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4797),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4797),
    [sym_property_signature] = STATE(4797),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4797),
    [sym_index_signature] = STATE(4797),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_export] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3914),
    [anon_sym_namespace] = ACTIONS(3914),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3986),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(3922),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3924),
    [anon_sym_readonly] = ACTIONS(3926),
    [anon_sym_get] = ACTIONS(3928),
    [anon_sym_set] = ACTIONS(3928),
    [anon_sym_declare] = ACTIONS(3914),
    [anon_sym_public] = ACTIONS(3930),
    [anon_sym_private] = ACTIONS(3930),
    [anon_sym_protected] = ACTIONS(3930),
    [anon_sym_override] = ACTIONS(3932),
    [anon_sym_module] = ACTIONS(3914),
    [anon_sym_any] = ACTIONS(3914),
    [anon_sym_number] = ACTIONS(3914),
    [anon_sym_boolean] = ACTIONS(3914),
    [anon_sym_string] = ACTIONS(3914),
    [anon_sym_symbol] = ACTIONS(3914),
    [anon_sym_object] = ACTIONS(3914),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3912),
    [sym_html_comment] = ACTIONS(5),
  },
  [1678] = {
    [sym_export_statement] = STATE(4679),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(5739),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6145),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1678),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(5739),
    [sym_method_definition] = STATE(6145),
    [sym_pair] = STATE(6145),
    [sym_pair_pattern] = STATE(5739),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4679),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4679),
    [sym_property_signature] = STATE(4679),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4679),
    [sym_index_signature] = STATE(4679),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [aux_sym_object_repeat1] = STATE(6146),
    [aux_sym_object_pattern_repeat1] = STATE(5743),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_export] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3914),
    [anon_sym_namespace] = ACTIONS(3914),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(4002),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(3922),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3924),
    [anon_sym_readonly] = ACTIONS(3926),
    [anon_sym_get] = ACTIONS(3928),
    [anon_sym_set] = ACTIONS(3928),
    [anon_sym_declare] = ACTIONS(3914),
    [anon_sym_public] = ACTIONS(3930),
    [anon_sym_private] = ACTIONS(3930),
    [anon_sym_protected] = ACTIONS(3930),
    [anon_sym_override] = ACTIONS(3932),
    [anon_sym_module] = ACTIONS(3914),
    [anon_sym_any] = ACTIONS(3914),
    [anon_sym_number] = ACTIONS(3914),
    [anon_sym_boolean] = ACTIONS(3914),
    [anon_sym_string] = ACTIONS(3914),
    [anon_sym_symbol] = ACTIONS(3914),
    [anon_sym_object] = ACTIONS(3914),
    [anon_sym_abstract] = ACTIONS(3910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4008),
    [sym_html_comment] = ACTIONS(5),
  },
  [1679] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1679),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5448),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(4010),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1680] = {
    [sym_nested_identifier] = STATE(962),
    [sym_string] = STATE(1161),
    [sym_comment] = STATE(1680),
    [sym__module] = STATE(1517),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4012),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4014),
    [anon_sym_SQUOTE] = ACTIONS(4016),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1681] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1681),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5451),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(4018),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1682] = {
    [sym_nested_identifier] = STATE(962),
    [sym_string] = STATE(1161),
    [sym_comment] = STATE(1682),
    [sym__module] = STATE(1517),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4012),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4014),
    [anon_sym_SQUOTE] = ACTIONS(4016),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1683] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1683),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5437),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(4020),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1684] = {
    [sym_nested_identifier] = STATE(372),
    [sym_string] = STATE(373),
    [sym_comment] = STATE(1684),
    [sym__module] = STATE(453),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4024),
    [anon_sym_SQUOTE] = ACTIONS(4026),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1685] = {
    [sym_variable_declarator] = STATE(5443),
    [sym_object_pattern] = STATE(4389),
    [sym_array_pattern] = STATE(4389),
    [sym__destructuring_pattern] = STATE(4574),
    [sym_comment] = STATE(1685),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4028),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4030),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1686] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1686),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5412),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1687] = {
    [sym_nested_identifier] = STATE(372),
    [sym_string] = STATE(373),
    [sym_comment] = STATE(1687),
    [sym__module] = STATE(453),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4024),
    [anon_sym_SQUOTE] = ACTIONS(4026),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1688] = {
    [sym_variable_declarator] = STATE(5443),
    [sym_object_pattern] = STATE(4389),
    [sym_array_pattern] = STATE(4389),
    [sym__destructuring_pattern] = STATE(4574),
    [sym_comment] = STATE(1688),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4028),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4030),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1689] = {
    [sym_nested_identifier] = STATE(962),
    [sym_string] = STATE(1161),
    [sym_comment] = STATE(1689),
    [sym__module] = STATE(1517),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4012),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4014),
    [anon_sym_SQUOTE] = ACTIONS(4016),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1690] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1690),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4791),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(4036),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [sym_jsx_identifier] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1691] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1691),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5590),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_RBRACK] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1692] = {
    [sym_variable_declarator] = STATE(5443),
    [sym_object_pattern] = STATE(4389),
    [sym_array_pattern] = STATE(4389),
    [sym__destructuring_pattern] = STATE(4574),
    [sym_comment] = STATE(1692),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4028),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4030),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1693] = {
    [sym_nested_identifier] = STATE(372),
    [sym_string] = STATE(373),
    [sym_comment] = STATE(1693),
    [sym__module] = STATE(453),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4024),
    [anon_sym_SQUOTE] = ACTIONS(4026),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1694] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1694),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1695] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1695),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4293),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1696] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1696),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4099),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1697] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1697),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4097),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1698] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1698),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5580),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1699] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1699),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(6165),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3692),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1700] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1700),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(6165),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3699),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1701] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1701),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5383),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1702] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1702),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5314),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1703] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1703),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5227),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1704] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1704),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2338),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(4048),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1705] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1705),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5353),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1706] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1706),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4267),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1707] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1707),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4271),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1708] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1708),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(6000),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(2296),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1709] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1709),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2829),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1710] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1710),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2720),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1711] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1711),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3701),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1712] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1712),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2832),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1713] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1713),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2363),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1714] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1714),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2880),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1715] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1715),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5397),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1716] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1716),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3732),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1717] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1717),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2365),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1718] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1718),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3705),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1719] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1719),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5334),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1720] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1720),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4069),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1721] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1721),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3734),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1722] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1722),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3785),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1723] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1723),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2251),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1724] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1724),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2858),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1725] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1725),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2857),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1726] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1726),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5453),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1727] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1727),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2847),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1728] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1728),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5592),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1729] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1729),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(3970),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1730] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1730),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2255),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1731] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1731),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4200),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1732] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1732),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2742),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1733] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1733),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3768),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1734] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1734),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5406),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1735] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1735),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3769),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1736] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1736),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3784),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1737] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1737),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(6311),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(2846),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1738] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1738),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5574),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1739] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1739),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5122),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1740] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1740),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2873),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1741] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1741),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(6311),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(2844),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1742] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1742),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5530),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1743] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1743),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2753),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(4056),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1744] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1744),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5320),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1745] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1745),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(3994),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1746] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1746),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2282),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1747] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1747),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(3995),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1748] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1748),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2337),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1749] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1749),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4294),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1750] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1750),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5417),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1751] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1751),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3727),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1752] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1752),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(6165),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(5388),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(5427),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1753] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1753),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2849),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1754] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1754),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(4014),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1755] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1755),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5528),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1756] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1756),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2280),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1757] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1757),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2841),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1758] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1758),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5268),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1759] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1759),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5428),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1760] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1760),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2236),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1761] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1761),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(4013),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1762] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1762),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(4982),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1763] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1763),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(4305),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1764] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1764),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(4304),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1765] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1765),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(4303),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1766] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1766),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4244),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1767] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1767),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4241),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1768] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1768),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5426),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1769] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1769),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5474),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1770] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1770),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(3986),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1771] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1771),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5151),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1772] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1772),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4232),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1773] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1773),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5500),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1774] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1774),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2270),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1775] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1775),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2271),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1776] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1776),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3688),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1777] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1777),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(4988),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1778] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1778),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3708),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1779] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1779),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(6249),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(4231),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1780] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1780),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5536),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1781] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1781),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4162),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1782] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1782),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5710),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(4021),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1783] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1783),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(6249),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(4228),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1784] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1784),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(3968),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1785] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1785),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5259),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1786] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1786),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5710),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(4019),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1787] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1787),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(3967),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1788] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1788),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2336),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1789] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1789),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4791),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1790] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1790),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(3974),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1791] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1791),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2743),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1792] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1792),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(6000),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(2281),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1793] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1793),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2734),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1794] = {
    [sym_nested_identifier] = STATE(7161),
    [sym_string] = STATE(4286),
    [sym_comment] = STATE(1794),
    [sym_formal_parameters] = STATE(7313),
    [sym_nested_type_identifier] = STATE(3987),
    [sym__type] = STATE(4157),
    [sym_constructor_type] = STATE(4279),
    [sym__primary_type] = STATE(4277),
    [sym_template_literal_type] = STATE(4298),
    [sym_infer_type] = STATE(4279),
    [sym_conditional_type] = STATE(4298),
    [sym_generic_type] = STATE(4298),
    [sym_type_query] = STATE(4298),
    [sym_index_type_query] = STATE(4298),
    [sym_lookup_type] = STATE(4298),
    [sym_literal_type] = STATE(4298),
    [sym__number] = STATE(4253),
    [sym_existential_type] = STATE(4298),
    [sym_flow_maybe_type] = STATE(4298),
    [sym_parenthesized_type] = STATE(4298),
    [sym_predefined_type] = STATE(4298),
    [sym_object_type] = STATE(4298),
    [sym_type_parameters] = STATE(6810),
    [sym_array_type] = STATE(4298),
    [sym_tuple_type] = STATE(4298),
    [sym_readonly_type] = STATE(4279),
    [sym_union_type] = STATE(4298),
    [sym_intersection_type] = STATE(4298),
    [sym_function_type] = STATE(4279),
    [sym_identifier] = ACTIONS(4042),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_typeof] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_LPAREN] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3666),
    [anon_sym_AMP] = ACTIONS(3668),
    [anon_sym_PIPE] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3676),
    [sym_number] = ACTIONS(3678),
    [sym_this] = ACTIONS(4044),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_any] = ACTIONS(3674),
    [anon_sym_number] = ACTIONS(3674),
    [anon_sym_boolean] = ACTIONS(3674),
    [anon_sym_string] = ACTIONS(3674),
    [anon_sym_symbol] = ACTIONS(3674),
    [anon_sym_object] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3686),
    [anon_sym_infer] = ACTIONS(3690),
    [anon_sym_keyof] = ACTIONS(3692),
    [anon_sym_unique] = ACTIONS(3694),
    [anon_sym_unknown] = ACTIONS(3674),
    [anon_sym_never] = ACTIONS(3674),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3652),
    [sym_html_comment] = ACTIONS(5),
  },
  [1795] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1795),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5244),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1796] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1796),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2261),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1797] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1797),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5233),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1798] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1798),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5065),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1799] = {
    [sym_nested_identifier] = STATE(7170),
    [sym_string] = STATE(2890),
    [sym_comment] = STATE(1799),
    [sym_formal_parameters] = STATE(7340),
    [sym_nested_type_identifier] = STATE(2590),
    [sym__type] = STATE(2718),
    [sym_constructor_type] = STATE(2897),
    [sym__primary_type] = STATE(2898),
    [sym_template_literal_type] = STATE(2886),
    [sym_infer_type] = STATE(2897),
    [sym_conditional_type] = STATE(2886),
    [sym_generic_type] = STATE(2886),
    [sym_type_query] = STATE(2886),
    [sym_index_type_query] = STATE(2886),
    [sym_lookup_type] = STATE(2886),
    [sym_literal_type] = STATE(2886),
    [sym__number] = STATE(2899),
    [sym_existential_type] = STATE(2886),
    [sym_flow_maybe_type] = STATE(2886),
    [sym_parenthesized_type] = STATE(2886),
    [sym_predefined_type] = STATE(2886),
    [sym_object_type] = STATE(2886),
    [sym_type_parameters] = STATE(6726),
    [sym_array_type] = STATE(2886),
    [sym_tuple_type] = STATE(2886),
    [sym_readonly_type] = STATE(2897),
    [sym_union_type] = STATE(2886),
    [sym_intersection_type] = STATE(2886),
    [sym_function_type] = STATE(2897),
    [sym_identifier] = ACTIONS(4052),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_LBRACE] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3836),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_AMP] = ACTIONS(3846),
    [anon_sym_PIPE] = ACTIONS(3848),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3852),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3854),
    [sym_number] = ACTIONS(3856),
    [sym_this] = ACTIONS(4054),
    [sym_true] = ACTIONS(3856),
    [sym_false] = ACTIONS(3856),
    [sym_null] = ACTIONS(3856),
    [sym_undefined] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3860),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_any] = ACTIONS(3852),
    [anon_sym_number] = ACTIONS(3852),
    [anon_sym_boolean] = ACTIONS(3852),
    [anon_sym_string] = ACTIONS(3852),
    [anon_sym_symbol] = ACTIONS(3852),
    [anon_sym_object] = ACTIONS(3852),
    [anon_sym_abstract] = ACTIONS(3864),
    [anon_sym_infer] = ACTIONS(3868),
    [anon_sym_keyof] = ACTIONS(3870),
    [anon_sym_unique] = ACTIONS(3872),
    [anon_sym_unknown] = ACTIONS(3852),
    [anon_sym_never] = ACTIONS(3852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [sym_html_comment] = ACTIONS(5),
  },
  [1800] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1800),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(4000),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1801] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1801),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(3982),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1802] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1802),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5496),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1803] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1803),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5585),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1804] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1804),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5202),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1805] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1805),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5497),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1806] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1806),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5343),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1807] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1807),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(3971),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1808] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1808),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5588),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1809] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1809),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(5589),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1810] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1810),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(3990),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1811] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1811),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2279),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1812] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1812),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(3783),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1813] = {
    [sym_nested_identifier] = STATE(7046),
    [sym_string] = STATE(2318),
    [sym_comment] = STATE(1813),
    [sym_formal_parameters] = STATE(7001),
    [sym_nested_type_identifier] = STATE(2222),
    [sym__type] = STATE(2254),
    [sym_constructor_type] = STATE(2373),
    [sym__primary_type] = STATE(2228),
    [sym_template_literal_type] = STATE(2259),
    [sym_infer_type] = STATE(2373),
    [sym_conditional_type] = STATE(2259),
    [sym_generic_type] = STATE(2259),
    [sym_type_query] = STATE(2259),
    [sym_index_type_query] = STATE(2259),
    [sym_lookup_type] = STATE(2259),
    [sym_literal_type] = STATE(2259),
    [sym__number] = STATE(2380),
    [sym_existential_type] = STATE(2259),
    [sym_flow_maybe_type] = STATE(2259),
    [sym_parenthesized_type] = STATE(2259),
    [sym_predefined_type] = STATE(2259),
    [sym_object_type] = STATE(2259),
    [sym_type_parameters] = STATE(6884),
    [sym_array_type] = STATE(2259),
    [sym_tuple_type] = STATE(2259),
    [sym_readonly_type] = STATE(2373),
    [sym_union_type] = STATE(2259),
    [sym_intersection_type] = STATE(2259),
    [sym_function_type] = STATE(2373),
    [sym_identifier] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_typeof] = ACTIONS(3792),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3796),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(3808),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3810),
    [sym_number] = ACTIONS(3812),
    [sym_this] = ACTIONS(4050),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [sym_null] = ACTIONS(3812),
    [sym_undefined] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3816),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_any] = ACTIONS(3808),
    [anon_sym_number] = ACTIONS(3808),
    [anon_sym_boolean] = ACTIONS(3808),
    [anon_sym_string] = ACTIONS(3808),
    [anon_sym_symbol] = ACTIONS(3808),
    [anon_sym_object] = ACTIONS(3808),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_infer] = ACTIONS(3824),
    [anon_sym_keyof] = ACTIONS(3826),
    [anon_sym_unique] = ACTIONS(3828),
    [anon_sym_unknown] = ACTIONS(3808),
    [anon_sym_never] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
    [sym_html_comment] = ACTIONS(5),
  },
  [1814] = {
    [sym_nested_identifier] = STATE(7011),
    [sym_string] = STATE(3758),
    [sym_comment] = STATE(1814),
    [sym_formal_parameters] = STATE(7012),
    [sym_nested_type_identifier] = STATE(3662),
    [sym__type] = STATE(4836),
    [sym_constructor_type] = STATE(3763),
    [sym__primary_type] = STATE(3681),
    [sym_template_literal_type] = STATE(3753),
    [sym_infer_type] = STATE(3763),
    [sym_conditional_type] = STATE(3753),
    [sym_generic_type] = STATE(3753),
    [sym_type_query] = STATE(3753),
    [sym_index_type_query] = STATE(3753),
    [sym_lookup_type] = STATE(3753),
    [sym_literal_type] = STATE(3753),
    [sym__number] = STATE(3765),
    [sym_existential_type] = STATE(3753),
    [sym_flow_maybe_type] = STATE(3753),
    [sym_parenthesized_type] = STATE(3753),
    [sym_predefined_type] = STATE(3753),
    [sym_object_type] = STATE(3753),
    [sym_type_parameters] = STATE(6946),
    [sym_array_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_readonly_type] = STATE(3763),
    [sym_union_type] = STATE(3753),
    [sym_intersection_type] = STATE(3753),
    [sym_function_type] = STATE(3763),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(130),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1910),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(207),
    [anon_sym_number] = ACTIONS(207),
    [anon_sym_boolean] = ACTIONS(207),
    [anon_sym_string] = ACTIONS(207),
    [anon_sym_symbol] = ACTIONS(207),
    [anon_sym_object] = ACTIONS(207),
    [anon_sym_abstract] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(201),
    [anon_sym_keyof] = ACTIONS(203),
    [anon_sym_unique] = ACTIONS(205),
    [anon_sym_unknown] = ACTIONS(207),
    [anon_sym_never] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1815] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1815),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5046),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1816] = {
    [sym_nested_identifier] = STATE(7025),
    [sym_string] = STATE(3992),
    [sym_comment] = STATE(1816),
    [sym_formal_parameters] = STATE(7448),
    [sym_nested_type_identifier] = STATE(3882),
    [sym__type] = STATE(5099),
    [sym_constructor_type] = STATE(3996),
    [sym__primary_type] = STATE(3997),
    [sym_template_literal_type] = STATE(3991),
    [sym_infer_type] = STATE(3996),
    [sym_conditional_type] = STATE(3991),
    [sym_generic_type] = STATE(3991),
    [sym_type_query] = STATE(3991),
    [sym_index_type_query] = STATE(3991),
    [sym_lookup_type] = STATE(3991),
    [sym_literal_type] = STATE(3991),
    [sym__number] = STATE(3999),
    [sym_existential_type] = STATE(3991),
    [sym_flow_maybe_type] = STATE(3991),
    [sym_parenthesized_type] = STATE(3991),
    [sym_predefined_type] = STATE(3991),
    [sym_object_type] = STATE(3991),
    [sym_type_parameters] = STATE(6928),
    [sym_array_type] = STATE(3991),
    [sym_tuple_type] = STATE(3991),
    [sym_readonly_type] = STATE(3996),
    [sym_union_type] = STATE(3991),
    [sym_intersection_type] = STATE(3991),
    [sym_function_type] = STATE(3996),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1914),
    [anon_sym_const] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1342),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1330),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_infer] = ACTIONS(1336),
    [anon_sym_keyof] = ACTIONS(1338),
    [anon_sym_unique] = ACTIONS(1340),
    [anon_sym_unknown] = ACTIONS(1342),
    [anon_sym_never] = ACTIONS(1342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1344),
    [sym_html_comment] = ACTIONS(5),
  },
  [1817] = {
    [sym_nested_identifier] = STATE(2346),
    [sym_string] = STATE(2345),
    [sym_comment] = STATE(1817),
    [sym__module] = STATE(2460),
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1818] = {
    [sym_nested_identifier] = STATE(2346),
    [sym_string] = STATE(2345),
    [sym_comment] = STATE(1818),
    [sym__module] = STATE(2460),
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(216),
    [anon_sym_RBRACE] = ACTIONS(216),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_RPAREN] = ACTIONS(216),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1819] = {
    [sym_nested_identifier] = STATE(2346),
    [sym_string] = STATE(2345),
    [sym_comment] = STATE(1819),
    [sym__module] = STATE(2460),
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(1105),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1820] = {
    [sym_nested_identifier] = STATE(2346),
    [sym_string] = STATE(2345),
    [sym_comment] = STATE(1820),
    [sym__module] = STATE(2460),
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1821] = {
    [sym_export_statement] = STATE(4680),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(6820),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6775),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1821),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(6820),
    [sym_method_definition] = STATE(6775),
    [sym_pair] = STATE(6775),
    [sym_pair_pattern] = STATE(6820),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4680),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4680),
    [sym_property_signature] = STATE(4680),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4680),
    [sym_index_signature] = STATE(4680),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [sym_identifier] = ACTIONS(4060),
    [anon_sym_export] = ACTIONS(4062),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(4060),
    [anon_sym_namespace] = ACTIONS(4060),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(4064),
    [anon_sym_RBRACE] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4060),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(4067),
    [anon_sym_new] = ACTIONS(4069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4071),
    [anon_sym_readonly] = ACTIONS(4073),
    [anon_sym_get] = ACTIONS(4075),
    [anon_sym_set] = ACTIONS(4075),
    [anon_sym_declare] = ACTIONS(4060),
    [anon_sym_public] = ACTIONS(4077),
    [anon_sym_private] = ACTIONS(4077),
    [anon_sym_protected] = ACTIONS(4077),
    [anon_sym_override] = ACTIONS(4079),
    [anon_sym_module] = ACTIONS(4060),
    [anon_sym_any] = ACTIONS(4060),
    [anon_sym_number] = ACTIONS(4060),
    [anon_sym_boolean] = ACTIONS(4060),
    [anon_sym_string] = ACTIONS(4060),
    [anon_sym_symbol] = ACTIONS(4060),
    [anon_sym_object] = ACTIONS(4060),
    [anon_sym_abstract] = ACTIONS(3910),
    [sym_html_comment] = ACTIONS(5),
  },
  [1822] = {
    [sym_nested_identifier] = STATE(2346),
    [sym_string] = STATE(2345),
    [sym_comment] = STATE(1822),
    [sym__module] = STATE(2460),
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1823] = {
    [sym_export_statement] = STATE(4719),
    [sym_object_pattern] = STATE(4288),
    [sym_object_assignment_pattern] = STATE(6820),
    [sym_array_pattern] = STATE(4288),
    [sym__call_signature] = STATE(5095),
    [sym__destructuring_pattern] = STATE(7130),
    [sym_spread_element] = STATE(6775),
    [sym_string] = STATE(3980),
    [sym_comment] = STATE(1823),
    [sym_decorator] = STATE(5410),
    [sym_formal_parameters] = STATE(4055),
    [sym_rest_pattern] = STATE(6820),
    [sym_method_definition] = STATE(6775),
    [sym_pair] = STATE(6775),
    [sym_pair_pattern] = STATE(6820),
    [sym__property_name] = STATE(3844),
    [sym_computed_property_name] = STATE(3980),
    [sym_method_signature] = STATE(4719),
    [sym_accessibility_modifier] = STATE(3477),
    [sym_override_modifier] = STATE(3526),
    [sym_call_signature] = STATE(4719),
    [sym_property_signature] = STATE(4719),
    [sym_type_parameters] = STATE(6769),
    [sym_construct_signature] = STATE(4719),
    [sym_index_signature] = STATE(4719),
    [aux_sym_export_statement_repeat1] = STATE(5563),
    [sym_identifier] = ACTIONS(4060),
    [anon_sym_export] = ACTIONS(4062),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(4060),
    [anon_sym_namespace] = ACTIONS(4060),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(4064),
    [anon_sym_RBRACE] = ACTIONS(4064),
    [anon_sym_let] = ACTIONS(4060),
    [anon_sym_LPAREN] = ACTIONS(3886),
    [anon_sym_LBRACK] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(4067),
    [anon_sym_new] = ACTIONS(4069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [anon_sym_LT] = ACTIONS(1902),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3898),
    [sym_private_property_identifier] = ACTIONS(3898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4071),
    [anon_sym_readonly] = ACTIONS(4073),
    [anon_sym_get] = ACTIONS(4075),
    [anon_sym_set] = ACTIONS(4075),
    [anon_sym_declare] = ACTIONS(4060),
    [anon_sym_public] = ACTIONS(4077),
    [anon_sym_private] = ACTIONS(4077),
    [anon_sym_protected] = ACTIONS(4077),
    [anon_sym_override] = ACTIONS(4079),
    [anon_sym_module] = ACTIONS(4060),
    [anon_sym_any] = ACTIONS(4060),
    [anon_sym_number] = ACTIONS(4060),
    [anon_sym_boolean] = ACTIONS(4060),
    [anon_sym_string] = ACTIONS(4060),
    [anon_sym_symbol] = ACTIONS(4060),
    [anon_sym_object] = ACTIONS(4060),
    [anon_sym_abstract] = ACTIONS(3910),
    [sym_html_comment] = ACTIONS(5),
  },
  [1824] = {
    [sym_nested_identifier] = STATE(308),
    [sym_string] = STATE(307),
    [sym_comment] = STATE(1824),
    [sym__module] = STATE(408),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4083),
    [anon_sym_SQUOTE] = ACTIONS(4085),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1825] = {
    [sym_nested_identifier] = STATE(5073),
    [sym_string] = STATE(5616),
    [sym_comment] = STATE(1825),
    [sym__module] = STATE(6527),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1896),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1826] = {
    [sym_nested_identifier] = STATE(293),
    [sym_string] = STATE(291),
    [sym_comment] = STATE(1826),
    [sym__module] = STATE(319),
    [sym_identifier] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4091),
    [anon_sym_SQUOTE] = ACTIONS(4093),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1827] = {
    [sym_variable_declarator] = STATE(5481),
    [sym_object_pattern] = STATE(4389),
    [sym_array_pattern] = STATE(4389),
    [sym__destructuring_pattern] = STATE(4574),
    [sym_comment] = STATE(1827),
    [sym_identifier] = ACTIONS(4028),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4030),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1828] = {
    [sym_nested_identifier] = STATE(372),
    [sym_string] = STATE(373),
    [sym_comment] = STATE(1828),
    [sym__module] = STATE(453),
    [sym_identifier] = ACTIONS(4022),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4024),
    [anon_sym_SQUOTE] = ACTIONS(4026),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1829] = {
    [sym_variable_declarator] = STATE(5572),
    [sym_object_pattern] = STATE(4389),
    [sym_array_pattern] = STATE(4389),
    [sym__destructuring_pattern] = STATE(4574),
    [sym_comment] = STATE(1829),
    [sym_identifier] = ACTIONS(4028),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4030),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1830] = {
    [sym_nested_identifier] = STATE(891),
    [sym_string] = STATE(912),
    [sym_comment] = STATE(1830),
    [sym__module] = STATE(1083),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4097),
    [anon_sym_SQUOTE] = ACTIONS(4099),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1831] = {
    [sym_variable_declarator] = STATE(5443),
    [sym_object_pattern] = STATE(4389),
    [sym_array_pattern] = STATE(4389),
    [sym__destructuring_pattern] = STATE(4574),
    [sym_comment] = STATE(1831),
    [sym_identifier] = ACTIONS(4028),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4030),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1832] = {
    [sym_nested_identifier] = STATE(930),
    [sym_string] = STATE(1068),
    [sym_comment] = STATE(1832),
    [sym__module] = STATE(1331),
    [sym_identifier] = ACTIONS(4101),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_SQUOTE] = ACTIONS(4105),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1833] = {
    [sym_nested_identifier] = STATE(2217),
    [sym_string] = STATE(2221),
    [sym_comment] = STATE(1833),
    [sym__module] = STATE(2459),
    [sym_identifier] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1834] = {
    [sym_nested_identifier] = STATE(2217),
    [sym_string] = STATE(2221),
    [sym_comment] = STATE(1834),
    [sym__module] = STATE(2459),
    [sym_identifier] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(1179),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1835] = {
    [sym_variable_declarator] = STATE(5575),
    [sym_object_pattern] = STATE(4389),
    [sym_array_pattern] = STATE(4389),
    [sym__destructuring_pattern] = STATE(4574),
    [sym_comment] = STATE(1835),
    [sym_identifier] = ACTIONS(4028),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4030),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1836] = {
    [sym_nested_identifier] = STATE(2217),
    [sym_string] = STATE(2221),
    [sym_comment] = STATE(1836),
    [sym__module] = STATE(2459),
    [sym_identifier] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1837] = {
    [sym_nested_identifier] = STATE(947),
    [sym_string] = STATE(1041),
    [sym_comment] = STATE(1837),
    [sym__module] = STATE(1375),
    [sym_identifier] = ACTIONS(4109),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [anon_sym_SQUOTE] = ACTIONS(4113),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1838] = {
    [sym_variable_declarator] = STATE(5459),
    [sym_object_pattern] = STATE(4389),
    [sym_array_pattern] = STATE(4389),
    [sym__destructuring_pattern] = STATE(4574),
    [sym_comment] = STATE(1838),
    [sym_identifier] = ACTIONS(4028),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4030),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1839] = {
    [sym_nested_identifier] = STATE(297),
    [sym_string] = STATE(298),
    [sym_comment] = STATE(1839),
    [sym__module] = STATE(384),
    [sym_identifier] = ACTIONS(4115),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4117),
    [anon_sym_SQUOTE] = ACTIONS(4119),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1840] = {
    [sym_nested_identifier] = STATE(2346),
    [sym_string] = STATE(2345),
    [sym_comment] = STATE(1840),
    [sym__module] = STATE(2460),
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(1179),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1841] = {
    [sym_nested_identifier] = STATE(2346),
    [sym_string] = STATE(2345),
    [sym_comment] = STATE(1841),
    [sym__module] = STATE(2460),
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(1208),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(219),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1842] = {
    [sym_nested_identifier] = STATE(2346),
    [sym_string] = STATE(2345),
    [sym_comment] = STATE(1842),
    [sym__module] = STATE(2460),
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1843] = {
    [sym_nested_identifier] = STATE(2217),
    [sym_string] = STATE(2221),
    [sym_comment] = STATE(1843),
    [sym__module] = STATE(2459),
    [sym_identifier] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_of] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1844] = {
    [sym_variable_declarator] = STATE(5540),
    [sym_object_pattern] = STATE(4389),
    [sym_array_pattern] = STATE(4389),
    [sym__destructuring_pattern] = STATE(4072),
    [sym_comment] = STATE(1844),
    [sym_identifier] = ACTIONS(4121),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4030),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_of] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1845] = {
    [sym_nested_identifier] = STATE(962),
    [sym_string] = STATE(1161),
    [sym_comment] = STATE(1845),
    [sym__module] = STATE(1517),
    [sym_identifier] = ACTIONS(4012),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4014),
    [anon_sym_SQUOTE] = ACTIONS(4016),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1846] = {
    [sym_comment] = STATE(1846),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4123),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1847] = {
    [sym_nested_identifier] = STATE(2346),
    [sym_string] = STATE(2345),
    [sym_comment] = STATE(1847),
    [sym__module] = STATE(2460),
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(1266),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1848] = {
    [sym_comment] = STATE(1848),
    [aux_sym_object_repeat1] = STATE(5868),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4123),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1849] = {
    [sym_nested_identifier] = STATE(2346),
    [sym_string] = STATE(2345),
    [sym_comment] = STATE(1849),
    [sym__module] = STATE(2460),
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(1266),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1850] = {
    [sym_nested_identifier] = STATE(2346),
    [sym_string] = STATE(2345),
    [sym_comment] = STATE(1850),
    [sym__module] = STATE(2460),
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(145),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1851] = {
    [sym_comment] = STATE(1851),
    [aux_sym_object_repeat1] = STATE(6261),
    [aux_sym_object_pattern_repeat1] = STATE(5869),
    [sym_identifier] = ACTIONS(4123),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2693),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(979),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(159),
    [anon_sym_DASH_EQ] = ACTIONS(159),
    [anon_sym_STAR_EQ] = ACTIONS(159),
    [anon_sym_SLASH_EQ] = ACTIONS(159),
    [anon_sym_PERCENT_EQ] = ACTIONS(159),
    [anon_sym_CARET_EQ] = ACTIONS(159),
    [anon_sym_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(159),
    [anon_sym_LT_LT_EQ] = ACTIONS(159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(159),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(159),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym__ternary_qmark] = ACTIONS(211),
    [sym_html_comment] = ACTIONS(5),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4109), 1,
      sym_identifier,
    ACTIONS(4111), 1,
      anon_sym_DQUOTE,
    ACTIONS(4113), 1,
      anon_sym_SQUOTE,
    STATE(947), 1,
      sym_nested_identifier,
    STATE(1041), 1,
      sym_string,
    STATE(1375), 1,
      sym__module,
    STATE(1852), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1853), 1,
      sym_comment,
    ACTIONS(4125), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4127), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [168] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1854), 1,
      sym_comment,
    ACTIONS(4129), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4131), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [243] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4095), 1,
      sym_identifier,
    ACTIONS(4097), 1,
      anon_sym_DQUOTE,
    ACTIONS(4099), 1,
      anon_sym_SQUOTE,
    STATE(891), 1,
      sym_nested_identifier,
    STATE(912), 1,
      sym_string,
    STATE(1083), 1,
      sym__module,
    STATE(1855), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [336] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(960), 1,
      anon_sym_EQ,
    ACTIONS(987), 1,
      anon_sym_QMARK,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2680), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2693), 1,
      anon_sym_LT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2710), 1,
      anon_sym_RBRACE,
    STATE(1856), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [431] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1857), 1,
      sym_comment,
    ACTIONS(4133), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4135), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [506] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1220), 1,
      anon_sym_COLON,
    ACTIONS(1224), 1,
      anon_sym_EQ_GT,
    ACTIONS(1272), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1858), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [601] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4022), 1,
      sym_identifier,
    ACTIONS(4024), 1,
      anon_sym_DQUOTE,
    ACTIONS(4026), 1,
      anon_sym_SQUOTE,
    STATE(372), 1,
      sym_nested_identifier,
    STATE(373), 1,
      sym_string,
    STATE(453), 1,
      sym__module,
    STATE(1859), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [694] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(124), 1,
      anon_sym_COMMA,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(216), 1,
      anon_sym_RBRACK,
    ACTIONS(1215), 1,
      anon_sym_EQ,
    ACTIONS(1224), 1,
      anon_sym_EQ_GT,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1860), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [791] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    STATE(1861), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5459), 1,
      sym_variable_declarator,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [884] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    STATE(1862), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5443), 1,
      sym_variable_declarator,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [977] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4012), 1,
      sym_identifier,
    ACTIONS(4014), 1,
      anon_sym_DQUOTE,
    ACTIONS(4016), 1,
      anon_sym_SQUOTE,
    STATE(962), 1,
      sym_nested_identifier,
    STATE(1161), 1,
      sym_string,
    STATE(1517), 1,
      sym__module,
    STATE(1863), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1070] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    STATE(1864), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4143), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4147), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1167] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    STATE(1865), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5481), 1,
      sym_variable_declarator,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1260] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4159), 1,
      anon_sym_LPAREN,
    ACTIONS(4161), 1,
      anon_sym_DOT,
    ACTIONS(4163), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4165), 1,
      anon_sym_LT,
    STATE(1866), 1,
      sym_comment,
    STATE(3879), 1,
      sym_arguments,
    STATE(4025), 1,
      sym_type_arguments,
    ACTIONS(4147), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4143), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4141), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1357] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    STATE(1867), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5572), 1,
      sym_variable_declarator,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1450] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(987), 1,
      anon_sym_QMARK,
    ACTIONS(2680), 1,
      anon_sym_COLON,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2710), 1,
      anon_sym_RBRACE,
    ACTIONS(4167), 1,
      anon_sym_EQ,
    ACTIONS(4169), 1,
      anon_sym_LPAREN,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4174), 1,
      anon_sym_LT,
    STATE(1868), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1545] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1869), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1638] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4101), 1,
      sym_identifier,
    ACTIONS(4103), 1,
      anon_sym_DQUOTE,
    ACTIONS(4105), 1,
      anon_sym_SQUOTE,
    STATE(930), 1,
      sym_nested_identifier,
    STATE(1068), 1,
      sym_string,
    STATE(1331), 1,
      sym__module,
    STATE(1870), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1731] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(67), 1,
      anon_sym_DQUOTE,
    ACTIONS(69), 1,
      anon_sym_SQUOTE,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4107), 1,
      sym_identifier,
    STATE(1871), 1,
      sym_comment,
    STATE(2217), 1,
      sym_nested_identifier,
    STATE(2221), 1,
      sym_string,
    STATE(2459), 1,
      sym__module,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1824] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1246), 1,
      anon_sym_EQ,
    ACTIONS(1252), 1,
      anon_sym_EQ_GT,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1872), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1917] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(960), 1,
      anon_sym_EQ,
    ACTIONS(987), 1,
      anon_sym_QMARK,
    ACTIONS(2667), 1,
      anon_sym_RBRACE,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2680), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2693), 1,
      anon_sym_LT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1873), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2012] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1874), 1,
      sym_comment,
    ACTIONS(4177), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4179), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [2087] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4089), 1,
      sym_identifier,
    ACTIONS(4091), 1,
      anon_sym_DQUOTE,
    ACTIONS(4093), 1,
      anon_sym_SQUOTE,
    STATE(291), 1,
      sym_string,
    STATE(293), 1,
      sym_nested_identifier,
    STATE(319), 1,
      sym__module,
    STATE(1875), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2180] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1876), 1,
      sym_comment,
    ACTIONS(4181), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4183), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [2255] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1877), 1,
      sym_comment,
    ACTIONS(4185), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4187), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [2330] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4189), 1,
      sym_identifier,
    STATE(1878), 1,
      sym_comment,
    STATE(4330), 1,
      sym_nested_identifier,
    STATE(4500), 1,
      sym_string,
    STATE(5038), 1,
      sym__module,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2423] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1879), 1,
      sym_comment,
    ACTIONS(4191), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4193), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [2498] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4115), 1,
      sym_identifier,
    ACTIONS(4117), 1,
      anon_sym_DQUOTE,
    ACTIONS(4119), 1,
      anon_sym_SQUOTE,
    STATE(297), 1,
      sym_nested_identifier,
    STATE(298), 1,
      sym_string,
    STATE(384), 1,
      sym__module,
    STATE(1880), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2591] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(960), 1,
      anon_sym_EQ,
    ACTIONS(987), 1,
      anon_sym_QMARK,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2680), 1,
      anon_sym_COLON,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2693), 1,
      anon_sym_LT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2712), 1,
      anon_sym_RBRACE,
    STATE(1881), 1,
      sym_comment,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2686] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    STATE(1882), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5575), 1,
      sym_variable_declarator,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2779] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1224), 1,
      anon_sym_EQ_GT,
    ACTIONS(1272), 1,
      anon_sym_EQ,
    ACTIONS(1274), 1,
      anon_sym_COLON,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2874] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(987), 1,
      anon_sym_QMARK,
    ACTIONS(2667), 1,
      anon_sym_RBRACE,
    ACTIONS(2680), 1,
      anon_sym_COLON,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4167), 1,
      anon_sym_EQ,
    ACTIONS(4169), 1,
      anon_sym_LPAREN,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4174), 1,
      anon_sym_LT,
    STATE(1884), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2969] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4087), 1,
      sym_identifier,
    STATE(1885), 1,
      sym_comment,
    STATE(5073), 1,
      sym_nested_identifier,
    STATE(5616), 1,
      sym_string,
    STATE(6527), 1,
      sym__module,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3062] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    STATE(1886), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5416), 1,
      sym_variable_declarator,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3155] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1252), 1,
      anon_sym_EQ_GT,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1887), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3248] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4081), 1,
      sym_identifier,
    ACTIONS(4083), 1,
      anon_sym_DQUOTE,
    ACTIONS(4085), 1,
      anon_sym_SQUOTE,
    STATE(307), 1,
      sym_string,
    STATE(308), 1,
      sym_nested_identifier,
    STATE(408), 1,
      sym__module,
    STATE(1888), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3341] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(987), 1,
      anon_sym_QMARK,
    ACTIONS(2680), 1,
      anon_sym_COLON,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2712), 1,
      anon_sym_RBRACE,
    ACTIONS(4167), 1,
      anon_sym_EQ,
    ACTIONS(4169), 1,
      anon_sym_LPAREN,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4174), 1,
      anon_sym_LT,
    STATE(1889), 1,
      sym_comment,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3436] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4204), 1,
      anon_sym_LBRACK,
    ACTIONS(4207), 1,
      anon_sym_DOT,
    ACTIONS(4213), 1,
      anon_sym_LT,
    STATE(1890), 1,
      sym_comment,
    STATE(4022), 1,
      sym_type_arguments,
    ACTIONS(4198), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4210), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4202), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4141), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3530] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1203), 1,
      anon_sym_in,
    ACTIONS(1206), 1,
      anon_sym_of,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1891), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 34,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3626] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1224), 1,
      anon_sym_EQ_GT,
    ACTIONS(1272), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1892), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3718] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    STATE(1893), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4143), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4147), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3814] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4202), 1,
      anon_sym_extends,
    ACTIONS(4204), 1,
      anon_sym_LBRACK,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4226), 1,
      anon_sym_QMARK,
    STATE(1894), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    STATE(6658), 1,
      sym_type_annotation,
    ACTIONS(4198), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4210), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3914] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    STATE(1895), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4147), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4143), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4141), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4010] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1224), 1,
      anon_sym_EQ_GT,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1896), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [4102] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1105), 1,
      anon_sym_COLON,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1897), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [4196] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1280), 1,
      anon_sym_EQ,
    ACTIONS(1286), 1,
      anon_sym_EQ_GT,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1898), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [4288] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1899), 1,
      sym_comment,
    ACTIONS(3116), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3118), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [4362] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    STATE(1900), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [4440] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4202), 1,
      anon_sym_extends,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    STATE(1901), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4204), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4210), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4141), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [4532] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(4231), 1,
      anon_sym_EQ,
    ACTIONS(4233), 1,
      anon_sym_EQ_GT,
    STATE(1902), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4143), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4147), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4628] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1286), 1,
      anon_sym_EQ_GT,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1903), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [4720] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1904), 1,
      sym_comment,
    ACTIONS(3082), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3084), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [4794] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(4235), 1,
      anon_sym_EQ,
    ACTIONS(4237), 1,
      anon_sym_EQ_GT,
    STATE(1905), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4143), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4147), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4889] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4241), 1,
      anon_sym_class,
    ACTIONS(4244), 1,
      anon_sym_AT,
    STATE(1906), 1,
      sym_comment,
    STATE(1935), 1,
      aux_sym_export_statement_repeat1,
    STATE(2014), 1,
      sym_decorator,
    ACTIONS(4239), 55,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [4968] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4249), 1,
      anon_sym_LPAREN,
    ACTIONS(4251), 1,
      anon_sym_DOT,
    STATE(1907), 1,
      sym_comment,
    STATE(1966), 1,
      sym_arguments,
    ACTIONS(4247), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [5045] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    STATE(1908), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4147), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(4143), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4141), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5140] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1909), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [5231] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4257), 1,
      anon_sym_QMARK,
    STATE(1910), 1,
      sym_comment,
    ACTIONS(4253), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5314] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1203), 1,
      anon_sym_in,
    ACTIONS(1206), 1,
      anon_sym_of,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4259), 1,
      sym_identifier,
    ACTIONS(4261), 1,
      anon_sym_LBRACK,
    STATE(1911), 1,
      sym_comment,
    STATE(6431), 1,
      sym__destructuring_pattern,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 33,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [5407] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4198), 1,
      anon_sym_RPAREN,
    ACTIONS(4202), 1,
      anon_sym_extends,
    ACTIONS(4204), 1,
      anon_sym_LBRACK,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4267), 1,
      anon_sym_QMARK,
    STATE(1912), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4210), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4264), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4141), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5504] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1294), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1913), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [5595] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(213), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_LBRACK,
    ACTIONS(4272), 1,
      anon_sym_EQ_GT,
    STATE(1914), 1,
      sym_comment,
    ACTIONS(4274), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2030), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(211), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5680] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4267), 1,
      anon_sym_QMARK,
    STATE(1915), 1,
      sym_comment,
    ACTIONS(4264), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5763] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1105), 1,
      anon_sym_QMARK,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(1916), 1,
      sym_comment,
    ACTIONS(4277), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5846] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1292), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1917), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [5937] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1352), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1918), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [6028] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(124), 1,
      anon_sym_QMARK,
    ACTIONS(213), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4272), 1,
      anon_sym_EQ_GT,
    STATE(1919), 1,
      sym_comment,
    ACTIONS(4281), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6111] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1920), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [6202] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4202), 1,
      anon_sym_extends,
    ACTIONS(4204), 1,
      anon_sym_LBRACK,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4267), 1,
      anon_sym_QMARK,
    ACTIONS(4284), 1,
      anon_sym_EQ,
    ACTIONS(4289), 1,
      anon_sym_RPAREN,
    STATE(1921), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4210), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4287), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4141), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6299] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4267), 1,
      anon_sym_QMARK,
    ACTIONS(4284), 1,
      anon_sym_EQ,
    STATE(1922), 1,
      sym_comment,
    ACTIONS(4287), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6382] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1358), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1923), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [6473] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4202), 1,
      anon_sym_extends,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4231), 1,
      anon_sym_EQ,
    ACTIONS(4233), 1,
      anon_sym_EQ_GT,
    STATE(1924), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4204), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4210), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6564] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(115), 1,
      anon_sym_EQ,
    ACTIONS(124), 1,
      anon_sym_QMARK,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(1925), 1,
      sym_comment,
    ACTIONS(4292), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6647] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4202), 1,
      anon_sym_extends,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    STATE(1926), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4204), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4210), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6738] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1348), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1927), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [6829] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(4294), 1,
      anon_sym_EQ,
    ACTIONS(4296), 1,
      anon_sym_EQ_GT,
    STATE(1928), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4143), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4147), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6924] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(4298), 1,
      anon_sym_EQ,
    ACTIONS(4300), 1,
      anon_sym_EQ_GT,
    STATE(1929), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4143), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4147), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7019] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1930), 1,
      sym_comment,
    ACTIONS(4181), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4183), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [7092] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1165), 1,
      anon_sym_EQ,
    ACTIONS(2030), 1,
      anon_sym_extends,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4272), 1,
      anon_sym_EQ_GT,
    STATE(1931), 1,
      sym_comment,
    ACTIONS(4269), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4274), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(211), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [7177] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1354), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1932), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [7268] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1933), 1,
      sym_comment,
    ACTIONS(4125), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4127), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [7341] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1356), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1934), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [7432] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4244), 1,
      anon_sym_AT,
    STATE(2014), 1,
      sym_decorator,
    STATE(1935), 2,
      sym_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(4239), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [7507] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_EQ_GT,
    ACTIONS(211), 1,
      sym__ternary_qmark,
    ACTIONS(1346), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      sym_identifier,
    STATE(1936), 1,
      sym_comment,
    STATE(2345), 1,
      sym_string,
    STATE(2346), 1,
      sym_nested_identifier,
    STATE(2460), 1,
      sym__module,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [7598] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(4302), 1,
      anon_sym_EQ,
    ACTIONS(4304), 1,
      anon_sym_EQ_GT,
    STATE(1937), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4143), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4147), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7692] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4257), 1,
      anon_sym_QMARK,
    STATE(1938), 1,
      sym_comment,
    ACTIONS(4253), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7772] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4272), 1,
      anon_sym_EQ_GT,
    STATE(1939), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7850] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4267), 1,
      anon_sym_QMARK,
    ACTIONS(4284), 1,
      anon_sym_EQ,
    STATE(1940), 1,
      sym_comment,
    ACTIONS(4287), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7930] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(979), 1,
      anon_sym_EQ_GT,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(1195), 1,
      anon_sym_COLON,
    ACTIONS(4123), 1,
      sym_identifier,
    STATE(1941), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [8012] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(124), 1,
      anon_sym_QMARK,
    ACTIONS(213), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_LBRACK,
    ACTIONS(4272), 1,
      anon_sym_EQ_GT,
    STATE(1942), 1,
      sym_comment,
    ACTIONS(2030), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4274), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4281), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(211), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8100] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4204), 1,
      anon_sym_LBRACK,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4294), 1,
      anon_sym_EQ,
    ACTIONS(4296), 1,
      anon_sym_EQ_GT,
    STATE(1943), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4202), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4210), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8190] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4202), 1,
      anon_sym_extends,
    ACTIONS(4204), 1,
      anon_sym_LBRACK,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4253), 1,
      anon_sym_COLON,
    STATE(1944), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4210), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4306), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4141), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8284] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(979), 1,
      anon_sym_EQ_GT,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(1201), 1,
      anon_sym_COLON,
    ACTIONS(4310), 1,
      sym_identifier,
    STATE(1945), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [8366] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(1946), 1,
      sym_comment,
    ACTIONS(4312), 58,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [8436] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    STATE(1947), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8514] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(979), 1,
      anon_sym_EQ_GT,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(1199), 1,
      anon_sym_COLON,
    ACTIONS(4314), 1,
      sym_identifier,
    STATE(1948), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [8596] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(2030), 1,
      anon_sym_extends,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ_GT,
    STATE(1949), 1,
      sym_comment,
    ACTIONS(4269), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4274), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8680] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4204), 1,
      anon_sym_LBRACK,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4235), 1,
      anon_sym_EQ,
    ACTIONS(4237), 1,
      anon_sym_EQ_GT,
    STATE(1950), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4202), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4210), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8770] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(979), 1,
      anon_sym_EQ_GT,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(1177), 1,
      anon_sym_COLON,
    ACTIONS(4318), 1,
      sym_identifier,
    STATE(1951), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [8852] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(2030), 1,
      anon_sym_extends,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1952), 1,
      sym_comment,
    ACTIONS(4269), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4274), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8936] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(4320), 1,
      anon_sym_EQ,
    ACTIONS(4322), 1,
      anon_sym_EQ_GT,
    STATE(1953), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4143), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4147), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9030] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    STATE(1954), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9108] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(1955), 1,
      sym_comment,
    ACTIONS(3320), 58,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [9178] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(1956), 1,
      sym_comment,
    ACTIONS(3296), 58,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [9248] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4202), 1,
      anon_sym_extends,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4298), 1,
      anon_sym_EQ,
    ACTIONS(4300), 1,
      anon_sym_EQ_GT,
    STATE(1957), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4204), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4210), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9338] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    STATE(1958), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4147), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4143), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4141), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9432] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4267), 1,
      anon_sym_QMARK,
    STATE(1959), 1,
      sym_comment,
    ACTIONS(4264), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9512] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(115), 1,
      anon_sym_EQ,
    ACTIONS(124), 1,
      anon_sym_QMARK,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_LBRACK,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(1960), 1,
      sym_comment,
    ACTIONS(2030), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4274), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4292), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(211), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9600] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4204), 1,
      anon_sym_LBRACK,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4253), 1,
      anon_sym_COLON,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    STATE(1961), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4210), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4202), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4141), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9692] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1165), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4272), 1,
      anon_sym_EQ_GT,
    STATE(1962), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9770] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(979), 1,
      anon_sym_EQ_GT,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(4324), 1,
      sym_identifier,
    STATE(1963), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9852] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2806), 1,
      anon_sym_COLON,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    STATE(1964), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9931] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4204), 1,
      anon_sym_LBRACK,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4302), 1,
      anon_sym_EQ,
    ACTIONS(4304), 1,
      anon_sym_EQ_GT,
    STATE(1965), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4202), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4210), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10020] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(1966), 1,
      sym_comment,
    ACTIONS(4326), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [10089] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    ACTIONS(4202), 1,
      anon_sym_extends,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    STATE(1967), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4204), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4210), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10178] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2882), 1,
      anon_sym_COLON,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    STATE(1968), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10257] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4328), 1,
      anon_sym_COMMA,
    STATE(1969), 1,
      sym_comment,
    ACTIONS(4125), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4127), 34,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [10330] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_COMMA,
    STATE(1970), 1,
      sym_comment,
    ACTIONS(4181), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4183), 34,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [10403] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(1971), 1,
      sym_comment,
    ACTIONS(3140), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [10472] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    ACTIONS(2030), 1,
      anon_sym_extends,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4332), 1,
      anon_sym_EQ_GT,
    STATE(1972), 1,
      sym_comment,
    ACTIONS(4269), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4274), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10555] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ_GT,
    STATE(1973), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10632] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4233), 1,
      anon_sym_EQ_GT,
    STATE(1974), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10709] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_LBRACK,
    ACTIONS(4277), 1,
      anon_sym_COLON,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(1975), 1,
      sym_comment,
    ACTIONS(4274), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2030), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(211), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10794] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    STATE(1976), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10871] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1977), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10948] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(1978), 1,
      sym_comment,
    ACTIONS(4247), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [11017] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2882), 1,
      anon_sym_COLON,
    STATE(1979), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11096] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(1980), 1,
      sym_comment,
    ACTIONS(3144), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [11165] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    STATE(1981), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4143), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4147), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11258] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1982), 1,
      sym_comment,
    ACTIONS(4177), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4179), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [11329] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(1983), 1,
      sym_comment,
    ACTIONS(3238), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [11398] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2768), 1,
      anon_sym_COLON,
    STATE(1984), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11477] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2768), 1,
      anon_sym_COLON,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    STATE(1985), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11556] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(213), 1,
      anon_sym_EQ,
    ACTIONS(1972), 1,
      anon_sym_QMARK,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_LBRACK,
    ACTIONS(4272), 1,
      anon_sym_EQ_GT,
    STATE(1986), 1,
      sym_comment,
    ACTIONS(4274), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2030), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(211), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11641] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2844), 1,
      anon_sym_COLON,
    STATE(1987), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11720] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(1988), 1,
      sym_comment,
    ACTIONS(3260), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [11789] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ_GT,
    STATE(1989), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11866] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2844), 1,
      anon_sym_COLON,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    STATE(1990), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11945] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(1203), 1,
      anon_sym_in,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4334), 1,
      anon_sym_of,
    STATE(1991), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12026] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2806), 1,
      anon_sym_COLON,
    STATE(1992), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12105] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1993), 1,
      sym_comment,
    ACTIONS(4125), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4127), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [12176] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    STATE(1994), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12253] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1995), 1,
      sym_comment,
    ACTIONS(4133), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4135), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [12324] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    STATE(1996), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12399] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1997), 1,
      sym_comment,
    ACTIONS(3116), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3118), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [12470] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1165), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4272), 1,
      anon_sym_EQ_GT,
    ACTIONS(4277), 1,
      anon_sym_COLON,
    STATE(1998), 1,
      sym_comment,
    ACTIONS(4336), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12551] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(1999), 1,
      sym_comment,
    ACTIONS(3082), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3084), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [12622] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2000), 1,
      sym_comment,
    ACTIONS(4181), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4183), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [12693] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2001), 1,
      sym_comment,
    ACTIONS(4330), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4181), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4183), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [12766] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1165), 1,
      anon_sym_EQ,
    ACTIONS(2030), 1,
      anon_sym_extends,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_LBRACK,
    ACTIONS(4272), 1,
      anon_sym_EQ_GT,
    ACTIONS(4277), 1,
      anon_sym_COLON,
    STATE(2002), 1,
      sym_comment,
    ACTIONS(4274), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4339), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(211), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12853] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2003), 1,
      sym_comment,
    ACTIONS(4191), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4193), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [12924] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2004), 1,
      sym_comment,
    ACTIONS(4328), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4125), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4127), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [12997] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2005), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13074] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2746), 1,
      anon_sym_COLON,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    STATE(2006), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13153] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2007), 1,
      sym_comment,
    ACTIONS(4343), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [13222] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2008), 1,
      sym_comment,
    ACTIONS(4181), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4183), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13293] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1175), 1,
      anon_sym_EQ,
    ACTIONS(2689), 1,
      anon_sym_EQ_GT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2746), 1,
      anon_sym_COLON,
    STATE(2009), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13372] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4204), 1,
      anon_sym_LBRACK,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4320), 1,
      anon_sym_EQ,
    ACTIONS(4322), 1,
      anon_sym_EQ_GT,
    STATE(2010), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4202), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4210), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13461] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2011), 1,
      sym_comment,
    ACTIONS(4125), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4127), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13532] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2012), 1,
      sym_comment,
    ACTIONS(4345), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [13601] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    STATE(2013), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13676] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2014), 1,
      sym_comment,
    ACTIONS(4347), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [13745] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2015), 1,
      sym_comment,
    ACTIONS(4349), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [13814] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2016), 1,
      sym_comment,
    ACTIONS(4129), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4131), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13885] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2017), 1,
      sym_comment,
    ACTIONS(4185), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4187), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13956] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4231), 1,
      anon_sym_EQ,
    ACTIONS(4233), 1,
      anon_sym_EQ_GT,
    STATE(2018), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14033] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2934), 1,
      anon_sym_EQ_GT,
    ACTIONS(4269), 1,
      anon_sym_LBRACK,
    STATE(2019), 1,
      sym_comment,
    ACTIONS(2030), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4274), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14116] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4172), 1,
      anon_sym_EQ_GT,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    ACTIONS(4351), 1,
      anon_sym_in,
    ACTIONS(4354), 1,
      anon_sym_of,
    STATE(2020), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14197] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1246), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_EQ_GT,
    STATE(2021), 1,
      sym_comment,
    ACTIONS(2030), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4274), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14280] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    STATE(2022), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4147), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4143), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4141), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14373] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4300), 1,
      anon_sym_EQ_GT,
    STATE(2023), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14449] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1272), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_LBRACK,
    ACTIONS(4358), 1,
      anon_sym_EQ_GT,
    STATE(2024), 1,
      sym_comment,
    ACTIONS(2030), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4274), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14531] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    ACTIONS(4351), 1,
      anon_sym_in,
    ACTIONS(4354), 1,
      anon_sym_of,
    STATE(2025), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14609] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    STATE(2026), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14683] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1215), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4281), 1,
      anon_sym_RBRACK,
    ACTIONS(4292), 1,
      anon_sym_COMMA,
    ACTIONS(4358), 1,
      anon_sym_EQ_GT,
    ACTIONS(4360), 1,
      anon_sym_COLON,
    STATE(2027), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14765] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4362), 1,
      sym_identifier,
    STATE(2028), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [14843] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1280), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_LBRACK,
    ACTIONS(4364), 1,
      anon_sym_EQ_GT,
    STATE(2029), 1,
      sym_comment,
    ACTIONS(2030), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4274), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14925] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4310), 1,
      sym_identifier,
    STATE(2030), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [15003] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4253), 1,
      anon_sym_COLON,
    STATE(2031), 1,
      sym_comment,
    ACTIONS(4366), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15081] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      anon_sym_EQ_GT,
    STATE(2032), 1,
      sym_comment,
    ACTIONS(4366), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15159] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4264), 1,
      anon_sym_RBRACK,
    ACTIONS(4287), 1,
      anon_sym_COMMA,
    ACTIONS(4322), 1,
      anon_sym_EQ_GT,
    ACTIONS(4369), 1,
      anon_sym_EQ,
    ACTIONS(4372), 1,
      anon_sym_in,
    ACTIONS(4374), 1,
      anon_sym_COLON,
    STATE(2033), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15243] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4204), 1,
      anon_sym_LBRACK,
    ACTIONS(4220), 1,
      anon_sym_DOT,
    ACTIONS(4223), 1,
      anon_sym_LT,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    STATE(2034), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4202), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4210), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4141), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15331] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4318), 1,
      sym_identifier,
    STATE(2035), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [15409] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1260), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4332), 1,
      anon_sym_EQ_GT,
    STATE(2036), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15485] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4314), 1,
      sym_identifier,
    STATE(2037), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [15563] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4231), 1,
      anon_sym_EQ,
    STATE(2038), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15637] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4298), 1,
      anon_sym_EQ,
    ACTIONS(4300), 1,
      anon_sym_EQ_GT,
    STATE(2039), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15713] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4332), 1,
      anon_sym_EQ_GT,
    STATE(2040), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15789] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4123), 1,
      sym_identifier,
    STATE(2041), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [15867] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_EQ_GT,
    ACTIONS(4324), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_comment,
    ACTIONS(211), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [15945] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1165), 1,
      anon_sym_EQ,
    ACTIONS(2030), 1,
      anon_sym_extends,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4272), 1,
      anon_sym_EQ_GT,
    STATE(2043), 1,
      sym_comment,
    ACTIONS(4269), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4274), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16027] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1215), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4281), 1,
      anon_sym_RBRACK,
    ACTIONS(4292), 1,
      anon_sym_COMMA,
    ACTIONS(4358), 1,
      anon_sym_EQ_GT,
    STATE(2044), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16106] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4298), 1,
      anon_sym_EQ,
    STATE(2045), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16179] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4356), 1,
      anon_sym_EQ_GT,
    STATE(2046), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16254] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2934), 1,
      anon_sym_EQ_GT,
    STATE(2047), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16329] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2048), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4382), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4384), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4630), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [16456] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2049), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3888), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3912), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4797), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [16583] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2050), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4402), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4404), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4775), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [16710] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_COMMA,
    STATE(2051), 1,
      sym_comment,
    ACTIONS(4181), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4183), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [16781] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2052), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4406), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4408), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4718), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [16908] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2053), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4410), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4412), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4757), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [17035] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2054), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4414), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4416), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4735), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [17162] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_LBRACK,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2055), 1,
      sym_comment,
    ACTIONS(2030), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4274), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(211), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17243] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4296), 1,
      anon_sym_EQ_GT,
    STATE(2056), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17318] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2057), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4418), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4420), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4740), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [17445] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4237), 1,
      anon_sym_EQ_GT,
    STATE(2058), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17520] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2934), 1,
      anon_sym_EQ_GT,
    STATE(2059), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17595] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4264), 1,
      anon_sym_RBRACK,
    ACTIONS(4287), 1,
      anon_sym_COMMA,
    ACTIONS(4322), 1,
      anon_sym_EQ_GT,
    ACTIONS(4369), 1,
      anon_sym_EQ,
    STATE(2060), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17674] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1246), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4356), 1,
      anon_sym_EQ_GT,
    STATE(2061), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17749] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4328), 1,
      anon_sym_COMMA,
    STATE(2062), 1,
      sym_comment,
    ACTIONS(4125), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4127), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [17820] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1272), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4358), 1,
      anon_sym_EQ_GT,
    ACTIONS(4422), 1,
      anon_sym_COLON,
    STATE(2063), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17897] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4235), 1,
      anon_sym_EQ,
    ACTIONS(4237), 1,
      anon_sym_EQ_GT,
    STATE(2064), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17972] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4294), 1,
      anon_sym_EQ,
    ACTIONS(4296), 1,
      anon_sym_EQ_GT,
    STATE(2065), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18047] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1272), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4358), 1,
      anon_sym_EQ_GT,
    ACTIONS(4360), 1,
      anon_sym_COLON,
    STATE(2066), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18124] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4320), 1,
      anon_sym_EQ,
    ACTIONS(4322), 1,
      anon_sym_EQ_GT,
    ACTIONS(4372), 1,
      anon_sym_in,
    ACTIONS(4424), 1,
      anon_sym_COLON,
    STATE(2067), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18203] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2068), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4426), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4428), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4769), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [18330] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2069), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4006), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4008), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4679), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [18457] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4320), 1,
      anon_sym_EQ,
    ACTIONS(4322), 1,
      anon_sym_EQ_GT,
    ACTIONS(4372), 1,
      anon_sym_in,
    ACTIONS(4374), 1,
      anon_sym_COLON,
    STATE(2070), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18536] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4304), 1,
      anon_sym_EQ_GT,
    STATE(2071), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18610] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4235), 1,
      anon_sym_EQ,
    STATE(2072), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18682] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4277), 1,
      anon_sym_COLON,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2073), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18758] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4358), 1,
      anon_sym_EQ_GT,
    STATE(2074), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18832] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1272), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4358), 1,
      anon_sym_EQ_GT,
    STATE(2075), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18906] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4264), 1,
      anon_sym_RBRACK,
    ACTIONS(4287), 1,
      anon_sym_COMMA,
    ACTIONS(4369), 1,
      anon_sym_EQ,
    STATE(2076), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18982] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1280), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4364), 1,
      anon_sym_EQ_GT,
    STATE(2077), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19056] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4320), 1,
      anon_sym_EQ,
    ACTIONS(4322), 1,
      anon_sym_EQ_GT,
    STATE(2078), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19130] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4364), 1,
      anon_sym_EQ_GT,
    STATE(2079), 1,
      sym_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(211), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19204] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1203), 1,
      anon_sym_in,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    ACTIONS(4334), 1,
      anon_sym_of,
    STATE(2080), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19282] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4322), 1,
      anon_sym_EQ_GT,
    STATE(2081), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19356] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4351), 1,
      anon_sym_in,
    ACTIONS(4354), 1,
      anon_sym_of,
    STATE(2082), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19434] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4302), 1,
      anon_sym_EQ,
    ACTIONS(4304), 1,
      anon_sym_EQ_GT,
    STATE(2083), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19508] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4294), 1,
      anon_sym_EQ,
    STATE(2084), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19580] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1354), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2085), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19653] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4430), 1,
      anon_sym_EQ,
    STATE(2086), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19726] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4320), 1,
      anon_sym_EQ,
    STATE(2087), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19797] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4432), 1,
      anon_sym_EQ,
    STATE(2088), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19870] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2089), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4434), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [19993] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2090), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4436), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [20116] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2091), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20189] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2092), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4438), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [20312] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    STATE(2093), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20385] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2094), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20458] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2095), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4440), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [20581] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1294), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2096), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20654] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2097), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4442), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [20777] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2098), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4444), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [20900] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1358), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2099), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20973] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4446), 1,
      anon_sym_EQ,
    STATE(2100), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21046] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4448), 1,
      anon_sym_EQ,
    STATE(2101), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21119] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1356), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2102), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21192] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2103), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4450), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [21315] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2104), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4452), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [21438] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2105), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4454), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [21561] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2106), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4456), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [21684] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2107), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4458), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [21807] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2108), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4460), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [21930] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1348), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2109), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22003] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4462), 1,
      anon_sym_EQ,
    STATE(2110), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22076] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4253), 1,
      anon_sym_COLON,
    STATE(2111), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22149] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4302), 1,
      anon_sym_EQ,
    STATE(2112), 1,
      sym_comment,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4141), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22220] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2113), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4464), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [22343] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2114), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4466), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [22466] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4468), 1,
      anon_sym_EQ,
    STATE(2115), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22539] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4470), 1,
      anon_sym_EQ,
    STATE(2116), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22612] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2117), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4472), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [22735] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1346), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2118), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22808] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2119), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4474), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [22931] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2120), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4476), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [23054] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2121), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4478), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [23177] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4480), 1,
      anon_sym_EQ,
    STATE(2122), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23250] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2123), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4482), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [23373] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ_GT,
    ACTIONS(4484), 1,
      anon_sym_EQ,
    STATE(2124), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23446] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2125), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4486), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [23569] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4351), 1,
      anon_sym_in,
    ACTIONS(4354), 1,
      anon_sym_of,
    STATE(2126), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23644] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2127), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4488), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [23767] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1292), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2128), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23840] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2129), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4490), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [23963] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2130), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4492), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24086] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2131), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4494), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24209] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2132), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4496), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24332] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2133), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4498), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24455] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1352), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4279), 1,
      anon_sym_EQ_GT,
    STATE(2134), 1,
      sym_comment,
    ACTIONS(211), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2691), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24528] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2135), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4500), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24651] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4448), 1,
      anon_sym_EQ,
    STATE(2136), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24721] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4430), 1,
      anon_sym_EQ,
    STATE(2137), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24791] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4470), 1,
      anon_sym_EQ,
    STATE(2138), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24861] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4480), 1,
      anon_sym_EQ,
    STATE(2139), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24931] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4468), 1,
      anon_sym_EQ,
    STATE(2140), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25001] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4484), 1,
      anon_sym_EQ,
    STATE(2141), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25071] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4432), 1,
      anon_sym_EQ,
    STATE(2142), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25141] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4446), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25211] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4462), 1,
      anon_sym_EQ,
    STATE(2144), 1,
      sym_comment,
    ACTIONS(4141), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4155), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4137), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25281] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2145), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4719), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [25400] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2146), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4943), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [25519] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2147), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4742), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [25638] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2148), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4760), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [25757] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2149), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4770), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [25876] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2150), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4777), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [25995] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2151), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4722), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [26114] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2152), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4632), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [26233] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2153), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4680), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [26352] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(3886), 1,
      anon_sym_LPAREN,
    ACTIONS(3910), 1,
      anon_sym_abstract,
    ACTIONS(4378), 1,
      anon_sym_export,
    ACTIONS(4380), 1,
      anon_sym_STAR,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4388), 1,
      anon_sym_async,
    ACTIONS(4390), 1,
      anon_sym_new,
    ACTIONS(4392), 1,
      anon_sym_static,
    ACTIONS(4394), 1,
      anon_sym_readonly,
    ACTIONS(4400), 1,
      anon_sym_override,
    STATE(2154), 1,
      sym_comment,
    STATE(3508), 1,
      sym_accessibility_modifier,
    STATE(3515), 1,
      sym_override_modifier,
    STATE(3842), 1,
      sym__property_name,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5095), 1,
      sym__call_signature,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      aux_sym_export_statement_repeat1,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4396), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4398), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4713), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4376), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [26471] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2665), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2938), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_import,
    ACTIONS(2942), 1,
      anon_sym_var,
    ACTIONS(2944), 1,
      anon_sym_let,
    ACTIONS(2946), 1,
      anon_sym_const,
    ACTIONS(2948), 1,
      anon_sym_class,
    ACTIONS(2950), 1,
      anon_sym_async,
    ACTIONS(2952), 1,
      anon_sym_function,
    ACTIONS(2954), 1,
      anon_sym_declare,
    ACTIONS(2958), 1,
      anon_sym_abstract,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    ACTIONS(4502), 1,
      anon_sym_STAR,
    ACTIONS(4504), 1,
      anon_sym_default,
    ACTIONS(4506), 1,
      anon_sym_type,
    ACTIONS(4508), 1,
      anon_sym_EQ,
    ACTIONS(4510), 1,
      anon_sym_as,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4515), 1,
      anon_sym_RBRACE,
    ACTIONS(4520), 1,
      anon_sym_module,
    STATE(2155), 1,
      sym_comment,
    STATE(4878), 1,
      sym_internal_module,
    STATE(5318), 1,
      sym_declaration,
    STATE(5382), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5549), 1,
      sym_export_clause,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    STATE(6927), 1,
      sym_namespace_export,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5171), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [26595] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2665), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2938), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_import,
    ACTIONS(2942), 1,
      anon_sym_var,
    ACTIONS(2944), 1,
      anon_sym_let,
    ACTIONS(2946), 1,
      anon_sym_const,
    ACTIONS(2948), 1,
      anon_sym_class,
    ACTIONS(2950), 1,
      anon_sym_async,
    ACTIONS(2952), 1,
      anon_sym_function,
    ACTIONS(2954), 1,
      anon_sym_declare,
    ACTIONS(2958), 1,
      anon_sym_abstract,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    ACTIONS(4502), 1,
      anon_sym_STAR,
    ACTIONS(4504), 1,
      anon_sym_default,
    ACTIONS(4506), 1,
      anon_sym_type,
    ACTIONS(4508), 1,
      anon_sym_EQ,
    ACTIONS(4510), 1,
      anon_sym_as,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4520), 1,
      anon_sym_module,
    ACTIONS(4522), 1,
      anon_sym_RBRACE,
    STATE(2156), 1,
      sym_comment,
    STATE(4878), 1,
      sym_internal_module,
    STATE(5318), 1,
      sym_declaration,
    STATE(5382), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5549), 1,
      sym_export_clause,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    STATE(6927), 1,
      sym_namespace_export,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5171), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [26719] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2665), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2938), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_import,
    ACTIONS(2942), 1,
      anon_sym_var,
    ACTIONS(2944), 1,
      anon_sym_let,
    ACTIONS(2946), 1,
      anon_sym_const,
    ACTIONS(2948), 1,
      anon_sym_class,
    ACTIONS(2950), 1,
      anon_sym_async,
    ACTIONS(2952), 1,
      anon_sym_function,
    ACTIONS(2954), 1,
      anon_sym_declare,
    ACTIONS(2958), 1,
      anon_sym_abstract,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    ACTIONS(4502), 1,
      anon_sym_STAR,
    ACTIONS(4504), 1,
      anon_sym_default,
    ACTIONS(4506), 1,
      anon_sym_type,
    ACTIONS(4508), 1,
      anon_sym_EQ,
    ACTIONS(4510), 1,
      anon_sym_as,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4520), 1,
      anon_sym_module,
    ACTIONS(4525), 1,
      anon_sym_RBRACE,
    STATE(2157), 1,
      sym_comment,
    STATE(4878), 1,
      sym_internal_module,
    STATE(5318), 1,
      sym_declaration,
    STATE(5382), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5549), 1,
      sym_export_clause,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    STATE(6927), 1,
      sym_namespace_export,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5171), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [26843] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2665), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2938), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_import,
    ACTIONS(2942), 1,
      anon_sym_var,
    ACTIONS(2944), 1,
      anon_sym_let,
    ACTIONS(2946), 1,
      anon_sym_const,
    ACTIONS(2948), 1,
      anon_sym_class,
    ACTIONS(2950), 1,
      anon_sym_async,
    ACTIONS(2952), 1,
      anon_sym_function,
    ACTIONS(2954), 1,
      anon_sym_declare,
    ACTIONS(2958), 1,
      anon_sym_abstract,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    ACTIONS(4502), 1,
      anon_sym_STAR,
    ACTIONS(4504), 1,
      anon_sym_default,
    ACTIONS(4506), 1,
      anon_sym_type,
    ACTIONS(4508), 1,
      anon_sym_EQ,
    ACTIONS(4510), 1,
      anon_sym_as,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4520), 1,
      anon_sym_module,
    ACTIONS(4528), 1,
      anon_sym_RBRACE,
    STATE(2158), 1,
      sym_comment,
    STATE(4878), 1,
      sym_internal_module,
    STATE(5318), 1,
      sym_declaration,
    STATE(5382), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5549), 1,
      sym_export_clause,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6927), 1,
      sym_namespace_export,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5171), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [26967] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2665), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2938), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_import,
    ACTIONS(2942), 1,
      anon_sym_var,
    ACTIONS(2944), 1,
      anon_sym_let,
    ACTIONS(2946), 1,
      anon_sym_const,
    ACTIONS(2948), 1,
      anon_sym_class,
    ACTIONS(2950), 1,
      anon_sym_async,
    ACTIONS(2952), 1,
      anon_sym_function,
    ACTIONS(2954), 1,
      anon_sym_declare,
    ACTIONS(2958), 1,
      anon_sym_abstract,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    ACTIONS(4502), 1,
      anon_sym_STAR,
    ACTIONS(4504), 1,
      anon_sym_default,
    ACTIONS(4506), 1,
      anon_sym_type,
    ACTIONS(4508), 1,
      anon_sym_EQ,
    ACTIONS(4510), 1,
      anon_sym_as,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4520), 1,
      anon_sym_module,
    ACTIONS(4531), 1,
      anon_sym_RBRACE,
    STATE(2159), 1,
      sym_comment,
    STATE(4878), 1,
      sym_internal_module,
    STATE(5318), 1,
      sym_declaration,
    STATE(5382), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5549), 1,
      sym_export_clause,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    STATE(6927), 1,
      sym_namespace_export,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5171), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27091] = 31,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4537), 1,
      anon_sym_STAR,
    ACTIONS(4540), 1,
      anon_sym_RBRACE,
    ACTIONS(4542), 1,
      anon_sym_SEMI,
    ACTIONS(4545), 1,
      anon_sym_LBRACK,
    ACTIONS(4548), 1,
      anon_sym_DQUOTE,
    ACTIONS(4551), 1,
      anon_sym_SQUOTE,
    ACTIONS(4554), 1,
      anon_sym_async,
    ACTIONS(4563), 1,
      anon_sym_AT,
    ACTIONS(4566), 1,
      anon_sym_static,
    ACTIONS(4569), 1,
      anon_sym_readonly,
    ACTIONS(4575), 1,
      anon_sym_declare,
    ACTIONS(4581), 1,
      anon_sym_override,
    ACTIONS(4584), 1,
      anon_sym_abstract,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(4557), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4560), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4572), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2160), 2,
      sym_comment,
      aux_sym_class_body_repeat1,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4534), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27206] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4589), 1,
      anon_sym_RBRACE,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2161), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27323] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(225), 1,
      anon_sym_STAR,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(243), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4611), 1,
      anon_sym_RBRACE,
    ACTIONS(4613), 1,
      anon_sym_LBRACK,
    ACTIONS(4615), 1,
      anon_sym_async,
    ACTIONS(4617), 1,
      anon_sym_static,
    ACTIONS(4619), 1,
      anon_sym_readonly,
    ACTIONS(4625), 1,
      anon_sym_override,
    STATE(2162), 1,
      sym_comment,
    STATE(3468), 1,
      sym_accessibility_modifier,
    STATE(3530), 1,
      sym_override_modifier,
    STATE(4583), 1,
      sym__property_name,
    STATE(5743), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5792), 1,
      aux_sym_object_repeat1,
    STATE(7130), 1,
      sym__destructuring_pattern,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4621), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4623), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5739), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5740), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4609), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27434] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4627), 1,
      anon_sym_RBRACE,
    STATE(2163), 1,
      sym_comment,
    STATE(2181), 1,
      aux_sym_class_body_repeat1,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27551] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4629), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2164), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27668] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4631), 1,
      anon_sym_RBRACE,
    STATE(2165), 1,
      sym_comment,
    STATE(2186), 1,
      aux_sym_class_body_repeat1,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27785] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(225), 1,
      anon_sym_STAR,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(243), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LBRACK,
    ACTIONS(4635), 1,
      anon_sym_RBRACE,
    ACTIONS(4637), 1,
      anon_sym_async,
    ACTIONS(4639), 1,
      anon_sym_static,
    ACTIONS(4641), 1,
      anon_sym_readonly,
    ACTIONS(4647), 1,
      anon_sym_override,
    STATE(2166), 1,
      sym_comment,
    STATE(3468), 1,
      sym_accessibility_modifier,
    STATE(3530), 1,
      sym_override_modifier,
    STATE(4583), 1,
      sym__property_name,
    STATE(5743), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5792), 1,
      aux_sym_object_repeat1,
    STATE(7130), 1,
      sym__destructuring_pattern,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4643), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4645), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5739), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5740), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4633), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27896] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4649), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2167), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28013] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4651), 1,
      anon_sym_RBRACE,
    STATE(2168), 1,
      sym_comment,
    STATE(2170), 1,
      aux_sym_class_body_repeat1,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28130] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4653), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2169), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28247] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4655), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2170), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28364] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(225), 1,
      anon_sym_STAR,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(243), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LBRACK,
    ACTIONS(4659), 1,
      anon_sym_RBRACE,
    ACTIONS(4661), 1,
      anon_sym_async,
    ACTIONS(4663), 1,
      anon_sym_static,
    ACTIONS(4665), 1,
      anon_sym_readonly,
    ACTIONS(4671), 1,
      anon_sym_override,
    STATE(2171), 1,
      sym_comment,
    STATE(3468), 1,
      sym_accessibility_modifier,
    STATE(3530), 1,
      sym_override_modifier,
    STATE(4583), 1,
      sym__property_name,
    STATE(5743), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6146), 1,
      aux_sym_object_repeat1,
    STATE(7130), 1,
      sym__destructuring_pattern,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4667), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4669), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5739), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(6145), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4657), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28475] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4673), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2172), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28592] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4675), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2173), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28709] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4677), 1,
      anon_sym_RBRACE,
    STATE(2167), 1,
      aux_sym_class_body_repeat1,
    STATE(2174), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28826] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(225), 1,
      anon_sym_STAR,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(243), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LBRACK,
    ACTIONS(4681), 1,
      anon_sym_RBRACE,
    ACTIONS(4683), 1,
      anon_sym_async,
    ACTIONS(4685), 1,
      anon_sym_static,
    ACTIONS(4687), 1,
      anon_sym_readonly,
    ACTIONS(4693), 1,
      anon_sym_override,
    STATE(2175), 1,
      sym_comment,
    STATE(3468), 1,
      sym_accessibility_modifier,
    STATE(3530), 1,
      sym_override_modifier,
    STATE(4583), 1,
      sym__property_name,
    STATE(5743), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6146), 1,
      aux_sym_object_repeat1,
    STATE(7130), 1,
      sym__destructuring_pattern,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4689), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4691), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5739), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(6145), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4679), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28937] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4695), 1,
      anon_sym_RBRACE,
    STATE(2173), 1,
      aux_sym_class_body_repeat1,
    STATE(2176), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29054] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4697), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_comment,
    STATE(2187), 1,
      aux_sym_class_body_repeat1,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29171] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4699), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2178), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29288] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4701), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2179), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29405] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4703), 1,
      anon_sym_RBRACE,
    STATE(2180), 1,
      sym_comment,
    STATE(2189), 1,
      aux_sym_class_body_repeat1,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29522] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4705), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2181), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29639] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(225), 1,
      anon_sym_STAR,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(243), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LBRACK,
    ACTIONS(4709), 1,
      anon_sym_RBRACE,
    ACTIONS(4711), 1,
      anon_sym_async,
    ACTIONS(4713), 1,
      anon_sym_static,
    ACTIONS(4715), 1,
      anon_sym_readonly,
    ACTIONS(4721), 1,
      anon_sym_override,
    STATE(2182), 1,
      sym_comment,
    STATE(3468), 1,
      sym_accessibility_modifier,
    STATE(3530), 1,
      sym_override_modifier,
    STATE(4583), 1,
      sym__property_name,
    STATE(5743), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6146), 1,
      aux_sym_object_repeat1,
    STATE(7130), 1,
      sym__destructuring_pattern,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4717), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4719), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5739), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(6145), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4707), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29750] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4723), 1,
      anon_sym_RBRACE,
    STATE(2172), 1,
      aux_sym_class_body_repeat1,
    STATE(2183), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29867] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4725), 1,
      anon_sym_RBRACE,
    STATE(2169), 1,
      aux_sym_class_body_repeat1,
    STATE(2184), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29984] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4727), 1,
      anon_sym_RBRACE,
    STATE(2179), 1,
      aux_sym_class_body_repeat1,
    STATE(2185), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30101] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4729), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2186), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30218] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4731), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2187), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30335] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4733), 1,
      anon_sym_RBRACE,
    STATE(2164), 1,
      aux_sym_class_body_repeat1,
    STATE(2188), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30452] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4735), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2189), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30569] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(225), 1,
      anon_sym_STAR,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(243), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LBRACK,
    ACTIONS(4739), 1,
      anon_sym_RBRACE,
    ACTIONS(4741), 1,
      anon_sym_async,
    ACTIONS(4743), 1,
      anon_sym_static,
    ACTIONS(4745), 1,
      anon_sym_readonly,
    ACTIONS(4751), 1,
      anon_sym_override,
    STATE(2190), 1,
      sym_comment,
    STATE(3468), 1,
      sym_accessibility_modifier,
    STATE(3530), 1,
      sym_override_modifier,
    STATE(4583), 1,
      sym__property_name,
    STATE(5743), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6146), 1,
      aux_sym_object_repeat1,
    STATE(7130), 1,
      sym__destructuring_pattern,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4747), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4749), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5739), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(6145), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4737), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30680] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4753), 1,
      anon_sym_RBRACE,
    STATE(2161), 1,
      aux_sym_class_body_repeat1,
    STATE(2191), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30797] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4755), 1,
      anon_sym_RBRACE,
    STATE(2178), 1,
      aux_sym_class_body_repeat1,
    STATE(2192), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30914] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4757), 1,
      anon_sym_RBRACE,
    STATE(2193), 1,
      sym_comment,
    STATE(2198), 1,
      aux_sym_class_body_repeat1,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31031] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(225), 1,
      anon_sym_STAR,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(243), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LBRACK,
    ACTIONS(4761), 1,
      anon_sym_RBRACE,
    ACTIONS(4763), 1,
      anon_sym_async,
    ACTIONS(4765), 1,
      anon_sym_static,
    ACTIONS(4767), 1,
      anon_sym_readonly,
    ACTIONS(4773), 1,
      anon_sym_override,
    STATE(2194), 1,
      sym_comment,
    STATE(3468), 1,
      sym_accessibility_modifier,
    STATE(3530), 1,
      sym_override_modifier,
    STATE(4583), 1,
      sym__property_name,
    STATE(5743), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6146), 1,
      aux_sym_object_repeat1,
    STATE(7130), 1,
      sym__destructuring_pattern,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4769), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4771), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5739), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(6145), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4759), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31142] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4775), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2195), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31259] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4777), 1,
      anon_sym_RBRACE,
    STATE(2195), 1,
      aux_sym_class_body_repeat1,
    STATE(2196), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31376] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4779), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2197), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31493] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4781), 1,
      anon_sym_RBRACE,
    STATE(2160), 1,
      aux_sym_class_body_repeat1,
    STATE(2198), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31610] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4386), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4587), 1,
      anon_sym_STAR,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(4597), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      anon_sym_readonly,
    ACTIONS(4603), 1,
      anon_sym_declare,
    ACTIONS(4607), 1,
      anon_sym_abstract,
    ACTIONS(4783), 1,
      anon_sym_RBRACE,
    STATE(2197), 1,
      aux_sym_class_body_repeat1,
    STATE(2199), 1,
      sym_comment,
    STATE(3279), 1,
      aux_sym_export_statement_repeat1,
    STATE(3378), 1,
      sym_method_definition,
    STATE(3425), 1,
      sym_class_static_block,
    STATE(3463), 1,
      sym_accessibility_modifier,
    STATE(3528), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3792), 1,
      sym__property_name,
    STATE(5623), 1,
      sym_method_signature,
    ACTIONS(3896), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5976), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31727] = 31,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2665), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2938), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_import,
    ACTIONS(2942), 1,
      anon_sym_var,
    ACTIONS(2944), 1,
      anon_sym_let,
    ACTIONS(2946), 1,
      anon_sym_const,
    ACTIONS(2948), 1,
      anon_sym_class,
    ACTIONS(2950), 1,
      anon_sym_async,
    ACTIONS(2952), 1,
      anon_sym_function,
    ACTIONS(2954), 1,
      anon_sym_declare,
    ACTIONS(2958), 1,
      anon_sym_abstract,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    ACTIONS(4502), 1,
      anon_sym_STAR,
    ACTIONS(4504), 1,
      anon_sym_default,
    ACTIONS(4506), 1,
      anon_sym_type,
    ACTIONS(4510), 1,
      anon_sym_as,
    ACTIONS(4520), 1,
      anon_sym_module,
    ACTIONS(4785), 1,
      anon_sym_EQ,
    STATE(2200), 1,
      sym_comment,
    STATE(4878), 1,
      sym_internal_module,
    STATE(5318), 1,
      sym_declaration,
    STATE(5382), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5549), 1,
      sym_export_clause,
    STATE(6927), 1,
      sym_namespace_export,
    ACTIONS(4518), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5171), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [31841] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2201), 1,
      sym_comment,
    ACTIONS(2183), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2185), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [31903] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2665), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2938), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_import,
    ACTIONS(2942), 1,
      anon_sym_var,
    ACTIONS(2944), 1,
      anon_sym_let,
    ACTIONS(2946), 1,
      anon_sym_const,
    ACTIONS(2948), 1,
      anon_sym_class,
    ACTIONS(2950), 1,
      anon_sym_async,
    ACTIONS(2952), 1,
      anon_sym_function,
    ACTIONS(2954), 1,
      anon_sym_declare,
    ACTIONS(2958), 1,
      anon_sym_abstract,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    ACTIONS(4502), 1,
      anon_sym_STAR,
    ACTIONS(4504), 1,
      anon_sym_default,
    ACTIONS(4506), 1,
      anon_sym_type,
    ACTIONS(4508), 1,
      anon_sym_EQ,
    ACTIONS(4510), 1,
      anon_sym_as,
    ACTIONS(4520), 1,
      anon_sym_module,
    STATE(2202), 1,
      sym_comment,
    STATE(4878), 1,
      sym_internal_module,
    STATE(5318), 1,
      sym_declaration,
    STATE(5382), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5549), 1,
      sym_export_clause,
    STATE(6927), 1,
      sym_namespace_export,
    ACTIONS(4787), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5171), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [32019] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2203), 1,
      sym_comment,
    ACTIONS(2251), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2253), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [32081] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4793), 1,
      anon_sym_DOT,
    ACTIONS(4795), 1,
      anon_sym_LT,
    STATE(2204), 1,
      sym_comment,
    STATE(2324), 1,
      sym_arguments,
    STATE(2325), 1,
      sym_type_arguments,
    ACTIONS(4147), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4143), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [32152] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_LT,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4805), 1,
      anon_sym_QMARK_DOT,
    STATE(2205), 1,
      sym_comment,
    STATE(2382), 1,
      sym_type_arguments,
    STATE(2391), 1,
      sym_arguments,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4797), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4799), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [32229] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4795), 1,
      anon_sym_LT,
    ACTIONS(4809), 1,
      anon_sym_DOT,
    ACTIONS(4811), 1,
      anon_sym_is,
    STATE(2206), 1,
      sym_comment,
    STATE(2276), 1,
      sym_type_arguments,
    ACTIONS(4807), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4202), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [32298] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_LT,
    ACTIONS(4817), 1,
      anon_sym_DOT,
    STATE(2207), 1,
      sym_comment,
    STATE(2334), 1,
      sym_arguments,
    STATE(2335), 1,
      sym_type_arguments,
    ACTIONS(4813), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4815), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [32369] = 26,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(225), 1,
      anon_sym_STAR,
    ACTIONS(243), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LBRACK,
    ACTIONS(4821), 1,
      anon_sym_async,
    ACTIONS(4823), 1,
      anon_sym_static,
    ACTIONS(4825), 1,
      anon_sym_readonly,
    ACTIONS(4831), 1,
      anon_sym_override,
    STATE(2208), 1,
      sym_comment,
    STATE(3468), 1,
      sym_accessibility_modifier,
    STATE(3530), 1,
      sym_override_modifier,
    STATE(4583), 1,
      sym__property_name,
    STATE(7130), 1,
      sym__destructuring_pattern,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4064), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4827), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4829), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(6775), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(6820), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(4819), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [32472] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4795), 1,
      anon_sym_LT,
    ACTIONS(4837), 1,
      anon_sym_DOT,
    STATE(2209), 1,
      sym_comment,
    STATE(2326), 1,
      sym_arguments,
    STATE(2331), 1,
      sym_type_arguments,
    ACTIONS(4833), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4835), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [32543] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4795), 1,
      anon_sym_LT,
    ACTIONS(4809), 1,
      anon_sym_DOT,
    STATE(2210), 1,
      sym_comment,
    STATE(2276), 1,
      sym_type_arguments,
    ACTIONS(4807), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4202), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [32609] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2211), 1,
      sym_comment,
    ACTIONS(4345), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(4839), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [32669] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2212), 1,
      sym_comment,
    ACTIONS(1972), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2030), 33,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [32729] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2213), 1,
      sym_comment,
    ACTIONS(2251), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2253), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [32789] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4811), 1,
      anon_sym_is,
    STATE(2214), 1,
      sym_comment,
    ACTIONS(4841), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4843), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [32851] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2215), 1,
      sym_comment,
    ACTIONS(4845), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4847), 33,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [32911] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    ACTIONS(4851), 1,
      anon_sym_DOT,
    STATE(2216), 1,
      sym_comment,
    STATE(2535), 1,
      sym_statement_block,
    ACTIONS(2057), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [32977] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    ACTIONS(4853), 1,
      anon_sym_DOT,
    STATE(2217), 1,
      sym_comment,
    STATE(2535), 1,
      sym_statement_block,
    ACTIONS(2057), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [33043] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4859), 1,
      anon_sym_is,
    STATE(2218), 1,
      sym_comment,
    ACTIONS(4855), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4857), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [33105] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2219), 1,
      sym_comment,
    ACTIONS(2183), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2185), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [33165] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    STATE(2220), 1,
      sym_comment,
    STATE(2458), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4861), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4863), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [33231] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(2221), 1,
      sym_comment,
    STATE(2535), 1,
      sym_statement_block,
    ACTIONS(2057), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [33295] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4795), 1,
      anon_sym_LT,
    STATE(2222), 1,
      sym_comment,
    STATE(2303), 1,
      sym_type_arguments,
    ACTIONS(4855), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4857), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [33359] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2223), 1,
      sym_comment,
    ACTIONS(4343), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(4867), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [33419] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2224), 1,
      sym_comment,
    ACTIONS(4349), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(4869), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [33479] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4811), 1,
      anon_sym_is,
    STATE(2225), 1,
      sym_comment,
    ACTIONS(4871), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4873), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [33541] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4875), 1,
      sym__automatic_semicolon,
    STATE(2226), 1,
      sym_comment,
    ACTIONS(2067), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2095), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [33605] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2227), 1,
      sym_comment,
    ACTIONS(4877), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [33664] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4885), 1,
      anon_sym_LBRACK,
    STATE(2228), 1,
      sym_comment,
    ACTIONS(4881), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [33725] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2229), 1,
      sym_comment,
    ACTIONS(4871), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4873), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [33784] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4895), 1,
      anon_sym_RPAREN,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2230), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(7328), 1,
      sym_type_annotation,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33909] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4941), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2231), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4937), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4939), 19,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [33994] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2232), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4946), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [34089] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2233), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [34198] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(4948), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2234), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(7298), 1,
      sym_type_annotation,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34323] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4805), 1,
      anon_sym_QMARK_DOT,
    STATE(2235), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(2151), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2153), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34390] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_AMP,
    ACTIONS(4956), 1,
      anon_sym_PIPE,
    ACTIONS(4958), 1,
      anon_sym_extends,
    STATE(2236), 1,
      sym_comment,
    ACTIONS(4950), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4952), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34455] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2237), 1,
      sym_comment,
    ACTIONS(4877), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [34514] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2238), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4960), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [34631] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(4962), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2239), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(7344), 1,
      sym_type_annotation,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34756] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2240), 1,
      sym_comment,
    ACTIONS(4964), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4966), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [34815] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2241), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4968), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [34932] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(4970), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2242), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(7305), 1,
      sym_type_annotation,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35057] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2243), 1,
      sym_comment,
    ACTIONS(3222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3540), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35116] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2244), 1,
      sym_comment,
    ACTIONS(4972), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4974), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35175] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2245), 1,
      sym_comment,
    ACTIONS(2233), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [35234] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2246), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4976), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [35351] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2247), 1,
      sym_comment,
    ACTIONS(2237), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2239), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [35410] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4982), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2248), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4980), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [35487] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2249), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4985), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [35604] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4991), 1,
      anon_sym_DOT,
    STATE(2250), 1,
      sym_comment,
    ACTIONS(4987), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4989), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35665] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2251), 1,
      sym_comment,
    ACTIONS(4993), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4995), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35724] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2252), 1,
      sym_comment,
    ACTIONS(4997), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4999), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35783] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2253), 1,
      sym_comment,
    ACTIONS(5001), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5003), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35842] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2254), 1,
      sym_comment,
    ACTIONS(5005), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5007), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35901] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2255), 1,
      sym_comment,
    ACTIONS(5009), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5011), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35960] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2256), 1,
      sym_comment,
    ACTIONS(5013), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5015), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36019] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2257), 1,
      sym_comment,
    ACTIONS(5017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5019), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36078] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2258), 1,
      sym_comment,
    ACTIONS(5017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5019), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36137] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2259), 1,
      sym_comment,
    ACTIONS(4855), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4857), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36196] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2260), 1,
      sym_comment,
    ACTIONS(5021), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5023), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36255] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_AMP,
    STATE(2261), 1,
      sym_comment,
    ACTIONS(5025), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5027), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36316] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2262), 1,
      sym_comment,
    ACTIONS(5021), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5023), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36375] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2263), 1,
      sym_comment,
    ACTIONS(5029), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5031), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36434] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2264), 1,
      sym_comment,
    ACTIONS(5021), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5023), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36493] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2265), 1,
      sym_comment,
    ACTIONS(5033), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5035), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36552] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2266), 1,
      sym_comment,
    ACTIONS(5033), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5035), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36611] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2267), 1,
      sym_comment,
    ACTIONS(5033), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5035), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36670] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2268), 1,
      sym_comment,
    ACTIONS(5037), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36729] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2269), 1,
      sym_comment,
    ACTIONS(5041), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5043), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36788] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_AMP,
    ACTIONS(4956), 1,
      anon_sym_PIPE,
    ACTIONS(4958), 1,
      anon_sym_extends,
    STATE(2270), 1,
      sym_comment,
    ACTIONS(5045), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5047), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36853] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_AMP,
    ACTIONS(4956), 1,
      anon_sym_PIPE,
    ACTIONS(4958), 1,
      anon_sym_extends,
    STATE(2271), 1,
      sym_comment,
    ACTIONS(5049), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5051), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36918] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5057), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2272), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [36997] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_AMP,
    ACTIONS(4956), 1,
      anon_sym_PIPE,
    ACTIONS(4958), 1,
      anon_sym_extends,
    STATE(2273), 1,
      sym_comment,
    ACTIONS(5060), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5062), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37062] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2274), 1,
      sym_comment,
    ACTIONS(3236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3570), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37121] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5064), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2275), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(7412), 1,
      sym_type_annotation,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37246] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2276), 1,
      sym_comment,
    ACTIONS(5066), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5068), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37305] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2277), 1,
      sym_comment,
    ACTIONS(5060), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5062), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37364] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2278), 1,
      sym_comment,
    ACTIONS(5070), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5072), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37423] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_AMP,
    ACTIONS(4956), 1,
      anon_sym_PIPE,
    ACTIONS(4958), 1,
      anon_sym_extends,
    STATE(2279), 1,
      sym_comment,
    ACTIONS(5074), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5076), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37488] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_AMP,
    ACTIONS(4956), 1,
      anon_sym_PIPE,
    ACTIONS(4958), 1,
      anon_sym_extends,
    STATE(2280), 1,
      sym_comment,
    ACTIONS(5078), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5080), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37553] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4883), 1,
      anon_sym_extends,
    ACTIONS(4885), 1,
      anon_sym_LBRACK,
    STATE(2281), 1,
      sym_comment,
    ACTIONS(4881), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5082), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5084), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37618] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2282), 1,
      sym_comment,
    ACTIONS(5086), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5088), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37677] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2283), 1,
      sym_comment,
    ACTIONS(5090), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5092), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37736] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2284), 1,
      sym_comment,
    ACTIONS(5094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5096), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37795] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2285), 1,
      sym_comment,
    ACTIONS(5098), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37854] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2286), 1,
      sym_comment,
    ACTIONS(5094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5096), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37913] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2287), 1,
      sym_comment,
    ACTIONS(5098), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37972] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2288), 1,
      sym_comment,
    ACTIONS(5102), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5104), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38031] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2289), 1,
      sym_comment,
    ACTIONS(5106), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5108), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38090] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2290), 1,
      sym_comment,
    ACTIONS(5110), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5112), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38149] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2291), 1,
      sym_comment,
    ACTIONS(5102), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5104), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38208] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2292), 1,
      sym_comment,
    ACTIONS(5106), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5108), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38267] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4875), 1,
      sym__automatic_semicolon,
    STATE(2293), 1,
      sym_comment,
    ACTIONS(2067), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2095), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38328] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2294), 1,
      sym_comment,
    ACTIONS(5110), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5112), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38387] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5118), 1,
      anon_sym_extends,
    STATE(2295), 1,
      sym_comment,
    ACTIONS(5114), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5116), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38448] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4885), 1,
      anon_sym_LBRACK,
    STATE(2296), 1,
      sym_comment,
    ACTIONS(5120), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5122), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38509] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2297), 1,
      sym_comment,
    ACTIONS(5124), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5126), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38568] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2298), 1,
      sym_comment,
    ACTIONS(5128), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5130), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38627] = 23,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5139), 1,
      anon_sym_RBRACE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5146), 1,
      anon_sym_readonly,
    STATE(2299), 1,
      sym_comment,
    STATE(3516), 1,
      sym_override_modifier,
    STATE(3892), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [38722] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2300), 1,
      sym_comment,
    ACTIONS(3228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3518), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38781] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2301), 1,
      sym_comment,
    ACTIONS(5124), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5126), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38840] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2302), 1,
      sym_comment,
    ACTIONS(5128), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5130), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38899] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2303), 1,
      sym_comment,
    ACTIONS(5150), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5152), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38958] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2304), 1,
      sym_comment,
    ACTIONS(5154), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5156), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39017] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2305), 1,
      sym_comment,
    ACTIONS(5158), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5160), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39076] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2306), 1,
      sym_comment,
    ACTIONS(5162), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5164), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39135] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2307), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4946), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4944), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39234] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2308), 1,
      sym_comment,
    ACTIONS(5166), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5168), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39293] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2309), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5170), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [39410] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5176), 1,
      anon_sym_QMARK,
    ACTIONS(5178), 1,
      anon_sym_extends,
    STATE(2310), 1,
      sym_comment,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [39473] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2311), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5180), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [39590] = 23,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5146), 1,
      anon_sym_readonly,
    ACTIONS(5182), 1,
      anon_sym_RBRACE,
    STATE(2312), 1,
      sym_comment,
    STATE(3516), 1,
      sym_override_modifier,
    STATE(3892), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [39685] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2313), 1,
      sym_comment,
    ACTIONS(3230), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3508), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39744] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2314), 1,
      sym_comment,
    ACTIONS(3232), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3506), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39803] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5185), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2315), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 18,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [39890] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2316), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [39975] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2317), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [40078] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2318), 1,
      sym_comment,
    ACTIONS(5188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5190), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40137] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2319), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [40238] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5192), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2320), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(7443), 1,
      sym_type_annotation,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40363] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2321), 1,
      sym_comment,
    ACTIONS(4841), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4843), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40422] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2322), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5194), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [40539] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5196), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2323), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(7014), 1,
      sym_type_annotation,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40664] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2324), 1,
      sym_comment,
    ACTIONS(5176), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40723] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2325), 1,
      sym_comment,
    ACTIONS(5198), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5200), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40782] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2326), 1,
      sym_comment,
    ACTIONS(5202), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5204), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40841] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2327), 1,
      sym_comment,
    ACTIONS(5017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5019), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40900] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2328), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [41007] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2329), 1,
      sym_comment,
    ACTIONS(5154), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5156), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41066] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2330), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [41171] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2331), 1,
      sym_comment,
    ACTIONS(5206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5208), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41230] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2332), 1,
      sym_comment,
    ACTIONS(5210), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5212), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41289] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2333), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5214), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [41406] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2334), 1,
      sym_comment,
    ACTIONS(5216), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5218), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41465] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2335), 1,
      sym_comment,
    ACTIONS(5220), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5222), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41524] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_AMP,
    ACTIONS(4956), 1,
      anon_sym_PIPE,
    ACTIONS(4958), 1,
      anon_sym_extends,
    STATE(2336), 1,
      sym_comment,
    ACTIONS(5224), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5226), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [41589] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2337), 1,
      sym_comment,
    ACTIONS(5228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5230), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41648] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_AMP,
    ACTIONS(4956), 1,
      anon_sym_PIPE,
    ACTIONS(4958), 1,
      anon_sym_extends,
    STATE(2338), 1,
      sym_comment,
    ACTIONS(5232), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5234), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [41713] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4857), 1,
      anon_sym_extends,
    STATE(2339), 1,
      sym_comment,
    ACTIONS(5232), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5234), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [41774] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2340), 1,
      sym_comment,
    ACTIONS(5236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5238), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41833] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2341), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [41914] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2342), 1,
      sym_comment,
    ACTIONS(5240), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5242), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41973] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2343), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5244), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [42090] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2344), 1,
      sym_comment,
    ACTIONS(5246), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5248), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42149] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    STATE(2345), 1,
      sym_comment,
    STATE(2540), 1,
      sym_statement_block,
    ACTIONS(2057), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [42212] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    ACTIONS(5252), 1,
      anon_sym_DOT,
    STATE(2346), 1,
      sym_comment,
    STATE(2540), 1,
      sym_statement_block,
    ACTIONS(2057), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [42277] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5258), 1,
      anon_sym_DOT,
    STATE(2347), 1,
      sym_comment,
    ACTIONS(5254), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5256), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42338] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5261), 1,
      anon_sym_DOT,
    STATE(2348), 1,
      sym_comment,
    ACTIONS(5254), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5256), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42399] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2349), 1,
      sym_comment,
    ACTIONS(4877), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42458] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2350), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5264), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [42575] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2351), 1,
      sym_comment,
    ACTIONS(5266), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5268), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42634] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2352), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5270), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [42751] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2353), 1,
      sym_comment,
    ACTIONS(5162), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5164), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42810] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2354), 1,
      sym_comment,
    ACTIONS(5246), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5248), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42869] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2355), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5272), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [42986] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2356), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5274), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43103] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2357), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [43194] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2358), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5276), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43311] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_AMP,
    ACTIONS(4956), 1,
      anon_sym_PIPE,
    ACTIONS(4958), 1,
      anon_sym_extends,
    STATE(2359), 1,
      sym_comment,
    ACTIONS(5266), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5268), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [43376] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2360), 1,
      sym_comment,
    ACTIONS(5246), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5248), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43435] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2361), 1,
      sym_comment,
    ACTIONS(5278), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5280), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43494] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2362), 1,
      sym_comment,
    ACTIONS(5282), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5284), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43553] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2363), 1,
      sym_comment,
    ACTIONS(5286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5288), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43612] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2364), 1,
      sym_comment,
    ACTIONS(5290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5292), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43671] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_AMP,
    STATE(2365), 1,
      sym_comment,
    ACTIONS(5294), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5296), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43732] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    ACTIONS(5298), 1,
      anon_sym_DOT,
    STATE(2366), 1,
      sym_comment,
    STATE(2540), 1,
      sym_statement_block,
    ACTIONS(2057), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [43797] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2367), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5300), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43914] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5302), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2368), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(6997), 1,
      sym_type_annotation,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44039] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2369), 1,
      sym_comment,
    ACTIONS(5304), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5306), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44098] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    STATE(2370), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [44159] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5308), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2371), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(7293), 1,
      sym_type_annotation,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44284] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2372), 1,
      sym_comment,
    ACTIONS(5162), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5164), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44343] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2373), 1,
      sym_comment,
    ACTIONS(4881), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44402] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2374), 1,
      sym_comment,
    ACTIONS(5310), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5312), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44461] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2375), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [44548] = 23,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5146), 1,
      anon_sym_readonly,
    ACTIONS(5314), 1,
      anon_sym_RBRACE,
    STATE(2376), 1,
      sym_comment,
    STATE(3516), 1,
      sym_override_modifier,
    STATE(3892), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [44643] = 23,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5146), 1,
      anon_sym_readonly,
    ACTIONS(5317), 1,
      anon_sym_RBRACE,
    STATE(2377), 1,
      sym_comment,
    STATE(3516), 1,
      sym_override_modifier,
    STATE(3892), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [44738] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2378), 1,
      sym_comment,
    ACTIONS(5029), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5031), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [44801] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5003), 1,
      anon_sym_extends,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    STATE(2379), 1,
      sym_comment,
    ACTIONS(5326), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5329), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5320), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [44868] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2380), 1,
      sym_comment,
    ACTIONS(5332), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5334), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44927] = 23,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5146), 1,
      anon_sym_readonly,
    ACTIONS(5336), 1,
      anon_sym_RBRACE,
    STATE(2381), 1,
      sym_comment,
    STATE(3516), 1,
      sym_override_modifier,
    STATE(3892), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [45022] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    STATE(2382), 1,
      sym_comment,
    STATE(2444), 1,
      sym_arguments,
    ACTIONS(5339), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [45085] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3570), 1,
      anon_sym_extends,
    STATE(2383), 1,
      sym_comment,
    ACTIONS(5343), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5346), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2069), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [45152] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2384), 1,
      sym_comment,
    ACTIONS(5349), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5351), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [45211] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2385), 1,
      sym_comment,
    ACTIONS(5353), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5355), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [45270] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2386), 1,
      sym_comment,
    ACTIONS(5357), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5359), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [45329] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5361), 1,
      sym__automatic_semicolon,
    STATE(2387), 1,
      sym_comment,
    ACTIONS(2111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2115), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [45390] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2388), 1,
      sym_comment,
    ACTIONS(5363), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5365), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [45448] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2389), 1,
      sym_comment,
    ACTIONS(5367), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [45506] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5371), 1,
      anon_sym_STAR,
    ACTIONS(5373), 1,
      anon_sym_LBRACE,
    ACTIONS(5375), 1,
      anon_sym_async,
    ACTIONS(5377), 1,
      anon_sym_readonly,
    ACTIONS(5381), 1,
      sym__automatic_semicolon,
    STATE(2390), 1,
      sym_comment,
    STATE(3418), 1,
      sym_statement_block,
    STATE(3523), 1,
      sym_override_modifier,
    STATE(3819), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [45594] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2391), 1,
      sym_comment,
    ACTIONS(5384), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5386), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [45652] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2392), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5180), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [45768] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5336), 1,
      anon_sym_RBRACE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2393), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5442), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [45854] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2394), 1,
      sym_comment,
    ACTIONS(2145), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2147), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [45912] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5336), 1,
      anon_sym_RBRACE,
    ACTIONS(5444), 1,
      anon_sym_LBRACK,
    STATE(2395), 1,
      sym_comment,
    STATE(3892), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [46000] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2396), 1,
      sym_comment,
    ACTIONS(5446), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5448), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46058] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2397), 1,
      sym_comment,
    ACTIONS(5450), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5452), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46116] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2398), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5276), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [46232] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2399), 1,
      sym_comment,
    ACTIONS(5490), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5492), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46290] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(2400), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [46392] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5494), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5496), 1,
      anon_sym_LT,
    STATE(2401), 1,
      sym_comment,
    STATE(2869), 1,
      sym_type_arguments,
    STATE(3016), 1,
      sym_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4797), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4799), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [46466] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2402), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5500), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46586] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2403), 1,
      sym_comment,
    ACTIONS(5502), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5504), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46644] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2404), 1,
      sym_comment,
    ACTIONS(5506), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5508), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46702] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2405), 1,
      sym_comment,
    ACTIONS(5510), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46760] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5317), 1,
      anon_sym_RBRACE,
    ACTIONS(5444), 1,
      anon_sym_LBRACK,
    STATE(2406), 1,
      sym_comment,
    STATE(3892), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [46848] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2407), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5270), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [46964] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5514), 1,
      anon_sym_LT,
    STATE(2408), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [47048] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5314), 1,
      anon_sym_RBRACE,
    ACTIONS(5444), 1,
      anon_sym_LBRACK,
    STATE(2409), 1,
      sym_comment,
    STATE(3892), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [47136] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2410), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4960), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [47252] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5317), 1,
      anon_sym_RBRACE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2411), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5442), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [47338] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2412), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5517), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47458] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5043), 1,
      anon_sym_extends,
    STATE(2413), 1,
      sym_comment,
    ACTIONS(5523), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5526), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5519), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5521), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [47522] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2414), 1,
      sym_comment,
    ACTIONS(5529), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5531), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [47580] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2415), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5272), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [47696] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2416), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5533), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47816] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2417), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5535), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47936] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2418), 1,
      sym_comment,
    ACTIONS(5537), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5539), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [47994] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2419), 1,
      sym_comment,
    ACTIONS(2145), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2147), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48052] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2420), 1,
      sym_comment,
    ACTIONS(5541), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5543), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48110] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2421), 1,
      sym_comment,
    ACTIONS(5545), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5547), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48168] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2422), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5264), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [48284] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5549), 1,
      anon_sym_LT,
    STATE(2423), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4937), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4939), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48368] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2424), 1,
      sym_comment,
    ACTIONS(5552), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5554), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48426] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2425), 1,
      sym_comment,
    ACTIONS(5556), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48484] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2426), 1,
      sym_comment,
    ACTIONS(5560), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5562), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48542] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2427), 1,
      sym_comment,
    ACTIONS(5564), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5566), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48600] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2428), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5568), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48720] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2429), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5570), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48840] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2430), 1,
      sym_comment,
    ACTIONS(5572), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5574), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48898] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2431), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5244), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [49014] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2432), 1,
      sym_comment,
    ACTIONS(5576), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5578), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49072] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5580), 1,
      anon_sym_LT,
    STATE(2433), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4980), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49148] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5314), 1,
      anon_sym_RBRACE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2434), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5442), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [49234] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2435), 1,
      sym_comment,
    ACTIONS(5552), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5554), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49292] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2436), 1,
      sym_comment,
    ACTIONS(5583), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5194), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49350] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5585), 1,
      anon_sym_LT,
    STATE(2437), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [49428] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2438), 1,
      sym_comment,
    ACTIONS(5588), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5590), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49486] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5514), 1,
      anon_sym_LT,
    STATE(2439), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49572] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2440), 1,
      sym_comment,
    ACTIONS(2237), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2239), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49630] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2441), 1,
      sym_comment,
    ACTIONS(5552), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5554), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49688] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2442), 1,
      sym_comment,
    ACTIONS(5592), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5594), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49746] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2443), 1,
      sym_comment,
    ACTIONS(2233), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49804] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2444), 1,
      sym_comment,
    ACTIONS(5596), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5598), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49862] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2445), 1,
      sym_comment,
    ACTIONS(5600), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5602), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49920] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2446), 1,
      sym_comment,
    ACTIONS(5604), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5270), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49978] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    STATE(2447), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [50078] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2448), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5606), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50198] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2449), 1,
      sym_comment,
    ACTIONS(5608), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5610), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50256] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2450), 1,
      sym_comment,
    ACTIONS(2215), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2219), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50314] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2451), 1,
      sym_comment,
    ACTIONS(2227), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2231), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50372] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2452), 1,
      sym_comment,
    ACTIONS(2243), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2247), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50430] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2453), 1,
      sym_comment,
    ACTIONS(5612), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5264), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50488] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2454), 1,
      sym_comment,
    ACTIONS(2191), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2195), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50546] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2455), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5614), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5616), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50664] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    STATE(2456), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [50762] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2457), 1,
      sym_comment,
    ACTIONS(5618), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5620), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50820] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2458), 1,
      sym_comment,
    ACTIONS(5622), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5624), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50878] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2459), 1,
      sym_comment,
    ACTIONS(2163), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2165), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [50936] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2460), 1,
      sym_comment,
    ACTIONS(2163), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2165), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50994] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2461), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5300), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51110] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2462), 1,
      sym_comment,
    ACTIONS(5626), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5628), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [51168] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2463), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5194), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51284] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(2464), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [51374] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    STATE(2465), 1,
      sym_comment,
    ACTIONS(5630), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5634), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [51434] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2466), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5636), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51554] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2467), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5638), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51674] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5640), 1,
      anon_sym_COMMA,
    ACTIONS(5643), 1,
      anon_sym_RBRACE,
    STATE(2468), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5300), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51794] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5614), 1,
      anon_sym_RBRACE,
    ACTIONS(5645), 1,
      anon_sym_COMMA,
    STATE(2469), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5300), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51914] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5496), 1,
      anon_sym_LT,
    ACTIONS(5648), 1,
      anon_sym_DOT,
    ACTIONS(5650), 1,
      anon_sym_is,
    STATE(2470), 1,
      sym_comment,
    STATE(2848), 1,
      sym_type_arguments,
    ACTIONS(4807), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4202), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [51980] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(2471), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [52080] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5614), 1,
      anon_sym_RBRACE,
    ACTIONS(5652), 1,
      anon_sym_COMMA,
    STATE(2472), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5170), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52200] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2473), 1,
      sym_comment,
    ACTIONS(5655), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5244), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [52258] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2474), 1,
      sym_comment,
    ACTIONS(5632), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5657), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5630), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5634), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [52320] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2475), 1,
      sym_comment,
    ACTIONS(5660), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5662), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [52378] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5496), 1,
      anon_sym_LT,
    ACTIONS(5664), 1,
      anon_sym_DOT,
    STATE(2476), 1,
      sym_comment,
    STATE(2731), 1,
      sym_type_arguments,
    STATE(2732), 1,
      sym_arguments,
    ACTIONS(4813), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4815), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [52446] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5614), 1,
      anon_sym_RBRACE,
    ACTIONS(5652), 1,
      anon_sym_COMMA,
    STATE(2477), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5666), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52566] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2478), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5668), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52686] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2479), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5670), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52806] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2480), 1,
      sym_comment,
    ACTIONS(5672), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5674), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [52864] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2481), 1,
      sym_comment,
    ACTIONS(5676), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5678), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [52922] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2482), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5274), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [53038] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2483), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5180), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [53154] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2484), 1,
      sym_comment,
    ACTIONS(2071), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5680), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2069), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [53216] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2485), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5276), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [53332] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2486), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5274), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [53448] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5496), 1,
      anon_sym_LT,
    ACTIONS(5683), 1,
      anon_sym_DOT,
    STATE(2487), 1,
      sym_comment,
    STATE(2735), 1,
      sym_type_arguments,
    STATE(2736), 1,
      sym_arguments,
    ACTIONS(4833), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4835), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53516] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5496), 1,
      anon_sym_LT,
    ACTIONS(5685), 1,
      anon_sym_DOT,
    STATE(2488), 1,
      sym_comment,
    STATE(2737), 1,
      sym_type_arguments,
    STATE(2738), 1,
      sym_arguments,
    ACTIONS(4147), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4143), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [53584] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2489), 1,
      sym_comment,
    ACTIONS(2125), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2127), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [53642] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    STATE(2490), 1,
      sym_comment,
    ACTIONS(5320), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [53702] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(2491), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [53800] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2492), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5270), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [53916] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2493), 1,
      sym_comment,
    ACTIONS(5687), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5689), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [53974] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2494), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5264), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [54090] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2495), 1,
      sym_comment,
    ACTIONS(5691), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4968), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [54148] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2496), 1,
      sym_comment,
    ACTIONS(5693), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5695), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [54206] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2497), 1,
      sym_comment,
    ACTIONS(5697), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5699), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [54264] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2498), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5244), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [54380] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2499), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4968), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [54496] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5701), 1,
      sym__automatic_semicolon,
    STATE(2500), 1,
      sym_comment,
    ACTIONS(2067), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2095), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [54556] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2501), 1,
      sym_comment,
    ACTIONS(5703), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5705), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [54614] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2502), 1,
      sym_comment,
    ACTIONS(5707), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5709), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [54672] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2503), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4985), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [54788] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2504), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4976), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [54904] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2505), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5711), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55024] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2506), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5272), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [55140] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5139), 1,
      anon_sym_RBRACE,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5444), 1,
      anon_sym_LBRACK,
    STATE(2507), 1,
      sym_comment,
    STATE(3892), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [55228] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2508), 1,
      sym_comment,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [55286] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2509), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5300), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [55402] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5139), 1,
      anon_sym_RBRACE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2510), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5442), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [55488] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2511), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5170), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [55604] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2512), 1,
      sym_comment,
    ACTIONS(2105), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2109), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [55662] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2513), 1,
      sym_comment,
    ACTIONS(5713), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5715), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [55720] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2514), 1,
      sym_comment,
    ACTIONS(2111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2115), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [55778] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2515), 1,
      sym_comment,
    ACTIONS(2199), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2203), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [55836] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    STATE(2516), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [55944] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2517), 1,
      sym_comment,
    ACTIONS(5717), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5719), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [56002] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(2518), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4946), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [56096] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    STATE(2519), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4946), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [56190] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2520), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5194), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [56306] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2521), 1,
      sym_comment,
    ACTIONS(2085), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2089), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [56364] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2522), 1,
      sym_comment,
    ACTIONS(2257), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2261), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [56422] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2523), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5721), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [56538] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(2524), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [56646] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2525), 1,
      sym_comment,
    ACTIONS(2125), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2127), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [56704] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2526), 1,
      sym_comment,
    ACTIONS(2207), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2211), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [56762] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5514), 1,
      anon_sym_LT,
    STATE(2527), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [56848] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(2528), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [56954] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2529), 1,
      sym_comment,
    ACTIONS(2169), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2173), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57012] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(2530), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [57116] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2531), 1,
      sym_comment,
    ACTIONS(5723), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5725), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57174] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2532), 1,
      sym_comment,
    ACTIONS(2221), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2223), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57232] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    STATE(2533), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [57322] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2534), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4976), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [57438] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2535), 1,
      sym_comment,
    ACTIONS(2175), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2177), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [57496] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2536), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4968), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [57612] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2537), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5170), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [57728] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5727), 1,
      anon_sym_LT,
    STATE(2538), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4980), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57804] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2539), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4985), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [57920] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2540), 1,
      sym_comment,
    ACTIONS(2175), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2177), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57978] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2541), 1,
      sym_comment,
    ACTIONS(5519), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5521), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58036] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5514), 1,
      anon_sym_LT,
    STATE(2542), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [58116] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2543), 1,
      sym_comment,
    ACTIONS(2111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2115), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [58174] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5730), 1,
      sym__automatic_semicolon,
    STATE(2544), 1,
      sym_comment,
    ACTIONS(2111), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2115), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [58234] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2545), 1,
      sym_comment,
    ACTIONS(5732), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5734), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58292] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2546), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5736), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58412] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2547), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58470] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2548), 1,
      sym_comment,
    ACTIONS(5738), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4976), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58528] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2549), 1,
      sym_comment,
    ACTIONS(2221), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2223), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [58586] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2550), 1,
      sym_comment,
    ACTIONS(5740), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5742), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58644] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5182), 1,
      anon_sym_RBRACE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2551), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5442), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [58730] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2552), 1,
      sym_comment,
    ACTIONS(5322), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5744), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5320), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [58792] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2553), 1,
      sym_comment,
    ACTIONS(2069), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58852] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2554), 1,
      sym_comment,
    ACTIONS(5747), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5749), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58910] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5751), 1,
      anon_sym_LT,
    STATE(2555), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [58996] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5751), 1,
      anon_sym_LT,
    STATE(2556), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [59080] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    STATE(2557), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5396), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4960), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [59196] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2558), 1,
      sym_comment,
    ACTIONS(5754), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5756), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59254] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    STATE(2559), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [59356] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2560), 1,
      sym_comment,
    ACTIONS(5758), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5760), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59414] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5396), 1,
      anon_sym_GT,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5404), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5406), 1,
      anon_sym_GT_GT,
    ACTIONS(5410), 1,
      anon_sym_AMP,
    ACTIONS(5412), 1,
      anon_sym_CARET,
    ACTIONS(5414), 1,
      anon_sym_PIPE,
    ACTIONS(5418), 1,
      anon_sym_PERCENT,
    ACTIONS(5420), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5430), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5438), 1,
      sym__ternary_qmark,
    ACTIONS(5764), 1,
      anon_sym_in,
    STATE(2561), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5388), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5408), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5416), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5426), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5428), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5424), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5762), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [59532] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5751), 1,
      anon_sym_LT,
    STATE(2562), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [59612] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5767), 1,
      anon_sym_LT,
    STATE(2563), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [59690] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    STATE(2564), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [59794] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2565), 1,
      sym_comment,
    ACTIONS(2139), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2143), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59852] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2566), 1,
      sym_comment,
    ACTIONS(2131), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2135), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59910] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5182), 1,
      anon_sym_RBRACE,
    ACTIONS(5444), 1,
      anon_sym_LBRACK,
    STATE(2567), 1,
      sym_comment,
    STATE(3892), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [59998] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2568), 1,
      sym_comment,
    ACTIONS(2151), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2153), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [60056] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5770), 1,
      anon_sym_LT,
    STATE(2569), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4937), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4939), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [60140] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4843), 1,
      anon_sym_extends,
    STATE(2570), 1,
      sym_comment,
    ACTIONS(5773), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5776), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [60204] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    STATE(2571), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [60310] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5190), 1,
      anon_sym_extends,
    STATE(2572), 1,
      sym_comment,
    ACTIONS(5779), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [60374] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2573), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5785), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60494] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5751), 1,
      anon_sym_LT,
    STATE(2574), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [60580] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2575), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5787), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60700] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(2576), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5591), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5789), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60820] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5791), 1,
      anon_sym_RBRACK,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2577), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60939] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    ACTIONS(5326), 1,
      anon_sym_LBRACK,
    STATE(2578), 1,
      sym_comment,
    ACTIONS(5329), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5793), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5003), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5320), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61006] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5799), 1,
      anon_sym_RBRACK,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2579), 1,
      sym_comment,
    STATE(5970), 1,
      aux_sym_array_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61125] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5801), 1,
      anon_sym_static,
    ACTIONS(5803), 1,
      anon_sym_readonly,
    ACTIONS(5805), 1,
      anon_sym_abstract,
    STATE(2580), 1,
      sym_comment,
    STATE(3494), 1,
      sym_accessibility_modifier,
    STATE(3567), 1,
      sym_override_modifier,
    STATE(4076), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [61210] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5170), 1,
      anon_sym_COMMA,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2581), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5666), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61327] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2582), 1,
      sym_comment,
    ACTIONS(2071), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5807), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2069), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61388] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2583), 1,
      sym_comment,
    ACTIONS(5632), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5809), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5630), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5634), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61449] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2584), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5170), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61564] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(5190), 1,
      anon_sym_extends,
    STATE(2585), 1,
      sym_comment,
    ACTIONS(5779), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [61629] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2586), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4968), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61744] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5847), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2587), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61863] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5849), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2588), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61982] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5317), 1,
      anon_sym_RBRACE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2589), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [62063] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5496), 1,
      anon_sym_LT,
    STATE(2590), 1,
      sym_comment,
    STATE(2840), 1,
      sym_type_arguments,
    ACTIONS(4855), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4857), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62124] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5170), 1,
      anon_sym_COMMA,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2591), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5851), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62241] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2592), 1,
      sym_comment,
    STATE(2921), 1,
      sym_type_arguments,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5853), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [62356] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5496), 1,
      anon_sym_LT,
    ACTIONS(5648), 1,
      anon_sym_DOT,
    STATE(2593), 1,
      sym_comment,
    STATE(2848), 1,
      sym_type_arguments,
    ACTIONS(4807), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4202), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62419] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2594), 1,
      sym_comment,
    ACTIONS(1972), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2030), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_is,
  [62476] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5855), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2595), 1,
      sym_comment,
    STATE(5723), 1,
      aux_sym_array_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62595] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5857), 1,
      anon_sym_static,
    ACTIONS(5859), 1,
      anon_sym_readonly,
    ACTIONS(5861), 1,
      anon_sym_abstract,
    STATE(2596), 1,
      sym_comment,
    STATE(3480), 1,
      sym_accessibility_modifier,
    STATE(3554), 1,
      sym_override_modifier,
    STATE(4125), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [62680] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2597), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5863), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [62795] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5650), 1,
      anon_sym_is,
    STATE(2598), 1,
      sym_comment,
    ACTIONS(4871), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4873), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62854] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2599), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5180), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62969] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2600), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [63084] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5865), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2601), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63203] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2602), 1,
      sym_comment,
    ACTIONS(4343), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4867), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [63260] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2603), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5272), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63375] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5314), 1,
      anon_sym_RBRACE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2604), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [63456] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3570), 1,
      anon_sym_extends,
    STATE(2605), 1,
      sym_comment,
    ACTIONS(5343), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5346), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2069), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63521] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2606), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5762), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [63636] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5182), 1,
      anon_sym_RBRACE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2607), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [63717] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2608), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5276), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63832] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2609), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5274), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63947] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5139), 1,
      anon_sym_RBRACE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2610), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [64028] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2611), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5270), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64143] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2612), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5264), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64258] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2613), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5244), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64373] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5867), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2614), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4980), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [64448] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2615), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4960), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64563] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5870), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2616), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4937), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4939), 17,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [64646] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5873), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2617), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [64723] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2618), 1,
      sym_comment,
    ACTIONS(5178), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64782] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5003), 1,
      anon_sym_extends,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    STATE(2619), 1,
      sym_comment,
    ACTIONS(5326), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5329), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5320), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64847] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2620), 1,
      sym_comment,
    ACTIONS(4845), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4847), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_is,
  [64904] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5876), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2621), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65023] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5170), 1,
      anon_sym_COMMA,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2622), 1,
      sym_comment,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5878), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65140] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5880), 1,
      anon_sym_RBRACK,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2623), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65259] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4257), 1,
      anon_sym_QMARK,
    STATE(2624), 1,
      sym_comment,
    ACTIONS(4253), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65322] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5882), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2625), 1,
      sym_comment,
    STATE(6013), 1,
      aux_sym_array_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65441] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5884), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2626), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65560] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(2627), 1,
      sym_comment,
    STATE(3118), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4861), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4863), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [65623] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5886), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2628), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65742] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5888), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2629), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65861] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5890), 1,
      anon_sym_RBRACE,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2630), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65980] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5892), 1,
      anon_sym_RBRACE,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2631), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66099] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5894), 1,
      anon_sym_RBRACK,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2632), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66218] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5896), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2633), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(6324), 1,
      aux_sym_array_repeat1,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66337] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5170), 1,
      anon_sym_COMMA,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2634), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5898), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66454] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5146), 1,
      anon_sym_readonly,
    STATE(2635), 1,
      sym_comment,
    STATE(3516), 1,
      sym_override_modifier,
    STATE(3892), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5900), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [66541] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2636), 1,
      sym_comment,
    ACTIONS(5322), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5904), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5320), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66602] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2637), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5906), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [66717] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5336), 1,
      anon_sym_RBRACE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2638), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [66798] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2639), 1,
      sym_comment,
    ACTIONS(4349), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4869), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [66855] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2640), 1,
      sym_comment,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [66912] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5908), 1,
      anon_sym_RBRACK,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2641), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(6206), 1,
      aux_sym_array_repeat1,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67031] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2642), 1,
      sym_comment,
    ACTIONS(4345), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4839), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [67088] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5910), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2643), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(6189), 1,
      aux_sym_array_repeat1,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67207] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2644), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5300), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67322] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2645), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5194), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67437] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5912), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2646), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(6233), 1,
      aux_sym_array_repeat1,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67556] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2647), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [67645] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4267), 1,
      anon_sym_QMARK,
    ACTIONS(4284), 1,
      anon_sym_EQ,
    STATE(2648), 1,
      sym_comment,
    ACTIONS(4287), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67708] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2649), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5214), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67823] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5914), 1,
      anon_sym_RBRACK,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2650), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67942] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5916), 1,
      anon_sym_COLON,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2651), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68061] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5918), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2652), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [68140] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5921), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2653), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68259] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5170), 1,
      anon_sym_COMMA,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5458), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5460), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5462), 1,
      anon_sym_GT_GT,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 1,
      anon_sym_CARET,
    ACTIONS(5470), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_PERCENT,
    ACTIONS(5476), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5478), 1,
      anon_sym_LT,
    ACTIONS(5486), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5488), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2654), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5456), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5464), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5472), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5484), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5923), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5480), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68376] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5925), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2655), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68495] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5927), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2656), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(6260), 1,
      aux_sym_array_repeat1,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68614] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5929), 1,
      anon_sym_RBRACE,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2657), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68733] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2658), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [68836] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5343), 1,
      anon_sym_LBRACK,
    STATE(2659), 1,
      sym_comment,
    ACTIONS(5346), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5931), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3570), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2069), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [68903] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5935), 1,
      anon_sym_is,
    STATE(2660), 1,
      sym_comment,
    ACTIONS(4855), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4857), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [68962] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5937), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2661), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69081] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5650), 1,
      anon_sym_is,
    STATE(2662), 1,
      sym_comment,
    ACTIONS(4841), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4843), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [69140] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    ACTIONS(5326), 1,
      anon_sym_LBRACK,
    STATE(2663), 1,
      sym_comment,
    ACTIONS(5003), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5329), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5320), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69205] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5343), 1,
      anon_sym_LBRACK,
    STATE(2664), 1,
      sym_comment,
    ACTIONS(3570), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5346), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2069), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69270] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4267), 1,
      anon_sym_QMARK,
    STATE(2665), 1,
      sym_comment,
    ACTIONS(4264), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69333] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2666), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [69438] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2667), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4976), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69553] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5918), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2668), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [69638] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    ACTIONS(5843), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5845), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2669), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4985), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69753] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5939), 1,
      anon_sym_RBRACK,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2670), 1,
      sym_comment,
    STATE(5970), 1,
      aux_sym_array_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69872] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5815), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5827), 1,
      anon_sym_PIPE,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2671), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [69979] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2672), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [70076] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2673), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [70175] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5823), 1,
      anon_sym_AMP,
    ACTIONS(5825), 1,
      anon_sym_CARET,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2674), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [70276] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5819), 1,
      anon_sym_GT_GT,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5835), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2675), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5813), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5821), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5837), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4946), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [70369] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5831), 1,
      anon_sym_PERCENT,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5918), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2676), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5811), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [70452] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5833), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5918), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2677), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 16,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [70537] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5941), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2678), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70656] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5943), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2679), 1,
      sym_comment,
    STATE(4631), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70775] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(2680), 1,
      sym_comment,
    ACTIONS(5782), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5190), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [70840] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5945), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2681), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(6278), 1,
      aux_sym_array_repeat1,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70959] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5190), 1,
      anon_sym_extends,
    STATE(2682), 1,
      sym_comment,
    ACTIONS(5779), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71021] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2683), 1,
      sym_comment,
    ACTIONS(5021), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5023), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71077] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2684), 1,
      sym_comment,
    ACTIONS(5102), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5104), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71133] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2685), 1,
      sym_comment,
    ACTIONS(5110), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5112), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71189] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2686), 1,
      sym_comment,
    ACTIONS(5102), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5104), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71245] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2687), 1,
      sym_comment,
    ACTIONS(5110), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5112), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71301] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2688), 1,
      sym_comment,
    ACTIONS(5124), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5126), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71357] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2689), 1,
      sym_comment,
    ACTIONS(5128), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5130), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71413] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2690), 1,
      sym_comment,
    ACTIONS(5124), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5126), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71469] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2691), 1,
      sym_comment,
    ACTIONS(5128), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5130), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71525] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2692), 1,
      sym_comment,
    ACTIONS(3232), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3506), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71581] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2693), 1,
      sym_comment,
    ACTIONS(5158), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5160), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71637] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2694), 1,
      sym_comment,
    ACTIONS(5166), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5168), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71693] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2695), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5951), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71807] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    STATE(2696), 1,
      sym_comment,
    ACTIONS(5320), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71865] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2697), 1,
      sym_comment,
    ACTIONS(5782), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5779), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5190), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71927] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4231), 1,
      anon_sym_EQ,
    ACTIONS(5190), 1,
      anon_sym_extends,
    STATE(2698), 1,
      sym_comment,
    ACTIONS(5779), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71991] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2699), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5614), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72105] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5773), 1,
      anon_sym_LBRACK,
    STATE(2700), 1,
      sym_comment,
    ACTIONS(4843), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5776), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72167] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2701), 1,
      sym_comment,
    ACTIONS(5526), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5523), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5043), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5519), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5521), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72229] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2702), 1,
      sym_comment,
    ACTIONS(5210), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5212), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [72285] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2703), 1,
      sym_comment,
    ACTIONS(5154), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5156), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [72341] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(5987), 1,
      anon_sym_RBRACE,
    STATE(2704), 1,
      sym_comment,
    STATE(3531), 1,
      sym_override_modifier,
    STATE(4808), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [72431] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2705), 1,
      sym_comment,
    ACTIONS(5154), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5156), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [72487] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2706), 1,
      sym_comment,
    ACTIONS(5106), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5108), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [72543] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2707), 1,
      sym_comment,
    ACTIONS(5106), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5108), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [72599] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3236), 1,
      anon_sym_QMARK,
    ACTIONS(3570), 1,
      anon_sym_extends,
    ACTIONS(5343), 1,
      anon_sym_LBRACK,
    ACTIONS(5807), 1,
      anon_sym_COLON,
    STATE(2708), 1,
      sym_comment,
    ACTIONS(5346), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5931), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2069), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72669] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2709), 1,
      sym_comment,
    ACTIONS(5094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5096), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [72725] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2710), 1,
      sym_comment,
    ACTIONS(5029), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5031), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72785] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    STATE(2711), 1,
      sym_comment,
    ACTIONS(5043), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5526), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5519), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5521), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72847] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2712), 1,
      sym_comment,
    ACTIONS(5098), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [72903] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2713), 1,
      sym_comment,
    ACTIONS(5776), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5773), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4843), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72965] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2714), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [73061] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2715), 1,
      sym_comment,
    ACTIONS(5094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5096), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [73117] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6011), 1,
      anon_sym_STAR,
    ACTIONS(6013), 1,
      anon_sym_async,
    ACTIONS(6015), 1,
      anon_sym_readonly,
    STATE(2716), 1,
      sym_comment,
    STATE(3527), 1,
      sym_override_modifier,
    STATE(3809), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6017), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [73199] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2717), 1,
      sym_comment,
    ACTIONS(5304), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5306), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [73255] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6019), 1,
      anon_sym_AMP,
    STATE(2718), 1,
      sym_comment,
    ACTIONS(5294), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5296), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [73313] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    STATE(2719), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73371] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2720), 1,
      sym_comment,
    ACTIONS(5286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5288), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [73427] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6019), 1,
      anon_sym_AMP,
    ACTIONS(6021), 1,
      anon_sym_PIPE,
    ACTIONS(6023), 1,
      anon_sym_extends,
    STATE(2721), 1,
      sym_comment,
    ACTIONS(5266), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5268), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73489] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2722), 1,
      sym_comment,
    ACTIONS(5266), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5268), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [73545] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5261), 1,
      anon_sym_DOT,
    STATE(2723), 1,
      sym_comment,
    ACTIONS(5254), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5256), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [73603] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6011), 1,
      anon_sym_STAR,
    ACTIONS(6013), 1,
      anon_sym_async,
    ACTIONS(6025), 1,
      anon_sym_abstract,
    STATE(2724), 1,
      sym_comment,
    STATE(3810), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6017), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [73681] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5258), 1,
      anon_sym_DOT,
    STATE(2725), 1,
      sym_comment,
    ACTIONS(5254), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5256), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [73739] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2726), 1,
      sym_comment,
    ACTIONS(5310), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5312), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [73795] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6027), 1,
      anon_sym_static,
    ACTIONS(6029), 1,
      anon_sym_readonly,
    ACTIONS(6031), 1,
      anon_sym_abstract,
    STATE(2727), 1,
      sym_comment,
    STATE(3577), 1,
      sym_override_modifier,
    STATE(4233), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [73875] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2728), 1,
      sym_comment,
    ACTIONS(5090), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5092), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [73931] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2729), 1,
      sym_comment,
    ACTIONS(5240), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5242), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [73987] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2730), 1,
      sym_comment,
    ACTIONS(5236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5238), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [74043] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2731), 1,
      sym_comment,
    ACTIONS(5220), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5222), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [74099] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2732), 1,
      sym_comment,
    ACTIONS(5216), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5218), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [74155] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2733), 1,
      sym_comment,
    ACTIONS(3230), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3508), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [74211] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2734), 1,
      sym_comment,
    ACTIONS(5086), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5088), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [74267] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2735), 1,
      sym_comment,
    ACTIONS(5206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5208), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [74323] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2736), 1,
      sym_comment,
    ACTIONS(5202), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5204), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [74379] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2737), 1,
      sym_comment,
    ACTIONS(5198), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5200), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [74435] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2738), 1,
      sym_comment,
    ACTIONS(5176), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5178), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [74491] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6033), 1,
      sym__automatic_semicolon,
    STATE(2739), 1,
      sym_comment,
    ACTIONS(2095), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2069), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74553] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    ACTIONS(6035), 1,
      anon_sym_SEMI,
    ACTIONS(6037), 1,
      sym__automatic_semicolon,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2740), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74669] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    ACTIONS(6039), 1,
      anon_sym_SEMI,
    ACTIONS(6041), 1,
      sym__automatic_semicolon,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2741), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74785] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6019), 1,
      anon_sym_AMP,
    ACTIONS(6021), 1,
      anon_sym_PIPE,
    ACTIONS(6023), 1,
      anon_sym_extends,
    STATE(2742), 1,
      sym_comment,
    ACTIONS(4950), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4952), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74847] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6019), 1,
      anon_sym_AMP,
    ACTIONS(6021), 1,
      anon_sym_PIPE,
    ACTIONS(6023), 1,
      anon_sym_extends,
    STATE(2743), 1,
      sym_comment,
    ACTIONS(5078), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5080), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74909] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    ACTIONS(5190), 1,
      anon_sym_extends,
    STATE(2744), 1,
      sym_comment,
    ACTIONS(5779), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74973] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6043), 1,
      anon_sym_STAR,
    ACTIONS(6045), 1,
      anon_sym_async,
    ACTIONS(6047), 1,
      anon_sym_readonly,
    STATE(2745), 1,
      sym_comment,
    STATE(3529), 1,
      sym_override_modifier,
    STATE(3872), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6049), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [75055] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4843), 1,
      anon_sym_extends,
    STATE(2746), 1,
      sym_comment,
    ACTIONS(5773), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5776), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75117] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2747), 1,
      sym_comment,
    ACTIONS(5070), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5072), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [75173] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    STATE(2748), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75231] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2749), 1,
      sym_comment,
    ACTIONS(5060), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5062), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [75287] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6019), 1,
      anon_sym_AMP,
    ACTIONS(6021), 1,
      anon_sym_PIPE,
    ACTIONS(6023), 1,
      anon_sym_extends,
    STATE(2750), 1,
      sym_comment,
    ACTIONS(5060), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5062), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75349] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2751), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6051), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75463] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2752), 1,
      sym_comment,
    ACTIONS(5357), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5359), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [75519] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6019), 1,
      anon_sym_AMP,
    ACTIONS(6021), 1,
      anon_sym_PIPE,
    ACTIONS(6023), 1,
      anon_sym_extends,
    STATE(2753), 1,
      sym_comment,
    ACTIONS(5232), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5234), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75581] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4857), 1,
      anon_sym_extends,
    STATE(2754), 1,
      sym_comment,
    ACTIONS(5232), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5234), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75639] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4843), 1,
      anon_sym_extends,
    ACTIONS(5773), 1,
      anon_sym_LBRACK,
    ACTIONS(6057), 1,
      anon_sym_RPAREN,
    STATE(2755), 1,
      sym_comment,
    ACTIONS(5776), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6053), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6055), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75707] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2756), 1,
      sym_comment,
    ACTIONS(5353), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5355), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [75763] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(161), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LBRACK,
    ACTIONS(6062), 1,
      anon_sym_COMMA,
    ACTIONS(6064), 1,
      anon_sym_RBRACE,
    STATE(2757), 1,
      sym_comment,
    STATE(5743), 1,
      aux_sym_object_pattern_repeat1,
    STATE(7005), 1,
      sym__property_name,
    STATE(7130), 1,
      sym__destructuring_pattern,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    STATE(5739), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(6060), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [75845] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2758), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4968), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75959] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2759), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5170), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76073] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2760), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5272), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76187] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2761), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5300), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76301] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2762), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5194), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76415] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2763), 1,
      sym_comment,
    ACTIONS(5349), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5351), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [76471] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2764), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6080), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76585] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2765), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [76673] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6082), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2766), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [76751] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4901), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4903), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4905), 1,
      anon_sym_GT_GT,
    ACTIONS(4909), 1,
      anon_sym_AMP,
    ACTIONS(4911), 1,
      anon_sym_CARET,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(4917), 1,
      anon_sym_PERCENT,
    ACTIONS(4919), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4921), 1,
      anon_sym_LT,
    ACTIONS(4929), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4935), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2767), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4887), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4897), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4907), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4915), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4927), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5643), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4923), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76865] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2768), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [76967] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2769), 1,
      sym_comment,
    ACTIONS(5037), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77023] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2770), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [77127] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6082), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2771), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [77211] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2772), 1,
      sym_comment,
    ACTIONS(5033), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5035), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77267] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2773), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [77365] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2774), 1,
      sym_comment,
    ACTIONS(5033), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5035), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77421] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2775), 1,
      sym_comment,
    ACTIONS(3236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3570), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77477] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2776), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [77577] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2777), 1,
      sym_comment,
    ACTIONS(5033), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5035), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77633] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6082), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2778), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [77715] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(161), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LBRACK,
    ACTIONS(6062), 1,
      anon_sym_COMMA,
    ACTIONS(6087), 1,
      anon_sym_RBRACE,
    STATE(2779), 1,
      sym_comment,
    STATE(6147), 1,
      aux_sym_object_pattern_repeat1,
    STATE(7005), 1,
      sym__property_name,
    STATE(7130), 1,
      sym__destructuring_pattern,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    STATE(6143), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(6085), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [77797] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2780), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5442), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5900), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [77875] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2781), 1,
      sym_comment,
    ACTIONS(5021), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5023), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77931] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2782), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6089), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78045] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5001), 1,
      anon_sym_QMARK,
    ACTIONS(5003), 1,
      anon_sym_extends,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    ACTIONS(5326), 1,
      anon_sym_LBRACK,
    ACTIONS(5904), 1,
      anon_sym_COLON,
    STATE(2783), 1,
      sym_comment,
    ACTIONS(5329), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5793), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5320), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78115] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2784), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4968), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78229] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2785), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5170), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78343] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2786), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5272), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78457] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2787), 1,
      sym_comment,
    ACTIONS(5290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5292), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [78513] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2788), 1,
      sym_comment,
    ACTIONS(5282), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5284), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [78569] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2789), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5300), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78683] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2790), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5194), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78797] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2791), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [78885] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5444), 1,
      anon_sym_LBRACK,
    STATE(2792), 1,
      sym_comment,
    STATE(3892), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5900), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [78965] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(6091), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2793), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4980), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [79039] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2794), 1,
      sym_comment,
    ACTIONS(5278), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5280), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [79095] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6094), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2795), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [79173] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2796), 1,
      sym_comment,
    ACTIONS(5021), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5023), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [79229] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2797), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [79331] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2798), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [79435] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2799), 1,
      sym_comment,
    ACTIONS(5098), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [79491] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6094), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2800), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [79575] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2801), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [79671] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2802), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [79769] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2803), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [79869] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6094), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2804), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [79951] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6097), 1,
      anon_sym_STAR,
    ACTIONS(6099), 1,
      anon_sym_async,
    ACTIONS(6101), 1,
      anon_sym_readonly,
    STATE(2805), 1,
      sym_comment,
    STATE(3519), 1,
      sym_override_modifier,
    STATE(3909), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6103), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [80033] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6094), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2806), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [80117] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2807), 1,
      sym_comment,
    ACTIONS(3228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3518), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80173] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5178), 1,
      anon_sym_extends,
    STATE(2808), 1,
      sym_comment,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [80231] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6082), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2809), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 15,
      sym__ternary_qmark,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [80315] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2810), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4946), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [80407] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2811), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4946), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [80499] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2812), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 6,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [80605] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2813), 1,
      sym_comment,
    ACTIONS(5017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5019), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80661] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2814), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4976), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80775] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2815), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [80881] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2816), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4976), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80995] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2817), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4985), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81109] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2818), 1,
      sym_comment,
    ACTIONS(5017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5019), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81165] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2819), 1,
      sym_comment,
    ACTIONS(5017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5019), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81221] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2820), 1,
      sym_comment,
    ACTIONS(5013), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5015), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81277] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2821), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5244), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81391] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2822), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5264), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81505] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2823), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5270), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81619] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    ACTIONS(6105), 1,
      anon_sym_SEMI,
    ACTIONS(6107), 1,
      sym__automatic_semicolon,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2824), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81735] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2825), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4985), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81849] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2826), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5274), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81963] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2827), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5276), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82077] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    ACTIONS(6109), 1,
      anon_sym_SEMI,
    ACTIONS(6111), 1,
      sym__automatic_semicolon,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2828), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82193] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2829), 1,
      sym_comment,
    ACTIONS(5009), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5011), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82249] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6113), 1,
      anon_sym_RBRACE,
    STATE(2830), 1,
      sym_comment,
    STATE(3531), 1,
      sym_override_modifier,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [82339] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2831), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5244), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82453] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2832), 1,
      sym_comment,
    ACTIONS(4993), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4995), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82509] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2833), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5264), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82623] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2834), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5270), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82737] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    ACTIONS(6115), 1,
      anon_sym_SEMI,
    ACTIONS(6117), 1,
      sym__automatic_semicolon,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2835), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82853] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2836), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6119), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82967] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2837), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5180), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83081] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5043), 1,
      anon_sym_extends,
    STATE(2838), 1,
      sym_comment,
    ACTIONS(5523), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5526), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5519), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5521), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83143] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2839), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5274), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83257] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2840), 1,
      sym_comment,
    ACTIONS(5150), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5152), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83313] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6019), 1,
      anon_sym_AMP,
    ACTIONS(6021), 1,
      anon_sym_PIPE,
    ACTIONS(6023), 1,
      anon_sym_extends,
    STATE(2841), 1,
      sym_comment,
    ACTIONS(5049), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5051), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83375] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6121), 1,
      anon_sym_RBRACE,
    STATE(2842), 1,
      sym_comment,
    STATE(3531), 1,
      sym_override_modifier,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [83465] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1043), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(2843), 1,
      sym_comment,
    STATE(3531), 1,
      sym_override_modifier,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [83555] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6123), 1,
      anon_sym_LBRACK,
    STATE(2844), 1,
      sym_comment,
    ACTIONS(5120), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5122), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83613] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6125), 1,
      anon_sym_extends,
    STATE(2845), 1,
      sym_comment,
    ACTIONS(5114), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5116), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83671] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4883), 1,
      anon_sym_extends,
    ACTIONS(6123), 1,
      anon_sym_LBRACK,
    STATE(2846), 1,
      sym_comment,
    ACTIONS(4881), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5082), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5084), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83733] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6019), 1,
      anon_sym_AMP,
    ACTIONS(6021), 1,
      anon_sym_PIPE,
    ACTIONS(6023), 1,
      anon_sym_extends,
    STATE(2847), 1,
      sym_comment,
    ACTIONS(5074), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5076), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83795] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2848), 1,
      sym_comment,
    ACTIONS(5066), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5068), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83851] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6019), 1,
      anon_sym_AMP,
    ACTIONS(6021), 1,
      anon_sym_PIPE,
    ACTIONS(6023), 1,
      anon_sym_extends,
    STATE(2849), 1,
      sym_comment,
    ACTIONS(5045), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5047), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83913] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2850), 1,
      sym_comment,
    ACTIONS(5029), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5031), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83973] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2851), 1,
      sym_comment,
    ACTIONS(5041), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5043), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84029] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2852), 1,
      sym_comment,
    ACTIONS(4964), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4966), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84085] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2853), 1,
      sym_comment,
    ACTIONS(4877), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84141] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2854), 1,
      sym_comment,
    ACTIONS(4877), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84197] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2855), 1,
      sym_comment,
    ACTIONS(4877), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84253] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2856), 1,
      sym_comment,
    ACTIONS(5029), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5031), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84309] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6019), 1,
      anon_sym_AMP,
    STATE(2857), 1,
      sym_comment,
    ACTIONS(5025), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5027), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84367] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2858), 1,
      sym_comment,
    ACTIONS(5005), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5007), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84423] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2859), 1,
      sym_comment,
    ACTIONS(5001), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5003), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84479] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2860), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5276), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84593] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2861), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5180), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84707] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(4267), 1,
      anon_sym_QMARK,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(2862), 1,
      sym_comment,
    ACTIONS(4264), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5190), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5782), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [84775] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4843), 1,
      anon_sym_extends,
    ACTIONS(5773), 1,
      anon_sym_LBRACK,
    ACTIONS(6132), 1,
      anon_sym_RPAREN,
    STATE(2863), 1,
      sym_comment,
    ACTIONS(5776), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6127), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6129), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [84843] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2864), 1,
      sym_comment,
    ACTIONS(5162), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5164), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84899] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2865), 1,
      sym_comment,
    ACTIONS(4997), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4999), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84955] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6136), 1,
      anon_sym_DOT,
    STATE(2866), 1,
      sym_comment,
    ACTIONS(4987), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4989), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85013] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2867), 1,
      sym_comment,
    ACTIONS(5162), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5164), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85069] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2868), 1,
      sym_comment,
    ACTIONS(5162), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5164), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85125] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    STATE(2869), 1,
      sym_comment,
    STATE(2975), 1,
      sym_arguments,
    ACTIONS(5339), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [85185] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2870), 1,
      sym_comment,
    ACTIONS(5246), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5248), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85241] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2871), 1,
      sym_comment,
    ACTIONS(5246), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5248), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85297] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2872), 1,
      sym_comment,
    ACTIONS(5246), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5248), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85353] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2873), 1,
      sym_comment,
    ACTIONS(5228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5230), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85409] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6138), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2874), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [85485] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3570), 1,
      anon_sym_extends,
    ACTIONS(5343), 1,
      anon_sym_LBRACK,
    ACTIONS(6141), 1,
      anon_sym_RPAREN,
    STATE(2875), 1,
      sym_comment,
    ACTIONS(2071), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5346), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5807), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2069), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [85553] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6144), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2876), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4937), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4939), 16,
      sym__ternary_qmark,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [85635] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(2877), 1,
      sym_comment,
    ACTIONS(5190), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [85697] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2878), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85811] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5003), 1,
      anon_sym_extends,
    ACTIONS(5326), 1,
      anon_sym_LBRACK,
    ACTIONS(6147), 1,
      anon_sym_RPAREN,
    STATE(2879), 1,
      sym_comment,
    ACTIONS(5322), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5329), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5904), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5320), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [85879] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6019), 1,
      anon_sym_AMP,
    ACTIONS(6021), 1,
      anon_sym_PIPE,
    ACTIONS(6023), 1,
      anon_sym_extends,
    STATE(2880), 1,
      sym_comment,
    ACTIONS(5224), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5226), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [85941] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5494), 1,
      anon_sym_QMARK_DOT,
    STATE(2881), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(2151), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2153), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86005] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    ACTIONS(6150), 1,
      anon_sym_SEMI,
    ACTIONS(6152), 1,
      sym__automatic_semicolon,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2882), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86121] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6154), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2883), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4980), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [86195] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2884), 1,
      sym_comment,
    ACTIONS(5178), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86253] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2885), 1,
      sym_comment,
    ACTIONS(4972), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4974), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86309] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2886), 1,
      sym_comment,
    ACTIONS(4855), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4857), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86365] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5701), 1,
      sym__automatic_semicolon,
    STATE(2887), 1,
      sym_comment,
    ACTIONS(2067), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2095), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86425] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2888), 1,
      sym_comment,
    ACTIONS(4871), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4873), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86481] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6157), 1,
      anon_sym_STAR,
    ACTIONS(6159), 1,
      anon_sym_async,
    ACTIONS(6163), 1,
      anon_sym_abstract,
    STATE(2889), 1,
      sym_comment,
    STATE(3803), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6161), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [86559] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2890), 1,
      sym_comment,
    ACTIONS(5188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5190), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86615] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4267), 1,
      anon_sym_QMARK,
    ACTIONS(4284), 1,
      anon_sym_EQ,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(2891), 1,
      sym_comment,
    ACTIONS(4287), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5190), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5782), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86683] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2892), 1,
      sym_comment,
    ACTIONS(4841), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4843), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86739] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4843), 1,
      anon_sym_extends,
    ACTIONS(5773), 1,
      anon_sym_LBRACK,
    ACTIONS(6167), 1,
      anon_sym_RPAREN,
    STATE(2893), 1,
      sym_comment,
    ACTIONS(5776), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6127), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6165), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86807] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6157), 1,
      anon_sym_STAR,
    ACTIONS(6159), 1,
      anon_sym_async,
    ACTIONS(6170), 1,
      anon_sym_readonly,
    STATE(2894), 1,
      sym_comment,
    STATE(3524), 1,
      sym_override_modifier,
    STATE(3797), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6161), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [86889] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2895), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6172), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87003] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6174), 1,
      anon_sym_static,
    ACTIONS(6176), 1,
      anon_sym_readonly,
    ACTIONS(6178), 1,
      anon_sym_abstract,
    STATE(2896), 1,
      sym_comment,
    STATE(3582), 1,
      sym_override_modifier,
    STATE(4122), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [87083] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2897), 1,
      sym_comment,
    ACTIONS(4881), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87139] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6123), 1,
      anon_sym_LBRACK,
    STATE(2898), 1,
      sym_comment,
    ACTIONS(4881), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87197] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2899), 1,
      sym_comment,
    ACTIONS(5332), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5334), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87253] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(6180), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2900), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [87329] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6183), 1,
      anon_sym_STAR,
    ACTIONS(6185), 1,
      anon_sym_async,
    ACTIONS(6189), 1,
      anon_sym_abstract,
    STATE(2901), 1,
      sym_comment,
    STATE(3794), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6187), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [87407] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2902), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6191), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87521] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6183), 1,
      anon_sym_STAR,
    ACTIONS(6185), 1,
      anon_sym_async,
    ACTIONS(6193), 1,
      anon_sym_readonly,
    STATE(2903), 1,
      sym_comment,
    STATE(3517), 1,
      sym_override_modifier,
    STATE(3794), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6187), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [87603] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(966), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(2904), 1,
      sym_comment,
    STATE(3531), 1,
      sym_override_modifier,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [87693] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6195), 1,
      anon_sym_RBRACE,
    STATE(2905), 1,
      sym_comment,
    STATE(3531), 1,
      sym_override_modifier,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [87783] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(6197), 1,
      anon_sym_LT,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2906), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4937), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4939), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [87865] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6200), 1,
      anon_sym_STAR,
    ACTIONS(6202), 1,
      anon_sym_async,
    ACTIONS(6204), 1,
      anon_sym_readonly,
    STATE(2907), 1,
      sym_comment,
    STATE(3534), 1,
      sym_override_modifier,
    STATE(3863), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6206), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [87947] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3570), 1,
      anon_sym_extends,
    ACTIONS(5343), 1,
      anon_sym_LBRACK,
    ACTIONS(5931), 1,
      anon_sym_RPAREN,
    STATE(2908), 1,
      sym_comment,
    ACTIONS(2071), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5346), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5680), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2069), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [88015] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2909), 1,
      sym_comment,
    ACTIONS(2069), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [88073] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2910), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5616), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88187] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6212), 1,
      sym_regex_flags,
    STATE(2911), 1,
      sym_comment,
    ACTIONS(6208), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(6210), 25,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88245] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5390), 1,
      anon_sym_as,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(5436), 1,
      anon_sym_satisfies,
    ACTIONS(5953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5955), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5957), 1,
      anon_sym_GT_GT,
    ACTIONS(5961), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_PIPE,
    ACTIONS(5969), 1,
      anon_sym_PERCENT,
    ACTIONS(5971), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5973), 1,
      anon_sym_LT,
    ACTIONS(5981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5983), 1,
      sym__ternary_qmark,
    STATE(2627), 1,
      sym_type_arguments,
    STATE(2912), 1,
      sym_comment,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4960), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5432), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5947), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5949), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5959), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5967), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5977), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5979), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5975), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88359] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1041), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(2913), 1,
      sym_comment,
    STATE(3531), 1,
      sym_override_modifier,
    STATE(4808), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [88449] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2914), 1,
      sym_comment,
    ACTIONS(3222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3540), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88505] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5003), 1,
      anon_sym_extends,
    ACTIONS(5326), 1,
      anon_sym_LBRACK,
    ACTIONS(5793), 1,
      anon_sym_RPAREN,
    STATE(2915), 1,
      sym_comment,
    ACTIONS(5322), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5329), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5744), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5320), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [88573] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    STATE(2916), 1,
      sym_comment,
    ACTIONS(5630), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5634), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [88631] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5371), 1,
      anon_sym_STAR,
    ACTIONS(5375), 1,
      anon_sym_async,
    ACTIONS(5444), 1,
      anon_sym_LBRACK,
    ACTIONS(6214), 1,
      anon_sym_abstract,
    STATE(2917), 1,
      sym_comment,
    STATE(3819), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [88709] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5043), 1,
      anon_sym_extends,
    STATE(2918), 1,
      sym_comment,
    ACTIONS(5526), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5523), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(5519), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5521), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [88770] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6113), 1,
      anon_sym_RBRACE,
    STATE(2919), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [88851] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6216), 1,
      anon_sym_STAR,
    STATE(2920), 1,
      sym_comment,
    STATE(4810), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6218), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [88924] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    STATE(2921), 1,
      sym_comment,
    STATE(2458), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6220), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4861), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4863), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [88987] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2922), 1,
      sym_comment,
    ACTIONS(2275), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2191), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2195), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89044] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6200), 1,
      anon_sym_STAR,
    STATE(2923), 1,
      sym_comment,
    STATE(4720), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6222), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [89117] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2924), 1,
      sym_comment,
    ACTIONS(6224), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89174] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2925), 1,
      sym_comment,
    ACTIONS(5691), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4968), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89229] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(966), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(2926), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [89312] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5444), 1,
      anon_sym_LBRACK,
    ACTIONS(6200), 1,
      anon_sym_STAR,
    ACTIONS(6202), 1,
      anon_sym_async,
    STATE(2927), 1,
      sym_comment,
    STATE(3863), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6206), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [89387] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2928), 1,
      sym_comment,
    ACTIONS(2343), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2199), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2203), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89444] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6226), 1,
      sym__automatic_semicolon,
    STATE(2929), 1,
      sym_comment,
    ACTIONS(2365), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2085), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2089), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89503] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5276), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2930), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [89616] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4231), 1,
      anon_sym_EQ,
    STATE(2931), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89673] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2932), 1,
      sym_comment,
    ACTIONS(2131), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2135), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89728] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2933), 1,
      sym_comment,
    ACTIONS(2139), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2143), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89783] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5274), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2934), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [89896] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(966), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(2935), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [89977] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6264), 1,
      sym__automatic_semicolon,
    STATE(2936), 1,
      sym_comment,
    ACTIONS(2329), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2243), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2247), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90036] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6266), 1,
      sym__automatic_semicolon,
    STATE(2937), 1,
      sym_comment,
    ACTIONS(2357), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2257), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2261), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90095] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6157), 1,
      anon_sym_STAR,
    STATE(2938), 1,
      sym_comment,
    STATE(4801), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6268), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [90168] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6270), 1,
      anon_sym_STAR,
    ACTIONS(6272), 1,
      anon_sym_async,
    STATE(2939), 1,
      sym_comment,
    STATE(3838), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6274), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [90243] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2940), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90298] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5270), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2941), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90411] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(161), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LBRACK,
    STATE(2942), 1,
      sym_comment,
    STATE(7005), 1,
      sym__property_name,
    STATE(7130), 1,
      sym__destructuring_pattern,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6278), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    STATE(6820), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(6276), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [90488] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5264), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2943), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90601] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2944), 1,
      sym_comment,
    ACTIONS(5660), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5662), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90656] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5244), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2945), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90769] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1041), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(2946), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [90850] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1041), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(2947), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [90933] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    STATE(2948), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90990] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6183), 1,
      anon_sym_STAR,
    ACTIONS(6185), 1,
      anon_sym_async,
    STATE(2949), 1,
      sym_comment,
    STATE(3794), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6187), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [91065] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6183), 1,
      anon_sym_STAR,
    STATE(2950), 1,
      sym_comment,
    STATE(4731), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6280), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [91138] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6195), 1,
      anon_sym_RBRACE,
    STATE(2951), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [91219] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    ACTIONS(6282), 1,
      anon_sym_COLON,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2952), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91332] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6288), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2953), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91445] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4216), 1,
      anon_sym_EQ,
    ACTIONS(4351), 1,
      anon_sym_in,
    ACTIONS(4354), 1,
      anon_sym_of,
    STATE(2954), 1,
      sym_comment,
    ACTIONS(4137), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91506] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2955), 1,
      sym_comment,
    ACTIONS(6053), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6055), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91565] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2956), 1,
      sym_comment,
    ACTIONS(6322), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6324), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91624] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2957), 1,
      sym_comment,
    ACTIONS(5576), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5578), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91679] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5180), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2958), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91792] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5371), 1,
      anon_sym_STAR,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(2959), 1,
      sym_comment,
    STATE(4799), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6326), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [91865] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2960), 1,
      sym_comment,
    ACTIONS(5687), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5689), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91920] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2961), 1,
      sym_comment,
    ACTIONS(6328), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6330), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91979] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6332), 1,
      anon_sym_STAR,
    ACTIONS(6334), 1,
      anon_sym_async,
    STATE(2962), 1,
      sym_comment,
    STATE(3861), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6336), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [92054] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2963), 1,
      sym_comment,
    ACTIONS(6328), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6330), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92113] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2964), 1,
      sym_comment,
    ACTIONS(6328), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6330), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92172] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6332), 1,
      anon_sym_STAR,
    STATE(2965), 1,
      sym_comment,
    STATE(4784), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6338), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [92245] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2966), 1,
      sym_comment,
    ACTIONS(5626), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5628), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92300] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2967), 1,
      sym_comment,
    ACTIONS(5655), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5244), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92355] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2968), 1,
      sym_comment,
    ACTIONS(5618), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5620), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92410] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2969), 1,
      sym_comment,
    ACTIONS(5612), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5264), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92465] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5721), 1,
      anon_sym_RBRACE,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2970), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [92578] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    ACTIONS(6340), 1,
      anon_sym_COLON,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(2971), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [92691] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2972), 1,
      sym_comment,
    ACTIONS(5600), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5602), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92746] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6342), 1,
      sym__automatic_semicolon,
    STATE(2973), 1,
      sym_comment,
    ACTIONS(2271), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2105), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2109), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92805] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6195), 1,
      anon_sym_RBRACE,
    STATE(2974), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [92888] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2975), 1,
      sym_comment,
    ACTIONS(5596), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5598), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92943] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6344), 1,
      anon_sym_STAR,
    ACTIONS(6346), 1,
      anon_sym_async,
    STATE(2976), 1,
      sym_comment,
    STATE(3806), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6348), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [93018] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2977), 1,
      sym_comment,
    ACTIONS(5592), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5594), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93073] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2978), 1,
      sym_comment,
    ACTIONS(5552), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5554), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93128] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6224), 1,
      anon_sym_COMMA,
    STATE(2979), 1,
      sym_comment,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93185] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2980), 1,
      sym_comment,
    ACTIONS(6350), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6352), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93244] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5041), 1,
      anon_sym_QMARK,
    STATE(2981), 1,
      sym_comment,
    ACTIONS(5043), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5526), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5523), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(5519), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5521), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93307] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2982), 1,
      sym_comment,
    ACTIONS(2151), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2153), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93362] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2983), 1,
      sym_comment,
    ACTIONS(5588), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5590), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93417] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2984), 1,
      sym_comment,
    ACTIONS(5029), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5031), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93476] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2985), 1,
      sym_comment,
    ACTIONS(5552), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5554), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93531] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2986), 1,
      sym_comment,
    ACTIONS(5560), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5562), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93586] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2987), 1,
      sym_comment,
    ACTIONS(5556), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5558), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93641] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6344), 1,
      anon_sym_STAR,
    ACTIONS(6346), 1,
      anon_sym_async,
    STATE(2988), 1,
      sym_comment,
    STATE(3818), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6348), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [93716] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2989), 1,
      sym_comment,
    ACTIONS(5552), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5554), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93771] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6344), 1,
      anon_sym_STAR,
    STATE(2990), 1,
      sym_comment,
    STATE(4820), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6354), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [93844] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2991), 1,
      sym_comment,
    ACTIONS(2325), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2227), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2231), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93901] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6097), 1,
      anon_sym_STAR,
    STATE(2992), 1,
      sym_comment,
    STATE(4715), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6356), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [93974] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6358), 1,
      sym_regex_flags,
    STATE(2993), 1,
      sym_comment,
    ACTIONS(6208), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(6210), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [94031] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2994), 1,
      sym_comment,
    ACTIONS(2387), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2215), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2219), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94088] = 24,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(225), 1,
      anon_sym_STAR,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_COMMA,
    ACTIONS(6364), 1,
      anon_sym_RBRACE,
    ACTIONS(6366), 1,
      anon_sym_async,
    ACTIONS(6368), 1,
      anon_sym_static,
    ACTIONS(6370), 1,
      anon_sym_readonly,
    ACTIONS(6376), 1,
      anon_sym_override,
    STATE(2995), 1,
      sym_comment,
    STATE(3468), 1,
      sym_accessibility_modifier,
    STATE(3530), 1,
      sym_override_modifier,
    STATE(4504), 1,
      sym__property_name,
    STATE(5847), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6372), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(6374), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5848), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(6360), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [94181] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2996), 1,
      sym_comment,
    ACTIONS(2381), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2207), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2211), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94238] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6270), 1,
      anon_sym_STAR,
    STATE(2997), 1,
      sym_comment,
    STATE(4701), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6378), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [94311] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2998), 1,
      sym_comment,
    ACTIONS(5506), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5508), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94366] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(2999), 1,
      sym_comment,
    ACTIONS(2373), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2169), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2173), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94423] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6380), 1,
      sym__automatic_semicolon,
    STATE(3000), 1,
      sym_comment,
    ACTIONS(2287), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2139), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2143), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94482] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3001), 1,
      sym_comment,
    ACTIONS(2313), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2131), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2135), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94539] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6382), 1,
      anon_sym_STAR,
    STATE(3002), 1,
      sym_comment,
    STATE(4696), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6384), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [94612] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6386), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3003), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [94687] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6389), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3004), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4937), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4939), 15,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [94768] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4294), 1,
      anon_sym_EQ,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(3005), 1,
      sym_comment,
    ACTIONS(5190), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94831] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4960), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3006), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [94944] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3007), 1,
      sym_comment,
    ACTIONS(5502), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5504), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94999] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3008), 1,
      sym_comment,
    ACTIONS(5450), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5452), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95054] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6392), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3009), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4980), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [95127] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6121), 1,
      anon_sym_RBRACE,
    STATE(3010), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95208] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6121), 1,
      anon_sym_RBRACE,
    STATE(3011), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95291] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3012), 1,
      sym_comment,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95346] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6344), 1,
      anon_sym_STAR,
    ACTIONS(6346), 1,
      anon_sym_async,
    STATE(3013), 1,
      sym_comment,
    STATE(3825), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6348), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95421] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5182), 1,
      anon_sym_RBRACE,
    STATE(3014), 1,
      sym_comment,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95488] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3015), 1,
      sym_comment,
    ACTIONS(5446), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5448), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95543] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3016), 1,
      sym_comment,
    ACTIONS(5384), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5386), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95598] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3017), 1,
      sym_comment,
    ACTIONS(5604), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5270), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95653] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6395), 1,
      anon_sym_STAR,
    STATE(3018), 1,
      sym_comment,
    STATE(4692), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6397), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95726] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_STAR,
    ACTIONS(6401), 1,
      anon_sym_async,
    STATE(3019), 1,
      sym_comment,
    STATE(3828), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6403), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95801] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6358), 1,
      sym_regex_flags,
    STATE(3020), 1,
      sym_comment,
    ACTIONS(6208), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(6210), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95858] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6405), 1,
      sym__automatic_semicolon,
    STATE(3021), 1,
      sym_comment,
    ACTIONS(2387), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2215), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2219), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95917] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3022), 1,
      sym_comment,
    ACTIONS(5541), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5543), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95972] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6407), 1,
      sym__automatic_semicolon,
    STATE(3023), 1,
      sym_comment,
    ACTIONS(2325), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2227), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2231), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96031] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3024), 1,
      sym_comment,
    ACTIONS(5545), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5547), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96086] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3025), 1,
      sym_comment,
    ACTIONS(2105), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2109), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96141] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_STAR,
    STATE(3026), 1,
      sym_comment,
    STATE(4662), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6409), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [96214] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5182), 1,
      anon_sym_RBRACE,
    STATE(3027), 1,
      sym_comment,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [96281] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3028), 1,
      sym_comment,
    ACTIONS(5564), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5566), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96336] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    ACTIONS(6411), 1,
      anon_sym_COLON,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3029), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [96449] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6413), 1,
      anon_sym_LPAREN,
    ACTIONS(6416), 1,
      anon_sym_COLON,
    ACTIONS(6418), 1,
      anon_sym_LT,
    ACTIONS(6421), 1,
      anon_sym_QMARK,
    STATE(3030), 1,
      sym_comment,
    ACTIONS(4137), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96512] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3031), 1,
      sym_comment,
    ACTIONS(5490), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5492), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96567] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4985), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3032), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [96680] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4976), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3033), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [96793] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3034), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [96898] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3035), 1,
      sym_comment,
    ACTIONS(5572), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5574), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96953] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3036), 1,
      sym_comment,
    ACTIONS(5529), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5531), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97008] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3037), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4946), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [97099] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5762), 1,
      anon_sym_of,
    ACTIONS(6230), 1,
      anon_sym_GT,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    ACTIONS(6423), 1,
      anon_sym_in,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3038), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [97214] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3039), 1,
      sym_comment,
    ACTIONS(5713), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5715), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97269] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3040), 1,
      sym_comment,
    ACTIONS(2351), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2151), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2153), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97326] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4298), 1,
      anon_sym_EQ,
    ACTIONS(5190), 1,
      anon_sym_extends,
    STATE(3041), 1,
      sym_comment,
    ACTIONS(5779), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [97389] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3042), 1,
      sym_comment,
    ACTIONS(2215), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2219), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97444] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3043), 1,
      sym_comment,
    ACTIONS(2227), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2231), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97499] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3044), 1,
      sym_comment,
    ACTIONS(2243), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2247), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97554] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3045), 1,
      sym_comment,
    ACTIONS(2191), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2195), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97609] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1043), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(3046), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [97692] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6426), 1,
      sym__automatic_semicolon,
    STATE(3047), 1,
      sym_comment,
    ACTIONS(2313), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2131), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2135), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97751] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1043), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(3048), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [97832] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3049), 1,
      sym_comment,
    ACTIONS(6428), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6430), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97891] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5190), 1,
      anon_sym_extends,
    STATE(3050), 1,
      sym_comment,
    ACTIONS(5782), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5779), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97952] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5343), 1,
      anon_sym_LBRACK,
    STATE(3051), 1,
      sym_comment,
    ACTIONS(3570), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5346), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2069), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98015] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6432), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3052), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 14,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [98098] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3053), 1,
      sym_comment,
    ACTIONS(5693), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5695), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98153] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6435), 1,
      sym__automatic_semicolon,
    STATE(3054), 1,
      sym_comment,
    ACTIONS(2287), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2139), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2143), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98212] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6432), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3055), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [98293] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3056), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [98392] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3057), 1,
      sym_comment,
    ACTIONS(2169), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2173), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98447] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3058), 1,
      sym_comment,
    ACTIONS(2207), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2211), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98502] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3059), 1,
      sym_comment,
    ACTIONS(2257), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2261), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98557] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3060), 1,
      sym_comment,
    ACTIONS(2085), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2089), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98612] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5314), 1,
      anon_sym_RBRACE,
    STATE(3061), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [98679] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3062), 1,
      sym_comment,
    ACTIONS(2199), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2203), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98734] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6437), 1,
      sym__automatic_semicolon,
    STATE(3063), 1,
      sym_comment,
    ACTIONS(2329), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2243), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2247), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98793] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6011), 1,
      anon_sym_STAR,
    STATE(3064), 1,
      sym_comment,
    STATE(4816), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6439), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [98866] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3065), 1,
      sym_comment,
    ACTIONS(5510), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98921] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3066), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [99018] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3067), 1,
      sym_comment,
    ACTIONS(5697), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5699), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99073] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    ACTIONS(6441), 1,
      anon_sym_COLON,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3068), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [99186] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3069), 1,
      sym_comment,
    ACTIONS(5703), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5705), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99241] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3070), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [99336] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6432), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3071), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [99419] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3072), 1,
      sym_comment,
    ACTIONS(5608), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5610), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99474] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3073), 1,
      sym_comment,
    ACTIONS(5707), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5709), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99529] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6443), 1,
      anon_sym_STAR,
    ACTIONS(6445), 1,
      anon_sym_async,
    STATE(3074), 1,
      sym_comment,
    STATE(3823), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6447), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [99604] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3075), 1,
      sym_comment,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99659] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    ACTIONS(5904), 1,
      anon_sym_of,
    ACTIONS(6449), 1,
      anon_sym_in,
    STATE(3076), 1,
      sym_comment,
    ACTIONS(5320), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99720] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    ACTIONS(6452), 1,
      anon_sym_RBRACK,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3077), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [99833] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    ACTIONS(6454), 1,
      anon_sym_COLON,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3078), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [99946] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3079), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [100049] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3080), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [100150] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6097), 1,
      anon_sym_STAR,
    ACTIONS(6099), 1,
      anon_sym_async,
    STATE(3081), 1,
      sym_comment,
    STATE(3909), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6103), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [100225] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3082), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5900), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [100298] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6432), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3083), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [100375] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    ACTIONS(6456), 1,
      anon_sym_COLON,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3084), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [100488] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3085), 1,
      sym_comment,
    ACTIONS(5519), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5521), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100543] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3086), 1,
      sym_comment,
    ACTIONS(6127), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6129), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100602] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3087), 1,
      sym_comment,
    ACTIONS(5732), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5734), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100657] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4235), 1,
      anon_sym_EQ,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(3088), 1,
      sym_comment,
    ACTIONS(5190), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100720] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4195), 1,
      anon_sym_EQ,
    ACTIONS(5188), 1,
      anon_sym_QMARK,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(3089), 1,
      sym_comment,
    ACTIONS(5782), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5190), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100785] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6458), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3090), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4980), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [100858] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3091), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [100945] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5194), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3092), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101058] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4968), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3093), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101171] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3094), 1,
      sym_comment,
    ACTIONS(5583), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5194), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101226] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5300), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3095), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101339] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6461), 1,
      anon_sym_STAR,
    STATE(3096), 1,
      sym_comment,
    STATE(4779), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6463), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [101412] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3097), 1,
      sym_comment,
    ACTIONS(5537), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5539), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101467] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6461), 1,
      anon_sym_STAR,
    ACTIONS(6465), 1,
      anon_sym_async,
    STATE(3098), 1,
      sym_comment,
    STATE(3837), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6467), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [101542] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5170), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3099), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101655] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4960), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3100), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101768] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5272), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3101), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101881] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3102), 1,
      sym_comment,
    ACTIONS(5363), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5365), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101936] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3103), 1,
      sym_comment,
    ACTIONS(5676), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5678), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101991] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5300), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3104), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [102104] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3105), 1,
      sym_comment,
    ACTIONS(5672), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5674), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102159] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5194), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3106), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [102272] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3107), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [102359] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3108), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [102436] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3109), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [102537] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3110), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [102640] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6472), 1,
      sym__automatic_semicolon,
    STATE(3111), 1,
      sym_comment,
    ACTIONS(2275), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2191), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2195), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102699] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3112), 1,
      sym_comment,
    ACTIONS(5367), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102754] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3113), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [102837] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3114), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [102932] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3115), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [103029] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6474), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3116), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4937), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4939), 15,
      sym__ternary_qmark,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [103110] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4253), 1,
      anon_sym_COLON,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(3117), 1,
      sym_comment,
    ACTIONS(5782), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5190), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [103175] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3118), 1,
      sym_comment,
    ACTIONS(5622), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5624), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [103230] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    ACTIONS(6477), 1,
      anon_sym_COLON,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3119), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103343] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3120), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [103442] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3121), 1,
      sym_comment,
    ACTIONS(6127), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6165), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [103501] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3122), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [103582] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6479), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3123), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [103657] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5180), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3124), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103770] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6443), 1,
      anon_sym_STAR,
    STATE(3125), 1,
      sym_comment,
    STATE(4821), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6482), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [103843] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5276), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3126), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103956] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6382), 1,
      anon_sym_STAR,
    ACTIONS(6484), 1,
      anon_sym_async,
    STATE(3127), 1,
      sym_comment,
    STATE(3839), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6486), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [104031] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5274), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3128), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [104144] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3129), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 14,
      sym__ternary_qmark,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [104227] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    ACTIONS(6488), 1,
      anon_sym_COLON,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3130), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [104340] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3131), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4946), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [104431] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5270), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3132), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [104544] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3133), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [104649] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4976), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3134), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [104762] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6113), 1,
      anon_sym_RBRACE,
    STATE(3135), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [104845] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6490), 1,
      anon_sym_STAR,
    STATE(3136), 1,
      sym_comment,
    STATE(4843), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6492), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [104918] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5993), 1,
      anon_sym_GT_GT,
    ACTIONS(5999), 1,
      anon_sym_PERCENT,
    ACTIONS(6001), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6003), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6068), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6070), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      anon_sym_CARET,
    ACTIONS(6074), 1,
      anon_sym_PIPE,
    ACTIONS(6076), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6078), 1,
      sym__ternary_qmark,
    ACTIONS(6494), 1,
      anon_sym_COLON,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3137), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5991), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5995), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5997), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105031] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3138), 1,
      sym_comment,
    ACTIONS(6496), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6498), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105090] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3139), 1,
      sym_comment,
    ACTIONS(2271), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2105), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2109), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105147] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3140), 1,
      sym_comment,
    ACTIONS(5758), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5760), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105202] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6043), 1,
      anon_sym_STAR,
    ACTIONS(6045), 1,
      anon_sym_async,
    STATE(3141), 1,
      sym_comment,
    STATE(3872), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6049), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [105277] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6043), 1,
      anon_sym_STAR,
    STATE(3142), 1,
      sym_comment,
    STATE(4618), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6500), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [105350] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3143), 1,
      sym_comment,
    ACTIONS(5754), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5756), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105405] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5272), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3144), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105518] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3145), 1,
      sym_comment,
    ACTIONS(6502), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6504), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105577] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3146), 1,
      sym_comment,
    ACTIONS(6502), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6504), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105636] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3147), 1,
      sym_comment,
    ACTIONS(6502), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6504), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105695] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3148), 1,
      sym_comment,
    ACTIONS(5747), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5749), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105750] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6506), 1,
      sym__automatic_semicolon,
    STATE(3149), 1,
      sym_comment,
    ACTIONS(2343), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2199), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2203), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105809] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6011), 1,
      anon_sym_STAR,
    ACTIONS(6013), 1,
      anon_sym_async,
    STATE(3150), 1,
      sym_comment,
    STATE(3814), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6017), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [105884] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5264), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3151), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105997] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3152), 1,
      sym_comment,
    ACTIONS(5740), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5742), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106052] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5139), 1,
      anon_sym_RBRACE,
    STATE(3153), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [106119] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5139), 1,
      anon_sym_RBRACE,
    STATE(3154), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [106186] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5314), 1,
      anon_sym_RBRACE,
    STATE(3155), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [106253] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6508), 1,
      anon_sym_STAR,
    STATE(3156), 1,
      sym_comment,
    STATE(4822), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6510), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [106326] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5317), 1,
      anon_sym_RBRACE,
    STATE(3157), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [106393] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5317), 1,
      anon_sym_RBRACE,
    STATE(3158), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [106460] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4985), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3159), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106573] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3160), 1,
      sym_comment,
    ACTIONS(5738), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4976), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106628] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(4253), 1,
      anon_sym_COLON,
    ACTIONS(5190), 1,
      anon_sym_extends,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(3161), 1,
      sym_comment,
    ACTIONS(5782), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6512), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106695] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3162), 1,
      sym_comment,
    ACTIONS(2351), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2151), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2153), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106752] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5244), 1,
      anon_sym_RBRACK,
    ACTIONS(6290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6294), 1,
      anon_sym_GT_GT,
    ACTIONS(6298), 1,
      anon_sym_AMP,
    ACTIONS(6300), 1,
      anon_sym_CARET,
    ACTIONS(6302), 1,
      anon_sym_PIPE,
    ACTIONS(6306), 1,
      anon_sym_PERCENT,
    ACTIONS(6308), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6310), 1,
      anon_sym_LT,
    ACTIONS(6318), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6320), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3163), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6304), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6316), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6312), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106865] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5336), 1,
      anon_sym_RBRACE,
    STATE(3164), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [106932] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5136), 1,
      anon_sym_COMMA,
    ACTIONS(5336), 1,
      anon_sym_RBRACE,
    STATE(3165), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [106999] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    ACTIONS(5326), 1,
      anon_sym_LBRACK,
    ACTIONS(5904), 1,
      anon_sym_COLON,
    STATE(3166), 1,
      sym_comment,
    ACTIONS(5329), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5003), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5320), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107064] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3167), 1,
      sym_comment,
    ACTIONS(5723), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5725), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107119] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3168), 1,
      sym_comment,
    ACTIONS(5717), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5719), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107174] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5343), 1,
      anon_sym_LBRACK,
    ACTIONS(5807), 1,
      anon_sym_COLON,
    STATE(3169), 1,
      sym_comment,
    ACTIONS(5346), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3570), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2069), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107239] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6516), 1,
      sym__automatic_semicolon,
    STATE(3170), 1,
      sym_comment,
    ACTIONS(2365), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2085), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2089), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107298] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6518), 1,
      sym__automatic_semicolon,
    STATE(3171), 1,
      sym_comment,
    ACTIONS(2357), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2257), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2261), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107357] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6520), 1,
      anon_sym_LPAREN,
    ACTIONS(6523), 1,
      anon_sym_COLON,
    ACTIONS(6525), 1,
      anon_sym_LT,
    ACTIONS(6528), 1,
      anon_sym_QMARK,
    STATE(3172), 1,
      sym_comment,
    ACTIONS(5576), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5578), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107420] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(4968), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3173), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [107533] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5170), 1,
      anon_sym_of,
    ACTIONS(6232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6236), 1,
      anon_sym_GT_GT,
    ACTIONS(6240), 1,
      anon_sym_AMP,
    ACTIONS(6242), 1,
      anon_sym_CARET,
    ACTIONS(6244), 1,
      anon_sym_PIPE,
    ACTIONS(6248), 1,
      anon_sym_PERCENT,
    ACTIONS(6250), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6262), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3174), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6230), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6238), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6246), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6256), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6258), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6254), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [107646] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    ACTIONS(5809), 1,
      anon_sym_of,
    ACTIONS(6530), 1,
      anon_sym_in,
    STATE(3175), 1,
      sym_comment,
    ACTIONS(5630), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5634), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107707] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5807), 1,
      anon_sym_of,
    ACTIONS(6533), 1,
      anon_sym_in,
    STATE(3176), 1,
      sym_comment,
    ACTIONS(2069), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107768] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(5987), 1,
      anon_sym_RBRACE,
    STATE(3177), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [107849] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(5987), 1,
      anon_sym_RBRACE,
    STATE(3178), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [107932] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6011), 1,
      anon_sym_STAR,
    ACTIONS(6013), 1,
      anon_sym_async,
    STATE(3179), 1,
      sym_comment,
    STATE(3798), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6017), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [108007] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5188), 1,
      anon_sym_QMARK,
    STATE(3180), 1,
      sym_comment,
    ACTIONS(5190), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5782), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5779), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108070] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6536), 1,
      sym__automatic_semicolon,
    STATE(3181), 1,
      sym_comment,
    ACTIONS(2381), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2207), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2211), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108129] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6538), 1,
      sym__automatic_semicolon,
    STATE(3182), 1,
      sym_comment,
    ACTIONS(2373), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2169), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2173), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108188] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    ACTIONS(5326), 1,
      anon_sym_LBRACK,
    STATE(3183), 1,
      sym_comment,
    ACTIONS(5003), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5329), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5320), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108251] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_STAR,
    ACTIONS(6542), 1,
      anon_sym_async,
    STATE(3184), 1,
      sym_comment,
    STATE(3799), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6544), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [108326] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_STAR,
    STATE(3185), 1,
      sym_comment,
    STATE(4651), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6546), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [108399] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3570), 1,
      anon_sym_extends,
    STATE(3186), 1,
      sym_comment,
    ACTIONS(5343), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5346), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2069), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108461] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3187), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [108571] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3188), 1,
      sym_comment,
    STATE(4122), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [108639] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3189), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [108749] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    ACTIONS(5190), 1,
      anon_sym_extends,
    STATE(3190), 1,
      sym_comment,
    ACTIONS(5779), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5782), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108811] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3191), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [108921] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    STATE(3192), 1,
      sym_comment,
    ACTIONS(5043), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5526), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5519), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5521), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108981] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5003), 1,
      anon_sym_extends,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    STATE(3193), 1,
      sym_comment,
    ACTIONS(5326), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5329), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5320), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [109043] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3194), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [109111] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5773), 1,
      anon_sym_LBRACK,
    STATE(3195), 1,
      sym_comment,
    ACTIONS(4843), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5776), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [109171] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3196), 1,
      sym_comment,
    STATE(4696), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [109239] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3197), 1,
      sym_comment,
    STATE(4701), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [109307] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3198), 1,
      sym_comment,
    STATE(4692), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [109375] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3199), 1,
      sym_comment,
    STATE(4726), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [109443] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5987), 1,
      anon_sym_RBRACE,
    STATE(3200), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [109519] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(966), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3201), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [109595] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3202), 1,
      sym_comment,
    STATE(4720), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [109663] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3203), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [109773] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3204), 1,
      sym_comment,
    STATE(4779), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [109841] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3205), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [109951] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    ACTIONS(5809), 1,
      anon_sym_COLON,
    STATE(3206), 1,
      sym_comment,
    ACTIONS(5657), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5630), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5634), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110011] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6584), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3207), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4937), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4939), 14,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [110091] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(3208), 1,
      sym_comment,
    STATE(3531), 1,
      sym_override_modifier,
    STATE(4808), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6587), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [110173] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6590), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3209), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5053), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5055), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [110247] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3210), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [110357] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3211), 1,
      sym_comment,
    STATE(4810), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [110425] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6593), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3212), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4978), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4980), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [110497] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3213), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [110607] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3214), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [110693] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6596), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3215), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [110769] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4139), 1,
      anon_sym_EQ,
    STATE(3216), 1,
      sym_comment,
    ACTIONS(4366), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110827] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4302), 1,
      anon_sym_EQ,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(3217), 1,
      sym_comment,
    ACTIONS(5190), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110889] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(225), 1,
      anon_sym_STAR,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2081), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6603), 1,
      anon_sym_async,
    ACTIONS(6605), 1,
      anon_sym_static,
    ACTIONS(6607), 1,
      anon_sym_readonly,
    ACTIONS(6613), 1,
      anon_sym_override,
    STATE(3218), 1,
      sym_comment,
    STATE(3468), 1,
      sym_accessibility_modifier,
    STATE(3530), 1,
      sym_override_modifier,
    STATE(4504), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6601), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(6609), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(6611), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(6775), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(6599), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [110977] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4298), 1,
      anon_sym_EQ,
    STATE(3219), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [111033] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3220), 1,
      sym_comment,
    STATE(4816), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [111101] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6212), 1,
      sym_regex_flags,
    STATE(3221), 1,
      sym_comment,
    ACTIONS(6208), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(6210), 22,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [111157] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1041), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3222), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [111233] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3223), 1,
      sym_comment,
    STATE(4801), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [111301] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3224), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [111403] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3225), 1,
      sym_comment,
    STATE(4822), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [111471] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3226), 1,
      sym_comment,
    ACTIONS(5029), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(5031), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111529] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3227), 1,
      sym_comment,
    STATE(4799), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [111597] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3228), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [111707] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6596), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3229), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [111789] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3230), 1,
      sym_comment,
    STATE(4618), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [111857] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3231), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [111957] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3232), 1,
      sym_comment,
    STATE(4641), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112025] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3233), 1,
      sym_comment,
    STATE(4731), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112093] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1043), 1,
      anon_sym_RBRACE,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3234), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112169] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3235), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [112263] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6121), 1,
      anon_sym_RBRACE,
    STATE(3236), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112339] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4320), 1,
      anon_sym_EQ,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(3237), 1,
      sym_comment,
    ACTIONS(5190), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [112401] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3238), 1,
      sym_comment,
    STATE(4662), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112469] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3239), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [112565] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3240), 1,
      sym_comment,
    STATE(4651), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112633] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3241), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4946), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [112731] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3242), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [112841] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3243), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [112951] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3244), 1,
      sym_comment,
    STATE(4784), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113019] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(3245), 1,
      sym_comment,
    ACTIONS(5190), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [113079] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3246), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113189] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6195), 1,
      anon_sym_RBRACE,
    STATE(3247), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113265] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3248), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113375] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3249), 1,
      sym_comment,
    STATE(4821), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113443] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6362), 1,
      anon_sym_COMMA,
    ACTIONS(6615), 1,
      anon_sym_RBRACE,
    STATE(3250), 1,
      sym_comment,
    STATE(3531), 1,
      sym_override_modifier,
    STATE(4808), 1,
      sym__property_name,
    STATE(5670), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113527] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3251), 1,
      sym_comment,
    STATE(4843), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113595] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3252), 1,
      sym_comment,
    STATE(4715), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113663] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3253), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113773] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3254), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113883] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(5392), 1,
      anon_sym_BANG,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(3255), 1,
      sym_comment,
    STATE(3314), 1,
      sym_type_arguments,
    STATE(5804), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113993] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    ACTIONS(6580), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6582), 1,
      sym__ternary_qmark,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3256), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [114103] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3257), 1,
      sym_comment,
    STATE(4820), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [114171] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4946), 1,
      anon_sym_BANG,
    ACTIONS(6552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6554), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6562), 1,
      anon_sym_CARET,
    ACTIONS(6564), 1,
      anon_sym_PIPE,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3258), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4944), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [114275] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6556), 1,
      anon_sym_GT_GT,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3259), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6550), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6558), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6566), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6574), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4946), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [114365] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4889), 1,
      anon_sym_as,
    ACTIONS(4893), 1,
      anon_sym_BANG,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4933), 1,
      anon_sym_satisfies,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6596), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3260), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 13,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [114447] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3261), 1,
      sym_comment,
    ACTIONS(5178), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [114503] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4841), 1,
      anon_sym_QMARK,
    ACTIONS(4843), 1,
      anon_sym_extends,
    STATE(3262), 1,
      sym_comment,
    ACTIONS(5776), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5773), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [114565] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_RBRACE,
    STATE(3263), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [114641] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6568), 1,
      anon_sym_PERCENT,
    ACTIONS(6570), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6596), 1,
      anon_sym_LT,
    STATE(2220), 1,
      sym_type_arguments,
    STATE(3264), 1,
      sym_comment,
    STATE(6178), 1,
      sym_optional_chain,
    ACTIONS(4931), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6548), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4946), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4944), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [114721] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    STATE(3265), 1,
      sym_comment,
    ACTIONS(987), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [114777] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    STATE(3266), 1,
      sym_comment,
    ACTIONS(987), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2403), 30,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [114832] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6362), 1,
      anon_sym_COMMA,
    ACTIONS(6615), 1,
      anon_sym_RBRACE,
    STATE(3267), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5670), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [114907] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    STATE(3268), 1,
      sym_comment,
    ACTIONS(5900), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [114966] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    STATE(3269), 1,
      sym_comment,
    ACTIONS(5900), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(987), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [115025] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3270), 1,
      sym_comment,
    ACTIONS(2211), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6620), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115080] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    ACTIONS(5744), 1,
      anon_sym_RBRACK,
    ACTIONS(5904), 1,
      anon_sym_COMMA,
    STATE(3271), 1,
      sym_comment,
    ACTIONS(5320), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115139] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4235), 1,
      anon_sym_EQ,
    STATE(3272), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115194] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    ACTIONS(5657), 1,
      anon_sym_RBRACK,
    ACTIONS(5809), 1,
      anon_sym_COMMA,
    STATE(3273), 1,
      sym_comment,
    ACTIONS(5630), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5634), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115253] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6362), 1,
      anon_sym_COMMA,
    ACTIONS(6615), 1,
      anon_sym_RBRACE,
    STATE(3274), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5670), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [115330] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5680), 1,
      anon_sym_RBRACK,
    ACTIONS(5807), 1,
      anon_sym_COMMA,
    STATE(3275), 1,
      sym_comment,
    ACTIONS(2069), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115389] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6623), 1,
      anon_sym_readonly,
    STATE(3276), 1,
      sym_comment,
    STATE(3574), 1,
      sym_override_modifier,
    STATE(4143), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [115462] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3277), 1,
      sym_comment,
    ACTIONS(2173), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6625), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6628), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115517] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6631), 1,
      anon_sym_abstract,
    STATE(3278), 1,
      sym_comment,
    STATE(4164), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [115586] = 25,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4595), 1,
      anon_sym_AT,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6633), 1,
      anon_sym_STAR,
    ACTIONS(6635), 1,
      anon_sym_async,
    ACTIONS(6637), 1,
      anon_sym_static,
    ACTIONS(6639), 1,
      anon_sym_readonly,
    ACTIONS(6643), 1,
      anon_sym_declare,
    ACTIONS(6645), 1,
      anon_sym_abstract,
    STATE(3279), 1,
      sym_comment,
    STATE(3400), 1,
      sym_method_definition,
    STATE(3436), 1,
      sym_accessibility_modifier,
    STATE(3496), 1,
      aux_sym_export_statement_repeat1,
    STATE(3521), 1,
      sym_override_modifier,
    STATE(3557), 1,
      sym_decorator,
    STATE(3807), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6641), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4605), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(4376), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [115679] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3280), 1,
      sym_comment,
    ACTIONS(5574), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6647), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6650), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115734] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3281), 1,
      sym_comment,
    ACTIONS(5725), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6653), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6656), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115789] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3282), 1,
      sym_comment,
    ACTIONS(2195), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6659), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6662), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115844] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3283), 1,
      sym_comment,
    ACTIONS(5566), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6668), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115899] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6671), 1,
      anon_sym_readonly,
    STATE(3284), 1,
      sym_comment,
    STATE(3561), 1,
      sym_override_modifier,
    STATE(4210), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [115972] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4294), 1,
      anon_sym_EQ,
    STATE(3285), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116027] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6224), 1,
      anon_sym_COMMA,
    STATE(3286), 1,
      sym_comment,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116082] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4843), 1,
      anon_sym_extends,
    STATE(3287), 1,
      sym_comment,
    ACTIONS(5773), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5776), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116141] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3288), 1,
      sym_comment,
    ACTIONS(5610), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6673), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116196] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6679), 1,
      anon_sym_readonly,
    STATE(3289), 1,
      sym_comment,
    STATE(3582), 1,
      sym_override_modifier,
    STATE(4122), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [116269] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(3290), 1,
      sym_comment,
    ACTIONS(5782), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5190), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116328] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6681), 1,
      anon_sym_abstract,
    STATE(3291), 1,
      sym_comment,
    STATE(4202), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [116397] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4264), 1,
      anon_sym_RBRACK,
    ACTIONS(4287), 1,
      anon_sym_COMMA,
    ACTIONS(4369), 1,
      anon_sym_EQ,
    STATE(3292), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116456] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(3293), 1,
      sym_comment,
    STATE(3531), 1,
      sym_override_modifier,
    STATE(4808), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6683), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [116535] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6189), 1,
      anon_sym_abstract,
    STATE(3294), 1,
      sym_comment,
    STATE(4122), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [116604] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(3295), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6587), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [116679] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6685), 1,
      anon_sym_readonly,
    STATE(3296), 1,
      sym_comment,
    STATE(3585), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [116752] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6687), 1,
      anon_sym_abstract,
    STATE(3297), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [116821] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    STATE(3298), 1,
      sym_comment,
    ACTIONS(5190), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5782), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4137), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116882] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(3299), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6587), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [116955] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3300), 1,
      sym_comment,
    ACTIONS(2135), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6689), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6692), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [117010] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3301), 1,
      sym_comment,
    ACTIONS(5178), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5174), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [117065] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6695), 1,
      anon_sym_readonly,
    STATE(3302), 1,
      sym_comment,
    STATE(3541), 1,
      sym_override_modifier,
    STATE(4219), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117138] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    STATE(3303), 1,
      sym_comment,
    ACTIONS(5526), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5043), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5519), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5521), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [117197] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6697), 1,
      anon_sym_abstract,
    STATE(3304), 1,
      sym_comment,
    STATE(4220), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117266] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5773), 1,
      anon_sym_LBRACK,
    STATE(3305), 1,
      sym_comment,
    ACTIONS(5776), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4843), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [117325] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3306), 1,
      sym_comment,
    STATE(4161), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117391] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(6195), 1,
      anon_sym_RBRACE,
    STATE(3307), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117453] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4229), 1,
      anon_sym_EQ,
    ACTIONS(4351), 1,
      anon_sym_in,
    ACTIONS(4354), 1,
      anon_sym_of,
    STATE(3308), 1,
      sym_comment,
    ACTIONS(4137), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [117511] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(966), 1,
      anon_sym_RBRACE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    STATE(3309), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117573] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(966), 1,
      anon_sym_RBRACE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    STATE(3310), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117635] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(6113), 1,
      anon_sym_RBRACE,
    STATE(3311), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117697] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(6113), 1,
      anon_sym_RBRACE,
    STATE(3312), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117759] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5987), 1,
      anon_sym_RBRACE,
    STATE(3313), 1,
      sym_comment,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117821] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(3314), 1,
      sym_comment,
    STATE(3118), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4861), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4863), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [117879] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3315), 1,
      sym_comment,
    STATE(4190), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117945] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5987), 1,
      anon_sym_RBRACE,
    STATE(3316), 1,
      sym_comment,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118007] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3317), 1,
      sym_comment,
    STATE(4160), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118073] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3318), 1,
      sym_comment,
    STATE(4289), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118139] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1043), 1,
      anon_sym_RBRACE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    STATE(3319), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118201] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(3320), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6683), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118271] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3321), 1,
      sym_comment,
    STATE(4226), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118337] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3322), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6587), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118405] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4320), 1,
      anon_sym_EQ,
    STATE(3323), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [118459] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(3324), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6683), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118531] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1041), 1,
      anon_sym_RBRACE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    STATE(3325), 1,
      sym_comment,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118593] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_EQ,
    ACTIONS(5904), 1,
      anon_sym_of,
    ACTIONS(6449), 1,
      anon_sym_in,
    STATE(3326), 1,
      sym_comment,
    ACTIONS(5320), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [118651] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1041), 1,
      anon_sym_RBRACE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    STATE(3327), 1,
      sym_comment,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118713] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3328), 1,
      sym_comment,
    STATE(4296), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118779] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3329), 1,
      sym_comment,
    STATE(4218), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118845] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(1043), 1,
      anon_sym_RBRACE,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    STATE(3330), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118907] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5632), 1,
      anon_sym_EQ,
    ACTIONS(5809), 1,
      anon_sym_of,
    ACTIONS(6530), 1,
      anon_sym_in,
    STATE(3331), 1,
      sym_comment,
    ACTIONS(5630), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5634), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [118965] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3332), 1,
      sym_comment,
    STATE(4295), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119031] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2071), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5807), 1,
      anon_sym_of,
    ACTIONS(6533), 1,
      anon_sym_in,
    STATE(3333), 1,
      sym_comment,
    ACTIONS(2069), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2075), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [119089] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(6121), 1,
      anon_sym_RBRACE,
    STATE(3334), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119151] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6362), 1,
      anon_sym_COMMA,
    ACTIONS(6615), 1,
      anon_sym_RBRACE,
    STATE(3335), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    STATE(5670), 1,
      aux_sym_object_repeat1,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119221] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(6121), 1,
      anon_sym_RBRACE,
    STATE(3336), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119283] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3337), 1,
      sym_comment,
    STATE(4109), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119349] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    STATE(3338), 1,
      sym_comment,
    ACTIONS(987), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119403] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4302), 1,
      anon_sym_EQ,
    STATE(3339), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [119457] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3340), 1,
      sym_comment,
    STATE(4149), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119523] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3341), 1,
      sym_comment,
    STATE(4198), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119589] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6212), 1,
      sym_regex_flags,
    STATE(3342), 1,
      sym_comment,
    ACTIONS(6208), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(6210), 20,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [119643] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3343), 1,
      sym_comment,
    STATE(4285), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119709] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3344), 1,
      sym_comment,
    STATE(4077), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119775] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3345), 1,
      sym_comment,
    STATE(4147), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119841] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3346), 1,
      sym_comment,
    STATE(4085), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119907] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(231), 1,
      anon_sym_COMMA,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    ACTIONS(6195), 1,
      anon_sym_RBRACE,
    STATE(3347), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119969] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4518), 1,
      sym__automatic_semicolon,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3348), 1,
      sym_comment,
    STATE(4170), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [120035] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4446), 1,
      anon_sym_EQ,
    STATE(3349), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120088] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4484), 1,
      anon_sym_EQ,
    STATE(3350), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120141] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4480), 1,
      anon_sym_EQ,
    STATE(3351), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120194] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4432), 1,
      anon_sym_EQ,
    STATE(3352), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120247] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3353), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6683), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [120312] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4448), 1,
      anon_sym_EQ,
    STATE(3354), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120365] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4468), 1,
      anon_sym_EQ,
    STATE(3355), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120418] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4462), 1,
      anon_sym_EQ,
    STATE(3356), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120471] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4430), 1,
      anon_sym_EQ,
    STATE(3357), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120524] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4470), 1,
      anon_sym_EQ,
    STATE(3358), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4141), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120577] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6701), 1,
      sym__automatic_semicolon,
    STATE(3359), 1,
      sym_comment,
    ACTIONS(6699), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [120627] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6705), 1,
      sym__automatic_semicolon,
    STATE(3360), 1,
      sym_comment,
    ACTIONS(6703), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [120677] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6709), 1,
      sym__automatic_semicolon,
    STATE(3361), 1,
      sym_comment,
    ACTIONS(6707), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [120727] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6713), 1,
      sym__automatic_semicolon,
    STATE(3362), 1,
      sym_comment,
    ACTIONS(6711), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [120777] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6717), 1,
      sym__automatic_semicolon,
    STATE(3363), 1,
      sym_comment,
    ACTIONS(6715), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [120827] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6721), 1,
      sym__automatic_semicolon,
    STATE(3364), 1,
      sym_comment,
    ACTIONS(6719), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [120877] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6701), 1,
      sym__automatic_semicolon,
    STATE(3365), 1,
      sym_comment,
    ACTIONS(6699), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [120927] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6701), 1,
      sym__automatic_semicolon,
    STATE(3366), 1,
      sym_comment,
    ACTIONS(6699), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [120977] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6717), 1,
      sym__automatic_semicolon,
    STATE(3367), 1,
      sym_comment,
    ACTIONS(6715), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121027] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6725), 1,
      sym__automatic_semicolon,
    STATE(3368), 1,
      sym_comment,
    ACTIONS(6723), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121077] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6729), 1,
      sym__automatic_semicolon,
    STATE(3369), 1,
      sym_comment,
    ACTIONS(6727), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121127] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6721), 1,
      sym__automatic_semicolon,
    STATE(3370), 1,
      sym_comment,
    ACTIONS(6719), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121177] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6733), 1,
      sym__automatic_semicolon,
    STATE(3371), 1,
      sym_comment,
    ACTIONS(6731), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121227] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6362), 1,
      anon_sym_COMMA,
    ACTIONS(6615), 1,
      anon_sym_RBRACE,
    STATE(3372), 1,
      sym_comment,
    STATE(5670), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121283] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6737), 1,
      sym__automatic_semicolon,
    STATE(3373), 1,
      sym_comment,
    ACTIONS(6735), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121333] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6705), 1,
      sym__automatic_semicolon,
    STATE(3374), 1,
      sym_comment,
    ACTIONS(6703), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121383] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6741), 1,
      sym__automatic_semicolon,
    STATE(3375), 1,
      sym_comment,
    ACTIONS(6739), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121433] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2223), 1,
      sym__automatic_semicolon,
    STATE(3376), 1,
      sym_comment,
    ACTIONS(2221), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121483] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6717), 1,
      sym__automatic_semicolon,
    STATE(3377), 1,
      sym_comment,
    ACTIONS(6715), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121533] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6745), 1,
      anon_sym_SEMI,
    ACTIONS(6748), 1,
      sym__automatic_semicolon,
    STATE(3378), 1,
      sym_comment,
    ACTIONS(6743), 34,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121585] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2115), 1,
      sym__automatic_semicolon,
    STATE(3379), 1,
      sym_comment,
    ACTIONS(2111), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121635] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6362), 1,
      anon_sym_COMMA,
    ACTIONS(6615), 1,
      anon_sym_RBRACE,
    STATE(3380), 1,
      sym_comment,
    STATE(5670), 1,
      aux_sym_object_repeat1,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121691] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6737), 1,
      sym__automatic_semicolon,
    STATE(3381), 1,
      sym_comment,
    ACTIONS(6735), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121741] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6741), 1,
      sym__automatic_semicolon,
    STATE(3382), 1,
      sym_comment,
    ACTIONS(6739), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121791] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6721), 1,
      sym__automatic_semicolon,
    STATE(3383), 1,
      sym_comment,
    ACTIONS(6719), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121841] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6741), 1,
      sym__automatic_semicolon,
    STATE(3384), 1,
      sym_comment,
    ACTIONS(6739), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121891] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6737), 1,
      sym__automatic_semicolon,
    STATE(3385), 1,
      sym_comment,
    ACTIONS(6735), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121941] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6705), 1,
      sym__automatic_semicolon,
    STATE(3386), 1,
      sym_comment,
    ACTIONS(6703), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121991] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6741), 1,
      sym__automatic_semicolon,
    STATE(3387), 1,
      sym_comment,
    ACTIONS(6739), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122041] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6752), 1,
      sym__automatic_semicolon,
    STATE(3388), 1,
      sym_comment,
    ACTIONS(6750), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122091] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6754), 1,
      anon_sym_STAR,
    ACTIONS(6756), 1,
      anon_sym_async,
    ACTIONS(6758), 1,
      anon_sym_readonly,
    STATE(3389), 1,
      sym_comment,
    STATE(3525), 1,
      sym_override_modifier,
    STATE(4826), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6760), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122165] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6705), 1,
      sym__automatic_semicolon,
    STATE(3390), 1,
      sym_comment,
    ACTIONS(6703), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122215] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6764), 1,
      sym__automatic_semicolon,
    STATE(3391), 1,
      sym_comment,
    ACTIONS(6762), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122265] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    STATE(3392), 1,
      sym_comment,
    ACTIONS(6587), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122319] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6766), 1,
      sym__automatic_semicolon,
    STATE(3393), 1,
      sym_comment,
    ACTIONS(2111), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122369] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6717), 1,
      sym__automatic_semicolon,
    STATE(3394), 1,
      sym_comment,
    ACTIONS(6715), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122419] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(5134), 1,
      anon_sym_EQ,
    STATE(3395), 1,
      sym_comment,
    ACTIONS(6587), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122473] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6701), 1,
      sym__automatic_semicolon,
    STATE(3396), 1,
      sym_comment,
    ACTIONS(6699), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122523] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6737), 1,
      sym__automatic_semicolon,
    STATE(3397), 1,
      sym_comment,
    ACTIONS(6735), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122573] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6770), 1,
      sym__automatic_semicolon,
    STATE(3398), 1,
      sym_comment,
    ACTIONS(6768), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122623] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6717), 1,
      sym__automatic_semicolon,
    STATE(3399), 1,
      sym_comment,
    ACTIONS(6715), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122673] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6774), 1,
      anon_sym_SEMI,
    ACTIONS(6777), 1,
      sym__automatic_semicolon,
    STATE(3400), 1,
      sym_comment,
    ACTIONS(6772), 34,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122725] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6779), 1,
      sym__automatic_semicolon,
    STATE(3401), 1,
      sym_comment,
    ACTIONS(2067), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122775] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6721), 1,
      sym__automatic_semicolon,
    STATE(3402), 1,
      sym_comment,
    ACTIONS(6719), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122825] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6781), 1,
      sym__automatic_semicolon,
    STATE(3403), 1,
      sym_comment,
    ACTIONS(2111), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122875] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6705), 1,
      sym__automatic_semicolon,
    STATE(3404), 1,
      sym_comment,
    ACTIONS(6703), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122925] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6717), 1,
      sym__automatic_semicolon,
    STATE(3405), 1,
      sym_comment,
    ACTIONS(6715), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [122975] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6741), 1,
      sym__automatic_semicolon,
    STATE(3406), 1,
      sym_comment,
    ACTIONS(6739), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123025] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6725), 1,
      sym__automatic_semicolon,
    STATE(3407), 1,
      sym_comment,
    ACTIONS(6723), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123075] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6701), 1,
      sym__automatic_semicolon,
    STATE(3408), 1,
      sym_comment,
    ACTIONS(6699), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123125] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6705), 1,
      sym__automatic_semicolon,
    STATE(3409), 1,
      sym_comment,
    ACTIONS(6703), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123175] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6721), 1,
      sym__automatic_semicolon,
    STATE(3410), 1,
      sym_comment,
    ACTIONS(6719), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123225] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6783), 1,
      sym__automatic_semicolon,
    STATE(3411), 1,
      sym_comment,
    ACTIONS(2067), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123275] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6705), 1,
      sym__automatic_semicolon,
    STATE(3412), 1,
      sym_comment,
    ACTIONS(6703), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123325] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6770), 1,
      sym__automatic_semicolon,
    STATE(3413), 1,
      sym_comment,
    ACTIONS(6768), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123375] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6737), 1,
      sym__automatic_semicolon,
    STATE(3414), 1,
      sym_comment,
    ACTIONS(6735), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123425] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6717), 1,
      sym__automatic_semicolon,
    STATE(3415), 1,
      sym_comment,
    ACTIONS(6715), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123475] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6785), 1,
      anon_sym_STAR,
    ACTIONS(6787), 1,
      anon_sym_async,
    STATE(3416), 1,
      sym_comment,
    STATE(4758), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6789), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123542] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3417), 1,
      sym_comment,
    ACTIONS(6683), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2403), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123593] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3418), 1,
      sym_comment,
    ACTIONS(6791), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123640] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3419), 1,
      sym_comment,
    ACTIONS(6793), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123687] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3420), 1,
      sym_comment,
    ACTIONS(6793), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123734] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6754), 1,
      anon_sym_STAR,
    ACTIONS(6756), 1,
      anon_sym_async,
    STATE(3421), 1,
      sym_comment,
    STATE(4826), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6760), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123801] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6754), 1,
      anon_sym_STAR,
    STATE(3422), 1,
      sym_comment,
    STATE(4826), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6760), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123866] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3423), 1,
      sym_comment,
    ACTIONS(2111), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123913] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3424), 1,
      sym_comment,
    ACTIONS(2221), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [123960] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3425), 1,
      sym_comment,
    ACTIONS(6743), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [124007] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6785), 1,
      anon_sym_STAR,
    STATE(3426), 1,
      sym_comment,
    STATE(4758), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6789), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124072] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6795), 1,
      anon_sym_EQ_GT,
    STATE(3427), 1,
      sym_comment,
    STATE(4826), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124135] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6797), 1,
      anon_sym_STAR,
    STATE(3428), 1,
      sym_comment,
    STATE(4675), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6799), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124200] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3429), 1,
      sym_comment,
    ACTIONS(6801), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [124247] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6797), 1,
      anon_sym_STAR,
    ACTIONS(6803), 1,
      anon_sym_async,
    STATE(3430), 1,
      sym_comment,
    STATE(4675), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6799), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124314] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3431), 1,
      sym_comment,
    ACTIONS(6805), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [124361] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6807), 1,
      anon_sym_STAR,
    STATE(3432), 1,
      sym_comment,
    STATE(4653), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6809), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124426] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3433), 1,
      sym_comment,
    ACTIONS(6683), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124477] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3434), 1,
      sym_comment,
    STATE(4662), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124537] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3435), 1,
      sym_comment,
    STATE(4803), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124597] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6157), 1,
      anon_sym_STAR,
    ACTIONS(6159), 1,
      anon_sym_async,
    ACTIONS(6811), 1,
      anon_sym_static,
    ACTIONS(6813), 1,
      anon_sym_readonly,
    ACTIONS(6815), 1,
      anon_sym_declare,
    ACTIONS(6817), 1,
      anon_sym_abstract,
    STATE(3436), 1,
      sym_comment,
    STATE(3533), 1,
      sym_override_modifier,
    STATE(3831), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6161), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124673] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3437), 1,
      sym_comment,
    STATE(4823), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124733] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3438), 1,
      sym_comment,
    STATE(4821), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124793] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3439), 1,
      sym_comment,
    STATE(4701), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124853] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3440), 1,
      sym_comment,
    STATE(4702), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124913] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3441), 1,
      sym_comment,
    STATE(4779), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124973] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3442), 1,
      sym_comment,
    STATE(4820), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125033] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3443), 1,
      sym_comment,
    STATE(4816), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125093] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6819), 1,
      anon_sym_LPAREN,
    ACTIONS(6821), 1,
      anon_sym_DOT,
    STATE(3444), 1,
      sym_comment,
    STATE(3594), 1,
      sym_arguments,
    ACTIONS(4247), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125145] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3445), 1,
      sym_comment,
    STATE(4675), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125205] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3446), 1,
      sym_comment,
    STATE(4673), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125265] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3447), 1,
      sym_comment,
    STATE(4690), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125325] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_comment,
    STATE(4692), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125385] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3449), 1,
      sym_comment,
    STATE(4653), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125445] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3450), 1,
      sym_comment,
    STATE(4810), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125505] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3451), 1,
      sym_comment,
    STATE(4696), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125565] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3452), 1,
      sym_comment,
    STATE(4731), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125625] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3453), 1,
      sym_comment,
    STATE(4822), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125685] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3454), 1,
      sym_comment,
    STATE(4618), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125745] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3455), 1,
      sym_comment,
    STATE(4784), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125805] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3456), 1,
      sym_comment,
    STATE(4651), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125865] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3457), 1,
      sym_comment,
    STATE(4641), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125925] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3458), 1,
      sym_comment,
    STATE(4749), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125985] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3459), 1,
      sym_comment,
    STATE(4843), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126045] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3460), 1,
      sym_comment,
    STATE(4826), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126105] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3461), 1,
      sym_comment,
    STATE(4758), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126165] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3462), 1,
      sym_comment,
    STATE(4715), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126225] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5371), 1,
      anon_sym_STAR,
    ACTIONS(5375), 1,
      anon_sym_async,
    ACTIONS(6823), 1,
      anon_sym_static,
    ACTIONS(6825), 1,
      anon_sym_readonly,
    ACTIONS(6827), 1,
      anon_sym_declare,
    ACTIONS(6829), 1,
      anon_sym_abstract,
    STATE(3463), 1,
      sym_comment,
    STATE(3523), 1,
      sym_override_modifier,
    STATE(3819), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126301] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6831), 1,
      anon_sym_RBRACE,
    STATE(3464), 1,
      sym_comment,
    STATE(5037), 1,
      sym__property_name,
    STATE(5722), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126362] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6833), 1,
      anon_sym_RBRACE,
    STATE(3465), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126423] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6835), 1,
      anon_sym_RBRACE,
    STATE(3466), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126484] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6837), 1,
      anon_sym_RBRACE,
    STATE(3467), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126545] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(2908), 1,
      anon_sym_override,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    ACTIONS(6839), 1,
      anon_sym_static,
    STATE(3468), 1,
      sym_comment,
    STATE(3531), 1,
      sym_override_modifier,
    STATE(4808), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126616] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6841), 1,
      anon_sym_RBRACE,
    STATE(3469), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126677] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6843), 1,
      anon_sym_RBRACE,
    STATE(3470), 1,
      sym_comment,
    STATE(5252), 1,
      sym__property_name,
    STATE(6280), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126738] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6845), 1,
      anon_sym_RBRACE,
    STATE(3471), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126799] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2872), 1,
      anon_sym_namespace,
    ACTIONS(2874), 1,
      anon_sym_import,
    ACTIONS(2876), 1,
      anon_sym_var,
    ACTIONS(2878), 1,
      anon_sym_let,
    ACTIONS(2880), 1,
      anon_sym_const,
    ACTIONS(2884), 1,
      anon_sym_class,
    ACTIONS(2886), 1,
      anon_sym_async,
    ACTIONS(2888), 1,
      anon_sym_function,
    ACTIONS(2890), 1,
      anon_sym_declare,
    ACTIONS(2892), 1,
      anon_sym_module,
    ACTIONS(2894), 1,
      anon_sym_abstract,
    ACTIONS(2896), 1,
      anon_sym_interface,
    ACTIONS(2898), 1,
      anon_sym_enum,
    ACTIONS(2910), 1,
      anon_sym_type,
    ACTIONS(6847), 1,
      anon_sym_default,
    STATE(1399), 1,
      sym_internal_module,
    STATE(1439), 1,
      sym_declaration,
    STATE(3472), 1,
      sym_comment,
    STATE(5232), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(1444), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [126884] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6849), 1,
      anon_sym_STAR,
    ACTIONS(6851), 1,
      anon_sym_readonly,
    STATE(3473), 1,
      sym_comment,
    STATE(3522), 1,
      sym_override_modifier,
    STATE(3812), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126951] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6855), 1,
      anon_sym_RBRACE,
    STATE(3474), 1,
      sym_comment,
    STATE(5344), 1,
      sym__property_name,
    STATE(6259), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [127012] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2663), 1,
      anon_sym_namespace,
    ACTIONS(2669), 1,
      anon_sym_import,
    ACTIONS(2671), 1,
      anon_sym_var,
    ACTIONS(2673), 1,
      anon_sym_let,
    ACTIONS(2675), 1,
      anon_sym_const,
    ACTIONS(2683), 1,
      anon_sym_class,
    ACTIONS(2685), 1,
      anon_sym_async,
    ACTIONS(2687), 1,
      anon_sym_function,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2700), 1,
      anon_sym_declare,
    ACTIONS(2704), 1,
      anon_sym_abstract,
    ACTIONS(2706), 1,
      anon_sym_interface,
    ACTIONS(2708), 1,
      anon_sym_enum,
    ACTIONS(2738), 1,
      anon_sym_type,
    ACTIONS(2740), 1,
      anon_sym_module,
    ACTIONS(2742), 1,
      anon_sym_global,
    STATE(1514), 1,
      sym_declaration,
    STATE(1557), 1,
      sym_internal_module,
    STATE(3475), 1,
      sym_comment,
    STATE(5398), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(1558), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [127097] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2872), 1,
      anon_sym_namespace,
    ACTIONS(2874), 1,
      anon_sym_import,
    ACTIONS(2876), 1,
      anon_sym_var,
    ACTIONS(2878), 1,
      anon_sym_let,
    ACTIONS(2880), 1,
      anon_sym_const,
    ACTIONS(2884), 1,
      anon_sym_class,
    ACTIONS(2886), 1,
      anon_sym_async,
    ACTIONS(2888), 1,
      anon_sym_function,
    ACTIONS(2890), 1,
      anon_sym_declare,
    ACTIONS(2894), 1,
      anon_sym_abstract,
    ACTIONS(2896), 1,
      anon_sym_interface,
    ACTIONS(2898), 1,
      anon_sym_enum,
    ACTIONS(2910), 1,
      anon_sym_type,
    ACTIONS(2912), 1,
      anon_sym_module,
    ACTIONS(2914), 1,
      anon_sym_global,
    STATE(1332), 1,
      sym_declaration,
    STATE(1399), 1,
      sym_internal_module,
    STATE(3476), 1,
      sym_comment,
    STATE(5232), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(1444), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [127182] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5146), 1,
      anon_sym_readonly,
    ACTIONS(6857), 1,
      anon_sym_static,
    STATE(3477), 1,
      sym_comment,
    STATE(3516), 1,
      sym_override_modifier,
    STATE(3892), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [127253] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2936), 1,
      anon_sym_type,
    ACTIONS(2938), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_import,
    ACTIONS(2942), 1,
      anon_sym_var,
    ACTIONS(2944), 1,
      anon_sym_let,
    ACTIONS(2946), 1,
      anon_sym_const,
    ACTIONS(2948), 1,
      anon_sym_class,
    ACTIONS(2950), 1,
      anon_sym_async,
    ACTIONS(2952), 1,
      anon_sym_function,
    ACTIONS(2954), 1,
      anon_sym_declare,
    ACTIONS(2958), 1,
      anon_sym_abstract,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    ACTIONS(4520), 1,
      anon_sym_module,
    ACTIONS(6859), 1,
      anon_sym_default,
    STATE(3478), 1,
      sym_comment,
    STATE(4878), 1,
      sym_internal_module,
    STATE(5051), 1,
      sym_declaration,
    STATE(5382), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5171), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [127338] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6861), 1,
      anon_sym_RBRACE,
    STATE(3479), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [127399] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6863), 1,
      anon_sym_static,
    ACTIONS(6865), 1,
      anon_sym_readonly,
    ACTIONS(6867), 1,
      anon_sym_abstract,
    STATE(3480), 1,
      sym_comment,
    STATE(3590), 1,
      sym_override_modifier,
    STATE(4224), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [127466] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6869), 1,
      anon_sym_RBRACE,
    STATE(3481), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [127527] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6871), 1,
      anon_sym_RBRACE,
    STATE(3482), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [127588] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6873), 1,
      anon_sym_RBRACE,
    STATE(3483), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [127649] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2758), 1,
      anon_sym_namespace,
    ACTIONS(2760), 1,
      anon_sym_import,
    ACTIONS(2762), 1,
      anon_sym_var,
    ACTIONS(2764), 1,
      anon_sym_let,
    ACTIONS(2766), 1,
      anon_sym_const,
    ACTIONS(2770), 1,
      anon_sym_class,
    ACTIONS(2772), 1,
      anon_sym_async,
    ACTIONS(2774), 1,
      anon_sym_function,
    ACTIONS(2776), 1,
      anon_sym_declare,
    ACTIONS(2778), 1,
      anon_sym_module,
    ACTIONS(2780), 1,
      anon_sym_abstract,
    ACTIONS(2782), 1,
      anon_sym_interface,
    ACTIONS(2784), 1,
      anon_sym_enum,
    ACTIONS(2922), 1,
      anon_sym_type,
    ACTIONS(6875), 1,
      anon_sym_default,
    STATE(1348), 1,
      sym_internal_module,
    STATE(1403), 1,
      sym_declaration,
    STATE(3484), 1,
      sym_comment,
    STATE(5102), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(1327), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [127734] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6877), 1,
      anon_sym_RBRACE,
    STATE(3485), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [127795] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2663), 1,
      anon_sym_namespace,
    ACTIONS(2669), 1,
      anon_sym_import,
    ACTIONS(2671), 1,
      anon_sym_var,
    ACTIONS(2673), 1,
      anon_sym_let,
    ACTIONS(2675), 1,
      anon_sym_const,
    ACTIONS(2683), 1,
      anon_sym_class,
    ACTIONS(2685), 1,
      anon_sym_async,
    ACTIONS(2687), 1,
      anon_sym_function,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2700), 1,
      anon_sym_declare,
    ACTIONS(2702), 1,
      anon_sym_module,
    ACTIONS(2704), 1,
      anon_sym_abstract,
    ACTIONS(2706), 1,
      anon_sym_interface,
    ACTIONS(2708), 1,
      anon_sym_enum,
    ACTIONS(2738), 1,
      anon_sym_type,
    ACTIONS(6879), 1,
      anon_sym_default,
    STATE(1473), 1,
      sym_declaration,
    STATE(1557), 1,
      sym_internal_module,
    STATE(3486), 1,
      sym_comment,
    STATE(5398), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(1558), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [127880] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6881), 1,
      anon_sym_RBRACE,
    STATE(3487), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [127941] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6883), 1,
      anon_sym_RBRACE,
    STATE(3488), 1,
      sym_comment,
    STATE(5154), 1,
      sym__property_name,
    STATE(6188), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128002] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3489), 1,
      sym_comment,
    ACTIONS(4312), 33,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [128047] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2758), 1,
      anon_sym_namespace,
    ACTIONS(2760), 1,
      anon_sym_import,
    ACTIONS(2762), 1,
      anon_sym_var,
    ACTIONS(2764), 1,
      anon_sym_let,
    ACTIONS(2766), 1,
      anon_sym_const,
    ACTIONS(2770), 1,
      anon_sym_class,
    ACTIONS(2772), 1,
      anon_sym_async,
    ACTIONS(2774), 1,
      anon_sym_function,
    ACTIONS(2776), 1,
      anon_sym_declare,
    ACTIONS(2780), 1,
      anon_sym_abstract,
    ACTIONS(2782), 1,
      anon_sym_interface,
    ACTIONS(2784), 1,
      anon_sym_enum,
    ACTIONS(2922), 1,
      anon_sym_type,
    ACTIONS(2924), 1,
      anon_sym_module,
    ACTIONS(2926), 1,
      anon_sym_global,
    STATE(1348), 1,
      sym_internal_module,
    STATE(1377), 1,
      sym_declaration,
    STATE(3490), 1,
      sym_comment,
    STATE(5102), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(1327), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [128132] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2936), 1,
      anon_sym_type,
    ACTIONS(2938), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_import,
    ACTIONS(2942), 1,
      anon_sym_var,
    ACTIONS(2944), 1,
      anon_sym_let,
    ACTIONS(2946), 1,
      anon_sym_const,
    ACTIONS(2948), 1,
      anon_sym_class,
    ACTIONS(2950), 1,
      anon_sym_async,
    ACTIONS(2952), 1,
      anon_sym_function,
    ACTIONS(2954), 1,
      anon_sym_declare,
    ACTIONS(2956), 1,
      anon_sym_module,
    ACTIONS(2958), 1,
      anon_sym_abstract,
    ACTIONS(2960), 1,
      anon_sym_global,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    STATE(3491), 1,
      sym_comment,
    STATE(4878), 1,
      sym_internal_module,
    STATE(4945), 1,
      sym_declaration,
    STATE(5382), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5171), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [128217] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6885), 1,
      anon_sym_RBRACE,
    STATE(3492), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128278] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6887), 1,
      anon_sym_RBRACE,
    STATE(3493), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128339] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6174), 1,
      anon_sym_static,
    ACTIONS(6176), 1,
      anon_sym_readonly,
    ACTIONS(6178), 1,
      anon_sym_abstract,
    STATE(3494), 1,
      sym_comment,
    STATE(3582), 1,
      sym_override_modifier,
    STATE(4122), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128406] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6889), 1,
      anon_sym_RBRACE,
    STATE(3495), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128467] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6891), 1,
      anon_sym_AT,
    STATE(3557), 1,
      sym_decorator,
    STATE(3496), 2,
      sym_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(4239), 30,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [128516] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6679), 1,
      anon_sym_readonly,
    ACTIONS(6894), 1,
      anon_sym_STAR,
    STATE(3497), 1,
      sym_comment,
    STATE(3520), 1,
      sym_override_modifier,
    STATE(3796), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128583] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_RBRACE,
    STATE(3498), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128644] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2796), 1,
      anon_sym_namespace,
    ACTIONS(2798), 1,
      anon_sym_import,
    ACTIONS(2800), 1,
      anon_sym_var,
    ACTIONS(2802), 1,
      anon_sym_let,
    ACTIONS(2804), 1,
      anon_sym_const,
    ACTIONS(2808), 1,
      anon_sym_class,
    ACTIONS(2810), 1,
      anon_sym_async,
    ACTIONS(2812), 1,
      anon_sym_function,
    ACTIONS(2814), 1,
      anon_sym_declare,
    ACTIONS(2818), 1,
      anon_sym_abstract,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_enum,
    ACTIONS(2928), 1,
      anon_sym_type,
    ACTIONS(2930), 1,
      anon_sym_module,
    ACTIONS(2932), 1,
      anon_sym_global,
    STATE(3499), 1,
      sym_comment,
    STATE(5201), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(6385), 1,
      sym_internal_module,
    STATE(6491), 1,
      sym_declaration,
    STATE(6360), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [128729] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6900), 1,
      anon_sym_RBRACE,
    STATE(3500), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128790] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6902), 1,
      anon_sym_RBRACE,
    STATE(3501), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128851] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6904), 1,
      anon_sym_RBRACE,
    STATE(3502), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128912] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6906), 1,
      anon_sym_RBRACE,
    STATE(3503), 1,
      sym_comment,
    STATE(5279), 1,
      sym__property_name,
    STATE(6012), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128973] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2834), 1,
      anon_sym_namespace,
    ACTIONS(2836), 1,
      anon_sym_import,
    ACTIONS(2838), 1,
      anon_sym_var,
    ACTIONS(2840), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_const,
    ACTIONS(2846), 1,
      anon_sym_class,
    ACTIONS(2848), 1,
      anon_sym_async,
    ACTIONS(2850), 1,
      anon_sym_function,
    ACTIONS(2852), 1,
      anon_sym_declare,
    ACTIONS(2854), 1,
      anon_sym_module,
    ACTIONS(2856), 1,
      anon_sym_abstract,
    ACTIONS(2858), 1,
      anon_sym_interface,
    ACTIONS(2860), 1,
      anon_sym_enum,
    ACTIONS(2916), 1,
      anon_sym_type,
    ACTIONS(6908), 1,
      anon_sym_default,
    STATE(1022), 1,
      sym_declaration,
    STATE(1094), 1,
      sym_internal_module,
    STATE(3504), 1,
      sym_comment,
    STATE(4991), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(1100), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [129058] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6910), 1,
      anon_sym_RBRACE,
    STATE(3505), 1,
      sym_comment,
    STATE(5313), 1,
      sym__property_name,
    STATE(6323), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129119] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2796), 1,
      anon_sym_namespace,
    ACTIONS(2798), 1,
      anon_sym_import,
    ACTIONS(2800), 1,
      anon_sym_var,
    ACTIONS(2802), 1,
      anon_sym_let,
    ACTIONS(2804), 1,
      anon_sym_const,
    ACTIONS(2808), 1,
      anon_sym_class,
    ACTIONS(2810), 1,
      anon_sym_async,
    ACTIONS(2812), 1,
      anon_sym_function,
    ACTIONS(2814), 1,
      anon_sym_declare,
    ACTIONS(2816), 1,
      anon_sym_module,
    ACTIONS(2818), 1,
      anon_sym_abstract,
    ACTIONS(2820), 1,
      anon_sym_interface,
    ACTIONS(2822), 1,
      anon_sym_enum,
    ACTIONS(2928), 1,
      anon_sym_type,
    ACTIONS(6912), 1,
      anon_sym_default,
    STATE(3506), 1,
      sym_comment,
    STATE(5201), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(6385), 1,
      sym_internal_module,
    STATE(6982), 1,
      sym_declaration,
    STATE(6360), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [129204] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6914), 1,
      anon_sym_RBRACE,
    STATE(3507), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129265] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(4400), 1,
      anon_sym_override,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6200), 1,
      anon_sym_STAR,
    ACTIONS(6202), 1,
      anon_sym_async,
    ACTIONS(6204), 1,
      anon_sym_readonly,
    ACTIONS(6916), 1,
      anon_sym_static,
    STATE(3508), 1,
      sym_comment,
    STATE(3534), 1,
      sym_override_modifier,
    STATE(3863), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6206), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129336] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6918), 1,
      anon_sym_RBRACE,
    STATE(3509), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129397] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(2834), 1,
      anon_sym_namespace,
    ACTIONS(2836), 1,
      anon_sym_import,
    ACTIONS(2838), 1,
      anon_sym_var,
    ACTIONS(2840), 1,
      anon_sym_let,
    ACTIONS(2842), 1,
      anon_sym_const,
    ACTIONS(2846), 1,
      anon_sym_class,
    ACTIONS(2848), 1,
      anon_sym_async,
    ACTIONS(2850), 1,
      anon_sym_function,
    ACTIONS(2852), 1,
      anon_sym_declare,
    ACTIONS(2856), 1,
      anon_sym_abstract,
    ACTIONS(2858), 1,
      anon_sym_interface,
    ACTIONS(2860), 1,
      anon_sym_enum,
    ACTIONS(2916), 1,
      anon_sym_type,
    ACTIONS(2918), 1,
      anon_sym_module,
    ACTIONS(2920), 1,
      anon_sym_global,
    STATE(1086), 1,
      sym_declaration,
    STATE(1094), 1,
      sym_internal_module,
    STATE(3510), 1,
      sym_comment,
    STATE(4991), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(1100), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [129482] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6920), 1,
      anon_sym_RBRACE,
    STATE(3511), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129543] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6922), 1,
      anon_sym_RBRACE,
    STATE(3512), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129604] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6924), 1,
      anon_sym_RBRACE,
    STATE(3513), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129665] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6926), 1,
      anon_sym_RBRACE,
    STATE(3514), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129726] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6200), 1,
      anon_sym_STAR,
    ACTIONS(6202), 1,
      anon_sym_async,
    ACTIONS(6204), 1,
      anon_sym_readonly,
    STATE(3515), 1,
      sym_comment,
    STATE(3863), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6206), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129790] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6097), 1,
      anon_sym_STAR,
    ACTIONS(6099), 1,
      anon_sym_async,
    ACTIONS(6101), 1,
      anon_sym_readonly,
    STATE(3516), 1,
      sym_comment,
    STATE(3909), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6103), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129854] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6540), 1,
      anon_sym_STAR,
    ACTIONS(6542), 1,
      anon_sym_async,
    ACTIONS(6928), 1,
      anon_sym_readonly,
    STATE(3517), 1,
      sym_comment,
    STATE(3799), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6544), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129918] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3518), 1,
      sym_comment,
    STATE(5555), 1,
      sym__property_name,
    STATE(6757), 1,
      sym_enum_assignment,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129976] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6270), 1,
      anon_sym_STAR,
    ACTIONS(6272), 1,
      anon_sym_async,
    ACTIONS(6930), 1,
      anon_sym_readonly,
    STATE(3519), 1,
      sym_comment,
    STATE(3838), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6274), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130040] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6932), 1,
      anon_sym_STAR,
    STATE(3520), 1,
      sym_comment,
    STATE(4641), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6934), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130100] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6157), 1,
      anon_sym_STAR,
    ACTIONS(6159), 1,
      anon_sym_async,
    ACTIONS(6936), 1,
      anon_sym_readonly,
    STATE(3521), 1,
      sym_comment,
    STATE(3826), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6161), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130164] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6894), 1,
      anon_sym_STAR,
    STATE(3522), 1,
      sym_comment,
    STATE(4726), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6938), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130224] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6183), 1,
      anon_sym_STAR,
    ACTIONS(6185), 1,
      anon_sym_async,
    ACTIONS(6193), 1,
      anon_sym_readonly,
    STATE(3523), 1,
      sym_comment,
    STATE(3794), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6187), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130288] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6011), 1,
      anon_sym_STAR,
    ACTIONS(6013), 1,
      anon_sym_async,
    ACTIONS(6940), 1,
      anon_sym_readonly,
    STATE(3524), 1,
      sym_comment,
    STATE(3795), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6017), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130352] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6785), 1,
      anon_sym_STAR,
    ACTIONS(6787), 1,
      anon_sym_async,
    ACTIONS(6942), 1,
      anon_sym_readonly,
    STATE(3525), 1,
      sym_comment,
    STATE(4758), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6789), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130416] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5132), 1,
      anon_sym_STAR,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5144), 1,
      anon_sym_async,
    ACTIONS(5146), 1,
      anon_sym_readonly,
    STATE(3526), 1,
      sym_comment,
    STATE(3892), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5148), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130480] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6344), 1,
      anon_sym_STAR,
    ACTIONS(6346), 1,
      anon_sym_async,
    ACTIONS(6944), 1,
      anon_sym_readonly,
    STATE(3527), 1,
      sym_comment,
    STATE(3815), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6348), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130544] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(5371), 1,
      anon_sym_STAR,
    ACTIONS(5375), 1,
      anon_sym_async,
    ACTIONS(5377), 1,
      anon_sym_readonly,
    STATE(3528), 1,
      sym_comment,
    STATE(3819), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130608] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6332), 1,
      anon_sym_STAR,
    ACTIONS(6334), 1,
      anon_sym_async,
    ACTIONS(6946), 1,
      anon_sym_readonly,
    STATE(3529), 1,
      sym_comment,
    STATE(3861), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6336), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130672] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(2902), 1,
      anon_sym_async,
    ACTIONS(2904), 1,
      anon_sym_readonly,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(5985), 1,
      anon_sym_STAR,
    STATE(3530), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2906), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130736] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    ACTIONS(6754), 1,
      anon_sym_STAR,
    ACTIONS(6756), 1,
      anon_sym_async,
    ACTIONS(6758), 1,
      anon_sym_readonly,
    STATE(3531), 1,
      sym_comment,
    STATE(4826), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6760), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130800] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3532), 1,
      sym_comment,
    ACTIONS(987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2405), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130846] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6011), 1,
      anon_sym_STAR,
    ACTIONS(6013), 1,
      anon_sym_async,
    ACTIONS(6948), 1,
      anon_sym_readonly,
    STATE(3533), 1,
      sym_comment,
    STATE(3813), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6017), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130910] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6043), 1,
      anon_sym_STAR,
    ACTIONS(6045), 1,
      anon_sym_async,
    ACTIONS(6047), 1,
      anon_sym_readonly,
    STATE(3534), 1,
      sym_comment,
    STATE(3872), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6049), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130974] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3535), 1,
      sym_comment,
    STATE(4820), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131029] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3536), 1,
      sym_comment,
    STATE(4821), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131084] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3537), 1,
      sym_comment,
    STATE(4702), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131139] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3538), 1,
      sym_comment,
    STATE(4715), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131194] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3539), 1,
      sym_comment,
    STATE(4736), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131249] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6950), 1,
      anon_sym_readonly,
    STATE(3540), 1,
      sym_comment,
    STATE(4236), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131306] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6952), 1,
      anon_sym_readonly,
    STATE(3541), 1,
      sym_comment,
    STATE(4283), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131363] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3542), 1,
      sym_comment,
    STATE(4675), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131418] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3543), 1,
      sym_comment,
    ACTIONS(4345), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [131461] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3544), 1,
      sym_comment,
    STATE(4618), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131516] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3545), 1,
      sym_comment,
    ACTIONS(4343), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [131559] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3546), 1,
      sym_comment,
    STATE(4673), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131614] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3547), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131669] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3548), 1,
      sym_comment,
    STATE(4803), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131724] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3549), 1,
      sym_comment,
    STATE(4808), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131779] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3550), 1,
      sym_comment,
    STATE(4810), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131834] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3551), 1,
      sym_comment,
    ACTIONS(4349), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [131877] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3552), 1,
      sym_comment,
    STATE(4826), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131932] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3553), 1,
      sym_comment,
    STATE(4801), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131987] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6954), 1,
      anon_sym_readonly,
    STATE(3554), 1,
      sym_comment,
    STATE(4225), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132044] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3555), 1,
      sym_comment,
    STATE(4799), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132099] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3556), 1,
      sym_comment,
    STATE(4701), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132154] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3557), 1,
      sym_comment,
    ACTIONS(4347), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [132197] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3558), 1,
      sym_comment,
    STATE(4784), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132252] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3559), 1,
      sym_comment,
    STATE(4731), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132307] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3560), 1,
      sym_comment,
    STATE(4696), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132362] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6956), 1,
      anon_sym_readonly,
    STATE(3561), 1,
      sym_comment,
    STATE(4159), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132419] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3562), 1,
      sym_comment,
    STATE(4158), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132474] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6958), 1,
      anon_sym_readonly,
    STATE(3563), 1,
      sym_comment,
    STATE(4221), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132531] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3564), 1,
      sym_comment,
    STATE(4122), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132586] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3565), 1,
      sym_comment,
    STATE(4816), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132641] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3566), 1,
      sym_comment,
    STATE(4216), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132696] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6679), 1,
      anon_sym_readonly,
    STATE(3567), 1,
      sym_comment,
    STATE(4122), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132753] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3568), 1,
      sym_comment,
    STATE(4726), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132808] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3569), 1,
      sym_comment,
    STATE(4758), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132863] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3570), 1,
      sym_comment,
    STATE(4282), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132918] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6960), 1,
      anon_sym_readonly,
    STATE(3571), 1,
      sym_comment,
    STATE(4191), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132975] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3572), 1,
      sym_comment,
    STATE(4822), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133030] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3573), 1,
      sym_comment,
    STATE(4117), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133085] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6962), 1,
      anon_sym_readonly,
    STATE(3574), 1,
      sym_comment,
    STATE(4094), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133142] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3575), 1,
      sym_comment,
    STATE(4092), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133197] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3576), 1,
      sym_comment,
    STATE(4641), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133252] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6964), 1,
      anon_sym_readonly,
    STATE(3577), 1,
      sym_comment,
    STATE(4194), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133309] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3578), 1,
      sym_comment,
    STATE(4823), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133364] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3579), 1,
      sym_comment,
    STATE(4692), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133419] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6966), 1,
      anon_sym_readonly,
    STATE(3580), 1,
      sym_comment,
    STATE(4126), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133476] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    STATE(3581), 1,
      sym_comment,
    STATE(4289), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133531] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6685), 1,
      anon_sym_readonly,
    STATE(3582), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133588] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3583), 1,
      sym_comment,
    STATE(4843), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133643] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3584), 1,
      sym_comment,
    STATE(4690), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133698] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6968), 1,
      anon_sym_readonly,
    STATE(3585), 1,
      sym_comment,
    STATE(4289), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133755] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6970), 1,
      anon_sym_readonly,
    STATE(3586), 1,
      sym_comment,
    STATE(4201), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133812] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3587), 1,
      sym_comment,
    STATE(4653), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133867] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3588), 1,
      sym_comment,
    STATE(4749), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133922] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3589), 1,
      sym_comment,
    STATE(4651), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133977] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(5142), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_readonly,
    STATE(3590), 1,
      sym_comment,
    STATE(4189), 1,
      sym__property_name,
    ACTIONS(3898), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3980), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4376), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134034] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3591), 1,
      sym_comment,
    STATE(4720), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134089] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3592), 1,
      sym_comment,
    STATE(4662), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134144] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(5440), 1,
      anon_sym_LBRACK,
    STATE(3593), 1,
      sym_comment,
    STATE(4779), 1,
      sym__property_name,
    ACTIONS(2734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4582), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2900), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134199] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3594), 1,
      sym_comment,
    ACTIONS(4326), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [134242] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3595), 1,
      sym_comment,
    ACTIONS(4247), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [134285] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6974), 1,
      sym_identifier,
    STATE(3596), 1,
      sym_comment,
    STATE(7124), 1,
      sym_mapped_type_clause,
    ACTIONS(6976), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134325] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3597), 1,
      sym_comment,
    ACTIONS(4345), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4839), 19,
      anon_sym_export,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
  [134360] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(4149), 1,
      anon_sym_DOT,
    ACTIONS(4153), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6978), 1,
      anon_sym_LT,
    STATE(3598), 1,
      sym_comment,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    ACTIONS(4147), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4143), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [134407] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(6978), 1,
      anon_sym_LT,
    ACTIONS(6980), 1,
      anon_sym_DOT,
    ACTIONS(6982), 1,
      anon_sym_QMARK_DOT,
    STATE(3599), 1,
      sym_comment,
    STATE(3649), 1,
      sym_arguments,
    STATE(3718), 1,
      sym_type_arguments,
    ACTIONS(4833), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4835), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [134454] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(6978), 1,
      anon_sym_LT,
    ACTIONS(6984), 1,
      anon_sym_DOT,
    ACTIONS(6986), 1,
      anon_sym_QMARK_DOT,
    STATE(3600), 1,
      sym_comment,
    STATE(3659), 1,
      sym_arguments,
    STATE(3720), 1,
      sym_type_arguments,
    ACTIONS(4813), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4815), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [134501] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3601), 1,
      sym_comment,
    ACTIONS(4349), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4869), 19,
      anon_sym_export,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
  [134536] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3602), 1,
      sym_comment,
    ACTIONS(4343), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4867), 19,
      anon_sym_export,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
  [134571] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2251), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3603), 1,
      sym_comment,
    ACTIONS(2253), 19,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
  [134605] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2183), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3604), 1,
      sym_comment,
    ACTIONS(2185), 19,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
  [134639] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3605), 1,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5023), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [134672] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3606), 1,
      sym_comment,
    ACTIONS(4877), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4879), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [134705] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3607), 1,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5023), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [134738] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4807), 1,
      anon_sym_EQ,
    ACTIONS(6978), 1,
      anon_sym_LT,
    ACTIONS(6988), 1,
      anon_sym_DOT,
    ACTIONS(6990), 1,
      anon_sym_is,
    STATE(3608), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4202), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [134779] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3609), 1,
      sym_comment,
    ACTIONS(5033), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5035), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [134812] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3610), 1,
      sym_comment,
    ACTIONS(5094), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5096), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [134845] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3611), 1,
      sym_comment,
    ACTIONS(5033), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5035), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [134878] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3612), 1,
      sym_comment,
    ACTIONS(5033), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5035), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [134911] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3613), 1,
      sym_comment,
    ACTIONS(5037), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5039), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [134944] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3614), 1,
      sym_comment,
    ACTIONS(5098), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5100), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [134977] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3615), 1,
      sym_comment,
    ACTIONS(5094), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5096), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135010] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3616), 1,
      sym_comment,
    ACTIONS(5098), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5100), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135043] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3617), 1,
      sym_comment,
    ACTIONS(5017), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5019), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135076] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3618), 1,
      sym_comment,
    ACTIONS(5102), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5104), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135109] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3619), 1,
      sym_comment,
    ACTIONS(5017), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5019), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135142] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3620), 1,
      sym_comment,
    ACTIONS(5017), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5019), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135175] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3621), 1,
      sym_comment,
    ACTIONS(5110), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5112), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135208] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3622), 1,
      sym_comment,
    ACTIONS(5102), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5104), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135241] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3623), 1,
      sym_comment,
    ACTIONS(5110), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5112), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135274] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3624), 1,
      sym_comment,
    ACTIONS(5124), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5126), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135307] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3625), 1,
      sym_comment,
    ACTIONS(5128), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5130), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135340] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3626), 1,
      sym_comment,
    ACTIONS(5021), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5023), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135373] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3627), 1,
      sym_comment,
    ACTIONS(5124), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5126), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135406] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3628), 1,
      sym_comment,
    ACTIONS(5128), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5130), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135439] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3629), 1,
      sym_comment,
    ACTIONS(5246), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5248), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135472] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3630), 1,
      sym_comment,
    ACTIONS(5158), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5160), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135505] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3631), 1,
      sym_comment,
    ACTIONS(5166), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5168), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135538] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3632), 1,
      sym_comment,
    ACTIONS(5246), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5248), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135571] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3633), 1,
      sym_comment,
    ACTIONS(5246), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5248), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135604] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3634), 1,
      sym_comment,
    ACTIONS(5162), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5164), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135637] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3635), 1,
      sym_comment,
    ACTIONS(5162), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5164), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135670] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3636), 1,
      sym_comment,
    ACTIONS(4964), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4966), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135703] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3637), 1,
      sym_comment,
    ACTIONS(5162), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5164), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135736] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3638), 1,
      sym_comment,
    ACTIONS(4877), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4879), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135769] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3639), 1,
      sym_comment,
    ACTIONS(4877), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4879), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [135802] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6992), 1,
      sym_identifier,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6996), 1,
      anon_sym_type,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7000), 1,
      anon_sym_typeof,
    STATE(3640), 1,
      sym_comment,
    STATE(5578), 1,
      sym_import_require_clause,
    STATE(5579), 1,
      sym_string,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6676), 1,
      sym_import_clause,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(7002), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [135856] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7004), 1,
      sym_identifier,
    ACTIONS(7006), 1,
      anon_sym_type,
    ACTIONS(7008), 1,
      anon_sym_typeof,
    STATE(3641), 1,
      sym_comment,
    STATE(5436), 1,
      sym_string,
    STATE(5439), 1,
      sym_import_require_clause,
    STATE(6558), 1,
      sym_import_clause,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(7002), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [135910] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7012), 1,
      anon_sym_EQ,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7016), 1,
      anon_sym_COMMA,
    ACTIONS(7018), 1,
      anon_sym_COLON,
    ACTIONS(7020), 1,
      anon_sym_GT,
    ACTIONS(7023), 1,
      anon_sym_DOT,
    ACTIONS(7025), 1,
      anon_sym_SLASH_GT,
    ACTIONS(7027), 1,
      anon_sym_LT,
    ACTIONS(7029), 1,
      anon_sym_extends,
    STATE(3642), 1,
      sym_comment,
    STATE(4281), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4300), 1,
      sym_type_arguments,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    STATE(5617), 1,
      sym_constraint,
    STATE(6886), 1,
      sym_default_type,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [135970] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7031), 1,
      sym_identifier,
    ACTIONS(7033), 1,
      anon_sym_type,
    ACTIONS(7035), 1,
      anon_sym_typeof,
    STATE(3643), 1,
      sym_comment,
    STATE(5413), 1,
      sym_string,
    STATE(5414), 1,
      sym_import_require_clause,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6821), 1,
      sym_import_clause,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(7002), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [136024] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4807), 1,
      anon_sym_EQ,
    ACTIONS(6978), 1,
      anon_sym_LT,
    ACTIONS(6988), 1,
      anon_sym_DOT,
    STATE(3644), 1,
      sym_comment,
    STATE(3786), 1,
      sym_type_arguments,
    ACTIONS(4202), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136062] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7037), 1,
      sym_identifier,
    ACTIONS(7039), 1,
      anon_sym_type,
    ACTIONS(7041), 1,
      anon_sym_typeof,
    STATE(3645), 1,
      sym_comment,
    STATE(5542), 1,
      sym_import_require_clause,
    STATE(5545), 1,
      sym_string,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6918), 1,
      sym_import_clause,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(7002), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [136116] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7043), 1,
      sym_identifier,
    ACTIONS(7045), 1,
      anon_sym_type,
    ACTIONS(7047), 1,
      anon_sym_typeof,
    STATE(3646), 1,
      sym_comment,
    STATE(5526), 1,
      sym_import_require_clause,
    STATE(5569), 1,
      sym_string,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6808), 1,
      sym_import_clause,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(7002), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [136170] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7012), 1,
      anon_sym_EQ,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7016), 1,
      anon_sym_COMMA,
    ACTIONS(7018), 1,
      anon_sym_COLON,
    ACTIONS(7020), 1,
      anon_sym_GT,
    ACTIONS(7023), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_LT,
    ACTIONS(7029), 1,
      anon_sym_extends,
    ACTIONS(7049), 1,
      anon_sym_SLASH_GT,
    STATE(3647), 1,
      sym_comment,
    STATE(4172), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4176), 1,
      sym_type_arguments,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    STATE(5617), 1,
      sym_constraint,
    STATE(6886), 1,
      sym_default_type,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [136230] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4159), 1,
      anon_sym_LPAREN,
    ACTIONS(4813), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_DOT,
    ACTIONS(7053), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7055), 1,
      anon_sym_LT,
    STATE(3648), 1,
      sym_comment,
    STATE(3874), 1,
      sym_arguments,
    STATE(4028), 1,
      sym_type_arguments,
    ACTIONS(4815), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [136273] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3649), 1,
      sym_comment,
    ACTIONS(5202), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5204), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [136304] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5290), 1,
      anon_sym_EQ,
    STATE(3650), 1,
      sym_comment,
    ACTIONS(5292), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136335] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5282), 1,
      anon_sym_EQ,
    STATE(3651), 1,
      sym_comment,
    ACTIONS(5284), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136366] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5106), 1,
      anon_sym_EQ,
    STATE(3652), 1,
      sym_comment,
    ACTIONS(5108), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136397] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5154), 1,
      anon_sym_EQ,
    STATE(3653), 1,
      sym_comment,
    ACTIONS(5156), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136428] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5278), 1,
      anon_sym_EQ,
    STATE(3654), 1,
      sym_comment,
    ACTIONS(5280), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136459] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5154), 1,
      anon_sym_EQ,
    STATE(3655), 1,
      sym_comment,
    ACTIONS(5156), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136490] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7057), 1,
      anon_sym_DOT,
    ACTIONS(7059), 1,
      anon_sym_QMARK_DOT,
    STATE(3656), 1,
      sym_comment,
    ACTIONS(4987), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4989), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [136525] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5210), 1,
      anon_sym_EQ,
    STATE(3657), 1,
      sym_comment,
    ACTIONS(5212), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136556] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3232), 1,
      anon_sym_EQ,
    STATE(3658), 1,
      sym_comment,
    ACTIONS(3506), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136587] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3659), 1,
      sym_comment,
    ACTIONS(5216), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5218), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [136618] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2183), 1,
      anon_sym_PIPE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3660), 1,
      sym_comment,
    ACTIONS(2185), 16,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_with,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [136649] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5106), 1,
      anon_sym_EQ,
    STATE(3661), 1,
      sym_comment,
    ACTIONS(5108), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136680] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4855), 1,
      anon_sym_EQ,
    ACTIONS(6978), 1,
      anon_sym_LT,
    STATE(3662), 1,
      sym_comment,
    STATE(3690), 1,
      sym_type_arguments,
    ACTIONS(4857), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136715] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2239), 1,
      anon_sym_DOT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5254), 1,
      anon_sym_EQ,
    STATE(3663), 1,
      sym_comment,
    ACTIONS(5256), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
  [136748] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2235), 1,
      anon_sym_DOT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5254), 1,
      anon_sym_EQ,
    STATE(3664), 1,
      sym_comment,
    ACTIONS(5256), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
  [136781] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4159), 1,
      anon_sym_LPAREN,
    ACTIONS(4833), 1,
      anon_sym_PIPE,
    ACTIONS(7055), 1,
      anon_sym_LT,
    ACTIONS(7061), 1,
      anon_sym_DOT,
    ACTIONS(7063), 1,
      anon_sym_QMARK_DOT,
    STATE(3665), 1,
      sym_comment,
    STATE(3877), 1,
      sym_arguments,
    STATE(4026), 1,
      sym_type_arguments,
    ACTIONS(4835), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [136824] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3666), 1,
      sym_comment,
    ACTIONS(5176), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5178), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [136855] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3228), 1,
      anon_sym_EQ,
    STATE(3667), 1,
      sym_comment,
    ACTIONS(3518), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136886] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5349), 1,
      anon_sym_EQ,
    STATE(3668), 1,
      sym_comment,
    ACTIONS(5351), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136917] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3230), 1,
      anon_sym_EQ,
    STATE(3669), 1,
      sym_comment,
    ACTIONS(3508), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136948] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5353), 1,
      anon_sym_EQ,
    STATE(3670), 1,
      sym_comment,
    ACTIONS(5355), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [136979] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5357), 1,
      anon_sym_EQ,
    STATE(3671), 1,
      sym_comment,
    ACTIONS(5359), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137010] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4147), 1,
      anon_sym_PIPE,
    ACTIONS(4159), 1,
      anon_sym_LPAREN,
    ACTIONS(4161), 1,
      anon_sym_DOT,
    ACTIONS(4163), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7055), 1,
      anon_sym_LT,
    STATE(3672), 1,
      sym_comment,
    STATE(3879), 1,
      sym_arguments,
    STATE(4025), 1,
      sym_type_arguments,
    ACTIONS(4143), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [137053] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3222), 1,
      anon_sym_EQ,
    STATE(3673), 1,
      sym_comment,
    ACTIONS(3540), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137084] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2251), 1,
      anon_sym_PIPE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3674), 1,
      sym_comment,
    ACTIONS(2253), 16,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_with,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [137115] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3236), 1,
      anon_sym_EQ,
    STATE(3675), 1,
      sym_comment,
    ACTIONS(3570), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137146] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4841), 1,
      anon_sym_EQ,
    ACTIONS(6990), 1,
      anon_sym_is,
    STATE(3676), 1,
      sym_comment,
    ACTIONS(4843), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137178] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4845), 1,
      anon_sym_EQ,
    STATE(3677), 1,
      sym_comment,
    ACTIONS(4847), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_is,
  [137208] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4871), 1,
      anon_sym_EQ,
    ACTIONS(6990), 1,
      anon_sym_is,
    STATE(3678), 1,
      sym_comment,
    ACTIONS(4873), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137240] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1972), 1,
      anon_sym_EQ,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3679), 1,
      sym_comment,
    ACTIONS(2030), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_is,
  [137270] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4855), 1,
      anon_sym_EQ,
    ACTIONS(7065), 1,
      anon_sym_is,
    STATE(3680), 1,
      sym_comment,
    ACTIONS(4857), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137302] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4881), 1,
      anon_sym_EQ,
    ACTIONS(7067), 1,
      anon_sym_LBRACK,
    STATE(3681), 1,
      sym_comment,
    ACTIONS(4883), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137333] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5166), 1,
      anon_sym_PIPE,
    STATE(3682), 1,
      sym_comment,
    ACTIONS(5168), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [137362] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5005), 1,
      anon_sym_EQ,
    STATE(3683), 1,
      sym_comment,
    ACTIONS(5007), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137391] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5060), 1,
      anon_sym_EQ,
    STATE(3684), 1,
      sym_comment,
    ACTIONS(5062), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137420] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5060), 1,
      anon_sym_EQ,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(3685), 1,
      sym_comment,
    ACTIONS(5062), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [137455] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7075), 1,
      anon_sym_LPAREN,
    ACTIONS(7077), 1,
      anon_sym_DOT,
    ACTIONS(7079), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7081), 1,
      anon_sym_LT,
    STATE(3686), 1,
      sym_comment,
    STATE(4001), 1,
      sym_arguments,
    STATE(4124), 1,
      sym_type_arguments,
    ACTIONS(4815), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [137494] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7075), 1,
      anon_sym_LPAREN,
    ACTIONS(7081), 1,
      anon_sym_LT,
    ACTIONS(7083), 1,
      anon_sym_DOT,
    ACTIONS(7085), 1,
      anon_sym_QMARK_DOT,
    STATE(3687), 1,
      sym_comment,
    STATE(4007), 1,
      sym_arguments,
    STATE(4129), 1,
      sym_type_arguments,
    ACTIONS(4835), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [137533] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5086), 1,
      anon_sym_EQ,
    STATE(3688), 1,
      sym_comment,
    ACTIONS(5088), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137562] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5090), 1,
      anon_sym_EQ,
    STATE(3689), 1,
      sym_comment,
    ACTIONS(5092), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137591] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5150), 1,
      anon_sym_EQ,
    STATE(3690), 1,
      sym_comment,
    ACTIONS(5152), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137620] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7093), 1,
      sym_number,
    ACTIONS(7095), 1,
      anon_sym_unique,
    STATE(3691), 1,
      sym_comment,
    STATE(7179), 1,
      sym_predefined_type,
    STATE(7183), 1,
      sym_string,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [137659] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5120), 1,
      anon_sym_EQ,
    ACTIONS(7067), 1,
      anon_sym_LBRACK,
    STATE(3692), 1,
      sym_comment,
    ACTIONS(5122), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [137690] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5114), 1,
      anon_sym_EQ,
    ACTIONS(7097), 1,
      anon_sym_extends,
    STATE(3693), 1,
      sym_comment,
    ACTIONS(5116), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [137721] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7099), 1,
      sym_number,
    STATE(3694), 1,
      sym_comment,
    STATE(7470), 1,
      sym_predefined_type,
    STATE(7473), 1,
      sym_string,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [137760] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7101), 1,
      sym_number,
    STATE(3695), 1,
      sym_comment,
    STATE(7115), 1,
      sym_string,
    STATE(7117), 1,
      sym_predefined_type,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [137799] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7103), 1,
      sym_number,
    STATE(3696), 1,
      sym_comment,
    STATE(7047), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [137836] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7105), 1,
      sym_number,
    STATE(3697), 1,
      sym_comment,
    STATE(7110), 1,
      sym_string,
    STATE(7111), 1,
      sym_predefined_type,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [137875] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7107), 1,
      sym_number,
    STATE(3698), 1,
      sym_comment,
    STATE(7072), 1,
      sym_string,
    STATE(7107), 1,
      sym_predefined_type,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [137914] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5082), 1,
      anon_sym_EQ,
    ACTIONS(7067), 1,
      anon_sym_LBRACK,
    STATE(3699), 1,
      sym_comment,
    ACTIONS(4883), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(5084), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [137947] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7109), 1,
      sym_number,
    STATE(3700), 1,
      sym_comment,
    STATE(7188), 1,
      sym_predefined_type,
    STATE(7190), 1,
      sym_string,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [137986] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5074), 1,
      anon_sym_EQ,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(3701), 1,
      sym_comment,
    ACTIONS(5076), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [138021] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3702), 1,
      sym_comment,
    ACTIONS(7111), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [138048] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7113), 1,
      sym_number,
    STATE(3703), 1,
      sym_comment,
    STATE(7093), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [138085] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7115), 1,
      sym_number,
    STATE(3704), 1,
      sym_comment,
    STATE(7374), 1,
      sym_string,
    STATE(7478), 1,
      sym_predefined_type,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [138124] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5025), 1,
      anon_sym_EQ,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    STATE(3705), 1,
      sym_comment,
    ACTIONS(5027), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138155] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7117), 1,
      sym_number,
    STATE(3706), 1,
      sym_comment,
    STATE(7460), 1,
      sym_predefined_type,
    STATE(7463), 1,
      sym_string,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [138194] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7075), 1,
      anon_sym_LPAREN,
    ACTIONS(7081), 1,
      anon_sym_LT,
    ACTIONS(7119), 1,
      anon_sym_DOT,
    ACTIONS(7121), 1,
      anon_sym_QMARK_DOT,
    STATE(3707), 1,
      sym_comment,
    STATE(4009), 1,
      sym_arguments,
    STATE(4133), 1,
      sym_type_arguments,
    ACTIONS(4143), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [138233] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5078), 1,
      anon_sym_EQ,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(3708), 1,
      sym_comment,
    ACTIONS(5080), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [138268] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3709), 1,
      sym_comment,
    ACTIONS(7123), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [138295] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5041), 1,
      anon_sym_EQ,
    STATE(3710), 1,
      sym_comment,
    ACTIONS(5043), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138324] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3711), 1,
      sym_comment,
    ACTIONS(7125), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [138351] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3712), 1,
      sym_comment,
    ACTIONS(7127), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [138378] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5198), 1,
      anon_sym_EQ,
    STATE(3713), 1,
      sym_comment,
    ACTIONS(5200), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138407] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3714), 1,
      sym_comment,
    ACTIONS(7129), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [138434] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7131), 1,
      sym_number,
    STATE(3715), 1,
      sym_comment,
    STATE(7199), 1,
      sym_predefined_type,
    STATE(7212), 1,
      sym_string,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [138473] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7133), 1,
      sym_number,
    STATE(3716), 1,
      sym_comment,
    STATE(7257), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [138510] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5001), 1,
      anon_sym_EQ,
    STATE(3717), 1,
      sym_comment,
    ACTIONS(5003), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138539] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5206), 1,
      anon_sym_EQ,
    STATE(3718), 1,
      sym_comment,
    ACTIONS(5208), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138568] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5070), 1,
      anon_sym_EQ,
    STATE(3719), 1,
      sym_comment,
    ACTIONS(5072), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138597] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5220), 1,
      anon_sym_EQ,
    STATE(3720), 1,
      sym_comment,
    ACTIONS(5222), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138626] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3721), 1,
      sym_comment,
    ACTIONS(7135), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [138653] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4997), 1,
      anon_sym_EQ,
    STATE(3722), 1,
      sym_comment,
    ACTIONS(4999), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138682] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7137), 1,
      sym_number,
    STATE(3723), 1,
      sym_comment,
    STATE(7141), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [138719] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7139), 1,
      sym_number,
    STATE(3724), 1,
      sym_comment,
    STATE(7134), 1,
      sym_predefined_type,
    STATE(7139), 1,
      sym_string,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [138758] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5236), 1,
      anon_sym_EQ,
    STATE(3725), 1,
      sym_comment,
    ACTIONS(5238), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138787] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5240), 1,
      anon_sym_EQ,
    STATE(3726), 1,
      sym_comment,
    ACTIONS(5242), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138816] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5228), 1,
      anon_sym_EQ,
    STATE(3727), 1,
      sym_comment,
    ACTIONS(5230), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138845] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5310), 1,
      anon_sym_EQ,
    STATE(3728), 1,
      sym_comment,
    ACTIONS(5312), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138874] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5029), 1,
      anon_sym_EQ,
    STATE(3729), 1,
      sym_comment,
    ACTIONS(5031), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138903] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5266), 1,
      anon_sym_EQ,
    STATE(3730), 1,
      sym_comment,
    ACTIONS(5268), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138932] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5266), 1,
      anon_sym_EQ,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(3731), 1,
      sym_comment,
    ACTIONS(5268), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [138967] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5286), 1,
      anon_sym_EQ,
    STATE(3732), 1,
      sym_comment,
    ACTIONS(5288), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [138996] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7141), 1,
      sym_number,
    STATE(3733), 1,
      sym_comment,
    STATE(7125), 1,
      sym_predefined_type,
    STATE(7132), 1,
      sym_string,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [139035] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5294), 1,
      anon_sym_EQ,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    STATE(3734), 1,
      sym_comment,
    ACTIONS(5296), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [139066] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5304), 1,
      anon_sym_EQ,
    STATE(3735), 1,
      sym_comment,
    ACTIONS(5306), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [139095] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5162), 1,
      anon_sym_PIPE,
    STATE(3736), 1,
      sym_comment,
    ACTIONS(5164), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139124] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5158), 1,
      anon_sym_PIPE,
    STATE(3737), 1,
      sym_comment,
    ACTIONS(5160), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139153] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5128), 1,
      anon_sym_PIPE,
    STATE(3738), 1,
      sym_comment,
    ACTIONS(5130), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139182] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5124), 1,
      anon_sym_PIPE,
    STATE(3739), 1,
      sym_comment,
    ACTIONS(5126), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139211] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5128), 1,
      anon_sym_PIPE,
    STATE(3740), 1,
      sym_comment,
    ACTIONS(5130), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139240] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5124), 1,
      anon_sym_PIPE,
    STATE(3741), 1,
      sym_comment,
    ACTIONS(5126), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139269] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5110), 1,
      anon_sym_PIPE,
    STATE(3742), 1,
      sym_comment,
    ACTIONS(5112), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139298] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5102), 1,
      anon_sym_PIPE,
    STATE(3743), 1,
      sym_comment,
    ACTIONS(5104), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139327] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5110), 1,
      anon_sym_PIPE,
    STATE(3744), 1,
      sym_comment,
    ACTIONS(5112), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139356] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5102), 1,
      anon_sym_PIPE,
    STATE(3745), 1,
      sym_comment,
    ACTIONS(5104), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139385] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5098), 1,
      anon_sym_PIPE,
    STATE(3746), 1,
      sym_comment,
    ACTIONS(5100), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139414] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5094), 1,
      anon_sym_PIPE,
    STATE(3747), 1,
      sym_comment,
    ACTIONS(5096), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139443] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5098), 1,
      anon_sym_PIPE,
    STATE(3748), 1,
      sym_comment,
    ACTIONS(5100), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139472] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5094), 1,
      anon_sym_PIPE,
    STATE(3749), 1,
      sym_comment,
    ACTIONS(5096), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139501] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4972), 1,
      anon_sym_EQ,
    STATE(3750), 1,
      sym_comment,
    ACTIONS(4974), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [139530] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7143), 1,
      sym_number,
    STATE(3751), 1,
      sym_comment,
    STATE(7118), 1,
      sym_predefined_type,
    STATE(7119), 1,
      sym_string,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [139569] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5246), 1,
      anon_sym_PIPE,
    STATE(3752), 1,
      sym_comment,
    ACTIONS(5248), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139598] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4855), 1,
      anon_sym_EQ,
    STATE(3753), 1,
      sym_comment,
    ACTIONS(4857), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [139627] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5246), 1,
      anon_sym_PIPE,
    STATE(3754), 1,
      sym_comment,
    ACTIONS(5248), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139656] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5246), 1,
      anon_sym_PIPE,
    STATE(3755), 1,
      sym_comment,
    ACTIONS(5248), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139685] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5162), 1,
      anon_sym_PIPE,
    STATE(3756), 1,
      sym_comment,
    ACTIONS(5164), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139714] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4807), 1,
      anon_sym_PIPE,
    ACTIONS(7055), 1,
      anon_sym_LT,
    ACTIONS(7145), 1,
      anon_sym_DOT,
    ACTIONS(7147), 1,
      anon_sym_is,
    STATE(3757), 1,
      sym_comment,
    STATE(4022), 1,
      sym_type_arguments,
    ACTIONS(4202), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [139751] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5188), 1,
      anon_sym_EQ,
    STATE(3758), 1,
      sym_comment,
    ACTIONS(5190), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [139780] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4841), 1,
      anon_sym_EQ,
    STATE(3759), 1,
      sym_comment,
    ACTIONS(4843), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [139809] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7149), 1,
      sym_number,
    STATE(3760), 1,
      sym_comment,
    STATE(7210), 1,
      sym_predefined_type,
    STATE(7213), 1,
      sym_string,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [139848] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7151), 1,
      sym_number,
    STATE(3761), 1,
      sym_comment,
    STATE(7219), 1,
      sym_predefined_type,
    STATE(7224), 1,
      sym_string,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [139887] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7153), 1,
      sym_number,
    STATE(3762), 1,
      sym_comment,
    STATE(7226), 1,
      sym_predefined_type,
    STATE(7228), 1,
      sym_string,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [139926] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4881), 1,
      anon_sym_EQ,
    STATE(3763), 1,
      sym_comment,
    ACTIONS(4883), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [139955] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4871), 1,
      anon_sym_EQ,
    STATE(3764), 1,
      sym_comment,
    ACTIONS(4873), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [139984] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5332), 1,
      anon_sym_EQ,
    STATE(3765), 1,
      sym_comment,
    ACTIONS(5334), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140013] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    ACTIONS(7095), 1,
      anon_sym_unique,
    ACTIONS(7155), 1,
      sym_number,
    STATE(3766), 1,
      sym_comment,
    STATE(7232), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(7091), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [140050] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5013), 1,
      anon_sym_EQ,
    STATE(3767), 1,
      sym_comment,
    ACTIONS(5015), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140079] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5009), 1,
      anon_sym_EQ,
    STATE(3768), 1,
      sym_comment,
    ACTIONS(5011), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140108] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4993), 1,
      anon_sym_EQ,
    STATE(3769), 1,
      sym_comment,
    ACTIONS(4995), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140137] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3770), 1,
      sym_comment,
    ACTIONS(7157), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [140164] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3771), 1,
      sym_comment,
    ACTIONS(7159), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [140191] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    STATE(3772), 1,
      sym_comment,
    ACTIONS(5039), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140220] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    STATE(3773), 1,
      sym_comment,
    ACTIONS(5035), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140249] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    STATE(3774), 1,
      sym_comment,
    ACTIONS(5035), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140278] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    STATE(3775), 1,
      sym_comment,
    ACTIONS(5035), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140307] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5021), 1,
      anon_sym_PIPE,
    STATE(3776), 1,
      sym_comment,
    ACTIONS(5023), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140336] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5021), 1,
      anon_sym_PIPE,
    STATE(3777), 1,
      sym_comment,
    ACTIONS(5023), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140365] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5021), 1,
      anon_sym_PIPE,
    STATE(3778), 1,
      sym_comment,
    ACTIONS(5023), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140394] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5017), 1,
      anon_sym_PIPE,
    STATE(3779), 1,
      sym_comment,
    ACTIONS(5019), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140423] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5017), 1,
      anon_sym_PIPE,
    STATE(3780), 1,
      sym_comment,
    ACTIONS(5019), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140452] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5017), 1,
      anon_sym_PIPE,
    STATE(3781), 1,
      sym_comment,
    ACTIONS(5019), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140481] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3782), 1,
      sym_comment,
    ACTIONS(7161), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [140508] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5224), 1,
      anon_sym_EQ,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(3783), 1,
      sym_comment,
    ACTIONS(5226), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [140543] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5049), 1,
      anon_sym_EQ,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(3784), 1,
      sym_comment,
    ACTIONS(5051), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [140578] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5045), 1,
      anon_sym_EQ,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(3785), 1,
      sym_comment,
    ACTIONS(5047), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [140613] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5066), 1,
      anon_sym_EQ,
    STATE(3786), 1,
      sym_comment,
    ACTIONS(5068), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140642] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4964), 1,
      anon_sym_PIPE,
    STATE(3787), 1,
      sym_comment,
    ACTIONS(4966), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140671] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4877), 1,
      anon_sym_PIPE,
    STATE(3788), 1,
      sym_comment,
    ACTIONS(4879), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140700] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4877), 1,
      anon_sym_PIPE,
    STATE(3789), 1,
      sym_comment,
    ACTIONS(4879), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140729] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4877), 1,
      anon_sym_PIPE,
    STATE(3790), 1,
      sym_comment,
    ACTIONS(4879), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140758] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5162), 1,
      anon_sym_PIPE,
    STATE(3791), 1,
      sym_comment,
    ACTIONS(5164), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140787] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7167), 1,
      anon_sym_BANG,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7175), 1,
      anon_sym_QMARK,
    STATE(3792), 1,
      sym_comment,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4798), 1,
      sym__call_signature,
    STATE(5090), 1,
      sym_type_annotation,
    STATE(6152), 1,
      sym__initializer,
    STATE(6732), 1,
      sym_type_parameters,
    ACTIONS(7165), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [140835] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_identifier,
    ACTIONS(7179), 1,
      anon_sym_type,
    STATE(3793), 1,
      sym_comment,
    STATE(5505), 1,
      sym_import_require_clause,
    STATE(5506), 1,
      sym_string,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6719), 1,
      sym_import_clause,
    ACTIONS(7181), 2,
      anon_sym_COMMA,
      anon_sym_from,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
  [140883] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7185), 1,
      anon_sym_BANG,
    ACTIONS(7187), 1,
      anon_sym_QMARK,
    STATE(3794), 1,
      sym_comment,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4648), 1,
      sym__call_signature,
    STATE(5112), 1,
      sym_type_annotation,
    STATE(5865), 1,
      sym__initializer,
    STATE(6732), 1,
      sym_type_parameters,
    ACTIONS(7183), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [140931] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7191), 1,
      anon_sym_BANG,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7195), 1,
      anon_sym_QMARK,
    STATE(3795), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5276), 1,
      sym_type_annotation,
    STATE(6009), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6923), 1,
      sym__call_signature,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [140979] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7185), 1,
      anon_sym_BANG,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7199), 1,
      anon_sym_QMARK,
    STATE(3796), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5112), 1,
      sym_type_annotation,
    STATE(5830), 1,
      sym__initializer,
    STATE(5831), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7183), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141027] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7203), 1,
      anon_sym_BANG,
    ACTIONS(7205), 1,
      anon_sym_QMARK,
    STATE(3797), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5078), 1,
      sym_type_annotation,
    STATE(5826), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6704), 1,
      sym__call_signature,
    ACTIONS(7201), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141075] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7207), 1,
      anon_sym_BANG,
    ACTIONS(7209), 1,
      anon_sym_QMARK,
    STATE(3798), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5229), 1,
      sym_type_annotation,
    STATE(5983), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6953), 1,
      sym__call_signature,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141123] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7213), 1,
      anon_sym_BANG,
    ACTIONS(7215), 1,
      anon_sym_QMARK,
    STATE(3799), 1,
      sym_comment,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4669), 1,
      sym__call_signature,
    STATE(5185), 1,
      sym_type_annotation,
    STATE(5950), 1,
      sym__initializer,
    STATE(6732), 1,
      sym_type_parameters,
    ACTIONS(7211), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141171] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_identifier,
    ACTIONS(7179), 1,
      anon_sym_type,
    STATE(3800), 1,
      sym_comment,
    STATE(5409), 1,
      sym_import_require_clause,
    STATE(5628), 1,
      sym_string,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6922), 1,
      sym_import_clause,
    ACTIONS(7181), 2,
      anon_sym_COMMA,
      anon_sym_from,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
  [141219] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(205), 1,
      anon_sym_unique,
    STATE(3801), 1,
      sym_comment,
    STATE(3985), 1,
      sym_type_predicate,
    STATE(7041), 1,
      sym_predefined_type,
    ACTIONS(7217), 2,
      sym_identifier,
      sym_this,
    ACTIONS(207), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [141253] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4525), 1,
      anon_sym_RBRACE,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(3802), 1,
      sym_comment,
    STATE(4457), 1,
      sym_formal_parameters,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    STATE(6477), 1,
      sym_type_parameters,
    ACTIONS(4518), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [141297] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7221), 1,
      anon_sym_BANG,
    ACTIONS(7223), 1,
      anon_sym_QMARK,
    STATE(3803), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5077), 1,
      sym_type_annotation,
    STATE(5820), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6698), 1,
      sym__call_signature,
    ACTIONS(7201), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141345] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_identifier,
    ACTIONS(7179), 1,
      anon_sym_type,
    STATE(3804), 1,
      sym_comment,
    STATE(5431), 1,
      sym_string,
    STATE(5432), 1,
      sym_import_require_clause,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6816), 1,
      sym_import_clause,
    ACTIONS(7181), 2,
      anon_sym_COMMA,
      anon_sym_from,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
  [141393] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4522), 1,
      anon_sym_RBRACE,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(3805), 1,
      sym_comment,
    STATE(4457), 1,
      sym_formal_parameters,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    STATE(6477), 1,
      sym_type_parameters,
    ACTIONS(4518), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [141437] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7227), 1,
      anon_sym_BANG,
    ACTIONS(7229), 1,
      anon_sym_QMARK,
    STATE(3806), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4884), 1,
      sym_type_annotation,
    STATE(5881), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6811), 1,
      sym__call_signature,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141485] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7233), 1,
      anon_sym_BANG,
    ACTIONS(7235), 1,
      anon_sym_QMARK,
    STATE(3807), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5331), 1,
      sym_type_annotation,
    STATE(6294), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6574), 1,
      sym__call_signature,
    ACTIONS(7231), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141533] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4531), 1,
      anon_sym_RBRACE,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(3808), 1,
      sym_comment,
    STATE(4457), 1,
      sym_formal_parameters,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    STATE(6477), 1,
      sym_type_parameters,
    ACTIONS(4518), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [141577] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7237), 1,
      anon_sym_BANG,
    ACTIONS(7239), 1,
      anon_sym_QMARK,
    STATE(3809), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5258), 1,
      sym_type_annotation,
    STATE(6297), 1,
      sym__initializer,
    STATE(6381), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141625] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7241), 1,
      anon_sym_BANG,
    ACTIONS(7243), 1,
      anon_sym_QMARK,
    STATE(3810), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5242), 1,
      sym_type_annotation,
    STATE(6271), 1,
      sym__initializer,
    STATE(6446), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141673] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_identifier,
    ACTIONS(7179), 1,
      anon_sym_type,
    STATE(3811), 1,
      sym_comment,
    STATE(5639), 1,
      sym_import_require_clause,
    STATE(5640), 1,
      sym_string,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6851), 1,
      sym_import_clause,
    ACTIONS(7181), 2,
      anon_sym_COMMA,
      anon_sym_from,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
  [141721] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7247), 1,
      anon_sym_BANG,
    ACTIONS(7249), 1,
      anon_sym_QMARK,
    STATE(3812), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5321), 1,
      sym_type_annotation,
    STATE(6331), 1,
      sym__call_signature,
    STATE(6333), 1,
      sym__initializer,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7245), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141769] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7251), 1,
      anon_sym_BANG,
    ACTIONS(7253), 1,
      anon_sym_QMARK,
    STATE(3813), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5178), 1,
      sym_type_annotation,
    STATE(6203), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6553), 1,
      sym__call_signature,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141817] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7255), 1,
      anon_sym_BANG,
    ACTIONS(7257), 1,
      anon_sym_QMARK,
    STATE(3814), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5152), 1,
      sym_type_annotation,
    STATE(6187), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6593), 1,
      sym__call_signature,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141865] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7259), 1,
      anon_sym_BANG,
    ACTIONS(7261), 1,
      anon_sym_QMARK,
    STATE(3815), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4883), 1,
      sym_type_annotation,
    STATE(5930), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6935), 1,
      sym__call_signature,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [141913] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(205), 1,
      anon_sym_unique,
    STATE(2888), 1,
      sym_type_predicate,
    STATE(3816), 1,
      sym_comment,
    STATE(7327), 1,
      sym_predefined_type,
    ACTIONS(7263), 2,
      sym_identifier,
      sym_this,
    ACTIONS(207), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [141947] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(205), 1,
      anon_sym_unique,
    STATE(3817), 1,
      sym_comment,
    STATE(4100), 1,
      sym_type_predicate,
    STATE(7403), 1,
      sym_predefined_type,
    ACTIONS(7265), 2,
      sym_identifier,
      sym_this,
    ACTIONS(207), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [141981] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7267), 1,
      anon_sym_BANG,
    ACTIONS(7269), 1,
      anon_sym_QMARK,
    STATE(3818), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4894), 1,
      sym_type_annotation,
    STATE(5946), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6983), 1,
      sym__call_signature,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [142029] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7247), 1,
      anon_sym_BANG,
    ACTIONS(7271), 1,
      anon_sym_QMARK,
    STATE(3819), 1,
      sym_comment,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4729), 1,
      sym__call_signature,
    STATE(5321), 1,
      sym_type_annotation,
    STATE(6321), 1,
      sym__initializer,
    STATE(6732), 1,
      sym_type_parameters,
    ACTIONS(7245), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [142077] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    STATE(3820), 1,
      sym_comment,
    STATE(2458), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5200), 10,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142109] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4807), 1,
      anon_sym_PIPE,
    ACTIONS(7055), 1,
      anon_sym_LT,
    ACTIONS(7145), 1,
      anon_sym_DOT,
    STATE(3821), 1,
      sym_comment,
    STATE(4022), 1,
      sym_type_arguments,
    ACTIONS(4202), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142143] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4528), 1,
      anon_sym_RBRACE,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(3822), 1,
      sym_comment,
    STATE(4457), 1,
      sym_formal_parameters,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6477), 1,
      sym_type_parameters,
    ACTIONS(4518), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [142187] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7275), 1,
      anon_sym_BANG,
    ACTIONS(7277), 1,
      anon_sym_QMARK,
    STATE(3823), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4902), 1,
      sym_type_annotation,
    STATE(5650), 1,
      sym__initializer,
    STATE(6347), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [142235] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(205), 1,
      anon_sym_unique,
    STATE(2229), 1,
      sym_type_predicate,
    STATE(3824), 1,
      sym_comment,
    STATE(7384), 1,
      sym_predefined_type,
    ACTIONS(7279), 2,
      sym_identifier,
      sym_this,
    ACTIONS(207), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [142269] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7281), 1,
      anon_sym_BANG,
    ACTIONS(7283), 1,
      anon_sym_QMARK,
    STATE(3825), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4994), 1,
      sym_type_annotation,
    STATE(6097), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6797), 1,
      sym__call_signature,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [142317] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7285), 1,
      anon_sym_BANG,
    ACTIONS(7287), 1,
      anon_sym_QMARK,
    STATE(3826), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4940), 1,
      sym_type_annotation,
    STATE(5676), 1,
      sym__initializer,
    STATE(6405), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
    ACTIONS(7201), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [142365] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4515), 1,
      anon_sym_RBRACE,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(3827), 1,
      sym_comment,
    STATE(4457), 1,
      sym_formal_parameters,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    STATE(6477), 1,
      sym_type_parameters,
    ACTIONS(4518), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [142409] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7291), 1,
      anon_sym_BANG,
    ACTIONS(7293), 1,
      anon_sym_QMARK,
    STATE(3828), 1,
      sym_comment,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4819), 1,
      sym__call_signature,
    STATE(5025), 1,
      sym_type_annotation,
    STATE(6114), 1,
      sym__initializer,
    STATE(6732), 1,
      sym_type_parameters,
    ACTIONS(7289), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [142457] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(205), 1,
      anon_sym_unique,
    STATE(3764), 1,
      sym_type_predicate,
    STATE(3829), 1,
      sym_comment,
    STATE(7311), 1,
      sym_predefined_type,
    ACTIONS(7295), 2,
      sym_identifier,
      sym_this,
    ACTIONS(207), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [142491] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(7299), 1,
      anon_sym_GT,
    ACTIONS(7302), 1,
      anon_sym_DOT,
    STATE(3786), 1,
      sym_type_arguments,
    STATE(3830), 1,
      sym_comment,
    ACTIONS(7297), 4,
      anon_sym_LBRACE,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
    ACTIONS(4807), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [142527] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_BANG,
    ACTIONS(7306), 1,
      anon_sym_QMARK,
    STATE(3831), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5023), 1,
      sym_type_annotation,
    STATE(5725), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6525), 1,
      sym__call_signature,
    ACTIONS(7201), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [142575] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_identifier,
    ACTIONS(7179), 1,
      anon_sym_type,
    STATE(3832), 1,
      sym_comment,
    STATE(5516), 1,
      sym_import_require_clause,
    STATE(5517), 1,
      sym_string,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6898), 1,
      sym_import_clause,
    ACTIONS(7181), 2,
      anon_sym_COMMA,
      anon_sym_from,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
  [142623] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7308), 1,
      anon_sym_LBRACE,
    ACTIONS(7312), 1,
      sym_html_character_reference,
    ACTIONS(7314), 1,
      anon_sym_LT_SLASH,
    ACTIONS(7316), 1,
      anon_sym_LT,
    STATE(3833), 1,
      sym_comment,
    STATE(3883), 1,
      sym_jsx_opening_element,
    STATE(3924), 1,
      aux_sym_jsx_element_repeat1,
    STATE(4717), 1,
      sym_jsx_closing_element,
    ACTIONS(7310), 2,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
    STATE(4763), 4,
      sym_jsx_element,
      sym_jsx_text,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
  [142664] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3834), 1,
      sym_comment,
    ACTIONS(5019), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [142689] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7308), 1,
      anon_sym_LBRACE,
    ACTIONS(7312), 1,
      sym_html_character_reference,
    ACTIONS(7316), 1,
      anon_sym_LT,
    ACTIONS(7318), 1,
      anon_sym_LT_SLASH,
    STATE(3835), 1,
      sym_comment,
    STATE(3865), 1,
      aux_sym_jsx_element_repeat1,
    STATE(3883), 1,
      sym_jsx_opening_element,
    STATE(5127), 1,
      sym_jsx_closing_element,
    ACTIONS(7310), 2,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
    STATE(4763), 4,
      sym_jsx_element,
      sym_jsx_text,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
  [142730] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5154), 1,
      anon_sym_PIPE,
    STATE(3836), 1,
      sym_comment,
    ACTIONS(5156), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142757] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7322), 1,
      anon_sym_QMARK,
    STATE(3837), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4859), 1,
      sym__call_signature,
    STATE(4862), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7320), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [142798] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7326), 1,
      anon_sym_QMARK,
    STATE(3838), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4534), 1,
      sym__call_signature,
    STATE(5188), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7324), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [142839] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7328), 1,
      anon_sym_QMARK,
    STATE(3839), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4548), 1,
      sym__call_signature,
    STATE(4862), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7320), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [142880] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5210), 1,
      anon_sym_PIPE,
    STATE(3840), 1,
      sym_comment,
    ACTIONS(5212), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142907] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5357), 1,
      anon_sym_PIPE,
    STATE(3841), 1,
      sym_comment,
    ACTIONS(5359), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142934] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7332), 1,
      anon_sym_QMARK,
    STATE(3842), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5363), 1,
      sym__call_signature,
    STATE(5368), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7330), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [142975] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5353), 1,
      anon_sym_PIPE,
    STATE(3843), 1,
      sym_comment,
    ACTIONS(5355), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143002] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7334), 1,
      anon_sym_COLON,
    ACTIONS(7336), 1,
      anon_sym_QMARK,
    STATE(3844), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4455), 1,
      sym__call_signature,
    STATE(5368), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7330), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [143043] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5349), 1,
      anon_sym_PIPE,
    STATE(3845), 1,
      sym_comment,
    ACTIONS(5351), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143070] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4349), 1,
      anon_sym_PIPE,
    STATE(3846), 1,
      sym_comment,
    ACTIONS(4869), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143097] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5154), 1,
      anon_sym_PIPE,
    STATE(3847), 1,
      sym_comment,
    ACTIONS(5156), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143124] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5106), 1,
      anon_sym_PIPE,
    STATE(3848), 1,
      sym_comment,
    ACTIONS(5108), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143151] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7308), 1,
      anon_sym_LBRACE,
    ACTIONS(7312), 1,
      sym_html_character_reference,
    ACTIONS(7316), 1,
      anon_sym_LT,
    ACTIONS(7338), 1,
      anon_sym_LT_SLASH,
    STATE(2496), 1,
      sym_jsx_closing_element,
    STATE(3849), 1,
      sym_comment,
    STATE(3883), 1,
      sym_jsx_opening_element,
    STATE(3900), 1,
      aux_sym_jsx_element_repeat1,
    ACTIONS(7310), 2,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
    STATE(4763), 4,
      sym_jsx_element,
      sym_jsx_text,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
  [143192] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7023), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_LT,
    ACTIONS(7340), 1,
      anon_sym_COLON,
    ACTIONS(7342), 1,
      anon_sym_GT,
    ACTIONS(7344), 1,
      anon_sym_SLASH_GT,
    STATE(3850), 1,
      sym_comment,
    STATE(4185), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4186), 1,
      sym_type_arguments,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [143237] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3851), 1,
      sym_comment,
    ACTIONS(5039), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143262] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3852), 1,
      sym_comment,
    ACTIONS(5035), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143287] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4345), 1,
      anon_sym_PIPE,
    STATE(3853), 1,
      sym_comment,
    ACTIONS(4839), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143314] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3854), 1,
      sym_comment,
    ACTIONS(5035), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143339] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3855), 1,
      sym_comment,
    ACTIONS(5035), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143364] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5106), 1,
      anon_sym_PIPE,
    STATE(3856), 1,
      sym_comment,
    ACTIONS(5108), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143391] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7308), 1,
      anon_sym_LBRACE,
    ACTIONS(7312), 1,
      sym_html_character_reference,
    ACTIONS(7316), 1,
      anon_sym_LT,
    ACTIONS(7346), 1,
      anon_sym_LT_SLASH,
    STATE(3152), 1,
      sym_jsx_closing_element,
    STATE(3857), 1,
      sym_comment,
    STATE(3883), 1,
      sym_jsx_opening_element,
    STATE(3924), 1,
      aux_sym_jsx_element_repeat1,
    ACTIONS(7310), 2,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
    STATE(4763), 4,
      sym_jsx_element,
      sym_jsx_text,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
  [143432] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3858), 1,
      sym_comment,
    ACTIONS(5023), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143457] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7081), 1,
      anon_sym_LT,
    ACTIONS(7348), 1,
      anon_sym_DOT,
    ACTIONS(7350), 1,
      anon_sym_is,
    STATE(3859), 1,
      sym_comment,
    STATE(4078), 1,
      sym_type_arguments,
    ACTIONS(4202), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [143490] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3860), 1,
      sym_comment,
    ACTIONS(5023), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143515] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7352), 1,
      anon_sym_QMARK,
    STATE(3861), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5183), 1,
      sym__call_signature,
    STATE(5188), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7324), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [143556] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3862), 1,
      sym_comment,
    ACTIONS(5023), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143581] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7356), 1,
      anon_sym_QMARK,
    STATE(3863), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4915), 1,
      sym__call_signature,
    STATE(4926), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7354), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [143622] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3864), 1,
      sym_comment,
    ACTIONS(5019), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143647] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7308), 1,
      anon_sym_LBRACE,
    ACTIONS(7312), 1,
      sym_html_character_reference,
    ACTIONS(7316), 1,
      anon_sym_LT,
    ACTIONS(7318), 1,
      anon_sym_LT_SLASH,
    STATE(3865), 1,
      sym_comment,
    STATE(3883), 1,
      sym_jsx_opening_element,
    STATE(3924), 1,
      aux_sym_jsx_element_repeat1,
    STATE(5058), 1,
      sym_jsx_closing_element,
    ACTIONS(7310), 2,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
    STATE(4763), 4,
      sym_jsx_element,
      sym_jsx_text,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
  [143688] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2235), 1,
      anon_sym_DOT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5254), 1,
      anon_sym_PIPE,
    STATE(3866), 1,
      sym_comment,
    ACTIONS(5256), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143717] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3867), 1,
      sym_comment,
    ACTIONS(5019), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143742] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2239), 1,
      anon_sym_DOT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5254), 1,
      anon_sym_PIPE,
    STATE(3868), 1,
      sym_comment,
    ACTIONS(5256), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143771] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3869), 1,
      sym_comment,
    ACTIONS(5096), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143796] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3870), 1,
      sym_comment,
    ACTIONS(5248), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143821] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3871), 1,
      sym_comment,
    ACTIONS(5100), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143846] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7360), 1,
      anon_sym_QMARK,
    STATE(3872), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5117), 1,
      sym_type_annotation,
    STATE(5121), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7358), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [143887] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3873), 1,
      sym_comment,
    ACTIONS(5096), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143912] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5216), 1,
      anon_sym_PIPE,
    STATE(3874), 1,
      sym_comment,
    ACTIONS(5218), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143939] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3875), 1,
      sym_comment,
    ACTIONS(5100), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143964] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3876), 1,
      sym_comment,
    ACTIONS(5104), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [143989] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5202), 1,
      anon_sym_PIPE,
    STATE(3877), 1,
      sym_comment,
    ACTIONS(5204), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144016] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7023), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_LT,
    ACTIONS(7340), 1,
      anon_sym_COLON,
    ACTIONS(7342), 1,
      anon_sym_GT,
    ACTIONS(7362), 1,
      anon_sym_SLASH_GT,
    STATE(3878), 1,
      sym_comment,
    STATE(4260), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4261), 1,
      sym_type_arguments,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [144061] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5176), 1,
      anon_sym_PIPE,
    STATE(3879), 1,
      sym_comment,
    ACTIONS(5178), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144088] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3880), 1,
      sym_comment,
    ACTIONS(5248), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144113] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3881), 1,
      sym_comment,
    ACTIONS(5248), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144138] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4855), 1,
      anon_sym_PIPE,
    ACTIONS(7055), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_comment,
    STATE(4023), 1,
      sym_type_arguments,
    ACTIONS(4857), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144169] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7308), 1,
      anon_sym_LBRACE,
    ACTIONS(7312), 1,
      sym_html_character_reference,
    ACTIONS(7314), 1,
      anon_sym_LT_SLASH,
    ACTIONS(7316), 1,
      anon_sym_LT,
    STATE(3833), 1,
      aux_sym_jsx_element_repeat1,
    STATE(4753), 1,
      sym_jsx_closing_element,
    ACTIONS(7310), 2,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
    STATE(3883), 2,
      sym_jsx_opening_element,
      sym_comment,
    STATE(4763), 4,
      sym_jsx_element,
      sym_jsx_text,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
  [144208] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7308), 1,
      anon_sym_LBRACE,
    ACTIONS(7312), 1,
      sym_html_character_reference,
    ACTIONS(7316), 1,
      anon_sym_LT,
    ACTIONS(7346), 1,
      anon_sym_LT_SLASH,
    STATE(3053), 1,
      sym_jsx_closing_element,
    STATE(3857), 1,
      aux_sym_jsx_element_repeat1,
    STATE(3883), 1,
      sym_jsx_opening_element,
    STATE(3884), 1,
      sym_comment,
    ACTIONS(7310), 2,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
    STATE(4763), 4,
      sym_jsx_element,
      sym_jsx_text,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
  [144249] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3885), 1,
      sym_comment,
    ACTIONS(5164), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144274] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3886), 1,
      sym_comment,
    ACTIONS(5164), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144299] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3887), 1,
      sym_comment,
    ACTIONS(5112), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144324] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3888), 1,
      sym_comment,
    ACTIONS(5164), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144349] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3889), 1,
      sym_comment,
    ACTIONS(4879), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144374] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3890), 1,
      sym_comment,
    ACTIONS(4879), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144399] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3891), 1,
      sym_comment,
    ACTIONS(5104), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144424] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7364), 1,
      anon_sym_QMARK,
    STATE(3892), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4487), 1,
      sym__call_signature,
    STATE(4926), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7354), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [144465] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(5198), 1,
      anon_sym_PIPE,
    STATE(3893), 1,
      sym_comment,
    STATE(2458), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5200), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144498] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3894), 1,
      sym_comment,
    ACTIONS(5112), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144523] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5290), 1,
      anon_sym_PIPE,
    STATE(3895), 1,
      sym_comment,
    ACTIONS(5292), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144550] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5282), 1,
      anon_sym_PIPE,
    STATE(3896), 1,
      sym_comment,
    ACTIONS(5284), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144577] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3897), 1,
      sym_comment,
    ACTIONS(4879), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144602] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5278), 1,
      anon_sym_PIPE,
    STATE(3898), 1,
      sym_comment,
    ACTIONS(5280), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144629] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4343), 1,
      anon_sym_PIPE,
    STATE(3899), 1,
      sym_comment,
    ACTIONS(4867), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144656] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7308), 1,
      anon_sym_LBRACE,
    ACTIONS(7312), 1,
      sym_html_character_reference,
    ACTIONS(7316), 1,
      anon_sym_LT,
    ACTIONS(7338), 1,
      anon_sym_LT_SLASH,
    STATE(2550), 1,
      sym_jsx_closing_element,
    STATE(3883), 1,
      sym_jsx_opening_element,
    STATE(3900), 1,
      sym_comment,
    STATE(3924), 1,
      aux_sym_jsx_element_repeat1,
    ACTIONS(7310), 2,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
    STATE(4763), 4,
      sym_jsx_element,
      sym_jsx_text,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
  [144697] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3901), 1,
      sym_comment,
    ACTIONS(5126), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144722] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3902), 1,
      sym_comment,
    ACTIONS(5168), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144747] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3903), 1,
      sym_comment,
    ACTIONS(5160), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144772] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4987), 1,
      anon_sym_PIPE,
    ACTIONS(7366), 1,
      anon_sym_DOT,
    ACTIONS(7368), 1,
      anon_sym_QMARK_DOT,
    STATE(3904), 1,
      sym_comment,
    ACTIONS(4989), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144803] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3905), 1,
      sym_comment,
    ACTIONS(4966), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144828] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3906), 1,
      sym_comment,
    ACTIONS(5130), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144853] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3907), 1,
      sym_comment,
    ACTIONS(5126), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144878] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3908), 1,
      sym_comment,
    ACTIONS(5130), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [144903] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7370), 1,
      anon_sym_QMARK,
    STATE(3909), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4515), 1,
      sym__call_signature,
    STATE(5117), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7358), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [144944] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3910), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5392), 1,
      sym__call_signature,
    STATE(5404), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7372), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [144982] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3911), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4532), 1,
      sym__call_signature,
    STATE(5179), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7374), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [145020] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_identifier,
    ACTIONS(7179), 1,
      anon_sym_type,
    STATE(3912), 1,
      sym_comment,
    STATE(5409), 1,
      sym_import_require_clause,
    STATE(5628), 1,
      sym_string,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6922), 1,
      sym_import_clause,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
  [145064] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3913), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5145), 1,
      sym_type_annotation,
    STATE(6182), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6603), 1,
      sym__call_signature,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145106] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(3914), 1,
      sym_comment,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4748), 1,
      sym__call_signature,
    STATE(5225), 1,
      sym_type_annotation,
    STATE(5799), 1,
      sym__initializer,
    STATE(6732), 1,
      sym_type_parameters,
    ACTIONS(7378), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145148] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7027), 1,
      anon_sym_LT,
    ACTIONS(7380), 1,
      anon_sym_GT,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7384), 1,
      anon_sym_SLASH_GT,
    STATE(3915), 1,
      sym_comment,
    STATE(4258), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4259), 1,
      sym_type_arguments,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [145190] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3916), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5270), 1,
      sym_type_annotation,
    STATE(5793), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6646), 1,
      sym__call_signature,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145232] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3917), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5177), 1,
      sym__call_signature,
    STATE(5179), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7374), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [145270] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3918), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5115), 1,
      sym_type_annotation,
    STATE(5116), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7388), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [145308] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3919), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4488), 1,
      sym__call_signature,
    STATE(4948), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7390), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [145346] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(3920), 1,
      sym_comment,
    STATE(4457), 1,
      sym_formal_parameters,
    STATE(6477), 1,
      sym_type_parameters,
    ACTIONS(4787), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4518), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [145382] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4525), 1,
      anon_sym_RBRACE,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(3921), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [145416] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(3922), 1,
      sym_comment,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4815), 1,
      sym__call_signature,
    STATE(5042), 1,
      sym_type_annotation,
    STATE(6136), 1,
      sym__initializer,
    STATE(6732), 1,
      sym_type_parameters,
    ACTIONS(7392), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145458] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3923), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5001), 1,
      sym_type_annotation,
    STATE(5828), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6722), 1,
      sym__call_signature,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145500] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7396), 1,
      anon_sym_LBRACE,
    ACTIONS(7402), 1,
      sym_html_character_reference,
    ACTIONS(7405), 1,
      anon_sym_LT_SLASH,
    ACTIONS(7407), 1,
      anon_sym_LT,
    STATE(3883), 1,
      sym_jsx_opening_element,
    ACTIONS(7399), 2,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
    STATE(3924), 2,
      sym_comment,
      aux_sym_jsx_element_repeat1,
    STATE(4763), 4,
      sym_jsx_element,
      sym_jsx_text,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
  [145536] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1972), 1,
      anon_sym_PIPE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3925), 1,
      sym_comment,
    ACTIONS(2030), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [145562] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4522), 1,
      anon_sym_RBRACE,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(3926), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [145596] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3927), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4946), 1,
      sym__call_signature,
    STATE(4948), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7390), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [145634] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3928), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5019), 1,
      sym_type_annotation,
    STATE(5661), 1,
      sym__initializer,
    STATE(6358), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145676] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4515), 1,
      anon_sym_RBRACE,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(3929), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [145710] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7027), 1,
      anon_sym_LT,
    ACTIONS(7380), 1,
      anon_sym_GT,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7410), 1,
      anon_sym_SLASH_GT,
    STATE(3930), 1,
      sym_comment,
    STATE(4222), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4227), 1,
      sym_type_arguments,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [145752] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3931), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5002), 1,
      sym_type_annotation,
    STATE(6106), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6790), 1,
      sym__call_signature,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145794] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3932), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4898), 1,
      sym_type_annotation,
    STATE(5646), 1,
      sym__initializer,
    STATE(6340), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145836] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(3933), 1,
      sym_comment,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4667), 1,
      sym__call_signature,
    STATE(5166), 1,
      sym_type_annotation,
    STATE(5940), 1,
      sym__initializer,
    STATE(6732), 1,
      sym_type_parameters,
    ACTIONS(7412), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145878] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3934), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4989), 1,
      sym_type_annotation,
    STATE(6094), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6805), 1,
      sym__call_signature,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145920] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3935), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5053), 1,
      sym_type_annotation,
    STATE(5769), 1,
      sym__initializer,
    STATE(6403), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
    ACTIONS(7414), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145962] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_identifier,
    ACTIONS(7179), 1,
      anon_sym_type,
    STATE(3936), 1,
      sym_comment,
    STATE(5639), 1,
      sym_import_require_clause,
    STATE(5640), 1,
      sym_string,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6851), 1,
      sym_import_clause,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
  [146006] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3937), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5103), 1,
      sym_type_annotation,
    STATE(5837), 1,
      sym__initializer,
    STATE(5843), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7416), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146048] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4855), 1,
      anon_sym_PIPE,
    ACTIONS(7418), 1,
      anon_sym_is,
    STATE(3938), 1,
      sym_comment,
    ACTIONS(4857), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [146076] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7027), 1,
      anon_sym_LT,
    ACTIONS(7380), 1,
      anon_sym_GT,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7420), 1,
      anon_sym_SLASH_GT,
    STATE(3939), 1,
      sym_comment,
    STATE(4168), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4171), 1,
      sym_type_arguments,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [146118] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3940), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4553), 1,
      sym__call_signature,
    STATE(5404), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7372), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [146156] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3941), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5066), 1,
      sym_type_annotation,
    STATE(5879), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6791), 1,
      sym__call_signature,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146198] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7081), 1,
      anon_sym_LT,
    ACTIONS(7348), 1,
      anon_sym_DOT,
    STATE(3942), 1,
      sym_comment,
    STATE(4078), 1,
      sym_type_arguments,
    ACTIONS(4202), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [146228] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_identifier,
    ACTIONS(7179), 1,
      anon_sym_type,
    STATE(3943), 1,
      sym_comment,
    STATE(5516), 1,
      sym_import_require_clause,
    STATE(5517), 1,
      sym_string,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6898), 1,
      sym_import_clause,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
  [146272] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3944), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5030), 1,
      sym_type_annotation,
    STATE(5877), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6780), 1,
      sym__call_signature,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146314] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4874), 1,
      sym_type_annotation,
    STATE(5924), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6904), 1,
      sym__call_signature,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146356] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4845), 1,
      anon_sym_PIPE,
    STATE(3946), 1,
      sym_comment,
    ACTIONS(4847), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [146382] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7027), 1,
      anon_sym_LT,
    ACTIONS(7380), 1,
      anon_sym_GT,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7422), 1,
      anon_sym_SLASH_GT,
    STATE(3947), 1,
      sym_comment,
    STATE(4183), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4184), 1,
      sym_type_arguments,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [146424] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3948), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4546), 1,
      sym__call_signature,
    STATE(4858), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7424), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [146462] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3949), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5213), 1,
      sym_type_annotation,
    STATE(6234), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6501), 1,
      sym__call_signature,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146504] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3950), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4857), 1,
      sym__call_signature,
    STATE(4858), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7424), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [146542] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4871), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_is,
    STATE(3951), 1,
      sym_comment,
    ACTIONS(4873), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [146570] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3952), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5189), 1,
      sym_type_annotation,
    STATE(6139), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6571), 1,
      sym__call_signature,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146612] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(3953), 1,
      sym_comment,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4706), 1,
      sym__call_signature,
    STATE(5319), 1,
      sym_type_annotation,
    STATE(6314), 1,
      sym__initializer,
    STATE(6732), 1,
      sym_type_parameters,
    ACTIONS(7428), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146654] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_identifier,
    ACTIONS(7179), 1,
      anon_sym_type,
    STATE(3954), 1,
      sym_comment,
    STATE(5505), 1,
      sym_import_require_clause,
    STATE(5506), 1,
      sym_string,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6719), 1,
      sym_import_clause,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
  [146698] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(3955), 1,
      sym_comment,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4643), 1,
      sym__call_signature,
    STATE(5103), 1,
      sym_type_annotation,
    STATE(5853), 1,
      sym__initializer,
    STATE(6732), 1,
      sym_type_parameters,
    ACTIONS(7416), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146740] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3956), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5303), 1,
      sym_type_annotation,
    STATE(6028), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6899), 1,
      sym__call_signature,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146782] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4841), 1,
      anon_sym_PIPE,
    ACTIONS(7147), 1,
      anon_sym_is,
    STATE(3957), 1,
      sym_comment,
    ACTIONS(4843), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [146810] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3958), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4516), 1,
      sym__call_signature,
    STATE(5115), 1,
      sym_type_annotation,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7388), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [146848] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3959), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5251), 1,
      sym_type_annotation,
    STATE(5993), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6936), 1,
      sym__call_signature,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146890] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(3960), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4889), 1,
      sym_type_annotation,
    STATE(5943), 1,
      sym__initializer,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6988), 1,
      sym__call_signature,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146932] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4528), 1,
      anon_sym_RBRACE,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(3961), 1,
      sym_comment,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [146966] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(6994), 1,
      anon_sym_STAR,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_identifier,
    ACTIONS(7179), 1,
      anon_sym_type,
    STATE(3962), 1,
      sym_comment,
    STATE(5431), 1,
      sym_string,
    STATE(5432), 1,
      sym_import_require_clause,
    STATE(6559), 1,
      sym__import_identifier,
    STATE(6816), 1,
      sym_import_clause,
    STATE(7302), 2,
      sym_namespace_import,
      sym_named_imports,
  [147010] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(6978), 1,
      anon_sym_LT,
    ACTIONS(6988), 1,
      anon_sym_DOT,
    ACTIONS(7430), 1,
      anon_sym_QMARK,
    STATE(3786), 1,
      sym_type_arguments,
    STATE(3963), 1,
      sym_comment,
    STATE(6658), 1,
      sym_type_annotation,
    ACTIONS(4202), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [147046] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3964), 1,
      sym_comment,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5166), 1,
      sym_type_annotation,
    STATE(5964), 1,
      sym__call_signature,
    STATE(5965), 1,
      sym__initializer,
    STATE(6769), 1,
      sym_type_parameters,
    ACTIONS(7412), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [147088] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4512), 1,
      anon_sym_COMMA,
    ACTIONS(4531), 1,
      anon_sym_RBRACE,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(3965), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [147122] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3966), 1,
      sym_comment,
    ACTIONS(4518), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [147145] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_extends,
    STATE(3967), 1,
      sym_comment,
    ACTIONS(5076), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [147174] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4993), 1,
      anon_sym_PIPE,
    STATE(3968), 1,
      sym_comment,
    ACTIONS(4995), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147199] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    STATE(3969), 1,
      sym_comment,
    ACTIONS(5015), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147224] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    STATE(3970), 1,
      sym_comment,
    ACTIONS(5230), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147249] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5009), 1,
      anon_sym_PIPE,
    STATE(3971), 1,
      sym_comment,
    ACTIONS(5011), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147274] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5090), 1,
      anon_sym_PIPE,
    STATE(3972), 1,
      sym_comment,
    ACTIONS(5092), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147299] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_extends,
    STATE(3973), 1,
      sym_comment,
    ACTIONS(5062), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [147328] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_extends,
    STATE(3974), 1,
      sym_comment,
    ACTIONS(5226), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [147357] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(3975), 1,
      sym_comment,
    STATE(4457), 1,
      sym_formal_parameters,
    STATE(6477), 1,
      sym_type_parameters,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [147388] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5060), 1,
      anon_sym_PIPE,
    STATE(3976), 1,
      sym_comment,
    ACTIONS(5062), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147413] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3222), 1,
      anon_sym_PIPE,
    STATE(3977), 1,
      sym_comment,
    ACTIONS(3540), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147438] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5070), 1,
      anon_sym_PIPE,
    STATE(3978), 1,
      sym_comment,
    ACTIONS(5072), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147463] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3979), 1,
      sym_comment,
    ACTIONS(6523), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [147486] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3980), 1,
      sym_comment,
    ACTIONS(6416), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [147509] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7439), 1,
      anon_sym_DOT,
    ACTIONS(7441), 1,
      anon_sym_QMARK_DOT,
    STATE(3981), 1,
      sym_comment,
    ACTIONS(4989), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [147536] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_extends,
    STATE(3982), 1,
      sym_comment,
    ACTIONS(5080), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [147565] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(3983), 1,
      sym_comment,
    ACTIONS(4839), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [147588] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3232), 1,
      anon_sym_PIPE,
    STATE(3984), 1,
      sym_comment,
    ACTIONS(3506), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147613] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4871), 1,
      anon_sym_PIPE,
    STATE(3985), 1,
      sym_comment,
    ACTIONS(4873), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147638] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5086), 1,
      anon_sym_PIPE,
    STATE(3986), 1,
      sym_comment,
    ACTIONS(5088), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147663] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7081), 1,
      anon_sym_LT,
    STATE(3987), 1,
      sym_comment,
    STATE(4093), 1,
      sym_type_arguments,
    ACTIONS(4857), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [147690] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5304), 1,
      anon_sym_PIPE,
    STATE(3988), 1,
      sym_comment,
    ACTIONS(5306), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147715] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4972), 1,
      anon_sym_PIPE,
    STATE(3989), 1,
      sym_comment,
    ACTIONS(4974), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147740] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5294), 1,
      anon_sym_PIPE,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    STATE(3990), 1,
      sym_comment,
    ACTIONS(5296), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147767] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4855), 1,
      anon_sym_PIPE,
    STATE(3991), 1,
      sym_comment,
    ACTIONS(4857), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147792] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5188), 1,
      anon_sym_PIPE,
    STATE(3992), 1,
      sym_comment,
    ACTIONS(5190), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147817] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4841), 1,
      anon_sym_PIPE,
    STATE(3993), 1,
      sym_comment,
    ACTIONS(4843), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147842] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_extends,
    STATE(3994), 1,
      sym_comment,
    ACTIONS(5047), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [147871] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_extends,
    STATE(3995), 1,
      sym_comment,
    ACTIONS(5051), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [147900] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    STATE(3996), 1,
      sym_comment,
    ACTIONS(4883), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147925] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    STATE(3997), 1,
      sym_comment,
    ACTIONS(4883), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147952] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3236), 1,
      anon_sym_PIPE,
    STATE(3998), 1,
      sym_comment,
    ACTIONS(3570), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147977] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5332), 1,
      anon_sym_PIPE,
    STATE(3999), 1,
      sym_comment,
    ACTIONS(5334), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148002] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5286), 1,
      anon_sym_PIPE,
    STATE(4000), 1,
      sym_comment,
    ACTIONS(5288), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148027] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4001), 1,
      sym_comment,
    ACTIONS(5218), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [148050] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2235), 1,
      anon_sym_DOT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4002), 1,
      sym_comment,
    ACTIONS(5256), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148075] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(7445), 1,
      sym_identifier,
    ACTIONS(7447), 1,
      anon_sym_type,
    ACTIONS(7449), 1,
      anon_sym_COMMA,
    ACTIONS(7451), 1,
      anon_sym_RBRACE,
    ACTIONS(7453), 1,
      anon_sym_typeof,
    STATE(4003), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(5923), 1,
      sym_import_specifier,
    STATE(6907), 1,
      sym__import_identifier,
    STATE(7043), 1,
      sym__module_export_name,
  [148118] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2239), 1,
      anon_sym_DOT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4004), 1,
      sym_comment,
    ACTIONS(5256), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148143] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_extends,
    STATE(4005), 1,
      sym_comment,
    ACTIONS(5268), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [148172] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4997), 1,
      anon_sym_PIPE,
    STATE(4006), 1,
      sym_comment,
    ACTIONS(4999), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148197] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4007), 1,
      sym_comment,
    ACTIONS(5204), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [148220] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4008), 1,
      sym_comment,
    ACTIONS(4867), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [148243] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4009), 1,
      sym_comment,
    ACTIONS(5178), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [148266] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5266), 1,
      anon_sym_PIPE,
    STATE(4010), 1,
      sym_comment,
    ACTIONS(5268), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148291] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3230), 1,
      anon_sym_PIPE,
    STATE(4011), 1,
      sym_comment,
    ACTIONS(3508), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148316] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5001), 1,
      anon_sym_PIPE,
    STATE(4012), 1,
      sym_comment,
    ACTIONS(5003), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148341] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5005), 1,
      anon_sym_PIPE,
    STATE(4013), 1,
      sym_comment,
    ACTIONS(5007), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148366] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5025), 1,
      anon_sym_PIPE,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    STATE(4014), 1,
      sym_comment,
    ACTIONS(5027), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148393] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5029), 1,
      anon_sym_PIPE,
    STATE(4015), 1,
      sym_comment,
    ACTIONS(5031), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148418] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5041), 1,
      anon_sym_PIPE,
    STATE(4016), 1,
      sym_comment,
    ACTIONS(5043), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148443] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3228), 1,
      anon_sym_PIPE,
    STATE(4017), 1,
      sym_comment,
    ACTIONS(3518), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148468] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5310), 1,
      anon_sym_PIPE,
    STATE(4018), 1,
      sym_comment,
    ACTIONS(5312), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148493] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4881), 1,
      anon_sym_PIPE,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    STATE(4019), 1,
      sym_comment,
    ACTIONS(4883), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(5084), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148522] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5114), 1,
      anon_sym_PIPE,
    ACTIONS(7455), 1,
      anon_sym_extends,
    STATE(4020), 1,
      sym_comment,
    ACTIONS(5116), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [148549] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5120), 1,
      anon_sym_PIPE,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    STATE(4021), 1,
      sym_comment,
    ACTIONS(5122), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148576] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5066), 1,
      anon_sym_PIPE,
    STATE(4022), 1,
      sym_comment,
    ACTIONS(5068), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148601] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5150), 1,
      anon_sym_PIPE,
    STATE(4023), 1,
      sym_comment,
    ACTIONS(5152), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148626] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5240), 1,
      anon_sym_PIPE,
    STATE(4024), 1,
      sym_comment,
    ACTIONS(5242), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148651] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5198), 1,
      anon_sym_PIPE,
    STATE(4025), 1,
      sym_comment,
    ACTIONS(5200), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148676] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5206), 1,
      anon_sym_PIPE,
    STATE(4026), 1,
      sym_comment,
    ACTIONS(5208), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148701] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4027), 1,
      sym_comment,
    ACTIONS(4869), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [148724] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5220), 1,
      anon_sym_PIPE,
    STATE(4028), 1,
      sym_comment,
    ACTIONS(5222), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148749] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5236), 1,
      anon_sym_PIPE,
    STATE(4029), 1,
      sym_comment,
    ACTIONS(5238), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148774] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(7457), 1,
      sym_identifier,
    ACTIONS(7461), 1,
      anon_sym_COMMA,
    ACTIONS(7463), 1,
      anon_sym_RBRACE,
    STATE(4030), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(5829), 1,
      sym_export_specifier,
    STATE(5832), 1,
      sym__module_export_name,
    ACTIONS(7459), 2,
      anon_sym_type,
      anon_sym_typeof,
  [148812] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(4031), 1,
      sym_comment,
    STATE(3118), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5200), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [148840] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7465), 1,
      sym_identifier,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    STATE(3167), 1,
      sym_class_body,
    STATE(4032), 1,
      sym_comment,
    STATE(4506), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6831), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [148880] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(4033), 1,
      sym_comment,
    ACTIONS(4857), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [148904] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7475), 1,
      sym_identifier,
    STATE(3112), 1,
      sym_class_body,
    STATE(4034), 1,
      sym_comment,
    STATE(4570), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6641), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [148944] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_extends,
    STATE(4035), 1,
      sym_comment,
    ACTIONS(7477), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148972] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7479), 1,
      sym_identifier,
    STATE(3112), 1,
      sym_class_body,
    STATE(4036), 1,
      sym_comment,
    STATE(4570), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6641), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149012] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7340), 1,
      anon_sym_COLON,
    ACTIONS(7342), 1,
      anon_sym_GT,
    ACTIONS(7362), 1,
      anon_sym_SLASH_GT,
    STATE(4037), 1,
      sym_comment,
    STATE(4262), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [149048] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7481), 1,
      sym_identifier,
    STATE(3167), 1,
      sym_class_body,
    STATE(4038), 1,
      sym_comment,
    STATE(4506), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6831), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149088] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4159), 1,
      anon_sym_LPAREN,
    ACTIONS(7485), 1,
      anon_sym_DOT,
    STATE(4039), 1,
      sym_comment,
    STATE(4332), 1,
      sym_arguments,
    ACTIONS(7483), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149116] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7487), 1,
      sym_identifier,
    ACTIONS(7489), 1,
      anon_sym_LBRACE,
    STATE(3281), 1,
      sym_class_body,
    STATE(4040), 1,
      sym_comment,
    STATE(4499), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6706), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149156] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(7445), 1,
      sym_identifier,
    ACTIONS(7447), 1,
      anon_sym_type,
    ACTIONS(7453), 1,
      anon_sym_typeof,
    ACTIONS(7491), 1,
      anon_sym_RBRACE,
    STATE(4041), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(6472), 1,
      sym_import_specifier,
    STATE(6907), 1,
      sym__import_identifier,
    STATE(7043), 1,
      sym__module_export_name,
  [149196] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7049), 1,
      anon_sym_SLASH_GT,
    ACTIONS(7340), 1,
      anon_sym_COLON,
    ACTIONS(7342), 1,
      anon_sym_GT,
    STATE(4042), 1,
      sym_comment,
    STATE(4178), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [149232] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7493), 1,
      anon_sym_EQ,
    ACTIONS(7497), 1,
      anon_sym_BANG,
    STATE(4043), 1,
      sym_comment,
    STATE(4888), 1,
      sym_type_annotation,
    STATE(5311), 1,
      sym__initializer,
    ACTIONS(7499), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7495), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149266] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7350), 1,
      anon_sym_is,
    STATE(4044), 1,
      sym_comment,
    ACTIONS(4873), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [149290] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7025), 1,
      anon_sym_SLASH_GT,
    ACTIONS(7340), 1,
      anon_sym_COLON,
    ACTIONS(7342), 1,
      anon_sym_GT,
    STATE(4045), 1,
      sym_comment,
    STATE(4299), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [149326] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7501), 1,
      sym_identifier,
    STATE(3112), 1,
      sym_class_body,
    STATE(4046), 1,
      sym_comment,
    STATE(4570), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6641), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149366] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(7445), 1,
      sym_identifier,
    ACTIONS(7447), 1,
      anon_sym_type,
    ACTIONS(7453), 1,
      anon_sym_typeof,
    ACTIONS(7503), 1,
      anon_sym_RBRACE,
    STATE(4047), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(6472), 1,
      sym_import_specifier,
    STATE(6907), 1,
      sym__import_identifier,
    STATE(7043), 1,
      sym__module_export_name,
  [149406] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7497), 1,
      anon_sym_BANG,
    STATE(4048), 1,
      sym_comment,
    STATE(4888), 1,
      sym_type_annotation,
    STATE(5942), 1,
      sym__initializer,
    ACTIONS(7499), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7495), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149440] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7489), 1,
      anon_sym_LBRACE,
    ACTIONS(7505), 1,
      sym_identifier,
    STATE(2531), 1,
      sym_class_body,
    STATE(4049), 1,
      sym_comment,
    STATE(4348), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6416), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149480] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4050), 1,
      sym_comment,
    ACTIONS(2030), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [149502] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7509), 1,
      anon_sym_COLON,
    STATE(4051), 1,
      sym_comment,
    STATE(4704), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7507), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149528] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7511), 1,
      sym_identifier,
    STATE(3167), 1,
      sym_class_body,
    STATE(4052), 1,
      sym_comment,
    STATE(4506), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6831), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149568] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7350), 1,
      anon_sym_is,
    STATE(4053), 1,
      sym_comment,
    ACTIONS(4843), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [149592] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7513), 1,
      sym_identifier,
    STATE(3112), 1,
      sym_class_body,
    STATE(4054), 1,
      sym_comment,
    STATE(4570), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6641), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149632] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7509), 1,
      anon_sym_COLON,
    STATE(4055), 1,
      sym_comment,
    STATE(4751), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7515), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149658] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7517), 1,
      sym_identifier,
    STATE(3167), 1,
      sym_class_body,
    STATE(4056), 1,
      sym_comment,
    STATE(4506), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6831), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149698] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7340), 1,
      anon_sym_COLON,
    ACTIONS(7342), 1,
      anon_sym_GT,
    ACTIONS(7344), 1,
      anon_sym_SLASH_GT,
    STATE(4057), 1,
      sym_comment,
    STATE(4188), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [149734] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(7445), 1,
      sym_identifier,
    ACTIONS(7519), 1,
      anon_sym_type,
    ACTIONS(7521), 1,
      anon_sym_as,
    STATE(4058), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(6778), 1,
      sym__import_identifier,
    STATE(7126), 1,
      sym__module_export_name,
    ACTIONS(7181), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [149772] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7523), 1,
      sym_identifier,
    STATE(3167), 1,
      sym_class_body,
    STATE(4059), 1,
      sym_comment,
    STATE(4506), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6831), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149812] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7525), 1,
      sym_identifier,
    STATE(3167), 1,
      sym_class_body,
    STATE(4060), 1,
      sym_comment,
    STATE(4506), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6831), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149852] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7489), 1,
      anon_sym_LBRACE,
    ACTIONS(7527), 1,
      sym_identifier,
    STATE(2389), 1,
      sym_class_body,
    STATE(4061), 1,
      sym_comment,
    STATE(4395), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6673), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149892] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7529), 1,
      sym_identifier,
    STATE(3167), 1,
      sym_class_body,
    STATE(4062), 1,
      sym_comment,
    STATE(4506), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6831), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149932] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7531), 1,
      sym_identifier,
    STATE(3112), 1,
      sym_class_body,
    STATE(4063), 1,
      sym_comment,
    STATE(4570), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6641), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [149972] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(4064), 1,
      sym_comment,
    ACTIONS(4787), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4518), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [149998] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7533), 1,
      sym_identifier,
    STATE(3112), 1,
      sym_class_body,
    STATE(4065), 1,
      sym_comment,
    STATE(4570), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6641), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [150038] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(7467), 1,
      anon_sym_LBRACE,
    ACTIONS(7469), 1,
      anon_sym_extends,
    ACTIONS(7471), 1,
      anon_sym_implements,
    ACTIONS(7535), 1,
      sym_identifier,
    STATE(3112), 1,
      sym_class_body,
    STATE(4066), 1,
      sym_comment,
    STATE(4570), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6641), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [150078] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4067), 1,
      sym_comment,
    ACTIONS(4847), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [150100] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4068), 1,
      sym_comment,
    STATE(5185), 1,
      sym_type_annotation,
    STATE(5951), 1,
      sym__initializer,
    ACTIONS(7213), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7211), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150131] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7537), 1,
      anon_sym_AMP,
    ACTIONS(7539), 1,
      anon_sym_PIPE,
    ACTIONS(7541), 1,
      anon_sym_extends,
    STATE(4069), 1,
      sym_comment,
    ACTIONS(5080), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [150158] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4070), 1,
      sym_comment,
    ACTIONS(4330), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [150179] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7493), 1,
      anon_sym_EQ,
    STATE(4071), 1,
      sym_comment,
    STATE(4888), 1,
      sym_type_annotation,
    STATE(5239), 1,
      sym__initializer,
    ACTIONS(7499), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7495), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150210] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4072), 1,
      sym_comment,
    STATE(4888), 1,
      sym_type_annotation,
    STATE(5944), 1,
      sym__initializer,
    ACTIONS(7499), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7495), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150241] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7543), 1,
      anon_sym_LBRACE,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    STATE(1173), 1,
      sym_class_body,
    STATE(4073), 1,
      sym_comment,
    STATE(4481), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6521), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [150278] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    ACTIONS(7549), 1,
      anon_sym_COMMA,
    ACTIONS(7551), 1,
      anon_sym_RBRACE,
    STATE(4074), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(4518), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [150309] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(3282), 1,
      sym_class_body,
    STATE(4075), 1,
      sym_comment,
    STATE(4468), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6399), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [150346] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4076), 1,
      sym_comment,
    STATE(5321), 1,
      sym_type_annotation,
    STATE(6325), 1,
      sym__initializer,
    ACTIONS(7247), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7245), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150377] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7555), 1,
      anon_sym_BANG,
    ACTIONS(7557), 1,
      anon_sym_QMARK,
    STATE(4077), 1,
      sym_comment,
    STATE(5193), 1,
      sym_type_annotation,
    STATE(5809), 1,
      sym__initializer,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150410] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4078), 1,
      sym_comment,
    ACTIONS(5068), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150431] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4079), 1,
      sym_comment,
    ACTIONS(7559), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [150452] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7561), 1,
      anon_sym_LBRACE,
    ACTIONS(7563), 1,
      anon_sym_DQUOTE,
    ACTIONS(7565), 1,
      anon_sym_SQUOTE,
    ACTIONS(7567), 1,
      anon_sym_LT,
    STATE(3835), 1,
      sym_jsx_opening_element,
    STATE(4080), 1,
      sym_comment,
    STATE(5405), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym__jsx_string,
  [150483] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7561), 1,
      anon_sym_LBRACE,
    ACTIONS(7563), 1,
      anon_sym_DQUOTE,
    ACTIONS(7565), 1,
      anon_sym_SQUOTE,
    ACTIONS(7567), 1,
      anon_sym_LT,
    STATE(3835), 1,
      sym_jsx_opening_element,
    STATE(4081), 1,
      sym_comment,
    STATE(5403), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym__jsx_string,
  [150514] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7572), 1,
      anon_sym_LBRACE,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7569), 2,
      sym_jsx_identifier,
      sym_identifier,
    ACTIONS(7575), 2,
      anon_sym_GT,
      anon_sym_SLASH_GT,
    STATE(4082), 2,
      sym_comment,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [150543] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7577), 1,
      anon_sym_GT,
    ACTIONS(7579), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4083), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [150576] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7581), 1,
      anon_sym_GT,
    ACTIONS(7583), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4084), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [150609] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7585), 1,
      anon_sym_BANG,
    ACTIONS(7587), 1,
      anon_sym_QMARK,
    STATE(4085), 1,
      sym_comment,
    STATE(5341), 1,
      sym_type_annotation,
    STATE(5754), 1,
      sym__initializer,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150642] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3111), 1,
      sym_class_body,
    STATE(4086), 1,
      sym_comment,
    STATE(4341), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6423), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [150679] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7577), 1,
      anon_sym_GT,
    ACTIONS(7591), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4087), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [150712] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(6978), 1,
      anon_sym_LT,
    STATE(2808), 1,
      sym_arguments,
    STATE(3075), 1,
      sym_template_string,
    STATE(4031), 1,
      sym_type_arguments,
    STATE(4088), 1,
      sym_comment,
    STATE(6667), 1,
      sym_optional_chain,
  [150749] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7581), 1,
      anon_sym_GT,
    ACTIONS(7593), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4089), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [150782] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(7457), 1,
      sym_identifier,
    ACTIONS(7595), 1,
      anon_sym_RBRACE,
    STATE(4090), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(5832), 1,
      sym__module_export_name,
    STATE(6537), 1,
      sym_export_specifier,
    ACTIONS(7459), 2,
      anon_sym_type,
      anon_sym_typeof,
  [150817] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4091), 1,
      sym_comment,
    ACTIONS(2185), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150838] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7597), 1,
      anon_sym_BANG,
    ACTIONS(7599), 1,
      anon_sym_QMARK,
    STATE(4092), 1,
      sym_comment,
    STATE(5399), 1,
      sym_type_annotation,
    STATE(5733), 1,
      sym__initializer,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150871] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4093), 1,
      sym_comment,
    ACTIONS(5152), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150892] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7601), 1,
      anon_sym_BANG,
    ACTIONS(7603), 1,
      anon_sym_QMARK,
    STATE(4094), 1,
      sym_comment,
    STATE(5384), 1,
      sym_type_annotation,
    STATE(5719), 1,
      sym__initializer,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150925] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4095), 1,
      sym_comment,
    ACTIONS(5306), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150946] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7605), 1,
      anon_sym_LBRACE,
    STATE(1500), 1,
      sym_class_body,
    STATE(4096), 1,
      sym_comment,
    STATE(4422), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6878), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [150983] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7537), 1,
      anon_sym_AMP,
    STATE(4097), 1,
      sym_comment,
    ACTIONS(5296), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [151006] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    STATE(1085), 1,
      sym_class_body,
    STATE(4098), 1,
      sym_comment,
    STATE(4475), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6461), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [151043] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4099), 1,
      sym_comment,
    ACTIONS(5288), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151064] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4100), 1,
      sym_comment,
    ACTIONS(4873), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151085] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3025), 1,
      sym_class_body,
    STATE(4101), 1,
      sym_comment,
    STATE(4503), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6798), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [151122] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(7055), 1,
      anon_sym_LT,
    STATE(2508), 1,
      sym_template_string,
    STATE(2884), 1,
      sym_arguments,
    STATE(3893), 1,
      sym_type_arguments,
    STATE(4102), 1,
      sym_comment,
    STATE(6617), 1,
      sym_optional_chain,
  [151159] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7537), 1,
      anon_sym_AMP,
    ACTIONS(7539), 1,
      anon_sym_PIPE,
    ACTIONS(7541), 1,
      anon_sym_extends,
    STATE(4103), 1,
      sym_comment,
    ACTIONS(5268), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [151186] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7609), 1,
      anon_sym_LBRACE,
    STATE(960), 1,
      sym_class_body,
    STATE(4104), 1,
      sym_comment,
    STATE(4472), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6445), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [151223] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4105), 1,
      sym_comment,
    ACTIONS(5268), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151244] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7611), 1,
      anon_sym_LBRACE,
    STATE(327), 1,
      sym_class_body,
    STATE(4106), 1,
      sym_comment,
    STATE(4471), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6439), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [151281] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6978), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_arguments,
    STATE(2508), 1,
      sym_template_string,
    STATE(3820), 1,
      sym_type_arguments,
    STATE(4107), 1,
      sym_comment,
    STATE(6617), 1,
      sym_optional_chain,
  [151318] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    STATE(996), 1,
      sym_class_body,
    STATE(4108), 1,
      sym_comment,
    STATE(4470), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6425), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [151355] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7613), 1,
      anon_sym_BANG,
    ACTIONS(7615), 1,
      anon_sym_QMARK,
    STATE(4109), 1,
      sym_comment,
    STATE(5222), 1,
      sym_type_annotation,
    STATE(5701), 1,
      sym__initializer,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [151388] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4110), 1,
      sym_comment,
    ACTIONS(2253), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151409] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7609), 1,
      anon_sym_LBRACE,
    STATE(953), 1,
      sym_class_body,
    STATE(4111), 1,
      sym_comment,
    STATE(4469), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6412), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [151446] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4112), 1,
      sym_comment,
    ACTIONS(5312), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151467] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4113), 1,
      sym_comment,
    ACTIONS(5242), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151488] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7611), 1,
      anon_sym_LBRACE,
    STATE(303), 1,
      sym_class_body,
    STATE(4114), 1,
      sym_comment,
    STATE(4467), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6392), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [151525] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4115), 1,
      sym_comment,
    ACTIONS(5280), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151546] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4116), 1,
      sym_comment,
    STATE(4351), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6219), 1,
      sym_class_body,
    STATE(6448), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [151583] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7619), 1,
      anon_sym_BANG,
    ACTIONS(7621), 1,
      anon_sym_QMARK,
    STATE(4117), 1,
      sym_comment,
    STATE(4879), 1,
      sym_type_annotation,
    STATE(5928), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [151616] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4118), 1,
      sym_comment,
    ACTIONS(5238), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151637] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4119), 1,
      sym_comment,
    ACTIONS(7623), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [151658] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7625), 1,
      anon_sym_LBRACE,
    STATE(4120), 1,
      sym_comment,
    STATE(4363), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6595), 1,
      sym_class_heritage,
    STATE(6880), 1,
      sym_class_body,
    STATE(7265), 1,
      sym_implements_clause,
  [151695] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4121), 1,
      sym_comment,
    ACTIONS(7627), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [151716] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4122), 1,
      sym_comment,
    STATE(5112), 1,
      sym_type_annotation,
    STATE(5849), 1,
      sym__initializer,
    ACTIONS(7185), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7183), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [151747] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3045), 1,
      sym_class_body,
    STATE(4123), 1,
      sym_comment,
    STATE(4477), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6488), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [151784] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4124), 1,
      sym_comment,
    ACTIONS(5222), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151805] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7629), 1,
      anon_sym_BANG,
    ACTIONS(7631), 1,
      anon_sym_QMARK,
    STATE(4125), 1,
      sym_comment,
    STATE(5008), 1,
      sym_type_annotation,
    STATE(5813), 1,
      sym__initializer,
    ACTIONS(7201), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [151838] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7633), 1,
      anon_sym_BANG,
    ACTIONS(7635), 1,
      anon_sym_QMARK,
    STATE(4126), 1,
      sym_comment,
    STATE(5056), 1,
      sym_type_annotation,
    STATE(5780), 1,
      sym__initializer,
    ACTIONS(7201), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [151871] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6978), 1,
      anon_sym_LT,
    ACTIONS(7637), 1,
      anon_sym_DOT,
    STATE(2508), 1,
      sym_template_string,
    STATE(2640), 1,
      sym_arguments,
    STATE(4127), 1,
      sym_comment,
    STATE(5544), 1,
      sym_type_arguments,
    STATE(6617), 1,
      sym_optional_chain,
  [151908] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4128), 1,
      sym_comment,
    ACTIONS(3506), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151929] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4129), 1,
      sym_comment,
    ACTIONS(5208), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151950] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1265), 1,
      sym_class_body,
    STATE(4130), 1,
      sym_comment,
    STATE(4461), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6378), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [151987] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4131), 1,
      sym_comment,
    ACTIONS(7641), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [152008] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6978), 1,
      anon_sym_LT,
    STATE(2508), 1,
      sym_template_string,
    STATE(3301), 1,
      sym_arguments,
    STATE(3820), 1,
      sym_type_arguments,
    STATE(4132), 1,
      sym_comment,
    STATE(6617), 1,
      sym_optional_chain,
  [152045] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4133), 1,
      sym_comment,
    ACTIONS(5200), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [152066] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4134), 1,
      sym_comment,
    ACTIONS(7643), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [152087] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4135), 1,
      sym_comment,
    ACTIONS(3508), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [152108] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    STATE(1152), 1,
      sym_class_body,
    STATE(4136), 1,
      sym_comment,
    STATE(4459), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6432), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [152145] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(7457), 1,
      sym_identifier,
    ACTIONS(7647), 1,
      anon_sym_RBRACE,
    STATE(4137), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(5832), 1,
      sym__module_export_name,
    STATE(6537), 1,
      sym_export_specifier,
    ACTIONS(7459), 2,
      anon_sym_type,
      anon_sym_typeof,
  [152180] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4138), 1,
      sym_comment,
    ACTIONS(3518), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [152201] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7649), 1,
      anon_sym_LBRACE,
    STATE(454), 1,
      sym_class_body,
    STATE(4139), 1,
      sym_comment,
    STATE(4482), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6550), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [152238] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(7651), 1,
      anon_sym_EQ,
    STATE(4140), 1,
      sym_comment,
    ACTIONS(7477), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [152267] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(2922), 1,
      sym_class_body,
    STATE(4141), 1,
      sym_comment,
    STATE(4458), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6447), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [152304] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(6978), 1,
      anon_sym_LT,
    ACTIONS(7653), 1,
      anon_sym_DOT,
    STATE(2508), 1,
      sym_template_string,
    STATE(2924), 1,
      sym_arguments,
    STATE(4142), 1,
      sym_comment,
    STATE(5544), 1,
      sym_type_arguments,
    STATE(6617), 1,
      sym_optional_chain,
  [152341] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7655), 1,
      anon_sym_BANG,
    ACTIONS(7657), 1,
      anon_sym_QMARK,
    STATE(4143), 1,
      sym_comment,
    STATE(4867), 1,
      sym_type_annotation,
    STATE(5916), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [152374] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4144), 1,
      sym_comment,
    ACTIONS(7659), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [152395] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1236), 1,
      sym_class_body,
    STATE(4145), 1,
      sym_comment,
    STATE(4456), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6468), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [152432] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4146), 1,
      sym_comment,
    ACTIONS(7661), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [152453] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7663), 1,
      anon_sym_BANG,
    ACTIONS(7665), 1,
      anon_sym_QMARK,
    STATE(4147), 1,
      sym_comment,
    STATE(5133), 1,
      sym_type_annotation,
    STATE(5683), 1,
      sym__initializer,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [152486] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    STATE(961), 1,
      sym_class_body,
    STATE(4148), 1,
      sym_comment,
    STATE(4452), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6512), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [152523] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7667), 1,
      anon_sym_BANG,
    ACTIONS(7669), 1,
      anon_sym_QMARK,
    STATE(4149), 1,
      sym_comment,
    STATE(5163), 1,
      sym_type_annotation,
    STATE(5691), 1,
      sym__initializer,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [152556] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(7671), 1,
      anon_sym_EQ,
    ACTIONS(7673), 1,
      anon_sym_DOT,
    STATE(4150), 1,
      sym_comment,
    STATE(4337), 1,
      sym_arguments,
    ACTIONS(7483), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [152585] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3139), 1,
      sym_class_body,
    STATE(4151), 1,
      sym_comment,
    STATE(4448), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6579), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [152622] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7675), 1,
      anon_sym_EQ,
    STATE(4152), 1,
      sym_comment,
    ACTIONS(4330), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [152645] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7677), 1,
      anon_sym_EQ,
    STATE(4153), 1,
      sym_comment,
    ACTIONS(4328), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [152668] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7679), 1,
      anon_sym_EQ,
    STATE(4154), 1,
      sym_comment,
    ACTIONS(7623), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [152691] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7681), 1,
      anon_sym_EQ,
    STATE(4155), 1,
      sym_comment,
    ACTIONS(7627), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [152714] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7683), 1,
      anon_sym_EQ,
    STATE(4156), 1,
      sym_comment,
    ACTIONS(7659), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [152737] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7537), 1,
      anon_sym_AMP,
    ACTIONS(7539), 1,
      anon_sym_PIPE,
    ACTIONS(7541), 1,
      anon_sym_extends,
    STATE(4157), 1,
      sym_comment,
    ACTIONS(5047), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [152764] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7685), 1,
      anon_sym_BANG,
    ACTIONS(7687), 1,
      anon_sym_QMARK,
    STATE(4158), 1,
      sym_comment,
    STATE(5218), 1,
      sym_type_annotation,
    STATE(5711), 1,
      sym__initializer,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [152797] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7689), 1,
      anon_sym_BANG,
    ACTIONS(7691), 1,
      anon_sym_QMARK,
    STATE(4159), 1,
      sym_comment,
    STATE(5236), 1,
      sym_type_annotation,
    STATE(5717), 1,
      sym__initializer,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [152830] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7693), 1,
      anon_sym_BANG,
    ACTIONS(7695), 1,
      anon_sym_QMARK,
    STATE(4160), 1,
      sym_comment,
    STATE(5376), 1,
      sym_type_annotation,
    STATE(5731), 1,
      sym__initializer,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [152863] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7697), 1,
      anon_sym_BANG,
    ACTIONS(7699), 1,
      anon_sym_QMARK,
    STATE(4161), 1,
      sym_comment,
    STATE(5342), 1,
      sym_type_annotation,
    STATE(5765), 1,
      sym__initializer,
    ACTIONS(7273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [152896] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7537), 1,
      anon_sym_AMP,
    ACTIONS(7539), 1,
      anon_sym_PIPE,
    ACTIONS(7541), 1,
      anon_sym_extends,
    STATE(4162), 1,
      sym_comment,
    ACTIONS(5051), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [152923] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(6978), 1,
      anon_sym_LT,
    ACTIONS(7701), 1,
      anon_sym_DOT,
    STATE(3012), 1,
      sym_arguments,
    STATE(3075), 1,
      sym_template_string,
    STATE(4163), 1,
      sym_comment,
    STATE(5479), 1,
      sym_type_arguments,
    STATE(6667), 1,
      sym_optional_chain,
  [152960] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7703), 1,
      anon_sym_BANG,
    ACTIONS(7705), 1,
      anon_sym_QMARK,
    STATE(4164), 1,
      sym_comment,
    STATE(4860), 1,
      sym_type_annotation,
    STATE(5914), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [152993] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7605), 1,
      anon_sym_LBRACE,
    STATE(1456), 1,
      sym_class_body,
    STATE(4165), 1,
      sym_comment,
    STATE(4476), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6610), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [153030] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7707), 1,
      anon_sym_GT,
    ACTIONS(7709), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4166), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153063] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4167), 1,
      sym_comment,
    STATE(4434), 1,
      sym_type_parameters,
    STATE(5324), 1,
      sym_class_body,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6867), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [153100] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7711), 1,
      anon_sym_GT,
    ACTIONS(7713), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4168), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153133] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(6978), 1,
      anon_sym_LT,
    STATE(3075), 1,
      sym_template_string,
    STATE(3261), 1,
      sym_arguments,
    STATE(4031), 1,
      sym_type_arguments,
    STATE(4169), 1,
      sym_comment,
    STATE(6667), 1,
      sym_optional_chain,
  [153170] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7715), 1,
      anon_sym_BANG,
    ACTIONS(7717), 1,
      anon_sym_QMARK,
    STATE(4170), 1,
      sym_comment,
    STATE(4912), 1,
      sym_type_annotation,
    STATE(5984), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153203] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7719), 1,
      anon_sym_GT,
    ACTIONS(7721), 1,
      anon_sym_SLASH_GT,
    STATE(4084), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4171), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153236] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7723), 1,
      anon_sym_GT,
    ACTIONS(7725), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4172), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153269] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7581), 1,
      anon_sym_GT,
    ACTIONS(7727), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4173), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153302] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7577), 1,
      anon_sym_GT,
    ACTIONS(7729), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4174), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153335] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4175), 1,
      sym_comment,
    STATE(4421), 1,
      sym_type_parameters,
    STATE(5098), 1,
      sym_class_body,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6888), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [153372] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7731), 1,
      anon_sym_GT,
    ACTIONS(7733), 1,
      anon_sym_SLASH_GT,
    STATE(4083), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4176), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153405] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7735), 1,
      anon_sym_LBRACE,
    STATE(391), 1,
      sym_class_body,
    STATE(4177), 1,
      sym_comment,
    STATE(4420), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6900), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [153442] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7737), 1,
      anon_sym_GT,
    ACTIONS(7739), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4178), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153475] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(6978), 1,
      anon_sym_LT,
    ACTIONS(7741), 1,
      anon_sym_DOT,
    STATE(3075), 1,
      sym_template_string,
    STATE(3286), 1,
      sym_arguments,
    STATE(4179), 1,
      sym_comment,
    STATE(5479), 1,
      sym_type_arguments,
    STATE(6667), 1,
      sym_optional_chain,
  [153512] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4180), 1,
      sym_comment,
    ACTIONS(5284), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153533] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4181), 1,
      sym_comment,
    STATE(4418), 1,
      sym_type_parameters,
    STATE(4983), 1,
      sym_class_body,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6917), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [153570] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7707), 1,
      anon_sym_GT,
    ACTIONS(7743), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4182), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153603] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7711), 1,
      anon_sym_GT,
    ACTIONS(7745), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4183), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153636] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7719), 1,
      anon_sym_GT,
    ACTIONS(7747), 1,
      anon_sym_SLASH_GT,
    STATE(4173), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4184), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153669] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7723), 1,
      anon_sym_GT,
    ACTIONS(7749), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4185), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153702] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7731), 1,
      anon_sym_GT,
    ACTIONS(7751), 1,
      anon_sym_SLASH_GT,
    STATE(4174), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4186), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153735] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4187), 1,
      sym_comment,
    ACTIONS(3540), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153756] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7737), 1,
      anon_sym_GT,
    ACTIONS(7753), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4188), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [153789] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7755), 1,
      anon_sym_BANG,
    ACTIONS(7757), 1,
      anon_sym_QMARK,
    STATE(4189), 1,
      sym_comment,
    STATE(4917), 1,
      sym_type_annotation,
    STATE(5991), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153822] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4190), 1,
      sym_comment,
    STATE(5234), 1,
      sym_type_annotation,
    STATE(5800), 1,
      sym__initializer,
    ACTIONS(7761), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7759), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153853] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7763), 1,
      anon_sym_BANG,
    ACTIONS(7765), 1,
      anon_sym_QMARK,
    STATE(4191), 1,
      sym_comment,
    STATE(4855), 1,
      sym_type_annotation,
    STATE(5912), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153886] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4192), 1,
      sym_comment,
    ACTIONS(3570), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153907] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7767), 1,
      anon_sym_EQ,
    STATE(4193), 1,
      sym_comment,
    ACTIONS(7661), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [153930] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7769), 1,
      anon_sym_BANG,
    ACTIONS(7771), 1,
      anon_sym_QMARK,
    STATE(4194), 1,
      sym_comment,
    STATE(4846), 1,
      sym_type_annotation,
    STATE(5903), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153963] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4195), 1,
      sym_comment,
    STATE(4415), 1,
      sym_type_parameters,
    STATE(4935), 1,
      sym_class_body,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6960), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [154000] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(7445), 1,
      sym_identifier,
    ACTIONS(7447), 1,
      anon_sym_type,
    ACTIONS(7453), 1,
      anon_sym_typeof,
    STATE(4196), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(6472), 1,
      sym_import_specifier,
    STATE(6907), 1,
      sym__import_identifier,
    STATE(7043), 1,
      sym__module_export_name,
  [154037] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4197), 1,
      sym_comment,
    ACTIONS(7773), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [154058] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7775), 1,
      anon_sym_BANG,
    ACTIONS(7777), 1,
      anon_sym_QMARK,
    STATE(4198), 1,
      sym_comment,
    STATE(4897), 1,
      sym_type_annotation,
    STATE(5900), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154091] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4199), 1,
      sym_comment,
    ACTIONS(5092), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154112] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4200), 1,
      sym_comment,
    ACTIONS(5088), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154133] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7779), 1,
      anon_sym_BANG,
    ACTIONS(7781), 1,
      anon_sym_QMARK,
    STATE(4201), 1,
      sym_comment,
    STATE(4927), 1,
      sym_type_annotation,
    STATE(6003), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154166] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7783), 1,
      anon_sym_BANG,
    ACTIONS(7785), 1,
      anon_sym_QMARK,
    STATE(4202), 1,
      sym_comment,
    STATE(4932), 1,
      sym_type_annotation,
    STATE(6014), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154199] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7342), 1,
      anon_sym_GT,
    ACTIONS(7344), 1,
      anon_sym_SLASH_GT,
    STATE(4182), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4203), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [154232] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4204), 1,
      sym_comment,
    ACTIONS(4328), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [154253] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4205), 1,
      sym_comment,
    ACTIONS(5072), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154274] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7735), 1,
      anon_sym_LBRACE,
    STATE(356), 1,
      sym_class_body,
    STATE(4206), 1,
      sym_comment,
    STATE(4412), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6952), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [154311] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6978), 1,
      anon_sym_LT,
    STATE(4207), 1,
      sym_comment,
    STATE(5544), 1,
      sym_type_arguments,
    STATE(6617), 1,
      sym_optional_chain,
    STATE(2508), 2,
      sym_template_string,
      sym_arguments,
  [154346] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4208), 1,
      sym_comment,
    ACTIONS(5062), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154367] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7537), 1,
      anon_sym_AMP,
    ACTIONS(7539), 1,
      anon_sym_PIPE,
    ACTIONS(7541), 1,
      anon_sym_extends,
    STATE(4209), 1,
      sym_comment,
    ACTIONS(5062), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [154394] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7787), 1,
      anon_sym_BANG,
    ACTIONS(7789), 1,
      anon_sym_QMARK,
    STATE(4210), 1,
      sym_comment,
    STATE(4939), 1,
      sym_type_annotation,
    STATE(6029), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154427] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7625), 1,
      anon_sym_LBRACE,
    STATE(4211), 1,
      sym_comment,
    STATE(4344), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6357), 1,
      sym_class_heritage,
    STATE(6376), 1,
      sym_class_body,
    STATE(7265), 1,
      sym_implements_clause,
  [154464] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2454), 1,
      sym_class_body,
    STATE(4212), 1,
      sym_comment,
    STATE(4352), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6496), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [154501] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2712), 1,
      anon_sym_RBRACE,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    ACTIONS(7549), 1,
      anon_sym_COMMA,
    STATE(4213), 1,
      sym_comment,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4518), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [154532] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7707), 1,
      anon_sym_GT,
    ACTIONS(7791), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4214), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [154565] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4215), 1,
      sym_comment,
    ACTIONS(7793), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [154586] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7795), 1,
      anon_sym_BANG,
    ACTIONS(7797), 1,
      anon_sym_QMARK,
    STATE(4216), 1,
      sym_comment,
    STATE(5288), 1,
      sym_type_annotation,
    STATE(6020), 1,
      sym__initializer,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154619] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    ACTIONS(7549), 1,
      anon_sym_COMMA,
    ACTIONS(7799), 1,
      anon_sym_RBRACE,
    STATE(4217), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(4518), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [154650] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7801), 1,
      anon_sym_BANG,
    ACTIONS(7803), 1,
      anon_sym_QMARK,
    STATE(4218), 1,
      sym_comment,
    STATE(4951), 1,
      sym_type_annotation,
    STATE(6057), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154683] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7805), 1,
      anon_sym_BANG,
    ACTIONS(7807), 1,
      anon_sym_QMARK,
    STATE(4219), 1,
      sym_comment,
    STATE(5322), 1,
      sym_type_annotation,
    STATE(6037), 1,
      sym__initializer,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154716] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7809), 1,
      anon_sym_BANG,
    ACTIONS(7811), 1,
      anon_sym_QMARK,
    STATE(4220), 1,
      sym_comment,
    STATE(5348), 1,
      sym_type_annotation,
    STATE(6055), 1,
      sym__initializer,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154749] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7813), 1,
      anon_sym_BANG,
    ACTIONS(7815), 1,
      anon_sym_QMARK,
    STATE(4221), 1,
      sym_comment,
    STATE(5360), 1,
      sym_type_annotation,
    STATE(6059), 1,
      sym__initializer,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154782] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7711), 1,
      anon_sym_GT,
    ACTIONS(7817), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4222), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [154815] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(2973), 1,
      sym_class_body,
    STATE(4223), 1,
      sym_comment,
    STATE(4372), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6545), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [154852] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7819), 1,
      anon_sym_BANG,
    ACTIONS(7821), 1,
      anon_sym_QMARK,
    STATE(4224), 1,
      sym_comment,
    STATE(5375), 1,
      sym_type_annotation,
    STATE(6191), 1,
      sym__initializer,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154885] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7823), 1,
      anon_sym_BANG,
    ACTIONS(7825), 1,
      anon_sym_QMARK,
    STATE(4225), 1,
      sym_comment,
    STATE(5352), 1,
      sym_type_annotation,
    STATE(6231), 1,
      sym__initializer,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154918] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7827), 1,
      anon_sym_BANG,
    ACTIONS(7829), 1,
      anon_sym_QMARK,
    STATE(4226), 1,
      sym_comment,
    STATE(5323), 1,
      sym_type_annotation,
    STATE(6306), 1,
      sym__initializer,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154951] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7719), 1,
      anon_sym_GT,
    ACTIONS(7831), 1,
      anon_sym_SLASH_GT,
    STATE(4089), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4227), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [154984] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7833), 1,
      anon_sym_LBRACK,
    STATE(4228), 1,
      sym_comment,
    ACTIONS(5122), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155007] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7835), 1,
      anon_sym_extends,
    STATE(4229), 1,
      sym_comment,
    ACTIONS(5116), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [155030] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2667), 1,
      anon_sym_RBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    ACTIONS(7549), 1,
      anon_sym_COMMA,
    STATE(4230), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(4518), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [155061] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7833), 1,
      anon_sym_LBRACK,
    STATE(4231), 1,
      sym_comment,
    ACTIONS(4883), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(5084), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155086] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7537), 1,
      anon_sym_AMP,
    ACTIONS(7539), 1,
      anon_sym_PIPE,
    ACTIONS(7541), 1,
      anon_sym_extends,
    STATE(4232), 1,
      sym_comment,
    ACTIONS(5076), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [155113] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7837), 1,
      anon_sym_BANG,
    ACTIONS(7839), 1,
      anon_sym_QMARK,
    STATE(4233), 1,
      sym_comment,
    STATE(5235), 1,
      sym_type_annotation,
    STATE(6258), 1,
      sym__initializer,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155146] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7543), 1,
      anon_sym_LBRACE,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    STATE(1404), 1,
      sym_class_body,
    STATE(4234), 1,
      sym_comment,
    STATE(4505), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6818), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [155183] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4235), 1,
      sym_comment,
    ACTIONS(5351), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155204] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7841), 1,
      anon_sym_BANG,
    ACTIONS(7843), 1,
      anon_sym_QMARK,
    STATE(4236), 1,
      sym_comment,
    STATE(5228), 1,
      sym_type_annotation,
    STATE(6250), 1,
      sym__initializer,
    ACTIONS(7189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155237] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4237), 1,
      sym_comment,
    ACTIONS(5043), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155258] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7845), 1,
      anon_sym_LBRACE,
    STATE(1368), 1,
      sym_class_body,
    STATE(4238), 1,
      sym_comment,
    STATE(4399), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6611), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [155295] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7847), 1,
      anon_sym_COLON,
    STATE(4239), 1,
      sym_comment,
    STATE(5194), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7507), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155320] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4240), 1,
      sym_comment,
    ACTIONS(5031), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155341] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7537), 1,
      anon_sym_AMP,
    STATE(4241), 1,
      sym_comment,
    ACTIONS(5027), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [155364] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6978), 1,
      anon_sym_LT,
    STATE(2508), 1,
      sym_template_string,
    STATE(2618), 1,
      sym_arguments,
    STATE(3820), 1,
      sym_type_arguments,
    STATE(4242), 1,
      sym_comment,
    STATE(6617), 1,
      sym_optional_chain,
  [155401] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4243), 1,
      sym_comment,
    ACTIONS(5355), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155422] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4244), 1,
      sym_comment,
    ACTIONS(5007), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155443] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7581), 1,
      anon_sym_GT,
    ACTIONS(7849), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4245), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [155476] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7577), 1,
      anon_sym_GT,
    ACTIONS(7851), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4246), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [155509] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4247), 1,
      sym_comment,
    ACTIONS(5003), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155530] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7853), 1,
      anon_sym_LBRACE,
    STATE(1072), 1,
      sym_class_body,
    STATE(4248), 1,
      sym_comment,
    STATE(4396), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6548), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [155567] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4249), 1,
      sym_comment,
    ACTIONS(4999), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155588] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7855), 1,
      anon_sym_LBRACE,
    STATE(352), 1,
      sym_class_body,
    STATE(4250), 1,
      sym_comment,
    STATE(4394), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6534), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [155625] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6978), 1,
      anon_sym_LT,
    ACTIONS(7857), 1,
      anon_sym_DOT,
    STATE(2508), 1,
      sym_template_string,
    STATE(2979), 1,
      sym_arguments,
    STATE(4251), 1,
      sym_comment,
    STATE(5544), 1,
      sym_type_arguments,
    STATE(6617), 1,
      sym_optional_chain,
  [155662] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4252), 1,
      sym_comment,
    ACTIONS(5359), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155683] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4253), 1,
      sym_comment,
    ACTIONS(5334), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155704] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7845), 1,
      anon_sym_LBRACE,
    STATE(1307), 1,
      sym_class_body,
    STATE(4254), 1,
      sym_comment,
    STATE(4392), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6490), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [155741] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7847), 1,
      anon_sym_COLON,
    STATE(4255), 1,
      sym_comment,
    STATE(5039), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7515), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155766] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4256), 1,
      sym_comment,
    ACTIONS(5212), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155787] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7707), 1,
      anon_sym_GT,
    ACTIONS(7859), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4257), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [155820] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7711), 1,
      anon_sym_GT,
    ACTIONS(7861), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4258), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [155853] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7719), 1,
      anon_sym_GT,
    ACTIONS(7863), 1,
      anon_sym_SLASH_GT,
    STATE(4245), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4259), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [155886] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7723), 1,
      anon_sym_GT,
    ACTIONS(7865), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4260), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [155919] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7731), 1,
      anon_sym_GT,
    ACTIONS(7867), 1,
      anon_sym_SLASH_GT,
    STATE(4246), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4261), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [155952] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7737), 1,
      anon_sym_GT,
    ACTIONS(7869), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4262), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [155985] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4263), 1,
      sym_comment,
    ACTIONS(5156), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156006] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2710), 1,
      anon_sym_RBRACE,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    ACTIONS(7549), 1,
      anon_sym_COMMA,
    STATE(4264), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(4518), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [156037] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7049), 1,
      anon_sym_SLASH_GT,
    ACTIONS(7342), 1,
      anon_sym_GT,
    STATE(4166), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4265), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [156070] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4266), 1,
      sym_comment,
    ACTIONS(5015), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156091] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4267), 1,
      sym_comment,
    ACTIONS(5011), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156112] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7853), 1,
      anon_sym_LBRACE,
    STATE(1007), 1,
      sym_class_body,
    STATE(4268), 1,
      sym_comment,
    STATE(4390), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6420), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [156149] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    ACTIONS(7549), 1,
      anon_sym_COMMA,
    ACTIONS(7871), 1,
      anon_sym_RBRACE,
    STATE(4269), 1,
      sym_comment,
    STATE(5868), 1,
      aux_sym_object_repeat1,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4518), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [156180] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7025), 1,
      anon_sym_SLASH_GT,
    ACTIONS(7342), 1,
      anon_sym_GT,
    STATE(4214), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4270), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [156213] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4271), 1,
      sym_comment,
    ACTIONS(4995), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156234] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7649), 1,
      anon_sym_LBRACE,
    STATE(448), 1,
      sym_class_body,
    STATE(4272), 1,
      sym_comment,
    STATE(4521), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6959), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [156271] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7342), 1,
      anon_sym_GT,
    ACTIONS(7362), 1,
      anon_sym_SLASH_GT,
    STATE(4257), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4273), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [156304] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4274), 1,
      sym_comment,
    ACTIONS(5156), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156325] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4275), 1,
      sym_comment,
    ACTIONS(5108), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156346] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7855), 1,
      anon_sym_LBRACE,
    STATE(351), 1,
      sym_class_body,
    STATE(4276), 1,
      sym_comment,
    STATE(4385), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6336), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [156383] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7833), 1,
      anon_sym_LBRACK,
    STATE(4277), 1,
      sym_comment,
    ACTIONS(4883), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156406] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4278), 1,
      sym_comment,
    ACTIONS(5108), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156427] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4279), 1,
      sym_comment,
    ACTIONS(4883), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156448] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4280), 1,
      sym_comment,
    ACTIONS(5292), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156469] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7723), 1,
      anon_sym_GT,
    ACTIONS(7873), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4281), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [156502] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_BANG,
    ACTIONS(7877), 1,
      anon_sym_QMARK,
    STATE(4282), 1,
      sym_comment,
    STATE(4961), 1,
      sym_type_annotation,
    STATE(6068), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156535] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7879), 1,
      anon_sym_BANG,
    ACTIONS(7881), 1,
      anon_sym_QMARK,
    STATE(4283), 1,
      sym_comment,
    STATE(4966), 1,
      sym_type_annotation,
    STATE(6102), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156568] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4284), 1,
      sym_comment,
    ACTIONS(4843), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156589] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7885), 1,
      anon_sym_BANG,
    ACTIONS(7887), 1,
      anon_sym_QMARK,
    STATE(4285), 1,
      sym_comment,
    STATE(5238), 1,
      sym_type_annotation,
    STATE(6283), 1,
      sym__initializer,
    ACTIONS(7883), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156622] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4286), 1,
      sym_comment,
    ACTIONS(5190), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156643] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4287), 1,
      sym_comment,
    STATE(4347), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(5969), 1,
      sym_class_body,
    STATE(6409), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [156680] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4288), 1,
      sym_comment,
    ACTIONS(7889), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [156701] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4289), 1,
      sym_comment,
    STATE(5025), 1,
      sym_type_annotation,
    STATE(6125), 1,
      sym__initializer,
    ACTIONS(7291), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7289), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156732] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4899), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5400), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    ACTIONS(6978), 1,
      anon_sym_LT,
    STATE(4290), 1,
      sym_comment,
    STATE(5479), 1,
      sym_type_arguments,
    STATE(6667), 1,
      sym_optional_chain,
    STATE(3075), 2,
      sym_template_string,
      sym_arguments,
  [156767] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    ACTIONS(7549), 1,
      anon_sym_COMMA,
    ACTIONS(7891), 1,
      anon_sym_RBRACE,
    STATE(4291), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6261), 1,
      aux_sym_object_repeat1,
    ACTIONS(4518), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [156798] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2512), 1,
      sym_class_body,
    STATE(4292), 1,
      sym_comment,
    STATE(4346), 1,
      sym_type_parameters,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6398), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [156835] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7537), 1,
      anon_sym_AMP,
    ACTIONS(7539), 1,
      anon_sym_PIPE,
    ACTIONS(7541), 1,
      anon_sym_extends,
    STATE(4293), 1,
      sym_comment,
    ACTIONS(5226), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [156862] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4294), 1,
      sym_comment,
    ACTIONS(5230), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156883] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7893), 1,
      anon_sym_BANG,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    STATE(4295), 1,
      sym_comment,
    STATE(4965), 1,
      sym_type_annotation,
    STATE(6072), 1,
      sym__initializer,
    ACTIONS(7883), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156916] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7897), 1,
      anon_sym_BANG,
    ACTIONS(7899), 1,
      anon_sym_QMARK,
    STATE(4296), 1,
      sym_comment,
    STATE(4977), 1,
      sym_type_annotation,
    STATE(6085), 1,
      sym__initializer,
    ACTIONS(7225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156949] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4297), 1,
      sym_comment,
    ACTIONS(4974), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156970] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4298), 1,
      sym_comment,
    ACTIONS(4857), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156991] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7737), 1,
      anon_sym_GT,
    ACTIONS(7901), 1,
      anon_sym_SLASH_GT,
    STATE(4082), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4299), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [157024] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7014), 1,
      anon_sym_LBRACE,
    ACTIONS(7731), 1,
      anon_sym_GT,
    ACTIONS(7903), 1,
      anon_sym_SLASH_GT,
    STATE(4087), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(4300), 1,
      sym_comment,
    STATE(4832), 1,
      sym_jsx_namespace_name,
    ACTIONS(7010), 2,
      sym_jsx_identifier,
      sym_identifier,
    STATE(4937), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [157057] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7905), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7907), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7909), 1,
      anon_sym_QMARK_COLON,
    STATE(4301), 1,
      sym_comment,
    STATE(5216), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [157085] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(7911), 1,
      anon_sym_enum,
    STATE(4302), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5459), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [157117] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_extends,
    STATE(4303), 1,
      sym_comment,
    ACTIONS(7913), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [157143] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_extends,
    STATE(4304), 1,
      sym_comment,
    ACTIONS(7915), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [157169] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_extends,
    STATE(4305), 1,
      sym_comment,
    ACTIONS(7917), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [157195] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7905), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7907), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7909), 1,
      anon_sym_QMARK_COLON,
    STATE(4306), 1,
      sym_comment,
    STATE(5055), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [157223] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7905), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7907), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7909), 1,
      anon_sym_QMARK_COLON,
    STATE(4307), 1,
      sym_comment,
    STATE(5044), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [157251] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7497), 1,
      anon_sym_BANG,
    STATE(4308), 1,
      sym_comment,
    STATE(4888), 1,
      sym_type_annotation,
    STATE(5942), 1,
      sym__initializer,
    ACTIONS(7495), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157281] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7537), 1,
      anon_sym_AMP,
    ACTIONS(7539), 1,
      anon_sym_PIPE,
    ACTIONS(7541), 1,
      anon_sym_extends,
    STATE(4309), 1,
      sym_comment,
    ACTIONS(7477), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157307] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7075), 1,
      anon_sym_LPAREN,
    ACTIONS(7919), 1,
      anon_sym_DOT,
    STATE(4310), 1,
      sym_comment,
    STATE(4665), 1,
      sym_arguments,
    ACTIONS(7483), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157333] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7921), 1,
      sym_escape_sequence,
    ACTIONS(7923), 1,
      anon_sym_BQUOTE,
    ACTIONS(7925), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7927), 1,
      sym__template_chars,
    STATE(4311), 1,
      sym_comment,
    STATE(4788), 1,
      aux_sym_template_string_repeat1,
    STATE(5108), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5469), 1,
      sym_template_substitution,
    STATE(6164), 1,
      sym_template_type,
  [157367] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7905), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7907), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7909), 1,
      anon_sym_QMARK_COLON,
    STATE(4312), 1,
      sym_comment,
    STATE(4868), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [157395] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7905), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7907), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7909), 1,
      anon_sym_QMARK_COLON,
    STATE(4313), 1,
      sym_comment,
    STATE(4866), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [157423] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(7929), 1,
      anon_sym_enum,
    STATE(4314), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5481), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [157455] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(7931), 1,
      anon_sym_enum,
    STATE(4315), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5443), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [157487] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7905), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7907), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7909), 1,
      anon_sym_QMARK_COLON,
    STATE(4316), 1,
      sym_comment,
    STATE(5186), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [157515] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(7933), 1,
      anon_sym_enum,
    STATE(4317), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5416), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [157547] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7905), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7907), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7909), 1,
      anon_sym_QMARK_COLON,
    STATE(4318), 1,
      sym_comment,
    STATE(5214), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [157575] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7905), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7907), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7909), 1,
      anon_sym_QMARK_COLON,
    STATE(4319), 1,
      sym_comment,
    STATE(5052), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [157603] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7935), 1,
      sym_identifier,
    ACTIONS(7937), 1,
      anon_sym_const,
    ACTIONS(7939), 1,
      anon_sym_GT,
    ACTIONS(7941), 1,
      sym_jsx_identifier,
    ACTIONS(7943), 1,
      anon_sym_SLASH_GT,
    STATE(3939), 1,
      sym_nested_identifier,
    STATE(4265), 1,
      sym_jsx_namespace_name,
    STATE(4320), 1,
      sym_comment,
    STATE(5794), 1,
      sym_type_parameter,
  [157637] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7921), 1,
      sym_escape_sequence,
    ACTIONS(7925), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7927), 1,
      sym__template_chars,
    ACTIONS(7945), 1,
      anon_sym_BQUOTE,
    STATE(4321), 1,
      sym_comment,
    STATE(4788), 1,
      aux_sym_template_string_repeat1,
    STATE(5108), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5469), 1,
      sym_template_substitution,
    STATE(6164), 1,
      sym_template_type,
  [157671] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7949), 1,
      anon_sym_DOT,
    STATE(4322), 1,
      sym_comment,
    ACTIONS(7947), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [157693] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(7951), 1,
      anon_sym_enum,
    STATE(4323), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5572), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [157725] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7937), 1,
      anon_sym_const,
    ACTIONS(7939), 1,
      anon_sym_GT,
    ACTIONS(7953), 1,
      sym_identifier,
    ACTIONS(7955), 1,
      sym_jsx_identifier,
    ACTIONS(7957), 1,
      anon_sym_SLASH_GT,
    STATE(3930), 1,
      sym_nested_identifier,
    STATE(4270), 1,
      sym_jsx_namespace_name,
    STATE(4324), 1,
      sym_comment,
    STATE(5794), 1,
      sym_type_parameter,
  [157759] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(7457), 1,
      sym_identifier,
    STATE(4325), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(5832), 1,
      sym__module_export_name,
    STATE(6537), 1,
      sym_export_specifier,
    ACTIONS(7459), 2,
      anon_sym_type,
      anon_sym_typeof,
  [157791] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7921), 1,
      sym_escape_sequence,
    ACTIONS(7925), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7927), 1,
      sym__template_chars,
    ACTIONS(7959), 1,
      anon_sym_BQUOTE,
    STATE(4326), 1,
      sym_comment,
    STATE(4741), 1,
      aux_sym_template_string_repeat1,
    STATE(5108), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5469), 1,
      sym_template_substitution,
    STATE(6164), 1,
      sym_template_type,
  [157825] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7921), 1,
      sym_escape_sequence,
    ACTIONS(7925), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7927), 1,
      sym__template_chars,
    ACTIONS(7961), 1,
      anon_sym_BQUOTE,
    STATE(4327), 1,
      sym_comment,
    STATE(4788), 1,
      aux_sym_template_string_repeat1,
    STATE(5108), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5469), 1,
      sym_template_substitution,
    STATE(6164), 1,
      sym_template_type,
  [157859] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7921), 1,
      sym_escape_sequence,
    ACTIONS(7925), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7927), 1,
      sym__template_chars,
    ACTIONS(7963), 1,
      anon_sym_BQUOTE,
    STATE(4328), 1,
      sym_comment,
    STATE(4788), 1,
      aux_sym_template_string_repeat1,
    STATE(5108), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5469), 1,
      sym_template_substitution,
    STATE(6164), 1,
      sym_template_type,
  [157893] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    ACTIONS(7967), 1,
      anon_sym_DOT,
    STATE(4329), 1,
      sym_comment,
    STATE(4996), 1,
      sym_statement_block,
    ACTIONS(2061), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [157919] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    ACTIONS(7969), 1,
      anon_sym_DOT,
    STATE(4330), 1,
      sym_comment,
    STATE(4996), 1,
      sym_statement_block,
    ACTIONS(2061), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [157945] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4331), 1,
      sym_comment,
    ACTIONS(6224), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [157965] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4332), 1,
      sym_comment,
    ACTIONS(7971), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [157985] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    ACTIONS(7905), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7907), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7909), 1,
      anon_sym_QMARK_COLON,
    STATE(4333), 1,
      sym_comment,
    STATE(5150), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [158013] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7921), 1,
      sym_escape_sequence,
    ACTIONS(7925), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7927), 1,
      sym__template_chars,
    ACTIONS(7973), 1,
      anon_sym_BQUOTE,
    STATE(4334), 1,
      sym_comment,
    STATE(4741), 1,
      aux_sym_template_string_repeat1,
    STATE(5108), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5469), 1,
      sym_template_substitution,
    STATE(6164), 1,
      sym_template_type,
  [158047] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7921), 1,
      sym_escape_sequence,
    ACTIONS(7925), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7927), 1,
      sym__template_chars,
    ACTIONS(7975), 1,
      anon_sym_BQUOTE,
    STATE(4335), 1,
      sym_comment,
    STATE(4788), 1,
      aux_sym_template_string_repeat1,
    STATE(5108), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5469), 1,
      sym_template_substitution,
    STATE(6164), 1,
      sym_template_type,
  [158081] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7921), 1,
      sym_escape_sequence,
    ACTIONS(7925), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7927), 1,
      sym__template_chars,
    ACTIONS(7977), 1,
      anon_sym_BQUOTE,
    STATE(4336), 1,
      sym_comment,
    STATE(4788), 1,
      aux_sym_template_string_repeat1,
    STATE(5020), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5469), 1,
      sym_template_substitution,
    STATE(6164), 1,
      sym_template_type,
  [158115] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7979), 1,
      anon_sym_EQ,
    STATE(4337), 1,
      sym_comment,
    ACTIONS(7971), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [158137] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7981), 1,
      anon_sym_EQ,
    STATE(4338), 1,
      sym_comment,
    ACTIONS(6224), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [158159] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_enum,
    STATE(4339), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5575), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [158191] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4340), 1,
      sym_comment,
    STATE(5365), 1,
      sym_type_annotation,
    STATE(6063), 1,
      sym__initializer,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158218] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3182), 1,
      sym_class_body,
    STATE(4341), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6592), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [158249] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4342), 1,
      sym_comment,
    STATE(4905), 1,
      sym_type_annotation,
    STATE(5978), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158276] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4343), 1,
      sym_comment,
    STATE(4903), 1,
      sym_type_annotation,
    STATE(5977), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158303] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7625), 1,
      anon_sym_LBRACE,
    STATE(4344), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6542), 1,
      sym_class_heritage,
    STATE(6733), 1,
      sym_class_body,
    STATE(7265), 1,
      sym_implements_clause,
  [158334] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4345), 1,
      sym_comment,
    STATE(4892), 1,
      sym_type_annotation,
    STATE(5945), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158361] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2451), 1,
      sym_class_body,
    STATE(4346), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6475), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [158392] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4347), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6223), 1,
      sym_class_body,
    STATE(6436), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [158423] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2430), 1,
      sym_class_body,
    STATE(4348), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6430), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [158454] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4349), 1,
      sym_comment,
    STATE(4877), 1,
      sym_type_annotation,
    STATE(5927), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158481] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4350), 1,
      sym_comment,
    STATE(4923), 1,
      sym_type_annotation,
    STATE(6001), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158508] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4351), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6030), 1,
      sym_class_body,
    STATE(6599), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [158539] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2529), 1,
      sym_class_body,
    STATE(4352), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6642), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [158570] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4353), 1,
      sym_comment,
    STATE(4908), 1,
      sym_type_annotation,
    STATE(5981), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158597] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4354), 1,
      sym_comment,
    STATE(4910), 1,
      sym_type_annotation,
    STATE(5982), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158624] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4355), 1,
      sym_comment,
    STATE(4853), 1,
      sym_type_annotation,
    STATE(5911), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158651] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4356), 1,
      sym_comment,
    STATE(4851), 1,
      sym_type_annotation,
    STATE(5905), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158678] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4357), 1,
      sym_comment,
    STATE(5120), 1,
      sym_type_annotation,
    STATE(6168), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158705] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4358), 1,
      sym_comment,
    STATE(5125), 1,
      sym_type_annotation,
    STATE(5908), 1,
      sym__initializer,
    ACTIONS(7985), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158732] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4359), 1,
      sym_comment,
    STATE(5155), 1,
      sym_type_annotation,
    STATE(5909), 1,
      sym__initializer,
    ACTIONS(7985), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158759] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4360), 1,
      sym_comment,
    STATE(4925), 1,
      sym_type_annotation,
    STATE(6002), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158786] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4361), 1,
      sym_comment,
    STATE(4911), 1,
      sym_type_annotation,
    STATE(5896), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158813] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4362), 1,
      sym_comment,
    STATE(4936), 1,
      sym_type_annotation,
    STATE(5894), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158840] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7625), 1,
      anon_sym_LBRACE,
    STATE(4363), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6750), 1,
      sym_class_heritage,
    STATE(6954), 1,
      sym_class_body,
    STATE(7265), 1,
      sym_implements_clause,
  [158871] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4364), 1,
      sym_comment,
    STATE(4947), 1,
      sym_type_annotation,
    STATE(6048), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158898] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4365), 1,
      sym_comment,
    STATE(4949), 1,
      sym_type_annotation,
    STATE(6049), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158925] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4366), 1,
      sym_comment,
    STATE(4957), 1,
      sym_type_annotation,
    STATE(6066), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158952] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7987), 1,
      sym__automatic_semicolon,
    STATE(4367), 1,
      sym_comment,
    ACTIONS(2115), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [158973] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4368), 1,
      sym_comment,
    STATE(4959), 1,
      sym_type_annotation,
    STATE(6067), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159000] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4369), 1,
      sym_comment,
    STATE(4973), 1,
      sym_type_annotation,
    STATE(6078), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159027] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(128), 1,
      anon_sym_import,
    ACTIONS(7989), 1,
      sym_identifier,
    STATE(2476), 1,
      sym__type_query_subscript_expression,
    STATE(2487), 1,
      sym__type_query_member_expression,
    STATE(2865), 1,
      sym__type_query_instantiation_expression,
    STATE(2866), 1,
      sym__type_query_call_expression,
    STATE(4370), 1,
      sym_comment,
    STATE(5463), 1,
      sym_import,
  [159058] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4371), 1,
      sym_comment,
    STATE(5010), 1,
      sym_type_annotation,
    STATE(5880), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159085] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3023), 1,
      sym_class_body,
    STATE(4372), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6380), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [159116] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4373), 1,
      sym_comment,
    STATE(4975), 1,
      sym_type_annotation,
    STATE(6083), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159143] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4374), 1,
      sym_comment,
    STATE(4984), 1,
      sym_type_annotation,
    STATE(6091), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159170] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4375), 1,
      sym_comment,
    STATE(4986), 1,
      sym_type_annotation,
    STATE(6092), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159197] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4376), 1,
      sym_comment,
    STATE(4992), 1,
      sym_type_annotation,
    STATE(6095), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159224] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4377), 1,
      sym_comment,
    STATE(5005), 1,
      sym_type_annotation,
    STATE(6107), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159251] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4378), 1,
      sym_comment,
    STATE(5042), 1,
      sym_type_annotation,
    STATE(5992), 1,
      sym__initializer,
    ACTIONS(7392), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159278] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(7991), 1,
      sym_identifier,
    ACTIONS(7993), 1,
      anon_sym_LPAREN,
    STATE(2560), 1,
      sym_arguments,
    STATE(4379), 1,
      sym_comment,
    STATE(6443), 1,
      sym_type_arguments,
    ACTIONS(7995), 2,
      anon_sym_LBRACK,
      sym_private_property_identifier,
  [159307] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(209), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7997), 1,
      anon_sym_LT,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8001), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4380), 1,
      sym_comment,
    STATE(5219), 1,
      sym_type_parameters,
    STATE(6242), 1,
      sym_extends_type_clause,
    STATE(6838), 1,
      sym_object_type,
  [159338] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(8003), 1,
      sym_identifier,
    ACTIONS(8005), 1,
      anon_sym_DOT,
    STATE(4381), 1,
      sym_comment,
    STATE(5073), 1,
      sym_nested_identifier,
    STATE(5616), 1,
      sym_string,
    STATE(6527), 1,
      sym__module,
  [159369] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4103), 1,
      anon_sym_DQUOTE,
    ACTIONS(4105), 1,
      anon_sym_SQUOTE,
    ACTIONS(8007), 1,
      sym_identifier,
    ACTIONS(8009), 1,
      anon_sym_DOT,
    STATE(930), 1,
      sym_nested_identifier,
    STATE(1068), 1,
      sym_string,
    STATE(1331), 1,
      sym__module,
    STATE(4382), 1,
      sym_comment,
  [159400] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7997), 1,
      anon_sym_LT,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8011), 1,
      anon_sym_LBRACE,
    ACTIONS(8013), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1298), 1,
      sym_object_type,
    STATE(4383), 1,
      sym_comment,
    STATE(4891), 1,
      sym_type_parameters,
    STATE(5663), 1,
      sym_extends_type_clause,
  [159431] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4384), 1,
      sym_comment,
    STATE(5113), 1,
      sym_type_annotation,
    ACTIONS(8015), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159454] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7855), 1,
      anon_sym_LBRACE,
    STATE(382), 1,
      sym_class_body,
    STATE(4385), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6473), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [159485] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4386), 1,
      sym_comment,
    STATE(5135), 1,
      sym_type_annotation,
    ACTIONS(8017), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159508] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4387), 1,
      sym_comment,
    STATE(5190), 1,
      sym_type_annotation,
    ACTIONS(8019), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159531] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(128), 1,
      anon_sym_import,
    ACTIONS(8021), 1,
      sym_identifier,
    STATE(3648), 1,
      sym__type_query_subscript_expression,
    STATE(3665), 1,
      sym__type_query_member_expression,
    STATE(3904), 1,
      sym__type_query_call_expression,
    STATE(4006), 1,
      sym__type_query_instantiation_expression,
    STATE(4388), 1,
      sym_comment,
    STATE(5603), 1,
      sym_import,
  [159562] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4389), 1,
      sym_comment,
    ACTIONS(7889), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [159581] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7853), 1,
      anon_sym_LBRACE,
    STATE(1111), 1,
      sym_class_body,
    STATE(4390), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6538), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [159612] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4391), 1,
      sym_comment,
    STATE(5149), 1,
      sym_type_annotation,
    STATE(6183), 1,
      sym__initializer,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159639] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7845), 1,
      anon_sym_LBRACE,
    STATE(1209), 1,
      sym_class_body,
    STATE(4392), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6587), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [159670] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4393), 1,
      sym_comment,
    STATE(5220), 1,
      sym_type_annotation,
    STATE(6243), 1,
      sym__initializer,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159697] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7855), 1,
      anon_sym_LBRACE,
    STATE(409), 1,
      sym_class_body,
    STATE(4394), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6608), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [159728] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2403), 1,
      sym_class_body,
    STATE(4395), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6524), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [159759] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7853), 1,
      anon_sym_LBRACE,
    STATE(1090), 1,
      sym_class_body,
    STATE(4396), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6631), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [159790] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4397), 1,
      sym_comment,
    ACTIONS(7793), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [159809] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8023), 1,
      sym__automatic_semicolon,
    STATE(4398), 1,
      sym_comment,
    ACTIONS(2115), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
  [159830] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7845), 1,
      anon_sym_LBRACE,
    STATE(1438), 1,
      sym_class_body,
    STATE(4399), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6653), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [159861] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4400), 1,
      sym_comment,
    STATE(5305), 1,
      sym_type_annotation,
    STATE(6317), 1,
      sym__initializer,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159888] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4401), 1,
      sym_comment,
    STATE(5302), 1,
      sym_type_annotation,
    STATE(6329), 1,
      sym__initializer,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159915] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4402), 1,
      sym_comment,
    STATE(5400), 1,
      sym_type_annotation,
    STATE(6327), 1,
      sym__initializer,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159942] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(8027), 1,
      anon_sym_RBRACE,
    STATE(4403), 1,
      sym_comment,
    STATE(5670), 1,
      aux_sym_object_repeat1,
    ACTIONS(4518), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [159967] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4404), 1,
      sym_comment,
    STATE(5297), 1,
      sym_type_annotation,
    STATE(6025), 1,
      sym__initializer,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159994] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4405), 1,
      sym_comment,
    STATE(5089), 1,
      sym_type_annotation,
    STATE(5850), 1,
      sym__initializer,
    ACTIONS(7394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160021] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4406), 1,
      sym_comment,
    STATE(5231), 1,
      sym_type_annotation,
    STATE(5989), 1,
      sym__initializer,
    ACTIONS(7376), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160048] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4407), 1,
      sym_comment,
    STATE(5166), 1,
      sym_type_annotation,
    STATE(5939), 1,
      sym__initializer,
    ACTIONS(7412), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160075] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4408), 1,
      sym_comment,
    ACTIONS(7773), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [160094] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(8029), 1,
      sym_identifier,
    ACTIONS(8031), 1,
      anon_sym_DOT,
    STATE(4330), 1,
      sym_nested_identifier,
    STATE(4409), 1,
      sym_comment,
    STATE(4500), 1,
      sym_string,
    STATE(5038), 1,
      sym__module,
  [160125] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4410), 1,
      sym_comment,
    STATE(5225), 1,
      sym_type_annotation,
    STATE(5892), 1,
      sym__initializer,
    ACTIONS(7378), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160152] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1344), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7997), 1,
      anon_sym_LT,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4411), 1,
      sym_comment,
    STATE(5195), 1,
      sym_type_parameters,
    STATE(5285), 1,
      sym_object_type,
    STATE(5956), 1,
      sym_extends_type_clause,
  [160183] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7735), 1,
      anon_sym_LBRACE,
    STATE(368), 1,
      sym_class_body,
    STATE(4412), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6938), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [160214] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(128), 1,
      anon_sym_import,
    ACTIONS(8035), 1,
      sym_identifier,
    STATE(2207), 1,
      sym__type_query_subscript_expression,
    STATE(2209), 1,
      sym__type_query_member_expression,
    STATE(2250), 1,
      sym__type_query_call_expression,
    STATE(2252), 1,
      sym__type_query_instantiation_expression,
    STATE(4413), 1,
      sym_comment,
    STATE(5472), 1,
      sym_import,
  [160245] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4414), 1,
      sym_comment,
    STATE(5237), 1,
      sym_type_annotation,
    STATE(5805), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160272] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4415), 1,
      sym_comment,
    STATE(5092), 1,
      sym_class_body,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6895), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [160303] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4416), 1,
      sym_comment,
    STATE(5310), 1,
      sym_type_annotation,
    STATE(5784), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160330] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4417), 1,
      sym_comment,
    STATE(5316), 1,
      sym_type_annotation,
    STATE(5782), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160357] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4418), 1,
      sym_comment,
    STATE(5262), 1,
      sym_class_body,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6870), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [160388] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4419), 1,
      sym_comment,
    ACTIONS(2237), 7,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_DOT,
      anon_sym_SLASH_GT,
      anon_sym_LT,
      sym_identifier,
  [160407] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7735), 1,
      anon_sym_LBRACE,
    STATE(422), 1,
      sym_class_body,
    STATE(4420), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6868), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [160438] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4421), 1,
      sym_comment,
    STATE(5337), 1,
      sym_class_body,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6865), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [160469] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7605), 1,
      anon_sym_LBRACE,
    STATE(1496), 1,
      sym_class_body,
    STATE(4422), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6758), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [160500] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4423), 1,
      sym_comment,
    STATE(5350), 1,
      sym_type_annotation,
    STATE(5764), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160527] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4424), 1,
      sym_comment,
    ACTIONS(2223), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [160546] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4425), 1,
      sym_comment,
    STATE(5355), 1,
      sym_type_annotation,
    STATE(5758), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160573] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4426), 1,
      sym_comment,
    ACTIONS(2115), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [160592] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4427), 1,
      sym_comment,
    STATE(5366), 1,
      sym_type_annotation,
    STATE(5749), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160619] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4428), 1,
      sym_comment,
    STATE(5373), 1,
      sym_type_annotation,
    STATE(5747), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160646] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4429), 1,
      sym_comment,
    STATE(5312), 1,
      sym_type_annotation,
    STATE(6036), 1,
      sym__initializer,
    ACTIONS(7985), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160673] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4430), 1,
      sym_comment,
    STATE(5328), 1,
      sym_type_annotation,
    STATE(6038), 1,
      sym__initializer,
    ACTIONS(7985), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160700] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8037), 1,
      sym__automatic_semicolon,
    STATE(4431), 1,
      sym_comment,
    ACTIONS(2095), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [160721] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4432), 1,
      sym_comment,
    STATE(5393), 1,
      sym_type_annotation,
    STATE(5742), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160748] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4433), 1,
      sym_comment,
    STATE(5407), 1,
      sym_type_annotation,
    STATE(5741), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160775] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(4434), 1,
      sym_comment,
    STATE(5278), 1,
      sym_class_body,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6827), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [160806] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4435), 1,
      sym_comment,
    STATE(5367), 1,
      sym_type_annotation,
    STATE(5729), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160833] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4436), 1,
      sym_comment,
    STATE(5356), 1,
      sym_type_annotation,
    STATE(5728), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160860] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4437), 1,
      sym_comment,
    ACTIONS(2233), 7,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_DOT,
      anon_sym_SLASH_GT,
      anon_sym_LT,
      sym_identifier,
  [160879] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4438), 1,
      sym_comment,
    ACTIONS(7643), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [160898] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4439), 1,
      sym_comment,
    STATE(5211), 1,
      sym_type_annotation,
    STATE(5709), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160925] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4440), 1,
      sym_comment,
    STATE(5168), 1,
      sym_type_annotation,
    STATE(5707), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160952] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4441), 1,
      sym_comment,
    ACTIONS(7641), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [160971] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4111), 1,
      anon_sym_DQUOTE,
    ACTIONS(4113), 1,
      anon_sym_SQUOTE,
    ACTIONS(8039), 1,
      sym_identifier,
    ACTIONS(8041), 1,
      anon_sym_DOT,
    STATE(947), 1,
      sym_nested_identifier,
    STATE(1041), 1,
      sym_string,
    STATE(1375), 1,
      sym__module,
    STATE(4442), 1,
      sym_comment,
  [161002] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4443), 1,
      sym_comment,
    STATE(5059), 1,
      sym_type_annotation,
    STATE(5690), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161029] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4444), 1,
      sym_comment,
    STATE(5153), 1,
      sym_type_annotation,
    STATE(5688), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161056] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7997), 1,
      anon_sym_LT,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8043), 1,
      anon_sym_LBRACE,
    ACTIONS(8045), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1334), 1,
      sym_object_type,
    STATE(4445), 1,
      sym_comment,
    STATE(5369), 1,
      sym_type_parameters,
    STATE(6209), 1,
      sym_extends_type_clause,
  [161087] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4446), 1,
      sym_comment,
    STATE(5129), 1,
      sym_type_annotation,
    STATE(5682), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161114] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4447), 1,
      sym_comment,
    STATE(5110), 1,
      sym_type_annotation,
    STATE(5681), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161141] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(2991), 1,
      sym_class_body,
    STATE(4448), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6497), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161172] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4449), 1,
      sym_comment,
    STATE(5091), 1,
      sym_type_annotation,
    STATE(5673), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161199] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4450), 1,
      sym_comment,
    STATE(5048), 1,
      sym_type_annotation,
    STATE(5662), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161226] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(128), 1,
      anon_sym_import,
    ACTIONS(8047), 1,
      sym_identifier,
    STATE(3686), 1,
      sym__type_query_subscript_expression,
    STATE(3687), 1,
      sym__type_query_member_expression,
    STATE(3981), 1,
      sym__type_query_call_expression,
    STATE(4249), 1,
      sym__type_query_instantiation_expression,
    STATE(4451), 1,
      sym_comment,
    STATE(5445), 1,
      sym_import,
  [161257] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    STATE(1156), 1,
      sym_class_body,
    STATE(4452), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6434), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161288] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4453), 1,
      sym_comment,
    STATE(4901), 1,
      sym_type_annotation,
    STATE(5649), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161315] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4454), 1,
      sym_comment,
    ACTIONS(7559), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [161334] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4455), 1,
      sym_comment,
    STATE(6799), 1,
      sym_statement_block,
    ACTIONS(8051), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [161357] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1244), 1,
      sym_class_body,
    STATE(4456), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6401), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161388] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4457), 1,
      sym_comment,
    STATE(4870), 1,
      sym_type_annotation,
    ACTIONS(8053), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [161411] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(2999), 1,
      sym_class_body,
    STATE(4458), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6387), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161442] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    STATE(1124), 1,
      sym_class_body,
    STATE(4459), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6369), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161473] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4460), 1,
      sym_comment,
    STATE(5054), 1,
      sym_type_annotation,
    STATE(5772), 1,
      sym__initializer,
    ACTIONS(7414), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161500] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1305), 1,
      sym_class_body,
    STATE(4461), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6345), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161531] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4462), 1,
      sym_comment,
    STATE(5103), 1,
      sym_type_annotation,
    STATE(5860), 1,
      sym__initializer,
    ACTIONS(7416), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161558] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4463), 1,
      sym_comment,
    STATE(5164), 1,
      sym_type_annotation,
    STATE(5644), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161585] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4097), 1,
      anon_sym_DQUOTE,
    ACTIONS(4099), 1,
      anon_sym_SQUOTE,
    ACTIONS(8055), 1,
      sym_identifier,
    ACTIONS(8057), 1,
      anon_sym_DOT,
    STATE(891), 1,
      sym_nested_identifier,
    STATE(912), 1,
      sym_string,
    STATE(1083), 1,
      sym__module,
    STATE(4464), 1,
      sym_comment,
  [161616] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4465), 1,
      sym_comment,
    STATE(5021), 1,
      sym_type_annotation,
    STATE(5713), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161643] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7997), 1,
      anon_sym_LT,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8059), 1,
      anon_sym_LBRACE,
    ACTIONS(8061), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1029), 1,
      sym_object_type,
    STATE(4466), 1,
      sym_comment,
    STATE(5271), 1,
      sym_type_parameters,
    STATE(6301), 1,
      sym_extends_type_clause,
  [161674] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7611), 1,
      anon_sym_LBRACE,
    STATE(332), 1,
      sym_class_body,
    STATE(4467), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6419), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161705] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(3277), 1,
      sym_class_body,
    STATE(4468), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6852), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161736] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7609), 1,
      anon_sym_LBRACE,
    STATE(951), 1,
      sym_class_body,
    STATE(4469), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6442), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161767] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    STATE(1060), 1,
      sym_class_body,
    STATE(4470), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6452), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161798] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7611), 1,
      anon_sym_LBRACE,
    STATE(320), 1,
      sym_class_body,
    STATE(4471), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6460), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161829] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7609), 1,
      anon_sym_LBRACE,
    STATE(920), 1,
      sym_class_body,
    STATE(4472), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6464), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161860] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4473), 1,
      sym_comment,
    STATE(5223), 1,
      sym_type_annotation,
    STATE(5712), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161887] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4474), 1,
      sym_comment,
    STATE(5332), 1,
      sym_type_annotation,
    STATE(5795), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161914] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    STATE(1114), 1,
      sym_class_body,
    STATE(4475), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6470), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161945] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7605), 1,
      anon_sym_LBRACE,
    STATE(1451), 1,
      sym_class_body,
    STATE(4476), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6770), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [161976] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3057), 1,
      sym_class_body,
    STATE(4477), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6976), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [162007] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4478), 1,
      sym_comment,
    ACTIONS(6523), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [162026] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4479), 1,
      sym_comment,
    STATE(5362), 1,
      sym_type_annotation,
    STATE(5736), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162053] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4480), 1,
      sym_comment,
    STATE(5361), 1,
      sym_type_annotation,
    STATE(5751), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162080] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7543), 1,
      anon_sym_LBRACE,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    STATE(1374), 1,
      sym_class_body,
    STATE(4481), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6915), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [162111] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7649), 1,
      anon_sym_LBRACE,
    STATE(444), 1,
      sym_class_body,
    STATE(4482), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6869), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [162142] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4483), 1,
      sym_comment,
    STATE(5287), 1,
      sym_type_annotation,
    STATE(5766), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162169] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8063), 1,
      anon_sym_LBRACE,
    ACTIONS(8065), 1,
      anon_sym_COMMA,
    ACTIONS(8067), 1,
      anon_sym_DOT,
    ACTIONS(8069), 1,
      anon_sym_LT,
    ACTIONS(8071), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4484), 1,
      sym_comment,
    STATE(5422), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(6167), 1,
      sym_type_arguments,
  [162200] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4485), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5459), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [162229] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4486), 1,
      sym_comment,
    STATE(6514), 1,
      sym_statement_block,
    ACTIONS(8075), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162252] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4487), 1,
      sym_comment,
    STATE(6903), 1,
      sym_statement_block,
    ACTIONS(8075), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162275] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4488), 1,
      sym_comment,
    STATE(6503), 1,
      sym_statement_block,
    ACTIONS(8077), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162298] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4489), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5576), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [162327] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4490), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5575), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [162356] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4491), 1,
      sym_comment,
    STATE(5282), 1,
      sym_type_annotation,
    STATE(5791), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162383] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8079), 1,
      sym_identifier,
    ACTIONS(8081), 1,
      anon_sym_STAR,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    STATE(4492), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6657), 1,
      sym__call_signature,
  [162414] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4493), 1,
      sym_comment,
    STATE(5180), 1,
      sym_type_annotation,
    STATE(5814), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162441] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4494), 1,
      sym_comment,
    STATE(5174), 1,
      sym_type_annotation,
    STATE(6005), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162468] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4495), 1,
      sym_comment,
    STATE(5126), 1,
      sym_type_annotation,
    STATE(5825), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162495] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4496), 1,
      sym_comment,
    STATE(5118), 1,
      sym_type_annotation,
    STATE(5834), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162522] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4497), 1,
      sym_comment,
    STATE(5040), 1,
      sym_type_annotation,
    STATE(5872), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162549] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4498), 1,
      sym_comment,
    STATE(5319), 1,
      sym_type_annotation,
    STATE(6330), 1,
      sym__initializer,
    ACTIONS(7428), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162576] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(3280), 1,
      sym_class_body,
    STATE(4499), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6391), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [162607] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    STATE(4500), 1,
      sym_comment,
    STATE(4996), 1,
      sym_statement_block,
    ACTIONS(2061), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162630] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8085), 1,
      sym_identifier,
    ACTIONS(8087), 1,
      anon_sym_STAR,
    STATE(4501), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6523), 1,
      sym__call_signature,
  [162661] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4502), 1,
      sym_comment,
    ACTIONS(5809), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [162680] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3043), 1,
      sym_class_body,
    STATE(4503), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6502), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [162711] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8089), 1,
      anon_sym_COLON,
    ACTIONS(8091), 1,
      anon_sym_QMARK,
    STATE(4504), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6975), 1,
      sym__call_signature,
  [162742] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7543), 1,
      anon_sym_LBRACE,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    STATE(1168), 1,
      sym_class_body,
    STATE(4505), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6528), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [162773] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3035), 1,
      sym_class_body,
    STATE(4506), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6546), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [162804] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8093), 1,
      anon_sym_EQ,
    ACTIONS(8095), 1,
      anon_sym_DOT,
    STATE(4507), 1,
      sym_comment,
    ACTIONS(7947), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [162827] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4508), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5571), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [162856] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4509), 1,
      sym_comment,
    STATE(6929), 1,
      sym_statement_block,
    ACTIONS(8097), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162879] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4510), 1,
      sym_comment,
    ACTIONS(2127), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162898] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4511), 1,
      sym_comment,
    STATE(5100), 1,
      sym_type_annotation,
    STATE(5674), 1,
      sym__initializer,
    ACTIONS(7386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162925] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4512), 1,
      sym_comment,
    ACTIONS(2235), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [162944] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4513), 1,
      sym_comment,
    ACTIONS(2239), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [162963] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4514), 1,
      sym_comment,
    STATE(6966), 1,
      sym_statement_block,
    ACTIONS(8099), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162986] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4515), 1,
      sym_comment,
    STATE(6920), 1,
      sym_statement_block,
    ACTIONS(8099), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163009] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4516), 1,
      sym_comment,
    STATE(6906), 1,
      sym_statement_block,
    ACTIONS(8097), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163032] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7340), 1,
      anon_sym_COLON,
    ACTIONS(8103), 1,
      anon_sym_EQ,
    STATE(4517), 1,
      sym_comment,
    ACTIONS(8101), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [163055] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4518), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5572), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163084] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8105), 1,
      anon_sym_EQ,
    STATE(4519), 1,
      sym_comment,
    STATE(5553), 1,
      sym_constraint,
    STATE(6636), 1,
      sym_default_type,
    ACTIONS(8107), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(8109), 2,
      anon_sym_COLON,
      anon_sym_extends,
  [163111] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(128), 1,
      anon_sym_import,
    ACTIONS(8111), 1,
      sym_identifier,
    STATE(3599), 1,
      sym__type_query_member_expression,
    STATE(3600), 1,
      sym__type_query_subscript_expression,
    STATE(3656), 1,
      sym__type_query_call_expression,
    STATE(3722), 1,
      sym__type_query_instantiation_expression,
    STATE(4520), 1,
      sym_comment,
    STATE(5558), 1,
      sym_import,
  [163142] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7649), 1,
      anon_sym_LBRACE,
    STATE(460), 1,
      sym_class_body,
    STATE(4521), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6688), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [163173] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8105), 1,
      anon_sym_EQ,
    STATE(4522), 1,
      sym_comment,
    STATE(5617), 1,
      sym_constraint,
    STATE(6886), 1,
      sym_default_type,
    ACTIONS(8109), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(8113), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [163200] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8115), 1,
      sym_identifier,
    STATE(4072), 1,
      sym__destructuring_pattern,
    STATE(4523), 1,
      sym_comment,
    STATE(5540), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163229] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8117), 1,
      sym_identifier,
    STATE(4071), 1,
      sym__destructuring_pattern,
    STATE(4524), 1,
      sym_comment,
    STATE(5541), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163258] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4525), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(6135), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163287] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4526), 1,
      sym_comment,
    ACTIONS(5904), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [163306] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4527), 1,
      sym_comment,
    ACTIONS(5807), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [163325] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4528), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5415), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163354] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4529), 1,
      sym_comment,
    STATE(6763), 1,
      sym_statement_block,
    ACTIONS(8119), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163377] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4530), 1,
      sym_comment,
    STATE(6768), 1,
      sym_statement_block,
    ACTIONS(8121), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163400] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4531), 1,
      sym_comment,
    ACTIONS(2147), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163419] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4532), 1,
      sym_comment,
    STATE(6716), 1,
      sym_statement_block,
    ACTIONS(8119), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163442] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4533), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5416), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163471] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4534), 1,
      sym_comment,
    STATE(6697), 1,
      sym_statement_block,
    ACTIONS(8121), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163494] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(7445), 1,
      sym_identifier,
    ACTIONS(7519), 1,
      anon_sym_type,
    STATE(4535), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(6778), 1,
      sym__import_identifier,
    STATE(7126), 1,
      sym__module_export_name,
  [163525] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8123), 1,
      sym_identifier,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    STATE(4536), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6925), 1,
      sym__call_signature,
  [163556] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4537), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5458), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163585] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4538), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5442), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163614] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(4539), 1,
      sym_comment,
    ACTIONS(8127), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4518), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [163637] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4540), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5478), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163666] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4541), 1,
      sym_comment,
    STATE(5333), 1,
      sym_type_annotation,
    STATE(6298), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163693] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4542), 1,
      sym_comment,
    STATE(5325), 1,
      sym_type_annotation,
    STATE(6320), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163720] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4543), 1,
      sym_comment,
    STATE(6714), 1,
      sym_statement_block,
    ACTIONS(8130), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163743] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4544), 1,
      sym_comment,
    STATE(6724), 1,
      sym_statement_block,
    ACTIONS(8132), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163766] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4545), 1,
      sym_comment,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(5481), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163795] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4546), 1,
      sym_comment,
    STATE(6681), 1,
      sym_statement_block,
    ACTIONS(8130), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163818] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4547), 1,
      sym_comment,
    STATE(4881), 1,
      sym_type_annotation,
    STATE(5973), 1,
      sym__initializer,
    ACTIONS(8134), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163845] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4548), 1,
      sym_comment,
    STATE(6680), 1,
      sym_statement_block,
    ACTIONS(8132), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163868] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8136), 1,
      sym_identifier,
    ACTIONS(8138), 1,
      anon_sym_STAR,
    STATE(4549), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6643), 1,
      sym__call_signature,
  [163899] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4550), 1,
      sym_comment,
    STATE(6675), 1,
      sym_statement_block,
    ACTIONS(8140), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163922] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4551), 1,
      sym_comment,
    STATE(4920), 1,
      sym_type_annotation,
    STATE(5995), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163949] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4552), 1,
      sym_comment,
    STATE(4929), 1,
      sym_type_annotation,
    STATE(5997), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163976] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4553), 1,
      sym_comment,
    STATE(6677), 1,
      sym_statement_block,
    ACTIONS(8142), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163999] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8144), 1,
      anon_sym_EQ,
    STATE(4554), 1,
      sym_comment,
    ACTIONS(4287), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [164020] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4555), 1,
      sym_comment,
    STATE(5284), 1,
      sym_type_annotation,
    STATE(6303), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164047] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4556), 1,
      sym_comment,
    STATE(5273), 1,
      sym_type_annotation,
    STATE(6296), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164074] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4557), 1,
      sym_comment,
    STATE(6861), 1,
      sym_statement_block,
    ACTIONS(8147), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [164097] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4558), 1,
      sym_comment,
    STATE(6701), 1,
      sym_statement_block,
    ACTIONS(8149), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [164120] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8151), 1,
      sym_identifier,
    ACTIONS(8153), 1,
      anon_sym_STAR,
    STATE(4559), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6925), 1,
      sym__call_signature,
  [164151] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4560), 1,
      sym_comment,
    STATE(6748), 1,
      sym_statement_block,
    ACTIONS(8155), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [164174] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4561), 1,
      sym_comment,
    ACTIONS(8157), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [164193] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4157), 1,
      anon_sym_LT,
    ACTIONS(7991), 1,
      sym_identifier,
    ACTIONS(8159), 1,
      anon_sym_LPAREN,
    STATE(3140), 1,
      sym_arguments,
    STATE(4562), 1,
      sym_comment,
    STATE(6854), 1,
      sym_type_arguments,
    ACTIONS(7995), 2,
      anon_sym_LBRACK,
      sym_private_property_identifier,
  [164222] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8161), 1,
      anon_sym_EQ,
    STATE(4563), 1,
      sym_comment,
    ACTIONS(4253), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [164243] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7997), 1,
      anon_sym_LT,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8163), 1,
      anon_sym_LBRACE,
    ACTIONS(8165), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1569), 1,
      sym_object_type,
    STATE(4564), 1,
      sym_comment,
    STATE(4950), 1,
      sym_type_parameters,
    STATE(6050), 1,
      sym_extends_type_clause,
  [164274] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4014), 1,
      anon_sym_DQUOTE,
    ACTIONS(4016), 1,
      anon_sym_SQUOTE,
    ACTIONS(8167), 1,
      sym_identifier,
    ACTIONS(8169), 1,
      anon_sym_DOT,
    STATE(962), 1,
      sym_nested_identifier,
    STATE(1161), 1,
      sym_string,
    STATE(1517), 1,
      sym__module,
    STATE(4565), 1,
      sym_comment,
  [164305] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(8173), 1,
      anon_sym_DOT,
    STATE(4566), 1,
      sym_comment,
    STATE(5612), 1,
      sym_arguments,
    ACTIONS(8171), 4,
      anon_sym_export,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [164330] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4567), 1,
      sym_comment,
    ACTIONS(8175), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [164349] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4568), 1,
      sym_comment,
    STATE(6682), 1,
      sym_statement_block,
    ACTIONS(8142), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [164372] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8177), 1,
      sym_identifier,
    ACTIONS(8179), 1,
      anon_sym_STAR,
    STATE(4569), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6925), 1,
      sym__call_signature,
  [164403] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7545), 1,
      anon_sym_extends,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3007), 1,
      sym_class_body,
    STATE(4570), 1,
      sym_comment,
    STATE(5785), 1,
      sym_extends_clause,
    STATE(6943), 1,
      sym_class_heritage,
    STATE(7265), 1,
      sym_implements_clause,
  [164434] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    ACTIONS(8185), 1,
      anon_sym_QMARK,
    STATE(4571), 1,
      sym_comment,
    STATE(5627), 1,
      sym_type_annotation,
    STATE(6979), 1,
      sym__initializer,
    ACTIONS(8183), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [164463] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4572), 1,
      sym_comment,
    ACTIONS(4287), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [164482] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8187), 1,
      anon_sym_EQ,
    STATE(4573), 1,
      sym_comment,
    ACTIONS(4287), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [164503] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4574), 1,
      sym_comment,
    STATE(4888), 1,
      sym_type_annotation,
    STATE(5944), 1,
      sym__initializer,
    ACTIONS(7495), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164530] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4575), 1,
      sym_comment,
    STATE(4942), 1,
      sym_type_annotation,
    STATE(6034), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164557] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4576), 1,
      sym_comment,
    STATE(4953), 1,
      sym_type_annotation,
    STATE(6039), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164584] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4577), 1,
      sym_comment,
    STATE(5257), 1,
      sym_type_annotation,
    STATE(6328), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164611] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4578), 1,
      sym_comment,
    STATE(5255), 1,
      sym_type_annotation,
    STATE(6200), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164638] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8190), 1,
      sym_identifier,
    ACTIONS(8192), 1,
      anon_sym_STAR,
    STATE(4579), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6643), 1,
      sym__call_signature,
  [164669] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4580), 1,
      sym_comment,
    ACTIONS(8194), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [164688] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6033), 1,
      sym__automatic_semicolon,
    STATE(4581), 1,
      sym_comment,
    ACTIONS(2095), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
  [164709] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4582), 1,
      sym_comment,
    ACTIONS(6416), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [164728] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8091), 1,
      anon_sym_QMARK,
    ACTIONS(8196), 1,
      anon_sym_COLON,
    STATE(4583), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6975), 1,
      sym__call_signature,
  [164759] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_LBRACK,
    ACTIONS(8073), 1,
      sym_identifier,
    STATE(4574), 1,
      sym__destructuring_pattern,
    STATE(4584), 1,
      sym_comment,
    STATE(5443), 1,
      sym_variable_declarator,
    STATE(4389), 2,
      sym_object_pattern,
      sym_array_pattern,
  [164788] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8198), 1,
      sym_identifier,
    ACTIONS(8200), 1,
      anon_sym_STAR,
    STATE(4585), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6643), 1,
      sym__call_signature,
  [164819] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8202), 1,
      sym_identifier,
    ACTIONS(8204), 1,
      anon_sym_STAR,
    STATE(4586), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6925), 1,
      sym__call_signature,
  [164850] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8206), 1,
      sym_identifier,
    ACTIONS(8208), 1,
      anon_sym_STAR,
    STATE(4587), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6643), 1,
      sym__call_signature,
  [164881] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4588), 1,
      sym_comment,
    ACTIONS(8210), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [164900] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8212), 1,
      sym_identifier,
    ACTIONS(8214), 1,
      anon_sym_STAR,
    STATE(4589), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6925), 1,
      sym__call_signature,
  [164931] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8216), 1,
      sym_identifier,
    ACTIONS(8218), 1,
      anon_sym_STAR,
    STATE(4590), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6643), 1,
      sym__call_signature,
  [164962] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8220), 1,
      sym_identifier,
    ACTIONS(8222), 1,
      anon_sym_STAR,
    STATE(4591), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6643), 1,
      sym__call_signature,
  [164993] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4592), 1,
      sym_comment,
    STATE(4969), 1,
      sym_type_annotation,
    STATE(6075), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165020] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4593), 1,
      sym_comment,
    STATE(4845), 1,
      sym_type_annotation,
    STATE(6269), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165047] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4594), 1,
      sym_comment,
    STATE(5240), 1,
      sym_type_annotation,
    STATE(6268), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165074] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4595), 1,
      sym_comment,
    ACTIONS(4330), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [165093] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4596), 1,
      sym_comment,
    STATE(4971), 1,
      sym_type_annotation,
    STATE(6076), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165120] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4597), 1,
      sym_comment,
    STATE(4997), 1,
      sym_type_annotation,
    STATE(6087), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165147] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4598), 1,
      sym_comment,
    STATE(5018), 1,
      sym_type_annotation,
    STATE(6099), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165174] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4599), 1,
      sym_comment,
    ACTIONS(4328), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [165193] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4600), 1,
      sym_comment,
    ACTIONS(7623), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [165212] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4601), 1,
      sym_comment,
    ACTIONS(7627), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [165231] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4602), 1,
      sym_comment,
    STATE(5031), 1,
      sym_type_annotation,
    STATE(6130), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165258] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4603), 1,
      sym_comment,
    STATE(5036), 1,
      sym_type_annotation,
    STATE(6132), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165285] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4604), 1,
      sym_comment,
    STATE(5230), 1,
      sym_type_annotation,
    STATE(6238), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165312] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4605), 1,
      sym_comment,
    STATE(5210), 1,
      sym_type_annotation,
    STATE(6228), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165339] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4606), 1,
      sym_comment,
    ACTIONS(7659), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [165358] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4607), 1,
      sym_comment,
    ACTIONS(7661), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [165377] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8224), 1,
      sym_identifier,
    ACTIONS(8226), 1,
      anon_sym_STAR,
    STATE(4608), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6925), 1,
      sym__call_signature,
  [165408] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8228), 1,
      sym_identifier,
    ACTIONS(8230), 1,
      anon_sym_STAR,
    STATE(4609), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6643), 1,
      sym__call_signature,
  [165439] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4610), 1,
      sym_comment,
    STATE(5165), 1,
      sym_type_annotation,
    STATE(6186), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165466] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(4611), 1,
      sym_comment,
    STATE(5104), 1,
      sym_type_annotation,
    STATE(6150), 1,
      sym__initializer,
    ACTIONS(7426), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165493] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8232), 1,
      sym_identifier,
    ACTIONS(8234), 1,
      anon_sym_STAR,
    STATE(4612), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6925), 1,
      sym__call_signature,
  [165524] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4613), 1,
      sym_comment,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8238), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8236), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165546] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3391), 1,
      sym_statement_block,
    STATE(4614), 1,
      sym_comment,
    ACTIONS(8147), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165568] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8242), 1,
      sym_identifier,
    STATE(4615), 1,
      sym_comment,
    ACTIONS(7002), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [165588] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8244), 1,
      anon_sym_default,
    ACTIONS(8246), 1,
      anon_sym_RBRACE,
    ACTIONS(8248), 1,
      anon_sym_case,
    STATE(4616), 1,
      sym_comment,
    STATE(4629), 1,
      aux_sym_switch_body_repeat1,
    STATE(6137), 2,
      sym_switch_case,
      sym_switch_default,
  [165614] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8250), 1,
      sym_identifier,
    STATE(4617), 1,
      sym_comment,
    ACTIONS(7002), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [165634] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8252), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4618), 1,
      sym_comment,
    STATE(5136), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [165662] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4619), 1,
      sym_comment,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8256), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8254), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165684] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8258), 1,
      sym_identifier,
    STATE(4620), 1,
      sym_comment,
    ACTIONS(7002), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [165704] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_DOT,
    ACTIONS(8260), 1,
      anon_sym_COMMA,
    ACTIONS(8262), 1,
      anon_sym_GT,
    STATE(4337), 1,
      sym_arguments,
    STATE(4621), 1,
      sym_comment,
    STATE(5727), 1,
      aux_sym_type_arguments_repeat1,
  [165732] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(8264), 1,
      anon_sym_COMMA,
    ACTIONS(8266), 1,
      anon_sym_GT,
    STATE(4622), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_type_arguments_repeat1,
  [165760] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8268), 1,
      sym_identifier,
    STATE(4623), 1,
      sym_comment,
    ACTIONS(7002), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [165780] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8270), 1,
      anon_sym_catch,
    ACTIONS(8272), 1,
      anon_sym_finally,
    STATE(4624), 1,
      sym_comment,
    STATE(5562), 1,
      sym_catch_clause,
    STATE(6744), 1,
      sym_finally_clause,
    ACTIONS(3028), 2,
      anon_sym_else,
      anon_sym_while,
  [165806] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8274), 1,
      sym_identifier,
    STATE(4625), 1,
      sym_comment,
    ACTIONS(7002), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [165826] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8276), 1,
      sym_identifier,
    STATE(4626), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6639), 1,
      sym__call_signature,
  [165854] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8278), 1,
      sym_identifier,
    STATE(4627), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6921), 1,
      sym__call_signature,
  [165882] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8283), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4628), 2,
      sym_comment,
      aux_sym_object_type_repeat1,
    ACTIONS(8280), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165902] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8244), 1,
      anon_sym_default,
    ACTIONS(8248), 1,
      anon_sym_case,
    ACTIONS(8285), 1,
      anon_sym_RBRACE,
    STATE(4629), 1,
      sym_comment,
    STATE(4744), 1,
      aux_sym_switch_body_repeat1,
    STATE(6137), 2,
      sym_switch_case,
      sym_switch_default,
  [165928] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4630), 1,
      sym_comment,
    STATE(4633), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8289), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8287), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165950] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4891), 1,
      anon_sym_COMMA,
    STATE(4631), 1,
      sym_comment,
    STATE(4686), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(8291), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [165972] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4632), 1,
      sym_comment,
    STATE(4636), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8295), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8293), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165994] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4633), 1,
      sym_comment,
    ACTIONS(8295), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8293), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166016] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4634), 1,
      sym_comment,
    ACTIONS(2115), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
  [166034] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(8297), 1,
      sym_identifier,
    ACTIONS(8299), 1,
      anon_sym_LBRACK,
    STATE(4635), 1,
      sym_comment,
    STATE(5874), 1,
      sym__destructuring_pattern,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
  [166060] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4636), 1,
      sym_comment,
    ACTIONS(8303), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8301), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166082] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8305), 1,
      sym_identifier,
    STATE(4637), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6639), 1,
      sym__call_signature,
  [166110] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4638), 1,
      sym_comment,
    ACTIONS(8175), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [166128] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8307), 1,
      sym_identifier,
    STATE(4639), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6921), 1,
      sym__call_signature,
  [166156] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4640), 1,
      sym_comment,
    ACTIONS(5363), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [166174] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8309), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4641), 1,
      sym_comment,
    STATE(5963), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [166202] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8067), 1,
      anon_sym_DOT,
    ACTIONS(8069), 1,
      anon_sym_LT,
    ACTIONS(8311), 1,
      anon_sym_LBRACE,
    STATE(4642), 1,
      sym_comment,
    STATE(6167), 1,
      sym_type_arguments,
    ACTIONS(8313), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [166228] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3406), 1,
      sym_statement_block,
    STATE(4643), 1,
      sym_comment,
    ACTIONS(8097), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166250] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(8029), 1,
      sym_identifier,
    STATE(4330), 1,
      sym_nested_identifier,
    STATE(4500), 1,
      sym_string,
    STATE(4644), 1,
      sym_comment,
    STATE(5024), 1,
      sym__module,
  [166278] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4645), 1,
      sym_comment,
    ACTIONS(5676), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [166296] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4646), 1,
      sym_comment,
    ACTIONS(8157), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [166314] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1922), 1,
      anon_sym_SQUOTE,
    ACTIONS(8029), 1,
      sym_identifier,
    STATE(4330), 1,
      sym_nested_identifier,
    STATE(4500), 1,
      sym_string,
    STATE(4647), 1,
      sym_comment,
    STATE(5038), 1,
      sym__module,
  [166342] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3404), 1,
      sym_statement_block,
    STATE(4648), 1,
      sym_comment,
    ACTIONS(8099), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166364] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4103), 1,
      anon_sym_DQUOTE,
    ACTIONS(4105), 1,
      anon_sym_SQUOTE,
    ACTIONS(8007), 1,
      sym_identifier,
    STATE(930), 1,
      sym_nested_identifier,
    STATE(1068), 1,
      sym_string,
    STATE(1331), 1,
      sym__module,
    STATE(4649), 1,
      sym_comment,
  [166392] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4103), 1,
      anon_sym_DQUOTE,
    ACTIONS(4105), 1,
      anon_sym_SQUOTE,
    ACTIONS(8007), 1,
      sym_identifier,
    STATE(930), 1,
      sym_nested_identifier,
    STATE(1068), 1,
      sym_string,
    STATE(1357), 1,
      sym__module,
    STATE(4650), 1,
      sym_comment,
  [166420] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(8315), 1,
      anon_sym_QMARK,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4651), 1,
      sym_comment,
    STATE(4658), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [166448] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3386), 1,
      sym_statement_block,
    STATE(4652), 1,
      sym_comment,
    ACTIONS(8099), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166470] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8317), 1,
      anon_sym_QMARK,
    STATE(4653), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6728), 1,
      sym__call_signature,
  [166498] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3387), 1,
      sym_statement_block,
    STATE(4654), 1,
      sym_comment,
    ACTIONS(8097), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166520] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(8299), 1,
      anon_sym_LBRACK,
    ACTIONS(8319), 1,
      sym_identifier,
    STATE(4655), 1,
      sym_comment,
    STATE(5913), 1,
      sym__destructuring_pattern,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
  [166546] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8321), 1,
      sym_identifier,
    STATE(4656), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6639), 1,
      sym__call_signature,
  [166574] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3394), 1,
      sym_statement_block,
    STATE(4657), 1,
      sym_comment,
    ACTIONS(8119), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166596] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3397), 1,
      sym_statement_block,
    STATE(4658), 1,
      sym_comment,
    ACTIONS(8121), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166618] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8323), 1,
      anon_sym_BQUOTE,
    ACTIONS(8325), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(4659), 1,
      sym_comment,
    STATE(4741), 1,
      aux_sym_template_string_repeat1,
    STATE(5469), 1,
      sym_template_substitution,
    ACTIONS(7921), 2,
      sym__template_chars,
      sym_escape_sequence,
  [166644] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8327), 1,
      sym_identifier,
    STATE(4660), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6921), 1,
      sym__call_signature,
  [166672] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4661), 1,
      sym_comment,
    ACTIONS(5545), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [166690] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(8329), 1,
      anon_sym_QMARK,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4662), 1,
      sym_comment,
    STATE(4805), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [166718] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8244), 1,
      anon_sym_default,
    ACTIONS(8248), 1,
      anon_sym_case,
    ACTIONS(8331), 1,
      anon_sym_RBRACE,
    STATE(4663), 1,
      sym_comment,
    STATE(4678), 1,
      aux_sym_switch_body_repeat1,
    STATE(6137), 2,
      sym_switch_case,
      sym_switch_default,
  [166744] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4664), 1,
      sym_comment,
    ACTIONS(5541), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [166762] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4665), 1,
      sym_comment,
    ACTIONS(7971), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
  [166780] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4666), 1,
      sym_comment,
    ACTIONS(6224), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
  [166798] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3399), 1,
      sym_statement_block,
    STATE(4667), 1,
      sym_comment,
    ACTIONS(8119), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166820] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4668), 1,
      sym_comment,
    ACTIONS(5552), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [166838] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3373), 1,
      sym_statement_block,
    STATE(4669), 1,
      sym_comment,
    ACTIONS(8121), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166860] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_DOT,
    ACTIONS(8333), 1,
      anon_sym_COMMA,
    ACTIONS(8335), 1,
      anon_sym_GT,
    STATE(4337), 1,
      sym_arguments,
    STATE(4670), 1,
      sym_comment,
    STATE(6015), 1,
      aux_sym_type_arguments_repeat1,
  [166888] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(8337), 1,
      anon_sym_COMMA,
    ACTIONS(8339), 1,
      anon_sym_GT,
    STATE(4671), 1,
      sym_comment,
    STATE(6019), 1,
      aux_sym_type_arguments_repeat1,
  [166916] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(8299), 1,
      anon_sym_LBRACK,
    ACTIONS(8341), 1,
      sym_identifier,
    STATE(4672), 1,
      sym_comment,
    STATE(5985), 1,
      sym__destructuring_pattern,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
  [166942] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8343), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4673), 1,
      sym_comment,
    STATE(6108), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [166970] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8345), 1,
      sym_identifier,
    STATE(4674), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6639), 1,
      sym__call_signature,
  [166998] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8347), 1,
      anon_sym_QMARK,
    STATE(4675), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6814), 1,
      sym__call_signature,
  [167026] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8349), 1,
      sym_identifier,
    STATE(4676), 1,
      sym_comment,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6921), 1,
      sym__call_signature,
  [167054] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4677), 1,
      sym_comment,
    ACTIONS(5556), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [167072] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8244), 1,
      anon_sym_default,
    ACTIONS(8248), 1,
      anon_sym_case,
    ACTIONS(8351), 1,
      anon_sym_RBRACE,
    STATE(4678), 1,
      sym_comment,
    STATE(4744), 1,
      aux_sym_switch_body_repeat1,
    STATE(6137), 2,
      sym_switch_case,
      sym_switch_default,
  [167098] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4679), 1,
      sym_comment,
    STATE(4681), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8355), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8353), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167120] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4680), 1,
      sym_comment,
    STATE(4688), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8359), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8357), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167142] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4681), 1,
      sym_comment,
    ACTIONS(8359), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8357), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167164] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3362), 1,
      sym_statement_block,
    STATE(4682), 1,
      sym_comment,
    ACTIONS(8155), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167186] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8361), 1,
      anon_sym_COLON,
    STATE(4683), 1,
      sym_comment,
    ACTIONS(7515), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6678), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [167208] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8363), 1,
      anon_sym_export,
    ACTIONS(8365), 1,
      anon_sym_class,
    ACTIONS(8367), 1,
      anon_sym_abstract,
    STATE(4684), 1,
      sym_comment,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
  [167236] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4014), 1,
      anon_sym_DQUOTE,
    ACTIONS(4016), 1,
      anon_sym_SQUOTE,
    ACTIONS(8167), 1,
      sym_identifier,
    STATE(962), 1,
      sym_nested_identifier,
    STATE(1161), 1,
      sym_string,
    STATE(1450), 1,
      sym__module,
    STATE(4685), 1,
      sym_comment,
  [167264] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8369), 1,
      anon_sym_COMMA,
    STATE(4686), 2,
      sym_comment,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5214), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [167284] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4687), 1,
      sym_comment,
    ACTIONS(5552), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [167302] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4688), 1,
      sym_comment,
    ACTIONS(8374), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8372), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167324] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4689), 1,
      sym_comment,
    ACTIONS(5588), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [167342] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8376), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4558), 1,
      sym__call_signature,
    STATE(4690), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [167370] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4691), 1,
      sym_comment,
    ACTIONS(2223), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
  [167388] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8378), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4550), 1,
      sym__call_signature,
    STATE(4692), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [167416] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4014), 1,
      anon_sym_DQUOTE,
    ACTIONS(4016), 1,
      anon_sym_SQUOTE,
    ACTIONS(8167), 1,
      sym_identifier,
    STATE(962), 1,
      sym_nested_identifier,
    STATE(1161), 1,
      sym_string,
    STATE(1517), 1,
      sym__module,
    STATE(4693), 1,
      sym_comment,
  [167444] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4694), 1,
      sym_comment,
    ACTIONS(8380), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [167462] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4695), 1,
      sym_comment,
    ACTIONS(8382), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [167480] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8384), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4544), 1,
      sym__call_signature,
    STATE(4696), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [167508] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4111), 1,
      anon_sym_DQUOTE,
    ACTIONS(4113), 1,
      anon_sym_SQUOTE,
    ACTIONS(8039), 1,
      sym_identifier,
    STATE(947), 1,
      sym_nested_identifier,
    STATE(1041), 1,
      sym_string,
    STATE(1220), 1,
      sym__module,
    STATE(4697), 1,
      sym_comment,
  [167536] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4698), 1,
      sym_comment,
    ACTIONS(5552), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [167554] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4111), 1,
      anon_sym_DQUOTE,
    ACTIONS(4113), 1,
      anon_sym_SQUOTE,
    ACTIONS(8039), 1,
      sym_identifier,
    STATE(947), 1,
      sym_nested_identifier,
    STATE(1041), 1,
      sym_string,
    STATE(1375), 1,
      sym__module,
    STATE(4699), 1,
      sym_comment,
  [167582] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4700), 1,
      sym_comment,
    ACTIONS(8388), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167604] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8390), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4530), 1,
      sym__call_signature,
    STATE(4701), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [167632] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8392), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4702), 1,
      sym_comment,
    STATE(4852), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [167660] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8244), 1,
      anon_sym_default,
    ACTIONS(8248), 1,
      anon_sym_case,
    ACTIONS(8394), 1,
      anon_sym_RBRACE,
    STATE(4703), 1,
      sym_comment,
    STATE(4716), 1,
      aux_sym_switch_body_repeat1,
    STATE(6137), 2,
      sym_switch_case,
      sym_switch_default,
  [167686] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4704), 1,
      sym_comment,
    ACTIONS(8396), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [167704] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4705), 1,
      sym_comment,
    ACTIONS(8398), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [167722] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3371), 1,
      sym_statement_block,
    STATE(4706), 1,
      sym_comment,
    ACTIONS(8077), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167744] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_DOT,
    ACTIONS(8400), 1,
      anon_sym_COMMA,
    ACTIONS(8402), 1,
      anon_sym_GT,
    STATE(4337), 1,
      sym_arguments,
    STATE(4707), 1,
      sym_comment,
    STATE(6262), 1,
      aux_sym_type_arguments_repeat1,
  [167772] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(8404), 1,
      anon_sym_COMMA,
    ACTIONS(8406), 1,
      anon_sym_GT,
    STATE(4708), 1,
      sym_comment,
    STATE(6266), 1,
      aux_sym_type_arguments_repeat1,
  [167800] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4709), 1,
      sym_comment,
    ACTIONS(8410), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8408), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167822] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4710), 1,
      sym_comment,
    ACTIONS(8194), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [167840] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4711), 1,
      sym_comment,
    ACTIONS(8412), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [167858] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4712), 1,
      sym_comment,
    ACTIONS(8416), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8414), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167880] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4700), 1,
      aux_sym_object_type_repeat1,
    STATE(4713), 1,
      sym_comment,
    ACTIONS(8416), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8414), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167902] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8418), 1,
      anon_sym_DOT,
    STATE(4714), 1,
      sym_comment,
    ACTIONS(7947), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167922] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8420), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4514), 1,
      sym__call_signature,
    STATE(4715), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [167950] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8244), 1,
      anon_sym_default,
    ACTIONS(8248), 1,
      anon_sym_case,
    ACTIONS(8422), 1,
      anon_sym_RBRACE,
    STATE(4716), 1,
      sym_comment,
    STATE(4744), 1,
      aux_sym_switch_body_repeat1,
    STATE(6137), 2,
      sym_switch_case,
      sym_switch_default,
  [167976] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4717), 1,
      sym_comment,
    ACTIONS(5740), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [167994] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4718), 1,
      sym_comment,
    STATE(4724), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8426), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8424), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168016] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4619), 1,
      aux_sym_object_type_repeat1,
    STATE(4719), 1,
      sym_comment,
    ACTIONS(8410), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8408), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168038] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8428), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4720), 1,
      sym_comment,
    STATE(4906), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [168066] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4721), 1,
      sym_comment,
    ACTIONS(5747), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [168084] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4722), 1,
      sym_comment,
    STATE(4725), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8432), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8430), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168106] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4723), 1,
      sym_comment,
    ACTIONS(5510), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [168124] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4724), 1,
      sym_comment,
    ACTIONS(8432), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8430), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168146] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4725), 1,
      sym_comment,
    ACTIONS(8436), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8434), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168168] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8438), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4726), 1,
      sym_comment,
    STATE(5844), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [168196] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4097), 1,
      anon_sym_DQUOTE,
    ACTIONS(4099), 1,
      anon_sym_SQUOTE,
    ACTIONS(8055), 1,
      sym_identifier,
    STATE(891), 1,
      sym_nested_identifier,
    STATE(912), 1,
      sym_string,
    STATE(1155), 1,
      sym__module,
    STATE(4727), 1,
      sym_comment,
  [168224] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4728), 1,
      sym_comment,
    ACTIONS(5490), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [168242] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3408), 1,
      sym_statement_block,
    STATE(4729), 1,
      sym_comment,
    ACTIONS(8075), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168264] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4097), 1,
      anon_sym_DQUOTE,
    ACTIONS(4099), 1,
      anon_sym_SQUOTE,
    ACTIONS(8055), 1,
      sym_identifier,
    STATE(891), 1,
      sym_nested_identifier,
    STATE(912), 1,
      sym_string,
    STATE(1083), 1,
      sym__module,
    STATE(4730), 1,
      sym_comment,
  [168292] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(8440), 1,
      anon_sym_QMARK,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4652), 1,
      sym__call_signature,
    STATE(4731), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [168320] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8442), 1,
      sym_identifier,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4732), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6921), 1,
      sym__call_signature,
  [168348] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3359), 1,
      sym_statement_block,
    STATE(4733), 1,
      sym_comment,
    ACTIONS(8075), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168370] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4734), 1,
      sym_comment,
    ACTIONS(8444), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [168388] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4712), 1,
      aux_sym_object_type_repeat1,
    STATE(4735), 1,
      sym_comment,
    ACTIONS(8448), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168410] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8450), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4486), 1,
      sym__call_signature,
    STATE(4736), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [168438] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8244), 1,
      anon_sym_default,
    ACTIONS(8248), 1,
      anon_sym_case,
    ACTIONS(8452), 1,
      anon_sym_RBRACE,
    STATE(4737), 1,
      sym_comment,
    STATE(4744), 1,
      aux_sym_switch_body_repeat1,
    STATE(6137), 2,
      sym_switch_case,
      sym_switch_default,
  [168464] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_DOT,
    ACTIONS(8454), 1,
      anon_sym_COMMA,
    ACTIONS(8456), 1,
      anon_sym_GT,
    STATE(4337), 1,
      sym_arguments,
    STATE(4738), 1,
      sym_comment,
    STATE(6277), 1,
      aux_sym_type_arguments_repeat1,
  [168492] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(8458), 1,
      anon_sym_COMMA,
    ACTIONS(8460), 1,
      anon_sym_GT,
    STATE(4739), 1,
      sym_comment,
    STATE(6273), 1,
      aux_sym_type_arguments_repeat1,
  [168520] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4740), 1,
      sym_comment,
    STATE(4743), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8464), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8462), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168542] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8325), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8466), 1,
      anon_sym_BQUOTE,
    STATE(4741), 1,
      sym_comment,
    STATE(4827), 1,
      aux_sym_template_string_repeat1,
    STATE(5469), 1,
      sym_template_substitution,
    ACTIONS(7921), 2,
      sym__template_chars,
      sym_escape_sequence,
  [168568] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4742), 1,
      sym_comment,
    STATE(4745), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8470), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168590] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4743), 1,
      sym_comment,
    ACTIONS(8470), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168612] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8472), 1,
      anon_sym_default,
    ACTIONS(8475), 1,
      anon_sym_RBRACE,
    ACTIONS(8477), 1,
      anon_sym_case,
    STATE(4744), 2,
      sym_comment,
      aux_sym_switch_body_repeat1,
    STATE(6137), 2,
      sym_switch_case,
      sym_switch_default,
  [168636] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4745), 1,
      sym_comment,
    ACTIONS(8482), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8480), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168658] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(8299), 1,
      anon_sym_LBRACK,
    ACTIONS(8484), 1,
      sym_identifier,
    STATE(4746), 1,
      sym_comment,
    STATE(6119), 1,
      sym__destructuring_pattern,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
  [168684] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8486), 1,
      sym_identifier,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4747), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6639), 1,
      sym__call_signature,
  [168712] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3407), 1,
      sym_statement_block,
    STATE(4748), 1,
      sym_comment,
    ACTIONS(8142), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168734] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(8488), 1,
      anon_sym_QMARK,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4749), 1,
      sym_comment,
    STATE(4839), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [168762] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(8490), 1,
      anon_sym_COMMA,
    ACTIONS(8492), 1,
      anon_sym_GT,
    STATE(4750), 1,
      sym_comment,
    STATE(6315), 1,
      aux_sym_type_arguments_repeat1,
  [168790] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4751), 1,
      sym_comment,
    ACTIONS(8494), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [168808] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_DOT,
    ACTIONS(8496), 1,
      anon_sym_COMMA,
    ACTIONS(8498), 1,
      anon_sym_GT,
    STATE(4337), 1,
      sym_arguments,
    STATE(4752), 1,
      sym_comment,
    STATE(6332), 1,
      aux_sym_type_arguments_repeat1,
  [168836] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4753), 1,
      sym_comment,
    ACTIONS(5693), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [168854] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_DOT,
    ACTIONS(8500), 1,
      anon_sym_COMMA,
    ACTIONS(8502), 1,
      anon_sym_GT,
    STATE(4337), 1,
      sym_arguments,
    STATE(4754), 1,
      sym_comment,
    STATE(6230), 1,
      aux_sym_type_arguments_repeat1,
  [168882] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4755), 1,
      sym_comment,
    ACTIONS(5560), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [168900] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(8504), 1,
      anon_sym_COMMA,
    ACTIONS(8506), 1,
      anon_sym_GT,
    STATE(4756), 1,
      sym_comment,
    STATE(6227), 1,
      aux_sym_type_arguments_repeat1,
  [168928] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4757), 1,
      sym_comment,
    STATE(4764), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8510), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8508), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168950] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8512), 1,
      anon_sym_QMARK,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4758), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6971), 1,
      sym__call_signature,
  [168978] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3369), 1,
      sym_statement_block,
    STATE(4759), 1,
      sym_comment,
    ACTIONS(8140), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169000] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4760), 1,
      sym_comment,
    STATE(4765), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8516), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8514), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169022] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3368), 1,
      sym_statement_block,
    STATE(4761), 1,
      sym_comment,
    ACTIONS(8142), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169044] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4762), 1,
      sym_comment,
    ACTIONS(8518), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [169062] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4763), 1,
      sym_comment,
    ACTIONS(8520), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [169080] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4764), 1,
      sym_comment,
    ACTIONS(8516), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8514), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169102] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4765), 1,
      sym_comment,
    ACTIONS(8524), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8522), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169124] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7939), 1,
      anon_sym_GT,
    ACTIONS(8526), 1,
      sym_identifier,
    ACTIONS(8528), 1,
      sym_jsx_identifier,
    ACTIONS(8530), 1,
      anon_sym_SLASH_GT,
    STATE(3915), 1,
      sym_nested_identifier,
    STATE(4273), 1,
      sym_jsx_namespace_name,
    STATE(4766), 1,
      sym_comment,
  [169152] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8532), 1,
      sym_identifier,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4767), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6921), 1,
      sym__call_signature,
  [169180] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8361), 1,
      anon_sym_COLON,
    STATE(4768), 1,
      sym_comment,
    ACTIONS(7507), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6833), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [169202] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4769), 1,
      sym_comment,
    STATE(4772), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8536), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8534), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169224] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4770), 1,
      sym_comment,
    STATE(4773), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8540), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8538), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169246] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8544), 1,
      anon_sym_AT,
    STATE(5410), 1,
      sym_decorator,
    STATE(4771), 2,
      sym_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(8542), 3,
      anon_sym_export,
      anon_sym_class,
      anon_sym_abstract,
  [169268] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4772), 1,
      sym_comment,
    ACTIONS(8540), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8538), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169290] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4773), 1,
      sym_comment,
    ACTIONS(8549), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8547), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169312] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4774), 1,
      sym_comment,
    ACTIONS(8551), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [169330] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4775), 1,
      sym_comment,
    STATE(4778), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8555), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8553), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169352] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8244), 1,
      anon_sym_default,
    ACTIONS(8248), 1,
      anon_sym_case,
    ACTIONS(8557), 1,
      anon_sym_RBRACE,
    STATE(4737), 1,
      aux_sym_switch_body_repeat1,
    STATE(4776), 1,
      sym_comment,
    STATE(6137), 2,
      sym_switch_case,
      sym_switch_default,
  [169378] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4613), 1,
      aux_sym_object_type_repeat1,
    STATE(4777), 1,
      sym_comment,
    ACTIONS(8561), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8559), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169400] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4628), 1,
      aux_sym_object_type_repeat1,
    STATE(4778), 1,
      sym_comment,
    ACTIONS(8561), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8559), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169422] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8563), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4779), 1,
      sym_comment,
    STATE(4849), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [169450] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8565), 1,
      sym_identifier,
    STATE(4780), 1,
      sym_comment,
    ACTIONS(7002), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [169470] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8065), 1,
      anon_sym_COMMA,
    ACTIONS(8069), 1,
      anon_sym_LT,
    ACTIONS(8567), 1,
      anon_sym_LBRACE,
    ACTIONS(8569), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4781), 1,
      sym_comment,
    STATE(5423), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(6159), 1,
      sym_type_arguments,
  [169498] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7939), 1,
      anon_sym_GT,
    ACTIONS(8571), 1,
      sym_identifier,
    ACTIONS(8573), 1,
      sym_jsx_identifier,
    ACTIONS(8575), 1,
      anon_sym_SLASH_GT,
    STATE(3947), 1,
      sym_nested_identifier,
    STATE(4203), 1,
      sym_jsx_namespace_name,
    STATE(4782), 1,
      sym_comment,
  [169526] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4783), 1,
      sym_comment,
    ACTIONS(8577), 6,
      anon_sym_export,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [169544] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8579), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4784), 1,
      sym_comment,
    STATE(5147), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [169572] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4785), 1,
      sym_comment,
    ACTIONS(8581), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [169590] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4786), 1,
      sym_comment,
    ACTIONS(8583), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [169608] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4787), 1,
      sym_comment,
    ACTIONS(8585), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [169626] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8325), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8587), 1,
      anon_sym_BQUOTE,
    STATE(4788), 1,
      sym_comment,
    STATE(4827), 1,
      aux_sym_template_string_repeat1,
    STATE(5469), 1,
      sym_template_substitution,
    ACTIONS(7921), 2,
      sym__template_chars,
      sym_escape_sequence,
  [169652] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4789), 1,
      sym_comment,
    ACTIONS(8581), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [169670] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4790), 1,
      sym_comment,
    ACTIONS(8589), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [169688] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(4791), 1,
      sym_comment,
    ACTIONS(8591), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [169712] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4792), 1,
      sym_comment,
    ACTIONS(8210), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [169730] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4793), 1,
      sym_comment,
    ACTIONS(8581), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [169748] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4794), 1,
      sym_comment,
    ACTIONS(7297), 6,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [169766] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8593), 1,
      anon_sym_export,
    ACTIONS(8595), 1,
      anon_sym_class,
    ACTIONS(8597), 1,
      anon_sym_abstract,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(4795), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [169794] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(8601), 1,
      anon_sym_QMARK,
    STATE(4796), 1,
      sym_comment,
    ACTIONS(8599), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [169820] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4709), 1,
      aux_sym_object_type_repeat1,
    STATE(4797), 1,
      sym_comment,
    ACTIONS(8605), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8603), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169842] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3361), 1,
      sym_statement_block,
    STATE(4798), 1,
      sym_comment,
    ACTIONS(8051), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169864] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(8607), 1,
      anon_sym_QMARK,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4733), 1,
      sym__call_signature,
    STATE(4799), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [169892] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(8299), 1,
      anon_sym_LBRACK,
    ACTIONS(8609), 1,
      sym_identifier,
    STATE(4800), 1,
      sym_comment,
    STATE(6310), 1,
      sym__destructuring_pattern,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
  [169918] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8611), 1,
      anon_sym_QMARK,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4801), 1,
      sym_comment,
    STATE(6404), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [169946] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8613), 1,
      sym_identifier,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4802), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6520), 1,
      sym__call_signature,
  [169974] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8615), 1,
      anon_sym_QMARK,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4803), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6672), 1,
      sym__call_signature,
  [170002] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3402), 1,
      sym_statement_block,
    STATE(4804), 1,
      sym_comment,
    ACTIONS(8130), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170024] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3398), 1,
      sym_statement_block,
    STATE(4805), 1,
      sym_comment,
    ACTIONS(8132), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170046] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(8299), 1,
      anon_sym_LBRACK,
    ACTIONS(8617), 1,
      sym_identifier,
    STATE(4806), 1,
      sym_comment,
    STATE(6431), 1,
      sym__destructuring_pattern,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
  [170072] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4807), 1,
      sym_comment,
    ACTIONS(4518), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [170090] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8619), 1,
      anon_sym_QMARK,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4808), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6908), 1,
      sym__call_signature,
  [170118] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4809), 1,
      sym_comment,
    ACTIONS(5732), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [170136] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(8621), 1,
      anon_sym_QMARK,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4759), 1,
      sym__call_signature,
    STATE(4810), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [170164] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(8003), 1,
      sym_identifier,
    STATE(4811), 1,
      sym_comment,
    STATE(5073), 1,
      sym_nested_identifier,
    STATE(5616), 1,
      sym_string,
    STATE(6527), 1,
      sym__module,
  [170192] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(8003), 1,
      sym_identifier,
    STATE(4812), 1,
      sym_comment,
    STATE(5073), 1,
      sym_nested_identifier,
    STATE(5616), 1,
      sym_string,
    STATE(6481), 1,
      sym__module,
  [170220] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3880), 1,
      anon_sym_LBRACE,
    ACTIONS(8299), 1,
      anon_sym_LBRACK,
    ACTIONS(8623), 1,
      sym_identifier,
    STATE(4813), 1,
      sym_comment,
    STATE(5473), 1,
      sym__destructuring_pattern,
    STATE(4288), 2,
      sym_object_pattern,
      sym_array_pattern,
  [170246] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8244), 1,
      anon_sym_default,
    ACTIONS(8248), 1,
      anon_sym_case,
    ACTIONS(8625), 1,
      anon_sym_RBRACE,
    STATE(4744), 1,
      aux_sym_switch_body_repeat1,
    STATE(4814), 1,
      sym_comment,
    STATE(6137), 2,
      sym_switch_case,
      sym_switch_default,
  [170272] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3410), 1,
      sym_statement_block,
    STATE(4815), 1,
      sym_comment,
    ACTIONS(8130), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170294] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8627), 1,
      anon_sym_QMARK,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4816), 1,
      sym_comment,
    STATE(6466), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [170322] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4817), 1,
      sym_comment,
    STATE(6364), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [170350] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8325), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8631), 1,
      anon_sym_BQUOTE,
    STATE(4788), 1,
      aux_sym_template_string_repeat1,
    STATE(4818), 1,
      sym_comment,
    STATE(5469), 1,
      sym_template_substitution,
    ACTIONS(7921), 2,
      sym__template_chars,
      sym_escape_sequence,
  [170376] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3413), 1,
      sym_statement_block,
    STATE(4819), 1,
      sym_comment,
    ACTIONS(8132), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170398] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8633), 1,
      anon_sym_QMARK,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4820), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6621), 1,
      sym__call_signature,
  [170426] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8635), 1,
      anon_sym_QMARK,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4821), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6754), 1,
      sym__call_signature,
  [170454] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8637), 1,
      anon_sym_QMARK,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4822), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6804), 1,
      sym__call_signature,
  [170482] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8639), 1,
      anon_sym_QMARK,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4823), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6830), 1,
      sym__call_signature,
  [170510] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8641), 1,
      sym_identifier,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4824), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6639), 1,
      sym__call_signature,
  [170538] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4825), 1,
      sym_comment,
    ACTIONS(8643), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4518), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [170558] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    ACTIONS(8645), 1,
      anon_sym_QMARK,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4826), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6509), 1,
      sym__call_signature,
  [170586] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8650), 1,
      anon_sym_BQUOTE,
    ACTIONS(8652), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(5469), 1,
      sym_template_substitution,
    ACTIONS(8647), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4827), 2,
      sym_comment,
      aux_sym_template_string_repeat1,
  [170610] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4828), 1,
      sym_comment,
    ACTIONS(8655), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [170628] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(8657), 1,
      anon_sym_COMMA,
    ACTIONS(8659), 1,
      anon_sym_GT,
    STATE(4829), 1,
      sym_comment,
    STATE(6198), 1,
      aux_sym_type_arguments_repeat1,
  [170656] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_DOT,
    ACTIONS(8661), 1,
      anon_sym_COMMA,
    ACTIONS(8663), 1,
      anon_sym_GT,
    STATE(4337), 1,
      sym_arguments,
    STATE(4830), 1,
      sym_comment,
    STATE(6193), 1,
      aux_sym_type_arguments_repeat1,
  [170684] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4831), 1,
      sym_comment,
    ACTIONS(8665), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [170702] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8669), 1,
      anon_sym_EQ,
    STATE(4832), 1,
      sym_comment,
    ACTIONS(8667), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [170722] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8671), 1,
      anon_sym_export,
    ACTIONS(8673), 1,
      anon_sym_class,
    ACTIONS(8675), 1,
      anon_sym_abstract,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(4833), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [170750] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4834), 1,
      sym_comment,
    ACTIONS(8677), 6,
      anon_sym_LBRACE,
      aux_sym_jsx_text_token1,
      aux_sym_jsx_text_token2,
      sym_html_character_reference,
      anon_sym_LT_SLASH,
      anon_sym_LT,
  [170768] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8679), 1,
      sym_identifier,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4835), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6639), 1,
      sym__call_signature,
  [170796] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(8681), 1,
      anon_sym_LBRACE,
    ACTIONS(8683), 1,
      anon_sym_COMMA,
    STATE(4836), 1,
      sym_comment,
    STATE(6166), 1,
      aux_sym_implements_clause_repeat1,
  [170824] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    STATE(4837), 1,
      sym_comment,
    STATE(5582), 1,
      sym_type_annotation,
    STATE(6721), 1,
      sym__initializer,
    ACTIONS(8685), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [170850] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8687), 1,
      anon_sym_export,
    ACTIONS(8689), 1,
      anon_sym_class,
    ACTIONS(8691), 1,
      anon_sym_abstract,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(4838), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [170878] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3388), 1,
      sym_statement_block,
    STATE(4839), 1,
      sym_comment,
    ACTIONS(8149), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170900] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8244), 1,
      anon_sym_default,
    ACTIONS(8248), 1,
      anon_sym_case,
    ACTIONS(8693), 1,
      anon_sym_RBRACE,
    STATE(4814), 1,
      aux_sym_switch_body_repeat1,
    STATE(4840), 1,
      sym_comment,
    STATE(6137), 2,
      sym_switch_case,
      sym_switch_default,
  [170926] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8695), 1,
      anon_sym_export,
    ACTIONS(8697), 1,
      anon_sym_class,
    ACTIONS(8699), 1,
      anon_sym_abstract,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(4841), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [170954] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1902), 1,
      anon_sym_LT,
    ACTIONS(8083), 1,
      anon_sym_LPAREN,
    ACTIONS(8701), 1,
      sym_identifier,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4842), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6921), 1,
      sym__call_signature,
  [170982] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    ACTIONS(8703), 1,
      anon_sym_QMARK,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4843), 1,
      sym_comment,
    STATE(5378), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [171010] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4844), 1,
      sym_comment,
    STATE(5267), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [171035] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4845), 1,
      sym_comment,
    STATE(5750), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171056] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4846), 1,
      sym_comment,
    STATE(5700), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171077] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4847), 1,
      sym_comment,
    ACTIONS(3522), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171094] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4848), 1,
      sym_comment,
    STATE(5374), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [171119] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4849), 1,
      sym_comment,
    ACTIONS(8132), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171136] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4850), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6792), 1,
      sym__call_signature,
  [171161] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4851), 1,
      sym_comment,
    STATE(5808), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171182] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4852), 1,
      sym_comment,
    ACTIONS(8149), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171199] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4853), 1,
      sym_comment,
    STATE(5807), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171220] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4854), 1,
      sym_comment,
    STATE(4890), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [171245] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4855), 1,
      sym_comment,
    STATE(5801), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171266] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4856), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6866), 1,
      sym__call_signature,
  [171291] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4857), 1,
      sym_comment,
    ACTIONS(8130), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171308] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4858), 1,
      sym_comment,
    ACTIONS(8711), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171325] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4859), 1,
      sym_comment,
    ACTIONS(8132), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171342] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4860), 1,
      sym_comment,
    STATE(5752), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171363] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4861), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6873), 1,
      sym__call_signature,
  [171388] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4862), 1,
      sym_comment,
    ACTIONS(8713), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171405] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4863), 1,
      sym_comment,
    ACTIONS(8147), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171422] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4864), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6893), 1,
      sym__call_signature,
  [171447] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4865), 1,
      sym_comment,
    STATE(5306), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [171472] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4866), 1,
      sym_comment,
    ACTIONS(8715), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171489] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4867), 1,
      sym_comment,
    STATE(5718), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171510] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4868), 1,
      sym_comment,
    ACTIONS(8717), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171527] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4869), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6924), 1,
      sym__call_signature,
  [171552] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4870), 1,
      sym_comment,
    ACTIONS(8719), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171569] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8721), 1,
      anon_sym_BQUOTE,
    ACTIONS(8723), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8725), 1,
      sym__template_chars,
    STATE(4871), 1,
      sym_comment,
    STATE(5020), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(6164), 1,
      sym_template_type,
  [171594] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2235), 1,
      anon_sym_DOT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5254), 1,
      anon_sym_LBRACE,
    STATE(4872), 1,
      sym_comment,
    ACTIONS(5256), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [171615] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4873), 1,
      sym_comment,
    STATE(5226), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [171640] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4874), 1,
      sym_comment,
    STATE(5689), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171661] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8727), 1,
      anon_sym_class,
    ACTIONS(8729), 1,
      anon_sym_abstract,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(4875), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [171686] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4876), 1,
      sym_comment,
    STATE(5181), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [171711] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4877), 1,
      sym_comment,
    STATE(5699), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171732] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4878), 1,
      sym_comment,
    ACTIONS(2351), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171749] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4879), 1,
      sym_comment,
    STATE(5697), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171770] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4880), 1,
      sym_comment,
    ACTIONS(3468), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171787] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4881), 1,
      sym_comment,
    STATE(6312), 1,
      sym__initializer,
    ACTIONS(8731), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171808] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2239), 1,
      anon_sym_DOT,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5254), 1,
      anon_sym_LBRACE,
    STATE(4882), 1,
      sym_comment,
    ACTIONS(5256), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [171829] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4883), 1,
      sym_comment,
    STATE(5645), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171850] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4884), 1,
      sym_comment,
    STATE(5878), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171871] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8733), 1,
      anon_sym_LBRACE,
    ACTIONS(8735), 1,
      anon_sym_SEMI,
    ACTIONS(8737), 1,
      sym__automatic_semicolon,
    ACTIONS(8739), 1,
      sym__function_signature_automatic_semicolon,
    STATE(383), 1,
      sym_statement_block,
    STATE(4885), 1,
      sym_comment,
  [171896] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4518), 1,
      anon_sym_COLON,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    ACTIONS(8741), 1,
      anon_sym_COMMA,
    ACTIONS(8743), 1,
      anon_sym_RBRACE,
    STATE(4886), 1,
      sym_comment,
    STATE(6192), 1,
      aux_sym_object_pattern_repeat1,
  [171921] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4682), 1,
      sym__call_signature,
    STATE(4887), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [171946] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4888), 1,
      sym_comment,
    STATE(6127), 1,
      sym__initializer,
    ACTIONS(8745), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171967] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4889), 1,
      sym_comment,
    STATE(5653), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171988] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4890), 1,
      sym_comment,
    ACTIONS(8155), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172005] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8011), 1,
      anon_sym_LBRACE,
    ACTIONS(8013), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1255), 1,
      sym_object_type,
    STATE(4891), 1,
      sym_comment,
    STATE(5720), 1,
      sym_extends_type_clause,
  [172030] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4892), 1,
      sym_comment,
    STATE(5658), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172051] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4893), 1,
      sym_comment,
    ACTIONS(3522), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172068] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4894), 1,
      sym_comment,
    STATE(5659), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172089] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4895), 1,
      sym_comment,
    ACTIONS(3522), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172106] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4896), 1,
      sym_comment,
    ACTIONS(6055), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [172123] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4897), 1,
      sym_comment,
    STATE(5838), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172144] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4898), 1,
      sym_comment,
    STATE(6215), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172165] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4899), 1,
      sym_comment,
    ACTIONS(6324), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [172182] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4900), 1,
      sym_comment,
    ACTIONS(5732), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [172199] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4901), 1,
      sym_comment,
    STATE(6212), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172220] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4902), 1,
      sym_comment,
    STATE(6211), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172241] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4903), 1,
      sym_comment,
    STATE(5817), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172262] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4904), 1,
      sym_comment,
    ACTIONS(3522), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172279] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4905), 1,
      sym_comment,
    STATE(5664), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172300] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4906), 1,
      sym_comment,
    ACTIONS(8075), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172317] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4907), 1,
      sym_comment,
    STATE(5140), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [172342] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4908), 1,
      sym_comment,
    STATE(5665), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172363] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8723), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8725), 1,
      sym__template_chars,
    ACTIONS(8751), 1,
      anon_sym_BQUOTE,
    STATE(4909), 1,
      sym_comment,
    STATE(5108), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(6164), 1,
      sym_template_type,
  [172388] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4910), 1,
      sym_comment,
    STATE(5671), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172409] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4911), 1,
      sym_comment,
    STATE(5855), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172430] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4912), 1,
      sym_comment,
    STATE(5672), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172451] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4913), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6613), 1,
      sym__call_signature,
  [172476] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4914), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6586), 1,
      sym__call_signature,
  [172501] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4915), 1,
      sym_comment,
    ACTIONS(8075), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172518] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4916), 1,
      sym_comment,
    ACTIONS(3522), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172535] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4917), 1,
      sym_comment,
    STATE(5679), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172556] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4918), 1,
      sym_comment,
    STATE(5111), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [172581] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4919), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6540), 1,
      sym__call_signature,
  [172606] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4920), 1,
      sym_comment,
    STATE(6056), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172627] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4921), 1,
      sym_comment,
    STATE(5043), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [172652] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4922), 1,
      sym_comment,
    STATE(6482), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [172677] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4923), 1,
      sym_comment,
    STATE(5685), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172698] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4924), 1,
      sym_comment,
    STATE(5035), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [172723] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4925), 1,
      sym_comment,
    STATE(5686), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172744] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4926), 1,
      sym_comment,
    ACTIONS(8753), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172761] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4927), 1,
      sym_comment,
    STATE(5687), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172782] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4928), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6637), 1,
      sym__call_signature,
  [172807] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4929), 1,
      sym_comment,
    STATE(6054), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172828] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4930), 1,
      sym_comment,
    STATE(4960), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [172853] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8673), 1,
      anon_sym_class,
    ACTIONS(8675), 1,
      anon_sym_abstract,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(4931), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [172878] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4932), 1,
      sym_comment,
    STATE(5705), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172899] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8755), 1,
      anon_sym_LBRACE,
    ACTIONS(8757), 1,
      anon_sym_SEMI,
    ACTIONS(8759), 1,
      sym__automatic_semicolon,
    ACTIONS(8761), 1,
      sym__function_signature_automatic_semicolon,
    STATE(428), 1,
      sym_statement_block,
    STATE(4933), 1,
      sym_comment,
  [172924] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4885), 1,
      sym__call_signature,
    STATE(4934), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [172949] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4935), 1,
      sym_comment,
    ACTIONS(2271), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172966] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4936), 1,
      sym_comment,
    STATE(5856), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172987] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4937), 1,
      sym_comment,
    ACTIONS(8763), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [173004] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4938), 1,
      sym_comment,
    STATE(5370), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [173029] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4939), 1,
      sym_comment,
    STATE(5721), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173050] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4940), 1,
      sym_comment,
    STATE(6181), 1,
      sym__initializer,
    ACTIONS(8765), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173071] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4941), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6800), 1,
      sym__call_signature,
  [173096] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4942), 1,
      sym_comment,
    STATE(6052), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173117] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4943), 1,
      sym_comment,
    ACTIONS(8283), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173134] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4944), 1,
      sym_comment,
    ACTIONS(8767), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [173151] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4945), 1,
      sym_comment,
    ACTIONS(3492), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173168] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4946), 1,
      sym_comment,
    ACTIONS(8077), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173185] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4947), 1,
      sym_comment,
    STATE(5734), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173206] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4948), 1,
      sym_comment,
    ACTIONS(8769), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173223] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4949), 1,
      sym_comment,
    STATE(5735), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173244] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8163), 1,
      anon_sym_LBRACE,
    ACTIONS(8165), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1492), 1,
      sym_object_type,
    STATE(4950), 1,
      sym_comment,
    STATE(6184), 1,
      sym_extends_type_clause,
  [173269] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4951), 1,
      sym_comment,
    STATE(5738), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173290] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4952), 1,
      sym_comment,
    ACTIONS(3530), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173307] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4953), 1,
      sym_comment,
    STATE(6047), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173328] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8771), 1,
      sym_identifier,
    ACTIONS(8773), 1,
      anon_sym_GT,
    ACTIONS(8775), 1,
      sym_jsx_identifier,
    STATE(4954), 1,
      sym_comment,
    STATE(6397), 1,
      sym_nested_identifier,
    STATE(7407), 1,
      sym_jsx_namespace_name,
  [173353] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8697), 1,
      anon_sym_class,
    ACTIONS(8699), 1,
      anon_sym_abstract,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(4955), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [173378] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4956), 1,
      sym_comment,
    ACTIONS(3504), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173395] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4957), 1,
      sym_comment,
    STATE(5744), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173416] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8361), 1,
      anon_sym_COLON,
    ACTIONS(8777), 1,
      anon_sym_EQ_GT,
    STATE(4958), 1,
      sym_comment,
    STATE(6678), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [173437] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4959), 1,
      sym_comment,
    STATE(5745), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173458] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8735), 1,
      anon_sym_SEMI,
    ACTIONS(8737), 1,
      sym__automatic_semicolon,
    ACTIONS(8739), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(8780), 1,
      anon_sym_LBRACE,
    STATE(1070), 1,
      sym_statement_block,
    STATE(4960), 1,
      sym_comment,
  [173483] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4961), 1,
      sym_comment,
    STATE(5746), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173504] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4962), 1,
      sym_comment,
    STATE(5357), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [173529] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4963), 1,
      sym_comment,
    ACTIONS(3504), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173546] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4964), 1,
      sym_comment,
    ACTIONS(3504), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173563] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4965), 1,
      sym_comment,
    STATE(6032), 1,
      sym__initializer,
    ACTIONS(8782), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173584] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4966), 1,
      sym_comment,
    STATE(5756), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173605] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4967), 1,
      sym_comment,
    ACTIONS(5552), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [173622] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4968), 1,
      sym_comment,
    ACTIONS(3534), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173639] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4969), 1,
      sym_comment,
    STATE(6018), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173660] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4970), 1,
      sym_comment,
    ACTIONS(5588), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [173677] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4971), 1,
      sym_comment,
    STATE(6011), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173698] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4972), 1,
      sym_comment,
    ACTIONS(5560), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [173715] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4973), 1,
      sym_comment,
    STATE(5767), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173736] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4974), 1,
      sym_comment,
    ACTIONS(5556), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [173753] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4975), 1,
      sym_comment,
    STATE(5775), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173774] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(8784), 1,
      sym_identifier,
    STATE(4976), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(6531), 1,
      sym__module_export_name,
  [173799] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4977), 1,
      sym_comment,
    STATE(5779), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173820] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(4978), 1,
      sym_comment,
    ACTIONS(5552), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [173837] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4979), 1,
      sym_comment,
    STATE(5198), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [173862] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4980), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6522), 1,
      sym__call_signature,
  [173887] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8757), 1,
      anon_sym_SEMI,
    ACTIONS(8759), 1,
      sym__automatic_semicolon,
    ACTIONS(8761), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(8786), 1,
      anon_sym_LBRACE,
    STATE(1171), 1,
      sym_statement_block,
    STATE(4981), 1,
      sym_comment,
  [173912] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(4982), 1,
      sym_comment,
    ACTIONS(8788), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [173935] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4983), 1,
      sym_comment,
    ACTIONS(3474), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173952] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4984), 1,
      sym_comment,
    STATE(5786), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173973] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4985), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6516), 1,
      sym__call_signature,
  [173998] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4986), 1,
      sym_comment,
    STATE(5787), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174019] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8792), 1,
      anon_sym_EQ,
    STATE(4987), 1,
      sym_comment,
    ACTIONS(4253), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [174038] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(4988), 1,
      sym_comment,
    ACTIONS(8794), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [174061] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4989), 1,
      sym_comment,
    STATE(5788), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174082] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4990), 1,
      sym_comment,
    ACTIONS(3456), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174099] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8691), 1,
      anon_sym_abstract,
    ACTIONS(8796), 1,
      anon_sym_class,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(4991), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [174124] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4992), 1,
      sym_comment,
    STATE(5789), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174145] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4993), 1,
      sym_comment,
    ACTIONS(3442), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174162] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4994), 1,
      sym_comment,
    STATE(5790), 1,
      sym__initializer,
    ACTIONS(8707), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174183] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4995), 1,
      sym_comment,
    ACTIONS(3438), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174200] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(4996), 1,
      sym_comment,
    ACTIONS(2177), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174217] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(4997), 1,
      sym_comment,
    STATE(6004), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174238] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4998), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6495), 1,
      sym__call_signature,
  [174263] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(4999), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6987), 1,
      sym__call_signature,
  [174288] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5000), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6494), 1,
      sym__call_signature,
  [174313] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5001), 1,
      sym_comment,
    STATE(5902), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174334] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5002), 1,
      sym_comment,
    STATE(5796), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174355] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5003), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6807), 1,
      sym__call_signature,
  [174380] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5004), 1,
      sym_comment,
    ACTIONS(5278), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [174397] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5005), 1,
      sym_comment,
    STATE(5797), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174418] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(5006), 1,
      sym_comment,
    STATE(5345), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [174443] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5007), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6803), 1,
      sym__call_signature,
  [174468] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5008), 1,
      sym_comment,
    STATE(6131), 1,
      sym__initializer,
    ACTIONS(8765), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174489] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym_comment,
    STATE(5798), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [174514] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5010), 1,
      sym_comment,
    STATE(5882), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174535] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5011), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6751), 1,
      sym__call_signature,
  [174560] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5012), 1,
      sym_comment,
    ACTIONS(5282), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [174577] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5013), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6628), 1,
      sym__call_signature,
  [174602] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5014), 1,
      sym_comment,
    STATE(6469), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [174627] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5015), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6602), 1,
      sym__call_signature,
  [174652] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5016), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6835), 1,
      sym__call_signature,
  [174677] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(5017), 1,
      sym_comment,
    STATE(5336), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [174702] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5018), 1,
      sym_comment,
    STATE(5998), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174723] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5019), 1,
      sym_comment,
    STATE(6180), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174744] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8723), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8725), 1,
      sym__template_chars,
    ACTIONS(8798), 1,
      anon_sym_BQUOTE,
    STATE(5020), 1,
      sym_comment,
    STATE(5394), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(6164), 1,
      sym_template_type,
  [174769] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5021), 1,
      sym_comment,
    STATE(6226), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174790] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5022), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6541), 1,
      sym__call_signature,
  [174815] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5023), 1,
      sym_comment,
    STATE(6216), 1,
      sym__initializer,
    ACTIONS(8765), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174836] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5024), 1,
      sym_comment,
    ACTIONS(2165), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174853] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5025), 1,
      sym_comment,
    STATE(5803), 1,
      sym__initializer,
    ACTIONS(8800), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174874] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5026), 1,
      sym_comment,
    ACTIONS(5290), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [174891] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5027), 1,
      sym_comment,
    STATE(6492), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [174916] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5028), 1,
      sym_comment,
    STATE(6485), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [174941] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5029), 1,
      sym_comment,
    STATE(6433), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [174966] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5030), 1,
      sym_comment,
    STATE(6185), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174987] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5031), 1,
      sym_comment,
    STATE(5980), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175008] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5032), 1,
      sym_comment,
    STATE(6456), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [175033] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5033), 1,
      sym_comment,
    STATE(6441), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [175058] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(5034), 1,
      sym_comment,
    STATE(5339), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [175083] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8733), 1,
      anon_sym_LBRACE,
    ACTIONS(8802), 1,
      anon_sym_SEMI,
    ACTIONS(8804), 1,
      sym__automatic_semicolon,
    ACTIONS(8806), 1,
      sym__function_signature_automatic_semicolon,
    STATE(406), 1,
      sym_statement_block,
    STATE(5035), 1,
      sym_comment,
  [175108] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5036), 1,
      sym_comment,
    STATE(5967), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175129] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    ACTIONS(8808), 1,
      anon_sym_COMMA,
    ACTIONS(8810), 1,
      anon_sym_RBRACE,
    STATE(5037), 1,
      sym_comment,
    STATE(5768), 1,
      aux_sym_enum_body_repeat1,
    STATE(6795), 1,
      sym__initializer,
  [175154] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5038), 1,
      sym_comment,
    ACTIONS(3490), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175171] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5039), 1,
      sym_comment,
    ACTIONS(8494), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175188] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5040), 1,
      sym_comment,
    STATE(6210), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175209] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5041), 1,
      sym_comment,
    STATE(6362), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [175234] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5042), 1,
      sym_comment,
    STATE(5806), 1,
      sym__initializer,
    ACTIONS(8812), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175255] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8780), 1,
      anon_sym_LBRACE,
    ACTIONS(8802), 1,
      anon_sym_SEMI,
    ACTIONS(8804), 1,
      sym__automatic_semicolon,
    ACTIONS(8806), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1120), 1,
      sym_statement_block,
    STATE(5043), 1,
      sym_comment,
  [175280] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5044), 1,
      sym_comment,
    ACTIONS(8814), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175297] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5045), 1,
      sym_comment,
    STATE(6402), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [175322] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5046), 1,
      sym_comment,
    ACTIONS(8816), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [175345] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5047), 1,
      sym_comment,
    STATE(6371), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [175370] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5048), 1,
      sym_comment,
    STATE(6179), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175391] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5049), 1,
      sym_comment,
    ACTIONS(3522), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175408] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4761), 1,
      sym__call_signature,
    STATE(5050), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [175433] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5051), 1,
      sym_comment,
    ACTIONS(3580), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175450] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5052), 1,
      sym_comment,
    ACTIONS(8818), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175467] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5053), 1,
      sym_comment,
    STATE(6313), 1,
      sym__initializer,
    ACTIONS(8820), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175488] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5054), 1,
      sym_comment,
    STATE(6202), 1,
      sym__initializer,
    ACTIONS(8820), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175509] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5055), 1,
      sym_comment,
    ACTIONS(8822), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175526] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5056), 1,
      sym_comment,
    STATE(6316), 1,
      sym__initializer,
    ACTIONS(8765), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175547] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(5057), 1,
      sym_comment,
    STATE(5301), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [175572] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5058), 1,
      sym_comment,
    ACTIONS(5740), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [175589] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5059), 1,
      sym_comment,
    STATE(6174), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175610] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5060), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6679), 1,
      sym__call_signature,
  [175635] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5061), 1,
      sym_comment,
    ACTIONS(6352), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [175652] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5062), 1,
      sym_comment,
    STATE(6396), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [175677] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(5063), 1,
      sym_comment,
    STATE(5274), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [175702] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5064), 1,
      sym_comment,
    ACTIONS(5541), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [175719] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5065), 1,
      sym_comment,
    ACTIONS(8824), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [175742] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5066), 1,
      sym_comment,
    STATE(5883), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175763] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5067), 1,
      sym_comment,
    ACTIONS(5545), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [175780] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(5068), 1,
      sym_comment,
    STATE(5266), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [175805] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8595), 1,
      anon_sym_class,
    ACTIONS(8597), 1,
      anon_sym_abstract,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5069), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [175830] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5070), 1,
      sym_comment,
    ACTIONS(3396), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175847] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5071), 1,
      sym_comment,
    ACTIONS(5807), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [175864] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5072), 1,
      sym_comment,
    ACTIONS(5904), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [175881] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    ACTIONS(8826), 1,
      anon_sym_DOT,
    STATE(5073), 1,
      sym_comment,
    STATE(6339), 1,
      sym_statement_block,
    ACTIONS(2061), 2,
      anon_sym_else,
      anon_sym_while,
  [175904] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    ACTIONS(8828), 1,
      anon_sym_DOT,
    STATE(5074), 1,
      sym_comment,
    STATE(6339), 1,
      sym_statement_block,
    ACTIONS(2061), 2,
      anon_sym_else,
      anon_sym_while,
  [175927] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5075), 1,
      sym_comment,
    ACTIONS(8830), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [175944] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5076), 1,
      sym_comment,
    ACTIONS(3566), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175961] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5077), 1,
      sym_comment,
    STATE(6031), 1,
      sym__initializer,
    ACTIONS(8765), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175982] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5078), 1,
      sym_comment,
    STATE(5994), 1,
      sym__initializer,
    ACTIONS(8765), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176003] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5079), 1,
      sym_comment,
    ACTIONS(5552), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [176020] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5080), 1,
      sym_comment,
    ACTIONS(6330), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [176037] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5081), 1,
      sym_comment,
    ACTIONS(6330), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [176054] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5082), 1,
      sym_comment,
    ACTIONS(6330), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [176071] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5083), 1,
      sym_comment,
    ACTIONS(5747), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [176088] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5084), 1,
      sym_comment,
    ACTIONS(3394), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176105] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(5085), 1,
      sym_comment,
    STATE(5261), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [176130] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5086), 1,
      sym_comment,
    ACTIONS(3394), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176147] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5087), 1,
      sym_comment,
    ACTIONS(3392), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176164] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5088), 1,
      sym_comment,
    ACTIONS(2387), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176181] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5089), 1,
      sym_comment,
    STATE(5887), 1,
      sym__initializer,
    ACTIONS(8709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176202] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5090), 1,
      sym_comment,
    STATE(6307), 1,
      sym__initializer,
    ACTIONS(8832), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176223] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5091), 1,
      sym_comment,
    STATE(6176), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176244] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5092), 1,
      sym_comment,
    ACTIONS(2325), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176261] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(5093), 1,
      sym_comment,
    STATE(5203), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [176286] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4981), 1,
      sym__call_signature,
    STATE(5094), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [176311] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5095), 1,
      sym_comment,
    ACTIONS(8834), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176328] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5096), 1,
      sym_comment,
    ACTIONS(8836), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [176345] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5097), 1,
      sym_comment,
    STATE(5962), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [176370] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5098), 1,
      sym_comment,
    ACTIONS(2275), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176387] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5099), 1,
      sym_comment,
    ACTIONS(8838), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [176410] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5100), 1,
      sym_comment,
    STATE(6190), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176431] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8069), 1,
      anon_sym_LT,
    ACTIONS(8840), 1,
      anon_sym_LBRACE,
    STATE(5101), 1,
      sym_comment,
    STATE(6159), 1,
      sym_type_arguments,
    ACTIONS(8842), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [176454] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8699), 1,
      anon_sym_abstract,
    ACTIONS(8844), 1,
      anon_sym_class,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5102), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [176479] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5103), 1,
      sym_comment,
    STATE(5932), 1,
      sym__initializer,
    ACTIONS(8846), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176500] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5104), 1,
      sym_comment,
    STATE(5957), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176521] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5105), 1,
      sym_comment,
    ACTIONS(3536), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176538] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(5106), 1,
      sym_comment,
    STATE(5254), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [176563] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5107), 1,
      sym_comment,
    STATE(6424), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [176588] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8723), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8725), 1,
      sym__template_chars,
    ACTIONS(8848), 1,
      anon_sym_BQUOTE,
    STATE(5108), 1,
      sym_comment,
    STATE(5394), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(6164), 1,
      sym_template_type,
  [176613] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5109), 1,
      sym_comment,
    ACTIONS(3388), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176630] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5110), 1,
      sym_comment,
    STATE(6172), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176651] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8755), 1,
      anon_sym_LBRACE,
    ACTIONS(8850), 1,
      anon_sym_SEMI,
    ACTIONS(8852), 1,
      sym__automatic_semicolon,
    ACTIONS(8854), 1,
      sym__function_signature_automatic_semicolon,
    STATE(451), 1,
      sym_statement_block,
    STATE(5111), 1,
      sym_comment,
  [176676] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5112), 1,
      sym_comment,
    STATE(5941), 1,
      sym__initializer,
    ACTIONS(8856), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176697] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5113), 1,
      sym_comment,
    ACTIONS(8858), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176714] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(5114), 1,
      sym_comment,
    STATE(5247), 1,
      sym__call_signature,
    STATE(6732), 1,
      sym_type_parameters,
  [176739] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5115), 1,
      sym_comment,
    ACTIONS(8860), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176756] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5116), 1,
      sym_comment,
    ACTIONS(8097), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176773] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5117), 1,
      sym_comment,
    ACTIONS(8862), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176790] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5118), 1,
      sym_comment,
    STATE(6220), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176811] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5119), 1,
      sym_comment,
    STATE(6444), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [176836] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5120), 1,
      sym_comment,
    STATE(5949), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176857] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5121), 1,
      sym_comment,
    ACTIONS(8099), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176874] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(5122), 1,
      sym_comment,
    ACTIONS(8864), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [176897] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5123), 1,
      sym_comment,
    STATE(6451), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [176922] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5124), 1,
      sym_comment,
    STATE(6463), 1,
      sym__call_signature,
    STATE(6493), 1,
      sym_type_parameters,
  [176947] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5125), 1,
      sym_comment,
    STATE(5657), 1,
      sym__initializer,
    ACTIONS(8866), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176968] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5126), 1,
      sym_comment,
    STATE(6241), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176989] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5127), 1,
      sym_comment,
    ACTIONS(5693), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [177006] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(8784), 1,
      sym_identifier,
    STATE(5128), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(6081), 1,
      sym__module_export_name,
  [177031] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5129), 1,
      sym_comment,
    STATE(6170), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177052] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5130), 1,
      sym_comment,
    ACTIONS(8868), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [177069] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8365), 1,
      anon_sym_class,
    ACTIONS(8367), 1,
      anon_sym_abstract,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5131), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [177094] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5132), 1,
      sym_comment,
    ACTIONS(3452), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177111] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5133), 1,
      sym_comment,
    STATE(6169), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177132] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5134), 1,
      sym_comment,
    ACTIONS(3444), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177149] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5135), 1,
      sym_comment,
    ACTIONS(8870), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177166] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5136), 1,
      sym_comment,
    ACTIONS(8099), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177183] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5137), 1,
      sym_comment,
    STATE(5138), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [177208] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5138), 1,
      sym_comment,
    ACTIONS(8119), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177225] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5139), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6717), 1,
      sym__call_signature,
  [177250] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5140), 1,
      sym_comment,
    ACTIONS(8097), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177267] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8872), 1,
      sym_identifier,
    ACTIONS(8874), 1,
      anon_sym_GT,
    ACTIONS(8876), 1,
      sym_jsx_identifier,
    STATE(5141), 1,
      sym_comment,
    STATE(6428), 1,
      sym_nested_identifier,
    STATE(7393), 1,
      sym_jsx_namespace_name,
  [177292] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5142), 1,
      sym_comment,
    STATE(5243), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [177317] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5143), 1,
      sym_comment,
    ACTIONS(2239), 5,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_GT,
      anon_sym_DOT,
  [177334] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5144), 1,
      sym_comment,
    ACTIONS(2235), 5,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_GT,
      anon_sym_DOT,
  [177351] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5145), 1,
      sym_comment,
    STATE(5821), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177372] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5146), 1,
      sym_comment,
    ACTIONS(3418), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177389] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5147), 1,
      sym_comment,
    ACTIONS(8121), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177406] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4657), 1,
      sym__call_signature,
    STATE(5148), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [177431] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5149), 1,
      sym_comment,
    STATE(5823), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177452] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5150), 1,
      sym_comment,
    ACTIONS(8880), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177469] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(8882), 1,
      anon_sym_as,
    ACTIONS(8884), 1,
      anon_sym_RBRACK,
    STATE(5151), 1,
      sym_comment,
  [177494] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5152), 1,
      sym_comment,
    STATE(5812), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177515] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5153), 1,
      sym_comment,
    STATE(5948), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177536] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    ACTIONS(8888), 1,
      anon_sym_COMMA,
    ACTIONS(8890), 1,
      anon_sym_RBRACE,
    STATE(5154), 1,
      sym_comment,
    STATE(6101), 1,
      aux_sym_enum_body_repeat1,
    STATE(6795), 1,
      sym__initializer,
  [177561] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5155), 1,
      sym_comment,
    STATE(5656), 1,
      sym__initializer,
    ACTIONS(8866), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177582] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5156), 1,
      sym_comment,
    ACTIONS(6430), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [177599] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8892), 1,
      sym_identifier,
    ACTIONS(8894), 1,
      anon_sym_GT,
    ACTIONS(8896), 1,
      sym_jsx_identifier,
    STATE(5157), 1,
      sym_comment,
    STATE(6967), 1,
      sym_nested_identifier,
    STATE(6998), 1,
      sym_jsx_namespace_name,
  [177624] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5158), 1,
      sym_comment,
    ACTIONS(8655), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [177641] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5159), 1,
      sym_comment,
    ACTIONS(3548), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177658] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5160), 1,
      sym_comment,
    ACTIONS(3564), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177675] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5161), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6837), 1,
      sym__call_signature,
  [177700] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4804), 1,
      sym__call_signature,
    STATE(5162), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [177725] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5163), 1,
      sym_comment,
    STATE(5988), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177746] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5164), 1,
      sym_comment,
    STATE(6225), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177767] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5165), 1,
      sym_comment,
    STATE(5708), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177788] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5166), 1,
      sym_comment,
    STATE(6138), 1,
      sym__initializer,
    ACTIONS(8898), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177809] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    STATE(5167), 1,
      sym_comment,
    STATE(6658), 1,
      sym_type_annotation,
    ACTIONS(4287), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [177830] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5168), 1,
      sym_comment,
    STATE(6129), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177851] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5169), 1,
      sym_comment,
    ACTIONS(3544), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177868] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5170), 1,
      sym_comment,
    ACTIONS(3568), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177885] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5171), 1,
      sym_comment,
    ACTIONS(2351), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177902] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8361), 1,
      anon_sym_COLON,
    ACTIONS(8900), 1,
      anon_sym_EQ_GT,
    STATE(5172), 1,
      sym_comment,
    STATE(6678), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [177923] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4518), 1,
      anon_sym_COLON,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    ACTIONS(8741), 1,
      anon_sym_COMMA,
    ACTIONS(8903), 1,
      anon_sym_RBRACE,
    STATE(5173), 1,
      sym_comment,
    STATE(5869), 1,
      aux_sym_object_pattern_repeat1,
  [177948] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5174), 1,
      sym_comment,
    STATE(6265), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177969] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5175), 1,
      sym_comment,
    ACTIONS(3574), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177986] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8723), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8725), 1,
      sym__template_chars,
    ACTIONS(8905), 1,
      anon_sym_BQUOTE,
    STATE(5176), 1,
      sym_comment,
    STATE(5256), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(6164), 1,
      sym_template_type,
  [178011] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5177), 1,
      sym_comment,
    ACTIONS(8119), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178028] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5178), 1,
      sym_comment,
    STATE(5851), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178049] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5179), 1,
      sym_comment,
    ACTIONS(8907), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178066] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5180), 1,
      sym_comment,
    STATE(6275), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178087] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8909), 1,
      anon_sym_LBRACE,
    ACTIONS(8911), 1,
      anon_sym_SEMI,
    ACTIONS(8913), 1,
      sym__automatic_semicolon,
    ACTIONS(8915), 1,
      sym__function_signature_automatic_semicolon,
    STATE(344), 1,
      sym_statement_block,
    STATE(5181), 1,
      sym_comment,
  [178112] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8361), 1,
      anon_sym_COLON,
    ACTIONS(8917), 1,
      anon_sym_EQ_GT,
    STATE(5182), 1,
      sym_comment,
    STATE(6833), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [178133] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5183), 1,
      sym_comment,
    ACTIONS(8121), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178150] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5184), 1,
      sym_comment,
    ACTIONS(8412), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178167] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5185), 1,
      sym_comment,
    STATE(6134), 1,
      sym__initializer,
    ACTIONS(8920), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178188] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5186), 1,
      sym_comment,
    ACTIONS(8922), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178205] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5187), 1,
      sym_comment,
    ACTIONS(8398), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178222] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5188), 1,
      sym_comment,
    ACTIONS(8924), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178239] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5189), 1,
      sym_comment,
    STATE(5815), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178260] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5190), 1,
      sym_comment,
    ACTIONS(8926), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178277] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(8784), 1,
      sym_identifier,
    STATE(5191), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(6885), 1,
      sym__module_export_name,
  [178302] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1894), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(8784), 1,
      sym_identifier,
    STATE(5192), 1,
      sym_comment,
    STATE(5551), 1,
      sym_string,
    STATE(7090), 1,
      sym__module_export_name,
  [178327] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5193), 1,
      sym_comment,
    STATE(6279), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178348] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5194), 1,
      sym_comment,
    ACTIONS(8396), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178365] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1344), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4993), 1,
      sym_object_type,
    STATE(5195), 1,
      sym_comment,
    STATE(6010), 1,
      sym_extends_type_clause,
  [178390] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8723), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8725), 1,
      sym__template_chars,
    ACTIONS(8928), 1,
      anon_sym_BQUOTE,
    STATE(5196), 1,
      sym_comment,
    STATE(5293), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(6164), 1,
      sym_template_type,
  [178415] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5197), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6912), 1,
      sym__call_signature,
  [178440] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8786), 1,
      anon_sym_LBRACE,
    ACTIONS(8850), 1,
      anon_sym_SEMI,
    ACTIONS(8852), 1,
      sym__automatic_semicolon,
    ACTIONS(8854), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1386), 1,
      sym_statement_block,
    STATE(5198), 1,
      sym_comment,
  [178465] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(5199), 1,
      sym_comment,
    STATE(6122), 1,
      sym__call_signature,
    STATE(6769), 1,
      sym_type_parameters,
  [178490] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6380), 1,
      sym__automatic_semicolon,
    STATE(5200), 1,
      sym_comment,
    ACTIONS(2287), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178509] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8597), 1,
      anon_sym_abstract,
    ACTIONS(8930), 1,
      anon_sym_class,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5201), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [178534] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5202), 1,
      sym_comment,
    ACTIONS(8932), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [178557] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    ACTIONS(8934), 1,
      anon_sym_SEMI,
    ACTIONS(8936), 1,
      sym__automatic_semicolon,
    ACTIONS(8938), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3063), 1,
      sym_statement_block,
    STATE(5203), 1,
      sym_comment,
  [178582] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5204), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6862), 1,
      sym__call_signature,
  [178607] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5205), 1,
      sym_comment,
    ACTIONS(3466), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178624] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5206), 1,
      sym_comment,
    ACTIONS(3460), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178641] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8940), 1,
      sym_identifier,
    ACTIONS(8942), 1,
      anon_sym_GT,
    ACTIONS(8944), 1,
      sym_jsx_identifier,
    STATE(5207), 1,
      sym_comment,
    STATE(6842), 1,
      sym_nested_identifier,
    STATE(7077), 1,
      sym_jsx_namespace_name,
  [178666] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5208), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6939), 1,
      sym__call_signature,
  [178691] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4614), 1,
      sym__call_signature,
    STATE(5209), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [178716] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5210), 1,
      sym_comment,
    STATE(5926), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178737] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5211), 1,
      sym_comment,
    STATE(6124), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178758] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6266), 1,
      sym__automatic_semicolon,
    STATE(5212), 1,
      sym_comment,
    ACTIONS(2357), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178777] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5213), 1,
      sym_comment,
    STATE(5888), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178798] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5214), 1,
      sym_comment,
    ACTIONS(8946), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178815] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6226), 1,
      sym__automatic_semicolon,
    STATE(5215), 1,
      sym_comment,
    ACTIONS(2365), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178834] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5216), 1,
      sym_comment,
    ACTIONS(8948), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178851] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5217), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6974), 1,
      sym__call_signature,
  [178876] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5218), 1,
      sym_comment,
    STATE(6123), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178897] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(209), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8001), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5219), 1,
      sym_comment,
    STATE(6322), 1,
      sym_extends_type_clause,
    STATE(6361), 1,
      sym_object_type,
  [178922] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5220), 1,
      sym_comment,
    STATE(5889), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178943] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6264), 1,
      sym__automatic_semicolon,
    STATE(5221), 1,
      sym_comment,
    ACTIONS(2329), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178962] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5222), 1,
      sym_comment,
    STATE(6251), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178983] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5223), 1,
      sym_comment,
    STATE(6252), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179004] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4683), 1,
      sym_formal_parameters,
    STATE(5224), 1,
      sym_comment,
    STATE(6493), 1,
      sym_type_parameters,
    STATE(6767), 1,
      sym__call_signature,
  [179029] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5225), 1,
      sym_comment,
    STATE(5917), 1,
      sym__initializer,
    ACTIONS(8950), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179050] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    ACTIONS(8952), 1,
      anon_sym_SEMI,
    ACTIONS(8954), 1,
      sym__automatic_semicolon,
    ACTIONS(8956), 1,
      sym__function_signature_automatic_semicolon,
    STATE(5221), 1,
      sym_statement_block,
    STATE(5226), 1,
      sym_comment,
  [179075] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5227), 1,
      sym_comment,
    ACTIONS(8958), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [179098] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5228), 1,
      sym_comment,
    STATE(5891), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179119] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5229), 1,
      sym_comment,
    STATE(6104), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179140] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5230), 1,
      sym_comment,
    STATE(5910), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179161] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5231), 1,
      sym_comment,
    STATE(6103), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179182] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8675), 1,
      anon_sym_abstract,
    ACTIONS(8960), 1,
      anon_sym_class,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5232), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [179207] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5233), 1,
      sym_comment,
    ACTIONS(8962), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [179230] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5234), 1,
      sym_comment,
    STATE(5933), 1,
      sym__initializer,
    ACTIONS(8964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179251] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5235), 1,
      sym_comment,
    STATE(5904), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179272] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5236), 1,
      sym_comment,
    STATE(6086), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179293] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5237), 1,
      sym_comment,
    STATE(5954), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179314] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5238), 1,
      sym_comment,
    STATE(5861), 1,
      sym__initializer,
    ACTIONS(8782), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179335] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8968), 1,
      anon_sym_in,
    ACTIONS(8970), 1,
      anon_sym_of,
    STATE(5239), 1,
      sym_comment,
    ACTIONS(8966), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179356] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5240), 1,
      sym_comment,
    STATE(5771), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179377] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5241), 1,
      sym_comment,
    ACTIONS(3472), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179394] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5242), 1,
      sym_comment,
    STATE(5920), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179415] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5243), 1,
      sym_comment,
    ACTIONS(8130), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179432] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5244), 1,
      sym_comment,
    ACTIONS(8972), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [179455] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8361), 1,
      anon_sym_COLON,
    ACTIONS(8974), 1,
      anon_sym_EQ_GT,
    STATE(5245), 1,
      sym_comment,
    STATE(6678), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [179476] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5246), 1,
      sym_comment,
    ACTIONS(3458), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179493] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8977), 1,
      anon_sym_LBRACE,
    ACTIONS(8979), 1,
      anon_sym_SEMI,
    ACTIONS(8981), 1,
      sym__automatic_semicolon,
    ACTIONS(8983), 1,
      sym__function_signature_automatic_semicolon,
    STATE(952), 1,
      sym_statement_block,
    STATE(5247), 1,
      sym_comment,
  [179518] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5248), 1,
      sym_comment,
    ACTIONS(3458), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179535] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5249), 1,
      sym_comment,
    ACTIONS(3470), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179552] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5250), 1,
      sym_comment,
    ACTIONS(5676), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [179569] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5251), 1,
      sym_comment,
    STATE(6148), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179590] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    ACTIONS(8985), 1,
      anon_sym_COMMA,
    ACTIONS(8987), 1,
      anon_sym_RBRACE,
    STATE(5252), 1,
      sym_comment,
    STATE(6267), 1,
      aux_sym_enum_body_repeat1,
    STATE(6795), 1,
      sym__initializer,
  [179615] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5253), 1,
      sym_comment,
    ACTIONS(5363), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [179632] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8979), 1,
      anon_sym_SEMI,
    ACTIONS(8981), 1,
      sym__automatic_semicolon,
    ACTIONS(8983), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(8989), 1,
      anon_sym_LBRACE,
    STATE(296), 1,
      sym_statement_block,
    STATE(5254), 1,
      sym_comment,
  [179657] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5255), 1,
      sym_comment,
    STATE(5704), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179678] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8723), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8725), 1,
      sym__template_chars,
    ACTIONS(8991), 1,
      anon_sym_BQUOTE,
    STATE(5256), 1,
      sym_comment,
    STATE(5394), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(6164), 1,
      sym_template_type,
  [179703] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5257), 1,
      sym_comment,
    STATE(5703), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179724] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5258), 1,
      sym_comment,
    STATE(5937), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179745] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5259), 1,
      sym_comment,
    ACTIONS(8993), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [179768] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5260), 1,
      sym_comment,
    ACTIONS(3476), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179785] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8977), 1,
      anon_sym_LBRACE,
    ACTIONS(8995), 1,
      anon_sym_SEMI,
    ACTIONS(8997), 1,
      sym__automatic_semicolon,
    ACTIONS(8999), 1,
      sym__function_signature_automatic_semicolon,
    STATE(926), 1,
      sym_statement_block,
    STATE(5261), 1,
      sym_comment,
  [179810] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5262), 1,
      sym_comment,
    ACTIONS(3408), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179827] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5263), 1,
      sym_comment,
    ACTIONS(3480), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179844] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5264), 1,
      sym_comment,
    ACTIONS(3482), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179861] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5265), 1,
      sym_comment,
    ACTIONS(6498), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [179878] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    ACTIONS(8934), 1,
      anon_sym_SEMI,
    ACTIONS(8936), 1,
      sym__automatic_semicolon,
    ACTIONS(8938), 1,
      sym__function_signature_automatic_semicolon,
    STATE(5266), 1,
      sym_comment,
    STATE(6222), 1,
      sym_statement_block,
  [179903] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8909), 1,
      anon_sym_LBRACE,
    ACTIONS(9001), 1,
      anon_sym_SEMI,
    ACTIONS(9003), 1,
      sym__automatic_semicolon,
    ACTIONS(9005), 1,
      sym__function_signature_automatic_semicolon,
    STATE(375), 1,
      sym_statement_block,
    STATE(5267), 1,
      sym_comment,
  [179928] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5268), 1,
      sym_comment,
    ACTIONS(9007), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [179951] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5269), 1,
      sym_comment,
    ACTIONS(2313), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179968] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5270), 1,
      sym_comment,
    STATE(5955), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179989] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8059), 1,
      anon_sym_LBRACE,
    ACTIONS(8061), 1,
      anon_sym_LBRACE_PIPE,
    STATE(992), 1,
      sym_object_type,
    STATE(5271), 1,
      sym_comment,
    STATE(6282), 1,
      sym_extends_type_clause,
  [180014] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5272), 1,
      sym_comment,
    ACTIONS(3484), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180031] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5273), 1,
      sym_comment,
    STATE(5702), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180052] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8989), 1,
      anon_sym_LBRACE,
    ACTIONS(8995), 1,
      anon_sym_SEMI,
    ACTIONS(8997), 1,
      sym__automatic_semicolon,
    ACTIONS(8999), 1,
      sym__function_signature_automatic_semicolon,
    STATE(337), 1,
      sym_statement_block,
    STATE(5274), 1,
      sym_comment,
  [180077] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5275), 1,
      sym_comment,
    ACTIONS(8551), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [180094] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5276), 1,
      sym_comment,
    STATE(6093), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180115] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5277), 1,
      sym_comment,
    ACTIONS(5106), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [180132] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5278), 1,
      sym_comment,
    ACTIONS(3578), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180149] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    ACTIONS(9009), 1,
      anon_sym_COMMA,
    ACTIONS(9011), 1,
      anon_sym_RBRACE,
    STATE(5279), 1,
      sym_comment,
    STATE(6051), 1,
      aux_sym_enum_body_repeat1,
    STATE(6795), 1,
      sym__initializer,
  [180174] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5280), 1,
      sym_comment,
    ACTIONS(5106), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [180191] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5281), 1,
      sym_comment,
    ACTIONS(3582), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180208] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5282), 1,
      sym_comment,
    STATE(6319), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180229] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5283), 1,
      sym_comment,
    ACTIONS(6504), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [180246] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5284), 1,
      sym_comment,
    STATE(5698), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180267] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5285), 1,
      sym_comment,
    ACTIONS(3464), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180284] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5286), 1,
      sym_comment,
    ACTIONS(6504), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [180301] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5287), 1,
      sym_comment,
    STATE(6318), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180322] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5288), 1,
      sym_comment,
    STATE(6090), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180343] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5289), 1,
      sym_comment,
    ACTIONS(5349), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [180360] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5290), 1,
      sym_comment,
    ACTIONS(6504), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [180377] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4654), 1,
      sym__call_signature,
    STATE(5291), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [180402] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5292), 1,
      sym_comment,
    ACTIONS(5154), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [180419] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8723), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8725), 1,
      sym__template_chars,
    ACTIONS(9013), 1,
      anon_sym_BQUOTE,
    STATE(5293), 1,
      sym_comment,
    STATE(5394), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(6164), 1,
      sym_template_type,
  [180444] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5294), 1,
      sym_comment,
    ACTIONS(5154), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [180461] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5295), 1,
      sym_comment,
    ACTIONS(5210), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [180478] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5296), 1,
      sym_comment,
    ACTIONS(3462), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180495] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5297), 1,
      sym_comment,
    STATE(6089), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180516] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5298), 1,
      sym_comment,
    ACTIONS(5353), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [180533] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    ACTIONS(7173), 1,
      anon_sym_LT,
    STATE(4255), 1,
      sym_formal_parameters,
    STATE(4933), 1,
      sym__call_signature,
    STATE(5299), 1,
      sym_comment,
    STATE(6732), 1,
      sym_type_parameters,
  [180558] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5300), 1,
      sym_comment,
    ACTIONS(5357), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [180575] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    ACTIONS(9015), 1,
      anon_sym_SEMI,
    ACTIONS(9017), 1,
      sym__automatic_semicolon,
    ACTIONS(9019), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3170), 1,
      sym_statement_block,
    STATE(5301), 1,
      sym_comment,
  [180600] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5302), 1,
      sym_comment,
    STATE(6073), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180621] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5303), 1,
      sym_comment,
    STATE(6088), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180642] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5304), 1,
      sym_comment,
    ACTIONS(3510), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180659] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5305), 1,
      sym_comment,
    STATE(5958), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180680] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    ACTIONS(9021), 1,
      anon_sym_SEMI,
    ACTIONS(9023), 1,
      sym__automatic_semicolon,
    ACTIONS(9025), 1,
      sym__function_signature_automatic_semicolon,
    STATE(5215), 1,
      sym_statement_block,
    STATE(5306), 1,
      sym_comment,
  [180705] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5307), 1,
      sym_comment,
    ACTIONS(5510), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [180722] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5308), 1,
      sym_comment,
    ACTIONS(5490), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [180739] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5309), 1,
      sym_comment,
    ACTIONS(3558), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180756] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5310), 1,
      sym_comment,
    STATE(5915), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180777] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9027), 1,
      anon_sym_in,
    ACTIONS(9029), 1,
      anon_sym_of,
    STATE(5311), 1,
      sym_comment,
    ACTIONS(8966), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180798] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5312), 1,
      sym_comment,
    STATE(5655), 1,
      sym__initializer,
    ACTIONS(8866), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180819] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    ACTIONS(9031), 1,
      anon_sym_COMMA,
    ACTIONS(9033), 1,
      anon_sym_RBRACE,
    STATE(5313), 1,
      sym_comment,
    STATE(6207), 1,
      aux_sym_enum_body_repeat1,
    STATE(6795), 1,
      sym__initializer,
  [180844] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5314), 1,
      sym_comment,
    ACTIONS(9035), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [180867] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5315), 1,
      sym_comment,
    ACTIONS(3510), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180884] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5316), 1,
      sym_comment,
    STATE(5990), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180905] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5317), 1,
      sym_comment,
    ACTIONS(3458), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180922] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5318), 1,
      sym_comment,
    ACTIONS(3538), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180939] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5319), 1,
      sym_comment,
    STATE(5833), 1,
      sym__initializer,
    ACTIONS(9037), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180960] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5320), 1,
      sym_comment,
    ACTIONS(9039), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [180983] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5321), 1,
      sym_comment,
    STATE(5852), 1,
      sym__initializer,
    ACTIONS(9041), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181004] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5322), 1,
      sym_comment,
    STATE(6077), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181025] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5323), 1,
      sym_comment,
    STATE(5975), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181046] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5324), 1,
      sym_comment,
    ACTIONS(3516), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181063] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5325), 1,
      sym_comment,
    STATE(5684), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181084] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5326), 1,
      sym_comment,
    ACTIONS(2343), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181101] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8361), 1,
      anon_sym_COLON,
    ACTIONS(9043), 1,
      anon_sym_EQ_GT,
    STATE(5327), 1,
      sym_comment,
    STATE(6678), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [181122] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5328), 1,
      sym_comment,
    STATE(5647), 1,
      sym__initializer,
    ACTIONS(8866), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181143] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8361), 1,
      anon_sym_COLON,
    ACTIONS(9046), 1,
      anon_sym_EQ_GT,
    STATE(5329), 1,
      sym_comment,
    STATE(6833), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [181164] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5330), 1,
      sym_comment,
    ACTIONS(3556), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181181] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5331), 1,
      sym_comment,
    STATE(5760), 1,
      sym__initializer,
    ACTIONS(9049), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181202] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5332), 1,
      sym_comment,
    STATE(6256), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181223] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5333), 1,
      sym_comment,
    STATE(5675), 1,
      sym__initializer,
    ACTIONS(8705), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181244] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5334), 1,
      sym_comment,
    ACTIONS(9051), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181267] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5335), 1,
      sym_comment,
    ACTIONS(2381), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181284] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9001), 1,
      anon_sym_SEMI,
    ACTIONS(9003), 1,
      sym__automatic_semicolon,
    ACTIONS(9005), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(9053), 1,
      anon_sym_LBRACE,
    STATE(1023), 1,
      sym_statement_block,
    STATE(5336), 1,
      sym_comment,
  [181309] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5337), 1,
      sym_comment,
    ACTIONS(2373), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181326] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5338), 1,
      sym_comment,
    ACTIONS(3524), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181343] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    ACTIONS(9015), 1,
      anon_sym_SEMI,
    ACTIONS(9017), 1,
      sym__automatic_semicolon,
    ACTIONS(9019), 1,
      sym__function_signature_automatic_semicolon,
    STATE(5339), 1,
      sym_comment,
    STATE(6040), 1,
      sym_statement_block,
  [181368] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8361), 1,
      anon_sym_COLON,
    ACTIONS(9055), 1,
      anon_sym_EQ_GT,
    STATE(5340), 1,
      sym_comment,
    STATE(6833), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [181389] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5341), 1,
      sym_comment,
    STATE(6272), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181410] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5342), 1,
      sym_comment,
    STATE(6149), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181431] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5343), 1,
      sym_comment,
    ACTIONS(9058), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181454] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    ACTIONS(9060), 1,
      anon_sym_COMMA,
    ACTIONS(9062), 1,
      anon_sym_RBRACE,
    STATE(5344), 1,
      sym_comment,
    STATE(6302), 1,
      aux_sym_enum_body_repeat1,
    STATE(6795), 1,
      sym__initializer,
  [181479] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    ACTIONS(9021), 1,
      anon_sym_SEMI,
    ACTIONS(9023), 1,
      sym__automatic_semicolon,
    ACTIONS(9025), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2929), 1,
      sym_statement_block,
    STATE(5345), 1,
      sym_comment,
  [181504] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8723), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8725), 1,
      sym__template_chars,
    ACTIONS(9064), 1,
      anon_sym_BQUOTE,
    STATE(5346), 1,
      sym_comment,
    STATE(5394), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(6164), 1,
      sym_template_type,
  [181529] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5347), 1,
      sym_comment,
    ACTIONS(3554), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181546] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5348), 1,
      sym_comment,
    STATE(6065), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181567] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5349), 1,
      sym_comment,
    ACTIONS(6165), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [181584] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5350), 1,
      sym_comment,
    STATE(6007), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181605] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5351), 1,
      sym_comment,
    ACTIONS(3552), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181622] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5352), 1,
      sym_comment,
    STATE(5979), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181643] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5353), 1,
      sym_comment,
    ACTIONS(9066), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181666] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4509), 1,
      sym__call_signature,
    STATE(5354), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [181691] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5355), 1,
      sym_comment,
    STATE(6008), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181712] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5356), 1,
      sym_comment,
    STATE(6070), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181733] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8911), 1,
      anon_sym_SEMI,
    ACTIONS(8913), 1,
      sym__automatic_semicolon,
    ACTIONS(8915), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(9053), 1,
      anon_sym_LBRACE,
    STATE(1107), 1,
      sym_statement_block,
    STATE(5357), 1,
      sym_comment,
  [181758] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5358), 1,
      sym_comment,
    ACTIONS(3422), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181775] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5359), 1,
      sym_comment,
    ACTIONS(3550), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181792] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5360), 1,
      sym_comment,
    STATE(6046), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181813] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5361), 1,
      sym_comment,
    STATE(6290), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181834] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5362), 1,
      sym_comment,
    STATE(6288), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181855] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5363), 1,
      sym_comment,
    ACTIONS(8051), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181872] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5364), 1,
      sym_comment,
    ACTIONS(3546), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181889] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5365), 1,
      sym_comment,
    STATE(6043), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181910] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5366), 1,
      sym_comment,
    STATE(6016), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181931] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5367), 1,
      sym_comment,
    STATE(6064), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181952] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5368), 1,
      sym_comment,
    ACTIONS(9068), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181969] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7999), 1,
      anon_sym_extends,
    ACTIONS(8043), 1,
      anon_sym_LBRACE,
    ACTIONS(8045), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1211), 1,
      sym_object_type,
    STATE(5369), 1,
      sym_comment,
    STATE(6257), 1,
      sym_extends_type_clause,
  [181994] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    ACTIONS(8952), 1,
      anon_sym_SEMI,
    ACTIONS(8954), 1,
      sym__automatic_semicolon,
    ACTIONS(8956), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2936), 1,
      sym_statement_block,
    STATE(5370), 1,
      sym_comment,
  [182019] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8723), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8725), 1,
      sym__template_chars,
    ACTIONS(9070), 1,
      anon_sym_BQUOTE,
    STATE(5346), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5371), 1,
      sym_comment,
    STATE(6164), 1,
      sym_template_type,
  [182044] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4560), 1,
      sym__call_signature,
    STATE(5372), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [182069] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5373), 1,
      sym_comment,
    STATE(6021), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182090] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5374), 1,
      sym_comment,
    ACTIONS(8142), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182107] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5375), 1,
      sym_comment,
    STATE(5999), 1,
      sym__initializer,
    ACTIONS(8886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182128] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5376), 1,
      sym_comment,
    STATE(6062), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182149] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4863), 1,
      sym__call_signature,
    STATE(5377), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [182174] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5378), 1,
      sym_comment,
    ACTIONS(8140), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182191] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8361), 1,
      anon_sym_COLON,
    ACTIONS(9072), 1,
      anon_sym_EQ_GT,
    STATE(5379), 1,
      sym_comment,
    STATE(6833), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [182212] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8689), 1,
      anon_sym_class,
    ACTIONS(8691), 1,
      anon_sym_abstract,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5380), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [182237] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4557), 1,
      sym__call_signature,
    STATE(5381), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [182262] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8729), 1,
      anon_sym_abstract,
    ACTIONS(9075), 1,
      anon_sym_class,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5382), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [182287] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5383), 1,
      sym_comment,
    ACTIONS(9077), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182310] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5384), 1,
      sym_comment,
    STATE(6270), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182331] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4568), 1,
      sym__call_signature,
    STATE(5385), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [182356] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(5386), 1,
      sym_comment,
    ACTIONS(9079), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [182379] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5387), 1,
      sym_comment,
    ACTIONS(5809), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [182396] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7067), 1,
      anon_sym_LBRACK,
    ACTIONS(9081), 1,
      anon_sym_RBRACE,
    STATE(5388), 1,
      sym_comment,
    ACTIONS(4883), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [182417] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(5389), 1,
      sym_comment,
    ACTIONS(9083), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [182440] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4529), 1,
      sym__call_signature,
    STATE(5390), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [182465] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5391), 1,
      sym_comment,
    ACTIONS(9085), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [182482] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5392), 1,
      sym_comment,
    ACTIONS(8142), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182499] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5393), 1,
      sym_comment,
    STATE(6026), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182520] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9087), 1,
      anon_sym_BQUOTE,
    ACTIONS(9089), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(9092), 1,
      sym__template_chars,
    STATE(6164), 1,
      sym_template_type,
    STATE(5394), 2,
      sym_comment,
      aux_sym_template_literal_type_repeat1,
  [182543] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(7673), 1,
      anon_sym_DOT,
    STATE(4337), 1,
      sym_arguments,
    STATE(5395), 1,
      sym_comment,
    ACTIONS(9095), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [182566] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5396), 1,
      sym_comment,
    ACTIONS(9097), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [182583] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(5397), 1,
      sym_comment,
    ACTIONS(9099), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [182606] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(8367), 1,
      anon_sym_abstract,
    ACTIONS(9101), 1,
      anon_sym_class,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5398), 1,
      sym_comment,
    STATE(5410), 1,
      sym_decorator,
  [182631] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5399), 1,
      sym_comment,
    STATE(6284), 1,
      sym__initializer,
    ACTIONS(8749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182652] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5400), 1,
      sym_comment,
    STATE(6042), 1,
      sym__initializer,
    ACTIONS(8878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182673] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5480), 1,
      anon_sym_in,
    STATE(5401), 1,
      sym_comment,
    ACTIONS(6416), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [182692] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
    STATE(4543), 1,
      sym__call_signature,
    STATE(5402), 1,
      sym_comment,
    STATE(6769), 1,
      sym_type_parameters,
  [182717] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5403), 1,
      sym_comment,
    ACTIONS(9103), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [182734] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5404), 1,
      sym_comment,
    ACTIONS(9105), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182751] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5405), 1,
      sym_comment,
    ACTIONS(9107), 5,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_SLASH_GT,
      sym_identifier,
  [182768] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5406), 1,
      sym_comment,
    ACTIONS(9109), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182791] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7163), 1,
      anon_sym_EQ,
    STATE(5407), 1,
      sym_comment,
    STATE(6027), 1,
      sym__initializer,
    ACTIONS(8747), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182812] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9111), 1,
      anon_sym_DQUOTE,
    STATE(5408), 1,
      sym_comment,
    STATE(5586), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [182832] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5409), 1,
      sym_comment,
    STATE(6438), 1,
      sym_import_attribute,
    ACTIONS(9117), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182852] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5410), 1,
      sym_comment,
    ACTIONS(9119), 4,
      anon_sym_export,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [182868] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5411), 1,
      sym_comment,
    STATE(6609), 1,
      sym__from_clause,
    ACTIONS(9123), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182888] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9125), 1,
      anon_sym_RBRACK,
    STATE(5412), 1,
      sym_comment,
  [182910] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5413), 1,
      sym_comment,
    STATE(6598), 1,
      sym_import_attribute,
    ACTIONS(9127), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182930] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5414), 1,
      sym_comment,
    STATE(6597), 1,
      sym_import_attribute,
    ACTIONS(9129), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182950] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5415), 1,
      sym_comment,
    STATE(5434), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9133), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182970] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5416), 1,
      sym_comment,
    STATE(5435), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9135), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182990] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9137), 1,
      anon_sym_QMARK,
    STATE(5417), 1,
      sym_comment,
  [183012] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9139), 1,
      anon_sym_DQUOTE,
    STATE(5418), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183032] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9141), 1,
      anon_sym_SQUOTE,
    STATE(5419), 1,
      sym_comment,
    STATE(5425), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183052] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9141), 1,
      anon_sym_DQUOTE,
    STATE(5418), 1,
      aux_sym_string_repeat1,
    STATE(5420), 1,
      sym_comment,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183072] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9145), 1,
      sym_identifier,
    STATE(5101), 1,
      sym_nested_type_identifier,
    STATE(5421), 1,
      sym_comment,
    STATE(5857), 1,
      sym_generic_type,
    STATE(7112), 1,
      sym_nested_identifier,
  [183094] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8065), 1,
      anon_sym_COMMA,
    ACTIONS(9147), 1,
      anon_sym_LBRACE,
    ACTIONS(9149), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5422), 1,
      sym_comment,
    STATE(5534), 1,
      aux_sym_extends_type_clause_repeat1,
  [183116] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8065), 1,
      anon_sym_COMMA,
    ACTIONS(9151), 1,
      anon_sym_LBRACE,
    ACTIONS(9153), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5423), 1,
      sym_comment,
    STATE(5534), 1,
      aux_sym_extends_type_clause_repeat1,
  [183138] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8065), 1,
      anon_sym_COMMA,
    ACTIONS(9151), 1,
      anon_sym_LBRACE,
    ACTIONS(9153), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5424), 1,
      sym_comment,
    STATE(5534), 1,
      aux_sym_extends_type_clause_repeat1,
  [183160] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9139), 1,
      anon_sym_SQUOTE,
    STATE(5425), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183180] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9155), 1,
      anon_sym_COLON,
    STATE(5426), 1,
      sym_comment,
  [183202] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9081), 1,
      anon_sym_RBRACE,
    STATE(5427), 1,
      sym_comment,
    ACTIONS(4883), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [183220] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9157), 1,
      anon_sym_COLON,
    STATE(5428), 1,
      sym_comment,
  [183242] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5429), 1,
      sym_comment,
    STATE(6515), 1,
      sym__from_clause,
    ACTIONS(5878), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183262] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5430), 1,
      sym_comment,
    STATE(6747), 1,
      sym__from_clause,
    ACTIONS(9159), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183282] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5431), 1,
      sym_comment,
    STATE(6506), 1,
      sym_import_attribute,
    ACTIONS(9161), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183302] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5432), 1,
      sym_comment,
    STATE(6505), 1,
      sym_import_attribute,
    ACTIONS(9163), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183322] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    ACTIONS(9165), 1,
      anon_sym_SEMI,
    ACTIONS(9167), 1,
      sym__automatic_semicolon,
    STATE(5433), 1,
      sym_comment,
    STATE(6504), 1,
      sym_import_attribute,
  [183344] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5434), 1,
      sym_comment,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9169), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183364] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5435), 1,
      sym_comment,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9171), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183384] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5436), 1,
      sym_comment,
    STATE(6931), 1,
      sym_import_attribute,
    ACTIONS(9173), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183404] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9175), 1,
      anon_sym_RBRACK,
    STATE(5437), 1,
      sym_comment,
  [183426] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8095), 1,
      anon_sym_DOT,
    ACTIONS(9177), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_GT,
    STATE(5438), 1,
      sym_comment,
    STATE(6264), 1,
      aux_sym_type_arguments_repeat1,
  [183448] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5439), 1,
      sym_comment,
    STATE(6945), 1,
      sym_import_attribute,
    ACTIONS(9181), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183468] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5440), 1,
      sym_comment,
    ACTIONS(3242), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(9183), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183486] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4384), 1,
      sym_formal_parameters,
    STATE(5441), 1,
      sym_comment,
    STATE(6341), 1,
      sym_type_parameters,
  [183508] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5442), 1,
      sym_comment,
    STATE(5632), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9185), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183528] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5443), 1,
      sym_comment,
    STATE(5631), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9187), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183548] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    ACTIONS(9189), 1,
      anon_sym_SEMI,
    ACTIONS(9191), 1,
      sym__automatic_semicolon,
    STATE(5444), 1,
      sym_comment,
    STATE(6429), 1,
      sym_import_attribute,
  [183570] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7075), 1,
      anon_sym_LPAREN,
    ACTIONS(7081), 1,
      anon_sym_LT,
    STATE(4009), 1,
      sym_arguments,
    STATE(4133), 1,
      sym_type_arguments,
    STATE(5445), 1,
      sym_comment,
  [183592] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9193), 1,
      anon_sym_RPAREN,
    STATE(5446), 1,
      sym_comment,
  [183614] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9197), 1,
      anon_sym_COMMA,
    ACTIONS(9195), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    STATE(5447), 2,
      sym_comment,
      aux_sym_extends_clause_repeat1,
  [183632] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9200), 1,
      anon_sym_RBRACK,
    STATE(5448), 1,
      sym_comment,
  [183654] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9202), 1,
      anon_sym_EQ,
    ACTIONS(9204), 1,
      anon_sym_COMMA,
    ACTIONS(9206), 1,
      anon_sym_RBRACK,
    STATE(5449), 1,
      sym_comment,
    STATE(5972), 1,
      aux_sym_array_pattern_repeat1,
  [183676] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9208), 1,
      anon_sym_DQUOTE,
    STATE(5450), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183696] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9210), 1,
      anon_sym_RBRACK,
    STATE(5451), 1,
      sym_comment,
  [183718] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9208), 1,
      anon_sym_SQUOTE,
    STATE(5452), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183738] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9212), 1,
      anon_sym_COLON,
    STATE(5453), 1,
      sym_comment,
  [183760] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9214), 1,
      anon_sym_DQUOTE,
    STATE(5454), 1,
      sym_comment,
    STATE(5460), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183780] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9214), 1,
      anon_sym_SQUOTE,
    STATE(5455), 1,
      sym_comment,
    STATE(5461), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183800] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7937), 1,
      anon_sym_const,
    ACTIONS(9216), 1,
      sym_identifier,
    ACTIONS(9218), 1,
      anon_sym_GT,
    STATE(5456), 1,
      sym_comment,
    STATE(6618), 1,
      sym_type_parameter,
  [183822] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5457), 1,
      sym_comment,
    STATE(6384), 1,
      sym__from_clause,
    ACTIONS(9220), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183842] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5458), 1,
      sym_comment,
    STATE(5465), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9222), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183862] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5459), 1,
      sym_comment,
    STATE(5466), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9224), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183882] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9226), 1,
      anon_sym_DQUOTE,
    STATE(5460), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183902] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9226), 1,
      anon_sym_SQUOTE,
    STATE(5461), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183922] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9228), 1,
      anon_sym_RPAREN,
    STATE(5462), 1,
      sym_comment,
  [183944] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym_LT,
    STATE(2737), 1,
      sym_type_arguments,
    STATE(2738), 1,
      sym_arguments,
    STATE(5463), 1,
      sym_comment,
  [183966] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5464), 1,
      sym_comment,
    STATE(6410), 1,
      sym__from_clause,
    ACTIONS(5923), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183986] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5465), 1,
      sym_comment,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9232), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184006] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5466), 1,
      sym_comment,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9234), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184026] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    ACTIONS(9236), 1,
      anon_sym_SEMI,
    ACTIONS(9238), 1,
      sym__automatic_semicolon,
    STATE(5467), 1,
      sym_comment,
    STATE(6499), 1,
      sym_import_attribute,
  [184048] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8095), 1,
      anon_sym_DOT,
    ACTIONS(9240), 1,
      anon_sym_COMMA,
    ACTIONS(9242), 1,
      anon_sym_GT,
    STATE(5468), 1,
      sym_comment,
    STATE(6274), 1,
      aux_sym_type_arguments_repeat1,
  [184070] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5469), 1,
      sym_comment,
    ACTIONS(9244), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [184086] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(9246), 1,
      anon_sym_class,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5470), 1,
      sym_comment,
  [184108] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9248), 1,
      anon_sym_RPAREN,
    STATE(5471), 1,
      sym_comment,
  [184130] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(9250), 1,
      anon_sym_LT,
    STATE(2324), 1,
      sym_arguments,
    STATE(2325), 1,
      sym_type_arguments,
    STATE(5472), 1,
      sym_comment,
  [184152] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9252), 1,
      anon_sym_EQ,
    STATE(5473), 1,
      sym_comment,
    STATE(6858), 1,
      sym__initializer,
    ACTIONS(7499), 2,
      anon_sym_in,
      anon_sym_of,
  [184172] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9254), 1,
      anon_sym_QMARK,
    STATE(5474), 1,
      sym_comment,
  [184194] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9256), 1,
      anon_sym_DQUOTE,
    STATE(5475), 1,
      sym_comment,
    STATE(5482), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184214] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9256), 1,
      anon_sym_SQUOTE,
    STATE(5476), 1,
      sym_comment,
    STATE(5483), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184234] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    ACTIONS(9258), 1,
      anon_sym_SEMI,
    ACTIONS(9260), 1,
      sym__automatic_semicolon,
    STATE(5477), 1,
      sym_comment,
    STATE(6887), 1,
      sym_import_attribute,
  [184256] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5478), 1,
      sym_comment,
    STATE(5484), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9262), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184276] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    ACTIONS(5434), 1,
      anon_sym_BQUOTE,
    STATE(5479), 1,
      sym_comment,
    STATE(3118), 2,
      sym_template_string,
      sym_arguments,
  [184296] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8095), 1,
      anon_sym_DOT,
    ACTIONS(9264), 1,
      anon_sym_COMMA,
    ACTIONS(9266), 1,
      anon_sym_GT,
    STATE(5480), 1,
      sym_comment,
    STATE(6326), 1,
      aux_sym_type_arguments_repeat1,
  [184318] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5481), 1,
      sym_comment,
    STATE(5485), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9268), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184338] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9270), 1,
      anon_sym_DQUOTE,
    STATE(5482), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184358] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9270), 1,
      anon_sym_SQUOTE,
    STATE(5483), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184378] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5484), 1,
      sym_comment,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9272), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184398] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5485), 1,
      sym_comment,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9274), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184418] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8095), 1,
      anon_sym_DOT,
    ACTIONS(9276), 1,
      anon_sym_COMMA,
    ACTIONS(9278), 1,
      anon_sym_GT,
    STATE(5486), 1,
      sym_comment,
    STATE(6017), 1,
      aux_sym_type_arguments_repeat1,
  [184440] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8095), 1,
      anon_sym_DOT,
    ACTIONS(9280), 1,
      anon_sym_COMMA,
    ACTIONS(9282), 1,
      anon_sym_GT,
    STATE(5487), 1,
      sym_comment,
    STATE(6229), 1,
      aux_sym_type_arguments_repeat1,
  [184462] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9284), 1,
      sym__glimmer_template_content,
    ACTIONS(9286), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(3143), 1,
      sym_glimmer_closing_tag,
    STATE(5488), 1,
      sym_comment,
    STATE(6069), 1,
      aux_sym_glimmer_template_repeat1,
  [184484] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7937), 1,
      anon_sym_const,
    ACTIONS(9216), 1,
      sym_identifier,
    ACTIONS(9288), 1,
      anon_sym_GT,
    STATE(5489), 1,
      sym_comment,
    STATE(6618), 1,
      sym_type_parameter,
  [184506] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9290), 1,
      anon_sym_DQUOTE,
    STATE(5490), 1,
      sym_comment,
    STATE(5492), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184526] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9290), 1,
      anon_sym_SQUOTE,
    STATE(5491), 1,
      sym_comment,
    STATE(5493), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184546] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9292), 1,
      anon_sym_DQUOTE,
    STATE(5492), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184566] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9292), 1,
      anon_sym_SQUOTE,
    STATE(5493), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184586] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9294), 1,
      anon_sym_DQUOTE,
    STATE(5494), 1,
      sym_comment,
    STATE(5498), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184606] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9294), 1,
      anon_sym_SQUOTE,
    STATE(5495), 1,
      sym_comment,
    STATE(5499), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184626] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9296), 1,
      anon_sym_RBRACK,
    STATE(5496), 1,
      sym_comment,
  [184648] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9298), 1,
      anon_sym_RBRACK,
    STATE(5497), 1,
      sym_comment,
  [184670] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9300), 1,
      anon_sym_DQUOTE,
    STATE(5498), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184690] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9300), 1,
      anon_sym_SQUOTE,
    STATE(5499), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184710] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9302), 1,
      anon_sym_QMARK,
    STATE(5500), 1,
      sym_comment,
  [184732] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9244), 1,
      sym_escape_sequence,
    STATE(5501), 1,
      sym_comment,
    ACTIONS(9304), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [184750] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5502), 1,
      sym_comment,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9307), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184770] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5503), 1,
      sym_comment,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9309), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184790] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    ACTIONS(9311), 1,
      anon_sym_SEMI,
    ACTIONS(9313), 1,
      sym__automatic_semicolon,
    STATE(5504), 1,
      sym_comment,
    STATE(6382), 1,
      sym_import_attribute,
  [184812] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5505), 1,
      sym_comment,
    STATE(6393), 1,
      sym_import_attribute,
    ACTIONS(9315), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184832] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5506), 1,
      sym_comment,
    STATE(6394), 1,
      sym_import_attribute,
    ACTIONS(9317), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184852] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9319), 1,
      anon_sym_DQUOTE,
    STATE(5507), 1,
      sym_comment,
    STATE(5510), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184872] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9284), 1,
      sym__glimmer_template_content,
    ACTIONS(9286), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(3067), 1,
      sym_glimmer_closing_tag,
    STATE(5488), 1,
      aux_sym_glimmer_template_repeat1,
    STATE(5508), 1,
      sym_comment,
  [184894] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9319), 1,
      anon_sym_SQUOTE,
    STATE(5509), 1,
      sym_comment,
    STATE(5511), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184914] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9321), 1,
      anon_sym_DQUOTE,
    STATE(5510), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184934] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9321), 1,
      anon_sym_SQUOTE,
    STATE(5511), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184954] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5512), 1,
      sym_comment,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9323), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184974] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5513), 1,
      sym_comment,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9325), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184994] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5514), 1,
      sym_comment,
    ACTIONS(3118), 4,
      sym__automatic_semicolon,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
  [185010] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    ACTIONS(9327), 1,
      anon_sym_SEMI,
    ACTIONS(9329), 1,
      sym__automatic_semicolon,
    STATE(5515), 1,
      sym_comment,
    STATE(6940), 1,
      sym_import_attribute,
  [185032] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5516), 1,
      sym_comment,
    STATE(6941), 1,
      sym_import_attribute,
    ACTIONS(9331), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185052] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5517), 1,
      sym_comment,
    STATE(6947), 1,
      sym_import_attribute,
    ACTIONS(9333), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185072] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9335), 1,
      anon_sym_DQUOTE,
    STATE(5518), 1,
      sym_comment,
    STATE(5521), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [185092] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9335), 1,
      anon_sym_SQUOTE,
    STATE(5519), 1,
      sym_comment,
    STATE(5522), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [185112] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5520), 1,
      sym_comment,
    STATE(6962), 1,
      sym__from_clause,
    ACTIONS(5616), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185132] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9337), 1,
      anon_sym_DQUOTE,
    STATE(5521), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [185152] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9337), 1,
      anon_sym_SQUOTE,
    STATE(5522), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [185172] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9339), 1,
      anon_sym_DQUOTE,
    STATE(5523), 1,
      sym_comment,
    STATE(5527), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [185192] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9341), 1,
      sym_html_character_reference,
    ACTIONS(9343), 1,
      anon_sym_SQUOTE,
    ACTIONS(9345), 1,
      sym_unescaped_single_jsx_string_fragment,
    STATE(5524), 1,
      sym_comment,
    STATE(5561), 1,
      aux_sym__jsx_string_repeat2,
  [185214] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9343), 1,
      anon_sym_DQUOTE,
    ACTIONS(9347), 1,
      sym_html_character_reference,
    ACTIONS(9349), 1,
      sym_unescaped_double_jsx_string_fragment,
    STATE(5525), 1,
      sym_comment,
    STATE(5564), 1,
      aux_sym__jsx_string_repeat1,
  [185236] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5526), 1,
      sym_comment,
    STATE(6363), 1,
      sym_import_attribute,
    ACTIONS(9351), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185256] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9353), 1,
      anon_sym_DQUOTE,
    STATE(5527), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [185276] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9355), 1,
      anon_sym_RBRACK,
    STATE(5528), 1,
      sym_comment,
  [185298] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5529), 1,
      sym_comment,
    STATE(6414), 1,
      sym__from_clause,
    ACTIONS(5898), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185318] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9357), 1,
      anon_sym_RBRACK,
    STATE(5530), 1,
      sym_comment,
  [185340] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9353), 1,
      anon_sym_SQUOTE,
    STATE(5531), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [185360] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8065), 1,
      anon_sym_COMMA,
    ACTIONS(8567), 1,
      anon_sym_LBRACE,
    ACTIONS(8569), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5424), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(5532), 1,
      sym_comment,
  [185382] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9359), 1,
      anon_sym_SQUOTE,
    STATE(5533), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [185402] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9361), 1,
      anon_sym_LBRACE,
    ACTIONS(9363), 1,
      anon_sym_COMMA,
    ACTIONS(9366), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5534), 2,
      sym_comment,
      aux_sym_extends_type_clause_repeat1,
  [185422] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9359), 1,
      anon_sym_DQUOTE,
    STATE(5535), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [185442] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9368), 1,
      anon_sym_QMARK,
    STATE(5536), 1,
      sym_comment,
  [185464] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9370), 1,
      anon_sym_DQUOTE,
    STATE(5537), 1,
      sym_comment,
    STATE(5539), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [185484] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9370), 1,
      anon_sym_SQUOTE,
    STATE(5538), 1,
      sym_comment,
    STATE(5543), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [185504] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9372), 1,
      anon_sym_DQUOTE,
    STATE(5539), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [185524] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5512), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5540), 1,
      sym_comment,
    ACTIONS(9374), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185544] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5513), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5541), 1,
      sym_comment,
    ACTIONS(9376), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185564] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5542), 1,
      sym_comment,
    STATE(6913), 1,
      sym_import_attribute,
    ACTIONS(9378), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185584] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9372), 1,
      anon_sym_SQUOTE,
    STATE(5543), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [185604] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    ACTIONS(4865), 1,
      anon_sym_BQUOTE,
    STATE(5544), 1,
      sym_comment,
    STATE(2458), 2,
      sym_template_string,
      sym_arguments,
  [185624] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5545), 1,
      sym_comment,
    STATE(6911), 1,
      sym_import_attribute,
    ACTIONS(9380), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185644] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5546), 1,
      sym_comment,
    ACTIONS(9382), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [185660] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5547), 1,
      sym_comment,
    STATE(6373), 1,
      sym__from_clause,
    ACTIONS(9384), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185680] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7937), 1,
      anon_sym_const,
    ACTIONS(9216), 1,
      sym_identifier,
    ACTIONS(9386), 1,
      anon_sym_GT,
    STATE(5548), 1,
      sym_comment,
    STATE(6618), 1,
      sym_type_parameter,
  [185702] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5549), 1,
      sym_comment,
    STATE(6897), 1,
      sym__from_clause,
    ACTIONS(9388), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185722] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5550), 1,
      sym_comment,
    STATE(6826), 1,
      sym__from_clause,
    ACTIONS(5666), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185742] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5551), 1,
      sym_comment,
    ACTIONS(9390), 4,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
  [185758] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5552), 1,
      sym_comment,
    ACTIONS(8171), 4,
      anon_sym_export,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [185774] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8105), 1,
      anon_sym_EQ,
    STATE(5553), 1,
      sym_comment,
    STATE(6749), 1,
      sym_default_type,
    ACTIONS(9392), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [185794] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5554), 1,
      sym_comment,
    STATE(6712), 1,
      sym_type_parameters,
    STATE(7192), 1,
      sym_formal_parameters,
  [185816] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    STATE(5555), 1,
      sym_comment,
    STATE(6795), 1,
      sym__initializer,
    ACTIONS(9394), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [185836] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9396), 1,
      anon_sym_RPAREN,
    STATE(5556), 1,
      sym_comment,
  [185858] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(9398), 1,
      anon_sym_class,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5557), 1,
      sym_comment,
  [185880] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(6978), 1,
      anon_sym_LT,
    STATE(3666), 1,
      sym_arguments,
    STATE(3713), 1,
      sym_type_arguments,
    STATE(5558), 1,
      sym_comment,
  [185902] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9400), 1,
      anon_sym_SQUOTE,
    STATE(5559), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [185922] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9400), 1,
      anon_sym_DQUOTE,
    STATE(5560), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [185942] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9341), 1,
      sym_html_character_reference,
    ACTIONS(9345), 1,
      sym_unescaped_single_jsx_string_fragment,
    ACTIONS(9402), 1,
      anon_sym_SQUOTE,
    STATE(5561), 1,
      sym_comment,
    STATE(5581), 1,
      aux_sym__jsx_string_repeat2,
  [185964] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8272), 1,
      anon_sym_finally,
    STATE(5562), 1,
      sym_comment,
    STATE(6508), 1,
      sym_finally_clause,
    ACTIONS(3120), 2,
      anon_sym_else,
      anon_sym_while,
  [185984] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(2698), 1,
      anon_sym_AT,
    ACTIONS(9404), 1,
      anon_sym_export,
    STATE(4771), 1,
      aux_sym_export_statement_repeat1,
    STATE(5410), 1,
      sym_decorator,
    STATE(5563), 1,
      sym_comment,
  [186006] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9347), 1,
      sym_html_character_reference,
    ACTIONS(9349), 1,
      sym_unescaped_double_jsx_string_fragment,
    ACTIONS(9402), 1,
      anon_sym_DQUOTE,
    STATE(5564), 1,
      sym_comment,
    STATE(5577), 1,
      aux_sym__jsx_string_repeat1,
  [186028] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9406), 1,
      anon_sym_SQUOTE,
    STATE(5533), 1,
      aux_sym_string_repeat2,
    STATE(5565), 1,
      sym_comment,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [186048] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9202), 1,
      anon_sym_EQ,
    ACTIONS(9204), 1,
      anon_sym_COMMA,
    ACTIONS(9408), 1,
      anon_sym_RBRACK,
    STATE(5566), 1,
      sym_comment,
    STATE(6208), 1,
      aux_sym_array_pattern_repeat1,
  [186070] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9406), 1,
      anon_sym_DQUOTE,
    STATE(5535), 1,
      aux_sym_string_repeat1,
    STATE(5567), 1,
      sym_comment,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [186090] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9410), 1,
      anon_sym_SQUOTE,
    STATE(5452), 1,
      aux_sym_string_repeat2,
    STATE(5568), 1,
      sym_comment,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [186110] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5569), 1,
      sym_comment,
    STATE(6365), 1,
      sym_import_attribute,
    ACTIONS(9412), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186130] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9339), 1,
      anon_sym_SQUOTE,
    STATE(5531), 1,
      aux_sym_string_repeat2,
    STATE(5570), 1,
      sym_comment,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [186150] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5571), 1,
      sym_comment,
    STATE(5633), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9414), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186170] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5572), 1,
      sym_comment,
    STATE(5634), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9416), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186190] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9420), 1,
      anon_sym_COMMA,
    STATE(5447), 1,
      aux_sym_extends_clause_repeat1,
    STATE(5573), 1,
      sym_comment,
    ACTIONS(9418), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [186210] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9422), 1,
      anon_sym_COLON,
    STATE(5574), 1,
      sym_comment,
  [186232] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5502), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5575), 1,
      sym_comment,
    ACTIONS(9424), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186252] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5503), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5576), 1,
      sym_comment,
    ACTIONS(9426), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186272] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9428), 1,
      sym_html_character_reference,
    ACTIONS(9431), 1,
      anon_sym_DQUOTE,
    ACTIONS(9433), 1,
      sym_unescaped_double_jsx_string_fragment,
    STATE(5577), 2,
      sym_comment,
      aux_sym__jsx_string_repeat1,
  [186292] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5578), 1,
      sym_comment,
    STATE(6568), 1,
      sym_import_attribute,
    ACTIONS(9436), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186312] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5579), 1,
      sym_comment,
    STATE(6569), 1,
      sym_import_attribute,
    ACTIONS(9438), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186332] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9440), 1,
      anon_sym_COLON,
    STATE(5580), 1,
      sym_comment,
  [186354] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9442), 1,
      sym_html_character_reference,
    ACTIONS(9445), 1,
      anon_sym_SQUOTE,
    ACTIONS(9447), 1,
      sym_unescaped_single_jsx_string_fragment,
    STATE(5581), 2,
      sym_comment,
      aux_sym__jsx_string_repeat2,
  [186374] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    STATE(5582), 1,
      sym_comment,
    STATE(6400), 1,
      sym__initializer,
    ACTIONS(9450), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [186394] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9410), 1,
      anon_sym_DQUOTE,
    STATE(5450), 1,
      aux_sym_string_repeat1,
    STATE(5583), 1,
      sym_comment,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [186414] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5584), 1,
      sym_comment,
    STATE(6756), 1,
      sym_type_parameters,
    STATE(7416), 1,
      sym_formal_parameters,
  [186436] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9452), 1,
      anon_sym_RBRACK,
    STATE(5585), 1,
      sym_comment,
  [186458] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9454), 1,
      anon_sym_DQUOTE,
    STATE(5586), 1,
      sym_comment,
    STATE(5625), 1,
      aux_sym_string_repeat1,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [186478] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9454), 1,
      anon_sym_SQUOTE,
    STATE(5587), 1,
      sym_comment,
    STATE(5614), 1,
      aux_sym_string_repeat2,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [186498] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9456), 1,
      anon_sym_RBRACK,
    STATE(5588), 1,
      sym_comment,
  [186520] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9458), 1,
      anon_sym_RBRACK,
    STATE(5589), 1,
      sym_comment,
  [186542] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9460), 1,
      anon_sym_RBRACK,
    STATE(5590), 1,
      sym_comment,
  [186564] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5498), 1,
      anon_sym_COMMA,
    STATE(5591), 1,
      sym_comment,
    STATE(5609), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(8291), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186584] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9462), 1,
      anon_sym_QMARK,
    STATE(5592), 1,
      sym_comment,
  [186606] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5593), 1,
      sym_comment,
    STATE(6594), 1,
      sym__from_clause,
    ACTIONS(9464), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186626] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5594), 1,
      sym_comment,
    STATE(6776), 1,
      sym_type_parameters,
    STATE(7408), 1,
      sym_formal_parameters,
  [186648] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9466), 1,
      anon_sym_EQ_GT,
    STATE(5595), 1,
      sym_comment,
    ACTIONS(4518), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [186666] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9284), 1,
      sym__glimmer_template_content,
    ACTIONS(9468), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(2558), 1,
      sym_glimmer_closing_tag,
    STATE(5596), 1,
      sym_comment,
    STATE(6069), 1,
      aux_sym_glimmer_template_repeat1,
  [186688] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9470), 1,
      anon_sym_EQ_GT,
    STATE(5597), 1,
      sym_comment,
    ACTIONS(4518), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [186706] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9472), 1,
      anon_sym_COMMA,
    ACTIONS(9475), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(5598), 2,
      sym_comment,
      aux_sym_variable_declaration_repeat1,
  [186724] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9284), 1,
      sym__glimmer_template_content,
    ACTIONS(9468), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(2497), 1,
      sym_glimmer_closing_tag,
    STATE(5596), 1,
      aux_sym_glimmer_template_repeat1,
    STATE(5599), 1,
      sym_comment,
  [186746] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5600), 1,
      sym_comment,
    STATE(6772), 1,
      sym_type_parameters,
    STATE(7316), 1,
      sym_formal_parameters,
  [186768] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9477), 1,
      anon_sym_SQUOTE,
    STATE(5559), 1,
      aux_sym_string_repeat2,
    STATE(5601), 1,
      sym_comment,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [186788] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    ACTIONS(9479), 1,
      anon_sym_RPAREN,
    STATE(5602), 1,
      sym_comment,
  [186810] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4159), 1,
      anon_sym_LPAREN,
    ACTIONS(7055), 1,
      anon_sym_LT,
    STATE(3879), 1,
      sym_arguments,
    STATE(4025), 1,
      sym_type_arguments,
    STATE(5603), 1,
      sym_comment,
  [186832] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9477), 1,
      anon_sym_DQUOTE,
    STATE(5560), 1,
      aux_sym_string_repeat1,
    STATE(5604), 1,
      sym_comment,
    ACTIONS(9113), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [186852] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    ACTIONS(9481), 1,
      anon_sym_SEMI,
    ACTIONS(9483), 1,
      sym__automatic_semicolon,
    STATE(5605), 1,
      sym_comment,
    STATE(6484), 1,
      sym_import_attribute,
  [186874] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5606), 1,
      sym_comment,
    STATE(6781), 1,
      sym_type_parameters,
    STATE(7350), 1,
      sym_formal_parameters,
  [186896] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    ACTIONS(9485), 1,
      anon_sym_SEMI,
    ACTIONS(9487), 1,
      sym__automatic_semicolon,
    STATE(5607), 1,
      sym_comment,
    STATE(6556), 1,
      sym_import_attribute,
  [186918] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4518), 1,
      anon_sym_COLON,
    ACTIONS(7219), 1,
      anon_sym_EQ,
    STATE(5608), 1,
      sym_comment,
    ACTIONS(9489), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [186938] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9491), 1,
      anon_sym_COMMA,
    ACTIONS(5214), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(5609), 2,
      sym_comment,
      aux_sym_sequence_expression_repeat1,
  [186956] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8095), 1,
      anon_sym_DOT,
    ACTIONS(9494), 1,
      anon_sym_COMMA,
    ACTIONS(9496), 1,
      anon_sym_GT,
    STATE(5610), 1,
      sym_comment,
    STATE(6197), 1,
      aux_sym_type_arguments_repeat1,
  [186978] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9498), 1,
      sym_identifier,
    STATE(4781), 1,
      sym_nested_type_identifier,
    STATE(5532), 1,
      sym_generic_type,
    STATE(5611), 1,
      sym_comment,
    STATE(7112), 1,
      sym_nested_identifier,
  [187000] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5612), 1,
      sym_comment,
    ACTIONS(9500), 4,
      anon_sym_export,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [187016] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5613), 1,
      sym_comment,
    ACTIONS(3084), 4,
      sym__automatic_semicolon,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
  [187032] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9502), 1,
      anon_sym_SQUOTE,
    ACTIONS(9504), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
    STATE(5614), 2,
      sym_comment,
      aux_sym_string_repeat2,
  [187050] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7937), 1,
      anon_sym_const,
    ACTIONS(9216), 1,
      sym_identifier,
    ACTIONS(9507), 1,
      anon_sym_GT,
    STATE(5615), 1,
      sym_comment,
    STATE(6618), 1,
      sym_type_parameter,
  [187072] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(5616), 1,
      sym_comment,
    STATE(6339), 1,
      sym_statement_block,
    ACTIONS(2061), 2,
      anon_sym_else,
      anon_sym_while,
  [187092] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8105), 1,
      anon_sym_EQ,
    STATE(5617), 1,
      sym_comment,
    STATE(6625), 1,
      sym_default_type,
    ACTIONS(9509), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [187112] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5618), 1,
      sym_comment,
    STATE(6937), 1,
      sym_type_parameters,
    STATE(7371), 1,
      sym_formal_parameters,
  [187134] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5619), 1,
      sym_comment,
    STATE(6406), 1,
      sym__from_clause,
    ACTIONS(5851), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187154] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5620), 1,
      sym_comment,
    STATE(6942), 1,
      sym_type_parameters,
    STATE(7290), 1,
      sym_formal_parameters,
  [187176] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5621), 1,
      sym_comment,
    STATE(6660), 1,
      sym_type_parameters,
    STATE(6991), 1,
      sym_formal_parameters,
  [187198] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9420), 1,
      anon_sym_COMMA,
    STATE(5573), 1,
      aux_sym_extends_clause_repeat1,
    STATE(5622), 1,
      sym_comment,
    ACTIONS(9511), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [187218] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5623), 1,
      sym_comment,
    ACTIONS(6748), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187234] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8095), 1,
      anon_sym_DOT,
    ACTIONS(9513), 1,
      anon_sym_COMMA,
    ACTIONS(9515), 1,
      anon_sym_GT,
    STATE(5624), 1,
      sym_comment,
    STATE(5730), 1,
      aux_sym_type_arguments_repeat1,
  [187256] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9517), 1,
      anon_sym_DQUOTE,
    ACTIONS(9519), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
    STATE(5625), 2,
      sym_comment,
      aux_sym_string_repeat1,
  [187274] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9522), 1,
      anon_sym_COMMA,
    ACTIONS(5906), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(5626), 2,
      sym_comment,
      aux_sym_array_repeat1,
  [187292] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8181), 1,
      anon_sym_EQ,
    STATE(5627), 1,
      sym_comment,
    STATE(6713), 1,
      sym__initializer,
    ACTIONS(9525), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [187312] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5628), 1,
      sym_comment,
    STATE(6435), 1,
      sym_import_attribute,
    ACTIONS(9527), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187332] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9111), 1,
      anon_sym_SQUOTE,
    STATE(5587), 1,
      aux_sym_string_repeat2,
    STATE(5629), 1,
      sym_comment,
    ACTIONS(9143), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [187352] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    ACTIONS(9529), 1,
      anon_sym_SEMI,
    ACTIONS(9531), 1,
      sym__automatic_semicolon,
    STATE(5630), 1,
      sym_comment,
    STATE(6440), 1,
      sym_import_attribute,
  [187374] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5631), 1,
      sym_comment,
    ACTIONS(9533), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187394] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5632), 1,
      sym_comment,
    ACTIONS(9535), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187414] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5633), 1,
      sym_comment,
    ACTIONS(9537), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187434] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9131), 1,
      anon_sym_COMMA,
    STATE(5598), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5634), 1,
      sym_comment,
    ACTIONS(9539), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187454] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9541), 1,
      anon_sym_STAR,
    ACTIONS(9543), 1,
      anon_sym_LBRACE,
    STATE(5635), 1,
      sym_comment,
    STATE(7149), 2,
      sym_namespace_import,
      sym_named_imports,
  [187474] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    ACTIONS(9545), 1,
      anon_sym_SEMI,
    ACTIONS(9547), 1,
      sym__automatic_semicolon,
    STATE(5636), 1,
      sym_comment,
    STATE(6760), 1,
      sym_import_attribute,
  [187496] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5637), 1,
      sym_comment,
    STATE(6863), 1,
      sym_type_parameters,
    STATE(7020), 1,
      sym_formal_parameters,
  [187518] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5638), 1,
      sym_comment,
    STATE(6857), 1,
      sym_type_parameters,
    STATE(7053), 1,
      sym_formal_parameters,
  [187540] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5639), 1,
      sym_comment,
    STATE(6782), 1,
      sym_import_attribute,
    ACTIONS(9549), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187560] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9115), 1,
      anon_sym_with,
    STATE(5640), 1,
      sym_comment,
    STATE(6783), 1,
      sym_import_attribute,
    ACTIONS(9551), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187580] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7969), 1,
      anon_sym_DOT,
    STATE(5641), 1,
      sym_comment,
    ACTIONS(9553), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187597] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9555), 1,
      sym_identifier,
    ACTIONS(9557), 1,
      anon_sym_LBRACE,
    STATE(5520), 1,
      sym_export_clause,
    STATE(5642), 1,
      sym_comment,
  [187616] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9559), 1,
      anon_sym_COMMA,
    ACTIONS(9561), 1,
      anon_sym_RPAREN,
    STATE(5643), 1,
      sym_comment,
    STATE(6142), 1,
      aux_sym_formal_parameters_repeat1,
  [187635] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5644), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187650] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5645), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187665] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5646), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187680] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5647), 1,
      sym_comment,
    ACTIONS(9567), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187695] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9569), 1,
      anon_sym_LBRACE,
    ACTIONS(9571), 1,
      anon_sym_LPAREN,
    STATE(1045), 1,
      sym_statement_block,
    STATE(5648), 1,
      sym_comment,
  [187714] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5649), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187729] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5650), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187744] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9575), 1,
      anon_sym_LPAREN,
    ACTIONS(9577), 1,
      anon_sym_await,
    STATE(78), 1,
      sym__for_header,
    STATE(5651), 1,
      sym_comment,
  [187763] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9579), 1,
      sym_identifier,
    ACTIONS(9581), 1,
      anon_sym_SEMI,
    ACTIONS(9583), 1,
      sym__automatic_semicolon,
    STATE(5652), 1,
      sym_comment,
  [187782] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5653), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187797] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9587), 1,
      sym_identifier,
    ACTIONS(9589), 1,
      anon_sym_SEMI,
    ACTIONS(9591), 1,
      sym__automatic_semicolon,
    STATE(5654), 1,
      sym_comment,
  [187816] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5655), 1,
      sym_comment,
    ACTIONS(9567), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187831] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5656), 1,
      sym_comment,
    ACTIONS(9567), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187846] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5657), 1,
      sym_comment,
    ACTIONS(9567), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187861] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5658), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187876] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5659), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187891] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(9593), 1,
      anon_sym_EQ,
    STATE(5660), 1,
      sym_comment,
    STATE(7447), 1,
      sym_type_parameters,
  [187910] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5661), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187925] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5662), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187940] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8011), 1,
      anon_sym_LBRACE,
    ACTIONS(8013), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1277), 1,
      sym_object_type,
    STATE(5663), 1,
      sym_comment,
  [187959] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5664), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187974] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5665), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187989] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(9595), 1,
      anon_sym_RBRACE,
    STATE(5666), 1,
      sym_comment,
    STATE(5895), 1,
      aux_sym_object_repeat1,
  [188008] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5855), 1,
      anon_sym_RPAREN,
    STATE(5667), 1,
      sym_comment,
    STATE(5723), 1,
      aux_sym_array_repeat1,
  [188027] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5855), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(5668), 1,
      sym_comment,
  [188046] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7075), 1,
      anon_sym_LPAREN,
    ACTIONS(9597), 1,
      anon_sym_DOT,
    STATE(4666), 1,
      sym_arguments,
    STATE(5669), 1,
      sym_comment,
  [188065] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(9599), 1,
      anon_sym_RBRACE,
    STATE(5670), 1,
      sym_comment,
    STATE(5895), 1,
      aux_sym_object_repeat1,
  [188084] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5671), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188099] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5672), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188114] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5673), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188129] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5674), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188144] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5675), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188159] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5676), 1,
      sym_comment,
    ACTIONS(9603), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188174] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9605), 1,
      anon_sym_EQ,
    STATE(5677), 1,
      sym_comment,
    ACTIONS(9607), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [188191] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(9609), 1,
      anon_sym_EQ,
    STATE(5678), 1,
      sym_comment,
    STATE(7425), 1,
      sym_type_parameters,
  [188210] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5679), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188225] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8828), 1,
      anon_sym_DOT,
    ACTIONS(9611), 1,
      anon_sym_COLON,
    ACTIONS(9613), 1,
      anon_sym_GT,
    STATE(5680), 1,
      sym_comment,
  [188244] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5681), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188259] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5682), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188274] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5683), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188289] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5684), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188304] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5685), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188319] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5686), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188334] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5687), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188349] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5688), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188364] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5689), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188379] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5690), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188394] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5691), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188409] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9615), 1,
      sym_identifier,
    STATE(4566), 1,
      sym_decorator_member_expression,
    STATE(5552), 1,
      sym_decorator_call_expression,
    STATE(5692), 1,
      sym_comment,
  [188428] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9617), 1,
      anon_sym_EQ,
    STATE(5693), 1,
      sym_comment,
    ACTIONS(9607), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [188445] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(9619), 1,
      anon_sym_EQ,
    STATE(5694), 1,
      sym_comment,
    STATE(7397), 1,
      sym_type_parameters,
  [188464] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7967), 1,
      anon_sym_DOT,
    STATE(5695), 1,
      sym_comment,
    ACTIONS(9621), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [188481] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7969), 1,
      anon_sym_DOT,
    STATE(5696), 1,
      sym_comment,
    ACTIONS(9621), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [188498] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5697), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188513] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5698), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188528] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5699), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188543] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5700), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188558] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5701), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188573] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5702), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188588] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5703), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188603] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5704), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188618] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5705), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188633] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9623), 1,
      anon_sym_COMMA,
    ACTIONS(9625), 1,
      anon_sym_RBRACK,
    STATE(5706), 1,
      sym_comment,
    STATE(5761), 1,
      aux_sym_tuple_type_repeat1,
  [188652] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5707), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188667] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5708), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188682] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5709), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188697] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7433), 1,
      anon_sym_AMP,
    ACTIONS(7437), 1,
      anon_sym_extends,
    ACTIONS(8790), 1,
      anon_sym_PIPE,
    STATE(5710), 1,
      sym_comment,
  [188716] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5711), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188731] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5712), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188746] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5713), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188761] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9627), 1,
      anon_sym_EQ,
    STATE(5714), 1,
      sym_comment,
    ACTIONS(4287), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [188778] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9630), 1,
      anon_sym_EQ,
    STATE(5715), 1,
      sym_comment,
    ACTIONS(9607), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [188795] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(9632), 1,
      anon_sym_EQ,
    STATE(5716), 1,
      sym_comment,
    STATE(7363), 1,
      sym_type_parameters,
  [188814] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5717), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188829] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5718), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188844] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5719), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188859] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8011), 1,
      anon_sym_LBRACE,
    ACTIONS(8013), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1314), 1,
      sym_object_type,
    STATE(5720), 1,
      sym_comment,
  [188878] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5721), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188893] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9634), 1,
      anon_sym_COMMA,
    ACTIONS(9636), 1,
      anon_sym_RBRACE,
    STATE(5722), 1,
      sym_comment,
    STATE(5770), 1,
      aux_sym_enum_body_repeat1,
  [188912] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(9638), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(5723), 1,
      sym_comment,
  [188931] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    ACTIONS(9640), 1,
      anon_sym_as,
    STATE(5724), 1,
      sym_comment,
    STATE(6694), 1,
      sym__from_clause,
  [188950] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5725), 1,
      sym_comment,
    ACTIONS(9603), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188965] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9557), 1,
      anon_sym_LBRACE,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(5550), 1,
      sym_export_clause,
    STATE(5726), 1,
      sym_comment,
  [188984] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9644), 1,
      anon_sym_COMMA,
    ACTIONS(9646), 1,
      anon_sym_GT,
    STATE(5727), 1,
      sym_comment,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
  [189003] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5728), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189018] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5729), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189033] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9648), 1,
      anon_sym_COMMA,
    ACTIONS(9650), 1,
      anon_sym_GT,
    STATE(5730), 1,
      sym_comment,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
  [189052] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5731), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189067] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9652), 1,
      anon_sym_COMMA,
    ACTIONS(9654), 1,
      anon_sym_GT,
    STATE(5732), 1,
      sym_comment,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
  [189086] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5733), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189101] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5734), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189116] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5735), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189131] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5736), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189146] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(9656), 1,
      anon_sym_EQ,
    STATE(5737), 1,
      sym_comment,
    STATE(7142), 1,
      sym_type_parameters,
  [189165] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5738), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189180] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8741), 1,
      anon_sym_COMMA,
    ACTIONS(9658), 1,
      anon_sym_RBRACE,
    STATE(5739), 1,
      sym_comment,
    STATE(5885), 1,
      aux_sym_object_pattern_repeat1,
  [189199] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(9660), 1,
      anon_sym_RBRACE,
    STATE(5740), 1,
      sym_comment,
    STATE(5890), 1,
      aux_sym_object_repeat1,
  [189218] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5741), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189233] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5742), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189248] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8741), 1,
      anon_sym_COMMA,
    ACTIONS(9658), 1,
      anon_sym_RBRACE,
    STATE(5743), 1,
      sym_comment,
    STATE(5897), 1,
      aux_sym_object_pattern_repeat1,
  [189267] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5744), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189282] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5745), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189297] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5746), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189312] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5747), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189327] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9662), 1,
      anon_sym_EQ,
    STATE(5748), 1,
      sym_comment,
    ACTIONS(9607), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [189344] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5749), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189359] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5750), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189374] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5751), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189389] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5752), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189404] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9664), 1,
      sym_identifier,
    ACTIONS(9666), 1,
      anon_sym_LBRACK,
    ACTIONS(9668), 1,
      sym_private_property_identifier,
    STATE(5753), 1,
      sym_comment,
  [189423] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5754), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189438] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9670), 1,
      sym_identifier,
    ACTIONS(9672), 1,
      anon_sym_LBRACK,
    ACTIONS(9674), 1,
      sym_private_property_identifier,
    STATE(5755), 1,
      sym_comment,
  [189457] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5756), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189472] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9676), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LBRACK,
    ACTIONS(9680), 1,
      sym_private_property_identifier,
    STATE(5757), 1,
      sym_comment,
  [189491] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5758), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189506] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9682), 1,
      sym_identifier,
    ACTIONS(9684), 1,
      anon_sym_LBRACK,
    ACTIONS(9686), 1,
      sym_private_property_identifier,
    STATE(5759), 1,
      sym_comment,
  [189525] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5760), 1,
      sym_comment,
    ACTIONS(9688), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189540] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9690), 1,
      anon_sym_COMMA,
    ACTIONS(9692), 1,
      anon_sym_RBRACK,
    STATE(5761), 1,
      sym_comment,
    STATE(5819), 1,
      aux_sym_tuple_type_repeat1,
  [189559] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5762), 1,
      sym_comment,
    ACTIONS(8157), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [189574] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9694), 1,
      anon_sym_COMMA,
    ACTIONS(9696), 1,
      anon_sym_RPAREN,
    STATE(5763), 1,
      sym_comment,
    STATE(5953), 1,
      aux_sym_formal_parameters_repeat1,
  [189593] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5764), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189608] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5765), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189623] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5766), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189638] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5767), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189653] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9698), 1,
      anon_sym_COMMA,
    ACTIONS(9700), 1,
      anon_sym_RBRACE,
    STATE(5768), 1,
      sym_comment,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
  [189672] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5769), 1,
      sym_comment,
    ACTIONS(9702), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189687] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9704), 1,
      anon_sym_COMMA,
    ACTIONS(9706), 1,
      anon_sym_RBRACE,
    STATE(5770), 1,
      sym_comment,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
  [189706] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5771), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189721] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5772), 1,
      sym_comment,
    ACTIONS(9702), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189736] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9204), 1,
      anon_sym_COMMA,
    ACTIONS(9206), 1,
      anon_sym_RBRACK,
    STATE(5773), 1,
      sym_comment,
    STATE(5972), 1,
      aux_sym_array_pattern_repeat1,
  [189755] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5939), 1,
      anon_sym_RBRACK,
    STATE(5774), 1,
      sym_comment,
    STATE(5970), 1,
      aux_sym_array_repeat1,
  [189774] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5775), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189789] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5939), 1,
      anon_sym_RBRACK,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(5776), 1,
      sym_comment,
  [189808] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9204), 1,
      anon_sym_COMMA,
    ACTIONS(9206), 1,
      anon_sym_RBRACK,
    STATE(5777), 1,
      sym_comment,
    STATE(5974), 1,
      aux_sym_array_pattern_repeat1,
  [189827] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9708), 1,
      anon_sym_DQUOTE,
    STATE(5778), 1,
      sym_comment,
    ACTIONS(9710), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [189844] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5779), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189859] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5780), 1,
      sym_comment,
    ACTIONS(9603), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189874] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9712), 1,
      anon_sym_SQUOTE,
    STATE(5781), 1,
      sym_comment,
    ACTIONS(9714), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [189891] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5782), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189906] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7937), 1,
      anon_sym_const,
    ACTIONS(9216), 1,
      sym_identifier,
    STATE(5783), 1,
      sym_comment,
    STATE(5794), 1,
      sym_type_parameter,
  [189925] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5784), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189940] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7547), 1,
      anon_sym_implements,
    ACTIONS(9716), 1,
      anon_sym_LBRACE,
    STATE(5785), 1,
      sym_comment,
    STATE(7013), 1,
      sym_implements_clause,
  [189959] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5786), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189974] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5787), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189989] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5788), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190004] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5789), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190019] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5790), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190034] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5791), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190049] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(9660), 1,
      anon_sym_RBRACE,
    STATE(5792), 1,
      sym_comment,
    STATE(5895), 1,
      aux_sym_object_repeat1,
  [190068] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5793), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190083] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9718), 1,
      anon_sym_COMMA,
    ACTIONS(9720), 1,
      anon_sym_GT,
    STATE(5794), 1,
      sym_comment,
    STATE(6045), 1,
      aux_sym_type_parameters_repeat1,
  [190102] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5795), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190117] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5796), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190132] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5797), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190147] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5798), 1,
      sym_comment,
    ACTIONS(9722), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190162] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5799), 1,
      sym_comment,
    ACTIONS(9724), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190177] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5800), 1,
      sym_comment,
    ACTIONS(9726), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190192] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5801), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190207] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7991), 1,
      sym_identifier,
    STATE(5802), 1,
      sym_comment,
    ACTIONS(7995), 2,
      anon_sym_LBRACK,
      sym_private_property_identifier,
  [190224] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5803), 1,
      sym_comment,
    ACTIONS(9728), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190239] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9730), 1,
      sym_identifier,
    ACTIONS(9732), 1,
      anon_sym_LBRACK,
    ACTIONS(9734), 1,
      sym_private_property_identifier,
    STATE(5804), 1,
      sym_comment,
  [190258] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5805), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190273] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5806), 1,
      sym_comment,
    ACTIONS(9736), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190288] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5807), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190303] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5808), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190318] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5809), 1,
      sym_comment,
    ACTIONS(9573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190333] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9738), 1,
      anon_sym_EQ,
    STATE(5810), 1,
      sym_comment,
    ACTIONS(9607), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [190350] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7173), 1,
      anon_sym_LT,
    ACTIONS(9740), 1,
      anon_sym_EQ,
    STATE(5811), 1,
      sym_comment,
    STATE(7223), 1,
      sym_type_parameters,
  [190369] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5812), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190384] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5813), 1,
      sym_comment,
    ACTIONS(9603), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190399] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5814), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190414] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5815), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190429] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9744), 1,
      anon_sym_COMMA,
    ACTIONS(9746), 1,
      anon_sym_RPAREN,
    STATE(5643), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(5816), 1,
      sym_comment,
  [190448] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5817), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190463] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9748), 1,
      anon_sym_DQUOTE,
    ACTIONS(9750), 1,
      anon_sym_SQUOTE,
    STATE(5818), 1,
      sym_comment,
    STATE(6080), 1,
      sym_string,
  [190482] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9755), 1,
      anon_sym_RBRACK,
    STATE(5819), 2,
      sym_comment,
      aux_sym_tuple_type_repeat1,
  [190499] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5820), 1,
      sym_comment,
    ACTIONS(9603), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190514] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5821), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190529] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3206), 1,
      anon_sym_while,
    ACTIONS(9759), 1,
      anon_sym_else,
    STATE(5822), 1,
      sym_comment,
    STATE(6570), 1,
      sym_else_clause,
  [190548] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5823), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190563] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8161), 1,
      anon_sym_EQ,
    STATE(5824), 1,
      sym_comment,
    ACTIONS(4354), 2,
      anon_sym_in,
      anon_sym_of,
  [190580] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5825), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190595] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5826), 1,
      sym_comment,
    ACTIONS(9603), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190610] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5827), 1,
      sym_comment,
    ACTIONS(9761), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [190625] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5828), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190640] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9765), 1,
      anon_sym_COMMA,
    ACTIONS(9767), 1,
      anon_sym_RBRACE,
    STATE(5829), 1,
      sym_comment,
    STATE(6084), 1,
      aux_sym_export_clause_repeat1,
  [190659] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5830), 1,
      sym_comment,
    ACTIONS(9769), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190674] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5831), 1,
      sym_comment,
    ACTIONS(9771), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190689] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9773), 1,
      anon_sym_as,
    STATE(5832), 1,
      sym_comment,
    ACTIONS(9775), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [190706] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5833), 1,
      sym_comment,
    ACTIONS(9777), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190721] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5834), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190736] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5835), 1,
      sym_comment,
    ACTIONS(9779), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [190751] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9781), 1,
      anon_sym_LPAREN,
    ACTIONS(9783), 1,
      anon_sym_await,
    STATE(107), 1,
      sym__for_header,
    STATE(5836), 1,
      sym_comment,
  [190770] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5837), 1,
      sym_comment,
    ACTIONS(9785), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190785] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5838), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190800] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5278), 1,
      anon_sym_LBRACE,
    STATE(5839), 1,
      sym_comment,
    ACTIONS(5280), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [190817] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9787), 1,
      sym_identifier,
    ACTIONS(9789), 1,
      anon_sym_SEMI,
    ACTIONS(9791), 1,
      sym__automatic_semicolon,
    STATE(5840), 1,
      sym_comment,
  [190836] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9793), 1,
      sym_identifier,
    ACTIONS(9795), 1,
      anon_sym_SEMI,
    ACTIONS(9797), 1,
      sym__automatic_semicolon,
    STATE(5841), 1,
      sym_comment,
  [190855] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5282), 1,
      anon_sym_LBRACE,
    STATE(5842), 1,
      sym_comment,
    ACTIONS(5284), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [190872] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5843), 1,
      sym_comment,
    ACTIONS(9799), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190887] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5844), 1,
      sym_comment,
    ACTIONS(9771), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190902] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5290), 1,
      anon_sym_LBRACE,
    STATE(5845), 1,
      sym_comment,
    ACTIONS(5292), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [190919] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9803), 1,
      sym_unescaped_double_jsx_string_fragment,
    STATE(5846), 1,
      sym_comment,
    ACTIONS(9801), 2,
      sym_html_character_reference,
      anon_sym_DQUOTE,
  [190936] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(9805), 1,
      anon_sym_RBRACE,
    STATE(5847), 1,
      sym_comment,
    STATE(5895), 1,
      aux_sym_object_repeat1,
  [190955] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(9805), 1,
      anon_sym_RBRACE,
    STATE(5666), 1,
      aux_sym_object_repeat1,
    STATE(5848), 1,
      sym_comment,
  [190974] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5849), 1,
      sym_comment,
    ACTIONS(9769), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190989] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5850), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191004] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5851), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191019] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5852), 1,
      sym_comment,
    ACTIONS(9807), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191034] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5853), 1,
      sym_comment,
    ACTIONS(9785), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191049] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9811), 1,
      sym_unescaped_single_jsx_string_fragment,
    STATE(5854), 1,
      sym_comment,
    ACTIONS(9809), 2,
      sym_html_character_reference,
      anon_sym_SQUOTE,
  [191066] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5855), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191081] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5856), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191096] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8840), 1,
      anon_sym_LBRACE,
    STATE(5857), 1,
      sym_comment,
    ACTIONS(8842), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [191113] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5106), 1,
      anon_sym_LBRACE,
    STATE(5858), 1,
      sym_comment,
    ACTIONS(5108), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [191130] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9557), 1,
      anon_sym_LBRACE,
    ACTIONS(9813), 1,
      sym_identifier,
    STATE(5464), 1,
      sym_export_clause,
    STATE(5859), 1,
      sym_comment,
  [191149] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5860), 1,
      sym_comment,
    ACTIONS(9785), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191164] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5861), 1,
      sym_comment,
    ACTIONS(9815), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191179] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    ACTIONS(9640), 1,
      anon_sym_as,
    STATE(5862), 1,
      sym_comment,
    STATE(6377), 1,
      sym__from_clause,
  [191198] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9817), 1,
      anon_sym_COMMA,
    ACTIONS(9820), 1,
      anon_sym_RBRACE,
    STATE(5863), 2,
      sym_comment,
      aux_sym_enum_body_repeat1,
  [191215] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5864), 1,
      sym_comment,
    ACTIONS(3200), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_finally,
  [191230] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5865), 1,
      sym_comment,
    ACTIONS(9769), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191245] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5106), 1,
      anon_sym_LBRACE,
    STATE(5866), 1,
      sym_comment,
    ACTIONS(5108), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [191262] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    STATE(5867), 1,
      sym_comment,
    ACTIONS(5156), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [191279] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(9822), 1,
      anon_sym_RBRACE,
    STATE(5868), 1,
      sym_comment,
    STATE(5895), 1,
      aux_sym_object_repeat1,
  [191298] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8741), 1,
      anon_sym_COMMA,
    ACTIONS(9824), 1,
      anon_sym_RBRACE,
    STATE(5869), 1,
      sym_comment,
    STATE(5897), 1,
      aux_sym_object_pattern_repeat1,
  [191317] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5154), 1,
      anon_sym_LBRACE,
    STATE(5870), 1,
      sym_comment,
    ACTIONS(5156), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [191334] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5210), 1,
      anon_sym_LBRACE,
    STATE(5871), 1,
      sym_comment,
    ACTIONS(5212), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [191351] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5872), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191366] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5357), 1,
      anon_sym_LBRACE,
    STATE(5873), 1,
      sym_comment,
    ACTIONS(5359), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [191383] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(9826), 1,
      anon_sym_RPAREN,
    STATE(5874), 1,
      sym_comment,
    STATE(7129), 1,
      sym_type_annotation,
  [191402] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5353), 1,
      anon_sym_LBRACE,
    STATE(5875), 1,
      sym_comment,
    ACTIONS(5355), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [191419] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5349), 1,
      anon_sym_LBRACE,
    STATE(5876), 1,
      sym_comment,
    ACTIONS(5351), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [191436] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5877), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191451] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5878), 1,
      sym_comment,
    ACTIONS(9565), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191466] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5879), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191481] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5880), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191496] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5881), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191511] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5882), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191526] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5883), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191541] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9830), 1,
      sym_identifier,
    ACTIONS(9832), 1,
      anon_sym_require,
    STATE(5884), 1,
      sym_comment,
    STATE(6285), 1,
      sym_nested_identifier,
  [191560] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8741), 1,
      anon_sym_COMMA,
    ACTIONS(9834), 1,
      anon_sym_RBRACE,
    STATE(5885), 1,
      sym_comment,
    STATE(5897), 1,
      aux_sym_object_pattern_repeat1,
  [191579] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5886), 1,
      sym_comment,
    ACTIONS(9836), 3,
      sym__automatic_semicolon,
      anon_sym_with,
      anon_sym_SEMI,
  [191594] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5887), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191609] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5888), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191624] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5889), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191639] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(9838), 1,
      anon_sym_RBRACE,
    STATE(5890), 1,
      sym_comment,
    STATE(5895), 1,
      aux_sym_object_repeat1,
  [191658] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5891), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191673] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5892), 1,
      sym_comment,
    ACTIONS(9724), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191688] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9840), 1,
      sym_identifier,
    STATE(3444), 1,
      sym_decorator_member_expression,
    STATE(3595), 1,
      sym_decorator_call_expression,
    STATE(5893), 1,
      sym_comment,
  [191707] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5894), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191722] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9842), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_RBRACE,
    STATE(5895), 2,
      sym_comment,
      aux_sym_object_repeat1,
  [191739] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5896), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191754] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9847), 1,
      anon_sym_COMMA,
    ACTIONS(9850), 1,
      anon_sym_RBRACE,
    STATE(5897), 2,
      sym_comment,
      aux_sym_object_pattern_repeat1,
  [191771] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9557), 1,
      anon_sym_LBRACE,
    ACTIONS(9852), 1,
      sym_identifier,
    STATE(5429), 1,
      sym_export_clause,
    STATE(5898), 1,
      sym_comment,
  [191790] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    ACTIONS(9640), 1,
      anon_sym_as,
    STATE(5899), 1,
      sym_comment,
    STATE(6627), 1,
      sym__from_clause,
  [191809] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5900), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191824] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9854), 1,
      anon_sym_LBRACE,
    STATE(5901), 1,
      sym_comment,
    ACTIONS(8767), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [191841] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5902), 1,
      sym_comment,
    ACTIONS(9585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191856] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5903), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191871] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5904), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191886] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5905), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191901] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5906), 1,
      sym_comment,
    ACTIONS(9856), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
  [191916] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9858), 1,
      anon_sym_EQ,
    STATE(5907), 1,
      sym_comment,
    ACTIONS(9607), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [191933] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5908), 1,
      sym_comment,
    ACTIONS(9860), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191948] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5909), 1,
      sym_comment,
    ACTIONS(9860), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191963] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5910), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191978] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5911), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191993] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5912), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192008] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(9862), 1,
      anon_sym_RPAREN,
    STATE(5913), 1,
      sym_comment,
    STATE(7063), 1,
      sym_type_annotation,
  [192027] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5914), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192042] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5915), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192057] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5916), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192072] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5917), 1,
      sym_comment,
    ACTIONS(9866), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192087] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9868), 1,
      sym_identifier,
    ACTIONS(9870), 1,
      anon_sym_SEMI,
    ACTIONS(9872), 1,
      sym__automatic_semicolon,
    STATE(5918), 1,
      sym_comment,
  [192106] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9874), 1,
      sym_identifier,
    ACTIONS(9876), 1,
      anon_sym_SEMI,
    ACTIONS(9878), 1,
      sym__automatic_semicolon,
    STATE(5919), 1,
      sym_comment,
  [192125] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5920), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192140] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9390), 1,
      anon_sym_as,
    STATE(5921), 1,
      sym_comment,
    ACTIONS(9607), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [192157] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9832), 1,
      anon_sym_require,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(5922), 1,
      sym_comment,
    STATE(6236), 1,
      sym_nested_identifier,
  [192176] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9882), 1,
      anon_sym_COMMA,
    ACTIONS(9884), 1,
      anon_sym_RBRACE,
    STATE(5923), 1,
      sym_comment,
    STATE(6116), 1,
      aux_sym_named_imports_repeat1,
  [192195] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5924), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192210] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9832), 1,
      anon_sym_require,
    ACTIONS(9886), 1,
      sym_identifier,
    STATE(5641), 1,
      sym_nested_identifier,
    STATE(5925), 1,
      sym_comment,
  [192229] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5926), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192244] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5927), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192259] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5928), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192274] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9888), 1,
      anon_sym_LPAREN,
    ACTIONS(9890), 1,
      anon_sym_await,
    STATE(112), 1,
      sym__for_header,
    STATE(5929), 1,
      sym_comment,
  [192293] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5930), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192308] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    ACTIONS(9640), 1,
      anon_sym_as,
    STATE(5931), 1,
      sym_comment,
    STATE(6853), 1,
      sym__from_clause,
  [192327] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5932), 1,
      sym_comment,
    ACTIONS(9892), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192342] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5933), 1,
      sym_comment,
    ACTIONS(9894), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192357] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5934), 1,
      sym_comment,
    ACTIONS(3186), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_finally,
  [192372] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9896), 1,
      anon_sym_LBRACE,
    ACTIONS(9898), 1,
      anon_sym_LPAREN,
    STATE(1142), 1,
      sym_statement_block,
    STATE(5935), 1,
      sym_comment,
  [192391] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6426), 1,
      sym__automatic_semicolon,
    STATE(5936), 1,
      sym_comment,
    ACTIONS(2313), 2,
      anon_sym_else,
      anon_sym_while,
  [192408] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5937), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192423] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6435), 1,
      sym__automatic_semicolon,
    STATE(5938), 1,
      sym_comment,
    ACTIONS(2287), 2,
      anon_sym_else,
      anon_sym_while,
  [192440] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5939), 1,
      sym_comment,
    ACTIONS(9900), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192455] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5940), 1,
      sym_comment,
    ACTIONS(9900), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192470] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5941), 1,
      sym_comment,
    ACTIONS(9902), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192485] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5942), 1,
      sym_comment,
    ACTIONS(8966), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192500] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5943), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192515] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5944), 1,
      sym_comment,
    ACTIONS(8966), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192530] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5945), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192545] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5946), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192560] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9904), 1,
      anon_sym_EQ,
    STATE(5947), 1,
      sym_comment,
    ACTIONS(4354), 2,
      anon_sym_in,
      anon_sym_of,
  [192577] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5948), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192592] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5949), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192607] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5950), 1,
      sym_comment,
    ACTIONS(9906), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192622] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5951), 1,
      sym_comment,
    ACTIONS(9906), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192637] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5952), 1,
      sym_comment,
    ACTIONS(8175), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [192652] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9908), 1,
      anon_sym_COMMA,
    ACTIONS(9910), 1,
      anon_sym_RPAREN,
    STATE(5953), 1,
      sym_comment,
    STATE(6142), 1,
      aux_sym_formal_parameters_repeat1,
  [192671] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5954), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192686] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5955), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192701] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1344), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4990), 1,
      sym_object_type,
    STATE(5956), 1,
      sym_comment,
  [192720] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5957), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192735] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5958), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192750] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9912), 1,
      anon_sym_LBRACE,
    ACTIONS(9914), 1,
      anon_sym_LPAREN,
    STATE(1205), 1,
      sym_statement_block,
    STATE(5959), 1,
      sym_comment,
  [192769] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5882), 1,
      anon_sym_RPAREN,
    STATE(5960), 1,
      sym_comment,
    STATE(6013), 1,
      aux_sym_array_repeat1,
  [192788] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5882), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(5961), 1,
      sym_comment,
  [192807] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5962), 1,
      sym_comment,
    ACTIONS(9916), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192822] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5963), 1,
      sym_comment,
    ACTIONS(9918), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192837] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5964), 1,
      sym_comment,
    ACTIONS(9916), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192852] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5965), 1,
      sym_comment,
    ACTIONS(9900), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192867] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5966), 1,
      sym_comment,
    ACTIONS(5906), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [192882] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5967), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192897] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9202), 1,
      anon_sym_EQ,
    STATE(5968), 1,
      sym_comment,
    ACTIONS(9920), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [192914] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6342), 1,
      sym__automatic_semicolon,
    STATE(5969), 1,
      sym_comment,
    ACTIONS(2271), 2,
      anon_sym_else,
      anon_sym_while,
  [192931] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(9922), 1,
      anon_sym_RBRACK,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(5970), 1,
      sym_comment,
  [192950] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8828), 1,
      anon_sym_DOT,
    ACTIONS(9611), 1,
      anon_sym_COLON,
    ACTIONS(9924), 1,
      anon_sym_GT,
    STATE(5971), 1,
      sym_comment,
  [192969] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9204), 1,
      anon_sym_COMMA,
    ACTIONS(9926), 1,
      anon_sym_RBRACK,
    STATE(5972), 1,
      sym_comment,
    STATE(5974), 1,
      aux_sym_array_pattern_repeat1,
  [192988] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5973), 1,
      sym_comment,
    ACTIONS(9928), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193003] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9920), 1,
      anon_sym_RBRACK,
    ACTIONS(9930), 1,
      anon_sym_COMMA,
    STATE(5974), 2,
      sym_comment,
      aux_sym_array_pattern_repeat1,
  [193020] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5975), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193035] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5976), 1,
      sym_comment,
    ACTIONS(6748), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193050] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5977), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193065] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5978), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193080] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5979), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193095] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5980), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193110] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5981), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193125] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5982), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193140] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5983), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193155] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5984), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193170] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(9935), 1,
      anon_sym_RPAREN,
    STATE(5985), 1,
      sym_comment,
    STATE(7018), 1,
      sym_type_annotation,
  [193189] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7967), 1,
      anon_sym_DOT,
    STATE(5986), 1,
      sym_comment,
    ACTIONS(9937), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [193206] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7969), 1,
      anon_sym_DOT,
    STATE(5987), 1,
      sym_comment,
    ACTIONS(9937), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [193223] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5988), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193238] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5989), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193253] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5990), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193268] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5991), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193283] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5992), 1,
      sym_comment,
    ACTIONS(9943), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193298] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5993), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193313] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5994), 1,
      sym_comment,
    ACTIONS(9945), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193328] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5995), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193343] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9949), 1,
      anon_sym_COMMA,
    ACTIONS(9951), 1,
      anon_sym_RBRACK,
    STATE(5996), 1,
      sym_comment,
    STATE(6044), 1,
      aux_sym_tuple_type_repeat1,
  [193362] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5997), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193377] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5998), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193392] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(5999), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193407] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4958), 1,
      anon_sym_extends,
    ACTIONS(9953), 1,
      anon_sym_AMP,
    ACTIONS(9955), 1,
      anon_sym_PIPE,
    STATE(6000), 1,
      sym_comment,
  [193426] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6001), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193441] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6002), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193456] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6003), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193471] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6004), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193486] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6005), 1,
      sym_comment,
    ACTIONS(9563), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193501] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9832), 1,
      anon_sym_require,
    ACTIONS(9957), 1,
      sym_identifier,
    STATE(5696), 1,
      sym_nested_identifier,
    STATE(6006), 1,
      sym_comment,
  [193520] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6007), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193535] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6008), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193550] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6009), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193565] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1344), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8033), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5263), 1,
      sym_object_type,
    STATE(6010), 1,
      sym_comment,
  [193584] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6011), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193599] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9959), 1,
      anon_sym_COMMA,
    ACTIONS(9961), 1,
      anon_sym_RBRACE,
    STATE(6012), 1,
      sym_comment,
    STATE(6053), 1,
      aux_sym_enum_body_repeat1,
  [193618] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(9963), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6013), 1,
      sym_comment,
  [193637] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6014), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193652] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9965), 1,
      anon_sym_COMMA,
    ACTIONS(9967), 1,
      anon_sym_GT,
    STATE(6015), 1,
      sym_comment,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
  [193671] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6016), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193686] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9969), 1,
      anon_sym_COMMA,
    ACTIONS(9971), 1,
      anon_sym_GT,
    STATE(6017), 1,
      sym_comment,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
  [193705] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6018), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193720] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9973), 1,
      anon_sym_COMMA,
    ACTIONS(9975), 1,
      anon_sym_GT,
    STATE(6019), 1,
      sym_comment,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
  [193739] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6020), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193754] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6021), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193769] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9557), 1,
      anon_sym_LBRACE,
    ACTIONS(9977), 1,
      sym_identifier,
    STATE(5619), 1,
      sym_export_clause,
    STATE(6022), 1,
      sym_comment,
  [193788] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6023), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [193803] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    ACTIONS(9640), 1,
      anon_sym_as,
    STATE(6024), 1,
      sym_comment,
    STATE(6422), 1,
      sym__from_clause,
  [193822] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6025), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193837] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6026), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193852] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6027), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193867] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6028), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193882] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6029), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193897] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6538), 1,
      sym__automatic_semicolon,
    STATE(6030), 1,
      sym_comment,
    ACTIONS(2373), 2,
      anon_sym_else,
      anon_sym_while,
  [193914] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6031), 1,
      sym_comment,
    ACTIONS(9945), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193929] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6032), 1,
      sym_comment,
    ACTIONS(9815), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193944] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6536), 1,
      sym__automatic_semicolon,
    STATE(6033), 1,
      sym_comment,
    ACTIONS(2381), 2,
      anon_sym_else,
      anon_sym_while,
  [193961] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6034), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193976] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6518), 1,
      sym__automatic_semicolon,
    STATE(6035), 1,
      sym_comment,
    ACTIONS(2357), 2,
      anon_sym_else,
      anon_sym_while,
  [193993] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6036), 1,
      sym_comment,
    ACTIONS(9860), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194008] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6037), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194023] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6038), 1,
      sym_comment,
    ACTIONS(9860), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194038] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6039), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194053] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6516), 1,
      sym__automatic_semicolon,
    STATE(6040), 1,
      sym_comment,
    ACTIONS(2365), 2,
      anon_sym_else,
      anon_sym_while,
  [194070] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6506), 1,
      sym__automatic_semicolon,
    STATE(6041), 1,
      sym_comment,
    ACTIONS(2343), 2,
      anon_sym_else,
      anon_sym_while,
  [194087] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6042), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194102] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6043), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194117] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9981), 1,
      anon_sym_COMMA,
    ACTIONS(9983), 1,
      anon_sym_RBRACK,
    STATE(5819), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6044), 1,
      sym_comment,
  [194136] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9985), 1,
      anon_sym_COMMA,
    ACTIONS(9987), 1,
      anon_sym_GT,
    STATE(6045), 1,
      sym_comment,
    STATE(6177), 1,
      aux_sym_type_parameters_repeat1,
  [194155] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6046), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194170] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6047), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194185] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6048), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194200] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6049), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194215] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8163), 1,
      anon_sym_LBRACE,
    ACTIONS(8165), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1487), 1,
      sym_object_type,
    STATE(6050), 1,
      sym_comment,
  [194234] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9989), 1,
      anon_sym_COMMA,
    ACTIONS(9991), 1,
      anon_sym_RBRACE,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
    STATE(6051), 1,
      sym_comment,
  [194253] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6052), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194268] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9993), 1,
      anon_sym_COMMA,
    ACTIONS(9995), 1,
      anon_sym_RBRACE,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
    STATE(6053), 1,
      sym_comment,
  [194287] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6054), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194302] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6055), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194317] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6056), 1,
      sym_comment,
    ACTIONS(9601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194332] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6057), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194347] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5910), 1,
      anon_sym_RPAREN,
    STATE(6058), 1,
      sym_comment,
    STATE(6189), 1,
      aux_sym_array_repeat1,
  [194366] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6059), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194381] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5910), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6060), 1,
      sym_comment,
  [194400] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4145), 1,
      anon_sym_LPAREN,
    ACTIONS(9997), 1,
      anon_sym_DOT,
    STATE(4338), 1,
      sym_arguments,
    STATE(6061), 1,
      sym_comment,
  [194419] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6062), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194434] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6063), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194449] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6064), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194464] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6065), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194479] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6066), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194494] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6067), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194509] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6068), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194524] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9999), 1,
      sym__glimmer_template_content,
    ACTIONS(10002), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(6069), 2,
      sym_comment,
      aux_sym_glimmer_template_repeat1,
  [194541] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6070), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194556] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8828), 1,
      anon_sym_DOT,
    ACTIONS(9611), 1,
      anon_sym_COLON,
    ACTIONS(10004), 1,
      anon_sym_GT,
    STATE(6071), 1,
      sym_comment,
  [194575] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6072), 1,
      sym_comment,
    ACTIONS(10006), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194590] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6073), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194605] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10008), 1,
      anon_sym_LBRACE,
    STATE(6074), 1,
      sym_comment,
    ACTIONS(8868), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [194622] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6075), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194637] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6076), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194652] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6077), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194667] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6078), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194682] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9083), 1,
      anon_sym_GT,
    ACTIONS(10010), 1,
      anon_sym_COMMA,
    STATE(6079), 2,
      sym_comment,
      aux_sym_type_arguments_repeat1,
  [194699] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6080), 1,
      sym_comment,
    ACTIONS(10013), 3,
      sym__automatic_semicolon,
      anon_sym_with,
      anon_sym_SEMI,
  [194714] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10015), 1,
      anon_sym_as,
    STATE(6081), 1,
      sym_comment,
    ACTIONS(10017), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [194731] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6082), 1,
      sym_comment,
    ACTIONS(10019), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [194746] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6083), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194761] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10021), 1,
      anon_sym_COMMA,
    ACTIONS(10023), 1,
      anon_sym_RBRACE,
    STATE(6084), 1,
      sym_comment,
    STATE(6221), 1,
      aux_sym_export_clause_repeat1,
  [194780] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6085), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194795] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6086), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194810] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6087), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194825] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6088), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194840] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6089), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194855] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6090), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194870] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6091), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194885] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6092), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194900] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6093), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194915] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6094), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194930] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6095), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194945] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8095), 1,
      anon_sym_DOT,
    STATE(6096), 1,
      sym_comment,
    ACTIONS(10025), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [194962] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6097), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194977] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9202), 1,
      anon_sym_EQ,
    STATE(6098), 1,
      sym_comment,
    ACTIONS(10027), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [194994] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6099), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195009] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10029), 1,
      anon_sym_COMMA,
    ACTIONS(10031), 1,
      anon_sym_RBRACE,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
    STATE(6100), 1,
      sym_comment,
  [195028] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10033), 1,
      anon_sym_COMMA,
    ACTIONS(10035), 1,
      anon_sym_RBRACE,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
    STATE(6101), 1,
      sym_comment,
  [195047] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6102), 1,
      sym_comment,
    ACTIONS(9828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195062] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6103), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195077] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6104), 1,
      sym_comment,
    ACTIONS(9742), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195092] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10037), 1,
      anon_sym_LPAREN,
    ACTIONS(10039), 1,
      anon_sym_await,
    STATE(79), 1,
      sym__for_header,
    STATE(6105), 1,
      sym_comment,
  [195111] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6106), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195126] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6107), 1,
      sym_comment,
    ACTIONS(9763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195141] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6108), 1,
      sym_comment,
    ACTIONS(10041), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195156] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10043), 1,
      sym_identifier,
    ACTIONS(10045), 1,
      anon_sym_SEMI,
    ACTIONS(10047), 1,
      sym__automatic_semicolon,
    STATE(6109), 1,
      sym_comment,
  [195175] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10049), 1,
      sym_identifier,
    ACTIONS(10051), 1,
      anon_sym_SEMI,
    ACTIONS(10053), 1,
      sym__automatic_semicolon,
    STATE(6110), 1,
      sym_comment,
  [195194] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10055), 1,
      anon_sym_LPAREN,
    ACTIONS(10057), 1,
      anon_sym_await,
    STATE(86), 1,
      sym__for_header,
    STATE(6111), 1,
      sym_comment,
  [195213] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10059), 1,
      anon_sym_as,
    STATE(6112), 1,
      sym_comment,
    ACTIONS(9856), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [195230] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7179), 1,
      anon_sym_type,
    ACTIONS(10061), 1,
      sym_identifier,
    STATE(6113), 1,
      sym_comment,
    STATE(6478), 1,
      sym__import_identifier,
  [195249] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6114), 1,
      sym_comment,
    ACTIONS(10063), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195264] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7179), 1,
      anon_sym_type,
    ACTIONS(10061), 1,
      sym_identifier,
    STATE(6115), 1,
      sym_comment,
    STATE(6474), 1,
      sym__import_identifier,
  [195283] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10065), 1,
      anon_sym_COMMA,
    ACTIONS(10067), 1,
      anon_sym_RBRACE,
    STATE(6116), 1,
      sym_comment,
    STATE(6254), 1,
      aux_sym_named_imports_repeat1,
  [195302] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7937), 1,
      anon_sym_const,
    ACTIONS(9216), 1,
      sym_identifier,
    STATE(6117), 1,
      sym_comment,
    STATE(6618), 1,
      sym_type_parameter,
  [195321] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7967), 1,
      anon_sym_DOT,
    STATE(6118), 1,
      sym_comment,
    ACTIONS(9553), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195338] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(10069), 1,
      anon_sym_RPAREN,
    STATE(6119), 1,
      sym_comment,
    STATE(7128), 1,
      sym_type_annotation,
  [195357] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10071), 1,
      sym_identifier,
    ACTIONS(10073), 1,
      anon_sym_SEMI,
    ACTIONS(10075), 1,
      sym__automatic_semicolon,
    STATE(6120), 1,
      sym_comment,
  [195376] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10077), 1,
      sym_identifier,
    ACTIONS(10079), 1,
      anon_sym_SEMI,
    ACTIONS(10081), 1,
      sym__automatic_semicolon,
    STATE(6121), 1,
      sym_comment,
  [195395] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6122), 1,
      sym_comment,
    ACTIONS(10083), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195410] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6123), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195425] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6124), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195440] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6125), 1,
      sym_comment,
    ACTIONS(10063), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195455] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6126), 1,
      sym_comment,
    ACTIONS(10085), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195470] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6127), 1,
      sym_comment,
    ACTIONS(10087), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195485] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10089), 1,
      sym_identifier,
    STATE(1907), 1,
      sym_decorator_member_expression,
    STATE(1978), 1,
      sym_decorator_call_expression,
    STATE(6128), 1,
      sym_comment,
  [195504] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6129), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195519] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6130), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195534] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6131), 1,
      sym_comment,
    ACTIONS(9945), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195549] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6132), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195564] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10091), 1,
      sym_identifier,
    ACTIONS(10093), 1,
      anon_sym_LBRACK,
    ACTIONS(10095), 1,
      sym_private_property_identifier,
    STATE(6133), 1,
      sym_comment,
  [195583] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6134), 1,
      sym_comment,
    ACTIONS(10097), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195598] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6135), 1,
      sym_comment,
    ACTIONS(9475), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195613] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6136), 1,
      sym_comment,
    ACTIONS(9943), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195628] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6137), 1,
      sym_comment,
    ACTIONS(10099), 3,
      anon_sym_default,
      anon_sym_RBRACE,
      anon_sym_case,
  [195643] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6138), 1,
      sym_comment,
    ACTIONS(10101), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195658] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6139), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195673] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6140), 1,
      sym_comment,
    ACTIONS(8194), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [195688] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9099), 1,
      anon_sym_LBRACE,
    ACTIONS(10103), 1,
      anon_sym_COMMA,
    STATE(6141), 2,
      sym_comment,
      aux_sym_implements_clause_repeat1,
  [195705] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10106), 1,
      anon_sym_COMMA,
    ACTIONS(10109), 1,
      anon_sym_RPAREN,
    STATE(6142), 2,
      sym_comment,
      aux_sym_formal_parameters_repeat1,
  [195722] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8741), 1,
      anon_sym_COMMA,
    ACTIONS(10111), 1,
      anon_sym_RBRACE,
    STATE(6143), 1,
      sym_comment,
    STATE(6195), 1,
      aux_sym_object_pattern_repeat1,
  [195741] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9832), 1,
      anon_sym_require,
    ACTIONS(10113), 1,
      sym_identifier,
    STATE(6144), 1,
      sym_comment,
    STATE(6308), 1,
      sym_nested_identifier,
  [195760] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(10115), 1,
      anon_sym_RBRACE,
    STATE(6145), 1,
      sym_comment,
    STATE(6199), 1,
      aux_sym_object_repeat1,
  [195779] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(10115), 1,
      anon_sym_RBRACE,
    STATE(5895), 1,
      aux_sym_object_repeat1,
    STATE(6146), 1,
      sym_comment,
  [195798] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8741), 1,
      anon_sym_COMMA,
    ACTIONS(10111), 1,
      anon_sym_RBRACE,
    STATE(5897), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6147), 1,
      sym_comment,
  [195817] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6148), 1,
      sym_comment,
    ACTIONS(9757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195832] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6149), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195847] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6150), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195862] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10117), 1,
      anon_sym_COMMA,
    ACTIONS(10119), 1,
      anon_sym_RPAREN,
    STATE(6151), 1,
      sym_comment,
    STATE(6204), 1,
      aux_sym_formal_parameters_repeat1,
  [195881] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6152), 1,
      sym_comment,
    ACTIONS(10121), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195896] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9204), 1,
      anon_sym_COMMA,
    ACTIONS(9408), 1,
      anon_sym_RBRACK,
    STATE(6153), 1,
      sym_comment,
    STATE(6208), 1,
      aux_sym_array_pattern_repeat1,
  [195915] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7937), 1,
      anon_sym_const,
    ACTIONS(9216), 1,
      sym_identifier,
    STATE(6154), 1,
      sym_comment,
    STATE(6171), 1,
      sym_type_parameter,
  [195934] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5908), 1,
      anon_sym_RBRACK,
    STATE(6155), 1,
      sym_comment,
    STATE(6206), 1,
      aux_sym_array_repeat1,
  [195953] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5908), 1,
      anon_sym_RBRACK,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6156), 1,
      sym_comment,
  [195972] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10123), 1,
      anon_sym_LBRACE,
    STATE(6157), 1,
      sym_comment,
    ACTIONS(9097), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [195989] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9204), 1,
      anon_sym_COMMA,
    ACTIONS(9408), 1,
      anon_sym_RBRACK,
    STATE(5974), 1,
      aux_sym_array_pattern_repeat1,
    STATE(6158), 1,
      sym_comment,
  [196008] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5150), 1,
      anon_sym_LBRACE,
    STATE(6159), 1,
      sym_comment,
    ACTIONS(5152), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [196025] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10125), 1,
      anon_sym_COMMA,
    ACTIONS(10127), 1,
      anon_sym_RBRACK,
    STATE(6160), 1,
      sym_comment,
    STATE(6161), 1,
      aux_sym_tuple_type_repeat1,
  [196044] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10129), 1,
      anon_sym_COMMA,
    ACTIONS(10131), 1,
      anon_sym_RBRACK,
    STATE(5819), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6161), 1,
      sym_comment,
  [196063] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9557), 1,
      anon_sym_LBRACE,
    ACTIONS(10133), 1,
      sym_identifier,
    STATE(5529), 1,
      sym_export_clause,
    STATE(6162), 1,
      sym_comment,
  [196082] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    ACTIONS(9640), 1,
      anon_sym_as,
    STATE(6163), 1,
      sym_comment,
    STATE(6605), 1,
      sym__from_clause,
  [196101] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6164), 1,
      sym_comment,
    ACTIONS(10135), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [196116] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7069), 1,
      anon_sym_AMP,
    ACTIONS(7071), 1,
      anon_sym_PIPE,
    ACTIONS(7073), 1,
      anon_sym_extends,
    STATE(6165), 1,
      sym_comment,
  [196135] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8683), 1,
      anon_sym_COMMA,
    ACTIONS(10137), 1,
      anon_sym_LBRACE,
    STATE(6141), 1,
      aux_sym_implements_clause_repeat1,
    STATE(6166), 1,
      sym_comment,
  [196154] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5066), 1,
      anon_sym_LBRACE,
    STATE(6167), 1,
      sym_comment,
    ACTIONS(5068), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [196171] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6168), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196186] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6169), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196201] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6170), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196216] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10139), 1,
      anon_sym_COMMA,
    ACTIONS(10141), 1,
      anon_sym_GT,
    STATE(6171), 1,
      sym_comment,
    STATE(6232), 1,
      aux_sym_type_parameters_repeat1,
  [196235] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6172), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196250] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10143), 1,
      sym_identifier,
    ACTIONS(10145), 1,
      anon_sym_LBRACK,
    ACTIONS(10147), 1,
      sym_private_property_identifier,
    STATE(6173), 1,
      sym_comment,
  [196269] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6174), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196284] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10149), 1,
      sym_identifier,
    ACTIONS(10151), 1,
      anon_sym_LBRACK,
    ACTIONS(10153), 1,
      sym_private_property_identifier,
    STATE(6175), 1,
      sym_comment,
  [196303] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6176), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196318] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10155), 1,
      anon_sym_COMMA,
    ACTIONS(10158), 1,
      anon_sym_GT,
    STATE(6177), 2,
      sym_comment,
      aux_sym_type_parameters_repeat1,
  [196335] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10160), 1,
      sym_identifier,
    ACTIONS(10162), 1,
      anon_sym_LBRACK,
    ACTIONS(10164), 1,
      sym_private_property_identifier,
    STATE(6178), 1,
      sym_comment,
  [196354] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6179), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196369] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6180), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196384] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6181), 1,
      sym_comment,
    ACTIONS(9945), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196399] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6182), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196414] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6183), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196429] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8163), 1,
      anon_sym_LBRACE,
    ACTIONS(8165), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1449), 1,
      sym_object_type,
    STATE(6184), 1,
      sym_comment,
  [196448] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6185), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196463] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6186), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196478] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6187), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196493] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10166), 1,
      anon_sym_COMMA,
    ACTIONS(10168), 1,
      anon_sym_RBRACE,
    STATE(6100), 1,
      aux_sym_enum_body_repeat1,
    STATE(6188), 1,
      sym_comment,
  [196512] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(10170), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6189), 1,
      sym_comment,
  [196531] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6190), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196546] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6191), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196561] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8741), 1,
      anon_sym_COMMA,
    ACTIONS(10172), 1,
      anon_sym_RBRACE,
    STATE(5897), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6192), 1,
      sym_comment,
  [196580] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10174), 1,
      anon_sym_COMMA,
    ACTIONS(10176), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6193), 1,
      sym_comment,
  [196599] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10178), 1,
      anon_sym_LBRACE,
    ACTIONS(10180), 1,
      anon_sym_LPAREN,
    STATE(940), 1,
      sym_statement_block,
    STATE(6194), 1,
      sym_comment,
  [196618] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8741), 1,
      anon_sym_COMMA,
    ACTIONS(10182), 1,
      anon_sym_RBRACE,
    STATE(5897), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6195), 1,
      sym_comment,
  [196637] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10184), 1,
      anon_sym_COMMA,
    ACTIONS(10186), 1,
      anon_sym_RBRACE,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
    STATE(6196), 1,
      sym_comment,
  [196656] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10188), 1,
      anon_sym_COMMA,
    ACTIONS(10190), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6197), 1,
      sym_comment,
  [196675] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10192), 1,
      anon_sym_COMMA,
    ACTIONS(10194), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6198), 1,
      sym_comment,
  [196694] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(10196), 1,
      anon_sym_RBRACE,
    STATE(5895), 1,
      aux_sym_object_repeat1,
    STATE(6199), 1,
      sym_comment,
  [196713] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6200), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196728] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10198), 1,
      sym_identifier,
    ACTIONS(10200), 1,
      anon_sym_LBRACK,
    ACTIONS(10202), 1,
      sym_private_property_identifier,
    STATE(6201), 1,
      sym_comment,
  [196747] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6202), 1,
      sym_comment,
    ACTIONS(10204), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196762] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6203), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196777] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10206), 1,
      anon_sym_COMMA,
    ACTIONS(10208), 1,
      anon_sym_RPAREN,
    STATE(6142), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(6204), 1,
      sym_comment,
  [196796] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    ACTIONS(10210), 1,
      anon_sym_LPAREN,
    STATE(6205), 1,
      sym_comment,
    STATE(6224), 1,
      sym_statement_block,
  [196815] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(10212), 1,
      anon_sym_RBRACK,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6206), 1,
      sym_comment,
  [196834] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10214), 1,
      anon_sym_COMMA,
    ACTIONS(10216), 1,
      anon_sym_RBRACE,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
    STATE(6207), 1,
      sym_comment,
  [196853] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9204), 1,
      anon_sym_COMMA,
    ACTIONS(10218), 1,
      anon_sym_RBRACK,
    STATE(5974), 1,
      aux_sym_array_pattern_repeat1,
    STATE(6208), 1,
      sym_comment,
  [196872] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8043), 1,
      anon_sym_LBRACE,
    ACTIONS(8045), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1235), 1,
      sym_object_type,
    STATE(6209), 1,
      sym_comment,
  [196891] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6210), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196906] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6211), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196921] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6212), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196936] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5927), 1,
      anon_sym_RPAREN,
    STATE(6213), 1,
      sym_comment,
    STATE(6260), 1,
      aux_sym_array_repeat1,
  [196955] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5927), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6214), 1,
      sym_comment,
  [196974] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6215), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196989] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6216), 1,
      sym_comment,
    ACTIONS(9945), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197004] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6217), 1,
      sym_comment,
    ACTIONS(10220), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [197019] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10222), 1,
      anon_sym_COMMA,
    ACTIONS(10224), 1,
      anon_sym_RBRACK,
    STATE(5819), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6218), 1,
      sym_comment,
  [197038] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6472), 1,
      sym__automatic_semicolon,
    STATE(6219), 1,
      sym_comment,
    ACTIONS(2275), 2,
      anon_sym_else,
      anon_sym_while,
  [197055] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6220), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197070] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10226), 1,
      anon_sym_COMMA,
    ACTIONS(10229), 1,
      anon_sym_RBRACE,
    STATE(6221), 2,
      sym_comment,
      aux_sym_export_clause_repeat1,
  [197087] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6437), 1,
      sym__automatic_semicolon,
    STATE(6222), 1,
      sym_comment,
    ACTIONS(2329), 2,
      anon_sym_else,
      anon_sym_while,
  [197104] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6407), 1,
      sym__automatic_semicolon,
    STATE(6223), 1,
      sym_comment,
    ACTIONS(2325), 2,
      anon_sym_else,
      anon_sym_while,
  [197121] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6224), 1,
      sym_comment,
    ACTIONS(3248), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_finally,
  [197136] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6225), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197151] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6226), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197166] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10231), 1,
      anon_sym_COMMA,
    ACTIONS(10233), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6227), 1,
      sym_comment,
  [197185] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6228), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197200] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10235), 1,
      anon_sym_COMMA,
    ACTIONS(10237), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6229), 1,
      sym_comment,
  [197219] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10239), 1,
      anon_sym_COMMA,
    ACTIONS(10241), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6230), 1,
      sym_comment,
  [197238] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6231), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197253] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10243), 1,
      anon_sym_COMMA,
    ACTIONS(10245), 1,
      anon_sym_GT,
    STATE(6177), 1,
      aux_sym_type_parameters_repeat1,
    STATE(6232), 1,
      sym_comment,
  [197272] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(10247), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6233), 1,
      sym_comment,
  [197291] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6234), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197306] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7967), 1,
      anon_sym_DOT,
    STATE(6235), 1,
      sym_comment,
    ACTIONS(10249), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [197323] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7969), 1,
      anon_sym_DOT,
    STATE(6236), 1,
      sym_comment,
    ACTIONS(10249), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [197340] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6405), 1,
      sym__automatic_semicolon,
    STATE(6237), 1,
      sym_comment,
    ACTIONS(2387), 2,
      anon_sym_else,
      anon_sym_while,
  [197357] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6238), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197372] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5912), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6239), 1,
      sym_comment,
  [197391] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5912), 1,
      anon_sym_RPAREN,
    STATE(6233), 1,
      aux_sym_array_repeat1,
    STATE(6240), 1,
      sym_comment,
  [197410] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6241), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197425] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(209), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8001), 1,
      anon_sym_LBRACE_PIPE,
    STATE(6242), 1,
      sym_comment,
    STATE(6576), 1,
      sym_object_type,
  [197444] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6243), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197459] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5896), 1,
      anon_sym_RPAREN,
    STATE(6244), 1,
      sym_comment,
    STATE(6324), 1,
      aux_sym_array_repeat1,
  [197478] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10251), 1,
      anon_sym_COMMA,
    ACTIONS(10253), 1,
      anon_sym_RBRACK,
    STATE(6245), 1,
      sym_comment,
    STATE(6295), 1,
      aux_sym_tuple_type_repeat1,
  [197497] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5896), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6246), 1,
      sym_comment,
  [197516] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4159), 1,
      anon_sym_LPAREN,
    ACTIONS(10255), 1,
      anon_sym_DOT,
    STATE(4331), 1,
      sym_arguments,
    STATE(6247), 1,
      sym_comment,
  [197535] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7179), 1,
      anon_sym_type,
    ACTIONS(10061), 1,
      sym_identifier,
    STATE(6248), 1,
      sym_comment,
    STATE(6661), 1,
      sym__import_identifier,
  [197554] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7537), 1,
      anon_sym_AMP,
    ACTIONS(7539), 1,
      anon_sym_PIPE,
    ACTIONS(7541), 1,
      anon_sym_extends,
    STATE(6249), 1,
      sym_comment,
  [197573] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6250), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197588] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6251), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197603] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6252), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197618] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7179), 1,
      anon_sym_type,
    ACTIONS(10061), 1,
      sym_identifier,
    STATE(6253), 1,
      sym_comment,
    STATE(6859), 1,
      sym__import_identifier,
  [197637] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10257), 1,
      anon_sym_COMMA,
    ACTIONS(10260), 1,
      anon_sym_RBRACE,
    STATE(6254), 2,
      sym_comment,
      aux_sym_named_imports_repeat1,
  [197654] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7087), 1,
      anon_sym_DQUOTE,
    ACTIONS(7089), 1,
      anon_sym_SQUOTE,
    STATE(6255), 1,
      sym_comment,
    STATE(7052), 1,
      sym_string,
  [197673] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6256), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197688] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8043), 1,
      anon_sym_LBRACE,
    ACTIONS(8045), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1246), 1,
      sym_object_type,
    STATE(6257), 1,
      sym_comment,
  [197707] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6258), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197722] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10262), 1,
      anon_sym_COMMA,
    ACTIONS(10264), 1,
      anon_sym_RBRACE,
    STATE(6259), 1,
      sym_comment,
    STATE(6304), 1,
      aux_sym_enum_body_repeat1,
  [197741] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(10266), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6260), 1,
      sym_comment,
  [197760] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8025), 1,
      anon_sym_COMMA,
    ACTIONS(10268), 1,
      anon_sym_RBRACE,
    STATE(5895), 1,
      aux_sym_object_repeat1,
    STATE(6261), 1,
      sym_comment,
  [197779] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10270), 1,
      anon_sym_COMMA,
    ACTIONS(10272), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6262), 1,
      sym_comment,
  [197798] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10274), 1,
      anon_sym_COMMA,
    ACTIONS(10276), 1,
      anon_sym_RBRACE,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
    STATE(6263), 1,
      sym_comment,
  [197817] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10278), 1,
      anon_sym_COMMA,
    ACTIONS(10280), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6264), 1,
      sym_comment,
  [197836] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6265), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197851] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10282), 1,
      anon_sym_COMMA,
    ACTIONS(10284), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6266), 1,
      sym_comment,
  [197870] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10286), 1,
      anon_sym_COMMA,
    ACTIONS(10288), 1,
      anon_sym_RBRACE,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
    STATE(6267), 1,
      sym_comment,
  [197889] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6268), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197904] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6269), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197919] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6270), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197934] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6271), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197949] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6272), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197964] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10290), 1,
      anon_sym_COMMA,
    ACTIONS(10292), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6273), 1,
      sym_comment,
  [197983] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10294), 1,
      anon_sym_COMMA,
    ACTIONS(10296), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6274), 1,
      sym_comment,
  [198002] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6275), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198017] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8828), 1,
      anon_sym_DOT,
    ACTIONS(9611), 1,
      anon_sym_COLON,
    ACTIONS(10298), 1,
      anon_sym_GT,
    STATE(6276), 1,
      sym_comment,
  [198036] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10300), 1,
      anon_sym_COMMA,
    ACTIONS(10302), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6277), 1,
      sym_comment,
  [198055] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(10304), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6278), 1,
      sym_comment,
  [198074] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6279), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198089] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10306), 1,
      anon_sym_COMMA,
    ACTIONS(10308), 1,
      anon_sym_RBRACE,
    STATE(6263), 1,
      aux_sym_enum_body_repeat1,
    STATE(6280), 1,
      sym_comment,
  [198108] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6281), 1,
      sym_comment,
    ACTIONS(10310), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [198123] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8059), 1,
      anon_sym_LBRACE,
    ACTIONS(8061), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1050), 1,
      sym_object_type,
    STATE(6282), 1,
      sym_comment,
  [198142] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6283), 1,
      sym_comment,
    ACTIONS(10006), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198157] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6284), 1,
      sym_comment,
    ACTIONS(9939), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198172] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7969), 1,
      anon_sym_DOT,
    STATE(6285), 1,
      sym_comment,
    ACTIONS(10312), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198189] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7967), 1,
      anon_sym_DOT,
    STATE(6286), 1,
      sym_comment,
    ACTIONS(10312), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198206] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10314), 1,
      sym_identifier,
    ACTIONS(10316), 1,
      anon_sym_LBRACK,
    ACTIONS(10318), 1,
      sym_private_property_identifier,
    STATE(6287), 1,
      sym_comment,
  [198225] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6288), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198240] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10320), 1,
      sym_identifier,
    ACTIONS(10322), 1,
      anon_sym_LBRACK,
    ACTIONS(10324), 1,
      sym_private_property_identifier,
    STATE(6289), 1,
      sym_comment,
  [198259] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6290), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198274] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10326), 1,
      sym_identifier,
    ACTIONS(10328), 1,
      anon_sym_LBRACK,
    ACTIONS(10330), 1,
      sym_private_property_identifier,
    STATE(6291), 1,
      sym_comment,
  [198293] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6292), 1,
      sym_comment,
    ACTIONS(8210), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [198308] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10332), 1,
      sym_identifier,
    ACTIONS(10334), 1,
      anon_sym_LBRACK,
    ACTIONS(10336), 1,
      sym_private_property_identifier,
    STATE(6293), 1,
      sym_comment,
  [198327] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6294), 1,
      sym_comment,
    ACTIONS(10338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198342] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10340), 1,
      anon_sym_COMMA,
    ACTIONS(10342), 1,
      anon_sym_RBRACK,
    STATE(5819), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6295), 1,
      sym_comment,
  [198361] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6296), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198376] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6297), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198391] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6298), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198406] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5945), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6299), 1,
      sym_comment,
  [198425] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5945), 1,
      anon_sym_RPAREN,
    STATE(6278), 1,
      aux_sym_array_repeat1,
    STATE(6300), 1,
      sym_comment,
  [198444] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8059), 1,
      anon_sym_LBRACE,
    ACTIONS(8061), 1,
      anon_sym_LBRACE_PIPE,
    STATE(993), 1,
      sym_object_type,
    STATE(6301), 1,
      sym_comment,
  [198463] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    ACTIONS(10346), 1,
      anon_sym_RBRACE,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
    STATE(6302), 1,
      sym_comment,
  [198482] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6303), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198497] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10348), 1,
      anon_sym_COMMA,
    ACTIONS(10350), 1,
      anon_sym_RBRACE,
    STATE(5863), 1,
      aux_sym_enum_body_repeat1,
    STATE(6304), 1,
      sym_comment,
  [198516] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7967), 1,
      anon_sym_DOT,
    STATE(6305), 1,
      sym_comment,
    ACTIONS(10352), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198533] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6306), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198548] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6307), 1,
      sym_comment,
    ACTIONS(10354), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198563] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7969), 1,
      anon_sym_DOT,
    STATE(6308), 1,
      sym_comment,
    ACTIONS(10352), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198580] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10356), 1,
      anon_sym_COMMA,
    ACTIONS(10358), 1,
      anon_sym_RBRACK,
    STATE(6218), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6309), 1,
      sym_comment,
  [198599] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    ACTIONS(10360), 1,
      anon_sym_RPAREN,
    STATE(6310), 1,
      sym_comment,
    STATE(7087), 1,
      sym_type_annotation,
  [198618] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6023), 1,
      anon_sym_extends,
    ACTIONS(10362), 1,
      anon_sym_AMP,
    ACTIONS(10364), 1,
      anon_sym_PIPE,
    STATE(6311), 1,
      sym_comment,
  [198637] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6312), 1,
      sym_comment,
    ACTIONS(10366), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198652] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6313), 1,
      sym_comment,
    ACTIONS(10204), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198667] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6314), 1,
      sym_comment,
    ACTIONS(10368), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198682] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10370), 1,
      anon_sym_COMMA,
    ACTIONS(10372), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6315), 1,
      sym_comment,
  [198701] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6316), 1,
      sym_comment,
    ACTIONS(9945), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198716] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6317), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198731] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6318), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198746] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6319), 1,
      sym_comment,
    ACTIONS(9864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198761] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6320), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198776] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6321), 1,
      sym_comment,
    ACTIONS(10374), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198791] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(209), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8001), 1,
      anon_sym_LBRACE_PIPE,
    STATE(6322), 1,
      sym_comment,
    STATE(6734), 1,
      sym_object_type,
  [198810] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10376), 1,
      anon_sym_COMMA,
    ACTIONS(10378), 1,
      anon_sym_RBRACE,
    STATE(6196), 1,
      aux_sym_enum_body_repeat1,
    STATE(6323), 1,
      sym_comment,
  [198829] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(10380), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      aux_sym_array_repeat1,
    STATE(6324), 1,
      sym_comment,
  [198848] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6325), 1,
      sym_comment,
    ACTIONS(10374), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198863] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10382), 1,
      anon_sym_COMMA,
    ACTIONS(10384), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6326), 1,
      sym_comment,
  [198882] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6327), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198897] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6328), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198912] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6329), 1,
      sym_comment,
    ACTIONS(9941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198927] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6330), 1,
      sym_comment,
    ACTIONS(10368), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198942] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6331), 1,
      sym_comment,
    ACTIONS(10386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198957] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10388), 1,
      anon_sym_COMMA,
    ACTIONS(10390), 1,
      anon_sym_GT,
    STATE(6079), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6332), 1,
      sym_comment,
  [198976] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6333), 1,
      sym_comment,
    ACTIONS(10374), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198991] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10394), 1,
      sym_private_property_identifier,
    STATE(6334), 1,
      sym_comment,
  [199007] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6335), 1,
      sym_comment,
    ACTIONS(3458), 2,
      anon_sym_else,
      anon_sym_while,
  [199021] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7855), 1,
      anon_sym_LBRACE,
    STATE(419), 1,
      sym_class_body,
    STATE(6336), 1,
      sym_comment,
  [199037] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(90), 1,
      sym_parenthesized_expression,
    STATE(6337), 1,
      sym_comment,
  [199053] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10398), 1,
      anon_sym_LPAREN,
    STATE(1044), 1,
      sym_parenthesized_expression,
    STATE(6338), 1,
      sym_comment,
  [199069] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6339), 1,
      sym_comment,
    ACTIONS(2177), 2,
      anon_sym_else,
      anon_sym_while,
  [199083] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3383), 1,
      sym_statement_block,
    STATE(6340), 1,
      sym_comment,
  [199099] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4387), 1,
      sym_formal_parameters,
    STATE(6341), 1,
      sym_comment,
  [199115] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(80), 1,
      sym_parenthesized_expression,
    STATE(6342), 1,
      sym_comment,
  [199131] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10400), 1,
      anon_sym_LPAREN,
    STATE(6343), 1,
      sym_comment,
    STATE(6578), 1,
      sym_parenthesized_expression,
  [199147] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10178), 1,
      anon_sym_LBRACE,
    STATE(937), 1,
      sym_statement_block,
    STATE(6344), 1,
      sym_comment,
  [199163] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1321), 1,
      sym_class_body,
    STATE(6345), 1,
      sym_comment,
  [199179] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10402), 1,
      sym_identifier,
    ACTIONS(10404), 1,
      sym_private_property_identifier,
    STATE(6346), 1,
      sym_comment,
  [199195] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3413), 1,
      sym_statement_block,
    STATE(6347), 1,
      sym_comment,
  [199211] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(97), 1,
      sym_parenthesized_expression,
    STATE(6348), 1,
      sym_comment,
  [199227] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10406), 1,
      sym_identifier,
    ACTIONS(10408), 1,
      sym_private_property_identifier,
    STATE(6349), 1,
      sym_comment,
  [199243] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10410), 1,
      anon_sym_LBRACE,
    STATE(894), 1,
      sym_statement_block,
    STATE(6350), 1,
      sym_comment,
  [199259] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10412), 1,
      sym_identifier,
    ACTIONS(10414), 1,
      anon_sym_STAR,
    STATE(6351), 1,
      sym_comment,
  [199275] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10416), 1,
      anon_sym_LBRACE,
    STATE(1302), 1,
      sym_enum_body,
    STATE(6352), 1,
      sym_comment,
  [199291] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6353), 1,
      sym_comment,
    ACTIONS(3572), 2,
      anon_sym_else,
      anon_sym_while,
  [199305] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6354), 1,
      sym_comment,
    ACTIONS(5711), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199319] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6355), 1,
      sym_comment,
    ACTIONS(3586), 2,
      anon_sym_else,
      anon_sym_while,
  [199333] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10418), 1,
      sym_identifier,
    ACTIONS(10420), 1,
      anon_sym_STAR,
    STATE(6356), 1,
      sym_comment,
  [199349] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7625), 1,
      anon_sym_LBRACE,
    STATE(6357), 1,
      sym_comment,
    STATE(6584), 1,
      sym_class_body,
  [199365] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3370), 1,
      sym_statement_block,
    STATE(6358), 1,
      sym_comment,
  [199381] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6359), 1,
      sym_comment,
    ACTIONS(10422), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199395] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6360), 1,
      sym_comment,
    ACTIONS(2351), 2,
      anon_sym_else,
      anon_sym_while,
  [199409] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6361), 1,
      sym_comment,
    ACTIONS(3442), 2,
      anon_sym_else,
      anon_sym_while,
  [199423] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(3171), 1,
      sym_statement_block,
    STATE(6362), 1,
      sym_comment,
  [199439] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6363), 1,
      sym_comment,
    ACTIONS(9117), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199453] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    STATE(2480), 1,
      sym_statement_block,
    STATE(6364), 1,
      sym_comment,
  [199469] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6365), 1,
      sym_comment,
    ACTIONS(10424), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199483] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6366), 1,
      sym_comment,
    ACTIONS(3438), 2,
      anon_sym_else,
      anon_sym_while,
  [199497] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10178), 1,
      anon_sym_LBRACE,
    STATE(929), 1,
      sym_statement_block,
    STATE(6367), 1,
      sym_comment,
  [199513] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10426), 1,
      sym_identifier,
    ACTIONS(10428), 1,
      anon_sym_STAR,
    STATE(6368), 1,
      sym_comment,
  [199529] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    STATE(1113), 1,
      sym_class_body,
    STATE(6369), 1,
      sym_comment,
  [199545] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(6370), 1,
      sym_comment,
    ACTIONS(10430), 2,
      sym__glimmer_template_content,
      anon_sym_LT_SLASHtemplate_GT,
  [199559] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9053), 1,
      anon_sym_LBRACE,
    STATE(1056), 1,
      sym_statement_block,
    STATE(6371), 1,
      sym_comment,
  [199575] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10432), 1,
      anon_sym_LBRACE,
    STATE(1030), 1,
      sym_statement_block,
    STATE(6372), 1,
      sym_comment,
  [199591] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10434), 1,
      anon_sym_SEMI,
    ACTIONS(10436), 1,
      sym__automatic_semicolon,
    STATE(6373), 1,
      sym_comment,
  [199607] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10438), 1,
      anon_sym_LBRACE,
    STATE(1026), 1,
      sym_enum_body,
    STATE(6374), 1,
      sym_comment,
  [199623] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10440), 1,
      anon_sym_SEMI,
    ACTIONS(10442), 1,
      sym__automatic_semicolon,
    STATE(6375), 1,
      sym_comment,
  [199639] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6376), 1,
      sym_comment,
    ACTIONS(3474), 2,
      anon_sym_else,
      anon_sym_while,
  [199653] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10444), 1,
      anon_sym_SEMI,
    ACTIONS(10446), 1,
      sym__automatic_semicolon,
    STATE(6377), 1,
      sym_comment,
  [199669] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1300), 1,
      sym_class_body,
    STATE(6378), 1,
      sym_comment,
  [199685] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6379), 1,
      sym_comment,
    ACTIONS(3538), 2,
      anon_sym_else,
      anon_sym_while,
  [199699] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3149), 1,
      sym_class_body,
    STATE(6380), 1,
      sym_comment,
  [199715] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3409), 1,
      sym_statement_block,
    STATE(6381), 1,
      sym_comment,
  [199731] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10448), 1,
      anon_sym_SEMI,
    ACTIONS(10450), 1,
      sym__automatic_semicolon,
    STATE(6382), 1,
      sym_comment,
  [199747] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10452), 1,
      anon_sym_SEMI,
    ACTIONS(10454), 1,
      sym__automatic_semicolon,
    STATE(6383), 1,
      sym_comment,
  [199763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10456), 1,
      anon_sym_SEMI,
    ACTIONS(10458), 1,
      sym__automatic_semicolon,
    STATE(6384), 1,
      sym_comment,
  [199779] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6385), 1,
      sym_comment,
    ACTIONS(2351), 2,
      anon_sym_else,
      anon_sym_while,
  [199793] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9611), 1,
      anon_sym_COLON,
    ACTIONS(9613), 1,
      anon_sym_GT,
    STATE(6386), 1,
      sym_comment,
  [199809] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3001), 1,
      sym_class_body,
    STATE(6387), 1,
      sym_comment,
  [199825] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10460), 1,
      sym_identifier,
    ACTIONS(10462), 1,
      sym_private_property_identifier,
    STATE(6388), 1,
      sym_comment,
  [199841] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10438), 1,
      anon_sym_LBRACE,
    STATE(1008), 1,
      sym_enum_body,
    STATE(6389), 1,
      sym_comment,
  [199857] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10464), 1,
      sym_identifier,
    ACTIONS(10466), 1,
      anon_sym_STAR,
    STATE(6390), 1,
      sym_comment,
  [199873] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(3288), 1,
      sym_class_body,
    STATE(6391), 1,
      sym_comment,
  [199889] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7611), 1,
      anon_sym_LBRACE,
    STATE(330), 1,
      sym_class_body,
    STATE(6392), 1,
      sym_comment,
  [199905] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6393), 1,
      sym_comment,
    ACTIONS(10468), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199919] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6394), 1,
      sym_comment,
    ACTIONS(10470), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199933] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6395), 1,
      sym_comment,
    ACTIONS(3468), 2,
      anon_sym_else,
      anon_sym_while,
  [199947] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    STATE(2452), 1,
      sym_statement_block,
    STATE(6396), 1,
      sym_comment,
  [199963] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8826), 1,
      anon_sym_DOT,
    ACTIONS(10472), 1,
      anon_sym_GT,
    STATE(6397), 1,
      sym_comment,
  [199979] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2450), 1,
      sym_class_body,
    STATE(6398), 1,
      sym_comment,
  [199995] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(3270), 1,
      sym_class_body,
    STATE(6399), 1,
      sym_comment,
  [200011] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6400), 1,
      sym_comment,
    ACTIONS(10474), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [200025] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1287), 1,
      sym_class_body,
    STATE(6401), 1,
      sym_comment,
  [200041] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(3000), 1,
      sym_statement_block,
    STATE(6402), 1,
      sym_comment,
  [200057] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3371), 1,
      sym_statement_block,
    STATE(6403), 1,
      sym_comment,
  [200073] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3359), 1,
      sym_statement_block,
    STATE(6404), 1,
      sym_comment,
  [200089] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3366), 1,
      sym_statement_block,
    STATE(6405), 1,
      sym_comment,
  [200105] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10476), 1,
      anon_sym_SEMI,
    ACTIONS(10478), 1,
      sym__automatic_semicolon,
    STATE(6406), 1,
      sym_comment,
  [200121] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10480), 1,
      sym_identifier,
    ACTIONS(10482), 1,
      sym_private_property_identifier,
    STATE(6407), 1,
      sym_comment,
  [200137] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    ACTIONS(10486), 1,
      sym_private_property_identifier,
    STATE(6408), 1,
      sym_comment,
  [200153] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(6237), 1,
      sym_class_body,
    STATE(6409), 1,
      sym_comment,
  [200169] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10488), 1,
      anon_sym_SEMI,
    ACTIONS(10490), 1,
      sym__automatic_semicolon,
    STATE(6410), 1,
      sym_comment,
  [200185] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6411), 1,
      sym_comment,
    ACTIONS(10492), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200199] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7609), 1,
      anon_sym_LBRACE,
    STATE(955), 1,
      sym_class_body,
    STATE(6412), 1,
      sym_comment,
  [200215] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6413), 1,
      sym_comment,
    ACTIONS(10494), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200229] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10496), 1,
      anon_sym_SEMI,
    ACTIONS(10498), 1,
      sym__automatic_semicolon,
    STATE(6414), 1,
      sym_comment,
  [200245] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10500), 1,
      sym_identifier,
    ACTIONS(10502), 1,
      sym_private_property_identifier,
    STATE(6415), 1,
      sym_comment,
  [200261] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2427), 1,
      sym_class_body,
    STATE(6416), 1,
      sym_comment,
  [200277] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10314), 1,
      sym_identifier,
    ACTIONS(10318), 1,
      sym_private_property_identifier,
    STATE(6417), 1,
      sym_comment,
  [200293] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6418), 1,
      sym_comment,
    ACTIONS(10504), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200307] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7611), 1,
      anon_sym_LBRACE,
    STATE(328), 1,
      sym_class_body,
    STATE(6419), 1,
      sym_comment,
  [200323] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7853), 1,
      anon_sym_LBRACE,
    STATE(1034), 1,
      sym_class_body,
    STATE(6420), 1,
      sym_comment,
  [200339] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10506), 1,
      sym_identifier,
    ACTIONS(10508), 1,
      anon_sym_STAR,
    STATE(6421), 1,
      sym_comment,
  [200355] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10510), 1,
      anon_sym_SEMI,
    ACTIONS(10512), 1,
      sym__automatic_semicolon,
    STATE(6422), 1,
      sym_comment,
  [200371] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3181), 1,
      sym_class_body,
    STATE(6423), 1,
      sym_comment,
  [200387] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8989), 1,
      anon_sym_LBRACE,
    STATE(340), 1,
      sym_statement_block,
    STATE(6424), 1,
      sym_comment,
  [200403] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    STATE(964), 1,
      sym_class_body,
    STATE(6425), 1,
      sym_comment,
  [200419] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6426), 1,
      sym_comment,
    ACTIONS(3500), 2,
      anon_sym_else,
      anon_sym_while,
  [200433] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10416), 1,
      anon_sym_LBRACE,
    STATE(1306), 1,
      sym_enum_body,
    STATE(6427), 1,
      sym_comment,
  [200449] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8826), 1,
      anon_sym_DOT,
    ACTIONS(10514), 1,
      anon_sym_GT,
    STATE(6428), 1,
      sym_comment,
  [200465] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10516), 1,
      anon_sym_SEMI,
    ACTIONS(10518), 1,
      sym__automatic_semicolon,
    STATE(6429), 1,
      sym_comment,
  [200481] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2449), 1,
      sym_class_body,
    STATE(6430), 1,
      sym_comment,
  [200497] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6431), 1,
      sym_comment,
    ACTIONS(7499), 2,
      anon_sym_in,
      anon_sym_of,
  [200511] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    STATE(1125), 1,
      sym_class_body,
    STATE(6432), 1,
      sym_comment,
  [200527] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9053), 1,
      anon_sym_LBRACE,
    STATE(1020), 1,
      sym_statement_block,
    STATE(6433), 1,
      sym_comment,
  [200543] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    STATE(1132), 1,
      sym_class_body,
    STATE(6434), 1,
      sym_comment,
  [200559] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6435), 1,
      sym_comment,
    ACTIONS(10520), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200573] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(6041), 1,
      sym_class_body,
    STATE(6436), 1,
      sym_comment,
  [200589] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9611), 1,
      anon_sym_COLON,
    ACTIONS(10298), 1,
      anon_sym_GT,
    STATE(6437), 1,
      sym_comment,
  [200605] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6438), 1,
      sym_comment,
    ACTIONS(10522), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200619] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7611), 1,
      anon_sym_LBRACE,
    STATE(329), 1,
      sym_class_body,
    STATE(6439), 1,
      sym_comment,
  [200635] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10524), 1,
      anon_sym_SEMI,
    ACTIONS(10526), 1,
      sym__automatic_semicolon,
    STATE(6440), 1,
      sym_comment,
  [200651] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    STATE(6035), 1,
      sym_statement_block,
    STATE(6441), 1,
      sym_comment,
  [200667] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7609), 1,
      anon_sym_LBRACE,
    STATE(922), 1,
      sym_class_body,
    STATE(6442), 1,
      sym_comment,
  [200683] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_LPAREN,
    STATE(2414), 1,
      sym_arguments,
    STATE(6443), 1,
      sym_comment,
  [200699] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8977), 1,
      anon_sym_LBRACE,
    STATE(949), 1,
      sym_statement_block,
    STATE(6444), 1,
      sym_comment,
  [200715] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7609), 1,
      anon_sym_LBRACE,
    STATE(921), 1,
      sym_class_body,
    STATE(6445), 1,
      sym_comment,
  [200731] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3412), 1,
      sym_statement_block,
    STATE(6446), 1,
      sym_comment,
  [200747] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(2996), 1,
      sym_class_body,
    STATE(6447), 1,
      sym_comment,
  [200763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(6033), 1,
      sym_class_body,
    STATE(6448), 1,
      sym_comment,
  [200779] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10528), 1,
      sym_identifier,
    ACTIONS(10530), 1,
      anon_sym_STAR,
    STATE(6449), 1,
      sym_comment,
  [200795] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10532), 1,
      sym_identifier,
    ACTIONS(10534), 1,
      sym_private_property_identifier,
    STATE(6450), 1,
      sym_comment,
  [200811] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8989), 1,
      anon_sym_LBRACE,
    STATE(312), 1,
      sym_statement_block,
    STATE(6451), 1,
      sym_comment,
  [200827] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    STATE(1126), 1,
      sym_class_body,
    STATE(6452), 1,
      sym_comment,
  [200843] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6453), 1,
      sym_comment,
    ACTIONS(3394), 2,
      anon_sym_else,
      anon_sym_while,
  [200857] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6454), 1,
      sym_comment,
    ACTIONS(3504), 2,
      anon_sym_else,
      anon_sym_while,
  [200871] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6455), 1,
      sym_comment,
    ACTIONS(3498), 2,
      anon_sym_else,
      anon_sym_while,
  [200885] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3387), 1,
      sym_statement_block,
    STATE(6456), 1,
      sym_comment,
  [200901] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6457), 1,
      sym_comment,
    ACTIONS(3504), 2,
      anon_sym_else,
      anon_sym_while,
  [200915] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10536), 1,
      anon_sym_LBRACE,
    STATE(1294), 1,
      sym_statement_block,
    STATE(6458), 1,
      sym_comment,
  [200931] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6459), 1,
      sym_comment,
    ACTIONS(2075), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200945] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7611), 1,
      anon_sym_LBRACE,
    STATE(311), 1,
      sym_class_body,
    STATE(6460), 1,
      sym_comment,
  [200961] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    STATE(1025), 1,
      sym_class_body,
    STATE(6461), 1,
      sym_comment,
  [200977] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6462), 1,
      sym_comment,
    ACTIONS(3396), 2,
      anon_sym_else,
      anon_sym_while,
  [200991] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8977), 1,
      anon_sym_LBRACE,
    STATE(939), 1,
      sym_statement_block,
    STATE(6463), 1,
      sym_comment,
  [201007] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7609), 1,
      anon_sym_LBRACE,
    STATE(914), 1,
      sym_class_body,
    STATE(6464), 1,
      sym_comment,
  [201023] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6465), 1,
      sym_comment,
    ACTIONS(3394), 2,
      anon_sym_else,
      anon_sym_while,
  [201037] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3386), 1,
      sym_statement_block,
    STATE(6466), 1,
      sym_comment,
  [201053] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6467), 1,
      sym_comment,
    ACTIONS(3504), 2,
      anon_sym_else,
      anon_sym_while,
  [201067] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1240), 1,
      sym_class_body,
    STATE(6468), 1,
      sym_comment,
  [201083] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(2937), 1,
      sym_statement_block,
    STATE(6469), 1,
      sym_comment,
  [201099] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    STATE(1073), 1,
      sym_class_body,
    STATE(6470), 1,
      sym_comment,
  [201115] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6471), 1,
      sym_comment,
    ACTIONS(3386), 2,
      anon_sym_else,
      anon_sym_while,
  [201129] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6472), 1,
      sym_comment,
    ACTIONS(10260), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201143] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7855), 1,
      anon_sym_LBRACE,
    STATE(393), 1,
      sym_class_body,
    STATE(6473), 1,
      sym_comment,
  [201159] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6474), 1,
      sym_comment,
    ACTIONS(10538), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201173] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2515), 1,
      sym_class_body,
    STATE(6475), 1,
      sym_comment,
  [201189] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10540), 1,
      sym_identifier,
    ACTIONS(10542), 1,
      anon_sym_STAR,
    STATE(6476), 1,
      sym_comment,
  [201205] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4386), 1,
      sym_formal_parameters,
    STATE(6477), 1,
      sym_comment,
  [201221] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6478), 1,
      sym_comment,
    ACTIONS(10544), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201235] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6479), 1,
      sym_comment,
    ACTIONS(9607), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201249] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6480), 1,
      sym_comment,
    ACTIONS(5670), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [201263] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6481), 1,
      sym_comment,
    ACTIONS(2165), 2,
      anon_sym_else,
      anon_sym_while,
  [201277] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8733), 1,
      anon_sym_LBRACE,
    STATE(401), 1,
      sym_statement_block,
    STATE(6482), 1,
      sym_comment,
  [201293] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6483), 1,
      sym_comment,
    ACTIONS(3496), 2,
      anon_sym_else,
      anon_sym_while,
  [201307] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10546), 1,
      anon_sym_SEMI,
    ACTIONS(10548), 1,
      sym__automatic_semicolon,
    STATE(6484), 1,
      sym_comment,
  [201323] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    STATE(2521), 1,
      sym_statement_block,
    STATE(6485), 1,
      sym_comment,
  [201339] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6486), 1,
      sym_comment,
    ACTIONS(3494), 2,
      anon_sym_else,
      anon_sym_while,
  [201353] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6487), 1,
      sym_comment,
    ACTIONS(3392), 2,
      anon_sym_else,
      anon_sym_while,
  [201367] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3058), 1,
      sym_class_body,
    STATE(6488), 1,
      sym_comment,
  [201383] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10550), 1,
      sym_identifier,
    ACTIONS(10552), 1,
      anon_sym_STAR,
    STATE(6489), 1,
      sym_comment,
  [201399] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7845), 1,
      anon_sym_LBRACE,
    STATE(1309), 1,
      sym_class_body,
    STATE(6490), 1,
      sym_comment,
  [201415] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6491), 1,
      sym_comment,
    ACTIONS(3492), 2,
      anon_sym_else,
      anon_sym_while,
  [201429] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    STATE(2522), 1,
      sym_statement_block,
    STATE(6492), 1,
      sym_comment,
  [201445] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(4768), 1,
      sym_formal_parameters,
    STATE(6493), 1,
      sym_comment,
  [201461] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(3059), 1,
      sym_statement_block,
    STATE(6494), 1,
      sym_comment,
  [201477] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(3060), 1,
      sym_statement_block,
    STATE(6495), 1,
      sym_comment,
  [201493] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2526), 1,
      sym_class_body,
    STATE(6496), 1,
      sym_comment,
  [201509] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(2928), 1,
      sym_class_body,
    STATE(6497), 1,
      sym_comment,
  [201525] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6498), 1,
      sym_comment,
    ACTIONS(3372), 2,
      anon_sym_else,
      anon_sym_while,
  [201539] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10554), 1,
      anon_sym_SEMI,
    ACTIONS(10556), 1,
      sym__automatic_semicolon,
    STATE(6499), 1,
      sym_comment,
  [201555] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10558), 1,
      sym_identifier,
    ACTIONS(10560), 1,
      sym_private_property_identifier,
    STATE(6500), 1,
      sym_comment,
  [201571] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3382), 1,
      sym_statement_block,
    STATE(6501), 1,
      sym_comment,
  [201587] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3062), 1,
      sym_class_body,
    STATE(6502), 1,
      sym_comment,
  [201603] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6503), 1,
      sym_comment,
    ACTIONS(6733), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201617] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10562), 1,
      anon_sym_SEMI,
    ACTIONS(10564), 1,
      sym__automatic_semicolon,
    STATE(6504), 1,
      sym_comment,
  [201633] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6505), 1,
      sym_comment,
    ACTIONS(10566), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [201647] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6506), 1,
      sym_comment,
    ACTIONS(10568), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [201661] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10570), 1,
      sym_identifier,
    ACTIONS(10572), 1,
      sym_private_property_identifier,
    STATE(6507), 1,
      sym_comment,
  [201677] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6508), 1,
      sym_comment,
    ACTIONS(3514), 2,
      anon_sym_else,
      anon_sym_while,
  [201691] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6509), 1,
      sym_comment,
    STATE(6966), 1,
      sym_statement_block,
  [201707] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10574), 1,
      sym_identifier,
    ACTIONS(10576), 1,
      sym_private_property_identifier,
    STATE(6510), 1,
      sym_comment,
  [201723] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6511), 1,
      sym_comment,
    ACTIONS(3502), 2,
      anon_sym_else,
      anon_sym_while,
  [201737] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    STATE(1157), 1,
      sym_class_body,
    STATE(6512), 1,
      sym_comment,
  [201753] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6513), 1,
      sym_comment,
    ACTIONS(10578), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [201767] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6514), 1,
      sym_comment,
    ACTIONS(6701), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201781] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10580), 1,
      anon_sym_SEMI,
    ACTIONS(10582), 1,
      sym__automatic_semicolon,
    STATE(6515), 1,
      sym_comment,
  [201797] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6516), 1,
      sym_comment,
    STATE(6929), 1,
      sym_statement_block,
  [201813] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10584), 1,
      sym_identifier,
    ACTIONS(10586), 1,
      sym_private_property_identifier,
    STATE(6517), 1,
      sym_comment,
  [201829] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(6518), 1,
      sym_comment,
    ACTIONS(10588), 2,
      sym_jsx_identifier,
      sym_identifier,
  [201843] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10590), 1,
      sym_identifier,
    ACTIONS(10592), 1,
      sym_private_property_identifier,
    STATE(6519), 1,
      sym_comment,
  [201859] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    STATE(2445), 1,
      sym_statement_block,
    STATE(6520), 1,
      sym_comment,
  [201875] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7543), 1,
      anon_sym_LBRACE,
    STATE(1376), 1,
      sym_class_body,
    STATE(6521), 1,
      sym_comment,
  [201891] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8786), 1,
      anon_sym_LBRACE,
    STATE(1380), 1,
      sym_statement_block,
    STATE(6522), 1,
      sym_comment,
  [201907] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    STATE(2457), 1,
      sym_statement_block,
    STATE(6523), 1,
      sym_comment,
  [201923] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2462), 1,
      sym_class_body,
    STATE(6524), 1,
      sym_comment,
  [201939] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3365), 1,
      sym_statement_block,
    STATE(6525), 1,
      sym_comment,
  [201955] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10594), 1,
      sym_identifier,
    ACTIONS(10596), 1,
      sym_private_property_identifier,
    STATE(6526), 1,
      sym_comment,
  [201971] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6527), 1,
      sym_comment,
    ACTIONS(3490), 2,
      anon_sym_else,
      anon_sym_while,
  [201985] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7543), 1,
      anon_sym_LBRACE,
    STATE(1387), 1,
      sym_class_body,
    STATE(6528), 1,
      sym_comment,
  [202001] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6529), 1,
      sym_comment,
    ACTIONS(3488), 2,
      anon_sym_else,
      anon_sym_while,
  [202015] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10598), 1,
      sym_identifier,
    ACTIONS(10600), 1,
      anon_sym_STAR,
    STATE(6530), 1,
      sym_comment,
  [202031] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6531), 1,
      sym_comment,
    ACTIONS(10602), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [202045] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10604), 1,
      sym_identifier,
    ACTIONS(10606), 1,
      sym_private_property_identifier,
    STATE(6532), 1,
      sym_comment,
  [202061] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(6533), 1,
      sym_comment,
    STATE(6746), 1,
      sym__from_clause,
  [202077] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7855), 1,
      anon_sym_LBRACE,
    STATE(415), 1,
      sym_class_body,
    STATE(6534), 1,
      sym_comment,
  [202093] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10608), 1,
      sym_identifier,
    ACTIONS(10610), 1,
      sym_private_property_identifier,
    STATE(6535), 1,
      sym_comment,
  [202109] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6536), 1,
      sym_comment,
    ACTIONS(3486), 2,
      anon_sym_else,
      anon_sym_while,
  [202123] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6537), 1,
      sym_comment,
    ACTIONS(10229), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [202137] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7853), 1,
      anon_sym_LBRACE,
    STATE(1131), 1,
      sym_class_body,
    STATE(6538), 1,
      sym_comment,
  [202153] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6539), 1,
      sym_comment,
    ACTIONS(3536), 2,
      anon_sym_else,
      anon_sym_while,
  [202167] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8780), 1,
      anon_sym_LBRACE,
    STATE(1103), 1,
      sym_statement_block,
    STATE(6540), 1,
      sym_comment,
  [202183] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(3054), 1,
      sym_statement_block,
    STATE(6541), 1,
      sym_comment,
  [202199] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7625), 1,
      anon_sym_LBRACE,
    STATE(6542), 1,
      sym_comment,
    STATE(6956), 1,
      sym_class_body,
  [202215] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10198), 1,
      sym_identifier,
    ACTIONS(10202), 1,
      sym_private_property_identifier,
    STATE(6543), 1,
      sym_comment,
  [202231] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10612), 1,
      sym_identifier,
    ACTIONS(10614), 1,
      sym_private_property_identifier,
    STATE(6544), 1,
      sym_comment,
  [202247] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3021), 1,
      sym_class_body,
    STATE(6545), 1,
      sym_comment,
  [202263] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3072), 1,
      sym_class_body,
    STATE(6546), 1,
      sym_comment,
  [202279] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6547), 1,
      sym_comment,
    ACTIONS(3542), 2,
      anon_sym_else,
      anon_sym_while,
  [202293] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7853), 1,
      anon_sym_LBRACE,
    STATE(1095), 1,
      sym_class_body,
    STATE(6548), 1,
      sym_comment,
  [202309] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6549), 1,
      sym_comment,
    ACTIONS(3374), 2,
      anon_sym_else,
      anon_sym_while,
  [202323] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7649), 1,
      anon_sym_LBRACE,
    STATE(425), 1,
      sym_class_body,
    STATE(6550), 1,
      sym_comment,
  [202339] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6551), 1,
      sym_comment,
    ACTIONS(3452), 2,
      anon_sym_else,
      anon_sym_while,
  [202353] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6552), 1,
      sym_comment,
    ACTIONS(5715), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202367] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3390), 1,
      sym_statement_block,
    STATE(6553), 1,
      sym_comment,
  [202383] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6511), 1,
      sym_statement_block,
    STATE(6554), 1,
      sym_comment,
  [202399] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6555), 1,
      sym_comment,
    ACTIONS(5719), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202413] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10616), 1,
      anon_sym_SEMI,
    ACTIONS(10618), 1,
      sym__automatic_semicolon,
    STATE(6556), 1,
      sym_comment,
  [202429] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6557), 1,
      sym_comment,
    ACTIONS(3448), 2,
      anon_sym_else,
      anon_sym_while,
  [202443] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5636), 1,
      sym__from_clause,
    STATE(6558), 1,
      sym_comment,
  [202459] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(10622), 1,
      anon_sym_from,
    STATE(6559), 1,
      sym_comment,
  [202475] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10624), 1,
      anon_sym_LPAREN,
    STATE(5440), 1,
      sym_parenthesized_expression,
    STATE(6560), 1,
      sym_comment,
  [202491] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10626), 1,
      sym_identifier,
    ACTIONS(10628), 1,
      sym_private_property_identifier,
    STATE(6561), 1,
      sym_comment,
  [202507] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9664), 1,
      sym_identifier,
    ACTIONS(9668), 1,
      sym_private_property_identifier,
    STATE(6562), 1,
      sym_comment,
  [202523] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10630), 1,
      sym_identifier,
    ACTIONS(10632), 1,
      sym_private_property_identifier,
    STATE(6563), 1,
      sym_comment,
  [202539] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10634), 1,
      sym_identifier,
    ACTIONS(10636), 1,
      sym_private_property_identifier,
    STATE(6564), 1,
      sym_comment,
  [202555] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5340), 1,
      sym_formal_parameters,
    STATE(6565), 1,
      sym_comment,
  [202571] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10638), 1,
      anon_sym_LBRACE,
    STATE(6395), 1,
      sym_enum_body,
    STATE(6566), 1,
      sym_comment,
  [202587] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10640), 1,
      sym_identifier,
    ACTIONS(10642), 1,
      sym_private_property_identifier,
    STATE(6567), 1,
      sym_comment,
  [202603] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6568), 1,
      sym_comment,
    ACTIONS(9315), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202617] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6569), 1,
      sym_comment,
    ACTIONS(10644), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202631] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6570), 1,
      sym_comment,
    ACTIONS(3478), 2,
      anon_sym_else,
      anon_sym_while,
  [202645] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3407), 1,
      sym_statement_block,
    STATE(6571), 1,
      sym_comment,
  [202661] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6572), 1,
      sym_comment,
    ACTIONS(3374), 2,
      anon_sym_else,
      anon_sym_while,
  [202675] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6573), 1,
      sym_comment,
    ACTIONS(3376), 2,
      anon_sym_else,
      anon_sym_while,
  [202689] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3361), 1,
      sym_statement_block,
    STATE(6574), 1,
      sym_comment,
  [202705] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10646), 1,
      sym_identifier,
    ACTIONS(10648), 1,
      sym_private_property_identifier,
    STATE(6575), 1,
      sym_comment,
  [202721] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6576), 1,
      sym_comment,
    ACTIONS(3456), 2,
      anon_sym_else,
      anon_sym_while,
  [202735] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10650), 1,
      sym_identifier,
    ACTIONS(10652), 1,
      sym_private_property_identifier,
    STATE(6577), 1,
      sym_comment,
  [202751] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10654), 1,
      anon_sym_LBRACE,
    STATE(1446), 1,
      sym_switch_body,
    STATE(6578), 1,
      sym_comment,
  [202767] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(2994), 1,
      sym_class_body,
    STATE(6579), 1,
      sym_comment,
  [202783] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10432), 1,
      anon_sym_LBRACE,
    STATE(1117), 1,
      sym_statement_block,
    STATE(6580), 1,
      sym_comment,
  [202799] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10656), 1,
      anon_sym_LPAREN,
    STATE(919), 1,
      sym_parenthesized_expression,
    STATE(6581), 1,
      sym_comment,
  [202815] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10658), 1,
      anon_sym_LPAREN,
    STATE(117), 1,
      sym__for_header,
    STATE(6582), 1,
      sym_comment,
  [202831] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10660), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_enum_body,
    STATE(6583), 1,
      sym_comment,
  [202847] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6584), 1,
      sym_comment,
    ACTIONS(3476), 2,
      anon_sym_else,
      anon_sym_while,
  [202861] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10662), 1,
      sym_identifier,
    ACTIONS(10664), 1,
      sym_private_property_identifier,
    STATE(6585), 1,
      sym_comment,
  [202877] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8733), 1,
      anon_sym_LBRACE,
    STATE(360), 1,
      sym_statement_block,
    STATE(6586), 1,
      sym_comment,
  [202893] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7845), 1,
      anon_sym_LBRACE,
    STATE(1412), 1,
      sym_class_body,
    STATE(6587), 1,
      sym_comment,
  [202909] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6588), 1,
      sym_comment,
    ACTIONS(3388), 2,
      anon_sym_else,
      anon_sym_while,
  [202923] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6589), 1,
      sym_comment,
    ACTIONS(10666), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [202937] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6590), 1,
      sym_comment,
    ACTIONS(10668), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202951] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10670), 1,
      sym_identifier,
    ACTIONS(10672), 1,
      sym_private_property_identifier,
    STATE(6591), 1,
      sym_comment,
  [202967] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3047), 1,
      sym_class_body,
    STATE(6592), 1,
      sym_comment,
  [202983] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3360), 1,
      sym_statement_block,
    STATE(6593), 1,
      sym_comment,
  [202999] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10674), 1,
      anon_sym_SEMI,
    ACTIONS(10676), 1,
      sym__automatic_semicolon,
    STATE(6594), 1,
      sym_comment,
  [203015] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7625), 1,
      anon_sym_LBRACE,
    STATE(6595), 1,
      sym_comment,
    STATE(6989), 1,
      sym_class_body,
  [203031] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10678), 1,
      anon_sym_SEMI,
    ACTIONS(10680), 1,
      sym__automatic_semicolon,
    STATE(6596), 1,
      sym_comment,
  [203047] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6597), 1,
      sym_comment,
    ACTIONS(9163), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203061] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6598), 1,
      sym_comment,
    ACTIONS(10682), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203075] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(5936), 1,
      sym_class_body,
    STATE(6599), 1,
      sym_comment,
  [203091] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6600), 1,
      sym_comment,
    ACTIONS(10684), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203105] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6601), 1,
      sym_comment,
    ACTIONS(5535), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203119] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3394), 1,
      sym_statement_block,
    STATE(6602), 1,
      sym_comment,
  [203135] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3384), 1,
      sym_statement_block,
    STATE(6603), 1,
      sym_comment,
  [203151] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6604), 1,
      sym_comment,
    ACTIONS(5517), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203165] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10686), 1,
      anon_sym_SEMI,
    ACTIONS(10688), 1,
      sym__automatic_semicolon,
    STATE(6605), 1,
      sym_comment,
  [203181] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6606), 1,
      sym_comment,
    ACTIONS(3400), 2,
      anon_sym_else,
      anon_sym_while,
  [203195] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6607), 1,
      sym_comment,
    ACTIONS(3400), 2,
      anon_sym_else,
      anon_sym_while,
  [203209] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7855), 1,
      anon_sym_LBRACE,
    STATE(376), 1,
      sym_class_body,
    STATE(6608), 1,
      sym_comment,
  [203225] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10690), 1,
      anon_sym_SEMI,
    ACTIONS(10692), 1,
      sym__automatic_semicolon,
    STATE(6609), 1,
      sym_comment,
  [203241] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7605), 1,
      anon_sym_LBRACE,
    STATE(1453), 1,
      sym_class_body,
    STATE(6610), 1,
      sym_comment,
  [203257] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7845), 1,
      anon_sym_LBRACE,
    STATE(1440), 1,
      sym_class_body,
    STATE(6611), 1,
      sym_comment,
  [203273] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6612), 1,
      sym_comment,
    ACTIONS(5785), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203287] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8780), 1,
      anon_sym_LBRACE,
    STATE(995), 1,
      sym_statement_block,
    STATE(6613), 1,
      sym_comment,
  [203303] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10694), 1,
      anon_sym_SEMI,
    ACTIONS(10696), 1,
      sym__automatic_semicolon,
    STATE(6614), 1,
      sym_comment,
  [203319] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6615), 1,
      sym_comment,
    ACTIONS(3466), 2,
      anon_sym_else,
      anon_sym_while,
  [203333] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10698), 1,
      sym_identifier,
    ACTIONS(10700), 1,
      sym_private_property_identifier,
    STATE(6616), 1,
      sym_comment,
  [203349] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10160), 1,
      sym_identifier,
    ACTIONS(10164), 1,
      sym_private_property_identifier,
    STATE(6617), 1,
      sym_comment,
  [203365] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6618), 1,
      sym_comment,
    ACTIONS(10158), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [203379] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10702), 1,
      sym_identifier,
    ACTIONS(10704), 1,
      sym_private_property_identifier,
    STATE(6619), 1,
      sym_comment,
  [203395] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10638), 1,
      anon_sym_LBRACE,
    STATE(6620), 1,
      sym_comment,
    STATE(6845), 1,
      sym_enum_body,
  [203411] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3397), 1,
      sym_statement_block,
    STATE(6621), 1,
      sym_comment,
  [203427] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6622), 1,
      sym_comment,
    ACTIONS(3414), 2,
      anon_sym_else,
      anon_sym_while,
  [203441] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6623), 1,
      sym_comment,
    STATE(6836), 1,
      sym_statement_block,
  [203457] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10706), 1,
      sym_identifier,
    ACTIONS(10708), 1,
      sym_private_property_identifier,
    STATE(6624), 1,
      sym_comment,
  [203473] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6625), 1,
      sym_comment,
    ACTIONS(10710), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [203487] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6626), 1,
      sym_comment,
    ACTIONS(3420), 2,
      anon_sym_else,
      anon_sym_while,
  [203501] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10712), 1,
      anon_sym_SEMI,
    ACTIONS(10714), 1,
      sym__automatic_semicolon,
    STATE(6627), 1,
      sym_comment,
  [203517] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    STATE(2565), 1,
      sym_statement_block,
    STATE(6628), 1,
      sym_comment,
  [203533] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    STATE(6629), 1,
      sym_comment,
    STATE(6656), 1,
      sym_type_annotation,
  [203549] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10660), 1,
      anon_sym_LBRACE,
    STATE(1342), 1,
      sym_enum_body,
    STATE(6630), 1,
      sym_comment,
  [203565] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7853), 1,
      anon_sym_LBRACE,
    STATE(997), 1,
      sym_class_body,
    STATE(6631), 1,
      sym_comment,
  [203581] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6632), 1,
      sym_comment,
    ACTIONS(3426), 2,
      anon_sym_else,
      anon_sym_while,
  [203595] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6633), 1,
      sym_comment,
    ACTIONS(3430), 2,
      anon_sym_else,
      anon_sym_while,
  [203609] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9569), 1,
      anon_sym_LBRACE,
    STATE(998), 1,
      sym_statement_block,
    STATE(6634), 1,
      sym_comment,
  [203625] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6635), 1,
      sym_comment,
    ACTIONS(3460), 2,
      anon_sym_else,
      anon_sym_while,
  [203639] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6636), 1,
      sym_comment,
    ACTIONS(10716), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [203653] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8755), 1,
      anon_sym_LBRACE,
    STATE(449), 1,
      sym_statement_block,
    STATE(6637), 1,
      sym_comment,
  [203669] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10718), 1,
      anon_sym_LBRACE,
    STATE(1333), 1,
      sym_statement_block,
    STATE(6638), 1,
      sym_comment,
  [203685] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(3105), 1,
      sym_statement_block,
    STATE(6639), 1,
      sym_comment,
  [203701] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6640), 1,
      sym_comment,
    ACTIONS(3436), 2,
      anon_sym_else,
      anon_sym_while,
  [203715] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(2998), 1,
      sym_class_body,
    STATE(6641), 1,
      sym_comment,
  [203731] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2566), 1,
      sym_class_body,
    STATE(6642), 1,
      sym_comment,
  [203747] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(3008), 1,
      sym_statement_block,
    STATE(6643), 1,
      sym_comment,
  [203763] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6644), 1,
      sym_comment,
    ACTIONS(3432), 2,
      anon_sym_else,
      anon_sym_while,
  [203777] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6645), 1,
      sym_comment,
    ACTIONS(5500), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203791] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3410), 1,
      sym_statement_block,
    STATE(6646), 1,
      sym_comment,
  [203807] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6647), 1,
      sym_comment,
    ACTIONS(3458), 2,
      anon_sym_else,
      anon_sym_while,
  [203821] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(115), 1,
      sym_parenthesized_expression,
    STATE(6648), 1,
      sym_comment,
  [203837] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10400), 1,
      anon_sym_LPAREN,
    STATE(6649), 1,
      sym_comment,
    STATE(6707), 1,
      sym_parenthesized_expression,
  [203853] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6650), 1,
      sym_comment,
    ACTIONS(3428), 2,
      anon_sym_else,
      anon_sym_while,
  [203867] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6651), 1,
      sym_comment,
    ACTIONS(3424), 2,
      anon_sym_else,
      anon_sym_while,
  [203881] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6652), 1,
      sym_comment,
    ACTIONS(3458), 2,
      anon_sym_else,
      anon_sym_while,
  [203895] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7845), 1,
      anon_sym_LBRACE,
    STATE(1411), 1,
      sym_class_body,
    STATE(6653), 1,
      sym_comment,
  [203911] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9569), 1,
      anon_sym_LBRACE,
    STATE(1013), 1,
      sym_statement_block,
    STATE(6654), 1,
      sym_comment,
  [203927] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10720), 1,
      anon_sym_LBRACE,
    STATE(1572), 1,
      sym_statement_block,
    STATE(6655), 1,
      sym_comment,
  [203943] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6656), 1,
      sym_comment,
    ACTIONS(10722), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [203957] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    STATE(2397), 1,
      sym_statement_block,
    STATE(6657), 1,
      sym_comment,
  [203973] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6658), 1,
      sym_comment,
    ACTIONS(10724), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [203987] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6659), 1,
      sym_comment,
    ACTIONS(10726), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [204001] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6660), 1,
      sym_comment,
    STATE(7233), 1,
      sym_formal_parameters,
  [204017] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6661), 1,
      sym_comment,
    ACTIONS(10728), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204031] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6662), 1,
      sym_comment,
    ACTIONS(5662), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204045] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10730), 1,
      anon_sym_LBRACE,
    STATE(1565), 1,
      sym_enum_body,
    STATE(6663), 1,
      sym_comment,
  [204061] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(6596), 1,
      sym__from_clause,
    STATE(6664), 1,
      sym_comment,
  [204077] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10732), 1,
      sym_identifier,
    ACTIONS(10734), 1,
      sym_private_property_identifier,
    STATE(6665), 1,
      sym_comment,
  [204093] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6666), 1,
      sym_comment,
    ACTIONS(8599), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [204107] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9730), 1,
      sym_identifier,
    ACTIONS(9734), 1,
      sym_private_property_identifier,
    STATE(6667), 1,
      sym_comment,
  [204123] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4218), 1,
      anon_sym_COLON,
    STATE(6658), 1,
      sym_type_annotation,
    STATE(6668), 1,
      sym_comment,
  [204139] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6669), 1,
      sym_comment,
    ACTIONS(3470), 2,
      anon_sym_else,
      anon_sym_while,
  [204153] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10736), 1,
      sym_identifier,
    ACTIONS(10738), 1,
      anon_sym_STAR,
    STATE(6670), 1,
      sym_comment,
  [204169] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(6671), 1,
      sym_comment,
    ACTIONS(10740), 2,
      sym__glimmer_template_content,
      anon_sym_LT_SLASHtemplate_GT,
  [204183] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6672), 1,
      sym_comment,
    STATE(6701), 1,
      sym_statement_block,
  [204199] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(2404), 1,
      sym_class_body,
    STATE(6673), 1,
      sym_comment,
  [204215] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(5934), 1,
      sym_statement_block,
    STATE(6674), 1,
      sym_comment,
  [204231] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6675), 1,
      sym_comment,
    ACTIONS(6729), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204245] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5504), 1,
      sym__from_clause,
    STATE(6676), 1,
      sym_comment,
  [204261] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6677), 1,
      sym_comment,
    ACTIONS(6725), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204275] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6678), 1,
      sym_comment,
    ACTIONS(8494), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [204289] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6679), 1,
      sym_comment,
    STATE(6861), 1,
      sym_statement_block,
  [204305] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6680), 1,
      sym_comment,
    ACTIONS(6770), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204319] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6681), 1,
      sym_comment,
    ACTIONS(6721), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204333] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6682), 1,
      sym_comment,
    ACTIONS(6725), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204347] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6683), 1,
      sym_comment,
    ACTIONS(10742), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204361] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6684), 1,
      sym_comment,
    ACTIONS(3510), 2,
      anon_sym_else,
      anon_sym_while,
  [204375] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6685), 1,
      sym_comment,
    ACTIONS(3384), 2,
      anon_sym_else,
      anon_sym_while,
  [204389] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6686), 1,
      sym_comment,
    ACTIONS(10744), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204403] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10746), 1,
      sym_identifier,
    ACTIONS(10748), 1,
      anon_sym_STAR,
    STATE(6687), 1,
      sym_comment,
  [204419] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7649), 1,
      anon_sym_LBRACE,
    STATE(435), 1,
      sym_class_body,
    STATE(6688), 1,
      sym_comment,
  [204435] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6689), 1,
      sym_comment,
    ACTIONS(5789), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204449] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6690), 1,
      sym_comment,
    ACTIONS(9755), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [204463] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6691), 1,
      sym_comment,
    ACTIONS(3422), 2,
      anon_sym_else,
      anon_sym_while,
  [204477] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6692), 1,
      sym_comment,
    ACTIONS(3418), 2,
      anon_sym_else,
      anon_sym_while,
  [204491] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6693), 1,
      sym_comment,
    ACTIONS(5787), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204505] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10750), 1,
      anon_sym_SEMI,
    ACTIONS(10752), 1,
      sym__automatic_semicolon,
    STATE(6694), 1,
      sym_comment,
  [204521] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6695), 1,
      sym_comment,
    ACTIONS(10754), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204535] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10756), 1,
      anon_sym_LBRACE,
    STATE(3429), 1,
      sym_statement_block,
    STATE(6696), 1,
      sym_comment,
  [204551] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6697), 1,
      sym_comment,
    ACTIONS(6737), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204565] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3396), 1,
      sym_statement_block,
    STATE(6698), 1,
      sym_comment,
  [204581] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6699), 1,
      sym_comment,
    ACTIONS(10758), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204595] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6700), 1,
      sym_comment,
    ACTIONS(3416), 2,
      anon_sym_else,
      anon_sym_while,
  [204609] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6701), 1,
      sym_comment,
    ACTIONS(6752), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204623] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(87), 1,
      sym_parenthesized_expression,
    STATE(6702), 1,
      sym_comment,
  [204639] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10658), 1,
      anon_sym_LPAREN,
    STATE(102), 1,
      sym__for_header,
    STATE(6703), 1,
      sym_comment,
  [204655] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3408), 1,
      sym_statement_block,
    STATE(6704), 1,
      sym_comment,
  [204671] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10658), 1,
      anon_sym_LPAREN,
    STATE(121), 1,
      sym__for_header,
    STATE(6705), 1,
      sym_comment,
  [204687] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(3283), 1,
      sym_class_body,
    STATE(6706), 1,
      sym_comment,
  [204703] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10760), 1,
      anon_sym_LBRACE,
    STATE(6700), 1,
      sym_switch_body,
    STATE(6707), 1,
      sym_comment,
  [204719] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6708), 1,
      sym_comment,
    ACTIONS(3410), 2,
      anon_sym_else,
      anon_sym_while,
  [204733] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10762), 1,
      anon_sym_LBRACE,
    STATE(1224), 1,
      sym_switch_body,
    STATE(6709), 1,
      sym_comment,
  [204749] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6710), 1,
      sym_comment,
    ACTIONS(5570), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204763] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6711), 1,
      sym_comment,
    ACTIONS(3402), 2,
      anon_sym_else,
      anon_sym_while,
  [204777] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6712), 1,
      sym_comment,
    STATE(7162), 1,
      sym_formal_parameters,
  [204793] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6713), 1,
      sym_comment,
    ACTIONS(10764), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [204807] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6714), 1,
      sym_comment,
    ACTIONS(6721), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204821] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6715), 1,
      sym_comment,
    ACTIONS(5568), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204835] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6716), 1,
      sym_comment,
    ACTIONS(6717), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204849] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6682), 1,
      sym_statement_block,
    STATE(6717), 1,
      sym_comment,
  [204865] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6718), 1,
      sym_comment,
    ACTIONS(10766), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204879] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5467), 1,
      sym__from_clause,
    STATE(6719), 1,
      sym_comment,
  [204895] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6720), 1,
      sym_comment,
    ACTIONS(10768), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204909] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6721), 1,
      sym_comment,
    ACTIONS(10770), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [204923] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3363), 1,
      sym_statement_block,
    STATE(6722), 1,
      sym_comment,
  [204939] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(105), 1,
      sym_parenthesized_expression,
    STATE(6723), 1,
      sym_comment,
  [204955] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6724), 1,
      sym_comment,
    ACTIONS(6770), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204969] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10772), 1,
      sym_identifier,
    ACTIONS(10774), 1,
      anon_sym_STAR,
    STATE(6725), 1,
      sym_comment,
  [204985] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6726), 1,
      sym_comment,
    STATE(7427), 1,
      sym_formal_parameters,
  [205001] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6727), 1,
      sym_comment,
    ACTIONS(10109), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [205015] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6675), 1,
      sym_statement_block,
    STATE(6728), 1,
      sym_comment,
  [205031] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10658), 1,
      anon_sym_LPAREN,
    STATE(98), 1,
      sym__for_header,
    STATE(6729), 1,
      sym_comment,
  [205047] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10776), 1,
      anon_sym_LBRACE,
    STATE(974), 1,
      sym_switch_body,
    STATE(6730), 1,
      sym_comment,
  [205063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6731), 1,
      sym_comment,
    ACTIONS(3532), 2,
      anon_sym_else,
      anon_sym_while,
  [205077] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7169), 1,
      anon_sym_LPAREN,
    STATE(4239), 1,
      sym_formal_parameters,
    STATE(6732), 1,
      sym_comment,
  [205093] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6733), 1,
      sym_comment,
    ACTIONS(3408), 2,
      anon_sym_else,
      anon_sym_while,
  [205107] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6734), 1,
      sym_comment,
    ACTIONS(3480), 2,
      anon_sym_else,
      anon_sym_while,
  [205121] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6735), 1,
      sym_comment,
    ACTIONS(3482), 2,
      anon_sym_else,
      anon_sym_while,
  [205135] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6736), 1,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_else,
      anon_sym_while,
  [205149] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6737), 1,
      sym_comment,
    ACTIONS(5736), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205163] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(119), 1,
      sym_parenthesized_expression,
    STATE(6738), 1,
      sym_comment,
  [205179] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10778), 1,
      anon_sym_LBRACE,
    STATE(881), 1,
      sym_statement_block,
    STATE(6739), 1,
      sym_comment,
  [205195] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5329), 1,
      sym_formal_parameters,
    STATE(6740), 1,
      sym_comment,
  [205211] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10780), 1,
      sym_identifier,
    STATE(6285), 1,
      sym_nested_identifier,
    STATE(6741), 1,
      sym_comment,
  [205227] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6742), 1,
      sym_comment,
    ACTIONS(10782), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205241] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10784), 1,
      sym_identifier,
    STATE(6308), 1,
      sym_nested_identifier,
    STATE(6743), 1,
      sym_comment,
  [205257] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6744), 1,
      sym_comment,
    ACTIONS(3398), 2,
      anon_sym_else,
      anon_sym_while,
  [205271] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6745), 1,
      sym_comment,
    ACTIONS(3390), 2,
      anon_sym_else,
      anon_sym_while,
  [205285] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10786), 1,
      anon_sym_SEMI,
    ACTIONS(10788), 1,
      sym__automatic_semicolon,
    STATE(6746), 1,
      sym_comment,
  [205301] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10790), 1,
      anon_sym_SEMI,
    ACTIONS(10792), 1,
      sym__automatic_semicolon,
    STATE(6747), 1,
      sym_comment,
  [205317] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6748), 1,
      sym_comment,
    ACTIONS(6713), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205331] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6749), 1,
      sym_comment,
    ACTIONS(10794), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [205345] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7625), 1,
      anon_sym_LBRACE,
    STATE(6750), 1,
      sym_comment,
    STATE(6841), 1,
      sym_class_body,
  [205361] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3402), 1,
      sym_statement_block,
    STATE(6751), 1,
      sym_comment,
  [205377] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6752), 1,
      sym_comment,
    ACTIONS(5533), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205391] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(6383), 1,
      sym__from_clause,
    STATE(6753), 1,
      sym_comment,
  [205407] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3398), 1,
      sym_statement_block,
    STATE(6754), 1,
      sym_comment,
  [205423] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6755), 1,
      sym_comment,
    ACTIONS(5668), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205437] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6756), 1,
      sym_comment,
    STATE(7325), 1,
      sym_formal_parameters,
  [205453] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6757), 1,
      sym_comment,
    ACTIONS(10796), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205467] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7605), 1,
      anon_sym_LBRACE,
    STATE(1455), 1,
      sym_class_body,
    STATE(6758), 1,
      sym_comment,
  [205483] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6759), 1,
      sym_comment,
    ACTIONS(10798), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205497] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10800), 1,
      anon_sym_SEMI,
    ACTIONS(10802), 1,
      sym__automatic_semicolon,
    STATE(6760), 1,
      sym_comment,
  [205513] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(5864), 1,
      sym_statement_block,
    STATE(6761), 1,
      sym_comment,
  [205529] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5379), 1,
      sym_formal_parameters,
    STATE(6762), 1,
      sym_comment,
  [205545] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6763), 1,
      sym_comment,
    ACTIONS(6717), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205559] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6764), 1,
      sym_comment,
    ACTIONS(10804), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205573] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6765), 1,
      sym_comment,
    ACTIONS(3382), 2,
      anon_sym_else,
      anon_sym_while,
  [205587] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6766), 1,
      sym_comment,
    ACTIONS(3380), 2,
      anon_sym_else,
      anon_sym_while,
  [205601] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6714), 1,
      sym_statement_block,
    STATE(6767), 1,
      sym_comment,
  [205617] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6768), 1,
      sym_comment,
    ACTIONS(6737), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205631] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7197), 1,
      anon_sym_LPAREN,
    STATE(4051), 1,
      sym_formal_parameters,
    STATE(6769), 1,
      sym_comment,
  [205647] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7605), 1,
      anon_sym_LBRACE,
    STATE(1519), 1,
      sym_class_body,
    STATE(6770), 1,
      sym_comment,
  [205663] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(4624), 1,
      sym_statement_block,
    STATE(6771), 1,
      sym_comment,
  [205679] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6772), 1,
      sym_comment,
    STATE(7155), 1,
      sym_formal_parameters,
  [205695] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6773), 1,
      sym_comment,
    ACTIONS(5606), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205709] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(122), 1,
      sym_parenthesized_expression,
    STATE(6774), 1,
      sym_comment,
  [205725] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6775), 1,
      sym_comment,
    ACTIONS(9845), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205739] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6776), 1,
      sym_comment,
    STATE(7459), 1,
      sym_formal_parameters,
  [205755] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10806), 1,
      anon_sym_LBRACE,
    STATE(1356), 1,
      sym_switch_body,
    STATE(6777), 1,
      sym_comment,
  [205771] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6778), 1,
      sym_comment,
    ACTIONS(10808), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205785] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10658), 1,
      anon_sym_LPAREN,
    STATE(91), 1,
      sym__for_header,
    STATE(6779), 1,
      sym_comment,
  [205801] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3364), 1,
      sym_statement_block,
    STATE(6780), 1,
      sym_comment,
  [205817] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6781), 1,
      sym_comment,
    STATE(7406), 1,
      sym_formal_parameters,
  [205833] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6782), 1,
      sym_comment,
    ACTIONS(10810), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205847] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6783), 1,
      sym_comment,
    ACTIONS(10812), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205861] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6784), 1,
      sym_comment,
    ACTIONS(10814), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205875] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(84), 1,
      sym_parenthesized_expression,
    STATE(6785), 1,
      sym_comment,
  [205891] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10816), 1,
      anon_sym_LBRACE,
    STATE(867), 1,
      sym_statement_block,
    STATE(6786), 1,
      sym_comment,
  [205907] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10818), 1,
      anon_sym_in,
    ACTIONS(10820), 1,
      anon_sym_COLON,
    STATE(6787), 1,
      sym_comment,
  [205923] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6788), 1,
      sym_comment,
    ACTIONS(10822), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205937] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(75), 1,
      sym_parenthesized_expression,
    STATE(6789), 1,
      sym_comment,
  [205953] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3399), 1,
      sym_statement_block,
    STATE(6790), 1,
      sym_comment,
  [205969] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3415), 1,
      sym_statement_block,
    STATE(6791), 1,
      sym_comment,
  [205985] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(3044), 1,
      sym_statement_block,
    STATE(6792), 1,
      sym_comment,
  [206001] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10824), 1,
      sym_identifier,
    STATE(6236), 1,
      sym_nested_identifier,
    STATE(6793), 1,
      sym_comment,
  [206017] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(81), 1,
      sym_parenthesized_expression,
    STATE(6794), 1,
      sym_comment,
  [206033] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6795), 1,
      sym_comment,
    ACTIONS(10826), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [206047] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6796), 1,
      sym_comment,
    ACTIONS(3440), 2,
      anon_sym_else,
      anon_sym_while,
  [206061] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3373), 1,
      sym_statement_block,
    STATE(6797), 1,
      sym_comment,
  [206077] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3042), 1,
      sym_class_body,
    STATE(6798), 1,
      sym_comment,
  [206093] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6799), 1,
      sym_comment,
    ACTIONS(6709), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [206107] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6503), 1,
      sym_statement_block,
    STATE(6800), 1,
      sym_comment,
  [206123] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6801), 1,
      sym_comment,
    ACTIONS(3440), 2,
      anon_sym_else,
      anon_sym_while,
  [206137] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6802), 1,
      sym_comment,
    ACTIONS(10027), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [206151] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3368), 1,
      sym_statement_block,
    STATE(6803), 1,
      sym_comment,
  [206167] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3369), 1,
      sym_statement_block,
    STATE(6804), 1,
      sym_comment,
  [206183] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3367), 1,
      sym_statement_block,
    STATE(6805), 1,
      sym_comment,
  [206199] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6806), 1,
      sym_comment,
    ACTIONS(3446), 2,
      anon_sym_else,
      anon_sym_while,
  [206213] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3391), 1,
      sym_statement_block,
    STATE(6807), 1,
      sym_comment,
  [206229] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5630), 1,
      sym__from_clause,
    STATE(6808), 1,
      sym_comment,
  [206245] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6809), 1,
      sym_comment,
    ACTIONS(10828), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [206259] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6810), 1,
      sym_comment,
    STATE(7373), 1,
      sym_formal_parameters,
  [206275] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3385), 1,
      sym_statement_block,
    STATE(6811), 1,
      sym_comment,
  [206291] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6812), 1,
      sym_comment,
    ACTIONS(8412), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [206305] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6813), 1,
      sym_comment,
    ACTIONS(5638), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [206319] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6724), 1,
      sym_statement_block,
    STATE(6814), 1,
      sym_comment,
  [206335] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6815), 1,
      sym_comment,
    ACTIONS(5636), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [206349] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5444), 1,
      sym__from_clause,
    STATE(6816), 1,
      sym_comment,
  [206365] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6817), 1,
      sym_comment,
    ACTIONS(3378), 2,
      anon_sym_else,
      anon_sym_while,
  [206379] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7543), 1,
      anon_sym_LBRACE,
    STATE(1166), 1,
      sym_class_body,
    STATE(6818), 1,
      sym_comment,
  [206395] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10830), 1,
      sym_identifier,
    STATE(5641), 1,
      sym_nested_identifier,
    STATE(6819), 1,
      sym_comment,
  [206411] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6820), 1,
      sym_comment,
    ACTIONS(9850), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [206425] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5433), 1,
      sym__from_clause,
    STATE(6821), 1,
      sym_comment,
  [206441] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(6614), 1,
      sym__from_clause,
    STATE(6822), 1,
      sym_comment,
  [206457] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6823), 1,
      sym_comment,
    ACTIONS(3450), 2,
      anon_sym_else,
      anon_sym_while,
  [206471] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9896), 1,
      anon_sym_LBRACE,
    STATE(1084), 1,
      sym_statement_block,
    STATE(6824), 1,
      sym_comment,
  [206487] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6825), 1,
      sym_comment,
    ACTIONS(10832), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [206501] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10834), 1,
      anon_sym_SEMI,
    ACTIONS(10836), 1,
      sym__automatic_semicolon,
    STATE(6826), 1,
      sym_comment,
  [206517] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(5159), 1,
      sym_class_body,
    STATE(6827), 1,
      sym_comment,
  [206533] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9912), 1,
      anon_sym_LBRACE,
    STATE(1330), 1,
      sym_statement_block,
    STATE(6828), 1,
      sym_comment,
  [206549] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9912), 1,
      anon_sym_LBRACE,
    STATE(1177), 1,
      sym_statement_block,
    STATE(6829), 1,
      sym_comment,
  [206565] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3388), 1,
      sym_statement_block,
    STATE(6830), 1,
      sym_comment,
  [206581] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(3028), 1,
      sym_class_body,
    STATE(6831), 1,
      sym_comment,
  [206597] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6832), 1,
      sym_comment,
    ACTIONS(3554), 2,
      anon_sym_else,
      anon_sym_while,
  [206611] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6833), 1,
      sym_comment,
    ACTIONS(8396), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [206625] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6834), 1,
      sym_comment,
    ACTIONS(8398), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [206639] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    STATE(5938), 1,
      sym_statement_block,
    STATE(6835), 1,
      sym_comment,
  [206655] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6836), 1,
      sym_comment,
    ACTIONS(3462), 2,
      anon_sym_else,
      anon_sym_while,
  [206669] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8755), 1,
      anon_sym_LBRACE,
    STATE(438), 1,
      sym_statement_block,
    STATE(6837), 1,
      sym_comment,
  [206685] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6838), 1,
      sym_comment,
    ACTIONS(3464), 2,
      anon_sym_else,
      anon_sym_while,
  [206699] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6839), 1,
      sym_comment,
    ACTIONS(2127), 2,
      anon_sym_else,
      anon_sym_while,
  [206713] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10400), 1,
      anon_sym_LPAREN,
    STATE(6730), 1,
      sym_parenthesized_expression,
    STATE(6840), 1,
      sym_comment,
  [206729] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6841), 1,
      sym_comment,
    ACTIONS(3548), 2,
      anon_sym_else,
      anon_sym_while,
  [206743] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8826), 1,
      anon_sym_DOT,
    ACTIONS(10838), 1,
      anon_sym_GT,
    STATE(6842), 1,
      sym_comment,
  [206759] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6843), 1,
      sym_comment,
    ACTIONS(3562), 2,
      anon_sym_else,
      anon_sym_while,
  [206773] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6844), 1,
      sym_comment,
    ACTIONS(3564), 2,
      anon_sym_else,
      anon_sym_while,
  [206787] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6845), 1,
      sym_comment,
    ACTIONS(3472), 2,
      anon_sym_else,
      anon_sym_while,
  [206801] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9611), 1,
      anon_sym_COLON,
    ACTIONS(10004), 1,
      anon_sym_GT,
    STATE(6846), 1,
      sym_comment,
  [206817] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    STATE(5296), 1,
      sym_statement_block,
    STATE(6847), 1,
      sym_comment,
  [206833] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6848), 1,
      sym_comment,
    ACTIONS(3566), 2,
      anon_sym_else,
      anon_sym_while,
  [206847] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6849), 1,
      sym_comment,
    ACTIONS(3444), 2,
      anon_sym_else,
      anon_sym_while,
  [206861] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10840), 1,
      anon_sym_LBRACE,
    STATE(5241), 1,
      sym_enum_body,
    STATE(6850), 1,
      sym_comment,
  [206877] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5605), 1,
      sym__from_clause,
    STATE(6851), 1,
      sym_comment,
  [206893] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7553), 1,
      anon_sym_LBRACE,
    STATE(3300), 1,
      sym_class_body,
    STATE(6852), 1,
      sym_comment,
  [206909] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10842), 1,
      anon_sym_SEMI,
    ACTIONS(10844), 1,
      sym__automatic_semicolon,
    STATE(6853), 1,
      sym_comment,
  [206925] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5394), 1,
      anon_sym_LPAREN,
    STATE(3036), 1,
      sym_arguments,
    STATE(6854), 1,
      sym_comment,
  [206941] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6855), 1,
      sym_comment,
    ACTIONS(3568), 2,
      anon_sym_else,
      anon_sym_while,
  [206955] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(5182), 1,
      sym_formal_parameters,
    STATE(6856), 1,
      sym_comment,
  [206971] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6857), 1,
      sym_comment,
    STATE(7086), 1,
      sym_formal_parameters,
  [206987] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9027), 1,
      anon_sym_in,
    ACTIONS(9029), 1,
      anon_sym_of,
    STATE(6858), 1,
      sym_comment,
  [207003] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6859), 1,
      sym_comment,
    ACTIONS(10846), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207017] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6860), 1,
      sym_comment,
    ACTIONS(3510), 2,
      anon_sym_else,
      anon_sym_while,
  [207031] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6861), 1,
      sym_comment,
    ACTIONS(6764), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207045] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6748), 1,
      sym_statement_block,
    STATE(6862), 1,
      sym_comment,
  [207061] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6863), 1,
      sym_comment,
    STATE(7049), 1,
      sym_formal_parameters,
  [207077] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9896), 1,
      anon_sym_LBRACE,
    STATE(1058), 1,
      sym_statement_block,
    STATE(6864), 1,
      sym_comment,
  [207093] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(5269), 1,
      sym_class_body,
    STATE(6865), 1,
      sym_comment,
  [207109] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    STATE(5200), 1,
      sym_statement_block,
    STATE(6866), 1,
      sym_comment,
  [207125] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(5281), 1,
      sym_class_body,
    STATE(6867), 1,
      sym_comment,
  [207141] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7735), 1,
      anon_sym_LBRACE,
    STATE(353), 1,
      sym_class_body,
    STATE(6868), 1,
      sym_comment,
  [207157] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7649), 1,
      anon_sym_LBRACE,
    STATE(458), 1,
      sym_class_body,
    STATE(6869), 1,
      sym_comment,
  [207173] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(5359), 1,
      sym_class_body,
    STATE(6870), 1,
      sym_comment,
  [207189] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6871), 1,
      sym_comment,
    ACTIONS(3512), 2,
      anon_sym_else,
      anon_sym_while,
  [207203] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6872), 1,
      sym_comment,
    ACTIONS(3574), 2,
      anon_sym_else,
      anon_sym_while,
  [207217] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8909), 1,
      anon_sym_LBRACE,
    STATE(354), 1,
      sym_statement_block,
    STATE(6873), 1,
      sym_comment,
  [207233] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6874), 1,
      sym_comment,
    ACTIONS(5634), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207247] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10848), 1,
      sym_identifier,
    STATE(5987), 1,
      sym_nested_identifier,
    STATE(6875), 1,
      sym_comment,
  [207263] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6876), 1,
      sym_comment,
    ACTIONS(10850), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207277] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6877), 1,
      sym_comment,
    ACTIONS(2147), 2,
      anon_sym_else,
      anon_sym_while,
  [207291] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7605), 1,
      anon_sym_LBRACE,
    STATE(1498), 1,
      sym_class_body,
    STATE(6878), 1,
      sym_comment,
  [207307] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10852), 1,
      sym_identifier,
    ACTIONS(10854), 1,
      sym_private_property_identifier,
    STATE(6879), 1,
      sym_comment,
  [207323] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6880), 1,
      sym_comment,
    ACTIONS(3516), 2,
      anon_sym_else,
      anon_sym_while,
  [207337] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10856), 1,
      sym_identifier,
    ACTIONS(10858), 1,
      sym_private_property_identifier,
    STATE(6881), 1,
      sym_comment,
  [207353] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10860), 1,
      sym_identifier,
    ACTIONS(10862), 1,
      sym_private_property_identifier,
    STATE(6882), 1,
      sym_comment,
  [207369] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10864), 1,
      sym_identifier,
    ACTIONS(10866), 1,
      sym_private_property_identifier,
    STATE(6883), 1,
      sym_comment,
  [207385] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6884), 1,
      sym_comment,
    STATE(7026), 1,
      sym_formal_parameters,
  [207401] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6885), 1,
      sym_comment,
    ACTIONS(10868), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207415] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6886), 1,
      sym_comment,
    ACTIONS(10870), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [207429] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10872), 1,
      anon_sym_SEMI,
    ACTIONS(10874), 1,
      sym__automatic_semicolon,
    STATE(6887), 1,
      sym_comment,
  [207445] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(5335), 1,
      sym_class_body,
    STATE(6888), 1,
      sym_comment,
  [207461] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6889), 1,
      sym_comment,
    ACTIONS(3524), 2,
      anon_sym_else,
      anon_sym_while,
  [207475] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6890), 1,
      sym_comment,
    ACTIONS(3526), 2,
      anon_sym_else,
      anon_sym_while,
  [207489] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(99), 1,
      sym_parenthesized_expression,
    STATE(6891), 1,
      sym_comment,
  [207505] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10400), 1,
      anon_sym_LPAREN,
    STATE(6709), 1,
      sym_parenthesized_expression,
    STATE(6892), 1,
      sym_comment,
  [207521] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    STATE(5212), 1,
      sym_statement_block,
    STATE(6893), 1,
      sym_comment,
  [207537] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6894), 1,
      sym_comment,
    ACTIONS(3526), 2,
      anon_sym_else,
      anon_sym_while,
  [207551] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(5326), 1,
      sym_class_body,
    STATE(6895), 1,
      sym_comment,
  [207567] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10876), 1,
      anon_sym_SEMI,
    ACTIONS(10878), 1,
      sym__automatic_semicolon,
    STATE(6896), 1,
      sym_comment,
  [207583] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10880), 1,
      anon_sym_SEMI,
    ACTIONS(10882), 1,
      sym__automatic_semicolon,
    STATE(6897), 1,
      sym_comment,
  [207599] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5477), 1,
      sym__from_clause,
    STATE(6898), 1,
      sym_comment,
  [207615] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3375), 1,
      sym_statement_block,
    STATE(6899), 1,
      sym_comment,
  [207631] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7735), 1,
      anon_sym_LBRACE,
    STATE(420), 1,
      sym_class_body,
    STATE(6900), 1,
      sym_comment,
  [207647] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10884), 1,
      anon_sym_LBRACE,
    STATE(883), 1,
      sym_statement_block,
    STATE(6901), 1,
      sym_comment,
  [207663] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6902), 1,
      sym_comment,
    ACTIONS(3528), 2,
      anon_sym_else,
      anon_sym_while,
  [207677] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6903), 1,
      sym_comment,
    ACTIONS(6701), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207691] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3377), 1,
      sym_statement_block,
    STATE(6904), 1,
      sym_comment,
  [207707] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(6375), 1,
      sym__from_clause,
    STATE(6905), 1,
      sym_comment,
  [207723] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6906), 1,
      sym_comment,
    ACTIONS(6741), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207737] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6907), 1,
      sym_comment,
    ACTIONS(10886), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207751] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6514), 1,
      sym_statement_block,
    STATE(6908), 1,
      sym_comment,
  [207767] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(6909), 1,
      sym_comment,
    ACTIONS(4038), 2,
      sym_jsx_identifier,
      sym_identifier,
  [207781] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(92), 1,
      sym_parenthesized_expression,
    STATE(6910), 1,
      sym_comment,
  [207797] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6911), 1,
      sym_comment,
    ACTIONS(10888), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207811] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8786), 1,
      anon_sym_LBRACE,
    STATE(1186), 1,
      sym_statement_block,
    STATE(6912), 1,
      sym_comment,
  [207827] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6913), 1,
      sym_comment,
    ACTIONS(9331), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207841] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6914), 1,
      sym_comment,
    ACTIONS(3544), 2,
      anon_sym_else,
      anon_sym_while,
  [207855] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7543), 1,
      anon_sym_LBRACE,
    STATE(1185), 1,
      sym_class_body,
    STATE(6915), 1,
      sym_comment,
  [207871] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6916), 1,
      sym_comment,
    ACTIONS(3546), 2,
      anon_sym_else,
      anon_sym_while,
  [207885] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(5260), 1,
      sym_class_body,
    STATE(6917), 1,
      sym_comment,
  [207901] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5515), 1,
      sym__from_clause,
    STATE(6918), 1,
      sym_comment,
  [207917] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6919), 1,
      sym_comment,
    ACTIONS(3522), 2,
      anon_sym_else,
      anon_sym_while,
  [207931] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6920), 1,
      sym_comment,
    ACTIONS(6705), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207945] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(2972), 1,
      sym_statement_block,
    STATE(6921), 1,
      sym_comment,
  [207961] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(5607), 1,
      sym__from_clause,
    STATE(6922), 1,
      sym_comment,
  [207977] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3374), 1,
      sym_statement_block,
    STATE(6923), 1,
      sym_comment,
  [207993] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8909), 1,
      anon_sym_LBRACE,
    STATE(386), 1,
      sym_statement_block,
    STATE(6924), 1,
      sym_comment,
  [208009] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(2968), 1,
      sym_statement_block,
    STATE(6925), 1,
      sym_comment,
  [208025] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10890), 1,
      anon_sym_LBRACE,
    STATE(6759), 1,
      sym_object,
    STATE(6926), 1,
      sym_comment,
  [208041] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9121), 1,
      anon_sym_from,
    STATE(6896), 1,
      sym__from_clause,
    STATE(6927), 1,
      sym_comment,
  [208057] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6928), 1,
      sym_comment,
    STATE(7353), 1,
      sym_formal_parameters,
  [208073] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6929), 1,
      sym_comment,
    ACTIONS(6741), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [208087] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(111), 1,
      sym_parenthesized_expression,
    STATE(6930), 1,
      sym_comment,
  [208103] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6931), 1,
      sym_comment,
    ACTIONS(10892), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208117] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10894), 1,
      sym_identifier,
    STATE(5696), 1,
      sym_nested_identifier,
    STATE(6932), 1,
      sym_comment,
  [208133] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10536), 1,
      anon_sym_LBRACE,
    STATE(1349), 1,
      sym_statement_block,
    STATE(6933), 1,
      sym_comment,
  [208149] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10840), 1,
      anon_sym_LBRACE,
    STATE(4880), 1,
      sym_enum_body,
    STATE(6934), 1,
      sym_comment,
  [208165] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3381), 1,
      sym_statement_block,
    STATE(6935), 1,
      sym_comment,
  [208181] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3406), 1,
      sym_statement_block,
    STATE(6936), 1,
      sym_comment,
  [208197] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6937), 1,
      sym_comment,
    STATE(7291), 1,
      sym_formal_parameters,
  [208213] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7735), 1,
      anon_sym_LBRACE,
    STATE(417), 1,
      sym_class_body,
    STATE(6938), 1,
      sym_comment,
  [208229] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6763), 1,
      sym_statement_block,
    STATE(6939), 1,
      sym_comment,
  [208245] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10896), 1,
      anon_sym_SEMI,
    ACTIONS(10898), 1,
      sym__automatic_semicolon,
    STATE(6940), 1,
      sym_comment,
  [208261] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6941), 1,
      sym_comment,
    ACTIONS(10900), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208275] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6942), 1,
      sym_comment,
    STATE(7248), 1,
      sym_formal_parameters,
  [208291] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(2966), 1,
      sym_class_body,
    STATE(6943), 1,
      sym_comment,
  [208307] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10902), 1,
      anon_sym_LPAREN,
    STATE(1143), 1,
      sym_parenthesized_expression,
    STATE(6944), 1,
      sym_comment,
  [208323] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6945), 1,
      sym_comment,
    ACTIONS(9549), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208337] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7193), 1,
      anon_sym_LPAREN,
    STATE(6946), 1,
      sym_comment,
    STATE(7272), 1,
      sym_formal_parameters,
  [208353] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6947), 1,
      sym_comment,
    ACTIONS(10904), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208367] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10400), 1,
      anon_sym_LPAREN,
    STATE(6777), 1,
      sym_parenthesized_expression,
    STATE(6948), 1,
      sym_comment,
  [208383] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      anon_sym_LPAREN,
    STATE(108), 1,
      sym_parenthesized_expression,
    STATE(6949), 1,
      sym_comment,
  [208399] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6950), 1,
      sym_comment,
    ACTIONS(3576), 2,
      anon_sym_else,
      anon_sym_while,
  [208413] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10718), 1,
      anon_sym_LBRACE,
    STATE(1221), 1,
      sym_statement_block,
    STATE(6951), 1,
      sym_comment,
  [208429] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7735), 1,
      anon_sym_LBRACE,
    STATE(387), 1,
      sym_class_body,
    STATE(6952), 1,
      sym_comment,
  [208445] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3404), 1,
      sym_statement_block,
    STATE(6953), 1,
      sym_comment,
  [208461] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6954), 1,
      sym_comment,
    ACTIONS(3578), 2,
      anon_sym_else,
      anon_sym_while,
  [208475] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6955), 1,
      sym_comment,
    ACTIONS(3522), 2,
      anon_sym_else,
      anon_sym_while,
  [208489] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6956), 1,
      sym_comment,
    ACTIONS(3550), 2,
      anon_sym_else,
      anon_sym_while,
  [208503] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6957), 1,
      sym_comment,
    ACTIONS(3522), 2,
      anon_sym_else,
      anon_sym_while,
  [208517] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6958), 1,
      sym_comment,
    ACTIONS(3552), 2,
      anon_sym_else,
      anon_sym_while,
  [208531] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7649), 1,
      anon_sym_LBRACE,
    STATE(437), 1,
      sym_class_body,
    STATE(6959), 1,
      sym_comment,
  [208547] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_LBRACE,
    STATE(5088), 1,
      sym_class_body,
    STATE(6960), 1,
      sym_comment,
  [208563] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6961), 1,
      sym_comment,
    ACTIONS(10906), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208577] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10908), 1,
      anon_sym_SEMI,
    ACTIONS(10910), 1,
      sym__automatic_semicolon,
    STATE(6962), 1,
      sym_comment,
  [208593] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_COLON,
    STATE(6126), 1,
      sym_type_annotation,
    STATE(6963), 1,
      sym_comment,
  [208609] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10912), 1,
      anon_sym_LPAREN,
    STATE(1204), 1,
      sym_parenthesized_expression,
    STATE(6964), 1,
      sym_comment,
  [208625] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6965), 1,
      sym_comment,
    ACTIONS(3522), 2,
      anon_sym_else,
      anon_sym_while,
  [208639] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6966), 1,
      sym_comment,
    ACTIONS(6705), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [208653] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8826), 1,
      anon_sym_DOT,
    ACTIONS(10914), 1,
      anon_sym_GT,
    STATE(6967), 1,
      sym_comment,
  [208669] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6968), 1,
      sym_comment,
    ACTIONS(3556), 2,
      anon_sym_else,
      anon_sym_while,
  [208683] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9611), 1,
      anon_sym_COLON,
    ACTIONS(9924), 1,
      anon_sym_GT,
    STATE(6969), 1,
      sym_comment,
  [208699] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6970), 1,
      sym_comment,
    ACTIONS(3530), 2,
      anon_sym_else,
      anon_sym_while,
  [208713] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6768), 1,
      sym_statement_block,
    STATE(6971), 1,
      sym_comment,
  [208729] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6972), 1,
      sym_comment,
    ACTIONS(9920), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [208743] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10720), 1,
      anon_sym_LBRACE,
    STATE(1548), 1,
      sym_statement_block,
    STATE(6973), 1,
      sym_comment,
  [208759] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4849), 1,
      anon_sym_LBRACE,
    STATE(2933), 1,
      sym_statement_block,
    STATE(6974), 1,
      sym_comment,
  [208775] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(6799), 1,
      sym_statement_block,
    STATE(6975), 1,
      sym_comment,
  [208791] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7589), 1,
      anon_sym_LBRACE,
    STATE(2932), 1,
      sym_class_body,
    STATE(6976), 1,
      sym_comment,
  [208807] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6977), 1,
      sym_comment,
    ACTIONS(3558), 2,
      anon_sym_else,
      anon_sym_while,
  [208821] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6978), 1,
      sym_comment,
    ACTIONS(3534), 2,
      anon_sym_else,
      anon_sym_while,
  [208835] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6979), 1,
      sym_comment,
    ACTIONS(10916), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [208849] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6980), 1,
      sym_comment,
    ACTIONS(3522), 2,
      anon_sym_else,
      anon_sym_while,
  [208863] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6981), 1,
      sym_comment,
    ACTIONS(3522), 2,
      anon_sym_else,
      anon_sym_while,
  [208877] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6982), 1,
      sym_comment,
    ACTIONS(3580), 2,
      anon_sym_else,
      anon_sym_while,
  [208891] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3414), 1,
      sym_statement_block,
    STATE(6983), 1,
      sym_comment,
  [208907] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6984), 1,
      sym_comment,
    ACTIONS(3560), 2,
      anon_sym_else,
      anon_sym_while,
  [208921] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6985), 1,
      sym_comment,
    ACTIONS(3584), 2,
      anon_sym_else,
      anon_sym_while,
  [208935] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10730), 1,
      anon_sym_LBRACE,
    STATE(1464), 1,
      sym_enum_body,
    STATE(6986), 1,
      sym_comment,
  [208951] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3362), 1,
      sym_statement_block,
    STATE(6987), 1,
      sym_comment,
  [208967] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8240), 1,
      anon_sym_LBRACE,
    STATE(3405), 1,
      sym_statement_block,
    STATE(6988), 1,
      sym_comment,
  [208983] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    STATE(6989), 1,
      sym_comment,
    ACTIONS(3582), 2,
      anon_sym_else,
      anon_sym_while,
  [208997] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10918), 1,
      sym_regex_pattern,
    STATE(6990), 1,
      sym_comment,
  [209010] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10920), 1,
      anon_sym_EQ_GT,
    STATE(6991), 1,
      sym_comment,
  [209023] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10922), 1,
      anon_sym_EQ_GT,
    STATE(6992), 1,
      sym_comment,
  [209036] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10924), 1,
      sym_identifier,
    STATE(6993), 1,
      sym_comment,
  [209049] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10926), 1,
      anon_sym_EQ_GT,
    STATE(6994), 1,
      sym_comment,
  [209062] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10928), 1,
      anon_sym_EQ_GT,
    STATE(6995), 1,
      sym_comment,
  [209075] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10930), 1,
      anon_sym_EQ_GT,
    STATE(6996), 1,
      sym_comment,
  [209088] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10932), 1,
      anon_sym_RPAREN,
    STATE(6997), 1,
      sym_comment,
  [209101] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9924), 1,
      anon_sym_GT,
    STATE(6998), 1,
      sym_comment,
  [209114] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10934), 1,
      anon_sym_symbol,
    STATE(6999), 1,
      sym_comment,
  [209127] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10936), 1,
      sym_number,
    STATE(7000), 1,
      sym_comment,
  [209140] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10938), 1,
      anon_sym_EQ_GT,
    STATE(7001), 1,
      sym_comment,
  [209153] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5929), 1,
      anon_sym_RBRACE,
    STATE(7002), 1,
      sym_comment,
  [209166] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10940), 1,
      anon_sym_readonly,
    STATE(7003), 1,
      sym_comment,
  [209179] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10942), 1,
      anon_sym_EQ,
    STATE(7004), 1,
      sym_comment,
  [209192] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10944), 1,
      anon_sym_COLON,
    STATE(7005), 1,
      sym_comment,
  [209205] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10946), 1,
      sym_number,
    STATE(7006), 1,
      sym_comment,
  [209218] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10948), 1,
      anon_sym_from,
    STATE(7007), 1,
      sym_comment,
  [209231] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10950), 1,
      anon_sym_new,
    STATE(7008), 1,
      sym_comment,
  [209244] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10952), 1,
      sym_identifier,
    STATE(7009), 1,
      sym_comment,
  [209257] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10954), 1,
      anon_sym_symbol,
    STATE(7010), 1,
      sym_comment,
  [209270] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10956), 1,
      anon_sym_DOT,
    STATE(7011), 1,
      sym_comment,
  [209283] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10958), 1,
      anon_sym_EQ_GT,
    STATE(7012), 1,
      sym_comment,
  [209296] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10960), 1,
      anon_sym_LBRACE,
    STATE(7013), 1,
      sym_comment,
  [209309] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10962), 1,
      anon_sym_RPAREN,
    STATE(7014), 1,
      sym_comment,
  [209322] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10964), 1,
      sym_regex_pattern,
    STATE(7015), 1,
      sym_comment,
  [209335] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10966), 1,
      sym_identifier,
    STATE(7016), 1,
      sym_comment,
  [209348] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10968), 1,
      sym_identifier,
    STATE(7017), 1,
      sym_comment,
  [209361] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10970), 1,
      anon_sym_RPAREN,
    STATE(7018), 1,
      sym_comment,
  [209374] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9951), 1,
      anon_sym_RBRACK,
    STATE(7019), 1,
      sym_comment,
  [209387] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10972), 1,
      anon_sym_EQ_GT,
    STATE(7020), 1,
      sym_comment,
  [209400] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10974), 1,
      sym_identifier,
    STATE(7021), 1,
      sym_comment,
  [209413] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10976), 1,
      sym_identifier,
    STATE(7022), 1,
      sym_comment,
  [209426] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10978), 1,
      sym_identifier,
    STATE(7023), 1,
      sym_comment,
  [209439] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10980), 1,
      sym_identifier,
    STATE(7024), 1,
      sym_comment,
  [209452] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10982), 1,
      anon_sym_DOT,
    STATE(7025), 1,
      sym_comment,
  [209465] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10984), 1,
      anon_sym_EQ_GT,
    STATE(7026), 1,
      sym_comment,
  [209478] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10986), 1,
      sym_identifier,
    STATE(7027), 1,
      sym_comment,
  [209491] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10988), 1,
      sym_identifier,
    STATE(7028), 1,
      sym_comment,
  [209504] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10990), 1,
      sym_identifier,
    STATE(7029), 1,
      sym_comment,
  [209517] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10992), 1,
      anon_sym_while,
    STATE(7030), 1,
      sym_comment,
  [209530] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10994), 1,
      sym_identifier,
    STATE(7031), 1,
      sym_comment,
  [209543] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10996), 1,
      sym_identifier,
    STATE(7032), 1,
      sym_comment,
  [209556] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10998), 1,
      anon_sym_while,
    STATE(7033), 1,
      sym_comment,
  [209569] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11000), 1,
      sym_identifier,
    STATE(7034), 1,
      sym_comment,
  [209582] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11002), 1,
      anon_sym_RBRACK,
    STATE(7035), 1,
      sym_comment,
  [209595] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11004), 1,
      anon_sym_RBRACK,
    STATE(7036), 1,
      sym_comment,
  [209608] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11006), 1,
      sym_identifier,
    STATE(7037), 1,
      sym_comment,
  [209621] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11008), 1,
      sym_identifier,
    STATE(7038), 1,
      sym_comment,
  [209634] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11010), 1,
      sym_identifier,
    STATE(7039), 1,
      sym_comment,
  [209647] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11012), 1,
      sym_identifier,
    STATE(7040), 1,
      sym_comment,
  [209660] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7418), 1,
      anon_sym_is,
    STATE(7041), 1,
      sym_comment,
  [209673] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11014), 1,
      sym_identifier,
    STATE(7042), 1,
      sym_comment,
  [209686] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11016), 1,
      anon_sym_as,
    STATE(7043), 1,
      sym_comment,
  [209699] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11018), 1,
      sym_identifier,
    STATE(7044), 1,
      sym_comment,
  [209712] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11020), 1,
      sym_identifier,
    STATE(7045), 1,
      sym_comment,
  [209725] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11022), 1,
      anon_sym_DOT,
    STATE(7046), 1,
      sym_comment,
  [209738] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11024), 1,
      anon_sym_RBRACK,
    STATE(7047), 1,
      sym_comment,
  [209751] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5888), 1,
      anon_sym_RPAREN,
    STATE(7048), 1,
      sym_comment,
  [209764] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11026), 1,
      anon_sym_EQ_GT,
    STATE(7049), 1,
      sym_comment,
  [209777] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11028), 1,
      sym_identifier,
    STATE(7050), 1,
      sym_comment,
  [209790] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5892), 1,
      anon_sym_RBRACE,
    STATE(7051), 1,
      sym_comment,
  [209803] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11030), 1,
      anon_sym_RPAREN,
    STATE(7052), 1,
      sym_comment,
  [209816] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11032), 1,
      anon_sym_EQ_GT,
    STATE(7053), 1,
      sym_comment,
  [209829] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11034), 1,
      sym_identifier,
    STATE(7054), 1,
      sym_comment,
  [209842] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11036), 1,
      anon_sym_from,
    STATE(7055), 1,
      sym_comment,
  [209855] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11038), 1,
      sym_identifier,
    STATE(7056), 1,
      sym_comment,
  [209868] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11040), 1,
      anon_sym_RPAREN,
    STATE(7057), 1,
      sym_comment,
  [209881] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11042), 1,
      anon_sym_RBRACK,
    STATE(7058), 1,
      sym_comment,
  [209894] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5914), 1,
      anon_sym_RBRACK,
    STATE(7059), 1,
      sym_comment,
  [209907] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11044), 1,
      anon_sym_EQ,
    STATE(7060), 1,
      sym_comment,
  [209920] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11046), 1,
      anon_sym_RBRACK,
    STATE(7061), 1,
      sym_comment,
  [209933] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9884), 1,
      anon_sym_RBRACE,
    STATE(7062), 1,
      sym_comment,
  [209946] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11048), 1,
      anon_sym_RPAREN,
    STATE(7063), 1,
      sym_comment,
  [209959] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11050), 1,
      anon_sym_RBRACK,
    STATE(7064), 1,
      sym_comment,
  [209972] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11052), 1,
      anon_sym_RBRACK,
    STATE(7065), 1,
      sym_comment,
  [209985] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11054), 1,
      anon_sym_RBRACK,
    STATE(7066), 1,
      sym_comment,
  [209998] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11056), 1,
      anon_sym_RBRACK,
    STATE(7067), 1,
      sym_comment,
  [210011] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11058), 1,
      anon_sym_EQ_GT,
    STATE(7068), 1,
      sym_comment,
  [210024] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11060), 1,
      anon_sym_EQ_GT,
    STATE(7069), 1,
      sym_comment,
  [210037] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11062), 1,
      sym_identifier,
    STATE(7070), 1,
      sym_comment,
  [210050] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11064), 1,
      anon_sym_EQ_GT,
    STATE(7071), 1,
      sym_comment,
  [210063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11066), 1,
      anon_sym_RBRACK,
    STATE(7072), 1,
      sym_comment,
  [210076] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8792), 1,
      anon_sym_EQ,
    STATE(7073), 1,
      sym_comment,
  [210089] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11068), 1,
      anon_sym_EQ_GT,
    STATE(7074), 1,
      sym_comment,
  [210102] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6574), 1,
      anon_sym_in,
    STATE(7075), 1,
      sym_comment,
  [210115] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11070), 1,
      anon_sym_RBRACK,
    STATE(7076), 1,
      sym_comment,
  [210128] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10004), 1,
      anon_sym_GT,
    STATE(7077), 1,
      sym_comment,
  [210141] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11072), 1,
      anon_sym_RBRACK,
    STATE(7078), 1,
      sym_comment,
  [210154] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11074), 1,
      anon_sym_RBRACK,
    STATE(7079), 1,
      sym_comment,
  [210167] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11076), 1,
      anon_sym_RBRACK,
    STATE(7080), 1,
      sym_comment,
  [210180] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11078), 1,
      sym_regex_pattern,
    STATE(7081), 1,
      sym_comment,
  [210193] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11080), 1,
      sym_identifier,
    STATE(7082), 1,
      sym_comment,
  [210206] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11082), 1,
      sym_identifier,
    STATE(7083), 1,
      sym_comment,
  [210219] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11084), 1,
      anon_sym_SLASH2,
    STATE(7084), 1,
      sym_comment,
  [210232] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11086), 1,
      anon_sym_EQ,
    STATE(7085), 1,
      sym_comment,
  [210245] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11088), 1,
      anon_sym_EQ_GT,
    STATE(7086), 1,
      sym_comment,
  [210258] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11090), 1,
      anon_sym_RPAREN,
    STATE(7087), 1,
      sym_comment,
  [210271] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11092), 1,
      sym_identifier,
    STATE(7088), 1,
      sym_comment,
  [210284] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11094), 1,
      sym_identifier,
    STATE(7089), 1,
      sym_comment,
  [210297] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11096), 1,
      anon_sym_from,
    STATE(7090), 1,
      sym_comment,
  [210310] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5837), 1,
      anon_sym_in,
    STATE(7091), 1,
      sym_comment,
  [210323] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11098), 1,
      anon_sym_RPAREN,
    STATE(7092), 1,
      sym_comment,
  [210336] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11100), 1,
      anon_sym_RBRACK,
    STATE(7093), 1,
      sym_comment,
  [210349] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11102), 1,
      anon_sym_RBRACK,
    STATE(7094), 1,
      sym_comment,
  [210362] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11104), 1,
      sym_identifier,
    STATE(7095), 1,
      sym_comment,
  [210375] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11106), 1,
      anon_sym_while,
    STATE(7096), 1,
      sym_comment,
  [210388] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_RPAREN,
    STATE(7097), 1,
      sym_comment,
  [210401] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11110), 1,
      sym_identifier,
    STATE(7098), 1,
      sym_comment,
  [210414] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ_GT,
    STATE(7099), 1,
      sym_comment,
  [210427] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11114), 1,
      anon_sym_EQ_GT,
    STATE(7100), 1,
      sym_comment,
  [210440] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11116), 1,
      anon_sym_EQ_GT,
    STATE(7101), 1,
      sym_comment,
  [210453] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11118), 1,
      anon_sym_RBRACK,
    STATE(7102), 1,
      sym_comment,
  [210466] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11120), 1,
      sym_identifier,
    STATE(7103), 1,
      sym_comment,
  [210479] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11122), 1,
      anon_sym_RPAREN,
    STATE(7104), 1,
      sym_comment,
  [210492] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11124), 1,
      sym_identifier,
    STATE(7105), 1,
      sym_comment,
  [210505] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11126), 1,
      anon_sym_EQ_GT,
    STATE(7106), 1,
      sym_comment,
  [210518] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11128), 1,
      anon_sym_RBRACK,
    STATE(7107), 1,
      sym_comment,
  [210531] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11130), 1,
      sym_identifier,
    STATE(7108), 1,
      sym_comment,
  [210544] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11132), 1,
      anon_sym_RBRACK,
    STATE(7109), 1,
      sym_comment,
  [210557] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11134), 1,
      anon_sym_RBRACK,
    STATE(7110), 1,
      sym_comment,
  [210570] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11136), 1,
      anon_sym_RBRACK,
    STATE(7111), 1,
      sym_comment,
  [210583] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11138), 1,
      anon_sym_DOT,
    STATE(7112), 1,
      sym_comment,
  [210596] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11140), 1,
      anon_sym_RBRACK,
    STATE(7113), 1,
      sym_comment,
  [210609] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11142), 1,
      anon_sym_COLON,
    STATE(7114), 1,
      sym_comment,
  [210622] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11144), 1,
      anon_sym_RBRACK,
    STATE(7115), 1,
      sym_comment,
  [210635] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11146), 1,
      sym_identifier,
    STATE(7116), 1,
      sym_comment,
  [210648] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11148), 1,
      anon_sym_RBRACK,
    STATE(7117), 1,
      sym_comment,
  [210661] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11150), 1,
      anon_sym_RBRACK,
    STATE(7118), 1,
      sym_comment,
  [210674] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11152), 1,
      anon_sym_RBRACK,
    STATE(7119), 1,
      sym_comment,
  [210687] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11154), 1,
      anon_sym_from,
    STATE(7120), 1,
      sym_comment,
  [210700] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5196), 1,
      anon_sym_RPAREN,
    STATE(7121), 1,
      sym_comment,
  [210713] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11156), 1,
      anon_sym_require,
    STATE(7122), 1,
      sym_comment,
  [210726] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11158), 1,
      anon_sym_RBRACK,
    STATE(7123), 1,
      sym_comment,
  [210739] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11160), 1,
      anon_sym_RBRACK,
    STATE(7124), 1,
      sym_comment,
  [210752] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11162), 1,
      anon_sym_RBRACK,
    STATE(7125), 1,
      sym_comment,
  [210765] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11164), 1,
      anon_sym_as,
    STATE(7126), 1,
      sym_comment,
  [210778] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11166), 1,
      anon_sym_from,
    STATE(7127), 1,
      sym_comment,
  [210791] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11168), 1,
      anon_sym_RPAREN,
    STATE(7128), 1,
      sym_comment,
  [210804] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11170), 1,
      anon_sym_RPAREN,
    STATE(7129), 1,
      sym_comment,
  [210817] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11172), 1,
      anon_sym_EQ,
    STATE(7130), 1,
      sym_comment,
  [210830] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11174), 1,
      anon_sym_EQ,
    STATE(7131), 1,
      sym_comment,
  [210843] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11176), 1,
      anon_sym_RBRACK,
    STATE(7132), 1,
      sym_comment,
  [210856] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11178), 1,
      anon_sym_RBRACK,
    STATE(7133), 1,
      sym_comment,
  [210869] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11180), 1,
      anon_sym_RBRACK,
    STATE(7134), 1,
      sym_comment,
  [210882] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11182), 1,
      anon_sym_LPAREN,
    STATE(7135), 1,
      sym_comment,
  [210895] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6254), 1,
      anon_sym_in,
    STATE(7136), 1,
      sym_comment,
  [210908] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11184), 1,
      sym_identifier,
    STATE(7137), 1,
      sym_comment,
  [210921] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11186), 1,
      sym_identifier,
    STATE(7138), 1,
      sym_comment,
  [210934] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11188), 1,
      anon_sym_RBRACK,
    STATE(7139), 1,
      sym_comment,
  [210947] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11190), 1,
      anon_sym_RBRACK,
    STATE(7140), 1,
      sym_comment,
  [210960] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11192), 1,
      anon_sym_RBRACK,
    STATE(7141), 1,
      sym_comment,
  [210973] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11194), 1,
      anon_sym_EQ,
    STATE(7142), 1,
      sym_comment,
  [210986] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11196), 1,
      sym_identifier,
    STATE(7143), 1,
      sym_comment,
  [210999] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11198), 1,
      sym_identifier,
    STATE(7144), 1,
      sym_comment,
  [211012] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11200), 1,
      anon_sym_EQ_GT,
    STATE(7145), 1,
      sym_comment,
  [211025] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4923), 1,
      anon_sym_in,
    STATE(7146), 1,
      sym_comment,
  [211038] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11202), 1,
      anon_sym_EQ,
    STATE(7147), 1,
      sym_comment,
  [211051] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11204), 1,
      sym_identifier,
    STATE(7148), 1,
      sym_comment,
  [211064] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11206), 1,
      anon_sym_from,
    STATE(7149), 1,
      sym_comment,
  [211077] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11208), 1,
      sym_identifier,
    STATE(7150), 1,
      sym_comment,
  [211090] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11210), 1,
      sym_identifier,
    STATE(7151), 1,
      sym_comment,
  [211103] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11212), 1,
      anon_sym_EQ_GT,
    STATE(7152), 1,
      sym_comment,
  [211116] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11214), 1,
      sym_identifier,
    STATE(7153), 1,
      sym_comment,
  [211129] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11216), 1,
      anon_sym_EQ,
    STATE(7154), 1,
      sym_comment,
  [211142] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11218), 1,
      anon_sym_EQ_GT,
    STATE(7155), 1,
      sym_comment,
  [211155] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11220), 1,
      anon_sym_RBRACK,
    STATE(7156), 1,
      sym_comment,
  [211168] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11222), 1,
      sym_identifier,
    STATE(7157), 1,
      sym_comment,
  [211181] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11224), 1,
      anon_sym_RBRACK,
    STATE(7158), 1,
      sym_comment,
  [211194] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11226), 1,
      sym_identifier,
    STATE(7159), 1,
      sym_comment,
  [211207] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_in,
    STATE(7160), 1,
      sym_comment,
  [211220] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11228), 1,
      anon_sym_DOT,
    STATE(7161), 1,
      sym_comment,
  [211233] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11230), 1,
      anon_sym_EQ_GT,
    STATE(7162), 1,
      sym_comment,
  [211246] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11232), 1,
      anon_sym_EQ_GT,
    STATE(7163), 1,
      sym_comment,
  [211259] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11234), 1,
      sym_identifier,
    STATE(7164), 1,
      sym_comment,
  [211272] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11236), 1,
      sym_identifier,
    STATE(7165), 1,
      sym_comment,
  [211285] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(8161), 1,
      anon_sym_EQ,
    STATE(7166), 1,
      sym_comment,
  [211298] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11238), 1,
      anon_sym_COLON,
    STATE(7167), 1,
      sym_comment,
  [211311] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11240), 1,
      sym_identifier,
    STATE(7168), 1,
      sym_comment,
  [211324] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11242), 1,
      anon_sym_RBRACK,
    STATE(7169), 1,
      sym_comment,
  [211337] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11244), 1,
      anon_sym_DOT,
    STATE(7170), 1,
      sym_comment,
  [211350] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5308), 1,
      anon_sym_RPAREN,
    STATE(7171), 1,
      sym_comment,
  [211363] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11246), 1,
      anon_sym_EQ_GT,
    STATE(7172), 1,
      sym_comment,
  [211376] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11248), 1,
      anon_sym_EQ,
    STATE(7173), 1,
      sym_comment,
  [211389] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11250), 1,
      anon_sym_RBRACK,
    STATE(7174), 1,
      sym_comment,
  [211402] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11252), 1,
      sym_identifier,
    STATE(7175), 1,
      sym_comment,
  [211415] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11254), 1,
      sym_identifier,
    STATE(7176), 1,
      sym_comment,
  [211428] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11256), 1,
      anon_sym_RBRACK,
    STATE(7177), 1,
      sym_comment,
  [211441] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9767), 1,
      anon_sym_RBRACE,
    STATE(7178), 1,
      sym_comment,
  [211454] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11258), 1,
      anon_sym_RBRACK,
    STATE(7179), 1,
      sym_comment,
  [211467] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11260), 1,
      sym_identifier,
    STATE(7180), 1,
      sym_comment,
  [211480] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11262), 1,
      anon_sym_RBRACK,
    STATE(7181), 1,
      sym_comment,
  [211493] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4948), 1,
      anon_sym_RPAREN,
    STATE(7182), 1,
      sym_comment,
  [211506] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11264), 1,
      anon_sym_RBRACK,
    STATE(7183), 1,
      sym_comment,
  [211519] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11266), 1,
      anon_sym_RBRACK,
    STATE(7184), 1,
      sym_comment,
  [211532] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11268), 1,
      anon_sym_RBRACK,
    STATE(7185), 1,
      sym_comment,
  [211545] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11270), 1,
      anon_sym_LBRACK,
    STATE(7186), 1,
      sym_comment,
  [211558] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5975), 1,
      anon_sym_in,
    STATE(7187), 1,
      sym_comment,
  [211571] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11272), 1,
      anon_sym_RBRACK,
    STATE(7188), 1,
      sym_comment,
  [211584] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11274), 1,
      anon_sym_class,
    STATE(7189), 1,
      sym_comment,
  [211597] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11276), 1,
      anon_sym_RBRACK,
    STATE(7190), 1,
      sym_comment,
  [211610] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11278), 1,
      anon_sym_EQ_GT,
    STATE(7191), 1,
      sym_comment,
  [211623] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11280), 1,
      anon_sym_EQ_GT,
    STATE(7192), 1,
      sym_comment,
  [211636] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11282), 1,
      anon_sym_EQ,
    STATE(7193), 1,
      sym_comment,
  [211649] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11284), 1,
      anon_sym_namespace,
    STATE(7194), 1,
      sym_comment,
  [211662] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11286), 1,
      sym_identifier,
    STATE(7195), 1,
      sym_comment,
  [211675] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5876), 1,
      anon_sym_RPAREN,
    STATE(7196), 1,
      sym_comment,
  [211688] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11288), 1,
      anon_sym_RBRACK,
    STATE(7197), 1,
      sym_comment,
  [211701] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11290), 1,
      anon_sym_class,
    STATE(7198), 1,
      sym_comment,
  [211714] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11292), 1,
      anon_sym_RBRACK,
    STATE(7199), 1,
      sym_comment,
  [211727] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11294), 1,
      anon_sym_EQ_GT,
    STATE(7200), 1,
      sym_comment,
  [211740] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11296), 1,
      anon_sym_new,
    STATE(7201), 1,
      sym_comment,
  [211753] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11298), 1,
      anon_sym_EQ_GT,
    STATE(7202), 1,
      sym_comment,
  [211766] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11300), 1,
      anon_sym_EQ_GT,
    STATE(7203), 1,
      sym_comment,
  [211779] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11302), 1,
      anon_sym_while,
    STATE(7204), 1,
      sym_comment,
  [211792] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11304), 1,
      anon_sym_EQ_GT,
    STATE(7205), 1,
      sym_comment,
  [211805] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11306), 1,
      anon_sym_EQ_GT,
    STATE(7206), 1,
      sym_comment,
  [211818] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11308), 1,
      anon_sym_EQ_GT,
    STATE(7207), 1,
      sym_comment,
  [211831] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11310), 1,
      anon_sym_RBRACK,
    STATE(7208), 1,
      sym_comment,
  [211844] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11312), 1,
      sym_identifier,
    STATE(7209), 1,
      sym_comment,
  [211857] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11314), 1,
      anon_sym_RBRACK,
    STATE(7210), 1,
      sym_comment,
  [211870] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11316), 1,
      anon_sym_RBRACK,
    STATE(7211), 1,
      sym_comment,
  [211883] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11318), 1,
      anon_sym_RBRACK,
    STATE(7212), 1,
      sym_comment,
  [211896] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11320), 1,
      anon_sym_RBRACK,
    STATE(7213), 1,
      sym_comment,
  [211909] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11322), 1,
      anon_sym_RBRACK,
    STATE(7214), 1,
      sym_comment,
  [211922] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11324), 1,
      anon_sym_EQ,
    STATE(7215), 1,
      sym_comment,
  [211935] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10133), 1,
      sym_identifier,
    STATE(7216), 1,
      sym_comment,
  [211948] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11326), 1,
      anon_sym_class,
    STATE(7217), 1,
      sym_comment,
  [211961] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11328), 1,
      anon_sym_EQ_GT,
    STATE(7218), 1,
      sym_comment,
  [211974] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11330), 1,
      anon_sym_RBRACK,
    STATE(7219), 1,
      sym_comment,
  [211987] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11332), 1,
      anon_sym_EQ,
    STATE(7220), 1,
      sym_comment,
  [212000] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10127), 1,
      anon_sym_RBRACK,
    STATE(7221), 1,
      sym_comment,
  [212013] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11334), 1,
      sym_identifier,
    STATE(7222), 1,
      sym_comment,
  [212026] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11336), 1,
      anon_sym_EQ,
    STATE(7223), 1,
      sym_comment,
  [212039] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11338), 1,
      anon_sym_RBRACK,
    STATE(7224), 1,
      sym_comment,
  [212052] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11340), 1,
      anon_sym_RBRACK,
    STATE(7225), 1,
      sym_comment,
  [212065] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11342), 1,
      anon_sym_RBRACK,
    STATE(7226), 1,
      sym_comment,
  [212078] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11344), 1,
      sym_identifier,
    STATE(7227), 1,
      sym_comment,
  [212091] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11346), 1,
      anon_sym_RBRACK,
    STATE(7228), 1,
      sym_comment,
  [212104] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11348), 1,
      anon_sym_RBRACK,
    STATE(7229), 1,
      sym_comment,
  [212117] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11350), 1,
      anon_sym_EQ_GT,
    STATE(7230), 1,
      sym_comment,
  [212130] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11352), 1,
      anon_sym_new,
    STATE(7231), 1,
      sym_comment,
  [212143] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11354), 1,
      anon_sym_RBRACK,
    STATE(7232), 1,
      sym_comment,
  [212156] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11356), 1,
      anon_sym_EQ_GT,
    STATE(7233), 1,
      sym_comment,
  [212169] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11358), 1,
      sym_identifier,
    STATE(7234), 1,
      sym_comment,
  [212182] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6005), 1,
      anon_sym_in,
    STATE(7235), 1,
      sym_comment,
  [212195] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11360), 1,
      sym_identifier,
    STATE(7236), 1,
      sym_comment,
  [212208] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11362), 1,
      sym_identifier,
    STATE(7237), 1,
      sym_comment,
  [212221] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11364), 1,
      anon_sym_COLON,
    STATE(7238), 1,
      sym_comment,
  [212234] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11366), 1,
      sym_identifier,
    STATE(7239), 1,
      sym_comment,
  [212247] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3084), 1,
      anon_sym_LBRACE,
    STATE(7240), 1,
      sym_comment,
  [212260] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(7241), 1,
      sym_comment,
  [212273] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11368), 1,
      sym_identifier,
    STATE(7242), 1,
      sym_comment,
  [212286] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11370), 1,
      sym_regex_pattern,
    STATE(7243), 1,
      sym_comment,
  [212299] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11372), 1,
      anon_sym_EQ,
    STATE(7244), 1,
      sym_comment,
  [212312] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11374), 1,
      anon_sym_target,
    STATE(7245), 1,
      sym_comment,
  [212325] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11376), 1,
      sym_identifier,
    STATE(7246), 1,
      sym_comment,
  [212338] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11378), 1,
      anon_sym_RBRACK,
    STATE(7247), 1,
      sym_comment,
  [212351] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11380), 1,
      anon_sym_EQ_GT,
    STATE(7248), 1,
      sym_comment,
  [212364] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11382), 1,
      anon_sym_SLASH2,
    STATE(7249), 1,
      sym_comment,
  [212377] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11384), 1,
      anon_sym_RBRACK,
    STATE(7250), 1,
      sym_comment,
  [212390] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11386), 1,
      anon_sym_RBRACK,
    STATE(7251), 1,
      sym_comment,
  [212403] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11388), 1,
      sym_identifier,
    STATE(7252), 1,
      sym_comment,
  [212416] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11390), 1,
      anon_sym_SLASH2,
    STATE(7253), 1,
      sym_comment,
  [212429] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11392), 1,
      anon_sym_EQ,
    STATE(7254), 1,
      sym_comment,
  [212442] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11394), 1,
      anon_sym_EQ,
    STATE(7255), 1,
      sym_comment,
  [212455] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11396), 1,
      anon_sym_target,
    STATE(7256), 1,
      sym_comment,
  [212468] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11398), 1,
      anon_sym_RBRACK,
    STATE(7257), 1,
      sym_comment,
  [212481] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11400), 1,
      anon_sym_RBRACK,
    STATE(7258), 1,
      sym_comment,
  [212494] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11402), 1,
      anon_sym_RBRACK,
    STATE(7259), 1,
      sym_comment,
  [212507] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11404), 1,
      anon_sym_EQ_GT,
    STATE(7260), 1,
      sym_comment,
  [212520] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9470), 1,
      anon_sym_EQ_GT,
    STATE(7261), 1,
      sym_comment,
  [212533] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11406), 1,
      anon_sym_RBRACK,
    STATE(7262), 1,
      sym_comment,
  [212546] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9466), 1,
      anon_sym_EQ_GT,
    STATE(7263), 1,
      sym_comment,
  [212559] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11408), 1,
      anon_sym_RBRACK,
    STATE(7264), 1,
      sym_comment,
  [212572] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9716), 1,
      anon_sym_LBRACE,
    STATE(7265), 1,
      sym_comment,
  [212585] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11410), 1,
      anon_sym_RBRACK,
    STATE(7266), 1,
      sym_comment,
  [212598] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11412), 1,
      sym_identifier,
    STATE(7267), 1,
      sym_comment,
  [212611] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11414), 1,
      anon_sym_RBRACK,
    STATE(7268), 1,
      sym_comment,
  [212624] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11416), 1,
      anon_sym_RBRACK,
    STATE(7269), 1,
      sym_comment,
  [212637] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11418), 1,
      anon_sym_RBRACK,
    STATE(7270), 1,
      sym_comment,
  [212650] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11420), 1,
      anon_sym_RBRACK,
    STATE(7271), 1,
      sym_comment,
  [212663] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11422), 1,
      anon_sym_EQ_GT,
    STATE(7272), 1,
      sym_comment,
  [212676] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11424), 1,
      anon_sym_EQ,
    STATE(7273), 1,
      sym_comment,
  [212689] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11426), 1,
      anon_sym_SLASH2,
    STATE(7274), 1,
      sym_comment,
  [212702] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11428), 1,
      anon_sym_COLON,
    STATE(7275), 1,
      sym_comment,
  [212715] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11430), 1,
      sym_identifier,
    STATE(7276), 1,
      sym_comment,
  [212728] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11432), 1,
      sym_identifier,
    STATE(7277), 1,
      sym_comment,
  [212741] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11434), 1,
      anon_sym_RBRACK,
    STATE(7278), 1,
      sym_comment,
  [212754] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11436), 1,
      sym_identifier,
    STATE(7279), 1,
      sym_comment,
  [212767] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11438), 1,
      sym_identifier,
    STATE(7280), 1,
      sym_comment,
  [212780] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11440), 1,
      sym_identifier,
    STATE(7281), 1,
      sym_comment,
  [212793] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4962), 1,
      anon_sym_RPAREN,
    STATE(7282), 1,
      sym_comment,
  [212806] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11442), 1,
      anon_sym_while,
    STATE(7283), 1,
      sym_comment,
  [212819] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11444), 1,
      anon_sym_EQ_GT,
    STATE(7284), 1,
      sym_comment,
  [212832] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11446), 1,
      sym_identifier,
    STATE(7285), 1,
      sym_comment,
  [212845] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11448), 1,
      sym_identifier,
    STATE(7286), 1,
      sym_comment,
  [212858] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11450), 1,
      sym_identifier,
    STATE(7287), 1,
      sym_comment,
  [212871] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5302), 1,
      anon_sym_RPAREN,
    STATE(7288), 1,
      sym_comment,
  [212884] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11452), 1,
      anon_sym_EQ_GT,
    STATE(7289), 1,
      sym_comment,
  [212897] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11454), 1,
      anon_sym_EQ_GT,
    STATE(7290), 1,
      sym_comment,
  [212910] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11456), 1,
      anon_sym_EQ_GT,
    STATE(7291), 1,
      sym_comment,
  [212923] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11458), 1,
      sym_identifier,
    STATE(7292), 1,
      sym_comment,
  [212936] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11460), 1,
      anon_sym_RPAREN,
    STATE(7293), 1,
      sym_comment,
  [212949] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11462), 1,
      sym_identifier,
    STATE(7294), 1,
      sym_comment,
  [212962] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11464), 1,
      sym_identifier,
    STATE(7295), 1,
      sym_comment,
  [212975] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11466), 1,
      sym_identifier,
    STATE(7296), 1,
      sym_comment,
  [212988] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11468), 1,
      sym_number,
    STATE(7297), 1,
      sym_comment,
  [213001] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11470), 1,
      anon_sym_RPAREN,
    STATE(7298), 1,
      sym_comment,
  [213014] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11472), 1,
      anon_sym_EQ_GT,
    STATE(7299), 1,
      sym_comment,
  [213027] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11474), 1,
      sym_identifier,
    STATE(7300), 1,
      sym_comment,
  [213040] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11476), 1,
      anon_sym_RBRACK,
    STATE(7301), 1,
      sym_comment,
  [213053] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10622), 1,
      anon_sym_from,
    STATE(7302), 1,
      sym_comment,
  [213066] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5880), 1,
      anon_sym_RBRACK,
    STATE(7303), 1,
      sym_comment,
  [213079] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5865), 1,
      anon_sym_RPAREN,
    STATE(7304), 1,
      sym_comment,
  [213092] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11478), 1,
      anon_sym_RPAREN,
    STATE(7305), 1,
      sym_comment,
  [213105] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11480), 1,
      sym_identifier,
    STATE(7306), 1,
      sym_comment,
  [213118] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11482), 1,
      anon_sym_as,
    STATE(7307), 1,
      sym_comment,
  [213131] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11484), 1,
      anon_sym_RBRACK,
    STATE(7308), 1,
      sym_comment,
  [213144] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11486), 1,
      sym_identifier,
    STATE(7309), 1,
      sym_comment,
  [213157] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11488), 1,
      anon_sym_symbol,
    STATE(7310), 1,
      sym_comment,
  [213170] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7065), 1,
      anon_sym_is,
    STATE(7311), 1,
      sym_comment,
  [213183] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4970), 1,
      anon_sym_RPAREN,
    STATE(7312), 1,
      sym_comment,
  [213196] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11490), 1,
      anon_sym_EQ_GT,
    STATE(7313), 1,
      sym_comment,
  [213209] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(3118), 1,
      anon_sym_LBRACE,
    STATE(7314), 1,
      sym_comment,
  [213222] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11492), 1,
      anon_sym_RBRACK,
    STATE(7315), 1,
      sym_comment,
  [213235] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11494), 1,
      anon_sym_EQ_GT,
    STATE(7316), 1,
      sym_comment,
  [213248] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11496), 1,
      anon_sym_EQ,
    STATE(7317), 1,
      sym_comment,
  [213261] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(6312), 1,
      anon_sym_in,
    STATE(7318), 1,
      sym_comment,
  [213274] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11498), 1,
      anon_sym_EQ_GT,
    STATE(7319), 1,
      sym_comment,
  [213287] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11500), 1,
      anon_sym_RBRACK,
    STATE(7320), 1,
      sym_comment,
  [213300] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11502), 1,
      anon_sym_EQ_GT,
    STATE(7321), 1,
      sym_comment,
  [213313] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11504), 1,
      anon_sym_EQ_GT,
    STATE(7322), 1,
      sym_comment,
  [213326] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11506), 1,
      anon_sym_EQ_GT,
    STATE(7323), 1,
      sym_comment,
  [213339] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11508), 1,
      anon_sym_RBRACK,
    STATE(7324), 1,
      sym_comment,
  [213352] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11510), 1,
      anon_sym_EQ_GT,
    STATE(7325), 1,
      sym_comment,
  [213365] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11512), 1,
      anon_sym_RBRACK,
    STATE(7326), 1,
      sym_comment,
  [213378] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5935), 1,
      anon_sym_is,
    STATE(7327), 1,
      sym_comment,
  [213391] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11514), 1,
      anon_sym_RPAREN,
    STATE(7328), 1,
      sym_comment,
  [213404] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11516), 1,
      sym_identifier,
    STATE(7329), 1,
      sym_comment,
  [213417] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11518), 1,
      sym_identifier,
    STATE(7330), 1,
      sym_comment,
  [213430] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11520), 1,
      anon_sym_EQ,
    STATE(7331), 1,
      sym_comment,
  [213443] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11522), 1,
      anon_sym_function,
    STATE(7332), 1,
      sym_comment,
  [213456] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11524), 1,
      sym_number,
    STATE(7333), 1,
      sym_comment,
  [213469] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11526), 1,
      sym_identifier,
    STATE(7334), 1,
      sym_comment,
  [213482] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11528), 1,
      sym_identifier,
    STATE(7335), 1,
      sym_comment,
  [213495] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8565), 1,
      sym_identifier,
    STATE(7336), 1,
      sym_comment,
  [213508] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4895), 1,
      anon_sym_RPAREN,
    STATE(7337), 1,
      sym_comment,
  [213521] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11530), 1,
      anon_sym_symbol,
    STATE(7338), 1,
      sym_comment,
  [213534] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11532), 1,
      anon_sym_namespace,
    STATE(7339), 1,
      sym_comment,
  [213547] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11534), 1,
      anon_sym_EQ_GT,
    STATE(7340), 1,
      sym_comment,
  [213560] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5884), 1,
      anon_sym_RPAREN,
    STATE(7341), 1,
      sym_comment,
  [213573] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11536), 1,
      anon_sym_RBRACK,
    STATE(7342), 1,
      sym_comment,
  [213586] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11538), 1,
      sym_identifier,
    STATE(7343), 1,
      sym_comment,
  [213599] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11540), 1,
      anon_sym_RPAREN,
    STATE(7344), 1,
      sym_comment,
  [213612] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10253), 1,
      anon_sym_RBRACK,
    STATE(7345), 1,
      sym_comment,
  [213625] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11542), 1,
      anon_sym_class,
    STATE(7346), 1,
      sym_comment,
  [213638] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11544), 1,
      anon_sym_namespace,
    STATE(7347), 1,
      sym_comment,
  [213651] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11546), 1,
      sym_identifier,
    STATE(7348), 1,
      sym_comment,
  [213664] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11548), 1,
      sym_identifier,
    STATE(7349), 1,
      sym_comment,
  [213677] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11550), 1,
      anon_sym_EQ_GT,
    STATE(7350), 1,
      sym_comment,
  [213690] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11552), 1,
      anon_sym_from,
    STATE(7351), 1,
      sym_comment,
  [213703] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11554), 1,
      anon_sym_EQ,
    STATE(7352), 1,
      sym_comment,
  [213716] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11556), 1,
      anon_sym_EQ_GT,
    STATE(7353), 1,
      sym_comment,
  [213729] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11558), 1,
      sym_identifier,
    STATE(7354), 1,
      sym_comment,
  [213742] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9977), 1,
      sym_identifier,
    STATE(7355), 1,
      sym_comment,
  [213755] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11560), 1,
      anon_sym_class,
    STATE(7356), 1,
      sym_comment,
  [213768] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11562), 1,
      sym_identifier,
    STATE(7357), 1,
      sym_comment,
  [213781] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11564), 1,
      sym_identifier,
    STATE(7358), 1,
      sym_comment,
  [213794] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9904), 1,
      anon_sym_EQ,
    STATE(7359), 1,
      sym_comment,
  [213807] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11566), 1,
      anon_sym_EQ,
    STATE(7360), 1,
      sym_comment,
  [213820] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5894), 1,
      anon_sym_RBRACK,
    STATE(7361), 1,
      sym_comment,
  [213833] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11568), 1,
      sym_identifier,
    STATE(7362), 1,
      sym_comment,
  [213846] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11570), 1,
      anon_sym_EQ,
    STATE(7363), 1,
      sym_comment,
  [213859] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11572), 1,
      anon_sym_new,
    STATE(7364), 1,
      sym_comment,
  [213872] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11574), 1,
      anon_sym_SLASH2,
    STATE(7365), 1,
      sym_comment,
  [213885] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11576), 1,
      sym_identifier,
    STATE(7366), 1,
      sym_comment,
  [213898] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11578), 1,
      sym_identifier,
    STATE(7367), 1,
      sym_comment,
  [213911] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11580), 1,
      anon_sym_COLON,
    STATE(7368), 1,
      sym_comment,
  [213924] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11582), 1,
      sym_identifier,
    STATE(7369), 1,
      sym_comment,
  [213937] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11584), 1,
      anon_sym_EQ_GT,
    STATE(7370), 1,
      sym_comment,
  [213950] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11586), 1,
      anon_sym_EQ_GT,
    STATE(7371), 1,
      sym_comment,
  [213963] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9625), 1,
      anon_sym_RBRACK,
    STATE(7372), 1,
      sym_comment,
  [213976] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11588), 1,
      anon_sym_EQ_GT,
    STATE(7373), 1,
      sym_comment,
  [213989] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11590), 1,
      anon_sym_RBRACK,
    STATE(7374), 1,
      sym_comment,
  [214002] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11592), 1,
      ts_builtin_sym_end,
    STATE(7375), 1,
      sym_comment,
  [214015] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11594), 1,
      sym_identifier,
    STATE(7376), 1,
      sym_comment,
  [214028] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11596), 1,
      sym_identifier,
    STATE(7377), 1,
      sym_comment,
  [214041] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11598), 1,
      anon_sym_EQ,
    STATE(7378), 1,
      sym_comment,
  [214054] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11600), 1,
      anon_sym_class,
    STATE(7379), 1,
      sym_comment,
  [214067] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5916), 1,
      anon_sym_COLON,
    STATE(7380), 1,
      sym_comment,
  [214080] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11602), 1,
      anon_sym_class,
    STATE(7381), 1,
      sym_comment,
  [214093] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11604), 1,
      anon_sym_namespace,
    STATE(7382), 1,
      sym_comment,
  [214106] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5921), 1,
      anon_sym_RPAREN,
    STATE(7383), 1,
      sym_comment,
  [214119] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(4859), 1,
      anon_sym_is,
    STATE(7384), 1,
      sym_comment,
  [214132] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5890), 1,
      anon_sym_RBRACE,
    STATE(7385), 1,
      sym_comment,
  [214145] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5941), 1,
      anon_sym_RPAREN,
    STATE(7386), 1,
      sym_comment,
  [214158] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5943), 1,
      anon_sym_RPAREN,
    STATE(7387), 1,
      sym_comment,
  [214171] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11606), 1,
      anon_sym_RBRACK,
    STATE(7388), 1,
      sym_comment,
  [214184] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5937), 1,
      anon_sym_RPAREN,
    STATE(7389), 1,
      sym_comment,
  [214197] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9555), 1,
      sym_identifier,
    STATE(7390), 1,
      sym_comment,
  [214210] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11608), 1,
      anon_sym_class,
    STATE(7391), 1,
      sym_comment,
  [214223] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5480), 1,
      anon_sym_in,
    STATE(7392), 1,
      sym_comment,
  [214236] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10298), 1,
      anon_sym_GT,
    STATE(7393), 1,
      sym_comment,
  [214249] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11610), 1,
      anon_sym_EQ,
    STATE(7394), 1,
      sym_comment,
  [214262] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11612), 1,
      sym_identifier,
    STATE(7395), 1,
      sym_comment,
  [214275] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11614), 1,
      sym_identifier,
    STATE(7396), 1,
      sym_comment,
  [214288] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11616), 1,
      anon_sym_EQ,
    STATE(7397), 1,
      sym_comment,
  [214301] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11618), 1,
      anon_sym_new,
    STATE(7398), 1,
      sym_comment,
  [214314] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5192), 1,
      anon_sym_RPAREN,
    STATE(7399), 1,
      sym_comment,
  [214327] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11620), 1,
      sym_identifier,
    STATE(7400), 1,
      sym_comment,
  [214340] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11622), 1,
      sym_identifier,
    STATE(7401), 1,
      sym_comment,
  [214353] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11624), 1,
      anon_sym_COLON,
    STATE(7402), 1,
      sym_comment,
  [214366] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(7473), 1,
      anon_sym_is,
    STATE(7403), 1,
      sym_comment,
  [214379] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5791), 1,
      anon_sym_RBRACK,
    STATE(7404), 1,
      sym_comment,
  [214392] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11626), 1,
      sym_regex_pattern,
    STATE(7405), 1,
      sym_comment,
  [214405] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11628), 1,
      anon_sym_EQ_GT,
    STATE(7406), 1,
      sym_comment,
  [214418] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(9613), 1,
      anon_sym_GT,
    STATE(7407), 1,
      sym_comment,
  [214431] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11630), 1,
      anon_sym_EQ_GT,
    STATE(7408), 1,
      sym_comment,
  [214444] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11632), 1,
      anon_sym_class,
    STATE(7409), 1,
      sym_comment,
  [214457] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11634), 1,
      anon_sym_namespace,
    STATE(7410), 1,
      sym_comment,
  [214470] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11636), 1,
      anon_sym_GT,
    STATE(7411), 1,
      sym_comment,
  [214483] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11638), 1,
      anon_sym_RPAREN,
    STATE(7412), 1,
      sym_comment,
  [214496] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11640), 1,
      sym_identifier,
    STATE(7413), 1,
      sym_comment,
  [214509] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11642), 1,
      sym_identifier,
    STATE(7414), 1,
      sym_comment,
  [214522] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(10358), 1,
      anon_sym_RBRACK,
    STATE(7415), 1,
      sym_comment,
  [214535] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11644), 1,
      anon_sym_EQ_GT,
    STATE(7416), 1,
      sym_comment,
  [214548] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11646), 1,
      sym_identifier,
    STATE(7417), 1,
      sym_comment,
  [214561] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9852), 1,
      sym_identifier,
    STATE(7418), 1,
      sym_comment,
  [214574] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11648), 1,
      anon_sym_class,
    STATE(7419), 1,
      sym_comment,
  [214587] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11650), 1,
      sym_identifier,
    STATE(7420), 1,
      sym_comment,
  [214600] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11652), 1,
      sym_identifier,
    STATE(7421), 1,
      sym_comment,
  [214613] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11654), 1,
      anon_sym_EQ,
    STATE(7422), 1,
      sym_comment,
  [214626] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11656), 1,
      sym_identifier,
    STATE(7423), 1,
      sym_comment,
  [214639] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11658), 1,
      sym_identifier,
    STATE(7424), 1,
      sym_comment,
  [214652] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11660), 1,
      anon_sym_EQ,
    STATE(7425), 1,
      sym_comment,
  [214665] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11662), 1,
      anon_sym_new,
    STATE(7426), 1,
      sym_comment,
  [214678] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11664), 1,
      anon_sym_EQ_GT,
    STATE(7427), 1,
      sym_comment,
  [214691] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11666), 1,
      sym_identifier,
    STATE(7428), 1,
      sym_comment,
  [214704] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(5064), 1,
      anon_sym_RPAREN,
    STATE(7429), 1,
      sym_comment,
  [214717] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11668), 1,
      anon_sym_COLON,
    STATE(7430), 1,
      sym_comment,
  [214730] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11670), 1,
      anon_sym_RBRACK,
    STATE(7431), 1,
      sym_comment,
  [214743] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11672), 1,
      anon_sym_RBRACK,
    STATE(7432), 1,
      sym_comment,
  [214756] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11674), 1,
      anon_sym_RBRACK,
    STATE(7433), 1,
      sym_comment,
  [214769] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11676), 1,
      anon_sym_class,
    STATE(7434), 1,
      sym_comment,
  [214782] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11678), 1,
      anon_sym_namespace,
    STATE(7435), 1,
      sym_comment,
  [214795] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11680), 1,
      anon_sym_RBRACK,
    STATE(7436), 1,
      sym_comment,
  [214808] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11682), 1,
      sym_identifier,
    STATE(7437), 1,
      sym_comment,
  [214821] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11684), 1,
      anon_sym_RBRACK,
    STATE(7438), 1,
      sym_comment,
  [214834] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11686), 1,
      anon_sym_RBRACK,
    STATE(7439), 1,
      sym_comment,
  [214847] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11688), 1,
      anon_sym_RBRACK,
    STATE(7440), 1,
      sym_comment,
  [214860] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9813), 1,
      sym_identifier,
    STATE(7441), 1,
      sym_comment,
  [214873] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11690), 1,
      anon_sym_class,
    STATE(7442), 1,
      sym_comment,
  [214886] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11692), 1,
      anon_sym_RPAREN,
    STATE(7443), 1,
      sym_comment,
  [214899] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11694), 1,
      anon_sym_EQ,
    STATE(7444), 1,
      sym_comment,
  [214912] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11696), 1,
      anon_sym_RBRACK,
    STATE(7445), 1,
      sym_comment,
  [214925] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11698), 1,
      sym_identifier,
    STATE(7446), 1,
      sym_comment,
  [214938] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11700), 1,
      anon_sym_EQ,
    STATE(7447), 1,
      sym_comment,
  [214951] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11702), 1,
      anon_sym_EQ_GT,
    STATE(7448), 1,
      sym_comment,
  [214964] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11704), 1,
      sym_identifier,
    STATE(7449), 1,
      sym_comment,
  [214977] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11706), 1,
      anon_sym_COLON,
    STATE(7450), 1,
      sym_comment,
  [214990] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11708), 1,
      anon_sym_symbol,
    STATE(7451), 1,
      sym_comment,
  [215003] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11710), 1,
      anon_sym_RBRACK,
    STATE(7452), 1,
      sym_comment,
  [215016] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11712), 1,
      anon_sym_RBRACK,
    STATE(7453), 1,
      sym_comment,
  [215029] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8274), 1,
      sym_identifier,
    STATE(7454), 1,
      sym_comment,
  [215042] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11714), 1,
      anon_sym_function,
    STATE(7455), 1,
      sym_comment,
  [215055] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11716), 1,
      sym_identifier,
    STATE(7456), 1,
      sym_comment,
  [215068] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11718), 1,
      anon_sym_RBRACK,
    STATE(7457), 1,
      sym_comment,
  [215081] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11720), 1,
      sym_identifier,
    STATE(7458), 1,
      sym_comment,
  [215094] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11722), 1,
      anon_sym_EQ_GT,
    STATE(7459), 1,
      sym_comment,
  [215107] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11724), 1,
      anon_sym_RBRACK,
    STATE(7460), 1,
      sym_comment,
  [215120] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8268), 1,
      sym_identifier,
    STATE(7461), 1,
      sym_comment,
  [215133] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11726), 1,
      anon_sym_function,
    STATE(7462), 1,
      sym_comment,
  [215146] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11728), 1,
      anon_sym_RBRACK,
    STATE(7463), 1,
      sym_comment,
  [215159] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11730), 1,
      sym_identifier,
    STATE(7464), 1,
      sym_comment,
  [215172] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11732), 1,
      sym_number,
    STATE(7465), 1,
      sym_comment,
  [215185] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8258), 1,
      sym_identifier,
    STATE(7466), 1,
      sym_comment,
  [215198] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11734), 1,
      anon_sym_function,
    STATE(7467), 1,
      sym_comment,
  [215211] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11736), 1,
      anon_sym_RBRACK,
    STATE(7468), 1,
      sym_comment,
  [215224] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11738), 1,
      sym_identifier,
    STATE(7469), 1,
      sym_comment,
  [215237] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11740), 1,
      anon_sym_RBRACK,
    STATE(7470), 1,
      sym_comment,
  [215250] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8250), 1,
      sym_identifier,
    STATE(7471), 1,
      sym_comment,
  [215263] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11742), 1,
      anon_sym_function,
    STATE(7472), 1,
      sym_comment,
  [215276] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11744), 1,
      anon_sym_RBRACK,
    STATE(7473), 1,
      sym_comment,
  [215289] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11746), 1,
      sym_identifier,
    STATE(7474), 1,
      sym_comment,
  [215302] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11748), 1,
      anon_sym_RBRACK,
    STATE(7475), 1,
      sym_comment,
  [215315] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8242), 1,
      sym_identifier,
    STATE(7476), 1,
      sym_comment,
  [215328] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11750), 1,
      anon_sym_function,
    STATE(7477), 1,
      sym_comment,
  [215341] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2696), 1,
      aux_sym_comment_token1,
    ACTIONS(11752), 1,
      anon_sym_RBRACK,
    STATE(7478), 1,
      sym_comment,
  [215354] = 1,
    ACTIONS(11754), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1852)] = 0,
  [SMALL_STATE(1853)] = 93,
  [SMALL_STATE(1854)] = 168,
  [SMALL_STATE(1855)] = 243,
  [SMALL_STATE(1856)] = 336,
  [SMALL_STATE(1857)] = 431,
  [SMALL_STATE(1858)] = 506,
  [SMALL_STATE(1859)] = 601,
  [SMALL_STATE(1860)] = 694,
  [SMALL_STATE(1861)] = 791,
  [SMALL_STATE(1862)] = 884,
  [SMALL_STATE(1863)] = 977,
  [SMALL_STATE(1864)] = 1070,
  [SMALL_STATE(1865)] = 1167,
  [SMALL_STATE(1866)] = 1260,
  [SMALL_STATE(1867)] = 1357,
  [SMALL_STATE(1868)] = 1450,
  [SMALL_STATE(1869)] = 1545,
  [SMALL_STATE(1870)] = 1638,
  [SMALL_STATE(1871)] = 1731,
  [SMALL_STATE(1872)] = 1824,
  [SMALL_STATE(1873)] = 1917,
  [SMALL_STATE(1874)] = 2012,
  [SMALL_STATE(1875)] = 2087,
  [SMALL_STATE(1876)] = 2180,
  [SMALL_STATE(1877)] = 2255,
  [SMALL_STATE(1878)] = 2330,
  [SMALL_STATE(1879)] = 2423,
  [SMALL_STATE(1880)] = 2498,
  [SMALL_STATE(1881)] = 2591,
  [SMALL_STATE(1882)] = 2686,
  [SMALL_STATE(1883)] = 2779,
  [SMALL_STATE(1884)] = 2874,
  [SMALL_STATE(1885)] = 2969,
  [SMALL_STATE(1886)] = 3062,
  [SMALL_STATE(1887)] = 3155,
  [SMALL_STATE(1888)] = 3248,
  [SMALL_STATE(1889)] = 3341,
  [SMALL_STATE(1890)] = 3436,
  [SMALL_STATE(1891)] = 3530,
  [SMALL_STATE(1892)] = 3626,
  [SMALL_STATE(1893)] = 3718,
  [SMALL_STATE(1894)] = 3814,
  [SMALL_STATE(1895)] = 3914,
  [SMALL_STATE(1896)] = 4010,
  [SMALL_STATE(1897)] = 4102,
  [SMALL_STATE(1898)] = 4196,
  [SMALL_STATE(1899)] = 4288,
  [SMALL_STATE(1900)] = 4362,
  [SMALL_STATE(1901)] = 4440,
  [SMALL_STATE(1902)] = 4532,
  [SMALL_STATE(1903)] = 4628,
  [SMALL_STATE(1904)] = 4720,
  [SMALL_STATE(1905)] = 4794,
  [SMALL_STATE(1906)] = 4889,
  [SMALL_STATE(1907)] = 4968,
  [SMALL_STATE(1908)] = 5045,
  [SMALL_STATE(1909)] = 5140,
  [SMALL_STATE(1910)] = 5231,
  [SMALL_STATE(1911)] = 5314,
  [SMALL_STATE(1912)] = 5407,
  [SMALL_STATE(1913)] = 5504,
  [SMALL_STATE(1914)] = 5595,
  [SMALL_STATE(1915)] = 5680,
  [SMALL_STATE(1916)] = 5763,
  [SMALL_STATE(1917)] = 5846,
  [SMALL_STATE(1918)] = 5937,
  [SMALL_STATE(1919)] = 6028,
  [SMALL_STATE(1920)] = 6111,
  [SMALL_STATE(1921)] = 6202,
  [SMALL_STATE(1922)] = 6299,
  [SMALL_STATE(1923)] = 6382,
  [SMALL_STATE(1924)] = 6473,
  [SMALL_STATE(1925)] = 6564,
  [SMALL_STATE(1926)] = 6647,
  [SMALL_STATE(1927)] = 6738,
  [SMALL_STATE(1928)] = 6829,
  [SMALL_STATE(1929)] = 6924,
  [SMALL_STATE(1930)] = 7019,
  [SMALL_STATE(1931)] = 7092,
  [SMALL_STATE(1932)] = 7177,
  [SMALL_STATE(1933)] = 7268,
  [SMALL_STATE(1934)] = 7341,
  [SMALL_STATE(1935)] = 7432,
  [SMALL_STATE(1936)] = 7507,
  [SMALL_STATE(1937)] = 7598,
  [SMALL_STATE(1938)] = 7692,
  [SMALL_STATE(1939)] = 7772,
  [SMALL_STATE(1940)] = 7850,
  [SMALL_STATE(1941)] = 7930,
  [SMALL_STATE(1942)] = 8012,
  [SMALL_STATE(1943)] = 8100,
  [SMALL_STATE(1944)] = 8190,
  [SMALL_STATE(1945)] = 8284,
  [SMALL_STATE(1946)] = 8366,
  [SMALL_STATE(1947)] = 8436,
  [SMALL_STATE(1948)] = 8514,
  [SMALL_STATE(1949)] = 8596,
  [SMALL_STATE(1950)] = 8680,
  [SMALL_STATE(1951)] = 8770,
  [SMALL_STATE(1952)] = 8852,
  [SMALL_STATE(1953)] = 8936,
  [SMALL_STATE(1954)] = 9030,
  [SMALL_STATE(1955)] = 9108,
  [SMALL_STATE(1956)] = 9178,
  [SMALL_STATE(1957)] = 9248,
  [SMALL_STATE(1958)] = 9338,
  [SMALL_STATE(1959)] = 9432,
  [SMALL_STATE(1960)] = 9512,
  [SMALL_STATE(1961)] = 9600,
  [SMALL_STATE(1962)] = 9692,
  [SMALL_STATE(1963)] = 9770,
  [SMALL_STATE(1964)] = 9852,
  [SMALL_STATE(1965)] = 9931,
  [SMALL_STATE(1966)] = 10020,
  [SMALL_STATE(1967)] = 10089,
  [SMALL_STATE(1968)] = 10178,
  [SMALL_STATE(1969)] = 10257,
  [SMALL_STATE(1970)] = 10330,
  [SMALL_STATE(1971)] = 10403,
  [SMALL_STATE(1972)] = 10472,
  [SMALL_STATE(1973)] = 10555,
  [SMALL_STATE(1974)] = 10632,
  [SMALL_STATE(1975)] = 10709,
  [SMALL_STATE(1976)] = 10794,
  [SMALL_STATE(1977)] = 10871,
  [SMALL_STATE(1978)] = 10948,
  [SMALL_STATE(1979)] = 11017,
  [SMALL_STATE(1980)] = 11096,
  [SMALL_STATE(1981)] = 11165,
  [SMALL_STATE(1982)] = 11258,
  [SMALL_STATE(1983)] = 11329,
  [SMALL_STATE(1984)] = 11398,
  [SMALL_STATE(1985)] = 11477,
  [SMALL_STATE(1986)] = 11556,
  [SMALL_STATE(1987)] = 11641,
  [SMALL_STATE(1988)] = 11720,
  [SMALL_STATE(1989)] = 11789,
  [SMALL_STATE(1990)] = 11866,
  [SMALL_STATE(1991)] = 11945,
  [SMALL_STATE(1992)] = 12026,
  [SMALL_STATE(1993)] = 12105,
  [SMALL_STATE(1994)] = 12176,
  [SMALL_STATE(1995)] = 12253,
  [SMALL_STATE(1996)] = 12324,
  [SMALL_STATE(1997)] = 12399,
  [SMALL_STATE(1998)] = 12470,
  [SMALL_STATE(1999)] = 12551,
  [SMALL_STATE(2000)] = 12622,
  [SMALL_STATE(2001)] = 12693,
  [SMALL_STATE(2002)] = 12766,
  [SMALL_STATE(2003)] = 12853,
  [SMALL_STATE(2004)] = 12924,
  [SMALL_STATE(2005)] = 12997,
  [SMALL_STATE(2006)] = 13074,
  [SMALL_STATE(2007)] = 13153,
  [SMALL_STATE(2008)] = 13222,
  [SMALL_STATE(2009)] = 13293,
  [SMALL_STATE(2010)] = 13372,
  [SMALL_STATE(2011)] = 13461,
  [SMALL_STATE(2012)] = 13532,
  [SMALL_STATE(2013)] = 13601,
  [SMALL_STATE(2014)] = 13676,
  [SMALL_STATE(2015)] = 13745,
  [SMALL_STATE(2016)] = 13814,
  [SMALL_STATE(2017)] = 13885,
  [SMALL_STATE(2018)] = 13956,
  [SMALL_STATE(2019)] = 14033,
  [SMALL_STATE(2020)] = 14116,
  [SMALL_STATE(2021)] = 14197,
  [SMALL_STATE(2022)] = 14280,
  [SMALL_STATE(2023)] = 14373,
  [SMALL_STATE(2024)] = 14449,
  [SMALL_STATE(2025)] = 14531,
  [SMALL_STATE(2026)] = 14609,
  [SMALL_STATE(2027)] = 14683,
  [SMALL_STATE(2028)] = 14765,
  [SMALL_STATE(2029)] = 14843,
  [SMALL_STATE(2030)] = 14925,
  [SMALL_STATE(2031)] = 15003,
  [SMALL_STATE(2032)] = 15081,
  [SMALL_STATE(2033)] = 15159,
  [SMALL_STATE(2034)] = 15243,
  [SMALL_STATE(2035)] = 15331,
  [SMALL_STATE(2036)] = 15409,
  [SMALL_STATE(2037)] = 15485,
  [SMALL_STATE(2038)] = 15563,
  [SMALL_STATE(2039)] = 15637,
  [SMALL_STATE(2040)] = 15713,
  [SMALL_STATE(2041)] = 15789,
  [SMALL_STATE(2042)] = 15867,
  [SMALL_STATE(2043)] = 15945,
  [SMALL_STATE(2044)] = 16027,
  [SMALL_STATE(2045)] = 16106,
  [SMALL_STATE(2046)] = 16179,
  [SMALL_STATE(2047)] = 16254,
  [SMALL_STATE(2048)] = 16329,
  [SMALL_STATE(2049)] = 16456,
  [SMALL_STATE(2050)] = 16583,
  [SMALL_STATE(2051)] = 16710,
  [SMALL_STATE(2052)] = 16781,
  [SMALL_STATE(2053)] = 16908,
  [SMALL_STATE(2054)] = 17035,
  [SMALL_STATE(2055)] = 17162,
  [SMALL_STATE(2056)] = 17243,
  [SMALL_STATE(2057)] = 17318,
  [SMALL_STATE(2058)] = 17445,
  [SMALL_STATE(2059)] = 17520,
  [SMALL_STATE(2060)] = 17595,
  [SMALL_STATE(2061)] = 17674,
  [SMALL_STATE(2062)] = 17749,
  [SMALL_STATE(2063)] = 17820,
  [SMALL_STATE(2064)] = 17897,
  [SMALL_STATE(2065)] = 17972,
  [SMALL_STATE(2066)] = 18047,
  [SMALL_STATE(2067)] = 18124,
  [SMALL_STATE(2068)] = 18203,
  [SMALL_STATE(2069)] = 18330,
  [SMALL_STATE(2070)] = 18457,
  [SMALL_STATE(2071)] = 18536,
  [SMALL_STATE(2072)] = 18610,
  [SMALL_STATE(2073)] = 18682,
  [SMALL_STATE(2074)] = 18758,
  [SMALL_STATE(2075)] = 18832,
  [SMALL_STATE(2076)] = 18906,
  [SMALL_STATE(2077)] = 18982,
  [SMALL_STATE(2078)] = 19056,
  [SMALL_STATE(2079)] = 19130,
  [SMALL_STATE(2080)] = 19204,
  [SMALL_STATE(2081)] = 19282,
  [SMALL_STATE(2082)] = 19356,
  [SMALL_STATE(2083)] = 19434,
  [SMALL_STATE(2084)] = 19508,
  [SMALL_STATE(2085)] = 19580,
  [SMALL_STATE(2086)] = 19653,
  [SMALL_STATE(2087)] = 19726,
  [SMALL_STATE(2088)] = 19797,
  [SMALL_STATE(2089)] = 19870,
  [SMALL_STATE(2090)] = 19993,
  [SMALL_STATE(2091)] = 20116,
  [SMALL_STATE(2092)] = 20189,
  [SMALL_STATE(2093)] = 20312,
  [SMALL_STATE(2094)] = 20385,
  [SMALL_STATE(2095)] = 20458,
  [SMALL_STATE(2096)] = 20581,
  [SMALL_STATE(2097)] = 20654,
  [SMALL_STATE(2098)] = 20777,
  [SMALL_STATE(2099)] = 20900,
  [SMALL_STATE(2100)] = 20973,
  [SMALL_STATE(2101)] = 21046,
  [SMALL_STATE(2102)] = 21119,
  [SMALL_STATE(2103)] = 21192,
  [SMALL_STATE(2104)] = 21315,
  [SMALL_STATE(2105)] = 21438,
  [SMALL_STATE(2106)] = 21561,
  [SMALL_STATE(2107)] = 21684,
  [SMALL_STATE(2108)] = 21807,
  [SMALL_STATE(2109)] = 21930,
  [SMALL_STATE(2110)] = 22003,
  [SMALL_STATE(2111)] = 22076,
  [SMALL_STATE(2112)] = 22149,
  [SMALL_STATE(2113)] = 22220,
  [SMALL_STATE(2114)] = 22343,
  [SMALL_STATE(2115)] = 22466,
  [SMALL_STATE(2116)] = 22539,
  [SMALL_STATE(2117)] = 22612,
  [SMALL_STATE(2118)] = 22735,
  [SMALL_STATE(2119)] = 22808,
  [SMALL_STATE(2120)] = 22931,
  [SMALL_STATE(2121)] = 23054,
  [SMALL_STATE(2122)] = 23177,
  [SMALL_STATE(2123)] = 23250,
  [SMALL_STATE(2124)] = 23373,
  [SMALL_STATE(2125)] = 23446,
  [SMALL_STATE(2126)] = 23569,
  [SMALL_STATE(2127)] = 23644,
  [SMALL_STATE(2128)] = 23767,
  [SMALL_STATE(2129)] = 23840,
  [SMALL_STATE(2130)] = 23963,
  [SMALL_STATE(2131)] = 24086,
  [SMALL_STATE(2132)] = 24209,
  [SMALL_STATE(2133)] = 24332,
  [SMALL_STATE(2134)] = 24455,
  [SMALL_STATE(2135)] = 24528,
  [SMALL_STATE(2136)] = 24651,
  [SMALL_STATE(2137)] = 24721,
  [SMALL_STATE(2138)] = 24791,
  [SMALL_STATE(2139)] = 24861,
  [SMALL_STATE(2140)] = 24931,
  [SMALL_STATE(2141)] = 25001,
  [SMALL_STATE(2142)] = 25071,
  [SMALL_STATE(2143)] = 25141,
  [SMALL_STATE(2144)] = 25211,
  [SMALL_STATE(2145)] = 25281,
  [SMALL_STATE(2146)] = 25400,
  [SMALL_STATE(2147)] = 25519,
  [SMALL_STATE(2148)] = 25638,
  [SMALL_STATE(2149)] = 25757,
  [SMALL_STATE(2150)] = 25876,
  [SMALL_STATE(2151)] = 25995,
  [SMALL_STATE(2152)] = 26114,
  [SMALL_STATE(2153)] = 26233,
  [SMALL_STATE(2154)] = 26352,
  [SMALL_STATE(2155)] = 26471,
  [SMALL_STATE(2156)] = 26595,
  [SMALL_STATE(2157)] = 26719,
  [SMALL_STATE(2158)] = 26843,
  [SMALL_STATE(2159)] = 26967,
  [SMALL_STATE(2160)] = 27091,
  [SMALL_STATE(2161)] = 27206,
  [SMALL_STATE(2162)] = 27323,
  [SMALL_STATE(2163)] = 27434,
  [SMALL_STATE(2164)] = 27551,
  [SMALL_STATE(2165)] = 27668,
  [SMALL_STATE(2166)] = 27785,
  [SMALL_STATE(2167)] = 27896,
  [SMALL_STATE(2168)] = 28013,
  [SMALL_STATE(2169)] = 28130,
  [SMALL_STATE(2170)] = 28247,
  [SMALL_STATE(2171)] = 28364,
  [SMALL_STATE(2172)] = 28475,
  [SMALL_STATE(2173)] = 28592,
  [SMALL_STATE(2174)] = 28709,
  [SMALL_STATE(2175)] = 28826,
  [SMALL_STATE(2176)] = 28937,
  [SMALL_STATE(2177)] = 29054,
  [SMALL_STATE(2178)] = 29171,
  [SMALL_STATE(2179)] = 29288,
  [SMALL_STATE(2180)] = 29405,
  [SMALL_STATE(2181)] = 29522,
  [SMALL_STATE(2182)] = 29639,
  [SMALL_STATE(2183)] = 29750,
  [SMALL_STATE(2184)] = 29867,
  [SMALL_STATE(2185)] = 29984,
  [SMALL_STATE(2186)] = 30101,
  [SMALL_STATE(2187)] = 30218,
  [SMALL_STATE(2188)] = 30335,
  [SMALL_STATE(2189)] = 30452,
  [SMALL_STATE(2190)] = 30569,
  [SMALL_STATE(2191)] = 30680,
  [SMALL_STATE(2192)] = 30797,
  [SMALL_STATE(2193)] = 30914,
  [SMALL_STATE(2194)] = 31031,
  [SMALL_STATE(2195)] = 31142,
  [SMALL_STATE(2196)] = 31259,
  [SMALL_STATE(2197)] = 31376,
  [SMALL_STATE(2198)] = 31493,
  [SMALL_STATE(2199)] = 31610,
  [SMALL_STATE(2200)] = 31727,
  [SMALL_STATE(2201)] = 31841,
  [SMALL_STATE(2202)] = 31903,
  [SMALL_STATE(2203)] = 32019,
  [SMALL_STATE(2204)] = 32081,
  [SMALL_STATE(2205)] = 32152,
  [SMALL_STATE(2206)] = 32229,
  [SMALL_STATE(2207)] = 32298,
  [SMALL_STATE(2208)] = 32369,
  [SMALL_STATE(2209)] = 32472,
  [SMALL_STATE(2210)] = 32543,
  [SMALL_STATE(2211)] = 32609,
  [SMALL_STATE(2212)] = 32669,
  [SMALL_STATE(2213)] = 32729,
  [SMALL_STATE(2214)] = 32789,
  [SMALL_STATE(2215)] = 32851,
  [SMALL_STATE(2216)] = 32911,
  [SMALL_STATE(2217)] = 32977,
  [SMALL_STATE(2218)] = 33043,
  [SMALL_STATE(2219)] = 33105,
  [SMALL_STATE(2220)] = 33165,
  [SMALL_STATE(2221)] = 33231,
  [SMALL_STATE(2222)] = 33295,
  [SMALL_STATE(2223)] = 33359,
  [SMALL_STATE(2224)] = 33419,
  [SMALL_STATE(2225)] = 33479,
  [SMALL_STATE(2226)] = 33541,
  [SMALL_STATE(2227)] = 33605,
  [SMALL_STATE(2228)] = 33664,
  [SMALL_STATE(2229)] = 33725,
  [SMALL_STATE(2230)] = 33784,
  [SMALL_STATE(2231)] = 33909,
  [SMALL_STATE(2232)] = 33994,
  [SMALL_STATE(2233)] = 34089,
  [SMALL_STATE(2234)] = 34198,
  [SMALL_STATE(2235)] = 34323,
  [SMALL_STATE(2236)] = 34390,
  [SMALL_STATE(2237)] = 34455,
  [SMALL_STATE(2238)] = 34514,
  [SMALL_STATE(2239)] = 34631,
  [SMALL_STATE(2240)] = 34756,
  [SMALL_STATE(2241)] = 34815,
  [SMALL_STATE(2242)] = 34932,
  [SMALL_STATE(2243)] = 35057,
  [SMALL_STATE(2244)] = 35116,
  [SMALL_STATE(2245)] = 35175,
  [SMALL_STATE(2246)] = 35234,
  [SMALL_STATE(2247)] = 35351,
  [SMALL_STATE(2248)] = 35410,
  [SMALL_STATE(2249)] = 35487,
  [SMALL_STATE(2250)] = 35604,
  [SMALL_STATE(2251)] = 35665,
  [SMALL_STATE(2252)] = 35724,
  [SMALL_STATE(2253)] = 35783,
  [SMALL_STATE(2254)] = 35842,
  [SMALL_STATE(2255)] = 35901,
  [SMALL_STATE(2256)] = 35960,
  [SMALL_STATE(2257)] = 36019,
  [SMALL_STATE(2258)] = 36078,
  [SMALL_STATE(2259)] = 36137,
  [SMALL_STATE(2260)] = 36196,
  [SMALL_STATE(2261)] = 36255,
  [SMALL_STATE(2262)] = 36316,
  [SMALL_STATE(2263)] = 36375,
  [SMALL_STATE(2264)] = 36434,
  [SMALL_STATE(2265)] = 36493,
  [SMALL_STATE(2266)] = 36552,
  [SMALL_STATE(2267)] = 36611,
  [SMALL_STATE(2268)] = 36670,
  [SMALL_STATE(2269)] = 36729,
  [SMALL_STATE(2270)] = 36788,
  [SMALL_STATE(2271)] = 36853,
  [SMALL_STATE(2272)] = 36918,
  [SMALL_STATE(2273)] = 36997,
  [SMALL_STATE(2274)] = 37062,
  [SMALL_STATE(2275)] = 37121,
  [SMALL_STATE(2276)] = 37246,
  [SMALL_STATE(2277)] = 37305,
  [SMALL_STATE(2278)] = 37364,
  [SMALL_STATE(2279)] = 37423,
  [SMALL_STATE(2280)] = 37488,
  [SMALL_STATE(2281)] = 37553,
  [SMALL_STATE(2282)] = 37618,
  [SMALL_STATE(2283)] = 37677,
  [SMALL_STATE(2284)] = 37736,
  [SMALL_STATE(2285)] = 37795,
  [SMALL_STATE(2286)] = 37854,
  [SMALL_STATE(2287)] = 37913,
  [SMALL_STATE(2288)] = 37972,
  [SMALL_STATE(2289)] = 38031,
  [SMALL_STATE(2290)] = 38090,
  [SMALL_STATE(2291)] = 38149,
  [SMALL_STATE(2292)] = 38208,
  [SMALL_STATE(2293)] = 38267,
  [SMALL_STATE(2294)] = 38328,
  [SMALL_STATE(2295)] = 38387,
  [SMALL_STATE(2296)] = 38448,
  [SMALL_STATE(2297)] = 38509,
  [SMALL_STATE(2298)] = 38568,
  [SMALL_STATE(2299)] = 38627,
  [SMALL_STATE(2300)] = 38722,
  [SMALL_STATE(2301)] = 38781,
  [SMALL_STATE(2302)] = 38840,
  [SMALL_STATE(2303)] = 38899,
  [SMALL_STATE(2304)] = 38958,
  [SMALL_STATE(2305)] = 39017,
  [SMALL_STATE(2306)] = 39076,
  [SMALL_STATE(2307)] = 39135,
  [SMALL_STATE(2308)] = 39234,
  [SMALL_STATE(2309)] = 39293,
  [SMALL_STATE(2310)] = 39410,
  [SMALL_STATE(2311)] = 39473,
  [SMALL_STATE(2312)] = 39590,
  [SMALL_STATE(2313)] = 39685,
  [SMALL_STATE(2314)] = 39744,
  [SMALL_STATE(2315)] = 39803,
  [SMALL_STATE(2316)] = 39890,
  [SMALL_STATE(2317)] = 39975,
  [SMALL_STATE(2318)] = 40078,
  [SMALL_STATE(2319)] = 40137,
  [SMALL_STATE(2320)] = 40238,
  [SMALL_STATE(2321)] = 40363,
  [SMALL_STATE(2322)] = 40422,
  [SMALL_STATE(2323)] = 40539,
  [SMALL_STATE(2324)] = 40664,
  [SMALL_STATE(2325)] = 40723,
  [SMALL_STATE(2326)] = 40782,
  [SMALL_STATE(2327)] = 40841,
  [SMALL_STATE(2328)] = 40900,
  [SMALL_STATE(2329)] = 41007,
  [SMALL_STATE(2330)] = 41066,
  [SMALL_STATE(2331)] = 41171,
  [SMALL_STATE(2332)] = 41230,
  [SMALL_STATE(2333)] = 41289,
  [SMALL_STATE(2334)] = 41406,
  [SMALL_STATE(2335)] = 41465,
  [SMALL_STATE(2336)] = 41524,
  [SMALL_STATE(2337)] = 41589,
  [SMALL_STATE(2338)] = 41648,
  [SMALL_STATE(2339)] = 41713,
  [SMALL_STATE(2340)] = 41774,
  [SMALL_STATE(2341)] = 41833,
  [SMALL_STATE(2342)] = 41914,
  [SMALL_STATE(2343)] = 41973,
  [SMALL_STATE(2344)] = 42090,
  [SMALL_STATE(2345)] = 42149,
  [SMALL_STATE(2346)] = 42212,
  [SMALL_STATE(2347)] = 42277,
  [SMALL_STATE(2348)] = 42338,
  [SMALL_STATE(2349)] = 42399,
  [SMALL_STATE(2350)] = 42458,
  [SMALL_STATE(2351)] = 42575,
  [SMALL_STATE(2352)] = 42634,
  [SMALL_STATE(2353)] = 42751,
  [SMALL_STATE(2354)] = 42810,
  [SMALL_STATE(2355)] = 42869,
  [SMALL_STATE(2356)] = 42986,
  [SMALL_STATE(2357)] = 43103,
  [SMALL_STATE(2358)] = 43194,
  [SMALL_STATE(2359)] = 43311,
  [SMALL_STATE(2360)] = 43376,
  [SMALL_STATE(2361)] = 43435,
  [SMALL_STATE(2362)] = 43494,
  [SMALL_STATE(2363)] = 43553,
  [SMALL_STATE(2364)] = 43612,
  [SMALL_STATE(2365)] = 43671,
  [SMALL_STATE(2366)] = 43732,
  [SMALL_STATE(2367)] = 43797,
  [SMALL_STATE(2368)] = 43914,
  [SMALL_STATE(2369)] = 44039,
  [SMALL_STATE(2370)] = 44098,
  [SMALL_STATE(2371)] = 44159,
  [SMALL_STATE(2372)] = 44284,
  [SMALL_STATE(2373)] = 44343,
  [SMALL_STATE(2374)] = 44402,
  [SMALL_STATE(2375)] = 44461,
  [SMALL_STATE(2376)] = 44548,
  [SMALL_STATE(2377)] = 44643,
  [SMALL_STATE(2378)] = 44738,
  [SMALL_STATE(2379)] = 44801,
  [SMALL_STATE(2380)] = 44868,
  [SMALL_STATE(2381)] = 44927,
  [SMALL_STATE(2382)] = 45022,
  [SMALL_STATE(2383)] = 45085,
  [SMALL_STATE(2384)] = 45152,
  [SMALL_STATE(2385)] = 45211,
  [SMALL_STATE(2386)] = 45270,
  [SMALL_STATE(2387)] = 45329,
  [SMALL_STATE(2388)] = 45390,
  [SMALL_STATE(2389)] = 45448,
  [SMALL_STATE(2390)] = 45506,
  [SMALL_STATE(2391)] = 45594,
  [SMALL_STATE(2392)] = 45652,
  [SMALL_STATE(2393)] = 45768,
  [SMALL_STATE(2394)] = 45854,
  [SMALL_STATE(2395)] = 45912,
  [SMALL_STATE(2396)] = 46000,
  [SMALL_STATE(2397)] = 46058,
  [SMALL_STATE(2398)] = 46116,
  [SMALL_STATE(2399)] = 46232,
  [SMALL_STATE(2400)] = 46290,
  [SMALL_STATE(2401)] = 46392,
  [SMALL_STATE(2402)] = 46466,
  [SMALL_STATE(2403)] = 46586,
  [SMALL_STATE(2404)] = 46644,
  [SMALL_STATE(2405)] = 46702,
  [SMALL_STATE(2406)] = 46760,
  [SMALL_STATE(2407)] = 46848,
  [SMALL_STATE(2408)] = 46964,
  [SMALL_STATE(2409)] = 47048,
  [SMALL_STATE(2410)] = 47136,
  [SMALL_STATE(2411)] = 47252,
  [SMALL_STATE(2412)] = 47338,
  [SMALL_STATE(2413)] = 47458,
  [SMALL_STATE(2414)] = 47522,
  [SMALL_STATE(2415)] = 47580,
  [SMALL_STATE(2416)] = 47696,
  [SMALL_STATE(2417)] = 47816,
  [SMALL_STATE(2418)] = 47936,
  [SMALL_STATE(2419)] = 47994,
  [SMALL_STATE(2420)] = 48052,
  [SMALL_STATE(2421)] = 48110,
  [SMALL_STATE(2422)] = 48168,
  [SMALL_STATE(2423)] = 48284,
  [SMALL_STATE(2424)] = 48368,
  [SMALL_STATE(2425)] = 48426,
  [SMALL_STATE(2426)] = 48484,
  [SMALL_STATE(2427)] = 48542,
  [SMALL_STATE(2428)] = 48600,
  [SMALL_STATE(2429)] = 48720,
  [SMALL_STATE(2430)] = 48840,
  [SMALL_STATE(2431)] = 48898,
  [SMALL_STATE(2432)] = 49014,
  [SMALL_STATE(2433)] = 49072,
  [SMALL_STATE(2434)] = 49148,
  [SMALL_STATE(2435)] = 49234,
  [SMALL_STATE(2436)] = 49292,
  [SMALL_STATE(2437)] = 49350,
  [SMALL_STATE(2438)] = 49428,
  [SMALL_STATE(2439)] = 49486,
  [SMALL_STATE(2440)] = 49572,
  [SMALL_STATE(2441)] = 49630,
  [SMALL_STATE(2442)] = 49688,
  [SMALL_STATE(2443)] = 49746,
  [SMALL_STATE(2444)] = 49804,
  [SMALL_STATE(2445)] = 49862,
  [SMALL_STATE(2446)] = 49920,
  [SMALL_STATE(2447)] = 49978,
  [SMALL_STATE(2448)] = 50078,
  [SMALL_STATE(2449)] = 50198,
  [SMALL_STATE(2450)] = 50256,
  [SMALL_STATE(2451)] = 50314,
  [SMALL_STATE(2452)] = 50372,
  [SMALL_STATE(2453)] = 50430,
  [SMALL_STATE(2454)] = 50488,
  [SMALL_STATE(2455)] = 50546,
  [SMALL_STATE(2456)] = 50664,
  [SMALL_STATE(2457)] = 50762,
  [SMALL_STATE(2458)] = 50820,
  [SMALL_STATE(2459)] = 50878,
  [SMALL_STATE(2460)] = 50936,
  [SMALL_STATE(2461)] = 50994,
  [SMALL_STATE(2462)] = 51110,
  [SMALL_STATE(2463)] = 51168,
  [SMALL_STATE(2464)] = 51284,
  [SMALL_STATE(2465)] = 51374,
  [SMALL_STATE(2466)] = 51434,
  [SMALL_STATE(2467)] = 51554,
  [SMALL_STATE(2468)] = 51674,
  [SMALL_STATE(2469)] = 51794,
  [SMALL_STATE(2470)] = 51914,
  [SMALL_STATE(2471)] = 51980,
  [SMALL_STATE(2472)] = 52080,
  [SMALL_STATE(2473)] = 52200,
  [SMALL_STATE(2474)] = 52258,
  [SMALL_STATE(2475)] = 52320,
  [SMALL_STATE(2476)] = 52378,
  [SMALL_STATE(2477)] = 52446,
  [SMALL_STATE(2478)] = 52566,
  [SMALL_STATE(2479)] = 52686,
  [SMALL_STATE(2480)] = 52806,
  [SMALL_STATE(2481)] = 52864,
  [SMALL_STATE(2482)] = 52922,
  [SMALL_STATE(2483)] = 53038,
  [SMALL_STATE(2484)] = 53154,
  [SMALL_STATE(2485)] = 53216,
  [SMALL_STATE(2486)] = 53332,
  [SMALL_STATE(2487)] = 53448,
  [SMALL_STATE(2488)] = 53516,
  [SMALL_STATE(2489)] = 53584,
  [SMALL_STATE(2490)] = 53642,
  [SMALL_STATE(2491)] = 53702,
  [SMALL_STATE(2492)] = 53800,
  [SMALL_STATE(2493)] = 53916,
  [SMALL_STATE(2494)] = 53974,
  [SMALL_STATE(2495)] = 54090,
  [SMALL_STATE(2496)] = 54148,
  [SMALL_STATE(2497)] = 54206,
  [SMALL_STATE(2498)] = 54264,
  [SMALL_STATE(2499)] = 54380,
  [SMALL_STATE(2500)] = 54496,
  [SMALL_STATE(2501)] = 54556,
  [SMALL_STATE(2502)] = 54614,
  [SMALL_STATE(2503)] = 54672,
  [SMALL_STATE(2504)] = 54788,
  [SMALL_STATE(2505)] = 54904,
  [SMALL_STATE(2506)] = 55024,
  [SMALL_STATE(2507)] = 55140,
  [SMALL_STATE(2508)] = 55228,
  [SMALL_STATE(2509)] = 55286,
  [SMALL_STATE(2510)] = 55402,
  [SMALL_STATE(2511)] = 55488,
  [SMALL_STATE(2512)] = 55604,
  [SMALL_STATE(2513)] = 55662,
  [SMALL_STATE(2514)] = 55720,
  [SMALL_STATE(2515)] = 55778,
  [SMALL_STATE(2516)] = 55836,
  [SMALL_STATE(2517)] = 55944,
  [SMALL_STATE(2518)] = 56002,
  [SMALL_STATE(2519)] = 56096,
  [SMALL_STATE(2520)] = 56190,
  [SMALL_STATE(2521)] = 56306,
  [SMALL_STATE(2522)] = 56364,
  [SMALL_STATE(2523)] = 56422,
  [SMALL_STATE(2524)] = 56538,
  [SMALL_STATE(2525)] = 56646,
  [SMALL_STATE(2526)] = 56704,
  [SMALL_STATE(2527)] = 56762,
  [SMALL_STATE(2528)] = 56848,
  [SMALL_STATE(2529)] = 56954,
  [SMALL_STATE(2530)] = 57012,
  [SMALL_STATE(2531)] = 57116,
  [SMALL_STATE(2532)] = 57174,
  [SMALL_STATE(2533)] = 57232,
  [SMALL_STATE(2534)] = 57322,
  [SMALL_STATE(2535)] = 57438,
  [SMALL_STATE(2536)] = 57496,
  [SMALL_STATE(2537)] = 57612,
  [SMALL_STATE(2538)] = 57728,
  [SMALL_STATE(2539)] = 57804,
  [SMALL_STATE(2540)] = 57920,
  [SMALL_STATE(2541)] = 57978,
  [SMALL_STATE(2542)] = 58036,
  [SMALL_STATE(2543)] = 58116,
  [SMALL_STATE(2544)] = 58174,
  [SMALL_STATE(2545)] = 58234,
  [SMALL_STATE(2546)] = 58292,
  [SMALL_STATE(2547)] = 58412,
  [SMALL_STATE(2548)] = 58470,
  [SMALL_STATE(2549)] = 58528,
  [SMALL_STATE(2550)] = 58586,
  [SMALL_STATE(2551)] = 58644,
  [SMALL_STATE(2552)] = 58730,
  [SMALL_STATE(2553)] = 58792,
  [SMALL_STATE(2554)] = 58852,
  [SMALL_STATE(2555)] = 58910,
  [SMALL_STATE(2556)] = 58996,
  [SMALL_STATE(2557)] = 59080,
  [SMALL_STATE(2558)] = 59196,
  [SMALL_STATE(2559)] = 59254,
  [SMALL_STATE(2560)] = 59356,
  [SMALL_STATE(2561)] = 59414,
  [SMALL_STATE(2562)] = 59532,
  [SMALL_STATE(2563)] = 59612,
  [SMALL_STATE(2564)] = 59690,
  [SMALL_STATE(2565)] = 59794,
  [SMALL_STATE(2566)] = 59852,
  [SMALL_STATE(2567)] = 59910,
  [SMALL_STATE(2568)] = 59998,
  [SMALL_STATE(2569)] = 60056,
  [SMALL_STATE(2570)] = 60140,
  [SMALL_STATE(2571)] = 60204,
  [SMALL_STATE(2572)] = 60310,
  [SMALL_STATE(2573)] = 60374,
  [SMALL_STATE(2574)] = 60494,
  [SMALL_STATE(2575)] = 60580,
  [SMALL_STATE(2576)] = 60700,
  [SMALL_STATE(2577)] = 60820,
  [SMALL_STATE(2578)] = 60939,
  [SMALL_STATE(2579)] = 61006,
  [SMALL_STATE(2580)] = 61125,
  [SMALL_STATE(2581)] = 61210,
  [SMALL_STATE(2582)] = 61327,
  [SMALL_STATE(2583)] = 61388,
  [SMALL_STATE(2584)] = 61449,
  [SMALL_STATE(2585)] = 61564,
  [SMALL_STATE(2586)] = 61629,
  [SMALL_STATE(2587)] = 61744,
  [SMALL_STATE(2588)] = 61863,
  [SMALL_STATE(2589)] = 61982,
  [SMALL_STATE(2590)] = 62063,
  [SMALL_STATE(2591)] = 62124,
  [SMALL_STATE(2592)] = 62241,
  [SMALL_STATE(2593)] = 62356,
  [SMALL_STATE(2594)] = 62419,
  [SMALL_STATE(2595)] = 62476,
  [SMALL_STATE(2596)] = 62595,
  [SMALL_STATE(2597)] = 62680,
  [SMALL_STATE(2598)] = 62795,
  [SMALL_STATE(2599)] = 62854,
  [SMALL_STATE(2600)] = 62969,
  [SMALL_STATE(2601)] = 63084,
  [SMALL_STATE(2602)] = 63203,
  [SMALL_STATE(2603)] = 63260,
  [SMALL_STATE(2604)] = 63375,
  [SMALL_STATE(2605)] = 63456,
  [SMALL_STATE(2606)] = 63521,
  [SMALL_STATE(2607)] = 63636,
  [SMALL_STATE(2608)] = 63717,
  [SMALL_STATE(2609)] = 63832,
  [SMALL_STATE(2610)] = 63947,
  [SMALL_STATE(2611)] = 64028,
  [SMALL_STATE(2612)] = 64143,
  [SMALL_STATE(2613)] = 64258,
  [SMALL_STATE(2614)] = 64373,
  [SMALL_STATE(2615)] = 64448,
  [SMALL_STATE(2616)] = 64563,
  [SMALL_STATE(2617)] = 64646,
  [SMALL_STATE(2618)] = 64723,
  [SMALL_STATE(2619)] = 64782,
  [SMALL_STATE(2620)] = 64847,
  [SMALL_STATE(2621)] = 64904,
  [SMALL_STATE(2622)] = 65023,
  [SMALL_STATE(2623)] = 65140,
  [SMALL_STATE(2624)] = 65259,
  [SMALL_STATE(2625)] = 65322,
  [SMALL_STATE(2626)] = 65441,
  [SMALL_STATE(2627)] = 65560,
  [SMALL_STATE(2628)] = 65623,
  [SMALL_STATE(2629)] = 65742,
  [SMALL_STATE(2630)] = 65861,
  [SMALL_STATE(2631)] = 65980,
  [SMALL_STATE(2632)] = 66099,
  [SMALL_STATE(2633)] = 66218,
  [SMALL_STATE(2634)] = 66337,
  [SMALL_STATE(2635)] = 66454,
  [SMALL_STATE(2636)] = 66541,
  [SMALL_STATE(2637)] = 66602,
  [SMALL_STATE(2638)] = 66717,
  [SMALL_STATE(2639)] = 66798,
  [SMALL_STATE(2640)] = 66855,
  [SMALL_STATE(2641)] = 66912,
  [SMALL_STATE(2642)] = 67031,
  [SMALL_STATE(2643)] = 67088,
  [SMALL_STATE(2644)] = 67207,
  [SMALL_STATE(2645)] = 67322,
  [SMALL_STATE(2646)] = 67437,
  [SMALL_STATE(2647)] = 67556,
  [SMALL_STATE(2648)] = 67645,
  [SMALL_STATE(2649)] = 67708,
  [SMALL_STATE(2650)] = 67823,
  [SMALL_STATE(2651)] = 67942,
  [SMALL_STATE(2652)] = 68061,
  [SMALL_STATE(2653)] = 68140,
  [SMALL_STATE(2654)] = 68259,
  [SMALL_STATE(2655)] = 68376,
  [SMALL_STATE(2656)] = 68495,
  [SMALL_STATE(2657)] = 68614,
  [SMALL_STATE(2658)] = 68733,
  [SMALL_STATE(2659)] = 68836,
  [SMALL_STATE(2660)] = 68903,
  [SMALL_STATE(2661)] = 68962,
  [SMALL_STATE(2662)] = 69081,
  [SMALL_STATE(2663)] = 69140,
  [SMALL_STATE(2664)] = 69205,
  [SMALL_STATE(2665)] = 69270,
  [SMALL_STATE(2666)] = 69333,
  [SMALL_STATE(2667)] = 69438,
  [SMALL_STATE(2668)] = 69553,
  [SMALL_STATE(2669)] = 69638,
  [SMALL_STATE(2670)] = 69753,
  [SMALL_STATE(2671)] = 69872,
  [SMALL_STATE(2672)] = 69979,
  [SMALL_STATE(2673)] = 70076,
  [SMALL_STATE(2674)] = 70175,
  [SMALL_STATE(2675)] = 70276,
  [SMALL_STATE(2676)] = 70369,
  [SMALL_STATE(2677)] = 70452,
  [SMALL_STATE(2678)] = 70537,
  [SMALL_STATE(2679)] = 70656,
  [SMALL_STATE(2680)] = 70775,
  [SMALL_STATE(2681)] = 70840,
  [SMALL_STATE(2682)] = 70959,
  [SMALL_STATE(2683)] = 71021,
  [SMALL_STATE(2684)] = 71077,
  [SMALL_STATE(2685)] = 71133,
  [SMALL_STATE(2686)] = 71189,
  [SMALL_STATE(2687)] = 71245,
  [SMALL_STATE(2688)] = 71301,
  [SMALL_STATE(2689)] = 71357,
  [SMALL_STATE(2690)] = 71413,
  [SMALL_STATE(2691)] = 71469,
  [SMALL_STATE(2692)] = 71525,
  [SMALL_STATE(2693)] = 71581,
  [SMALL_STATE(2694)] = 71637,
  [SMALL_STATE(2695)] = 71693,
  [SMALL_STATE(2696)] = 71807,
  [SMALL_STATE(2697)] = 71865,
  [SMALL_STATE(2698)] = 71927,
  [SMALL_STATE(2699)] = 71991,
  [SMALL_STATE(2700)] = 72105,
  [SMALL_STATE(2701)] = 72167,
  [SMALL_STATE(2702)] = 72229,
  [SMALL_STATE(2703)] = 72285,
  [SMALL_STATE(2704)] = 72341,
  [SMALL_STATE(2705)] = 72431,
  [SMALL_STATE(2706)] = 72487,
  [SMALL_STATE(2707)] = 72543,
  [SMALL_STATE(2708)] = 72599,
  [SMALL_STATE(2709)] = 72669,
  [SMALL_STATE(2710)] = 72725,
  [SMALL_STATE(2711)] = 72785,
  [SMALL_STATE(2712)] = 72847,
  [SMALL_STATE(2713)] = 72903,
  [SMALL_STATE(2714)] = 72965,
  [SMALL_STATE(2715)] = 73061,
  [SMALL_STATE(2716)] = 73117,
  [SMALL_STATE(2717)] = 73199,
  [SMALL_STATE(2718)] = 73255,
  [SMALL_STATE(2719)] = 73313,
  [SMALL_STATE(2720)] = 73371,
  [SMALL_STATE(2721)] = 73427,
  [SMALL_STATE(2722)] = 73489,
  [SMALL_STATE(2723)] = 73545,
  [SMALL_STATE(2724)] = 73603,
  [SMALL_STATE(2725)] = 73681,
  [SMALL_STATE(2726)] = 73739,
  [SMALL_STATE(2727)] = 73795,
  [SMALL_STATE(2728)] = 73875,
  [SMALL_STATE(2729)] = 73931,
  [SMALL_STATE(2730)] = 73987,
  [SMALL_STATE(2731)] = 74043,
  [SMALL_STATE(2732)] = 74099,
  [SMALL_STATE(2733)] = 74155,
  [SMALL_STATE(2734)] = 74211,
  [SMALL_STATE(2735)] = 74267,
  [SMALL_STATE(2736)] = 74323,
  [SMALL_STATE(2737)] = 74379,
  [SMALL_STATE(2738)] = 74435,
  [SMALL_STATE(2739)] = 74491,
  [SMALL_STATE(2740)] = 74553,
  [SMALL_STATE(2741)] = 74669,
  [SMALL_STATE(2742)] = 74785,
  [SMALL_STATE(2743)] = 74847,
  [SMALL_STATE(2744)] = 74909,
  [SMALL_STATE(2745)] = 74973,
  [SMALL_STATE(2746)] = 75055,
  [SMALL_STATE(2747)] = 75117,
  [SMALL_STATE(2748)] = 75173,
  [SMALL_STATE(2749)] = 75231,
  [SMALL_STATE(2750)] = 75287,
  [SMALL_STATE(2751)] = 75349,
  [SMALL_STATE(2752)] = 75463,
  [SMALL_STATE(2753)] = 75519,
  [SMALL_STATE(2754)] = 75581,
  [SMALL_STATE(2755)] = 75639,
  [SMALL_STATE(2756)] = 75707,
  [SMALL_STATE(2757)] = 75763,
  [SMALL_STATE(2758)] = 75845,
  [SMALL_STATE(2759)] = 75959,
  [SMALL_STATE(2760)] = 76073,
  [SMALL_STATE(2761)] = 76187,
  [SMALL_STATE(2762)] = 76301,
  [SMALL_STATE(2763)] = 76415,
  [SMALL_STATE(2764)] = 76471,
  [SMALL_STATE(2765)] = 76585,
  [SMALL_STATE(2766)] = 76673,
  [SMALL_STATE(2767)] = 76751,
  [SMALL_STATE(2768)] = 76865,
  [SMALL_STATE(2769)] = 76967,
  [SMALL_STATE(2770)] = 77023,
  [SMALL_STATE(2771)] = 77127,
  [SMALL_STATE(2772)] = 77211,
  [SMALL_STATE(2773)] = 77267,
  [SMALL_STATE(2774)] = 77365,
  [SMALL_STATE(2775)] = 77421,
  [SMALL_STATE(2776)] = 77477,
  [SMALL_STATE(2777)] = 77577,
  [SMALL_STATE(2778)] = 77633,
  [SMALL_STATE(2779)] = 77715,
  [SMALL_STATE(2780)] = 77797,
  [SMALL_STATE(2781)] = 77875,
  [SMALL_STATE(2782)] = 77931,
  [SMALL_STATE(2783)] = 78045,
  [SMALL_STATE(2784)] = 78115,
  [SMALL_STATE(2785)] = 78229,
  [SMALL_STATE(2786)] = 78343,
  [SMALL_STATE(2787)] = 78457,
  [SMALL_STATE(2788)] = 78513,
  [SMALL_STATE(2789)] = 78569,
  [SMALL_STATE(2790)] = 78683,
  [SMALL_STATE(2791)] = 78797,
  [SMALL_STATE(2792)] = 78885,
  [SMALL_STATE(2793)] = 78965,
  [SMALL_STATE(2794)] = 79039,
  [SMALL_STATE(2795)] = 79095,
  [SMALL_STATE(2796)] = 79173,
  [SMALL_STATE(2797)] = 79229,
  [SMALL_STATE(2798)] = 79331,
  [SMALL_STATE(2799)] = 79435,
  [SMALL_STATE(2800)] = 79491,
  [SMALL_STATE(2801)] = 79575,
  [SMALL_STATE(2802)] = 79671,
  [SMALL_STATE(2803)] = 79769,
  [SMALL_STATE(2804)] = 79869,
  [SMALL_STATE(2805)] = 79951,
  [SMALL_STATE(2806)] = 80033,
  [SMALL_STATE(2807)] = 80117,
  [SMALL_STATE(2808)] = 80173,
  [SMALL_STATE(2809)] = 80231,
  [SMALL_STATE(2810)] = 80315,
  [SMALL_STATE(2811)] = 80407,
  [SMALL_STATE(2812)] = 80499,
  [SMALL_STATE(2813)] = 80605,
  [SMALL_STATE(2814)] = 80661,
  [SMALL_STATE(2815)] = 80775,
  [SMALL_STATE(2816)] = 80881,
  [SMALL_STATE(2817)] = 80995,
  [SMALL_STATE(2818)] = 81109,
  [SMALL_STATE(2819)] = 81165,
  [SMALL_STATE(2820)] = 81221,
  [SMALL_STATE(2821)] = 81277,
  [SMALL_STATE(2822)] = 81391,
  [SMALL_STATE(2823)] = 81505,
  [SMALL_STATE(2824)] = 81619,
  [SMALL_STATE(2825)] = 81735,
  [SMALL_STATE(2826)] = 81849,
  [SMALL_STATE(2827)] = 81963,
  [SMALL_STATE(2828)] = 82077,
  [SMALL_STATE(2829)] = 82193,
  [SMALL_STATE(2830)] = 82249,
  [SMALL_STATE(2831)] = 82339,
  [SMALL_STATE(2832)] = 82453,
  [SMALL_STATE(2833)] = 82509,
  [SMALL_STATE(2834)] = 82623,
  [SMALL_STATE(2835)] = 82737,
  [SMALL_STATE(2836)] = 82853,
  [SMALL_STATE(2837)] = 82967,
  [SMALL_STATE(2838)] = 83081,
  [SMALL_STATE(2839)] = 83143,
  [SMALL_STATE(2840)] = 83257,
  [SMALL_STATE(2841)] = 83313,
  [SMALL_STATE(2842)] = 83375,
  [SMALL_STATE(2843)] = 83465,
  [SMALL_STATE(2844)] = 83555,
  [SMALL_STATE(2845)] = 83613,
  [SMALL_STATE(2846)] = 83671,
  [SMALL_STATE(2847)] = 83733,
  [SMALL_STATE(2848)] = 83795,
  [SMALL_STATE(2849)] = 83851,
  [SMALL_STATE(2850)] = 83913,
  [SMALL_STATE(2851)] = 83973,
  [SMALL_STATE(2852)] = 84029,
  [SMALL_STATE(2853)] = 84085,
  [SMALL_STATE(2854)] = 84141,
  [SMALL_STATE(2855)] = 84197,
  [SMALL_STATE(2856)] = 84253,
  [SMALL_STATE(2857)] = 84309,
  [SMALL_STATE(2858)] = 84367,
  [SMALL_STATE(2859)] = 84423,
  [SMALL_STATE(2860)] = 84479,
  [SMALL_STATE(2861)] = 84593,
  [SMALL_STATE(2862)] = 84707,
  [SMALL_STATE(2863)] = 84775,
  [SMALL_STATE(2864)] = 84843,
  [SMALL_STATE(2865)] = 84899,
  [SMALL_STATE(2866)] = 84955,
  [SMALL_STATE(2867)] = 85013,
  [SMALL_STATE(2868)] = 85069,
  [SMALL_STATE(2869)] = 85125,
  [SMALL_STATE(2870)] = 85185,
  [SMALL_STATE(2871)] = 85241,
  [SMALL_STATE(2872)] = 85297,
  [SMALL_STATE(2873)] = 85353,
  [SMALL_STATE(2874)] = 85409,
  [SMALL_STATE(2875)] = 85485,
  [SMALL_STATE(2876)] = 85553,
  [SMALL_STATE(2877)] = 85635,
  [SMALL_STATE(2878)] = 85697,
  [SMALL_STATE(2879)] = 85811,
  [SMALL_STATE(2880)] = 85879,
  [SMALL_STATE(2881)] = 85941,
  [SMALL_STATE(2882)] = 86005,
  [SMALL_STATE(2883)] = 86121,
  [SMALL_STATE(2884)] = 86195,
  [SMALL_STATE(2885)] = 86253,
  [SMALL_STATE(2886)] = 86309,
  [SMALL_STATE(2887)] = 86365,
  [SMALL_STATE(2888)] = 86425,
  [SMALL_STATE(2889)] = 86481,
  [SMALL_STATE(2890)] = 86559,
  [SMALL_STATE(2891)] = 86615,
  [SMALL_STATE(2892)] = 86683,
  [SMALL_STATE(2893)] = 86739,
  [SMALL_STATE(2894)] = 86807,
  [SMALL_STATE(2895)] = 86889,
  [SMALL_STATE(2896)] = 87003,
  [SMALL_STATE(2897)] = 87083,
  [SMALL_STATE(2898)] = 87139,
  [SMALL_STATE(2899)] = 87197,
  [SMALL_STATE(2900)] = 87253,
  [SMALL_STATE(2901)] = 87329,
  [SMALL_STATE(2902)] = 87407,
  [SMALL_STATE(2903)] = 87521,
  [SMALL_STATE(2904)] = 87603,
  [SMALL_STATE(2905)] = 87693,
  [SMALL_STATE(2906)] = 87783,
  [SMALL_STATE(2907)] = 87865,
  [SMALL_STATE(2908)] = 87947,
  [SMALL_STATE(2909)] = 88015,
  [SMALL_STATE(2910)] = 88073,
  [SMALL_STATE(2911)] = 88187,
  [SMALL_STATE(2912)] = 88245,
  [SMALL_STATE(2913)] = 88359,
  [SMALL_STATE(2914)] = 88449,
  [SMALL_STATE(2915)] = 88505,
  [SMALL_STATE(2916)] = 88573,
  [SMALL_STATE(2917)] = 88631,
  [SMALL_STATE(2918)] = 88709,
  [SMALL_STATE(2919)] = 88770,
  [SMALL_STATE(2920)] = 88851,
  [SMALL_STATE(2921)] = 88924,
  [SMALL_STATE(2922)] = 88987,
  [SMALL_STATE(2923)] = 89044,
  [SMALL_STATE(2924)] = 89117,
  [SMALL_STATE(2925)] = 89174,
  [SMALL_STATE(2926)] = 89229,
  [SMALL_STATE(2927)] = 89312,
  [SMALL_STATE(2928)] = 89387,
  [SMALL_STATE(2929)] = 89444,
  [SMALL_STATE(2930)] = 89503,
  [SMALL_STATE(2931)] = 89616,
  [SMALL_STATE(2932)] = 89673,
  [SMALL_STATE(2933)] = 89728,
  [SMALL_STATE(2934)] = 89783,
  [SMALL_STATE(2935)] = 89896,
  [SMALL_STATE(2936)] = 89977,
  [SMALL_STATE(2937)] = 90036,
  [SMALL_STATE(2938)] = 90095,
  [SMALL_STATE(2939)] = 90168,
  [SMALL_STATE(2940)] = 90243,
  [SMALL_STATE(2941)] = 90298,
  [SMALL_STATE(2942)] = 90411,
  [SMALL_STATE(2943)] = 90488,
  [SMALL_STATE(2944)] = 90601,
  [SMALL_STATE(2945)] = 90656,
  [SMALL_STATE(2946)] = 90769,
  [SMALL_STATE(2947)] = 90850,
  [SMALL_STATE(2948)] = 90933,
  [SMALL_STATE(2949)] = 90990,
  [SMALL_STATE(2950)] = 91065,
  [SMALL_STATE(2951)] = 91138,
  [SMALL_STATE(2952)] = 91219,
  [SMALL_STATE(2953)] = 91332,
  [SMALL_STATE(2954)] = 91445,
  [SMALL_STATE(2955)] = 91506,
  [SMALL_STATE(2956)] = 91565,
  [SMALL_STATE(2957)] = 91624,
  [SMALL_STATE(2958)] = 91679,
  [SMALL_STATE(2959)] = 91792,
  [SMALL_STATE(2960)] = 91865,
  [SMALL_STATE(2961)] = 91920,
  [SMALL_STATE(2962)] = 91979,
  [SMALL_STATE(2963)] = 92054,
  [SMALL_STATE(2964)] = 92113,
  [SMALL_STATE(2965)] = 92172,
  [SMALL_STATE(2966)] = 92245,
  [SMALL_STATE(2967)] = 92300,
  [SMALL_STATE(2968)] = 92355,
  [SMALL_STATE(2969)] = 92410,
  [SMALL_STATE(2970)] = 92465,
  [SMALL_STATE(2971)] = 92578,
  [SMALL_STATE(2972)] = 92691,
  [SMALL_STATE(2973)] = 92746,
  [SMALL_STATE(2974)] = 92805,
  [SMALL_STATE(2975)] = 92888,
  [SMALL_STATE(2976)] = 92943,
  [SMALL_STATE(2977)] = 93018,
  [SMALL_STATE(2978)] = 93073,
  [SMALL_STATE(2979)] = 93128,
  [SMALL_STATE(2980)] = 93185,
  [SMALL_STATE(2981)] = 93244,
  [SMALL_STATE(2982)] = 93307,
  [SMALL_STATE(2983)] = 93362,
  [SMALL_STATE(2984)] = 93417,
  [SMALL_STATE(2985)] = 93476,
  [SMALL_STATE(2986)] = 93531,
  [SMALL_STATE(2987)] = 93586,
  [SMALL_STATE(2988)] = 93641,
  [SMALL_STATE(2989)] = 93716,
  [SMALL_STATE(2990)] = 93771,
  [SMALL_STATE(2991)] = 93844,
  [SMALL_STATE(2992)] = 93901,
  [SMALL_STATE(2993)] = 93974,
  [SMALL_STATE(2994)] = 94031,
  [SMALL_STATE(2995)] = 94088,
  [SMALL_STATE(2996)] = 94181,
  [SMALL_STATE(2997)] = 94238,
  [SMALL_STATE(2998)] = 94311,
  [SMALL_STATE(2999)] = 94366,
  [SMALL_STATE(3000)] = 94423,
  [SMALL_STATE(3001)] = 94482,
  [SMALL_STATE(3002)] = 94539,
  [SMALL_STATE(3003)] = 94612,
  [SMALL_STATE(3004)] = 94687,
  [SMALL_STATE(3005)] = 94768,
  [SMALL_STATE(3006)] = 94831,
  [SMALL_STATE(3007)] = 94944,
  [SMALL_STATE(3008)] = 94999,
  [SMALL_STATE(3009)] = 95054,
  [SMALL_STATE(3010)] = 95127,
  [SMALL_STATE(3011)] = 95208,
  [SMALL_STATE(3012)] = 95291,
  [SMALL_STATE(3013)] = 95346,
  [SMALL_STATE(3014)] = 95421,
  [SMALL_STATE(3015)] = 95488,
  [SMALL_STATE(3016)] = 95543,
  [SMALL_STATE(3017)] = 95598,
  [SMALL_STATE(3018)] = 95653,
  [SMALL_STATE(3019)] = 95726,
  [SMALL_STATE(3020)] = 95801,
  [SMALL_STATE(3021)] = 95858,
  [SMALL_STATE(3022)] = 95917,
  [SMALL_STATE(3023)] = 95972,
  [SMALL_STATE(3024)] = 96031,
  [SMALL_STATE(3025)] = 96086,
  [SMALL_STATE(3026)] = 96141,
  [SMALL_STATE(3027)] = 96214,
  [SMALL_STATE(3028)] = 96281,
  [SMALL_STATE(3029)] = 96336,
  [SMALL_STATE(3030)] = 96449,
  [SMALL_STATE(3031)] = 96512,
  [SMALL_STATE(3032)] = 96567,
  [SMALL_STATE(3033)] = 96680,
  [SMALL_STATE(3034)] = 96793,
  [SMALL_STATE(3035)] = 96898,
  [SMALL_STATE(3036)] = 96953,
  [SMALL_STATE(3037)] = 97008,
  [SMALL_STATE(3038)] = 97099,
  [SMALL_STATE(3039)] = 97214,
  [SMALL_STATE(3040)] = 97269,
  [SMALL_STATE(3041)] = 97326,
  [SMALL_STATE(3042)] = 97389,
  [SMALL_STATE(3043)] = 97444,
  [SMALL_STATE(3044)] = 97499,
  [SMALL_STATE(3045)] = 97554,
  [SMALL_STATE(3046)] = 97609,
  [SMALL_STATE(3047)] = 97692,
  [SMALL_STATE(3048)] = 97751,
  [SMALL_STATE(3049)] = 97832,
  [SMALL_STATE(3050)] = 97891,
  [SMALL_STATE(3051)] = 97952,
  [SMALL_STATE(3052)] = 98015,
  [SMALL_STATE(3053)] = 98098,
  [SMALL_STATE(3054)] = 98153,
  [SMALL_STATE(3055)] = 98212,
  [SMALL_STATE(3056)] = 98293,
  [SMALL_STATE(3057)] = 98392,
  [SMALL_STATE(3058)] = 98447,
  [SMALL_STATE(3059)] = 98502,
  [SMALL_STATE(3060)] = 98557,
  [SMALL_STATE(3061)] = 98612,
  [SMALL_STATE(3062)] = 98679,
  [SMALL_STATE(3063)] = 98734,
  [SMALL_STATE(3064)] = 98793,
  [SMALL_STATE(3065)] = 98866,
  [SMALL_STATE(3066)] = 98921,
  [SMALL_STATE(3067)] = 99018,
  [SMALL_STATE(3068)] = 99073,
  [SMALL_STATE(3069)] = 99186,
  [SMALL_STATE(3070)] = 99241,
  [SMALL_STATE(3071)] = 99336,
  [SMALL_STATE(3072)] = 99419,
  [SMALL_STATE(3073)] = 99474,
  [SMALL_STATE(3074)] = 99529,
  [SMALL_STATE(3075)] = 99604,
  [SMALL_STATE(3076)] = 99659,
  [SMALL_STATE(3077)] = 99720,
  [SMALL_STATE(3078)] = 99833,
  [SMALL_STATE(3079)] = 99946,
  [SMALL_STATE(3080)] = 100049,
  [SMALL_STATE(3081)] = 100150,
  [SMALL_STATE(3082)] = 100225,
  [SMALL_STATE(3083)] = 100298,
  [SMALL_STATE(3084)] = 100375,
  [SMALL_STATE(3085)] = 100488,
  [SMALL_STATE(3086)] = 100543,
  [SMALL_STATE(3087)] = 100602,
  [SMALL_STATE(3088)] = 100657,
  [SMALL_STATE(3089)] = 100720,
  [SMALL_STATE(3090)] = 100785,
  [SMALL_STATE(3091)] = 100858,
  [SMALL_STATE(3092)] = 100945,
  [SMALL_STATE(3093)] = 101058,
  [SMALL_STATE(3094)] = 101171,
  [SMALL_STATE(3095)] = 101226,
  [SMALL_STATE(3096)] = 101339,
  [SMALL_STATE(3097)] = 101412,
  [SMALL_STATE(3098)] = 101467,
  [SMALL_STATE(3099)] = 101542,
  [SMALL_STATE(3100)] = 101655,
  [SMALL_STATE(3101)] = 101768,
  [SMALL_STATE(3102)] = 101881,
  [SMALL_STATE(3103)] = 101936,
  [SMALL_STATE(3104)] = 101991,
  [SMALL_STATE(3105)] = 102104,
  [SMALL_STATE(3106)] = 102159,
  [SMALL_STATE(3107)] = 102272,
  [SMALL_STATE(3108)] = 102359,
  [SMALL_STATE(3109)] = 102436,
  [SMALL_STATE(3110)] = 102537,
  [SMALL_STATE(3111)] = 102640,
  [SMALL_STATE(3112)] = 102699,
  [SMALL_STATE(3113)] = 102754,
  [SMALL_STATE(3114)] = 102837,
  [SMALL_STATE(3115)] = 102932,
  [SMALL_STATE(3116)] = 103029,
  [SMALL_STATE(3117)] = 103110,
  [SMALL_STATE(3118)] = 103175,
  [SMALL_STATE(3119)] = 103230,
  [SMALL_STATE(3120)] = 103343,
  [SMALL_STATE(3121)] = 103442,
  [SMALL_STATE(3122)] = 103501,
  [SMALL_STATE(3123)] = 103582,
  [SMALL_STATE(3124)] = 103657,
  [SMALL_STATE(3125)] = 103770,
  [SMALL_STATE(3126)] = 103843,
  [SMALL_STATE(3127)] = 103956,
  [SMALL_STATE(3128)] = 104031,
  [SMALL_STATE(3129)] = 104144,
  [SMALL_STATE(3130)] = 104227,
  [SMALL_STATE(3131)] = 104340,
  [SMALL_STATE(3132)] = 104431,
  [SMALL_STATE(3133)] = 104544,
  [SMALL_STATE(3134)] = 104649,
  [SMALL_STATE(3135)] = 104762,
  [SMALL_STATE(3136)] = 104845,
  [SMALL_STATE(3137)] = 104918,
  [SMALL_STATE(3138)] = 105031,
  [SMALL_STATE(3139)] = 105090,
  [SMALL_STATE(3140)] = 105147,
  [SMALL_STATE(3141)] = 105202,
  [SMALL_STATE(3142)] = 105277,
  [SMALL_STATE(3143)] = 105350,
  [SMALL_STATE(3144)] = 105405,
  [SMALL_STATE(3145)] = 105518,
  [SMALL_STATE(3146)] = 105577,
  [SMALL_STATE(3147)] = 105636,
  [SMALL_STATE(3148)] = 105695,
  [SMALL_STATE(3149)] = 105750,
  [SMALL_STATE(3150)] = 105809,
  [SMALL_STATE(3151)] = 105884,
  [SMALL_STATE(3152)] = 105997,
  [SMALL_STATE(3153)] = 106052,
  [SMALL_STATE(3154)] = 106119,
  [SMALL_STATE(3155)] = 106186,
  [SMALL_STATE(3156)] = 106253,
  [SMALL_STATE(3157)] = 106326,
  [SMALL_STATE(3158)] = 106393,
  [SMALL_STATE(3159)] = 106460,
  [SMALL_STATE(3160)] = 106573,
  [SMALL_STATE(3161)] = 106628,
  [SMALL_STATE(3162)] = 106695,
  [SMALL_STATE(3163)] = 106752,
  [SMALL_STATE(3164)] = 106865,
  [SMALL_STATE(3165)] = 106932,
  [SMALL_STATE(3166)] = 106999,
  [SMALL_STATE(3167)] = 107064,
  [SMALL_STATE(3168)] = 107119,
  [SMALL_STATE(3169)] = 107174,
  [SMALL_STATE(3170)] = 107239,
  [SMALL_STATE(3171)] = 107298,
  [SMALL_STATE(3172)] = 107357,
  [SMALL_STATE(3173)] = 107420,
  [SMALL_STATE(3174)] = 107533,
  [SMALL_STATE(3175)] = 107646,
  [SMALL_STATE(3176)] = 107707,
  [SMALL_STATE(3177)] = 107768,
  [SMALL_STATE(3178)] = 107849,
  [SMALL_STATE(3179)] = 107932,
  [SMALL_STATE(3180)] = 108007,
  [SMALL_STATE(3181)] = 108070,
  [SMALL_STATE(3182)] = 108129,
  [SMALL_STATE(3183)] = 108188,
  [SMALL_STATE(3184)] = 108251,
  [SMALL_STATE(3185)] = 108326,
  [SMALL_STATE(3186)] = 108399,
  [SMALL_STATE(3187)] = 108461,
  [SMALL_STATE(3188)] = 108571,
  [SMALL_STATE(3189)] = 108639,
  [SMALL_STATE(3190)] = 108749,
  [SMALL_STATE(3191)] = 108811,
  [SMALL_STATE(3192)] = 108921,
  [SMALL_STATE(3193)] = 108981,
  [SMALL_STATE(3194)] = 109043,
  [SMALL_STATE(3195)] = 109111,
  [SMALL_STATE(3196)] = 109171,
  [SMALL_STATE(3197)] = 109239,
  [SMALL_STATE(3198)] = 109307,
  [SMALL_STATE(3199)] = 109375,
  [SMALL_STATE(3200)] = 109443,
  [SMALL_STATE(3201)] = 109519,
  [SMALL_STATE(3202)] = 109595,
  [SMALL_STATE(3203)] = 109663,
  [SMALL_STATE(3204)] = 109773,
  [SMALL_STATE(3205)] = 109841,
  [SMALL_STATE(3206)] = 109951,
  [SMALL_STATE(3207)] = 110011,
  [SMALL_STATE(3208)] = 110091,
  [SMALL_STATE(3209)] = 110173,
  [SMALL_STATE(3210)] = 110247,
  [SMALL_STATE(3211)] = 110357,
  [SMALL_STATE(3212)] = 110425,
  [SMALL_STATE(3213)] = 110497,
  [SMALL_STATE(3214)] = 110607,
  [SMALL_STATE(3215)] = 110693,
  [SMALL_STATE(3216)] = 110769,
  [SMALL_STATE(3217)] = 110827,
  [SMALL_STATE(3218)] = 110889,
  [SMALL_STATE(3219)] = 110977,
  [SMALL_STATE(3220)] = 111033,
  [SMALL_STATE(3221)] = 111101,
  [SMALL_STATE(3222)] = 111157,
  [SMALL_STATE(3223)] = 111233,
  [SMALL_STATE(3224)] = 111301,
  [SMALL_STATE(3225)] = 111403,
  [SMALL_STATE(3226)] = 111471,
  [SMALL_STATE(3227)] = 111529,
  [SMALL_STATE(3228)] = 111597,
  [SMALL_STATE(3229)] = 111707,
  [SMALL_STATE(3230)] = 111789,
  [SMALL_STATE(3231)] = 111857,
  [SMALL_STATE(3232)] = 111957,
  [SMALL_STATE(3233)] = 112025,
  [SMALL_STATE(3234)] = 112093,
  [SMALL_STATE(3235)] = 112169,
  [SMALL_STATE(3236)] = 112263,
  [SMALL_STATE(3237)] = 112339,
  [SMALL_STATE(3238)] = 112401,
  [SMALL_STATE(3239)] = 112469,
  [SMALL_STATE(3240)] = 112565,
  [SMALL_STATE(3241)] = 112633,
  [SMALL_STATE(3242)] = 112731,
  [SMALL_STATE(3243)] = 112841,
  [SMALL_STATE(3244)] = 112951,
  [SMALL_STATE(3245)] = 113019,
  [SMALL_STATE(3246)] = 113079,
  [SMALL_STATE(3247)] = 113189,
  [SMALL_STATE(3248)] = 113265,
  [SMALL_STATE(3249)] = 113375,
  [SMALL_STATE(3250)] = 113443,
  [SMALL_STATE(3251)] = 113527,
  [SMALL_STATE(3252)] = 113595,
  [SMALL_STATE(3253)] = 113663,
  [SMALL_STATE(3254)] = 113773,
  [SMALL_STATE(3255)] = 113883,
  [SMALL_STATE(3256)] = 113993,
  [SMALL_STATE(3257)] = 114103,
  [SMALL_STATE(3258)] = 114171,
  [SMALL_STATE(3259)] = 114275,
  [SMALL_STATE(3260)] = 114365,
  [SMALL_STATE(3261)] = 114447,
  [SMALL_STATE(3262)] = 114503,
  [SMALL_STATE(3263)] = 114565,
  [SMALL_STATE(3264)] = 114641,
  [SMALL_STATE(3265)] = 114721,
  [SMALL_STATE(3266)] = 114777,
  [SMALL_STATE(3267)] = 114832,
  [SMALL_STATE(3268)] = 114907,
  [SMALL_STATE(3269)] = 114966,
  [SMALL_STATE(3270)] = 115025,
  [SMALL_STATE(3271)] = 115080,
  [SMALL_STATE(3272)] = 115139,
  [SMALL_STATE(3273)] = 115194,
  [SMALL_STATE(3274)] = 115253,
  [SMALL_STATE(3275)] = 115330,
  [SMALL_STATE(3276)] = 115389,
  [SMALL_STATE(3277)] = 115462,
  [SMALL_STATE(3278)] = 115517,
  [SMALL_STATE(3279)] = 115586,
  [SMALL_STATE(3280)] = 115679,
  [SMALL_STATE(3281)] = 115734,
  [SMALL_STATE(3282)] = 115789,
  [SMALL_STATE(3283)] = 115844,
  [SMALL_STATE(3284)] = 115899,
  [SMALL_STATE(3285)] = 115972,
  [SMALL_STATE(3286)] = 116027,
  [SMALL_STATE(3287)] = 116082,
  [SMALL_STATE(3288)] = 116141,
  [SMALL_STATE(3289)] = 116196,
  [SMALL_STATE(3290)] = 116269,
  [SMALL_STATE(3291)] = 116328,
  [SMALL_STATE(3292)] = 116397,
  [SMALL_STATE(3293)] = 116456,
  [SMALL_STATE(3294)] = 116535,
  [SMALL_STATE(3295)] = 116604,
  [SMALL_STATE(3296)] = 116679,
  [SMALL_STATE(3297)] = 116752,
  [SMALL_STATE(3298)] = 116821,
  [SMALL_STATE(3299)] = 116882,
  [SMALL_STATE(3300)] = 116955,
  [SMALL_STATE(3301)] = 117010,
  [SMALL_STATE(3302)] = 117065,
  [SMALL_STATE(3303)] = 117138,
  [SMALL_STATE(3304)] = 117197,
  [SMALL_STATE(3305)] = 117266,
  [SMALL_STATE(3306)] = 117325,
  [SMALL_STATE(3307)] = 117391,
  [SMALL_STATE(3308)] = 117453,
  [SMALL_STATE(3309)] = 117511,
  [SMALL_STATE(3310)] = 117573,
  [SMALL_STATE(3311)] = 117635,
  [SMALL_STATE(3312)] = 117697,
  [SMALL_STATE(3313)] = 117759,
  [SMALL_STATE(3314)] = 117821,
  [SMALL_STATE(3315)] = 117879,
  [SMALL_STATE(3316)] = 117945,
  [SMALL_STATE(3317)] = 118007,
  [SMALL_STATE(3318)] = 118073,
  [SMALL_STATE(3319)] = 118139,
  [SMALL_STATE(3320)] = 118201,
  [SMALL_STATE(3321)] = 118271,
  [SMALL_STATE(3322)] = 118337,
  [SMALL_STATE(3323)] = 118405,
  [SMALL_STATE(3324)] = 118459,
  [SMALL_STATE(3325)] = 118531,
  [SMALL_STATE(3326)] = 118593,
  [SMALL_STATE(3327)] = 118651,
  [SMALL_STATE(3328)] = 118713,
  [SMALL_STATE(3329)] = 118779,
  [SMALL_STATE(3330)] = 118845,
  [SMALL_STATE(3331)] = 118907,
  [SMALL_STATE(3332)] = 118965,
  [SMALL_STATE(3333)] = 119031,
  [SMALL_STATE(3334)] = 119089,
  [SMALL_STATE(3335)] = 119151,
  [SMALL_STATE(3336)] = 119221,
  [SMALL_STATE(3337)] = 119283,
  [SMALL_STATE(3338)] = 119349,
  [SMALL_STATE(3339)] = 119403,
  [SMALL_STATE(3340)] = 119457,
  [SMALL_STATE(3341)] = 119523,
  [SMALL_STATE(3342)] = 119589,
  [SMALL_STATE(3343)] = 119643,
  [SMALL_STATE(3344)] = 119709,
  [SMALL_STATE(3345)] = 119775,
  [SMALL_STATE(3346)] = 119841,
  [SMALL_STATE(3347)] = 119907,
  [SMALL_STATE(3348)] = 119969,
  [SMALL_STATE(3349)] = 120035,
  [SMALL_STATE(3350)] = 120088,
  [SMALL_STATE(3351)] = 120141,
  [SMALL_STATE(3352)] = 120194,
  [SMALL_STATE(3353)] = 120247,
  [SMALL_STATE(3354)] = 120312,
  [SMALL_STATE(3355)] = 120365,
  [SMALL_STATE(3356)] = 120418,
  [SMALL_STATE(3357)] = 120471,
  [SMALL_STATE(3358)] = 120524,
  [SMALL_STATE(3359)] = 120577,
  [SMALL_STATE(3360)] = 120627,
  [SMALL_STATE(3361)] = 120677,
  [SMALL_STATE(3362)] = 120727,
  [SMALL_STATE(3363)] = 120777,
  [SMALL_STATE(3364)] = 120827,
  [SMALL_STATE(3365)] = 120877,
  [SMALL_STATE(3366)] = 120927,
  [SMALL_STATE(3367)] = 120977,
  [SMALL_STATE(3368)] = 121027,
  [SMALL_STATE(3369)] = 121077,
  [SMALL_STATE(3370)] = 121127,
  [SMALL_STATE(3371)] = 121177,
  [SMALL_STATE(3372)] = 121227,
  [SMALL_STATE(3373)] = 121283,
  [SMALL_STATE(3374)] = 121333,
  [SMALL_STATE(3375)] = 121383,
  [SMALL_STATE(3376)] = 121433,
  [SMALL_STATE(3377)] = 121483,
  [SMALL_STATE(3378)] = 121533,
  [SMALL_STATE(3379)] = 121585,
  [SMALL_STATE(3380)] = 121635,
  [SMALL_STATE(3381)] = 121691,
  [SMALL_STATE(3382)] = 121741,
  [SMALL_STATE(3383)] = 121791,
  [SMALL_STATE(3384)] = 121841,
  [SMALL_STATE(3385)] = 121891,
  [SMALL_STATE(3386)] = 121941,
  [SMALL_STATE(3387)] = 121991,
  [SMALL_STATE(3388)] = 122041,
  [SMALL_STATE(3389)] = 122091,
  [SMALL_STATE(3390)] = 122165,
  [SMALL_STATE(3391)] = 122215,
  [SMALL_STATE(3392)] = 122265,
  [SMALL_STATE(3393)] = 122319,
  [SMALL_STATE(3394)] = 122369,
  [SMALL_STATE(3395)] = 122419,
  [SMALL_STATE(3396)] = 122473,
  [SMALL_STATE(3397)] = 122523,
  [SMALL_STATE(3398)] = 122573,
  [SMALL_STATE(3399)] = 122623,
  [SMALL_STATE(3400)] = 122673,
  [SMALL_STATE(3401)] = 122725,
  [SMALL_STATE(3402)] = 122775,
  [SMALL_STATE(3403)] = 122825,
  [SMALL_STATE(3404)] = 122875,
  [SMALL_STATE(3405)] = 122925,
  [SMALL_STATE(3406)] = 122975,
  [SMALL_STATE(3407)] = 123025,
  [SMALL_STATE(3408)] = 123075,
  [SMALL_STATE(3409)] = 123125,
  [SMALL_STATE(3410)] = 123175,
  [SMALL_STATE(3411)] = 123225,
  [SMALL_STATE(3412)] = 123275,
  [SMALL_STATE(3413)] = 123325,
  [SMALL_STATE(3414)] = 123375,
  [SMALL_STATE(3415)] = 123425,
  [SMALL_STATE(3416)] = 123475,
  [SMALL_STATE(3417)] = 123542,
  [SMALL_STATE(3418)] = 123593,
  [SMALL_STATE(3419)] = 123640,
  [SMALL_STATE(3420)] = 123687,
  [SMALL_STATE(3421)] = 123734,
  [SMALL_STATE(3422)] = 123801,
  [SMALL_STATE(3423)] = 123866,
  [SMALL_STATE(3424)] = 123913,
  [SMALL_STATE(3425)] = 123960,
  [SMALL_STATE(3426)] = 124007,
  [SMALL_STATE(3427)] = 124072,
  [SMALL_STATE(3428)] = 124135,
  [SMALL_STATE(3429)] = 124200,
  [SMALL_STATE(3430)] = 124247,
  [SMALL_STATE(3431)] = 124314,
  [SMALL_STATE(3432)] = 124361,
  [SMALL_STATE(3433)] = 124426,
  [SMALL_STATE(3434)] = 124477,
  [SMALL_STATE(3435)] = 124537,
  [SMALL_STATE(3436)] = 124597,
  [SMALL_STATE(3437)] = 124673,
  [SMALL_STATE(3438)] = 124733,
  [SMALL_STATE(3439)] = 124793,
  [SMALL_STATE(3440)] = 124853,
  [SMALL_STATE(3441)] = 124913,
  [SMALL_STATE(3442)] = 124973,
  [SMALL_STATE(3443)] = 125033,
  [SMALL_STATE(3444)] = 125093,
  [SMALL_STATE(3445)] = 125145,
  [SMALL_STATE(3446)] = 125205,
  [SMALL_STATE(3447)] = 125265,
  [SMALL_STATE(3448)] = 125325,
  [SMALL_STATE(3449)] = 125385,
  [SMALL_STATE(3450)] = 125445,
  [SMALL_STATE(3451)] = 125505,
  [SMALL_STATE(3452)] = 125565,
  [SMALL_STATE(3453)] = 125625,
  [SMALL_STATE(3454)] = 125685,
  [SMALL_STATE(3455)] = 125745,
  [SMALL_STATE(3456)] = 125805,
  [SMALL_STATE(3457)] = 125865,
  [SMALL_STATE(3458)] = 125925,
  [SMALL_STATE(3459)] = 125985,
  [SMALL_STATE(3460)] = 126045,
  [SMALL_STATE(3461)] = 126105,
  [SMALL_STATE(3462)] = 126165,
  [SMALL_STATE(3463)] = 126225,
  [SMALL_STATE(3464)] = 126301,
  [SMALL_STATE(3465)] = 126362,
  [SMALL_STATE(3466)] = 126423,
  [SMALL_STATE(3467)] = 126484,
  [SMALL_STATE(3468)] = 126545,
  [SMALL_STATE(3469)] = 126616,
  [SMALL_STATE(3470)] = 126677,
  [SMALL_STATE(3471)] = 126738,
  [SMALL_STATE(3472)] = 126799,
  [SMALL_STATE(3473)] = 126884,
  [SMALL_STATE(3474)] = 126951,
  [SMALL_STATE(3475)] = 127012,
  [SMALL_STATE(3476)] = 127097,
  [SMALL_STATE(3477)] = 127182,
  [SMALL_STATE(3478)] = 127253,
  [SMALL_STATE(3479)] = 127338,
  [SMALL_STATE(3480)] = 127399,
  [SMALL_STATE(3481)] = 127466,
  [SMALL_STATE(3482)] = 127527,
  [SMALL_STATE(3483)] = 127588,
  [SMALL_STATE(3484)] = 127649,
  [SMALL_STATE(3485)] = 127734,
  [SMALL_STATE(3486)] = 127795,
  [SMALL_STATE(3487)] = 127880,
  [SMALL_STATE(3488)] = 127941,
  [SMALL_STATE(3489)] = 128002,
  [SMALL_STATE(3490)] = 128047,
  [SMALL_STATE(3491)] = 128132,
  [SMALL_STATE(3492)] = 128217,
  [SMALL_STATE(3493)] = 128278,
  [SMALL_STATE(3494)] = 128339,
  [SMALL_STATE(3495)] = 128406,
  [SMALL_STATE(3496)] = 128467,
  [SMALL_STATE(3497)] = 128516,
  [SMALL_STATE(3498)] = 128583,
  [SMALL_STATE(3499)] = 128644,
  [SMALL_STATE(3500)] = 128729,
  [SMALL_STATE(3501)] = 128790,
  [SMALL_STATE(3502)] = 128851,
  [SMALL_STATE(3503)] = 128912,
  [SMALL_STATE(3504)] = 128973,
  [SMALL_STATE(3505)] = 129058,
  [SMALL_STATE(3506)] = 129119,
  [SMALL_STATE(3507)] = 129204,
  [SMALL_STATE(3508)] = 129265,
  [SMALL_STATE(3509)] = 129336,
  [SMALL_STATE(3510)] = 129397,
  [SMALL_STATE(3511)] = 129482,
  [SMALL_STATE(3512)] = 129543,
  [SMALL_STATE(3513)] = 129604,
  [SMALL_STATE(3514)] = 129665,
  [SMALL_STATE(3515)] = 129726,
  [SMALL_STATE(3516)] = 129790,
  [SMALL_STATE(3517)] = 129854,
  [SMALL_STATE(3518)] = 129918,
  [SMALL_STATE(3519)] = 129976,
  [SMALL_STATE(3520)] = 130040,
  [SMALL_STATE(3521)] = 130100,
  [SMALL_STATE(3522)] = 130164,
  [SMALL_STATE(3523)] = 130224,
  [SMALL_STATE(3524)] = 130288,
  [SMALL_STATE(3525)] = 130352,
  [SMALL_STATE(3526)] = 130416,
  [SMALL_STATE(3527)] = 130480,
  [SMALL_STATE(3528)] = 130544,
  [SMALL_STATE(3529)] = 130608,
  [SMALL_STATE(3530)] = 130672,
  [SMALL_STATE(3531)] = 130736,
  [SMALL_STATE(3532)] = 130800,
  [SMALL_STATE(3533)] = 130846,
  [SMALL_STATE(3534)] = 130910,
  [SMALL_STATE(3535)] = 130974,
  [SMALL_STATE(3536)] = 131029,
  [SMALL_STATE(3537)] = 131084,
  [SMALL_STATE(3538)] = 131139,
  [SMALL_STATE(3539)] = 131194,
  [SMALL_STATE(3540)] = 131249,
  [SMALL_STATE(3541)] = 131306,
  [SMALL_STATE(3542)] = 131363,
  [SMALL_STATE(3543)] = 131418,
  [SMALL_STATE(3544)] = 131461,
  [SMALL_STATE(3545)] = 131516,
  [SMALL_STATE(3546)] = 131559,
  [SMALL_STATE(3547)] = 131614,
  [SMALL_STATE(3548)] = 131669,
  [SMALL_STATE(3549)] = 131724,
  [SMALL_STATE(3550)] = 131779,
  [SMALL_STATE(3551)] = 131834,
  [SMALL_STATE(3552)] = 131877,
  [SMALL_STATE(3553)] = 131932,
  [SMALL_STATE(3554)] = 131987,
  [SMALL_STATE(3555)] = 132044,
  [SMALL_STATE(3556)] = 132099,
  [SMALL_STATE(3557)] = 132154,
  [SMALL_STATE(3558)] = 132197,
  [SMALL_STATE(3559)] = 132252,
  [SMALL_STATE(3560)] = 132307,
  [SMALL_STATE(3561)] = 132362,
  [SMALL_STATE(3562)] = 132419,
  [SMALL_STATE(3563)] = 132474,
  [SMALL_STATE(3564)] = 132531,
  [SMALL_STATE(3565)] = 132586,
  [SMALL_STATE(3566)] = 132641,
  [SMALL_STATE(3567)] = 132696,
  [SMALL_STATE(3568)] = 132753,
  [SMALL_STATE(3569)] = 132808,
  [SMALL_STATE(3570)] = 132863,
  [SMALL_STATE(3571)] = 132918,
  [SMALL_STATE(3572)] = 132975,
  [SMALL_STATE(3573)] = 133030,
  [SMALL_STATE(3574)] = 133085,
  [SMALL_STATE(3575)] = 133142,
  [SMALL_STATE(3576)] = 133197,
  [SMALL_STATE(3577)] = 133252,
  [SMALL_STATE(3578)] = 133309,
  [SMALL_STATE(3579)] = 133364,
  [SMALL_STATE(3580)] = 133419,
  [SMALL_STATE(3581)] = 133476,
  [SMALL_STATE(3582)] = 133531,
  [SMALL_STATE(3583)] = 133588,
  [SMALL_STATE(3584)] = 133643,
  [SMALL_STATE(3585)] = 133698,
  [SMALL_STATE(3586)] = 133755,
  [SMALL_STATE(3587)] = 133812,
  [SMALL_STATE(3588)] = 133867,
  [SMALL_STATE(3589)] = 133922,
  [SMALL_STATE(3590)] = 133977,
  [SMALL_STATE(3591)] = 134034,
  [SMALL_STATE(3592)] = 134089,
  [SMALL_STATE(3593)] = 134144,
  [SMALL_STATE(3594)] = 134199,
  [SMALL_STATE(3595)] = 134242,
  [SMALL_STATE(3596)] = 134285,
  [SMALL_STATE(3597)] = 134325,
  [SMALL_STATE(3598)] = 134360,
  [SMALL_STATE(3599)] = 134407,
  [SMALL_STATE(3600)] = 134454,
  [SMALL_STATE(3601)] = 134501,
  [SMALL_STATE(3602)] = 134536,
  [SMALL_STATE(3603)] = 134571,
  [SMALL_STATE(3604)] = 134605,
  [SMALL_STATE(3605)] = 134639,
  [SMALL_STATE(3606)] = 134672,
  [SMALL_STATE(3607)] = 134705,
  [SMALL_STATE(3608)] = 134738,
  [SMALL_STATE(3609)] = 134779,
  [SMALL_STATE(3610)] = 134812,
  [SMALL_STATE(3611)] = 134845,
  [SMALL_STATE(3612)] = 134878,
  [SMALL_STATE(3613)] = 134911,
  [SMALL_STATE(3614)] = 134944,
  [SMALL_STATE(3615)] = 134977,
  [SMALL_STATE(3616)] = 135010,
  [SMALL_STATE(3617)] = 135043,
  [SMALL_STATE(3618)] = 135076,
  [SMALL_STATE(3619)] = 135109,
  [SMALL_STATE(3620)] = 135142,
  [SMALL_STATE(3621)] = 135175,
  [SMALL_STATE(3622)] = 135208,
  [SMALL_STATE(3623)] = 135241,
  [SMALL_STATE(3624)] = 135274,
  [SMALL_STATE(3625)] = 135307,
  [SMALL_STATE(3626)] = 135340,
  [SMALL_STATE(3627)] = 135373,
  [SMALL_STATE(3628)] = 135406,
  [SMALL_STATE(3629)] = 135439,
  [SMALL_STATE(3630)] = 135472,
  [SMALL_STATE(3631)] = 135505,
  [SMALL_STATE(3632)] = 135538,
  [SMALL_STATE(3633)] = 135571,
  [SMALL_STATE(3634)] = 135604,
  [SMALL_STATE(3635)] = 135637,
  [SMALL_STATE(3636)] = 135670,
  [SMALL_STATE(3637)] = 135703,
  [SMALL_STATE(3638)] = 135736,
  [SMALL_STATE(3639)] = 135769,
  [SMALL_STATE(3640)] = 135802,
  [SMALL_STATE(3641)] = 135856,
  [SMALL_STATE(3642)] = 135910,
  [SMALL_STATE(3643)] = 135970,
  [SMALL_STATE(3644)] = 136024,
  [SMALL_STATE(3645)] = 136062,
  [SMALL_STATE(3646)] = 136116,
  [SMALL_STATE(3647)] = 136170,
  [SMALL_STATE(3648)] = 136230,
  [SMALL_STATE(3649)] = 136273,
  [SMALL_STATE(3650)] = 136304,
  [SMALL_STATE(3651)] = 136335,
  [SMALL_STATE(3652)] = 136366,
  [SMALL_STATE(3653)] = 136397,
  [SMALL_STATE(3654)] = 136428,
  [SMALL_STATE(3655)] = 136459,
  [SMALL_STATE(3656)] = 136490,
  [SMALL_STATE(3657)] = 136525,
  [SMALL_STATE(3658)] = 136556,
  [SMALL_STATE(3659)] = 136587,
  [SMALL_STATE(3660)] = 136618,
  [SMALL_STATE(3661)] = 136649,
  [SMALL_STATE(3662)] = 136680,
  [SMALL_STATE(3663)] = 136715,
  [SMALL_STATE(3664)] = 136748,
  [SMALL_STATE(3665)] = 136781,
  [SMALL_STATE(3666)] = 136824,
  [SMALL_STATE(3667)] = 136855,
  [SMALL_STATE(3668)] = 136886,
  [SMALL_STATE(3669)] = 136917,
  [SMALL_STATE(3670)] = 136948,
  [SMALL_STATE(3671)] = 136979,
  [SMALL_STATE(3672)] = 137010,
  [SMALL_STATE(3673)] = 137053,
  [SMALL_STATE(3674)] = 137084,
  [SMALL_STATE(3675)] = 137115,
  [SMALL_STATE(3676)] = 137146,
  [SMALL_STATE(3677)] = 137178,
  [SMALL_STATE(3678)] = 137208,
  [SMALL_STATE(3679)] = 137240,
  [SMALL_STATE(3680)] = 137270,
  [SMALL_STATE(3681)] = 137302,
  [SMALL_STATE(3682)] = 137333,
  [SMALL_STATE(3683)] = 137362,
  [SMALL_STATE(3684)] = 137391,
  [SMALL_STATE(3685)] = 137420,
  [SMALL_STATE(3686)] = 137455,
  [SMALL_STATE(3687)] = 137494,
  [SMALL_STATE(3688)] = 137533,
  [SMALL_STATE(3689)] = 137562,
  [SMALL_STATE(3690)] = 137591,
  [SMALL_STATE(3691)] = 137620,
  [SMALL_STATE(3692)] = 137659,
  [SMALL_STATE(3693)] = 137690,
  [SMALL_STATE(3694)] = 137721,
  [SMALL_STATE(3695)] = 137760,
  [SMALL_STATE(3696)] = 137799,
  [SMALL_STATE(3697)] = 137836,
  [SMALL_STATE(3698)] = 137875,
  [SMALL_STATE(3699)] = 137914,
  [SMALL_STATE(3700)] = 137947,
  [SMALL_STATE(3701)] = 137986,
  [SMALL_STATE(3702)] = 138021,
  [SMALL_STATE(3703)] = 138048,
  [SMALL_STATE(3704)] = 138085,
  [SMALL_STATE(3705)] = 138124,
  [SMALL_STATE(3706)] = 138155,
  [SMALL_STATE(3707)] = 138194,
  [SMALL_STATE(3708)] = 138233,
  [SMALL_STATE(3709)] = 138268,
  [SMALL_STATE(3710)] = 138295,
  [SMALL_STATE(3711)] = 138324,
  [SMALL_STATE(3712)] = 138351,
  [SMALL_STATE(3713)] = 138378,
  [SMALL_STATE(3714)] = 138407,
  [SMALL_STATE(3715)] = 138434,
  [SMALL_STATE(3716)] = 138473,
  [SMALL_STATE(3717)] = 138510,
  [SMALL_STATE(3718)] = 138539,
  [SMALL_STATE(3719)] = 138568,
  [SMALL_STATE(3720)] = 138597,
  [SMALL_STATE(3721)] = 138626,
  [SMALL_STATE(3722)] = 138653,
  [SMALL_STATE(3723)] = 138682,
  [SMALL_STATE(3724)] = 138719,
  [SMALL_STATE(3725)] = 138758,
  [SMALL_STATE(3726)] = 138787,
  [SMALL_STATE(3727)] = 138816,
  [SMALL_STATE(3728)] = 138845,
  [SMALL_STATE(3729)] = 138874,
  [SMALL_STATE(3730)] = 138903,
  [SMALL_STATE(3731)] = 138932,
  [SMALL_STATE(3732)] = 138967,
  [SMALL_STATE(3733)] = 138996,
  [SMALL_STATE(3734)] = 139035,
  [SMALL_STATE(3735)] = 139066,
  [SMALL_STATE(3736)] = 139095,
  [SMALL_STATE(3737)] = 139124,
  [SMALL_STATE(3738)] = 139153,
  [SMALL_STATE(3739)] = 139182,
  [SMALL_STATE(3740)] = 139211,
  [SMALL_STATE(3741)] = 139240,
  [SMALL_STATE(3742)] = 139269,
  [SMALL_STATE(3743)] = 139298,
  [SMALL_STATE(3744)] = 139327,
  [SMALL_STATE(3745)] = 139356,
  [SMALL_STATE(3746)] = 139385,
  [SMALL_STATE(3747)] = 139414,
  [SMALL_STATE(3748)] = 139443,
  [SMALL_STATE(3749)] = 139472,
  [SMALL_STATE(3750)] = 139501,
  [SMALL_STATE(3751)] = 139530,
  [SMALL_STATE(3752)] = 139569,
  [SMALL_STATE(3753)] = 139598,
  [SMALL_STATE(3754)] = 139627,
  [SMALL_STATE(3755)] = 139656,
  [SMALL_STATE(3756)] = 139685,
  [SMALL_STATE(3757)] = 139714,
  [SMALL_STATE(3758)] = 139751,
  [SMALL_STATE(3759)] = 139780,
  [SMALL_STATE(3760)] = 139809,
  [SMALL_STATE(3761)] = 139848,
  [SMALL_STATE(3762)] = 139887,
  [SMALL_STATE(3763)] = 139926,
  [SMALL_STATE(3764)] = 139955,
  [SMALL_STATE(3765)] = 139984,
  [SMALL_STATE(3766)] = 140013,
  [SMALL_STATE(3767)] = 140050,
  [SMALL_STATE(3768)] = 140079,
  [SMALL_STATE(3769)] = 140108,
  [SMALL_STATE(3770)] = 140137,
  [SMALL_STATE(3771)] = 140164,
  [SMALL_STATE(3772)] = 140191,
  [SMALL_STATE(3773)] = 140220,
  [SMALL_STATE(3774)] = 140249,
  [SMALL_STATE(3775)] = 140278,
  [SMALL_STATE(3776)] = 140307,
  [SMALL_STATE(3777)] = 140336,
  [SMALL_STATE(3778)] = 140365,
  [SMALL_STATE(3779)] = 140394,
  [SMALL_STATE(3780)] = 140423,
  [SMALL_STATE(3781)] = 140452,
  [SMALL_STATE(3782)] = 140481,
  [SMALL_STATE(3783)] = 140508,
  [SMALL_STATE(3784)] = 140543,
  [SMALL_STATE(3785)] = 140578,
  [SMALL_STATE(3786)] = 140613,
  [SMALL_STATE(3787)] = 140642,
  [SMALL_STATE(3788)] = 140671,
  [SMALL_STATE(3789)] = 140700,
  [SMALL_STATE(3790)] = 140729,
  [SMALL_STATE(3791)] = 140758,
  [SMALL_STATE(3792)] = 140787,
  [SMALL_STATE(3793)] = 140835,
  [SMALL_STATE(3794)] = 140883,
  [SMALL_STATE(3795)] = 140931,
  [SMALL_STATE(3796)] = 140979,
  [SMALL_STATE(3797)] = 141027,
  [SMALL_STATE(3798)] = 141075,
  [SMALL_STATE(3799)] = 141123,
  [SMALL_STATE(3800)] = 141171,
  [SMALL_STATE(3801)] = 141219,
  [SMALL_STATE(3802)] = 141253,
  [SMALL_STATE(3803)] = 141297,
  [SMALL_STATE(3804)] = 141345,
  [SMALL_STATE(3805)] = 141393,
  [SMALL_STATE(3806)] = 141437,
  [SMALL_STATE(3807)] = 141485,
  [SMALL_STATE(3808)] = 141533,
  [SMALL_STATE(3809)] = 141577,
  [SMALL_STATE(3810)] = 141625,
  [SMALL_STATE(3811)] = 141673,
  [SMALL_STATE(3812)] = 141721,
  [SMALL_STATE(3813)] = 141769,
  [SMALL_STATE(3814)] = 141817,
  [SMALL_STATE(3815)] = 141865,
  [SMALL_STATE(3816)] = 141913,
  [SMALL_STATE(3817)] = 141947,
  [SMALL_STATE(3818)] = 141981,
  [SMALL_STATE(3819)] = 142029,
  [SMALL_STATE(3820)] = 142077,
  [SMALL_STATE(3821)] = 142109,
  [SMALL_STATE(3822)] = 142143,
  [SMALL_STATE(3823)] = 142187,
  [SMALL_STATE(3824)] = 142235,
  [SMALL_STATE(3825)] = 142269,
  [SMALL_STATE(3826)] = 142317,
  [SMALL_STATE(3827)] = 142365,
  [SMALL_STATE(3828)] = 142409,
  [SMALL_STATE(3829)] = 142457,
  [SMALL_STATE(3830)] = 142491,
  [SMALL_STATE(3831)] = 142527,
  [SMALL_STATE(3832)] = 142575,
  [SMALL_STATE(3833)] = 142623,
  [SMALL_STATE(3834)] = 142664,
  [SMALL_STATE(3835)] = 142689,
  [SMALL_STATE(3836)] = 142730,
  [SMALL_STATE(3837)] = 142757,
  [SMALL_STATE(3838)] = 142798,
  [SMALL_STATE(3839)] = 142839,
  [SMALL_STATE(3840)] = 142880,
  [SMALL_STATE(3841)] = 142907,
  [SMALL_STATE(3842)] = 142934,
  [SMALL_STATE(3843)] = 142975,
  [SMALL_STATE(3844)] = 143002,
  [SMALL_STATE(3845)] = 143043,
  [SMALL_STATE(3846)] = 143070,
  [SMALL_STATE(3847)] = 143097,
  [SMALL_STATE(3848)] = 143124,
  [SMALL_STATE(3849)] = 143151,
  [SMALL_STATE(3850)] = 143192,
  [SMALL_STATE(3851)] = 143237,
  [SMALL_STATE(3852)] = 143262,
  [SMALL_STATE(3853)] = 143287,
  [SMALL_STATE(3854)] = 143314,
  [SMALL_STATE(3855)] = 143339,
  [SMALL_STATE(3856)] = 143364,
  [SMALL_STATE(3857)] = 143391,
  [SMALL_STATE(3858)] = 143432,
  [SMALL_STATE(3859)] = 143457,
  [SMALL_STATE(3860)] = 143490,
  [SMALL_STATE(3861)] = 143515,
  [SMALL_STATE(3862)] = 143556,
  [SMALL_STATE(3863)] = 143581,
  [SMALL_STATE(3864)] = 143622,
  [SMALL_STATE(3865)] = 143647,
  [SMALL_STATE(3866)] = 143688,
  [SMALL_STATE(3867)] = 143717,
  [SMALL_STATE(3868)] = 143742,
  [SMALL_STATE(3869)] = 143771,
  [SMALL_STATE(3870)] = 143796,
  [SMALL_STATE(3871)] = 143821,
  [SMALL_STATE(3872)] = 143846,
  [SMALL_STATE(3873)] = 143887,
  [SMALL_STATE(3874)] = 143912,
  [SMALL_STATE(3875)] = 143939,
  [SMALL_STATE(3876)] = 143964,
  [SMALL_STATE(3877)] = 143989,
  [SMALL_STATE(3878)] = 144016,
  [SMALL_STATE(3879)] = 144061,
  [SMALL_STATE(3880)] = 144088,
  [SMALL_STATE(3881)] = 144113,
  [SMALL_STATE(3882)] = 144138,
  [SMALL_STATE(3883)] = 144169,
  [SMALL_STATE(3884)] = 144208,
  [SMALL_STATE(3885)] = 144249,
  [SMALL_STATE(3886)] = 144274,
  [SMALL_STATE(3887)] = 144299,
  [SMALL_STATE(3888)] = 144324,
  [SMALL_STATE(3889)] = 144349,
  [SMALL_STATE(3890)] = 144374,
  [SMALL_STATE(3891)] = 144399,
  [SMALL_STATE(3892)] = 144424,
  [SMALL_STATE(3893)] = 144465,
  [SMALL_STATE(3894)] = 144498,
  [SMALL_STATE(3895)] = 144523,
  [SMALL_STATE(3896)] = 144550,
  [SMALL_STATE(3897)] = 144577,
  [SMALL_STATE(3898)] = 144602,
  [SMALL_STATE(3899)] = 144629,
  [SMALL_STATE(3900)] = 144656,
  [SMALL_STATE(3901)] = 144697,
  [SMALL_STATE(3902)] = 144722,
  [SMALL_STATE(3903)] = 144747,
  [SMALL_STATE(3904)] = 144772,
  [SMALL_STATE(3905)] = 144803,
  [SMALL_STATE(3906)] = 144828,
  [SMALL_STATE(3907)] = 144853,
  [SMALL_STATE(3908)] = 144878,
  [SMALL_STATE(3909)] = 144903,
  [SMALL_STATE(3910)] = 144944,
  [SMALL_STATE(3911)] = 144982,
  [SMALL_STATE(3912)] = 145020,
  [SMALL_STATE(3913)] = 145064,
  [SMALL_STATE(3914)] = 145106,
  [SMALL_STATE(3915)] = 145148,
  [SMALL_STATE(3916)] = 145190,
  [SMALL_STATE(3917)] = 145232,
  [SMALL_STATE(3918)] = 145270,
  [SMALL_STATE(3919)] = 145308,
  [SMALL_STATE(3920)] = 145346,
  [SMALL_STATE(3921)] = 145382,
  [SMALL_STATE(3922)] = 145416,
  [SMALL_STATE(3923)] = 145458,
  [SMALL_STATE(3924)] = 145500,
  [SMALL_STATE(3925)] = 145536,
  [SMALL_STATE(3926)] = 145562,
  [SMALL_STATE(3927)] = 145596,
  [SMALL_STATE(3928)] = 145634,
  [SMALL_STATE(3929)] = 145676,
  [SMALL_STATE(3930)] = 145710,
  [SMALL_STATE(3931)] = 145752,
  [SMALL_STATE(3932)] = 145794,
  [SMALL_STATE(3933)] = 145836,
  [SMALL_STATE(3934)] = 145878,
  [SMALL_STATE(3935)] = 145920,
  [SMALL_STATE(3936)] = 145962,
  [SMALL_STATE(3937)] = 146006,
  [SMALL_STATE(3938)] = 146048,
  [SMALL_STATE(3939)] = 146076,
  [SMALL_STATE(3940)] = 146118,
  [SMALL_STATE(3941)] = 146156,
  [SMALL_STATE(3942)] = 146198,
  [SMALL_STATE(3943)] = 146228,
  [SMALL_STATE(3944)] = 146272,
  [SMALL_STATE(3945)] = 146314,
  [SMALL_STATE(3946)] = 146356,
  [SMALL_STATE(3947)] = 146382,
  [SMALL_STATE(3948)] = 146424,
  [SMALL_STATE(3949)] = 146462,
  [SMALL_STATE(3950)] = 146504,
  [SMALL_STATE(3951)] = 146542,
  [SMALL_STATE(3952)] = 146570,
  [SMALL_STATE(3953)] = 146612,
  [SMALL_STATE(3954)] = 146654,
  [SMALL_STATE(3955)] = 146698,
  [SMALL_STATE(3956)] = 146740,
  [SMALL_STATE(3957)] = 146782,
  [SMALL_STATE(3958)] = 146810,
  [SMALL_STATE(3959)] = 146848,
  [SMALL_STATE(3960)] = 146890,
  [SMALL_STATE(3961)] = 146932,
  [SMALL_STATE(3962)] = 146966,
  [SMALL_STATE(3963)] = 147010,
  [SMALL_STATE(3964)] = 147046,
  [SMALL_STATE(3965)] = 147088,
  [SMALL_STATE(3966)] = 147122,
  [SMALL_STATE(3967)] = 147145,
  [SMALL_STATE(3968)] = 147174,
  [SMALL_STATE(3969)] = 147199,
  [SMALL_STATE(3970)] = 147224,
  [SMALL_STATE(3971)] = 147249,
  [SMALL_STATE(3972)] = 147274,
  [SMALL_STATE(3973)] = 147299,
  [SMALL_STATE(3974)] = 147328,
  [SMALL_STATE(3975)] = 147357,
  [SMALL_STATE(3976)] = 147388,
  [SMALL_STATE(3977)] = 147413,
  [SMALL_STATE(3978)] = 147438,
  [SMALL_STATE(3979)] = 147463,
  [SMALL_STATE(3980)] = 147486,
  [SMALL_STATE(3981)] = 147509,
  [SMALL_STATE(3982)] = 147536,
  [SMALL_STATE(3983)] = 147565,
  [SMALL_STATE(3984)] = 147588,
  [SMALL_STATE(3985)] = 147613,
  [SMALL_STATE(3986)] = 147638,
  [SMALL_STATE(3987)] = 147663,
  [SMALL_STATE(3988)] = 147690,
  [SMALL_STATE(3989)] = 147715,
  [SMALL_STATE(3990)] = 147740,
  [SMALL_STATE(3991)] = 147767,
  [SMALL_STATE(3992)] = 147792,
  [SMALL_STATE(3993)] = 147817,
  [SMALL_STATE(3994)] = 147842,
  [SMALL_STATE(3995)] = 147871,
  [SMALL_STATE(3996)] = 147900,
  [SMALL_STATE(3997)] = 147925,
  [SMALL_STATE(3998)] = 147952,
  [SMALL_STATE(3999)] = 147977,
  [SMALL_STATE(4000)] = 148002,
  [SMALL_STATE(4001)] = 148027,
  [SMALL_STATE(4002)] = 148050,
  [SMALL_STATE(4003)] = 148075,
  [SMALL_STATE(4004)] = 148118,
  [SMALL_STATE(4005)] = 148143,
  [SMALL_STATE(4006)] = 148172,
  [SMALL_STATE(4007)] = 148197,
  [SMALL_STATE(4008)] = 148220,
  [SMALL_STATE(4009)] = 148243,
  [SMALL_STATE(4010)] = 148266,
  [SMALL_STATE(4011)] = 148291,
  [SMALL_STATE(4012)] = 148316,
  [SMALL_STATE(4013)] = 148341,
  [SMALL_STATE(4014)] = 148366,
  [SMALL_STATE(4015)] = 148393,
  [SMALL_STATE(4016)] = 148418,
  [SMALL_STATE(4017)] = 148443,
  [SMALL_STATE(4018)] = 148468,
  [SMALL_STATE(4019)] = 148493,
  [SMALL_STATE(4020)] = 148522,
  [SMALL_STATE(4021)] = 148549,
  [SMALL_STATE(4022)] = 148576,
  [SMALL_STATE(4023)] = 148601,
  [SMALL_STATE(4024)] = 148626,
  [SMALL_STATE(4025)] = 148651,
  [SMALL_STATE(4026)] = 148676,
  [SMALL_STATE(4027)] = 148701,
  [SMALL_STATE(4028)] = 148724,
  [SMALL_STATE(4029)] = 148749,
  [SMALL_STATE(4030)] = 148774,
  [SMALL_STATE(4031)] = 148812,
  [SMALL_STATE(4032)] = 148840,
  [SMALL_STATE(4033)] = 148880,
  [SMALL_STATE(4034)] = 148904,
  [SMALL_STATE(4035)] = 148944,
  [SMALL_STATE(4036)] = 148972,
  [SMALL_STATE(4037)] = 149012,
  [SMALL_STATE(4038)] = 149048,
  [SMALL_STATE(4039)] = 149088,
  [SMALL_STATE(4040)] = 149116,
  [SMALL_STATE(4041)] = 149156,
  [SMALL_STATE(4042)] = 149196,
  [SMALL_STATE(4043)] = 149232,
  [SMALL_STATE(4044)] = 149266,
  [SMALL_STATE(4045)] = 149290,
  [SMALL_STATE(4046)] = 149326,
  [SMALL_STATE(4047)] = 149366,
  [SMALL_STATE(4048)] = 149406,
  [SMALL_STATE(4049)] = 149440,
  [SMALL_STATE(4050)] = 149480,
  [SMALL_STATE(4051)] = 149502,
  [SMALL_STATE(4052)] = 149528,
  [SMALL_STATE(4053)] = 149568,
  [SMALL_STATE(4054)] = 149592,
  [SMALL_STATE(4055)] = 149632,
  [SMALL_STATE(4056)] = 149658,
  [SMALL_STATE(4057)] = 149698,
  [SMALL_STATE(4058)] = 149734,
  [SMALL_STATE(4059)] = 149772,
  [SMALL_STATE(4060)] = 149812,
  [SMALL_STATE(4061)] = 149852,
  [SMALL_STATE(4062)] = 149892,
  [SMALL_STATE(4063)] = 149932,
  [SMALL_STATE(4064)] = 149972,
  [SMALL_STATE(4065)] = 149998,
  [SMALL_STATE(4066)] = 150038,
  [SMALL_STATE(4067)] = 150078,
  [SMALL_STATE(4068)] = 150100,
  [SMALL_STATE(4069)] = 150131,
  [SMALL_STATE(4070)] = 150158,
  [SMALL_STATE(4071)] = 150179,
  [SMALL_STATE(4072)] = 150210,
  [SMALL_STATE(4073)] = 150241,
  [SMALL_STATE(4074)] = 150278,
  [SMALL_STATE(4075)] = 150309,
  [SMALL_STATE(4076)] = 150346,
  [SMALL_STATE(4077)] = 150377,
  [SMALL_STATE(4078)] = 150410,
  [SMALL_STATE(4079)] = 150431,
  [SMALL_STATE(4080)] = 150452,
  [SMALL_STATE(4081)] = 150483,
  [SMALL_STATE(4082)] = 150514,
  [SMALL_STATE(4083)] = 150543,
  [SMALL_STATE(4084)] = 150576,
  [SMALL_STATE(4085)] = 150609,
  [SMALL_STATE(4086)] = 150642,
  [SMALL_STATE(4087)] = 150679,
  [SMALL_STATE(4088)] = 150712,
  [SMALL_STATE(4089)] = 150749,
  [SMALL_STATE(4090)] = 150782,
  [SMALL_STATE(4091)] = 150817,
  [SMALL_STATE(4092)] = 150838,
  [SMALL_STATE(4093)] = 150871,
  [SMALL_STATE(4094)] = 150892,
  [SMALL_STATE(4095)] = 150925,
  [SMALL_STATE(4096)] = 150946,
  [SMALL_STATE(4097)] = 150983,
  [SMALL_STATE(4098)] = 151006,
  [SMALL_STATE(4099)] = 151043,
  [SMALL_STATE(4100)] = 151064,
  [SMALL_STATE(4101)] = 151085,
  [SMALL_STATE(4102)] = 151122,
  [SMALL_STATE(4103)] = 151159,
  [SMALL_STATE(4104)] = 151186,
  [SMALL_STATE(4105)] = 151223,
  [SMALL_STATE(4106)] = 151244,
  [SMALL_STATE(4107)] = 151281,
  [SMALL_STATE(4108)] = 151318,
  [SMALL_STATE(4109)] = 151355,
  [SMALL_STATE(4110)] = 151388,
  [SMALL_STATE(4111)] = 151409,
  [SMALL_STATE(4112)] = 151446,
  [SMALL_STATE(4113)] = 151467,
  [SMALL_STATE(4114)] = 151488,
  [SMALL_STATE(4115)] = 151525,
  [SMALL_STATE(4116)] = 151546,
  [SMALL_STATE(4117)] = 151583,
  [SMALL_STATE(4118)] = 151616,
  [SMALL_STATE(4119)] = 151637,
  [SMALL_STATE(4120)] = 151658,
  [SMALL_STATE(4121)] = 151695,
  [SMALL_STATE(4122)] = 151716,
  [SMALL_STATE(4123)] = 151747,
  [SMALL_STATE(4124)] = 151784,
  [SMALL_STATE(4125)] = 151805,
  [SMALL_STATE(4126)] = 151838,
  [SMALL_STATE(4127)] = 151871,
  [SMALL_STATE(4128)] = 151908,
  [SMALL_STATE(4129)] = 151929,
  [SMALL_STATE(4130)] = 151950,
  [SMALL_STATE(4131)] = 151987,
  [SMALL_STATE(4132)] = 152008,
  [SMALL_STATE(4133)] = 152045,
  [SMALL_STATE(4134)] = 152066,
  [SMALL_STATE(4135)] = 152087,
  [SMALL_STATE(4136)] = 152108,
  [SMALL_STATE(4137)] = 152145,
  [SMALL_STATE(4138)] = 152180,
  [SMALL_STATE(4139)] = 152201,
  [SMALL_STATE(4140)] = 152238,
  [SMALL_STATE(4141)] = 152267,
  [SMALL_STATE(4142)] = 152304,
  [SMALL_STATE(4143)] = 152341,
  [SMALL_STATE(4144)] = 152374,
  [SMALL_STATE(4145)] = 152395,
  [SMALL_STATE(4146)] = 152432,
  [SMALL_STATE(4147)] = 152453,
  [SMALL_STATE(4148)] = 152486,
  [SMALL_STATE(4149)] = 152523,
  [SMALL_STATE(4150)] = 152556,
  [SMALL_STATE(4151)] = 152585,
  [SMALL_STATE(4152)] = 152622,
  [SMALL_STATE(4153)] = 152645,
  [SMALL_STATE(4154)] = 152668,
  [SMALL_STATE(4155)] = 152691,
  [SMALL_STATE(4156)] = 152714,
  [SMALL_STATE(4157)] = 152737,
  [SMALL_STATE(4158)] = 152764,
  [SMALL_STATE(4159)] = 152797,
  [SMALL_STATE(4160)] = 152830,
  [SMALL_STATE(4161)] = 152863,
  [SMALL_STATE(4162)] = 152896,
  [SMALL_STATE(4163)] = 152923,
  [SMALL_STATE(4164)] = 152960,
  [SMALL_STATE(4165)] = 152993,
  [SMALL_STATE(4166)] = 153030,
  [SMALL_STATE(4167)] = 153063,
  [SMALL_STATE(4168)] = 153100,
  [SMALL_STATE(4169)] = 153133,
  [SMALL_STATE(4170)] = 153170,
  [SMALL_STATE(4171)] = 153203,
  [SMALL_STATE(4172)] = 153236,
  [SMALL_STATE(4173)] = 153269,
  [SMALL_STATE(4174)] = 153302,
  [SMALL_STATE(4175)] = 153335,
  [SMALL_STATE(4176)] = 153372,
  [SMALL_STATE(4177)] = 153405,
  [SMALL_STATE(4178)] = 153442,
  [SMALL_STATE(4179)] = 153475,
  [SMALL_STATE(4180)] = 153512,
  [SMALL_STATE(4181)] = 153533,
  [SMALL_STATE(4182)] = 153570,
  [SMALL_STATE(4183)] = 153603,
  [SMALL_STATE(4184)] = 153636,
  [SMALL_STATE(4185)] = 153669,
  [SMALL_STATE(4186)] = 153702,
  [SMALL_STATE(4187)] = 153735,
  [SMALL_STATE(4188)] = 153756,
  [SMALL_STATE(4189)] = 153789,
  [SMALL_STATE(4190)] = 153822,
  [SMALL_STATE(4191)] = 153853,
  [SMALL_STATE(4192)] = 153886,
  [SMALL_STATE(4193)] = 153907,
  [SMALL_STATE(4194)] = 153930,
  [SMALL_STATE(4195)] = 153963,
  [SMALL_STATE(4196)] = 154000,
  [SMALL_STATE(4197)] = 154037,
  [SMALL_STATE(4198)] = 154058,
  [SMALL_STATE(4199)] = 154091,
  [SMALL_STATE(4200)] = 154112,
  [SMALL_STATE(4201)] = 154133,
  [SMALL_STATE(4202)] = 154166,
  [SMALL_STATE(4203)] = 154199,
  [SMALL_STATE(4204)] = 154232,
  [SMALL_STATE(4205)] = 154253,
  [SMALL_STATE(4206)] = 154274,
  [SMALL_STATE(4207)] = 154311,
  [SMALL_STATE(4208)] = 154346,
  [SMALL_STATE(4209)] = 154367,
  [SMALL_STATE(4210)] = 154394,
  [SMALL_STATE(4211)] = 154427,
  [SMALL_STATE(4212)] = 154464,
  [SMALL_STATE(4213)] = 154501,
  [SMALL_STATE(4214)] = 154532,
  [SMALL_STATE(4215)] = 154565,
  [SMALL_STATE(4216)] = 154586,
  [SMALL_STATE(4217)] = 154619,
  [SMALL_STATE(4218)] = 154650,
  [SMALL_STATE(4219)] = 154683,
  [SMALL_STATE(4220)] = 154716,
  [SMALL_STATE(4221)] = 154749,
  [SMALL_STATE(4222)] = 154782,
  [SMALL_STATE(4223)] = 154815,
  [SMALL_STATE(4224)] = 154852,
  [SMALL_STATE(4225)] = 154885,
  [SMALL_STATE(4226)] = 154918,
  [SMALL_STATE(4227)] = 154951,
  [SMALL_STATE(4228)] = 154984,
  [SMALL_STATE(4229)] = 155007,
  [SMALL_STATE(4230)] = 155030,
  [SMALL_STATE(4231)] = 155061,
  [SMALL_STATE(4232)] = 155086,
  [SMALL_STATE(4233)] = 155113,
  [SMALL_STATE(4234)] = 155146,
  [SMALL_STATE(4235)] = 155183,
  [SMALL_STATE(4236)] = 155204,
  [SMALL_STATE(4237)] = 155237,
  [SMALL_STATE(4238)] = 155258,
  [SMALL_STATE(4239)] = 155295,
  [SMALL_STATE(4240)] = 155320,
  [SMALL_STATE(4241)] = 155341,
  [SMALL_STATE(4242)] = 155364,
  [SMALL_STATE(4243)] = 155401,
  [SMALL_STATE(4244)] = 155422,
  [SMALL_STATE(4245)] = 155443,
  [SMALL_STATE(4246)] = 155476,
  [SMALL_STATE(4247)] = 155509,
  [SMALL_STATE(4248)] = 155530,
  [SMALL_STATE(4249)] = 155567,
  [SMALL_STATE(4250)] = 155588,
  [SMALL_STATE(4251)] = 155625,
  [SMALL_STATE(4252)] = 155662,
  [SMALL_STATE(4253)] = 155683,
  [SMALL_STATE(4254)] = 155704,
  [SMALL_STATE(4255)] = 155741,
  [SMALL_STATE(4256)] = 155766,
  [SMALL_STATE(4257)] = 155787,
  [SMALL_STATE(4258)] = 155820,
  [SMALL_STATE(4259)] = 155853,
  [SMALL_STATE(4260)] = 155886,
  [SMALL_STATE(4261)] = 155919,
  [SMALL_STATE(4262)] = 155952,
  [SMALL_STATE(4263)] = 155985,
  [SMALL_STATE(4264)] = 156006,
  [SMALL_STATE(4265)] = 156037,
  [SMALL_STATE(4266)] = 156070,
  [SMALL_STATE(4267)] = 156091,
  [SMALL_STATE(4268)] = 156112,
  [SMALL_STATE(4269)] = 156149,
  [SMALL_STATE(4270)] = 156180,
  [SMALL_STATE(4271)] = 156213,
  [SMALL_STATE(4272)] = 156234,
  [SMALL_STATE(4273)] = 156271,
  [SMALL_STATE(4274)] = 156304,
  [SMALL_STATE(4275)] = 156325,
  [SMALL_STATE(4276)] = 156346,
  [SMALL_STATE(4277)] = 156383,
  [SMALL_STATE(4278)] = 156406,
  [SMALL_STATE(4279)] = 156427,
  [SMALL_STATE(4280)] = 156448,
  [SMALL_STATE(4281)] = 156469,
  [SMALL_STATE(4282)] = 156502,
  [SMALL_STATE(4283)] = 156535,
  [SMALL_STATE(4284)] = 156568,
  [SMALL_STATE(4285)] = 156589,
  [SMALL_STATE(4286)] = 156622,
  [SMALL_STATE(4287)] = 156643,
  [SMALL_STATE(4288)] = 156680,
  [SMALL_STATE(4289)] = 156701,
  [SMALL_STATE(4290)] = 156732,
  [SMALL_STATE(4291)] = 156767,
  [SMALL_STATE(4292)] = 156798,
  [SMALL_STATE(4293)] = 156835,
  [SMALL_STATE(4294)] = 156862,
  [SMALL_STATE(4295)] = 156883,
  [SMALL_STATE(4296)] = 156916,
  [SMALL_STATE(4297)] = 156949,
  [SMALL_STATE(4298)] = 156970,
  [SMALL_STATE(4299)] = 156991,
  [SMALL_STATE(4300)] = 157024,
  [SMALL_STATE(4301)] = 157057,
  [SMALL_STATE(4302)] = 157085,
  [SMALL_STATE(4303)] = 157117,
  [SMALL_STATE(4304)] = 157143,
  [SMALL_STATE(4305)] = 157169,
  [SMALL_STATE(4306)] = 157195,
  [SMALL_STATE(4307)] = 157223,
  [SMALL_STATE(4308)] = 157251,
  [SMALL_STATE(4309)] = 157281,
  [SMALL_STATE(4310)] = 157307,
  [SMALL_STATE(4311)] = 157333,
  [SMALL_STATE(4312)] = 157367,
  [SMALL_STATE(4313)] = 157395,
  [SMALL_STATE(4314)] = 157423,
  [SMALL_STATE(4315)] = 157455,
  [SMALL_STATE(4316)] = 157487,
  [SMALL_STATE(4317)] = 157515,
  [SMALL_STATE(4318)] = 157547,
  [SMALL_STATE(4319)] = 157575,
  [SMALL_STATE(4320)] = 157603,
  [SMALL_STATE(4321)] = 157637,
  [SMALL_STATE(4322)] = 157671,
  [SMALL_STATE(4323)] = 157693,
  [SMALL_STATE(4324)] = 157725,
  [SMALL_STATE(4325)] = 157759,
  [SMALL_STATE(4326)] = 157791,
  [SMALL_STATE(4327)] = 157825,
  [SMALL_STATE(4328)] = 157859,
  [SMALL_STATE(4329)] = 157893,
  [SMALL_STATE(4330)] = 157919,
  [SMALL_STATE(4331)] = 157945,
  [SMALL_STATE(4332)] = 157965,
  [SMALL_STATE(4333)] = 157985,
  [SMALL_STATE(4334)] = 158013,
  [SMALL_STATE(4335)] = 158047,
  [SMALL_STATE(4336)] = 158081,
  [SMALL_STATE(4337)] = 158115,
  [SMALL_STATE(4338)] = 158137,
  [SMALL_STATE(4339)] = 158159,
  [SMALL_STATE(4340)] = 158191,
  [SMALL_STATE(4341)] = 158218,
  [SMALL_STATE(4342)] = 158249,
  [SMALL_STATE(4343)] = 158276,
  [SMALL_STATE(4344)] = 158303,
  [SMALL_STATE(4345)] = 158334,
  [SMALL_STATE(4346)] = 158361,
  [SMALL_STATE(4347)] = 158392,
  [SMALL_STATE(4348)] = 158423,
  [SMALL_STATE(4349)] = 158454,
  [SMALL_STATE(4350)] = 158481,
  [SMALL_STATE(4351)] = 158508,
  [SMALL_STATE(4352)] = 158539,
  [SMALL_STATE(4353)] = 158570,
  [SMALL_STATE(4354)] = 158597,
  [SMALL_STATE(4355)] = 158624,
  [SMALL_STATE(4356)] = 158651,
  [SMALL_STATE(4357)] = 158678,
  [SMALL_STATE(4358)] = 158705,
  [SMALL_STATE(4359)] = 158732,
  [SMALL_STATE(4360)] = 158759,
  [SMALL_STATE(4361)] = 158786,
  [SMALL_STATE(4362)] = 158813,
  [SMALL_STATE(4363)] = 158840,
  [SMALL_STATE(4364)] = 158871,
  [SMALL_STATE(4365)] = 158898,
  [SMALL_STATE(4366)] = 158925,
  [SMALL_STATE(4367)] = 158952,
  [SMALL_STATE(4368)] = 158973,
  [SMALL_STATE(4369)] = 159000,
  [SMALL_STATE(4370)] = 159027,
  [SMALL_STATE(4371)] = 159058,
  [SMALL_STATE(4372)] = 159085,
  [SMALL_STATE(4373)] = 159116,
  [SMALL_STATE(4374)] = 159143,
  [SMALL_STATE(4375)] = 159170,
  [SMALL_STATE(4376)] = 159197,
  [SMALL_STATE(4377)] = 159224,
  [SMALL_STATE(4378)] = 159251,
  [SMALL_STATE(4379)] = 159278,
  [SMALL_STATE(4380)] = 159307,
  [SMALL_STATE(4381)] = 159338,
  [SMALL_STATE(4382)] = 159369,
  [SMALL_STATE(4383)] = 159400,
  [SMALL_STATE(4384)] = 159431,
  [SMALL_STATE(4385)] = 159454,
  [SMALL_STATE(4386)] = 159485,
  [SMALL_STATE(4387)] = 159508,
  [SMALL_STATE(4388)] = 159531,
  [SMALL_STATE(4389)] = 159562,
  [SMALL_STATE(4390)] = 159581,
  [SMALL_STATE(4391)] = 159612,
  [SMALL_STATE(4392)] = 159639,
  [SMALL_STATE(4393)] = 159670,
  [SMALL_STATE(4394)] = 159697,
  [SMALL_STATE(4395)] = 159728,
  [SMALL_STATE(4396)] = 159759,
  [SMALL_STATE(4397)] = 159790,
  [SMALL_STATE(4398)] = 159809,
  [SMALL_STATE(4399)] = 159830,
  [SMALL_STATE(4400)] = 159861,
  [SMALL_STATE(4401)] = 159888,
  [SMALL_STATE(4402)] = 159915,
  [SMALL_STATE(4403)] = 159942,
  [SMALL_STATE(4404)] = 159967,
  [SMALL_STATE(4405)] = 159994,
  [SMALL_STATE(4406)] = 160021,
  [SMALL_STATE(4407)] = 160048,
  [SMALL_STATE(4408)] = 160075,
  [SMALL_STATE(4409)] = 160094,
  [SMALL_STATE(4410)] = 160125,
  [SMALL_STATE(4411)] = 160152,
  [SMALL_STATE(4412)] = 160183,
  [SMALL_STATE(4413)] = 160214,
  [SMALL_STATE(4414)] = 160245,
  [SMALL_STATE(4415)] = 160272,
  [SMALL_STATE(4416)] = 160303,
  [SMALL_STATE(4417)] = 160330,
  [SMALL_STATE(4418)] = 160357,
  [SMALL_STATE(4419)] = 160388,
  [SMALL_STATE(4420)] = 160407,
  [SMALL_STATE(4421)] = 160438,
  [SMALL_STATE(4422)] = 160469,
  [SMALL_STATE(4423)] = 160500,
  [SMALL_STATE(4424)] = 160527,
  [SMALL_STATE(4425)] = 160546,
  [SMALL_STATE(4426)] = 160573,
  [SMALL_STATE(4427)] = 160592,
  [SMALL_STATE(4428)] = 160619,
  [SMALL_STATE(4429)] = 160646,
  [SMALL_STATE(4430)] = 160673,
  [SMALL_STATE(4431)] = 160700,
  [SMALL_STATE(4432)] = 160721,
  [SMALL_STATE(4433)] = 160748,
  [SMALL_STATE(4434)] = 160775,
  [SMALL_STATE(4435)] = 160806,
  [SMALL_STATE(4436)] = 160833,
  [SMALL_STATE(4437)] = 160860,
  [SMALL_STATE(4438)] = 160879,
  [SMALL_STATE(4439)] = 160898,
  [SMALL_STATE(4440)] = 160925,
  [SMALL_STATE(4441)] = 160952,
  [SMALL_STATE(4442)] = 160971,
  [SMALL_STATE(4443)] = 161002,
  [SMALL_STATE(4444)] = 161029,
  [SMALL_STATE(4445)] = 161056,
  [SMALL_STATE(4446)] = 161087,
  [SMALL_STATE(4447)] = 161114,
  [SMALL_STATE(4448)] = 161141,
  [SMALL_STATE(4449)] = 161172,
  [SMALL_STATE(4450)] = 161199,
  [SMALL_STATE(4451)] = 161226,
  [SMALL_STATE(4452)] = 161257,
  [SMALL_STATE(4453)] = 161288,
  [SMALL_STATE(4454)] = 161315,
  [SMALL_STATE(4455)] = 161334,
  [SMALL_STATE(4456)] = 161357,
  [SMALL_STATE(4457)] = 161388,
  [SMALL_STATE(4458)] = 161411,
  [SMALL_STATE(4459)] = 161442,
  [SMALL_STATE(4460)] = 161473,
  [SMALL_STATE(4461)] = 161500,
  [SMALL_STATE(4462)] = 161531,
  [SMALL_STATE(4463)] = 161558,
  [SMALL_STATE(4464)] = 161585,
  [SMALL_STATE(4465)] = 161616,
  [SMALL_STATE(4466)] = 161643,
  [SMALL_STATE(4467)] = 161674,
  [SMALL_STATE(4468)] = 161705,
  [SMALL_STATE(4469)] = 161736,
  [SMALL_STATE(4470)] = 161767,
  [SMALL_STATE(4471)] = 161798,
  [SMALL_STATE(4472)] = 161829,
  [SMALL_STATE(4473)] = 161860,
  [SMALL_STATE(4474)] = 161887,
  [SMALL_STATE(4475)] = 161914,
  [SMALL_STATE(4476)] = 161945,
  [SMALL_STATE(4477)] = 161976,
  [SMALL_STATE(4478)] = 162007,
  [SMALL_STATE(4479)] = 162026,
  [SMALL_STATE(4480)] = 162053,
  [SMALL_STATE(4481)] = 162080,
  [SMALL_STATE(4482)] = 162111,
  [SMALL_STATE(4483)] = 162142,
  [SMALL_STATE(4484)] = 162169,
  [SMALL_STATE(4485)] = 162200,
  [SMALL_STATE(4486)] = 162229,
  [SMALL_STATE(4487)] = 162252,
  [SMALL_STATE(4488)] = 162275,
  [SMALL_STATE(4489)] = 162298,
  [SMALL_STATE(4490)] = 162327,
  [SMALL_STATE(4491)] = 162356,
  [SMALL_STATE(4492)] = 162383,
  [SMALL_STATE(4493)] = 162414,
  [SMALL_STATE(4494)] = 162441,
  [SMALL_STATE(4495)] = 162468,
  [SMALL_STATE(4496)] = 162495,
  [SMALL_STATE(4497)] = 162522,
  [SMALL_STATE(4498)] = 162549,
  [SMALL_STATE(4499)] = 162576,
  [SMALL_STATE(4500)] = 162607,
  [SMALL_STATE(4501)] = 162630,
  [SMALL_STATE(4502)] = 162661,
  [SMALL_STATE(4503)] = 162680,
  [SMALL_STATE(4504)] = 162711,
  [SMALL_STATE(4505)] = 162742,
  [SMALL_STATE(4506)] = 162773,
  [SMALL_STATE(4507)] = 162804,
  [SMALL_STATE(4508)] = 162827,
  [SMALL_STATE(4509)] = 162856,
  [SMALL_STATE(4510)] = 162879,
  [SMALL_STATE(4511)] = 162898,
  [SMALL_STATE(4512)] = 162925,
  [SMALL_STATE(4513)] = 162944,
  [SMALL_STATE(4514)] = 162963,
  [SMALL_STATE(4515)] = 162986,
  [SMALL_STATE(4516)] = 163009,
  [SMALL_STATE(4517)] = 163032,
  [SMALL_STATE(4518)] = 163055,
  [SMALL_STATE(4519)] = 163084,
  [SMALL_STATE(4520)] = 163111,
  [SMALL_STATE(4521)] = 163142,
  [SMALL_STATE(4522)] = 163173,
  [SMALL_STATE(4523)] = 163200,
  [SMALL_STATE(4524)] = 163229,
  [SMALL_STATE(4525)] = 163258,
  [SMALL_STATE(4526)] = 163287,
  [SMALL_STATE(4527)] = 163306,
  [SMALL_STATE(4528)] = 163325,
  [SMALL_STATE(4529)] = 163354,
  [SMALL_STATE(4530)] = 163377,
  [SMALL_STATE(4531)] = 163400,
  [SMALL_STATE(4532)] = 163419,
  [SMALL_STATE(4533)] = 163442,
  [SMALL_STATE(4534)] = 163471,
  [SMALL_STATE(4535)] = 163494,
  [SMALL_STATE(4536)] = 163525,
  [SMALL_STATE(4537)] = 163556,
  [SMALL_STATE(4538)] = 163585,
  [SMALL_STATE(4539)] = 163614,
  [SMALL_STATE(4540)] = 163637,
  [SMALL_STATE(4541)] = 163666,
  [SMALL_STATE(4542)] = 163693,
  [SMALL_STATE(4543)] = 163720,
  [SMALL_STATE(4544)] = 163743,
  [SMALL_STATE(4545)] = 163766,
  [SMALL_STATE(4546)] = 163795,
  [SMALL_STATE(4547)] = 163818,
  [SMALL_STATE(4548)] = 163845,
  [SMALL_STATE(4549)] = 163868,
  [SMALL_STATE(4550)] = 163899,
  [SMALL_STATE(4551)] = 163922,
  [SMALL_STATE(4552)] = 163949,
  [SMALL_STATE(4553)] = 163976,
  [SMALL_STATE(4554)] = 163999,
  [SMALL_STATE(4555)] = 164020,
  [SMALL_STATE(4556)] = 164047,
  [SMALL_STATE(4557)] = 164074,
  [SMALL_STATE(4558)] = 164097,
  [SMALL_STATE(4559)] = 164120,
  [SMALL_STATE(4560)] = 164151,
  [SMALL_STATE(4561)] = 164174,
  [SMALL_STATE(4562)] = 164193,
  [SMALL_STATE(4563)] = 164222,
  [SMALL_STATE(4564)] = 164243,
  [SMALL_STATE(4565)] = 164274,
  [SMALL_STATE(4566)] = 164305,
  [SMALL_STATE(4567)] = 164330,
  [SMALL_STATE(4568)] = 164349,
  [SMALL_STATE(4569)] = 164372,
  [SMALL_STATE(4570)] = 164403,
  [SMALL_STATE(4571)] = 164434,
  [SMALL_STATE(4572)] = 164463,
  [SMALL_STATE(4573)] = 164482,
  [SMALL_STATE(4574)] = 164503,
  [SMALL_STATE(4575)] = 164530,
  [SMALL_STATE(4576)] = 164557,
  [SMALL_STATE(4577)] = 164584,
  [SMALL_STATE(4578)] = 164611,
  [SMALL_STATE(4579)] = 164638,
  [SMALL_STATE(4580)] = 164669,
  [SMALL_STATE(4581)] = 164688,
  [SMALL_STATE(4582)] = 164709,
  [SMALL_STATE(4583)] = 164728,
  [SMALL_STATE(4584)] = 164759,
  [SMALL_STATE(4585)] = 164788,
  [SMALL_STATE(4586)] = 164819,
  [SMALL_STATE(4587)] = 164850,
  [SMALL_STATE(4588)] = 164881,
  [SMALL_STATE(4589)] = 164900,
  [SMALL_STATE(4590)] = 164931,
  [SMALL_STATE(4591)] = 164962,
  [SMALL_STATE(4592)] = 164993,
  [SMALL_STATE(4593)] = 165020,
  [SMALL_STATE(4594)] = 165047,
  [SMALL_STATE(4595)] = 165074,
  [SMALL_STATE(4596)] = 165093,
  [SMALL_STATE(4597)] = 165120,
  [SMALL_STATE(4598)] = 165147,
  [SMALL_STATE(4599)] = 165174,
  [SMALL_STATE(4600)] = 165193,
  [SMALL_STATE(4601)] = 165212,
  [SMALL_STATE(4602)] = 165231,
  [SMALL_STATE(4603)] = 165258,
  [SMALL_STATE(4604)] = 165285,
  [SMALL_STATE(4605)] = 165312,
  [SMALL_STATE(4606)] = 165339,
  [SMALL_STATE(4607)] = 165358,
  [SMALL_STATE(4608)] = 165377,
  [SMALL_STATE(4609)] = 165408,
  [SMALL_STATE(4610)] = 165439,
  [SMALL_STATE(4611)] = 165466,
  [SMALL_STATE(4612)] = 165493,
  [SMALL_STATE(4613)] = 165524,
  [SMALL_STATE(4614)] = 165546,
  [SMALL_STATE(4615)] = 165568,
  [SMALL_STATE(4616)] = 165588,
  [SMALL_STATE(4617)] = 165614,
  [SMALL_STATE(4618)] = 165634,
  [SMALL_STATE(4619)] = 165662,
  [SMALL_STATE(4620)] = 165684,
  [SMALL_STATE(4621)] = 165704,
  [SMALL_STATE(4622)] = 165732,
  [SMALL_STATE(4623)] = 165760,
  [SMALL_STATE(4624)] = 165780,
  [SMALL_STATE(4625)] = 165806,
  [SMALL_STATE(4626)] = 165826,
  [SMALL_STATE(4627)] = 165854,
  [SMALL_STATE(4628)] = 165882,
  [SMALL_STATE(4629)] = 165902,
  [SMALL_STATE(4630)] = 165928,
  [SMALL_STATE(4631)] = 165950,
  [SMALL_STATE(4632)] = 165972,
  [SMALL_STATE(4633)] = 165994,
  [SMALL_STATE(4634)] = 166016,
  [SMALL_STATE(4635)] = 166034,
  [SMALL_STATE(4636)] = 166060,
  [SMALL_STATE(4637)] = 166082,
  [SMALL_STATE(4638)] = 166110,
  [SMALL_STATE(4639)] = 166128,
  [SMALL_STATE(4640)] = 166156,
  [SMALL_STATE(4641)] = 166174,
  [SMALL_STATE(4642)] = 166202,
  [SMALL_STATE(4643)] = 166228,
  [SMALL_STATE(4644)] = 166250,
  [SMALL_STATE(4645)] = 166278,
  [SMALL_STATE(4646)] = 166296,
  [SMALL_STATE(4647)] = 166314,
  [SMALL_STATE(4648)] = 166342,
  [SMALL_STATE(4649)] = 166364,
  [SMALL_STATE(4650)] = 166392,
  [SMALL_STATE(4651)] = 166420,
  [SMALL_STATE(4652)] = 166448,
  [SMALL_STATE(4653)] = 166470,
  [SMALL_STATE(4654)] = 166498,
  [SMALL_STATE(4655)] = 166520,
  [SMALL_STATE(4656)] = 166546,
  [SMALL_STATE(4657)] = 166574,
  [SMALL_STATE(4658)] = 166596,
  [SMALL_STATE(4659)] = 166618,
  [SMALL_STATE(4660)] = 166644,
  [SMALL_STATE(4661)] = 166672,
  [SMALL_STATE(4662)] = 166690,
  [SMALL_STATE(4663)] = 166718,
  [SMALL_STATE(4664)] = 166744,
  [SMALL_STATE(4665)] = 166762,
  [SMALL_STATE(4666)] = 166780,
  [SMALL_STATE(4667)] = 166798,
  [SMALL_STATE(4668)] = 166820,
  [SMALL_STATE(4669)] = 166838,
  [SMALL_STATE(4670)] = 166860,
  [SMALL_STATE(4671)] = 166888,
  [SMALL_STATE(4672)] = 166916,
  [SMALL_STATE(4673)] = 166942,
  [SMALL_STATE(4674)] = 166970,
  [SMALL_STATE(4675)] = 166998,
  [SMALL_STATE(4676)] = 167026,
  [SMALL_STATE(4677)] = 167054,
  [SMALL_STATE(4678)] = 167072,
  [SMALL_STATE(4679)] = 167098,
  [SMALL_STATE(4680)] = 167120,
  [SMALL_STATE(4681)] = 167142,
  [SMALL_STATE(4682)] = 167164,
  [SMALL_STATE(4683)] = 167186,
  [SMALL_STATE(4684)] = 167208,
  [SMALL_STATE(4685)] = 167236,
  [SMALL_STATE(4686)] = 167264,
  [SMALL_STATE(4687)] = 167284,
  [SMALL_STATE(4688)] = 167302,
  [SMALL_STATE(4689)] = 167324,
  [SMALL_STATE(4690)] = 167342,
  [SMALL_STATE(4691)] = 167370,
  [SMALL_STATE(4692)] = 167388,
  [SMALL_STATE(4693)] = 167416,
  [SMALL_STATE(4694)] = 167444,
  [SMALL_STATE(4695)] = 167462,
  [SMALL_STATE(4696)] = 167480,
  [SMALL_STATE(4697)] = 167508,
  [SMALL_STATE(4698)] = 167536,
  [SMALL_STATE(4699)] = 167554,
  [SMALL_STATE(4700)] = 167582,
  [SMALL_STATE(4701)] = 167604,
  [SMALL_STATE(4702)] = 167632,
  [SMALL_STATE(4703)] = 167660,
  [SMALL_STATE(4704)] = 167686,
  [SMALL_STATE(4705)] = 167704,
  [SMALL_STATE(4706)] = 167722,
  [SMALL_STATE(4707)] = 167744,
  [SMALL_STATE(4708)] = 167772,
  [SMALL_STATE(4709)] = 167800,
  [SMALL_STATE(4710)] = 167822,
  [SMALL_STATE(4711)] = 167840,
  [SMALL_STATE(4712)] = 167858,
  [SMALL_STATE(4713)] = 167880,
  [SMALL_STATE(4714)] = 167902,
  [SMALL_STATE(4715)] = 167922,
  [SMALL_STATE(4716)] = 167950,
  [SMALL_STATE(4717)] = 167976,
  [SMALL_STATE(4718)] = 167994,
  [SMALL_STATE(4719)] = 168016,
  [SMALL_STATE(4720)] = 168038,
  [SMALL_STATE(4721)] = 168066,
  [SMALL_STATE(4722)] = 168084,
  [SMALL_STATE(4723)] = 168106,
  [SMALL_STATE(4724)] = 168124,
  [SMALL_STATE(4725)] = 168146,
  [SMALL_STATE(4726)] = 168168,
  [SMALL_STATE(4727)] = 168196,
  [SMALL_STATE(4728)] = 168224,
  [SMALL_STATE(4729)] = 168242,
  [SMALL_STATE(4730)] = 168264,
  [SMALL_STATE(4731)] = 168292,
  [SMALL_STATE(4732)] = 168320,
  [SMALL_STATE(4733)] = 168348,
  [SMALL_STATE(4734)] = 168370,
  [SMALL_STATE(4735)] = 168388,
  [SMALL_STATE(4736)] = 168410,
  [SMALL_STATE(4737)] = 168438,
  [SMALL_STATE(4738)] = 168464,
  [SMALL_STATE(4739)] = 168492,
  [SMALL_STATE(4740)] = 168520,
  [SMALL_STATE(4741)] = 168542,
  [SMALL_STATE(4742)] = 168568,
  [SMALL_STATE(4743)] = 168590,
  [SMALL_STATE(4744)] = 168612,
  [SMALL_STATE(4745)] = 168636,
  [SMALL_STATE(4746)] = 168658,
  [SMALL_STATE(4747)] = 168684,
  [SMALL_STATE(4748)] = 168712,
  [SMALL_STATE(4749)] = 168734,
  [SMALL_STATE(4750)] = 168762,
  [SMALL_STATE(4751)] = 168790,
  [SMALL_STATE(4752)] = 168808,
  [SMALL_STATE(4753)] = 168836,
  [SMALL_STATE(4754)] = 168854,
  [SMALL_STATE(4755)] = 168882,
  [SMALL_STATE(4756)] = 168900,
  [SMALL_STATE(4757)] = 168928,
  [SMALL_STATE(4758)] = 168950,
  [SMALL_STATE(4759)] = 168978,
  [SMALL_STATE(4760)] = 169000,
  [SMALL_STATE(4761)] = 169022,
  [SMALL_STATE(4762)] = 169044,
  [SMALL_STATE(4763)] = 169062,
  [SMALL_STATE(4764)] = 169080,
  [SMALL_STATE(4765)] = 169102,
  [SMALL_STATE(4766)] = 169124,
  [SMALL_STATE(4767)] = 169152,
  [SMALL_STATE(4768)] = 169180,
  [SMALL_STATE(4769)] = 169202,
  [SMALL_STATE(4770)] = 169224,
  [SMALL_STATE(4771)] = 169246,
  [SMALL_STATE(4772)] = 169268,
  [SMALL_STATE(4773)] = 169290,
  [SMALL_STATE(4774)] = 169312,
  [SMALL_STATE(4775)] = 169330,
  [SMALL_STATE(4776)] = 169352,
  [SMALL_STATE(4777)] = 169378,
  [SMALL_STATE(4778)] = 169400,
  [SMALL_STATE(4779)] = 169422,
  [SMALL_STATE(4780)] = 169450,
  [SMALL_STATE(4781)] = 169470,
  [SMALL_STATE(4782)] = 169498,
  [SMALL_STATE(4783)] = 169526,
  [SMALL_STATE(4784)] = 169544,
  [SMALL_STATE(4785)] = 169572,
  [SMALL_STATE(4786)] = 169590,
  [SMALL_STATE(4787)] = 169608,
  [SMALL_STATE(4788)] = 169626,
  [SMALL_STATE(4789)] = 169652,
  [SMALL_STATE(4790)] = 169670,
  [SMALL_STATE(4791)] = 169688,
  [SMALL_STATE(4792)] = 169712,
  [SMALL_STATE(4793)] = 169730,
  [SMALL_STATE(4794)] = 169748,
  [SMALL_STATE(4795)] = 169766,
  [SMALL_STATE(4796)] = 169794,
  [SMALL_STATE(4797)] = 169820,
  [SMALL_STATE(4798)] = 169842,
  [SMALL_STATE(4799)] = 169864,
  [SMALL_STATE(4800)] = 169892,
  [SMALL_STATE(4801)] = 169918,
  [SMALL_STATE(4802)] = 169946,
  [SMALL_STATE(4803)] = 169974,
  [SMALL_STATE(4804)] = 170002,
  [SMALL_STATE(4805)] = 170024,
  [SMALL_STATE(4806)] = 170046,
  [SMALL_STATE(4807)] = 170072,
  [SMALL_STATE(4808)] = 170090,
  [SMALL_STATE(4809)] = 170118,
  [SMALL_STATE(4810)] = 170136,
  [SMALL_STATE(4811)] = 170164,
  [SMALL_STATE(4812)] = 170192,
  [SMALL_STATE(4813)] = 170220,
  [SMALL_STATE(4814)] = 170246,
  [SMALL_STATE(4815)] = 170272,
  [SMALL_STATE(4816)] = 170294,
  [SMALL_STATE(4817)] = 170322,
  [SMALL_STATE(4818)] = 170350,
  [SMALL_STATE(4819)] = 170376,
  [SMALL_STATE(4820)] = 170398,
  [SMALL_STATE(4821)] = 170426,
  [SMALL_STATE(4822)] = 170454,
  [SMALL_STATE(4823)] = 170482,
  [SMALL_STATE(4824)] = 170510,
  [SMALL_STATE(4825)] = 170538,
  [SMALL_STATE(4826)] = 170558,
  [SMALL_STATE(4827)] = 170586,
  [SMALL_STATE(4828)] = 170610,
  [SMALL_STATE(4829)] = 170628,
  [SMALL_STATE(4830)] = 170656,
  [SMALL_STATE(4831)] = 170684,
  [SMALL_STATE(4832)] = 170702,
  [SMALL_STATE(4833)] = 170722,
  [SMALL_STATE(4834)] = 170750,
  [SMALL_STATE(4835)] = 170768,
  [SMALL_STATE(4836)] = 170796,
  [SMALL_STATE(4837)] = 170824,
  [SMALL_STATE(4838)] = 170850,
  [SMALL_STATE(4839)] = 170878,
  [SMALL_STATE(4840)] = 170900,
  [SMALL_STATE(4841)] = 170926,
  [SMALL_STATE(4842)] = 170954,
  [SMALL_STATE(4843)] = 170982,
  [SMALL_STATE(4844)] = 171010,
  [SMALL_STATE(4845)] = 171035,
  [SMALL_STATE(4846)] = 171056,
  [SMALL_STATE(4847)] = 171077,
  [SMALL_STATE(4848)] = 171094,
  [SMALL_STATE(4849)] = 171119,
  [SMALL_STATE(4850)] = 171136,
  [SMALL_STATE(4851)] = 171161,
  [SMALL_STATE(4852)] = 171182,
  [SMALL_STATE(4853)] = 171199,
  [SMALL_STATE(4854)] = 171220,
  [SMALL_STATE(4855)] = 171245,
  [SMALL_STATE(4856)] = 171266,
  [SMALL_STATE(4857)] = 171291,
  [SMALL_STATE(4858)] = 171308,
  [SMALL_STATE(4859)] = 171325,
  [SMALL_STATE(4860)] = 171342,
  [SMALL_STATE(4861)] = 171363,
  [SMALL_STATE(4862)] = 171388,
  [SMALL_STATE(4863)] = 171405,
  [SMALL_STATE(4864)] = 171422,
  [SMALL_STATE(4865)] = 171447,
  [SMALL_STATE(4866)] = 171472,
  [SMALL_STATE(4867)] = 171489,
  [SMALL_STATE(4868)] = 171510,
  [SMALL_STATE(4869)] = 171527,
  [SMALL_STATE(4870)] = 171552,
  [SMALL_STATE(4871)] = 171569,
  [SMALL_STATE(4872)] = 171594,
  [SMALL_STATE(4873)] = 171615,
  [SMALL_STATE(4874)] = 171640,
  [SMALL_STATE(4875)] = 171661,
  [SMALL_STATE(4876)] = 171686,
  [SMALL_STATE(4877)] = 171711,
  [SMALL_STATE(4878)] = 171732,
  [SMALL_STATE(4879)] = 171749,
  [SMALL_STATE(4880)] = 171770,
  [SMALL_STATE(4881)] = 171787,
  [SMALL_STATE(4882)] = 171808,
  [SMALL_STATE(4883)] = 171829,
  [SMALL_STATE(4884)] = 171850,
  [SMALL_STATE(4885)] = 171871,
  [SMALL_STATE(4886)] = 171896,
  [SMALL_STATE(4887)] = 171921,
  [SMALL_STATE(4888)] = 171946,
  [SMALL_STATE(4889)] = 171967,
  [SMALL_STATE(4890)] = 171988,
  [SMALL_STATE(4891)] = 172005,
  [SMALL_STATE(4892)] = 172030,
  [SMALL_STATE(4893)] = 172051,
  [SMALL_STATE(4894)] = 172068,
  [SMALL_STATE(4895)] = 172089,
  [SMALL_STATE(4896)] = 172106,
  [SMALL_STATE(4897)] = 172123,
  [SMALL_STATE(4898)] = 172144,
  [SMALL_STATE(4899)] = 172165,
  [SMALL_STATE(4900)] = 172182,
  [SMALL_STATE(4901)] = 172199,
  [SMALL_STATE(4902)] = 172220,
  [SMALL_STATE(4903)] = 172241,
  [SMALL_STATE(4904)] = 172262,
  [SMALL_STATE(4905)] = 172279,
  [SMALL_STATE(4906)] = 172300,
  [SMALL_STATE(4907)] = 172317,
  [SMALL_STATE(4908)] = 172342,
  [SMALL_STATE(4909)] = 172363,
  [SMALL_STATE(4910)] = 172388,
  [SMALL_STATE(4911)] = 172409,
  [SMALL_STATE(4912)] = 172430,
  [SMALL_STATE(4913)] = 172451,
  [SMALL_STATE(4914)] = 172476,
  [SMALL_STATE(4915)] = 172501,
  [SMALL_STATE(4916)] = 172518,
  [SMALL_STATE(4917)] = 172535,
  [SMALL_STATE(4918)] = 172556,
  [SMALL_STATE(4919)] = 172581,
  [SMALL_STATE(4920)] = 172606,
  [SMALL_STATE(4921)] = 172627,
  [SMALL_STATE(4922)] = 172652,
  [SMALL_STATE(4923)] = 172677,
  [SMALL_STATE(4924)] = 172698,
  [SMALL_STATE(4925)] = 172723,
  [SMALL_STATE(4926)] = 172744,
  [SMALL_STATE(4927)] = 172761,
  [SMALL_STATE(4928)] = 172782,
  [SMALL_STATE(4929)] = 172807,
  [SMALL_STATE(4930)] = 172828,
  [SMALL_STATE(4931)] = 172853,
  [SMALL_STATE(4932)] = 172878,
  [SMALL_STATE(4933)] = 172899,
  [SMALL_STATE(4934)] = 172924,
  [SMALL_STATE(4935)] = 172949,
  [SMALL_STATE(4936)] = 172966,
  [SMALL_STATE(4937)] = 172987,
  [SMALL_STATE(4938)] = 173004,
  [SMALL_STATE(4939)] = 173029,
  [SMALL_STATE(4940)] = 173050,
  [SMALL_STATE(4941)] = 173071,
  [SMALL_STATE(4942)] = 173096,
  [SMALL_STATE(4943)] = 173117,
  [SMALL_STATE(4944)] = 173134,
  [SMALL_STATE(4945)] = 173151,
  [SMALL_STATE(4946)] = 173168,
  [SMALL_STATE(4947)] = 173185,
  [SMALL_STATE(4948)] = 173206,
  [SMALL_STATE(4949)] = 173223,
  [SMALL_STATE(4950)] = 173244,
  [SMALL_STATE(4951)] = 173269,
  [SMALL_STATE(4952)] = 173290,
  [SMALL_STATE(4953)] = 173307,
  [SMALL_STATE(4954)] = 173328,
  [SMALL_STATE(4955)] = 173353,
  [SMALL_STATE(4956)] = 173378,
  [SMALL_STATE(4957)] = 173395,
  [SMALL_STATE(4958)] = 173416,
  [SMALL_STATE(4959)] = 173437,
  [SMALL_STATE(4960)] = 173458,
  [SMALL_STATE(4961)] = 173483,
  [SMALL_STATE(4962)] = 173504,
  [SMALL_STATE(4963)] = 173529,
  [SMALL_STATE(4964)] = 173546,
  [SMALL_STATE(4965)] = 173563,
  [SMALL_STATE(4966)] = 173584,
  [SMALL_STATE(4967)] = 173605,
  [SMALL_STATE(4968)] = 173622,
  [SMALL_STATE(4969)] = 173639,
  [SMALL_STATE(4970)] = 173660,
  [SMALL_STATE(4971)] = 173677,
  [SMALL_STATE(4972)] = 173698,
  [SMALL_STATE(4973)] = 173715,
  [SMALL_STATE(4974)] = 173736,
  [SMALL_STATE(4975)] = 173753,
  [SMALL_STATE(4976)] = 173774,
  [SMALL_STATE(4977)] = 173799,
  [SMALL_STATE(4978)] = 173820,
  [SMALL_STATE(4979)] = 173837,
  [SMALL_STATE(4980)] = 173862,
  [SMALL_STATE(4981)] = 173887,
  [SMALL_STATE(4982)] = 173912,
  [SMALL_STATE(4983)] = 173935,
  [SMALL_STATE(4984)] = 173952,
  [SMALL_STATE(4985)] = 173973,
  [SMALL_STATE(4986)] = 173998,
  [SMALL_STATE(4987)] = 174019,
  [SMALL_STATE(4988)] = 174038,
  [SMALL_STATE(4989)] = 174061,
  [SMALL_STATE(4990)] = 174082,
  [SMALL_STATE(4991)] = 174099,
  [SMALL_STATE(4992)] = 174124,
  [SMALL_STATE(4993)] = 174145,
  [SMALL_STATE(4994)] = 174162,
  [SMALL_STATE(4995)] = 174183,
  [SMALL_STATE(4996)] = 174200,
  [SMALL_STATE(4997)] = 174217,
  [SMALL_STATE(4998)] = 174238,
  [SMALL_STATE(4999)] = 174263,
  [SMALL_STATE(5000)] = 174288,
  [SMALL_STATE(5001)] = 174313,
  [SMALL_STATE(5002)] = 174334,
  [SMALL_STATE(5003)] = 174355,
  [SMALL_STATE(5004)] = 174380,
  [SMALL_STATE(5005)] = 174397,
  [SMALL_STATE(5006)] = 174418,
  [SMALL_STATE(5007)] = 174443,
  [SMALL_STATE(5008)] = 174468,
  [SMALL_STATE(5009)] = 174489,
  [SMALL_STATE(5010)] = 174514,
  [SMALL_STATE(5011)] = 174535,
  [SMALL_STATE(5012)] = 174560,
  [SMALL_STATE(5013)] = 174577,
  [SMALL_STATE(5014)] = 174602,
  [SMALL_STATE(5015)] = 174627,
  [SMALL_STATE(5016)] = 174652,
  [SMALL_STATE(5017)] = 174677,
  [SMALL_STATE(5018)] = 174702,
  [SMALL_STATE(5019)] = 174723,
  [SMALL_STATE(5020)] = 174744,
  [SMALL_STATE(5021)] = 174769,
  [SMALL_STATE(5022)] = 174790,
  [SMALL_STATE(5023)] = 174815,
  [SMALL_STATE(5024)] = 174836,
  [SMALL_STATE(5025)] = 174853,
  [SMALL_STATE(5026)] = 174874,
  [SMALL_STATE(5027)] = 174891,
  [SMALL_STATE(5028)] = 174916,
  [SMALL_STATE(5029)] = 174941,
  [SMALL_STATE(5030)] = 174966,
  [SMALL_STATE(5031)] = 174987,
  [SMALL_STATE(5032)] = 175008,
  [SMALL_STATE(5033)] = 175033,
  [SMALL_STATE(5034)] = 175058,
  [SMALL_STATE(5035)] = 175083,
  [SMALL_STATE(5036)] = 175108,
  [SMALL_STATE(5037)] = 175129,
  [SMALL_STATE(5038)] = 175154,
  [SMALL_STATE(5039)] = 175171,
  [SMALL_STATE(5040)] = 175188,
  [SMALL_STATE(5041)] = 175209,
  [SMALL_STATE(5042)] = 175234,
  [SMALL_STATE(5043)] = 175255,
  [SMALL_STATE(5044)] = 175280,
  [SMALL_STATE(5045)] = 175297,
  [SMALL_STATE(5046)] = 175322,
  [SMALL_STATE(5047)] = 175345,
  [SMALL_STATE(5048)] = 175370,
  [SMALL_STATE(5049)] = 175391,
  [SMALL_STATE(5050)] = 175408,
  [SMALL_STATE(5051)] = 175433,
  [SMALL_STATE(5052)] = 175450,
  [SMALL_STATE(5053)] = 175467,
  [SMALL_STATE(5054)] = 175488,
  [SMALL_STATE(5055)] = 175509,
  [SMALL_STATE(5056)] = 175526,
  [SMALL_STATE(5057)] = 175547,
  [SMALL_STATE(5058)] = 175572,
  [SMALL_STATE(5059)] = 175589,
  [SMALL_STATE(5060)] = 175610,
  [SMALL_STATE(5061)] = 175635,
  [SMALL_STATE(5062)] = 175652,
  [SMALL_STATE(5063)] = 175677,
  [SMALL_STATE(5064)] = 175702,
  [SMALL_STATE(5065)] = 175719,
  [SMALL_STATE(5066)] = 175742,
  [SMALL_STATE(5067)] = 175763,
  [SMALL_STATE(5068)] = 175780,
  [SMALL_STATE(5069)] = 175805,
  [SMALL_STATE(5070)] = 175830,
  [SMALL_STATE(5071)] = 175847,
  [SMALL_STATE(5072)] = 175864,
  [SMALL_STATE(5073)] = 175881,
  [SMALL_STATE(5074)] = 175904,
  [SMALL_STATE(5075)] = 175927,
  [SMALL_STATE(5076)] = 175944,
  [SMALL_STATE(5077)] = 175961,
  [SMALL_STATE(5078)] = 175982,
  [SMALL_STATE(5079)] = 176003,
  [SMALL_STATE(5080)] = 176020,
  [SMALL_STATE(5081)] = 176037,
  [SMALL_STATE(5082)] = 176054,
  [SMALL_STATE(5083)] = 176071,
  [SMALL_STATE(5084)] = 176088,
  [SMALL_STATE(5085)] = 176105,
  [SMALL_STATE(5086)] = 176130,
  [SMALL_STATE(5087)] = 176147,
  [SMALL_STATE(5088)] = 176164,
  [SMALL_STATE(5089)] = 176181,
  [SMALL_STATE(5090)] = 176202,
  [SMALL_STATE(5091)] = 176223,
  [SMALL_STATE(5092)] = 176244,
  [SMALL_STATE(5093)] = 176261,
  [SMALL_STATE(5094)] = 176286,
  [SMALL_STATE(5095)] = 176311,
  [SMALL_STATE(5096)] = 176328,
  [SMALL_STATE(5097)] = 176345,
  [SMALL_STATE(5098)] = 176370,
  [SMALL_STATE(5099)] = 176387,
  [SMALL_STATE(5100)] = 176410,
  [SMALL_STATE(5101)] = 176431,
  [SMALL_STATE(5102)] = 176454,
  [SMALL_STATE(5103)] = 176479,
  [SMALL_STATE(5104)] = 176500,
  [SMALL_STATE(5105)] = 176521,
  [SMALL_STATE(5106)] = 176538,
  [SMALL_STATE(5107)] = 176563,
  [SMALL_STATE(5108)] = 176588,
  [SMALL_STATE(5109)] = 176613,
  [SMALL_STATE(5110)] = 176630,
  [SMALL_STATE(5111)] = 176651,
  [SMALL_STATE(5112)] = 176676,
  [SMALL_STATE(5113)] = 176697,
  [SMALL_STATE(5114)] = 176714,
  [SMALL_STATE(5115)] = 176739,
  [SMALL_STATE(5116)] = 176756,
  [SMALL_STATE(5117)] = 176773,
  [SMALL_STATE(5118)] = 176790,
  [SMALL_STATE(5119)] = 176811,
  [SMALL_STATE(5120)] = 176836,
  [SMALL_STATE(5121)] = 176857,
  [SMALL_STATE(5122)] = 176874,
  [SMALL_STATE(5123)] = 176897,
  [SMALL_STATE(5124)] = 176922,
  [SMALL_STATE(5125)] = 176947,
  [SMALL_STATE(5126)] = 176968,
  [SMALL_STATE(5127)] = 176989,
  [SMALL_STATE(5128)] = 177006,
  [SMALL_STATE(5129)] = 177031,
  [SMALL_STATE(5130)] = 177052,
  [SMALL_STATE(5131)] = 177069,
  [SMALL_STATE(5132)] = 177094,
  [SMALL_STATE(5133)] = 177111,
  [SMALL_STATE(5134)] = 177132,
  [SMALL_STATE(5135)] = 177149,
  [SMALL_STATE(5136)] = 177166,
  [SMALL_STATE(5137)] = 177183,
  [SMALL_STATE(5138)] = 177208,
  [SMALL_STATE(5139)] = 177225,
  [SMALL_STATE(5140)] = 177250,
  [SMALL_STATE(5141)] = 177267,
  [SMALL_STATE(5142)] = 177292,
  [SMALL_STATE(5143)] = 177317,
  [SMALL_STATE(5144)] = 177334,
  [SMALL_STATE(5145)] = 177351,
  [SMALL_STATE(5146)] = 177372,
  [SMALL_STATE(5147)] = 177389,
  [SMALL_STATE(5148)] = 177406,
  [SMALL_STATE(5149)] = 177431,
  [SMALL_STATE(5150)] = 177452,
  [SMALL_STATE(5151)] = 177469,
  [SMALL_STATE(5152)] = 177494,
  [SMALL_STATE(5153)] = 177515,
  [SMALL_STATE(5154)] = 177536,
  [SMALL_STATE(5155)] = 177561,
  [SMALL_STATE(5156)] = 177582,
  [SMALL_STATE(5157)] = 177599,
  [SMALL_STATE(5158)] = 177624,
  [SMALL_STATE(5159)] = 177641,
  [SMALL_STATE(5160)] = 177658,
  [SMALL_STATE(5161)] = 177675,
  [SMALL_STATE(5162)] = 177700,
  [SMALL_STATE(5163)] = 177725,
  [SMALL_STATE(5164)] = 177746,
  [SMALL_STATE(5165)] = 177767,
  [SMALL_STATE(5166)] = 177788,
  [SMALL_STATE(5167)] = 177809,
  [SMALL_STATE(5168)] = 177830,
  [SMALL_STATE(5169)] = 177851,
  [SMALL_STATE(5170)] = 177868,
  [SMALL_STATE(5171)] = 177885,
  [SMALL_STATE(5172)] = 177902,
  [SMALL_STATE(5173)] = 177923,
  [SMALL_STATE(5174)] = 177948,
  [SMALL_STATE(5175)] = 177969,
  [SMALL_STATE(5176)] = 177986,
  [SMALL_STATE(5177)] = 178011,
  [SMALL_STATE(5178)] = 178028,
  [SMALL_STATE(5179)] = 178049,
  [SMALL_STATE(5180)] = 178066,
  [SMALL_STATE(5181)] = 178087,
  [SMALL_STATE(5182)] = 178112,
  [SMALL_STATE(5183)] = 178133,
  [SMALL_STATE(5184)] = 178150,
  [SMALL_STATE(5185)] = 178167,
  [SMALL_STATE(5186)] = 178188,
  [SMALL_STATE(5187)] = 178205,
  [SMALL_STATE(5188)] = 178222,
  [SMALL_STATE(5189)] = 178239,
  [SMALL_STATE(5190)] = 178260,
  [SMALL_STATE(5191)] = 178277,
  [SMALL_STATE(5192)] = 178302,
  [SMALL_STATE(5193)] = 178327,
  [SMALL_STATE(5194)] = 178348,
  [SMALL_STATE(5195)] = 178365,
  [SMALL_STATE(5196)] = 178390,
  [SMALL_STATE(5197)] = 178415,
  [SMALL_STATE(5198)] = 178440,
  [SMALL_STATE(5199)] = 178465,
  [SMALL_STATE(5200)] = 178490,
  [SMALL_STATE(5201)] = 178509,
  [SMALL_STATE(5202)] = 178534,
  [SMALL_STATE(5203)] = 178557,
  [SMALL_STATE(5204)] = 178582,
  [SMALL_STATE(5205)] = 178607,
  [SMALL_STATE(5206)] = 178624,
  [SMALL_STATE(5207)] = 178641,
  [SMALL_STATE(5208)] = 178666,
  [SMALL_STATE(5209)] = 178691,
  [SMALL_STATE(5210)] = 178716,
  [SMALL_STATE(5211)] = 178737,
  [SMALL_STATE(5212)] = 178758,
  [SMALL_STATE(5213)] = 178777,
  [SMALL_STATE(5214)] = 178798,
  [SMALL_STATE(5215)] = 178815,
  [SMALL_STATE(5216)] = 178834,
  [SMALL_STATE(5217)] = 178851,
  [SMALL_STATE(5218)] = 178876,
  [SMALL_STATE(5219)] = 178897,
  [SMALL_STATE(5220)] = 178922,
  [SMALL_STATE(5221)] = 178943,
  [SMALL_STATE(5222)] = 178962,
  [SMALL_STATE(5223)] = 178983,
  [SMALL_STATE(5224)] = 179004,
  [SMALL_STATE(5225)] = 179029,
  [SMALL_STATE(5226)] = 179050,
  [SMALL_STATE(5227)] = 179075,
  [SMALL_STATE(5228)] = 179098,
  [SMALL_STATE(5229)] = 179119,
  [SMALL_STATE(5230)] = 179140,
  [SMALL_STATE(5231)] = 179161,
  [SMALL_STATE(5232)] = 179182,
  [SMALL_STATE(5233)] = 179207,
  [SMALL_STATE(5234)] = 179230,
  [SMALL_STATE(5235)] = 179251,
  [SMALL_STATE(5236)] = 179272,
  [SMALL_STATE(5237)] = 179293,
  [SMALL_STATE(5238)] = 179314,
  [SMALL_STATE(5239)] = 179335,
  [SMALL_STATE(5240)] = 179356,
  [SMALL_STATE(5241)] = 179377,
  [SMALL_STATE(5242)] = 179394,
  [SMALL_STATE(5243)] = 179415,
  [SMALL_STATE(5244)] = 179432,
  [SMALL_STATE(5245)] = 179455,
  [SMALL_STATE(5246)] = 179476,
  [SMALL_STATE(5247)] = 179493,
  [SMALL_STATE(5248)] = 179518,
  [SMALL_STATE(5249)] = 179535,
  [SMALL_STATE(5250)] = 179552,
  [SMALL_STATE(5251)] = 179569,
  [SMALL_STATE(5252)] = 179590,
  [SMALL_STATE(5253)] = 179615,
  [SMALL_STATE(5254)] = 179632,
  [SMALL_STATE(5255)] = 179657,
  [SMALL_STATE(5256)] = 179678,
  [SMALL_STATE(5257)] = 179703,
  [SMALL_STATE(5258)] = 179724,
  [SMALL_STATE(5259)] = 179745,
  [SMALL_STATE(5260)] = 179768,
  [SMALL_STATE(5261)] = 179785,
  [SMALL_STATE(5262)] = 179810,
  [SMALL_STATE(5263)] = 179827,
  [SMALL_STATE(5264)] = 179844,
  [SMALL_STATE(5265)] = 179861,
  [SMALL_STATE(5266)] = 179878,
  [SMALL_STATE(5267)] = 179903,
  [SMALL_STATE(5268)] = 179928,
  [SMALL_STATE(5269)] = 179951,
  [SMALL_STATE(5270)] = 179968,
  [SMALL_STATE(5271)] = 179989,
  [SMALL_STATE(5272)] = 180014,
  [SMALL_STATE(5273)] = 180031,
  [SMALL_STATE(5274)] = 180052,
  [SMALL_STATE(5275)] = 180077,
  [SMALL_STATE(5276)] = 180094,
  [SMALL_STATE(5277)] = 180115,
  [SMALL_STATE(5278)] = 180132,
  [SMALL_STATE(5279)] = 180149,
  [SMALL_STATE(5280)] = 180174,
  [SMALL_STATE(5281)] = 180191,
  [SMALL_STATE(5282)] = 180208,
  [SMALL_STATE(5283)] = 180229,
  [SMALL_STATE(5284)] = 180246,
  [SMALL_STATE(5285)] = 180267,
  [SMALL_STATE(5286)] = 180284,
  [SMALL_STATE(5287)] = 180301,
  [SMALL_STATE(5288)] = 180322,
  [SMALL_STATE(5289)] = 180343,
  [SMALL_STATE(5290)] = 180360,
  [SMALL_STATE(5291)] = 180377,
  [SMALL_STATE(5292)] = 180402,
  [SMALL_STATE(5293)] = 180419,
  [SMALL_STATE(5294)] = 180444,
  [SMALL_STATE(5295)] = 180461,
  [SMALL_STATE(5296)] = 180478,
  [SMALL_STATE(5297)] = 180495,
  [SMALL_STATE(5298)] = 180516,
  [SMALL_STATE(5299)] = 180533,
  [SMALL_STATE(5300)] = 180558,
  [SMALL_STATE(5301)] = 180575,
  [SMALL_STATE(5302)] = 180600,
  [SMALL_STATE(5303)] = 180621,
  [SMALL_STATE(5304)] = 180642,
  [SMALL_STATE(5305)] = 180659,
  [SMALL_STATE(5306)] = 180680,
  [SMALL_STATE(5307)] = 180705,
  [SMALL_STATE(5308)] = 180722,
  [SMALL_STATE(5309)] = 180739,
  [SMALL_STATE(5310)] = 180756,
  [SMALL_STATE(5311)] = 180777,
  [SMALL_STATE(5312)] = 180798,
  [SMALL_STATE(5313)] = 180819,
  [SMALL_STATE(5314)] = 180844,
  [SMALL_STATE(5315)] = 180867,
  [SMALL_STATE(5316)] = 180884,
  [SMALL_STATE(5317)] = 180905,
  [SMALL_STATE(5318)] = 180922,
  [SMALL_STATE(5319)] = 180939,
  [SMALL_STATE(5320)] = 180960,
  [SMALL_STATE(5321)] = 180983,
  [SMALL_STATE(5322)] = 181004,
  [SMALL_STATE(5323)] = 181025,
  [SMALL_STATE(5324)] = 181046,
  [SMALL_STATE(5325)] = 181063,
  [SMALL_STATE(5326)] = 181084,
  [SMALL_STATE(5327)] = 181101,
  [SMALL_STATE(5328)] = 181122,
  [SMALL_STATE(5329)] = 181143,
  [SMALL_STATE(5330)] = 181164,
  [SMALL_STATE(5331)] = 181181,
  [SMALL_STATE(5332)] = 181202,
  [SMALL_STATE(5333)] = 181223,
  [SMALL_STATE(5334)] = 181244,
  [SMALL_STATE(5335)] = 181267,
  [SMALL_STATE(5336)] = 181284,
  [SMALL_STATE(5337)] = 181309,
  [SMALL_STATE(5338)] = 181326,
  [SMALL_STATE(5339)] = 181343,
  [SMALL_STATE(5340)] = 181368,
  [SMALL_STATE(5341)] = 181389,
  [SMALL_STATE(5342)] = 181410,
  [SMALL_STATE(5343)] = 181431,
  [SMALL_STATE(5344)] = 181454,
  [SMALL_STATE(5345)] = 181479,
  [SMALL_STATE(5346)] = 181504,
  [SMALL_STATE(5347)] = 181529,
  [SMALL_STATE(5348)] = 181546,
  [SMALL_STATE(5349)] = 181567,
  [SMALL_STATE(5350)] = 181584,
  [SMALL_STATE(5351)] = 181605,
  [SMALL_STATE(5352)] = 181622,
  [SMALL_STATE(5353)] = 181643,
  [SMALL_STATE(5354)] = 181666,
  [SMALL_STATE(5355)] = 181691,
  [SMALL_STATE(5356)] = 181712,
  [SMALL_STATE(5357)] = 181733,
  [SMALL_STATE(5358)] = 181758,
  [SMALL_STATE(5359)] = 181775,
  [SMALL_STATE(5360)] = 181792,
  [SMALL_STATE(5361)] = 181813,
  [SMALL_STATE(5362)] = 181834,
  [SMALL_STATE(5363)] = 181855,
  [SMALL_STATE(5364)] = 181872,
  [SMALL_STATE(5365)] = 181889,
  [SMALL_STATE(5366)] = 181910,
  [SMALL_STATE(5367)] = 181931,
  [SMALL_STATE(5368)] = 181952,
  [SMALL_STATE(5369)] = 181969,
  [SMALL_STATE(5370)] = 181994,
  [SMALL_STATE(5371)] = 182019,
  [SMALL_STATE(5372)] = 182044,
  [SMALL_STATE(5373)] = 182069,
  [SMALL_STATE(5374)] = 182090,
  [SMALL_STATE(5375)] = 182107,
  [SMALL_STATE(5376)] = 182128,
  [SMALL_STATE(5377)] = 182149,
  [SMALL_STATE(5378)] = 182174,
  [SMALL_STATE(5379)] = 182191,
  [SMALL_STATE(5380)] = 182212,
  [SMALL_STATE(5381)] = 182237,
  [SMALL_STATE(5382)] = 182262,
  [SMALL_STATE(5383)] = 182287,
  [SMALL_STATE(5384)] = 182310,
  [SMALL_STATE(5385)] = 182331,
  [SMALL_STATE(5386)] = 182356,
  [SMALL_STATE(5387)] = 182379,
  [SMALL_STATE(5388)] = 182396,
  [SMALL_STATE(5389)] = 182417,
  [SMALL_STATE(5390)] = 182440,
  [SMALL_STATE(5391)] = 182465,
  [SMALL_STATE(5392)] = 182482,
  [SMALL_STATE(5393)] = 182499,
  [SMALL_STATE(5394)] = 182520,
  [SMALL_STATE(5395)] = 182543,
  [SMALL_STATE(5396)] = 182566,
  [SMALL_STATE(5397)] = 182583,
  [SMALL_STATE(5398)] = 182606,
  [SMALL_STATE(5399)] = 182631,
  [SMALL_STATE(5400)] = 182652,
  [SMALL_STATE(5401)] = 182673,
  [SMALL_STATE(5402)] = 182692,
  [SMALL_STATE(5403)] = 182717,
  [SMALL_STATE(5404)] = 182734,
  [SMALL_STATE(5405)] = 182751,
  [SMALL_STATE(5406)] = 182768,
  [SMALL_STATE(5407)] = 182791,
  [SMALL_STATE(5408)] = 182812,
  [SMALL_STATE(5409)] = 182832,
  [SMALL_STATE(5410)] = 182852,
  [SMALL_STATE(5411)] = 182868,
  [SMALL_STATE(5412)] = 182888,
  [SMALL_STATE(5413)] = 182910,
  [SMALL_STATE(5414)] = 182930,
  [SMALL_STATE(5415)] = 182950,
  [SMALL_STATE(5416)] = 182970,
  [SMALL_STATE(5417)] = 182990,
  [SMALL_STATE(5418)] = 183012,
  [SMALL_STATE(5419)] = 183032,
  [SMALL_STATE(5420)] = 183052,
  [SMALL_STATE(5421)] = 183072,
  [SMALL_STATE(5422)] = 183094,
  [SMALL_STATE(5423)] = 183116,
  [SMALL_STATE(5424)] = 183138,
  [SMALL_STATE(5425)] = 183160,
  [SMALL_STATE(5426)] = 183180,
  [SMALL_STATE(5427)] = 183202,
  [SMALL_STATE(5428)] = 183220,
  [SMALL_STATE(5429)] = 183242,
  [SMALL_STATE(5430)] = 183262,
  [SMALL_STATE(5431)] = 183282,
  [SMALL_STATE(5432)] = 183302,
  [SMALL_STATE(5433)] = 183322,
  [SMALL_STATE(5434)] = 183344,
  [SMALL_STATE(5435)] = 183364,
  [SMALL_STATE(5436)] = 183384,
  [SMALL_STATE(5437)] = 183404,
  [SMALL_STATE(5438)] = 183426,
  [SMALL_STATE(5439)] = 183448,
  [SMALL_STATE(5440)] = 183468,
  [SMALL_STATE(5441)] = 183486,
  [SMALL_STATE(5442)] = 183508,
  [SMALL_STATE(5443)] = 183528,
  [SMALL_STATE(5444)] = 183548,
  [SMALL_STATE(5445)] = 183570,
  [SMALL_STATE(5446)] = 183592,
  [SMALL_STATE(5447)] = 183614,
  [SMALL_STATE(5448)] = 183632,
  [SMALL_STATE(5449)] = 183654,
  [SMALL_STATE(5450)] = 183676,
  [SMALL_STATE(5451)] = 183696,
  [SMALL_STATE(5452)] = 183718,
  [SMALL_STATE(5453)] = 183738,
  [SMALL_STATE(5454)] = 183760,
  [SMALL_STATE(5455)] = 183780,
  [SMALL_STATE(5456)] = 183800,
  [SMALL_STATE(5457)] = 183822,
  [SMALL_STATE(5458)] = 183842,
  [SMALL_STATE(5459)] = 183862,
  [SMALL_STATE(5460)] = 183882,
  [SMALL_STATE(5461)] = 183902,
  [SMALL_STATE(5462)] = 183922,
  [SMALL_STATE(5463)] = 183944,
  [SMALL_STATE(5464)] = 183966,
  [SMALL_STATE(5465)] = 183986,
  [SMALL_STATE(5466)] = 184006,
  [SMALL_STATE(5467)] = 184026,
  [SMALL_STATE(5468)] = 184048,
  [SMALL_STATE(5469)] = 184070,
  [SMALL_STATE(5470)] = 184086,
  [SMALL_STATE(5471)] = 184108,
  [SMALL_STATE(5472)] = 184130,
  [SMALL_STATE(5473)] = 184152,
  [SMALL_STATE(5474)] = 184172,
  [SMALL_STATE(5475)] = 184194,
  [SMALL_STATE(5476)] = 184214,
  [SMALL_STATE(5477)] = 184234,
  [SMALL_STATE(5478)] = 184256,
  [SMALL_STATE(5479)] = 184276,
  [SMALL_STATE(5480)] = 184296,
  [SMALL_STATE(5481)] = 184318,
  [SMALL_STATE(5482)] = 184338,
  [SMALL_STATE(5483)] = 184358,
  [SMALL_STATE(5484)] = 184378,
  [SMALL_STATE(5485)] = 184398,
  [SMALL_STATE(5486)] = 184418,
  [SMALL_STATE(5487)] = 184440,
  [SMALL_STATE(5488)] = 184462,
  [SMALL_STATE(5489)] = 184484,
  [SMALL_STATE(5490)] = 184506,
  [SMALL_STATE(5491)] = 184526,
  [SMALL_STATE(5492)] = 184546,
  [SMALL_STATE(5493)] = 184566,
  [SMALL_STATE(5494)] = 184586,
  [SMALL_STATE(5495)] = 184606,
  [SMALL_STATE(5496)] = 184626,
  [SMALL_STATE(5497)] = 184648,
  [SMALL_STATE(5498)] = 184670,
  [SMALL_STATE(5499)] = 184690,
  [SMALL_STATE(5500)] = 184710,
  [SMALL_STATE(5501)] = 184732,
  [SMALL_STATE(5502)] = 184750,
  [SMALL_STATE(5503)] = 184770,
  [SMALL_STATE(5504)] = 184790,
  [SMALL_STATE(5505)] = 184812,
  [SMALL_STATE(5506)] = 184832,
  [SMALL_STATE(5507)] = 184852,
  [SMALL_STATE(5508)] = 184872,
  [SMALL_STATE(5509)] = 184894,
  [SMALL_STATE(5510)] = 184914,
  [SMALL_STATE(5511)] = 184934,
  [SMALL_STATE(5512)] = 184954,
  [SMALL_STATE(5513)] = 184974,
  [SMALL_STATE(5514)] = 184994,
  [SMALL_STATE(5515)] = 185010,
  [SMALL_STATE(5516)] = 185032,
  [SMALL_STATE(5517)] = 185052,
  [SMALL_STATE(5518)] = 185072,
  [SMALL_STATE(5519)] = 185092,
  [SMALL_STATE(5520)] = 185112,
  [SMALL_STATE(5521)] = 185132,
  [SMALL_STATE(5522)] = 185152,
  [SMALL_STATE(5523)] = 185172,
  [SMALL_STATE(5524)] = 185192,
  [SMALL_STATE(5525)] = 185214,
  [SMALL_STATE(5526)] = 185236,
  [SMALL_STATE(5527)] = 185256,
  [SMALL_STATE(5528)] = 185276,
  [SMALL_STATE(5529)] = 185298,
  [SMALL_STATE(5530)] = 185318,
  [SMALL_STATE(5531)] = 185340,
  [SMALL_STATE(5532)] = 185360,
  [SMALL_STATE(5533)] = 185382,
  [SMALL_STATE(5534)] = 185402,
  [SMALL_STATE(5535)] = 185422,
  [SMALL_STATE(5536)] = 185442,
  [SMALL_STATE(5537)] = 185464,
  [SMALL_STATE(5538)] = 185484,
  [SMALL_STATE(5539)] = 185504,
  [SMALL_STATE(5540)] = 185524,
  [SMALL_STATE(5541)] = 185544,
  [SMALL_STATE(5542)] = 185564,
  [SMALL_STATE(5543)] = 185584,
  [SMALL_STATE(5544)] = 185604,
  [SMALL_STATE(5545)] = 185624,
  [SMALL_STATE(5546)] = 185644,
  [SMALL_STATE(5547)] = 185660,
  [SMALL_STATE(5548)] = 185680,
  [SMALL_STATE(5549)] = 185702,
  [SMALL_STATE(5550)] = 185722,
  [SMALL_STATE(5551)] = 185742,
  [SMALL_STATE(5552)] = 185758,
  [SMALL_STATE(5553)] = 185774,
  [SMALL_STATE(5554)] = 185794,
  [SMALL_STATE(5555)] = 185816,
  [SMALL_STATE(5556)] = 185836,
  [SMALL_STATE(5557)] = 185858,
  [SMALL_STATE(5558)] = 185880,
  [SMALL_STATE(5559)] = 185902,
  [SMALL_STATE(5560)] = 185922,
  [SMALL_STATE(5561)] = 185942,
  [SMALL_STATE(5562)] = 185964,
  [SMALL_STATE(5563)] = 185984,
  [SMALL_STATE(5564)] = 186006,
  [SMALL_STATE(5565)] = 186028,
  [SMALL_STATE(5566)] = 186048,
  [SMALL_STATE(5567)] = 186070,
  [SMALL_STATE(5568)] = 186090,
  [SMALL_STATE(5569)] = 186110,
  [SMALL_STATE(5570)] = 186130,
  [SMALL_STATE(5571)] = 186150,
  [SMALL_STATE(5572)] = 186170,
  [SMALL_STATE(5573)] = 186190,
  [SMALL_STATE(5574)] = 186210,
  [SMALL_STATE(5575)] = 186232,
  [SMALL_STATE(5576)] = 186252,
  [SMALL_STATE(5577)] = 186272,
  [SMALL_STATE(5578)] = 186292,
  [SMALL_STATE(5579)] = 186312,
  [SMALL_STATE(5580)] = 186332,
  [SMALL_STATE(5581)] = 186354,
  [SMALL_STATE(5582)] = 186374,
  [SMALL_STATE(5583)] = 186394,
  [SMALL_STATE(5584)] = 186414,
  [SMALL_STATE(5585)] = 186436,
  [SMALL_STATE(5586)] = 186458,
  [SMALL_STATE(5587)] = 186478,
  [SMALL_STATE(5588)] = 186498,
  [SMALL_STATE(5589)] = 186520,
  [SMALL_STATE(5590)] = 186542,
  [SMALL_STATE(5591)] = 186564,
  [SMALL_STATE(5592)] = 186584,
  [SMALL_STATE(5593)] = 186606,
  [SMALL_STATE(5594)] = 186626,
  [SMALL_STATE(5595)] = 186648,
  [SMALL_STATE(5596)] = 186666,
  [SMALL_STATE(5597)] = 186688,
  [SMALL_STATE(5598)] = 186706,
  [SMALL_STATE(5599)] = 186724,
  [SMALL_STATE(5600)] = 186746,
  [SMALL_STATE(5601)] = 186768,
  [SMALL_STATE(5602)] = 186788,
  [SMALL_STATE(5603)] = 186810,
  [SMALL_STATE(5604)] = 186832,
  [SMALL_STATE(5605)] = 186852,
  [SMALL_STATE(5606)] = 186874,
  [SMALL_STATE(5607)] = 186896,
  [SMALL_STATE(5608)] = 186918,
  [SMALL_STATE(5609)] = 186938,
  [SMALL_STATE(5610)] = 186956,
  [SMALL_STATE(5611)] = 186978,
  [SMALL_STATE(5612)] = 187000,
  [SMALL_STATE(5613)] = 187016,
  [SMALL_STATE(5614)] = 187032,
  [SMALL_STATE(5615)] = 187050,
  [SMALL_STATE(5616)] = 187072,
  [SMALL_STATE(5617)] = 187092,
  [SMALL_STATE(5618)] = 187112,
  [SMALL_STATE(5619)] = 187134,
  [SMALL_STATE(5620)] = 187154,
  [SMALL_STATE(5621)] = 187176,
  [SMALL_STATE(5622)] = 187198,
  [SMALL_STATE(5623)] = 187218,
  [SMALL_STATE(5624)] = 187234,
  [SMALL_STATE(5625)] = 187256,
  [SMALL_STATE(5626)] = 187274,
  [SMALL_STATE(5627)] = 187292,
  [SMALL_STATE(5628)] = 187312,
  [SMALL_STATE(5629)] = 187332,
  [SMALL_STATE(5630)] = 187352,
  [SMALL_STATE(5631)] = 187374,
  [SMALL_STATE(5632)] = 187394,
  [SMALL_STATE(5633)] = 187414,
  [SMALL_STATE(5634)] = 187434,
  [SMALL_STATE(5635)] = 187454,
  [SMALL_STATE(5636)] = 187474,
  [SMALL_STATE(5637)] = 187496,
  [SMALL_STATE(5638)] = 187518,
  [SMALL_STATE(5639)] = 187540,
  [SMALL_STATE(5640)] = 187560,
  [SMALL_STATE(5641)] = 187580,
  [SMALL_STATE(5642)] = 187597,
  [SMALL_STATE(5643)] = 187616,
  [SMALL_STATE(5644)] = 187635,
  [SMALL_STATE(5645)] = 187650,
  [SMALL_STATE(5646)] = 187665,
  [SMALL_STATE(5647)] = 187680,
  [SMALL_STATE(5648)] = 187695,
  [SMALL_STATE(5649)] = 187714,
  [SMALL_STATE(5650)] = 187729,
  [SMALL_STATE(5651)] = 187744,
  [SMALL_STATE(5652)] = 187763,
  [SMALL_STATE(5653)] = 187782,
  [SMALL_STATE(5654)] = 187797,
  [SMALL_STATE(5655)] = 187816,
  [SMALL_STATE(5656)] = 187831,
  [SMALL_STATE(5657)] = 187846,
  [SMALL_STATE(5658)] = 187861,
  [SMALL_STATE(5659)] = 187876,
  [SMALL_STATE(5660)] = 187891,
  [SMALL_STATE(5661)] = 187910,
  [SMALL_STATE(5662)] = 187925,
  [SMALL_STATE(5663)] = 187940,
  [SMALL_STATE(5664)] = 187959,
  [SMALL_STATE(5665)] = 187974,
  [SMALL_STATE(5666)] = 187989,
  [SMALL_STATE(5667)] = 188008,
  [SMALL_STATE(5668)] = 188027,
  [SMALL_STATE(5669)] = 188046,
  [SMALL_STATE(5670)] = 188065,
  [SMALL_STATE(5671)] = 188084,
  [SMALL_STATE(5672)] = 188099,
  [SMALL_STATE(5673)] = 188114,
  [SMALL_STATE(5674)] = 188129,
  [SMALL_STATE(5675)] = 188144,
  [SMALL_STATE(5676)] = 188159,
  [SMALL_STATE(5677)] = 188174,
  [SMALL_STATE(5678)] = 188191,
  [SMALL_STATE(5679)] = 188210,
  [SMALL_STATE(5680)] = 188225,
  [SMALL_STATE(5681)] = 188244,
  [SMALL_STATE(5682)] = 188259,
  [SMALL_STATE(5683)] = 188274,
  [SMALL_STATE(5684)] = 188289,
  [SMALL_STATE(5685)] = 188304,
  [SMALL_STATE(5686)] = 188319,
  [SMALL_STATE(5687)] = 188334,
  [SMALL_STATE(5688)] = 188349,
  [SMALL_STATE(5689)] = 188364,
  [SMALL_STATE(5690)] = 188379,
  [SMALL_STATE(5691)] = 188394,
  [SMALL_STATE(5692)] = 188409,
  [SMALL_STATE(5693)] = 188428,
  [SMALL_STATE(5694)] = 188445,
  [SMALL_STATE(5695)] = 188464,
  [SMALL_STATE(5696)] = 188481,
  [SMALL_STATE(5697)] = 188498,
  [SMALL_STATE(5698)] = 188513,
  [SMALL_STATE(5699)] = 188528,
  [SMALL_STATE(5700)] = 188543,
  [SMALL_STATE(5701)] = 188558,
  [SMALL_STATE(5702)] = 188573,
  [SMALL_STATE(5703)] = 188588,
  [SMALL_STATE(5704)] = 188603,
  [SMALL_STATE(5705)] = 188618,
  [SMALL_STATE(5706)] = 188633,
  [SMALL_STATE(5707)] = 188652,
  [SMALL_STATE(5708)] = 188667,
  [SMALL_STATE(5709)] = 188682,
  [SMALL_STATE(5710)] = 188697,
  [SMALL_STATE(5711)] = 188716,
  [SMALL_STATE(5712)] = 188731,
  [SMALL_STATE(5713)] = 188746,
  [SMALL_STATE(5714)] = 188761,
  [SMALL_STATE(5715)] = 188778,
  [SMALL_STATE(5716)] = 188795,
  [SMALL_STATE(5717)] = 188814,
  [SMALL_STATE(5718)] = 188829,
  [SMALL_STATE(5719)] = 188844,
  [SMALL_STATE(5720)] = 188859,
  [SMALL_STATE(5721)] = 188878,
  [SMALL_STATE(5722)] = 188893,
  [SMALL_STATE(5723)] = 188912,
  [SMALL_STATE(5724)] = 188931,
  [SMALL_STATE(5725)] = 188950,
  [SMALL_STATE(5726)] = 188965,
  [SMALL_STATE(5727)] = 188984,
  [SMALL_STATE(5728)] = 189003,
  [SMALL_STATE(5729)] = 189018,
  [SMALL_STATE(5730)] = 189033,
  [SMALL_STATE(5731)] = 189052,
  [SMALL_STATE(5732)] = 189067,
  [SMALL_STATE(5733)] = 189086,
  [SMALL_STATE(5734)] = 189101,
  [SMALL_STATE(5735)] = 189116,
  [SMALL_STATE(5736)] = 189131,
  [SMALL_STATE(5737)] = 189146,
  [SMALL_STATE(5738)] = 189165,
  [SMALL_STATE(5739)] = 189180,
  [SMALL_STATE(5740)] = 189199,
  [SMALL_STATE(5741)] = 189218,
  [SMALL_STATE(5742)] = 189233,
  [SMALL_STATE(5743)] = 189248,
  [SMALL_STATE(5744)] = 189267,
  [SMALL_STATE(5745)] = 189282,
  [SMALL_STATE(5746)] = 189297,
  [SMALL_STATE(5747)] = 189312,
  [SMALL_STATE(5748)] = 189327,
  [SMALL_STATE(5749)] = 189344,
  [SMALL_STATE(5750)] = 189359,
  [SMALL_STATE(5751)] = 189374,
  [SMALL_STATE(5752)] = 189389,
  [SMALL_STATE(5753)] = 189404,
  [SMALL_STATE(5754)] = 189423,
  [SMALL_STATE(5755)] = 189438,
  [SMALL_STATE(5756)] = 189457,
  [SMALL_STATE(5757)] = 189472,
  [SMALL_STATE(5758)] = 189491,
  [SMALL_STATE(5759)] = 189506,
  [SMALL_STATE(5760)] = 189525,
  [SMALL_STATE(5761)] = 189540,
  [SMALL_STATE(5762)] = 189559,
  [SMALL_STATE(5763)] = 189574,
  [SMALL_STATE(5764)] = 189593,
  [SMALL_STATE(5765)] = 189608,
  [SMALL_STATE(5766)] = 189623,
  [SMALL_STATE(5767)] = 189638,
  [SMALL_STATE(5768)] = 189653,
  [SMALL_STATE(5769)] = 189672,
  [SMALL_STATE(5770)] = 189687,
  [SMALL_STATE(5771)] = 189706,
  [SMALL_STATE(5772)] = 189721,
  [SMALL_STATE(5773)] = 189736,
  [SMALL_STATE(5774)] = 189755,
  [SMALL_STATE(5775)] = 189774,
  [SMALL_STATE(5776)] = 189789,
  [SMALL_STATE(5777)] = 189808,
  [SMALL_STATE(5778)] = 189827,
  [SMALL_STATE(5779)] = 189844,
  [SMALL_STATE(5780)] = 189859,
  [SMALL_STATE(5781)] = 189874,
  [SMALL_STATE(5782)] = 189891,
  [SMALL_STATE(5783)] = 189906,
  [SMALL_STATE(5784)] = 189925,
  [SMALL_STATE(5785)] = 189940,
  [SMALL_STATE(5786)] = 189959,
  [SMALL_STATE(5787)] = 189974,
  [SMALL_STATE(5788)] = 189989,
  [SMALL_STATE(5789)] = 190004,
  [SMALL_STATE(5790)] = 190019,
  [SMALL_STATE(5791)] = 190034,
  [SMALL_STATE(5792)] = 190049,
  [SMALL_STATE(5793)] = 190068,
  [SMALL_STATE(5794)] = 190083,
  [SMALL_STATE(5795)] = 190102,
  [SMALL_STATE(5796)] = 190117,
  [SMALL_STATE(5797)] = 190132,
  [SMALL_STATE(5798)] = 190147,
  [SMALL_STATE(5799)] = 190162,
  [SMALL_STATE(5800)] = 190177,
  [SMALL_STATE(5801)] = 190192,
  [SMALL_STATE(5802)] = 190207,
  [SMALL_STATE(5803)] = 190224,
  [SMALL_STATE(5804)] = 190239,
  [SMALL_STATE(5805)] = 190258,
  [SMALL_STATE(5806)] = 190273,
  [SMALL_STATE(5807)] = 190288,
  [SMALL_STATE(5808)] = 190303,
  [SMALL_STATE(5809)] = 190318,
  [SMALL_STATE(5810)] = 190333,
  [SMALL_STATE(5811)] = 190350,
  [SMALL_STATE(5812)] = 190369,
  [SMALL_STATE(5813)] = 190384,
  [SMALL_STATE(5814)] = 190399,
  [SMALL_STATE(5815)] = 190414,
  [SMALL_STATE(5816)] = 190429,
  [SMALL_STATE(5817)] = 190448,
  [SMALL_STATE(5818)] = 190463,
  [SMALL_STATE(5819)] = 190482,
  [SMALL_STATE(5820)] = 190499,
  [SMALL_STATE(5821)] = 190514,
  [SMALL_STATE(5822)] = 190529,
  [SMALL_STATE(5823)] = 190548,
  [SMALL_STATE(5824)] = 190563,
  [SMALL_STATE(5825)] = 190580,
  [SMALL_STATE(5826)] = 190595,
  [SMALL_STATE(5827)] = 190610,
  [SMALL_STATE(5828)] = 190625,
  [SMALL_STATE(5829)] = 190640,
  [SMALL_STATE(5830)] = 190659,
  [SMALL_STATE(5831)] = 190674,
  [SMALL_STATE(5832)] = 190689,
  [SMALL_STATE(5833)] = 190706,
  [SMALL_STATE(5834)] = 190721,
  [SMALL_STATE(5835)] = 190736,
  [SMALL_STATE(5836)] = 190751,
  [SMALL_STATE(5837)] = 190770,
  [SMALL_STATE(5838)] = 190785,
  [SMALL_STATE(5839)] = 190800,
  [SMALL_STATE(5840)] = 190817,
  [SMALL_STATE(5841)] = 190836,
  [SMALL_STATE(5842)] = 190855,
  [SMALL_STATE(5843)] = 190872,
  [SMALL_STATE(5844)] = 190887,
  [SMALL_STATE(5845)] = 190902,
  [SMALL_STATE(5846)] = 190919,
  [SMALL_STATE(5847)] = 190936,
  [SMALL_STATE(5848)] = 190955,
  [SMALL_STATE(5849)] = 190974,
  [SMALL_STATE(5850)] = 190989,
  [SMALL_STATE(5851)] = 191004,
  [SMALL_STATE(5852)] = 191019,
  [SMALL_STATE(5853)] = 191034,
  [SMALL_STATE(5854)] = 191049,
  [SMALL_STATE(5855)] = 191066,
  [SMALL_STATE(5856)] = 191081,
  [SMALL_STATE(5857)] = 191096,
  [SMALL_STATE(5858)] = 191113,
  [SMALL_STATE(5859)] = 191130,
  [SMALL_STATE(5860)] = 191149,
  [SMALL_STATE(5861)] = 191164,
  [SMALL_STATE(5862)] = 191179,
  [SMALL_STATE(5863)] = 191198,
  [SMALL_STATE(5864)] = 191215,
  [SMALL_STATE(5865)] = 191230,
  [SMALL_STATE(5866)] = 191245,
  [SMALL_STATE(5867)] = 191262,
  [SMALL_STATE(5868)] = 191279,
  [SMALL_STATE(5869)] = 191298,
  [SMALL_STATE(5870)] = 191317,
  [SMALL_STATE(5871)] = 191334,
  [SMALL_STATE(5872)] = 191351,
  [SMALL_STATE(5873)] = 191366,
  [SMALL_STATE(5874)] = 191383,
  [SMALL_STATE(5875)] = 191402,
  [SMALL_STATE(5876)] = 191419,
  [SMALL_STATE(5877)] = 191436,
  [SMALL_STATE(5878)] = 191451,
  [SMALL_STATE(5879)] = 191466,
  [SMALL_STATE(5880)] = 191481,
  [SMALL_STATE(5881)] = 191496,
  [SMALL_STATE(5882)] = 191511,
  [SMALL_STATE(5883)] = 191526,
  [SMALL_STATE(5884)] = 191541,
  [SMALL_STATE(5885)] = 191560,
  [SMALL_STATE(5886)] = 191579,
  [SMALL_STATE(5887)] = 191594,
  [SMALL_STATE(5888)] = 191609,
  [SMALL_STATE(5889)] = 191624,
  [SMALL_STATE(5890)] = 191639,
  [SMALL_STATE(5891)] = 191658,
  [SMALL_STATE(5892)] = 191673,
  [SMALL_STATE(5893)] = 191688,
  [SMALL_STATE(5894)] = 191707,
  [SMALL_STATE(5895)] = 191722,
  [SMALL_STATE(5896)] = 191739,
  [SMALL_STATE(5897)] = 191754,
  [SMALL_STATE(5898)] = 191771,
  [SMALL_STATE(5899)] = 191790,
  [SMALL_STATE(5900)] = 191809,
  [SMALL_STATE(5901)] = 191824,
  [SMALL_STATE(5902)] = 191841,
  [SMALL_STATE(5903)] = 191856,
  [SMALL_STATE(5904)] = 191871,
  [SMALL_STATE(5905)] = 191886,
  [SMALL_STATE(5906)] = 191901,
  [SMALL_STATE(5907)] = 191916,
  [SMALL_STATE(5908)] = 191933,
  [SMALL_STATE(5909)] = 191948,
  [SMALL_STATE(5910)] = 191963,
  [SMALL_STATE(5911)] = 191978,
  [SMALL_STATE(5912)] = 191993,
  [SMALL_STATE(5913)] = 192008,
  [SMALL_STATE(5914)] = 192027,
  [SMALL_STATE(5915)] = 192042,
  [SMALL_STATE(5916)] = 192057,
  [SMALL_STATE(5917)] = 192072,
  [SMALL_STATE(5918)] = 192087,
  [SMALL_STATE(5919)] = 192106,
  [SMALL_STATE(5920)] = 192125,
  [SMALL_STATE(5921)] = 192140,
  [SMALL_STATE(5922)] = 192157,
  [SMALL_STATE(5923)] = 192176,
  [SMALL_STATE(5924)] = 192195,
  [SMALL_STATE(5925)] = 192210,
  [SMALL_STATE(5926)] = 192229,
  [SMALL_STATE(5927)] = 192244,
  [SMALL_STATE(5928)] = 192259,
  [SMALL_STATE(5929)] = 192274,
  [SMALL_STATE(5930)] = 192293,
  [SMALL_STATE(5931)] = 192308,
  [SMALL_STATE(5932)] = 192327,
  [SMALL_STATE(5933)] = 192342,
  [SMALL_STATE(5934)] = 192357,
  [SMALL_STATE(5935)] = 192372,
  [SMALL_STATE(5936)] = 192391,
  [SMALL_STATE(5937)] = 192408,
  [SMALL_STATE(5938)] = 192423,
  [SMALL_STATE(5939)] = 192440,
  [SMALL_STATE(5940)] = 192455,
  [SMALL_STATE(5941)] = 192470,
  [SMALL_STATE(5942)] = 192485,
  [SMALL_STATE(5943)] = 192500,
  [SMALL_STATE(5944)] = 192515,
  [SMALL_STATE(5945)] = 192530,
  [SMALL_STATE(5946)] = 192545,
  [SMALL_STATE(5947)] = 192560,
  [SMALL_STATE(5948)] = 192577,
  [SMALL_STATE(5949)] = 192592,
  [SMALL_STATE(5950)] = 192607,
  [SMALL_STATE(5951)] = 192622,
  [SMALL_STATE(5952)] = 192637,
  [SMALL_STATE(5953)] = 192652,
  [SMALL_STATE(5954)] = 192671,
  [SMALL_STATE(5955)] = 192686,
  [SMALL_STATE(5956)] = 192701,
  [SMALL_STATE(5957)] = 192720,
  [SMALL_STATE(5958)] = 192735,
  [SMALL_STATE(5959)] = 192750,
  [SMALL_STATE(5960)] = 192769,
  [SMALL_STATE(5961)] = 192788,
  [SMALL_STATE(5962)] = 192807,
  [SMALL_STATE(5963)] = 192822,
  [SMALL_STATE(5964)] = 192837,
  [SMALL_STATE(5965)] = 192852,
  [SMALL_STATE(5966)] = 192867,
  [SMALL_STATE(5967)] = 192882,
  [SMALL_STATE(5968)] = 192897,
  [SMALL_STATE(5969)] = 192914,
  [SMALL_STATE(5970)] = 192931,
  [SMALL_STATE(5971)] = 192950,
  [SMALL_STATE(5972)] = 192969,
  [SMALL_STATE(5973)] = 192988,
  [SMALL_STATE(5974)] = 193003,
  [SMALL_STATE(5975)] = 193020,
  [SMALL_STATE(5976)] = 193035,
  [SMALL_STATE(5977)] = 193050,
  [SMALL_STATE(5978)] = 193065,
  [SMALL_STATE(5979)] = 193080,
  [SMALL_STATE(5980)] = 193095,
  [SMALL_STATE(5981)] = 193110,
  [SMALL_STATE(5982)] = 193125,
  [SMALL_STATE(5983)] = 193140,
  [SMALL_STATE(5984)] = 193155,
  [SMALL_STATE(5985)] = 193170,
  [SMALL_STATE(5986)] = 193189,
  [SMALL_STATE(5987)] = 193206,
  [SMALL_STATE(5988)] = 193223,
  [SMALL_STATE(5989)] = 193238,
  [SMALL_STATE(5990)] = 193253,
  [SMALL_STATE(5991)] = 193268,
  [SMALL_STATE(5992)] = 193283,
  [SMALL_STATE(5993)] = 193298,
  [SMALL_STATE(5994)] = 193313,
  [SMALL_STATE(5995)] = 193328,
  [SMALL_STATE(5996)] = 193343,
  [SMALL_STATE(5997)] = 193362,
  [SMALL_STATE(5998)] = 193377,
  [SMALL_STATE(5999)] = 193392,
  [SMALL_STATE(6000)] = 193407,
  [SMALL_STATE(6001)] = 193426,
  [SMALL_STATE(6002)] = 193441,
  [SMALL_STATE(6003)] = 193456,
  [SMALL_STATE(6004)] = 193471,
  [SMALL_STATE(6005)] = 193486,
  [SMALL_STATE(6006)] = 193501,
  [SMALL_STATE(6007)] = 193520,
  [SMALL_STATE(6008)] = 193535,
  [SMALL_STATE(6009)] = 193550,
  [SMALL_STATE(6010)] = 193565,
  [SMALL_STATE(6011)] = 193584,
  [SMALL_STATE(6012)] = 193599,
  [SMALL_STATE(6013)] = 193618,
  [SMALL_STATE(6014)] = 193637,
  [SMALL_STATE(6015)] = 193652,
  [SMALL_STATE(6016)] = 193671,
  [SMALL_STATE(6017)] = 193686,
  [SMALL_STATE(6018)] = 193705,
  [SMALL_STATE(6019)] = 193720,
  [SMALL_STATE(6020)] = 193739,
  [SMALL_STATE(6021)] = 193754,
  [SMALL_STATE(6022)] = 193769,
  [SMALL_STATE(6023)] = 193788,
  [SMALL_STATE(6024)] = 193803,
  [SMALL_STATE(6025)] = 193822,
  [SMALL_STATE(6026)] = 193837,
  [SMALL_STATE(6027)] = 193852,
  [SMALL_STATE(6028)] = 193867,
  [SMALL_STATE(6029)] = 193882,
  [SMALL_STATE(6030)] = 193897,
  [SMALL_STATE(6031)] = 193914,
  [SMALL_STATE(6032)] = 193929,
  [SMALL_STATE(6033)] = 193944,
  [SMALL_STATE(6034)] = 193961,
  [SMALL_STATE(6035)] = 193976,
  [SMALL_STATE(6036)] = 193993,
  [SMALL_STATE(6037)] = 194008,
  [SMALL_STATE(6038)] = 194023,
  [SMALL_STATE(6039)] = 194038,
  [SMALL_STATE(6040)] = 194053,
  [SMALL_STATE(6041)] = 194070,
  [SMALL_STATE(6042)] = 194087,
  [SMALL_STATE(6043)] = 194102,
  [SMALL_STATE(6044)] = 194117,
  [SMALL_STATE(6045)] = 194136,
  [SMALL_STATE(6046)] = 194155,
  [SMALL_STATE(6047)] = 194170,
  [SMALL_STATE(6048)] = 194185,
  [SMALL_STATE(6049)] = 194200,
  [SMALL_STATE(6050)] = 194215,
  [SMALL_STATE(6051)] = 194234,
  [SMALL_STATE(6052)] = 194253,
  [SMALL_STATE(6053)] = 194268,
  [SMALL_STATE(6054)] = 194287,
  [SMALL_STATE(6055)] = 194302,
  [SMALL_STATE(6056)] = 194317,
  [SMALL_STATE(6057)] = 194332,
  [SMALL_STATE(6058)] = 194347,
  [SMALL_STATE(6059)] = 194366,
  [SMALL_STATE(6060)] = 194381,
  [SMALL_STATE(6061)] = 194400,
  [SMALL_STATE(6062)] = 194419,
  [SMALL_STATE(6063)] = 194434,
  [SMALL_STATE(6064)] = 194449,
  [SMALL_STATE(6065)] = 194464,
  [SMALL_STATE(6066)] = 194479,
  [SMALL_STATE(6067)] = 194494,
  [SMALL_STATE(6068)] = 194509,
  [SMALL_STATE(6069)] = 194524,
  [SMALL_STATE(6070)] = 194541,
  [SMALL_STATE(6071)] = 194556,
  [SMALL_STATE(6072)] = 194575,
  [SMALL_STATE(6073)] = 194590,
  [SMALL_STATE(6074)] = 194605,
  [SMALL_STATE(6075)] = 194622,
  [SMALL_STATE(6076)] = 194637,
  [SMALL_STATE(6077)] = 194652,
  [SMALL_STATE(6078)] = 194667,
  [SMALL_STATE(6079)] = 194682,
  [SMALL_STATE(6080)] = 194699,
  [SMALL_STATE(6081)] = 194714,
  [SMALL_STATE(6082)] = 194731,
  [SMALL_STATE(6083)] = 194746,
  [SMALL_STATE(6084)] = 194761,
  [SMALL_STATE(6085)] = 194780,
  [SMALL_STATE(6086)] = 194795,
  [SMALL_STATE(6087)] = 194810,
  [SMALL_STATE(6088)] = 194825,
  [SMALL_STATE(6089)] = 194840,
  [SMALL_STATE(6090)] = 194855,
  [SMALL_STATE(6091)] = 194870,
  [SMALL_STATE(6092)] = 194885,
  [SMALL_STATE(6093)] = 194900,
  [SMALL_STATE(6094)] = 194915,
  [SMALL_STATE(6095)] = 194930,
  [SMALL_STATE(6096)] = 194945,
  [SMALL_STATE(6097)] = 194962,
  [SMALL_STATE(6098)] = 194977,
  [SMALL_STATE(6099)] = 194994,
  [SMALL_STATE(6100)] = 195009,
  [SMALL_STATE(6101)] = 195028,
  [SMALL_STATE(6102)] = 195047,
  [SMALL_STATE(6103)] = 195062,
  [SMALL_STATE(6104)] = 195077,
  [SMALL_STATE(6105)] = 195092,
  [SMALL_STATE(6106)] = 195111,
  [SMALL_STATE(6107)] = 195126,
  [SMALL_STATE(6108)] = 195141,
  [SMALL_STATE(6109)] = 195156,
  [SMALL_STATE(6110)] = 195175,
  [SMALL_STATE(6111)] = 195194,
  [SMALL_STATE(6112)] = 195213,
  [SMALL_STATE(6113)] = 195230,
  [SMALL_STATE(6114)] = 195249,
  [SMALL_STATE(6115)] = 195264,
  [SMALL_STATE(6116)] = 195283,
  [SMALL_STATE(6117)] = 195302,
  [SMALL_STATE(6118)] = 195321,
  [SMALL_STATE(6119)] = 195338,
  [SMALL_STATE(6120)] = 195357,
  [SMALL_STATE(6121)] = 195376,
  [SMALL_STATE(6122)] = 195395,
  [SMALL_STATE(6123)] = 195410,
  [SMALL_STATE(6124)] = 195425,
  [SMALL_STATE(6125)] = 195440,
  [SMALL_STATE(6126)] = 195455,
  [SMALL_STATE(6127)] = 195470,
  [SMALL_STATE(6128)] = 195485,
  [SMALL_STATE(6129)] = 195504,
  [SMALL_STATE(6130)] = 195519,
  [SMALL_STATE(6131)] = 195534,
  [SMALL_STATE(6132)] = 195549,
  [SMALL_STATE(6133)] = 195564,
  [SMALL_STATE(6134)] = 195583,
  [SMALL_STATE(6135)] = 195598,
  [SMALL_STATE(6136)] = 195613,
  [SMALL_STATE(6137)] = 195628,
  [SMALL_STATE(6138)] = 195643,
  [SMALL_STATE(6139)] = 195658,
  [SMALL_STATE(6140)] = 195673,
  [SMALL_STATE(6141)] = 195688,
  [SMALL_STATE(6142)] = 195705,
  [SMALL_STATE(6143)] = 195722,
  [SMALL_STATE(6144)] = 195741,
  [SMALL_STATE(6145)] = 195760,
  [SMALL_STATE(6146)] = 195779,
  [SMALL_STATE(6147)] = 195798,
  [SMALL_STATE(6148)] = 195817,
  [SMALL_STATE(6149)] = 195832,
  [SMALL_STATE(6150)] = 195847,
  [SMALL_STATE(6151)] = 195862,
  [SMALL_STATE(6152)] = 195881,
  [SMALL_STATE(6153)] = 195896,
  [SMALL_STATE(6154)] = 195915,
  [SMALL_STATE(6155)] = 195934,
  [SMALL_STATE(6156)] = 195953,
  [SMALL_STATE(6157)] = 195972,
  [SMALL_STATE(6158)] = 195989,
  [SMALL_STATE(6159)] = 196008,
  [SMALL_STATE(6160)] = 196025,
  [SMALL_STATE(6161)] = 196044,
  [SMALL_STATE(6162)] = 196063,
  [SMALL_STATE(6163)] = 196082,
  [SMALL_STATE(6164)] = 196101,
  [SMALL_STATE(6165)] = 196116,
  [SMALL_STATE(6166)] = 196135,
  [SMALL_STATE(6167)] = 196154,
  [SMALL_STATE(6168)] = 196171,
  [SMALL_STATE(6169)] = 196186,
  [SMALL_STATE(6170)] = 196201,
  [SMALL_STATE(6171)] = 196216,
  [SMALL_STATE(6172)] = 196235,
  [SMALL_STATE(6173)] = 196250,
  [SMALL_STATE(6174)] = 196269,
  [SMALL_STATE(6175)] = 196284,
  [SMALL_STATE(6176)] = 196303,
  [SMALL_STATE(6177)] = 196318,
  [SMALL_STATE(6178)] = 196335,
  [SMALL_STATE(6179)] = 196354,
  [SMALL_STATE(6180)] = 196369,
  [SMALL_STATE(6181)] = 196384,
  [SMALL_STATE(6182)] = 196399,
  [SMALL_STATE(6183)] = 196414,
  [SMALL_STATE(6184)] = 196429,
  [SMALL_STATE(6185)] = 196448,
  [SMALL_STATE(6186)] = 196463,
  [SMALL_STATE(6187)] = 196478,
  [SMALL_STATE(6188)] = 196493,
  [SMALL_STATE(6189)] = 196512,
  [SMALL_STATE(6190)] = 196531,
  [SMALL_STATE(6191)] = 196546,
  [SMALL_STATE(6192)] = 196561,
  [SMALL_STATE(6193)] = 196580,
  [SMALL_STATE(6194)] = 196599,
  [SMALL_STATE(6195)] = 196618,
  [SMALL_STATE(6196)] = 196637,
  [SMALL_STATE(6197)] = 196656,
  [SMALL_STATE(6198)] = 196675,
  [SMALL_STATE(6199)] = 196694,
  [SMALL_STATE(6200)] = 196713,
  [SMALL_STATE(6201)] = 196728,
  [SMALL_STATE(6202)] = 196747,
  [SMALL_STATE(6203)] = 196762,
  [SMALL_STATE(6204)] = 196777,
  [SMALL_STATE(6205)] = 196796,
  [SMALL_STATE(6206)] = 196815,
  [SMALL_STATE(6207)] = 196834,
  [SMALL_STATE(6208)] = 196853,
  [SMALL_STATE(6209)] = 196872,
  [SMALL_STATE(6210)] = 196891,
  [SMALL_STATE(6211)] = 196906,
  [SMALL_STATE(6212)] = 196921,
  [SMALL_STATE(6213)] = 196936,
  [SMALL_STATE(6214)] = 196955,
  [SMALL_STATE(6215)] = 196974,
  [SMALL_STATE(6216)] = 196989,
  [SMALL_STATE(6217)] = 197004,
  [SMALL_STATE(6218)] = 197019,
  [SMALL_STATE(6219)] = 197038,
  [SMALL_STATE(6220)] = 197055,
  [SMALL_STATE(6221)] = 197070,
  [SMALL_STATE(6222)] = 197087,
  [SMALL_STATE(6223)] = 197104,
  [SMALL_STATE(6224)] = 197121,
  [SMALL_STATE(6225)] = 197136,
  [SMALL_STATE(6226)] = 197151,
  [SMALL_STATE(6227)] = 197166,
  [SMALL_STATE(6228)] = 197185,
  [SMALL_STATE(6229)] = 197200,
  [SMALL_STATE(6230)] = 197219,
  [SMALL_STATE(6231)] = 197238,
  [SMALL_STATE(6232)] = 197253,
  [SMALL_STATE(6233)] = 197272,
  [SMALL_STATE(6234)] = 197291,
  [SMALL_STATE(6235)] = 197306,
  [SMALL_STATE(6236)] = 197323,
  [SMALL_STATE(6237)] = 197340,
  [SMALL_STATE(6238)] = 197357,
  [SMALL_STATE(6239)] = 197372,
  [SMALL_STATE(6240)] = 197391,
  [SMALL_STATE(6241)] = 197410,
  [SMALL_STATE(6242)] = 197425,
  [SMALL_STATE(6243)] = 197444,
  [SMALL_STATE(6244)] = 197459,
  [SMALL_STATE(6245)] = 197478,
  [SMALL_STATE(6246)] = 197497,
  [SMALL_STATE(6247)] = 197516,
  [SMALL_STATE(6248)] = 197535,
  [SMALL_STATE(6249)] = 197554,
  [SMALL_STATE(6250)] = 197573,
  [SMALL_STATE(6251)] = 197588,
  [SMALL_STATE(6252)] = 197603,
  [SMALL_STATE(6253)] = 197618,
  [SMALL_STATE(6254)] = 197637,
  [SMALL_STATE(6255)] = 197654,
  [SMALL_STATE(6256)] = 197673,
  [SMALL_STATE(6257)] = 197688,
  [SMALL_STATE(6258)] = 197707,
  [SMALL_STATE(6259)] = 197722,
  [SMALL_STATE(6260)] = 197741,
  [SMALL_STATE(6261)] = 197760,
  [SMALL_STATE(6262)] = 197779,
  [SMALL_STATE(6263)] = 197798,
  [SMALL_STATE(6264)] = 197817,
  [SMALL_STATE(6265)] = 197836,
  [SMALL_STATE(6266)] = 197851,
  [SMALL_STATE(6267)] = 197870,
  [SMALL_STATE(6268)] = 197889,
  [SMALL_STATE(6269)] = 197904,
  [SMALL_STATE(6270)] = 197919,
  [SMALL_STATE(6271)] = 197934,
  [SMALL_STATE(6272)] = 197949,
  [SMALL_STATE(6273)] = 197964,
  [SMALL_STATE(6274)] = 197983,
  [SMALL_STATE(6275)] = 198002,
  [SMALL_STATE(6276)] = 198017,
  [SMALL_STATE(6277)] = 198036,
  [SMALL_STATE(6278)] = 198055,
  [SMALL_STATE(6279)] = 198074,
  [SMALL_STATE(6280)] = 198089,
  [SMALL_STATE(6281)] = 198108,
  [SMALL_STATE(6282)] = 198123,
  [SMALL_STATE(6283)] = 198142,
  [SMALL_STATE(6284)] = 198157,
  [SMALL_STATE(6285)] = 198172,
  [SMALL_STATE(6286)] = 198189,
  [SMALL_STATE(6287)] = 198206,
  [SMALL_STATE(6288)] = 198225,
  [SMALL_STATE(6289)] = 198240,
  [SMALL_STATE(6290)] = 198259,
  [SMALL_STATE(6291)] = 198274,
  [SMALL_STATE(6292)] = 198293,
  [SMALL_STATE(6293)] = 198308,
  [SMALL_STATE(6294)] = 198327,
  [SMALL_STATE(6295)] = 198342,
  [SMALL_STATE(6296)] = 198361,
  [SMALL_STATE(6297)] = 198376,
  [SMALL_STATE(6298)] = 198391,
  [SMALL_STATE(6299)] = 198406,
  [SMALL_STATE(6300)] = 198425,
  [SMALL_STATE(6301)] = 198444,
  [SMALL_STATE(6302)] = 198463,
  [SMALL_STATE(6303)] = 198482,
  [SMALL_STATE(6304)] = 198497,
  [SMALL_STATE(6305)] = 198516,
  [SMALL_STATE(6306)] = 198533,
  [SMALL_STATE(6307)] = 198548,
  [SMALL_STATE(6308)] = 198563,
  [SMALL_STATE(6309)] = 198580,
  [SMALL_STATE(6310)] = 198599,
  [SMALL_STATE(6311)] = 198618,
  [SMALL_STATE(6312)] = 198637,
  [SMALL_STATE(6313)] = 198652,
  [SMALL_STATE(6314)] = 198667,
  [SMALL_STATE(6315)] = 198682,
  [SMALL_STATE(6316)] = 198701,
  [SMALL_STATE(6317)] = 198716,
  [SMALL_STATE(6318)] = 198731,
  [SMALL_STATE(6319)] = 198746,
  [SMALL_STATE(6320)] = 198761,
  [SMALL_STATE(6321)] = 198776,
  [SMALL_STATE(6322)] = 198791,
  [SMALL_STATE(6323)] = 198810,
  [SMALL_STATE(6324)] = 198829,
  [SMALL_STATE(6325)] = 198848,
  [SMALL_STATE(6326)] = 198863,
  [SMALL_STATE(6327)] = 198882,
  [SMALL_STATE(6328)] = 198897,
  [SMALL_STATE(6329)] = 198912,
  [SMALL_STATE(6330)] = 198927,
  [SMALL_STATE(6331)] = 198942,
  [SMALL_STATE(6332)] = 198957,
  [SMALL_STATE(6333)] = 198976,
  [SMALL_STATE(6334)] = 198991,
  [SMALL_STATE(6335)] = 199007,
  [SMALL_STATE(6336)] = 199021,
  [SMALL_STATE(6337)] = 199037,
  [SMALL_STATE(6338)] = 199053,
  [SMALL_STATE(6339)] = 199069,
  [SMALL_STATE(6340)] = 199083,
  [SMALL_STATE(6341)] = 199099,
  [SMALL_STATE(6342)] = 199115,
  [SMALL_STATE(6343)] = 199131,
  [SMALL_STATE(6344)] = 199147,
  [SMALL_STATE(6345)] = 199163,
  [SMALL_STATE(6346)] = 199179,
  [SMALL_STATE(6347)] = 199195,
  [SMALL_STATE(6348)] = 199211,
  [SMALL_STATE(6349)] = 199227,
  [SMALL_STATE(6350)] = 199243,
  [SMALL_STATE(6351)] = 199259,
  [SMALL_STATE(6352)] = 199275,
  [SMALL_STATE(6353)] = 199291,
  [SMALL_STATE(6354)] = 199305,
  [SMALL_STATE(6355)] = 199319,
  [SMALL_STATE(6356)] = 199333,
  [SMALL_STATE(6357)] = 199349,
  [SMALL_STATE(6358)] = 199365,
  [SMALL_STATE(6359)] = 199381,
  [SMALL_STATE(6360)] = 199395,
  [SMALL_STATE(6361)] = 199409,
  [SMALL_STATE(6362)] = 199423,
  [SMALL_STATE(6363)] = 199439,
  [SMALL_STATE(6364)] = 199453,
  [SMALL_STATE(6365)] = 199469,
  [SMALL_STATE(6366)] = 199483,
  [SMALL_STATE(6367)] = 199497,
  [SMALL_STATE(6368)] = 199513,
  [SMALL_STATE(6369)] = 199529,
  [SMALL_STATE(6370)] = 199545,
  [SMALL_STATE(6371)] = 199559,
  [SMALL_STATE(6372)] = 199575,
  [SMALL_STATE(6373)] = 199591,
  [SMALL_STATE(6374)] = 199607,
  [SMALL_STATE(6375)] = 199623,
  [SMALL_STATE(6376)] = 199639,
  [SMALL_STATE(6377)] = 199653,
  [SMALL_STATE(6378)] = 199669,
  [SMALL_STATE(6379)] = 199685,
  [SMALL_STATE(6380)] = 199699,
  [SMALL_STATE(6381)] = 199715,
  [SMALL_STATE(6382)] = 199731,
  [SMALL_STATE(6383)] = 199747,
  [SMALL_STATE(6384)] = 199763,
  [SMALL_STATE(6385)] = 199779,
  [SMALL_STATE(6386)] = 199793,
  [SMALL_STATE(6387)] = 199809,
  [SMALL_STATE(6388)] = 199825,
  [SMALL_STATE(6389)] = 199841,
  [SMALL_STATE(6390)] = 199857,
  [SMALL_STATE(6391)] = 199873,
  [SMALL_STATE(6392)] = 199889,
  [SMALL_STATE(6393)] = 199905,
  [SMALL_STATE(6394)] = 199919,
  [SMALL_STATE(6395)] = 199933,
  [SMALL_STATE(6396)] = 199947,
  [SMALL_STATE(6397)] = 199963,
  [SMALL_STATE(6398)] = 199979,
  [SMALL_STATE(6399)] = 199995,
  [SMALL_STATE(6400)] = 200011,
  [SMALL_STATE(6401)] = 200025,
  [SMALL_STATE(6402)] = 200041,
  [SMALL_STATE(6403)] = 200057,
  [SMALL_STATE(6404)] = 200073,
  [SMALL_STATE(6405)] = 200089,
  [SMALL_STATE(6406)] = 200105,
  [SMALL_STATE(6407)] = 200121,
  [SMALL_STATE(6408)] = 200137,
  [SMALL_STATE(6409)] = 200153,
  [SMALL_STATE(6410)] = 200169,
  [SMALL_STATE(6411)] = 200185,
  [SMALL_STATE(6412)] = 200199,
  [SMALL_STATE(6413)] = 200215,
  [SMALL_STATE(6414)] = 200229,
  [SMALL_STATE(6415)] = 200245,
  [SMALL_STATE(6416)] = 200261,
  [SMALL_STATE(6417)] = 200277,
  [SMALL_STATE(6418)] = 200293,
  [SMALL_STATE(6419)] = 200307,
  [SMALL_STATE(6420)] = 200323,
  [SMALL_STATE(6421)] = 200339,
  [SMALL_STATE(6422)] = 200355,
  [SMALL_STATE(6423)] = 200371,
  [SMALL_STATE(6424)] = 200387,
  [SMALL_STATE(6425)] = 200403,
  [SMALL_STATE(6426)] = 200419,
  [SMALL_STATE(6427)] = 200433,
  [SMALL_STATE(6428)] = 200449,
  [SMALL_STATE(6429)] = 200465,
  [SMALL_STATE(6430)] = 200481,
  [SMALL_STATE(6431)] = 200497,
  [SMALL_STATE(6432)] = 200511,
  [SMALL_STATE(6433)] = 200527,
  [SMALL_STATE(6434)] = 200543,
  [SMALL_STATE(6435)] = 200559,
  [SMALL_STATE(6436)] = 200573,
  [SMALL_STATE(6437)] = 200589,
  [SMALL_STATE(6438)] = 200605,
  [SMALL_STATE(6439)] = 200619,
  [SMALL_STATE(6440)] = 200635,
  [SMALL_STATE(6441)] = 200651,
  [SMALL_STATE(6442)] = 200667,
  [SMALL_STATE(6443)] = 200683,
  [SMALL_STATE(6444)] = 200699,
  [SMALL_STATE(6445)] = 200715,
  [SMALL_STATE(6446)] = 200731,
  [SMALL_STATE(6447)] = 200747,
  [SMALL_STATE(6448)] = 200763,
  [SMALL_STATE(6449)] = 200779,
  [SMALL_STATE(6450)] = 200795,
  [SMALL_STATE(6451)] = 200811,
  [SMALL_STATE(6452)] = 200827,
  [SMALL_STATE(6453)] = 200843,
  [SMALL_STATE(6454)] = 200857,
  [SMALL_STATE(6455)] = 200871,
  [SMALL_STATE(6456)] = 200885,
  [SMALL_STATE(6457)] = 200901,
  [SMALL_STATE(6458)] = 200915,
  [SMALL_STATE(6459)] = 200931,
  [SMALL_STATE(6460)] = 200945,
  [SMALL_STATE(6461)] = 200961,
  [SMALL_STATE(6462)] = 200977,
  [SMALL_STATE(6463)] = 200991,
  [SMALL_STATE(6464)] = 201007,
  [SMALL_STATE(6465)] = 201023,
  [SMALL_STATE(6466)] = 201037,
  [SMALL_STATE(6467)] = 201053,
  [SMALL_STATE(6468)] = 201067,
  [SMALL_STATE(6469)] = 201083,
  [SMALL_STATE(6470)] = 201099,
  [SMALL_STATE(6471)] = 201115,
  [SMALL_STATE(6472)] = 201129,
  [SMALL_STATE(6473)] = 201143,
  [SMALL_STATE(6474)] = 201159,
  [SMALL_STATE(6475)] = 201173,
  [SMALL_STATE(6476)] = 201189,
  [SMALL_STATE(6477)] = 201205,
  [SMALL_STATE(6478)] = 201221,
  [SMALL_STATE(6479)] = 201235,
  [SMALL_STATE(6480)] = 201249,
  [SMALL_STATE(6481)] = 201263,
  [SMALL_STATE(6482)] = 201277,
  [SMALL_STATE(6483)] = 201293,
  [SMALL_STATE(6484)] = 201307,
  [SMALL_STATE(6485)] = 201323,
  [SMALL_STATE(6486)] = 201339,
  [SMALL_STATE(6487)] = 201353,
  [SMALL_STATE(6488)] = 201367,
  [SMALL_STATE(6489)] = 201383,
  [SMALL_STATE(6490)] = 201399,
  [SMALL_STATE(6491)] = 201415,
  [SMALL_STATE(6492)] = 201429,
  [SMALL_STATE(6493)] = 201445,
  [SMALL_STATE(6494)] = 201461,
  [SMALL_STATE(6495)] = 201477,
  [SMALL_STATE(6496)] = 201493,
  [SMALL_STATE(6497)] = 201509,
  [SMALL_STATE(6498)] = 201525,
  [SMALL_STATE(6499)] = 201539,
  [SMALL_STATE(6500)] = 201555,
  [SMALL_STATE(6501)] = 201571,
  [SMALL_STATE(6502)] = 201587,
  [SMALL_STATE(6503)] = 201603,
  [SMALL_STATE(6504)] = 201617,
  [SMALL_STATE(6505)] = 201633,
  [SMALL_STATE(6506)] = 201647,
  [SMALL_STATE(6507)] = 201661,
  [SMALL_STATE(6508)] = 201677,
  [SMALL_STATE(6509)] = 201691,
  [SMALL_STATE(6510)] = 201707,
  [SMALL_STATE(6511)] = 201723,
  [SMALL_STATE(6512)] = 201737,
  [SMALL_STATE(6513)] = 201753,
  [SMALL_STATE(6514)] = 201767,
  [SMALL_STATE(6515)] = 201781,
  [SMALL_STATE(6516)] = 201797,
  [SMALL_STATE(6517)] = 201813,
  [SMALL_STATE(6518)] = 201829,
  [SMALL_STATE(6519)] = 201843,
  [SMALL_STATE(6520)] = 201859,
  [SMALL_STATE(6521)] = 201875,
  [SMALL_STATE(6522)] = 201891,
  [SMALL_STATE(6523)] = 201907,
  [SMALL_STATE(6524)] = 201923,
  [SMALL_STATE(6525)] = 201939,
  [SMALL_STATE(6526)] = 201955,
  [SMALL_STATE(6527)] = 201971,
  [SMALL_STATE(6528)] = 201985,
  [SMALL_STATE(6529)] = 202001,
  [SMALL_STATE(6530)] = 202015,
  [SMALL_STATE(6531)] = 202031,
  [SMALL_STATE(6532)] = 202045,
  [SMALL_STATE(6533)] = 202061,
  [SMALL_STATE(6534)] = 202077,
  [SMALL_STATE(6535)] = 202093,
  [SMALL_STATE(6536)] = 202109,
  [SMALL_STATE(6537)] = 202123,
  [SMALL_STATE(6538)] = 202137,
  [SMALL_STATE(6539)] = 202153,
  [SMALL_STATE(6540)] = 202167,
  [SMALL_STATE(6541)] = 202183,
  [SMALL_STATE(6542)] = 202199,
  [SMALL_STATE(6543)] = 202215,
  [SMALL_STATE(6544)] = 202231,
  [SMALL_STATE(6545)] = 202247,
  [SMALL_STATE(6546)] = 202263,
  [SMALL_STATE(6547)] = 202279,
  [SMALL_STATE(6548)] = 202293,
  [SMALL_STATE(6549)] = 202309,
  [SMALL_STATE(6550)] = 202323,
  [SMALL_STATE(6551)] = 202339,
  [SMALL_STATE(6552)] = 202353,
  [SMALL_STATE(6553)] = 202367,
  [SMALL_STATE(6554)] = 202383,
  [SMALL_STATE(6555)] = 202399,
  [SMALL_STATE(6556)] = 202413,
  [SMALL_STATE(6557)] = 202429,
  [SMALL_STATE(6558)] = 202443,
  [SMALL_STATE(6559)] = 202459,
  [SMALL_STATE(6560)] = 202475,
  [SMALL_STATE(6561)] = 202491,
  [SMALL_STATE(6562)] = 202507,
  [SMALL_STATE(6563)] = 202523,
  [SMALL_STATE(6564)] = 202539,
  [SMALL_STATE(6565)] = 202555,
  [SMALL_STATE(6566)] = 202571,
  [SMALL_STATE(6567)] = 202587,
  [SMALL_STATE(6568)] = 202603,
  [SMALL_STATE(6569)] = 202617,
  [SMALL_STATE(6570)] = 202631,
  [SMALL_STATE(6571)] = 202645,
  [SMALL_STATE(6572)] = 202661,
  [SMALL_STATE(6573)] = 202675,
  [SMALL_STATE(6574)] = 202689,
  [SMALL_STATE(6575)] = 202705,
  [SMALL_STATE(6576)] = 202721,
  [SMALL_STATE(6577)] = 202735,
  [SMALL_STATE(6578)] = 202751,
  [SMALL_STATE(6579)] = 202767,
  [SMALL_STATE(6580)] = 202783,
  [SMALL_STATE(6581)] = 202799,
  [SMALL_STATE(6582)] = 202815,
  [SMALL_STATE(6583)] = 202831,
  [SMALL_STATE(6584)] = 202847,
  [SMALL_STATE(6585)] = 202861,
  [SMALL_STATE(6586)] = 202877,
  [SMALL_STATE(6587)] = 202893,
  [SMALL_STATE(6588)] = 202909,
  [SMALL_STATE(6589)] = 202923,
  [SMALL_STATE(6590)] = 202937,
  [SMALL_STATE(6591)] = 202951,
  [SMALL_STATE(6592)] = 202967,
  [SMALL_STATE(6593)] = 202983,
  [SMALL_STATE(6594)] = 202999,
  [SMALL_STATE(6595)] = 203015,
  [SMALL_STATE(6596)] = 203031,
  [SMALL_STATE(6597)] = 203047,
  [SMALL_STATE(6598)] = 203061,
  [SMALL_STATE(6599)] = 203075,
  [SMALL_STATE(6600)] = 203091,
  [SMALL_STATE(6601)] = 203105,
  [SMALL_STATE(6602)] = 203119,
  [SMALL_STATE(6603)] = 203135,
  [SMALL_STATE(6604)] = 203151,
  [SMALL_STATE(6605)] = 203165,
  [SMALL_STATE(6606)] = 203181,
  [SMALL_STATE(6607)] = 203195,
  [SMALL_STATE(6608)] = 203209,
  [SMALL_STATE(6609)] = 203225,
  [SMALL_STATE(6610)] = 203241,
  [SMALL_STATE(6611)] = 203257,
  [SMALL_STATE(6612)] = 203273,
  [SMALL_STATE(6613)] = 203287,
  [SMALL_STATE(6614)] = 203303,
  [SMALL_STATE(6615)] = 203319,
  [SMALL_STATE(6616)] = 203333,
  [SMALL_STATE(6617)] = 203349,
  [SMALL_STATE(6618)] = 203365,
  [SMALL_STATE(6619)] = 203379,
  [SMALL_STATE(6620)] = 203395,
  [SMALL_STATE(6621)] = 203411,
  [SMALL_STATE(6622)] = 203427,
  [SMALL_STATE(6623)] = 203441,
  [SMALL_STATE(6624)] = 203457,
  [SMALL_STATE(6625)] = 203473,
  [SMALL_STATE(6626)] = 203487,
  [SMALL_STATE(6627)] = 203501,
  [SMALL_STATE(6628)] = 203517,
  [SMALL_STATE(6629)] = 203533,
  [SMALL_STATE(6630)] = 203549,
  [SMALL_STATE(6631)] = 203565,
  [SMALL_STATE(6632)] = 203581,
  [SMALL_STATE(6633)] = 203595,
  [SMALL_STATE(6634)] = 203609,
  [SMALL_STATE(6635)] = 203625,
  [SMALL_STATE(6636)] = 203639,
  [SMALL_STATE(6637)] = 203653,
  [SMALL_STATE(6638)] = 203669,
  [SMALL_STATE(6639)] = 203685,
  [SMALL_STATE(6640)] = 203701,
  [SMALL_STATE(6641)] = 203715,
  [SMALL_STATE(6642)] = 203731,
  [SMALL_STATE(6643)] = 203747,
  [SMALL_STATE(6644)] = 203763,
  [SMALL_STATE(6645)] = 203777,
  [SMALL_STATE(6646)] = 203791,
  [SMALL_STATE(6647)] = 203807,
  [SMALL_STATE(6648)] = 203821,
  [SMALL_STATE(6649)] = 203837,
  [SMALL_STATE(6650)] = 203853,
  [SMALL_STATE(6651)] = 203867,
  [SMALL_STATE(6652)] = 203881,
  [SMALL_STATE(6653)] = 203895,
  [SMALL_STATE(6654)] = 203911,
  [SMALL_STATE(6655)] = 203927,
  [SMALL_STATE(6656)] = 203943,
  [SMALL_STATE(6657)] = 203957,
  [SMALL_STATE(6658)] = 203973,
  [SMALL_STATE(6659)] = 203987,
  [SMALL_STATE(6660)] = 204001,
  [SMALL_STATE(6661)] = 204017,
  [SMALL_STATE(6662)] = 204031,
  [SMALL_STATE(6663)] = 204045,
  [SMALL_STATE(6664)] = 204061,
  [SMALL_STATE(6665)] = 204077,
  [SMALL_STATE(6666)] = 204093,
  [SMALL_STATE(6667)] = 204107,
  [SMALL_STATE(6668)] = 204123,
  [SMALL_STATE(6669)] = 204139,
  [SMALL_STATE(6670)] = 204153,
  [SMALL_STATE(6671)] = 204169,
  [SMALL_STATE(6672)] = 204183,
  [SMALL_STATE(6673)] = 204199,
  [SMALL_STATE(6674)] = 204215,
  [SMALL_STATE(6675)] = 204231,
  [SMALL_STATE(6676)] = 204245,
  [SMALL_STATE(6677)] = 204261,
  [SMALL_STATE(6678)] = 204275,
  [SMALL_STATE(6679)] = 204289,
  [SMALL_STATE(6680)] = 204305,
  [SMALL_STATE(6681)] = 204319,
  [SMALL_STATE(6682)] = 204333,
  [SMALL_STATE(6683)] = 204347,
  [SMALL_STATE(6684)] = 204361,
  [SMALL_STATE(6685)] = 204375,
  [SMALL_STATE(6686)] = 204389,
  [SMALL_STATE(6687)] = 204403,
  [SMALL_STATE(6688)] = 204419,
  [SMALL_STATE(6689)] = 204435,
  [SMALL_STATE(6690)] = 204449,
  [SMALL_STATE(6691)] = 204463,
  [SMALL_STATE(6692)] = 204477,
  [SMALL_STATE(6693)] = 204491,
  [SMALL_STATE(6694)] = 204505,
  [SMALL_STATE(6695)] = 204521,
  [SMALL_STATE(6696)] = 204535,
  [SMALL_STATE(6697)] = 204551,
  [SMALL_STATE(6698)] = 204565,
  [SMALL_STATE(6699)] = 204581,
  [SMALL_STATE(6700)] = 204595,
  [SMALL_STATE(6701)] = 204609,
  [SMALL_STATE(6702)] = 204623,
  [SMALL_STATE(6703)] = 204639,
  [SMALL_STATE(6704)] = 204655,
  [SMALL_STATE(6705)] = 204671,
  [SMALL_STATE(6706)] = 204687,
  [SMALL_STATE(6707)] = 204703,
  [SMALL_STATE(6708)] = 204719,
  [SMALL_STATE(6709)] = 204733,
  [SMALL_STATE(6710)] = 204749,
  [SMALL_STATE(6711)] = 204763,
  [SMALL_STATE(6712)] = 204777,
  [SMALL_STATE(6713)] = 204793,
  [SMALL_STATE(6714)] = 204807,
  [SMALL_STATE(6715)] = 204821,
  [SMALL_STATE(6716)] = 204835,
  [SMALL_STATE(6717)] = 204849,
  [SMALL_STATE(6718)] = 204865,
  [SMALL_STATE(6719)] = 204879,
  [SMALL_STATE(6720)] = 204895,
  [SMALL_STATE(6721)] = 204909,
  [SMALL_STATE(6722)] = 204923,
  [SMALL_STATE(6723)] = 204939,
  [SMALL_STATE(6724)] = 204955,
  [SMALL_STATE(6725)] = 204969,
  [SMALL_STATE(6726)] = 204985,
  [SMALL_STATE(6727)] = 205001,
  [SMALL_STATE(6728)] = 205015,
  [SMALL_STATE(6729)] = 205031,
  [SMALL_STATE(6730)] = 205047,
  [SMALL_STATE(6731)] = 205063,
  [SMALL_STATE(6732)] = 205077,
  [SMALL_STATE(6733)] = 205093,
  [SMALL_STATE(6734)] = 205107,
  [SMALL_STATE(6735)] = 205121,
  [SMALL_STATE(6736)] = 205135,
  [SMALL_STATE(6737)] = 205149,
  [SMALL_STATE(6738)] = 205163,
  [SMALL_STATE(6739)] = 205179,
  [SMALL_STATE(6740)] = 205195,
  [SMALL_STATE(6741)] = 205211,
  [SMALL_STATE(6742)] = 205227,
  [SMALL_STATE(6743)] = 205241,
  [SMALL_STATE(6744)] = 205257,
  [SMALL_STATE(6745)] = 205271,
  [SMALL_STATE(6746)] = 205285,
  [SMALL_STATE(6747)] = 205301,
  [SMALL_STATE(6748)] = 205317,
  [SMALL_STATE(6749)] = 205331,
  [SMALL_STATE(6750)] = 205345,
  [SMALL_STATE(6751)] = 205361,
  [SMALL_STATE(6752)] = 205377,
  [SMALL_STATE(6753)] = 205391,
  [SMALL_STATE(6754)] = 205407,
  [SMALL_STATE(6755)] = 205423,
  [SMALL_STATE(6756)] = 205437,
  [SMALL_STATE(6757)] = 205453,
  [SMALL_STATE(6758)] = 205467,
  [SMALL_STATE(6759)] = 205483,
  [SMALL_STATE(6760)] = 205497,
  [SMALL_STATE(6761)] = 205513,
  [SMALL_STATE(6762)] = 205529,
  [SMALL_STATE(6763)] = 205545,
  [SMALL_STATE(6764)] = 205559,
  [SMALL_STATE(6765)] = 205573,
  [SMALL_STATE(6766)] = 205587,
  [SMALL_STATE(6767)] = 205601,
  [SMALL_STATE(6768)] = 205617,
  [SMALL_STATE(6769)] = 205631,
  [SMALL_STATE(6770)] = 205647,
  [SMALL_STATE(6771)] = 205663,
  [SMALL_STATE(6772)] = 205679,
  [SMALL_STATE(6773)] = 205695,
  [SMALL_STATE(6774)] = 205709,
  [SMALL_STATE(6775)] = 205725,
  [SMALL_STATE(6776)] = 205739,
  [SMALL_STATE(6777)] = 205755,
  [SMALL_STATE(6778)] = 205771,
  [SMALL_STATE(6779)] = 205785,
  [SMALL_STATE(6780)] = 205801,
  [SMALL_STATE(6781)] = 205817,
  [SMALL_STATE(6782)] = 205833,
  [SMALL_STATE(6783)] = 205847,
  [SMALL_STATE(6784)] = 205861,
  [SMALL_STATE(6785)] = 205875,
  [SMALL_STATE(6786)] = 205891,
  [SMALL_STATE(6787)] = 205907,
  [SMALL_STATE(6788)] = 205923,
  [SMALL_STATE(6789)] = 205937,
  [SMALL_STATE(6790)] = 205953,
  [SMALL_STATE(6791)] = 205969,
  [SMALL_STATE(6792)] = 205985,
  [SMALL_STATE(6793)] = 206001,
  [SMALL_STATE(6794)] = 206017,
  [SMALL_STATE(6795)] = 206033,
  [SMALL_STATE(6796)] = 206047,
  [SMALL_STATE(6797)] = 206061,
  [SMALL_STATE(6798)] = 206077,
  [SMALL_STATE(6799)] = 206093,
  [SMALL_STATE(6800)] = 206107,
  [SMALL_STATE(6801)] = 206123,
  [SMALL_STATE(6802)] = 206137,
  [SMALL_STATE(6803)] = 206151,
  [SMALL_STATE(6804)] = 206167,
  [SMALL_STATE(6805)] = 206183,
  [SMALL_STATE(6806)] = 206199,
  [SMALL_STATE(6807)] = 206213,
  [SMALL_STATE(6808)] = 206229,
  [SMALL_STATE(6809)] = 206245,
  [SMALL_STATE(6810)] = 206259,
  [SMALL_STATE(6811)] = 206275,
  [SMALL_STATE(6812)] = 206291,
  [SMALL_STATE(6813)] = 206305,
  [SMALL_STATE(6814)] = 206319,
  [SMALL_STATE(6815)] = 206335,
  [SMALL_STATE(6816)] = 206349,
  [SMALL_STATE(6817)] = 206365,
  [SMALL_STATE(6818)] = 206379,
  [SMALL_STATE(6819)] = 206395,
  [SMALL_STATE(6820)] = 206411,
  [SMALL_STATE(6821)] = 206425,
  [SMALL_STATE(6822)] = 206441,
  [SMALL_STATE(6823)] = 206457,
  [SMALL_STATE(6824)] = 206471,
  [SMALL_STATE(6825)] = 206487,
  [SMALL_STATE(6826)] = 206501,
  [SMALL_STATE(6827)] = 206517,
  [SMALL_STATE(6828)] = 206533,
  [SMALL_STATE(6829)] = 206549,
  [SMALL_STATE(6830)] = 206565,
  [SMALL_STATE(6831)] = 206581,
  [SMALL_STATE(6832)] = 206597,
  [SMALL_STATE(6833)] = 206611,
  [SMALL_STATE(6834)] = 206625,
  [SMALL_STATE(6835)] = 206639,
  [SMALL_STATE(6836)] = 206655,
  [SMALL_STATE(6837)] = 206669,
  [SMALL_STATE(6838)] = 206685,
  [SMALL_STATE(6839)] = 206699,
  [SMALL_STATE(6840)] = 206713,
  [SMALL_STATE(6841)] = 206729,
  [SMALL_STATE(6842)] = 206743,
  [SMALL_STATE(6843)] = 206759,
  [SMALL_STATE(6844)] = 206773,
  [SMALL_STATE(6845)] = 206787,
  [SMALL_STATE(6846)] = 206801,
  [SMALL_STATE(6847)] = 206817,
  [SMALL_STATE(6848)] = 206833,
  [SMALL_STATE(6849)] = 206847,
  [SMALL_STATE(6850)] = 206861,
  [SMALL_STATE(6851)] = 206877,
  [SMALL_STATE(6852)] = 206893,
  [SMALL_STATE(6853)] = 206909,
  [SMALL_STATE(6854)] = 206925,
  [SMALL_STATE(6855)] = 206941,
  [SMALL_STATE(6856)] = 206955,
  [SMALL_STATE(6857)] = 206971,
  [SMALL_STATE(6858)] = 206987,
  [SMALL_STATE(6859)] = 207003,
  [SMALL_STATE(6860)] = 207017,
  [SMALL_STATE(6861)] = 207031,
  [SMALL_STATE(6862)] = 207045,
  [SMALL_STATE(6863)] = 207061,
  [SMALL_STATE(6864)] = 207077,
  [SMALL_STATE(6865)] = 207093,
  [SMALL_STATE(6866)] = 207109,
  [SMALL_STATE(6867)] = 207125,
  [SMALL_STATE(6868)] = 207141,
  [SMALL_STATE(6869)] = 207157,
  [SMALL_STATE(6870)] = 207173,
  [SMALL_STATE(6871)] = 207189,
  [SMALL_STATE(6872)] = 207203,
  [SMALL_STATE(6873)] = 207217,
  [SMALL_STATE(6874)] = 207233,
  [SMALL_STATE(6875)] = 207247,
  [SMALL_STATE(6876)] = 207263,
  [SMALL_STATE(6877)] = 207277,
  [SMALL_STATE(6878)] = 207291,
  [SMALL_STATE(6879)] = 207307,
  [SMALL_STATE(6880)] = 207323,
  [SMALL_STATE(6881)] = 207337,
  [SMALL_STATE(6882)] = 207353,
  [SMALL_STATE(6883)] = 207369,
  [SMALL_STATE(6884)] = 207385,
  [SMALL_STATE(6885)] = 207401,
  [SMALL_STATE(6886)] = 207415,
  [SMALL_STATE(6887)] = 207429,
  [SMALL_STATE(6888)] = 207445,
  [SMALL_STATE(6889)] = 207461,
  [SMALL_STATE(6890)] = 207475,
  [SMALL_STATE(6891)] = 207489,
  [SMALL_STATE(6892)] = 207505,
  [SMALL_STATE(6893)] = 207521,
  [SMALL_STATE(6894)] = 207537,
  [SMALL_STATE(6895)] = 207551,
  [SMALL_STATE(6896)] = 207567,
  [SMALL_STATE(6897)] = 207583,
  [SMALL_STATE(6898)] = 207599,
  [SMALL_STATE(6899)] = 207615,
  [SMALL_STATE(6900)] = 207631,
  [SMALL_STATE(6901)] = 207647,
  [SMALL_STATE(6902)] = 207663,
  [SMALL_STATE(6903)] = 207677,
  [SMALL_STATE(6904)] = 207691,
  [SMALL_STATE(6905)] = 207707,
  [SMALL_STATE(6906)] = 207723,
  [SMALL_STATE(6907)] = 207737,
  [SMALL_STATE(6908)] = 207751,
  [SMALL_STATE(6909)] = 207767,
  [SMALL_STATE(6910)] = 207781,
  [SMALL_STATE(6911)] = 207797,
  [SMALL_STATE(6912)] = 207811,
  [SMALL_STATE(6913)] = 207827,
  [SMALL_STATE(6914)] = 207841,
  [SMALL_STATE(6915)] = 207855,
  [SMALL_STATE(6916)] = 207871,
  [SMALL_STATE(6917)] = 207885,
  [SMALL_STATE(6918)] = 207901,
  [SMALL_STATE(6919)] = 207917,
  [SMALL_STATE(6920)] = 207931,
  [SMALL_STATE(6921)] = 207945,
  [SMALL_STATE(6922)] = 207961,
  [SMALL_STATE(6923)] = 207977,
  [SMALL_STATE(6924)] = 207993,
  [SMALL_STATE(6925)] = 208009,
  [SMALL_STATE(6926)] = 208025,
  [SMALL_STATE(6927)] = 208041,
  [SMALL_STATE(6928)] = 208057,
  [SMALL_STATE(6929)] = 208073,
  [SMALL_STATE(6930)] = 208087,
  [SMALL_STATE(6931)] = 208103,
  [SMALL_STATE(6932)] = 208117,
  [SMALL_STATE(6933)] = 208133,
  [SMALL_STATE(6934)] = 208149,
  [SMALL_STATE(6935)] = 208165,
  [SMALL_STATE(6936)] = 208181,
  [SMALL_STATE(6937)] = 208197,
  [SMALL_STATE(6938)] = 208213,
  [SMALL_STATE(6939)] = 208229,
  [SMALL_STATE(6940)] = 208245,
  [SMALL_STATE(6941)] = 208261,
  [SMALL_STATE(6942)] = 208275,
  [SMALL_STATE(6943)] = 208291,
  [SMALL_STATE(6944)] = 208307,
  [SMALL_STATE(6945)] = 208323,
  [SMALL_STATE(6946)] = 208337,
  [SMALL_STATE(6947)] = 208353,
  [SMALL_STATE(6948)] = 208367,
  [SMALL_STATE(6949)] = 208383,
  [SMALL_STATE(6950)] = 208399,
  [SMALL_STATE(6951)] = 208413,
  [SMALL_STATE(6952)] = 208429,
  [SMALL_STATE(6953)] = 208445,
  [SMALL_STATE(6954)] = 208461,
  [SMALL_STATE(6955)] = 208475,
  [SMALL_STATE(6956)] = 208489,
  [SMALL_STATE(6957)] = 208503,
  [SMALL_STATE(6958)] = 208517,
  [SMALL_STATE(6959)] = 208531,
  [SMALL_STATE(6960)] = 208547,
  [SMALL_STATE(6961)] = 208563,
  [SMALL_STATE(6962)] = 208577,
  [SMALL_STATE(6963)] = 208593,
  [SMALL_STATE(6964)] = 208609,
  [SMALL_STATE(6965)] = 208625,
  [SMALL_STATE(6966)] = 208639,
  [SMALL_STATE(6967)] = 208653,
  [SMALL_STATE(6968)] = 208669,
  [SMALL_STATE(6969)] = 208683,
  [SMALL_STATE(6970)] = 208699,
  [SMALL_STATE(6971)] = 208713,
  [SMALL_STATE(6972)] = 208729,
  [SMALL_STATE(6973)] = 208743,
  [SMALL_STATE(6974)] = 208759,
  [SMALL_STATE(6975)] = 208775,
  [SMALL_STATE(6976)] = 208791,
  [SMALL_STATE(6977)] = 208807,
  [SMALL_STATE(6978)] = 208821,
  [SMALL_STATE(6979)] = 208835,
  [SMALL_STATE(6980)] = 208849,
  [SMALL_STATE(6981)] = 208863,
  [SMALL_STATE(6982)] = 208877,
  [SMALL_STATE(6983)] = 208891,
  [SMALL_STATE(6984)] = 208907,
  [SMALL_STATE(6985)] = 208921,
  [SMALL_STATE(6986)] = 208935,
  [SMALL_STATE(6987)] = 208951,
  [SMALL_STATE(6988)] = 208967,
  [SMALL_STATE(6989)] = 208983,
  [SMALL_STATE(6990)] = 208997,
  [SMALL_STATE(6991)] = 209010,
  [SMALL_STATE(6992)] = 209023,
  [SMALL_STATE(6993)] = 209036,
  [SMALL_STATE(6994)] = 209049,
  [SMALL_STATE(6995)] = 209062,
  [SMALL_STATE(6996)] = 209075,
  [SMALL_STATE(6997)] = 209088,
  [SMALL_STATE(6998)] = 209101,
  [SMALL_STATE(6999)] = 209114,
  [SMALL_STATE(7000)] = 209127,
  [SMALL_STATE(7001)] = 209140,
  [SMALL_STATE(7002)] = 209153,
  [SMALL_STATE(7003)] = 209166,
  [SMALL_STATE(7004)] = 209179,
  [SMALL_STATE(7005)] = 209192,
  [SMALL_STATE(7006)] = 209205,
  [SMALL_STATE(7007)] = 209218,
  [SMALL_STATE(7008)] = 209231,
  [SMALL_STATE(7009)] = 209244,
  [SMALL_STATE(7010)] = 209257,
  [SMALL_STATE(7011)] = 209270,
  [SMALL_STATE(7012)] = 209283,
  [SMALL_STATE(7013)] = 209296,
  [SMALL_STATE(7014)] = 209309,
  [SMALL_STATE(7015)] = 209322,
  [SMALL_STATE(7016)] = 209335,
  [SMALL_STATE(7017)] = 209348,
  [SMALL_STATE(7018)] = 209361,
  [SMALL_STATE(7019)] = 209374,
  [SMALL_STATE(7020)] = 209387,
  [SMALL_STATE(7021)] = 209400,
  [SMALL_STATE(7022)] = 209413,
  [SMALL_STATE(7023)] = 209426,
  [SMALL_STATE(7024)] = 209439,
  [SMALL_STATE(7025)] = 209452,
  [SMALL_STATE(7026)] = 209465,
  [SMALL_STATE(7027)] = 209478,
  [SMALL_STATE(7028)] = 209491,
  [SMALL_STATE(7029)] = 209504,
  [SMALL_STATE(7030)] = 209517,
  [SMALL_STATE(7031)] = 209530,
  [SMALL_STATE(7032)] = 209543,
  [SMALL_STATE(7033)] = 209556,
  [SMALL_STATE(7034)] = 209569,
  [SMALL_STATE(7035)] = 209582,
  [SMALL_STATE(7036)] = 209595,
  [SMALL_STATE(7037)] = 209608,
  [SMALL_STATE(7038)] = 209621,
  [SMALL_STATE(7039)] = 209634,
  [SMALL_STATE(7040)] = 209647,
  [SMALL_STATE(7041)] = 209660,
  [SMALL_STATE(7042)] = 209673,
  [SMALL_STATE(7043)] = 209686,
  [SMALL_STATE(7044)] = 209699,
  [SMALL_STATE(7045)] = 209712,
  [SMALL_STATE(7046)] = 209725,
  [SMALL_STATE(7047)] = 209738,
  [SMALL_STATE(7048)] = 209751,
  [SMALL_STATE(7049)] = 209764,
  [SMALL_STATE(7050)] = 209777,
  [SMALL_STATE(7051)] = 209790,
  [SMALL_STATE(7052)] = 209803,
  [SMALL_STATE(7053)] = 209816,
  [SMALL_STATE(7054)] = 209829,
  [SMALL_STATE(7055)] = 209842,
  [SMALL_STATE(7056)] = 209855,
  [SMALL_STATE(7057)] = 209868,
  [SMALL_STATE(7058)] = 209881,
  [SMALL_STATE(7059)] = 209894,
  [SMALL_STATE(7060)] = 209907,
  [SMALL_STATE(7061)] = 209920,
  [SMALL_STATE(7062)] = 209933,
  [SMALL_STATE(7063)] = 209946,
  [SMALL_STATE(7064)] = 209959,
  [SMALL_STATE(7065)] = 209972,
  [SMALL_STATE(7066)] = 209985,
  [SMALL_STATE(7067)] = 209998,
  [SMALL_STATE(7068)] = 210011,
  [SMALL_STATE(7069)] = 210024,
  [SMALL_STATE(7070)] = 210037,
  [SMALL_STATE(7071)] = 210050,
  [SMALL_STATE(7072)] = 210063,
  [SMALL_STATE(7073)] = 210076,
  [SMALL_STATE(7074)] = 210089,
  [SMALL_STATE(7075)] = 210102,
  [SMALL_STATE(7076)] = 210115,
  [SMALL_STATE(7077)] = 210128,
  [SMALL_STATE(7078)] = 210141,
  [SMALL_STATE(7079)] = 210154,
  [SMALL_STATE(7080)] = 210167,
  [SMALL_STATE(7081)] = 210180,
  [SMALL_STATE(7082)] = 210193,
  [SMALL_STATE(7083)] = 210206,
  [SMALL_STATE(7084)] = 210219,
  [SMALL_STATE(7085)] = 210232,
  [SMALL_STATE(7086)] = 210245,
  [SMALL_STATE(7087)] = 210258,
  [SMALL_STATE(7088)] = 210271,
  [SMALL_STATE(7089)] = 210284,
  [SMALL_STATE(7090)] = 210297,
  [SMALL_STATE(7091)] = 210310,
  [SMALL_STATE(7092)] = 210323,
  [SMALL_STATE(7093)] = 210336,
  [SMALL_STATE(7094)] = 210349,
  [SMALL_STATE(7095)] = 210362,
  [SMALL_STATE(7096)] = 210375,
  [SMALL_STATE(7097)] = 210388,
  [SMALL_STATE(7098)] = 210401,
  [SMALL_STATE(7099)] = 210414,
  [SMALL_STATE(7100)] = 210427,
  [SMALL_STATE(7101)] = 210440,
  [SMALL_STATE(7102)] = 210453,
  [SMALL_STATE(7103)] = 210466,
  [SMALL_STATE(7104)] = 210479,
  [SMALL_STATE(7105)] = 210492,
  [SMALL_STATE(7106)] = 210505,
  [SMALL_STATE(7107)] = 210518,
  [SMALL_STATE(7108)] = 210531,
  [SMALL_STATE(7109)] = 210544,
  [SMALL_STATE(7110)] = 210557,
  [SMALL_STATE(7111)] = 210570,
  [SMALL_STATE(7112)] = 210583,
  [SMALL_STATE(7113)] = 210596,
  [SMALL_STATE(7114)] = 210609,
  [SMALL_STATE(7115)] = 210622,
  [SMALL_STATE(7116)] = 210635,
  [SMALL_STATE(7117)] = 210648,
  [SMALL_STATE(7118)] = 210661,
  [SMALL_STATE(7119)] = 210674,
  [SMALL_STATE(7120)] = 210687,
  [SMALL_STATE(7121)] = 210700,
  [SMALL_STATE(7122)] = 210713,
  [SMALL_STATE(7123)] = 210726,
  [SMALL_STATE(7124)] = 210739,
  [SMALL_STATE(7125)] = 210752,
  [SMALL_STATE(7126)] = 210765,
  [SMALL_STATE(7127)] = 210778,
  [SMALL_STATE(7128)] = 210791,
  [SMALL_STATE(7129)] = 210804,
  [SMALL_STATE(7130)] = 210817,
  [SMALL_STATE(7131)] = 210830,
  [SMALL_STATE(7132)] = 210843,
  [SMALL_STATE(7133)] = 210856,
  [SMALL_STATE(7134)] = 210869,
  [SMALL_STATE(7135)] = 210882,
  [SMALL_STATE(7136)] = 210895,
  [SMALL_STATE(7137)] = 210908,
  [SMALL_STATE(7138)] = 210921,
  [SMALL_STATE(7139)] = 210934,
  [SMALL_STATE(7140)] = 210947,
  [SMALL_STATE(7141)] = 210960,
  [SMALL_STATE(7142)] = 210973,
  [SMALL_STATE(7143)] = 210986,
  [SMALL_STATE(7144)] = 210999,
  [SMALL_STATE(7145)] = 211012,
  [SMALL_STATE(7146)] = 211025,
  [SMALL_STATE(7147)] = 211038,
  [SMALL_STATE(7148)] = 211051,
  [SMALL_STATE(7149)] = 211064,
  [SMALL_STATE(7150)] = 211077,
  [SMALL_STATE(7151)] = 211090,
  [SMALL_STATE(7152)] = 211103,
  [SMALL_STATE(7153)] = 211116,
  [SMALL_STATE(7154)] = 211129,
  [SMALL_STATE(7155)] = 211142,
  [SMALL_STATE(7156)] = 211155,
  [SMALL_STATE(7157)] = 211168,
  [SMALL_STATE(7158)] = 211181,
  [SMALL_STATE(7159)] = 211194,
  [SMALL_STATE(7160)] = 211207,
  [SMALL_STATE(7161)] = 211220,
  [SMALL_STATE(7162)] = 211233,
  [SMALL_STATE(7163)] = 211246,
  [SMALL_STATE(7164)] = 211259,
  [SMALL_STATE(7165)] = 211272,
  [SMALL_STATE(7166)] = 211285,
  [SMALL_STATE(7167)] = 211298,
  [SMALL_STATE(7168)] = 211311,
  [SMALL_STATE(7169)] = 211324,
  [SMALL_STATE(7170)] = 211337,
  [SMALL_STATE(7171)] = 211350,
  [SMALL_STATE(7172)] = 211363,
  [SMALL_STATE(7173)] = 211376,
  [SMALL_STATE(7174)] = 211389,
  [SMALL_STATE(7175)] = 211402,
  [SMALL_STATE(7176)] = 211415,
  [SMALL_STATE(7177)] = 211428,
  [SMALL_STATE(7178)] = 211441,
  [SMALL_STATE(7179)] = 211454,
  [SMALL_STATE(7180)] = 211467,
  [SMALL_STATE(7181)] = 211480,
  [SMALL_STATE(7182)] = 211493,
  [SMALL_STATE(7183)] = 211506,
  [SMALL_STATE(7184)] = 211519,
  [SMALL_STATE(7185)] = 211532,
  [SMALL_STATE(7186)] = 211545,
  [SMALL_STATE(7187)] = 211558,
  [SMALL_STATE(7188)] = 211571,
  [SMALL_STATE(7189)] = 211584,
  [SMALL_STATE(7190)] = 211597,
  [SMALL_STATE(7191)] = 211610,
  [SMALL_STATE(7192)] = 211623,
  [SMALL_STATE(7193)] = 211636,
  [SMALL_STATE(7194)] = 211649,
  [SMALL_STATE(7195)] = 211662,
  [SMALL_STATE(7196)] = 211675,
  [SMALL_STATE(7197)] = 211688,
  [SMALL_STATE(7198)] = 211701,
  [SMALL_STATE(7199)] = 211714,
  [SMALL_STATE(7200)] = 211727,
  [SMALL_STATE(7201)] = 211740,
  [SMALL_STATE(7202)] = 211753,
  [SMALL_STATE(7203)] = 211766,
  [SMALL_STATE(7204)] = 211779,
  [SMALL_STATE(7205)] = 211792,
  [SMALL_STATE(7206)] = 211805,
  [SMALL_STATE(7207)] = 211818,
  [SMALL_STATE(7208)] = 211831,
  [SMALL_STATE(7209)] = 211844,
  [SMALL_STATE(7210)] = 211857,
  [SMALL_STATE(7211)] = 211870,
  [SMALL_STATE(7212)] = 211883,
  [SMALL_STATE(7213)] = 211896,
  [SMALL_STATE(7214)] = 211909,
  [SMALL_STATE(7215)] = 211922,
  [SMALL_STATE(7216)] = 211935,
  [SMALL_STATE(7217)] = 211948,
  [SMALL_STATE(7218)] = 211961,
  [SMALL_STATE(7219)] = 211974,
  [SMALL_STATE(7220)] = 211987,
  [SMALL_STATE(7221)] = 212000,
  [SMALL_STATE(7222)] = 212013,
  [SMALL_STATE(7223)] = 212026,
  [SMALL_STATE(7224)] = 212039,
  [SMALL_STATE(7225)] = 212052,
  [SMALL_STATE(7226)] = 212065,
  [SMALL_STATE(7227)] = 212078,
  [SMALL_STATE(7228)] = 212091,
  [SMALL_STATE(7229)] = 212104,
  [SMALL_STATE(7230)] = 212117,
  [SMALL_STATE(7231)] = 212130,
  [SMALL_STATE(7232)] = 212143,
  [SMALL_STATE(7233)] = 212156,
  [SMALL_STATE(7234)] = 212169,
  [SMALL_STATE(7235)] = 212182,
  [SMALL_STATE(7236)] = 212195,
  [SMALL_STATE(7237)] = 212208,
  [SMALL_STATE(7238)] = 212221,
  [SMALL_STATE(7239)] = 212234,
  [SMALL_STATE(7240)] = 212247,
  [SMALL_STATE(7241)] = 212260,
  [SMALL_STATE(7242)] = 212273,
  [SMALL_STATE(7243)] = 212286,
  [SMALL_STATE(7244)] = 212299,
  [SMALL_STATE(7245)] = 212312,
  [SMALL_STATE(7246)] = 212325,
  [SMALL_STATE(7247)] = 212338,
  [SMALL_STATE(7248)] = 212351,
  [SMALL_STATE(7249)] = 212364,
  [SMALL_STATE(7250)] = 212377,
  [SMALL_STATE(7251)] = 212390,
  [SMALL_STATE(7252)] = 212403,
  [SMALL_STATE(7253)] = 212416,
  [SMALL_STATE(7254)] = 212429,
  [SMALL_STATE(7255)] = 212442,
  [SMALL_STATE(7256)] = 212455,
  [SMALL_STATE(7257)] = 212468,
  [SMALL_STATE(7258)] = 212481,
  [SMALL_STATE(7259)] = 212494,
  [SMALL_STATE(7260)] = 212507,
  [SMALL_STATE(7261)] = 212520,
  [SMALL_STATE(7262)] = 212533,
  [SMALL_STATE(7263)] = 212546,
  [SMALL_STATE(7264)] = 212559,
  [SMALL_STATE(7265)] = 212572,
  [SMALL_STATE(7266)] = 212585,
  [SMALL_STATE(7267)] = 212598,
  [SMALL_STATE(7268)] = 212611,
  [SMALL_STATE(7269)] = 212624,
  [SMALL_STATE(7270)] = 212637,
  [SMALL_STATE(7271)] = 212650,
  [SMALL_STATE(7272)] = 212663,
  [SMALL_STATE(7273)] = 212676,
  [SMALL_STATE(7274)] = 212689,
  [SMALL_STATE(7275)] = 212702,
  [SMALL_STATE(7276)] = 212715,
  [SMALL_STATE(7277)] = 212728,
  [SMALL_STATE(7278)] = 212741,
  [SMALL_STATE(7279)] = 212754,
  [SMALL_STATE(7280)] = 212767,
  [SMALL_STATE(7281)] = 212780,
  [SMALL_STATE(7282)] = 212793,
  [SMALL_STATE(7283)] = 212806,
  [SMALL_STATE(7284)] = 212819,
  [SMALL_STATE(7285)] = 212832,
  [SMALL_STATE(7286)] = 212845,
  [SMALL_STATE(7287)] = 212858,
  [SMALL_STATE(7288)] = 212871,
  [SMALL_STATE(7289)] = 212884,
  [SMALL_STATE(7290)] = 212897,
  [SMALL_STATE(7291)] = 212910,
  [SMALL_STATE(7292)] = 212923,
  [SMALL_STATE(7293)] = 212936,
  [SMALL_STATE(7294)] = 212949,
  [SMALL_STATE(7295)] = 212962,
  [SMALL_STATE(7296)] = 212975,
  [SMALL_STATE(7297)] = 212988,
  [SMALL_STATE(7298)] = 213001,
  [SMALL_STATE(7299)] = 213014,
  [SMALL_STATE(7300)] = 213027,
  [SMALL_STATE(7301)] = 213040,
  [SMALL_STATE(7302)] = 213053,
  [SMALL_STATE(7303)] = 213066,
  [SMALL_STATE(7304)] = 213079,
  [SMALL_STATE(7305)] = 213092,
  [SMALL_STATE(7306)] = 213105,
  [SMALL_STATE(7307)] = 213118,
  [SMALL_STATE(7308)] = 213131,
  [SMALL_STATE(7309)] = 213144,
  [SMALL_STATE(7310)] = 213157,
  [SMALL_STATE(7311)] = 213170,
  [SMALL_STATE(7312)] = 213183,
  [SMALL_STATE(7313)] = 213196,
  [SMALL_STATE(7314)] = 213209,
  [SMALL_STATE(7315)] = 213222,
  [SMALL_STATE(7316)] = 213235,
  [SMALL_STATE(7317)] = 213248,
  [SMALL_STATE(7318)] = 213261,
  [SMALL_STATE(7319)] = 213274,
  [SMALL_STATE(7320)] = 213287,
  [SMALL_STATE(7321)] = 213300,
  [SMALL_STATE(7322)] = 213313,
  [SMALL_STATE(7323)] = 213326,
  [SMALL_STATE(7324)] = 213339,
  [SMALL_STATE(7325)] = 213352,
  [SMALL_STATE(7326)] = 213365,
  [SMALL_STATE(7327)] = 213378,
  [SMALL_STATE(7328)] = 213391,
  [SMALL_STATE(7329)] = 213404,
  [SMALL_STATE(7330)] = 213417,
  [SMALL_STATE(7331)] = 213430,
  [SMALL_STATE(7332)] = 213443,
  [SMALL_STATE(7333)] = 213456,
  [SMALL_STATE(7334)] = 213469,
  [SMALL_STATE(7335)] = 213482,
  [SMALL_STATE(7336)] = 213495,
  [SMALL_STATE(7337)] = 213508,
  [SMALL_STATE(7338)] = 213521,
  [SMALL_STATE(7339)] = 213534,
  [SMALL_STATE(7340)] = 213547,
  [SMALL_STATE(7341)] = 213560,
  [SMALL_STATE(7342)] = 213573,
  [SMALL_STATE(7343)] = 213586,
  [SMALL_STATE(7344)] = 213599,
  [SMALL_STATE(7345)] = 213612,
  [SMALL_STATE(7346)] = 213625,
  [SMALL_STATE(7347)] = 213638,
  [SMALL_STATE(7348)] = 213651,
  [SMALL_STATE(7349)] = 213664,
  [SMALL_STATE(7350)] = 213677,
  [SMALL_STATE(7351)] = 213690,
  [SMALL_STATE(7352)] = 213703,
  [SMALL_STATE(7353)] = 213716,
  [SMALL_STATE(7354)] = 213729,
  [SMALL_STATE(7355)] = 213742,
  [SMALL_STATE(7356)] = 213755,
  [SMALL_STATE(7357)] = 213768,
  [SMALL_STATE(7358)] = 213781,
  [SMALL_STATE(7359)] = 213794,
  [SMALL_STATE(7360)] = 213807,
  [SMALL_STATE(7361)] = 213820,
  [SMALL_STATE(7362)] = 213833,
  [SMALL_STATE(7363)] = 213846,
  [SMALL_STATE(7364)] = 213859,
  [SMALL_STATE(7365)] = 213872,
  [SMALL_STATE(7366)] = 213885,
  [SMALL_STATE(7367)] = 213898,
  [SMALL_STATE(7368)] = 213911,
  [SMALL_STATE(7369)] = 213924,
  [SMALL_STATE(7370)] = 213937,
  [SMALL_STATE(7371)] = 213950,
  [SMALL_STATE(7372)] = 213963,
  [SMALL_STATE(7373)] = 213976,
  [SMALL_STATE(7374)] = 213989,
  [SMALL_STATE(7375)] = 214002,
  [SMALL_STATE(7376)] = 214015,
  [SMALL_STATE(7377)] = 214028,
  [SMALL_STATE(7378)] = 214041,
  [SMALL_STATE(7379)] = 214054,
  [SMALL_STATE(7380)] = 214067,
  [SMALL_STATE(7381)] = 214080,
  [SMALL_STATE(7382)] = 214093,
  [SMALL_STATE(7383)] = 214106,
  [SMALL_STATE(7384)] = 214119,
  [SMALL_STATE(7385)] = 214132,
  [SMALL_STATE(7386)] = 214145,
  [SMALL_STATE(7387)] = 214158,
  [SMALL_STATE(7388)] = 214171,
  [SMALL_STATE(7389)] = 214184,
  [SMALL_STATE(7390)] = 214197,
  [SMALL_STATE(7391)] = 214210,
  [SMALL_STATE(7392)] = 214223,
  [SMALL_STATE(7393)] = 214236,
  [SMALL_STATE(7394)] = 214249,
  [SMALL_STATE(7395)] = 214262,
  [SMALL_STATE(7396)] = 214275,
  [SMALL_STATE(7397)] = 214288,
  [SMALL_STATE(7398)] = 214301,
  [SMALL_STATE(7399)] = 214314,
  [SMALL_STATE(7400)] = 214327,
  [SMALL_STATE(7401)] = 214340,
  [SMALL_STATE(7402)] = 214353,
  [SMALL_STATE(7403)] = 214366,
  [SMALL_STATE(7404)] = 214379,
  [SMALL_STATE(7405)] = 214392,
  [SMALL_STATE(7406)] = 214405,
  [SMALL_STATE(7407)] = 214418,
  [SMALL_STATE(7408)] = 214431,
  [SMALL_STATE(7409)] = 214444,
  [SMALL_STATE(7410)] = 214457,
  [SMALL_STATE(7411)] = 214470,
  [SMALL_STATE(7412)] = 214483,
  [SMALL_STATE(7413)] = 214496,
  [SMALL_STATE(7414)] = 214509,
  [SMALL_STATE(7415)] = 214522,
  [SMALL_STATE(7416)] = 214535,
  [SMALL_STATE(7417)] = 214548,
  [SMALL_STATE(7418)] = 214561,
  [SMALL_STATE(7419)] = 214574,
  [SMALL_STATE(7420)] = 214587,
  [SMALL_STATE(7421)] = 214600,
  [SMALL_STATE(7422)] = 214613,
  [SMALL_STATE(7423)] = 214626,
  [SMALL_STATE(7424)] = 214639,
  [SMALL_STATE(7425)] = 214652,
  [SMALL_STATE(7426)] = 214665,
  [SMALL_STATE(7427)] = 214678,
  [SMALL_STATE(7428)] = 214691,
  [SMALL_STATE(7429)] = 214704,
  [SMALL_STATE(7430)] = 214717,
  [SMALL_STATE(7431)] = 214730,
  [SMALL_STATE(7432)] = 214743,
  [SMALL_STATE(7433)] = 214756,
  [SMALL_STATE(7434)] = 214769,
  [SMALL_STATE(7435)] = 214782,
  [SMALL_STATE(7436)] = 214795,
  [SMALL_STATE(7437)] = 214808,
  [SMALL_STATE(7438)] = 214821,
  [SMALL_STATE(7439)] = 214834,
  [SMALL_STATE(7440)] = 214847,
  [SMALL_STATE(7441)] = 214860,
  [SMALL_STATE(7442)] = 214873,
  [SMALL_STATE(7443)] = 214886,
  [SMALL_STATE(7444)] = 214899,
  [SMALL_STATE(7445)] = 214912,
  [SMALL_STATE(7446)] = 214925,
  [SMALL_STATE(7447)] = 214938,
  [SMALL_STATE(7448)] = 214951,
  [SMALL_STATE(7449)] = 214964,
  [SMALL_STATE(7450)] = 214977,
  [SMALL_STATE(7451)] = 214990,
  [SMALL_STATE(7452)] = 215003,
  [SMALL_STATE(7453)] = 215016,
  [SMALL_STATE(7454)] = 215029,
  [SMALL_STATE(7455)] = 215042,
  [SMALL_STATE(7456)] = 215055,
  [SMALL_STATE(7457)] = 215068,
  [SMALL_STATE(7458)] = 215081,
  [SMALL_STATE(7459)] = 215094,
  [SMALL_STATE(7460)] = 215107,
  [SMALL_STATE(7461)] = 215120,
  [SMALL_STATE(7462)] = 215133,
  [SMALL_STATE(7463)] = 215146,
  [SMALL_STATE(7464)] = 215159,
  [SMALL_STATE(7465)] = 215172,
  [SMALL_STATE(7466)] = 215185,
  [SMALL_STATE(7467)] = 215198,
  [SMALL_STATE(7468)] = 215211,
  [SMALL_STATE(7469)] = 215224,
  [SMALL_STATE(7470)] = 215237,
  [SMALL_STATE(7471)] = 215250,
  [SMALL_STATE(7472)] = 215263,
  [SMALL_STATE(7473)] = 215276,
  [SMALL_STATE(7474)] = 215289,
  [SMALL_STATE(7475)] = 215302,
  [SMALL_STATE(7476)] = 215315,
  [SMALL_STATE(7477)] = 215328,
  [SMALL_STATE(7478)] = 215341,
  [SMALL_STATE(7479)] = 215354,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7479),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3641),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6337),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4538),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4315),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6342),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6343),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5651),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6348),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6350),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5652),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5654),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6359),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6370),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5583),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5568),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4046),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4590),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7405),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4320),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4659),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7392),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5692),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7379),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7377),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7376),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3750),
  [115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 1), SHIFT(806),
  [118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1),
  [120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 1),
  [126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5391),
  [130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3753),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(551),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5567),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5565),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4061),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4492),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__augmented_assignment_lhs, 1, 0, 1),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(7243),
  [172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(769),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4311),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3180),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7075),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2755),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2891),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7008),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7009),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7010),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3679),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 1), SHIFT(625),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_pattern, 1, -1, 1),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3030),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5401),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2887),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, 0, 88),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3645),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6723),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4537),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4302),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6891),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6948),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5836),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6738),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6739),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5840),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5841),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6742),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4054),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4587),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7409),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7082),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7083),
  [403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2, 0, 0),
  [405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1985),
  [408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(817),
  [411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1951),
  [416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1824),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4),
  [422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(553),
  [425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3645),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6723),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4537),
  [434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1838),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4302),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6891),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6948),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5836),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(247),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(564),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6738),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(114),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6739),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5840),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5841),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6742),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(459),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(471),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1293),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(221),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(269),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6370),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5583),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5568),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4054),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(860),
  [503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4587),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(156),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(569),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7405),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4320),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(573),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4659),
  [524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2940),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7392),
  [530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2948),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5692),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1984),
  [539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(832),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1837),
  [545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7409),
  [548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7082),
  [551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7083),
  [554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, 0, 238),
  [556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, 0, 51),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2006),
  [563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(816),
  [566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1941),
  [569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1828),
  [572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(8),
  [575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3641),
  [578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6337),
  [581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4538),
  [584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1831),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4315),
  [590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6342),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6343),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5651),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6348),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(94),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6350),
  [608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5652),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5654),
  [614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6359),
  [617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(423),
  [620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(503),
  [623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1516),
  [626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4046),
  [629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(858),
  [632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4590),
  [635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(161),
  [638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2009),
  [641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1845),
  [647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7379),
  [650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7377),
  [653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7376),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4398),
  [660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3411),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4581),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4431),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4367),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2500),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, 0, 0),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3646),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6930),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4508),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4323),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6702),
  [786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5929),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6910),
  [792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6901),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5919),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5918),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6876),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4034),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4585),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7346),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7045),
  [826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7044),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3643),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6794),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4540),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4314),
  [848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6949),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6840),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6105),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6789),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6786),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6109),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6110),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6784),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4065),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4609),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7434),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7143),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7144),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3640),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6785),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4489),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4339),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6648),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6649),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6111),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6774),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6771),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6120),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6121),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6764),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6353),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4066),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4549),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7189),
  [952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7242),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7239),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2465),
  [968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(85),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7256),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4579),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2748),
  [987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7243),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7146),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3262),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3089),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2783),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2379),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2916),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2474),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2879),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3166),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2915),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [1065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(250),
  [1068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(268),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [1073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(4324),
  [1076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(4818),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2964),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3147),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2955),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3145),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3138),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2980),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, 0, 28),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7245),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4818),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5762),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4327),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3050),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2863),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6128),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2893),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7015),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [1203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(539),
  [1206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [1208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_rest_pattern, 2, 0, 28),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [1215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 1), SHIFT(698),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [1232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [1248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [1256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [1258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [1262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [1264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [1266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [1268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [1270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6990),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [1284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [1288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [1290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7081),
  [1292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [1294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3989),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3991),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [1318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4336),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [1324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [1334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7364),
  [1336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7456),
  [1338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [1340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7451),
  [1342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3925),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [1350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [1354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [1358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [1360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [1362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [1364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [1366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [1368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [1370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [1372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [1374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [1376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [1378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [1380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [1384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [1386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [1388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [1390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4328),
  [1392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2572),
  [1394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7091),
  [1396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2570),
  [1398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [1400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [1402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [1404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [1406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [1408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [1410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [1412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [1414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [1418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [1422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [1424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [1426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4326),
  [1428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [1430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2746),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [1436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [1438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [1440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [1442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [1444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [1448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [1450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4321),
  [1452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2877),
  [1454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3298),
  [1458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [1460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [1462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [1464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [1466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [1468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [1472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [1474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [1476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [1478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [1480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [1482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7160),
  [1490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [1492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [1494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [1496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [1502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [1506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [1508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [1524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7318),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3237),
  [1528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [1536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [1546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [1548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [1550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [1552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [1554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [1556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7136),
  [1560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3217),
  [1562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [1564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [1568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [1572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [1580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [1584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [1586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [1588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [1590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [1592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7235),
  [1594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3088),
  [1596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [1598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [1600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [1604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [1606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [1608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [1610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [1614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [1616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [1618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [1622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [1624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [1626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [1628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [1630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4334),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3245),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7187),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3195),
  [1638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3005),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [1642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [1646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [1648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [1650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [1654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [1656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [1660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [1662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [1666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [1668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3287),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3190),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [1682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4335),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3290),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3305),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3117),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1676),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3161),
  [1720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [1726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [1728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1, 0, 0),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1, 0, 0),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [1738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2931),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3219),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3272),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3339),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4623),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4617),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4780),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4620),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4528),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4317),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4063),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4591),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7381),
  [1856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7016),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7017),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4615),
  [1866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [1868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [1872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4625),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [1880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [1882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3644),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4520),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [1892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [1894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5454),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5455),
  [1898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5621),
  [1900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7006),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5783),
  [1904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4909),
  [1906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3758),
  [1908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3759),
  [1910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [1912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3821),
  [1914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4388),
  [1916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [1918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [1920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5408),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5629),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5618),
  [1926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7465),
  [1928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4871),
  [1930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3992),
  [1932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3993),
  [1934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [1936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3086),
  [1942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [1944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4561),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3121),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6292),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4646),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4710),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4792),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6140),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4588),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4580),
  [1968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3271),
  [1972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1, 0, 0),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2490),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [1982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3076),
  [1984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3326),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [1988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [1990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [1992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [1994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4524),
  [1996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [1998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4523),
  [2000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [2002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [2004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2954),
  [2010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [2012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [2014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [2016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [2018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [2020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5072),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [2028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [2030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1, 0, 0),
  [2032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0), REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [2045] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0), REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0), SHIFT(4024),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4526),
  [2051] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0), REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0), SHIFT(3726),
  [2055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0),
  [2057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, 0, 5),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, 0, 5),
  [2063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7227),
  [2065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7281),
  [2067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2, 0, 0),
  [2069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2, 0, 0),
  [2071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2, 0, 0),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [2075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2, 0, 0),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3597),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [2083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 175),
  [2085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 5, 0, 175),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 5, 0, 175),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7329),
  [2095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2, 0, 0),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3853),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3983),
  [2103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, 0, 45),
  [2105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 45),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [2109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 45),
  [2111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3, 0, 0),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3, 0, 0),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7295),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7296),
  [2125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3, 0, 105),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3, 0, 105),
  [2129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 233),
  [2131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, 0, 233),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [2135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, 0, 233),
  [2137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, 0, 227),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, 0, 227),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [2143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, 0, 227),
  [2145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2, 0, 0),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2, 0, 0),
  [2149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 0),
  [2151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4040),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2956),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [2163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, 0, 6),
  [2165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, 0, 6),
  [2167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 193),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 193),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 193),
  [2175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, 0, 25),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, 0, 25),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [2181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0),
  [2189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 145),
  [2191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 145),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [2195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 145),
  [2197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 164),
  [2199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 164),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [2203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 164),
  [2205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 192),
  [2207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 192),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [2211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 192),
  [2213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 106),
  [2215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 106),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [2219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 106),
  [2221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4, 0, 0),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4, 0, 0),
  [2225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 107),
  [2227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 107),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 107),
  [2233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3, 0, 83),
  [2235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 83),
  [2237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3, 0, 67),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 67),
  [2241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 123),
  [2243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 4, 0, 123),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 4, 0, 123),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [2251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [2253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [2255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, 0, 175),
  [2257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, 0, 175),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [2261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, 0, 175),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3543),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7330),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [2269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [2271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, 0, 45),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [2275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 145),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [2287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, 0, 227),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2963),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [2303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7138),
  [2309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7137),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [2313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 233),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [2321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [2323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [2325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 107),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [2329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 123),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [2337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [2339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [2343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 164),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [2353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [2355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [2357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, 0, 175),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [2363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [2365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 175),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [2369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5158),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [2373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 193),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4828),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [2381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 192),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [2387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 106),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [2397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [2403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1, 0, 0),
  [2405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_modifier, 1, 0, 0),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [2411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3146),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [2427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [2431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6486),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6486),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [2445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [2447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2961),
  [2449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [2459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [2463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [2465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [2467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4813),
  [2469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [2471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4806),
  [2473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [2475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [2477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [2479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3308),
  [2481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [2483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [2485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [2487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [2491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [2493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [2495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [2497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [2499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [2509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [2513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [2515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [2523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [2525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3354),
  [2529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2710),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [2533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [2541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [2545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [2547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [2551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [2555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [2563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3216),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3350),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3357),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [2627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [2629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3349),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [2641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [2643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3352),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [2653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5724),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [2661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7339),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7336),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [2677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym__property_name, 1, 0, 7),
  [2680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(85),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7334),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7332),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6530),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, 0, 1),
  [2693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym__property_name, 1, 0, 7),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7479),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7379),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7377),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7376),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5597),
  [2716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5595),
  [2718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(3552),
  [2721] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym__property_name, 1, 0, 7), SHIFT(256),
  [2725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(796),
  [2728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4569),
  [2730] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym__property_name, 1, 0, 7), SHIFT(5783),
  [2734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4582),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3427),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7241),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4565),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6655),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5899),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5898),
  [2754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7410),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7471),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7089),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7472),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6390),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7082),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7083),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6163),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6162),
  [2792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7194),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7454),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7237),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7455),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6687),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7242),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7239),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5862),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5859),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7435),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7476),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7148),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7477),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6356),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7434),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7143),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7144),
  [2862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6024),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6022),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7347),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7461),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7038),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7462),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6489),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7346),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7045),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7044),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4807),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3422),
  [2904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [2906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [2908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3532),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7355),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6458),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7441),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6372),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7418),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6638),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7216),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6623),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7390),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7466),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7023),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7467),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6449),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7381),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6847),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7016),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7017),
  [2966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7069),
  [2968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7071),
  [2970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(256),
  [2973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4501),
  [2975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(5783),
  [2978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7172),
  [2980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7218),
  [2982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7261),
  [2984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7263),
  [2986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4559),
  [2988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4536),
  [2990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7100),
  [2992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7101),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4586),
  [2996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4612),
  [2998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4589),
  [3000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7289),
  [3002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7284),
  [3004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7322),
  [3006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7321),
  [3008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, 0, 11),
  [3010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6194),
  [3012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6580),
  [3014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7205),
  [3016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7203),
  [3018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6995),
  [3020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6994),
  [3022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4608),
  [3024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5935),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6951),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, 0, 11),
  [3030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5648),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6933),
  [3034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7202),
  [3036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7200),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [3044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7276),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [3048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5959),
  [3050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6973),
  [3052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 42),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [3064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7277),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [3070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 34),
  [3072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [3074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 4, 0, 100),
  [3076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [3082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [3084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [3090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [3092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7309),
  [3094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, 0, 241),
  [3096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7306),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [3100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, 0, 272),
  [3102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, 0, 11),
  [3104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [3110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [3112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7285),
  [3114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7286),
  [3116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, 0, 94),
  [3118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, 0, 94),
  [3120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 42),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [3126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7420),
  [3128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 43),
  [3130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, 0, 179),
  [3132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [3134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 123),
  [3136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 41),
  [3138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, 0, 174),
  [3140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, 0, 0),
  [3142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 175),
  [3144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4, 0, 33),
  [3146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 35),
  [3148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, 0, 30),
  [3150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 107),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 106),
  [3158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5, 0, 0),
  [3160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, 0, 150),
  [3162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, 0, 0),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [3166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, 0, 29),
  [3168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2, 0, 0),
  [3170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, 0, 0),
  [3172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, 0, 148),
  [3174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 144),
  [3176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2, 0, 0),
  [3178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 140),
  [3180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 139),
  [3182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, 0, 136),
  [3186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, 0, 241),
  [3188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, 0, 122),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [3192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, -1, 23),
  [3194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 45),
  [3196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, 0, 91),
  [3198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 81),
  [3200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, 0, 272),
  [3202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 0),
  [3204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 82),
  [3206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 34),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [3210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, 0, 79),
  [3212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, 0, 234),
  [3214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, 0, 66),
  [3216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 193),
  [3218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, 0, 65),
  [3220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3, 0, 0),
  [3222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3, 0, 0),
  [3224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 0),
  [3226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, 0, 44),
  [3228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4, 0, 0),
  [3230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5, 0, 0),
  [3232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6, 0, 0),
  [3234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, 0, 44),
  [3236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2, 0, 0),
  [3238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3, 0, 33),
  [3240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 4, 0, 100),
  [3244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [3248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 11),
  [3250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, 0, 36),
  [3254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7417),
  [3258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 183),
  [3260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3, 0, 0),
  [3262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, 0, 57),
  [3264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 87),
  [3266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, 0, 0),
  [3268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, 0, 191),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 81),
  [3274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, 0, 180),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [3278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 29),
  [3280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 145),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [3284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, 0, 268),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [3288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 92),
  [3290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2, 0, 0),
  [3292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, 0, 0),
  [3294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, 0, 21),
  [3296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, 0, 6),
  [3300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, 0, 195),
  [3302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2, 0, 0),
  [3304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 233),
  [3306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, 0, 93),
  [3308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, 0, 197),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [3312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, 0, 232),
  [3314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, 0, 230),
  [3316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, 0, 4),
  [3318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, 0, 267),
  [3320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [3322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, 0, 227),
  [3324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 164),
  [3326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 240),
  [3328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, 0, 235),
  [3330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, 0, 11),
  [3332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 202),
  [3334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 6, 0, 148),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [3338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, 0, 175),
  [3340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, 0, 228),
  [3342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 57),
  [3344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 230),
  [3346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 101),
  [3348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 100),
  [3350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3, 0, 0),
  [3352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 0),
  [3354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [3356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 81),
  [3358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 0),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [3364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 232),
  [3366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 87),
  [3368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 148),
  [3370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 192),
  [3372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 45),
  [3374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 148),
  [3376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 87),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, 0, 44),
  [3384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 29),
  [3386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 0),
  [3388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5, 0, 0),
  [3390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, 0, 44),
  [3392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, 0, 0),
  [3394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, 0, 148),
  [3396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 144),
  [3398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 43),
  [3400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 81),
  [3402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 41),
  [3404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [3408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, 0, 180),
  [3410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, 0, 36),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [3414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [3416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 35),
  [3418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3, 0, 33),
  [3420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3, 0, 0),
  [3422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 0),
  [3424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, 0, 30),
  [3426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 100),
  [3428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, 0, 0),
  [3430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 106),
  [3432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, 0, 29),
  [3434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [3436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 107),
  [3438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2, 0, 0),
  [3440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 81),
  [3442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 140),
  [3444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, 0, 0),
  [3446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 0),
  [3448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, -1, 23),
  [3450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 87),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, 0, 21),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [3456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 139),
  [3458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, 0, 174),
  [3460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 0),
  [3462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3, 0, 0),
  [3464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, 0, 65),
  [3466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4, 0, 33),
  [3468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, 0, 91),
  [3470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 123),
  [3472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, 0, 66),
  [3474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, 0, 136),
  [3476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, 0, 179),
  [3478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 92),
  [3480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 183),
  [3482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 57),
  [3484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 0),
  [3486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, 0, 93),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, 0, 6),
  [3492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2, 0, 0),
  [3494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2, 0, 0),
  [3498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, 0, 11),
  [3504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, 0, 122),
  [3506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6, 0, 0),
  [3508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5, 0, 0),
  [3510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, 0, 191),
  [3512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 145),
  [3514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 101),
  [3516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, 0, 195),
  [3518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4, 0, 0),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [3522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 81),
  [3524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, 0, 197),
  [3526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 6, 0, 148),
  [3528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 202),
  [3530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 0),
  [3532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 164),
  [3534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 82),
  [3536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, 0, 150),
  [3538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, 0, 4),
  [3540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3, 0, 0),
  [3542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2, 0, 0),
  [3544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 175),
  [3546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, 0, 175),
  [3548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, 0, 268),
  [3550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, 0, 228),
  [3552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 57),
  [3554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 230),
  [3556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 0),
  [3558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 232),
  [3560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 192),
  [3562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 233),
  [3564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, 0, 232),
  [3566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, 0, 230),
  [3568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, 0, 267),
  [3570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2, 0, 0),
  [3572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [3574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, 0, 227),
  [3576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 240),
  [3578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, 0, 235),
  [3580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, 0, 79),
  [3582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, 0, 234),
  [3584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 193),
  [3586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [3588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [3590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3963),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7345),
  [3594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4247),
  [3596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [3598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7415),
  [3600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7019),
  [3604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [3606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7372),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [3610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7221),
  [3612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3717),
  [3614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [3616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3767),
  [3618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 7, 0, 271),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [3622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, 0, 200),
  [3624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3972),
  [3626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4266),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3969),
  [3630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, 0, 201),
  [3632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, 0, 239),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4199),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3689),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3608),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3676),
  [3646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3829),
  [3648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [3650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4297),
  [3652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [3654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4451),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4298),
  [3658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [3662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5494),
  [3664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5495),
  [3666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5606),
  [3668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [3670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [3672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7297),
  [3674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4050),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [3678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4286),
  [3680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4053),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [3684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [3686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7426),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3817),
  [3690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7300),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7310),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3757),
  [3698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3957),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3801),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3661),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [3706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2702),
  [3708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2752),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4278),
  [3712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5298),
  [3714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5300),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5858),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [3720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3653),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5295),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3671),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5292),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5277),
  [3730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4235),
  [3732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [3734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [3736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [3738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5867),
  [3740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5871),
  [3742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3841),
  [3744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4243),
  [3746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4252),
  [3748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3670),
  [3750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2763),
  [3752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [3754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3840),
  [3756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4274),
  [3758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3847),
  [3760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5876),
  [3762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5875),
  [3764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3668),
  [3766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5873),
  [3768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3843),
  [3770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3845),
  [3772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3848),
  [3774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3657),
  [3776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [3778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [3780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [3782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5289),
  [3784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4256),
  [3786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [3788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [3790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [3792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4413),
  [3794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [3796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [3798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [3800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5637),
  [3802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [3804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [3806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7000),
  [3808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [3810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5176),
  [3812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [3814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [3816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [3818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [3820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7398),
  [3822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3824),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6993),
  [3826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [3828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6999),
  [3830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [3832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2885),
  [3834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [3836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4370),
  [3838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2886),
  [3840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [3842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [3844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5584),
  [3846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [3848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [3850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7333),
  [3852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [3854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5196),
  [3856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2890),
  [3858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [3860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [3862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [3864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7231),
  [3866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3816),
  [3868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7335),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [3872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7338),
  [3874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3961),
  [3876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [3878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [3880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2757),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [3884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2605),
  [3886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [3888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [3892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [3894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3822),
  [3896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7003),
  [3898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3980),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [3902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2567),
  [3904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [3906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [3908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [3910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7201),
  [3912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3675),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3926),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [3918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [3920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [3922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3805),
  [3924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [3926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [3928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [3930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3061),
  [3932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3155),
  [3934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3965),
  [3936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [3938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [3940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2393),
  [3942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3808),
  [3944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [3946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [3948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [3952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3164),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3929),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3169),
  [3960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [3962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3827),
  [3964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [3968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2589),
  [3970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3158),
  [3972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3157),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3186),
  [3976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2664),
  [3978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2875),
  [3980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3051),
  [3982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3921),
  [3984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [3986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [3988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [3990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3802),
  [3992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [3994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [3996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2610),
  [3998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3154),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [4002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [4004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3998),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [4012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5420),
  [4016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5419),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4095),
  [4020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [4022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [4024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5604),
  [4026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5601),
  [4028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4308),
  [4030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2779),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3735),
  [4036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3830),
  [4038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4794),
  [4040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3988),
  [4042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3942),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4284),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [4048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2339),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [4052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [4056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2754),
  [4058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [4060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4064),
  [4062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [4064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_object_repeat1, 1, 0, 0), REDUCE(aux_sym_object_pattern_repeat1, 1, 0, 0),
  [4067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [4069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3920),
  [4071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [4073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2792),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [4077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3269),
  [4079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3268),
  [4081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [4083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5507),
  [4085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5509),
  [4087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5074),
  [4089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [4091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5523),
  [4093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5570),
  [4095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [4097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5537),
  [4099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5538),
  [4101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5490),
  [4105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5491),
  [4107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [4109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [4111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5518),
  [4113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5519),
  [4115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [4117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5475),
  [4119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5476),
  [4121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4048),
  [4123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5737),
  [4125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 68),
  [4127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 68),
  [4129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 70),
  [4131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 70),
  [4133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, 0, 142),
  [4135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, 0, 142),
  [4137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [4139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [4141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [4143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 0),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [4147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 0),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6543),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6201),
  [4155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, 0, 0),
  [4157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6562),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [4165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [4167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [4169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 7),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [4174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 7),
  [4177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, 0, 189),
  [4179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, 0, 189),
  [4181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 67),
  [4183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 67),
  [4185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 69),
  [4187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 69),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4329),
  [4191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2, 0, 0),
  [4193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2, 0, 0),
  [4195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(699),
  [4198] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_pattern, 1, -1, 0), REDUCE(sym__primary_type, 1, 0, 48),
  [4202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 48),
  [4204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 48),
  [4207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(7369),
  [4210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 48),
  [4213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(1655),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [4220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(7246),
  [4223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(1650),
  [4226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 48), SHIFT(6629),
  [4229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [4239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 20),
  [4241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 20), SHIFT(4049),
  [4244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 20), SHIFT_REPEAT(6128),
  [4247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2, 0, 0),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [4251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7343),
  [4253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, 0, 0),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, 0, 0),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6431),
  [4261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(283),
  [4264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_pattern, 1, -1, 0),
  [4267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0),
  [4269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_predefined_type, 1, 0, 0),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [4274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_predefined_type, 1, 0, 0),
  [4277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, 0, 28),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [4281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_pattern, 1, -1, 1),
  [4284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(779),
  [4287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0),
  [4289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), REDUCE(sym__primary_type, 1, 0, 48),
  [4292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 1),
  [4294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [4298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [4302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4306] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 48), REDUCE(sym_rest_pattern, 2, 0, 0),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5716),
  [4312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, 0, 67),
  [4314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5660),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [4318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5678),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5811),
  [4326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, 0, 14),
  [4328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 68),
  [4330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 67),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [4336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_rest_pattern, 2, 0, 28),
  [4339] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_predefined_type, 1, 0, 0), REDUCE(sym_rest_pattern, 2, 0, 28),
  [4343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 0),
  [4345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2, 0, 0),
  [4347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, 0, 2),
  [4349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4, 0, 0),
  [4351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(540),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [4362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5694),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [4366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_rest_pattern, 2, 0, 0),
  [4369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(691),
  [4372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [4376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3966),
  [4378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [4380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3591),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [4384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [4386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [4388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [4390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3975),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [4394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [4396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3202),
  [4398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3338),
  [4400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3265),
  [4402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [4404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [4406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [4408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [4410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4192),
  [4414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [4416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [4418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [4420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [4426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [4428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [4432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [4434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3658),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [4450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [4452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [4454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [4456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3669),
  [4458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [4460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [4462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [4464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4017),
  [4468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [4472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [4474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [4476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [4484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [4486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4011),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3984),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4138),
  [4498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4135),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4128),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5931),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7382),
  [4512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2208),
  [4515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2583),
  [4518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [4522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2474),
  [4525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(3206),
  [4528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2916),
  [4531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2465),
  [4534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(3966),
  [4537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(3555),
  [4540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20),
  [4542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(3425),
  [4545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(525),
  [4548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(5408),
  [4551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(5629),
  [4554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(2959),
  [4557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(7003),
  [4560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(3980),
  [4563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(5893),
  [4566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(2390),
  [4569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(2917),
  [4572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(3227),
  [4575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(2580),
  [4578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(3266),
  [4581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(3265),
  [4584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 20), SHIFT_REPEAT(3473),
  [4587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [4589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [4591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3425),
  [4593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2959),
  [4595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5893),
  [4597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [4599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [4601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [4603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2580),
  [4605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3266),
  [4607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3473),
  [4609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4213),
  [4611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [4613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [4615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2946),
  [4617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [4619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2947),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3222),
  [4623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3325),
  [4625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3327),
  [4627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [4629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [4631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6877),
  [4633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4269),
  [4635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3176),
  [4637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [4639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [4641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3178),
  [4643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3200),
  [4645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3313),
  [4647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [4649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4510),
  [4651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [4653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [4655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [4657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4230),
  [4659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [4661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3048),
  [4663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2843),
  [4665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [4667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3234),
  [4669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [4671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [4673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [4675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [4677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4531),
  [4679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4074),
  [4681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3333),
  [4683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2919),
  [4685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2830),
  [4687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3135),
  [4689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3263),
  [4691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3312),
  [4693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [4695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [4697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [4699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [4701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [4703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [4705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [4707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4291),
  [4709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2582),
  [4711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2951),
  [4713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2905),
  [4715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2974),
  [4717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [4719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3307),
  [4721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3347),
  [4723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [4725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [4727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [4729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6839),
  [4731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [4733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [4735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [4737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4217),
  [4739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3275),
  [4741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [4743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2842),
  [4745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [4747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [4749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [4751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [4753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [4755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [4757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2394),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4264),
  [4761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2553),
  [4763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2904),
  [4767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2926),
  [4769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3201),
  [4771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3310),
  [4773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [4775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [4777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [4779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [4781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2525),
  [4783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [4787] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), REDUCE(aux_sym_object_repeat1, 2, 0, 26), REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 27),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6883),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [4797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 12),
  [4799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 12),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6619),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [4807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 48),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7021),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [4813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 111),
  [4815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 111),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6881),
  [4819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4539),
  [4821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [4823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3208),
  [4825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3295),
  [4827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [4829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3395),
  [4831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [4833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 76),
  [4835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 76),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6882),
  [4839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [4841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 49),
  [4843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 49),
  [4845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 2, 0, 115),
  [4847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 2, 0, 115),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7042),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7040),
  [4855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 0),
  [4857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 0),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [4861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instantiation_expression, 2, 0, 16),
  [4863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instantiation_expression, 2, 0, 16),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4818),
  [4867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [4869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 0),
  [4871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asserts, 2, 0, 0),
  [4873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 2, 0, 0),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [4877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 295),
  [4879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 295),
  [4881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 0),
  [4883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 0),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [4887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [4893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [4897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5802),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [4905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [4909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [4913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [4925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [4937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0),
  [4939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2, 0, 0),
  [4941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(216),
  [4944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 64),
  [4946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 64),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [4950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_satisfies_expression, 3, 0, 0),
  [4952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_satisfies_expression, 3, 0, 0),
  [4954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [4956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [4960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2, 0, 0),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [4964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 294),
  [4966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 294),
  [4968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, 0, 24),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [4972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1, 0, 0),
  [4974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1, 0, 0),
  [4976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, 0, 75),
  [4978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8),
  [4980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 8),
  [4982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(216),
  [4985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, 0, 64),
  [4987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 77),
  [4989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 77),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [4993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, 0, 266),
  [4995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, 0, 266),
  [4997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 112),
  [4999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 112),
  [5001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2, 0, 0),
  [5003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2, 0, 0),
  [5005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2, 0, 0),
  [5007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2, 0, 0),
  [5009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, 0, 265),
  [5011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, 0, 265),
  [5013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [5015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [5017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 264),
  [5019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 264),
  [5021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 263),
  [5023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 263),
  [5025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2, 0, 0),
  [5027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2, 0, 0),
  [5029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, 0, 8),
  [5031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, 0, 8),
  [5033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 262),
  [5035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 262),
  [5037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 142),
  [5039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 142),
  [5041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 2, 0, 0),
  [5043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 2, 0, 0),
  [5045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, 0, 89),
  [5047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, 0, 89),
  [5049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, 0, 190),
  [5051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, 0, 190),
  [5053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8),
  [5055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 8),
  [5057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(216),
  [5060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 226),
  [5062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 226),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [5066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 113),
  [5068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 113),
  [5070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4, 0, 0),
  [5072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4, 0, 0),
  [5074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2, 0, 0),
  [5076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2, 0, 0),
  [5078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 4, 0, 114),
  [5080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 4, 0, 114),
  [5082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2, 0, 0),
  [5084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2, 0, 0),
  [5086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4, 0, 225),
  [5088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4, 0, 225),
  [5090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [5092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [5094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 187),
  [5096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 187),
  [5098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 186),
  [5100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 186),
  [5102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 224),
  [5104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 224),
  [5106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 76),
  [5108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 76),
  [5110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 223),
  [5112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 223),
  [5114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, 0, 114),
  [5116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, 0, 114),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [5120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2, 0, 0),
  [5122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2, 0, 0),
  [5124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 185),
  [5126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 185),
  [5128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 184),
  [5130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 184),
  [5132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3538),
  [5134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [5136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2208),
  [5139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(3206),
  [5142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [5144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2992),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [5148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3252),
  [5150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 116),
  [5152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 116),
  [5154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 77),
  [5156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 77),
  [5158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 68),
  [5160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 68),
  [5162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 296),
  [5164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 296),
  [5166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 67),
  [5168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 67),
  [5170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 22),
  [5172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 14),
  [5174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 14),
  [5176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, 0, 14),
  [5178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, 0, 14),
  [5180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, 0, 188),
  [5182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2916),
  [5185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 64), SHIFT(216),
  [5188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, 0, 0),
  [5190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, 0, 0),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7240),
  [5194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, 0, 63),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [5198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 167),
  [5200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 167),
  [5202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, 0, 141),
  [5204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, 0, 141),
  [5206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 168),
  [5208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 168),
  [5210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [5212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [5214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_expression_repeat1, 2, 0, 0),
  [5216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, 0, 169),
  [5218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, 0, 169),
  [5220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 170),
  [5222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 170),
  [5224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, 0, 318),
  [5226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, 0, 318),
  [5228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 6, 0, 298),
  [5230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 6, 0, 298),
  [5232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3, 0, 0),
  [5234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3, 0, 0),
  [5236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3, 0, 0),
  [5238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3, 0, 0),
  [5240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [5242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [5244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, 0, 118),
  [5246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 297),
  [5248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 297),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7280),
  [5254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, 0, 171),
  [5256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, 0, 171),
  [5258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 67), REDUCE(sym_nested_type_identifier, 3, 0, 171),
  [5261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 83), REDUCE(sym_nested_type_identifier, 3, 0, 171),
  [5264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, 0, 120),
  [5266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 172),
  [5268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 172),
  [5270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, 0, 121),
  [5272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3, 0, 0),
  [5274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 4, 0, 125),
  [5276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 4, 0, 126),
  [5278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 76),
  [5280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 76),
  [5282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 77),
  [5284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 77),
  [5286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3, 0, 0),
  [5288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3, 0, 0),
  [5290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [5292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [5294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3, 0, 0),
  [5296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3, 0, 0),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7279),
  [5300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 62),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [5304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0),
  [5306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [5310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 3, 0, 0),
  [5312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 3, 0, 0),
  [5314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2474),
  [5317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2583),
  [5320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2, 0, 0),
  [5322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [5324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2, 0, 0),
  [5326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [5329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [5332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, 0, 50),
  [5334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, 0, 50),
  [5336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2465),
  [5339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 55),
  [5341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 55),
  [5343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [5346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [5349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [5351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [5353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 77),
  [5355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 77),
  [5357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 76),
  [5359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 76),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [5363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 5, -1, 178),
  [5365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 5, -1, 178),
  [5367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, 0, 11),
  [5369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, 0, 11),
  [5371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [5373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [5375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2950),
  [5377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2949),
  [5379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3233),
  [5381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(6696),
  [5384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 54),
  [5386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 54),
  [5388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [5392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [5396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6665),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [5406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [5410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [5414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [5416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [5422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [5426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [5440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [5442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [5444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [5446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3, 0, 0),
  [5448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3, 0, 0),
  [5450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 3, 0, 53),
  [5452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 3, 0, 53),
  [5454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [5456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [5462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [5466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [5470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [5472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [5478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [5480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [5482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [5490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 3, -1, 57),
  [5492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 3, -1, 57),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [5502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 52),
  [5504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 52),
  [5506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 51),
  [5508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 51),
  [5510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 3, -1, 61),
  [5512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 3, -1, 61),
  [5514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 64), SHIFT(211),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [5519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2, 0, 0),
  [5521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2, 0, 0),
  [5523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_string, 2, 0, 0), REDUCE(sym_template_literal_type, 2, 0, 0),
  [5526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_string, 2, 0, 0), REDUCE(sym_template_literal_type, 2, 0, 0),
  [5529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, 0, 143),
  [5531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, 0, 143),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [5537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3, 0, 0),
  [5539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3, 0, 0),
  [5541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_closing_element, 3, 0, 57),
  [5543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_closing_element, 3, 0, 57),
  [5545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_closing_element, 3, 0, 61),
  [5547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_closing_element, 3, 0, 61),
  [5549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(209),
  [5552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 4, -1, 130),
  [5554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 4, -1, 130),
  [5556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 4, -1, 135),
  [5558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 4, -1, 135),
  [5560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 4, -1, 134),
  [5562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 4, -1, 134),
  [5564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 146),
  [5566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 146),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [5572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 147),
  [5574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 147),
  [5576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, 0, 0),
  [5578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, 0, 0),
  [5580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(209),
  [5583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, 0, 63),
  [5585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(209),
  [5588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 4, -1, 132),
  [5590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 4, -1, 132),
  [5592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, 0, 127),
  [5594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, 0, 127),
  [5596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 124),
  [5598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 124),
  [5600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, 0, 119),
  [5602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, 0, 119),
  [5604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, 0, 121),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [5608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 194),
  [5610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 194),
  [5612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, 0, 120),
  [5614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 84),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4952),
  [5618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 4, 0, 119),
  [5620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 4, 0, 119),
  [5622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 71),
  [5624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 71),
  [5626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 117),
  [5628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 117),
  [5630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, 0, 26),
  [5632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, 0, 27),
  [5634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, 0, 26),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [5640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 62), REDUCE(sym_assignment_expression, 3, 0, 62),
  [5643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 62),
  [5645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 84), REDUCE(sym_assignment_expression, 3, 0, 62),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7421),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [5652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 84), REDUCE(sym_assignment_expression, 3, 0, 22),
  [5655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, 0, 118),
  [5657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, 0, 26), REDUCE(sym_object_pattern, 3, 0, 27),
  [5660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, 0, 0),
  [5662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, 0, 0),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6519),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [5672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, 0, 173),
  [5674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, 0, 173),
  [5676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 5, -1, 177),
  [5678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 5, -1, 177),
  [5680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_pattern, 2, 0, 0),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6517),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6510),
  [5687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4, 0, 0),
  [5689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4, 0, 0),
  [5691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, 0, 24),
  [5693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 2, 0, 17),
  [5695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 2, 0, 17),
  [5697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 2, 0, 17),
  [5699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 2, 0, 17),
  [5701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [5703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_closing_tag, 1, 0, 0),
  [5705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_closing_tag, 1, 0, 0),
  [5707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 15),
  [5709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 15),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [5713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, 0, 0),
  [5715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, 0, 0),
  [5717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, 0, 26),
  [5719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, 0, 26),
  [5721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2, 0, 0),
  [5723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 80),
  [5725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 80),
  [5727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(211),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [5732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 2, -1, 0),
  [5734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 2, -1, 0),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6529),
  [5738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, 0, 75),
  [5740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 3, 0, 74),
  [5742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 3, 0, 74),
  [5744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_array_pattern, 2, 0, 0),
  [5747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_closing_element, 2, 0, 0),
  [5749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_closing_element, 2, 0, 0),
  [5751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 64), SHIFT(209),
  [5754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 3, 0, 73),
  [5756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 3, 0, 73),
  [5758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 72),
  [5760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 72),
  [5762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, 0, 88),
  [5764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, 0, 88), SHIFT(659),
  [5767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(211),
  [5770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(211),
  [5773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 49),
  [5776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 49),
  [5779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_literal_type, 1, 0, 0),
  [5782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_literal_type, 1, 0, 0),
  [5785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6766),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6817),
  [5791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [5793] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_array_pattern, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [5801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3289),
  [5803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3294),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3567),
  [5807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2, 0, 0),
  [5809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, 0, 27),
  [5811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [5813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [5819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [5823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [5827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [5829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [5835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [5839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [5853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__extends_clause_single, 1, 0, 46),
  [5855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [5857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3302),
  [5859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3304),
  [5861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [5863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, 0, 62),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [5867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(208),
  [5870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(208),
  [5873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(208),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5275),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5546),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6970),
  [5900] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), REDUCE(aux_sym_object_repeat1, 2, 0, 26), REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 27),
  [5904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [5906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [5918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 64), SHIFT(208),
  [5921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [5923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [5925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [5931] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_pattern, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [5935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [5947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [5949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [5957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [5961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [5965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [5967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [5973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [5977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [5985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [5987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [5989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [5991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [5993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [5997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [6001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [6003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [6007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [6011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3535),
  [6013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2990),
  [6015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2988),
  [6017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3257),
  [6019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [6021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [6025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3573),
  [6027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3276),
  [6029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3278),
  [6031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3571),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [6043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3558),
  [6045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2965),
  [6047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [6049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [6053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, 0, 37),
  [6055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, 0, 37),
  [6057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 49), REDUCE(sym__parameter_name, 2, 0, 37),
  [6060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5173),
  [6062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2942),
  [6064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5071),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [6070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [6074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [6080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 85),
  [6082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 64), SHIFT(214),
  [6085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4886),
  [6087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4527),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6978),
  [6091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(215),
  [6094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 64), SHIFT(215),
  [6097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3556),
  [6099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2997),
  [6101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2939),
  [6103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3197),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6684),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6860),
  [6113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [6121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3273),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [6127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1, 0, 9),
  [6129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__parameter_name, 1, 0, 9),
  [6132] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__parameter_name, 1, 0, 9), REDUCE(sym__primary_type, 1, 0, 49),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6535),
  [6138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(214),
  [6141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [6144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(214),
  [6147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [6154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(214),
  [6157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3565),
  [6159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [6161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3220),
  [6163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3566),
  [6165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, 0, 9),
  [6167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, 0, 9), REDUCE(sym__primary_type, 1, 0, 49),
  [6170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [6174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3296),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3297),
  [6178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [6180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(215),
  [6183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3589),
  [6185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3185),
  [6187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3240),
  [6189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3547),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [6193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [6195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [6197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(215),
  [6200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3544),
  [6202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [6204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3141),
  [6206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3230),
  [6208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, 0, 37),
  [6210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, 0, 37),
  [6212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [6214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3564),
  [6216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3588),
  [6218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3458),
  [6220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__extends_clause_single, 2, 0, 108),
  [6222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3454),
  [6224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 14),
  [6226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [6228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [6230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [6236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [6240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [6242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [6244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [6246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [6252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [6256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5249),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [6268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3443),
  [6270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3560),
  [6272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [6274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3196),
  [6276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5608),
  [6278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_object_pattern_repeat1, 1, 0, 0),
  [6280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3456),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [6284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [6286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [6294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [6298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [6302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [6304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [6310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [6314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [6322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, 0, 40),
  [6324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, 0, 40),
  [6326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3452),
  [6328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, 0, 99),
  [6330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, 0, 99),
  [6332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3593),
  [6334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [6336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [6338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6498),
  [6344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [6346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3125),
  [6348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3249),
  [6350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, 0, 95),
  [6352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, 0, 95),
  [6354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [6356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3439),
  [6358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2977),
  [6360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4403),
  [6362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [6364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6459),
  [6366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3267),
  [6368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3250),
  [6370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3274),
  [6372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3335),
  [6374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3380),
  [6376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3372),
  [6378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3451),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [6382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3579),
  [6384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3448),
  [6386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(213),
  [6389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(213),
  [6392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(213),
  [6395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3584),
  [6397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3447),
  [6399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [6401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2920),
  [6403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3211),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6633),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6640),
  [6409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3450),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [6413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 0),
  [6416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 0),
  [6418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 0),
  [6421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 0),
  [6423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, 0, 88), SHIFT(710),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6843),
  [6428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 5, 0, 203),
  [6430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 5, 0, 203),
  [6432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 64), SHIFT(213),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6669),
  [6439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [6443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3572),
  [6445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3156),
  [6447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [6449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_array_pattern, 2, 0, 0),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [6458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(212),
  [6461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3583),
  [6463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3459),
  [6465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3136),
  [6467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3251),
  [6469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 64), SHIFT(212),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [6474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(212),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [6479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(212),
  [6482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [6484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3018),
  [6486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [6490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [6492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [6496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, 0, 153),
  [6498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, 0, 153),
  [6500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3455),
  [6502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, 0, 155),
  [6504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, 0, 155),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [6508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3578),
  [6510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [6512] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_literal_type, 1, 0, 0), REDUCE(sym_rest_pattern, 2, 0, 0),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6914),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6916),
  [6520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3, 0, 0), REDUCE(sym_computed_property_name, 3, 0, 0),
  [6523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3, 0, 0),
  [6525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3, 0, 0), REDUCE(sym_computed_property_name, 3, 0, 0),
  [6528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_computed_property_name, 3, 0, 0),
  [6530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, 0, 26), REDUCE(sym_object_pattern, 3, 0, 27),
  [6533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_pattern, 2, 0, 0),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6984),
  [6538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6985),
  [6540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3592),
  [6542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3026),
  [6544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3238),
  [6546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3434),
  [6548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [6550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [6554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [6556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [6560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [6564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [6566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [6572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [6576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [6584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(210),
  [6587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_object_repeat1, 2, 0, 26), REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 27),
  [6590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(210),
  [6593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(210),
  [6596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 64), SHIFT(210),
  [6599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4825),
  [6601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_object_repeat1, 1, 0, 0),
  [6603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [6605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3293),
  [6607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [6609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3353),
  [6611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3417),
  [6613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [6615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6874),
  [6617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, 0, 106), REDUCE(sym_class, 5, 0, 192),
  [6620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, 0, 106), REDUCE(sym_class, 5, 0, 192),
  [6623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3337),
  [6625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, 0, 107), REDUCE(sym_class, 5, 0, 193),
  [6628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, 0, 107), REDUCE(sym_class, 5, 0, 193),
  [6631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [6633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [6635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2938),
  [6637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2894),
  [6639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [6641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3223),
  [6643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [6645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3580),
  [6647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, 0, 52), REDUCE(sym_class, 4, 0, 147),
  [6650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, 0, 52), REDUCE(sym_class, 4, 0, 147),
  [6653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 2, 0, 11), REDUCE(sym_class, 3, 0, 80),
  [6656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 2, 0, 11), REDUCE(sym_class, 3, 0, 80),
  [6659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, 0, 45), REDUCE(sym_class, 4, 0, 145),
  [6662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, 0, 45), REDUCE(sym_class, 4, 0, 145),
  [6665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, 0, 51), REDUCE(sym_class, 4, 0, 146),
  [6668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, 0, 51), REDUCE(sym_class, 4, 0, 146),
  [6671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [6673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, 0, 117), REDUCE(sym_class, 5, 0, 194),
  [6676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, 0, 117), REDUCE(sym_class, 5, 0, 194),
  [6679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [6681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [6683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_object_repeat1, 2, 0, 26),
  [6685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3318),
  [6687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3581),
  [6689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 5, 0, 164), REDUCE(sym_class, 6, 0, 233),
  [6692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 5, 0, 164), REDUCE(sym_class, 6, 0, 233),
  [6695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3328),
  [6697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3570),
  [6699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, 0, 123),
  [6701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, 0, 123),
  [6703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, 0, 175),
  [6705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, 0, 175),
  [6707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, 0, 86),
  [6709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, 0, 86),
  [6711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 10, 0, 335),
  [6713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 10, 0, 335),
  [6715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, 0, 236),
  [6717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, 0, 236),
  [6719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, 0, 269),
  [6721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, 0, 269),
  [6723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, 0, 299),
  [6725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, 0, 299),
  [6727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, 0, 300),
  [6729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, 0, 300),
  [6731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, 0, 151),
  [6733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, 0, 151),
  [6735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, 0, 227),
  [6737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, 0, 227),
  [6739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, 0, 198),
  [6741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, 0, 198),
  [6743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1, 0, 0),
  [6745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1, 0, 0), SHIFT_REPEAT(3431),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [6750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, 0, 320),
  [6752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, 0, 320),
  [6754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3569),
  [6756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [6758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3416),
  [6760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [6762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, 0, 319),
  [6764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, 0, 319),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [6768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, 0, 270),
  [6770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, 0, 270),
  [6772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 103),
  [6774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 103), SHIFT_REPEAT(3419),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [6785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3542),
  [6787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3428),
  [6789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [6791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_static_block, 2, 0, 11),
  [6793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 3, 0, 103),
  [6795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [6797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3587),
  [6799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [6801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_static_block, 3, 0, 51),
  [6803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [6805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 0),
  [6807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3548),
  [6809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3435),
  [6811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [6813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [6815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [6817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3540),
  [6819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [6821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7437),
  [6823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [6825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2901),
  [6827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2896),
  [6829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3497),
  [6831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [6833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [6835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [6837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [6839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [6841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [6843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [6845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [6849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3568),
  [6851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3188),
  [6853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3199),
  [6855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [6857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [6859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [6861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6848),
  [6863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3284),
  [6865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [6867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3586),
  [6869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [6871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [6873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6844),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [6877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [6881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [6883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [6885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6968),
  [6887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6958),
  [6889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [6891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 20), SHIFT_REPEAT(5893),
  [6894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3576),
  [6896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3232),
  [6898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [6900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [6902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [6904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [6906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4995),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [6910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6366),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [6914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5351),
  [6916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [6918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5330),
  [6920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [6922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5076),
  [6924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [6926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5160),
  [6928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [6930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3127),
  [6932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [6934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [6936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3150),
  [6938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3457),
  [6940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3013),
  [6942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [6944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [6946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3098),
  [6948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2976),
  [6950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3341),
  [6952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3306),
  [6954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3348),
  [6956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3332),
  [6958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3329),
  [6960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3346),
  [6962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3343),
  [6964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3344),
  [6966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3321),
  [6968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [6970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3340),
  [6972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [6974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6787),
  [6976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7114),
  [6978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6575),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6133),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6616),
  [6986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6175),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [6992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5810),
  [6994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7307),
  [6996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3793),
  [6998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [7000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3954),
  [7002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1, 0, 0),
  [7004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5748),
  [7006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3811),
  [7008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [7010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4517),
  [7012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [7014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [7016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter, 1, 0, 13),
  [7018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [7020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_parameter, 1, 0, 13), SHIFT(4834),
  [7023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7287),
  [7025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2399),
  [7027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [7029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [7031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5677),
  [7033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3804),
  [7035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3962),
  [7037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5693),
  [7039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3832),
  [7041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3943),
  [7043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5715),
  [7045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3800),
  [7047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3912),
  [7049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3031),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6567),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6624),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6564),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5755),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6408),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6291),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6415),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6289),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5455),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7010),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7475),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7113),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7047),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7109),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7094),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7197),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7093),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7036),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7468),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6417),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7247),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7257),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7141),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7133),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7369),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7214),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7225),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7229),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7232),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [7159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [7163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [7165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, 0, 5),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [7173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [7177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5907),
  [7179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5906),
  [7181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_identifier, 1, 0, 1),
  [7183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 156),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [7189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 214),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [7197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [7201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 161),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [7205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [7211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 212),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [7215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [7217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3951),
  [7219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [7225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 257),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [7229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [7231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 104),
  [7233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [7241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [7245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 57),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [7263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [7265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4044),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [7273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 292),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [7279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [7287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [7289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 251),
  [7291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [7295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3678),
  [7297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_namespace_name, 3, 0, 0),
  [7299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 48), REDUCE(sym_jsx_namespace_name, 3, 0, 0),
  [7302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7246),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [7308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [7310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4762),
  [7312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4763),
  [7314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4954),
  [7316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [7318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5157),
  [7320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 251),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [7324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 212),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [7330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, 0, 5),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [7338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5141),
  [7340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6909),
  [7342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4834),
  [7344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5308),
  [7346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5207),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [7354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, 0, 57),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [7358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 156),
  [7360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [7362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4728),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6577),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [7372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, 0, 251),
  [7374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 156),
  [7376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 161),
  [7378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 251),
  [7380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4831),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7292),
  [7384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4723),
  [7386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 257),
  [7388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 57),
  [7390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, 0, 5),
  [7392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 212),
  [7394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 214),
  [7396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2, 0, 0), SHIFT_REPEAT(411),
  [7399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2, 0, 0), SHIFT_REPEAT(4762),
  [7402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2, 0, 0), SHIFT_REPEAT(4763),
  [7405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2, 0, 0),
  [7407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2, 0, 0), SHIFT_REPEAT(4766),
  [7410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [7412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 156),
  [7414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 104),
  [7416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 57),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [7420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3065),
  [7422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5307),
  [7424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 212),
  [7426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 292),
  [7428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 5),
  [7430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 48), SHIFT(6629),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [7435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6407),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6293),
  [7443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [7445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5921),
  [7447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4058),
  [7449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7062),
  [7451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7055),
  [7453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4535),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [7457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5551),
  [7459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5128),
  [7461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7178),
  [7463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5827),
  [7465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4141),
  [7467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [7469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [7471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [7475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4276),
  [7477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2, 0, 0),
  [7479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4101),
  [7481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4250),
  [7483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2, 0, 76),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [7487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [7489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [7491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7351),
  [7493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [7495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 5),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6963),
  [7499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [7501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4272),
  [7503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7007),
  [7505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4212),
  [7507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 19),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [7511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4086),
  [7513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4206),
  [7515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 3),
  [7517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4177),
  [7519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6112),
  [7521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6113),
  [7523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4123),
  [7525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [7527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4292),
  [7529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4106),
  [7531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4151),
  [7533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4114),
  [7535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4223),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [7555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [7559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4, 0, 0),
  [7561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [7563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [7567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4782),
  [7569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, 0, 131), SHIFT_REPEAT(4517),
  [7572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, 0, 131), SHIFT_REPEAT(407),
  [7575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, 0, 131),
  [7577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4695),
  [7579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [7581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4694),
  [7583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3102),
  [7585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [7589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [7591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [7593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [7595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6023),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [7603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [7607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [7611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4465),
  [7623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 184),
  [7625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [7627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 185),
  [7629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [7631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [7633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [7637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6388),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [7641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, 0, 0),
  [7643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, 0, 27),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [7647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6217),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [7651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2, 0, 0),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6450),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [7659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 186),
  [7661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 187),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [7671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2, 0, 76),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6585),
  [7675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 67),
  [7677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 68),
  [7679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 184),
  [7681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 185),
  [7683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 186),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4575),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4551),
  [7699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [7701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [7705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [7707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4785),
  [7709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [7711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4786),
  [7713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [7719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4787),
  [7721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2986),
  [7723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4789),
  [7725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2985),
  [7727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5253),
  [7729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5250),
  [7731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4790),
  [7733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2983),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [7737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4793),
  [7739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2978),
  [7741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6334),
  [7743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4978),
  [7745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4974),
  [7747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4972),
  [7749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5079),
  [7751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4970),
  [7753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4967),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [7759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 285),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [7763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [7765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [7767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 187),
  [7769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [7771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [7773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, 0, 0),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [7791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [7793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, 0, 0),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [7817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4350),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [7825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [7829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [7831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [7835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [7845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [7849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4640),
  [7851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4645),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6532),
  [7859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4668),
  [7861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4677),
  [7863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4755),
  [7865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4687),
  [7867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4689),
  [7869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4698),
  [7871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [7873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [7883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 317),
  [7885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [7889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__destructuring_pattern, 1, 0, 0),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [7893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [7897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [7901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [7903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [7907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [7911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7095),
  [7913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2, 0, 0),
  [7915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_adding_type_annotation, 2, 0, 0),
  [7917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2, 0, 0),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5469),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [7929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7151),
  [7931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7294),
  [7933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7029),
  [7935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3647),
  [7937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7252),
  [7939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4734),
  [7941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4042),
  [7943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3087),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [7947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2, 0, 77),
  [7949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6563),
  [7951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7034),
  [7953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [7955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4045),
  [7957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [7961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [7963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7349),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7348),
  [7971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 141),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [7979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 141),
  [7981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 14),
  [7983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7209),
  [7985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 317),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [7989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2488),
  [7991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_chain, 1, 0, 0),
  [7993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [7995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_chain, 1, 0, 0),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6154),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [8005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7458),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [8009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7464),
  [8011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [8015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, 0, 222),
  [8017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, 0, 221),
  [8019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, 0, 261),
  [8021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3672),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [8031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7469),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [8035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [8041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7474),
  [8043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [8047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3707),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [8051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, 0, 102),
  [8053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2, 0, 166),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [8057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7357),
  [8059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [8063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, 0, 137),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5421),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7354),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [8071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, 0, 137),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4308),
  [8075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, 0, 122),
  [8077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, 0, 160),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [8081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4802),
  [8083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5028),
  [8087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4817),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4941),
  [8093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2, 0, 77),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [8097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, 0, 204),
  [8099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, 0, 174),
  [8101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1, 0, 7),
  [8103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4080),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [8107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 56),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [8111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3598),
  [8113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 13),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [8119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, 0, 242),
  [8121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, 0, 243),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [8125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4824),
  [8127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 26), REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 27),
  [8130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, 0, 277),
  [8132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, 0, 278),
  [8134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 285),
  [8136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [8138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4767),
  [8140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, 0, 302),
  [8142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, 0, 301),
  [8144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(779),
  [8147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, 0, 323),
  [8149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, 0, 328),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5057),
  [8153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4747),
  [8155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 9, 0, 337),
  [8157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2, 0, 0),
  [8159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [8163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [8169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7056),
  [8171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2, 0, 0),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [8175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3, 0, 0),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [8179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4835),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [8183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, 0, 10),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [8187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(699),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [8192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4842),
  [8194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4, 0, 0),
  [8196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [8198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4934),
  [8200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4676),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [8204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4674),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [8208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4660),
  [8210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, 0, 0),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [8214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4656),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [8218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4732),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [8222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4639),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [8226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4637),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5063),
  [8230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4627),
  [8232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [8234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4626),
  [8236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [8242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7444),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7167),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7422),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7394),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7360),
  [8270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6205),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6554),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5107),
  [8280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2146),
  [8283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [8291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 2, 0, 0),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [8295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [8297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [8299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [8303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5014),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [8311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 137),
  [8313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 137),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [8323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [8331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [8333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [8335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [8339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5026),
  [8341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [8343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [8345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4914),
  [8347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [8349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [8351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [8353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [8355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [8357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [8359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [8361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [8363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [8365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [8367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [8369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(712),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5372),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5381),
  [8380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 5, -1, 178),
  [8382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 5, -1, 177),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [8390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5402),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [8394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [8396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, 0, 78),
  [8398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2, 0, 0),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [8404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [8412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts_annotation, 2, 0, 0),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6526),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [8432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [8434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [8438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4928),
  [8444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 2, -1, 0),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6626),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5839),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [8472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(7167),
  [8475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0),
  [8477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(537),
  [8480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6119),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5022),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [8494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 18),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [8498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [8502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [8518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_text, 1, 0, 0),
  [8520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 1, 0, 0),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [8526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3878),
  [8528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4037),
  [8530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4809),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [8542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 20),
  [8544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 20), SHIFT_REPEAT(5692),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [8549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [8551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 3, 0, 0),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [8555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6547),
  [8559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [8561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [8563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7173),
  [8567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, 0, 138),
  [8569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, 0, 138),
  [8571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3850),
  [8573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [8575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4900),
  [8577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, 0, 67),
  [8579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [8581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, -1, 130),
  [8583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, -1, 135),
  [8585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, -1, 134),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [8589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, -1, 132),
  [8591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2, 0, 0),
  [8593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [8599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1, 0, 0),
  [8601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6659),
  [8603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [8605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [8607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5291),
  [8609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6310),
  [8611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [8613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [8617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6431),
  [8619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [8621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [8623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [8627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [8629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5013),
  [8631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [8633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5011),
  [8635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5007),
  [8637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5003),
  [8639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [8641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [8643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 26),
  [8645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [8647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5469),
  [8650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2, 0, 0),
  [8652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2, 0, 0), SHIFT_REPEAT(544),
  [8655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 2, 0, 0),
  [8657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [8659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [8661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [8663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [8665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 3, -1, 61),
  [8667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1, 0, 0),
  [8669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4081),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [8673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [8675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7356),
  [8677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 3, -1, 57),
  [8679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [8681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2, 0, 0),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [8685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, 0, 10),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7442),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7419),
  [8701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [8703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [8705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 331),
  [8707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 291),
  [8709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 287),
  [8711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, 0, 281),
  [8713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, 0, 284),
  [8715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, 0, 321),
  [8717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, 0, 322),
  [8719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, 0, 220),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6164),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7391),
  [8731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 326),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [8745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 32),
  [8747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 313),
  [8749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 316),
  [8751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [8753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 158),
  [8755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [8757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [8761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [8763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 1, 0, 58),
  [8765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 216),
  [8767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [8769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 89),
  [8771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5680),
  [8773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4721),
  [8775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6386),
  [8777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 3), SHIFT(1659),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [8782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 334),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5551),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [8788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [8792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [8796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7159),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [8800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 284),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [8812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 281),
  [8814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, 0, 273),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [8818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, 0, 276),
  [8820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 218),
  [8822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, 0, 275),
  [8824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7413),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7414),
  [8830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__jsx_string, 3, 0, 0),
  [8832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 32),
  [8834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, 0, 110),
  [8836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__jsx_string, 2, 0, 0),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [8840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 138),
  [8842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 138),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7105),
  [8846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 210),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [8850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [8852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [8854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [8856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 208),
  [8858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, 0, 260),
  [8860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 210),
  [8862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 208),
  [8864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2, 0, 0),
  [8866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 340),
  [8868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [8870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, 0, 259),
  [8872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6276),
  [8874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2554),
  [8876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6437),
  [8878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 255),
  [8880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4, 0, 206),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [8884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, 0, 205),
  [8886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 253),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [8892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5971),
  [8894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5083),
  [8896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6969),
  [8898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 245),
  [8900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 3), SHIFT(1776),
  [8903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5387),
  [8905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [8907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 245),
  [8909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [8911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [8917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 19), SHIFT(1658),
  [8920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 249),
  [8922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5, 0, 250),
  [8924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 249),
  [8926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 5, 0, 293),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7175),
  [8932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [8934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6454),
  [8936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6467),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [8940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6071),
  [8942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3148),
  [8944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6846),
  [8946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, 0, 304),
  [8948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, 0, 305),
  [8950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 307),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7027),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [8964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 310),
  [8966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 31),
  [8968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [8974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 3), SHIFT(1665),
  [8977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [8981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [8983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [8987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [8989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [8991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [8993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [8995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [8997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [8999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [9001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [9003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [9005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [9007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [9013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6335),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [9019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6652),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [9023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5317),
  [9025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6735),
  [9035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [9037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 89),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [9041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 158),
  [9043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 3), SHIFT(1770),
  [9046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 19), SHIFT(1664),
  [9049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 163),
  [9051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [9053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [9055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 19), SHIFT(1733),
  [9058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6889),
  [9060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [9062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [9064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [9066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [9068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, 0, 32),
  [9070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [9072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 19), SHIFT(1807),
  [9075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7039),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [9079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2, 0, 0),
  [9081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5835),
  [9083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0),
  [9085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1, 0, 0),
  [9087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2, 0, 0),
  [9089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1752),
  [9092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6164),
  [9095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 76),
  [9097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, 0, 0),
  [9099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2, 0, 0),
  [9101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7150),
  [9103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3, 0, 0),
  [9105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 7, 0, 307),
  [9107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3, 0, 7),
  [9109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6855),
  [9111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3660),
  [9113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [9115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6926),
  [9117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [9119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, 0, 2),
  [9121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [9123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [9125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [9127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [9129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [9131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [9133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [9135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [9137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [9139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [9141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [9143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5781),
  [9145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [9147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, 0, 181),
  [9149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, 0, 181),
  [9151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, 0, 182),
  [9153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, 0, 182),
  [9155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [9157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [9159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [9161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [9163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [9165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [9167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [9169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [9171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [9173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [9175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [9177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [9179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [9181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [9183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6632),
  [9185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [9189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [9191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [9193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [9195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, 0, 165),
  [9197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, 0, 165), SHIFT_REPEAT(524),
  [9200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [9202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [9206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [9208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [9210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [9214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3604),
  [9216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4522),
  [9218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6157),
  [9220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [9222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [9224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [9226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3603),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [9230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [9232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [9234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [9236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6572),
  [9238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [9240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [9242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5842),
  [9244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1, 0, 0),
  [9246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [9248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [9250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [9252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [9254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [9256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [9258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [9260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [9264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [9266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [9270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [9276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [9284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6671),
  [9286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [9288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6074),
  [9290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [9292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [9294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4091),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [9300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4110),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [9304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1, 0, 0), REDUCE(aux_sym_template_literal_type_repeat1, 1, 0, 0),
  [9307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [9309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6635),
  [9311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6796),
  [9313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6801),
  [9315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6806),
  [9317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6823),
  [9319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [9321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [9323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [9325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [9327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [9329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [9331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [9333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [9335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [9337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [9339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [9341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5854),
  [9343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5096),
  [9345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5854),
  [9347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5846),
  [9349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [9351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [9353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [9355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4307),
  [9357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [9359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [9361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 229),
  [9363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 229), SHIFT_REPEAT(5421),
  [9366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 229),
  [9368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [9370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [9372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [9374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [9376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [9378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [9380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [9382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3, 0, 0),
  [9384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [9386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5396),
  [9388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [9390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_export_name, 1, 0, 0),
  [9392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 129),
  [9394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 57),
  [9396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [9398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [9400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [9402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5075),
  [9404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [9406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [9408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [9410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [9414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [9416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [9418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, 0, 109),
  [9420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [9424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6692),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6691),
  [9428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__jsx_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5846),
  [9431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_string_repeat1, 2, 0, 0),
  [9433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__jsx_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5846),
  [9436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6650),
  [9438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [9440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [9442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__jsx_string_repeat2, 2, 0, 0), SHIFT_REPEAT(5854),
  [9445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_string_repeat2, 2, 0, 0),
  [9447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__jsx_string_repeat2, 2, 0, 0), SHIFT_REPEAT(5854),
  [9450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, 0, 97),
  [9452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 5, 0, 274),
  [9454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3674),
  [9456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [9458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [9460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [9462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [9464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6849),
  [9466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [9468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [9470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [9472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(4525),
  [9475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [9477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [9479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [9481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [9483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [9485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [9487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [9489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 27),
  [9491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(612),
  [9494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [9496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [9498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [9500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, 0, 14),
  [9502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0),
  [9504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(5781),
  [9507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5130),
  [9509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 60),
  [9511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, 0, 47),
  [9513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [9515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [9517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [9519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5778),
  [9522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(325),
  [9525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, 0, 39),
  [9527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [9529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [9531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [9533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [9535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [9537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [9539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [9541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7307),
  [9543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [9545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [9547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [9549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [9551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [9553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [9555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [9557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4030),
  [9559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [9561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [9563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 312),
  [9565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 314),
  [9567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 10, 0, 342),
  [9569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [9571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [9573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 315),
  [9575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [9577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [9579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6590),
  [9581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [9583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [9585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 311),
  [9587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6600),
  [9589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [9591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [9593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [9595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6552),
  [9597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6500),
  [9599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [9601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 338),
  [9603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 215),
  [9605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5884),
  [9607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_identifier, 1, 0, 0),
  [9609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [9611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6518),
  [9613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [9615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [9617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5922),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [9621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [9623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [9625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [9627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(691),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6006),
  [9632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [9636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [9644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [9646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [9648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [9650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [9652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [9654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [9656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [9658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [9660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [9662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [9664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [9666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3766),
  [9668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3737),
  [9670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [9672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3762),
  [9674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3741),
  [9676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [9678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3761),
  [9680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3745),
  [9682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [9684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3760),
  [9686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3749),
  [9688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 219),
  [9690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [9692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [9694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [9696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5952),
  [9698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [9700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [9702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 217),
  [9704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [9706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [9708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 1, 0, 0),
  [9710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 1, 0, 0),
  [9712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 1, 0, 0),
  [9714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 1, 0, 0),
  [9716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1, 0, 0),
  [9718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [9720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [9722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 7, 0, 301),
  [9724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 306),
  [9726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 309),
  [9728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 308),
  [9730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [9732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [9734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [9736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 303),
  [9738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6144),
  [9740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [9742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 288),
  [9744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [9746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [9748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [9750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [9752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1603),
  [9755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [9757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 289),
  [9759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [9761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2, 0, 0),
  [9763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 286),
  [9765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [9767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6082),
  [9769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 207),
  [9771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, 0, 174),
  [9773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4976),
  [9775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 1, 0, 5),
  [9777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 213),
  [9779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 3, 0, 0),
  [9781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [9783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6779),
  [9785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 209),
  [9787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [9789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [9791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [9793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [9795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [9797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [9799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, 0, 204),
  [9801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_string_repeat1, 1, 0, 0),
  [9803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__jsx_string_repeat1, 1, 0, 0),
  [9805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6662),
  [9807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 211),
  [9809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_string_repeat2, 1, 0, 0),
  [9811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__jsx_string_repeat2, 1, 0, 0),
  [9813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [9815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 341),
  [9817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 231), SHIFT_REPEAT(3518),
  [9820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 231),
  [9822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [9824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [9826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6367),
  [9828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 290),
  [9830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6286),
  [9832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7135),
  [9834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [9836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6, 0, 237),
  [9838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [9840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [9842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 0), SHIFT_REPEAT(3218),
  [9845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 0),
  [9847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2942),
  [9850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 0),
  [9852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [9854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [9856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_identifier, 1, 0, 1),
  [9858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7122),
  [9860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 339),
  [9862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6864),
  [9864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 329),
  [9866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 324),
  [9868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6683),
  [9870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [9872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [9874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6686),
  [9876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [9878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [9880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6235),
  [9882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [9884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7127),
  [9886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6118),
  [9888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [9890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [9892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 247),
  [9894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 327),
  [9896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [9898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [9900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 244),
  [9902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 246),
  [9904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [9906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 248),
  [9908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [9910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [9912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [9914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [9916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, 0, 242),
  [9918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, 0, 243),
  [9920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2, 0, 0),
  [9922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [9924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [9926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [9928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 325),
  [9930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(290),
  [9933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 252),
  [9935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6634),
  [9937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [9939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 332),
  [9941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 254),
  [9943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 280),
  [9945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 256),
  [9947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 330),
  [9949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [9953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [9957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5695),
  [9959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [9961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [9963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [9965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [9967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [9969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [9971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [9973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [9975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [9977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [9979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, 0, 0),
  [9981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [9983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [9985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [9987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [9991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [9993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [9995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [9997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [9999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2, 0, 0), SHIFT_REPEAT(6671),
  [10002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2, 0, 0),
  [10004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [10006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 333),
  [10008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [10010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(1647),
  [10013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, 0, 29),
  [10015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [10017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 2, 0, 57),
  [10019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, 0, 0),
  [10021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [10023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6217),
  [10025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 77),
  [10027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, 0, 85),
  [10029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [10031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [10033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6729),
  [10041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, 0, 278),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [10045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [10049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6718),
  [10051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [10053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [10055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [10057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6705),
  [10059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6248),
  [10061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6479),
  [10063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 283),
  [10065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [10067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7351),
  [10069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6674),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6699),
  [10073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6426),
  [10075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [10077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6695),
  [10079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6455),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6455),
  [10083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, 0, 277),
  [10085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 89),
  [10087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 90),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [10091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [10093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3715),
  [10095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3624),
  [10097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 282),
  [10099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 1, 0, 0),
  [10101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 279),
  [10103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1715),
  [10106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(270),
  [10109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, 0, 0),
  [10111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [10113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6305),
  [10115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [10117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [10119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [10121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 31),
  [10123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5, 0, 0),
  [10125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [10127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [10129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [10131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [10133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [10135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 1, 0, 0),
  [10137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3, 0, 0),
  [10139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [10141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5901),
  [10143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [10145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3691),
  [10147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3610),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [10151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3700),
  [10153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3618),
  [10155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(6117),
  [10158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0),
  [10160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [10162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [10164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [10166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [10168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [10170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [10172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [10174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [10176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [10178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [10180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [10184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [10186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6977),
  [10188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [10190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [10192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [10194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [10196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [10198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [10200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3716),
  [10202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3630),
  [10204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 258),
  [10206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [10208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [10210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [10212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [10214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [10216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [10218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [10220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, 0, 0),
  [10222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [10224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [10226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4325),
  [10229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, 0, 0),
  [10231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [10233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [10235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [10237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [10239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [10241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [10243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [10245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6074),
  [10247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [10249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [10251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [10253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [10255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6349),
  [10257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, 0, 0), SHIFT_REPEAT(4196),
  [10260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, 0, 0),
  [10262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [10264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [10266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [10268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [10270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [10272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [10274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [10276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [10278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [10280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [10282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [10284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [10286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [10290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [10292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [10294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [10296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [10298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [10300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [10302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5866),
  [10304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [10306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [10308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [10310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, 0, 47),
  [10312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [10314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [10316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3696),
  [10318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3903),
  [10320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [10322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3704),
  [10324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3901),
  [10326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [10328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3694),
  [10330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3876),
  [10332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [10334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3706),
  [10336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3869),
  [10338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 162),
  [10340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [10342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [10344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [10346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [10348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [10350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [10352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6588),
  [10354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 90),
  [10356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [10358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [10360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6829),
  [10362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [10364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [10366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 336),
  [10368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 159),
  [10370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [10372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [10374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 157),
  [10376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [10378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6736),
  [10380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [10382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [10384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [10386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, 0, 122),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [10390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [10392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [10394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [10396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [10398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [10400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [10404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4121),
  [10406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [10408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4204),
  [10410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [10412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [10414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7449),
  [10416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [10418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [10420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7446),
  [10422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [10424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [10426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [10428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7428),
  [10430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_opening_tag, 1, 0, 0),
  [10432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [10434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [10436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [10438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [10440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [10442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [10444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [10446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [10448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6607),
  [10450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6606),
  [10452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [10454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [10456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [10458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [10460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [10462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [10464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [10466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7424),
  [10468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6471),
  [10470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6573),
  [10472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [10474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, 0, 154),
  [10476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [10478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [10480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [10482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3873),
  [10484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [10486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3891),
  [10488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [10490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [10492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [10494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6487),
  [10496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6453),
  [10498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6465),
  [10500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [10502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3907),
  [10504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [10506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [10508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7400),
  [10510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [10512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [10514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [10516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [10518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [10520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [10522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [10524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [10526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [10528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [10530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7396),
  [10532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [10534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [10536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [10538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 3, 0, 149),
  [10540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [10542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7366),
  [10544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 3, 0, 152),
  [10546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [10548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [10550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4930),
  [10552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7362),
  [10554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6894),
  [10556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6890),
  [10558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [10560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4599),
  [10562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [10564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [10566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [10568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [10570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [10572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4601),
  [10574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [10576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2693),
  [10578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [10580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [10582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [10584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [10586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [10588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7411),
  [10590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [10592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2686),
  [10594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [10596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4607),
  [10598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [10600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7168),
  [10602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 3, 0, 149),
  [10604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [10606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [10608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [10610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2709),
  [10612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [10614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4193),
  [10616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [10618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [10620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [10622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1, 0, 0),
  [10624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [10626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [10628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [10630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4144),
  [10632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4146),
  [10634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [10636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3739),
  [10638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [10640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [10642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3743),
  [10644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [10646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [10648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3627),
  [10650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [10652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3747),
  [10654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4840),
  [10656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [10658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [10660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [10662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [10664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4155),
  [10666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter, 1, 0, 0),
  [10668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [10670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [10672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4153),
  [10674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6919),
  [10676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6955),
  [10678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6957),
  [10680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6965),
  [10682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [10684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [10686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6980),
  [10688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [10690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [10692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [10694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [10696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [10698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [10700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3622),
  [10702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [10704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [10706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [10708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3615),
  [10710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 133),
  [10712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [10714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [10716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 128),
  [10718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [10720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [10722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3, 0, 89),
  [10724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2, 0, 32),
  [10726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2, 0, 0),
  [10728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 4, 0, 199),
  [10730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [10732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [10734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [10736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [10738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7234),
  [10740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 1, 0, 0),
  [10742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [10744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [10746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [10748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7222),
  [10750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [10752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [10754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6765),
  [10756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [10758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6745),
  [10760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4776),
  [10762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [10764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, 0, 98),
  [10766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [10768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [10770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, 0, 96),
  [10772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [10774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7108),
  [10776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [10778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [10780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6286),
  [10782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [10784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6305),
  [10786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [10788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [10790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [10792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [10794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4, 0, 176),
  [10796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0),
  [10798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_attribute, 2, 0, 0),
  [10800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [10802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [10804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6483),
  [10806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4663),
  [10808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 2, 0, 57),
  [10810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [10812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [10814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [10816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [10818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [10820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [10822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [10824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6235),
  [10826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, 0, 31),
  [10828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [10830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6118),
  [10832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [10834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [10836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [10838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [10840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [10842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5049),
  [10846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 4, 0, 196),
  [10848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [10854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [10858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [10862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [10864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [10866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [10868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 4, 0, 196),
  [10870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 59),
  [10872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [10874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [10876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [10878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [10880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [10882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [10884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [10886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 1, 0, 5),
  [10888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [10890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [10892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [10894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [10896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [10898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [10900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [10902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [10904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [10910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [10914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5067),
  [10916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, 0, 38),
  [10918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7365),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [10924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [10926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [10928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [10930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [10932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [10934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [10936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [10938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [10940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7186),
  [10942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [10944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [10946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [10948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, 0, 0),
  [10950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5554),
  [10952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [10954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [10956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [10958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [10960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2, 0, 0),
  [10962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [10964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7084),
  [10966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [10968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6850),
  [10970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6654),
  [10972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [10976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [10978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [10980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [10982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7367),
  [10984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [10986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6418),
  [10990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6934),
  [10992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6944),
  [10994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [10996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [10998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [11000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6352),
  [11002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [11004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [11006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6961),
  [11008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [11010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [11012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [11014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [11016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6115),
  [11018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6427),
  [11020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [11022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7024),
  [11024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [11026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [11028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [11030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5886),
  [11032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [11034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [11036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2, 0, 0),
  [11038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7275),
  [11040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [11042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [11044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [11046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [11048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6824),
  [11050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [11052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [11054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [11056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [11058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [11060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [11062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7120),
  [11064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [11066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [11068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [11070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [11072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [11074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [11076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [11078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7249),
  [11080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [11082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6630),
  [11084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [11088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [11090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6828),
  [11092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [11094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [11096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_export, 3, 0, 0),
  [11098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [11100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [11102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [11104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6583),
  [11106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6581),
  [11108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [11110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [11112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [11114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [11118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [11120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6513),
  [11122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [11124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [11126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [11128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [11130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [11132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [11134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [11136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [11138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [11140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [11142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [11144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [11146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [11148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [11150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [11152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [11154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3, 0, 0),
  [11156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7135),
  [11158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4319),
  [11162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6253),
  [11166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, 0, 0),
  [11168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [11170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6344),
  [11172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [11174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [11176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [11178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [11180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [11182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6255),
  [11184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [11186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [11188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [11190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [11192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [11194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [11196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [11198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6374),
  [11200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [11202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [11204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [11206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3, 0, 0),
  [11208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [11210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6389),
  [11212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [11214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [11216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [11218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [11220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [11222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6411),
  [11224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [11226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [11228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7395),
  [11230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [11232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [11234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [11236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [11238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [11240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [11242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [11244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [11246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [11248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6819),
  [11250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [11252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [11254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6413),
  [11256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [11258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [11260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6825),
  [11262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [11264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [11266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [11268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [11270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [11272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [11274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [11276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [11278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [11280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [11282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [11284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7176),
  [11286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [11288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [11290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7088),
  [11292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [11294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [11296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5441),
  [11298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [11300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [11302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6560),
  [11304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [11306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [11308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [11310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [11312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6566),
  [11314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [11316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [11318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [11320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [11322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [11324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [11326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [11328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [11330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [11332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6743),
  [11334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5033),
  [11336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [11340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [11342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [11344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [11346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [11348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [11350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [11352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [11354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [11356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [11358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5016),
  [11360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [11362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [11364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [11366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6620),
  [11368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [11370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7274),
  [11372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [11374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [11376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [11378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [11380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [11382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [11384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [11386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [11388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [11390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [11392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [11394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [11396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [11398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [11400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [11402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [11404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [11406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [11408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [11410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [11412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [11414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [11416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [11418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [11420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [11422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [11424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [11426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [11428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [11430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [11432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [11434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [11436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [11438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [11440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [11442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [11444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [11446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [11448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [11450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [11452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [11454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [11456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [11458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [11460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [11462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6986),
  [11464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [11466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [11468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [11470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [11472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [11474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [11476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [11478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [11480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [11482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7070),
  [11484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [11486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [11488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [11490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [11492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [11494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [11496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [11498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [11500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [11502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [11504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [11506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [11514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [11516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [11518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6725),
  [11524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [11526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [11530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [11542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7031),
  [11544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7028),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [11548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [11550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [11552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, 0, 0),
  [11554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [11556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [11558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [11560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7022),
  [11562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7450),
  [11564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [11566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6932),
  [11568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [11570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [11572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [11574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [11576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4913),
  [11578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [11580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [11582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [11584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [11586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [11588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [11590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [11592] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [11594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6663),
  [11596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [11598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [11600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [11602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7032),
  [11604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7037),
  [11606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [11608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7050),
  [11610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6875),
  [11612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [11614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [11616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [11618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5638),
  [11620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [11622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [11624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [11626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7253),
  [11628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [11630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [11632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7098),
  [11634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7103),
  [11636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_namespace_name, 3, 0, 0),
  [11638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [11640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [11642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [11644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [11646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [11648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7116),
  [11650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [11652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [11654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [11656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [11658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [11660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [11662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [11664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [11666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5047),
  [11668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [11670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [11672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [11674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [11676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7153),
  [11678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7157),
  [11680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [11682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [11684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [11686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [11688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [11690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7164),
  [11692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7314),
  [11694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6741),
  [11696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [11698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [11700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [11702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [11704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [11706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [11708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [11710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6670),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [11720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7238),
  [11722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [11724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [11726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6476),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [11730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7368),
  [11732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [11734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6421),
  [11736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7402),
  [11740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [11742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [11744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [11746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7430),
  [11748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [11750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6351),
  [11752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [11754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 1, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token__ternary_qmark = 2,
  ts_external_token_html_comment = 3,
  ts_external_token_PIPE_PIPE = 4,
  ts_external_token_escape_sequence = 5,
  ts_external_token_regex_pattern = 6,
  ts_external_token__function_signature_automatic_semicolon = 7,
  ts_external_token___error_recovery = 8,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token__ternary_qmark] = sym__ternary_qmark,
  [ts_external_token_html_comment] = sym_html_comment,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token_escape_sequence] = sym_escape_sequence,
  [ts_external_token_regex_pattern] = sym_regex_pattern,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [ts_external_token___error_recovery] = sym___error_recovery,
};

static const bool ts_external_scanner_states[11][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
    [ts_external_token___error_recovery] = true,
  },
  [2] = {
    [ts_external_token_html_comment] = true,
  },
  [3] = {
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_html_comment] = true,
  },
  [6] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [7] = {
    [ts_external_token__template_chars] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_escape_sequence] = true,
  },
  [8] = {
    [ts_external_token__template_chars] = true,
    [ts_external_token_html_comment] = true,
  },
  [9] = {
    [ts_external_token_html_comment] = true,
    [ts_external_token_escape_sequence] = true,
  },
  [10] = {
    [ts_external_token_html_comment] = true,
    [ts_external_token_regex_pattern] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_tsx_external_scanner_create(void);
void tree_sitter_tsx_external_scanner_destroy(void *);
bool tree_sitter_tsx_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_tsx_external_scanner_serialize(void *, char *);
void tree_sitter_tsx_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_tsx(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_tsx_external_scanner_create,
      tree_sitter_tsx_external_scanner_destroy,
      tree_sitter_tsx_external_scanner_scan,
      tree_sitter_tsx_external_scanner_serialize,
      tree_sitter_tsx_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
